#!/usr/bin/env python
# Author: Kristjan Haule, Jan 2008


import os,sys,re
from bisect import bisect

if 'ROOT' not in globals().keys():
    ROOT = os.environ.get('LMTO_DMFT_ROOT')
    sys.path.append( ROOT )
    sys.path.append( ROOT + '/fort')

from ld_base import *
# import optics
from pylab import *
from matplotlib.font_manager import fontManager, FontProperties
import copy

# MPI start
from mpi4py import MPI
Master = 0
# for the version 0.5
MPI.rprint = MPI._rprint
MPI.rank = MPI.WORLD_RANK
MPI.size = MPI.WORLD_SIZE
MPI.rprint('mpi.(root,size) =  %d %d'%(Master,MPI.size), MPI.COMM_WORLD, Master)

font = {'family' : 'serif', 'weight' : 'bold', 'size'   : 20,}
rc('font', **font)  # pass in the font dict as kwargs
    


        
if __name__ == '__main__':

    #------------------------------------------------------
        #  Plotting
    #------------------------------------------------------
    Ry2eV = 13.6058
    color_bar = True
    inpdir = '.'

    execfile('PARAMS.akw') # File containing all parameters!

    a_outdir = inpdir+'/akw'
    execfile(a_outdir+'/Akw.dat')
    data = array(data)

    print shape(data)

    # find maximum
    copydata = copy.deepcopy(data)
    copydata = sort(copydata.flatten())
    vmax = copydata[len(copydata)*0.99]
    vmm = [vmm[0], vmm[1]*vmax]
    print 'vmm=', vmm

    xmm=[0,1]
    ymm=[0,1]
    
    imshow(data, interpolation='bilinear', cmap=cm.hot, origin='lower', extent=[xmm[0],xmm[1],ymm[0],ymm[1]], aspect=1.0, vmin=vmm[0], vmax=vmm[1])

    if color_bar: colorbar()

    # Memorize the axis range
    ax = axis()

    
    show()
