#!/usr/bin/env python

import os,sys,re
from scipy import *

from pylab import *
from matplotlib.font_manager import fontManager, FontProperties
import copy


font = {'family' : 'serif', 'weight' : 'bold', 'size'   : 20,}
rc('font', **font)  # pass in the font dict as kwargs

if __name__ == '__main__':

    #------------------------------------------------------
    #  Plotting
    #------------------------------------------------------
    Ry2eV = 13.6058
    Ninterp=5.            # Number of additional points to make spagetti look smooth
    color_bar = True
    
    execfile('PARAMS.akw') # File containing all parameters!
    
    a_outdir = inpdir+'/akw'
    execfile(a_outdir+'/Akw.dat')
    data = array(data)
    Ek=array(Ek)
    
    print shape(data)

    # find maximum
    copydata = copy.deepcopy(data)
    copydata = sort(copydata.flatten())
    vmax = copydata[len(copydata)*0.99]
    vmm = [vmm[0], vmm[1]*vmax]
    print 'vmm=', vmm
    
    xmm=[0,len(kpath)]
    ymm=[omp[0],omp[-1]]
    imshow(data, interpolation='bilinear', cmap=cm.hot, origin='lower', extent=[xmm[0],xmm[1],ymm[0],ymm[1]], aspect=(xmm[1]-xmm[0])*0.8/(ymm[1]-ymm[0]), vmin=vmm[0], vmax=vmm[1])

    if color_bar: colorbar()

    # Memorize the axis range
    ax = axis()

    # Plotting of LDA spagetti
    Ek = Ek*Ry2eV - muLDA
    # for x-axis
    X = array(range(shape(data)[1]))*(xmm[1])/float(shape(data)[1])
    # adding many points for smooth spagetti plot
    lX=[]
    for i in range(len(X)-1):
        a = X[i]
        b = X[i+1]
        dh = (b-a)/Ninterp
        lX += arange(a,b,dh).tolist()
    lX.append(X[-1])
    
    for ib in range(len(Ek)):
        # interpolate on denser msh
        tckr = interpolate.splrep(X, Ek[ib], s=0)
        lEk = interpolate.splev(lX, tckr)
        #plot(lX, lEk,  '-k', linewidth = 2)
        #plot(lX, lEk,  '-', color='#CC6633', linewidth = 1)
        plot(lX, lEk,  '-', color='#996600', linewidth = 1)


    plot((ax[0], ax[1]), (0, 0), '--w', linewidth = 3, zorder=1)
    
    Klabel = [kpath[i][0][0] for i in range(len(kpath))]
    Klabel.append(kpath[-1][0][1])
    
    xticks(range(len(Klabel)), tuple(Klabel), fontsize='x-large')
    yticks(fontsize='x-large')
    ylabel('$\omega$', fontsize='x-large')

    for ik,kl in enumerate(Klabel):
        plot((ik, ik), (ax[2], ax[3]), '--w', linewidth = 1, zorder=1)

    axis(ax)
    show()
