#!/usr/bin/env python
# Author: Kristjan Haule, Jan 2007

import sys as s
import copy as cpy
# local imports
s.path.append("/home/haule/realMaterial/source/fully-self-consistent/new_generation/lmto_dmft/fort")

from read_lmtart import *
from gdmft import *

import ldau

if __name__ == '__main__':
#    inpdir = "/home/haule/realMaterial/source/fully-self-consistent/new_generation/ksum_1/test"
    inpdir = '/home/haule/realMaterial/source/fully-self-consistent/plot_ksum_n25/test1'
#    inpdir = "/home/haule/realMaterial/database/CeIrIn5/from_jihoon/oca_10k_16x16x10/ksum"
    lmt = Lmtart(inpdir)
    lmt.read_cix()
    (om,Sigc) = ReadSelfEnergyColumns(inpdir + "/sig.inp")

    fh_out1 = open('bz1.dat', 'w')
    print >> fh_out1, lmt.ndiv[0], lmt.ndiv[1], lmt.ndiv[2]
    for i2 in range(lmt.ndiv[2]):
        for i1 in range(lmt.ndiv[1]):
            for i0 in range(lmt.ndiv[0]):
                print >> fh_out1, i2, i1, i0, lmt.kirrptr[i0, i1, i2]
                
    for im in range(len(om)-1):
        if (om[im]*om[im+1] < 0): break
    print im
    
    Sigma1 = CreateSelfEnergyMatrix(Sigc[im], lmt.Sigind)
    Sigma2 = CreateSelfEnergyMatrix(Sigc[im+1], lmt.Sigind)
    Sigma = Sigma1 + (Sigma2-Sigma1)*(0.0-om[im])/(om[im+1]-om[im])

    fh_out = open('epsk.dat', 'w')
    (ndim,nkp) = (lmt.ndim, lmt.nkp)
    # Computes eigenvalues only
    Et = array(zeros((ndim,nkp), dtype=complex), order='F')
    print >> fh_out, ndim, nkp, lmt.mu
    for ikp in range(nkp):
        # Rotates Sigma to this base
        sig2 = array(cpy.deepcopy(Sigma),order='F')
        la.ztransform(sig2, lmt.Utk[:,:,ikp],'N') # From DMFT base to LMTO basis
#        sym.symmetrize_spheric(sig2)               # Symmetrization of self-energy in LMTO basis
        # Checks causality of self-energy. Imaginary part should be negative
        la.check_causality2(sig2,1e-12)
        Et[:,ikp] = Eigenvaluesf(lmt.hamf[:,:,ikp]+sig2, lmt.olap[:,:,ikp])
        print 'ikp=', ikp
        print Et[:,ikp]
        print >> fh_out, ikp+1
        for p in range(lmt.ndim):
            print >> fh_out, p, Et[p,ikp].real-lmt.mu, Et[p,ikp].imag

