SUBROUTINE read_c(filename, n1, n2, n3, dataout, beg_skip, rep_skip)
  IMPLICIT NONE
  CHARACTER*(*), intent(in) :: filename
  INTEGER, intent(in)       :: n1
  INTEGER, intent(in)       :: n2
  INTEGER, intent(in)       :: n3
  INTEGER, intent(in)       :: beg_skip
  INTEGER, intent(in)       :: rep_skip
  DOUBLE COMPLEX, intent(out):: dataout(n1,n2,n3)
!f2p integer optional :: beg_skip=1
!f2p integer optional :: rep_skip=1
!!! temporary
  INTEGER :: fh_tmp, i, j, k
  fh_tmp = 113
  OPEN(fh_tmp,file=filename ,form='formatted',status='old')
  DO i=1,beg_skip
     READ(fh_tmp,*)
  ENDDO
  IF (rep_skip.NE.0) THEN
     DO k=1,n3
        DO i=1,rep_skip
           READ(fh_tmp,*)
        ENDDO
        READ(fh_tmp,*) ((dataout(i,j,k),i=1,n1),j=1,n2)
     ENDDO
  ELSE
     READ(fh_tmp,*) (((dataout(i,j,k),i=1,n1),j=1,n2),k=1,n3)
  ENDIF
  CLOSE(fh_tmp)
END SUBROUTINE read_c

SUBROUTINE read_d(filename, n1, n2, n3, dataout, beg_skip, rep_skip)
  IMPLICIT NONE
  CHARACTER*(*), intent(in) :: filename
  INTEGER, intent(in)       :: n1
  INTEGER, intent(in)       :: n2
  INTEGER, intent(in)       :: n3
  INTEGER, intent(in)       :: beg_skip
  INTEGER, intent(in)       :: rep_skip
  REAL*8,  intent(out)      :: dataout(n1,n2,n3)
!f2p integer optional :: beg_skip=1
!f2p integer optional :: rep_skip=1
!!! temporary
  INTEGER :: fh_tmp, i, j, k
  fh_tmp = 113
  OPEN(fh_tmp,file=filename ,form='formatted',status='old')
  DO i=1,beg_skip
     READ(fh_tmp,*)
  ENDDO
  IF (rep_skip.NE.0) THEN
     DO k=1,n3
        DO i=1,rep_skip
           READ(fh_tmp,*)
        ENDDO
        READ(fh_tmp,*) ((dataout(i,j,k),i=1,n1),j=1,n2)
     ENDDO
  ELSE
     READ(fh_tmp,*) (((dataout(i,j,k),i=1,n1),j=1,n2),k=1,n3)
  ENDIF
  CLOSE(fh_tmp)
END SUBROUTINE read_d

! n2 = ng
! n1 = imax
SUBROUTINE read_sparse(filename, n1, n2, dataout, beg_skip)
  IMPLICIT NONE
  CHARACTER*(*), intent(in)  :: filename
  INTEGER, intent(in)        :: n1
  INTEGER, intent(in)        :: n2
  INTEGER, intent(in)        :: beg_skip
  DOUBLE COMPLEX,intent(out) :: dataout(n1,n2)
!!! temporary
  DOUBLE COMPLEX :: ctmp
  INTEGER :: fh_tmp, i, j, i0, j0 
  fh_tmp = 113
  OPEN(fh_tmp,file=filename ,form='formatted',status='old')
  DO i=1,beg_skip
     READ(fh_tmp,*)
  ENDDO
  DO j=1,n2
     READ(fh_tmp,*) j0
     DO i = 1,n1
        READ(fh_tmp,*) i0, ctmp
        dataout(i0,j0) = ctmp
     ENDDO
  ENDDO
END SUBROUTINE read_sparse

SUBROUTINE read_v(filename, n1, n2, n3, n4, dataout, beg_skip, rep_skip)
  IMPLICIT NONE
  CHARACTER*(*), intent(in) :: filename
  INTEGER, intent(in)       :: n1
  INTEGER, intent(in)       :: n2
  INTEGER, intent(in)       :: n3
  INTEGER, intent(in)       :: n4
  INTEGER, intent(in)       :: beg_skip
  INTEGER, intent(in)       :: rep_skip
  DOUBLE COMPLEX, intent(out):: dataout(n1,n2,n3,n4)
!f2p integer optional :: beg_skip=1
!f2p integer optional :: rep_skip=1
!!! temporary
  INTEGER :: fh_tmp, i, j, k, l
  fh_tmp = 113
  OPEN(fh_tmp,file=filename ,form='formatted',status='old')
  DO i=1,beg_skip
     READ(fh_tmp,*)
  ENDDO
  IF (rep_skip.NE.0) THEN
     DO k=1,n4
        DO i=1,rep_skip
           READ(fh_tmp,*)
        ENDDO
        READ(fh_tmp,*) (((dataout(i,j,l,k),i=1,n1),j=1,n2),l=1,n3)
     ENDDO
  ELSE
     READ(fh_tmp,*) ((((dataout(i,j,l,k),i=1,n1),j=1,n2),l=1,n3),k=1,n4)
  ENDIF
  CLOSE(fh_tmp)
END SUBROUTINE read_v

