!**************************************************!
!*******  Copyright by Kristjan Haule, 2002 ******!
!**************************************************!
      SUBROUTINE CINV(N,A,IDIM,R,IFAIL) 
C     ******************************************************************    
C   
C     REPLACES A BY ITS INVERSE.    
C   
C     ******************************************************************    
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 A(IDIM,N)
      INTEGER    N, IDIM
      INTEGER    IFAIL
      REAL*8     R(N)
Cf2py intent(inout) A
Cf2py intent(in)    N      
Cf2py intent(in)    idim      
Cf2py intent(in)    R   
Cf2py intent(out) ifail      
Cf2py integer intent(hide), depend(A)  :: idim=shape(A,0)
Cf2py integer intent(hide), depend(A)  :: N=shape(A,1)
      REAL*8     T1,T2,T3    
      COMPLEX*16 ONE,DET,TEMP,S, 
     $        C11,C12,C13,C21,C22,C23,C31,C32,C33   
      CHARACTER*6 NAME  
      DATA NAME/'CINV'/,KPRNT/0/    
      DATA ONE/(1.D0,0.D0)/   
C   
C  TEST FOR PARAMETER ERRORS.   
C   
      IF((N.LT.1).OR.(N.GT.IDIM)) GO TO 7   
C   
C  TEST FOR N.LE.3. 
C   
      IF(N.GT.3) GO TO 6    
      IFAIL=0   
      IF(N.LT.3) GO TO 4    
C   
C  N=3 CASE.    
C   
C     COMPUTE COFACTORS.    
      C11=A(2,2)*A(3,3)-A(2,3)*A(3,2)   
      C12=A(2,3)*A(3,1)-A(2,1)*A(3,3)   
      C13=A(2,1)*A(3,2)-A(2,2)*A(3,1)   
      C21=A(3,2)*A(1,3)-A(3,3)*A(1,2)   
      C22=A(3,3)*A(1,1)-A(3,1)*A(1,3)   
      C23=A(3,1)*A(1,2)-A(3,2)*A(1,1)   
      C31=A(1,2)*A(2,3)-A(1,3)*A(2,2)   
      C32=A(1,3)*A(2,1)-A(1,1)*A(2,3)   
      C33=A(1,1)*A(2,2)-A(1,2)*A(2,1)   
      T1=ABS(DREAL(A(1,1)))+ABS(DIMAG(A(1,1)))   
      T2=ABS(DREAL(A(2,1)))+ABS(DIMAG(A(2,1)))   
      T3=ABS(DREAL(A(3,1)))+ABS(DIMAG(A(3,1)))   
C   
C     (SET TEMP=PIVOT AND DET=PIVOT*DET.)   
      IF(T1.GE.T2) GO TO 1  
	 IF(T3.GE.T2) GO TO 2   
C        (PIVOT IS A21) 
	    TEMP=A(2,1) 
	    DET=C13*C32-C12*C33 
	    GO TO 3 
    1 IF(T3.GE.T1) GO TO 2  
C     (PIVOT IS A11)    
	 TEMP=A(1,1)    
	 DET=C22*C33-C23*C32    
	 GO TO 3    
C     (PIVOT IS A31)    
    2    TEMP=A(3,1)    
	 DET=C23*C12-C22*C13    
C   
C     SET ELEMENTS OF INVERSE IN A. 
    3 IF(DREAL(DET).EQ.0.D0.AND.DIMAG(DET).EQ.0.D0) GO TO 8  
      S=TEMP/DET    
      A(1,1)=S*C11  
      A(1,2)=S*C21  
      A(1,3)=S*C31  
      A(2,1)=S*C12  
      A(2,2)=S*C22  
      A(2,3)=S*C32  
      A(3,1)=S*C13  
      A(3,2)=S*C23  
      A(3,3)=S*C33  
      RETURN    
C   
    4 IF(N.LT.2) GO TO 5    
C   
C  N=2 CASE BY CRAMERS RULE.    
C   
      DET=A(1,1)*A(2,2)-A(1,2)*A(2,1)   
      IF(DREAL(DET).EQ.0.D0.AND.DIMAG(DET).EQ.0.D0) GO TO 8  
      S=ONE/DET 
      C11   =S*A(2,2)   
      A(1,2)=-S*A(1,2)  
      A(2,1)=-S*A(2,1)  
      A(2,2)=S*A(1,1)   
      A(1,1)=C11    
      RETURN    
C   
C  N=1 CASE.    
C   
    5 IF(DREAL(A(1,1)).EQ.0.D0.AND.DIMAG(A(1,1)).EQ.0.D0) GO TO 8    
      A(1,1)=ONE/A(1,1) 
      RETURN    
C   
C  N.GT.3 CASES.  FACTORIZE MATRIX AND INVERT.  
C   
    6 CALL CFACT(N,A,IDIM,R,IFAIL,DET,JFAIL)    
      IF(IFAIL.NE.0) RETURN 
      CALL CFINV(N,A,IDIM,R)    
      RETURN    
C   
C  ERROR EXITS. 
C   
    7 IFAIL=+1  
      RETURN    
C   
    8 IFAIL=-1  
      RETURN    
C   
      END   


	  SUBROUTINE          CFINV(N,A,IDIM,IR)    
	  IMPLICIT REAL*8 (A-H,O-Z)
	  INTEGER*4           IR(2*N) 
	  COMPLEX*16          A(IDIM,N),     X, Y, TI   
	  CHARACTER*6         HNAME 
	  COMPLEX*16          ZERO, S31, S32, S33, S34, DC, DOTF    
	  DOTF(X,Y,S31)  =  X*Y + S31   
	  DATA      ZERO      /  (0.D0,0.D0)  / 
	  DATA      HNAME               /  ' CFINV'  /  
	  IF(IDIM .GE. N  .AND.  N .GT. 0)  GOTO 310    
	  WRITE(0,*) 'ERROR IN SUBROUTINE CFINV STOP'
          CALL EXIT(1)
 310      IF(N .EQ. 1)  RETURN  
	  A(2,1)  =  -A(2,2) * DOTF(A(1,1),A(2,1),ZERO) 
	  A(1,2)  =  -A(1,2)    
	  IF(N .EQ. 2)  GOTO 330    
	  DO 314    I  =  3, N  
	     IM2  =  I-2    
	     DO 312 J  =  1, IM2    
		S31  =  ZERO    
		S32  =  A(J,I)  
		DO 311  K  =  J, IM2    
		   S31  =  DOTF(A(K,J),A(I,K),S31)  
		   S32  =  DOTF(A(J,K+1),A(K+1,I),S32)  
 311               CONTINUE 
		A(I,J)  =  -A(I,I) * DOTF(A(I-1,J),A(I,I-1),S31)    
		A(J,I)  =  -S32 
 312            CONTINUE    
	     A(I,I-1)  =  -A(I,I) * DOTF(A(I-1,I-1),A(I,I-1),ZERO)  
	     A(I-1,I)  =  -A(I-1,I) 
 314         CONTINUE   
 330      NM1  =  N-1   
	  DO 335   I  =  1, NM1 
	     NMI  =  N-I    
	     DO 332   J  =  1, I    
		S33  =  A(I,J)  
		DO 331   K  =  1, NMI   
		   S33  =  DOTF(A(I+K,J),A(I,I+K),S33)  
 331               CONTINUE 
		A(I,J)  =  S33  
 332            CONTINUE    
	     DO 334   J  =  1, NMI  
		S34  =  ZERO    
		DO 333   K  =  J, NMI   
		   S34  =  DOTF(A(I+K,I+J),A(I,I+K),S34)    
 333               CONTINUE 
		A(I,I+J)  =  S34    
 334            CONTINUE    
 335         CONTINUE   
	  NXCH  =  IR(N)    
	  IF(NXCH .EQ. 0)  RETURN   
	    DO 342 M  =  1, NXCH    
	     K   =  NXCH - M+1  
	     IJ  =  IR(K)   
	     I   =  IJ / 4096   
	     J   =  MOD(IJ,4096)    
	     DO 341  K  =  1, N 
		TI      =  A(K,I)   
		A(K,I)  =  A(K,J)   
		A(K,J)  =  TI   
 341            CONTINUE    
 342         CONTINUE   
	  RETURN    
	  END   


	  SUBROUTINE          CFACT(N,A,IDIM,IR,IFAIL,DET,JFAIL)    
	  IMPLICIT REAL*8 (A-H,O-Z)
	  INTEGER*4           IR(2*N),  IPAIRF  
	  COMPLEX*16          A(IDIM,N),DET,      ZERO,     ONE,X,Y,TF  
	  REAL*8              G1,       G2  
	  REAL*8              PIVOTF,   P,        Q,        SIZEF,  T   
	  CHARACTER*6         HNAME 
	  COMPLEX*16          S11, S12, DC, DOTF    
	  DOTF(X,Y,S11)  =  X*Y + S11   
	  IPAIRF(J,K)  =  J*2**12 + K   
	  PIVOTF(X)    =  DMAX1(ABS(DREAL(X)),ABS(DIMAG(X))) 
	  SIZEF(X)     =  DMAX1(ABS(DREAL(X)),ABS(DIMAG(X))) 
	  DATA      G1, G2              /  1.D-19,  1.D19  /    
	  DATA      HNAME               /  ' CFACT'  /  
	  DATA      ZERO, ONE           /(0.D0,0.D0),(1.D0,0.D0)/    
	  DATA      NORMAL, IMPOSS      /  0, -1  / 
	  DATA      JRANGE, JOVER, JUNDER  /  0, +1, -1  /  
	  IF(IDIM .GE. N  .AND.  N .GT. 0)  GOTO 110    
	  WRITE(0,*) 'ERROR IN SUBROUTINE CFACT STOP'
          CALL EXIT(1)
 110      IFAIL  =  NORMAL  
	  JFAIL  =  JRANGE  
	  NXCH   =  0   
	  DET    =  ONE 
	  DO 144    J  =  1, N  
 120         K  =  J    
	     P  =  PIVOTF(A(J,J))   
	     IF(J .EQ. N)  GOTO 122 
	     JP1  =  J+1    
	     DO 121    I  =  JP1, N 
		Q  =  PIVOTF(A(I,J))    
		IF(Q .LE. P)  GOTO 121  
		   K  =  I  
		   P  =  Q  
 121            CONTINUE    
	     IF(K .NE. J)  GOTO 123 
 122         IF(P .GT. 0.)  GOTO 130    
		DET    =  ZERO  
		IFAIL  =  IMPOSS    
		JFAIL  =  JRANGE    
		RETURN  
 123         DO 124    L  =  1, N   
		TF      =  A(J,L)   
		A(J,L)  =  A(K,L)   
		A(K,L)  =  TF   
 124            CONTINUE    
	     NXCH      =  NXCH + 1  
	     IR(NXCH)  =  IPAIRF(J,K)   
 130         DET     =  DET * A(J,J)    
	     A(J,J)  =  ONE / A(J,J)    
	     T  =  SIZEF(DET)   
	     IF(T .LT. G1)  GOTO 132    
	     IF(T .GT. G2)  GOTO 133    
 131         IF(J .EQ. N)  GOTO 144 
	     GOTO 140   
 132         DET    =  ZERO 
	     IF(JFAIL .EQ. JRANGE)  JFAIL  =  JUNDER    
	     GOTO 131   
 133         DET    =  ONE  
	     IF(JFAIL .EQ. JRANGE)  JFAIL  =  JOVER 
	     GOTO 131   
 140         JM1  =  J-1    
	     JP1  =  J+1    
	     DO 143   K  =  JP1, N  
		S11  =  -A(J,K) 
		S12  =  -A(K,J+1)   
		IF(J .EQ. 1)  GOTO 142  
		DO 141  I  =  1, JM1    
		   S11  =  DOTF(A(I,K),A(J,I),S11)  
		   S12  =  DOTF(A(I,J+1),A(K,I),S12)    
 141               CONTINUE 
 142            A(J,K)    =  -S11 * A(J,J)  
		A(K,J+1)  =  -DOTF(A(J,J+1),A(K,J),S12) 
 143            CONTINUE    
 144         CONTINUE   
 150      IF(MOD(NXCH,2) .NE. 0)  DET  =  -DET  
	  IF(JFAIL .NE. JRANGE)   DET  =  ZERO  
	  IR(N)  =  NXCH    
	  RETURN    
	  END   
