MODULE com_scs

  INTEGER   :: natom0, nsort0, nspin0, norbs0
  INTEGER, ALLOCATABLE   :: is0(:)

  CHARACTER :: text*64
  REAL*8    :: rbas0(3,3), gbas0(3,3), parr0, orth0(2:3), strain0(3,3,2)
  INTEGER   :: nfftg0(3), nplw0
  LOGICAL   :: scfmade
  REAL*8,     ALLOCATABLE :: tao0(:,:), tau0(:,:)
  REAL*8 ,    ALLOCATABLE :: znuc0(:), smt0(:), axmag0(:,:)
  INTEGER,    ALLOCATABLE :: nrad0(:), nsym0(:)
  REAL*8,     ALLOCATABLE :: R0(:,:) !, RHOCOR0(:,:,:), POTFRZ0(:,:,:)
!  REAL*8,     ALLOCATABLE :: ENY0(:,:,:), DNY0(:,:,:)
  INTEGER,    ALLOCATABLE :: MNY0(:,:), NOD0(:,:)
  INTEGER,    ALLOCATABLE :: lmval(:,:)

!  REAL*8,     ALLOCATABLE :: RHOCOR1(:,:,:), POTFRZ1(:,:,:)
!  REAL*8,     ALLOCATABLE :: ENY1(:,:,:), DNY1(:,:,:)

  REAL*8    :: rbas1(3,3), gbas1(3,3), parr1, orth1(2:3), strain1(3,3,2)
  INTEGER   :: nfftg1(3), nplw1
  REAL*8,     ALLOCATABLE :: tao1(:,:), tau1(:,:)

contains

  subroutine ReadSCSFile1(filename, inf_buf, &
       efmu0, task, RHO0, nrad_max, nsym_max, admix,&
       is, natom, nsort, nspin, norbs)
    IMPLICIT NONE
    !Passed varibables
    CHARACTER*500, intent(in)      :: filename
    CHARACTER*10000, intent(inout) :: inf_buf

    REAL*8,    intent(out) :: RHOCOR0(0:nrad_max,nsort,nspin)
    REAL*8,    intent(out) :: POTFRZ0(0:nrad_max,nsort,nspin)
    REAL*8,    intent(out) :: ENY0(0:ilst_max,nsort,nspin)
    REAL*8,    intent(out) :: DNY0(0:ilst_max,nsort,nspin)
    COMPLEX*16,intent(out) :: RHO0(0:nrad_max,nsym_max,natom,nspin,norbs)

    REAL*8, intent(out)    :: efmu0

    INTEGER, intent(in)    :: natom, nsort, nspin
    INTEGER, intent(in)    :: ilst_max, nrad_max, nsym_max


!    CHARACTER, intent(out) :: text*64
!    REAL*8,    intent(out) :: rbas0(3,3), gbas0(3,3), parr0, orth0(2:3), strain0(3,3,2)
!    INTEGER,   intent(out) :: nfftg0(3), nplw0
!    LOGICAL,   intent(out) :: scfmade
!    REAL*8,    intent(out) :: tao0(3,natom)
!    REAL*8,    intent(out) :: tau0(3,natom)
!    REAL*8,    intent(out) :: znuc0(nsort)
!    REAL*8,    intent(out) :: smt0(nsort)
!    REAL*8,    intent(out) :: axmag0(3,nsort)
!    INTEGER,   intent(out) :: nrad0(nsort)
!    INTEGER,   intent(out) :: nsym0(natom)
!    REAL*8,    intent(out) :: R0(0:nrad_max0,nsort0)
!    INTEGER,   intent(out) :: lmval(nsym_max0,nsort0)
!    INTEGER,   intent(out) :: MNY0(0:ilst_max,nsort)
!    INTEGER,   intent(out) :: NOD0(0:ilst_max,nsort)

    !Local variables
    INTEGER  :: fh_scs
    INTEGER  :: iatom0, isort0, iorbs0, ispin0, isym0, lm0, irad0, l0, iupdn0
    INTEGER  :: iatom,  isort,  iorbs,  ispin,  isym,  lm,  irad,  l
    INTEGER  :: i, m
    INTEGER  :: nrad_max0, nsym_max0, ilst_max
    INTEGER  :: ilsv0(nsort), nkap0, ilst0(nsort), ilsb0(nsort)
    CHARACTER*256 :: fh_info   

    ! Open the self-consistent file
    fh_scs = new_filehandle()
    OPEN(fh_scs,file=TRIM(filename),status='old')

    WRITE(fh_info,fmt='(1x,A,1x,A1)') 'READ_SCS: Start reading SCFFILE in mode ', task
    inf_buf = TRIM(inf_buf)//'\n'//TRIM(fh_info)

    READ(fh_scs,fmt='(A)') text
    IF(text(2:2).NE.'<') THEN 
       WRITE(0,*) "READ_SCS The format of scs file seems to be wrong"
       WRITE(fh_info,*) "READ_SCS The format of scs file seems to be wrong"
       inf_buf = TRIM(inf_buf)//'\n'//TRIM(fh_info)
       EXIT(1)
    ENDIF

    READ(fh_scs,*) natom0, nsort0, nspin0, norbs0

    IF (.NOT. ALLOCATED(is0)) ALLOCATE(is0(natom0))
    READ(fh_scs,*)(is0(iatom0),iatom0=1,natom0)

    IF (.NOT.ALLOCATED(tao0))   ALLOCATE(tao0(3,natom0))
    IF (.NOT.ALLOCATED(tau0))   ALLOCATE(tau0(3,natom0))
    IF (.NOT.ALLOCATED(znuc0))  ALLOCATE(znuc0(nsort0))
    IF (.NOT.ALLOCATED(smt0))   ALLOCATE(smt0(nsort0))
    IF (.NOT.ALLOCATED(axmag0)) ALLOCATE(axmag0(3,nsort0))
    IF (.NOT.ALLOCATED(nrad0))  ALLOCATE(nrad0(nsort0))
    IF (.NOT.ALLOCATED(nsym0))  ALLOCATE(nsym0(natom0))

    READ(fh_scs,*) RBAS0, GBAS0, PARR0, ORTH0, STRAIN0, ((TAO0(I,IATOM0),I=1,3),IATOM0=1,NATOM0), ((TAU0(I,IATOM0),I=1,3),IATOM0=1,NATOM0),&
         (ZNUC0(ISORT0),ISORT0=1,NSORT0), (SMT0(ISORT0),ISORT0=1,NSORT0), ((AXMAG0(I,ISORT0),I=1,3),ISORT0=1,NSORT0)

    READ(fh_scs,*) (NRAD0(ISORT0),ISORT0=1,NSORT0), (NSYM0(IATOM0),IATOM0=1,NATOM0),(ILSV0(ISORT0),ISORT0=1,NSORT0)
    
    nrad_max0 = maxim(nsort0, nrad0)
    nsym_max0 = maxim(natom0,nsym0)

    IF (.NOT.ALLOCATED(R0)) ALLOCATE(R0(0:nrad_max0,nsort0))
    IF (.NOT.ALLOCATED(lmval)) ALLOCATE(lmval(nsym_max0,nsort0))

    READ(fh_scs,*)((R0(IRAD0,ISORT0),IRAD0=0,NRAD0(ISORT0)),ISORT0=1,NSORT0)

    ! Actual reading of the largest array of total density
    DO IATOM0=1,NATOM0        !!! over old atoms
       ISORT0=IS0(IATOM0)
       DO IORBS0=1,NORBS0     !!! over old iorbs
          DO IUPDN0=1,NSPIN0  !!! over old spins
             DO ISYM0=1,NSYM0(IATOM0) !!! over old symmetry
                READ(fh_scs,*) lmval(isym0,isort0)!LM0
                READ(fh_scs,*)(RHO0(irad0,isym0,iatom0,iupdn0,iorbs0),irad0=0,nrad0(isort0))
             ENDDO
          ENDDO
       ENDDO
    ENDDO

    IF(.NOT.ALLOCATED(RHOCOR0)) ALLOCATE(RHOCOR0(0:nrad_max0,nsort,nspin))
    IF(.NOT.ALLOCATED(POTFRZ0)) ALLOCATE(POTFRZ0(0:nrad_max0,nsort,nspin))
    DO ISORT0=1,NSORT0        !!! over old sorts
       DO ISPIN0=1,NSPIN0     !!! over old spins
          READ(fh_scs,*)(RHOCOR0(IRAD0,isort0,ispin0),IRAD0=0,NRAD0(ISORT0))
          READ(fh_scs,*)(POTFRZ0(IRAD0,isort0,ispin0),IRAD0=0,NRAD0(ISORT0))
       ENDDO
    ENDDO

    IF (.NOT.ALLOCATED(tao1))   ALLOCATE(tao1(3,natom0))
    IF (.NOT.ALLOCATED(tau1))   ALLOCATE(tau1(3,natom0))

    READ(fh_scs,*) RBAS1,GBAS1,ORTH1,PARR1,STRAIN1,NPLW1,NFFTG1,((TAO1(I,IATOM0),I=1,3),IATOM0=1,NATOM0),((TAU1(I,IATOM0),I=1,3),IATOM0=1,NATOM0)

    ! Gap here!
    READ(fh_scs,*) NKAP0,(ILST0(ISORT0),ISORT0=1,NSORT0),(ILSB0(ISORT0),ISORT0=1,NSORT0)

    ilst_max = maxim(nsort,ilst0)

    IF(.NOT.ALLOCATED(Eny0)) ALLOCATE(Eny0(0:ilst_max,nsort,nspin))
    IF(.NOT.ALLOCATED(Dny0)) ALLOCATE(Dny0(0:ilst_max,nsort,nspin))
    IF(.NOT.ALLOCATED(Mny0)) ALLOCATE(Mny0(0:ilst_max,nsort))
    IF(.NOT.ALLOCATED(Nod0)) ALLOCATE(Nod0(0:ilst_max,nsort))

    READ(fh_scs,*) &
         (((ENY0(L0,ISORT0,ISPIN0),L0=0,ILST0(ISORT0)),ISORT0=1,NSORT0),ISPIN0=1,NSPIN0),&
         (((DNY0(L0,ISORT0,ISPIN0),L0=0,ILST0(ISORT0)),ISORT0=1,NSORT0),ISPIN0=1,NSPIN0),&
         ((MNY0(L0,ISORT0),L0=0,ILST0(ISORT0)),ISORT0=1,NSORT0),&
         ((NOD0(L0,ISORT0),L0=0,ILST0(ISORT0)),ISORT0=1,NSORT0)

    READ(fh_scs,*) efmu0, scfmade

    efmu0 = efmu0 * Ry2eV

    CLOSE(fh_scs)

  end subroutine ReadSCSFile1

!  subroutine WriteSCSFile(filename, fh_info, RHOTOT, efmu, nrad_max, nsym_max)
!    USE com_dim, ONLY: natom, nsort, nspin, norbs
!    USE com_idx, ONLY: is, ilsv, ilsb, ilst
!    USE lib_io,  ONLY: inpdir, outdir, new_filehandle
!    USE lib_phys,ONLY: Ry2eV
!    USE com_flg, ONLY: units_ev
!    IMPLICIT NONE
!    !Passed varibables
!    CHARACTER*100, intent(in) :: filename
!    INTEGER, intent(in)       :: fh_info, nrad_max, nsym_max
!    REAL*8, intent(in)        :: efmu
!    COMPLEX*16, intent(in)    :: RHOTOT(0:nrad_max,nsym_max,natom,nspin,norbs)
!    !Local variables
!    INTEGER :: fh_scsn
!    INTEGER :: iatom, isort, ispin, i, l, irad, iorbs, isym
!    INTEGER, PARAMETER :: nkap = 1
!    REAL*8  :: efmut
!
!    ! Open the new self-consistent file
!    fh_scsn = new_filehandle()
!    OPEN(fh_scsn,file=TRIM(outdir)//"/"//TRIM(filename),status='unknown')
!
!    WRITE(fh_scsn,fmt='(A)') text
!    ! STORE: control information:
!    WRITE(fh_scsn,*) natom,nsort,nspin,norbs
!    WRITE(fh_scsn,*)(is(iatom),iatom=1,natom)
!    WRITE(fh_scsn,*) RBAS0,GBAS0,PARR0,ORTH0,STRAIN0,((TAO0(i,IATOM),i=1,3),IATOM=1,NATOM),((TAU0(i,IATOM),i=1,3),IATOM=1,NATOM),&
!         (ZNUC0(ISORT),ISORT=1,NSORT),(SMT0(ISORT),ISORT=1,NSORT),((AXMAG0(i,ISORT),i=1,3),ISORT=1,NSORT)
!    WRITE(fh_scsn,*) (NRAD0(ISORT),ISORT=1,NSORT),(NSYM0(IATOM),IATOM=1,NATOM),(ILSV(ISORT),ISORT=1,NSORT)
!    ! STORE: Radial mesh
!    WRITE(fh_scsn,*) ((R0(IRAD,ISORT),IRAD=0,NRAD0(ISORT)),ISORT=1,NSORT)
!
!    ! STORE: Charge density
!    DO IATOM=1,NATOM
!       ISORT=IS(IATOM)
!       DO IORBS=1,NORBS
!          DO ISPIN=1,NSPIN
!             DO isym=1,nsym0(iatom)
!                WRITE(fh_scsn,*) lmval(isym,isort)
!                WRITE(fh_scsn,*) (RHOTOT(IRAD,ISYM,IATOM,ISPIN,IORBS),IRAD=0,NRAD0(ISORT))
!             ENDDO
!          ENDDO
!       ENDDO
!    ENDDO
!    ! STORE: core density, spherical potential.
!    DO ISORT=1,NSORT
!       DO ISPIN=1,NSPIN
!          WRITE(fh_scsn,*)(RHOCOR0(IRAD,ISORT,ISPIN),IRAD=0,NRAD0(ISORT))
!          WRITE(fh_scsn,*)(POTFRZ0(IRAD,ISORT,ISPIN),IRAD=0,NRAD0(ISORT))
!       ENDDO
!    ENDDO
!    ! STORE: pseudodensity
!    WRITE(fh_scsn,*)RBAS0,GBAS0,ORTH0,PARR0,STRAIN0,NPLW0,NFFTG0,((TAO0(I,IATOM),I=1,3),IATOM=1,NATOM),((TAU0(I,IATOM),I=1,3),IATOM=1,NATOM)
!    WRITE(fh_scsn,*)
!    DO IORBS=1,NORBS
!       DO ISPIN=1,NSPIN
!          WRITE(fh_scsn,*)
!          WRITE(fh_scsn,*)
!       ENDDO
!    ENDDO
!    ! STORE: restart information
!    WRITE(fh_scsn,*) nkap,(ILST(ISORT),ISORT=1,NSORT),(ILSB(ISORT),ISORT=1,NSORT)
!    WRITE(fh_scsn,*) &
!         (((ENY0(L,ISORT,ISPIN),L=0,ILST(ISORT)),ISORT=1,NSORT),ISPIN=1,NSPIN),&
!         (((DNY0(L,ISORT,ISPIN),L=0,ILST(ISORT)),ISORT=1,NSORT),ISPIN=1,NSPIN),&
!         ((MNY0(L,ISORT),L=0,ILST(ISORT)),ISORT=1,NSORT),&
!         ((NOD0(L,ISORT),L=0,ILST(ISORT)),ISORT=1,NSORT)
!    ! STORE: EFermi,SCFkey
!    IF (units_ev) THEN
!       efmut = efmu
!    ELSE
!       efmut = efmu/Ry2eV
!    ENDIF
!    WRITE(fh_scsn,*) efmut, scfmade
!    CLOSE(fh_scsn)
!
!  end subroutine WriteSCSFile
!
!  SUBROUTINE Deallocate_SCS
!    IF (ALLOCATED(Eny0)) DEALLOCATE(Eny0)
!    IF (ALLOCATED(Dny0)) DEALLOCATE(Dny0)
!    IF (ALLOCATED(Mny0)) DEALLOCATE(Mny0)
!    IF (ALLOCATED(Nod0)) DEALLOCATE(Nod0)
!    IF (ALLOCATED(RHOCOR0)) DEALLOCATE(RHOCOR0)
!    IF (ALLOCATED(POTFRZ0)) DEALLOCATE(POTFRZ0)
!    IF (ALLOCATED(lmval)) DEALLOCATE(lmval)
!    IF (ALLOCATED(R0)) DEALLOCATE(R0)
!    IF (ALLOCATED(tao0)) DEALLOCATE(tao0)
!    IF (ALLOCATED(tau0)) DEALLOCATE(tau0)
!    IF (ALLOCATED(znuc0)) DEALLOCATE(znuc0)
!    IF (ALLOCATED(smt0)) DEALLOCATE(smt0)
!    IF (ALLOCATED(axmag0)) DEALLOCATE(axmag0)
!    IF (ALLOCATED(nrad0)) DEALLOCATE(nrad0)
!    IF (ALLOCATED(nsym0)) DEALLOCATE(nsym0)
!  END SUBROUTINE Deallocate_SCS
!
!  SUBROUTINE Mix_Rho(RHO1,RHO0,nrad,rweight,h,Sym,LmSym,nrad_max,nsym_max,fh_info)
!    use com_dim, ONLY: nspin, nsort, natom, norbs
!    use com_idx, ONLY: is, ilsv
!    use lib_phys,ONLY: pi
!    USE lib_intg,ONLY: simps
!    USE FileMix, ONLY: Simple_Mix, Vanderbilt_Mix, Johnson_Mix
!    USE com_par, ONLY: alpha_mag, alpha_rho, MIX, alpha_large
!    USE lib_io,  ONLY: outdir
!    USE com_ham, ONLY: SASA, SMT
!    IMPLICIT NONE
!    !Passed variables
!    INTEGER, intent(in)      :: nrad_max, nsym_max
!    COMPLEX*16, intent(in)   :: RHO1(0:nrad_max,nsym_max,natom,nspin,norbs)
!    COMPLEX*16, intent(inout):: RHO0(0:nrad_max,nsym_max,natom,nspin,norbs)
!    INTEGER, intent(in)      :: nrad(nsort)
!    COMPLEX*16, intent(in)   :: rweight(0:nrad_max,nsort)
!    REAL*8, intent(in)       :: h(nsort)
!    LOGICAL, intent(in)      :: Sym(:,:)
!    INTEGER, intent(in)      :: LmSym(:,:)
!    INTEGER, intent(in)      :: fh_info
!    !Local variables
!    INTEGER,     PARAMETER :: lbroy=0
!!    REAL*8,      PARAMETER :: alpha_large=0.5
!    LOGICAL,     PARAMETER :: restart = .FALSE.
!    INTEGER    :: iatom, isort, l, m, lm, isym, irad, i
!    REAL*8     :: weight(0:nrad_max,nsort)
!    COMPLEX*16 :: trho(0:3,0:1)
!    REAL*8     :: tsum(0:3), tCharge, diff(0:3)
!    REAL*8     :: xrho(0:nrad_max), Frho(0:nrad_max), xmag(0:nrad_max), Fmag(0:nrad_max)
!    COMPLEX*16 :: zrho(0:nrad_max), Grho(0:nrad_max), zmag(0:nrad_max), Gmag(0:nrad_max)
!    LOGICAL    :: positive_rho
!    CHARACTER*100 :: mix_filerv(natom,nsym_max)
!    CHARACTER*100 :: mix_filemv(natom,nsym_max)
!    CHARACTER*100 :: mix_filerj(natom,nsym_max)
!    CHARACTER*100 :: mix_filemj(natom,nsym_max)
!    CHARACTER*50  :: chatom, chsym
!
!    DO iatom=1,natom
!       DO isym=1,nsym_max
!          write(chatom,fmt='(I)') iatom
!          write(chsym, fmt='(I)') isym
!          mix_filerv(iatom,isym) = TRIM(outdir)//'/vbmixr.'//TRIM(ADJUSTL(chatom))//'.'//TRIM(ADJUSTL(chsym))//'.tmp'
!          mix_filemv(iatom,isym) = TRIM(outdir)//'/vbmixm.'//TRIM(ADJUSTL(chatom))//'.'//TRIM(ADJUSTL(chsym))//'.tmp'
!          mix_filerj(iatom,isym) = TRIM(outdir)//'/jsmixr.'//TRIM(ADJUSTL(chatom))//'.'//TRIM(ADJUSTL(chsym))//'.tmp'
!          mix_filemj(iatom,isym) = TRIM(outdir)//'/jsmixm.'//TRIM(ADJUSTL(chatom))//'.'//TRIM(ADJUSTL(chsym))//'.tmp'
!       ENDDO
!    ENDDO
!    
!    DO isort=1,nsort
!       DO irad=0,nrad(isort)
!          !Integration weights
!          weight(irad,isort) = real(rweight(irad,isort))*h(isort)/(4*pi)
!          IF (irad.EQ.0 .OR. irad.EQ.nrad(isort)) weight(irad,isort) = 0.5*weight(irad,isort)
!          IF (weight(irad,isort).LT.1e-18) weight(irad,isort) = 1e-18
!       ENDDO
!    ENDDO
!
!    diff=0
!    DO iatom=1,natom
!       isort=is(iatom)
!       DO l=0,ilsv(isort)
!          DO m=-l,l
!             lm=l*(l+1)+m+1
!             IF(Sym(lm,iatom)) THEN
!                isym = LmSym(lm,iatom)
!                tsum=0
!                DO irad=0,nrad(isort)
!                   trho(0,1) = (RHO1(irad,isym,iatom,1,1)+RHO1(irad,isym,iatom,nspin,1))*0.5*nspin
!                   trho(0,0) = (RHO0(irad,isym,iatom,1,1)+RHO0(irad,isym,iatom,nspin,1))*0.5*nspin
!                   trho(1,1) = (RHO1(irad,isym,iatom,1,1)-RHO1(irad,isym,iatom,nspin,1))
!                   trho(1,0) = (RHO0(irad,isym,iatom,1,1)-RHO0(irad,isym,iatom,nspin,1))
!                   trho(2,1) = (RHO1(irad,isym,iatom,1,norbs))
!                   trho(2,0) = (RHO0(irad,isym,iatom,1,norbs))
!                   trho(3,1) = (RHO1(irad,isym,iatom,nspin,norbs))
!                   trho(3,0) = (RHO0(irad,isym,iatom,nspin,norbs))
!                   !Checking for difference between itterations
!                   DO i=0,3
!                      tsum(i) = tsum(i) + abs(trho(i,1)-trho(i,0))**2*weight(irad,isort)
!                   ENDDO
!                   !Mixing transverse magnetization
!                   RHO0(irad,isym,iatom,1,    norbs) = trho(2,0) + alpha_mag*(trho(2,1) -trho(2,0))
!                   RHO0(irad,isym,iatom,nspin,norbs) = trho(3,0) + alpha_mag*(trho(3,1) -trho(3,0))
!                   !Preparing density for mixing
!                   zrho(irad) = trho(0,0)
!                   Grho(irad) = trho(0,1) - trho(0,0)
!                   zmag(irad) = trho(1,0)
!                   Gmag(irad) = trho(1,1) - trho(1,0)
!                   IF (l.LE.lbroy) THEN
!                      !Preparing density for mixing at small l
!                      xrho(irad) = real(zrho(irad))*sqrt(weight(irad,isort))
!                      Frho(irad) = real(Grho(irad))*sqrt(weight(irad,isort))
!                      xmag(irad) = real(zmag(irad))*sqrt(weight(irad,isort))
!                      Fmag(irad) = real(Gmag(irad))*sqrt(weight(irad,isort))
!                   ENDIF
!                ENDDO
!                DO i=0,3
!                   diff(i) = diff(i) + sqrt(tsum(i))
!                ENDDO
!                !Finally, mixing
!                zrho(:) = zrho(:) + alpha_rho*Grho(:)
!                zmag(:) = zmag(:) + alpha_mag*Gmag(:)
!                IF (l.LE.lbroy) THEN
!                   SELECT CASE (MIX)
!                   CASE('v') 
!                      CALL Vanderbilt_Mix(mix_filerv(iatom,isym), nrad(isort)+1, Frho, xrho, restart, alpha_rho,alpha_large)
!                      CALL Vanderbilt_Mix(mix_filemv(iatom,isym), nrad(isort)+1, Fmag, xmag, restart, alpha_mag,alpha_large)
!                   CASE('j')
!                      CALL Johnson_Mix(mix_filerj(iatom,isym), nrad(isort)+1, Frho, xrho, restart, alpha_rho,alpha_large)
!                      CALL Johnson_Mix(mix_filemj(iatom,isym), nrad(isort)+1, Fmag, xmag, restart, alpha_mag,alpha_large)
!                   CASE DEFAULT
!                      xrho(:) = xrho(:) + alpha_rho*Frho(:)
!                      xmag(:) = xmag(:) + alpha_mag*Fmag(:)
!                   END SELECT
!                   DO irad=0,nrad(isort)
!                      Frho(irad) = xrho(irad)/sqrt(weight(irad,isort))*dreal(rweight(irad,isort))
!                   ENDDO
!                   tCharge = simps(nrad(isort)+1,Frho,h(isort))/sqrt(4*pi)
!                   tCharge = tCharge + (4*pi/3.)*(SASA(isort)**3-SMT(isort)**3)*xrho(nrad(isort))/sqrt(weight(nrad(isort),isort))/sqrt(4*pi)
!                   positive_rho = .TRUE.
!                   DO irad=0,nrad(isort)
!                      IF (xrho(irad).LT.0) positive_rho = .FALSE.
!                   ENDDO
!                   IF (.NOT.positive_rho) WRITE(6,*)'Mix_Rho: CHARGE DENSITY IS NOT POSITIVE'
!                   WRITE(6,fmt='(1x,A,1x,f10.3)') 'Mix_Rho: Partial charge of new density after Broyden is', tCharge
!                   IF (.NOT.positive_rho) THEN
!                      WRITE(6,*)'Mix_Rho: RESTARTING BROYDEN'
!                      !Removing files...
!                      OPEN(unit=1,file=mix_filerv(iatom,isym),form='unformatted',status='unknown')
!                      CLOSE(unit=1,status='DELETE')
!                      OPEN(unit=1,file=mix_filemv(iatom,isym),form='unformatted',status='unknown')
!                      CLOSE(unit=1,status='DELETE')
!                      OPEN(unit=1,file=mix_filerj(iatom,isym),form='unformatted',status='unknown')
!                      CLOSE(unit=1,status='DELETE')
!                      OPEN(unit=1,file=mix_filemj(iatom,isym),form='unformatted',status='unknown')
!                      CLOSE(unit=1,status='DELETE')
!                   ELSE
!                      DO irad=0,nrad(isort)
!                         zrho(irad)=xrho(irad)/sqrt(weight(irad,isort))
!                         zmag(irad)=xmag(irad)/sqrt(weight(irad,isort))
!                      ENDDO
!                   ENDIF
!                ENDIF
!                RHO0(:,isym,iatom,1,    1) = (zrho(:)+zmag(:))/nspin
!                RHO0(:,isym,iatom,nspin,1) = (zrho(:)-zmag(:))/nspin
!             ENDIF
!          ENDDO
!       ENDDO
!    ENDDO
!    ! Writing difference
!    WRITE(6,FMT='(1X,A,1x,G14.7,1x)') 'Charge density self-consistency=',diff(0)
!    IF (nspin.EQ.2) THEN
!       WRITE(6,FMT='(1X,A,1x,G14.7,1X)')'Zmagnetization self-consistency=',diff(1)
!       WRITE(6,FMT='(1X,A,1x,G14.7,1X)')'Mmagnetization self-consistency=',diff(2)
!       WRITE(6,FMT='(1X,A,1x,G14.7,1X)')'Pmagnetization self-consistency=',diff(3)
!    ENDIF
!
!    WRITE(fh_info,FMT='(1X,A,1x,G14.7,1x)') 'Charge density self-consistency=',diff(0)
!    IF (nspin.EQ.2) THEN
!       WRITE(fh_info,FMT='(1X,A,1x,G14.7,1X)')'Zmagnetization self-consistency=',diff(1)
!       WRITE(fh_info,FMT='(1X,A,1x,G14.7,1X)')'Mmagnetization self-consistency=',diff(2)
!       WRITE(fh_info,FMT='(1X,A,1x,G14.7,1X)')'Pmagnetization self-consistency=',diff(3)
!    ENDIF
!
!  END SUBROUTINE Mix_Rho
!

FUNCTION maxim(nsort, nrad)
  IMPLICIT NONE
  INTEGER :: maxim
  ! Passed variables
  INTEGER :: nsort
  INTEGER :: nrad(nsort)
  ! Local variables
  INTEGER :: nrad_max, isort
  nrad_max = nrad(1)
  DO isort=2,nsort
     IF (nrad(isort).GT.nrad_max) nrad_max = nrad(isort)
  ENDDO
  maxim = nrad_max
END FUNCTION maxim

!
!  FUNCTION maxim_(LIMVMEM,NATOMMEM,Sym, LmSym)
!    USE com_dim,   ONLY: natom
!    USE com_idx,   ONLY: is, ilst
!    IMPLICIT NONE
!    INTEGER  :: maxim_
!    ! Passed variables
!    INTEGER  :: LIMVMEM,NATOMMEM
!    LOGICAL  :: Sym(LIMVMEM,NATOMMEM)
!    INTEGER  :: LmSym(LIMVMEM,NATOMMEM)
!    ! Local variables
!    INTEGER  :: isym_max, isym
!    INTEGER  :: iatom, isort, l, m, lm
!    isym_max = 0
!    isym = 0
!    DO iatom=1,natom
!       isort = is(iatom)
!       DO l=0,ilst(isort)
!          DO m=-l,l
!             lm = l*(l+1)+m+1
!             IF(SYM(lm,iatom)) isym = LMSYM(lm,iatom)
!             IF (isym.GT.isym_max) isym_max = isym
!          ENDDO
!       ENDDO
!    ENDDO
!    maxim_ = isym_max
!  END FUNCTION maxim_
!
!END MODULE com_scs
