
SUBROUTINE cmp_mtoverlap(Olap, inpdir, bndind, isrt, nkp, natom, ndim)
  !******************************************************************************!
  USE msk, ONLY: open_file, close_file, readS
  IMPLICIT NONE
  !---------- Passed variables ----------     
  COMPLEX*16, intent(out) :: Olap(ndim,ndim,nkp)
  CHARACTER*1000, intent(in) :: inpdir
  INTEGER, intent(in)     :: bndind(ndim,4)
  INTEGER, intent(in)     :: isrt(natom)
  INTEGER, intent(in)     :: natom, ndim, nkp
  !f2py integer intent(hide), depend(bndind)  :: ndim=shape(bndind,0)
  !f2py integer intent(hide), depend(isrt)    :: natom=shape(isrt,0)
  !---------- Local variables ----------
  INTEGER    :: ikp              ! Loop index for k-point loop
  COMPLEX*16 :: Sk(ndim,ndim), Skp(ndim,ndim), Ojj(ndim,ndim)   ! temporary memory for structure constant
  COMPLEX*16 :: temp(ndim,ndim)
  INTEGER    :: iatom, p, q, i, l, isort, ispin, il, is
  INTEGER    :: l_max, nsort_tmp, nspin_tmp, fh_opar
  COMPLEX*16 :: moox(ndim,4)
  COMPLEX*16, ALLOCATABLE :: moo(:,:,:,:)
!!! Reads the overlap numbers

  fh_opar = 998
  OPEN(fh_opar,file=TRIM(inpdir)//"/opar.dat" ,form='formatted',status='old')
  !---------- Read dimension data ----------
  READ(fh_opar,*) l_max, nsort_tmp, nspin_tmp

  ALLOCATE(moo(4,0:l_max,nsort_tmp,nspin_tmp))
  !---------- Reads overlap numbers into moo ----
  DO i=1,4
     READ(fh_opar,*) (((moo(i,l,isort,ispin),l=0,l_max),isort=1,nsort_tmp),ispin=1,nspin_tmp)
     if (i.lt.4) READ(fh_opar,*) ! empty line
  ENDDO
  CLOSE(fh_opar)

  DO p=1,ndim
     iatom = bndind(p,1)
     isort = isrt(iatom)
     il    = bndind(p,2)
     ispin = bndind(p,4)
     DO i=1,4
        moox(p,i) = moo(i,il,isort,ispin)
     ENDDO
  ENDDO

  Olap=0
  ! Reads structure constant
  CALL open_file(inpdir, natom)
  DO ikp=1,nkp
     CALL readS(Sk, ikp, bndind, bndind, ndim, ndim)

     Skp = conjg(transpose(Sk))

     CALL ZProduct_ADAt(Ojj, Skp, moox(:,4), Sk, ndim, ndim, ndim, temp)

     DO p=1,ndim
        Olap(p,p,ikp) = Olap(p,p,ikp) + moox(p,1)

        DO q=1,ndim
           Olap(p,q,ikp) = Olap(p,q,ikp) - Skp(p,q)*moox(q,2)
           Olap(p,q,ikp) = Olap(p,q,ikp) - moox(p,3)*Sk(p,q)
           Olap(p,q,ikp) = Olap(p,q,ikp) + Ojj(p,q)
        ENDDO
     ENDDO
  ENDDO

  CALL close_file

  DEALLOCATE(moo)
!  print *, 'after deallocate'

END SUBROUTINE cmp_mtoverlap

