	SUBROUTINE BND_ALLOCATE(AOPER,IPAN)
*********************************************************
*  Prints potential parameters.                         *
*********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                    !!! from setup
      USE COM_CONTROL ,ONLY: LIFT,LMTO,IASA,IDMF,NPFR              !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS,ILST,ILSB
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP,EK                     !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN,IATS,ISTS                 !!! from readini
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDC,NBNDT,NBNDH         !!! from readini
	USE COM_LMTVEC  ,ONLY: APHR,APSR,APJR                        !!! from lmtbnd
      USE COM_STRCON  ,ONLY: SSCON,SDCON                           !!! from strgnt
	USE COM_LMTMAT  ,ONLY: HMAT,OMAT                             !!! from lmtmat
      USE COM_INDORB  ,ONLY: INDLMT                                !!! from lmtpar
	USE COM_ENERGY  ,ONLY: EARR,EARW,ETRT,ETRW,WTOS,WDOS
     &                      ,WTRT,WDRT                             !!! from allocate
      USE COM_FERMI   ,ONLY: ATOS,ADOS,ETOS                        !!! from ttrints
	USE COM_RINPAR  ,ONLY: RINT0,RFUN                            !!! from tosint
	USE COM_PULAYF  ,ONLY: PFVAL,PILF                            !!! from forces
      USE COM_KMESH   ,ONLY: NPNT,PNT                              !!! from makettr
      USE COM_FERMI   ,ONLY: EF                                    !!! from ttrints
      USE COM_LABELS  ,ONLY: TXTAT,TXTEL,TXTSP                     !!! from readini
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT                           !!! from setup
	USE COM_MASHDEP ,ONLY: NVAL,LENREL,LENCMP                    !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	CHARACTER*1 AOPER
	LOGICAL FIRST
	DATA FIRST/.TRUE./
C MEMORY ALLOCATIONS FOR MAIN CONTROL ARRAYS
	IF(FIRST)THEN                                 !!! for first call
	FIRST=.FALSE.
	NBNDTMEM=0
	NBNDHMEM=0
	DO JPAN=1,NPAN
	NBNDTMEM=MAX(NBNDTMEM,NBNDT(JPAN))
	NBNDHMEM=MAX(NBNDHMEM,NBNDT(JPAN)+NBNDH(JPAN))
	ENDDO
	ALLOCATE(EARR(NBNDTMEM*NSPINMEM,NPNTMEM,NPANMEM))
	ALLOCATE(EARW(NBNDTMEM*NSPINMEM,NPNWMEM,NPANMEM))
	ALLOCATE(WTOS(NBNDTMEM*NSPINMEM,NPNTMEM))
	ALLOCATE(WDOS(NBNDTMEM*NSPINMEM,NPNTMEM))
	ALLOCATE(ETRT(NBNDHMEM*NSPINMEM,NPNTMEM,NPANMEM))
	ALLOCATE(ETRW(NBNDHMEM*NSPINMEM,NPNWMEM,NPANMEM))
	ALLOCATE(WTRT(NBNDHMEM*NSPINMEM,NPNTMEM))
	ALLOCATE(WDRT(NBNDHMEM*NSPINMEM,NPNTMEM))
      SIZE_EARR=DBLE(SIZE(EARR)*LENREL)/1024.D0**2
      SIZE_WTOS=DBLE(SIZE(WTOS)*LENREL)/1024.D0**2
      SIZE_WDOS=DBLE(SIZE(WDOS)*LENREL)/1024.D0**2
      CURMEM=CURMEM+SIZE_EARR+SIZE_WTOS+SIZE_WDOS
	ALLOCATE(ETOS(NPANMEM,0:1,NSPINMEM))
	ALLOCATE(ATOS(0:LMAXTMEM,NSORTMEM,NKAPMEM,NKAPMEM,NPANMEM,
     &NSPINMEM,0:5))
	ALLOCATE(ADOS(0:LMAXTMEM,NSORTMEM,NKAPMEM,NKAPMEM,NPANMEM,
     &NSPINMEM))
	ALLOCATE(PFVAL(-1:1,NATOMMEM,NPANMEM,NSPINMEM,2))
	ENDIF                                         !!! for first call
C
	IF(AOPER.EQ.'A')THEN
	ALLOCATE(APHR(LIMBMEM,NATOMMEM,NKAPMEM,NSPINMEM,
     &              NBNDT(IPAN)*NSPINMEM))
	ALLOCATE(APSR(LIMBMEM,NATOMMEM,NKAPMEM,NSPINMEM,
     &              NBNDT(IPAN)*NSPINMEM))
	ALLOCATE(APJR(LIMT1MEM,NATOMMEM,NKAPMEM,NSPINMEM,
     &              NBNDT(IPAN)*NSPINMEM))
      ALLOCATE(HMAT(NBNDT(IPAN)*NSPINMEM,NBNDT(IPAN)*NSPINMEM))
      ALLOCATE(OMAT(NBNDT(IPAN)*NSPINMEM,NBNDT(IPAN)*NSPINMEM))
	ALLOCATE(SSCON(LIMT1MEM,NATOMMEM,LIMBMEM,NATOMMEM,NKAPMEM))
	ALLOCATE(SDCON(LIMB1MEM,NATOMMEM,LIMBMEM,NATOMMEM,NKAPMEM))
	ALLOCATE(RINT0(NBNDT(IPAN),NBNDT(IPAN)))
	ALLOCATE(RFUN(NBNDT(IPAN),0:MBASMEM))
      ALLOCATE(PILF(-1:1,NATOMMEM,NSPINMEM,NBNDT(IPAN)*NSPINMEM,2))
	ELSEIF(AOPER.EQ.'D')THEN
	DEALLOCATE(APHR,APSR,APJR)
	DEALLOCATE(HMAT,OMAT)
	DEALLOCATE(SSCON,SDCON)
	DEALLOCATE(RINT0,RFUN)
      DEALLOCATE(PILF)
	ENDIF
	END
