	SUBROUTINE BND_BNDPAR(IPAN)
*********************************************************
*  Prints potential parameters.                         *
*********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_CONTROL ,ONLY: LIFT,LMTO,IASA,IDMF,NPFR              !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS,ILST,ILSB
     &                      ,LRTV,NHSORT                           !!! from readini
      USE COM_LATPAR  ,ONLY: PAR,OMEGAC                            !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP,EK                     !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN,IATS,ISTS                 !!! from readini
      USE COM_SPHERE  ,ONLY: SMT,SASA,SWZ                          !!! from readini
      USE COM_INPTTR  ,ONLY: NDIV,NDIC,NDIVDIR,NDIR,PNTNOT         !!! from readini
      USE COM_HUBDAT  ,ONLY: NHUB,MCRL,LCRL,NCLM                   !!! from readhub
      USE COM_INPPAR  ,ONLY: ENY,DNY,TNY,NODES,MNY                 !!! from readini
      USE COM_KKRPAR  ,ONLY: CNY,WNY,VNY                           !!! from kkrpar
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDC,NBNDT,NBNDH         !!! from readini
     &                      ,MBNDF,MBNDE,MBNDC                     !!! from bzint
      USE COM_INDORB  ,ONLY: INDLMT                                !!! from lmtpar
      USE COM_KMESH   ,ONLY: NPNT,PNT                              !!! from makettr
      USE COM_FERMI   ,ONLY: EF                                    !!! from ttrints
      USE COM_LMTOUT  ,ONLY: ICPSI,PSIFILE,ICFAT,FATFILE           !!! from readini
     &                      ,ICDOS,DOSFILE,ICODF,ODFFILE
     &                      ,ICPSK,PSKFILE,ICCHI,ICOPT,SCRFILE
      USE COM_LABELS  ,ONLY: TXTAT,TXTEL,TXTSP                     !!! from readini
      USE COM_CHANNELS,ONLY: IUPSI,IUPSK,IUPUL,IUDOS,IUHAM,IUWFK   !!! from setup
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT                           !!! from setup
      USE COM_MASHDEP ,ONLY: NVAL                                  !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	LOGICAL, ALLOCATABLE :: TPAN(:,:)
	CHARACTER TXTNY(0:3)*6,TL(0:3)*1,TN(9)*1
	LOGICAL LOG,FIRST,EXIST,OPEN
	SAVE FIRST
	DATA PI/3.141592653589793D0/,TL/'s','p','d','f'/,TN/'1','2'
     &      ,'3','4','5','6','7','8','9'/,TXTNY/'fix.E '
     &      ,'fix.D ','bind.E','center'/,FIRST/.TRUE./
C RETURN KEYS
C     none
      CALL ABORTNOW()
C MEMORY ALLOCATIONS
	ALLOCATE(TPAN(NSORTMEM,NKAPMEM))
C START CODE
	DO IKAP=1,NKAP(IPAN)
	DO IATOM=1,NATOM
	TPAN(IS(IATOM),IKAP)=.FALSE.
	DO L=0,ILSB(IS(IATOM))
	IF(LTPAN(L,IATOM,IKAP,IPAN))TPAN(IS(IATOM),IKAP)=.TRUE.
	ENDDO
	ENDDO
	ENDDO
C REDEFINE # OF BANDS 
	IF(MBNDF.NE.-1.AND.MBNDE.NE.-1.AND.MBNDC.NE.-1)THEN
	NBNDF(1)=MBNDF
	NBNDE(1)=MBNDE
	NBNDC(1)=MBNDC
	ENDIF
C **************************************************************
	NRECLPSI=0
	DO ISORT=1,NSORT  !!! estimate record lenght
	MAXLM=(ILST(ISORT)+2)**2+2*(ILSB(ISORT)+1)**2 
	MAXLM=MAXLM*NATOM*NKAP(1)*(NBNDF(1)-NBNDE(1)+1)*NSPIN*NORBS
	NRECLPSI=MAX(NRECLPSI,NVAL*MAXLM)
	ENDDO
C OPEN FILE FOR CONDUCTION BANDS WAVE FUNCTIONS
	IF(ICPSI.EQ.0.AND.IPAN.EQ.1)THEN ! storage is not necessary
	INQUIRE(FILE=SCRFILE(IUPSI),EXIST=EXIST,OPENED=OPEN)
	IF(.NOT.OPEN.AND.EXIST)
     &OPEN(UNIT=IUPSI,FILE=SCRFILE(IUPSI),STATUS='OLD',ACCESS='DIRECT',
     &FORM='UNFORMATTED',RECL=NRECLPSI)
	IF(EXIST)CLOSE(UNIT=IUPSI,STATUS='DELETE')
	OPEN(UNIT=IUPSI,FILE=SCRFILE(IUPSI),STATUS='NEW',ACCESS='DIRECT',
     &FORM='UNFORMATTED',RECL=NRECLPSI)
	ELSEIF(ICPSI.NE.0.AND.IPAN.EQ.1)THEN
	INQUIRE(FILE=PSIFILE,EXIST=EXIST,OPENED=OPEN)
	IF(.NOT.OPEN.AND.EXIST)
     &OPEN(UNIT=IUPSI,FILE=PSIFILE,STATUS='OLD',ACCESS='DIRECT',
     &FORM='UNFORMATTED',RECL=NRECLPSI)
	IF(EXIST)CLOSE(UNIT=IUPSI,STATUS='DELETE')
	OPEN(UNIT=IUPSI,FILE=PSIFILE,STATUS='NEW',ACCESS='DIRECT',
     &FORM='UNFORMATTED',RECL=NRECLPSI)
	ENDIF
C **************************************************************
C OPEN FILE FOR ALL BANDS WAVE FUNCTIONS
	NRECLPSK=0
	DO JPAN=1,NPAN
	DO ISORT=1,NSORT  !!! estimate record lenght
	MAXLM=(ILST(ISORT)+2)**2+2*(ILSB(ISORT)+1)**2+NBNDH(JPAN)
	MAXLM=MAXLM*NATOM*NKAP(JPAN)*(NBNDT(JPAN)+NBNDH(JPAN))*NSPIN*NORBS
	NRECLPSK=MAX(NRECLPSK,NVAL*MAXLM)
	ENDDO
	ENDDO
	IF((ICPSK.EQ.1.OR.ICCHI.EQ.1.OR.ICOPT.EQ.1).AND.IPAN.EQ.1)THEN
	INQUIRE(FILE=SCRFILE(IUPSK),EXIST=EXIST,OPENED=OPEN)
	IF(.NOT.OPEN.AND.EXIST)
     &OPEN(UNIT=IUPSK,FILE=SCRFILE(IUPSK),STATUS='OLD',ACCESS='DIRECT',
     &FORM='UNFORMATTED',RECL=NRECLPSK)
	IF(EXIST)CLOSE(UNIT=IUPSK,STATUS='DELETE')
	OPEN(UNIT=IUPSK,FILE=SCRFILE(IUPSK),STATUS='NEW',ACCESS='DIRECT',
     &FORM='UNFORMATTED',RECL=NRECLPSK)
	ELSEIF(ICPSK.EQ.2.AND.IPAN.EQ.1)THEN
	INQUIRE(FILE=PSKFILE,EXIST=EXIST,OPENED=OPEN)
	IF(.NOT.OPEN.AND.EXIST)
     &OPEN(UNIT=IUPSK,FILE=PSKFILE,STATUS='OLD',ACCESS='DIRECT',
     &FORM='UNFORMATTED',RECL=NRECLPSK)
	IF(EXIST)CLOSE(UNIT=IUPSK,STATUS='DELETE')
	OPEN(UNIT=IUPSK,FILE=PSKFILE,STATUS='NEW',ACCESS='DIRECT',
     &FORM='UNFORMATTED',RECL=NRECLPSK)
	ENDIF
C **************************************************************
C OPEN FILE FOR PULAY FORCES
      NRECLPUL=NVAL*3*NATOM*2
      IF(NPFR.NE.0.AND.IPAN.EQ.1)THEN
	INQUIRE(FILE=SCRFILE(IUPUL),EXIST=EXIST,OPENED=OPEN)
	IF(.NOT.OPEN.AND.EXIST)
     &OPEN(UNIT=IUPUL,FILE=SCRFILE(IUPUL),STATUS='OLD',ACCESS='DIRECT',
     &FORM='UNFORMATTED',RECL=NRECLPUL)
	IF(EXIST)CLOSE(UNIT=IUPUL,STATUS='DELETE')
      OPEN(UNIT=IUPUL,FILE=SCRFILE(IUPUL),STATUS='NEW',ACCESS='DIRECT',
     &FORM='UNFORMATTED',RECL=NRECLPUL)
	ENDIF
C **************************************************************
C OPEN FILE FOR TLM-CHARACTERS
	IF((ICFAT.GT.0.OR.ICDOS.GT.0).AND.IPAN.EQ.1)THEN
	INQUIRE(FILE=SCRFILE(IUDOS),EXIST=EXIST,OPENED=OPEN)
	IF(.NOT.OPEN.AND.EXIST)
     &OPEN(UNIT=IUDOS,FILE=SCRFILE(IUDOS),STATUS='OLD',
     &ACCESS='SEQUENTIAL',FORM='UNFORMATTED')
	IF(EXIST)CLOSE(UNIT=IUDOS,STATUS='DELETE')
	OPEN(UNIT=IUDOS,FILE=SCRFILE(IUDOS),STATUS='NEW',
     &ACCESS='SEQUENTIAL',FORM='UNFORMATTED')
      ENDIF
C **************************************************************
C OPEN FILE FOR STORING HAMILTONIAN
	IF(IDMF.GT.2.AND.IPAN.EQ.1)THEN
	NRECLHAM=NVAL*2*NBNDT(1)*NBNDT(1)
	INQUIRE(FILE=SCRFILE(IUHAM),EXIST=EXIST,OPENED=OPEN)
	IF(.NOT.OPEN.AND.EXIST)
     &OPEN(UNIT=IUHAM,FILE=SCRFILE(IUHAM),STATUS='OLD',ACCESS='DIRECT',
     &FORM='UNFORMATTED',RECL=NRECLHAM)
	IF(EXIST)CLOSE(UNIT=IUHAM,STATUS='DELETE')
	OPEN(UNIT=IUHAM,FILE=SCRFILE(IUHAM),STATUS='NEW',ACCESS='DIRECT',
     &FORM='UNFORMATTED',RECL=NRECLHAM)
      ENDIF
C **************************************************************
C OPEN FILE FOR STORING EIGENVECTORS FOR CORRELATED STATES
	IF(IDMF.GT.2.AND.IPAN.EQ.1)THEN
	IF(NCLM.EQ.0)
     &CALL FULLSTOP('<BND_BNDPAR> :: Correlated subset not defined')
	NRECLWFK=NVAL*2*NCLM*NORBS*NBNDT(1)*NSPIN
	INQUIRE(FILE=SCRFILE(IUWFK),EXIST=EXIST,OPENED=OPEN)
	IF(.NOT.OPEN.AND.EXIST)
     &OPEN(UNIT=IUWFK,FILE=SCRFILE(IUWFK),STATUS='OLD',ACCESS='DIRECT',
     &FORM='UNFORMATTED',RECL=NRECLWFK)
	IF(EXIST)CLOSE(UNIT=IUWFK,STATUS='DELETE')
	OPEN(UNIT=IUWFK,FILE=SCRFILE(IUWFK),STATUS='NEW',ACCESS='DIRECT',
     &FORM='UNFORMATTED',RECL=NRECLWFK)
      ENDIF
C
	FIRST=.FALSE.
	DO ISPIN=1,NSPIN                          !!! over ispin
	IF(NSPIN.EQ.1)WRITE(IUN,1010)NKAP(IPAN),IPAN
	IF(NSPIN.EQ.2)WRITE(IUN,1015)NKAP(IPAN),TXTSP(ISPIN),IPAN
	DO ISORT=1,NSORT                          !!! over isort
	DO IKAP=1,NKAP(IPAN)                      !!! over ikap
	IF(ISTS(ISORT,IPAN).NE.0.AND.TPAN(ISORT,IKAP))
     &WRITE(IUN,1020)DREAL(EKAP(IKAP,IPAN)),TXTEL(ISORT)
	DO L=0,ILSB(ISORT)                        !!! over l
	MN=MNY(L,ISORT,IKAP,IPAN)
	NO=TNY(L,ISORT,IKAP,IPAN,ISPIN)+L+1
	IF(LSPAN(L,ISORT,IKAP,IPAN))
     &WRITE(IUN,1030)ENY(L,ISORT,IKAP,IPAN,ISPIN),
     &DNY(L,ISORT,IKAP,IPAN,ISPIN),CNY(L,ISORT,IKAP,IPAN,ISPIN),
     &WNY(L,ISORT,IKAP,IPAN,ISPIN),TN(NO)//TL(L),TXTNY(MN)
C	IF(.NOT.LSPAN(L,ISORT,IKAP,IPAN).AND.IPAN.EQ.1)
C    &WRITE(IUN,1040)ENY(L,ISORT,IKAP,IPAN,ISPIN),
C    &DNY(L,ISORT,IKAP,IPAN,ISPIN),TN(NO)//TL(L),TXTNY(MN)
	ENDDO                                     !!! over l
	ENDDO                                     !!! over ikap
	ENDDO                                     !!! over isort
	ENDDO                                     !!! over ispin
C MEMORY DEALLOCATIONS
	DEALLOCATE(TPAN)
1010  FORMAT(1X,I1,'kappa panel #',I2,
     &' : Band Structure Calculation of E(k) with :')
1015  FORMAT(1X,I1,'kappa spin-',A2,' panel #',I2,
     &' : Band Structure Calculation of E(k) with :')
1020  FORMAT('     Eny:    ','     Dny:    ','     Cny:    ',
     &       '     Wny:    ',' Et=',G10.3,A11)
1030  FORMAT(4(1X,G12.5),    ' for ',A2,'-state, ',A6)
1040  FORMAT(2(1X,G12.5),26X,' for ',A2,'-state, ',A6)
	END
