	SUBROUTINE BND_FNDFRM(X1,Y0,X0,ITMAX,EPS,H)
**************************************************************
*  Searches Fermi's energy.                                  *
**************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	LOGICAL LEFT,RIGHT
C INITIATION
	ITER=1
	H1=1.D0/H
	X=X1
	LEFT=.FALSE.
	RIGHT=.FALSE.
C
C THE BEGINNING OF THE ITERATION LOOP.
C
  100	CALL BND_TTRINT(X,Y,DY,0)
C	DY=DY/DX
	YY=Y-Y0
	IF(ABS(YY).LE.EPS) GOTO 200
C	WRITE(IUT,*)'ITER,X,YY',ITER,X,YY  !!!DEBUGGING
	CALL SLTRT(X,YY,DY,XL,YYL,DYL,LEFT,XR,YYR,DYR,RIGHT)
	IF(.NOT.LEFT.OR..NOT.RIGHT) THEN
C	THE NEWTON'S METHOD.
	IF(DY.LE.ABS(YY*H1)) X=X-SIGN(H,YY)
C	WITH LIMITATION
	IF(DY.GT.ABS(YY*H1)) X=X-YY/DY
C	WITHOUT LIMITATION
	ELSEIF(LEFT.AND.RIGHT)THEN
C	THE PARABOLA METHOD.
	DELTX=XR-XL
	IF(DELTX.LE.1.D-10)GOTO 200
	DYS=(YYR-YYL)/DELTX
	IF(ABS(YYL).LE.YYR)THEN
	ALFA=ABS(YYL/DELTX)
	IF(ALFA.LE.DYL)THEN
	A=ALFA/DYL
	B=DYS/DYL
	X=XL+DELTX*F1(A,B)
	ELSE
	C=DYL/ALFA
	D=DYS/ALFA
	X=XL+DELTX*F2(C,D)
	END IF
	ELSE
	BETA=YYR/DELTX
	IF(BETA.LE.DYR)THEN
	A=BETA/DYR
	B=DYS/DYR
	X=XR-DELTX*F1(A,B)
	ELSE
	C=DYR/BETA
	D=DYS/BETA
	X=XR-DELTX*F2(C,D)
	END IF
	END IF
	END IF
C	EXITS
	IF(ITER.GE.ITMAX.AND.ITMAX.GT.1)GOTO 200
	IF(ABS(YY).LE.EPS) GOTO 200
	ITER=ITER+1
	GOTO 100
C	THE END OF THE LOOP.
  200	IF(ITER.NE.1)THEN
	X0=X
	ELSE
	X0=X1
	ENDIF
	RETURN
C INTERNAL PROCEDURES
      CONTAINS
      FUNCTION F1(A,B)
      IMPLICIT REAL*8 (A-H,O-Z)
      F1=2.D0*A/(1.D0+SQRT(1.D0+4.D0*A*(B-1.D0)))
      END FUNCTION F1
      FUNCTION F2(C,D)
      IMPLICIT REAL*8 (A-H,O-Z)
      F2=2.D0/(C+SQRT(C*C+4.D0*(D-C)))
      END FUNCTION F2
      SUBROUTINE SLTRT(X,YY,DY,XL,YYL,DYL,LEFT,XR,YYR,DYR,RIGHT)
*************************************************************
*  CLASSIFIES X INTO LEFT AND RIGHT POINTS.                 *
*************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      LOGICAL LEFT,RIGHT
      IF(YY.LE.0.D0) THEN
      XL=X
      YYL=YY
      DYL=DY
      LEFT=.TRUE.
      ELSE
      XR=X
      YYR=YY
      DYR=DY
      RIGHT=.TRUE.
      END IF
      RETURN
      END SUBROUTINE SLTRT
      END SUBROUTINE BND_FNDFRM
