	SUBROUTINE BND_FTRMAT(PNTK,ID,IPAN,PNTR,YLM,CFTR)
***********************************************************
*  Calculates Fourier transform for the pseudoorbitals.   *
***********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_PARAM  ,ONLY: NATOM,NSORT,IS,ILSB,ILST          !!! from readini
      USE COM_LATPAR ,ONLY: PAR,OMEGAC                        !!! from readini
      USE COM_KAPPAR ,ONLY: NPAN,NKAP,EKAP,EK                 !!! from readini
      USE COM_PANPAR ,ONLY: LTPAN,LSPAN                       !!! from readini
      USE COM_SPHERE ,ONLY: SWZ,SMT                           !!! from readini
      USE COM_LATTICE,ONLY: TAU                               !!! from readstr
      USE COM_PLWMESH,ONLY: NPLW,GPLW                         !!! from plwmesh
      USE COM_TEILORG,ONLY: MBAS,KEYT                         !!! from readini
      USE COM_ETAPAR ,ONLY: NBAS,LBAS,ETA                     !!! from setpar
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: CCOF(:,:,:)
	COMPLEX*16 YLM(LIMBMEM,0:NBASMEM),DELE,EXPGK
     &  ,CFTR(0:LMAXBMEM,NSORTMEM,NKAPMEM,0:NBASMEM)
	DIMENSION PNTR(3),PNTK(3)
	DATA PI/3.141592653589793D0/
      CALL ABORTNOW()
C MEMORY ALLOCATIONS
	ALLOCATE(CCOF(0:LMAXBMEM,NKAPMEM,NSORTMEM))
      PNTR(1)=PNTK(1)*2.D0*PI/PAR
      PNTR(2)=PNTK(2)*2.D0*PI/PAR
      PNTR(3)=PNTK(3)*2.D0*PI/PAR
C  CALCULATE SPHERICAL HARMONICS
	LMB=0
	DO 20 ISORT=1,NSORT
	DO 20 IKAP=1,NKAP(IPAN)
	DO 10 L=0,ILSB(ISORT)
	IF(.NOT.LSPAN(L,ISORT,IKAP,IPAN))GOTO10
	LMB=MAX(L,LMB)
 10   CONTINUE
 20   CONTINUE
	IF(ID.EQ.0)NDOT=MIN(NBAS,MBAS)
	IF(ID.EQ.1)NDOT=NBAS
	DO 60 IBAS=0,NDOT
	GKX=(GPLW(1,IBAS)+PNTK(1))*2.D0*PI/PAR
	GKY=(GPLW(2,IBAS)+PNTK(2))*2.D0*PI/PAR
	GKZ=(GPLW(3,IBAS)+PNTK(3))*2.D0*PI/PAR
	ABSG=SQRT(GKX**2+GKY**2+GKZ**2)
C  CHECK WHETHER K+G=0
	IF(ABSG.GE.1.D-10)THEN
	CALL LIB_SPHHARM(GKX/ABSG,GKY/ABSG,GKZ/ABSG,LMB,YLM(1,IBAS))
	DO 40 L=0,LMB
	IF(L.EQ.0)GKL=1.D0
	IF(L.NE.0)GKL=ABSG**L
	DO 30 M=-L,L
	LM=L*(L+1)+M+1
	YLM(LM,IBAS)=YLM(LM,IBAS)*GKL
 30	CONTINUE
 40 	CONTINUE
	ELSE
	YLM(1,IBAS)=1.D0/SQRT(4.D0*PI)
	DO 50 LM=2,(LMB+1)**2
	YLM(LM,IBAS)=(0.D0,0.D0)
 50   CONTINUE
	ENDIF
 60   CONTINUE
C  *** CALCULATE FOURIER COEFFICIENTS ***
	DO 90 ISORT=1,NSORT                           !!! over isort
	DO 80 IKAP=1,NKAP(IPAN)                       !!! over ikap
	DO 70 L=0,ILSB(ISORT)                         !!! over l
	CCOF(L,IKAP,ISORT)=4.D0*PI/OMEGAC*SMT(ISORT)**(L+1)/
     &DFACT(2*L-1)*EXP(EKAP(IKAP,IPAN)*0.25D0/
     &ETA(L,ISORT,IKAP,IPAN)**2)
 70   CONTINUE
 80   CONTINUE
 90   CONTINUE
C  GET FOURIER TRANSFORM FOR THE PSEUDOORBITALS
	DO 140 ISORT=1,NSORT                          !!! over isort
	DO 130 IKAP=1,NKAP(IPAN)                      !!! over ikap
	DO 120 L=0,ILSB(ISORT)                        !!! over l
	IF(ID.EQ.0)NDOL=MIN(LBAS(L,ISORT,IKAP,IPAN),MBAS)
	IF(ID.EQ.1)NDOL=LBAS(L,ISORT,IKAP,IPAN)
	IF(LSPAN(L,ISORT,IKAP,IPAN))THEN
	DO 100 IBAS=0,NDOL                            !!! over ibas
	GKX=(GPLW(1,IBAS)+PNTK(1))*2.D0*PI/PAR
	GKY=(GPLW(2,IBAS)+PNTK(2))*2.D0*PI/PAR
	GKZ=(GPLW(3,IBAS)+PNTK(3))*2.D0*PI/PAR
	GD2=GKX**2+GKY**2+GKZ**2
	ABSG=SQRT(GD2)
	DELE=1.D0/(GD2-EKAP(IKAP,IPAN))                     
	EXPGK=EXP(-GD2*0.25D0/ETA(L,ISORT,IKAP,IPAN)**2)
	CFTR(L,ISORT,IKAP,IBAS)=CCOF(L,IKAP,ISORT)*DELE*EXPGK
100   CONTINUE                                     !!! over ibas
	ELSE
	DO 110 IBAS=0,NDOL                           !!! over ibas
	CFTR(L,ISORT,IKAP,IBAS)=(0.D0,0.D0)
110   CONTINUE                                     !!! over ibas
	ENDIF
120   CONTINUE                                     !!! over l
130   CONTINUE                                     !!! over ikap
140   CONTINUE                                     !!! over isort
C MEMORY ALLOCATIONS
	DEALLOCATE(CCOF)
      CONTAINS
      FUNCTION DFACT(N) !!! N MUST BE ODD NUMBER  !!!
      IMPLICIT REAL*8 (A-H,O-Z)
      DFACT=1.0
      DO I=1,N,2
      DFACT=DFACT*I
      ENDDO
      END FUNCTION DFACT
      END SUBROUTINE BND_FTRMAT
