	SUBROUTINE BND_GETENR
******************************************************
*   Reads Band Structure                             *
******************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                          !!! from setup
      USE COM_CONTROL ,ONLY: LIFT,LMTO,IASA,LRWF,NPFR         !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS       !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP                   !!! from readini
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC,NBNDH    !!! from readini
      USE COM_INPTTR  ,ONLY: NDIV,NDIC,NDIW                   !!! from readstr
      USE COM_WMESH   ,ONLY: NPNW,PNW                         !!! from makettr
      USE COM_FERMI   ,ONLY: EF                               !!! from ttrints
      USE COM_ENERGY  ,ONLY: EARW,ETRW                        !!! from bands
      USE COM_LABELS  ,ONLY: TXTAT,TXTEL,TXTSP                !!! from readini
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT,IUI                  !!! from setup
      USE COM_CHANNELS,ONLY: IUAIN                            !!! from channels
      USE COM_MASHDEP ,ONLY: NVAL,LENCMP                      !!! from setup
      USE COM_LMTINP  ,ONLY: ICENR,ENRFILE                    !!! from readini
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER NDIW0(3)
	DIMENSION PNW0(3)
	LOGICAL EXIST,OPEN
	DATA PI/3.141592653589793D0/
	IF(ICENR.NE.2)RETURN
C STORE HEADER INFO.
	INQUIRE(FILE=ENRFILE,EXIST=EXIST)
	IF(.NOT.EXIST)CALL FULLSTOP('<GENTENR>:: ENRFILE SHOULD EXIST!')
	OPEN(UNIT=IUAIN,FILE=ENRFILE,STATUS='OLD',FORM='UNFORMATTED')
	READ(IUAIN)EF0,NDIW0,NSPIN0,NPNW0,NBNDT0,NBNDH0
	IF(NSPIN0.NE.NSPIN)
     &CALL FULLSTOP('<GETENR>:: NSPIN MISMATCH IN ENRFILE')
	IF(NPNW0.NE.NPNW(1))
     &CALL FULLSTOP('<GETENR>:: NPNTW MISMATCH IN ENRFILE')
	IF(NBNDT0.NE.NBNDT(1))
     &CALL FULLSTOP('<GETENR>:: NBNDT MISMATCH IN ENRFILE')
	IF(NBNDH0.NE.NBNDH(1))
     &CALL FULLSTOP('<GETENR>:: NBNDH MISMATCH IN ENRFILE')
	IF(NDIW(1).NE.NDIW(1).OR.
     &   NDIW(2).NE.NDIW(2).OR.
     &   NDIW(3).NE.NDIW(3))
     &CALL FULLSTOP('<GETENR>:: NDIW MISMATCH IN ENRFILE')
	DO IPNT=1,NPNW0
	READ(IUAIN)(PNW0(I),I=1,3)
	READ(IUAIN)((EARW(IBNDS+NSPIN*(IBNDT-1),IPNT,1),
     &IBNDT=1,NBNDT(1)),IBNDS=1,NSPIN)
	READ(IUAIN)((ETRW(IBNDS+NSPIN*(IBNDT-1),IPNT,1),
     &IBNDT=1,NBNDT(1)+NBNDH(1)),IBNDS=1,NSPIN)
	ENDDO
	CLOSE(IUAIN)
	END
