	SUBROUTINE BND_LMTBND(IPNT,IPAN,IENW)
*********************************************************
*  Subroutine prepares hamiltonian matrix and overlap   *
*  matrix,calculates eigenvalues and eigenvectors and   *
*  prepares wave functions                              *
*********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                           !!! from setup
      USE COM_CONTROL ,ONLY: LIFT,LMTO,IDMF                    !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS           !!! from readini
     &                      ,IS,ILST,ILSB,ILSV                 !!! ILSV added by KH
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP,EK                 !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN                       !!! from readini
      USE COM_SPHERE  ,ONLY: SMT,SWZ                           !!! from readini
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDH           !!! from readini
	USE COM_LMTVEC  ,ONLY: APHR,APSR,APJR                    !!! from lmtbnd
	USE COM_INDORB  ,ONLY: INDLMT                            !!! from lmtpar
      USE COM_HUBDAT  ,ONLY: MCRL,LCRL,NCLM                    !!! from readhub
	USE COM_LMTMAT  ,ONLY: HMAT,OMAT                         !!! from lmtmat
      USE COM_KMESH   ,ONLY: NPNT,PNT                          !!! from tetra
      USE COM_WMESH   ,ONLY: NPNW,PNW                          !!! from tetra
      USE COM_SCRINP  ,ONLY: ALPHA                             !!! from alpcon
      USE COM_ENERGY  ,ONLY: EARR,EARW,ETRT,ETRW               !!! from bands
      USE COM_STRCON  ,ONLY: SSCON,SDCON                       !!! from strgnt
      USE COM_MASHDEP ,ONLY: LENCMP                            !!! from readini
	USE COM_LMTOUT  ,ONLY: ICPSK,ICCHI,ICOPT,ICODF           !!! from readini
	USE COM_CHANNELS,ONLY: IUPSI,IUPSK,IUHAM,IUWFK           !!! from readini
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT                       !!! from setup
      USE COM_OVRPAR  ,ONLY: OPARHH,OPARJH,OPARHJ,OPARJJ       !!! added by K.Haule
      USE COM_LATPAR  ,ONLY: PAR                               !!! added by K.Haule
      USE COM_SUMPAR  ,ONLY: OHH,OJH,OHJ,OJJ                   !!! added by K.Haule
      USE COM_LMTPAR  ,ONLY: GAM                               !!! added by K.Haule
      USE COM_SPHERE  ,ONLY : ZNUC,ZVAL,ZSEM,ZCOR              ! KH
      USE COM_INDORB  ,ONLY: INDLMT                            ! KH - it used to be LMTIND from COM_LMTIND
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER, INTRINSIC :: SIZE
	REAL*8, ALLOCATABLE :: E(:)
	COMPLEX*16, ALLOCATABLE :: CR(:,:,:)
	COMPLEX*16, ALLOCATABLE :: SR(:,:,:)
	COMPLEX*16 CONV
	LOGICAL LOG
	SAVE NERR

c---------- Start : Hamiltonian and overlap matrix output by Gunnar ----------
	integer :: fh_ham = 537
	integer :: fh_olp = 557
	integer, parameter  :: fh_idx = 7919 ! File handle added by Gunnar
	integer :: fh_strc = 577 ! For structure constants  -:) added by K.Haule
	integer :: fh_opar = 597 ! For overlap coefficients -:) added by K.Haule
c---------- Finish: Hamiltonian and overlap matrix output by Gunnar ----------

	
	CALL ABORTNOW()
C MEMORY ALLOCATIONS
	ALLOCATE(E(NBNDT(IPAN)*NSPINMEM))
      ALLOCATE(CR(NCLM,NSPINMEM,NBNDT(IPAN)*NSPINMEM))
      ALLOCATE(SR(NCLM,NSPINMEM,NBNDT(IPAN)*NSPINMEM))
	NDIM=NBNDT(IPAN)*NSPIN
C HERMITIANNESS OF THE MATRICES
	DO IDIM1=1,NDIM
	DO IDIM=1,IDIM1
      TH=ABS(HMAT(IDIM1,IDIM)-CONJG(HMAT(IDIM,IDIM1)))
      IF(TH.GE.1.D-05)WRITE(IUT,*)'HMAT-->',IDIM1,IDIM,TH
      TO=ABS(OMAT(IDIM1,IDIM)-CONJG(OMAT(IDIM,IDIM1)))
      IF(TO.GE.1.D-05)WRITE(IUT,*)'OMAT-->',IDIM1,IDIM,TO
	ENDDO
	ENDDO

c---------- Start : Hamiltonian and overlap matrix output by Gunnar ----------
	   
      if(IPAN.eq.1) then
	 if(IPNT.eq.1) then
	    open(fh_ham,file='ham.dat',form='formatted')
	    open(fh_olp,file='olp.dat',form='formatted')
	    open(fh_strc,file='Sk.dat',form='formatted') ! K.H.
	    open(fh_opar,file='opar.dat',form='formatted') ! K.H.
	    write(fh_ham,*) NPNT(1),NBNDT(1),norbs,nspin,LMAXBMEM
	    write(fh_olp,*) NPNT(1),NBNDT(1),norbs,nspin,LMAXBMEM
	    
	    ! Added by K.Haule for output of decomposition of overlap matrix
	    ! O_k = oparhh - S_k^+ . oparjh - oparhj . S_k + S_k^+ . oparjj . S_k
	    write(fh_opar,*) LMAXBMEM, NSORT, NSPIN
	    write(fh_opar,*) (((ohh(1,1,il,isort,1,ispin,1),il=0,
     &	                        LMAXBMEM),isort=1,NSORT),ispin=1,NSPIN)
            write(fh_opar,*)
	    write(fh_opar,*) (((ojh(1,1,il,isort,1,ispin,1),il=0,
     &	                        LMAXBMEM),isort=1,NSORT),ispin=1,NSPIN)
            write(fh_opar,*)
	    write(fh_opar,*) (((ohj(1,1,il,isort,1,ispin,1),il=0,
     &	                        LMAXBMEM),isort=1,NSORT),ispin=1,NSPIN)
            write(fh_opar,*)
	    write(fh_opar,*) (((ojj(1,1,il,isort,1,ispin,1),il=0,
     &	                        LMAXBMEM),isort=1,NSORT),ispin=1,NSPIN)
	    close(fh_opar)
	    
	    write(fh_strc,*) LIMT1MEM, LIMBMEM, NATOM, PAR

c---------- Output of IDX FILE added by K.Haule  ----------

        open(fh_idx,file="idx.dat",status='unknown')
	
	write(fh_idx,'("##### Number of atoms and sorts #####")')
	write(fh_idx,'(2i3)') natom,nsort
	write(fh_idx,'("##### Atom to sort index and max L #####")')
	do iatom = 1,natom
           isort = is(iatom)
           write(fh_idx,'(5i3)') iatom,isort,ilsb(isort),ilst(isort),
     &                                                   ilsv(isort)
	enddo
	write(fh_idx,'("##### Orbital presence array #####")')
	write(fh_idx,'("##### Atom #, l and is there #####")')
	do iatom = 1,natom
	   isort = is(iatom)
	   do l = 0,ilsb(isort)
	      write(fh_idx,'(2i3,l2)') iatom,l,ltpan(l,iatom,1,1)
	   enddo
	enddo
	write(fh_idx,'("##### Hamiltonian index array #####")')
	write(fh_idx,'("##### Atom, l, m and index    #####")')
	do iatom = 1,natom
	   isort = is(iatom)
	   do l = 0,ilsb(isort)
	      do m = -l,l
		 lm = l*(l+1)+m+1
                 if (ltpan(l,iatom,1,1)) then
                 write(fh_idx,'(4i4)') iatom,l,m,indlmt(lm,iatom,1,1,1)
                 else
                 write(fh_idx,'(4i4)') iatom,l,m,0
                 endif
	      enddo
	   enddo
	enddo
      write(fh_idx,'("#### Nuclear charge ####")')
      write(fh_idx,*) ZNUC,ZVAL,ZSEM,ZCOR  
      close(fh_idx)
c---------- End of output into IDX file  ----------
        
	 else
            open(fh_ham,file='ham.dat',access='SEQUENTIAL',
     &	    POSITION='APPEND')
	    open(fh_olp,file='olp.dat',access='SEQUENTIAL',
     &	    POSITION='APPEND')
	    open(fh_strc,file='Sk.dat',access='SEQUENTIAL',
     &	    POSITION='APPEND') ! K.H.

         endif

	 write(fh_ham,*) IPNT
	 write(fh_olp,*) IPNT
	 write(fh_strc,*) IPNT ! K.H.
	   
	 if(IENW.eq.1)NSHIFT=0
	 if(IENW.eq.0.and.NPNW(1).eq.NPNT(1))NSHIFT=0
	 if(IENW.eq.0.and.NPNW(1).gt.NPNT(1))NSHIFT=NSPIN*NORBS*NPNW(1)

         write(fh_ham,*) ((hmat(idim1,idim),idim1=1,ndim),idim=1,ndim)
         write(fh_olp,*) ((omat(idim1,idim),idim1=1,ndim),idim=1,ndim)

	! Output of structure constants added by K.Haule
	 write(fh_strc,*) ((((SSCON(ilm,iatom,ilm1,iatom1,1),
     &   ilm=1,LIMT1MEM),iatom=1,NATOM),ilm1=1,LIMBMEM),iatom1=1,NATOM)

	 close(fh_strc)
	 ! Finish output by K.H.
	   
	 close(fh_ham)
	 close(fh_olp)
      endif

c---------- Finish: Hamiltonian and overlap matrix output by Gunnar --------


	
C HAMILTONIAN STORAGE
	IF(IDMF.GT.2.AND.IPAN.EQ.1)THEN
	IF(IENW.EQ.1)NSHIFT=0
	IF(IENW.EQ.0.AND.NPNW(1).EQ.NPNT(1))NSHIFT=0
	IF(IENW.EQ.0.AND.NPNW(1).GT.NPNT(1))NSHIFT=NSPIN*NORBS*NPNW(1)
	DO IORBS=1,NORBS
	DO IUPDN=1,NSPIN
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
	IREC=IUPDN+NSPIN*(IORBS-1)+NSPIN*NORBS*(IPNT-1)+NSHIFT
      WRITE(IUHAM,REC=IREC)
     &((HMAT(IDIM1+NBNDT(1)*(ISPIN1-1),IDIM+NBNDT(1)*(ISPIN-1)),
     &IDIM1=1,NBNDT(1)),IDIM=1,NBNDT(1)),
     &((OMAT(IDIM1+NBNDT(1)*(ISPIN1-1),IDIM+NBNDT(1)*(ISPIN-1)),
     &IDIM1=1,NBNDT(1)),IDIM=1,NBNDT(1))
	ENDDO
	ENDDO
	ENDIF
C GENERALIZED EIGENVALUE PROBLEM
	IF(IPNT.EQ.1)NERR=0
      CALL LIB_EIGEN1C(NDIM,HMAT,OMAT,E,NSPIN,NORBS,1,IERR,0,1.D-07)
	IF(IERR.EQ.1)NERR=NERR+1
	IF((IPNT.EQ.NPNT(IPAN).OR.IPNT.EQ.NPNW(IPAN)).AND.NERR.NE.0)THEN
	WRITE(IUT,*)'Warning from <LMTBND>:'
	WRITE(IUT,*)'There were ',NERR,' errors in Cholesky decomposition'
	ENDIF
C EIGENVALUES
      DO IBNDS=1,NSPIN
      DO IBNDT=1,NBNDT(IPAN)
      IBAND=IBNDS+NSPIN*(IBNDT-1)
      IF(IENW.EQ.0)EARR(IBAND,IPNT,IPAN)=E(IBAND)
      IF(IENW.EQ.0)ETRT(IBAND,IPNT,IPAN)=E(IBAND)
      IF(IENW.EQ.1)EARW(IBAND,IPNT,IPAN)=E(IBAND)
      IF(IENW.EQ.1)ETRW(IBAND,IPNT,IPAN)=E(IBAND)
	IF(NPNT(IPAN).EQ.NPNW(IPAN))
     &EARW(IBAND,IPNT,IPAN)=EARR(IBAND,IPNT,IPAN)
	IF(NPNT(IPAN).EQ.NPNW(IPAN))
     &ETRW(IBAND,IPNT,IPAN)=ETRT(IBAND,IPNT,IPAN)
      ENDDO
      ENDDO
	IF(IENW.EQ.1)GOTO1000
C WAVE FUNCTIONS EXPANSION COEFFICIENTS APH AND APJ 
	DO 400 IORBS=1,NORBS        !!! over spinor components
	DO 300 IBNDS=1,NSPIN        !!! over spin subbands
	IF(NORBS.EQ.1)ISPIN=IBNDS
	IF(NORBS.EQ.2)ISPIN=IORBS
	DO 200 IBNDT=1,NBNDT(IPAN)  !!! over bands
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	DO 100 IKAP=1,NKAP(IPAN)    !!! over energies
C SET APH
	DO IATOM=1,NATOM            !!! over iatom
	ISORT=IS(IATOM)
      DO L=0,ILSB(ISORT)          !!! over l
      DO M=-L,L                   !!! over m
      LM=L*(L+1)+M+1
	IDIM=INDLMT(LM,IATOM,IKAP,ISPIN,IPAN)
	APHR(LM,IATOM,IKAP,ISPIN,IBAND)=(0.D0,0.D0)
	APSR(LM,IATOM,IKAP,ISPIN,IBAND)=(0.D0,0.D0)
      IF(.NOT.LTPAN(L,IATOM,IKAP,IPAN))CYCLE
	APHR(LM,IATOM,IKAP,ISPIN,IBAND)=OMAT(IDIM,IBAND)
	APSR(LM,IATOM,IKAP,ISPIN,IBAND)=OMAT(IDIM,IBAND)
      ENDDO                       !!! over m
      ENDDO                       !!! over l
      ENDDO                       !!! over iatom
C SET APJ
	DO IATOM=1,NATOM            !!! over iatom
	ISORT=IS(IATOM)
	DO L=0,ILST(ISORT)+1        !!! over l
	DO M=-L,L                   !!! over m
	LM=L*(L+1)+M+1
	CONV=(0.D0,0.D0)
	DO IATOM2=1,NATOM           !!! over iatom2
	ISORT2=IS(IATOM2)
	DO L2=0,ILSB(ISORT2)        !!! over l2
	IF(.NOT.LTPAN(L2,IATOM2,IKAP,IPAN))CYCLE
	DO M2=-L2,L2                !!! over m2
	L2M2=L2*(L2+1)+M2+1
	IDIM2=INDLMT(L2M2,IATOM2,IKAP,ISPIN,IPAN)
	CONV=CONV+SSCON(LM,IATOM,L2M2,IATOM2,IKAP)*
     &OMAT(IDIM2,IBAND)
      ENDDO                       !!! over m2
      ENDDO                       !!! over l2
      ENDDO                       !!! over iatom2
	APJR(LM,IATOM,IKAP,ISPIN,IBAND)=CONV
      ENDDO                       !!! over m
      ENDDO                       !!! over l
      ENDDO                       !!! over iatom
C SET APS (if screened LMTO, these represent bare coefficients)
	IF(LMTO.NE.1)THEN
      DO IATOM=1,NATOM            !!! over iatom
      ISORT=IS(IATOM)
      DO L=0,ILSB(ISORT)          !!! over l
      DO M=-L,L                   !!! over m
      LM=L*(L+1)+M+1
      IDIM=INDLMT(LM,IATOM,IKAP,ISPIN,IPAN)
      APSR(LM,IATOM,IKAP,ISPIN,IBAND)=(0.D0,0.D0)
      IF(.NOT.LTPAN(L,IATOM,IKAP,IPAN))CYCLE
      DO IATOM2=1,NATOM           !!! over iatom2
      ISORT2=IS(IATOM2)
      DO L2=0,ILSB(ISORT2)        !!! over l2
      IF(.NOT.LTPAN(L2,IATOM2,IKAP,IPAN))CYCLE
      DO M2=-L2,L2                !!! over m2
      L2M2=L2*(L2+1)+M2+1
      IDIM2=INDLMT(L2M2,IATOM2,IKAP,ISPIN,IPAN)
      IF(IDIM.EQ.IDIM2)ONE=1.D0
      IF(IDIM.NE.IDIM2)ONE=0.D0
	APSR(LM,IATOM,IKAP,ISPIN,IBAND)=APSR(LM,IATOM,IKAP,ISPIN,IBAND)+
     &(DCMPLX(ONE,0.D0)+ALPHA(L,ISORT,IKAP,IPAN)*
     &SSCON(LM,IATOM,L2M2,IATOM2,IKAP))*
     &APHR(L2M2,IATOM2,IKAP,ISPIN,IBAND)
      ENDDO                       !!! over m2
      ENDDO                       !!! over l2
      ENDDO                       !!! over iatom2
      ENDDO                       !!! over m
      ENDDO                       !!! over l
      ENDDO                       !!! over iatom
	ENDIF
  100 CONTINUE                    !!! over energies
C Coefficients for correlated states
      IF(IDMF.GT.2.AND.IPAN.EQ.1)THEN
	ICLM=0
	DO IKAP=1,NKAP(IPAN)        !!! over energies
	DO IATOM=1,NATOM            !!! over atoms
	ISORT=IS(IATOM)
	IF(MCRL(IATOM).EQ.0)CYCLE
	DO L=0,ILSB(ISORT)          !!! over l
	IF(.NOT.LTPAN(L,IATOM,IKAP,1))CYCLE
	IF(LCRL(L,IATOM).EQ.0)CYCLE
	DO M=-L,L
	LM=L*(L+1)+M+1
	ICLM=ICLM+1
	CR(ICLM,ISPIN,IBAND)=APHR(LM,IATOM,IKAP,ISPIN,IBAND)
	SR(ICLM,ISPIN,IBAND)=APSR(LM,IATOM,IKAP,ISPIN,IBAND)
      ENDDO                       !!! over m
      ENDDO                       !!! over l
      ENDDO                       !!! over iatom
      ENDDO                       !!! over energies
      ENDIF
  200 CONTINUE                    !!! over bands
  300 CONTINUE                    !!! over spin subbands
  400 CONTINUE                    !!! over spinor components
C File Storage
	IF(LIFT.GT.2.AND.IPAN.EQ.1)THEN !!! only for panel #1
	IREC=IPNT
      IF(NORBS.EQ.1)
     &WRITE(IUPSI,REC=IREC)
     &(((((APHR(LM,IATOM,IKAP,IBNDS,IBNDS+NSPIN*(IBNDT-1)),
     &LM=1,(ILSB(IS(IATOM))+1)**2),IATOM=1,NATOM),IKAP=1,NKAP(IPAN)),
     &IBNDS=1,NSPIN),IBNDT=NBNDE(IPAN),NBNDF(IPAN)),
     &(((((APSR(LM,IATOM,IKAP,IBNDS,IBNDS+NSPIN*(IBNDT-1)),
     &LM=1,(ILSB(IS(IATOM))+1)**2),IATOM=1,NATOM),IKAP=1,NKAP(IPAN)),
     &IBNDS=1,NSPIN),IBNDT=NBNDE(IPAN),NBNDF(IPAN)),
     &(((((APJR(LM,IATOM,IKAP,IBNDS,IBNDS+NSPIN*(IBNDT-1)),
     &LM=1,(ILST(IS(IATOM))+2)**2),IATOM=1,NATOM),IKAP=1,NKAP(IPAN)),
     &IBNDS=1,NSPIN),IBNDT=NBNDE(IPAN),NBNDF(IPAN))
      IF(NORBS.EQ.2)
     &WRITE(IUPSI,REC=IREC)
     &((((((APHR(LM,IATOM,IKAP,IORBS,IBNDS+NSPIN*(IBNDT-1)),
     &LM=1,(ILSB(IS(IATOM))+1)**2),IATOM=1,NATOM),IKAP=1,NKAP(IPAN)),
     &IORBS=1,NORBS),IBNDS=1,NSPIN),IBNDT=NBNDE(IPAN),NBNDF(IPAN)),
     &((((((APSR(LM,IATOM,IKAP,IORBS,IBNDS+NSPIN*(IBNDT-1)),
     &LM=1,(ILSB(IS(IATOM))+1)**2),IATOM=1,NATOM),IKAP=1,NKAP(IPAN)),
     &IORBS=1,NORBS),IBNDS=1,NSPIN),IBNDT=NBNDE(IPAN),NBNDF(IPAN)),
     &((((((APJR(LM,IATOM,IKAP,IORBS,IBNDS+NSPIN*(IBNDT-1)),
     &LM=1,(ILST(IS(IATOM))+2)**2),IATOM=1,NATOM),IKAP=1,NKAP(IPAN)),
     &IORBS=1,NORBS),IBNDS=1,NSPIN),IBNDT=NBNDE(IPAN),NBNDF(IPAN))
	ENDIF
      IF(ICPSK.GT.0.OR.ICCHI.GT.0.OR.ICOPT.GT.0)THEN ! store all bands
      NSHIFT=0
      DO JPAN=1,IPAN-1
      NSHIFT=NSHIFT+NPNT(JPAN)
	ENDDO
	IREC=IPNT+NSHIFT
      IF(NORBS.EQ.1)
     &WRITE(IUPSK,REC=IREC)
     &(((((APHR(LM,IATOM,IKAP,IBNDS,IBNDS+NSPIN*(IBNDT-1)),
     &LM=1,(ILSB(IS(IATOM))+1)**2),IATOM=1,NATOM),IKAP=1,NKAP(IPAN)),
     &IBNDS=1,NSPIN),IBNDT=1,NBNDT(IPAN)),
     &(((((APSR(LM,IATOM,IKAP,IBNDS,IBNDS+NSPIN*(IBNDT-1)),
     &LM=1,(ILSB(IS(IATOM))+1)**2),IATOM=1,NATOM),IKAP=1,NKAP(IPAN)),
     &IBNDS=1,NSPIN),IBNDT=1,NBNDT(IPAN)),
     &(((((APJR(LM,IATOM,IKAP,IBNDS,IBNDS+NSPIN*(IBNDT-1)),
     &LM=1,(ILST(IS(IATOM))+2)**2),IATOM=1,NATOM),IKAP=1,NKAP(IPAN)),
     &IBNDS=1,NSPIN),IBNDT=1,NBNDT(IPAN))
      IF(NORBS.EQ.2)
     &WRITE(IUPSK,REC=IREC)
     &((((((APHR(LM,IATOM,IKAP,IORBS,IBNDS+NSPIN*(IBNDT-1)),
     &LM=1,(ILSB(IS(IATOM))+1)**2),IATOM=1,NATOM),IKAP=1,NKAP(IPAN)),
     &IORBS=1,NORBS),IBNDS=1,NSPIN),IBNDT=1,NBNDT(IPAN)),
     &((((((APSR(LM,IATOM,IKAP,IORBS,IBNDS+NSPIN*(IBNDT-1)),
     &LM=1,(ILSB(IS(IATOM))+1)**2),IATOM=1,NATOM),IKAP=1,NKAP(IPAN)),
     &IORBS=1,NORBS),IBNDS=1,NSPIN),IBNDT=1,NBNDT(IPAN)),
     &((((((APJR(LM,IATOM,IKAP,IORBS,IBNDS+NSPIN*(IBNDT-1)),
     &LM=1,(ILST(IS(IATOM))+2)**2),IATOM=1,NATOM),IKAP=1,NKAP(IPAN)),
     &IORBS=1,NORBS),IBNDS=1,NSPIN),IBNDT=1,NBNDT(IPAN))
	ENDIF
	IF(IDMF.GT.2.AND.IPAN.EQ.1)THEN
	IREC=IPNT
	IF(NORBS.EQ.1)
     &WRITE(IUWFK,REC=IREC)
     &((( CR(ICLM,IBNDS,IBNDS+NSPIN*(IBNDT-1)),ICLM=1,NCLM),
     &    IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)),
     &((( SR(ICLM,IBNDS,IBNDS+NSPIN*(IBNDT-1)),ICLM=1,NCLM),
     &    IBNDS=1,NSPIN),IBNDT=1,NBNDT(1))
	IF(NORBS.EQ.2)
     &WRITE(IUWFK,REC=IREC)
     &((((CR(ICLM,IORBS,IBNDS+NSPIN*(IBNDT-1)),ICLM=1,NCLM),
     &    IORBS=1,NORBS),IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)),
     &((((SR(ICLM,IORBS,IBNDS+NSPIN*(IBNDT-1)),ICLM=1,NCLM),
     &    IORBS=1,NORBS),IBNDS=1,NSPIN),IBNDT=1,NBNDT(1))
	ENDIF
C MEMORY DEALLOCATIONS
 1000 DEALLOCATE(E,CR,SR)
	END
