	SUBROUTINE BND_LMTPAR(IPAN)
*********************************************************
*  Subroutine prepares arrays depended on potential     *
*  parameters for LMTBND program                        *
*********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,IS,ILST,ILSB,LRTV    !!! from readini
      USE COM_LATPAR  ,ONLY: PAR,OMEGAC                             !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP,EK                      !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN,IATS,ISTS                  !!! from readini
      USE COM_SPHERE  ,ONLY: SMT,SASA,SWZ                           !!! from readini
      USE COM_INPPAR  ,ONLY: ENY,DNY                                !!! from readini
      USE COM_POTPAR  ,ONLY: FF,FFP,FPF,FPFP                        !!! from potpar
      USE COM_LMTPAR  ,ONLY: GAM,AAH,BBH,AAJ,BBJ                    !!! from potpar
      USE COM_ASAPAR  ,ONLY: HS,BS,DH,DJ                            !!! from potpar
      USE COM_MTSPAR  ,ONLY: OMTHH,OMTHJ,OMTJH,OMTJJ
     &                      ,HMTHH,HMTHJ,HMTJH,HMTJJ                !!! from lmtpar
      USE COM_INDORB  ,ONLY: INDLMT                                 !!! from lmtpar
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT                            !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16 FHHFH,FJHFH,FHHFJ,FJHFJ,FHFH,FHFJ,FJFH,FJFJ
	LOGICAL LOG,FIRST
	SAVE FIRST
	DATA PI/3.141592653589793D0/,FIRST/.TRUE./
      CALL ABORTNOW()
C MEMORY ALLOCATIONS
	IF(FIRST)THEN
	FIRST=.FALSE.
	ALLOCATE(OMTHH(NKAPMEM,NKAPMEM,0:LMAXBMEM,NSORTMEM,NSPINMEM))
	ALLOCATE(OMTJH(NKAPMEM,NKAPMEM,0:LMAXBMEM,NSORTMEM,NSPINMEM))
	ALLOCATE(OMTHJ(NKAPMEM,NKAPMEM,0:LMAXBMEM,NSORTMEM,NSPINMEM))
	ALLOCATE(OMTJJ(NKAPMEM,NKAPMEM,0:LMAXTMEM,NSORTMEM,NSPINMEM))
	ALLOCATE(HMTHH(NKAPMEM,NKAPMEM,0:LMAXBMEM,NSORTMEM,NSPINMEM))
	ALLOCATE(HMTJH(NKAPMEM,NKAPMEM,0:LMAXBMEM,NSORTMEM,NSPINMEM))
	ALLOCATE(HMTHJ(NKAPMEM,NKAPMEM,0:LMAXBMEM,NSORTMEM,NSPINMEM))
	ALLOCATE(HMTJJ(NKAPMEM,NKAPMEM,0:LMAXTMEM,NSORTMEM,NSPINMEM))
	ENDIF
C COMPUTE POTENTIAL PARAMETERS FOR THE OVERLAP MATRIX AND HAMILTONIAN ::
	DO 2000 ISPIN=1,NSPIN                             !!! over ispin
	DO 1000 ISORT=1,NSORT                             !!! over isort
	DO L=0,ILST(ISORT)                                !!! over l
	DO IKAP1=1,NKAP(IPAN)                             !!! over ikap1
	DO IKAP=1,NKAP(IPAN)                              !!! over ikap
C SET POTENTIAL PARAMETERS TO ZERO
	IF(L.LE.ILSB(ISORT))THEN
	OMTHH(IKAP1,IKAP,L,ISORT,ISPIN)=(0.D0,0.D0)
	OMTJH(IKAP1,IKAP,L,ISORT,ISPIN)=(0.D0,0.D0)
	OMTHJ(IKAP1,IKAP,L,ISORT,ISPIN)=(0.D0,0.D0)
	HMTHH(IKAP1,IKAP,L,ISORT,ISPIN)=(0.D0,0.D0)
	HMTJH(IKAP1,IKAP,L,ISORT,ISPIN)=(0.D0,0.D0)
	HMTHJ(IKAP1,IKAP,L,ISORT,ISPIN)=(0.D0,0.D0)
	ENDIF
	OMTJJ(IKAP1,IKAP,L,ISORT,ISPIN)=(0.D0,0.D0)
	HMTJJ(IKAP1,IKAP,L,ISORT,ISPIN)=(0.D0,0.D0)
C ONE- AND TWO-CENTER POTENTIAL PARAMETERS
	IF(LSPAN(L,ISORT,IKAP1,IPAN).AND.LSPAN(L,ISORT,IKAP,IPAN))THEN
	FHFH=CONJG(AAH(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  FF(IKAP1,IKAP,L,ISORT,ISPIN)
     & *AAH(L,ISORT,IKAP,IPAN,ISPIN)+
     &  CONJG(BBH(L,ISORT,IKAP1,IPAN,ISPIN))
     & *FPFP(IKAP1,IKAP,L,ISORT,ISPIN)*BBH(L,ISORT,IKAP,IPAN,ISPIN)   
     & +CONJG(AAH(L,ISORT,IKAP1,IPAN,ISPIN))
     & *FFP(IKAP1,IKAP,L,ISORT,ISPIN)
     & *BBH(L,ISORT,IKAP,IPAN,ISPIN)+
     &  CONJG(BBH(L,ISORT,IKAP1,IPAN,ISPIN))
     & *FPF(IKAP1,IKAP,L,ISORT,ISPIN)*AAH(L,ISORT,IKAP,IPAN,ISPIN)   
	OMTHH(IKAP1,IKAP,L,ISORT,ISPIN)=FHFH
	FHHFH=CONJG(AAH(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  FF(IKAP1,IKAP,L,ISORT,ISPIN)
     & *BBH(L,ISORT,IKAP,IPAN,ISPIN)+
     *  CONJG(BBH(L,ISORT,IKAP1,IPAN,ISPIN))
     & *FPF(IKAP1,IKAP,L,ISORT,ISPIN)*BBH(L,ISORT,IKAP,IPAN,ISPIN) 
	HMTHH(IKAP1,IKAP,L,ISORT,ISPIN)=FHHFH+
     &  ENY(L,ISORT,IKAP,IPAN,ISPIN)*OMTHH(IKAP1,IKAP,L,ISORT,ISPIN)
	ENDIF
	IF(LSPAN(L,ISORT,IKAP,IPAN))THEN
	FJFH=CONJG(AAJ(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  FF(IKAP1,IKAP,L,ISORT,ISPIN)
     & *AAH(L,ISORT,IKAP,IPAN,ISPIN)+
     &  CONJG(BBJ(L,ISORT,IKAP1,IPAN,ISPIN))
     & *FPFP(IKAP1,IKAP,L,ISORT,ISPIN)*BBH(L,ISORT,IKAP,IPAN,ISPIN)    
     & +CONJG(AAJ(L,ISORT,IKAP1,IPAN,ISPIN))
     & *FFP(IKAP1,IKAP,L,ISORT,ISPIN)
     & *BBH(L,ISORT,IKAP,IPAN,ISPIN)+
     &  CONJG(BBJ(L,ISORT,IKAP1,IPAN,ISPIN))
     & *FPF(IKAP1,IKAP,L,ISORT,ISPIN)*AAH(L,ISORT,IKAP,IPAN,ISPIN)    
	OMTJH(IKAP1,IKAP,L,ISORT,ISPIN)=FJFH*GAM(L,ISORT)
	FJHFH=CONJG(AAJ(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  FF(IKAP1,IKAP,L,ISORT,ISPIN)
     & *BBH(L,ISORT,IKAP,IPAN,ISPIN)+
     &  CONJG(BBJ(L,ISORT,IKAP1,IPAN,ISPIN))
     & *FPF(IKAP1,IKAP,L,ISORT,ISPIN)*BBH(L,ISORT,IKAP,IPAN,ISPIN) 
	HMTJH(IKAP1,IKAP,L,ISORT,ISPIN)=FJHFH*GAM(L,ISORT)+
     &  ENY(L,ISORT,IKAP,IPAN,ISPIN)*OMTJH(IKAP1,IKAP,L,ISORT,ISPIN)
	ENDIF
	IF(LSPAN(L,ISORT,IKAP1,IPAN))THEN
	FHFJ=CONJG(AAH(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  FF(IKAP1,IKAP,L,ISORT,ISPIN)
     & *AAJ(L,ISORT,IKAP,IPAN,ISPIN)+
     &  CONJG(BBH(L,ISORT,IKAP1,IPAN,ISPIN))
     & *FPFP(IKAP1,IKAP,L,ISORT,ISPIN)*BBJ(L,ISORT,IKAP,IPAN,ISPIN)    
     & +CONJG(AAH(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  FFP(IKAP1,IKAP,L,ISORT,ISPIN)
     & *BBJ(L,ISORT,IKAP,IPAN,ISPIN)+
     &  CONJG(BBH(L,ISORT,IKAP1,IPAN,ISPIN))
     & *FPF(IKAP1,IKAP,L,ISORT,ISPIN)*AAJ(L,ISORT,IKAP,IPAN,ISPIN)
	OMTHJ(IKAP1,IKAP,L,ISORT,ISPIN)=FHFJ*GAM(L,ISORT)
	FHHFJ=CONJG(AAH(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  FF(IKAP1,IKAP,L,ISORT,ISPIN)
     & *BBJ(L,ISORT,IKAP,IPAN,ISPIN)+
     &  CONJG(BBH(L,ISORT,IKAP1,IPAN,ISPIN))
     & *FPF(IKAP1,IKAP,L,ISORT,ISPIN)*BBJ(L,ISORT,IKAP,IPAN,ISPIN) 
	HMTHJ(IKAP1,IKAP,L,ISORT,ISPIN)=FHHFJ*GAM(L,ISORT)+
     &  ENY(L,ISORT,IKAP,IPAN,ISPIN)*OMTHJ(IKAP1,IKAP,L,ISORT,ISPIN)
	ENDIF
C THREE-CENTER POTENTIAL PARAMETERS
	FJFJ=CONJG(AAJ(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  FF(IKAP1,IKAP,L,ISORT,ISPIN)
     & *AAJ(L,ISORT,IKAP,IPAN,ISPIN)+
     &  CONJG(BBJ(L,ISORT,IKAP1,IPAN,ISPIN))
     & *FPFP(IKAP1,IKAP,L,ISORT,ISPIN)*BBJ(L,ISORT,IKAP,IPAN,ISPIN)
     & +CONJG(AAJ(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  FFP(IKAP1,IKAP,L,ISORT,ISPIN)
     & *BBJ(L,ISORT,IKAP,IPAN,ISPIN)+
     &  CONJG(BBJ(L,ISORT,IKAP1,IPAN,ISPIN))
     & *FPF(IKAP1,IKAP,L,ISORT,ISPIN)*AAJ(L,ISORT,IKAP,IPAN,ISPIN)    
	FJHFJ=CONJG(AAJ(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  FF(IKAP1,IKAP,L,ISORT,ISPIN)
     & *BBJ(L,ISORT,IKAP,IPAN,ISPIN)+
     &  CONJG(BBJ(L,ISORT,IKAP1,IPAN,ISPIN))
     & *FPF(IKAP1,IKAP,L,ISORT,ISPIN)*BBJ(L,ISORT,IKAP,IPAN,ISPIN)
	OMTJJ(IKAP1,IKAP,L,ISORT,ISPIN)=FJFJ*GAM(L,ISORT)*GAM(L,ISORT)
	HMTJJ(IKAP1,IKAP,L,ISORT,ISPIN)=FJHFJ*GAM(L,ISORT)*GAM(L,ISORT)+
     &  ENY(L,ISORT,IKAP,IPAN,ISPIN)*OMTJJ(IKAP1,IKAP,L,ISORT,ISPIN)
      ENDDO                                                    !!! over ikap
      ENDDO                                                    !!! over ikap1
      ENDDO                                                    !!! over l
1000  CONTINUE                                                 !!! over isort
2000	CONTINUE                                                 !!! over ispin
	END
