	SUBROUTINE BND_ORBPAR(IPAN)
***************************************************************
* Calculates potential parameters due to spin-orbit coupling. *
***************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
	USE COM_LMTMEM
      USE COM_CONTROL ,ONLY: LMTO,IASA,NOVR,NPFR                    !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS             !!! from readini
     &                      ,ILST,ILSB,ILSV,LRTV,LSCO,SORN                    
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP,EK                      !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN,IATS,ISTS                  !!! from readini
      USE COM_SPHERE  ,ONLY: ZNUC,SMT                               !!! from readini
      USE COM_SYMMLM  ,ONLY: SYM,LMSYM                              !!! from symlmm
      USE COM_POTDAT  ,ONLY: POT,POTSPH,POTRWF                      !!! from potfull
      USE COM_INPPAR  ,ONLY: ENY,DNY                                !!! from readini
      USE COM_HAMPAR  ,ONLY: HPARHH,HPARJH,HPARHJ,HPARJJ            !!! from potpar
      USE COM_LMTPAR  ,ONLY: GAM,AAH,AAJ,BBH,BBJ                    !!! from potpar
      USE COM_ORBPAR  ,ONLY: SPARHH,SPARJH,SPARHJ,SPARJJ            !!! from orbpar
      USE COM_RADMESH ,ONLY: NRAD,H,R,DR,WEIGHT,RL                  !!! from radmesh
      USE COM_GAUNT   ,ONLY: C                                      !!! from gdata
      USE COM_LMTOUT  ,ONLY: SCRFILE                                !!! from readini
      USE COM_CHANNELS,ONLY: IUNMT                                  !!! from channels
      USE COM_MASHDEP ,ONLY: NVAL,LENCMP                            !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8, ALLOCATABLE :: AFI(:,:)
	REAL*8, ALLOCATABLE :: AFID(:,:)
	REAL*8, ALLOCATABLE :: AFIP(:,:)
	REAL*8, ALLOCATABLE :: AFIDP(:,:)
	REAL*8, ALLOCATABLE :: AFIDDS(:)
	REAL*8, ALLOCATABLE :: AFIDDPS(:)
	REAL*8, ALLOCATABLE :: VBAR(:)
	REAL*8, ALLOCATABLE :: VDER(:)
	REAL*8, ALLOCATABLE :: ACOR(:)
	REAL*8, ALLOCATABLE :: SLM(:,:,:)
	COMPLEX*16, ALLOCATABLE :: WORK1(:)
	COMPLEX*16, ALLOCATABLE :: WORK2(:)
	COMPLEX*16, ALLOCATABLE :: FIH(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: FIJ(:,:,:,:)
	LOGICAL LOG1,LOG,FIRST
	SAVE FIRST
	DATA PI/3.141592653589793D0/,C2/0.000013312838D0/,FIRST/.TRUE./
      CALL ABORTNOW()
C RETURN KEYS
	IF(NORBS.EQ.1)RETURN
C MEMORY ALLOCATIONS FOR MAIN CONTROL ARRAYS
	IF(FIRST)THEN
	FIRST=.FALSE.
	ALLOCATE(SPARHH(NKAPMEM,NKAPMEM,0:LMAXBMEM,NSORTMEM,
     &NORBSMEM,NORBSMEM,NPANMEM))
	ALLOCATE(SPARJH(NKAPMEM,NKAPMEM,0:LMAXBMEM,NSORTMEM,
     &NORBSMEM,NORBSMEM,NPANMEM))
	ALLOCATE(SPARHJ(NKAPMEM,NKAPMEM,0:LMAXBMEM,NSORTMEM,
     &NORBSMEM,NORBSMEM,NPANMEM))
	ALLOCATE(SPARJJ(NKAPMEM,NKAPMEM,0:LMAXTMEM,NSORTMEM,
     &NORBSMEM,NORBSMEM,NPANMEM))
	ENDIF
	ALLOCATE(WORK1(0:NRADMEM))
	ALLOCATE(WORK2(0:NRADMEM))
	ALLOCATE(FIH(0:NRADMEM,0:LMAXTMEM,NKAPMEM,NSPINMEM))
	ALLOCATE(FIJ(0:NRADMEM,0:LMAXTMEM,NKAPMEM,NSPINMEM))
	ALLOCATE(AFI(0:NRADMEM,0:LMAXTMEM))
	ALLOCATE(AFID(0:NRADMEM,0:LMAXTMEM))
	ALLOCATE(AFIP(0:NRADMEM,0:LMAXTMEM))
	ALLOCATE(AFIDP(0:NRADMEM,0:LMAXTMEM))
	ALLOCATE(AFIDDS(0:LMAXTMEM))
	ALLOCATE(AFIDDPS(0:LMAXTMEM))
	ALLOCATE(VBAR(0:NRADMEM))
	ALLOCATE(VDER(0:NRADMEM))
	ALLOCATE(ACOR(0:NRADMEM))
	ALLOCATE(SLM(LIMTMEM,2,2))
C SET <Ylm|s*l|Ylm>/2 MATRIX ELEMENT
	DO L=0,LMAXTMEM
	DO M=-L,L
	LM=L*(L+1)+M+1
	SLM(LM,1,1)=0.5D0*DBLE(+M)
	SLM(LM,1,2)=0.5D0*SQRT(DBLE((L+M)*(L-M+1)))
	SLM(LM,2,1)=0.5D0*SQRT(DBLE((L-M)*(L+M+1)))
	SLM(LM,2,2)=0.5D0*DBLE(-M)
	ENDDO
	ENDDO
	DO 5000 IATOM=1,NATOM          !!! over atoms
	ISORT=IS(IATOM)
C  Find FIny and FIny-dot radial functions:
	DO ISPIN=1,NSPIN               !!! over spins
	DO IKAP=1,NKAP(IPAN)           !!! over energies
      CALL LIB_RADSCH_PHIS(ENY(0,ISORT,IKAP,IPAN,ISPIN),AFI,AFIP,
     &AFID,AFIDP,AFIDDS,AFIDDPS,SMT(ISORT),POTRWF(0,ISORT,ISPIN),
     &ILST(ISORT),NRAD(ISORT),H(ISORT),R(0,ISORT),DR(0,ISORT),
     &LRTV(ISORT))
C  Transfere to FIH and FIJ convinient functions:
	DO L=0,ILST(ISORT)
	DO IRAD=0,NRAD(ISORT)
	FIH(IRAD,L,IKAP,ISPIN)=AAH(L,ISORT,IKAP,IPAN,ISPIN)*
     &AFI(IRAD,L)+BBH(L,ISORT,IKAP,IPAN,ISPIN)*AFIP(IRAD,L)
	FIJ(IRAD,L,IKAP,ISPIN)=AAJ(L,ISORT,IKAP,IPAN,ISPIN)*
     &AFI(IRAD,L)+BBJ(L,ISORT,IKAP,IPAN,ISPIN)*AFIP(IRAD,L)
      ENDDO   
      ENDDO   
      ENDDO                          !!! over energies
	ENDDO                          !!! over spins
C  Set average potential and its radial derivative
	IF(LSCO(ISORT).NE.0.AND.ABS(ZNUC(ISORT)).GE.1.D-05)THEN
	DO IRAD=1,NRAD(ISORT)
	VBAR(IRAD)=-R(IRAD,ISORT)/SQRT(4.D0*PI)*
     &(POT(IRAD,1,IATOM,1,1)+POT(IRAD,1,IATOM,NSPIN,1))/2.D0
      ENDDO   
	VBAR(0)=2.D0*ZNUC(ISORT)
	CALL LIB_DERIV1(VBAR,VDER,NRAD(ISORT),H(ISORT),R(0,ISORT),
     &DR(0,ISORT),SMT(ISORT))
	ELSE
	DO IRAD=0,NRAD(ISORT)
	VBAR(IRAD)=0.D0
	VDER(IRAD)=0.D0
      ENDDO   
	ENDIF
	DO 4000 IORBS=1,NORBS          !!! over spins
	DO 3000 IUPDN=1,NSPIN          !!! over spins
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
	DO 2000 IKAP1=1,NKAP(IPAN)     !!! over ikap1
	DO 1000 IKAP=1,NKAP(IPAN)      !!! over ikap
C READ POTENTIAL PARAMETERS
      IREC=IKAP1+NKAP(IPAN)*(IKAP-1)+NKAP(IPAN)**2*(IATOM-1)+
     &NKAP(IPAN)**2*NATOM*(IUPDN-1)+
     &NKAP(IPAN)**2*NATOM*NSPIN*(IORBS-1)
      READ(IUNMT,REC=IREC)((HPARHH(L1M1,LM,IATOM),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((HPARJH(L1M1,LM,IATOM),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((HPARHJ(L1M1,LM,IATOM),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &((HPARJJ(L1M1,LM,IATOM),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2)
C NO SO-COUPLING WITH S-ELECTRONS
	SPARHH(IKAP1,IKAP,0,ISORT,ISPIN1,ISPIN,IPAN)=(0.D0,0.D0)
	SPARJH(IKAP1,IKAP,0,ISORT,ISPIN1,ISPIN,IPAN)=(0.D0,0.D0)
	SPARHJ(IKAP1,IKAP,0,ISORT,ISPIN1,ISPIN,IPAN)=(0.D0,0.D0)
	SPARJJ(IKAP1,IKAP,0,ISORT,ISPIN1,ISPIN,IPAN)=(0.D0,0.D0)
C CALCULATE RADIAL MATRIX ELEMENTS <F|1/c2*2/r*dV/dr|F> OF SO-COUPLING 
	DO L=1,ILST(ISORT)             !!! over l
	LOG1=.FALSE.
	IF(LTPAN(L,IATOM,IKAP1,IPAN))LOG1=.TRUE.
	LOG =.FALSE.
	IF(LTPAN(L,IATOM,IKAP ,IPAN))LOG =.TRUE.
	IF(L.LE.ILSB(ISORT))THEN
	SPARHH(IKAP1,IKAP,L,ISORT,ISPIN1,ISPIN,IPAN)=(0.D0,0.D0)
	SPARJH(IKAP1,IKAP,L,ISORT,ISPIN1,ISPIN,IPAN)=(0.D0,0.D0)
	SPARHJ(IKAP1,IKAP,L,ISORT,ISPIN1,ISPIN,IPAN)=(0.D0,0.D0)
	ENDIF
	SPARJJ(IKAP1,IKAP,L,ISORT,ISPIN1,ISPIN,IPAN)=(0.D0,0.D0)
C Relativistic correction
	EN=(ENY(L,ISORT,IKAP1,IPAN,1)+ENY(L,ISORT,IKAP,IPAN,NSPIN))*0.5D0
	DO IRAD=1,NRAD(ISORT)
C	ACOR(IRAD)=1.D0
	ACOR(IRAD)=1.D0/(1.D0+C2*(EN+VBAR(IRAD)/R(IRAD,ISORT)))**2*
     &DBLE(LSCO(ISORT))
	ENDDO
	ACOR(0)=ACOR(1)
C 1) <H|dV|H>
	IF(LOG1.AND.LOG)THEN
	WORK1(0)=(0.D0,0.D0)
	DO IRAD=1,NRAD(ISORT)          !!! over radial mesh
	WORK1(IRAD)=
     &CONJG(FIH(IRAD,L,IKAP1,ISPIN1))*FIH(IRAD,L,IKAP,ISPIN)*
     &2.D0*(VBAR(IRAD)/R(IRAD,ISORT)-VDER(IRAD))*C2*ACOR(IRAD)*
     &DR(IRAD,ISORT)
      ENDDO                          !!! over radial mesh
	CALL LIB_CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	SPARHH(IKAP1,IKAP,L,ISORT,ISPIN1,ISPIN,IPAN)=
     &WORK2(NRAD(ISORT))
	ENDIF
C 2) <J|dV|H> diagonal
	IF(LOG)THEN
	WORK1(0)=(0.D0,0.D0)
	DO IRAD=1,NRAD(ISORT)          !!! over radial mesh
	WORK1(IRAD)=
     &CONJG(FIJ(IRAD,L,IKAP1,ISPIN1))*FIH(IRAD,L,IKAP,ISPIN)*
     &2.D0*(VBAR(IRAD)/R(IRAD,ISORT)-VDER(IRAD))*C2*ACOR(IRAD)*
     &DR(IRAD,ISORT)
      ENDDO                          !!! over radial mesh
	CALL LIB_CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	SPARJH(IKAP1,IKAP,L,ISORT,ISPIN1,ISPIN,IPAN)=
     &WORK2(NRAD(ISORT))*GAM(L,ISORT)
	ENDIF
C 3) <H|dV|J> diagonal
	IF(LOG1)THEN
	WORK1(0)=(0.D0,0.D0)
	DO IRAD=1,NRAD(ISORT)          !!! over radial mesh
	WORK1(IRAD)=
     &CONJG(FIH(IRAD,L,IKAP1,ISPIN1))*FIJ(IRAD,L,IKAP,ISPIN)*
     &2.D0*(VBAR(IRAD)/R(IRAD,ISORT)-VDER(IRAD))*C2*ACOR(IRAD)*
     &DR(IRAD,ISORT)
      ENDDO                          !!! over radial mesh
	CALL LIB_CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	SPARHJ(IKAP1,IKAP,L,ISORT,ISPIN1,ISPIN,IPAN)=
     &WORK2(NRAD(ISORT))*GAM(L,ISORT)
	ENDIF
C 4) <J|dV|J> diagonal
	WORK1(0)=(0.D0,0.D0)
	DO IRAD=1,NRAD(ISORT)          !!! over radial mesh
	WORK1(IRAD)=
     &CONJG(FIJ(IRAD,L,IKAP1,ISPIN1))*FIJ(IRAD,L,IKAP,ISPIN)*
     &2.D0*(VBAR(IRAD)/R(IRAD,ISORT)-VDER(IRAD))*C2*ACOR(IRAD)*
     &DR(IRAD,ISORT)
      ENDDO                          !!! over radial mesh
	CALL LIB_CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	SPARJJ(IKAP1,IKAP,L,ISORT,ISPIN1,ISPIN,IPAN)=
     &WORK2(NRAD(ISORT))*GAM(L,ISORT)**2
      ENDDO                          !!! over l
C ADD SPIN ORBIT TO THE HAMILTONIAN POTENTIAL PARAMETERS
	ISIGN=ISPIN1-ISPIN
	DO L=0,ILST(ISORT)             !!! over l
	LOG1=.FALSE.
	LOG =.FALSE.
	IF(LTPAN(L,IATOM,IKAP1,IPAN))LOG1=.TRUE.
	IF(LTPAN(L,IATOM,IKAP ,IPAN))LOG =.TRUE.
	DO M1=-L,L                     !!! over m1
	LM1=L*(L+1)+M1+1
	DO M=-L,L                      !!! over m
	LM=L*(L+1)+M+1
	IF(M1.NE.M+ISIGN)CYCLE
	IF(LOG1.AND.LOG)
     &HPARHH(LM1,LM,IATOM)=HPARHH(LM1,LM,IATOM)+
     &SORN*SPARHH(IKAP1,IKAP,L,ISORT,ISPIN1,ISPIN,IPAN)*
     &SLM(LM,ISPIN1,ISPIN)
 	IF(LOG)
     &HPARJH(LM1,LM,IATOM)=HPARJH(LM1,LM,IATOM)+
     &SORN*SPARJH(IKAP1,IKAP,L,ISORT,ISPIN1,ISPIN,IPAN)*
     &SLM(LM,ISPIN1,ISPIN)
 	IF(LOG1)
     &HPARHJ(LM1,LM,IATOM)=HPARHJ(LM1,LM,IATOM)+
     &SORN*SPARHJ(IKAP1,IKAP,L,ISORT,ISPIN1,ISPIN,IPAN)*
     &SLM(LM,ISPIN1,ISPIN)
 	HPARJJ(LM1,LM,IATOM)=HPARJJ(LM1,LM,IATOM)+
     &SORN*SPARJJ(IKAP1,IKAP,L,ISORT,ISPIN1,ISPIN,IPAN)*
     &SLM(LM,ISPIN1,ISPIN)
      ENDDO                          !!! over m
      ENDDO                          !!! over m1
      ENDDO                          !!! over l
C STORE POTENTIAL PARAMETERS
	IREC=IKAP1+NKAP(IPAN)*(IKAP-1)+NKAP(IPAN)**2*(IATOM-1)+
     &NKAP(IPAN)**2*NATOM*(IUPDN-1)+
     &NKAP(IPAN)**2*NATOM*NSPIN*(IORBS-1)
	WRITE(IUNMT,REC=IREC)((HPARHH(L1M1,LM,IATOM),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((HPARJH(L1M1,LM,IATOM),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((HPARHJ(L1M1,LM,IATOM),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &((HPARJJ(L1M1,LM,IATOM),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2)
1000	CONTINUE                       !!! over ikap
2000	CONTINUE                       !!! over ikap1
3000	CONTINUE                       !!! over spins
4000	CONTINUE                       !!! over spins
5000	CONTINUE                       !!! over atoms
C MEMORY DEALLOCATIONS
	DEALLOCATE(WORK1,WORK2,FIH,FIJ,AFI,AFID,AFIP,AFIDP)
	DEALLOCATE(AFIDDS,AFIDDPS,VBAR,VDER,ACOR,SLM)
	END
