	SUBROUTINE BND_OVRPAR(IPAN)
***************************************************************
*  Calculation of potential parameters in the overlap matrix. *
***************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
	USE COM_LMTMEM
      USE COM_CONTROL ,ONLY: LMTO,IASA,LPRO,NOVR,NPFR                        !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS,ILST,ILSB,LRTV       !!! from readini
      USE COM_LATPAR  ,ONLY: PAR,OMEGAC                                      !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP,EK                               !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN,IATS,ISTS                           !!! from readini
      USE COM_SPHERE  ,ONLY: SMT,SASA,SWZ                                    !!! from readini
      USE COM_INPPAR  ,ONLY: ENY,DNY                                         !!! from readini
      USE COM_SCRINP  ,ONLY: ALPHA,ALPDOT                                    !!! from alpcon
      USE COM_POTDAT  ,ONLY: POT,POTSPH,POTRWF                               !!! from potfull
      USE COM_RADMESH ,ONLY: NRAD,H,R,DR,WEIGHT,RL                           !!! from radmesh
      USE COM_LMTPAR  ,ONLY: GAM,AAH,BBH,AAJ,BBJ                             !!! from potpar
      USE COM_MTSPAR  ,ONLY: OMTHH,OMTHJ,OMTJH,OMTJJ                         !!! from lmtpar
      USE COM_OVRPAR  ,ONLY: OPARHH,OPARJH,OPARHJ,OPARJJ                     !!! from ovrpar
      USE COM_SUMPAR  ,ONLY: OHH,OJH,OHJ,OJJ,PHH,PJH,PHJ,PJJ                 !!! from ovrpar
      USE COM_INTPAR  ,ONLY: WHH,WJH,WHJ,WJJ                                 !!! from ovrpar
      USE COM_MASHDEP ,ONLY: NVAL,LENREL,LENCMP                              !!! from setup
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT                                     !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8, ALLOCATABLE :: AFI(:,:)
	REAL*8, ALLOCATABLE :: AFID(:,:)
	REAL*8, ALLOCATABLE :: AFIP(:,:)
	REAL*8, ALLOCATABLE :: AFIDP(:,:)
	REAL*8, ALLOCATABLE :: AFIDDS(:)
	REAL*8, ALLOCATABLE :: AFIDDPS(:)
	COMPLEX*16, ALLOCATABLE :: WORK1(:)
	COMPLEX*16, ALLOCATABLE :: WORK2(:)
	COMPLEX*16, ALLOCATABLE :: FIH(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: FIJ(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: ALP(:,:)
	COMPLEX*16, ALLOCATABLE :: ALPD(:,:)
	COMPLEX*16, ALLOCATABLE :: WHHS(:,:,:)
	COMPLEX*16, ALLOCATABLE :: WJHS(:,:,:)
	COMPLEX*16, ALLOCATABLE :: WHJS(:,:,:)
	COMPLEX*16, ALLOCATABLE :: WJJS(:,:,:)
	LOGICAL LOG1,LOG,FIRST
	SAVE FIRST
	DATA PI/3.141592653589793D0/,FIRST/.TRUE./
      CALL ABORTNOW()
C MEMORY ALLOCATIONS
	IF(FIRST)THEN
	FIRST=.FALSE.
	ALLOCATE(OPARHH(NKAPMEM,NKAPMEM,0:LMAXBMEM,NSORTMEM,NSPINMEM))
	ALLOCATE(OPARJH(NKAPMEM,NKAPMEM,0:LMAXBMEM,NSORTMEM,NSPINMEM))
	ALLOCATE(OPARHJ(NKAPMEM,NKAPMEM,0:LMAXBMEM,NSORTMEM,NSPINMEM))
	ALLOCATE(OPARJJ(NKAPMEM,NKAPMEM,0:LMAXTMEM,NSORTMEM,NSPINMEM))
	ALLOCATE(OHH(NKAPMEM,NKAPMEM,0:LMAXBMEM,NSORTMEM,
     &NPANMEM,NSPINMEM,NORBSMEM))
	ALLOCATE(OJH(NKAPMEM,NKAPMEM,0:LMAXBMEM,NSORTMEM,
     &NPANMEM,NSPINMEM,NORBSMEM))
	ALLOCATE(OHJ(NKAPMEM,NKAPMEM,0:LMAXBMEM,NSORTMEM,
     &NPANMEM,NSPINMEM,NORBSMEM))
	ALLOCATE(OJJ(NKAPMEM,NKAPMEM,0:LMAXTMEM,NSORTMEM,
     &NPANMEM,NSPINMEM,NORBSMEM))
	ALLOCATE(PHH(NKAPMEM,NKAPMEM,0:LMAXBMEM,NSORTMEM,
     &NPANMEM,NSPINMEM,NORBSMEM))
	ALLOCATE(PJH(NKAPMEM,NKAPMEM,0:LMAXBMEM,NSORTMEM,
     &NPANMEM,NSPINMEM,NORBSMEM))
	ALLOCATE(PHJ(NKAPMEM,NKAPMEM,0:LMAXBMEM,NSORTMEM,
     &NPANMEM,NSPINMEM,NORBSMEM))
	ALLOCATE(PJJ(NKAPMEM,NKAPMEM,0:LMAXTMEM,NSORTMEM,
     &NPANMEM,NSPINMEM,NORBSMEM))
      ALLOCATE(WHH(NKAPMEM,NKAPMEM,0:LMAXTMEM+1,NSORTMEM))
      ALLOCATE(WJH(NKAPMEM,NKAPMEM,0:LMAXTMEM+1,NSORTMEM))
      ALLOCATE(WHJ(NKAPMEM,NKAPMEM,0:LMAXTMEM+1,NSORTMEM))
      ALLOCATE(WJJ(NKAPMEM,NKAPMEM,0:LMAXTMEM+1,NSORTMEM))
	ENDIF
C MEMORY ALLOCATIONS
	ALLOCATE(ALP(0:LMAXTMEM+1,NKAP(IPAN)))
	ALLOCATE(ALPD(0:LMAXTMEM+1,NKAP(IPAN)))
      ALLOCATE(WHHS(NKAP(IPAN),NKAP(IPAN),0:LMAXTMEM+1))
      ALLOCATE(WJHS(NKAP(IPAN),NKAP(IPAN),0:LMAXTMEM+1))
      ALLOCATE(WHJS(NKAP(IPAN),NKAP(IPAN),0:LMAXTMEM+1))
      ALLOCATE(WJJS(NKAP(IPAN),NKAP(IPAN),0:LMAXTMEM+1))
	ALLOCATE(WORK1(0:NRADMEM))
	ALLOCATE(WORK2(0:NRADMEM))
	ALLOCATE(FIH(0:NRADMEM,0:LMAXTMEM,NKAPMEM,NSPINMEM))
	ALLOCATE(FIJ(0:NRADMEM,0:LMAXTMEM,NKAPMEM,NSPINMEM))
      SIZE_FIS=2.D0*DBLE(SIZE(FIH)*LENCMP)/1024.D0**2
	ALLOCATE(AFI(0:NRADMEM,0:LMAXTMEM))
	ALLOCATE(AFID(0:NRADMEM,0:LMAXTMEM))
	ALLOCATE(AFIP(0:NRADMEM,0:LMAXTMEM))
	ALLOCATE(AFIDP(0:NRADMEM,0:LMAXTMEM))
	SIZE_AFI=4.D0*DBLE(SIZE(AFI)*LENREL)/1024.D0**2
	ALLOCATE(AFIDDS(0:LMAXTMEM))
	ALLOCATE(AFIDDPS(0:LMAXTMEM))
      CURMEM=CURMEM+SIZE_FIS+SIZE_AFI
      IF(TOTMEM.LT.CURMEM)TXTMEM='<OVRPAR> Subroutine'
      IF(TOTMEM.LT.CURMEM)TOTMEM=CURMEM
C COMPUTE OFF_DIAGONAL ELEMENTS
	DO 1000 ISORT=1,NSORT                             !!! over isort
C Find FIny and FIny-dot radial functions:
	DO ISPIN=1,NSPIN                                  !!! over spins
	DO IKAP=1,NKAP(IPAN)                              !!! over energies
      CALL LIB_RADSCH_PHIS(ENY(0,ISORT,IKAP,IPAN,ISPIN),AFI,AFIP,
     &AFID,AFIDP,AFIDDS,AFIDDPS,SMT(ISORT),POTRWF(0,ISORT,ISPIN),
     &ILST(ISORT),NRAD(ISORT),H(ISORT),R(0,ISORT),DR(0,ISORT),
     &LRTV(ISORT))
C Transfere to FIH and FIJ convinient functions:
	DO L=0,ILST(ISORT)
	DO IRAD=0,NRAD(ISORT)
	FIH(IRAD,L,IKAP,ISPIN)=AAH(L,ISORT,IKAP,IPAN,ISPIN)*
     &AFI(IRAD,L)+BBH(L,ISORT,IKAP,IPAN,ISPIN)*AFIP(IRAD,L)
	FIJ(IRAD,L,IKAP,ISPIN)=AAJ(L,ISORT,IKAP,IPAN,ISPIN)*
     &AFI(IRAD,L)+BBJ(L,ISORT,IKAP,IPAN,ISPIN)*AFIP(IRAD,L)
      ENDDO    
      ENDDO   
      ENDDO                                             !!! over energies
	ENDDO                                             !!! over spins
	DO IORBS=1,NORBS                                  !!! over iorbs
	DO IUPDN=1,NSPIN                                  !!! over iupdn
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
	DO IKAP1=1,NKAP(IPAN)                             !!! over ikap1
	DO IKAP=1,NKAP(IPAN)                              !!! over ikap
	DO L=0,ILST(ISORT)                                !!! over l
	LOG1=.FALSE.
	LOG =.FALSE.
	IF(LSPAN(L,ISORT,IKAP1,IPAN))LOG1=.TRUE.
	IF(LSPAN(L,ISORT,IKAP ,IPAN))LOG =.TRUE.
	IF(L.LE.ILSB(ISORT))THEN
	OHH(IKAP1,IKAP,L,ISORT,IPAN,IUPDN,IORBS)=(0.D0,0.D0)
	OHJ(IKAP1,IKAP,L,ISORT,IPAN,IUPDN,IORBS)=(0.D0,0.D0)
	OJH(IKAP1,IKAP,L,ISORT,IPAN,IUPDN,IORBS)=(0.D0,0.D0)
	PHH(IKAP1,IKAP,L,ISORT,IPAN,IUPDN,IORBS)=(0.D0,0.D0)
	PHJ(IKAP1,IKAP,L,ISORT,IPAN,IUPDN,IORBS)=(0.D0,0.D0)
	PJH(IKAP1,IKAP,L,ISORT,IPAN,IUPDN,IORBS)=(0.D0,0.D0)
	ENDIF
	OJJ(IKAP1,IKAP,L,ISORT,IPAN,IUPDN,IORBS)=(0.D0,0.D0)
	PJJ(IKAP1,IKAP,L,ISORT,IPAN,IUPDN,IORBS)=(0.D0,0.D0)
C 1) <H|H>
	IF(LOG1.AND.LOG)THEN
	WORK1(0)=(0.D0,0.D0)
	DO IRAD=1,NRAD(ISORT)          !!! over radial mesh
	WORK1(IRAD)=
     &CONJG(FIH(IRAD,L,IKAP1,ISPIN1))*FIH(IRAD,L,IKAP,ISPIN)*
     &R(IRAD,ISORT)**2*DR(IRAD,ISORT)
      ENDDO                          !!! over radial mesh
	CALL LIB_CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
      OHH(IKAP1,IKAP,L,ISORT,IPAN,IUPDN,IORBS)=
     &WORK2(NRAD(ISORT))
      IF(LPRO.EQ.0)
     &PHH(IKAP1,IKAP,L,ISORT,IPAN,IUPDN,IORBS)=
     &OHH(IKAP1,IKAP,L,ISORT,IPAN,IUPDN,IORBS)
      IF(LPRO.EQ.1)
     &PHH(IKAP1,IKAP,L,ISORT,IPAN,IUPDN,IORBS)=
     &CONJG(AAH(L,ISORT,IKAP1,IPAN,ISPIN1))*
     &      AAH(L,ISORT,IKAP ,IPAN,ISPIN )
	ENDIF
C 2) <J|H> diagonal
	IF(LOG)THEN
	WORK1(0)=(0.D0,0.D0)
	DO IRAD=1,NRAD(ISORT)          !!! over radial mesh
	WORK1(IRAD)=
     &CONJG(FIJ(IRAD,L,IKAP1,ISPIN1))*FIH(IRAD,L,IKAP,ISPIN)*
     &R(IRAD,ISORT)**2*DR(IRAD,ISORT)
      ENDDO                          !!! over radial mesh
	CALL LIB_CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
      OJH(IKAP1,IKAP,L,ISORT,IPAN,IUPDN,IORBS)=
     &WORK2(NRAD(ISORT))*GAM(L,ISORT)
      IF(LPRO.EQ.0)
     &PJH(IKAP1,IKAP,L,ISORT,IPAN,IUPDN,IORBS)=
     &OJH(IKAP1,IKAP,L,ISORT,IPAN,IUPDN,IORBS)
      IF(LPRO.EQ.1)
     &PJH(IKAP1,IKAP,L,ISORT,IPAN,IUPDN,IORBS)=
     &CONJG(AAJ(L,ISORT,IKAP1,IPAN,ISPIN1))*
     &      AAH(L,ISORT,IKAP ,IPAN,ISPIN )*GAM(L,ISORT)
	ENDIF
C 3) <H|J> diagonal
	IF(LOG1)THEN
	WORK1(0)=(0.D0,0.D0)
	DO IRAD=1,NRAD(ISORT)          !!! over radial mesh
	WORK1(IRAD)=
     &CONJG(FIH(IRAD,L,IKAP1,ISPIN1))*FIJ(IRAD,L,IKAP,ISPIN)*
     &R(IRAD,ISORT)**2*DR(IRAD,ISORT)
      ENDDO                          !!! over radial mesh
	CALL LIB_CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
      OHJ(IKAP1,IKAP,L,ISORT,IPAN,IUPDN,IORBS)=
     &WORK2(NRAD(ISORT))*GAM(L,ISORT)
      IF(LPRO.EQ.0)
     &PHJ(IKAP1,IKAP,L,ISORT,IPAN,IUPDN,IORBS)=
     &OHJ(IKAP1,IKAP,L,ISORT,IPAN,IUPDN,IORBS)
      IF(LPRO.EQ.1)
     &PHJ(IKAP1,IKAP,L,ISORT,IPAN,IUPDN,IORBS)=
     &CONJG(AAH(L,ISORT,IKAP1,IPAN,ISPIN1))*
     &      AAJ(L,ISORT,IKAP ,IPAN,ISPIN )*GAM(L,ISORT)
	ENDIF
C 4) <J|J> diagonal
	WORK1(0)=(0.D0,0.D0)
	DO IRAD=1,NRAD(ISORT)          !!! over radial mesh
	WORK1(IRAD)=
     &CONJG(FIJ(IRAD,L,IKAP1,ISPIN1))*FIJ(IRAD,L,IKAP,ISPIN)*
     &R(IRAD,ISORT)**2*DR(IRAD,ISORT)
      ENDDO                          !!! over radial mesh
	CALL LIB_CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
      OJJ(IKAP1,IKAP,L,ISORT,IPAN,IUPDN,IORBS)=
     &WORK2(NRAD(ISORT))*GAM(L,ISORT)**2
      IF(LPRO.EQ.0)
     &PJJ(IKAP1,IKAP,L,ISORT,IPAN,IUPDN,IORBS)=
     &OJJ(IKAP1,IKAP,L,ISORT,IPAN,IUPDN,IORBS)
      IF(LPRO.EQ.1)
     &PJJ(IKAP1,IKAP,L,ISORT,IPAN,IUPDN,IORBS)=
     &CONJG(AAJ(L,ISORT,IKAP1,IPAN,ISPIN1))*
     &      AAJ(L,ISORT,IKAP ,IPAN,ISPIN )*GAM(L,ISORT)**2
      ENDDO                                             !!! over l
      ENDDO                                             !!! over ikap
      ENDDO                                             !!! over ikap1
      ENDDO                                             !!! over spins
      ENDDO                                             !!! over iorbs
 1000 CONTINUE                                          !!! over isort
C  DO GLOBALLY OVER SPINS AND SORTS
	DO 3000 ISPIN=1,NSPIN                             !!! over spins
	DO 2000 ISORT=1,NSORT                             !!! over isort
C  FIND OVERLAP PARAMETERS IN THE INT.REGION
      DO IKAP=1,NKAP(IPAN)
      DO L=0,ILST(ISORT)+1
      ALP(L,IKAP)=ALPHA(L,ISORT,IKAP,IPAN)/GAM(L,ISORT)
      ALPD(L,IKAP)=ALPDOT(L,ISORT,IKAP,IPAN)/GAM(L,ISORT)*PAR**2
	ENDDO
	ENDDO
	CALL LIB_WRONSK2(WHHS(1,1,0),WJHS(1,1,0),WHJS(1,1,0),WJJS(1,1,0),
     &     SMT(ISORT),SMT(ISORT),NKAP(IPAN),EKAP(1,IPAN),ILST(ISORT)+1,
     &     ALP(0,1),ALPD(0,1))
	DO L=0,ILST(ISORT)+1                              !!! over l
	DO IKAP1=1,NKAP(IPAN)                             !!! over ikap1
	DO IKAP=1,NKAP(IPAN)                              !!! over ikap
	WHH(IKAP1,IKAP,L,ISORT)=WHHS(IKAP1,IKAP,L)
	WJH(IKAP1,IKAP,L,ISORT)=WJHS(IKAP1,IKAP,L)
	WHJ(IKAP1,IKAP,L,ISORT)=WHJS(IKAP1,IKAP,L)
	WJJ(IKAP1,IKAP,L,ISORT)=WJJS(IKAP1,IKAP,L)
      ENDDO                                             !!! over ikap
      ENDDO                                             !!! over ikap1
      ENDDO                                             !!! over l
C  CALCULATE OVERLAP POTENTIAL PARAMETERS FROM WHOLE CELL
	DO L=0,ILST(ISORT)                                !!! over l
	DO IKAP1=1,NKAP(IPAN)                             !!! over ikap1
	DO IKAP=1,NKAP(IPAN)                              !!! over ikap
	IF(L.LE.ILSB(ISORT))THEN
	OPARHH(IKAP1,IKAP,L,ISORT,ISPIN)=(0.D0,0.D0)
	OPARJH(IKAP1,IKAP,L,ISORT,ISPIN)=(0.D0,0.D0)
	OPARHJ(IKAP1,IKAP,L,ISORT,ISPIN)=(0.D0,0.D0)
	ENDIF
	OPARJJ(IKAP1,IKAP,L,ISORT,ISPIN)=(0.D0,0.D0)
	IF(LSPAN(L,ISORT,IKAP1,IPAN).AND.LSPAN(L,ISORT,IKAP,IPAN))THEN
	IF(NOVR.EQ.0)
     &OPARHH(IKAP1,IKAP,L,ISORT,ISPIN)=
     &OMTHH(IKAP1,IKAP,L,ISORT,ISPIN)+WHH(IKAP1,IKAP,L,ISORT)
	IF(NOVR.EQ.1)
     &OPARHH(IKAP1,IKAP,L,ISORT,ISPIN)=
     &OMTHH(IKAP1,IKAP,L,ISORT,ISPIN)
	ENDIF
	IF(LSPAN(L,ISORT,IKAP,IPAN))THEN
	IF(NOVR.EQ.0)
     &OPARJH(IKAP1,IKAP,L,ISORT,ISPIN)=
     &OMTJH(IKAP1,IKAP,L,ISORT,ISPIN)+
     &WJH(IKAP1,IKAP,L,ISORT)*GAM(L,ISORT)
	IF(NOVR.EQ.1)
     &OPARJH(IKAP1,IKAP,L,ISORT,ISPIN)=
     &OMTJH(IKAP1,IKAP,L,ISORT,ISPIN)
	ENDIF
	IF(LSPAN(L,ISORT,IKAP1,IPAN))THEN
	IF(NOVR.EQ.0)
     &OPARHJ(IKAP1,IKAP,L,ISORT,ISPIN)=
     &OMTHJ(IKAP1,IKAP,L,ISORT,ISPIN)+
     &WHJ(IKAP1,IKAP,L,ISORT)*GAM(L,ISORT)
	IF(NOVR.EQ.1)
     &OPARHJ(IKAP1,IKAP,L,ISORT,ISPIN)=
     &OMTHJ(IKAP1,IKAP,L,ISORT,ISPIN)
	ENDIF
	IF(NOVR.EQ.0)
     &OPARJJ(IKAP1,IKAP,L,ISORT,ISPIN)=
     &OMTJJ(IKAP1,IKAP,L,ISORT,ISPIN)+
     &WJJ(IKAP1,IKAP,L,ISORT)*GAM(L,ISORT)*GAM(L,ISORT)
	IF(NOVR.EQ.1)
     &OPARJJ(IKAP1,IKAP,L,ISORT,ISPIN)=
     &OMTJJ(IKAP1,IKAP,L,ISORT,ISPIN)
      ENDDO                                             !!! over ikap
      ENDDO                                             !!! over ikap1
      ENDDO                                             !!! over l
 2000 CONTINUE                                          !!! over isort
 3000 CONTINUE                                          !!! over spins
C MEMORY DEALLOCATIONS
	DEALLOCATE(ALP,ALPD,WHHS,WHJS,WJHS,WJJS)
	DEALLOCATE(WORK1,WORK2,FIH,FIJ)
	DEALLOCATE(AFI,AFID,AFIP,AFIDP,AFIDDS,AFIDDPS)
      CURMEM=CURMEM-SIZE_FIS-SIZE_AFI
	END
