	SUBROUTINE BND_PLACE(ITER)
********************************************************************
* Place Eny at the centers of gravity of the occupied parts of the * 
* bands.                                                           *
********************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_CONTROL ,ONLY: LIFT,LMTO,LRWF,IASA,IDMF              !!! from readini
      USE COM_PARAM  ,ONLY : NATOM,NSORT,NSPIN,IS,ILSB,NHSORT,LRTV !!! from readini
      USE COM_KAPPAR ,ONLY : NPAN,NKAP                             !!! from readini
      USE COM_PANPAR ,ONLY : LTPAN,LSPAN                           !!! from readini
      USE COM_SPHERE ,ONLY : SMT                                   !!! from readini
      USE COM_POTDAT ,ONLY : POTRWF                                !!! from potfull
      USE COM_MIXRHO1,ONLY : ADMIX1,ADMIN,ADMAX,KEY,ADMOPT         !!! from mixro1
     &                      ,ADMSPN,ASMIN,ASMAX,KSP,ADSPIN         !!! from mixro1
      USE COM_INPPAR ,ONLY : TNY,ENY,DNY,NODES,MNY,NCLS,LNY        !!! from radmesh
      USE COM_KKRPAR ,ONLY : CNY,WNY,VNY                           !!! from kkrpar
      USE COM_HUBDAT ,ONLY : MCRL,LCRL                             !!! from readhub
      USE COM_HUBCOM ,ONLY : VHUB,VCNS,VDBC                        !!! from readhub
      USE COM_DMFDAT ,ONLY : SIGI                                  !!! from grfbnd
      USE COM_RADMESH,ONLY : NRAD,H,R,DR                           !!! from radmesh
      USE COM_FERMI  ,ONLY : EF,ETOS,ATOS,ADOS,PTOS,PDOS,PFOS      !!! from ttrints
      USE COM_UNIT   ,ONLY : IUT,IUR,IUN                           !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8, SAVE, ALLOCATABLE :: ONY(:,:,:,:,:) ! old Dnu(s).
	REAL*8, SAVE, ALLOCATABLE :: SNY(:,:,:,:,:) ! level shifts
	LOGICAL CASE
	DATA PI/3.141592653589793D0/, BANDMIN/0.3D0/
      CALL ABORTNOW()
C MEMORY ALLOCATIONS
	IF(ITER.EQ.0)THEN
      ALLOCATE(ONY(0:LMAXBMEM,NSORTMEM,NKAPMEM,NPANMEM,NSPINMEM))
	ALLOCATE(SNY(0:LMAXBMEM,NSORTMEM,NKAPMEM,NPANMEM,NSPINMEM))
	ENDIF
C FIND ENY SHIFTS DUE TO CORRELATIONS
	DO IPAN=1,NPAN                                   !!! over panels
	DO ISPIN=1,NSPIN                                 !!! over spins
	DO ISORT=1,NSORT                                 !!! over sorts
	DO IKAP=1,NKAP(IPAN)                             !!! over energies
	DO L=0,ILSB(ISORT)                               !!! over l
	SNY(L,ISORT,IKAP,IPAN,ISPIN)=0.D0
	IF(IPAN.GT.1)CYCLE
	IF(IDMF.EQ.0)CYCLE
C AVERAGE SHIFTS OVER ALL ATOMS OF GIVEN SORT
	DO IATOM=1,NATOM
	IF(IS(IATOM).NE.ISORT)CYCLE
	IF(LCRL(L,IATOM).EQ.0)CYCLE
	DO M=-L,L                                        !!! over m
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M+1 !!! (l,m m)
	IF(IDMF.EQ.1)THEN
	SNY(L,ISORT,IKAP,IPAN,ISPIN)=SNY(L,ISORT,IKAP,IPAN,ISPIN)+
     &VCNS(IU,IATOM,ISPIN,1)/DBLE(2*L+1)/DBLE(NHSORT(ISORT))
	ELSEIF(IDMF.EQ.2)THEN
	SNY(L,ISORT,IKAP,IPAN,ISPIN)=SNY(L,ISORT,IKAP,IPAN,ISPIN)+
     &(VHUB(IU,IATOM,ISPIN,1)-VDBC(IU,IATOM,ISPIN,1))
     &/DBLE(2*L+1)/DBLE(NHSORT(ISORT))
	ELSEIF(IDMF.GE.3)THEN
	SNY(L,ISORT,IKAP,IPAN,ISPIN)=SNY(L,ISORT,IKAP,IPAN,ISPIN)+
     &(SIGI(IU,IATOM,ISPIN,1)-VDBC(IU,IATOM,ISPIN,1))
     &/DBLE(2*L+1)/DBLE(NHSORT(ISORT))
	ENDIF
      ENDDO                                            !!! over m
      ENDDO                                            !!! over atoms
      ENDDO                                            !!! over l
      ENDDO                                            !!! over energies
      ENDDO                                            !!! over sorts
      ENDDO                                            !!! over spins
      ENDDO                                            !!! over panels
C FIND ENY FROM THE CENTER-OF-GRAVITY SCHEME
	IF(NSPIN.EQ.1)ADMIX=ADMOPT
	IF(NSPIN.EQ.2)ADMIX=MAX(ADMOPT,ADSPIN)
	DO IPAN=1,NPAN                                   !!! over panels
	DO ISORT=1,NSORT                                 !!! over sorts
	DO IKAP=1,NKAP(IPAN)                             !!! over energies
	DO L=0,ILSB(ISORT)                               !!! over l
	IF(MNY(L,ISORT,IKAP,IPAN).EQ.3)THEN
C CALCULATE CENTERS OF GRAVITY
	DO ISPIN=1,NSPIN                                 !!! over spins
	IF(ITER.EQ.0)GOTO300
	IF(LRWF.EQ.0)GOTO300
	ICLS=LNY(L,ISORT,IKAP,IPAN)
C Spin averaged
	IF(LRWF.EQ.1)THEN
	TOS1=DREAL(PFOS(L,ISORT,ICLS,IPAN,1    ,1))*0.5D0+
     &     DREAL(PFOS(L,ISORT,ICLS,IPAN,NSPIN,1))*0.5D0
	TOS0=DREAL(PTOS(L,ISORT,ICLS,IPAN,1    ,1))*0.5D0+
     &     DREAL(PTOS(L,ISORT,ICLS,IPAN,NSPIN,1))*0.5D0
C Spin dependent
	ELSEIF(LRWF.EQ.2)THEN
	TOS1=DREAL(PFOS(L,ISORT,ICLS,IPAN,ISPIN,1))
	TOS0=DREAL(PTOS(L,ISORT,ICLS,IPAN,ISPIN,1))
	ENDIF
C Leave it like previous
	IF(ABS(TOS0).LE.1.D-10)THEN
	DNYCEN=ONY(L,ISORT,IKAP,IPAN,ISPIN)
	GOTO200
	ENDIF
C SET ENY INTO CENTER OF GRAVITY
      ENYCEN=TOS1/TOS0-SNY(L,ISORT,IKAP,IPAN,ISPIN)
      CALL LIB_RADSCH_TNYS(ENYCEN,TNYCEN,DTNYDE,L+1,SMT(ISORT),
     &POTRWF(0,ISORT,ISPIN),NRAD(ISORT),H(ISORT),R(0,ISORT),
     &DR(0,ISORT),LRTV(ISORT))
      NODCEN=TNYCEN
      IF(NODCEN.EQ.NODES(L,ISORT,IKAP,IPAN))GOTO100
C NODES MISMATCH, TRY ENY=EF
      ENYCEN=EF
      CALL LIB_RADSCH_TNYS(ENYCEN,TNYCEN,DTNYDE,L+1,SMT(ISORT),
     &POTRWF(0,ISORT,ISPIN),NRAD(ISORT),H(ISORT),R(0,ISORT),
     &DR(0,ISORT),LRTV(ISORT))
      NODCEN=TNYCEN
      IF(NODCEN.EQ.NODES(L,ISORT,IKAP,IPAN))GOTO100
C NODES MISMATCH, SET DNY=L AND DO NOT WORRY
	DNYCEN=DBLE(L)-0.05D0
	GOTO200
 100  DNYCEN=TAN(PI*(0.5D0+NODCEN-TNYCEN))
C CHECK LIMITING CASES
	IF(DNYCEN.GT.DBLE(L))DNYCEN=DBLE(L)-0.05D0
	IF(DNYCEN.LT.-10.D0)DNYCEN=-10.D0
C CHECK NARROW BAND CASE FOR VALENCE STATES
	IF(IPAN.EQ.1.AND.LRWF.EQ.1.AND.(
     &CNY(L,ISORT,IKAP,IPAN,1    ).GE.EF.OR.
     &CNY(L,ISORT,IKAP,IPAN,NSPIN).GE.EF).AND.(
     &WNY(L,ISORT,IKAP,IPAN,1    ).LE.BANDMIN.OR.
     &WNY(L,ISORT,IKAP,IPAN,NSPIN).LE.BANDMIN))
     &DNYCEN=DBLE(-L-1)
	IF(IPAN.EQ.1.AND.LRWF.EQ.2.AND.
     &CNY(L,ISORT,IKAP,IPAN,ISPIN).GE.EF.AND.
     &WNY(L,ISORT,IKAP,IPAN,ISPIN).LE.BANDMIN)
     &DNYCEN=DBLE(-L-1)
 200  DNY(L,ISORT,IKAP,IPAN,ISPIN)=
     &ONY(L,ISORT,IKAP,IPAN,ISPIN)*(1.D0-ADMIX)+DNYCEN*ADMIX
 300  ONY(L,ISORT,IKAP,IPAN,ISPIN)=DNY(L,ISORT,IKAP,IPAN,ISPIN)
      ENDDO                                              !!! over spins
	ENDIF
      ENDDO                                              !!! over l
      ENDDO                                              !!! over energies
      ENDDO                                              !!! over sorts
      ENDDO                                              !!! over panels
	IF(ITER.EQ.0)RETURN
	END SUBROUTINE BND_PLACE
