	SUBROUTINE BND_POTPAR(IPAN)
****************************************************************
*  Subroutine prepares potential parameters for LMTPAR program *
****************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,IS,ILST,ILSB,LRTV    !!! from readini
      USE COM_RADMESH ,ONLY: NRAD,H,R,DR                            !!! from radmesh
      USE COM_LATPAR  ,ONLY: PAR,OMEGAC                             !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP,EK                      !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN,IATS,ISTS                  !!! from readini
      USE COM_SPHERE  ,ONLY: SMT,SASA,SWZ                           !!! from readini
      USE COM_POTDAT  ,ONLY: POTRWF                                 !!! from potfull
      USE COM_INPPAR  ,ONLY: ENY,DNY,TNY,MNY,NODES,DHLOG,LNY        !!! from readini
      USE COM_POTPAR  ,ONLY: FF,FFP,FPF,FPFP                        !!! from potpar
      USE COM_LMTPAR  ,ONLY: GAM,AAH,BBH,AAJ,BBJ                    !!! from potpar
      USE COM_ASAPAR  ,ONLY: HS,BS,DH,DJ                            !!! from potpar
      USE COM_SCRINP  ,ONLY: ALPHA,ALPDOT                           !!! from alpcon
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT                            !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8, ALLOCATABLE :: FPMN(:)
	REAL*8, ALLOCATABLE :: AFIS(:,:)
	REAL*8, ALLOCATABLE :: AFIPS(:,:)
	REAL*8, ALLOCATABLE :: DNYP(:,:)
	REAL*8, ALLOCATABLE :: AFI(:,:,:,:)
	REAL*8, ALLOCATABLE :: AFID(:,:,:,:)
	REAL*8, ALLOCATABLE :: AFIP(:,:,:,:)
	REAL*8, ALLOCATABLE :: AFIDP(:,:,:,:)
	REAL*8, ALLOCATABLE :: AFIDDS(:)
	REAL*8, ALLOCATABLE :: AFIDDPS(:)
	REAL*8, ALLOCATABLE :: WORK1(:)
	REAL*8, ALLOCATABLE :: WORK2(:)
	COMPLEX*16, ALLOCATABLE :: HAN(:,:)
	COMPLEX*16, ALLOCATABLE :: BES(:,:)
	LOGICAL FIRST
	SAVE FIRST
	DATA PI/3.141592653589793D0/,FIRST/.TRUE./
      CALL ABORTNOW()
C MEMORY ALLOCATIONS FOR MAIN CONTROL ARRAYS
	IF(FIRST)THEN
	FIRST=.FALSE.
      ALLOCATE(FF(NKAPMEM,NKAPMEM,0:LMAXTMEM,NSORTMEM,NSPINMEM))
      ALLOCATE(FFP(NKAPMEM,NKAPMEM,0:LMAXTMEM,NSORTMEM,NSPINMEM))
      ALLOCATE(FPF(NKAPMEM,NKAPMEM,0:LMAXTMEM,NSORTMEM,NSPINMEM))
      ALLOCATE(FPFP(NKAPMEM,NKAPMEM,0:LMAXTMEM,NSORTMEM,NSPINMEM))
      ALLOCATE(GAM(0:LMAXTMEM+1,NSORTMEM))
	ALLOCATE(AAH(0:LMAXTMEM,NSORTMEM,NKAPMEM,NPANMEM,NSPINMEM))
	ALLOCATE(BBH(0:LMAXTMEM,NSORTMEM,NKAPMEM,NPANMEM,NSPINMEM))
	ALLOCATE(AAJ(0:LMAXTMEM,NSORTMEM,NKAPMEM,NPANMEM,NSPINMEM))
	ALLOCATE(BBJ(0:LMAXTMEM,NSORTMEM,NKAPMEM,NPANMEM,NSPINMEM))
	ALLOCATE(HS(0:LMAXTMEM,NSORTMEM,NKAPMEM,NPANMEM,NSPINMEM))
	ALLOCATE(BS(0:LMAXTMEM,NSORTMEM,NKAPMEM,NPANMEM,NSPINMEM))
	ALLOCATE(DH(0:LMAXTMEM,NSORTMEM,NKAPMEM,NPANMEM,NSPINMEM))
	ALLOCATE(DJ(0:LMAXTMEM,NSORTMEM,NKAPMEM,NPANMEM,NSPINMEM))
	ENDIF
C MEMORY ALLOCATIONS FOR SCRATCH ARRAYS
	ALLOCATE(AFI(0:NRADMEM,0:LMAXTMEM,NKAPMEM,NSPINMEM))
	ALLOCATE(AFID(0:NRADMEM,0:LMAXTMEM,NKAPMEM,NSPINMEM))
	ALLOCATE(AFIP(0:NRADMEM,0:LMAXTMEM,NKAPMEM,NSPINMEM))
	ALLOCATE(AFIDP(0:NRADMEM,0:LMAXTMEM,NKAPMEM,NSPINMEM))
	ALLOCATE(AFIDDS(0:LMAXTMEM))
	ALLOCATE(AFIDDPS(0:LMAXTMEM))
	ALLOCATE(AFIS(0:LMAXTMEM,NKAPMEM))
	ALLOCATE(AFIPS(0:LMAXTMEM,NKAPMEM))
	ALLOCATE(DNYP(0:LMAXTMEM,NKAPMEM))
	ALLOCATE(FPMN(0:LMAXTMEM))
	ALLOCATE(HAN(3,0:LMAXTMEM))
	ALLOCATE(BES(3,0:LMAXTMEM))
	ALLOCATE(WORK1(0:NRADMEM))
	ALLOCATE(WORK2(0:NRADMEM))
C START CODE
	DO ISPIN=1,NSPIN                                  !!! over spins
	DO ISORT=1,NSORT                                  !!! over isort
	DO L=0,ILST(ISORT)+1
	GAM(L,ISORT)=1.D0/(SMT(ISORT)/PAR)/DBLE(2*L+1)
	ENDDO
	DO IKAP=1,NKAP(IPAN)                              !!! over ikap
	CALL LIB_BESSEL(SMT(ISORT),EKAP(IKAP,IPAN),SMT(ISORT),BES,
     &ILST(ISORT))
	CALL LIB_HANKEL(SMT(ISORT),EKAP(IKAP,IPAN),SMT(ISORT),HAN,
     &ILST(ISORT))
C  SOLVE SCHROEDINGER'S EQUATION FOR THE ENY
      CALL LIB_RADSCH_PARS(ENY(0,ISORT,IKAP,IPAN,ISPIN),
     &AFIS(0,IKAP),AFIPS(0,IKAP),DNY(0,ISORT,IKAP,IPAN,ISPIN),
     &TNY(0,ISORT,IKAP,IPAN,ISPIN),DNYP(0,IKAP),FPMN,
     &SMT(ISORT),POTRWF(0,ISORT,ISPIN),ILST(ISORT),
     &NRAD(ISORT),H(ISORT),R(0,ISORT),DR(0,ISORT),LRTV(ISORT))
      CALL LIB_RADSCH_PHIS(ENY(0,ISORT,IKAP,IPAN,ISPIN),
     &AFI(0,0,IKAP,ISPIN),AFIP(0,0,IKAP,ISPIN),AFID(0,0,IKAP,ISPIN),
     &AFIDP(0,0,IKAP,ISPIN),AFIDDS,AFIDDPS,SMT(ISORT),
     &POTRWF(0,ISORT,ISPIN),ILST(ISORT),NRAD(ISORT),H(ISORT),
     &R(0,ISORT),DR(0,ISORT),LRTV(ISORT))
	DO L=0,ILST(ISORT)                      !!! over l
C  CHECK RADIAL FUNCTIONS IN CASE SEMICORE STATES
	IF(MNY(L,ISORT,IKAP,IPAN).EQ.2)THEN
	IF(ABS(DNY(L,ISORT,IKAP,IPAN,ISPIN)-
     &DHLOG(L,ISORT,IKAP,IPAN,ISPIN)).GE.1.D-05)THEN
	WRITE(IUT,*)'Warning from <POTPAR>:'
      WRITE(IUT,1010)ENY(L,ISORT,IKAP,IPAN,ISPIN),
     &DNY(L,ISORT,IKAP,IPAN,ISPIN),
     &DHLOG(L,ISORT,IKAP,IPAN,ISPIN),
     &L,ISORT,IKAP,IPAN,ISPIN
	ENDIF
	ENDIF
C  TRANSFORM TO SCREENED BESSEL FUNCTIONS
      BES(1,L)=BES(1,L)-ALPHA(L,ISORT,IKAP,IPAN)/GAM(L,ISORT)*HAN(1,L)
      BES(2,L)=BES(2,L)-ALPHA(L,ISORT,IKAP,IPAN)/GAM(L,ISORT)*HAN(2,L)
      BES(3,L)=BES(3,L)-ALPHA(L,ISORT,IKAP,IPAN)/GAM(L,ISORT)*HAN(3,L)
C  SET MAIN POTENTIAL PARAMETERS OF THE FP-LMTO METHOD
	HS(L,ISORT,IKAP,IPAN,ISPIN)=HAN(1,L)
	BS(L,ISORT,IKAP,IPAN,ISPIN)=BES(1,L)
	DH(L,ISORT,IKAP,IPAN,ISPIN)=SMT(ISORT)*HAN(2,L)/HAN(1,L)
	DJ(L,ISORT,IKAP,IPAN,ISPIN)=SMT(ISORT)*BES(2,L)/BES(1,L)
	AAH(L,ISORT,IKAP,IPAN,ISPIN)=+SMT(ISORT)*AFIPS(L,IKAP)*
     &HS(L,ISORT,IKAP,IPAN,ISPIN)*(DH(L,ISORT,IKAP,IPAN,ISPIN)-
     &DNYP(L,IKAP))                                        !!! +W{Phi-dot,H}
	AAJ(L,ISORT,IKAP,IPAN,ISPIN)=+SMT(ISORT)*AFIPS(L,IKAP)*
     &BS(L,ISORT,IKAP,IPAN,ISPIN)*(DJ(L,ISORT,IKAP,IPAN,ISPIN)-
     &DNYP(L,IKAP))                                        !!! +W{Phi-dot,J}
	BBH(L,ISORT,IKAP,IPAN,ISPIN)=-SMT(ISORT)*AFIS (L,IKAP)*
     &HS(L,ISORT,IKAP,IPAN,ISPIN)*(DH(L,ISORT,IKAP,IPAN,ISPIN)-
     &DNY(L,ISORT,IKAP,IPAN,ISPIN))                        !!! -W{Phi,H}
	BBJ(L,ISORT,IKAP,IPAN,ISPIN)=-SMT(ISORT)*AFIS (L,IKAP)*
     &BS(L,ISORT,IKAP,IPAN,ISPIN)*(DJ(L,ISORT,IKAP,IPAN,ISPIN)-
     &DNY(L,ISORT,IKAP,IPAN,ISPIN))                        !!! -W{Phi,J}
C  SET INTEGRALS BETWEEN RADIAL WAVE FUNCTIONS
	FF(IKAP,IKAP,L,ISORT,ISPIN)=1.D0
	FFP(IKAP,IKAP,L,ISORT,ISPIN)=0.D0
	FPF(IKAP,IKAP,L,ISORT,ISPIN)=0.D0
	FPFP(IKAP,IKAP,L,ISORT,ISPIN)=FPMN(L)
	DO JKAP=1,IKAP-1                                  !!! over jkap
	IF(ABS(ENY(L,ISORT,IKAP,IPAN,ISPIN)-
     &       ENY(L,ISORT,JKAP,IPAN,ISPIN)).LE.1.D-05)THEN
	FF(IKAP,JKAP,L,ISORT,ISPIN)=1.D0
	FFP(IKAP,JKAP,L,ISORT,ISPIN)=0.D0
	FPF(IKAP,JKAP,L,ISORT,ISPIN)=0.D0
	FPFP(IKAP,JKAP,L,ISORT,ISPIN)=FPMN(L)
	ELSE
C Integrals expressed via Wronskians
	E1=1.D0/(ENY(L,ISORT,IKAP,IPAN,ISPIN)-
     &         ENY(L,ISORT,JKAP,IPAN,ISPIN))
	WFF=SMT(ISORT)*AFIS(L,IKAP)*AFIS(L,JKAP)*
     &(DNY(L,ISORT,JKAP,IPAN,ISPIN)-DNY(L,ISORT,IKAP,IPAN,ISPIN))
	WFFP=SMT(ISORT)*AFIS(L,IKAP)*AFIPS(L,JKAP)*
     &(DNYP(L,JKAP)-DNY(L,ISORT,IKAP,IPAN,ISPIN))
	WFPF=SMT(ISORT)*AFIPS(L,IKAP)*AFIS(L,JKAP)*
     &(DNY(L,ISORT,JKAP,IPAN,ISPIN)-DNYP(L,IKAP))
	WFPFP=SMT(ISORT)*AFIPS(L,IKAP)*AFIPS(L,JKAP)*
     &(DNYP(L,JKAP)-DNYP(L,IKAP))
	FF(IKAP,JKAP,L,ISORT,ISPIN)=E1*WFF
	FFP(IKAP,JKAP,L,ISORT,ISPIN)=E1*(WFFP+
     &FF(IKAP,JKAP,L,ISORT,ISPIN))
	FPF(IKAP,JKAP,L,ISORT,ISPIN)=E1*(WFPF-
     &FF(IKAP,JKAP,L,ISORT,ISPIN))
	FPFP(IKAP,JKAP,L,ISORT,ISPIN)=E1*(WFPFP+
     &FPF(IKAP,JKAP,L,ISORT,ISPIN)-
     &FFP(IKAP,JKAP,L,ISORT,ISPIN))
C Override with numerical integrals
C 1) <PHI|PHI>
	WORK1(0)=(0.D0,0.D0)
	DO IRAD=1,NRAD(ISORT)          !!! over radial mesh
	WORK1(IRAD)=
     &AFI(IRAD,L,IKAP,ISPIN)*AFI(IRAD,L,JKAP,ISPIN)*
     &R(IRAD,ISORT)**2*DR(IRAD,ISORT)
      ENDDO                          !!! over radial mesh
	CALL LIB_QD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	FF(IKAP,JKAP,L,ISORT,ISPIN)=WORK2(NRAD(ISORT))
C 2) <PHI|PHI-DOT>
	WORK1(0)=(0.D0,0.D0)
	DO IRAD=1,NRAD(ISORT)          !!! over radial mesh
	WORK1(IRAD)=
     &AFI(IRAD,L,IKAP,ISPIN)*AFIP(IRAD,L,JKAP,ISPIN)*
     &R(IRAD,ISORT)**2*DR(IRAD,ISORT)
      ENDDO                          !!! over radial mesh
	CALL LIB_QD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	FFP(IKAP,JKAP,L,ISORT,ISPIN)=
     &WORK2(NRAD(ISORT))
C 3) <PHI-DOT|PHI> diagonal
	WORK1(0)=(0.D0,0.D0)
	DO IRAD=1,NRAD(ISORT)          !!! over radial mesh
	WORK1(IRAD)=
     &AFIP(IRAD,L,IKAP,ISPIN)*AFI(IRAD,L,JKAP,ISPIN)*
     &R(IRAD,ISORT)**2*DR(IRAD,ISORT)
      ENDDO                          !!! over radial mesh
	CALL LIB_QD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	FPF(IKAP,JKAP,L,ISORT,ISPIN)=
     &WORK2(NRAD(ISORT))
C 4) <PHI-DOT|PHI-DOT> diagonal
	WORK1(0)=(0.D0,0.D0)
	DO IRAD=1,NRAD(ISORT)          !!! over radial mesh
	WORK1(IRAD)=
     &AFIP(IRAD,L,IKAP,ISPIN)*AFIP(IRAD,L,JKAP,ISPIN)*
     &R(IRAD,ISORT)**2*DR(IRAD,ISORT)
      ENDDO                          !!! over radial mesh
	CALL LIB_QD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	FPFP(IKAP,JKAP,L,ISORT,ISPIN)=
     &WORK2(NRAD(ISORT))
	ENDIF
	FF(JKAP,IKAP,L,ISORT,ISPIN)=FF(IKAP,JKAP,L,ISORT,ISPIN)
	FFP(JKAP,IKAP,L,ISORT,ISPIN)=FPF(IKAP,JKAP,L,ISORT,ISPIN)
	FPF(JKAP,IKAP,L,ISORT,ISPIN)=FFP(IKAP,JKAP,L,ISORT,ISPIN)
	FPFP(JKAP,IKAP,L,ISORT,ISPIN)=FPFP(IKAP,JKAP,L,ISORT,ISPIN)
      ENDDO                                                   !!! over jkap
      ENDDO                                                   !!! over ikap
      ENDDO                                                   !!! over l
      ENDDO                                                   !!! over isort
      ENDDO                                                   !!! over ispin
C MEMORY DEALLOCATIONS
	DEALLOCATE(AFIS,AFIPS,DNYP,FPMN,HAN,BES)
	DEALLOCATE(AFI,AFID,AFIP,AFIDP,AFIDDS,AFIDDPS,WORK1,WORK2)
1010  FORMAT(1X,'Dnu mismatch :','Enu=',G14.7,' Dnu=',G14.7,' DHlog=',
     &G14.7,' in ',I2,1X,I2,1X,I2,1X,I2,1X,I2)
	END
