	SUBROUTINE ENSEARCH(X1,Y0,X0,ISORT,L,ISPIN)
*************************************************************
*  Searchs for Eny value by iterative procedure.            *
*************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_PARAM  ,ONLY: NATOM,NSORT,NSPIN,IS,ILST,LRTV    !!! from readini
      USE COM_SPHERE ,ONLY: SMT                               !!! from readini
      USE COM_POTDAT ,ONLY: POTRWF                            !!! from potfull
      USE COM_RADMESH,ONLY: NRAD,H,R,DR                       !!! from radmesh
	USE COM_UNIT   ,ONLY: IUN,IUR,IUT                       !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	LOGICAL LEFT,RIGHT
C SET ITERATIVE PROCEDURE LIMITS
      DATA ITMAX/100/      ! max. number of iterations in search eny
      DATA EPS/1.D-10/     ! accuracy in search eny
      DATA STEP/0.5D0/     ! init. step in search of eny
C INITIATION
	ITER=1
	H1=1.D0/STEP
	X=X1
	LEFT=.FALSE.
	RIGHT=.FALSE.
C  BEGIN ITERATION LOOP
1     CALL LIB_RADSCH_TNYS(X,Y,DY,L,SMT(ISORT),POTRWF(0,ISORT,ISPIN),
     &NRAD(ISORT),H(ISORT),R(0,ISORT),DR(0,ISORT),LRTV(ISORT))
C	DY=DY/DX
	YY=Y-Y0
C	WRITE(IUT,*)'ITER,X,YY',ITER,X,YY  !!!DEBUGGING
	CALL SLTRT(X,YY,DY,XL,YYL,DYL,LEFT,XR,YYR,DYR,RIGHT)
	IF(.NOT.LEFT.OR..NOT.RIGHT) THEN
C	THE NEWTON'S METHOD.
	IF(DY.LE.ABS(YY*H1)) X=X-SIGN(STEP,YY)
C	WITH LIMITATION
	IF(DY.GT.ABS(YY*H1)) X=X-YY/DY
C	WITHOUT LIMITATION
	ELSE IF(LEFT.AND.RIGHT) THEN
C  PARABOLA METHOD.
	DELTX=XR-XL
	IF(ABS(DELTX).LE.EPS)GOTO 2
	DYS=(YYR-YYL)/DELTX
	IF(ABS(YYL).LE.YYR) THEN
	  ALFA=ABS(YYL/DELTX)
	  IF(ALFA.LE.DYL) THEN
	    A=ALFA/DYL
	    B=DYS/DYL
	    X=XL+DELTX*F1(A,B)
	  ELSE
	    C=DYL/ALFA
	    D=DYS/ALFA
	    X=XL+DELTX*F2(C,D)
	  END IF
	  ELSE
	  BETA=YYR/DELTX
	  IF(BETA.LE.DYR) THEN
	    A=BETA/DYR
	    B=DYS/DYR
	    X=XR-DELTX*F1(A,B)
	  ELSE
	    C=DYR/BETA
	    D=DYS/BETA
	    X=XR-DELTX*F2(C,D)
	  END IF
	  END IF
	END IF
C  EXITS
	IF(ITER.GE.ITMAX)THEN
	WRITE(IUT,*)' THE EXCEEDING OF ITMAX IN ENSEARCH'
	WRITE(IUT,*)' DELTA_ENY=',DELTX
	GOTO 2
	ENDIF
	IF(ABS(YY).LE.EPS) GO TO 2
	ITER=ITER+1
	GO TO 1
C  END LOOPING
2	IF(ITER.NE.1)THEN
	X0=X
	ELSE
	X0=X1
	ENDIF
	RETURN
C INTERNAL PROCEDURES

	CONTAINS
	
	FUNCTION F1(A,B)
	IMPLICIT REAL*8 (A-H,O-Z)
	F1=2.D0*A/(1.D0+SQRT(1.D0+4.D0*A*(B-1.D0)))
	END FUNCTION F1
	FUNCTION F2(C,D)
	IMPLICIT REAL*8 (A-H,O-Z)
	F2=2.D0/(C+SQRT(C*C+4.D0*(D-C)))
	END FUNCTION F2
	
      SUBROUTINE SLTRT(X,YY,DY,XL,YYL,DYL,LEFT,XR,YYR,DYR,RIGHT)
*************************************************************
*  Classifies X into left and right points.                 *
*************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      LOGICAL LEFT,RIGHT
      IF(YY.LE.0.D0) THEN
        XL=X
        YYL=YY
        DYL=DY
        LEFT=.TRUE.
      ELSE
        XR=X
        YYR=YY
        DYR=DY
        RIGHT=.TRUE.
      END IF
      RETURN
      END SUBROUTINE SLTRT
	END SUBROUTINE ENSEARCH

