	SUBROUTINE BND_SETENY(IPAN)
****************************************************************
*  Subroutine  finds optimal energy centers of linearization.  *
****************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,IS,ILST,ILSB,LRTV    !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP                         !!! from readini
      USE COM_PANPAR  ,ONLY: LSPAN,LTPAN,IATS,ISTS                  !!! from readini
      USE COM_SPHERE  ,ONLY: SMT                                    !!! from readini
      USE COM_POTDAT  ,ONLY: POTRWF                                 !!! from potfull
      USE COM_INPPAR  ,ONLY: ENY,TNY,DNY,MNY,NODES,DHLOG,LNY        !!! from readini
      USE COM_RADMESH ,ONLY: NRAD,H,R,DR                            !!! from radmesh
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT                            !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER, ALLOCATABLE :: INC(:)
	REAL*8, ALLOCATABLE :: APHI(:)
	REAL*8, ALLOCATABLE :: APHID(:)
	DATA PI/3.141592653589793D0/
      CALL ABORTNOW()
	IF(IPAN.NE.1)RETURN
C MEMORY ALLOCATIONS
	ALLOCATE(INC(NKAPMEM))
	ALLOCATE(APHI(0:NRADMEM))
	ALLOCATE(APHID(0:NRADMEM))
	DO 2000 ISPIN=1,NSPIN                                !!! over ispin
	DO 1000 ISORT=1,NSORT                                !!! over isort
	DO IKAP=1,NKAP(IPAN)                                 !!! over ikap
	DO L=0,ILSB(ISORT)                                   !!! over l
	IF(MNY(L,ISORT,IKAP,IPAN).EQ.1.OR.
     &   MNY(L,ISORT,IKAP,IPAN).EQ.3)THEN
C  TRANSFERE TO CONVINIET FUNCTION TNY DEPENDING ON DNY AND # OF NODES
	TNY(L,ISORT,IKAP,IPAN,ISPIN)=0.5D0+NODES(L,ISORT,IKAP,IPAN)-
     &ATAN(DNY(L,ISORT,IKAP,IPAN,ISPIN))/PI
C  FIND ENY-ENERGY
	CALL ENSEARCH(ENY(L,ISORT,IKAP,IPAN,ISPIN),
     &TNY(L,ISORT,IKAP,IPAN,ISPIN),ENY(L,ISORT,IKAP,IPAN,ISPIN),
     &ISORT,L+1,ISPIN)
	ELSEIF(MNY(L,ISORT,IKAP,IPAN).EQ.2)THEN
C  FIND BINDING ENERGY E FOR GIVEN VALENCE STATE
      CALL LIB_CORSCH_ENYS(ENY(L,ISORT,IKAP,IPAN,ISPIN),NODES(L,
     &ISORT,IKAP,IPAN),L,-1,DLOG,SMT(ISORT),POTRWF(0,ISORT,
     &ISPIN),APHI(0),APHID(0),NRAD(ISORT),H(ISORT),
     &R(0,ISORT),DR(0,ISORT),LRTV(ISORT))
	DHLOG(L,ISORT,IKAP,IPAN,ISPIN)=DLOG
	ENDIF
      ENDDO                                                !!! over l
      ENDDO                                                !!! over ikap
	DO 500 L=0,ILSB(ISORT)                               !!! over l
C  SORT ENY IN INCREASING ORDER
	DO IKAP=1,NKAP(IPAN)
	INC(IKAP)=0
	ENDDO
	DO IKAP=1,NKAP(IPAN)
	IN=1
	DO JKAP=1,NKAP(IPAN)
	IF(ENY(L,ISORT,IKAP,IPAN,ISPIN).GT.
     &   ENY(L,ISORT,JKAP,IPAN,ISPIN))IN=IN+1
	ENDDO
	DO II=IN,NKAP(IPAN)
	IF(INC(II).EQ.0)THEN
	INC(II)=IKAP
	EXIT
	ENDIF
	ENDDO
	ENDDO
C  CHECK ENERGY DISTANCES BETWEEN ENY 
	DO IKAP=1,NKAP(IPAN)
	DO JKAP=IKAP+1,NKAP(IPAN)
	DIFF=ENY(L,ISORT,INC(JKAP),IPAN,ISPIN)-
     &ENY(L,ISORT,INC(IKAP),IPAN,ISPIN)
	IF(ABS(DIFF).GE.1.D-10.AND.
     &LNY(L,ISORT,INC(JKAP),IPAN).EQ.
     &LNY(L,ISORT,INC(IKAP),IPAN))THEN
	WRITE(IUT,*)'Warning from <SETENY>:' 
	WRITE(IUT,*)'Enus for the same class of orbitals differ!'
      WRITE(IUT,*)'L,ISORT,IKAP1,IKAP==',
     &DIFF,L,ISORT,INC(JKAP),INC(IKAP)
      ENY(L,ISORT,INC(JKAP),IPAN,ISPIN)=
     &ENY(L,ISORT,INC(IKAP),IPAN,ISPIN)
	WRITE(IUT,*)'Standard correction will be made.'
	ELSEIF(ABS(DIFF).LT.0.1D0.AND.
     &LNY(L,ISORT,INC(JKAP),IPAN).NE.
     &LNY(L,ISORT,INC(IKAP),IPAN))THEN
 	WRITE(IUT,*)'Warning from <SETENY>:' 
	WRITE(IUT,*)
     &'Difference between Enus in the same class of orbitals'
	WRITE(IUT,*)'is too small; L,ISORT,IKAP1,IKAP=',
     &DIFF,L,ISORT,INC(JKAP),INC(IKAP)
      ENY(L,ISORT,INC(JKAP),IPAN,ISPIN)=
     &ENY(L,ISORT,INC(IKAP),IPAN,ISPIN)+0.1D0
 	WRITE(IUT,*)'Standard correction will be made.'
	ENDIF
      ENDDO   
      ENDDO    
 500  CONTINUE                                             !!! over l
1000  CONTINUE                                             !!! over isort
2000	CONTINUE                                             !!! over ispin
C MEMORY DEALLOCATIONS
	DEALLOCATE(INC)
	DEALLOCATE(APHI)
	DEALLOCATE(APHID)
	END





	SUBROUTINE BND_KKRPAR(IPAN)
****************************************************************
*  Subroutine  finds KKR-position of band center and effective *
*  band width.                                                 * 
****************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,IS,ILST,ILSB,LRTV    !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP                         !!! from readini
      USE COM_PANPAR  ,ONLY: LSPAN,LTPAN,IATS,ISTS                  !!! from readini
      USE COM_SPHERE  ,ONLY: SMT,SASA,SWZ                           !!! from readini
      USE COM_POTDAT  ,ONLY: POTRWF                                 !!! from potfull
      USE COM_INPPAR  ,ONLY: ENY,TNY,DNY,MNY,NODES                  !!! from readini
      USE COM_KKRPAR  ,ONLY: CNY,WNY,VNY                            !!! from kkrpar
      USE COM_RADMESH ,ONLY: NRAD,H,R,DR                            !!! from radmesh
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT                            !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8, ALLOCATABLE :: AFIS(:)
	REAL*8, ALLOCATABLE :: AFIPS(:)
	REAL*8, ALLOCATABLE :: DNYCEN(:)
	REAL*8, ALLOCATABLE :: TNYCEN(:)
	REAL*8, ALLOCATABLE :: DNYP(:)
	REAL*8, ALLOCATABLE :: FPMN(:)
	DATA PI/3.141592653589793D0/
C MEMORY ALLOCATIONS FOR MAIN CONTROL ARRAYS
	IF(.NOT.ALLOCATED(CNY))
     &ALLOCATE(CNY(0:LMAXTMEM,NSORTMEM,NKAPMEM,NPANMEM,NSPINMEM))
	IF(.NOT.ALLOCATED(WNY))
     &ALLOCATE(WNY(0:LMAXTMEM,NSORTMEM,NKAPMEM,NPANMEM,NSPINMEM))
	IF(.NOT.ALLOCATED(VNY))
     &ALLOCATE(VNY(0:LMAXTMEM,NSORTMEM,NKAPMEM,NPANMEM,NSPINMEM))
C MEMORY ALLOCATIONS
	ALLOCATE(AFIS(0:LMAXTMEM))
	ALLOCATE(AFIPS(0:LMAXTMEM))
	ALLOCATE(DNYCEN(0:LMAXTMEM))
	ALLOCATE(TNYCEN(0:LMAXTMEM))
	ALLOCATE(DNYP(0:LMAXTMEM))
	ALLOCATE(FPMN(0:LMAXTMEM))
C START CODE
	DO ISPIN=1,NSPIN                                     !!! over ispin
	DO ISORT=1,NSORT                                     !!! over isort
	DO IKAP=1,NKAP(IPAN)                                 !!! over ikap
C  FIND PARAMETERS FOR THE CHOICE D=-L-1
	DO L=0,ILST(ISORT)                                   !!! over l
	IF(LSPAN(L,ISORT,IKAP,IPAN))THEN
C  FIND KKR-BAND CENTER
	TNYCEN(L)=0.5D0+NODES(L,ISORT,IKAP,IPAN)-ATAN(DBLE(-L-1))/PI
	CALL ENSEARCH(ENY(L,ISORT,IKAP,IPAN,ISPIN),TNYCEN(L),
     &CNY(L,ISORT,IKAP,IPAN,ISPIN),ISORT,L+1,ISPIN)
	ELSE
	CNY(L,ISORT,IKAP,IPAN,ISPIN)=ENY(L,ISORT,IKAP,IPAN,ISPIN)
	ENDIF
      ENDDO                                                !!! over l
C  SOLVE SCHROEDINGER'S EQUATION FOR THE CNY
      CALL LIB_RADSCH_PARS(CNY(0,ISORT,IKAP,IPAN,ISPIN),AFIS(0),
     &AFIPS(0),DNYCEN(0),TNYCEN(0),DNYP(0),FPMN(0),SMT(ISORT),
     &POTRWF(0,ISORT,ISPIN),ILST(ISORT),NRAD(ISORT),
     &H(ISORT),R(0,ISORT),DR(0,ISORT),LRTV(ISORT))
C  ESTIMATE HALF OF BAND WIDTH
	DO L=0,ILSB(ISORT)                                   !!! over l
	IF(LSPAN(L,ISORT,IKAP,IPAN))THEN
	IF(ABS(DNYCEN(L)+DBLE(L+1)).GE.1.D-08)THEN
	WRITE(IUT,*)'Warning from <KKRPAR>:'
	WRITE(IUT,*)'Lost of accuracy detected. The error is'
	WRITE(IUT,*) DNYCEN(L)+DBLE(L+1)
	ENDIF
	IF(L.NE.0)
     &WNY(L,ISORT,IKAP,IPAN,ISPIN)=SMT(ISORT)*AFIS(L)**2/2.D0
     &*(SASA(ISORT)/SWZ)**(2*L+1)*DBLE(2*L+1)**2/DBLE(L)
	ENDIF
      ENDDO                                                !!! over l
C  FIND PARAMETERS FOR THE CHOICE D=L
	DO L=0,ILST(ISORT)                                   !!! over l
	IF(LSPAN(L,ISORT,IKAP,IPAN))THEN
C  FIND KKR-BAND EDGE
	TNYCEN(L)=0.5D0+NODES(L,ISORT,IKAP,IPAN)-ATAN(DBLE(L))/PI
	CALL ENSEARCH(ENY(L,ISORT,IKAP,IPAN,ISPIN),TNYCEN(L),
     &VNY(L,ISORT,IKAP,IPAN,ISPIN),ISORT,L+1,ISPIN)
	ELSE
	VNY(L,ISORT,IKAP,IPAN,ISPIN)=ENY(L,ISORT,IKAP,IPAN,ISPIN)
	ENDIF
      ENDDO                                                !!! over l
C  SOLVE SCHROEDINGER'S EQUATION FOR THE VNY
      CALL LIB_RADSCH_PARS(VNY(0,ISORT,IKAP,IPAN,ISPIN),AFIS(0),
     &AFIPS(0),DNYCEN(0),TNYCEN(0),DNYP(0),FPMN(0),SMT(ISORT),
     &POTRWF(0,ISORT,ISPIN),ILST(ISORT),NRAD(ISORT),
     &H(ISORT),R(0,ISORT),DR(0,ISORT),LRTV(ISORT))
C  ESTIMATE HALF OF BAND WIDTH FOR L=0
	DO L=0,ILSB(ISORT)                                   !!! over l
	IF(LSPAN(L,ISORT,IKAP,IPAN))THEN
	IF(ABS(DNYCEN(L)-DBLE(L)).GE.1.D-08)THEN
	WRITE(IUT,*)'Warning from <KKRPAR>:'
	WRITE(IUT,*)'Lost of accuracy detected. The error is'
	WRITE(IUT,*) DNYCEN(L)-DBLE(L)
	ENDIF
	TS21=SMT(ISORT)*AFIS(L)**2/DBLE(2*L+3)
	GAM1=DBLE(2*(2*L+1))*(1.D0-DBLE(2*L+1)*SMT(ISORT)*AFIS(L)*
     &AFIPS(L))
	IF(L.EQ.0)
     &WNY(L,ISORT,IKAP,IPAN,ISPIN)=TS21*6.D0/(GAM1-2.D0)*
     &(SASA(ISORT)/SWZ)**(2*L+1)
	ENDIF
      ENDDO                                                !!! over l
      ENDDO                                                !!! over ikap
      ENDDO                                                !!! over isort
      ENDDO                                                !!! over ispin
C MEMORY DEALLOCATIONS
	DEALLOCATE(AFIS)
	DEALLOCATE(AFIPS)
	DEALLOCATE(DNYCEN)
	DEALLOCATE(TNYCEN)
	DEALLOCATE(DNYP)
	DEALLOCATE(FPMN)
	END
