	SUBROUTINE BND_SETFAT
******************************************************
*   Stores Fat Bands                                 *
******************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                          !!! from setup
      USE COM_CONTROL ,ONLY: LIFT,LMTO,IASA,LRWF,NPFR         !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS       !!! from readini
     &                      ,ILST,ILSB,ILSV,LRTV,NHSORT
      USE COM_LATPAR  ,ONLY: PAR,ORTH,OMEGAC,STRAIN           !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP                   !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN,IATS,ISTS            !!! from readini
      USE COM_SPHERE  ,ONLY: SMT,SWZ                          !!! from readini
      USE COM_INPPAR  ,ONLY: ENY,DNY,TNY,NODES,MNY            !!! from readini
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC          !!! from readini
      USE COM_INPTTR  ,ONLY: NDIV,NDIC,NDIR,NDIVDIR,HSPNT,PNTNOT! from readstr
      USE COM_KMESH   ,ONLY: NPNT,PNT                         !!! from tetra
      USE COM_FERMI   ,ONLY: EF                               !!! from ttrints
      USE COM_ENERGY  ,ONLY: EARR                             !!! from bands
      USE COM_LABELS  ,ONLY: TXTAT,TXTEL,TXTSP                !!! from readini
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT,IUI                  !!! from setup
      USE COM_CHANNELS,ONLY: IUAIN,IUDOS,IUCHI                !!! from channels
      USE COM_MASHDEP ,ONLY: NVAL,LENCMP                      !!! from setup
      USE COM_LMTOUT                                          !!! from readini
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER, ALLOCATABLE :: ILMTBAS(:,:)
	INTEGER, ALLOCATABLE :: INODBAS(:,:)
	REAL*8, ALLOCATABLE :: HSPNTW(:,:,:)
      COMPLEX*16, ALLOCATABLE :: TLMM(:,:,:,:,:)
      COMPLEX*16, ALLOCATABLE :: TLMS(:,:,:)
      COMPLEX*16, ALLOCATABLE :: TLMT(:,:,:)
	LOGICAL EXIST,OPEN
	CHARACTER HELP*40

	! Variables added by Gunnar Palsson

	integer :: idiv

	real*8, allocatable :: pathLengths(:)
	real*8, allocatable :: pathSteps(:)

	! End of additions

	
	IF(ICFAT.LE.0)RETURN
	INQUIRE(FILE=SCRFILE(IUDOS),EXIST=EXIST,OPENED=OPEN)
	IF(.NOT.EXIST)CALL FULLSTOP('File does not exist')
	IF(OPEN)CLOSE(IUDOS,STATUS='KEEP')
	OPEN(IUDOS,FILE=SCRFILE(IUDOS),STATUS='OLD',FORM='UNFORMATTED')
C *******************************************************
	INQUIRE(FILE=FATFILE,EXIST=EXIST)
	IF(EXIST)THEN
      OPEN(UNIT=IUAIN,FILE=FATFILE,STATUS='OLD',FORM='FORMATTED')
	CLOSE(UNIT=IUAIN,STATUS='DELETE')
	ENDIF
C STORE HEADER INFO.
	OPEN(UNIT=IUAIN,FILE=FATFILE,STATUS='NEW',FORM='FORMATTED')
	WRITE(IUAIN,10010)
	WRITE(IUAIN,10020)
10010	FORMAT(1X,'<FILE=FATFILE,INPUT=MODERN>')
10020 FORMAT('****************************************************')
	WRITE(IUAIN,10030)
10030 FORMAT(1X,'<SECTION=CTRL>               ! CONTROL PARAMETERS:')
	HELP='! # of divisions                       '
	WRITE(IUAIN,10070)NDIVDIR,HELP
10070 FORMAT(1X,'nDivDir=',I3,1X,18X,A40)
      WRITE(IUAIN,10110)
10110 FORMAT(1X,'<SECTION=DIRS>               ! HIGH-SYMMETRY LINES:')
      WRITE(IUAIN,10120)NDIR
10120 FORMAT(1X,'       ',I3,15X,' ! # of directions in BZ')
	ALLOCATE(HSPNTW(3,2,NDIR))
      DO IDIR=1,NDIR
      DO IVEC=1,2
      DO I=1,3
      HSPNTW(I,IVEC,IDIR)=0.D0
      DO J=1,3
      HSPNTW(I,IVEC,IDIR)=HSPNTW(I,IVEC,IDIR)+
     &HSPNT (J,IVEC,IDIR)*STRAIN(J,I,1)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
      DO I=2,3
      DO IVEC=1,2
      DO IDIR=1,NDIR
      HSPNTW(I,IVEC,IDIR)=HSPNTW(I,IVEC,IDIR)*ORTH(I)
	ENDDO
	ENDDO
	ENDDO
      DO IDIR=1,NDIR
      WRITE(IUAIN,10130)(PNTNOT(K,IDIR),K=1,2)
      WRITE(IUAIN,10140)(HSPNTW(J,1,IDIR),J=1,3),
     &                  (HSPNTW(J,2,IDIR),J=1,3)
	ENDDO
10130 FORMAT(1X,A1,'-',A1)
10140 FORMAT(1X,G12.5,',',G12.5,',',G12.5,',',
     &       5X,G12.5,',',G12.5,',',G12.5)
C	DEALLOCATE(HSPNTW)
C STORE FAT BANDS DATA
	WRITE(IUAIN,10210)
10210 FORMAT(1X,'<SECTION=DATA>              ! FAT BANDS DATA:')
      WRITE(IUAIN,*)NATOM,NSORT,NSPIN,NORBS,(IS(IATOM),IATOM=1,NATOM),
     &(ILSB(ISORT),ISORT=1,NSORT),(NHSORT(ISORT),ISORT=1,NSORT),
     &NKAP(1),NBNDF(1),NBNDE(1),NBNDT(1),NPNT(1),NDIR,NDIVDIR,EF
      WRITE(IUAIN,FMT='(5A10)')(TXTAT(ISORT),ISORT=1,NSORT)
	WRITE(IUAIN,FMT='(20A2)')((PNTNOT(INOT,IDIR),INOT=1,2),
     &IDIR=1,NDIR)
C Store basis set
	ALLOCATE(ILMTBAS(0:LMAXBMEM,NATOMMEM))
	ALLOCATE(INODBAS(0:LMAXBMEM,NATOMMEM))
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	DO L=0,ILSB(IS(IATOM))
	ILMTBAS(L,IATOM)=0
	INODBAS(L,IATOM)=0
	DO IKAP=1,NKAP(1)
	IF(LTPAN(L,IATOM,IKAP,1))ILMTBAS(L,IATOM)=1
	IF(LTPAN(L,IATOM,IKAP,1))INODBAS(L,IATOM)=
     &NODES(L,ISORT,IKAP,1)+L+1
	ENDDO
	ENDDO
	ENDDO


	! Code added by Gunnar Palsson, Thu Feb 22 16:06:01 EST 2001

	allocate( pathLengths(0:ndir) )
	allocate( pathSteps(0:ndir*(nDivDir+1)) )

	pathLengths(0) = 0.d0
	do idir = 1,ndir
	   pathLengths(idir) = sqrt(
     &                  (HSPNTW(1,1,idir)-HSPNTW(1,2,idir))**2
     &                + (HSPNTW(2,1,idir)-HSPNTW(2,2,idir))**2
     &                + (HSPNTW(3,1,idir)-HSPNTW(3,2,idir))**2 )
	   pathLengths(0) = pathLengths(0)+pathLengths(idir)
	enddo
	pathLengths(:) = pathLengths(:)/(pathLengths(0)*nDivDir)

	pathSteps(0) = 0.d0
	ipnt = 0
	do idir = 1,ndir
	   pathSteps(0) = pathSteps(ipnt)
	   do idiv = 0,nDivDir
	      ipnt = (idir-1)*nDivDir+idiv+idir
	      pathSteps(ipnt) = pathSteps(0)+idiv*pathLengths(idir)
	   enddo
	enddo

	open(7919,file="bandsFile.dat")

	write(7919,'("# Number of points     :",i4)') NPNT(1)
	write(7919,'("# Number of bands      :",i4)') NBNDT(1)
	write(7919,'("# Number of directions :",i4)') ndir
	write(7919,'("# Number of divisions  :",i4)') ndivdir
	write(7919,'("# ",26("="))')
	do idir = 1,ndir
	   write(7919,fmt='("# Direction #",i3," : ")',advance='no') idir
	   write(7919,'(A1," to ",A1)') PNTNOT(1,IDIR),PNTNOT(2,IDIR)
	enddo
	do idir = 1,ndir
	   write(7919,fmt='("# Pathlength #",i3," : ")',advance='no') idir
	   write(7919,'(e18.10)') pathLengths(idir)*nDivDir
	enddo
	write(7919,'("# ",26("="))')
	
	do iband = 1,NBNDT(1)
	   write(7919,*)
	   write(7919,'("# Band #",i4)') iband
	   do ipnt = 1,NPNT(1)
	      !if(MOD(ipnt,nDivDir+1).eq.1.and.ipnt.ne.1) cycle
	      write(7919,'(i4,2e18.10)') 
     &        ipnt,pathSteps(ipnt),earr(iband,ipnt,1)
	   enddo
	enddo

	DEALLOCATE(HSPNTW)          ! Moved from previous location
	DEALLOCATE( pathLengths )
	DEALLOCATE( pathSteps )

	! End of added code


	
	WRITE(IUAIN,*)((ILMTBAS(L,IATOM),L=0,ILSB(IS(IATOM))),
     &IATOM=1,NATOM)
	WRITE(IUAIN,*)((INODBAS(L,IATOM),L=0,ILSB(IS(IATOM))),
     &IATOM=1,NATOM)
C Store fat bands and characters
      ALLOCATE(TLMM(LIMB2MEM,NATOMMEM,NSPINMEM,NBNDT(1),NSPINMEM))
	DO IPNT=1,NPNT(1)           !!! over k-points
	WRITE(IUAIN,*)(PNT(I,IPNT,1),I=1,3),
     &(EARR(IBAND,IPNT,1),IBAND=1,NBNDT(1)*NSPIN)
      DO IORBS=1,NORBS
      DO IATOM=1,NATOM
      ISORT=IS(IATOM)
      DO L=0,ILSB(ISORT)
      LMS=L*(2*L-1)*(2*L+1)/3+1
      LME=LMS+(2*L+1)**2-1
      IF(ILMTBAS(L,IATOM).EQ.0)CYCLE
      READ(IUDOS)(((TLMM(LM1M,IATOM,IORBS,IBNDT,IBNDS),
     &LM1M=LMS,LME),IBNDT=1,NBNDT(1)),IBNDS=1,NSPIN)
      WRITE(IUAIN,*)(((TLMM(LM1M,IATOM,IORBS,IBNDT,IBNDS),
     &LM1M=LMS,LME),IBNDT=1,NBNDT(1)),IBNDS=1,NSPIN)
      ENDDO
      ENDDO
      ENDDO
	ENDDO                       !!! over k-points
	CLOSE(IUAIN)
	CLOSE(IUDOS)
	DEALLOCATE(TLMM)
	DEALLOCATE(ILMTBAS,INODBAS)
	END SUBROUTINE BND_SETFAT
