	SUBROUTINE BND_SUMSUB(ASUM,IBNDT,IBNDS,IORBS,IPNT,IPAN)
**********************************************************
* Program calculates tl-characters of wave functions.    *
**********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS 
     &                      ,IS,ILST,ILSB,NHSORT               !!! from readini
      USE COM_LATPAR  ,ONLY: PAR,OMEGAC                        !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP                    !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN,IATS,ISTS             !!! from readini
      USE COM_SPHERE  ,ONLY: SMT                               !!! from readini
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC           !!! from readini
      USE COM_LMTPAR  ,ONLY: GAM,AAH,BBH,AAJ,BBJ               !!! from potpar
	USE COM_LMTVEC  ,ONLY: APHR,APSR,APJR                    !!! from lmtbnd
      USE COM_SUMPAR  ,ONLY: OHH,OJH,OHJ,OJJ                   !!! from ovrpar
	USE COM_CHANNELS,ONLY: IUPSI                             !!! from readini
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT                       !!! from setup
      USE COM_KMESH   ,ONLY: NPNT,PNT                          !!! from tetra
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: APH(:,:,:)
	COMPLEX*16, ALLOCATABLE :: APS(:,:,:)
	COMPLEX*16, ALLOCATABLE :: APJ(:,:,:)
	COMPLEX*16 AHH,AHJ,AJH,AJJ
     &   ,ASUM(0:LMAXTMEM,NSORTMEM,NKAPMEM,NKAPMEM)
	LOGICAL LOG
C START CODE
      IF(NORBS.EQ.1)ISPIN=IBNDS
      IF(NORBS.EQ.2)ISPIN=IORBS
      IBAND=IBNDS+NSPIN*(IBNDT-1)
	ANORM=0.D0
C AVERAGING OVER ALL ATOMS OF THIS SORT AND OVER ALL M FOR THIS L
	ANORM=0.D0
	DO IKAP1=1,NKAP(IPAN)                                 !!! over energies
	DO IKAP=1,NKAP(IPAN)                                  !!! over energies
	DO ISORT=1,NSORT                                      !!! over isort
	DO L=0,ILST(ISORT)                                    !!! over l
	AHH=(0.D0,0.D0)
	AHJ=(0.D0,0.D0)
	AJH=(0.D0,0.D0)
	AJJ=(0.D0,0.D0)
	DO IATOM=1,NATOM                                      !!! over atoms
	IF(ISORT.EQ.IS(IATOM))THEN
	DO M=-L,L                                             !!! over m
	LM=L*(L+1)+M+1
	IF(LSPAN(L,ISORT,IKAP1,IPAN).AND.LSPAN(L,ISORT,IKAP,IPAN))
     &AHH=AHH+CONJG(APHR(LM,IATOM,IKAP1,ISPIN,IBAND))*
     &APHR(LM,IATOM,IKAP,ISPIN,IBAND)*
     &OHH(IKAP1,IKAP,L,ISORT,IPAN,ISPIN,1)
	IF(LSPAN(L,ISORT,IKAP,IPAN))
     &AJH=AJH-CONJG(APJR(LM,IATOM,IKAP1,ISPIN,IBAND))*
     &APHR(LM,IATOM,IKAP,ISPIN,IBAND)*
     &OJH(IKAP1,IKAP,L,ISORT,IPAN,ISPIN,1)
	IF(LSPAN(L,ISORT,IKAP1,IPAN))
     &AHJ=AHJ-CONJG(APHR(LM,IATOM,IKAP1,ISPIN,IBAND))*
     &APJR(LM,IATOM,IKAP,ISPIN,IBAND)*
     &OHJ(IKAP1,IKAP,L,ISORT,IPAN,ISPIN,1)
	AJJ=AJJ+CONJG(APJR(LM,IATOM,IKAP1,ISPIN,IBAND))*
     &APJR(LM,IATOM,IKAP,ISPIN,IBAND)*
     &OJJ(IKAP1,IKAP,L,ISORT,IPAN,ISPIN,1)
      ENDDO                                                 !!! over m
	ENDIF
      ENDDO                                                 !!! over atoms
	ASUM(L,ISORT,IKAP1,IKAP)=(AHH+AHJ+AJH+AJJ)/DBLE(NHSORT(ISORT))
	ANORM=ANORM+ASUM(L,ISORT,IKAP1,IKAP)*DBLE(NHSORT(ISORT))
      ENDDO                                                 !!! over l
      ENDDO                                                 !!! over isort
      ENDDO                                                 !!! over ikap
      ENDDO                                                 !!! over ikap1
C NORMALIZATION
C Set normalization to unity in all cases
C	IF(ABS(ANORM).LE.1.D-10)ANORM=1.D0
	ANORM=1.D0
	DO IKAP1=1,NKAP(IPAN)                                 !!! over energies
	DO IKAP=1,NKAP(IPAN)                                  !!! over energies
	DO ISORT=1,NSORT                                      !!! over isort
	DO L=0,ILST(ISORT)                                    !!! over l
C	ASUM(L,ISORT,IKAP1,IKAP)=ASUM(L,ISORT,IKAP1,IKAP)/ANORM
      ENDDO                                                 !!! over l
      ENDDO                                                 !!! over isort
      ENDDO                                                 !!! over ikap
      ENDDO                                                 !!! over ikap1
C MEMORY DEALLOCATIONS
	END
