	SUBROUTINE BND_TOSEND(IPAN,ICALL)
***********************************************************
*  Makes final form for the pseudodensity.                *
***********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM
      USE COM_CONTROL ,ONLY: LIFT,LMTO,IASA,IDMF,NPFR         !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS          !!! from readini
     &                      ,IS,ILST,ILSB                     !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP                   !!! from readini
	USE COM_LATPAR  ,ONLY: PAR,OMEGAC                       !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN                      !!! from readini
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC          !!! from readini
      USE COM_LATTICE ,ONLY: TAU                              !!! from readini
      USE COM_DENDAT  ,ONLY: RHOPN                            !!! from rhofull
      USE COM_INDORB  ,ONLY: INDLMT                           !!! from lmtpar
      USE COM_PLWMESH ,ONLY: NPLW,GPLW                        !!! from plwmesh
      USE COM_ETAPAR  ,ONLY: NBAS,LBAS                        !!! from setpar
      USE COM_TEILORG ,ONLY: MBAS,KEYT                        !!! from readini
      USE COM_RINPAR  ,ONLY: RINT0,RFUN                       !!! from tosint
      USE COM_KMESH   ,ONLY: NPNT,PNT,WGT                     !!! from tetra
      USE COM_CHANNELS,ONLY: IUPDS                            !!! from setup
      USE COM_MASHDEP ,ONLY: LENCMP                           !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER, INTRINSIC :: SIZE
      COMPLEX*16, ALLOCATABLE :: YLM(:,:)
      COMPLEX*16, ALLOCATABLE :: CFTR(:,:,:,:)
      COMPLEX*16, ALLOCATABLE :: EXPS(:)
      COMPLEX*16, ALLOCATABLE :: CHIS(:)
      COMPLEX*16, ALLOCATABLE :: CONT(:)
      COMPLEX*16, ALLOCATABLE :: EXPK(:)
      COMPLEX*16, ALLOCATABLE :: CHIK(:)
      COMPLEX*16, ALLOCATABLE :: CHIL(:)
      COMPLEX*16, ALLOCATABLE :: CHIR(:)
	DIMENSION PNTR(3),PNTK(3)
	DATA PI/3.141592653589793D0/
      CALL ABORTNOW()
C RETURN KEYS
	IF(LIFT.LE.2)RETURN
      IF(KEYT.EQ.0)RETURN
	IF(NPLWMEM.EQ.-1)RETURN
	IF(IDMF.GT.2.AND.IPAN.EQ.1.AND.ICALL.EQ.0)RETURN
C MEMORY ALLOCATIONS
      ALLOCATE(YLM(LIMBMEM,0:NBASMEM))
      ALLOCATE(CFTR(0:LMAXBMEM,NSORTMEM,NKAPMEM,0:NBASMEM))
      SIZE_YLM=DBLE(SIZE(YLM)*LENCMP)/1024.D0**2
      SIZE_CFTR=DBLE(SIZE(CFTR)*LENCMP)/1024.D0**2
      ALLOCATE(EXPS(0:NBASMEM))
      ALLOCATE(CHIS(0:NBASMEM))
      ALLOCATE(CONT(0:NBASMEM))
      ALLOCATE(EXPK(0:NBASMEM))
      ALLOCATE(CHIK(0:NBASMEM))
      ALLOCATE(CHIL(0:NBASMEM))
      ALLOCATE(CHIR(0:NBASMEM))
      SIZE_PSIS=7.D0*DBLE(SIZE(EXPS)*LENCMP)/1024.D0**2
      CURMEM=CURMEM+SIZE_YLM+SIZE_CFTR+SIZE_PSIS
      IF(TOTMEM.LT.CURMEM)TXTMEM='<TOSEND> Subroutine'
      IF(TOTMEM.LT.CURMEM)TOTMEM=CURMEM
C START CODE
      PNTK(1)=0.D0
      PNTK(2)=0.D0
      PNTK(3)=0.D0
C SET PSEUDOLMTOS FOR THE POINT IPNTK
      CALL BND_FTRMAT(PNTK,1,IPAN,PNTR,YLM,CFTR)
C DO OVER SPINS
	DO 2000 IORBS=1,NORBS                       !!! over spins
	DO 1000 IUPDN=1,NSPIN                       !!! over spins
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
C READ DENSITY PARAMETERS
      IREC=IUPDN+NSPIN*(IORBS-1)
      READ(IUPDS,REC=IREC)((RINT0(IPAR1,IPAR),IPAR1=1,
     &NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((RFUN(IPAR1,IBAS),
     &IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
C DO OVER LEFT INDEX
      DO 340 IATOM1=1,NATOM                       !!! over iatom1
      ISORT1=IS(IATOM1)
C CALCULATE EXPONENTIAL FACTOR
      DO 10 IBAS=0,NBAS
      SCP=(GPLW(1,IBAS)+PNTK(1))*TAU(1,IATOM1)+
     &    (GPLW(2,IBAS)+PNTK(2))*TAU(2,IATOM1)+
     &    (GPLW(3,IBAS)+PNTK(3))*TAU(3,IATOM1)
      EXPS(IBAS)=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
  10  CONTINUE
      DO 330 IKAP1=1,NKAP(IPAN)                   !!! over energy
      DO 320 L1=0,ILSB(ISORT1)                    !!! over l1
      IF(.NOT.LTPAN(L1,IATOM1,IKAP1,IPAN))GOTO320
      DO 310 M1=-L1,L1                            !!! over m1
      L1M1=L1*(L1+1)+M1+1
      IPAR1=INDLMT(L1M1,IATOM1,IKAP1,1,IPAN)
C FOURIER TRANSFORM OF THE PSEUDOORBITAL
      DO 20 IBAS=MBAS+1,LBAS(L1,ISORT1,IKAP1,IPAN) !! NG_1{large}
      CHIS(IBAS)=DCONJG(CFTR(L1,ISORT1,IKAP1,IBAS)*
     &YLM(L1M1,IBAS)*EXPS(IBAS))
  20  CONTINUE
C SET CONVOLUTION OF PSEUDOORBITAL WITH TOS-MATRIX
	DO 100 IBAS=0,NBAS
	CONT(IBAS)=(0.D0,0.D0)
 100	CONTINUE
      DO 240 IATOM=1,NATOM                        !!! over iatom
      ISORT=IS(IATOM)
C CALCULATE EXPONENTIAL FACTOR
      DO 110 IBAS=0,NBAS                          !!! NGMAX{large}
      SCP=(GPLW(1,IBAS)+PNTK(1))*TAU(1,IATOM)+
     &    (GPLW(2,IBAS)+PNTK(2))*TAU(2,IATOM)+
     &    (GPLW(3,IBAS)+PNTK(3))*TAU(3,IATOM)
      EXPK(IBAS)=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
 110  CONTINUE
      DO 230 IKAP=1,NKAP(IPAN)                    !!! over energy
      DO 220 L=0,ILSB(ISORT)                      !!! over l
      IF(.NOT.LTPAN(L,IATOM,IKAP,IPAN))GOTO220
      DO 210 M=-L,L                               !!! over m
      LM=L*(L+1)+M+1
      IPAR=INDLMT(LM,IATOM,IKAP,1,IPAN)
C SET LOWER PART OF THE MATRIX
      IF(IPAR1.LT.IPAR)RINT0(IPAR1,IPAR)=
     &DCONJG(RINT0(IPAR,IPAR1))
C FOURIER TRANSFORM OF THE PSEUDOORBITAL
      DO 120 IBAS=MBAS+1,LBAS(L,ISORT,IKAP,IPAN)
      CHIK(IBAS)=CFTR(L,ISORT,IKAP,IBAS)*YLM(LM,IBAS)*EXPK(IBAS)
 120  CONTINUE
C CONVOLUTION
	DO 130 IBAS=MBAS+1,LBAS(L,ISORT,IKAP,IPAN)
	CONT(IBAS)=CONT(IBAS)+RINT0(IPAR1,IPAR)*CHIK(IBAS)
 130	CONTINUE 
 210  CONTINUE                                   !!! over m
 220  CONTINUE                                   !!! over l
 230  CONTINUE                                   !!! over energy
 240  CONTINUE                                   !!! over iatom
C FOURIER TRANSFORM OF THE PSEUDOCHARGE DENSITY
C 1) SMALL-SMALL G CONTRIBUTION : HAS BEEN DONE BEFORE
C 2) SMALL-LARGE G CONTRIBUTION
	DO JBAS=0,MIN(NBAS,MBAS)
	CHIL(JBAS)=DCONJG(RFUN(IPAR1,JBAS))
	ENDDO
	DO IBAS=MBAS+1,LBAS(L1,ISORT1,IKAP1,IPAN)
	CHIR(IBAS)=DCONJG(CHIS(IBAS))
	ENDDO
      CALL BND_CONVOL2(RHOPN(0,IUPDN,IORBS),CHIL(0),CHIR(0),'P',
     &0,MIN(NBAS,MBAS),MBAS+1,LBAS(L1,ISORT1,IKAP1,IPAN))
C  3) LARGE-SMALL G CONTRIBUTION
	DO IBAS=0,MIN(NBAS,MBAS)
	CHIR(IBAS)=RFUN(IPAR1,IBAS)
	ENDDO
      CALL BND_CONVOL2(RHOPN(0,IUPDN,IORBS),CHIS(0),CHIR(0),'P',
     &MBAS+1,LBAS(L1,ISORT1,IKAP1,IPAN),0,MIN(NBAS,MBAS))
C  4) LARGE-LARGE G CONTRIBUTION
      CALL BND_CONVOL2(RHOPN(0,IUPDN,IORBS),CHIS(0),CONT(0),'P',
     &MBAS+1,LBAS(L1,ISORT1,IKAP1,IPAN),MBAS+1,NBAS)
 310  CONTINUE                                !!! over m1
 320  CONTINUE                                !!! over l1
 330  CONTINUE                                !!! over energy
 340  CONTINUE                                !!! over iatom1
1000	CONTINUE                                !!! over spins
2000	CONTINUE                                !!! over iorbs
C MEMORY DEALLOCATIONS
      DEALLOCATE(YLM,CFTR,EXPS,CHIS,CONT,EXPK,CHIK,CHIL,CHIR)
      CURMEM=CURMEM-SIZE_YLM-SIZE_CFTR-SIZE_PSIS
	END
