	SUBROUTINE BND_TOSINT(IPNT,IPAN,IC)
***********************************************************
*  Calculates pseudopotential contribution to the         *
*  hamiltonian and overlap matrix using fourier transform.* 
***********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM
      USE COM_CONTROL ,ONLY: LIFT,LMTO,IASA,IDMF,NPFR         !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS          !!! from readini
     &                      ,IS,ILST,ILSB                     !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP                   !!! from readini
      USE COM_LATPAR  ,ONLY: PAR,OMEGAC                       !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN                      !!! from readini
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC          !!! from readini
      USE COM_LATTICE ,ONLY: TAU                              !!! from readini
      USE COM_DENDAT  ,ONLY: RHOPN                            !!! from rhofull
	USE COM_INDORB  ,ONLY: INDLMT                           !!! from lmtpar 
      USE COM_PLWMESH ,ONLY: NPLW,GPLW                        !!! from plwmesh
      USE COM_ETAPAR  ,ONLY: NBAS,LBAS                        !!! from setpar
      USE COM_TEILORG ,ONLY: MBAS,KEYT                        !!! from readini
	USE COM_RINPAR  ,ONLY: RINT0,RFUN                       !!! from tosint
	USE COM_LMTVEC  ,ONLY: APHR,APSR,APJR                   !!! from lmtbnd
      USE COM_KMESH   ,ONLY: NPNT,PNT,WGT                     !!! from tetra
      USE COM_INPTTR  ,ONLY: SH                               !!! from readini
      USE COM_ENERGY  ,ONLY: EARR,WTOS,WDOS                   !!! from bands
      USE COM_CHANNELS,ONLY: IUPDS,IUPSI                      !!! from setup
      USE COM_MASHDEP ,ONLY: LENCMP                           !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER, INTRINSIC :: SIZE
	COMPLEX*16, ALLOCATABLE :: YLM(:,:)
	COMPLEX*16, ALLOCATABLE :: CFTR(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: PSIK(:,:)
	COMPLEX*16, ALLOCATABLE :: DPSI(:)
	COMPLEX*16, ALLOCATABLE :: EXPK(:)
	COMPLEX*16 EXPK0,EXPS0,CTMP
	DIMENSION PNTR(3),PNTK(3)
	DATA PI/3.141592653589793D0/
C RETURN KEYS
      CALL ABORTNOW()
	IF(LIFT.LE.2)RETURN
	IF(IDMF.GT.2.AND.IPAN.EQ.1)RETURN
	IF(NPLWMEM.EQ.-1)RETURN
C MEMORY ALLOCATIONS
	ALLOCATE(YLM(LIMBMEM,0:NBASMEM))
      SIZE_YLM=DBLE(SIZE(YLM)*LENCMP)/1024.D0**2
	ALLOCATE(CFTR(0:LMAXBMEM,NSORTMEM,NKAPMEM,0:NBASMEM))
      SIZE_CFTR=DBLE(SIZE(CFTR)*LENCMP)/1024.D0**2
      CURMEM=CURMEM+SIZE_YLM+SIZE_CFTR
      IF(TOTMEM.LT.CURMEM)TXTMEM='<TOSINT> Subroutine'
      IF(TOTMEM.LT.CURMEM)TOTMEM=CURMEM
	ALLOCATE(PSIK(0:NBASMEM,NSPINMEM))
	ALLOCATE(DPSI(0:NBASMEM))
	ALLOCATE(EXPK(0:NBASMEM))
C FIND K-POINT PNTR=K+G WHICH HAS A MINIMAL LENGTH
      XK=PNT(1,IPNT,IPAN)+SH(1,IPAN)
      YK=PNT(2,IPNT,IPAN)+SH(2,IPAN)
      ZK=PNT(3,IPNT,IPAN)+SH(3,IPAN)
      CALL REDUC2(XK,YK,ZK,NBAS,GPLW(1,0),PNTK(1),PNTK(2),PNTK(3),
     &GRX,GRY,GRZ)
C SET PSEUDOLMTOS FOR THE POINT IPNTK
      CALL BND_FTRMAT(PNTK,0,IPAN,PNTR,YLM,CFTR)
C READ VARIATIONAL COEFFICIENTS
      IF(IC.EQ.1)THEN !!! call from ttrint
      IF(IPAN.GT.1)
     &CALL FULLSTOP('<BND_TOSINT>: RECORD FOR IPAN.GT.1 NOT ALLOWED')
      IREC=IPNT
      IF(NORBS.EQ.1)
     &READ(IUPSI,REC=IREC)
     &(((((APHR(LM,IATOM,IKAP,IBNDS,IBNDS+NSPIN*(IBNDT-1)),
     &LM=1,(ILSB(IS(IATOM))+1)**2),IATOM=1,NATOM),IKAP=1,NKAP(IPAN)),
     &IBNDS=1,NSPIN),IBNDT=NBNDE(IPAN),NBNDF(IPAN)),
     &(((((APSR(LM,IATOM,IKAP,IBNDS,IBNDS+NSPIN*(IBNDT-1)),
     &LM=1,(ILSB(IS(IATOM))+1)**2),IATOM=1,NATOM),IKAP=1,NKAP(IPAN)),
     &IBNDS=1,NSPIN),IBNDT=NBNDE(IPAN),NBNDF(IPAN))
      IF(NORBS.EQ.2)
     &READ(IUPSI,REC=IREC)
     &((((((APHR(LM,IATOM,IKAP,IORBS,IBNDS+NSPIN*(IBNDT-1)),
     &LM=1,(ILSB(IS(IATOM))+1)**2),IATOM=1,NATOM),IKAP=1,NKAP(IPAN)),
     &IORBS=1,NORBS),IBNDS=1,NSPIN),IBNDT=NBNDE(IPAN),NBNDF(IPAN)),
     &((((((APSR(LM,IATOM,IKAP,IORBS,IBNDS+NSPIN*(IBNDT-1)),
     &LM=1,(ILSB(IS(IATOM))+1)**2),IATOM=1,NATOM),IKAP=1,NKAP(IPAN)),
     &IORBS=1,NORBS),IBNDS=1,NSPIN),IBNDT=NBNDE(IPAN),NBNDF(IPAN))
	ENDIF
C DO GLOBALLY OVER SPINS
      DO 4000 IORBS=1,NORBS                   !!! over iorbs
      DO 3000 IUPDN=1,NSPIN                   !!! over spins
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	SIGNF=1.D0
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	IF(ISPIN1.EQ.1.AND.ISPIN.EQ.2)SIGNF=+SQRT(2.D0) ! M^{-}=<S^{-}>=-<S_{+}>
	IF(ISPIN1.EQ.2.AND.ISPIN.EQ.1)SIGNF=-SQRT(2.D0) ! M^{+}=<S^{+}>=-<S_{-}>
	ENDIF
C READ DENSITY PARAMETERS
      IREC=IUPDN+NSPIN*(IORBS-1)
      IF(KEYT.GT.0)
     &READ(IUPDS,REC=IREC)((RINT0(IPAR1,IPAR),IPAR1=1,
     &NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((RFUN(IPAR1,IBAS),
     &IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
C DO GLOBALLY OVER BANDS
      DO 2000 IBNDS=1,NSPIN                   !!! over spin subbands
      IF(NORBS.EQ.1.AND.IUPDN.NE.IBNDS)GOTO 2000
      DO 1000 IBNDT=1,NBNDF(IPAN)             !!! over bands
      IBAND=IBNDS+NSPIN*(IBNDT-1)
	IF(IC.EQ.0.AND.IBNDT.GE.NBNDE(IPAN))GOTO1000
	IF(IC.EQ.1.AND.IBNDT.LT.NBNDE(IPAN))GOTO1000
	IF(IC.EQ.0)WHT=WGT(IPNT,IPAN)/DBLE(NSPIN)*SIGNF
	IF(IC.EQ.1)WHT=WTOS(IBAND,IPNT)*SIGNF
	DO IBAS=0,NBAS
	PSIK(IBAS,ISPIN1)=(0.D0,0.D0)
	PSIK(IBAS,ISPIN )=(0.D0,0.D0)
	ENDDO
	DO IKAP=1,NKAP(IPAN)                    !!! over energies
	DO IATOM=1,NATOM                        !!! over iatom
	ISORT=IS(IATOM)
C CALCULATE EXPONENTIAL FACTOR
	DO IBAS=0,MIN(NBAS,MBAS)
	SCP=(GPLW(1,IBAS)+PNTK(1))*TAU(1,IATOM)+
     &    (GPLW(2,IBAS)+PNTK(2))*TAU(2,IATOM)+
     &    (GPLW(3,IBAS)+PNTK(3))*TAU(3,IATOM)
	EXPK(IBAS)=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	ENDDO
C PSEUDOWAVEFUNCTION 
	DO L=0,ILSB(ISORT)                      !!! over l
	IF(.NOT.LTPAN(L,IATOM,IKAP,IPAN))CYCLE
	MINB=MIN(LBAS(L,ISORT,IKAP,IPAN),MBAS)
	DO M=-L,L                               !!! over m
      LM=L*(L+1)+M+1
	DO IBAS=0,MINB
	PSIK(IBAS,ISPIN1)=PSIK(IBAS,ISPIN1)+
     &APSR(LM,IATOM,IKAP,ISPIN1,IBAND)*CFTR(L,ISORT,IKAP,IBAS)*
     &EXPK(IBAS)*YLM(LM,IBAS)
	IF(ISPIN1.NE.ISPIN)
     &PSIK(IBAS,ISPIN )=PSIK(IBAS,ISPIN )+
     &APSR(LM,IATOM,IKAP,ISPIN,IBAND )*CFTR(L,ISORT,IKAP,IBAS)*
     &EXPK(IBAS)*YLM(LM,IBAS)
      ENDDO        
      ENDDO                                   !!! over m
      ENDDO                                   !!! over l
      ENDDO                                   !!! over iatom
      ENDDO                                   !!! over ikap
	DO IBAS=0,MIN(NBAS,MBAS)                !!! over ibas
	DPSI(IBAS)=DCONJG(PSIK(IBAS,ISPIN1))*WHT
      ENDDO                                   !!! over ibas
C FOURIER TRANSFORM OF THE PSEUDOCHARGE DENSITY (SMALL G-VECTORS)
	CALL BND_CONVOL2(RHOPN(0,IUPDN,IORBS),DPSI(0),PSIK(0,ISPIN),'P',
     &             0,MIN(NBAS,MBAS),0,MIN(NBAS,MBAS))
C AUXILARY ARRAYS: 
	IF(KEYT.GT.0)THEN
      DO IATOM1=1,NATOM                       !!! over iatom1
      ISORT1=IS(IATOM1)
      SCP=PNTK(1)*TAU(1,IATOM1)+
     &    PNTK(2)*TAU(2,IATOM1)+
     &    PNTK(3)*TAU(3,IATOM1)
      EXPS0=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
      DO IKAP1=1,NKAP(IPAN)                   !!! over energy
      DO L1=0,ILSB(ISORT1)                    !!! over l1
      IF(.NOT.LTPAN(L1,IATOM1,IKAP1,IPAN))CYCLE
      DO M1=-L1,L1                            !!! over m1
      L1M1=L1*(L1+1)+M1+1
      IPAR1=INDLMT(L1M1,IATOM1,IKAP1,1,IPAN)
C  1) TOS-MATRIX
      DO IATOM=1,NATOM                        !!! over iatom
      ISORT=IS(IATOM)
      SCP=PNTK(1)*TAU(1,IATOM)+
     &    PNTK(2)*TAU(2,IATOM)+
     &    PNTK(3)*TAU(3,IATOM)
      EXPK0=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
      DO IKAP=1,NKAP(IPAN)                    !!! over energy
      DO L=0,ILSB(ISORT)                      !!! over l
      IF(.NOT.LTPAN(L,IATOM,IKAP,IPAN))CYCLE
      DO M=-L,L                               !!! over m
      LM=L*(L+1)+M+1
      IPAR=INDLMT(LM,IATOM,IKAP,1,IPAN)
      IF(IPAR1.GE.IPAR)THEN
	CTMP=DCONJG(APSR(L1M1,IATOM1,IKAP1,ISPIN1,IBAND)*EXPS0)*
     &APSR(LM,IATOM,IKAP,ISPIN,IBAND)*EXPK0*WHT
      RINT0(IPAR1,IPAR)=RINT0(IPAR1,IPAR)+CTMP
	ENDIF
      ENDDO                                   !!! over m
      ENDDO                                   !!! over l
      ENDDO                                   !!! over energy
      ENDDO                                   !!! over iatom
C  2) RFUN-ARARY
	DO IBAS=0,MIN(NBAS,MBAS)                !!! over ibas
	CTMP=DCONJG(APSR(L1M1,IATOM1,IKAP1,ISPIN1,IBAND)*EXPS0)*
     &PSIK(IBAS,ISPIN)*WHT
	RFUN(IPAR1,IBAS)=RFUN(IPAR1,IBAS)+CTMP
      ENDDO                                   !!! over ibas
      ENDDO                                   !!! over m1
      ENDDO                                   !!! over l1
      ENDDO                                   !!! over energy
      ENDDO                                   !!! over iatom1
	ENDIF
1000  CONTINUE                                !!! over bands
      IREC=IUPDN+NSPIN*(IORBS-1)
      IF(KEYT.GT.0)
     &WRITE(IUPDS,REC=IREC)((RINT0(IPAR1,IPAR),IPAR1=1,
     &NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((RFUN(IPAR1,IBAS),
     &IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
2000  CONTINUE                                !!! over spin subbands
3000  CONTINUE                                !!! over spins
4000  CONTINUE                                !!! over iorbs
C MEMORY DEALLOCATIONS
	DEALLOCATE(YLM,CFTR,DPSI,EXPK,PSIK)
      CURMEM=CURMEM-SIZE_YLM-SIZE_CFTR
C ERROR HANDLINGS
C     none
	END SUBROUTINE BND_TOSINT





	SUBROUTINE BND_NULINT(IPAN)
************************************************
*  Zeroises pseudodensity parameters           *
************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                          !!! from setup
      USE COM_CONTROL ,ONLY: LIFT,LMTO,IASA,NPFR              !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS          !!! from readini
     &                      ,IS,ILST,ILSB                     !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP                   !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN                      !!! from readini
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC          !!! from readini
      USE COM_ETAPAR  ,ONLY: NBAS                             !!! from readini
	USE COM_RINPAR  ,ONLY: RINT0,RFUN                       !!! from tosint
      USE COM_TEILORG ,ONLY: MBAS,KEYT                        !!! from readini
      USE COM_LMTOUT  ,ONLY: SCRFILE                          !!! from readini
      USE COM_CHANNELS,ONLY: IUPDS                            !!! from setup
      USE COM_MASHDEP ,ONLY: NVAL,LENCMP                      !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER, INTRINSIC :: SIZE
	LOGICAL EXIST
      DATA PI/3.141592653589793D0/
C OPEN SCRATCH FILE FOR STORING POTENTIAL PARAMETERS
      NRECL=NVAL*(NBNDT(IPAN)*(MIN(NBAS,MBAS)+1)+
     &NBNDT(IPAN)**2)
      OPEN(UNIT=IUPDS,FILE=SCRFILE(IUPDS),STATUS='NEW',
     &ACCESS='DIRECT',FORM='UNFORMATTED',RECL=NRECL)
C RETURN KEYS
	IF(KEYT.LE.0)RETURN
	IF(NPLWMEM.EQ.-1)RETURN
C NULLIFY
      DO IORBS=1,NORBS                               !!! over iorbs
      DO IUPDN=1,NSPIN                               !!! over spins
      DO IDIM=1,NBNDT(IPAN)                          !!! over idim
      DO JDIM=1,NBNDT(IPAN)                          !!! over jdim
      RINT0(JDIM,IDIM)=(0.D0,0.D0)
      ENDDO                                          !!! over jdim
      DO IBAS=0,MIN(NBAS,MBAS)                       !!! over ibas
      RFUN(IDIM,IBAS)=(0.D0,0.D0)
      ENDDO                                          !!! over ibas
      ENDDO                                          !!! over idim
      IREC=IUPDN+NSPIN*(IORBS-1)
      WRITE(IUPDS,REC=IREC)((RINT0(IPAR1,IPAR),IPAR1=1,
     &NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((RFUN(IPAR1,IBAS),
     &IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
      ENDDO                                          !!! over spins
      ENDDO                                          !!! over iorbs
	END SUBROUTINE BND_NULINT
