	SUBROUTINE BND_TTRINT(EF0,TOS,DOS,KEY)
***********************************************************
*  The calculation of the weight functions for integrati- *
*  on over IBZ by means of tetrahedron method.            *
***********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_PARAM  ,ONLY: NATOM,NSORT,NSPIN,NORBS                 !!! from readini
      USE COM_KAPPAR ,ONLY: NPAN,NKAP                               !!! from readini
      USE COM_LATPAR ,ONLY: PAR,ORTH,OMEGAC                         !!! from readini
      USE COM_LATTICE,ONLY: RBAS,GBAS,AKBAS,RKBAS                   !!! from readstr
      USE COM_NBANDS ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC                 !!! from readini
      USE COM_INPTTR ,ONLY: NDIV,NDIC,NDIW,SH,KEYTTR
     &                     ,TFERMI,GBROAD                           !!! from readini
      USE COM_KMESH  ,ONLY: NPNT,PNT,WGT,IPQARR,ITQARR,KCUT         !!! from makettr
      USE COM_WMESH  ,ONLY: NPNW,PNW,WGW,IPWARR,ITWARR,KCUW         !!! from makettr
      USE COM_ENERGY ,ONLY: EARR,EARW,WTOS,WDOS,WTRT,WDRT           !!! from bands
      USE COM_UNIT   ,ONLY: IUN,IUR,IUT                             !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8, ALLOCATABLE :: FINT(:,:,:)
	INTEGER KTT(4),KTW(4)
	DIMENSION E(4),AT(4),AD(4),FAT(4),FAD(4),FL(0:4,4)
     &   ,PKT(3,4),PKW(3,4),CRW(3,4),REC(3,3)
      DATA PI/3.141592653589793D0/,EPS/1.D-10/,EPSDEG/1.D-05/
C MEMORY ALLOCATIONS
	ALLOCATE(FINT(0:4,NBNDT(1)*NSPINMEM,NPNWMEM))
C *********** INITIALIZATION **************
	EF=EF0
	TOS=0.D0
	DOS=0.D0
	TOT=0.D0
	DOT=0.D0
      VOLIBZ=1.D0
      OT=1.D0/NDIV(1)/NDIV(2)/NDIV(3)/6.D0
      OW=1.D0/NDIW(1)/NDIW(2)/NDIW(3)/6.D0
C *********** TETRAHEDRON METHOD **********
      DO IPNT=1,NPNT(1)
      DO IBNDS=1,NSPIN
      DO IBNDT=1,NBNDT(1)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
      WTOS(IBAND,IPNT)=0.D0
      WDOS(IBAND,IPNT)=0.D0
	ENDDO
	ENDDO
	ENDDO
C Compute Fermi function integrals
	IF((KEYTTR.EQ.0.OR.KEYTTR.EQ.1).AND.TFERMI.NE.0.D0)THEN
      DO IBNDS=1,NSPIN
      DO IBNDT=1,NBNDT(1)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
      DO IPNW=1,NPNW(1)
	XT=(EARW(IBAND,IPNW,1)-EF)/TFERMI
	CALL TTR_FERMIINT(XT,40,FINT(0,IBAND,IPNW),0.D0)
	ENDDO
	ENDDO
	ENDDO
	ENDIF
C  DO OVER MICROCELLS
      DO 2200 I3=0,NDIV(3)-1               !!! over cells along G3
      DO 2200 I2=0,NDIV(2)-1               !!! over cells along G2
      DO 2200 I1=0,NDIV(1)-1               !!! over cells along G1
C  THE MICROCELL IS SET UP BY I1,I2,I3
C  SET UP TETRAHEDRON INSIDE MICROCELL
      DO 2100 ITTR=1,6                     !!! over tetrahedra
	IF(ITQARR(ITTR,I1,I2,I3).LT.0)GOTO 2100
	WTTR=DBLE(ITQARR(ITTR,I1,I2,I3))
      DO I=1,4
C  COORDINATES OF THE TETRAHEDRON AGE GIVEN BY KTT
      J1=I1+KCUT(1,I,ITTR)
      J2=I2+KCUT(2,I,ITTR)
      J3=I3+KCUT(3,I,ITTR)
      KTT(I)=IPQARR(J1,J2,J3)
      ENDDO
C  SET UP POINTS "K" DESCRIBING TETRAHEDRON IN THE SPACE
      DO I=1,4
      J1=I1+KCUT(1,I,ITTR)
      J2=I2+KCUT(2,I,ITTR)
      J3=I3+KCUT(3,I,ITTR)
      PKT(1,I)=(J1*AKBAS(1,1,1)+
     &          J2*AKBAS(1,2,1)+
     &          J3*AKBAS(1,3,1))*2.D0*PI/PAR
      PKT(2,I)=(J1*AKBAS(2,1,1)+
     &          J2*AKBAS(2,2,1)+
     &          J3*AKBAS(2,3,1))*2.D0*PI/PAR
      PKT(3,I)=(J1*AKBAS(3,1,1)+
     &          J2*AKBAS(3,2,1)+
     &          J3*AKBAS(3,3,1))*2.D0*PI/PAR
      ENDDO
C  SHIFT COORDINATE SYSTEM TO THE FIRST POINT
      DO I=2,4
      PKT(1,I)=PKT(1,I)-PKT(1,1)
      PKT(2,I)=PKT(2,I)-PKT(2,1)
      PKT(3,I)=PKT(3,I)-PKT(3,1)
      ENDDO
C  SET RECIPROCALS "REC" TO "PKT"
      CALL CROSS(REC(1,1),PKT(1,3),PKT(1,4))
      CALL CROSS(REC(1,2),PKT(1,4),PKT(1,2))
      CALL CROSS(REC(1,3),PKT(1,2),PKT(1,3))
      W=REC(1,1)*PKT(1,2)+REC(2,1)*PKT(2,2)+REC(3,1)*PKT(3,2)
      IF(ABS(W).LE.1.D-10)
     &CALL FULLSTOP('<TTRINT>:: INTERNAL ERROR: W=0')
      DO I=1,3
      REC(I,1)=REC(I,1)/W
      REC(I,2)=REC(I,2)/W
      REC(I,3)=REC(I,3)/W
      ENDDO
C  DO OVER DIVISIONS OF THE MICROCELL
      DO 1200 ID3=0,NDIW(3)/NDIV(3)-1
      DO 1200 ID2=0,NDIW(2)/NDIV(2)-1
      DO 1200 ID1=0,NDIW(1)/NDIV(1)-1
C  THE SMALL MICROCELL IS SET UP BY IW1,IW2,IW3
      IW1=I1*NDIW(1)/NDIV(1)+ID1
      IW2=I2*NDIW(2)/NDIV(2)+ID2
      IW3=I3*NDIW(3)/NDIV(3)+ID3
C  SET UP SMALL TETRAHEDRON INSIDE SMALL MICROCELL
      DO 1100 ITTRD=1,6
      DO I=1,4
      JW1=IW1+KCUT(1,I,ITTRD)
      JW2=IW2+KCUT(2,I,ITTRD)
      JW3=IW3+KCUT(3,I,ITTRD)
      KTW(I)=IPWARR(JW1,JW2,JW3)
      ENDDO
C  SET UP POINTS K DESCRIBING SMALL TETRAHEDRON IN THE SPACE
      DO I=1,4
      JW1=IW1+KCUT(1,I,ITTRD)
      JW2=IW2+KCUT(2,I,ITTRD)
      JW3=IW3+KCUT(3,I,ITTRD)
      PKW(1,I)=(JW1*AKBAS(1,1,3)+
     &          JW2*AKBAS(1,2,3)+
     &          JW3*AKBAS(1,3,3))*2.D0*PI/PAR
      PKW(2,I)=(JW1*AKBAS(2,1,3)+
     &          JW2*AKBAS(2,2,3)+
     &          JW3*AKBAS(2,3,3))*2.D0*PI/PAR
      PKW(3,I)=(JW1*AKBAS(3,1,3)+
     &          JW2*AKBAS(3,2,3)+
     &          JW3*AKBAS(3,3,3))*2.D0*PI/PAR
      ENDDO
C  SHIFT COORDINATE SYSTEM TO THE FIRST POINT
      DO I=1,4
      PKW(1,I)=PKW(1,I)-PKT(1,1)
      PKW(2,I)=PKW(2,I)-PKT(2,1)
      PKW(3,I)=PKW(3,I)-PKT(3,1)
      ENDDO
C  CHECK WHETHER A SMALL TETRAHEDRON "PKW" IS INSIDE  TETRAHEDRON "PKT"
      DO I=1,4
      X1=PKW(1,I)*REC(1,1)+PKW(2,I)*REC(2,1)+PKW(3,I)*REC(3,1)
      X2=PKW(1,I)*REC(1,2)+PKW(2,I)*REC(2,2)+PKW(3,I)*REC(3,2)
      X3=PKW(1,I)*REC(1,3)+PKW(2,I)*REC(2,3)+PKW(3,I)*REC(3,3)
      IF(.NOT.((X1.GE.-EPS.AND.X1.LE.1.D0+EPS).AND.
     &         (X2.GE.-EPS.AND.X2.LE.1.D0+EPS).AND.
     &         (X3.GE.-EPS.AND.X3.LE.1.D0+EPS).AND.
     &         (X1+X2+X3.LE.1.D0+EPS)))GOTO1100
      CRW(1,I)=X1
      CRW(2,I)=X2
      CRW(3,I)=X3
      ENDDO
C  CALCULATE CONTRIBUTION TO THE POINTS GIVEN BY "KTT=PKT"
      DO 1000 IBNDS=1,NSPIN                     !!! over spin subbands
      DO 1000 IBNDT=1,NBNDT(1)                  !!! over valence bands
      IBAND=IBNDS+NSPIN*(IBNDT-1)
      DO I=1,4
      IPNT=KTW(I)
      E(I)=EARW(IBAND,IPNT,1)
      ENDDO
C  USE TETRAHEDRON METHOD
	IF(KEYTTR.EQ.0.OR.KEYTTR.EQ.1)
     &CALL TTR_MCTTRINT0(E,EF,OW,AT,AD,TS,DS,'B','W')
C  ADD NON-ZERO TEMPERATURE CONTRIBUTION
	IF((KEYTTR.EQ.0.OR.KEYTTR.EQ.1).AND.TFERMI.NE.0.D0)THEN
      DO I=1,4
      IPNT=KTW(I)
	DO LD=0,4
	FL(LD,I)=FINT(LD,IBAND,IPNT)
	ENDDO
      ENDDO
      CALL TTR_MCTTRINTF(E,EF,TFERMI,FL,OW,FAT,FAD,FTS,FDS)
	TS=TS+FTS
	DS=DS+FDS
	DO I=1,4
	AT(I)=AT(I)+FAT(I)
	AD(I)=AD(I)+FAD(I)
	ENDDO
	ENDIF
C  USE GAUSSIAN BROADENING
	IF(KEYTTR.EQ.2)
     &CALL TTR_MCTTRINTG(E,EF,GBROAD,OW,AT,AD,TS,DS)
C  SET WEIGHTS
      TOS=TOS+TS*WTTR
      DOS=DOS+DS*WTTR
      DO IT=1,4
      IPNT=KTT(IT)
      DO I=1,4
      IF(IT.EQ.1)WF=1.D0-CRW(1,I)-CRW(2,I)-CRW(3,I)
      IF(IT.NE.1)WF=CRW(IT-1,I)
      WTOS(IBAND,IPNT)=WTOS(IBAND,IPNT)+AT(I)*WF*WTTR
      WDOS(IBAND,IPNT)=WDOS(IBAND,IPNT)+AD(I)*WF*WTTR
      ENDDO
      ENDDO
 1000 CONTINUE                                  !!! over valence bands
 1100 CONTINUE                                  !!! over small tetrahedra
 1200 CONTINUE                                  !!! over small microcells
 2100 CONTINUE                                  !!! over tetrahedra
 2200 CONTINUE                                  !!! over microcells
C Average for degenerate bands
	IF(KEYTTR.EQ.0)THEN
      DO 4000 IPNT=1,NPNT(1)                    !!! over k-points
	IDEG=0
	JDEG=0
      DO 3200 IBNDS=1,NSPIN
      DO 3100 IBNDT=1,NBNDT(1)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	EI=EARR(IBAND,IPNT,1)
	IF(IDEG.LT.JDEG)IDEG=IDEG+1
	IF(IDEG.LT.JDEG)CYCLE
	IDEG=0
	JDEG=0
      DO JBNDS=1,NSPIN
	IF(NORBS.EQ.1.AND.IBNDS.NE.JBNDS)CYCLE
      DO JBNDT=IBNDT,NBNDT(1)
	JBAND=JBNDS+NSPIN*(JBNDT-1)
	EJ=EARR(JBAND,IPNT,1)
	IF(ABS(EI-EJ).LE.EPSDEG)JDEG=JDEG+1
	IF(ABS(EI-EJ).GT.EPSDEG)EXIT
	ENDDO
	ENDDO
	WH=0.D0
	WD=0.D0
      DO JBNDS=1,NSPIN
	IF(NORBS.EQ.1.AND.IBNDS.NE.JBNDS)CYCLE
      DO JBNDT=IBNDT,IBNDT+JDEG-1
	JBAND=JBNDS+NSPIN*(JBNDT-1)
	WH=WH+WTOS(JBAND,IPNT)
	WD=WD+WDOS(JBAND,IPNT)
	ENDDO
	ENDDO
	WH=WH/DBLE(JDEG)
	WD=WD/DBLE(JDEG)
      DO JBNDS=1,NSPIN
	IF(NORBS.EQ.1.AND.IBNDS.NE.JBNDS)CYCLE
      DO JBNDT=IBNDT,IBNDT+JDEG-1
	JBAND=JBNDS+NSPIN*(JBNDT-1)
	WTOS(JBAND,IPNT)=WH
	WDOS(JBAND,IPNT)=WD
	ENDDO
	ENDDO
 3100	ENDDO
 3200	ENDDO
 4000 CONTINUE                              !!! over k-points
	ENDIF
C Normalize
      DO IBNDS=1,NSPIN
      DO IBNDT=1,NBNDT(1)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
      DO IPNT=1,NPNT(1)
      WTOS(IBAND,IPNT)=WTOS(IBAND,IPNT)/VOLIBZ*2.D0/DBLE(NSPIN)
      WDOS(IBAND,IPNT)=WDOS(IBAND,IPNT)/VOLIBZ*2.D0/DBLE(NSPIN)
      TOT=TOT+WTOS(IBAND,IPNT)
      DOT=DOT+WDOS(IBAND,IPNT)
	WTRT(IBAND,IPNT)=WTOS(IBAND,IPNT)
	WDRT(IBAND,IPNT)=WDOS(IBAND,IPNT)
	ENDDO
	ENDDO
	ENDDO
C ************ END OF INTEGRATION ***********
	TOS=TOS/VOLIBZ*2.D0/DBLE(NSPIN)
	DOS=DOS/VOLIBZ*2.D0/DBLE(NSPIN)
	IF(KEY.EQ.0)WRITE(IUN,10010)EF,TOS,DOS
	IF(ABS(TOS-TOT).GE.1.D-07)WRITE(IUN,10020)TOS,TOT
	IF(ABS(DOS-DOT).GE.1.D-07)WRITE(IUN,10030)DOS,DOT
10010 FORMAT(' EF,TOS,DOS==',3(1X,G14.7))
10020	FORMAT(' TOS-WEIGHTS MISMATCH :',G14.7,2X,G14.7)
10030	FORMAT(' DOS-WEIGHTS MISMATCH :',G14.7,2X,G14.7)
C MEMORY DEALLOCATIONS
	DEALLOCATE(FINT)
	RETURN
	END
