	SUBROUTINE CHIFILES(IQPNT,IOMG,ICHN,TOPER)
***********************************************************
*  Reads/writes susceptibility matrices.                  *
***********************************************************
C SET ARRAY-SIZE DATA
	USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
	USE COM_LMTMEM                                        !!! from setup
	USE COM_CONTROL ,ONLY: LIFT,LMTO                      !!! from readini
	USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS,ILSB!!! from readini
	USE COM_CHIDAT  ,ONLY: NCHI,CHI0,GINT                 !!! from intchi
	USE COM_QMESH   ,ONLY: NQPNT,QPNT                     !!! from tetra
	USE COM_FREQU   ,ONLY: NOMGCHI                        !!! from tetra
	USE COM_LMTOUT  ,ONLY: SCRFILE                        !!! from readini
	USE COM_MASHDEP ,ONLY: LENCMP,NVAL                    !!! from readini
	USE COM_UNIT    ,ONLY: IUN,IUR,IUT,IUI                !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	LOGICAL EXIST
	CHARACTER TOPER*1,STATUS*3,NFILE*130
	DATA PI/3.141592653589793D0/
C SCRATCH FILE FOR STORING SUSCEPTIBILITY
	NRECL=NVAL*NCHI*NCHI+NVAL*9*NSPIN**4*NATOM**2*9
	NFILE=SCRFILE(ICHN)
	INQUIRE(FILE=NFILE,EXIST=EXIST)
	IF(.NOT.EXIST)STATUS='NEW'
	IF(     EXIST)STATUS='OLD'
C DELETE FILE
	IF(TOPER.EQ.'D')THEN
	NRECL=4
	OPEN(UNIT=ICHN,FILE=NFILE,STATUS=STATUS,FORM='UNFORMATTED',
     &  ACCESS='DIRECT',RECL=NRECL)
	CLOSE(UNIT=ICHN,STATUS='DELETE')
	RETURN
	ENDIF
	OPEN(UNIT=ICHN,FILE=NFILE,STATUS=STATUS,ACCESS='DIRECT',
     &  FORM='UNFORMATTED',RECL=NRECL)
C READ/WRITE ACCORDING TO <<TOPER>>
	IREC=1+NSPIN**4*IOMG+NSPIN**4*(NOMGCHI+1)*(IQPNT-1)
	IF(TOPER.EQ.'R')
     &READ(ICHN,REC=IREC)(((CHI0(ICHI,ICHI1,I),
     &ICHI=1,NCHI),ICHI1=1,NCHI),I=1,2),
     &((((((GINT(IND1,IATOM1,IND,IATOM,IC1,IC)
     &                               ,IND1=1,3*NSPIN**2),IATOM1=1,NATOM)
     &                               ,IND =1,3*NSPIN**2),IATOM =1,NATOM)
     &                               ,IC1=1,3),IC=1,3)
	IF(TOPER.EQ.'W')
     &WRITE(ICHN,REC=IREC)(((CHI0(ICHI,ICHI1,I),
     &ICHI=1,NCHI),ICHI1=1,NCHI),I=1,2),
     &((((((GINT(IND1,IATOM1,IND,IATOM,IC1,IC)
     &                               ,IND1=1,3*NSPIN**2),IATOM1=1,NATOM)
     &                               ,IND =1,3*NSPIN**2),IATOM =1,NATOM)
     &                               ,IC1=1,3),IC=1,3)
	CLOSE(ICHN)
      RETURN
	END


 
	SUBROUTINE CHI_NULCHI(IQPNT,IOMG)
***********************************************************
*  Initialize susceptibility                              *
***********************************************************
C  SET ARRAY-SIZE DATA
	USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
	USE COM_LMTMEM                                         !!! from setup
	USE COM_CONTROL ,ONLY: LIFT,LMTO                       !!! from readini
	USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS,ILSB !!! from readini
      USE COM_HUBDAT  ,ONLY: MCRL,LCRL,NCLM                  !!! from readhub
	USE COM_CHIDAT  ,ONLY: NCHI,INCHI,CHI0,GINT            !!! from intchi
	USE COM_CHANNELS,ONLY: IUCHI                           !!! from channels
      USE COM_MASHDEP ,ONLY: NVAL,LENCMP                     !!! from setup
	USE COM_UNIT    ,ONLY: IUN,IUR,IUT,IUI                 !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	DATA PI/3.141592653589793D0/
C ZEROISE SUSCEPTIBILITY
      DO 4000 IM1SPIN=1,NSPIN                           !!! over im1spin
      DO 3000 IK1SPIN=1,NSPIN                           !!! over ik1spin
      DO 2000 IM SPIN=1,NSPIN                           !!! over im spin
      DO 1000 IK SPIN=1,NSPIN                           !!! over ik spin
C SET CHI(q,w)=0
	DO IATOM1=1,NATOM                                 !!! over atoms
	ISORT1=IS(IATOM1)
	IF(MCRL(IATOM1).EQ.0)CYCLE
	DO L1=0,ILSB(ISORT1)                              !!! over l1
	IF(LCRL(L1,IATOM1).EQ.0)CYCLE
	DO M1=-L1,L1                                      !!! over m1
	DO K1=-L1,L1                                      !!! over k1
	IU1=L1*(2*L1-1)*(2*L1+1)/3+(2*L1+1)*(L1+K1)+L1+M1+1 !!!    (l1,m1 k1)
	ICHI1=INCHI(IU1,IATOM1,IM1SPIN,IK1SPIN)
	DO IATOM=1,NATOM                                  !!! over atoms
	ISORT=IS(IATOM)
	IF(MCRL(IATOM).EQ.0)CYCLE
	DO L=0,ILSB(ISORT)                                !!! over l
	IF(LCRL(L,IATOM).EQ.0)CYCLE
	DO M=-L,L                                         !!! over m
	DO K=-L,L                                         !!! over k
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+K)+L+M+1 !!!    (l,m k)
	ICHI=INCHI(IU,IATOM,IMSPIN,IKSPIN)
	CHI0(ICHI1,ICHI,1)=(0.D0,0.D0)
	CHI0(ICHI1,ICHI,2)=(0.D0,0.D0)
	ENDDO                                             !!! over k
	ENDDO                                             !!! over m
	ENDDO                                             !!! over l
	ENDDO                                             !!! over atoms
	ENDDO                                             !!! over k1
	ENDDO                                             !!! over m1
	ENDDO                                             !!! over l1
	ENDDO                                             !!! over atoms
1000	CONTINUE                                          !!! over ikspin
2000	CONTINUE                                          !!! over imspin
3000	CONTINUE                                          !!! over ik1spin
4000	CONTINUE                                          !!! over im1spin
C Zeroise exchange intergrals
      DO IC1=1,3
	DO IATOM1=1,NATOM
	DO IND1=1,3*NSPIN**2
	DO IC=1,3
	DO IATOM=1,NATOM
	DO IND=1,3*NSPIN**2
	GINT(IND1,IATOM1,IND,IATOM,IC1,IC)=(0.D0,0.D0)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C  WRITE ZEROES
	CALL CHIFILES(IQPNT,IOMG,IUCHI,'W')
	END
