	SUBROUTINE CHI_CHIMAT(IPNT,ISGQ,IQPNT)
************************************************************
* Matrix elements calculation                              *
************************************************************
C  SET ARRAY-SIZE DATA
      USE DIM_LMTART
C  SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                           !!! from setup
      USE COM_CONTROL ,ONLY: LIFT,LMTO,IASA,NPFR,NOVR          !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS,ILSB,ILST! from readini
      USE COM_LATPAR  ,ONLY: PAR,ORTH,OMEGAC                   !!! from readini
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC,NBNDH     !!! from readini
      USE COM_KMESH   ,ONLY: NPNT,PNT                          !!! from tetra
      USE COM_EIGVEC  ,ONLY: APHK,APHQ,APJK,APJQ               !!! from ftbvec
	USE COM_CHIDAT  ,ONLY: NCHI,INCHI,CHIM                   !!! from intchi
      USE COM_SUBGROUP,ONLY: NSGQ,NGEQ,ISG                     !!! from delmsh
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP                    !!! from readini
      USE COM_HUBDAT  ,ONLY: MCRL,LCRL,NCLM                    !!! from readhub
      USE COM_CHIDAT  ,ONLY: CHH,CHJ,CJH,CJJ                   !!! from overpar
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN                       !!! from readini
      USE COM_MASHDEP ,ONLY: LENCMP,NVAL                       !!! from readini
      USE COM_CHANNELS,ONLY: IUPSK                             !!! from setup
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT                       !!! from setup
C  SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
	DATA PI/3.141592653589793D0/
C  LOOP OVER BANDS
      DO 4000 IBNDS1=1,NSPIN              !!! over spin subbands
      DO 3000 IBNDT1=1,NBNDT(1)+NBNDH(1)  !!! over bands
	IBAND1=IBNDS1+NSPIN*(IBNDT1-1)
      DO 2000 IBNDS=1,NSPIN               !!! over spin subbands
      DO 1000 IBNDT=1,NBNDT(1)+NBNDH(1)   !!! over bands
	IBAND=IBNDS+NSPIN*(IBNDT-1)
      DO IMSPIN=1,NSPIN                   !!! over imspin
      DO IKSPIN=1,NSPIN                   !!! over ikspin
C SET MATRIX ELEMENTS
	DO IATOM=1,NATOM                    !!! over atoms
	ISORT=IS(IATOM)
	IF(MCRL(IATOM).EQ.0)CYCLE
	DO L=0,ILSB(ISORT)                  !!! over l
	IF(LCRL(L,IATOM).EQ.0)CYCLE
	DO M=-L,L                           !!! over m
	DO K=-L,L                           !!! over k
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+K)+L+M+1 !!!    (l,m k)
	ICHI=INCHI(IU,IATOM,IMSPIN,IKSPIN)
	CHIM(ICHI,IBAND1,IBAND)=(0.D0,0.D0)
	ENDDO                               !!! over k
	ENDDO                               !!! over m
	ENDDO                               !!! over l
	ENDDO                               !!! over atoms
	IF(NORBS.EQ.1.AND.IMSPIN.NE.IBNDS1)CYCLE
	IF(NORBS.EQ.1.AND.IKSPIN.NE.IBNDS )CYCLE
	DO IKAP1=1,NKAP(1)                  !!! over ikap1
	DO IKAP=1,NKAP(1)                   !!! over ikap
	DO IATOM=1,NATOM                    !!! over iatom
	ISORT=IS(IATOM)
	IF(MCRL(IATOM).EQ.0)CYCLE
	DO L=0,ILSB(ISORT)                  !!! over l
	IF(LCRL(L,IATOM).EQ.0)CYCLE
	DO M=-L,L                           !!! over m
	LM=L*(L+1)+M+1
	DO K=-L,L                           !!! over k
	LK=L*(L+1)+K+1
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+K)+L+M+1 !!!    (l,m k)
	ICHI=INCHI(IU,IATOM,IMSPIN,IKSPIN)
C Greens function using LMTO representation
	IF(IASA.EQ.1.OR.IASA.EQ.2)THEN
	IF(LTPAN(L,IATOM,IKAP1,1).AND.LTPAN(L,IATOM,IKAP,1))
     &CHIM(ICHI,IBAND1,IBAND)=CHIM(ICHI,IBAND1,IBAND)+
     &DCONJG(APHQ(LM,IATOM,IKAP1,IMSPIN,IBAND1))*
     &CHH(IKAP1,IKAP,L,ISORT,IMSPIN,IKSPIN)*
     &APHK(LK,IATOM,IKAP,IKSPIN,IBAND)
	IF(LTPAN(L,IATOM,IKAP1,1))
     &CHIM(ICHI,IBAND1,IBAND)=CHIM(ICHI,IBAND1,IBAND)-
     &DCONJG(APHQ(LM,IATOM,IKAP1,IMSPIN,IBAND1))*
     &CHJ(IKAP1,IKAP,L,ISORT,IMSPIN,IKSPIN)*
     &APJK(LK,IATOM,IKAP,IKSPIN,IBAND)
	IF(LTPAN(L,IATOM,IKAP,1))
     &CHIM(ICHI,IBAND1,IBAND)=CHIM(ICHI,IBAND1,IBAND)-
     &DCONJG(APJQ(LM,IATOM,IKAP1,IMSPIN,IBAND1))*
     &CJH(IKAP1,IKAP,L,ISORT,IMSPIN,IKSPIN)*
     &APHK(LK,IATOM,IKAP,IKSPIN,IBAND)
      CHIM(ICHI,IBAND1,IBAND)=CHIM(ICHI,IBAND1,IBAND)+
     &DCONJG(APJQ(LM,IATOM,IKAP1,IMSPIN,IBAND1))*
     &CJJ(IKAP1,IKAP,L,ISORT,IMSPIN,IKSPIN)*
     &APJK(LK,IATOM,IKAP,IKSPIN,IBAND)
C Greens function using TB representation
	ELSEIF(IASA.EQ.4)THEN
	IF(LTPAN(L,IATOM,IKAP1,1).AND.LTPAN(L,IATOM,IKAP,1))
     &CHIM(ICHI,IBAND1,IBAND)=CHIM(ICHI,IBAND1,IBAND)+
     &DCONJG(APHQ(LM,IATOM,IKAP1,IMSPIN,IBAND1))*
     &APHK(LK,IATOM,IKAP,IKSPIN,IBAND)
	ENDIF
      ENDDO                               !!! over k
      ENDDO                               !!! over m
      ENDDO                               !!! over l
      ENDDO                               !!! over iatom
      ENDDO                               !!! over ikap
      ENDDO                               !!! over ikap1
      ENDDO                               !!! over ikspin
      ENDDO                               !!! over imspin
1000	CONTINUE                            !!! over bands
2000	CONTINUE                            !!! over spin subbands
3000	CONTINUE                            !!! over bands
4000	CONTINUE                            !!! over spin subbands
C  MEMORY DEALLOCATIONS
	END
