	SUBROUTINE CHI_CHIPAR
***************************************************************
*  Calculation of potential parameters in the overlap matrix. *
***************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
	USE COM_LMTMEM
      USE COM_CONTROL ,ONLY: LMTO,IASA,NOVR,NPFR                             !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,NHSORT
     &                      ,IS,ILST,ILSB,LRTV                               !!! from readini
      USE COM_LATPAR  ,ONLY: PAR,OMEGAC                                      !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP,EK                               !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN,IATS,ISTS                           !!! from readini
      USE COM_SPHERE  ,ONLY: SMT,SASA,SWZ                                    !!! from readini
      USE COM_INPPAR  ,ONLY: ENY,DNY                                         !!! from readini
	USE COM_MAGDAT  ,ONLY: AXMAG                                           !!! from readini
      USE COM_POTDAT  ,ONLY: POT,POTSPH,POTRWF                               !!! from potfull
      USE COM_RADMESH ,ONLY: NRAD,H,R,DR,WEIGHT,RL                           !!! from radmesh
      USE COM_CHIDAT  ,ONLY: IMATR,CHH,CJH,CHJ,CJJ                           !!! from chipar
      USE COM_LMTPAR  ,ONLY: GAM,AAH,BBH,AAJ,BBJ                             !!! from potpar
      USE COM_MASHDEP ,ONLY: NVAL,LENREL,LENCMP                              !!! from setup
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT                                     !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8, ALLOCATABLE :: AFI(:,:)
	REAL*8, ALLOCATABLE :: AFID(:,:)
	REAL*8, ALLOCATABLE :: AFIP(:,:)
	REAL*8, ALLOCATABLE :: AFIDP(:,:)
	REAL*8, ALLOCATABLE :: AFIDDS(:)
	REAL*8, ALLOCATABLE :: AFIDDPS(:)
	COMPLEX*16, ALLOCATABLE :: WORK1(:)
	COMPLEX*16, ALLOCATABLE :: WORK2(:)
	COMPLEX*16, ALLOCATABLE :: FIH(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: FIJ(:,:,:,:)
	LOGICAL LOG1,LOG,FIRST
	SAVE FIRST
	DATA PI/3.141592653589793D0/,FIRST/.TRUE./
      CALL ABORTNOW()
C MEMORY ALLOCATIONS
	ALLOCATE(WORK1(0:NRADMEM))
	ALLOCATE(WORK2(0:NRADMEM))
	ALLOCATE(FIH(0:NRADMEM,0:LMAXTMEM,NKAPMEM,NSPINMEM))
	ALLOCATE(FIJ(0:NRADMEM,0:LMAXTMEM,NKAPMEM,NSPINMEM))
      SIZE_FIS=2.D0*DBLE(SIZE(FIH)*LENCMP)/1024.D0**2
	ALLOCATE(AFI(0:NRADMEM,0:LMAXTMEM))
	ALLOCATE(AFID(0:NRADMEM,0:LMAXTMEM))
	ALLOCATE(AFIP(0:NRADMEM,0:LMAXTMEM))
	ALLOCATE(AFIDP(0:NRADMEM,0:LMAXTMEM))
	SIZE_AFI=4.D0*DBLE(SIZE(AFI)*LENREL)/1024.D0**2
	ALLOCATE(AFIDDS(0:LMAXTMEM))
	ALLOCATE(AFIDDPS(0:LMAXTMEM))
      CURMEM=CURMEM+SIZE_FIS+SIZE_AFI
      IF(TOTMEM.LT.CURMEM)TXTMEM='<OVRPAR> Subroutine'
      IF(TOTMEM.LT.CURMEM)TOTMEM=CURMEM
C COMPUTE OFF_DIAGONAL ELEMENTS
	DO 1000 ISORT=1,NSORT                             !!! over isort
C Find FIny and FIny-dot radial functions:
	DO ISPIN=1,NSPIN                                  !!! over spins
	DO IKAP=1,NKAP(1)                                 !!! over energies
      CALL LIB_RADSCH_PHIS(ENY(0,ISORT,IKAP,1,ISPIN),AFI,AFIP,
     &AFID,AFIDP,AFIDDS,AFIDDPS,SMT(ISORT),POTRWF(0,ISORT,ISPIN),
     &ILST(ISORT),NRAD(ISORT),H(ISORT),R(0,ISORT),DR(0,ISORT),
     &LRTV(ISORT))
C Transfere to FIH and FIJ convinient functions:
	DO L=0,ILST(ISORT)
	DO IRAD=0,NRAD(ISORT)
	FIH(IRAD,L,IKAP,ISPIN)=AAH(L,ISORT,IKAP,1,ISPIN)*
     &AFI(IRAD,L)+BBH(L,ISORT,IKAP,1,ISPIN)*AFIP(IRAD,L)
	FIJ(IRAD,L,IKAP,ISPIN)=AAJ(L,ISORT,IKAP,1,ISPIN)*
     &AFI(IRAD,L)+BBJ(L,ISORT,IKAP,1,ISPIN)*AFIP(IRAD,L)
      ENDDO    
      ENDDO   
      ENDDO                                             !!! over energies
	ENDDO                                             !!! over spins
	DO ISPIN1=1,NSPIN                                 !!! over ispin1
	DO ISPIN=1,NSPIN                                  !!! over ispin
	DO IKAP1=1,NKAP(1)                                !!! over ikap1
	DO IKAP=1,NKAP(1)                                 !!! over ikap
	DO L=0,ILST(ISORT)                                !!! over l
	LOG1=.FALSE.
	LOG =.FALSE.
	IF(LSPAN(L,ISORT,IKAP1,1))LOG1=.TRUE.
	IF(LSPAN(L,ISORT,IKAP ,1))LOG =.TRUE.
	IF(L.LE.ILSB(ISORT))THEN
	CHH(IKAP1,IKAP,L,ISORT,ISPIN1,ISPIN)=(0.D0,0.D0)
	CHJ(IKAP1,IKAP,L,ISORT,ISPIN1,ISPIN)=(0.D0,0.D0)
	CJH(IKAP1,IKAP,L,ISORT,ISPIN1,ISPIN)=(0.D0,0.D0)
	ENDIF
	CJJ(IKAP1,IKAP,L,ISORT,ISPIN1,ISPIN)=(0.D0,0.D0)
C 1) <H|H>
	IF(LOG1.AND.LOG)THEN
	WORK1(0)=(0.D0,0.D0)
	DO IRAD=1,NRAD(ISORT)          !!! over radial mesh
	WORK1(IRAD)=
     &CONJG(FIH(IRAD,L,IKAP1,ISPIN1))*FIH(IRAD,L,IKAP,ISPIN)*
     &R(IRAD,ISORT)**2*DR(IRAD,ISORT)
      ENDDO                          !!! over radial mesh
	CALL LIB_CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	CHH(IKAP1,IKAP,L,ISORT,ISPIN1,ISPIN)=
     &WORK2(NRAD(ISORT))
	ENDIF
C 2) <J|H> diagonal
	IF(LOG)THEN
	WORK1(0)=(0.D0,0.D0)
	DO IRAD=1,NRAD(ISORT)          !!! over radial mesh
	WORK1(IRAD)=
     &CONJG(FIJ(IRAD,L,IKAP1,ISPIN1))*FIH(IRAD,L,IKAP,ISPIN)*
     &R(IRAD,ISORT)**2*DR(IRAD,ISORT)
      ENDDO                          !!! over radial mesh
	CALL LIB_CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	CJH(IKAP1,IKAP,L,ISORT,ISPIN1,ISPIN)=
     &WORK2(NRAD(ISORT))*GAM(L,ISORT)
	ENDIF
C 3) <H|J> diagonal
	IF(LOG1)THEN
	WORK1(0)=(0.D0,0.D0)
	DO IRAD=1,NRAD(ISORT)          !!! over radial mesh
	WORK1(IRAD)=
     &CONJG(FIH(IRAD,L,IKAP1,ISPIN1))*FIJ(IRAD,L,IKAP,ISPIN)*
     &R(IRAD,ISORT)**2*DR(IRAD,ISORT)
      ENDDO                          !!! over radial mesh
	CALL LIB_CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	CHJ(IKAP1,IKAP,L,ISORT,ISPIN1,ISPIN)=
     &WORK2(NRAD(ISORT))*GAM(L,ISORT)
	ENDIF
C 4) <J|J> diagonal
	WORK1(0)=(0.D0,0.D0)
	DO IRAD=1,NRAD(ISORT)          !!! over radial mesh
	WORK1(IRAD)=
     &CONJG(FIJ(IRAD,L,IKAP1,ISPIN1))*FIJ(IRAD,L,IKAP,ISPIN)*
     &R(IRAD,ISORT)**2*DR(IRAD,ISORT)
      ENDDO                          !!! over radial mesh
	CALL LIB_CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	CJJ(IKAP1,IKAP,L,ISORT,ISPIN1,ISPIN)=
     &WORK2(NRAD(ISORT))*GAM(L,ISORT)**2
      ENDDO                                             !!! over l
      ENDDO                                             !!! over ikap
      ENDDO                                             !!! over ikap1
      ENDDO                                             !!! over spins
      ENDDO                                             !!! over spins
 1000 CONTINUE                                          !!! over isort
C MEMORY DEALLOCATIONS
	DEALLOCATE(WORK1,WORK2,FIH,FIJ)
	DEALLOCATE(AFI,AFID,AFIP,AFIDP,AFIDDS,AFIDDPS)
      CURMEM=CURMEM-SIZE_FIS-SIZE_AFI
	END
