	SUBROUTINE CHI_FTBCHI
************************************************************
*   The calculation of susceptibility                      *
************************************************************
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                        !!! from setup
      USE COM_CONTROL ,ONLY: LIFT,LMTO,IDMF                 !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN              !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP                      !!! from readini
      USE COM_QMESH   ,ONLY: NQPNT,QPNT                     !!! from tetra
      USE COM_KMESH   ,ONLY: NPNT,PNT                       !!! from tetra
      USE COM_FREQU   ,ONLY: NOMGCHI                        !!! from tetra
      USE COM_MSBMESH ,ONLY: TEMP,NMSC                      !!! from readhub
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC        !!! from readini
      USE COM_SUBGROUP,ONLY: NSGQ,NGEQ,KSYMPN,MSYMPN        !!! from delmsh
      USE COM_FERMI   ,ONLY: EF,ZFIL,KFRM                   !!! from ttrints
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT,IUI                !!! from setup
      USE COM_LMTOUT  ,ONLY: ICCHI                          !!! from readini
      USE COM_PHNCHN  ,ONLY: IUTTW                          !!! from channels
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
C *****************************
	IF(ICCHI.EQ.0)RETURN
C FIND FERMI LEVEL
	IF(IDMF.EQ.0.OR.IDMF.EQ.1.OR.IDMF.EQ.2)
     &CALL BND_FNDFRM(EF,ZDFT,EF,100,1.D-09,0.8D0)! search for Fermi energy
	IF(IDMF.EQ.3.AND.KFRM.EQ.0)
     &CALL DMF_FRMFND(EF,ZFIL,EF,0,100,1.D-05,0.8D0)
	IF(IDMF.EQ.4.AND.KFRM.EQ.0)
     &CALL DMF_FNDFRM(EF,ZFIL,EF,NMSC+1,100,1.D-05,0.8D0)
	IF(IDMF.EQ.4.AND.KFRM.EQ.1)
     &CALL DMF_FNDFRM(EF,ZBND,EF,NMSC+1,100,1.D-05,0.8D0)
	IF(IDMF.EQ.5.AND.KFRM.EQ.0)
     &CALL DMF_FRMFND(EF,ZFIL,EF,0,100,1.D-05,0.8D0)
C REDEFINE BANDS CROSSING EF
      CALL CHI_LRCHI(EF,MBNDF,MBNDE,MBNDC)      !!! bands crossing Ef +/- window
C Redefine number of filled and empty bands
      NF=NBNDF(1)
      NE=NBNDE(1)
      NC=NBNDC(1)
      NBNDF(1)=MBNDF
      NBNDE(1)=MBNDE
      NBNDC(1)=MBNDC
C START LOOPING OVER LIST OF Q-POINTS
	CALL CHI_ALLOCATE('A')               !!! memory allocations
      DO 2000 IQPNT=1,NQPNT                !!! over q's
C Comppute BZ-integrals
      CALL CHI_DELMSH(IQPNT)               !!! analisys of k-mesh in IBZ
      CALL CHI_DELMSW(IQPNT)               !!! set fine k-mesh in IBZ
C START LOOPOING OVER FREQUENCIES
      DO 1000 IOMG=0,NOMGCHI               !!! over frequencies
      CALL CHI_CHITET(IQPNT,IOMG)          !!! k-point tetrahedron weights
      CALL CHI_PRINTQ(IQPNT,IOMG)          !!! k-point tetrahedron weights
C INTEGRATE OVER BRILLOUINE ZONE
      CALL CHI_NULCHI(IQPNT,IOMG)          !!! set chi(q,w)=0
      DO ISGQ=1,NSGQ                       !!! DO over star of the q-vector
      DO IPNT=1,NPNT(1)                    !!! DO over k-points
      IF(KSYMPN(ISGQ,IPNT).LT.0)CYCLE
      CALL CHI_FTBVEC(IPNT,ISGQ,IQPNT)     !!! rotate variational coef
      CALL CHI_CHIMAT(IPNT,ISGQ,IQPNT)     !!! prepare matrix elements
      CALL CHI_INTCHI(IPNT,ISGQ,IQPNT,IOMG)!!! integrate susceptibility
      ENDDO                                !!! ENDDO over k-points
      ENDDO                                !!! ENDDO over star of q-vector
      CALL CHI_SYMCHI(IQPNT,IOMG)          !!! symmetrize susceptibility
      CLOSE(UNIT=IUTTW,STATUS='DELETE')
1000  CONTINUE                             !!! over frequencies
2000  CONTINUE                             !!! over q's
	CALL CHI_SETCHI                      !!! store susceptibility
	CALL CHI_ALLOCATE('D')               !!! memory deallocations
C Redefine number of filled and empty bands
      NBNDF(1)=NF
      NBNDE(1)=NE
      NBNDC(1)=NC
	END
