	SUBROUTINE CHI_HUBPAR
***************************************************************
* Calculates potential parameters due to spin-orbit coupling. *
***************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
	USE COM_LMTMEM
      USE COM_CONTROL ,ONLY: LMTO,IASA,NOVR,IDMF                    !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS             !!! from readini
     &                      ,ILST,ILSB,ILSV,LRTV,LSCO                    
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP,EK                      !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN,IATS,ISTS                  !!! from readini
      USE COM_SPHERE  ,ONLY: ZNUC,SMT                               !!! from readini
      USE COM_SYMMLM  ,ONLY: SYM,LMSYM                              !!! from symlmm
      USE COM_HUBDAT  ,ONLY: NHUB,MCRL,LCRL                         !!! from readhub
      USE COM_HUBCOM  ,ONLY: DHUB,VHUB,VCNS,VDBC                    !!! from readhub
      USE COM_DMFDAT  ,ONLY: SIGI                                   !!! from grfmat
	USE COM_CHIDAT  ,ONLY: IMATR                                  !!! from magmat
      USE COM_POTDAT  ,ONLY: POT,POTSPH,POTRWF                      !!! from potfull
      USE COM_INPPAR  ,ONLY: ENY,DNY                                !!! from readini
      USE COM_DHAMPAR ,ONLY: HPARHH,HPARJH,HPARHJ,HPARJJ            !!! from potpar
      USE COM_LMTPAR  ,ONLY: GAM,AAH,AAJ,BBH,BBJ                    !!! from potpar
      USE COM_RADMESH ,ONLY: NRAD,H,R,DR,WEIGHT,RL                  !!! from radmesh
      USE COM_GAUNT   ,ONLY: C                                      !!! from gdata
      USE COM_LMTOUT  ,ONLY: SCRFILE                                !!! from readini
      USE COM_PHNCHN  ,ONLY: IUDMT                                  !!! from readini
      USE COM_MASHDEP ,ONLY: NVAL,LENCMP                            !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8, ALLOCATABLE :: AFI(:,:)
	REAL*8, ALLOCATABLE :: AFID(:,:)
	REAL*8, ALLOCATABLE :: AFIP(:,:)
	REAL*8, ALLOCATABLE :: AFIDP(:,:)
	REAL*8, ALLOCATABLE :: AFIDDS(:)
	REAL*8, ALLOCATABLE :: AFIDDPS(:)
	COMPLEX*16, ALLOCATABLE :: BMAG(:,:)
	COMPLEX*16, ALLOCATABLE :: PARS(:,:)
	COMPLEX*16, ALLOCATABLE :: WORK1(:)
	COMPLEX*16, ALLOCATABLE :: WORK2(:)
	COMPLEX*16, ALLOCATABLE :: FIH(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: FIJ(:,:,:,:)
	LOGICAL LOG1,LOG,FIRST
	SAVE FIRST
	DATA PI/3.141592653589793D0/,C2/0.000013312838D0/,FIRST/.TRUE./
      CALL ABORTNOW()
C RETURN KEYS
	IF(IMATR.EQ.0)RETURN
C MEMORY ALLOCATIONS
	ALLOCATE(WORK1(0:NRADMEM))
	ALLOCATE(WORK2(0:NRADMEM))
	ALLOCATE(FIH(0:NRADMEM,0:LMAXTMEM,NKAPMEM,NSPINMEM))
	ALLOCATE(FIJ(0:NRADMEM,0:LMAXTMEM,NKAPMEM,NSPINMEM))
	ALLOCATE(AFI(0:NRADMEM,0:LMAXTMEM))
	ALLOCATE(AFID(0:NRADMEM,0:LMAXTMEM))
	ALLOCATE(AFIP(0:NRADMEM,0:LMAXTMEM))
	ALLOCATE(AFIDP(0:NRADMEM,0:LMAXTMEM))
	ALLOCATE(AFIDDS(0:LMAXTMEM))
	ALLOCATE(AFIDDPS(0:LMAXTMEM))
	ALLOCATE(BMAG(NWIGMEM,-1:1))
	ALLOCATE(PARS(0:LMAXTMEM,4))
	DO 5000 IATOM=1,NATOM          !!! over atoms
	ISORT=IS(IATOM)
C  Find FIny and FIny-dot radial functions:
	DO ISPIN=1,NSPIN               !!! over spins
	DO IKAP=1,NKAP(1)           !!! over energies
      CALL LIB_RADSCH_PHIS(ENY(0,ISORT,IKAP,1,ISPIN),AFI,AFIP,
     &AFID,AFIDP,AFIDDS,AFIDDPS,SMT(ISORT),POTRWF(0,ISORT,ISPIN),
     &ILST(ISORT),NRAD(ISORT),H(ISORT),R(0,ISORT),DR(0,ISORT),
     &LRTV(ISORT))
C  Transfere to FIH and FIJ convinient functions:
	DO L=0,ILST(ISORT)
	DO IRAD=0,NRAD(ISORT)
	FIH(IRAD,L,IKAP,ISPIN)=AAH(L,ISORT,IKAP,1,ISPIN)*
     &AFI(IRAD,L)+BBH(L,ISORT,IKAP,1,ISPIN)*AFIP(IRAD,L)
	FIJ(IRAD,L,IKAP,ISPIN)=AAJ(L,ISORT,IKAP,1,ISPIN)*
     &AFI(IRAD,L)+BBJ(L,ISORT,IKAP,1,ISPIN)*AFIP(IRAD,L)
      ENDDO   
      ENDDO   
      ENDDO                          !!! over energies
	ENDDO                          !!! over spins
	DO 4000 ISPIN1=1,NSPIN          !!! over spins
	DO 3000 ISPIN =1,NSPIN          !!! over spins
	DO 2000 IKAP1=1,NKAP(1)        !!! over ikap1
	DO 1000 IKAP=1,NKAP(1)         !!! over ikap
	DO L=0,ILST(ISORT)             !!! over l
	LOG1=.FALSE.
	IF(LTPAN(L,IATOM,IKAP1,1))LOG1=.TRUE.
	LOG =.FALSE.
	IF(LTPAN(L,IATOM,IKAP ,1))LOG =.TRUE.
      DO IC=1,4
	PARS(L,IC)=(0.D0,0.D0)
	ENDDO
C 1) <H|dV|H>
	IF(LOG1.AND.LOG)THEN
	WORK1(0)=(0.D0,0.D0)
	DO IRAD=1,NRAD(ISORT)          !!! over radial mesh
	WORK1(IRAD)=
     &CONJG(FIH(IRAD,L,IKAP1,ISPIN1))*FIH(IRAD,L,IKAP,ISPIN)*
     &R(IRAD,ISORT)**2*DR(IRAD,ISORT)
      ENDDO                          !!! over radial mesh
	CALL LIB_CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	PARS(L,1)=WORK2(NRAD(ISORT))
	ENDIF
C 2) <J|dV|H> diagonal
	IF(LOG)THEN
	WORK1(0)=(0.D0,0.D0)
	DO IRAD=1,NRAD(ISORT)          !!! over radial mesh
	WORK1(IRAD)=
     &CONJG(FIJ(IRAD,L,IKAP1,ISPIN1))*FIH(IRAD,L,IKAP,ISPIN)*
     &R(IRAD,ISORT)**2*DR(IRAD,ISORT)
      ENDDO                          !!! over radial mesh
	CALL LIB_CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	PARS(L,2)=WORK2(NRAD(ISORT))*GAM(L,ISORT)
	ENDIF
C 3) <H|dV|J> diagonal
	IF(LOG1)THEN
	WORK1(0)=(0.D0,0.D0)
	DO IRAD=1,NRAD(ISORT)          !!! over radial mesh
	WORK1(IRAD)=
     &CONJG(FIH(IRAD,L,IKAP1,ISPIN1))*FIJ(IRAD,L,IKAP,ISPIN)*
     &R(IRAD,ISORT)**2*DR(IRAD,ISORT)
      ENDDO                          !!! over radial mesh
	CALL LIB_CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	PARS(L,3)=WORK2(NRAD(ISORT))*GAM(L,ISORT)
	ENDIF
C 4) <J|dV|J> diagonal
	WORK1(0)=(0.D0,0.D0)
	DO IRAD=1,NRAD(ISORT)          !!! over radial mesh
	WORK1(IRAD)=
     &CONJG(FIJ(IRAD,L,IKAP1,ISPIN1))*FIJ(IRAD,L,IKAP,ISPIN)*
     &R(IRAD,ISORT)**2*DR(IRAD,ISORT)
      ENDDO                          !!! over radial mesh
	CALL LIB_CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	PARS(L,4)=WORK2(NRAD(ISORT))*GAM(L,ISORT)**2
      ENDDO                          !!! over l
C SET HAMILTONIAN PARAMETERS TO ZERO
	DO L1=0,ILST(ISORT)            !!! over l1
	LOG1=.FALSE.
	IF(LTPAN(L1,IATOM,IKAP1,1))LOG1=.TRUE.
	DO M1=-L1,L1                   !!! over m1
	L1M1=L1*(L1+1)+M1+1
	DO L=0,ILST(ISORT)             !!! over l
	LOG=.FALSE.
	IF(LTPAN(L,IATOM,IKAP,1))LOG=.TRUE.
	DO M=-L,L                      !!! over m
	LM=L*(L+1)+M+1
	IF(L1.LE.ILSB(ISORT).AND.L.LE.ILSB(ISORT))
     &HPARHH(L1M1,LM,IATOM,IKAP1,IKAP)=(0.D0,0.D0)
	IF(L.LE.ILSB(ISORT))
     &HPARJH(L1M1,LM,IATOM,IKAP1,IKAP)=(0.D0,0.D0)
	IF(L1.LE.ILSB(ISORT))
     &HPARHJ(L1M1,LM,IATOM,IKAP1,IKAP)=(0.D0,0.D0)
	HPARJJ(L1M1,LM,IATOM,IKAP1,IKAP)=(0.D0,0.D0)
      ENDDO                          !!! over m
      ENDDO                          !!! over l
      ENDDO                          !!! over m1
      ENDDO                          !!! over l1
C COMPUTE MAGNETIC FIELD
	DO L=0,ILSB(ISORT)             !!! over l
	DO M1=-L,L                     !!! over m1
	DO M=-L,L                      !!! over m
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M1+1 !!!    (l,m1 m)
	BMAG(IU, 0)=(0.D0,0.D0)
	BMAG(IU,-1)=(0.D0,0.D0)
	BMAG(IU,+1)=(0.D0,0.D0)
	IF(IDMF.EQ.1)THEN
	BMAG(IU, 0)=-((VCNS(IU,IATOM,1,1)-VCNS(IU,IATOM,NSPIN,1))
     &            )/2.D0
	ELSEIF(IDMF.EQ.2)THEN
	BMAG(IU, 0)=
     &         -((VHUB(IU,IATOM,1,1)-VHUB(IU,IATOM,NSPIN,1))+
     &           (VCNS(IU,IATOM,1,1)-VCNS(IU,IATOM,NSPIN,1))-
     &           (VDBC(IU,IATOM,1,1)-VDBC(IU,IATOM,NSPIN,1)))/2.D0
	ELSEIF(IDMF.GT.2)THEN
	BMAG(IU, 0)=
     &         -((SIGI(IU,IATOM,1,1)-SIGI(IU,IATOM,NSPIN,1))-
     &           (VDBC(IU,IATOM,1,1)-VDBC(IU,IATOM,NSPIN,1)))/2.D0
	ENDIF
	IF(IDMF.EQ.1.AND.NORBS.EQ.2)THEN
	BMAG(IU,-1)=-(VCNS(IU,IATOM,NSPIN,NORBS))/SQRT(2.D0)
	BMAG(IU,+1)=+(VCNS(IU,IATOM,    1,NORBS))/SQRT(2.D0)
	ELSEIF(IDMF.EQ.2.AND.NORBS.EQ.2)THEN
	BMAG(IU,-1)=
     &         -(VHUB(IU,IATOM,NSPIN,NORBS)+
     &           VCNS(IU,IATOM,NSPIN,NORBS)-
     &           VDBC(IU,IATOM,NSPIN,NORBS))/SQRT(2.D0)
	BMAG(IU,+1)=
     &         +(VHUB(IU,IATOM,    1,NORBS)+
     &           VCNS(IU,IATOM,    1,NORBS)-
     &           VDBC(IU,IATOM,    1,NORBS))/SQRT(2.D0)
	ELSEIF(IDMF.GT.2.AND.NORBS.EQ.2)THEN
	BMAG(IU,-1)=
     &         -(SIGI(IU,IATOM,NSPIN,NORBS)-
     &           VDBC(IU,IATOM,NSPIN,NORBS))/SQRT(2.D0)
	BMAG(IU,+1)=
     &         +(SIGI(IU,IATOM,    1,NORBS)-
     &           VDBC(IU,IATOM,    1,NORBS))/SQRT(2.D0)
	ENDIF
	ENDDO                          !!! over m
	ENDDO                          !!! over m1
	ENDDO                          !!! over l
C Do over polarizations	
      DO 500 MU=-1,1                 !!! over mu
C SET ORBTIAL FIELD PARAMETERS
	DO L=0,ILSB(ISORT)             !!! over l
	IF(.NOT.LCRL(L,IATOM))CYCLE
	LOG1=.FALSE.
	IF(LTPAN(L,IATOM,IKAP1,1))LOG1=.TRUE.
	LOG=.FALSE.
	IF(LTPAN(L,IATOM,IKAP,1))LOG=.TRUE.	
	DO M1=-L,L                     !!! over m1
	LM1=L*(L+1)+M1+1
	DO M=-L,L                      !!! over m
	LM=L*(L+1)+M+1
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M1+1 !!!    (l,m1 m)
	IF(LOG1.AND.LOG)
     &HPARHH(LM1,LM,IATOM,IKAP1,IKAP)=PARS(L,1)*BMAG(IU,MU)
 	IF(LOG)
     &HPARJH(LM1,LM,IATOM,IKAP1,IKAP)=PARS(L,2)*BMAG(IU,MU)
 	IF(LOG1)
     &HPARHJ(LM1,LM,IATOM,IKAP1,IKAP)=PARS(L,3)*BMAG(IU,MU)
 	HPARJJ(LM1,LM,IATOM,IKAP1,IKAP)=PARS(L,4)*BMAG(IU,MU)
      ENDDO                          !!! over m
      ENDDO                          !!! over m1
      ENDDO                          !!! over l
C STORE POTENTIAL PARAMETERS
      IC=1
	IREC=IKAP1+NKAP(1)*(IKAP-1)+NKAP(1)**2*(MU+1)+
     &NKAP(1)**2*3*(IATOM-1)+
     &NKAP(1)**2*3*NATOM*(ISPIN1-1)+
     &NKAP(1)**2*3*NATOM*NSPIN*(ISPIN-1)+
     &NKAP(1)**2*3*NATOM*NSPIN*NSPIN*(IC-1)
	WRITE(IUDMT,REC=IREC)
     &((HPARHH(L1M1,LM,IATOM,IKAP1,IKAP),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((HPARJH(L1M1,LM,IATOM,IKAP1,IKAP),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((HPARHJ(L1M1,LM,IATOM,IKAP1,IKAP),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &((HPARJJ(L1M1,LM,IATOM,IKAP1,IKAP),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2)
 500  CONTINUE                       !!! over mu
1000	CONTINUE                       !!! over ikap
2000	CONTINUE                       !!! over ikap1
3000	CONTINUE                       !!! over spins
4000	CONTINUE                       !!! over spins
5000	CONTINUE                       !!! over atoms
C MEMORY DEALLOCATIONS
	DEALLOCATE(WORK1,WORK2,FIH,FIJ,AFI,AFID,AFIP,AFIDP)
	DEALLOCATE(AFIDDS,AFIDDPS,BMAG,PARS)
	END
