	SUBROUTINE CHI_INTCHI(IPNT,ISGQ,IQPNT,IOMG)
***********************************************************
*  Calculate susceptibility                               *
***********************************************************
C SET ARRAY-SIZE DATA
	USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
	USE COM_LMTMEM                                              !!! from setup
	USE COM_CONTROL ,ONLY: LIFT,LMTO,IASA,NPFR,NOVR             !!! from readini
	USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS,ILSB      !!! from readini
	USE COM_LATPAR  ,ONLY: PAR,ORTH,OMEGAC                      !!! from readini
	USE COM_TBBPAR  ,ONLY: LTBAS,LSBAS,INBAS,NTBAS              !!! from readhop
	USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC,NBNDH,POLUS  !!! from readini
	USE COM_KMESH   ,ONLY: NPNT,PNT,WGT                         !!! from tetra
      USE COM_HUBDAT  ,ONLY: MCRL,LCRL,NCLM                       !!! from readhub
	USE COM_SUBGROUP,ONLY: NSGQ,NGEQ,ISG                        !!! from delmsh
	USE COM_SYMMESH ,ONLY: IG0IG1,IK0IK1                        !!! from delmsh
	USE COM_GROUPS  ,ONLY: NGROUP,U,IP,RDC,SHIFT,INV,IKOV       !!! from groups
	USE COM_CHIDAT  ,ONLY: NCHI,INCHI,CHI0,CHIM,IMATR,GINT,GMAT !!! from intchi
	USE COM_ENERGY  ,ONLY: ETRT                                 !!! from bands
	USE COM_QMESH   ,ONLY: NQPNT,QPNT                           !!! from tetra
	USE COM_FREQU   ,ONLY: NOMGCHI,OMGCHI                       !!! from tetra
	USE COM_MASHDEP ,ONLY: LENCMP,NVAL                          !!! from readini
	USE COM_CHANNELS,ONLY: IUCHI                                !!! from channels
	USE COM_PHNCHN  ,ONLY: IUTTW                                !!! from channels
	USE COM_UNIT    ,ONLY: IUN,IUR,IUT,IUI                      !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8, ALLOCATABLE :: WEIGK(:,:)
	REAL*8, ALLOCATABLE :: WEIGQ(:,:,:)
	REAL*8, ALLOCATABLE :: WGTOM(:,:,:)
	COMPLEX*16 WTR1,WTR2,WTI1,WTI2
	DATA PI/3.141592653589793D0/
C MEMORY ALLOCATIONS
	ALLOCATE(WEIGK(NBNDC(1)*NSPINMEM,4))
	ALLOCATE(WEIGQ(NBNDC(1)*NSPINMEM,NBNDC(1)*NSPINMEM,6))
	ALLOCATE(WGTOM(NBNDC(1)*NSPINMEM,NBNDC(1)*NSPINMEM,4))
C  SET POINT-GROUP INFORMATION
	IRK=ISG(1,ISGQ)       !!!  element "g"  in the main G-list
	IGK=IKOV(IRK)         !!!  element "g"  after Kovalev
	IPNTK=IPNT            !!!  point   "k"
	IRQ=IG0IG1(IPNT,IRK)  !!!  element "g'" in the main G-list
	IGQ=IKOV(IRQ)         !!!  element "g'" after Kovalev
	IPNTQ=IK0IK1(IPNT,IRK)!!!  point   "k'" such that g*k+q=g'*k'
C  READ 1/E TETRAHEDRON WEIGHTS FOR BRILLOUIN ZONE INTEGRATION
	IREC=1+IPNTK+NPNT(1)*(ISGQ-1)
	READ(IUTTW,REC=IREC)WGTQ1,(((WEIGQ(IBANC,IBANC1,IC),
     &  IBANC=1,NBNDC(1)*NSPIN),IBANC1=1,NBNDC(1)*NSPIN),
     &  IC=1,6),((WEIGK(IBANC,IC),IBANC=1,NBNDC(1)*NSPIN),
     &  IC=1,4),(((WGTOM(IBANC,IBANC1,IC),IBANC=1,
     &  NBNDC(1)*NSPIN),IBANC1=1,NBNDC(1)*NSPIN),IC=1,4)
C ***** DO GLOBALLY OVER SPINORS ********
C READ SUSCEPTIBILITY
	CALL CHIFILES(IQPNT,IOMG,IUCHI,'R')
C  CALCULATE CONTRIBUTION FROM THIS K-POINT TO SUSCEPTIBILITY
	DO IBNDS=1,NSPIN                               !!! over spin subbands
	DO IBNDT=1,NBNDF(1)                            !!! over filled bands
	IBNDC=IBNDT-NBNDE(1)+1
	IBANC=IBNDS+NSPIN*(IBNDC-1)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	DO IBNDS1=1,NSPIN                              !!! over spin subbands
	DO IBNDT1=NBNDE(1),NBNDT(1)+NBNDH(1)           !!! over empty bands
	IBNDC1=IBNDT1-NBNDE(1)+1
	IBANC1=IBNDS1+NSPIN*(IBNDC1-1)
	IBAND1=IBNDS1+NSPIN*(IBNDT1-1)
C  FOR THE FERMI SURFACE BANDS
	IF(IBNDT.GE.NBNDE(1).AND.IBNDT1.LE.NBNDF(1))THEN
	DEK1=OMGCHI(IOMG)+ETRT(IBAND,IPNTK,1)-ETRT(IBAND1,IPNTQ,1)
	DEK2=OMGCHI(IOMG)+ETRT(IBAND1,IPNTK,1)-ETRT(IBAND,IPNTQ,1)
C  1/E TETRAHEDRON WEIGHTS
 	WQ1=    WEIGQ(IBANC,IBANC1,1) !!! f(kj)*[1-f(k+qj')]/[E(kj)-E(k+qj')]
 	WQ2=    WEIGQ(IBANC1,IBANC,2) !!! [1-f(kj')]*f(k+qj)/[E(kj')-E(k+qj)]
C  WEIGHTS FROM DENSITY-OF-STATES AT EF 
 	WQ1=WQ1+WEIGQ(IBANC,IBANC1,3) !!! +0.5*Delta[E(kj )-Ef]
 	WQ2=WQ2+WEIGQ(IBANC1,IBANC,4) !!! -0.5*Delta[E(kj')-Ef]
C  WEIGHTS FROM LORENTZIAN SMEARING
	WQ1=WQ1+WEIGK(IBANC,1)*DEK1/(DEK1**2+POLUS**2) !!! f(kj)
	WQ2=WQ2+WEIGK(IBANC,2)*DEK2/(DEK2**2+POLUS**2) !!! f(k+qj')
 	WQ1=WQ1-WEIGQ(IBANC,IBANC1,5) !!! f(kj)*[1-f(k+qj')]/[E(kj)-E(k+qj')]
 	WQ2=WQ2-WEIGQ(IBANC1,IBANC,6) !!! [1-f(kj')]*f(k+qj)/[E(kj')-E(k+qj)]
C  WEIGHTS FROM THE IMAGINARY PART
	WI1=-PI*WGTOM(IBANC,IBANC1,1) !!! (f(kj)-f(k+qj')*d(E(kj)-E(k+qj')+Omega)
	WI2=0.D0                      !!! (f(kj')-f(k+qj)*d(E(kj')-E(k+qj)+Omega)
C  OTHERWISE, USUAL TETRAHEDRON WEIGHTS
	ELSEIF(IBNDT.GE.NBNDE(1).AND.IBNDT1.GT.NBNDF(1))THEN
	DEK1=OMGCHI(IOMG)+ETRT(IBAND,IPNTK,1)-ETRT(IBAND1,IPNTQ,1)
	DEK2=OMGCHI(IOMG)+ETRT(IBAND1,IPNTK,1)-ETRT(IBAND,IPNTQ,1)
		IF(ABS(DEK1).LE.1.D-10)THEN
		IF(ABS(WEIGK(IBANC,1)).GE.1.D-10)
     &  	WRITE(IUT,*)'<INTCHI> :: ERROR IN WEIGHTS'
		WEIGK(IBANC,1)=0.D0
		DEK1=1.D0
		ENDIF
		IF(ABS(DEK2).LE.1.D-10)THEN
		IF(ABS(WEIGK(IBANC,2)).GE.1.D-10)
     &  	WRITE(IUT,*)'<INTCHI> :: ERROR IN WEIGHTS'
		WEIGK(IBANC,2)=0.D0
		DEK2=1.D0
		ENDIF
	WQ1=WEIGK(IBANC,1)/DEK1     !!! f(kj)  /[E(kj)-E(k+qj')]
	WQ2=WEIGK(IBANC,2)/DEK2     !!! f(k+qj)/[E(kj')-E(k+qj)]
	WI1=0.D0
	WI2=0.D0
	ELSEIF(IBNDT.LT.NBNDE(1).AND.IBNDT1.LE.NBNDF(1))THEN
	DEK1=OMGCHI(IOMG)+ETRT(IBAND,IPNTK,1)-ETRT(IBAND1,IPNTQ,1)
	DEK2=OMGCHI(IOMG)+ETRT(IBAND1,IPNTK,1)-ETRT(IBAND,IPNTQ,1)
		IF(ABS(DEK1).LE.1.D-10)THEN
		IF(ABS(WGTQ1-WEIGK(IBANC1,2)).GE.1.D-10)
     &  	WRITE(IUT,*)'<INTCHI> :: ERROR IN WEIGHTS'
		WEIGK(IBANC1,2)=WGTQ1
		DEK1=1.D0
		ENDIF
		IF(ABS(DEK2).LE.1.D-10)THEN
		IF(ABS(WGTQ1-WEIGK(IBANC1,1)).GE.1.D-10)
     &  	WRITE(IUT,*)'<INTCHI> :: ERROR IN WEIGHTS'
		WEIGK(IBANC1,1)=WGTQ1
		DEK1=1.D0
		ENDIF
	WQ1=(WGTQ1-WEIGK(IBANC1,2))/DEK1 !!! [1-f(k+qj')]/[E(kj)-E(k+qj')]
	WQ2=(WGTQ1-WEIGK(IBANC1,1))/DEK2 !!! [1-f(kj')  ]/[E(kj')-E(k+qj)]
	WI1=0.D0
	WI2=0.D0
	ELSEIF(IBNDT.LT.NBNDE(1).AND.IBNDT1.GT.NBNDF(1))THEN
	DEK1=OMGCHI(IOMG)+ETRT(IBAND,IPNTK,1)-ETRT(IBAND1,IPNTQ,1)
	DEK2=OMGCHI(IOMG)+ETRT(IBAND1,IPNTK,1)-ETRT(IBAND,IPNTQ,1)
	WQ1=WGTQ1/DEK1              !!! 1/[E(kj)-E(k+qj')]
	WQ2=WGTQ1/DEK2              !!! 1/[E(kj')-E(k+qj)]
	WI1=0.D0
	WI2=0.D0
	ENDIF
C  SET TOTAL COMPLEX WEIGHT
	WTR1=DCMPLX(WQ1,0.D0)
	WTR2=DCMPLX(WQ2,0.D0)
C  COMPUTE IMAGINARY PART ONLY
 	WTI1=DCMPLX(WI1,0.D0)
 	WTI2=DCMPLX(WI2,0.D0)
	IF(ABS(WTR1)+ABS(WTR2)+ABS(WTI1)+ABS(WTI2).LE.1.D-12)CYCLE
      DO IM1SPIN=1,NSPIN                             !!! over im1spin
      DO IK1SPIN=1,NSPIN                             !!! over ik1spin
	DO IATOM1=1,NATOM                              !!! over iatom1
	ISORT1=IS(IATOM1)
	IF(MCRL(IATOM1).EQ.0)CYCLE
	DO L1=0,ILSB(ISORT1)                           !!! over l1
	IF(LCRL(L1,IATOM1).EQ.0)CYCLE
	DO M1=-L1,L1                                   !!! over m1
	DO K1=-L1,L1                                   !!! over k1
	IU1=L1*(2*L1-1)*(2*L1+1)/3+(2*L1+1)*(L1+K1)+L1+M1+1 !!!    (l1,m1 k1)
	JU1=L1*(2*L1-1)*(2*L1+1)/3+(2*L1+1)*(L1+M1)+L1+K1+1 !!!    (l1,k1 m1)
	ICHI1=INCHI(IU1,IATOM1,IM1SPIN,IK1SPIN)
	JCHI1=INCHI(JU1,IATOM1,IK1SPIN,IM1SPIN)
      DO IMSPIN=1,NSPIN                              !!! over imspin
      DO IKSPIN=1,NSPIN                              !!! over ikspin
	DO IATOM=1,NATOM                               !!! over iatom
	ISORT=IS(IATOM)
	IF(MCRL(IATOM).EQ.0)CYCLE
	DO L=0,ILSB(ISORT)                             !!! over l 
	IF(LCRL(L,IATOM).EQ.0)CYCLE
	DO M=-L,L                                      !!! over m 
	DO K=-L,L                                      !!! over k
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+K)+L+M+1 !!!    (l,m k)
	JU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+K+1 !!!    (l,k m)
	ICHI=INCHI(IU,IATOM,IMSPIN,IKSPIN)
	JCHI=INCHI(JU,IATOM,IKSPIN,IMSPIN)
	IF(NORBS.EQ.2.OR.(NORBS.EQ.1.AND.
     &(IK1SPIN.EQ.IBNDS1.AND.IM1SPIN.EQ.IBNDS.AND.
     & IM SPIN.EQ.IBNDS1.AND.IK SPIN.EQ.IBNDS)))THEN
      CHI0(ICHI1,ICHI,1)=CHI0(ICHI1,ICHI,1)+
     &WTR1*DCONJG(CHIM(JCHI1,IBAND1,IBAND))*
     &            CHIM(ICHI,IBAND1,IBAND)
      CHI0(ICHI1,ICHI,2)=CHI0(ICHI1,ICHI,2)+
     &WTI1*DCONJG(CHIM(JCHI1,IBAND1,IBAND))*
     &            CHIM(ICHI,IBAND1,IBAND)
	ENDIF
	IF(NORBS.EQ.2.OR.(NORBS.EQ.1.AND.
     &(IK1SPIN.EQ.IBNDS.AND.IM1SPIN.EQ.IBNDS1.AND.
     & IM SPIN.EQ.IBNDS.AND.IK SPIN.EQ.IBNDS1)))THEN
      CHI0(ICHI1,ICHI,1)=CHI0(ICHI1,ICHI,1)-
     &WTR2*DCONJG(CHIM(JCHI1,IBAND,IBAND1))*
     &            CHIM(ICHI,IBAND,IBAND1)
      CHI0(ICHI1,ICHI,2)=CHI0(ICHI1,ICHI,2)-
     &WTI2*DCONJG(CHIM(JCHI1,IBAND,IBAND1))*
     &            CHIM(ICHI,IBAND,IBAND1)
	ENDIF
	ENDDO                                          !!! over k
	ENDDO                                          !!! over m
	ENDDO                                          !!! over l
	ENDDO                                          !!! over iatom
	ENDDO                                          !!! over ikspin
	ENDDO                                          !!! over imspin
	ENDDO                                          !!! over k1
	ENDDO                                          !!! over m1
	ENDDO                                          !!! over l1
	ENDDO                                          !!! over iatom1
	ENDDO                                          !!! over ik1spin
	ENDDO                                          !!! over im1spin
C Contribution to exchange constants
	IF(IMATR.GT.0.AND.(IASA.EQ.1.OR.IASA.EQ.2))THEN
	DO IC1=1,3                                     !!! iver ic1
	DO IATOM1=1,NATOM                              !!! over iatom1
	ISORT1=IS(IATOM1)
	IND1=0
      DO IM1SPIN=1,NSPIN                             !!! over im1spin
      DO IK1SPIN=1,NSPIN                             !!! over ik1spin
	DO MU1=-1,1                                    !!! over mu1
	IND1=IND1+1
	DO IC=1,3                                      !!! over ic
	DO IATOM=1,NATOM                               !!! over iatom
	ISORT=IS(IATOM)
	IND=0
      DO IMSPIN=1,NSPIN                              !!! over imspin
      DO IKSPIN=1,NSPIN                              !!! over ikspin
	DO MU=-1,1                                     !!! over mu
	IND=IND+1
	IF(NORBS.EQ.2.OR.(NORBS.EQ.1.AND.
     &(IK1SPIN.EQ.IBNDS1.AND.IM1SPIN.EQ.IBNDS.AND.
     & IM SPIN.EQ.IBNDS1.AND.IK SPIN.EQ.IBNDS)))THEN
	GINT(IND1,IATOM1,IND,IATOM,IC1,IC)=
     &GINT(IND1,IATOM1,IND,IATOM,IC1,IC)+
     &(-1)**MU1*DCONJG(
     &GMAT(IBAND1,IBAND,IK1SPIN,IM1SPIN,-MU1,IATOM1,IC1))*
     &GMAT(IBAND1,IBAND,IMSPIN, IKSPIN,  MU, IATOM, IC)*WTR1
	ENDIF
	IF(NORBS.EQ.2.OR.(NORBS.EQ.1.AND.
     &(IK1SPIN.EQ.IBNDS.AND.IM1SPIN.EQ.IBNDS1.AND.
     & IM SPIN.EQ.IBNDS.AND.IK SPIN.EQ.IBNDS1)))THEN
	GINT(IND1,IATOM1,IND,IATOM,IC1,IC)=
     &GINT(IND1,IATOM1,IND,IATOM,IC1,IC)-
     &(-1)**MU1*DCONJG(
     &GMAT(IBAND,IBAND1,IK1SPIN,IM1SPIN,-MU1,IATOM1,IC1))*
     &GMAT(IBAND,IBAND1, IMSPIN, IKSPIN, MU, IATOM, IC)*WTR2
	ENDIF
	ENDDO                                          !!! over mu
	ENDDO                                          !!! over ikspin
	ENDDO                                          !!! over imspin
	ENDDO                                          !!! over iatom
	ENDDO                                          !!! over ic
	ENDDO                                          !!! over mu1
	ENDDO                                          !!! over ik1spin
	ENDDO                                          !!! over im1spin
	ENDDO                                          !!! over iatom1
	ENDDO                                          !!! over ic1
	ENDIF
	ENDDO                                          !!! over bands
	ENDDO                                          !!! over spin subbands
	ENDDO                                          !!! over bands
	ENDDO                                          !!! over spin subbands
	CALL CHIFILES(IQPNT,IOMG,IUCHI,'W')
	DEALLOCATE(WEIGK,WEIGQ,WGTOM)
	END
