	SUBROUTINE CHI_LMTCHI
************************************************************
*   The calculation of susceptibility                      *
************************************************************
C SET EXTERNAL CONNECTIONS
	USE COM_LMTMEM                                        !!! from setup
	USE COM_CONTROL ,ONLY: LIFT,LMTO,IDMF                 !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,NHSORT !!! from readini
	USE COM_KAPPAR  ,ONLY: NPAN,NKAP                      !!! from readini
	USE COM_QMESH   ,ONLY: NQPNT,QPNT                     !!! from tetra
	USE COM_KMESH   ,ONLY: NPNT,PNT                       !!! from tetra
	USE COM_FREQU   ,ONLY: NOMGCHI                        !!! from tetra
      USE COM_MSBMESH ,ONLY: TEMP,NMSC                      !!! from readhub
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC        !!! from readini
	USE COM_SUBGROUP,ONLY: NSGQ,NGEQ,KSYMPN,MSYMPN        !!! from delmsh
      USE COM_FERMI   ,ONLY: EF,ZDFT,ZBND,KFRM              !!! from ttrints
	USE COM_UNIT    ,ONLY: IUN,IUR,IUT,IUI                !!! from setup
	USE COM_LMTOUT  ,ONLY: ICCHI                          !!! from readini
	USE COM_PHNCHN  ,ONLY: IUTTW,IUDMT                    !!! from channels
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
C *****************************
	IF(ICCHI.EQ.0)RETURN
	CALL CHI_ALLOCATE('A')                    !!! memory allocations
C FIND FERMI LEVEL
	IF(IDMF.EQ.0.OR.IDMF.EQ.1.OR.IDMF.EQ.2)
     &CALL BND_FNDFRM(EF,ZDFT,EF,100,1.D-09,0.8D0)! search for Fermi energy
	IF(IDMF.EQ.3.AND.KFRM.EQ.0)
     &CALL DMF_FRMFND(EF,ZDFT,EF,0,100,1.D-05,0.8D0)
	IF(IDMF.EQ.4.AND.KFRM.EQ.0)
     &CALL DMF_FNDFRM(EF,ZDFT,EF,NMSC+1,100,1.D-05,0.8D0)
	IF(IDMF.EQ.4.AND.KFRM.EQ.1)
     &CALL DMF_FNDFRM(EF,ZBND,EF,NMSC+1,100,1.D-05,0.8D0)
	IF(IDMF.EQ.5.AND.KFRM.EQ.0)
     &CALL DMF_FRMFND(EF,ZDFT,EF,0,100,1.D-05,0.8D0)
C REDEFINE BANDS CROSSING EF
      CALL CHI_LRCHI(EF,MBNDF,MBNDE,MBNDC)      !!! bands crossing Ef +/- window
C Redefine number of filled and empty bands
      NF=NBNDF(1)
      NE=NBNDE(1)
      NC=NBNDC(1)
	NBNDF(1)=MBNDF
	NBNDE(1)=MBNDE
	NBNDC(1)=MBNDC
C START LOOPING OVER LIST OF Q-POINTS
	CALL CHI_CHIPAR
	CALL CHI_MAGPAR
	CALL CHI_ORBPAR
	CALL CHI_HUBPAR
	DO 2000 IQPNT=1,NQPNT                !!! over q's
C Compute BZ-integrals
	CALL CHI_DELMSH(IQPNT)               !!! analisys of k-mesh in IBZ
	CALL CHI_DELMSW(IQPNT)               !!! set fine k-mesh in IBZ
C START LOOPOING OVER FREQUENCIES
	DO 1000 IOMG=0,NOMGCHI               !!! over frequencies
	CALL CHI_CHITET(IQPNT,IOMG)          !!! k-point tetrahedron weights
	CALL CHI_PRINTQ(IQPNT,IOMG)          !!! k-point tetrahedron weights
C INTEGRATE OVER BRILLOUINE ZONE
	CALL CHI_NULCHI(IQPNT,IOMG)          !!! set chi(q,w)=0
	DO ISGQ=1,NSGQ                       !!! DO over star of the q-vector
	DO IPNT=1,NPNT(1)                    !!! DO over k-points
	IF(KSYMPN(ISGQ,IPNT).LT.0)CYCLE
	CALL CHI_LMTVEC(IPNT,ISGQ,IQPNT)     !!! rotate variational coef
	CALL CHI_CHIMAT(IPNT,ISGQ,IQPNT)     !!! prepare matrix elements
	CALL CHI_MAGMAT(IPNT,ISGQ,IQPNT)     !!! prepare matrix elements
 	CALL CHI_INTCHI(IPNT,ISGQ,IQPNT,IOMG)!!! integrate susceptibility
 	ENDDO                                !!! ENDDO over k-points
	ENDDO                                !!! ENDDO over star of q-vector
	CALL CHI_SYMCHI(IQPNT,IOMG)          !!! symmetrize susceptibility
	CLOSE(UNIT=IUTTW,STATUS='DELETE')
1000	CONTINUE                             !!! over frequencies
2000	CONTINUE                             !!! over q's
	CLOSE(UNIT=IUDMT,STATUS='DELETE')
	CALL CHI_SETCHI                      !!! store susceptibility
	CALL CHI_ALLOCATE('D')               !!! memory deallocations
C Redefine number of filled and empty bands
      NBNDF(1)=NF
      NBNDE(1)=NE
      NBNDC(1)=NC
	END




      SUBROUTINE CHI_LRCHI(EF,MBNDF,MBNDE,MBNDC)
***********************************************************
*  Prints the bands within +/- window from Ef.            *
***********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_CONTROL ,ONLY: LMTO,IASA,NPFR                         !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS                !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP                              !!! from readini
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC,NBNDH,WINDOW   !!! from readini
      USE COM_KMESH   ,ONLY: NPNT,PNT                               !!! from tetra
      USE COM_ENERGY  ,ONLY: ETRT                                   !!! from bands
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT                            !!! from setup
      USE COM_LABELS  ,ONLY: TXTSP                                  !!! from setup
C SET LOCAL VARIBLES
      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER NBNDFIL(2),NBNDEMP(2)
      DATA PI/3.141592653589793D0/
C DEFINE # OF FILLED BANDS IF THERE IS NO SPIN-ORBIT COUPLING
      IF(NORBS.EQ.1)THEN
      DO IBNDS=1,NSPIN
      NBNDFIL(IBNDS)=0
      DO IBNDT=1,NBNDT(1)+NBNDH(1)
      IBAND=IBNDS+NSPIN*(IBNDT-1)
      IWINF=0
      DO IPNT=1,NPNT(1)
      IF(ETRT(IBAND,IPNT,1).LT.EF-WINDOW)IWINF=IWINF+1
      ENDDO
      IF(IWINF.EQ.NPNT(1))NBNDFIL(IBNDS)=IBNDT
      ENDDO
      NBNDEMP(IBNDS)=NBNDT(1)+NBNDH(1)+1
      DO IBNDT=NBNDT(1)+NBNDH(1),1,-1
      IBAND=IBNDS+NSPIN*(IBNDT-1)
      IWINE=0
      DO IPNT=1,NPNT(1)
      IF(ETRT(IBAND,IPNT,1).GT.EF+WINDOW)IWINE=IWINE+1
      ENDDO
      IF(IWINE.EQ.NPNT(1))NBNDEMP(IBNDS)=IBNDT
      ENDDO
      ENDDO
      MBNDFIL=MIN(NBNDFIL(1),NBNDFIL(NSPIN))
      MBNDEMP=MAX(NBNDEMP(1),NBNDEMP(NSPIN))
C DEFINE # OF FILLED BANDS IF THERE IS SPIN-ORBIT COUPLING
      ELSEIF(NORBS.EQ.2)THEN
      MBNDFIL=0
      DO IBAND=1,(NBNDT(1)+NBNDH(1))*NSPIN
      IWINF=0
      DO IPNT=1,NPNT(1)
      IF(ETRT(IBAND,IPNT,1).LT.EF-WINDOW)IWINF=IWINF+1
      ENDDO
      IF(IWINF.EQ.NPNT(1))MBNDFIL=IBAND
      ENDDO
      MBNDEMP=(NBNDT(1)+NBNDH(1))*NSPIN+1
      DO IBAND=(NBNDT(1)+NBNDH(1))*NSPIN,1,-1
      IWINE=0
      DO IPNT=1,NPNT(1)
      IF(ETRT(IBAND,IPNT,1).GT.EF+WINDOW)IWINE=IWINE+1
      ENDDO
      IF(IWINE.EQ.NPNT(1))MBNDEMP=IBAND
      ENDDO
      IF(MOD(MBNDFIL,2).NE.0)MBNDFIL=MBNDFIL-1
      IF(MOD(MBNDEMP,2).NE.0)MBNDEMP=MBNDEMP+1
      IF(MBNDFIL.LT.0)MBNDFIL=0
      MBNDFIL=MBNDFIL/2
      MBNDEMP=MBNDEMP/2
      ENDIF
      WRITE(IUN,1010)MBNDFIL
      WRITE(IUN,1020)MBNDEMP-MBNDFIL-1
      MBNDF=MBNDEMP-1
      MBNDE=MBNDFIL+1
      MBNDC=MBNDEMP-MBNDFIL-1
1010  FORMAT(1X,'LR information: # of fully filled bands (nff) =',I4)
1020  FORMAT(1X,'LR information: # of bands crossing  EF (nef) =',I4)
      END
