	SUBROUTINE CHI_LMTVEC(IPNT,ISGQ,IQPNT)
************************************************************
*  Find LMT-variational coefficients A(L,g*kj)             *
*  at the point g*k of the Brillouin Zone. Find also these *
*  eigenvectors for the point g*k+q=g'*k'.                 *
************************************************************
C  SET ARRAY-SIZE DATA
      USE DIM_LMTART
C  SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                           !!! from setup
      USE COM_CONTROL ,ONLY: LIFT,LMTO,IASA,NPFR,NOVR          !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS,ILSB,ILST! from readini
      USE COM_LATPAR  ,ONLY: PAR,ORTH,OMEGAC                   !!! from readini
      USE COM_HUBDAT  ,ONLY: MCRL,LCRL,NCLM                    !!! from readhub
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC,NBNDH     !!! from readini
      USE COM_KMESH   ,ONLY: NPNT,PNT                          !!! from tetra
	USE COM_CHIDAT  ,ONLY: IMATR                             !!! from getchi
	USE COM_LMTVEC,  ONLY: AHK=>APHR,ASK=>APSR,AJK=>APJR,
     &                       AHQ=>AQHR,ASQ=>AQSR,AJQ=>AQJR     !!! from lmtbnd
      USE COM_EIGVEC  ,ONLY: APHK,APHQ,APJK,APJQ               !!! from ftbvec
      USE COM_SUBGROUP,ONLY: NSGQ,NGEQ,ISG                     !!! from delmsh
      USE COM_SYMMESH ,ONLY: IG0IG1,IK0IK1                     !!! from delmsh
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP                    !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN                       !!! from readini
      USE COM_GROUPS  ,ONLY: NGROUP,U,SJ,IP,RDC,SHIFT,INV,IKOV !!! from groups
      USE COM_MASHDEP ,ONLY: LENCMP,NVAL                       !!! from readini
      USE COM_CHANNELS,ONLY: IUPSK                             !!! from setup
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT                       !!! from setup
C  SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16 PHSK,PHSQ
	DATA PI/3.141592653589793D0/
C  MEMORY ALLOCATIONS
C  SET POINT-GROUP INFORMATION
	IRK=ISG(1,ISGQ)       !!!  element "g"  in the main G-list
	IGK=IKOV(IRK)         !!!  element "g"  after Kovalev
	IPNTK=IPNT            !!!  point   "k"
	IRQ=IG0IG1(IPNT,IRK)  !!!  element "g'" in the main G-list
	IGQ=IKOV(IRQ)         !!!  element "g'" after Kovalev
	IPNTQ=IK0IK1(IPNT,IRK)!!!  point   "k'" such that g*k+q=g'*k'
      NSHIFT=0
C  READ EIGENVECTORS FOR THE POINT "K"
      IREC=IPNTK+NSHIFT
      IF(NORBS.EQ.1)
     &READ(IUPSK,REC=IREC)
     &(((((AHK(LM,IATOM,IKAP,IBNDS,IBNDS+NSPIN*(IBNDT-1)),
     &LM=1,(ILSB(IS(IATOM))+1)**2),IATOM=1,NATOM),IKAP=1,NKAP(1)),
     &IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1)),
     &(((((ASK(LM,IATOM,IKAP,IBNDS,IBNDS+NSPIN*(IBNDT-1)),
     &LM=1,(ILSB(IS(IATOM))+1)**2),IATOM=1,NATOM),IKAP=1,NKAP(1)),
     &IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1)),
     &(((((AJK(LM,IATOM,IKAP,IBNDS,IBNDS+NSPIN*(IBNDT-1)),
     &LM=1,(ILST(IS(IATOM))+2)**2),IATOM=1,NATOM),IKAP=1,NKAP(1)),
     &IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1))
      IF(NORBS.EQ.2)
     &READ(IUPSK,REC=IREC)
     &((((((AHK(LM,IATOM,IKAP,IORBS,IBNDS+NSPIN*(IBNDT-1)),
     &LM=1,(ILSB(IS(IATOM))+1)**2),IATOM=1,NATOM),IKAP=1,NKAP(1)),
     &IORBS=1,NORBS),IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1)),
     &((((((ASK(LM,IATOM,IKAP,IORBS,IBNDS+NSPIN*(IBNDT-1)),
     &LM=1,(ILSB(IS(IATOM))+1)**2),IATOM=1,NATOM),IKAP=1,NKAP(1)),
     &IORBS=1,NORBS),IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1)),
     &((((((AJK(LM,IATOM,IKAP,IORBS,IBNDS+NSPIN*(IBNDT-1)),
     &LM=1,(ILST(IS(IATOM))+2)**2),IATOM=1,NATOM),IKAP=1,NKAP(1)),
     &IORBS=1,NORBS),IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1))
C  READ EIGENVECTORS FOR THE POINT "K'"
      IREC=IPNTQ+NSHIFT
      IF(NORBS.EQ.1)
     &READ(IUPSK,REC=IREC)
     &(((((AHQ(LM,IATOM,IKAP,IBNDS,IBNDS+NSPIN*(IBNDT-1)),
     &LM=1,(ILSB(IS(IATOM))+1)**2),IATOM=1,NATOM),IKAP=1,NKAP(1)),
     &IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1)),
     &(((((ASQ(LM,IATOM,IKAP,IBNDS,IBNDS+NSPIN*(IBNDT-1)),
     &LM=1,(ILSB(IS(IATOM))+1)**2),IATOM=1,NATOM),IKAP=1,NKAP(1)),
     &IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1)),
     &(((((AJQ(LM,IATOM,IKAP,IBNDS,IBNDS+NSPIN*(IBNDT-1)),
     &LM=1,(ILST(IS(IATOM))+2)**2),IATOM=1,NATOM),IKAP=1,NKAP(1)),
     &IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1))
      IF(NORBS.EQ.2)
     &READ(IUPSK,REC=IREC)
     &((((((AHQ(LM,IATOM,IKAP,IORBS,IBNDS+NSPIN*(IBNDT-1)),
     &LM=1,(ILSB(IS(IATOM))+1)**2),IATOM=1,NATOM),IKAP=1,NKAP(1)),
     &IORBS=1,NORBS),IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1)),
     &((((((ASQ(LM,IATOM,IKAP,IORBS,IBNDS+NSPIN*(IBNDT-1)),
     &LM=1,(ILSB(IS(IATOM))+1)**2),IATOM=1,NATOM),IKAP=1,NKAP(1)),
     &IORBS=1,NORBS),IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1)),
     &((((((AJQ(LM,IATOM,IKAP,IORBS,IBNDS+NSPIN*(IBNDT-1)),
     &LM=1,(ILST(IS(IATOM))+2)**2),IATOM=1,NATOM),IKAP=1,NKAP(1)),
     &IORBS=1,NORBS),IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1))
C  **** ROTATE EIGENVECTORS AFTER APPLYING POINT-GROUP OPERATIONS ****
	DO 2000 IBNDS=1,NSPIN                         !!! over spin subbands
      DO 1000 IBNDT=1,NBNDT(1)+NBNDH(1)             !!! over bands
      IBAND=IBNDS+NSPIN*(IBNDT-1)
C  Looping over atoms
	DO IKAP=1,NKAP(1)                             !!! over kappa's
	DO IATOM=1,NATOM                              !!! over atoms
	ISORT=IS(IATOM)
	SK=PNT(1,IPNTK,1)*RDC(1,IATOM,IRK)+
     &   PNT(2,IPNTK,1)*RDC(2,IATOM,IRK)+
     &   PNT(3,IPNTK,1)*RDC(3,IATOM,IRK)
	SQ=PNT(1,IPNTQ,1)*RDC(1,IATOM,IRQ)+
     &   PNT(2,IPNTQ,1)*RDC(2,IATOM,IRQ)+
     &   PNT(3,IPNTQ,1)*RDC(3,IATOM,IRQ)
	PHSK=EXP(2.D0*PI*SK*(0.D0,1.D0))
	PHSQ=EXP(2.D0*PI*SQ*(0.D0,1.D0))
	DO L=0,ILST(ISORT)                            !!! over l
	LL=L*(2*L-1)*(2*L+1)/3
	DO M=-L,L                                     !!! over m
	LM=L*(L+1)+M+1
	DO ISPIN=1,NSPIN
	IF(L.LE.ILSB(ISORT))THEN
      APHK(LM,IATOM,IKAP,ISPIN,IBAND)=(0.D0,0.D0)
      APHQ(LM,IATOM,IKAP,ISPIN,IBAND)=(0.D0,0.D0)
	ENDIF
      APJK(LM,IATOM,IKAP,ISPIN,IBAND)=(0.D0,0.D0)
      APJQ(LM,IATOM,IKAP,ISPIN,IBAND)=(0.D0,0.D0)
	ENDDO
	IF(LCRL(L,IATOM).EQ.0.AND.IMATR.EQ.0)CYCLE
	DO IORBS=1,NORBS                              !!! over spinors
      IF(NORBS.EQ.1)ISPIN=IBNDS
      IF(NORBS.EQ.2)ISPIN=IORBS
	DO M1=-L,L                                    !!! over m1
	LM1=L*(L+1)+M1+1
	IWIG01=LL+(2*L+1)*(L+M1)+L+M+1
	DO IORBS1=1,NORBS                             !!! over spinors
      IF(NORBS.EQ.1)ISPIN1=IBNDS
      IF(NORBS.EQ.2)ISPIN1=IORBS1
	IF(LTPAN(L,IATOM,IKAP,1))
     &APHK(LM,IATOM,IKAP,ISPIN,IBAND)=
     &APHK(LM,IATOM,IKAP,ISPIN,IBAND)+
     &U(IWIG01,IGK)*SJ(ISPIN,ISPIN1,IRK)*
     &AHK(LM1,IP(IATOM,IRK),IKAP,ISPIN1,IBAND)*PHSK
      APJK(LM,IATOM,IKAP,ISPIN,IBAND)=
     &APJK(LM,IATOM,IKAP,ISPIN,IBAND)+
     &U(IWIG01,IGK)*SJ(ISPIN,ISPIN1,IRK)*
     &AJK(LM1,IP(IATOM,IRK),IKAP,ISPIN1,IBAND)*PHSK
C  ROTATE EIGENVECTORS FROM THE POINT "K'" TO THE POINT "G'*K'=G*K+Q"
	IF(LTPAN(L,IATOM,IKAP,1))
     &APHQ(LM,IATOM,IKAP,ISPIN,IBAND)=
     &APHQ(LM,IATOM,IKAP,ISPIN,IBAND)+
     &U(IWIG01,IGQ)*SJ(ISPIN,ISPIN1,IRQ)*
     &AHQ(LM1,IP(IATOM,IRQ),IKAP,ISPIN1,IBAND)*PHSQ
      APJQ(LM,IATOM,IKAP,ISPIN,IBAND)=
     &APJQ(LM,IATOM,IKAP,ISPIN,IBAND)+
     &U(IWIG01,IGQ)*SJ(ISPIN,ISPIN1,IRQ)*
     &AJQ(LM1,IP(IATOM,IRQ),IKAP,ISPIN1,IBAND)*PHSQ
      ENDDO                                         !!! over spinors
      ENDDO                                         !!! over m1
	ENDDO                                         !!! over spinors
      ENDDO                                         !!! over m
      ENDDO                                         !!! over l
      ENDDO                                         !!! over atoms
      ENDDO                                         !!! over kappa's
1000	CONTINUE                                      !!! over bands
2000	CONTINUE                                      !!! over spin subbands
C MEMORY DEALLOCATIONS
	END
