	SUBROUTINE CHI_MAGMAT(IPNT,ISGQ,IQPNT)
**************************************************************
*  Calculate matrix elements due to magnetic field           *
**************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_KAPPAR,  ONLY : NPAN,NKAP,EK,EKAP                          !!! from readini
	USE COM_PANPAR,  ONLY : LTPAN,LSPAN,IATS,ISTS                      !!! from readini
      USE COM_EIGVEC,  ONLY : APHK,APHQ,APJK,APJQ                        !!! from lmtvec
	USE COM_CHIDAT,  ONLY : IMATR,GMAT                                 !!! from magmat
	USE COM_NBANDS,  ONLY : NBNDF,NBNDE,NBNDT,NBNDH                    !!! from readini
      USE COM_DHAMPAR, ONLY : HPARHH,HPARJH,HPARHJ,HPARJJ                !!! from potpar
      USE COM_PHNCHN  ,ONLY : IUDMT                                      !!! from readini
	USE COM_MASHDEP, ONLY : NVAL                                       !!! from setup
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: DHHA(:)
	COMPLEX*16, ALLOCATABLE :: DJHA(:)
	COMPLEX*16, ALLOCATABLE :: DHJS(:)
	COMPLEX*16, ALLOCATABLE :: DJJS(:)
	COMPLEX*16, ALLOCATABLE :: DHA(:,:,:)
	COMPLEX*16, ALLOCATABLE :: DHS(:,:,:)
	DATA PI/3.141592653589793D0/
	IF(IMATR.EQ.0)RETURN
C  Memory allocations
	ALLOCATE(DHHA(LIMTMEM))
	ALLOCATE(DJHA(LIMTMEM))
	ALLOCATE(DHJS(LIMTMEM))
	ALLOCATE(DJJS(LIMTMEM))
	ALLOCATE(DHA(LIMTMEM,NATOMMEM,NKAPMEM))
	ALLOCATE(DHS(LIMTMEM,NATOMMEM,NKAPMEM))
C  **** CALCULATE MATRIX ELEMETS
      DO 7000 IC=1,3                 !!! over cases
	DO 6000 IATOM=1,NATOM          !!! over atoms
	ISORT=IS(IATOM)
	DO 5000 MU=-1,1                !!! over polarizations
	DO 4000 ISPIN1=1,NSPIN         !!! over spins
	DO 3000 ISPIN=1,NSPIN          !!! over spins
C Zeroise matrix element
      DO IBNDS1=1,NSPIN              !!! over spin subbands
      DO IBNDT1=1,NBNDT(1)+NBNDH(1)  !!! over bands
	IBAND1=IBNDS1+NSPIN*(IBNDT1-1)
      DO IBNDS=1,NSPIN               !!! over spin subbands
      DO IBNDT=1,NBNDT(1)+NBNDH(1)   !!! over bands
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	GMAT(IBAND1,IBAND,ISPIN1,ISPIN,MU,IATOM,IC)=(0.D0,0.D0)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	DO IKAP1=1,NKAP(1)
	DO IKAP=1,NKAP(1)
	IREC=IKAP1+NKAP(1)*(IKAP-1)+NKAP(1)**2*(MU+1)+
     &NKAP(1)**2*3*(IATOM-1)+
     &NKAP(1)**2*3*NATOM*(ISPIN1-1)+
     &NKAP(1)**2*3*NATOM*NSPIN*(ISPIN-1)+
     &NKAP(1)**2*3*NATOM*NSPIN*NSPIN*(IC-1)
	READ(IUDMT,REC=IREC)
     &((HPARHH(L1M1,LM,IATOM,IKAP1,IKAP),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((HPARJH(L1M1,LM,IATOM,IKAP1,IKAP),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((HPARHJ(L1M1,LM,IATOM,IKAP1,IKAP),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &((HPARJJ(L1M1,LM,IATOM,IKAP1,IKAP),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2)
	ENDDO
	ENDDO
C ***** DO GLOBALLY OVER BANDS IBND ********
      DO 2100 IBNDS=1,NSPIN                     !!! over spin subbands
      DO 2000 IBNDT=1,NBNDT(1)+NBNDH(1)         !!! over bands
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	IF(NORBS.EQ.1.AND.ISPIN.NE.IBNDS)CYCLE
C  FIND CONVOLUTIONS WITH THE CHANGE IN H-PAR
	DO IKAP1=1,NKAP(1)                        !!! over energies
	DO L1=0,ILST(ISORT)                       !!! over l1
	DO M1=-L1,L1                              !!! over m1
	L1M1=L1*(L1+1)+M1+1
	DHHA(L1M1)=(0.D0,0.D0)
	DJHA(L1M1)=(0.D0,0.D0)
	DHJS(L1M1)=(0.D0,0.D0)
	DJJS(L1M1)=(0.D0,0.D0)
	DO IKAP=1,NKAP(1)                         !!! over energies
	DO L=0,ILST(ISORT)
	DO M=-L,L                                 !!! over l
	LM=L*(L+1)+M+1                            !!! over m
	IF(LTPAN(L1,IATOM,IKAP1,1).AND.LTPAN(L,IATOM,IKAP,1))
     &DHHA(L1M1)=DHHA(L1M1)+HPARHH(L1M1,LM,IATOM,IKAP1,IKAP)*
     &APHK(LM,IATOM,IKAP,ISPIN,IBAND)
	IF(LTPAN(L,IATOM,IKAP,1))
     &DJHA(L1M1)=DJHA(L1M1)+HPARJH(L1M1,LM,IATOM,IKAP1,IKAP)*
     &APHK(LM,IATOM,IKAP,ISPIN,IBAND)
	IF(LTPAN(L1,IATOM,IKAP1,1))
     &DHJS(L1M1)=DHJS(L1M1)+HPARHJ(L1M1,LM,IATOM,IKAP1,IKAP)*
     &APJK(LM,IATOM,IKAP,ISPIN,IBAND)
	DJJS(L1M1)=DJJS(L1M1)+HPARJJ(L1M1,LM,IATOM,IKAP1,IKAP)*
     &APJK(LM,IATOM,IKAP,ISPIN,IBAND)
      ENDDO                                     !!! over m
      ENDDO                                     !!! over l
      ENDDO                                     !!! over energies
	DHA(L1M1,IATOM,IKAP1)=+DHHA(L1M1)-DHJS(L1M1)
	DHS(L1M1,IATOM,IKAP1)=-DJHA(L1M1)+DJJS(L1M1)
      ENDDO                                     !!! over m1
      ENDDO                                     !!! over l1
      ENDDO                                     !!! over energies
C ***** DO GLOBALLY OVER BANDS IBND1 ******
      DO 1100 IBNDS1=1,NSPIN                    !!! over spin subbands
      DO 1000 IBNDT1=1,NBNDT(1)+NBNDH(1)        !!! over bands
	IBAND1=IBNDS1+NSPIN*(IBNDT1-1)
	IF(NORBS.EQ.1.AND.ISPIN1.NE.IBNDS1)CYCLE
	DO IKAP=1,NKAP(1)                         !!! over energies
	DO L=0,ILST(ISORT)                        !!! over l
	DO M=-L,L                                 !!! over m
	LM=L*(L+1)+M+1
C  ONE-, TWO- AND THREE-CENTER CONTRIBUTIONS TO THE CHANGE IN H-MATRIX
	IF(LTPAN(L,IATOM,IKAP,1))
     &GMAT(IBAND1,IBAND,ISPIN1,ISPIN,MU,IATOM,IC)=
     &GMAT(IBAND1,IBAND,ISPIN1,ISPIN,MU,IATOM,IC)+
     &CONJG(APHQ(LM,IATOM,IKAP,ISPIN1,IBAND1))*DHA(LM,IATOM,IKAP)
	GMAT(IBAND1,IBAND,ISPIN1,ISPIN,MU,IATOM,IC)=
     &GMAT(IBAND1,IBAND,ISPIN1,ISPIN,MU,IATOM,IC)+
     &CONJG(APJQ(LM,IATOM,IKAP,ISPIN1,IBAND1))*DHS(LM,IATOM,IKAP)
      ENDDO                                     !!! over m
      ENDDO                                     !!! over l
      ENDDO                                     !!! over energies
 1000 CONTINUE                                  !!! over all bands
 1100 CONTINUE                                  !!! over spin subbands
 2000 CONTINUE                                  !!! over all bands
 2100 CONTINUE                                  !!! over spin subbands
 3000 CONTINUE                                  !!! over ispin
 4000 CONTINUE                                  !!! over ispin1
 5000 CONTINUE                                  !!! over polarizations
 6000 CONTINUE                                  !!! over atoms
 7000 CONTINUE                                  !!! over cases
C  Memory deallocations
	DEALLOCATE(DHHA,DJHA,DHJS,DJJS)
	DEALLOCATE(DHA,DHS)
	END
