	SUBROUTINE CHI_MAGPAR
***************************************************************
*   Calculate potential parameters of the magnetic field      *
***************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
	USE COM_LMTMEM
      USE COM_CONTROL ,ONLY: LMTO,IASA,NOVR,NPFR                    !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS
     &                      ,IS,ILST,ILSB,ILSV,LRTV                 !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP,EK                      !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN,IATS,ISTS                  !!! from readini
      USE COM_SPHERE  ,ONLY: ZNUC,SMT,SASA,SWZ                      !!! from readini
      USE COM_SYMMLM  ,ONLY: SYM,LMSYM                              !!! from symlmm
      USE COM_POTDAT  ,ONLY: POT,POTSPH,POTRWF                      !!! from potfull
	USE COM_CHIDAT  ,ONLY: IMATR                                  !!! from magmat
      USE COM_INPPAR  ,ONLY: ENY,DNY                                !!! from readini
      USE COM_LMTPAR  ,ONLY: GAM,AAH,AAJ,BBH,BBJ                    !!! from potpar
      USE COM_DHAMPAR ,ONLY: HPARHH,HPARJH,HPARHJ,HPARJJ            !!! from magpar
      USE COM_RADMESH ,ONLY: NRAD,H,R,DR,WEIGHT,RL                  !!! from radmesh
      USE COM_GAUNT   ,ONLY: C                                      !!! from gdata
      USE COM_PHNCHN  ,ONLY: IUDMT                                  !!! from readini
      USE COM_LMTOUT  ,ONLY: SCRFILE                                !!! from readini
      USE COM_MASHDEP ,ONLY: NVAL,LENREL,LENCMP                     !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8, ALLOCATABLE :: AFI(:,:)
	REAL*8, ALLOCATABLE :: AFID(:,:)
	REAL*8, ALLOCATABLE :: AFIP(:,:)
	REAL*8, ALLOCATABLE :: AFIDP(:,:)
	REAL*8, ALLOCATABLE :: AFIDDS(:)
	REAL*8, ALLOCATABLE :: AFIDDPS(:)
	COMPLEX*16, ALLOCATABLE :: RADMAT(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: WORK1(:)
	COMPLEX*16, ALLOCATABLE :: WORK2(:)
	COMPLEX*16, ALLOCATABLE :: BMAG(:)
	COMPLEX*16, ALLOCATABLE :: FIH(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: FIJ(:,:,:,:)
	LOGICAL LOG1,LOG
	DATA PI/3.141592653589793D0/
      CALL ABORTNOW()
	IF(IMATR.EQ.0)RETURN
C MEMORY ALLOCATIONS FOR SCRATCH ARRAYS
	ALLOCATE(RADMAT(4,0:LMAXTMEM,0:LMAXTMEM,NSYMMEM))
      SIZE_RADMAT=DBLE(SIZE(RADMAT)*LENCMP)/1024.D0**2
	ALLOCATE(WORK1(0:NRADMEM))
	ALLOCATE(WORK2(0:NRADMEM))
	ALLOCATE(BMAG(0:NRADMEM))
	ALLOCATE(FIH(0:NRADMEM,0:LMAXTMEM,NKAPMEM,NSPINMEM))
	ALLOCATE(FIJ(0:NRADMEM,0:LMAXTMEM,NKAPMEM,NSPINMEM))
      SIZE_FIS=2.D0*DBLE(SIZE(FIH)*LENCMP)/1024.D0**2
	ALLOCATE(AFI(0:NRADMEM,0:LMAXTMEM))
	ALLOCATE(AFID(0:NRADMEM,0:LMAXTMEM))
	ALLOCATE(AFIP(0:NRADMEM,0:LMAXTMEM))
	ALLOCATE(AFIDP(0:NRADMEM,0:LMAXTMEM))
	SIZE_AFI=4.D0*DBLE(SIZE(AFI)*LENREL)/1024.D0**2
	ALLOCATE(AFIDDS(0:LMAXTMEM))
	ALLOCATE(AFIDDPS(0:LMAXTMEM))
      CURMEM=CURMEM+SIZE_RADMAT+SIZE_FIS+SIZE_AFI
      IF(TOTMEM.LT.CURMEM)TXTMEM='<MAGPAR> Subroutine'
      IF(TOTMEM.LT.CURMEM)TOTMEM=CURMEM
C OPEN SCRATCH FILE FOR STORING POTENTIAL PARAMETERS
	NRECL=0
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	LMAXH=((ILSB(ISORT)+1)**2+(ILST(ISORT)+1)**2)**2
	NRECL=MAX(NRECL,NVAL*LMAXH)
	ENDDO
	OPEN(UNIT=IUDMT,FILE=SCRFILE(IUDMT),STATUS='NEW',
     &ACCESS='DIRECT',FORM='UNFORMATTED',RECL=NRECL)
C *******************************************************
C CALCULATE MATRIX ELEMENTS OF THE FULL POTENTIAL
	DO 6000 IATOM=1,NATOM           !!! over atoms
	ISORT=IS(IATOM)
	DO 5000 MU=-1,1                 !!! over polarizations
C Find FIny and FIny-dot radial functions:
	DO ISPIN=1,NSPIN
	DO IKAP=1,NKAP(1)               !!! over energies
      CALL LIB_RADSCH_PHIS(ENY(0,ISORT,IKAP,1,ISPIN),AFI,AFIP,
     &AFID,AFIDP,AFIDDS,AFIDDPS,SMT(ISORT),POTRWF(0,ISORT,ISPIN),
     &ILST(ISORT),NRAD(ISORT),H(ISORT),R(0,ISORT),DR(0,ISORT),
     &LRTV(ISORT))
C Transfere to FIH and FIJ convinient functions:
	DO L=0,ILST(ISORT)
	DO IRAD=0,NRAD(ISORT)
	FIH(IRAD,L,IKAP,ISPIN)=AAH(L,ISORT,IKAP,1,ISPIN)*
     &AFI(IRAD,L)+BBH(L,ISORT,IKAP,1,ISPIN)*AFIP(IRAD,L)
	FIJ(IRAD,L,IKAP,ISPIN)=AAJ(L,ISORT,IKAP,1,ISPIN)*
     &AFI(IRAD,L)+BBJ(L,ISORT,IKAP,1,ISPIN)*AFIP(IRAD,L)
      ENDDO    
      ENDDO   
      ENDDO                          !!! over energies
	ENDDO                          !!! over spins
	DO 4000 ISPIN1=1,NSPIN         !!! over spins
	DO 3000 ISPIN=1,NSPIN          !!! over spins
	DO 2000 IKAP1=1,NKAP(1)        !!! over ikap1
	DO 1000 IKAP=1,NKAP(1)         !!! over ikap
C CALCULATE DIFFERENT RADIAL MATRIX ELEMENTS
	DO L1=0,ILST(ISORT)            !!! over l1
	LOG1=.FALSE.
	IF(LTPAN(L1,IATOM,IKAP1,1))LOG1=.TRUE.
	DO L=0,ILST(ISORT)             !!! over l
	LOG=.FALSE.
	IF(LTPAN(L,IATOM,IKAP,1))LOG=.TRUE.
	DO L2=ABS(L1-L),L1+L,2         !!! over l2
	IF(L2.LE.ILSV(ISORT))THEN
	DO M2=-L2,L2                   !!! over m2
	L2M2=L2*(L2+1)+M2+1
	IF(SYM(L2M2,IATOM))THEN
	ISYM=LMSYM(L2M2,IATOM)
	RADMAT(1,L1,L,ISYM)=(0.D0,0.D0)
	RADMAT(2,L1,L,ISYM)=(0.D0,0.D0)
	RADMAT(3,L1,L,ISYM)=(0.D0,0.D0)
	RADMAT(4,L1,L,ISYM)=(0.D0,0.D0)
	DO IRAD=0,NRAD(ISORT)           !!! over radial mesh
	BMAG(IRAD)=(0.D0,0.D0)
	IF(NORBS.EQ.2.AND.MU.EQ.-1)
     &BMAG(IRAD)=-POT(IRAD,ISYM,IATOM,1,NORBS)
	IF(NORBS.EQ.2.AND.MU.EQ.+1)
     &BMAG(IRAD)=-POT(IRAD,ISYM,IATOM,NSPIN,NORBS)
	IF(MU.EQ.0)
     &BMAG(IRAD)=-0.5D0*
     &         (POT(IRAD,ISYM,IATOM,1,1)-POT(IRAD,ISYM,IATOM,NSPIN,1))
	ENDDO
	IF(LOG1.AND.LOG)THEN
	DO IRAD=0,NRAD(ISORT)           !!! over radial mesh
	WORK1(IRAD)=BMAG(IRAD)*
     &CONJG(FIH(IRAD,L1,IKAP1,ISPIN1))*FIH(IRAD,L,IKAP,ISPIN)*
     &R(IRAD,ISORT)**2*DR(IRAD,ISORT)
      ENDDO                           !!! over radial mesh
	CALL LIB_CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	RADMAT(1,L1,L,ISYM)=WORK2(NRAD(ISORT))
	IF(ISPIN1.EQ.ISPIN.AND.ISYM.EQ.1)
     &RADMAT(1,L1,L,ISYM)=(0.D0,0.D0)
	IF(IASA.EQ.1)
     &RADMAT(1,L1,L,ISYM)=RADMAT(1,L1,L,ISYM)+
     &CONJG(FIH(NRAD(ISORT),L1,IKAP1,ISPIN1))*
     &FIH(NRAD(ISORT),L,IKAP,ISPIN)*
     &BMAG(NRAD(ISORT))*
     &(SASA(ISORT)**3-SMT(ISORT)**3)/3.D0
	ENDIF
	IF(LOG)THEN
	DO IRAD=0,NRAD(ISORT)          !!! over radial mesh
	WORK1(IRAD)=BMAG(IRAD)*
     &CONJG(FIJ(IRAD,L1,IKAP1,ISPIN1))*FIH(IRAD,L,IKAP,ISPIN)*
     &R(IRAD,ISORT)**2*DR(IRAD,ISORT)
      ENDDO                          !!! over radial mesh
	CALL LIB_CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	RADMAT(2,L1,L,ISYM)=WORK2(NRAD(ISORT))*GAM(L1,ISORT)
	IF(ISPIN1.EQ.ISPIN.AND.ISYM.EQ.1)
     &RADMAT(2,L1,L,ISYM)=(0.D0,0.D0)
      IF(IASA.EQ.1)
     &RADMAT(2,L1,L,ISYM)=RADMAT(2,L1,L,ISYM)+
     &CONJG(FIJ(NRAD(ISORT),L1,IKAP1,ISPIN1))*
     &FIH(NRAD(ISORT),L,IKAP,ISPIN)*
     &BMAG(NRAD(ISORT))*
     &(SASA(ISORT)**3-SMT(ISORT)**3)/3.D0
	ENDIF
	IF(LOG1)THEN
	DO IRAD=0,NRAD(ISORT)          !!! over radial mesh
	WORK1(IRAD)=BMAG(IRAD)*
     &CONJG(FIH(IRAD,L1,IKAP1,ISPIN1))*FIJ(IRAD,L,IKAP,ISPIN)*
     &R(IRAD,ISORT)**2*DR(IRAD,ISORT)
      ENDDO                          !!! over radial mesh
	CALL LIB_CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	RADMAT(3,L1,L,ISYM)=WORK2(NRAD(ISORT))*GAM(L,ISORT)
	IF(ISPIN1.EQ.ISPIN.AND.ISYM.EQ.1)
     &RADMAT(3,L1,L,ISYM)=(0.D0,0.D0)
      IF(IASA.EQ.1)
     &RADMAT(3,L1,L,ISYM)=RADMAT(3,L1,L,ISYM)+
     &CONJG(FIH(NRAD(ISORT),L1,IKAP1,ISPIN1))*
     &FIJ(NRAD(ISORT),L,IKAP,ISPIN)*
     &BMAG(NRAD(ISORT))*
     &(SASA(ISORT)**3-SMT(ISORT)**3)/3.D0
	ENDIF
	DO IRAD=0,NRAD(ISORT)          !!! over radial mesh
	WORK1(IRAD)=BMAG(IRAD)*
     &CONJG(FIJ(IRAD,L1,IKAP1,ISPIN1))*FIJ(IRAD,L,IKAP,ISPIN)*
     &R(IRAD,ISORT)**2*DR(IRAD,ISORT)
      ENDDO                          !!! over radial mesh
	CALL LIB_CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	RADMAT(4,L1,L,ISYM)=WORK2(NRAD(ISORT))*GAM(L1,ISORT)*
     &GAM(L,ISORT)
	IF(ISPIN1.EQ.ISPIN.AND.ISYM.EQ.1)
     &RADMAT(4,L1,L,ISYM)=(0.D0,0.D0)
      IF(IASA.EQ.1)
     &RADMAT(4,L1,L,ISYM)=RADMAT(4,L1,L,ISYM)+
     &CONJG(FIJ(NRAD(ISORT),L1,IKAP1,ISPIN1))*
     &FIJ(NRAD(ISORT),L,IKAP,ISPIN)*
     &BMAG(NRAD(ISORT))*
     &(SASA(ISORT)**3-SMT(ISORT)**3)/3.D0
	ENDIF
      ENDDO                          !!! over m2
	ENDIF
      ENDDO                          !!! over l2
      ENDDO                          !!! over l
      ENDDO                          !!! over l1
C ******************************
C GET TOTAL POTENTIAL PARAMETERS
C ******************************
	DO L1=0,ILST(ISORT)            !!! over l1
	LOG1=.FALSE.
	IF(LTPAN(L1,IATOM,IKAP1,1))LOG1=.TRUE.
	DO M1=-L1,L1                   !!! over m1
	L1M1=L1*(L1+1)+M1+1
	DO L=0,ILST(ISORT)             !!! over l
	LOG=.FALSE.
	IF(LTPAN(L,IATOM,IKAP,1))LOG=.TRUE.
	DO M=-L,L                      !!! over m
	LM=L*(L+1)+M+1
	IF(L1.LE.ILSB(ISORT).AND.L.LE.ILSB(ISORT))
     &HPARHH(L1M1,LM,IATOM,IKAP1,IKAP)=(0.D0,0.D0)
	IF(L.LE.ILSB(ISORT))
     &HPARJH(L1M1,LM,IATOM,IKAP1,IKAP)=(0.D0,0.D0)
	IF(L1.LE.ILSB(ISORT))
     &HPARHJ(L1M1,LM,IATOM,IKAP1,IKAP)=(0.D0,0.D0)
	HPARJJ(L1M1,LM,IATOM,IKAP1,IKAP)=(0.D0,0.D0)
	DO L2=ABS(L1-L),L1+L,2         !!! over l2
	LL2=L2/2
	M2=M1-M
	L2M2=L2*(L2+1)+M2+1
	IF(ABS(M2).LE.L2.AND.L2.LE.ILSV(ISORT))THEN
	IF(SYM(L2M2,IATOM))THEN        !NMT terms included
	ISYM=LMSYM(L2M2,IATOM)
	IF(LOG1.AND.LOG)HPARHH(L1M1,LM,IATOM,IKAP1,IKAP)=
     &HPARHH(L1M1,LM,IATOM,IKAP1,IKAP)+(0.D0,1.D0)**(L2+L-L1)*
     &C(LL2,L1M1,LM)*RADMAT(1,L1,L,ISYM)
	IF(LOG)HPARJH(L1M1,LM,IATOM,IKAP1,IKAP)=
     &HPARJH(L1M1,LM,IATOM,IKAP1,IKAP)+(0.D0,1.D0)**(L2+L-L1)*
     &C(LL2,L1M1,LM)*RADMAT(2,L1,L,ISYM)
	IF(LOG1)HPARHJ(L1M1,LM,IATOM,IKAP1,IKAP)=
     &HPARHJ(L1M1,LM,IATOM,IKAP1,IKAP)+(0.D0,1.D0)**(L2+L-L1)*
     &C(LL2,L1M1,LM)*RADMAT(3,L1,L,ISYM)
	HPARJJ(L1M1,LM,IATOM,IKAP1,IKAP)=
     &HPARJJ(L1M1,LM,IATOM,IKAP1,IKAP)+(0.D0,1.D0)**(L2+L-L1)*
     &C(LL2,L1M1,LM)*RADMAT(4,L1,L,ISYM)
	ENDIF
	ENDIF                          !!! over m2
      ENDDO                          !!! over l2
      ENDDO                          !!! over m
      ENDDO                          !!! over l
      ENDDO                          !!! over m1
      ENDDO                          !!! over l1
      IC=3
	IREC=IKAP1+NKAP(1)*(IKAP-1)+NKAP(1)**2*(MU+1)+
     &NKAP(1)**2*3*(IATOM-1)+
     &NKAP(1)**2*3*NATOM*(ISPIN1-1)+
     &NKAP(1)**2*3*NATOM*NSPIN*(ISPIN-1)+
     &NKAP(1)**2*3*NATOM*NSPIN*NSPIN*(IC-1)
	WRITE(IUDMT,REC=IREC)
     &((HPARHH(L1M1,LM,IATOM,IKAP1,IKAP),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((HPARJH(L1M1,LM,IATOM,IKAP1,IKAP),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((HPARHJ(L1M1,LM,IATOM,IKAP1,IKAP),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &((HPARJJ(L1M1,LM,IATOM,IKAP1,IKAP),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2)
1000  CONTINUE                       !!! over ikap
2000  CONTINUE                       !!! over ikap1
3000	CONTINUE                       !!! over spins
4000	CONTINUE                       !!! over spins
5000	CONTINUE                       !!! over polarizations
6000  CONTINUE                       !!! over atoms
C MEMORY DEALLOCATIONS
	DEALLOCATE(FIH,FIJ,AFI,AFID,AFIP,AFIDP,AFIDDS,AFIDDPS)
	DEALLOCATE(RADMAT,WORK1,WORK2,BMAG)
      CURMEM=CURMEM-SIZE_RADMAT-SIZE_FIS-SIZE_AFI
	END
