	SUBROUTINE CHI_MDHEAD(E,H,EF,OT,QWGD)
*******************************************************************
*  Calculate contributions to the weights from given tetrahedron  *
*******************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER MTTR(4,9)
      DIMENSION E(4),H(4),AINT(4),AM(4),QWGD(4)
     &   ,CPNT(3,18),WPNT(3,18),DPNT(3,18),DWPNT(3,18)
     &   ,CPNTM(3,4),DPNTM(3,4),WPNTM(3,4),DWPNTM(3,4)
     &   ,VV(9),DVV(9),WVV(9),DWVV(9)
C  INITIALIZATION
	DO 10 KPNT=1,4
	QWGD(KPNT)=0.D0
  10	CONTINUE
C  DIVIDE A GIVEN TTR INTO MICROTTR'S WHERE FERMI'S FACTORS = 1
	CALL MDTTRS(E,H,EF,OT,NCPNT,CPNT,WPNT,DPNT,DWPNT,
     &NMTTR,MTTR,VV,WVV,DVV,DWVV,1,1)
      DO 60 IMTTR=1,NMTTR                   !!! over microttr"s
      DO 30 I=1,4                           !!! interpolate to vertexes
      DO 20 J=1,3
      CPNTM(J,I)=CPNT(J,MTTR(I,IMTTR))
      DPNTM(J,I)=DPNT(J,MTTR(I,IMTTR))
      WPNTM(J,I)=WPNT(J,MTTR(I,IMTTR))
      DWPNTM(J,I)=DWPNT(J,MTTR(I,IMTTR))
  20  CONTINUE
  30  CONTINUE
C  CALCULATE CONTRIBUTION FROM THIS MICROTETRAHEDRON
	CPNTX=CPNTM(1,1)+CPNTM(1,2)+CPNTM(1,3)+CPNTM(1,4)
	CPNTY=CPNTM(2,1)+CPNTM(2,2)+CPNTM(2,3)+CPNTM(2,4)
	CPNTZ=CPNTM(3,1)+CPNTM(3,2)+CPNTM(3,3)+CPNTM(3,4)
	DPNTX=DPNTM(1,1)+DPNTM(1,2)+DPNTM(1,3)+DPNTM(1,4)
	DPNTY=DPNTM(2,1)+DPNTM(2,2)+DPNTM(2,3)+DPNTM(2,4)
	DPNTZ=DPNTM(3,1)+DPNTM(3,2)+DPNTM(3,3)+DPNTM(3,4)
	WPNTX=WPNTM(1,1)+WPNTM(1,2)+WPNTM(1,3)+WPNTM(1,4)
	WPNTY=WPNTM(2,1)+WPNTM(2,2)+WPNTM(2,3)+WPNTM(2,4)
	WPNTZ=WPNTM(3,1)+WPNTM(3,2)+WPNTM(3,3)+WPNTM(3,4)
	DWPNTX=DWPNTM(1,1)+DWPNTM(1,2)+DWPNTM(1,3)+DWPNTM(1,4)
	DWPNTY=DWPNTM(2,1)+DWPNTM(2,2)+DWPNTM(2,3)+DWPNTM(2,4)
	DWPNTZ=DWPNTM(3,1)+DWPNTM(3,2)+DWPNTM(3,3)+DWPNTM(3,4)
	QW2=0.25D0*(VV(IMTTR)*DWPNTX+DWVV(IMTTR)*CPNTX+
     &  DVV(IMTTR)*WPNTX+WVV(IMTTR)*DPNTX)
	QW3=0.25D0*(VV(IMTTR)*DWPNTY+DWVV(IMTTR)*CPNTY+
     &  DVV(IMTTR)*WPNTY+WVV(IMTTR)*DPNTY)
	QW4=0.25D0*(VV(IMTTR)*DWPNTZ+DWVV(IMTTR)*CPNTZ+
     &  DVV(IMTTR)*WPNTZ+WVV(IMTTR)*DPNTZ)
	QW1=DWVV(IMTTR)-QW2-QW3-QW4
	QWGD(1)=QWGD(1)+QW1
	QWGD(2)=QWGD(2)+QW2
	QWGD(3)=QWGD(3)+QW3
	QWGD(4)=QWGD(4)+QW4
  50	CONTINUE
  60  CONTINUE                             !!! over microttr"s
	END



	SUBROUTINE MDTTRS(E,H,EF,OT,NCPNT,CPNT,WPNT,DPNT,DWPNT,
     &  NMTTR,MTTR,VV,WVV,DVV,DWVV,K1,K2)
*******************************************************************
*        Divide a tetrahedron in a few regions (microtetrahedra)  *
*     where Fermi"s functions are equal to tetta(EF-E(k))=K1 and  *
*     tetta(EF-H(k))=K2 spontaneously and K1,K2=0 or 1.           *
*        Find integral delta(EF-E(k)*delta(EF-H(k)) using anali-  *
*     tical derivative:                                           *
*           d/dEF{tetta(EF-E(k)}*d/dEF{tetta(EF-H(k))}            * 
*     Written by S.Yu.Savrasov in Max-Planck-Institute, Germany.  *
*******************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER MTTR(4,9),MTTR1(4,3),MTTR2(4,3)
	DIMENSION E(4),H(4),CH(4),VV(9),WVV(9),DVV(9),DWVV(9)
     & ,CPNT(3,18),DPNT(3,18),WPNT(3,18),DWPNT(3,18),H1(4),WH1(4)
     & ,CPN1(3,6),WPN1(3,6),CPN2(3,6),DPN2(3,6),WPN2(3,6),DWPN2(3,6)
     & ,V1(3),WV1(3),V2(3),DV2(3),WV2(3),DWV2(3)
C  DEFINE INTERPOLATION COEFFICIENTS
	CH(1)=H(1)
	DO 10 I=2,4
	CH(I)=H(I)-H(1)
  10	CONTINUE
C  CROSS THE TETRAHEDRON WITH PLANE EF=CONSTANT AND DETERMINE
C  WHETHER THE (UN)OCCUPATED REGION IS TAKEN PLACE 
	CALL TTROCD1(E,EF,1.D0,V1,WV1,NMTTR1,MTTR1,NCPN1,
     &  CPN1,WPN1,K1)
C  NOW THE (UN)OCCUPATED REGION IS GIVEN BY A FEW TETRAHEDRA
C  VOLUMES OF THESE TETRAHEDRA ARE STORED IN V1, FERMI SURFACES IN WV1
	KPNT=0
	KTTR=0
	KSHF=0
	DO 90 IMTTR1=1,NMTTR1  ! OVER FOUND MICROTETRAHEDRA
	DO 30 I=1,4 ! INTERPOLATION IN THE TOPS
	H1(I)=CH(1)
	WH1(I)=0.D0
	DO 20 J=2,4
	H1(I)=H1(I)+CH(J)*CPN1(J-1,MTTR1(I,IMTTR1))
	WH1(I)=WH1(I)+CH(J)*WPN1(J-1,MTTR1(I,IMTTR1))
  20	CONTINUE
  30	CONTINUE
C  CROSS THE TETRAHEDRON WITH PLANE EF=CONSTANT AND DETERMINE
C  WHETHER THE (UN)OCCUPATED REGION IS TAKEN PLACE
	CALL TTROCD2(H1,WH1,EF,1.D0,V2,DV2,WV2,DWV2,NMTTR2,MTTR2,NCPN2,
     &  CPN2,DPN2,WPN2,DWPN2,K2)
C  DEFINE COORDINATES OF POINTS IN THE MAIN TETRAHEDRON SYSTEM
	DO 60 ICPN2=1,NCPN2
	KPNT=KPNT+1
	DO 50 I=1,3
	SS=0.0
	DSS=0.D0
	WSS=0.D0
	DWSS=0.D0
	CPNT(I,KPNT)=0.0
	DPNT(I,KPNT)=0.0
	WPNT(I,KPNT)=0.0
	DWPNT(I,KPNT)=0.0
	DO 40 J=1,3
	SS=SS+CPN2(J,ICPN2)
	DSS=DSS+DPN2(J,ICPN2)
	WSS=WSS+WPN2(J,ICPN2)
	DWSS=DWSS+DWPN2(J,ICPN2)
	CPNT(I,KPNT)=CPNT(I,KPNT)+CPN2(J,ICPN2)*
     &  CPN1(I,MTTR1(J+1,IMTTR1))
	WPNT(I,KPNT)=WPNT(I,KPNT)+WPN2(J,ICPN2)*
     &  CPN1(I,MTTR1(J+1,IMTTR1))+CPN2(J,ICPN2)*
     &  WPN1(I,MTTR1(J+1,IMTTR1))
	DPNT(I,KPNT)=DPNT(I,KPNT)+DPN2(J,ICPN2)*
     &  CPN1(I,MTTR1(J+1,IMTTR1))
	DWPNT(I,KPNT)=DWPNT(I,KPNT)+DWPN2(J,ICPN2)*
     &  CPN1(I,MTTR1(J+1,IMTTR1))+DPN2(J,ICPN2)*
     &  WPN1(I,MTTR1(J+1,IMTTR1))
  40	CONTINUE
	CPNT(I,KPNT)=CPNT(I,KPNT)+(1.D0-SS)*CPN1(I,MTTR1(1,IMTTR1))
	WPNT(I,KPNT)=WPNT(I,KPNT)-WSS*CPN1(I,MTTR1(1,IMTTR1))+
     &  (1.D0-SS)*WPN1(I,MTTR1(1,IMTTR1))
	DPNT(I,KPNT)=DPNT(I,KPNT)-DSS*CPN1(I,MTTR1(1,IMTTR1))
	DWPNT(I,KPNT)=DWPNT(I,KPNT)-DWSS*CPN1(I,MTTR1(1,IMTTR1))-
     &  DSS*WPN1(I,MTTR1(1,IMTTR1))
  50	CONTINUE
  60	CONTINUE
C  LIST OF MICROTETRAHEDRA
	DO 80 IMTTR2=1,NMTTR2
	KTTR=KTTR+1
	VV(KTTR)=V1(IMTTR1)*V2(IMTTR2)*OT
	WVV(KTTR)=(WV1(IMTTR1)*V2(IMTTR2)+V1(IMTTR1)*WV2(IMTTR2))*OT
	DVV(KTTR)=V1(IMTTR1)*DV2(IMTTR2)*OT
	DWVV(KTTR)=(WV1(IMTTR1)*DV2(IMTTR2)+V1(IMTTR1)*
     &  DWV2(IMTTR2))*OT
	DO 70 I=1,4
	MTTR(I,KTTR)=MTTR2(I,IMTTR2)+KSHF
  70	CONTINUE
  80	CONTINUE
	KSHF=KSHF+NCPN2
  90	CONTINUE
	NMTTR=KTTR
	NCPNT=KPNT
	END



	SUBROUTINE TTROCD1(A,ER,VT,V,WV,NMTTR,MTTR,NCPNT,CPNT,
     &  WPNT,KEY)
*********************************************************
*                                                       *
*     Find (un)occupated regions in that tetrahedron.   *
*     Find cross of this tetrahedron with the plane EF. *
*     The coordinate system is the following one :      *
*                                                       *
*               |z                                      *
*             A4|	                                      *
*               |	                                      *
*               |	                                      *
*             A1|_____A2__ x                            *
*              /                                        *
*             /                                         *
*          A3/                                          *
*           /y                                          *
*                                                       *
*********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	DIMENSION E(4),A(4),V(3),WV(3),CPNT(3,6),CPN(3,6),WPN(3,6)
     & ,WPNT(3,6),KP(3,4),MTTR1(4,3),MTTR2(4,3),IND(4)
     & ,INV(4),MTTR(4,3)
	DATA KP/0,0,0, 1,0,0, 0,1,0, 0,0,1/
     &  ,MTTR1/1,3,4,5, 1,3,5,6, 1,2,3,6/
     &  ,MTTR2/1,4,5,6, 1,2,3,4, 1,2,4,6/
C  ORDER ENERGIES A(I) IN THE TOPS OF THE TETRAHEDRON
	DO 10 I=1,4
	IND(I)=1
  10	CONTINUE
	DO 30 I=1,3
	DO 20 J=I+1,4
	IF((A(I).LT.A(J).AND.KEY.EQ.1).OR.(A(I).GT.A(J).AND.
     &  KEY.EQ.0))THEN
	IND(J)=IND(J)+1			!  E1<E2<E3<E4 FOR KEY=1
	ELSE				!  E1>E2>E3>E4 FOR KEY=0
	IND(I)=IND(I)+1
	ENDIF
  20	CONTINUE
  30	CONTINUE
	DO 40 I=1,4
	E(IND(I))=A(I)
	INV(IND(I))=I
  40	CONTINUE
C  FIND (UN)OCCUPATED REGIONS
	DO 55 I=1,3
	DO 50 J=1,6
	CPN(I,J)=0.D0
	WPN(I,J)=0.D0
  50	CONTINUE
  55	CONTINUE
	EF=ER
      DO 65 I=1,4
      DO 60 J=I+1,4
      IF(ABS(E(I)-E(J)).LE.1.D-08)E(J)=E(I)
  60  CONTINUE
  65  CONTINUE
	IF((EF.LT.E(1).AND.KEY.EQ.1).OR.(EF.GT.E(1).AND.KEY.EQ.0))THEN 
	NMTTR=0					          ! NO REGIONS
	NCPNT=0	
	RETURN
	ELSEIF((EF.LT.E(2).AND.KEY.EQ.1).OR.(EF.GT.E(2).AND.
     &  KEY.EQ.0))THEN 
	NMTTR=1					    ! ONLY ONE TETRAHEDRON
	NCPNT=4
	CPN(1,2)=(E(1)-EF)/(E(1)-E(2))
	CPN(2,3)=(E(1)-EF)/(E(1)-E(3))
	CPN(3,4)=(E(1)-EF)/(E(1)-E(4))
	WPN(1,2)=-1.D0/(E(1)-E(2))
	WPN(2,3)=-1.D0/(E(1)-E(3))
	WPN(3,4)=-1.D0/(E(1)-E(4))
	V (1) =CPN(1,2)*CPN(2,3)*CPN(3,4)*VT
	WV(1) =WPN(1,2)*CPN(2,3)*CPN(3,4)*VT+
     &       CPN(1,2)*WPN(2,3)*CPN(3,4)*VT+
     &       CPN(1,2)*CPN(2,3)*WPN(3,4)*VT
	DO 70 I=1,4
	MTTR(I,1)=I
  70	CONTINUE
	ELSEIF((EF.LT.E(3).AND.KEY.EQ.1).OR.(EF.GT.E(3).AND.
     &  KEY.EQ.0))THEN 
	NMTTR=3					        ! THREE TETRAHEDRA
	NCPNT=6
	CPN(1,2)=1.D0   !  LIST OF POINTS
	CPN(1,3)=(E(3)-EF)/(E(3)-E(2))
	CPN(2,3)=(EF-E(2))/(E(3)-E(2))
	CPN(2,4)=(E(1)-EF)/(E(1)-E(3))
	CPN(3,5)=(E(1)-EF)/(E(1)-E(4))
	CPN(1,6)=(EF-E(4))/(E(2)-E(4))
	CPN(3,6)=(E(2)-EF)/(E(2)-E(4))
	WPN(1,2)=0.D0   !  LIST OF DERIVATIVES
	WPN(1,3)=-1.D0/(E(3)-E(2))
	WPN(2,3)=+1.D0/(E(3)-E(2))
	WPN(2,4)=-1.D0/(E(1)-E(3))
	WPN(3,5)=-1.D0/(E(1)-E(4))
	WPN(1,6)=+1.D0/(E(2)-E(4))
	WPN(3,6)=-1.D0/(E(2)-E(4))
	V(1)=CPN(1,3)*CPN(2,4)*CPN(3,5)*VT
	V(2)=CPN(2,3)*CPN(3,5)*CPN(1,6)*VT
	V(3)=CPN(1,2)*CPN(2,3)*CPN(3,6)*VT
	WV(1)=WPN(1,3)*CPN(2,4)*CPN(3,5)*VT+
     &      CPN(1,3)*WPN(2,4)*CPN(3,5)*VT+
     &      CPN(1,3)*CPN(2,4)*WPN(3,5)*VT
	WV(2)=WPN(2,3)*CPN(3,5)*CPN(1,6)*VT+
     &      CPN(2,3)*WPN(3,5)*CPN(1,6)*VT+
     &      CPN(2,3)*CPN(3,5)*WPN(1,6)*VT
	WV(3)=WPN(1,2)*CPN(2,3)*CPN(3,6)*VT+
     &      CPN(1,2)*WPN(2,3)*CPN(3,6)*VT+
     &      CPN(1,2)*CPN(2,3)*WPN(3,6)*VT
	DO 90 IT=1,3
	DO 80 I=1,4
	MTTR(I,IT)=MTTR1(I,IT)
  80	CONTINUE
  90	CONTINUE
	ELSEIF((EF.LT.E(4).AND.KEY.EQ.1).OR.(EF.GT.E(4).AND.
     &  KEY.EQ.0))THEN 
	NMTTR=3						! THREE TETRAHEDRA
	NCPNT=6
	CPN(1,2)=1.D0   !  LIST OF POINTS
	CPN(2,3)=1.D0
	CPN(2,4)=(EF-E(4))/(E(3)-E(4))
	CPN(3,4)=(E(3)-EF)/(E(3)-E(4))
	CPN(3,5)=(E(1)-EF)/(E(1)-E(4))
	CPN(1,6)=(EF-E(4))/(E(2)-E(4))
	CPN(3,6)=(E(2)-EF)/(E(2)-E(4))
	WPN(1,2)=0.D0   !  LIST OF DERIVATIVES
	WPN(2,3)=0.D0
	WPN(2,4)=+1.D0/(E(3)-E(4))
	WPN(3,4)=-1.D0/(E(3)-E(4))
	WPN(3,5)=-1.D0/(E(1)-E(4))
	WPN(1,6)=+1.D0/(E(2)-E(4))
	WPN(3,6)=-1.D0/(E(2)-E(4))
	V(1)=CPN(2,4)*CPN(3,5)*CPN(1,6)*VT
	V(2)=CPN(1,2)*CPN(2,3)*CPN(3,4)*VT
	V(3)=CPN(1,2)*CPN(2,4)*CPN(3,6)*VT
	WV(1)=WPN(2,4)*CPN(3,5)*CPN(1,6)*VT+
     &      CPN(2,4)*WPN(3,5)*CPN(1,6)*VT+
     &      CPN(2,4)*CPN(3,5)*WPN(1,6)*VT
	WV(2)=WPN(1,2)*CPN(2,3)*CPN(3,4)*VT+
     &      CPN(1,2)*WPN(2,3)*CPN(3,4)*VT+
     &      CPN(1,2)*CPN(2,3)*WPN(3,4)*VT
	WV(3)=WPN(1,2)*CPN(2,4)*CPN(3,6)*VT+
     &      CPN(1,2)*WPN(2,4)*CPN(3,6)*VT+
     &      CPN(1,2)*CPN(2,4)*WPN(3,6)*VT
	DO 110 IT=1,3
	DO 100 I=1,4
	MTTR(I,IT)=MTTR2(I,IT)
 100	CONTINUE
 110	CONTINUE
	ELSEIF((EF.GE.E(4).AND.KEY.EQ.1).OR.(EF.LE.E(4).AND.
     &  KEY.EQ.0))THEN
	NMTTR=1					  ! THE ORIGIN TETRAHEDRON
	NCPNT=4
	CPN(1,2)=1.D0
	CPN(2,3)=1.D0
	CPN(3,4)=1.D0
	V(1)=VT
	WV(1)=0.D0
	DO 120 I=1,4
	MTTR(I,1)=I
 120	CONTINUE
	ENDIF
C  GET CROSS POINTS IN COORDINATE SYSTEM OF THE ORIGIN TETRAHEDRON
	DO 150 ICPNT=1,NCPNT
	DO 140 I=1,3
	SS=0.D0
	WSS=0.D0
	CPNT(I,ICPNT)=0.D0
	WPNT(I,ICPNT)=0.D0
	DO 130 J=1,3
	SS=SS+CPN(J,ICPNT)
	WSS=WSS+WPN(J,ICPNT)
	CPNT(I,ICPNT)=CPNT(I,ICPNT)+CPN(J,ICPNT)*KP(I,INV(J+1))
	WPNT(I,ICPNT)=WPNT(I,ICPNT)+WPN(J,ICPNT)*KP(I,INV(J+1))
 130	CONTINUE
	CPNT(I,ICPNT)=CPNT(I,ICPNT)+(1.D0-SS)*KP(I,INV(1))
	WPNT(I,ICPNT)=WPNT(I,ICPNT)+(0.D0-WSS)*KP(I,INV(1))
 140	CONTINUE
 150	CONTINUE
	END



	SUBROUTINE TTROCD2(A,WA,ER,VT,V,DV,WV,DWV,NMTTR,MTTR,
     &  NCPNT,CPNT,DPNT,WPNT,DWPNT,KEY)
*********************************************************
*                                                       *
*     Find (un)occupated regions in that tetrahedron.	  *
*     Find cross of this tetrahedron with the plane EF. *
*     The coordinate system is the following one :      *
*                                                       *
*               |z                                      *
*             A4|	                                      *
*               |                                       *
*               |	                                      *
*             A1|_____A2__ x                            *
*              /                                        *
*             /                                         *
*          A3/                                          *
*           /y                                          *
*********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	DIMENSION E(4),WE(4),A(4),WA(4),V(3),WV(3),DV(3),DWV(3)
     &   ,CPNT(3,6),DPNT(3,6),CPN(3,6),DPN(3,6),WPN(3,6),DWPN(3,6)
     & 	 ,WPNT(3,6),DWPNT(3,6),KP(3,4),MTTR1(4,3),MTTR2(4,3),IND(4)
     &   ,INV(4),MTTR(4,3)
	DATA KP/0,0,0, 1,0,0, 0,1,0, 0,0,1/
     &    ,MTTR1/1,3,4,5, 1,3,5,6, 1,2,3,6/
     & 	  ,MTTR2/1,4,5,6, 1,2,3,4, 1,2,4,6/
C  ORDER ENERGIES A(I) IN THE TOPS OF THE TETRAHEDRON
	DO 10 I=1,4
	IND(I)=1
  10	CONTINUE
	DO 30 I=1,3
	DO 20 J=I+1,4
	IF((A(I).LT.A(J).AND.KEY.EQ.1).OR.(A(I).GT.A(J).AND.
     &  KEY.EQ.0))THEN
	IND(J)=IND(J)+1			!  E1<E2<E3<E4 FOR KEY=1
	ELSE				!  E1>E2>E3>E4 FOR KEY=0
	IND(I)=IND(I)+1
	ENDIF
  20	CONTINUE
  30	CONTINUE
	DO 40 I=1,4
	E (IND(I))=A (I)
	WE(IND(I))=WA(I)
	INV(IND(I))=I
  40	CONTINUE
C  FIND (UN)OCCUPATED REGIONS
	DO 55 I=1,3
	DO 50 J=1,6
	CPN(I,J)=0.D0
	DPN(I,J)=0.D0
	WPN(I,J)=0.D0
	DWPN(I,J)=0.D0
  50	CONTINUE
  55	CONTINUE
      DO 65 I=1,4
      DO 60 J=I+1,4
      IF(ABS(E(I)-E(J)).LE.1.D-08)E(J)=E(I)
  60  CONTINUE
  65  CONTINUE
	EF=ER
	IF((EF.LT.E(1).AND.KEY.EQ.1).OR.(EF.GT.E(1).AND.KEY.EQ.0))THEN 
	NMTTR=0					          ! NO REGIONS
	NCPNT=0	
	RETURN
	ELSEIF((EF.LT.E(2).AND.KEY.EQ.1).OR.(EF.GT.E(2).AND.
     &  KEY.EQ.0))THEN 
	NMTTR=1					    ! ONLY ONE TETRAHEDRON
	NCPNT=4
	CPN(1,2)=(E(1)-EF)/(E(1)-E(2))
	CPN(2,3)=(E(1)-EF)/(E(1)-E(3))
	CPN(3,4)=(E(1)-EF)/(E(1)-E(4))
	DPN(1,2)=-1.D0/(E(1)-E(2))
	DPN(2,3)=-1.D0/(E(1)-E(3))
	DPN(3,4)=-1.D0/(E(1)-E(4))
	WPN(1,2)=-(E(1)-EF)/(E(1)-E(2))**2*(WE(1)-WE(2))+
     &  WE(1)/(E(1)-E(2))
	WPN(2,3)=-(E(1)-EF)/(E(1)-E(3))**2*(WE(1)-WE(3))+
     &  WE(1)/(E(1)-E(3))
	WPN(3,4)=-(E(1)-EF)/(E(1)-E(4))**2*(WE(1)-WE(4))+
     &  WE(1)/(E(1)-E(4))
	DWPN(1,2)=+1.D0/(E(1)-E(2))**2*(WE(1)-WE(2))
	DWPN(2,3)=+1.D0/(E(1)-E(3))**2*(WE(1)-WE(3))
	DWPN(3,4)=+1.D0/(E(1)-E(4))**2*(WE(1)-WE(4))
	V (1) =CPN(1,2)*CPN(2,3)*CPN(3,4)*VT
	DV(1) =DPN(1,2)*CPN(2,3)*CPN(3,4)*VT+
     &       CPN(1,2)*DPN(2,3)*CPN(3,4)*VT+
     &       CPN(1,2)*CPN(2,3)*DPN(3,4)*VT
	WV(1) =WPN(1,2)*CPN(2,3)*CPN(3,4)*VT+
     &       CPN(1,2)*WPN(2,3)*CPN(3,4)*VT+
     &       CPN(1,2)*CPN(2,3)*WPN(3,4)*VT
	DWV(1)=DWPN(1,2)*CPN(2,3)*CPN(3,4)*VT+
     &       DPN(1,2)*WPN(2,3)*CPN(3,4) *VT+
     &       DPN(1,2)*CPN(2,3)*WPN(3,4) *VT+
     &       WPN(1,2)*DPN(2,3)*CPN(3,4) *VT+
     &       CPN(1,2)*DWPN(2,3)*CPN(3,4)*VT+
     &       CPN(1,2)*DPN(2,3)*WPN(3,4) *VT+
     &       WPN(1,2)*CPN(2,3)*DPN(3,4) *VT+
     &       CPN(1,2)*WPN(2,3)*DPN(3,4) *VT+
     &       CPN(1,2)*CPN(2,3)*DWPN(3,4)*VT
	DO 70 I=1,4
	MTTR(I,1)=I
  70	CONTINUE
	ELSEIF((EF.LT.E(3).AND.KEY.EQ.1).OR.(EF.GT.E(3).AND.
     &  KEY.EQ.0))THEN 
	NMTTR=3					        ! THREE TETRAHEDRA
	NCPNT=6
	CPN(1,2)=1.D0   !  LIST OF POINTS
	CPN(1,3)=(E(3)-EF)/(E(3)-E(2))
	CPN(2,3)=(EF-E(2))/(E(3)-E(2))
	CPN(2,4)=(E(1)-EF)/(E(1)-E(3))
	CPN(3,5)=(E(1)-EF)/(E(1)-E(4))
	CPN(1,6)=(EF-E(4))/(E(2)-E(4))
	CPN(3,6)=(E(2)-EF)/(E(2)-E(4))
	WPN(1,2)=0.D0   !  LIST OF VARIATIONS
	WPN(1,3)=-(E(3)-EF)/(E(3)-E(2))**2*(WE(3)-WE(2))+
     &  WE(3)/(E(3)-E(2))
	WPN(2,3)=-(EF-E(2))/(E(3)-E(2))**2*(WE(3)-WE(2))-
     &  WE(2)/(E(3)-E(2))
	WPN(2,4)=-(E(1)-EF)/(E(1)-E(3))**2*(WE(1)-WE(3))+
     &  WE(1)/(E(1)-E(3))
	WPN(3,5)=-(E(1)-EF)/(E(1)-E(4))**2*(WE(1)-WE(4))+
     &  WE(1)/(E(1)-E(4))
	WPN(1,6)=-(EF-E(4))/(E(2)-E(4))**2*(WE(2)-WE(4))-
     &  WE(4)/(E(2)-E(4))
	WPN(3,6)=-(E(2)-EF)/(E(2)-E(4))**2*(WE(2)-WE(4))+
     &  WE(2)/(E(2)-E(4))
	DPN(1,2)=0.D0   !  LIST OF DERIVATIVES
	DPN(1,3)=-1.D0/(E(3)-E(2))
	DPN(2,3)=+1.D0/(E(3)-E(2))
	DPN(2,4)=-1.D0/(E(1)-E(3))
	DPN(3,5)=-1.D0/(E(1)-E(4))
	DPN(1,6)=+1.D0/(E(2)-E(4))
	DPN(3,6)=-1.D0/(E(2)-E(4))
	DWPN(1,2)=0.D0   !  LIST OF DERIVATIVES OF VARIATIONS
	DWPN(1,3)=+1.D0/(E(3)-E(2))**2*(WE(3)-WE(2))
	DWPN(2,3)=-1.D0/(E(3)-E(2))**2*(WE(3)-WE(2))
	DWPN(2,4)=+1.D0/(E(1)-E(3))**2*(WE(1)-WE(3))
	DWPN(3,5)=+1.D0/(E(1)-E(4))**2*(WE(1)-WE(4))
	DWPN(1,6)=-1.D0/(E(2)-E(4))**2*(WE(2)-WE(4))
	DWPN(3,6)=+1.D0/(E(2)-E(4))**2*(WE(2)-WE(4))
	V(1)=CPN(1,3)*CPN(2,4)*CPN(3,5)*VT
	V(2)=CPN(2,3)*CPN(3,5)*CPN(1,6)*VT
	V(3)=CPN(1,2)*CPN(2,3)*CPN(3,6)*VT
	DV(1)=DPN(1,3)*CPN(2,4)*CPN(3,5)*VT+
     &      CPN(1,3)*DPN(2,4)*CPN(3,5)*VT+
     &      CPN(1,3)*CPN(2,4)*DPN(3,5)*VT
	DV(2)=DPN(2,3)*CPN(3,5)*CPN(1,6)*VT+
     &      CPN(2,3)*DPN(3,5)*CPN(1,6)*VT+
     &      CPN(2,3)*CPN(3,5)*DPN(1,6)*VT
	DV(3)=DPN(1,2)*CPN(2,3)*CPN(3,6)*VT+
     &      CPN(1,2)*DPN(2,3)*CPN(3,6)*VT+
     &      CPN(1,2)*CPN(2,3)*DPN(3,6)*VT
	WV(1)=WPN(1,3)*CPN(2,4)*CPN(3,5)*VT+
     &      CPN(1,3)*WPN(2,4)*CPN(3,5)*VT+
     &      CPN(1,3)*CPN(2,4)*WPN(3,5)*VT
	WV(2)=WPN(2,3)*CPN(3,5)*CPN(1,6)*VT+
     &      CPN(2,3)*WPN(3,5)*CPN(1,6)*VT+
     &      CPN(2,3)*CPN(3,5)*WPN(1,6)*VT
	WV(3)=WPN(1,2)*CPN(2,3)*CPN(3,6)*VT+
     &      CPN(1,2)*WPN(2,3)*CPN(3,6)*VT+
     &      CPN(1,2)*CPN(2,3)*WPN(3,6)*VT
	DWV(1)=DWPN(1,3)*CPN(2,4)*CPN(3,5)*VT+
     &	   DPN(1,3)*WPN(2,4)*CPN(3,5) *VT+
     &	   DPN(1,3)*CPN(2,4)*WPN(3,5) *VT+
     &	   WPN(1,3)*DPN(2,4)*CPN(3,5) *VT+
     & 	   CPN(1,3)*DWPN(2,4)*CPN(3,5)*VT+
     &	   CPN(1,3)*DPN(2,4)*WPN(3,5) *VT+
     &	   WPN(1,3)*CPN(2,4)*DPN(3,5) *VT+
     & 	   CPN(1,3)*WPN(2,4)*DPN(3,5) *VT+
     &	   CPN(1,3)*CPN(2,4)*DWPN(3,5)*VT
	DWV(2)=DWPN(2,3)*CPN(3,5)*CPN(1,6)*VT+
     &	   DPN(2,3)*WPN(3,5)*CPN(1,6) *VT+
     &	   DPN(2,3)*CPN(3,5)*WPN(1,6) *VT+
     &	   WPN(2,3)*DPN(3,5)*CPN(1,6) *VT+
     &	   CPN(2,3)*DWPN(3,5)*CPN(1,6)*VT+
     &	   CPN(2,3)*DPN(3,5)*WPN(1,6) *VT+
     &	   WPN(2,3)*CPN(3,5)*DPN(1,6) *VT+
     &	   CPN(2,3)*WPN(3,5)*DPN(1,6) *VT+
     &	   CPN(2,3)*CPN(3,5)*DWPN(1,6)*VT
	DWV(3)=DWPN(1,2)*CPN(2,3)*CPN(3,6)*VT+
     &	   DPN(1,2)*WPN(2,3)*CPN(3,6) *VT+
     &	   DPN(1,2)*CPN(2,3)*WPN(3,6) *VT+
     &	   WPN(1,2)*DPN(2,3)*CPN(3,6) *VT+
     &	   CPN(1,2)*DWPN(2,3)*CPN(3,6)*VT+
     &	   CPN(1,2)*DPN(2,3)*WPN(3,6) *VT+
     &	   WPN(1,2)*CPN(2,3)*DPN(3,6) *VT+
     &	   CPN(1,2)*WPN(2,3)*DPN(3,6) *VT+
     &	   CPN(1,2)*CPN(2,3)*DWPN(3,6)*VT
	DO 90 IT=1,3
	DO 80 I=1,4
	MTTR(I,IT)=MTTR1(I,IT)
  80	CONTINUE
  90	CONTINUE
	ELSEIF((EF.LT.E(4).AND.KEY.EQ.1).OR.(EF.GT.E(4).AND.
     &  KEY.EQ.0))THEN 
	NMTTR=3						! THREE TETRAHEDRA
	NCPNT=6
	CPN(1,2)=1.D0   !  LIST OF POINTS
	CPN(2,3)=1.D0
	CPN(2,4)=(EF-E(4))/(E(3)-E(4))
	CPN(3,4)=(E(3)-EF)/(E(3)-E(4))
	CPN(3,5)=(E(1)-EF)/(E(1)-E(4))
	CPN(1,6)=(EF-E(4))/(E(2)-E(4))
	CPN(3,6)=(E(2)-EF)/(E(2)-E(4))
	WPN(1,2)=0.D0   !  LIST OF VARIATIONS
	WPN(2,3)=0.D0
	WPN(2,4)=-(EF-E(4))/(E(3)-E(4))**2*(WE(3)-WE(4))-
     &  WE(4)/(E(3)-E(4))
	WPN(3,4)=-(E(3)-EF)/(E(3)-E(4))**2*(WE(3)-WE(4))+
     &  WE(3)/(E(3)-E(4))
	WPN(3,5)=-(E(1)-EF)/(E(1)-E(4))**2*(WE(1)-WE(4))+
     &  WE(1)/(E(1)-E(4))
	WPN(1,6)=-(EF-E(4))/(E(2)-E(4))**2*(WE(2)-WE(4))-
     &  WE(4)/(E(2)-E(4))
	WPN(3,6)=-(E(2)-EF)/(E(2)-E(4))**2*(WE(2)-WE(4))+
     &  WE(2)/(E(2)-E(4))
	DPN(1,2)=0.D0   !  LIST OF DERIVATIVES
	DPN(2,3)=0.D0
	DPN(2,4)=+1.D0/(E(3)-E(4))
	DPN(3,4)=-1.D0/(E(3)-E(4))
	DPN(3,5)=-1.D0/(E(1)-E(4))
	DPN(1,6)=+1.D0/(E(2)-E(4))
	DPN(3,6)=-1.D0/(E(2)-E(4))
	DWPN(1,2)=0.D0   !  LIST OF DERIVATIVES OF VARIATIONS
	DWPN(2,3)=0.D0
	DWPN(2,4)=-1.D0/(E(3)-E(4))**2*(WE(3)-WE(4))
	DWPN(3,4)=+1.D0/(E(3)-E(4))**2*(WE(3)-WE(4))
	DWPN(3,5)=+1.D0/(E(1)-E(4))**2*(WE(1)-WE(4))
	DWPN(1,6)=-1.D0/(E(2)-E(4))**2*(WE(2)-WE(4))
	DWPN(3,6)=+1.D0/(E(2)-E(4))**2*(WE(2)-WE(4))
	V(1)=CPN(2,4)*CPN(3,5)*CPN(1,6)*VT
	V(2)=CPN(1,2)*CPN(2,3)*CPN(3,4)*VT
	V(3)=CPN(1,2)*CPN(2,4)*CPN(3,6)*VT
	DV(1)=DPN(2,4)*CPN(3,5)*CPN(1,6)*VT+
     &	  CPN(2,4)*DPN(3,5)*CPN(1,6)*VT+
     &	  CPN(2,4)*CPN(3,5)*DPN(1,6)*VT
	DV(2)=DPN(1,2)*CPN(2,3)*CPN(3,4)*VT+
     &	  CPN(1,2)*DPN(2,3)*CPN(3,4)*VT+
     &	  CPN(1,2)*CPN(2,3)*DPN(3,4)*VT
	DV(3)=DPN(1,2)*CPN(2,4)*CPN(3,6)*VT+
     &	  CPN(1,2)*DPN(2,4)*CPN(3,6)*VT+
     &	  CPN(1,2)*CPN(2,4)*DPN(3,6)*VT
	WV(1)=WPN(2,4)*CPN(3,5)*CPN(1,6)*VT+
     &	  CPN(2,4)*WPN(3,5)*CPN(1,6)*VT+
     &	  CPN(2,4)*CPN(3,5)*WPN(1,6)*VT
	WV(2)=WPN(1,2)*CPN(2,3)*CPN(3,4)*VT+
     &	  CPN(1,2)*WPN(2,3)*CPN(3,4)*VT+
     &	  CPN(1,2)*CPN(2,3)*WPN(3,4)*VT
	WV(3)=WPN(1,2)*CPN(2,4)*CPN(3,6)*VT+
     &	  CPN(1,2)*WPN(2,4)*CPN(3,6)*VT+
     &	  CPN(1,2)*CPN(2,4)*WPN(3,6)*VT
	DWV(1)=DWPN(2,4)*CPN(3,5)*CPN(1,6)*VT+
     &	   DPN(2,4)*WPN(3,5)*CPN(1,6) *VT+
     &	   DPN(2,4)*CPN(3,5)*WPN(1,6) *VT+
     &	   WPN(2,4)*DPN(3,5)*CPN(1,6) *VT+
     &	   CPN(2,4)*DWPN(3,5)*CPN(1,6)*VT+
     &	   CPN(2,4)*DPN(3,5)*WPN(1,6) *VT+
     &	   WPN(2,4)*CPN(3,5)*DPN(1,6) *VT+
     &	   CPN(2,4)*WPN(3,5)*DPN(1,6) *VT+
     &	   CPN(2,4)*CPN(3,5)*DWPN(1,6)*VT
	DWV(2)=DWPN(1,2)*CPN(2,3)*CPN(3,4)*VT+
     &	   DPN(1,2)*WPN(2,3)*CPN(3,4) *VT+
     &	   DPN(1,2)*CPN(2,3)*WPN(3,4) *VT+
     &	   WPN(1,2)*DPN(2,3)*CPN(3,4) *VT+
     &	   CPN(1,2)*DWPN(2,3)*CPN(3,4)*VT+
     &	   CPN(1,2)*DPN(2,3)*WPN(3,4) *VT+
     &	   WPN(1,2)*CPN(2,3)*DPN(3,4) *VT+
     &	   CPN(1,2)*WPN(2,3)*DPN(3,4) *VT+
     &	   CPN(1,2)*CPN(2,3)*DWPN(3,4)*VT
	DWV(3)=DWPN(1,2)*CPN(2,4)*CPN(3,6)*VT+
     &	   DPN(1,2)*WPN(2,4)*CPN(3,6) *VT+
     &	   DPN(1,2)*CPN(2,4)*WPN(3,6) *VT+
     &	   WPN(1,2)*DPN(2,4)*CPN(3,6) *VT+
     &	   CPN(1,2)*DWPN(2,4)*CPN(3,6)*VT+
     &	   CPN(1,2)*DPN(2,4)*WPN(3,6) *VT+
     &	   WPN(1,2)*CPN(2,4)*DPN(3,6) *VT+
     &	   CPN(1,2)*WPN(2,4)*DPN(3,6) *VT+
     &	   CPN(1,2)*CPN(2,4)*DWPN(3,6)*VT
	DO 110 IT=1,3
	DO 100 I=1,4
	MTTR(I,IT)=MTTR2(I,IT)
 100	CONTINUE
 110	CONTINUE
	ELSEIF((EF.GE.E(4).AND.KEY.EQ.1).OR.(EF.LE.E(4).AND.
     &  KEY.EQ.0))THEN
	NMTTR=1					  ! THE ORIGIN TETRAHEDRON
	NCPNT=4
	CPN(1,2)=1.D0
	CPN(2,3)=1.D0
	CPN(3,4)=1.D0
	V(1)=VT
	DV (1)=0.D0
	WV (1)=0.D0
	DWV(1)=0.D0
	DO 120 I=1,4
	MTTR(I,1)=I
 120	CONTINUE
	ENDIF
C  GET CROSS POINTS IN COORDINATE SYSTEM OF THE ORIGIN TETRAHEDRON
	DO 150 ICPNT=1,NCPNT
	DO 140 I=1,3
	SS=0.D0
      DSS=0.D0
	WSS=0.D0
	DWSS=0.D0
	CPNT(I,ICPNT)=0.D0
	DPNT(I,ICPNT)=0.D0
	WPNT(I,ICPNT)=0.D0
	DWPNT(I,ICPNT)=0.D0
	DO 130 J=1,3
	SS=SS+CPN(J,ICPNT)
	DSS=DSS+DPN(J,ICPNT)
	WSS=WSS+WPN(J,ICPNT)
	DWSS=DWSS+DWPN(J,ICPNT)
	CPNT(I,ICPNT)=CPNT(I,ICPNT)+CPN(J,ICPNT)*KP(I,INV(J+1))
	DPNT(I,ICPNT)=DPNT(I,ICPNT)+DPN(J,ICPNT)*KP(I,INV(J+1))
	WPNT(I,ICPNT)=WPNT(I,ICPNT)+WPN(J,ICPNT)*KP(I,INV(J+1))
	DWPNT(I,ICPNT)=DWPNT(I,ICPNT)+DWPN(J,ICPNT)*KP(I,INV(J+1))
 130	CONTINUE
	CPNT(I,ICPNT)=CPNT(I,ICPNT)+(1.D0-SS)*KP(I,INV(1))
	DPNT(I,ICPNT)=DPNT(I,ICPNT)+(0.D0-DSS)*KP(I,INV(1))
	WPNT(I,ICPNT)=WPNT(I,ICPNT)+(0.D0-WSS)*KP(I,INV(1))
	DWPNT(I,ICPNT)=DWPNT(I,ICPNT)+(0.D0-DWSS)*KP(I,INV(1))
 140	CONTINUE
 150	CONTINUE
	END

