	SUBROUTINE CHI_MCHEAD(E,H,EF,OMG,OT,QWGT)
*******************************************************************
*  Calculate contributions to the weights from given tetrahedron  *
*******************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER MTTR(4,9)
	DIMENSION E(4),H(4),AM(4),CPNTM(3,4),V(9)
     &   ,DE(4),CDE(4),CPNT(3,18),QWGT(4,3),AINT(4)
C  INITIALIZATION
	CDE(1)=(E(1)-H(1)+OMG)
	DO I=2,4                              !!! interpolation coefficients
	CDE(I)=(E(I)-H(I)+OMG)-CDE(1)         !!! E(kj)-E(g*k+qj')+Omega
	ENDDO
	DO 1000 IUD=1,3                       !!! over three cases
	DO KPNT=1,4
	QWGT(KPNT,IUD)=0.D0
	ENDDO
C  DIVIDE A GIVEN TTR INTO MICROTTR'S WHERE FERMI'S FACTORS = 1
	IF(IUD.EQ.1)CALL MCTTRS(E,H,EF,OT,NCPNT,CPNT,NMTTR,MTTR,V,1,0)
	IF(IUD.EQ.2)CALL MCTTRS(E,H,EF,OT,NCPNT,CPNT,NMTTR,MTTR,V,0,1)
	IF(IUD.EQ.3)CALL MCTTRS(E,H,EF,OT,NCPNT,CPNT,NMTTR,MTTR,V,1,1)
	DO 100 IMTTR=1,NMTTR                  !!! over microttr"s
	DO I=1,4                              !!! interpolate to vertexes
	DE(I)=CDE(1)
	DO J=2,4
	CPNTM(J-1,I)=CPNT(J-1,MTTR(I,IMTTR))
	DE(I)=DE(I)+CDE(J)*CPNTM(J-1,I)
	ENDDO
	ENDDO
C  CALCULATE INTEGRALS OVER MICROTETRAHEDRA
	IF(IUD.EQ.1)CALL TTR_MCTTRINT1(DE,V(IMTTR),AINT)
	IF(IUD.EQ.2)CALL TTR_MCTTRINT1(DE,V(IMTTR),AINT)
	IF(IUD.EQ.3)CALL TTR_MCTTRINT2(   V(IMTTR),AINT)
C  AINT CONTAINES INTEGRALS WITH 1,KX,KY,KZ !
C  CALCULATE CONTRIBUTION FROM THIS MICROTETRAHEDRON
	DO KPNT=1,4
	IF(KPNT.EQ.1)AM(1)=1.D0-CPNTM(1,1)-CPNTM(2,1)-CPNTM(3,1)
	IF(KPNT.NE.1)AM(1)=CPNTM(KPNT-1,1)
	DO I=2,4
	IF(KPNT.EQ.1)AM(I)=-(CPNTM(1,I)-CPNTM(1,1))-(
     &CPNTM(2,I)-CPNTM(2,1))-(CPNTM(3,I)-CPNT(3,1))
	IF(KPNT.NE.1)AM(I)=CPNTM(KPNT-1,I)-CPNTM(KPNT-1,1)
	ENDDO
	QWGT(KPNT,IUD)=QWGT(KPNT,IUD)+AINT(1)*AM(1)+AINT(2)*AM(2)+
     &                              AINT(3)*AM(3)+AINT(4)*AM(4)
	ENDDO
 100  CONTINUE                             !!! over microttr"s
1000  CONTINUE                             !!! over three cases
	END


	SUBROUTINE MOHEAD(E,H,EF,OMG,OT,QWGT)
*******************************************************************
*  Calculate contributions to the weights from given tetrahedron  *
*******************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER MTTR(4,9)
	DIMENSION E(4),H(4),AM(4),CPNTM(3,4),V(9),DE(4),CDE(4)
     &   ,CPNT(3,18),QWGT(4),AT(4),AD(4),AINT(4)
C  INITIALIZATION
	CDE(1)=(E(1)-H(1)+OMG)
	DO I=2,4                              !!! interpolation coefficients
	CDE(I)=(E(I)-H(I)+OMG)-CDE(1)         !!! E(kj)-E(g*k+qj')-Omega
	ENDDO 
	DO KPNT=1,4
	QWGT(KPNT)=0.D0
	ENDDO 
C  DIVIDE A GIVEN TTR INTO MICROTTR'S WHERE FERMI'S FACTORS = 1
	CALL MCTTRS(E,H,EF,OT,NCPNT,CPNT,NMTTR,MTTR,V,1,0)
	DO 100 IMTTR=1,NMTTR                   !!! over microttr"s
	DO I=1,4                               !!! interpolate to vertexes
	DE(I)=CDE(1)
	DO J=2,4
	CPNTM(J-1,I)=CPNT(J-1,MTTR(I,IMTTR))
	DE(I)=DE(I)+CDE(J)*CPNTM(J-1,I)
	ENDDO
	ENDDO
C  CALCULATE INTEGRALS OVER MICROTETRAHEDRA
      CALL TTR_MCTTRINT0(DE,0.D0,V(IMTTR),AT,AD,TS,DS,'T','W')
C  AD CONTAINES WEIGHTS, NOT INTEGRALS WITH 1,KX,KY,KZ !
C  CALCULATE CONTRIBUTION FROM THIS MICROTETRAHEDRON
	DO KPNT=1,4
	DO I=1,4
	IF(KPNT.EQ.1)AM(I)=1.D0-CPNTM(1,I)-CPNTM(2,I)-CPNTM(3,I)
	IF(KPNT.NE.1)AM(I)=CPNTM(KPNT-1,I)
	ENDDO
	QWGT(KPNT)=QWGT(KPNT)+AD(1)*AM(1)+AD(2)*AM(2)+
     &                      AD(3)*AM(3)+AD(4)*AM(4)
	ENDDO
 100  CONTINUE                             !!! over microttr"s
	END



	SUBROUTINE MCTTRS(E,H,EF,OT,NCPNT,CPNT,NMTTR,MTTR,V,K1,K2)
*******************************************************************
*     Divide a tetrahedron in a few regions (microtetrahedra)     *
*     where Fermi"s functions are equal to                        *
*     tetta(EF-E(k))=K1 and tetta(EF-H(k))=K2 spontaneously       *
*     and K1,K2=0 or 1                                            *
*     Written by S.Yu.Savrasov (P.N.Lebedev Physical Institute)   *
*******************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER MTTR(4,9),MTTR1(4,3),MTTR2(4,3)
	DIMENSION E(4),H(4),CPNT(3,18),CPN1(3,6),CPN2(3,6)
     &    ,CH(4),H1(4),V(9),V1(3),V2(3)
C  DEFINE INTERPOLATION COEFFICIENTS
	CH(1)=H(1)
	DO 10 I=2,4
	CH(I)=H(I)-H(1)
  10  CONTINUE
C  CROSS THE TETRAHEDRON WITH PLANE EF=CONSTANT AND DEFINE
C  IF THE (UN)OCCUPATED REGION IS TAKEN PLACE OR NOT
	CALL TTROCC(E,EF,OT,V1,NMTTR1,MTTR1,NCPN1,CPN1,K1)
C  NOW THE (UN)OCCUPATED REGION IS GIVEN BY A FEW TETRAHEDRA
	KPNT=0
	KTTR=0
	KSHF=0
	DO 90 IMTTR1=1,NMTTR1  ! OVER THAT ONES
	DO 30 I=1,4 ! INTERPOLATION IN THE TOPS
	H1(I)=CH(1)
	DO 20 J=2,4
	H1(I)=H1(I)+CH(J)*CPN1(J-1,MTTR1(I,IMTTR1))
  20  CONTINUE
  30  CONTINUE
C  CROSS THE TETRAHEDRON WITH PLANE EF=CONSTANT AND DEFINE
C  IF THE (UN)OCCUPATED REGION IS TAKEN PLACE
	CALL TTROCC(H1,EF,V1(IMTTR1),V2,NMTTR2,MTTR2,NCPN2,CPN2,K2)
C  DEFINE COORDINATES OF POINTS IN THE MAIN TETRAHEDRON SYSTEM
	DO 60 ICPN2=1,NCPN2
	KPNT=KPNT+1
	DO 50 I=1,3
	S=0.0
	CPNT(I,KPNT)=0.0
	DO 40 J=1,3
	S=S+CPN2(J,ICPN2)
	CPNT(I,KPNT)=CPNT(I,KPNT)+CPN2(J,ICPN2)*
     &CPN1(I,MTTR1(J+1,IMTTR1))
  40  CONTINUE
	CPNT(I,KPNT)=CPNT(I,KPNT)+(1.D0-S)*CPN1(I,MTTR1(1,IMTTR1))
  50  CONTINUE
  60  CONTINUE
C  LIST OF MICROTETRAHEDRA
	DO 80 IMTTR2=1,NMTTR2
	IF(ABS(V2(IMTTR2)).GE.1.D-08)THEN
	KTTR=KTTR+1
	V(KTTR)=V2(IMTTR2)
	DO 70 I=1,4
	MTTR(I,KTTR)=MTTR2(I,IMTTR2)+KSHF
  70  CONTINUE
	ENDIF
  80  CONTINUE
	KSHF=KSHF+NCPN2
  90  CONTINUE
	NMTTR=KTTR
	NCPNT=KPNT
	END





      SUBROUTINE TTROCC(A,ER,VT,V,NMTTR,MTTR,NCPNT,CPNT,KEY)
*********************************************************
*                                                       *
*     Find (un)occupated regions in that tetrahedron.   *
*     The coordinate system is the following one :      *
*                                                       *
*               |z                                      *
*             A4|                                       *
*               |                                       *
*               |                                       *
*             A1|_____A2__ x                            *
*              /                                        *
*             /                                         *
*          A3/                                          *
*           /y                                          *
*                                                       *
*********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	DIMENSION E(4),V(3),MTTR(4,3),CPNT(3,6),CPN(3,6),A(4),INV(4)
     &    ,KP(3,4),MTTR1(4,3),MTTR2(4,3),IND(4)
	DATA KP/0,0,0 , 1,0,0 , 0,1,0 , 0,0,1/
     &    ,MTTR1/1,3,4,5, 1,3,5,6 , 1,2,3,6/
     &    ,MTTR2/1,4,5,6, 1,2,3,4 , 1,2,4,6/
C  ORDER ENERGIES A(I) IN THE TOPS OF THE TETRAHEDRON
	DO 10 I=1,4
	IND(I)=1
  10  CONTINUE
	DO 30 I=1,3
	DO 20 J=I+1,4
	IF((A(I).LT.A(J).AND.KEY.EQ.1).OR.(A(I).GT.A(J).AND.
     &KEY.EQ.0))THEN
	IND(J)=IND(J)+1               !  E1<E2<E3<E4 FOR KEY=1
	ELSE                          !  E1>E2>E3>E4 FOR KEY=0
	IND(I)=IND(I)+1
	ENDIF
  20  CONTINUE
  30  CONTINUE
	DO 40 I=1,4
	E(IND(I))=A(I)
	INV(IND(I))=I
  40  CONTINUE
C  FIND (UN)OCCUPATED REGIONS
	DO 60 I=1,3
	DO 50 J=1,6
	CPN(I,J)=0.D0
  50  CONTINUE
  60  CONTINUE
	EF=ER
	IF((EF.LT.E(1).AND.KEY.EQ.1).OR.(EF.GT.E(1).AND.KEY.EQ.0))THEN 
	NMTTR=0                                           ! NO REGIONS
	NCPNT=0 
	RETURN
	ELSEIF((EF.LT.E(2).AND.KEY.EQ.1).OR.(EF.GT.E(2).AND.
     &KEY.EQ.0))THEN 
	NMTTR=1                                     ! ONLY ONE TETRAHEDRON
	NCPNT=4
	CPN(1,2)=(E(1)-EF)/(E(1)-E(2))
	CPN(2,3)=(E(1)-EF)/(E(1)-E(3))
	CPN(3,4)=(E(1)-EF)/(E(1)-E(4))
	V(1)=CPN(1,2)*CPN(2,3)*CPN(3,4)*VT
	DO 70 I=1,4
	MTTR(I,1)=I
  70  CONTINUE
	ELSEIF((EF.LT.E(3).AND.KEY.EQ.1).OR.(EF.GT.E(3).AND.
     &KEY.EQ.0))THEN 
	NMTTR=3                                         ! THREE TETRAHEDRA
	NCPNT=6
	CPN(1,2)=1.D0   !  LIST OF POINTS
	CPN(1,3)=(E(3)-EF)/(E(3)-E(2))
	CPN(2,3)=(EF-E(2))/(E(3)-E(2))
	CPN(2,4)=(E(1)-EF)/(E(1)-E(3))
	CPN(3,5)=(E(1)-EF)/(E(1)-E(4))
	CPN(1,6)=(EF-E(4))/(E(2)-E(4))
	CPN(3,6)=(E(2)-EF)/(E(2)-E(4))
	V(1)=CPN(1,3)*CPN(2,4)*CPN(3,5)*VT
	V(2)=CPN(2,3)*CPN(3,5)*CPN(1,6)*VT
	V(3)=CPN(1,2)*CPN(2,3)*CPN(3,6)*VT
	DO 90 IT=1,3
	DO 80 I=1,4
	MTTR(I,IT)=MTTR1(I,IT)
  80  CONTINUE
  90  CONTINUE
	ELSEIF((EF.LT.E(4).AND.KEY.EQ.1).OR.(EF.GT.E(4).AND.
     &  KEY.EQ.0))THEN 
	NMTTR=3                                         ! THREE TETRAHEDRA
	NCPNT=6
	CPN(1,2)=1.D0   !  LIST OF POINTS
	CPN(2,3)=1.D0
	CPN(2,4)=(EF-E(4))/(E(3)-E(4))
	CPN(3,4)=(E(3)-EF)/(E(3)-E(4))
	CPN(3,5)=(E(1)-EF)/(E(1)-E(4))
	CPN(1,6)=(EF-E(4))/(E(2)-E(4))
	CPN(3,6)=(E(2)-EF)/(E(2)-E(4))
	V(1)=CPN(2,4)*CPN(3,5)*CPN(1,6)*VT
	V(2)=CPN(1,2)*CPN(2,3)*CPN(3,4)*VT
	V(3)=CPN(1,2)*CPN(2,4)*CPN(3,6)*VT
	DO 110 IT=1,3
	DO 100 I=1,4
	MTTR(I,IT)=MTTR2(I,IT)
 100  CONTINUE
 110  CONTINUE
	ELSEIF((EF.GE.E(4).AND.KEY.EQ.1).OR.(EF.LE.E(4).AND.
     &KEY.EQ.0))THEN
	NMTTR=1                                   ! THE ORIGIN TETRAHEDRON
	NCPNT=4
	CPN(1,2)=1.D0
	CPN(2,3)=1.D0
	CPN(3,4)=1.D0
	V(1)=VT
	DO 120 I=1,4
	MTTR(I,1)=I
 120  CONTINUE
	ENDIF
C  GET CROSS POINTS IN COORDINATE SYSTEM OF THE ORIGIN TETRAHEDRON
	DO 150 ICPNT=1,NCPNT
	DO 140 I=1,3
	S=0.D0
	CPNT(I,ICPNT)=0.0
	DO 130 J=1,3
	S=S+CPN(J,ICPNT)
	CPNT(I,ICPNT)=CPNT(I,ICPNT)+CPN(J,ICPNT)*KP(I,INV(J+1))
 130  CONTINUE
	CPNT(I,ICPNT)=CPNT(I,ICPNT)+(1.D0-S)*KP(I,INV(1))
 140  CONTINUE
 150  CONTINUE
	END
