	SUBROUTINE CHI_ORBPAR
***************************************************************
* Calculates potential parameters due to spin-orbit coupling. *
***************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
	USE COM_LMTMEM
      USE COM_CONTROL ,ONLY: LMTO,IASA,NOVR,NPFR                    !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS             !!! from readini
     &                      ,ILST,ILSB,ILSV,LRTV,LSCO                    
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP,EK                      !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN,IATS,ISTS                  !!! from readini
      USE COM_SPHERE  ,ONLY: ZNUC,SMT                               !!! from readini
      USE COM_SYMMLM  ,ONLY: SYM,LMSYM                              !!! from symlmm
	USE COM_CHIDAT  ,ONLY: IMATR                                  !!! from magmat
      USE COM_POTDAT  ,ONLY: POT,POTSPH,POTRWF                      !!! from potfull
      USE COM_INPPAR  ,ONLY: ENY,DNY                                !!! from readini
      USE COM_DHAMPAR ,ONLY: HPARHH,HPARJH,HPARHJ,HPARJJ            !!! from potpar
      USE COM_LMTPAR  ,ONLY: GAM,AAH,AAJ,BBH,BBJ                    !!! from potpar
      USE COM_RADMESH ,ONLY: NRAD,H,R,DR,WEIGHT,RL                  !!! from radmesh
      USE COM_GAUNT   ,ONLY: C                                      !!! from gdata
      USE COM_LMTOUT  ,ONLY: SCRFILE                                !!! from readini
      USE COM_PHNCHN  ,ONLY: IUDMT                                  !!! from readini
      USE COM_MASHDEP ,ONLY: NVAL,LENCMP                            !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8, ALLOCATABLE :: AFI(:,:)
	REAL*8, ALLOCATABLE :: AFID(:,:)
	REAL*8, ALLOCATABLE :: AFIP(:,:)
	REAL*8, ALLOCATABLE :: AFIDP(:,:)
	REAL*8, ALLOCATABLE :: AFIDDS(:)
	REAL*8, ALLOCATABLE :: AFIDDPS(:)
	REAL*8, ALLOCATABLE :: VBAR(:)
	REAL*8, ALLOCATABLE :: VDER(:)
	REAL*8, ALLOCATABLE :: ACOR(:)
	REAL*8, ALLOCATABLE :: OMAT(:,:)
	COMPLEX*16, ALLOCATABLE :: PARS(:,:)
	COMPLEX*16, ALLOCATABLE :: WORK1(:)
	COMPLEX*16, ALLOCATABLE :: WORK2(:)
	COMPLEX*16, ALLOCATABLE :: FIH(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: FIJ(:,:,:,:)
	LOGICAL LOG1,LOG,FIRST
	SAVE FIRST
	DATA PI/3.141592653589793D0/,C2/0.000013312838D0/,FIRST/.TRUE./
      CALL ABORTNOW()
C RETURN KEYS
	IF(IMATR.EQ.0)RETURN
C MEMORY ALLOCATIONS
	ALLOCATE(WORK1(0:NRADMEM))
	ALLOCATE(WORK2(0:NRADMEM))
	ALLOCATE(FIH(0:NRADMEM,0:LMAXTMEM,NKAPMEM,NSPINMEM))
	ALLOCATE(FIJ(0:NRADMEM,0:LMAXTMEM,NKAPMEM,NSPINMEM))
	ALLOCATE(AFI(0:NRADMEM,0:LMAXTMEM))
	ALLOCATE(AFID(0:NRADMEM,0:LMAXTMEM))
	ALLOCATE(AFIP(0:NRADMEM,0:LMAXTMEM))
	ALLOCATE(AFIDP(0:NRADMEM,0:LMAXTMEM))
	ALLOCATE(AFIDDS(0:LMAXTMEM))
	ALLOCATE(AFIDDPS(0:LMAXTMEM))
	ALLOCATE(VBAR(0:NRADMEM))
	ALLOCATE(VDER(0:NRADMEM))
	ALLOCATE(ACOR(0:NRADMEM))
	ALLOCATE(OMAT(NWIGMEM,-1:1))
	ALLOCATE(PARS(0:LMAXTMEM,4))
	DO 5000 IATOM=1,NATOM          !!! over atoms
	ISORT=IS(IATOM)
C  Find FIny and FIny-dot radial functions:
	DO ISPIN=1,NSPIN               !!! over spins
	DO IKAP=1,NKAP(1)              !!! over energies
      CALL LIB_RADSCH_PHIS(ENY(0,ISORT,IKAP,1,ISPIN),AFI,AFIP,
     &AFID,AFIDP,AFIDDS,AFIDDPS,SMT(ISORT),POTRWF(0,ISORT,ISPIN),
     &ILST(ISORT),NRAD(ISORT),H(ISORT),R(0,ISORT),DR(0,ISORT),
     &LRTV(ISORT))
C  Transfere to FIH and FIJ convinient functions:
	DO L=0,ILST(ISORT)
	DO IRAD=0,NRAD(ISORT)
	FIH(IRAD,L,IKAP,ISPIN)=AAH(L,ISORT,IKAP,1,ISPIN)*
     &AFI(IRAD,L)+BBH(L,ISORT,IKAP,1,ISPIN)*AFIP(IRAD,L)
	FIJ(IRAD,L,IKAP,ISPIN)=AAJ(L,ISORT,IKAP,1,ISPIN)*
     &AFI(IRAD,L)+BBJ(L,ISORT,IKAP,1,ISPIN)*AFIP(IRAD,L)
      ENDDO   
      ENDDO   
      ENDDO                          !!! over energies
	ENDDO                          !!! over spins
C  Set average potential and its radial derivative
	IF(LSCO(ISORT).NE.0.AND.ABS(ZNUC(ISORT)).GE.1.D-05)THEN
	DO IRAD=1,NRAD(ISORT)
	VBAR(IRAD)=-R(IRAD,ISORT)/SQRT(4.D0*PI)*
     &(POT(IRAD,1,IATOM,1,1)+POT(IRAD,1,IATOM,NSPIN,1))/2.D0
      ENDDO   
	VBAR(0)=2.D0*ZNUC(ISORT)
	CALL LIB_DERIV1(VBAR,VDER,NRAD(ISORT),H(ISORT),R(0,ISORT),
     &DR(0,ISORT),SMT(ISORT))
	ELSE
	DO IRAD=0,NRAD(ISORT)
	VBAR(IRAD)=0.D0
	VDER(IRAD)=0.D0
      ENDDO   
	ENDIF
	DO 4000 ISPIN1=1,NSPIN          !!! over spins
	DO 3000 ISPIN =1,NSPIN          !!! over spins
	DO 2000 IKAP1=1,NKAP(1)     !!! over ikap1
	DO 1000 IKAP=1,NKAP(1)      !!! over ikap
C NO SO-COUPLING WITH S-ELECTRONS
      DO IC=1,4
	PARS(0,IC)=(0.D0,0.D0)
	ENDDO
C CALCULATE RADIAL MATRIX ELEMENTS <F|1/c2*2/r*dV/dr|F> OF SO-COUPLING 
	DO L=1,ILST(ISORT)             !!! over l
	LOG1=.FALSE.
	IF(LTPAN(L,IATOM,IKAP1,1))LOG1=.TRUE.
	LOG =.FALSE.
	IF(LTPAN(L,IATOM,IKAP ,1))LOG =.TRUE.
      DO IC=1,4
	PARS(L,IC)=(0.D0,0.D0)
	ENDDO
C Relativistic correction
	EN=(ENY(L,ISORT,IKAP1,1,1)+ENY(L,ISORT,IKAP,1,NSPIN))*0.5D0
	DO IRAD=1,NRAD(ISORT)
C	ACOR(IRAD)=1.D0
	ACOR(IRAD)=1.D0/(1.D0+C2*(EN+VBAR(IRAD)/R(IRAD,ISORT)))**2*
     &DBLE(LSCO(ISORT))
	ENDDO
	ACOR(0)=ACOR(1)
C 1) <H|dV|H>
	IF(LOG1.AND.LOG)THEN
	WORK1(0)=(0.D0,0.D0)
	DO IRAD=1,NRAD(ISORT)          !!! over radial mesh
	WORK1(IRAD)=
     &CONJG(FIH(IRAD,L,IKAP1,ISPIN1))*FIH(IRAD,L,IKAP,ISPIN)*
     &2.D0*(VBAR(IRAD)/R(IRAD,ISORT)-VDER(IRAD))*C2*ACOR(IRAD)*
     &DR(IRAD,ISORT)
      ENDDO                          !!! over radial mesh
	CALL LIB_CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	PARS(L,1)=WORK2(NRAD(ISORT))
	ENDIF
C 2) <J|dV|H> diagonal
	IF(LOG)THEN
	WORK1(0)=(0.D0,0.D0)
	DO IRAD=1,NRAD(ISORT)          !!! over radial mesh
	WORK1(IRAD)=
     &CONJG(FIJ(IRAD,L,IKAP1,ISPIN1))*FIH(IRAD,L,IKAP,ISPIN)*
     &2.D0*(VBAR(IRAD)/R(IRAD,ISORT)-VDER(IRAD))*C2*ACOR(IRAD)*
     &DR(IRAD,ISORT)
      ENDDO                          !!! over radial mesh
	CALL LIB_CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	PARS(L,2)=WORK2(NRAD(ISORT))*GAM(L,ISORT)
	ENDIF
C 3) <H|dV|J> diagonal
	IF(LOG1)THEN
	WORK1(0)=(0.D0,0.D0)
	DO IRAD=1,NRAD(ISORT)          !!! over radial mesh
	WORK1(IRAD)=
     &CONJG(FIH(IRAD,L,IKAP1,ISPIN1))*FIJ(IRAD,L,IKAP,ISPIN)*
     &2.D0*(VBAR(IRAD)/R(IRAD,ISORT)-VDER(IRAD))*C2*ACOR(IRAD)*
     &DR(IRAD,ISORT)
      ENDDO                          !!! over radial mesh
	CALL LIB_CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	PARS(L,3)=WORK2(NRAD(ISORT))*GAM(L,ISORT)
	ENDIF
C 4) <J|dV|J> diagonal
	WORK1(0)=(0.D0,0.D0)
	DO IRAD=1,NRAD(ISORT)          !!! over radial mesh
	WORK1(IRAD)=
     &CONJG(FIJ(IRAD,L,IKAP1,ISPIN1))*FIJ(IRAD,L,IKAP,ISPIN)*
     &2.D0*(VBAR(IRAD)/R(IRAD,ISORT)-VDER(IRAD))*C2*ACOR(IRAD)*
     &DR(IRAD,ISORT)
      ENDDO                          !!! over radial mesh
	CALL LIB_CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	PARS(L,4)=WORK2(NRAD(ISORT))*GAM(L,ISORT)**2
      ENDDO                          !!! over l
C SET HAMILTONIAN PARAMETERS TO ZERO
	DO L1=0,ILST(ISORT)            !!! over l1
	LOG1=.FALSE.
	IF(LTPAN(L1,IATOM,IKAP1,1))LOG1=.TRUE.
	DO M1=-L1,L1                   !!! over m1
	L1M1=L1*(L1+1)+M1+1
	DO L=0,ILST(ISORT)             !!! over l
	LOG=.FALSE.
	IF(LTPAN(L,IATOM,IKAP,1))LOG=.TRUE.
	DO M=-L,L                      !!! over m
	LM=L*(L+1)+M+1
	IF(L1.LE.ILSB(ISORT).AND.L.LE.ILSB(ISORT))
     &HPARHH(L1M1,LM,IATOM,IKAP1,IKAP)=(0.D0,0.D0)
	IF(L.LE.ILSB(ISORT))
     &HPARJH(L1M1,LM,IATOM,IKAP1,IKAP)=(0.D0,0.D0)
	IF(L1.LE.ILSB(ISORT))
     &HPARHJ(L1M1,LM,IATOM,IKAP1,IKAP)=(0.D0,0.D0)
	HPARJJ(L1M1,LM,IATOM,IKAP1,IKAP)=(0.D0,0.D0)
      ENDDO                          !!! over m
      ENDDO                          !!! over l
      ENDDO                          !!! over m1
      ENDDO                          !!! over l1
C SET <Ylm'|l^mu|Ylm> MATRIX ELEMENT
	DO L=0,LMAXTMEM                                   !!! over l
	DO M1=-L,L                                        !!! over m1
	DO M=-L,L                                         !!! over m
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M1+1 !!!    (l,m1 m)
	OMAT(IU, 0)=0.D0
      OMAT(IU,+1)=0.D0
      OMAT(IU,-1)=0.D0
      IF(M1.EQ.M)
     &OMAT(IU, 0)=+DBLE(M)
      IF(M1.EQ.M-1)
     &OMAT(IU,+1)=-SQRT(DBLE(L+M)*DBLE(L-M+1))/SQRT(2.D0)
      IF(M1.EQ.M+1)
     &OMAT(IU,-1)=+SQRT(DBLE(L-M)*DBLE(L+M+1))/SQRT(2.D0)
	ENDDO                                             !!! over m
	ENDDO                                             !!! over m1
	ENDDO                                             !!! over l
C Do over polarizations	
      DO 500 MU=-1,1                 !!! over mu
C SET ORBTIAL FIELD PARAMETERS
	DO L=0,ILST(ISORT)             !!! over l
	LOG1=.FALSE.
	IF(LTPAN(L,IATOM,IKAP1,1))LOG1=.TRUE.
	LOG=.FALSE.
	IF(LTPAN(L,IATOM,IKAP,1))LOG=.TRUE.	
	DO M1=-L,L                     !!! over m
	LM1=L*(L+1)+M1+1
	DO M=-L,L                      !!! over m
	LM=L*(L+1)+M+1
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M1+1 !!!    (l,m1 m)
	IF(LOG1.AND.LOG)
     &HPARHH(LM1,LM,IATOM,IKAP1,IKAP)=PARS(L,1)*OMAT(IU,MU)
 	IF(LOG)
     &HPARJH(LM1,LM,IATOM,IKAP1,IKAP)=PARS(L,2)*OMAT(IU,MU)
 	IF(LOG1)
     &HPARHJ(LM1,LM,IATOM,IKAP1,IKAP)=PARS(L,3)*OMAT(IU,MU)
 	HPARJJ(LM1,LM,IATOM,IKAP1,IKAP)=PARS(L,4)*OMAT(IU,MU)
      ENDDO                          !!! over m
      ENDDO                          !!! over m1
      ENDDO                          !!! over l1
C STORE POTENTIAL PARAMETERS
      IC=2
	IREC=IKAP1+NKAP(1)*(IKAP-1)+NKAP(1)**2*(MU+1)+
     &NKAP(1)**2*3*(IATOM-1)+
     &NKAP(1)**2*3*NATOM*(ISPIN1-1)+
     &NKAP(1)**2*3*NATOM*NSPIN*(ISPIN-1)+
     &NKAP(1)**2*3*NATOM*NSPIN*NSPIN*(IC-1)
	WRITE(IUDMT,REC=IREC)
     &((HPARHH(L1M1,LM,IATOM,IKAP1,IKAP),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((HPARJH(L1M1,LM,IATOM,IKAP1,IKAP),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((HPARHJ(L1M1,LM,IATOM,IKAP1,IKAP),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &((HPARJJ(L1M1,LM,IATOM,IKAP1,IKAP),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2)
 500  CONTINUE                       !!! over mu
1000	CONTINUE                       !!! over ikap
2000	CONTINUE                       !!! over ikap1
3000	CONTINUE                       !!! over spins
4000	CONTINUE                       !!! over spins
5000	CONTINUE                       !!! over atoms
C MEMORY DEALLOCATIONS
	DEALLOCATE(WORK1,WORK2,FIH,FIJ,AFI,AFID,AFIP,AFIDP)
	DEALLOCATE(AFIDDS,AFIDDPS,VBAR,VDER,ACOR,OMAT,PARS)
	END
