	SUBROUTINE CHI_SETCHI
************************************************************
*   Saves optical matrix                                   *
************************************************************
C SET ARRAY-SIZE DATA
	USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
	USE COM_LMTMEM                                        !!! from setup
	USE COM_CONTROL ,ONLY: LIFT,LMTO                      !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,NHSORT !!! from readini
     &                      ,IS,ILST,ILSB
      USE COM_LATPAR  ,ONLY: PAR,OMEGAC                     !!! from readini
	USE COM_QMESH   ,ONLY: NQPNT,QPNT                     !!! from tetra
	USE COM_KAPPAR  ,ONLY: NPAN,NKAP                      !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN                    !!! from readini
	USE COM_INPTTR  ,ONLY: NDIV,NDIC,NDIW                 !!! from readini
	USE COM_KMESH   ,ONLY: NPNT,PNT                       !!! from tetra
      USE COM_FREQU   ,ONLY: NOMGCHI,OMGCHI                 !!! from readini
	USE COM_CHIDAT  ,ONLY: IMATR,NCHI,INCHI,CHI0          !!! from intchi
      USE COM_HUBDAT  ,ONLY: NHUB,MCRL,LCRL,ICUBC,IRE       !!! from readhub
      USE COM_HUBSYS  ,ONLY: ROUTAXE,ROUTANG,ROUTINV        !!! from readhop
	USE COM_UNIT    ,ONLY: IUN,IUR,IUT,IUI                !!! from setup
      USE COM_CHANNELS,ONLY: IUAIN,IUCHI                    !!! from channels
      USE COM_LABELS  ,ONLY: TXTAT,TXTEL,TXTSP              !!! from readini
	USE COM_LMTOUT  ,ONLY: ICCHI,CHIFILE                  !!! from readini
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 TRS(7,-3:3,0:3),GINTS(-1:1,-1:1,3,3),GINTC(3,3,3,3)
	LOGICAL EXIST
	CHARACTER TXTL(0:3)*1,LIB_TCP*23,TCHAR(3)*23,TXYZ(3)*1,HELP*40
     &     ,TCTRL1*10,TCTRL*10,TCHI1*3,TCHI*3
	DATA PI/3.141592653589793D0/,TXTL/'s','p','d','f'/
     &     ,TXYZ/'x','y','z'/
	IF(ICCHI.EQ.0)RETURN
C Memory Allocations
C     none
C Build transformation matrices
	CALL LIB_TRANSS(TRS)
C STORE HEADER INFO.
	INQUIRE(FILE=CHIFILE,EXIST=EXIST)
	IF(EXIST)THEN
      OPEN(UNIT=IUAIN,FILE=CHIFILE,STATUS='OLD',FORM='FORMATTED')
	CLOSE(UNIT=IUAIN,STATUS='DELETE')
	ENDIF
	OPEN(IUAIN,FILE=CHIFILE,STATUS='NEW',FORM='FORMATTED')
	WRITE(IUAIN,10010)
	WRITE(IUAIN,10020)
10010	FORMAT(1X,'<FILE=CHIFILE,INPUT=MODERN>')
10020 FORMAT('****************************************************')
	WRITE(IUAIN,10030)
10030 FORMAT(1X,'<SECTION=CTRL>               ! CONTROL PARAMETERS:')
      HELP='! Frequency mesh for chi(q,w)        '
	WRITE(IUAIN,10040)NOMGCHI,HELP
10040 FORMAT(1X,'nOmgCHI=',I5,16X,A40)
      HELP='! Min.Frequency (Ry)  for chi(q,w)   '
	WRITE(IUAIN,10050)OMGCHI(0),HELP
10050 FORMAT(1X,'WminCHI=',G14.7,7X,A40)
      HELP='! Max.Frequency (Ry)  for chi(q,w)   '
	WRITE(IUAIN,10060)OMGCHI(NOMGCHI),HELP
10060 FORMAT(1X,'WmaxCHI=',G14.7,7X,A40)
	HELP='! Tetrahedron mesh                     '
	WRITE(IUAIN,10070)NDIV,HELP
10070 FORMAT(1X,'nDiv(:)=',I2,1X,I2,1X,I2,1X,12X,A40)
	HELP='! Tetrahedron mesh for weights         '
	WRITE(IUAIN,10080)NDIW,HELP
10080 FORMAT(1X,'nDiw(:)=',I2,1X,I2,1X,I2,1X,12X,A40)
      HELP='! Matrix Elements: none/find         '
	IF(IMATR.EQ.0)
     &WRITE(IUAIN,10090)'none',HELP
	IF(IMATR.EQ.1)
     &WRITE(IUAIN,10090)'find',HELP
10090 FORMAT(1X,'MatElem=',A4,17X,A40)
C STORE CHI(Q,W) DATA
	WRITE(IUAIN,10110)
10110 FORMAT(1X,'<SECTION=DATA>               ! CHI(Q,W) DATA:')
	DO IQPNT=1,NQPNT                                  !!! over q-points
	WRITE(IUAIN,10120)(QPNT(I,IQPNT),I=1,3)
10120	FORMAT(1X,G14.7,1X,G14.7,1X,G14.7,10X,'! q-vector')
	DO IOMG=0,NOMGCHI                                 !!! over frequencies
	WRITE(IUAIN,10130)OMGCHI(IOMG)
10130	FORMAT(1X,G14.7,40X,'! Frequency')
	CALL CHIFILES(IQPNT,IOMG,IUCHI,'R')
	DO IATOM1=1,NATOM                                 !!! over atoms
	ISORT1=IS(IATOM1)
	IF(MCRL(IATOM1).EQ.0)CYCLE
	DO IATOM=1,NATOM                                  !!! over atoms
	ISORT=IS(IATOM)
	IF(MCRL(IATOM).EQ.0)CYCLE
	DO L1=0,ILSB(ISORT1)                              !!! over l1
	IF(LCRL(L1,IATOM1).EQ.0)CYCLE
	DO L=0,ILSB(ISORT)                                !!! over l
	IF(LCRL(L,IATOM).EQ.0)CYCLE
      DO IM1SPIN=1,NSPIN                                !!! over im1spin
      DO IK1SPIN=1,NSPIN                                !!! over ik1spin
      DO IMSPIN=1,NSPIN                                 !!! over imspin
      DO IKSPIN=1,NSPIN                                 !!! over ikspin
	IF(NSPIN.EQ.1)WRITE(IUAIN,10140)
     &TXTL(L1),TXTAT(ISORT1),TXTL(L),TXTAT(ISORT)
	IF(NSPIN.EQ.2)WRITE(IUAIN,10150)
     &TXTSP(IM1SPIN),TXTSP(IK1SPIN),TXTL(L1),TXTAT(ISORT1),
     &TXTSP(IM SPIN),TXTSP(IK SPIN),TXTL(L ),TXTAT(ISORT )
10140	FORMAT('!','L1 = ',A1,1X,'Atom1 = ',A10,
     &        1X,'L  = ',A1,1X,'Atom  = ',A10)
10150	FORMAT('!',A2,'-',A2,1X,'L1 = ',A1,1X,'Atom1 = ',A10, 
     &        1X,A2,'-',A2,1X,' L = ',A1,1X,'Atom  = ',A10)
	DO M1=-L1,L1                                      !!! over m1
	DO K1=-L1,L1                                      !!! over k1
	IU1=L1*(2*L1-1)*(2*L1+1)/3+(2*L1+1)*(L1+K1)+L1+M1+1 !!!    (l1,m1 k1)
	ICHI1=INCHI(IU1,IATOM1,IK1SPIN,IM1SPIN)
	DO M=-L,L                                         !!! over m
	DO K=-L,L                                         !!! over k
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+K)+L+M+1 !!!    (l,m k)
	ICHI=INCHI(IU,IATOM,IKSPIN,IMSPIN)
	WRITE(IUAIN,10160)(CHI0(ICHI1,ICHI,IREIM),IREIM=1,2)
10160 FORMAT(1X,'(',G14.7,',',G14.7,')',' , ','(',G14.7,',',G14.7,')')
	ENDDO                                             !!! over k
	ENDDO                                             !!! over m
	ENDDO                                             !!! over k1
	ENDDO                                             !!! over m1
	ENDDO                                             !!! over ikspin
	ENDDO                                             !!! over imspin
	ENDDO                                             !!! over ik1spin
	ENDDO                                             !!! over im1spin
	ENDDO                                             !!! over l
	ENDDO                                             !!! over l1
	ENDDO                                             !!! over atoms
	ENDDO                                             !!! over atoms
	ENDDO                                             !!! over frequencies
	ENDDO                                             !!! over q-points
C STORE J(Q,W) DATA
	IF(NSPIN.EQ.2)THEN
	WRITE(IUAIN,10210)
10210 FORMAT(1X,'<SECTION=JEYS>               ! J(Q,W) DATA:')
	DO IQPNT=1,NQPNT                                  !!! over q-points
	WRITE(IUAIN,10220)(QPNT(I,IQPNT),I=1,3)
10220	FORMAT(1X,G14.7,1X,G14.7,1X,G14.7,10X,'! q-vector')
	DO IOMG=0,NOMGCHI                                 !!! over frequencies
	WRITE(IUAIN,10230)OMGCHI(IOMG)
10230	FORMAT(1X,G14.7,40X,'! Frequency')
	CALL CHIFILES(IQPNT,IOMG,IUCHI,'R')
	DO IATOM1=1,NATOM                                 !!! over atoms
	ISORT1=IS(IATOM1)
	IF(MCRL(IATOM1).EQ.0)CYCLE
	DO IATOM=1,NATOM                                  !!! over atoms
	ISORT=IS(IATOM)
	IF(MCRL(IATOM).EQ.0)CYCLE
	DO L1=0,ILSB(ISORT1)                              !!! over l1
	IF(LCRL(L1,IATOM1).EQ.0)CYCLE
	DO L=0,ILSB(ISORT)                                !!! over l
	IF(LCRL(L,IATOM).EQ.0)CYCLE
	CALL SET_STATE(TCTRL1,10,TXTAT(ISORT1),IATOM1,0,
     &LCRL(L1,IATOM1),L1,-100,1)
	CALL SET_STATE(TCTRL,10,TXTAT(ISORT),IATOM,0,
     &LCRL(L,IATOM),L,-100,1)
C Compute J's for given q
	CALL CHI_SETJEYS(L1,IATOM1,L,IATOM,GINTS,GINTC)
C Chi_SS
	WRITE(IUAIN,10240)TCTRL1,TCTRL,'Chi_SS'
	WRITE(IUAIN,10250)
	DO IA1=1,3
	DO IA=1,3
	TCHAR(IA)=LIB_TCP(GINTC(IA1,IA,1,1),1.D-07)
	ENDDO
	WRITE(IUAIN,10260)(TCHAR(IA),IA=1,3),TXYZ(IA1)
	ENDDO
C Do not print orbital parts
	IF(.FALSE.)THEN
C Chi_SO
	WRITE(IUAIN,10240)TCTRL1,TCTRL,'Chi_SO1'
	WRITE(IUAIN,10250)
	DO IA1=1,3
	DO IA=1,3
	TCHAR(IA)=LIB_TCP(GINTC(IA1,IA,1,2),1.D-07)
	ENDDO
	WRITE(IUAIN,10260)(TCHAR(IA),IA=1,3),TXYZ(IA1)
	ENDDO
C Chi_OS
	WRITE(IUAIN,10240)TCTRL1,TCTRL,'Chi_OS1'
	WRITE(IUAIN,10250)
	DO IA1=1,3
	DO IA=1,3
	TCHAR(IA)=LIB_TCP(GINTC(IA1,IA,2,1),1.D-07)
	ENDDO
	WRITE(IUAIN,10260)(TCHAR(IA),IA=1,3),TXYZ(IA1)
	ENDDO
C Chi_OO
	WRITE(IUAIN,10240)TCTRL1,TCTRL,'Chi_OO1'
	WRITE(IUAIN,10250)
	DO IA1=1,3
	DO IA=1,3
	TCHAR(IA)=LIB_TCP(GINTC(IA1,IA,2,2),1.D-07)
	ENDDO
	WRITE(IUAIN,10260)(TCHAR(IA),IA=1,3),TXYZ(IA1)
	ENDDO
C Chi_SO
	WRITE(IUAIN,10240)TCTRL1,TCTRL,'Chi_SO2'
	WRITE(IUAIN,10250)
	DO IA1=1,3
	DO IA=1,3
	TCHAR(IA)=LIB_TCP(GINTC(IA1,IA,1,3),1.D-07)
	ENDDO
	WRITE(IUAIN,10260)(TCHAR(IA),IA=1,3),TXYZ(IA1)
	ENDDO
C Chi_OS
	WRITE(IUAIN,10240)TCTRL1,TCTRL,'Chi_OS2'
	WRITE(IUAIN,10250)
	DO IA1=1,3
	DO IA=1,3
	TCHAR(IA)=LIB_TCP(GINTC(IA1,IA,3,1),1.D-07)
	ENDDO
	WRITE(IUAIN,10260)(TCHAR(IA),IA=1,3),TXYZ(IA1)
	ENDDO
C Chi_OO
	WRITE(IUAIN,10240)TCTRL1,TCTRL,'Chi_OO2'
	WRITE(IUAIN,10250)
	DO IA1=1,3
	DO IA=1,3
	TCHAR(IA)=LIB_TCP(GINTC(IA1,IA,3,3),1.D-07)
	ENDDO
	WRITE(IUAIN,10260)(TCHAR(IA),IA=1,3),TXYZ(IA1)
	ENDDO
      ENDIF	
10240	FORMAT(' cState = ',A10,' ; cState = ',A10,2X,A7)
10250 FORMAT(1X,11X,'x',11X,1X,11X,'y',11X,1X,11X,'z')
10260 FORMAT(1X,A23,1X,A23,1X,A23,3X,A1)
	ENDDO                                             !!! over l
	ENDDO                                             !!! over atoms
	ENDDO                                             !!! over l1
	ENDDO                                             !!! over atoms
	ENDDO                                             !!! over frequencies
	ENDDO                                             !!! over q-points
	ENDIF
C PRINT EXCHANGE CONSTANTS
	IF(IMATR.EQ.1.AND.NSPIN.EQ.2)THEN
C STORE J(Q,W) DATA
	WRITE(IUAIN,10310)
10310 FORMAT(1X,'<SECTION=JMAT>               ! Jmat(Q,W) DATA:')
	DO IQPNT=1,NQPNT                                  !!! over q-points
	WRITE(IUAIN,10320)(QPNT(I,IQPNT),I=1,3)
10320	FORMAT(1X,G14.7,1X,G14.7,1X,G14.7,10X,'! q-vector')
	DO IOMG=0,NOMGCHI                                 !!! over frequencies
	WRITE(IUAIN,10330)OMGCHI(IOMG)
10330	FORMAT(1X,G14.7,40X,'! Frequency')
	CALL CHIFILES(IQPNT,IOMG,IUCHI,'R')
	DO IATOM1=1,NATOM                                 !!! over atoms
	ISORT1=IS(IATOM1)
	DO IATOM=1,NATOM                                  !!! over atoms
	ISORT=IS(IATOM)
C Compute J's for given q
	CALL CHI_SETJMAT(IATOM1,IATOM,GINTS,GINTC)
      DO IC1=1,3
      IF(IC1.EQ.1)TCHI1='hub'
      IF(IC1.EQ.2)TCHI1='orb'
      IF(IC1.EQ.3)TCHI1='lda'
      DO IC =1,3
      IF(IC.EQ.1)TCHI='hub'
      IF(IC.EQ.2)TCHI='orb'
      IF(IC.EQ.3)TCHI='lda'
	WRITE(IUAIN,10340)TXTAT(ISORT1),TXTAT(ISORT),TCHI1//'-'//TCHI
	WRITE(IUAIN,10350)
	DO IA1=1,3
	DO IA=1,3
	TCHAR(IA)=LIB_TCP(GINTC(IA1,IA,IC1,IC),1.D-07)
	ENDDO
	WRITE(IUAIN,10360)(TCHAR(IA),IA=1,3),TXYZ(IA1)
	ENDDO
      ENDDO
	ENDDO
	ENDDO                                             !!! over atoms
	ENDDO                                             !!! over atoms
	ENDDO                                             !!! over frequencies
	ENDDO                                             !!! over q-points
	ENDIF
10340	FORMAT('!','Atom1 = ',A10,1X,'Atom  = ',A10,1X,'Chi(',A7,')')
10350 FORMAT(1X,11X,'x',11X,1X,11X,'y',11X,1X,11X,'z')
10360 FORMAT(1X,A23,1X,A23,1X,A23,3X,A1)
      CLOSE(IUAIN)
C Memory deallocations
	END

