	SUBROUTINE CHI_SETJEYS(L1,IATOM1,L,IATOM,GINTS,GINTC)
************************************************************
*   Computes exchange constants for a given q              *
************************************************************
C SET ARRAY-SIZE DATA
	USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
	USE COM_LMTMEM                                        !!! from setup
	USE COM_CONTROL ,ONLY: LIFT,LMTO,IDMF                 !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,NHSORT !!! from readini
     &                      ,IS,ILST,ILSB
      USE COM_LATPAR  ,ONLY: PAR,OMEGAC                     !!! from readini
	USE COM_QMESH   ,ONLY: NQPNT,QPNT                     !!! from tetra
	USE COM_KAPPAR  ,ONLY: NPAN,NKAP                      !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN                    !!! from readini
	USE COM_CHIDAT  ,ONLY: NCHI,INCHI,CHI0                !!! from intchi
      USE COM_HUBDAT  ,ONLY: NHUB,MCRL,LCRL,ICUBC,IRE       !!! from readhub
      USE COM_HUBCOM  ,ONLY: DHUB,VHUB,VCNS,VDBC            !!! from readhub
      USE COM_DMFDAT  ,ONLY: SIGI                           !!! from grfmat
	USE COM_UNIT    ,ONLY: IUN,IUR,IUT,IUI                !!! from setup
      USE COM_CHANNELS,ONLY: IUCHI                          !!! from channels
      USE COM_LABELS  ,ONLY: TXTAT,TXTEL,TXTSP              !!! from readini
	USE COM_LMTOUT  ,ONLY: ICCHI                          !!! from readini
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8, ALLOCATABLE :: OMAT1(:,:)
	REAL*8, ALLOCATABLE :: OMAT (:,:)
	REAL*8, ALLOCATABLE :: BMAG1(:,:,:)
	REAL*8, ALLOCATABLE :: BMAG (:,:,:)
	COMPLEX*16 PMATS(2,2,-1:1),SPHC(-1:1,-1:1,-1:1),TR(3,-1:1)
     &   ,GINTS(-1:1,-1:1,3,3),GINTC(3,3,3,3)
	DATA PI/3.141592653589793D0/
	IF(ICCHI.EQ.0)RETURN
	IF(NSPIN.EQ.1)RETURN
      ALLOCATE(BMAG1(-L1:L1,-L1:L1,-1:1))
      ALLOCATE(BMAG(-L:L,-L:L,-1:1))
      ALLOCATE(OMAT1(-L1:L1,-1:1))
      ALLOCATE(OMAT (-L:L,-1:1))
C Build transformation matrices
	CALL LIB_PMATSUP(PMATS)
	CALL LIB_SPHCROSSDNDNUP(SPHC)
      CALL LIB_SPHUP2CAR(TR)
C Build orbital matrices
	DO M1=-L1,L1                                      !!! over m1
      OMAT1(M1, 0)=+DBLE(M1)
      OMAT1(M1,+1)=-SQRT(DBLE(L1+M1)*DBLE(L1-M1+1))/SQRT(2.D0)
      OMAT1(M1,-1)=+SQRT(DBLE(L1-M1)*DBLE(L1+M1+1))/SQRT(2.D0)
	ENDDO                                             !!! over m1
	DO M=-L,L                                         !!! over m
      OMAT(M, 0)=+DBLE(M)
      OMAT(M,+1)=-SQRT(DBLE(L+M)*DBLE(L-M+1))/SQRT(2.D0)
      OMAT(M,-1)=+SQRT(DBLE(L-M)*DBLE(L+M+1))/SQRT(2.D0)
	ENDDO                                             !!! over m
C Set exchange constants to zero
      DO IC1=1,3
      DO IC =1,3
	DO MU1=-1,1
	DO MU =-1,1
	GINTS(MU1,MU,IC1,IC)=(0.D0,0.D0)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C Set exchange constants to zero
      DO IC1=1,3
      DO IC =1,3
	DO IA1=1,3
	DO IA =1,3
	GINTC(IA1,IA,IC1,IC)=(0.D0,0.D0)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C Compute magnetic field
	DO M1=-L1,L1                                      !!! over m1
	DO K1=-L1,L1                                      !!! over k1
	IU1=L1*(2*L1-1)*(2*L1+1)/3+(2*L1+1)*(L1+K1)+L1+M1+1 !!!    (l1,m1 k1)
	BMAG1(M1,K1, 0)=(0.D0,0.D0)
	BMAG1(M1,K1,-1)=(0.D0,0.D0)
	BMAG1(M1,K1,+1)=(0.D0,0.D0)
	IF(IDMF.EQ.1)THEN
	BMAG1(M1,K1, 0)=
     &          -((VCNS(IU1,IATOM1,1,1)-VCNS(IU1,IATOM1,NSPIN,1)))/2.D0
	ELSEIF(IDMF.EQ.2)THEN
	BMAG1(M1,K1, 0)=
     &          -((VHUB(IU1,IATOM1,1,1)-VHUB(IU1,IATOM1,NSPIN,1))+
     &            (VCNS(IU1,IATOM1,1,1)-VCNS(IU1,IATOM1,NSPIN,1))-
     &            (VDBC(IU1,IATOM1,1,1)-VDBC(IU1,IATOM1,NSPIN,1)))/2.D0
	ELSEIF(IDMF.GT.2)THEN
	BMAG1(M1,K1, 0)=
     &          -((SIGI(IU1,IATOM1,1,1)-SIGI(IU1,IATOM1,NSPIN,1))-
     &            (VDBC(IU1,IATOM1,1,1)-VDBC(IU1,IATOM1,NSPIN,1)))/2.D0
	ENDIF
	IF(IDMF.EQ.1.AND.NORBS.EQ.2)THEN
	BMAG1(M1,K1,-1)=-(VCNS(IU1,IATOM1,NSPIN,NORBS))/SQRT(2.D0)
	BMAG1(M1,K1,+1)=+(VCNS(IU1,IATOM1,    1,NORBS))/SQRT(2.D0)
	ELSEIF(IDMF.EQ.2.AND.NORBS.EQ.2)THEN
	BMAG1(M1,K1,-1)=
     &          -(VHUB(IU1,IATOM1,NSPIN,NORBS)+
     &            VCNS(IU1,IATOM1,NSPIN,NORBS)-
     &            VDBC(IU1,IATOM1,NSPIN,NORBS))/SQRT(2.D0)
	BMAG1(M1,K1,+1)=
     &          +(VHUB(IU1,IATOM1,    1,NORBS)+
     &            VCNS(IU1,IATOM1,    1,NORBS)-
     &            VDBC(IU1,IATOM1,    1,NORBS))/SQRT(2.D0)
	ELSEIF(IDMF.GT.2.AND.NORBS.EQ.2)THEN
	BMAG1(M1,K1,-1)=
     &          -(SIGI(IU1,IATOM1,NSPIN,NORBS)-
     &            VDBC(IU1,IATOM1,NSPIN,NORBS))/SQRT(2.D0)
	BMAG1(M1,K1,+1)=
     &          +(SIGI(IU1,IATOM1,    1,NORBS)-
     &            VDBC(IU1,IATOM1,    1,NORBS))/SQRT(2.D0)
	ENDIF
	ENDDO                                             !!! over k1
	ENDDO                                             !!! over m1
C Compute magnetic field
	DO M=-L,L                                         !!! over m
	DO K=-L,L                                         !!! over k
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+K)+L+M+1 !!!    (l,m k)
	BMAG(M,K, 0)=(0.D0,0.D0)
	BMAG(M,K,-1)=(0.D0,0.D0)
	BMAG(M,K,+1)=(0.D0,0.D0)
	IF(IDMF.EQ.1)THEN
	BMAG(M,K, 0)=-((VCNS(IU,IATOM,1,1)-VCNS(IU,IATOM,NSPIN,1))
     &            )/2.D0
	ELSEIF(IDMF.EQ.2)THEN
	BMAG(M,K, 0)=-((VHUB(IU,IATOM,1,1)-VHUB(IU,IATOM,NSPIN,1))+
     &           (VCNS(IU,IATOM,1,1)-VCNS(IU,IATOM,NSPIN,1))-
     &           (VDBC(IU,IATOM,1,1)-VDBC(IU,IATOM,NSPIN,1)))/2.D0
	ELSEIF(IDMF.GT.2)THEN
	BMAG(M,K, 0)=-((SIGI(IU,IATOM,1,1)-SIGI(IU,IATOM,NSPIN,1))-
     &           (VDBC(IU,IATOM,1,1)-VDBC(IU,IATOM,NSPIN,1)))/2.D0
	ENDIF
	IF(IDMF.EQ.1.AND.NORBS.EQ.2)THEN
	BMAG(M,K,-1)=-(VCNS(IU,IATOM,NSPIN,NORBS))/SQRT(2.D0)
	BMAG(M,K,+1)=+(VCNS(IU,IATOM,    1,NORBS))/SQRT(2.D0)
	ELSEIF(IDMF.EQ.2.AND.NORBS.EQ.2)THEN
	BMAG(M,K,-1)=-(VHUB(IU,IATOM,NSPIN,NORBS)+
     &           VCNS(IU,IATOM,NSPIN,NORBS)-
     &           VDBC(IU,IATOM,NSPIN,NORBS))/SQRT(2.D0)
	BMAG(M,K,+1)=+(VHUB(IU,IATOM,    1,NORBS)+
     &           VCNS(IU,IATOM,    1,NORBS)-
     &           VDBC(IU,IATOM,    1,NORBS))/SQRT(2.D0)
	ELSEIF(IDMF.GT.2.AND.NORBS.EQ.2)THEN
	BMAG(M,K,-1)=-(SIGI(IU,IATOM,NSPIN,NORBS)-
     &           VDBC(IU,IATOM,NSPIN,NORBS))/SQRT(2.D0)
	BMAG(M,K,+1)=+(SIGI(IU,IATOM,    1,NORBS)-
     &           VDBC(IU,IATOM,    1,NORBS))/SQRT(2.D0)
	ENDIF
	ENDDO                                             !!! over k
	ENDDO                                             !!! over m
C Loop over coordinates
	DO IA1=-1,1
	DO IA =-1,1
	DO MU1=-1,1
	DO MU =-1,1
	DO NU1=-1,1
	DO NU =-1,1
C Compute convolutions with magnetic fields
      DO IM1SPIN=1,NSPIN                                !!! over im1spin
      DO IK1SPIN=1,NSPIN                                !!! over ik1spin
	DO M1=-L1,L1                                      !!! over m1
	DO K1=-L1,L1                                      !!! over k1
	IU1=L1*(2*L1-1)*(2*L1+1)/3+(2*L1+1)*(L1+K1)+L1+M1+1 !!!    (l1,m1 k1)
	ICHI1=INCHI(IU1,IATOM1,IM1SPIN,IK1SPIN)
      DO IMSPIN=1,NSPIN                                 !!! over imspin
      DO IKSPIN=1,NSPIN                                 !!! over ikspin
	DO M=-L,L                                         !!! over m
	DO K=-L,L                                         !!! over k
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+K)+L+M+1 !!!    (l,m k)
	ICHI=INCHI(IU,IATOM,IMSPIN,IKSPIN)
C Chi-SS
	GINTS(IA1,IA,1,1)=GINTS(IA1,IA,1,1)+
     &PMATS(IM1SPIN,IK1SPIN,NU1)*SPHC(NU1,MU1,IA1)*
     &BMAG1(M1,K1,MU1)*CHI0(ICHI1,ICHI,1)*BMAG(M,K,MU)*
     &PMATS(IMSPIN,IKSPIN,NU)*SPHC(NU,MU,IA)
C Chi-SO
      IF(IMSPIN.EQ.IKSPIN.AND.ABS(K-NU).LE.L)
     &GINTS(IA1,IA,1,2)=GINTS(IA1,IA,1,2)+
     &PMATS(IM1SPIN,IK1SPIN,NU1)*SPHC(NU1,MU1,IA1)*
     &BMAG1(M1,K1,MU1)*CHI0(ICHI1,ICHI,1)*BMAG(M,K-NU,MU)*
     &OMAT(K,NU)*SPHC(NU,MU,IA)
C Chi-OS
      IF(IM1SPIN.EQ.IK1SPIN.AND.ABS(K1-NU1).LE.L1)
     &GINTS(IA1,IA,2,1)=GINTS(IA1,IA,2,1)+
     &OMAT1(K1,NU1)*SPHC(NU1,MU1,IA1)*
     &BMAG1(M1,K1-NU1,MU1)*CHI0(ICHI1,ICHI,1)*BMAG(M,K,MU)*
     &PMATS(IMSPIN,IKSPIN,NU)*SPHC(NU,MU,IA)
C Chi-OO
      IF(IM1SPIN.EQ.IK1SPIN.AND.IMSPIN.EQ.IKSPIN.AND.
     &ABS(K1-NU1).LE.L1.AND.ABS(K-NU).LE.L)
     &GINTS(IA1,IA,2,2)=GINTS(IA1,IA,2,2)+
     &OMAT1(K1,NU1)*SPHC(NU1,MU1,IA1)*
     &BMAG1(M1,K1-NU1,MU1)*CHI0(ICHI1,ICHI,1)*BMAG(M,K-NU,MU)*
     &OMAT(K,NU)*SPHC(NU,MU,IA)
C Chi-SO
      IF(IMSPIN.EQ.IKSPIN.AND.ABS(M+NU).LE.L)
     &GINTS(IA1,IA,1,3)=GINTS(IA1,IA,1,3)+
     &PMATS(IM1SPIN,IK1SPIN,NU1)*SPHC(NU1,MU1,IA1)*
     &BMAG1(M1,K1,MU1)*CHI0(ICHI1,ICHI,1)*BMAG(M+NU,K,MU)*
     &OMAT(M,-NU)*SPHC(NU,MU,IA)
C Chi-OS
      IF(IM1SPIN.EQ.IK1SPIN.AND.ABS(M1+NU1).LE.L1)
     &GINTS(IA1,IA,3,1)=GINTS(IA1,IA,3,1)+
     &OMAT1(M1,-NU1)*SPHC(NU1,MU1,IA1)*
     &BMAG1(M1+NU1,K1,MU1)*CHI0(ICHI1,ICHI,1)*BMAG(M,K,MU)*
     &PMATS(IMSPIN,IKSPIN,NU)*SPHC(NU,MU,IA)
C Chi-OO
      IF(IM1SPIN.EQ.IK1SPIN.AND.IMSPIN.EQ.IKSPIN.AND.
     &ABS(M1+NU1).LE.L1.AND.ABS(M+NU).LE.L)
     &GINTS(IA1,IA,3,3)=GINTS(IA1,IA,3,3)+
     &OMAT1(M1,-NU1)*SPHC(NU1,MU1,IA1)*
     &BMAG1(M1+NU1,K1,MU1)*CHI0(ICHI1,ICHI,1)*BMAG(M+NU,K,MU)*
     &OMAT(M,-NU)*SPHC(NU,MU,IA)
	ENDDO                                             !!! over k
	ENDDO                                             !!! over m
	ENDDO                                             !!! over ikspin
	ENDDO                                             !!! over imspin
	ENDDO                                             !!! over k1
	ENDDO                                             !!! over m1
	ENDDO                                             !!! over ik1spin
	ENDDO                                             !!! over im1spin
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C Transform to caretensian coordinates
      DO IC1=1,3
      DO IC =1,3
	DO IA1=1,3
	DO IA =1,3
	GINTC(IA1,IA,IC1,IC)=(0.D0,0.D0)
	DO MU1=-1,1
	DO MU =-1,1
	GINTC(IA1,IA,IC1,IC)=GINTC(IA1,IA,IC1,IC)+
     &TR(IA1,MU1)*GINTS(MU1,MU,IC1,IC)*TR(IA,MU)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C Memory Deallocations
      DEALLOCATE(OMAT1,OMAT,BMAG1,BMAG)
	END




	SUBROUTINE CHI_SETJMAT(IATOM1,IATOM,GINTS,GINTC)
************************************************************
*   Computes exchange constants for a given q              *
************************************************************
C SET ARRAY-SIZE DATA
	USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
	USE COM_LMTMEM                                        !!! from setup
	USE COM_CONTROL ,ONLY: LIFT,LMTO                      !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,NHSORT !!! from readini
     &                      ,IS,ILST,ILSB
      USE COM_LATPAR  ,ONLY: PAR,OMEGAC                     !!! from readini
	USE COM_QMESH   ,ONLY: NQPNT,QPNT                     !!! from tetra
	USE COM_KAPPAR  ,ONLY: NPAN,NKAP                      !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN                    !!! from readini
	USE COM_INPTTR  ,ONLY: NDIV,NDIC,NDIW                 !!! from readini
	USE COM_KMESH   ,ONLY: NPNT,PNT                       !!! from tetra
      USE COM_FREQU   ,ONLY: NOMGCHI,OMGCHI                 !!! from readini
	USE COM_CHIDAT  ,ONLY: GINT                           !!! from intchi
      USE COM_HUBSYS  ,ONLY: ROUTAXE,ROUTANG,ROUTINV        !!! from readhop
	USE COM_UNIT    ,ONLY: IUN,IUR,IUT,IUI                !!! from setup
      USE COM_LABELS  ,ONLY: TXTAT,TXTEL,TXTSP              !!! from readini
	USE COM_LMTOUT  ,ONLY: ICCHI                          !!! from readini
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16 PMATS(2,2,-1:1),SPHC(-1:1,-1:1,-1:1),TR(3,-1:1)
     &  ,GINTS(-1:1,-1:1,3,3),GINTC(3,3,3,3),BMAG1(-1:1),BMAG(-1:1)
	DATA PI/3.141592653589793D0/
	IF(ICCHI.EQ.0)RETURN
	IF(NSPIN.EQ.1)RETURN
C Build transformation matrices
	CALL LIB_PMATSUP(PMATS)
	CALL LIB_SPHCROSSDNDNUP(SPHC)
      CALL LIB_SPHUP2CAR(TR)
C Set exchange constants to zero
      DO IC1=1,3
      DO IC =1,3
	DO MU1=-1,1
	DO MU =-1,1
	GINTS(MU1,MU,IC1,IC)=(0.D0,0.D0)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C Set exchange constants to zero
      DO IC1=1,3
      DO IC =1,3
	DO IA1=1,3
	DO IA =1,3
	GINTC(IA1,IA,IC1,IC)=(0.D0,0.D0)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C Compute convolutions with magnetic fields
	IND1=0
      DO IM1SPIN=1,NSPIN                                !!! over im1spin
      DO IK1SPIN=1,NSPIN                                !!! over ik1spin
	DO MU1=-1,1
	IND1=IND1+1
	IND=0
      DO IMSPIN=1,NSPIN                                 !!! over imspin
      DO IKSPIN=1,NSPIN                                 !!! over ikspin
	DO MU =-1,1
	IND=IND+1
C Loop over coordinates
      DO IC1=1,3
      DO IC=1,3
	DO IA1=-1,1
	DO IA =-1,1
	DO NU1=-1,1
	DO NU =-1,1
	GINTS(IA1,IA,IC1,IC)=GINTS(IA1,IA,IC1,IC)+
     &PMATS(IM1SPIN,IK1SPIN,NU1)*SPHC(NU1,MU1,IA1)*
     &GINT(IND1,IATOM1,IND,IATOM,IC1,IC)*
     &PMATS(IMSPIN,IKSPIN,NU)*SPHC(NU,MU,IA)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO                                             !!! over ikspin
	ENDDO                                             !!! over imspin
	ENDDO                                             !!! over ik1spin
	ENDDO                                             !!! over im1spin
C Transform to caretensian coordinates
	DO IC1=1,3
	DO IC =1,3
	DO IA1=1,3
	DO IA =1,3
	GINTC(IA1,IA,IC1,IC)=(0.D0,0.D0)
	DO MU1=-1,1
	DO MU =-1,1
	GINTC(IA1,IA,IC1,IC)=GINTC(IA1,IA,IC1,IC)+
     &TR(IA1,MU1)*GINTS(MU1,MU,IC1,IC)*TR(IA,MU)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	END
