	SUBROUTINE CHI_SYMCHI(IQPNT,IOMG)
***********************************************************
*  Calculate susceptibility                               *
***********************************************************
C SET ARRAY-SIZE DATA
	USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
	USE COM_LMTMEM                                           !!! from setup
	USE COM_CONTROL ,ONLY: LIFT,LMTO,IASA,NPFR,NOVR          !!! from readini
	USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS,ILSB   !!! from readini
	USE COM_LATPAR  ,ONLY: PAR,ORTH,OMEGAC                   !!! from readini
      USE COM_HUBDAT  ,ONLY: MCRL,LCRL,NCLM                    !!! from readhub
	USE COM_SUBGROUP,ONLY: NSGQ,NGEQ,ISG                     !!! from delmsh
	USE COM_GROUPS  ,ONLY: NGROUP,U,SJ,IP,RDC,SHIFT,INV,IKOV !!! from groups
	USE COM_CHIDAT  ,ONLY: IMATR,NCHI,INCHI,CHI0,GINT        !!! from intchi
	USE COM_QMESH   ,ONLY: NQPNT,QPNT                        !!! from tetra
	USE COM_FREQU   ,ONLY: NOMGCHI,OMGCHI                    !!! from tetra
	USE COM_MASHDEP ,ONLY: LENCMP,NVAL                       !!! from readini
	USE COM_CHANNELS,ONLY: IUCHI                             !!! from channels
      USE COM_LABELS  ,ONLY: TXTAT,TXTEL,TXTSP                 !!! from readini
	USE COM_UNIT    ,ONLY: IUN,IUR,IUT,IUI                   !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: TCHI(:,:)
	COMPLEX*16, ALLOCATABLE :: WCHI(:,:)
	COMPLEX*16, ALLOCATABLE :: GTMP(:,:,:,:,:,:)
	COMPLEX*16 PHSQ1,PHSQ
      COMPLEX*16 GINTS(-1:1,-1:1,3,3),GINTC(3,3,3,3)
	CHARACTER TXTL(0:3)*1,LIB_TCP*23,TCHAR(3)*23,TXYZ(3)*1
	DATA PI/3.141592653589793D0/,TXTL/'s','p','d','f'/
     &     ,TXYZ/'x','y','z'/
C MEMORY ALLOCATIONS
	ALLOCATE(TCHI(NCHI,NCHI))
	ALLOCATE(WCHI(NCHI,NCHI))
	CALL CHIFILES(IQPNT,IOMG,IUCHI,'R')
C CHI(q,w)=0
	DO 1000 IREIM=1,2                                 !!! over re/im parts
      DO IM1SPIN=1,NSPIN                                !!! over im1spin
      DO IK1SPIN=1,NSPIN                                !!! over ik1spin
	DO IATOM1=1,NATOM                                 !!! over atoms
	ISORT1=IS(IATOM1)
	IF(MCRL(IATOM1).EQ.0)CYCLE
	DO L1=0,ILSB(ISORT1)                              !!! over l1
	IF(LCRL(L1,IATOM1).EQ.0)CYCLE
	DO M1=-L1,L1                                      !!! over m1
	DO K1=-L1,L1                                      !!! over k1
	IU1=L1*(2*L1-1)*(2*L1+1)/3+(2*L1+1)*(L1+K1)+L1+M1+1 !!!    (l1,m1 k1)
	ICHI1=INCHI(IU1,IATOM1,IM1SPIN,IK1SPIN)
      DO IMSPIN=1,NSPIN                                 !!! over imspin
      DO IKSPIN=1,NSPIN                                 !!! over ikspin
	DO IATOM=1,NATOM                                  !!! over atoms
	ISORT=IS(IATOM)
	IF(MCRL(IATOM).EQ.0)CYCLE
	DO L=0,ILSB(ISORT)                                !!! over l
	IF(LCRL(L,IATOM).EQ.0)CYCLE
	DO M=-L,L                                         !!! over m
	DO K=-L,L                                         !!! over k
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+K)+L+M+1 !!!    (l,m k)
	ICHI=INCHI(IU,IATOM,IMSPIN,IKSPIN)
	TCHI(ICHI1,ICHI)=(0.D0,0.D0)
	ENDDO                                             !!! over k
	ENDDO                                             !!! over m
	ENDDO                                             !!! over l
	ENDDO                                             !!! over atoms
	ENDDO                                             !!! over ikspin
	ENDDO                                             !!! over imspin
	ENDDO                                             !!! over k1
	ENDDO                                             !!! over m1
	ENDDO                                             !!! over l1
	ENDDO                                             !!! over atoms
	ENDDO                                             !!! over ik1spin
	ENDDO                                             !!! over im1spin
C  DO OVER GROUP OF WAVE VECTOR Q
	DO 100 IGEQ=1,NGEQ                                !!! over group of q-vector
	IR=ISG(IGEQ,1)                                    !!! element "g" in the main G-list
	IG=IKOV(IR)                                       !!! element "g" after Kovalev
	DO IATOM1=1,NATOM                                 !!! over atoms
	ISORT1=IS(IATOM1)
	IF(MCRL(IATOM1).EQ.0)CYCLE
      IATOM1G=IP(IATOM1,IR)
	SQ=QPNT(1,IQPNT)*(RDC(1,IATOM1,IR)+SHIFT(1,IR))+
     &   QPNT(2,IQPNT)*(RDC(2,IATOM1,IR)+SHIFT(2,IR))+
     &   QPNT(3,IQPNT)*(RDC(3,IATOM1,IR)+SHIFT(3,IR))
	PHSQ1=EXP(+2.D0*PI*SQ*(0.D0,1.D0))
	DO L1=0,ILSB(ISORT1)                              !!! over l1
	IF(LCRL(L1,IATOM1).EQ.0)CYCLE
	DO IATOM=1,NATOM                                  !!! over atoms
	ISORT=IS(IATOM)
	IF(MCRL(IATOM).EQ.0)CYCLE
      IATOMG=IP(IATOM,IR)
	SQ=QPNT(1,IQPNT)*(RDC(1,IATOM,IR)+SHIFT(1,IR))+
     &   QPNT(2,IQPNT)*(RDC(2,IATOM,IR)+SHIFT(2,IR))+
     &   QPNT(3,IQPNT)*(RDC(3,IATOM,IR)+SHIFT(3,IR))
	PHSQ=EXP(-2.D0*PI*SQ*(0.D0,1.D0))
	DO L=0,ILSB(ISORT)                                !!! over l
	IF(LCRL(L,IATOM).EQ.0)CYCLE
C SYMMETRIZE SUSCEPTIBILITY WITH WIGNERS MATRICES (SLOW METHOD)
	IF(.FALSE.)THEN
      DO IM1SPIN=1,NSPIN                                !!! over im1spin
      DO IK1SPIN=1,NSPIN                                !!! over ik1spin
	DO IM1=-L1,L1                                     !!! over im1
	DO IK1=-L1,L1                                     !!! over ik1
	IU1=L1*(2*L1-1)*(2*L1+1)/3+(2*L1+1)*(L1+IK1)+L1+IM1+1 !!!    (l1,im1 ik1)
	ICHI1=INCHI(IU1,IATOM1,IM1SPIN,IK1SPIN)
      DO IMSPIN=1,NSPIN                                 !!! over imspin
      DO IKSPIN=1,NSPIN                                 !!! over ikspin
	DO IM=-L,L                                        !!! over im
	DO IK=-L,L                                        !!! over ik
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+IK)+L+IM+1      !!! (l,im ik)
	ICHI=INCHI(IU,IATOM,IMSPIN,IKSPIN)
C
      DO JM1SPIN=1,NSPIN                                !!! over jm1spin
      DO JK1SPIN=1,NSPIN                                !!! over jk1spin
	DO JM1=-L1,L1                                     !!! over m1i
	IM1JM1=L1*(2*L1-1)*(2*L1+1)/3+(2*L1+1)*(L1+JM1)+L1+IM1+1 !!!  (l1,im1 jm1)
	DO JK1=-L1,L1                                     !!! over k1i
	IK1JK1=L1*(2*L1-1)*(2*L1+1)/3+(2*L1+1)*(L1+JK1)+L1+IK1+1 !!!  (l1,ik1 jk1)
	JU1=L1*(2*L1-1)*(2*L1+1)/3+(2*L1+1)*(L1+JK1)+L1+JM1+1    !!!  (l1,jm1 jk1)
	JCHI1=INCHI(JU1,IATOM1G,JM1SPIN,JK1SPIN)
      DO JMSPIN=1,NSPIN                                 !!! over jmspin
      DO JKSPIN=1,NSPIN                                 !!! over jkspin
	DO JM=-L,L                                        !!! over m
	IMJM=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+JM)+L+IM+1    !!! (l,im jm)
	DO JK=-L,L                                        !!! over k
	IKJK=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+JK)+L+IK+1    !!! (l,ik jk)
	JU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+JK)+L+JM+1      !!! (l,jm jk)
	JCHI=INCHI(JU,IATOMG,JMSPIN,JKSPIN)
	TCHI(ICHI1,ICHI)=TCHI(ICHI1,ICHI)+
     &DCONJG(U(IM1JM1,IG)*SJ(IM1SPIN,JM1SPIN,IR))*
     &U(IK1JK1,IG)*SJ(IK1SPIN,JK1SPIN,IR)*
     &CHI0(JCHI1,JCHI,IREIM)*PHSQ*PHSQ1*
     &DCONJG(U(IMJM,IG)*SJ(IMSPIN,JMSPIN,IR))*
     &U(IKJK,IG)*SJ(IKSPIN,JKSPIN,IR)
	ENDDO                                             !!! over jk
	ENDDO                                             !!! over jm
	ENDDO                                             !!! over jkspin
	ENDDO                                             !!! over jmspin
	ENDDO                                             !!! over jk1
	ENDDO                                             !!! over jm1
	ENDDO                                             !!! over jk1spin
	ENDDO                                             !!! over jm1spin
C
	ENDDO                                             !!! over ik
	ENDDO                                             !!! over im
	ENDDO                                             !!! over ikspin
	ENDDO                                             !!! over imspin
	ENDDO                                             !!! over ik1
	ENDDO                                             !!! over im1
	ENDDO                                             !!! over ik1spin
	ENDDO                                             !!! over im1spin
	ENDIF
C SYMMETRIZE SUSCEPTIBILITY WITH WIGNERS MATRICES (FAST METHOD)
      DO IM1SPIN=1,NSPIN                                !!! over im1spin
      DO IK1SPIN=1,NSPIN                                !!! over ik1spin
	DO IM1=-L1,L1                                     !!! over im1
	DO IK1=-L1,L1                                     !!! over ik1
	IU1=L1*(2*L1-1)*(2*L1+1)/3+(2*L1+1)*(L1+IK1)+L1+IM1+1 !!!    (l1,im1 ik1)
	ICHI1=INCHI(IU1,IATOM1,IM1SPIN,IK1SPIN)
      DO IMSPIN=1,NSPIN                                 !!! over imspin
      DO IKSPIN=1,NSPIN                                 !!! over ikspin
	DO IM=-L,L                                        !!! over im
	DO IK=-L,L                                        !!! over ik
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+IK)+L+IM+1      !!! (l,im ik)
	ICHI=INCHI(IU,IATOM,IMSPIN,IKSPIN)
	WCHI(ICHI1,ICHI)=(0.D0,0.D0)
      DO JMSPIN=1,NSPIN                                 !!! over jmspin
      DO JKSPIN=1,NSPIN                                 !!! over jkspin
	DO JM=-L,L                                        !!! over m
	IMJM=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+JM)+L+IM+1    !!! (l,im jm)
	DO JK=-L,L                                        !!! over k
	IKJK=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+JK)+L+IK+1    !!! (l,ik jk)
	JU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+JK)+L+JM+1      !!! (l,jm jk)
	JCHI=INCHI(JU,IATOMG,JMSPIN,JKSPIN)
	WCHI(ICHI1,ICHI)=WCHI(ICHI1,ICHI)+
     &CHI0(ICHI1,JCHI,IREIM)*PHSQ*PHSQ1*
     &DCONJG(U(IMJM,IG)*SJ(IMSPIN,JMSPIN,IR))*
     &U(IKJK,IG)*SJ(IKSPIN,JKSPIN,IR)
	ENDDO                                             !!! over jk
	ENDDO                                             !!! over jm
	ENDDO                                             !!! over jkspin
	ENDDO                                             !!! over jmspin
C
	ENDDO                                             !!! over ik
	ENDDO                                             !!! over im
	ENDDO                                             !!! over ikspin
	ENDDO                                             !!! over imspin
	ENDDO                                             !!! over ik1
	ENDDO                                             !!! over im1
	ENDDO                                             !!! over ik1spin
	ENDDO                                             !!! over im1spin
C
      DO IM1SPIN=1,NSPIN                                !!! over im1spin
      DO IK1SPIN=1,NSPIN                                !!! over ik1spin
	DO IM1=-L1,L1                                     !!! over im1
	DO IK1=-L1,L1                                     !!! over ik1
	IU1=L1*(2*L1-1)*(2*L1+1)/3+(2*L1+1)*(L1+IK1)+L1+IM1+1 !!!    (l1,im1 ik1)
	ICHI1=INCHI(IU1,IATOM1,IM1SPIN,IK1SPIN)
      DO IMSPIN=1,NSPIN                                 !!! over imspin
      DO IKSPIN=1,NSPIN                                 !!! over ikspin
	DO IM=-L,L                                        !!! over im
	DO IK=-L,L                                        !!! over ik
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+IK)+L+IM+1      !!! (l,im ik)
	ICHI=INCHI(IU,IATOM,IMSPIN,IKSPIN)
C
      DO JM1SPIN=1,NSPIN                                !!! over jm1spin
      DO JK1SPIN=1,NSPIN                                !!! over jk1spin
	DO JM1=-L1,L1                                     !!! over m1i
	IM1JM1=L1*(2*L1-1)*(2*L1+1)/3+(2*L1+1)*(L1+JM1)+L1+IM1+1 !!!  (l1,im1 jm1)
	DO JK1=-L1,L1                                     !!! over k1i
	IK1JK1=L1*(2*L1-1)*(2*L1+1)/3+(2*L1+1)*(L1+JK1)+L1+IK1+1 !!!  (l1,ik1 jk1)
	JU1=L1*(2*L1-1)*(2*L1+1)/3+(2*L1+1)*(L1+JK1)+L1+JM1+1    !!!  (l1,jm1 jk1)
	JCHI1=INCHI(JU1,IATOM1G,JM1SPIN,JK1SPIN)
	TCHI(ICHI1,ICHI)=TCHI(ICHI1,ICHI)+
     &DCONJG(U(IM1JM1,IG)*SJ(IM1SPIN,JM1SPIN,IR))*
     &U(IK1JK1,IG)*SJ(IK1SPIN,JK1SPIN,IR)*
     &WCHI(JCHI1,ICHI)
	ENDDO                                             !!! over jk1
	ENDDO                                             !!! over jm1
	ENDDO                                             !!! over jk1spin
	ENDDO                                             !!! over jm1spin
C
	ENDDO                                             !!! over ik
	ENDDO                                             !!! over im
	ENDDO                                             !!! over ikspin
	ENDDO                                             !!! over imspin
	ENDDO                                             !!! over ik1
	ENDDO                                             !!! over im1
	ENDDO                                             !!! over ik1spin
	ENDDO                                             !!! over im1spin
C
	ENDDO                                             !!! over l
	ENDDO                                             !!! over atoms
	ENDDO                                             !!! over l1
	ENDDO                                             !!! over atoms
  100	CONTINUE                                          !!! over group
C NORMALIZE
      DO IM1SPIN=1,NSPIN                                !!! over im1spin
      DO IK1SPIN=1,NSPIN                                !!! over ik1spin
	DO IATOM1=1,NATOM                                 !!! over atoms
	ISORT1=IS(IATOM1)
	IF(MCRL(IATOM1).EQ.0)CYCLE
	DO L1=0,ILSB(ISORT1)                              !!! over l1
	IF(LCRL(L1,IATOM1).EQ.0)CYCLE
	DO M1=-L1,L1                                      !!! over m1
	DO K1=-L1,L1                                      !!! over k1
	IU1=L1*(2*L1-1)*(2*L1+1)/3+(2*L1+1)*(L1+K1)+L1+M1+1 !!!    (l1,m1 k1)
	ICHI1=INCHI(IU1,IATOM1,IM1SPIN,IK1SPIN)
      DO IMSPIN=1,NSPIN                                 !!! over imspin
      DO IKSPIN=1,NSPIN                                 !!! over ikspin
	DO IATOM=1,NATOM                                  !!! over atoms
	ISORT=IS(IATOM)
	IF(MCRL(IATOM).EQ.0)CYCLE
	DO L=0,ILSB(ISORT)                                !!! over l
	IF(LCRL(L,IATOM).EQ.0)CYCLE
	DO M=-L,L                                         !!! over m
	DO K=-L,L                                         !!! over k
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+K)+L+M+1 !!!    (l,m k)
	ICHI=INCHI(IU,IATOM,IMSPIN,IKSPIN)
	CHI0(ICHI1,ICHI,IREIM)=TCHI(ICHI1,ICHI)/DBLE(NGEQ)
	ENDDO                                             !!! over k
	ENDDO                                             !!! over m
	ENDDO                                             !!! over l
	ENDDO                                             !!! over atoms
	ENDDO                                             !!! over ikspin
	ENDDO                                             !!! over imspin
	ENDDO                                             !!! over k1
	ENDDO                                             !!! over m1
	ENDDO                                             !!! over l1
	ENDDO                                             !!! over atoms
	ENDDO                                             !!! over ik1spin
	ENDDO                                             !!! over im1spin
1000	CONTINUE                                          !!! re/im parts
	DEALLOCATE(TCHI,WCHI)
C SYMMETRIZE EXCHANGE CONSTANTS
	ALLOCATE(GTMP(3*NSPINMEM**2,NATOMMEM,3*NSPINMEM**2,NATOMMEM,3,3))
C SET TEMPORARY MATRIX TO ZERO
      DO IC1=1,3
      DO IC=1,3
	DO IATOM1=1,NATOM
	DO IATOM=1,NATOM
	DO IND1=1,3*NSPIN**2
	DO IND =1,3*NSPIN**2
      GTMP(IND1,IATOM1,IND,IATOM,IC1,IC)=(0.D0,0.D0)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C DO OVER SYMMETRY GROUP FOR Q-VECTOR
	DO IGEQ=1,NGEQ                                    !!! over group of q-vector
	IR=ISG(IGEQ,1)                                    !!! element "g" in the main G-list
	IG=IKOV(IR)                                       !!! element "g" after Kovalev
	DO IC1=1,3                                        !!! over cases
	DO IATOM1=1,NATOM                                 !!! over atoms
	IATOM1G=IP(IATOM1,IR)
	SQ=QPNT(1,IQPNT)*(RDC(1,IATOM1,IR)+SHIFT(1,IR))+
     &   QPNT(2,IQPNT)*(RDC(2,IATOM1,IR)+SHIFT(2,IR))+
     &   QPNT(3,IQPNT)*(RDC(3,IATOM1,IR)+SHIFT(3,IR))
	PHSQ1=EXP(+2.D0*PI*SQ*(0.D0,1.D0))
	IND1=0
      DO IM1SPIN=1,NSPIN                                !!! over im1spin
      DO IK1SPIN=1,NSPIN                                !!! over ik1spin
	DO MU1=-1,1                                       !!! over polarizations
	IND1=IND1+1
	DO IC=1,3                                         !!! over cases
	DO IATOM=1,NATOM                                  !!! over atoms
	IATOMG =IP(IATOM ,IR)
	SQ=QPNT(1,IQPNT)*(RDC(1,IATOM,IR)+SHIFT(1,IR))+
     &   QPNT(2,IQPNT)*(RDC(2,IATOM,IR)+SHIFT(2,IR))+
     &   QPNT(3,IQPNT)*(RDC(3,IATOM,IR)+SHIFT(3,IR))
	PHSQ=EXP(-2.D0*PI*SQ*(0.D0,1.D0))
	IND=0
      DO IMSPIN=1,NSPIN                                 !!! over imspin
      DO IKSPIN=1,NSPIN                                 !!! over ikspin
	DO MU =-1,1                                       !!! over polarizations
	IND=IND+1
	JIND1=0
      DO JM1SPIN=1,NSPIN                                !!! over jm1spin
      DO JK1SPIN=1,NSPIN                                !!! over jk1spin
	DO M1=-1,1                                        !!! over polarizations
	JIND1=JIND1+1
	IF(M1.NE.MU1)CYCLE
	IWIGM1=3+3*(1+M1)+MU1
	JIND=0
      DO JMSPIN=1,NSPIN                                 !!! over jmspin
      DO JKSPIN=1,NSPIN                                 !!! over jkspin
	DO M =-1,1                                        !!! over polarizations
	JIND=JIND+1
	IF(M.NE.MU)CYCLE
	IWIGM =3+3*(1+M) +MU
C	GTMP(IND1,IATOM1,IND,IATOM)=GTMP(IND1,IATOM1,IND,IATOM)+
C     &DCONJG(SJ(IM1SPIN,JM1SPIN,IR))*SJ(IK1SPIN,JK1SPIN,IR)*
C     &DCONJG(U(IWIGM1,IG))*GINT(JIND1,IATOM1G,JIND,IATOMG)*
C     &DCONJG(U(IWIGM,IG))*PHSQ1*PHSQ*
C     &DCONJG(SJ(IMSPIN,JMSPIN,IR))*SJ(IKSPIN,JKSPIN,IR)
	GTMP(IND1,IATOM1,IND,IATOM,IC1,IC)=
     &GTMP(IND1,IATOM1,IND,IATOM,IC1,IC)+
     &DCONJG(SJ(IM1SPIN,JM1SPIN,IR))*SJ(IK1SPIN,JK1SPIN,IR)*
     &GINT(JIND1,IATOM1G,JIND,IATOMG,IC1,IC)*PHSQ1*PHSQ*
     &DCONJG(SJ(IMSPIN,JMSPIN,IR))*SJ(IKSPIN,JKSPIN,IR)
      ENDDO                                             !!! over m
	ENDDO                                             !!! over jkspin
	ENDDO                                             !!! over jmspin
      ENDDO                                             !!! over m1
	ENDDO                                             !!! over jk1spin
	ENDDO                                             !!! over jm1spin

      ENDDO                                             !!! over polarizations
	ENDDO                                             !!! over ik1spin
	ENDDO                                             !!! over im1spin
      ENDDO                                             !!! over iatom
      ENDDO                                             !!! over ic
      ENDDO                                             !!! over polarizations
	ENDDO                                             !!! over ikspin
	ENDDO                                             !!! over imspin
      ENDDO                                             !!! over iatom1
      ENDDO                                             !!! over ic1
      ENDDO                                             !!! over group of q-vector
C NORMALIZE
      DO IC1=1,3
      DO IC=1,3
	DO IATOM1=1,NATOM
	DO IND1=1,3*NSPIN**2
	DO IATOM=1,NATOM
	DO IND =1,3*NSPIN**2
      GINT(IND1,IATOM1,IND,IATOM,IC1,IC)=
     &GTMP(IND1,IATOM1,IND,IATOM,IC1,IC)/DBLE(NGEQ)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	DEALLOCATE(GTMP)
	CALL CHIFILES(IQPNT,IOMG,IUCHI,'W')
C PRINT DIAGONAL TO THE SCREEN
	WRITE(IUN,10100)
	DO IATOM=1,NATOM                                  !!! over atoms
	ISORT=IS(IATOM)
	IF(MCRL(IATOM).EQ.0)CYCLE
	DO L=0,ILSB(ISORT)                                !!! over l
	IF(LCRL(L,IATOM).EQ.0)CYCLE
      DO IMSPIN=1,NSPIN                                 !!! over imspin
      DO IKSPIN=1,NSPIN                                 !!! over ikspin
      CALL FIND_LBLANK(TXTAT(ISORT),10,NBP)
	IF(NSPIN.EQ.1)WRITE(IUN,10110)TXTL(L),TXTAT(ISORT)(:NBP)
	IF(NSPIN.EQ.2)WRITE(IUN,10120)TXTSP(IMSPIN),TXTSP(IKSPIN),
     &              TXTL(L),TXTAT(ISORT)(:NBP)
	DO M=-L,L                                         !!! over m
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M+1        !!! (l,m m)
	ICHI=INCHI(IU,IATOM,IMSPIN,IKSPIN)
	TCHAR(1)=LIB_TCP(CHI0(ICHI,ICHI,1),1.D-07)
	WRITE(IUN,10130)M,TCHAR(1)
	ENDDO                                             !!! over m
	ENDDO                                             !!! over ikspin
	ENDDO                                             !!! over imspin
	ENDDO                                             !!! over l
	ENDDO                                             !!! over atoms
10100	FORMAT(1X,'Susceptibility, Diagonal elements:')
10110	FORMAT(1X,'L = ',A1,' Atom = ',A10)
10120	FORMAT(1X, A2,'-',A2,1X,'L = ',A1,' Atom = ',A10)
10130	FORMAT(1X, 'm = ',I2,A23)
C PRINT EXCHANGE CONSTANTS
	WRITE(IUN,10210)
	DO IATOM1=1,NATOM                                 !!! over atoms
	ISORT1=IS(IATOM1)
	IF(MCRL(IATOM1).EQ.0)CYCLE
	DO IATOM=1,NATOM                                  !!! over atoms
	ISORT=IS(IATOM)
	IF(MCRL(IATOM).EQ.0)CYCLE
	DO L1=0,ILSB(ISORT1)                              !!! over l1
	IF(LCRL(L1,IATOM1).EQ.0)CYCLE
	DO L=0,ILSB(ISORT)                                !!! over l
	IF(LCRL(L,IATOM).EQ.0)CYCLE
C Compute J's for given q
	CALL CHI_SETJEYS(L1,IATOM1,L,IATOM,GINTS,GINTC)
C Show the results
	WRITE(IUN,10220)
     &TXTL(L1),TXTAT(ISORT1),TXTL(L ),TXTAT(ISORT )
	WRITE(IUN,10230)
	DO IA1=1,3
	DO IA=1,3
	TCHAR(IA)=LIB_TCP(GINTC(IA1,IA,1,1),1.D-07)
	ENDDO
	WRITE(IUN,10240)(TCHAR(IA),IA=1,3),TXYZ(IA1)
	ENDDO
	ENDDO                                             !!! over l
	ENDDO                                             !!! over atoms
	ENDDO                                             !!! over l1
	ENDDO                                             !!! over atoms
10210	FORMAT(1X,'Exchange Constants Jab(q) matrix :')
10220	FORMAT('!','L1 = ',A1,1X,'Atom1 = ',A10,
     &        1X,'L  = ',A1,1X,'Atom  = ',A10)
10230 FORMAT(1X,11X,'x',11X,1X,11X,'y',11X,1X,11X,'z')
10240 FORMAT(1X,A23,1X,A23,1X,A23,3X,A1)
C PRINT LSD PART OF EXCHANGE CONSTANTS
	IF(IMATR.EQ.1)THEN
	WRITE(IUN,10310)
	DO IATOM1=1,NATOM                                 !!! over atoms
	ISORT1=IS(IATOM1)
	DO IATOM=1,NATOM                                  !!! over atoms
	ISORT=IS(IATOM)
	CALL CHI_SETJMAT(IATOM1,IATOM,GINTS,GINTC)
C Show the results
	WRITE(IUN,10320)TXTAT(ISORT1),TXTAT(ISORT )
	WRITE(IUN,10330)
	DO IA1=1,3
	DO IA=1,3
	TCHAR(IA)=LIB_TCP(GINTC(IA1,IA,3,3),1.D-07)
	ENDDO
	WRITE(IUN,10340)(TCHAR(IA),IA=1,3),TXYZ(IA1)
	ENDDO
	ENDDO                                             !!! over atoms
	ENDDO                                             !!! over atoms
	ENDIF
10310	FORMAT(1X,'LSDA Constants Jab(q) matrix :')
10320	FORMAT('!','Atom1 = ',A10,1X,'Atom  = ',A10)
10330 FORMAT(1X,11X,'x',11X,1X,11X,'y',11X,1X,11X,'z')
10340 FORMAT(1X,A23,1X,A23,1X,A23,3X,A1)
	END
