subroutine cls_angmom2(Ns, Nd, N, subdim, phi, invphi, precont, A, ML, MS, MJ, L, S, J, Occ, MSC, SC)

implicit none

integer Ns
integer Nd
integer N
integer subdim
integer phi(subdim)
integer invphi(2**N)
integer precont
complex*16 A(subdim,subdim)
real*8 ML(subdim)
real*8 MS(subdim)
real*8 MJ(subdim)
real*8 L(subdim)
real*8 S(subdim)
real*8 J(subdim)
real*8 Occ(0:N-1, subdim)
real*8 MSC(subdim)
real*8 SC(subdim)

integer Ld
integer alpha, nu
integer ipr
integer kapa1, kapa2
integer dummy1, dummy2, dummy3, dummy4
integer sign1, sign2, sign3, sign4
integer ms1, ms2, ms3, ms4
integer m1, m2, m3, m4
integer sigma1, sigma2, sigma3, sigma4
integer DDM
real*8 smat
real*8 SM(-1:1, -1:1, -1:1)
real*8, allocatable :: LZM(:,:)
real*8, allocatable :: SZM(:,:)
real*8, allocatable :: JZM(:,:)
real*8, allocatable :: OCM(:,:,:)
real*8, allocatable :: SSM(:,:)
real*8, allocatable :: LLM(:,:)
real*8, allocatable :: JJM(:,:)
real*8, allocatable :: Lsqr(:)
real*8, allocatable :: Ssqr(:)
real*8, allocatable :: Jsqr(:)
real*8, allocatable :: SZMC(:,:)
real*8, allocatable :: SSMC(:,:)
real*8, allocatable :: SSMS(:,:)
real*8, allocatable :: SSMDS(:,:)
real*8, allocatable :: SsqrC(:)
real*8, allocatable :: work(:)

integer, external :: cls_spind
integer, external :: cls_spins
integer, external :: cls_opsign
real*8, external :: cls_lm
real*8, external :: cls_SMAT
real*8, external :: cls_LMAT
real*8, external :: cls_OMAT

ipr = Nd/2 + Ns - 1
Ld = (Nd - 2) / 4
call cls_getsm(SM)

ML = 0.D0
MS = 0.D0
MJ = 0.D0
L = 0.D0
S = 0.D0
J = 0.D0
Occ = 0.D0

allocate (LZM(subdim, subdim))
allocate (SZM(subdim, subdim))
allocate (JZM(subdim, subdim))
LZM = 0.D0
SZM = 0.D0
JZM = 0.D0


do kapa1 = 1, subdim
  do ms1 = Ns, N-1
    if (btest(phi(kapa1), ms1)) then
      m1 = mod((ms1 - Ns), (Nd/2)) - Ld 
      LZM(kapa1, kapa1) = LZM(kapa1, kapa1) + real(m1)
      sigma1 = cls_spind(ms1, ipr)
      SZM(kapa1, kapa1) = SZM(kapa1, kapa1) + real(sigma1) / 2.D0
    end if
  end do
end do

JZM = LZM + SZM

call cls_convert(ML, LZM, A, subdim)
deallocate (LZM)
call cls_convert(MS, SZM, A, subdim)
deallocate (SZM)
call cls_convert(MJ, JZM, A, subdim)
deallocate (JZM)

allocate (OCM(subdim, subdim, 0:N-1))
allocate (SZMC(subdim, subdim))
OCM = 0.D0
SZMC = 0.D0

do kapa1 = 1, subdim
  do ms1 = 0, N-1
    if (btest(phi(kapa1), ms1)) then
      if (ms1 >= Ns) then
      sigma1 = cls_spind(ms1, ipr)
      else
      sigma1 = cls_spins(ms1, Ns)
      end if
      SZMC(kapa1, kapa1) = SZMC(kapa1, kapa1) + real(sigma1) / 2.D0
      OCM(kapa1, kapa1, ms1) = OCM(kapa1, kapa1, ms1) + 1.0
    end if
  end do
end do

MSC = 0.D0
call cls_convert(MSC, SZMC, A, subdim)
deallocate (SZMC)
allocate (work(subdim))
do ms1 = 0, N-1
  work = 0.D0
  call cls_convert(work, OCM(1, 1, ms1), A, subdim)
  do alpha = 1, subdim
    Occ(ms1, alpha) = work(alpha)
  end do
end do
deallocate (OCM)
deallocate (work)

allocate (SSM(subdim, subdim))
allocate (LLM(subdim, subdim))
allocate (JJM(subdim, subdim))
SSM = 0.D0
LLM = 0.D0
JJM = 0.D0

do kapa2 = 1, subdim
  
  do ms4 = Ns, N-1
    if (.not.btest(phi(kapa2), ms4)) cycle
    dummy4 = phi(kapa2)
    sign4 = cls_opsign(ms4, dummy4)
    dummy4 = ibclr(dummy4, ms4)
    m4 = mod((ms4 - Ns), (Nd/2)) - Ld
    sigma4 = cls_spind(ms4, ipr)
    
    do ms3 = Ns, N-1
      if (btest(dummy4, ms3)) cycle
      dummy3 = dummy4
      sign3 = cls_opsign(ms3, dummy3)
      dummy3 = ibset(dummy3, ms3)
      m3 = mod((ms3 - Ns), (Nd/2)) - Ld
      sigma3 = cls_spind(ms3, ipr)
      
      do ms2 = Ns, N-1
        if (.not.btest(dummy3, ms2)) cycle
        dummy2 = dummy3
        sign2 = cls_opsign(ms2, dummy2)
        dummy2 = ibclr(dummy2, ms2)
        m2 = mod((ms2 - Ns), (Nd/2)) - Ld
        sigma2 = cls_spind(ms2, ipr)
        
        do ms1 = Ns, N-1
          if (btest(dummy2, ms1)) cycle
          dummy1 = dummy2
          sign1 = cls_opsign(ms1, dummy1)
          dummy1 = ibset(dummy1, ms1)
          m1 = mod((ms1 - Ns), (Nd/2)) - Ld
          sigma1 = cls_spind(ms1, ipr)
         
          DDM = sign1 * sign2 * sign3 * sign4
          kapa1 = invphi(dummy1) - precont
          
          SSM(kapa1, kapa2) = SSM(kapa1, kapa2) + cls_SMAT(m1, m2, m3, m4, sigma1, sigma2, sigma3, sigma4, SM) * real(DDM)
            
          LLM(kapa1, kapa2) = LLM(kapa1, kapa2) + cls_LMAT(m1, m2, m3, m4, sigma1, sigma2, sigma3, sigma4, Ld) * real(DDM)
            
          JJM(kapa1, kapa2) = JJM(kapa1, kapa2) + (cls_OMAT(m1, m2, m3, m4, sigma1, sigma2, sigma3, sigma4, Ld, SM)  &
                                           & + cls_SMAT(m1, m2, m3, m4, sigma1, sigma2, sigma3, sigma4, SM) &
                                           & + cls_LMAT(m1, m2, m3, m4, sigma1, sigma2, sigma3, sigma4, Ld)) * real(DDM)
                   
        end do
      end do
    end do
  end do
end do

allocate (Lsqr(subdim))
allocate (Ssqr(subdim))
allocate (Jsqr(subdim))
Lsqr = 0.D0
Ssqr = 0.D0
Jsqr = 0.D0

call cls_convert(Lsqr, LLM, A, subdim)
deallocate (LLM)
call cls_convert(Ssqr, SSM, A, subdim)
call cls_convert(Jsqr, JJM, A, subdim)
deallocate (JJM)

do alpha = 1, subdim
  L(alpha) = -0.5 + 0.5 * sqrt(abs(1.0 + 4.0*Lsqr(alpha)))
  S(alpha) = -0.5 + 0.5 * sqrt(abs(1.0 + 4.0*Ssqr(alpha)))
  J(alpha) = -0.5 + 0.5 * sqrt(abs(1.0 + 4.0*Jsqr(alpha)))
end do

deallocate (Lsqr)
deallocate (Ssqr)
deallocate (Jsqr)

allocate (SSMS(subdim, subdim))
SSMS = 0.D0

do kapa2 = 1, subdim
  
  do ms4 = 0, Ns-1
    if (.not.btest(phi(kapa2), ms4)) cycle
    dummy4 = phi(kapa2)
    sign4 = cls_opsign(ms4, dummy4)
    dummy4 = ibclr(dummy4, ms4)
    sigma4 = cls_spins(ms4, Ns)
    m4 = mod(ms4, (Ns/2))
    
    do ms3 = 0, Ns-1
      if (btest(dummy4, ms3)) cycle
      dummy3 = dummy4
      sign3 = cls_opsign(ms3, dummy3)
      dummy3 = ibset(dummy3, ms3)
      sigma3 = cls_spins(ms3, Ns)
      m3 = mod(ms3, (Ns/2))
      
      do ms2 = 0, Ns-1
        if (.not.btest(dummy3, ms2)) cycle
        dummy2 = dummy3
        sign2 = cls_opsign(ms2, dummy2)
        dummy2 = ibclr(dummy2, ms2)
        sigma2 = cls_spins(ms2, Ns)
        m2 = mod(ms2, (Ns/2))
        
        do ms1 = 0, Ns-1
          if (btest(dummy2, ms1)) cycle
          dummy1 = dummy2
          sign1 = cls_opsign(ms1, dummy1)
          dummy1 = ibset(dummy1, ms1)
          sigma1 = cls_spins(ms1, Ns)
          m1 = mod(ms1, (Ns/2))
         
          kapa1 = invphi(dummy1) - precont
          DDM = sign1 * sign2 * sign3 * sign4
          smat = cls_SMAT(m1, m2, m3, m4, sigma1, sigma2, sigma3, sigma4, SM)
          
          SSMS(kapa1, kapa2) = SSMS(kapa1, kapa2) + smat * real(DDM)
                            
        end do
      end do
    end do
  end do
end do

allocate (SSMDS(subdim, subdim))
SSMDS = 0.D0

do kapa2 = 1, subdim
  
  do ms4 = 0, Ns-1
    if (.not.btest(phi(kapa2), ms4)) cycle
    dummy4 = phi(kapa2)
    sign4 = cls_opsign(ms4, dummy4)
    dummy4 = ibclr(dummy4, ms4)
    sigma4 = cls_spins(ms4, Ns)
    m4 = mod(ms4, (Ns/2))
    
    do ms3 = 0, Ns-1
      if (btest(dummy4, ms3)) cycle
      dummy3 = dummy4
      sign3 = cls_opsign(ms3, dummy3)
      dummy3 = ibset(dummy3, ms3)
      sigma3 = cls_spins(ms3, Ns)
      m3 = mod(ms3, (Ns/2))
      
      do ms2 = Ns, N-1
        if (.not.btest(dummy3, ms2)) cycle
        dummy2 = dummy3
        sign2 = cls_opsign(ms2, dummy2)
        dummy2 = ibclr(dummy2, ms2)
        m2 = mod((ms2 - Ns), (Nd/2)) - Ld
        sigma2 = cls_spind(ms2, ipr)
        
        do ms1 = Ns, N-1
          if (btest(dummy2, ms1)) cycle
          dummy1 = dummy2
          sign1 = cls_opsign(ms1, dummy1)
          dummy1 = ibset(dummy1, ms1)
          m1 = mod((ms1 - Ns), (Nd/2)) - Ld
          sigma1 = cls_spind(ms1, ipr)
      
          kapa1 = invphi(dummy1) - precont
          DDM = sign1 * sign2 * sign3 * sign4
          smat = cls_SMAT(m1, m2, m3, m4, sigma1, sigma2, sigma3, sigma4, SM)
          
          SSMDS(kapa1, kapa2) = SSMDS(kapa1, kapa2) +  smat * real(DDM)
                            
        end do
      end do
    end do
  end do
end do

allocate (SSMC(subdim, subdim))
SSMC = SSM + SSMS + 2.0*SSMDS
deallocate (SSM)
deallocate (SSMS)
deallocate (SSMDS)

allocate (SsqrC(subdim))
SsqrC = 0.D0
call cls_convert(SsqrC, SSMC, A, subdim)
deallocate (SSMC)
do alpha = 1, subdim
  SC(alpha) = -0.5 + 0.5 * sqrt(abs(1.0 + 4.0*SsqrC(alpha)))
end do
deallocate (SsqrC)

end