subroutine cls_bath(Ns, totdim_bath, Es, B3, nsmin, nsmax, Ebath, channel, filename)

implicit none

integer Ns
integer totdim_bath
complex*16 Es(0:Ns-1,0:Ns-1)  
real*8 B3
integer nsmin, nsmax
real*8 Ebath(totdim_bath)
integer channel(6)
character(len=130) filename(5)   

integer ins
integer subdim
integer subn, subm
integer i, j, k
integer, allocatable :: comb(:)
integer, allocatable :: phi(:)
integer phiket, phibra
integer dummy1, dummy2
integer sign, sign1, sign2
integer ms1, ms2, ms, ks
integer beta1, beta2
integer spin
real*8 Emin
real*8, allocatable :: E(:)
real*8, allocatable :: E0s(:)
real*8, allocatable :: Emags(:)
integer, allocatable :: SDMAT(:, :, :)
integer, allocatable :: SCMAT(:, :, :)

real*8, external :: cls_combination
integer,external :: cls_opsign
integer,external :: cls_spins
integer,external :: cls_occnum


allocate (comb(-1:Ns))
call cls_getcomb(comb, Ns)

allocate (phi(2**Ns))
phi = 0
j = 1
do ins = 0, Ns
  do i = 0, 2**Ns-1
     if (cls_occnum(i, Ns) /= ins) cycle
     phi(j) = i
     j = j+1
   end do
end do

Ebath = 0.D0
k = 1

do ins = nsmin , nsmax
  subdim = nint(cls_combination(ins, Ns))

  allocate(E0s(subdim))
  E0s = 0.D0
  do i = 1, subdim
    j = i + comb(ins-1)
    do ms2 = 0, Ns-1
      if (.NOT.btest(phi(j),ms2)) cycle
	  dummy1 = phi(j)
	  dummy1 = ibclr(dummy1,ms2)
	  sign2 = cls_opsign(ms2,dummy1)
	  do ms1 = 0, Ns-1
	     if (btest(dummy1,ms1)) cycle
	     dummy2 = dummy1
	     dummy2 = ibset(dummy2,ms1)
	     if (dummy2 /= phi(j)) cycle
	     sign1 = cls_opsign(ms1,dummy2)
	     sign = sign1 * sign2
         E0s(i) = E0s(i) + sign * real(Es(ms1,ms2))
      end do
    end do
  end do

  allocate(Emags(subdim))
  Emags= 0.D0
  do i = 1, subdim
    j = i + comb(ins-1)
    do ms = 0, Ns
      if (btest(phi(j),ms)) then
      spin = cls_spins(ms, Ns)
	  Emags(i) = Emags(i) - B3*spin
	  end if
    end do
  end do

  do i = 1, subdim
    Ebath(k) = real(E0s(i) + Emags(i))
    k = k + 1
  end do
  deallocate (E0s)
  deallocate (Emags)
  
end do

open (unit=channel(1), file=filename(1)//"sdmat.bin", form='UNFORMATTED')

do ins = nsmin, nsmax-1
  subm = nint(cls_combination(ins, Ns))
  subn = nint(cls_combination(ins+1, Ns))
  allocate (SDMAT(subm, subn, 0:Ns-1))
  SDMAT = 0
  do ks = 0, Ns-1
    do beta2 = 1, subn
      phiket = phi(comb(ins)+beta2)
      if (.not. btest(phiket, ks)) cycle
      phiket = ibclr(phiket, ks)
      sign = cls_opsign(ks, phiket)
      do beta1 = 1, subm
        phibra = phi(comb(ins-1)+beta1)
        if (phibra /= phiket) cycle  
        SDMAT(beta1, beta2, ks) = sign
      end do
    end do
  end do
  do ks = 0, Ns-1
    do beta2 = 1, subn
      do beta1 = 1, subm
        write (channel(1)) SDMAT(beta1, beta2, ks)
      end do
    end do
  end do
  deallocate (SDMAT)
end do

close (channel(1))

open (unit=channel(1), file=filename(1)//"scmat.bin", form='UNFORMATTED')

do ins = nsmin+1, nsmax
  subm = nint(cls_combination(ins-1, Ns))
  subn = nint(cls_combination(ins, Ns))
  allocate (SCMAT(subn, subm, 0:Ns-1))
  SCMAT = 0
  do ks = 0, Ns-1
    do beta2 = 1, subm
      phiket = phi(comb(ins-2)+beta2)
      if (btest(phiket, ks)) cycle
      phiket = ibset(phiket, ks)
      sign = cls_opsign(ks, phiket)
      do beta1 = 1, subn
        phibra = phi(comb(ins-1)+beta1)
        if (phibra /= phiket) cycle  
        SCMAT(beta1, beta2, ks) = sign
      end do
    end do
  end do
  do ks = 0, Ns-1
    do beta2 = 1, subm
      do beta1 = 1, subn
        write (channel(1)) SCMAT(beta1, beta2, ks)
      end do
    end do
  end do
  deallocate (SCMAT)
end do

close (channel(1))

deallocate (phi)
deallocate (comb)


end