	subroutine cls_chempotn2(fill, chem, Temp, NDEG, KFRM, 
     &	Locc, subdim_cls1, subdim_cls2, channel, filename)
	
	implicit none

	real*8 fill
	real*8 chem
	real*8 Temp
	integer NDEG
	integer KFRM
	integer Locc(0: NDEG)
	integer subdim_cls1(0:NDEG)
	integer subdim_cls2(0:NDEG)
	integer channel(6)
	character (len=130) filename(5)
	
	real*8 EFRM, ZDIF, E1, E2, EMIN, EMAX
	integer JTER, IEXIT, IFOC, ncls
	integer MDIM, NOCC, NFOC
	real*8 STAT, ZSUM, SUM
	integer cin(6)
	
	integer i, j, k
	integer, allocatable :: fcontin(:)
	real*8,allocatable :: XHUB(:)
	real*8,allocatable :: SPEC(:)
	
      ncls = 0
      do i = 0, NDEG
      if (Locc(i) == 0) cycle
      ncls = ncls + subdim_cls1(i) + subdim_cls2(i)
      end do

	allocate (XHUB(ncls))
	allocate (SPEC(ncls))
	allocate (fcontin(0:NDEG))
	
	fcontin = subdim_cls1 + subdim_cls2

	open (unit=channel(1), file=filename(1), form='UNFORMATTED')
	open (unit=channel(2), file=filename(1)//"index2_tmp.bin", 
     &form='UNFORMATTED')
	spec = 0.D0
	k = 1
	do i = 0, ndeg
	if (Locc(i) == 0) cycle
	do j = 1, subdim_cls1(i)
	read (channel(1)) spec(k)
	k = k + 1
	end do
	if (subdim_cls2(i) == 0) cycle
	do j = 1, subdim_cls2(i)
	read (channel(2)) spec(k)
	read (channel(2)) cin(1), cin(2), cin(3), cin(4), cin(5), cin(6)
	k = k + 1
	end do
	end do
	close(channel(1))
	close(channel(2))

	EFRM=CHEM
	ZDIF=0.D0
	JTER=0

	EMIN=+1.D+10
	EMAX=-1.D+10
	DO I=1,NCLS
	EMIN=MIN(EMIN,SPEC(I))
	EMAX=MAX(EMAX,SPEC(I))
	ENDDO
	E1=-0.5D0*(EMAX-EMIN)
	E2=+0.5D0*(EMAX-EMIN)

	IEXIT = 0
	IF(KFRM.EQ.0)
     &CALL LIB_FINDROOT(EFRM,ZDIF,E1,E2,JTER,IEXIT,
     &                        channel(6),1.D-05,50)
 100	JTER=JTER+1
C Find new charge
	CALL CLS_SHELLS_XNOT(NDEG,NCLS,SPEC,EFRM,TEMP,XHUB,LOCC,fcontin)
	STAT=0.D0
	ZSUM=0.D0
	MDIM=0
	DO NOCC=0,NDEG
	IF(LOCC(NOCC).EQ.0)CYCLE
	NFOC=fcontin(nocc)
	MDIM=MDIM+NFOC
	SUM=0.D0
	DO IFOC=1,NFOC
	SUM=SUM+XHUB(IFOC+MDIM-NFOC)
	ENDDO
	STAT=STAT+SUM
	ZSUM=ZSUM+SUM*DBLE(NOCC)
	ENDDO
	IF(ABS(STAT-1.D0).GT.1.D-07)
     &CALL FULLSTOP('Wrong renormalization')
	ZSUM=ZSUM/STAT
C Difference
	ZDIF=FILL-ZSUM
c	WRITE(6,*)EFRM,ZSUM
10130 FORMAT(1X,G14.7,1X,G14.7)
	IF(KFRM.NE.0)GOTO 200
      CALL LIB_FINDROOT(EFRM,ZDIF,E1,E2,JTER,IEXIT,
     &                     channel(6),1.D-05,50)
	IF(IEXIT.EQ.1)GOTO 200
	GOTO 100
  200 CONTINUE

	open (unit=channel(1), file=filename(3), form='UNFORMATTED')
      do i = 1, ncls
	write (channel(1)) XHUB(i)
	end do
	close(channel(1))

	CHEM=EFRM

	deallocate(XHUB)
	end