subroutine cls_exactdiag(subdim, H, A, E)

implicit none

integer subdim
complex*16 H(subdim,subdim)
complex*16 A(subdim,subdim)
real*8 E(subdim)

complex*16,allocatable :: O(:,:)
integer i, j
integer ierror
integer icheck
integer nspin
integer norbs
real*8 eps
real*8 hdiff

!----Check Hermitianess of Hamiltonian matrix----------------
hdiff = 0.D0
do i = 1, subdim
  do j = 1, i
    hdiff = abs(H(i,j) - conjg(H(j,i)))
    if (hdiff >= 1.D-04) write (6,*) 'H-->', i, j, hdiff
  end do
end do
if (hdiff >= 1.D-04) then
  write(6, *) "Error!  Hamiltonian is non-Hermitian ! ---Program stoped---"
  stop
end if

icheck = 0
nspin = 1
norbs = 1
eps = 1.D-4

allocate(O(subdim,subdim))
O = (0.0D0,0.0D0)
E = 0.D0

do i=1, subdim
  O(i,i) = (1.0D0,0.0D0)
end do 


call lib_eigen1c(subdim, H, O, E, nspin, norbs, 1, ierror, icheck, eps)

A = O

deallocate(O)

end