subroutine cls_meanfill2(N, subdim_cls1, subdim_cls2, chem, temp, fill, Locc, channel, filename)

implicit none

integer N
integer subdim_cls1(0:N)
integer subdim_cls2(0:N)
real*8 chem
real*8 temp
real*8 fill
integer Locc(0:N)
integer channel(6)
character (len = 130) filename(5)

integer in
integer alpha
integer i
integer ipt
integer dim
real*8 Z
real*8 X
real*8 nor
real*8 Emin
real*8 Emax
real*8 Eigen
integer cin(6)
real*8, allocatable :: Eg(:)
integer, allocatable :: fcontin(:)

real*8, external :: SAFEEXP

!---find lowest eigen-energy--------------------------------------------------------------------
dim = 0
do i = 0, N
  if (Locc(i) == 0) cycle
  dim = dim + subdim_cls1(i) + subdim_cls2(i)
end do

allocate (fcontin(0:N))
fcontin = subdim_cls1 + subdim_cls2

allocate (Eg(dim))

open (unit = channel(1), file = filename(1), form = "UNFORMATTED")
open (unit = channel(2), file = filename(1)//"index2_tmp.bin", form = "UNFORMATTED")

ipt = 1
do in = 0, N
  if (Locc(in) == 0) cycle
  do i = 1, subdim_cls1(in)
    read (channel(1)) Eigen
    Eg(ipt) = Eigen - real(in)*chem
    ipt = ipt + 1
  end do
  if (subdim_cls2(in) == 0) cycle
  do i = 1, subdim_cls2(in)
    read (channel(2)) Eigen
    read (channel(2)) cin(1), cin(2), cin(3), cin(4), cin(5), cin(6)
    Eg(ipt) = Eigen - real(in)*chem
    ipt = ipt + 1
  end do
end do

close (channel(1))
close (channel(2))

Emin = Eg(1)
do alpha = 2, dim
  if (Eg(alpha) - Emin <= 1.D-5) Emin = Eg(alpha)
end do

Eg = - Eg
Emax = - Emin

!---calculate normalization factor Z--------------------------------------------
Z = 0.D0
do i = 1, dim
Z = Z + SAFEEXP((Eg(i) - Emax) / temp)
end do

!---calculate X and mean filiing-------------------------------------------------
fill = 0.D0
nor = 0.D0
open (unit=channel(2), file=filename(3), form='UNFORMATTED')
ipt = 1
do in = 0, N  

  if (Locc(in) == 0) cycle
  
  do alpha = 1, fcontin(in)
    X = SAFEEXP((Eg(ipt) - Emax) / temp) / Z
    fill = fill + real(in) * X
    write (channel(2)) X
    nor = nor + X
    ipt = ipt + 1
  end do
  
end do 

close (channel(2))

!----check normalization-----------------------
if (abs(nor - 1.D0) >= 1.D-4) then
  write (channel(6), *) 'Normalization Error !!!!'
  stop
end if

end