subroutine cls_Fock1(Ns, Nd, N, dimvar, phi, invphi, locc, Ese, Es, Ed, Umat, B1, B2, B3, Soc, fcontin, fcont)

implicit none

integer Ns
integer Nd
integer N
integer dimvar
integer phi(dimvar)
integer invphi(2**N)
integer locc(0:N)
real*8 Ese
complex*16 Es(0:Ns-1,0:Ns-1)
complex*16 Ed(Ns:N-1,Ns:N-1)
real*8 UMAT(0:Nd/2-1,0:Nd/2-1,0:Nd/2-1,0:Nd/2-1)
real*8 B1
real*8 B2
real*8 B3
real*8 SOC
integer fcontin(0:N)
integer fcont(0:N)

integer dummy1, dummy2, dummy3, dummy4
integer Ld
integer sign, sign1, sign2, sign3, sign4, isign
integer i, j
integer in
integer subdim
integer m1, m2, k1, k2, m, k
integer ms1, ms2, ks1, ks2, ms
integer spin1, spin2, spin
integer ipr
real*8 Emin
complex*16, allocatable :: E0s(:)
complex*16, allocatable :: E0d(:)
complex*16, allocatable :: Edd(:)
complex*16, allocatable :: Esd(:)
complex*16, allocatable :: Eso(:)
complex*16, allocatable :: Emagd(:)
complex*16, allocatable :: Emags(:)
complex*16, allocatable :: Etot(:)
integer, allocatable :: comb(:)
integer, allocatable :: phiwork(:)

integer, external :: cls_occnum
integer,external :: cls_parity
integer,external :: cls_opsign
integer,external :: cls_spind
integer,external :: cls_spins
real*8,external :: cls_SLM
real*8,external :: cls_combination

!---------------------------------------------------------------------------------
ipr = Nd/2 + Ns - 1
Ld = (Nd - 2)/4
!---------------------------------------------------------------------------------
allocate (phiwork(dimvar))
phiwork = 0
k = 1
do in=0, N
  if (locc(in) == 0) cycle
  do i=0, 2**N -1
     if (cls_occnum(i,N) /= in) cycle
     phiwork(k) = i
     k = k+1
   end do
end do

allocate (comb(-1:N))
comb = 0
do in = 0, N
  if (locc(in) == 0) cycle
  comb(in) = comb(in-1) + nint(cls_combination(in, N)) 
end do

!----------------------------------------------------------------------------------------
k = 1
do in = 0, N
  if (locc(in) == 0) cycle
  subdim = nint(cls_combination(in, N))
  
allocate(E0s(subdim))
E0s = (0.D0,0.D0)
do i = 1, subdim
  j = i + comb(in-1)
  do ms2 = 0, Ns-1
    if (.NOT.btest(phiwork(j),ms2)) cycle
	dummy1 = phiwork(j)
	dummy1 = ibclr(dummy1,ms2)
	sign2 = cls_opsign(ms2,dummy1)
	do ms1 = 0, Ns-1
	   if (btest(dummy1,ms1)) cycle
	   dummy2 = dummy1
	   dummy2 = ibset(dummy2,ms1)
	   if (dummy2 /= phiwork(j)) cycle
	   sign1 = cls_opsign(ms1,dummy2)
	   sign = sign1 * sign2
       E0s(i) = E0s(i) + sign * Es(ms1,ms2)
    end do
  end do
end do

allocate(E0d(subdim))
E0d = (0.D0,0.D0)
do i = 1, subdim
  j = i + comb(in-1)
  do ms2 = Ns, N-1
    if (.NOT.btest(phiwork(j),ms2)) cycle
	dummy1 = phiwork(j)
    dummy1 = ibclr(dummy1,ms2)
	sign2 = cls_opsign(ms2,dummy1)
	do ms1 = Ns, N-1
	   if (btest(dummy1,ms1)) cycle
	   dummy2 = dummy1
	   dummy2 = ibset(dummy2,ms1)
	   if (dummy2 /= phiwork(j)) cycle
	   sign1 = cls_opsign(ms1,dummy2)
	   sign = sign1 * sign2
	   E0d(i) = E0d(i) + sign * Ed(ms1,ms2)
    end do
  end do
end do

allocate(Edd(subdim))
Edd = (0.D0,0.D0)
do i = 1, subdim
  j = i + comb(in-1)
  do ks1 = Ns, N-1
    if (.NOT.btest(phiwork(j),ks1)) cycle
	dummy1 = phiwork(j)
	dummy1 = ibclr(dummy1,ks1)
	sign1 = cls_opsign(ks1,dummy1)
	do ks2 = Ns, N-1
	  if (.NOT.btest(dummy1,ks2)) cycle
      dummy2 = dummy1
	  dummy2 = ibclr(dummy2,ks2)
	  sign2 = cls_opsign(ks2,dummy2)
	  do ms2 = Ns, N-1
	  	if (cls_spind(ms2,ipr) /= cls_spind(ks2,ipr)) cycle
		if (btest(dummy2,ms2)) cycle
		dummy3 = dummy2
		dummy3 = ibset(dummy3,ms2)
		sign3 = cls_opsign(ms2,dummy3)
	    do ms1 = Ns, N-1
		  if (cls_spind(ms1,ipr) /= cls_spind(ks1,ipr)) cycle
		  if (btest(dummy3,ms1)) cycle
		  dummy4 = dummy3
		  dummy4 = ibset(dummy4,ms1)
		  if (dummy4 /= phiwork(j)) cycle
		  sign4 = cls_opsign(ms1,dummy4)
		  sign = sign1 * sign2 * sign3 * sign4
		  m1 = mod((ms1 - Ns), (Nd/2))
		  k1 = mod((ks1 - Ns), (Nd/2))
		  m2 = mod((ms2 - Ns), (Nd/2))
		  k2 = mod((ks2 - Ns), (Nd/2))
          Edd(i) = Edd(i) + sign * 0.5 * UMAT(m1,k1,m2,k2)
		end do
	  end do
	end do
  end do
end do

allocate(Emagd(subdim))
Emagd= (0.D0,0.D0)
do i = 1, subdim
  j = i + comb(in-1)
  do ms = Ns, N-1
    if (btest(phiwork(j),ms)) then
    spin = cls_spind(ms, ipr)
    m = mod((ms - Ns), (Nd/2)) - Ld
	Emagd(i) = Emagd(i) - B1*spin - B2*m
	end if
  end do
end do

allocate(Emags(subdim))
Emags= (0.D0,0.D0)
do i = 1, subdim
  j = i + comb(in-1)
  do ms = 0, Ns
    if (btest(phiwork(j),ms)) then
    spin = cls_spins(ms, Ns)
	Emags(i) = Emags(i) - B3*spin
	end if
  end do
end do

allocate(Eso(subdim))
Eso= (0.D0,0.D0)
do i = 1, subdim
  j = i + comb(in-1)
  do ms2 = Ns, N-1
    if (.NOT.btest(phiwork(j),ms2)) cycle
	dummy1 = phiwork(j)
    dummy1 = ibclr(dummy1,ms2)
	sign2 = cls_opsign(ms2,dummy1)
	do ms1 = Ns, N-1
	  if (btest(dummy1,ms1)) cycle
	  dummy2 = dummy1
	  dummy2 = ibset(dummy2,ms1)
	  if (dummy2 /= phiwork(j)) cycle
	  sign1 = cls_opsign(ms1,dummy2)
	  sign = sign1 * sign2
	  m1 = mod((ms1 - Ns), (Nd/2)) - Ld
	  m2 = mod((ms2 - Ns), (Nd/2)) - Ld
	  spin1 = cls_spind(ms1,ipr)
	  spin2 = cls_spind(ms2,ipr)
	  Eso(i) = Eso(i) + sign * cls_SLM(Ld, m1, m2, spin1, spin2)*SOC
	end do
  end do
end do

allocate (Etot(subdim))
Etot = (0.D0,0.D0)
Etot = E0s + E0d + Edd  + Eso + Emagd + Emags

Emin = Etot(1)
do i = 2, subdim
  if (real(Etot(i) - Emin) <= 1.D-6) Emin = Etot(i)
end do

do i = 1, subdim
  if (real(Etot(i) - Emin) >= Ese) cycle
  
  fcontin(in) = fcontin(in) + 1
  if (in == 0) then
    fcont(in) = 0
  else
    fcont(in) = fcont(in-1) + fcontin(in)
  end if
  
  j = i + comb(in-1)
  phi(k) = phiwork(j)
  invphi(phi(k)) = k
  k = k + 1
end do

deallocate(E0s)
deallocate(E0d)
deallocate(Edd)
deallocate(Eso)
deallocate(Emagd)
deallocate(Emags)
deallocate(Etot)

end do
deallocate (phiwork)
end