subroutine cls_Fock2(in, Ns, Nd, subdim, totdim_imp, totdim_bath, Eimp, Ebath, Ecut1, Ecut2, ndmin, ndmax, &
                    & subdim_imp, subdim_bath, comb_imp, comb_bath, dim1, dim2, Ecls1, Ecls2, cin1, cin2)

implicit none

integer in
integer Ns
integer Nd
integer subdim
integer totdim_imp
integer totdim_bath
real*8 Eimp(totdim_imp)
real*8 Ebath(totdim_bath)
real*8 Ecut1
real*8 Ecut2
integer ndmin, ndmax
integer subdim_imp(0:Nd)
integer subdim_bath(0:Ns)
integer comb_imp(-1:Nd)
integer comb_bath(-1:Ns)
integer dim1, dim2
real*8 Ecls1(subdim)
real*8 Ecls2(subdim)
integer cin1(subdim, 6)
integer cin2(subdim, 6)

integer i, j, k
integer ind, ins
integer alpha, beta
integer mu, nu
real*8 Emin
real*8, allocatable ::  Etot(:)
integer, allocatable :: cin(:,:)

!------------------------------------------------------------------------------------------------------------------------
allocate (cin(subdim, 6))
cin = 0
allocate (Etot(subdim))
Etot = 0.D0

i = 1
do ind = ndmin, ndmax
  if (ind > in .OR. ind < in - Ns) cycle
  ins = in - ind 
  do alpha = 1, subdim_imp(ind)
    mu = alpha + comb_imp(ind - 1)
    do beta = 1, subdim_bath(ins)
      nu = beta + comb_bath(ins - 1)
      Etot(i) = Eimp(mu) + Ebath(nu)
      cin(i, 1) = ind
      cin(i, 2) = ins
      cin(i, 3) = alpha
      cin(i, 4) = beta
      cin(i, 5) = mu
      cin(i, 6) = nu
      i = i + 1
    end do
  end do
end do

Emin = Etot(1)
do i = 1, subdim
  if (Etot(i) < Emin) Emin = Etot(i)
end do

dim1 = 0
dim2 = 0
cin1 = 0
cin2 = 0
Ecls1 = 0.D0
Ecls2 = 0.D0
k = 1
j = 1
do i = 1, subdim
  if (Etot(i) - Emin > Ecut2) cycle
  if (Etot(i) - Emin > Ecut1) then
    dim2 = dim2 + 1
    Ecls2(k) = Etot(i)
    cin2(k, 1:6) = cin(i, 1:6)
    k = k + 1
  else
    dim1 = dim1 + 1
    Ecls1(j) = Etot(i)
    cin1(j, 1:6) = cin(i, 1:6)
    j = j + 1
  end if
end do

end