!---Dirac delta funtion----------------------------------------------------------------
integer function cls_delta(m, n)
integer m, n

if (m == n) then
  cls_delta = 1
else
  cls_delta = 0
end if

end

!----function that finds the sign of an operation-------------------------------
integer function cls_opsign(m, phi)
implicit none
integer sgn, i, m
integer phi

sgn = 0

do i=0, m-1
  if (btest(phi,i)) sgn = sgn + 1
end do
cls_opsign = (-1)**sgn

end

!----function that finds the spin of correlated site--------------------------------
integer function cls_spind(ms, ipr)
implicit none
integer ms, ipr

if (ms<=ipr) then
  cls_spind = -1
else
  cls_spind = 1
end if

end

!----function that finds the spin of uncorrelated site--------------------------------
integer function cls_spins(ms, Ns)
implicit none
integer ms, Ns

if (ms <= Ns/2-1) then
  cls_spins = -1
else
  cls_spins = 1
end if

end


!-----------------------------------------------------------------------------------------------
real*8 function cls_combination(m,n)

implicit none
integer m,n
real*8 fun
real*8,external :: cls_factorial

fun = cls_factorial(n)/(cls_factorial(m) * cls_factorial(n-m))

cls_combination = fun

end

!-----------------------------------------------------------------------------------------------
real*8 function cls_factorial(n)

implicit none
integer n
real*8 fac
integer i

fac = 1

if (n==0) then
fac=1
else
do i=1, n
fac = fac*i
end do
endif

cls_factorial = fac

end

!----function that finds the spin-orbit coupling---------------------------------------
real*8 function cls_SLM(Ld, m1, m2, spin1, spin2)
implicit none
integer Ld, m1, m2, spin1, spin2
real*8 soc
integer, external :: cls_delta

soc = 0.D0

  if (spin1 == 1) then
    if (spin2 ==  1) soc = cls_delta(m1, m2) * real(m2)/2.D0
    if (spin2 == -1) soc = cls_delta(m1, m2-1) * sqrt(real((ld+m2)*(ld-m2+1))) / 2.D0
  else
    if (spin2 ==  1) soc = cls_delta(m1, m2+1) * sqrt(real((ld-m2)*(ld+m2+1))) / 2.D0
    if (spin2 == -1) soc = cls_delta(m1, m2) * real(-m2) / 2.D0
  end if

cls_SLM = soc

end

!-----funtion that finds number of electrons in a Fock Vector----------------
integer function cls_occnum(phi, N)
implicit none
integer N
integer phi
integer num, i

num = 0
do i=0, N-1
   if (BTEST(phi,i))   num = num + 1
end do
cls_occnum = num

end  

!-----funtion that finds number of d-electrons in a Fock Vector--------------
integer function cls_dnum(phi, Ns, N)
implicit none
integer Ns, N
integer phi
integer num, i

num = 0
do i=Ns, N-1
   if (BTEST(phi,i))   num = num + 1
end do
cls_dnum = num

end