subroutine cls_AGF1(N, Ns, Nd, Es, Ed, V, dim, phi, invphi, Chem, damp, E_grid, E_array, Locc, Channel,&
& filename, Green1, Green2, Self_E, Self_Einf, mor, Mom, Den, DOS, fcontin, fcont, mode)

implicit none

integer N
integer Ns
integer Nd
complex*16 Es(0:Ns-1, 0:Ns-1)
complex*16 Ed(0:Nd-1, 0:Nd-1)
complex*16 V(0:Nd-1,0:Ns-1)
integer dim
integer phi(dim)
integer invphi(2**N)
real*8 Chem
real*8 damp
integer E_grid
complex*16 E_array(E_grid)
integer Locc(0:N)
integer Channel(6)
character (len=130) filename(5)
complex*16 Green1(0:N-1, 0:N-1, E_grid)
complex*16 Green2(0:N-1, 0:N-1, E_grid)
complex*16 Self_E(0:N-1, 0:N-1, E_grid)
complex*16 Self_Einf(0:N-1, 0:N-1)
integer mor
complex*16 Mom(0:N-1, 0:N-1, -5:5)
complex*16 Den(0:N-1, 0:N-1, -5:5)
real*8 DOS(E_grid)
integer fcontin(0:N)
integer fcont(0:N)
integer mode

complex*16 matrele
complex*16 matreld
complex*16 omega
integer i, j
integer in, inpoint
integer ms1, ms2
integer alpha1, alpha2
integer kapa1, kapa2
integer subn, subm
integer imy, im
integer ifail
integer phibra, phiket
integer iMom
real*8 Ediff, Edifm
real*8 contrb
complex*16 mummy1
real*8 mummy2, mummy3
complex*16 greeng1, greeng2
integer,allocatable :: Locc2(:)
integer,allocatable :: IMATC(:,:,:)
integer,allocatable :: maxn(:)
integer,allocatable :: maxm(:)
integer,allocatable :: maxi(:)
integer,allocatable :: maxj(:)
real*8,allocatable :: En(:)
real*8,allocatable :: Em(:)
real*8,allocatable :: X(:)
real*8,allocatable :: Xn(:)
real*8,allocatable :: Xm(:)
real*8,allocatable :: Ec(:,:)
real*8,allocatable :: DosMax(:)
complex*16,allocatable :: Green(:,:,:)
complex*16,allocatable :: An(:,:)
complex*16,allocatable :: Am(:,:)
complex*16,allocatable :: MAT(:,:,:)
complex*16,allocatable :: Awork(:,:,:)
complex*16,allocatable :: Sigma(:,:)
complex*16,allocatable :: IU(:,:)
complex*16,allocatable :: G_inv(:,:)
complex*16,allocatable :: R(:)

integer, external :: cls_opsign

!-------------------------------------------------------------------------
write (channel(6),*) "Start calculating Green's function"

Green1 = (0.D0,0.D0)
Green2 = (0.D0,0.D0)
Mom = (0.D0,0.D0)
Den = (0.D0,0.D0)
DOS = 0.D0

allocate (Green(0:N-1, 0:N-1, E_grid))
Green = (0.D0,0.D0)

allocate (Locc2(0:N))
Locc2 = Locc
do in = 0, N
  if (Locc2(in) /= 0) then 
    Locc2(in) = 0
    exit
  end if
end do

allocate (DosMax(E_grid))
DosMax = 0.D0
allocate (maxn(E_grid))
maxn = 0
allocate (maxm(E_grid))
maxm = 0
allocate (maxi(E_grid))
maxi = 0
allocate (maxj(E_grid))
maxj = 0

do in = 0, N   !--start loop over number of electrons-----------------------------

  if (Locc2(in)==0) cycle  
  
  subm = fcontin(in-1)
  subn = fcontin(in)
 
!--calculate <phi|d+|phi> = IMATC matrix------------------------------------------
  allocate(IMATC(subn,subm,0:N-1))
  IMATC = 0
  do ms1 = 0, N-1
    do kapa2 = 1, subm
	   inpoint = fcont(in-1) - subm + kapa2
       phiket = phi(inpoint)
	   if (btest(phiket,ms1)) cycle
       phiket = ibset(phiket, ms1)
       if (invphi(phiket) == 0) cycle
	   kapa1 = invphi(phiket) - fcont(in) + subn
	   IMATC(kapa1,kapa2,ms1) = cls_opsign(ms1, phiket)
	end do
  end do

!--calculate <PSI|d+|PSI> = M matrix----------------------------------------- 
  open (unit=channel(1), file=filename(2), form='UNFORMATTED')
  if (in /= 1) then
    do im = 0, in-2
      if (Locc(im) /= 0) then
        do imy = 1, fcontin(im)**2
          read (channel(1)) mummy1
        end do
      end if
    end do
  end if
  allocate(Am(subm,subm))
  do j = 1, subm
    do i = 1, subm
      read (channel(1)) Am(i,j)
    end do
  end do
  
  allocate (Awork(subn,subm,0:N-1))
  Awork = (0.D0,0.D0)
  
  do ms1 = 0, N-1
    do kapa1 = 1, subn
	  do alpha2 = 1, subm
	    do kapa2 = 1, subm
	       Awork(kapa1,alpha2,ms1) = Awork(kapa1,alpha2,ms1) + IMATC(kapa1,kapa2,ms1) * Am(kapa2,alpha2)
		end do
	  end do
	end do
  end do
  
  deallocate(IMATC)
  deallocate(Am)
  
  allocate(An(subn,subn))
  do j = 1, subn
    do i = 1, subn
      read (channel(1)) An(i,j)
    end do
  end do
  close (channel(1))
  
  allocate(MAT(subn,subm,0:N-1))
  MAT = (0.D0,0.D0)
  
  do ms1 = 0, N-1
    do alpha1 = 1, subn
	  do alpha2 = 1, subm
	    do kapa1 = 1, subn
		  MAT(alpha1,alpha2,ms1) = MAT(alpha1,alpha2,ms1) + conjg(An(kapa1,alpha1)) * Awork(kapa1,alpha2,ms1)
		end do
	  end do
	end do
  end do
  
  deallocate(Awork)
  deallocate(An)

!--find maximun contribution to DOS----------------------------------------------------------------------------------
  open (unit=channel(1), file=filename(1), form='UNFORMATTED')
  open (unit=channel(2), file=filename(3), form='UNFORMATTED')
  if (in /= 1) then
    do im = 0, in-2
      if (Locc(im) /= 0) then
        do imy = 1, fcontin(im)
          read (channel(1)) mummy2
          read (channel(2)) mummy3
        end do
      end if
    end do
  end if
  allocate (Em(subm))
  allocate (Xm(subm))
  do i = 1, subm
    read (channel(1)) Em(i)
    read (channel(2)) Xm(i)
  end do
  allocate (En(subn))
  allocate (Xn(subn))
  do  i = 1, subn
    read (channel(1)) En(i)
    read (channel(2)) Xn(i)
  end do
  close (channel(1))
  close (channel(2))
do i = 1, E_grid
  omega = E_array(i)
  do alpha1 = 1, subn
    do alpha2 = 1, subm
      greeng2 =  1.d0 / (omega + chem - En(alpha1) + Em(alpha2) + (0.D0,1.D0)*damp)
      contrb = 0.D0
      do ms1 = 0, N-1
        contrb = contrb - real(MAT(alpha1,alpha2,ms1) * conjg(MAT(alpha1,alpha2,ms1))) * (Xn(alpha1) + Xm(alpha2)) * imag(greeng2)
      end do
      if (contrb - DosMax(i) >= 1.D-5) then
        DosMax(i) = contrb
        maxn(i) = in
        maxm(i) = in -1
        maxi(i) = alpha1
        maxj(i) = alpha2
      end if
    end do
  end do
end do
  
!--calculate Green's function---------------------------------------------------
  do alpha1 = 1, subn
    do alpha2 = 1, subm
      do ms1 = 0, N-1
        do ms2 = 0, N-1
		  matrele = MAT(alpha1,alpha2,ms1) * conjg(MAT(alpha1,alpha2,ms2)) * (Xn(alpha1) + Xm(alpha2))
		  matreld = MAT(alpha1,alpha2,ms1) * conjg(MAT(alpha1,alpha2,ms2)) *  Xn(alpha1)
		  if (abs(matrele) <= 1.D-14) cycle
          do i = 1, E_grid
            omega = E_array(i)
   	        greeng1 =  1.d0 / (omega + chem - En(alpha1) + Em(alpha2)) 
	        greeng2 =  1.d0 / (omega + chem - En(alpha1) + Em(alpha2) + (0.D0,1.D0)*damp)
            Green(ms1,ms2,i)  = Green(ms1,ms2,i) + matrele * greeng1
            Green1(ms1,ms2,i) = Green1(ms1,ms2,i) + matrele * Real(greeng2)
            Green2(ms1,ms2,i) = Green2(ms1,ms2,i) + matrele * imag(greeng2)
          end do
          do iMom= -mor, mor
            Ediff = En(alpha1) - Em(alpha2) - Chem
            if(abs(Ediff) > 1.D-14) Edifm = Ediff**iMom
            if(abs(Ediff) <= 1.D-14 .and. iMom /= 0) Edifm=0.d0
            if(abs(Ediff) <= 1.D-14 .and. iMom == 0) Edifm=1.d0
            Mom(ms1,ms2,iMom) = Mom(ms1,ms2,iMom) +  matrele * Edifm 
            Den(ms1,ms2,iMom) = Den(ms1,ms2,iMom) +  matreld * Edifm 
          end do
        end do
	  end do
    end do
  end do

  deallocate (MAT)
  deallocate(Em)
  deallocate(En)
  deallocate(Xm)
  deallocate(Xn)

end do !--end loop over number of electrons----------------------------

open (unit=channel(1), file=filename(1), form='UNFORMATTED')
open (unit=channel(2), file=filename(2), form='UNFORMATTED')
open (unit=channel(3), file=filename(3), form='UNFORMATTED')
close(channel(1), status='delete')
close(channel(2), status='delete')
close(channel(3), status='delete')

write (channel(6),*) 'Green function finished'

!--compute DOS--------------------------------------------------------------------
write (channel(6),*) 'Start computing DOS...'
do i = 1, E_grid 
  do ms1=0, N-1
    DOS(i) = DOS(i)-real(Green2(ms1,ms1,i))
  end do
end do 
write (channel(6),*) 'DOS finished'

!--output total DOS-----------------------------------------------------------------
if (Mode/10 == 2 .or. Mode/10 == 4) then
  write (channel(6), *) '-------------------------------------------------------------------------------'
  write (channel(6), *) ' omega    DosTot   MaxContrb  n      i    n-1   j'
  do i = 1, E_grid
    write (channel(6),'(3F9.4, 4I6)') real(E_array(i)), Dos(i), DosMax(i), maxn(i), maxi(i), maxm(i), maxj(i)
  end do
end if

deallocate (DosMax)
deallocate (maxn)
deallocate (maxm)
deallocate (maxi)
deallocate (maxj)

!----calculate self-energy----------------------------------------------------------
write (channel(6),*) 'Start calculating self-energy...'

allocate (Sigma(0:N-1,0:N-1))
allocate (IU(0:N-1,0:N-1))
IU = (0.D0,0.D0)
allocate (Ec(0:N-1, 0:N-1))
Ec = (0.D0,0.D0)

do ms1 = 0, N-1
  IU(ms1, ms1) = (1.D0,0.D0)
end do

Ec(0:Ns-1, 0:Ns-1) = Es
Ec(Ns:N-1, Ns:N-1) = Ed
do ms1 = Ns, N-1
  do ms2 = 0, Ns-1
    Ec(ms1, ms2) = V(ms1 - Ns, ms2)
    Ec(ms2, ms1) = conjg(V(ms1 - Ns, ms2))
  enddo
enddo

allocate (G_inv(0:N-1,0:N-1))
allocate (R(N))

do i = 1, E_grid            
  omega = E_array(i)
  G_inv(0:N-1,0:N-1) = Green(0:N-1,0:N-1,i)
  call LIB_CINV(N, G_inv, N, R, IFAIL)
! call DLINCG(N, Green(0:N-1,0:N-1,i), N, G_inv, N)
  Sigma = (0.D0,0.D0) 
  do ms1 = 0, N-1
    do ms2 = 0, N-1
	  Sigma(ms1,ms2) = omega*IU(ms1,ms2) + Chem*IU(ms1,ms2) - Ec(ms1,ms2) - G_inv(ms1,ms2)
	end do
  end do
  Self_E(0:N-1,0:N-1,i) = Sigma
end do          

deallocate(Sigma)
deallocate(Green)
deallocate(G_inv)
deallocate(R)

Self_Einf = Mom(0:N-1, 0:N-1, 1) - Ec + chem * IU

deallocate(Ec)

write (channel(6),*) 'Self-energy finished'

end




