subroutine cls_AGF2(N, Ns, Nd, Es, Ed, V, ndmin, ndmax, nsmin, nsmax, subdim_cls1, subdim_cls2, Chem, damp, E_grid, E_array, &
                   & Locc, Channel, filename, Green1, Green2, Self_E, Self_Einf, mor, Mom, Den, DOS, mode)

implicit none

integer N
integer Ns
integer Nd
complex*16 Es(0:Ns-1, 0:Ns-1)
complex*16 Ed(0:Nd-1, 0:Nd-1)
complex*16 V(0:Nd-1,0:Ns-1)
integer ndmin, ndmax
integer nsmin, nsmax
integer subdim_cls1(0:N)
integer subdim_cls2(0:N)
real*8 Chem
real*8 damp
integer E_grid
complex*16 E_array(E_grid)
integer Locc(0:N)
integer Channel(6)
character (len = 130) filename(5)
complex*16 Green1(0:N-1, 0:N-1, E_grid)
complex*16 Green2(0:N-1, 0:N-1, E_grid)
complex*16 Self_E(0:N-1, 0:N-1, E_grid)
complex*16 Self_Einf(0:N-1, 0:N-1)
integer mor
complex*16 Mom(0:N-1, 0:N-1, -mor:mor)
complex*16 Den(0:N-1, 0:N-1, -mor:mor)
real*8 DOS(E_grid)
integer mode

complex*16 matrele
complex*16 matreld
complex*16 omega
integer i, j, k
integer in, inpoint
integer ind, ins
integer ms1, ms2
integer ks, ms
integer ns1, ns2
integer nd1, nd2
integer a, b
integer a_act, b_act
integer alpha1, alpha2
integer alpha1_act, alpha2_act
integer beta1, beta2
integer kapa1, kapa2
integer subn1, subm1
integer subn2, subm2
integer subn1_act, subm1_act
integer subn2_act, subm2_act
integer subn, subm
integer subdim_impmax, subdim_bathmax
integer subs, subd
integer ifail
integer phibra, phiket            
integer iMom
real*8 Ediff, Edifm
real*8 contrb
integer idummy
integer idummy1, idummy2, idummy3, idummy4, idummy5, idummy6 
real*8 rdummy
complex*16 ddummy
complex*16 greeng1, greeng2
integer,allocatable :: Locc2(:)
integer,allocatable :: cin1m(:, :)
integer,allocatable :: cin1n(:, :)
integer,allocatable :: cin2m(:, :)
integer,allocatable :: cin2n(:, :)
integer,allocatable :: IMATC(:,:,:)
integer,allocatable :: maxn(:)
integer,allocatable :: maxm(:)
integer,allocatable :: maxi(:)
integer,allocatable :: maxj(:)
integer,allocatable :: act_pointern(:)
integer,allocatable :: act_pointerm(:)
real*8,allocatable :: En1(:)
real*8,allocatable :: Em1(:)
real*8,allocatable :: Xn1(:)
real*8,allocatable :: Xm1(:)
real*8,allocatable :: En2(:)
real*8,allocatable :: Em2(:)
real*8,allocatable :: Xn2(:)
real*8,allocatable :: Xm2(:)
real*8,allocatable :: Ec(:,:)
real*8,allocatable :: DosMax(:)
complex*16,allocatable :: DCMAT(:, :, :, :)
integer,allocatable :: SCMAT(:, :, :, :)
complex*16,allocatable :: Green(:,:,:)
complex*16,allocatable :: An(:,:)
complex*16,allocatable :: Am(:,:)
complex*16,allocatable :: MATD1(:,:,:)
complex*16,allocatable :: MATD2(:,:,:)
complex*16,allocatable :: MATD3(:,:,:)
complex*16,allocatable :: MATS1(:,:,:)
complex*16,allocatable :: MATS2(:,:,:)
complex*16,allocatable :: MATS3(:,:,:)
complex*16,allocatable :: AW(:,:)
complex*16,allocatable :: MAT1(:,:,:)
complex*16,allocatable :: MAT2(:,:,:)
complex*16,allocatable :: MAT3(:,:,:)
complex*16,allocatable :: Sigma(:,:)
complex*16,allocatable :: IU(:,:)
complex*16,allocatable :: G_inv(:,:)
complex*16,allocatable :: R(:)

real*8, parameter :: pro_acu = 1.D-8

integer, external :: cls_opsign
real*8, external :: cls_combination

!---------------------------------------------------------------------------------------------------
write (channel(6),*) "Start calculating Green's function"

Green1 = (0.D0,0.D0)
Green2 = (0.D0,0.D0)
Mom = (0.D0,0.D0)
Den = (0.D0,0.D0)
DOS = 0.D0

allocate (Green(0:N-1, 0:N-1, E_grid))
Green = (0.D0,0.D0)

allocate (Locc2(0:N))
Locc2 = Locc
do in = 0, N
  if (Locc2(in) /= 0) then 
    Locc2(in) = 0
    exit
  end if
end do

subdim_impmax = 0
do ind = ndmin, ndmax
  subd = nint(cls_combination(ind, Nd))
  if ( subd > subdim_impmax) subdim_impmax = subd
end do

subdim_bathmax = 0
do ins = nsmin, nsmax
  subs = nint(cls_combination(ins, Ns))
  if (subs> subdim_bathmax) subdim_bathmax = subs
end do  
    
allocate (DCMAT(subdim_impmax, subdim_impmax, 0:Nd-1, ndmin+1:ndmax))
allocate (SCMAT(subdim_bathmax, subdim_bathmax, 0:Ns-1, nsmin+1:nsmax))
DCMAT = (0.D0, 0.D0)
SCMAT = 0

open (unit = channel(1), file = filename(1)//"dcmat.bin", form = "UNFORMATTED")
do ind = ndmin+1, ndmax
  subn = nint(cls_combination(ind, Nd))
  subm = nint(cls_combination(ind-1, Nd))
  do ms = 0, Nd-1
    do alpha2 = 1, subm
      do alpha1 = 1, subn
        read (channel(1)) DCMAT(alpha1, alpha2, ms, ind)
      end do
    end do
  end do
end do
close (channel(1), status="DELETE")

open (unit = channel(1), file = filename(1)//"scmat.bin", form = "UNFORMATTED")
do ins = nsmin+1, nsmax
  subn = nint(cls_combination(ins, Ns))
  subm = nint(cls_combination(ins-1, Ns))
  do ks = 0, Ns-1
    do beta2 = 1, subm
      do beta1 = 1, subn
        read (channel(1)) SCMAT(beta1, beta2, ks, ins)
      end do
    end do
  end do
end do
close (channel(1), status="DELETE")


do in = 0, N   !--start loop over number of electrons-------------------------------------------------

  if (Locc2(in)==0) cycle  
  
  subm1 = subdim_cls1(in-1)
  subn1 = subdim_cls1(in)
  subm2 = subdim_cls2(in-1)
  subn2 = subdim_cls2(in)

  open (unit = channel(1), file = filename(2), form = "UNFORMATTED")
  
  do i = 0, in-2
    if (Locc(i) == 0) cycle
    do j = 1, subdim_cls1(i)**2
      read (channel(1)) ddummy
    end do
  end do
  
  allocate(Am(subm1,subm1))
  do j = 1, subm1
    do i = 1, subm1
      read (channel(1)) Am(i,j)
    end do
  end do
  
  allocate(An(subn1,subn1))
  do j = 1, subn1
    do i = 1, subn1
      read (channel(1)) An(i,j)
    end do
  end do
  
  close (channel(1))
 
  open (unit = channel(1), file = filename(1)//"index1_tmp.bin", form = "UNFORMATTED")
  open (unit = channel(2), file = filename(1)//"index2_tmp.bin", form = "UNFORMATTED")
  
  do i = 0, in-2
    if (Locc(i) == 0) cycle
    do j = 1, subdim_cls1(i)
      read (channel(1)) idummy1, idummy2, idummy3, idummy4, idummy5, idummy6 
    end do
    if (subdim_cls2(i) == 0) cycle
    do j = 1, subdim_cls2(i)
      read (channel(2)) rdummy
      read (channel(2)) idummy1, idummy2, idummy3, idummy4, idummy5, idummy6 
    end do
  end do
  
  allocate (cin1m(subm1, 6))
  allocate (cin1n(subn1, 6))
  do i = 1, subm1
    read (channel(1)) cin1m(i, 1), cin1m(i, 2), cin1m(i, 3), cin1m(i, 4), cin1m(i, 5), cin1m(i, 6)
  end do
   do i = 1, subn1
    read (channel(1)) cin1n(i, 1), cin1n(i, 2), cin1n(i, 3), cin1n(i, 4), cin1n(i, 5), cin1n(i, 6)
  end do
  
  if (subm2 /= 0) then
    allocate (cin2m(subm2, 6))
    allocate (Em2(subm2))
    do i = 1, subm2
      read (channel(2)) Em2(i)
      read (channel(2)) cin2m(i, 1), cin2m(i, 2), cin2m(i, 3), cin2m(i, 4), cin2m(i, 5), cin2m(i, 6)
    end do
  end if
  
  if (subn2 /= 0) then
    allocate (cin2n(subn2, 6))
    allocate (En2(subn2))
    do i = 1, subn2
      read (channel(2)) En2(i)
      read (channel(2)) cin2n(i, 1), cin2n(i, 2), cin2n(i, 3), cin2n(i, 4), cin2n(i, 5), cin2n(i, 6)
    end do
  end if
  
  close (channel(1))
  close (channel(2))
  
  open (unit=channel(1), file=filename(1), form='UNFORMATTED')
  open (unit=channel(2), file=filename(3), form='UNFORMATTED')
  
  do i = 0, in-2
    if (Locc(i) == 0) cycle
    do j = 1, subdim_cls1(i)
      read (channel(1)) rdummy
      read (channel(2)) rdummy
    end do
    if (subdim_cls2(i) == 0) cycle
    do j = 1, subdim_cls2(i)
      read (channel(2)) rdummy
    end do
  end do

  allocate (Em1(subm1))
  allocate (Xm1(subm1))
  allocate (En1(subn1))
  allocate (Xn1(subn1))
  
  do i = 1, subm1
    read (channel(1)) Em1(i)
    read (channel(2)) Xm1(i)
  end do
  
  if (subm2 /= 0 ) then
    allocate (Xm2(subm2))
    do i = 1, subm2
      read (channel(2)) Xm2(i)
    end do
  end if

  do  i = 1, subn1
    read (channel(1)) En1(i)
    read (channel(2)) Xn1(i)
  end do
  
  if (subn2 /= 0) then
    allocate (Xn2(subn2))
    do i = 1, subn2
      read (channel(2)) Xn2(i)
    end do
  end if
  
  close (channel(1))
  close (channel(2))
  
  subn1_act = 0
  do i = 1, subn1
    if (Xn1(i) >= pro_acu) subn1_act = subn1_act + 1
  end do
  
  subm1_act = 0
  do i = 1, subm1
    if (Xm1(i) >= pro_acu) subm1_act = subm1_act + 1
  end do
  
  allocate (act_pointerm(subm1_act))
  allocate (act_pointern(subn1_act))
  act_pointerm = 0
  act_pointern = 0
  
  k = 1
  do i = 1, subn1
    if (Xn1(i) >= pro_acu) then
      act_pointern(k) = i
      k = k + 1
    end if
  end do
  
  k = 1
  do i = 1, subm1
    if (Xm1(i) >= pro_acu) then
      act_pointerm(k) = i
      k = k + 1
    end if
  end do
  
!----Bath matirx elements of Green's function-----------------------------------------------------------------------------  
  allocate (MATS1(subn1, subm1, 0:Ns-1))
  MATS1 = (0.D0, 0.D0)
  allocate (AW(subm1, subn1))
  
  if (subm2 /= 0) then
    allocate (MATS2(subn1_act, subm2, 0:Ns-1))
    MATS2 = (0.D0, 0.D0)
  end if
  if (subn2 /= 0) then
    allocate (MATS3(subn2, subm1_act, 0:Ns-1))
    MATS3 = (0.D0, 0.D0)
  end if
    
  do ks = 0, Ns-1   
        
    AW = (0.D0, 0.D0)
    do j = 1, subm1
      nd2 = cin1m(j, 1)
      ns2 = cin1m(j, 2)
      alpha2 = cin1m(j, 3)
      beta2 = cin1m(j, 4)
      do a = 1, subn1
        do i = 1, subn1
          nd1 = cin1n(i, 1)
          ns1 = cin1n(i, 2)
          alpha1 = cin1n(i, 3)
          beta1 = cin1n(i, 4)
          if (nd1 /= nd2) cycle
          if (alpha1 /= alpha2) cycle
          AW(j, a) = AW(j, a) + conjg(An(i, a)) * SCMAT(beta1, beta2, ks, ns1)
        end do
      end do
    end do
    do b = 1, subm1
      do a = 1, subn1
        do j = 1, subm1
          nd2 = cin1m(j, 1)
          ns2 = cin1m(j, 2)
          alpha2 = cin1m(j, 3)
          beta2 = cin1m(j, 4)
          MATS1(a, b, ks) = MATS1(a, b, ks) +  AW(j, a) * Am(j, b)
        end do
      end do
    end do
   
    if (subm2 /= 0) then
    do j = 1, subm2
      nd2 = cin2m(j, 1)
      ns2 = cin2m(j, 2)
      alpha2 = cin2m(j, 3)
      beta2 = cin2m(j, 4)
      do a_act = 1, subn1_act
        a = act_pointern(a_act)
        do i = 1, subn1
          nd1 = cin1n(i, 1)
          ns1 = cin1n(i, 2)
          alpha1 = cin1n(i, 3)
          beta1 = cin1n(i, 4)
          if (nd1 /= nd2) cycle
          if (alpha1 /= alpha2) cycle
          MATS2(a, j, ks) = MATS2(a, j, ks) + conjg(An(i, a)) * SCMAT(beta1, beta2, ks, ns1)
        end do
      end do
    end do
    end if

    if (subn2 /= 0) then
    do b_act = 1, subm1_act
      b = act_pointerm(b_act)
      do j = 1, subm1
        nd2 = cin1m(j, 1)
        ns2 = cin1m(j, 2)
        alpha2 = cin1m(j, 3)
        beta2 = cin1m(j, 4)
        do i = 1, subn2
          nd1 = cin2n(i, 1)
          ns1 = cin2n(i, 2)
          alpha1 = cin2n(i, 3)
          beta1 = cin2n(i, 4)
          if (nd1 /= nd2) cycle
          if (alpha1 /= alpha2) cycle
          MATS3(i, b, ks) = MATS3(i, b, ks) + Am(j, b) * SCMAT(beta1, beta2, ks, ns1)
        end do
      end do
    end do
    end if
        
  end do
  
!----impurity matirx elements of Green's function------------------------------------------------------------------------------  
  allocate (MATD1(subn1, subm1, 0:Nd-1))
  MATD1 = 0.D0
  if (subm2 /= 0) then
    allocate (MATD2(subn1_act, subm2, 0:Nd-1))
    MATD2 = (0.D0, 0.D0)
  end if
  if (subn2 /= 0) then
    allocate (MATD3(subn2, subm1_act, 0:Nd-1))
    MATD3 = (0.D0, 0.D0)
  end if
    
  do ms = 0, Nd-1 
    
    AW = (0.D0, 0.D0)
    do j = 1, subm1
      nd2 = cin1m(j, 1)
      ns2 = cin1m(j, 2)
      alpha2 = cin1m(j, 3)
      beta2 = cin1m(j, 4)
      do a = 1, subn1
        do i = 1, subn1
          nd1 = cin1n(i, 1)
          ns1 = cin1n(i, 2)
          alpha1 = cin1n(i, 3)
          beta1 = cin1n(i, 4)
          if (ns1 /= ns2) cycle
          if (beta1 /= beta2) cycle
          AW(j, a) = AW(j, a) + ((-1)**ns2) * conjg(An(i, a)) * DCMAT(alpha1, alpha2, ms, nd1)
        end do
      end do
    end do
    do b = 1, subm1
      do a = 1, subn1
        do j = 1, subm1
          nd2 = cin1m(j, 1)
          ns2 = cin1m(j, 2)
          alpha2 = cin1m(j, 3)
          beta2 = cin1m(j, 4)
          MATD1(a, b, ms) = MATD1(a, b, ms) +  AW(j, a) * Am(j, b)
        end do
      end do
    end do

    if (subm2 /= 0) then
    do j = 1, subm2
      nd2 = cin2m(j, 1)
      ns2 = cin2m(j, 2)
      alpha2 = cin2m(j, 3)
      beta2 = cin2m(j, 4)
      do a_act = 1, subn1_act
        a = act_pointern(a_act)
        do i = 1, subn1
          nd1 = cin1n(i, 1)
          ns1 = cin1n(i, 2)
          alpha1 = cin1n(i, 3)
          beta1 = cin1n(i, 4)
          if (ns1 /= ns2) cycle
          if (beta1 /= beta2) cycle
          MATD2(a, j, ms) = MATD2(a, j, ms) + ((-1)**ns2) * conjg(An(i, a)) * DCMAT(alpha1, alpha2, ms, nd1)
        end do
      end do
    end do
    end if

    if (subn2 /= 0) then
    do b_act = 1, subm1_act
      b = act_pointerm(b_act)
      do j = 1, subm1
        nd2 = cin1m(j, 1)
        ns2 = cin1m(j, 2)
        alpha2 = cin1m(j, 3)
        beta2 = cin1m(j, 4)
        do i = 1, subn2
          nd1 = cin2n(i, 1)
          ns1 = cin2n(i, 2)
          alpha1 = cin2n(i, 3)
          beta1 = cin2n(i, 4)
          if (ns1 /= ns2) cycle
          if (beta1 /= beta2) cycle
          MATD3(i, b, ms) = MATD3(i, b, ms) + ((-1)**ns2) * Am(j, b) * DCMAT(alpha1, alpha2, ms, nd1)
        end do
      end do
    end do
    end if
        
  end do
  
  deallocate (AW)
  deallocate (Am)
  deallocate (An)
  deallocate (cin1n)
  deallocate (cin1m)
  if (subm2 /= 0) deallocate (cin2m)
  if (subn2 /= 0)  deallocate (cin2n)

!----calculate total matrix elements-----------------------------------------------------------------------------------
  allocate(MAT1(subn1, subm1, 0:N-1))
  MAT1(1:subn1, 1:subm1, 0:Ns-1) = MATS1(1:subn1, 1:subm1, 0:Ns-1)
  MAT1(1:subn1, 1:subm1, Ns:N-1) = MATD1(1:subn1, 1:subm1, 0:Nd-1)
  deallocate (MATS1)
  deallocate (MATD1)
  
  if (subm2 /= 0) then
  allocate(MAT2(subn1_act, subm2, 0:N-1))
  MAT2(1:subn1_act, 1:subm2, 0:Ns-1) = MATS2(1:subn1_act, 1:subm2, 0:Ns-1)
  MAT2(1:subn1_act, 1:subm2, Ns:N-1) = MATD2(1:subn1_act, 1:subm2, 0:Nd-1)
  deallocate (MATS2)
  deallocate (MATD2)
  end if
  
  if (subn2 /= 0) then
  allocate(MAT3(subn2, subm1_act, 0:N-1))
  MAT3(1:subn2, 1:subm1_act, 0:Ns-1) = MATS3(1:subn2, 1:subm1_act, 0:Ns-1)
  MAT3(1:subn2, 1:subm1_act, Ns:N-1) = MATD3(1:subn2, 1:subm1_act, 0:Nd-1)
  deallocate (MATS3)
  deallocate (MATD3)
  end if
  
!----Green's function Part 1---------------------------------------------------------------------------------------------------------------------
  do alpha1 = 1, subn1
    do alpha2 = 1, subm1
      do ms1 = 0, N-1
        do ms2 = 0, N-1
		  matrele = MAT1(alpha1,alpha2,ms1) * conjg(MAT1(alpha1,alpha2,ms2)) * (Xn1(alpha1) + Xm1(alpha2))
		  matreld = MAT1(alpha1,alpha2,ms1) * conjg(MAT1(alpha1,alpha2,ms2)) *  Xn1(alpha1)
		  if (abs(matrele) <= 1.D-14) cycle
          do i = 1, E_grid
            omega = E_array(i)
   	        greeng1 =  1.d0 / (omega + chem - En1(alpha1) + Em1(alpha2)) 
	        greeng2 =  1.d0 / (omega + chem - En1(alpha1) + Em1(alpha2) + (0.D0,1.D0)*damp)
            Green(ms1, ms2, i)  = Green(ms1, ms2, i) + matrele * greeng1
            Green1(ms1, ms2, i) = Green1(ms1, ms2, i) + matrele * Real(greeng2)
            Green2(ms1, ms2, i) = Green2(ms1, ms2, i) + matrele * imag(greeng2)
          end do
          do iMom= -mor, mor
            Ediff = En1(alpha1) - Em1(alpha2) - Chem
            if(abs(Ediff) > 1.D-14) Edifm = Ediff**iMom
            if(abs(Ediff) <= 1.D-14 .and. iMom /= 0) Edifm=0.d0
            if(abs(Ediff) <= 1.D-14 .and. iMom == 0) Edifm=1.d0
            Mom(ms1,ms2,iMom) = Mom(ms1,ms2,iMom) +  matrele * Edifm 
            Den(ms1,ms2,iMom) = Den(ms1,ms2,iMom) +  matreld * Edifm 
          end do
        end do
	  end do
    end do
  end do

  deallocate (MAT1)
  
!----Green's function Part 2---------------------------------------------------------------------------------------------------------------------
  if ( subm2 /= 0) then
  do alpha1_act = 1, subn1_act
    alpha1 = act_pointern(alpha1_act)
    if (Xn1(alpha1) < pro_acu) cycle
    do alpha2 = 1, subm2
      do ms1 = 0, N-1
        do ms2 = 0, N-1
		  matrele = MAT2(alpha1,alpha2,ms1) * conjg(MAT2(alpha1,alpha2,ms2)) * (Xn1(alpha1) + Xm2(alpha2))
		  matreld = MAT2(alpha1,alpha2,ms1) * conjg(MAT2(alpha1,alpha2,ms2)) *  Xn1(alpha1)
		  if (abs(matrele) <= 1.D-14) cycle
          do i = 1, E_grid
            omega = E_array(i)
   	        greeng1 =  1.d0 / (omega + chem - En1(alpha1) + Em2(alpha2)) 
	        greeng2 =  1.d0 / (omega + chem - En1(alpha1) + Em2(alpha2) + (0.D0,1.D0)*damp)
            Green(ms1, ms2, i)  = Green(ms1, ms2, i) + matrele * greeng1
            Green1(ms1, ms2, i) = Green1(ms1, ms2, i) + matrele * Real(greeng2)
            Green2(ms1, ms2, i) = Green2(ms1, ms2, i) + matrele * imag(greeng2)
          end do
          do iMom= -mor, mor
            Ediff = En1(alpha1) - Em2(alpha2) - Chem
            if(abs(Ediff) > 1.D-14) Edifm = Ediff**iMom
            if(abs(Ediff) <= 1.D-14 .and. iMom /= 0) Edifm=0.d0
            if(abs(Ediff) <= 1.D-14 .and. iMom == 0) Edifm=1.d0
            Mom(ms1,ms2,iMom) = Mom(ms1,ms2,iMom) +  matrele * Edifm 
            Den(ms1,ms2,iMom) = Den(ms1,ms2,iMom) +  matreld * Edifm 
          end do
        end do
	  end do
    end do
  end do
  deallocate (MAT2) 
  end if
  
!----Green's function Part 3---------------------------------------------------------------------------------------------------------------------
  if (subn2 /= 0) then
  do alpha1 = 1, subn2
    do alpha2_act = 1, subm1_act
    alpha2 = act_pointerm(alpha2_act)
      do ms1 = 0, N-1
        do ms2 = 0, N-1
		  matrele = MAT3(alpha1,alpha2,ms1) * conjg(MAT3(alpha1,alpha2,ms2)) * (Xn2(alpha1) + Xm1(alpha2))
		  matreld = MAT3(alpha1,alpha2,ms1) * conjg(MAT3(alpha1,alpha2,ms2)) *  Xn2(alpha1)
		  if (abs(matrele) <= 1.D-14) cycle
          do i = 1, E_grid
            omega = E_array(i)
   	        greeng1 =  1.d0 / (omega + chem - En2(alpha1) + Em1(alpha2)) 
	        greeng2 =  1.d0 / (omega + chem - En2(alpha1) + Em1(alpha2) + (0.D0,1.D0)*damp)
            Green(ms1, ms2, i)  = Green(ms1, ms2, i) + matrele * greeng1
            Green1(ms1, ms2, i) = Green1(ms1, ms2, i) + matrele * Real(greeng2)
            Green2(ms1, ms2, i) = Green2(ms1, ms2, i) + matrele * imag(greeng2)
          end do
          do iMom= -mor, mor
            Ediff = En2(alpha1) - Em1(alpha2) - Chem
            if(abs(Ediff) > 1.D-14) Edifm = Ediff**iMom
            if(abs(Ediff) <= 1.D-14 .and. iMom /= 0) Edifm=0.d0
            if(abs(Ediff) <= 1.D-14 .and. iMom == 0) Edifm=1.d0
            Mom(ms1,ms2,iMom) = Mom(ms1,ms2,iMom) +  matrele * Edifm 
            Den(ms1,ms2,iMom) = Den(ms1,ms2,iMom) +  matreld * Edifm 
          end do
        end do
	  end do
    end do
  end do
  deallocate (MAT3)
  end if
  
!------------------------------------------------------------------------------------------  
  deallocate (Em1)
  deallocate (En1)
  deallocate (Xm1)  
  deallocate (Xn1)
  deallocate (act_pointern)
  deallocate (act_pointerm)
  
  if (subm2 /= 0) then
  deallocate (Em2)   
  deallocate (Xm2)  
  end if
  
  if (subn2 /= 0) then
  deallocate (En2) 
  deallocate (Xn2)  
  end if

end do !--end loop over number of electrons----------------------------

deallocate (SCMAT)
deallocate (DCMAT)
deallocate (Locc2)

open (unit=channel(1), file=filename(1), form='UNFORMATTED')
open (unit=channel(2), file=filename(2), form='UNFORMATTED')
open (unit=channel(3), file=filename(3), form='UNFORMATTED')
close(channel(1), status='DELETE')
close(channel(2), status='DELETE')
close(channel(3), status='DELETE')
open (unit=channel(1), file=filename(1)//"index1_tmp.bin", form='UNFORMATTED')
open (unit=channel(2), file=filename(1)//"index2_tmp.bin", form='UNFORMATTED')
close(channel(1), status='DELETE')
close(channel(2), status='DELETE')

write (channel(6),*) 'Green function finished'

!--compute DOS--------------------------------------------------------------------------
write (channel(6),*) 'Start computing DOS...'
do i = 1, E_grid 
  do ms1=0, N-1
    DOS(i) = DOS(i)  - real(Green2(ms1,ms1,i))
  end do
end do 
write (channel(6),*) 'DOS finished'

!----calculate self-energy----------------------------------------------------------------
write (channel(6),*) 'Start calculating self-energy...'

allocate (Sigma(0:N-1,0:N-1))
allocate (IU(0:N-1,0:N-1))
IU = (0.D0,0.D0)
allocate (Ec(0:N-1, 0:N-1))
Ec = (0.D0,0.D0)

do ms1 = 0, N-1
  IU(ms1, ms1) = (1.D0,0.D0)
end do

Ec(0:Ns-1, 0:Ns-1) = Es
Ec(Ns:N-1, Ns:N-1) = Ed
do ms1 = Ns, N-1
  do ms2 = 0, Ns-1
    Ec(ms1, ms2) = V(ms1 - Ns, ms2)
    Ec(ms2, ms1) = conjg(V(ms1 - Ns, ms2))
  enddo
enddo

allocate (G_inv(0:N-1,0:N-1))
allocate (R(N))

do i = 1, E_grid            
  omega = E_array(i)
  G_inv(0:N-1,0:N-1) = Green(0:N-1,0:N-1,i)
  call LIB_CINV(N, G_inv, N, R, IFAIL)
  Sigma = (0.D0,0.D0) 
  do ms1 = 0, N-1
    do ms2 = 0, N-1
	  Sigma(ms1,ms2) = omega*IU(ms1,ms2) + Chem*IU(ms1,ms2) - Ec(ms1,ms2) - G_inv(ms1,ms2)
	end do
  end do
  Self_E(0:N-1,0:N-1,i) = Sigma
end do          

deallocate(Sigma)
deallocate(Green)
deallocate(G_inv)
deallocate(R)

Self_Einf = Mom(0:N-1, 0:N-1, 1) - Ec + chem * IU

deallocate(Ec)
deallocate (IU)

write (channel(6),*) 'Self-energy finished'

end




