subroutine cls_Hamiltonian2(in, Ns, Nd, dim1, Ecls1, cin1, ndmin, ndmax, nsmin, nsmax, VMAT, H, channel, filename)

implicit none

integer in
integer Ns
integer Nd
integer dim1
real*8 Ecls1(dim1)
integer cin1(dim1, 6)
integer ndmin, ndmax
integer nsmin, nsmax
complex*16 VMAT(0:Nd-1, 0:Ns-1)
complex*16 H(dim1, dim1)
integer channel(6)
character (len = 130) filename(5)

integer dummy
integer i, j, is, js
integer ind, ins
integer ind1, ind2, ins1, ins2
integer nd1, nd2, ns1, ns2
integer ms, ks
integer mu, nu
integer alpha1, alpha2, beta1, beta2
integer subdim_impmax
integer subdim_bathmax
integer subd, subs
integer subm, subn
complex*16, allocatable :: DCMAT(:, :, :, :)
integer, allocatable :: SDMAT(:, :, :, :)
complex*16, allocatable :: Hsd(:,:)

integer,external :: cls_opsign
integer,external :: cls_spind
integer,external :: cls_spins
real*8,external :: cls_SLM
real*8,external :: cls_combination


subdim_impmax = 0
do ind = ndmin, ndmax
  subd = nint(cls_combination(ind, Nd))
  if ( subd > subdim_impmax) subdim_impmax = subd
end do

subdim_bathmax = 0
do ins = nsmin, nsmax
  subs = nint(cls_combination(ins, Ns))
  if (subs> subdim_bathmax) subdim_bathmax = subs
end do  

allocate (DCMAT(subdim_impmax, subdim_impmax, 0:Nd-1, ndmin+1:ndmax))
allocate (SDMAT(subdim_bathmax, subdim_bathmax, 0:Ns-1, nsmin:nsmax-1))
DCMAT = (0.D0, 0.D0)
SDMAT = 0

open (unit = channel(5), file = filename(1)//"dcmat.bin", form = "UNFORMATTED")
do ind = ndmin+1, ndmax
  subn = nint(cls_combination(ind, Nd))
  subm = nint(cls_combination(ind-1, Nd))
  do ms = 0, Nd-1
    do alpha2 = 1, subm
      do alpha1 = 1, subn
        read (channel(5)) DCMAT(alpha1, alpha2, ms, ind)
      end do
    end do
  end do
end do
close (channel(5))

open (unit = channel(5), file = filename(1)//"sdmat.bin", form = "UNFORMATTED")
do ins = nsmin, nsmax-1
  subm = nint(cls_combination(ins, Ns))
  subn = nint(cls_combination(ins+1, Ns))
  do ks = 0, Ns-1
    do beta2 = 1, subn
      do beta1 = 1, subm
        read (channel(5)) SDMAT(beta1, beta2, ks, ins)
      end do
    end do
  end do
end do
close (channel(5))

allocate(Hsd(dim1, dim1))
Hsd = (0.D0,0.D0)
do i =1, dim1
  ind1 = cin1(i, 1)
  ins1 = cin1(i, 2)
  alpha1 = cin1(i, 3)
  beta1 = cin1(i, 4)
  do j=1, i
    ind2 = cin1(j, 1)
    ins2 = cin1(j, 2)
    alpha2 = cin1(j, 3)
    beta2 = cin1(j, 4)
    if (ind1 /= ind2 + 1) cycle
    if (ins1 /= ins2 - 1) cycle
    do ms = 0, Nd-1
      do ks = 0, Ns-1
        Hsd(i, j) = Hsd(i, j) + ((-1)**ins2) * VMAT(ms, ks) * DCMAT(alpha1, alpha2, ms, ind1) * SDMAT(beta1, beta2, ks, ins1)
      end do
    end do
    if (i == j) cycle
    Hsd(j, i) = conjg(Hsd(i, j))
  end do
end do

deallocate (DCMAT)
deallocate (SDMAT)

H = (0.D0,0.D0)
do i = 1, dim1
  H(i,i) = Ecls1(i)
end do

H = H + Hsd

deallocate (Hsd)

end