subroutine cls_imp(Nd, totdim_imp, Ed, U, B1, B2, SOC, ndmin, ndmax, Eimp, channel, filename)

implicit none

integer Nd
integer totdim_imp
complex*16 Ed(Nd, Nd)
real*8 U(Nd/2,Nd/2,Nd/2,Nd/2)
real*8 B1
real*8 B2
real*8 Soc
integer ndmin
integer ndmax
real*8 Eimp(totdim_imp)
integer channel(6) 
character (len=130) filename(5)

integer, allocatable :: comb(:)
integer, allocatable :: phi(:)
integer, allocatable :: invphi(:)
complex*16, allocatable :: D(:,:)
complex*16, allocatable :: D1(:,:)
complex*16, allocatable :: D2(:,:)
integer, allocatable :: IMATC(:,:,:)
complex*16,allocatable :: AW(:,:)
complex*16, allocatable :: DCMAT(:,:,:)
real*8, allocatable :: E(:)
integer precont
integer i, j, k
integer ms
integer kapa1, kapa2, alpha1, alpha2
integer ind
integer subdim
integer subn, subm
integer inp
integer phiket
real*8, external :: cls_combination
integer, external :: cls_occnum
integer, external :: cls_opsign


allocate (comb(-1:Nd))
call cls_getcomb(comb, Nd)

allocate (phi(2**Nd))
allocate (invphi(0:2**Nd))
phi = 0
invphi = 0
j = 1
do ind = 0, Nd
  do i = 0, 2**Nd-1
     if (cls_occnum(i, Nd) /= ind) cycle
     phi(j) = i
     invphi(i) = j
     j = j+1
   end do
end do

open (unit=channel(1), file=filename(1)//"impvec.bin", form='UNFORMATTED')

Eimp = 0.D0
k = 1

do ind = ndmin, ndmax
  
  subdim = nint(cls_combination(ind, Nd))
  inp = comb(ind-1) + 1
  precont = comb(ind-1)
  
  allocate (E(subdim))
  allocate (D(subdim, subdim))
  call cls_impdiag(Nd, Ed, U, B1, B2, SOC, subdim, E, D, phi(inp), invphi, precont)
  
  do j = 1, subdim
    Eimp(k) = E(j)
    k = k + 1
    do i = 1, subdim
      write (channel(1)) D(i,j)
    end do
  end do
  
  deallocate (E)
  deallocate (D)
  
end do

close(channel(1))


open (unit=channel(1), file=filename(1)//"impvec.bin", form='UNFORMATTED')
do ind = ndmin, ndmax
  subdim = nint(cls_combination(ind, Nd))
  allocate (D2(subdim, subdim))
  do j = 1, subdim
    do i = 1, subdim
      read (channel(1)) D2(i,j)
    end do
  end do
  exit
end do

open (unit=channel(2), file=filename(1)//"dcmat.bin", form='UNFORMATTED')

do ind = ndmin+1, ndmax
  
  subn = nint(cls_combination(ind, Nd))
  subm = nint(cls_combination(ind-1, Nd))
  
  allocate (IMATC(subn, subm, 0:Nd-1))
  IMATC = 0
  do ms = 0, Nd-1
    do kapa2 = 1, subm
	   inp = comb(ind-2) + kapa2
       phiket = phi(inp)
	   if (btest(phiket,ms)) cycle
       phiket = ibset(phiket, ms)
	   kapa1 = invphi(phiket) - comb(ind-1)
	   IMATC(kapa1,kapa2,ms) = cls_opsign(ms, phiket)
	end do
  end do
  
  allocate (DCMAT(subn, subm, 0:Nd-1))
  DCMAT = (0.D0, 0.D0)
  allocate (D1(subn, subn))
  do j = 1, subn
    do i = 1, subn
      read (channel(1)) D1(i,j)
    end do
  end do
 
  allocate (AW(subm, subn))
 
  do ms = 0, Nd-1
    AW = (0.D0, 0.D0)
    do kapa2 = 1, subm
      do alpha1 = 1, subn
        do kapa1 = 1, subn
        AW(kapa2, alpha1) = AW(kapa2, alpha1) + conjg(D1(kapa1,alpha1)) * IMATC(kapa1, kapa2, ms)
        end do
      end do
    end do
    do alpha2 = 1, subm
      do alpha1 = 1, subn
        do kapa2 = 1, subm
        DCMAT(alpha1, alpha2, ms) = DCMAT(alpha1, alpha2, ms) + AW(kapa2, alpha1) * D2(kapa2, alpha2)
        end do
        write (channel(2)) DCMAT(alpha1, alpha2, ms)
      end do
    end do
  end do
  deallocate (AW)
  deallocate (D2)
  allocate (D2(subn, subn))
  D2 = D1
  deallocate (D1)
  deallocate (IMATC)
  deallocate (DCMAT)
end do


deallocate (D2)
deallocate (phi)
deallocate (invphi)
deallocate (comb)

close(channel(1), status='DELETE')
close(channel(2))

end

!---------------------------------------------------------------------------------------------------------------------------------------------
subroutine cls_impdiag(Nd, Ed, U, B1, B2, SOC, subdim, E, D, phi, invphi, precont)

implicit none

integer Nd
complex*16 Ed(0:Nd-1, 0:Nd-1)
real*8 U(0:Nd/2-1, 0:Nd/2-1, 0:Nd/2-1, 0:Nd/2-1)
real*8 B1
real*8 B2
real*8 Soc
integer subdim
real*8 E(subdim)
complex*16 D(subdim, subdim)
integer phi(subdim)
integer invphi(0:2**Nd)
integer precont

integer dummy1, dummy2, dummy3, dummy4
integer Ld
integer sign, sign1, sign2, sign3, sign4
integer i, j
integer m1, m2, k1, k2, m
integer ms1, ms2, ks1, ks2, ms
integer spin1, spin2, spin
integer ipr
complex*16, allocatable :: H(:,:)
complex*16, allocatable :: H0d(:,:)
complex*16, allocatable :: Hdd(:,:)
complex*16, allocatable :: Hmag(:,:)
complex*16, allocatable :: Hsoc(:,:)

integer,external :: cls_opsign
integer,external :: cls_spind
real*8,external :: cls_SLM

Ld = (Nd - 2) / 4
ipr = Nd/2 - 1

allocate(H0d(subdim, subdim))
H0d = (0.D0,0.D0)
do j = 1, subdim
  do ms2 = 0, Nd-1
    if (.NOT.btest(phi(j),ms2)) cycle
	dummy1 = phi(j)
    dummy1 = ibclr(dummy1,ms2)
	sign2 = cls_opsign(ms2,dummy1)
	do ms1 = 0, Nd-1
	   if (btest(dummy1,ms1)) cycle
	   dummy2 = dummy1
	   dummy2 = ibset(dummy2,ms1)
	   sign1 = cls_opsign(ms1,dummy2)
	   sign = sign1 * sign2
	   if (invphi(dummy2) == 0) cycle
	   i = invphi(dummy2) - precont
	   H0d(i,j) = H0d(i,j) + sign * Ed(ms1,ms2)
    end do
  end do
end do


allocate(Hdd(subdim, subdim))
Hdd = (0.D0,0.D0)
do j = 1, subdim
  do ks1 = 0, Nd-1
    if (.NOT.btest(phi(j),ks1)) cycle
	dummy1 = phi(j)
	dummy1 = ibclr(dummy1,ks1)
	sign1 = cls_opsign(ks1,dummy1)
	do ks2 = 0, Nd-1
	  if (.NOT.btest(dummy1,ks2)) cycle
      dummy2 = dummy1
	  dummy2 = ibclr(dummy2,ks2)
	  sign2 = cls_opsign(ks2,dummy2)
	  do ms2 = 0, Nd-1
	  	if (cls_spind(ms2,ipr) /= cls_spind(ks2,ipr)) cycle
		if (btest(dummy2,ms2)) cycle
		dummy3 = dummy2
		dummy3 = ibset(dummy3,ms2)
		sign3 = cls_opsign(ms2,dummy3)
	    do ms1 = 0, Nd-1
		  if (cls_spind(ms1,ipr) /= cls_spind(ks1,ipr)) cycle
		  if (btest(dummy3,ms1)) cycle
		  dummy4 = dummy3
		  dummy4 = ibset(dummy4,ms1)
		  sign4 = cls_opsign(ms1,dummy4)
		  sign = sign1 * sign2 * sign3 * sign4
		  m1 = mod((ms1), (Nd/2))
		  k1 = mod((ks1), (Nd/2))
		  m2 = mod((ms2), (Nd/2))
		  k2 = mod((ks2), (Nd/2))
		  i = invphi(dummy4) - precont
          Hdd(i,j) = Hdd(i,j) + sign * 0.5 * U(m1,k1,m2,k2)
		end do
	  end do
	end do
  end do
end do

allocate(Hmag(subdim, subdim))
Hmag= (0.D0,0.D0)
do i = 1, subdim
  do ms = 0, Nd-1
    if (btest(phi(i),ms)) then
    spin = cls_spind(ms, ipr)
    m = mod((ms), (Nd/2)) - Ld
	Hmag(i,i) = Hmag(i,i) - B1*spin - B2*m
	end if
  end do
end do

allocate(Hsoc(subdim, subdim))
Hsoc= (0.D0,0.D0)
do j = 1, subdim
  do ms2 = 0, Nd-1
    if (.NOT.btest(phi(j),ms2)) cycle
	dummy1 = phi(j)
    dummy1 = ibclr(dummy1,ms2)
	sign2 = cls_opsign(ms2,dummy1)
	do ms1 = 0, Nd-1
	  if (btest(dummy1,ms1)) cycle
	  dummy2 = dummy1
	  dummy2 = ibset(dummy2,ms1)
	  sign1 = cls_opsign(ms1,dummy2)
	  sign = sign1 * sign2
	  if (invphi(dummy2) == 0) cycle
	  i = invphi(dummy2) - precont
	  m1 = mod((ms1), (Nd/2)) - Ld
	  m2 = mod((ms2), (Nd/2)) - Ld
	  spin1 = cls_spind(ms1,ipr)
	  spin2 = cls_spind(ms2,ipr)
	  Hsoc(i,j) = Hsoc(i,j) + sign * cls_SLM(Ld, m1, m2, spin1, spin2)*SOC
	end do
  end do
end do

allocate(H(subdim, subdim))
H = (0.D0,0.D0)
H = H0d + Hdd + Hmag + Hsoc
deallocate(H0d)
deallocate(Hdd)
deallocate(Hsoc)
deallocate(Hmag)
D = (0.D0,0.D0)
call cls_exactdiag(subdim, H, D, E) 

deallocate (H)

end