      SUBROUTINE CLS_SHELLS_XNOT(NDEG,NCLS,
     &           SPEC,CHEM,TEMP,XHUB,LOCC,fcontin)
*******************************************************
*  Finds correlational functions for an atom          *
*******************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER, ALLOCATABLE :: IATM(:)
	REAL*8, ALLOCATABLE :: EATM(:)
	REAL*8, ALLOCATABLE :: XATM(:)
	INTEGER LOCC(0:NDEG)
	integer fcontin(0:NDEG)
	REAL*8 XHUB(NCLS),SPEC(NCLS),COMB(0:NDEG,0:NDEG)
	DATA EPS/1.D-05/
	ALLOCATE(EATM(NCLS))
	ALLOCATE(XATM(NCLS))
	ALLOCATE(IATM(NCLS))
C Order atomic states in increasing order
	DO IDIM=1,NCLS
	EATM(IDIM)=0.D0
	XATM(IDIM)=0.D0
	XHUB(IDIM)=0.D0
	IATM(IDIM)=0
	ENDDO
	MDIM=0
	DO NOCC=0,NDEG
	IF(LOCC(NOCC).EQ.0)CYCLE
	NFOC = fcontin(nocc)
	MDIM=MDIM+NFOC
	DO IFOC=1,NFOC
	IDIM=IFOC+MDIM-NFOC
	EATM(IDIM)=SPEC(IDIM)-CHEM*DBLE(NOCC)
	IATM(IDIM)=IDIM
	ENDDO
	ENDDO
C Sort atomic energies in increasing order
      DO ISTR=1,NCLS
	IF(IATM(ISTR).EQ.0)CYCLE
      DO JSTR=ISTR+1,NCLS
	IF(IATM(JSTR).EQ.0)CYCLE
	IF(EATM(ISTR).GT.EATM(JSTR))THEN
	S=EATM(ISTR)
	EATM(ISTR)=EATM(JSTR)
	EATM(JSTR)=S
	I=IATM(ISTR)
	IATM(ISTR)=IATM(JSTR)
	IATM(JSTR)=I
	ENDIF
	ENDDO
	ENDDO
C In this ordering scheme we can loop forward only
	IF(TEMP.GT.0.D0)THEN
      DO ISTR=1,NCLS-1
	IF(IATM(ISTR).EQ.0)CYCLE
      XATM(ISTR)=1.D0
	EXIT
	ENDDO
      DO ISTR=1,NCLS-1
	IF(IATM(ISTR+1).EQ.0.OR.IATM(ISTR).EQ.0)CYCLE
      E=EATM(ISTR+1)-EATM(ISTR)
      XATM(ISTR+1)=SAFEEXP(-E/TEMP)*XATM(ISTR)
      ENDDO
C If temperature is zero, only first states survive
	ELSEIF(TEMP.EQ.0.D0)THEN
      DO ISTR=1,NCLS-1
	IF(IATM(ISTR).EQ.0)CYCLE
      XATM(ISTR)=1.D0
	EXIT
	ENDDO
      DO ISTR=1,NCLS-1
	IF(IATM(ISTR+1).EQ.0.OR.IATM(ISTR).EQ.0)CYCLE
      E=EATM(ISTR+1)-EATM(ISTR)
      IF(ABS(E).LE.EPS)XATM(ISTR+1)=XATM(ISTR)
	IF(ABS(E).GT.EPS)XATM(ISTR+1)=0.D0
      ENDDO
	ENDIF
C Reorder
	DO ISTR=1,NCLS
	IF(IATM(ISTR).EQ.0)CYCLE
	JDIM=(IATM(ISTR)-1)/NCLS+1
	IDIM=IATM(ISTR)
	XHUB(IDIM)=XATM(ISTR)
	ENDDO
C Renormalize 
      XSUM=0.D0
      DO IDIM=1,NCLS
      XSUM=XSUM+XHUB(IDIM)
      ENDDO
      DO IDIM=1,NCLS
      XHUB(IDIM)=XHUB(IDIM)/XSUM
      ENDDO
C Check
	XSUM=0.D0
	DO IDIM=1,NCLS
	XSUM=XSUM+XHUB(IDIM)
	ENDDO
	IF(ABS(XSUM-1.D0).GT.1.D-10)
     &CALL FULLSTOP('<RAT_SHELLS_XNOT>:: Normalization error')
	DEALLOCATE(EATM,XATM,IATM)
	RETURN
	END
