	SUBROUTINE DEL_D2INTPAR(MY1,INUC,IPAN,IQPNT)
***********************************************************
*  Calculates contribution to the change in the           *
*  interstitial potential matrix elements from k=0        *
*  and large vectors G.                                   *
***********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                               !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                  !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,NATOM,NSPIN,NORBS !!! from readini
	USE COM_LATTICE, ONLY : TAU                                  !!! from readstr
	USE COM_QMESH,   ONLY : NQPNT,QPNT                           !!! from readpnt
	USE COM_PANPAR,  ONLY : LTPAN,LSPAN,IATS,ISTS                !!! from readini
	USE COM_KAPPAR,  ONLY : NPAN,NKAP,EK,EKAP                    !!! from readini
	USE COM_PLWMESH, ONLY : NPLW,GPLW                            !!! from makeplw
	USE COM_SPHERE,  ONLY : SWZ,SMT                              !!! from readini
	USE COM_KMESH,   ONLY : NPNT,PNT                             !!! from makettr
	USE COM_LATPAR,  ONLY : PAR,ORTH,OMEGAC                      !!! from readini
	USE COM_NBANDS,  ONLY : NBNDF,NBNDE,NBNDT,NBNDH              !!! from readini
	USE COM_ETAPAR,  ONLY : ETA,CUT,LBAS,NBAS                    !!! from makeplw
	USE COM_INPTTR,  ONLY : NDIV,NDIW                            !!! from readini
	USE COM_POTDAT,  ONLY : POTPS,POTPS1                         !!! from fulpot
	USE COM_DELPOT,  ONLY : DPOTPS,DPOTPS1                       !!! from delpot
	USE COM_TEILORG, ONLY : KEYT,BZM,GOPT,MBAS                   !!! from makeplw
	USE COM_INDORB,  ONLY : INDLMT                               !!! from readini
	USE COM_LMTOUT,  ONLY : SCRFILE                              !!! from setup
	USE COM_PHNCHN  ,ONLY : IUDYN                                !!! from channels
	USE COM_MASHDEP, ONLY : NVAL                                 !!! from setup
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                      !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: DXFUN0(:,:)
	COMPLEX*16, ALLOCATABLE :: DXFUNQ(:,:)
	COMPLEX*16, ALLOCATABLE :: DVINT0(:,:)
	COMPLEX*16, ALLOCATABLE :: DVINTQ(:,:)
	COMPLEX*16, ALLOCATABLE :: YLM0(:,:)
	COMPLEX*16, ALLOCATABLE :: CFTR0(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: YLMQ(:,:)
	COMPLEX*16, ALLOCATABLE :: CFTRQ(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: CHI0(:)
	COMPLEX*16, ALLOCATABLE :: RHI0(:)
	COMPLEX*16, ALLOCATABLE :: CON0(:)
	COMPLEX*16, ALLOCATABLE :: CHIQ(:)
	COMPLEX*16, ALLOCATABLE :: RHIQ(:)
	COMPLEX*16, ALLOCATABLE :: CONQ(:)
	COMPLEX*16, ALLOCATABLE :: EXP0(:)
	COMPLEX*16, ALLOCATABLE :: EXPQ(:)
	COMPLEX*16, ALLOCATABLE :: EXS0(:)
	COMPLEX*16, ALLOCATABLE :: EXSQ(:)
	COMPLEX*16 DHH0,DHHQ,GMY1,GMY0
	DIMENSION PNTR(3),PNTK(3)
	LOGICAL EXIST
	DATA PI/3.141592653589793D0/
C  OPEN SCRATCH FILE FOR STORING POTENTIAL PARAMETERS
	INQUIRE(FILE=SCRFILE(IUDYN),EXIST=EXIST)
	IF(.NOT.EXIST)THEN
	NRECL=NVAL*(NBNDT(IPAN)*(MIN(NBAS,MBAS)+1)+
     &  NBNDT(IPAN)**2)
	OPEN(UNIT=IUDYN,FILE=SCRFILE(IUDYN),STATUS='NEW',
     &  ACCESS='DIRECT',FORM='UNFORMATTED',RECL=NRECL)
	ENDIF
	IF(KEYT.EQ.0)RETURN
	IF(MODE.NE.4)RETURN
C Memory allocations
	ALLOCATE(DXFUN0(NBNDT(IPAN),0:MBASMEM))
	ALLOCATE(DXFUNQ(NBNDT(IPAN),0:MBASMEM))
	ALLOCATE(DVINT0(NBNDT(IPAN),NBNDT(IPAN)))
	ALLOCATE(DVINTQ(NBNDT(IPAN),NBNDT(IPAN)))
	ALLOCATE(YLM0(LIMBMEM,0:NBASMEM))
	ALLOCATE(CFTR0(0:LMAXBMEM,NSORTMEM,NKAPMEM,0:NBASMEM))
	ALLOCATE(YLMQ(LIMBMEM,0:NBASMEM))
	ALLOCATE(CFTRQ(0:LMAXBMEM,NSORTMEM,NKAPMEM,0:NBASMEM))
	ALLOCATE(CHI0(0:NBASMEM))
	ALLOCATE(RHI0(0:NBASMEM))
	ALLOCATE(CON0(0:NBASMEM))
	ALLOCATE(CHIQ(0:NBASMEM))
	ALLOCATE(RHIQ(0:NBASMEM))
	ALLOCATE(CONQ(0:NBASMEM))
	ALLOCATE(EXP0(0:NBASMEM))
	ALLOCATE(EXPQ(0:NBASMEM))
	ALLOCATE(EXS0(0:NBASMEM))
	ALLOCATE(EXSQ(0:NBASMEM))
	LMB=0
	DO ISORT=1,NSORT
	DO IKAP=1,NKAP(IPAN)
	DO L=0,ILSB(ISORT)
	IF(LSPAN(L,ISORT,IKAP,IPAN))LMB=MAX(L,LMB)
	ENDDO
	ENDDO
	ENDDO
C  SET PSEUDOLMTOS FOR THE POINT IPNTK
	PNTK(1)=QPNT(1,IQPNT)
	PNTK(2)=QPNT(2,IQPNT)
	PNTK(3)=QPNT(3,IQPNT)
	CALL BND_FTRMAT(PNTK,1,IPAN,PNTR,YLM0,CFTR0)
	DO IBAS=0,NBAS
	DO L=0,LMB
	DO M=-L,L
	LM=L*(L+1)+M+1
	YLMQ(LM,IBAS)=YLM0(LM,IBAS)
	ENDDO
	ENDDO
	ENDDO
	DO ISORT=1,NSORT                  !!! over isort
	DO IKAP=1,NKAP(IPAN)              !!! over ikap
	DO L=0,ILSB(ISORT)                !!! over l
	DO IBAS=0,LBAS(L,ISORT,IKAP,IPAN) !!! over ibas
	CFTRQ(L,ISORT,IKAP,IBAS)=CFTR0(L,ISORT,IKAP,IBAS)
	ENDDO                             !!! over ibas
	ENDDO                             !!! over l
	ENDDO                             !!! over ikap
	ENDDO                             !!! over isort
C  SET PSEUDOLMTOS FOR THE POINT IPNTK
	PNTK(1)=0.D0
	PNTK(2)=0.D0
	PNTK(3)=0.D0
	CALL BND_FTRMAT(PNTK,1,IPAN,PNTR,YLM0,CFTR0)
C  DO OVER SPINS
	DO 3000 IORBS=1,NORBS                                     !!! over iorbs
	DO 2000 IUPDN=1,NSPIN                                     !!! over iupdn
 	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
C  ####################################################
C  FIRST-ORDER DERIVATIVES
C  ####################################################
	DO 1000 MY0=-1,1                  !!! over polarizations
	DO IATOM1=1,NATOM                 !!! over iatom1
	ISORT1=IS(IATOM1)
C  CALCULATE EXPONENTIAL FACTOR
	DO IBAS=0,NBAS
	SCP=(GPLW(1,IBAS)+PNTK(1))*TAU(1,IATOM1)+
     &    (GPLW(2,IBAS)+PNTK(2))*TAU(2,IATOM1)+
     &    (GPLW(3,IBAS)+PNTK(3))*TAU(3,IATOM1)
	EXP0(IBAS)=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	SCP=(GPLW(1,IBAS)+QPNT(1,IQPNT))*TAU(1,IATOM1)+
     &    (GPLW(2,IBAS)+QPNT(2,IQPNT))*TAU(2,IATOM1)+
     &    (GPLW(3,IBAS)+QPNT(3,IQPNT))*TAU(3,IATOM1)
	EXPQ(IBAS)=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	ENDDO
	DO IKAP1=1,NKAP(IPAN)             !!! over energy
	DO L1=0,ILSB(ISORT1)              !!! over l1
	DO M1=-L1,L1                      !!! over m1
	IF(.NOT.LTPAN(L1,IATOM1,IKAP1,IPAN))EXIT
	L1M1=L1*(L1+1)+M1+1
	IPAR1=INDLMT(L1M1,IATOM1,IKAP1,1,IPAN)
	DO IBAS=0,LBAS(L1,ISORT1,IKAP1,IPAN)! NG_1
C  FOURIER TRANSFORM OF THE PSEUDOORBITAL
	CHI0(IBAS)=CFTR0(L1,ISORT1,IKAP1,IBAS)*
     &  YLM0(L1M1,IBAS)*EXP0(IBAS)
	CHIQ(IBAS)=DCONJG(CFTRQ(L1,ISORT1,IKAP1,IBAS)*
     &  YLMQ(L1M1,IBAS)*EXPQ(IBAS))
	ENDDO
C  DERIVATIVES OF THE PSEUDOORBITALS
	DO IBAS=0,LBAS(L1,ISORT1,IKAP1,IPAN)! NG_1
	GX=PNTK(1)+GPLW(1,IBAS)
	GY=PNTK(2)+GPLW(2,IBAS)
	GZ=PNTK(3)+GPLW(3,IBAS)
	IF(MY0.EQ.-1)GMY0=+1.D0/SQRT(2.D0)*(GX-(0.D0,1.D0)*GY)
	IF(MY0.EQ.+1)GMY0=-1.D0/SQRT(2.D0)*(GX+(0.D0,1.D0)*GY)
	IF(MY0.EQ. 0)GMY0=GZ
	RHI0(IBAS)=(0.D0,-1.D0)*GMY0*2.D0*PI/PAR*CHI0(IBAS)
	ENDDO
	DO IBAS=0,LBAS(L1,ISORT1,IKAP1,IPAN)! NG_1
	GX=QPNT(1,IQPNT)+GPLW(1,IBAS)
	GY=QPNT(2,IQPNT)+GPLW(2,IBAS)
	GZ=QPNT(3,IQPNT)+GPLW(3,IBAS)
	IF(-MY0.EQ.-1)GMY0=+1.D0/SQRT(2.D0)*(GX-(0.D0,1.D0)*GY)
	IF(-MY0.EQ.+1)GMY0=-1.D0/SQRT(2.D0)*(GX+(0.D0,1.D0)*GY)
	IF(-MY0.EQ. 0)GMY0=GZ
	RHIQ(IBAS)=(-1)**MY0*DCONJG((0.D0,-1.D0)*GMY0)*
     &  2.D0*PI/PAR*CHIQ(IBAS)
	ENDDO
C  CONVOLUTION OF THE PSEUDOORBITAL WITH THE PSEUDOPOTENTIAL
      CALL BND_CONVOL1(DPOTPS1(0,IUPDN,IORBS),RHI0(0),CON0(0),'R',
     &               0,NBAS,MBAS+1,LBAS(L1,ISORT1,IKAP1,IPAN))
      CALL BND_CONVOL1(DPOTPS1(0,IUPDN,IORBS),RHIQ(0),CONQ(0),'L',
     &               0,NBAS,MBAS+1,LBAS(L1,ISORT1,IKAP1,IPAN))
	DO IBAS=0,MIN(NBAS,MBAS)          !!! NGMAX{small}
	DXFUN0(IPAR1,IBAS)=CON0(IBAS)     !!! D{m0}dX0/d{t1m1}
	DXFUNQ(IPAR1,IBAS)=CONQ(IBAS)     !!! D{m0}dYq/d{t1m1}
	ENDDO
C  DO OVER RIGHT INDEX
	DO IATOM=1,NATOM                  !!! over iatom
	ISORT=IS(IATOM)
C  CALCULATE EXPONENTIAL FACTOR
	DO IBAS=0,NBAS                    !!! NGMAX{large}
	SCP=(GPLW(1,IBAS)+PNTK(1))*TAU(1,IATOM)+
     &    (GPLW(2,IBAS)+PNTK(2))*TAU(2,IATOM)+
     &    (GPLW(3,IBAS)+PNTK(3))*TAU(3,IATOM)
	EXS0(IBAS)=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	SCP=(GPLW(1,IBAS)+QPNT(1,IQPNT))*TAU(1,IATOM)+
     &    (GPLW(2,IBAS)+QPNT(2,IQPNT))*TAU(2,IATOM)+
     &    (GPLW(3,IBAS)+QPNT(3,IQPNT))*TAU(3,IATOM)
	EXSQ(IBAS)=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	ENDDO
	DO IKAP=1,NKAP(IPAN)              !!! over energy
	DO L=0,ILSB(ISORT)                !!! over l
	DO M=-L,L                         !!! over m
	IF(.NOT.LTPAN(L,IATOM,IKAP,IPAN))EXIT
	LM=L*(L+1)+M+1
	IPAR=INDLMT(LM,IATOM,IKAP,1,IPAN)
C  FOURIER TRANSFORM OF THE PSEUDOORBITAL
	DO IBAS=MBAS+1,LBAS(L,ISORT,IKAP,IPAN)  !!! NG_0{large}
	CHI0(IBAS)=CFTR0(L,ISORT,IKAP,IBAS)*
     &  YLM0(LM,IBAS)*EXS0(IBAS)
	CHIQ(IBAS)=DCONJG(CFTRQ(L,ISORT,IKAP,IBAS)*
     &  YLMQ(LM,IBAS)*EXSQ(IBAS))
	ENDDO
C  ******** PSEUDOPOTENTIAL MATRIX ************
C     CONTRIBUTION FROM LARGE G, K-DEPENDENCE BY TEILOR WILL BE USED
	DHH0=(0.D0,0.D0)
	DHHQ=(0.D0,0.D0)
	DO IBAS=MBAS+1,LBAS(L,ISORT,IKAP,IPAN)  !!! NG_0{large}
	DHH0=DHH0+CONQ(IBAS)*CHI0(IBAS)         !!! {m0}DdV0/d{t1m1}
	DHHQ=DHHQ+CHIQ(IBAS)*CON0(IBAS)         !!! D{m0}dVq/d{t1m1}
	ENDDO
	DVINT0(IPAR1,IPAR)=DHH0
	DVINTQ(IPAR,IPAR1)=DHHQ
	ENDDO                             !!! over m
	ENDDO                             !!! over l
	ENDDO                             !!! over energy
	ENDDO                             !!! over iatom
	ENDDO                             !!! over m1
	ENDDO                             !!! over l1
	ENDDO                             !!! over energy
	ENDDO                             !!! over iatom1
C  STORE DATA
	IREC=1+2*(MY0+1)+6*(IUPDN-1)+6*NSPIN*(IORBS-1) !!! D{m0}dX0/d{t1m1}, {m0}DdV0/d{t1m1}
	WRITE(IUDYN,REC=IREC)((DVINT0(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DXFUN0(IPAR1,
     &  IBAS),IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
	IREC=2+2*(MY0+1)+6*(IUPDN-1)+6*NSPIN*(IORBS-1) !!! D{m0}dYq/d{t1m1},D{m0}dVq/d{t1m1}
	WRITE(IUDYN,REC=IREC)((DVINTQ(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DXFUNQ(IPAR1,
     &  IBAS),IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
1000  CONTINUE                          !!! over my0
2000  CONTINUE                          !!! over iupdn
3000  CONTINUE                          !!! over iorbs
C  ####################################################
C  SECOND-ORDER DERIVATIVES
C  ####################################################
C  DO OVER SPINS
	DO 6000 IORBS=1,NORBS                                     !!! over iorbs
	DO 5000 IUPDN=1,NSPIN                                     !!! over iupdn
 	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
	DO 4000 MY0=-1,1                  !!! over polarizations
	DO IATOM1=1,NATOM                 !!! over iatom1
	ISORT1=IS(IATOM1)
C  CALCULATE EXPONENTIAL FACTOR
	DO IBAS=0,NBAS
	SCP=(GPLW(1,IBAS)+PNTK(1))*TAU(1,IATOM1)+
     &    (GPLW(2,IBAS)+PNTK(2))*TAU(2,IATOM1)+
     &    (GPLW(3,IBAS)+PNTK(3))*TAU(3,IATOM1)
	EXP0(IBAS)=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	SCP=(GPLW(1,IBAS)+QPNT(1,IQPNT))*TAU(1,IATOM1)+
     &    (GPLW(2,IBAS)+QPNT(2,IQPNT))*TAU(2,IATOM1)+
     &    (GPLW(3,IBAS)+QPNT(3,IQPNT))*TAU(3,IATOM1)
	EXPQ(IBAS)=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	ENDDO
	DO IKAP1=1,NKAP(IPAN)             !!! over energy
	DO L1=0,ILSB(ISORT1)              !!! over l1
	DO M1=-L1,L1                      !!! over m1
	IF(.NOT.LTPAN(L1,IATOM1,IKAP1,IPAN))EXIT
	L1M1=L1*(L1+1)+M1+1
	IPAR1=INDLMT(L1M1,IATOM1,IKAP1,1,IPAN)
	DO IBAS=0,LBAS(L1,ISORT1,IKAP1,IPAN)! NG_1
C  FOURIER TRANSFORM OF THE PSEUDOORBITAL
	CHI0(IBAS)=DCONJG(CFTR0(L1,ISORT1,IKAP1,IBAS)*
     &  YLM0(L1M1,IBAS)*EXP0(IBAS))
	CHIQ(IBAS)=CFTRQ(L1,ISORT1,IKAP1,IBAS)*
     &  YLMQ(L1M1,IBAS)*EXPQ(IBAS)
	ENDDO
C  DERIVATIVES OF THE PSEUDOORBITALS
	DO IBAS=0,LBAS(L1,ISORT1,IKAP1,IPAN)! NG_1
	GX=PNTK(1)+GPLW(1,IBAS)
	GY=PNTK(2)+GPLW(2,IBAS)
	GZ=PNTK(3)+GPLW(3,IBAS)
	IF(-MY1.EQ.-1)GMY1=+1.D0/SQRT(2.D0)*(GX-(0.D0,1.D0)*GY)
	IF(-MY1.EQ.+1)GMY1=-1.D0/SQRT(2.D0)*(GX+(0.D0,1.D0)*GY)
	IF(-MY1.EQ. 0)GMY1=GZ
	IF(-MY0.EQ.-1)GMY0=+1.D0/SQRT(2.D0)*(GX-(0.D0,1.D0)*GY)
	IF(-MY0.EQ.+1)GMY0=-1.D0/SQRT(2.D0)*(GX+(0.D0,1.D0)*GY)
	IF(-MY0.EQ. 0)GMY0=GZ
	RHI0(IBAS)=(-1)**(MY1+MY0)*(-1.D0)*DCONJG(GMY1*GMY0)*
     &  (2.D0*PI/PAR)**2*CHI0(IBAS)
	ENDDO
	DO IBAS=0,LBAS(L1,ISORT1,IKAP1,IPAN)! NG_1
	GX=QPNT(1,IQPNT)+GPLW(1,IBAS)
	GY=QPNT(2,IQPNT)+GPLW(2,IBAS)
	GZ=QPNT(3,IQPNT)+GPLW(3,IBAS)
	IF(MY1.EQ.-1)GMY1=+1.D0/SQRT(2.D0)*(GX-(0.D0,1.D0)*GY)
	IF(MY1.EQ.+1)GMY1=-1.D0/SQRT(2.D0)*(GX+(0.D0,1.D0)*GY)
	IF(MY1.EQ. 0)GMY1=GZ
	IF(MY0.EQ.-1)GMY0=+1.D0/SQRT(2.D0)*(GX-(0.D0,1.D0)*GY)
	IF(MY0.EQ.+1)GMY0=-1.D0/SQRT(2.D0)*(GX+(0.D0,1.D0)*GY)
	IF(MY0.EQ. 0)GMY0=GZ
	RHIQ(IBAS)=(-1.D0)*GMY1*GMY0*(2.D0*PI/PAR)**2*CHIQ(IBAS)
	ENDDO
C  CONVOLUTION OF THE PSEUDOORBITAL WITH THE PSEUDOPOTENTIAL
      CALL BND_CONVOL1(POTPS1(0,IUPDN,IORBS),RHI0(0),CON0(0),'L',
     &               0,NBAS,MBAS+1,LBAS(L1,ISORT1,IKAP1,IPAN))
      CALL BND_CONVOL1(POTPS1(0,IUPDN,IORBS),RHIQ(0),CONQ(0),'R',
     &               0,NBAS,MBAS+1,LBAS(L1,ISORT1,IKAP1,IPAN))
	DO IBAS=0,MIN(NBAS,MBAS)          !!! NGMAX{small}
	DXFUN0(IPAR1,IBAS)=CON0(IBAS)     !!! D{m1m0}Y0
	DXFUNQ(IPAR1,IBAS)=CONQ(IBAS)     !!! D{m1m0}Xq
	ENDDO
C  DO OVER RIGHT INDEX
	DO IATOM=1,NATOM                  !!! over iatom
	ISORT=IS(IATOM)
C  CALCULATE EXPONENTIAL FACTOR
	DO IBAS=0,NBAS                    !!! NGMAX{large}
	SCP=(GPLW(1,IBAS)+PNTK(1))*TAU(1,IATOM)+
     &    (GPLW(2,IBAS)+PNTK(2))*TAU(2,IATOM)+
     &    (GPLW(3,IBAS)+PNTK(3))*TAU(3,IATOM)
	EXS0(IBAS)=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	SCP=(GPLW(1,IBAS)+QPNT(1,IQPNT))*TAU(1,IATOM)+
     &    (GPLW(2,IBAS)+QPNT(2,IQPNT))*TAU(2,IATOM)+
     &    (GPLW(3,IBAS)+QPNT(3,IQPNT))*TAU(3,IATOM)
	EXSQ(IBAS)=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	ENDDO
	DO IKAP=1,NKAP(IPAN)              !!! over energy
	DO L=0,ILSB(ISORT)                !!! over l
	DO M=-L,L                         !!! over m
	IF(.NOT.LTPAN(L,IATOM,IKAP,IPAN))EXIT
	LM=L*(L+1)+M+1
	IPAR=INDLMT(LM,IATOM,IKAP,1,IPAN)
C  FOURIER TRANSFORM OF THE PSEUDOORBITAL
	DO IBAS=MBAS+1,LBAS(L,ISORT,IKAP,IPAN)  !!! NG_0{large}
	CHI0(IBAS)=CFTR0(L,ISORT,IKAP,IBAS)*
     &  YLM0(LM,IBAS)*EXS0(IBAS)
	CHIQ(IBAS)=DCONJG(CFTRQ(L,ISORT,IKAP,IBAS)*
     &  YLMQ(LM,IBAS)*EXSQ(IBAS))
	ENDDO
C  ******** PSEUDOPOTENTIAL MATRIX ************
C     CONTRIBUTION FROM LARGE G, K-DEPENDENCE BY TEILOR WILL BE USED
	DHH0=(0.D0,0.D0)
	DHHQ=(0.D0,0.D0)
	DO IBAS=MBAS+1,LBAS(L,ISORT,IKAP,IPAN)  !!! NG_0{large}
	DHH0=DHH0+CON0(IBAS)*CHI0(IBAS)         !!! {m1m0}DV0
	DHHQ=DHHQ+CHIQ(IBAS)*CONQ(IBAS)         !!! D{m1m0}Vq
	ENDDO
	DVINT0(IPAR1,IPAR)=DHH0
	DVINTQ(IPAR,IPAR1)=DHHQ
	ENDDO                             !!! over m
	ENDDO                             !!! over l
	ENDDO                             !!! over energy
	ENDDO                             !!! over iatom
	ENDDO                             !!! over m1
	ENDDO                             !!! over l1
	ENDDO                             !!! over energy
	ENDDO                             !!! over iatom1
C  STORE DATA FOR K=0
	IREC=1+2*(MY0+1)+6*(IUPDN-1)+6*NSPIN*(IORBS-1) +6*NSPIN*NORBS !!! D{m1m0}Y0,{m1m0}DV0
	WRITE(IUDYN,REC=IREC)((DVINT0(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DXFUN0(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
C  STORE DATA FOR K=Q
	IREC=2+2*(MY0+1)+6*(IUPDN-1)+6*NSPIN*(IORBS-1) +6*NSPIN*NORBS !!! D{m1m0}Xq,D{m1m0}Vq
	WRITE(IUDYN,REC=IREC)((DVINTQ(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DXFUNQ(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
 4000 CONTINUE                          !!! over polarizations
 5000 CONTINUE                          !!! over iupdn
 6000 CONTINUE                          !!! over iorbs
C Deallocations
	DEALLOCATE(DXFUN0,DXFUNQ,DVINT0,DVINTQ,CFTR0,YLM0,CFTRQ,YLMQ)
	DEALLOCATE(CHI0,RHI0,CON0,CHIQ,RHIQ,CONQ,EXP0,EXPQ,EXS0,EXSQ)
	END
