	SUBROUTINE DEL_SD2LMAT(MY1,INUC1,IPNT,ISGQ,IPAN,IQPNT)
***************************************************************
*  Find second-order change in the Hamiltonian and Overlap    *
*  matrices going from the change in the structure constants  *
*  in the first order and from the change in the potential    *
*  parameters in the first order.                             *
***************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_KAPPAR,  ONLY : NPAN,NKAP,EK,EKAP                          !!! from readini
	USE COM_NBANDS,  ONLY : NBNDF,NBNDE,NBNDT,NBNDH                    !!! from readini
	USE COM_OVRPAR,  ONLY : OPARHH,OPARJH,OPARHJ,OPARJJ                !!! from ovrpar
	USE COM_PANPAR,  ONLY : LTPAN,LSPAN,IATS,ISTS                      !!! from readini
	USE COM_PSIVEC,  ONLY : APHK,APJK,APHQ,APJQ                        !!! from lmtvec
	USE COM_DHAMPAR, ONLY : HPARHH,HPARJH,HPARHJ,HPARJJ                !!! from intpar
     &                       ,DELHHH,DELHJH,DELHHJ,DELHJJ
	USE COM_DOVRPAR, ONLY : DELOHH,DELOJH,DELOHJ,DELOJJ                !!! for delmat 
      USE COM_D2HAML,  ONLY : D2HMATK,D2OMATK,D2HMATQ,D2OMATQ            !!! from d2lmat
	USE COM_DSTRCON, ONLY : DSKL2,DSQL2                                !!! from strvec2
	USE COM_MASHDEP, ONLY : NVAL                                       !!! from setup
	USE COM_CHANNELS,ONLY : IUNMT                                      !!! from channels
	USE COM_PHNCHN  ,ONLY : IUDMT                                      !!! from channels
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: DHJHA(:)
	COMPLEX*16, ALLOCATABLE :: ADHHJ(:)
	COMPLEX*16, ALLOCATABLE :: HJJDS(:)
	COMPLEX*16, ALLOCATABLE :: DSHJJ(:)
	COMPLEX*16, ALLOCATABLE :: DHJJS(:)
	COMPLEX*16, ALLOCATABLE :: SDHJJ(:)
	DATA PI/3.141592653589793D0/
	IF(MODE.NE.4)RETURN
C Memory allocations
	ALLOCATE(DHJHA(LIMTMEM))
	ALLOCATE(ADHHJ(LIMTMEM))
	ALLOCATE(HJJDS(LIMTMEM))
	ALLOCATE(DSHJJ(LIMTMEM))
	ALLOCATE(DHJJS(LIMTMEM))
	ALLOCATE(SDHJJ(LIMTMEM))
C  DO OVER SPINS
      DO 7000 IORBS=1,NORBS                       !!! over iorbs
      DO 6000 IUPDN=1,NSPIN                       !!! over iupdn
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
C READ ORIGINAL POTENTIAL PARAMETERS
      DO IATOM=1,NATOM
      ISORT=IS(IATOM)
      DO IKAP1=1,NKAP(IPAN)
      DO IKAP=1,NKAP(IPAN)
	IREC=IKAP1+NKAP(IPAN)*(IKAP-1)+NKAP(IPAN)**2*(IATOM-1)+
     &NKAP(IPAN)**2*NATOM*(IUPDN-1)+
     &NKAP(IPAN)**2*NATOM*NSPIN*(IORBS-1)
      READ(IUNMT,REC=IREC)
     &((HPARHH(L1M1,LM,IATOM,IKAP1,IKAP),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((HPARJH(L1M1,LM,IATOM,IKAP1,IKAP),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((HPARHJ(L1M1,LM,IATOM,IKAP1,IKAP),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &((HPARJJ(L1M1,LM,IATOM,IKAP1,IKAP),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2)
      ENDDO
      ENDDO
      ENDDO
C READ CHANGE IN POTENTIAL PARAMETERS
      CALL NMTFILES(MY1,INUC1,IPAN,IUPDN,IORBS,IUDMT,'R')
C  **** CALCULATE CHANGE IN THE HAMILTONIAN AND OVERLAP MATRIX **** 
	DO 5000 IBNDS=1,NSPIN                        !!! over filled bands
	IF(NORBS.EQ.1.AND.ISPIN1.NE.IBNDS)GOTO 5000
	IF(NORBS.EQ.1.AND.ISPIN .NE.IBNDS)GOTO 5000
	DO 4000 IBNDT=1,NBNDF(IPAN)                  !!! over filled bands
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	DO 3000 IKAP1=1,NKAP(IPAN)                !!! over energies
	DO 2000 IKAP=1,NKAP(IPAN)                 !!! over energies
	DO 1000 IATOM=1,NATOM                     !!! over atoms
	ISORT=IS(IATOM)
	DO L1=0,ILST(ISORT)                       !!! over l1
	DO M1=-L1,L1                              !!! over m1
	L1M1=L1*(L1+1)+M1+1
C  FIND CONVOLUTIONS WITH THE H-PAR
	DHJHA(L1M1)=(0.D0,0.D0)                   !!! dH{JH}   x A(k)
	ADHHJ(L1M1)=(0.D0,0.D0)                   !!! A(k+q)*  x dH{HJ}
	HJJDS(L1M1)=(0.D0,0.D0)                   !!! H{JJ}    x dS(k)
	DSHJJ(L1M1)=(0.D0,0.D0)                   !!! dS(k+q)* x H{JJ}
	DHJJS(L1M1)=(0.D0,0.D0)                   !!! dH{JJ}   x S(k)
	SDHJJ(L1M1)=(0.D0,0.D0)                   !!! S(k+q)*  x dH{JJ}
	DO L=0,ILST(ISORT)                        !!! over l
	DO M=-L,L                                 !!! over m
	LM=L*(L+1)+M+1                       
	IF(LTPAN(L,IATOM,IKAP,IPAN))
     &DHJHA(L1M1)=DHJHA(L1M1)+
     &DELHJH(L1M1,LM,IATOM,IKAP1,IKAP)*
     &APHK(LM,IATOM,IKAP,ISPIN,IBAND)
	HJJDS(L1M1)=HJJDS(L1M1)+
     &HPARJJ(L1M1,LM,IATOM,IKAP1,IKAP)*
     &DSKL2(LM,IATOM,IKAP,MY1,INUC1,ISPIN,IBAND)
	DHJJS(L1M1)=DHJJS(L1M1)+
     &DELHJJ(L1M1,LM,IATOM,IKAP1,IKAP)*
     &APJK(LM,IATOM,IKAP,ISPIN,IBAND)
	IF(LTPAN(L,IATOM,IKAP1,IPAN))
     &ADHHJ(L1M1)=ADHHJ(L1M1)+
     &CONJG(APHQ(LM,IATOM,IKAP1,ISPIN1,IBAND))*
     &DELHHJ(LM,L1M1,IATOM,IKAP1,IKAP)
	DSHJJ(L1M1)=DSHJJ(L1M1)+
     &CONJG(DSQL2(LM,IATOM,IKAP1,-MY1,INUC1,ISPIN1,IBAND))*
     &(-1)**MY1*HPARJJ(LM,L1M1,IATOM,IKAP1,IKAP)
	SDHJJ(L1M1)=SDHJJ(L1M1)+
     &CONJG(APJQ(LM,IATOM,IKAP1,ISPIN1,IBAND))*
     &DELHJJ(LM,L1M1,IATOM,IKAP1,IKAP)
      ENDDO                                     !!! over m
      ENDDO                                     !!! over l
      ENDDO                                     !!! over m1
      ENDDO                                     !!! over l1
	DO INUC=1,NATOM                           !!! over displacements
	DO MY=-1,1                                !!! over polarizations
	DO L=0,ILST(ISORT)                        !!! over l
	DO M=-L,L                                 !!! over m
	LM=L*(L+1)+M+1
C  TWO- AND THREE-CENTER CONTRIBUTIONS TO THE CHANGE IN H-MATRIX
	D2HMATK(MY1,INUC1,MY,INUC,IBAND,2)=
     &D2HMATK(MY1,INUC1,MY,INUC,IBAND,2)+
     &(-1)**MY*CONJG(DSKL2(LM,IATOM,IKAP1,-MY,INUC,ISPIN1,IBAND))*
     &(-DHJHA(LM)+HJJDS(LM)+DHJJS(LM))
	D2HMATQ(MY1,INUC1,MY,INUC,IBAND,2)=
     &D2HMATQ(MY1,INUC1,MY,INUC,IBAND,2)+
     &(-ADHHJ(LM)+DSHJJ(LM)+SDHJJ(LM))*
     &DSQL2(LM,IATOM,IKAP,MY,INUC,ISPIN,IBAND)
C  TWO- AND THREE-CENTER CONTRIBUTIONS TO THE CHANGE IN O-MATRIX
      IF(ISPIN1.EQ.ISPIN)THEN
	IF(LTPAN(L,IATOM,IKAP,IPAN))
     &D2OMATK(MY1,INUC1,MY,INUC,IBAND,2)=
     &D2OMATK(MY1,INUC1,MY,INUC,IBAND,2)-
     &(-1)**MY*CONJG(DSKL2(LM,IATOM,IKAP1,-MY,INUC,ISPIN1,IBAND))*
     &DELOJH(IKAP1,IKAP,L,IATOM,IUPDN,IORBS)*
     &APHK(LM,IATOM,IKAP,ISPIN,IBAND)
	D2OMATK(MY1,INUC1,MY,INUC,IBAND,2)=
     &D2OMATK(MY1,INUC1,MY,INUC,IBAND,2)+
     &(-1)**MY*CONJG(DSKL2(LM,IATOM,IKAP1,-MY,INUC,ISPIN1,IBAND))*
     &OPARJJ(IKAP1,IKAP,L,ISORT,ISPIN)*
     &DSKL2(LM,IATOM,IKAP,MY1,INUC1,ISPIN,IBAND)
	D2OMATK(MY1,INUC1,MY,INUC,IBAND,2)=
     &D2OMATK(MY1,INUC1,MY,INUC,IBAND,2)+
     &(-1)**MY*CONJG(DSKL2(LM,IATOM,IKAP1,-MY,INUC,ISPIN1,IBAND))*
     &DELOJJ(IKAP1,IKAP,L,IATOM,IUPDN,IORBS)*
     &APJK(LM,IATOM,IKAP,ISPIN,IBAND)
	IF(LTPAN(L,IATOM,IKAP1,IPAN))
     &D2OMATQ(MY1,INUC1,MY,INUC,IBAND,2)=
     &D2OMATQ(MY1,INUC1,MY,INUC,IBAND,2)-
     &CONJG(APHQ(LM,IATOM,IKAP1,ISPIN1,IBAND))*
     &DELOHJ(IKAP1,IKAP,L,IATOM,IUPDN,IORBS)*
     &DSQL2(LM,IATOM,IKAP,MY,INUC,ISPIN,IBAND)
	D2OMATQ(MY1,INUC1,MY,INUC,IBAND,2)=
     &D2OMATQ(MY1,INUC1,MY,INUC,IBAND,2)+
     &(-1)**MY1*CONJG(DSQL2(LM,IATOM,IKAP1,-MY1,INUC1,ISPIN1,IBAND))*
     &OPARJJ(IKAP1,IKAP,L,ISORT,ISPIN)*
     &DSQL2(LM,IATOM,IKAP,MY,INUC,ISPIN,IBAND)
	D2OMATQ(MY1,INUC1,MY,INUC,IBAND,2)=
     &D2OMATQ(MY1,INUC1,MY,INUC,IBAND,2)+
     &CONJG(APJQ(LM,IATOM,IKAP1,ISPIN1,IBAND))*
     &DELOJJ(IKAP1,IKAP,L,IATOM,IUPDN,IORBS)*
     &DSQL2(LM,IATOM,IKAP,MY,INUC,ISPIN,IBAND)
      ENDIF
      ENDDO                                     !!! over m
      ENDDO                                     !!! over l
      ENDDO                                     !!! over polarizations
      ENDDO                                     !!! over displacements
 1000 CONTINUE                                  !!! over atoms
 2000 CONTINUE                                  !!! over energies
 3000 CONTINUE                                  !!! over energies
 4000	CONTINUE                                  !!! over bands
 5000	CONTINUE                                  !!! over spin subbands
 6000	CONTINUE                                  !!! over iupdn
 7000	CONTINUE                                  !!! over iorbs
C Memory deallocations
	DEALLOCATE(DHJHA,ADHHJ,HJJDS,DSHJJ,DHJJS,SDHJJ)
	END     
