	SUBROUTINE DEL_SD2LMTO(IPNT,ISGQ,IPAN,IQPNT)
***************************************************************
*  Find second-order change in the Hamiltonian and Overlap    *
*  matrices going from the change in the structure constants  *
*  in the second order.                                       *
*  Last revised 26.03.97.                                     *
***************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_KAPPAR,  ONLY : NPAN,NKAP,EK,EKAP                          !!! from readini
	USE COM_SPHERE,  ONLY : SWZ,SMT                                    !!! from readini
      USE COM_LATPAR,  ONLY : PAR,ORTH,OMEGAC                            !!! from readstr
	USE COM_PANPAR,  ONLY : LTPAN,LSPAN,IATS,ISTS                      !!! from readini
	USE COM_OVRPAR,  ONLY : OPARHH,OPARJH,OPARHJ,OPARJJ                !!! from ovrpar
	USE COM_NBANDS,  ONLY : NBNDF,NBNDE,NBNDT,NBNDH                    !!! from readini
	USE COM_PSIVEC,  ONLY : APHK,APJK,APHQ,APJQ                        !!! from lmtvec
	USE COM_DSTRCON, ONLY : STRK,STDK,STRQ,STDQ                        !!! from delgnt
	USE COM_GAUNT,   ONLY : C                                          !!! from makegnt
	USE COM_DHAMPAR, ONLY : HPARHH,HPARJH,HPARHJ,HPARJJ                !!! from intpar
      USE COM_D2HAML,  ONLY : D2HMATK,D2OMATK,D2HMATQ,D2OMATQ            !!! from d2lmat
	USE COM_MASHDEP, ONLY : NVAL                                       !!! from setup
	USE COM_CHANNELS,ONLY : IUNMT                                      !!! frm channels
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8, ALLOCATABLE :: CCOF(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: BHASK(:,:,:)
	COMPLEX*16, ALLOCATABLE :: BASHK(:,:,:)
	COMPLEX*16, ALLOCATABLE :: BOASK(:,:,:)
	COMPLEX*16, ALLOCATABLE :: BASOK(:,:,:)
	COMPLEX*16, ALLOCATABLE :: BHASQ(:,:,:)
	COMPLEX*16, ALLOCATABLE :: BASHQ(:,:,:)
	COMPLEX*16, ALLOCATABLE :: BOASQ(:,:,:)
	COMPLEX*16, ALLOCATABLE :: BASOQ(:,:,:)
	COMPLEX*16, ALLOCATABLE :: STKAK(:,:)
	COMPLEX*16, ALLOCATABLE :: STKAQ(:,:)
	COMPLEX*16, ALLOCATABLE :: SDKAK(:,:)
	COMPLEX*16, ALLOCATABLE :: SDKAQ(:,:)
	COMPLEX*16, ALLOCATABLE :: STQAK(:,:)
	COMPLEX*16, ALLOCATABLE :: STQAQ(:,:)
	COMPLEX*16, ALLOCATABLE :: SDQAK(:,:)
	COMPLEX*16, ALLOCATABLE :: SDQAQ(:,:)
	COMPLEX*16, ALLOCATABLE :: DSTKAK(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: DSTKAQ(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: DSDKAK(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: DSDKAQ(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: DSTQAK(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: DSTQAQ(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: DSDQAK(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: DSDQAQ(:,:,:,:)
	COMPLEX*16 CGNT(2),DGNT(2),HDOTPAR
	LOGICAL LOG1,LOG,KDOT,FIRST
	SAVE FIRST,CCOF
	DATA PI/3.141592653589793D0/,FIRST/.TRUE./
	IF(MODE.NE.4)RETURN
C Memory allocations
	ALLOCATE(BHASK(LIMTMEM,NATOMMEM,NKAPMEM))
	ALLOCATE(BASHK(LIMTMEM,NATOMMEM,NKAPMEM))
	ALLOCATE(BOASK(LIMTMEM,NATOMMEM,NKAPMEM))
	ALLOCATE(BASOK(LIMTMEM,NATOMMEM,NKAPMEM))
	ALLOCATE(BHASQ(LIMTMEM,NATOMMEM,NKAPMEM))
	ALLOCATE(BASHQ(LIMTMEM,NATOMMEM,NKAPMEM))
	ALLOCATE(BOASQ(LIMTMEM,NATOMMEM,NKAPMEM))
	ALLOCATE(BASOQ(LIMTMEM,NATOMMEM,NKAPMEM))
	ALLOCATE(STKAK(LIMT1MEM,NSPINMEM))
	ALLOCATE(STKAQ(LIMT1MEM,NSPINMEM))
	ALLOCATE(STQAK(LIMT1MEM,NSPINMEM))
	ALLOCATE(STQAQ(LIMT1MEM,NSPINMEM))
	ALLOCATE(SDKAK(LIMB1MEM,NSPINMEM))
	ALLOCATE(SDKAQ(LIMB1MEM,NSPINMEM))
	ALLOCATE(SDQAK(LIMB1MEM,NSPINMEM))
	ALLOCATE(SDQAQ(LIMB1MEM,NSPINMEM))
	ALLOCATE(DSTKAK(LIMTMEM,-1:1,-1:1,NSPINMEM))
	ALLOCATE(DSTKAQ(LIMTMEM,-1:1,-1:1,NSPINMEM))
	ALLOCATE(DSTQAK(LIMTMEM,-1:1,-1:1,NSPINMEM))
	ALLOCATE(DSTQAQ(LIMTMEM,-1:1,-1:1,NSPINMEM))
	ALLOCATE(DSDKAK(LIMBMEM,-1:1,-1:1,NSPINMEM))
	ALLOCATE(DSDKAQ(LIMBMEM,-1:1,-1:1,NSPINMEM))
	ALLOCATE(DSDQAK(LIMBMEM,-1:1,-1:1,NSPINMEM))
	ALLOCATE(DSDQAQ(LIMBMEM,-1:1,-1:1,NSPINMEM))
	IF(FIRST)THEN
	ALLOCATE(CCOF(LIMTMEM,-1:1,-1:1,4))
C  CALCULATE GAUNT ARRAYS
	FIRST=.FALSE.
	PI43=4.D0*PI/3.D0
	ILSTMAX=0
	DO ISORT=1,NSORT
	ILSTMAX=MAX(ILSTMAX,ILST(ISORT))
	ENDDO
	DO MY1=-1,1
	DO MY=-1,1 
	DO L=0,ILSTMAX
	DO M=-L,L
	LM=L*(L+1)+M+1
	LM1MY=(L-1)*L+M-MY+1
	LP1MY=(L+1)*(L+2)+M-MY+1
	LM2MY=(L-2)*(L-1)+M-MY-MY1+1
	LP2MY=(L+2)*(L+3)+M-MY-MY1+1
	LP0MY=L*(L+1)+M-MY-MY1+1
	CCOF(LM,MY1,MY,1)=0.D0
	CCOF(LM,MY1,MY,2)=0.D0
	CCOF(LM,MY1,MY,3)=0.D0
	CCOF(LM,MY1,MY,4)=0.D0
	IF(L.GE.1.AND.ABS(M-MY).LE.L-1.AND.
     &  L.GE.2.AND.ABS(M-MY-MY1).LE.L-2)THEN
	CCOF(LM,MY1,MY,1)=PI43*C(0,LM,LM1MY)*C(0,LM1MY,LM2MY)/
     &  DBLE((2*L-1)*(2*L-3))
	ENDIF
	IF(L.GE.1.AND.ABS(M-MY).LE.L-1.AND.
     &  L.GE.0.AND.ABS(M-MY-MY1).LE.L)THEN
	CCOF(LM,MY1,MY,2)=PI43*C(0,LM,LM1MY)*C(0,LM1MY,LP0MY)
	ENDIF
	IF(L.GE.0.AND.ABS(M-MY).LE.L+1.AND.
     &  L.GE.0.AND.ABS(M-MY-MY1).LE.L)THEN
	CCOF(LM,MY1,MY,3)=PI43*C(0,LM,LP1MY)*C(0,LP1MY,LP0MY)
	ENDIF
	IF(L.GE.0.AND.ABS(M-MY).LE.L+1.AND.
     &  L.LE.ILSTMAX-1.AND.ABS(M-MY-MY1).LE.L+2)THEN
	CCOF(LM,MY1,MY,4)=PI43*C(0,LM,LP1MY)*C(0,LP1MY,LP2MY)*
     &  DBLE(2*L+1)*(2*L+3)
	ENDIF
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDIF
C  SET ZEROES
	DO IBNDS=1,NSPIN
	DO IBNDT=1,NBNDF(IPAN)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
      DO INUC1=1,NATOM
      DO INUC=1,NATOM
      DO MY1=-1,1
      DO MY=-1,1
	DO II=1,3
      D2HMATK(MY1,INUC1,MY,INUC,IBAND,II)=(0.D0,0.D0)
      D2OMATK(MY1,INUC1,MY,INUC,IBAND,II)=(0.D0,0.D0)
	D2HMATQ(MY1,INUC1,MY,INUC,IBAND,II)=(0.D0,0.D0)
      D2OMATQ(MY1,INUC1,MY,INUC,IBAND,II)=(0.D0,0.D0)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C  DO OVER SPINS
      DO 7000 IORBS=1,NORBS                       !!! over iorbs
      DO 6000 IUPDN=1,NSPIN                       !!! over iupdn
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
C  READ POTENTIAL PARAMETERS
      DO IATOM=1,NATOM
      ISORT=IS(IATOM)
      DO IKAP1=1,NKAP(IPAN)
      DO IKAP=1,NKAP(IPAN)
	IREC=IKAP1+NKAP(IPAN)*(IKAP-1)+NKAP(IPAN)**2*(IATOM-1)+
     &NKAP(IPAN)**2*NATOM*(IUPDN-1)+
     &NKAP(IPAN)**2*NATOM*NSPIN*(IORBS-1)
      READ(IUNMT,REC=IREC)
     &((HPARHH(L1M1,LM,IATOM,IKAP1,IKAP),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((HPARJH(L1M1,LM,IATOM,IKAP1,IKAP),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((HPARHJ(L1M1,LM,IATOM,IKAP1,IKAP),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &((HPARJJ(L1M1,LM,IATOM,IKAP1,IKAP),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2)
      ENDDO
      ENDDO
      ENDDO
C * DO GLOBALLY OVER FILLED BANDS, ALL OPERATIONS BELOW ASSUME IBND-INDEX *
	DO 5000 IBNDS=1,NSPIN                        !!! over filled bands
	IF(NORBS.EQ.1.AND.ISPIN.NE.IBNDS)GOTO 5000
	DO 4000 IBNDT=1,NBNDF(IPAN)                  !!! over filled bands
	IBAND=IBNDS+NSPIN*(IBNDT-1)
C  CALCULATE CONVOLUTIONS OF THE POTENTIAL PARAMETERS AND EIGENVECTORS
	DO IKAP=1,NKAP(IPAN)                         !!! over ikap
	DO IATOM=1,NATOM                             !!! over iatom
	ISORT=IS(IATOM)
	DO L=0,ILST(ISORT)                           !!! over l
	LOG=.FALSE.
	IF(LTPAN(L,IATOM,IKAP,IPAN))LOG=.TRUE.
	DO M=-L,L                                    !!! over m
	LM=L*(L+1)+M+1
C  HAMILTONIAN CONVOLUTIONS
	BHASK(LM,IATOM,IKAP)=(0.D0,0.D0)
	BASHK(LM,IATOM,IKAP)=(0.D0,0.D0)
	BHASQ(LM,IATOM,IKAP)=(0.D0,0.D0)
	BASHQ(LM,IATOM,IKAP)=(0.D0,0.D0)
C  OVERLAP CONVOLUTIONS
	BOASK(LM,IATOM,IKAP)=(0.D0,0.D0)
	BASOK(LM,IATOM,IKAP)=(0.D0,0.D0)
	BOASQ(LM,IATOM,IKAP)=(0.D0,0.D0)
	BASOQ(LM,IATOM,IKAP)=(0.D0,0.D0)
	DO IKAP1=1,NKAP(IPAN)                        !!! over ikap1
	DO L1=0,ILST(ISORT)                          !!! over l1
	LOG1=.FALSE.
	IF(LTPAN(L1,IATOM,IKAP1,IPAN))LOG1=.TRUE.
	DO M1=-L1,L1                                 !!! over m1
	L1M1=L1*(L1+1)+M1+1
C  HAMILTONIAN PARAMETERS WITH THE EIGENVECTORS OF VECTOR K
C  Hpar{JH} x A(kl)
	IF(LOG1)
     &  BHASK(LM,IATOM,IKAP)=BHASK(LM,IATOM,IKAP)+
     &  HPARJH(LM,L1M1,IATOM,IKAP,IKAP1)*
     &  APHK(L1M1,IATOM,IKAP1,ISPIN,IBAND)
C  Hpar{JJ} x S(kl)
	BHASK(LM,IATOM,IKAP)=BHASK(LM,IATOM,IKAP)-
     &  HPARJJ(LM,L1M1,IATOM,IKAP,IKAP1)*
     &  APJK(L1M1,IATOM,IKAP1,ISPIN,IBAND)
C  A(kl) x Hpar{HJ}
	IF(LOG1)
     &  BASHK(LM,IATOM,IKAP)=BASHK(LM,IATOM,IKAP)+
     &  CONJG(APHK(L1M1,IATOM,IKAP1,ISPIN1,IBAND))*
     &  HPARHJ(L1M1,LM,IATOM,IKAP1,IKAP)
C  S(kl) x Hpar{JJ}
	BASHK(LM,IATOM,IKAP)=BASHK(LM,IATOM,IKAP)-
     &  CONJG(APJK(L1M1,IATOM,IKAP1,ISPIN1,IBAND))*
     &  HPARJJ(L1M1,LM,IATOM,IKAP1,IKAP)
C  HAMILTONIAN PARAMETERS WITH THE EIGENVECTORS OF VECTOR K+Q
C  Hpar{JH} x A(k+ql)
	IF(LOG1)
     &  BHASQ(LM,IATOM,IKAP)=BHASQ(LM,IATOM,IKAP)+
     &  HPARJH(LM,L1M1,IATOM,IKAP,IKAP1)*
     &  APHQ(L1M1,IATOM,IKAP1,ISPIN,IBAND)
C  Hpar{JJ} x S(k+ql)
	BHASQ(LM,IATOM,IKAP)=BHASQ(LM,IATOM,IKAP)-
     &  HPARJJ(LM,L1M1,IATOM,IKAP,IKAP1)*
     &  APJQ(L1M1,IATOM,IKAP1,ISPIN,IBAND)
C  A(k+ql) x Hpar{HJ}
	IF(LOG1)
     &  BASHQ(LM,IATOM,IKAP)=BASHQ(LM,IATOM,IKAP)+
     &  CONJG(APHQ(L1M1,IATOM,IKAP1,ISPIN1,IBAND))*
     &  HPARHJ(L1M1,LM,IATOM,IKAP1,IKAP)
C  S(k+ql) x Hpar{JJ}
	BASHQ(LM,IATOM,IKAP)=BASHQ(LM,IATOM,IKAP)-
     &  CONJG(APJQ(L1M1,IATOM,IKAP1,ISPIN1,IBAND))*
     &  HPARJJ(L1M1,LM,IATOM,IKAP1,IKAP)
      ENDDO                                        !!! over m1
      ENDDO                                        !!! over l1
	LOG1=.FALSE.
	IF(LTPAN(L,IATOM,IKAP1,IPAN))LOG1=.TRUE.
C  OVERLAP PARAMETERS WITH THE EIGENVECTORS OF VECTOR K
C  Opar{JH} x A(kl)
      IF(ISPIN1.EQ.ISPIN)THEN
	IF(LOG1)
     &  BOASK(LM,IATOM,IKAP)=BOASK(LM,IATOM,IKAP)+
     &  OPARJH(IKAP,IKAP1,L,ISORT,ISPIN)*
     &  APHK(LM,IATOM,IKAP1,ISPIN,IBAND)
C  Opar{JJ} x S(kl)
	BOASK(LM,IATOM,IKAP)=BOASK(LM,IATOM,IKAP)-
     &  OPARJJ(IKAP,IKAP1,L,ISORT,ISPIN)*
     &  APJK(LM,IATOM,IKAP1,ISPIN,IBAND)
C  A(kl) x Opar{HJ}
	IF(LOG1)
     &  BASOK(LM,IATOM,IKAP)=BASOK(LM,IATOM,IKAP)+
     &  CONJG(APHK(LM,IATOM,IKAP1,ISPIN1,IBAND))*
     &  OPARHJ(IKAP1,IKAP,L,ISORT,ISPIN)
C  S(kl) x Opar{JJ}
	BASOK(LM,IATOM,IKAP)=BASOK(LM,IATOM,IKAP)-
     &  CONJG(APJK(LM,IATOM,IKAP1,ISPIN1,IBAND))*
     &  OPARJJ(IKAP1,IKAP,L,ISORT,ISPIN)
C  OVERLAP PARAMETERS WITH THE EIGENVECTORS OF VECTOR K+Q
C  Opar{JH} x A(k+ql)
	IF(LOG1)
     &  BOASQ(LM,IATOM,IKAP)=BOASQ(LM,IATOM,IKAP)+
     &  OPARJH(IKAP,IKAP1,L,ISORT,ISPIN)*
     &  APHQ(LM,IATOM,IKAP1,ISPIN,IBAND)
C  Opar{JJ} x S(k+ql)
	BOASQ(LM,IATOM,IKAP)=BOASQ(LM,IATOM,IKAP)-
     &  OPARJJ(IKAP,IKAP1,L,ISORT,ISPIN)*
     &  APJQ(LM,IATOM,IKAP1,ISPIN,IBAND)
C  A(k+ql) x Opar{HJ}
	IF(LOG1)
     &  BASOQ(LM,IATOM,IKAP)=BASOQ(LM,IATOM,IKAP)+
     &  CONJG(APHQ(LM,IATOM,IKAP1,ISPIN1,IBAND))*
     &  OPARHJ(IKAP1,IKAP,L,ISORT,ISPIN)
C  S(k+ql) x Opar{JJ}
	BASOQ(LM,IATOM,IKAP)=BASOQ(LM,IATOM,IKAP)-
     &  CONJG(APJQ(LM,IATOM,IKAP1,ISPIN1,IBAND))*
     &  OPARJJ(IKAP1,IKAP,L,ISORT,ISPIN)
      ENDIF
      ENDDO                                        !!! over ikap1
      ENDDO                                        !!! over m
      ENDDO                                        !!! over l
      ENDDO                                        !!! over iatom
      ENDDO                                        !!! over ikap
C  END OF CALCULATING POTENTIAL PARAMETER CONVOLUTIONS
C* DO GLOBALLY OVER ENERGIES AND ATOMS IATOM1 AND IATOM *
	DO 3000 IKAP=1,NKAP(IPAN)                    !!! over energies
	IF(EKAP(IKAP,IPAN).EQ.CONJG(EKAP(IKAP,IPAN)))KDOT=.TRUE.
	IF(EKAP(IKAP,IPAN).NE.CONJG(EKAP(IKAP,IPAN)))KDOT=.FALSE.
	IF(ISPIN1.NE.ISPIN)KDOT=.FALSE.
	DO 2000 IATOM1=1,NATOM                       !!! over iatom1
	ISORT1=IS(IATOM1)
	DO 1000 IATOM=1,NATOM                        !!! over iatom
	ISORT=IS(IATOM)
C  CALCULATE CONVOLUTIONS OF THE STRUCTURE CONSTANTS WITH THE EIGENVECTORS
	DO L1=0,ILST(ISORT1)+1                       !!! over l1
	LOG1=.FALSE.
	IF(L1.LE.ILSB(ISORT1)+1)LOG1=.TRUE.
	DO M1=-L1,L1                                 !!! over m1
	L1M1=L1*(L1+1)+M1+1
C  STRUCTURE CONSTANTS CONVOLUTIONS
	STKAK(L1M1,ISPIN1)=(0.D0,0.D0)
	STKAQ(L1M1,ISPIN1)=(0.D0,0.D0)
	STQAK(L1M1,ISPIN1)=(0.D0,0.D0)
	STQAQ(L1M1,ISPIN1)=(0.D0,0.D0)
	STKAK(L1M1,ISPIN )=(0.D0,0.D0)
	STKAQ(L1M1,ISPIN )=(0.D0,0.D0)
	STQAK(L1M1,ISPIN )=(0.D0,0.D0)
	STQAQ(L1M1,ISPIN )=(0.D0,0.D0)
C  ENERGY DERIVATIVES CONVOLUTIONS
	IF(LOG1.AND.KDOT)THEN
	SDKAK(L1M1,ISPIN1)=(0.D0,0.D0)
	SDKAQ(L1M1,ISPIN1)=(0.D0,0.D0)
	SDQAK(L1M1,ISPIN1)=(0.D0,0.D0)
	SDQAQ(L1M1,ISPIN1)=(0.D0,0.D0)
	SDKAK(L1M1,ISPIN )=(0.D0,0.D0)
	SDKAQ(L1M1,ISPIN )=(0.D0,0.D0)
	SDQAK(L1M1,ISPIN )=(0.D0,0.D0)
	SDQAQ(L1M1,ISPIN )=(0.D0,0.D0)
	ENDIF
	DO L=0,ILSB(ISORT)                           !!! over l
	IF(LTPAN(L,IATOM,IKAP,IPAN))THEN
	DO M=-L,L                                    !!! over m
	LM=L*(L+1)+M+1
C  S(L'L,k) x A(kl)
	STKAK(L1M1,ISPIN1)=STKAK(L1M1,ISPIN1)+
     &STRK(L1M1,IATOM1,LM,IATOM,IKAP)*APHK(LM,IATOM,IKAP,ISPIN1,IBAND) 
C  S(L'L,k) x A(k+ql)
	STKAQ(L1M1,ISPIN1)=STKAQ(L1M1,ISPIN1)+
     &STRK(L1M1,IATOM1,LM,IATOM,IKAP)*APHQ(LM,IATOM,IKAP,ISPIN1,IBAND)
C  S(L'L,k+q) x A(kl)
	STQAK(L1M1,ISPIN1)=STQAK(L1M1,ISPIN1)+
     &STRQ(L1M1,IATOM1,LM,IATOM,IKAP)*APHK(LM,IATOM,IKAP,ISPIN1,IBAND) 
C  S(L'L,k+q) x A(k+ql)
	STQAQ(L1M1,ISPIN1)=STQAQ(L1M1,ISPIN1)+
     &STRQ(L1M1,IATOM1,LM,IATOM,IKAP)*APHQ(LM,IATOM,IKAP,ISPIN1,IBAND) 
      IF(ISPIN1.NE.ISPIN)THEN
C  S(L'L,k) x A(kl)
	STKAK(L1M1,ISPIN)=STKAK(L1M1,ISPIN)+
     &STRK(L1M1,IATOM1,LM,IATOM,IKAP)*APHK(LM,IATOM,IKAP,ISPIN,IBAND) 
C  S(L'L,k) x A(k+ql)
	STKAQ(L1M1,ISPIN)=STKAQ(L1M1,ISPIN)+
     &STRK(L1M1,IATOM1,LM,IATOM,IKAP)*APHQ(LM,IATOM,IKAP,ISPIN,IBAND)
C  S(L'L,k+q) x A(kl)
	STQAK(L1M1,ISPIN)=STQAK(L1M1,ISPIN)+
     &STRQ(L1M1,IATOM1,LM,IATOM,IKAP)*APHK(LM,IATOM,IKAP,ISPIN,IBAND) 
C  S(L'L,k+q) x A(k+ql)
	STQAQ(L1M1,ISPIN)=STQAQ(L1M1,ISPIN)+
     &STRQ(L1M1,IATOM1,LM,IATOM,IKAP)*APHQ(LM,IATOM,IKAP,ISPIN,IBAND) 
      ENDIF
	IF(LOG1.AND.KDOT)THEN
C  Sdot(L'L,k) x A(kl)
	SDKAK(L1M1,ISPIN1)=SDKAK(L1M1,ISPIN1)+
     &STDK(L1M1,IATOM1,LM,IATOM,IKAP)*APHK(LM,IATOM,IKAP,ISPIN1,IBAND) 
C  Sdot(L'L,k) x A(k+ql)
	SDKAQ(L1M1,ISPIN1)=SDKAQ(L1M1,ISPIN1)+
     &STDK(L1M1,IATOM1,LM,IATOM,IKAP)*APHQ(LM,IATOM,IKAP,ISPIN1,IBAND) 
C  Sdot(L'L,k+q) x A(kl)
	SDQAK(L1M1,ISPIN1)=SDQAK(L1M1,ISPIN1)+
     &STDQ(L1M1,IATOM1,LM,IATOM,IKAP)*APHK(LM,IATOM,IKAP,ISPIN1,IBAND) 
C  Sdot(L'L,k+q) x A(k+ql)
	SDQAQ(L1M1,ISPIN1)=SDQAQ(L1M1,ISPIN1)+
     &STDQ(L1M1,IATOM1,LM,IATOM,IKAP)*APHQ(LM,IATOM,IKAP,ISPIN1,IBAND)
      IF(ISPIN1.NE.ISPIN)THEN
C  Sdot(L'L,k) x A(kl)
	SDKAK(L1M1,ISPIN)=SDKAK(L1M1,ISPIN)+
     &STDK(L1M1,IATOM1,LM,IATOM,IKAP)*APHK(LM,IATOM,IKAP,ISPIN,IBAND) 
C  Sdot(L'L,k) x A(k+ql)
	SDKAQ(L1M1,ISPIN)=SDKAQ(L1M1,ISPIN)+
     &STDK(L1M1,IATOM1,LM,IATOM,IKAP)*APHQ(LM,IATOM,IKAP,ISPIN,IBAND) 
C  Sdot(L'L,k+q) x A(kl)
	SDQAK(L1M1,ISPIN)=SDQAK(L1M1,ISPIN)+
     &STDQ(L1M1,IATOM1,LM,IATOM,IKAP)*APHK(LM,IATOM,IKAP,ISPIN,IBAND) 
C  Sdot(L'L,k+q) x A(k+ql)
	SDQAQ(L1M1,ISPIN)=SDQAQ(L1M1,ISPIN)+
     &STDQ(L1M1,IATOM1,LM,IATOM,IKAP)*APHQ(LM,IATOM,IKAP,ISPIN,IBAND)
      ENDIF
	ENDIF
      ENDDO                                        !!! over m
	ENDIF
      ENDDO                                        !!! over l
      ENDDO                                        !!! over m1
      ENDDO                                        !!! over l1
C  END OF CALCULATING STRUCTURE CONSTANTS CONVOLUTIONS
C  CALCULATE SECOND-ORDER DERIVATIVES OF THE STRUCTURE CONSTANTS CONVOLUTIONS
	DO MY1=-1,1                                  !!! over my1 
	DO MY=-1,1                                   !!! over my
	DO L=0,ILST(ISORT1)                          !!! over l
	LOG=.FALSE.
	IF(L.LE.ILSB(ISORT1))LOG=.TRUE.
	DO M=-L,L                                    !!! over m
	LM=L*(L+1)+M+1
	LM1MY=(L-1)*L+M-MY+1
	LP1MY=(L+1)*(L+2)+M-MY+1
	LM2MY=(L-2)*(L-1)+M-MY-MY1+1
	LP2MY=(L+2)*(L+3)+M-MY-MY1+1
	LP0MY=L*(L+1)+M-MY-MY1+1
	DSTKAK(LM,MY1,MY,ISPIN1)=(0.D0,0.D0)
	DSTKAQ(LM,MY1,MY,ISPIN1)=(0.D0,0.D0)
	DSTQAK(LM,MY1,MY,ISPIN1)=(0.D0,0.D0)
	DSTQAQ(LM,MY1,MY,ISPIN1)=(0.D0,0.D0)
	DSTKAK(LM,MY1,MY,ISPIN )=(0.D0,0.D0)
	DSTKAQ(LM,MY1,MY,ISPIN )=(0.D0,0.D0)
	DSTQAK(LM,MY1,MY,ISPIN )=(0.D0,0.D0)
	DSTQAQ(LM,MY1,MY,ISPIN )=(0.D0,0.D0)
	IF(LOG.AND.KDOT)THEN
	DSDKAK(LM,MY1,MY,ISPIN1)=(0.D0,0.D0)
	DSDKAQ(LM,MY1,MY,ISPIN1)=(0.D0,0.D0)
	DSDQAK(LM,MY1,MY,ISPIN1)=(0.D0,0.D0)
	DSDQAQ(LM,MY1,MY,ISPIN1)=(0.D0,0.D0)
	DSDKAK(LM,MY1,MY,ISPIN )=(0.D0,0.D0)
	DSDKAQ(LM,MY1,MY,ISPIN )=(0.D0,0.D0)
	DSDQAK(LM,MY1,MY,ISPIN )=(0.D0,0.D0)
	DSDQAQ(LM,MY1,MY,ISPIN )=(0.D0,0.D0)
	ENDIF
	DO I=1,4                                        !!! over cases
	IF(I.EQ.1)LMS=LM2MY
	IF(I.EQ.2.OR.I.EQ.3)LMS=LP0MY
	IF(I.EQ.4)LMS=LP2MY
	IF(ABS(CCOF(LM,MY1,MY,I)).GE.1.D-12)THEN
	IF(I.EQ.1)
     &CGNT(1)=CCOF(LM,MY1,MY,I)*EKAP(IKAP,IPAN)**2*SMT(ISORT1)**2
	IF(I.EQ.2.OR.I.EQ.3)
     &CGNT(1)=CCOF(LM,MY1,MY,I)*EKAP(IKAP,IPAN)
	IF(I.EQ.4)
     &CGNT(1)=CCOF(LM,MY1,MY,I)/SMT(ISORT1)**2
	DGNT(1)=CGNT(1)*PAR**3
	DSTKAK(LM,MY1,MY,ISPIN1)=DSTKAK(LM,MY1,MY,ISPIN1)-
     &CGNT(1)*STKAK(LMS,ISPIN1)
	DSTQAK(LM,MY1,MY,ISPIN1)=DSTQAK(LM,MY1,MY,ISPIN1)-
     &CGNT(1)*STQAK(LMS,ISPIN1)
	DSTKAQ(LM,MY1,MY,ISPIN1)=DSTKAQ(LM,MY1,MY,ISPIN1)-
     &CGNT(1)*STKAQ(LMS,ISPIN1)
	DSTQAQ(LM,MY1,MY,ISPIN1)=DSTQAQ(LM,MY1,MY,ISPIN1)-
     &CGNT(1)*STQAQ(LMS,ISPIN1)
      IF(ISPIN1.NE.ISPIN)THEN
	DSTKAK(LM,MY1,MY,ISPIN)=DSTKAK(LM,MY1,MY,ISPIN)-
     &CGNT(1)*STKAK(LMS,ISPIN)
	DSTQAK(LM,MY1,MY,ISPIN)=DSTQAK(LM,MY1,MY,ISPIN)-
     &CGNT(1)*STQAK(LMS,ISPIN)
	DSTKAQ(LM,MY1,MY,ISPIN)=DSTKAQ(LM,MY1,MY,ISPIN)-
     &CGNT(1)*STKAQ(LMS,ISPIN)
	DSTQAQ(LM,MY1,MY,ISPIN)=DSTQAQ(LM,MY1,MY,ISPIN)-
     &CGNT(1)*STQAQ(LMS,ISPIN)
      ENDIF
	IF(LOG.AND.KDOT)THEN
	IF(I.EQ.1)
     &CGNT(2)=CCOF(LM,MY1,MY,I)*2.D0*EKAP(IKAP,IPAN)*SMT(ISORT1)**2
	IF(I.EQ.2.OR.I.EQ.3)
     &CGNT(2)=CCOF(LM,MY1,MY,I)
	IF(I.EQ.4)
     &CGNT(2)=(0.D0,0.D0)
	DGNT(2)=CGNT(2)*PAR
	IF(I.NE.4.OR.(I.EQ.4.AND.L.LE.ILSB(ISORT1)-1))THEN
	DSDKAK(LM,MY1,MY,ISPIN1)=DSDKAK(LM,MY1,MY,ISPIN1)-
     &DGNT(1)*SDKAK(LMS,ISPIN1)-DGNT(2)*STKAK(LMS,ISPIN1)
	DSDQAK(LM,MY1,MY,ISPIN1)=DSDQAK(LM,MY1,MY,ISPIN1)-
     &DGNT(1)*SDQAK(LMS,ISPIN1)-DGNT(2)*STQAK(LMS,ISPIN1)
	DSDKAQ(LM,MY1,MY,ISPIN1)=DSDKAQ(LM,MY1,MY,ISPIN1)-
     &DGNT(1)*SDKAQ(LMS,ISPIN1)-DGNT(2)*STKAQ(LMS,ISPIN1)
	DSDQAQ(LM,MY1,MY,ISPIN1)=DSDQAQ(LM,MY1,MY,ISPIN1)-
     &DGNT(1)*SDQAQ(LMS,ISPIN1)-DGNT(2)*STQAQ(LMS,ISPIN1)
      IF(ISPIN1.NE.ISPIN)THEN
	DSDKAK(LM,MY1,MY,ISPIN)=DSDKAK(LM,MY1,MY,ISPIN)-
     &DGNT(1)*SDKAK(LMS,ISPIN)-DGNT(2)*STKAK(LMS,ISPIN)
	DSDQAK(LM,MY1,MY,ISPIN)=DSDQAK(LM,MY1,MY,ISPIN)-
     &DGNT(1)*SDQAK(LMS,ISPIN)-DGNT(2)*STQAK(LMS,ISPIN)
	DSDKAQ(LM,MY1,MY,ISPIN)=DSDKAQ(LM,MY1,MY,ISPIN)-
     &DGNT(1)*SDKAQ(LMS,ISPIN)-DGNT(2)*STKAQ(LMS,ISPIN)
	DSDQAQ(LM,MY1,MY,ISPIN)=DSDQAQ(LM,MY1,MY,ISPIN)-
     &DGNT(1)*SDQAQ(LMS,ISPIN)-DGNT(2)*STQAQ(LMS,ISPIN)
      ENDIF
	ENDIF
	ENDIF
	ENDIF
      ENDDO                                        !!! over cases
      ENDDO                                        !!! over m
      ENDDO                                        !!! over l
      ENDDO                                        !!! over my
      ENDDO                                        !!! over my1
C  END OF CALCULATING SECOND-ORDER DERIVATIVES
C  CALCULATE CONTRIBUTION TO THE DYNAMICAL MATRIX
	HDOTPAR=-EKAP(IKAP,IPAN)
	ODOTPAR=-1.D0
	DO MY1=-1,1                                  !!! over my1
	DO MY=-1,1                                   !!! over my
	DO L=0,ILST(ISORT1)                          !!! over l
	LOG=.FALSE.
	IF(LTPAN(L,IATOM1,IKAP,IPAN))LOG=.TRUE.
	DO M=-L,L                                    !!! over m
	LM=L*(L+1)+M+1
C d2S(k+q,k) x B(k)
	D2HMATK(MY1,IATOM1,MY,IATOM,IBAND,1)=
     &D2HMATK(MY1,IATOM1,MY,IATOM,IBAND,1)+
     &  (-1)**(MY1+MY)*CONJG(DSTQAK(LM,-MY1,-MY,ISPIN1))*
     &  BHASK(LM,IATOM1,IKAP)
	D2OMATK(MY1,IATOM1,MY,IATOM,IBAND,1)=
     &D2OMATK(MY1,IATOM1,MY,IATOM,IBAND,1)+
     &  (-1)**(MY1+MY)*CONJG(DSTQAK(LM,-MY1,-MY,ISPIN1))*
     &  BOASK(LM,IATOM1,IKAP)
C B(k) x d2S(k+q,k)
	D2HMATK(MY1,IATOM,MY,IATOM1,IBAND,1)=
     &D2HMATK(MY1,IATOM,MY,IATOM1,IBAND,1)+
     &  BASHK(LM,IATOM1,IKAP)*DSTQAK(LM,MY1,MY,ISPIN)
	D2OMATK(MY1,IATOM,MY,IATOM1,IBAND,1)=
     &D2OMATK(MY1,IATOM,MY,IATOM1,IBAND,1)+
     &  BASOK(LM,IATOM1,IKAP)*DSTQAK(LM,MY1,MY,ISPIN)
C d2S(k,k+q) x B(k+q)
	D2HMATQ(MY1,IATOM,MY,IATOM1,IBAND,1)=
     &D2HMATQ(MY1,IATOM,MY,IATOM1,IBAND,1)+
     &  (-1)**(MY1+MY)*CONJG(DSTKAQ(LM,-MY1,-MY,ISPIN1))*
     &  BHASQ(LM,IATOM1,IKAP)
	D2OMATQ(MY1,IATOM,MY,IATOM1,IBAND,1)=
     &D2OMATQ(MY1,IATOM,MY,IATOM1,IBAND,1)+
     &  (-1)**(MY1+MY)*CONJG(DSTKAQ(LM,-MY1,-MY,ISPIN1))*
     &  BOASQ(LM,IATOM1,IKAP)
C B(k+q) x d2S(k,k+q)
	D2HMATQ(MY1,IATOM1,MY,IATOM,IBAND,1)=
     &D2HMATQ(MY1,IATOM1,MY,IATOM,IBAND,1)+
     &  BASHQ(LM,IATOM1,IKAP)*DSTKAQ(LM,MY1,MY,ISPIN)
	D2OMATQ(MY1,IATOM1,MY,IATOM,IBAND,1)=
     &D2OMATQ(MY1,IATOM1,MY,IATOM,IBAND,1)+
     &  BASOQ(LM,IATOM1,IKAP)*DSTKAQ(LM,MY1,MY,ISPIN)
	IF(LOG.AND.KDOT)THEN
C d2Sdot(k+q,k) x A(kl) x H(kappa)
	D2HMATK(MY1,IATOM1,MY,IATOM,IBAND,1)=
     &D2HMATK(MY1,IATOM1,MY,IATOM,IBAND,1)-
     &  (-1)**(MY1+MY)*CONJG(DSDQAK(LM,-MY1,-MY,ISPIN1))*
     &  APHK(LM,IATOM1,IKAP,ISPIN,IBAND)*HDOTPAR 
	D2OMATK(MY1,IATOM1,MY,IATOM,IBAND,1)=
     &D2OMATK(MY1,IATOM1,MY,IATOM,IBAND,1)-
     &  (-1)**(MY1+MY)*CONJG(DSDQAK(LM,-MY1,-MY,ISPIN1))*
     &  APHK(LM,IATOM1,IKAP,ISPIN,IBAND)*ODOTPAR
C d2Sdot(k,k+q) x B(k+q)
	D2HMATQ(MY1,IATOM,MY,IATOM1,IBAND,1)=
     &D2HMATQ(MY1,IATOM,MY,IATOM1,IBAND,1)-
     &  (-1)**(MY1+MY)*CONJG(DSDKAQ(LM,-MY1,-MY,ISPIN1))*
     &  APHQ(LM,IATOM1,IKAP,ISPIN,IBAND)*HDOTPAR
	D2OMATQ(MY1,IATOM,MY,IATOM1,IBAND,1)=
     &D2OMATQ(MY1,IATOM,MY,IATOM1,IBAND,1)-
     &  (-1)**(MY1+MY)*CONJG(DSDKAQ(LM,-MY1,-MY,ISPIN1))*
     &  APHQ(LM,IATOM1,IKAP,ISPIN,IBAND)*ODOTPAR
	ENDIF
C ADD DIAGONAL TERMS
C d2S(k,k) x B(k)
	D2HMATK(MY1,IATOM,MY,IATOM,IBAND,1)=
     &D2HMATK(MY1,IATOM,MY,IATOM,IBAND,1)-
     &  (-1)**(MY1+MY)*CONJG(DSTKAK(LM,-MY1,-MY,ISPIN1))*
     &  BHASK(LM,IATOM1,IKAP)
	D2OMATK(MY1,IATOM,MY,IATOM,IBAND,1)=
     &D2OMATK(MY1,IATOM,MY,IATOM,IBAND,1)-
     &  (-1)**(MY1+MY)*CONJG(DSTKAK(LM,-MY1,-MY,ISPIN1))*
     &  BOASK(LM,IATOM1,IKAP)
C B(k) x d2S(k,k)
	D2HMATK(MY1,IATOM1,MY,IATOM1,IBAND,1)=
     &D2HMATK(MY1,IATOM1,MY,IATOM1,IBAND,1)-
     &  BASHK(LM,IATOM1,IKAP)*DSTKAK(LM,MY1,MY,ISPIN)
	D2OMATK(MY1,IATOM1,MY,IATOM1,IBAND,1)=
     &D2OMATK(MY1,IATOM1,MY,IATOM1,IBAND,1)-
     &  BASOK(LM,IATOM1,IKAP)*DSTKAK(LM,MY1,MY,ISPIN)
C d2S(k+q,k+q) x B(k+q)
	D2HMATQ(MY1,IATOM1,MY,IATOM1,IBAND,1)=
     &D2HMATQ(MY1,IATOM1,MY,IATOM1,IBAND,1)-
     &  (-1)**(MY1+MY)*CONJG(DSTQAQ(LM,-MY1,-MY,ISPIN1))*
     &  BHASQ(LM,IATOM1,IKAP)
	D2OMATQ(MY1,IATOM1,MY,IATOM1,IBAND,1)=
     &D2OMATQ(MY1,IATOM1,MY,IATOM1,IBAND,1)-
     &  (-1)**(MY1+MY)*CONJG(DSTQAQ(LM,-MY1,-MY,ISPIN1))*
     &  BOASQ(LM,IATOM1,IKAP)
C B(k+q) x d2S(k+q,k+q)
	D2HMATQ(MY1,IATOM,MY,IATOM,IBAND,1)=
     &D2HMATQ(MY1,IATOM,MY,IATOM,IBAND,1)-
     &  BASHQ(LM,IATOM1,IKAP)*DSTQAQ(LM,MY1,MY,ISPIN)
	D2OMATQ(MY1,IATOM,MY,IATOM,IBAND,1)=
     &D2OMATQ(MY1,IATOM,MY,IATOM,IBAND,1)-
     &  BASOQ(LM,IATOM1,IKAP)*DSTQAQ(LM,MY1,MY,ISPIN)
	IF(LOG.AND.KDOT)THEN
C d2Sdot(k,k) x A(kl) x H(kappa)
	D2HMATK(MY1,IATOM,MY,IATOM,IBAND,1)=
     &D2HMATK(MY1,IATOM,MY,IATOM,IBAND,1)+
     &  (-1)**(MY1+MY)*CONJG(DSDKAK(LM,-MY1,-MY,ISPIN1))*
     &  APHK(LM,IATOM1,IKAP,ISPIN,IBAND)*HDOTPAR
	D2OMATK(MY1,IATOM,MY,IATOM,IBAND,1)=
     &D2OMATK(MY1,IATOM,MY,IATOM,IBAND,1)+
     &  (-1)**(MY1+MY)*CONJG(DSDKAK(LM,-MY1,-MY,ISPIN1))*
     &  APHK(LM,IATOM1,IKAP,ISPIN,IBAND)*ODOTPAR
C d2Sdot(k+q,k+q) x B(k+q)
	D2HMATQ(MY1,IATOM1,MY,IATOM1,IBAND,1)=
     &D2HMATQ(MY1,IATOM1,MY,IATOM1,IBAND,1)+
     &  (-1)**(MY1+MY)*CONJG(DSDQAQ(LM,-MY1,-MY,ISPIN1))*
     &  APHQ(LM,IATOM1,IKAP,ISPIN,IBAND)*HDOTPAR
	D2OMATQ(MY1,IATOM1,MY,IATOM1,IBAND,1)=
     &D2OMATQ(MY1,IATOM1,MY,IATOM1,IBAND,1)+
     &  (-1)**(MY1+MY)*CONJG(DSDQAQ(LM,-MY1,-MY,ISPIN1))*
     &  APHQ(LM,IATOM1,IKAP,ISPIN,IBAND)*ODOTPAR
	ENDIF
      ENDDO                                        !!! over m
      ENDDO                                        !!! over l
      ENDDO                                        !!! over my
      ENDDO                                        !!! over my1
C  END OF CALCULATING DYNAMICAL MATRIX CONTRIBUTION
 1000 CONTINUE                                     !!! over atoms
 2000 CONTINUE                                     !!! over atoms
 3000 CONTINUE                                     !!! over energies
 4000 CONTINUE                                     !!! over bands
 5000 CONTINUE                                     !!! over spin subbands
C
 6000 CONTINUE                                     !!! over iupdn
 7000 CONTINUE                                     !!! over iorbs
C Memory deallocations
	DEALLOCATE(BHASK,BASHK,BOASK,BASOK,BHASQ,BASHQ,BOASQ,BASOQ)
	DEALLOCATE(STKAK,STKAQ,STQAK,STQAQ,SDKAK,SDKAQ,SDQAK,SDQAQ)
	DEALLOCATE(DSTKAK,DSTKAQ,DSTQAK,DSTQAQ)
	DEALLOCATE(DSDKAK,DSDKAQ,DSDQAK,DSDQAQ)
	END     
