	SUBROUTINE DEL_D2TOSEND(MY1,INUC1,IPAN,IQPNT)
**************************************************************
*  Makes final dynamical matrix by adding LS,SL and LL terms.*
*  Programmed according to pages -F1...F7- of my notes.      *
*  Created 15.03.97                                          *
**************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
      USE COM_PHNCOM,  ONLY : ITERMAX,NITER                              !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_LATTICE, ONLY : TAU                                        !!! from readstr
	USE COM_QMESH,   ONLY : NQPNT,QPNT                                 !!! from readpnt
	USE COM_KAPPAR,  ONLY : NPAN,NKAP,EK,EKAP                          !!! from readini
	USE COM_LATPAR,  ONLY : PAR,ORTH,OMEGAC                            !!! from readini
	USE COM_SPHERE,  ONLY : SWZ,SMT                                    !!! from readini
	USE COM_NBANDS,  ONLY : NBNDF,NBNDE,NBNDT,NBNDC,NBNDH              !!! from readini
	USE COM_PLWMESH, ONLY : NPLW                                       !!! from makeplw
	USE COM_PANPAR,  ONLY : LTPAN,LSPAN,IATS,ISTS                      !!! from readini
	USE COM_ETAPAR,  ONLY : ETA,CUT,LBAS,NBAS                          !!! from makeplw
	USE COM_DYNMAT,  ONLY : BNDMAT                                     !!! from d2dynend
	USE COM_INDORB,  ONLY : INDLMT                                     !!! from readini
	USE COM_TEILORG, ONLY : KEYT,BZM,GOPT,MBAS                         !!! from makeplw
	USE COM_MASHDEP, ONLY : NVAL                                       !!! from setup
      USE COM_LMTOUT,  ONLY : SCNFILE                                    !!! from phn_storage
	USE COM_CHANNELS,ONLY : IUPDS,IUPIN                                !!! from channels
	USE COM_PHNCHN  ,ONLY : IUDYN,IUDMD,IUDIN                          !!! from channels
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: DXFUN0(:,:)
	COMPLEX*16, ALLOCATABLE :: DXFUNQ(:,:)
	COMPLEX*16, ALLOCATABLE :: DVINT0(:,:)
	COMPLEX*16, ALLOCATABLE :: DVINTQ(:,:)
	COMPLEX*16, ALLOCATABLE :: DRFUN0(:,:)
	COMPLEX*16, ALLOCATABLE :: DRFUNQ(:,:)
	COMPLEX*16, ALLOCATABLE :: DRINT0(:,:)
	COMPLEX*16, ALLOCATABLE :: DRINTQ(:,:)
	COMPLEX*16
     &     C10SL,C21SL,C22SL,C23SL,C24SL,C31SL
     &    ,C32SL,C41SL,C51SL,C52SL,C61SL,C62SL
     &    ,C11LS,C12LS,C13LS,C14LS,C20LS,C31LS
     &    ,C32LS,C41LS,C42LS,C51LS,C52LS,C60LS
     &    ,C11LL,C12LL,C13LL,C14LL,C21LL,C22LL
     &    ,C23LL,C24LL,C31LL,C32LL,C33LL,C34LL
     &    ,C41LL,C42LL,C51LL,C52LL,C53LL,C54LL
     &    ,C61LL,C62LL
	DATA PI/3.141592653589793D0/
	IF(KEYT.LE.0)RETURN
	IF(MODE.NE.4)RETURN
C Memory allocations
	ALLOCATE(DXFUN0(NBNDT(IPAN),0:MBASMEM))
	ALLOCATE(DXFUNQ(NBNDT(IPAN),0:MBASMEM))
	ALLOCATE(DVINT0(NBNDT(IPAN),NBNDT(IPAN)))
	ALLOCATE(DVINTQ(NBNDT(IPAN),NBNDT(IPAN)))
	ALLOCATE(DRFUN0(NBNDT(IPAN),0:MBASMEM))
	ALLOCATE(DRFUNQ(NBNDT(IPAN),0:MBASMEM))
	ALLOCATE(DRINT0(NBNDT(IPAN),NBNDT(IPAN)))
	ALLOCATE(DRINTQ(NBNDT(IPAN),NBNDT(IPAN)))
C  DO OVER SPINS
	DO 2000 IORBS=1,NORBS                                     !!! over iorbs
	DO 1000 IUPDN=1,NSPIN                                     !!! over iupdn
 	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
C  **** STEP 1, PAGE -F3- OF MY NOTES ****
C  READ DENSITY PARAMETERS
	IREC=1+2*(IUPDN-1)+2*NSPIN*(IORBS-1) !!! R0,T0
	READ(IUPDS,REC=IREC)((DRINT0(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DRFUN0(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
	IREC=2+2*(IUPDN-1)+2*NSPIN*(IORBS-1) !!! Sq,Tq
	READ(IUPDS,REC=IREC)((DRINTQ(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DRFUNQ(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
	DO MY0=-1,1                                   !!! over polarizations
C  READ MATRIX ELEMENTS
	IREC=1+2*(MY0+1)+6*(IUPDN-1)+6*NSPIN*(IORBS-1)+6*NSPIN*NORBS !!! D{m1m0}Y0,{m1m0}DV0
	READ(IUDYN,REC=IREC)((DVINT0(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DXFUN0(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
	IREC=2+2*(MY0+1)+6*(IUPDN-1)+6*NSPIN*(IORBS-1)+6*NSPIN*NORBS !!! D{m1m0}Xq,D{m1m0}Vq
	READ(IUDYN,REC=IREC)((DVINTQ(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DXFUNQ(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
	DO INUC0=1,NATOM                              !!! over displacements
	IF(NITER(MY0,INUC0).NE.0)THEN
	IF(INUC1.EQ.INUC0)THEN
C  SET CONVOLUTIONS
	CALL DEL_TRSUMLS(C24SL,'0N','0C',1,INUC0,IPAN,
     &                 DRFUN0,DRFUNQ,DXFUN0,DXFUNQ)
	BNDMAT(-MY1,INUC1,-MY0,INUC0,3,IPAN)=
     &BNDMAT(-MY1,INUC1,-MY0,INUC0,3,IPAN)+
     &  C24SL*(-1)**(MY1+MY0) ! ok
	CALL DEL_TRSUMLS(C14LS,'0C','0N',1,INUC0,IPAN,
     &                 DRFUN0,DRFUNQ,DXFUN0,DXFUNQ)
	BNDMAT(+MY1,INUC1,+MY0,INUC0,3,IPAN)=
     &BNDMAT(+MY1,INUC1,+MY0,INUC0,3,IPAN)+
     &  C14LS                 ! ok
	CALL DEL_TRSUMLL(C14LL,'0N','0N',1,INUC0,0,0,IPAN,
     &                 DRINT0,DRINTQ,DVINT0,DVINTQ)
	BNDMAT(+MY1,INUC1,+MY0,INUC0,3,IPAN)=
     &BNDMAT(+MY1,INUC1,+MY0,INUC0,3,IPAN)+
     &  C14LL                 ! ok
	CALL DEL_TRSUMLL(C24LL,'0N','0C',0,0,1,INUC0,IPAN,
     &                 DRINT0,DRINTQ,DVINT0,DVINTQ)
	BNDMAT(-MY1,INUC1,-MY0,INUC0,3,IPAN)=
     &BNDMAT(-MY1,INUC1,-MY0,INUC0,3,IPAN)+
     &  C24LL*(-1)**(MY1+MY0) ! ok
	ENDIF
	ENDIF
	ENDDO                                         !!! over displacements
	ENDDO                                         !!! over polarizations
	DO MY0=-1,1                                   !!! over polarizations
C  READ MATRIX ELEMENTS
	IREC=1+2*(MY0+1)+6*(IUPDN-1)+6*NSPIN*(IORBS-1) !!! D{m0}dX0/d{t1m1}, {m0}DdV0/d{t1m1}
	READ(IUDYN,REC=IREC)((DVINT0(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DXFUN0(IPAR1,
     &  IBAS),IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
	IREC=2+2*(MY0+1)+6*(IUPDN-1)+6*NSPIN*(IORBS-1) !!! D{m0}dYq/d{t1m1},D{m0}dVq/d{t1m1}
	READ(IUDYN,REC=IREC)((DVINTQ(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DXFUNQ(IPAR1,
     &  IBAS),IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
C  SET CONVOLUTIONS
	DO INUC0=1,NATOM                              !!! over displacements
	IF(NITER(MY0,INUC0).NE.0)THEN
	CALL DEL_TRSUMLS(C62SL,'QC','0N',1,INUC0,IPAN,
     &                 DRFUN0,DRFUNQ,DXFUN0,DXFUNQ)
	BNDMAT(+MY1,INUC1,+MY0,INUC0,3,IPAN)=
     &BNDMAT(+MY1,INUC1,+MY0,INUC0,3,IPAN)+
     &  C62SL                 ! ok
	CALL DEL_TRSUMLS(C42LS,'0C','QN',1,INUC0,IPAN,
     &                 DRFUN0,DRFUNQ,DXFUN0,DXFUNQ)
	BNDMAT(+MY1,INUC1,+MY0,INUC0,3,IPAN)=
     &BNDMAT(+MY1,INUC1,+MY0,INUC0,3,IPAN)+
     &  C42LS                 ! ok
	CALL DEL_TRSUMLL(C42LL,'0N','0N',1,INUC0,0,0,IPAN,
     &                 DRINT0,DRINTQ,DVINT0,DVINTQ)
	BNDMAT(+MY1,INUC1,+MY0,INUC0,3,IPAN)=
     &BNDMAT(+MY1,INUC1,+MY0,INUC0,3,IPAN)+
     &  C42LL                 ! ok
	CALL DEL_TRSUMLL(C62LL,'QN','QN',0,0,1,INUC0,IPAN,
     &                 DRINT0,DRINTQ,DVINT0,DVINTQ)
	BNDMAT(+MY1,INUC1,+MY0,INUC0,3,IPAN)=
     &BNDMAT(+MY1,INUC1,+MY0,INUC0,3,IPAN)+
     &  C62LL                 ! ok
	ENDIF
	ENDDO                                         !!! over displacements
	ENDDO                                         !!! over polarizations
	DO MY0=-1,1                                   !!! over polarizations
C  READ MATRIX ELEMENTS
	IREC=1+2*(MY1+1)+6*(IUPDN-1)+6*NSPIN*(IORBS-1)+8*NSPIN*NORBS !!! {m1}dV0{m0}
	READ(IUPIN,REC=IREC)(((DVINT0(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),MYX=-1,MY0)
	IREC=2+2*(MY1+1)+6*(IUPDN-1)+6*NSPIN*(IORBS-1)+8*NSPIN*NORBS !!! {m0}dVq{m1}
	READ(IUPIN,REC=IREC)(((DVINTQ(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),MYX=-1,MY0)
C  SET CONVOLUTIONS
	DO INUC0=1,NATOM                              !!! over displacements
	IF(NITER(MY0,INUC0).NE.0)THEN
	CALL DEL_TRSUMLL(C34LL,'0N','QN',1,INUC0,1,INUC1,IPAN,
     &                 DRINT0,DRINTQ,DVINT0,DVINTQ)
	BNDMAT(+MY1,INUC1,+MY0,INUC0,3,IPAN)=
     &BNDMAT(+MY1,INUC1,+MY0,INUC0,3,IPAN)+
     &  C34LL                 ! ok
	CALL DEL_TRSUMLL(C54LL,'QN','0N',1,INUC1,1,INUC0,IPAN,
     &                 DRINT0,DRINTQ,DVINT0,DVINTQ)
	BNDMAT(+MY1,INUC1,+MY0,INUC0,3,IPAN)=
     &BNDMAT(+MY1,INUC1,+MY0,INUC0,3,IPAN)+
     &  C54LL                 ! ok
	ENDIF
	ENDDO                                         !!! over displacements
	ENDDO                                         !!! over polarizations
C  **** STEP 2, PAGE -F4- OF MY NOTES ****
C  READ DENSITY PARAMETERS
	IREC=1+2*(IUPDN-1)+2*NSPIN*(IORBS-1)+11*NSPIN*NORBS !!! R0{m1},T0{m1}
	READ(IUDMD,REC=IREC)((DRINT0(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DRFUN0(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
	IREC=2+2*(IUPDN-1)+2*NSPIN*(IORBS-1)+11*NSPIN*NORBS !!! Sq{m1},Tq{m1}
	READ(IUDMD,REC=IREC)((DRINTQ(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DRFUNQ(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
	DO MY0=-1,1                                   !!! over polarizations
C  READ MATRIX ELEMENTS
	IREC=1+2*(MY0+1)+6*(IUPDN-1)+6*NSPIN*(IORBS-1)+2*NSPIN*NORBS !!! d{m0}Y0,{m0}DV0
	READ(IUPIN,REC=IREC)((DVINT0(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DXFUN0(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
	IREC=2+2*(MY0+1)+6*(IUPDN-1)+6*NSPIN*(IORBS-1)+2*NSPIN*NORBS !!! d{m0}Xq,D{m0}Vq
	READ(IUPIN,REC=IREC)((DVINTQ(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DXFUNQ(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
C  SET CONVOLUTIONS
	DO INUC0=1,NATOM                              !!! over displacements
	IF(NITER(MY0,INUC0).NE.0)THEN
	IF(INUC1.EQ.INUC0)THEN
	CALL DEL_TRSUMLS(C22SL,'0N','0C',1,INUC0,IPAN,
     &                 DRFUN0,DRFUNQ,DXFUN0,DXFUNQ)
	BNDMAT(+MY1,INUC1,-MY0,INUC0,3,IPAN)=
     &BNDMAT(+MY1,INUC1,-MY0,INUC0,3,IPAN)+
     &  C22SL*(-1)**MY0       ! ok
	CALL DEL_TRSUMLS(C12LS,'0C','0N',1,INUC0,IPAN,
     &                 DRFUN0,DRFUNQ,DXFUN0,DXFUNQ)
	BNDMAT(-MY1,INUC1,+MY0,INUC0,3,IPAN)=
     &BNDMAT(-MY1,INUC1,+MY0,INUC0,3,IPAN)+
     &  C12LS*(-1)**MY1       ! ok
	CALL DEL_TRSUMLS(C23SL,'0N','0C',1,INUC1,IPAN,
     &                 DRFUN0,DRFUNQ,DXFUN0,DXFUNQ)
	BNDMAT(-MY0,INUC0,+MY1,INUC1,3,IPAN)=
     &BNDMAT(-MY0,INUC0,+MY1,INUC1,3,IPAN)+
     &  C23SL*(-1)**MY0       ! ok
	CALL DEL_TRSUMLS(C13LS,'0C','0N',1,INUC1,IPAN,
     &                 DRFUN0,DRFUNQ,DXFUN0,DXFUNQ)
	BNDMAT(+MY0,INUC0,-MY1,INUC1,3,IPAN)=
     &BNDMAT(+MY0,INUC0,-MY1,INUC1,3,IPAN)+
     &  C13LS*(-1)**MY1       ! ok
	CALL DEL_TRSUMLL(C12LL,'0N','0N',1,INUC0,0,0,IPAN,
     &                 DRINT0,DRINTQ,DVINT0,DVINTQ)
	BNDMAT(+MY1,INUC1,+MY0,INUC0,3,IPAN)=
     &BNDMAT(+MY1,INUC1,+MY0,INUC0,3,IPAN)+
     &  C12LL*(-1) ! sign minus here !
	CALL DEL_TRSUMLL(C22LL,'0N','0C',0,0,1,INUC0,IPAN,
     &                 DRINT0,DRINTQ,DVINT0,DVINTQ)
	BNDMAT(+MY1,INUC1,-MY0,INUC0,3,IPAN)=
     &BNDMAT(+MY1,INUC1,-MY0,INUC0,3,IPAN)+
     &  C22LL*(-1)**MY0       ! ok
	CALL DEL_TRSUMLL(C13LL,'0N','0N',1,INUC1,0,0,IPAN,
     &                 DRINT0,DRINTQ,DVINT0,DVINTQ)
	BNDMAT(+MY0,INUC0,+MY1,INUC1,3,IPAN)=
     &BNDMAT(+MY0,INUC0,+MY1,INUC1,3,IPAN)+
     &  C13LL*(-1) ! sign minus here !
	CALL DEL_TRSUMLL(C23LL,'0N','0C',0,0,1,INUC1,IPAN,
     &                 DRINT0,DRINTQ,DVINT0,DVINTQ)
	BNDMAT(-MY0,INUC0,+MY1,INUC1,3,IPAN)=
     &BNDMAT(-MY0,INUC0,+MY1,INUC1,3,IPAN)+
     &  C23LL*(-1)**MY0      ! ok
	ENDIF
	CALL DEL_TRSUMLL(C32LL,'0N','QC',1,INUC0,1,INUC1,IPAN,
     &                 DRINT0,DRINTQ,DVINT0,DVINTQ)
	BNDMAT(+MY1,INUC1,-MY0,INUC0,3,IPAN)=
     &BNDMAT(+MY1,INUC1,-MY0,INUC0,3,IPAN)+
     &  C32LL*(-1)**MY0      ! ok
	CALL DEL_TRSUMLL(C53LL,'QN','0C',1,INUC1,1,INUC0,IPAN,
     &                 DRINT0,DRINTQ,DVINT0,DVINTQ)
	BNDMAT(+MY1,INUC1,-MY0,INUC0,3,IPAN)=
     &BNDMAT(+MY1,INUC1,-MY0,INUC0,3,IPAN)+
     &  C53LL*(-1)**MY0*(-1) ! sign minus here !
	CALL DEL_TRSUMLL(C52LL,'QN','0N',1,INUC0,1,INUC1,IPAN,
     &                 DRINT0,DRINTQ,DVINT0,DVINTQ)
	BNDMAT(+MY0,INUC0,+MY1,INUC1,3,IPAN)=
     &BNDMAT(+MY0,INUC0,+MY1,INUC1,3,IPAN)+
     &  C52LL                ! ok
	CALL DEL_TRSUMLL(C33LL,'0N','QN',1,INUC1,1,INUC0,IPAN,
     &                 DRINT0,DRINTQ,DVINT0,DVINTQ)
	BNDMAT(+MY0,INUC0,+MY1,INUC1,3,IPAN)=
     &BNDMAT(+MY0,INUC0,+MY1,INUC1,3,IPAN)+
     &  C33LL*(-1) ! sign minus here !
	ENDIF
	ENDDO                                         !!! over displacements
	ENDDO                                         !!! over polarizations
C  **** STEP 3, PAGE -F5- OF MY NOTES ****
C  READ DENSITY PARAMETERS
	IREC=1+2*(IUPDN-1)+2*NSPIN*(IORBS-1)+11*NSPIN*NORBS !!! R0{m1},T0{m1}
	READ(IUDMD,REC=IREC)((DRINT0(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DRFUN0(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
	IREC=2+2*(IUPDN-1)+2*NSPIN*(IORBS-1)+11*NSPIN*NORBS !!! Sq{m1},Tq{m1}
	READ(IUDMD,REC=IREC)((DRINTQ(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DRFUNQ(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
	DO INUC0=1,NATOM                              !!! over displacements
	DO MY0=-1,1                                   !!! over polarizations
	IF(NITER(MY0,INUC0).NE.0)THEN
C  READ MATRIX ELEMENTS
      NRECL=NVAL*(NBNDT(IPAN)*(MIN(NBAS,MBAS)+1)+
     &NBNDT(IPAN)**2)
      OPEN(UNIT=IUDIN,FILE=SCNFILE(MY0,INUC0,IUDIN),STATUS='OLD',
     &ACCESS='DIRECT',FORM='UNFORMATTED',RECL=NRECL)
	IREC=1+2*(IUPDN-1)+2*NSPIN*(IORBS-1)          !!! dX0/d{t0m0},dV/d{t0m0}
	READ(IUDIN,REC=IREC)((DVINT0(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DXFUN0(IPAR1,
     &  IBAS),IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
	IREC=2+2*(IUPDN-1)+2*NSPIN*(IORBS-1)          !!! dYq/d{t0m0},dV/d{t0m0}
	READ(IUDIN,REC=IREC)((DVINTQ(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DXFUNQ(IPAR1,
     &  IBAS),IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
	CLOSE(IUDIN)
C  SET CONVOLUTIONS
	CALL DEL_TRSUMLS(C61SL,'QC','0N',1,INUC1,IPAN,
     &                 DRFUN0,DRFUNQ,DXFUN0,DXFUNQ)
	BNDMAT(+MY0,INUC0,-MY1,INUC1,3,IPAN)=
     &BNDMAT(+MY0,INUC0,-MY1,INUC1,3,IPAN)+
     &  C61SL*(-1)**MY1      ! ok
	CALL DEL_TRSUMLS(C41LS,'0C','QN',1,INUC1,IPAN,
     &                 DRFUN0,DRFUNQ,DXFUN0,DXFUNQ)
	BNDMAT(+MY0,INUC0,-MY1,INUC1,3,IPAN)=
     &BNDMAT(+MY0,INUC0,-MY1,INUC1,3,IPAN)+
     &  C41LS*(-1)**MY1      ! ok
	CALL DEL_TRSUMLL(C41LL,'0N','0N',1,INUC1,0,0,IPAN,
     &                 DRINT0,DRINTQ,DVINT0,DVINTQ)
	BNDMAT(+MY0,INUC0,+MY1,INUC1,3,IPAN)=
     &BNDMAT(+MY0,INUC0,+MY1,INUC1,3,IPAN)+
     &  C41LL*(-1) ! sign minus here !
	CALL DEL_TRSUMLL(C61LL,'QN','QN',0,0,1,INUC1,IPAN,
     &                 DRINT0,DRINTQ,DVINT0,DVINTQ)
	BNDMAT(+MY0,INUC0,+MY1,INUC1,3,IPAN)=
     &BNDMAT(+MY0,INUC0,+MY1,INUC1,3,IPAN)+
     &  C61LL                ! ok
	ENDIF
	ENDDO                                         !!! over polarizations
	ENDDO                                         !!! over displacements
C  **** STEP 4, PAGE -F5- OF MY NOTES ****
C  READ MATRIX ELEMENTS
	IREC=1+2*(IUPDN-1)+2*NSPIN*(IORBS-1) !!! Y0,V0
	READ(IUPIN,REC=IREC)((DVINT0(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DXFUN0(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
	IREC=2+2*(IUPDN-1)+2*NSPIN*(IORBS-1) !!! Xq,Vq
	READ(IUPIN,REC=IREC)((DVINTQ(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DXFUNQ(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
	DO MY0=-1,1                                   !!! over polarizations
C  READ DENSITY PARAMETERS
	IREC=1+2*(MY0+1)+6*(IUPDN-1)+6*NSPIN*(IORBS-1)+13*NSPIN*NORBS !!! R0{m1m0},T0{m1m0}
	READ(IUDMD,REC=IREC)((DRINT0(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DRFUN0(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
	IREC=2+2*(MY0+1)+6*(IUPDN-1)+6*NSPIN*(IORBS-1)+13*NSPIN*NORBS !!! Sq{m1m0},Tq{m1m0}
	READ(IUDMD,REC=IREC)((DRINTQ(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DRFUNQ(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
C  SET CONVOLUTIONS
	DO INUC0=1,NATOM                              !!! over displacements
	IF(NITER(MY0,INUC0).NE.0)THEN
	IF(INUC1.EQ.INUC0)THEN
	CALL DEL_TRSUMLS(C21SL,'0N','0C',1,INUC0,IPAN,
     &                 DRFUN0,DRFUNQ,DXFUN0,DXFUNQ)
	BNDMAT(+MY1,INUC1,+MY0,INUC0,3,IPAN)=
     &BNDMAT(+MY1,INUC1,+MY0,INUC0,3,IPAN)+
     &  C21SL                ! ok
	CALL DEL_TRSUMLS(C11LS,'0C','0N',1,INUC0,IPAN,
     &                 DRFUN0,DRFUNQ,DXFUN0,DXFUNQ)
	BNDMAT(-MY1,INUC1,-MY0,INUC0,3,IPAN)=
     &BNDMAT(-MY1,INUC1,-MY0,INUC0,3,IPAN)+
     &  C11LS*(-1)**(MY1+MY0)! ok
	CALL DEL_TRSUMLL(C11LL,'0N','0N',1,INUC0,0,0,IPAN,
     &                 DRINT0,DRINTQ,DVINT0,DVINTQ)
	BNDMAT(+MY1,INUC1,+MY0,INUC0,3,IPAN)=
     &BNDMAT(+MY1,INUC1,+MY0,INUC0,3,IPAN)+
     &  C11LL                ! ok
	CALL DEL_TRSUMLL(C21LL,'0N','0N',0,0,1,INUC0,IPAN,
     &                 DRINT0,DRINTQ,DVINT0,DVINTQ)
	BNDMAT(+MY1,INUC1,+MY0,INUC0,3,IPAN)=
     &BNDMAT(+MY1,INUC1,+MY0,INUC0,3,IPAN)+
     &  C21LL                ! ok
	ENDIF
	CALL DEL_TRSUMLL(C31LL,'0N','QN',1,INUC0,1,INUC1,IPAN,
     &                 DRINT0,DRINTQ,DVINT0,DVINTQ)
	BNDMAT(+MY1,INUC1,+MY0,INUC0,3,IPAN)=
     &BNDMAT(+MY1,INUC1,+MY0,INUC0,3,IPAN)+
     &  C31LL*(-1) ! sign minus here !
	CALL DEL_TRSUMLL(C51LL,'QN','0N',1,INUC1,1,INUC0,IPAN,
     &                 DRINT0,DRINTQ,DVINT0,DVINTQ)
	BNDMAT(+MY1,INUC1,+MY0,INUC0,3,IPAN)=
     &BNDMAT(+MY1,INUC1,+MY0,INUC0,3,IPAN)+
     &  C51LL*(-1) ! sign minus here !
	ENDIF
	ENDDO                                         !!! over displacements
	ENDDO                                         !!! over polarizations
C  **** STEP 5, PAGE -F6- OF MY NOTES ****
C  READ DENSITY PARAMETERS
	IREC=1+2*(IUPDN-1)+2*NSPIN*(IORBS-1) !!! D{t1m1}S0
	READ(IUDMD,REC=IREC)((DRFUN0(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
	IREC=2+2*(IUPDN-1)+2*NSPIN*(IORBS-1) !!! D{t1m1}Rq
	READ(IUDMD,REC=IREC)((DRFUNQ(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
	DO MY0=-1,1                                   !!! over polarizations
C  READ MATRIX ELEMENTS
	IREC=1+2*(MY0+1)+6*(IUPDN-1)+6*NSPIN*(IORBS-1)+2*NSPIN*NORBS !!! d{m0}Y0,{m0}DV0
	READ(IUPIN,REC=IREC)((DVINT0(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DXFUN0(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
	IREC=2+2*(MY0+1)+6*(IUPDN-1)+6*NSPIN*(IORBS-1)+2*NSPIN*NORBS !!! d{m0}Xq,D{m0}Vq
	READ(IUPIN,REC=IREC)((DVINTQ(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DXFUNQ(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
	DO INUC0=1,NATOM                              !!! over displacements
	IF(NITER(MY0,INUC0).NE.0)THEN
	CALL DEL_TRSUMLS(C52SL,'QN','0C',1,INUC0,IPAN,
     &                 DRFUN0,DRFUNQ,DXFUN0,DXFUNQ)
	BNDMAT(+MY1,INUC1,-MY0,INUC0,3,IPAN)=
     &BNDMAT(+MY1,INUC1,-MY0,INUC0,3,IPAN)+
     &  C52SL*(-1)**MY0      ! ok
	CALL DEL_TRSUMLS(C32LS,'0N','QC',1,INUC0,IPAN,
     &                 DRFUN0,DRFUNQ,DXFUN0,DXFUNQ)
	BNDMAT(+MY1,INUC1,-MY0,INUC0,3,IPAN)=
     &BNDMAT(+MY1,INUC1,-MY0,INUC0,3,IPAN)+
     &  C32LS*(-1)**MY0      ! ok
	CALL DEL_TRSUMLS(C32SL,'0C','QN',1,INUC0,IPAN,
     &                 DRFUN0,DRFUNQ,DXFUN0,DXFUNQ)
	BNDMAT(+MY0,INUC0,-MY1,INUC1,3,IPAN)=
     &BNDMAT(+MY0,INUC0,-MY1,INUC1,3,IPAN)+
     &  C32SL*(-1)**MY1      ! ok
	CALL DEL_TRSUMLS(C52LS,'QC','0N',1,INUC0,IPAN,
     &                 DRFUN0,DRFUNQ,DXFUN0,DXFUNQ)
	BNDMAT(+MY0,INUC0,-MY1,INUC1,3,IPAN)=
     &BNDMAT(+MY0,INUC0,-MY1,INUC1,3,IPAN)+
     &  C52LS*(-1)**MY1      ! ok
	ENDIF
	ENDDO                                         !!! over displacements
	ENDDO                                         !!! over polarizations
C  **** STEP 6, PAGE -F6- OF MY NOTES ****
C  READ DENSITY PARAMETERS
	IREC=1+2*(IUPDN-1)+2*NSPIN*(IORBS-1) !!! D{t1m1}S0
	READ(IUDMD,REC=IREC)((DRFUN0(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
	IREC=2+2*(IUPDN-1)+2*NSPIN*(IORBS-1) !!! D{t1m1}Rq
	READ(IUDMD,REC=IREC)((DRFUNQ(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
	DO INUC0=1,NATOM                              !!! over displacements
	DO MY0=-1,1                                   !!! over polarizations
	IF(NITER(MY0,INUC0).NE.0)THEN
C  READ MATRIX ELEMENTS
      NRECL=NVAL*(NBNDT(IPAN)*(MIN(NBAS,MBAS)+1)+
     &NBNDT(IPAN)**2)
      OPEN(UNIT=IUDIN,FILE=SCNFILE(MY0,INUC0,IUDIN),STATUS='OLD',
     &ACCESS='DIRECT',FORM='UNFORMATTED',RECL=NRECL)
	IREC=1+2*(IUPDN-1)+2*NSPIN*(IORBS-1)           !!! dX0/d{t1m1},dV/d{t1m1}
	READ(IUDIN,REC=IREC)((DVINT0(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DXFUN0(IPAR1,
     &  IBAS),IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
	IREC=2+2*(IUPDN-1)+2*NSPIN*(IORBS-1)           !!! dYq/d{t1m1},dV/d{t1m1}
	READ(IUDIN,REC=IREC)((DVINT0(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DXFUNQ(IPAR1,
     &  IBAS),IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
	CLOSE(IUDIN)
C  SET CONVOLUTIONS
	CALL DEL_TRSUMLS(C41SL,'0C','0N',0,0,IPAN,
     &                 DRFUN0,DRFUNQ,DXFUN0,DXFUNQ)
	BNDMAT(+MY0,INUC0,-MY1,INUC1,3,IPAN)=
     &BNDMAT(+MY0,INUC0,-MY1,INUC1,3,IPAN)+
     &  C41SL*(-1)**MY1      ! ok
	CALL DEL_TRSUMLS(C60LS,'QC','QN',0,0,IPAN,
     &                 DRFUN0,DRFUNQ,DXFUN0,DXFUNQ)
	BNDMAT(+MY0,INUC0,-MY1,INUC1,3,IPAN)=
     &BNDMAT(+MY0,INUC0,-MY1,INUC1,3,IPAN)+
     &  C60LS*(-1)**MY1      ! ok
	ENDIF
	ENDDO                                         !!! over polarizations
	ENDDO                                         !!! over displacements
C  **** STEP 7, PAGE -F7- OF MY NOTES ****
C  READ MATRIX ELEMENTS
	IREC=1+2*(IUPDN-1)+2*NSPIN*(IORBS-1) !!! Y0,V0
	READ(IUPIN,REC=IREC)((DVINT0(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DXFUN0(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
	IREC=2+2*(IUPDN-1)+2*NSPIN*(IORBS-1) !!! Xq,Vq
	READ(IUPIN,REC=IREC)((DVINTQ(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DXFUNQ(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
	DO MY0=-1,1                                   !!! over polarizations
C  READ DENSITY PARAMETERS
	IREC=1+2*(MY0+1)+6*(IUPDN-1)+6*NSPIN*(IORBS-1)+2*NSPIN*NORBS !!! D{t1m1}S0{m0}
	READ(IUDMD,REC=IREC)((DRFUN0(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
	IREC=2+2*(MY0+1)+6*(IUPDN-1)+6*NSPIN*(IORBS-1)+2*NSPIN*NORBS !!! D{t1m1}Rq{m0}
	READ(IUDMD,REC=IREC)((DRFUNQ(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
C  SET CONVOLUTIONS
	DO INUC0=1,NATOM                              !!! over displacements
	IF(NITER(MY0,INUC0).NE.0)THEN
	CALL DEL_TRSUMLS(C51SL,'QN','0C',1,INUC0,IPAN,
     &                 DRFUN0,DRFUNQ,DXFUN0,DXFUNQ)
	BNDMAT(+MY1,INUC1,+MY0,INUC0,3,IPAN)=
     &BNDMAT(+MY1,INUC1,+MY0,INUC0,3,IPAN)+
     &  C51SL                ! ok
	CALL DEL_TRSUMLS(C31LS,'0N','QC',1,INUC0,IPAN,
     &                 DRFUN0,DRFUNQ,DXFUN0,DXFUNQ)
	BNDMAT(+MY1,INUC1,+MY0,INUC0,3,IPAN)=
     &BNDMAT(+MY1,INUC1,+MY0,INUC0,3,IPAN)+
     &  C31LS                ! ok
	CALL DEL_TRSUMLS(C31SL,'0C','QN',1,INUC0,IPAN,
     &                 DRFUN0,DRFUNQ,DXFUN0,DXFUNQ)
	BNDMAT(-MY0,INUC0,-MY1,INUC1,3,IPAN)=
     &BNDMAT(-MY0,INUC0,-MY1,INUC1,3,IPAN)+
     &  C31SL*(-1)**(MY1+MY0)! ok
	CALL DEL_TRSUMLS(C51LS,'QC','0N',1,INUC0,IPAN,
     &                 DRFUN0,DRFUNQ,DXFUN0,DXFUNQ)
	BNDMAT(-MY0,INUC0,-MY1,INUC1,3,IPAN)=
     &BNDMAT(-MY0,INUC0,-MY1,INUC1,3,IPAN)+
     &  C51LS*(-1)**(MY1+MY0)! ok
	ENDIF
	ENDDO                                         !!! over displacements
	ENDDO                                         !!! over polarizations
C  **** STEP 8, PAGE -F7- OF MY NOTES ****
C  READ MATRIX ELEMENTS
	IREC=1+2*(IUPDN-1)+2*NSPIN*(IORBS-1) !!! Y0,V0
	READ(IUPIN,REC=IREC)((DVINT0(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DXFUN0(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
	IREC=2+2*(IUPDN-1)+2*NSPIN*(IORBS-1) !!! Xq,Vq
	READ(IUPIN,REC=IREC)((DVINTQ(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DXFUNQ(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
	DO MY0=-1,1                                   !!! over polarizations
C  READ DENSITY PARAMETERS
	IREC=MY0+2+3*(IUPDN-1)+3*NSPIN*(IORBS-1)+8*NSPIN*NORBS !!! d{m0}d{t1m1}S0
	READ(IUDMD,REC=IREC)((DRFUN0(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
C  SET CONVOLUTIONS
	DO INUC0=1,NATOM                              !!! over displacements
	IF(NITER(MY0,INUC0).NE.0)THEN
	IF(INUC1.EQ.INUC0)THEN
	CALL DEL_TRSUMLS(C10SL,'0C','0C',0,0,IPAN,
     &                 DRFUN0,DRFUNQ,DXFUN0,DXFUNQ)
	BNDMAT(-MY0,INUC0,-MY1,INUC1,3,IPAN)=
     &BNDMAT(-MY0,INUC0,-MY1,INUC1,3,IPAN)+
     &  C10SL*(-1)**(MY1+MY0)! ok
	CALL DEL_TRSUMLS(C20LS,'0N','0N',0,0,IPAN,
     &                 DRFUN0,DRFUNQ,DXFUN0,DXFUNQ)
	BNDMAT(+MY0,INUC0,+MY1,INUC1,3,IPAN)=
     &BNDMAT(+MY0,INUC0,+MY1,INUC1,3,IPAN)+
     &  C20LS                ! ok
	ENDIF 
	ENDIF
	ENDDO                                         !!! over displacements
	ENDDO                                         !!! over polarizations
C
 1000 CONTINUE                                      !!! over iupdn
 2000 CONTINUE                                      !!! over iupdn
C Deallocations
	DEALLOCATE(DXFUN0,DXFUNQ,DVINT0,DVINTQ)
	DEALLOCATE(DRFUN0,DRFUNQ,DRINT0,DRINTQ)
	END







	SUBROUTINE DEL_TRSUMLS(CSUMLS,TR,TX,IAVD,INUC,IPAN,
     &           DRFUN0,DRFUNQ,DXFUN0,DXFUNQ)
*********************************************************
* Makes a summation for LS-contribution                 *
*********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_KAPPAR,  ONLY : NPAN,NKAP,EK,EKAP                          !!! from readini
	USE COM_PANPAR,  ONLY : LTPAN,LSPAN,IATS,ISTS                      !!! from readini
	USE COM_NBANDS,  ONLY : NBNDF,NBNDE,NBNDT,NBNDC,NBNDH              !!! from readini
	USE COM_PLWMESH, ONLY : NPLW                                       !!! from makeplw
	USE COM_ETAPAR,  ONLY : ETA,CUT,LBAS,NBAS                          !!! from makeplw
	USE COM_INDORB,  ONLY : INDLMT                                     !!! from readini
	USE COM_TEILORG, ONLY : KEYT,BZM,GOPT,MBAS                         !!! from makeplw
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16 
     &    DRFUN0(NBNDT(IPAN),0:MBASMEM),DRFUNQ(NBNDT(IPAN),0:MBASMEM)
     &   ,DXFUN0(NBNDT(IPAN),0:MBASMEM),DXFUNQ(NBNDT(IPAN),0:MBASMEM)
	COMPLEX*16, ALLOCATABLE :: RFUN(:)
	COMPLEX*16, ALLOCATABLE :: XFUN(:)
	COMPLEX*16 CSUMLS
	CHARACTER TR*2,TX*2
	DATA PI/3.141592653589793D0/
C Memory allocations
	ALLOCATE(RFUN(0:MBASMEM))
	ALLOCATE(XFUN(0:MBASMEM))
	CSUMLS=(0.D0,0.D0)
	DO IATOM=1,NATOM                             !!! over iatom
	ISORT=IS(IATOM)
	DO IKAP=1,NKAP(IPAN)                         !!! over energy
	IF(IATOM.NE.INUC.AND.IAVD.EQ.1)EXIT
	DO L=0,ILSB(ISORT)                           !!! over l
	DO M=-L,L                                    !!! over m
	IF(.NOT.LTPAN(L,IATOM,IKAP,IPAN))EXIT
	LM=L*(L+1)+M+1
	IPAR=INDLMT(LM,IATOM,IKAP,1,IPAN)
C SET RFUN ACCORDING TO <<TR>>
	    IF(TR.EQ.'0N')THEN
	DO IBAS=0,MIN(NBAS,MBAS)
	RFUN(IBAS)=DRFUN0(IPAR,IBAS)
	ENDDO
	ELSEIF(TR.EQ.'0C')THEN
	DO IBAS=0,MIN(NBAS,MBAS)
	RFUN(IBAS)=DCONJG(DRFUN0(IPAR,IBAS))
	ENDDO
	ELSEIF(TR.EQ.'QN')THEN
	DO IBAS=0,MIN(NBAS,MBAS)
	RFUN(IBAS)=DRFUNQ(IPAR,IBAS)
	ENDDO
	ELSEIF(TR.EQ.'QC')THEN
	DO IBAS=0,MIN(NBAS,MBAS)
	RFUN(IBAS)=DCONJG(DRFUNQ(IPAR,IBAS))
	ENDDO
	ENDIF
C SET XFUN ACCORDING TO <<TX>>
	    IF(TX.EQ.'0N')THEN
	DO IBAS=0,MIN(NBAS,MBAS)
	XFUN(IBAS)=DXFUN0(IPAR,IBAS)
	ENDDO
	ELSEIF(TX.EQ.'0C')THEN
	DO IBAS=0,MIN(NBAS,MBAS)
	XFUN(IBAS)=DCONJG(DXFUN0(IPAR,IBAS))
	ENDDO
	ELSEIF(TX.EQ.'QN')THEN
	DO IBAS=0,MIN(NBAS,MBAS)
	XFUN(IBAS)=DXFUNQ(IPAR,IBAS)
	ENDDO
	ELSEIF(TX.EQ.'QC')THEN
	DO IBAS=0,MIN(NBAS,MBAS)
	XFUN(IBAS)=DCONJG(DXFUNQ(IPAR,IBAS))
	ENDDO
	ENDIF
C SUM UP
	DO IBAS=0,MIN(NBAS,MBAS)
	CSUMLS=CSUMLS+RFUN(IBAS)*XFUN(IBAS)
	ENDDO
	ENDDO                                        !!! over m
	ENDDO                                        !!! over l
	ENDDO                                        !!! over energy
	ENDDO                                        !!! over iatom
	DEALLOCATE(RFUN,XFUN)
	END




	SUBROUTINE DEL_TRSUMLL(CSUMLL,TR,TX,IAVD1,INUC1,IAVD,
     &           INUC,IPAN,DRINT0,DRINTQ,DVINT0,DVINTQ)
*********************************************************
* Makes a summation for LS-contribution                 *
*********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_KAPPAR,  ONLY : NPAN,NKAP,EK,EKAP                          !!! from readini
	USE COM_PANPAR,  ONLY : LTPAN,LSPAN,IATS,ISTS                      !!! from readini
	USE COM_NBANDS,  ONLY : NBNDF,NBNDE,NBNDT,NBNDC,NBNDH              !!! from readini
	USE COM_ETAPAR,  ONLY : ETA,CUT,LBAS,NBAS                          !!! from makeplw
	USE COM_INDORB,  ONLY : INDLMT                                     !!! from readini
	USE COM_PLWMESH, ONLY : NPLW                                       !!! from makeplw
	USE COM_TEILORG, ONLY : KEYT,BZM,GOPT,MBAS                         !!! from makeplw
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16 CSUMLL,RINT,XINT
     &   ,DRINT0(NBNDT(IPAN),NBNDT(IPAN))
     &   ,DRINTQ(NBNDT(IPAN),NBNDT(IPAN))
     &   ,DVINT0(NBNDT(IPAN),NBNDT(IPAN))
     &   ,DVINTQ(NBNDT(IPAN),NBNDT(IPAN))
	CHARACTER TR*2,TX*2
	DATA PI/3.141592653589793D0/
	CSUMLL=(0.D0,0.D0)
	DO IATOM1=1,NATOM                            !!! over iatom1
	ISORT1=IS(IATOM1)
	DO IKAP1=1,NKAP(IPAN)                        !!! over energy
	IF(IATOM1.NE.INUC1.AND.IAVD1.EQ.1)EXIT
	DO L1=0,ILSB(ISORT1)                         !!! over l1
	DO M1=-L1,L1                                 !!! over m1
	IF(.NOT.LTPAN(L1,IATOM1,IKAP1,IPAN))EXIT
	L1M1=L1*(L1+1)+M1+1
	IPAR1=INDLMT(L1M1,IATOM1,IKAP1,1,IPAN)
	DO IATOM=1,NATOM                             !!! over iatom
	ISORT=IS(IATOM)
	DO IKAP=1,NKAP(IPAN)                         !!! over energy
	IF(IATOM.NE.INUC.AND.IAVD.EQ.1)EXIT
	DO L=0,ILSB(ISORT)                           !!! over l
	DO M=-L,L                                    !!! over m
	IF(.NOT.LTPAN(L,IATOM,IKAP,IPAN))EXIT
	LM=L*(L+1)+M+1
	IPAR=INDLMT(LM,IATOM,IKAP,1,IPAN)
C SET RINT ACCORDING TO <<TR>>
	    IF(TR.EQ.'0N')THEN
	RINT=DRINT0(IPAR1,IPAR)
	ELSEIF(TR.EQ.'0C')THEN
	RINT=DCONJG(DRINT0(IPAR,IPAR1))
	ELSEIF(TR.EQ.'QN')THEN
	RINT=DRINTQ(IPAR1,IPAR)
	ELSEIF(TR.EQ.'QC')THEN
	RINT=DCONJG(DRINTQ(IPAR,IPAR1))
	ENDIF
C SET XINT ACCORDING TO <<TX>>
	    IF(TX.EQ.'0N')THEN
	XINT=DVINT0(IPAR1,IPAR)
	ELSEIF(TX.EQ.'0C')THEN
	XINT=DCONJG(DVINT0(IPAR,IPAR1))
	ELSEIF(TX.EQ.'QN')THEN
	XINT=DVINTQ(IPAR1,IPAR)
	ELSEIF(TX.EQ.'QC')THEN
	XINT=DCONJG(DVINTQ(IPAR,IPAR1))
	ENDIF
C SUM UP
	CSUMLL=CSUMLL+RINT*XINT
	ENDDO                                        !!! over m
	ENDDO                                        !!! over l
	ENDDO                                        !!! over energy
	ENDDO                                        !!! over iatom
	ENDDO                                        !!! over m1
	ENDDO                                        !!! over l1
	ENDDO                                        !!! over energy
	ENDDO                                        !!! over iatom1
	END

