	SUBROUTINE DEL_D2TOSINT(MY1,INUC,IPNT,ISGQ,IPAN,IQPNT)
***********************************************************
*  Calculates density arrays.                             *
***********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_KAPPAR,  ONLY : NPAN,NKAP,EK,EKAP                          !!! from readini
	USE COM_LATTICE, ONLY : TAU                                        !!! from readstr
	USE COM_LATPAR,  ONLY : PAR,ORTH,OMEGAC                            !!! from readini
	USE COM_PANPAR,  ONLY : LTPAN,LSPAN,IATS,ISTS                      !!! from readini
	USE COM_NBANDS,  ONLY : NBNDF,NBNDE,NBNDT,NBNDC,NBNDH,POLUS        !!! from readini
	USE COM_KMESH,   ONLY : NPNT,PNT,WGT                               !!! from makettr
	USE COM_ETAPAR,  ONLY : ETA,CUT,LBAS,NBAS                          !!! from makeplw
	USE COM_QMESH,   ONLY : NQPNT,QPNT                                 !!! from readpnt
	USE COM_SUBGROUP,ONLY : NSGQ,NGEQ,ISG                              !!! from delmesh
	USE COM_PLWMESH, ONLY : NPLW,GPLW                                  !!! from makeplw
	USE COM_GROUPS,  ONLY : NGROUP,INV,IKOV                            !!! from makegrp
	USE COM_PSIVEC,  ONLY : APHK,APJK,APHQ,APJQ                        !!! from lmtvec
	USE COM_SYMMESH, ONLY : IG0IG1,IK0IK1                              !!! from delmesh
	USE COM_DPSIVEC, ONLY : PSIK,PSIQ,DPSK,DPSQ,SPSK,PNTK,PNTQ         !!! from d2psivec
	USE COM_INDORB,  ONLY : INDLMT                                     !!! from readini
	USE COM_MASHDEP, ONLY : NVAL                                       !!! from setup
	USE COM_TEILORG, ONLY : KEYT,BZM,GOPT,MBAS                         !!! from makeplw
	USE COM_LMTOUT,  ONLY : SCRFILE                                    !!! from setup
	USE COM_PHNCHN  ,ONLY : IUTTW,IUDMD                                !!! from channels
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8, ALLOCATABLE :: WEIGQ(:,:,:)
	REAL*8, ALLOCATABLE :: WEIGK(:,:)
	COMPLEX*16, ALLOCATABLE :: DRINT0(:,:)
	COMPLEX*16, ALLOCATABLE :: DRINTQ(:,:)
	COMPLEX*16, ALLOCATABLE :: DRFUN0(:,:)
	COMPLEX*16, ALLOCATABLE :: DRFUNQ(:,:)
	COMPLEX*16, ALLOCATABLE :: TPSK(:)
	COMPLEX*16, ALLOCATABLE :: TPSQ(:)
	COMPLEX*16 EXPK0,EXPK1,RMY0,RPY0,RMY1,RPY1,GMY1,GMY0
	DIMENSION PNTR(3)
	LOGICAL LOG1,LOG,EXIST
	DATA PI/3.141592653589793D0/
	IF(MODE.NE.4)RETURN
	IF(KEYT.LE.0)RETURN
C Memory allocations
	ALLOCATE(DRINT0(NBNDT(IPAN),NBNDT(IPAN)))
	ALLOCATE(DRINTQ(NBNDT(IPAN),NBNDT(IPAN)))
	ALLOCATE(DRFUN0(NBNDT(IPAN),0:MBASMEM))
	ALLOCATE(DRFUNQ(NBNDT(IPAN),0:MBASMEM))
	ALLOCATE(TPSK(0:NBASMEM))
	ALLOCATE(TPSQ(0:NBASMEM))
	ALLOCATE(WEIGK(NBNDC(1)*NSPINMEM,4))
	ALLOCATE(WEIGQ(NBNDC(1)*NSPINMEM,NBNDC(1)*NSPINMEM,6))
C  SET POINT-GROUP INFORMATION
	IRK=ISG(1,ISGQ)       !!!  element "g"  in the main G-list
	IGK=IKOV(IRK)         !!!  element "g"  after Kovalev
	IPNTK=IPNT            !!!  point   "k"
	IRQ=IG0IG1(IPNT,IRK)  !!!  element "g'" in the main G-list
	IGQ=IKOV(IRQ)         !!!  element "g'" after Kovalev
	IPNTQ=IK0IK1(IPNT,IRK)!!!  point   "k'" such that g*k+q=g'*k'
C  READ 1/E TETRAHEDRON WEIGHTS FOR BRILLOUIN ZONE INTEGRATION
	IREC=1+IPNTK+NPNT(1)*(ISGQ-1)
	IF(IPAN.EQ.1)THEN
	READ(IUTTW,REC=IREC)WGTQ1,
     &(((WEIGQ(IBANC,IBANC1,IC),IBANC=1,NBNDC(1)*NSPIN),
     &IBANC1=1,NBNDC(1)*NSPIN),IC=1,6),
     &((WEIGK(IBANC,IC),IBANC=1,NBNDC(1)*NSPIN),IC=1,4)
	ELSE ! only geometrical weigths are neccessary
	READ(IUTTW,REC=IREC)WGTQ1
	ENDIF
C  DO OVER SPINS
	DO 9200 IORBS=1,NORBS                                     !!! over iorbs
	DO 9100 IUPDN=1,NSPIN                                     !!! over iupdn
 	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
C  ####################################################
C  STEP 1 MAKES INTEGRATION FOR FIRST-ORDER DERIVATIVES
C  ####################################################
C  READ DENSITY PARAMETERS
      IREC=1+2*(IUPDN-1)+2*NSPIN*(IORBS-1) !!! D{t1m1}S0
	READ(IUDMD,REC=IREC)((DRFUN0(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
	IREC=2+2*(IUPDN-1)+2*NSPIN*(IORBS-1) !!! D{t1m1}Rq
	READ(IUDMD,REC=IREC)((DRFUNQ(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
C  DO OVER BANDS
	DO 1200 IBNDS=1,NSPIN                          !!! over spin subbands
	DO 1100 IBNDT=1,NBNDF(IPAN)                    !!! over filled bands
	IBNDC=IBNDT-NBNDE(IPAN)+1
	IBANC=IBNDS+NSPIN*(IBNDC-1)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	IF(IBNDT.GE.NBNDE(IPAN))THEN
	WQ1=WEIGK(IBANC,1)          !!! f(kj) 
	WQ2=WEIGK(IBANC,2)          !!! f(k+qj)
	ELSEIF(IBNDT.LT.NBNDE(IPAN))THEN
	WQ1=WGTQ1                   !!! 1
	WQ2=WGTQ1                   !!! 1
	ENDIF
C  SET RIGID CHANGE IN PSEUDOWAVEFUNCTIONS
	DO IBAS=0,MIN(NBAS,MBAS)
	GX=PNTQ(1)+GPLW(1,IBAS)
	GY=PNTQ(2)+GPLW(2,IBAS)
	GZ=PNTQ(3)+GPLW(3,IBAS)
	IF(+MY1.EQ.-1)GMY1=+1.D0/SQRT(2.D0)*(GX-(0.D0,1.D0)*GY)
	IF(+MY1.EQ.+1)GMY1=-1.D0/SQRT(2.D0)*(GX+(0.D0,1.D0)*GY)
	IF(+MY1.EQ. 0)GMY1=GZ
	TPSQ(IBAS)=DPSQ(IBAS,ISPIN,IBAND)*GMY1*(0.D0,1.D0)*
     &  2.D0*PI/PAR*WQ1
	GX=PNTK(1)+GPLW(1,IBAS)
	GY=PNTK(2)+GPLW(2,IBAS)
	GZ=PNTK(3)+GPLW(3,IBAS)
	IF(-MY1.EQ.-1)GMY1=+1.D0/SQRT(2.D0)*(GX-(0.D0,1.D0)*GY)
	IF(-MY1.EQ.+1)GMY1=-1.D0/SQRT(2.D0)*(GX+(0.D0,1.D0)*GY)
	IF(-MY1.EQ. 0)GMY1=GZ
	TPSK(IBAS)=DCONJG(DPSK(IBAS,ISPIN1,IBAND)*GMY1*(0.D0,1.D0)*
     &  2.D0*PI/PAR)*(-1)**MY1*WQ2
	ENDDO
C  SET DENSITY PARAMETERS
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	SCP=PNTK(1)*TAU(1,IATOM)+
     &      PNTK(2)*TAU(2,IATOM)+
     &      PNTK(3)*TAU(3,IATOM)
	EXPK0=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	DO IKAP=1,NKAP(IPAN)
	DO L=0,ILSB(ISORT)
	DO M=-L,L
	IF(.NOT.LTPAN(L,IATOM,IKAP,IPAN))EXIT
	LM=L*(L+1)+M+1
	IPAR=INDLMT(LM,IATOM,IKAP,1,IPAN)
	DO IBAS=0,MIN(NBAS,MBAS)
	DRFUN0(IPAR,IBAS)=DRFUN0(IPAR,IBAS)+
     &  DCONJG(APHK(LM,IATOM,IKAP,ISPIN1,IBAND)*EXPK0)*TPSQ(IBAS)
	DRFUNQ(IPAR,IBAS)=DRFUNQ(IPAR,IBAS)+
     &  TPSK(IBAS)*APHQ(LM,IATOM,IKAP,ISPIN,IBAND)*EXPK0
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
 1100 CONTINUE                                       !!! over filled bands
 1200 CONTINUE                                       !!! over spin subbands
C  STORE DENSITY PARAMETERS
	IREC=1+2*(IUPDN-1)+2*NSPIN*(IORBS-1) !!! D{t1m1}S0
	WRITE(IUDMD,REC=IREC)((DRFUN0(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
	IREC=2+2*(IUPDN-1)+2*NSPIN*(IORBS-1) !!! D{t1m1}Rq
	WRITE(IUDMD,REC=IREC)((DRFUNQ(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
C  ####################################################
C  STEP 2 MAKES INTEGRATION FOR 1ST DERIVATIVES AND KMY
C  ####################################################
	DO 3000 MY0=-1,1                               !!! over polarizations
C  READ DENSITY PARAMETERS
	IREC=1+2*(MY0+1)+6*(IUPDN-1)+6*NSPIN*(IORBS-1)+2*NSPIN*NORBS !!! D{t1m1}S0{m0}
	READ(IUDMD,REC=IREC)((DRFUN0(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
	IREC=2+2*(MY0+1)+6*(IUPDN-1)+6*NSPIN*(IORBS-1)+2*NSPIN*NORBS !!! D{t1m1}Rq{m0}
	READ(IUDMD,REC=IREC)((DRFUNQ(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
C  DO OVER BANDS
	DO 2200 IBNDS=1,NSPIN                          !!! over spin subbands
	DO 2100 IBNDT=1,NBNDF(IPAN)                    !!! over filled bands
	IBNDC=IBNDT-NBNDE(IPAN)+1
	IBANC=IBNDS+NSPIN*(IBNDC-1)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	IF(IBNDT.GE.NBNDE(IPAN))THEN
	WQ1=WEIGK(IBANC,1)          !!! f(kj) 
	WQ2=WEIGK(IBANC,2)          !!! f(k+qj)
	ELSEIF(IBNDT.LT.NBNDE(IPAN))THEN
	WQ1=WGTQ1                   !!! 1
	WQ2=WGTQ1                   !!! 1
	ENDIF
C  SET RIGID CHANGE IN PSEUDOWAVEFUNCTIONS
	DO IBAS=0,MIN(NBAS,MBAS)
	GX=PNTQ(1)+GPLW(1,IBAS)
	GY=PNTQ(2)+GPLW(2,IBAS)
	GZ=PNTQ(3)+GPLW(3,IBAS)
	IF(+MY1.EQ.-1)GMY1=+1.D0/SQRT(2.D0)*(GX-(0.D0,1.D0)*GY)
	IF(+MY1.EQ.+1)GMY1=-1.D0/SQRT(2.D0)*(GX+(0.D0,1.D0)*GY)
	IF(+MY1.EQ. 0)GMY1=GZ
	TPSQ(IBAS)=DPSQ(IBAS,ISPIN,IBAND)*GMY1*(0.D0,1.D0)*
     &  2.D0*PI/PAR*WQ1
	GX=PNTK(1)+GPLW(1,IBAS)
	GY=PNTK(2)+GPLW(2,IBAS)
	GZ=PNTK(3)+GPLW(3,IBAS)
	IF(-MY1.EQ.-1)GMY1=+1.D0/SQRT(2.D0)*(GX-(0.D0,1.D0)*GY)
	IF(-MY1.EQ.+1)GMY1=-1.D0/SQRT(2.D0)*(GX+(0.D0,1.D0)*GY)
	IF(-MY1.EQ. 0)GMY1=GZ
	TPSK(IBAS)=DCONJG(DPSK(IBAS,ISPIN1,IBAND)*GMY1*(0.D0,1.D0)*
     &  2.D0*PI/PAR)*(-1)**MY1*WQ2
	ENDDO
C  SET DENSITY PARAMETERS
	XK=PNTK(1)
	YK=PNTK(2)
	ZK=PNTK(3)
	IF(+MY0.EQ.-1)RPY0=+1.D0/SQRT(2.D0)*(XK-(0.D0,1.D0)*YK)
	IF(+MY0.EQ.+1)RPY0=-1.D0/SQRT(2.D0)*(XK+(0.D0,1.D0)*YK)
	IF(+MY0.EQ. 0)RPY0=ZK
	IF(-MY0.EQ.-1)RMY0=+1.D0/SQRT(2.D0)*(XK-(0.D0,1.D0)*YK)
	IF(-MY0.EQ.+1)RMY0=-1.D0/SQRT(2.D0)*(XK+(0.D0,1.D0)*YK)
	IF(-MY0.EQ. 0)RMY0=ZK
	RPY0=RPY0*(0.D0,-1.D0)*2.D0*PI/PAR
	RMY0=DCONJG(RMY0*(0.D0,-1.D0)*2.D0*PI/PAR)*(-1)**MY0
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	SCP=PNTK(1)*TAU(1,IATOM)+
     &      PNTK(2)*TAU(2,IATOM)+
     &      PNTK(3)*TAU(3,IATOM)
	EXPK0=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	DO IKAP=1,NKAP(IPAN)
	DO L=0,ILSB(ISORT)
	DO M=-L,L
	IF(.NOT.LTPAN(L,IATOM,IKAP,IPAN))EXIT
	LM=L*(L+1)+M+1
	IPAR=INDLMT(LM,IATOM,IKAP,1,IPAN)
	DO IBAS=0,MIN(NBAS,MBAS)
	DRFUN0(IPAR,IBAS)=DRFUN0(IPAR,IBAS)+RMY0*
     &  DCONJG(APHK(LM,IATOM,IKAP,ISPIN1,IBAND)*EXPK0)*TPSQ(IBAS)
	DRFUNQ(IPAR,IBAS)=DRFUNQ(IPAR,IBAS)+RPY0*
     &  TPSK(IBAS)*APHQ(LM,IATOM,IKAP,ISPIN,IBAND)*EXPK0
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
 2100 CONTINUE                                       !!! over filled bands
 2200 CONTINUE                                       !!! over spin subbands
C  STORE DENSITY PARAMETERS
	IREC=1+2*(MY0+1)+6*(IUPDN-1)+6*NSPIN*(IORBS-1)+2*NSPIN*NORBS !!! D{t1m1}S0{m0}
	WRITE(IUDMD,REC=IREC)((DRFUN0(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
	IREC=2+2*(MY0+1)+6*(IUPDN-1)+6*NSPIN*(IORBS-1)+2*NSPIN*NORBS !!! D{t1m1}Rq{m0}
	WRITE(IUDMD,REC=IREC)((DRFUNQ(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
3000    CONTINUE                                       !!! over polarizations
C  ####################################################
C  STEP 3 MAKES INTEGRATION FOR SECOND-ORDER DERIVATIVE
C  ####################################################
	DO 5000 MY0=-1,1                               !!! over polarizations
C  READ DENSITY PARAMETERS
	IREC=MY0+2+3*(IUPDN-1)+3*NSPIN*(IORBS-1)+8*NSPIN*NORBS !!! d{m0}d{t1m1}S0
	READ(IUDMD,REC=IREC)((DRFUN0(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
C  DO OVER BANDS
	DO 4200 IBNDS=1,NSPIN                          !!! over spin subbands
	DO 4100 IBNDT=1,NBNDF(IPAN)                    !!! over filled bands
	IBNDC=IBNDT-NBNDE(IPAN)+1
	IBANC=IBNDS+NSPIN*(IBNDC-1)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	IF(IBNDT.GE.NBNDE(IPAN))THEN
	WQ1=WEIGK(IBANC,1)          !!! f(kj) 
	WQ2=WEIGK(IBANC,2)          !!! f(k+qj)
	ELSEIF(IBNDT.LT.NBNDE(IPAN))THEN
	WQ1=WGTQ1                   !!! 1
	WQ2=WGTQ1                   !!! 1
	ENDIF
C  SET RIGID CHANGE IN PSEUDOWAVEFUNCTIONS TO SECOND-ORDER
	DO IBAS=0,MIN(NBAS,MBAS)
	GX=PNTK(1)+GPLW(1,IBAS)
	GY=PNTK(2)+GPLW(2,IBAS)
	GZ=PNTK(3)+GPLW(3,IBAS)
	IF(+MY1.EQ.-1)GMY1=+1.D0/SQRT(2.D0)*(GX-(0.D0,1.D0)*GY)
	IF(+MY1.EQ.+1)GMY1=-1.D0/SQRT(2.D0)*(GX+(0.D0,1.D0)*GY)
	IF(+MY1.EQ. 0)GMY1=GZ
	IF(+MY0.EQ.-1)GMY0=+1.D0/SQRT(2.D0)*(GX-(0.D0,1.D0)*GY)
	IF(+MY0.EQ.+1)GMY0=-1.D0/SQRT(2.D0)*(GX+(0.D0,1.D0)*GY)
	IF(+MY0.EQ. 0)GMY0=GZ
	TPSK(IBAS)=SPSK(IBAS,ISPIN,IBAND)*(-1.D0)*GMY1*GMY0*
     &  (2.D0*PI/PAR)**2*WQ1
	ENDDO
C  SET DENSITY PARAMETERS
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	SCP=PNTK(1)*TAU(1,IATOM)+
     &      PNTK(2)*TAU(2,IATOM)+
     &      PNTK(3)*TAU(3,IATOM)
	EXPK0=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	DO IKAP=1,NKAP(IPAN)
	DO L=0,ILSB(ISORT)
	DO M=-L,L
	IF(.NOT.LTPAN(L,IATOM,IKAP,IPAN))EXIT
	LM=L*(L+1)+M+1
	IPAR=INDLMT(LM,IATOM,IKAP,1,IPAN)
	DO IBAS=0,MIN(NBAS,MBAS)
	DRFUN0(IPAR,IBAS)=DRFUN0(IPAR,IBAS)+
     &  DCONJG(APHK(LM,IATOM,IKAP,ISPIN1,IBAND)*EXPK0)*TPSK(IBAS)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
 4100 CONTINUE                                       !!! over filled bands
 4200 CONTINUE                                       !!! over spin subbands
C  STORE DENSITY PARAMETERS
	IREC=MY0+2+3*(IUPDN-1)+3*NSPIN*(IORBS-1)+8*NSPIN*NORBS !!! d{m0}d{t1m1}S0
	WRITE(IUDMD,REC=IREC)((DRFUN0(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
 5000 CONTINUE                                       !!! over polarizations
C  ####################################################
C  STEP 4 MAKES INTEGRATION WITH THE WEIGHT K
C  ####################################################
C  READ DENSITY PARAMETERS
	IREC=1+2*(IUPDN-1)+2*NSPIN*(IORBS-1)+11*NSPIN*NORBS !!! R0{m1},T0{m1}
	READ(IUDMD,REC=IREC)((DRINT0(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DRFUN0(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
	IREC=2+2*(IUPDN-1)+2*NSPIN*(IORBS-1)+11*NSPIN*NORBS !!! Sq{m1},Tq{m1}
	READ(IUDMD,REC=IREC)((DRINTQ(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DRFUNQ(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
C  DO OVER BANDS
	DO 6200 IBNDS=1,NSPIN                          !!! over filled bands
	DO 6100 IBNDT=1,NBNDF(IPAN)                    !!! over filled bands
	IBNDC=IBNDT-NBNDE(IPAN)+1
	IBANC=IBNDS+NSPIN*(IBNDC-1)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	IF(IBNDT.GE.NBNDE(IPAN))THEN
	WQ1=WEIGK(IBANC,1)          !!! f(kj) 
	WQ2=WEIGK(IBANC,2)          !!! f(k+qj)
	ELSEIF(IBNDT.LT.NBNDE(IPAN))THEN
	WQ1=WGTQ1                   !!! 1
	WQ2=WGTQ1                   !!! 1
	ENDIF
C  SET DENSITY PARAMETERS
	XK=PNTK(1)
	YK=PNTK(2)
	ZK=PNTK(3)
	IF(+MY1.EQ.-1)RPY1=+1.D0/SQRT(2.D0)*(XK-(0.D0,1.D0)*YK)
	IF(+MY1.EQ.+1)RPY1=-1.D0/SQRT(2.D0)*(XK+(0.D0,1.D0)*YK)
	IF(+MY1.EQ. 0)RPY1=ZK
	RPY1=RPY1*(0.D0,-1.D0)*2.D0*PI/PAR
	IF(-MY1.EQ.-1)RMY1=+1.D0/SQRT(2.D0)*(XK-(0.D0,1.D0)*YK)
	IF(-MY1.EQ.+1)RMY1=-1.D0/SQRT(2.D0)*(XK+(0.D0,1.D0)*YK)
	IF(-MY1.EQ. 0)RMY1=ZK
	RMY1=DCONJG(RMY1*(0.D0,-1.D0)*2.D0*PI/PAR)*(-1)**MY1
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	SCP=PNTK(1)*TAU(1,IATOM)+
     &      PNTK(2)*TAU(2,IATOM)+
     &      PNTK(3)*TAU(3,IATOM)
	EXPK0=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	DO IKAP=1,NKAP(IPAN)
	DO L=0,ILSB(ISORT)
	DO M=-L,L
	IF(.NOT.LTPAN(L,IATOM,IKAP,IPAN))EXIT
	LM=L*(L+1)+M+1
	IPAR=INDLMT(LM,IATOM,IKAP,1,IPAN)
	DO IBAS=0,MIN(NBAS,MBAS)
	DRFUN0(IPAR,IBAS)=DRFUN0(IPAR,IBAS)+WQ1*RPY1*     !!! RPY HERE
     &  DCONJG(PSIK(IBAS,ISPIN1,IBAND))*
     &  APHK(LM,IATOM,IKAP,ISPIN,IBAND)*EXPK0
	DRFUNQ(IPAR,IBAS)=DRFUNQ(IPAR,IBAS)+WQ2*RMY1*     !!! RMY HERE !!!
     &  DCONJG(APHQ(LM,IATOM,IKAP,ISPIN1,IBAND)*EXPK0)*
     &  PSIQ(IBAS,ISPIN,IBAND)
	ENDDO
	DO IATOM1=1,NATOM
	ISORT1=IS(IATOM1)
	SCP=PNTK(1)*TAU(1,IATOM1)+
     &    PNTK(2)*TAU(2,IATOM1)+
     &    PNTK(3)*TAU(3,IATOM1)
	EXPK1=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	DO IKAP1=1,NKAP(IPAN)
	DO L1=0,ILSB(ISORT1)
	DO M1=-L1,L1
	IF(.NOT.LTPAN(L1,IATOM1,IKAP1,IPAN))EXIT
	L1M1=L1*(L1+1)+M1+1
	IPAR1=INDLMT(L1M1,IATOM1,IKAP1,1,IPAN)
	DRINT0(IPAR1,IPAR)=DRINT0(IPAR1,IPAR)+WQ1*RPY1*   !!! RPY HERE
     &  DCONJG(APHK(L1M1,IATOM1,IKAP1,ISPIN1,IBAND)*EXPK1)*
     &  APHK(LM,IATOM,IKAP,ISPIN,IBAND)*EXPK0
	DRINTQ(IPAR1,IPAR)=DRINTQ(IPAR1,IPAR)+WQ2*RPY1*   !!! RPY HERE ALSO !!!
     &  DCONJG(APHQ(L1M1,IATOM1,IKAP1,ISPIN1,IBAND)*EXPK1)*
     &  APHQ(LM,IATOM,IKAP,ISPIN,IBAND)*EXPK0
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
 6100 CONTINUE                                       !!! over filled bands
 6200 CONTINUE                                       !!! over spin subbands
C  STORE DENSITY PARAMETERS
	IREC=1+2*(IUPDN-1)+2*NSPIN*(IORBS-1)+11*NSPIN*NORBS !!! R0{m1},T0{m1}
	WRITE(IUDMD,REC=IREC)((DRINT0(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DRFUN0(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
	IREC=2+2*(IUPDN-1)+2*NSPIN*(IORBS-1)+11*NSPIN*NORBS !!! Sq{m1},Tq{m1}
	WRITE(IUDMD,REC=IREC)((DRINTQ(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DRFUNQ(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
C  ####################################################
C  STEP 5 MAKES INTEGRATION WITH THE WEIGHT K^2
C  ####################################################
	DO 8000 MY0=-1,1                               !!! over polarizations
C  READ DENSITY PARAMETERS
	IREC=1+2*(MY0+1)+6*(IUPDN-1)+6*NSPIN*(IORBS-1)+13*NSPIN*NORBS !!! R0{m1m0},T0{m1m0}
	READ(IUDMD,REC=IREC)((DRINT0(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DRFUN0(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
	IREC=2+2*(MY0+1)+6*(IUPDN-1)+6*NSPIN*(IORBS-1)+13*NSPIN*NORBS !!! Sq{m1m0},Tq{m1m0}
	READ(IUDMD,REC=IREC)((DRINTQ(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DRFUNQ(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
C  DO OVER BANDS
	DO 7200 IBNDS=1,NSPIN                          !!! over spin subbands
	DO 7100 IBNDT=1,NBNDF(IPAN)                    !!! over filled bands
	IBNDC=IBNDT-NBNDE(IPAN)+1
	IBANC=IBNDS+NSPIN*(IBNDC-1)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	IF(IBNDT.GE.NBNDE(IPAN))THEN
	WQ1=WEIGK(IBANC,1)          !!! f(kj) 
	WQ2=WEIGK(IBANC,2)          !!! f(k+qj)
	ELSEIF(IBNDT.LT.NBNDE(IPAN))THEN
	WQ1=WGTQ1                   !!! 1
	WQ2=WGTQ1                   !!! 1
	ENDIF
C  SET DENSITY PARAMETERS
	XK=PNTK(1)
	YK=PNTK(2)
	ZK=PNTK(3)
	IF(+MY1.EQ.-1)RPY1=+1.D0/SQRT(2.D0)*(XK-(0.D0,1.D0)*YK)
	IF(+MY1.EQ.+1)RPY1=-1.D0/SQRT(2.D0)*(XK+(0.D0,1.D0)*YK)
	IF(+MY1.EQ. 0)RPY1=ZK
	IF(+MY0.EQ.-1)RPY0=+1.D0/SQRT(2.D0)*(XK-(0.D0,1.D0)*YK)
	IF(+MY0.EQ.+1)RPY0=-1.D0/SQRT(2.D0)*(XK+(0.D0,1.D0)*YK)
	IF(+MY0.EQ. 0)RPY0=ZK
	RPY1=RPY1*(0.D0,-1.D0)*2.D0*PI/PAR
	RPY0=RPY0*(0.D0,-1.D0)*2.D0*PI/PAR
	IF(-MY1.EQ.-1)RMY1=+1.D0/SQRT(2.D0)*(XK-(0.D0,1.D0)*YK)
	IF(-MY1.EQ.+1)RMY1=-1.D0/SQRT(2.D0)*(XK+(0.D0,1.D0)*YK)
	IF(-MY1.EQ. 0)RMY1=ZK
	IF(-MY0.EQ.-1)RMY0=+1.D0/SQRT(2.D0)*(XK-(0.D0,1.D0)*YK)
	IF(-MY0.EQ.+1)RMY0=-1.D0/SQRT(2.D0)*(XK+(0.D0,1.D0)*YK)
	IF(-MY0.EQ. 0)RMY0=ZK
	RMY1=DCONJG(RMY1*(0.D0,-1.D0)*2.D0*PI/PAR)*(-1)**MY1
	RMY0=DCONJG(RMY0*(0.D0,-1.D0)*2.D0*PI/PAR)*(-1)**MY0
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	SCP=PNTK(1)*TAU(1,IATOM)+
     &    PNTK(2)*TAU(2,IATOM)+
     &    PNTK(3)*TAU(3,IATOM)
	EXPK0=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	DO IKAP=1,NKAP(IPAN)
	DO L=0,ILSB(ISORT)
	DO M=-L,L
	IF(.NOT.LTPAN(L,IATOM,IKAP,IPAN))EXIT
	LM=L*(L+1)+M+1
	IPAR=INDLMT(LM,IATOM,IKAP,1,IPAN)
	DO IBAS=0,MIN(NBAS,MBAS)
	DRFUN0(IPAR,IBAS)=DRFUN0(IPAR,IBAS)+WQ1*RPY1*RPY0*   !!! HERE RPY^2
     &  DCONJG(PSIK(IBAS,ISPIN1,IBAND))*
     &  APHK(LM,IATOM,IKAP,ISPIN,IBAND)*EXPK0
	DRFUNQ(IPAR,IBAS)=DRFUNQ(IPAR,IBAS)+WQ2*RMY1*RMY0*   !!! HERE RMY^2=RPY^2
     &  DCONJG(APHQ(LM,IATOM,IKAP,ISPIN1,IBAND)*EXPK0)*
     &  PSIQ(IBAS,ISPIN,IBAND)
	ENDDO
	DO IATOM1=1,NATOM
	ISORT1=IS(IATOM1)
	SCP=PNTK(1)*TAU(1,IATOM1)+
     &    PNTK(2)*TAU(2,IATOM1)+
     &    PNTK(3)*TAU(3,IATOM1)
	EXPK1=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	DO IKAP1=1,NKAP(IPAN)
	DO L1=0,ILSB(ISORT1)
	DO M1=-L1,L1
	IF(.NOT.LTPAN(L1,IATOM1,IKAP1,IPAN))EXIT
	L1M1=L1*(L1+1)+M1+1
	IPAR1=INDLMT(L1M1,IATOM1,IKAP1,1,IPAN)
	DRINT0(IPAR1,IPAR)=DRINT0(IPAR1,IPAR)+WQ1*RPY1*RPY0* !!! HERE RPY^2
     &  DCONJG(APHK(L1M1,IATOM1,IKAP1,ISPIN1,IBAND)*EXPK1)*
     &  APHK(LM,IATOM,IKAP,ISPIN,IBAND)*EXPK0
	DRINTQ(IPAR1,IPAR)=DRINTQ(IPAR1,IPAR)+WQ2*RPY1*RPY0* !!! HERE RPY^2
     &  DCONJG(APHQ(L1M1,IATOM1,IKAP1,ISPIN1,IBAND)*EXPK1)*
     &  APHQ(LM,IATOM,IKAP,ISPIN,IBAND)*EXPK0
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
 7100 CONTINUE                                       !!! over filled bands
 7200 CONTINUE                                       !!! over spin subbands
C  STORE DENSITY PARAMETERS
	IREC=1+2*(MY0+1)+6*(IUPDN-1)+6*NSPIN*(IORBS-1)+13*NSPIN*NORBS !!! R0{m1m0},T0{m1m0}
	WRITE(IUDMD,REC=IREC)((DRINT0(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DRFUN0(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
	IREC=2+2*(MY0+1)+6*(IUPDN-1)+6*NSPIN*(IORBS-1)+13*NSPIN*NORBS !!! Sq{m1m0},Tq{m1m0}
	WRITE(IUDMD,REC=IREC)((DRINTQ(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DRFUNQ(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
8000  CONTINUE                                         !!! over polarizations
9100  CONTINUE                                         !!! over spins
9200  CONTINUE                                         !!! over spins
C Memory deallocations
	DEALLOCATE(DRINT0,DRINTQ,DRFUN0,DRFUNQ,TPSK,TPSQ)
	DEALLOCATE(WEIGQ,WEIGK)
	END





	SUBROUTINE DEL_D2TOSNUL(MY1,INUC,IPAN,IQPNT)
************************************************
*  Zeroises density parameters                 *
************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_KAPPAR,  ONLY : NPAN,NKAP,EK,EKAP                          !!! from readini
	USE COM_PANPAR,  ONLY : LTPAN,LSPAN,IATS,ISTS                      !!! from readini
	USE COM_NBANDS,  ONLY : NBNDF,NBNDE,NBNDT,NBNDC,POLUS              !!! from readini
	USE COM_ETAPAR,  ONLY : ETA,CUT,LBAS,NBAS                          !!! from makeplw
	USE COM_PLWMESH, ONLY : NPLW,GPLW                                  !!! from makeplw
	USE COM_INDORB,  ONLY : INDLMT                                     !!! from readini
	USE COM_MASHDEP, ONLY : NVAL                                       !!! from setup
	USE COM_TEILORG, ONLY : KEYT,BZM,GOPT,MBAS                         !!! from makeplw
	USE COM_LMTOUT,  ONLY : SCRFILE                                    !!! from setup
	USE COM_PHNCHN  ,ONLY : IUTTW,IUDMD                                !!! from channels
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: DRINT0(:,:)
	COMPLEX*16, ALLOCATABLE :: DRINTQ(:,:)
	COMPLEX*16, ALLOCATABLE :: DRFUN0(:,:)
	COMPLEX*16, ALLOCATABLE :: DRFUNQ(:,:)
	LOGICAL EXIST
	DATA PI/3.141592653589793D0/
C  OPEN SCRATCH FILE FOR STORING DENSITY PARAMETERS
	INQUIRE(FILE=SCRFILE(IUDMD),EXIST=EXIST)
	IF(.NOT.EXIST)THEN
	NRECL=NVAL*(NBNDT(IPAN)*(MIN(NBAS,MBAS)+1)+
     &  NBNDT(IPAN)**2)
	OPEN(UNIT=IUDMD,FILE=SCRFILE(IUDMD),STATUS='NEW',
     &  ACCESS='DIRECT',FORM='UNFORMATTED',RECL=NRECL)
	ENDIF
	IF(KEYT.LE.0)RETURN
	IF(MODE.NE.4)RETURN
C Memory allocations
	ALLOCATE(DRINT0(NBNDT(IPAN),NBNDT(IPAN)))
	ALLOCATE(DRINTQ(NBNDT(IPAN),NBNDT(IPAN)))
	ALLOCATE(DRFUN0(NBNDT(IPAN),0:MBASMEM))
	ALLOCATE(DRFUNQ(NBNDT(IPAN),0:MBASMEM))
	DO IPAR=1,NBNDT(IPAN)                          !!! over ipar
	DO JPAR=1,NBNDT(IPAN)                          !!! over jpar
	DRINT0(JPAR,IPAR)=(0.D0,0.D0)
	DRINTQ(JPAR,IPAR)=(0.D0,0.D0)
	ENDDO                                          !!! over jpar
	DO IBAS=0,MIN(NBAS,MBAS)                       !!! over ibas
	DRFUN0(IPAR,IBAS)=(0.D0,0.D0)
	DRFUNQ(IPAR,IBAS)=(0.D0,0.D0)
	ENDDO                                          !!! over ibas
	ENDDO                                          !!! over ipar
	DO IORBS=1,NORBS
	DO IUPDN=1,NSPIN
C  SET ZEROES FOR STEP 1
	IREC=1+2*(IUPDN-1)+2*NSPIN*(IORBS-1)
	WRITE(IUDMD,REC=IREC)((DRFUN0(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
	IREC=2+2*(IUPDN-1)+2*NSPIN*(IORBS-1)
	WRITE(IUDMD,REC=IREC)((DRFUNQ(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
C  SET ZEROES FOR STEP 2
	DO MY0=-1,1                                    !!! over polarizations
	IREC=1+2*(MY0+1)+6*(IUPDN-1)+2*NSPIN*(IORBS-1)+2*NSPIN*NORBS
	WRITE(IUDMD,REC=IREC)((DRFUN0(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
	IREC=2+2*(MY0+1)+6*(IUPDN-1)+2*NSPIN*(IORBS-1)+2*NSPIN*NORBS
	WRITE(IUDMD,REC=IREC)((DRFUNQ(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
	ENDDO                                          !!! over polarizations
C  SET ZEROES FOR STEP 3
	DO MY0=-1,1                                    !!! over polarizations
	IREC=MY0+2+3*(IUPDN-1)+3*NSPIN*(IORBS-1)+8*NSPIN*NORBS
	WRITE(IUDMD,REC=IREC)((DRFUN0(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
	ENDDO                                          !!! over polarizations
C  SET ZEROES FOR STEP 4
	IREC=1+2*(IUPDN-1)+2*NSPIN*(IORBS-1)+11*NSPIN*NORBS
	WRITE(IUDMD,REC=IREC)((DRINT0(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DRFUN0(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
	IREC=2+2*(IUPDN-1)+2*NSPIN*(IORBS-1)+11*NSPIN*NORBS
	WRITE(IUDMD,REC=IREC)((DRINTQ(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DRFUNQ(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
C  SET ZEROES FOR STEP 5
	DO MY0=-1,1                                    !!! over polarizations
	IREC=1+2*(MY0+1)+6*(IUPDN-1)+6*NSPIN*(IORBS-1)+13*NSPIN*NORBS
	WRITE(IUDMD,REC=IREC)((DRINT0(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DRFUN0(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
	IREC=2+2*(MY0+1)+6*(IUPDN-1)+6*NSPIN*(IORBS-1)+13*NSPIN*NORBS
	WRITE(IUDMD,REC=IREC)((DRINTQ(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DRFUNQ(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
	ENDDO                                          !!! over polarizations
C
	ENDDO                                          !!! over iupdn
	ENDDO                                          !!! over iorbs
C Memory deallocations
	DEALLOCATE(DRINT0,DRINTQ,DRFUN0,DRFUNQ)
	END
