	SUBROUTINE DEL_SD2VINT(MY1,INUC1,IPNT,ISGQ,IPAN,IQPNT)
***********************************************************************
*  Calculates pseudopotential contribution to the second-order change *
*  in the interstitial potential matrix elements which enters to the  *
*  band contribution of the dynamical matrix.                         *
*  S.Savrasov, Last revison 04.05.95.                                 *
***********************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_LATPAR,  ONLY : PAR,ORTH,OMEGAC                            !!! from readini
	USE COM_KAPPAR,  ONLY : NPAN,NKAP,EK,EKAP                          !!! from readini
	USE COM_PANPAR,  ONLY : LTPAN,LSPAN,IATS,ISTS                      !!! from readini
	USE COM_NBANDS,  ONLY : NBNDF,NBNDE,NBNDT,NBNDH                    !!! from readini
	USE COM_ETAPAR,  ONLY : ETA,CUT,LBAS,NBAS                          !!! from makeplw
	USE COM_PLWMESH, ONLY : NPLW,GPLW                                  !!! from makeplw
	USE COM_POTDAT,  ONLY : POTPS,POTPS1                               !!! from fulpot
      USE COM_D2HAML,  ONLY : D2HMATK,D2OMATK,D2HMATQ,D2OMATQ            !!! from d2lmat
	USE COM_DELPOT,  ONLY : DPOTPS,DPOTPS1                             !!! from delpot
	USE COM_DPSIVEC, ONLY : PSIK2,PSIQ2,DPSK2,DPSQ2,SPSK2
     &                       ,PNTK,PNTQ                                  !!! from d2psivec
	USE COM_MASHDEP, ONLY : NVAL                                       !!! from setup
	USE COM_TEILORG, ONLY : KEYT,BZM,GOPT,MBAS                         !!! from makeplw
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: CONV(:,:)
	COMPLEX*16, ALLOCATABLE :: CHIS(:)
	COMPLEX*16, ALLOCATABLE :: DPSKP(:)
	COMPLEX*16, ALLOCATABLE :: DPSQP(:)
	COMPLEX*16, ALLOCATABLE :: DPSKM(:)
	COMPLEX*16, ALLOCATABLE :: DPSQM(:)
	COMPLEX*16, ALLOCATABLE :: D2PSP(:)
	COMPLEX*16, ALLOCATABLE :: D2PSM(:)
	COMPLEX*16 GMY1,GMY,D2HK,D2HQ
	DATA PI/3.141592653589793D0/
      IF(MODE.NE.4)RETURN
C  Memory allocations
	ALLOCATE(CONV(0:NBASMEM,6))
	ALLOCATE(DPSKP(0:NBASMEM))
	ALLOCATE(DPSQP(0:NBASMEM))
	ALLOCATE(DPSKM(0:NBASMEM))
	ALLOCATE(DPSQM(0:NBASMEM))
	ALLOCATE(D2PSP(0:NBASMEM))
	ALLOCATE(D2PSM(0:NBASMEM))
	ALLOCATE(CHIS(0:NBASMEM))
C  DO OVER SPINS
      DO 6000 IORBS=1,NORBS                       !!! over iorbs
      DO 5000 IUPDN=1,NSPIN                       !!! over iupdn
	IF(IORBS.EQ.1)THEN
	IUPDN1=IUPDN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	SIGNF=1.D0
	ELSEIF(IORBS.EQ.2)THEN
	IUPDN1=NSPIN+1-IUPDN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	IF(ISPIN1.EQ.1.AND.ISPIN.EQ.2)SIGNF=-SQRT(2.D0) ! B^{+}*S_{+}
	IF(ISPIN1.EQ.2.AND.ISPIN.EQ.1)SIGNF=+SQRT(2.D0) ! B^{-}*S_{-}
	ENDIF
	DO 4000 IBNDS=1,NSPIN                      !!! over spin subbands
	IF(NORBS.EQ.1.AND.ISPIN1.NE.IBNDS)GOTO 4000
	IF(NORBS.EQ.1.AND.ISPIN .NE.IBNDS)GOTO 4000
	DO 3000 IBNDT=1,NBNDF(IPAN)                !!! ove bands
	IBAND=IBNDS+NSPIN*(IBNDT-1)
C  COMPUTE FIRST-ORDER CHANGES IN PSEUDOWAVEFUNCTIONS
C  |d(+)kj>/d(t1,my1)
	DO IBAS=0,MIN(NBAS,MBAS)                   !!! over plane waves
      GX=PNTQ(1)+GPLW(1,IBAS)
      GY=PNTQ(2)+GPLW(2,IBAS)
      GZ=PNTQ(3)+GPLW(3,IBAS)
      IF(MY1.EQ.-1)GMY1=+1.D0/SQRT(2.D0)*(GX-(0.D0,1.D0)*GY)
      IF(MY1.EQ.+1)GMY1=-1.D0/SQRT(2.D0)*(GX+(0.D0,1.D0)*GY)
      IF(MY1.EQ. 0)GMY1=GZ
      DPSKP(IBAS)=DPSQ2(IBAS,INUC1,ISPIN,IBAND)*GMY1*
     &  (0.D0,1.D0)*2.D0*PI/PAR
      ENDDO   
C  |d(-)k+qj>/d(t1,-my1)*(-)^my1
	DO IBAS=0,MIN(NBAS,MBAS)                   !!! over plane waves
      GX=PNTK(1)+GPLW(1,IBAS)
      GY=PNTK(2)+GPLW(2,IBAS)
      GZ=PNTK(3)+GPLW(3,IBAS)
      IF(-MY1.EQ.-1)GMY1=+1.D0/SQRT(2.D0)*(GX-(0.D0,1.D0)*GY)
      IF(-MY1.EQ.+1)GMY1=-1.D0/SQRT(2.D0)*(GX+(0.D0,1.D0)*GY)
      IF(-MY1.EQ. 0)GMY1=GZ
      DPSQM(IBAS)=DPSK2(IBAS,INUC1,ISPIN1,IBAND)*GMY1*
     &  (0.D0,1.D0)*2.D0*PI/PAR*(-1)**MY1
      ENDDO                                      !!! over plane waves
C  CONVOLUTION OF THE PSEUDOORBITAL WITH THE PSEUDOPOTENTIAL
C  1)
      CALL BND_CONVOL1(POTPS1(0,IUPDN1,IORBS),PSIK2(0,ISPIN,IBAND),
     &     CONV(0,1),'R',0,MIN(NBAS,MBAS),0,MIN(NBAS,MBAS))
C  2)
	DO IBAS=0,MIN(NBAS,MBAS)
	CHIS(IBAS)=DCONJG(PSIK2(IBAS,ISPIN1,IBAND))
	ENDDO
      CALL BND_CONVOL1(POTPS1(0,IUPDN1,IORBS), CHIS(0),
     &     CONV(0,2),'L',0,MIN(NBAS,MBAS),0,MIN(NBAS,MBAS))
C  3)
      CALL BND_CONVOL1(POTPS1(0,IUPDN1,IORBS),DPSKP(0),
     &     CONV(0,3),'R',0,MIN(NBAS,MBAS),0,MIN(NBAS,MBAS))
C  4)
      CALL BND_CONVOL1(DPOTPS1(0,IUPDN1,IORBS),PSIK2(0,ISPIN,IBAND),
     &     CONV(0,4),'R',0,MIN(NBAS,MBAS),0,MIN(NBAS,MBAS))
C  5)
	DO IBAS=0,MIN(NBAS,MBAS)
	CHIS(IBAS)=DCONJG(DPSQM(IBAS))
	ENDDO
      CALL BND_CONVOL1(POTPS1(0,IUPDN1,IORBS), CHIS(0),
     &     CONV(0,5),'L',0,MIN(NBAS,MBAS),0,MIN(NBAS,MBAS))
C  6)
	DO IBAS=0,MIN(NBAS,MBAS)
	CHIS(IBAS)=DCONJG(PSIQ2(IBAS,ISPIN1,IBAND))
	ENDDO
      CALL BND_CONVOL1(DPOTPS1(0,IUPDN1,IORBS),CHIS(0),
     &     CONV(0,6),'L',0,MIN(NBAS,MBAS),0,MIN(NBAS,MBAS))
C  DO OVER DISPLACEMENTS AND POLARIZATIONS
	DO 2000 INUC=1,NATOM                       !!! over displacements
	DO 1000 MY=-1,1                            !!! over polarizations
C  COMPUTE FIRST-ORDER CHANGES IN PSEUDOWAVEFUNCTIONS
C  |d(+)kj>/d(t,-my)*(-)^my
	DO IBAS=0,MIN(NBAS,MBAS)                   !!! over plane waves
      GX=PNTQ(1)+GPLW(1,IBAS)
      GY=PNTQ(2)+GPLW(2,IBAS)
      GZ=PNTQ(3)+GPLW(3,IBAS)
      IF(-MY.EQ.-1)GMY=+1.D0/SQRT(2.D0)*(GX-(0.D0,1.D0)*GY)
      IF(-MY.EQ.+1)GMY=-1.D0/SQRT(2.D0)*(GX+(0.D0,1.D0)*GY)
      IF(-MY.EQ. 0)GMY=GZ
      DPSKM(IBAS)=DPSQ2(IBAS,INUC,ISPIN1,IBAND)*GMY*
     &  (0.D0,1.D0)*2.D0*PI/PAR*(-1)**MY
      ENDDO                                      !!! over plane waves
C  |d(-)k+qj>/d(t,my)
	DO IBAS=0,MIN(NBAS,MBAS)                   !!! over plane waves
      GX=PNTK(1)+GPLW(1,IBAS)
      GY=PNTK(2)+GPLW(2,IBAS)
      GZ=PNTK(3)+GPLW(3,IBAS)
      IF(MY.EQ.-1)GMY=+1.D0/SQRT(2.D0)*(GX-(0.D0,1.D0)*GY)
      IF(MY.EQ.+1)GMY=-1.D0/SQRT(2.D0)*(GX+(0.D0,1.D0)*GY)
      IF(MY.EQ. 0)GMY=GZ
      DPSQP(IBAS)=DPSK2(IBAS,INUC,ISPIN,IBAND)*GMY*
     &  (0.D0,1.D0)*2.D0*PI/PAR
      ENDDO                                      !!! over plane waves
C  COMPUTE SECOND-ORDER CHANGES IN PSEUDOWAVEFUNCTIONS
C  |d(2)kj>/d(t1,my1)/d(t,my)
	DO IBAS=0,MIN(NBAS,MBAS)                   !!! over plane waves
	IF(INUC1.EQ.INUC)THEN
      GX=PNTK(1)+GPLW(1,IBAS)
      GY=PNTK(2)+GPLW(2,IBAS)
      GZ=PNTK(3)+GPLW(3,IBAS)
      IF(MY1.EQ.-1)GMY1=+1.D0/SQRT(2.D0)*(GX-(0.D0,1.D0)*GY)
      IF(MY1.EQ.+1)GMY1=-1.D0/SQRT(2.D0)*(GX+(0.D0,1.D0)*GY)
      IF(MY1.EQ. 0)GMY1=GZ
      IF(MY .EQ.-1)GMY =+1.D0/SQRT(2.D0)*(GX-(0.D0,1.D0)*GY)
      IF(MY .EQ.+1)GMY =-1.D0/SQRT(2.D0)*(GX+(0.D0,1.D0)*GY)
      IF(MY .EQ. 0)GMY =GZ
      D2PSP(IBAS)=SPSK2(IBAS,INUC,ISPIN,IBAND)*GMY1*GMY*
     &  (0.D0,1.D0)*2.D0*PI/PAR*(0.D0,1.D0)*2.D0*PI/PAR
	ELSE
	D2PSP(IBAS)=(0.D0,0.D0)
	ENDIF
      ENDDO                                      !!! over plane waves
C  |d(2)kj>/d(t1,-my1)/d(t,-my)*(-)^(my+my1)
	DO IBAS=0,MIN(NBAS,MBAS)                   !!! over plane waves
	IF(INUC1.EQ.INUC)THEN
      GX=PNTK(1)+GPLW(1,IBAS)
      GY=PNTK(2)+GPLW(2,IBAS)
      GZ=PNTK(3)+GPLW(3,IBAS)
      IF(-MY1.EQ.-1)GMY1=+1.D0/SQRT(2.D0)*(GX-(0.D0,1.D0)*GY)
      IF(-MY1.EQ.+1)GMY1=-1.D0/SQRT(2.D0)*(GX+(0.D0,1.D0)*GY)
      IF(-MY1.EQ. 0)GMY1=GZ
      IF(-MY .EQ.-1)GMY =+1.D0/SQRT(2.D0)*(GX-(0.D0,1.D0)*GY)
      IF(-MY .EQ.+1)GMY =-1.D0/SQRT(2.D0)*(GX+(0.D0,1.D0)*GY)
      IF(-MY .EQ. 0)GMY =GZ
      D2PSM(IBAS)=SPSK2(IBAS,INUC,ISPIN1,IBAND)*GMY1*GMY*(-1)**(MY1+MY)*
     &  (0.D0,1.D0)*2.D0*PI/PAR*(0.D0,1.D0)*2.D0*PI/PAR
	ELSE
	D2PSM(IBAS)=(0.D0,0.D0)
	ENDIF
      ENDDO                                     !!! over plane waves
C  COMPUTE CONTRIBUTION TO THE DYNAMICAL MATRIX
      D2HK=(0.D0,0.D0)
      D2HQ=(0.D0,0.D0)
	DO IBAS=0,MIN(NBAS,MBAS)                  !!! over plane waves
C  1 term
      D2HK=D2HK+CONJG(D2PSM(IBAS))*CONV(IBAS,1)
C  3 term
      D2HK=D2HK+CONJG(DPSKM(IBAS))*CONV(IBAS,3)
C  4 term
      D2HK=D2HK+CONJG(DPSKM(IBAS))*CONV(IBAS,4)
C  2 term
      D2HK=D2HK+CONV(IBAS,2)*D2PSP(IBAS)
C  5 term
      D2HQ=D2HQ+CONV(IBAS,5)*DPSQP(IBAS)
C  6 term
      D2HQ=D2HQ+CONV(IBAS,6)*DPSQP(IBAS)
      ENDDO                                     !!! over plane waves
      D2HMATK(MY1,INUC1,MY,INUC,IBAND,3)=
     &D2HMATK(MY1,INUC1,MY,INUC,IBAND,3)+D2HK*SIGNF
      D2HMATQ(MY1,INUC1,MY,INUC,IBAND,3)=
     &D2HMATQ(MY1,INUC1,MY,INUC,IBAND,3)+D2HQ*SIGNF
 1000 CONTINUE                                  !!! over polarizations
 2000 CONTINUE                                  !!! over displacements
 3000	CONTINUE                                  !!! over bands
 4000	CONTINUE                                  !!! over spin subbands
 5000 CONTINUE                                  !!! over iupdn
 6000	CONTINUE                                  !!! over iorbs
	DEALLOCATE(CONV,DPSKP,DPSQP,DPSKM,DPSQM,D2PSP,D2PSM,CHIS)
	END
