	SUBROUTINE DEL_DELBND(IQPNT)
****************************************************************
*   Control module for package of programs finding change in   *
*   all potential parameters of the LMTO method as wells as    *
*   change in the numbers of states matrix. The induced charge *
*   density is also calculated.                                *
****************************************************************
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
      USE COM_PHNCOM,  ONLY : ITERMAX,NITER                              !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_KAPPAR,  ONLY : NPAN                                       !!! from readini
	USE COM_NBANDS,  ONLY : NBNDF,NBNDE,NBNDT,NBNDH                    !!! from readini
	USE COM_KMESH,   ONLY : NPNT                                       !!! from makettr
	USE COM_SUBGROUP,ONLY : NSGQ,NGEQ,ISG,KSYMPN                       !!! from delmesh
	USE COM_TEILORG, ONLY : KEYT                                       !!! from makeplw
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	USE COM_CHANNELS,ONLY : IUNMT,IUPIN,IUPDS                          !!! from channels
	USE COM_PHNCHN,  ONLY : IUDPX,IUDPY,IUDSV,IUDPV,IUDMT,IUDTS
     &                       ,IUPDD,IUDYN,IUDMD,IUDIN                    !!! from phnchn
	IMPLICIT REAL*8 (A-H,O-Z)
C I.   INITIALIZATION
	DO INUC=1,NATOM
	DO MY=-1,1
	IF(NITER(MY,INUC).NE.0.AND.MODE.NE.5)THEN
	CALL DRO_DROFILES(MY,INUC,IQPNT,IUDPX,'I',' ',' ') !!! initialize change in density
	CALL DRO_DPSFILES(MY,INUC,IQPNT,IUDPY,'I',' ',' ') !!! initialize change in pseudod
	ENDIF
	ENDDO
	ENDDO
	CALL DEL_ALLOCATE(IQPNT,'A')            !!! allocate objects
	DO 5000 IPAN=1,NPAN                     !!! DO over energy panels
C II.  COMPUTE ORIGINAL POTENTIAL PARAMETERS
	CALL BND_SETENY(IPAN)                   !!! place Eny somewhere
	CALL BND_CORENY(IPAN)                   !!! find binding energies for semicore
	CALL BND_POTPAR(IPAN)                   !!! different pot. parameters
	CALL BND_LMTPAR(IPAN)                   !!! some compbinations of them
	CALL BND_OVRPAR(IPAN)                   !!! overlap potential par.
	CALL BND_NMTPAR(IPAN)                   !!! NMT-potential parameters
	CALL HUB_HUBPAR(IPAN)                   !!! Hubbard corrections
	CALL BND_ORBPAR(IPAN)                   !!! SO-coupling parameters
	CALL DEL_SGMPAR(IPAN)                   !!! DMFT self-energy
	CALL DEL_RINTPAR(IPAN,IQPNT)            !!! INT potential parameters
	CALL DEL_RNULINT(IPAN,IQPNT)            !!! zeroes in FUN-arrays
	DO INUC=1,NATOM
	DO MY=-1,1
	IF(NITER(MY,INUC).NE.0)THEN
	CALL DPT_DSVFILES(MY,INUC,IQPNT,IUDSV,'R','D',' ') !!! read change in the potential
	CALL DPT_DPVFILES(MY,INUC,IQPNT,IUDPV,'R','D',' ') !!! read change in pseudopotent.
C III. COMPUTE POTENTIAL PARAMETERS VARIATIONS
	CALL DEL_DSSETENY(MY,INUC,IPAN,IQPNT)       !!!"soft" change in set of Eny
	CALL DEL_DSPOTPAR(MY,INUC,IPAN,IQPNT)       !!!"soft" change in rad.fun.
	CALL DEL_DSLMTPAR(MY,INUC,IPAN,IQPNT)       !!!"soft" change in HMT-pot.par.
	CALL DEL_DSOVRPAR(MY,INUC,IPAN,IQPNT)       !!!"soft" change in OMT-pot.par.
	CALL DEL_DSNMTPAR(MY,INUC,IPAN,IQPNT)       !!!"soft" change in NMT-pot.par.
      CALL DEL_DSHUBPAR(MY,INUC,IPAN,IQPNT)       !!!"soft" change in HUB-pot.par.
C     CALL DEL_DSORBPAR(MY,INUC,IPAN,IQPNT)       !!!"soft" change in ORB-pot.par.
	CALL DEL_DSINTPAR(MY,INUC,IPAN,IQPNT)       !!! total change in INT-pot.par.
	CALL DEL_DSNULTOS(MY,INUC,IPAN,IQPNT)       !!! zeroes in DTOS-matrix
	CALL DEL_DSNULINT(MY,INUC,IPAN,IQPNT)       !!! zeroes in DFUN-arrays
	ENDIF
	ENDDO
	ENDDO
C  INTEGRATE CHANGE IN CHARGE DENSITY AND DYNAMICAL MATRIX
	DO 3200 ISGQ=1,NSGQ                         !!! DO over star of the q-vector
	DO 3100 IPNT=1,NPNT(IPAN)                   !!! DO over k-points
	IF(KSYMPN(ISGQ,IPNT).LT.0)GOTO3100
	CALL DEL_SLMTVEC(IPNT,ISGQ,IPAN,IQPNT)      !!! rotate variational coef
	CALL DEL_SDELGNT(IPNT,ISGQ,IPAN,IQPNT)      !!! set str.constants
	CALL DEL_SD2LMTO(IPNT,ISGQ,IPAN,IQPNT)      !!! 2nd change in dyn.mat
	CALL DEL_RTOSINT(IPNT,ISGQ,IPAN,IQPNT)      !!! integrate FUN-arrays
	DO 2200 INUC=1,NATOM
	DO 2100 MY=-1,1
	IF(NITER(MY,INUC).EQ.0)GOTO2100
	CALL DPT_DPVFILES(MY,INUC,IQPNT,IUDPV,'R','D',' ')  !!! read change in pseudopotent.
C IV.  COMPUTE FIRST-ORDER CHANGE IN THE LMTO MATRICES
C 1) PART FROM THE MT-SPHERE
	CALL DEL_SDELGNT(        IPNT,ISGQ,IPAN,IQPNT)      !!! set str.constants
	CALL DEL_SSTRVEC(MY,INUC,IPNT,ISGQ,IPAN,IQPNT)      !!! find A(kj)*dS(k+q) 
	CALL DEL_SDELMTO(MY,INUC,IPNT,ISGQ,IPAN,IQPNT)      !!!"rigid"change in H,O
	CALL DEL_SDELMAT(MY,INUC,IPNT,ISGQ,IPAN,IQPNT)      !!!"total"change in H,O
	CALL DEL_SDELEXP(MY,INUC,IPNT,ISGQ,IPAN,IQPNT)      !!!"total"change in H,O
C 2) PART FROM THE INTERSTITIAL REGION
	CALL DEL_DPSIVEC(MY,INUC,IPNT,ISGQ,IPAN,IQPNT)      !!! change in pseudo|kj>
	CALL DEL_DINTMAT(MY,INUC,IPNT,ISGQ,IPAN,IQPNT)      !!! "total"change in <V>
	CALL DEL_DINLMAT(MY,INUC,IPNT,ISGQ,IPAN,IQPNT)      !!! "total"change in <V>
C V.   COMPUTE CHANGE IN NUMBER-OF-STATES MATRIX AND PSEUDODENSITY
	IF(MODE.NE.5)THEN
C 1) PART FROM THE MT-SPHERE
	CALL DEL_DTOSPAR(MY,INUC,IPNT,ISGQ,IPAN,IQPNT)      !!! find change in TOS
C 2) PART FROM THE INTERSTITIAL REGION
	CALL DEL_DTOSINT(MY,INUC,IPNT,ISGQ,IPAN,IQPNT)      !!! find change in psrho
	ENDIF
C VI.  COMPUTE SECOND-ORDER CHANGE IN THE LMTO MATRICES
	IF(MODE.EQ.4)THEN
	CALL DEL_SDELGNT(IPNT,ISGQ,IPAN,IQPNT)              !!! set str.constants
	CALL DEL_STRVEC2(IPNT,ISGQ,IPAN,IQPNT)              !!! find A(kj)*dS(k+q)
	CALL DEL_SD2LMAT(MY,INUC,IPNT,ISGQ,IPAN,IQPNT)      !!! 2nd change
	CALL DEL_PSIVEC2(IPNT,ISGQ,IPAN,IQPNT)              !!! change in |kj>
	CALL DEL_SD2VINT(MY,INUC,IPNT,ISGQ,IPAN,IQPNT)      !!! 2nd change
	ENDIF 
2100  CONTINUE
2200  CONTINUE
C VII. COMPUTE BAND CONTRIBUTION TO THE DYNAMICAL MATRIX
	CALL DEL_SDYNBND(IPNT,ISGQ,IPAN,IQPNT)  !!! band contribution to dyn.mat
C VIII.COMPUTE ELECTRON-PHONON INTERACTION MATRIX ELEMENTS
	CALL DEL_SEPIBND(IPNT,ISGQ,IPAN,IQPNT)  !!! contribution to epi
3100  CONTINUE                                !!! ENDDO over star of q-vector
3200  CONTINUE                                !!! ENDDO over k-points
C IX.  COMPUTE FIRST-ORDER CHANGE IN CHARGE DENSITY
	DO INUC=1,NATOM
	DO MY=-1,1
	IF(NITER(MY,INUC).NE.0.AND.MODE.NE.5)THEN
	CALL DRO_SDELRHO(MY,INUC,IPAN,IQPNT)        !!! induced density within MTs
	CALL DEL_DTOSEND(MY,INUC,IPAN,IQPNT)  !!! induced density within INs
C REMOVE SCRATCH FILES
      CALL NMTFILES(MY,INUC,IPAN,1,1,IUDMT,'D')   !!! file opened in DNMTPAR
	CALL TOSFILES(MY,INUC,IPAN,1,1,IUDTS,'D')   !!! file opened in DTOSPAR
	CALL TOSFILES(MY,INUC,IPAN,1,1,IUPDD,'D')   !!! file opened in DTOSINT
	ENDIF
	ENDDO
	ENDDO
C X.  COMPUTE FINAL CONTRIBUTION TO THE DYNAMICAL MATRIX
	IF(MODE.EQ.4.AND.KEYT.GT.0)THEN
	DO INUC=1,NATOM
	DO MY=-1,1
	IF(NITER(MY,INUC).NE.0)THEN
	CALL DPT_DPVFILES(MY,INUC,IQPNT,IUDPV,'R','D',' ') !!! read change in pseudopotent.
	CALL DEL_D2INTPAR(MY,INUC,IPAN,IQPNT)       !!! D2 change in int.par.
	CALL DEL_D2TOSNUL(MY,INUC,IPAN,IQPNT)       !!! zeroes in D2-arrays
	DO ISGQ=1,NSGQ                              !!! over star of the q-vector
	DO IPNT=1,NPNT(IPAN)                        !!! over k-points
	IF(KSYMPN(ISGQ,IPNT).GE.0)THEN
	CALL DEL_SLMTVEC(         IPNT,ISGQ,IPAN,IQPNT)      !!! rotate variational coef
	CALL DEL_D2PSIVEC(MY,INUC,IPNT,ISGQ,IPAN,IQPNT)      !!! change in pseudo|kj>
	CALL DEL_D2TOSINT(MY,INUC,IPNT,ISGQ,IPAN,IQPNT)      !!! integrate DPUL-arrays
	ENDIF
	ENDDO                                   !!! over star of q-vector
	ENDDO                                   !!! over k-points
	CALL DEL_D2TOSEND(MY,INUC,IPAN,IQPNT)
	ENDIF
	ENDDO
	ENDDO
	CLOSE(UNIT=IUDYN,STATUS='DELETE')       !!! file opened in D2INTPAR
	CLOSE(UNIT=IUDMD,STATUS='DELETE')       !!! file opened in D2TOSINT
	ENDIF
C REMOVE SCRATCH FILES
	CLOSE(UNIT=IUPIN,STATUS='DELETE')       !!! file opened in RINTPAR
	CLOSE(UNIT=IUPDS,STATUS='DELETE')       !!! file opened in RTOSINT
	DO INUC=1,NATOM
	DO MY=-1,1
	IF(NITER(MY,INUC).NE.0)THEN
      CALL NMTFILES(MY,INUC,IPAN,1,1,IUDIN,'D')!! file opened in DINTPAR
	ENDIF
	ENDDO
	ENDDO
	CLOSE(UNIT=IUNMT,STATUS='DELETE')       !!! file opened in NMTPAR
5000  CONTINUE                                !!! ENDDO over energy panels
C  XI. SYMMETRIZATION PROGRAMS
	CALL DEL_SYMDRHO(IQPNT)                 !!! symmetrize change in density
	CALL DEL_SYMDPSR(IQPNT)                 !!! the same for pseudodensity
	CALL DEL_SDYNSYM(IQPNT)                 !!! Band term in dyn.mat.
	CALL DEL_SEPISYM(IQPNT)                 !!! Electron-phonon interaction
	CALL DEL_ALLOCATE(IQPNT,'D')            !!! deallocate objects
	END
