	SUBROUTINE DEL_DSSETENY(MY,INUC,IPAN,IQPNT)
****************************************************************
*  Subroutine calculates change in Eny for semicore states.    *
****************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT                                       !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,LRTV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_LRTCOM,  ONLY : LDLF                                       !!! from readlrt
	USE COM_RADMESH, ONLY : NRAD,H,R,DR                                !!! from makerad
	USE COM_SPHERE,  ONLY : SWZ,SMT                                    !!! from readini
      USE COM_INPPAR,  ONLY : TNY,ENY,DNY,NODES,MNY                      !!! from readini
	USE COM_KAPPAR,  ONLY : NPAN,NKAP,EK,EKAP                          !!! from readini
	USE COM_PANPAR,  ONLY : LTPAN,LSPAN,IATS,ISTS                      !!! from readini
	USE COM_DINPPAR, ONLY : DELENY                                     !!! from dinppar
	USE COM_POTDAT,  ONLY : POTRWF                                     !!! from fulpot
	USE COM_DELPOT,  ONLY : DPOTRWF                                    !!! from delpot
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8, ALLOCATABLE :: AFIS(:,:)
	REAL*8, ALLOCATABLE :: AFIDS(:,:)
	REAL*8, ALLOCATABLE :: AFIPS(:,:)
	REAL*8, ALLOCATABLE :: AFIDPS(:,:)
	REAL*8, ALLOCATABLE :: DNYP(:,:)
	REAL*8, ALLOCATABLE :: FPMN(:)
	COMPLEX*16, ALLOCATABLE :: HAN(:,:)
	COMPLEX*16, ALLOCATABLE :: DFPMN(:)
	COMPLEX*16, ALLOCATABLE :: DENYT(:)
	COMPLEX*16, ALLOCATABLE :: DFIS(:,:)
	COMPLEX*16, ALLOCATABLE :: DFIDS(:,:)
	COMPLEX*16, ALLOCATABLE :: DFIPS(:,:)
	COMPLEX*16, ALLOCATABLE :: DFIDPS(:,:)
	COMPLEX*16 HANDOT,HANDDOT,EC,HT
     &   ,WDFIFI,WFIPFI,WHAPHA,WDVPHA,DENY0
	DATA PI/3.141592653589793D0/
	SQPI4=SQRT(4.D0*PI)
C  Memory allocations
	ALLOCATE(HAN(3,-1:LMAXBMEM))
	ALLOCATE(DFPMN(0:LMAXTMEM))
	ALLOCATE(DENYT(0:LMAXTMEM))
	ALLOCATE(DFI S(0:LMAXTMEM,NKAPMEM))
	ALLOCATE(DFIDPS(0:LMAXTMEM,NKAPMEM))
	ALLOCATE(DFID S(0:LMAXTMEM,NKAPMEM))
	ALLOCATE(DFIPS(0:LMAXTMEM,NKAPMEM))
	ALLOCATE(AFI S(0:LMAXTMEM,NKAPMEM))
	ALLOCATE(AFID S(0:LMAXTMEM,NKAPMEM))
	ALLOCATE(AFIPS(0:LMAXTMEM,NKAPMEM))
	ALLOCATE(AFIDPS(0:LMAXTMEM,NKAPMEM))
	ALLOCATE(DNYP(0:LMAXTMEM,NKAPMEM))
	ALLOCATE(FPMN(0:LMAXTMEM))
C  ****** ENY VARIATION  ******
      DO ISPIN=1,NSPIN                                     !!! over spins
	DO IATOM=1,NATOM                                     !!! over iatom
	ISORT=IS(IATOM)
	DO IKAP=1,NKAP(IPAN)                                 !!! over ikap
	DO L=0,ILST(ISORT)
	DELENY(L,IKAP,IATOM,ISPIN,MY,INUC)=(0.D0,0.D0)
	DENYT(L)=(0.D0,0.D0)
	ENDDO
	IF(LDLF.EQ.2)THEN
C  SOLVE RADIAL SCHROEDINGER EQUATION IN CASE DELTA{ENY} IS NULL
	CALL LIB_DRADSCH_PARS(ENY(0,ISORT,IKAP,IPAN,ISPIN),DENYT(0),
     &AFIS(0,IKAP),AFIPS(0,IKAP),AFIDS(0,IKAP),AFIDPS(0,IKAP),FPMN,
     &DFIS(0,IKAP),DFIPS(0,IKAP),DFIDS(0,IKAP),DFIDPS(0,IKAP),
     &DFPMN,SMT(ISORT),POTRWF(0,ISORT,ISPIN),
     &DPOTRWF(0,IATOM,ISPIN,MY,INUC),ILST(ISORT),NRAD(ISORT),
     &H(ISORT),R(0,ISORT),DR(0,ISORT),LRTV(ISORT))
C  CALCULATE CHANGE IN ENY'S UPON THE PERTURBATION
      DO L=0,ILST(ISORT)
      WDFIFI=SMT(ISORT)/AFIS(L,IKAP)*(DFIDS(L,IKAP)-
     &  AFIDS(L,IKAP)/AFIS(L,IKAP)*DFIS(L,IKAP))
      WFIPFI=SMT(ISORT)/AFIS(L,IKAP)*(AFIDPS(L,IKAP)-
     &  AFIDS(L,IKAP)/AFIS(L,IKAP)*AFIPS(L,IKAP))
      DELENY(L,IKAP,IATOM,ISPIN,MY,INUC)=-WDFIFI/WFIPFI
	ENDDO
	ENDIF
	ENDDO                                                !!! over ikap
	ENDDO                                                !!! over atoms
      ENDDO                                                !!! over spins
C  FOR DEEP LYING SEMICORE STATES TAKE INTO ACCOUNT THAT DELDNY CAN BE .NE.0
      IF(IPAN.NE.1.AND.LDLF.EQ.2)THEN
      DO ISPIN=1,NSPIN                                     !!! over spins
      DO IATOM=1,NATOM                                     !!! over iatom
      ISORT=IS(IATOM)
      IF(IATS(IATOM,IPAN).NE.0)THEN
      DO IKAP=1,NKAP(IPAN)                                 !!! over ikap
      DO L=0,ILSB(ISORT)
      DENYT(L)=(0.D0,0.D0)
	ENDDO 
C  SOLVE RADIAL SCHROEDINGER EQUATION IN CASE DELTA{ENY} IS NULL
      CALL LIB_DRADSCH_PARS(ENY(0,ISORT,IKAP,IPAN,ISPIN),DENYT(0),
     &AFIS(0,IKAP),AFIPS(0,IKAP),AFIDS(0,IKAP),AFIDPS(0,IKAP),FPMN,
     &DFIS(0,IKAP),DFIPS(0,IKAP),DFIDS(0,IKAP),DFIDPS(0,IKAP),
     &DFPMN,SMT(ISORT),POTRWF(0,ISORT,ISPIN),
     &DPOTRWF(0,IATOM,ISPIN,MY,INUC),ILSB(ISORT),NRAD(ISORT),
     &H(ISORT),R(0,ISORT),DR(0,ISORT),LRTV(ISORT))
C  FIND HANKEL FUNCTIONS AND THEIR ENERGY DERIVATIVES
      DO L=0,ILSB(ISORT)
      IF(LSPAN(L,ISORT,IKAP,IPAN))THEN
      VMTS=-POTRWF(NRAD(ISORT),ISORT,ISPIN)/R(NRAD(ISORT),ISORT)
      EC=ENY(L,ISORT,IKAP,IPAN,ISPIN)-VMTS
      CALL LIB_HANKEL(SMT(ISORT),EC,SMT(ISORT),HAN(1,0),ILSB(ISORT))
      IF(ABS(EC).NE.0.D0)HT=-(0.D0,1.D0)/SQRT(EC)/SMT(ISORT)
      IF(ABS(EC).EQ.0.D0)HT=(1.D0,0.D0)
      DO ID=1,3
      HAN(ID,-1)=HT*HAN(ID,0)
	ENDDO 
      IF(ABS(EC).EQ.0.D0)HAN(2,-1)=(0.D0,0.D0)
      HANDOT=0.5D0*SMT(ISORT)*SMT(ISORT)/(2.D0*L-1.D0)*HAN(1,L-1)
      HANDDOT=0.5D0*SMT(ISORT)/(2.D0*L-1.D0)*(HAN(1,L-1)+
     &  SMT(ISORT)*HAN(2,L-1))
C  CALCULATE CHANGE IN ENY'S UPON THE PERTURBATION
      WDFIFI=SMT(ISORT)/AFIS(L,IKAP)*(DFIDS(L,IKAP)-
     &  AFIDS(L,IKAP)/AFIS(L,IKAP)*DFIS(L,IKAP))
      WFIPFI=SMT(ISORT)/AFIS(L,IKAP)*(AFIDPS(L,IKAP)-
     &  AFIDS(L,IKAP)/AFIS(L,IKAP)*AFIPS(L,IKAP))
      WHAPHA=SMT(ISORT)/HAN(1,L)*(HANDDOT-HAN(2,L)/HAN(1,L)*HANDOT)
      WDVPHA=DPOTRWF(NRAD(ISORT),IATOM,ISPIN,MY,INUC)*WHAPHA/SQPI4
      DELENY(L,IKAP,IATOM,ISPIN,MY,INUC)=(WDFIFI+WDVPHA)/
     &  (WHAPHA-WFIPFI)
	ENDIF
	ENDDO
      ENDDO                                                !!! over ikap
	ENDIF
      ENDDO                                                !!! over iatom
      ENDDO                                                !!! over spins
      ENDIF
C  Memory deallocations
	DEALLOCATE(HAN,DFPMN,DENYT,DFIS,DFIDPS,DFIDS,DFIPS)
	DEALLOCATE(AFIS,AFIDS,AFIPS,AFIDPS,DNYP,FPMN)
      END
