      SUBROUTINE DEL_SDELEXP(MY,INUC,IPNT,ISGQ,IPAN,IQPNT)
*************************************************************
* Subroutine adds self-energy part to the hamiltonian       *
*************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                          !!! from setup
      USE COM_CONTROL ,ONLY: LMTO,IASA,NPFR,NOVR,IDMF,MODE    !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS
     &                      ,IS,ILSB,ILST                     !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP                   !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN                      !!! from readini
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDH          !!! from readini
      USE COM_INDORB  ,ONLY: INDDMF                           !!! from lmtpar
	USE COM_DELHAM  ,ONLY: DHMATT,DOMATT,DHMATR,DOMATR      !!! from delexp
      USE COM_HUBDAT  ,ONLY: MCRL,LCRL                        !!! from readhub
      USE COM_IMPDAT  ,ONLY: NPOLIMP                          !!! from readhub
	USE COM_RATDAT  ,ONLY: VRAT,WRAT,PRAT,ORAT              !!! from readhub
      USE COM_DELHUB  ,ONLY: DELVRAT,DELWRAT,DELPRAT,DELORAT  !!! from potfiles
      USE COM_LMTPAR  ,ONLY: GAM,AAH,AAJ,BBH,BBJ              !!! from potpar
	USE COM_DLMTPAR ,ONLY: DELAAH,DELBBH,DELAAJ,DELBBJ      !!! from dpotpar
	USE COM_PSIVEC  ,ONLY: APHK,APJK,APHQ,APJQ,AEHK,AEHQ    !!! from lmtvec
	USE COM_FERMI   ,ONLY: EF                               !!! from ttrint
	USE COM_DSTRCON ,ONLY: DSKL,DSQL                        !!! from strvec2
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT,IUI                  !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: DELSVT(:,:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: DELSWT(:,:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: DELSVR(:,:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: DELSWR(:,:,:,:,:)
      COMPLEX*16  HHH,ZMSB,HS,OS
	LOGICAL LOG
	DATA PI/3.141592653589793D0/
	CALL ABORTNOW()
	IF(IDMF.NE.4)RETURN
	IF(IPAN.GT.1)RETURN
C MEMORY ALLOCATIONS
	NDIM=NBNDT(1)*NSPIN
      NDIR=(NBNDT(1)+NBNDH(1))*NSPIN
	ALLOCATE(DELSVT(LIMBMEM,NATOMMEM,NPOLMEM,NSPINMEM,
     &                     (NBNDT(1)+NBNDH(1))*NSPINMEM))
	ALLOCATE(DELSWT(LIMBMEM,NATOMMEM,NPOLMEM,NSPINMEM,
     &                     (NBNDT(1)+NBNDH(1))*NSPINMEM))
	ALLOCATE(DELSVR(LIMBMEM,NATOMMEM,NPOLMEM,NSPINMEM,
     &                     (NBNDT(1)+NBNDH(1))*NSPINMEM))
	ALLOCATE(DELSWR(LIMBMEM,NATOMMEM,NPOLMEM,NSPINMEM,
     &                     (NBNDT(1)+NBNDH(1))*NSPINMEM))
C FERMI LEVEL
	EFRM=EF
C *****************************************************
      IF(MODE.NE.5)IBNDMIN=1
      IF(MODE.NE.5)IBNDMAX=NBNDT(IPAN)+NBNDH(IPAN)
      IF(MODE.EQ.5)IBNDMIN=NBNDE(IPAN)
      IF(MODE.EQ.5)IBNDMAX=NBNDF(IPAN)
C SET EXPANSION OF THE HAMILTONIAN
      DO 5000 IORBS=1,NORBS
      DO 4000 IUPDN=1,NSPIN
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
      DO 1200 IBNDS=1,NSPIN                     !!! over spin subbands
	IF(NORBS.EQ.1.AND.IBNDS.NE.ISPIN1)GOTO 1200
	IF(NORBS.EQ.1.AND.IBNDS.NE.ISPIN) GOTO 1200
	DO 1100 IBNDT=IBNDMIN,IBNDMAX             !!! over all bands
	IBAND=IBNDS+NSPIN*(IBNDT-1)
C Zeroise
	DO IATOM=1,NATOM                    !!! over iatom
	ISORT=IS(IATOM)
	IF(MCRL(IATOM).EQ.0)CYCLE
	DO L=0,ILSB(ISORT)                  !!! over l
	IF(LCRL(L,IATOM).EQ.0)CYCLE
	DO M=-L,L                           !!! over m
	LM=L*(L+1)+M+1
	DO IPOL=1,NPOLMEM
	DELSVT(LM,IATOM,IPOL,ISPIN1,IBAND)=(0.D0,0.D0)
	DELSWT(LM,IATOM,IPOL,ISPIN ,IBAND)=(0.D0,0.D0)
	DELSVR(LM,IATOM,IPOL,ISPIN1,IBAND)=(0.D0,0.D0)
	DELSWR(LM,IATOM,IPOL,ISPIN ,IBAND)=(0.D0,0.D0)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C Compute
      DO IKAP=1,NKAP(1)                   !!! over ikap
	DO IATOM=1,NATOM                    !!! over iatom
	ISORT=IS(IATOM)
	IF(MCRL(IATOM).EQ.0)CYCLE
	DO L=0,ILSB(ISORT)                  !!! over l
	IF(LCRL(L,IATOM).EQ.0)CYCLE
	DO M=-L,L                           !!! over m
	LM=L*(L+1)+M+1
	DO IPOL=1,NPOLIMP(L,IATOM)          !!! over poles
	DO K=-L,L
	LK=L*(L+1)+K+1
	IV=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+K+1 !!! (l,k m)
	IW=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+K)+L+M+1 !!! (l,m k)
C H term
	DELSVT(LM,IATOM,IPOL,ISPIN1,IBAND)=
     &DELSVT(LM,IATOM,IPOL,ISPIN1,IBAND)+
     &DCONJG(APHQ(LK,IATOM,IKAP,ISPIN1,IBAND))*(
     &VRAT(IV,IATOM,IUPDN,IORBS,IPOL)*
     &DELAAH(L,IKAP,IATOM,ISPIN1,2,MY,INUC)+
     &DELVRAT(IV,IATOM,IUPDN,IORBS,IPOL)*
     &DCONJG(AAH(L,ISORT,IKAP,1,ISPIN1)))
	DELSWT(LM,IATOM,IPOL,ISPIN,IBAND)=
     &DELSWT(LM,IATOM,IPOL,ISPIN,IBAND)+
     &(WRAT(IW,IATOM,IUPDN,IORBS,IPOL)*
     &DELAAH(L,IKAP,IATOM,ISPIN,1,MY,INUC)+
     &DELWRAT(IW,IATOM,IUPDN,IORBS,IPOL)*
     &AAH(L,ISORT,IKAP,1,ISPIN))*
     &APHK(LK,IATOM,IKAP,ISPIN,IBAND)
C J term
	DELSVT(LM,IATOM,IPOL,ISPIN1,IBAND)=
     &DELSVT(LM,IATOM,IPOL,ISPIN1,IBAND)-
     &DCONJG(APJQ(LK,IATOM,IKAP,ISPIN1,IBAND))*GAM(L,ISORT)*
     &(DELAAJ(L,IKAP,IATOM,ISPIN1,2,MY,INUC)*
     &VRAT(IV,IATOM,IUPDN,IORBS,IPOL)+
     &DCONJG(AAJ(L,ISORT,IKAP,1,ISPIN1))*
     &DELVRAT(IV,IATOM,IUPDN,IORBS,IPOL))
 	DELSWT(LM,IATOM,IPOL,ISPIN,IBAND)=
     &DELSWT(LM,IATOM,IPOL,ISPIN,IBAND)-
     &(DELAAJ(L,IKAP,IATOM,ISPIN,1,MY,INUC)*
     &WRAT(IW,IATOM,IUPDN,IORBS,IPOL)+
     &AAJ(L,ISORT,IKAP,1,ISPIN)*
     &DELWRAT(IW,IATOM,IUPDN,IORBS,IPOL))*
     &APJK(LK,IATOM,IKAP,ISPIN,IBAND)*GAM(L,ISORT)
C J term-rigid change
      IF(MODE.NE.2)THEN
	DELSVR(LM,IATOM,IPOL,ISPIN1,IBAND)=
     &DELSVR(LM,IATOM,IPOL,ISPIN1,IBAND)-(-1)**MY*
     &DCONJG(DSQL(LK,IATOM,IKAP,ISPIN1,IBAND,-MY))*
     &GAM(L,ISORT)*AAJ(L,ISORT,IKAP,1,ISPIN1)*
     &VRAT(IV,IATOM,IUPDN,IORBS,IPOL)
 	DELSWR(LM,IATOM,IPOL,ISPIN,IBAND)=
     &DELSWR(LM,IATOM,IPOL,ISPIN,IBAND)-
     &AAJ(L,ISORT,IKAP,1,ISPIN)*
     &WRAT(IW,IATOM,IUPDN,IORBS,IPOL)*
     &DSKL(LK,IATOM,IKAP,ISPIN,IBAND,MY)*GAM(L,ISORT)
      ENDIF
	ENDDO                               !!! over k
	DELSVT(LM,IATOM,IPOL,ISPIN1,IBAND)=
     &DELSVT(LM,IATOM,IPOL,ISPIN1,IBAND)+
     &DELSVR(LM,IATOM,IPOL,ISPIN1,IBAND)
	DELSWT(LM,IATOM,IPOL,ISPIN1,IBAND)=
     &DELSWT(LM,IATOM,IPOL,ISPIN1,IBAND)+
     &DELSWR(LM,IATOM,IPOL,ISPIN1,IBAND)
	ENDDO                               !!! over poles
      ENDDO                               !!! over m
      ENDDO                               !!! over l
	ENDDO                               !!! over iatom
      ENDDO                               !!! over ikap
 1100 CONTINUE                            !!! over ibndt
 1200 CONTINUE                            !!! over ibnds
      DO 3200 IBNDS1=1,NSPIN              !!! over spin subbands
	IF(NORBS.EQ.1.AND.IBNDS1.NE.ISPIN1)GOTO 3200
	DO 3100 IBNDT1=IBNDMIN,IBNDMAX      !!! over all bands
	IBAND1=IBNDS1+NSPIN*(IBNDT1-1)
      DO 2200 IBNDS=1,NSPIN               !!! over spin subbands
	IF(NORBS.EQ.1.AND.IBNDS.NE.ISPIN)GOTO 2200
	DO 2100 IBNDT=IBNDMIN,IBNDMAX       !!! over all bands
	IBAND=IBNDS+NSPIN*(IBNDT-1)
C BUILD HAMILTONIAN AND OVERLAP MATRIX WITH SELF-ENERGY IN IT
	NSHF=0
	DO IATOM=1,NATOM                    !!! over iatom
	ISORT=IS(IATOM)
	IF(MCRL(IATOM).EQ.0)CYCLE
	DO L=0,ILSB(ISORT)                  !!! over l
	IF(LCRL(L,IATOM).EQ.0)CYCLE
	DO IPOL=1,NPOLIMP(L,IATOM)          !!! over poles
	ISH1=(ISPIN1-1)*(NBNDT(1)+NBNDH(1))+NBNDT(1)+
     &     (2*L+1)*(IPOL-1)+NSHF
	ISH =(ISPIN -1)*(NBNDT(1)+NBNDH(1))+NBNDT(1)+
     &     (2*L+1)*(IPOL-1)+NSHF
	DO M1=-L,L                          !!! over m1
	LM1=L*(L+1)+M1+1
C	IDIM1=INDDMF(LM1,IATOM,IKAP1,ISPIN1)
	IDIR1=M1+L+1+ISH1
	DO M=-L,L                           !!! over m
	LM=L*(L+1)+M+1
C	IDIM =INDDMF(LM ,IATOM,IKAP,ISPIN)
	IDIR =M +L+1+ISH
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M1+1 !!! (l,m1 m)
	DHMATT(IBAND1,IBAND,MY,INUC)=DHMATT(IBAND1,IBAND,MY,INUC)+
     &DCONJG(AEHQ(LM1,IATOM,IPOL,ISPIN1,IBAND1))*
     &(DELPRAT(IU,IATOM,IUPDN,IORBS,IPOL)+EFRM*
     & DELORAT(IU,IATOM,IUPDN,IORBS,IPOL))*
     &AEHK(LM,IATOM,IPOL,ISPIN,IBAND)
	DOMATT(IBAND1,IBAND,MY,INUC)=DOMATT(IBAND1,IBAND,MY,INUC)+
     &DCONJG(AEHQ(LM1,IATOM,IPOL,ISPIN1,IBAND1))*
     &DELORAT(IU,IATOM,IUPDN,IORBS,IPOL)*
     &AEHK(LM,IATOM,IPOL,ISPIN,IBAND)
      ENDDO                               !!! over m
      ENDDO                               !!! over m1
	ENDDO                               !!! over poles
	NSHF=NSHF+NPOLIMP(L,IATOM)*(2*L+1)
      ENDDO                               !!! over l
      ENDDO                               !!! over iatom
C
	DO IATOM=1,NATOM                    !!! over iatom
	ISORT=IS(IATOM)
	IF(MCRL(IATOM).EQ.0)CYCLE
	DO L=0,ILSB(ISORT)                  !!! over l
	IF(LCRL(L,IATOM).EQ.0)CYCLE
	DO IPOL=1,NPOLIMP(L,IATOM)          !!! over poles
	DO M=-L,L                           !!! over m
	LM=L*(L+1)+M+1
	DHMATT(IBAND1,IBAND,MY,INUC)=DHMATT(IBAND1,IBAND,MY,INUC)+
     &DCONJG(AEHQ(LM,IATOM,IPOL,ISPIN1,IBAND1))*
     &DELSWT(LM,IATOM,IPOL,ISPIN,IBAND)
      IF(MODE.NE.2)THEN
	DHMATR(IBAND1,IBAND,MY,INUC)=DHMATR(IBAND1,IBAND,MY,INUC)+
     &DCONJG(AEHQ(LM,IATOM,IPOL,ISPIN1,IBAND1))*
     &DELSWR(LM,IATOM,IPOL,ISPIN,IBAND)
      ENDIF
      ENDDO                               !!! over m
	ENDDO                               !!! over poles
      ENDDO                               !!! over l
      ENDDO                               !!! over iatom
C
	DO IATOM=1,NATOM                    !!! over iatom
	ISORT=IS(IATOM)
	IF(MCRL(IATOM).EQ.0)CYCLE
	DO L=0,ILSB(ISORT)                  !!! over l
	IF(LCRL(L,IATOM).EQ.0)CYCLE
	DO IPOL=1,NPOLIMP(L,IATOM)          !!! over poles
	DO M=-L,L                           !!! over m
	LM=L*(L+1)+M+1
	DHMATT(IBAND1,IBAND,MY,INUC)=
     &DHMATT(IBAND1,IBAND,MY,INUC)+
     &DELSVT(LM,IATOM,IPOL,ISPIN1,IBAND1)*
     &AEHK(LM,IATOM,IPOL,ISPIN,IBAND)
      IF(MODE.NE.2)THEN
	DHMATR(IBAND1,IBAND,MY,INUC)=
     &DHMATR(IBAND1,IBAND,MY,INUC)+
     &DELSVR(LM,IATOM,IPOL,ISPIN1,IBAND1)*
     &AEHK(LM,IATOM,IPOL,ISPIN,IBAND)
      ENDIF
      ENDDO                               !!! over m
	ENDDO                               !!! over poles
      ENDDO                               !!! over l
      ENDDO                               !!! over iatom
 2100	CONTINUE                            !!! over bands
 2200	CONTINUE                            !!! over ibnds
 3100	CONTINUE                            !!! over bands
 3200	CONTINUE                            !!! over ibnds
 4000	CONTINUE                            !!! over spins
 5000	CONTINUE                            !!! over iorbs
C ERROR HANDLINGS
C none
C MEMORY DEALLOCATIONS
	DEALLOCATE(DELSVT,DELSWT,DELSVR,DELSWR)
	END
