	SUBROUTINE DEL_SDELGNT(IPNT,ISGQ,IPAN,IQPNT)
**********************************************************
*  Calculate structure constants and their energy deri-  *
*  vatives for the k-points: g*k and g*k+q=g'*k'         *
**********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_KAPPAR,  ONLY : NPAN,NKAP,EK,EKAP                          !!! from readini
	USE COM_SUBGROUP,ONLY : NSGQ,NGEQ,ISG                              !!! from delmesh
	USE COM_NBANDS,  ONLY : NBNDF,NBNDE,NBNDT                          !!! from readini
	USE COM_GROUPS,  ONLY : NGROUP,U,IP,RDC,INV,IKOV                   !!! from makegrp
	USE COM_DSTRCON, ONLY : STRK,STDK,STRQ,STDQ                        !!! from delgnt
	USE COM_SYMMESH, ONLY : IG0IG1,IK0IK1                              !!! from delmesh
	USE COM_KMESH,   ONLY : NPNT,PNT                                   !!! from makettr
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: SSK(:,:)
	COMPLEX*16, ALLOCATABLE :: SSQ(:,:)
	COMPLEX*16, ALLOCATABLE :: SDK(:,:)
	COMPLEX*16, ALLOCATABLE :: SDQ(:,:)
	COMPLEX*16 PHSK,PHSQ
	LOGICAL FIRST,LOG
	DATA PI/3.141592653589793D0/,FIRST/.TRUE./
	IF(MODE.EQ.2)RETURN
C  Memory allocations
      ALLOCATE(SSK(LIMT1MEM,NATOMMEM))
	ALLOCATE(SDK(LIMB1MEM,NATOMMEM))
      ALLOCATE(SSQ(LIMT1MEM,NATOMMEM))
	ALLOCATE(SDQ(LIMB1MEM,NATOMMEM))
C  SET POINT-GROUP INFORMATION
	IRK=ISG(1,ISGQ)       !!!  element "g"  in the main G-list
	IGK=IKOV(IRK)         !!!  element "g"  after Kovalev
	IPNTK=IPNT            !!!  point   "k"
	IRQ=IG0IG1(IPNT,IRK)  !!!  element "g'" in the main G-list
	IGQ=IKOV(IRQ)         !!!  element "g'" after Kovalev
	IPNTQ=IK0IK1(IPNT,IRK)!!!  point   "k'" such that g*k+q=g'*k'
C  RESTORE STRUCTURE CONSTANTS FOR K AND K+Q VECTORS
	CALL DEL_DSTRGNT(IPNTK,IPNTQ,IPAN)
C  **** ROTATE STRUCTURE CONSTANTS WITH THE LEFT INDEX ****
	DO 200 IKAP=1,NKAP(IPAN)                   !!! over energies
	DO 90 JATOM=1,NATOM                        !!! over jatom
	JSORT=IS(JATOM)
	JATOMK=IP(JATOM,IRK)
	JATOMQ=IP(JATOM,IRQ)
	DO 80 L=0,ILSB(JSORT)                      !!! over l
	DO 70 M=-L,L                               !!! over m
	LM=L*(L+1)+M+1
	DO 20 IATOM=1,NATOM                        !!! over iatom
	ISORT=IS(IATOM)
	DO 10 L1=0,1+ILST(ISORT)                   !!! over l1
	LOG=.FALSE.
	IF(L1.LE.ILSB(ISORT)+1)LOG=.TRUE.
	DO 10 M1=-L1,L1                           !!! over m1
	L1M1=L1*(L1+1)+M1+1
C  SET S AND S-DOT FOR K-POINT
	SSK(L1M1,IATOM)=STRK(L1M1,IATOM,LM,JATOMK,IKAP)
	IF(LOG)
     &	SDK(L1M1,IATOM)=STDK(L1M1,IATOM,LM,JATOMK,IKAP)
C  SET S AND S-DOT FOR K'-POINT
	SSQ(L1M1,IATOM)=STRQ(L1M1,IATOM,LM,JATOMQ,IKAP)
	IF(LOG)
     &	SDQ(L1M1,IATOM)=STDQ(L1M1,IATOM,LM,JATOMQ,IKAP)
  10	CONTINUE                                  !!! over l1m1
  20  CONTINUE                                  !!! over iatom
	DO 60 IATOM=1,NATOM                       !!! over iatom
	ISORT=IS(IATOM)
	SK=PNT(1,IPNTK,IPAN)*RDC(1,IATOM,IRK)+
     &   PNT(2,IPNTK,IPAN)*RDC(2,IATOM,IRK)+
     &   PNT(3,IPNTK,IPAN)*RDC(3,IATOM,IRK)
	SQ=PNT(1,IPNTQ,IPAN)*RDC(1,IATOM,IRQ)+
     &   PNT(2,IPNTQ,IPAN)*RDC(2,IATOM,IRQ)+
     &   PNT(3,IPNTQ,IPAN)*RDC(3,IATOM,IRQ)
	PHSK=EXP(2.D0*PI*SK*(0.D0,1.D0))
	PHSQ=EXP(2.D0*PI*SQ*(0.D0,1.D0))
	DO 50 L1=0,ILST(ISORT)+1                  !!! over l1
	LOG=.FALSE.
	IF(L1.LE.ILSB(ISORT)+1)LOG=.TRUE.
	LL1=L1*(2*L1-1)*(2*L1+1)/3
	DO 40 M1=-L1,L1                           !!! over m1
	L1M1=L1*(L1+1)+M1+1
	STRK(L1M1,IATOM,LM,JATOMK,IKAP)=(0.D0,0.D0)
	STRQ(L1M1,IATOM,LM,JATOMQ,IKAP)=(0.D0,0.D0)
	IF(LOG)STDK(L1M1,IATOM,LM,JATOMK,IKAP)=(0.D0,0.D0)
	IF(LOG)STDQ(L1M1,IATOM,LM,JATOMQ,IKAP)=(0.D0,0.D0)
C  ROTATE S AND S-DOT FOR K,K'-POINTS
	DO 30 M2=-L1,L1                           !!! over m2
	L1M2=L1*(L1+1)+M2+1
	IWIG12=LL1+(2*L1+1)*(L1+M2)+L1+M1+1
	STRK(L1M1,IATOM,LM,JATOMK,IKAP)=
     &STRK(L1M1,IATOM,LM,JATOMK,IKAP)+
     &  U(IWIG12,IGK)*SSK(L1M2,IP(IATOM,IRK))*PHSK
	STRQ(L1M1,IATOM,LM,JATOMQ,IKAP)=
     &STRQ(L1M1,IATOM,LM,JATOMQ,IKAP)+
     &  U(IWIG12,IGQ)*SSQ(L1M2,IP(IATOM,IRQ))*PHSQ
	IF(LOG)
     &STDK(L1M1,IATOM,LM,JATOMK,IKAP)=
     &STDK(L1M1,IATOM,LM,JATOMK,IKAP)+
     &  U(IWIG12,IGK)*SDK(L1M2,IP(IATOM,IRK))*PHSK
	IF(LOG)
     &STDQ(L1M1,IATOM,LM,JATOMQ,IKAP)=
     &STDQ(L1M1,IATOM,LM,JATOMQ,IKAP)+
     &  U(IWIG12,IGQ)*SDQ(L1M2,IP(IATOM,IRQ))*PHSQ
  30  CONTINUE                                  !!! over m2
  40  CONTINUE                                  !!! over m1
  50  CONTINUE                                  !!! over l1
  60  CONTINUE                                  !!! over iatom
  70  CONTINUE                                  !!! over m
  80  CONTINUE                                  !!! over l
  90  CONTINUE                                  !!! over jatom
C **** ROTATE STRUCTURE CONSTANTS WITH THE RIGHT INDEX ****
	DO 190 IATOM=1,NATOM                      !!! over iatom
	ISORT=IS(IATOM)
	DO 180 L1=0,ILST(ISORT)+1                 !!! over l1
	LOG=.FALSE.
	IF(L1.LE.ILSB(ISORT)+1)LOG=.TRUE.
	DO 170 M1=-L1,L1                          !!! over m1
	L1M1=L1*(L1+1)+M1+1
	DO 130 JATOM=1,NATOM                      !!! over jatom
	JSORT=IS(JATOM)
	JATOMK=IP(JATOM,IRK)
	JATOMQ=IP(JATOM,IRQ)
	SK=PNT(1,IPNTK,IPAN)*RDC(1,JATOM,IRK)+
     &   PNT(2,IPNTK,IPAN)*RDC(2,JATOM,IRK)+
     &   PNT(3,IPNTK,IPAN)*RDC(3,JATOM,IRK)
	SQ=PNT(1,IPNTQ,IPAN)*RDC(1,JATOM,IRQ)+
     &   PNT(2,IPNTQ,IPAN)*RDC(2,JATOM,IRQ)+
     &   PNT(3,IPNTQ,IPAN)*RDC(3,JATOM,IRQ)
	PHSK=EXP(2.D0*PI*SK*(0.D0,-1.D0))
	PHSQ=EXP(2.D0*PI*SQ*(0.D0,-1.D0))
	DO 120 L=0,ILSB(JSORT)                    !!! over l 
	LL=L*(2*L-1)*(2*L+1)/3
	DO 110 M=-L,L                             !!! over m
	LM=L*(L+1)+M+1
	SSK(LM,JATOM)=(0.D0,0.D0)
	SDK(LM,JATOM)=(0.D0,0.D0)
	SSQ(LM,JATOM)=(0.D0,0.D0)
	SDQ(LM,JATOM)=(0.D0,0.D0)
	DO 100 M2=-L,L                            !!! over m2
	LM2=L*(L+1)+M2+1
	IWIG02=LL+(2*L+1)*(L+M2)+L+M+1
	SSK(LM,JATOM)=SSK(LM,JATOM)+STRK(L1M1,IATOM,LM2,JATOMK,IKAP)*
     &  CONJG(U(IWIG02,IGK))*PHSK
	SSQ(LM,JATOM)=SSQ(LM,JATOM)+STRQ(L1M1,IATOM,LM2,JATOMQ,IKAP)*
     &  CONJG(U(IWIG02,IGQ))*PHSQ
	IF(LOG)SDK(LM,JATOM)=SDK(LM,JATOM)+
     &  STDK(L1M1,IATOM,LM2,JATOMK,IKAP)*
     &  CONJG(U(IWIG02,IGK))*PHSK
	IF(LOG)SDQ(LM,JATOM)=SDQ(LM,JATOM)+
     &  STDQ(L1M1,IATOM,LM2,JATOMQ,IKAP)*
     &  CONJG(U(IWIG02,IGQ))*PHSQ
 100  CONTINUE                                  !!! over m2
 110  CONTINUE                                  !!! over m
 120  CONTINUE                                  !!! over l
 130  CONTINUE                                  !!! over jatom
	DO 160 JATOM=1,NATOM                      !!! over jatom
	JSORT=IS(JATOM)
	DO 150 L=0,ILSB(JSORT)                    !!! over l
	DO 140 M=-L,L                             !!! over m
	LM=L*(L+1)+M+1
	STRK(L1M1,IATOM,LM,JATOM,IKAP)=SSK(LM,JATOM)
	STRQ(L1M1,IATOM,LM,JATOM,IKAP)=SSQ(LM,JATOM)
	IF(LOG)STDK(L1M1,IATOM,LM,JATOM,IKAP)=SDK(LM,JATOM)
	IF(LOG)STDQ(L1M1,IATOM,LM,JATOM,IKAP)=SDQ(LM,JATOM)
 140  CONTINUE                                  !!! over m
 150  CONTINUE                                  !!! over l
 160  CONTINUE                                  !!! over jatom
 170  CONTINUE                                  !!! over m1
 180  CONTINUE                                  !!! over l1
 190  CONTINUE                                  !!! over iatom
 200  CONTINUE                                  !!! over energies
C  Memory deallocations
      DEALLOCATE(SSK,SDK,SSQ,SDQ)
	END



	SUBROUTINE DEL_DSTRGNT(IPNTK,IPNTQ,IPAN)
*******************************************************
*   Restore structre constants from Sigma.            *
*   Last revision: 30.11.92, S.S.                     *
*******************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
	USE COM_KAPPAR,  ONLY : NPAN,NKAP,EK,EKAP                          !!! from readini
	USE COM_SPHERE,  ONLY : SWZ,SMT                                    !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM              !!! from readini
	USE COM_NBANDS,  ONLY : NBNDF,NBNDE,NBNDT                          !!! from readini
	USE COM_LATPAR,  ONLY : PAR                                        !!! from readini
	USE COM_DSTRCON, ONLY : SSRK=>STRK,SSDK=>STDK
     &                       ,SSRQ=>STRQ,SSDQ=>STDQ                      !!! from delgnt
	USE COM_VECGEN,  ONLY : LIMDT                                      !!! from vecgen
	USE COM_LMSTRS,  ONLY : IDELP                                      !!! from vecgen
	USE COM_KMESH,   ONLY : NPNT                                       !!! from makettr
	USE COM_GAUNT,   ONLY : C,GGNT                                     !!! from makegnt
	USE COM_CHANNELS,ONLY : IUCON                                      !!! from channels
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: SIGMA(:)
	COMPLEX*16, ALLOCATABLE :: SIGMADOT(:)
	LOGICAL FIRST,LOG
	COMPLEX*16 KAPPA,KAPPADOT,KAP
	DATA PI/3.141592653589793D0/,FIRST/.TRUE./
C Memory allocations
	LTLMEM=(LMAXTMEM+1+LMAXBMEM+1)**2
	NDTMEM=NATOM*NATOM
      LDLMEM=(2*LMAXBMEM+2)**2
	ALLOCATE(SIGMA(LTLMEM))
	ALLOCATE(SIGMADOT(LDLMEM))
C  RESTORE FULL S AND S_DOT -MATRICES FOR THE POINT IPNTK
	NSHIFT=1+NKAP(IPAN)*LIMDT*(IPNTK-1)
	DO 10 JPAN=1,IPAN-1
	NSHIFT=NSHIFT+NPNT(IPAN)*NKAP(JPAN)*LIMDT
  10  CONTINUE
	DO 90 IKAP=1,NKAP(IPAN)                  !!! over diff.energies
	KAP=SQRT(EK(IKAP,IPAN))
	DO 80 JATOM=1,NATOM                      !!! over jatom
	JSORT=IS(JATOM)
	DO 70 IATOM=1,NATOM                      !!! over iatom
	ISORT=IS(IATOM)
	ITAU=IDELP(IATOM,JATOM)
	IREC=ITAU+LIMDT*(IKAP-1)+NSHIFT
	READ(IUCON,REC=IREC)LIM2,LID2,(SIGMA(LM),LM=1,LIM2),
     &  (SIGMADOT(LM),LM=1,LID2)
	DO 60 L =0,ILSB(IS(JATOM))               !!! over l
	DO 50 M =-L,L                            !!! over m
	LM=L*(L+1)+M+1
	DO 40 L1=0,1+ILST(ISORT)                 !!! over l1
	LOG=.FALSE.
	IF(L1.LE.1+ILSB(ISORT))LOG=.TRUE.
	SOS=(SMT(ISORT)/SWZ)**(L1+0.5D0)*(SMT(JSORT)/SWZ)**(L+0.5D0)
	QSOSQ=SQRT(SMT(ISORT)/2.D0/PAR)*SOS*SQRT(SMT(JSORT)/2.D0/PAR)
	SQSOSQS=SWZ/PAR*QSOSQ*SWZ/PAR
	DO 30 M1=-L1,L1                          !!! over m1
	L1M1=L1*(L1+1)+M1+1
	SSRK(L1M1,IATOM,LM,JATOM,IKAP)=(0.D0,0.D0)
	IF(LOG)SSDK(L1M1,IATOM,LM,JATOM,IKAP)=(0.D0,0.D0)
	DO 20 L2=ABS(L-L1),L+L1,2      !!! over l2
	LL2=L2/2
	M2=M1-M
	L2M2=L2*(L2+1)+M2+1
	IF(ABS(M2).LE.L2)THEN          !!! over m2
	KAPPA=(1.D0,0.D0)              !!! energies are in units 1/a^2)
	IF(L+L1-L2.NE.0)KAPPA=(SWZ/PAR*KAP)**(L+L1-L2)
	KAPPADOT=(0.D0,0.D0)
	IF(L+L1-L2.NE.0.AND.ABS(EK(IKAP,IPAN)).NE.0.D0)THEN
	KAPPADOT=(L+L1-L2)*0.5D0*(SWZ/PAR*KAP)**(L+L1-L2-2)
	ELSEIF(L+L1-L2.EQ.2.AND.ABS(EK(IKAP,IPAN)).EQ.0.D0)THEN
	KAPPADOT=(1.D0,0.D0)
	ENDIF
	SSRK(L1M1,IATOM,LM,JATOM,IKAP)=SSRK(L1M1,IATOM,LM,JATOM,IKAP)+
     &C(LL2,L1M1,LM)*GGNT(LL2,L1,L)*SIGMA(L2M2)*QSOSQ*
     &KAPPA
	IF(LOG)SSDK(L1M1,IATOM,LM,JATOM,IKAP)=
     &SSDK(L1M1,IATOM,LM,JATOM,IKAP)+
     &C(LL2,L1M1,LM)*GGNT(LL2,L1,L)*SIGMADOT(L2M2)*
     &SQSOSQS*KAPPA+C(LL2,L1M1,LM)*GGNT(LL2,L1,L)*
     &SIGMA(L2M2)*SQSOSQS*KAPPADOT
	ENDIF                          !!! over m2
  20  CONTINUE                       !!! over l2
  30  CONTINUE                       !!! over m1
  40  CONTINUE                       !!! over l1
  50  CONTINUE                       !!! over m
  60  CONTINUE                       !!! over l
  70  CONTINUE                       !!! over iatom
  80  CONTINUE                       !!! over jatom
  90  CONTINUE                       !!! over diff.energies
C  RESTORE FULL S AND S_DOT -MATRICES FOR THE POINT IPNTQ
	NSHIFT=1+NKAP(IPAN)*LIMDT*(IPNTQ-1)
	DO 110 JPAN=1,IPAN-1
	NSHIFT=NSHIFT+NPNT(IPAN)*NKAP(JPAN)*LIMDT
 110  CONTINUE
	DO 190 IKAP=1,NKAP(IPAN)                  !!! over diff.energies
	KAP=SQRT(EK(IKAP,IPAN))
	DO 180 JATOM=1,NATOM                      !!! over jatom
	JSORT=IS(JATOM)
	DO 170 IATOM=1,NATOM                      !!! over iatom
	ISORT=IS(IATOM)
	ITAU=IDELP(IATOM,JATOM)
	IREC=ITAU+LIMDT*(IKAP-1)+NSHIFT
	READ(IUCON,REC=IREC)LIM2,LID2,(SIGMA(LM),LM=1,LIM2),
     &(SIGMADOT(LM),LM=1,LID2)
	DO 160 L =0,ILSB(IS(JATOM))               !!! over l
	DO 150 M =-L,L                            !!! over m
	LM=L*(L+1)+M+1
	DO 140 L1=0,1+ILST(ISORT)                 !!! over l1
	LOG=.FALSE.
	IF(L1.LE.1+ILSB(ISORT))LOG=.TRUE.
	SOS=(SMT(ISORT)/SWZ)**(L1+0.5D0)*(SMT(JSORT)/SWZ)**(L+0.5D0)
	QSOSQ=SQRT(SMT(ISORT)/2.D0/PAR)*SOS*SQRT(SMT(JSORT)/2.D0/PAR)
	SQSOSQS=SWZ/PAR*QSOSQ*SWZ/PAR
	DO 130 M1=-L1,L1                          !!! over m1
	L1M1=L1*(L1+1)+M1+1
	SSRQ(L1M1,IATOM,LM,JATOM,IKAP)=(0.D0,0.D0)
	IF(LOG)SSDQ(L1M1,IATOM,LM,JATOM,IKAP)=(0.D0,0.D0)
	DO 120 L2=ABS(L-L1),L+L1,2      !!! over l2
	LL2=L2/2
	M2=M1-M
	L2M2=L2*(L2+1)+M2+1
	IF(ABS(M2).LE.L2)THEN          !!! over m2
	KAPPA=(1.D0,0.D0)              !!! energies are in units 1/a^2)
	IF(L+L1-L2.NE.0)KAPPA=(SWZ/PAR*KAP)**(L+L1-L2)
	KAPPADOT=(0.D0,0.D0)
	IF(L+L1-L2.NE.0.AND.ABS(EK(IKAP,IPAN)).NE.0.D0)THEN
	KAPPADOT=(L+L1-L2)*0.5D0*(SWZ/PAR*KAP)**(L+L1-L2-2)
	ELSEIF(L+L1-L2.EQ.2.AND.ABS(EK(IKAP,IPAN)).EQ.0.D0)THEN
	KAPPADOT=(1.D0,0.D0)
	ENDIF
	SSRQ(L1M1,IATOM,LM,JATOM,IKAP)=SSRQ(L1M1,IATOM,LM,JATOM,IKAP)+
     &C(LL2,L1M1,LM)*GGNT(LL2,L1,L)*SIGMA(L2M2)*QSOSQ*
     &KAPPA
	IF(LOG)SSDQ(L1M1,IATOM,LM,JATOM,IKAP)=
     &SSDQ(L1M1,IATOM,LM,JATOM,IKAP)+
     &C(LL2,L1M1,LM)*GGNT(LL2,L1,L)*SIGMADOT(L2M2)*
     &SQSOSQS*KAPPA+C(LL2,L1M1,LM)*GGNT(LL2,L1,L)*
     &SIGMA(L2M2)*SQSOSQS*KAPPADOT
	ENDIF                          !!! over m2
 120  CONTINUE                       !!! over l2
 130  CONTINUE                       !!! over m1
 140  CONTINUE                       !!! over l1
 150  CONTINUE                       !!! over m
 160  CONTINUE                       !!! over l
 170  CONTINUE                       !!! over iatom
 180  CONTINUE                       !!! over jatom
 190  CONTINUE                       !!! over diff.energies
	DEALLOCATE(SIGMA,SIGMADOT)
	END
