	SUBROUTINE DEL_DSHUBPAR(MY,INUC,IPAN,IQPNT)
***************************************************************
*   Calculate potential parameter variation of the HUB-       *
*   contribution to the hamiltonian matrix.                   *
***************************************************************
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_LRTCOM,  ONLY : LDLF                                       !!! from readlrt
	USE COM_KAPPAR,  ONLY : NPAN,NKAP,EK,EKAP                          !!! from readini
	USE COM_PANPAR,  ONLY : LTPAN,LSPAN,IATS,ISTS                      !!! from readini
	USE COM_SYMMLM,  ONLY : SYM,LMSYM                                  !!! from makesym
      USE COM_HUBCOM,  ONLY : VHUB                                       !!! from hubpot
      USE COM_SUMPAR,  ONLY : PHH,PJH,PHJ,PJJ                            !!! from ovrpar
	USE COM_DOVRPAR, ONLY : DELOHH,DELOJH,DELOHJ,DELOJJ                !!! for delmat 
	USE COM_DHAMPAR, ONLY : DELHHH,DELHJH,DELHHJ,DELHJJ                !!! from intpar
	USE COM_SPHERE,  ONLY : SWZ,SMT                                    !!! from readini
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
      USE COM_DELHUB,  ONLY : DELDHUB,DELVHUB                            !!! from plzfiles
      USE COM_LMTINP,  ONLY : ICHUB                                      !!! from init
	USE COM_PHNCHN  ,ONLY : IUDMT                                      !!! from channels
	USE COM_MASHDEP, ONLY : NVAL                                       !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	LOGICAL LOG1,LOG,EXIST
	DATA PI/3.141592653589793D0/
C  *** CALCULATE VARIATION OF THE MATRIX ELEMENTS ***
	IF(ICHUB.EQ.0)RETURN
	IF(IPAN.NE.1)RETURN
C  READ CHANGE IN POTENTIAL PARAMETERS
      DO 5000 IORBS=1,NORBS
      DO 4000 IUPDN=1,NSPIN
      CALL NMTFILES(MY,INUC,IPAN,IUPDN,IORBS,IUDMT,'R')
	DO 3000 IATOM=1,NATOM          !!! over atoms
	ISORT=IS(IATOM)
	DO 2000 IKAP1=1,NKAP(IPAN)     !!! over ikap1
	DO 1000 IKAP=1,NKAP(IPAN)      !!! over ikap
C  CALCULATE NMT-POTENTIAL PARAMETER VARIATIONS
	DO L1=0,ILSB(ISORT)            !!! over l1
	LOG1=.FALSE.
	IF(LTPAN(L1,IATOM,IKAP1,IPAN))LOG1=.TRUE.
	DO M1=-L1,L1                   !!! over m1
	L1M1=L1*(L1+1)+M1+1
	DO L=0,ILSB(ISORT)             !!! over l
	LOG=.FALSE.
	IF(LTPAN(L,IATOM,IKAP,IPAN))LOG=.TRUE.
	DO M=-L,L                      !!! over m
	LM=L*(L+1)+M+1
      IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M1+1 !!! (l,m1 m)
	IF(L1M1.EQ.LM)THEN             !!! add diagonal HMT-parameters
	IF(LOG1.AND.LOG)
     &DELHHH(LM,LM,IATOM,IKAP1,IKAP)=
     &DELHHH(LM,LM,IATOM,IKAP1,IKAP)+
     &DELOHH(IKAP1,IKAP,L,IATOM,IUPDN,IORBS)*
     &VHUB(IU,IATOM,IUPDN,IORBS)+
     &PHH(IKAP1,IKAP,L,ISORT,IPAN,IUPDN,IORBS)*
     &DELVHUB(IU,IATOM,IUPDN,IORBS)
	IF(LOG)
     &DELHJH(LM,LM,IATOM,IKAP1,IKAP)=
     &DELHJH(LM,LM,IATOM,IKAP1,IKAP)+
     &DELOJH(IKAP1,IKAP,L,IATOM,IUPDN,IORBS)*
     &VHUB(IU,IATOM,IUPDN,IORBS)+
     &PJH(IKAP1,IKAP,L,ISORT,IPAN,IUPDN,IORBS)*
     &DELVHUB(IU,IATOM,IUPDN,IORBS)
	IF(LOG1)
     &DELHHJ(LM,LM,IATOM,IKAP1,IKAP)=
     &DELHHJ(LM,LM,IATOM,IKAP1,IKAP)+
     &DELOHJ(IKAP1,IKAP,L,IATOM,IUPDN,IORBS)*
     &VHUB(IU,IATOM,IUPDN,IORBS)+
     &PHJ(IKAP1,IKAP,L,ISORT,IPAN,IUPDN,IORBS)*
     &DELVHUB(IU,IATOM,IUPDN,IORBS)
	DELHJJ(LM,LM,IATOM,IKAP1,IKAP)=
     &DELHJJ(LM,LM,IATOM,IKAP1,IKAP)+
     &DELOJJ(IKAP1,IKAP,L,IATOM,IUPDN,IORBS)*
     &VHUB(IU,IATOM,IUPDN,IORBS)+
     &PJJ(IKAP1,IKAP,L,ISORT,IPAN,IUPDN,IORBS)*
     &DELVHUB(IU,IATOM,IUPDN,IORBS)
	ENDIF
      ENDDO                          !!! over m
      ENDDO                          !!! over l
      ENDDO                          !!! over m1
      ENDDO                          !!! over l1
1000  CONTINUE                       !!! over ikap
2000  CONTINUE                       !!! over ikap1
3000  CONTINUE                       !!! over atoms
	CALL NMTFILES(MY,INUC,IPAN,IUPDN,IORBS,IUDMT,'W')
4000  CONTINUE                       !!! over iupdn
5000  CONTINUE                       !!! over iorbs
	END