	SUBROUTINE DEL_DINLMAT(MY,INUC,IPNT,ISGQ,IPAN,IQPNT)
***********************************************************
*  Calculates pseudopotential contribution to the         *
*  change in the hamiltonian and overlap matrix using     *
*  fourier transform.                                     * 
***********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_LATPAR,  ONLY : PAR,ORTH,OMEGAC                            !!! from readini
	USE COM_LATTICE, ONLY : TAU                                        !!! from readstr
	USE COM_PANPAR,  ONLY : LTPAN,LSPAN,IATS,ISTS                      !!! from readini
	USE COM_KAPPAR,  ONLY : NPAN,NKAP,EK,EKAP                          !!! from readini
	USE COM_PLWMESH, ONLY : NPLW,GPLW                                  !!! from makeplw
	USE COM_NBANDS,  ONLY : NBNDF,NBNDE,NBNDT,NBNDH                    !!! from readini
	USE COM_DPSIVEC, ONLY : PSIK,PSIQ,DPSK,DPSQ,PNTK,PNTQ              !!! from d2psivec
	USE COM_DELHAM,  ONLY : DHMATT,DOMATT,DHMATR,DOMATR,DVINTR         !!! from dintmat
	USE COM_INDORB,  ONLY : INDLMT                                     !!! from readini
	USE COM_TEILORG, ONLY : KEYT,BZM,GOPT,MBAS                         !!! from makeplw
	USE COM_ETAPAR,  ONLY : ETA,CUT,LBAS,NBAS                          !!! from makeplw
	USE COM_MASHDEP, ONLY : NVAL                                       !!! from setup
      USE COM_LMTOUT,  ONLY : SCNFILE                                    !!! from phn_storage
	USE COM_CHANNELS,ONLY : IUPIN                                      !!! from channels
	USE COM_PHNCHN  ,ONLY : IUDIN                                      !!! from channels
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: XFUN0(:,:,:)
	COMPLEX*16, ALLOCATABLE :: XFUNQ(:,:,:)
	COMPLEX*16, ALLOCATABLE :: VINT0Q(:,:)
	COMPLEX*16, ALLOCATABLE :: TPSK(:,:)
	COMPLEX*16, ALLOCATABLE :: TPSQ(:,:)
	COMPLEX*16 GMY,GPY,RMY,RPY,DELVR,DELVT
	DATA PI/3.141592653589793D0/
	IF(KEYT.EQ.0)RETURN
C Memory allocations
	ALLOCATE(XFUN0((NBNDT(IPAN)+NBNDH(IPAN))*NSPINMEM,
     &                0:MBASMEM,NSPINMEM))
	ALLOCATE(XFUNQ((NBNDT(IPAN)+NBNDH(IPAN))*NSPINMEM,
     &                0:MBASMEM,NSPINMEM))
	ALLOCATE(VINT0Q((NBNDT(IPAN)+NBNDH(IPAN))*NSPINMEM,
     &                (NBNDT(IPAN)+NBNDH(IPAN))*NSPINMEM))
	ALLOCATE(TPSK(0:NBASMEM,NSPINMEM))
	ALLOCATE(TPSQ(0:NBASMEM,NSPINMEM))
	XK=PNTK(1)
	YK=PNTK(2)
	ZK=PNTK(3)
      IF(MODE.NE.5)IBNDMIN=1
      IF(MODE.NE.5)IBNDMAX=NBNDT(IPAN)+NBNDH(IPAN)
      IF(MODE.EQ.5)IBNDMIN=NBNDE(IPAN)
      IF(MODE.EQ.5)IBNDMAX=NBNDF(IPAN)
C  **** STEP 1: SOFT CHANGE IN THE INTERSTITIAL POTENTIAL PARAMETERS
C  READ POTENTIAL PARAMETERS
      NRECL=NVAL*(NBNDT(IPAN)*(MIN(NBAS,MBAS)+1)+NBNDT(IPAN)**2)
      OPEN(UNIT=IUDIN,FILE=SCNFILE(MY,INUC,IUDIN),STATUS='OLD',
     &  ACCESS='DIRECT',FORM='UNFORMATTED',RECL=NRECL)
      DO IORBS=1,NORBS                  !!! over iorbs
      DO IUPDN=1,NSPIN                  !!! over ispin
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
	IREC=1+2*(IUPDN-1)+2*NSPIN*(IORBS-1)
	READ(IUDIN,REC=IREC)
     &((VINT0Q(IPAR1+NBNDT(IPAN)*(ISPIN1-1),
     &IPAR+NBNDT(IPAN)*(ISPIN-1)),IPAR1=1,
     &NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),
     &((XFUN0(IPAR1+NBNDT(IPAN)*(ISPIN1-1),IBAS,ISPIN),
     &IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
	IREC=2+2*(IUPDN-1)+2*NSPIN*(IORBS-1)
	READ(IUDIN,REC=IREC)
     &((VINT0Q(IPAR1+NBNDT(IPAN)*(ISPIN1-1),
     &IPAR+NBNDT(IPAN)*(ISPIN-1)),IPAR1=1,
     &NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),
     &((XFUNQ(IPAR1+NBNDT(IPAN)*(ISPIN1-1),IBAS,ISPIN),
     &IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
      ENDDO
	ENDDO
	CLOSE(IUDIN)
C  TRASFERE TO BAND REPRESENTATION
	CALL DEL_TRVINT(PNTK,      0,0,MY,INUC,IPAN,VINT0Q)
	CALL DEL_TRXFUN(PNTK,'0N*0N',0,MY,INUC,IPAN,XFUN0,XFUNQ)
	CALL DEL_TRXFUN(PNTK,'QN*QC',0,MY,INUC,IPAN,XFUN0,XFUNQ)
C  COMPUTE CONTRIBUTION
      DO IBNDS1=1,NSPIN
	DO IBNDT1=IBNDMIN,IBNDMAX
	IBAND1=IBNDS1+NSPIN*(IBNDT1-1)
      DO IBNDS=1,NSPIN
	IF(NORBS.EQ.1.AND.IBNDS1.NE.IBNDS)CYCLE
	DO IBNDT=IBNDMIN,IBNDMAX
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	DELVT=VINT0Q(IBAND1,IBAND)
	DO JSPIN=1,NSPIN
	IF(NORBS.EQ.1.AND.JSPIN.NE.IBNDS1)CYCLE
	IF(NORBS.EQ.1.AND.JSPIN.NE.IBNDS )CYCLE
	DO IBAS=0,MIN(NBAS,MBAS)
	DELVT=DELVT+
     &DCONJG(PSIQ(IBAS,JSPIN,IBAND1))*XFUN0(IBAND,IBAS,JSPIN)+
     &XFUNQ(IBAND1,IBAS,JSPIN)*PSIK(IBAS,JSPIN,IBAND)
	ENDDO
	ENDDO
	DHMATT(IBAND1,IBAND,MY,INUC)=
     &DHMATT(IBAND1,IBAND,MY,INUC)+DELVT
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	IF(MODE.EQ.2)GOTO 1000
C  **** STEP 2: INTERSTITIAL POTENTIAL PARAMETERS FOR ZERO VECTOR
C  READ POTENTIAL PARAMETERS
      DO IORBS=1,NORBS                  !!! over iorbs
      DO IUPDN=1,NSPIN                  !!! over ispin
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
	IREC=1+2*(IUPDN-1)+2*NSPIN*(IORBS-1)
	READ(IUPIN,REC=IREC)
     &((VINT0Q(IPAR1+NBNDT(IPAN)*(ISPIN1-1),
     &IPAR+NBNDT(IPAN)*(ISPIN-1)),IPAR1=1,
     &NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),
     &((XFUN0(IPAR1+NBNDT(IPAN)*(ISPIN1-1),IBAS,ISPIN),
     &IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
      ENDDO
      ENDDO
C  TRASFERE TO BAND REPRESENTATION
	CALL DEL_TRVINT(PNTK,      1,0,MY,INUC,IPAN,VINT0Q)
	CALL DEL_TRXFUN(PNTK,'0C*0N',0,MY,INUC,IPAN,XFUN0,XFUNQ)
C  COMPUTE CONTRIBUTION
	IF(-MY.EQ.-1)RMY=+1.D0/SQRT(2.D0)*(XK-(0.D0,1.D0)*YK)
	IF(-MY.EQ.+1)RMY=-1.D0/SQRT(2.D0)*(XK+(0.D0,1.D0)*YK)
	IF(-MY.EQ. 0)RMY=ZK
	RMY=DCONJG(RMY*(-1)**MY*(0.D0,-1.D0)*2.D0*PI/PAR)
      DO IBNDS1=1,NSPIN
	DO IBNDT1=IBNDMIN,IBNDMAX
	IBAND1=IBNDS1+NSPIN*(IBNDT1-1)
	DO JSPIN=1,NSPIN
	DO IBAS=0,MIN(NBAS,MBAS)
	GX=PNTK(1)+GPLW(1,IBAS)
	GY=PNTK(2)+GPLW(2,IBAS)
	GZ=PNTK(3)+GPLW(3,IBAS)
	IF(-MY.EQ.-1)GMY=+1.D0/SQRT(2.D0)*(GX-(0.D0,1.D0)*GY)
	IF(-MY.EQ.+1)GMY=-1.D0/SQRT(2.D0)*(GX+(0.D0,1.D0)*GY)
	IF(-MY.EQ. 0)GMY=GZ
	TPSK(IBAS,JSPIN)=DCONJG(DPSK(IBAS,JSPIN,IBAND1)*GMY*
     &  (0.D0,1.D0)*2.D0*PI/PAR*(-1)**MY)
	ENDDO
	ENDDO
      DO IBNDS=1,NSPIN
	IF(NORBS.EQ.1.AND.IBNDS.NE.IBNDS1)CYCLE
	DO IBNDT=IBNDMIN,IBNDMAX
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	DELVR=VINT0Q(IBAND1,IBAND)*RMY
	DO JSPIN=1,NSPIN
	IF(NORBS.EQ.1.AND.JSPIN.NE.IBNDS1)CYCLE
	IF(NORBS.EQ.1.AND.JSPIN.NE.IBNDS )CYCLE
	DO IBAS=0,MIN(NBAS,MBAS)
	DELVR=DELVR+TPSK(IBAS,JSPIN)*XFUN0(IBAND,IBAS,JSPIN)
	ENDDO
	ENDDO
	DHMATT(IBAND1,IBAND,MY,INUC)=
     &DHMATT(IBAND1,IBAND,MY,INUC)+DELVR
	DVINTR(IBAND1,IBAND,MY,INUC)=
     &DVINTR(IBAND1,IBAND,MY,INUC)+DELVR
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C  **** STEP 3: INTERSTITIAL POTENTIAL PARAMETERS FOR VECTOR Q
C  READ POTENTIAL PARAMETERS
      DO IORBS=1,NORBS                  !!! over iorbs
      DO IUPDN=1,NSPIN                  !!! over ispin
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
	IREC=2+2*(IUPDN-1)+2*NSPIN*(IORBS-1)
	READ(IUPIN,REC=IREC)
     &((VINT0Q(IPAR1+NBNDT(IPAN)*(ISPIN1-1),
     &IPAR+NBNDT(IPAN)*(ISPIN-1)),IPAR1=1,
     &NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),
     &((XFUNQ(IPAR1+NBNDT(IPAN)*(ISPIN1-1),IBAS,ISPIN),
     &IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
      ENDDO
      ENDDO
C  TRASFERE TO BAND REPRESENTATION
	CALL DEL_TRVINT(PNTK,      0,1,MY,INUC,IPAN,VINT0Q)
	CALL DEL_TRXFUN(PNTK,'QC*QC',0,MY,INUC,IPAN,XFUN0,XFUNQ)
	IF(+MY.EQ.-1)RPY=+1.D0/SQRT(2.D0)*(XK-(0.D0,1.D0)*YK)
	IF(+MY.EQ.+1)RPY=-1.D0/SQRT(2.D0)*(XK+(0.D0,1.D0)*YK)
	IF(+MY.EQ. 0)RPY=ZK
	RPY=RPY*(0.D0,-1.D0)*2.D0*PI/PAR
C  COMPUTE CONTRIBUTION
      DO IBNDS=1,NSPIN
	DO IBNDT=IBNDMIN,IBNDMAX
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	DO JSPIN=1,NSPIN
	DO IBAS=0,MIN(NBAS,MBAS)
	GX=PNTQ(1)+GPLW(1,IBAS)
	GY=PNTQ(2)+GPLW(2,IBAS)
	GZ=PNTQ(3)+GPLW(3,IBAS)
	IF(MY.EQ.-1)GMY=+1.D0/SQRT(2.D0)*(GX-(0.D0,1.D0)*GY)
	IF(MY.EQ.+1)GMY=-1.D0/SQRT(2.D0)*(GX+(0.D0,1.D0)*GY)
	IF(MY.EQ. 0)GMY=GZ
	TPSQ(IBAS,JSPIN)=DPSQ(IBAS,JSPIN,IBAND)*GMY*(0.D0,1.D0)*
     &  2.D0*PI/PAR
	ENDDO
	ENDDO
      DO IBNDS1=1,NSPIN
	IF(NORBS.EQ.1.AND.IBNDS1.NE.IBNDS)CYCLE
	DO IBNDT1=IBNDMIN,IBNDMAX
	IBAND1=IBNDS1+NSPIN*(IBNDT1-1)
	DELVR=VINT0Q(IBAND1,IBAND)*RPY
	DO JSPIN=1,NSPIN
	IF(NORBS.EQ.1.AND.JSPIN.NE.IBNDS1)CYCLE
	IF(NORBS.EQ.1.AND.JSPIN.NE.IBNDS )CYCLE
	DO IBAS=0,MIN(NBAS,MBAS)
	DELVR=DELVR+XFUNQ(IBAND1,IBAS,JSPIN)*TPSQ(IBAS,JSPIN)
	ENDDO
	ENDDO
	DHMATT(IBAND1,IBAND,MY,INUC)=
     &DHMATT(IBAND1,IBAND,MY,INUC)+DELVR
	DVINTR(IBAND1,IBAND,MY,INUC)=
     &DVINTR(IBAND1,IBAND,MY,INUC)+DELVR
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C  **** STEP 4: RIGID CHANGE IN POTENTIAL PARAMETERS FOR ZERO VECTOR
C  READ POTENTIAL PARAMETERS
      DO IORBS=1,NORBS                  !!! over iorbs
      DO IUPDN=1,NSPIN                  !!! over ispin
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
	IREC=1+2*(IUPDN-1)+2*NSPIN*(IORBS-1)
	READ(IUPIN,REC=IREC)
     &((VINT0Q(IPAR1+NBNDT(IPAN)*(ISPIN1-1),
     &IPAR+NBNDT(IPAN)*(ISPIN-1)),IPAR1=1,
     &NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),
     &((XFUNQ(IPAR1+NBNDT(IPAN)*(ISPIN1-1),IBAS,ISPIN),
     &IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))!!! xfunq=xfun0
	IREC=1+2*(MY+1)+2*3*(IUPDN-1)+2*3*NSPIN*(IORBS-1)+2*NSPIN*NORBS
	READ(IUPIN,REC=IREC)
     &((VINT0Q(IPAR1+NBNDT(IPAN)*(ISPIN1-1),
     &IPAR+NBNDT(IPAN)*(ISPIN-1)),IPAR1=1,
     &NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),
     &((XFUN0(IPAR1+NBNDT(IPAN)*(ISPIN1-1),IBAS,ISPIN),
     &IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
      ENDDO
      ENDDO
C  TRASFERE TO BAND REPRESENTATION
	CALL DEL_TRVINT(PNTK,      1,0,MY,INUC,IPAN,VINT0Q)
	CALL DEL_TRXFUN(PNTK,'QN*QC',1,MY,INUC,IPAN,XFUN0,XFUNQ) !!!  xfun0
	CALL DEL_TRXFUN(PNTK,'0N*QC',1,MY,INUC,IPAN,XFUN0,XFUNQ) !!! rxfun0
C  COMPUTE CONTRIBUTION
	IF(-MY.EQ.-1)RMY=+1.D0/SQRT(2.D0)*(XK-(0.D0,1.D0)*YK)
	IF(-MY.EQ.+1)RMY=-1.D0/SQRT(2.D0)*(XK+(0.D0,1.D0)*YK)
	IF(-MY.EQ. 0)RMY=ZK
	RMY=DCONJG(RMY*(-1)**MY*(0.D0,-1.D0)*2.D0*PI/PAR)
      DO IBNDS1=1,NSPIN
	DO IBNDT1=IBNDMIN,IBNDMAX
	IBAND1=IBNDS1+NSPIN*(IBNDT1-1)
	DO JSPIN=1,NSPIN
	DO IBAS=0,MIN(NBAS,MBAS)
	TPSK(IBAS,JSPIN)=XFUNQ(IBAND1,IBAS,JSPIN)*RMY+
     &                 XFUN0(IBAND1,IBAS,JSPIN)
	ENDDO
	ENDDO
      DO IBNDS=1,NSPIN
	IF(NORBS.EQ.1.AND.IBNDS.NE.IBNDS1)CYCLE
	DO IBNDT=IBNDMIN,IBNDMAX
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	DELVR=VINT0Q(IBAND1,IBAND)
	DO JSPIN=1,NSPIN
	IF(NORBS.EQ.1.AND.JSPIN.NE.IBNDS1)CYCLE
	IF(NORBS.EQ.1.AND.JSPIN.NE.IBNDS)CYCLE
	DO IBAS=0,MIN(NBAS,MBAS)
	DELVR=DELVR+TPSK(IBAS,JSPIN)*PSIK(IBAS,JSPIN,IBAND)
	ENDDO
	ENDDO
	DHMATT(IBAND1,IBAND,MY,INUC)=
     &DHMATT(IBAND1,IBAND,MY,INUC)+DELVR
	DVINTR(IBAND1,IBAND,MY,INUC)=
     &DVINTR(IBAND1,IBAND,MY,INUC)+DELVR
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C  **** STEP 5: RIGID CHANGE IN POTENTIAL PARAMETERS FOR VECTOR Q
C  READ POTENTIAL PARAMETERS
      DO IORBS=1,NORBS                  !!! over iorbs
      DO IUPDN=1,NSPIN                  !!! over ispin
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
	IREC=2+2*(IUPDN-1)+2*NSPIN*(IORBS-1)
	READ(IUPIN,REC=IREC)
     &((VINT0Q(IPAR1+NBNDT(IPAN)*(ISPIN1-1),
     &IPAR+NBNDT(IPAN)*(ISPIN-1)),IPAR1=1,
     &NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),
     &((XFUN0(IPAR1+NBNDT(IPAN)*(ISPIN1-1),IBAS,ISPIN),
     &IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))!!! xfunq=xfun0
	IREC=2+2*(MY+1)+2*3*(IUPDN-1)+2*3*NSPIN*(IORBS-1)+2*NSPIN*NORBS
	READ(IUPIN,REC=IREC)
     &((VINT0Q(IPAR1+NBNDT(IPAN)*(ISPIN1-1),
     &IPAR+NBNDT(IPAN)*(ISPIN-1)),IPAR1=1,
     &NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),
     &((XFUNQ(IPAR1+NBNDT(IPAN)*(ISPIN1-1),IBAS,ISPIN),
     &IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))!!! xfunq=xfun0
      ENDDO
      ENDDO
C  TRASFERE TO BAND REPRESENTATION
	CALL DEL_TRVINT(PNTK,      0,1,MY,INUC,IPAN,VINT0Q)
	CALL DEL_TRXFUN(PNTK,'0N*0N',1,MY,INUC,IPAN,XFUN0,XFUNQ) !!! xfunq
	CALL DEL_TRXFUN(PNTK,'QN*0N',1,MY,INUC,IPAN,XFUN0,XFUNQ) !!! rxfunq
C  COMPUTE CONTRIBUTION
	IF(+MY.EQ.-1)RPY=+1.D0/SQRT(2.D0)*(XK-(0.D0,1.D0)*YK)
	IF(+MY.EQ.+1)RPY=-1.D0/SQRT(2.D0)*(XK+(0.D0,1.D0)*YK)
	IF(+MY.EQ. 0)RPY=ZK
	RPY=RPY*(0.D0,-1.D0)*2.D0*PI/PAR
      DO IBNDS=1,NSPIN
	DO IBNDT=IBNDMIN,IBNDMAX
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	DO JSPIN=1,NSPIN
	DO IBAS=0,MIN(NBAS,MBAS)
	TPSK(IBAS,JSPIN)=XFUN0(IBAND,IBAS,JSPIN)*RPY+
     &                 XFUNQ(IBAND,IBAS,JSPIN)
	ENDDO
	ENDDO
      DO IBNDS1=1,NSPIN
	IF(NORBS.EQ.1.AND.IBNDS.NE.IBNDS1)CYCLE
	DO IBNDT1=IBNDMIN,IBNDMAX
	IBAND1=IBNDS1+NSPIN*(IBNDT1-1)
	DELVR=VINT0Q(IBAND1,IBAND)
	DO JSPIN=1,NSPIN
	IF(NORBS.EQ.1.AND.JSPIN.NE.IBNDS1)CYCLE
	IF(NORBS.EQ.1.AND.JSPIN.NE.IBNDS )CYCLE
	DO IBAS=0,MIN(NBAS,MBAS)
	DELVR=DELVR+DCONJG(PSIQ(IBAS,JSPIN,IBAND1))*TPSK(IBAS,JSPIN)
	ENDDO
	ENDDO
	DHMATT(IBAND1,IBAND,MY,INUC)=
     &DHMATT(IBAND1,IBAND,MY,INUC)+DELVR
	DVINTR(IBAND1,IBAND,MY,INUC)=
     &DVINTR(IBAND1,IBAND,MY,INUC)+DELVR
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C Memory deallocations
 1000 DEALLOCATE(XFUN0,XFUNQ,VINT0Q,TPSK,TPSQ)
	END





	SUBROUTINE DEL_TRVINT(PNTK,IAVD1,IAVD,MY,INUC,IPAN,VINT0Q)
***********************************************************
*  Transfers from lm-reperesentation to the band one.     *
***********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_LATPAR,  ONLY : PAR,ORTH,OMEGAC                            !!! from readini
	USE COM_KAPPAR,  ONLY : NPAN,NKAP,EK,EKAP                          !!! from readini
	USE COM_PANPAR,  ONLY : LTPAN,LSPAN,IATS,ISTS                      !!! from readini
	USE COM_NBANDS,  ONLY : NBNDF,NBNDE,NBNDT,NBNDH                    !!! from readini
	USE COM_LATTICE, ONLY : TAU                                        !!! from readstr
	USE COM_PLWMESH, ONLY : NPLW,GPLW                                  !!! from makeplw
	USE COM_ETAPAR,  ONLY : ETA,CUT,LBAS,NBAS                          !!! from makeplw
	USE COM_PSIVEC,  ONLY : APHK,APJK,APHQ,APJQ                        !!! from lmtvec
	USE COM_INDORB,  ONLY : INDLMT                                     !!! from readini
	USE COM_MASHDEP, ONLY : NVAL                                       !!! from setup
	USE COM_TEILORG, ONLY : KEYT,BZM,GOPT,MBAS                         !!! from makeplw
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: SUM(:)
	COMPLEX*16 VINT0Q((NBNDT(IPAN)+NBNDH(IPAN))*NSPINMEM,
     &                  (NBNDT(IPAN)+NBNDH(IPAN))*NSPINMEM)
     &    ,EXPK1,EXPK
	DIMENSION PNTK(3)
	DATA PI/3.141592653589793D0/
C Memory allocations
	ALLOCATE(SUM((NBNDT(IPAN)+NBNDH(IPAN))*NSPINMEM))
      IF(MODE.NE.5)IBNDMIN=1
      IF(MODE.NE.5)IBNDMAX=NBNDT(IPAN)+NBNDH(IPAN)
      IF(MODE.EQ.5)IBNDMIN=NBNDE(IPAN)
      IF(MODE.EQ.5)IBNDMAX=NBNDF(IPAN)
C  DO OVER LEFT INDEX
      DO ISPIN1=1,NSPIN                 !!! over ispin1
	DO IATOM1=1,NATOM                 !!! over iatom1
	ISORT1=IS(IATOM1)
	DO IKAP1=1,NKAP(IPAN)             !!! over energy
	DO L1=0,ILSB(ISORT1)              !!! over l1
	DO M1=-L1,L1                      !!! over m1
	IF(.NOT.LTPAN(L1,IATOM1,IKAP1,IPAN))EXIT
	L1M1=L1*(L1+1)+M1+1
	IPAR1=INDLMT(L1M1,IATOM1,IKAP1,ISPIN1,IPAN)
C  TRANSFERE RIGHT INDEX
      DO IBNDS=1,NSPIN                  !!! over spin subbands
	DO IBNDT=IBNDMIN,IBNDMAX          !!! over bands
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	SUM(IBAND)=(0.D0,0.D0)
      IF(NORBS.EQ.1.AND.IBNDS.NE.ISPIN1)CYCLE
      DO ISPIN=1,NSPIN                  !!! over ispin
      IF(NORBS.EQ.1.AND.IBNDS.NE.ISPIN)CYCLE
	DO IATOM=1,NATOM                  !!! over iatom
	ISORT=IS(IATOM)
	SCP=PNTK(1)*TAU(1,IATOM)+
     &    PNTK(2)*TAU(2,IATOM)+
     &    PNTK(3)*TAU(3,IATOM)
	EXPK=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	DO IKAP=1,NKAP(IPAN)              !!! over energy
	IF(IATOM.NE.INUC.AND.IAVD.EQ.1)EXIT
	DO L=0,ILSB(ISORT)                !!! over l
	DO M=-L,L                         !!! over m
	IF(.NOT.LTPAN(L,IATOM,IKAP,IPAN))EXIT
	LM=L*(L+1)+M+1
	IPAR=INDLMT(LM,IATOM,IKAP,ISPIN,IPAN)
	SUM(IBAND)=SUM(IBAND)+
     &  VINT0Q(IPAR1,IPAR)*EXPK*APHK(LM,IATOM,IKAP,ISPIN,IBAND)
	ENDDO                             !!! over m
	ENDDO                             !!! over l
	ENDDO                             !!! over energy
	ENDDO                             !!! over iatom
	ENDDO                             !!! over ispin
	ENDDO                             !!! over bands
	ENDDO                             !!! over spin subbands
      DO IBNDS=1,NSPIN                  !!! over spin subbands
	DO IBNDT=IBNDMIN,IBNDMAX          !!! over bands
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	VINT0Q(IPAR1,IBAND)=SUM(IBAND)
	ENDDO                             !!! over bands
	ENDDO                             !!! over spin subbands
	ENDDO                             !!! over m1
	ENDDO                             !!! over l1
	ENDDO                             !!! over energy
	ENDDO                             !!! over iatom1
	ENDDO                             !!! over ispin1
C  TRANSFERE LEFT INDEX
      DO IBNDS=1,NSPIN
	DO IBNDT =1,NBNDT(IPAN)+NBNDH(IPAN)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
      DO IBNDS1=1,NSPIN
	DO IBNDT1=1,NBNDT(IPAN)+NBNDH(IPAN)
	IBAND1=IBNDS1+NSPIN*(IBNDT1-1)
	SUM(IBAND1)=(0.D0,0.D0)
	DO ISPIN1=1,NSPIN                 !!! over ispin1
      IF(NORBS.EQ.1.AND.IBNDS1.NE.ISPIN1)CYCLE
      IF(NORBS.EQ.1.AND.IBNDS .NE.ISPIN1)CYCLE
	DO IATOM1=1,NATOM                 !!! over iatom1
	ISORT1=IS(IATOM1)
	SCP=PNTK(1)*TAU(1,IATOM1)+
     &    PNTK(2)*TAU(2,IATOM1)+
     &    PNTK(3)*TAU(3,IATOM1)
	EXPK1=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	DO IKAP1=1,NKAP(IPAN)             !!! over energy
	IF(IATOM1.NE.INUC.AND.IAVD1.EQ.1)EXIT
	DO L1=0,ILSB(ISORT1)              !!! over l1
	DO M1=-L1,L1                      !!! over m1
	IF(.NOT.LTPAN(L1,IATOM1,IKAP1,IPAN))EXIT
	L1M1=L1*(L1+1)+M1+1
	IPAR1=INDLMT(L1M1,IATOM1,IKAP1,ISPIN1,IPAN)
	SUM(IBAND1)=SUM(IBAND1)+VINT0Q(IPAR1,IBAND)*
     &DCONJG(APHQ(L1M1,IATOM1,IKAP1,ISPIN1,IBAND1)*EXPK1)
	ENDDO                             !!! over m1
	ENDDO                             !!! over l1
	ENDDO                             !!! over energy
	ENDDO                             !!! over iatom1
	ENDDO                             !!! over ispin1
	ENDDO                             !!! over bands
	ENDDO                             !!! over spin subbands
      DO IBNDS1=1,NSPIN
	DO IBNDT1=1,NBNDT(IPAN)+NBNDH(IPAN)
	IBAND1=IBNDS1+NSPIN*(IBNDT1-1)
	VINT0Q(IBAND1,IBAND)=SUM(IBAND1)
	ENDDO
	ENDDO
	ENDDO                             !!! over bands
	ENDDO                             !!! over spin subbands
C Memory deallocations
	DEALLOCATE(SUM)
	END




	SUBROUTINE DEL_TRXFUN(PNTK,TGO,IAVD,MY,INUC,IPAN,XFUN0,XFUNQ)
***********************************************************
*  Transfers from lm-reperesentation to the band one.     *
***********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
	USE COM_LATTICE, ONLY : TAU                                        !!! from readstr
	USE COM_LATPAR,  ONLY : PAR,ORTH,OMEGAC                            !!! from readini
	USE COM_KAPPAR,  ONLY : NPAN,NKAP,EK,EKAP                          !!! from readini
	USE COM_PANPAR,  ONLY : LTPAN,LSPAN,IATS,ISTS                      !!! from readini
	USE COM_PLWMESH, ONLY : NPLW,GPLW                                  !!! from makeplw
	USE COM_NBANDS,  ONLY : NBNDF,NBNDE,NBNDT,NBNDH                    !!! from readini
	USE COM_PSIVEC,  ONLY : APHK,APJK,APHQ,APJQ                        !!! from lmtvec
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_ETAPAR,  ONLY : ETA,CUT,LBAS,NBAS                          !!! from makeplw
	USE COM_INDORB,  ONLY : INDLMT                                     !!! from readini
	USE COM_MASHDEP, ONLY : NVAL                                       !!! from setup
	USE COM_TEILORG, ONLY : KEYT,BZM,GOPT,MBAS                         !!! from makeplw
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: SUM(:)
	COMPLEX*16 EXPK,
     &XFUN0((NBNDT(IPAN)+NBNDH(IPAN))*NSPINMEM,0:MBASMEM,NSPINMEM),
     &XFUNQ((NBNDT(IPAN)+NBNDH(IPAN))*NSPINMEM,0:MBASMEM,NSPINMEM)
	DIMENSION PNTK(3)
	CHARACTER TGO*5
	DATA PI/3.141592653589793D0/
C Memory allocations
	ALLOCATE(SUM((NBNDT(IPAN)+NBNDH(IPAN))*NSPINMEM))
      IF(MODE.NE.5)IBNDMIN=1
      IF(MODE.NE.5)IBNDMAX=NBNDT(IPAN)+NBNDH(IPAN)
      IF(MODE.EQ.5)IBNDMIN=NBNDE(IPAN)
      IF(MODE.EQ.5)IBNDMAX=NBNDF(IPAN)
C  TRANSFERE XFUN-VECTORS
      DO ISPIN1=1,NSPIN                 !!! over ispin1
	DO IBAS=0,MIN(NBAS,MBAS)          !!! over ibas
      DO IBNDS=1,NSPIN
	DO IBNDT =1,NBNDT(IPAN)+NBNDH(IPAN)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	SUM(IBAND)=(0.D0,0.D0)
	IF(NORBS.EQ.1.AND.ISPIN1.NE.IBNDS)CYCLE
	DO ISPIN=1,NSPIN                  !!! over ispin
	IF(NORBS.EQ.1.AND.ISPIN.NE.IBNDS)CYCLE
	DO IATOM=1,NATOM                  !!! over iatom
	ISORT=IS(IATOM)
	SCP=PNTK(1)*TAU(1,IATOM)+
     &    PNTK(2)*TAU(2,IATOM)+
     &    PNTK(3)*TAU(3,IATOM)
	EXPK=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	DO IKAP=1,NKAP(IPAN)              !!! over energy
	IF(IATOM.NE.INUC.AND.IAVD.EQ.1)EXIT
	DO L=0,ILSB(ISORT)                !!! over l
	DO M=-L,L                         !!! over m
	IF(.NOT.LTPAN(L,IATOM,IKAP,IPAN))EXIT
	LM=L*(L+1)+M+1
	IPAR=INDLMT(LM,IATOM,IKAP,ISPIN,IPAN)
	IF(TGO.EQ.'0N*0N')
     &SUM(IBAND)=SUM(IBAND)+XFUN0(IPAR,IBAS,ISPIN1)*
     &EXPK*APHK(LM,IATOM,IKAP,ISPIN,IBAND)
	IF(TGO.EQ.'0C*0N')
     &SUM(IBAND)=SUM(IBAND)+DCONJG(XFUN0(IPAR,IBAS,ISPIN1))*
     &EXPK*APHK(LM,IATOM,IKAP,ISPIN,IBAND)
	IF(TGO.EQ.'0N*QC')
     &SUM(IBAND)=SUM(IBAND)+XFUN0(IPAR,IBAS,ISPIN1)*
     &DCONJG(EXPK*APHQ(LM,IATOM,IKAP,ISPIN,IBAND))
C     IF(TGO.EQ.'0C*QC')
C    &SUM(IBAND)=SUM(IBAND)+DCONJG(XFUN0(IPAR,IBAS,ISPIN1))*
C    &DCONJG(EXPK*APHQ(LM,IATOM,IKAP,ISPIN,IBAND))
	IF(TGO.EQ.'QN*0N')
     &SUM(IBAND)=SUM(IBAND)+XFUNQ(IPAR,IBAS,ISPIN1)*
     &EXPK*APHK(LM,IATOM,IKAP,ISPIN,IBAND)
C     IF(TGO.EQ.'QC*0N')
C    &SUM(IBAND)=SUM(IBAND)+DCONJG(XFUNQ(IPAR,IBAS,ISPIN1))*
C    &EXPK*APHK(LM,IATOM,IKAP,ISPIN,IBAND)
	IF(TGO.EQ.'QN*QC')
     &SUM(IBAND)=SUM(IBAND)+XFUNQ(IPAR,IBAS,ISPIN1)*
     &DCONJG(EXPK*APHQ(LM,IATOM,IKAP,ISPIN,IBAND))
	IF(TGO.EQ.'QC*QC')
     &SUM(IBAND)=SUM(IBAND)+DCONJG(XFUNQ(IPAR,IBAS,ISPIN1))*
     &DCONJG(EXPK*APHQ(LM,IATOM,IKAP,ISPIN,IBAND))
	ENDDO                             !!! over m
	ENDDO                             !!! over l
	ENDDO                             !!! over energy
	ENDDO                             !!! over iatom
	ENDDO                             !!! over ispin
	ENDDO                             !!! over bands
	ENDDO                             !!! over spin subbands
      DO IBNDS=1,NSPIN
	DO IBNDT =1,NBNDT(IPAN)+NBNDH(IPAN)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	IF(TGO(1:1).EQ.'0')XFUN0(IBAND,IBAS,ISPIN1)=SUM(IBAND)
	IF(TGO(1:1).EQ.'Q')XFUNQ(IBAND,IBAS,ISPIN1)=SUM(IBAND)
	ENDDO
	ENDDO
	ENDDO                             !!! over ibas
	ENDDO                             !!! over ispin1
C Memory deallocations
	DEALLOCATE(SUM)
	END
