	SUBROUTINE DEL_DINTMAT(MY,INUC,IPNT,ISGQ,IPAN,IQPNT)
***********************************************************
*  Calculates pseudopotential contribution to the         *
*  change in the hamiltonian and overlap matrix using     *
*  fourier transform.                                     * 
*  S.Savrasov, Last revison 26.04.95.                     *
***********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_LATPAR,  ONLY : PAR,ORTH,OMEGAC                            !!! from readini
	USE COM_PANPAR,  ONLY : LTPAN,LSPAN,IATS,ISTS                      !!! from readini
	USE COM_KAPPAR,  ONLY : NPAN,NKAP,EK,EKAP                          !!! from readini
	USE COM_NBANDS,  ONLY : NBNDF,NBNDE,NBNDT,NBNDH                    !!! from readini
	USE COM_TEILORG, ONLY : KEYT,BZM,GOPT,MBAS                         !!! from makeplw
	USE COM_ETAPAR,  ONLY : ETA,CUT,LBAS,NBAS                          !!! from makeplw
	USE COM_DPSIVEC, ONLY : PSIK,PSIQ,DPSK,DPSQ,PNTK,PNTQ              !!! from d2psivec
	USE COM_PLWMESH, ONLY : NPLW,GPLW                                  !!! from makeplw
      USE COM_DELHAM,  ONLY : DHMATT,DOMATT,DHMATR,DOMATR,DVINTR         !!! from dintmat
	USE COM_POTDAT,  ONLY : POTPS,POTPS1                               !!! from readscf
	USE COM_DELPOT,  ONLY : DPOTPS,DPOTPS1                             !!! from delpot
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	USE COM_MASHDEP, ONLY : NVAL                                       !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: TPSK(:)
	COMPLEX*16, ALLOCATABLE :: TPSQ(:)
	COMPLEX*16, ALLOCATABLE :: CHIS(:)
	COMPLEX*16, ALLOCATABLE :: CONV(:,:)
	COMPLEX*16 GMY,DELVR,DELVT
	DATA PI/3.141592653589793D0/
C Memory allocations
	ALLOCATE(CONV(0:NBASMEM,4))
	ALLOCATE(TPSK(0:NBASMEM))
	ALLOCATE(TPSQ(0:NBASMEM))
	ALLOCATE(CHIS(0:NBASMEM))
      IF(MODE.NE.5)IBNDMIN=1
      IF(MODE.NE.5)IBNDMAX=NBNDT(IPAN)+NBNDH(IPAN)
      IF(MODE.EQ.5)IBNDMIN=NBNDE(IPAN)
      IF(MODE.EQ.5)IBNDMAX=NBNDF(IPAN)
C  SET INITIAL VALUES
      DO IBNDS1=1,NSPIN
	DO IBNDT1=1,NBNDT(IPAN)+NBNDH(IPAN)
	IBAND1=IBNDS1+NSPIN*(IBNDT1-1)
      DO IBNDS=1,NSPIN
	DO IBNDT =1,NBNDT(IPAN)+NBNDH(IPAN)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
      DVINTR(IBAND1,IBAND,MY,INUC)=(0.D0,0.D0)
      ENDDO   
      ENDDO   
      ENDDO   
      ENDDO   
C DO OVER SPINS
      DO 6000 IORBS=1,NORBS                       !!! over iorbs
      DO 5000 IUPDN=1,NSPIN                       !!! over iupdn
	IF(IORBS.EQ.1)THEN
	IUPDN1=IUPDN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	SIGNF=1.D0
	ELSEIF(IORBS.EQ.2)THEN
	IUPDN1=NSPIN+1-IUPDN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	IF(ISPIN1.EQ.1.AND.ISPIN.EQ.2)SIGNF=-SQRT(2.D0) ! B^{+}*S_{+}
	IF(ISPIN1.EQ.2.AND.ISPIN.EQ.1)SIGNF=+SQRT(2.D0) ! B^{-}*S_{-}
	ENDIF
C *** DO GLOBALLY OVER BANDS IBND ***
      DO 4000 IBNDS1=1,NSPIN                     !!! over spin subbands
	IF(NORBS.EQ.1.AND.IBNDS1.NE.ISPIN1)GOTO 4000
	DO 3000 IBNDT1=IBNDMIN,IBNDMAX             !!! over all bands
	IBAND1=IBNDS1+NSPIN*(IBNDT1-1)
	IF(MODE.NE.2)THEN                          !!! <- if mode.ne.2
	DO IBAS=0,MIN(NBAS,MBAS)                   !!! over plane waves
      GX=PNTK(1)+GPLW(1,IBAS)
      GY=PNTK(2)+GPLW(2,IBAS)
      GZ=PNTK(3)+GPLW(3,IBAS)
      IF(-MY.EQ.-1)GMY=+1.D0/SQRT(2.D0)*(GX-(0.D0,1.D0)*GY)
      IF(-MY.EQ.+1)GMY=-1.D0/SQRT(2.D0)*(GX+(0.D0,1.D0)*GY)
      IF(-MY.EQ. 0)GMY=GZ
      TPSK(IBAS)=DPSK(IBAS,ISPIN1,IBAND1)*GMY*
     &  (0.D0,1.D0)*2.D0*PI/PAR*(-1)**MY
      ENDDO   
	ENDIF                                      !!! <- endif mode.ne.2
C  CONVOLUTION OF THE PSEUDOORBITAL WITH THE PSEUDOPOTENTIAL
	DO IBAS=0,MIN(NBAS,MBAS)
	CHIS(IBAS)=DCONJG(PSIQ(IBAS,ISPIN1,IBAND1))
	ENDDO
      CALL BND_CONVOL1(DPOTPS1(0,IUPDN1,IORBS),CHIS(0),CONV(0,1),'L',
     &               0,MIN(NBAS,MBAS),0,MIN(NBAS,MBAS))
	IF(MODE.NE.2)THEN                          !!! <- if mode.ne.2
	DO IBAS=0,MIN(NBAS,MBAS)
	CHIS(IBAS)=DCONJG(TPSK(IBAS))
	ENDDO
      CALL BND_CONVOL1(POTPS1(0,IUPDN1,IORBS),CHIS(0),CONV(0,2),'L',
     &               0,MIN(NBAS,MBAS),0,MIN(NBAS,MBAS))
	DO IBAS=0,MIN(NBAS,MBAS)
	CHIS(IBAS)=DCONJG(PSIQ(IBAS,ISPIN1,IBAND1))
	ENDDO
      CALL BND_CONVOL1(POTPS1(0,IUPDN1,IORBS),CHIS(0),CONV(0,3),'L',
     &               0,MIN(NBAS,MBAS),0,MIN(NBAS,MBAS))
	ENDIF
C *** DO GLOBALLY OVER BANDS ***
      DO 2000 IBNDS=1,NSPIN                     !!! over spin subbands
	IF(NORBS.EQ.1.AND.IBNDS.NE.ISPIN)GOTO 2000
	DO 1000 IBNDT=IBNDMIN,IBNDMAX             !!! over all bands
	IBAND=IBNDS+NSPIN*(IBNDT-1)
      IF((IPAN.EQ.1.AND.((IBNDT.LE.NBNDF(IPAN).AND.IBNDT1.GE.NBNDE(
     &  IPAN)).OR.(IBNDT.GE.NBNDE(IPAN).AND.IBNDT1.LE.NBNDF(IPAN))))
     &  .OR.(MODE.EQ.4.OR.MODE.EQ.5))THEN                         
	IF(MODE.NE.2)THEN                         !!! <- if mode.ne.2
	DO IBAS=0,MIN(NBAS,MBAS)                  !!! over plane waves
      GX=PNTQ(1)+GPLW(1,IBAS)
      GY=PNTQ(2)+GPLW(2,IBAS)
      GZ=PNTQ(3)+GPLW(3,IBAS)
      IF(MY.EQ.-1)GMY=+1.D0/SQRT(2.D0)*(GX-(0.D0,1.D0)*GY)
      IF(MY.EQ.+1)GMY=-1.D0/SQRT(2.D0)*(GX+(0.D0,1.D0)*GY)
      IF(MY.EQ. 0)GMY=GZ
      TPSQ(IBAS)=DPSQ(IBAS,ISPIN,IBAND)*GMY*(0.D0,1.D0)*
     &  2.D0*PI/PAR
      ENDDO                                     !!! over plane waves
	ENDIF                                     !!! <- endif mode.ne.2
C  CHANGE IN PSEUDPOTENTIAL MATRIX ELEMENTS
	DELVT=(0.D0,0.D0)
	DO IBAS=0,MIN(NBAS,MBAS)                  !!! over plane waves
	DELVT=DELVT+CONV(IBAS,1)*PSIK(IBAS,ISPIN,IBAND)
      ENDDO                                     !!! over plane waves
      DELVT=DELVT*SIGNF
	DELVR=(0.D0,0.D0)
	IF(MODE.NE.2)THEN                         !!! <- if mode.ne.2
	DO IBAS=0,MIN(NBAS,MBAS)                  !!! over plane waves
	DELVR=DELVR+CONV(IBAS,2)*PSIK(IBAS,ISPIN,IBAND)
	DELVR=DELVR+CONV(IBAS,3)*TPSQ(IBAS)
      ENDDO                                     !!! over plane waves
      DELVR=DELVR*SIGNF
	DVINTR(IBAND1,IBAND,MY,INUC)=
     &DVINTR(IBAND1,IBAND,MY,INUC)+DELVR
	ENDIF                                     !!! <- endif mode.ne.2
	DHMATT(IBAND1,IBAND,MY,INUC)=
     &DHMATT(IBAND1,IBAND,MY,INUC)+DELVT+DELVR
 	ENDIF
 1000 CONTINUE                                  !!! over all bands
 2000 CONTINUE                                  !!! over spin subbands
 3000 CONTINUE                                  !!! over all bands
 4000 CONTINUE                                  !!! over spin subbands
 5000 CONTINUE                                  !!! over iupdn
 6000 CONTINUE                                  !!! over iorbs
C Memory deallocations
	DEALLOCATE(CONV,TPSK,TPSQ,CHIS)
	END
