	SUBROUTINE DEL_DSLMTPAR(MY,INUC,IPAN,IQPNT)
*********************************************************
*  Subroutine calculates "soft" change in the MT-part   *
*  of potential paramenters.                            *
*********************************************************
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT                                       !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_KAPPAR,  ONLY : NPAN,NKAP,EK,EKAP                          !!! from readini
      USE COM_INPPAR,  ONLY : TNY,ENY,DNY,NODES,MNY                      !!! from readini
	USE COM_PANPAR,  ONLY : LTPAN,LSPAN,IATS,ISTS                      !!! from readini
	USE COM_LMTPAR,  ONLY : GAM,AAH,BBH,AAJ,BBJ                        !!! from potpar
	USE COM_POTPAR,  ONLY : FF,FFP,FPF,FPFP                            !!! from potpar
      USE COM_MTSPAR,  ONLY : HMTHH,HMTJH,HMTHJ,HMTJJ
     &                       ,OMTHH,OMTJH,OMTHJ,OMTJJ
	USE COM_DINPPAR, ONLY : DELENY,DELDNY                              !!! from dinppar
	USE COM_DLMTPAR, ONLY : DELAAH,DELBBH,DELAAJ,DELBBJ                !!! from dpotpar
	USE COM_DMTSPAR, ONLY : DHMTHH,DHMTJH,DHMTHJ,DHMTJJ                !!! for dintpar
     &                       ,DOMTHH,DOMTJH,DOMTHJ,DOMTJJ                !!! for dintpar
	USE COM_DPOTPAR, ONLY : DELFF,DELFFP,DELFPF,DELFPFP                !!! from dpotpar
	USE COM_SPHERE,  ONLY : SWZ,SMT                                    !!! from readini
	USE COM_LABELS,  ONLY : TXTEL                                      !!! from readini
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	USE COM_MASHDEP, ONLY : NVAL                                       !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16 
     &    DFHHFH,DFJHFH,DFHHFJ,DFJHFJ,DFHFH,DFHFJ,DFJFH,DFJFJ
     &   ,TR(-1:1,3),LIB_CNUM0P
	CHARACTER TL(0:3)*1,TN(9)*1,POL(-1:1)*1
	LOGICAL LOG
	DATA PI/3.141592653589793D0/,TL/'s','p','d','f'/,TN/'1','2'
     &      ,'3','4','5','6','7','8','9'/,POL/'m','0','p'/
C  COMPUTE POTENTIAL PARAMETERS FOR THE OVERLAP MATRIX AND HAMILTONIAN ::
	WRITE(IUN,1000)NKAP(IPAN),IPAN
	DO ISPIN=1,NSPIN                                     !!! over ispin
	DO IATOM=1,NATOM                                     !!! over iatom
	ISORT=IS(IATOM)
	DO L=0,ILST(ISORT)                                   !!! over l
	DO IKAP1=1,NKAP(IPAN)                                !!! over ikap1
	DO IKAP=1,NKAP(IPAN)                                 !!! over ikap
C  SET POTENTIAL PARAMETERS TO ZERO
	IF(L.LE.ILSB(ISORT))THEN
	DHMTHH(IKAP1,IKAP,L,IATOM,ISPIN)=(0.D0,0.D0)
	DHMTJH(IKAP1,IKAP,L,IATOM,ISPIN)=(0.D0,0.D0)
	DHMTHJ(IKAP1,IKAP,L,IATOM,ISPIN)=(0.D0,0.D0)
	DOMTHH(IKAP1,IKAP,L,IATOM,ISPIN)=(0.D0,0.D0)
	DOMTJH(IKAP1,IKAP,L,IATOM,ISPIN)=(0.D0,0.D0)
	DOMTHJ(IKAP1,IKAP,L,IATOM,ISPIN)=(0.D0,0.D0)
	ENDIF
	DOMTJJ(IKAP1,IKAP,L,IATOM,ISPIN)=(0.D0,0.D0)
	DHMTJJ(IKAP1,IKAP,L,IATOM,ISPIN)=(0.D0,0.D0)
C  ONE- AND TWO-CENTER POTENTIAL PARAMETERS
C  1) SET CHANGE IN <FH|FH>
	IF(LSPAN(L,ISORT,IKAP1,IPAN).AND.LSPAN(L,ISORT,IKAP,IPAN))THEN
	DFHFH=(0.D0,0.D0)
	DFHFH=DFHFH+
     &  DELAAH(L,IKAP1,IATOM,ISPIN,2,MY,INUC)*
     &  FF(IKAP1,IKAP,L,ISORT,ISPIN)*
     &  AAH(L,ISORT,IKAP,IPAN,ISPIN)+
     &  DELBBH(L,IKAP1,IATOM,ISPIN,2,MY,INUC)* 
     &  FPFP(IKAP1,IKAP,L,ISORT,ISPIN)*
     &  BBH(L,ISORT,IKAP,IPAN,ISPIN)+
     &  DELAAH(L,IKAP1,IATOM,ISPIN,2,MY,INUC)*
     &  FFP(IKAP1,IKAP,L,ISORT,ISPIN)*
     &  BBH(L,ISORT,IKAP,IPAN,ISPIN)+
     &  DELBBH(L,IKAP1,IATOM,ISPIN,2,MY,INUC)*
     &  FPF(IKAP1,IKAP,L,ISORT,ISPIN)*
     &  AAH(L,ISORT,IKAP,IPAN,ISPIN)   
	DFHFH=DFHFH+
     &  CONJG(AAH(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  FF(IKAP1,IKAP,L,ISORT,ISPIN)*
     &  DELAAH(L,IKAP,IATOM,ISPIN,1,MY,INUC)+
     &  CONJG(BBH(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  FPFP(IKAP1,IKAP,L,ISORT,ISPIN)*
     &  DELBBH(L,IKAP,IATOM,ISPIN,1,MY,INUC)+
     &  CONJG(AAH(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  FFP(IKAP1,IKAP,L,ISORT,ISPIN)*
     &  DELBBH(L,IKAP,IATOM,ISPIN,1,MY,INUC)+
     &  CONJG(BBH(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  FPF(IKAP1,IKAP,L,ISORT,ISPIN)*
     &  DELAAH(L,IKAP,IATOM,ISPIN,1,MY,INUC)   
	DFHFH=DFHFH+
     &  CONJG(AAH(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  DELFF(IKAP1,IKAP,L,IATOM,ISPIN)*
     &  AAH(L,ISORT,IKAP,IPAN,ISPIN)+
     &  CONJG(BBH(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  DELFPFP(IKAP1,IKAP,L,IATOM,ISPIN)*
     &  BBH(L,ISORT,IKAP,IPAN,ISPIN)+
     &  CONJG(AAH(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  DELFFP(IKAP1,IKAP,L,IATOM,ISPIN)*
     &  BBH(L,ISORT,IKAP,IPAN,ISPIN)+
     &  CONJG(BBH(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  DELFPF(IKAP1,IKAP,L,IATOM,ISPIN)*
     &  AAH(L,ISORT,IKAP,IPAN,ISPIN)   
	DOMTHH(IKAP1,IKAP,L,IATOM,ISPIN)=DFHFH
	ENDIF
C  2) SET CHANGE IN <FJ|FH>
	IF(LSPAN(L,ISORT,IKAP,IPAN))THEN
	DFJFH=(0.D0,0.D0)
	DFJFH=DFJFH+
     &  DELAAJ(L,IKAP1,IATOM,ISPIN,2,MY,INUC)*
     &  FF(IKAP1,IKAP,L,ISORT,ISPIN)*
     &  AAH(L,ISORT,IKAP,IPAN,ISPIN)+
     &  DELBBJ(L,IKAP1,IATOM,ISPIN,2,MY,INUC)*
     &  FPFP(IKAP1,IKAP,L,ISORT,ISPIN)*
     &  BBH(L,ISORT,IKAP,IPAN,ISPIN)+
     &  DELAAJ(L,IKAP1,IATOM,ISPIN,2,MY,INUC)*
     &  FFP(IKAP1,IKAP,L,ISORT,ISPIN)*
     &  BBH(L,ISORT,IKAP,IPAN,ISPIN)+
     &  DELBBJ(L,IKAP1,IATOM,ISPIN,2,MY,INUC)*
     &  FPF(IKAP1,IKAP,L,ISORT,ISPIN)*
     &  AAH(L,ISORT,IKAP,IPAN,ISPIN)   
	DFJFH=DFJFH+
     &  CONJG(AAJ(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  FF(IKAP1,IKAP,L,ISORT,ISPIN)*
     &  DELAAH(L,IKAP,IATOM,ISPIN,1,MY,INUC)+
     &  CONJG(BBJ(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  FPFP(IKAP1,IKAP,L,ISORT,ISPIN)*
     &  DELBBH(L,IKAP,IATOM,ISPIN,1,MY,INUC)+
     &  CONJG(AAJ(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  FFP(IKAP1,IKAP,L,ISORT,ISPIN)*
     &  DELBBH(L,IKAP,IATOM,ISPIN,1,MY,INUC)+
     &  CONJG(BBJ(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  FPF(IKAP1,IKAP,L,ISORT,ISPIN)*
     &  DELAAH(L,IKAP,IATOM,ISPIN,1,MY,INUC)   
	DFJFH=DFJFH+
     &  CONJG(AAJ(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  DELFF(IKAP1,IKAP,L,IATOM,ISPIN)*
     &  AAH(L,ISORT,IKAP,IPAN,ISPIN)+
     &  CONJG(BBJ(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  DELFPFP(IKAP1,IKAP,L,IATOM,ISPIN)*
     &  BBH(L,ISORT,IKAP,IPAN,ISPIN)+
     &  CONJG(AAJ(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  DELFFP(IKAP1,IKAP,L,IATOM,ISPIN)*
     &  BBH(L,ISORT,IKAP,IPAN,ISPIN)+
     &  CONJG(BBJ(L,ISORT,IKAP1,IPAN,ISPIN))* 
     &  DELFPF(IKAP1,IKAP,L,IATOM,ISPIN)*
     &  AAH(L,ISORT,IKAP,IPAN,ISPIN)   
	DOMTJH(IKAP1,IKAP,L,IATOM,ISPIN)=DFJFH*GAM(L,ISORT)
	ENDIF
C  3) SET CHANGE IN <FH|FJ>
	IF(LSPAN(L,ISORT,IKAP1,IPAN))THEN
	DFHFJ=(0.D0,0.D0)
	DFHFJ=DFHFJ+
     &  DELAAH(L,IKAP1,IATOM,ISPIN,2,MY,INUC)*
     &  FF(IKAP1,IKAP,L,ISORT,ISPIN)*
     &  AAJ(L,ISORT,IKAP,IPAN,ISPIN)+
     &  DELBBH(L,IKAP1,IATOM,ISPIN,2,MY,INUC)*
     &  FPFP(IKAP1,IKAP,L,ISORT,ISPIN)*
     &  BBJ(L,ISORT,IKAP,IPAN,ISPIN)+
     &  DELAAH(L,IKAP1,IATOM,ISPIN,2,MY,INUC)*
     &  FFP(IKAP1,IKAP,L,ISORT,ISPIN)*
     &  BBJ(L,ISORT,IKAP,IPAN,ISPIN)+
     &  DELBBH(L,IKAP1,IATOM,ISPIN,2,MY,INUC)*
     &  FPF(IKAP1,IKAP,L,ISORT,ISPIN)*
     &  AAJ(L,ISORT,IKAP,IPAN,ISPIN)   
	DFHFJ=DFHFJ+
     &  CONJG(AAH(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  FF(IKAP1,IKAP,L,ISORT,ISPIN)*
     &  DELAAJ(L,IKAP,IATOM,ISPIN,1,MY,INUC)+
     &  CONJG(BBH(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  FPFP(IKAP1,IKAP,L,ISORT,ISPIN)*
     &  DELBBJ(L,IKAP,IATOM,ISPIN,1,MY,INUC)+
     &  CONJG(AAH(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  FFP(IKAP1,IKAP,L,ISORT,ISPIN)*
     &  DELBBJ(L,IKAP,IATOM,ISPIN,1,MY,INUC)+
     &  CONJG(BBH(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  FPF(IKAP1,IKAP,L,ISORT,ISPIN)*
     &  DELAAJ(L,IKAP,IATOM,ISPIN,1,MY,INUC)   
	DFHFJ=DFHFJ+
     &  CONJG(AAH(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  DELFF(IKAP1,IKAP,L,IATOM,ISPIN)*
     &  AAJ(L,ISORT,IKAP,IPAN,ISPIN)+
     &  CONJG(BBH(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  DELFPFP(IKAP1,IKAP,L,IATOM,ISPIN)*
     &  BBJ(L,ISORT,IKAP,IPAN,ISPIN)+
     &  CONJG(AAH(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  DELFFP(IKAP1,IKAP,L,IATOM,ISPIN)*
     &  BBJ(L,ISORT,IKAP,IPAN,ISPIN)+
     &  CONJG(BBH(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  DELFPF(IKAP1,IKAP,L,IATOM,ISPIN)*
     &  AAJ(L,ISORT,IKAP,IPAN,ISPIN)   
	DOMTHJ(IKAP1,IKAP,L,IATOM,ISPIN)=DFHFJ*GAM(L,ISORT)
	ENDIF
C 1) SET CHANGE IN <FH|H-Eny|FH>
	IF(LSPAN(L,ISORT,IKAP1,IPAN).AND.LSPAN(L,ISORT,IKAP,IPAN))THEN
	DFHHFH=(0.D0,0.D0)
	DFHHFH=DFHHFH+
     &  DELAAH(L,IKAP1,IATOM,ISPIN,2,MY,INUC)*
     &  FF(IKAP1,IKAP,L,ISORT,ISPIN)*
     &  BBH(L,ISORT,IKAP,IPAN,ISPIN)+
     &  DELBBH(L,IKAP1,IATOM,ISPIN,2,MY,INUC)*
     &  FPF(IKAP1,IKAP,L,ISORT,ISPIN)*
     &  BBH(L,ISORT,IKAP,IPAN,ISPIN) 
	DFHHFH=DFHHFH+
     &  CONJG(AAH(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  FF(IKAP1,IKAP,L,ISORT,ISPIN)*
     &  DELBBH(L,IKAP,IATOM,ISPIN,1,MY,INUC)+
     &  CONJG(BBH(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  FPF(IKAP1,IKAP,L,ISORT,ISPIN)*
     &  DELBBH(L,IKAP,IATOM,ISPIN,1,MY,INUC) 
	DFHHFH=DFHHFH+
     &  CONJG(AAH(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  DELFF(IKAP1,IKAP,L,IATOM,ISPIN)*
     &  BBH(L,ISORT,IKAP,IPAN,ISPIN)+
     &  CONJG(BBH(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  DELFPF(IKAP1,IKAP,L,IATOM,ISPIN)*
     &  BBH(L,ISORT,IKAP,IPAN,ISPIN) 
	DHMTHH(IKAP1,IKAP,L,IATOM,ISPIN)=DFHHFH+
     &  ENY(L,ISORT,IKAP,IPAN,ISPIN)*
     &  DOMTHH(IKAP1,IKAP,L,IATOM,ISPIN)+
     &  DELENY(L,IKAP,IATOM,ISPIN,MY,INUC)*
     &  OMTHH(IKAP1,IKAP,L,ISORT,ISPIN)
	ENDIF
C 2) SET CHANGE IN <FJ|H-Eny|FH>
	IF(LSPAN(L,ISORT,IKAP,IPAN))THEN
	DFJHFH=(0.D0,0.D0)
	DFJHFH=DFJHFH+
     &  DELAAJ(L,IKAP1,IATOM,ISPIN,2,MY,INUC)*
     &  FF(IKAP1,IKAP,L,ISORT,ISPIN)*
     &  BBH(L,ISORT,IKAP,IPAN,ISPIN)+
     &  DELBBJ(L,IKAP1,IATOM,ISPIN,2,MY,INUC)*
     &  FPF(IKAP1,IKAP,L,ISORT,ISPIN)*
     &  BBH(L,ISORT,IKAP,IPAN,ISPIN) 
	DFJHFH=DFJHFH+
     &  CONJG(AAJ(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  FF(IKAP1,IKAP,L,ISORT,ISPIN)*
     &  DELBBH(L,IKAP,IATOM,ISPIN,1,MY,INUC)+
     &  CONJG(BBJ(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  FPF(IKAP1,IKAP,L,ISORT,ISPIN)*
     &  DELBBH(L,IKAP,IATOM,ISPIN,1,MY,INUC) 
	DFJHFH=DFJHFH+
     &  CONJG(AAJ(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  DELFF(IKAP1,IKAP,L,IATOM,ISPIN)*
     &  BBH(L,ISORT,IKAP,IPAN,ISPIN)+
     &  CONJG(BBJ(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  DELFPF(IKAP1,IKAP,L,IATOM,ISPIN)*
     &  BBH(L,ISORT,IKAP,IPAN,ISPIN) 
	DHMTJH(IKAP1,IKAP,L,IATOM,ISPIN)=DFJHFH*GAM(L,ISORT)+
     &  ENY(L,ISORT,IKAP,IPAN,ISPIN)*
     &  DOMTJH(IKAP1,IKAP,L,IATOM,ISPIN)+
     &  DELENY(L,IKAP,IATOM,ISPIN,MY,INUC)*
     &  OMTJH(IKAP1,IKAP,L,ISORT,ISPIN)
	ENDIF
C 3) SET CHANGE IN <FH|H-Eny|FJ>
	IF(LSPAN(L,ISORT,IKAP1,IPAN))THEN
	DFHHFJ=(0.D0,0.D0)
	DFHHFJ=DFHHFJ+
     &  DELAAH(L,IKAP1,IATOM,ISPIN,2,MY,INUC)*
     &  FF(IKAP1,IKAP,L,ISORT,ISPIN)*
     &  BBJ(L,ISORT,IKAP,IPAN,ISPIN)+
     &  DELBBH(L,IKAP1,IATOM,ISPIN,2,MY,INUC)*
     &  FPF(IKAP1,IKAP,L,ISORT,ISPIN)*
     &  BBJ(L,ISORT,IKAP,IPAN,ISPIN) 
	DFHHFJ=DFHHFJ+
     &  CONJG(AAH(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  FF(IKAP1,IKAP,L,ISORT,ISPIN)*
     &  DELBBJ(L,IKAP,IATOM,ISPIN,1,MY,INUC)+
     &  CONJG(BBH(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  FPF(IKAP1,IKAP,L,ISORT,ISPIN)*
     &  DELBBJ(L,IKAP,IATOM,ISPIN,1,MY,INUC) 
	DFHHFJ=DFHHFJ+
     &  CONJG(AAH(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  DELFF(IKAP1,IKAP,L,IATOM,ISPIN)*
     &  BBJ(L,ISORT,IKAP,IPAN,ISPIN)+
     &  CONJG(BBH(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  DELFPF(IKAP1,IKAP,L,IATOM,ISPIN)*
     &  BBJ(L,ISORT,IKAP,IPAN,ISPIN) 
	DHMTHJ(IKAP1,IKAP,L,IATOM,ISPIN)=DFHHFJ*GAM(L,ISORT)+
     &  ENY(L,ISORT,IKAP,IPAN,ISPIN)*
     &  DOMTHJ(IKAP1,IKAP,L,IATOM,ISPIN)+
     &  DELENY(L,IKAP,IATOM,ISPIN,MY,INUC)*
     &  OMTHJ(IKAP1,IKAP,L,ISORT,ISPIN)
	ENDIF
C  THREE-CENTER POTENTIAL PARAMETERS
C  SET CHANGE IN <FJ|FJ>
	DFJFJ=(0.D0,0.D0)
	DFJFJ=DFJFJ+
     &  DELAAJ(L,IKAP1,IATOM,ISPIN,2,MY,INUC)*
     &  FF(IKAP1,IKAP,L,ISORT,ISPIN)*
     &  AAJ(L,ISORT,IKAP,IPAN,ISPIN)+
     &  DELBBJ(L,IKAP1,IATOM,ISPIN,2,MY,INUC)*
     &  FPFP(IKAP1,IKAP,L,ISORT,ISPIN)*
     &  BBJ(L,ISORT,IKAP,IPAN,ISPIN)+
     &  DELAAJ(L,IKAP1,IATOM,ISPIN,2,MY,INUC)*
     &  FFP(IKAP1,IKAP,L,ISORT,ISPIN)*
     &  BBJ(L,ISORT,IKAP,IPAN,ISPIN)+
     &  DELBBJ(L,IKAP1,IATOM,ISPIN,2,MY,INUC)*
     &  FPF(IKAP1,IKAP,L,ISORT,ISPIN)*
     &  AAJ(L,ISORT,IKAP,IPAN,ISPIN)   
	DFJFJ=DFJFJ+
     &  CONJG(AAJ(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  FF(IKAP1,IKAP,L,ISORT,ISPIN)*
     &  DELAAJ(L,IKAP,IATOM,ISPIN,1,MY,INUC)+
     &  CONJG(BBJ(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  FPFP(IKAP1,IKAP,L,ISORT,ISPIN)*
     &  DELBBJ(L,IKAP,IATOM,ISPIN,1,MY,INUC)+
     &  CONJG(AAJ(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  FFP(IKAP1,IKAP,L,ISORT,ISPIN)*
     &  DELBBJ(L,IKAP,IATOM,ISPIN,1,MY,INUC)+
     &  CONJG(BBJ(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  FPF(IKAP1,IKAP,L,ISORT,ISPIN)*
     &  DELAAJ(L,IKAP,IATOM,ISPIN,1,MY,INUC)   
	DFJFJ=DFJFJ+
     &  CONJG(AAJ(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  DELFF(IKAP1,IKAP,L,IATOM,ISPIN)*
     &  AAJ(L,ISORT,IKAP,IPAN,ISPIN)+
     &  CONJG(BBJ(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  DELFPFP(IKAP1,IKAP,L,IATOM,ISPIN)*
     &  BBJ(L,ISORT,IKAP,IPAN,ISPIN)+
     &  CONJG(AAJ(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  DELFFP(IKAP1,IKAP,L,IATOM,ISPIN)*
     &  BBJ(L,ISORT,IKAP,IPAN,ISPIN)+
     &  CONJG(BBJ(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  DELFPF(IKAP1,IKAP,L,IATOM,ISPIN)*
     &  AAJ(L,ISORT,IKAP,IPAN,ISPIN)   
C SET CHANGE IN <FJ|H-Eny|FJ>
	DFJHFJ=(0.D0,0.D0)
	DFJHFJ=DFJHFJ+
     &  DELAAJ(L,IKAP1,IATOM,ISPIN,2,MY,INUC)*
     &  FF(IKAP1,IKAP,L,ISORT,ISPIN)*
     &  BBJ(L,ISORT,IKAP,IPAN,ISPIN)+
     &  DELBBJ(L,IKAP1,IATOM,ISPIN,2,MY,INUC)*
     &  FPF(IKAP1,IKAP,L,ISORT,ISPIN)*
     &  BBJ(L,ISORT,IKAP,IPAN,ISPIN) 
	DFJHFJ=DFJHFJ+
     &  CONJG(AAJ(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  FF(IKAP1,IKAP,L,ISORT,ISPIN)*
     &  DELBBJ(L,IKAP,IATOM,ISPIN,1,MY,INUC)+
     &  CONJG(BBJ(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  FPF(IKAP1,IKAP,L,ISORT,ISPIN)*
     &  DELBBJ(L,IKAP,IATOM,ISPIN,1,MY,INUC) 
	DFJHFJ=DFJHFJ+
     &  CONJG(AAJ(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  DELFF(IKAP1,IKAP,L,IATOM,ISPIN)*
     &  BBJ(L,ISORT,IKAP,IPAN,ISPIN)+
     &  CONJG(BBJ(L,ISORT,IKAP1,IPAN,ISPIN))*
     &  DELFPF(IKAP1,IKAP,L,IATOM,ISPIN)*
     &  BBJ(L,ISORT,IKAP,IPAN,ISPIN) 
C THREE-CENTER POTENTIAL PARAMETERS ARE GIVEN BY
	DOMTJJ(IKAP1,IKAP,L,IATOM,ISPIN)=DFJFJ*GAM(L,ISORT)*
     &  GAM(L,ISORT)
	DHMTJJ(IKAP1,IKAP,L,IATOM,ISPIN)=DFJHFJ*GAM(L,ISORT)*
     &  GAM(L,ISORT)+ENY(L,ISORT,IKAP,IPAN,ISPIN)*
     &  DOMTJJ(IKAP1,IKAP,L,IATOM,ISPIN)+
     &  DELENY(L,IKAP,IATOM,ISPIN,MY,INUC)*
     &  OMTJJ(IKAP1,IKAP,L,ISORT,ISPIN)
      ENDDO                                                    !!! over ikap
      ENDDO                                                    !!! over ikap1
      ENDDO                                                    !!! over l
      ENDDO                                                    !!! over iatom
      ENDDO                                                    !!! over ispin
C
	WRITE(IUN,1010)INUC,POL(MY),TXTEL(IS(INUC))
	DO ISPIN=1,NSPIN
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	DO IKAP=1,NKAP(IPAN)
	IF(IPAN.EQ.1.AND.MNY(0,1,1,1).EQ.0)THEN
	WRITE(IUN,1020)DREAL(EKAP(IKAP,IPAN)),TXTEL(ISORT)
	ELSE
	WRITE(IUN,1030)DREAL(EKAP(IKAP,IPAN)),TXTEL(ISORT)
	ENDIF
	DO L=0,ILSB(ISORT)
	NO=TNY(L,ISORT,IKAP,IPAN,ISPIN)+L+1
	IF(LSPAN(L,ISORT,IKAP,IPAN).AND.IPAN.EQ.1
     &  .AND.MNY(0,1,1,1).EQ.0)WRITE(IUN,1040)
     &  LIB_CNUM0P(DELDNY(L,IKAP,IATOM,ISPIN,MY,INUC),1.D-07),
     &  TN(NO)//TL(L)
	IF(LSPAN(L,ISORT,IKAP,IPAN).AND.IPAN.EQ.1
     &  .AND.MNY(0,1,1,1).NE.0)WRITE(IUN,1040)
     &  LIB_CNUM0P(DELENY(L,IKAP,IATOM,ISPIN,MY,INUC),1.D-07),
     &  TN(NO)//TL(L)
	IF(LSPAN(L,ISORT,IKAP,IPAN).AND.IPAN.NE.1)WRITE(IUN,1040)
     &  LIB_CNUM0P(DELENY(L,IKAP,IATOM,ISPIN,MY,INUC),1.D-07),
     &  TN(NO)//TL(L)
      ENDDO     
      ENDDO     
      ENDDO     
      ENDDO     
1000  FORMAT(1X,I1,'kappa Panel #',I2,' :: Calculation of Linear',
     &  ' Response ------->')
1010  FORMAT(1X,'Atom ',I2,' Movement::  polarization  "',A1,'" ',A10)
1020  FORMAT(1X,'         Delta{Dny} :       Ekap=',G11.4,1X,A10)
1030  FORMAT(1X,'         Delta{Eny} :       Ekap=',G11.4,1X,A10)
1040  FORMAT(1X,'(',G14.7,',',G14.7,')','  for ',A2,' state')
	END
