	SUBROUTINE DEL_DSNMTPAR(MY,INUC,IPAN,IQPNT)
***************************************************************
*   Calculate potential parameter variation of the NMT-       *
*   contribution to the hamiltonian matrix.                   *
***************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
     &                       ,LRTV
	USE COM_RADMESH, ONLY : NRAD,H,R,DR,WEIGHT                         !!! from radmsh
	USE COM_LRTCOM,  ONLY : LDLF                                       !!! from readlrt
	USE COM_PANPAR,  ONLY : LTPAN,LSPAN,IATS,ISTS                      !!! from readini
	USE COM_SPHERE,  ONLY : SWZ,SMT                                    !!! from readini
	USE COM_SYMMLM,  ONLY : SYM,LMSYM                                  !!! from makesym
      USE COM_INPPAR,  ONLY : TNY,ENY,DNY                                !!! from readini
	USE COM_DINPPAR, ONLY : DELENY                                     !!! from dinppar
	USE COM_DMTSPAR, ONLY : DHMTHH,DHMTJH,DHMTHJ,DHMTJJ                !!! for dintpar
	USE COM_POTDAT,  ONLY : POT,POTRWF                                 !!! from fulpot
	USE COM_KAPPAR,  ONLY : NPAN,NKAP,EK,EKAP                          !!! from readini
	USE COM_LMTPAR,  ONLY : GAM,AAH,BBH,AAJ,BBJ                        !!! from potpar
	USE COM_DLMTPAR, ONLY : DELAAH,DELBBH,DELAAJ,DELBBJ                !!! from dpotpar
	USE COM_DHAMPAR, ONLY : DELHHH,DELHJH,DELHHJ,DELHJJ                !!! from intpar
	USE COM_DELPOT,  ONLY : DPOT,DPOTRWF                               !!! from delpot
	USE COM_GAUNT,   ONLY : C                                          !!! from makegnt
	USE COM_MASHDEP, ONLY : NVAL                                       !!! from setup
	USE COM_PHNCHN  ,ONLY : IUDMT                                      !!! from channels
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: RADMAT(:,:,:,:)
      COMPLEX*16, ALLOCATABLE :: WORK1(:)
      COMPLEX*16, ALLOCATABLE :: WORK2(:)
	COMPLEX*16, ALLOCATABLE :: DELFIH(:,:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: DELFIJ(:,:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: FIH(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: FIJ(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: DVT(:)
	COMPLEX*16, ALLOCATABLE :: DFI(:,:) 
	COMPLEX*16, ALLOCATABLE :: DFID(:,:)
	COMPLEX*16, ALLOCATABLE :: DFIP(:,:)
	COMPLEX*16, ALLOCATABLE :: DFIDP(:,:)
	COMPLEX*16, ALLOCATABLE :: DFIDDS(:)
	COMPLEX*16, ALLOCATABLE :: DFIDDPS(:)
	REAL*8, ALLOCATABLE :: AFI(:,:)
	REAL*8, ALLOCATABLE :: AFID(:,:)
	REAL*8, ALLOCATABLE :: AFIP(:,:)
	REAL*8, ALLOCATABLE :: AFIDP(:,:)
	REAL*8, ALLOCATABLE :: AFIDDS(:)
	REAL*8, ALLOCATABLE :: AFIDDPS(:)
	LOGICAL LOG1,LOG,EXIST
	DATA PI/3.141592653589793D0/
C Memory allocations
	ALLOCATE(RADMAT(4,0:LMAXTMEM,0:LMAXTMEM,LIMVMEM))
      ALLOCATE(WORK1(0:NRADMEM))
      ALLOCATE(WORK2(0:NRADMEM))
	ALLOCATE(DELFIH(0:NRADMEM,0:LMAXTMEM,2,NKAPMEM,NSPINMEM))
	ALLOCATE(DELFIJ(0:NRADMEM,0:LMAXTMEM,2,NKAPMEM,NSPINMEM))
	ALLOCATE(FIH(0:NRADMEM,0:LMAXTMEM,NKAPMEM,NSPINMEM))
	ALLOCATE(FIJ(0:NRADMEM,0:LMAXTMEM,NKAPMEM,NSPINMEM))
	ALLOCATE(DVT(0:NRADMEM))
	ALLOCATE(DFI(0:NRADMEM,0:LMAXTMEM))
	ALLOCATE(DFID(0:NRADMEM,0:LMAXTMEM))
	ALLOCATE(DFIP(0:NRADMEM,0:LMAXTMEM))
	ALLOCATE(DFIDP(0:NRADMEM,0:LMAXTMEM))
	ALLOCATE(DFIDDS(0:LMAXTMEM))
	ALLOCATE(DFIDDPS(0:LMAXTMEM))
	ALLOCATE(AFI(0:NRADMEM,0:LMAXTMEM))
	ALLOCATE(AFID(0:NRADMEM,0:LMAXTMEM))
	ALLOCATE(AFIP(0:NRADMEM,0:LMAXTMEM))
	ALLOCATE(AFIDP(0:NRADMEM,0:LMAXTMEM))
	ALLOCATE(AFIDDS(0:LMAXTMEM))
	ALLOCATE(AFIDDPS(0:LMAXTMEM))
C  *** CALCULATE VARIATION OF THE MATRIX ELEMENTS ***
      DO 5000 IORBS=1,NORBS          !!! over iorbs
      DO 4000 IUPDN=1,NSPIN          !!! over ispin
	DO 3000 IATOM=1,NATOM          !!! over atoms
	ISORT=IS(IATOM)
	DO ISPIN=1,NSPIN
	DO IRAD=0,NRAD(ISORT)
	IF(LDLF.EQ.2)DVT(IRAD)=DPOTRWF(IRAD,IATOM,ISPIN,MY,INUC)
	IF(LDLF.EQ.1)DVT(IRAD)=(0.D0,0.D0)
	ENDDO
C  Find FIny and FIny-dot radial functions as well as their variations
	DO IKAP=1,NKAP(IPAN)           !!! over energies
	CALL LIB_RADSCH_PHIS(ENY(0,ISORT,IKAP,IPAN,ISPIN),
     &  AFI,AFIP,AFID,AFIDP,AFIDDS,AFIDDPS,SMT(ISORT),
     &  POTRWF(0,ISORT,ISPIN),ILST(ISORT),
     &  NRAD(ISORT),H(ISORT),R(0,ISORT),DR(0,ISORT),LRTV(ISORT))
	CALL LIB_DRADSCH_PHIS(ENY(0,ISORT,IKAP,IPAN,ISPIN),
     &  DELENY(0,IKAP,IATOM,ISPIN,MY,INUC),
     &  DFI,DFID,DFIP,DFIDP,DFIDDS,DFIDDPS,SMT(ISORT),
     &  POTRWF(0,ISORT,ISPIN),DVT(0),ILST(ISORT),NRAD(ISORT),
     &  H(ISORT),R(0,ISORT),DR(0,ISORT),LRTV(ISORT))
C  Transfere to FIH,FIJ,DELFIH,DELFIJ convinient functions:
	DO L=0,ILST(ISORT)
	DO IRAD=0,NRAD(ISORT)
	FIH(IRAD,L,IKAP,ISPIN)=
     &  AAH(L,ISORT,IKAP,IPAN,ISPIN)*AFI (IRAD,L)+
     &  BBH(L,ISORT,IKAP,IPAN,ISPIN)*AFIP(IRAD,L)
	FIJ(IRAD,L,IKAP,ISPIN)=
     &  AAJ(L,ISORT,IKAP,IPAN,ISPIN)*AFI (IRAD,L)+
     &  BBJ(L,ISORT,IKAP,IPAN,ISPIN)*AFIP(IRAD,L)
	DELFIH(IRAD,L,1,IKAP,ISPIN)=
     &  DELAAH(L,IKAP,IATOM,ISPIN,1,MY,INUC)*AFI(IRAD,L)+
     &  DELBBH(L,IKAP,IATOM,ISPIN,1,MY,INUC)*AFIP(IRAD,L)+
     &  AAH(L,ISORT,IKAP,IPAN,ISPIN)*DFI (IRAD,L)+
     &  BBH(L,ISORT,IKAP,IPAN,ISPIN)*DFIP(IRAD,L)
	DELFIH(IRAD,L,2,IKAP,ISPIN)=
     &  DELAAH(L,IKAP,IATOM,ISPIN,2,MY,INUC)*AFI (IRAD,L)+
     &  DELBBH(L,IKAP,IATOM,ISPIN,2,MY,INUC)*AFIP(IRAD,L)+
     &  CONJG(AAH(L,ISORT,IKAP,IPAN,ISPIN))*DFI (IRAD,L)+
     &  CONJG(BBH(L,ISORT,IKAP,IPAN,ISPIN))*DFIP(IRAD,L)
	DELFIJ(IRAD,L,1,IKAP,ISPIN)=
     &  DELAAJ(L,IKAP,IATOM,ISPIN,1,MY,INUC)*AFI (IRAD,L)+
     &  DELBBJ(L,IKAP,IATOM,ISPIN,1,MY,INUC)*AFIP(IRAD,L)+
     &  AAJ(L,ISORT,IKAP,IPAN,ISPIN)*DFI (IRAD,L)+
     &  BBJ(L,ISORT,IKAP,IPAN,ISPIN)*DFIP(IRAD,L)
	DELFIJ(IRAD,L,2,IKAP,ISPIN)=
     &  DELAAJ(L,IKAP,IATOM,ISPIN,2,MY,INUC)*AFI (IRAD,L)+
     &  DELBBJ(L,IKAP,IATOM,ISPIN,2,MY,INUC)*AFIP(IRAD,L)+
     &  CONJG(AAJ(L,ISORT,IKAP,IPAN,ISPIN))*DFI (IRAD,L)+
     &  CONJG(BBJ(L,ISORT,IKAP,IPAN,ISPIN))*DFIP(IRAD,L)
      ENDDO   
      ENDDO   
      ENDDO                          !!! over energies
      ENDDO                          !!! over energies
	IF(IORBS.EQ.1)THEN
	IUPDN1=IUPDN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	SIGNF=1.D0
	ELSEIF(IORBS.EQ.2)THEN
	IUPDN1=NSPIN+1-IUPDN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	IF(ISPIN1.EQ.1.AND.ISPIN.EQ.2)SIGNF=-SQRT(2.D0) ! B^{+} * <S_{+}>
	IF(ISPIN1.EQ.2.AND.ISPIN.EQ.1)SIGNF=+SQRT(2.D0) ! B^{-} * <S_{-}>
	ENDIF
	DO 2000 IKAP1=1,NKAP(IPAN)     !!! over ikap1
	DO 1000 IKAP=1,NKAP(IPAN)      !!! over ikap
C  CALCULATE DIFFERENT RADIAL MATRIX ELEMENTS
	DO L1=0,ILST(ISORT)            !!! over l1
	LOG1=.FALSE.
	IF(LTPAN(L1,IATOM,IKAP1,IPAN))LOG1=.TRUE.
	DO L=0,ILST(ISORT)             !!! over l
	LOG=.FALSE.
	IF(LTPAN(L,IATOM,IKAP,IPAN))LOG=.TRUE.
	DO L2=ABS(L1-L),L1+L,2         !!! over l2
	IF(L2.LE.ILSV(ISORT))THEN
	DO M2=-L2,L2                   !!! over m2
	L2M2=L2*(L2+1)+M2+1
	RADMAT(1,L1,L,L2M2)=(0.D0,0.D0)
	RADMAT(2,L1,L,L2M2)=(0.D0,0.D0)
	RADMAT(3,L1,L,L2M2)=(0.D0,0.D0)
	RADMAT(4,L1,L,L2M2)=(0.D0,0.D0)
	IF(SYM(L2M2,IATOM))THEN
	ISYM=LMSYM(L2M2,IATOM)
	IF(LOG1.AND.LOG)THEN
	DO IRAD=0,NRAD(ISORT)          !!! over radial mesh
	WORK1(IRAD)=
     &(DELFIH(IRAD,L1,2,IKAP1,ISPIN1)*FIH(IRAD,L,IKAP,ISPIN)+
     &CONJG(FIH(IRAD,L1,IKAP1,ISPIN1))*DELFIH(IRAD,L,1,IKAP,ISPIN))*
     &POT(IRAD,ISYM,IATOM,IUPDN1,IORBS)*
     &R(IRAD,ISORT)**2*DR(IRAD,ISORT)
      ENDDO                          !!! over radial mesh
	CALL LIB_CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	RADMAT(1,L1,L,L2M2)=RADMAT(1,L1,L,L2M2)+
     &WORK2(NRAD(ISORT))*SIGNF
	ENDIF
	IF(LOG)THEN
	DO IRAD=0,NRAD(ISORT)          !!! over radial mesh
	WORK1(IRAD)=
     &(DELFIJ(IRAD,L1,2,IKAP1,ISPIN1)*FIH(IRAD,L,IKAP,ISPIN)+
     &CONJG(FIJ(IRAD,L1,IKAP1,ISPIN1))*DELFIH(IRAD,L,1,IKAP,ISPIN))*
     &POT(IRAD,ISYM,IATOM,IUPDN1,IORBS)*
     &R(IRAD,ISORT)**2*DR(IRAD,ISORT)
      ENDDO                          !!! over radial mesh
	CALL LIB_CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	RADMAT(2,L1,L,L2M2)=RADMAT(2,L1,L,L2M2)+
     &WORK2(NRAD(ISORT))*SIGNF
	ENDIF
	IF(LOG1)THEN
	DO IRAD=0,NRAD(ISORT)          !!! over radial mesh
	WORK1(IRAD)=
     &(DELFIH(IRAD,L1,2,IKAP1,ISPIN1)*FIJ(IRAD,L,IKAP,ISPIN)+
     &CONJG(FIH(IRAD,L1,IKAP1,ISPIN1))*DELFIJ(IRAD,L,1,IKAP,ISPIN))*
     &POT(IRAD,ISYM,IATOM,IUPDN1,IORBS)*
     &R(IRAD,ISORT)**2*DR(IRAD,ISORT)
      ENDDO                          !!! over radial mesh
	CALL LIB_CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	RADMAT(3,L1,L,L2M2)=RADMAT(3,L1,L,L2M2)+
     &WORK2(NRAD(ISORT))*SIGNF
	ENDIF
	DO IRAD=0,NRAD(ISORT)          !!! over radial mesh
	WORK1(IRAD)=
     &(DELFIJ(IRAD,L1,2,IKAP1,ISPIN1)*FIJ(IRAD,L,IKAP,ISPIN)+
     &CONJG(FIJ(IRAD,L1,IKAP1,ISPIN1))*DELFIJ(IRAD,L,1,IKAP,ISPIN))*
     &POT(IRAD,ISYM,IATOM,IUPDN1,IORBS)*
     &R(IRAD,ISORT)**2*DR(IRAD,ISORT)
      ENDDO                          !!! over radial mesh
	CALL LIB_CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	RADMAT(4,L1,L,L2M2)=RADMAT(4,L1,L,L2M2)+
     &WORK2(NRAD(ISORT))*SIGNF
	ENDIF
	IF(LOG1.AND.LOG)THEN
	DO IRAD=0,NRAD(ISORT)          !!! over radial mesh
	WORK1(IRAD)=
     &CONJG(FIH(IRAD,L1,IKAP1,ISPIN1))*FIH(IRAD,L,IKAP,ISPIN)*
     &DPOT(IRAD,L2M2,IATOM,IUPDN1,IORBS)*
     &R(IRAD,ISORT)**2*DR(IRAD,ISORT)
      ENDDO                          !!! over radial mesh
	CALL LIB_CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	RADMAT(1,L1,L,L2M2)=RADMAT(1,L1,L,L2M2)+
     &WORK2(NRAD(ISORT))*SIGNF
	ENDIF
	IF(LOG)THEN
	DO IRAD=0,NRAD(ISORT)          !!! over radial mesh
	WORK1(IRAD)=
     &CONJG(FIJ(IRAD,L1,IKAP1,ISPIN1))*FIH(IRAD,L,IKAP,ISPIN)*
     &DPOT(IRAD,L2M2,IATOM,IUPDN1,IORBS)*
     &R(IRAD,ISORT)**2*DR(IRAD,ISORT)
      ENDDO                          !!! over radial mesh
	CALL LIB_CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	RADMAT(2,L1,L,L2M2)=RADMAT(2,L1,L,L2M2)+
     &WORK2(NRAD(ISORT))*SIGNF
	ENDIF
	IF(LOG1)THEN
	DO IRAD=0,NRAD(ISORT)          !!! over radial mesh
	WORK1(IRAD)=
     &CONJG(FIH(IRAD,L1,IKAP1,ISPIN1))*FIJ(IRAD,L,IKAP,ISPIN)*
     &DPOT(IRAD,L2M2,IATOM,IUPDN1,IORBS)*
     &R(IRAD,ISORT)**2*DR(IRAD,ISORT)
      ENDDO                          !!! over radial mesh
	CALL LIB_CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	RADMAT(3,L1,L,L2M2)=RADMAT(3,L1,L,L2M2)+
     &WORK2(NRAD(ISORT))*SIGNF
	ENDIF
	DO IRAD=0,NRAD(ISORT)          !!! over radial mesh
	WORK1(IRAD)=
     &CONJG(FIJ(IRAD,L1,IKAP1,ISPIN1))*FIJ(IRAD,L,IKAP,ISPIN)*
     &DPOT(IRAD,L2M2,IATOM,IUPDN1,IORBS)*
     &R(IRAD,ISORT)**2*DR(IRAD,ISORT)
      ENDDO                          !!! over radial mesh
	CALL LIB_CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	RADMAT(4,L1,L,L2M2)=RADMAT(4,L1,L,L2M2)+
     &WORK2(NRAD(ISORT))*SIGNF
      ENDDO                          !!! over m2
	ENDIF
      ENDDO                          !!! over l2
      ENDDO                          !!! over l
      ENDDO                          !!! over l1
C  CALCULATE NMT-POTENTIAL PARAMETER VARIATIONS
	DO L1=0,ILST(ISORT)            !!! over l1
	LOG1=.FALSE.
	IF(LTPAN(L1,IATOM,IKAP1,IPAN))LOG1=.TRUE.
	DO M1=-L1,L1                   !!! over m1
	L1M1=L1*(L1+1)+M1+1
	DO L=0,ILST(ISORT)             !!! over l
	LOG=.FALSE.
	IF(LTPAN(L,IATOM,IKAP,IPAN))LOG=.TRUE.
	DO M=-L,L                      !!! over m
	LM=L*(L+1)+M+1
	IF(LOG1.AND.LOG)
     &DELHHH(L1M1,LM,IATOM,IKAP1,IKAP)=(0.D0,0.D0)
	IF(LOG )DELHJH(L1M1,LM,IATOM,IKAP1,IKAP)=(0.D0,0.D0)
	IF(LOG1)DELHHJ(L1M1,LM,IATOM,IKAP1,IKAP)=(0.D0,0.D0)
	DELHJJ(L1M1,LM,IATOM,IKAP1,IKAP)=(0.D0,0.D0)
	IF(L1M1.EQ.LM.AND.ISPIN1.EQ.ISPIN)THEN       !!! add diagonal HMT-parameters
	IF(LOG1.AND.LOG)
     &DELHHH(LM,LM,IATOM,IKAP1,IKAP)=
     &DELHHH(LM,LM,IATOM,IKAP1,IKAP)+
     &DHMTHH(IKAP1,IKAP,L,IATOM,ISPIN)
	IF(LOG)
     &DELHJH(LM,LM,IATOM,IKAP1,IKAP)=
     &DELHJH(LM,LM,IATOM,IKAP1,IKAP)+
     &DHMTJH(IKAP1,IKAP,L,IATOM,ISPIN)
	IF(LOG1)
     &DELHHJ(LM,LM,IATOM,IKAP1,IKAP)=
     &DELHHJ(LM,LM,IATOM,IKAP1,IKAP)+
     &DHMTHJ(IKAP1,IKAP,L,IATOM,ISPIN)
	DELHJJ(LM,LM,IATOM,IKAP1,IKAP)=
     &DELHJJ(LM,LM,IATOM,IKAP1,IKAP)+
     &DHMTJJ(IKAP1,IKAP,L,IATOM,ISPIN)
	ENDIF
	DO L2=ABS(L1-L),L1+L,2        !!! over l2
	LL2=L2/2
	M2=M1-M
	L2M2=L2*(L2+1)+M2+1
      IF(ABS(M2).LE.L2.AND.L2.LE.ILSV(ISORT))THEN
	IF(.NOT.(L2.EQ.0.AND.LDLF.EQ.2))THEN
	IF(LOG1.AND.LOG)
     &DELHHH(L1M1,LM,IATOM,IKAP1,IKAP)=
     &DELHHH(L1M1,LM,IATOM,IKAP1,IKAP)+
     &(0.D0,1.D0)**(L2+L-L1)*C(LL2,L1M1,LM)*RADMAT(1,L1,L,L2M2)
	IF(LOG)
     &DELHJH(L1M1,LM,IATOM,IKAP1,IKAP)=
     &DELHJH(L1M1,LM,IATOM,IKAP1,IKAP)+
     &(0.D0,1.D0)**(L2+L-L1)*C(LL2,L1M1,LM)*
     &RADMAT(2,L1,L,L2M2)*GAM(L1,ISORT)
	IF(LOG1)
     &DELHHJ(L1M1,LM,IATOM,IKAP1,IKAP)=
     &DELHHJ(L1M1,LM,IATOM,IKAP1,IKAP)+
     &(0.D0,1.D0)**(L2+L-L1)*C(LL2,L1M1,LM)*
     &RADMAT(3,L1,L,L2M2)*GAM(L,ISORT)
	DELHJJ(L1M1,LM,IATOM,IKAP1,IKAP)=
     &DELHJJ(L1M1,LM,IATOM,IKAP1,IKAP)+
     &(0.D0,1.D0)**(L2+L-L1)*C(LL2,L1M1,LM)*RADMAT(4,L1,L,L2M2)*
     &GAM(L1,ISORT)*GAM(L,ISORT)
	ENDIF                          !!! over m2
	ENDIF
      ENDDO                          !!! over l2
      ENDDO                          !!! over m
      ENDDO                          !!! over l
      ENDDO                          !!! over m1
      ENDDO                          !!! over l1
 1000 CONTINUE                       !!! over ikap
 2000 CONTINUE                       !!! over ikap1
 3000 CONTINUE                       !!! over atoms
	CALL NMTFILES(MY,INUC,IPAN,IUPDN,IORBS,IUDMT,'W')
 4000 CONTINUE                       !!! over ispin
 5000 CONTINUE                       !!! over iorbs
C STORE DATA
C Memory deallocations
	DEALLOCATE(DELFIH,DELFIJ,FIH,FIJ,RADMAT,WORK1,WORK2)
	DEALLOCATE(DVT,DFI,DFID,DFIP,DFIDP,DFIDDS,DFIDDPS,AFI,AFID)
	DEALLOCATE(AFIP,AFIDP,AFIDDS,AFIDDPS)
	END



