	SUBROUTINE DEL_DSOVRPAR(MY,INUC,IPAN,IQPNT)
***************************************************************
*   Calculate potential parameter variation of the NMT-       *
*   contribution to the hamiltonian matrix.                   *
***************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
     &                       ,LRTV
	USE COM_RADMESH, ONLY : NRAD,H,R,DR,WEIGHT                         !!! from radmsh
	USE COM_LRTCOM,  ONLY : LDLF                                       !!! from readlrt
	USE COM_PANPAR,  ONLY : LTPAN,LSPAN,IATS,ISTS                      !!! from readini
	USE COM_SPHERE,  ONLY : SWZ,SMT                                    !!! from readini
	USE COM_SYMMLM,  ONLY : SYM,LMSYM                                  !!! from makesym
      USE COM_INPPAR,  ONLY : TNY,ENY,DNY                                !!! from readini
	USE COM_DINPPAR, ONLY : DELENY                                     !!! from dinppar
	USE COM_POTDAT,  ONLY : POT,POTRWF                                 !!! from fulpot
	USE COM_KAPPAR,  ONLY : NPAN,NKAP,EK,EKAP                          !!! from readini
	USE COM_LMTPAR,  ONLY : GAM,AAH,BBH,AAJ,BBJ                        !!! from potpar
	USE COM_DLMTPAR, ONLY : DELAAH,DELBBH,DELAAJ,DELBBJ                !!! from dpotpar
	USE COM_DMTSPAR, ONLY : DOMTHH,DOMTJH,DOMTHJ,DOMTJJ                !!! from intpar
	USE COM_DOVRPAR, ONLY : DELOHH,DELOJH,DELOHJ,DELOJJ                !!! from intpar
	USE COM_DELPOT,  ONLY : DPOT,DPOTRWF                               !!! from delpot
	USE COM_GAUNT,   ONLY : C                                          !!! from makegnt
	USE COM_MASHDEP, ONLY : NVAL                                       !!! from setup
	USE COM_PHNCHN  ,ONLY : IUDMT                                      !!! from channels
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16, ALLOCATABLE :: WORK1(:)
      COMPLEX*16, ALLOCATABLE :: WORK2(:)
	COMPLEX*16, ALLOCATABLE :: DELFIH(:,:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: DELFIJ(:,:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: FIH(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: FIJ(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: DVT(:)
	COMPLEX*16, ALLOCATABLE :: DFI(:,:) 
	COMPLEX*16, ALLOCATABLE :: DFID(:,:)
	COMPLEX*16, ALLOCATABLE :: DFIP(:,:)
	COMPLEX*16, ALLOCATABLE :: DFIDP(:,:)
	COMPLEX*16, ALLOCATABLE :: DFIDDS(:)
	COMPLEX*16, ALLOCATABLE :: DFIDDPS(:)
	REAL*8, ALLOCATABLE :: AFI(:,:)
	REAL*8, ALLOCATABLE :: AFID(:,:)
	REAL*8, ALLOCATABLE :: AFIP(:,:)
	REAL*8, ALLOCATABLE :: AFIDP(:,:)
	REAL*8, ALLOCATABLE :: AFIDDS(:)
	REAL*8, ALLOCATABLE :: AFIDDPS(:)
	LOGICAL LOG1,LOG,EXIST
	DATA PI/3.141592653589793D0/
C Memory allocations
      ALLOCATE(WORK1(0:NRADMEM))
      ALLOCATE(WORK2(0:NRADMEM))
	ALLOCATE(DELFIH(0:NRADMEM,0:LMAXTMEM,2,NKAPMEM,NSPINMEM))
	ALLOCATE(DELFIJ(0:NRADMEM,0:LMAXTMEM,2,NKAPMEM,NSPINMEM))
	ALLOCATE(FIH(0:NRADMEM,0:LMAXTMEM,NKAPMEM,NSPINMEM))
	ALLOCATE(FIJ(0:NRADMEM,0:LMAXTMEM,NKAPMEM,NSPINMEM))
	ALLOCATE(DVT(0:NRADMEM))
	ALLOCATE(DFI(0:NRADMEM,0:LMAXTMEM))
	ALLOCATE(DFID(0:NRADMEM,0:LMAXTMEM))
	ALLOCATE(DFIP(0:NRADMEM,0:LMAXTMEM))
	ALLOCATE(DFIDP(0:NRADMEM,0:LMAXTMEM))
	ALLOCATE(DFIDDS(0:LMAXTMEM))
	ALLOCATE(DFIDDPS(0:LMAXTMEM))
	ALLOCATE(AFI(0:NRADMEM,0:LMAXTMEM))
	ALLOCATE(AFID(0:NRADMEM,0:LMAXTMEM))
	ALLOCATE(AFIP(0:NRADMEM,0:LMAXTMEM))
	ALLOCATE(AFIDP(0:NRADMEM,0:LMAXTMEM))
	ALLOCATE(AFIDDS(0:LMAXTMEM))
	ALLOCATE(AFIDDPS(0:LMAXTMEM))
C  *** CALCULATE VARIATION OF THE MATRIX ELEMENTS ***
      DO 5000 IORBS=1,NORBS          !!! over iorbs
      DO 4000 IUPDN=1,NSPIN          !!! over ispin
	DO 3000 IATOM=1,NATOM          !!! over atoms
	ISORT=IS(IATOM)
	DO ISPIN=1,NSPIN
	DO IRAD=0,NRAD(ISORT)
	IF(LDLF.EQ.2)DVT(IRAD)=DPOTRWF(IRAD,IATOM,ISPIN,MY,INUC)
	IF(LDLF.EQ.1)DVT(IRAD)=(0.D0,0.D0)
	ENDDO
C  Find FIny and FIny-dot radial functions as well as their variations
	DO IKAP=1,NKAP(IPAN)           !!! over energies
	CALL LIB_RADSCH_PHIS(ENY(0,ISORT,IKAP,IPAN,ISPIN),
     &  AFI,AFIP,AFID,AFIDP,AFIDDS,AFIDDPS,SMT(ISORT),
     &  POTRWF(0,ISORT,ISPIN),ILST(ISORT),
     &  NRAD(ISORT),H(ISORT),R(0,ISORT),DR(0,ISORT),LRTV(ISORT))
	CALL LIB_DRADSCH_PHIS(ENY(0,ISORT,IKAP,IPAN,ISPIN),
     &  DELENY(0,IKAP,IATOM,ISPIN,MY,INUC),
     &  DFI,DFID,DFIP,DFIDP,DFIDDS,DFIDDPS,SMT(ISORT),
     &  POTRWF(0,ISORT,ISPIN),DVT(0),ILST(ISORT),NRAD(ISORT),
     &  H(ISORT),R(0,ISORT),DR(0,ISORT),LRTV(ISORT))
C  Transfere to FIH,FIJ,DELFIH,DELFIJ convinient functions:
	DO L=0,ILST(ISORT)
	DO IRAD=0,NRAD(ISORT)
	FIH(IRAD,L,IKAP,ISPIN)=
     &  AAH(L,ISORT,IKAP,IPAN,ISPIN)*AFI (IRAD,L)+
     &  BBH(L,ISORT,IKAP,IPAN,ISPIN)*AFIP(IRAD,L)
	FIJ(IRAD,L,IKAP,ISPIN)=
     &  AAJ(L,ISORT,IKAP,IPAN,ISPIN)*AFI (IRAD,L)+
     &  BBJ(L,ISORT,IKAP,IPAN,ISPIN)*AFIP(IRAD,L)
	DELFIH(IRAD,L,1,IKAP,ISPIN)=
     &  DELAAH(L,IKAP,IATOM,ISPIN,1,MY,INUC)*AFI(IRAD,L)+
     &  DELBBH(L,IKAP,IATOM,ISPIN,1,MY,INUC)*AFIP(IRAD,L)+
     &  AAH(L,ISORT,IKAP,IPAN,ISPIN)*DFI (IRAD,L)+
     &  BBH(L,ISORT,IKAP,IPAN,ISPIN)*DFIP(IRAD,L)
	DELFIH(IRAD,L,2,IKAP,ISPIN)=
     &  DELAAH(L,IKAP,IATOM,ISPIN,2,MY,INUC)*AFI (IRAD,L)+
     &  DELBBH(L,IKAP,IATOM,ISPIN,2,MY,INUC)*AFIP(IRAD,L)+
     &  CONJG(AAH(L,ISORT,IKAP,IPAN,ISPIN))*DFI (IRAD,L)+
     &  CONJG(BBH(L,ISORT,IKAP,IPAN,ISPIN))*DFIP(IRAD,L)
	DELFIJ(IRAD,L,1,IKAP,ISPIN)=
     &  DELAAJ(L,IKAP,IATOM,ISPIN,1,MY,INUC)*AFI (IRAD,L)+
     &  DELBBJ(L,IKAP,IATOM,ISPIN,1,MY,INUC)*AFIP(IRAD,L)+
     &  AAJ(L,ISORT,IKAP,IPAN,ISPIN)*DFI (IRAD,L)+
     &  BBJ(L,ISORT,IKAP,IPAN,ISPIN)*DFIP(IRAD,L)
	DELFIJ(IRAD,L,2,IKAP,ISPIN)=
     &  DELAAJ(L,IKAP,IATOM,ISPIN,2,MY,INUC)*AFI (IRAD,L)+
     &  DELBBJ(L,IKAP,IATOM,ISPIN,2,MY,INUC)*AFIP(IRAD,L)+
     &  CONJG(AAJ(L,ISORT,IKAP,IPAN,ISPIN))*DFI (IRAD,L)+
     &  CONJG(BBJ(L,ISORT,IKAP,IPAN,ISPIN))*DFIP(IRAD,L)
      ENDDO   
      ENDDO   
      ENDDO                          !!! over energies
      ENDDO                          !!! over energies
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
	DO 2000 IKAP1=1,NKAP(IPAN)     !!! over ikap1
	DO 1000 IKAP=1,NKAP(IPAN)      !!! over ikap
C  CALCULATE DIFFERENT RADIAL MATRIX ELEMENTS
	DO L=0,ILST(ISORT)             !!! over l
	LOG=.FALSE.
	IF(LTPAN(L,IATOM,IKAP,IPAN))LOG=.TRUE.
	IF(L.LE.LMAXBMEM)THEN
	DELOHH(IKAP1,IKAP,L,IATOM,IUPDN,IORBS)=(0.D0,0.D0)
	DELOHJ(IKAP1,IKAP,L,IATOM,IUPDN,IORBS)=(0.D0,0.D0)
	DELOJH(IKAP1,IKAP,L,IATOM,IUPDN,IORBS)=(0.D0,0.D0)
	ENDIF
	DELOJJ(IKAP1,IKAP,L,IATOM,IUPDN,IORBS)=(0.D0,0.D0)
	IF(LOG)THEN
	DO IRAD=0,NRAD(ISORT)          !!! over radial mesh
	WORK1(IRAD)=(DELFIH(IRAD,L,2,IKAP1,ISPIN1)*FIH(IRAD,L,IKAP,ISPIN)+
     &  CONJG(FIH(IRAD,L,IKAP1,ISPIN1))*DELFIH(IRAD,L,1,IKAP,ISPIN))*
     &  R(IRAD,ISORT)**2*DR(IRAD,ISORT)
        ENDDO                          !!! over radial mesh
	CALL LIB_CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	DELOHH(IKAP1,IKAP,L,IATOM,IUPDN,IORBS)=WORK2(NRAD(ISORT))
	IF(ISPIN1.EQ.ISPIN)DELOHH(IKAP1,IKAP,L,IATOM,IUPDN,IORBS)=
     &DOMTHH(IKAP1,IKAP,L,IATOM,ISPIN)
	ENDIF
	IF(LOG)THEN
	DO IRAD=0,NRAD(ISORT)          !!! over radial mesh
	WORK1(IRAD)=(DELFIJ(IRAD,L,2,IKAP1,ISPIN1)*FIH(IRAD,L,IKAP,ISPIN)+
     &  CONJG(FIJ(IRAD,L,IKAP1,ISPIN1))*DELFIH(IRAD,L,1,IKAP,ISPIN))*
     &  R(IRAD,ISORT)**2*DR(IRAD,ISORT)
      ENDDO                          !!! over radial mesh
	CALL LIB_CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	DELOJH(IKAP1,IKAP,L,IATOM,IUPDN,IORBS)=WORK2(NRAD(ISORT))
	IF(ISPIN1.EQ.ISPIN)DELOJH(IKAP1,IKAP,L,IATOM,IUPDN,IORBS)=
     &DOMTJH(IKAP1,IKAP,L,IATOM,ISPIN)
	ENDIF
	IF(LOG)THEN
	DO IRAD=0,NRAD(ISORT)          !!! over radial mesh
	WORK1(IRAD)=(DELFIH(IRAD,L,2,IKAP1,ISPIN1)*FIJ(IRAD,L,IKAP,ISPIN)+
     &  CONJG(FIH(IRAD,L,IKAP1,ISPIN1))*DELFIJ(IRAD,L,1,IKAP,ISPIN))*
     &  R(IRAD,ISORT)**2*DR(IRAD,ISORT)
      ENDDO                          !!! over radial mesh
	CALL LIB_CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	DELOHJ(IKAP1,IKAP,L,IATOM,IUPDN,IORBS)=WORK2(NRAD(ISORT))
	IF(ISPIN1.EQ.ISPIN)DELOHJ(IKAP1,IKAP,L,IATOM,IUPDN,IORBS)=
     &DOMTHJ(IKAP1,IKAP,L,IATOM,ISPIN)
	ENDIF
	DO IRAD=0,NRAD(ISORT)          !!! over radial mesh
	WORK1(IRAD)=(DELFIJ(IRAD,L,2,IKAP1,ISPIN1)*FIJ(IRAD,L,IKAP,ISPIN)+
     &  CONJG(FIJ(IRAD,L,IKAP1,ISPIN1))*DELFIJ(IRAD,L,1,IKAP,ISPIN))*
     &  R(IRAD,ISORT)**2*DR(IRAD,ISORT)
      ENDDO                          !!! over radial mesh
	CALL LIB_CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	DELOJJ(IKAP1,IKAP,L,IATOM,IUPDN,IORBS)=WORK2(NRAD(ISORT))
	IF(ISPIN1.EQ.ISPIN)DELOJJ(IKAP1,IKAP,L,IATOM,IUPDN,IORBS)=
     &DOMTJJ(IKAP1,IKAP,L,IATOM,ISPIN)
      ENDDO                          !!! over l
 1000 CONTINUE                       !!! over ikap
 2000 CONTINUE                       !!! over ikap1
 3000 CONTINUE                       !!! over atoms
	CALL NMTFILES(MY,INUC,IPAN,IUPDN,IORBS,IUDMT,'W')
 4000 CONTINUE                       !!! over ispin
 5000 CONTINUE                       !!! over iorbs
C STORE DATA
C Memory deallocations
	DEALLOCATE(DELFIH,DELFIJ,FIH,FIJ,WORK1,WORK2)
	DEALLOCATE(DVT,DFI,DFID,DFIP,DFIDP,DFIDDS,DFIDDPS,AFI,AFID)
	DEALLOCATE(AFIP,AFIDP,AFIDDS,AFIDDPS)
	END



