	SUBROUTINE DEL_DSPOTPAR(MY,INUC,IPAN,IQPNT)
****************************************************************
*  Subroutine calculates change in the potential parameters.   *
*  Written by S.Yu.Savrasov in Max-Planck-Institute,Germany.   *
****************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT                                       !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,LRTV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_RADMESH, ONLY : NRAD,H,R,DR                                !!! from makerad
	USE COM_PANPAR,  ONLY : LTPAN,LSPAN,IATS,ISTS                      !!! from readini
	USE COM_LRTCOM,  ONLY : LDLF                                       !!! from readlrt
	USE COM_POTPAR,  ONLY : FF,FFP,FPF,FPFP                            !!! from potpar
      USE COM_INPPAR,  ONLY : TNY,ENY,DNY,NODES,MNY                      !!! from readini
	USE COM_DINPPAR, ONLY : DELENY,DELDNY                              !!! from dinppar
	USE COM_DPOTPAR, ONLY : DELFF,DELFFP,DELFPF,DELFPFP                !!! from dpotpar
	USE COM_DLMTPAR, ONLY : DELAAH,DELBBH,DELAAJ,DELBBJ                !!! from dpotpar
	USE COM_SPHERE,  ONLY : SWZ,SMT                                    !!! from readini
	USE COM_KAPPAR,  ONLY : NPAN,NKAP,EK,EKAP                          !!! from readini
	USE COM_DELPOT,  ONLY : DPOTRWF                                    !!! from delpot
	USE COM_POTDAT,  ONLY : POTRWF                                     !!! from fulpot
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: HAN(:,:)
	COMPLEX*16, ALLOCATABLE :: BES(:,:)
	COMPLEX*16, ALLOCATABLE :: DFPMN(:)
	COMPLEX*16, ALLOCATABLE :: DVT(:)
	COMPLEX*16, ALLOCATABLE :: DFIS(:,:)
	COMPLEX*16, ALLOCATABLE :: DFIDS(:,:)
	COMPLEX*16, ALLOCATABLE :: DFIPS(:,:)
	COMPLEX*16, ALLOCATABLE :: DFIDPS(:,:)
	REAL*8, ALLOCATABLE :: AFIS(:,:)
	REAL*8, ALLOCATABLE :: AFIDS(:,:)
	REAL*8, ALLOCATABLE ::AFIPS(:,:)
	REAL*8, ALLOCATABLE ::AFIDPS(:,:)
	REAL*8, ALLOCATABLE ::FPMN(:)
	REAL*8, ALLOCATABLE ::DNYP(:,:)
	DATA PI/3.141592653589793D0/
C Memory allocations
	ALLOCATE(HAN(3,0:LMAXTMEM))
	ALLOCATE(BES(3,0:LMAXTMEM))
	ALLOCATE(DFPMN(0:LMAXTMEM))
	ALLOCATE(DVT(0:NRADMEM))
	ALLOCATE(DFIS(0:LMAXTMEM,NKAPMEM))
	ALLOCATE(DFIDS(0:LMAXTMEM,NKAPMEM))
	ALLOCATE(DFIPS(0:LMAXTMEM,NKAPMEM))
	ALLOCATE(DFIDPS(0:LMAXTMEM,NKAPMEM))
	ALLOCATE(AFIS(0:LMAXTMEM,NKAPMEM))
	ALLOCATE(AFIDS(0:LMAXTMEM,NKAPMEM))
	ALLOCATE(AFIPS(0:LMAXTMEM,NKAPMEM))
	ALLOCATE(AFIDPS(0:LMAXTMEM,NKAPMEM))
	ALLOCATE(FPMN(0:LMAXTMEM))
	ALLOCATE(DNYP(0:LMAXTMEM,NKAPMEM))
	DO ISPIN=1,NSPIN                                  !!! over spins
	DO IATOM=1,NATOM                                  !!! over atoms
	ISORT=IS(IATOM)
	DO IKAP=1,NKAP(IPAN)                              !!! over ikap
	CALL LIB_BESSEL(SMT(ISORT),EKAP(IKAP,IPAN),SMT(ISORT),BES,
     &  ILST(ISORT))
	CALL LIB_HANKEL(SMT(ISORT),EKAP(IKAP,IPAN),SMT(ISORT),HAN,
     &  ILST(ISORT))
C  SOLVE LINEARIZED SCHROEDINGER'S EQUATION FOR SET OF ENY
	DO IRAD=0,NRAD(ISORT)
	IF(LDLF.EQ.2)DVT(IRAD)=DPOTRWF(IRAD,IATOM,ISPIN,MY,INUC)
	IF(LDLF.EQ.1)DVT(IRAD)=(0.D0,0.D0)
	ENDDO
	CALL LIB_DRADSCH_PARS(ENY(0,ISORT,IKAP,IPAN,ISPIN),
     &DELENY(0,IKAP,IATOM,ISPIN,MY,INUC),
     &AFIS(0,IKAP),AFIPS(0,IKAP),AFIDS(0,IKAP),
     &AFIDPS(0,IKAP),FPMN,DFIS(0,IKAP),DFIPS(0,IKAP),
     &DFIDS(0,IKAP),DFIDPS(0,IKAP),DFPMN,SMT(ISORT),
     &POTRWF(0,ISORT,ISPIN),DVT(0),ILST(ISORT),
     &NRAD(ISORT),H(ISORT),R(0,ISORT),DR(0,ISORT),LRTV(ISORT))
	DO L=0,ILST(ISORT)                               !!! over l
        AFIDPS(L,IKAP)=AFIPS(L,IKAP)/AFIS(L,IKAP)*(AFIDS(L,IKAP)-
     &  1.D0/(SMT(ISORT)*SMT(ISORT)*AFIPS(L,IKAP)))
C  SET CHANGE IN MAIN POTENTIAL PARAMETERS OF THE FP-LMTO METHOD
	DELDNY(L,IKAP,IATOM,ISPIN,MY,INUC)=
     &  SMT(ISORT)/AFIS(L,IKAP)*(
     &  DFIDS(L,IKAP)-AFIDS(L,IKAP)*DFIS(L,IKAP)/AFIS(L,IKAP))
	DELAAH(L,IKAP,IATOM,ISPIN,1,MY,INUC)=+
     &  SMT(ISORT)*SMT(ISORT)*(
     &  DFIPS(L,IKAP)*HAN(2,L)-DFIDPS(L,IKAP)*HAN(1,L))      !!! +W{d-phidot,H}
	DELAAH(L,IKAP,IATOM,ISPIN,2,MY,INUC)=+
     &  SMT(ISORT)*SMT(ISORT)*(
     &  DFIPS(L,IKAP)*CONJG(HAN(2,L))-DFIDPS(L,IKAP)*CONJG(HAN(1,L)))
	DELAAJ(L,IKAP,IATOM,ISPIN,1,MY,INUC)=+
     &  SMT(ISORT)*SMT(ISORT)*(
     &  DFIPS(L,IKAP)*BES(2,L)-DFIDPS(L,IKAP)*BES(1,L))      !!! +W{d-phidot,J}
	DELAAJ(L,IKAP,IATOM,ISPIN,2,MY,INUC)=+
     &  SMT(ISORT)*SMT(ISORT)*(
     &  DFIPS(L,IKAP)*CONJG(BES(2,L))-DFIDPS(L,IKAP)*CONJG(BES(1,L)))
	DELBBH(L,IKAP,IATOM,ISPIN,1,MY,INUC)=-
     &  SMT(ISORT)*SMT(ISORT)*(
     &  DFIS(L,IKAP)*HAN(2,L)-DFIDS(L,IKAP)*HAN(1,L))        !!! -W{d-phi,H}
	DELBBH(L,IKAP,IATOM,ISPIN,2,MY,INUC)=-
     &  SMT(ISORT)*SMT(ISORT)*(
     &  DFIS(L,IKAP)*CONJG(HAN(2,L))-DFIDS(L,IKAP)*CONJG(HAN(1,L)))
	DELBBJ(L,IKAP,IATOM,ISPIN,1,MY,INUC)=-
     &  SMT(ISORT)*SMT(ISORT)*(
     &  DFIS(L,IKAP)*BES(2,L)-DFIDS(L,IKAP)*BES(1,L))        !!! -W{d-phi,J}
	DELBBJ(L,IKAP,IATOM,ISPIN,2,MY,INUC)=-
     &  SMT(ISORT)*SMT(ISORT)*(
     &  DFIS(L,IKAP)*CONJG(BES(2,L))-DFIDS(L,IKAP)*CONJG(BES(1,L)))
	DNYP(L,IKAP)=DNY(L,ISORT,IKAP,IPAN,ISPIN)-1.D0/(SMT(ISORT)*
     &  AFIS(L,IKAP)*AFIPS(L,IKAP))
C  SET INTEGRALS BETWEEN CHANGE IN RADIAL WAVE FUNCTIONS
C  DIAGONAL ELEMENTS:
	DELFF  (IKAP,IKAP,L,IATOM,ISPIN)=0.D0
	DELFFP (IKAP,IKAP,L,IATOM,ISPIN)=0.D0
	DELFPF (IKAP,IKAP,L,IATOM,ISPIN)=0.D0
	DELFPFP(IKAP,IKAP,L,IATOM,ISPIN)=DFPMN(L)
C  OFF DIAGONAL ELEMENTS:
	DO JKAP=1,IKAP-1                                     !!! over jkap
C  IF ENY'S COINSIDE
	IF(ABS(ENY(L,ISORT,IKAP,IPAN,ISPIN)-ENY(L,ISORT,JKAP,IPAN,ISPIN))
     &  .LE.1.D-05)THEN
	DE1=DELENY(L,IKAP,IATOM,ISPIN,MY,INUC)-
     &  DELENY(L,JKAP,IATOM,ISPIN,MY,INUC)
	DELFF  (IKAP,JKAP,L,IATOM,ISPIN)=0.D0
	DELFFP (IKAP,JKAP,L,IATOM,ISPIN)=+DE1*FPMN(L)
	DELFPF (IKAP,JKAP,L,IATOM,ISPIN)=-DE1*FPMN(L)
	DELFPFP(IKAP,JKAP,L,IATOM,ISPIN)=DFPMN(L)
C  IF ENY'S DIFFER
	ELSE
C  FOR PHI-PHIDOTS
	E1=1.D0/(ENY(L,ISORT,IKAP,IPAN,ISPIN)-
     &  ENY(L,ISORT,JKAP,IPAN,ISPIN))
	WFF=SMT(ISORT)*AFIS(L,IKAP)*AFIS(L,JKAP)*
     &  (DNY(L,ISORT,JKAP,IPAN,ISPIN)-DNY(L,ISORT,IKAP,IPAN,ISPIN))
	WFFP=SMT(ISORT)*AFIS(L,IKAP)*AFIPS(L,JKAP)*
     &  (DNYP(L,JKAP)-DNY(L,ISORT,IKAP,IPAN,ISPIN))
	WFPF=SMT(ISORT)*AFIPS(L,IKAP)*AFIS(L,JKAP)*
     &  (DNY(L,ISORT,JKAP,IPAN,ISPIN)-DNYP(L,IKAP))
	WFPFP=SMT(ISORT)*AFIPS(L,IKAP)*AFIPS(L,JKAP)*
     &  (DNYP(L,JKAP)-DNYP(L,IKAP))
C  FOR PERTURBATIVE FUNCTIONS
	E1=1.D0/(ENY(L,ISORT,IKAP,IPAN,ISPIN)-
     &  ENY(L,ISORT,JKAP,IPAN,ISPIN))
	DE1=-(DELENY(L,IKAP,IATOM,ISPIN,MY,INUC)-
     &  DELENY(L,JKAP,IATOM,ISPIN,MY,INUC))*E1*E1
	DELWFF=SMT(ISORT)**2*(DFIS(L,IKAP)*AFIDS(L,JKAP)-
     &  DFIDS(L,IKAP)*AFIS(L,JKAP)+AFIS(L,IKAP)*DFIDS(L,JKAP)-
     &  AFIDS(L,IKAP)*DFIS(L,JKAP))
	DELWFFP=SMT(ISORT)**2*(DFIS(L,IKAP)*AFIDPS(L,JKAP)-
     &  DFIDS(L,IKAP)*AFIPS(L,JKAP)+AFIS(L,IKAP)*DFIDPS(L,JKAP)-
     &  AFIDS(L,IKAP)*DFIPS(L,JKAP))
	DELWFPF=SMT(ISORT)**2*(DFIPS(L,IKAP)*AFIDS(L,JKAP)-
     &  DFIDPS(L,IKAP)*AFIS(L,JKAP)+AFIPS(L,IKAP)*DFIDS(L,JKAP)-
     &  AFIDPS(L,IKAP)*DFIS(L,JKAP))
	DELWFPFP=SMT(ISORT)**2*(DFIPS(L,IKAP)*AFIDPS(L,JKAP)-
     &  DFIDPS(L,IKAP)*AFIPS(L,JKAP)+AFIPS(L,IKAP)*DFIDPS(L,JKAP)-
     &  AFIDPS(L,IKAP)*DFIPS(L,JKAP))
	DELFF(IKAP,JKAP,L,IATOM,ISPIN)=E1*DELWFF+DE1*WFF
	DELFFP(IKAP,JKAP,L,IATOM,ISPIN)=E1*(DELWFFP+
     &  DELFF(IKAP,JKAP,L,IATOM,ISPIN))+
     &  DE1*(WFFP+FF(IKAP,JKAP,L,ISORT,ISPIN))
	DELFPF (IKAP,JKAP,L,IATOM,ISPIN)=E1*(DELWFPF-
     &  DELFF(IKAP,JKAP,L,IATOM,ISPIN))+
     &  DE1*(WFPF-FF(IKAP,JKAP,L,ISORT,ISPIN))
	DELFPFP(IKAP,JKAP,L,IATOM,ISPIN)=E1*(DELWFPFP+
     &  DELFPF (IKAP,JKAP,L,IATOM,ISPIN)-
     &  DELFFP (IKAP,JKAP,L,IATOM,ISPIN))+
     &  DE1*(WFPFP+FPF(IKAP,JKAP,L,ISORT,ISPIN)-
     &  FFP(IKAP,JKAP,L,ISORT,ISPIN))
	ENDIF
C  ACCOUNT FOR SYMMETRICITY
	DELFF  (JKAP,IKAP,L,IATOM,ISPIN)=DELFF  (IKAP,JKAP,L,IATOM,ISPIN)
	DELFFP (JKAP,IKAP,L,IATOM,ISPIN)=DELFPF (IKAP,JKAP,L,IATOM,ISPIN)
	DELFPF (JKAP,IKAP,L,IATOM,ISPIN)=DELFFP (IKAP,JKAP,L,IATOM,ISPIN)
	DELFPFP(JKAP,IKAP,L,IATOM,ISPIN)=DELFPFP(IKAP,JKAP,L,IATOM,ISPIN)
      ENDDO                                                   !!! over jkap
      ENDDO                                                   !!! over l
      ENDDO                                                   !!! over ikap
      ENDDO                                                   !!! over iatom
      ENDDO                                                   !!! over ispin
C Memory allocations
	DEALLOCATE(HAN,BES,DFPMN,DVT,DFIS,DFIDS,DFIPS,DFIDPS)
	DEALLOCATE(AFIS,AFIDS,AFIPS,AFIDPS,FPMN,DNYP)
	END
