	SUBROUTINE DEL_DTOSINT(MY,INUC,IPNT,ISGQ,IPAN,IQPNT)
***********************************************************
*  Calculate change in the pseudocharge density           *
***********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_LATPAR,  ONLY : PAR,ORTH,OMEGAC                            !!! from readini
	USE COM_KAPPAR,  ONLY : NPAN,NKAP,EK,EKAP                          !!! from readini
	USE COM_PANPAR,  ONLY : LTPAN,LSPAN,IATS,ISTS                      !!! from readini
	USE COM_PLWMESH, ONLY : NPLW,GPLW                                  !!! from makeplw
	USE COM_NBANDS,  ONLY : NBNDF,NBNDE,NBNDT,NBNDC,NBNDH,POLUS        !!! from readini
	USE COM_LATTICE, ONLY : TAU                                        !!! from readstr
	USE COM_SYMMESH, ONLY : IG0IG1,IK0IK1                              !!! from delmesh
	USE COM_GROUPS,  ONLY : NGROUP,INV,IKOV                            !!! from makegrp
	USE COM_ENERGY,  ONLY : ETRT                                       !!! from lmtbnd
	USE COM_KMESH,   ONLY : NPNT,PNT,WGT                               !!! from makettr
	USE COM_ETAPAR,  ONLY : ETA,CUT,LBAS,NBAS                          !!! from makeplw
	USE COM_SUBGROUP,ONLY : NSGQ,NGEQ,ISG                              !!! from delmesh
	USE COM_DPSIVEC, ONLY : PSIK,PSIQ,DPSK,DPSQ,SPSK,PNTK,PNTQ         !!! from d2psivec
	USE COM_PSIVEC,  ONLY : APHK,APJK,APHQ,APJQ                        !!! from lmtvec
	USE COM_DELHAM,  ONLY : DHMAT=>DHMATT,DOMAT=>DOMATT                !!! from delmat
	USE COM_INDORB,  ONLY : INDLMT                                     !!! from readini
	USE COM_QMESH,   ONLY : NQPNT,QPNT                                 !!! from readpnt
	USE COM_DELRHO,  ONLY : DRHOPS                                     !!! from delrho
	USE COM_TEILORG, ONLY : KEYT,BZM,GOPT,MBAS                         !!! from makeplw
	USE COM_MASHDEP, ONLY : NVAL                                       !!! from setup
      USE COM_LMTOUT,  ONLY : SCNFILE                                    !!! from storage
	USE COM_PHNCHN  ,ONLY : IUDRO,IUDPX,IUDRX,IUDPY,IUDRY,IUPDD,IUTTW  !!! from channels
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8, ALLOCATABLE :: WEIGQ(:,:,:)
	REAL*8, ALLOCATABLE :: WEIGK(:,:)
	COMPLEX*16, ALLOCATABLE :: DRINT0Q(:,:)
	COMPLEX*16, ALLOCATABLE :: DRFUN0(:,:)
	COMPLEX*16, ALLOCATABLE :: DRFUNQ(:,:)
	COMPLEX*16, ALLOCATABLE :: TPSK(:)
	COMPLEX*16, ALLOCATABLE :: TPSQ(:)
	COMPLEX*16, ALLOCATABLE :: CHIS(:)
	COMPLEX*16, ALLOCATABLE :: APSI(:)
	COMPLEX*16, ALLOCATABLE :: SPSI(:)
	COMPLEX*16, ALLOCATABLE :: AFUN(:)
	COMPLEX*16, ALLOCATABLE :: SFUN(:)
	COMPLEX*16 EXPK0,RMY,RPY,GMY,EXPK1,CTMP1,CTMP2
	DIMENSION PNTR(3)
	LOGICAL LOG1,LOG,EXIST
	CHARACTER STATUS*3
	DATA PI/3.141592653589793D0/
	IF(MODE.EQ.5)RETURN
C Memory allocations
	ALLOCATE(DRINT0Q(NBNDT(IPAN),NBNDT(IPAN)))
	ALLOCATE(DRFUN0(NBNDT(IPAN),0:MBASMEM))
	ALLOCATE(DRFUNQ(NBNDT(IPAN),0:MBASMEM))
	ALLOCATE(TPSK(0:NBASMEM))
	ALLOCATE(TPSQ(0:NBASMEM))
	ALLOCATE(CHIS(0:NBASMEM))
	ALLOCATE(WEIGK(NBNDC(1)*NSPINMEM,4))
	ALLOCATE(WEIGQ(NBNDC(1)*NSPINMEM,NBNDC(1)*NSPINMEM,6))
	ALLOCATE(APSI(0:NBASMEM))
	ALLOCATE(AFUN(NBNDT(IPAN)))
	ALLOCATE(SPSI(0:NBASMEM))
	ALLOCATE(SFUN(NBNDT(IPAN)))
C  SET POINT-GROUP INFORMATION
	IRK=ISG(1,ISGQ)       !!!  element "g"  in the main G-list
	IGK=IKOV(IRK)         !!!  element "g"  after Kovalev
	IPNTK=IPNT            !!!  point   "k"
	IRQ=IG0IG1(IPNT,IRK)  !!!  element "g'" in the main G-list
	IGQ=IKOV(IRQ)         !!!  element "g'" after Kovalev
	IPNTQ=IK0IK1(IPNT,IRK)!!!  point   "k'" such that g*k+q=g'*k'
C  READ 1/E TETRAHEDRON WEIGHTS FOR BRILLOUIN ZONE INTEGRATION
	IREC=1+IPNTK+NPNT(1)*(ISGQ-1)
	IF(IPAN.EQ.1)THEN
	READ(IUTTW,REC=IREC)WGTQ1,
     &(((WEIGQ(IBANC,IBANC1,IC),IBANC=1,NBNDC(1)*NSPIN),
     &IBANC1=1,NBNDC(1)*NSPIN),IC=1,6),
     &((WEIGK(IBANC,IC),IBANC=1,NBNDC(1)*NSPIN),IC=1,4)
	ELSE ! only geometrical weigths are neccessary
	READ(IUTTW,REC=IREC)WGTQ1
	ENDIF
C  READ DENSITY PARAMETERS
      CALL DRO_DPSFILES(MY,INUC,IQPNT,IUDPY,'R','D',' ')        !!! read density
	NRECL=NVAL*(2*NBNDT(IPAN)*(MIN(NBAS,MBAS)+1)+NBNDT(IPAN)**2)
	OPEN(UNIT=IUPDD,FILE=SCNFILE(MY,INUC,IUPDD),STATUS='OLD',
     &ACCESS='DIRECT',FORM='UNFORMATTED',RECL=NRECL)
C  DO OVER SPINS
	DO 4000 IORBS=1,NORBS                                     !!! over iorbs
	DO 3000 IUPDN=1,NSPIN                                     !!! over iupdn
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	SIGNF=1.D0
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	IF(ISPIN1.EQ.1.AND.ISPIN.EQ.2)SIGNF=+SQRT(2.D0) ! M^{-}=<S^{-}>=-<S_{+}>
	IF(ISPIN1.EQ.2.AND.ISPIN.EQ.1)SIGNF=-SQRT(2.D0) ! M^{+}=<S^{+}>=-<S_{-}>
	ENDIF
      IREC=IUPDN+NSPIN*(IORBS-1)	
      IF(KEYT.GT.0)
     &READ(IUPDD,REC=IREC)((DRINT0Q(IPAR1,IPAR),IPAR1=1,
     &NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DRFUN0(IPAR1,
     &IBAS),IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS)),
     &((DRFUNQ(IPAR1,IBAS),IPAR1=1,NBNDT(IPAN)),IBAS=0,
     &MIN(NBAS,MBAS))
C  **** CALCULATE CONTRIBUTION TO THE CHANGE IN PSEUDODENSITY
C  **** FROM A SINGLE K-POINT OF BZ AND ALL BAND TRASITIONS 
      DO 2000 IBNDS=1,NSPIN                          !!! over spin subbands
      IF(NORBS.EQ.1.AND.IBNDS.NE.ISPIN)GOTO 2000
	DO 1000 IBNDT=1,NBNDF(IPAN)                    !!! over filled bands
	IBNDC=IBNDT-NBNDE(IPAN)+1
	IBANC=IBNDS+NSPIN*(IBNDC-1)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
C  CALCULATE CONVOLUTIONS OVER BANDS
	DO IBAS=0,MIN(NBAS,MBAS)
	APSI(IBAS)=(0.D0,0.D0)
	SPSI(IBAS)=(0.D0,0.D0)
	ENDDO
	DO IPAR=1,NBNDT(IPAN)
	AFUN(IPAR)=(0.D0,0.D0)
	SFUN(IPAR)=(0.D0,0.D0)
	ENDDO
C  1) CALCULATE CONTRIBUTION FROM UNOCCUPIED STATES
      DO IBNDS1=1,NSPIN                              !!! over spin subbands
      IF(NORBS.EQ.1.AND.IBNDS1.NE.ISPIN1)CYCLE
	DO IBNDT1=NBNDE(IPAN),NBNDT(IPAN)+NBNDH(IPAN)  !!! over empty bands
	IF(IPAN.GT.1)
     &CALL FULLSTOP('<DTOSINT>: Error in empty bands for ipan>1')
	IBNDC1=IBNDT1-NBNDE(IPAN)+1
	IBANC1=IBNDS1+NSPIN*(IBNDC1-1)
	IBAND1=IBNDS1+NSPIN*(IBNDT1-1)
C  FOR THE FERMI SURFACE BANDS
	IF(IBNDT.GE.NBNDE(IPAN).AND.IBNDT1.LE.NBNDF(IPAN))THEN
	DEK1=ETRT(IBAND,IPNTK,IPAN)-ETRT(IBAND1,IPNTQ,IPAN)
	DEK2=ETRT(IBAND1,IPNTK,IPAN)-ETRT(IBAND,IPNTQ,IPAN)
C  1/E TETRAHEDRON WEIGHTS
	WQ1=   +WEIGQ(IBANC,IBANC1,1) !!! f(kj)*[1-f(k+qj')]/[E(kj)-E(k+qj')]
	WQ2=   +WEIGQ(IBANC1,IBANC,2) !!! [1-f(kj')]*f(k+qj)/[E(kj')-E(k+qj)]
C  WEIGHTS FROM DENSITY-OF-STATES AT EF
	WQ1=WQ1+WEIGQ(IBANC,IBANC1,3) !!! +0.5*Delta[E(kj )-Ef]
	WQ2=WQ2+WEIGQ(IBANC1,IBANC,4) !!! -0.5*Delta[E(kj')-Ef]
C  WEIGHTS FROM LORENTZIAN SMEARING
	WQ1=WQ1+WEIGK(IBANC,1)*DEK1/(DEK1**2+POLUS**2) !!! f(kj)
	WQ2=WQ2+WEIGK(IBANC,2)*DEK2/(DEK2**2+POLUS**2) !!! f(k+qj')
	WQ1=WQ1-WEIGQ(IBANC,IBANC1,5) !!! f(kj)*[1-f(k+qj')]/[E(kj)-E(k+qj')]
	WQ2=WQ2-WEIGQ(IBANC1,IBANC,6) !!! [1-f(kj')]*f(k+qj)/[E(kj')-E(k+qj)]
C  OTHERWISE, USUAL TETRAHEDRON WEIGHTS
	ELSEIF(IBNDT.GE.NBNDE(IPAN).AND.IBNDT1.GT.NBNDF(IPAN))THEN
	DEK1=ETRT(IBAND,IPNTK,IPAN)-ETRT(IBAND1,IPNTQ,IPAN)
	DEK2=ETRT(IBAND1,IPNTK,IPAN)-ETRT(IBAND,IPNTQ,IPAN)
		IF(ABS(DEK1).LE.1.D-10)THEN
		IF(ABS(WEIGK(IBANC,1)).GE.1.D-10)
     &          WRITE(IUT,*)'<DTOSINT> :: ERROR IN WEIGHTS'
		WEIGK(IBANC,1)=0.D0
		DEK1=1.D0
		ENDIF
		IF(ABS(DEK2).LE.1.D-10)THEN
		IF(ABS(WEIGK(IBANC,2)).GE.1.D-10)
     &    WRITE(IUT,*)'<DTOSINT> :: ERROR IN WEIGHTS'
		WEIGK(IBANC,2)=0.D0
		DEK2=1.D0
		ENDIF
	WQ1=WEIGK(IBANC,1)/DEK1     !!! f(kj)  /[E(kj)-E(k+qj')]
	WQ2=WEIGK(IBANC,2)/DEK2     !!! f(k+qj)/[E(kj')-E(k+qj)]
	ELSEIF(IBNDT.LT.NBNDE(IPAN).AND.IBNDT1.LE.NBNDF(IPAN))THEN
	DEK1=ETRT(IBAND,IPNTK,IPAN)-ETRT(IBAND1,IPNTQ,IPAN)
	DEK2=ETRT(IBAND1,IPNTK,IPAN)-ETRT(IBAND,IPNTQ,IPAN)
		IF(ABS(DEK1).LE.1.D-10)THEN
		IF(ABS(WGTQ1-WEIGK(IBANC1,2)).GE.1.D-10)
     &    WRITE(IUT,*)'<DTOSINT> :: ERROR IN WEIGHTS'
		WEIGK(IBANC1,2)=WGTQ1
		DEK1=1.D0
		ENDIF
		IF(ABS(DEK2).LE.1.D-10)THEN
		IF(ABS(WGTQ1-WEIGK(IBANC1,1)).GE.1.D-10)
     &    WRITE(IUT,*)'<DTOSINT> :: ERROR IN WEIGHTS'
		WEIGK(IBANC1,1)=WGTQ1
		DEK1=1.D0
		ENDIF
	WQ1=(WGTQ1-WEIGK(IBANC1,2))/DEK1 !!! [1-f(k+qj')]/[E(kj)-E(k+qj')]
	WQ2=(WGTQ1-WEIGK(IBANC1,1))/DEK2 !!! [1-f(kj')  ]/[E(kj')-E(k+qj)]
	ELSEIF(IBNDT.LT.NBNDE(IPAN).AND.IBNDT1.GT.NBNDF(IPAN))THEN
	DEK1=ETRT(IBAND,IPNTK,IPAN)-ETRT(IBAND1,IPNTQ,IPAN)
	DEK2=ETRT(IBAND1,IPNTK,IPAN)-ETRT(IBAND,IPNTQ,IPAN)
	WQ1=WGTQ1/DEK1              !!! 1/[E(kj)-E(k+qj')]
	WQ2=WGTQ1/DEK2              !!! 1/[E(kj')-E(k+qj)]
	ENDIF
	WQ1=WQ1*SIGNF
	WQ2=WQ2*SIGNF
C  SET UP CONTRIBUTION
	ESUM1=ETRT(IBAND,IPNTK,IPAN)+ETRT(IBAND1,IPNTQ,IPAN)
	ESUM2=ETRT(IBAND1,IPNTK,IPAN)+ETRT(IBAND,IPNTQ,IPAN)
	CTMP1=(DHMAT(IBAND1,IBAND,MY,INUC)-0.5D0*ESUM1*
     &  DOMAT(IBAND1,IBAND,MY,INUC))*WQ1
	CTMP2=(DHMAT(IBAND,IBAND1,MY,INUC)-0.5D0*ESUM2*
     &  DOMAT(IBAND,IBAND1,MY,INUC))*WQ2
	DO IBAS=0,MIN(NBAS,MBAS)
	APSI(IBAS)=APSI(IBAS)+PSIQ(IBAS,ISPIN,IBAND1)*CTMP1
	SPSI(IBAS)=SPSI(IBAS)+CONJG(PSIK(IBAS,ISPIN1,IBAND1))*CTMP2
	ENDDO
	IF(KEYT.GT.0)THEN
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	SCP=PNTK(1)*TAU(1,IATOM)+
     &    PNTK(2)*TAU(2,IATOM)+
     &    PNTK(3)*TAU(3,IATOM)
	EXPK0=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	DO IKAP=1,NKAP(IPAN)
	DO L=0,ILSB(ISORT)
	IF(LTPAN(L,IATOM,IKAP,IPAN))THEN
	DO M=-L,L
	LM=L*(L+1)+M+1
	IPAR=INDLMT(LM,IATOM,IKAP,1,IPAN)
	AFUN(IPAR)=AFUN(IPAR)+APHQ(LM,IATOM,IKAP,ISPIN,IBAND1)*
     &EXPK0*CTMP1
	SFUN(IPAR)=SFUN(IPAR)+DCONJG(APHK(LM,IATOM,IKAP,ISPIN1,IBAND1)*
     &EXPK0)*CTMP2
	ENDDO
	ENDIF
	ENDDO
	ENDDO
	ENDDO
	ENDIF
	ENDDO                                          !!! over empty bands
	ENDDO                                          !!! over spin subbands
C  2) CONTRIBUTION FROM ALL STATES
      DO IBNDS1=1,NSPIN                              !!! over spin subbands
      IF(NORBS.EQ.1.AND.IBNDS1.NE.ISPIN1)CYCLE
	DO IBNDT1=1,NBNDT(IPAN)+NBNDH(IPAN)            !!! over all bands
	IBNDC1=IBNDT1-NBNDE(IPAN)+1
	IBANC1=IBNDS1+NSPIN*(IBNDC1-1)
	IBAND1=IBNDS1+NSPIN*(IBNDT1-1)
	IF(IBNDT.GE.NBNDE(IPAN))THEN
	WQ1=WEIGK(IBANC,1)          !!! f(kj)
	WQ2=WEIGK(IBANC,2)          !!! f(k+qj)
	ELSEIF(IBNDT.LT.NBNDE(IPAN))THEN
	WQ1=WGTQ1                   !!! 1
	WQ2=WGTQ1                   !!! 1
	ENDIF
	WQ1=WQ1*SIGNF
	WQ2=WQ2*SIGNF
	CTMP1=-0.5D0*DOMAT(IBAND1,IBAND,MY,INUC)*WQ1
	CTMP2=+0.5D0*DOMAT(IBAND,IBAND1,MY,INUC)*WQ2
	DO IBAS=0,MIN(NBAS,MBAS)
	APSI(IBAS)=APSI(IBAS)+PSIQ(IBAS,ISPIN,IBAND1)*CTMP1
	SPSI(IBAS)=SPSI(IBAS)+CONJG(PSIK(IBAS,ISPIN1,IBAND1))*CTMP2
	ENDDO
	IF(KEYT.GT.0)THEN
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	SCP=PNTK(1)*TAU(1,IATOM)+
     &    PNTK(2)*TAU(2,IATOM)+
     &    PNTK(3)*TAU(3,IATOM)
	EXPK0=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	DO IKAP=1,NKAP(IPAN)
	DO L=0,ILSB(ISORT)
	IF(LTPAN(L,IATOM,IKAP,IPAN))THEN
	DO M=-L,L
	LM=L*(L+1)+M+1
	IPAR=INDLMT(LM,IATOM,IKAP,1,IPAN)
	AFUN(IPAR)=AFUN(IPAR)+APHQ(LM,IATOM,IKAP,ISPIN,IBAND1)*
     &EXPK0*CTMP1
	SFUN(IPAR)=SFUN(IPAR)+DCONJG(APHK(LM,IATOM,IKAP,ISPIN1,IBAND1)*
     &EXPK0)*CTMP2
	ENDDO
	ENDIF
	ENDDO
	ENDDO
	ENDDO
	ENDIF
	ENDDO                                          !!! over filled bands
	ENDDO                                          !!! over spin subbands
C  ADD A CONTRIBUTION IF MODE=1 OR 3,4
	IF(MODE.EQ.1.OR.MODE.EQ.3.OR.MODE.EQ.4)THEN
	IF(IBNDT.GE.NBNDE(IPAN))THEN
	WQ1=WEIGK(IBANC,1)          !!! f(kj) 
	WQ2=WEIGK(IBANC,2)          !!! f(k+qj)
	ELSEIF(IBNDT.LT.NBNDE(IPAN))THEN
	WQ1=WGTQ1                   !!! 1
	WQ2=WGTQ1                   !!! 1
	ENDIF
	WQ1=WQ1*SIGNF
	WQ2=WQ2*SIGNF
C  SET RIGID CHANGE IN PSEUDOWAVEFUNCTIONS
	DO IBAS=0,MIN(NBAS,MBAS)
	GX=PNTQ(1)+GPLW(1,IBAS)
	GY=PNTQ(2)+GPLW(2,IBAS)
	GZ=PNTQ(3)+GPLW(3,IBAS)
	IF(MY.EQ.-1)GMY=+1.D0/SQRT(2.D0)*(GX-(0.D0,1.D0)*GY)
	IF(MY.EQ.+1)GMY=-1.D0/SQRT(2.D0)*(GX+(0.D0,1.D0)*GY)
	IF(MY.EQ. 0)GMY=GZ
	TPSQ(IBAS)=DPSQ(IBAS,ISPIN,IBAND)*GMY*(0.D0,1.D0)*
     &  2.D0*PI/PAR*WQ1
	GX=PNTK(1)+GPLW(1,IBAS)
	GY=PNTK(2)+GPLW(2,IBAS)
	GZ=PNTK(3)+GPLW(3,IBAS)
	IF(-MY.EQ.-1)GMY=+1.D0/SQRT(2.D0)*(GX-(0.D0,1.D0)*GY)
	IF(-MY.EQ.+1)GMY=-1.D0/SQRT(2.D0)*(GX+(0.D0,1.D0)*GY)
	IF(-MY.EQ. 0)GMY=GZ
	TPSK(IBAS)=DCONJG(DPSK(IBAS,ISPIN1,IBAND)*GMY*(0.D0,1.D0)*
     &  2.D0*PI/PAR)*(-1)**MY*WQ2
	ENDDO
C ADD TO APSI,SPSI
	DO IBAS=0,MIN(NBAS,MBAS)
	APSI(IBAS)=APSI(IBAS)+TPSQ(IBAS)
	SPSI(IBAS)=SPSI(IBAS)-TPSK(IBAS)
	ENDDO
	IF(KEYT.GT.0)THEN
	XK=PNTK(1)
	YK=PNTK(2)
	ZK=PNTK(3)
	IF(+MY.EQ.-1)RPY=+1.D0/SQRT(2.D0)*(XK-(0.D0,1.D0)*YK)
	IF(+MY.EQ.+1)RPY=-1.D0/SQRT(2.D0)*(XK+(0.D0,1.D0)*YK)
	IF(+MY.EQ. 0)RPY=ZK
	RPY=RPY*(0.D0,-1.D0)*2.D0*PI/PAR*WQ1
	IF(-MY.EQ.-1)RMY=+1.D0/SQRT(2.D0)*(XK-(0.D0,1.D0)*YK)
	IF(-MY.EQ.+1)RMY=-1.D0/SQRT(2.D0)*(XK+(0.D0,1.D0)*YK)
	IF(-MY.EQ. 0)RMY=ZK
	RMY=DCONJG(RMY*(-1)**MY*(0.D0,-1.D0)*2.D0*PI/PAR)*WQ2
C ADD TO AFUN,SFUN
	IATOM=INUC
	ISORT=IS(IATOM)
	SCP=PNTK(1)*TAU(1,IATOM)+
     &    PNTK(2)*TAU(2,IATOM)+
     &    PNTK(3)*TAU(3,IATOM)
	EXPK0=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	DO IKAP=1,NKAP(IPAN)
	DO L=0,ILSB(ISORT)
	DO M=-L,L
	IF(.NOT.LTPAN(L,IATOM,IKAP,IPAN))EXIT
	LM=L*(L+1)+M+1
	IPAR=INDLMT(LM,IATOM,IKAP,1,IPAN)
	AFUN(IPAR)=AFUN(IPAR)+APHK(LM,IATOM,IKAP,ISPIN,IBAND)*
     &EXPK0*RPY
	SFUN(IPAR)=SFUN(IPAR)-DCONJG(APHQ(LM,IATOM,IKAP,ISPIN1,IBAND)*
     &EXPK0)*RMY
	ENDDO
	ENDDO
	ENDDO
	ENDIF
	ENDIF
C  FOURIER TRANSFORM OF THE PSEUDOCHARGE DENSITY (SMALL G-VECTORS)
	DO IBAS=0,MIN(NBAS,MBAS)
	CHIS(IBAS)=DCONJG(PSIK(IBAS,ISPIN1,IBAND))
	ENDDO
      CALL BND_CONVOL2(DRHOPS(0,IUPDN,IORBS),CHIS(0),APSI(0),'P',
     &               0,MIN(NBAS,MBAS),0,MIN(NBAS,MBAS))
	DO IBAS=0,MIN(NBAS,MBAS)
	CHIS(IBAS)=PSIQ(IBAS,ISPIN,IBAND)
	ENDDO
      CALL BND_CONVOL2(DRHOPS(0,IUPDN,IORBS),SPSI(0),CHIS(0),'M',
     &               0,MIN(NBAS,MBAS),0,MIN(NBAS,MBAS))
C  SET DENSITY PARAMETERS
	IF(KEYT.GT.0)THEN
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	SCP=PNTK(1)*TAU(1,IATOM)+
     &    PNTK(2)*TAU(2,IATOM)+
     &    PNTK(3)*TAU(3,IATOM)
	EXPK0=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	DO IKAP=1,NKAP(IPAN)
	DO L=0,ILSB(ISORT)
	DO M=-L,L
	IF(.NOT.LTPAN(L,IATOM,IKAP,IPAN))EXIT
	LM=L*(L+1)+M+1
	IPAR=INDLMT(LM,IATOM,IKAP,1,IPAN)
	DO IBAS=0,MIN(NBAS,MBAS)
	DRFUN0(IPAR,IBAS)=DRFUN0(IPAR,IBAS)+
     &DCONJG(PSIK(IBAS,ISPIN1,IBAND))*AFUN(IPAR)-
     &SPSI(IBAS)*APHQ(LM,IATOM,IKAP,ISPIN,IBAND)*EXPK0
	DRFUNQ(IPAR,IBAS)=DRFUNQ(IPAR,IBAS)+
     &DCONJG(APHK(LM,IATOM,IKAP,ISPIN1,IBAND)*EXPK0)*APSI(IBAS)-
     &SFUN(IPAR)*PSIQ(IBAS,ISPIN,IBAND)
	ENDDO
	DO IATOM1=1,NATOM
	ISORT1=IS(IATOM1)
	SCP=PNTK(1)*TAU(1,IATOM1)+
     &    PNTK(2)*TAU(2,IATOM1)+
     &    PNTK(3)*TAU(3,IATOM1)
	EXPK1=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	DO IKAP1=1,NKAP(IPAN)
	DO L1=0,ILSB(ISORT1)
	DO M1=-L1,L1
	IF(.NOT.LTPAN(L1,IATOM1,IKAP1,IPAN))EXIT
	L1M1=L1*(L1+1)+M1+1
	IPAR1=INDLMT(L1M1,IATOM1,IKAP1,1,IPAN)
	DRINT0Q(IPAR1,IPAR)=DRINT0Q(IPAR1,IPAR)+
     &  DCONJG(APHK(L1M1,IATOM1,IKAP1,ISPIN1,IBAND)*EXPK1)*AFUN(IPAR)-
     &  SFUN(IPAR1)*APHQ(LM,IATOM,IKAP,ISPIN,IBAND)*EXPK0
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDIF
 1000 CONTINUE                                       !!! over filled bands
 2000 CONTINUE                                       !!! over spin subbands
C  STORE DENSITY PARAMETERS
      IREC=IUPDN+NSPIN*(IORBS-1)	
      IF(KEYT.GT.0)
     &WRITE(IUPDD,REC=IREC)((DRINT0Q(IPAR1,IPAR),IPAR1=1,
     &NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DRFUN0(IPAR1,
     &IBAS),IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS)),
     &((DRFUNQ(IPAR1,IBAS),IPAR1=1,NBNDT(IPAN)),IBAS=0,
     & MIN(NBAS,MBAS))
 3000 CONTINUE                                       !!! over iupdn
 4000 CONTINUE                                       !!! over iorbs
	CLOSE(IUPDD)
      CALL DRO_DPSFILES(MY,INUC,IQPNT,IUDPY,'W','D',' ')        !!! store density
C Memory deallocations
	DEALLOCATE(DRINT0Q,DRFUN0,DRFUNQ,TPSK,TPSQ,CHIS)
	DEALLOCATE(WEIGQ,WEIGK,APSI,AFUN,SPSI,SFUN)
	END





	SUBROUTINE DEL_DSNULINT(MY,INUC,IPAN,IQPNT)
************************************************
*  Zeroises density parameters                 *
************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_LATPAR,  ONLY : PAR,ORTH,OMEGAC                            !!! from readini
	USE COM_KAPPAR,  ONLY : NPAN,NKAP,EK,EKAP                          !!! from readini
	USE COM_PANPAR,  ONLY : LTPAN,LSPAN,IATS,ISTS                      !!! from readini
	USE COM_PLWMESH, ONLY : NPLW,GPLW                                  !!! from makeplw
	USE COM_NBANDS,  ONLY : NBNDF,NBNDE,NBNDT,NBNDC,POLUS              !!! from readini
	USE COM_ETAPAR,  ONLY : ETA,CUT,LBAS,NBAS                          !!! from makeplw
	USE COM_INDORB,  ONLY : INDLMT                                     !!! from readini
	USE COM_TEILORG, ONLY : KEYT,BZM,GOPT,MBAS                         !!! from makeplw
	USE COM_MASHDEP, ONLY : NVAL                                       !!! from setup
      USE COM_LMTOUT,  ONLY : SCNFILE                                    !!! from storage
	USE COM_PHNCHN  ,ONLY : IUPDD                                      !!! from channels
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: DRINT0Q(:,:)
	COMPLEX*16, ALLOCATABLE :: DRFUN0(:,:)
	COMPLEX*16, ALLOCATABLE :: DRFUNQ(:,:)
	LOGICAL EXIST
	CHARACTER STATUS*3
C  OPEN SCRATCH FILE FOR STORING POTENTIAL PARAMETERS
	NRECL=NVAL*(2*NBNDT(IPAN)*(MIN(NBAS,MBAS)+1)+
     &NBNDT(IPAN)**2)
	INQUIRE(FILE=SCNFILE(MY,INUC,IUPDD),EXIST=EXIST)
      IF(.NOT.EXIST)STATUS='NEW'
      IF(     EXIST)STATUS='OLD'
	OPEN(UNIT=IUPDD,FILE=SCNFILE(MY,INUC,IUPDD),STATUS=STATUS,
     &  ACCESS='DIRECT',FORM='UNFORMATTED',RECL=NRECL)
	IF(KEYT.LE.0)THEN
	CLOSE(IUPDD)
	RETURN
	ENDIF
C Memory allocations
	ALLOCATE(DRINT0Q(NBNDT(IPAN),NBNDT(IPAN)))
	ALLOCATE(DRFUN0(NBNDT(IPAN),0:MBASMEM))
	ALLOCATE(DRFUNQ(NBNDT(IPAN),0:MBASMEM))
	DO IDIM=1,NBNDT(IPAN)                          !!! over idim
	DO JDIM=1,NBNDT(IPAN)                          !!! over jdim
	DRINT0Q(JDIM,IDIM)=(0.D0,0.D0)
	ENDDO                                          !!! over jdim
	DO IBAS=0,MIN(NBAS,MBAS)                       !!! over ibas
	DRFUN0(IDIM,IBAS)=(0.D0,0.D0)
	DRFUNQ(IDIM,IBAS)=(0.D0,0.D0)
	ENDDO                                          !!! over ibas
	ENDDO                                          !!! over idim
C  STORE DATA
      DO IORBS=1,NORBS
      DO IUPDN=1,NSPIN
	IREC=IUPDN+NSPIN*(IORBS-1)
	WRITE(IUPDD,REC=IREC)((DRINT0Q(IPAR1,IPAR),IPAR1=1,
     &NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DRFUN0(IPAR1,
     &IBAS),IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS)),
     &((DRFUNQ(IPAR1,IBAS),IPAR1=1,NBNDT(IPAN)),IBAS=0,
     &MIN(NBAS,MBAS))
      ENDDO
      ENDDO
	CLOSE(IUPDD)
C Memory deallocations
	DEALLOCATE(DRINT0Q,DRFUN0,DRFUNQ)
	END
