        SUBROUTINE DEL_DTOSPAR(MY,INUC,IPNT,ISGQ,IPAN,IQPNT)
***********************************************************
*  Calculate change in the number of states matrix (TOS)  *
*  due to presense of frozen phonon with q-vector number. *
***********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_KAPPAR,  ONLY : NPAN,NKAP,EK,EKAP                          !!! from readini
	USE COM_PANPAR,  ONLY : LTPAN,LSPAN,IATS,ISTS                      !!! from readini
	USE COM_KMESH,   ONLY : NPNT,PNT,WGT                               !!! from makettr
	USE COM_GROUPS,  ONLY : NGROUP,INV,IKOV                            !!! from makegrp
	USE COM_SUBGROUP,ONLY : NSGQ,NGEQ,ISG                              !!! from delmesh
	USE COM_SYMMESH, ONLY : IG0IG1,IK0IK1                              !!! from delmesh
	USE COM_PSIVEC,  ONLY : APHK,APJK,APHQ,APJQ                        !!! from lmtvec
	USE COM_ENERGY,  ONLY : ETRT                                       !!! from lmtbnd
	USE COM_NBANDS,  ONLY : NBNDF,NBNDE,NBNDT,NBNDC,NBNDH,POLUS        !!! from readini
	USE COM_DHAMPAR, ONLY : DTOSHH=>DELHHH                             !!! from tospar
     &                       ,DTOSJH=>DELHJH
     &                       ,DTOSHJ=>DELHHJ
     &                       ,DTOSJJ=>DELHJJ 
	USE COM_DELHAM,  ONLY : DHMAT=>DHMATT,DOMAT=>DOMATT                !!! from delmat
	USE COM_DSTRCON, ONLY : DSKL,DSQL                                  !!! from strvec
	USE COM_MASHDEP, ONLY : NVAL                                       !!! from setup
	USE COM_PHNCHN  ,ONLY : IUDTS,IUTTW                                !!! from channels
	USE COM_LMTOUT,  ONLY : SCRFILE                                    !!! from setup
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: APH(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: APJ(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: SPH(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: SPJ(:,:,:,:)
	REAL*8, ALLOCATABLE :: WEIGQ(:,:,:)
	REAL*8, ALLOCATABLE :: WEIGK(:,:)
	LOGICAL LOG1,LOG,EXIST
	DATA PI/3.141592653589793D0/
	IF(MODE.EQ.5)RETURN
C  Memory allocations
      ALLOCATE(APH(LIMBMEM,NKAPMEM,NSPINMEM,
     &        (NBNDT(IPAN)+NBNDH(IPAN))*NSPINMEM))
	ALLOCATE(APJ(LIMTMEM,NKAPMEM,NSPINMEM,
     &        (NBNDT(IPAN)+NBNDH(IPAN))*NSPINMEM))
	ALLOCATE(SPH(LIMBMEM,NKAPMEM,NSPINMEM,
     &        (NBNDT(IPAN)+NBNDH(IPAN))*NSPINMEM))
	ALLOCATE(SPJ(LIMTMEM,NKAPMEM,NSPINMEM,
     &        (NBNDT(IPAN)+NBNDH(IPAN))*NSPINMEM))
	ALLOCATE(WEIGK(NBNDC(1)*NSPINMEM,4))
	ALLOCATE(WEIGQ(NBNDC(1)*NSPINMEM,NBNDC(1)*NSPINMEM,6))
C  SET POINT-GROUP INFORMATION
	IRK=ISG(1,ISGQ)       !!!  element "g"  in the main G-list
	IGK=IKOV(IRK)         !!!  element "g"  after Kovalev
	IPNTK=IPNT            !!!  point   "k"
	IRQ=IG0IG1(IPNT,IRK)  !!!  element "g'" in the main G-list
	IGQ=IKOV(IRQ)         !!!  element "g'" after Kovalev
	IPNTQ=IK0IK1(IPNT,IRK)!!!  point   "k'" such that g*k+q=g'*k'
C  READ 1/E TETRAHEDRON WEIGHTS FOR BRILLOUIN ZONE INTEGRATION
	IREC=1+IPNTK+NPNT(1)*(ISGQ-1)
	IF(IPAN.EQ.1)THEN
	READ(IUTTW,REC=IREC)WGTQ1,
     &(((WEIGQ(IBANC,IBANC1,IC),IBANC=1,NBNDC(1)*NSPIN),
     &IBANC1=1,NBNDC(1)*NSPIN),IC=1,6),
     &((WEIGK(IBANC,IC),IBANC=1,NBNDC(1)*NSPIN),IC=1,4)
	ELSE ! only geometrical weigths are neccessary
	READ(IUTTW,REC=IREC)WGTQ1
	ENDIF
C  DO OVER SPINS
	DO 3000 IORBS=1,NORBS
	DO 2000 IUPDN=1,NSPIN
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	SIGNF=1.D0
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	IF(ISPIN1.EQ.1.AND.ISPIN.EQ.2)SIGNF=+SQRT(2.D0) ! M^{-}=<S^{-}>=-<S_{+}>
	IF(ISPIN1.EQ.2.AND.ISPIN.EQ.1)SIGNF=-SQRT(2.D0) ! M^{+}=<S^{+}>=-<S_{-}>
	ENDIF
C  READ CHANGE IN THE TOS-MATRIX
	CALL TOSFILES(MY,INUC,IPAN,IUPDN,IORBS,IUDTS,'R')
C  **** CALCULATE CONTRIBUTION TO THE CHANGE IN THE TOS-MATRIX GOING 
C  **** FROM A SINGLE K-POINT OF BZ AND ALL BAND TRASITIONS 
	DO 1000 IATOM=1,NATOM                          !!! over iatom
	ISORT=IS(IATOM)
	DO IKAP=1,NKAP(IPAN)                           !!! over energies
	DO IBNDS=1,NSPIN                               !!! over spin subbands
      IF(NORBS.EQ.1.AND.IBNDS.NE.ISPIN)CYCLE
	DO IBNDT=1,NBNDF(IPAN)                         !!! over filled bands
	IBNDC=IBNDT-NBNDE(IPAN)+1
	IBANC=IBNDS+NSPIN*(IBNDC-1)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
C  CALCULATE CONVOLUTIONS OVER BANDS
	DO L=0,ILST(ISORT)                             !!! over l
	LOG=.FALSE.
	IF(LTPAN(L,IATOM,IKAP,IPAN))LOG=.TRUE.
	DO M=-L,L                                      !!! over m
	LM=L*(L+1)+M+1
	IF(L.LE.ILSB(ISORT))
     &APH(LM,IKAP,ISPIN,IBAND)=(0.D0,0.D0)
	APJ(LM,IKAP,ISPIN,IBAND)=(0.D0,0.D0)
	IF(L.LE.ILSB(ISORT))
     &SPH(LM,IKAP,ISPIN1,IBAND)=(0.D0,0.D0)
	SPJ(LM,IKAP,ISPIN1,IBAND)=(0.D0,0.D0)
C  1) CALCULATE CONTRIBUTION FROM UNOCCUPIED STATES
      DO IBNDS1=1,NSPIN                              !!! over spin subbands
      IF(NORBS.EQ.1.AND.IBNDS1.NE.ISPIN1)CYCLE
	DO IBNDT1=NBNDE(IPAN),NBNDT(IPAN)+NBNDH(IPAN)  !!! over empty bands
	IF(IPAN.GT.1)
     &CALL  FULLSTOP('<DELTOS>: Error in empty bands for ipan>1')
	IBNDC1=IBNDT1-NBNDE(IPAN)+1
	IBANC1=IBNDS1+NSPIN*(IBNDC1-1)
	IBAND1=IBNDS1+NSPIN*(IBNDT1-1)
C  FOR THE FERMI SURFACE BANDS
	IF(IBNDT.GE.NBNDE(IPAN).AND.IBNDT1.LE.NBNDF(IPAN))THEN
	DEK1=ETRT(IBAND,IPNTK,IPAN)-ETRT(IBAND1,IPNTQ,IPAN)
      DEK2=ETRT(IBAND1,IPNTK,IPAN)-ETRT(IBAND,IPNTQ,IPAN)
C  1/E TETRAHEDRON WEIGHTS
 	WQ1=   +WEIGQ(IBANC,IBANC1,1) !!! f(kj)*[1-f(k+qj')]/[E(kj)-E(k+qj')]
 	WQ2=   +WEIGQ(IBANC1,IBANC,2) !!! [1-f(kj')]*f(k+qj)/[E(kj')-E(k+qj)]
C  WEIGHTS FROM DENSITY-OF-STATES AT EF 
 	WQ1=WQ1+WEIGQ(IBANC,IBANC1,3) !!! +0.5*Delta[E(kj )-Ef]
 	WQ2=WQ2+WEIGQ(IBANC1,IBANC,4) !!! -0.5*Delta[E(kj')-Ef]
C  WEIGHTS FROM LORENTZIAN SMEARING
	WQ1=WQ1+WEIGK(IBANC,1)*DEK1/(DEK1**2+POLUS**2) !!! f(kj)
	WQ2=WQ2+WEIGK(IBANC,2)*DEK2/(DEK2**2+POLUS**2) !!! f(k+qj')
 	WQ1=WQ1-WEIGQ(IBANC,IBANC1,5) !!! f(kj)*[1-f(k+qj')]/[E(kj)-E(k+qj')]
 	WQ2=WQ2-WEIGQ(IBANC1,IBANC,6) !!! [1-f(kj')]*f(k+qj)/[E(kj')-E(k+qj)]
C  OTHERWISE, USUAL TETRAHEDRON WEIGHTS
	ELSEIF(IBNDT.GE.NBNDE(IPAN).AND.IBNDT1.GT.NBNDF(IPAN))THEN
	DEK1=ETRT(IBAND,IPNTK,IPAN)-ETRT(IBAND1,IPNTQ,IPAN)
      DEK2=ETRT(IBAND1,IPNTK,IPAN)-ETRT(IBAND,IPNTQ,IPAN)
		IF(ABS(DEK1).LE.1.D-10)THEN
		IF(ABS(WEIGK(IBANC,1)).GE.1.D-10)
     &  WRITE(IUT,*)'<DELTOS> :: ERROR IN WEIGHTS'
		WEIGK(IBANC,1)=0.D0
		DEK1=1.D0
		ENDIF
		IF(ABS(DEK2).LE.1.D-10)THEN
		IF(ABS(WEIGK(IBANC,2)).GE.1.D-10)
     &  WRITE(IUT,*)'<DELTOS> :: ERROR IN WEIGHTS'
		WEIGK(IBANC,2)=0.D0
		DEK2=1.D0
		ENDIF
	WQ1=WEIGK(IBANC,1)/DEK1     !!! f(kj)  /[E(kj)-E(k+qj')]
	WQ2=WEIGK(IBANC,2)/DEK2     !!! f(k+qj)/[E(kj')-E(k+qj)]
	ELSEIF(IBNDT.LT.NBNDE(IPAN).AND.IBNDT1.LE.NBNDF(IPAN))THEN
	DEK1=ETRT(IBAND,IPNTK,IPAN)-ETRT(IBAND1,IPNTQ,IPAN)
      DEK2=ETRT(IBAND1,IPNTK,IPAN)-ETRT(IBAND,IPNTQ,IPAN)
		IF(ABS(DEK1).LE.1.D-10)THEN
		IF(ABS(WGTQ1-WEIGK(IBANC1,2)).GE.1.D-10)
     &  WRITE(IUT,*)'<DELTOS> :: ERROR IN WEIGHTS'
		WEIGK(IBANC1,2)=WGTQ1
		DEK1=1.D0
		ENDIF
		IF(ABS(DEK2).LE.1.D-10)THEN
		IF(ABS(WGTQ1-WEIGK(IBANC1,1)).GE.1.D-10)
     &  WRITE(IUT,*)'<DELTOS> :: ERROR IN WEIGHTS'
		WEIGK(IBANC1,1)=WGTQ1
		DEK1=1.D0
		ENDIF
	WQ1=(WGTQ1-WEIGK(IBANC1,2))/DEK1 !!! [1-f(k+qj')]/[E(kj)-E(k+qj')]
	WQ2=(WGTQ1-WEIGK(IBANC1,1))/DEK2 !!! [1-f(kj')  ]/[E(kj')-E(k+qj)]
	ELSEIF(IBNDT.LT.NBNDE(IPAN).AND.IBNDT1.GT.NBNDF(IPAN))THEN
	DEK1=ETRT(IBAND,IPNTK,IPAN)-ETRT(IBAND1,IPNTQ,IPAN)
      DEK2=ETRT(IBAND1,IPNTK,IPAN)-ETRT(IBAND,IPNTQ,IPAN)
	WQ1=WGTQ1/DEK1              !!! 1/[E(kj)-E(k+qj')]
	WQ2=WGTQ1/DEK2              !!! 1/[E(kj')-E(k+qj)]
	ENDIF
	WQ1=WQ1*SIGNF
	WQ2=WQ2*SIGNF
C  SET UP CONTRIBUTION
	ESUM1=ETRT(IBAND,IPNTK,IPAN)+ETRT(IBAND1,IPNTQ,IPAN)
	ESUM2=ETRT(IBAND1,IPNTK,IPAN)+ETRT(IBAND,IPNTQ,IPAN)
   	IF(LOG)
     &APH(LM,IKAP,ISPIN,IBAND)=APH(LM,IKAP,ISPIN,IBAND)+
     &  APHQ(LM,IATOM,IKAP,ISPIN,IBAND1)*(
     &  DHMAT(IBAND1,IBAND,MY,INUC)-0.5D0*ESUM1*
     &  DOMAT(IBAND1,IBAND,MY,INUC))*WQ1
   	APJ(LM,IKAP,ISPIN,IBAND)=APJ(LM,IKAP,ISPIN,IBAND)+
     &  APJQ(LM,IATOM,IKAP,ISPIN,IBAND1)*(
     &  DHMAT(IBAND1,IBAND,MY,INUC)-0.5D0*ESUM1*
     &  DOMAT(IBAND1,IBAND,MY,INUC))*WQ1
   	IF(LOG)
     &SPH(LM,IKAP,ISPIN1,IBAND)=SPH(LM,IKAP,ISPIN1,IBAND)+
     &  CONJG(APHK(LM,IATOM,IKAP,ISPIN1,IBAND1))*
     &  (DHMAT(IBAND,IBAND1,MY,INUC)-0.5D0*ESUM2*
     &  DOMAT(IBAND,IBAND1,MY,INUC))*WQ2
   	SPJ(LM,IKAP,ISPIN1,IBAND)=SPJ(LM,IKAP,ISPIN1,IBAND)+
     &  CONJG(APJK(LM,IATOM,IKAP,ISPIN1,IBAND1))*
     &  (DHMAT(IBAND,IBAND1,MY,INUC)-0.5D0*ESUM2*
     &   DOMAT(IBAND,IBAND1,MY,INUC))*WQ2
      ENDDO                                          !!! over empty bands
      ENDDO                                          !!! over spin subbands
C  2) CONTRIBUTION FROM ALL STATES
      DO IBNDS1=1,NSPIN                              !!! over spin subbands
      IF(NORBS.EQ.1.AND.IBNDS1.NE.ISPIN1)CYCLE
	DO IBNDT1=1,NBNDT(IPAN)+NBNDH(IPAN)            !!! over all bands
	IBNDC1=IBNDT1-NBNDE(IPAN)+1
	IBANC1=IBNDS1+NSPIN*(IBNDC1-1)
	IBAND1=IBNDS1+NSPIN*(IBNDT1-1)
      IF(IBNDT.GE.NBNDE(IPAN))THEN
      WQ1=WEIGK(IBANC,1)          !!! f(kj)
      WQ2=WEIGK(IBANC,2)          !!! f(k+qj)
      ELSEIF(IBNDT.LT.NBNDE(IPAN))THEN
      WQ1=WGTQ1                   !!! 1
      WQ2=WGTQ1                   !!! 1
      ENDIF
	WQ1=WQ1*SIGNF
	WQ2=WQ2*SIGNF
C  SET UP CONTRIBUTION
      IF(LOG)
     &APH(LM,IKAP,ISPIN,IBAND)=APH(LM,IKAP,ISPIN,IBAND)-
     &  APHQ(LM,IATOM,IKAP,ISPIN,IBAND1)*
     &  0.5D0*DOMAT(IBAND1,IBAND,MY,INUC)*WQ1
      APJ(LM,IKAP,ISPIN,IBAND)=APJ(LM,IKAP,ISPIN,IBAND)-
     &  APJQ(LM,IATOM,IKAP,ISPIN,IBAND1)*
     &  0.5D0*DOMAT(IBAND1,IBAND,MY,INUC)*WQ1
      IF(LOG)
     &SPH(LM,IKAP,ISPIN1,IBAND)=SPH(LM,IKAP,ISPIN1,IBAND)+
     &  DCONJG(APHK(LM,IATOM,IKAP,ISPIN1,IBAND1))*
     &  0.5D0*DOMAT(IBAND,IBAND1,MY,INUC)*WQ2
      SPJ(LM,IKAP,ISPIN1,IBAND)=SPJ(LM,IKAP,ISPIN1,IBAND)+
     &  DCONJG(APJK(LM,IATOM,IKAP,ISPIN1,IBAND1))*
     &  0.5D0*DOMAT(IBAND,IBAND1,MY,INUC)*WQ2
      ENDDO                                          !!! over all bands
      ENDDO                                          !!! over spin subbands
C  ADD A CONTRIBUTION IF MODE=1 OR 3,4
      IF(MODE.EQ.1.OR.MODE.EQ.3.OR.MODE.EQ.4)THEN
      IF(IBNDT.GE.NBNDE(IPAN))THEN
      WQ1=WEIGK(IBANC,1)          !!! f(kj)
      WQ2=WEIGK(IBANC,2)          !!! f(k+qj)
      ELSEIF(IBNDT.LT.NBNDE(IPAN))THEN
      WQ1=WGTQ1                   !!! 1
      WQ2=WGTQ1                   !!! 1
      ENDIF
	WQ1=WQ1*SIGNF
	WQ2=WQ2*SIGNF
      APJ(LM,IKAP,ISPIN,IBAND)=APJ(LM,IKAP,ISPIN,IBAND)+
     &DSKL(LM,IATOM,IKAP,ISPIN,IBAND,MY)*WQ1
      SPJ(LM,IKAP,ISPIN1,IBAND)=SPJ(LM,IKAP,ISPIN1,IBAND)-
     &(-1)**MY*CONJG(DSQL(LM,IATOM,IKAP,ISPIN1,IBAND,-MY))*WQ2
      ENDIF
      ENDDO                                          !!! over m
      ENDDO                                          !!! over l
      ENDDO                                          !!! over filled bands
      ENDDO                                          !!! over spin subbands
      ENDDO                                          !!! over energies
C  CALCULATE CONTRIBUTION FROM THIS K-POINT TO THE CHANGE IN TOS-MATRIX
	DO IKAP1=1,NKAP(IPAN)                          !!! over energies
	DO IKAP =1,NKAP(IPAN)                          !!! over energies
	DO IBNDS=1,NSPIN                               !!! over spin subbands
      IF(NORBS.EQ.1.AND.IBNDS.NE.ISPIN1)CYCLE
      IF(NORBS.EQ.1.AND.IBNDS.NE.ISPIN )CYCLE
	DO IBNDT=1,NBNDF(IPAN)                         !!! over filled bands
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	DO L1=0,ILST(ISORT)                            !!! over l1
	LOG1=.FALSE.
	IF(LTPAN(L1,IATOM,IKAP1,IPAN))LOG1=.TRUE.
	DO M1=-L1,L1                                   !!! over m1
	L1M1=L1*(L1+1)+M1+1
	DO L=0,ILST(ISORT)                             !!! over l
	LOG=.FALSE.
	IF(LTPAN(L,IATOM,IKAP,IPAN))LOG=.TRUE.
	DO M=-L,L                                      !!! over m
	LM=L*(L+1)+M+1
	IF(LOG1.AND.LOG)
     &DTOSHH(L1M1,LM,IATOM,IKAP1,IKAP)=
     &DTOSHH(L1M1,LM,IATOM,IKAP1,IKAP)+
     &CONJG(APHK(L1M1,IATOM,IKAP1,ISPIN1,IBAND))*
     &APH(LM,IKAP,ISPIN,IBAND)-
     &SPH(L1M1,IKAP1,ISPIN1,IBAND)*
     &APHQ(LM,IATOM,IKAP,ISPIN,IBAND)
	IF(LOG1)
     &DTOSHJ(L1M1,LM,IATOM,IKAP1,IKAP)=
     &DTOSHJ(L1M1,LM,IATOM,IKAP1,IKAP)+
     &CONJG(APHK(L1M1,IATOM,IKAP1,ISPIN1,IBAND))*
     &APJ(LM,IKAP,ISPIN,IBAND)-
     &SPH(L1M1,IKAP1,ISPIN1,IBAND)*
     &APJQ(LM,IATOM,IKAP,ISPIN,IBAND)
	IF(LOG)
     &DTOSJH(L1M1,LM,IATOM,IKAP1,IKAP)=
     &DTOSJH(L1M1,LM,IATOM,IKAP1,IKAP)+
     &CONJG(APJK(L1M1,IATOM,IKAP1,ISPIN1,IBAND))*
     &APH(LM,IKAP,ISPIN,IBAND)-
     &SPJ(L1M1,IKAP1,ISPIN1,IBAND)*
     &APHQ(LM,IATOM,IKAP,ISPIN,IBAND)
	DTOSJJ(L1M1,LM,IATOM,IKAP1,IKAP)=
     &DTOSJJ(L1M1,LM,IATOM,IKAP1,IKAP)+
     &CONJG(APJK(L1M1,IATOM,IKAP1,ISPIN1,IBAND))*
     &APJ(LM,IKAP,ISPIN,IBAND)-
     &SPJ(L1M1,IKAP1,ISPIN1,IBAND)*
     &APJQ(LM,IATOM,IKAP,ISPIN,IBAND)
      ENDDO                                          !!! over m
      ENDDO                                          !!! over l
      ENDDO                                          !!! over m1
      ENDDO                                          !!! over l1
      ENDDO                                          !!! over filled bands
      ENDDO                                          !!! over spin subbands
      ENDDO                                          !!! over energies
      ENDDO                                          !!! over energies
 1000 CONTINUE                                       !!! over atoms
C  STORE CHANGE IN THE TOS-MATRIX
	CALL TOSFILES(MY,INUC,IPAN,IUPDN,IORBS,IUDTS,'W')
 2000 CONTINUE                                       !!! over iupdn
 3000 CONTINUE                                       !!! over iorbs
C  Memory deallocations
      DEALLOCATE(APH,APJ,SPH,SPJ,WEIGQ,WEIGK)
	END




 
	SUBROUTINE DEL_DSNULTOS(MY,INUC,IPAN,IQPNT)
***********************************************************
*  Initialize change in the TOS-matrix, i.e. set to zero  *
***********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_PANPAR,  ONLY : LTPAN,LSPAN,IATS,ISTS                      !!! from readini
	USE COM_KAPPAR,  ONLY : NPAN,NKAP,EK,EKAP                          !!! from readini
	USE COM_DHAMPAR, ONLY : DTOSHH=>DELHHH                             !!! from tospar
     &                       ,DTOSJH=>DELHJH
     &                       ,DTOSHJ=>DELHHJ
     &                       ,DTOSJJ=>DELHJJ 
	USE COM_NBANDS,  ONLY : NBNDF,NBNDE,NBNDT,NBNDH                    !!! from readini
	USE COM_DYNMAT,  ONLY : BNDMAT                                     !!! from d2dynend
      USE COM_EPIMAT,  ONLY : EPIMAT,VELMAT                              !!! from nultos
	USE COM_MASHDEP, ONLY : NVAL                                       !!! from setup
	USE COM_PHNCHN  ,ONLY : IUDTS                                      !!! from channels
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	LOGICAL LOG1,LOG,EXIST
	DATA PI/3.141592653589793D0/
C  SET CHANGE IN THE TOS-MATRIX TO ZERO
	DO IKAP1=1,NKAP(IPAN)                             !!! over energies
	DO IKAP=1,NKAP(IPAN)                              !!! over energies
	DO IATOM=1,NATOM                                  !!! over iatom
	ISORT=IS(IATOM)
	DO L1=0,ILST(ISORT)                               !!! over l1
	LOG1=.FALSE.
	IF(L1.LE.ILSB(ISORT))LOG1=.TRUE.
	DO M1=-L1,L1                                      !!! over m1
	L1M1=L1*(L1+1)+M1+1
	DO L=0,ILST(ISORT)                                !!! over l
	LOG=.FALSE.
	IF(L.LE.ILSB(ISORT))LOG=.TRUE.
	DO M=-L,L                                         !!! over m
	LM=L*(L+1)+M+1
	IF(LOG1.AND.LOG)
     &DTOSHH(L1M1,LM,IATOM,IKAP1,IKAP)=(0.D0,0.D0)
	IF(LOG1)
     &DTOSHJ(L1M1,LM,IATOM,IKAP1,IKAP)=(0.D0,0.D0)
	IF(LOG)
     &DTOSJH(L1M1,LM,IATOM,IKAP1,IKAP)=(0.D0,0.D0)
	DTOSJJ(L1M1,LM,IATOM,IKAP1,IKAP)=(0.D0,0.D0)
      ENDDO                                             !!! over m
      ENDDO                                             !!! over l
      ENDDO                                             !!! over m1
      ENDDO                                             !!! over l1
      ENDDO                                             !!! over atoms
      ENDDO                                             !!! over energies
      ENDDO                                             !!! over energies
C  WRITE ZEROES
      DO IORBS=1,NORBS                                  !!! over iorbs
      DO ISPIN=1,NSPIN                                  !!! over ispin
      IF(MODE.NE.5)CALL TOSFILES(MY,INUC,IPAN,ISPIN,IORBS,IUDTS,'W')
      ENDDO                                             !!! over ispin
      ENDDO                                             !!! over iorbs
C  SET ZERO IN THE ELECTRON-PHONON MATRIX ELEMENTS
	IF(IPAN.EQ.1)THEN
      DO INUC1=1,NATOM                                  !!! over displacements
      DO MY1=-1,1                                       !!! over polarizations
	DO II=1,4
      EPIMAT(MY1,INUC1,MY,INUC,II)=(0.D0,0.D0)
      VELMAT(MY1,INUC1,MY,INUC,II)=(0.D0,0.D0)
      ENDDO   
      ENDDO                                             !!! over polarizations
      ENDDO                                             !!! over displacements
	ENDIF
C  SET ZERO IN THE BAND CONTRIBUTION TO THE DYNAMICAL MATRIX
      DO INUC1=1,NATOM                                  !!! over displacements
      DO MY1=-1,1                                       !!! over polarizations
	DO II=1,10
      BNDMAT(MY1,INUC1,MY,INUC,II,IPAN)=(0.D0,0.D0)
      ENDDO   
      ENDDO                                             !!! over polarizations
      ENDDO                                             !!! over displacements
	END





      SUBROUTINE TOSFILES(MY,INUC,IPAN,IUPDN,IORBS,ICHN,TOPER)
***********************************************************
*  Reads/writes change in TOS-matrices.                   *
***********************************************************
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_PANPAR,  ONLY : LTPAN,LSPAN,IATS,ISTS                      !!! from readini
	USE COM_NBANDS,  ONLY : NBNDF,NBNDE,NBNDT,NBNDH                    !!! from readini
	USE COM_KAPPAR,  ONLY : NPAN,NKAP,EK,EKAP                          !!! from readini
	USE COM_DHAMPAR, ONLY : DTOSHH=>DELHHH                             !!! from tospar
     &                       ,DTOSJH=>DELHJH
     &                       ,DTOSHJ=>DELHHJ
     &                       ,DTOSJJ=>DELHJJ 
	USE COM_MASHDEP, ONLY : NVAL                                       !!! from setup
	USE COM_LMTOUT,  ONLY : SCRFILE,SCNFILE                            !!! from setup
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
      IMPLICIT REAL*8 (A-H,O-Z)
      LOGICAL LOG1,LOG,EXIST
      CHARACTER TOPER*1,STATUS*3,TFILE*60
      DATA PI/3.141592653589793D0/
	IF(MODE.EQ.5)RETURN
C SCRATCH FILE FOR STORING CHANGE IN POTENTIAL PARAMETERS
      NRECL=0
      DO IATOM=1,NATOM
      ISORT=IS(IATOM)
      LMAXH=((ILSB(ISORT)+1)**2+(ILST(ISORT)+1)**2)**2
      NRECL=MAX(NRECL,NVAL*LMAXH)
      ENDDO
      TFILE=SCNFILE(MY,INUC,ICHN)
      INQUIRE(FILE=TFILE,EXIST=EXIST)
      IF(.NOT.EXIST)STATUS='NEW'
      IF(     EXIST)STATUS='OLD'
C *** DELETE FILE
      IF(TOPER.EQ.'D')THEN
	NRECL=4
      OPEN(UNIT=ICHN,FILE=TFILE,STATUS=STATUS,FORM='UNFORMATTED',
     &  ACCESS='DIRECT',RECL=NRECL)
      CLOSE(UNIT=ICHN,STATUS='DELETE')
      RETURN
      ENDIF
C READ/WRITE ACCORDING TO <<TOPER>>
      OPEN(UNIT=ICHN,FILE=TFILE,STATUS=STATUS,ACCESS='DIRECT',
     &  FORM='UNFORMATTED',RECL=NRECL)
      DO IATOM=1,NATOM               !!! over atoms
      ISORT=IS(IATOM)
      DO IKAP1=1,NKAP(IPAN)          !!! over ikap1
      DO IKAP=1,NKAP(IPAN)           !!! over ikap
      IREC=IKAP1+NKAP(IPAN)*(IKAP-1)+
     &NKAP(IPAN)**2*(IATOM-1)+
     &NKAP(IPAN)**2*NATOM*(IUPDN-1)+
     &NKAP(IPAN)**2*NATOM*NSPIN*(IORBS-1)
      IF(TOPER.EQ.'R')
     &READ(ICHN,REC=IREC)
     &((DTOSHH(L1M1,LM,IATOM,IKAP1,IKAP),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((DTOSJH(L1M1,LM,IATOM,IKAP1,IKAP),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((DTOSHJ(L1M1,LM,IATOM,IKAP1,IKAP),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &((DTOSJJ(L1M1,LM,IATOM,IKAP1,IKAP),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2)
      IF(TOPER.EQ.'W')
     &WRITE(ICHN,REC=IREC)
     &((DTOSHH(L1M1,LM,IATOM,IKAP1,IKAP),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((DTOSJH(L1M1,LM,IATOM,IKAP1,IKAP),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((DTOSHJ(L1M1,LM,IATOM,IKAP1,IKAP),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &((DTOSJJ(L1M1,LM,IATOM,IKAP1,IKAP),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2)
      ENDDO                          !!! over ikap
      ENDDO                          !!! over ikap1
      ENDDO                          !!! over atoms
	CLOSE(ICHN)
      END
