	SUBROUTINE DEL_SDYNBND(IPNT,ISGQ,IPAN,IQPNT)
***********************************************************
*  Computes band contribution to the dynamical matrix.    *
***********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
      USE COM_PHNCOM,  ONLY : ITERMAX,NITER                              !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_KAPPAR,  ONLY : NPAN,NKAP,EK,EKAP                          !!! from readini
	USE COM_PANPAR,  ONLY : LTPAN,LSPAN,IATS,ISTS                      !!! from readini
	USE COM_GROUPS,  ONLY : NGROUP,INV,IKOV                            !!! from makegrp
	USE COM_NBANDS,  ONLY : NBNDF,NBNDE,NBNDT,NBNDC,NBNDH,POLUS        !!! from readini
	USE COM_ENERGY,  ONLY : ETRT                                       !!! from lmtbnd
	USE COM_SUBGROUP,ONLY : NSGQ,NGEQ,ISG                              !!! from delmesh
      USE COM_D2HAML,  ONLY : D2HMATK,D2OMATK,D2HMATQ,D2OMATQ            !!! from d2lmat
      USE COM_DELHAM,  ONLY : DHMATT,DOMATT,DHMATR,DOMATR,DVINTR         !!! from dintmat
	USE COM_DYNMAT,  ONLY : BNDMAT                                     !!! from d2dynend
	USE COM_SYMMESH, ONLY : IG0IG1,IK0IK1                              !!! from delmesh
	USE COM_KMESH,   ONLY : NPNT,PNT,WGT                               !!! from makettr
	USE COM_MASHDEP, ONLY : NVAL                                       !!! from setup
	USE COM_PHNCHN  ,ONLY : IUTTW                                      !!! from channels
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8, ALLOCATABLE :: WEIGQ(:,:,:)
	REAL*8, ALLOCATABLE :: WEIGK(:,:)
	COMPLEX*16 DMATT1,DMATT2,DMATR1,DMATR2,DBND(10)
	LOGICAL LOG1,LOG,EXIST
	DATA PI/3.141592653589793D0/
	IF(MODE.NE.4)RETURN
C Memory allocations
	ALLOCATE(WEIGK(NBNDC(1)*NSPINMEM,4))
	ALLOCATE(WEIGQ(NBNDC(1)*NSPINMEM,NBNDC(1)*NSPINMEM,6))
C  SET POINT-GROUP INFORMATION
	IRK=ISG(1,ISGQ)       !!!  element "g"  in the main G-list
	IGK=IKOV(IRK)         !!!  element "g"  after Kovalev
	IPNTK=IPNT            !!!  point   "k"
	IRQ=IG0IG1(IPNT,IRK)  !!!  element "g'" in the main G-list
	IGQ=IKOV(IRQ)         !!!  element "g'" after Kovalev
	IPNTQ=IK0IK1(IPNT,IRK)!!!  point   "k'" such that g*k+q=g'*k'
C  READ 1/E TETRAHEDRON WEIGHTS FOR BRILLOUIN ZONE INTEGRATION
	IREC=1+IPNTK+NPNT(1)*(ISGQ-1)
	IF(IPAN.EQ.1)THEN
	READ(IUTTW,REC=IREC)WGTQ1,
     &(((WEIGQ(IBANC,IBANC1,IC),IBANC=1,NBNDC(1)*NSPIN),
     &IBANC1=1,NBNDC(1)*NSPIN),IC=1,6),
     &((WEIGK(IBANC,IC),IBANC=1,NBNDC(1)*NSPIN),IC=1,4)
	ELSE ! only geometrical weigths are neccessary
	READ(IUTTW,REC=IREC)WGTQ1
	ENDIF
C **** CALCULATE BAND CONTRIBUTION FROM A GIVEN K-POINT ****
      DO 4000 INUC1=1,NATOM          !!! over displacements
      DO 3000 INUC =1,NATOM          !!! over displacements
      DO 2000 MY1=-1,1               !!! over polarizations
      DO 1000 MY=-1,1                !!! over polarizations
	IF(NITER(MY1,INUC1).EQ.0)GOTO1000
	IF(NITER(MY ,INUC ).EQ.0)GOTO1000
C  FIRST TERM IS GOING FROM THE FIRST-ORDER CHANGE IN THE HAMILTONIAN
	DO 520 IBNDS=1,NSPIN                           !!! over spin subbands
	DO 510 IBNDT=1,NBNDF(IPAN)                     !!! over filled bands
	IBNDC=IBNDT-NBNDE(IPAN)+1
	IBANC=IBNDS+NSPIN*(IBNDC-1)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	DO II=1,10
	DBND(II)=(0.D0,0.D0)
	ENDDO
	DO IBNDS1=1,NSPIN                              !!! over spin subbands
      DO IBNDT1=NBNDE(IPAN),NBNDT(IPAN)+NBNDH(IPAN)  !!! over unoccupied bands
	IF(IPAN.GT.1)
     &CALL FULLSTOP('<DELTOS>: Error in empty bands for ipan>1')
	IBNDC1=IBNDT1-NBNDE(IPAN)+1
	IBANC1=IBNDS1+NSPIN*(IBNDC1-1)
	IBAND1=IBNDS1+NSPIN*(IBNDT1-1)
C  SET MATRIX ELEMENTS
      ESUM1=ETRT(IBAND,IPNTK,IPAN)+ETRT(IBAND1,IPNTQ,IPAN)
	DMATT1=DHMATT(IBAND1,IBAND,MY1,INUC1)-0.5D0*ESUM1*
     &DOMATT(IBAND1,IBAND,MY1,INUC1)
	DMATR1=(-1)**MY*CONJG(DHMATR(IBAND1,IBAND,-MY,INUC)+
     &DVINTR(IBAND1,IBAND,-MY,INUC)-0.5D0*ESUM1*
     &DOMATR(IBAND1,IBAND,-MY,INUC))
      ESUM2=ETRT(IBAND1,IPNTK,IPAN)+ETRT(IBAND,IPNTQ,IPAN)
	DMATT2=DHMATT(IBAND,IBAND1,MY1,INUC1)-0.5D0*ESUM2*
     &DOMATT(IBAND,IBAND1,MY1,INUC1)
	DMATR2=(-1)**MY*CONJG(DHMATR(IBAND,IBAND1,-MY,INUC)+
     &DVINTR(IBAND,IBAND1,-MY,INUC)-0.5D0*ESUM2*
     &DOMATR(IBAND,IBAND1,-MY,INUC))
C  *** CONTRIBUTION FROM UNOCCUPIED STATES ***
	WQ1=0.D0
	WQ2=0.D0
	IF(IBNDT.GE.NBNDE(IPAN).AND.IBNDT1.GT.NBNDF(IPAN))THEN
C  USING USUAL TETRAHEDRON WEIGHTS 
	DEK1=ETRT(IBAND,IPNTK,IPAN)-ETRT(IBAND1,IPNTQ,IPAN)
      DEK2=ETRT(IBAND1,IPNTK,IPAN)-ETRT(IBAND,IPNTQ,IPAN)
                IF(ABS(DEK1).LE.1.D-10)THEN
                IF(ABS(WEIGK(IBNDC,1)).GE.1.D-10)
     &          WRITE(IUT,*)'<DYNBND> :: ERROR IN WEIGHTS'
                WEIGK(IBANC,1)=0.D0
                DEK1=1.D0
                ENDIF
                IF(ABS(DEK2).LE.1.D-10)THEN
                IF(ABS(WEIGK(IBANC,2)).GE.1.D-10)
     &          WRITE(IUT,*)'<DYNBND> :: ERROR IN WEIGHTS'
                WEIGK(IBANC,2)=0.D0
                DEK2=1.D0
                ENDIF
	WQ1=WEIGK(IBANC,1)/DEK1     !!! f(kj)  /[E(kj)-E(k+qj')]
	WQ2=WEIGK(IBANC,2)/DEK2     !!! f(k+qj)/[E(kj')-E(k+qj)]
	ELSEIF(IBNDT.LT.NBNDE(IPAN).AND.IBNDT1.LE.NBNDF(IPAN))THEN
	DEK1=ETRT(IBAND,IPNTK,IPAN)-ETRT(IBAND1,IPNTQ,IPAN)
      DEK2=ETRT(IBAND1,IPNTK,IPAN)-ETRT(IBAND,IPNTQ,IPAN)
                IF(ABS(DEK1).LE.1.D-10)THEN
                IF(ABS(WGTQ1-WEIGK(IBANC1,2)).GE.1.D-10)
     &          WRITE(IUT,*)'<DYNBND> :: ERROR IN WEIGHTS'
                WEIGK(IBANC1,2)=WGTQ1
                DEK1=1.D0
                ENDIF
                IF(ABS(DEK2).LE.1.D-10)THEN
                IF(ABS(WGTQ1-WEIGK(IBANC1,1)).GE.1.D-10)
     &          WRITE(IUT,*)'<DYNBND> :: ERROR IN WEIGHTS'
                WEIGK(IBANC1,1)=WGTQ1
                DEK1=1.D0
                ENDIF
	WQ1=(WGTQ1-WEIGK(IBANC1,2))/DEK1 !!! [1-f(k+qj')]/[E(kj)-E(k+qj')]
	WQ2=(WGTQ1-WEIGK(IBANC1,1))/DEK2 !!! [1-f(kj')  ]/[E(kj')-E(k+qj)]
	ELSEIF(IBNDT.LT.NBNDE(IPAN).AND.IBNDT1.GT.NBNDF(IPAN))THEN
	DEK1=ETRT(IBAND,IPNTK,IPAN)-ETRT(IBAND1,IPNTQ,IPAN)
      DEK2=ETRT(IBAND1,IPNTK,IPAN)-ETRT(IBAND,IPNTQ,IPAN)
	WQ1=WGTQ1/DEK1              !!! 1/[E(kj)-E(k+qj')]
	WQ2=WGTQ1/DEK2              !!! 1/[E(kj')-E(k+qj)]
	ENDIF
      DBND(4)=DBND(4)+WQ1*DMATT1*DMATR1
      DBND(4)=DBND(4)-WQ2*DMATT2*DMATR2
C  *** CONTRIBUTION FROM THE FERMI-SURFACE BANDS ***
	IF(IBNDT.GE.NBNDE(IPAN).AND.IBNDT1.LE.NBNDF(IPAN))THEN
C  USING USUAL TETRAHEDRON WEIGHTS AND LORENTZIAN SMEARING
	DEK1=ETRT(IBAND,IPNTK,IPAN)-ETRT(IBAND1,IPNTQ,IPAN)
      DEK2=ETRT(IBAND1,IPNTK,IPAN)-ETRT(IBAND,IPNTQ,IPAN)
	WQ1=WEIGK(IBANC,1)*DEK1/(DEK1**2+POLUS**2)!!! f(kj)  /[E(kj)-E(k+qj')]
	WQ2=WEIGK(IBANC,2)*DEK2/(DEK2**2+POLUS**2)!!! f(k+qj)/[E(kj')-E(k+qj)]
      DBND(5)=DBND(5)+WQ1*DMATT1*DMATR1
      DBND(5)=DBND(5)-WQ2*DMATT2*DMATR2
C   1/E TETRAHEDRON WEIGHTS
      WQ1=WEIGQ(IBANC,IBANC1,1) !!! f(kj)*[1-f(k+qj')]/[E(kj)-E(k+qj')]
      WQ2=WEIGQ(IBANC1,IBANC,2) !!! [1-f(kj')]*f(k+qj)/[E(kj')-E(k+qj)]
C  WEIGHTS FROM DENSITY-OF-STATES AT EF
      WQ1=WQ1+WEIGQ(IBANC,IBANC1,3) !!! +0.5*Delta[E(kj )-Ef]
      WQ2=WQ2+WEIGQ(IBANC1,IBANC,4) !!! -0.5*Delta[E(kj')-Ef]
C  SUBTRACT LORENTZIAN SMEARING
      WQ1=WQ1-WEIGQ(IBANC,IBANC1,5) !!! f(kj)*[1-f(k+qj')]/[E(kj)-E(k+qj')]
      WQ2=WQ2-WEIGQ(IBANC1,IBANC,6) !!! [1-f(kj')]*f(k+qj)/[E(kj')-E(k+qj)]
      DBND(6)=DBND(6)+WQ1*DMATT1*DMATR1
      DBND(6)=DBND(6)-WQ2*DMATT2*DMATR2
C  CHECK OUT FOR CANCELLATION OF LORENTZIAN SMEARING
      WQ1=WEIGQ(IBANC,IBANC1,1) !!! f(kj)*[1-f(k+qj')]/[E(kj)-E(k+qj')]
      WQ2=WEIGQ(IBANC1,IBANC,2) !!! [1-f(kj')]*f(k+qj)/[E(kj')-E(k+qj)]
      WQ1=WQ1+WEIGQ(IBANC,IBANC1,3) !!! +0.5*Delta[E(kj )-Ef]
      WQ2=WQ2+WEIGQ(IBANC1,IBANC,4) !!! -0.5*Delta[E(kj')-Ef]
      DBND(7)=DBND(7)+WQ1*DMATT1*DMATR1
      DBND(7)=DBND(7)-WQ2*DMATT2*DMATR2
C  WEIGHTS FROM DENSITY-OF-STATES AT EF
      WQ1=WEIGQ(IBANC,IBANC1,3)     !!! +0.5*Delta[E(kj )-Ef]
      WQ2=WEIGQ(IBANC1,IBANC,4)     !!! -0.5*Delta[E(kj')-Ef]
      DBND(8)=DBND(8)+WQ1*DMATT1*DMATR1
      DBND(8)=DBND(8)-WQ2*DMATT2*DMATR2
	ENDIF
      ENDDO                         !!! over unoccupied bands
      ENDDO                         !!! over spin subbands
C  CONTRIBUTION FROM ALL STATES
      DO IBNDS1=1,NSPIN             !!! over spin subbands
      DO IBNDT1=1,NBNDT(IPAN)+NBNDH(IPAN)  !!! over all bands
	IBNDC1=IBNDT1-NBNDE(IPAN)+1
	IBANC1=IBNDS1+NSPIN*(IBNDC1-1)
	IBAND1=IBNDS1+NSPIN*(IBNDT1-1)
      IF(IBNDT.GE.NBNDE(IPAN))THEN
      WQ1=WEIGK(IBANC,1)          !!! f(kj)
      WQ2=WEIGK(IBANC,2)          !!! f(k+qj)
      ELSEIF(IBNDT.LT.NBNDE(IPAN))THEN
      WQ1=WGTQ1                   !!! 1
      WQ2=WGTQ1                   !!! 1
      ENDIF
      ESUM1=ETRT(IBAND,IPNTK,IPAN)+ETRT(IBAND1,IPNTQ,IPAN)
      EDEL1=ETRT(IBAND,IPNTK,IPAN)-ETRT(IBAND1,IPNTQ,IPAN)
      DBND(4)=DBND(4)-WQ1*(
     &  DHMATT(IBAND1,IBAND,MY1,INUC1)-0.5D0*ESUM1*
     &  DOMATT(IBAND1,IBAND,MY1,INUC1))*(-1)**MY*CONJG(
     &  0.5D0*DOMATR(IBAND1,IBAND,-MY,INUC))
      DBND(4)=DBND(4)-WQ1*
     &  0.5D0*DOMATT(IBAND1,IBAND,MY1,INUC1)*(-1)**MY*CONJG(
     &  DHMATR(IBAND1,IBAND,-MY,INUC)+DVINTR(IBAND1,IBAND,-MY,INUC)-
     &  0.5D0*ESUM1*DOMATR(IBAND1,IBAND,-MY,INUC))
      DBND(4)=DBND(4)+WQ1*EDEL1*
     &  0.5D0*DOMATT(IBAND1,IBAND,MY1,INUC1)*(-1)**MY*CONJG(
     &  0.5D0*DOMATR(IBAND1,IBAND,-MY,INUC))
      ESUM2=ETRT(IBAND1,IPNTK,IPAN)+ETRT(IBAND,IPNTQ,IPAN)
      EDEL2=ETRT(IBAND1,IPNTK,IPAN)-ETRT(IBAND,IPNTQ,IPAN)
      DBND(4)=DBND(4)-WQ2*(
     &  DHMATT(IBAND,IBAND1,MY1,INUC1)-0.5D0*ESUM2*
     &  DOMATT(IBAND,IBAND1,MY1,INUC1))*(-1)**MY*CONJG(
     &  0.5D0*DOMATR(IBAND,IBAND1,-MY,INUC))
      DBND(4)=DBND(4)-WQ2*
     &  0.5D0*DOMATT(IBAND,IBAND1,MY1,INUC1)*(-1)**MY*CONJG(
     &  DHMATR(IBAND,IBAND1,-MY,INUC)+DVINTR(IBAND,IBAND1,-MY,INUC)-
     &  0.5D0*ESUM2*DOMATR(IBAND,IBAND1,-MY,INUC))
      DBND(4)=DBND(4)-WQ2*EDEL2*
     &  0.5D0*DOMATT(IBAND,IBAND1,MY1,INUC1)*(-1)**MY*CONJG(
     &  0.5D0*DOMATR(IBAND,IBAND1,-MY,INUC))
      ENDDO                        !!! over all bands
      ENDDO                        !!! over spin subbands
C  CONTRIBUTION FROM THE SECOND-ORDER CHANGE IN THE HAMILTONIAN
      IF(IBNDT.GE.NBNDE(IPAN))THEN
      WQ1=WEIGK(IBANC,1)          !!! f(kj)
      WQ2=WEIGK(IBANC,2)          !!! f(k+qj)
      ELSEIF(IBNDT.LT.NBNDE(IPAN))THEN
      WQ1=WGTQ1                   !!! 1
      WQ2=WGTQ1                   !!! 1
      ENDIF
	DO II=1,3
      DBND(II)=DBND(II)+(D2HMATK(MY1,INUC1,MY,INUC,IBAND,II)-
     &ETRT(IBAND,IPNTK,IPAN)*D2OMATK(MY1,INUC1,MY,INUC,
     &IBAND,II))*WQ1
      DBND(II)=DBND(II)+(D2HMATQ(MY1,INUC1,MY,INUC,IBAND,II)-
     &ETRT(IBAND,IPNTQ,IPAN)*D2OMATQ(MY1,INUC1,MY,INUC,
     &IBAND,II))*WQ2
	ENDDO
	DO II=1,9
      BNDMAT(MY1,INUC1,MY,INUC,II,IPAN)=
     &BNDMAT(MY1,INUC1,MY,INUC,II,IPAN)+DBND(II)
      ENDDO    
  510 CONTINUE                     !!! over occupied bands
  520 CONTINUE                     !!! over spin subbands
 1000 CONTINUE                     !!! over polarizations
 2000 CONTINUE                     !!! over polarizations
 3000 CONTINUE                     !!! over displacements
 4000 CONTINUE                     !!! over displacements
 5000 CONTINUE                     !!! over iupdn
 6000 CONTINUE                     !!! over iorbs
C Memory deallocations
	DEALLOCATE(WEIGQ,WEIGK)
	END
