	SUBROUTINE DEL_SEPIBND(IPNT,ISGQ,IPAN,IQPNT)
***********************************************************
*  Calculates electron-phonon interaction matrix elements.*
***********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_KAPPAR,  ONLY : NPAN,NKAP,EK,EKAP                          !!! from readini
	USE COM_NBANDS,  ONLY : NBNDF,NBNDE,NBNDT,NBNDC,NBNDH              !!! from readini
	USE COM_SUBGROUP,ONLY : NSGQ,NGEQ,ISG,KSYMPN                       !!! from delmesh
	USE COM_KMESH,   ONLY : NPNT,PNT                                   !!! from makettr
	USE COM_QMESH,   ONLY : NQPNT,QPNT                                 !!! from readpnt
	USE COM_LRTCOM,  ONLY : LWAV                                       !!! from readlrt
      USE COM_EPIMAT,  ONLY : EPIMAT,VELMAT                              !!! from nultos
	USE COM_DELHAM,  ONLY : DHMATT,DOMATT                              !!! from delmat
	USE COM_SYMMESH, ONLY : IG0IG1,IK0IK1                              !!! from delmesh
	USE COM_ENERGY,  ONLY : ETRT                                       !!! from lmtbnd
	USE COM_GROUPS,  ONLY : NGROUP,U,INV,IKOV                          !!! from makegrp
	USE COM_MASHDEP, ONLY : NVAL                                       !!! from setup
	USE COM_PHNCHN  ,ONLY : IUTTR                                      !!! from channels
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: DELH(:,:,:,:)
	REAL*8, ALLOCATABLE :: WEPI(:,:)
	REAL*8, ALLOCATABLE :: WVEL(:,:,:)
	REAL*8 TBHARMK(0:9),TBHARMQ(0:9),PKT(3),PQT(3)
	DATA PI/3.141592653589793D0/
	IF(MODE.NE.5)RETURN
   	IF(IPAN.NE.1)RETURN
C Memory allocations
	ALLOCATE(DELH(NBNDC(1)*NSPINMEM,NBNDC(1)*NSPINMEM,-1:1,NATOMMEM))
	ALLOCATE(WEPI(NBNDC(1)*NSPINMEM,NBNDC(1)*NSPINMEM))
	ALLOCATE(WVEL(NBNDC(1)*NSPINMEM,NBNDC(1)*NSPINMEM,3))
C  SET POINT-GROUP INFORMATION
      IRK=ISG(1,ISGQ)       !!!  element "g"  in the main G-list
      IGK=IKOV(IRK)         !!!  element "g"  after Kovalev
      IPNTK=IPNT            !!!  point   "k"
      IRQ=IG0IG1(IPNT,IRK)  !!!  element "g'" in the main G-list
      IGQ=IKOV(IRQ)         !!!  element "g'" after Kovalev
      IPNTQ=IK0IK1(IPNT,IRK)!!!  point   "k'" such that g*k+q=g'*k'
C  ROTATE K-VECTOR BY SYMMETRY OPERATION
      CALL LIB_ROTATE(PNT(1,IPNTK,IPAN),PNT(2,IPNTK,IPAN),
     &  PNT(3,IPNTK,IPAN),XK,YK,ZK,U(2,IGK),2)
C  POINT G*K
	PKT(1)=XK*2.D0*PI
	PKT(2)=YK*2.D0*PI
	PKT(3)=ZK*2.D0*PI
C  POINT G*K+Q
	PQT(1)=(XK+QPNT(1,IQPNT))*2.D0*PI
	PQT(2)=(YK+QPNT(2,IQPNT))*2.D0*PI
	PQT(3)=(ZK+QPNT(3,IQPNT))*2.D0*PI
C  TIGHT-BINDING CUBIC HARMONICS
C  EXTENDED S-WAVE: S^{*}
      AA=-0.3043185
      TBHARMK(0)=AA+COS(PKT(1))+COS(PKT(2))!+COS(PKT(3))
      TBHARMQ(0)=AA+COS(PQT(1))+COS(PQT(2))!+COS(PQT(3))
C  S-WAVE:
      TBHARMK(1)=1.D0
      TBHARMQ(1)=1.D0
C  P-WAVE:
      TBHARMK(2)=SIN(PKT(1))
      TBHARMK(3)=SIN(PKT(2))
      TBHARMK(4)=SIN(PKT(3))
      TBHARMQ(2)=SIN(PQT(1))
      TBHARMQ(3)=SIN(PQT(2))
      TBHARMQ(4)=SIN(PQT(3))
C  D-WAVE:
C  Y*Z
      TBHARMK(5)=SIN(PKT(2))*SIN(PKT(3))
      TBHARMQ(5)=SIN(PQT(2))*SIN(PQT(3))
C  Z*X
      TBHARMK(6)=SIN(PKT(3))*SIN(PKT(1))
      TBHARMQ(6)=SIN(PQT(3))*SIN(PQT(1))
C  X*Y
      TBHARMK(7)=SIN(PKT(1))*SIN(PKT(2))
      TBHARMQ(7)=SIN(PQT(1))*SIN(PQT(2))
C  X^2-Y^2
      TBHARMK(8)=COS(PKT(1))-COS(PKT(2))
      TBHARMQ(8)=COS(PQT(1))-COS(PQT(2))
C  3Z^2-R^2
      TBHARMK(9)=2.D0*COS(PKT(3))-COS(PKT(1))-COS(PKT(2))
      TBHARMQ(9)=2.D0*COS(PQT(3))-COS(PQT(1))-COS(PQT(2))
C  CALCULATE CONTRIBUTION FROM A GIVEN K-POINT
      IREC=1+IPNT+NPNT(IPAN)*(ISGQ-1)
      READ(IUTTR,REC=IREC)
     &  ((WEPI(IBANC,IBANC1  ),IBANC =1,NBNDC(1)*NSPIN),
     &                         IBANC1=1,NBNDC(1)*NSPIN),
     &  ((WVEL(IBANC,IBANC1,1),IBANC =1,NBNDC(1)*NSPIN),
     &                         IBANC1=1,NBNDC(1)*NSPIN),
     &  ((WVEL(IBANC,IBANC1,2),IBANC =1,NBNDC(1)*NSPIN),
     &                         IBANC1=1,NBNDC(1)*NSPIN),
     &  ((WVEL(IBANC,IBANC1,3),IBANC =1,NBNDC(1)*NSPIN),
     &                         IBANC1=1,NBNDC(1)*NSPIN),
     &  ((((DELH(IBANC,IBANC1,MYT,INUCT),IBANC=1,NBNDC(1)*NSPIN),
     &  IBANC1=1,NBNDC(1)*NSPIN),MYT=-1,1),INUCT=1,NATOM)
C  REDEFINE MATRIX ELEMENTS FOR "MY,INUC"
      DO IBNDS=1,NSPIN                  ! over spin subbands
      IBNDC=0
      DO IBNDT=NBNDE(IPAN),NBNDF(IPAN)  ! over bands
      IBNDC=IBNDC+1
	IBANC=IBNDS+NSPIN*(IBNDC-1)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
      DO IBNDS1=1,NSPIN                 ! over spin subbands
      IBNDC1=0
      DO IBNDT1=NBNDE(IPAN),NBNDF(IPAN) ! over bands
      IBNDC1=IBNDC1+1
	IBANC1=IBNDS1+NSPIN*(IBNDC1-1)
	IBAND1=IBNDS1+NSPIN*(IBNDT1-1)
	DO INUC=1,NATOM
	DO MY=-1,1
	DELH(IBANC1,IBANC,MY,INUC)=DHMATT(IBAND1,IBAND,MY,INUC)-
     &  ETRT(IBAND,IPNT,IPAN)*DOMATT(IBAND1,IBAND,MY,INUC)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	DO INUC1=1,NATOM              !!! over displacements
	DO INUC =1,NATOM              !!! over displacements
	DO MY1=-1,1                   !!! over polarizations
	DO MY=-1,1                    !!! over polarizations
	DO IBNDS=1,NSPIN                      ! over spin subbands
	DO IBNDC=1,NBNDF(IPAN)-NBNDE(IPAN)+1  ! over bands
	IBANC=IBNDS+NSPIN*(IBNDC-1)
	DO IBNDS1=1,NSPIN                      ! over spin subbands
	DO IBNDC1=1,NBNDF(IPAN)-NBNDE(IPAN)+1 ! over bands
	IBANC1=IBNDS1+NSPIN*(IBNDC1-1)
C TOTAL CONTRIBUTION TO THE HOPFIELD MATRIX
	EPIMAT(MY1,INUC1,MY,INUC,3)=
     &EPIMAT(MY1,INUC1,MY,INUC,3)+
     &DELH(IBANC1,IBANC,MY1,INUC1)*
     &(-1)**MY*CONJG(DELH(IBANC1,IBANC,-MY,INUC))*
     &WEPI(IBANC,IBANC1)*TBHARMK(LWAV)*TBHARMQ(LWAV)
C TRANSPORT MATRICES V(kj)*V(kj) (1); V(k+qj')*V(k+qj') (2); V(kj)*V(k+qj') (3)
	VELMAT(MY1,INUC1,MY,INUC,1)=
     &VELMAT(MY1,INUC1,MY,INUC,1)+
     &DELH(IBANC1,IBANC,MY1,INUC1)*
     &(-1)**MY*CONJG(DELH(IBANC1,IBANC,-MY,INUC))*
     &WVEL(IBANC,IBANC1,1)
	VELMAT(MY1,INUC1,MY,INUC,2)=
     &VELMAT(MY1,INUC1,MY,INUC,2)+
     &DELH(IBANC1,IBANC,MY1,INUC1)*
     &(-1)**MY*CONJG(DELH(IBANC1,IBANC,-MY,INUC))*
     &WVEL(IBANC,IBANC1,2)
	VELMAT(MY1,INUC1,MY,INUC,3)=
     &VELMAT(MY1,INUC1,MY,INUC,3)+
     &DELH(IBANC1,IBANC,MY1,INUC1)*
     &(-1)**MY*CONJG(DELH(IBANC1,IBANC,-MY,INUC))*
     &WVEL(IBANC,IBANC1,3)
      ENDDO                        !!! over bands
      ENDDO                        !!! over spin subbands
      ENDDO                        !!! over bands
      ENDDO                        !!! over spin subbands
      ENDDO                        !!! over polarizations
      ENDDO                        !!! over polarizations
      ENDDO                        !!! over displacements
      ENDDO                        !!! over displacements
      WRITE(IUTTR,REC=IREC)
     &  ((WEPI(IBANC,IBANC1  ),IBANC =1,NBNDC(1)*NSPIN),
     &                         IBANC1=1,NBNDC(1)*NSPIN),
     &  ((WVEL(IBANC,IBANC1,1),IBANC =1,NBNDC(1)*NSPIN),
     &                         IBANC1=1,NBNDC(1)*NSPIN),
     &  ((WVEL(IBANC,IBANC1,2),IBANC =1,NBNDC(1)*NSPIN),
     &                         IBANC1=1,NBNDC(1)*NSPIN),
     &  ((WVEL(IBANC,IBANC1,3),IBANC =1,NBNDC(1)*NSPIN),
     &                         IBANC1=1,NBNDC(1)*NSPIN),
     &  ((((DELH(IBANC,IBANC1,MYT,INUCT),IBANC=1,NBNDC(1)*NSPIN),
     &  IBANC1=1,NBNDC(1)*NSPIN),MYT=-1,1),INUCT=1,NATOM)
C Memory allocations
	DEALLOCATE(DELH,WEPI,WVEL)
	END
