	SUBROUTINE DEL_SEPISYM(IQPNT)
***********************************************************
*  Written by S.Yu.Savrasov in Max-Planck-Institute, FRG. *
***********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_QMESH,   ONLY : NQPNT,QPNT                                 !!! from readpnt
	USE COM_GROUPS,  ONLY : NGROUP,U,IP,RDC,INV,IKOV                   !!! from makegrp
      USE COM_EPIMAT,  ONLY : EPIMAT,VELMAT                              !!! from nultos
	USE COM_SUBGROUP,ONLY : NSGQ,NGEQ,ISG                              !!! from delmesh
	USE COM_MASHDEP, ONLY : NVAL                                       !!! from setup
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: TMPMAT(:,:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: TMVMAT(:,:,:,:,:)
	COMPLEX*16 PHSQ
	DATA PI/3.141592653589793D0/
	IF(MODE.NE.5)RETURN
	ALLOCATE(TMPMAT(-1:1,NATOMMEM,-1:1,NATOMMEM,4))
	ALLOCATE(TMVMAT(-1:1,NATOMMEM,-1:1,NATOMMEM,4))
C  SET TEMPORARY MATRIX TO ZERO
	DO 50 INUC1=1,NATOM
	DO 40 INUC=1,NATOM
	DO 30 MY1=-1,1
	DO 20 MY =-1,1
	DO 10 II=1,4
	TMPMAT(MY1,INUC1,MY,INUC,II)=(0.D0,0.D0)
	TMVMAT(MY1,INUC1,MY,INUC,II)=(0.D0,0.D0)
  10  CONTINUE
  20  CONTINUE
  30  CONTINUE
  40  CONTINUE
  50  CONTINUE
C  DO OVER SYMMETRY GROUP FOR Q-VECTOR
	DO 180 INUC1=1,NATOM                  !!! over displacements
	DO 170 INUC=1,NATOM                   !!! over displacements 
	DO 160 MY1=-1,1                       !!! over polarizations
	DO 150 MY =-1,1                       !!! over polarizations
	DO 140 IGEQ=1,NGEQ                    !!! over group of q-vector
	IR=ISG(IGEQ,1)                        !!! element "g" in the main G-list
	IG=IKOV(IR)                           !!! element "g" after Kovalev
	INUC1G=IP(INUC1,IR)
	INUCG =IP(INUC ,IR)
	SQ=QPNT(1,IQPNT)*(RDC(1,INUC,IR)-RDC(1,INUC1,IR))+
     &   QPNT(2,IQPNT)*(RDC(2,INUC,IR)-RDC(2,INUC1,IR))+
     &   QPNT(3,IQPNT)*(RDC(3,INUC,IR)-RDC(3,INUC1,IR))
	PHSQ=EXP(2.D0*PI*SQ*(0.D0,1.D0))
	DO 130 M1=-1,1                        !!! over polarizations
	DO 120 M =-1,1                        !!! over polarizations
	IWIGM1=3+3*(1+M1)+MY1
	IWIGM =3+3*(1+M) +MY
	DO 110 II=1,4
C  ROTATE BAND CONTRIBUTION
	TMPMAT(MY1,INUC1,MY,INUC,II)=TMPMAT(MY1,INUC1,MY,INUC,II)+
     &  CONJG(U(IWIGM1,IG))*EPIMAT(M1,INUC1G,M,INUCG,II)*
     &  CONJG(U(IWIGM,IG))*PHSQ
	TMVMAT(MY1,INUC1,MY,INUC,II)=TMVMAT(MY1,INUC1,MY,INUC,II)+
     &  CONJG(U(IWIGM1,IG))*VELMAT(M1,INUC1G,M,INUCG,II)*
     &  CONJG(U(IWIGM,IG))*PHSQ
 110	CONTINUE
 120  CONTINUE                             !!! over m
 130  CONTINUE                             !!! over m1
 140  CONTINUE                             !!! over group of q-vector
 150  CONTINUE                             !!! over polarizations
 160  CONTINUE                             !!! over polarizations
 170  CONTINUE                             !!! over displacements
 180  CONTINUE                             !!! over displacements
C  NORMALIZATION
	DO 250 INUC1=1,NATOM
	DO 240 INUC=1,NATOM
	DO 230 MY1=-1,1
	DO 220 MY =-1,1
	DO 210 II=1,4
	EPIMAT(MY1,INUC1,MY,INUC,II)=
     &TMPMAT(MY1,INUC1,MY,INUC,II)/DBLE(NGEQ)
	VELMAT(MY1,INUC1,MY,INUC,II)=
     &TMVMAT(MY1,INUC1,MY,INUC,II)/DBLE(NGEQ)
 210  CONTINUE
 220  CONTINUE
 230  CONTINUE
 240  CONTINUE
 250  CONTINUE
	DEALLOCATE(TMPMAT,TMVMAT)
	END
