	SUBROUTINE NMTFILES(MY,INUC,IPAN,IUPDN,IORBS,ICHN,TOPER)
************************************************************
*  Reads/writes change in the Hpar from/to the SCRFILE.    *
************************************************************
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_PANPAR,  ONLY : LTPAN,LSPAN,IATS,ISTS                      !!! from readini
	USE COM_KAPPAR,  ONLY : NPAN,NKAP,EK,EKAP                          !!! from readini
	USE COM_MASHDEP, ONLY : NVAL                                       !!! from setup
	USE COM_DHAMPAR, ONLY : DELHHH,DELHJH,DELHHJ,DELHJJ                !!! from intpar
	USE COM_DOVRPAR, ONLY : DELOHH,DELOJH,DELOHJ,DELOJJ                !!! from intpar
	USE COM_LMTOUT,  ONLY : SCRFILE,SCNFILE                            !!! from setup
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
      LOGICAL LOG1,LOG,EXIST
	CHARACTER TOPER*1,STATUS*3,NFILE*60
      DATA PI/3.141592653589793D0/
C SCRATCH FILE FOR STORING CHANGE IN POTENTIAL PARAMETERS
      NRECL=0
      DO IATOM=1,NATOM
      ISORT=IS(IATOM)
      LMAXH=((ILSB(ISORT)+1)**2+(ILST(ISORT)+1)**2)**2+
     &     3*(ILSB(ISORT)+1)+1*(ILST(ISORT)+1)
      NRECL=MAX(NRECL,NVAL*LMAXH)
	ENDDO
	NFILE=SCNFILE(MY,INUC,ICHN)
      INQUIRE(FILE=NFILE,EXIST=EXIST)
      IF(.NOT.EXIST)STATUS='NEW'
      IF(     EXIST)STATUS='OLD'
C *** DELETE FILE
      IF(TOPER.EQ.'D')THEN
	NRECL=4
      OPEN(UNIT=ICHN,FILE=NFILE,STATUS=STATUS,FORM='UNFORMATTED',
     &  ACCESS='DIRECT',RECL=NRECL)
      CLOSE(UNIT=ICHN,STATUS='DELETE')
      RETURN
      ENDIF
	OPEN(UNIT=ICHN,FILE=NFILE,STATUS=STATUS,ACCESS='DIRECT',
     &  FORM='UNFORMATTED',RECL=NRECL)
C READ/WRITE ACCORDING TO <<TOPER>>
      DO IATOM=1,NATOM              !!! over atoms
	ISORT=IS(IATOM)
      DO IKAP1=1,NKAP(IPAN)         !!! over ikap1
      DO IKAP=1,NKAP(IPAN)          !!! over ikap
      IREC=IKAP1+NKAP(IPAN)*(IKAP-1)+NKAP(IPAN)**2*(IATOM-1)+
     &NKAP(IPAN)**2*NATOM*(IUPDN-1)+
     &NKAP(IPAN)**2*NATOM*NSPIN*(IORBS-1)
	IF(TOPER.EQ.'R')
     &READ(ICHN,REC=IREC)
     &  ((DELHHH(L1M1,LM,IATOM,IKAP1,IKAP),
     &  L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &  ((DELHJH(L1M1,LM,IATOM,IKAP1,IKAP),
     &  L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &  ((DELHHJ(L1M1,LM,IATOM,IKAP1,IKAP),
     &  L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &  ((DELHJJ(L1M1,LM,IATOM,IKAP1,IKAP),
     &  L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &  (DELOHH(IKAP1,IKAP,L,IATOM,IUPDN,IORBS),L=0,ILSB(ISORT)),
     &  (DELOJH(IKAP1,IKAP,L,IATOM,IUPDN,IORBS),L=0,ILSB(ISORT)),
     &  (DELOHJ(IKAP1,IKAP,L,IATOM,IUPDN,IORBS),L=0,ILSB(ISORT)),
     &  (DELOJJ(IKAP1,IKAP,L,IATOM,IUPDN,IORBS),L=0,ILST(ISORT))
      IF(TOPER.EQ.'W')
     &WRITE(ICHN,REC=IREC)
     &  ((DELHHH(L1M1,LM,IATOM,IKAP1,IKAP),
     &  L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &  ((DELHJH(L1M1,LM,IATOM,IKAP1,IKAP),
     &  L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &  ((DELHHJ(L1M1,LM,IATOM,IKAP1,IKAP),
     &  L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &  ((DELHJJ(L1M1,LM,IATOM,IKAP1,IKAP),
     &  L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &  (DELOHH(IKAP1,IKAP,L,IATOM,IUPDN,IORBS),L=0,ILSB(ISORT)),
     &  (DELOJH(IKAP1,IKAP,L,IATOM,IUPDN,IORBS),L=0,ILSB(ISORT)),
     &  (DELOHJ(IKAP1,IKAP,L,IATOM,IUPDN,IORBS),L=0,ILSB(ISORT)),
     &  (DELOJJ(IKAP1,IKAP,L,IATOM,IUPDN,IORBS),L=0,ILST(ISORT))
      ENDDO                          !!! over ikap
      ENDDO                          !!! over ikap1
      ENDDO                          !!! over atoms
	CLOSE(ICHN)
	END
