      SUBROUTINE DEL_DPSIVEC(MY,INUC,IPNT,ISGQ,IPAN,IQPNT)
****************************************************************
*  Calculates Fourier transform for pseudowavefunctions.       *
****************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_LATTICE, ONLY : RBAS,GBAS,TAU                              !!! from readstr
	USE COM_KAPPAR,  ONLY : NPAN,NKAP,EK,EKAP                          !!! from readini
	USE COM_PANPAR,  ONLY : LTPAN,LSPAN                                !!! from readini
	USE COM_LATPAR,  ONLY : PAR,ORTH,OMEGAC                            !!! from readini
	USE COM_PLWMESH, ONLY : NPLW,GPLW                                  !!! from makeplw
	USE COM_NBANDS,  ONLY : NBNDF,NBNDE,NBNDT,NBNDH                    !!! from readini
	USE COM_ETAPAR,  ONLY : ETA,CUT,LBAS,NBAS                          !!! from makeplw
	USE COM_GROUPS,  ONLY : NGROUP,U,INV,IKOV                          !!! from makegrp
	USE COM_SYMMESH, ONLY : IG0IG1,IK0IK1                              !!! from delmesh
	USE COM_SUBGROUP,ONLY : NSGQ,NGEQ,ISG                              !!! from delmesh
	USE COM_PSIVEC,  ONLY : APHK,APJK,APHQ,APJQ                        !!! from lmtvec
	USE COM_KMESH,   ONLY : NPNT,PNT                                   !!! from makettr
	USE COM_QMESH,   ONLY : NQPNT,QPNT                                 !!! from readpnt
	USE COM_TEILORG, ONLY : KEYT,BZM,GOPT,MBAS                         !!! from makeplw
	USE COM_DPSIVEC, ONLY : PSIK,PSIQ,DPSK,DPSQ,PNTK,PNTQ              !!! from d2psivec
	USE COM_SPHERE,  ONLY : SWZ,SMT                                    !!! from readini
	USE COM_INPTTR,  ONLY : NDIV,NDIW,SH                               !!! from readini
	USE COM_MASHDEP, ONLY : NVAL                                       !!! from setup
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: YLM(:,:)
	COMPLEX*16, ALLOCATABLE :: CFTR(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: CHIK(:)
	COMPLEX*16, ALLOCATABLE :: EXPK(:)
	DIMENSION PNTR(3)
	DATA PI/3.141592653589793D0/
C Memory allocations
	ALLOCATE(YLM(LIMBMEM,0:NBASMEM))
	ALLOCATE(CFTR(0:LMAXBMEM,NSORTMEM,NKAPMEM,0:NBASMEM))
	ALLOCATE(CHIK(0:NBASMEM))
	ALLOCATE(EXPK(0:NBASMEM))
C  SET POINT-GROUP INFORMATION
      IRK=ISG(1,ISGQ)       !!!  element "g"  in the main G-list
      IGK=IKOV(IRK)         !!!  element "g"  after Kovalev
      IPNTK=IPNT            !!!  point   "k"
      IRQ=IG0IG1(IPNT,IRK)  !!!  element "g'" in the main G-list
      IGQ=IKOV(IRQ)         !!!  element "g'" after Kovalev
      IPNTQ=IK0IK1(IPNT,IRK)!!!  point   "k'" such that g*k+q=g'*k'
C  ROTATE K-VECTOR BY SYMMETRY OPERATION
      CALL LIB_ROTATE(PNT(1,IPNTK,IPAN),PNT(2,IPNTK,IPAN),
     &  PNT(3,IPNTK,IPAN),XK,YK,ZK,U(2,IGK),2)
C  FIND K-POINT R=K+G WHICH HAS A MINIMAL LENGTH
	XK=XK+SH(1,IPAN)
	YK=YK+SH(2,IPAN)
	ZK=ZK+SH(3,IPAN)
	CALL REDUC2(XK,YK,ZK,NBAS,GPLW(1,0),PNTK(1),PNTK(2),PNTK(3),
     &  GRX,GRY,GRZ)
      IF(MODE.NE.5)IBNDMIN=1
      IF(MODE.NE.5)IBNDMAX=NBNDT(IPAN)+NBNDH(IPAN)
      IF(MODE.EQ.5)IBNDMIN=NBNDE(IPAN)
      IF(MODE.EQ.5)IBNDMAX=NBNDF(IPAN)
C  SET PSEUDOLMTOS FOR THE POINT IPNTK
	CALL BND_FTRMAT(PNTK,0,IPAN,PNTR,YLM,CFTR)
C  SET |PSI(k+G)> and D|PSI(k+G)> 
	DO 2000 IBNDS=1,NSPIN                         !!! over spin subbands
      DO 1000 IBNDT=IBNDMIN,IBNDMAX                 !!! over bands
      IBAND=IBNDS+NSPIN*(IBNDT-1)
	DO IORBS=1,NORBS                              !!! over spinors
      IF(NORBS.EQ.1)ISPIN=IBNDS
      IF(NORBS.EQ.2)ISPIN=IORBS
      DO IBAS=0,MIN(NBAS,MBAS)
      PSIK(IBAS,ISPIN,IBAND)=(0.D0,0.D0)
      DPSK(IBAS,ISPIN,IBAND)=(0.D0,0.D0)
	ENDDO
      DO IATOM=1,NATOM                               !!! over iatom
      ISORT=IS(IATOM)
C  CALCULATE EXPONENTIAL FACTOR
      DO IBAS=0,MIN(NBAS,MBAS)
      SCP=(GPLW(1,IBAS)+PNTK(1))*TAU(1,IATOM)+
     &    (GPLW(2,IBAS)+PNTK(2))*TAU(2,IATOM)+
     &    (GPLW(3,IBAS)+PNTK(3))*TAU(3,IATOM)
      EXPK(IBAS)=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	ENDDO
C  PSEUDOWAVEFUNCTION AND ITS RIGID CHANGE TO FIRST ORDER
      DO IKAP=1,NKAP(IPAN)                           !!! over energies
      DO L=0,ILSB(ISORT)                             !!! over l
      IF(LTPAN(L,IATOM,IKAP,IPAN))THEN
      DO M=-L,L                                      !!! over m
      LM=L*(L+1)+M+1
      DO IBAS=0,MIN(LBAS(L,ISORT,IKAP,IPAN),MBAS)
      PSIK(IBAS,ISPIN,IBAND)=PSIK(IBAS,ISPIN,IBAND)+
     &  APHK(LM,IATOM,IKAP,ISPIN,IBAND)*
     &  CFTR(L,ISORT,IKAP,IBAS)*EXPK(IBAS)*YLM(LM,IBAS)
	ENDDO
	IF(IATOM.EQ.INUC.AND.MODE.NE.2)THEN
      DO IBAS=0,MIN(LBAS(L,ISORT,IKAP,IPAN),MBAS)
      DPSK(IBAS,ISPIN,IBAND)=DPSK(IBAS,ISPIN,IBAND)-
     &APHQ(LM,IATOM,IKAP,ISPIN,IBAND)*
     &CFTR(L,ISORT,IKAP,IBAS)*EXPK(IBAS)*YLM(LM,IBAS)
	ENDDO
	ENDIF
      ENDDO                                          !!! over m
	ENDIF
      ENDDO                                          !!! over l
      ENDDO                                          !!! over ikap
      ENDDO                                          !!! over iatom
      ENDDO                                          !!! over spinors
 1000 CONTINUE                                       !!! over bands
 2000 CONTINUE                                       !!! over spin subbands
      PNTQ(1)=PNTK(1)+QPNT(1,IQPNT)
      PNTQ(2)=PNTK(2)+QPNT(2,IQPNT)
      PNTQ(3)=PNTK(3)+QPNT(3,IQPNT)
      CALL BND_FTRMAT(PNTQ,0,IPAN,PNTR,YLM,CFTR)
C  SET |PSI(k+q+G)> AND D|PSI(k+q+G)>
	DO 4000 IBNDS=1,NSPIN                         !!! over spin subbands
      DO 3000 IBNDT=IBNDMIN,IBNDMAX                 !!! over bands
      IBAND=IBNDS+NSPIN*(IBNDT-1)
	DO IORBS=1,NORBS                              !!! over spinors
      IF(NORBS.EQ.1)ISPIN=IBNDS
      IF(NORBS.EQ.2)ISPIN=IORBS
      DO IBAS=0,MIN(NBAS,MBAS)
      PSIQ(IBAS,ISPIN,IBAND)=(0.D0,0.D0)
      DPSQ(IBAS,ISPIN,IBAND)=(0.D0,0.D0)
	ENDDO 
      DO IATOM=1,NATOM                               !!! over iatom
      ISORT=IS(IATOM)
C  CALCULATE EXPONENTIAL FACTOR
      DO IBAS=0,MIN(NBAS,MBAS)
      SCP=(GPLW(1,IBAS)+PNTQ(1))*TAU(1,IATOM)+
     &    (GPLW(2,IBAS)+PNTQ(2))*TAU(2,IATOM)+
     &    (GPLW(3,IBAS)+PNTQ(3))*TAU(3,IATOM)
      EXPK(IBAS)=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	ENDDO
C  PSEUDOWAVEFUNCTION AND ITS RIGID CHANGE TO FIRST ORDER
      DO IKAP=1,NKAP(IPAN)                           !!! over energies
      DO L=0,ILSB(ISORT)                             !!! over l
      IF(LTPAN(L,IATOM,IKAP,IPAN))THEN
      DO M=-L,L                                      !!! over m
      LM=L*(L+1)+M+1
      DO IBAS=0,MIN(LBAS(L,ISORT,IKAP,IPAN),MBAS)
      PSIQ(IBAS,ISPIN,IBAND)=PSIQ(IBAS,ISPIN,IBAND)+
     &APHQ(LM,IATOM,IKAP,ISPIN,IBAND)*
     &CFTR(L,ISORT,IKAP,IBAS)*EXPK(IBAS)*YLM(LM,IBAS)
	ENDDO
	IF(IATOM.EQ.INUC.AND.MODE.NE.2)THEN
      DO IBAS=0,MIN(LBAS(L,ISORT,IKAP,IPAN),MBAS)
      DPSQ(IBAS,ISPIN,IBAND)=DPSQ(IBAS,ISPIN,IBAND)-
     &APHK(LM,IATOM,IKAP,ISPIN,IBAND)*
     &CFTR(L,ISORT,IKAP,IBAS)*EXPK(IBAS)*YLM(LM,IBAS)
	ENDDO
	ENDIF
      ENDDO                                          !!! over m
	ENDIF
      ENDDO                                          !!! over l
      ENDDO                                          !!! over ikap
      ENDDO                                          !!! over iatom
      ENDDO                                          !!! over spinors
 3000 CONTINUE                                       !!! over bands
 4000 CONTINUE                                       !!! over spin subbands
C Memory deallocations
	DEALLOCATE(YLM,CFTR,CHIK,EXPK)
	END



      SUBROUTINE DEL_D2PSIVEC(MY,INUC,IPNT,ISGQ,IPAN,IQPNT)
****************************************************************
*  Calculates Fourier transform for pseudowavefunctions.       *
****************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_LATTICE, ONLY : RBAS,GBAS,TAU                              !!! from readstr
	USE COM_KAPPAR,  ONLY : NPAN,NKAP,EK,EKAP                          !!! from readini
	USE COM_PANPAR,  ONLY : LTPAN,LSPAN,IATS,ISTS                      !!! from readini
	USE COM_LATPAR,  ONLY : PAR,ORTH,OMEGAC                            !!! from readini
	USE COM_SPHERE,  ONLY : SWZ,SMT                                    !!! from readini
	USE COM_NBANDS,  ONLY : NBNDF,NBNDE,NBNDT,NBNDH                    !!! from readini
	USE COM_PLWMESH, ONLY : NPLW,GPLW                                  !!! from makeplw
	USE COM_SUBGROUP,ONLY : NSGQ,NGEQ,ISG                              !!! from delmesh
	USE COM_GROUPS,  ONLY : NGROUP,U,INV,IKOV                          !!! from makegrp
	USE COM_TEILORG, ONLY : KEYT,BZM,GOPT,MBAS                         !!! from makeplw
	USE COM_SYMMESH, ONLY : IG0IG1,IK0IK1                              !!! from delmesh
	USE COM_PSIVEC,  ONLY : APHK,APJK,APHQ,APJQ                        !!! from lmtvec
	USE COM_KMESH,   ONLY : NPNT,PNT                                   !!! from makettr
	USE COM_ETAPAR,  ONLY : ETA,CUT,LBAS,NBAS                          !!! from makeplw
	USE COM_INPTTR,  ONLY : NDIV,NDIW,SH                               !!! from readini
	USE COM_DPSIVEC, ONLY : PSIK,PSIQ,DPSK,DPSQ,SPSK,PNTK,PNTQ         !!! from d2psivec
	USE COM_QMESH,   ONLY : NQPNT,QPNT                                 !!! from readpnt
	USE COM_MASHDEP, ONLY : NVAL                                       !!! from setup
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: YLM(:,:)
	COMPLEX*16, ALLOCATABLE :: CFTR(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: CHIK(:)
	COMPLEX*16, ALLOCATABLE :: EXPK(:)
	DIMENSION PNTR(3)
	DATA PI/3.141592653589793D0/
	IF(MODE.NE.4)RETURN
	IF(KEYT.LE.0)RETURN
C Memory allocations
	ALLOCATE(YLM(LIMBMEM,0:NBASMEM))
	ALLOCATE(CFTR(0:LMAXBMEM,NSORTMEM,NKAPMEM,0:NBASMEM))
	ALLOCATE(CHIK(0:NBASMEM))
	ALLOCATE(EXPK(0:NBASMEM))
C  SET POINT-GROUP INFORMATION
      IRK=ISG(1,ISGQ)       !!!  element "g"  in the main G-list
      IGK=IKOV(IRK)         !!!  element "g"  after Kovalev
      IPNTK=IPNT            !!!  point   "k"
      IRQ=IG0IG1(IPNT,IRK)  !!!  element "g'" in the main G-list
      IGQ=IKOV(IRQ)         !!!  element "g'" after Kovalev
      IPNTQ=IK0IK1(IPNT,IRK)!!!  point   "k'" such that g*k+q=g'*k'
C  ROTATE K-VECTOR BY SYMMETRY OPERATION
      CALL LIB_ROTATE(PNT(1,IPNTK,IPAN),PNT(2,IPNTK,IPAN),
     &  PNT(3,IPNTK,IPAN),XK,YK,ZK,U(2,IGK),2)
C  FIND K-POINT R=K+G WHICH HAS A MINIMAL LENGTH
	XK=XK+SH(1,IPAN)
	YK=YK+SH(2,IPAN)
	ZK=ZK+SH(3,IPAN)
	CALL REDUC2(XK,YK,ZK,NBAS,GPLW(1,0),PNTK(1),PNTK(2),PNTK(3),
     &  GRX,GRY,GRZ)
      IF(MODE.NE.5)IBNDMIN=1
      IF(MODE.NE.5)IBNDMAX=NBNDT(IPAN)+NBNDH(IPAN)
      IF(MODE.EQ.5)IBNDMIN=NBNDE(IPAN)
      IF(MODE.EQ.5)IBNDMAX=NBNDF(IPAN)
C  SET PSEUDOLMTOS FOR THE POINT IPNTK
	CALL BND_FTRMAT(PNTK,0,IPAN,PNTR,YLM,CFTR)
C  SET |PSI(k+G)> and D|PSI(k+G)> 
	DO 2000 IBNDS=1,NSPIN                         !!! over spin subbands
      DO 1000 IBNDT=IBNDMIN,IBNDMAX                 !!! over bands
      IBAND=IBNDS+NSPIN*(IBNDT-1)
	DO IORBS=1,NORBS                              !!! over spinors
      IF(NORBS.EQ.1)ISPIN=IBNDS
      IF(NORBS.EQ.2)ISPIN=IORBS
      DO IBAS=0,MIN(NBAS,MBAS)
      PSIK(IBAS,ISPIN,IBAND)=(0.D0,0.D0)
      DPSK(IBAS,ISPIN,IBAND)=(0.D0,0.D0)
      SPSK(IBAS,ISPIN,IBAND)=(0.D0,0.D0)
	ENDDO
      DO IATOM=1,NATOM                               !!! over iatom
      ISORT=IS(IATOM)
C  CALCULATE EXPONENTIAL FACTOR
      DO IBAS=0,MIN(NBAS,MBAS)
      SCP=(GPLW(1,IBAS)+PNTK(1))*TAU(1,IATOM)+
     &    (GPLW(2,IBAS)+PNTK(2))*TAU(2,IATOM)+
     &    (GPLW(3,IBAS)+PNTK(3))*TAU(3,IATOM)
      EXPK(IBAS)=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	ENDDO
C  PSEUDOWAVEFUNCTION AND ITS RIGID CHANGE TO FIRST ORDER
      DO IKAP=1,NKAP(IPAN)                           !!! over energies
      DO L=0,ILSB(ISORT)                             !!! over l
      IF(LTPAN(L,IATOM,IKAP,IPAN))THEN
      DO M=-L,L                                      !!! over m
      LM=L*(L+1)+M+1
      DO IBAS=0,MIN(LBAS(L,ISORT,IKAP,IPAN),MBAS)
      PSIK(IBAS,ISPIN,IBAND)=PSIK(IBAS,ISPIN,IBAND)+
     &  APHK(LM,IATOM,IKAP,ISPIN,IBAND)*
     &  CFTR(L,ISORT,IKAP,IBAS)*EXPK(IBAS)*YLM(LM,IBAS)
	ENDDO
	IF(IATOM.EQ.INUC.AND.MODE.NE.2)THEN
      DO IBAS=0,MIN(LBAS(L,ISORT,IKAP,IPAN),MBAS)
      DPSK(IBAS,ISPIN,IBAND)=DPSK(IBAS,ISPIN,IBAND)-
     &  APHQ(LM,IATOM,IKAP,ISPIN,IBAND)*
     &  CFTR(L,ISORT,IKAP,IBAS)*EXPK(IBAS)*YLM(LM,IBAS)
	ENDDO
	ENDIF
	IF(IATOM.EQ.INUC.AND.MODE.EQ.4)THEN
      DO IBAS=0,MIN(LBAS(L,ISORT,IKAP,IPAN),MBAS)
      SPSK(IBAS,ISPIN,IBAND)=SPSK(IBAS,ISPIN,IBAND)+
     &  APHK(LM,IATOM,IKAP,ISPIN,IBAND)*
     &  CFTR(L,ISORT,IKAP,IBAS)*EXPK(IBAS)*YLM(LM,IBAS)
	ENDDO
	ENDIF
      ENDDO                                          !!! over m
	ENDIF
      ENDDO                                          !!! over l
      ENDDO                                          !!! over ikap
      ENDDO                                          !!! over iatom
      ENDDO                                          !!! over spinors
 1000 CONTINUE                                       !!! over bands
 2000 CONTINUE                                       !!! over spinors
      PNTQ(1)=PNTK(1)+QPNT(1,IQPNT)
      PNTQ(2)=PNTK(2)+QPNT(2,IQPNT)
      PNTQ(3)=PNTK(3)+QPNT(3,IQPNT)
      CALL BND_FTRMAT(PNTQ,0,IPAN,PNTR,YLM,CFTR)
C  SET |PSI(k+q+G)> AND D|PSI(k+q+G)>
	DO 4000 IBNDS=1,NSPIN                         !!! over spin subbands
      DO 3000 IBNDT=IBNDMIN,IBNDMAX                 !!! over bands
      IBAND=IBNDS+NSPIN*(IBNDT-1)
	DO IORBS=1,NORBS                              !!! over spinors
      IF(NORBS.EQ.1)ISPIN=IBNDS
      IF(NORBS.EQ.2)ISPIN=IORBS
      DO IBAS=0,MIN(NBAS,MBAS)
      PSIQ(IBAS,ISPIN,IBAND)=(0.D0,0.D0)
      DPSQ(IBAS,ISPIN,IBAND)=(0.D0,0.D0)
	ENDDO 
      DO IATOM=1,NATOM                               !!! over iatom
      ISORT=IS(IATOM)
C  CALCULATE EXPONENTIAL FACTOR
      DO IBAS=0,MIN(NBAS,MBAS)
      SCP=(GPLW(1,IBAS)+PNTQ(1))*TAU(1,IATOM)+
     &    (GPLW(2,IBAS)+PNTQ(2))*TAU(2,IATOM)+
     &    (GPLW(3,IBAS)+PNTQ(3))*TAU(3,IATOM)
      EXPK(IBAS)=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	ENDDO
C  PSEUDOWAVEFUNCTION AND ITS RIGID CHANGE TO FIRST ORDER
      DO IKAP=1,NKAP(IPAN)                           !!! over energies
      DO L=0,ILSB(ISORT)                             !!! over l
      IF(LTPAN(L,IATOM,IKAP,IPAN))THEN
      DO M=-L,L                                      !!! over m
      LM=L*(L+1)+M+1
      DO IBAS=0,MIN(LBAS(L,ISORT,IKAP,IPAN),MBAS)
      PSIQ(IBAS,ISPIN,IBAND)=PSIQ(IBAS,ISPIN,IBAND)+
     &  APHQ(LM,IATOM,IKAP,ISPIN,IBAND)*
     &  CFTR(L,ISORT,IKAP,IBAS)*EXPK(IBAS)*YLM(LM,IBAS)
	ENDDO
	IF(IATOM.EQ.INUC.AND.MODE.NE.2)THEN
      DO IBAS=0,MIN(LBAS(L,ISORT,IKAP,IPAN),MBAS)
      DPSQ(IBAS,ISPIN,IBAND)=DPSQ(IBAS,ISPIN,IBAND)-
     &  APHK(LM,IATOM,IKAP,ISPIN,IBAND)*
     &  CFTR(L,ISORT,IKAP,IBAS)*EXPK(IBAS)*YLM(LM,IBAS)
	ENDDO
	ENDIF
      ENDDO                                          !!! over m
	ENDIF
      ENDDO                                          !!! over l
      ENDDO                                          !!! over ikap
      ENDDO                                          !!! over iatom
      ENDDO                                          !!! over spinors
 3000 CONTINUE                                       !!! over bands
 4000 CONTINUE                                       !!! over spin subbands
C Memory deallocations
	DEALLOCATE(YLM,CFTR,CHIK,EXPK)
	END


      SUBROUTINE DEL_PSIVEC2(IPNT,ISGQ,IPAN,IQPNT)
****************************************************************
*  Calculates Fourier transform for pseudowavefunctions.       *
****************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_LATPAR,  ONLY : PAR,ORTH,OMEGAC                            !!! from readini
	USE COM_LATTICE, ONLY : RBAS,GBAS,TAU                              !!! from readstr
	USE COM_PANPAR,  ONLY : LTPAN,LSPAN                                !!! from readini
	USE COM_KAPPAR,  ONLY : NPAN,NKAP,EK,EKAP                          !!! from readini
	USE COM_KMESH,   ONLY : NPNT,PNT                                   !!! from makettr
	USE COM_NBANDS,  ONLY : NBNDF,NBNDE,NBNDT,NBNDH                    !!! from readini
	USE COM_ETAPAR,  ONLY : ETA,CUT,LBAS,NBAS                          !!! from makeplw
	USE COM_INPTTR,  ONLY : NDIV,NDIW,SH                               !!! from readini
	USE COM_TEILORG, ONLY : KEYT,BZM,GOPT,MBAS                         !!! from makeplw
	USE COM_SYMMESH, ONLY : IG0IG1,IK0IK1                              !!! from delmesh
	USE COM_SUBGROUP,ONLY : NSGQ,NGEQ,ISG                              !!! from delmesh
	USE COM_PSIVEC,  ONLY : APHK,APJK,APHQ,APJQ                        !!! from lmtvec
	USE COM_GROUPS,  ONLY : NGROUP,U,INV,IKOV                          !!! from makegrp
	USE COM_DPSIVEC, ONLY : PSIK2,PSIQ2,DPSK2,DPSQ2,SPSK2
     &                       ,PNTK,PNTQ                                  !!! from d2psivec
	USE COM_PLWMESH, ONLY : NPLW,GPLW                                  !!! from makeplw
	USE COM_QMESH,   ONLY : NQPNT,QPNT                                 !!! from readpnt
	USE COM_SPHERE,  ONLY : SWZ,SMT                                    !!! from readini
	USE COM_MASHDEP, ONLY : NVAL                                       !!! from setup
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: YLM0(:,:)
	COMPLEX*16, ALLOCATABLE :: CFTR0(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: YLMQ(:,:)
	COMPLEX*16, ALLOCATABLE :: CFTRQ(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: CHIK(:)
	COMPLEX*16, ALLOCATABLE :: EXPK(:)
	DIMENSION PNTR(3)
	DATA PI/3.141592653589793D0/
	IF(MODE.NE.4)RETURN
C Memory allocations
	ALLOCATE(YLM0(LIMBMEM,0:NBASMEM))
	ALLOCATE(CFTR0(0:LMAXBMEM,NSORTMEM,NKAPMEM,0:NBASMEM))
	ALLOCATE(YLMQ(LIMBMEM,0:NBASMEM))
	ALLOCATE(CFTRQ(0:LMAXBMEM,NSORTMEM,NKAPMEM,0:NBASMEM))
	ALLOCATE(CHIK(0:NBASMEM))
	ALLOCATE(EXPK(0:NBASMEM))
C  SET POINT-GROUP INFORMATION
      IRK=ISG(1,ISGQ)       !!!  element "g"  in the main G-list
      IGK=IKOV(IRK)         !!!  element "g"  after Kovalev
      IPNTK=IPNT            !!!  point   "k"
      IRQ=IG0IG1(IPNT,IRK)  !!!  element "g'" in the main G-list
      IGQ=IKOV(IRQ)         !!!  element "g'" after Kovalev
      IPNTQ=IK0IK1(IPNT,IRK)!!!  point   "k'" such that g*k+q=g'*k'
C  ROTATE K-VECTOR BY SYMMETRY OPERATION
      CALL LIB_ROTATE(PNT(1,IPNTK,IPAN),PNT(2,IPNTK,IPAN),
     &  PNT(3,IPNTK,IPAN),XK,YK,ZK,U(2,IGK),2)
C  FIND K-POINT R=K+G WHICH HAS A MINIMAL LENGTH
	XK=XK+SH(1,IPAN)
	YK=YK+SH(2,IPAN)
	ZK=ZK+SH(3,IPAN)
	CALL REDUC2(XK,YK,ZK,NBAS,GPLW(1,0),PNTK(1),PNTK(2),PNTK(3),
     &  GRX,GRY,GRZ)
      LMB=0
      DO ISORT=1,NSORT
      DO IKAP=1,NKAP(IPAN)
      DO L=0,ILSB(ISORT)
      IF(LSPAN(L,ISORT,IKAP,IPAN))LMB=MAX(L,LMB)
      ENDDO
      ENDDO
      ENDDO
C  SET PSEUDOLMTOS FOR THE POINT IPNTQ
      PNTQ(1)=PNTK(1)+QPNT(1,IQPNT)
      PNTQ(2)=PNTK(2)+QPNT(2,IQPNT)
      PNTQ(3)=PNTK(3)+QPNT(3,IQPNT)
      CALL BND_FTRMAT(PNTQ,0,IPAN,PNTR,YLM0,CFTR0)
      DO IBAS=0,MIN(NBAS,MBAS)
      DO L=0,LMB
      DO M=-L,L
      LM=L*(L+1)+M+1
      YLMQ(LM,IBAS)=YLM0(LM,IBAS)
      ENDDO
      ENDDO
      ENDDO
      DO ISORT=1,NSORT
      DO IKAP=1,NKAP(IPAN)
      DO L=0,ILSB(ISORT)
      DO IBAS=0,MIN(LBAS(L,ISORT,IKAP,IPAN),MBAS)
      CFTRQ(L,ISORT,IKAP,IBAS)=CFTR0(L,ISORT,IKAP,IBAS)
      ENDDO
      ENDDO
      ENDDO
      ENDDO
C  SET PSEUDOLMTOS FOR THE POINT IPNTK
      CALL BND_FTRMAT(PNTK,0,IPAN,PNTR,YLM0,CFTR0)
C  DO OVER BANDS
      DO 2000 IBNDS=1,NSPIN 
	DO 1000 IBNDT=1,NBNDF(IPAN)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
C  SET  D|PSI(k+G)> and D2|PSI(k+G)>
	DO IORBS=1,NORBS                               !!! over spinors
	IF(NORBS.EQ.1)ISPIN=IBNDS
	IF(NORBS.EQ.2)ISPIN=IORBS
      DO IBAS=0,MIN(NBAS,MBAS)
      PSIK2(IBAS,ISPIN,IBAND)=(0.D0,0.D0)
	DO INUC=1,NATOM
      DPSK2(IBAS,INUC,ISPIN,IBAND)=(0.D0,0.D0)
      SPSK2(IBAS,INUC,ISPIN,IBAND)=(0.D0,0.D0)
      ENDDO   
	ENDDO
      DO IATOM=1,NATOM                               !!! over iatom
      ISORT=IS(IATOM)
C  CALCULATE EXPONENTIAL FACTOR
      DO IBAS=0,MIN(NBAS,MBAS)
      SCP=(GPLW(1,IBAS)+PNTK(1))*TAU(1,IATOM)+
     &    (GPLW(2,IBAS)+PNTK(2))*TAU(2,IATOM)+
     &    (GPLW(3,IBAS)+PNTK(3))*TAU(3,IATOM)
      EXPK(IBAS)=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
      ENDDO   
C  PSEUDOWAVEFUNCTION AND ITS RIGID CHANGE TO FIRST ORDER
      DO IKAP=1,NKAP(IPAN)                           !!! over energies
      DO L=0,ILSB(ISORT)                             !!! over l
      IF(LTPAN(L,IATOM,IKAP,IPAN))THEN
      DO M=-L,L                                      !!! over m
      LM=L*(L+1)+M+1
      DO IBAS=0,MIN(LBAS(L,ISORT,IKAP,IPAN),MBAS)
      PSIK2(IBAS,ISPIN,IBAND)=PSIK2(IBAS,ISPIN,IBAND)+
     &  APHK(LM,IATOM,IKAP,ISPIN,IBAND)*
     &  CFTR0(L,ISORT,IKAP,IBAS)*EXPK(IBAS)*YLM0(LM,IBAS)
      DPSK2(IBAS,IATOM,ISPIN,IBAND)=DPSK2(IBAS,IATOM,ISPIN,IBAND)-
     &  APHQ(LM,IATOM,IKAP,ISPIN,IBAND)*
     &  CFTR0(L,ISORT,IKAP,IBAS)*EXPK(IBAS)*YLM0(LM,IBAS)
      SPSK2(IBAS,IATOM,ISPIN,IBAND)=SPSK2(IBAS,IATOM,ISPIN,IBAND)+
     &  APHK(LM,IATOM,IKAP,ISPIN,IBAND)*
     &  CFTR0(L,ISORT,IKAP,IBAS)*EXPK(IBAS)*YLM0(LM,IBAS)
	ENDDO
      ENDDO                                          !!! over m
	ENDIF
      ENDDO                                          !!! over l
      ENDDO                                          !!! over ikap
      ENDDO                                          !!! over iatom
	ENDDO                                          !!! over spinors
C  SET |PSI(k+q+G)> AND D|PSI(k+q+G)>
	DO IORBS=1,NORBS                               !!! over spinors
	IF(NORBS.EQ.1)ISPIN=IBNDS
	IF(NORBS.EQ.2)ISPIN=IORBS
      DO IBAS=0,MIN(NBAS,MBAS)
      PSIQ2(IBAS,ISPIN,IBAND)=(0.D0,0.D0)
	DO INUC=1,NATOM                                !!! over displacements
      DPSQ2(IBAS,INUC,ISPIN,IBAND)=(0.D0,0.D0)
	ENDDO
	ENDDO
      DO IATOM=1,NATOM                               !!! over iatom
      ISORT=IS(IATOM)
C  CALCULATE EXPONENTIAL FACTOR
      DO IBAS=0,MIN(NBAS,MBAS)
      SCP=(GPLW(1,IBAS)+PNTQ(1))*TAU(1,IATOM)+
     &    (GPLW(2,IBAS)+PNTQ(2))*TAU(2,IATOM)+
     &    (GPLW(3,IBAS)+PNTQ(3))*TAU(3,IATOM)
      EXPK(IBAS)=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
      ENDDO   
C  PSEUDOWAVEFUNCTION AND ITS RIGID CHANGE TO FIRST ORDER
      DO IKAP=1,NKAP(IPAN)                           !!! over energies
      DO L=0,ILSB(ISORT)                             !!! over l
      IF(LTPAN(L,IATOM,IKAP,IPAN))THEN
      DO M=-L,L                                      !!! over m
      LM=L*(L+1)+M+1
      DO IBAS=0,MIN(LBAS(L,ISORT,IKAP,IPAN),MBAS)
      PSIQ2(IBAS,ISPIN,IBAND)=PSIQ2(IBAS,ISPIN,IBAND)+
     &  APHQ(LM,IATOM,IKAP,ISPIN,IBAND)*
     &  CFTRQ(L,ISORT,IKAP,IBAS)*EXPK(IBAS)*YLMQ(LM,IBAS)
      DPSQ2(IBAS,IATOM,ISPIN,IBAND)=DPSQ2(IBAS,IATOM,ISPIN,IBAND)-
     &  APHK(LM,IATOM,IKAP,ISPIN,IBAND)*
     &  CFTRQ(L,ISORT,IKAP,IBAS)*EXPK(IBAS)*YLMQ(LM,IBAS)
      ENDDO   
      ENDDO                                          !!! over m
	ENDIF
      ENDDO                                          !!! over l
      ENDDO                                          !!! over ikap
      ENDDO                                          !!! over iatom
      ENDDO                                          !!! over spinors
 1000	CONTINUE                                       !!! over bands
 2000	CONTINUE                                       !!! over spin subbands
C Memory allocations
	DEALLOCATE(YLM0,CFTR0,YLMQ,CFTRQ,CHIK,EXPK)
	END
