	SUBROUTINE DEL_RINTPAR(IPAN,IQPNT)
***********************************************************
*  Calculates contribution to the change in the           *
*  interstitial potential matrix elements from k=0 and q  *
*  and large vectors G.                                   *
***********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_LATPAR,  ONLY : PAR,ORTH,OMEGAC                            !!! from readini
	USE COM_KAPPAR,  ONLY : NPAN,NKAP,EK,EKAP                          !!! from readini
	USE COM_KMESH,   ONLY : NPNT,PNT                                   !!! from makettr
	USE COM_PANPAR,  ONLY : LTPAN,LSPAN,IATS,ISTS                      !!! from readini
	USE COM_LATTICE, ONLY : TAU                                        !!! from readstr
	USE COM_INDORB,  ONLY : INDLMT                                     !!! from readini
	USE COM_NBANDS,  ONLY : NBNDF,NBNDE,NBNDT,NBNDH                    !!! from readini
	USE COM_ETAPAR,  ONLY : ETA,CUT,LBAS,NBAS                          !!! from makeplw
	USE COM_TEILORG, ONLY : KEYT,BZM,GOPT,MBAS                         !!! from makeplw
	USE COM_INPTTR,  ONLY : NDIV,NDIW                                  !!! from readini
	USE COM_PLWMESH, ONLY : NPLW,GPLW                                  !!! from makeplw
	USE COM_POTDAT,  ONLY : POTPS,POTPS1                               !!! from readscf
	USE COM_DELPOT,  ONLY : DPOTPS,DPOTPS1                             !!! from delpot
	USE COM_SPHERE,  ONLY : SWZ,SMT                                    !!! from readini
	USE COM_QMESH,   ONLY : NQPNT,QPNT                                 !!! from readpnt
	USE COM_MASHDEP, ONLY : NVAL                                       !!! from setup
	USE COM_CHANNELS,ONLY : IUPIN                                      !!! from channels
	USE COM_LMTOUT,  ONLY : SCRFILE                                    !!! from setup
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: DXFUN0(:,:)
	COMPLEX*16, ALLOCATABLE :: DXFUNQ(:,:)
	COMPLEX*16, ALLOCATABLE :: DVINT0(:,:)
	COMPLEX*16, ALLOCATABLE :: DVINTQ(:,:)
	COMPLEX*16, ALLOCATABLE :: YLM0(:,:)
	COMPLEX*16, ALLOCATABLE :: CFTR0(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: YLMQ(:,:)
	COMPLEX*16, ALLOCATABLE :: CFTRQ(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: CHI0(:)
	COMPLEX*16, ALLOCATABLE :: RHI0(:)
	COMPLEX*16, ALLOCATABLE :: CON0(:)
	COMPLEX*16, ALLOCATABLE :: CHIQ(:)
	COMPLEX*16, ALLOCATABLE :: RHIQ(:)
	COMPLEX*16, ALLOCATABLE :: CONQ(:)
	COMPLEX*16, ALLOCATABLE :: EXP0(:)
	COMPLEX*16, ALLOCATABLE :: EXPQ(:)
	COMPLEX*16, ALLOCATABLE :: EXS0(:)
	COMPLEX*16, ALLOCATABLE :: EXSQ(:)
	COMPLEX*16, ALLOCATABLE :: DMINT0(:,:,:)
	COMPLEX*16, ALLOCATABLE :: DMINTQ(:,:,:)
	COMPLEX*16 DHH0,DHHQ,GMY1,GMY
	DIMENSION PNTR(3),PNTK(3)
	LOGICAL EXIST
	DATA PI/3.141592653589793D0/
C  OPEN SCRATCH FILE FOR STORING POTENTIAL PARAMETERS
	INQUIRE(FILE=SCRFILE(IUPIN),EXIST=EXIST)
	IF(.NOT.EXIST)THEN
	NRECL=NVAL*(NBNDT(IPAN)*(MIN(NBAS,MBAS)+1)+
     &NBNDT(IPAN)**2)
	IF(NRECL.LT.3*NBNDT(IPAN)**2)WRITE(IUT,*)
     &  '<RINTPAR>:: STORAGE IN CHANNEL IUPIN IS NOT OPTIMAL'
	NRECL=MAX(NRECL,3*NBNDT(IPAN)**2*NVAL)
	OPEN(UNIT=IUPIN,FILE=SCRFILE(IUPIN),STATUS='NEW',
     &ACCESS='DIRECT',FORM='UNFORMATTED',RECL=NRECL)
	ENDIF
	IF(KEYT.EQ.0)RETURN
C Memory allocations
	ALLOCATE(DXFUN0(NBNDT(IPAN),0:MBASMEM))
	ALLOCATE(DVINT0(NBNDT(IPAN),NBNDT(IPAN)))
	ALLOCATE(DXFUNQ(NBNDT(IPAN),0:MBASMEM))
	ALLOCATE(DVINTQ(NBNDT(IPAN),NBNDT(IPAN)))
	ALLOCATE(YLM0(LIMBMEM,0:NBASMEM))
	ALLOCATE(CFTR0(0:LMAXBMEM,NSORTMEM,NKAPMEM,0:NBASMEM))
	ALLOCATE(YLMQ(LIMBMEM,0:NBASMEM))
	ALLOCATE(CFTRQ(0:LMAXBMEM,NSORTMEM,NKAPMEM,0:NBASMEM))
	ALLOCATE(CHI0(0:NBASMEM))
	ALLOCATE(RHI0(0:NBASMEM))
	ALLOCATE(CON0(0:NBASMEM))
	ALLOCATE(CHIQ(0:NBASMEM))
	ALLOCATE(RHIQ(0:NBASMEM))
	ALLOCATE(CONQ(0:NBASMEM))
	ALLOCATE(EXP0(0:NBASMEM))
	ALLOCATE(EXPQ(0:NBASMEM))
	ALLOCATE(EXS0(0:NBASMEM))
	ALLOCATE(EXSQ(0:NBASMEM))
	ALLOCATE(DMINT0(NBNDT(IPAN),NBNDT(IPAN),-1:1))
      ALLOCATE(DMINTQ(NBNDT(IPAN),NBNDT(IPAN),-1:1))
	LMB=0
	DO ISORT=1,NSORT
	DO IKAP=1,NKAP(IPAN)
	DO L=0,ILSB(ISORT)
	IF(LSPAN(L,ISORT,IKAP,IPAN))LMB=MAX(L,LMB)
	ENDDO
	ENDDO
	ENDDO
C  SET PSEUDOLMTOS FOR THE POINT IPNTK
	PNTK(1)=QPNT(1,IQPNT)
	PNTK(2)=QPNT(2,IQPNT)
	PNTK(3)=QPNT(3,IQPNT)
	CALL BND_FTRMAT(PNTK,1,IPAN,PNTR,YLM0,CFTR0)
	DO IBAS=0,NBAS
	DO L=0,LMB
	DO M=-L,L
	LM=L*(L+1)+M+1
	YLMQ(LM,IBAS)=YLM0(LM,IBAS)
	ENDDO
	ENDDO
	ENDDO
	DO ISORT=1,NSORT                  !!! over isort
	DO IKAP=1,NKAP(IPAN)              !!! over ikap
	DO L=0,ILSB(ISORT)                !!! over l
	DO IBAS=0,LBAS(L,ISORT,IKAP,IPAN) !!! over ibas
	CFTRQ(L,ISORT,IKAP,IBAS)=CFTR0(L,ISORT,IKAP,IBAS)
	ENDDO                             !!! over ibas
	ENDDO                             !!! over l
	ENDDO                             !!! over ikap
	ENDDO                             !!! over isort
C  SET PSEUDOLMTOS FOR THE POINT IPNTK
	PNTK(1)=0.D0
	PNTK(2)=0.D0
	PNTK(3)=0.D0
	CALL BND_FTRMAT(PNTK,1,IPAN,PNTR,YLM0,CFTR0)
	DO 3000 IORBS=1,NORBS
	DO 2000 IUPDN=1,NSPIN
	IF(IORBS.EQ.1)THEN
	IUPDN1=IUPDN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	SIGNF=1.D0
	ELSEIF(IORBS.EQ.2)THEN
	IUPDN1=NSPIN+1-IUPDN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	IF(ISPIN1.EQ.1.AND.ISPIN.EQ.2)SIGNF=-SQRT(2.D0) ! B^{+} * <S_{+}>
	IF(ISPIN1.EQ.2.AND.ISPIN.EQ.1)SIGNF=+SQRT(2.D0) ! B^{-} * <S_{-}>
	ENDIF
C  ####################################################
C  STEP 1 MAKES ORIGINAL CONVOLUTIONS OF PSEUDOORBITALS
C  ####################################################
	DO IATOM1=1,NATOM                 !!! over iatom1
	ISORT1=IS(IATOM1)
C  CALCULATE EXPONENTIAL FACTOR
	DO IBAS=0,NBAS
	SCP=(GPLW(1,IBAS)+PNTK(1))*TAU(1,IATOM1)+
     &    (GPLW(2,IBAS)+PNTK(2))*TAU(2,IATOM1)+
     &    (GPLW(3,IBAS)+PNTK(3))*TAU(3,IATOM1)
	EXP0(IBAS)=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	SCP=(GPLW(1,IBAS)+QPNT(1,IQPNT))*TAU(1,IATOM1)+
     &    (GPLW(2,IBAS)+QPNT(2,IQPNT))*TAU(2,IATOM1)+
     &    (GPLW(3,IBAS)+QPNT(3,IQPNT))*TAU(3,IATOM1)
	EXPQ(IBAS)=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	ENDDO
	DO IKAP1=1,NKAP(IPAN)             !!! over energy
	DO L1=0,ILSB(ISORT1)              !!! over l1
	DO M1=-L1,L1                      !!! over m1
	IF(.NOT.LTPAN(L1,IATOM1,IKAP1,IPAN))EXIT
	L1M1=L1*(L1+1)+M1+1
	IPAR1=INDLMT(L1M1,IATOM1,IKAP1,1,IPAN)
	DO IBAS=0,LBAS(L1,ISORT1,IKAP1,IPAN)! NG_1
C  FOURIER TRANSFORM OF THE PSEUDOORBITAL
	CHI0(IBAS)=DCONJG(CFTR0(L1,ISORT1,IKAP1,IBAS)*
     &  YLM0(L1M1,IBAS)*EXP0(IBAS))
	CHIQ(IBAS)=CFTRQ(L1,ISORT1,IKAP1,IBAS)*
     &  YLMQ(L1M1,IBAS)*EXPQ(IBAS)
	ENDDO
C  CONVOLUTION OF THE PSEUDOORBITAL WITH THE PSEUDOPOTENTIAL
	CALL BND_CONVOL1(POTPS1(0,IUPDN1,IORBS),CHI0(0),CON0(0),'L',
     &               0,NBAS,MBAS+1,LBAS(L1,ISORT1,IKAP1,IPAN))
	CALL BND_CONVOL1(POTPS1(0,IUPDN1,IORBS),CHIQ(0),CONQ(0),'R',
     &               0,NBAS,MBAS+1,LBAS(L1,ISORT1,IKAP1,IPAN))
	DO IBAS=0,MIN(NBAS,MBAS)                !!! NGMAX{small}
	DXFUN0(IPAR1,IBAS)=CON0(IBAS)*SIGNF     !!! Y0
	DXFUNQ(IPAR1,IBAS)=CONQ(IBAS)*SIGNF     !!! Xq
	ENDDO
C  DO OVER RIGHT INDEX
	DO IATOM=1,NATOM                  !!! over iatom
	ISORT=IS(IATOM)
C  CALCULATE EXPONENTIAL FACTOR
	DO IBAS=0,NBAS                    !!! NGMAX{large}
	SCP=(GPLW(1,IBAS)+PNTK(1))*TAU(1,IATOM)+
     &    (GPLW(2,IBAS)+PNTK(2))*TAU(2,IATOM)+
     &    (GPLW(3,IBAS)+PNTK(3))*TAU(3,IATOM)
	EXS0(IBAS)=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	SCP=(GPLW(1,IBAS)+QPNT(1,IQPNT))*TAU(1,IATOM)+
     &    (GPLW(2,IBAS)+QPNT(2,IQPNT))*TAU(2,IATOM)+
     &    (GPLW(3,IBAS)+QPNT(3,IQPNT))*TAU(3,IATOM)
	EXSQ(IBAS)=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	ENDDO
	DO IKAP=1,NKAP(IPAN)              !!! over energy
	DO L=0,ILSB(ISORT)                !!! over l
	DO M=-L,L                         !!! over m
	IF(.NOT.LTPAN(L,IATOM,IKAP,IPAN))EXIT
	LM=L*(L+1)+M+1
	IPAR=INDLMT(LM,IATOM,IKAP,1,IPAN)
C  FOURIER TRANSFORM OF THE PSEUDOORBITAL
	DO IBAS=MBAS+1,LBAS(L,ISORT,IKAP,IPAN)  !!! NG_0{large}
	CHI0(IBAS)=CFTR0(L,ISORT,IKAP,IBAS)*YLM0(LM,IBAS)*EXS0(IBAS)
	CHIQ(IBAS)=DCONJG(CFTRQ(L,ISORT,IKAP,IBAS)*
     &  YLMQ(LM,IBAS)*EXSQ(IBAS))
	ENDDO
C  ******** PSEUDOPOTENTIAL MATRIX ************
C     CONTRIBUTION FROM LARGE G, K-DEPENDENCE BY TEILOR WILL BE USED
	DHH0=(0.D0,0.D0)
	DHHQ=(0.D0,0.D0)
	DO IBAS=MBAS+1,LBAS(L,ISORT,IKAP,IPAN)  !!! NG_0{large}
	DHH0=DHH0+CON0(IBAS)*CHI0(IBAS)         !!! V0
	DHHQ=DHHQ+CHIQ(IBAS)*CONQ(IBAS)         !!! Vq
	ENDDO
	DVINT0(IPAR1,IPAR)=DHH0*SIGNF
	DVINTQ(IPAR,IPAR1)=DHHQ*SIGNF
	ENDDO                             !!! over m
	ENDDO                             !!! over l
	ENDDO                             !!! over energy
	ENDDO                             !!! over iatom
	ENDDO                             !!! over m1
	ENDDO                             !!! over l1
	ENDDO                             !!! over energy
	ENDDO                             !!! over iatom1
C  STORE DATA FOR K=0
	IREC=1+2*(IUPDN-1)+2*NSPIN*(IORBS-1) !!! Y0,V0
	WRITE(IUPIN,REC=IREC)((DVINT0(IPAR1,IPAR),IPAR1=1,
     &NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DXFUN0(IPAR1,IBAS),
     &IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
C  STORE DATA FOR K=Q
	IREC=2+2*(IUPDN-1)+2*NSPIN*(IORBS-1) !!! Xq,Vq
	WRITE(IUPIN,REC=IREC)((DVINTQ(IPAR1,IPAR),IPAR1=1,
     &NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DXFUNQ(IPAR1,IBAS),
     &IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
C  ####################################################
C  STEP 2 WORKS WITH THE FIRST-ORDER DERIVATIVES        
C  ####################################################
	DO 1000 MY=-1,1                   !!! over polarizations
	DO IATOM1=1,NATOM                 !!! over iatom1
	ISORT1=IS(IATOM1)
C  CALCULATE EXPONENTIAL FACTOR
	DO IBAS=0,NBAS
	SCP=(GPLW(1,IBAS)+PNTK(1))*TAU(1,IATOM1)+
     &    (GPLW(2,IBAS)+PNTK(2))*TAU(2,IATOM1)+
     &    (GPLW(3,IBAS)+PNTK(3))*TAU(3,IATOM1)
	EXP0(IBAS)=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	SCP=(GPLW(1,IBAS)+QPNT(1,IQPNT))*TAU(1,IATOM1)+
     &    (GPLW(2,IBAS)+QPNT(2,IQPNT))*TAU(2,IATOM1)+
     &    (GPLW(3,IBAS)+QPNT(3,IQPNT))*TAU(3,IATOM1)
	EXPQ(IBAS)=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	ENDDO
	DO IKAP1=1,NKAP(IPAN)             !!! over energy
	DO L1=0,ILSB(ISORT1)              !!! over l1
	DO M1=-L1,L1                      !!! over m1
	IF(.NOT.LTPAN(L1,IATOM1,IKAP1,IPAN))EXIT
	L1M1=L1*(L1+1)+M1+1
	IPAR1=INDLMT(L1M1,IATOM1,IKAP1,1,IPAN)
C  FOURIER TRANSFORM OF THE PSEUDOORBITAL
	DO IBAS=0,LBAS(L1,ISORT1,IKAP1,IPAN)! NG_1
	CHI0(IBAS)=DCONJG(CFTR0(L1,ISORT1,IKAP1,IBAS)*
     &YLM0(L1M1,IBAS)*EXP0(IBAS))
	CHIQ(IBAS)=CFTRQ(L1,ISORT1,IKAP1,IBAS)*
     &YLMQ(L1M1,IBAS)*EXPQ(IBAS)
	ENDDO
C  DERIVATIVES OF THE PSEUDOORBITALS
	DO IBAS=0,LBAS(L1,ISORT1,IKAP1,IPAN)! NG_1
	GX=PNTK(1)+GPLW(1,IBAS)
	GY=PNTK(2)+GPLW(2,IBAS)
	GZ=PNTK(3)+GPLW(3,IBAS)
	IF(-MY.EQ.-1)GMY=+1.D0/SQRT(2.D0)*(GX-(0.D0,1.D0)*GY)
	IF(-MY.EQ.+1)GMY=-1.D0/SQRT(2.D0)*(GX+(0.D0,1.D0)*GY)
	IF(-MY.EQ. 0)GMY=GZ
	RHI0(IBAS)=(-1)**MY*DCONJG((0.D0,-1.D0)*GMY)*
     &2.D0*PI/PAR*CHI0(IBAS)
	ENDDO
	DO IBAS=0,LBAS(L1,ISORT1,IKAP1,IPAN)! NG_1
	GX=QPNT(1,IQPNT)+GPLW(1,IBAS)
	GY=QPNT(2,IQPNT)+GPLW(2,IBAS)
	GZ=QPNT(3,IQPNT)+GPLW(3,IBAS)
	IF(+MY.EQ.-1)GMY=+1.D0/SQRT(2.D0)*(GX-(0.D0,1.D0)*GY)
	IF(+MY.EQ.+1)GMY=-1.D0/SQRT(2.D0)*(GX+(0.D0,1.D0)*GY)
	IF(+MY.EQ. 0)GMY=GZ
	RHIQ(IBAS)=(0.D0,-1.D0)*GMY*2.D0*PI/PAR*CHIQ(IBAS)
	ENDDO
C  CONVOLUTION OF THE PSEUDOORBITAL WITH THE PSEUDOPOTENTIAL
	CALL BND_CONVOL1(POTPS1(0,IUPDN1,IORBS),RHI0(0),CON0(0),'L',
     &               0,NBAS,MBAS+1,LBAS(L1,ISORT1,IKAP1,IPAN))
	CALL BND_CONVOL1(POTPS1(0,IUPDN1,IORBS),RHIQ(0),CONQ(0),'R',
     &               0,NBAS,MBAS+1,LBAS(L1,ISORT1,IKAP1,IPAN))
	DO IBAS=0,MIN(NBAS,MBAS)                !!! NGMAX{small}
	DXFUN0(IPAR1,IBAS)=CON0(IBAS)*SIGNF     !!! d{m0}Y0
	DXFUNQ(IPAR1,IBAS)=CONQ(IBAS)*SIGNF     !!! d{m0}Xq
	ENDDO
C  DO OVER RIGHT INDEX
	DO IATOM=1,NATOM                  !!! over iatom
	ISORT=IS(IATOM)
C  CALCULATE EXPONENTIAL FACTOR
	DO IBAS=0,NBAS                    !!! NGMAX{large}
	SCP=(GPLW(1,IBAS)+PNTK(1))*TAU(1,IATOM)+
     &    (GPLW(2,IBAS)+PNTK(2))*TAU(2,IATOM)+
     &    (GPLW(3,IBAS)+PNTK(3))*TAU(3,IATOM)
	EXS0(IBAS)=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	SCP=(GPLW(1,IBAS)+QPNT(1,IQPNT))*TAU(1,IATOM)+
     &    (GPLW(2,IBAS)+QPNT(2,IQPNT))*TAU(2,IATOM)+
     &    (GPLW(3,IBAS)+QPNT(3,IQPNT))*TAU(3,IATOM)
	EXSQ(IBAS)=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	ENDDO
	DO IKAP=1,NKAP(IPAN)              !!! over energy
	DO L=0,ILSB(ISORT)                !!! over l
	DO M=-L,L                         !!! over m
	IF(.NOT.LTPAN(L,IATOM,IKAP,IPAN))EXIT
	LM=L*(L+1)+M+1
	IPAR=INDLMT(LM,IATOM,IKAP,1,IPAN)
C  FOURIER TRANSFORM OF THE PSEUDOORBITAL
	DO IBAS=MBAS+1,LBAS(L,ISORT,IKAP,IPAN)  !!! NG_0{large}
	CHI0(IBAS)=CFTR0(L,ISORT,IKAP,IBAS)*
     &  YLM0(LM,IBAS)*EXS0(IBAS)
	CHIQ(IBAS)=DCONJG(CFTRQ(L,ISORT,IKAP,IBAS)*
     &  YLMQ(LM,IBAS)*EXSQ(IBAS))
	ENDDO
C  ******** PSEUDOPOTENTIAL MATRIX ************
C     CONTRIBUTION FROM LARGE G, K-DEPENDENCE BY TEILOR WILL BE USED
	DHH0=(0.D0,0.D0)
	DHHQ=(0.D0,0.D0)
	DO IBAS=MBAS+1,LBAS(L,ISORT,IKAP,IPAN)  !!! NG_0{large}
	DHH0=DHH0+CON0(IBAS)*CHI0(IBAS)         !!! {m0}DV0
	DHHQ=DHHQ+CHIQ(IBAS)*CONQ(IBAS)         !!! D{m0}Vq
	ENDDO
	DVINT0(IPAR1,IPAR)=DHH0*SIGNF
	DVINTQ(IPAR,IPAR1)=DHHQ*SIGNF
	IF(MODE.EQ.4)THEN                 !!! for mode=4 only
	DO MY0=-1,1                       !!! over polarizations
C  DERIVATIVES OF THE PSEUDOORBITALS
	DO IBAS=0,LBAS(L,ISORT,IKAP,IPAN)! NG_1
	GX=PNTK(1)+GPLW(1,IBAS)
	GY=PNTK(2)+GPLW(2,IBAS)
	GZ=PNTK(3)+GPLW(3,IBAS)
	IF(+MY0.EQ.-1)GMY=+1.D0/SQRT(2.D0)*(GX-(0.D0,1.D0)*GY)
	IF(+MY0.EQ.+1)GMY=-1.D0/SQRT(2.D0)*(GX+(0.D0,1.D0)*GY)
	IF(+MY0.EQ. 0)GMY=GZ
	RHI0(IBAS)=(0.D0,-1.D0)*GMY*2.D0*PI/PAR*CHI0(IBAS)
	ENDDO
	DO IBAS=0,LBAS(L,ISORT,IKAP,IPAN)! NG_1
	GX=QPNT(1,IQPNT)+GPLW(1,IBAS)
	GY=QPNT(2,IQPNT)+GPLW(2,IBAS)
	GZ=QPNT(3,IQPNT)+GPLW(3,IBAS)
	IF(-MY0.EQ.-1)GMY=+1.D0/SQRT(2.D0)*(GX-(0.D0,1.D0)*GY)
	IF(-MY0.EQ.+1)GMY=-1.D0/SQRT(2.D0)*(GX+(0.D0,1.D0)*GY)
	IF(-MY0.EQ. 0)GMY=GZ
	RHIQ(IBAS)=(-1)**MY0*DCONJG((0.D0,-1.D0)*GMY)*
     &2.D0*PI/PAR*CHIQ(IBAS)
	ENDDO
	DHH0=(0.D0,0.D0)
	DHHQ=(0.D0,0.D0)
	DO IBAS=MBAS+1,LBAS(L,ISORT,IKAP,IPAN)  !!! NG_0{large}
	DHH0=DHH0+CON0(IBAS)*RHI0(IBAS)         !!! {m1}dV0{m0}
	DHHQ=DHHQ+RHIQ(IBAS)*CONQ(IBAS)         !!! {m0}dVq{m1}
	ENDDO
	DMINT0(IPAR1,IPAR,MY0)=DHH0*SIGNF
	DMINTQ(IPAR,IPAR1,MY0)=DHHQ*SIGNF
	ENDDO                             !!! over polarizations
	ENDIF                             !!! for mode=4 only
	ENDDO                             !!! over m
	ENDDO                             !!! over l
	ENDDO                             !!! over energy
	ENDDO                             !!! over iatom
	ENDDO                             !!! over m1
	ENDDO                             !!! over l1
	ENDDO                             !!! over energy
	ENDDO                             !!! over iatom1
C  STORE DATA FOR K=0
	IREC=1+2*(MY+1)+2*3*(IUPDN-1)+2*3*NSPIN*(IORBS-1)+2*NSPIN*NORBS !!! d{m0}Y0,{m0}DV0
	WRITE(IUPIN,REC=IREC)((DVINT0(IPAR1,IPAR),IPAR1=1,
     &NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DXFUN0(IPAR1,IBAS),
     &IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
C  STORE DATA FOR K=Q
	IREC=2+2*(MY+1)+2*3*(IUPDN-1)+2*3*NSPIN*(IORBS-1)+2*NSPIN*NORBS !!! d{m0}Xq,D{m0}Vq
	WRITE(IUPIN,REC=IREC)((DVINTQ(IPAR1,IPAR),IPAR1=1,
     &NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DXFUNQ(IPAR1,IBAS),
     &IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
C  STORE DMINT-MATRIX
	IREC=1+2*(MY+1)+2*3*(IUPDN-1)+2*3*NSPIN*(IORBS-1)+8*NSPIN*NORBS !!! {m1}dV0{m0}
	IF(MODE.EQ.4)
     &WRITE(IUPIN,REC=IREC)(((DMINT0(IPAR1,IPAR,MY0),IPAR1=1,
     &NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),MY0=-1,1)
	IREC=2+2*(MY+1)+2*3*(IUPDN-1)+2*3*NSPIN*(IORBS-1)+8*NSPIN*NORBS !!! {m0}dVq{m1}
	IF(MODE.EQ.4)
     &WRITE(IUPIN,REC=IREC)(((DMINTQ(IPAR1,IPAR,MY0),IPAR1=1,
     &NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),MY0=-1,1)
 1000 CONTINUE                          !!! over polarizations
 2000 CONTINUE                          !!! over ispin
 3000 CONTINUE                          !!! over iorbs
C Memory allocations
	DEALLOCATE(DXFUN0,DVINT0,DXFUNQ,DVINTQ,CHI0,RHI0)
	DEALLOCATE(CON0,CHIQ,RHIQ,CONQ,EXP0,EXPQ,EXS0,EXSQ)
	DEALLOCATE(YLM0,CFTR0,YLMQ,CFTRQ,DMINT0,DMINTQ)
	END
