	SUBROUTINE DEL_RTOSINT(IPNT,ISGQ,IPAN,IQPNT)
***********************************************************
*  Calculates density arrays.                             *
***********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_KAPPAR,  ONLY : NPAN,NKAP,EK,EKAP                          !!! from readini
	USE COM_LATTICE, ONLY : RBAS,GBAS,TAU                              !!! from readstr
	USE COM_KMESH,   ONLY : NPNT,PNT,WGT                               !!! from makettr
	USE COM_LATPAR,  ONLY : PAR,ORTH,OMEGAC                            !!! from readini
	USE COM_PANPAR,  ONLY : LTPAN,LSPAN,IATS,ISTS                      !!! from readini
	USE COM_PLWMESH, ONLY : NPLW,GPLW                                  !!! from makeplw
	USE COM_SUBGROUP,ONLY : NSGQ,NGEQ,ISG                              !!! from delmesh
	USE COM_GROUPS,  ONLY : NGROUP,INV,IKOV                            !!! from makegrp
	USE COM_QMESH,   ONLY : NQPNT,QPNT                                 !!! from readpnt
	USE COM_NBANDS,  ONLY : NBNDF,NBNDE,NBNDT,NBNDC,NBNDH              !!! from readini
	USE COM_PSIVEC,  ONLY : APHK,APJK,APHQ,APJQ                        !!! from lmtvec
	USE COM_DPSIVEC, ONLY : PSIK,PSIQ,PNTK,PNTQ                        !!! from d2psivec
	USE COM_TEILORG, ONLY : KEYT,BZM,GOPT,MBAS                         !!! from makeplw
	USE COM_SYMMESH, ONLY : IG0IG1,IK0IK1                              !!! from delmesh
	USE COM_ETAPAR,  ONLY : ETA,CUT,LBAS,NBAS                          !!! from makeplw
	USE COM_INDORB,  ONLY : INDLMT                                     !!! from readini
	USE COM_MASHDEP, ONLY : NVAL                                       !!! from setup
	USE COM_LMTOUT,  ONLY : SCRFILE                                    !!! from setup
	USE COM_CHANNELS,ONLY : IUPDS                                      !!! from channels
	USE COM_PHNCHN  ,ONLY : IUTTW                                      !!! from channels
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8, ALLOCATABLE :: WEIGQ(:,:,:)
	REAL*8, ALLOCATABLE :: WEIGK(:,:)
	COMPLEX*16, ALLOCATABLE :: DRFUN0(:,:)
	COMPLEX*16, ALLOCATABLE :: DRFUNQ(:,:)
	COMPLEX*16, ALLOCATABLE :: DRINT0(:,:)
	COMPLEX*16, ALLOCATABLE :: DRINTQ(:,:)
	COMPLEX*16 EXPK0,EXPK1,RMY,RPY
	DIMENSION PNTR(3)
	LOGICAL LOG1,LOG,EXIST
	DATA PI/3.141592653589793D0/
	IF(MODE.EQ.2)RETURN
	IF(MODE.EQ.5)RETURN
	IF(KEYT.LE.0)RETURN
C Memory allocations
	ALLOCATE(WEIGK(NBNDC(1)*NSPINMEM,4))
	ALLOCATE(WEIGQ(NBNDC(1)*NSPINMEM,NBNDC(1)*NSPINMEM,6))
	ALLOCATE(DRFUN0(NBNDT(IPAN),0:MBASMEM))
	ALLOCATE(DRINT0(NBNDT(IPAN),NBNDT(IPAN)))
	ALLOCATE(DRFUNQ(NBNDT(IPAN),0:MBASMEM))
	ALLOCATE(DRINTQ(NBNDT(IPAN),NBNDT(IPAN)))
C  SET POINT-GROUP INFORMATION
	IRK=ISG(1,ISGQ)       !!!  element "g"  in the main G-list
	IGK=IKOV(IRK)         !!!  element "g"  after Kovalev
	IPNTK=IPNT            !!!  point   "k"
	IRQ=IG0IG1(IPNT,IRK)  !!!  element "g'" in the main G-list
	IGQ=IKOV(IRQ)         !!!  element "g'" after Kovalev
	IPNTQ=IK0IK1(IPNT,IRK)!!!  point   "k'" such that g*k+q=g'*k'
C  READ 1/E TETRAHEDRON WEIGHTS FOR BRILLOUIN ZONE INTEGRATION
	IREC=1+IPNTK+NPNT(1)*(ISGQ-1)
	IF(IPAN.EQ.1)THEN
	READ(IUTTW,REC=IREC)WGTQ1,
     &(((WEIGQ(IBANC,IBANC1,IC),IBANC=1,NBNDC(1)*NSPIN),
     &IBANC1=1,NBNDC(1)*NSPIN),IC=1,6),
     &((WEIGK(IBANC,IC),IBANC=1,NBNDC(1)*NSPIN),IC=1,4)
	ELSE ! only geometrical weigths are neccessary
	READ(IUTTW,REC=IREC)WGTQ1
	ENDIF
C  COMPUTE WAVE FUNCTIONS
	CALL DEL_DPSIVEC(0,0,IPNT,ISGQ,IPAN,IQPNT)
C  DO OVER SPINS
	DO 3000 IORBS=1,NORBS
	DO 2000 IUPDN=1,NSPIN
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
C  ####################################################
C  MAKE ORIGINAL INTEGRATION
C  ####################################################
C  READ DENSITY PARAMETERS
	IREC=1+2*(IUPDN-1)+2*NSPIN*(IORBS-1) !!! R0,T0
	READ(IUPDS,REC=IREC)((DRINT0(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DRFUN0(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
	IREC=2+2*(IUPDN-1)+2*NSPIN*(IORBS-1) !!! Sq,Tq
	READ(IUPDS,REC=IREC)((DRINTQ(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DRFUNQ(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
C  DO OVER BANDS
      DO 1200 IBNDS=1,NSPIN                          !!! over spin subbands
      IF(NORBS.EQ.1.AND.IBNDS.NE.ISPIN)GOTO 1200
	DO 1100 IBNDT=1,NBNDF(IPAN)                    !!! over filled bands
	IBNDC=IBNDT-NBNDE(IPAN)+1
	IBANC=IBNDS+NSPIN*(IBNDC-1)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	IF(IBNDT.GE.NBNDE(IPAN))THEN
	WQ1=WEIGK(IBANC,1)          !!! f(kj) 
	WQ2=WEIGK(IBANC,2)          !!! f(k+qj)
	ELSEIF(IBNDT.LT.NBNDE(IPAN))THEN
	WQ1=WGTQ1                   !!! 1
	WQ2=WGTQ1                   !!! 1
	ENDIF
C  SET DENSITY PARAMETERS
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	SCP=PNTK(1)*TAU(1,IATOM)+
     &    PNTK(2)*TAU(2,IATOM)+
     &    PNTK(3)*TAU(3,IATOM)
	EXPK0=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	DO IKAP=1,NKAP(IPAN)
	DO L=0,ILSB(ISORT)
	DO M=-L,L
	IF(.NOT.LTPAN(L,IATOM,IKAP,IPAN))EXIT
	LM=L*(L+1)+M+1
	IPAR=INDLMT(LM,IATOM,IKAP,1,IPAN)
	DO IBAS=0,MIN(NBAS,MBAS)
	DRFUN0(IPAR,IBAS)=DRFUN0(IPAR,IBAS)+WQ1*
     &DCONJG(PSIK(IBAS,ISPIN1,IBAND))*
     &APHK(LM,IATOM,IKAP,ISPIN,IBAND)*EXPK0
	DRFUNQ(IPAR,IBAS)=DRFUNQ(IPAR,IBAS)+WQ2*
     &DCONJG(APHQ(LM,IATOM,IKAP,ISPIN1,IBAND)*EXPK0)*
     &PSIQ(IBAS,ISPIN,IBAND)
	ENDDO
	DO IATOM1=1,NATOM
	ISORT1=IS(IATOM1)
	SCP=PNTK(1)*TAU(1,IATOM1)+
     &    PNTK(2)*TAU(2,IATOM1)+
     &    PNTK(3)*TAU(3,IATOM1)
	EXPK1=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	DO IKAP1=1,NKAP(IPAN)
	DO L1=0,ILSB(ISORT1)
	DO M1=-L1,L1
	IF(.NOT.LTPAN(L1,IATOM1,IKAP1,IPAN))EXIT
	L1M1=L1*(L1+1)+M1+1
	IPAR1=INDLMT(L1M1,IATOM1,IKAP1,1,IPAN)
	DRINT0(IPAR1,IPAR)=DRINT0(IPAR1,IPAR)+WQ1*
     &DCONJG(APHK(L1M1,IATOM1,IKAP1,ISPIN1,IBAND)*EXPK1)*
     &APHK(LM,IATOM,IKAP,ISPIN,IBAND)*EXPK0
	DRINTQ(IPAR1,IPAR)=DRINTQ(IPAR1,IPAR)+WQ2*
     &DCONJG(APHQ(L1M1,IATOM1,IKAP1,ISPIN1,IBAND)*EXPK1)*
     &APHQ(LM,IATOM,IKAP,ISPIN,IBAND)*EXPK0
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
 1100 CONTINUE                                      !!! over filled bands
 1200 CONTINUE                                      !!! over spin subbands
C  STORE DENSITY PARAMETERS
	IREC=1+2*(IUPDN-1)+2*NSPIN*(IORBS-1) !!! R0,T0
	WRITE(IUPDS,REC=IREC)((DRINT0(IPAR1,IPAR),IPAR1=1,
     &NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DRFUN0(IPAR1,IBAS),
     &IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
	IREC=2+2*(IUPDN-1)+2*NSPIN*(IORBS-1) !!! Sq,Tq
	WRITE(IUPDS,REC=IREC)((DRINTQ(IPAR1,IPAR),IPAR1=1,
     &NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DRFUNQ(IPAR1,IBAS),
     &IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
 2000 CONTINUE
 3000 CONTINUE
C Memory deallocations
	DEALLOCATE(WEIGQ,WEIGK,DRFUN0,DRINT0,DRFUNQ,DRINTQ)
	END





	SUBROUTINE DEL_RNULINT(IPAN,IQPNT)
************************************************
*  Zeroises density parameters                 *
************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_KAPPAR,  ONLY : NPAN,NKAP,EK,EKAP                          !!! from readini
	USE COM_PANPAR,  ONLY : LTPAN,LSPAN,IATS,ISTS                      !!! from readini
	USE COM_QMESH,   ONLY : NQPNT,QPNT                                 !!! from readpnt
	USE COM_NBANDS,  ONLY : NBNDF,NBNDE,NBNDT                          !!! from readini
	USE COM_ETAPAR,  ONLY : ETA,CUT,LBAS,NBAS                          !!! from makeplw
	USE COM_INDORB,  ONLY : INDLMT                                     !!! from readini
	USE COM_MASHDEP, ONLY : NVAL                                       !!! from setup
	USE COM_TEILORG, ONLY : KEYT,MBAS                                  !!! from makeplw
	USE COM_LMTOUT,  ONLY : SCRFILE                                    !!! from setup
	USE COM_CHANNELS,ONLY : IUPDS                                      !!! from channels
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: DRFUN0(:,:)
	COMPLEX*16, ALLOCATABLE :: DRFUNQ(:,:)
	COMPLEX*16, ALLOCATABLE :: DRINT0(:,:)
	COMPLEX*16, ALLOCATABLE :: DRINTQ(:,:)
	COMPLEX*16 EXPK0,EXPK1,RMY,RPY
	DIMENSION PNTR(3)
	LOGICAL LOG1,LOG,EXIST
	DATA PI/3.141592653589793D0/
C  OPEN SCRATCH FILE FOR STORING DENSITY PARAMETERS
	INQUIRE(FILE=SCRFILE(IUPDS),EXIST=EXIST)
	IF(.NOT.EXIST)THEN
	NRECL=NVAL*(NBNDT(IPAN)*(MIN(NBAS,MBAS)+1)+
     &  NBNDT(IPAN)**2)
	OPEN(UNIT=IUPDS,FILE=SCRFILE(IUPDS),STATUS='NEW',
     &  ACCESS='DIRECT',FORM='UNFORMATTED',RECL=NRECL)
	ENDIF
	IF(KEYT.LE.0)RETURN
	IF(MODE.EQ.2)RETURN
	IF(MODE.EQ.5)RETURN
	ALLOCATE(DRFUN0(NBNDT(IPAN),0:MBASMEM))
	ALLOCATE(DRINT0(NBNDT(IPAN),NBNDT(IPAN)))
	ALLOCATE(DRFUNQ(NBNDT(IPAN),0:MBASMEM))
	ALLOCATE(DRINTQ(NBNDT(IPAN),NBNDT(IPAN)))
	DO IPAR=1,NBNDT(IPAN)                          !!! over ipar
	DO JPAR=1,NBNDT(IPAN)                          !!! over jpar
	DRINT0(JPAR,IPAR)=(0.D0,0.D0)
	DRINTQ(JPAR,IPAR)=(0.D0,0.D0)
	ENDDO                                          !!! over jpar
	DO IBAS=0,MIN(NBAS,MBAS)                       !!! over ibas
	DRFUN0(IPAR,IBAS)=(0.D0,0.D0)
	DRFUNQ(IPAR,IBAS)=(0.D0,0.D0)
	ENDDO                                          !!! over ibas
	ENDDO                                          !!! over ipar
C  SET ZEROES IN SCRATCH FILE
      DO IORBS=1,NORBS
      DO IUPDN=1,NSPIN
	IREC=1+2*(IUPDN-1)+2*NSPIN*(IORBS-1) !!! R0,T0
	WRITE(IUPDS,REC=IREC)((DRINT0(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DRFUN0(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
	IREC=2+2*(IUPDN-1)+2*NSPIN*(IORBS-1) !!! Sq,Tq
	WRITE(IUPDS,REC=IREC)((DRINTQ(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DRFUNQ(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
      ENDDO
      ENDDO
	DEALLOCATE(DRFUN0,DRINT0,DRFUNQ,DRINTQ)
	END
