	SUBROUTINE DEL_SGMPAR(IPAN)
***************************************************************
*   Prepare self-energy potential parameters.                 *
***************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
	USE COM_LMTMEM
      USE COM_CONTROL ,ONLY: LMTO,IASA,IDMF,NOVR,NPFR               !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS,ILST,ILSB,LRTV! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP,EK                      !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN,IATS,ISTS                  !!! from readini
      USE COM_SPHERE  ,ONLY: ZNUC,SMT                               !!! from readini
      USE COM_INPPAR  ,ONLY: ENY,DNY                                !!! from readini
      USE COM_MTSPAR  ,ONLY: OMTHH,OMTJH,OMTHJ,OMTJJ                !!! from lmtpar
      USE COM_POTDAT  ,ONLY: POT,POTSPH,POTRWF                      !!! from potfull
      USE COM_LMTPAR  ,ONLY: GAM,AAH,AAJ,BBH,BBJ                    !!! from potpar
      USE COM_HAMPAR  ,ONLY: HPARHH,HPARJH,HPARHJ,HPARJJ            !!! from potpar
      USE COM_RADMESH ,ONLY: NRAD,H,R,DR,WEIGHT,RL                  !!! from radmesh
      USE COM_MASHDEP ,ONLY: NVAL,LENREL,LENCMP                     !!! from setup
      USE COM_HUBCOM  ,ONLY: VDBC                                   !!! from grfmat
      USE COM_DMFDAT  ,ONLY: SIGW                                   !!! from grfmat
      USE COM_CHANNELS,ONLY: IUNMT                                  !!! from readini
      USE COM_LMTOUT  ,ONLY: SCRFILE                                !!! from readini
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8, ALLOCATABLE :: AFI(:,:)
	REAL*8, ALLOCATABLE :: AFID(:,:)
	REAL*8, ALLOCATABLE :: AFIP(:,:)
	REAL*8, ALLOCATABLE :: AFIDP(:,:)
	REAL*8, ALLOCATABLE :: AFIDDS(:)
	REAL*8, ALLOCATABLE :: AFIDDPS(:)
	COMPLEX*16, ALLOCATABLE :: DPAR(:,:)
	COMPLEX*16, ALLOCATABLE :: WORK1(:)
	COMPLEX*16, ALLOCATABLE :: WORK2(:)
	COMPLEX*16, ALLOCATABLE :: FIH(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: FIJ(:,:,:,:)
	LOGICAL LOG1,LOG
	DATA PI/3.141592653589793D0/
      CALL ABORTNOW()
C RETURN KEYS
	IF(IDMF.NE.4)RETURN
	IF(IPAN.NE.1)RETURN
C MEMORY ALLOCATIONS FOR SCRATCH ARRAYS
	ALLOCATE(DPAR(4,0:LMAXTMEM))
	ALLOCATE(WORK1(0:NRADMEM))
	ALLOCATE(WORK2(0:NRADMEM))
	ALLOCATE(FIH(0:NRADMEM,0:LMAXTMEM,NKAPMEM,NSPINMEM))
	ALLOCATE(FIJ(0:NRADMEM,0:LMAXTMEM,NKAPMEM,NSPINMEM))
      SIZE_FIS=2.D0*DBLE(SIZE(FIH)*LENCMP)/1024.D0**2
	ALLOCATE(AFI(0:NRADMEM,0:LMAXTMEM))
	ALLOCATE(AFID(0:NRADMEM,0:LMAXTMEM))
	ALLOCATE(AFIP(0:NRADMEM,0:LMAXTMEM))
	ALLOCATE(AFIDP(0:NRADMEM,0:LMAXTMEM))
	SIZE_AFI=4.D0*DBLE(SIZE(AFI)*LENREL)/1024.D0**2
	ALLOCATE(AFIDDS(0:LMAXTMEM))
	ALLOCATE(AFIDDPS(0:LMAXTMEM))
      CURMEM=CURMEM+SIZE_FIS+SIZE_AFI
      IF(TOTMEM.LT.CURMEM)TXTMEM='<HUBPAR> Subroutine'
      IF(TOTMEM.LT.CURMEM)TOTMEM=CURMEM
C OPEN SCRATCH FILE FOR STORING POTENTIAL PARAMETERS
	NRECL=0
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	LMAXH=((ILSB(ISORT)+1)**2+(ILST(ISORT)+1)**2)**2
	NRECL=MAX(NRECL,NVAL*LMAXH)
	ENDDO
C START CODE
	DO 5000 IATOM=1,NATOM          !!! over atoms
	ISORT=IS(IATOM)
C Find FIny and FIny-dot radial functions:
	DO ISPIN=1,NSPIN
	DO IKAP=1,NKAP(IPAN)           !!! over energies
      CALL LIB_RADSCH_PHIS(ENY(0,ISORT,IKAP,IPAN,ISPIN),AFI,AFIP,
     &AFID,AFIDP,AFIDDS,AFIDDPS,SMT(ISORT),POTRWF(0,ISORT,ISPIN),
     &ILST(ISORT),NRAD(ISORT),H(ISORT),R(0,ISORT),DR(0,ISORT),
     &LRTV(ISORT))
C Transfere to FIH and FIJ convinient functions:
	DO L=0,ILST(ISORT)
	DO IRAD=0,NRAD(ISORT)
	FIH(IRAD,L,IKAP,ISPIN)=AAH(L,ISORT,IKAP,IPAN,ISPIN)*
     &AFI(IRAD,L)+BBH(L,ISORT,IKAP,IPAN,ISPIN)*AFIP(IRAD,L)
	FIJ(IRAD,L,IKAP,ISPIN)=AAJ(L,ISORT,IKAP,IPAN,ISPIN)*
     &AFI(IRAD,L)+BBJ(L,ISORT,IKAP,IPAN,ISPIN)*AFIP(IRAD,L)
      ENDDO    
      ENDDO   
      ENDDO                          !!! over energies
	ENDDO                          !!! over spins
	DO 4000 IORBS=1,NORBS          !!! over spins
	DO 3000 IUPDN=1,NSPIN          !!! over spins
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
      DO 2000 IKAP1=1,NKAP(IPAN)     !!! over energy
      DO 1000 IKAP =1,NKAP(IPAN)     !!! over energy
C READ POTENTIAL PARAMETERS
      IREC=IKAP1+NKAP(IPAN)*(IKAP-1)+NKAP(IPAN)**2*(IATOM-1)+
     &NKAP(IPAN)**2*NATOM*(IUPDN-1)+
     &NKAP(IPAN)**2*NATOM*NSPIN*(IORBS-1)
      READ(IUNMT,REC=IREC)((HPARHH(L1M1,LM,IATOM),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((HPARJH(L1M1,LM,IATOM),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((HPARHJ(L1M1,LM,IATOM),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &((HPARJJ(L1M1,LM,IATOM),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2)
C ADD SELF-ENERGY TO THE HAMILTONIAN MATRIX ELEMENTS
	DO L=0,ILSB(ISORT)             !!! over l
	LOG1=.FALSE.
	LOG =.FALSE.
	IF(LTPAN(L,IATOM,IKAP1,IPAN))LOG1=.TRUE.
	IF(LTPAN(L,IATOM,IKAP ,IPAN))LOG =.TRUE.
C 1) <H|dV|H>
	IF(LOG1.AND.LOG)THEN
	WORK1(0)=(0.D0,0.D0)
	DO IRAD=1,NRAD(ISORT)          !!! over radial mesh
	WORK1(IRAD)=
     &CONJG(FIH(IRAD,L,IKAP1,ISPIN1))*FIH(IRAD,L,IKAP,ISPIN)*
     &R(IRAD,ISORT)**2*DR(IRAD,ISORT)
      ENDDO                          !!! over radial mesh
	CALL LIB_CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	DPAR(1,L)=WORK2(NRAD(ISORT))
	IF(ISPIN1.EQ.ISPIN)
     &DPAR(1,L)=OMTHH(IKAP1,IKAP,L,ISORT,ISPIN)
	ENDIF
C 2) <J|dV|H> diagonal
	IF(LOG)THEN
	WORK1(0)=(0.D0,0.D0)
	DO IRAD=1,NRAD(ISORT)          !!! over radial mesh
	WORK1(IRAD)=
     &CONJG(FIJ(IRAD,L,IKAP1,ISPIN1))*FIH(IRAD,L,IKAP,ISPIN)*
     &R(IRAD,ISORT)**2*DR(IRAD,ISORT)
      ENDDO                          !!! over radial mesh
	CALL LIB_CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	DPAR(2,L)=WORK2(NRAD(ISORT))*GAM(L,ISORT)
	IF(ISPIN1.EQ.ISPIN)
     &DPAR(2,L)=OMTJH(IKAP1,IKAP,L,ISORT,ISPIN)
	ENDIF
C 3) <H|dV|J> diagonal
	IF(LOG1)THEN
	WORK1(0)=(0.D0,0.D0)
	DO IRAD=1,NRAD(ISORT)          !!! over radial mesh
	WORK1(IRAD)=
     &CONJG(FIH(IRAD,L,IKAP1,ISPIN1))*FIJ(IRAD,L,IKAP,ISPIN)*
     &R(IRAD,ISORT)**2*DR(IRAD,ISORT)
      ENDDO                          !!! over radial mesh
	CALL LIB_CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	DPAR(3,L)=WORK2(NRAD(ISORT))*GAM(L,ISORT)
	IF(ISPIN1.EQ.ISPIN)
     &DPAR(3,L)=OMTHJ(IKAP1,IKAP,L,ISORT,ISPIN)
	ENDIF
C 4) <J|dV|J> diagonal
	WORK1(0)=(0.D0,0.D0)
	DO IRAD=1,NRAD(ISORT)          !!! over radial mesh
	WORK1(IRAD)=
     &CONJG(FIJ(IRAD,L,IKAP1,ISPIN1))*FIJ(IRAD,L,IKAP,ISPIN)*
     &R(IRAD,ISORT)**2*DR(IRAD,ISORT)
      ENDDO                          !!! over radial mesh
	CALL LIB_CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	DPAR(4,L)=WORK2(NRAD(ISORT))*GAM(L,ISORT)**2
	IF(ISPIN1.EQ.ISPIN)
     &DPAR(4,L)=OMTJJ(IKAP1,IKAP,L,ISORT,ISPIN)
C ********************
C Note that SIGW is ALREADY the matrix element <B^{+/-} * S_{+/-}>
C not just a field <B^{+/-}>!
	DO M1=-L,L                     !!! over m1
	LM1=L*(L+1)+M1+1
	DO M=-L,L                      !!! over m
	LM=L*(L+1)+M+1
      IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M1+1 !!! (l,m1 m)
C We need to divide by {+/-}sqrt(2) here since off diag. elements were multiplied by this factor
	IF(LOG1.AND.LOG)
     &HPARHH(LM1,LM,IATOM)=HPARHH(LM1,LM,IATOM)+
     &DPAR(1,L)*(SIGW(IU,IATOM,IUPDN,IORBS)-
     &           VDBC(IU,IATOM,IUPDN,IORBS))
 	IF(LOG)
     &HPARJH(LM1,LM,IATOM)=HPARJH(LM1,LM,IATOM)+
     &DPAR(2,L)*(SIGW(IU,IATOM,IUPDN,IORBS)-
     &           VDBC(IU,IATOM,IUPDN,IORBS))
 	IF(LOG1)
     &HPARHJ(LM1,LM,IATOM)=HPARHJ(LM1,LM,IATOM)+
     &DPAR(3,L)*(SIGW(IU,IATOM,IUPDN,IORBS)-
     &           VDBC(IU,IATOM,IUPDN,IORBS))
 	HPARJJ(LM1,LM,IATOM)=HPARJJ(LM1,LM,IATOM)+
     &DPAR(4,L)*(SIGW(IU,IATOM,IUPDN,IORBS)-
     &           VDBC(IU,IATOM,IUPDN,IORBS))
      ENDDO                          !!! over m
      ENDDO                          !!! over m1
      ENDDO                          !!! over l
C STORE POTENTIAL PARAMETERS
	IREC=IKAP1+NKAP(IPAN)*(IKAP-1)+NKAP(IPAN)**2*(IATOM-1)+
     &NKAP(IPAN)**2*NATOM*(IUPDN-1)+
     &NKAP(IPAN)**2*NATOM*NSPIN*(IORBS-1)
	WRITE(IUNMT,REC=IREC)((HPARHH(L1M1,LM,IATOM),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((HPARJH(L1M1,LM,IATOM),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((HPARHJ(L1M1,LM,IATOM),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &((HPARJJ(L1M1,LM,IATOM),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2)
1000  CONTINUE                       !!! over ikap
2000  CONTINUE                       !!! over ikap1
3000  CONTINUE                       !!! over spins
4000  CONTINUE                       !!! over iorbs
5000  CONTINUE                       !!! over atoms
C MEMORY DEALLOCATIONS
	DEALLOCATE(DPAR,WORK1,WORK2,FIH,FIJ)
	DEALLOCATE(AFI,AFID,AFIP,AFIDP,AFIDDS,AFIDDPS)
      CURMEM=CURMEM-SIZE_FIS-SIZE_AFI
	END
