	SUBROUTINE DEL_SSTRVEC(MY0,INUC,IPNT,ISGQ,IPAN,IQPNT)
************************************************************
*  Calculate convolutions of the variational coefficients  *
*  A(kj) with the structure constants S(k+q).              *
************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_LATPAR,  ONLY : PAR                                        !!! from readini
	USE COM_KAPPAR,  ONLY : NPAN,NKAP,EK,EKAP                          !!! from readini
	USE COM_PANPAR,  ONLY : LTPAN,LSPAN,IATS,ISTS                      !!! from readini
	USE COM_NBANDS,  ONLY : NBNDF,NBNDE,NBNDT,NBNDH                    !!! from readini
	USE COM_PSIVEC,  ONLY : APHK,APJK,APHQ,APJQ                        !!! from lmtvec
	USE COM_DSTRCON, ONLY : STRK,STDK,STRQ,STDQ,DSKL,DSQL,DDQL         !!! from delgnt
	USE COM_SPHERE,  ONLY : SWZ,SMT                                    !!! from readini
	USE COM_GAUNT,   ONLY : C                                          !!! from makegnt
	USE COM_MASHDEP, ONLY : NVAL                                       !!! from setup
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: SSKQ(:,:)
	COMPLEX*16, ALLOCATABLE :: SSQK(:,:)
	COMPLEX*16, ALLOCATABLE :: SDKQ(:,:)
	COMPLEX*16, ALLOCATABLE :: SDQK(:,:)
	COMPLEX*16, ALLOCATABLE :: DPJK(:)
	COMPLEX*16, ALLOCATABLE :: DPJQ(:)
	COMPLEX*16 CGNT1,CGNT2,CGNT3,DGNT1,DGNT2,DGNT3
	LOGICAL LOG(4)
	DATA PI/3.141592653589793D0/
	IF(MODE.EQ.2)RETURN
C Memory allocations
	ALLOCATE(SSKQ(LIMT1MEM,NATOMMEM))
	ALLOCATE(SSQK(LIMT1MEM,NATOMMEM))
	ALLOCATE(SDKQ(LIMT1MEM,NATOMMEM))
	ALLOCATE(SDQK(LIMT1MEM,NATOMMEM))
	ALLOCATE(DPJK(LIMB1MEM))
	ALLOCATE(DPJQ(LIMB1MEM))
	SQPI43=SQRT(4.D0*PI/3.D0)
      IF(MODE.NE.5)IBNDMIN=1
      IF(MODE.NE.5)IBNDMAX=NBNDT(IPAN)+NBNDH(IPAN)
      IF(MODE.EQ.5)IBNDMIN=NBNDE(IPAN)
      IF(MODE.EQ.5)IBNDMAX=NBNDF(IPAN)
	DO 4000 IBNDS=1,NSPIN                          !!! over spin subbands
      DO 3000 IBNDT=IBNDMIN,IBNDMAX                  !!! over bands
      IBAND=IBNDS+NSPIN*(IBNDT-1)
	DO 2000 IORBS=1,NORBS                          !!! over spinors
      IF(NORBS.EQ.1)ISPIN=IBNDS
      IF(NORBS.EQ.2)ISPIN=IORBS
	DO 1000 IKAP=1,NKAP(IPAN)                      !!! over energies
C ***** FIND STR.CONSTANTS-EIGENVECTORS CONVOLUTIONS *****
	DO IATOM=1,NATOM                               !!! over atoms
	ISORT=IS(IATOM)
	DO L=0,ILST(ISORT)+1                           !!! over l
	DO M=-L,L                                      !!! over m
	LM=L*(L+1)+M+1
	SSQK(LM,IATOM)=(0.D0,0.D0)
	SSKQ(LM,IATOM)=(0.D0,0.D0)
	SDKQ(LM,IATOM)=(0.D0,0.D0)
C     SDQK(LM,IATOM)=(0.D0,0.D0)
	DO L1=0,ILSB(IS(INUC))                         !!! over l1
	LOG(1)=.FALSE.
	LOG(2)=.FALSE.
	LOG(3)=.FALSE.
C     LOG(4)=.FALSE.
	IF(LTPAN(L1,INUC,IKAP,IPAN))LOG(1)=.TRUE.
	IF(LTPAN(L1,INUC,IKAP,IPAN))LOG(2)=.TRUE.
	IF(LTPAN(L1,INUC,IKAP,IPAN).AND.L.LE.ILSB(ISORT)+1)LOG(3)=.TRUE.
C     IF(LTPAN(L1,INUC,IKAP,IPAN).AND.L.LE.ILSB(ISORT)+1)LOG(4)=.TRUE.
	DO M1=-L1,L1                                   !!! over m1
	L1M1=L1*(L1+1)+M1+1
C  MAKE CONVOLUTIONS OF S(k+q) WITH A(k)
	IF(LOG(1))SSQK(LM,IATOM)=SSQK(LM,IATOM)+
     &  STRQ(LM,IATOM,L1M1,INUC,IKAP)*APHK(L1M1,INUC,IKAP,ISPIN,IBAND)
C  MAKE CONVOLUTIONS OF S(k) WITH A(k+q)
	IF(LOG(2))SSKQ(LM,IATOM)=SSKQ(LM,IATOM)+
     &  STRK(LM,IATOM,L1M1,INUC,IKAP)*APHQ(L1M1,INUC,IKAP,ISPIN,IBAND)
C  MAKE CONVOLUTIONS OF S-dot(k) WITH A(k+q)
	IF(LOG(3))SDKQ(LM,IATOM)=SDKQ(LM,IATOM)+
     &  STDK(LM,IATOM,L1M1,INUC,IKAP)*APHQ(L1M1,INUC,IKAP,ISPIN,IBAND)
C  MAKE CONVOLUTIONS OF S-DOT(k+q) WITH A(k)
C     IF(LOG(4))SDQK(LM,IATOM)=SDQK(LM,IATOM)+
C    &  STDQ(LM,IATOM,L1M1,INUC,IKAP)*APHK(L1M1,INUC,IKAP,ISPIN,IBAND)
      ENDDO                                          !!! over m1
      ENDDO                                          !!! over l1
      ENDDO                                          !!! over m
      ENDDO                                          !!! over l
      ENDDO                                          !!! over atoms
C ***** FIND STR.DOT.CONSTANTS-EIGENVECTORS CONVOLUTIONS *****
	DO L=0,ILSB(IS(INUC))+1                        !!! over l
	DO M=-L,L                                      !!! over m
	LM=L*(L+1)+M+1
	DPJQ(LM)=(0.D0,0.D0)
C     DPJK(LM)=(0.D0,0.D0)
	DO IATOM=1,NATOM                               !!! over atoms
	ISORT=IS(IATOM)
	DO L1=0,ILSB(ISORT)                            !!! over l1
	LOG(1)=.FALSE.
	IF(LTPAN(L1,IATOM,IKAP,IPAN))LOG(1)=.TRUE.
	DO M1=-L1,L1                                   !!! over m1
	L1M1=L1*(L1+1)+M1+1
	IF(LOG(1))DPJQ(LM)=DPJQ(LM)+
     &  STDQ(LM,INUC,L1M1,IATOM,IKAP)*APHQ(L1M1,IATOM,IKAP,ISPIN,IBAND)
C     IF(LOG(1))DPJK(LM)=DPJK(LM)+
C    &  STDK(LM,INUC,L1M1,IATOM,IKAP)*APHK(L1M1,IATOM,IKAP,ISPIN,IBAND)
      ENDDO                                          !!! over m1
      ENDDO                                          !!! over l1
      ENDDO                                          !!! over atoms
      ENDDO                                          !!! over m
      ENDDO                                          !!! over l
C ***** FIND DERIVATIVE OF THE STR.CON-EIGENVEC. CONVOLUTIONS *****
	DO IATOM=1,NATOM                               !!! over atoms
	ISORT=IS(IATOM)
	DO MY=-1,1                                     !!! over polarizations
	DO L=0,ILST(ISORT)                             !!! over l
	DO M=-L,L                                      !!! over m
	LM=L*(L+1)+M+1
	LM1M=L*(L-1)+M-MY+1
	LP1M=(L+1)*(L+2)+M-MY+1
	LOG(1)=.FALSE.
	IF(L.LE.ILSB(ISORT))LOG(1)=.TRUE.
	DSKL(LM,IATOM,IKAP,ISPIN,IBAND,MY)=(0.D0,0.D0) !!! dS(kj)    /dT
	DSQL(LM,IATOM,IKAP,ISPIN,IBAND,MY)=(0.D0,0.D0) !!! dS(k+q,j')/dT
	IF(LOG(1))
     &DDQL(LM,IATOM,IKAP,ISPIN,IBAND,MY)=(0.D0,0.D0) !!! dD(k+q,j')/dT
C     IF(LOG(1))
C    &DDKL(LM,IATOM,IKAP,ISPIN,IBAND,MY)=(0.D0,0.D0) !!! dD(kj)    /dT
	CGNT1=(0.D0,0.D0)
	IF(L.NE.0.AND.ABS(M-MY).LE.L-1)THEN
	CGNT1=(0.D0,1.D0)*SQPI43*C((L-1)/2,LM,3+MY)*
     &EKAP(IKAP,IPAN)*SMT(ISORT)/(2.D0*L-1)
	CGNT3=(0.D0,1.D0)*SQPI43*C((L-1)/2,LM,3+MY)*
     &  SMT(ISORT)/(2.D0*L-1)
	DGNT1=CGNT1*PAR**3
	DGNT3=CGNT3*PAR
	IF(IATOM.EQ.INUC)THEN
	DSKL(LM,IATOM,IKAP,ISPIN,IBAND,MY)=
     &DSKL(LM,IATOM,IKAP,ISPIN,IBAND,MY)+
     &CGNT1*APJK(LM1M,IATOM,IKAP,ISPIN,IBAND)
	DSQL(LM,IATOM,IKAP,ISPIN,IBAND,MY)=
     &DSQL(LM,IATOM,IKAP,ISPIN,IBAND,MY)+
     &CGNT1*APJQ(LM1M,IATOM,IKAP,ISPIN,IBAND)
	IF(LOG(1))DDQL(LM,IATOM,IKAP,ISPIN,IBAND,MY)=
     &DDQL(LM,IATOM,IKAP,ISPIN,IBAND,MY)+DGNT1*DPJQ(LM1M)+
     &DGNT3*APJQ(LM1M,IATOM,IKAP,ISPIN,IBAND)
C     IF(LOG(1))DDKL(LM,IATOM,IKAP,ISPIN,IBAND,MY)=
C    &DDKL(LM,IATOM,IKAP,ISPIN,IBAND,MY)+DGNT1*DPJK(LM1M)+
C    &DGNT3*APJK(LM1M,IATOM,IKAP,ISPIN,IBAND)
	ENDIF
	DSKL(LM,IATOM,IKAP,ISPIN,IBAND,MY)=
     &DSKL(LM,IATOM,IKAP,ISPIN,IBAND,MY)-CGNT1*SSQK(LM1M,IATOM)
	DSQL(LM,IATOM,IKAP,ISPIN,IBAND,MY)=
     &DSQL(LM,IATOM,IKAP,ISPIN,IBAND,MY)-CGNT1*SSKQ(LM1M,IATOM)
	IF(LOG(1))DDQL(LM,IATOM,IKAP,ISPIN,IBAND,MY)=
     &DDQL(LM,IATOM,IKAP,ISPIN,IBAND,MY)-DGNT1*SDKQ(LM1M,IATOM)-
     &DGNT3*SSKQ(LM1M,IATOM)
C     IF(LOG(1))DDKL(LM,IATOM,IKAP,ISPIN,IBAND,MY)=
C    &DDKL(LM,IATOM,IKAP,ISPIN,IBAND,MY)-DGNT1*SDQK(LM1M,IATOM)-
C    &DGNT3*SSKQ(LM1M,IATOM)
	ENDIF
	CGNT2=(0.D0,1.D0)*SQPI43*C((L+1)/2,LM,3+MY)/
     &SMT(ISORT)*(2.D0*L+1)
	DGNT2=CGNT2*PAR**3
	IF(IATOM.EQ.INUC)THEN
	DSKL(LM,IATOM,IKAP,ISPIN,IBAND,MY)=
     &DSKL(LM,IATOM,IKAP,ISPIN,IBAND,MY)+
     &CGNT2*APJK(LP1M,IATOM,IKAP,ISPIN,IBAND)
	DSQL(LM,IATOM,IKAP,ISPIN,IBAND,MY)=
     &DSQL(LM,IATOM,IKAP,ISPIN,IBAND,MY)+
     &CGNT2*APJQ(LP1M,IATOM,IKAP,ISPIN,IBAND)
	IF(LOG(1))DDQL(LM,IATOM,IKAP,ISPIN,IBAND,MY)=
     &DDQL(LM,IATOM,IKAP,ISPIN,IBAND,MY)+DGNT2*DPJQ(LP1M)
C     IF(LOG(1))DDKL(LM,IATOM,IKAP,ISPIN,IBAND,MY)=
C    &DDKL(LM,IATOM,IKAP,ISPIN,IBAND,MY)+DGNT2*DPJK(LP1M)
	ENDIF
	DSKL(LM,IATOM,IKAP,ISPIN,IBAND,MY)=
     &DSKL(LM,IATOM,IKAP,ISPIN,IBAND,MY)-CGNT2*SSQK(LP1M,IATOM)
	DSQL(LM,IATOM,IKAP,ISPIN,IBAND,MY)=
     &DSQL(LM,IATOM,IKAP,ISPIN,IBAND,MY)-CGNT2*SSKQ(LP1M,IATOM)
	IF(LOG(1))DDQL(LM,IATOM,IKAP,ISPIN,IBAND,MY)=
     &DDQL(LM,IATOM,IKAP,ISPIN,IBAND,MY)-DGNT2*SDKQ(LP1M,IATOM)
C     IF(LOG(1))DDKL(LM,IATOM,IKAP,ISPIN,IBAND,MY)=
C    &DDKL(LM,IATOM,IKAP,ISPIN,IBAND,MY)-DGNT2*SDQK(LP1M,IATOM)
      ENDDO                                       !!! over m
      ENDDO                                       !!! over l
      ENDDO                                       !!! over polarizations
      ENDDO                                       !!! over atoms
 1000 CONTINUE                                    !!! over energies
 2000 CONTINUE                                    !!! over spinors
 3000 CONTINUE                                    !!! over bands
 4000 CONTINUE                                    !!! over spin subbands
C Memory deallocations
	DEALLOCATE(SSKQ,SSQK,SDKQ,SDQK,DPJK,DPJQ)
	END



	SUBROUTINE DEL_STRVEC2(IPNT,ISGQ,IPAN,IQPNT)
************************************************************
*  Calculate convolutions of the variational coefficients  *
*  A(kj) with the structure constants S(k+q).              *
************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_LATPAR,  ONLY : PAR                                        !!! from readini
	USE COM_KAPPAR,  ONLY : NPAN,NKAP,EK,EKAP                          !!! from readini
	USE COM_PANPAR,  ONLY : LTPAN,LSPAN,IATS,ISTS                      !!! from readini
	USE COM_SPHERE,  ONLY : SWZ,SMT                                    !!! from readini
	USE COM_PSIVEC,  ONLY : APHK,APJK,APHQ,APJQ                        !!! from lmtvec
	USE COM_DSTRCON, ONLY : STRK,STDK,STRQ,STDQ
     &                       ,DSKL2,DSQL2,DDQL2                          !!! from delgnt
	USE COM_NBANDS,  ONLY : NBNDF,NBNDE,NBNDT,NBNDH                    !!! from readini
	USE COM_GAUNT,   ONLY : C                                          !!! from makegnt
	USE COM_MASHDEP, ONLY : NVAL                                       !!! from setup
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: SSKQ(:,:)
	COMPLEX*16, ALLOCATABLE :: SSQK(:,:)
	COMPLEX*16, ALLOCATABLE :: SDKQ(:,:)
	COMPLEX*16, ALLOCATABLE :: SDQK(:,:)
	COMPLEX*16, ALLOCATABLE :: DPJK(:)
	COMPLEX*16, ALLOCATABLE :: DPJQ(:)
	COMPLEX*16 CGNT1,CGNT2,CGNT3,DGNT1,DGNT2,DGNT3
	LOGICAL LOG(4)
	DATA PI/3.141592653589793D0/
	IF(MODE.NE.4)RETURN
C Memory allocations
	ALLOCATE(SSKQ(LIMT1MEM,NATOMMEM))
	ALLOCATE(SSQK(LIMT1MEM,NATOMMEM))
	ALLOCATE(SDKQ(LIMT1MEM,NATOMMEM))
	ALLOCATE(SDQK(LIMT1MEM,NATOMMEM))
	ALLOCATE(DPJK(LIMB1MEM))
	ALLOCATE(DPJQ(LIMB1MEM))
	SQPI43=SQRT(4.D0*PI/3.D0)
	DO 5000 IBNDS=1,NSPIN                          !!! over spin subbands
      DO 4000 IBNDT=1,NBNDF(IPAN)+NBNDH(IPAN)        !!! over bands
      IBAND=IBNDS+NSPIN*(IBNDT-1)
	DO 3000 IORBS=1,NORBS                          !!! over spinors
      IF(NORBS.EQ.1)ISPIN=IBNDS
      IF(NORBS.EQ.2)ISPIN=IORBS
C ALL OPERATIONS BELOW ASSUME IBND-INDEX
	DO 2000 INUC=1,NATOM                           !!! over displacements
	DO 1000 IKAP=1,NKAP(IPAN)                      !!! over energies
C ***** FIND STR.CONSTANTS-EIGENVECTORS CONVOLUTIONS *****
	DO IATOM=1,NATOM                               !!! over atoms
	ISORT=IS(IATOM)
	DO L=0,ILST(ISORT)+1                           !!! over l
	DO M=-L,L                                      !!! over m
	LM=L*(L+1)+M+1
	SSQK(LM,IATOM)=(0.D0,0.D0)
	SSKQ(LM,IATOM)=(0.D0,0.D0)
	SDKQ(LM,IATOM)=(0.D0,0.D0)
C     SDQK(LM,IATOM)=(0.D0,0.D0)
	DO L1=0,ILSB(IS(INUC))                         !!! over l1
	LOG(1)=.FALSE.
	LOG(2)=.FALSE.
	LOG(3)=.FALSE.
C     LOG(4)=.FALSE.
	IF(LTPAN(L1,INUC,IKAP,IPAN))LOG(1)=.TRUE.
	IF(LTPAN(L1,INUC,IKAP,IPAN))LOG(2)=.TRUE.
	IF(LTPAN(L1,INUC,IKAP,IPAN).AND.L.LE.ILSB(ISORT)+1)LOG(3)=.TRUE.
C     IF(LTPAN(L1,INUC,IKAP,IPAN).AND.L.LE.ILSB(ISORT)+1)LOG(4)=.TRUE.
	DO M1=-L1,L1                                   !!! over m1
	L1M1=L1*(L1+1)+M1+1
C  MAKE CONVOLUTIONS OF S(k+q) WITH A(k)
	IF(LOG(1))SSQK(LM,IATOM)=SSQK(LM,IATOM)+
     &STRQ(LM,IATOM,L1M1,INUC,IKAP)*APHK(L1M1,INUC,IKAP,ISPIN,IBAND)
C  MAKE CONVOLUTIONS OF S(k) WITH A(k+q)
	IF(LOG(2))SSKQ(LM,IATOM)=SSKQ(LM,IATOM)+
     &STRK(LM,IATOM,L1M1,INUC,IKAP)*APHQ(L1M1,INUC,IKAP,ISPIN,IBAND)
C  MAKE CONVOLUTIONS OF S-dot(k) WITH A(k+q)
	IF(LOG(3))SDKQ(LM,IATOM)=SDKQ(LM,IATOM)+
     &STDK(LM,IATOM,L1M1,INUC,IKAP)*APHQ(L1M1,INUC,IKAP,ISPIN,IBAND)
C  MAKE CONVOLUTIONS OF S-DOT(k+q) WITH A(k)
C     IF(LOG(4))SDQK(LM,IATOM)=SDQK(LM,IATOM)+
C    &STDQ(LM,IATOM,L1M1,INUC,IKAP)*APHK(L1M1,INUC,IKAP,ISPIN,IBAND)
      ENDDO                                          !!! over m1
      ENDDO                                          !!! over l1
      ENDDO                                          !!! over m
      ENDDO                                          !!! over l
      ENDDO                                          !!! over atoms
C ***** FIND STR.DOT.CONSTANTS-EIGENVECTORS CONVOLUTIONS *****
	DO L=0,ILSB(IS(INUC))+1                        !!! over l
	DO M=-L,L                                      !!! over m
	LM=L*(L+1)+M+1
	DPJQ(LM)=(0.D0,0.D0)
C     DPJK(LM)=(0.D0,0.D0)
	DO IATOM=1,NATOM                               !!! over atoms
	ISORT=IS(IATOM)
	DO L1=0,ILSB(ISORT)                            !!! over l1
	LOG(1)=.FALSE.
	IF(LTPAN(L1,IATOM,IKAP,IPAN))LOG(1)=.TRUE.
	DO M1=-L1,L1                                   !!! over m1
	L1M1=L1*(L1+1)+M1+1
	IF(LOG(1))DPJQ(LM)=DPJQ(LM)+
     &STDQ(LM,INUC,L1M1,IATOM,IKAP)*APHQ(L1M1,IATOM,IKAP,ISPIN,IBAND)
C     IF(LOG(1))DPJK(LM)=DPJK(LM)+
C    &STDK(LM,INUC,L1M1,IATOM,IKAP)*APHK(L1M1,IATOM,IKAP,ISPIN,IBAND)
      ENDDO                                          !!! over m1
      ENDDO                                          !!! over l1
      ENDDO                                          !!! over atoms
      ENDDO                                          !!! over m
      ENDDO                                          !!! over l
C ***** FIND DERIVATIVE OF THE STR.CON-EIGENVEC. CONVOLUTIONS *****
	DO IATOM=1,NATOM                               !!! over atoms
	ISORT=IS(IATOM)
	DO MY=-1,1                                     !!! over polarizations
	DO L=0,ILST(ISORT)                             !!! over l
	DO M=-L,L                                      !!! over m
	LM=L*(L+1)+M+1
	LM1M=L*(L-1)+M-MY+1
	LP1M=(L+1)*(L+2)+M-MY+1
	LOG(1)=.FALSE.
	IF(L.LE.ILSB(ISORT))LOG(1)=.TRUE.
	DSKL2(LM,IATOM,IKAP,MY,INUC,ISPIN,IBAND)=(0.D0,0.D0) !!! dS(kj)    /dT
	DSQL2(LM,IATOM,IKAP,MY,INUC,ISPIN,IBAND)=(0.D0,0.D0) !!! dS(k+q,j')/dT
	IF(LOG(1))
     &DDQL2(LM,IATOM,IKAP,MY,INUC,ISPIN,IBAND)=(0.D0,0.D0) !!! dD(k+q,j')/dT
C     IF(LOG(1))
C    &DDKL2(LM,IATOM,IKAP,MY,INUC,ISPIN,IBAND)=(0.D0,0.D0) !!! dD(kj)    /dT
	CGNT1=(0.D0,0.D0)
	IF(L.NE.0.AND.ABS(M-MY).LE.L-1)THEN
	CGNT1=(0.D0,1.D0)*SQPI43*C((L-1)/2,LM,3+MY)*
     &EKAP(IKAP,IPAN)*SMT(ISORT)/(2.D0*L-1)
	CGNT3=(0.D0,1.D0)*SQPI43*C((L-1)/2,LM,3+MY)*
     &SMT(ISORT)/(2.D0*L-1)
	DGNT1=CGNT1*PAR**3
	DGNT3=CGNT3*PAR
	IF(IATOM.EQ.INUC)THEN
	DSKL2(LM,IATOM,IKAP,MY,INUC,ISPIN,IBAND)=
     &DSKL2(LM,IATOM,IKAP,MY,INUC,ISPIN,IBAND)+
     &CGNT1*APJK(LM1M,IATOM,IKAP,ISPIN,IBAND)
	DSQL2(LM,IATOM,IKAP,MY,INUC,ISPIN,IBAND)=
     &DSQL2(LM,IATOM,IKAP,MY,INUC,ISPIN,IBAND)+
     &CGNT1*APJQ(LM1M,IATOM,IKAP,ISPIN,IBAND)
	IF(LOG(1))
     &DDQL2(LM,IATOM,IKAP,MY,INUC,ISPIN,IBAND)=
     &DDQL2(LM,IATOM,IKAP,MY,INUC,ISPIN,IBAND)+DGNT1*DPJQ(LM1M)+
     &DGNT3*APJQ(LM1M,IATOM,IKAP,ISPIN,IBAND)
C     IF(LOG(1))
C    &DDKL2(LM,IATOM,IKAP,MY,INUC,ISPIN,IBAND)=
C    &DDKL2(LM,IATOM,IKAP,MY,INUC,ISPIN,IBAND)+DGNT1*DPJK(LM1M)+
C    &DGNT3*APJK(LM1M,IATOM,IKAP,ISPIN,IBAND)
	ENDIF
	DSKL2(LM,IATOM,IKAP,MY,INUC,ISPIN,IBAND)=
     &DSKL2(LM,IATOM,IKAP,MY,INUC,ISPIN,IBAND)-CGNT1*SSQK(LM1M,IATOM)
	DSQL2(LM,IATOM,IKAP,MY,INUC,ISPIN,IBAND)=
     &DSQL2(LM,IATOM,IKAP,MY,INUC,ISPIN,IBAND)-CGNT1*SSKQ(LM1M,IATOM)
	IF(LOG(1))
     &DDQL2(LM,IATOM,IKAP,MY,INUC,ISPIN,IBAND)=
     &DDQL2(LM,IATOM,IKAP,MY,INUC,ISPIN,IBAND)-DGNT1*SDKQ(LM1M,IATOM)-
     &DGNT3*SSKQ(LM1M,IATOM)
C     IF(LOG(1))
C    &DDKL2(LM,IATOM,IKAP,MY,INUC,ISPIN,IBAND)=
C    &DDKL2(LM,IATOM,IKAP,MY,INUC,ISPIN,IBAND)-DGNT1*SDQK(LM1M,IATOM)-
C    &DGNT3*SSKQ(LM1M,IATOM)
	ENDIF
	CGNT2=(0.D0,1.D0)*SQPI43*C((L+1)/2,LM,3+MY)/
     &SMT(ISORT)*(2.D0*L+1)
	DGNT2=CGNT2*PAR**3
	IF(IATOM.EQ.INUC)THEN
	DSKL2(LM,IATOM,IKAP,MY,INUC,ISPIN,IBAND)=
     &DSKL2(LM,IATOM,IKAP,MY,INUC,ISPIN,IBAND)+
     &CGNT2*APJK(LP1M,IATOM,IKAP,ISPIN,IBAND)
	DSQL2(LM,IATOM,IKAP,MY,INUC,ISPIN,IBAND)=
     &DSQL2(LM,IATOM,IKAP,MY,INUC,ISPIN,IBAND)+
     &CGNT2*APJQ(LP1M,IATOM,IKAP,ISPIN,IBAND)
	IF(LOG(1))
     &DDQL2(LM,IATOM,IKAP,MY,INUC,ISPIN,IBAND)=
     &DDQL2(LM,IATOM,IKAP,MY,INUC,ISPIN,IBAND)+DGNT2*DPJQ(LP1M)
C     IF(LOG(1))
C    &DDKL2(LM,IATOM,IKAP,MY,INUC)=
C    &DDKL2(LM,IATOM,IKAP,MY,INUC,ISPIN,IBAND)+DGNT2*DPJK(LP1M)
	ENDIF
	DSKL2(LM,IATOM,IKAP,MY,INUC,ISPIN,IBAND)=
     &DSKL2(LM,IATOM,IKAP,MY,INUC,ISPIN,IBAND)-CGNT2*SSQK(LP1M,IATOM)
	DSQL2(LM,IATOM,IKAP,MY,INUC,ISPIN,IBAND)=
     &DSQL2(LM,IATOM,IKAP,MY,INUC,ISPIN,IBAND)-CGNT2*SSKQ(LP1M,IATOM)
	IF(LOG(1))
     &DDQL2(LM,IATOM,IKAP,MY,INUC,ISPIN,IBAND)=
     &DDQL2(LM,IATOM,IKAP,MY,INUC,ISPIN,IBAND)-DGNT2*SDKQ(LP1M,IATOM)
C     IF(LOG(1))
C    &DDKL2(LM,IATOM,IKAP,MY,INUC,ISPIN,IBAND)=
C    &DDKL2(LM,IATOM,IKAP,MY,INUC,ISPIN,IBAND)-DGNT2*SDQK(LP1M,IATOM)
      ENDDO                                       !!! over m
      ENDDO                                       !!! over l
      ENDDO                                       !!! over polarizations
      ENDDO                                       !!! over atoms
 1000 CONTINUE                                    !!! over energies
 2000 CONTINUE                                    !!! over displacements
 3000 CONTINUE                                    !!! over spinors
 4000 CONTINUE                                    !!! over bands
 5000 CONTINUE                                    !!! over spin subbands
C Memory deallocations
	DEALLOCATE(SSKQ,SSQK,SDKQ,SDQK,DPJK,DPJQ)
	END
