	SUBROUTINE DEL_SYMDPSR(IQPNT)
********************************************************
*  Symmetrizes change in pseudocharge density.         *
********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
      USE COM_PHNCOM,  ONLY : ITERMAX,NITER                              !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_LATTICE, ONLY : RBAS,GBAS                                  !!! from readstr
      USE COM_SYMNUC,  ONLY : NUMQ,KEYQ,USUM                             !!! from symnuc
	USE COM_QMESH,   ONLY : NQPNT,QPNT                                 !!! from readpnt
      USE COM_PLWMESH, ONLY : NPLW,GPLW,KVEC,KGMIN,KGMAX,INDG            !!! from makeplw
	USE COM_GROUPS,  ONLY : NGROUP,U,SJ,IP,RDC,SHIFT,INV,IKOV          !!! from makegrp
	USE COM_SUBGROUP,ONLY : NSGQ,NGEQ,ISG                              !!! from delmesh
	USE COM_DENDAT,  ONLY : DNORM                                      !!! from renrov
	USE COM_DELRHO,  ONLY : DRHOPS,TRHOPS                              !!! from delrho
	USE COM_SPHERE,  ONLY : SWZ,SMT                                    !!! from readini
	USE COM_MASHDEP, ONLY : NVAL                                       !!! from setup
	USE COM_PHNCHN  ,ONLY : IUDRO,IUDPX,IUDRX,IUDPY,IUDRY,IUDPS        !!! from channels
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: SRHOPS(:,:,:)
	COMPLEX*16 PHSQ,EXPGR,EXPQR
	DIMENSION QPNT0(3)
      DATA PI/3.141592653589793D0/
      IF(MODE.EQ.5)RETURN
C Memory allocations
	ALLOCATE(SRHOPS(0:NPLWMEM,NSPINMEM,NORBSMEM))
      DO 10000 ISORTN=1,NSORT                       !!! over sorts
C  DO OVER DISPLACEMENTS AND POLARIZATIONS
      DO 5000 INUC=1,NATOM                          !!! over displacements
      IF(IS(INUC).NE.ISORTN)GOTO5000
      DO 4000 MY=-1,1                               !!! over polarizations
      IF(NITER(MY,INUC).EQ.0)GOTO4000
C  SET SYMMETRIZED CHARGE DENSITY TO ZERO.
      CALL DRO_DPSFILES(MY,INUC,IQPNT,IUDPS,'I',' ',' ')
	DO IORBS=1,NORBS
	DO IUPDN=1,NSPIN
	DO IPLW=0,NPLW
	SRHOPS(IPLW,IUPDN,IORBS)=(0.D0,0.D0)
	ENDDO
	ENDDO
	ENDDO
      DO 3000 INUC1=1,NATOM                         !!! over displacements
      DO 2000 MY1=-1,1                              !!! over polarizations
      IF(NITER(MY1,INUC1).EQ.0)GOTO2000
      IF(USUM(MY,INUC,MY1,INUC1).LE.1.D-06)GOTO2000
      CALL DRO_DPSFILES(MY1,INUC1,IQPNT,IUDPY,'R','D',' ')
C  DO OVER GROUP OF WAVE VECTOR Q
      DO 1000 IGEQ=1,NGEQ                           !!! over group of q-vector
      IR=ISG(IGEQ,1)                                !!! element "g" in the main G-list
      IG=IKOV(IR)                                   !!! element "g" after Kovalev
      INUCG=IP(INUC,IR)
      IF(INUCG.NE.INUC1)GOTO1000
      IWIGMY=3+3*(1+MY1)+MY                         !!! U(1,my,my1)
      IF(ABS(U(IWIGMY,IG)).LE.1.D-10)GOTO1000
      SQ=QPNT(1,IQPNT)*RDC(1,INUC,IR)+
     &   QPNT(2,IQPNT)*RDC(2,INUC,IR)+
     &   QPNT(3,IQPNT)*RDC(3,INUC,IR)
      PHSQ=EXP(2.D0*PI*SQ*(0.D0,-1.D0))
      SCP=QPNT(1,IQPNT)*SHIFT(1,IR)+
     &    QPNT(2,IQPNT)*SHIFT(2,IR)+
     &    QPNT(3,IQPNT)*SHIFT(3,IR)
      EXPQR=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	DO IORBS=1,NORBS                              !!! over iorbs
	DO IUPDN=1,NSPIN                              !!! over spins
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	SIGNI=1.D0
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	IF(ISPIN1.EQ.1.AND.ISPIN.EQ.2)SIGNI=+SQRT(2.D0) ! M^{-}=<S^{-}>=-<S_{+}>
	IF(ISPIN1.EQ.2.AND.ISPIN.EQ.1)SIGNI=-SQRT(2.D0) ! M^{+}=<S^{+}>=-<S_{-}>
	ENDIF
	DO JORBS=1,NORBS                              !!! over iorbs
	DO JUPDN=1,NSPIN                              !!! over spins
	IF(NORBS.EQ.1.AND.IUPDN.NE.JUPDN)CYCLE
	IF(JORBS.EQ.1)THEN
	JSPIN1=JUPDN
	JSPIN =JUPDN
	SIGNJ=1.D0
	ELSEIF(JORBS.EQ.2)THEN
	JSPIN1=JUPDN
	JSPIN =NSPIN+1-JUPDN
	IF(JSPIN1.EQ.1.AND.JSPIN.EQ.2)SIGNJ=+SQRT(2.D0) ! M^{-}=<S^{-}>=-<S_{+}>
	IF(JSPIN1.EQ.2.AND.JSPIN.EQ.1)SIGNJ=-SQRT(2.D0) ! M^{+}=<S^{+}>=-<S_{-}>
	ENDIF
      DO IPLW=0,NPLW                                !!! over plane waves
C  RECIPROCAL LATTICE VECTOR IS GIVEN BY
      GX=GPLW(1,IPLW)
      GY=GPLW(2,IPLW)
      GZ=GPLW(3,IPLW)
C  APPLY SYMMETRY OPERATION
      CALL LIB_ROTATE(GX,GY,GZ,GRX,GRY,GRZ,U(2,IG),1)
C  GET COORDINATES IN G1,G2,G3
      X1R=GRX*RBAS(1,1)+GRY*RBAS(2,1)+GRZ*RBAS(3,1)
      X2R=GRX*RBAS(1,2)+GRY*RBAS(2,2)+GRZ*RBAS(3,2)
      X3R=GRX*RBAS(1,3)+GRY*RBAS(2,3)+GRZ*RBAS(3,3)
      M1R=ANINT(X1R)
      M2R=ANINT(X2R)
      M3R=ANINT(X3R)
      IF(ABS(DBLE(M1R)-X1R).GE.1.D-10.OR.
     &   ABS(DBLE(M2R)-X2R).GE.1.D-10.OR.
     &   ABS(DBLE(M3R)-X3R).GE.1.D-10)
     &CALL FULLSTOP('<SYMDPS>: WRONG VECTOR')
      IDIM=1+M1R-KGMIN(1)+(KGMAX(1)-KGMIN(1)+1)*(M2R-KGMIN(2))+
     &  (KGMAX(1)-KGMIN(1)+1)*(KGMAX(2)-KGMIN(2)+1)*(M3R-KGMIN(3))
      IPLWR=INDG(IDIM)
      IF(IPLWR.EQ.-1)
     &CALL FULLSTOP('<SYMDPS>:: ERROR IN IPLWR')
      SCP=GX*SHIFT(1,IR)+GY*SHIFT(2,IR)+GZ*SHIFT(3,IR)
      EXPGR=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
C  SYMMETRIZE CHARGE DENSITY
      SRHOPS(IPLW,IUPDN,IORBS)=SRHOPS(IPLW,IUPDN,IORBS)+
     &DRHOPS(IPLWR,JUPDN,JORBS)*CONJG(U(IWIGMY,IG))*PHSQ*EXPGR*EXPQR*
     &SIGNI/SIGNJ*DCONJG(SJ(ISPIN1,JSPIN1,IR))*SJ(ISPIN,JSPIN,IR)
      ENDDO                                         !!! over plane waves
	ENDDO                                         !!! over jupdn
	ENDDO                                         !!! over jorbs
	ENDDO                                         !!! over iupdn
	ENDDO                                         !!! over iorbs
1000	CONTINUE                                      !!! over group of q-vector
2000  CONTINUE                                      !!! over polarizations
3000  CONTINUE                                      !!! over displacements
C  SYMMETRIZATION FINISHED, NORMALIZATION
      CALL DRO_DPSFILES(MY,INUC,IQPNT,IUDRY,'R','T',' ')
	DO IORBS=1,NORBS
	DO IUPDN=1,NSPIN
	DO IPLW=0,NPLW
	DRHOPS(IPLW,IUPDN,IORBS)=
     &SRHOPS(IPLW,IUPDN,IORBS)*DNORM/DBLE(NGEQ)+
     &TRHOPS(IPLW,IUPDN,IORBS)
	IF(MODE.EQ.4)
     &DRHOPS(IPLW,IUPDN,IORBS)=DRHOPS(IPLW,IUPDN,IORBS)-
     &TRHOPS(IPLW,IUPDN,IORBS)
	ENDDO
	ENDDO
	ENDDO
C  SAVE FINAL CHANGE IN CHARGE DENSITY
      CALL DRO_DPSFILES(MY,INUC,IQPNT,IUDPS,'W','D',' ')
4000  CONTINUE                                      !!! over polarizations
5000  CONTINUE                                      !!! over displacements
      DO INUC=1,NATOM
      IF(IS(INUC).EQ.ISORTN)THEN
      DO MY=-1,1
      IF(NITER(MY,INUC).NE.0)THEN
C  COPY CHANGE IN CHARGE DENSITY TO CHANNEL 33
      CALL DRO_DPSFILES(MY,INUC,IQPNT,IUDPS,'R','D',' ')
      CALL DRO_DPSFILES(MY,INUC,IQPNT,IUDPY,'W','D',' ')
      CALL DRO_DPSFILES(MY,INUC,IQPNT,IUDPS,'D',' ',' ')
      ENDIF
      ENDDO
      ENDIF
      ENDDO
10000 CONTINUE                                      !!! over sorts
      DEALLOCATE(SRHOPS)
	END
