	SUBROUTINE DEL_SYMDRHO(IQPNT)
********************************************************
*  Symmetrizes change in charge density.               *
********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
      USE COM_PHNCOM,  ONLY : ITERMAX,NITER                              !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_RADMESH, ONLY : NRAD,H,R                                   !!! from makerad
	USE COM_SUBGROUP,ONLY : NSGQ,NGEQ,ISG                              !!! from delmesh
	USE COM_QMESH,   ONLY : NQPNT,QPNT                                 !!! from readpnt
      USE COM_DELRHO,  ONLY : DRHO,TRHO                                  !!! from delrho
      USE COM_SYMNUC,  ONLY : NUMQ,KEYQ,USUM                             !!! from symnuc
	USE COM_DENDAT,  ONLY : DNORM                                      !!! from renrov
      USE COM_DELHUB,  ONLY : DELDHUB,DELVHUB,DELTHUB,DELGHUB            !!! from plzfiles
	USE COM_SPHERE,  ONLY : SWZ,SMT                                    !!! from readini
	USE COM_GROUPS,  ONLY : NGROUP,U,SJ,IP,RDC,INV,IKOV                !!! from makegrp
	USE COM_PHNCHN  ,ONLY : IUDRO,IUDPS,IUDPX,IUDRX,IUDPY,IUDRY        !!! from channels
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: SRHO(:,:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: DELSHUB(:,:,:,:)
	COMPLEX*16 PHSQ
	DIMENSION QPNT0(3)
      DATA PI/3.141592653589793D0/
      IF(MODE.EQ.5)RETURN
C Memory allocations
	ALLOCATE(SRHO(0:NRADMEM,LIMVMEM,NATOMMEM,NSPINMEM,NORBSMEM))
	ALLOCATE(DELSHUB(LIMB2MEM,NATOMMEM,NSPINMEM,NORBSMEM))
	DO 10000 ISORTN=1,NSORT                       !!! over sorts
C  DO OVER DISPLACEMENTS AND POLARIZATIONS
	DO 5000 INUC=1,NATOM                          !!! over displacements
	IF(IS(INUC).NE.ISORTN)GOTO5000
	DO 4000 MY=-1,1                               !!! over polarizations
	IF(NITER(MY,INUC).EQ.0)GOTO4000
C  SET SYMMETRIZED CHARGE DENSITY TO ZERO. 
	CALL DRO_DROFILES(MY,INUC,IQPNT,IUDPS,'I',' ',' ')
      DO IATOM=1,NATOM
      ISORT=IS(IATOM)
      DO IORBS=1,NORBS
      DO IUPDN=1,NSPIN
      DO L=0,ILSV(ISORT)
      DO M=-L,L
      LM=L*(L+1)+M+1
      DO IRAD=0,NRAD(ISORT)
      SRHO(IRAD,LM,IATOM,IUPDN,IORBS)=(0.D0,0.D0)
      ENDDO
      ENDDO
      ENDDO
	DO L=0,ILSB(ISORT)                         !!! over l
      DO M1=-L,L                                 !!! over m1
      LM1=L*(L+1)+M1+1
      DO M=-L,L                                  !!! over m
      LM=L*(L+1)+M+1
      IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M1+1 ! ! (l,m'm)
      DELSHUB(IU,IATOM,IUPDN,IORBS)=(0.D0,0.D0)
	ENDDO                                      !!! over m1
      ENDDO                                      !!! over m
      ENDDO                                      !!! over l
      ENDDO
      ENDDO
      ENDDO
	DO 3000 INUC1=1,NATOM                         !!! over displacements
	DO 2000 MY1=-1,1                              !!! over polarizations
	IF(NITER(MY1,INUC1).EQ.0)GOTO2000
	IF(USUM(MY,INUC,MY1,INUC1).LE.1.D-06)GOTO2000
	CALL DRO_DROFILES(MY1,INUC1,IQPNT,IUDPX,'R','D',' ')
C  DO OVER GROUP OF WAVE VECTOR Q
      DO 1000 IGEQ=1,NGEQ                           !!! over group of q-vector
      IR=ISG(IGEQ,1)                                !!! element "g" in the main G-list
      IG=IKOV(IR)                                   !!! element "g" after Kovalev
      INUCG=IP(INUC,IR)
	IF(INUCG.NE.INUC1)GOTO1000
      IWIGMY=3+3*(1+MY1)+MY                         !!! U(1,my,my1)
      IF(ABS(U(IWIGMY,IG)).LE.1.D-10)GOTO1000
C  DO OVER SPINS AND ATOMS
      DO IORBS=1,NORBS                              !!! over iorbs
	DO IUPDN=1,NSPIN                              !!! over spins  
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	SIGNI=1.D0
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	IF(ISPIN1.EQ.1.AND.ISPIN.EQ.2)SIGNI=+SQRT(2.D0) ! M^{-}=<S^{-}>=-<S_{+}>
	IF(ISPIN1.EQ.2.AND.ISPIN.EQ.1)SIGNI=-SQRT(2.D0) ! M^{+}=<S^{+}>=-<S_{-}>
	ENDIF
	DO IATOM=1,NATOM                              !!! over atoms
      ISORT=IS(IATOM)
      IATOMG=IP(IATOM,IR)
      SQ=QPNT(1,IQPNT)*(RDC(1,IATOM,IR)-RDC(1,INUC,IR))+
     &   QPNT(2,IQPNT)*(RDC(2,IATOM,IR)-RDC(2,INUC,IR))+
     &   QPNT(3,IQPNT)*(RDC(3,IATOM,IR)-RDC(3,INUC,IR))
      PHSQ=EXP(2.D0*PI*SQ*(0.D0,1.D0))
	DO JORBS=1,NORBS                              !!! over jorbs
	DO JUPDN=1,NSPIN                              !!! over jupdn
	IF(JORBS.EQ.1)THEN
	JSPIN1=JUPDN
	JSPIN =JUPDN
	SIGNJ=1.D0
	ELSEIF(JORBS.EQ.2)THEN
	JSPIN1=JUPDN
	JSPIN =NSPIN+1-JUPDN
	IF(JSPIN1.EQ.1.AND.JSPIN.EQ.2)SIGNJ=+SQRT(2.D0) ! M^{-}=<S^{-}>=-<S_{+}>
	IF(JSPIN1.EQ.2.AND.JSPIN.EQ.1)SIGNJ=-SQRT(2.D0) ! M^{+}=<S^{+}>=-<S_{-}>
	ENDIF
	IF(NORBS.EQ.1.AND.JUPDN.NE.IUPDN)CYCLE
      DO L=0,ILSV(ISORT)                            !!! over l
      LL=L*(2*L-1)*(2*L+1)/3
      DO M=-L,L                                     !!! over m
      LM=L*(L+1)+M+1
C  SYMMETRIZATION
	DO M1=-L,L                                    !!! over m1
	LM1=L*(L+1)+M1+1
	IWIG01=LL+(2*L+1)*(L+M1)+L+M+1                !!! U(l,m,m1)
	DO IRAD=0,NRAD(ISORT)
	SRHO(IRAD,LM,IATOM,IUPDN,IORBS)=
     &SRHO(IRAD,LM,IATOM,IUPDN,IORBS)+U(IWIG01,IG)*
     &DRHO(IRAD,LM1,IATOMG,JUPDN,JORBS)*CONJG(U(IWIGMY,IG))*PHSQ*
     &SIGNI/SIGNJ*DCONJG(SJ(ISPIN1,JSPIN1,IR))*SJ(ISPIN,JSPIN,IR)
	ENDDO
      ENDDO                                         !!! over m1
      ENDDO                                         !!! over m
      ENDDO                                         !!! over l
	DO L=0,ILSB(ISORT)                            !!! over l
      LL=L*(2*L-1)*(2*L+1)/3
      DO M1=-L,L                                    !!! over m1
      LM1=L*(L+1)+M1+1
      DO M=-L,L                                     !!! over m
      LM=L*(L+1)+M+1
      IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M1+1 ! ! (l,m'm)
      DO K1=-L,L                                    !!! over m1
      LK1=L*(L+1)+K1+1
      DO K=-L,L                                     !!! over m
      LK=L*(L+1)+K+1
      IW=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+K)+L+K1+1   ! ! (l,k'k)
	M1K1=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+K1)+L+M1+1  ! U(l,m1,k1)
	MK=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+K)+L+M+1    !!! U(l,m,k)
      DELSHUB(IU,IATOM,IUPDN,IORBS)=
     &DELSHUB(IU,IATOM,IUPDN,IORBS)+
     &CONJG(U(M1K1,IG))*DELDHUB(IW,IATOMG,JUPDN,JORBS)*U(MK,IG)*
     &CONJG(U(IWIGMY,IG))*PHSQ*SIGNI/SIGNJ*
     &DCONJG(SJ(ISPIN1,JSPIN1,IR))*SJ(ISPIN,JSPIN,IR)
	ENDDO                                         !!! over k1
      ENDDO                                         !!! over k
	ENDDO                                         !!! over m1
      ENDDO                                         !!! over m
      ENDDO                                         !!! over l
      ENDDO                                         !!! over jupdn
      ENDDO                                         !!! over jorbs
      ENDDO                                         !!! over atoms
      ENDDO                                         !!! over iupdn
      ENDDO                                         !!! over iorbs
1000	CONTINUE                                      !!! over group of q-vector
2000	CONTINUE                                      !!! over polarizations
3000	CONTINUE                                      !!! over displacements
C  SYMMETRIZATION FINISHED, NORMALIZATION
	CALL DRO_DROFILES(MY,INUC,IQPNT,IUDRX,'R','T',' ')
      DO IATOM=1,NATOM                              !!! over atoms
      ISORT=IS(IATOM)
      DO IORBS=1,NORBS                              !!! over iorbs
      DO IUPDN=1,NSPIN                              !!! over ispin
      DO L=0,ILSV(ISORT)                            !!! over l
      DO M=-L,L                                     !!! over m
      LM=L*(L+1)+M+1
      DO IRAD=0,NRAD(ISORT)
	DRHO(IRAD,LM,IATOM,IUPDN,IORBS)=
     &SRHO(IRAD,LM,IATOM,IUPDN,IORBS)*DNORM/DBLE(NGEQ)+
     &TRHO(IRAD,LM,IATOM,IUPDN,IORBS)
	IF(MODE.EQ.4)
     &DRHO(IRAD,LM,IATOM,IUPDN,IORBS)=
     &DRHO(IRAD,LM,IATOM,IUPDN,IORBS)-
     &TRHO(IRAD,LM,IATOM,IUPDN,IORBS)
      ENDDO
      ENDDO                                         !!! over m
      ENDDO                                         !!! over l
	DO L=0,ILSB(ISORT)                            !!! over l
      DO M1=-L,L                                    !!! over m1
      LM1=L*(L+1)+M1+1
      DO M=-L,L                                     !!! over m
      LM=L*(L+1)+M+1
      IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M1+1 ! ! (l,m'm)
      DELDHUB(IU,IATOM,IUPDN,IORBS)=
     &DELSHUB(IU,IATOM,IUPDN,IORBS)*DNORM/DBLE(NGEQ)+
     &DELTHUB(IU,IATOM,IUPDN,IORBS)
	IF(MODE.EQ.4)
     &DELDHUB(IU,IATOM,IUPDN,IORBS)=
     &DELDHUB(IU,IATOM,IUPDN,IORBS)-
     &DELTHUB(IU,IATOM,IUPDN,IORBS)
	ENDDO                                         !!! over m1
      ENDDO                                         !!! over m
      ENDDO                                         !!! over l
      ENDDO                                         !!! over spins
      ENDDO                                         !!! over iorbs
      ENDDO                                         !!! over atoms
C  SAVE FINAL CHANGE IN CHARGE DENSITY
	CALL DRO_DROFILES(MY,INUC,IQPNT,IUDPS,'W','D',' ')
4000	CONTINUE                                      !!! over polarizations
5000	CONTINUE                                      !!! over displacements
	DO INUC=1,NATOM
	IF(IS(INUC).EQ.ISORTN)THEN
	DO MY=-1,1
	IF(NITER(MY,INUC).NE.0)THEN
C  COPY CHANGE IN CHARGE DENSITY TO CHANNEL 33
	CALL DRO_DROFILES(MY,INUC,IQPNT,IUDPS,'R','D',' ')
	CALL DRO_DROFILES(MY,INUC,IQPNT,IUDPX,'W','D',' ')
	CALL DRO_DROFILES(MY,INUC,IQPNT,IUDPS,'D',' ',' ')
	ENDIF
	ENDDO
	ENDIF
	ENDDO
10000 CONTINUE                                      !!! over sorts
	DEALLOCATE(DELSHUB,SRHO)
	END
