	SUBROUTINE DMF_ALLOCATE(AOPER)
************************************************************
*   Prepare for the calculation of Green's function        *
************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                  !!! from setup
      USE COM_CONTROL ,ONLY: LIFT,LMTO,IDMF,IASA                      !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS,ILSB,ILST     !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP                                !!! from readini
      USE COM_KMESH   ,ONLY: NPNT,PNT                                 !!! from tetra
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN                              !!! from readini
      USE COM_HUBDAT  ,ONLY: MCRL,LCRL                                !!! from readhub
      USE COM_STRCON  ,ONLY: SSCON,SDCON                              !!! from strgnt
      USE COM_LMTMAT  ,ONLY: HMAT,OMAT                                !!! from lmtmat
      USE COM_ORDDAT  ,ONLY: IORD                                     !!! from readhub
      USE COM_GRFDAT  ,ONLY: EPOL,EPOW,ECAP,GWGT,GWGD,GW0T
     &                      ,GW0D,GWTS,EBND                           !!! from grfbnd
	USE COM_LMTVEC  ,ONLY: APHR,APSR,APJR,APHL,APSL,APJL            !!! from lmtvec
	USE COM_RINPAR  ,ONLY: RINT0,RFUN                               !!! from tosint
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC,NBNDH            !!! from readini
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT,IUI                          !!! from setup
      USE COM_MASHDEP ,ONLY: NVAL,LENINT,LENCMP                       !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	LOGICAL FIRST,EXIST,OPEN
	CHARACTER*1 AOPER
	DATA FIRST/.TRUE./
C MEMORY ALLOCATIONS
	IF(FIRST)THEN
	ALLOCATE(IORD((NBNDT(1)+NBNDH(1))*NSPINMEM,NPNTMEM,0:NMSCMEM+1))
	ALLOCATE(EPOL((NBNDT(1)+NBNDH(1))*NSPINMEM,NPNTMEM,0:NMSCMEM+1))
	ALLOCATE(EPOW((NBNDT(1)+NBNDH(1))*NSPINMEM,NPNWMEM,0:NMSCMEM+1))
	ALLOCATE(EBND((NBNDT(1)+NBNDH(1))*NSPINMEM,NPNTMEM,0:NMSCMEM+1))
      ALLOCATE(GWGT((NBNDT(1)+NBNDH(1))*NSPINMEM,NPNTMEM,0:NMSCMEM+1))
      ALLOCATE(GWGD((NBNDT(1)+NBNDH(1))*NSPINMEM,NPNTMEM,0:NMSCMEM+1))
	ALLOCATE(ECAP((NBNDT(1)+NBNDH(1))*NSPINMEM,NPNTMEM))
      ALLOCATE(GW0T((NBNDT(1)+NBNDH(1))*NSPINMEM,NPNTMEM))
      ALLOCATE(GW0D((NBNDT(1)+NBNDH(1))*NSPINMEM,NPNTMEM))
	ALLOCATE(GWTS((NBNDT(1)+NBNDH(1))*NSPINMEM,NPNTMEM,
     &                               0:LMAXBMEM,NATOMMEM))
      SIZE_IORD=DBLE(SIZE(IORD)*LENINT)/1024.D0**2
      SIZE_EPOL=DBLE(SIZE(EPOL)*LENCMP)/1024.D0**2
      SIZE_EPOW=DBLE(SIZE(EPOW)*LENCMP)/1024.D0**2
      SIZE_GWGT=DBLE(SIZE(GWGT)*LENCMP)/1024.D0**2
      SIZE_GW0T=DBLE(SIZE(GW0T)*LENCMP)/1024.D0**2
      SIZE_EBND=DBLE(SIZE(EBND)*LENCMP)/1024.D0**2
      CURMEM=CURMEM+SIZE_EPOL+SIZE_EPOW+2.D0*SIZE_GWGT+2.D0*SIZE_GW0T+
     &SIZE_EBND+SIZE_IORD
	FIRST=.FALSE.
	ENDIF
C MEMORY ALLOCATIONS
	IF(AOPER.EQ.'A')THEN
	IF(IASA.EQ.1.OR.IASA.EQ.2)THEN
	ALLOCATE(APHR(LIMBMEM,NATOMMEM,NKAPMEM,NSPINMEM,
     &              (NBNDT(1)+NBNDH(1))*NSPINMEM))
	ALLOCATE(APSR(LIMBMEM,NATOMMEM,NKAPMEM,NSPINMEM,
     &              (NBNDT(1)+NBNDH(1))*NSPINMEM))
	ALLOCATE(APJR(LIMT1MEM,NATOMMEM,NKAPMEM,NSPINMEM,
     &              (NBNDT(1)+NBNDH(1))*NSPINMEM))
	ALLOCATE(APHL(LIMBMEM,NATOMMEM,NKAPMEM,NSPINMEM,
     &              (NBNDT(1)+NBNDH(1))*NSPINMEM))
	ALLOCATE(APSL(LIMBMEM,NATOMMEM,NKAPMEM,NSPINMEM,
     &              (NBNDT(1)+NBNDH(1))*NSPINMEM))
	ALLOCATE(APJL(LIMT1MEM,NATOMMEM,NKAPMEM,NSPINMEM,
     &              (NBNDT(1)+NBNDH(1))*NSPINMEM))
	ALLOCATE(SSCON(LIMT1MEM,NATOMMEM,LIMBMEM,NATOMMEM,NKAPMEM))
	ALLOCATE(SDCON(LIMB1MEM,NATOMMEM,LIMBMEM,NATOMMEM,NKAPMEM))
	ALLOCATE(RINT0(NBNDT(1),NBNDT(1)))
	ALLOCATE(RFUN(NBNDT(1),0:MBASMEM))
	ENDIF
      ALLOCATE(HMAT((NBNDT(1)+NBNDH(1))*NSPINMEM,
     &              (NBNDT(1)+NBNDH(1))*NSPINMEM))
      ALLOCATE(OMAT((NBNDT(1)+NBNDH(1))*NSPINMEM,
     &              (NBNDT(1)+NBNDH(1))*NSPINMEM))
C MEMORY DEALLOCATIONS
	ELSEIF(AOPER.EQ.'D')THEN
	IF(IASA.EQ.1.OR.IASA.EQ.2)THEN
	DEALLOCATE(APHR,APSR,APJR,APHL,APSL,APJL)
	DEALLOCATE(SSCON,SDCON)
	DEALLOCATE(RINT0,RFUN)
	ENDIF
	DEALLOCATE(HMAT,OMAT)
	ENDIF
	END