	SUBROUTINE DMF_DENMAT(IPNT,IMSC,IDEA)
*********************************************************
*  Computes Density matrix                              *
*********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                 !!! from setup
      USE COM_CONTROL ,ONLY: LIFT,LMTO,IDMF                          !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS,ILSB         !!! from readini
      USE COM_LATTICE ,ONLY: RBAS,GBAS,TAU                           !!! from readstr
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP                          !!! from readini
      USE COM_INDORB  ,ONLY: INDDMF                                  !!! from lmtpar
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC,NBNDH           !!! from readini
      USE COM_ENVSITE ,ONLY: NENV,TENV,ISENV,IPENV,IRENV             !!! from envmesh
      USE COM_LMTMAT  ,ONLY: HMAT,OMAT                               !!! from lmtmat
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN                             !!! from readini
      USE COM_HOPCOM  ,ONLY: DMAT                                    !!! from readhop
      USE COM_MSBMESH ,ONLY: TEMP,NMSC,WMSC,FMSC                     !!! from grfbnd
      USE COM_ENERGY  ,ONLY: WTRT                                    !!! from grfbnd
      USE COM_GRFDAT  ,ONLY: EPOL,EPOW,GWGT,GW0T                     !!! from grfbnd
      USE COM_GROUPS  ,ONLY: NGROUP,U,SJ,IP,RDC,SHIFT,INV,IKOV       !!! from groups
      USE COM_KMESH   ,ONLY: NPNT,PNT,WGT                            !!! from tetra
      USE COM_INPTTR  ,ONLY: NDIV,NDIC,SH                            !!! from readini
      USE COM_FERMI   ,ONLY: EF                                      !!! from ttrints
      USE COM_MASHDEP ,ONLY: LENCMP                                  !!! from setup
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                         !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: AL(:)
	COMPLEX*16, ALLOCATABLE :: AR(:)
	COMPLEX*16, ALLOCATABLE :: CL(:)
	COMPLEX*16, ALLOCATABLE :: CR(:)
	COMPLEX*16 ZMSC,PHS,WHT,PHSK
      DATA PI/3.141592653589793D0/
      CALL ABORTNOW()
C MEMORY ALLOCATIONS
      ALLOCATE(AR((NBNDT(1)+NBNDH(1))*NSPINMEM),STAT=IALLOC)
      ALLOCATE(AL((NBNDT(1)+NBNDH(1))*NSPINMEM),STAT=IALLOC)
      SIZE_MAT=2.D0*DBLE(SIZE(AL)*LENCMP)/1024.D0**2
      CURMEM=CURMEM+SIZE_MAT
      ALLOCATE(CR((NBNDT(1)+NBNDH(1))*NSPINMEM))
      ALLOCATE(CL((NBNDT(1)+NBNDH(1))*NSPINMEM))
	IF(IMSC.NE.NMSC+1)ZMSC=WMSC(IMSC)
	IF(IMSC.EQ.NMSC+1)ZMSC=(0.D0,0.D0)
C FIND GREEN FUNCTION
      DO 2000 IBNDS=1,NSPIN             !!! over spin subbands
      DO 1000 IBNDT=1,NBNDT(1)+NBNDH(1) !!! over bands
	IBAND=IBNDS+NSPIN*(IBNDT-1)
C  SET WEIGHT
	IF(IMSC.NE.NMSC+1.AND.IDMF.EQ.3)
     &WHT=+TEMP*GWGT(IBAND,IPNT,IMSC)*FMSC(IMSC)/DBLE(NGROUP)
	IF(IMSC.EQ.NMSC+1.AND.IDMF.EQ.3) ! 0.5*W/Nspin is a weight, 1/2/Ng is a renorm.
     &WHT=-TEMP*GW0T(IBAND,IPNT)/DBLE(NGROUP)+
     &DCMPLX(0.5D0*WTRT(IBAND,IPNT)/DBLE(NGROUP),0.D0)
	IF(IMSC.EQ.0.AND.IDMF.EQ.4)   !!! simple weight
     &WHT=DCMPLX(0.5D0*WTRT(IBAND,IPNT)/DBLE(NGROUP),0.D0)
	IF(IMSC.NE.NMSC+1.AND.IDMF.EQ.5)
     &WHT=-0.5D0*DIMAG(GWGT(IBAND,IPNT,IMSC))/PI*
     &FMSC(IMSC)*FERMIFUN(DREAL(ZMSC),TEMP)/DBLE(NGROUP)
	IF(IMSC.EQ.NMSC+1.AND.IDMF.EQ.5)
     &WHT=(0.D0,0.D0)
C Do over point group
	DO 100 IR=1,NGROUP            !!! over group
	IG=IKOV(IR)
C Rotate eigenvectors
	DO IORBS=1,NORBS              !!! over iorbs
	IF(NORBS.EQ.1)ISPIN=IBNDS
	IF(NORBS.EQ.2)ISPIN=IORBS
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	SK=PNT(1,IPNT,1)*RDC(1,IATOM,IR)+
     &   PNT(2,IPNT,1)*RDC(2,IATOM,IR)+
     &   PNT(3,IPNT,1)*RDC(3,IATOM,IR)
	PHS=EXP(2.D0*PI*SK*(0.D0,1.D0))
	DO L=0,ILSB(ISORT)            !!! over l
	IF(.NOT.LTPAN(L,IATOM,1,1))CYCLE
	DO M=-L,L                     !!! over m
	LM=L*(L+1)+M+1
	IDIM=INDDMF(LM,IATOM,1,ISPIN)
      CL(IDIM)=(0.D0,0.D0)
      CR(IDIM)=(0.D0,0.D0)
C  ROTATE EIGENVECTORS FROM THE POINT "K" TO THE POINT "G*K"
	DO IORBS1=1,NORBS
	IF(NORBS.EQ.1)ISPIN1=IBNDS
	IF(NORBS.EQ.2)ISPIN1=IORBS1
	DO M1=-L,L                    !!! over m1
	LM1=L*(L+1)+M1+1
	IWIG01=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M1)+L+M+1
	IDIM1=INDDMF(LM1,IP(IATOM,IR),1,ISPIN1)
      CR(IDIM)=CR(IDIM)+
     &U(IWIG01,IG)*PHS*SJ(ISPIN,ISPIN1,IR)*OMAT(IDIM1,IBAND)
      CL(IDIM)=CL(IDIM)+
     &DCONJG(U(IWIG01,IG)*PHS*SJ(ISPIN,ISPIN1,IR))*HMAT(IDIM1,IBAND)
      ENDDO                         !!! over m1
      ENDDO                         !!! over iorbs1
      ENDDO                         !!! over m
      ENDDO                         !!! over l
      ENDDO                         !!! over atoms
      ENDDO                         !!! over iorbs
C  SET UP DENSITY MATRIX
      DO IORBS=1,NORBS              !!! over iorbs
      DO IUPDN=1,NSPIN              !!! over iupdn
	IF(NORBS.EQ.1.AND.IUPDN.NE.IBNDS)CYCLE
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
	DO IATOM1=1,NATOM             !!! over iatom1
      ISORT1=IS(IATOM1)
      DO IENV=0,NENV(IATOM1)        !!! over ienv
      IATOM=ISENV(IENV,IATOM1)
      ISORT=IS(IATOM)
	IF(IRENV(IENV,IATOM1).EQ.1)THEN
      RX=TENV(1,IENV,IATOM1)+(TAU(1,IATOM1)-TAU(1,IATOM))
      RY=TENV(2,IENV,IATOM1)+(TAU(2,IATOM1)-TAU(2,IATOM))
      RZ=TENV(3,IENV,IATOM1)+(TAU(3,IATOM1)-TAU(3,IATOM))
      XK=PNT(1,IPNT,1)+SH(1,1)
      YK=PNT(2,IPNT,1)+SH(2,1)
      ZK=PNT(3,IPNT,1)+SH(3,1)
      SCP=XK*RX+YK*RY+ZK*RZ
      PHSK=EXP((0.D0,+1.D0)*SCP*2.D0*PI)
      DO L1=0,ILSB(ISORT1)          !!! over l1
      DO M1=-L1,L1                  !!! over m1
      IF(.NOT.LTPAN(L1,IATOM1,1,1))EXIT
      L1M1=L1*(L1+1)+M1+1
	IDIM1=INDDMF(L1M1,IATOM1,1,ISPIN1)
      DO L=0,ILSB(ISORT)            !!! over l
      DO M=-L,L                     !!! over m
      IF(.NOT.LTPAN(L,IATOM,1,1))EXIT
      LM=L*(L+1)+M+1
	IDIM=INDDMF(LM,IATOM,1,ISPIN)
C Density matrix D(ab)==G(ba) since rho=dconjg(chi(a))*D(ab)*chi(a)
      DMAT(L1M1,LM,IATOM1,IENV,IUPDN,IORBS)=
     &DMAT(L1M1,LM,IATOM1,IENV,IUPDN,IORBS)+
     &PHSK*  WHT*CL(IDIM1)*CR(IDIM)+
     &DCONJG(WHT*CR(IDIM1)*CL(IDIM))*
     &PHSK
      ENDDO                         !!! over m
      ENDDO                         !!! over l
      ENDDO                         !!! over m1
      ENDDO                         !!! over l1
	ENDIF
      ENDDO                         !!! over ienv
      ENDDO                         !!! over iatom1
	ENDDO                         !!! over iupdn
	ENDDO                         !!! over iorbs
  100	CONTINUE                      !!! over group
 1000	CONTINUE                      !!! over bands
 2000	CONTINUE                      !!! over spin subbands
C MEMORY DEALLOCATIONS
	DEALLOCATE(AR,AL,CR,CL)
      CURMEM=CURMEM-SIZE_MAT
	END
