	SUBROUTINE DMF_ENERGY
*****************************************************************
*  Computes Kinetic and Coulomb energies                        *
*****************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                               !!! from setup
      USE COM_CONTROL ,ONLY: LIFT,LMTO,IASA,IDMF                   !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS,ILSB       !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP                        !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN                           !!! from readini
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC,NBNDH         !!! from readini
      USE COM_HUBCOM  ,ONLY: VHUB,DHUB,VCNS,VDBC                   !!! from readhub
      USE COM_MSBMESH ,ONLY: TEMP,NMSC,WMSC,FMSC                   !!! from msbmesh
      USE COM_DMFDAT  ,ONLY: SIGW,DELW,GLOC,SIGI                   !!! from grfint
	USE COM_ENERGY  ,ONLY: ETRT,WTRT                             !!! from ttrint
      USE COM_GRFDAT  ,ONLY: EPOL,ECAP,EBND,GWGT,GW0T              !!! from grfbnd
      USE COM_HUBDAT  ,ONLY: NHUB,MCRL,LCRL,KSOLVER,KDBLCNT,CDBLCNT!!! from readhub
      USE COM_INDORB  ,ONLY: INDDMF                                !!! from lmtpar
      USE COM_KMESH   ,ONLY: NPNT,PNT,WGT                          !!! from tetra
      USE COM_WMESH   ,ONLY: NPNW,PNW                              !!! from tetra
      USE COM_FERMI   ,ONLY: EF                                    !!! from ttrints
      USE COM_CHANNELS,ONLY: IUSGM                                 !!! from channels
      USE COM_MASHDEP ,ONLY: LENCMP                                !!! from setup
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                       !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8, ALLOCATABLE :: UMAT(:,:)
	REAL*8, ALLOCATABLE :: GMAT(:,:)
	REAL*8, ALLOCATABLE :: UBAR(:,:)
	REAL*8, ALLOCATABLE :: GBAR(:,:)
	COMPLEX*16, ALLOCATABLE :: DBAR(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: DAVR(:,:)
	COMPLEX*16 ZMSB,WHT
      DATA PI/3.141592653589793D0/
      CALL ABORTNOW()
C MEMORY ALLOCATIONS
	ALLOCATE(UMAT(LIMB2MEM,LIMB2MEM))
	ALLOCATE(GMAT(LIMB2MEM,LIMB2MEM))
	ALLOCATE(UBAR(0:LMAXBMEM,0:LMAXBMEM))
	ALLOCATE(GBAR(0:LMAXBMEM,0:LMAXBMEM))
	ALLOCATE(DBAR(0:LMAXBMEM,NATOMMEM,NSPINMEM,NORBSMEM))
	ALLOCATE(DAVR(0:LMAXBMEM,NATOMMEM))
C COMPUTE BAND ENERGY WHICH IS MATRIX ELEMENT <KJW|-Nabla2+Veff|KJW>
	EBNDVAL=0.D0
	ESUMVAL=0.D0
	DO IMSC=0,NMSC+1               !!! over Matsubara frequencies
	DO IPNT=1,NPNT(1)              !!! over k-points
      DO IBNDS=1,NSPIN               !!! over spin subbands
      DO IBNDT=1,NBNDT(1)+NBNDH(1)   !!! over bands
	IBAND=IBNDS+NSPIN*(IBNDT-1)
      WHT=(0.D0,0.D0)
	IF(IMSC.NE.NMSC+1.AND.IDMF.EQ.3)
     &WHT=+TEMP*GWGT(IBAND,IPNT,IMSC)*FMSC(IMSC)
	IF(IMSC.EQ.NMSC+1.AND.IDMF.EQ.3)
     &WHT=-TEMP*GW0T(IBAND,IPNT)+
     &DCMPLX(0.5D0*WTRT(IBAND,IPNT),0.D0)
	IF(IMSC.EQ.NMSC+1.AND.IDMF.EQ.4)   !!! simple weight
     &WHT=DCMPLX(0.5D0*WTRT(IBAND,IPNT),0.D0)
	IF(IMSC.NE.NMSC+1.AND.IDMF.EQ.5)
     &WHT=-0.5D0*DIMAG(GWGT(IBAND,IPNT,IMSC))/PI*
     &FMSC(IMSC)*FERMIFUN(DREAL(WMSC(IMSC)),TEMP)
	IF(IMSC.EQ.NMSC+1.AND.IDMF.EQ.5)
     &WHT=(0.D0,0.D0)
	EBNDVAL=EBNDVAL+WHT*EBND(IBAND,IPNT,IMSC)+
     &         DCONJG(WHT*EBND(IBAND,IPNT,IMSC))
	ESUMVAL=ESUMVAL+WHT*EPOL(IBAND,IPNT,IMSC)+
     &         DCONJG(WHT*EPOL(IBAND,IPNT,IMSC))
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C *******************************************
C COMPUTE FREQUENCY DEPENDENT PART OF THE INTERACTION AFTER GALIZKY MIGDAL
	EINTGAL=0.D0
	DO 1000 IMSC=0,NMSC            !!! over Matsubara frequencies
C READ SELF-ENERGY, LOCAL GREEN FUNCTION
	IREC=0
	DO JMSB=0,NMSC                 !!! over Matsubara frequencies
	DO IATOM=1,NATOM               !!! over atoms
	ISORT=IS(IATOM)
	IF(MCRL(IATOM).EQ.0)CYCLE
	IREC=IREC+1
	IF(JMSB.NE.IMSC)CYCLE
	IUMAX=(ILSB(ISORT)+1)*(2*ILSB(ISORT)+1)*(2*ILSB(ISORT)+3)/3
	READ(IUSGM,REC=IREC)
     &(((SIGW(IU,IATOM,IUPDN,IORBS),IU=1,IUMAX),IUPDN=1,NSPIN),
     &IORBS=1,NORBS),
     &(((DELW(IU,IATOM,IUPDN,IORBS),IU=1,IUMAX),IUPDN=1,NSPIN),
     &IORBS=1,NORBS),
     &(((GLOC(IU,IATOM,IUPDN,IORBS),IU=1,IUMAX),IUPDN=1,NSPIN),
     &IORBS=1,NORBS)
	ENDDO                          !!! over atoms
	ENDDO                          !!! over Matsubara frequencies
	DO IATOM=1,NATOM               !!! over atoms
	ISORT=IS(IATOM)
	IF(MCRL(IATOM).EQ.0)CYCLE
	DO IORBS=1,NORBS               !!! over spins
	DO IUPDN=1,NSPIN               !!! over spins
	IF(IORBS.EQ.1)THEN
	IUPDN1=IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	IUPDN1=NSPIN-IUPDN+1
	ENDIF
	DO L=0,ILSB(ISORT)             !!! over l
	IF(LCRL(L,IATOM).EQ.0)CYCLE
	DO M=-L,L                      !!! over m
	DO K=-L,L                      !!! over k
	LM=L*(L+1)+M+1
	LK=L*(L+1)+K+1
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+K)+L+M+1           !  (l,m k) packed
	IW=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+K+1           !  (l,m k) packed
	IF(IDMF.EQ.3)
     &EINTGAL=EINTGAL+0.5D0*2.D0*TEMP*FMSC(IMSC)*DREAL(
     &(SIGW(IU,IATOM,IUPDN1,IORBS)-SIGI(IU,IATOM,IUPDN1,IORBS))*
     & GLOC(IW,IATOM,IUPDN,IORBS))
	ENDDO                          !!! over k
	ENDDO                          !!! over m
	ENDDO                          !!! over l
	ENDDO                          !!! over spins
	ENDDO                          !!! over iorbs
	ENDDO                          !!! over atoms
 1000	CONTINUE                       !!! over IMSC
C ******************************
C STATIC PART OF THE INTERACTION
	ESTAHFK=0.D0
	ESTADBC=0.D0
	DO 3000 IATOM=1,NATOM          !!! over atoms
	ISORT=IS(IATOM)
	IF(MCRL(IATOM).EQ.0)CYCLE
      CALL LIB_HUBMAT_L2(IATOM,UMAT,GMAT,UBAR,GBAR) ! set Hubbard and Exchange matrices
C SET AVERAGE OCCUPANCIES <Nup> and <Ndn>
	DO IORBS=1,NORBS               !!! over iorbs
	DO IUPDN=1,NSPIN               !!! over spins
	DO L=0,ILSB(ISORT)             !!! over l
	DBAR(L,IATOM,IUPDN,IORBS)=(0.D0,0.D0)
	DO M=-L,L                      !!! over m
	LM=L*(L+1)+M+1
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M+1           !  (l,m m) packed
	DBAR(L,IATOM,IUPDN,IORBS)=DBAR(L,IATOM,IUPDN,IORBS)+
     &DHUB(IU,IATOM,IUPDN,IORBS)
	ENDDO                          !!! over m
	ENDDO                          !!! over l
	ENDDO                          !!! over spins
	ENDDO                          !!! over iorbs
C SET MEAN NUMBER OF ELECTRONS
	DO L=0,ILSB(ISORT)             !!! over l
	DAVR(L,IATOM)=(0.D0,0.D0)
	DO IUPDN=1,NSPIN               !!! over spins
	DAVR(L,IATOM)=DAVR(L,IATOM)+DBAR(L,IATOM,IUPDN,1)
	ENDDO                          !!! over spins
	ENDDO                          !!! over l
C **********************************
C SET CORRECTION TO THE TOTAL ENERGY
	DO 2000 L=0,ILSB(ISORT)        !!! over l
	IF(LCRL(L,IATOM).EQ.0)CYCLE
C Hartree Fock formula (Rotationally Invariant, after Liechtenstein et.al )
	IF(KSOLVER(L,IATOM).EQ.11)THEN
	DO M=-L,L                      !!! over m
	DO K=-L,L                      !!! over k
	LM=L*(L+1)+M+1
	LK=L*(L+1)+K+1
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+K)+L+M+1           !  (l,m k) packed
	DO M1=-L,L                     !!! over m1
	DO K1=-L,L                     !!! over k1
	LM1=L*(L+1)+M1+1
	LK1=L*(L+1)+K1+1
	IU1=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+K1)+L+M1+1  !  (l,m1 k1) packed
      ESTAHFK=ESTAHFK+0.5D0*UMAT(IU,IU1)*(
     &DHUB(IU,IATOM,1,1)*DHUB(IU1,IATOM,NSPIN,1)+
     &DHUB(IU,IATOM,1,1)*DHUB(IU1,IATOM,NSPIN,1))
     &           *0.5D0*DBLE(NSPIN)*0.5D0*DBLE(NSPIN)
     &           +0.5D0*(UMAT(IU,IU1)-GMAT(IU,IU1))*(
     &DHUB(IU,IATOM,1    ,1)*DHUB(IU1,IATOM,1    ,1)+
     &DHUB(IU,IATOM,NSPIN,1)*DHUB(IU1,IATOM,NSPIN,1))
     &           *0.5D0*DBLE(NSPIN)*0.5D0*DBLE(NSPIN)
C Relativistic corrections
	IF(NORBS.EQ.2)
     &ESTAHFK=ESTAHFK-0.5D0*GMAT(IU,IU1)*(
     &DHUB(IU,IATOM,1,NORBS)*DHUB(IU1,IATOM,NSPIN,NORBS)+
     &DHUB(IU,IATOM,NSPIN,NORBS)*DHUB(IU1,IATOM,1,NORBS))
	ENDDO                          !!! over k1
	ENDDO                          !!! over m1
	ENDDO                          !!! over k
	ENDDO                          !!! over m
C Galitzky-Migdal formula in all other cases
	ELSEIF(KSOLVER(L,IATOM).GT.11)THEN
	DO IORBS=1,NORBS               !!! over spins
	DO IUPDN=1,NSPIN               !!! over spins
	IF(IORBS.EQ.1)THEN
	IUPDN1=IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	IUPDN1=NSPIN-IUPDN+1
	ENDIF
	DO M=-L,L                      !!! over m
	DO K=-L,L                      !!! over k
	LM=L*(L+1)+M+1
	LK=L*(L+1)+K+1
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+K)+L+M+1           !  (l,m k) packed
	IW=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+K+1           !  (l,m k) packed
	ESTAHFK=ESTAHFK+0.5D0*DHUB(IW,IATOM,IUPDN,IORBS)*
     &SIGI(IU,IATOM,IUPDN1,IORBS)
	ENDDO                          !!! over k
	ENDDO                          !!! over m
	ENDDO                          !!! over spins
	ENDDO                          !!! over iorbs
	ENDIF
C ******************************
C SET DOUBLE COUNTING CORRECTION
C Spin polarized fully localized limit
      IF(KDBLCNT(L,IATOM).EQ.11)THEN
      ESTADBC=ESTADBC+0.5D0*UBAR(L,L)*(
     &DBAR(L,IATOM,1,1)*DBAR(L,IATOM,NSPIN,1)+
     &DBAR(L,IATOM,1,1)*DBAR(L,IATOM,NSPIN,1))
     &           *0.5D0*DBLE(NSPIN)*0.5D0*DBLE(NSPIN)
     &           -0.5D0*(UBAR(L,L)-GBAR(L,L))*(
     &DBAR(L,IATOM,1    ,1)*DBAR(L,IATOM,1    ,1)+
     &DBAR(L,IATOM,NSPIN,1)*DBAR(L,IATOM,NSPIN,1))
     &           *0.5D0*DBLE(NSPIN)*0.5D0*DBLE(NSPIN)
     &+CDBLCNT(L,IATOM)*(UBAR(L,L)-GBAR(L,L))*(
     &DBAR(L,IATOM,1    ,1)+DBAR(L,IATOM,NSPIN,1))
     &           *0.5D0*DBLE(NSPIN)
	IF(NORBS.EQ.2) !!! off-diagonal
     &ESTADBC=ESTADBC+0.5D0*GBAR(L,L)*(
     &DBAR(L,IATOM,1,NORBS)*DBAR(L,IATOM,NSPIN,NORBS)+
     &DBAR(L,IATOM,NSPIN,NORBS)*DBAR(L,IATOM,1,NORBS))
C Spin restricted fully localized limit
      ELSEIF(KDBLCNT(L,IATOM).EQ.12)THEN
      ESTADBC=ESTADBC+0.5D0*UBAR(L,L)*(
     &DAVR(L,IATOM)*DAVR(L,IATOM)+
     &DAVR(L,IATOM)*DAVR(L,IATOM))
     &           *0.5D0*0.5D0
     &           -0.5D0*(UBAR(L,L)-GBAR(L,L))*(
     &DAVR(L,IATOM)*DAVR(L,IATOM)+
     &DAVR(L,IATOM)*DAVR(L,IATOM))
     &           *0.5D0*0.5D0
     &+CDBLCNT(L,IATOM)*(UBAR(L,L)-GBAR(L,L))*(
     &DAVR(L,IATOM)+DAVR(L,IATOM))
     &           *0.5D0
	IF(NORBS.EQ.2) !!! off-diagonal
     &ESTADBC=ESTADBC
C Galitzky-Migdal formula in all other cases
      ELSEIF(KDBLCNT(L,IATOM).GE.20)THEN
	DO IORBS=1,NORBS               !!! over spins
	DO IUPDN=1,NSPIN               !!! over spins
	IF(IORBS.EQ.1)THEN
	IUPDN1=IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	IUPDN1=NSPIN-IUPDN+1
	ENDIF
	DO M=-L,L                      !!! over m
	DO K=-L,L                      !!! over k
	LM=L*(L+1)+M+1
	LK=L*(L+1)+K+1
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+K)+L+M+1           !  (l,m k) packed
	IW=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+K+1           !  (l,m k) packed
	ESTADBC=ESTADBC+0.5D0*DHUB(IW,IATOM,IUPDN,IORBS)*
     &VDBC(IU,IATOM,IUPDN1,IORBS)
	ENDDO                          !!! over k
	ENDDO                          !!! over m
	ENDDO                          !!! over spins
	ENDDO                          !!! over iorbs
	ENDIF
 2000 CONTINUE                       !!! over l
 3000 CONTINUE                       !!! over atoms
C ************************
C GALITZKY MIGDAL FORMULAE
	EGALHFK=0.D0
	EGALDBC=0.D0
	DO 5000 IATOM=1,NATOM          !!! over atoms
	ISORT=IS(IATOM)
	IF(MCRL(IATOM).EQ.0)CYCLE
	DO 4000 L=0,ILSB(ISORT)        !!! over l
	IF(LCRL(L,IATOM).EQ.0)CYCLE
C Hartree Fock
	DO IORBS=1,NORBS               !!! over spins
	DO IUPDN=1,NSPIN               !!! over spins
	IF(IORBS.EQ.1)THEN
	IUPDN1=IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	IUPDN1=NSPIN-IUPDN+1
	ENDIF
	DO M=-L,L                      !!! over m
	DO K=-L,L                      !!! over k
	LM=L*(L+1)+M+1
	LK=L*(L+1)+K+1
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+K)+L+M+1           !  (l,m k) packed
	IW=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+K+1           !  (l,m k) packed
	EGALHFK=EGALHFK+0.5D0*DHUB(IW,IATOM,IUPDN,IORBS)*
     &SIGI(IU,IATOM,IUPDN1,IORBS)
	ENDDO                          !!! over k
	ENDDO                          !!! over m
	ENDDO                          !!! over spins
	ENDDO                          !!! over iorbs
C Double counting
	DO IORBS=1,NORBS               !!! over spins
	DO IUPDN=1,NSPIN               !!! over spins
	IF(IORBS.EQ.1)THEN
	IUPDN1=IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	IUPDN1=NSPIN-IUPDN+1
	ENDIF
	DO M=-L,L                      !!! over m
	DO K=-L,L                      !!! over k
	LM=L*(L+1)+M+1
	LK=L*(L+1)+K+1
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+K)+L+M+1           !  (l,m k) packed
	IW=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+K+1           !  (l,m k) packed
	EGALDBC=EGALDBC+0.5D0*DHUB(IW,IATOM,IUPDN,IORBS)*
     &VDBC(IU,IATOM,IUPDN1,IORBS)
	ENDDO                          !!! over k
	ENDDO                          !!! over m
	ENDDO                          !!! over spins
	ENDDO                          !!! over iorbs
 4000 CONTINUE                       !!! over l
 5000 CONTINUE                       !!! over atoms
	CALL DMF_DMFTENER(EINTGAL,ESTAHFK,ESTADBC,EGALHFK,EGALDBC,0)
C PRINT BLOCK
	WRITE(IUN,10000)
	WRITE(IUN,10010)EBNDVAL,ESUMVAL
	WRITE(IUN,10020)EINTGAL,ESTAHFK
	WRITE(IUN,10030)ESTADBC,EGALDBC
10000 FORMAT(1X,'DMFT ENERGY CONTRIBUTIONS -------------------->')
10010	FORMAT(1X,'Eband,Esumk ==',G14.7,1X,G14.7)
10020	FORMAT(1X,'EintW,EintS ==',G14.7,1X,G14.7)
10030	FORMAT(1X,'EdbcS,EdbcG ==',G14.7,1X,G14.7)
	EINTDMF=EINTGAL+ESTAHFK-ESTADBC ! Interaction energy correction
	EBNDDMF=EBNDVAL                 ! New band energy from valence panel
	ETOTDMF=EBNDDMF+EINTDMF         ! Total DMFT correction to the DFT energy
	WRITE(IUN,10110)
	WRITE(IUN,10120)EBNDDMF
	WRITE(IUN,10130)EINTDMF
	WRITE(IUN,10140)ETOTDMF
	WRITE(IUN,10110)
10110 FORMAT(1X,'***************************************************')
10120 FORMAT(1X,'*     DMFT BAND ENERGY  =',G20.14,'     *')
10130 FORMAT(1X,'*     DMFT INT. ENERGY  =',G20.14,'     *')
10140 FORMAT(1X,'*     DMFT TOTAL ENERGY =',G20.14,'     *')
C SAVE ENERGY CORRECTION DUE TO DMFT
	CALL FRC_DMFTENER(ETOTDMF,1)
C MEMORY DEALLOCATIONS
	DEALLOCATE(UMAT,GMAT,UBAR,GBAR,DBAR,DAVR)
	END



	SUBROUTINE DMF_DMFTENER(EINTGAL,ESTAHFK,ESTADBC,
     &                        EGALHFK,EGALDBC,ISAVE)
*****************************************************************
*  Saves energy correction due to DMFT                          *
*****************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                               !!! from setup
      USE COM_CONTROL ,ONLY: LIFT,LMTO,IASA,IDMF                   !!! from readini
      USE COM_FERMI   ,ONLY: EF                                    !!! from ttrints
      USE COM_CHANNELS,ONLY: IUCEW,IUHAM                           !!! from channels
      USE COM_MASHDEP ,ONLY: LENCMP                                !!! from setup
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                       !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
	SAVE EINTGAL1,ESTAHFK1,ESTADBC1,EGALHFK1,EGALDBC1
      DATA PI/3.141592653589793D0/
      CALL ABORTNOW()
	IF(ISAVE.EQ.0)THEN ! returns saved energy correction
      EINTGAL=EINTGAL1
      ESTAHFK=ESTAHFK1
      ESTADBC=ESTADBC1
      EGALHFK=EGALHFK1
      EGALDBC=EGALDBC1
	ELSEIF(ISAVE.EQ.1)THEN ! saves current correction to energy
      EINTGAL1=EINTGAL
      ESTAHFK1=ESTAHFK
      ESTADBC1=ESTADBC
      EGALHFK1=EGALHFK
      EGALDBC1=EGALDBC
	ENDIF
	END





	SUBROUTINE FRC_DMFTENER(DE,ISAVE)
*****************************************************************
*  Saves energy correction due to DMFT                          *
*****************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                               !!! from setup
      USE COM_CONTROL ,ONLY: LIFT,LMTO,IASA,IDMF                   !!! from readini
      USE COM_FERMI   ,ONLY: EF                                    !!! from ttrints
      USE COM_CHANNELS,ONLY: IUCEW,IUHAM                           !!! from channels
      USE COM_MASHDEP ,ONLY: LENCMP                                !!! from setup
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                       !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
	SAVE EDMF
      DATA PI/3.141592653589793D0/,EDMF/0.D0/
      CALL ABORTNOW()
	IF(ISAVE.EQ.0)DE=EDMF ! returns saved energy correction
	IF(ISAVE.EQ.1)EDMF=DE ! saves current correction to energy
	END
