	SUBROUTINE DMF_FTBMAS(IPNT,IMSC,IENW)
*********************************************************
*  Renormalizes overlap matrix by effective masses      *
*********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                          !!! from setup
      USE COM_CONTROL ,ONLY : IDMF                            !!! from readini
      USE COM_PARAM   ,ONLY : NATOM,NSORT,NSPIN,NORBS,IS,ILSB !!! from readini
      USE COM_KAPPAR  ,ONLY : NPAN,NKAP                       !!! from readini
      USE COM_PANPAR  ,ONLY : LTPAN,LSPAN                     !!! from readini
      USE COM_LATTICE ,ONLY : RBAS,GBAS,TAU                   !!! from readstr
      USE COM_NBANDS  ,ONLY : NBNDF,NBNDE,NBNDT,NBNDC,NBNDH   !!! from readini
      USE COM_LMTMAT  ,ONLY : HMAT,OMAT                       !!! from grfmat
      USE COM_DMFDAT  ,ONLY : SIGW                            !!! from grfmat
      USE COM_HUBDAT  ,ONLY : MCRL,LCRL                       !!! from readhub
      USE COM_INDORB  ,ONLY : INDDMF                          !!! from lmtpar
      USE COM_INPTTR  ,ONLY : NDIV,NDIC,SH                    !!! from readini
      USE COM_KMESH   ,ONLY : NPNT,PNT                        !!! from tetra
      USE COM_WMESH   ,ONLY : NPNW,PNW                        !!! from tetra
      USE COM_UNIT    ,ONLY : IUN,IUR,IUT,IUI                 !!! from setup
      USE COM_MASHDEP ,ONLY : LENCMP                          !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16 HS,OS
	LOGICAL LOG
	DATA PI/3.141592653589793D0/
      CALL ABORTNOW()
      NDIM=NBNDT(1)*NSPIN
C CALCULATE NEW OVERLAP MATRIX
      DO 2000 IORBS=1,NORBS
      DO 1000 IUPDN=1,NSPIN
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
	DO IKAP1=1,NKAP(1)                  !!! over ikap1
	DO IATOM1=1,NATOM                   !!! over iatom1
	ISORT1=IS(IATOM1)
	DO L1=0,ILSB(ISORT1)                !!! over l1
	IF(.NOT.LTPAN(L1,IATOM1,IKAP1,1))CYCLE
	DO M1=-L1,L1                        !!! over m1
	L1M1=L1*(L1+1)+M1+1
	IDIM1=INDDMF(L1M1,IATOM1,IKAP1,ISPIN1)
	DO IKAP=1,NKAP(1)                   !!! over ikap
	DO IATOM=1,NATOM                    !!! over iatom
	ISORT=IS(IATOM)
	DO L=0,ILSB(ISORT)                  !!! over l
	IF(.NOT.LTPAN(L,IATOM,IKAP,1))CYCLE
	DO M=-L,L                           !!! over m
	LM=L*(L+1)+M+1
	IDIM=INDDMF(LM,IATOM,IKAP,ISPIN)
	IF(IKAP1.EQ.IKAP.AND.IATOM1.EQ.IATOM.AND.L1.EQ.L)THEN
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M1+1 !!! (l,m1 m)
	OMAT(IDIM1,IDIM)=OMAT(IDIM1,IDIM)
	ENDIF
      ENDDO                               !!! over m
      ENDDO                               !!! over l
      ENDDO                               !!! over iatom
      ENDDO                               !!! over ikap
      ENDDO                               !!! over m1
      ENDDO                               !!! over l1
      ENDDO                               !!! over iatom1
      ENDDO                               !!! over ikap1
1000	CONTINUE                            !!! over spins
2000	CONTINUE                            !!! over iorbs
C ERROR HANDLINGS
C none
C MEMORY DEALLOCATIONS
	END
