	SUBROUTINE DMF_GRFBND(IPNT,IMSC,IENW,ICOF)
*********************************************************
*  Subroutine prepares hamiltonian matrix plus          *
*  self-energy matrix, computes complex eigenvalues and *
*  eigenvectors and stores them.                        *
*********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                               !!! from setup
      USE COM_CONTROL ,ONLY: LIFT,LMTO,IASA,IDMF                   !!! from readini
      USE COM_LATTICE ,ONLY: RBAS,GBAS,TAU                         !!! from readstr
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS,ILSB,ILST  !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP                        !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN                           !!! from readini
      USE COM_TBBPAR  ,ONLY: LTBAS,LSBAS,INBAS,NTBAS               !!! from readhop
      USE COM_ENVSITE ,ONLY: NENV,TENV,ISENV                       !!! from envmesh
      USE COM_LMTMAT  ,ONLY: HMAT,OMAT                             !!! from lmtmat
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC,NBNDH         !!! from readini
      USE COM_MSBMESH ,ONLY: TEMP,NMSC                             !!! from grfbnd
      USE COM_HUBDAT  ,ONLY: MCRL,LCRL,NCLM,KHRM                   !!! from readhub
      USE COM_IMPDAT  ,ONLY: NPOLIMP                               !!! from readhub
	USE COM_ENERGY  ,ONLY: ETRT,ETRW                             !!! from grfbnd
      USE COM_GRFDAT  ,ONLY: EPOL,EPOW,ECAP,EBND                   !!! from grfbnd
	USE COM_LMTVEC  ,ONLY: APHR,APSR,APJR,APHL,APSL,APJL         !!! from lmtvec
      USE COM_SCRINP  ,ONLY: ALPHA                                 !!! from alpcon
      USE COM_KMESH   ,ONLY: NPNT,PNT                              !!! from tetra
      USE COM_WMESH   ,ONLY: NPNW,PNW                              !!! from tetra
      USE COM_INDORB  ,ONLY: INDLMT,INDDMF                         !!! from lmtpar
      USE COM_STRCON  ,ONLY: SSCON,SDCON                           !!! from strgnt
	USE COM_LMTOUT  ,ONLY: ICCHI,ICPSK                           !!! from readini
      USE COM_CHANNELS,ONLY: IUCEW,IUHAM,IUPSK,IUPSI               !!! from channels
      USE COM_MASHDEP ,ONLY: LENCMP                                !!! from setup
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                       !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8, ALLOCATABLE :: RE(:)
      COMPLEX*16, ALLOCATABLE :: CE(:)
	COMPLEX*16, ALLOCATABLE :: CR(:,:,:)
	COMPLEX*16, ALLOCATABLE :: CL(:,:,:)
	COMPLEX*16, ALLOCATABLE :: SR(:,:,:)
	COMPLEX*16, ALLOCATABLE :: SL(:,:,:)
	COMPLEX*16, ALLOCATABLE :: AEXPR(:,:)
	COMPLEX*16, ALLOCATABLE :: HTMP(:,:)
	COMPLEX*16, ALLOCATABLE :: OTMP(:,:)
	COMPLEX*16 CONVL,CONVR
      LOGICAL LOG
      DATA PI/3.141592653589793D0/
      CALL ABORTNOW()
      ALLOCATE(RE((NBNDT(1)+NBNDH(1))*NSPINMEM))
      ALLOCATE(CE((NBNDT(1)+NBNDH(1))*NSPINMEM))
      ALLOCATE(CR(NCLM,NSPINMEM,(NBNDT(1)+NBNDH(1))*NSPINMEM))
      ALLOCATE(CL(NCLM,NSPINMEM,(NBNDT(1)+NBNDH(1))*NSPINMEM))
      ALLOCATE(SR(NCLM,NSPINMEM,(NBNDT(1)+NBNDH(1))*NSPINMEM))
      ALLOCATE(SL(NCLM,NSPINMEM,(NBNDT(1)+NBNDH(1))*NSPINMEM))
      ALLOCATE(AEXPR(NBNDH(1),(NBNDT(1)+NBNDH(1))*NSPINMEM))
      ALLOCATE(HTMP(NBNDT(1)*NSPINMEM,NBNDT(1)*NSPINMEM))
      ALLOCATE(OTMP(NBNDT(1)*NSPINMEM,NBNDT(1)*NSPINMEM))
C CHECK HERMITIANNESS IF REQUIRED
	IF(KHRM.EQ.1)THEN
	DO IDIM1=1,(NBNDT(1)+NBNDH(1))*NSPIN
	DO IDIM=1,IDIM1
      TH=ABS(HMAT(IDIM1,IDIM)-CONJG(HMAT(IDIM,IDIM1)))
      IF(TH.GE.1.D-05)WRITE(IUT,*)'HMAT-->',IDIM1,IDIM,TH
      TO=ABS(OMAT(IDIM1,IDIM)-CONJG(OMAT(IDIM,IDIM1)))
      IF(TO.GE.1.D-05)WRITE(IUT,*)'OMAT-->',IDIM1,IDIM,TO
	ENDDO
	ENDDO
	ENDIF
C GENERALIZED EIGENVALUE PROBLEM
	IF(IENW.EQ.1)IVEC=0 !!! eigenvectors not needed
	IF(IENW.EQ.0)IVEC=1 !!! eigenvectors required
	IF(KHRM.EQ.0)THEN
      CALL LIB_CMPEIG1A((NBNDT(1)+NBNDH(1))*NSPIN,HMAT,OMAT,CE,
     &                   NSPIN,NORBS,IVEC,IERR,0,1.D-05)
	ELSEIF(KHRM.EQ.1)THEN
      CALL LIB_EIGEN1C((NBNDT(1)+NBNDH(1))*NSPIN,HMAT,OMAT,RE,
     &                   NSPIN,NORBS,IVEC,IERR,0,1.D-05)
      DO IBNDS=1,NSPIN
      DO IBNDT=1,NBNDT(1)+NBNDH(1)
      IBAND=IBNDS+NSPIN*(IBNDT-1)
      CE(IBAND)=DCMPLX(RE(IBAND),0.D0)
      ENDDO
      ENDDO
      ENDIF
C Eigenvalues for H+Sigma(iWn)-Sigma0
      DO IBNDS=1,NSPIN
      DO IBNDT=1,NBNDT(1)+NBNDH(1)
      IBAND=IBNDS+NSPIN*(IBNDT-1)
      IF(IENW.EQ.0)EPOL(IBAND,IPNT,IMSC)=CE(IBAND)
      IF(IENW.EQ.1)EPOW(IBAND,IPNT,IMSC)=CE(IBAND)
      IF(NPNT(1).EQ.NPNW(1))
     &EPOW(IBAND,IPNT,IMSC)=EPOL(IBAND,IPNT,IMSC)
      ENDDO
      ENDDO
C For rational interpolation these bands are for all omega's
	IF(IMSC.EQ.0.AND.IDMF.EQ.4)THEN
	DO JMSB=0,NMSC+1
      DO IBNDS=1,NSPIN
      DO IBNDT=1,NBNDT(1)+NBNDH(1)
      IBAND=IBNDS+NSPIN*(IBNDT-1)
      IF(IENW.EQ.0)EPOL(IBAND,IPNT,JMSB)=CE(IBAND)
      IF(IENW.EQ.1)EPOW(IBAND,IPNT,JMSB)=CE(IBAND)
      IF(NPNT(1).EQ.NPNW(1))
     &EPOW(IBAND,IPNT,JMSB)=EPOL(IBAND,IPNT,JMSB)
      ENDDO
      ENDDO
	ENDDO
	ENDIF
C Eigenvalues for H+Sigma(Inf)-Vdc
	IF(IMSC.EQ.0.OR.IMSC.EQ.NMSC+1)THEN
      DO IBNDS=1,NSPIN
      DO IBNDT=1,NBNDT(1)+NBNDH(1)
      IBAND=IBNDS+NSPIN*(IBNDT-1)
      IF(IENW.EQ.0)ETRT(IBAND,IPNT,1)=DREAL(CE(IBAND))
      IF(IENW.EQ.1)ETRW(IBAND,IPNT,1)=DREAL(CE(IBAND))
      IF(NPNT(1).EQ.NPNW(1))
     &ETRW(IBAND,IPNT,1)=ETRT(IBAND,IPNT,1)
      ENDDO
      ENDDO
	ENDIF
	IF(IENW.EQ.1)GOTO1000
C READ ORIGINAL HAMILTONIAN AND OVERLAP MATRICES
	IF(IENW.EQ.1)NSHIFT=0
	IF(IENW.EQ.0.AND.NPNW(1).EQ.NPNT(1))NSHIFT=0
	IF(IENW.EQ.0.AND.NPNW(1).GT.NPNT(1))NSHIFT=NSPIN*NORBS*NPNW(1)
	DO IORBS=1,NORBS
	DO IUPDN=1,NSPIN
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
	IREC=IUPDN+NSPIN*(IORBS-1)+NSPIN*NORBS*(IPNT-1)+NSHIFT
      READ(IUHAM,REC=IREC)
     &((HTMP(IDIM1+NBNDT(1)*(ISPIN1-1),IDIM+NBNDT(1)*(ISPIN-1)),
     &IDIM1=1,NBNDT(1)),IDIM=1,NBNDT(1)),
     &((OTMP(IDIM1+NBNDT(1)*(ISPIN1-1),IDIM+NBNDT(1)*(ISPIN-1)),
     &IDIM1=1,NBNDT(1)),IDIM=1,NBNDT(1))
	ENDDO
	ENDDO
C EVALUATE BAND CAPACITIES AND MATRIX ELEMENTS OF -Nabla2+Veff
      DO IBNDS=1,NSPIN                     !!! over spin subbands
      DO IBNDT=1,NBNDT(1)+NBNDH(1)         !!! over bands
      IBAND=IBNDS+NSPIN*(IBNDT-1)
	ECAP(IBAND,IPNT)     =(0.D0,0.D0)
	EBND(IBAND,IPNT,IMSC)=(0.D0,0.D0)
      DO IORBS=1,NORBS                     !!! over iorbs
      DO IUPDN=1,NSPIN                     !!! over iupdn
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
	IF(NORBS.EQ.1.AND.IUPDN.NE.IBNDS)CYCLE
	DO IKAP1=1,NKAP(1)                  !!! over ikap1
	DO IATOM1=1,NATOM                   !!! over iatom1
	ISORT1=IS(IATOM1)
	DO L1=0,ILSB(ISORT1)                !!! over l1
	IF(.NOT.LTPAN(L1,IATOM1,IKAP1,1))CYCLE
	DO M1=-L1,L1                        !!! over m1
	L1M1=L1*(L1+1)+M1+1
	IDIM1=INDDMF(L1M1,IATOM1,IKAP1,ISPIN1)
	JDIM1=INDLMT(L1M1,IATOM1,IKAP1,ISPIN1,1)
	DO IKAP=1,NKAP(1)                   !!! over ikap
	DO IATOM=1,NATOM                    !!! over iatom
	ISORT=IS(IATOM)
	DO L=0,ILSB(ISORT)                  !!! over l
	IF(.NOT.LTPAN(L,IATOM,IKAP,1))CYCLE
	DO M=-L,L                           !!! over m
	LM=L*(L+1)+M+1
	IDIM=INDDMF(LM,IATOM,IKAP,ISPIN)
	JDIM=INDLMT(LM,IATOM,IKAP,ISPIN,1)
	ECAP(IBAND,IPNT)=ECAP(IBAND,IPNT)+
     &HMAT(IDIM1,IBAND)*OTMP(JDIM1,JDIM)*OMAT(IDIM,IBAND)
	EBND(IBAND,IPNT,IMSC)=EBND(IBAND,IPNT,IMSC)+
     &HMAT(IDIM1,IBAND)*HTMP(JDIM1,JDIM)*OMAT(IDIM,IBAND)
      ENDDO                               !!! over m
      ENDDO                               !!! over l
      ENDDO                               !!! over iatom
      ENDDO                               !!! over ikap
      ENDDO                               !!! over m1
      ENDDO                               !!! over l1
      ENDDO                               !!! over iatom1
      ENDDO                               !!! over ikap1
	ENDDO                               !!! over spins
	ENDDO                               !!! over iorbs
	ENDDO                               !!! over bands
	ENDDO                               !!! over spin subbands
C For rational interpolation these bands are for all omega's
	IF(IMSC.EQ.0.AND.IDMF.EQ.4)THEN
	DO JMSB=0,NMSC+1
      DO IBNDS=1,NSPIN
      DO IBNDT=1,NBNDT(1)+NBNDH(1)
      IBAND=IBNDS+NSPIN*(IBNDT-1)
      EBND(IBAND,IPNT,JMSB)=EBND(IBAND,IPNT,0)
      ENDDO
      ENDDO
	ENDDO
	ENDIF
C STORE COEFFICIENTS FOR CORRELATED STATES
	DO IORBS=1,NORBS            !!! over spinor components
      DO IBNDS=1,NSPIN            !!! over spin subbands
	IF(NORBS.EQ.1)ISPIN=IBNDS
	IF(NORBS.EQ.2)ISPIN=IORBS
      DO IBNDT=1,NBNDT(1)+NBNDH(1)!!! over bands
      IBAND=IBNDS+NSPIN*(IBNDT-1)
	ICLM=0
	DO IKAP=1,NKAP(1)           !!! over ikap
	DO IATOM=1,NATOM            !!! over atoms
	ISORT=IS(IATOM)
	IF(MCRL(IATOM).EQ.0)CYCLE
	DO L=0,ILSB(ISORT)          !!! over l
	IF(.NOT.LTPAN(L,IATOM,IKAP,1))CYCLE
	IF(LCRL(L,IATOM).EQ.0)CYCLE
	DO M=-L,L
	LM=L*(L+1)+M+1
	IDIM=INDDMF(LM,IATOM,IKAP,ISPIN)
	ICLM=ICLM+1
	CR(ICLM,ISPIN,IBAND)=OMAT(IDIM,IBAND)
	CL(ICLM,ISPIN,IBAND)=HMAT(IDIM,IBAND)
      ENDDO                       !!! over m
      ENDDO                       !!! over l
      ENDDO                       !!! over iatom
      ENDDO                       !!! over ikap
C SET CONVOLUTIONS WITH THE STRUCTURE CONSTANTS
	ICLM=0
	DO IKAP=1,NKAP(1)           !!! over ikap
	DO IATOM=1,NATOM            !!! over iatom
	ISORT=IS(IATOM)
	IF(MCRL(IATOM).EQ.0)CYCLE
	DO L=0,ILSB(ISORT)          !!! over l
	IF(.NOT.LTPAN(L,IATOM,IKAP,1))CYCLE
	IF(LCRL(L,IATOM).EQ.0)CYCLE
	DO M=-L,L                   !!! over m
	LM=L*(L+1)+M+1
	IDIM=INDDMF(LM,IATOM,IKAP,ISPIN)
	ICLM=ICLM+1
	CONVL=(0.D0,0.D0)
	CONVR=(0.D0,0.D0)
	IF(IASA.EQ.1.OR.IASA.EQ.2)THEN
	DO IATOM2=1,NATOM            !!! over iatom2
	ISORT2=IS(IATOM2)
	DO L2=0,ILSB(ISORT2)         !!! over l2
	IF(.NOT.LTPAN(L2,IATOM2,IKAP,1))CYCLE
	DO M2=-L2,L2                !!! over m2
	L2M2=L2*(L2+1)+M2+1
	IDIM2=INDDMF(L2M2,IATOM2,IKAP,ISPIN)
	CONVL=CONVL+DCONJG(SSCON(LM,IATOM,L2M2,IATOM2,IKAP))*
     &HMAT(IDIM2,IBAND)
	CONVR=CONVR+SSCON(LM,IATOM,L2M2,IATOM2,IKAP)*
     &OMAT(IDIM2,IBAND)
      ENDDO                       !!! over m2
      ENDDO                       !!! over l2
      ENDDO                       !!! over iatom2
	ENDIF
	SL(ICLM,ISPIN,IBAND)=CONVL
	SR(ICLM,ISPIN,IBAND)=CONVR
      ENDDO                       !!! over m
      ENDDO                       !!! over l
      ENDDO                       !!! over iatom
      ENDDO                       !!! over ikap
      ENDDO                       !!! over bands
      ENDDO                       !!! over spin subbands
	ENDDO                       !!! over spinor components
C COMPUTE COEFFICIENTS FOR ALL STATES
	IF(ICOF.EQ.1)THEN
	DO IORBS=1,NORBS            !!! over spinor components
	DO IBNDS=1,NSPIN            !!! over spin subbands
	IF(NORBS.EQ.1)ISPIN=IBNDS
	IF(NORBS.EQ.2)ISPIN=IORBS
	DO IBNDT=1,NBNDT(1)+NBNDH(1)!!! over bands
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	DO IKAP=1,NKAP(1)           !!! over energies
C SET APH
	IF(IASA.EQ.1.OR.IASA.EQ.2)THEN
	DO IATOM=1,NATOM            !!! over iatom
	ISORT=IS(IATOM)
      DO L=0,ILSB(ISORT)          !!! over l
      DO M=-L,L                   !!! over m
      LM=L*(L+1)+M+1
	IDIM=INDDMF(LM,IATOM,IKAP,ISPIN)
	APHR(LM,IATOM,IKAP,ISPIN,IBAND)=(0.D0,0.D0)
	APSR(LM,IATOM,IKAP,ISPIN,IBAND)=(0.D0,0.D0)
	APHL(LM,IATOM,IKAP,ISPIN,IBAND)=(0.D0,0.D0)
	APSL(LM,IATOM,IKAP,ISPIN,IBAND)=(0.D0,0.D0)
      IF(.NOT.LTPAN(L,IATOM,IKAP,1))CYCLE
	APHR(LM,IATOM,IKAP,ISPIN,IBAND)=OMAT(IDIM,IBAND)
	APSR(LM,IATOM,IKAP,ISPIN,IBAND)=OMAT(IDIM,IBAND)
	APHL(LM,IATOM,IKAP,ISPIN,IBAND)=HMAT(IDIM,IBAND)
	APSL(LM,IATOM,IKAP,ISPIN,IBAND)=HMAT(IDIM,IBAND)
      ENDDO                       !!! over m
      ENDDO                       !!! over l
      ENDDO                       !!! over iatom
C SET APJ
	DO IATOM=1,NATOM            !!! over iatom
	ISORT=IS(IATOM)
	DO L=0,ILST(ISORT)+1        !!! over l
	DO M=-L,L                   !!! over m
	LM=L*(L+1)+M+1
	CONVR=(0.D0,0.D0)
	CONVL=(0.D0,0.D0)
	IF(IASA.EQ.1.OR.IASA.EQ.2)THEN
	DO IATOM2=1,NATOM           !!! over iatom2
	ISORT2=IS(IATOM2)
	DO L2=0,ILSB(ISORT2)        !!! over l2
	IF(.NOT.LTPAN(L2,IATOM2,IKAP,1))CYCLE
	DO M2=-L2,L2                !!! over m2
	L2M2=L2*(L2+1)+M2+1
	IDIM2=INDDMF(L2M2,IATOM2,IKAP,ISPIN)
	CONVR=CONVR+SSCON(LM,IATOM,L2M2,IATOM2,IKAP)*
     &OMAT(IDIM2,IBAND)
	CONVL=CONVL+DCONJG(SSCON(LM,IATOM,L2M2,IATOM2,IKAP))*
     &HMAT(IDIM2,IBAND)
      ENDDO                       !!! over m2
      ENDDO                       !!! over l2
      ENDDO                       !!! over iatom2
	ENDIF
	APJR(LM,IATOM,IKAP,ISPIN,IBAND)=CONVR
	APJL(LM,IATOM,IKAP,ISPIN,IBAND)=CONVL
      ENDDO                       !!! over m
      ENDDO                       !!! over l
      ENDDO                       !!! over iatom
      ENDIF
C SET APS (if screened LMTO, these represent bare coefficients)
	IF((IASA.EQ.1.OR.IASA.EQ.2).AND.LMTO.NE.1)THEN
      DO IATOM=1,NATOM            !!! over iatom
      ISORT=IS(IATOM)
      DO L=0,ILSB(ISORT)          !!! over l
      DO M=-L,L                   !!! over m
      LM=L*(L+1)+M+1
      IDIM=INDDMF(LM,IATOM,IKAP,ISPIN)
      APSR(LM,IATOM,IKAP,ISPIN,IBAND)=(0.D0,0.D0)
      APSL(LM,IATOM,IKAP,ISPIN,IBAND)=(0.D0,0.D0)
      IF(.NOT.LTPAN(L,IATOM,IKAP,1))CYCLE
      DO IATOM2=1,NATOM           !!! over iatom2
      ISORT2=IS(IATOM2)
      DO L2=0,ILSB(ISORT2)        !!! over l2
      IF(.NOT.LTPAN(L2,IATOM2,IKAP,1))CYCLE
      DO M2=-L2,L2                !!! over m2
      L2M2=L2*(L2+1)+M2+1
      IDIM2=INDDMF(L2M2,IATOM2,IKAP,ISPIN)
      IF(IDIM.EQ.IDIM2)ONE=1.D0
      IF(IDIM.NE.IDIM2)ONE=0.D0
	APSR(LM,IATOM,IKAP,ISPIN,IBAND)=
     &APSR(LM,IATOM,IKAP,ISPIN,IBAND)+(DCMPLX(ONE,0.D0)+
     &ALPHA(L,ISORT,IKAP,1)*SSCON(LM,IATOM,L2M2,IATOM2,IKAP))*
     &APHR(L2M2,IATOM2,IKAP,ISPIN,IBAND)
	APSL(LM,IATOM,IKAP,ISPIN,IBAND)=
     &APSL(LM,IATOM,IKAP,ISPIN,IBAND)+DCONJG(DCMPLX(ONE,0.D0)+
     &ALPHA(L,ISORT,IKAP,1)*SSCON(LM,IATOM,L2M2,IATOM2,IKAP))*
     &APHL(L2M2,IATOM2,IKAP,ISPIN,IBAND)
      ENDDO                       !!! over m2
      ENDDO                       !!! over l2
      ENDDO                       !!! over iatom2
      ENDDO                       !!! over m
      ENDDO                       !!! over l
      ENDDO                       !!! over iatom
	ENDIF
C SET COEFFICIENTS IN THE AUXILIARY SPACE
      IF(IDMF.EQ.4)THEN
	NSHF=0
	IBNDH=0
	DO IATOM=1,NATOM            !!! over iatom
	ISORT=IS(IATOM)
	IF(MCRL(IATOM).EQ.0)CYCLE
	DO L=0,ILSB(ISORT)          !!! over l
	IF(LCRL(L,IATOM).EQ.0)CYCLE
	DO IPOL=1,NPOLIMP(L,IATOM)  !!! over poles
	ISH =(ISPIN-1)*(NBNDT(1)+NBNDH(1))+NBNDT(1)+
     &     (2*L+1)*(IPOL-1)+NSHF
	DO M=-L,L                   !!! over m
	LM=L*(L+1)+M+1
C	IDIM=INDDMF(LM,IATOM,IKAP,ISPIN)
	IDIR=M+L+1+ISH
	IBNDH=IBNDH+1
	AEXPR(IBNDH,IBAND)=OMAT(IDIR,IBAND)
C	AEXPL(IBNDH,IBAND)=HMAT(IDIR,IBAND)
      ENDDO                       !!! over m
	ENDDO                       !!! over poles
	NSHF=NSHF+NPOLIMP(L,IATOM)*(2*L+1)
      ENDDO                       !!! over l
      ENDDO                       !!! over iatom
      ENDIF
      ENDDO                       !!! over energies
      ENDDO                       !!! over bands
      ENDDO                       !!! over spin subbands
      ENDDO                       !!! over spinor components
C STORE COEFFICIENTS
      IF((IASA.EQ.1.OR.IASA.EQ.2).AND.(ICPSK.GT.0.OR.ICCHI.GT.0))THEN ! store all bands
      IREC=IPNT
      IF(NORBS.EQ.1)
     &WRITE(IUPSK,REC=IREC)
     &(((((APHR(LM,IATOM,IKAP,IBNDS,IBNDS+NSPIN*(IBNDT-1)),
     &LM=1,(ILSB(IS(IATOM))+1)**2),IATOM=1,NATOM),IKAP=1,NKAP(1)),
     &IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1)),
     &(((((APSR(LM,IATOM,IKAP,IBNDS,IBNDS+NSPIN*(IBNDT-1)),
     &LM=1,(ILSB(IS(IATOM))+1)**2),IATOM=1,NATOM),IKAP=1,NKAP(1)),
     &IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1)),
     &(((((APJR(LM,IATOM,IKAP,IBNDS,IBNDS+NSPIN*(IBNDT-1)),
     &LM=1,(ILST(IS(IATOM))+2)**2),IATOM=1,NATOM),IKAP=1,NKAP(1)),
     &IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1)),
     &(((AEXPR(IBNDH,IBNDS+NSPIN*(IBNDT-1)),IBNDH=1,NBNDH(1)),
     &IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1))
      IF(NORBS.EQ.2)
     &WRITE(IUPSK,REC=IREC)
     &((((((APHR(LM,IATOM,IKAP,IORBS,IBNDS+NSPIN*(IBNDT-1)),
     &LM=1,(ILSB(IS(IATOM))+1)**2),IATOM=1,NATOM),IKAP=1,NKAP(1)),
     &IORBS=1,NORBS),IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1)),
     &((((((APSR(LM,IATOM,IKAP,IORBS,IBNDS+NSPIN*(IBNDT-1)),
     &LM=1,(ILSB(IS(IATOM))+1)**2),IATOM=1,NATOM),IKAP=1,NKAP(1)),
     &IORBS=1,NORBS),IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1)),
     &((((((APJR(LM,IATOM,IKAP,IORBS,IBNDS+NSPIN*(IBNDT-1)),
     &LM=1,(ILST(IS(IATOM))+2)**2),IATOM=1,NATOM),IKAP=1,NKAP(1)),
     &IORBS=1,NORBS),IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1)),
     &(((AEXPR(IBNDH,IBNDS+NSPIN*(IBNDT-1)),IBNDH=1,NBNDH(1)),
     &IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1))
	ELSEIF(IASA.EQ.4.AND.(ICPSK.GT.0.OR.ICCHI.GT.0))THEN
      IREC=IPNT
      IF(NORBS.EQ.1)
     &WRITE(IUPSK,REC=IREC)
     &(((OMAT(IDIM+NTBAS*(IBNDS-1),IBNDS+NSPIN*(IBNDT-1)),
     &IDIM=1,NTBAS),IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1))
      IF(NORBS.EQ.2)
     &WRITE(IUPSK,REC=IREC)
     &((((OMAT(IDIM+NTBAS*(IORBS-1),IBNDS+NSPIN*(IBNDT-1)),
     &IDIM=1,NTBAS),IORBS=1,NORBS),IBNDS=1,NSPIN),
     &IBNDT=1,NBNDT(1)+NBNDH(1))
	ENDIF
	ENDIF
      IREC=IPNT+NPNT(1)*IMSC
      IF(NORBS.EQ.1)
     &WRITE(IUCEW,REC=IREC)
     &(((CR(ICLM,IBNDS,IBNDS+NSPIN*(IBNDT-1)),ICLM=1,NCLM),
     &   IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1)),
     &(((CL(ICLM,IBNDS,IBNDS+NSPIN*(IBNDT-1)),ICLM=1,NCLM),
     &   IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1)),
     &(((SR(ICLM,IBNDS,IBNDS+NSPIN*(IBNDT-1)),ICLM=1,NCLM),
     &   IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1)),
     &(((SL(ICLM,IBNDS,IBNDS+NSPIN*(IBNDT-1)),ICLM=1,NCLM),
     &   IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1))
      IF(NORBS.EQ.2)
     &WRITE(IUCEW,REC=IREC)
     &((((CR(ICLM,IORBS,IBNDS+NSPIN*(IBNDT-1)),ICLM=1,NCLM),
     &IORBS=1,NORBS),IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1)),
     &((((CL(ICLM,IORBS,IBNDS+NSPIN*(IBNDT-1)),ICLM=1,NCLM),
     &IORBS=1,NORBS),IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1)),
     &((((SR(ICLM,IORBS,IBNDS+NSPIN*(IBNDT-1)),ICLM=1,NCLM),
     &IORBS=1,NORBS),IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1)),
     &((((SL(ICLM,IORBS,IBNDS+NSPIN*(IBNDT-1)),ICLM=1,NCLM),
     &IORBS=1,NORBS),IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1))
C MEMORY DEALLOCATIONS
 1000 DEALLOCATE(RE,CE,CR,CL,SR,SL,AEXPR,HTMP,OTMP)
	END
