	SUBROUTINE DMF_GRFGRP(GFUN,GSYM,FACT)
*****************************************************************
*  Forces symmetry for the Greens function                      *
*****************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                               !!! from setup
      USE COM_CONTROL ,ONLY: LIFT,LMTO,IDMF                        !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS,ILSB       !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP                        !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN                           !!! from readini
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC               !!! from readini
      USE COM_HUBDAT  ,ONLY: MCRL,LCRL,NCLM                        !!! from readhub
      USE COM_GROUPS  ,ONLY: NGROUP,U,SJ,IP,RDC,SHIFT,INV,IKOV     !!! from groups
      USE COM_MASHDEP ,ONLY: LENCMP                                !!! from setup
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                       !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16 GFUN(LIMB2MEM,NATOMMEM,NSPINMEM,NORBSMEM)
     &      ,PHS,GSYM(LIMB2MEM,NATOMMEM,NSPINMEM,NORBSMEM)
      DATA PI/3.141592653589793D0/
      CALL ABORTNOW()
C SET GREEN FUNCTION TO ZERO
      DO IORBS=1,NORBS                    !!! over iorbs
      DO IUPDN=1,NSPIN                    !!! over iupdn
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
	DO IATOM=1,NATOM                    !!! over iatom
	ISORT=IS(IATOM)
	DO L=0,ILSB(ISORT)                  !!! over l
	DO K=-L,L                           !!! over k
	DO M=-L,L                           !!! over m
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+K+1 !!! (l,k m)
	GSYM(IU,IATOM,IUPDN,IORBS)=(0.D0,0.D0)
      ENDDO                               !!! over m
      ENDDO                               !!! over k
      ENDDO                               !!! over l
      ENDDO                               !!! over iatom
      ENDDO                               !!! over spins
      ENDDO                               !!! over iorbs
C  SYMMETRIZE OVER GROUP
	DO IR=1,NGROUP                      !!! over group
	IG=IKOV(IR)
      DO IORBS=1,NORBS                    !!! over iorbs
      DO IUPDN=1,NSPIN                    !!! over iupdn
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
      DO JORBS=1,NORBS                    !!! over iorbs
      DO JUPDN=1,NSPIN                    !!! over iupdn
	IF(JORBS.EQ.1)THEN
	JSPIN1=JUPDN
	JSPIN =JUPDN
	ELSEIF(JORBS.EQ.2)THEN
	JSPIN1=JUPDN
	JSPIN =NSPIN+1-JUPDN
	ENDIF
	DO IATOM=1,NATOM                    !!! over iatom
	ISORT=IS(IATOM)
	IF(MCRL(IATOM).EQ.0)CYCLE
	DO L=0,ILSB(ISORT)                  !!! over l
	IF(LCRL(L,IATOM).EQ.0)CYCLE
	DO K=-L,L                           !!! over k
	DO M=-L,L                           !!! over m
	IKM=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+K+1     !!! (l,k m)
	DO K1=-L,L                          !!! over k1
	DO M1=-L,L                          !!! over m1
	IKK1=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+K1)+L+K+1   !!! (l,k k1)
	IMM1=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M1)+L+M+1   !!! (l,m m1)
	IK1M1=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M1)+L+K1+1 !!! (l,k1 m1)
C Greens function
      GSYM(IKM,IATOM,IUPDN,IORBS)=GSYM(IKM,IATOM,IUPDN,IORBS)+
     &SJ(ISPIN1,JSPIN1,IR)*DCONJG(SJ(ISPIN,JSPIN,IR))*
     &U(IKK1,IG)*DCONJG(U(IMM1,IG))*
     &GFUN(IK1M1,IP(IATOM,IR),JUPDN,JORBS)
      ENDDO                               !!! over m1
      ENDDO                               !!! over k1
      ENDDO                               !!! over m
      ENDDO                               !!! over k
      ENDDO                               !!! over l
      ENDDO                               !!! over iatom
      ENDDO                               !!! over spins
      ENDDO                               !!! over iorbs
      ENDDO                               !!! over spins
      ENDDO                               !!! over iorbs
	ENDDO                               !!! over group
C NORMALIZE
      DO IORBS=1,NORBS                    !!! over iorbs
      DO IUPDN=1,NSPIN                    !!! over iupdn
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
	DO IATOM=1,NATOM                    !!! over iatom
	ISORT=IS(IATOM)
	IF(MCRL(IATOM).EQ.0)CYCLE
	DO L=0,ILSB(ISORT)                  !!! over l
	IF(LCRL(L,IATOM).EQ.0)CYCLE
	DO K=-L,L                           !!! over k
	DO M=-L,L                           !!! over m
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+K+1 !!! (l,k m)
C Result
      GFUN(IU,IATOM,IUPDN,IORBS)=GSYM(IU,IATOM,IUPDN,IORBS)/
     &DBLE(NGROUP)*FACT                   !!! Nspin/2 cancels prefactor 2/Nspin !!!
      ENDDO                               !!! over m
      ENDDO                               !!! over k
      ENDDO                               !!! over l
      ENDDO                               !!! over iatom
      ENDDO                               !!! over spins
      ENDDO                               !!! over iorbs
C MEMORY DEALLOCATIONS
C none
	END


	SUBROUTINE DMF_DELGRP(DFUN,DSYM,FACT)
*****************************************************************
*  Forces symmetry for the self-energy & hybridization          *
*****************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                               !!! from setup
      USE COM_CONTROL ,ONLY: LIFT,LMTO,IDMF                        !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS,ILSB       !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP                        !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN                           !!! from readini
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC               !!! from readini
      USE COM_HUBDAT  ,ONLY: MCRL,LCRL,NCLM                        !!! from readhub
      USE COM_GROUPS  ,ONLY: NGROUP,U,SJ,IP,RDC,SHIFT,INV,IKOV     !!! from groups
      USE COM_MASHDEP ,ONLY: LENCMP                                !!! from setup
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                       !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16 DFUN(LIMB2MEM,NATOMMEM,NSPINMEM,NORBSMEM)
     &      ,PHS,DSYM(LIMB2MEM,NATOMMEM,NSPINMEM,NORBSMEM)
      DATA PI/3.141592653589793D0/
      CALL ABORTNOW()
C SET FUNCTION TO ZERO
      DO IORBS=1,NORBS                    !!! over iorbs
      DO IUPDN=1,NSPIN                    !!! over iupdn
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
	DO IATOM=1,NATOM                    !!! over iatom
	ISORT=IS(IATOM)
	DO L=0,ILSB(ISORT)                  !!! over l
	DO K=-L,L                           !!! over k
	DO M=-L,L                           !!! over m
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+K+1 !!! (l,k m)
	DSYM(IU,IATOM,IUPDN,IORBS)=(0.D0,0.D0)
      ENDDO                               !!! over m
      ENDDO                               !!! over k
      ENDDO                               !!! over l
      ENDDO                               !!! over iatom
      ENDDO                               !!! over spins
      ENDDO                               !!! over iorbs
C  SYMMETRIZE OVER GROUP
	DO IR=1,NGROUP                      !!! over group
	IG=IKOV(IR)
      DO IORBS=1,NORBS                    !!! over iorbs
      DO IUPDN=1,NSPIN                    !!! over iupdn
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
      DO JORBS=1,NORBS                    !!! over iorbs
      DO JUPDN=1,NSPIN                    !!! over iupdn
	IF(JORBS.EQ.1)THEN
	JSPIN1=JUPDN
	JSPIN =JUPDN
	ELSEIF(JORBS.EQ.2)THEN
	JSPIN1=JUPDN
	JSPIN =NSPIN+1-JUPDN
	ENDIF
	DO IATOM=1,NATOM                    !!! over iatom
	ISORT=IS(IATOM)
	IF(MCRL(IATOM).EQ.0)CYCLE
	DO L=0,ILSB(ISORT)                  !!! over l
	IF(LCRL(L,IATOM).EQ.0)CYCLE
	DO K=-L,L                           !!! over k
	DO M=-L,L                           !!! over m
	IKM=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+K+1     !!! (l,k m)
	DO K1=-L,L                          !!! over k1
	DO M1=-L,L                          !!! over m1
	IKK1=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+K1)+L+K+1   !!! (l,k k1)
	IMM1=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M1)+L+M+1   !!! (l,m m1)
	IK1M1=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M1)+L+K1+1 !!! (l,k1 m1)
C Greens function
      DSYM(IKM,IATOM,IUPDN,IORBS)=DSYM(IKM,IATOM,IUPDN,IORBS)+
     &DCONJG(SJ(ISPIN1,JSPIN1,IR))*SJ(ISPIN,JSPIN,IR)*
     &DCONJG(U(IKK1,IG))*U(IMM1,IG)*
     &DFUN(IK1M1,IP(IATOM,IR),JUPDN,JORBS)
      ENDDO                               !!! over m1
      ENDDO                               !!! over k1
      ENDDO                               !!! over m
      ENDDO                               !!! over k
      ENDDO                               !!! over l
      ENDDO                               !!! over iatom
      ENDDO                               !!! over spins
      ENDDO                               !!! over iorbs
      ENDDO                               !!! over spins
      ENDDO                               !!! over iorbs
	ENDDO                               !!! over group
C NORMALIZE
      DO IORBS=1,NORBS                    !!! over iorbs
      DO IUPDN=1,NSPIN                    !!! over iupdn
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
	DO IATOM=1,NATOM                    !!! over iatom
	ISORT=IS(IATOM)
	IF(MCRL(IATOM).EQ.0)CYCLE
	DO L=0,ILSB(ISORT)                  !!! over l
	IF(LCRL(L,IATOM).EQ.0)CYCLE
	DO K=-L,L                           !!! over k
	DO M=-L,L                           !!! over m
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+K+1 !!! (l,k m)
C Result
      DFUN(IU,IATOM,IUPDN,IORBS)=DSYM(IU,IATOM,IUPDN,IORBS)/
     &DBLE(NGROUP)*FACT                   !!! Nspin/2 cancels prefactor 2/Nspin !!!
      ENDDO                               !!! over m
      ENDDO                               !!! over k
      ENDDO                               !!! over l
      ENDDO                               !!! over iatom
      ENDDO                               !!! over spins
      ENDDO                               !!! over iorbs
C MEMORY DEALLOCATIONS
C none
	END




	SUBROUTINE DMF_GRFERR(KMSC,KEY,ITER)
*****************************************************************
*  Supresses errors by forcing symmetry                         *
*****************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                               !!! from setup
      USE COM_CONTROL ,ONLY: LIFT,LMTO,IDMF                        !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS,ILSB       !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP                        !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN                           !!! from readini
      USE COM_MSBMESH ,ONLY: NMSC                                  !!! from msbmesh
      USE COM_HUBDAT  ,ONLY: MCRL,LCRL,NCLM                        !!! from readhub
      USE COM_DMFDAT  ,ONLY: SIGW,DELW,GLOC                        !!! from grfbnd
      USE COM_CHANNELS,ONLY: IUSGM                                 !!! from channels
      USE COM_MASHDEP ,ONLY: LENCMP                                !!! from setup
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                       !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: DSYM(:,:,:,:)
      DATA PI/3.141592653589793D0/
      CALL ABORTNOW()
C MEMORY ALLOCATIONS
	ALLOCATE(DSYM(LIMB2MEM,NATOMMEM,NSPINMEM,NORBSMEM))
C SET LOOPING LIMITS
	IF(KMSC.EQ.0)LMSC=NMSC
	IF(KMSC.EQ.NMSC+1)LMSC=NMSC+1
C SUPRESS ERRORS BY SYMMETRIZATION
	DO 1000 IMSC=KMSC,LMSC              !!! over Matsubara frequencies
	IREC=0
	DO JMSC=KMSC,LMSC                   !!! over Matsubara frequencies
	DO IATOM=1,NATOM                    !!! over atoms
	ISORT=IS(IATOM)
	IF(MCRL(IATOM).EQ.0)CYCLE
	IREC=IREC+1
	IF(JMSC.NE.IMSC)CYCLE
	IF(JMSC.EQ.NMSC+1)CYCLE
	IUMAX=(ILSB(ISORT)+1)*(2*ILSB(ISORT)+1)*(2*ILSB(ISORT)+3)/3
	READ(IUSGM,REC=IREC)
     &(((SIGW(IU,IATOM,IUPDN,IORBS),IU=1,IUMAX),IUPDN=1,NSPIN),
     &IORBS=1,NORBS),
     &(((DELW(IU,IATOM,IUPDN,IORBS),IU=1,IUMAX),IUPDN=1,NSPIN),
     &IORBS=1,NORBS),
     &(((GLOC(IU,IATOM,IUPDN,IORBS),IU=1,IUMAX),IUPDN=1,NSPIN),
     &IORBS=1,NORBS)
	ENDDO                               !!! over atoms
	ENDDO                               !!! over Matsubara frequencies
	IF(KEY.EQ.0.OR.KEY.EQ.1) ! symmetrize Hybridization
     &CALL DMF_DELGRP(DELW,DSYM,1.D0)
	IF(KEY.EQ.0.OR.KEY.EQ.2) ! symmetrize Self-energy
     &CALL DMF_DELGRP(SIGW,DSYM,1.D0)
C STORE HYBRIDIZATION FUNCTION
	IREC=0
	DO JMSC=KMSC,LMSC                   !!! over Matsubara frequencies
	DO IATOM=1,NATOM                    !!! over atoms
	ISORT=IS(IATOM)
	IF(MCRL(IATOM).EQ.0)CYCLE
	IREC=IREC+1
	IF(JMSC.NE.IMSC)CYCLE
	IF(JMSC.EQ.NMSC+1)CYCLE
	IUMAX=(ILSB(ISORT)+1)*(2*ILSB(ISORT)+1)*(2*ILSB(ISORT)+3)/3
	WRITE(IUSGM,REC=IREC)
     &(((SIGW(IU,IATOM,IUPDN,IORBS),IU=1,IUMAX),IUPDN=1,NSPIN),
     &IORBS=1,NORBS),
     &(((DELW(IU,IATOM,IUPDN,IORBS),IU=1,IUMAX),IUPDN=1,NSPIN),
     &IORBS=1,NORBS),
     &(((GLOC(IU,IATOM,IUPDN,IORBS),IU=1,IUMAX),IUPDN=1,NSPIN),
     &IORBS=1,NORBS)
	ENDDO                               !!! over atoms
	ENDDO                               !!! over Matsubara frequencies
 1000 CONTINUE                            !!! over Matsubara frequencies
C MEMORY DEALLOCATIONS
	DEALLOCATE(DSYM)
	END

