	SUBROUTINE DMF_GRFLEV(KMSC)
*****************************************************************
*  Computes impurity levels and effective overlap matrix        *
*****************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                               !!! from setup
      USE COM_CONTROL ,ONLY: LIFT,LMTO,IASA,IDMF                   !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS,ILSB       !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP                        !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN                           !!! from readini
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC,NBNDH         !!! from readini
      USE COM_MSBMESH ,ONLY: TEMP,NMSC                             !!! from msbmesh
      USE COM_DMFDAT  ,ONLY: OIMP,EIMP                             !!! from grfint
      USE COM_GRFDAT  ,ONLY: GWTS,ECAP,EPOL                        !!! from grfbnd
      USE COM_ENERGY  ,ONLY: ETRT                                  !!! from grfbnd
      USE COM_HUBDAT  ,ONLY: MCRL,LCRL,NCLM                        !!! from readhub
      USE COM_INDORB  ,ONLY: INDDMF                                !!! from lmtpar
      USE COM_SUMPAR  ,ONLY: PHH,PHJ,PJH,PJJ                       !!! from lmtpar
      USE COM_KMESH   ,ONLY: NPNT,PNT,WGT                          !!! from tetra
      USE COM_FERMI   ,ONLY: EF                                    !!! from ttrints
      USE COM_CHANNELS,ONLY: IUHAM,IUCEW                           !!! from channels
      USE COM_MASHDEP ,ONLY: LENCMP                                !!! from setup
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                       !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: AL(:)
	COMPLEX*16, ALLOCATABLE :: AR(:)
	COMPLEX*16, ALLOCATABLE :: BL(:)
	COMPLEX*16, ALLOCATABLE :: BR(:)
	COMPLEX*16, ALLOCATABLE :: CL(:,:,:)
	COMPLEX*16, ALLOCATABLE :: CR(:,:,:)
	COMPLEX*16, ALLOCATABLE :: SL(:,:,:)
	COMPLEX*16, ALLOCATABLE :: SR(:,:,:)
	COMPLEX*16, ALLOCATABLE :: WA(:)
	COMPLEX*16, ALLOCATABLE :: OF(:,:)
	COMPLEX*16, ALLOCATABLE :: ESYM(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: EINV(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: OINV(:,:,:,:)
	COMPLEX*16 ZMSB,PHS,HERM
      DATA PI/3.141592653589793D0/
      CALL ABORTNOW()
C MEMORY ALLOCATIONS
      ALLOCATE(CR(NCLM,NSPINMEM,(NBNDT(1)+NBNDH(1))*NSPINMEM))
      ALLOCATE(CL(NCLM,NSPINMEM,(NBNDT(1)+NBNDH(1))*NSPINMEM))
      ALLOCATE(SR(NCLM,NSPINMEM,(NBNDT(1)+NBNDH(1))*NSPINMEM))
      ALLOCATE(SL(NCLM,NSPINMEM,(NBNDT(1)+NBNDH(1))*NSPINMEM))
      ALLOCATE(AR((NBNDT(1)+NBNDH(1))*NSPINMEM))
      ALLOCATE(AL((NBNDT(1)+NBNDH(1))*NSPINMEM))
      ALLOCATE(BR((NBNDT(1)+NBNDH(1))*NSPINMEM))
      ALLOCATE(BL((NBNDT(1)+NBNDH(1))*NSPINMEM))
	ALLOCATE(WA((NBNDT(1)+NBNDH(1))*NSPINMEM))
	ALLOCATE(ESYM(LIMB2MEM,NATOMMEM,NSPINMEM,NORBSMEM))
	ALLOCATE(EINV(LIMB2MEM,NATOMMEM,NSPINMEM,NORBSMEM))
	ALLOCATE(OINV(LIMB2MEM,NATOMMEM,NSPINMEM,NORBSMEM))
      SIZE_MAT=4.D0*DBLE(SIZE(AL)*LENCMP)/1024.D0**2
      CURMEM=CURMEM+SIZE_MAT
C SET ZEROES
      DO IORBS=1,NORBS                    !!! over iorbs
      DO IUPDN=1,NSPIN                    !!! over iupdn
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
	DO IATOM=1,NATOM                    !!! over iatom
	ISORT=IS(IATOM)
	DO L=0,ILSB(ISORT)                  !!! over l
	DO K=-L,L                           !!! over k
	DO M=-L,L                           !!! over m
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+K+1 !!! (l,k m)
	EINV(IU,IATOM,IUPDN,IORBS)=(0.D0,0.D0)
	OINV(IU,IATOM,IUPDN,IORBS)=(0.D0,0.D0)
      ENDDO                               !!! over m
      ENDDO                               !!! over k
      ENDDO                               !!! over l
      ENDDO                               !!! over iatom
      ENDDO                               !!! over spins
      ENDDO                               !!! over iorbs
C FIND IMPURITY LEVELS AND EFFECTIVE OVERLAP
	DO 3000 IPNT=1,NPNT(1)              !!! over k-points
      IREC=IPNT+NPNT(1)*KMSC
      IF(NORBS.EQ.1)
     &READ(IUCEW,REC=IREC)
     &(((CR(ICLM,IBNDS,IBNDS+NSPIN*(IBNDT-1)),ICLM=1,NCLM),
     &   IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1)),
     &(((CL(ICLM,IBNDS,IBNDS+NSPIN*(IBNDT-1)),ICLM=1,NCLM),
     &   IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1)),
     &(((SR(ICLM,IBNDS,IBNDS+NSPIN*(IBNDT-1)),ICLM=1,NCLM),
     &   IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1)),
     &(((SL(ICLM,IBNDS,IBNDS+NSPIN*(IBNDT-1)),ICLM=1,NCLM),
     &   IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1))
      IF(NORBS.EQ.2)
     &READ(IUCEW,REC=IREC)
     &((((CR(ICLM,IORBS,IBNDS+NSPIN*(IBNDT-1)),ICLM=1,NCLM),
     &IORBS=1,NORBS),IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1)),
     &((((CL(ICLM,IORBS,IBNDS+NSPIN*(IBNDT-1)),ICLM=1,NCLM),
     &IORBS=1,NORBS),IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1)),
     &((((SR(ICLM,IORBS,IBNDS+NSPIN*(IBNDT-1)),ICLM=1,NCLM),
     &IORBS=1,NORBS),IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1)),
     &((((SL(ICLM,IORBS,IBNDS+NSPIN*(IBNDT-1)),ICLM=1,NCLM),
     &IORBS=1,NORBS),IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1))
      DO 2000 IBNDS=1,NSPIN               !!! over spin subbands
      DO 1000 IBNDT=1,NBNDT(1)+NBNDH(1)   !!! over bands
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	DO IORBS=1,NORBS
	IF(NORBS.EQ.1)ISPIN=IBNDS
	IF(NORBS.EQ.2)ISPIN=IORBS
	ICLM=0
	DO IKAP=1,NKAP(1)
	DO IATOM=1,NATOM            !!! over atoms
	ISORT=IS(IATOM)
	IF(MCRL(IATOM).EQ.0)CYCLE
	DO L=0,ILSB(ISORT)          !!! over l
	IF(.NOT.LTPAN(L,IATOM,IKAP,1))CYCLE
	IF(LCRL(L,IATOM).EQ.0)CYCLE
	DO M=-L,L
	LM=L*(L+1)+M+1
	IDIM=INDDMF(LM,IATOM,IKAP,ISPIN)
	ICLM=ICLM+1
	AR(IDIM)=CR(ICLM,ISPIN,IBAND)
	AL(IDIM)=CL(ICLM,ISPIN,IBAND)
	BR(IDIM)=SR(ICLM,ISPIN,IBAND)
	BL(IDIM)=SL(ICLM,ISPIN,IBAND)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
      DO IORBS=1,NORBS                    !!! over iorbs
      DO IUPDN=1,NSPIN                    !!! over iupdn
	IF(NORBS.EQ.1.AND.IUPDN.NE.IBNDS)CYCLE
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
	DO IKAP1=1,NKAP(1)                  !!! over ikap1
	DO IKAP =1,NKAP(1)                  !!! over ikap
	DO IATOM=1,NATOM                    !!! over iatom
	ISORT=IS(IATOM)
	IF(MCRL(IATOM).EQ.0)CYCLE
	DO L=0,ILSB(ISORT)                  !!! over l
	IF(LCRL(L,IATOM).EQ.0)CYCLE
	DO K=-L,L                           !!! over k
	LK=L*(L+1)+K+1
	IDIM1=INDDMF(LK,IATOM,IKAP1,ISPIN1)
	DO M=-L,L                           !!! over m
	LM=L*(L+1)+M+1
	IDIM =INDDMF(LM,IATOM,IKAP ,ISPIN)
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+K+1 !!! (l,k m)
C LMTO Representation
	IF(IASA.EQ.1.OR.IASA.EQ.2)THEN
C Impurity levels
	IF(LTPAN(L,IATOM,IKAP1,1).AND.LTPAN(L,IATOM,IKAP,1))THEN
      EINV(IU,IATOM,IUPDN,IORBS)=EINV(IU,IATOM,IUPDN,IORBS)+
     &AR(IDIM1)*DCONJG(PHH(IKAP1,IKAP,L,ISORT,1,IUPDN,IORBS))*AL(IDIM)*
     &EPOL(IBAND,IPNT,NMSC+1)*WGT(IPNT,1)*GWTS(IBAND,IPNT,L,IATOM)
      EINV(IU,IATOM,IUPDN,IORBS)=EINV(IU,IATOM,IUPDN,IORBS)-
     &AR(IDIM1)*DCONJG(PHJ(IKAP1,IKAP,L,ISORT,1,IUPDN,IORBS))*BL(IDIM)*
     &EPOL(IBAND,IPNT,NMSC+1)*WGT(IPNT,1)*GWTS(IBAND,IPNT,L,IATOM)
      EINV(IU,IATOM,IUPDN,IORBS)=EINV(IU,IATOM,IUPDN,IORBS)-
     &BR(IDIM1)*DCONJG(PJH(IKAP1,IKAP,L,ISORT,1,IUPDN,IORBS))*AL(IDIM)*
     &EPOL(IBAND,IPNT,NMSC+1)*WGT(IPNT,1)*GWTS(IBAND,IPNT,L,IATOM)
      EINV(IU,IATOM,IUPDN,IORBS)=EINV(IU,IATOM,IUPDN,IORBS)+
     &BR(IDIM1)*DCONJG(PJJ(IKAP1,IKAP,L,ISORT,1,IUPDN,IORBS))*BL(IDIM)*
     &EPOL(IBAND,IPNT,NMSC+1)*WGT(IPNT,1)*GWTS(IBAND,IPNT,L,IATOM)
      ENDIF
C Effective overlap
	IF(LTPAN(L,IATOM,IKAP1,1).AND.LTPAN(L,IATOM,IKAP,1))THEN
      OINV(IU,IATOM,IUPDN,IORBS)=OINV(IU,IATOM,IUPDN,IORBS)+
     &AR(IDIM1)*DCONJG(PHH(IKAP1,IKAP,L,ISORT,1,IUPDN,IORBS))*AL(IDIM)*
     &WGT(IPNT,1)*GWTS(IBAND,IPNT,L,IATOM)
      OINV(IU,IATOM,IUPDN,IORBS)=OINV(IU,IATOM,IUPDN,IORBS)-
     &AR(IDIM1)*DCONJG(PHJ(IKAP1,IKAP,L,ISORT,1,IUPDN,IORBS))*BL(IDIM)*
     &WGT(IPNT,1)*GWTS(IBAND,IPNT,L,IATOM)
      OINV(IU,IATOM,IUPDN,IORBS)=OINV(IU,IATOM,IUPDN,IORBS)-
     &BR(IDIM1)*DCONJG(PJH(IKAP1,IKAP,L,ISORT,1,IUPDN,IORBS))*AL(IDIM)*
     &WGT(IPNT,1)*GWTS(IBAND,IPNT,L,IATOM)
      OINV(IU,IATOM,IUPDN,IORBS)=OINV(IU,IATOM,IUPDN,IORBS)+
     &BR(IDIM1)*DCONJG(PJJ(IKAP1,IKAP,L,ISORT,1,IUPDN,IORBS))*BL(IDIM)*
     &WGT(IPNT,1)*GWTS(IBAND,IPNT,L,IATOM)
      ENDIF
C TB Representation
	ELSEIF(IASA.EQ.4)THEN
C Impurity levels
	IF(LTPAN(L,IATOM,IKAP1,1).AND.LTPAN(L,IATOM,IKAP,1))
     &EINV(IU,IATOM,IUPDN,IORBS)=EINV(IU,IATOM,IUPDN,IORBS)+
     &AR(IDIM1)*AL(IDIM)*EPOL(IBAND,IPNT,NMSC+1)*WGT(IPNT,1)*
     &GWTS(IBAND,IPNT,L,IATOM)
C Effective overlap
	IF(LTPAN(L,IATOM,IKAP1,1).AND.LTPAN(L,IATOM,IKAP,1))
     &OINV(IU,IATOM,IUPDN,IORBS)=OINV(IU,IATOM,IUPDN,IORBS)+
     &AR(IDIM1)*AL(IDIM)*WGT(IPNT,1)*
     &GWTS(IBAND,IPNT,L,IATOM)
	ENDIF
      ENDDO                               !!! over m
      ENDDO                               !!! over k
      ENDDO                               !!! over l
      ENDDO                               !!! over iatom
      ENDDO                               !!! over ikap
      ENDDO                               !!! over ikap1
      ENDDO                               !!! over spins
      ENDDO                               !!! over iorbs
1000	CONTINUE                            !!! over bands
2000	CONTINUE                            !!! over spin subbands
3000	CONTINUE                            !!! over k-points
C SYMMETRIZE OVER GROUP
	CALL DMF_GRFGRP(EINV,ESYM,0.5D0)
	CALL DMF_GRFGRP(OINV,ESYM,0.5D0)
C DO NOT ENFORCE HERMITIANNESS
      DO IORBS=1,NORBS                    !!! over iorbs
      DO IUPDN=1,NSPIN                    !!! over iupdn
	IF(IORBS.EQ.1)THEN
	IDNUP=IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	IDNUP=NSPIN-IUPDN+1
	ENDIF
	DO IATOM=1,NATOM                    !!! over iatom
	ISORT=IS(IATOM)
	IF(MCRL(IATOM).EQ.0)CYCLE
	DO L=0,ILSB(ISORT)                  !!! over l
	IF(LCRL(L,IATOM).EQ.0)CYCLE
	DO K=-L,L                           !!! over k
	LK=L*(L+1)+K+1
	DO M=-L,L                           !!! over m
	LM=L*(L+1)+M+1
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+K+1 !!! (l,k m)
	IW=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+K)+L+M+1 !!! (l,k m)
      HERM=0.5D0*(EINV(IU,IATOM,IUPDN,IORBS)+
     &     DCONJG(EINV(IW,IATOM,IDNUP,IORBS)))
C     EINV(IU,IATOM,IUPDN,IORBS)=HERM
C     EINV(IW,IATOM,IDNUP,IORBS)=DCONJG(HERM)
      HERM=0.5D0*(OINV(IU,IATOM,IUPDN,IORBS)+
     &     DCONJG(OINV(IW,IATOM,IDNUP,IORBS)))
C     OINV(IU,IATOM,IUPDN,IORBS)=HERM
C     OINV(IW,IATOM,IDNUP,IORBS)=DCONJG(HERM)
      ENDDO                               !!! over m
      ENDDO                               !!! over k
      ENDDO                               !!! over iupdn
      ENDDO                               !!! over iorbs
      ENDDO                               !!! over l
      ENDDO                               !!! over iatom
C INTEGRATION DONE, NOW THE INVERSION
      NINVS=NSPIN-NORBS+1
	NDIM=(2*L+1)*NSPIN
      IF(MOD(NDIM,NINVS).NE.0)
     &CALL FULLSTOP('<GRFIMP>: error in dimension')
	DO 6000 IATOM=1,NATOM               !!! over atoms
	ISORT=IS(IATOM)
	IF(MCRL(IATOM).EQ.0)CYCLE
	DO 5000 L=0,ILSB(ISORT)             !!! over l
	IF(LCRL(L,IATOM).EQ.0)CYCLE
C MEMORY ALLOCATIONS
      MDIM=(2*L+1)*NSPIN/NINVS
      ALLOCATE(OF(MDIM,MDIM),STAT=IALLOC)
	DO 4000 INVS=1,NINVS                !!! over invs
      MSHF=MDIM*(INVS-1)                   
C PREPARE OVERLAP FUNCTION TO INVERT
      DO IORBS=1,NORBS                    !!! over iorbs
      DO IUPDN=1,NSPIN                    !!! over iupdn
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
	IF(NORBS.EQ.1.AND.IUPDN.NE.INVS)CYCLE
C PREPARE OVERLAP TO INVERT
	DO K=-L,L                           !!! over k
	IDIM1=L+1+K
	DO M=-L,L                           !!! over m
	IDIM=L+1+M
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+K+1 !!! (l,k m)
C Inverse overlap
      OF(IDIM1+(2*L+1)*(ISPIN1-1)-MSHF,IDIM+(2*L+1)*(ISPIN-1)-MSHF)=
     &OINV(IU,IATOM,IUPDN,IORBS)
      ENDDO                               !!! over m
      ENDDO                               !!! over k
      ENDDO                               !!! over iupdn
      ENDDO                               !!! over iorbs
C INVERT OVERLAP
	CALL LIB_CINV(MDIM,OF,MDIM,WA,IFAIL)
	IF(IFAIL.NE.0)
     &CALL FULLSTOP('<HYBFUN>:: Error in inversion program')
      DO IORBS=1,NORBS                    !!! over iorbs
      DO IUPDN=1,NSPIN                    !!! over iupdn
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
	IF(NORBS.EQ.1.AND.IUPDN.NE.INVS)CYCLE
	DO K=-L,L                           !!! over k
	IDIM1=L+1+K
	DO M=-L,L                           !!! over m
	IDIM=L+1+M
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+K+1 !!! (l,k m)
C Inverse Overlap inverse
      OIMP(IU,IATOM,IUPDN,IORBS)=
     &OF(IDIM1+(2*L+1)*(ISPIN1-1)-MSHF,IDIM+(2*L+1)*(ISPIN-1)-MSHF)
      ENDDO                               !!! over m
      ENDDO                               !!! over k
C Set impurities as O*E*O
	DO K=-L,L                           !!! over k
	IDIM1=L+1+K
	DO M=-L,L                           !!! over m
	IDIM=L+1+M
	IKM=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+K+1 !!! (l,k m)
	ESYM(IKM,IATOM,IUPDN,IORBS)=(0.D0,0.D0)
      DO JORBS=1,NORBS                    !!! over jorbs
      DO JUPDN=1,NSPIN                    !!! over jupdn
	IF(JORBS.EQ.1)THEN
	JSPIN1=JUPDN
	JSPIN =JUPDN
	ELSEIF(JORBS.EQ.2)THEN
	JSPIN1=JUPDN
	JSPIN =NSPIN+1-JUPDN
	ENDIF
	IF(NORBS.EQ.1.AND.JUPDN.NE.INVS)CYCLE
	DO I=-L,L                           !!! over i
	JDIM1=L+1+I
	DO J=-L,L                           !!! over j
	JDIM=L+1+J
	IKI=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+I)+L+K+1 !!! (l,k i)
	IIJ=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+J)+L+I+1 !!! (l,i j)
	IJM=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+J+1 !!! (l,j m)
C	ESYM(IKM,IATOM,IUPDN,IORBS)=ESYM(IKM,IATOM,IUPDN,IORBS)+
C    &OIMP(IKI,IATOM,IUPDN,IORBS)*EINV(IIJ,IATOM,JUPDN,JORBS)*
C    &OIMP(IJM,IATOM,IUPDN,IORBS)
	ESYM(IKM,IATOM,IUPDN,IORBS)=ESYM(IKM,IATOM,IUPDN,IORBS)+
     &OF(IDIM1+(2*L+1)*(ISPIN1-1)-MSHF,JDIM1+(2*L+1)*(JSPIN1-1)-MSHF)*
     &EINV(IIJ,IATOM,JUPDN,JORBS)*
     &OF(JDIM+(2*L+1)*(JSPIN-1)-MSHF,IDIM+(2*L+1)*(ISPIN-1)-MSHF)
      ENDDO                               !!! over j
      ENDDO                               !!! over i
      ENDDO                               !!! over jupdn
      ENDDO                               !!! over jorbs
      ENDDO                               !!! over m
      ENDDO                               !!! over k
	DO K=-L,L                           !!! over k
	DO M=-L,L                           !!! over m
	IKM=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+K+1 !!! (l,k m)
      EIMP(IKM,IATOM,IUPDN,IORBS)=ESYM(IKM,IATOM,IUPDN,IORBS)
      ENDDO                               !!! over m
      ENDDO                               !!! over k
      ENDDO                               !!! over iupdn
      ENDDO                               !!! over iorbs
 4000	CONTINUE                            !!! over invs
	DEALLOCATE(OF)
 5000	CONTINUE                            !!! over l
 6000	CONTINUE                            !!! over iatom
C MEMORY DEALLOCATIONS
	DEALLOCATE(AR,AL,BR,BL,CR,CL,WA,ESYM,EINV,OINV)
      CURMEM=CURMEM-SIZE_MAT
	END
