	SUBROUTINE DMF_GRFLOC(KMSC)
*****************************************************************
*  Computes local Greens functionm using LMTO representation    *
*****************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                               !!! from setup
      USE COM_CONTROL ,ONLY: LIFT,LMTO,IASA,IDMF                   !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS,ILSB       !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP                        !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN                           !!! from readini
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC,NBNDH,POLUS   !!! from readini
      USE COM_MSBMESH ,ONLY: TEMP,NMSC,WMSC,FMSC                   !!! from msbmesh
      USE COM_DMFDAT  ,ONLY: SIGW,DELW,GLOC,OIMP,EIMP              !!! from grfloc
      USE COM_ENERGY  ,ONLY: WTRT                                  !!! from grfbnd
      USE COM_GRFDAT  ,ONLY: EPOL,EPOW,ECAP,GWGT,GWTS,GW0T         !!! from grfbnd
      USE COM_HUBDAT  ,ONLY: MCRL,LCRL,NCLM,KSUM,GDMP              !!! from readhub
      USE COM_INDORB  ,ONLY: INDDMF                                !!! from lmtpar
      USE COM_SUMPAR  ,ONLY: PHH,PHJ,PJH,PJJ                       !!! from lmtpar
      USE COM_WMESH   ,ONLY: NPNW,PNW                              !!! from tetra
      USE COM_KMESH   ,ONLY: NPNT,PNT,WGT                          !!! from tetra
      USE COM_FERMI   ,ONLY: EF                                    !!! from ttrints
      USE COM_CHANNELS,ONLY: IUCEW,IUSGM                           !!! from channels
      USE COM_MASHDEP ,ONLY: LENCMP                                !!! from setup
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                       !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: AL(:)
	COMPLEX*16, ALLOCATABLE :: AR(:)
	COMPLEX*16, ALLOCATABLE :: BL(:)
	COMPLEX*16, ALLOCATABLE :: BR(:)
	COMPLEX*16, ALLOCATABLE :: CL(:,:,:)
	COMPLEX*16, ALLOCATABLE :: CR(:,:,:)
	COMPLEX*16, ALLOCATABLE :: SL(:,:,:)
	COMPLEX*16, ALLOCATABLE :: SR(:,:,:)
	COMPLEX*16, ALLOCATABLE :: GSYM(:,:,:,:)
	COMPLEX*16 ZMSC,ZOMG,WHT,WGF,WMEK,WFAC  
	SAVE ZTOT
      DATA PI/3.141592653589793D0/
      CALL ABORTNOW()
C MEMORY ALLOCATIONS
      ALLOCATE(CR(NCLM,NSPINMEM,(NBNDT(1)+NBNDH(1))*NSPINMEM))
      ALLOCATE(CL(NCLM,NSPINMEM,(NBNDT(1)+NBNDH(1))*NSPINMEM))
      ALLOCATE(SR(NCLM,NSPINMEM,(NBNDT(1)+NBNDH(1))*NSPINMEM))
      ALLOCATE(SL(NCLM,NSPINMEM,(NBNDT(1)+NBNDH(1))*NSPINMEM))
      ALLOCATE(AR((NBNDT(1)+NBNDH(1))*NSPINMEM))
      ALLOCATE(AL((NBNDT(1)+NBNDH(1))*NSPINMEM))
      ALLOCATE(BR((NBNDT(1)+NBNDH(1))*NSPINMEM))
      ALLOCATE(BL((NBNDT(1)+NBNDH(1))*NSPINMEM))
	ALLOCATE(GSYM(LIMB2MEM,NATOMMEM,NSPINMEM,NORBSMEM))
      SIZE_MAT=4.D0*DBLE(SIZE(AL)*LENCMP)/1024.D0**2
      CURMEM=CURMEM+SIZE_MAT
C DO GLOBALLY OVER FREQUENCIES
      DO 4000 IMSC=0,NMSC+1               !!! over frequencies
	IF(IMSC.NE.NMSC+1)ZMSC=WMSC(IMSC)
	IF(IMSC.EQ.NMSC+1)ZMSC=(0.D0,0.D0)
C     DUMP=+ABS(GDMP)
	DUMP=0.D0      ! dumping applied inside the Hamiltonian !
C SET GREEN FUNCTION TO ZERO
      DO IORBS=1,NORBS                    !!! over iorbs
      DO IUPDN=1,NSPIN                    !!! over iupdn
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
	DO IATOM=1,NATOM                    !!! over iatom
	ISORT=IS(IATOM)
	DO L=0,ILSB(ISORT)                  !!! over l
	DO K=-L,L                           !!! over k
	DO M=-L,L                           !!! over m
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+K+1 !!! (l,k m)
C Greens function
	GLOC(IU,IATOM,IUPDN,IORBS)=(0.D0,0.D0)
      ENDDO                               !!! over m
      ENDDO                               !!! over k
      ENDDO                               !!! over l
      ENDDO                               !!! over iatom
      ENDDO                               !!! over spins
      ENDDO                               !!! over iorbs
C FIND GREEN FUNCTION AND DENSITY MATRIX
	DO 3000 IPNT=1,NPNT(1)              !!! over k-points
	IREC=IPNT+NPNT(1)*IMSC              !!! read current eighevector
	IF(KMSC.EQ.0)IREC=IPNT              !!! read the same eighevector
      IF(NORBS.EQ.1)
     &READ(IUCEW,REC=IREC)
     &(((CR(ICLM,IBNDS,IBNDS+NSPIN*(IBNDT-1)),ICLM=1,NCLM),
     &   IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1)),
     &(((CL(ICLM,IBNDS,IBNDS+NSPIN*(IBNDT-1)),ICLM=1,NCLM),
     &   IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1)),
     &(((SR(ICLM,IBNDS,IBNDS+NSPIN*(IBNDT-1)),ICLM=1,NCLM),
     &   IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1)),
     &(((SL(ICLM,IBNDS,IBNDS+NSPIN*(IBNDT-1)),ICLM=1,NCLM),
     &   IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1))
      IF(NORBS.EQ.2)
     &READ(IUCEW,REC=IREC)
     &((((CR(ICLM,IORBS,IBNDS+NSPIN*(IBNDT-1)),ICLM=1,NCLM),
     &IORBS=1,NORBS),IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1)),
     &((((CL(ICLM,IORBS,IBNDS+NSPIN*(IBNDT-1)),ICLM=1,NCLM),
     &IORBS=1,NORBS),IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1)),
     &((((SR(ICLM,IORBS,IBNDS+NSPIN*(IBNDT-1)),ICLM=1,NCLM),
     &IORBS=1,NORBS),IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1)),
     &((((SL(ICLM,IORBS,IBNDS+NSPIN*(IBNDT-1)),ICLM=1,NCLM),
     &IORBS=1,NORBS),IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1))
      DO 2000 IBNDS=1,NSPIN               !!! over spin subbands
      DO 1000 IBNDT=1,NBNDT(1)+NBNDH(1)   !!! over bands
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	DO IORBS=1,NORBS
	IF(NORBS.EQ.1)ISPIN=IBNDS
	IF(NORBS.EQ.2)ISPIN=IORBS
	ICLM=0
	DO IKAP=1,NKAP(1)
	DO IATOM=1,NATOM            !!! over atoms
	ISORT=IS(IATOM)
	IF(MCRL(IATOM).EQ.0)CYCLE
	DO L=0,ILSB(ISORT)          !!! over l
	IF(.NOT.LTPAN(L,IATOM,IKAP,1))CYCLE
	IF(LCRL(L,IATOM).EQ.0)CYCLE
	DO M=-L,L
	LM=L*(L+1)+M+1
	IDIM=INDDMF(LM,IATOM,IKAP,ISPIN)
	ICLM=ICLM+1
	AR(IDIM)=CR(ICLM,ISPIN,IBAND)
	AL(IDIM)=CL(ICLM,ISPIN,IBAND)
	BR(IDIM)=SR(ICLM,ISPIN,IBAND)
	BL(IDIM)=SL(ICLM,ISPIN,IBAND)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
      DO IORBS=1,NORBS                    !!! over iorbs
      DO IUPDN=1,NSPIN                    !!! over iupdn
	IF(NORBS.EQ.1.AND.IUPDN.NE.IBNDS)CYCLE
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
	DO IKAP1=1,NKAP(1)                  !!! over ikap1
	DO IKAP =1,NKAP(1)                  !!! over ikap
	DO IATOM=1,NATOM                    !!! over iatom
	ISORT=IS(IATOM)
	IF(MCRL(IATOM).EQ.0)CYCLE
	DO L=0,ILSB(ISORT)                  !!! over l
	IF(LCRL(L,IATOM).EQ.0)CYCLE
C Set weight for the Green function
      WGF=(0.D0,0.D0)
      IF(KSUM.EQ.0.AND.IMSC.NE.NMSC+1)THEN
      WGF=GWGT(IBAND,IPNT,IMSC)*GWTS(IBAND,IPNT,L,IATOM)
      ELSEIF(KSUM.EQ.1.AND.IMSC.NE.NMSC+1)THEN
      ZOMG=ZMSC+DCMPLX(0.D0,DUMP)-
     &EPOL(IBAND,IPNT,IMSC)+DCMPLX(EF,0.D0)
      IF(ABS(ZOMG).LE.1.D-10)ZOMG=DCMPLX(1.D-10,0.D0)
      WGF=WGT(IPNT,1)/DBLE(NSPIN)/ZOMG*GWTS(IBAND,IPNT,L,IATOM)
      ENDIF      
	DO K=-L,L                           !!! over k
	LK=L*(L+1)+K+1
	IDIM1=INDDMF(LK,IATOM,IKAP1,ISPIN1)
	DO M=-L,L                           !!! over m
	LM=L*(L+1)+M+1
	IDIM =INDDMF(LM,IATOM,IKAP ,ISPIN)
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+K+1 !!! (l,k m)
	IF(IASA.EQ.1.OR.IASA.EQ.2)THEN      !!! LMTO representation
C Greens function using LMTO representation
	IF(LTPAN(L,IATOM,IKAP1,1).AND.LTPAN(L,IATOM,IKAP,1))THEN
      GLOC(IU,IATOM,IUPDN,IORBS)=GLOC(IU,IATOM,IUPDN,IORBS)+WGF*
     &AR(IDIM1)*DCONJG(PHH(IKAP1,IKAP,L,ISORT,1,IUPDN,IORBS))*AL(IDIM)
      GLOC(IU,IATOM,IUPDN,IORBS)=GLOC(IU,IATOM,IUPDN,IORBS)-WGF*
     &AR(IDIM1)*DCONJG(PHJ(IKAP1,IKAP,L,ISORT,1,IUPDN,IORBS))*BL(IDIM)
      GLOC(IU,IATOM,IUPDN,IORBS)=GLOC(IU,IATOM,IUPDN,IORBS)-WGF*
     &BR(IDIM1)*DCONJG(PJH(IKAP1,IKAP,L,ISORT,1,IUPDN,IORBS))*AL(IDIM)
      GLOC(IU,IATOM,IUPDN,IORBS)=GLOC(IU,IATOM,IUPDN,IORBS)+WGF*
     &BR(IDIM1)*DCONJG(PJJ(IKAP1,IKAP,L,ISORT,1,IUPDN,IORBS))*BL(IDIM)
      ENDIF
	ELSEIF(IASA.EQ.4)THEN               !!! TB representation
C Greens function using TB representation
	IF(LTPAN(L,IATOM,IKAP1,1).AND.LTPAN(L,IATOM,IKAP,1))
     &GLOC(IU,IATOM,IUPDN,IORBS)=GLOC(IU,IATOM,IUPDN,IORBS)+WGF*
     &AR(IDIM1)*AL(IDIM)
	ENDIF                               !!! over representations
      ENDDO                               !!! over m
      ENDDO                               !!! over k
      ENDDO                               !!! over l
      ENDDO                               !!! over iatom
      ENDDO                               !!! over ikap
      ENDDO                               !!! over ikap1
      ENDDO                               !!! over spins
      ENDDO                               !!! over iorbs
1000	CONTINUE                            !!! over bands
2000	CONTINUE                            !!! over spin subbands
3000	CONTINUE                            !!! over k-points
C SYMMETRIZE OVER GROUP
	CALL DMF_GRFGRP(GLOC,GSYM,DBLE(NSPIN)/2.D0)
C STORE LOCAL GREEN FUNCTION
	IREC=0
	DO JMSC=0,NMSC                      !!! over frequencies
	DO IATOM=1,NATOM                    !!! over atoms
	ISORT=IS(IATOM)
	IF(MCRL(IATOM).EQ.0)CYCLE
	IREC=IREC+1
	IF(JMSC.NE.IMSC)CYCLE
	IUMAX=(ILSB(ISORT)+1)*(2*ILSB(ISORT)+1)*(2*ILSB(ISORT)+3)/3
	READ(IUSGM,REC=IREC)
     &(((SIGW(IU,IATOM,IUPDN,IORBS),IU=1,IUMAX),IUPDN=1,NSPIN),
     &IORBS=1,NORBS),
     &(((DELW(IU,IATOM,IUPDN,IORBS),IU=1,IUMAX),IUPDN=1,NSPIN),
     &IORBS=1,NORBS)
	WRITE(IUSGM,REC=IREC)
     &(((SIGW(IU,IATOM,IUPDN,IORBS),IU=1,IUMAX),IUPDN=1,NSPIN),
     &IORBS=1,NORBS),
     &(((DELW(IU,IATOM,IUPDN,IORBS),IU=1,IUMAX),IUPDN=1,NSPIN),
     &IORBS=1,NORBS),
     &(((GLOC(IU,IATOM,IUPDN,IORBS),IU=1,IUMAX),IUPDN=1,NSPIN),
     &IORBS=1,NORBS)
	ENDDO                               !!! over atoms
	ENDDO                               !!! over frequencies
 4000 CONTINUE                            !!! over frequencies
C MEMORY DEALLOCATIONS
	DEALLOCATE(AR,AL,BR,BL,CR,CL,SR,SL,GSYM)
      CURMEM=CURMEM-SIZE_MAT
	END
