	SUBROUTINE DMF_GRFWGT(KMSC)
******************************************************
* Finds weights for local Green function calculation *
******************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                          !!! from setup
      USE COM_CONTROL ,ONLY: LIFT,LMTO,IASA,IDMF              !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS       !!! from readini
     &                      ,ILST,ILSB,ILSV,LRTV,NHSORT
      USE COM_LATPAR  ,ONLY: PAR,ORTH,OMEGAC                  !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP                   !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN,IATS,ISTS            !!! from readini
      USE COM_HUBDAT  ,ONLY: NHUB,MCRL,LCRL,NCLM              !!! from readhub
      USE COM_SPHERE  ,ONLY: SMT,SWZ                          !!! from readini
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC,NBNDH    !!! from readini
      USE COM_MSBMESH ,ONLY: TEMP,NMSC                        !!! from msbmesh
      USE COM_INPTTR  ,ONLY: TFERMI                           !!! from readini
      USE COM_INPTTR  ,ONLY: NDIV,NDIC,NDIW                   !!! from readstr
      USE COM_KMESH   ,ONLY: NPNT,PNT,WGT                     !!! from tetra
      USE COM_INDORB  ,ONLY: INDDMF                           !!! from lmtpar
      USE COM_FERMI   ,ONLY: EF                               !!! from ttrints
      USE COM_SUMPAR  ,ONLY: PHH,PHJ,PJH,PJJ                  !!! from lmtpar
	USE COM_ENERGY  ,ONLY: ETRT,ETRW,WTRT,WDRT              !!! from grfbnd
      USE COM_GRFDAT  ,ONLY: GWTS                             !!! from grfbnd
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT,IUI                  !!! from setup
      USE COM_CHANNELS,ONLY: IUAIN,IUDOS,IUCEW                !!! from channels
      USE COM_MASHDEP ,ONLY: NVAL,LENCMP                      !!! from setup
      USE COM_LMTOUT                                          !!! from readini
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER*4, ALLOCATABLE :: LOOP(:,:)
	REAL*8, ALLOCATABLE :: DLEV(:,:,:)
	REAL*8, ALLOCATABLE :: FLEV(:,:,:)
	COMPLEX*16, ALLOCATABLE :: AL(:)
	COMPLEX*16, ALLOCATABLE :: AR(:)
	COMPLEX*16, ALLOCATABLE :: BL(:)
	COMPLEX*16, ALLOCATABLE :: BR(:)
	COMPLEX*16, ALLOCATABLE :: CL(:,:,:)
	COMPLEX*16, ALLOCATABLE :: CR(:,:,:)
	COMPLEX*16, ALLOCATABLE :: SL(:,:,:)
	COMPLEX*16, ALLOCATABLE :: SR(:,:,:)
	LOGICAL EXIST,OPEN
	DATA ITERMAX/100/,ACCU/1.D-04/,BROAD/0.1D0/
C MEMORY ALLOCATIONS
	ALLOCATE(LOOP(0:LMAXBMEM,NSORTMEM))
	ALLOCATE(FLEV(0:LMAXBMEM,NSORTMEM,0:2))
	ALLOCATE(DLEV(0:LMAXBMEM,NSORTMEM,0:2))
      ALLOCATE(CR(NCLM,NSPINMEM,(NBNDT(1)+NBNDH(1))*NSPINMEM))
      ALLOCATE(CL(NCLM,NSPINMEM,(NBNDT(1)+NBNDH(1))*NSPINMEM))
      ALLOCATE(SR(NCLM,NSPINMEM,(NBNDT(1)+NBNDH(1))*NSPINMEM))
      ALLOCATE(SL(NCLM,NSPINMEM,(NBNDT(1)+NBNDH(1))*NSPINMEM))
      ALLOCATE(AR((NBNDT(1)+NBNDH(1))*NSPINMEM))
      ALLOCATE(AL((NBNDT(1)+NBNDH(1))*NSPINMEM))
      ALLOCATE(BR((NBNDT(1)+NBNDH(1))*NSPINMEM))
      ALLOCATE(BL((NBNDT(1)+NBNDH(1))*NSPINMEM))
C FIND LIMITS
	EMIN=+1.D+15
	EMAX=-1.D+15
	DO IPNT=1,NPNT(1)
      DO IBNDS=1,NSPIN
      DO IBNDT=1,NBNDT(1)+NBNDH(1)
	EMIN=MIN(ETRT(IBNDS+NSPIN*(IBNDT-1),IPNT,1),EMIN)
	EMAX=MAX(ETRT(IBNDS+NSPIN*(IBNDT-1),IPNT,1),EMAX)
	ENDDO
	ENDDO
	ENDDO
	EMIN=EMIN-1.D-04-10.D0*TEMP
	EMAX=EMAX+1.D-04+10.D0*TEMP
C FOR CORRELATED STATES INTEGRATE PARTIAL NUMBERS OF STATES AND 
C FIND FICTIOUS FERMI LEVELS SATISFYING NORMALIZATION CONDITION Z=2*(2l+1)
	DO ISORT=1,NSORT
	DO L=0,ILSB(ISORT)
	LOOP(L,ISORT)=1
	ENDDO
	ENDDO
C START ITERATIVE SEARCH
	DO 4000 ITER=1,ITERMAX      !!! over iterations
C Find approximation to the fictious Fermi levels
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	IF(MCRL(IATOM).EQ.0)CYCLE
	DO L=0,ILSB(ISORT)
	IF(LCRL(L,IATOM).EQ.0)CYCLE
	IF(LOOP(L,ISORT).EQ.0)CYCLE
	IF(ITER.EQ.1)THEN
	FLEV(L,ISORT,0)=EMIN
	ELSEIF(ITER.EQ.2)THEN
	FLEV(L,ISORT,0)=EMAX
	ELSEIF(ITER.GT.2)THEN
C  DEFINE ROOT BY LINEAR INTERPOLATION
      IF(DLEV(L,ISORT,0)*DLEV(L,ISORT,2).GE.0.D0)THEN
	FLEV(L,ISORT,2)=FLEV(L,ISORT,0)
	DLEV(L,ISORT,2)=DLEV(L,ISORT,0)
	ELSEIF(DLEV(L,ISORT,0)*DLEV(L,ISORT,1).GE.0.D0)THEN
	FLEV(L,ISORT,1)=FLEV(L,ISORT,0)
	DLEV(L,ISORT,1)=DLEV(L,ISORT,0)
	ENDIF
	E=(DLEV(L,ISORT,1)*FLEV(L,ISORT,2)-DLEV(L,ISORT,2)*
     &FLEV(L,ISORT,1))/(DLEV(L,ISORT,1)-DLEV(L,ISORT,2))
C  CHECK FOR CONVERGENCY
	IF(ABS(E-FLEV(L,ISORT,0)).GT.ACCU)LOOP(L,ISORT)=1
	IF(ABS(E-FLEV(L,ISORT,0)).LE.ACCU)LOOP(L,ISORT)=0
	FLEV(L,ISORT,0)=E
	ENDIF
	ENDDO
	ENDDO
C Find integration weights for current Fermi levels
	DO IATOM=1,NATOM
	IF(MCRL(IATOM).EQ.0)CYCLE
	ISORT=IS(IATOM)
	DO L=0,ILSB(ISORT)
	IF(LCRL(L,IATOM).EQ.0)CYCLE
	IF(LOOP(L,ISORT).EQ.0)CYCLE
	CALL DMF_TTRINT(FLEV(L,ISORT,0),NMSC+1,(0.D0,0.D0),TOS,DOS,1,1,0)
	DO IPNT=1,NPNT(1)
      DO IBNDS=1,NSPIN
      DO IBNDT=1,NBNDT(1)+NBNDH(1)
      IBAND=IBNDS+NSPIN*(IBNDT-1)
	GWTS(IBAND,IPNT,L,IATOM)=WTRT(IBAND,IPNT)/WGT(IPNT,1)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C Sum over BZ, find occupations for correlated states
	DO ISORT=1,NSORT
	DO L=0,ILSB(ISORT)
	DLEV(L,ISORT,0)=0.D0
	ENDDO
	ENDDO
	DO 3000 IPNT=1,NPNT(1)              !!! over k-points
      IREC=IPNT+NPNT(1)*KMSC
      IF(NORBS.EQ.1)
     &READ(IUCEW,REC=IREC)
     &(((CR(ICLM,IBNDS,IBNDS+NSPIN*(IBNDT-1)),ICLM=1,NCLM),
     &   IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1)),
     &(((CL(ICLM,IBNDS,IBNDS+NSPIN*(IBNDT-1)),ICLM=1,NCLM),
     &   IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1)),
     &(((SR(ICLM,IBNDS,IBNDS+NSPIN*(IBNDT-1)),ICLM=1,NCLM),
     &   IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1)),
     &(((SL(ICLM,IBNDS,IBNDS+NSPIN*(IBNDT-1)),ICLM=1,NCLM),
     &   IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1))
      IF(NORBS.EQ.2)
     &READ(IUCEW,REC=IREC)
     &((((CR(ICLM,IORBS,IBNDS+NSPIN*(IBNDT-1)),ICLM=1,NCLM),
     &IORBS=1,NORBS),IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1)),
     &((((CL(ICLM,IORBS,IBNDS+NSPIN*(IBNDT-1)),ICLM=1,NCLM),
     &IORBS=1,NORBS),IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1)),
     &((((SR(ICLM,IORBS,IBNDS+NSPIN*(IBNDT-1)),ICLM=1,NCLM),
     &IORBS=1,NORBS),IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1)),
     &((((SL(ICLM,IORBS,IBNDS+NSPIN*(IBNDT-1)),ICLM=1,NCLM),
     &IORBS=1,NORBS),IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1))
      DO 2000 IBNDS=1,NSPIN               !!! over spin subbands
      DO 1000 IBNDT=1,NBNDT(1)+NBNDH(1)   !!! over bands
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	DO IORBS=1,NORBS
	IF(NORBS.EQ.1)ISPIN=IBNDS
	IF(NORBS.EQ.2)ISPIN=IORBS
	ICLM=0
	DO IKAP=1,NKAP(1)
	DO IATOM=1,NATOM            !!! over atoms
	ISORT=IS(IATOM)
	IF(MCRL(IATOM).EQ.0)CYCLE
	DO L=0,ILSB(ISORT)          !!! over l
	IF(.NOT.LTPAN(L,IATOM,IKAP,1))CYCLE
	IF(LCRL(L,IATOM).EQ.0)CYCLE
	DO M=-L,L
	LM=L*(L+1)+M+1
	IDIM=INDDMF(LM,IATOM,IKAP,ISPIN)
	ICLM=ICLM+1
	AR(IDIM)=CR(ICLM,ISPIN,IBAND)
	AL(IDIM)=CL(ICLM,ISPIN,IBAND)
	BR(IDIM)=SR(ICLM,ISPIN,IBAND)
	BL(IDIM)=SL(ICLM,ISPIN,IBAND)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
      DO IORBS=1,NORBS                    !!! over iorbs
      DO IUPDN=1,NSPIN                    !!! over iupdn
	IF(NORBS.EQ.1.AND.IUPDN.NE.IBNDS)CYCLE
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
	DO IKAP1=1,NKAP(1)                  !!! over ikap1
	DO IKAP=1,NKAP(1)                   !!! over ikap
	DO IATOM=1,NATOM                    !!! over iatom
	ISORT=IS(IATOM)
	IF(MCRL(IATOM).EQ.0)CYCLE
	DO L=0,ILSB(ISORT)                  !!! over l
	IF(LCRL(L,IATOM).EQ.0)CYCLE
	DO K=-L,L                           !!! over k
	LK=L*(L+1)+K+1
	IDIM1=INDDMF(LK,IATOM,IKAP1,ISPIN1)
	DO M=-L,L                           !!! over m
	LM=L*(L+1)+M+1
	IDIM =INDDMF(LM,IATOM,IKAP ,ISPIN)
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+K+1 !!! (l,k m)
	IF(K.NE.M)CYCLE                     !!! skip off-diagonals
C LMTO calculation
	IF(IASA.EQ.1.OR.IASA.EQ.2)THEN
	IF(LTPAN(L,IATOM,IKAP1,1).AND.LTPAN(L,IATOM,IKAP,1))THEN
      DLEV(L,ISORT,0)=DLEV(L,ISORT,0)+
     &AR(IDIM1)*DCONJG(PHH(IKAP1,IKAP,L,ISORT,1,IUPDN,IORBS))*AL(IDIM)*
     &GWTS(IBAND,IPNT,L,IATOM)*WGT(IPNT,1)
      DLEV(L,ISORT,0)=DLEV(L,ISORT,0)-
     &AR(IDIM1)*DCONJG(PHJ(IKAP1,IKAP,L,ISORT,1,IUPDN,IORBS))*BL(IDIM)*
     &GWTS(IBAND,IPNT,L,IATOM)*WGT(IPNT,1)
      DLEV(L,ISORT,0)=DLEV(L,ISORT,0)-
     &BR(IDIM1)*DCONJG(PJH(IKAP1,IKAP,L,ISORT,1,IUPDN,IORBS))*AL(IDIM)*
     &GWTS(IBAND,IPNT,L,IATOM)*WGT(IPNT,1)
      DLEV(L,ISORT,0)=DLEV(L,ISORT,0)+
     &BR(IDIM1)*DCONJG(PJJ(IKAP1,IKAP,L,ISORT,1,IUPDN,IORBS))*BL(IDIM)*
     &GWTS(IBAND,IPNT,L,IATOM)*WGT(IPNT,1)
      ENDIF
C Tight-binding calculation
	ELSEIF(IASA.EQ.4)THEN
	IF(LTPAN(L,IATOM,IKAP1,1).AND.LTPAN(L,IATOM,IKAP,1))
     &DLEV(L,ISORT,0)=DLEV(L,ISORT,0)+AR(IDIM1)*AL(IDIM)*WGT(IPNT,1)*
     &GWTS(IBAND,IPNT,L,IATOM)
	ENDIF
      ENDDO                               !!! over m
      ENDDO                               !!! over k
      ENDDO                               !!! over l
      ENDDO                               !!! over iatom
      ENDDO                               !!! over ikap
      ENDDO                               !!! over ikap1
      ENDDO                               !!! over spins
      ENDDO                               !!! over iorbs
 1000	CONTINUE                            !!! over bands
 2000	CONTINUE                            !!! over spin subbands
 3000	CONTINUE                            !!! over k-points
C RENORMALIZE
	IEXIT=1
	DO ISORT=1,NSORT
	DO L=0,ILSB(ISORT)
	IF(LOOP(L,ISORT).EQ.0)CYCLE
	DLEV(L,ISORT,0)=DLEV(L,ISORT,0)/DBLE(NHSORT(ISORT))
     &               -2.D0*DBLE(2*L+1)
	IF(ITER.EQ.1)THEN
	DLEV(L,ISORT,1)=DLEV(L,ISORT,0)
	FLEV(L,ISORT,1)=FLEV(L,ISORT,0)
	ELSEIF(ITER.EQ.2)THEN
	DLEV(L,ISORT,2)=DLEV(L,ISORT,0)
	FLEV(L,ISORT,2)=FLEV(L,ISORT,0)
	IF(DLEV(L,ISORT,0).LE.0.D0)LOOP(L,ISORT)=0
	ENDIF
	IF(LOOP(L,ISORT).NE.0)IEXIT=0
	ENDDO
	ENDDO
	IF(IEXIT.EQ.1)GOTO 5000
 4000	CONTINUE                    !!! over iterations
C SMEAR OUT THE WEIGHTS BY GAUSSIAN BROADENING
 5000	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	IF(MCRL(IATOM).EQ.0)CYCLE
	DO L=0,ILSB(ISORT)
	IF(LCRL(L,IATOM).EQ.0)CYCLE
	IF(FLEV(L,ISORT,0).LE.EF+5.D0*BROAD)FLEV(L,ISORT,0)=EF+5.D0*BROAD
	IF(FLEV(L,ISORT,0).GE.EMAX)FLEV(L,ISORT,0)=EMAX+5.D0*BROAD
	DO IPNT=1,NPNT(1)
      DO IBNDS=1,NSPIN
      DO IBNDT=1,NBNDT(1)+NBNDH(1)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	XX=(ETRT(IBAND,IPNT,1)-FLEV(L,ISORT,0))/BROAD
      GWTS(IBAND,IPNT,L,IATOM)=0.5D0*(1.D0-ERF(XX))
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C MEMORY DEALLOCATIONS
	DEALLOCATE(DLEV,FLEV,LOOP,AR,AL,BR,BL,CR,CL,SL,SR)
	END SUBROUTINE DMF_GRFWGT
