	SUBROUTINE DMF_IMPHYB
*********************************************************
*  Subroutine solves Anderson impurity model for given  *
*  hybridization function Delta(iWn)                    *
*********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                               !!! from setup
      USE COM_CONTROL ,ONLY: LIFT,LMTO,IDMF                        !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS,ILSB       !!! from readini
      USE COM_MSBMESH ,ONLY: TEMP,NMSC,WMSC                        !!! from readhub
      USE COM_DMFDAT  ,ONLY: SIGW,DELW,DELI,SIGI,SIG0,BMAS
     &                      ,OIMP,EIMP,ELOC,AINV,ALAM,GLOC         !!! from grfbnd
      USE COM_HUBCOM  ,ONLY: DHUB,VDBC                             !!! from readhub
      USE COM_HUBDAT  ,ONLY: MCRL,LCRL,KHRM,KSOLVER,KFIXSIG        !!! from readhub
      USE COM_FERMI   ,ONLY: EF                                    !!! from ttrints
	USE COM_RATDAT  ,ONLY: VRAT,WRAT,PRAT,ORAT                   !!! from readhub
     &                      ,VRHB,WRHB,PRHB,ORHB                   !!! from readhub
      USE COM_HUBSYS  ,ONLY: ROUTAXE,ROUTANG,ROUTINV               !!! from readhub
	USE COM_IMPDAT  ,ONLY: KCRDSYS,NPOLIMP,NPLDIMP,DSYS,RSYS     !!! from readhub
     &                      ,NRUNIMP,KSTATES
      USE COM_LMTOUT  ,ONLY: SCRFILE                               !!! from readini
      USE COM_CHANNELS,ONLY: IUSGM,IUBIM                           !!! from channels
      USE COM_MASHDEP ,ONLY: NVAL,LENCMP                           !!! from setup
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                       !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
C
      INTEGER, ALLOCATABLE :: KST(:,:)
C
	REAL*8, ALLOCATABLE :: TREL(:,:)
	COMPLEX*16, ALLOCATABLE :: SIGWMAT(:,:,:)
	COMPLEX*16, ALLOCATABLE :: DELWMAT(:,:,:)
	COMPLEX*16, ALLOCATABLE :: GLOCMAT(:,:,:)
	COMPLEX*16, ALLOCATABLE :: VDBCMAT(:,:)
	COMPLEX*16, ALLOCATABLE :: SIGIMAT(:,:)
	COMPLEX*16, ALLOCATABLE :: SIG0MAT(:,:)
	COMPLEX*16, ALLOCATABLE :: DELIMAT(:,:)
	COMPLEX*16, ALLOCATABLE :: BMASMAT(:,:)
	COMPLEX*16, ALLOCATABLE :: EIMPMAT(:,:)
	COMPLEX*16, ALLOCATABLE :: ELOCMAT(:,:)
	COMPLEX*16, ALLOCATABLE :: OIMPMAT(:,:)
	COMPLEX*16, ALLOCATABLE :: DHUBMAT(:,:)
	COMPLEX*16, ALLOCATABLE :: G0M1MAT(:,:)
	COMPLEX*16, ALLOCATABLE :: VRATMAT(:,:,:)
	COMPLEX*16, ALLOCATABLE :: WRATMAT(:,:,:)
	COMPLEX*16, ALLOCATABLE :: PRATMAT(:,:,:)
	COMPLEX*16, ALLOCATABLE :: ORATMAT(:,:,:)
	COMPLEX*16, ALLOCATABLE :: VRHBMAT(:,:,:)
	COMPLEX*16, ALLOCATABLE :: WRHBMAT(:,:,:)
	COMPLEX*16, ALLOCATABLE :: PRHBMAT(:,:,:)
	COMPLEX*16, ALLOCATABLE :: ORHBMAT(:,:,:)
	COMPLEX*16, ALLOCATABLE :: ETRAMAT(:,:)
	COMPLEX*16, ALLOCATABLE :: OTRAMAT(:,:)
	COMPLEX*16, ALLOCATABLE :: WORK(:)
	COMPLEX*16, ALLOCATABLE :: DEL(:)
	COMPLEX*16, ALLOCATABLE :: SIG(:)
	COMPLEX*16, ALLOCATABLE :: GFF(:)
      COMPLEX*16, ALLOCATABLE :: ULR(:)
      COMPLEX*16, ALLOCATABLE :: UJR(:,:)
C Local Global systems
	COMPLEX*16, ALLOCATABLE :: SIGWGLO(:,:,:)
	COMPLEX*16, ALLOCATABLE :: DELWGLO(:,:,:)
	COMPLEX*16, ALLOCATABLE :: GLOCGLO(:,:,:)
	COMPLEX*16, ALLOCATABLE :: VDBCGLO(:,:,:)
	COMPLEX*16, ALLOCATABLE :: SIGIGLO(:,:,:)
	COMPLEX*16, ALLOCATABLE :: SIG0GLO(:,:,:)
	COMPLEX*16, ALLOCATABLE :: DELIGLO(:,:,:)
	COMPLEX*16, ALLOCATABLE :: BMASGLO(:,:,:)
	COMPLEX*16, ALLOCATABLE :: EIMPGLO(:,:,:)
	COMPLEX*16, ALLOCATABLE :: ELOCGLO(:,:,:)
	COMPLEX*16, ALLOCATABLE :: OIMPGLO(:,:,:)
	COMPLEX*16, ALLOCATABLE :: DHUBGLO(:,:,:)
	COMPLEX*16, ALLOCATABLE :: VRATGLO(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: WRATGLO(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: PRATGLO(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: ORATGLO(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: VRHBGLO(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: WRHBGLO(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: PRHBGLO(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: ORHBGLO(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: SIGWLOC(:,:,:)
	COMPLEX*16, ALLOCATABLE :: DELWLOC(:,:,:)
	COMPLEX*16, ALLOCATABLE :: GLOCLOC(:,:,:)
	COMPLEX*16, ALLOCATABLE :: VDBCLOC(:,:,:)
	COMPLEX*16, ALLOCATABLE :: SIGILOC(:,:,:)
	COMPLEX*16, ALLOCATABLE :: SIG0LOC(:,:,:)
	COMPLEX*16, ALLOCATABLE :: DELILOC(:,:,:)
	COMPLEX*16, ALLOCATABLE :: BMASLOC(:,:,:)
	COMPLEX*16, ALLOCATABLE :: EIMPLOC(:,:,:)
	COMPLEX*16, ALLOCATABLE :: ELOCLOC(:,:,:)
	COMPLEX*16, ALLOCATABLE :: OIMPLOC(:,:,:)
	COMPLEX*16, ALLOCATABLE :: DHUBLOC(:,:,:)
	COMPLEX*16, ALLOCATABLE :: VRATLOC(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: WRATLOC(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: PRATLOC(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: ORATLOC(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: VRHBLOC(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: WRHBLOC(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: PRHBLOC(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: ORHBLOC(:,:,:,:)
C
      REAL*8 FSLT(0:3)
	COMPLEX*16 ZMSC,DIM,VAL
      COMPLEX*16 TC(-3:3,7,0:3),TS(7,-3:3,0:3)
      DATA PI/3.141592653589793D0/,DIM/(0.D0,1.D0)/
      CALL ABORTNOW()
	IF(IDMF.NE.3.AND.IDMF.NE.4.AND.IDMF.NE.5.AND.IDMF.NE.6)RETURN
C Build transformation matrices
	CALL LIB_TRANSC(TC)
	CALL LIB_TRANSS(TS)
      CALL ABORTNOW()
C MEMORY ALLOCATIONS
      ALLOCATE(ULR(LIMB2MEM))
      ALLOCATE(UJR(2,2))
	ALLOCATE(SIGWGLO(LIMB2MEM,NSPINMEM,NORBSMEM))
	ALLOCATE(DELWGLO(LIMB2MEM,NSPINMEM,NORBSMEM))
	ALLOCATE(GLOCGLO(LIMB2MEM,NSPINMEM,NORBSMEM))
	ALLOCATE(VDBCGLO(LIMB2MEM,NSPINMEM,NORBSMEM))
	ALLOCATE(SIGIGLO(LIMB2MEM,NSPINMEM,NORBSMEM))
	ALLOCATE(SIG0GLO(LIMB2MEM,NSPINMEM,NORBSMEM))
	ALLOCATE(DELIGLO(LIMB2MEM,NSPINMEM,NORBSMEM))
	ALLOCATE(BMASGLO(LIMB2MEM,NSPINMEM,NORBSMEM))
	ALLOCATE(EIMPGLO(LIMB2MEM,NSPINMEM,NORBSMEM))
	ALLOCATE(ELOCGLO(LIMB2MEM,NSPINMEM,NORBSMEM))
	ALLOCATE(OIMPGLO(LIMB2MEM,NSPINMEM,NORBSMEM))
	ALLOCATE(DHUBGLO(LIMB2MEM,NSPINMEM,NORBSMEM))
	ALLOCATE(VRATGLO(LIMB2MEM,NSPINMEM,NORBSMEM,NPOLMEM))
	ALLOCATE(WRATGLO(LIMB2MEM,NSPINMEM,NORBSMEM,NPOLMEM))
	ALLOCATE(PRATGLO(LIMB2MEM,NSPINMEM,NORBSMEM,NPOLMEM))
	ALLOCATE(ORATGLO(LIMB2MEM,NSPINMEM,NORBSMEM,NPOLMEM))
	ALLOCATE(VRHBGLO(LIMB2MEM,NSPINMEM,NORBSMEM,NPLDMEM))
	ALLOCATE(WRHBGLO(LIMB2MEM,NSPINMEM,NORBSMEM,NPLDMEM))
	ALLOCATE(PRHBGLO(LIMB2MEM,NSPINMEM,NORBSMEM,NPLDMEM))
	ALLOCATE(ORHBGLO(LIMB2MEM,NSPINMEM,NORBSMEM,NPLDMEM))
	ALLOCATE(SIGWLOC(LIMB2MEM,NSPINMEM,NORBSMEM))
	ALLOCATE(DELWLOC(LIMB2MEM,NSPINMEM,NORBSMEM))
	ALLOCATE(GLOCLOC(LIMB2MEM,NSPINMEM,NORBSMEM))
	ALLOCATE(VDBCLOC(LIMB2MEM,NSPINMEM,NORBSMEM))
	ALLOCATE(SIGILOC(LIMB2MEM,NSPINMEM,NORBSMEM))
	ALLOCATE(SIG0LOC(LIMB2MEM,NSPINMEM,NORBSMEM))
	ALLOCATE(DELILOC(LIMB2MEM,NSPINMEM,NORBSMEM))
	ALLOCATE(BMASLOC(LIMB2MEM,NSPINMEM,NORBSMEM))
	ALLOCATE(EIMPLOC(LIMB2MEM,NSPINMEM,NORBSMEM))
	ALLOCATE(ELOCLOC(LIMB2MEM,NSPINMEM,NORBSMEM))
	ALLOCATE(OIMPLOC(LIMB2MEM,NSPINMEM,NORBSMEM))
	ALLOCATE(DHUBLOC(LIMB2MEM,NSPINMEM,NORBSMEM))
	ALLOCATE(VRATLOC(LIMB2MEM,NSPINMEM,NORBSMEM,NPOLMEM))
	ALLOCATE(WRATLOC(LIMB2MEM,NSPINMEM,NORBSMEM,NPOLMEM))
	ALLOCATE(PRATLOC(LIMB2MEM,NSPINMEM,NORBSMEM,NPOLMEM))
	ALLOCATE(ORATLOC(LIMB2MEM,NSPINMEM,NORBSMEM,NPOLMEM))
	ALLOCATE(VRHBLOC(LIMB2MEM,NSPINMEM,NORBSMEM,NPLDMEM))
	ALLOCATE(WRHBLOC(LIMB2MEM,NSPINMEM,NORBSMEM,NPLDMEM))
	ALLOCATE(PRHBLOC(LIMB2MEM,NSPINMEM,NORBSMEM,NPLDMEM))
	ALLOCATE(ORHBLOC(LIMB2MEM,NSPINMEM,NORBSMEM,NPLDMEM))
C START LOOPING OVER CORRELATED ATOMS
	DO 5000 IATOM=1,NATOM               !!! over atoms
	ISORT=IS(IATOM)
	IF(MCRL(IATOM).EQ.0)CYCLE
	DO 4000 L=0,ILSB(ISORT)             !!! over l
	IF(LCRL(L,IATOM).EQ.0)CYCLE
C BUILD TRANSFORMATION MATRICES
      CALL LIB_TRANSU(L,ROUTAXE(1,L,IATOM),ROUTANG(L,IATOM),
     &ROUTINV(L,IATOM),ULR,LIMB2MEM)
      CALL LIB_TRANSUJ(ROUTAXE(1,L,IATOM),ROUTANG(L,IATOM),
     &ROUTINV(L,IATOM),UJR)
	EFRM=EF
	NDEG=2*(2*L+1)
	NDIM=2*(2*L+1)
C ALLOCATE ARRAYS
      ALLOCATE(KST(NDIM,NRUNIMP(L,IATOM)))
	ALLOCATE(SIGWMAT(0:NMSCMEM+1,NDIM,NDIM))
	ALLOCATE(DELWMAT(0:NMSCMEM+1,NDIM,NDIM))
	ALLOCATE(GLOCMAT(0:NMSCMEM+1,NDIM,NDIM))
	ALLOCATE(EIMPMAT(NDIM,NDIM))
	ALLOCATE(ELOCMAT(NDIM,NDIM))
	ALLOCATE(VDBCMAT(NDIM,NDIM))
	ALLOCATE(SIGIMAT(NDIM,NDIM))
	ALLOCATE(SIG0MAT(NDIM,NDIM))
	ALLOCATE(DELIMAT(NDIM,NDIM))
	ALLOCATE(BMASMAT(NDIM,NDIM))
	ALLOCATE(OIMPMAT(NDIM,NDIM))
	ALLOCATE(DHUBMAT(NDIM,NDIM))
	ALLOCATE(ETRAMAT(NDIM,NDIM))
	ALLOCATE(OTRAMAT(NDIM,NDIM))
      ALLOCATE(G0M1MAT(NDIM,NDIM))
	ALLOCATE(VRATMAT(NDIM,NDIM,NPOLMEM))
	ALLOCATE(WRATMAT(NDIM,NDIM,NPOLMEM))
	ALLOCATE(PRATMAT(NDIM,NDIM,NPOLMEM))
	ALLOCATE(ORATMAT(NDIM,NDIM,NPOLMEM))
	ALLOCATE(VRHBMAT(NDIM,NDIM,NPLDMEM))
	ALLOCATE(WRHBMAT(NDIM,NDIM,NPLDMEM))
	ALLOCATE(PRHBMAT(NDIM,NDIM,NPLDMEM))
	ALLOCATE(ORHBMAT(NDIM,NDIM,NPLDMEM))
      ALLOCATE(WORK(NDIM))
C SPINORS TRANSFORMATIONS
	ALLOCATE(TREL(NDIM,NDIM))
	CALL LIB_TRANSREL_LINP(TREL,L)
C READ HYBRIDIZATION FUNCTION
	IREC=0
	DO 1000 IMSC=0,NMSC                 !!! over Matsubara frequencies
	DO JATOM=1,NATOM                    !!! over atoms
	JSORT=IS(JATOM)
	IF(MCRL(JATOM).EQ.0)CYCLE
	IREC=IREC+1
	IF(JATOM.NE.IATOM)CYCLE
	IUMAX=(ILSB(ISORT)+1)*(2*ILSB(ISORT)+1)*(2*ILSB(ISORT)+3)/3
      READ(IUSGM,REC=IREC)
     &(((SIGW(IU,IATOM,IUPDN,IORBS),IU=1,IUMAX),IUPDN=1,NSPIN),
     &IORBS=1,NORBS),
     &(((DELW(IU,IATOM,IUPDN,IORBS),IU=1,IUMAX),IUPDN=1,NSPIN),
     &IORBS=1,NORBS),
     &(((GLOC(IU,IATOM,IUPDN,IORBS),IU=1,IUMAX),IUPDN=1,NSPIN),
     &IORBS=1,NORBS)
	ENDDO                               !!! over atoms
C SET UP MATRICES IN LOCAL COORDINATE SYSTEM
	DO IORBS=1,NORBS
	DO IUPDN=1,NSPIN
      DO M=-L,L
      DO K=-L,L
      IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+K)+L+M+1           !  (l,m k) packed
C Sigma and Hybridization functions
	SIGWGLO(IU,IUPDN,IORBS)=SIGW(IU,IATOM,IUPDN,IORBS)
	DELWGLO(IU,IUPDN,IORBS)=DELW(IU,IATOM,IUPDN,IORBS)
	GLOCGLO(IU,IUPDN,IORBS)=GLOC(IU,IATOM,IUPDN,IORBS)
	IF(IMSC.EQ.0)THEN
C Sigma(inf), Sigma(0), Impurity levels and overlap
	VDBCGLO(IU,IUPDN,IORBS)=VDBC(IU,IATOM,IUPDN,IORBS)
	SIGIGLO(IU,IUPDN,IORBS)=SIGI(IU,IATOM,IUPDN,IORBS)
	SIG0GLO(IU,IUPDN,IORBS)=SIG0(IU,IATOM,IUPDN,IORBS)
	DELIGLO(IU,IUPDN,IORBS)=DELI(IU,IATOM,IUPDN,IORBS)
	BMASGLO(IU,IUPDN,IORBS)=BMAS(IU,IATOM,IUPDN,IORBS)
	EIMPGLO(IU,IUPDN,IORBS)=EIMP(IU,IATOM,IUPDN,IORBS)
	ELOCGLO(IU,IUPDN,IORBS)=ELOC(IU,IATOM,IUPDN,IORBS)
	OIMPGLO(IU,IUPDN,IORBS)=OIMP(IU,IATOM,IUPDN,IORBS)
C Density matrix
	DHUBGLO(IU,IUPDN,IORBS)=DHUB(IU,IATOM,IUPDN,IORBS)
C Rational interpolation coefficients for Sigma
	DO IPOL=1,NPOLIMP(L,IATOM)
	VRATGLO(IU,IUPDN,IORBS,IPOL)=VRAT(IU,IATOM,IUPDN,IORBS,IPOL)
	WRATGLO(IU,IUPDN,IORBS,IPOL)=WRAT(IU,IATOM,IUPDN,IORBS,IPOL)
	PRATGLO(IU,IUPDN,IORBS,IPOL)=PRAT(IU,IATOM,IUPDN,IORBS,IPOL)
	ORATGLO(IU,IUPDN,IORBS,IPOL)=ORAT(IU,IATOM,IUPDN,IORBS,IPOL)
	ENDDO
C Rational interpolation coefficients for Delta
	DO IPOL=1,NPLDIMP(L,IATOM)
	VRHBGLO(IU,IUPDN,IORBS,IPOL)=VRHB(IU,IATOM,IUPDN,IORBS,IPOL)
	WRHBGLO(IU,IUPDN,IORBS,IPOL)=WRHB(IU,IATOM,IUPDN,IORBS,IPOL)
	PRHBGLO(IU,IUPDN,IORBS,IPOL)=PRHB(IU,IATOM,IUPDN,IORBS,IPOL)
	ORHBGLO(IU,IUPDN,IORBS,IPOL)=ORHB(IU,IATOM,IUPDN,IORBS,IPOL)
	ENDDO
	ENDIF
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C TRANSFER TO LOCAL COORDINATE SYSTEM 
	CALL LIB_LTURNU(SIGWLOC,SIGWGLO,L,ULR,UJR,LIMB2MEM,NSPIN,NORBS)
	CALL LIB_LTURNU(DELWLOC,DELWGLO,L,ULR,UJR,LIMB2MEM,NSPIN,NORBS)
	CALL LIB_LTURNU(GLOCLOC,GLOCGLO,L,ULR,UJR,LIMB2MEM,NSPIN,NORBS)
	IF(IMSC.EQ.0)THEN
	CALL LIB_LTURNU(VDBCLOC,VDBCGLO,L,ULR,UJR,LIMB2MEM,NSPIN,NORBS)
	CALL LIB_LTURNU(SIGILOC,SIGIGLO,L,ULR,UJR,LIMB2MEM,NSPIN,NORBS)
	CALL LIB_LTURNU(SIG0LOC,SIG0GLO,L,ULR,UJR,LIMB2MEM,NSPIN,NORBS)
	CALL LIB_LTURNU(DELILOC,DELIGLO,L,ULR,UJR,LIMB2MEM,NSPIN,NORBS)
	CALL LIB_LTURNU(BMASLOC,BMASGLO,L,ULR,UJR,LIMB2MEM,NSPIN,NORBS)
	CALL LIB_LTURNU(EIMPLOC,EIMPGLO,L,ULR,UJR,LIMB2MEM,NSPIN,NORBS)
	CALL LIB_LTURNU(ELOCLOC,ELOCGLO,L,ULR,UJR,LIMB2MEM,NSPIN,NORBS)
	CALL LIB_LTURNU(OIMPLOC,OIMPGLO,L,ULR,UJR,LIMB2MEM,NSPIN,NORBS)
	CALL LIB_LTURNU(DHUBLOC,DHUBGLO,L,ULR,UJR,LIMB2MEM,NSPIN,NORBS)
	DO IPOL=1,NPOLIMP(L,IATOM)
	CALL LIB_LTURNU(VRATLOC(1,1,1,IPOL),VRATGLO(1,1,1,IPOL),
     &            L,ULR,UJR,LIMB2MEM,NSPIN,NORBS)
	CALL LIB_LTURNU(WRATLOC(1,1,1,IPOL),WRATGLO(1,1,1,IPOL),
     &            L,ULR,UJR,LIMB2MEM,NSPIN,NORBS)
	CALL LIB_LTURNU(PRATLOC(1,1,1,IPOL),PRATGLO(1,1,1,IPOL),
     &            L,ULR,UJR,LIMB2MEM,NSPIN,NORBS)
	CALL LIB_LTURNU(ORATLOC(1,1,1,IPOL),ORATGLO(1,1,1,IPOL),
     &            L,ULR,UJR,LIMB2MEM,NSPIN,NORBS)
	ENDDO
	DO IPOL=1,NPLDIMP(L,IATOM)
	CALL LIB_LTURNU(VRHBLOC(1,1,1,IPOL),VRHBGLO(1,1,1,IPOL),
     &            L,ULR,UJR,LIMB2MEM,NSPIN,NORBS)
	CALL LIB_LTURNU(WRHBLOC(1,1,1,IPOL),WRHBGLO(1,1,1,IPOL),
     &            L,ULR,UJR,LIMB2MEM,NSPIN,NORBS)
	CALL LIB_LTURNU(PRHBLOC(1,1,1,IPOL),PRHBGLO(1,1,1,IPOL),
     &            L,ULR,UJR,LIMB2MEM,NSPIN,NORBS)
	CALL LIB_LTURNU(ORHBLOC(1,1,1,IPOL),ORHBGLO(1,1,1,IPOL),
     &            L,ULR,UJR,LIMB2MEM,NSPIN,NORBS)
	ENDDO
	ENDIF
C SET ZEROES EVERYWHERE
	DO ISPIN1=1,2
	DO K=-L,L
	IDIM1=K+L+1+(2*L+1)*(ISPIN1-1)
	DO ISPIN=1,2
	DO M=-L,L
	IDIM=M+L+1+(2*L+1)*(ISPIN-1)
C Sigma and Hybridization functions
	SIGWMAT(IMSC,IDIM1,IDIM)=(0.D0,0.D0)
	DELWMAT(IMSC,IDIM1,IDIM)=(0.D0,0.D0)
	GLOCMAT(IMSC,IDIM1,IDIM)=(0.D0,0.D0)
	IF(IMSC.EQ.0)THEN
C Sigma(inf), Sgma(0), Impurity levels and overlap
	VDBCMAT(IDIM1,IDIM)=(0.D0,0.D0)
	SIGIMAT(IDIM1,IDIM)=(0.D0,0.D0)
	SIG0MAT(IDIM1,IDIM)=(0.D0,0.D0)
	DELIMAT(IDIM1,IDIM)=(0.D0,0.D0)
	BMASMAT(IDIM1,IDIM)=(0.D0,0.D0)
	EIMPMAT(IDIM1,IDIM)=(0.D0,0.D0)
	ELOCMAT(IDIM1,IDIM)=(0.D0,0.D0)
	OIMPMAT(IDIM1,IDIM)=(0.D0,0.D0)
	DHUBMAT(IDIM1,IDIM)=(0.D0,0.D0)
	ETRAMAT(IDIM1,IDIM)=(0.D0,0.D0)
	OTRAMAT(IDIM1,IDIM)=(0.D0,0.D0)
C Rational interpolation coefficients for Sigma
	DO IPOL=1,NPOLIMP(L,IATOM)
	VRATMAT(IDIM1,IDIM,IPOL)=(0.D0,0.D0)
	WRATMAT(IDIM1,IDIM,IPOL)=(0.D0,0.D0)
	PRATMAT(IDIM1,IDIM,IPOL)=(0.D0,0.D0)
	ORATMAT(IDIM1,IDIM,IPOL)=(0.D0,0.D0)
	ENDDO
C Rational interpolation coefficients for Delta
	DO IPOL=1,NPLDIMP(L,IATOM)
	VRHBMAT(IDIM1,IDIM,IPOL)=(0.D0,0.D0)
	WRHBMAT(IDIM1,IDIM,IPOL)=(0.D0,0.D0)
	PRHBMAT(IDIM1,IDIM,IPOL)=(0.D0,0.D0)
	ORHBMAT(IDIM1,IDIM,IPOL)=(0.D0,0.D0)
	ENDDO
	ENDIF
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	DO IORBS=1,2
	DO IUPDN=1,2
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
	IF(NORBS.EQ.1.AND.IORBS.EQ.2)CYCLE
	IF(NSPIN.EQ.1)IUPDN0=1
	IF(NSPIN.EQ.2)IUPDN0=IUPDN
	DO K=-L,L
	IDIM1=K+L+1+(2*L+1)*(ISPIN1-1)
	DO M=-L,L
	IDIM=M+L+1+(2*L+1)*(ISPIN-1)
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+K+1 !!! (l,k m)
C Sigma and Hybridization functions
	SIGWMAT(IMSC,IDIM1,IDIM)=SIGWLOC(IU,IUPDN0,IORBS)
	DELWMAT(IMSC,IDIM1,IDIM)=DELWLOC(IU,IUPDN0,IORBS)
	GLOCMAT(IMSC,IDIM1,IDIM)=GLOCLOC(IU,IUPDN0,IORBS)
	IF(IMSC.EQ.0)THEN
C Sigma(inf), Sigma(0), Impurity levels and overlap
	VDBCMAT(IDIM1,IDIM)=VDBCLOC(IU,IUPDN0,IORBS)
	SIGIMAT(IDIM1,IDIM)=SIGILOC(IU,IUPDN0,IORBS)
	SIG0MAT(IDIM1,IDIM)=SIG0LOC(IU,IUPDN0,IORBS)
	DELIMAT(IDIM1,IDIM)=DELILOC(IU,IUPDN0,IORBS)
	BMASMAT(IDIM1,IDIM)=BMASLOC(IU,IUPDN0,IORBS)
	EIMPMAT(IDIM1,IDIM)=EIMPLOC(IU,IUPDN0,IORBS)
	ELOCMAT(IDIM1,IDIM)=ELOCLOC(IU,IUPDN0,IORBS)
	OIMPMAT(IDIM1,IDIM)=OIMPLOC(IU,IUPDN0,IORBS)
C Density matrix
	DHUBMAT(IDIM1,IDIM)=DHUBLOC(IU,IUPDN0,IORBS)/2.D0*DBLE(NSPIN)
C Rational interpolation coefficients for Sigma
	DO IPOL=1,NPOLIMP(L,IATOM)
	VRATMAT(IDIM1,IDIM,IPOL)=VRATLOC(IU,IUPDN0,IORBS,IPOL)
	WRATMAT(IDIM1,IDIM,IPOL)=WRATLOC(IU,IUPDN0,IORBS,IPOL)
	PRATMAT(IDIM1,IDIM,IPOL)=PRATLOC(IU,IUPDN0,IORBS,IPOL)
	ORATMAT(IDIM1,IDIM,IPOL)=ORATLOC(IU,IUPDN0,IORBS,IPOL)
	ENDDO
C Rational interpolation coefficients for Delta
	DO IPOL=1,NPLDIMP(L,IATOM)
	VRHBMAT(IDIM1,IDIM,IPOL)=VRHBLOC(IU,IUPDN0,IORBS,IPOL)
	WRHBMAT(IDIM1,IDIM,IPOL)=WRHBLOC(IU,IUPDN0,IORBS,IPOL)
	PRHBMAT(IDIM1,IDIM,IPOL)=PRHBLOC(IU,IUPDN0,IORBS,IPOL)
	ORHBMAT(IDIM1,IDIM,IPOL)=ORHBLOC(IU,IUPDN0,IORBS,IPOL)
	ENDDO
	ENDIF
	ENDDO
	ENDDO
	ENDDO
	ENDDO
 1000	CONTINUE                               !!! over Matsubara frequencies
C  SET UP REPRESENTATION IN WHICH THE IMPURITY MODEL IS SOLVED
	DO IORBS=1,2
	DO IUPDN=1,2
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
	IF(NORBS.EQ.1.AND.IORBS.EQ.2)CYCLE
	IF(NSPIN.EQ.1)IUPDN0=1
	IF(NSPIN.EQ.2)IUPDN0=IUPDN
	DO K=-L,L
	IDIM1=K+L+1+(2*L+1)*(ISPIN1-1)
	DO M=-L,L
	IDIM=M+L+1+(2*L+1)*(ISPIN-1)
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+K+1 !!! (l,k m)
C Cubic Harmonics
	IF(KCRDSYS(L,IATOM).EQ.1)THEN
	IF(ISPIN1.EQ.ISPIN)ETRAMAT(IDIM1,IDIM)=TC(K,M+L+1,L)
	IF(ISPIN1.EQ.ISPIN)OTRAMAT(IDIM1,IDIM)=TS(M+L+1,K,L)
	IF(ISPIN1.NE.ISPIN)ETRAMAT(IDIM1,IDIM)=(0.D0,0.D0)
	IF(ISPIN1.NE.ISPIN)OTRAMAT(IDIM1,IDIM)=(0.D0,0.D0)
C Spherical Harmonics
	ELSEIF(KCRDSYS(L,IATOM).EQ.2)THEN
	IF(IDIM1.EQ.IDIM)VAL=(1.D0,0.D0)
	IF(IDIM1.NE.IDIM)VAL=(0.D0,0.D0)
	ETRAMAT(IDIM1,IDIM)=VAL
	OTRAMAT(IDIM1,IDIM)=VAL
C Spinors
	ELSEIF(KCRDSYS(L,IATOM).EQ.3)THEN
	ETRAMAT(IDIM1,IDIM)=TREL(IDIM,IDIM1) ! reciprocal is simply transposed, but transposition is done later
	OTRAMAT(IDIM1,IDIM)=TREL(IDIM,IDIM1) ! indexation checked, first index in OTRAMAT= sph.harm, 
C Diagonal representation               ! second - relativistic 
	ELSEIF(KCRDSYS(L,IATOM).EQ.4)THEN
	ETRAMAT(IDIM1,IDIM)=AINV(IU,IATOM,IUPDN0,IORBS)
	OTRAMAT(IDIM1,IDIM)=ALAM(IU,IATOM,IUPDN0,IORBS)
C Custom representation
	ELSEIF(KCRDSYS(L,IATOM).EQ.5)THEN
	ETRAMAT(IDIM1,IDIM)=RSYS(IU,IATOM,IUPDN0,IORBS)
	OTRAMAT(IDIM1,IDIM)=DSYS(IU,IATOM,IUPDN0,IORBS)
	ENDIF
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C TRANSFORM TO DESIRED REPRESENTATION 
C Sigma and Hybridization functions
      CALL LIB_TRANSMAT3L(NDIM,+KCRDSYS(L,IATOM),NDIM,
     &    +KCRDSYS(L,IATOM),GLOCMAT,OTRAMAT,ETRAMAT,NMSC+2)
      CALL LIB_TRANSMAT3L(NDIM,+KCRDSYS(L,IATOM),NDIM,
     &    +KCRDSYS(L,IATOM),SIGWMAT,OTRAMAT,ETRAMAT,NMSC+2)
      CALL LIB_TRANSMAT3L(NDIM,+KCRDSYS(L,IATOM),NDIM,
     &    +KCRDSYS(L,IATOM),DELWMAT,OTRAMAT,ETRAMAT,NMSC+2)
C Sigma(inf), Sigma(0), Impurity levels and overlap
      CALL LIB_TRANSMAT3L(NDIM,+KCRDSYS(L,IATOM),NDIM,
     &    +KCRDSYS(L,IATOM),SIG0MAT,OTRAMAT,ETRAMAT,1)
      CALL LIB_TRANSMAT3L(NDIM,+KCRDSYS(L,IATOM),NDIM,
     &    +KCRDSYS(L,IATOM),DELIMAT,OTRAMAT,ETRAMAT,1)
      CALL LIB_TRANSMAT3L(NDIM,+KCRDSYS(L,IATOM),NDIM,
     &    +KCRDSYS(L,IATOM),EIMPMAT,OTRAMAT,ETRAMAT,1)
      CALL LIB_TRANSMAT3L(NDIM,+KCRDSYS(L,IATOM),NDIM,
     &    +KCRDSYS(L,IATOM),OIMPMAT,OTRAMAT,ETRAMAT,1)
      CALL LIB_TRANSMAT3L(NDIM,+KCRDSYS(L,IATOM),NDIM,
     &    +KCRDSYS(L,IATOM),SIGIMAT,OTRAMAT,ETRAMAT,1)
      CALL LIB_TRANSMAT3L(NDIM,+KCRDSYS(L,IATOM),NDIM,
     &    +KCRDSYS(L,IATOM),DHUBMAT,OTRAMAT,ETRAMAT,1)
      CALL LIB_TRANSMAT3L(NDIM,+KCRDSYS(L,IATOM),NDIM,
     &    +KCRDSYS(L,IATOM),VDBCMAT,OTRAMAT,ETRAMAT,1)
      CALL LIB_TRANSMAT3L(NDIM,+KCRDSYS(L,IATOM),NDIM,
     &    +KCRDSYS(L,IATOM),BMASMAT,OTRAMAT,ETRAMAT,1)
      CALL LIB_TRANSMAT3L(NDIM,+KCRDSYS(L,IATOM),NDIM,
     &    +KCRDSYS(L,IATOM),ELOCMAT,OTRAMAT,ETRAMAT,1)
C Rational interpolation coefficients for Sigma
      CALL LIB_TRANSMAT3R(NDIM,+KCRDSYS(L,IATOM),NDIM,
     &    +KCRDSYS(L,IATOM),VRATMAT,OTRAMAT,ETRAMAT,NPOLIMP(L,IATOM))
      CALL LIB_TRANSMAT3R(NDIM,+KCRDSYS(L,IATOM),NDIM,
     &    +KCRDSYS(L,IATOM),WRATMAT,OTRAMAT,ETRAMAT,NPOLIMP(L,IATOM))
      CALL LIB_TRANSMAT3R(NDIM,+KCRDSYS(L,IATOM),NDIM,
     &    +KCRDSYS(L,IATOM),PRATMAT,OTRAMAT,ETRAMAT,NPOLIMP(L,IATOM))
      CALL LIB_TRANSMAT3R(NDIM,+KCRDSYS(L,IATOM),NDIM,
     &    +KCRDSYS(L,IATOM),ORATMAT,OTRAMAT,ETRAMAT,NPOLIMP(L,IATOM))
C Rational interpolation coefficients for Delta
      CALL LIB_TRANSMAT3R(NDIM,+KCRDSYS(L,IATOM),NDIM,
     &    +KCRDSYS(L,IATOM),VRHBMAT,OTRAMAT,ETRAMAT,NPLDIMP(L,IATOM))
      CALL LIB_TRANSMAT3R(NDIM,+KCRDSYS(L,IATOM),NDIM,
     &    +KCRDSYS(L,IATOM),WRHBMAT,OTRAMAT,ETRAMAT,NPLDIMP(L,IATOM))
      CALL LIB_TRANSMAT3R(NDIM,+KCRDSYS(L,IATOM),NDIM,
     &    +KCRDSYS(L,IATOM),PRHBMAT,OTRAMAT,ETRAMAT,NPLDIMP(L,IATOM))
      CALL LIB_TRANSMAT3R(NDIM,+KCRDSYS(L,IATOM),NDIM,
     &    +KCRDSYS(L,IATOM),ORHBMAT,OTRAMAT,ETRAMAT,NPLDIMP(L,IATOM))
C ************************************************
C FIND HYBRIDIZATION FUNCTION IN THIS REPRESENTATION
      CALL IMP_HYBFUN(L,IATOM,GLOCMAT,EIMPMAT,OIMPMAT,VDBCMAT,
     &     SIGWMAT,SIGIMAT,VRATMAT,WRATMAT,PRATMAT,ORATMAT,
     &     DELWMAT,DELIMAT,IERR)
C ******************************************************
C AVERAGE DIAGONAL ELEMENTS ACCORDING TO KSTATES POINTER
      NPOL=NPOLIMP(L,IATOM)
      NPLD=NPLDIMP(L,IATOM)
      NRUN=NRUNIMP(L,IATOM)
      DO IRUN=1,NRUN
      DO IDIM=1,NDIM
      KST(IDIM,IRUN)=KSTATES(IDIM,IRUN,L,IATOM)
      ENDDO
      ENDDO
      CALL LIB_FORCESYM3L(EIMPMAT,KST,NDIM,1,NRUN)
      CALL LIB_FORCESYM3L(ELOCMAT,KST,NDIM,1,NRUN)
      CALL LIB_FORCESYM3L(OIMPMAT,KST,NDIM,1,NRUN)
      CALL LIB_FORCESYM3L(SIGIMAT,KST,NDIM,1,NRUN)
      CALL LIB_FORCESYM3L(VDBCMAT,KST,NDIM,1,NRUN)
      CALL LIB_FORCESYM3L(DHUBMAT,KST,NDIM,1,NRUN)
      CALL LIB_FORCESYM3L(SIG0MAT,KST,NDIM,1,NRUN)
      CALL LIB_FORCESYM3L(DELIMAT,KST,NDIM,1,NRUN)
      CALL LIB_FORCESYM3L(BMASMAT,KST,NDIM,1,NRUN)
C Sigma(w), Delta(w), Gloc(w)
      CALL LIB_FORCESYM3L(GLOCMAT,KST,NDIM,NMSC+2,NRUN)
      CALL LIB_FORCESYM3L(SIGWMAT,KST,NDIM,NMSC+2,NRUN)
      CALL LIB_FORCESYM3L(DELWMAT,KST,NDIM,NMSC+2,NRUN)
C Pole representation for Sigma(w)
      CALL LIB_FORCESYM3R(VRATMAT,KST,NDIM,NPOL,NRUN)
      CALL LIB_FORCESYM3R(WRATMAT,KST,NDIM,NPOL,NRUN)
      CALL LIB_FORCESYM3R(PRATMAT,KST,NDIM,NPOL,NRUN)
      CALL LIB_FORCESYM3R(ORATMAT,KST,NDIM,NPOL,NRUN)
C Pole representation for Delta(w)
      CALL LIB_FORCESYM3R(VRHBMAT,KST,NDIM,NPLD,NRUN)
      CALL LIB_FORCESYM3R(WRHBMAT,KST,NDIM,NPLD,NRUN)
      CALL LIB_FORCESYM3R(PRHBMAT,KST,NDIM,NPLD,NRUN)
      CALL LIB_FORCESYM3R(ORHBMAT,KST,NDIM,NPLD,NRUN)
C ******************************************************
C FIND RATIONAL INTERPOLATION FOR HYBRIDIZATION
      CALL IMP_HYBINT(L,IATOM,DHUBMAT,VDBCMAT,EIMPMAT,ELOCMAT,
     &     OIMPMAT,DELWMAT,DELIMAT,VRHBMAT,WRHBMAT,PRHBMAT,
     &     ORHBMAT,IERR)
C ******************************************************
C AVERAGE DIAGONAL ELEMENTS ACCORDING TO KSTATES POINTER
      NPOL=NPOLIMP(L,IATOM)
      NPLD=NPLDIMP(L,IATOM)
      NRUN=NRUNIMP(L,IATOM)
      DO IRUN=1,NRUN
      DO IDIM=1,NDIM
      KST(IDIM,IRUN)=KSTATES(IDIM,IRUN,L,IATOM)
      ENDDO
      ENDDO
      CALL LIB_FORCESYM3L(EIMPMAT,KST,NDIM,1,NRUN)
      CALL LIB_FORCESYM3L(ELOCMAT,KST,NDIM,1,NRUN)
      CALL LIB_FORCESYM3L(OIMPMAT,KST,NDIM,1,NRUN)
      CALL LIB_FORCESYM3L(SIGIMAT,KST,NDIM,1,NRUN)
      CALL LIB_FORCESYM3L(VDBCMAT,KST,NDIM,1,NRUN)
      CALL LIB_FORCESYM3L(DHUBMAT,KST,NDIM,1,NRUN)
      CALL LIB_FORCESYM3L(SIG0MAT,KST,NDIM,1,NRUN)
      CALL LIB_FORCESYM3L(DELIMAT,KST,NDIM,1,NRUN)
      CALL LIB_FORCESYM3L(BMASMAT,KST,NDIM,1,NRUN)
C Sigma(w), Delta(w), Bath(w)
      CALL LIB_FORCESYM3L(GLOCMAT,KST,NDIM,NMSC+2,NRUN)
      CALL LIB_FORCESYM3L(SIGWMAT,KST,NDIM,NMSC+2,NRUN)
      CALL LIB_FORCESYM3L(DELWMAT,KST,NDIM,NMSC+2,NRUN)
C Pole representation for Sigma(w)
      CALL LIB_FORCESYM3R(VRATMAT,KST,NDIM,NPOL,NRUN)
      CALL LIB_FORCESYM3R(WRATMAT,KST,NDIM,NPOL,NRUN)
      CALL LIB_FORCESYM3R(PRATMAT,KST,NDIM,NPOL,NRUN)
      CALL LIB_FORCESYM3R(ORATMAT,KST,NDIM,NPOL,NRUN)
C Pole representation for Delta(w)
      CALL LIB_FORCESYM3R(VRHBMAT,KST,NDIM,NPLD,NRUN)
      CALL LIB_FORCESYM3R(WRHBMAT,KST,NDIM,NPLD,NRUN)
      CALL LIB_FORCESYM3R(PRHBMAT,KST,NDIM,NPLD,NRUN)
      CALL LIB_FORCESYM3R(ORHBMAT,KST,NDIM,NPLD,NRUN)
C TRANSFORM BACK TO ORIGINAL REPRESENTATION OF SPHERICAL HARMONICS
C Bath, Sigma and Hybridization functions
      CALL LIB_TRANSMAT3L(NDIM,-KCRDSYS(L,IATOM),NDIM,
     &    -KCRDSYS(L,IATOM),GLOCMAT,OTRAMAT,ETRAMAT,NMSC+2)
      CALL LIB_TRANSMAT3L(NDIM,-KCRDSYS(L,IATOM),NDIM,
     &    -KCRDSYS(L,IATOM),SIGWMAT,OTRAMAT,ETRAMAT,NMSC+2)
      CALL LIB_TRANSMAT3L(NDIM,-KCRDSYS(L,IATOM),NDIM,
     &    -KCRDSYS(L,IATOM),DELWMAT,OTRAMAT,ETRAMAT,NMSC+2)
C Sigma(inf), Sigma(0), Impurity levels and overlap
      CALL LIB_TRANSMAT3L(NDIM,-KCRDSYS(L,IATOM),NDIM,
     &    -KCRDSYS(L,IATOM),SIG0MAT,OTRAMAT,ETRAMAT,1)
      CALL LIB_TRANSMAT3L(NDIM,-KCRDSYS(L,IATOM),NDIM,
     &    -KCRDSYS(L,IATOM),DELIMAT,OTRAMAT,ETRAMAT,1)
      CALL LIB_TRANSMAT3L(NDIM,-KCRDSYS(L,IATOM),NDIM,
     &    -KCRDSYS(L,IATOM),EIMPMAT,OTRAMAT,ETRAMAT,1)
      CALL LIB_TRANSMAT3L(NDIM,-KCRDSYS(L,IATOM),NDIM,
     &    -KCRDSYS(L,IATOM),OIMPMAT,OTRAMAT,ETRAMAT,1)
      CALL LIB_TRANSMAT3L(NDIM,-KCRDSYS(L,IATOM),NDIM,
     &    -KCRDSYS(L,IATOM),SIGIMAT,OTRAMAT,ETRAMAT,1)
      CALL LIB_TRANSMAT3L(NDIM,-KCRDSYS(L,IATOM),NDIM,
     &    -KCRDSYS(L,IATOM),DHUBMAT,OTRAMAT,ETRAMAT,1)
      CALL LIB_TRANSMAT3L(NDIM,-KCRDSYS(L,IATOM),NDIM,
     &    -KCRDSYS(L,IATOM),VDBCMAT,OTRAMAT,ETRAMAT,1)
      CALL LIB_TRANSMAT3L(NDIM,-KCRDSYS(L,IATOM),NDIM,
     &    -KCRDSYS(L,IATOM),BMASMAT,OTRAMAT,ETRAMAT,1)
      CALL LIB_TRANSMAT3L(NDIM,-KCRDSYS(L,IATOM),NDIM,
     &    -KCRDSYS(L,IATOM),ELOCMAT,OTRAMAT,ETRAMAT,1)
C Rational interpolation coefficients for Sigma
      CALL LIB_TRANSMAT3R(NDIM,-KCRDSYS(L,IATOM),NDIM,
     &    -KCRDSYS(L,IATOM),VRATMAT,OTRAMAT,ETRAMAT,NPOLIMP(L,IATOM))
      CALL LIB_TRANSMAT3R(NDIM,-KCRDSYS(L,IATOM),NDIM,
     &    -KCRDSYS(L,IATOM),WRATMAT,OTRAMAT,ETRAMAT,NPOLIMP(L,IATOM))
      CALL LIB_TRANSMAT3R(NDIM,-KCRDSYS(L,IATOM),NDIM,
     &    -KCRDSYS(L,IATOM),PRATMAT,OTRAMAT,ETRAMAT,NPOLIMP(L,IATOM))
      CALL LIB_TRANSMAT3R(NDIM,-KCRDSYS(L,IATOM),NDIM,
     &    -KCRDSYS(L,IATOM),ORATMAT,OTRAMAT,ETRAMAT,NPOLIMP(L,IATOM))
C Rational interpolation coefficients for Delta
      CALL LIB_TRANSMAT3R(NDIM,-KCRDSYS(L,IATOM),NDIM,
     &    -KCRDSYS(L,IATOM),VRHBMAT,OTRAMAT,ETRAMAT,NPLDIMP(L,IATOM))
      CALL LIB_TRANSMAT3R(NDIM,-KCRDSYS(L,IATOM),NDIM,
     &    -KCRDSYS(L,IATOM),WRHBMAT,OTRAMAT,ETRAMAT,NPLDIMP(L,IATOM))
      CALL LIB_TRANSMAT3R(NDIM,-KCRDSYS(L,IATOM),NDIM,
     &    -KCRDSYS(L,IATOM),PRHBMAT,OTRAMAT,ETRAMAT,NPLDIMP(L,IATOM))
      CALL LIB_TRANSMAT3R(NDIM,-KCRDSYS(L,IATOM),NDIM,
     &    -KCRDSYS(L,IATOM),ORHBMAT,OTRAMAT,ETRAMAT,NPLDIMP(L,IATOM))
C STORE NEW HYBRIDIZATION
	IREC=0
	DO IMSC=0,NMSC                      !!! over Matsubara frequencies
	DO JATOM=1,NATOM                    !!! over atoms
	JSORT=IS(JATOM)
	IF(MCRL(JATOM).EQ.0)CYCLE
	IREC=IREC+1
	IF(JATOM.NE.IATOM)CYCLE
	IUMAX=(ILSB(ISORT)+1)*(2*ILSB(ISORT)+1)*(2*ILSB(ISORT)+3)/3
      READ(IUSGM,REC=IREC)
     &(((SIGW(IU,IATOM,IUPDN,IORBS),IU=1,IUMAX),IUPDN=1,NSPIN),
     &IORBS=1,NORBS),
     &(((DELW(IU,IATOM,IUPDN,IORBS),IU=1,IUMAX),IUPDN=1,NSPIN),
     &IORBS=1,NORBS),
     &(((GLOC(IU,IATOM,IUPDN,IORBS),IU=1,IUMAX),IUPDN=1,NSPIN),
     &IORBS=1,NORBS)
	DO IORBS=1,2
	DO IUPDN=1,2
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
	IF(NORBS.EQ.1.AND.IORBS.EQ.2)CYCLE
	IF(NSPIN.EQ.1)IUPDN0=1
	IF(NSPIN.EQ.2)IUPDN0=IUPDN
	DO K=-L,L
	IDIM1=K+L+1+(2*L+1)*(ISPIN1-1)
	DO M=-L,L
	IDIM=M+L+1+(2*L+1)*(ISPIN-1)
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+K+1 !!! (l,k m)
	IW=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+K)+L+M+1 !!! (l,m k)
C Hybridization
	DELWLOC(IU,IUPDN0,IORBS)=DELWMAT(IMSC,IDIM1,IDIM)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C Transfer back to global coordinate system
	CALL LIB_GTURNU(DELWGLO,DELWLOC,L,ULR,UJR,LIMB2MEM,NSPIN,NORBS)
	DO IORBS=1,NORBS
	DO IUPDN=1,NSPIN
      DO M=-L,L
      DO K=-L,L
      IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+K)+L+M+1           !  (l,m k) packed
	DELW(IU,IATOM,IUPDN,IORBS)=DELWGLO(IU,IUPDN,IORBS)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
      WRITE(IUSGM,REC=IREC)
     &(((SIGW(IU,IATOM,IUPDN,IORBS),IU=1,IUMAX),IUPDN=1,NSPIN),
     &IORBS=1,NORBS),
     &(((DELW(IU,IATOM,IUPDN,IORBS),IU=1,IUMAX),IUPDN=1,NSPIN),
     &IORBS=1,NORBS),
     &(((GLOC(IU,IATOM,IUPDN,IORBS),IU=1,IUMAX),IUPDN=1,NSPIN),
     &IORBS=1,NORBS)
	ENDDO                               !!! over atoms
	ENDDO                               !!! over Matsubara frequencies
C Hybridization limits and its interpolation
	DO IORBS=1,2
	DO IUPDN=1,2
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
	IF(NORBS.EQ.1.AND.IORBS.EQ.2)CYCLE
	IF(NSPIN.EQ.1)IUPDN0=1
	IF(NSPIN.EQ.2)IUPDN0=IUPDN
	DO K=-L,L
	IDIM1=K+L+1+(2*L+1)*(ISPIN1-1)
	DO M=-L,L
	IDIM=M+L+1+(2*L+1)*(ISPIN-1)
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+K+1 !!! (l,k m)
	IW=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+K)+L+M+1 !!! (l,m k)
C Delta limits
	DELILOC(IU,IUPDN0,IORBS)=DELIMAT(IDIM1,IDIM)
C Rational interpolation coefficients for Delta
	DO IPOL=1,NPLDIMP(L,IATOM)
	VRHBLOC(IU,IUPDN0,IORBS,IPOL)=VRHBMAT(IDIM1,IDIM,IPOL)
	WRHBLOC(IU,IUPDN0,IORBS,IPOL)=WRHBMAT(IDIM1,IDIM,IPOL)
	PRHBLOC(IU,IUPDN0,IORBS,IPOL)=PRHBMAT(IDIM1,IDIM,IPOL)
	ORHBLOC(IU,IUPDN0,IORBS,IPOL)=ORHBMAT(IDIM1,IDIM,IPOL)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C Transfer to global coordinate system
	CALL LIB_GTURNU(DELIGLO,DELILOC,L,ULR,UJR,LIMB2MEM,NSPIN,NORBS)
	DO IPOL=1,NPLDIMP(L,IATOM)
	CALL LIB_GTURNU(VRHBGLO(1,1,1,IPOL),VRHBLOC(1,1,1,IPOL),
     &            L,ULR,UJR,LIMB2MEM,NSPIN,NORBS)
	CALL LIB_GTURNU(WRHBGLO(1,1,1,IPOL),WRHBLOC(1,1,1,IPOL),
     &            L,ULR,UJR,LIMB2MEM,NSPIN,NORBS)
	CALL LIB_GTURNU(PRHBGLO(1,1,1,IPOL),PRHBLOC(1,1,1,IPOL),
     &            L,ULR,UJR,LIMB2MEM,NSPIN,NORBS)
	CALL LIB_GTURNU(ORHBGLO(1,1,1,IPOL),ORHBLOC(1,1,1,IPOL),
     &            L,ULR,UJR,LIMB2MEM,NSPIN,NORBS)
	ENDDO
	DO IORBS=1,NORBS
	DO IUPDN=1,NSPIN
      DO M=-L,L
      DO K=-L,L
      IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+K)+L+M+1           !  (l,m k) packed
C Sigma(inf), Sigma(0), Impurity levels
	DELI(IU,IATOM,IUPDN,IORBS)=DELIGLO(IU,IUPDN,IORBS)
C Rational interpolation coefficients for Delta
	DO IPOL=1,NPLDIMP(L,IATOM)
	VRHB(IU,IATOM,IUPDN,IORBS,IPOL)=VRHBGLO(IU,IUPDN,IORBS,IPOL)
	WRHB(IU,IATOM,IUPDN,IORBS,IPOL)=WRHBGLO(IU,IUPDN,IORBS,IPOL)
	PRHB(IU,IATOM,IUPDN,IORBS,IPOL)=PRHBGLO(IU,IUPDN,IORBS,IPOL)
	ORHB(IU,IATOM,IUPDN,IORBS,IPOL)=ORHBGLO(IU,IUPDN,IORBS,IPOL)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C MEMORY DEALLOCATIONS
	DEALLOCATE(DHUBMAT,SIGWMAT,DELWMAT,GLOCMAT)
	DEALLOCATE(EIMPMAT,VDBCMAT,BMASMAT,ELOCMAT)
	DEALLOCATE(SIGIMAT,SIG0MAT,DELIMAT,OIMPMAT,G0M1MAT)
	DEALLOCATE(VRATMAT,WRATMAT,PRATMAT,ORATMAT)
	DEALLOCATE(VRHBMAT,WRHBMAT,PRHBMAT,ORHBMAT)
	DEALLOCATE(ETRAMAT,OTRAMAT,WORK,TREL,KST)
 4000	CONTINUE                            !!! over l
 5000	CONTINUE                            !!! over atoms
	DEALLOCATE(ULR,UJR)
	DEALLOCATE(SIGWGLO,DELWGLO,VDBCGLO,SIGIGLO,SIG0GLO)
	DEALLOCATE(DELIGLO,BMASGLO,EIMPGLO,ELOCGLO,OIMPGLO)
	DEALLOCATE(DHUBGLO,VRATGLO,WRATGLO,PRATGLO,ORATGLO)
	DEALLOCATE(        VRHBGLO,WRHBGLO,PRHBGLO,ORHBGLO)
	DEALLOCATE(SIGWLOC,DELWLOC,VDBCLOC,SIGILOC,SIG0LOC)
	DEALLOCATE(DELILOC,BMASLOC,EIMPLOC,ELOCLOC,OIMPLOC)
	DEALLOCATE(DHUBLOC,VRATLOC,WRATLOC,PRATLOC,ORATLOC)
	DEALLOCATE(        VRHBLOC,WRHBLOC,PRHBLOC,ORHBLOC)
	END
