	SUBROUTINE DMF_IMPLEV(KMSC)
*********************************************************
*  Subroutine finds impurity levels and degeneracies    *
*********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                               !!! from setup
      USE COM_CONTROL ,ONLY: LIFT,LMTO,IDMF                        !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS,ILSB       !!! from readini
	USE COM_IMPDAT  ,ONLY: KCRDSYS,DSYS,RSYS                     !!! from readhub
      USE COM_DMFDAT  ,ONLY: DELI,OIMP,EIMP,AINV,ALAM              !!! from grfbnd
      USE COM_HUBCOM  ,ONLY: VDBC                                  !!! from readhub
      USE COM_HUBDAT  ,ONLY: MCRL,LCRL                             !!! from readhub
      USE COM_KKRPAR  ,ONLY: CNY,WNY,VNY                           !!! from kkrpar
      USE COM_FERMI   ,ONLY: EF                                    !!! from ttrints
      USE COM_LMTOUT  ,ONLY: SCRFILE                               !!! from readini
      USE COM_MASHDEP ,ONLY: NVAL,LENCMP                           !!! from setup
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                       !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
C
	INTEGER, ALLOCATABLE :: LREP(:)
	INTEGER, ALLOCATABLE :: KREP(:)
	REAL*8, ALLOCATABLE :: ELOC(:)
	REAL*8, ALLOCATABLE :: EDOP(:)
	REAL*8, ALLOCATABLE :: EVAL(:)
	REAL*8, ALLOCATABLE :: UMAT(:,:)
	REAL*8, ALLOCATABLE :: GMAT(:,:)
	REAL*8, ALLOCATABLE :: UBAR(:,:)
	REAL*8, ALLOCATABLE :: GBAR(:,:)
	REAL*8, ALLOCATABLE :: UINT(:,:,:,:)
	REAL*8, ALLOCATABLE :: GINT(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: SI0L(:,:)
	COMPLEX*16, ALLOCATABLE :: EIML(:,:)
	COMPLEX*16, ALLOCATABLE :: OVRL(:,:)
	COMPLEX*16, ALLOCATABLE :: TRCS(:,:,:)
	COMPLEX*16, ALLOCATABLE :: EMAT(:,:)
	COMPLEX*16, ALLOCATABLE :: OMAT(:,:)
C
	COMPLEX*16 DIM,CMAT
      DATA PI/3.141592653589793D0/,DIM/(0.D0,1.D0)/,EPSDEG/1.D-05/
     &    ,IOVRL/0/
      CALL ABORTNOW()
C START LOOPING OVER CORRELATED ATOMS
	DO 2000 IATOM=1,NATOM               !!! over atoms
	ISORT=IS(IATOM)
	IF(MCRL(IATOM).EQ.0)CYCLE
	DO 1000 L=0,ILSB(ISORT)             !!! over l
	IF(LCRL(L,IATOM).EQ.0)CYCLE
	NDEG=2*(2*L+1)
	NDIM=NSPIN*(2*L+1)
	NDEG=2*(2*L+1)
C ALLOCATE ARRAYS
	ALLOCATE(EIML((2*L+1)*NSPINMEM,(2*L+1)*NSPINMEM))
	ALLOCATE(SI0L((2*L+1)*NSPINMEM,(2*L+1)*NSPINMEM))
	ALLOCATE(OVRL((2*L+1)*NSPINMEM,(2*L+1)*NSPINMEM))
	ALLOCATE(TRCS((2*L+1)*NSPINMEM,(2*L+1)*NSPINMEM,2))
C ALLOCATE MORE ARRAYS
	ALLOCATE(EMAT((2*L+1)*NSPINMEM,(2*L+1)*NSPINMEM))
	ALLOCATE(OMAT((2*L+1)*NSPINMEM,(2*L+1)*NSPINMEM))
	ALLOCATE(EVAL((2*L+1)*NSPINMEM))
C CONFIGURE MATRICES
	DO ISPIN1=1,NSPIN
	DO K=-L,L
	IDIM1=K+L+1+(2*L+1)*(ISPIN1-1)
	DO ISPIN=1,NSPIN
	DO M=-L,L
	IDIM=M+L+1+(2*L+1)*(ISPIN-1)
	SI0L(IDIM1,IDIM)=(0.D0,0.D0)
	EIML(IDIM1,IDIM)=(0.D0,0.D0)
	OVRL(IDIM1,IDIM)=(0.D0,0.D0)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	DO IORBS=1,NORBS
	DO IUPDN=1,NSPIN
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
	DO K=-L,L
	IDIM1=K+L+1+(2*L+1)*(ISPIN1-1)
	DO M=-L,L
	IDIM=M+L+1+(2*L+1)*(ISPIN-1)
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+K+1 !!! (l,k m)
	SI0L(IDIM1,IDIM)=VDBC(IU,IATOM,IUPDN,IORBS)
	EIML(IDIM1,IDIM)=EIMP(IU,IATOM,IUPDN,IORBS)
	OVRL(IDIM1,IDIM)=OIMP(IU,IATOM,IUPDN,IORBS)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C DIAGONALIZE IMPURITY LEVELS
	NDIM=(2*L+1)*NSPIN
	DO ISPIN1=1,NSPIN
	DO K=-L,L
	IDIM1=K+L+1+(2*L+1)*(ISPIN1-1)
	DO ISPIN=1,NSPIN
	DO M=-L,L
	IDIM=M+L+1+(2*L+1)*(ISPIN-1)
	EMAT(IDIM1,IDIM)=EIML(IDIM1,IDIM)
	IF(IOVRL.EQ.1)
     &OMAT(IDIM1,IDIM)=OVRL(IDIM1,IDIM)
	IF(IOVRL.EQ.0.AND.IDIM1.EQ.IDIM)
     &OMAT(IDIM1,IDIM)=(1.D0,0.D0)
	IF(IOVRL.EQ.0.AND.IDIM1.NE.IDIM)
     &OMAT(IDIM1,IDIM)=(0.D0,0.D0)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C ENFORCE HEMITIANNESS
	DO IDIM1=1,NDIM
	DO IDIM =1,IDIM1
	CMAT=0.5D0*(EMAT(IDIM1,IDIM)+DCONJG(EMAT(IDIM,IDIM1)))
	EMAT(IDIM1,IDIM)=CMAT
	EMAT(IDIM,IDIM1)=DCONJG(CMAT)
	CMAT=0.5D0*(OMAT(IDIM1,IDIM)+DCONJG(OMAT(IDIM,IDIM1)))
	OMAT(IDIM1,IDIM)=CMAT
	OMAT(IDIM,IDIM1)=DCONJG(CMAT)
	ENDDO
	ENDDO
      CALL LIB_EIGEN1C(NDIM,EMAT,OMAT,EVAL,NSPIN,NORBS,1,IERR,1,1.D-07)
	IF(IERR.EQ.1)
     &CALL FULLSTOP('<DMF_IMPLEV> Error in diagonalization')
C TRASFORM TO REPRESENTATION OF EIGENVECTORS <OMAT>
	DO IBND1=1,NDIM
	DO IBND=1,NDIM
	TRCS(IBND1,IBND,1)=(0.D0,0.D0)
	TRCS(IBND1,IBND,2)=(0.D0,0.D0)
	DO IDIM1=1,NDIM
	DO IDIM=1,NDIM
	TRCS(IBND1,IBND,1)=TRCS(IBND1,IBND,1)+
     &DCONJG(OMAT(IDIM1,IBND1))*OMAT(IDIM,IBND)*
     &SI0L(IDIM1,IDIM)
	TRCS(IBND1,IBND,2)=TRCS(IBND1,IBND,2)+
     &DCONJG(OMAT(IDIM1,IBND1))*OMAT(IDIM,IBND)*
     &EIML(IDIM1,IDIM)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	DO IBND1=1,NDIM
	DO IBND=1,NDIM
	SI0L(IBND1,IBND)=TRCS(IBND1,IBND,1)
	EIML(IBND1,IBND)=TRCS(IBND1,IBND,2)
	ENDDO
	ENDDO
C TRANSFORMATON MATRIX BACK TO ORIGINAL REPRESENTATION
	DO IBND=1,NDIM
	DO IDIM=1,NDIM
	IF(IOVRL.EQ.0)THEN
	EMAT(IDIM,IBND)=DCONJG(OMAT(IDIM,IBND))
	ELSEIF(IOVRL.EQ.1)THEN
	EMAT(IDIM,IBND)=(0.D0,0.D0)
	DO IDIM1=1,NDIM
	EMAT(IDIM,IBND)=EMAT(IDIM,IBND)+
     &DCONJG(OMAT(IDIM1,IBND))*OVRL(IDIM1,IDIM)
	ENDDO
	ENDIF
	ENDDO
	ENDDO
C PACK IT
	DO IORBS=1,NORBS
	DO IUPDN=1,NSPIN
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
	DO K=-L,L
	IDIM1=K+L+1+(2*L+1)*(ISPIN1-1)
	DO M=-L,L
	IDIM=M+L+1+(2*L+1)*(ISPIN-1)
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+K+1 !!! (l,k m)
	AINV(IU,IATOM,IUPDN,IORBS)=EMAT(IDIM1,IDIM)
	ALAM(IU,IATOM,IUPDN,IORBS)=OMAT(IDIM1,IDIM)
C Reset transformation matrices
	IF(KCRDSYS(L,IATOM).EQ.4)THEN
	RSYS(IU,IATOM,IUPDN,IORBS)=AINV(IU,IATOM,IUPDN,IORBS)
	DSYS(IU,IATOM,IUPDN,IORBS)=ALAM(IU,IATOM,IUPDN,IORBS)
	ENDIF
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C INTERACTION MATRICES
	ALLOCATE(UMAT(LIMB2MEM,LIMB2MEM))
	ALLOCATE(GMAT(LIMB2MEM,LIMB2MEM))
	ALLOCATE(UBAR(0:LMAXBMEM,0:LMAXBMEM))
	ALLOCATE(GBAR(0:LMAXBMEM,0:LMAXBMEM))
	ALLOCATE(UINT(-L:L,-L:L,-L:L,-L:L))
	ALLOCATE(GINT(-L:L,-L:L,-L:L,-L:L))
	CALL LIB_HUBMAT_L2(IATOM,UMAT,GMAT,UBAR,GBAR)
	DO M=-L,L
	DO K=-L,L
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+K)+L+M+1          !  (l,m k) packed
	DO M1=-L,L
	DO K1=-L,L
	IU1=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+K1)+L+M1+1       !  (l,m1 k1) packed
	UINT(M,M1,K,K1)=UMAT(IU,IU1)
	GINT(M,M1,K1,K)=GMAT(IU,IU1)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C AVERAGE INTERACTION
	UPAR=0.D0
	DLL=1.D0/DBLE(2*L+1)/DBLE(2*L+1)
	DO M2=-L,L                                !!! over m
	DO M1=-L,L                                !!! over m1
	UPAR=UPAR+DLL*UINT(M2,M1,M2,M1)
	ENDDO                                     !!! over m1
	ENDDO                                     !!! over m
	EFRM=EF
C COUNT DEGENERACIES
	NDEG=2*(2*L+1)
	NDIM=NSPIN*(2*L+1)
	NREP=1
	DO IBND=2,NDIM
	IF(ABS(EVAL(IBND-1)-EVAL(IBND)).LE.EPSDEG)CYCLE
	NREP=NREP+1
	ENDDO
	ALLOCATE(LREP(NREP))
	ALLOCATE(KREP(NREP))
	IREP=1
	KREP(1)=1
	DO IBND=2,NDIM
	IF(ABS(EVAL(IBND-1)-EVAL(IBND)).LE.EPSDEG)KREP(IREP)=KREP(IREP)+1
	IF(ABS(EVAL(IBND-1)-EVAL(IBND)).LE.EPSDEG)CYCLE
	IREP=IREP+1
	KREP(IREP)=1
	ENDDO
	DO IREP=1,NREP
	LREP(IREP)=KREP(IREP)*2/NSPIN
	ENDDO
	IDEG=0
	DO IREP=1,NREP
	IDEG=IDEG+KREP(IREP)
	ENDDO
	IF(IDEG.NE.NDIM)CALL FULLSTOP('<DMF_IMPLEV>: Wrong degeneracy')
C LEVELS WITHIN SU(N)
	ALLOCATE(ELOC(NREP))
	ALLOCATE(EDOP(NREP))
	IDIM=0
	DO IREP=1,NREP
	ELOC(IREP)=0.D0
	DO IALP=1,KREP(IREP)
	IDIM=IDIM+1
	ELOC(IREP)=ELOC(IREP)+EVAL(IDIM)-SI0L(IDIM,IDIM)-EFRM
	ENDDO
	ELOC(IREP)=ELOC(IREP)/DBLE(KREP(IREP))
	EDOP(IREP)=ELOC(IREP)+DBLE(NDEG-1)/2.D0*UPAR
	ENDDO
C CONFIGURATIONS, Minimum: NDEG+1, Maximum 2**NDEG
	NCNF=1
	DO IREP=1,NREP
	NCNF=NCNF*(KREP(IREP)*2/NSPIN+1)
	ENDDO
C MEMORY DEALLOCATIONS
	DEALLOCATE(LREP,KREP,EVAL,SI0L,EIML,OVRL,TRCS,EMAT,OMAT)
	DEALLOCATE(UMAT,GMAT,UBAR,GBAR,UINT,GINT,ELOC,EDOP)
 1000	CONTINUE                            !!! over l
 2000	CONTINUE                            !!! over atoms
	END
