      SUBROUTINE DMF_LMTEXP(IPNT,IMSC,IENW,EFRM)
*************************************************************
* Subroutine adds self-energy part to the hamiltonian       *
*************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                          !!! from setup
      USE COM_CONTROL ,ONLY: LMTO,IASA,NPFR,NOVR,IDMF         !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS
     &                      ,IS,ILSB,ILST                     !!! from readini
      USE COM_LATPAR  ,ONLY: PAR,OMEGAC                       !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP                   !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN                      !!! from readini
      USE COM_SPHERE  ,ONLY: SMT,SWZ                          !!! from readini
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDH          !!! from readini
      USE COM_INDORB  ,ONLY: INDDMF                           !!! from lmtpar
      USE COM_LMTMAT  ,ONLY: HMAT,OMAT                        !!! from lmtmat
      USE COM_HUBDAT  ,ONLY: MCRL,LCRL                        !!! from readhub
      USE COM_IMPDAT  ,ONLY: NPOLIMP                          !!! from readhub
	USE COM_RATDAT  ,ONLY: VRAT,WRAT,PRAT,ORAT
      USE COM_LMTPAR  ,ONLY: GAM,AAH,AAJ,BBH,BBJ              !!! from potpar
      USE COM_MSBMESH ,ONLY: TEMP                             !!! from readhub
      USE COM_INPTTR  ,ONLY: NDIV,NDIC,SH                     !!! from readini
      USE COM_KMESH   ,ONLY: NPNT,PNT                         !!! from tetra
      USE COM_WMESH   ,ONLY: NPNW,PNW                         !!! from tetra
      USE COM_CHANNELS,ONLY: IUNMT,IUHAM                      !!! from lmtmat
      USE COM_STRCON  ,ONLY: SSCON,SDCON                      !!! from strgnt
      USE COM_MASHDEP ,ONLY: LENCMP                           !!! from setup
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT,IUI                  !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: SV(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: SW(:,:,:,:)
      COMPLEX*16  HHH,HS,OS
	LOGICAL LOG
	DATA PI/3.141592653589793D0/
	CALL  ABORTNOW()
	IF(IDMF.NE.4)RETURN
C MEMORY ALLOCATIONS
	NDIM=NBNDT(1)*NSPIN
      NDIR=(NBNDT(1)+NBNDH(1))*NSPIN
	ALLOCATE(SV(NBNDT(1),LIMBMEM,NATOMMEM,NPOLMEM))
	ALLOCATE(SW(NBNDT(1),LIMBMEM,NATOMMEM,NPOLMEM))
      SIZE_MAT=2.D0*DBLE(SIZE(OMAT)*LENCMP)/1024.D0**2
      CURMEM=CURMEM+SIZE_MAT
      IF(TOTMEM.LT.CURMEM)TXTMEM='<DMF_LMTEXP> Subroutine'
      IF(TOTMEM.LT.CURMEM)TOTMEM=CURMEM
C K-POINT
	IF(IENW.EQ.0)THEN
	XK=PNT(1,IPNT,1)+SH(1,1)
	YK=PNT(2,IPNT,1)+SH(2,1)
	ZK=PNT(3,IPNT,1)+SH(3,1)
	ELSE
	XK=PNW(1,IPNT,1)+SH(1,1)
	YK=PNW(2,IPNT,1)+SH(2,1)
	ZK=PNW(3,IPNT,1)+SH(3,1)
	ENDIF
C *****************************************************
C SET EXPANSION OF THE HAMILTONIAN
      DO 2000 IORBS=1,NORBS
      DO 1000 IUPDN=1,NSPIN
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
C SET CONVOLUTIONS OF THE STRUCTURE CONSTANTS
	DO IKAP1=1,NKAP(1)                  !!! over ikap1
	DO IATOM1=1,NATOM                   !!! over iatom1
	ISORT1=IS(IATOM1)
	DO L1=0,ILSB(ISORT1)                !!! over l1
	IF(.NOT.LTPAN(L1,IATOM1,IKAP1,1))CYCLE
	DO M1=-L1,L1                        !!! over m1
	L1M1=L1*(L1+1)+M1+1
	ICON1=INDDMF(L1M1,IATOM1,IKAP1,1)
C Zeroise
	DO IATOM=1,NATOM                    !!! over iatom
	ISORT=IS(IATOM)
	DO L=0,LMAXBMEM                     !!! over l
	DO M=-L,L                           !!! over m
	LM=L*(L+1)+M+1
	DO IPOL=1,NPOLMEM
	SV(ICON1,LM,IATOM,IPOL)=(0.D0,0.D0)
	SW(ICON1,LM,IATOM,IPOL)=(0.D0,0.D0)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C Compute
	DO IATOM=1,NATOM                    !!! over iatom
	ISORT=IS(IATOM)
	IF(MCRL(IATOM).EQ.0)CYCLE
	DO L=0,ILSB(ISORT)                  !!! over l
	IF(LCRL(L,IATOM).EQ.0)CYCLE
	DO M=-L,L                           !!! over m
	LM=L*(L+1)+M+1
	DO IPOL=1,NPOLIMP(L,IATOM)          !!! over poles
C H term
	IF(IATOM1.EQ.IATOM.AND.L1.EQ.L)THEN
	IV=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M1+1 !!! (l,m1 m)
	SV(ICON1,LM,IATOM,IPOL)=VRAT(IV,IATOM,IUPDN,IORBS,IPOL)*
     &DCONJG(AAH(L,ISORT,IKAP1,1,ISPIN1))
	IW=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M1)+L+M+1 !!! (l,m m1)
	SW(ICON1,LM,IATOM,IPOL)=WRAT(IW,IATOM,IUPDN,IORBS,IPOL)*
     &       AAH(L,ISORT,IKAP1,1,ISPIN)
	ENDIF
C J term
	DO K=-L,L
	LK=L*(L+1)+K+1
	IV=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+K+1 !!! (l,k m)
	SV(ICON1,LM,IATOM,IPOL)=SV(ICON1,LM,IATOM,IPOL)-
     &DCONJG(SSCON(LK,IATOM,L1M1,IATOM1,IKAP1))*
     &DCONJG(AAJ(L,ISORT,IKAP1,1,ISPIN1))*GAM(L,ISORT)*
     &       VRAT(IV,IATOM,IUPDN,IORBS,IPOL)
	IW=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+K)+L+M+1 !!! (l,m k)
 	SW(ICON1,LM,IATOM,IPOL)=SW(ICON1,LM,IATOM,IPOL)-
     &       AAJ(L,ISORT,IKAP1,1,ISPIN)*GAM(L,ISORT)*
     &       WRAT(IW,IATOM,IUPDN,IORBS,IPOL)*
     &       SSCON(LK,IATOM,L1M1,IATOM1,IKAP1)
	ENDDO
	ENDDO                               !!! over poles
      ENDDO                               !!! over m
      ENDDO                               !!! over l
	ENDDO                               !!! over iatom
      ENDDO                               !!! over m1
      ENDDO                               !!! over l1
      ENDDO                               !!! over iatom1
      ENDDO                               !!! over ikap1
C BUILD HAMILTONIAN AND OVERLAP MATRIX WITH SELF-ENERGY IN IT
	NSHF=0
	DO IATOM=1,NATOM                    !!! over iatom
	ISORT=IS(IATOM)
	IF(MCRL(IATOM).EQ.0)CYCLE
	DO L=0,ILSB(ISORT)                  !!! over l
	IF(LCRL(L,IATOM).EQ.0)CYCLE
	DO IPOL=1,NPOLIMP(L,IATOM)          !!! over poles
	ISH1=(ISPIN1-1)*(NBNDT(1)+NBNDH(1))+NBNDT(1)+
     &     (2*L+1)*(IPOL-1)+NSHF
	ISH =(ISPIN -1)*(NBNDT(1)+NBNDH(1))+NBNDT(1)+
     &     (2*L+1)*(IPOL-1)+NSHF
	DO M1=-L,L                          !!! over m1
	LM1=L*(L+1)+M1+1
C	IDIM1=INDDMF(LM1,IATOM,IKAP1,ISPIN1)
	IDIR1=M1+L+1+ISH1
	DO M=-L,L                           !!! over m
	LM=L*(L+1)+M+1
C	IDIM =INDDMF(LM ,IATOM,IKAP,ISPIN)
	IDIR =M +L+1+ISH
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M1+1 !!! (l,m1 m)
	HMAT(IDIR1,IDIR)=PRAT(IU,IATOM,IUPDN,IORBS,IPOL)+
     &            EFRM*ORAT(IU,IATOM,IUPDN,IORBS,IPOL)
	OMAT(IDIR1,IDIR)=ORAT(IU,IATOM,IUPDN,IORBS,IPOL)
      ENDDO                               !!! over m
      ENDDO                               !!! over m1
	ENDDO                               !!! over poles
	NSHF=NSHF+NPOLIMP(L,IATOM)*(2*L+1)
      ENDDO                               !!! over l
      ENDDO                               !!! over iatom
C
	NSHF=0
	DO IATOM1=1,NATOM                   !!! over iatom1
	ISORT1=IS(IATOM1)
	IF(MCRL(IATOM1).EQ.0)CYCLE
	DO L1=0,ILSB(ISORT1)                !!! over l1
	IF(LCRL(L1,IATOM1).EQ.0)CYCLE
	DO IPOL=1,NPOLIMP(L1,IATOM1)        !!! over poles
	ISH1=(ISPIN1-1)*(NBNDT(1)+NBNDH(1))+NBNDT(1)+
     &     (2*L1+1)*(IPOL-1)+NSHF
	DO M1=-L1,L1                        !!! over m1
	L1M1=L1*(L1+1)+M1+1
	IDIR1=M1+L1+1+ISH1
	DO IKAP=1,NKAP(1)                   !!! over ikap
	DO IATOM=1,NATOM                    !!! over iatom
	ISORT=IS(IATOM)
	DO L=0,ILSB(ISORT)                  !!! over l
	IF(.NOT.LTPAN(L,IATOM,IKAP,1))CYCLE
	DO M=-L,L                           !!! over m
	LM=L*(L+1)+M+1
	ICON=INDDMF(LM,IATOM,IKAP,1)
	IDIM=INDDMF(LM,IATOM,IKAP,ISPIN)
	HMAT(IDIR1,IDIM)=SW(ICON,L1M1,IATOM1,IPOL)
	OMAT(IDIR1,IDIM)=(0.D0,0.D0)
      ENDDO                               !!! over m
      ENDDO                               !!! over l
      ENDDO                               !!! over iatom
      ENDDO                               !!! over ikap
      ENDDO                               !!! over m1
	ENDDO                               !!! over poles
	NSHF=NSHF+NPOLIMP(L1,IATOM1)*(2*L1+1)
      ENDDO                               !!! over l1
      ENDDO                               !!! over iatom1
C
	NSHF=0
	DO IATOM=1,NATOM                    !!! over iatom
	ISORT=IS(IATOM)
	IF(MCRL(IATOM).EQ.0)CYCLE
	DO L=0,ILSB(ISORT)                  !!! over l
	IF(LCRL(L,IATOM).EQ.0)CYCLE
	DO IPOL=1,NPOLIMP(L,IATOM)          !!! over poles
	ISH=(ISPIN-1)*(NBNDT(1)+NBNDH(1))+NBNDT(1)+
     &    (2*L+1)*(IPOL-1)+NSHF
	DO M=-L,L                           !!! over m
	LM=L*(L+1)+M+1
	IDIR=M+L+1+ISH
	DO IKAP1=1,NKAP(1)                  !!! over ikap1
	DO IATOM1=1,NATOM                   !!! over iatom
	ISORT1=IS(IATOM1)
	DO L1=0,ILSB(ISORT1)                !!! over l1
	IF(.NOT.LTPAN(L1,IATOM1,IKAP1,1))CYCLE
	DO M1=-L1,L1                        !!! over m1
	L1M1=L1*(L1+1)+M1+1
	ICON1=INDDMF(L1M1,IATOM1,IKAP1,1)
	IDIM1=INDDMF(L1M1,IATOM1,IKAP1,ISPIN1)
	HMAT(IDIM1,IDIR)=SV(ICON1,LM,IATOM,IPOL)
	OMAT(IDIM1,IDIR)=(0.D0,0.D0)
      ENDDO                               !!! over m1
      ENDDO                               !!! over l1
      ENDDO                               !!! over iatom1
      ENDDO                               !!! over ikap1
      ENDDO                               !!! over m
	ENDDO                               !!! over poles
	NSHF=NSHF+NPOLIMP(L,IATOM)*(2*L+1)
      ENDDO                               !!! over l
      ENDDO                               !!! over iatom
 1000	CONTINUE                            !!! over spins
 2000	CONTINUE                            !!! over iorbs
C ERROR HANDLINGS
C none
C MEMORY DEALLOCATIONS
	DEALLOCATE(SV,SW)
      CURMEM=CURMEM-SIZE_MAT
	END
