	SUBROUTINE DMF_LMTIMA
************************************************************
*   The calculation of Green's function                    *
************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                   !!! from setup
      USE COM_CONTROL ,ONLY: LIFT,LMTO,IDMF                            !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS                !!! from readini
      USE COM_SPHERE  ,ONLY: ZNUC,ZCOR,ZSEM,ZVAL                       !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP                                 !!! from readini
      USE COM_KMESH   ,ONLY: NPNT,PNT                                  !!! from tetra
      USE COM_WMESH   ,ONLY: NPNW,PNW                                  !!! from tetra
      USE COM_MSBMESH ,ONLY: TEMP,NMSC,WMSC                            !!! from readhub
      USE COM_DMFPAR  ,ONLY: NDIT                                      !!! from readhub
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC                   !!! from readini
	USE COM_FERMI   ,ONLY: EF,ZDFT,KFRM                              !!! from ttrints
      USE COM_LMTOUT  ,ONLY: ICCON,ICGRF,ICHYB                         !!! from readini
      USE COM_CHANNELS,ONLY: IUCON,IUNMT,IUPDS,IUHAM,IUCEW
     &                      ,IUSCF,IUGRF,IUHYB                         !!! from channels
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT,IUI                           !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
      DATA PI/3.141592653589793D0/
	IF(IDMF.NE.3)RETURN
C Compute radial matrix elements
	CALL BND_POTPAR(1)                   !!! different potential partameters
	CALL BND_LMTPAR(1)                   !!! some combinations of parameters
	CALL BND_OVRPAR(1)                   !!! potential parameters for overlapping
C Memory allocations
	CALL DMF_ALLOCATE('A')
C ******************************************************
C THE DMFT LOOP
C ******************************************************
	DO 1000 ITER=1,NDIT
	WRITE(IUN,10010)iter
      CALL DMF_MIXDMF(0,ITER,IEXIT,0)      !!! initialize Broyden
C COMPUTE PARAMETERS
	CALL DMF_GRFPAR                      !!! prepare parameters
C LOOPING OVER IMAGINARY ENERGIES
	DO IMSC=0,NMSC+1                     !!! over Matsubara frequencies
	CALL DMF_SIGMAW(IMSC)                !!! Set self-energy
	CALL DMF_SGMPAR(1)
C COMPUTE POLES OF THE GREENS FUNCTION
	DO IPNT=1,NPNT(1)                    !!! over k-points
      CALL BND_STRSUM(IPNT,1,0)            !!! calculate lattice sums
      CALL BND_STRGNT(IPNT,1,0,0)          !!! restore bare structure matrices
      CALL HOP_STRALP(IPNT,1,0)            !!! screen structure constants
      CALL HOP_SCRSTR(IPNT,1,0)            !!! restore screened structure constants
	CALL DMF_LMTMAT(IPNT,IMSC,0)         !!! Build H+Self-energy
	CALL DMF_GRFBND(IPNT,IMSC,0,0)       !!! solve eigenvalue problem
	CALL DMF_LMTFAT(IPNT,IMSC,0)         !!! store fat bands information
      ENDDO                                !!! over k-points
	CLOSE(UNIT=IUNMT,STATUS='DELETE')
	IF(ICCON.EQ.0)CLOSE(UNIT=IUCON,STATUS='DELETE')
	IF(ICCON.NE.0)CLOSE(UNIT=IUCON,STATUS='KEEP')
	ENDDO                                !!! over Matsubara frequencies
C REORDER COMPLEX EIGENVALUES BY LINKING IMAGINARY PARTS
      CALL DMF_ORDBND(NMSC+1)
C COMPUTE INTEGRATION WEIGHTS
	CALL DMF_GRFWGT(NMSC+1)             !!! find projection weights
	CALL DMF_TTRINT(EF,0,(0.D0,0.D0),TOS,DOS,0,0,0)
C SET IMPURITY LEVELS AND LOCAL GREEN FUNCTION
	CALL DMF_GRFLEV(NMSC+1)              !!! find impurity levels
	CALL DMF_IMPLEV(NMSC+1)              !!! diagonalize impurty levels
	CALL DMF_GRFLOC(NMSC+1)              !!! local Green function (direct method)
C SET HYBRIDIZATION FUNCTION
	CALL DMF_IMPHYB                      !!! Compute hybridization function
 	CALL DMF_SETGRF                      !!! Store Green function
 	CALL DMF_SETHYB                      !!! Store Hybridization
	IF(ICGRF.GT.0.OR.ICHYB.GT.0)RETURN
C COMPUTE FERMI ENERGY
	IF(KFRM.EQ.0)
     &CALL DMF_FRMFND(EF,ZDFT,EF,0,100,1.D-05,0.8D0)
C COMPUTE INTEGRATION WEIGHTS
	CALL DMF_GRFWGT(NMSC+1)              !!! find projection weights
	CALL DMF_TTRINT(EF,0,(0.D0,0.D0),TOS,DOS,0,0,0)
	CALL DMF_HUBMAT(NMSC+1)              !!! compute density matrix
C Delete scratch files
	CLOSE(UNIT=IUCEW,STATUS='DELETE')
C MIX HYBRIDIZATIONS
      CALL DMF_MIXDMF(0,ITER,IEXIT,1)      !!! mix hybridizations
	CALL DMF_GRFERR(0,1,ITER)            !!! suppress errors
	IF(IEXIT.EQ.1)GOTO 2000
C FIND NEW SELF-ENERGY
      CALL DMF_IMPMOD                      !!! solve Anderson impurity model
	CALL DMF_GRFERR(0,2,ITER)            !!! suppress errors
C COMPUTE TOTAL ENERGY OF THE MODEL
	CALL DMF_ENERGY                      !!! energies
      CALL DMF_MIXDMF(0,ITER,IEXIT,2)      !!! mix self-energies
	CALL HUB_WRITEHUB(2)                 !!! Store Self-energy
	IF(IEXIT.EQ.1)GOTO 2000
 1000	CONTINUE
C ******************************************************
C DMFT LOOP DONE, FIND NEW DENSITY
C ******************************************************
 2000	CONTINUE
	CALL DMF_GRFPAR                      !!! prepare parameters
	CALL BND_NULINT(1)
	DO IMSC=0,NMSC+1                     !!! over Matsubara frequencies
	CALL DMF_SIGMAW(IMSC)                !!! Set self-energy
	CALL DMF_SGMPAR(1)
	DO IPNT=1,NPNT(1)                    !!! over k-points
      CALL BND_STRSUM(IPNT,1,0)            !!! calculate lattice sums
      CALL BND_STRGNT(IPNT,1,0,0)          !!! restore bare structure matrices
      CALL HOP_STRALP(IPNT,1,0)            !!! screen structure constants
      CALL HOP_SCRSTR(IPNT,1,0)            !!! restore screened structure constants
	CALL DMF_LMTMAT(IPNT,IMSC,0)         !!! Build H+Self-energy
	CALL DMF_GRFBND(IPNT,IMSC,0,1)       !!! solve eigenvalue problem
	CALL DMF_ORDVEC(IPNT,IMSC,0)         !!! reorder eigenvectors
	CALL DMF_TOSPAR(IPNT,IMSC,0)         !!! Compute TOS-matrix
	CALL DMF_TOSINT(IPNT,IMSC,0)         !!! Compute interstitial density
      ENDDO                                !!! over k-points
	CLOSE(UNIT=IUNMT,STATUS='DELETE')
	IF(ICCON.EQ.0)CLOSE(UNIT=IUCON,STATUS='DELETE')
	IF(ICCON.NE.0)CLOSE(UNIT=IUCON,STATUS='KEEP')
	ENDDO                                !!! over Matsubara frequencies
      CALL BND_TOSEND(1,1)                 !!! make final pseudodensity
C SYMMETRIZE NUMBER OF STATES MATRIX
      CALL RHO_RHOFILES(IUSCF,'!','A')     !!! initialize new charge density
	CALL BND_SYMTOS                      !!! Symmetrize density matrix
	CLOSE(UNIT=IUCEW,STATUS='DELETE')
	CLOSE(UNIT=IUPDS,STATUS='DELETE')
	CLOSE(UNIT=IUHAM,STATUS='DELETE')
	IF(ICCON.EQ.0)CLOSE(UNIT=IUCON,STATUS='DELETE')
	IF(ICCON.NE.0)CLOSE(UNIT=IUCON,STATUS='KEEP')
C Memory deallocations
	CALL DMF_ALLOCATE('D')
10010	FORMAT(' Dmft Iteration ',I3/)
	END
