	SUBROUTINE DMF_LMTMAS(IPNT,IMSC,IENW)
************************************************************
* Recalculates overlap matrix with mass quasiparticles    *
************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                          !!! from setup
      USE COM_CONTROL ,ONLY: LMTO,IASA,NPFR,NOVR              !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS
     &                      ,IS,ILSB,ILST                     !!! from readini
      USE COM_LATPAR  ,ONLY: PAR,OMEGAC                       !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP                   !!! from readini
      USE COM_DMFDAT  ,ONLY: RMAS                             !!! from readhub
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN                      !!! from readini
      USE COM_SPHERE  ,ONLY: SMT,SWZ                          !!! from readini
      USE COM_HUBDAT  ,ONLY: MCRL,LCRL                        !!! from readhub
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDH          !!! from readini
      USE COM_MTSPAR  ,ONLY: OMTHH,OMTJH,OMTHJ,OMTJJ          !!! from lmtpar
      USE COM_OVRPAR  ,ONLY: OPARHH,OPARJH,OPARHJ,OPARJJ      !!! from ovrpar
      USE COM_HAMPAR  ,ONLY: HPARHH,HPARJH,HPARHJ,HPARJJ      !!! from nmtpar
      USE COM_INDORB  ,ONLY: INDDMF                           !!! from lmtpar
      USE COM_LMTMAT  ,ONLY: OMAT                             !!! from lmtmat
      USE COM_STRCON  ,ONLY: SSCON,SDCON                      !!! from strgnt
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: HSS(:,:)
      COMPLEX*16  OOO
      LOGICAL LOG1,LOG
C MEMORY ALLOCATIONS
	CALL ABORTNOW()
	ALLOCATE(HSS(LIMTMEM,NATOMMEM))
C DO GLOBALLY OVER SPINS, SET UP-UP, DN-DN HAMILTONIAN 
	DO 2000 IORBS=1,NORBS          !!! over iorbs
	DO 1000 IUPDN=1,NSPIN          !!! over spins
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
	IF(ISPIN1.NE.ISPIN)GOTO 1000
	DO IKAP1=1,NKAP(1)             !!! over energy
	DO IKAP =1,NKAP(1)             !!! over energy
	DO IATOM=1,NATOM               !!! compute overlap matrix elements
	ISORT=IS(IATOM)
C SET ZEROES
	DO L1=0,ILST(ISORT)            !!! over l1
	LOG1=.FALSE.
	IF(LTPAN(L1,IATOM,IKAP1,1))LOG1=.TRUE.
	DO M1=-L1,L1                   !!! over m1
	L1M1=L1*(L1+1)+M1+1
	DO L=0,ILST(ISORT)             !!! over l
	LOG=.FALSE.
	IF(LTPAN(L,IATOM,IKAP,1))LOG=.TRUE.
	DO M=-L,L                      !!! over m
	LM=L*(L+1)+M+1
	IF(L1.LE.ILSB(ISORT).AND.L.LE.ILSB(ISORT))
     &HPARHH(L1M1,LM,IATOM)=(0.D0,0.D0)
	IF(L.LE.ILSB(ISORT))
     &HPARJH(L1M1,LM,IATOM)=(0.D0,0.D0)
	IF(L1.LE.ILSB(ISORT))
     &HPARHJ(L1M1,LM,IATOM)=(0.D0,0.D0)
	HPARJJ(L1M1,LM,IATOM)=(0.D0,0.D0)
      ENDDO                          !!! over m
      ENDDO                          !!! over l
      ENDDO                          !!! over m1
      ENDDO                          !!! over l1
C SET MATRIX ELEMENTS OF ORDINARY OVERLAP MATRIX
	DO L=0,ILST(ISORT)
	LOG1=.FALSE.
	IF(LTPAN(L,IATOM,IKAP1,1))LOG1=.TRUE.
	LOG=.FALSE.
	IF(LTPAN(L,IATOM,IKAP,1))LOG=.TRUE.
	DO M=-L,L                      !!! over m
	LM=L*(L+1)+M+1
	IF(LOG1.AND.LOG)
     &HPARHH(LM,LM,IATOM)=HPARHH(LM,LM,IATOM)+
     &OPARHH(IKAP1,IKAP,L,ISORT,ISPIN)
 	IF(LOG)
     &HPARJH(LM,LM,IATOM)=HPARJH(LM,LM,IATOM)+
     &OPARJH(IKAP1,IKAP,L,ISORT,ISPIN)
 	IF(LOG1)
     &HPARHJ(LM,LM,IATOM)=HPARHJ(LM,LM,IATOM)+
     &OPARHJ(IKAP1,IKAP,L,ISORT,ISPIN)
      HPARJJ(LM,LM,IATOM)=HPARJJ(LM,LM,IATOM)+
     &OPARJJ(IKAP1,IKAP,L,ISORT,ISPIN)
      ENDDO                          !!! over m
      ENDDO                          !!! over l
C SET MATRIX ELEMENTS DUE TO EFFECTIVE MASS
	DO L=0,ILSB(ISORT)
	IF(LCRL(L,IATOM).EQ.0)CYCLE
	LOG1=.FALSE.
	IF(LTPAN(L,IATOM,IKAP1,1))LOG1=.TRUE.
	LOG=.FALSE.
	IF(LTPAN(L,IATOM,IKAP,1))LOG=.TRUE.
	DO M1=-L,L                     !!! over m1
	LM1=L*(L+1)+M1+1
	DO M=-L,L                      !!! over m
	LM=L*(L+1)+M+1
      IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M1+1 !!! (l,m1 m)
	IF(LOG1.AND.LOG)
     &HPARHH(LM,LM,IATOM)=HPARHH(LM,LM,IATOM)+
     &OMTHH(IKAP1,IKAP,L,ISORT,ISPIN)*RMAS(IU,IATOM,IUPDN,IORBS)
 	IF(LOG)
     &HPARJH(LM,LM,IATOM)=HPARJH(LM,LM,IATOM)+
     &OMTJH(IKAP1,IKAP,L,ISORT,ISPIN)*RMAS(IU,IATOM,IUPDN,IORBS)
 	IF(LOG1)
     &HPARHJ(LM,LM,IATOM)=HPARHJ(LM,LM,IATOM)+
     &OMTHJ(IKAP1,IKAP,L,ISORT,ISPIN)*RMAS(IU,IATOM,IUPDN,IORBS)
      HPARJJ(LM,LM,IATOM)=HPARJJ(LM,LM,IATOM)+
     &OMTJJ(IKAP1,IKAP,L,ISORT,ISPIN)*RMAS(IU,IATOM,IUPDN,IORBS)
      ENDDO                          !!! over m
      ENDDO                          !!! over m1
      ENDDO                          !!! over l
      ENDDO                          !!! over atoms
C SET NEW OVERLAP MATRIX
	DO IATOM1=1,NATOM              !!! over iatom1
	ISORT1=IS(IATOM1)
	DO L1=0,ILSB(ISORT1)           !!! over l1
	IF(.NOT.LTPAN(L1,IATOM1,IKAP1,1))CYCLE
	DO M1=-L1,L1                   !!! over m1
	L1M1=L1*(L1+1)+M1+1
	IDIM1=INDDMF(L1M1,IATOM1,IKAP1,ISPIN1)
	DO KATOM=1,NATOM
	DO L3M3=1,(ILST(IS(KATOM))+1)**2
	HSS(L3M3,KATOM)=(0.D0,0.D0)
	DO L2M2=1,(ILST(IS(KATOM))+1)**2
	HSS(L3M3,KATOM)=HSS(L3M3,KATOM)+
     &CONJG(SSCON(L2M2,KATOM,L1M1,IATOM1,IKAP1))*
     &HPARJJ(L2M2,L3M3,KATOM)
      ENDDO         
      ENDDO         
      ENDDO         
	DO IATOM=1,NATOM            !!! over iatom
	ISORT=IS(IATOM)
	DO L=0,ILSB(ISORT)          !!! over l
	IF(.NOT.LTPAN(L,IATOM,IKAP,1))CYCLE
	DO M=-L,L                   !!! over m
	LM=L*(L+1)+M+1
	IDIM=INDDMF(LM,IATOM,IKAP,ISPIN)
	IF(IDIM1.GE.IDIM)THEN
	OOO=(0.D0,0.D0)
C ONE-CENTER TERM :
	IF(IATOM1.EQ.IATOM)THEN
	OOO=OOO+HPARHH(L1M1,LM,IATOM)
	ENDIF
C TWO-CENTER TERM :
	DO L2M2=1,(ILST(ISORT)+1)**2      !!! over l2m2
	OOO=OOO-HPARJH(L2M2,LM,IATOM)*
     &CONJG(SSCON(L2M2,IATOM,L1M1,IATOM1,IKAP1))
      ENDDO                             !!! over l2m2
	DO L2M2=1,(ILST(ISORT1)+1)**2     !!! over l2m2
	OOO=OOO-HPARHJ(L1M1,L2M2,IATOM1)*
     &SSCON(L2M2,IATOM1,LM,IATOM,IKAP)
      ENDDO                             !!! over l2m2
C ADD SDCON MATRIX IN CASE EQUAL ENERGIES
	IF(ABS(EKAP(IKAP,1)-DCONJG(EKAP(IKAP1,1))).
     &   LE.1.D-10.AND.ISPIN1.EQ.ISPIN)THEN
	IF(NOVR.EQ.0)
     &OOO=OOO-CONJG(SDCON(LM,IATOM,L1M1,IATOM1,IKAP))*PAR**3
	ENDIF
C THREE-CENTER TERM :
	DO KATOM=1,NATOM                  !!! over katom
	KSORT=IS(KATOM)
	DO L2=0,ILST(KSORT)               !!! over l2
	DO M2=-L2,L2                      !!! over m2
	L2M2=L2*(L2+1)+M2+1
	OOO=OOO+HSS(L2M2,KATOM)*SSCON(L2M2,KATOM,LM,IATOM,IKAP)
      ENDDO                             !!! over m2
      ENDDO                             !!! over l2
      ENDDO                             !!! over katom
C SET ZEROES WHERE NECESSARY
	IF(ISPIN1.NE.ISPIN)OOO=(0.D0,0.D0)
	ORE= DREAL(OOO)  ! real part of the overlap matrix
	OIM= DIMAG(OOO)  ! imaginary part of the overlap matrix
	IF(IDIM1.EQ.IDIM)OIM=0.D0
C SET HAMILTONIAN AND OVERLAP MATRICES
      OMAT(IDIM1,IDIM)=DCMPLX(ORE,+OIM)
      OMAT(IDIM,IDIM1)=DCONJG(OMAT(IDIM1,IDIM))
	ENDIF
      ENDDO                             !!! over m
      ENDDO                             !!! over l
      ENDDO                             !!! over iatom
      ENDDO                             !!! over m1
      ENDDO                             !!! over l1
      ENDDO                             !!! over iatom1
      ENDDO                             !!! over energy
      ENDDO                             !!! over energy
1000  CONTINUE                          !!! over spins
2000  CONTINUE                          !!! over iorbs
C MEMORY DEALLOCATIONS
	DEALLOCATE(HSS)
	END
