	SUBROUTINE DMF_LMTMAT(IPNT,IMSC,IENW)
*************************************************************
* Subroutine calculates self-energy part of the hamiltonian *
*************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                          !!! from setup
      USE COM_CONTROL ,ONLY: LMTO,IASA,NPFR,NOVR,IDMF         !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS
     &                      ,IS,ILSB,ILST                     !!! from readini
      USE COM_LATPAR  ,ONLY: PAR,OMEGAC                       !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP                   !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN                      !!! from readini
      USE COM_SPHERE  ,ONLY: SMT,SWZ                          !!! from readini
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDH          !!! from readini
      USE COM_HAMPAR  ,ONLY: HPARHH,HPARJH,HPARHJ,HPARJJ      !!! from nmtpar
      USE COM_INDORB  ,ONLY: INDDMF                           !!! from lmtpar
      USE COM_LMTMAT  ,ONLY: HMAT,OMAT                        !!! from lmtmat
      USE COM_HUBDAT  ,ONLY: MCRL,LCRL,KHRM,GDMP              !!! from readhub
	USE COM_MSBMESH ,ONLY: TEMP                             !!! from readhub
      USE COM_INPTTR  ,ONLY: NDIV,NDIC,SH                     !!! from readini
      USE COM_KMESH   ,ONLY: NPNT,PNT                         !!! from tetra
      USE COM_WMESH   ,ONLY: NPNW,PNW                         !!! from tetra
      USE COM_CHANNELS,ONLY: IUNMT,IUHAM                      !!! from lmtmat
      USE COM_STRCON  ,ONLY: SSCON,SDCON                      !!! from strgnt
      USE COM_MASHDEP ,ONLY: LENCMP                           !!! from setup
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT,IUI                  !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: HSS(:,:)
	COMPLEX*16, ALLOCATABLE :: HTMP(:,:)
	COMPLEX*16, ALLOCATABLE :: OTMP(:,:)
      COMPLEX*16  HHH,HS,OS
	LOGICAL LOG
	DATA PI/3.141592653589793D0/
	CALL  ABORTNOW()
C MEMORY ALLOCATIONS
	NDIM=NBNDT(1)*NSPIN
      NDIR=(NBNDT(1)+NBNDH(1))*NSPIN
	ALLOCATE(HSS(LIMTMEM,NATOMMEM))
      ALLOCATE(HTMP(NDIM,NDIM),STAT=IALLOC)
      ALLOCATE(OTMP(NDIM,NDIM),STAT=IALLOC)
      SIZE_MAT=2.D0*DBLE(SIZE(OMAT)*LENCMP)/1024.D0**2
      CURMEM=CURMEM+SIZE_MAT
      IF(TOTMEM.LT.CURMEM)TXTMEM='<SGMMAT> Subroutine'
      IF(TOTMEM.LT.CURMEM)TOTMEM=CURMEM
C K-POINT
	IF(IENW.EQ.0)THEN
	XK=PNT(1,IPNT,1)+SH(1,1)
	YK=PNT(2,IPNT,1)+SH(2,1)
	ZK=PNT(3,IPNT,1)+SH(3,1)
	ELSE
	XK=PNW(1,IPNT,1)+SH(1,1)
	YK=PNW(2,IPNT,1)+SH(2,1)
	ZK=PNW(3,IPNT,1)+SH(3,1)
	ENDIF
	DUMP=-ABS(GDMP)
C     DUMP=0.D0	
C READ HAMILTONIAN
	IF(IENW.EQ.1)NSHIFT=0
	IF(IENW.EQ.0.AND.NPNW(1).EQ.NPNT(1))NSHIFT=0
	IF(IENW.EQ.0.AND.NPNW(1).GT.NPNT(1))NSHIFT=NSPIN*NORBS*NPNW(1)
	DO IORBS=1,NORBS
	DO IUPDN=1,NSPIN
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
	IREC=IUPDN+NSPIN*(IORBS-1)+NSPIN*NORBS*(IPNT-1)+NSHIFT
      READ(IUHAM,REC=IREC)
     &((HTMP(IDIM1+NBNDT(1)*(ISPIN1-1),IDIM+NBNDT(1)*(ISPIN-1)),
     &IDIM1=1,NBNDT(1)),IDIM=1,NBNDT(1)),
     &((OTMP(IDIM1+NBNDT(1)*(ISPIN1-1),IDIM+NBNDT(1)*(ISPIN-1)),
     &IDIM1=1,NBNDT(1)),IDIM=1,NBNDT(1))
	ENDDO
	ENDDO
C EXPAND HAMILTONIAN AND OVERLAP MATRIX TO ACCOUNT FOR NEW DIMENSION
	DO IDIR1=1,NDIR
	DO IDIR =1,NDIR
	HMAT(IDIR1,IDIR)=(0.D0,0.D0)
	OMAT(IDIR1,IDIR)=(0.D0,0.D0)
	ENDDO
	ENDDO
      DO IORBS=1,NORBS
      DO IUPDN=1,NSPIN
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
	DO IBND1=1,NBNDT(1)
	DO IBND =1,NBNDT(1)
	IDIR1=IBND1+(ISPIN1-1)*(NBNDT(1)+NBNDH(1))
	IDIR =IBND +(ISPIN -1)*(NBNDT(1)+NBNDH(1))
	IDIM1=IBND1+(ISPIN1-1)*NBNDT(1)
	IDIM =IBND +(ISPIN -1)*NBNDT(1)
	HMAT(IDIR1,IDIR)=HTMP(IDIM1,IDIM)
	OMAT(IDIR1,IDIR)=OTMP(IDIM1,IDIM)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C DO GLOBALLY OVER SPINS, SET UP-UP, DN-DN HAMILTONIAN 
	DO 2000 IORBS=1,NORBS       !!! over iorbs
	DO 1000 IUPDN=1,NSPIN       !!! over spins
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
	DO IKAP1=1,NKAP(1)          !!! over energy
	DO IKAP =1,NKAP(1)          !!! over energy
	DO IATOM=1,NATOM            !!! read three-center parameter
	ISORT=IS(IATOM)
	IREC=IKAP1+NKAP(1)*(IKAP-1)+NKAP(1)**2*(IATOM-1)+
     &NKAP(1)**2*NATOM*(IUPDN-1)+
     &NKAP(1)**2*NATOM*NSPIN*(IORBS-1)
	READ(IUNMT,REC=IREC)((HPARHH(L1M1,LM,IATOM),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((HPARJH(L1M1,LM,IATOM),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((HPARHJ(L1M1,LM,IATOM),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &((HPARJJ(L1M1,LM,IATOM),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2)
      ENDDO         
C SET HAMILTONIAN AND OVERLAP MATRIX
	DO IATOM1=1,NATOM           !!! over iatom1
	ISORT1=IS(IATOM1)
	DO L1=0,ILSB(ISORT1)        !!! over l1
	IF(.NOT.LTPAN(L1,IATOM1,IKAP1,1))CYCLE
	DO M1=-L1,L1                !!! over m1
	L1M1=L1*(L1+1)+M1+1
	IDIM1=INDDMF(L1M1,IATOM1,IKAP1,ISPIN1)
	DO KATOM=1,NATOM
	DO L3M3=1,(ILST(IS(KATOM))+1)**2
	HSS(L3M3,KATOM)=(0.D0,0.D0)
	DO L2M2=1,(ILST(IS(KATOM))+1)**2
	HSS(L3M3,KATOM)=HSS(L3M3,KATOM)+
     &CONJG(SSCON(L2M2,KATOM,L1M1,IATOM1,IKAP1))*
     &HPARJJ(L2M2,L3M3,KATOM)
      ENDDO         
      ENDDO         
      ENDDO         
	DO IATOM=1,NATOM            !!! over iatom
	ISORT=IS(IATOM)
	DO L=0,ILSB(ISORT)          !!! over l
	IF(.NOT.LTPAN(L,IATOM,IKAP,1))CYCLE
	DO M=-L,L                   !!! over m
	LM=L*(L+1)+M+1
	IDIM=INDDMF(LM,IATOM,IKAP,ISPIN)
	HHH=(0.D0,0.D0)
C ONE-CENTER TERM :
	IF(IATOM1.EQ.IATOM)THEN
	HHH=HHH+HPARHH(L1M1,LM,IATOM)
	ENDIF
C TWO-CENTER TERM :
	DO L2M2=1,(ILST(ISORT)+1)**2      !!! over l2m2
	HHH=HHH-HPARJH(L2M2,LM,IATOM)*
     &CONJG(SSCON(L2M2,IATOM,L1M1,IATOM1,IKAP1))
      ENDDO                             !!! over l2m2
	DO L2M2=1,(ILST(ISORT1)+1)**2     !!! over l2m2
	HHH=HHH-HPARHJ(L1M1,L2M2,IATOM1)*
     &SSCON(L2M2,IATOM1,LM,IATOM,IKAP)
      ENDDO                             !!! over l2m2
C THREE-CENTER TERM :
	DO KATOM=1,NATOM                  !!! over katom
	KSORT=IS(KATOM)
	DO L2=0,ILST(KSORT)               !!! over l2
	DO M2=-L2,L2                      !!! over m2
	L2M2=L2*(L2+1)+M2+1
	HHH=HHH+HSS(L2M2,KATOM)*SSCON(L2M2,KATOM,LM,IATOM,IKAP)
      ENDDO                             !!! over m2
      ENDDO                             !!! over l2
      ENDDO                             !!! over katom
C SET ZEROES WHERE NECESSARY
	HRE= DREAL(HHH)  ! real part of the hamiltonian matrix
	HIM= DIMAG(HHH)  ! imaginary part of the hamiltonian matrix
C     IF(ABS(HRE).LE.1.D-10)HRE=0.D0
C     IF(ABS(HIM).LE.1.D-10)HIM=0.D0
C     IF(ABS(ORE).LE.1.D-10)ORE=0.D0   ! not necessary now !
C     IF(ABS(OIM).LE.1.D-10)OIM=0.D0
C SET HAMILTONIAN AND OVERLAP MATRICES
      HMAT(IDIM1,IDIM)=HMAT(IDIM1,IDIM)+DCMPLX(HRE,+HIM)
C Add small imaginary part for non-hermitian runs
      IF(KHRM.EQ.0)
     &HMAT(IDIM1,IDIM)=HMAT(IDIM1,IDIM)+DCMPLX(0.D0,DUMP)*
     &                 OMAT(IDIM1,IDIM)
      ENDDO                             !!! over m
      ENDDO                             !!! over l
      ENDDO                             !!! over iatom
      ENDDO                             !!! over m1
      ENDDO                             !!! over l1
      ENDDO                             !!! over iatom1
      ENDDO                             !!! over energy
      ENDDO                             !!! over energy
1000  CONTINUE                          !!! over spins
2000  CONTINUE                          !!! over iorbs
C MEMORY DEALLOCATIONS
	DEALLOCATE(HTMP,OTMP,HSS)
	END
