	SUBROUTINE DMF_MIXDMF(KMSC,ITER,IEXIT,KEY)
**************************************************************
* Mixes self-energy function in the DMFT loop according to   *
* Broyden prescription.                                      *
**************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM
      USE COM_CONTROL ,ONLY: LIFT,LMTO,IDMF                          !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS,ILSB         !!! from readini
      USE COM_TBBPAR  ,ONLY: LTBAS,LSBAS,INBAS,NTBAS                 !!! from readhop
	USE COM_FERMI   ,ONLY: EF                                      !!! from ttrint
      USE COM_HUBDAT  ,ONLY: MCRL,LCRL                               !!! from readhub
      USE COM_MSBMESH ,ONLY: NMSC,TEMP,KGRD                          !!! from readhub
      USE COM_DMFPAR  ,ONLY: NDIT,EPSDMF,MIXBRD,ADMIXL,ADMIX1,MIXFUN !!! from readhub
      USE COM_HUBCOM  ,ONLY: DHUB,VDBC                               !!! from readhub
      USE COM_DMFDAT  ,ONLY: SIGW,DELW,SIGI,SIG0,GLOC,
     &                       EIMP,ELOC,OIMP,BMAS,DELI                !!! from mixdmf
      USE COM_LMTOUT  ,ONLY: SCRFILE                                 !!! from readini
      USE COM_LABELS  ,ONLY: TXTAT,TXTEL,TXTSP                       !!! from readini
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT                             !!! from setup
      USE COM_CHANNELS,ONLY: IUSGM,IUBSG                             !!! from channels
	USE COM_MASHDEP ,ONLY: NVAL,LENCMP                             !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8, ALLOCATABLE :: WRAD(:)
	REAL*8, ALLOCATABLE :: WTER(:)
	REAL*8, ALLOCATABLE :: FNOM(:)
	COMPLEX*16, ALLOCATABLE :: BETA(:,:)
	COMPLEX*16, ALLOCATABLE :: CMAT(:,:)
	COMPLEX*16, ALLOCATABLE :: GAMA(:,:)
	COMPLEX*16, ALLOCATABLE :: WBRO(:)
	COMPLEX*16, ALLOCATABLE :: WINP(:)
	COMPLEX*16, ALLOCATABLE :: WMIX(:,:)
      COMPLEX*16, ALLOCATABLE :: WRK1(:)
      COMPLEX*16, ALLOCATABLE :: WRK2(:)
      COMPLEX*16, ALLOCATABLE :: XINP(:)
      COMPLEX*16, ALLOCATABLE :: XOUT(:)
      LOGICAL FIRST,RESET
      CHARACTER TCPS*19,TC*19,TM*19
	SAVE FIRST,RESET,WTER,WMIX,WBRO,WINP
     &    ,MTER,FNOM,BETA,CMAT,GAMA,ADMIXB
      DATA PI/3.141592653589793D0/,FIRST/.TRUE./,ADMIXB/0.D0/
      CALL ABORTNOW()
	IF(KEY.NE.0.AND.KEY.NE.MIXFUN)RETURN
	IEXIT=0
C ALLOCATE DATA
      IF(FIRST)THEN
      ALLOCATE(WTER(0:NTERMEM))
	ALLOCATE(FNOM(NTERMEM))
	ALLOCATE(BETA(NTERMEM,NTERMEM))
	ALLOCATE(CMAT(NTERMEM,NTERMEM))
	ALLOCATE(GAMA(NTERMEM,NTERMEM))
      ALLOCATE(WBRO(NTERMEM))
      ALLOCATE(WINP(NTERMEM))
      ALLOCATE(WMIX(NTERMEM,NTERMEM))
      RESET=.TRUE.
	MTER=0
      ENDIF
	IF(ITER.EQ.1.AND.KEY.EQ.0)MTER=0
      FIRST=.FALSE.
C SET ITERATION NUMBER
	IF(MTER.EQ.NTERMEM-1)RESET=.TRUE.
	IF(MTER.EQ.NTERMEM-1)
     &WRITE(IUT,*)'<MIXDMF>:: Mter>Ntermem, Broyden restarted'
	IF(RESET)MTER=0
	IF(KEY.EQ.0.AND.MTER.NE.0)RETURN
	IF(KEY.NE.0)MTER=MTER+1
	IF(.NOT.MIXBRD.AND.MTER.NE.0)MTER=1 ! use linear mixing
C CHOOSE PROPER MIXING
	IF(MTER.GT.0.AND.ADMIXB.NE.0.D0)ADMIXB=ADMIXL
	IF(MTER.GT.0.AND.ADMIXB.EQ.0.D0)ADMIXB=ADMIX1
C SET LOOPING LIMITS
C DEFINE MAXIMUM SIZE OF THE BROYDEN ARRAY
      ILEN=0
	DO IATOM=1,NATOM           !!! over atoms
	ISORT=IS(IATOM)
	IF(MCRL(IATOM).EQ.0)CYCLE
	DO IORBS=1,NORBS           !!! over iorbs
	DO IUPDN=1,NSPIN           !!! over iupdn
	DO L=0,ILSB(ISORT)         !!! over l
	IF(LCRL(L,IATOM).EQ.0)CYCLE
	ILEN=ILEN+(NMSC+1)*(2*L+1)**2+5*(2*L+1)**2
	ENDDO                      !!! over l
	ENDDO                      !!! over iupdn
	ENDDO                      !!! over iorbs
	ENDDO                      !!! over atoms
      NLEN=ILEN+1
      NLENMEM=NLEN
C  MEMORY ALLOCATIONS
      ALLOCATE(WRAD(NLENMEM))
      ALLOCATE(WRK1(NLENMEM))
      ALLOCATE(WRK2(NLENMEM))
      ALLOCATE(XINP(NLENMEM))
      ALLOCATE(XOUT(NLENMEM))
      SIZE_HERE=5.D0*DBLE(SIZE(WRAD)*LENCMP)/1024.D0**2
      CURMEM=CURMEM+SIZE_HERE
      IF(TOTMEM.LT.CURMEM)TXTMEM='<MIXSIG> Subroutine'
      IF(TOTMEM.LT.CURMEM)TOTMEM=CURMEM
C  *** SET MIXING ARRAY ***
	EFRM=EF                    !!! Fermi level
      ILEN=0
	IREC=0
	DO IMSC=0,NMSC             !!! over Matsubara frequencies
	DO IATOM=1,NATOM           !!! over atoms
	ISORT=IS(IATOM)
	IF(MCRL(IATOM).EQ.0)CYCLE
	IREC=IREC+1
	IUMAX=(ILSB(ISORT)+1)*(2*ILSB(ISORT)+1)*(2*ILSB(ISORT)+3)/3
	IF(IMSC.LE.NMSC)
     &READ(IUSGM,REC=IREC)
     &(((SIGW(IU,IATOM,IUPDN,IORBS),IU=1,IUMAX),IUPDN=1,NSPIN),
     &IORBS=1,NORBS),
     &(((DELW(IU,IATOM,IUPDN,IORBS),IU=1,IUMAX),IUPDN=1,NSPIN),
     &IORBS=1,NORBS)
	DO IORBS=1,NORBS           !!! over iorbs
	DO IUPDN=1,NSPIN           !!! over iupdn
	DO L=0,ILSB(ISORT)         !!! over l
	IF(LCRL(L,IATOM).EQ.0)CYCLE
	DO M=-L,L
	DO K=-L,L
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+K)+L+M+1           !  (l,m k) packed
	ILEN=ILEN+1
	IF(MIXFUN.EQ.1)XINP(ILEN)=DELW(IU,IATOM,IUPDN,IORBS)
	IF(MIXFUN.EQ.2)XINP(ILEN)=SIGW(IU,IATOM,IUPDN,IORBS)
	WRAD(ILEN)=1.D0
	ENDDO
	ENDDO
	ENDDO                      !!! over l
	ENDDO                      !!! over iupdn
	ENDDO                      !!! over iorbs
	ENDDO                      !!! over atoms
	ENDDO                      !!! over Matsubara frequencies
C Pack other arrays
	DO IATOM=1,NATOM           !!! over atoms
	ISORT=IS(IATOM)
	IF(MCRL(IATOM).EQ.0)CYCLE
	DO IORBS=1,NORBS           !!! over iorbs
	DO IUPDN=1,NSPIN           !!! over iupdn
	DO L=0,ILSB(ISORT)         !!! over l
	IF(LCRL(L,IATOM).EQ.0)CYCLE
	DO M=-L,L
	DO K=-L,L
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+K)+L+M+1           !  (l,m k) packed
C Density matrix
	ILEN=ILEN+1
	XINP(ILEN)=DHUB(IU,IATOM,IUPDN,IORBS)
	WRAD(ILEN)=1.D0
C Double counting
	ILEN=ILEN+1
	XINP(ILEN)=VDBC(IU,IATOM,IUPDN,IORBS)
	WRAD(ILEN)=1.D0
C Sigma(oo)
	ILEN=ILEN+1
	XINP(ILEN)=SIGI(IU,IATOM,IUPDN,IORBS)
	WRAD(ILEN)=1.D0
C Impurity levels
	ILEN=ILEN+1
	XINP(ILEN)=EIMP(IU,IATOM,IUPDN,IORBS)
	WRAD(ILEN)=1.D0
C Overlap
	ILEN=ILEN+1
	XINP(ILEN)=OIMP(IU,IATOM,IUPDN,IORBS)
	WRAD(ILEN)=1.D0
	ENDDO
	ENDDO
	ENDDO                      !!! over l
	ENDDO                      !!! over iupdn
	ENDDO                      !!! over iorbs
	ENDDO                      !!! over atoms
	ILEN=ILEN+1
	XINP(ILEN)=EFRM
	IF(ILEN.NE.NLENMEM)CALL FULLSTOP('<MixDmf>:: iLen.ne.Nlen')
C  SEND ARRAY TO BROYDEN
      CALL LIB_BROY6(XINP,XOUT,WRAD,WRK1,WRK2,NLEN,MTER,ADMIXB,WTER,
     &WBRO,WINP,WMIX,FNOM,BETA,CMAT,GAMA,NTERMEM,NVAL,
     &IUBSG,SCRFILE(IUBSG),IERR)      
	IF(MTER.EQ.0)RESET=.FALSE.
	IF(MTER.EQ.0)GOTO 1000
C CHECK EXIT
	DDIFW=0.D0
	DVALW=0.D0
	ILEN=0
	DO IMSC=0,NMSC             !!! over Matsubara frequencies
	DO IATOM=1,NATOM           !!! over atoms
	ISORT=IS(IATOM)
	IF(MCRL(IATOM).EQ.0)CYCLE
	DO IORBS=1,NORBS           !!! over iorbs
	DO IUPDN=1,NSPIN           !!! over iupdn
	DO L=0,ILSB(ISORT)         !!! over l
	IF(LCRL(L,IATOM).EQ.0)CYCLE
	DO M=-L,L
	DO K=-L,L
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+K)+L+M+1           !  (l,m k) packed
	ILEN=ILEN+1
	DDIFW=DDIFW+DCONJG(XOUT(ILEN)-XINP(ILEN))*(XOUT(ILEN)-XINP(ILEN))
	DVALW=DVALW+DCONJG(XOUT(ILEN)+XINP(ILEN))*(XOUT(ILEN)+XINP(ILEN))
	ENDDO
	ENDDO
	ENDDO                      !!! over l
	ENDDO                      !!! over iupdn
	ENDDO                      !!! over iorbs
	ENDDO                      !!! over atoms
	ENDDO                      !!! over Matsubara frequencies
	DDIFW=SQRT(DDIFW)/DBLE(NMSC+1)
	DVALW=SQRT(DVALW)/DBLE(NMSC+1)
	IF(DVALW.GT.1.D-10)DDIFW=DDIFW/DVALW
	DDIFD=0.D0
	DVALD=0.D0
	DDIFC=0.D0
	DVALC=0.D0
	DDIFS=0.D0
	DVALS=0.D0
	DDIFI=0.D0
	DVALI=0.D0
	DDIFO=0.D0
	DVALO=0.D0
	DO IATOM=1,NATOM           !!! over atoms
	ISORT=IS(IATOM)
	IF(MCRL(IATOM).EQ.0)CYCLE
	DO IORBS=1,NORBS           !!! over iorbs
	DO IUPDN=1,NSPIN           !!! over iupdn
	DO L=0,ILSB(ISORT)         !!! over l
	IF(LCRL(L,IATOM).EQ.0)CYCLE
	DO M=-L,L
	DO K=-L,L
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+K)+L+M+1           !  (l,m k) packed
C Compare densities
	ILEN=ILEN+1
	DDIFD=DDIFD+DCONJG(XOUT(ILEN)-XINP(ILEN))*(XOUT(ILEN)-XINP(ILEN))
	DVALD=DVALD+DCONJG(XOUT(ILEN)+XINP(ILEN))*(XOUT(ILEN)+XINP(ILEN))
C Compare double countings
	ILEN=ILEN+1
	DDIFC=DDIFC+DCONJG(XOUT(ILEN)-XINP(ILEN))*(XOUT(ILEN)-XINP(ILEN))
	DVALC=DVALC+DCONJG(XOUT(ILEN)+XINP(ILEN))*(XOUT(ILEN)+XINP(ILEN))
C Compare Sigma(oo)
	ILEN=ILEN+1
	DDIFS=DDIFS+DCONJG(XOUT(ILEN)-XINP(ILEN))*(XOUT(ILEN)-XINP(ILEN))
	DVALS=DVALS+DCONJG(XOUT(ILEN)+XINP(ILEN))*(XOUT(ILEN)+XINP(ILEN))
C Compare Impurity levels
	ILEN=ILEN+1
	DDIFI=DDIFI+DCONJG(XOUT(ILEN)-XINP(ILEN))*(XOUT(ILEN)-XINP(ILEN))
	DVALI=DVALI+DCONJG(XOUT(ILEN)+XINP(ILEN))*(XOUT(ILEN)+XINP(ILEN))
C Compare overlaps
	ILEN=ILEN+1
	DDIFO=DDIFO+DCONJG(XOUT(ILEN)-XINP(ILEN))*(XOUT(ILEN)-XINP(ILEN))
	DVALO=DVALO+DCONJG(XOUT(ILEN)+XINP(ILEN))*(XOUT(ILEN)+XINP(ILEN))
	ENDDO
	ENDDO
	ENDDO                      !!! over l
	ENDDO                      !!! over iupdn
	ENDDO                      !!! over iorbs
	ENDDO                      !!! over atoms
C Compare Fermi levels
	ILEN=ILEN+1
	DDIFF=DCONJG(XOUT(ILEN)-XINP(ILEN))*(XOUT(ILEN)-XINP(ILEN))
	DVALF=DCONJG(XOUT(ILEN)+XINP(ILEN))*(XOUT(ILEN)+XINP(ILEN))
	IF(ILEN.NE.NLENMEM)CALL FULLSTOP('<MixDmf>:: iLen.ne.Nlen')
C Average deviation
	DDIFD=SQRT(DDIFD)
	DVALD=SQRT(DVALD)
	DDIFC=SQRT(DDIFC)
	DVALC=SQRT(DVALC)
	DDIFS=SQRT(DDIFS)
	DVALS=SQRT(DVALS)
	DDIFI=SQRT(DDIFI)
	DVALI=SQRT(DVALI)
	DDIFO=SQRT(DDIFO)
	DVALO=SQRT(DVALO)
	DDIFF=SQRT(DDIFF)
	DVALF=SQRT(DVALF)
	IF(DVALD.GT.1.D-10)DDIFD=DDIFD/DVALD
	IF(DVALC.GT.1.D-10)DDIFC=DDIFC/DVALC
	IF(DVALS.GT.1.D-10)DDIFS=DDIFS/DVALS
	IF(DVALI.GT.1.D-10)DDIFI=DDIFI/DVALI
	IF(DVALO.GT.1.D-10)DDIFO=DDIFO/DVALO
	IF(DVALF.GT.1.D-10)DDIFF=DDIFF/DVALF
	DDIF=DDIFW+DDIFD+DDIFC+DDIFS+DDIFI+DDIFO+DDIFF
	DVAL=DVALW+DVALD+DVALC+DVALS+DVALI+DVALO+DVALF
C DIVERGENCY OCCURS
C	IF(DVAL.GT.1.D+04)THEN
C	DO ILEN=1,NLEN
C	XOUT(ILEN)=(0.D0,0.D0)
C	ENDDO
C	RESET=.TRUE.
C	GOTO 1000
C	ENDIF
	IF(DVAL.GT.1.D-10)DDIF=DDIF/DVAL
	IF(DDIF.LE.EPSDMF)IEXIT=1
	IF(ADMIXB.EQ.1.D0.AND.MTER.EQ.1)IEXIT=0
	IF(ITER.EQ.NDIT.AND.KEY.NE.0)IEXIT=1
C ON EXIT USE INPUT SELF-ENERGIES/HYBRIDIZATIONS AS AN OUTPUT 
C OTHERWISE REODERING EIGENVECTORS WOULD NEED NEW POINTERS
      IF(IEXIT.EQ.1)THEN
      DO ILEN=1,NLEN
      XOUT(ILEN)=XINP(ILEN)
      ENDDO
      ENDIF
C *** DEFINE NEW HYBRIDIZATION ***
      ILEN=0
	IREC=0
	DO IMSC=0,NMSC             !!! over Matsubara frequencies
	DO IATOM=1,NATOM           !!! over atoms
	ISORT=IS(IATOM)
	IF(MCRL(IATOM).EQ.0)CYCLE
	IREC=IREC+1
	IUMAX=(ILSB(ISORT)+1)*(2*ILSB(ISORT)+1)*(2*ILSB(ISORT)+3)/3
	IF(IMSC.LE.NMSC)
     &READ(IUSGM,REC=IREC)
     &(((SIGW(IU,IATOM,IUPDN,IORBS),IU=1,IUMAX),IUPDN=1,NSPIN),
     &IORBS=1,NORBS),
     &(((DELW(IU,IATOM,IUPDN,IORBS),IU=1,IUMAX),IUPDN=1,NSPIN),
     &IORBS=1,NORBS),
     &(((GLOC(IU,IATOM,IUPDN,IORBS),IU=1,IUMAX),IUPDN=1,NSPIN),
     &IORBS=1,NORBS)
	DO IORBS=1,NORBS           !!! over iorbs
	DO IUPDN=1,NSPIN           !!! over iupdn
	DO L=0,ILSB(ISORT)         !!! over l
	IF(LCRL(L,IATOM).EQ.0)CYCLE
	DO M=-L,L
	DO K=-L,L
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+K)+L+M+1           !  (l,m k) packed
	IW=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+K+1           !  (l,k m)
	ILEN=ILEN+1
	IF(MIXFUN.EQ.1)DELW(IU,IATOM,IUPDN,IORBS)=XOUT(ILEN)
	IF(MIXFUN.EQ.2)SIGW(IU,IATOM,IUPDN,IORBS)=XOUT(ILEN)
C Limiting behavior for Delta(w)
      IF(IMSC.EQ.NMSC.AND.KGRD.EQ.1.AND.MIXFUN.EQ.1)
     &DELI(IU,IATOM,IUPDN,IORBS)=(0.D0,0.D0)
      IF(IMSC.EQ.NMSC.AND.KGRD.EQ.2.AND.MIXFUN.EQ.1)
     &DELI(IU,IATOM,IUPDN,IORBS)=DELW(IU,IATOM,IUPDN,IORBS)
	ENDDO
	ENDDO
	ENDDO                      !!! over l
	ENDDO                      !!! over iupdn
	ENDDO                      !!! over iorbs
	IF(IMSC.LE.NMSC)
     &WRITE(IUSGM,REC=IREC)
     &(((SIGW(IU,IATOM,IUPDN,IORBS),IU=1,IUMAX),IUPDN=1,NSPIN),
     &IORBS=1,NORBS),
     &(((DELW(IU,IATOM,IUPDN,IORBS),IU=1,IUMAX),IUPDN=1,NSPIN),
     &IORBS=1,NORBS),
     &(((GLOC(IU,IATOM,IUPDN,IORBS),IU=1,IUMAX),IUPDN=1,NSPIN),
     &IORBS=1,NORBS)
	ENDDO                      !!! over atoms
	ENDDO                      !!! over Matsubara frequencies
C Unpack other arrays
	DO IATOM=1,NATOM           !!! over atoms
	ISORT=IS(IATOM)
	IF(MCRL(IATOM).EQ.0)CYCLE
	DO IORBS=1,NORBS           !!! over iorbs
	DO IUPDN=1,NSPIN           !!! over iupdn
	DO L=0,ILSB(ISORT)         !!! over l
	IF(LCRL(L,IATOM).EQ.0)CYCLE
	DO M=-L,L
	DO K=-L,L
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+K)+L+M+1           !  (l,m k) packed
	IW=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+K+1           !  (l,k m)
C Density matrix
	ILEN=ILEN+1
	DHUB(IU,IATOM,IUPDN,IORBS)=XOUT(ILEN)
C Double counting
	ILEN=ILEN+1
	VDBC(IU,IATOM,IUPDN,IORBS)=XOUT(ILEN)
C Sigma(oo)
	ILEN=ILEN+1
	SIGI(IU,IATOM,IUPDN,IORBS)=XOUT(ILEN)
C Impurity levels
	ILEN=ILEN+1
	EIMP(IU,IATOM,IUPDN,IORBS)=XOUT(ILEN)
C Overlap
	ILEN=ILEN+1
	OIMP(IU,IATOM,IUPDN,IORBS)=XOUT(ILEN)
	ENDDO
	ENDDO
	ENDDO                      !!! over l
	ENDDO                      !!! over iupdn
	ENDDO                      !!! over iorbs
	ENDDO                      !!! over atoms
C Unpack new Fermi level
	ILEN=ILEN+1
	EFRM=XOUT(ILEN)
	EF=EFRM
	IF(ILEN.NE.NLENMEM)CALL FULLSTOP('<MixDmf>:: iLen.ne.Nlen')
C  PRINT BLOCK
	WRITE(IUN,1010)WTER(MTER),DDIF
C MEMORY DEALLOCATONS
1000	DEALLOCATE(WRAD,WRK1,WRK2,XINP,XOUT) 
      CURMEM=CURMEM-SIZE_HERE
1010	FORMAT(1X,'Mixing, Iter-Weight=',G14.7, ' Accuracy=',G14.7)
	END
