      SUBROUTINE DMF_ORDBND(KMSC)
********************************************************************
* ROEPSers eigenvalues by trying to connect imaginary parts
********************************************************************
C SET ARRAY SIZE DATA
	USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM
      USE COM_CONTROL ,ONLY : LIFT,LMTO,IASA,IDMF                      !!! from readini
      USE COM_PARAM   ,ONLY : NATOM,NSORT,NSPIN,NORBS,IS,ILSB,ILST     !!! from readini
      USE COM_KMESH,   ONLY : NPNT,LINPNT                              !!! from tetra
      USE COM_WMESH   ,ONLY : NPNW                                     !!! from tetra
      USE COM_MSBMESH ,ONLY : TEMP,NMSC                                !!! from grfbnd
      USE COM_HUBDAT  ,ONLY : MCRL,LCRL,NCLM                           !!! from readhub
      USE COM_HUBDAT  ,ONLY : KHRM                                     !!! from readhub
      USE COM_NBANDS  ,ONLY : NBNDF,NBNDE,NBNDT,NBNDC,NBNDH            !!! from readini
      USE COM_ORDDAT  ,ONLY : KORD,NORD,IORD,OEPS,NSIG,OSIG            !!! from readhub
	USE COM_ENERGY  ,ONLY : ETRT,ETRW                                !!! from grfbnd
      USE COM_GRFDAT  ,ONLY : EPOL,EPOW,ECAP,EBND                      !!! from grfbnd
      USE COM_CHANNELS,ONLY : IUCEW                                    !!! from channels
	USE COM_KAPPAR,  ONLY : NPAN                                     !!! from readini
	USE COM_UNIT,    ONLY : IUN,IUR,IUT                              !!! from readini
      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER, ALLOCATABLE :: IO(:),NCUT(:)
      COMPLEX*16, ALLOCATABLE :: E1(:),E2(:)
      COMPLEX*16, ALLOCATABLE :: AL(:,:,:),AR(:,:,:)
      COMPLEX*16, ALLOCATABLE :: BL(:,:,:),BR(:,:,:)
	COMPLEX*16, ALLOCATABLE :: CL(:,:,:),CR(:,:,:)
	COMPLEX*16, ALLOCATABLE :: SL(:,:,:),SR(:,:,:)
      DATA PI/3.141592653589793D0/
C Returns
      CALL ABORTNOW()
      IF(KHRM.EQ.1)RETURN               ! no need for hermitian problems
      IF(NPNT(1).EQ.1)RETURN            ! no need if # points is 1
      IF(.NOT.ALLOCATED(LINPNT))RETURN  ! errors in algorithm
      IF(NPNT(1).NE.NPNW(1))
     &CALL FULLSTOP('<DMF_ORDBND> Does not work for different grids')
C MEMORY ALLOCATIONS
      ALLOCATE(CR(NCLM,NSPINMEM,(NBNDT(1)+NBNDH(1))*NSPINMEM))
      ALLOCATE(CL(NCLM,NSPINMEM,(NBNDT(1)+NBNDH(1))*NSPINMEM))
      ALLOCATE(SR(NCLM,NSPINMEM,(NBNDT(1)+NBNDH(1))*NSPINMEM))
      ALLOCATE(SL(NCLM,NSPINMEM,(NBNDT(1)+NBNDH(1))*NSPINMEM))
      ALLOCATE(AR(NCLM,NSPINMEM,(NBNDT(1)+NBNDH(1))*NSPINMEM))
      ALLOCATE(AL(NCLM,NSPINMEM,(NBNDT(1)+NBNDH(1))*NSPINMEM))
      ALLOCATE(BR(NCLM,NSPINMEM,(NBNDT(1)+NBNDH(1))*NSPINMEM))
      ALLOCATE(BL(NCLM,NSPINMEM,(NBNDT(1)+NBNDH(1))*NSPINMEM))
      ALLOCATE(E1((NBNDT(1)+NBNDH(1))*NSPINMEM))
      ALLOCATE(E2((NBNDT(1)+NBNDH(1))*NSPINMEM))
      ALLOCATE(IO((NBNDT(1)+NBNDH(1))*NSPINMEM))
      ALLOCATE(NCUT(NSPINMEM))
C Do over frequencies
      ERRM=0.D0
      IERR=0
      DO IMSC=0,KMSC                    !!! over frequencies
C Initial ordering is just increasing real parts
      DO IPNT=1,NPNT(1)
      DO IBNDS=1,NSPIN
      DO IBNDT=1,NBNDT(1)+NBNDH(1)
      IBAND=IBNDS+NSPIN*(IBNDT-1)
      IORD(IBAND,IPNT,IMSC)=IBAND
C Check eigenvalues      
      EKRE=DREAL(EPOL(IBAND,IPNT,IMSC))
      EKIM=DIMAG(EPOL(IBAND,IPNT,IMSC))
      IF(EKIM.GT.0.D0)THEN
      ERRM=MAX(ERRM,EKIM)
      IERR=IERR+1
      EKIM=0.D0
      EPOL(IBAND,IPNT,IMSC)=DCMPLX(EKRE,EKIM)
      ENDIF
      ENDDO
      ENDDO
      ENDDO
C Find cutoff band #
      IPNT=LINPNT(1,1)
      DO IBNDS=1,NSPIN
      NCUT(IBNDS)=0
      DO IBNDT=1,NBNDT(1)+NBNDH(1)
      IBAND=IBNDS+NSPIN*(IBNDT-1)
      IF(DIMAG(EPOL(IBAND,IPNT,IMSC)).LE.OSIG)
     &NCUT(IBNDS)=NCUT(IBNDS)+1
      ENDDO
      ENDDO
      NFIX=ABS(NINT(OSIG))
C Do over links
      DO ILIN=1,NPNT(1)-1               !!! over links
      IPNT1=LINPNT(1,ILIN)
      IPNT2=LINPNT(2,ILIN)
C For non-relativistic runs order up/dn bands separately      
      IF(NORBS.EQ.1)THEN
      DO IBNDS=1,NSPIN
      DO IBNDT=1,NBNDT(1)+NBNDH(1)
      IBAND=IBNDS+NSPIN*(IBNDT-1)
      E1(IBNDT)=EPOL(IBAND,IPNT1,IMSC)
      E2(IBNDT)=EPOL(IBAND,IPNT2,IMSC)
      IO(IBNDT)=IORD(IBAND,IPNT2,IMSC)
      ENDDO
      NBND=NBNDT(1)+NBNDH(1)
      NIMA=NCUT(IBNDS)
      IF(NSIG.NE.-1)
     &NIMA=MIN(NCUT(IBNDS),NSIG)
C Order by minimizing the functional      
      IF(KORD.EQ.1)
     &CALL LIB_ORDER_FUNC(NBND,E1,E2,IO,NORD,OEPS)
C Order by finding largest imaginary parts
      IF(KORD.EQ.2)
     &CALL LIB_ORDER_IMAX(NBND,E1,E2,IO,NORD,NIMA,OEPS)
      DO IBNDT=1,NBNDT(1)+NBNDH(1)
      IBAND=IBNDS+NSPIN*(IBNDT-1)
      EPOL(IBAND,IPNT2,IMSC)=E2(IBNDT)
      IORD(IBAND,IPNT2,IMSC)=IO(IBNDT)
      ENDDO
      ENDDO
C For relativistic runs order up/dn bands simulateniously
      ELSEIF(NORBS.EQ.2)THEN
      DO IBNDS=1,NSPIN
      DO IBNDT=1,NBNDT(1)+NBNDH(1)
      IBAND=IBNDS+NSPIN*(IBNDT-1)
      E1(IBAND)=EPOL(IBAND,IPNT1,IMSC)
      E2(IBAND)=EPOL(IBAND,IPNT2,IMSC)
      IO(IBAND)=IORD(IBAND,IPNT2,IMSC)
      ENDDO
      ENDDO
      NBND=NSPIN*(NBNDT(1)+NBNDH(1))
      NIMA=NCUT(1)+NCUT(NSPIN)
      IF(NSIG.NE.-1)
     &NIMA=MIN(NCUT(1)+NCUT(NSPIN),NSIG)
C Order by minimizing the functional      
      IF(KORD.EQ.1)
     &CALL LIB_ORDER_FUNC(NBND,E1,E2,IO,NORD,OEPS)
C Order by finding largest imaginary parts
      IF(KORD.EQ.2)
     &CALL LIB_ORDER_IMAX(NBND,E1,E2,IO,NORD,NIMA,OEPS)
      DO IBNDS=1,NSPIN
      DO IBNDT=1,NBNDT(1)+NBNDH(1)
      IBAND=IBNDS+NSPIN*(IBNDT-1)
      EPOL(IBAND,IPNT2,IMSC)=E2(IBAND)
      IORD(IBAND,IPNT2,IMSC)=IO(IBAND)
      ENDDO
      ENDDO
      ENDIF
      ENDDO                             !!! over links
C Reset Epow
      DO IPNT=1,NPNW(1)
      DO IBNDS=1,NSPIN
      DO IBNDT=1,NBNDT(1)+NBNDH(1)
      IBAND=IBNDS+NSPIN*(IBNDT-1)
      EPOW(IBAND,IPNT,IMSC)=EPOL(IBAND,IPNT,IMSC)
      ENDDO
      ENDDO
      ENDDO
      ENDDO                             !!! over frequencies
C Print errors
      IF(IERR.GT.0.AND.ERRM.GT.1.D-07)
     &WRITE(IUN,10010)ERRM
10010 FORMAT(1X,'Postive imaginary parts detected, max.error = ',G14.7)
C Reorder band capacities
      DO IPNT=1,NPNT(1)                 !!! over k-points
      DO IBNDS=1,NSPIN
      DO IBNDT=1,NBNDT(1)+NBNDH(1)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	IBAND1=IORD(IBAND,IPNT,KMSC)      !!! order pointer
      E1(IBAND)=ECAP(IBAND1,IPNT)
      ENDDO
      ENDDO
      DO IBNDS=1,NSPIN
      DO IBNDT=1,NBNDT(1)+NBNDH(1)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
      ECAP(IBAND,IPNT)=E1(IBAND)
      ENDDO      
      ENDDO
      ENDDO                             !!! over points
C Reorder band energies
      DO IMSC=0,KMSC                    !!! over frequencies
      DO IPNT=1,NPNT(1)                 !!! over k-points
      DO IBNDS=1,NSPIN
      DO IBNDT=1,NBNDT(1)+NBNDH(1)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	IBAND1=IORD(IBAND,IPNT,IMSC)      !!! order pointer
      E1(IBAND)=EBND(IBAND1,IPNT,IMSC)
      ENDDO
      ENDDO
      DO IBNDS=1,NSPIN
      DO IBNDT=1,NBNDT(1)+NBNDH(1)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
      EBND(IBAND,IPNT,IMSC)=E1(IBAND)
      ENDDO      
      ENDDO
      ENDDO                             !!! over points
      ENDDO                             !!! over frequencies
C Copy results for the remaining frequencies
      DO IMSC=KMSC+1,NMSC+1
      DO IPNT=1,NPNT(1)
      DO IBNDS=1,NSPIN
      DO IBNDT=1,NBNDT(1)+NBNDH(1)
      IBAND=IBNDS+NSPIN*(IBNDT-1)
      IORD(IBAND,IPNT,IMSC)=IORD(IBAND,IPNT,KMSC)
      EPOL(IBAND,IPNT,IMSC)=EPOL(IBAND,IPNT,KMSC)
      EPOW(IBAND,IPNT,IMSC)=EPOW(IBAND,IPNT,KMSC)
      EBND(IBAND,IPNT,IMSC)=EBND(IBAND,IPNT,KMSC)
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      DO IPNT=1,NPNT(1)
      DO IBNDS=1,NSPIN
      DO IBNDT=1,NBNDT(1)+NBNDH(1)
      IBAND=IBNDS+NSPIN*(IBNDT-1)
      ETRT(IBAND,IPNT,1)=DREAL(EPOL(IBAND,IPNT,KMSC))
      ETRW(IBAND,IPNT,1)=DREAL(EPOW(IBAND,IPNT,KMSC))
      ENDDO
      ENDDO
      ENDDO
C Reorder eigenvectors
      DO IMSC=0,KMSC                    !!! over frequencies
      DO IPNT=1,NPNT(1)                 !!! over k-points
      IREC=IPNT+NPNT(1)*IMSC
      IF(NORBS.EQ.1)
     &READ(IUCEW,REC=IREC)
     &(((CR(ICLM,IBNDS,IBNDS+NSPIN*(IBNDT-1)),ICLM=1,NCLM),
     &   IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1)),
     &(((CL(ICLM,IBNDS,IBNDS+NSPIN*(IBNDT-1)),ICLM=1,NCLM),
     &   IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1)),
     &(((SR(ICLM,IBNDS,IBNDS+NSPIN*(IBNDT-1)),ICLM=1,NCLM),
     &   IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1)),
     &(((SL(ICLM,IBNDS,IBNDS+NSPIN*(IBNDT-1)),ICLM=1,NCLM),
     &   IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1))
      IF(NORBS.EQ.2)
     &READ(IUCEW,REC=IREC)
     &((((CR(ICLM,IORBS,IBNDS+NSPIN*(IBNDT-1)),ICLM=1,NCLM),
     &IORBS=1,NORBS),IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1)),
     &((((CL(ICLM,IORBS,IBNDS+NSPIN*(IBNDT-1)),ICLM=1,NCLM),
     &IORBS=1,NORBS),IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1)),
     &((((SR(ICLM,IORBS,IBNDS+NSPIN*(IBNDT-1)),ICLM=1,NCLM),
     &IORBS=1,NORBS),IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1)),
     &((((SL(ICLM,IORBS,IBNDS+NSPIN*(IBNDT-1)),ICLM=1,NCLM),
     &IORBS=1,NORBS),IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1))
	DO IORBS=1,NORBS                  !!! over spinor components
      DO IBNDS=1,NSPIN                  !!! over spin subbands
	IF(NORBS.EQ.1)ISPIN=IBNDS
	IF(NORBS.EQ.2)ISPIN=IORBS
      DO IBNDT=1,NBNDT(1)+NBNDH(1)      !!! over bands
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	IBAND1=IORD(IBAND,IPNT,IMSC)      !!! order pointer
      DO ICLM=1,NCLM                    !!! over basis
      AL(ICLM,ISPIN,IBAND)=CL(ICLM,ISPIN,IBAND1)
      AR(ICLM,ISPIN,IBAND)=CR(ICLM,ISPIN,IBAND1)
      BL(ICLM,ISPIN,IBAND)=SL(ICLM,ISPIN,IBAND1)
      BR(ICLM,ISPIN,IBAND)=SR(ICLM,ISPIN,IBAND1)
      ENDDO                             !!! over basis
      ENDDO                             !!! over bands
      ENDDO                             !!! over spin bands
      ENDDO                             !!! over spinor components
C      
	DO IORBS=1,NORBS                  !!! over spinor components
      DO IBNDS=1,NSPIN                  !!! over spin subbands
	IF(NORBS.EQ.1)ISPIN=IBNDS
	IF(NORBS.EQ.2)ISPIN=IORBS
      DO IBNDT=1,NBNDT(1)+NBNDH(1)      !!! over bands
	IBAND=IBNDS+NSPIN*(IBNDT-1)
      DO ICLM=1,NCLM                    !!! over basis
      CL(ICLM,ISPIN,IBAND)=AL(ICLM,ISPIN,IBAND)
      CR(ICLM,ISPIN,IBAND)=AR(ICLM,ISPIN,IBAND)
      SL(ICLM,ISPIN,IBAND)=BL(ICLM,ISPIN,IBAND)
      SR(ICLM,ISPIN,IBAND)=BR(ICLM,ISPIN,IBAND)
      ENDDO                             !!! over basis
      ENDDO                             !!! over bands
      ENDDO                             !!! over spin bands
      ENDDO                             !!! over spinor components
      IREC=IPNT+NPNT(1)*IMSC
      IF(NORBS.EQ.1)
     &WRITE(IUCEW,REC=IREC)
     &(((CR(ICLM,IBNDS,IBNDS+NSPIN*(IBNDT-1)),ICLM=1,NCLM),
     &   IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1)),
     &(((CL(ICLM,IBNDS,IBNDS+NSPIN*(IBNDT-1)),ICLM=1,NCLM),
     &   IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1)),
     &(((SR(ICLM,IBNDS,IBNDS+NSPIN*(IBNDT-1)),ICLM=1,NCLM),
     &   IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1)),
     &(((SL(ICLM,IBNDS,IBNDS+NSPIN*(IBNDT-1)),ICLM=1,NCLM),
     &   IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1))
      IF(NORBS.EQ.2)
     &WRITE(IUCEW,REC=IREC)
     &((((CR(ICLM,IORBS,IBNDS+NSPIN*(IBNDT-1)),ICLM=1,NCLM),
     &IORBS=1,NORBS),IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1)),
     &((((CL(ICLM,IORBS,IBNDS+NSPIN*(IBNDT-1)),ICLM=1,NCLM),
     &IORBS=1,NORBS),IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1)),
     &((((SR(ICLM,IORBS,IBNDS+NSPIN*(IBNDT-1)),ICLM=1,NCLM),
     &IORBS=1,NORBS),IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1)),
     &((((SL(ICLM,IORBS,IBNDS+NSPIN*(IBNDT-1)),ICLM=1,NCLM),
     &IORBS=1,NORBS),IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)+NBNDH(1))
      ENDDO                             !!! over points
      ENDDO                             !!! over frequencies
C Memory deallocations
      DEALLOCATE(E1,E2,CR,CL,SR,SL,IO,NCUT)
      END
