      SUBROUTINE DMF_ORDVEC(IPNT,IMSC,KEY)
********************************************************************
* Reorders eigenvectors
********************************************************************
C SET ARRAY SIZE DATA
	USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM
      USE COM_CONTROL ,ONLY : LIFT,LMTO,IASA,IDMF                      !!! from readini
      USE COM_PARAM   ,ONLY : NATOM,NSORT,NSPIN,NORBS,IS,ILSB,ILST     !!! from readini
      USE COM_KMESH,   ONLY : NPNT                                     !!! from tetra
      USE COM_KAPPAR  ,ONLY : NKAP                                     !!! from readini
      USE COM_MSBMESH ,ONLY : TEMP,NMSC                                !!! from grfbnd
      USE COM_HUBDAT  ,ONLY : KHRM                                     !!! from readhub
	USE COM_ENERGY  ,ONLY : ETRT,ETRW                                !!! from grfbnd
      USE COM_GRFDAT  ,ONLY : EPOL,EPOW,ECAP,EBND                      !!! from grfbnd
      USE COM_ORDDAT  ,ONLY : IORD                                     !!! from grfbnd
      USE COM_LMTMAT  ,ONLY : HMAT,OMAT                                !!! from lmtmat
	USE COM_LMTVEC  ,ONLY : APHR,APSR,APJR,APHL,APSL,APJL            !!! from lmtvec
      USE COM_NBANDS  ,ONLY : NBNDF,NBNDE,NBNDT,NBNDC,NBNDH            !!! from readini
	USE COM_KAPPAR,  ONLY : NPAN                                     !!! from readini
	USE COM_UNIT,    ONLY : IUN,IUR,IUT                              !!! from readini
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16, ALLOCATABLE :: E1(:),E2(:),E3(:)
      COMPLEX*16, ALLOCATABLE :: HL(:),HR(:),SL(:),SR(:),GL(:),GR(:)
      DATA PI/3.141592653589793D0/
C Returns
      CALL ABORTNOW()
      IF(KHRM.EQ.1)RETURN               ! no need for hermitian problems
      IF(NPNT(1).EQ.1)RETURN            ! no need if # points is 1
C MEMORY ALLOCATIONS
      ALLOCATE(E1((NBNDT(1)+NBNDH(1))*NSPINMEM))
      ALLOCATE(E2((NBNDT(1)+NBNDH(1))*NSPINMEM))
      ALLOCATE(E3((NBNDT(1)+NBNDH(1))*NSPINMEM))
      ALLOCATE(HL((NBNDT(1)+NBNDH(1))*NSPINMEM))
      ALLOCATE(HR((NBNDT(1)+NBNDH(1))*NSPINMEM))
      ALLOCATE(SL((NBNDT(1)+NBNDH(1))*NSPINMEM))
      ALLOCATE(SR((NBNDT(1)+NBNDH(1))*NSPINMEM))
      ALLOCATE(GL((NBNDT(1)+NBNDH(1))*NSPINMEM))
      ALLOCATE(GR((NBNDT(1)+NBNDH(1))*NSPINMEM))
	IF(IDMF.EQ.3)KMSC=NMSC+1
	IF(IDMF.EQ.4)KMSC=0               
	IF(IDMF.EQ.5)KMSC=NMSC+1
C REORDER EIGENVALUES      
      DO IBNDS=1,NSPIN
      DO IBNDT=1,NBNDT(1)+NBNDH(1)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	IBAND1=IORD(IBAND,IPNT,IMSC)      !!! order pointer
      E1(IBAND)=EPOL(IBAND1,IPNT,IMSC)
      E2(IBAND)=EPOW(IBAND1,IPNT,IMSC)
      E3(IBAND)=EBND(IBAND1,IPNT,IMSC)
      ENDDO
      ENDDO
      DO IBNDS=1,NSPIN
      DO IBNDT=1,NBNDT(1)+NBNDH(1)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
      EPOL(IBAND,IPNT,IMSC)=E1(IBAND)
      EPOW(IBAND,IPNT,IMSC)=E2(IBAND)
      EBND(IBAND,IPNT,IMSC)=E3(IBAND)
      ENDDO      
      ENDDO
C Copy results for the remaining frequencies
      IF(IMSC.EQ.KMSC)THEN
      DO IBNDS=1,NSPIN
      DO IBNDT=1,NBNDT(1)+NBNDH(1)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	IBAND1=IORD(IBAND,IPNT,IMSC)      !!! order pointer
      E1(IBAND)=ECAP(IBAND1,IPNT)
      E2(IBAND)=ETRT(IBAND1,IPNT,1)
      E3(IBAND)=ETRW(IBAND1,IPNT,1)
      ENDDO
      ENDDO
      DO IBNDS=1,NSPIN
      DO IBNDT=1,NBNDT(1)+NBNDH(1)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
      ECAP(IBAND,IPNT)  =E1(IBAND)
      ETRT(IBAND,IPNT,1)=E2(IBAND)
      ETRW(IBAND,IPNT,1)=E3(IBAND)
      ENDDO      
      ENDDO
      DO JMSC=KMSC+1,NMSC+1
      DO IBNDS=1,NSPIN
      DO IBNDT=1,NBNDT(1)+NBNDH(1)
      IBAND=IBNDS+NSPIN*(IBNDT-1)
      EPOL(IBAND,IPNT,JMSC)=EPOL(IBAND,IPNT,KMSC)
      EPOW(IBAND,IPNT,JMSC)=EPOW(IBAND,IPNT,KMSC)
      ENDDO
      ENDDO
      ENDDO
      ENDIF
C FOR LMTO CALCULATIONS
	IF(IASA.EQ.1.OR.IASA.EQ.2)THEN
	DO IORBS=1,NORBS            !!! over spinor components
	DO IKAP=1,NKAP(1)           !!! over energies
	DO IATOM=1,NATOM            !!! over iatom
	ISORT=IS(IATOM)
      DO L=0,ILST(ISORT)+1        !!! over l
      DO M=-L,L                   !!! over m
      LM=L*(L+1)+M+1
C Reorder      
	DO IBNDS=1,NSPIN            !!! over spin subbands
	IF(NORBS.EQ.1)ISPIN=IBNDS
	IF(NORBS.EQ.2)ISPIN=IORBS
	DO IBNDT=1,NBNDT(1)+NBNDH(1)!!! over bands
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	IBAND1=IORD(IBAND,IPNT,IMSC)!!! ordering pointer
      IF(L.LE.ILSB(ISORT))THEN
	HR(IBAND)=APHR(LM,IATOM,IKAP,ISPIN,IBAND1)
	SR(IBAND)=APSR(LM,IATOM,IKAP,ISPIN,IBAND1)
	HL(IBAND)=APHL(LM,IATOM,IKAP,ISPIN,IBAND1)
	SL(IBAND)=APSL(LM,IATOM,IKAP,ISPIN,IBAND1)
      ENDIF
	GR(IBAND)=APJR(LM,IATOM,IKAP,ISPIN,IBAND1)
	GL(IBAND)=APJL(LM,IATOM,IKAP,ISPIN,IBAND1)
      ENDDO                       !!! over bands
      ENDDO                       !!! over spin subbands
C Assign back
	DO IBNDS=1,NSPIN            !!! over spin subbands
	IF(NORBS.EQ.1)ISPIN=IBNDS
	IF(NORBS.EQ.2)ISPIN=IORBS
	DO IBNDT=1,NBNDT(1)+NBNDH(1)!!! over bands
	IBAND=IBNDS+NSPIN*(IBNDT-1)
      IF(L.LE.ILSB(ISORT))THEN
	APHR(LM,IATOM,IKAP,ISPIN,IBAND)=HR(IBAND)
	APSR(LM,IATOM,IKAP,ISPIN,IBAND)=SR(IBAND)
	APHL(LM,IATOM,IKAP,ISPIN,IBAND)=HL(IBAND)
	APSL(LM,IATOM,IKAP,ISPIN,IBAND)=SL(IBAND)
      ENDIF
	APJR(LM,IATOM,IKAP,ISPIN,IBAND)=GR(IBAND)
	APJL(LM,IATOM,IKAP,ISPIN,IBAND)=GL(IBAND)
      ENDDO                       !!! over bands
      ENDDO                       !!! over spin subbands
      ENDDO                       !!! over m
      ENDDO                       !!! over l
      ENDDO                       !!! over iatom
      ENDDO                       !!! over energies
      ENDDO                       !!! over spinor components
      ENDIF
C FOR TB CALCULATIONS
	DO JBNDS=1,NSPIN            !!! over spin subbands
	DO JBNDT=1,NBNDT(1)+NBNDH(1)!!! over bands
	JDIM=JBNDS+NSPIN*(JBNDT-1)
C Reorder      
	DO IBNDS=1,NSPIN            !!! over spin subbands
	DO IBNDT=1,NBNDT(1)+NBNDH(1)!!! over bands
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	IBAND1=IORD(IBAND,IPNT,IMSC)!!! ordering pointer
	HR(IBAND)=OMAT(JDIM,IBAND1)
	HL(IBAND)=HMAT(JDIM,IBAND1)
      ENDDO                       !!! over bands
      ENDDO                       !!! over spin subbands
C Assign back
	DO IBNDS=1,NSPIN            !!! over spin subbands
	DO IBNDT=1,NBNDT(1)+NBNDH(1)!!! over bands
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	OMAT(JDIM,IBAND)=HR(IBAND)
	HMAT(JDIM,IBAND)=HL(IBAND)
      ENDDO                       !!! over bands
      ENDDO                       !!! over spin subbands
      ENDDO                       !!! over bands
      ENDDO                       !!! over spin subbands
C Memory deallocations
      DEALLOCATE(E1,E2,E3,HL,HR,SL,SR,GL,GR)
      END
