	SUBROUTINE DMF_SETFRS
******************************************************
*   Stores Fat Bands                                 *
******************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                          !!! from setup
      USE COM_CONTROL ,ONLY: LIFT,LMTO,IASA,LRWF,NPFR         !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS       !!! from readini
     &                      ,ILST,ILSB,ILSV,LRTV,NHSORT
      USE COM_LATPAR  ,ONLY: PAR,ORTH,OMEGAC,STRAIN           !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP                   !!! from readini
      USE COM_LATTICE ,ONLY: RBAS,GBAS,BBAS,AKBAS,ORIGIN      !!! from readstr
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC,NBNDH    !!! from readini
      USE COM_INPTTR  ,ONLY: NDIV,NDIC,NDIW                   !!! from readstr
      USE COM_KMESH   ,ONLY: NPNT,PNT,WGT,IPQARR,KCUT         !!! from makettr
      USE COM_FERMI   ,ONLY: EF                               !!! from ttrints
	USE COM_ENERGY  ,ONLY: ETRT                             !!! from grfbnd
      USE COM_GRFDAT  ,ONLY: ECAP                             !!! from grfbnd
      USE COM_LABELS  ,ONLY: TXTAT,TXTEL,TXTSP                !!! from readini
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT,IUI                  !!! from setup
      USE COM_CHANNELS,ONLY: IUAIN                            !!! from channels
      USE COM_MASHDEP ,ONLY: NVAL,LENCMP                      !!! from setup
      USE COM_LMTOUT                                          !!! from readini
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	DIMENSION CUBR(3,3),ORGR(3),PKT(3), PTTR(3,4),E(4),V(3,8)
	REAL*8, ALLOCATABLE :: VEL(:,:)
	LOGICAL EXIST,OPEN
	CHARACTER HELP*40
	DATA PI/3.141592653589793D0/
	IF(ICFRS.LE.0)RETURN
C MEMORY ALLOCATIONS
	ALLOCATE(VEL(3,(NBNDT(1)+NBNDH(1))*NSPIN))
C STORE HEADER INFO.
	INQUIRE(FILE=FRSFILE,EXIST=EXIST)
	IF(EXIST)THEN
      OPEN(UNIT=IUAIN,FILE=FRSFILE,STATUS='OLD',FORM='FORMATTED')
	CLOSE(UNIT=IUAIN,STATUS='DELETE')
	ENDIF
	OPEN(UNIT=IUAIN,FILE=FRSFILE,STATUS='NEW',FORM='FORMATTED')
	WRITE(IUAIN,10010)
	WRITE(IUAIN,10020)
10010	FORMAT(1X,'<FILE=FRSFILE,INPUT=MODERN>')
10020 FORMAT('****************************************************')
	WRITE(IUAIN,10030)
10030 FORMAT(1X,'<SECTION=CTRL>               ! CONTROL PARAMETERS:')
	HELP='! Tetrahedron mesh                     '
	WRITE(IUAIN,10040)NDIV,HELP
10040 FORMAT(1X,'nDiv(:)=',I2,1X,I2,1X,I2,1X,12X,A40)
	HELP='! Tetrahedron mesh for weights         '
	WRITE(IUAIN,10050)NDIW,HELP
10050 FORMAT(1X,'nDiw(:)=',I2,1X,I2,1X,I2,1X,12X,A40)
	WRITE(IUAIN,10060)
10060 FORMAT(1X,'<SECTION=CUBE>               ! DRAWING CUBE:')
C APPLY STRAIN
      DO IVEC=1,3
      DO I=1,3
      CUBR(I,IVEC)=0.D0
      ORGR(I)=0.D0
      DO J=1,3
      CUBR(I,IVEC)=CUBR(I,IVEC)+BBAS(J,IVEC)*STRAIN(J,I,1)
      ORGR(I)=ORGR(I)+ORIGIN(J)*STRAIN(J,I,1)
	ENDDO
	ENDDO
	ENDDO
C ACCOUNT FOR ORTHOROMBICITY
      DO I=2,3
      DO IVEC=1,3
      CUBR(I,IVEC)=CUBR(I,IVEC)*ORTH(I)
	ENDDO
      ORGR(I)=ORGR(I)*ORTH(I)
	ENDDO
	DO IVEC=1,3
	WRITE(IUAIN,10070)(CUBR(I,IVEC),I=1,3)
	ENDDO
	WRITE(IUAIN,10070)(ORGR(I),I=1,3)
10070 FORMAT(1X,G14.7,1X,',',1X,G14.7,1X,',',1X,G14.7)
C STORE DOS DATA
	WRITE(IUAIN,10110)
10110 FORMAT(1X,'<SECTION=DATA>               ! FERMI SURFACE DATA:')
	NBND=NBNDT(1)+NBNDH(1)
	NSPN=NSPIN
	IF(NORBS.EQ.2.AND.NSPIN.EQ.2)NBND=(NBNDT(1)+NBNDH(1))*NSPIN
	IF(NORBS.EQ.2.AND.NSPIN.EQ.2)NSPN=1
	WRITE(IUAIN,10200)EF,NDIV,NBND,NSPN
10200	FORMAT(1X,G14.7,2X,I3,1X,I3,1X,I3,2X,I3,2X,I3)
C DO OVER MICROCELLS
      DO I3=0,NDIV(3)
      DO I2=0,NDIV(2)
      DO I1=0,NDIV(1)
      PKT(1)=(I1*AKBAS(1,1,1)+I2*AKBAS(1,2,1)+I3*AKBAS(1,3,1))-ORIGIN(1)
      PKT(2)=(I1*AKBAS(2,1,1)+I2*AKBAS(2,2,1)+I3*AKBAS(2,3,1))-ORIGIN(2)
      PKT(3)=(I1*AKBAS(3,1,1)+I2*AKBAS(3,2,1)+I3*AKBAS(3,3,1))-ORIGIN(3)
	IPNT=IPQARR(I1,I2,I3) ! irreducible point
	WRITE(IUAIN,10210)(PKT(I),I=1,3)
C EVALUATE VELOCITIES FOR THIS POINT
	DO IBNDS=1,NSPIN
	DO IBNDT=1,NBNDT(1)+NBNDH(1)
	IBND=IBNDS+NSPIN*(IBNDT-1)
C Set v=0
	DO IX=1,3
	VEL(IX,IBND)=0.D0
	ENDDO
	ITTR=0  !!! this is tetrahedron counter around the given point
	DO J3=-1,1,2
	K3=I3+J3
	IF(K3.GT.NDIV(3).OR.K3.LT.0)CYCLE
	DO J2=-1,1,2
	K2=I2+J2
	IF(K2.GT.NDIV(2).OR.K2.LT.0)CYCLE
	DO J1=-1,1,2
	K1=I1+J1
	IF(K1.GT.NDIV(1).OR.K1.LT.0)CYCLE
	ITTR=ITTR+1
C Set tetrahedron
	DO I=1,4
	L1=I1
	L2=I2
	L3=I3
	IF(I.EQ.2)L1=K1 
	IF(I.EQ.3)L2=K2
	IF(I.EQ.4)L3=K3 
	IPNT=IPQARR(L1,L2,L3)
      PTTR(1,I)=(L1*AKBAS(1,1,1)+L2*AKBAS(1,2,1)+L3*AKBAS(1,3,1))
      PTTR(2,I)=(L1*AKBAS(2,1,1)+L2*AKBAS(2,2,1)+L3*AKBAS(2,3,1))
      PTTR(3,I)=(L1*AKBAS(3,1,1)+L2*AKBAS(3,2,1)+L3*AKBAS(3,3,1))
      PTTR(1,I)=PTTR(1,I)*2.D0*PI/PAR
      PTTR(2,I)=PTTR(2,I)*2.D0*PI/PAR
      PTTR(3,I)=PTTR(3,I)*2.D0*PI/PAR
	E(I)=ETRT(IBND,IPNT,1)
	ENDDO
C Set velocity within this tetrahedron
      CALL TTR_GETVEL(E,PTTR,V(1,ITTR))                  !!! dE(kj)/dk
	DO IX=1,3
	VEL(IX,IBND)=VEL(IX,IBND)+V(IX,ITTR)
	ENDDO
C End looping over adjustened tetrahedra
	ENDDO
	ENDDO
	ENDDO
	IF(ITTR.EQ.0)CYCLE
C Average velocity
	DO IX=1,3
	VEL(IX,IBND)=VEL(IX,IBND)/DBLE(ITTR)
	ENDDO
	ENDDO
	ENDDO
	DO IBNDS=1,NSPIN
	WRITE(IUAIN,10220)(ETRT(IBNDS+NSPIN*(IBNDT-1),IPNT,1),
     &IBNDT=1,NBNDT(1)+NBNDH(1))
	ENDDO
	DO IBNDS=1,NSPIN
	WRITE(IUAIN,10220)(VEL(1,IBNDS+NSPIN*(IBNDT-1)),
     &IBNDT=1,NBNDT(1)+NBNDH(1))
	ENDDO
	DO IBNDS=1,NSPIN
	WRITE(IUAIN,10220)(VEL(2,IBNDS+NSPIN*(IBNDT-1)),
     &IBNDT=1,NBNDT(1)+NBNDH(1))
	ENDDO
	DO IBNDS=1,NSPIN
	WRITE(IUAIN,10220)(VEL(3,IBNDS+NSPIN*(IBNDT-1)),
     &IBNDT=1,NBNDT(1)+NBNDH(1))
	ENDDO
10210 FORMAT(3(1X,G12.5))
10220 FORMAT(5(1X,G12.5))
      ENDDO
      ENDDO
      ENDDO
	CLOSE(IUAIN)
C MEMORY DEALLOCAGTIONS
	DEALLOCATE(VEL)
	END SUBROUTINE DMF_SETFRS
