	SUBROUTINE DMF_SETGRF
***********************************************************
* Symmetrize Green function on the real axis and store it *
***********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                              !!! from setup
      USE COM_CONTROL ,ONLY: LIFT,LMTO,IASA,LRWF,NPFR             !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS           !!! from readini
     &                      ,ILST,ILSB,ILSV,LRTV,NHSORT
      USE COM_LATPAR  ,ONLY: PAR,ORTH,OMEGAC                      !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP                       !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN                          !!! from readini
      USE COM_SPHERE  ,ONLY: SMT,SWZ                              !!! from readini
      USE COM_INPPAR  ,ONLY: ENY,DNY,NODES                        !!! from readini
      USE COM_HUBDAT  ,ONLY: MCRL,LCRL,NCLM                       !!! from readhub
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC,NBNDH,POLUS  !!! from readini
      USE COM_DMFDAT  ,ONLY: SIGI,SIGW,DELW,GLOC,OIMP,EIMP        !!! from grfbnd
      USE COM_KMESH   ,ONLY: NPNT,PNT,WGT                         !!! from tetra
      USE COM_MSBMESH ,ONLY: TEMP,KGRD,NMSC,WMSC                  !!! from msbmesh
      USE COM_GRFDAT  ,ONLY: EPOL,EPOW,ECAP,GWGT                  !!! from grfbnd
      USE COM_FERMI   ,ONLY: EF                                   !!! from ttrints
      USE COM_LABELS  ,ONLY: TXTAT,TXTEL,TXTSP                    !!! from readini
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT,IUI                      !!! from setup
      USE COM_MASHDEP ,ONLY: NVAL,LENCMP                          !!! from setup
      USE COM_CHANNELS,ONLY: IUGRF,IUTDS,IUSGM                    !!! from channels
      USE COM_LMTOUT                                              !!! from readini
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER, ALLOCATABLE :: ILMTBAS(:,:)
      INTEGER, ALLOCATABLE :: INODBAS(:,:)
	COMPLEX*16 ZMSC,WMEK,WFAC
      DIMENSION SPDOS(2),SPTOS(2)
	LOGICAL EXIST,OPEN
	CHARACTER HELP*40
	DATA PI/3.141592653589793D0/
	IF(ICGRF.EQ.0)RETURN
      ALLOCATE(ILMTBAS(0:LMAXBMEM,NATOMMEM))
      ALLOCATE(INODBAS(0:LMAXBMEM,NATOMMEM))
      DO IATOM=1,NATOM
      ISORT=IS(IATOM)
      DO L=0,ILSB(IS(IATOM))
      ILMTBAS(L,IATOM)=0
      INODBAS(L,IATOM)=0
      DO IKAP=1,NKAP(1)
      IF(LTPAN(L,IATOM,IKAP,1))ILMTBAS(L,IATOM)=1
      IF(LTPAN(L,IATOM,IKAP,1))INODBAS(L,IATOM)=
     &NODES(L,ISORT,IKAP,1)+L+1
      ENDDO
      ENDDO
      ENDDO
C WRITE HEADER
      CALL DMF_SETGRF_HEAD
C DO GLOBALLY OVER FREQUENCIES
      DO 1000 IMSC=0,NMSC                 !!! over frequencies
	ZMSC=WMSC(IMSC)
C SET GREEN FUNCTION TO ZERO
      DO IORBS=1,NORBS                    !!! over iorbs
      DO IUPDN=1,NSPIN                    !!! over iupdn
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
	DO IATOM=1,NATOM                    !!! over iatom
	ISORT=IS(IATOM)
	DO L=0,ILSB(ISORT)                  !!! over l
	DO K=-L,L                           !!! over k
	DO M=-L,L                           !!! over m
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+K+1 !!! (l,k m)
C Greens function
	GLOC(IU,IATOM,IUPDN,IORBS)=(0.D0,0.D0)
      ENDDO                               !!! over m
      ENDDO                               !!! over k
      ENDDO                               !!! over l
      ENDDO                               !!! over iatom
      ENDDO                               !!! over spins
      ENDDO                               !!! over iorbs
C READ SELF-ENERGY, LOCAL GREEN FUNCTION
	IREC=0
	DO JMSC=0,NMSC                      !!! over frequencies
	DO IATOM=1,NATOM                    !!! over atoms
	ISORT=IS(IATOM)
	IF(MCRL(IATOM).EQ.0)CYCLE
	IREC=IREC+1
	IF(JMSC.NE.IMSC)CYCLE
	IUMAX=(ILSB(ISORT)+1)*(2*ILSB(ISORT)+1)*(2*ILSB(ISORT)+3)/3
	READ(IUSGM,REC=IREC)
     &(((SIGW(IU,IATOM,IUPDN,IORBS),IU=1,IUMAX),IUPDN=1,NSPIN),
     &IORBS=1,NORBS),
     &(((DELW(IU,IATOM,IUPDN,IORBS),IU=1,IUMAX),IUPDN=1,NSPIN),
     &IORBS=1,NORBS),
     &(((GLOC(IU,IATOM,IUPDN,IORBS),IU=1,IUMAX),IUPDN=1,NSPIN),
     &IORBS=1,NORBS)
	ENDDO                               !!! over atoms
	ENDDO                               !!! over frequencies
C Store DOS
	SPTOS(1)    =0.D0
	SPTOS(NSPIN)=0.D0
	SPDOS(1)    =0.D0
	SPDOS(NSPIN)=0.D0
	DO IPNT=1,NPNT(1)
      DO IBNDS=1,NSPIN
      DO IBNDT=1,NBNDT(1)+NBNDH(1)
      IBAND=IBNDS+NSPIN*(IBNDT-1)
	SPDOS(IBNDS)=SPDOS(IBNDS)-DIMAG(GWGT(IBAND,IPNT,IMSC))*
     &ECAP(IBAND,IPNT)/PI
	ENDDO
	ENDDO
	ENDDO
	DOS=(SPDOS(1)+SPDOS(NSPIN))/2.D0*DBLE(NSPIN)
	IF(NORBS.EQ.2)SPDOS(1)=DOS/2.D0
	IF(NORBS.EQ.2)SPDOS(NSPIN)=DOS/2.D0
	IF(KGRD.EQ.1)WRITE(IUGRF,*)DREAL(WMSC(IMSC)),
     &(SPTOS(ISPIN),ISPIN=1,NSPIN),(SPDOS(ISPIN),ISPIN=1,NSPIN)
	IF(KGRD.EQ.2)WRITE(IUGRF,*)DIMAG(WMSC(IMSC)),
     &(SPTOS(ISPIN),ISPIN=1,NSPIN),(SPDOS(ISPIN),ISPIN=1,NSPIN)
	WRITE(IUT,*)WMSC(IMSC),DOS
C Store now
      DO ISPIN=1,NSPIN
      DO IATOM=1,NATOM
      ISORT=IS(IATOM)
      DO L=0,ILSB(ISORT)
      LMS=L*(2*L-1)*(2*L+1)/3+1
      LME=LMS+(2*L+1)**2-1
      IF(ILMTBAS(L,IATOM).EQ.0)CYCLE
      WRITE(IUGRF,*)(GLOC(LM1M,IATOM,ISPIN,1),LM1M=LMS,LME)
      ENDDO
      ENDDO
      ENDDO
 1000 CONTINUE                          !!! over frequencies
      CLOSE(UNIT=IUGRF,STATUS='KEEP')
      DEALLOCATE(ILMTBAS,INODBAS)
	END




	SUBROUTINE DMF_SETGRF_HEAD
***********************************************************
* Open file for storing the Greens function               *
***********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                          !!! from setup
      USE COM_CONTROL ,ONLY: LIFT,LMTO,IASA                   !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS       !!! from readini
     &                      ,ILST,ILSB,ILSV,LRTV,NHSORT
      USE COM_LATPAR  ,ONLY: PAR,ORTH,OMEGAC                  !!! from readini
      USE COM_INPPAR  ,ONLY: ENY,DNY,NODES                    !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP                   !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN                      !!! from readini
      USE COM_SPHERE  ,ONLY: SMT,SWZ                          !!! from readini
      USE COM_MSBMESH ,ONLY: TEMP,KGRD,NMSC,WMSC              !!! from grfint
	USE COM_FREQU   ,ONLY: NOMGGRF                          !!! from getgrf
      USE COM_FERMI   ,ONLY: EF                               !!! from ttrints
      USE COM_INPTTR  ,ONLY: NDIV,NDIC,NDIW                   !!! from readstr
      USE COM_LABELS  ,ONLY: TXTAT,TXTEL,TXTSP                !!! from readini
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT,IUI                  !!! from setup
      USE COM_MASHDEP ,ONLY: NVAL,LENCMP                      !!! from setup
      USE COM_CHANNELS,ONLY: IUGRF,IUTDS                      !!! from channels
      USE COM_LMTOUT                                          !!! from readini
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER, ALLOCATABLE :: ILMTBAS(:,:)
      INTEGER, ALLOCATABLE :: INODBAS(:,:)
	LOGICAL EXIST,OPEN
	CHARACTER HELP*40
	IF(ICGRF.EQ.0)RETURN
      IF(KGRD.EQ.1)WMINGRF=DREAL(WMSC(0))
      IF(KGRD.EQ.2)WMINGRF=DIMAG(WMSC(0))
      IF(KGRD.EQ.1)WMAXGRF=DREAL(WMSC(NMSC))
      IF(KGRD.EQ.2)WMAXGRF=DIMAG(WMSC(NMSC))
	INQUIRE(FILE=GRFFILE,EXIST=EXIST)
	IF(EXIST)THEN
      OPEN(UNIT=IUGRF,FILE=GRFFILE,STATUS='OLD',FORM='FORMATTED')
	CLOSE(UNIT=IUGRF,STATUS='DELETE')
	ENDIF
	OPEN(IUGRF,FILE=GRFFILE,STATUS='NEW',FORM='FORMATTED')
C STORE HEADER INFO.
	WRITE(IUGRF,10010)
	WRITE(IUGRF,10020)
10010	FORMAT(1X,'<FILE=GRFFILE,INPUT=MODERN>')
10020 FORMAT('****************************************************')
	WRITE(IUGRF,10030)
10030 FORMAT(1X,'<SECTION=CTRL>              ! CONTROL PARAMETERS:')
      IF(NOMGGRF.GT.0)THEN
      HELP='! Frequency mesh for G(w)              '
	WRITE(IUGRF,10040)NMSC,HELP
10040 FORMAT(1X,'nOmgGRF=',I5,16X,A40)
      HELP='! Min.Frequency (Ry) for G(w)          '
      WRITE(IUGRF,10050)WMINGRF,HELP
10050 FORMAT(1X,'WminGRF=',G14.7,7X,A40)
      HELP='! Max.Frequency (Ry) for G(w)          '
      WRITE(IUGRF,10060)WMAXGRF,HELP
10060 FORMAT(1X,'WmaxGRF=',G14.7,7X,A40)
      ENDIF
	HELP='! Tetrahedron mesh                     '
	WRITE(IUGRF,10070)NDIV,HELP
10070 FORMAT(1X,'nDiv(:)=',I2,1X,I2,1X,I2,1X,12X,A40)
	HELP='! Tetrahedron mesh for weights         '
	WRITE(IUGRF,10080)NDIW,HELP
10080 FORMAT(1X,'nDiw(:)=',I2,1X,I2,1X,I2,1X,12X,A40)
C STORE GRF DATA
	WRITE(IUGRF,10110)
10110 FORMAT(1X,'<SECTION=DATA>              ! G(W) DATA:')
      WRITE(IUGRF,*)NATOM,NSORT,NSPIN,NORBS,
     &(IS(IATOM),IATOM=1,NATOM),(ILSB(ISORT),ISORT=1,NSORT),
     &(NHSORT(ISORT),ISORT=1,NSORT),0.D0,WMINGRF,WMAXGRF,NMSC
      WRITE(IUGRF,FMT='(5A10)')(TXTAT(ISORT),ISORT=1,NSORT)
C Store basis set
      ALLOCATE(ILMTBAS(0:LMAXBMEM,NATOMMEM))
      ALLOCATE(INODBAS(0:LMAXBMEM,NATOMMEM))
      DO IATOM=1,NATOM
      ISORT=IS(IATOM)
      DO L=0,ILSB(IS(IATOM))
      ILMTBAS(L,IATOM)=0
      INODBAS(L,IATOM)=0
      DO IKAP=1,NKAP(1)
      IF(LTPAN(L,IATOM,IKAP,1))ILMTBAS(L,IATOM)=1
      IF(LTPAN(L,IATOM,IKAP,1))INODBAS(L,IATOM)=
     &NODES(L,ISORT,IKAP,1)+L+1
      ENDDO
      ENDDO
      ENDDO
      WRITE(IUGRF,*)((ILMTBAS(L,IATOM),L=0,ILSB(IS(IATOM))),
     &IATOM=1,NATOM)
      WRITE(IUGRF,*)((INODBAS(L,IATOM),L=0,ILSB(IS(IATOM))),
     &IATOM=1,NATOM)
      DEALLOCATE(ILMTBAS,INODBAS)
	END
