	SUBROUTINE DMF_SGMDAT(ZOMG)
*********************************************************
*  Sets self energy                                     *
*********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                          !!! from setup
      USE COM_CONTROL ,ONLY : IDMF                            !!! from readini
      USE COM_PARAM   ,ONLY : NATOM,NSORT,NSPIN,NORBS,IS,ILSB !!! from readini
      USE COM_KAPPAR  ,ONLY : NPAN,NKAP                       !!! from readini
	USE COM_MSBMESH ,ONLY : NOMG,WOMG,TEMP                  !!! from msbmesh
      USE COM_PANPAR  ,ONLY : LTPAN,LSPAN                     !!! from readini
      USE COM_DMFDAT  ,ONLY : SIGW                            !!! from grfmat
      USE COM_HUBDAT  ,ONLY : MCRL,LCRL                       !!! from readhub
	USE COM_LMTOUT  ,ONLY : ICODF                           !!! from readini
      USE COM_CHANNELS,ONLY : IUSGM                           !!! from channels
      USE COM_UNIT    ,ONLY : IUN,IUR,IUT,IUI                 !!! from setup
      USE COM_MASHDEP ,ONLY : LENCMP                          !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: SIGM(:,:,:,:)
	COMPLEX*16 ZOMG,TOP,BOT
	LOGICAL LOG
	DATA PI/3.141592653589793D0/
      CALL ABORTNOW()
C MEMORY ALLOCATIONS
	ALLOCATE(SIGM(LIMB2MEM,NATOMMEM,NSPINMEM,NORBSMEM))
C SET SELF-ENERGY
      DO IORBS=1,NORBS                    !!! over iorbs
      DO IUPDN=1,NSPIN                    !!! over iupdn
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
	DO IATOM=1,NATOM                    !!! over iatom
	ISORT=IS(IATOM)
	DO L=0,ILSB(ISORT)                  !!! over l
	DO K=-L,L                           !!! over k
	DO M=-L,L                           !!! over m
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+K+1 !!! (l,k m)
	SIGW(IU,IATOM,IUPDN,IORBS)=(0.D0,0.D0)
	SIGM(IU,IATOM,IUPDN,IORBS)=(0.D0,0.D0)
      ENDDO                               !!! over m
      ENDDO                               !!! over k
      ENDDO                               !!! over l
      ENDDO                               !!! over iatom
      ENDDO                               !!! over spins
      ENDDO                               !!! over iorbs
C ESTIMATE RECORD #
      IOMG0=-1
	DO IOMG=0,NOMG
	IF(ABS(WOMG(IOMG)-DREAL(ZOMG)).LE.1.D-10)IOMG0=IOMG
	IF(WOMG(IOMG).GT.DREAL(ZOMG))EXIT
	ENDDO
	IOMG=IOMG-1
	IF(IOMG.GT.NOMG)IOMG=NOMG
	IF(IOMG.LT.0)IOMG=0
	IF(IOMG0.NE.-1)IOMG=IOMG0  !!! override for same points
C READ SELF-ENERGY
	IREC=0
	DO IMSB=0,NOMG             !!! over frequencies
	DO IATOM=1,NATOM           !!! over atoms
	ISORT=IS(IATOM)
	IF(MCRL(IATOM).EQ.0)CYCLE
	IREC=IREC+1
	IUMAX=(ILSB(ISORT)+1)*(2*ILSB(ISORT)+1)*(2*ILSB(ISORT)+3)/3
	IF(IMSB.NE.IOMG)CYCLE
	READ(IUSGM,REC=IREC)
     &(((SIGW(IU,IATOM,IUPDN,IORBS),IU=1,IUMAX),IUPDN=1,NSPIN),
     &IORBS=1,NORBS)
	ENDDO                      !!! over atoms
	ENDDO                      !!! over frequencies
C READ SELF-ENERGY AT THE POINT I+1
	IF(IOMG.NE.NOMG)IOMG1=IOMG+1
	IF(IOMG.EQ.NOMG)IOMG1=IOMG
	IF(IOMG0.NE.-1)IOMG1=IOMG0  !!! override for same points
	IREC=0
	DO IMSB=0,NOMG             !!! over frequencies
	DO IATOM=1,NATOM           !!! over atoms
	ISORT=IS(IATOM)
	IF(MCRL(IATOM).EQ.0)CYCLE
	IREC=IREC+1
	IUMAX=(ILSB(ISORT)+1)*(2*ILSB(ISORT)+1)*(2*ILSB(ISORT)+3)/3
	IF(IMSB.NE.IOMG1)CYCLE
	READ(IUSGM,REC=IREC)
     &(((SIGM(IU,IATOM,IUPDN,IORBS),IU=1,IUMAX),IUPDN=1,NSPIN),
     &IORBS=1,NORBS)
	ENDDO                      !!! over atoms
	ENDDO                      !!! over frequencies
C USE LINEAR INTERPOLATION
      DO IORBS=1,NORBS                    !!! over iorbs
      DO IUPDN=1,NSPIN                    !!! over iupdn
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
	DO IATOM=1,NATOM                    !!! over iatom
	ISORT=IS(IATOM)
	DO L=0,ILSB(ISORT)                  !!! over l
	DO K=-L,L                           !!! over k
	DO M=-L,L                           !!! over m
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+K+1 !!! (l,k m)
C Estimate 1/step
	IF(ABS(WOMG(IOMG1)-WOMG(IOMG)).GT.1.D-10)
     &DS=(ZOMG-WOMG(IOMG))/(WOMG(IOMG1)-WOMG(IOMG))
	IF(ABS(WOMG(IOMG1)-WOMG(IOMG)).LE.1.D-10)
     &DS=0.D0
C Estimate Self-energy at given frequency
	SIGW(IU,IATOM,IUPDN,IORBS)=SIGW(IU,IATOM,IUPDN,IORBS)+
     &DS*(SIGM(IU,IATOM,IUPDN,IORBS)-SIGW(IU,IATOM,IUPDN,IORBS))
      ENDDO                               !!! over m
      ENDDO                               !!! over k
      ENDDO                               !!! over l
      ENDDO                               !!! over iatom
      ENDDO                               !!! over spins
      ENDDO                               !!! over iorbs
C MEMORY DEALLOCATIONS
	DEALLOCATE(SIGM)
C ERROR HANDLINGS
C none
	END
