	SUBROUTINE DMF_SGMMAS(IMSC)
*********************************************************
*  Sets self energy                                     *
*********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                          !!! from setup
      USE COM_CONTROL ,ONLY : IDMF                            !!! from readini
      USE COM_PARAM   ,ONLY : NATOM,NSORT,NSPIN,NORBS,IS,ILSB !!! from readini
      USE COM_KAPPAR  ,ONLY : NPAN,NKAP                       !!! from readini
      USE COM_PANPAR  ,ONLY : LTPAN,LSPAN                     !!! from readini
      USE COM_MSBMESH ,ONLY : NMSC,TEMP                       !!! from msbmesh
      USE COM_DMFDAT  ,ONLY : SIGI,SIG0,SIGW,BMAS,RMAS        !!! from grfmat
	USE COM_FERMI   ,ONLY : EF                              !!! from ttrints
      USE COM_HUBDAT  ,ONLY : MCRL,LCRL                       !!! from readhub
      USE COM_CHANNELS,ONLY : IUSGM                           !!! from channels
      USE COM_UNIT    ,ONLY : IUN,IUR,IUT,IUI                 !!! from setup
      USE COM_MASHDEP ,ONLY : LENCMP                          !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: BMAT(:,:)
	COMPLEX*16, ALLOCATABLE :: ZMAT(:,:)
	COMPLEX*16, ALLOCATABLE :: WORK(:)
	LOGICAL LOG
	DATA PI/3.141592653589793D0/
      CALL ABORTNOW()
C SET MASS RENORMALIZATION MATRIX	
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	IF(MCRL(IATOM).EQ.0)CYCLE
	DO L=0,ILSB(ISORT)
	IF(LCRL(L,IATOM).EQ.0)CYCLE
      NDIM=2*(2*L+1)
      ALLOCATE(ZMAT(NDIM,NDIM))
      ALLOCATE(BMAT(NDIM,NDIM))
      ALLOCATE(WORK(NDIM))
	DO IDIM1=1,NDIM
	DO IDIM=1,NDIM
      BMAT(IDIM1,IDIM)=(0.D0,0.D0)
      ENDDO
      ENDDO
C Repack B-matrix
	DO IORBS=1,2
	DO IUPDN=1,2
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
	IF(NORBS.EQ.1.AND.IORBS.EQ.2)CYCLE
	IF(NSPIN.EQ.1)IUPDN0=1
	IF(NSPIN.EQ.2)IUPDN0=IUPDN
	DO K=-L,L
	IDIM1=K+L+1+(2*L+1)*(ISPIN1-1)
	DO M=-L,L
	IDIM=M+L+1+(2*L+1)*(ISPIN-1)
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+K+1 !!! (l,k m)
	BMAT(IDIM1,IDIM)=BMAS(IU,IATOM,IUPDN0,IORBS)
      ENDDO
	ENDDO
      ENDDO
	ENDDO
C Set Z-matrix
	DO IDIM1=1,NDIM
	DO IDIM=1,NDIM
      ZMAT(IDIM1,IDIM)=(0.D0,0.D0)
	DO JDIM=1,NDIM
	ZMAT(IDIM1,IDIM)=ZMAT(IDIM1,IDIM)+
     &DCONJG(BMAT(JDIM,IDIM1))*BMAT(JDIM,IDIM)
	ENDDO
	ENDDO
	ENDDO
C Invert Z-matrix
	CALL LIB_CINV(NDIM,ZMAT,NDIM,WORK,IFAIL)
	IF(IFAIL.NE.0)
     &CALL FULLSTOP('<DMF_LMTMAS>:: Error in inversion program')
C Set reciprocal matrix
	DO IORBS=1,2
	DO IUPDN=1,2
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
	IF(NORBS.EQ.1.AND.IORBS.EQ.2)CYCLE
	IF(NSPIN.EQ.1)IUPDN0=1
	IF(NSPIN.EQ.2)IUPDN0=IUPDN
	DO K=-L,L
	IDIM1=K+L+1+(2*L+1)*(ISPIN1-1)
	DO M=-L,L
	IDIM=M+L+1+(2*L+1)*(ISPIN-1)
	IF(IDIM1.EQ.IDIM)DONE=1.D0
	IF(IDIM1.NE.IDIM)DONE=0.D0
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+K+1 !!! (l,k m)
	IW=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+K)+L+M+1 !!! (l,m k)
	RMAS(IU,IATOM,IUPDN0,IORBS)=ZMAT(IDIM1,IDIM)-DONE
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      DEALLOCATE(ZMAT,BMAT,WORK)
      ENDDO                          !!! over l
      ENDDO                          !!! over atoms
C SET SELF-ENERGY
      DO IORBS=1,NORBS                    !!! over iorbs
      DO IUPDN=1,NSPIN                    !!! over iupdn
	DO IATOM=1,NATOM                    !!! over iatom
	ISORT=IS(IATOM)
	DO L=0,ILSB(ISORT)                  !!! over l
	DO K=-L,L                           !!! over k
	DO M=-L,L                           !!! over m
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+K+1 !!! (l,k m)
	SIGW(IU,IATOM,IUPDN,IORBS)=SIG0(IU,IATOM,IUPDN,IORBS)+
     &                        EF*RMAS(IU,IATOM,IUPDN,IORBS)
      ENDDO                               !!! over m
      ENDDO                               !!! over k
      ENDDO                               !!! over l
      ENDDO                               !!! over iatom
      ENDDO                               !!! over spins
      ENDDO                               !!! over iorbs
C MEMORY DEALLOCATIONS
	END
