	SUBROUTINE DMF_SGMPAR(IPAN)
***************************************************************
*   Prepare self-energy potential parameters.                 *
***************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
	USE COM_LMTMEM
      USE COM_CONTROL ,ONLY: LMTO,IASA,IDMF,NOVR,NPFR               !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS,ILST,ILSB,LRTV! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP,EK                      !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN,IATS,ISTS                  !!! from readini
      USE COM_SUMPAR  ,ONLY: PHH,PJH,PHJ,PJJ                        !!! from ovrpar
      USE COM_LMTPAR  ,ONLY: GAM,AAH,AAJ,BBH,BBJ                    !!! from potpar
      USE COM_HAMPAR  ,ONLY: HPARHH,HPARJH,HPARHJ,HPARJJ            !!! from potpar
      USE COM_RADMESH ,ONLY: NRAD,H,R,DR,WEIGHT,RL                  !!! from radmesh
      USE COM_MASHDEP ,ONLY: NVAL,LENREL,LENCMP                     !!! from setup
      USE COM_HUBCOM  ,ONLY: VDBC                                   !!! from grfmat
      USE COM_DMFDAT  ,ONLY: SIGW                                   !!! from grfmat
      USE COM_CHANNELS,ONLY: IUNMT                                  !!! from readini
      USE COM_LMTOUT  ,ONLY: SCRFILE                                !!! from readini
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	LOGICAL LOG1,LOG
	DATA PI/3.141592653589793D0/
      CALL ABORTNOW()
C RETURN KEYS
	IF(IPAN.NE.1)RETURN
C OPEN SCRATCH FILE FOR STORING POTENTIAL PARAMETERS
	NRECL=0
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	LMAXH=((ILSB(ISORT)+1)**2+(ILST(ISORT)+1)**2)**2
	NRECL=MAX(NRECL,NVAL*LMAXH)
	ENDDO
	OPEN(UNIT=IUNMT,FILE=SCRFILE(IUNMT),STATUS='NEW',
     &ACCESS='DIRECT',FORM='UNFORMATTED',RECL=NRECL)
C START CODE
	DO 5000 IATOM=1,NATOM          !!! over atoms
	ISORT=IS(IATOM)
	DO 4000 IORBS=1,NORBS          !!! over spins
	DO 3000 IUPDN=1,NSPIN          !!! over spins
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
      DO 2000 IKAP1=1,NKAP(IPAN)     !!! over energy
      DO 1000 IKAP =1,NKAP(IPAN)     !!! over energy
C SET ZEROES
	DO L1=0,ILST(ISORT)            !!! over l1
	LOG1=.FALSE.
	IF(LTPAN(L1,IATOM,IKAP1,IPAN))LOG1=.TRUE.
	DO M1=-L1,L1                   !!! over m1
	L1M1=L1*(L1+1)+M1+1
	DO L=0,ILST(ISORT)             !!! over l
	LOG=.FALSE.
	IF(LTPAN(L,IATOM,IKAP,IPAN))LOG=.TRUE.
	DO M=-L,L                      !!! over m
	LM=L*(L+1)+M+1
	IF(L1.LE.ILSB(ISORT).AND.L.LE.ILSB(ISORT))
     &HPARHH(L1M1,LM,IATOM)=(0.D0,0.D0)
	IF(L.LE.ILSB(ISORT))
     &HPARJH(L1M1,LM,IATOM)=(0.D0,0.D0)
	IF(L1.LE.ILSB(ISORT))
     &HPARHJ(L1M1,LM,IATOM)=(0.D0,0.D0)
	HPARJJ(L1M1,LM,IATOM)=(0.D0,0.D0)
      ENDDO                          !!! over m
      ENDDO                          !!! over l
      ENDDO                          !!! over m1
      ENDDO                          !!! over l1
C ADD SELF-ENERGY
	DO L=0,ILSB(ISORT)             !!! over l
	LOG1=.FALSE.
	LOG =.FALSE.
	IF(LTPAN(L,IATOM,IKAP1,IPAN))LOG1=.TRUE.
	IF(LTPAN(L,IATOM,IKAP ,IPAN))LOG =.TRUE.
C ********************
C Note that SIGW is ALREADY the matrix element <B^{+/-} * S_{+/-}>
C not just a field <B^{+/-}>!
	DO M1=-L,L                     !!! over m1
	LM1=L*(L+1)+M1+1
	DO M=-L,L                      !!! over m
	LM=L*(L+1)+M+1
      IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M1+1 !!! (l,m1 m)
C We need to divide by {+/-}sqrt(2) here since off diag. elements were multiplied by this factor
	IF(LOG1.AND.LOG)
     &HPARHH(LM1,LM,IATOM)=HPARHH(LM1,LM,IATOM)+
     &PHH(IKAP1,IKAP,L,ISORT,IPAN,IUPDN,IORBS)*
     &          (SIGW(IU,IATOM,IUPDN,IORBS)-
     &           VDBC(IU,IATOM,IUPDN,IORBS))
 	IF(LOG)
     &HPARJH(LM1,LM,IATOM)=HPARJH(LM1,LM,IATOM)+
     &PJH(IKAP1,IKAP,L,ISORT,IPAN,IUPDN,IORBS)*
     &          (SIGW(IU,IATOM,IUPDN,IORBS)-
     &           VDBC(IU,IATOM,IUPDN,IORBS))
 	IF(LOG1)
     &HPARHJ(LM1,LM,IATOM)=HPARHJ(LM1,LM,IATOM)+
     &PHJ(IKAP1,IKAP,L,ISORT,IPAN,IUPDN,IORBS)*
     &          (SIGW(IU,IATOM,IUPDN,IORBS)-
     &           VDBC(IU,IATOM,IUPDN,IORBS))
 	HPARJJ(LM1,LM,IATOM)=HPARJJ(LM1,LM,IATOM)+
     &PJJ(IKAP1,IKAP,L,ISORT,IPAN,IUPDN,IORBS)*
     &          (SIGW(IU,IATOM,IUPDN,IORBS)-
     &           VDBC(IU,IATOM,IUPDN,IORBS))
      ENDDO                          !!! over m
      ENDDO                          !!! over m1
      ENDDO                          !!! over l
C STORE POTENTIAL PARAMETERS
	IREC=IKAP1+NKAP(IPAN)*(IKAP-1)+NKAP(IPAN)**2*(IATOM-1)+
     &NKAP(IPAN)**2*NATOM*(IUPDN-1)+
     &NKAP(IPAN)**2*NATOM*NSPIN*(IORBS-1)
	WRITE(IUNMT,REC=IREC)((HPARHH(L1M1,LM,IATOM),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((HPARJH(L1M1,LM,IATOM),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((HPARHJ(L1M1,LM,IATOM),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &((HPARJJ(L1M1,LM,IATOM),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2)
1000  CONTINUE                       !!! over ikap
2000  CONTINUE                       !!! over ikap1
3000  CONTINUE                       !!! over spins
4000  CONTINUE                       !!! over iorbs
5000  CONTINUE                       !!! over atoms
C MEMORY DEALLOCATIONS
	END
