	SUBROUTINE DMF_SIGMAW(IMSC)
*********************************************************
*  Sets self energy                                     *
*********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                          !!! from setup
      USE COM_CONTROL ,ONLY : IDMF                            !!! from readini
      USE COM_PARAM   ,ONLY : NATOM,NSORT,NSPIN,NORBS,IS,ILSB !!! from readini
      USE COM_KAPPAR  ,ONLY : NPAN,NKAP                       !!! from readini
      USE COM_PANPAR  ,ONLY : LTPAN,LSPAN                     !!! from readini
      USE COM_MSBMESH ,ONLY : NMSC,TEMP                       !!! from msbmesh
      USE COM_DMFDAT  ,ONLY : SIGI,SIGW,DELW                  !!! from grfmat
	USE COM_IMPDAT  ,ONLY : AMAGIMP,BSPLIMP,ISPLIMP         !!! from readhub
      USE COM_HUBDAT  ,ONLY : MCRL,LCRL                       !!! from readhub
      USE COM_CHANNELS,ONLY : IUSGM                           !!! from channels
      USE COM_UNIT    ,ONLY : IUN,IUR,IUT,IUI                 !!! from setup
      USE COM_MASHDEP ,ONLY : LENCMP                          !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16 HS,OS,AMAG(-1:1)
	LOGICAL LOG
	DATA PI/3.141592653589793D0/
      CALL ABORTNOW()
C SET SELF-ENERGY
      DO IORBS=1,NORBS                    !!! over iorbs
      DO IUPDN=1,NSPIN                    !!! over iupdn
	DO IATOM=1,NATOM                    !!! over iatom
	ISORT=IS(IATOM)
	DO L=0,ILSB(ISORT)                  !!! over l
	DO K=-L,L                           !!! over k
	DO M=-L,L                           !!! over m
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+K+1 !!! (l,k m)
	SIGW(IU,IATOM,IUPDN,IORBS)=SIGI(IU,IATOM,IUPDN,IORBS)
      ENDDO                               !!! over m
      ENDDO                               !!! over k
      ENDDO                               !!! over l
      ENDDO                               !!! over iatom
      ENDDO                               !!! over spins
      ENDDO                               !!! over iorbs
C READ SELF-ENERGY
	IREC=0
	DO JMSC=0,NMSC             !!! over Matsubara frequencies
	DO IATOM=1,NATOM           !!! over atoms
	ISORT=IS(IATOM)
	IF(MCRL(IATOM).EQ.0)CYCLE
	IREC=IREC+1
	IF(JMSC.NE.IMSC)CYCLE
	IUMAX=(ILSB(ISORT)+1)*(2*ILSB(ISORT)+1)*(2*ILSB(ISORT)+3)/3
	READ(IUSGM,REC=IREC)
     &(((SIGW(IU,IATOM,IUPDN,IORBS),IU=1,IUMAX),IUPDN=1,NSPIN),
     &IORBS=1,NORBS),
     &(((DELW(IU,IATOM,IUPDN,IORBS),IU=1,IUMAX),IUPDN=1,NSPIN),
     &IORBS=1,NORBS)
	ENDDO                      !!! over atoms
	ENDDO                      !!! over Matsubara frequencies
C ADD SPLITTING TO THE SELF-ENERGY
	DO IATOM=1,NATOM                          !!! over iatom
	ISORT=IS(IATOM)
	IF(MCRL(IATOM).EQ.0)CYCLE
	DO L=0,ILSB(ISORT)                        !!! over l
	IF(LCRL(L,IATOM).EQ.0)CYCLE
	AMAG(+0)=  AMAGIMP(3,L,IATOM)
	AMAG(-1)=+(AMAGIMP(1,L,IATOM)+(0.D0,1.D0)*
     &           AMAGIMP(2,L,IATOM))/SQRT(2.D0)
	AMAG(+1)=-(AMAGIMP(1,L,IATOM)-(0.D0,1.D0)*
     &           AMAGIMP(2,L,IATOM))/SQRT(2.D0)
	AMAG(+0)=AMAG(+0)*BSPLIMP(L,IATOM)
	AMAG(-1)=AMAG(-1)*BSPLIMP(L,IATOM)
	AMAG(+1)=AMAG(+1)*BSPLIMP(L,IATOM)
	DO M=-L,L                                 !!! over m
	LM=L*(L+1)+M+1
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M+1  !  (l,m m) packed
      SIGW(IU,IATOM,1,1)=SIGW(IU,IATOM,1,1)+AMAG(+0)
      SIGW(IU,IATOM,NSPIN,1)=SIGW(IU,IATOM,NSPIN,1)-AMAG(+0)
	IF(NORBS.EQ.2)THEN
      SIGW(IU,IATOM,1,NORBS)=SIGW(IU,IATOM,1,NORBS)-AMAG(+1)*SQRT(2.D0)
      SIGW(IU,IATOM,NSPIN,NORBS)=SIGW(IU,IATOM,NSPIN,NORBS)
     &                                             +AMAG(-1)*SQRT(2.D0)
	ENDIF
	ENDDO                                     !!! over m
C SET UP SPLITTING TO ZERO
      IF(ISPLIMP(L,IATOM).NE.1.AND.IMSC.EQ.NMSC+1)
     &BSPLIMP(L,IATOM)=0.D0
	ENDDO                                     !!! over l
	ENDDO                                     !!! over atoms
C ERROR HANDLINGS
C none
	END
