	SUBROUTINE DMF_TOSINT(IPNT,IMSC,IDEA)
*********************************************************
*  Computes Density matrix                              *
*********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                 !!! from setup
      USE COM_CONTROL ,ONLY: LIFT,LMTO,IASA,IDMF                     !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS
     &                      ,IS,ILSB,ILST,NHSORT                     !!! from readini
      USE COM_LATTICE ,ONLY: RBAS,GBAS,TAU                           !!! from readstr
      USE COM_LATPAR  ,ONLY: PAR,OMEGAC                              !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP                          !!! from readini
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC,NBNDH           !!! from readini
      USE COM_MSBMESH ,ONLY: TEMP,NMSC,WMSC,FMSC                     !!! from msbmesh
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN                             !!! from readini
	USE COM_ENERGY  ,ONLY: WTRT,WDRT                               !!! from ttrint
      USE COM_GRFDAT  ,ONLY: EPOL,EPOW,GWGT,GWGD,GW0T,GW0D           !!! from grfbnd
	USE COM_LMTVEC  ,ONLY: APHR,APSR,APJR,APHL,APSL,APJL           !!! from lmtvec
      USE COM_DENDAT  ,ONLY: RHOPN                                   !!! from rhofull
      USE COM_PLWMESH ,ONLY: NPLW,GPLW                               !!! from plwmesh
      USE COM_ETAPAR  ,ONLY: NBAS,LBAS                               !!! from setpar
      USE COM_TEILORG ,ONLY: MBAS,KEYT                               !!! from readini
	USE COM_RINPAR  ,ONLY: RINT0,RFUN                              !!! from tosint
      USE COM_KMESH   ,ONLY: NPNT,PNT,WGT                            !!! from tetra
      USE COM_INPTTR  ,ONLY: NDIV,NDIC,SH                            !!! from readini
	USE COM_INDORB  ,ONLY: INDLMT                                  !!! from lmtpar
      USE COM_MASHDEP ,ONLY: LENCMP                                  !!! from setup
	USE COM_CHANNELS,ONLY: IUTOS,IUPDS                             !!! from channels
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                         !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER, INTRINSIC :: SIZE
C
	COMPLEX*16, ALLOCATABLE :: YLM(:,:)
	COMPLEX*16, ALLOCATABLE :: CFTR(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: PSIKR(:,:)
	COMPLEX*16, ALLOCATABLE :: PSIKL(:,:)
	COMPLEX*16, ALLOCATABLE :: DPSIR(:)
	COMPLEX*16, ALLOCATABLE :: DPSIL(:)
	COMPLEX*16, ALLOCATABLE :: EXPK(:)
C
	DIMENSION PNTR(3),PNTK(3)
	COMPLEX*16 ZMSC,WHT,WDT,EXPK0,EXPS0,CTMP
	LOGICAL LOG1,LOG
      DATA PI/3.141592653589793D0/
      CALL ABORTNOW()
	IF(NPLWMEM.EQ.-1)RETURN
C MEMORY ALLOCATIONS
	ALLOCATE(YLM(LIMBMEM,0:NBASMEM))
      SIZE_YLM=DBLE(SIZE(YLM)*LENCMP)/1024.D0**2
	ALLOCATE(CFTR(0:LMAXBMEM,NSORTMEM,NKAPMEM,0:NBASMEM))
      SIZE_CFTR=DBLE(SIZE(CFTR)*LENCMP)/1024.D0**2
      CURMEM=CURMEM+SIZE_YLM+SIZE_CFTR
      IF(TOTMEM.LT.CURMEM)TXTMEM='<DMF_TOSPAR> Subroutine'
      IF(TOTMEM.LT.CURMEM)TOTMEM=CURMEM
	ALLOCATE(PSIKR(0:NBASMEM,NSPINMEM))
	ALLOCATE(PSIKL(0:NBASMEM,NSPINMEM))
	ALLOCATE(DPSIL(0:NBASMEM))
	ALLOCATE(DPSIR(0:NBASMEM))
	ALLOCATE(EXPK(0:NBASMEM))
C FIND K-POINT PNTR=K+G WHICH HAS A MINIMAL LENGTH
      XK=PNT(1,IPNT,1)+SH(1,1)
      YK=PNT(2,IPNT,1)+SH(2,1)
      ZK=PNT(3,IPNT,1)+SH(3,1)
      CALL REDUC2(XK,YK,ZK,NBAS,GPLW(1,0),PNTK(1),PNTK(2),PNTK(3),
     &GRX,GRY,GRZ)
	IF(IMSC.NE.NMSC+1)ZMSC=WMSC(IMSC)
	IF(IMSC.EQ.NMSC+1)ZMSC=(0.D0,0.D0)
C SET PSEUDOLMTOS FOR THE POINT IPNTK
      CALL BND_FTRMAT(PNTK,0,1,PNTR,YLM,CFTR)
C DO GLOBALLY OVER SPINS
      DO 2000 IORBS=1,NORBS                   !!! over iorbs
      DO 1000 IUPDN=1,NSPIN                   !!! over spins
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	SIGNF=1.D0
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	IF(ISPIN1.EQ.1.AND.ISPIN.EQ.2)SIGNF=+SQRT(2.D0) ! M^{-}=<S^{-}>=-<S_{+}>
	IF(ISPIN1.EQ.2.AND.ISPIN.EQ.1)SIGNF=-SQRT(2.D0) ! M^{+}=<S^{+}>=-<S_{-}>
	ENDIF
C READ DENSITY PARAMETERS
      IREC=IUPDN+NSPIN*(IORBS-1)
      IF(KEYT.GT.0)
     &READ(IUPDS,REC=IREC)((RINT0(IPAR1,IPAR),IPAR1=1,
     &NBNDT(1)),IPAR=1,NBNDT(1)),((RFUN(IPAR1,IBAS),
     &IPAR1=1,NBNDT(1)),IBAS=0,MIN(NBAS,MBAS))
C DO GLOBALLY OVER BANDS
      DO IBNDS=1,NSPIN                        !!! over spin subbands
      IF(NORBS.EQ.1.AND.IUPDN.NE.IBNDS)CYCLE
      DO IBNDT=1,NBNDT(1)+NBNDH(1)            !!! over bands
      IBAND=IBNDS+NSPIN*(IBNDT-1)
C SET WEIGHT
      WHT=(0.D0,0.D0)
	IF(IMSC.NE.NMSC+1.AND.IDMF.EQ.3)
     &WHT=+TEMP*GWGT(IBAND,IPNT,IMSC)*FMSC(IMSC)*SIGNF
	IF(IMSC.EQ.NMSC+1.AND.IDMF.EQ.3) ! 0.5*W/Nspin is a weight, 1/2/Ng is a renorm.
     &WHT=-TEMP*GW0T(IBAND,IPNT)*SIGNF+
     &DCMPLX(0.5D0*WTRT(IBAND,IPNT),0.D0)*SIGNF
	IF(IMSC.EQ.0.AND.IDMF.EQ.4)
     &WHT=DCMPLX(0.5D0*WTRT(IBAND,IPNT),0.D0)*SIGNF
	IF(IMSC.NE.NMSC+1.AND.IDMF.EQ.5)
     &WHT=-0.5D0*DIMAG(GWGT(IBAND,IPNT,IMSC))/PI*FMSC(IMSC)*
     &FERMIFUN(DREAL(ZMSC),TEMP)*SIGNF
 	IF(IMSC.EQ.NMSC+1.AND.IDMF.EQ.5) !
     &WHT=(0.D0,0.D0)
	DO IBAS=0,NBAS
	PSIKR(IBAS,ISPIN1)=(0.D0,0.D0)
	PSIKR(IBAS,ISPIN )=(0.D0,0.D0)
	PSIKL(IBAS,ISPIN1)=(0.D0,0.D0)
	PSIKL(IBAS,ISPIN )=(0.D0,0.D0)
	ENDDO
	DO IKAP=1,NKAP(1)                       !!! over energies
	DO IATOM=1,NATOM                        !!! over iatom
	ISORT=IS(IATOM)
C CALCULATE EXPONENTIAL FACTOR
	DO IBAS=0,MIN(NBAS,MBAS)
	SCP=(GPLW(1,IBAS)+PNTK(1))*TAU(1,IATOM)+
     &    (GPLW(2,IBAS)+PNTK(2))*TAU(2,IATOM)+
     &    (GPLW(3,IBAS)+PNTK(3))*TAU(3,IATOM)
	EXPK(IBAS)=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	ENDDO
C PSEUDOWAVEFUNCTION 
	DO L=0,ILSB(ISORT)                      !!! over l
	IF(.NOT.LTPAN(L,IATOM,IKAP,1))CYCLE
	MINB=MIN(LBAS(L,ISORT,IKAP,1),MBAS)
	DO M=-L,L                               !!! over m
      LM=L*(L+1)+M+1
	DO IBAS=0,MINB
	PSIKR(IBAS,ISPIN1)=PSIKR(IBAS,ISPIN1)+
     &CFTR(L,ISORT,IKAP,IBAS)*EXPK(IBAS)*YLM(LM,IBAS)*
     &APSR(LM,IATOM,IKAP,ISPIN1,IBAND)
	PSIKL(IBAS,ISPIN1)=PSIKL(IBAS,ISPIN1)+
     &DCONJG(CFTR(L,ISORT,IKAP,IBAS)*EXPK(IBAS)*YLM(LM,IBAS))*
     &APSL(LM,IATOM,IKAP,ISPIN1,IBAND)
	IF(ISPIN1.NE.ISPIN)
     &PSIKR(IBAS,ISPIN )=PSIKR(IBAS,ISPIN )+
     &CFTR(L,ISORT,IKAP,IBAS)*EXPK(IBAS)*YLM(LM,IBAS)*
     &APSR(LM,IATOM,IKAP,ISPIN ,IBAND)
	IF(ISPIN1.NE.ISPIN)
     &PSIKL(IBAS,ISPIN )=PSIKL(IBAS,ISPIN )+
     &DCONJG(CFTR(L,ISORT,IKAP,IBAS)*EXPK(IBAS)*YLM(LM,IBAS))*
     &APSL(LM,IATOM,IKAP,ISPIN ,IBAND)
      ENDDO        
      ENDDO                                   !!! over m
      ENDDO                                   !!! over l
      ENDDO                                   !!! over iatom
      ENDDO                                   !!! over ikap
	DO IBAS=0,MIN(NBAS,MBAS)                !!! over ibas
	DPSIL(IBAS)=PSIKL(IBAS,ISPIN1)*WHT
      ENDDO                                   !!! over ibas
C FOURIER TRANSFORM OF THE PSEUDOCHARGE DENSITY (SMALL G-VECTORS)
	CALL BND_CONVOL2(RHOPN(0,IUPDN,IORBS),DPSIL(0),PSIKR(0,ISPIN),'P',
     &                 0,MIN(NBAS,MBAS),0,MIN(NBAS,MBAS))
	DO IBAS=0,MIN(NBAS,MBAS)                !!! over ibas
	DPSIL(IBAS)=DCONJG(PSIKR(IBAS,ISPIN1)*WHT)
	DPSIR(IBAS)=DCONJG(PSIKL(IBAS,ISPIN ))
      ENDDO                                   !!! over ibas
C FOURIER TRANSFORM OF THE PSEUDOCHARGE DENSITY (SMALL G-VECTORS)
	CALL BND_CONVOL2(RHOPN(0,IUPDN,IORBS),DPSIL(0),DPSIR(0),'P',
     &                 0,MIN(NBAS,MBAS),0,MIN(NBAS,MBAS))
C AUXILARY ARRAYS: 
	IF(KEYT.GT.0)THEN
      DO IATOM1=1,NATOM                       !!! over iatom1
      ISORT1=IS(IATOM1)
      SCP=PNTK(1)*TAU(1,IATOM1)+
     &    PNTK(2)*TAU(2,IATOM1)+
     &    PNTK(3)*TAU(3,IATOM1)
      EXPS0=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
      DO IKAP1=1,NKAP(1)                      !!! over energy
      DO L1=0,ILSB(ISORT1)                    !!! over l1
      IF(.NOT.LTPAN(L1,IATOM1,IKAP1,1))CYCLE
      DO M1=-L1,L1                            !!! over m1
      L1M1=L1*(L1+1)+M1+1
      IPAR1=INDLMT(L1M1,IATOM1,IKAP1,1,1)
C  1) TOS-MATRIX
      DO IATOM=1,NATOM                        !!! over iatom
      ISORT=IS(IATOM)
      SCP=PNTK(1)*TAU(1,IATOM)+
     &    PNTK(2)*TAU(2,IATOM)+
     &    PNTK(3)*TAU(3,IATOM)
      EXPK0=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
      DO IKAP=1,NKAP(1)                       !!! over energy
      DO L=0,ILSB(ISORT)                      !!! over l
      IF(.NOT.LTPAN(L,IATOM,IKAP,1))CYCLE
      DO M=-L,L                               !!! over m
      LM=L*(L+1)+M+1
      IPAR=INDLMT(LM,IATOM,IKAP,1,1)
      IF(IPAR1.GE.IPAR)THEN
	CTMP= (APSL(L1M1,IATOM1,IKAP1,ISPIN1,IBAND)*WHT*
     &       APSR(L M ,IATOM ,IKAP ,ISPIN ,IBAND))*DCONJG(EXPS0)*EXPK0+
     &DCONJG(APSR(L1M1,IATOM1,IKAP1,ISPIN1,IBAND)*WHT*
     &       APSL(L M ,IATOM ,IKAP ,ISPIN ,IBAND))*DCONJG(EXPS0)*EXPK0
      RINT0(IPAR1,IPAR)=RINT0(IPAR1,IPAR)+CTMP
	ENDIF
      ENDDO                                   !!! over m
      ENDDO                                   !!! over l
      ENDDO                                   !!! over energy
      ENDDO                                   !!! over iatom
C  2) RFUN-ARARY
	DO IBAS=0,MIN(NBAS,MBAS)                !!! over ibas
	CTMP= (APSL(L1M1,IATOM1,IKAP1,ISPIN1,IBAND)*
     &PSIKR(IBAS,ISPIN)*WHT)*DCONJG(EXPS0)+
     &DCONJG(APSR(L1M1,IATOM1,IKAP1,ISPIN1,IBAND)*
     &PSIKL(IBAS,ISPIN)*WHT)*DCONJG(EXPS0)
	RFUN(IPAR1,IBAS)=RFUN(IPAR1,IBAS)+CTMP
      ENDDO                                   !!! over ibas
      ENDDO                                   !!! over m1
      ENDDO                                   !!! over l1
      ENDDO                                   !!! over energy
      ENDDO                                   !!! over iatom1
	ENDIF
	ENDDO                                   !!! over bands
      IREC=IUPDN+NSPIN*(IORBS-1)
      IF(KEYT.GT.0)
     &WRITE(IUPDS,REC=IREC)((RINT0(IPAR1,IPAR),IPAR1=1,
     &NBNDT(1)),IPAR=1,NBNDT(1)),((RFUN(IPAR1,IBAS),
     &IPAR1=1,NBNDT(1)),IBAS=0,MIN(NBAS,MBAS))
	ENDDO                                   !!! over spin subbands
 1000 CONTINUE                                !!! over spins
 2000 CONTINUE                                !!! over iorbs
C MEMORY DEALLOCATIONS
	DEALLOCATE(YLM,PSIKL,PSIKR,CFTR,DPSIL,DPSIR,EXPK)
      CURMEM=CURMEM-SIZE_YLM-SIZE_CFTR
	END
