	SUBROUTINE DMF_TOSPAR(IPNT,IMSC,IDEA)
*********************************************************
*  Computes Density matrix                              *
*********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                 !!! from setup
      USE COM_CONTROL ,ONLY: LIFT,LMTO,IASA,IDMF                     !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS
     &                      ,IS,ILSB,ILST,NHSORT                     !!! from readini
      USE COM_LATTICE ,ONLY: RBAS,GBAS,TAU                           !!! from readstr
      USE COM_LATPAR  ,ONLY: PAR,OMEGAC                              !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP                          !!! from readini
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC,NBNDH           !!! from readini
      USE COM_MSBMESH ,ONLY: TEMP,NMSC,WMSC,FMSC                     !!! from grfbnd
      USE COM_LMTMAT  ,ONLY: HMAT,OMAT                               !!! from lmtmat
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN                             !!! from readini
      USE COM_ENERGY  ,ONLY: ETRT,WTRT,WDRT                          !!! from grfbnd
	USE COM_LMTVEC  ,ONLY: APHR,APSR,APJR,APHL,APSL,APJL           !!! from lmtvec
      USE COM_GRFDAT  ,ONLY: GWGT,GWGD,GW0T,GW0D,ECAP                !!! from grfbnd
	USE COM_HAMPAR  ,ONLY: ATOSHH=>HPARHH                          !!! from tospar
     &                      ,ATOSJH=>HPARJH
     &                      ,ATOSHJ=>HPARHJ
     &                      ,ATOSJJ=>HPARJJ 
      USE COM_SUMPAR  ,ONLY: OHH,OJH,OHJ,OJJ                         !!! from ovrpar
      USE COM_SCRINP  ,ONLY: ALPHA                                   !!! from alpcon
      USE COM_KMESH   ,ONLY: NPNT,PNT,WGT                            !!! from tetra
      USE COM_INPTTR  ,ONLY: NDIV,NDIC,SH                            !!! from readini
      USE COM_MASHDEP ,ONLY: LENCMP                                  !!! from setup
      USE COM_FERMI   ,ONLY: ATOS,ADOS                               !!! from ttrints
	USE COM_CHANNELS,ONLY: IUTOS,IUPDS                             !!! from channels
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                         !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER, INTRINSIC :: SIZE
	COMPLEX*16, ALLOCATABLE :: ASUM(:,:,:,:)
	COMPLEX*16 ZMSC,WHT,WDT,CTMP,AHH,AHJ,AJH,AJJ
	LOGICAL LOG1,LOG
      DATA PI/3.141592653589793D0/
      CALL ABORTNOW()
C MEMORY ALLOCATIONS
	ALLOCATE(ASUM(0:LMAXTMEM,NSORTMEM,NKAPMEM,NKAPMEM))
C FIND TOS MATRIX
	NSHIFT=0
	DO JPAN=1,NPAN
	IF(JPAN.LT.1)
     &NSHIFT=NSHIFT+NKAP(JPAN)**2*NATOM*NSPIN*NORBS
      ENDDO
	IF(IMSC.NE.NMSC+1)ZMSC=WMSC(IMSC)
	IF(IMSC.EQ.NMSC+1)ZMSC=(0.D0,0.D0)
      DO 2000 IORBS=1,NORBS                          !!! over iorbs
      DO 1000 IUPDN=1,NSPIN                          !!! over iupdn
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	SIGNF=1.D0
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	IF(ISPIN1.EQ.1.AND.ISPIN.EQ.2)SIGNF=+SQRT(2.D0) ! M^{-}=<S^{-}>=-<S_{+}>
	IF(ISPIN1.EQ.2.AND.ISPIN.EQ.1)SIGNF=-SQRT(2.D0) ! M^{+}=<S^{+}>=-<S_{-}>
	ENDIF
      DO IKAP=1,NKAP(1)                              !!! over energies
      DO JKAP=1,NKAP(1)                              !!! over energies
	DO IATOM=1,NATOM                               !!! over iatom
	ISORT=IS(IATOM)
	IREC=IKAP+NKAP(1)*(JKAP-1)+NKAP(1)**2*(IATOM-1)+
     &NKAP(1)**2*NATOM*(IUPDN-1)+NKAP(1)**2*NATOM*NSPIN*(IORBS-1)+
     &NSHIFT
	READ(IUTOS,REC=IREC)
     &((ATOSHH(L1M1,LM,IATOM),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((ATOSJH(L1M1,LM,IATOM),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((ATOSHJ(L1M1,LM,IATOM),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &((ATOSJJ(L1M1,LM,IATOM),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2)
      ENDDO                                          !!! over iatom
C *********** TETRAHEDRON METHOD *****
      DO IBNDS=1,NSPIN                               !!! over spin subbands
      IF(NORBS.EQ.1.AND.IUPDN.NE.IBNDS)CYCLE
      DO IBNDT=1,NBNDT(1)+NBNDH(1)                   !!! over bands
      IBAND=IBNDS+NSPIN*(IBNDT-1)
C SET WEIGHT
      WHT=(0.D0,0.D0)
	IF(IMSC.NE.NMSC+1.AND.IDMF.EQ.3)
     &WHT=+TEMP*GWGT(IBAND,IPNT,IMSC)*FMSC(IMSC)*SIGNF
	IF(IMSC.EQ.NMSC+1.AND.IDMF.EQ.3) ! 0.5*W/Nspin is a weight, 1/2/Ng is a renorm.
     &WHT=-TEMP*GW0T(IBAND,IPNT)*SIGNF+
     &DCMPLX(0.5D0*WTRT(IBAND,IPNT),0.D0)*SIGNF
	IF(IMSC.EQ.0.AND.IDMF.EQ.4)   !!! simple weight
     &WHT=DCMPLX(0.5D0*WTRT(IBAND,IPNT),0.D0)*SIGNF
	IF(IMSC.NE.NMSC+1.AND.IDMF.EQ.5)
     &WHT=-0.5D0*DIMAG(GWGT(IBAND,IPNT,IMSC))/PI*FMSC(IMSC)*
     &FERMIFUN(DREAL(ZMSC),TEMP)*SIGNF
 	IF(IMSC.EQ.NMSC+1.AND.IDMF.EQ.5) !
     &WHT=(0.D0,0.D0)
C COMPUTE CONTRIBUTION FROM THIS K-POINT
      DO IATOM=1,NATOM                               !!! over atoms in cell
      ISORT=IS(IATOM)
      DO L1=0,ILST(ISORT)                            !!! over l1
      LOG1=.FALSE.
      IF(LTPAN(L1,IATOM,IKAP,1))LOG1=.TRUE.
      DO M1=-L1,L1                                   !!! over m1
      L1M1=L1*(L1+1)+M1+1
      DO L=0,ILST(ISORT)                             !!! over l
      LOG=.FALSE.
      IF(LTPAN(L,IATOM,JKAP,1))LOG=.TRUE.
      DO M=-L,L                                      !!! over m
      LM=L*(L+1)+M+1
      IF(LOG1.AND.LOG)
     &ATOSHH(L1M1,LM,IATOM)=ATOSHH(L1M1,LM,IATOM)+WHT*
     &APHL(L1M1,IATOM,IKAP,ISPIN1,IBAND)*
     &APHR(L M ,IATOM,JKAP,ISPIN ,IBAND)+DCONJG(WHT*
     &APHR(L1M1,IATOM,IKAP,ISPIN1,IBAND)*
     &APHL(L M ,IATOM,JKAP,ISPIN ,IBAND))
      IF(LOG1)
     &ATOSHJ(L1M1,LM,IATOM)=ATOSHJ(L1M1,LM,IATOM)+WHT*
     &APHL(L1M1,IATOM,IKAP,ISPIN1,IBAND)*
     &APJR(L M ,IATOM,JKAP,ISPIN ,IBAND)+DCONJG(WHT*
     &APHR(L1M1,IATOM,IKAP,ISPIN1,IBAND)*
     &APJL(L M ,IATOM,JKAP,ISPIN ,IBAND))
      IF(LOG)
     &ATOSJH(L1M1,LM,IATOM)=ATOSJH(L1M1,LM,IATOM)+WHT*
     &APJL(L1M1,IATOM,IKAP,ISPIN1,IBAND)*
     &APHR(L M ,IATOM,JKAP,ISPIN ,IBAND)+DCONJG(WHT*
     &APJR(L1M1,IATOM,IKAP,ISPIN1,IBAND)*
     &APHL(L M ,IATOM,JKAP,ISPIN ,IBAND))
      IF(.TRUE.)
     &ATOSJJ(L1M1,LM,IATOM)=ATOSJJ(L1M1,LM,IATOM)+WHT*
     &APJL(L1M1,IATOM,IKAP,ISPIN1,IBAND)*
     &APJR(L M ,IATOM,JKAP,ISPIN ,IBAND)+DCONJG(WHT*
     &APJR(L1M1,IATOM,IKAP,ISPIN1,IBAND)*
     &APJL(L M ,IATOM,JKAP,ISPIN ,IBAND))
      ENDDO                                          !!! over m
      ENDDO                                          !!! over l
      ENDDO                                          !!! over m1
      ENDDO                                          !!! over l1
      ENDDO                                          !!! over atoms in cell
      ENDDO                                          !!! over valence bands
      ENDDO                                          !!! over spin subbands
      DO IATOM=1,NATOM
      ISORT=IS(IATOM)
	IREC=IKAP+NKAP(1)*(JKAP-1)+NKAP(1)**2*(IATOM-1)+
     &NKAP(1)**2*NATOM*(IUPDN-1)+NKAP(1)**2*NATOM*NSPIN*(IORBS-1)+
     &NSHIFT
      WRITE(IUTOS,REC=IREC)
     &((ATOSHH(L1M1,LM,IATOM),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((ATOSJH(L1M1,LM,IATOM),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((ATOSHJ(L1M1,LM,IATOM),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &((ATOSJJ(L1M1,LM,IATOM),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2)
      ENDDO
      ENDDO                                          !!! over energies
      ENDDO                                          !!! over energies
 1000 CONTINUE                                       !!! over iupdn
 2000 CONTINUE                                       !!! over iorbs
C CALCULATE PARTIAL NUMBER OF STATES
      DO IORBS=1,NORBS                               !!! over spinor components
      DO IBNDS=1,NSPIN                               !!! over spin subbands
      IF(NORBS.EQ.1)ISPIN=IBNDS
      IF(NORBS.EQ.2)ISPIN=IORBS
      DO IBNDT=1,NBNDT(1)+NBNDH(1)                   !!! over bands
      IBAND=IBNDS+NSPIN*(IBNDT-1)
C Set weight
	IF(IMSC.NE.NMSC+1.AND.IDMF.EQ.3)
     &WHT=+TEMP*GWGT(IBAND,IPNT,IMSC)*FMSC(IMSC)
	IF(IMSC.EQ.NMSC+1.AND.IDMF.EQ.3) ! 0.5*W/Nspin is a weight, 1/2/Ng is a renorm.
     &WHT=-TEMP*GW0T(IBAND,IPNT)+
     &DCMPLX(0.5D0*WTRT(IBAND,IPNT),0.D0)
	IF(IMSC.EQ.0.AND.IDMF.EQ.4)   !!! simple weight
     &WHT=DCMPLX(0.5D0*WTRT(IBAND,IPNT),0.D0)
	IF(IMSC.NE.NMSC+1.AND.IDMF.EQ.5)
     &WHT=-0.5D0*DIMAG(GWGT(IBAND,IPNT,IMSC))/PI*FMSC(IMSC)*
     &FERMIFUN(DREAL(ZMSC),TEMP)*SIGNF
 	IF(IMSC.EQ.NMSC+1.AND.IDMF.EQ.5) !
     &WHT=(0.D0,0.D0)
	IF(IMSC.NE.NMSC+1.AND.IDMF.EQ.3)
     &WDT=+TEMP*GWGD(IBAND,IPNT,IMSC)*FMSC(IMSC)
	IF(IMSC.EQ.NMSC+1.AND.IDMF.EQ.3) ! 0.5*W/Nspin is a weight, 1/2/Ng is a renorm.
     &WDT=-TEMP*GW0D(IBAND,IPNT)+
     &DCMPLX(0.5D0*WDRT(IBAND,IPNT),0.D0)
	IF(IMSC.EQ.0.AND.IDMF.EQ.4)   !!! simple weight
     &WDT=DCMPLX(0.5D0*WDRT(IBAND,IPNT),0.D0)
	IF(IMSC.NE.NMSC+1.AND.IDMF.EQ.5)
     &WDT=-0.5D0*DIMAG(GWGD(IBAND,IPNT,IMSC))/PI*FMSC(IMSC)*SIGNF
 	IF(IMSC.EQ.NMSC+1.AND.IDMF.EQ.5) !
     &WDT=(0.D0,0.D0)
C Set partial characters array
	ANORM=0.D0
	DO IKAP1=1,NKAP(1)                                 !!! over energies
	DO IKAP=1,NKAP(1)                                  !!! over energies
	DO ISORT=1,NSORT                                      !!! over isort
	DO L=0,ILST(ISORT)                                    !!! over l
	AHH=(0.D0,0.D0)
	AHJ=(0.D0,0.D0)
	AJH=(0.D0,0.D0)
	AJJ=(0.D0,0.D0)
	DO IATOM=1,NATOM                                      !!! over atoms
	IF(ISORT.EQ.IS(IATOM))THEN
	DO M=-L,L                                             !!! over m
	LM=L*(L+1)+M+1
	IF(LSPAN(L,ISORT,IKAP1,1).AND.LSPAN(L,ISORT,IKAP,1))
     &AHH=AHH+OHH(IKAP1,IKAP,L,ISORT,1,ISPIN,1)*
     &APHL(LM,IATOM,IKAP1,ISPIN1,IBAND)*APHR(LM,IATOM,IKAP,ISPIN,IBAND)
	IF(LSPAN(L,ISORT,IKAP,1))
     &AJH=AJH-OJH(IKAP1,IKAP,L,ISORT,1,ISPIN,1)*
     &APJL(LM,IATOM,IKAP1,ISPIN1,IBAND)*APHR(LM,IATOM,IKAP,ISPIN,IBAND)
	IF(LSPAN(L,ISORT,IKAP1,1))
     &AHJ=AHJ-OHJ(IKAP1,IKAP,L,ISORT,1,ISPIN,1)*
     &APHL(LM,IATOM,IKAP1,ISPIN1,IBAND)*APJR(LM,IATOM,IKAP,ISPIN,IBAND)
	AJJ=AJJ+OJJ(IKAP1,IKAP,L,ISORT,1,ISPIN,1)*
     &APJL(LM,IATOM,IKAP1,ISPIN1,IBAND)*APJR(LM,IATOM,IKAP,ISPIN,IBAND)
      ENDDO                                                 !!! over m
	ENDIF
      ENDDO                                                 !!! over atoms
	ASUM(L,ISORT,IKAP1,IKAP)=(AHH+AHJ+AJH+AJJ)/DBLE(NHSORT(ISORT))
	ANORM=ANORM+ASUM(L,ISORT,IKAP1,IKAP)*DBLE(NHSORT(ISORT))
      ENDDO                                                 !!! over l
      ENDDO                                                 !!! over isort
      ENDDO                                                 !!! over ikap
      ENDDO                                                 !!! over ikap1
C Normalize partial characters array
	IF(ABS(ANORM).LE.1.D-10)ANORM=1.D0
	DO IKAP1=1,NKAP(1)                                    !!! over energies
	DO IKAP=1,NKAP(1)                                     !!! over energies
	DO ISORT=1,NSORT                                      !!! over isort
	DO L=0,ILST(ISORT)                                    !!! over l
C	ASUM(L,ISORT,IKAP1,IKAP)=ASUM(L,ISORT,IKAP1,IKAP)/ANORM
      ENDDO                                                 !!! over l
      ENDDO                                                 !!! over isort
      ENDDO                                                 !!! over ikap
      ENDDO        
      DO IKAP1=1,NKAP(1)                                    !!! over energies
      DO IKAP=1,NKAP(1)                                     !!! over energies
      DO ISORT=1,NSORT                                      !!! over isort
      DO L=0,ILST(ISORT)                                    !!! over l
      ADOS(L,ISORT,IKAP1,IKAP,1,ISPIN)=
     &ADOS(L,ISORT,IKAP1,IKAP,1,ISPIN)+
     &       ASUM(L,ISORT,IKAP1,IKAP)*WDT+
     &DCONJG(ASUM(L,ISORT,IKAP1,IKAP)*WDT)
      DO IMOM=0,5                                           !!! over moments
      ATOS(L,ISORT,IKAP1,IKAP,1,ISPIN,IMOM)=
     &ATOS(L,ISORT,IKAP1,IKAP,1,ISPIN,IMOM)+
     &ETRT(IBAND,IPNT,1)**IMOM*ASUM(L,ISORT,IKAP1,IKAP)*WHT+
     &ETRT(IBAND,IPNT,1)**IMOM*DCONJG(ASUM(L,ISORT,IKAP1,IKAP)*WHT)	
      ENDDO                                                 !!! over moments
      ENDDO                                                 !!! over l
      ENDDO                                                 !!! over isort
      ENDDO                                                 !!! over energies
      ENDDO                                                 !!! over energies
      ENDDO                                                 !!! over bands
      ENDDO                                                 !!! over spin subbands
      ENDDO                                                 !!! over spinor components
	DEALLOCATE(ASUM)
	END
