	SUBROUTINE DMF_TTRINT(EF0,KMSC,ZMSC,TOS,DOS,KEYPRN,KEYDOS,KEYCAP)
***********************************************************
*  The calculation of weights for Greens function integ-  *
*  rations over IBZ by means of tetrahedron method.       *
***********************************************************
C  SET ARRAY-SIZE DATA
      USE DIM_LMTART
C  SET EXTERNAL CONNECTIONS
      USE COM_CONTROL,ONLY: LIFT,LMTO,IDMF,IASA                      !!! from readini
      USE COM_PARAM  ,ONLY: NATOM,NSORT,NSPIN,NORBS                  !!! from readini
      USE COM_KAPPAR ,ONLY: NPAN,NKAP                                !!! from readini
      USE COM_LATPAR ,ONLY: PAR,ORTH,OMEGAC                          !!! from readini
      USE COM_LATTICE,ONLY: RBAS,GBAS,AKBAS,RKBAS                    !!! from readstr
      USE COM_NBANDS ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC,NBNDH            !!! from readini
      USE COM_MSBMESH,ONLY: TEMP,NMSC,WMSC,FMSC                      !!! from grfint
      USE COM_ENERGY ,ONLY: ETRT,ETRW,WTRT,WDRT                      !!! from grfbnd
      USE COM_GRFDAT ,ONLY: EPOL,EPOW,ECAP,GWGT,GWGD,GW0T,GW0D       !!! from grfbnd
      USE COM_INPTTR ,ONLY: NDIV,NDIC,NDIW,SH,KEYTTR
     &                     ,TFERMI,GBROAD                            !!! from readini
	USE COM_HUBDAT ,ONLY: KHRM,GDMP                                !!! from readhub
      USE COM_KMESH  ,ONLY: NPNT,PNT,WGT,IPQARR,ITQARR,KCUT          !!! from makettr
      USE COM_WMESH  ,ONLY: NPNW,PNW,WGW,IPWARR,ITWARR,KCUW          !!! from tetra
      USE COM_UNIT   ,ONLY: IUN,IUR,IUT                              !!! from setup
C  SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8, ALLOCATABLE :: FINT(:,:,:)
	INTEGER KTT(4),KTW(4)
      DIMENSION E(4),AT(4),AD(4),FAT(4),FAD(4),FL(0:4,4)
     &   ,PKT(3,4),PKW(3,4),CRW(3,4),REC(3,3)
	COMPLEX*16 ZE(4),AG(4),DG(4),A0(4),CINT(4),DINT(4)
     &   ,ZMSC,ZOMG,GH,GD,ZI,ZJ
      DATA PI/3.141592653589793D0/,EPS/1.D-10/,EPSDEG/1.D-05/
C  MEMORY ALLOCATIONS
	ALLOCATE(FINT(0:4,(NBNDT(1)+NBNDH(1))*NSPINMEM,NPNWMEM))
C  *********** INITIALIZATION **************
	EF=EF0
      VOLIBZ=1.D0
      OT=1.D0/NDIV(1)/NDIV(2)/NDIV(3)/6.D0
      OW=1.D0/NDIW(1)/NDIW(2)/NDIW(3)/6.D0
C     DUMP=+ABS(GDMP)
      DUMP=0.D0      ! dumping applied inside the Hamiltonian !
C  *********** TETRAHEDRON METHOD **********
      DO IBNDS=1,NSPIN
      DO IBNDT=1,NBNDT(1)+NBNDH(1)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
      DO IPNT=1,NPNT(1)
	DO IMSC=0,NMSC+1
      GWGT(IBAND,IPNT,IMSC)=(0.D0,0.D0)
      GWGD(IBAND,IPNT,IMSC)=(0.D0,0.D0)
	ENDDO
      GW0T(IBAND,IPNT)=(0.D0,0.D0)
      GW0D(IBAND,IPNT)=(0.D0,0.D0)
      WTRT(IBAND,IPNT)=(0.D0,0.D0)
      WDRT(IBAND,IPNT)=(0.D0,0.D0)
	ENDDO
	ENDDO
	ENDDO
C  Compute Fermi function integrals
	IF((KEYTTR.EQ.0.OR.KEYTTR.EQ.1).AND.TFERMI.NE.0.D0)THEN
      DO IBNDS=1,NSPIN
      DO IBNDT=1,NBNDT(1)+NBNDH(1)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
      DO IPNW=1,NPNW(1)
	XT=(ETRW(IBAND,IPNW,1)-EF)/TFERMI
	CALL TTR_FERMIINT(XT,40,FINT(0,IBAND,IPNW),0.D0)
	ENDDO
	ENDDO
	ENDDO
	ENDIF
	TOT1=0.D0
	DOT1=0.D0
	TOT2=0.D0
	DOT2=0.D0
	TOT3=0.D0
	DOT3=0.D0
C  DO OVER MICROCELLS
      DO 5200 I3=0,NDIV(3)-1               !!! over cells along G3
      DO 5200 I2=0,NDIV(2)-1               !!! over cells along G2
      DO 5200 I1=0,NDIV(1)-1               !!! over cells along G1
C  THE MICROCELL IS SET UP BY I1,I2,I3
C  SET UP TETRAHEDRON INSIDE MICROCELL
      DO 5100 ITTR=1,6                     !!! over tetrahedra
	IF(ITQARR(ITTR,I1,I2,I3).LT.0)GOTO 5100
	WTTR=DBLE(ITQARR(ITTR,I1,I2,I3))
      DO I=1,4
C  COORDINATES OF THE TETRAHEDRON AGE GIVEN BY KTT
      J1=I1+KCUT(1,I,ITTR)
      J2=I2+KCUT(2,I,ITTR)
      J3=I3+KCUT(3,I,ITTR)
      KTT(I)=IPQARR(J1,J2,J3)
      ENDDO
C  SET UP POINTS "K" DESCRIBING TETRAHEDRON IN THE SPACE
      DO I=1,4
      J1=I1+KCUT(1,I,ITTR)
      J2=I2+KCUT(2,I,ITTR)
      J3=I3+KCUT(3,I,ITTR)
      PKT(1,I)=(J1*AKBAS(1,1,1)+
     &          J2*AKBAS(1,2,1)+
     &          J3*AKBAS(1,3,1))*2.D0*PI/PAR
      PKT(2,I)=(J1*AKBAS(2,1,1)+
     &          J2*AKBAS(2,2,1)+
     &          J3*AKBAS(2,3,1))*2.D0*PI/PAR
      PKT(3,I)=(J1*AKBAS(3,1,1)+
     &          J2*AKBAS(3,2,1)+
     &          J3*AKBAS(3,3,1))*2.D0*PI/PAR
      ENDDO
C  SHIFT COORDINATE SYSTEM TO THE FIRST POINT
      DO I=2,4
      PKT(1,I)=PKT(1,I)-PKT(1,1)
      PKT(2,I)=PKT(2,I)-PKT(2,1)
      PKT(3,I)=PKT(3,I)-PKT(3,1)
      ENDDO
C  SET RECIPROCALS "REC" TO "PKT"
      CALL CROSS(REC(1,1),PKT(1,3),PKT(1,4))
      CALL CROSS(REC(1,2),PKT(1,4),PKT(1,2))
      CALL CROSS(REC(1,3),PKT(1,2),PKT(1,3))
      W=REC(1,1)*PKT(1,2)+REC(2,1)*PKT(2,2)+REC(3,1)*PKT(3,2)
      IF(ABS(W).LE.1.D-10)
     &CALL FULLSTOP('<TTRGRF>:: INTERNAL ERROR: W=0')
      DO I=1,3
      REC(I,1)=REC(I,1)/W
      REC(I,2)=REC(I,2)/W
      REC(I,3)=REC(I,3)/W
      ENDDO
C  DO OVER DIVISIONS OF THE MICROCELL
      DO 4200 ID3=0,NDIW(3)/NDIV(3)-1
      DO 4200 ID2=0,NDIW(2)/NDIV(2)-1
      DO 4200 ID1=0,NDIW(1)/NDIV(1)-1
C  THE SMALL MICROCELL IS SET UP BY IW1,IW2,IW3
      IW1=I1*NDIW(1)/NDIV(1)+ID1
      IW2=I2*NDIW(2)/NDIV(2)+ID2
      IW3=I3*NDIW(3)/NDIV(3)+ID3
C  SET UP SMALL TETRAHEDRON INSIDE SMALL MICROCELL
      DO 4100 ITTRD=1,6
      DO I=1,4
      JW1=IW1+KCUT(1,I,ITTRD)
      JW2=IW2+KCUT(2,I,ITTRD)
      JW3=IW3+KCUT(3,I,ITTRD)
      KTW(I)=IPWARR(JW1,JW2,JW3)
      ENDDO
C  SET UP POINTS K DESCRIBING SMALL TETRAHEDRON IN THE SPACE
      DO I=1,4
      JW1=IW1+KCUT(1,I,ITTRD)
      JW2=IW2+KCUT(2,I,ITTRD)
      JW3=IW3+KCUT(3,I,ITTRD)
      PKW(1,I)=(JW1*AKBAS(1,1,3)+
     &          JW2*AKBAS(1,2,3)+
     &          JW3*AKBAS(1,3,3))*2.D0*PI/PAR
      PKW(2,I)=(JW1*AKBAS(2,1,3)+
     &          JW2*AKBAS(2,2,3)+
     &          JW3*AKBAS(2,3,3))*2.D0*PI/PAR
      PKW(3,I)=(JW1*AKBAS(3,1,3)+
     &          JW2*AKBAS(3,2,3)+
     &          JW3*AKBAS(3,3,3))*2.D0*PI/PAR
      ENDDO
C  SHIFT COORDINATE SYSTEM TO THE FIRST POINT
      DO I=1,4
      PKW(1,I)=PKW(1,I)-PKT(1,1)
      PKW(2,I)=PKW(2,I)-PKT(2,1)
      PKW(3,I)=PKW(3,I)-PKT(3,1)
      ENDDO
C  CHECK WHETHER A SMALL TETRAHEDRON "PKW" IS INSIDE  TETRAHEDRON "PKT"
      DO I=1,4
      X1=PKW(1,I)*REC(1,1)+PKW(2,I)*REC(2,1)+PKW(3,I)*REC(3,1)
      X2=PKW(1,I)*REC(1,2)+PKW(2,I)*REC(2,2)+PKW(3,I)*REC(3,2)
      X3=PKW(1,I)*REC(1,3)+PKW(2,I)*REC(2,3)+PKW(3,I)*REC(3,3)
      IF(.NOT.((X1.GE.-EPS.AND.X1.LE.1.D0+EPS).AND.
     &         (X2.GE.-EPS.AND.X2.LE.1.D0+EPS).AND.
     &         (X3.GE.-EPS.AND.X3.LE.1.D0+EPS).AND.
     &         (X1+X2+X3.LE.1.D0+EPS)))GOTO 4100
      CRW(1,I)=X1
      CRW(2,I)=X2
      CRW(3,I)=X3
      ENDDO
C  CALCULATE CONTRIBUTION TO THE POINTS GIVEN BY "KTT=PKT"
      DO 1300 IMSC=KMSC,NMSC                    !!! over matsubara frequencies
      DO 1200 IBNDS=1,NSPIN                     !!! over spin subbands
      DO 1100 IBNDT=1,NBNDT(1)+NBNDH(1)         !!! over valence bands
      IBAND=IBNDS+NSPIN*(IBNDT-1)
C  TAKE INTEGRAL FOR FREQUENCY DEPENDENT BANDS
      DO I=1,4
      IPNT=KTW(I)
	ZE(I)=EPOW(IBAND,IPNT,IMSC)-DCMPLX(EF,0.D0)
      ENDDO
      ZOMG=WMSC(IMSC)+DCMPLX(0.D0,DUMP)
C  Tetrahedron weights
      IF(KEYTTR.EQ.0.OR.KEYTTR.EQ.1)THEN
      IF(DUMP.NE.0.D0. OR.KHRM.EQ.0)
     &CALL TTR_MCTTRINT5(ZE,OW,ZOMG,CINT,DINT,KEYDOS)
      IF(DUMP.EQ.0.D0.AND.KHRM.EQ.1)
     &CALL TTR_MCTTRINT6(ZE,OW,ZOMG,CINT,DINT,KEYDOS)
	AG(1)=CINT(1)-CINT(2)-CINT(3)-CINT(4)
	AG(2)=CINT(2)
	AG(3)=CINT(3)
	AG(4)=CINT(4)
	DG(1)=DINT(1)-DINT(2)-DINT(3)-DINT(4)
	DG(2)=DINT(2)
	DG(3)=DINT(3)
	DG(4)=DINT(4)
      DO IT=1,4
      IPNT=KTT(IT)
      DO I=1,4
      IF(IT.EQ.1)WF=1.D0-CRW(1,I)-CRW(2,I)-CRW(3,I)
      IF(IT.NE.1)WF=CRW(IT-1,I)
      GWGT(IBAND,IPNT,IMSC)=GWGT(IBAND,IPNT,IMSC)+AG(I)*WF*WTTR
      GWGD(IBAND,IPNT,IMSC)=GWGD(IBAND,IPNT,IMSC)+DG(I)*WF*WTTR
	TOT1=TOT1+2.D0*TEMP*AG(I)*WF*WTTR*ECAP(IBAND,IPNT)*FMSC(IMSC)
	DOT1=DOT1+2.D0*TEMP*DG(I)*WF*WTTR*ECAP(IBAND,IPNT)*FMSC(IMSC)
      ENDDO
      ENDDO
C  Geometrical weights
      ELSEIF(KEYTTR.EQ.2)THEN
      DO IT=1,4
      AG(IT)=+0.25D0*OW/(ZOMG-ZE(IT))
      DG(IT)=-0.25D0*OW/(ZOMG-ZE(IT))**2
      ENDDO
      DO IT=1,4
      IPNT=KTT(IT)
      DO I=1,4
      IF(IT.EQ.1)WF=1.D0-CRW(1,I)-CRW(2,I)-CRW(3,I)
      IF(IT.NE.1)WF=CRW(IT-1,I)
      GWGT(IBAND,IPNT,IMSC)=GWGT(IBAND,IPNT,IMSC)+AG(IT)*WF*WTTR
      GWGD(IBAND,IPNT,IMSC)=GWGD(IBAND,IPNT,IMSC)+DG(IT)*WF*WTTR
	TOT1=TOT1+2.D0*TEMP*AG(IT)*WF*WTTR*ECAP(IBAND,IPNT)*FMSC(IMSC)
	DOT1=DOT1+2.D0*TEMP*DG(IT)*WF*WTTR*ECAP(IBAND,IPNT)*FMSC(IMSC)
      ENDDO
      ENDDO
      ENDIF
C  TAKE INTEGRAL FOR LIMIT i*Omega->i*Infinity, Sum over omega's
      DO I=1,4
      IPNT=KTW(I)
	ZE(I)=ETRW(IBAND,IPNT,1)-DCMPLX(EF,0.D0)
      ENDDO
      ZOMG=WMSC(IMSC)+DCMPLX(0.D0,DUMP)
C  Tetrahedron weights
      IF(KEYTTR.EQ.0.OR.KEYTTR.EQ.1)THEN
      IF(DUMP.NE.0.D0. OR.KHRM.EQ.0)
     &CALL TTR_MCTTRINT5(ZE,OW,ZOMG,CINT,DINT,KEYDOS)
      IF(DUMP.EQ.0.D0.AND.KHRM.EQ.1)
     &CALL TTR_MCTTRINT6(ZE,OW,ZOMG,CINT,DINT,KEYDOS)
	AG(1)=CINT(1)-CINT(2)-CINT(3)-CINT(4)
	AG(2)=CINT(2)
	AG(3)=CINT(3)
	AG(4)=CINT(4)
	DG(1)=DINT(1)-DINT(2)-DINT(3)-DINT(4)
	DG(2)=DINT(2)
	DG(3)=DINT(3)
	DG(4)=DINT(4)
      DO IT=1,4
      IPNT=KTT(IT)
      DO I=1,4
      IF(IT.EQ.1)WF=1.D0-CRW(1,I)-CRW(2,I)-CRW(3,I)
      IF(IT.NE.1)WF=CRW(IT-1,I)
      GW0T(IBAND,IPNT)=GW0T(IBAND,IPNT)+AG(I)*WF*
     &FMSC(IMSC)*WTTR
      GW0D(IBAND,IPNT)=GW0D(IBAND,IPNT)+DG(I)*WF*
     &FMSC(IMSC)*WTTR
	TOT2=TOT2+2.D0*TEMP*AG(I)*WF*FMSC(IMSC)*
     *WTTR*ECAP(IBAND,IPNT)
	DOT2=DOT2+2.D0*TEMP*DG(I)*WF*FMSC(IMSC)*
     &WTTR*ECAP(IBAND,IPNT)
      ENDDO
      ENDDO
C  Geometrical weights
      ELSEIF(KEYTTR.EQ.2)THEN
      DO IT=1,4
      AG(IT)=+0.25D0*OW/(ZOMG-ZE(IT))
      DG(IT)=-0.25D0*OW/(ZOMG-ZE(IT))**2
      ENDDO
      DO IT=1,4
      IPNT=KTT(IT)
      DO I=1,4
      IF(IT.EQ.1)WF=1.D0-CRW(1,I)-CRW(2,I)-CRW(3,I)
      IF(IT.NE.1)WF=CRW(IT-1,I)
      GW0T(IBAND,IPNT)=GW0T(IBAND,IPNT)+AG(IT)*WF*
     &FMSC(IMSC)*WTTR
      GW0D(IBAND,IPNT)=GW0D(IBAND,IPNT)+DG(IT)*WF*
     &FMSC(IMSC)*WTTR
	TOT2=TOT2+2.D0*TEMP*AG(IT)*WF*FMSC(IMSC)*
     *WTTR*ECAP(IBAND,IPNT)
	DOT2=DOT2+2.D0*TEMP*DG(IT)*WF*FMSC(IMSC)*
     &WTTR*ECAP(IBAND,IPNT)
      ENDDO
      ENDDO
      ENDIF
 1100 CONTINUE                                  !!! over valence bands
 1200 CONTINUE                                  !!! over spin subbands
 1300 CONTINUE                                  !!! over Matsubara frequencies
C  TAKE INTEGRAL WITH FERMI DISTRIBUTION
      DO 2200 IBNDS=1,NSPIN                     !!! over spin subbands
      DO 2100 IBNDT=1,NBNDT(1)+NBNDH(1)         !!! over valence bands
      IBAND=IBNDS+NSPIN*(IBNDT-1)
      DO I=1,4
      IPNT=KTW(I)
      E(I)=ETRW(IBAND,IPNT,1)
	DO LD=0,4
	FL(LD,I)=FINT(LD,IBAND,IPNT)
	ENDDO
      ENDDO
C  USE TETRAHEDRON METHOD
	IF(KEYTTR.EQ.0.OR.KEYTTR.EQ.1)
     &CALL TTR_MCTTRINT0(E,EF,OW,AT,AD,TS,DS,'B','W')
C  ADD NON-ZERO TEMPERATURE CONTRIBUTION
	IF((KEYTTR.EQ.0.OR.KEYTTR.EQ.1).AND.TFERMI.NE.0.D0)THEN
      CALL TTR_MCTTRINTF(E,EF,TFERMI,FL,OW,FAT,FAD,FTS,FDS)
	TS=TS+FTS
	DS=DS+FDS
	DO I=1,4
	AT(I)=AT(I)+FAT(I)
	AD(I)=AD(I)+FAD(I)
	ENDDO
	ENDIF
C  USE GAUSSIAN BROADENING
	IF(KEYTTR.EQ.2)
     &CALL TTR_MCTTRINTG(E,EF,GBROAD,OW,AT,AD,TS,DS)
C  SET WEIGHTS
      DO IT=1,4
      IPNT=KTT(IT)
      DO I=1,4
      IF(IT.EQ.1)WF=1.D0-CRW(1,I)-CRW(2,I)-CRW(3,I)
      IF(IT.NE.1)WF=CRW(IT-1,I)
      WTRT(IBAND,IPNT)=WTRT(IBAND,IPNT)+AT(I)*WF*WTTR
      WDRT(IBAND,IPNT)=WDRT(IBAND,IPNT)+AD(I)*WF*WTTR
	TOT3=TOT3+AT(I)*WF*WTTR*ECAP(IBAND,IPNT)
	DOT3=DOT3+AD(I)*WF*WTTR*ECAP(IBAND,IPNT)
      ENDDO
      ENDDO
 2100 CONTINUE                                  !!! over valence bands
 2200 CONTINUE                                  !!! over spin subbands
	IF(KMSC.NE.NMSC+1)CYCLE
      DO 3200 IBNDS=1,NSPIN                     !!! over spin subbands
      DO 3100 IBNDT=1,NBNDT(1)+NBNDH(1)         !!! over valence bands
      IBAND=IBNDS+NSPIN*(IBNDT-1)
C  TAKE INTEGRAL FOR FREQUENCY DEPENDENT BANDS
      DO I=1,4
      IPNT=KTW(I)
	ZE(I)=EPOW(IBAND,IPNT,KMSC)-DCMPLX(EF,0.D0)
      ENDDO
      ZOMG=ZMSC+DCMPLX(0.D0,DUMP)
C  Tetrahedron weights
      IF(KEYTTR.EQ.0.OR.KEYTTR.EQ.1)THEN
      IF(DUMP.NE.0.D0. OR.KHRM.EQ.0)
     &CALL TTR_MCTTRINT5(ZE,OW,ZOMG,CINT,DINT,KEYDOS)
      IF(DUMP.EQ.0.D0.AND.KHRM.EQ.1)
     &CALL TTR_MCTTRINT6(ZE,OW,ZOMG,CINT,DINT,KEYDOS)
	AG(1)=CINT(1)-CINT(2)-CINT(3)-CINT(4)
	AG(2)=CINT(2)
	AG(3)=CINT(3)
	AG(4)=CINT(4)
      DO IT=1,4
      IPNT=KTT(IT)
      DO I=1,4
      IF(IT.EQ.1)WF=1.D0-CRW(1,I)-CRW(2,I)-CRW(3,I)
      IF(IT.NE.1)WF=CRW(IT-1,I)
      GWGT(IBAND,IPNT,KMSC)=GWGT(IBAND,IPNT,KMSC)+AG(I)*WF*WTTR
      ENDDO
      ENDDO
C  Geometrical weights
      ELSEIF(KEYTTR.EQ.2)THEN
      DO IT=1,4
      AG(IT)=+0.25D0*OW/(ZOMG-ZE(IT))
      ENDDO
      DO IT=1,4
      IPNT=KTT(IT)
      DO I=1,4
      IF(IT.EQ.1)WF=1.D0-CRW(1,I)-CRW(2,I)-CRW(3,I)
      IF(IT.NE.1)WF=CRW(IT-1,I)
      GWGT(IBAND,IPNT,KMSC)=GWGT(IBAND,IPNT,KMSC)+AG(IT)*WF*WTTR
      ENDDO
      ENDDO
      ENDIF
 3100 CONTINUE                                  !!! over valence bands
 3200 CONTINUE                                  !!! over spin subbands
 4100 CONTINUE                                  !!! over small tetrahedra
 4200 CONTINUE                                  !!! over small microcells
 5100 CONTINUE                                  !!! over tetrahedra
 5200 CONTINUE                                  !!! over microcells
C Average for degenerate bands
	IF(KEYTTR.EQ.0)THEN
      DO 7200 IPNT=1,NPNT(1)                    !!! over k-points
	DO 7100 IMSC=KMSC,NMSC                    !!! over frequencies
	IDEG=0
	JDEG=0
      DO 6200 IBNDS=1,NSPIN
      DO 6100 IBNDT=1,NBNDT(1)+NBNDH(1)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	ZI=EPOL(IBAND,IPNT,IMSC)
	IF(IDEG.LT.JDEG)IDEG=IDEG+1
	IF(IDEG.LT.JDEG)CYCLE
	IDEG=0
	JDEG=0
      DO JBNDS=1,NSPIN
	IF(NORBS.EQ.1.AND.IBNDS.NE.JBNDS)CYCLE
      DO JBNDT=IBNDT,NBNDT(1)+NBNDH(1)
	JBAND=JBNDS+NSPIN*(JBNDT-1)
	ZJ=EPOL(JBAND,IPNT,IMSC)
	IF(ABS(ZI-ZJ).LE.EPSDEG)JDEG=JDEG+1
	IF(ABS(ZI-ZJ).GT.EPSDEG)EXIT
	ENDDO
	ENDDO
	GH=(0.D0,0.D0)
	GD=(0.D0,0.D0)
      DO JBNDS=1,NSPIN
	IF(NORBS.EQ.1.AND.IBNDS.NE.JBNDS)CYCLE
      DO JBNDT=IBNDT,IBNDT+JDEG-1
	JBAND=JBNDS+NSPIN*(JBNDT-1)
	GH=GH+GWGT(JBAND,IPNT,IMSC)
	GD=GD+GWGD(JBAND,IPNT,IMSC)
	ENDDO
	ENDDO
	GH=GH/DBLE(JDEG)
	GD=GD/DBLE(JDEG)
      DO JBNDS=1,NSPIN
	IF(NORBS.EQ.1.AND.IBNDS.NE.JBNDS)CYCLE
      DO JBNDT=IBNDT,IBNDT+JDEG-1
	JBAND=JBNDS+NSPIN*(JBNDT-1)
	GWGT(JBAND,IPNT,IMSC)=GH
	GWGD(JBAND,IPNT,IMSC)=GD
	ENDDO
	ENDDO
 6100	ENDDO
 6200	ENDDO
 7100 CONTINUE                                  !!! over frequencies
 7200 CONTINUE                                  !!! over k-points
      DO 9000 IPNT=1,NPNT(1)                    !!! over k-points
	IDEG=0
	JDEG=0
      DO 8200 IBNDS=1,NSPIN
      DO 8100 IBNDT=1,NBNDT(1)+NBNDH(1)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	EI=ETRT(IBAND,IPNT,1)
	IF(IDEG.LT.JDEG)IDEG=IDEG+1
	IF(IDEG.LT.JDEG)CYCLE
	IDEG=0
	JDEG=0
      DO JBNDS=1,NSPIN
	IF(NORBS.EQ.1.AND.IBNDS.NE.JBNDS)CYCLE
      DO JBNDT=IBNDT,NBNDT(1)+NBNDH(1)
	JBAND=JBNDS+NSPIN*(JBNDT-1)
	EJ=ETRT(JBAND,IPNT,1)
	IF(ABS(EI-EJ).LE.EPSDEG)JDEG=JDEG+1
	IF(ABS(EI-EJ).GT.EPSDEG)EXIT
	ENDDO
	ENDDO
	WH=0.D0
	WD=0.D0
	GH=(0.D0,0.D0)
	GD=(0.D0,0.D0)
      DO JBNDS=1,NSPIN
	IF(NORBS.EQ.1.AND.IBNDS.NE.JBNDS)CYCLE
      DO JBNDT=IBNDT,IBNDT+JDEG-1
	JBAND=JBNDS+NSPIN*(JBNDT-1)
	WH=WH+WTRT(JBAND,IPNT)
	WD=WD+WDRT(JBAND,IPNT)
	GH=GH+GW0T(JBAND,IPNT)
	GD=GD+GW0D(JBAND,IPNT)
	ENDDO
	ENDDO
	WH=WH/DBLE(JDEG)
	WD=WD/DBLE(JDEG)
	GH=GH/DBLE(JDEG)
	GD=GD/DBLE(JDEG)
      DO JBNDS=1,NSPIN
	IF(NORBS.EQ.1.AND.IBNDS.NE.JBNDS)CYCLE
      DO JBNDT=IBNDT,IBNDT+JDEG-1
	JBAND=JBNDS+NSPIN*(JBNDT-1)
	WTRT(JBAND,IPNT)=WH
	WDRT(JBAND,IPNT)=WD
	GW0T(JBAND,IPNT)=GH
	GW0D(JBAND,IPNT)=GD
	ENDDO
	ENDDO
 8100	ENDDO
 8200	ENDDO
 9000 CONTINUE                              !!! over k-points
	ENDIF
C Normalization. Note that the imaginary part is PI times
C larger than density of states since ImG(E)=pi*N(E)
	TOT1=TOT1/VOLIBZ*2.D0/DBLE(NSPIN)
	DOT1=DOT1/VOLIBZ*2.D0/DBLE(NSPIN)
	TOT2=TOT2/VOLIBZ*2.D0/DBLE(NSPIN)
	DOT2=DOT2/VOLIBZ*2.D0/DBLE(NSPIN)
	TOT3=TOT3/VOLIBZ*2.D0/DBLE(NSPIN)
	DOT3=DOT3/VOLIBZ*2.D0/DBLE(NSPIN)
	TOT=TOT1-TOT2+TOT3
	DOT=DOT1-DOT2+DOT3
      DO IBNDS=1,NSPIN
      DO IBNDT=1,NBNDT(1)+NBNDH(1)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
      DO IPNT=1,NPNT(1)
C Frequency dependent weights
	DO IMSC=KMSC,NMSC+1
      GWGT(IBAND,IPNT,IMSC)=GWGT(IBAND,IPNT,IMSC)/
     &VOLIBZ*2.D0/DBLE(NSPIN)
      GWGD(IBAND,IPNT,IMSC)=GWGD(IBAND,IPNT,IMSC)/
     &VOLIBZ*2.D0/DBLE(NSPIN)
	ENDDO
C Summed over frequencies weights
      GW0T(IBAND,IPNT)=GW0T(IBAND,IPNT)/
     &VOLIBZ*2.D0/DBLE(NSPIN)
      GW0D(IBAND,IPNT)=GW0D(IBAND,IPNT)/
     &VOLIBZ*2.D0/DBLE(NSPIN)
C Fermi distribution weights
      WTRT(IBAND,IPNT)=WTRT(IBAND,IPNT)/
     &VOLIBZ*2.D0/DBLE(NSPIN)
      WDRT(IBAND,IPNT)=WDRT(IBAND,IPNT)/
     &VOLIBZ*2.D0/DBLE(NSPIN)
	ENDDO
	ENDDO
	ENDDO
C ESTIMATE NUMBER AND DENSITY OF STATES FOR GIVEN EF
C IMAGINARY AXIS DMFT
      IF(IDMF.EQ.3)THEN
	TOC1=0.D0
	DOC1=0.D0
	TOC2=0.D0
	DOC2=0.D0
	TOC3=0.D0
	DOC3=0.D0
      DO IBNDS=1,NSPIN
      DO IBNDT=1,NBNDT(1)+NBNDH(1)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
      DO IPNT=1,NPNT(1)
	DO IMSC=KMSC,NMSC
	TOC1=TOC1+2.D0*TEMP*DREAL(GWGT(IBAND,IPNT,IMSC))*ECAP(IBAND,IPNT)*
     &FMSC(IMSC)
	DOC1=DOC1+2.D0*TEMP*DREAL(GWGD(IBAND,IPNT,IMSC))*ECAP(IBAND,IPNT)*
     &FMSC(IMSC)
	ENDDO
	TOC2=TOC2+2.D0*TEMP*DREAL(GW0T(IBAND,IPNT))*ECAP(IBAND,IPNT)
	DOC2=DOC2+2.D0*TEMP*DREAL(GW0D(IBAND,IPNT))*ECAP(IBAND,IPNT)
      TOC3=TOC3+WTRT(IBAND,IPNT)*ECAP(IBAND,IPNT)
      DOC3=DOC3+WDRT(IBAND,IPNT)*ECAP(IBAND,IPNT)
	ENDDO
	ENDDO
	ENDDO
	TOC=TOC1-TOC2+TOC3
	DOC=DOC1-DOC2+DOC3
C Do the same without band capacities
	TOB1=0.D0
	DOB1=0.D0
	TOB2=0.D0
	DOB2=0.D0
	TOB3=0.D0
	DOB3=0.D0
      DO IBNDS=1,NSPIN
      DO IBNDT=1,NBNDT(1)+NBNDH(1)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
      DO IPNT=1,NPNT(1)
	DO IMSC=KMSC,NMSC
	TOB1=TOB1+2.D0*TEMP*DREAL(GWGT(IBAND,IPNT,IMSC))*
     &FMSC(IMSC)
	DOB1=DOB1+2.D0*TEMP*DREAL(GWGD(IBAND,IPNT,IMSC))*
     &FMSC(IMSC)
	ENDDO
	TOB2=TOB2+2.D0*TEMP*DREAL(GW0T(IBAND,IPNT))
	DOB2=DOB2+2.D0*TEMP*DREAL(GW0D(IBAND,IPNT))
      TOB3=TOB3+WTRT(IBAND,IPNT)
      DOB3=DOB3+WDRT(IBAND,IPNT)
	ENDDO
	ENDDO
	ENDDO
	TOB=TOB1-TOB2+TOB3
	DOB=DOB1-DOB2+DOB3
C RATIONAL INTERPOLATION DMFT
      ELSEIF(IDMF.EQ.4)THEN
	TOC=0.D0
	DOC=0.D0
      DO IPNT=1,NPNT(1)
      DO IBNDS=1,NSPIN
      DO IBNDT=1,NBNDT(1)+NBNDH(1)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
      TOC=TOC+WTRT(IBAND,IPNT)*DREAL(ECAP(IBAND,IPNT))
      DOC=DOC+WDRT(IBAND,IPNT)*DREAL(ECAP(IBAND,IPNT))
	ENDDO
	ENDDO
	ENDDO
C Do the same without band capacities
	TOB=0.D0
	DOB=0.D0
      DO IBNDS=1,NSPIN
      DO IBNDT=1,NBNDT(1)+NBNDH(1)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
      DO IPNT=1,NPNT(1)
      TOB=TOB+WTRT(IBAND,IPNT)
      DOB=DOB+WDRT(IBAND,IPNT)
	ENDDO
	ENDDO
	ENDDO
C REAL AXIS DMFT
	ELSEIF(IDMF.EQ.5)THEN
	TOC=0.D0
	DOC=0.D0
      DO IPNT=1,NPNT(1)
      DO IBNDS=1,NSPIN
      DO IBNDT=1,NBNDT(1)+NBNDH(1)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	DO IMSC=KMSC,NMSC
	TOC=TOC-DIMAG(GWGT(IBAND,IPNT,IMSC))/PI*ECAP(IBAND,IPNT)*
     &FMSC(IMSC)*FERMIFUN(DREAL(WMSC(IMSC)),TEMP)
	DOC=DOC-DIMAG(GWGD(IBAND,IPNT,IMSC))/PI*ECAP(IBAND,IPNT)*
     &FMSC(IMSC)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C Do the same without band capacities
	TOB=0.D0
	DOB=0.D0
      DO IBNDS=1,NSPIN
      DO IBNDT=1,NBNDT(1)+NBNDH(1)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
      DO IPNT=1,NPNT(1)
	DO IMSC=KMSC,NMSC
	TOB=TOB-DIMAG(GWGT(IBAND,IPNT,IMSC))/PI*
     &FMSC(IMSC)*FERMIFUN(DREAL(WMSC(IMSC)),TEMP)
	DOB=DOB-DIMAG(GWGD(IBAND,IPNT,IMSC))/PI*
     &FMSC(IMSC)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDIF
C
	IF(KEYCAP.EQ.0)THEN
	TOS=TOC
	DOS=DOC
	ELSEIF(KEYCAP.EQ.1)THEN
	TOS=TOB
	DOS=DOB
	ENDIF
C
	IF(KEYPRN.EQ.0.AND.KEYCAP.EQ.0)WRITE(IUN,10010)EF,TOC,DOC
	IF(KEYPRN.EQ.0.AND.KEYCAP.EQ.1)WRITE(IUN,10020)EF,TOC,DOC,TOB,DOB
10010 FORMAT(' EF,TOS,DOS=',3(1X,G14.7))
10020 FORMAT(' EF,TOS,DOS=',3(1X,G14.7), ' Band TOS,DOS=',2(1X,G12.5))
C MEMORY DEALLOCATIONS
	DEALLOCATE(FINT)
	END
