	SUBROUTINE DPT_SDELPOT(IQPNT,ITER)
************************************************************
*   The calculation of the change in the potential         *
*   Written by S.Yu.Savrasov                               *
************************************************************
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
      USE COM_PHNCOM,  ONLY : ITERMAX,NITER                              !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
      USE COM_PLZCOM,  ONLY : NPLZ,LPLZ,IPLZ                             !!! from readlrt
	USE COM_QMESH,   ONLY : NQPNT,QPNT                                 !!! from readpnt
	USE COM_PHNCHN  ,ONLY : IUDPX,IUDPY,IUDSV,IUDPV                    !!! from channels
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	LOGICAL EXIST
	CHARACTER POL(-1:1)*3
	DATA POL/'"M"','"0"','"P"'/
C  DO GLOBALLY OVER DISPLACEMENTS AND POLARIZATIONS
	DO 40 INUC=1,NATOM               !!! over displacements
	DO 30 MY=-1,1                    !!! over polarizations
      IF(NITER(MY,INUC).EQ.0)GOTO30
C  READ CHANGE IN CHARGE DENSITY
      CALL DRO_DROFILES(MY,INUC,IQPNT,IUDPX,'R','D',' ')
      CALL DRO_DPSFILES(MY,INUC,IQPNT,IUDPY,'R','D',' ')
C  CALCULATE CHANGE IN THE FULL POTENTIAL
   	CALL DPT_DMULTRHO(MY,INUC,IQPNT)     !!! change in pseudodensity moments
   	CALL DPT_DMULTFTR(MY,INUC,IQPNT,1)   !!! change in multipoles
   	CALL DPT_DELVCOUL(MY,INUC,IQPNT)     !!! change in Coulomb potential in MTS
   	CALL DPT_DELVEXCH(MY,INUC,IQPNT,1)   !!! change in XC-potential in MTS
   	CALL DPT_DELVCFTR(MY,INUC,IQPNT,1)   !!! change in Coulomb potential in INT
   	CALL DPT_DELVXFTR(MY,INUC,IQPNT,1)   !!! change in XC-potential in INT
    	CALL DPT_DELVSCRN(MY,INUC,IQPNT)     !!! add screened long range if MODE=4,5
   	CALL DPT_DELVZERO(MY,INUC,IQPNT)     !!! change in MT-zero 
   	CALL DPT_DELVPINT(MY,INUC,IQPNT)     !!! set convolutions 
	CALL DPT_DELVHUBS(MY,INUC,IQPNT)     !!! change in the hubbard potential
C  STORE CHANGE IN THE POTENTIAL 
   	CALL DPT_PRINT3  (MY,INUC,IQPNT,ITER)!!! print values
   	CALL DPT_DSVFILES(MY,INUC,IQPNT,IUDSV,'W','D',' ')
   	CALL DPT_DPVFILES(MY,INUC,IQPNT,IUDPV,'W','D',' ')
  30	CONTINUE                         !!! over polarizations
  40	CONTINUE                         !!! over displacements
	END
