	SUBROUTINE DPT_DELVHUBS(MY,INUC,IQPNT)
***************************************************************************
*  Computes change in the Hubbard correction to the LDA potential within  *
*  the LDA+U scheme.                                                      *
***************************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT                                       !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
     &                       ,NHSORT
	USE COM_KAPPAR,  ONLY : NPAN,NKAP                                  !!! from readini
	USE COM_PANPAR,  ONLY : LTPAN,LSPAN,IATS,ISTS                      !!! from readini
      USE COM_HUBDAT,  ONLY : NHUB,MCRL,LCRL,KSOLVER                     !!! from readhub
	USE COM_DELHUB,  ONLY : DELDHUB,DELVHUB                            !!! from delhub
	USE COM_SPHERE,  ONLY : SWZ,SMT                                    !!! from readini
      USE COM_LMTINP,  ONLY : ICHUB                                      !!! from init
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER, ALLOCATABLE :: LMSYM(:,:)
	REAL*8, ALLOCATABLE :: UMAT(:,:)
	REAL*8, ALLOCATABLE :: GMAT(:,:)
	REAL*8, ALLOCATABLE :: UBAR(:,:)
	REAL*8, ALLOCATABLE :: GBAR(:,:)
	COMPLEX*16, ALLOCATABLE :: DBAR(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: DAVR(:,:)
	DATA PI/3.141592653589793D0/
	IF(ICHUB.EQ.0)RETURN
C Memory allocations
	ALLOCATE(LMSYM(LIMVMEM,NATOMMEM))
      ALLOCATE(UMAT(LIMB2MEM,LIMB2MEM))
	ALLOCATE(GMAT(LIMB2MEM,LIMB2MEM))
      ALLOCATE(UBAR(0:LMAXBMEM,0:LMAXBMEM))
	ALLOCATE(GBAR(0:LMAXBMEM,0:LMAXBMEM))
      ALLOCATE(DBAR(0:LMAXBMEM,NATOMMEM,NSPINMEM,NORBSMEM))
	ALLOCATE(DAVR(LIMB2MEM,NATOMMEM))
C  DO GLOBALLY OVER ATOMS
	DO 1000 IATOM=1,NATOM                     !!! over atoms
	ISORT=IS(IATOM)
	CALL LIB_HUBMAT_L2(IATOM,UMAT,GMAT,UBAR,GBAR)!!! set Hubbard and Exchange matrices
C  SET AVERAGE OCCUPANCIES <Nup> and <Ndn>
      DO IORBS=1,NORBS                          !!! iorbs
	DO IUPDN=1,NSPIN                          !!! over spins
	DO L=0,ILSB(ISORT)                        !!! over l
	DBAR(L,IATOM,IUPDN,IORBS)=(0.D0,0.D0)
	DO M=-L,L                                 !!! over m
	LM=L*(L+1)+M+1
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M+1           !  (l,m m) packed
	DBAR(L,IATOM,IUPDN,IORBS)=DBAR(L,IATOM,IUPDN,IORBS)+
     &DELDHUB(IU,IATOM,IUPDN,IORBS)
	ENDDO                                     !!! over m
	ENDDO                                     !!! over l
	ENDDO                                     !!! over spins
	ENDDO                                     !!! over iorbs
C  SET AVERAGE OVER SPINS ONLY
	DO L=0,ILSB(ISORT)                        !!! over l
	DO M=-L,L                                 !!! over m
	DO K=-L,L                                 !!! over k
	LM=L*(L+1)+M+1
	LK=L*(L+1)+K+1
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+K)+L+M+1           !  (l,m k) packed
      DAVR(IU,IATOM)=(DELDHUB(IU,IATOM,1,1)+
     &DELDHUB(IU,IATOM,NSPIN,1))/2.D0
	ENDDO                                     !!! over m
	ENDDO                                     !!! over k
	ENDDO                                     !!! over l
C  SET HUBBARD CORRECTION TO THE POTENTIAL
	DO IUPDN=1,NSPIN                          !!! over spins
	IF(IUPDN.EQ.1)IUPDN1=NSPIN
	IF(IUPDN.EQ.NSPIN)IUPDN1=1
	DO L=0,ILSB(ISORT)                        !!! over l
	DO M=-L,L                                 !!! over m
	DO K=-L,L                                 !!! over k
	LM=L*(L+1)+M+1
	LK=L*(L+1)+K+1
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+K)+L+M+1           !  (l,m k) packed
	DELVHUB(IU,IATOM,IUPDN,    1)=(0.D0,0.D0)
	DELVHUB(IU,IATOM,IUPDN,NORBS)=(0.D0,0.D0)
	DO M1=-L,L                                !!! over m1
	DO K1=-L,L                                !!! over k1
	LM1=L*(L+1)+M1+1
	LK1=L*(L+1)+K1+1
	IU1=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+K1)+L+M1+1  !  (l1,m1 k1) packed
	IF(KSOLVER(L,IATOM).EQ.11)THEN
C  Original LDA+U after Liechtenstein et.al (Rotationally Invariant)
C  dVup=U*Ndn+(U-J)Nup-d*[<U>(<N>-1/2)+<J>(<Nup>-1/2)]
C  dVdn=U*Nup+(U-J)Ndn-d*[<U>(<N>-1/2)+<J>(<Ndn>-1/2)]
      DELVHUB(IU,IATOM,IUPDN,1)=
     &DELVHUB(IU,IATOM,IUPDN,1)+UMAT(IU,IU1)*
     &DELDHUB(IU1,IATOM,IUPDN1,1)+(UMAT(IU,IU1)-GMAT(IU,IU1))*
     &DELDHUB(IU1,IATOM,IUPDN,1)
	ENDIF
	IF(KSOLVER(L,IATOM).EQ.11.AND.NORBS.EQ.2)
     &DELVHUB(IU,IATOM,IUPDN,NORBS)=DELVHUB(IU,IATOM,IUPDN,NORBS)-
     &GMAT(IU,IU1)*DELDHUB(IU1,IATOM,IUPDN1,NORBS)
	ENDDO                                     !!! over k1
	ENDDO                                     !!! over m1
C  ADD DIAGONAL TERMS
      IF(K.EQ.M.AND.(KSOLVER(L,IATOM).EQ.11))
     &DELVHUB(IU,IATOM,IUPDN,1)=DELVHUB(IU,IATOM,IUPDN,1)-
     &UBAR(L,L)*(DBAR(L,IATOM,1,1)+DBAR(L,IATOM,NSPIN,1))/
     &2.D0*DBLE(NSPIN)+GBAR(L,L)*DBAR(L,IATOM,IUPDN,1)
	ENDDO                                     !!! over k
	ENDDO                                     !!! over m
	ENDDO                                     !!! over l
	ENDDO                                     !!! over spins
1000	CONTINUE                                  !!! over atoms
C Memory allocations
	DEALLOCATE(LMSYM,UMAT,GMAT,UBAR,GBAR,DBAR,DAVR)
	END
