	SUBROUTINE DPT_DMULTFTR(MY,INUC,IQPNT,ISCR)
*************************************************************
* Calculate induced multipoles as reciprocal lattice sums.  * 
* Written by S.Yu.Savrasov (Lebedev Physical Institute)     *
*************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_LATPAR,  ONLY : PAR,ORTH,OMEGAC                            !!! from readini
	USE COM_LATTICE, ONLY : TAU                                        !!! from readstr
	USE COM_SYMMLM,  ONLY : SYM,LMSYM                                  !!! from makesym
	USE COM_QMESH,   ONLY : NQPNT,QPNT                                 !!! from readpnt
	USE COM_PLWMESH, ONLY : NPLW,GPLW                                  !!! from makeplw
	USE COM_DENDAT,  ONLY : RHOPS,RHOPS1                               !!! from readscf
	USE COM_DELRHO,  ONLY : DRHOPS,DRHOPS1                             !!! from delrho
	USE COM_SPHERE,  ONLY : SWZ,SMT,ZNUC,ZCOR                          !!! from readini
      USE COM_PLZCOM,  ONLY : NPLZ,LPLZ,IPLZ,NPTB,QPTB,INDPTB            !!! from readlrt
	USE COM_MULTRO,  ONLY : PSMOM1                                     !!! from multrho
      USE COM_DROMULT, ONLY : DPSMOM1,DELMAD                             !!! from dmultrho
	USE COM_ACCURG,  ONLY : BET                                        !!! from multrho
	USE COM_MASHDEP, ONLY : NVAL                                       !!! from setup
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: GAUS(:,:)
	COMPLEX*16, ALLOCATABLE :: YLM(:)
	REAL*8, ALLOCATABLE :: BES(:)
	REAL*8, ALLOCATABLE :: BESD(:)
	REAL*8, ALLOCATABLE :: COFL(:,:)
	COMPLEX*16 EXPT,GMY,COUINT
	LOGICAL FIRST
	DATA PI/3.141592653589793D0/,FIRST/.TRUE./
C Memory allocations
      IF(FIRST)THEN
      FIRST=.FALSE.
	ALLOCATE(DELMAD(5,LIMVMEM,NATOMMEM,NSPINMEM,-1:1,NATOMMEM))
      ENDIF
	ALLOCATE(GAUS(0:LMAXVMEM,NATOMMEM))
	ALLOCATE(YLM(LIMVMEM))
	ALLOCATE(BES(-1:LMAXVMEM))
	ALLOCATE(BESD(0:LMAXVMEM))
	ALLOCATE(COFL(0:LMAXVMEM,NSORTMEM))
	LMM=0
	ZAUX=0.D0
	ZPSD=0.D0
	DO ISPIN=1,NSPIN
	ZPSD=ZPSD+OMEGAC*RHOPS(0,ISPIN,1)
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	LMM=MAX(LMM,ILSV(ISORT))
	ZAUX=ZAUX-DREAL(PSMOM1(1,IATOM,ISPIN))*SQRT(4.D0*PI)*SMT(ISORT)
	DO L=0,ILSV(ISORT)
	COFL(L,ISORT)=4.D0*PI/OMEGAC*SMT(ISORT)**(L+1)/FAC2(2*L-1)
	DO M=-L,L
	LM=L*(L+1)+M+1
	DELMAD(1,LM,IATOM,ISPIN,MY,INUC)=(0.D0,0.D0)
	DELMAD(2,LM,IATOM,ISPIN,MY,INUC)=(0.D0,0.D0)
	DELMAD(3,LM,IATOM,ISPIN,MY,INUC)=(0.D0,0.D0)
	DELMAD(4,LM,IATOM,ISPIN,MY,INUC)=(0.D0,0.D0)
	DELMAD(5,LM,IATOM,ISPIN,MY,INUC)=(0.D0,0.D0)
      ENDDO
      ENDDO
      ENDDO
      ENDDO
	REN1=1.D0                            !!! ZPSD/ZAUX
C  CALCULATE AUXILARY CHARGE DENSITY IN FOURIER REPRESENTATION
C  ALSO CALCULATE CHANGE IN MULTIPOLE CHARGE 
	DO IPLW=0,NPLW                   !!! over plane waves
	GX=(QPNT(1,IQPNT)+GPLW(1,IPLW))*2.D0*PI/PAR
	GY=(QPNT(2,IQPNT)+GPLW(2,IPLW))*2.D0*PI/PAR
	GZ=(QPNT(3,IQPNT)+GPLW(3,IPLW))*2.D0*PI/PAR
	AG=SQRT(GX**2+GY**2+GZ**2)
	AG2=AG*AG
      IF(MY.EQ.-1)GMY=+1.D0/SQRT(2.D0)*(GX-(0.D0,1.D0)*GY)
      IF(MY.EQ.+1)GMY=-1.D0/SQRT(2.D0)*(GX+(0.D0,1.D0)*GY)
      IF(MY.EQ. 0)GMY=GZ
C  SET SPHERICAL HARMONICS
	IF(AG.GE.1.D-10)THEN
	CALL LIB_SPHHARM(GX/AG,GY/AG,GZ/AG,LMM,YLM)
	ELSE
	YLM(1)=1.D0/SQRT(4.D0*PI)
	DO LM=2,(LMM+1)**2
	YLM(LM)=(0.D0,0.D0)
      ENDDO
	ENDIF
C  SET AUXILARY PSEUDODENSITY DRHOPS1
	DO ISPIN=1,NSPIN                  !!! over spins
	DRHOPS1(IPLW,ISPIN,1)=(0.D0,0.D0)
	DRHOPS1(IPLW,ISPIN,2)=(0.D0,0.D0)
	DO IATOM=1,NATOM                  !!! over atoms
	ISORT=IS(IATOM)
C  CALCULATE EXPONENTIAL FACTOR
	SCP=(QPNT(1,IQPNT)+GPLW(1,IPLW))*TAU(1,IATOM)+
     &    (QPNT(2,IQPNT)+GPLW(2,IPLW))*TAU(2,IATOM)+
     &    (QPNT(3,IQPNT)+GPLW(3,IPLW))*TAU(3,IATOM)
	EXPT=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	DO L=0,ILSV(ISORT)
	IF(L.EQ.0)AGL=1.D0
	IF(L.NE.0)AGL=AG**L
	EXPG=EXP(-0.25D0*AG**2/BET(L,ISORT)**2)
	GAUS(L,IATOM)=COFL(L,ISORT)*EXPT*AGL*EXPG
	DO M=-L,L
	LM=L*(L+1)+M+1
	ISYM=LMSYM(LM,IATOM)
	DRHOPS1(IPLW,ISPIN,1)=DRHOPS1(IPLW,ISPIN,1)+
     &  GAUS(L,IATOM)*YLM(LM)*DPSMOM1(1,LM,IATOM,ISPIN,
     &  MY,INUC)*REN1
	DRHOPS1(IPLW,ISPIN,2)=DRHOPS1(IPLW,ISPIN,2)+
     &  GAUS(L,IATOM)*YLM(LM)*DPSMOM1(2,LM,IATOM,ISPIN,
     &  MY,INUC)*REN1
	IF(SYM(LM,IATOM).AND.IATOM.EQ.INUC)
     &	DRHOPS1(IPLW,ISPIN,2)=DRHOPS1(IPLW,ISPIN,2)+
     &  GAUS(L,IATOM)*YLM(LM)*PSMOM1(ISYM,IATOM,ISPIN)*REN1*
     *  (0.D0,-1.D0)*GMY
      ENDDO
      ENDDO
      ENDDO
      ENDDO
	IF(AG.GE.1.D-10)COUINT=4.D0*PI/AG**2
	IF(AG.LT.1.D-10)COUINT=(0.D0,0.D0)
C  SET SCREENING
	DO IPTB=1,NPTB
	IF(ISCR.EQ.1.AND.LPLZ.GT.0.AND.IPLW.EQ.INDPTB(IPTB))
     &COUINT=(0.D0,0.D0)
      ENDDO
C  SET MULTIPOLE CHARGE DUE TO CHANGE IN PSRHO AND PSRHO1
	DO IATOM=1,NATOM                 !!! over atoms
	ISORT=IS(IATOM)
	CALL LIB_BESSR(AG*SMT(ISORT),BES(0),BESD(0),ILSV(ISORT))
      DO L=0,ILSV(ISORT)
      BES(L)=BES(L)*AG*SMT(ISORT)
      ENDDO
      BES(-1)=COS(AG*SMT(ISORT))
	SCP=(QPNT(1,IQPNT)+GPLW(1,IPLW))*TAU(1,IATOM)+
     &    (QPNT(2,IQPNT)+GPLW(2,IPLW))*TAU(2,IATOM)+
     &    (QPNT(3,IQPNT)+GPLW(3,IPLW))*TAU(3,IATOM)
	EXPT=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	DO ISPIN=1,NSPIN                 !!! over spins
	DO L=0,ILSV(ISORT)
	DO M=-L,L
	LM=L*(L+1)+M+1
	DELMAD(1,LM,IATOM,ISPIN,MY,INUC)=
     &DELMAD(1,LM,IATOM,ISPIN,MY,INUC)+
     &  COUINT*DRHOPS(IPLW,ISPIN,1)/DBLE(2*L+1)*
     &  4.D0*PI*DCONJG(EXPT*YLM(LM))*BES(L-1)
	DELMAD(2,LM,IATOM,ISPIN,MY,INUC)=
     &DELMAD(2,LM,IATOM,ISPIN,MY,INUC)+
     &  COUINT*DRHOPS1(IPLW,ISPIN,1)/DBLE(2*L+1)*
     &  4.D0*PI*DCONJG(EXPT*YLM(LM))*BES(L-1)
	DELMAD(3,LM,IATOM,ISPIN,MY,INUC)=
     &DELMAD(3,LM,IATOM,ISPIN,MY,INUC)+
     &  COUINT*DRHOPS1(IPLW,ISPIN,2)/DBLE(2*L+1)*
     &  4.D0*PI*DCONJG(EXPT*YLM(LM))*BES(L-1)
      ENDDO
      ENDDO
      ENDDO                             !!! over spins
      ENDDO                             !!! over atoms
      ENDDO                             !!! over plane waves
C  SET "RIGID" CHANGE IN MULTIPOLE CHARGE 
	DO 340 IPLW=0,NPLW                   !!! over plane waves
	GX=GPLW(1,IPLW)*2.D0*PI/PAR
	GY=GPLW(2,IPLW)*2.D0*PI/PAR
	GZ=GPLW(3,IPLW)*2.D0*PI/PAR
	AG=SQRT(GX**2+GY**2+GZ**2)
	AG2=AG*AG
      IF(MY.EQ.-1)GMY=+1.D0/SQRT(2.D0)*(GX-(0.D0,1.D0)*GY)
      IF(MY.EQ.+1)GMY=-1.D0/SQRT(2.D0)*(GX+(0.D0,1.D0)*GY)
      IF(MY.EQ. 0)GMY=GZ
C  SET SPHERICAL HARMONICS
	IF(AG.GE.1.D-10)THEN
	CALL LIB_SPHHARM(GX/AG,GY/AG,GZ/AG,LMM,YLM)
	ELSE
	YLM(1)=1.D0/SQRT(4.D0*PI)
	DO LM=2,(LMM+1)**2
	YLM(LM)=(0.D0,0.D0)
      ENDDO
	ENDIF
C  SET MULTIPOLE CHARGE
	IF(AG.GE.1.D-10)THEN                 !!! not for G=0 !
	DO IATOM=1,NATOM                 !!! over atoms
	IF(INUC.NE.IATOM)CYCLE
	ISORT=IS(IATOM)
	CALL LIB_BESSR(AG*SMT(ISORT),BES(0),BESD(0),ILSV(ISORT))
	BES(-1)=COS(AG*SMT(ISORT))/(AG*SMT(ISORT))
	SCP=GPLW(1,IPLW)*TAU(1,IATOM)+
     &    GPLW(2,IPLW)*TAU(2,IATOM)+
     &    GPLW(3,IPLW)*TAU(3,IATOM)
	EXPT=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	DO ISPIN=1,NSPIN                 !!! over spins
	DO L=0,ILSV(ISORT)
	DO M=-L,L
	LM=L*(L+1)+M+1
	DELMAD(4,LM,IATOM,ISPIN,MY,INUC)=
     &DELMAD(4,LM,IATOM,ISPIN,MY,INUC)+
     &  4.D0*PI*SMT(ISORT)/DBLE(2*L+1)*RHOPS(IPLW,ISPIN,1)*
     &  4.D0*PI*DCONJG(EXPT*YLM(LM))/AG*BES(L-1)*
     &  (0.D0,1.D0)*GMY
	DELMAD(5,LM,IATOM,ISPIN,MY,INUC)=
     &DELMAD(5,LM,IATOM,ISPIN,MY,INUC)+
     &  4.D0*PI*SMT(ISORT)/DBLE(2*L+1)*RHOPS1(IPLW,ISPIN,1)*
     &  4.D0*PI*DCONJG(EXPT*YLM(LM))/AG*BES(L-1)
     &  *(0.D0,1.D0)*GMY
      ENDDO
      ENDDO
      ENDDO                             !!! over spins
      ENDDO                             !!! over atoms
	ENDIF
 340  CONTINUE                             !!! over plane waves
C Memory deallocations
	DEALLOCATE(GAUS,YLM,BES,BESD,COFL)
	END
