	   SUBROUTINE DPT_DMULTRHO(MY,INUC,IQPNT)
**************************************************************
*  Calculates induced multipoles.                            *
**************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
     &                       ,NHSORT
	USE COM_RADMESH, ONLY : NRAD,H,R,DR,WEIGHT,RL                      !!! from radmsh
	USE COM_LATPAR,  ONLY : PAR,ORTH,OMEGAC                            !!! from readini
	USE COM_SPHERE,  ONLY : SWZ,SMT,ZNUC,ZCOR                          !!! from readini
	USE COM_DENDAT,  ONLY : RHOPS,RHOPS1                               !!! from readscf
	USE COM_MULTRO,  ONLY : AMTOT,PSMOM,PSMOM1,QMAD                    !!! from multrho
      USE COM_DROMULT, ONLY : DELMRO,DPSMOM,DPSMOM1                      !!! from dmultrho
	USE COM_QMESH,   ONLY : NQPNT,QPNT                                 !!! from readpnt
      USE COM_DELRHO,  ONLY : DRHO                                       !!! from delrho
	USE COM_PLWMESH, ONLY : NPLW,GPLW                                  !!! from makeplw
	USE COM_DELRHO,  ONLY : DRHOPS,DRHOPS1                             !!! from delrho
	USE COM_ACCURG,  ONLY : BET                                        !!! from multrho
	USE COM_LATTICE, ONLY : TAU                                        !!! from readstr
	USE COM_SYMMLM,  ONLY : SYM,LMSYM                                  !!! from makesym
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8, ALLOCATABLE :: BES(:)
	REAL*8, ALLOCATABLE :: BESD(:)
	REAL*8, ALLOCATABLE :: BT(:)
	COMPLEX*16, ALLOCATABLE :: WORK1(:)
	COMPLEX*16, ALLOCATABLE :: WORK2(:)
	COMPLEX*16, ALLOCATABLE :: YLM(:)
	COMPLEX*16, ALLOCATABLE :: RHAN(:)
	COMPLEX*16 EXPT,GMY
	LOGICAL FIRST
	DATA PI/3.141592653589793D0/,FIRST/.TRUE./
	SQPI4=2.D0*SQRT(PI)
C Memory allocations for main control arrays
	IF(FIRST)THEN
	FIRST=.FALSE.
      ALLOCATE(DPSMOM1(2,LIMVMEM,NATOMMEM,NSPINMEM,
     &                                   -1:1,NATOMMEM))
	ALLOCATE(DPSMOM(2,LIMVMEM,NATOMMEM,NSPINMEM,
     &                          NORBSMEM,-1:1,NATOMMEM))
	ALLOCATE(DELMRO(LIMVMEM,NATOMMEM,NSPINMEM,
     &                          NORBSMEM,-1:1,NATOMMEM))
	ENDIF
C Memory allocations
	ALLOCATE(BES(0:LMAXVMEM+1))
	ALLOCATE(BESD(0:LMAXVMEM+1))
	ALLOCATE(BT(0:LMAXVMEM+1))
	ALLOCATE(WORK1(0:NRADMEM))
	ALLOCATE(WORK2(0:NRADMEM))
	ALLOCATE(YLM(LIMVMEM))
	ALLOCATE(RHAN(0:LMAXVMEM+1))
C   CALCULATE MOMENTS OF THE INDUCED DENSITY WITHIN SPHERE
      DO IORBS=1,NORBS
	DO IUPDN=1,NSPIN
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	DO L=0,ILSV(ISORT)
	DO M=-L,L
	LM=L*(L+1)+M+1
	SL=SMT(ISORT)**L
	DO IRAD=0,NRAD(ISORT)
	WORK1(IRAD)=DRHO(IRAD,LM,IATOM,IUPDN,IORBS)*
     &RL(IRAD,L,ISORT)/SL*WEIGHT(IRAD,ISORT)/SQRT(4.D0*PI)
      ENDDO
	CALL LIB_CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	DELMRO(LM,IATOM,IUPDN,IORBS,MY,INUC)=WORK2(NRAD(ISORT))
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      ENDDO
C *** CALCULATE MOMENTS OF THE PSEUDOCHARGE DENSITY ***
	LMM=0
	DO IORBS=1,NORBS
	DO IUPDN=1,NSPIN
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	LMM=MAX(LMM,ILSV(ISORT))
	DO L=0,ILSV(ISORT)
	DO M=-L,L
	LM=L*(L+1)+M+1
	DPSMOM(1,LM,IATOM,IUPDN,IORBS,MY,INUC)=(0.D0,0.D0)
	DPSMOM(2,LM,IATOM,IUPDN,IORBS,MY,INUC)=(0.D0,0.D0)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C  SET MULTIPOLE MOMENTS DUE TO CHANGE IN PSRHO
	DO IPLW=0,NPLW                   !!! over plane waves
	GX=(GPLW(1,IPLW)+QPNT(1,IQPNT))*2.D0*PI/PAR
	GY=(GPLW(2,IPLW)+QPNT(2,IQPNT))*2.D0*PI/PAR
	GZ=(GPLW(3,IPLW)+QPNT(3,IQPNT))*2.D0*PI/PAR
	AG=SQRT(GX**2+GY**2+GZ**2)
	AG2=AG*AG
C  SET SPHERICAL HARMONICS
	IF(AG.GE.1.D-10)THEN
	CALL LIB_SPHHARM(GX/AG,GY/AG,GZ/AG,LMM,YLM)
	ELSE
	YLM(1)=1.D0/SQRT(4.D0*PI)
	DO LM=2,(LMM+1)**2
	YLM(LM)=(0.D0,0.D0)
      ENDDO
	ENDIF
	DO IATOM=1,NATOM                 !!! over atoms
	ISORT=IS(IATOM)
	CALL LIB_BESSR(AG*SMT(ISORT),BES,BESD,ILSV(ISORT)+1)
	SCP=(QPNT(1,IQPNT)+GPLW(1,IPLW))*TAU(1,IATOM)+
     &    (QPNT(2,IQPNT)+GPLW(2,IPLW))*TAU(2,IATOM)+
     &    (QPNT(3,IQPNT)+GPLW(3,IPLW))*TAU(3,IATOM)
	EXPT=EXP((0.D0,1.D0)*2.D0*PI*SCP)
	DO IORBS=1,NORBS                 !!! over spins
	DO IUPDN=1,NSPIN                 !!! over spins
	DO L=0,ILSV(ISORT)
	DO M=-L,L
	LM=L*(L+1)+M+1
	IF(AG.GT.1.D-10)THEN
	DPSMOM(1,LM,IATOM,IUPDN,IORBS,MY,INUC)=
     &DPSMOM(1,LM,IATOM,IUPDN,IORBS,MY,INUC)+
     &4.D0*PI*SMT(ISORT)**2*DRHOPS(IPLW,IUPDN,IORBS)*BES(L+1)*
     &EXPT*DCONJG(YLM(LM))/AG*SQPI4
	ELSE
	DPSMOM(1,LM,IATOM,IUPDN,IORBS,MY,INUC)=
     &DPSMOM(1,LM,IATOM,IUPDN,IORBS,MY,INUC)+
     &4.D0*PI/3.D0*SMT(ISORT)**3*DRHOPS(IPLW,IUPDN,IORBS)*
     &EXPT*DCONJG(YLM(LM))*SQPI4
	ENDIF
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      ENDDO
C  SET MULTIPOLE MOMENTS DUE TO RIGID CHANGE
	DO IPLW=0,NPLW                   !!! over plane waves
	GX=GPLW(1,IPLW)*2.D0*PI/PAR
	GY=GPLW(2,IPLW)*2.D0*PI/PAR
	GZ=GPLW(3,IPLW)*2.D0*PI/PAR
	AG=SQRT(GX**2+GY**2+GZ**2)
	AG2=AG*AG
      IF(MY.EQ.-1)GMY=+1.D0/SQRT(2.D0)*(GX-(0.D0,1.D0)*GY)
      IF(MY.EQ.+1)GMY=-1.D0/SQRT(2.D0)*(GX+(0.D0,1.D0)*GY)
      IF(MY.EQ. 0)GMY=GZ
C  SET SPHERICAL HARMONICS
	IF(AG.GE.1.D-10)THEN
	CALL LIB_SPHHARM(GX/AG,GY/AG,GZ/AG,LMM,YLM)
	ELSE
	YLM(1)=1.D0/SQRT(4.D0*PI)
	DO LM=2,(LMM+1)**2
	YLM(LM)=(0.D0,0.D0)
      ENDDO
	ENDIF
C  SET MOMENTS
	DO IATOM=1,NATOM                 !!! over atoms
	IF(IATOM.NE.INUC)CYCLE
	ISORT=IS(IATOM)
	CALL LIB_BESSR(AG*SMT(ISORT),BES,BESD,ILSV(ISORT)+1)
	SCP=GPLW(1,IPLW)*TAU(1,IATOM)+
     &    GPLW(2,IPLW)*TAU(2,IATOM)+
     &    GPLW(3,IPLW)*TAU(3,IATOM)
	EXPT=EXP((0.D0,1.D0)*2.D0*PI*SCP)
	DO IORBS=1,NORBS                 !!! over spins
	DO IUPDN=1,NSPIN                 !!! over spins
	DO L=0,ILSV(ISORT)
	DO M=-L,L
	LM=L*(L+1)+M+1
	IF(AG.GT.1.D-10)THEN
	DPSMOM(2,LM,IATOM,IUPDN,IORBS,MY,INUC)=
     &DPSMOM(2,LM,IATOM,IUPDN,IORBS,MY,INUC)+
     &4.D0*PI*SMT(ISORT)**2*RHOPS(IPLW,IUPDN,IORBS)*BES(L+1)*
     &EXPT*DCONJG(YLM(LM))/AG*SQPI4*GMY*(0.D0,1.D0)
	ELSE
	DPSMOM(2,LM,IATOM,IUPDN,IORBS,MY,INUC)=
     &DPSMOM(2,LM,IATOM,IUPDN,IORBS,MY,INUC)+
     &4.D0*PI/3.D0*SMT(ISORT)**3*RHOPS(IPLW,IUPDN,IORBS)*
     &EXPT*DCONJG(YLM(LM))*SQPI4*GMY*(0.D0,1.D0)
	ENDIF
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      ENDDO
C  CALCULATE AUXILARY PSEUDOCHARGE DENSITY (ITS COEFFICIENTS)
C  WHICH HAS THE SAME MULTIPOLES AS A TRUE DENSITY MINUS PSEUDODENSITY
	DO IUPDN=1,NSPIN
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	BT(0)=BET(0,ISORT)
	DO L=1,ILSV(ISORT)+1
	BT(L)=BET(L-1,ISORT)
      ENDDO
	CALL LIB_REGHAN(SMT(ISORT),(0.D0,0.D0),SMT(ISORT),BT(0),
     &  RHAN(0),ILSV(ISORT)+1)
	DO L=0,ILSV(ISORT)
	DO M=-L,L
	LM=L*(L+1)+M+1
C  GAUSSIAN MULTIPOLE MOMENT WITHIN SPHERE
	GSMOM=SQPI4*SMT(ISORT)*DBLE(2*L+1)*RHAN(L+1)
C  GAUSSIAN MULTIPOLE MOMENT IN WHOLE SPACE
C     GSMOM=SQPI4*SMT(ISORT)*DBLE(2*L+1)
	DPSMOM1(1,LM,IATOM,IUPDN,MY,INUC)=
     &(DELMRO(LM,IATOM,IUPDN,1,MY,INUC)-
     &DPSMOM(1,LM,IATOM,IUPDN,1,MY,INUC))/GSMOM
	DPSMOM1(2,LM,IATOM,IUPDN,MY,INUC)=-
     &DPSMOM(2,LM,IATOM,IUPDN,1,MY,INUC)/GSMOM
      ENDDO
      ENDDO
      ENDDO
      ENDDO
C Memory deallocations
	DEALLOCATE(BES,BESD,BT,WORK1,WORK2,YLM,RHAN)
	END
