	SUBROUTINE DPT_DELVCOUL(MY,INUC,IQPNT)
**************************************************************
*  Calculation of the Coulomb potential variation            *
*  due to presense of q-phonon.                              *
**************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_RADMESH, ONLY : NRAD,H,R,DR,WEIGHT,RL                      !!! from radmsh
	USE COM_DELPOT,  ONLY : DPOT                                       !!! from delpot
      USE COM_DELRHO,  ONLY : DRHO                                       !!! from delrho
      USE COM_DROMULT, ONLY : DELMAD                                     !!! from dmultrho
	USE COM_SPHERE,  ONLY : SWZ,SMT                                    !!! from readini
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: DVC1(:)
	COMPLEX*16, ALLOCATABLE :: DVC2(:)
	DATA PI/3.141592653589793D0/
	ALLOCATE(DVC1(0:NRADMEM))
	ALLOCATE(DVC2(0:NRADMEM))
	SQPI4=2.D0*SQRT(PI)
C   ***** CALCULATE EFFECTIVE POTENTIAL VARIATION *****
	DO ISPIN=1,NSPIN                    !!! over spins
	DO IATOM=1,NATOM                    !!! over all atoms in cell
	ISORT=IS(IATOM)
	DO L=0,ILSV(ISORT)                  !!! over l
	DO M=-L,L                           !!! over m
	LM=L*(L+1)+M+1
	SL=SMT(ISORT)**L
	DO IORBS=1,NORBS                    !!! over iorbs
	DO IRAD=0,NRAD(ISORT)               !!! over radial mesh
	DPOT(IRAD,LM,IATOM,ISPIN,IORBS)=(0.D0,0.D0)
      ENDDO                               !!! over radial mesh
      ENDDO                               !!! over iorbs
C   COULOMB CONTRIBUTION (RIGID CHANGE IN THE MULTIPOLE FIELD)
	DO IRAD=0,NRAD(ISORT)               !!! over radial mesh
	DPOT(IRAD,LM,IATOM,ISPIN,1)=DPOT(IRAD,LM,IATOM,ISPIN,1)+
     &2.D0*(DELMAD(3,LM,IATOM,1,MY,INUC)+
     &      DELMAD(3,LM,IATOM,NSPIN,MY,INUC)+
     &      DELMAD(4,LM,IATOM,1,MY,INUC)+
     &      DELMAD(4,LM,IATOM,NSPIN,MY,INUC)+
     &      DELMAD(5,LM,IATOM,1,MY,INUC)+
     &      DELMAD(5,LM,IATOM,NSPIN,MY,INUC))
     &/2.D0*DBLE(NSPIN)*RL(IRAD,L,ISORT)/SL
      ENDDO                              !!! over radial mesh
C   COULOMB CONTRIBUTION (SOFT CHANGE IN THE MULTIPOLE FIELD)
	DO IRAD=0,NRAD(ISORT)              !!! over radial mesh
	DPOT(IRAD,LM,IATOM,ISPIN,1)=DPOT(IRAD,LM,IATOM,ISPIN,1)+
     &2.D0*(DELMAD(1,LM,IATOM,1,MY,INUC)+
     &      DELMAD(1,LM,IATOM,NSPIN,MY,INUC)+
     &      DELMAD(2,LM,IATOM,1,MY,INUC)+
     &      DELMAD(2,LM,IATOM,NSPIN,MY,INUC))/
     &2.D0*DBLE(NSPIN)*RL(IRAD,L,ISORT)/SL
      ENDDO                              !!! over radial mesh
C   COULOMB CONTRIBUTION  (INTERNAL PART)
	CALL DPT_DPOISS1(DVC1,DVC2,L,M,IATOM,MY,INUC)! solve Poisson equation
	PL=2.D0/(2.D0*L+1.D0)
	DO IRAD=0,NRAD(ISORT)              !!! over radial mesh
	DPOT(IRAD,LM,IATOM,ISPIN,1)=DPOT(IRAD,LM,IATOM,ISPIN,1)+
     &PL*(DVC1(IRAD)+DVC2(IRAD))
      ENDDO                              !!! over radial mesh
      ENDDO                              !!! over m
      ENDDO                              !!! over l
      ENDDO                              !!! over all atoms in cell
      ENDDO                              !!! over spins
	DEALLOCATE(DVC1,DVC2)
	END



	SUBROUTINE DPT_DELVSCRN(MY,INUC,IQPNT)
***************************************************************
*  Add screened long-range part of the potential if MODE=4,5  *
*  Set change in the potential to zero if rigid-muffin-tin    *
*  approximation is needed.                                   *
***************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_LRTCOM,  ONLY : IRMT                                       !!! from readini
	USE COM_LATTICE, ONLY : TAU                                        !!! from readstr
	USE COM_LATPAR,  ONLY : PAR,ORTH,OMEGAC                            !!! from readini
	USE COM_RADMESH, ONLY : NRAD,H,R,DR,WEIGHT,RL                      !!! from radmsh
	USE COM_PLWMESH, ONLY : NPLW,GPLW                                  !!! from makeplw
      USE COM_PLZMOM,  ONLY : PSMAT,SCRMAT,DIEMAT,SCRINT                 !!! from screen
      USE COM_PLZCOM,  ONLY : NPLZ,LPLZ,IPLZ,NPTB,QPTB,INDPTB            !!! from readlrt
	USE COM_QMESH,   ONLY : NQPNT,QPNT                                 !!! from readpnt
	USE COM_DELPOT,  ONLY : DPOT,DPOTPS,DPOTPS1                        !!! from delpot
	USE COM_SPHERE,  ONLY : SWZ,SMT                                    !!! from readini
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: YLM(:)
	REAL*8, ALLOCATABLE :: BES(:)
	REAL*8, ALLOCATABLE :: BESD(:)
	COMPLEX*16 EXPQR
	DATA PI/3.141592653589793D0/
C  ADD LONG-RANGE PART OF THE POTENTIAL IF MODE=4,5 AND LPLZ.NE.0
	ALLOCATE(YLM(LIMVMEM))
	ALLOCATE(BES(-1:LMAXVMEM))
	ALLOCATE(BESD(0:LMAXVMEM))
      IF(LPLZ.GT.0.AND.(MODE.EQ.4.OR.MODE.EQ.5))THEN
	DO IPTB=1,NPTB                !!! over {q+G}-vectors
	DO ISPIN=1,NSPIN              !!! over spins
	DO IATOM=1,NATOM              !!! over atoms
      ISORT=IS(IATOM)
      QX=QPTB(1,IPTB)*2.D0*PI/PAR
      QY=QPTB(2,IPTB)*2.D0*PI/PAR
      QZ=QPTB(3,IPTB)*2.D0*PI/PAR
      AQ=SQRT(QX**2+QY**2+QZ**2)
      IF(AQ.GE.1.D-10)THEN
      CALL LIB_SPHHARM(QX/AQ,QY/AQ,QZ/AQ,ILSV(ISORT),YLM)
      ELSE
      YLM(1)=1.D0/SQRT(4.D0*PI)
      DO LM=2,(ILSV(ISORT)+1)**2
      YLM(LM)=(0.D0,0.D0)
      ENDDO
      ENDIF
      CALL LIB_BESSR(AQ*SMT(ISORT),BES(0),BESD(0),ILSV(ISORT))
      DO L=0,ILSV(ISORT)
      BES(L)=BES(L)*AQ*SMT(ISORT)
      ENDDO
      BES(-1)=COS(AQ*SMT(ISORT))
      SCP=QPTB(1,IPTB)*TAU(1,IATOM)+
     &    QPTB(2,IPTB)*TAU(2,IATOM)+
     &    QPTB(3,IPTB)*TAU(3,IATOM)
      EXPQR=EXP((0.D0,1.D0)*2.D0*PI*SCP)
      DO L=0,ILSV(ISORT)          !!! over l
      DO M=-L,L                   !!! over m
      LM=L*(L+1)+M+1
      DO IRAD=0,NRAD(ISORT)       !!! over radial mesh
      DPOT(IRAD,LM,IATOM,ISPIN,1)=DPOT(IRAD,LM,IATOM,ISPIN,1)+
     &  SCRINT(IPTB,MY,INUC)*RL(IRAD,L,ISORT)/SMT(ISORT)**L/
     &  DBLE(2*L+1)*EXPQR*DCONJG(YLM(LM))*4.D0*PI*BES(L-1)
      ENDDO                       !!! over radial mesh
      ENDDO                       !!! over m
      ENDDO                       !!! over l
      ENDDO                       !!! over atoms
	IPLW=INDPTB(IPTB)
	DPOTPS(IPLW,ISPIN,1)=DPOTPS(IPLW,ISPIN,1)+SCRINT(IPTB,MY,INUC)
      ENDDO                       !!! over spins
      ENDDO                       !!! over iptb
	ENDIF
C  SET CHANGE IN THE POTENTIAL TO ZERO IF RMTA=1 OR MODE=1,3
      IF(IRMT.EQ.1.OR.MODE.EQ.1.OR.MODE.EQ.3)THEN
      DO IORBS=1,NORBS                          !!! over iorbs
	DO ISPIN=1,NSPIN                          !!! over spins
	DO IATOM=1,NATOM                          !!! over atoms
	ISORT=IS(IATOM)
	DO LM=1,(ILSV(ISORT)+1)**2                !!! over lm
	DO IRAD=0,NRAD(ISORT)
	DPOT(IRAD,LM,IATOM,ISPIN,IORBS)=(0.D0,0.D0)
      ENDDO
      ENDDO                                      !!! over lm
      ENDDO                                      !!! over atoms
	DO IPLW=0,NPLW                             !!! over plane waves
	DPOTPS(IPLW,ISPIN,IORBS)=(0.D0,0.D0)
      ENDDO                                      !!! over plane waves
      ENDDO                                      !!! over spins
      ENDDO                                      !!! over spins
	ENDIF
	DEALLOCATE(YLM,BES,BESD)
	END


	SUBROUTINE DPT_DELVZERO(MY,INUC,IQPNT)
************************************************************
*  Calculate change in the MT-zero of the full potential.  *
************************************************************ 
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE,LRWF                   !!! from readini
      USE COM_LRTCOM,  ONLY : LDLF                                       !!! from readlrt
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_RADMESH, ONLY : NRAD                                       !!! from makerad
	USE COM_LATPAR,  ONLY : PAR,ORTH,OMEGAC                            !!! from readini
	USE COM_PLWMESH, ONLY : NPLW,GPLW                                  !!! from makeplw
	USE COM_DELPOT,  ONLY : DPOT,DPOTPS,DPOTRWF                        !!! from delpot
	USE COM_SPHERE,  ONLY : SWZ,SMT                                    !!! from readini
	USE COM_ZERODV,  ONLY : DVAV,DVMT,DVMT0                            !!! from dvzero
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	LOGICAL FIRST
	DATA PI/3.141592653589793D0/,FIRST/.TRUE./
	IF(FIRST)THEN
	FIRST=.FALSE.
	ALLOCATE(DVMT0(-1:1,NATOMMEM))
	ALLOCATE(DVAV (-1:1,NATOMMEM))
	ALLOCATE(DVMT(NATOMMEM,-1:1,NATOMMEM,NSPINMEM))
	ALLOCATE(DPOTRWF(0:NRADMEM,NATOMMEM,NSPINMEM,-1:1,NATOMMEM))
	ENDIF
	SQPI4=2.D0*SQRT(PI)
	DVMT0(MY,INUC)=(0.D0,0.D0)
C  DEFINE CHANGE IN THE MT-ZERO
	OMEGAM=0.D0
	DO ISPIN=1,NSPIN
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	DVMT(IATOM,MY,INUC,ISPIN)=DPOT(NRAD(ISORT),1,IATOM,ISPIN,1)/
     &SQPI4
      DVMT0(MY,INUC)=DVMT0(MY,INUC)+DVMT(IATOM,MY,INUC,ISPIN)
	OMEGAM=OMEGAM+4.D0*PI/3.D0*SMT(ISORT)**3
      ENDDO
      ENDDO
C     DVMT0(MY,INUC)=DVMT0(MY,INUC)/DBLE(NATOM*NSPIN)
	DVMT0(MY,INUC)=(0.D0,0.D0)
	OMEGAM=OMEGAM/DBLE(NSPIN)
C  SET AVERAGE CHANGE IN THE INTERSTITIAL POTENTIAL
      DVAV(MY,INUC)=0.D0
      DVAV(MY,INUC)=DVAV(MY,INUC)/(OMEGAC-OMEGAM)
C  SHIFT VARIATION OF THE POTENTIAL ACOORDING TO NEW ZERO
	DO ISPIN=1,NSPIN
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	DO IRAD=0,NRAD(ISORT)
	DPOT(IRAD,1,IATOM,ISPIN,1)=DPOT(IRAD,1,IATOM,ISPIN,1)-
     &DVMT0(MY,INUC)*SQPI4
      ENDDO
      ENDDO
	DPOTPS(0,ISPIN,1)=DPOTPS(0,ISPIN,1)-DVMT0(MY,INUC)
      ENDDO
C CALCULATE CHANGE IN THE SPHERICAL POTENTIAL
      DO IATOM=1,NATOM                                     !!! over sorts
      ISORT=IS(IATOM)
      DO ISPIN=1,NSPIN                                     !!! over spins
C Frozen
      IF(LRWF.EQ.0)THEN
      DO IRAD=0,NRAD(ISORT)
      DPOTRWF(IRAD,IATOM,ISPIN,MY,INUC)=(0.D0,0.D0)
      ENDDO
C Spin-averaged:
      ELSEIF(LRWF.EQ.1)THEN
      DO IRAD=0,NRAD(ISORT)
      DPOTRWF(IRAD,IATOM,ISPIN,MY,INUC)=
     &0.5D0*DPOT(IRAD,1,IATOM,1    ,1)+
     &0.5D0*DPOT(IRAD,1,IATOM,NSPIN,1)
      ENDDO
C Spin-dependent:
      ELSEIF(LRWF.EQ.2)THEN
      DO IRAD=0,NRAD(ISORT)
      DPOTRWF(IRAD,IATOM,ISPIN,MY,INUC)=
     &DPOT(IRAD,1,IATOM,ISPIN,1)
      ENDDO
      ELSE
      CALL FULLSTOP('<DELVZERO> Wrong LRWF key')
      ENDIF
C Check linear response key
      IF(LDLF.EQ.1)THEN
      DO IRAD=0,NRAD(ISORT)
      DPOTRWF(IRAD,IATOM,ISPIN,MY,INUC)=(0.D0,0.D0)
      ENDDO
      ENDIF
      ENDDO
      ENDDO
	END




	SUBROUTINE DPT_DPOISS1(DVC1,DVC2,L,M,IATOM,MY,INUC)
*************************************************************
*         The solution of the Poisson equation              *
*************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT                                       !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
      USE COM_DELRHO,  ONLY : DRHO                                       !!! from delrho
	USE COM_RADMESH, ONLY : NRAD,H,R,DR,WEIGHT,RL                      !!! from radmsh
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: WORK1(:)
	COMPLEX*16, ALLOCATABLE :: WORK2(:)
	COMPLEX*16 DRO,DVC1(0:NRADMEM),DVC2(0:NRADMEM)
	DATA PI/3.141592653589793D0/
	ALLOCATE(WORK1(0:NRADMEM))
	ALLOCATE(WORK2(0:NRADMEM))
C   INITIATION
	ISORT=IS(IATOM)
	LM=L*(L+1)+M+1
C   SOLUTION OF THE POISSON EQUATION
	DO IRAD=0,NRAD(ISORT)
	WORK1(IRAD)=(DRHO(IRAD,LM,IATOM,1,1)+DRHO(IRAD,LM,IATOM,NSPIN,1))
     &/2.D0*DBLE(NSPIN)*WEIGHT(IRAD,ISORT)*RL(IRAD,L,ISORT)
      ENDDO
	CALL LIB_CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	DVC1(0)=(0.D0,0.D0)
	DO IRAD=1,NRAD(ISORT)
	DVC1(IRAD)=WORK2(IRAD)
	DO L1=1,L+1
	DVC1(IRAD)=DVC1(IRAD)/R(IRAD,ISORT)
      ENDDO
      ENDDO
	WORK1(0)=(0.D0,0.D0)
	DO IRAD=1,NRAD(ISORT)
	WORK1(IRAD)=
     &(DRHO(IRAD,LM,IATOM,1,1)+DRHO(IRAD,LM,IATOM,NSPIN,1))/2.D0*
     &DBLE(NSPIN)*WEIGHT(IRAD,ISORT)
	DO L1=1,L+1
	WORK1(IRAD)=WORK1(IRAD)/R(IRAD,ISORT)
      ENDDO
      ENDDO
	IF(L.LE.1)THEN
	CALL LIB_CQD(H(ISORT),WORK1(0),WORK2(0),NRAD(ISORT)+1)
	ELSE
	CALL LIB_CQD(H(ISORT),WORK1(2),WORK2(2),NRAD(ISORT)-1)
	WORK2(1)=-(WORK1(1)+WORK1(2))*0.5D0*H(ISORT)
	ENDIF
	DVC2(0)=(0.D0,0.D0)
	DO IRAD=1,NRAD(ISORT)
	DVC2(IRAD)=(WORK2(NRAD(ISORT))-WORK2(IRAD))*RL(IRAD,L,ISORT)
      ENDDO
	IF(L.EQ.0)DVC2(0)=WORK2(NRAD(ISORT))
	DEALLOCATE(WORK1,WORK2)
	END
