	SUBROUTINE DPT_DELVEXCH(MY,INUC,IQPNT,KEY)
**************************************************************
*  Calculation of the exchange-correlation potential         *
*  variation due to presense of q-phonon.                    *
**************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE,ILDA,IGGA,ILSD         !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_RADMESH, ONLY : NRAD,H,R,DR,WEIGHT,RL                      !!! from radmsh
	USE COM_SPHERE,  ONLY : SWZ,SMT,ZNUC,ZCOR                          !!! from readini
	USE COM_SYMMLM,  ONLY : SYM,LMSYM                                  !!! from makesym
	USE COM_DENDAT,  ONLY : RHO                                        !!! from readscf
	USE COM_DELPOT,  ONLY : DPOT                                       !!! from delpot
      USE COM_DELRHO,  ONLY : DRHO                                       !!! from delrho
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER, ALLOCATABLE :: NCUT(:)
	REAL*8, ALLOCATABLE :: ZL(:,:)
	REAL*8, ALLOCATABLE :: WL(:,:)
	COMPLEX*16, ALLOCATABLE :: YLM(:)
	COMPLEX*16, ALLOCATABLE :: YLMI(:)
	COMPLEX*16, ALLOCATABLE :: FUN(:,:)
	COMPLEX*16, ALLOCATABLE :: DUPDN(:)
	COMPLEX*16, ALLOCATABLE :: DRODR(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: G1RO(:,:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: G2RO(:,:,:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: DG1RO(:,:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: DG2RO(:,:,:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: G1TOT(:,:,:)
	COMPLEX*16, ALLOCATABLE :: G2TOT(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: DG1TOT(:,:,:)
	COMPLEX*16, ALLOCATABLE :: DG2TOT(:,:,:,:)
	COMPLEX*16 DIM,RHOL,XC(2),DXC(2),WXC(2,2)
     &   ,DARHO,DZMAG,DAMAG,AMC(3),DMC(3),DMS(-1:1)
     &   ,GR1UP(-1:1),GR2UP(-1:1,-1:1),GR1DN(-1:1),GR2DN(-1:1,-1:1)
     &   ,GEXCUP(-1:1),GVXCUP(-1:1),DVXC2UP(-1:1,-1:1),ROTOT(2,2)
     &   ,GEXCDN(-1:1),GVXCDN(-1:1),DVXC2DN(-1:1,-1:1),AMS(-1:1)
     &   ,GR1RHO(-1:1),GR1MAG(-1:1,-1:1),GR2RHO(-1:1,-1:1),DROTOT(2,2)
     &   ,GR2MAG(-1:1,-1:1,-1:1),GR1MOD(-1:1),GR2MOD(-1:1,-1:1)
	DATA PI/3.141592653589793D0/
	SQPI4=2.D0*SQRT(PI)
      SFACT=0.5D0*DBLE(NSPIN)
      IF(IGGA.EQ.0)NTWO=2 ! increase mesh in LDA twice!
      IF(IGGA.NE.0)NTWO=4 ! increase mesh four times for GGA!
	NTHEMEM=NTWO*(2*LMAXVMEM+3)
C Memory allocations
	ALLOCATE(ZL(NTHEMEM,2))
	ALLOCATE(WL(NTHEMEM,2))
	ALLOCATE(NCUT(NSORTMEM))
	ALLOCATE(YLM(LIMVMEM))
	ALLOCATE(YLMI(LIMVMEM))
	ALLOCATE(FUN(0:NRADMEM,LIMVMEM))
	ALLOCATE(DUPDN(NSPIN))
	ALLOCATE(DRODR(0:NRADMEM,NSPINMEM,NORBSMEM,2))
	ALLOCATE(G1RO(0:NRADMEM,LIMVMEM,NSPINMEM,NORBSMEM,NGGAMEM))
	ALLOCATE(G2RO(0:NRADMEM,LIMVMEM,NSPINMEM,NORBSMEM,
     &NGGAMEM,NGGAMEM))
	ALLOCATE(G1TOT(NSPINMEM,NORBSMEM,-1:1))
	ALLOCATE(G2TOT(NSPINMEM,NORBSMEM,-1:1,-1:1))
	ALLOCATE(DG1RO(0:NRADMEM,LIMVMEM,NSPINMEM,NORBSMEM,NGGAMEM))
	ALLOCATE(DG2RO(0:NRADMEM,LIMVMEM,NSPINMEM,NORBSMEM,
     &NGGAMEM,NGGAMEM))
	ALLOCATE(DG1TOT(NSPINMEM,NORBSMEM,-1:1))
      ALLOCATE(DG2TOT(NSPINMEM,NORBSMEM,-1:1,-1:1))
C START LOOPING OVER ALL ATOMS IN CELL
      DO 1000 IATOM=1,NATOM               !!! over all atoms in cell
      ISORT=IS(IATOM)
C Set gradients to zero
      DO NY=-1,1
      GR1UP(NY)=(0.D0,0.D0)
      GR1DN(NY)=(0.D0,0.D0)
      DO NY1=-1,1
      GR2UP(NY,NY1)=(0.D0,0.D0)
      GR2DN(NY,NY1)=(0.D0,0.D0)
      ENDDO
      ENDDO
      ALRUP=0.D0
      ALRDN=0.D0
C **** COMPUTE DENSITY GRADIENTS FOR GGA ****
C Compute spherical density gradients
	DO IORBS=1,NORBS
	DO IUPDN=1,NSPIN
      CALL LIB_CDERIV1(RHO(0,1,IATOM,IUPDN,IORBS),DRODR(0,IUPDN,IORBS,1)
     &,NRAD(ISORT),H(ISORT),R(0,ISORT),DR(0,ISORT),SMT(ISORT))
      CALL LIB_CDERIV1(DRODR(0,IUPDN,IORBS,1),DRODR(0,IUPDN,IORBS,2)
     &,NRAD(ISORT),H(ISORT),R(0,ISORT),DR(0,ISORT),SMT(ISORT))
	ENDDO 
	ENDDO
C Compute full density gradients
	IF(IGGA.NE.0)THEN
      DO IORBS=1,NORBS                    !!! over spins
      DO IUPDN=1,NSPIN                    !!! over spins
      DO L=0,ILSV(ISORT)
      DO M=-L,L
      LM=L*(L+1)+M+1
	ISYM=LMSYM(LM,IATOM)
      DO IRAD=0,NRAD(ISORT)
      FUN(IRAD,LM)=(0.D0,0.D0)
	IF(SYM(LM,IATOM))
     &FUN(IRAD,LM)=RHO(IRAD,ISYM,IATOM,IUPDN,IORBS)
      ENDDO
      ENDDO
      ENDDO
	DO NY=-1,1                          !!! over directions
C Nabla_mu(Rho)
	CALL LIB_GRADFUN(FUN(0,1),G1RO(0,1,IUPDN,IORBS,NY+2),NY,
     &ILSV(ISORT),NRAD(ISORT),H(ISORT),R(0,ISORT),DR(0,ISORT),
     &SMT(ISORT))
      CALL LIB_GRADFUN(DRHO(0,1,IATOM,IUPDN,IORBS),
     &DG1RO(0,1,IUPDN,IORBS,NY+2),NY,ILSV(ISORT),NRAD(ISORT),
     &H(ISORT),R(0,ISORT),DR(0,ISORT),SMT(ISORT))
	DO NY1=-1,1                         !!! over directions
C Nabla_mu*Nabla_mu'(Rho)
	CALL LIB_GRADFUN(G1RO(0,1,IUPDN,IORBS,NY+2),
     &G2RO(0,1,IUPDN,IORBS,NY+2,NY1+2),NY1,ILSV(ISORT),
     &NRAD(ISORT),H(ISORT),R(0,ISORT),DR(0,ISORT),SMT(ISORT))
      CALL LIB_GRADFUN(DG1RO(0,1,IUPDN,IORBS,NY+2),
     &  DG2RO(0,1,IUPDN,IORBS,NY+2,NY1+2),
     &  NY1,ILSV(ISORT),NRAD(ISORT),H(ISORT),R(0,ISORT),
     &  DR(0,ISORT),SMT(ISORT))
	ENDDO                               !!! over directions
      ENDDO                               !!! over directions
      ENDDO                               !!! over spins
      ENDDO                               !!! over iorbs
	ENDIF
C ***** CALCULATE EXCHANGE-CORRELATION USING TEILOR SERIES *****
      IF(ABS(ZNUC(ISORT)).GE.1.D-05)RCUT1=0.03D0*
     &       ZNUC(ISORT)**(1.D0/3.D0)
      IF(ABS(ZNUC(ISORT)).LE.1.D-05)RCUT1=0.D0
      IF(RCUT1.GT.SMT(ISORT))
     &CALL FULLSTOP('<VEXCH>:RCUT>SMT NOT ASSUMED')
      NCUT(ISORT)=0
      DO IRAD=0,NRAD(ISORT)
      IF(R(IRAD,ISORT).LT.RCUT1)NCUT(ISORT)=IRAD
      ENDDO
      DO 100 IRAD=0,NCUT(ISORT)           !!! over irad
	DO IORBS=1,NORBS
	DO IUPDN=1,NSPIN
	ROTOT(IUPDN,IORBS)=RHO(IRAD,1,IATOM,IUPDN,IORBS)/SQPI4
	ENDDO
	ENDDO
	ARHO=DREAL(ROTOT(1,1)+ROTOT(NSPIN,1))*SFACT
	ZMAG=DREAL(ROTOT(1,1)-ROTOT(NSPIN,1))
	AMAG=SQRT(ZMAG*ZMAG)
	AMS( 0)=ROTOT(1,1)-ROTOT(NSPIN,1)
	AMS(-1)=(0.D0,0.D0)
	AMS(+1)=(0.D0,0.D0)
	IF(NORBS.EQ.2)THEN
	AMS(-1)=ROTOT(1    ,NORBS)
	AMS(+1)=ROTOT(NSPIN,NORBS)
	AMC(1)=(AMS(-1)-AMS(+1))/SQRT(2.D0)
	AMC(2)=(AMS(-1)+AMS(+1))/SQRT(2.D0)*(0.D0,-1.D0) ! since it is M^{+/-}
	AMC(3)= AMS(0)
	AMAG=SQRT(DCONJG(AMC(1))*AMC(1)+
     &          DCONJG(AMC(2))*AMC(2)+
     &          DCONJG(AMC(3))*AMC(3))
	ENDIF
C Account for spin densities
	IF(ILSD.EQ.1)THEN
	ROUP=0.5D0*(ARHO+AMAG)
	RODN=0.5D0*(ARHO-AMAG)
C Abandon spin polarization if desired
	ELSEIF(ILSD.EQ.0)THEN
	ROUP=0.5D0*ARHO
	RODN=0.5D0*ARHO
	ENDIF
C Change in density
	DO IORBS=1,NORBS
	DO IUPDN=1,NSPIN
      DROTOT(IUPDN,IORBS)=DRHO(IRAD,1,IATOM,IUPDN,IORBS)/SQPI4
      ENDDO
      ENDDO
	DARHO=(DROTOT(1,1)+DROTOT(NSPIN,1))*SFACT
C Changes in magnetization
	DZMAG=DROTOT(1,1)-DROTOT(NSPIN,1)
	DAMAG=(0.D0,0.D0)
	IF(ABS(AMAG).GT.1.D-14)DAMAG=ZMAG/AMAG*DZMAG
	IF(NORBS.EQ.2.AND.ABS(AMAG).GT.1.D-14)THEN
	DMS( 0)=DROTOT(1,1)-DROTOT(NSPIN,1)
	DMS(-1)=DROTOT(1,NORBS)
	DMS(+1)=DROTOT(NSPIN,NORBS)
	DMC(1)=(DMS(-1)-DMS(+1))/SQRT(2.D0)
	DMC(2)=(DMS(-1)+DMS(+1))/SQRT(2.D0)*(0.D0,-1.D0) ! since it is M^{+/-}
	DMC(3)= DMS(0)
	DAMAG=AMC(1)*DMC(1)/AMAG+AMC(2)*DMC(2)/AMAG+AMC(3)*DMC(3)/AMAG
C	DAMAG=       ZMAG               /AMAG*DZMAG          +
C    &      DCONJG(ROTOT(1,NORBS)    )/AMAG*DROTOT(1,NORBS)+
C    &      DCONJG(ROTOT(NSPIN,NORBS))/AMAG*DROTOT(NSPIN,NORBS)
	ENDIF
C Changes in spin densities
	IF(ILSD.EQ.1)THEN
	DUPDN(1)    =0.5D0*(DARHO+DAMAG)/SFACT
	DUPDN(NSPIN)=0.5D0*(DARHO-DAMAG)/SFACT
	ELSEIF(ILSD.EQ.0)THEN
	DUPDN(1)    =0.5D0*DARHO/SFACT
	DUPDN(NSPIN)=0.5D0*DARHO/SFACT
	ENDIF
C Gradients from spherical densities, let x=y=z=r/sqrt(3)
	IF(IGGA.NE.0)THEN
	DO IA=-1,1
	GR1RHO(IA)  =(DRODR(IRAD,1,1,1)+DRODR(IRAD,NSPIN,1,1))/
     &SQRT(3.D0)/SQPI4*SFACT
	GR1MAG(IA,0)=(DRODR(IRAD,1,1,1)-DRODR(IRAD,NSPIN,1,1))/
     &SQRT(3.D0)/SQPI4
	GR1MAG(IA,-1)=(0.D0,0.D0)
	GR1MAG(IA,+1)=(0.D0,0.D0)
	IF(NORBS.EQ.2)THEN
	GR1MAG(IA,-1)=DRODR(IRAD,1,NORBS,1)*SQRT(3.D0)/SQPI4
	GR1MAG(IA,+1)=DRODR(IRAD,2,NORBS,1)*SQRT(3.D0)/SQPI4
	ENDIF
	ENDDO
	DO IA=-1,1
	DO IB=-1,1
	IF(IA.EQ.IB)SD=+2.D0
	IF(IA.NE.IB)SD=-1.D0
	IF(IRAD.EQ.0)RR=R(1,ISORT)
	IF(IRAD.NE.0)RR=R(IRAD,ISORT)
	GR2RHO(IA,IB)  =((DRODR(IRAD,1,1,1)+DRODR(IRAD,NSPIN,1,1))/RR*SD+
     &(DRODR(IRAD,1,1,2)+DRODR(IRAD,NSPIN,1,2)))/3.D0/SQPI4*SFACT
	GR2MAG(IA,IB,0)=((DRODR(IRAD,1,1,1)-DRODR(IRAD,NSPIN,1,1))/RR*SD+
     &(DRODR(IRAD,1,1,2)-DRODR(IRAD,NSPIN,1,2)))/3.D0/SQPI4
	GR2MAG(IA,IB,-1)=(0.D0,0.D0)
	GR2MAG(IA,IB,+1)=(0.D0,0.D0)
	IF(NORBS.EQ.2)THEN
	GR2MAG(IA,IB,-1)=(DRODR(IRAD,1,NORBS,1)/RR*SD+
     &DRODR(IRAD,1,NORBS,2))/3.D0/SQPI4
	GR2MAG(IA,IB,+1)=(DRODR(IRAD,2,NORBS,1)/RR*SD+
     &DRODR(IRAD,2,NORBS,2))/3.D0/SQPI4
	ENDIF
	ENDDO
	ENDDO
C
	IF(ABS(AMAG).GT.1.D-14)RMAG=1.D0/AMAG
	IF(ABS(AMAG).LE.1.D-14)RMAG=0.D0
	DO IA=-1,1
	GR1MOD(IA)=(0.D0,0.D0)
	DO IB=-1,1
	GR1MOD(IA)=GR1MOD(IA)+0.5D0*(DCONJG(AMS(IB))*GR1MAG(IA,IB)+
     &AMS(IB)*DCONJG(GR1MAG(IA,IB)))*RMAG
	ENDDO
	ENDDO
	DO IA=-1,1
	DO IB=-1,1
	GR2MOD(IA,IB)=-GR1MOD(IA)*GR1MOD(IB)*RMAG
	DO IC=-1,1
	GR2MOD(IA,IB)=GR2MOD(IA,IB)+0.5D0*RMAG*(
     &DCONJG(GR1MAG(IB,IC))*GR1MAG(IA,IC)+
     &DCONJG(GR1MAG(IA,IC))*GR1MAG(IB,IC)+
     &DCONJG(AMS(IC))*GR2MAG(IA,IB,IC)+
     &AMS(IC)*DCONJG(GR2MAG(IA,IB,IC)))
	ENDDO
	ENDDO
	ENDDO
C
	ALRUP=0.D0
	ALRDN=0.D0
	DO IA=-1,1
	IF(ILSD.EQ.1)THEN
	GR1UP(IA)=0.5D0*(GR1RHO(IA)+GR1MOD(IA))
	GR1DN(IA)=0.5D0*(GR1RHO(IA)-GR1MOD(IA))
	ELSEIF(ILSD.EQ.0)THEN
	GR1UP(IA)=0.5D0*GR1RHO(IA)
	GR1DN(IA)=0.5D0*GR1RHO(IA)
	ENDIF
	DO IB=-1,1
	IF(ILSD.EQ.1)THEN
	GR2UP(IA,IB)=0.5D0*(GR2RHO(IA,IB)+GR2MOD(IA,IB))
	GR2DN(IA,IB)=0.5D0*(GR2RHO(IA,IB)-GR2MOD(IA,IB))
	ELSEIF(ILSD.EQ.0)THEN
	GR2UP(IA,IB)=0.5D0*GR2RHO(IA,IB)
	GR2DN(IA,IB)=0.5D0*GR2RHO(IA,IB)
	ENDIF
	ENDDO
	ALRUP=ALRUP+GR2UP(IA,IA)
	ALRDN=ALRDN+GR2DN(IA,IA)
	ENDDO
	ENDIF
C SET ORIGINAL EXCHANGE CORRELATION
	CALL POT_EXCVXC(ROUP,RODN,GR1UP,GR1DN,GR2UP,GR2DN,ALRUP,ALRDN,
     &     ILDA,IGGA,KEY,NSPIN,EXCUP,EXCDN,VXCUP,VXCDN)
	    IF(KEY.EQ.1.AND.ILSD.EQ.1)THEN
	XC(1)=VXCUP
	XC(2)=VXCDN
	ELSEIF(KEY.EQ.1.AND.ILSD.EQ.0)THEN
	XC(1)=0.5D0*(VXCUP+VXCDN)
	XC(2)=0.5D0*(VXCUP+VXCDN)
	ELSEIF(KEY.EQ.2.AND.ILSD.EQ.1)THEN
	XC(1)=EXCUP
	XC(2)=EXCDN
	ELSEIF(KEY.EQ.2.AND.ILSD.EQ.0)THEN
	XC(1)=0.5D0*(EXCUP+EXCDN)
	XC(2)=0.5D0*(EXCUP+EXCDN)
	ENDIF
C SET CHANGE IN EXCHANGE-CORRELATION
C Change due to density only
	DO JUPDN=1,NSPIN                    !!! over jupdn
      CALL POT_DEXCVXC(ROUP,RODN,GR1UP,GR1DN,GR2UP,GR2DN,ALRUP,
     &  ALRDN,ILDA,IGGA,JUPDN,KEY,NSPIN,DEXCUP,DEXCDN,DVXCUP,DVXCDN)
	    IF(KEY.EQ.1.AND.ILSD.EQ.1)THEN
	DXC(1)=DVXCUP
	DXC(2)=DVXCDN
	ELSEIF(KEY.EQ.1.AND.ILSD.EQ.0)THEN
	DXC(1)=0.5D0*(DVXCUP+DVXCDN)
	DXC(2)=0.5D0*(DVXCUP+DVXCDN)
	ELSEIF(KEY.EQ.2.AND.ILSD.EQ.1)THEN
	DXC(1)=DEXCUP
	DXC(2)=DEXCDN
	ELSEIF(KEY.EQ.2.AND.ILSD.EQ.0)THEN
	DXC(1)=0.5D0*(DEXCUP+DEXCDN)
	DXC(2)=0.5D0*(DEXCUP+DEXCDN)
	ENDIF
	DO IUPDN=1,NSPIN                    !!! over iupdn
	DO L=0,ILSV(ISORT)
	DO M=-L,L
	LM=L*(L+1)+M+1
	DPOT(IRAD,LM,IATOM,IUPDN,1)=DPOT(IRAD,LM,IATOM,IUPDN,1)+
     &0.5D0*(DXC(1)+DXC(NSPIN))*DUPDN(JUPDN)
	IF(ABS(AMAG).GT.1.D-14)
     &DPOT(IRAD,LM,IATOM,IUPDN,1)=DPOT(IRAD,LM,IATOM,IUPDN,1)+
     &(-1)**(IUPDN+1)*0.5D0*(DXC(1)-DXC(NSPIN))*ZMAG/AMAG*
     &DUPDN(JUPDN)
	IF(NORBS.EQ.2.AND.ABS(AMAG).GT.1.D-14)
     &DPOT(IRAD,LM,IATOM,IUPDN,NORBS)=DPOT(IRAD,LM,IATOM,IUPDN,NORBS)+
     &0.5D0*(DXC(1)-DXC(NSPIN))*ROTOT(IUPDN,NORBS)/AMAG*
     &DUPDN(JUPDN)
      ENDDO
      ENDDO
	ENDDO                               !!! over iupdn
	ENDDO                               !!! over jupdn
C Change due to field direction should be absent !
C     DO IUPDN=1,NSPIN
C	IF(NORBS.EQ.2.AND.ABS(AMAG).GT.1.D-14)
C    &DPOT(IRAD,1,IATOM,IUPDN,1)=DPOT(IRAD,1,IATOM,IUPDN,1)+
C    &(-1)**(IUPDN+1)*0.5D0*(XC(1)-XC(NSPIN))*
C    &(DZMAG/AMAG-ZMAG/AMAG*DAMAG/AMAG)
C	IF(NORBS.EQ.2.AND.ABS(AMAG).GT.1.D-14)
C    &DPOT(IRAD,1,IATOM,IUPDN,NORBS)=DPOT(IRAD,1,IATOM,IUPDN,NORBS)+
C    &(XC(1)-XC(NSPIN))*(DRHO(IRAD,1,IATOM,IUPDN,NORBS)/AMAG-
C    &RHO(IRAD,1,IATOM,IUPDN,NORBS)/AMAG*DAMAG/AMAG)
C     ENDDO
C  Change due to density gradients is neglected
C  Change due to density second gradients is neglected
 100	CONTINUE                            !!! over irad
C  **** CALCULATE EXCHANGE-CORRELATION BY DIRECT EXPANSION ****
      IF(ABS(ZNUC(ISORT)).GE.1.D-05)RCUT2=0.3D0*
     &       ZNUC(ISORT)**(1.D0/3.D0)
      IF(ABS(ZNUC(ISORT)).LE.1.D-05)RCUT2=0.0D0
      NTHETA=2*ILSV(ISORT)+3
      CALL LIB_MKLEGW(     NTHETA,ZL(1,1),WL(1,1),0)
      CALL LIB_MKLEGW(NTWO*NTHETA,ZL(1,2),WL(1,2),0)
      DO 400 IRAD=NCUT(ISORT)+1,NRAD(ISORT)!! over radial mesh
      IF(R(IRAD,ISORT).LE.RCUT2)MTWO=1
      IF(R(IRAD,ISORT).LE.RCUT2)MGRD=1
      IF(R(IRAD,ISORT).GT.RCUT2)MTWO=NTWO
      IF(R(IRAD,ISORT).GT.RCUT2)MGRD=2
      DO 300 ITHETA=1,NTHETA*MTWO         !!! over theta
      NPHI=NTHETA*MTWO
      ZCOORD=ZL(ITHETA,MGRD)
      STHETA=SQRT(1.D0-ZCOORD*ZCOORD)
      DPHI=2.D0*PI/DBLE(NPHI)
      WGTL=DPHI*WL(ITHETA,MGRD)
      DO 200 IPHI=1,NPHI                  !!! over phi
      PHI=DBLE(IPHI-1)*DPHI
      XCOORD=COS(PHI)*STHETA
      YCOORD=SIN(PHI)*STHETA
      CALL LIB_SPHHARM(XCOORD,YCOORD,ZCOORD,ILSV(ISORT),YLM)
      DIM=(0.D0,-1.D0)
      DO L=0,ILSV(ISORT)
      DIM=DIM*(0.D0,1.D0)
      DO M=-L,L
      LM=L*(L+1)+M+1
      YLMI(LM)=YLM(LM)*DIM
      ENDDO
      ENDDO
C SET UP TOTAL DENSITY AT THE POINT "R,THETA,PHI"
	DO IORBS=1,NORBS                    !!! over iorbs
	DO IUPDN=1,NSPIN                    !!! over spins 
	ROTOT(IUPDN,IORBS)=(0.D0,0.D0)
	DO L=0,ILSV(ISORT)                  !!! over l 
	DO M=-L,L                           !!! over m 
	LM=L*(L+1)+M+1
	IF(SYM(LM,IATOM))THEN
	ISYM=LMSYM(LM,IATOM)
	ROTOT(IUPDN,IORBS)=ROTOT(IUPDN,IORBS)+
     &RHO(IRAD,ISYM,IATOM,IUPDN,IORBS)*YLMI(LM)
	ENDIF
      ENDDO                               !!! over m
      ENDDO                               !!! over l
      ENDDO                               !!! over spins
      ENDDO                               !!! over iorbs
	ARHO=DREAL(ROTOT(1,1)+ROTOT(NSPIN,1))*SFACT
	ZMAG=DREAL(ROTOT(1,1)-ROTOT(NSPIN,1))
	AMAG=SQRT(ZMAG*ZMAG)
	AMS( 0)=ROTOT(1,1)-ROTOT(NSPIN,1)
	AMS(-1)=(0.D0,0.D0)
	AMS(+1)=(0.D0,0.D0)
	IF(NORBS.EQ.2)THEN
	AMS(-1)=ROTOT(1    ,NORBS)
	AMS(+1)=ROTOT(NSPIN,NORBS)
	AMC(1)=(AMS(-1)-AMS(+1))/SQRT(2.D0)
	AMC(2)=(AMS(-1)+AMS(+1))/SQRT(2.D0)*(0.D0,-1.D0) ! since it is M^{+/-}
	AMC(3)= AMS(0)
	AMAG=SQRT(DCONJG(AMC(1))*AMC(1)+
     &          DCONJG(AMC(2))*AMC(2)+
     &          DCONJG(AMC(3))*AMC(3))
	ENDIF
C Spin densities
	IF(ILSD.EQ.1)THEN
	ROUP=0.5D0*(ARHO+AMAG)
	RODN=0.5D0*(ARHO-AMAG)
	ELSEIF(ILSD.EQ.0)THEN
	ROUP=0.5D0*ARHO
	RODN=0.5D0*ARHO
	ENDIF
C SET UP DENSITY GRADIENTS AT THE POINT "R,THETA,PHI"
	IF(IGGA.NE.0)THEN
	ITWO=2
	DO NY=-1,1                          !!! over directions
	DO IORBS=1,NORBS                    !!! over iorbs
	DO IUPDN=1,NSPIN                    !!! over spins 
	G1TOT(IUPDN,IORBS,NY   )=(0.D0,0.D0)
	G2TOT(IUPDN,IORBS,NY,-1)=(0.D0,0.D0)
	G2TOT(IUPDN,IORBS,NY, 0)=(0.D0,0.D0)
	G2TOT(IUPDN,IORBS,NY,+1)=(0.D0,0.D0)
	DO L=0,ILSV(ISORT)                  !!! over l 
	DO M=-L,L                           !!! over m 
	LM=L*(L+1)+M+1
	G1TOT(IUPDN,IORBS,NY   )=G1TOT(IUPDN,IORBS,NY   )+
     &  YLMI(LM)*G1RO(IRAD,LM,IUPDN,IORBS,NY+2   )
	G2TOT(IUPDN,IORBS,NY,-1)=G2TOT(IUPDN,IORBS,NY,-1)+
     &  YLMI(LM)*G2RO(IRAD,LM,IUPDN,IORBS,NY+2,-1+ITWO)
	G2TOT(IUPDN,IORBS,NY, 0)=G2TOT(IUPDN,IORBS,NY, 0)+
     &  YLMI(LM)*G2RO(IRAD,LM,IUPDN,IORBS,NY+2, 0+ITWO)
	G2TOT(IUPDN,IORBS,NY,+1)=G2TOT(IUPDN,IORBS,NY,+1)+
     &  YLMI(LM)*G2RO(IRAD,LM,IUPDN,IORBS,NY+2,+1+ITWO)
      ENDDO                               !!! over m
      ENDDO                               !!! over l
      ENDDO                               !!! over spins 
      ENDDO                               !!! over iorbs
	ENDDO                               !!! over directions
	ENDIF
C FIND CONTRIBUTION TO EXCHANGE-CORRELATION POTENTIAL FROM "R,THETA,PHI"
	IF(IGGA.NE.0)THEN
	DO NY=-1,1
	GR1RHO(NY)=(G1TOT(1,1,NY)+G1TOT(NSPIN,1,NY))*SFACT
	GR1MAG(NY,0)=(G1TOT(1,1,NY)-G1TOT(NSPIN,1,NY))
	GR1MAG(NY,-1)=(0.D0,0.D0)
	GR1MAG(NY,+1)=(0.D0,0.D0)
	IF(NORBS.EQ.2)THEN
	GR1MAG(NY,-1)=G1TOT(1,NORBS,NY)
	GR1MAG(NY,+1)=G1TOT(2,NORBS,NY)
	ENDIF
	ENDDO
	DO NY=-1,1
	DO NY1=-1,1
	GR2RHO(NY,NY1)=(G2TOT(1,1,NY,NY1)+G2TOT(NSPIN,1,NY,NY1))*SFACT
	GR2MAG(NY,NY1,0)=(G2TOT(1,1,NY,NY1)-G2TOT(NSPIN,1,NY,NY1))
	GR2MAG(NY,NY1,-1)=(0.D0,0.D0)
	GR2MAG(NY,NY1,+1)=(0.D0,0.D0)
	IF(NORBS.EQ.2)THEN
	GR2MAG(NY,NY1,-1)=G2TOT(1,NORBS,NY,NY1)
	GR2MAG(NY,NY1,+1)=G2TOT(2,NORBS,NY,NY1)
	ENDIF
	ENDDO
	ENDDO
C
	IF(ABS(AMAG).GT.1.D-14)RMAG=1.D0/AMAG
	IF(ABS(AMAG).LE.1.D-14)RMAG=0.D0
	DO NY=-1,1
	GR1MOD(NY)=(0.D0,0.D0)
	DO IA=-1,1
	GR1MOD(NY)=GR1MOD(NY)+0.5D0*(DCONJG(AMS(IA))*GR1MAG(NY,IA)+
     &AMS(IA)*DCONJG(GR1MAG(NY,IA)))*RMAG
	ENDDO
	ENDDO
	DO NY=-1,1
	DO NY1=-1,1
	GR2MOD(NY,NY1)=-GR1MOD(NY)*GR1MOD(NY1)*RMAG
	DO IA=-1,1
	GR2MOD(NY,NY1)=GR2MOD(NY,NY1)+0.5D0*RMAG*(
     &DCONJG(GR1MAG(NY1,IA))*GR1MAG(NY,IA)+
     &DCONJG(GR1MAG(NY,IA))*GR1MAG(NY1,IA)+
     &DCONJG(AMS(IA))*GR2MAG(NY,NY1,IA)+
     &AMS(IA)*DCONJG(GR2MAG(NY,NY1,IA)))
	ENDDO
	ENDDO
	ENDDO
C
	ALRUP=0.D0
	ALRDN=0.D0
	DO NY=-1,1
	IF(ILSD.EQ.1)THEN
	GR1UP(NY)=0.5D0*(GR1RHO(NY)+GR1MOD(NY))
	GR1DN(NY)=0.5D0*(GR1RHO(NY)-GR1MOD(NY))
	ELSEIF(ILSD.EQ.0)THEN
	GR1UP(NY)=0.5D0*GR1RHO(NY)
	GR1DN(NY)=0.5D0*GR1RHO(NY)
	ENDIF
	DO NY1=-1,1
	IF(ILSD.EQ.1)THEN
	GR2UP(NY,NY1)=0.5D0*(GR2RHO(NY,NY1)+GR2MOD(NY,NY1))
	GR2DN(NY,NY1)=0.5D0*(GR2RHO(NY,NY1)-GR2MOD(NY,NY1))
	ELSEIF(ILSD.EQ.0)THEN
	GR2UP(NY,NY1)=0.5D0*GR2RHO(NY,NY1)
	GR2DN(NY,NY1)=0.5D0*GR2RHO(NY,NY1)
	ENDIF
	ENDDO
	ALRUP=ALRUP+(-1)**NY*GR2UP(NY,-NY)
	ALRDN=ALRDN+(-1)**NY*GR2DN(NY,-NY)
	ENDDO
	ENDIF
 	CALL POT_EXCVXC(ROUP,RODN,GR1UP,GR1DN,GR2UP,GR2DN,ALRUP,ALRDN,
     &     ILDA,IGGA,KEY,NSPIN,EXCUP,EXCDN,VXCUP,VXCDN)
	    IF(KEY.EQ.1.AND.ILSD.EQ.1)THEN
	XC(1)=VXCUP
	XC(2)=VXCDN
	ELSEIF(KEY.EQ.1.AND.ILSD.EQ.0)THEN
	XC(1)=0.5D0*(VXCUP+VXCDN)
	XC(2)=0.5D0*(VXCUP+VXCDN)
	ELSEIF(KEY.EQ.2.AND.ILSD.EQ.1)THEN
	XC(1)=EXCUP
	XC(2)=EXCDN
	ELSEIF(KEY.EQ.2.AND.ILSD.EQ.0)THEN
	XC(1)=0.5D0*(EXCUP+EXCDN)
	XC(2)=0.5D0*(EXCUP+EXCDN)
	ENDIF
C  SET UP CHANGE IN THE TOTAL DENSITY AT THE POINT "R,THETA,PHI"
	DO IORBS=1,NORBS                    !!! over spins
	DO IUPDN=1,NSPIN                    !!! over spins
	DROTOT(IUPDN,IORBS)=(0.D0,0.D0)
	DO L=0,ILSV(ISORT)                  !!! over l
	DO M=-L,L                           !!! over m
	LM=L*(L+1)+M+1
	DROTOT(IUPDN,IORBS)=DROTOT(IUPDN,IORBS)+
     &DRHO(IRAD,LM,IATOM,IUPDN,IORBS)*YLMI(LM)
	ENDDO                               !!! over m 
      ENDDO                               !!! over l
      ENDDO                               !!! over spins
      ENDDO                               !!! over spins
	DARHO=(DROTOT(1,1)+DROTOT(NSPIN,1))*SFACT
C Changes in magnetization
	DZMAG=DROTOT(1,1)-DROTOT(NSPIN,1)
	DAMAG=(0.D0,0.D0)
	IF(ABS(AMAG).GT.1.D-14)DAMAG=ZMAG/AMAG*DZMAG
	IF(NORBS.EQ.2.AND.ABS(AMAG).GT.1.D-14)THEN
	DMS( 0)=DROTOT(1,1)-DROTOT(NSPIN,1)
	DMS(-1)=DROTOT(1,NORBS)
	DMS(+1)=DROTOT(NSPIN,NORBS)
	DMC(1)=(DMS(-1)-DMS(+1))/SQRT(2.D0)
	DMC(2)=(DMS(-1)+DMS(+1))/SQRT(2.D0)*(0.D0,-1.D0) ! since it is M^{+/-}
	DMC(3)= DMS(0)
	DAMAG=AMC(1)*DMC(1)/AMAG+AMC(2)*DMC(2)/AMAG+AMC(3)*DMC(3)/AMAG
C	DAMAG=       ZMAG               /AMAG*DZMAG          +
C    &      DCONJG(ROTOT(1,NORBS)    )/AMAG*DROTOT(1,NORBS)+
C    &      DCONJG(ROTOT(NSPIN,NORBS))/AMAG*DROTOT(NSPIN,NORBS)
	ENDIF
C Changes in spin densities
	IF(ILSD.EQ.1)THEN
	DUPDN(1)=    0.5D0*(DARHO+DAMAG)/SFACT
	DUPDN(NSPIN)=0.5D0*(DARHO-DAMAG)/SFACT
	ELSEIF(ILSD.EQ.0)THEN
	DUPDN(1)=    0.5D0*DARHO/SFACT
	DUPDN(NSPIN)=0.5D0*DARHO/SFACT
	ENDIF
C SET UP DENSITY GRADIENTS AT THE POINT "R,THETA,PHI"
	IF(IGGA.NE.0)THEN
	ITWO=2
	DO NY=-1,1                          !!! over directions
	DO IORBS=1,NORBS                    !!! over iorbs
	DO IUPDN=1,NSPIN                    !!! over spins 
	DG1TOT(IUPDN,IORBS,NY  )=(0.D0,0.D0)
	DG2TOT(IUPDN,IORBS,NY,-1)=(0.D0,0.D0)
	DG2TOT(IUPDN,IORBS,NY, 0)=(0.D0,0.D0)
	DG2TOT(IUPDN,IORBS,NY,+1)=(0.D0,0.D0)
	DO L=0,ILSV(ISORT)                  !!! over l 
	DO M=-L,L                           !!! over m 
	LM=L*(L+1)+M+1
      DG1TOT(IUPDN,IORBS,NY)=DG1TOT(IUPDN,IORBS,NY)+
     &  YLMI(LM)*DG1RO(IRAD,LM,IUPDN,IORBS,NY+2)
	DG2TOT(IUPDN,IORBS,NY,-1)=DG2TOT(IUPDN,IORBS,NY,-1)+
     &  YLMI(LM)*DG2RO(IRAD,LM,IUPDN,IORBS,NY+2,-1+ITWO)
	DG2TOT(IUPDN,IORBS,NY, 0)=DG2TOT(IUPDN,IORBS,NY, 0)+
     &  YLMI(LM)*DG2RO(IRAD,LM,IUPDN,IORBS,NY+2, 0+ITWO)
	DG2TOT(IUPDN,IORBS,NY,+1)=DG2TOT(IUPDN,IORBS,NY,+1)+
     &  YLMI(LM)*DG2RO(IRAD,LM,IUPDN,IORBS,NY+2,+1+ITWO)
      ENDDO                               !!! over m
      ENDDO                               !!! over l
      ENDDO                               !!! over spins 
      ENDDO                               !!! over iorbs
	ENDDO                               !!! over directions
	ENDIF
C  FIND EXCHANGE-CORRELATION CONTRIBUTION FROM "R,THETA,PHI"
      DO IORBS=1,NORBS
      DO IUPDN=1,NSPIN
	WXC(IUPDN,IORBS)=(0.D0,0.D0)
	ENDDO
	ENDDO
C Change due to density
	DO JUPDN=1,NSPIN
      CALL POT_DEXCVXC(ROUP,RODN,GR1UP,GR1DN,GR2UP,GR2DN,ALRUP,
     &ALRDN,ILDA,IGGA,JUPDN,KEY,NSPIN,DEXCUP,DEXCDN,DVXCUP,DVXCDN)
	    IF(KEY.EQ.1.AND.ILSD.EQ.1)THEN
	DXC(1)=DVXCUP
	DXC(2)=DVXCDN
	ELSEIF(KEY.EQ.1.AND.ILSD.EQ.0)THEN
	DXC(1)=0.5D0*(DVXCUP+DVXCDN)
	DXC(2)=0.5D0*(DVXCUP+DVXCDN)
	ELSEIF(KEY.EQ.2.AND.ILSD.EQ.1)THEN
	DXC(1)=DEXCUP
	DXC(2)=DEXCDN
	ELSEIF(KEY.EQ.2.AND.ILSD.EQ.0)THEN
	DXC(1)=0.5D0*(DEXCUP+DEXCDN)
	DXC(2)=0.5D0*(DEXCUP+DEXCDN)
	ENDIF
      DO IUPDN=1,NSPIN
      WXC(IUPDN,1)=WXC(IUPDN,1)+WGTL*
     &0.5D0*(DXC(1)+DXC(NSPIN))*DUPDN(JUPDN)
	IF(ABS(AMAG).GT.1.D-14)
     &WXC(IUPDN,1)=WXC(IUPDN,1)+WGTL*
     &(-1)**(IUPDN+1)*0.5D0*(DXC(1)-DXC(NSPIN))*ZMAG/AMAG*
     &DUPDN(JUPDN)
	IF(NORBS.EQ.2.AND.ABS(AMAG).GT.1.D-14)
     &WXC(IUPDN,NORBS)=WXC(IUPDN,NORBS)+WGTL*
     &0.5D0*(DXC(1)-DXC(NSPIN))*ROTOT(IUPDN,NORBS)/AMAG*
     &DUPDN(JUPDN)
      ENDDO
      ENDDO
C Change due to field direction should be absent !
C     DO IUPDN=1,NSPIN
C	IF(NORBS.EQ.2.AND.ABS(AMAG).GT.1.D-14)
C    &WXC(IUPDN,1)=WXC(IUPDN,1)+WGTL*
C    &(-1)**(IUPDN+1)*0.5D0*(XC(1)-XC(NSPIN))*
C    &(DZMAG/AMAG-ZMAG/AMAG*DAMAG/AMAG)
C	IF(NORBS.EQ.2.AND.ABS(AMAG).GT.1.D-14)
C    &WXC(IUPDN,NORBS)=WXC(IUPDN,NORBS)+WGTL*
C    &(XC(1)-XC(NSPIN))*(DROTOT(IUPDN,NORBS)/AMAG-
C    &DROTOT(IUPDN,NORBS)/AMAG*DAMAG/AMAG)
C     ENDDO
C Change due to gradients
	IF(IGGA.NE.0)THEN
	DO JUPDN=1,NSPIN
      CALL POT_GEXCVXC(ROUP,RODN,GR1UP,GR1DN,GR2UP,GR2DN,ALRUP,
     &ALRDN,ILDA,IGGA,JUPDN,KEY,NSPIN,GEXCUP,GEXCDN,GVXCUP,GVXCDN)
	DO IA=-1,1
	    IF(KEY.EQ.1.AND.ILSD.EQ.1)THEN
	DXC(1)=GVXCUP(IA)
	DXC(2)=GVXCDN(IA)
	ELSEIF(KEY.EQ.1.AND.ILSD.EQ.0)THEN
	DXC(1)=0.5D0*(GVXCUP(IA)+GVXCDN(IA))
	DXC(2)=0.5D0*(GVXCUP(IA)+GVXCDN(IA))
	ELSEIF(KEY.EQ.2.AND.ILSD.EQ.1)THEN
	DXC(1)=GEXCUP(IA)
	DXC(2)=GEXCDN(IA)
	ELSEIF(KEY.EQ.2.AND.ILSD.EQ.0)THEN
	DXC(1)=0.5D0*(GEXCUP(IA)+GEXCDN(IA))
	DXC(2)=0.5D0*(GEXCUP(IA)+GEXCDN(IA))
	ENDIF
      DO IUPDN=1,NSPIN
      WXC(IUPDN,1)=WXC(IUPDN,1)+WGTL*
     &  0.5D0*(DXC(1)+DXC(NSPIN))*DG1TOT(JUPDN,1,IA)
	IF(ABS(AMAG).GT.1.D-14)
     &WXC(IUPDN,1)=WXC(IUPDN,1)+WGTL*
     &(-1)**(IUPDN+1)*0.5D0*(DXC(1)-DXC(NSPIN))*ZMAG/AMAG*
     &DG1TOT(JUPDN,1,IA)
	IF(NORBS.EQ.2.AND.ABS(AMAG).GT.1.D-14)
     &WXC(IUPDN,NORBS)=WXC(IUPDN,NORBS)+WGTL*
     &0.5D0*(DXC(1)-DXC(NSPIN))*ROTOT(IUPDN,NORBS)/AMAG*
     &DG1TOT(JUPDN,1,IA)
      ENDDO
      ENDDO
      ENDDO
      ENDIF
C Change due to second gradients
	IF(IGGA.NE.0.AND.KEY.EQ.1)THEN
	DO JUPDN=1,NSPIN
      CALL POT_G2VXC(ROUP,RODN,GR1UP,GR1DN,GR2UP,GR2DN,ALRUP,
     &ALRDN,ILDA,IGGA,JUPDN,KEY,NSPIN,DVXC2UP,DVXC2DN,DVXCLUP,DVXCLDN)
      DO IA1=-1,1
      DO IA =-1,1
	    IF(KEY.EQ.1.AND.ILSD.EQ.1)THEN
	DXC(1)=DVXC2UP(IA,IA1)
	DXC(2)=DVXC2DN(IA,IA1)
	ELSEIF(KEY.EQ.1.AND.ILSD.EQ.0)THEN
	DXC(1)=0.5D0*(DVXC2UP(IA,IA1)+DVXC2DN(IA,IA1))
	DXC(2)=0.5D0*(DVXC2UP(IA,IA1)+DVXC2DN(IA,IA1))
	ENDIF
      DO IUPDN=1,NSPIN
      WXC(IUPDN,1)=WXC(IUPDN,1)+WGTL*
     &  0.5D0*(DXC(1)+DXC(NSPIN))*DG2TOT(JUPDN,1,IA,IA1)
	IF(ABS(AMAG).GT.1.D-14)
     &WXC(IUPDN,1)=WXC(IUPDN,1)+WGTL*
     &(-1)**(IUPDN+1)*0.5D0*(DXC(1)-DXC(NSPIN))*ZMAG/AMAG*
     &DG2TOT(JUPDN,1,IA,IA1)
	IF(NORBS.EQ.2.AND.ABS(AMAG).GT.1.D-14)
     &WXC(IUPDN,NORBS)=WXC(IUPDN,NORBS)+WGTL*
     &0.5D0*(DXC(1)-DXC(NSPIN))*ROTOT(IUPDN,NORBS)/AMAG*
     &DG2TOT(JUPDN,1,IA,IA1)
      ENDDO
      ENDDO
      ENDDO
	    IF(KEY.EQ.1.AND.ILSD.EQ.1)THEN
	DXC(1)=DVXCLUP
	DXC(2)=DVXCLDN
	ELSEIF(KEY.EQ.1.AND.ILSD.EQ.0)THEN
	DXC(1)=0.5D0*(DVXCLUP+DVXCLDN)
	DXC(2)=0.5D0*(DVXCLUP+DVXCLDN)
	ENDIF
	DO IUPDN=1,NSPIN
      WXC(IUPDN,1)=WXC(IUPDN,1)+WGTL*
     &0.5D0*(DXC(1)+DXC(NSPIN))*
     &           ((-1)**(-1)*DG2TOT(JUPDN,1,-1,-1)+
     &            (-1)**( 0)*DG2TOT(JUPDN,1, 0, 0)+
     &            (-1)**(+1)*DG2TOT(JUPDN,1,+1,-1))
	IF(ABS(AMAG).GT.1.D-14)
     &WXC(IUPDN,1)=WXC(IUPDN,1)+WGTL*
     &(-1)**(IUPDN+1)*0.5D0*(DXC(1)-DXC(NSPIN))*ZMAG/AMAG*
     &           ((-1)**(-1)*DG2TOT(JUPDN,1,-1,-1)+
     &            (-1)**( 0)*DG2TOT(JUPDN,1, 0, 0)+
     &            (-1)**(+1)*DG2TOT(JUPDN,1,+1,-1))
	IF(NORBS.EQ.2.AND.ABS(AMAG).GT.1.D-14)
     &WXC(IUPDN,NORBS)=WXC(IUPDN,NORBS)+WGTL*
     &0.5D0*(DXC(1)-DXC(NSPIN))*ROTOT(IUPDN,NORBS)/AMAG*
     &           ((-1)**(-1)*DG2TOT(JUPDN,1,-1,-1)+
     &            (-1)**( 0)*DG2TOT(JUPDN,1, 0, 0)+
     &            (-1)**(+1)*DG2TOT(JUPDN,1,+1,-1))
      ENDDO
      ENDDO
      ENDIF
C  PROJECT ONTO SPHERICAL HARMONICS
	DO IORBS=1,NORBS                    !!! over spins
	DO IUPDN=1,NSPIN                    !!! over spins
	DO L=0,ILSV(ISORT)                  !!! over l
	DO M=-L,L                           !!! over m
	LM=L*(L+1)+M+1
	DPOT(IRAD,LM,IATOM,IUPDN,IORBS)=DPOT(IRAD,LM,IATOM,IUPDN,IORBS)+
     &DCONJG(YLMI(LM))*WXC(IUPDN,IORBS)
      ENDDO                               !!! over m
      ENDDO                               !!! over l
      ENDDO                               !!! over spins
      ENDDO                               !!! over spins
 200  CONTINUE                            !!! over phi
 300	CONTINUE                            !!! over theta
 400	CONTINUE                            !!! over radial points
1000  CONTINUE                            !!! over atoms
	DEALLOCATE(NCUT,YLM,YLMI,FUN,DRODR,DUPDN)
	DEALLOCATE(G1RO,G2RO,G1TOT,G2TOT,DG1RO,DG2RO,DG1TOT,DG2TOT)
	DEALLOCATE(ZL,WL)
	END
