	SUBROUTINE DPT_DELVXFTR(MY,INUC,IQPNT,KEY)
*************************************************************
* Calculates change in exchange-correlation pseudopotential *
* Generalized gradient corrections after Perdew et.al added *
*************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,ILDA,IGGA,ILSD                        !!! from readini
	USE COM_PARAM,   ONLY : NATOM,NSPIN,NORBS,IS                       !!! from readini
	USE COM_LATTICE, ONLY : RBAS,GBAS                                  !!! from init
	USE COM_DENDAT,  ONLY : RHOPS                                      !!! from readscf
	USE COM_DELRHO,  ONLY : DRHOPS                                     !!! from delrho
	USE COM_DELPOT,  ONLY : DPOTPS                                     !!! from delpot
	USE COM_FFTMESH, ONLY : MDIV=>NFFTG,AD,RD                          !!! from readini
	USE COM_LATPAR,  ONLY : PAR,ORTH,OMEGAC                            !!! from readini
	USE COM_QMESH,   ONLY : NQPNT,QPNT                                 !!! from readpnt
      USE COM_PLWMESH, ONLY : NPLW,GPLW,KVEC,KGMIN,KGMAX,INDG            !!! from makeplw
	USE COM_SPHERE,  ONLY : SWZ,SMT                                    !!! from readini
	USE COM_MASHDEP, ONLY : NVAL                                       !!! from setup
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER MF(3)
	COMPLEX*16, ALLOCATABLE :: RHORS(:,:,:)
	COMPLEX*16, ALLOCATABLE :: DRHORS(:,:,:)
	COMPLEX*16, ALLOCATABLE :: DUPDN(:)
	COMPLEX*16, ALLOCATABLE :: G1RHO(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: G2RHO(:,:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: DG1RHO(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: DG2RHO(:,:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: DVXCRS(:,:,:)
	COMPLEX*16, ALLOCATABLE :: TMPARR(:)
	COMPLEX*16 DXC,GR1UP(3),GR2UP(3,3),GR1DN(3),GR2DN(3,3)
     &    ,GEXCUP(3),GVXCUP(3),DVXC2UP(3,3)
     &    ,GEXCDN(3),GVXCDN(3),DVXC2DN(3,3),GR1RHO(3),GR1MAG(3,-1:1)
     &    ,GR2MAG(3,3,-1:1),GR1MOD(3),GR2MOD(3,3),GR2RHO(3,3)
     &    ,AMC(3),AMS(-1:1),DMC(3),DMS(-1:1),DBS(-1:1)
     &    ,DARHO,DZMAG,DAMAG
	DIMENSION QGAM(3),GL(3),XC(2),DXC(2)
	DATA PI/3.141592653589793D0/,QGAM/0.D0,0.D0,0.D0/
C Memory allocations
      ALLOCATE(DUPDN(NSPIN))
	ALLOCATE(RHORS(NFFTMEM,NSPINMEM,NORBSMEM))
	ALLOCATE(DRHORS(NFFTMEM,NSPINMEM,NORBSMEM))
	ALLOCATE(G1RHO(NFFTMEM,NSPINMEM,NORBSMEM,NGGAMEM))
	ALLOCATE(G2RHO(NFFTMEM,NSPINMEM,NORBSMEM,NGGAMEM,NGGAMEM))
	ALLOCATE(DG1RHO(NFFTMEM,NSPINMEM,NORBSMEM,NGGAMEM))
	ALLOCATE(DG2RHO(NFFTMEM,NSPINMEM,NORBSMEM,NGGAMEM,NGGAMEM))
	ALLOCATE(DVXCRS(NFFTMEM,NSPINMEM,NORBSMEM))
	ALLOCATE(TMPARR(NFFTMEM))
      SFACT=0.5D0*DBLE(NSPIN)
      DO IORBS=1,NORBS                         !!! over iorbs
      DO IUPDN=1,NSPIN                         !!! over spins
C SET CHARGE DENSITY AT THE REAL SPACE MESH
      CALL POT_FTRANSD( RHOPS(0,IUPDN,IORBS),
     & RHORS(1,IUPDN,IORBS),TMPARR,0,0,QGAM)
      CALL POT_FTRANSD(DRHOPS(0,IUPDN,IORBS),
     &DRHORS(1,IUPDN,IORBS),TMPARR,0,0,QPNT(1,IQPNT))
      IF(IGGA.NE.0)THEN
C SET DENSITY GRADIENTS
      DO IA=1,3
      CALL POT_FTRANSD( RHOPS(0,IUPDN,IORBS),
     & G1RHO(1,IUPDN,IORBS,IA),TMPARR,IA,0,QGAM)
      CALL POT_FTRANSD(DRHOPS(0,IUPDN,IORBS),
     &DG1RHO(1,IUPDN,IORBS,IA),TMPARR,IA,0,QPNT(1,IQPNT))
	DO IB=1,3
      CALL POT_FTRANSD( RHOPS(0,IUPDN,IORBS),
     & G2RHO(1,IUPDN,IORBS,IA,IB),TMPARR,IA,IB,QGAM)
      CALL POT_FTRANSD(DRHOPS(0,IUPDN,IORBS),
     &DG2RHO(1,IUPDN,IORBS,IA,IB),TMPARR,IA,IB,QPNT(1,IQPNT))
      ENDDO
      ENDDO
      ENDIF
      ENDDO                                    !!! over spins
      ENDDO                                    !!! over iorbs
C Set gradients to zero
      DO IA=1,3
      GR1UP(IA)=(0.D0,0.D0)
      GR1DN(IA)=(0.D0,0.D0)
      DO IB=1,3
      GR2UP(IA,IB)=(0.D0,0.D0)
      GR2DN(IA,IB)=(0.D0,0.D0)
      ENDDO
      ENDDO
      ALRUP=0.D0
      ALRDN=0.D0
C *** GET EXCHANGE-CORRELATION PSEUDOPOTENTIAL AT THE REAL SPACE MESH ***
	DO 3000 MFFT3=0,MDIV(3)-1               !!! over mfft3
	DO 2000 MFFT2=0,MDIV(2)-1               !!! over mfft2
	DO 1000 MFFT1=0,MDIV(1)-1               !!! over mfft1
	IFFT=1+MFFT1+MFFT2*MDIV(1)+MFFT3*MDIV(1)*MDIV(2)
	ARHO=DREAL(RHORS(IFFT,1,1)+RHORS(IFFT,NSPIN,1))*SFACT
	ZMAG=DREAL(RHORS(IFFT,1,1)-RHORS(IFFT,NSPIN,1))
	AMAG=SQRT(ZMAG*ZMAG)
	AMS( 0)=RHORS(IFFT,1,1)-RHORS(IFFT,NSPIN,1)
	AMS(-1)=(0.D0,0.D0)
	AMS(+1)=(0.D0,0.D0)
	IF(NORBS.EQ.2)THEN
	AMS(-1)=RHORS(IFFT,1,NORBS)
	AMS(+1)=RHORS(IFFT,2,NORBS)
	AMC(1)=(AMS(-1)-AMS(+1))/SQRT(2.D0)
	AMC(2)=(AMS(-1)+AMS(+1))/SQRT(2.D0)*(0.D0,-1.D0) ! since it is M^{+/-}
	AMC(3)= AMS(0)
	AMAG=SQRT(DCONJG(AMC(1))*AMC(1)+
     &          DCONJG(AMC(2))*AMC(2)+
     &          DCONJG(AMC(3))*AMC(3))
	ENDIF
	DARHO=SFACT*(DRHORS(IFFT,1,1)+DRHORS(IFFT,NSPIN,1))
C Changes in magnetization
	DZMAG=DRHORS(IFFT,1,1)-DRHORS(IFFT,NSPIN,1)
	DAMAG=(0.D0,0.D0)
	IF(ABS(AMAG).GT.1.D-14)
     &DAMAG=ZMAG/AMAG*DZMAG
	IF(NORBS.EQ.2.AND.ABS(AMAG).GT.1.D-14)THEN
	DMS( 0)=DRHORS(IFFT,1,1)-DRHORS(IFFT,NSPIN,1)
	DMS(-1)=DRHORS(IFFT,1,NORBS)
	DMS(+1)=DRHORS(IFFT,NSPIN,NORBS)
	DMC(1)=(DMS(-1)-DMS(+1))/SQRT(2.D0)
	DMC(2)=(DMS(-1)+DMS(+1))/SQRT(2.D0)*(0.D0,-1.D0) ! since it is M^{+/-}
	DMC(3)= DMS(0)
	DAMAG=AMC(1)*DMC(1)/AMAG+AMC(2)*DMC(2)/AMAG+AMC(3)*DMC(3)/AMAG
C	DAMAG=ZMAG                     /AMAG*DZMAG               +
C    &DCONJG(RHORS(IFFT,    1,NORBS))/AMAG*DRHORS(IFFT,1,NORBS)+
C    &DCONJG(RHORS(IFFT,NSPIN,NORBS))/AMAG*DRHORS(IFFT,NSPIN,NORBS)
	ENDIF
C Spin densities
	IF(ILSD.EQ.1)THEN
	ROUP=0.5D0*(ARHO+AMAG)
	RODN=0.5D0*(ARHO-AMAG)
	ELSEIF(ILSD.EQ.0)THEN
	ROUP=0.5D0*ARHO
	RODN=0.5D0*ARHO
	ENDIF
C Changes in spin densities
	IF(ILSD.EQ.1)THEN
	DUPDN(1)=    0.5D0*(DARHO+DAMAG)/SFACT
	DUPDN(NSPIN)=0.5D0*(DARHO-DAMAG)/SFACT
	ELSEIF(ILSD.EQ.0)THEN
	DUPDN(1)=    0.5D0*DARHO/SFACT
	DUPDN(NSPIN)=0.5D0*DARHO/SFACT
	ENDIF
C Spin gradients
      IF(IGGA.NE.0)THEN
	DO IA=1,3
	GR1RHO(IA)=(G1RHO(IFFT,1,1,IA)+G1RHO(IFFT,NSPIN,1,IA))*SFACT
	GR1MAG(IA,0)=(G1RHO(IFFT,1,1,IA)-G1RHO(IFFT,NSPIN,1,IA))
	GR1MAG(IA,-1)=(0.D0,0.D0)
	GR1MAG(IA,+1)=(0.D0,0.D0)
	IF(NORBS.EQ.2)THEN
	GR1MAG(IA,-1)=G1RHO(IFFT,1,NORBS,IA)
	GR1MAG(IA,+1)=G1RHO(IFFT,2,NORBS,IA)
	ENDIF
	ENDDO
	DO IA=1,3
	DO IB=1,3
	GR2RHO(IA,IB)=(G2RHO(IFFT,1,1,IA,IB)+G2RHO(IFFT,NSPIN,1,IA,IB))*
     &SFACT
	GR2MAG(IA,IB,0 )=G2RHO(IFFT,1,1,IA,IB)-G2RHO(IFFT,NSPIN,1,IA,IB)
	GR2MAG(IA,IB,-1)=(0.D0,0.D0)
	GR2MAG(IA,IB,+1)=(0.D0,0.D0)
	IF(NORBS.EQ.2)THEN
	GR2MAG(IA,IB,-1)=G2RHO(IFFT,1,NORBS,IA,IB)
	GR2MAG(IA,IB,+1)=G2RHO(IFFT,2,NORBS,IA,IB)
	ENDIF
	ENDDO
	ENDDO
C
	IF(ABS(AMAG).GT.1.D-14)RMAG=1.D0/AMAG
	IF(ABS(AMAG).LE.1.D-14)RMAG=0.D0
	DO IA=1,3
	GR1MOD(IA)=(0.D0,0.D0)
	DO IB=-1,1
	GR1MOD(IA)=GR1MOD(IA)+0.5D0*(DCONJG(AMS(IB))*GR1MAG(IA,IB)+
     &AMS(IB)*DCONJG(GR1MAG(IA,IB)))*RMAG
	ENDDO
	ENDDO
	DO IA=1,3
	DO IB=1,3
	GR2MOD(IA,IB)=-GR1MOD(IA)*GR1MOD(IB)*RMAG
	DO IC=-1,1
	GR2MOD(IA,IB)=GR2MOD(IA,IB)+0.5D0*RMAG*(
     &DCONJG(GR1MAG(IB,IC))*GR1MAG(IA,IC)+
     &DCONJG(GR1MAG(IA,IC))*GR1MAG(IB,IC)+
     &DCONJG(AMS(IC))*GR2MAG(IA,IB,IC)+
     &AMS(IC)*DCONJG(GR2MAG(IA,IB,IC)))
	ENDDO
	ENDDO
	ENDDO
C
	ALRUP=0.D0
	ALRDN=0.D0
	DO IA=1,3
	IF(ILSD.EQ.1)THEN
	GR1UP(IA)=0.5D0*(GR1RHO(IA)+GR1MOD(IA))
	GR1DN(IA)=0.5D0*(GR1RHO(IA)-GR1MOD(IA))
	ELSEIF(ILSD.EQ.0)THEN
	GR1UP(IA)=0.5D0*GR1RHO(IA)
	GR1DN(IA)=0.5D0*GR1RHO(IA)
	ENDIF
	DO IB=1,3
	IF(ILSD.EQ.1)THEN
	GR2UP(IA,IB)=0.5D0*(GR2RHO(IA,IB)+GR2MOD(IA,IB))
	GR2DN(IA,IB)=0.5D0*(GR2RHO(IA,IB)-GR2MOD(IA,IB))
	ELSEIF(ILSD.EQ.0)THEN
	GR2UP(IA,IB)=0.5D0*GR2RHO(IA,IB)
	GR2DN(IA,IB)=0.5D0*GR2RHO(IA,IB)
	ENDIF
	ENDDO
	ALRUP=ALRUP+GR2UP(IA,IA)
	ALRDN=ALRDN+GR2DN(IA,IA)
	ENDDO
      ENDIF
C Original Exchange correlation
      CALL POT_EXCVXC(ROUP,RODN,GR1UP,GR1DN,GR2UP,GR2DN,ALRUP,ALRDN,
     &            ILDA,IGGA,KEY,NSPIN,EXCUP,EXCDN,VXCUP,VXCDN)
	    IF(KEY.EQ.1.AND.ILSD.EQ.1)THEN
	XC(1)=VXCUP
	XC(2)=VXCDN
	ELSEIF(KEY.EQ.1.AND.ILSD.EQ.0)THEN
	XC(1)=0.5D0*(VXCUP+VXCDN)
	XC(2)=0.5D0*(VXCUP+VXCDN)
	ELSEIF(KEY.EQ.2.AND.ILSD.EQ.1)THEN
	XC(1)=EXCUP
	XC(2)=EXCDN
	ELSEIF(KEY.EQ.2.AND.ILSD.EQ.0)THEN
	XC(1)=0.5D0*(EXCUP+EXCDN)
	XC(2)=0.5D0*(EXCUP+EXCDN)
	ENDIF
C Change due to density
      DO IORBS=1,NORBS
      DO IUPDN=1,NSPIN
	DVXCRS(IFFT,IUPDN,IORBS)=(0.D0,0.D0)
	ENDDO
	ENDDO
      DO JUPDN=1,NSPIN
      CALL POT_DEXCVXC(ROUP,RODN,GR1UP,GR1DN,GR2UP,GR2DN,ALRUP,
     &ALRDN,ILDA,IGGA,JUPDN,KEY,NSPIN,DEXCUP,DEXCDN,DVXCUP,DVXCDN)
	    IF(KEY.EQ.1.AND.ILSD.EQ.1)THEN
	DXC(1)=DVXCUP
	DXC(2)=DVXCDN
	ELSEIF(KEY.EQ.1.AND.ILSD.EQ.0)THEN
	DXC(1)=0.5D0*(DVXCUP+DVXCDN)
	DXC(2)=0.5D0*(DVXCUP+DVXCDN)
	ELSEIF(KEY.EQ.2.AND.ILSD.EQ.1)THEN
	DXC(1)=DEXCUP
	DXC(2)=DEXCDN
	ELSEIF(KEY.EQ.2.AND.ILSD.EQ.0)THEN
	DXC(1)=0.5D0*(DEXCUP+DEXCDN)
	DXC(2)=0.5D0*(DEXCUP+DEXCDN)
	ENDIF
      DO IUPDN=1,NSPIN
      DVXCRS(IFFT,IUPDN,1)=DVXCRS(IFFT,IUPDN,1)+
     &  0.5D0*(DXC(1)+DXC(NSPIN))*DUPDN(JUPDN)
	IF(ABS(AMAG).GT.1.D-14)
     &DVXCRS(IFFT,IUPDN,1)=DVXCRS(IFFT,IUPDN,1)+
     &(-1)**(IUPDN+1)*0.5D0*(DXC(1)-DXC(NSPIN))*DUPDN(JUPDN)*
     &ZMAG/AMAG
	IF(NORBS.EQ.2.AND.ABS(AMAG).GT.1.D-14)
     &DVXCRS(IFFT,IUPDN,NORBS)=DVXCRS(IFFT,IUPDN,NORBS)+
     &0.5D0*(DXC(1)-DXC(NSPIN))*DUPDN(JUPDN)*
     &RHORS(IFFT,IUPDN,NORBS)/AMAG
      ENDDO
      ENDDO
C Change due to field direction should be absent !
C     DO IUPDN=1,NSPIN
C	IF(NORBS.EQ.2.AND.ABS(AMAG).GT.1.D-14)
C    &DVXCRS(IFFT,IUPDN,1)=DVXCRS(IFFT,IUPDN,1)+
C    &(-1)**(IUPDN+1)*0.5D0*(XC(1)-XC(NSPIN))*
C    &(DZMAG/AMAG-ZMAG/AMAG*DAMAG/AMAG)
C	IF(NORBS.EQ.2.AND.ABS(AMAG).GT.1.D-14)
C    &DVXCRS(IFFT,IUPDN,NORBS)=DVXCRS(IFFT,IUPDN,NORBS)+
C    &(XC(1)-XC(NSPIN))*(DRHORS(IFFT,IUPDN,NORBS)/AMAG-
C    &RHORS(IFFT,IUPDN,NORBS)/AMAG*DAMAG/AMAG)
C     ENDDO
C Change due to gradients
      IF(IGGA.NE.0)THEN
      DO JUPDN=1,NSPIN
      CALL POT_GEXCVXC(ROUP,RODN,GR1UP,GR1DN,GR2UP,GR2DN,ALRUP,
     &ALRDN,ILDA,IGGA,JUPDN,KEY,NSPIN,GEXCUP,GEXCDN,GVXCUP,GVXCDN)
      DO IA=1,3
	    IF(KEY.EQ.1.AND.ILSD.EQ.1)THEN
	DXC(1)=GVXCUP(IA)
	DXC(2)=GVXCDN(IA)
	ELSEIF(KEY.EQ.1.AND.ILSD.EQ.0)THEN
	DXC(1)=0.5D0*(GVXCUP(IA)+GVXCDN(IA))
	DXC(2)=0.5D0*(GVXCUP(IA)+GVXCDN(IA))
	ELSEIF(KEY.EQ.2.AND.ILSD.EQ.1)THEN
	DXC(1)=GEXCUP(IA)
	DXC(2)=GEXCDN(IA)
	ELSEIF(KEY.EQ.2.AND.ILSD.EQ.0)THEN
	DXC(1)=0.5D0*(GEXCUP(IA)+GEXCDN(IA))
	DXC(2)=0.5D0*(GEXCUP(IA)+GEXCDN(IA))
	ENDIF
      DO IUPDN=1,NSPIN
      DVXCRS(IFFT,IUPDN,1)=DVXCRS(IFFT,IUPDN,1)+
     &  0.5D0*(DXC(1)+DXC(NSPIN))*DG1RHO(IFFT,JUPDN,1,IA)
	IF(ABS(AMAG).GT.1.D-14)
     &DVXCRS(IFFT,IUPDN,1)=DVXCRS(IFFT,IUPDN,1)+
     &(-1)**(IUPDN+1)*0.5D0*(DXC(1)-DXC(NSPIN))*ZMAG/AMAG*
     &DG1RHO(IFFT,JUPDN,1,IA)
	IF(NORBS.EQ.2.AND.ABS(AMAG).GT.1.D-14)
     &DVXCRS(IFFT,IUPDN,NORBS)=DVXCRS(IFFT,IUPDN,NORBS)+
     &0.5D0*(DXC(1)-DXC(NSPIN))*RHORS(IFFT,IUPDN,NORBS)/AMAG*
     &DG1RHO(IFFT,JUPDN,1,IA)
      ENDDO
      ENDDO
      ENDDO
      ENDIF
C Change due to second gradients
      IF(IGGA.NE.0.AND.KEY.EQ.1)THEN
      DO JUPDN=1,NSPIN
      CALL POT_G2VXC(ROUP,RODN,GR1UP,GR1DN,GR2UP,GR2DN,ALRUP,
     &  ALRDN,ILDA,IGGA,JUPDN,KEY,NSPIN,DVXC2UP,DVXC2DN,DVXCLUP,DVXCLDN)
      DO IA1=1,3 
      DO IA =1,3
	    IF(KEY.EQ.1.AND.ILSD.EQ.1)THEN
	DXC(1)=DVXC2UP(IA,IA1)
	DXC(2)=DVXC2DN(IA,IA1)
	ELSEIF(KEY.EQ.1.AND.ILSD.EQ.0)THEN
	DXC(1)=0.5D0*(DVXC2UP(IA,IA1)+DVXC2DN(IA,IA1))
	DXC(2)=0.5D0*(DVXC2UP(IA,IA1)+DVXC2DN(IA,IA1))
	ENDIF
      DO IUPDN=1,NSPIN
      DVXCRS(IFFT,IUPDN,1)=DVXCRS(IFFT,IUPDN,1)+
     &  0.5D0*(DXC(1)+DXC(NSPIN))*DG2RHO(IFFT,JUPDN,1,IA,IA1)
	IF(ABS(AMAG).GT.1.D-14)
     &DVXCRS(IFFT,IUPDN,1)=DVXCRS(IFFT,IUPDN,1)+
     &(-1)**(IUPDN+1)*0.5D0*(DXC(1)-DXC(NSPIN))*ZMAG/AMAG*
     &DG2RHO(IFFT,JUPDN,1,IA,IA1)
	IF(NORBS.EQ.2.AND.ABS(AMAG).GT.1.D-14)
     &DVXCRS(IFFT,IUPDN,NORBS)=DVXCRS(IFFT,IUPDN,NORBS)+
     &0.5D0*(DXC(1)-DXC(NSPIN))*RHORS(IFFT,IUPDN,NORBS)/AMAG*
     &DG2RHO(IFFT,JUPDN,1,IA,IA1)
      ENDDO
      ENDDO
      ENDDO
	    IF(KEY.EQ.1.AND.ILSD.EQ.1)THEN
	DXC(1)=DVXCLUP
	DXC(2)=DVXCLDN
	ELSEIF(KEY.EQ.1.AND.ILSD.EQ.0)THEN
	DXC(1)=0.5D0*(DVXCLUP+DVXCLDN)
	DXC(2)=0.5D0*(DVXCLUP+DVXCLDN)
	ENDIF
	DO IUPDN=1,NSPIN
      DVXCRS(IFFT,IUPDN,1)=DVXCRS(IFFT,IUPDN,1)+
     &0.5D0*(DXC(1)+DXC(NSPIN))*
     &           (DG2RHO(IFFT,JUPDN,1,1,1)+
     &            DG2RHO(IFFT,JUPDN,1,2,2)+
     &            DG2RHO(IFFT,JUPDN,1,3,3))
	IF(ABS(AMAG).GT.1.D-14)
     &DVXCRS(IFFT,IUPDN,1)=DVXCRS(IFFT,IUPDN,1)+
     &(-1)**(IUPDN+1)*0.5D0*(DXC(1)-DXC(NSPIN))*ZMAG/AMAG*
     &           (DG2RHO(IFFT,JUPDN,1,1,1)+
     &            DG2RHO(IFFT,JUPDN,1,2,2)+
     &            DG2RHO(IFFT,JUPDN,1,3,3))
	IF(NORBS.EQ.2.AND.ABS(AMAG).GT.1.D-14)
     &DVXCRS(IFFT,IUPDN,NORBS)=DVXCRS(IFFT,IUPDN,NORBS)+
     &0.5D0*(DXC(1)-DXC(NSPIN))*RHORS(IFFT,IUPDN,NORBS)/AMAG*
     &           (DG2RHO(IFFT,JUPDN,1,1,1)+
     &            DG2RHO(IFFT,JUPDN,1,2,2)+
     &            DG2RHO(IFFT,JUPDN,1,3,3))
      ENDDO
      ENDDO
      ENDIF
1000	CONTINUE                                !!! over mfft1
2000	CONTINUE                                !!! over mfft2
3000	CONTINUE                                !!! over mfft3
C  GET EXCHANGE-CORRELATION POTENTIAL BY RECIPROCAL FOURIER TRANSFORM
      DO IORBS=1,NORBS
      DO IUPDN=1,NSPIN
      CALL POT_FTRANSR(DPOTPS(0,IUPDN,IORBS),DVXCRS(1,IUPDN,IORBS),
     &TMPARR,QPNT(1,IQPNT))
      ENDDO
      ENDDO
C Memory deallocations
	DEALLOCATE(DUPDN,RHORS,DRHORS)
	DEALLOCATE(G1RHO,G2RHO,DG1RHO,DG2RHO,DVXCRS,TMPARR)
	END
