	SUBROUTINE DPT_GRADPOT(IQPNT)
*****************************************************************
*  Calculates gradient for the ground-state potential.          * 
*****************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
      USE COM_PHNCOM,  ONLY : ITERMAX,NITER                              !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
     &                       ,NHSORT
	USE COM_RADMESH, ONLY : NRAD,H,R,DR,WEIGHT,RL                      !!! from radmsh
	USE COM_LATPAR,  ONLY : PAR,ORTH,OMEGAC                            !!! from readini
	USE COM_QMESH,   ONLY : NQPNT,QPNT                                 !!! from readpnt
	USE COM_POTDAT,  ONLY : POT,POTSPH                                 !!! from fulpot
	USE COM_SPHERE,  ONLY : SWZ,SMT,ZNUC,ZCOR                          !!! from readini
	USE COM_SYMMLM,  ONLY : SYM,LMSYM                                  !!! from makesym
	USE COM_GAUNT,   ONLY : C                                          !!! from makegnt
	USE COM_DELPOT,  ONLY : DPOT,GPOT                                  !!! from delpot
	USE COM_MASHDEP, ONLY : NVAL                                       !!! from setup
	USE COM_PHNCHN  ,ONLY : IUDSV,IUDPV                                !!! from channels
	USE COM_POTMTS,  ONLY : VMT0,VMT,VSF0,VSF                          !!! from vzero
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: WORK1(:)
	COMPLEX*16, ALLOCATABLE :: WORK2(:)
	COMPLEX*16, ALLOCATABLE :: DVDR(:,:)
	COMPLEX*16, ALLOCATABLE :: DVLMDR(:)
	COMPLEX*16, ALLOCATABLE :: VR2(:,:)
	COMPLEX*16 CGNT
	DATA PI/3.141592653589793D0/
C Memory allocations
	ALLOCATE(DVDR(0:NRADMEM,NSYMMEM))
	ALLOCATE(DVLMDR(0:NRADMEM))
	ALLOCATE(VR2(0:NRADMEM,NSYMMEM))
	ALLOCATE(WORK1(0:NRADMEM))
	ALLOCATE(WORK2(0:NRADMEM))
	SQPI4=2.D0*SQRT(PI)
C  *** CALCULATE GRADIENT OF THE POTENTIAL
	DO 2000 INUC=1,NATOM                       !!! over displacements
	DO 1000 MY=-1,1                            !!! over poalrizations
	IF(NITER(MY,INUC).EQ.0)GOTO1000
      CALL DPT_DSVFILES(MY,INUC,IQPNT,IUDSV,'I',' ',' ')
	IATOM=INUC
	ISORT=IS(INUC)
	DO 600 IORBS=1,NORBS                       !!! over iorbs
	DO 500 IUPDN=1,NSPIN                       !!! over spins
	DO L=0,ILSV(ISORT)                         !!! over l
	DO M=-L,L                                  !!! over m
	LM=L*(L+1)+M+1
	IF(SYM(LM,INUC))THEN
	ISYM=LMSYM(LM,INUC)
	IF(ISYM.NE.1)THEN
	DO IRAD=0,NRAD(ISORT)
	WORK1(IRAD)=POT(IRAD,ISYM,INUC,IUPDN,IORBS)
	ENDDO
     	CALL LIB_DRSUB(WORK1,WORK2,NRAD(ISORT),H(ISORT),
     &R(0,ISORT),DR(0,ISORT))
	DO IRAD=0,NRAD(ISORT)
	DVDR(IRAD,ISYM)=WORK2(IRAD)*R(IRAD,ISORT)**2
	VR2(IRAD,ISYM)=POT(IRAD,ISYM,INUC,IUPDN,IORBS)*R(IRAD,ISORT)
	ENDDO
	ELSEIF(ISYM.EQ.1)THEN
      WORK1(0)=2.D0*ZNUC(ISORT)
      DO IRAD=1,NRAD(ISORT)
      WORK1(IRAD)=-R(IRAD,ISORT)*POT(IRAD,1,INUC,IUPDN,IORBS)/
     &SQRT(4.D0*PI)
	ENDDO
      CALL LIB_DRSUB(WORK1,WORK2,NRAD(ISORT),H(ISORT),
     &R(0,ISORT),DR(0,ISORT))
      DVDR(0,ISYM)=2.D0*ZNUC(ISORT)*SQPI4
      VR2(0,ISYM)=-2.D0*ZNUC(ISORT)*SQPI4
      DO IRAD=1,NRAD(ISORT)
      DVDR(IRAD,ISYM)=-R(IRAD,ISORT)*POT(IRAD,1,INUC,IUPDN,IORBS)-
     &WORK2(IRAD)*R(IRAD,ISORT)*SQPI4
      VR2(IRAD,ISYM)=R(IRAD,ISORT)*POT(IRAD,1,INUC,IUPDN,IORBS)
	ENDDO
      ENDIF
      ENDIF
      ENDDO                                      !!! over m
      ENDDO                                      !!! over l
	DO L=0,ILSV(ISORT)                         !!! over l
	DO M=-L,L                                  !!! over m
	LM=L*(L+1)+M+1
	LMMY=(L-1)*L+M-MY+1
	LMPY=(L+1)*(L+2)+M-MY+1
	DO IRAD=0,NRAD(ISORT)                      !!! over radial mesh
	DVLMDR(IRAD)=(0.D0,0.D0)
	IF(L.GT.0.AND.ABS(M-MY).LE.L-1)THEN
	IF(SYM(LMMY,INUC))THEN
	ISYMMY=LMSYM(LMMY,INUC)
	CGNT=(0.D0,-1.D0)*SQRT(4.D0*PI/3.D0)*C(0,LM,LMMY)
	DVLMDR(IRAD)=DVLMDR(IRAD)+CGNT*(DVDR(IRAD,ISYMMY)-
     &  DBLE(L-1)*VR2(IRAD,ISYMMY))
	ENDIF
	ENDIF
	IF(L.LT.ILSV(ISORT))THEN
	IF(SYM(LMPY,INUC))THEN
	ISYMPY=LMSYM(LMPY,INUC)
	CGNT=(0.D0,+1.D0)*SQRT(4.D0*PI/3.D0)*C(0,LM,LMPY)
	DVLMDR(IRAD)=DVLMDR(IRAD)+CGNT*(DVDR(IRAD,ISYMPY)+
     &DBLE(L+2)*VR2(IRAD,ISYMPY))
	ENDIF
	ENDIF
      ENDDO                                      !!! over radial mesh
	DO IRAD=1,NRAD(ISORT)                      !!! over radial mesh
	GPOT(IRAD,LM,IATOM,IUPDN,IORBS)=DVLMDR(IRAD)/R(IRAD,ISORT)**2
      ENDDO                                      !!! over radial mesh
	IF(LM.LE.9)
     &GPOT(0,LM,IATOM,IUPDN,IORBS)=GPOT(1,LM,IATOM,IUPDN,IORBS)
	IF(LM.GT.9)
     &GPOT(0,LM,IATOM,IUPDN,IORBS)=(0.D0,0.D0)
      ENDDO                                      !!! over m
      ENDDO                                      !!! over l
 500	CONTINUE                                   !!! over spins
 600	CONTINUE                                   !!! over iorbs
C STORE POTENTIAL GRADIENT
      CALL DPT_DSVFILES(MY,INUC,IQPNT,IUDSV,'W','G',' ')
1000	CONTINUE                                   !!! over polarizations
2000	CONTINUE                                   !!! over displacements
C Memory deallocations
	DEALLOCATE(DVDR,DVLMDR,VR2,WORK1,WORK2)
	END
