	SUBROUTINE DPT_DSVFILES(MY,INUC,IQPNT,ICHN,TOPER,TDPOT,AOPER)
************************************************************
*  Reads/writes/initializes induced potential in channel36 *
*  TOPER='R'ead, 'W'rite, or 'I'nitialize                  *
*  TDPOT='D'pot, 'G'pot                                    *
*  ICHN=36 for permanent/scratch storage.                  *
************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
      USE COM_PHNCOM,  ONLY : ITERMAX,NITER                              !!! from readini
	USE COM_QMESH,   ONLY : NQPNT,QPNT                                 !!! from readpnt
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
     &                       ,NHSORT
	USE COM_RADMESH, ONLY : NRAD,H,R                                   !!! from makerad
	USE COM_SPHERE,  ONLY : SWZ,SMT                                    !!! from readini
	USE COM_DELPOT,  ONLY : DPOT,GPOT                                  !!! from delpot
	USE COM_MASHDEP, ONLY : NVAL                                       !!! from setup
	USE COM_OLDMESH, ONLY : NRAD0,ROLD                                 !!! from drofiles
      USE COM_DELHUB,  ONLY : DELVHUB,DELVRAT,DELWRAT,DELPRAT,DELORAT    !!! from plzfiles
	USE COM_PHNCHN  ,ONLY : IUDSV,IUDPV                                !!! from channels
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	USE COM_LMTOUT
	USE COM_PHNOUT
	IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER, ALLOCATABLE :: ILSV0(:)
	COMPLEX*16, ALLOCATABLE :: DELWHUB(:,:,:,:)
	CHARACTER TDPOT*1,TOPER*1,AOPER*1,STATUS*3,DFILE*130
	LOGICAL EXIST,LDPOT,LGPOT,NDPOT,NGPOT
	DIMENSION QPNT0(3)
	IF(TOPER.NE.' ')THEN
      IF(ICDSV.GT.0)DFILE=DSVFILE(MY,INUC)
      IF(ICDSV.EQ.0)DFILE=SCNFILE(MY,INUC,ICHN)
      INQUIRE(FILE=DFILE,EXIST=EXIST)
	IF(.NOT.EXIST)STATUS='NEW'
	IF(     EXIST)STATUS='OLD'
	ENDIF
C Allocate data
	IF(AOPER.EQ.'A')THEN
	ALLOCATE(DPOT(0:NRADMEM,LIMVMEM,NATOMMEM,NSPINMEM,NORBSMEM))
	ALLOCATE(GPOT(0:NRADMEM,LIMVMEM,NATOMMEM,NSPINMEM,NORBSMEM))
	ALLOCATE(DELVHUB(LIMB2MEM,NATOMMEM,NSPINMEM,NORBSMEM))
	ALLOCATE(DELVRAT(LIMB2MEM,NATOMMEM,NSPINMEM,NORBSMEM,NPOLMEM))
	ALLOCATE(DELWRAT(LIMB2MEM,NATOMMEM,NSPINMEM,NORBSMEM,NPOLMEM))
	ALLOCATE(DELPRAT(LIMB2MEM,NATOMMEM,NSPINMEM,NORBSMEM,NPOLMEM))
	ALLOCATE(DELORAT(LIMB2MEM,NATOMMEM,NSPINMEM,NORBSMEM,NPOLMEM))
	IF(.NOT.ALLOCATED(ROLD))ALLOCATE(ROLD(0:NRADMEM,NSORTMEM))
	IF(.NOT.ALLOCATED(NRAD0))ALLOCATE(NRAD0(NSORTMEM))
	ENDIF
C *** DELETE FILE
	IF(TOPER.EQ.'D')THEN
      OPEN(UNIT=ICHN,FILE=DFILE,STATUS=STATUS,
     &FORM='UNFORMATTED',ACCESS='SEQUENTIAL')
	CLOSE(UNIT=ICHN,STATUS='DELETE')
	RETURN
	ENDIF
C Memory allocations
	ALLOCATE(DELWHUB(LIMB2MEM,NATOMMEM,NSPINMEM,NORBSMEM))
	ALLOCATE(ILSV0(NSORTMEM))
C *** READ DATA FROM DSVFILE OR SCNFILE
	IF(TOPER.NE.'I'.AND.TOPER.NE.' ')THEN
      IF(.NOT.EXIST)
     &CALL FULLSTOP('<DSVFILES>: FILE MUST EXIST!')
      OPEN(UNIT=ICHN,FILE=DFILE,STATUS='OLD',
     &FORM='UNFORMATTED',ACCESS='SEQUENTIAL')
C Read control information:
      READ(ICHN)NATOM0,NSORT0,NSPIN0,NORBS0,
     &(NRAD0(ISORT),ISORT=1,NSORT0),
     &(ILSV0(ISORT),ISORT=1,NSORT0),(QPNT0(I),I=1,3)
      READ(ICHN)((ROLD(IRAD,ISORT),IRAD=0,NRAD0(ISORT)),ISORT=1,NSORT) 
      IF(NATOM0.NE.NATOM)
     &CALL FULLSTOP('<DSVFILES>: # OF ATOMS MISMATCH')
      IF(NSORT0.NE.NSORT)
     &CALL FULLSTOP('<DSVFILES>: # OF SORTS MISMATCH')
      IF(NSPIN0.NE.NSPIN)
     &CALL FULLSTOP('<DSVFILES>: # OF SPINS MISMATCH')
      IF(NORBS0.NE.NORBS)
     &CALL FULLSTOP('<DSVFILES>: # OF NORBS MISMATCH')
	DO ISORT=1,NSORT
	IF(NRAD0(ISORT).GT.NRADMEM)
     &CALL FULLSTOP('<DSVFILES>:: NRAD0>NRADMAX')
	IF(ILSV0(ISORT).GT.LMAXVMEM)
     &CALL FULLSTOP('<DSVFILES>:: ILSV0>LMAXV  ')
	ENDDO
C Understand what to read:
	LDPOT=(TOPER.EQ.'R'.AND.TDPOT.EQ.'D')
	LGPOT=(TOPER.EQ.'R'.AND.TDPOT.EQ.'G')
	LDPOT=(TOPER.EQ.'W'.AND.TDPOT.NE.'D').OR.LDPOT
	LGPOT=(TOPER.EQ.'W'.AND.TDPOT.NE.'G').OR.LGPOT
	NDPOT=.NOT.LDPOT
	NGPOT=.NOT.LGPOT
C Read change in the potential
      DO IATOM=1,NATOM                           !!! over atoms
      ISORT=IS(IATOM)
	LGPOT=LGPOT.AND.IATOM.EQ.INUC
	NGPOT=NGPOT.AND.IATOM.EQ.INUC
      DO IORBS=1,NORBS                           !!! over iorbs
      DO ISPIN=1,NSPIN                           !!! over spins
      IF(LDPOT)READ(ICHN)((DPOT(IRAD,LM,IATOM,ISPIN,IORBS),
     &IRAD=0,NRAD0(ISORT)),LM=1,(ILSV0(ISORT)+1)**2)
	IF(NDPOT)READ(ICHN)
      IF(LGPOT)READ(ICHN)((GPOT(IRAD,LM,IATOM,ISPIN,IORBS),
     &IRAD=0,NRAD0(ISORT)),LM=1,(ILSV0(ISORT)+1)**2)
	IF(NGPOT)READ(ICHN)
      IF(LDPOT)READ(ICHN)(DELVHUB(IU,IATOM,ISPIN,IORBS),
     &  IU=1,(ILSB(ISORT)+1)*(2*ILSB(ISORT)+1)*(2*ILSB(ISORT)+3)/3)
	IF(NDPOT)READ(ICHN)
      IF(LGPOT)READ(ICHN)(DELWHUB(IU,IATOM,ISPIN,IORBS),
     &  IU=1,(ILSB(ISORT)+1)*(2*ILSB(ISORT)+1)*(2*ILSB(ISORT)+3)/3)
	IF(NGPOT)READ(ICHN)
      DO IPOL=1,NPOLMEM
      IF(LDPOT)READ(ICHN)(DELVRAT(IU,IATOM,ISPIN,IORBS,IPOL),
     &  IU=1,(ILSB(ISORT)+1)*(2*ILSB(ISORT)+1)*(2*ILSB(ISORT)+3)/3)
      IF(LDPOT)READ(ICHN)(DELWRAT(IU,IATOM,ISPIN,IORBS,IPOL),
     &  IU=1,(ILSB(ISORT)+1)*(2*ILSB(ISORT)+1)*(2*ILSB(ISORT)+3)/3)
      IF(LDPOT)READ(ICHN)(DELPRAT(IU,IATOM,ISPIN,IORBS,IPOL),
     &  IU=1,(ILSB(ISORT)+1)*(2*ILSB(ISORT)+1)*(2*ILSB(ISORT)+3)/3)
      IF(LDPOT)READ(ICHN)(DELORAT(IU,IATOM,ISPIN,IORBS,IPOL),
     &  IU=1,(ILSB(ISORT)+1)*(2*ILSB(ISORT)+1)*(2*ILSB(ISORT)+3)/3)
	IF(NDPOT)READ(ICHN)
	IF(NDPOT)READ(ICHN)
	IF(NDPOT)READ(ICHN)
	IF(NDPOT)READ(ICHN)
      ENDDO
C Set zeroes for higher l's
	DO L=ILSV0(ISORT)+1,ILSV(ISORT)
	DO M=-L,L
	LM=L*(L+1)+M+1
	DO IRAD=0,NRAD0(ISORT)
	IF(LDPOT)DPOT(IRAD,LM,IATOM,ISPIN,IORBS)=(0.D0,0.D0)
	IF(LGPOT)GPOT(IRAD,LM,IATOM,ISPIN,IORBS)=(0.D0,0.D0)
	ENDDO
	ENDDO
	ENDDO
	ENDDO                                      !!! over spins
	ENDDO                                      !!! over iorbs
	ENDDO                                      !!! over atoms
	CLOSE(ICHN)
	ENDIF
C **** INITIALIZE CHANGE IN THE POTENTIAL
	IF(TOPER.EQ.'I')THEN
	LDPOT=.TRUE.
	LGPOT=.TRUE.
	DO IATOM=1,NATOM                           !!! over atoms
	ISORT=IS(IATOM)
	LGPOT=LGPOT.AND.IATOM.EQ.INUC
	DO IORBS=1,NORBS                           !!! over iorbs
	DO ISPIN=1,NSPIN                           !!! over spins
	DO L=0,ILSV(ISORT)
	DO M=-L,L
	LM=L*(L+1)+M+1
	DO IRAD=0,NRAD(ISORT)
	IF(LDPOT)DPOT(IRAD,LM,IATOM,ISPIN,IORBS)=(0.D0,0.D0)
	IF(LGPOT)GPOT(IRAD,LM,IATOM,ISPIN,IORBS)=(0.D0,0.D0)
	ENDDO
	ENDDO
	ENDDO
	ENDDO                                      !!! over spins
	ENDDO                                      !!! over iorbs
	ENDDO                                      !!! over atoms
	DO IORBS=1,NORBS                           !!! over spins
	DO ISPIN=1,NSPIN                           !!! over spins
	DO IATOM=1,NATOM                           !!! over atoms
	ISORT=IS(IATOM) 
	DO L=0,ILSB(ISORT)                         !!! over l
      DO M1=-L,L                                 !!! over m1
      LM1=L*(L+1)+M1+1
      DO M=-L,L                                  !!! over m
      LM=L*(L+1)+M+1
      IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M1+1 ! ! (l,m'm)
      IF(LDPOT)DELVHUB(IU,IATOM,ISPIN,IORBS)=(0.D0,0.D0)
      IF(LGPOT)DELWHUB(IU,IATOM,ISPIN,IORBS)=(0.D0,0.D0)
      DO IPOL=1,NPOLMEM
      IF(LDPOT)DELVRAT(IU,IATOM,ISPIN,IORBS,IPOL)=(0.D0,0.D0)
      IF(LDPOT)DELWRAT(IU,IATOM,ISPIN,IORBS,IPOL)=(0.D0,0.D0)
      IF(LDPOT)DELPRAT(IU,IATOM,ISPIN,IORBS,IPOL)=(0.D0,0.D0)
      IF(LDPOT)DELORAT(IU,IATOM,ISPIN,IORBS,IPOL)=(0.D0,0.D0)
      ENDDO
	ENDDO                                      !!! over m1
      ENDDO                                      !!! over m
      ENDDO                                      !!! over l
      ENDDO                                      !!! over atoms
	ENDDO                                      !!! over spins
      ENDDO                                      !!! over iorbs
	ENDIF
C **** STORE DATA IN DSVFILE OR SCNFILE
	IF(TOPER.NE.'R'.AND.TOPER.NE.' ')THEN
	OPEN(UNIT=ICHN,FILE=DFILE,STATUS=STATUS,
     &FORM='UNFORMATTED',ACCESS='SEQUENTIAL')
	CLOSE(UNIT=ICHN,STATUS='DELETE')
	OPEN(UNIT=ICHN,FILE=DFILE,STATUS='NEW',
     &FORM='UNFORMATTED',ACCESS='SEQUENTIAL')
C Store control information:
      WRITE(ICHN)NATOM,NSORT,NSPIN,NORBS,
     &(NRAD(ISORT),ISORT=1,NSORT),
     &(ILSV(ISORT),ISORT=1,NSORT),(QPNT(I,IQPNT),I=1,3)
      WRITE(ICHN)((R(IRAD,ISORT),IRAD=0,NRAD(ISORT)),ISORT=1,NSORT) 
C Store change in the potential
	LDPOT=.TRUE.
	LGPOT=.TRUE.    
      DO IATOM=1,NATOM                           !!! over atoms
      ISORT=IS(IATOM)
	LGPOT=LGPOT.AND.IATOM.EQ.INUC
      DO IORBS=1,NORBS                           !!! over iorbs
      DO ISPIN=1,NSPIN                           !!! over spins
      IF(LDPOT)WRITE(ICHN)((DPOT(IRAD,LM,IATOM,ISPIN,IORBS),
     &IRAD=0,NRAD(ISORT)),LM=1,(ILSV(ISORT)+1)**2)
      IF(LGPOT)WRITE(ICHN)((GPOT(IRAD,LM,IATOM,ISPIN,IORBS),
     &IRAD=0,NRAD(ISORT)),LM=1,(ILSV(ISORT)+1)**2)
      IF(LDPOT)WRITE(ICHN)(DELVHUB(IU,IATOM,ISPIN,IORBS),
     &  IU=1,(ILSB(ISORT)+1)*(2*ILSB(ISORT)+1)*(2*ILSB(ISORT)+3)/3)
      IF(LGPOT)WRITE(ICHN)(DELWHUB(IU,IATOM,ISPIN,IORBS),
     &  IU=1,(ILSB(ISORT)+1)*(2*ILSB(ISORT)+1)*(2*ILSB(ISORT)+3)/3)
      DO IPOL=1,NPOLMEM
      IF(LDPOT)WRITE(ICHN)(DELVRAT(IU,IATOM,ISPIN,IORBS,IPOL),
     &  IU=1,(ILSB(ISORT)+1)*(2*ILSB(ISORT)+1)*(2*ILSB(ISORT)+3)/3)
      IF(LDPOT)WRITE(ICHN)(DELWRAT(IU,IATOM,ISPIN,IORBS,IPOL),
     &  IU=1,(ILSB(ISORT)+1)*(2*ILSB(ISORT)+1)*(2*ILSB(ISORT)+3)/3)
      IF(LDPOT)WRITE(ICHN)(DELPRAT(IU,IATOM,ISPIN,IORBS,IPOL),
     &  IU=1,(ILSB(ISORT)+1)*(2*ILSB(ISORT)+1)*(2*ILSB(ISORT)+3)/3)
      IF(LDPOT)WRITE(ICHN)(DELORAT(IU,IATOM,ISPIN,IORBS,IPOL),
     &  IU=1,(ILSB(ISORT)+1)*(2*ILSB(ISORT)+1)*(2*ILSB(ISORT)+3)/3)
      ENDDO
	ENDDO                                      !!! over spins
	ENDDO                                      !!! over iorbs
	ENDDO                                      !!! over atoms
	CLOSE(ICHN)
	ENDIF
C Deallocate data
	IF(AOPER.EQ.'D')THEN
	DEALLOCATE(DPOT,GPOT,DELVHUB,DELVRAT,DELWRAT,DELPRAT,DELORAT)
	IF(ALLOCATED(ROLD))DEALLOCATE(ROLD)
	IF(ALLOCATED(NRAD0))DEALLOCATE(NRAD0)
	ENDIF
C Memory deallocations
	DEALLOCATE(DELWHUB,ILSV0)
	END




	SUBROUTINE DPT_DPVFILES(MY,INUC,IQPNT,ICHN,TOPER,TDPOT,AOPER)
************************************************************
*  Reads/writes/initializes induced pseudopotential in     *
*  channel 37                                              *
*  TOPER='R'ead, 'W'rite, or 'I'nitialize                  *
*  ICHN=37 for permanent/scratch storage.                  *
************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
      USE COM_PHNCOM,  ONLY : ITERMAX,NITER                              !!! from readini
	USE COM_QMESH,   ONLY : NQPNT,QPNT                                 !!! from readpnt
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_LATTICE, ONLY : RBAS,GBAS                                  !!! from readstr
	USE COM_LATPAR,  ONLY : PAR,ORTH,OMEGAC                            !!! from readini
	USE COM_PLWMESH, ONLY : NPLW,GPLW                                  !!! from makeplw
	USE COM_DELPOT,  ONLY : DPOTPS,DPOTPS1                             !!! from delpot
	USE COM_MASHDEP, ONLY : NVAL                                       !!! from setup
      USE COM_OLDMESH, ONLY : NPLW0,GPLW0,RBAS0,GBAS0,ORTH0              !!! from dpsfiles
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	USE COM_PHNCHN  ,ONLY : IUDSV,IUDPV                                !!! from channels
	USE COM_LMTOUT
	USE COM_PHNOUT
	IMPLICIT REAL*8 (A-H,O-Z)
	CHARACTER TOPER*1,TDPOT*1,AOPER*1,STATUS*3,DFILE*130
	LOGICAL EXIST
	DIMENSION QPNT0(3)
	IF(TOPER.NE.' ')THEN
      IF(ICDSV.GT.0)DFILE=DPVFILE(MY,INUC)
      IF(ICDSV.EQ.0)DFILE=SCNFILE(MY,INUC,ICHN)
      INQUIRE(FILE=DFILE,EXIST=EXIST)
	IF(.NOT.EXIST)STATUS='NEW'
	IF(     EXIST)STATUS='OLD'
	ENDIF
C *** DELETE FILE
	IF(TOPER.EQ.'D')THEN
        OPEN(UNIT=ICHN,FILE=DFILE,STATUS=STATUS,
     &  FORM='UNFORMATTED',ACCESS='SEQUENTIAL')
	CLOSE(UNIT=ICHN,STATUS='DELETE')
	RETURN
	ENDIF
C Allocate data
	IF(AOPER.EQ.'A')THEN
	ALLOCATE(DPOTPS(0:NPLWMEM,NSPINMEM,NORBSMEM))
	ALLOCATE(DPOTPS1(0:NPLWMEM,NSPINMEM,NORBSMEM))
	IF(.NOT.ALLOCATED(GPLW0))ALLOCATE(GPLW0(3,0:NPLWMEM))
	ENDIF
C *** READ DATA FROM DPVFILE OR SCNFILE
	IF(TOPER.EQ.'R')THEN
      IF(.NOT.EXIST)
     &CALL FULLSTOP('<DPVFILES>: FILE MUST EXIST!')
      OPEN(UNIT=ICHN,FILE=DFILE,STATUS='OLD',
     &  FORM='UNFORMATTED',ACCESS='SEQUENTIAL')
C Read control information:
C     READ(ICHN)NPLW0,((GPLW0(I,IPLW),I=1,3),IPLW=0,NPLW0),
C    &  ORTH0,GBAS0,RBAS0
C     IF(NPLW0.GT.NPLWMEM)
C    &CALL FULLSTOP('<DPVFILES>: NPLW0>NPLWMEM')
	READ(ICHN)NPLW0
C Read change in pseudopotential:
      DO IORBS=1,NORBS
	DO ISPIN=1,NSPIN
      READ(ICHN)(DPOTPS(IPLW,ISPIN,IORBS),IPLW=0,NPLW0),
     &(DPOTPS1(IPLW,ISPIN,IORBS),IPLW=0,NPLW0)
C Set zeroes for higher plw's
	DO IPLW=NPLW0+1,NPLW
	DPOTPS (IPLW,ISPIN,IORBS)=(0.D0,0.D0)
	DPOTPS1(IPLW,ISPIN,IORBS)=(0.D0,0.D0)
	ENDDO
	ENDDO                                      !!! over spins
	ENDDO                                      !!! over iorbs
	CLOSE(ICHN)
	ENDIF
C **** INITIALIZE CHANGE IN POTENTIAL
	IF(TOPER.EQ.'I')THEN
	DO IORBS=1,NORBS                           !!! over iorbs
	DO ISPIN=1,NSPIN                           !!! over spins
	DO IPLW=0,NPLW
	DPOTPS (IPLW,ISPIN,IORBS)=(0.D0,0.D0)
	DPOTPS1(IPLW,ISPIN,IORBS)=(0.D0,0.D0)
	ENDDO
	ENDDO                                      !!! over spins
	ENDDO                                      !!! over iorbs
	ENDIF
C **** STORE DATA IN DPVFILE OR SCNFILE
	IF(TOPER.NE.'R'.AND.TOPER.NE.' ')THEN
	OPEN(UNIT=ICHN,FILE=DFILE,STATUS=STATUS,
     &FORM='UNFORMATTED',ACCESS='SEQUENTIAL')
	CLOSE(UNIT=ICHN,STATUS='DELETE')
	OPEN(UNIT=ICHN,FILE=DFILE,STATUS='NEW',
     &FORM='UNFORMATTED',ACCESS='SEQUENTIAL')
C Store control information:
      WRITE(ICHN)NPLW,((GPLW(I,IPLW),I=1,3),IPLW=0,NPLW),
     &ORTH,GBAS,RBAS
C Store change in potential:
      DO IORBS=1,NORBS                           !!! over spins
      DO ISPIN=1,NSPIN                           !!! over spins
      WRITE(ICHN)(DPOTPS(IPLW,ISPIN,IORBS),IPLW=0,NPLW),
     &(DPOTPS1(IPLW,ISPIN,IORBS),IPLW=0,NPLW)
	ENDDO                                      !!! over spins
	ENDDO                                      !!! over iorbs
	CLOSE(ICHN)
	ENDIF
C Deallocate data
	IF(AOPER.EQ.'D')THEN
	DEALLOCATE(DPOTPS,DPOTPS1)
	IF(ALLOCATED(GPLW0))DEALLOCATE(GPLW0)
	ENDIF
	END
