	SUBROUTINE DPT_PRINT3(MY,INUC,IQPNT,ITER)
********************************************************
*  Print data on the potential and density variations. *
********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_QMESH,   ONLY : NQPNT,QPNT                                 !!! from readpnt
	USE COM_LATTICE, ONLY : TAU                                        !!! from readstr
	USE COM_RADMESH, ONLY : NRAD                                       !!! from makerad
	USE COM_DENDAT,  ONLY : RHO                                        !!! from readscf
	USE COM_PLWMESH, ONLY : NPLW,GPLW                                  !!! from makeplw
	USE COM_SYMMLM,  ONLY : SYM,LMSYM                                  !!! from makesym
	USE COM_LATPAR,  ONLY : PAR,ORTH,OMEGAC                            !!! from readini
	USE COM_POTDAT,  ONLY : POT,POTSPH,POTPS                           !!! from fulpot
	USE COM_DELPOT,  ONLY : DPOT,DPOTPS,DPOTPS1                        !!! from delpot
      USE COM_DELRHO,  ONLY : DRHO,DRHOPS,DRHOPS1                        !!! from delrho
      USE COM_INPDCH,  ONLY : DCHINP,DPSINP,DCHOUT,DPSOUT                !!! from print3
      USE COM_PLZCOM,  ONLY : NPLZ,LPLZ,IPLZ,NPTB,QPTB,INDPTB            !!! from readlrt
	USE COM_DENDAT,  ONLY : RHOPS,RHOPS1                               !!! from readscf
      USE COM_DROMULT, ONLY : DELMRO,DPSMOM                              !!! from dmultrho
	USE COM_ZERODV,  ONLY : DVAV,DVMT,DVMT0                            !!! from dvzero
	USE COM_SPHERE,  ONLY : SWZ,SMT                                    !!! from readini
	USE COM_LABELS,  ONLY : TXTEL                                      !!! from readini
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-C,E-H,O-Z)
	IMPLICIT COMPLEX*16 (D)
	COMPLEX*16 TR(-1:1,3),DIPOLE(-1:1),LIB_CNUM0P,DMS(-1:1),DMC(0:3)
     &       ,DMSTOT(-1:1),DMPTOT(-1:1),DMDTOT(-1:1,-1:1)
     &       ,DRHO0(0:3),DRHOS(0:3),DVPS0(0:3),DVPSS(0:3)
     &       ,DGPSS(0:3),DGPVS(0:3),GRHOS(0:3),GPOTS(0:3)
	CHARACTER POL(-1:1)*1
	LOGICAL FIRST
	DATA PI/3.141592653589793D0/,POL/'m','0','p'/,FIRST/.TRUE./
	IF(FIRST)THEN
	FIRST=.FALSE.
	ALLOCATE(DCHINP(LIMVMEM,NATOMMEM,NSPINMEM,-1:1,NATOMMEM))
	ALLOCATE(DCHOUT(LIMVMEM,NATOMMEM,NSPINMEM,-1:1,NATOMMEM))
	ALLOCATE(DPSINP(NENVMEM,NSPINMEM,-1:1,NATOMMEM))
	ALLOCATE(DPSOUT(NENVMEM,NSPINMEM,-1:1,NATOMMEM))
	ENDIF
	SQPI4=2.D0*SQRT(PI)
	WRITE(IUN,1001)INUC,POL(MY),TXTEL(IS(INUC))
1001  FORMAT(1X,'Atom ',I2,' Movement::  polarization  "',A1,'" ',A10)
	DZTOT=(0.D0,0.D0)
	DPTOT=(0.D0,0.D0)
	DO MY1=-1,1
	DIPOLE(MY1)=(0.D0,0.D0)
	DMSTOT(MY1)=(0.D0,0.D0)
	DMPTOT(MY1)=(0.D0,0.D0)
	DMDTOT(MY1,-1)=(0.D0,0.D0)
	DMDTOT(MY1, 0)=(0.D0,0.D0)
	DMDTOT(MY1,+1)=(0.D0,0.D0)
	ENDDO
	DO 2000 IATOM=1,NATOM                         !!! over atoms
	ISORT=IS(IATOM)
	WRITE(IUN,1011)IATOM,TXTEL(ISORT)
1011  FORMAT(1X,'Data  variation ::  atom position ',I2,'  ' ,A10)
C  CHANGE IN THE TOTAL CHARGE
      DO ISPIN=1,NSPIN                              !!! over spins
	DZTOT=DZTOT+DELMRO(1,IATOM,ISPIN,1,MY,INUC)
      DPTOT=DPTOT+DPSMOM(1,1,IATOM,ISPIN,1,MY,INUC)+
     &            DPSMOM(2,1,IATOM,ISPIN,1,MY,INUC)
      ENDDO
      DMSTOT( 0)=DMSTOT( 0)+
     &DELMRO(1,IATOM,1,1,MY,INUC)-DELMRO(1,IATOM,NSPIN,1,MY,INUC)
      DMSTOT(-1)=DMSTOT(-1)+DELMRO(1,IATOM,1,NORBS,MY,INUC)
      DMSTOT(+1)=DMSTOT(+1)+DELMRO(1,IATOM,NSPIN,NORBS,MY,INUC)
      DMPTOT( 0)=DMPTOT( 0)+
     &DPSMOM(1,1,IATOM,1,1,MY,INUC)-DPSMOM(1,1,IATOM,NSPIN,1,MY,INUC)+
     &DPSMOM(2,1,IATOM,1,1,MY,INUC)-DPSMOM(2,1,IATOM,NSPIN,1,MY,INUC)
      DMPTOT(-1)=DMPTOT(-1)+DPSMOM(1,1,IATOM,1,NORBS,MY,INUC)+
     &                      DPSMOM(2,1,IATOM,1,NORBS,MY,INUC)
      DMPTOT(+1)=DMPTOT(+1)+DPSMOM(1,1,IATOM,NSPIN,NORBS,MY,INUC)+
     &                      DPSMOM(2,1,IATOM,NSPIN,NORBS,MY,INUC)
C  CHANGE IN THE DIPOLE CHARGE
	DO MY1=-1,1
	LM=3-MY1
      DO ISPIN=1,NSPIN                              !!! over spins
	DIPOLE(MY1)=DIPOLE(MY1)+DELMRO(LM,IATOM,ISPIN,1,MY,INUC)
	ENDDO
	DMDTOT(MY1, 0)=DMDTOT(MY1, 0)+
     &DELMRO(LM,IATOM,1,1,MY,INUC)-DELMRO(LM,IATOM,NSPIN,1,MY,INUC)
	DMDTOT(MY1,-1)=DMDTOT(MY1,-1)+
     &DELMRO(LM,IATOM,1    ,NORBS,MY,INUC)
	DMDTOT(MY1,+1)=DMDTOT(MY1,+1)+
     &DELMRO(LM,IATOM,NSPIN,NORBS,MY,INUC)
	ENDDO
C  INPUT INDUCED CHARGE TRANSFER
      DO ISPIN=1,NSPIN                              !!! over spins
      DO L=0,ILSV(ISORT)
      DO M=-L,L
      LM=L*(L+1)+M+1
      DCHINP(LM,IATOM,ISPIN,MY,INUC)=
     &DELMRO(LM,IATOM,ISPIN,1,MY,INUC)
	ENDDO
	ENDDO
	ENDDO
C  INPUT INDUCED PSEUDOCHARGE 
      DO ISPIN=1,NSPIN                              !!! over spins
	DO IPTB=1,NPTB
	IPLW=INDPTB(IPTB)
	DPSINP(IPTB,ISPIN,MY,INUC)=DRHOPS(IPLW,ISPIN,1)+
     &DRHOPS1(IPLW,ISPIN,1)+DRHOPS1(IPLW,ISPIN,2)
	ENDDO
	ENDDO
C  POTENTIAL AND DENSITY AT THE CENTER OF ATOM
      DO IA=0,3
      DVPS0(IA)=(0.D0,0.D0)
      DVPSS(IA)=(0.D0,0.D0)
      DRHO0(IA)=(0.D0,0.D0)
      DRHOS(IA)=(0.D0,0.D0)
      ENDDO
      DO IPLW=0,NPLW
	GX=QPNT(1,IQPNT)+GPLW(1,IPLW)
	GY=QPNT(2,IQPNT)+GPLW(2,IPLW)
	GZ=QPNT(3,IQPNT)+GPLW(3,IPLW)
      SCP=GX*TAU(1,IATOM)+GY*TAU(2,IATOM)+GZ*TAU(3,IATOM)
      GS=SQRT(GX**2+GY**2+GZ**2)*2.D0*PI/PAR*SMT(ISORT)
      DEXPGR=EXP((0.D0,1.D0)*2.D0*PI*SCP)
      DMS( 0)=DRHOPS(IPLW,1,1)-DRHOPS(IPLW,NSPIN,1)
      DMS(-1)=DRHOPS(IPLW,1,NORBS)
      DMS(+1)=DRHOPS(IPLW,NSPIN,NORBS)
      DMC(0)=0.5D0*DBLE(NSPIN)*
     &(DRHOPS(IPLW,1,1)+DRHOPS(IPLW,NSPIN,1))
	DMC(1)=(DMS(-1)-DMS(+1))/SQRT(2.D0)
	DMC(2)=(DMS(-1)+DMS(+1))/SQRT(2.D0)*(0.D0,-1.D0) ! since it is M^{+/-}
	DMC(3)= DMS(0)
      DO IA=0,3
      DRHO0(IA)=DRHO0(IA)+DMC(IA)*DEXPGR
      IF(GS.GE.1.D-10)
     &DRHOS(IA)=DRHOS(IA)+DMC(IA)*DEXPGR*SIN(GS)/GS
      IF(GS.LT.1.D-10)
     &DRHOS(0)=DRHOS(0)+DMC(IA)*DEXPGR
      ENDDO
      DMS( 0)=0.5D0*(DPOTPS(IPLW,1,1)-DPOTPS(IPLW,NSPIN,1))
      DMS(-1)=DPOTPS(IPLW,1,NORBS)
      DMS(+1)=DPOTPS(IPLW,NSPIN,NORBS)
      DMC(0)=0.5D0*(DPOTPS(IPLW,1,1)+DPOTPS(IPLW,NSPIN,1))
	DMC(1)=(DMS(-1)-DMS(+1))/SQRT(2.D0)
	DMC(2)=(DMS(-1)+DMS(+1))/SQRT(2.D0)*(0.D0,-1.D0) ! since it is M^{+/-}
	DMC(3)= DMS(0)
      DO IA=0,3
      DVPS0(IA)=DVPS0(IA)+DMC(IA)*DEXPGR
      IF(GS.GE.1.D-10)
     &DVPSS(IA)=DVPSS(IA)+DMC(IA)*DEXPGR*SIN(GS)/GS
      IF(GS.LT.1.D-10)
     &DVPSS(IA)=DVPSS(IA)+DMC(IA)*DEXPGR
      ENDDO
	ENDDO
C  EVALUATE AVERAGE GRADIENT OF THE PSEUDOPOTENTIAL AND THE PSEUDODENSITY 
      DO IA=0,3
	DGPSS(IA)=(0.D0,0.D0)
	DGPVS(IA)=(0.D0,0.D0)
	ENDDO
	IF(IATOM.EQ.INUC)THEN
      DO IPLW=0,NPLW
      IF(MY.EQ.-1)DGMY=+1.D0/SQRT(2.D0)*(GPLW(1,IPLW)-
     &  (0.D0,1.D0)*GPLW(2,IPLW))
      IF(MY.EQ.+1)DGMY=-1.D0/SQRT(2.D0)*(GPLW(1,IPLW)+
     &  (0.D0,1.D0)*GPLW(2,IPLW))
      IF(MY.EQ. 0)DGMY=GPLW(3,IPLW)
      CALL INI_MAKEPLW_DINT(GPLW(1,IPLW),GPLW(2,IPLW),GPLW(3,IPLW),
     &  DINT,INUC)
      DMS( 0)=RHOPS(IPLW,1,1)-RHOPS(IPLW,NSPIN,1)
      DMS(-1)=RHOPS(IPLW,1,NORBS)
      DMS(+1)=RHOPS(IPLW,NSPIN,NORBS)
      DMC(0)=0.5D0*DBLE(NSPIN)*(RHOPS(IPLW,1,1)+RHOPS(IPLW,NSPIN,1))
	DMC(1)=(DMS(-1)-DMS(+1))/SQRT(2.D0)
	DMC(2)=(DMS(-1)+DMS(+1))/SQRT(2.D0)*(0.D0,-1.D0) ! since it is M^{+/-}
	DMC(3)= DMS(0)
      DO IA=0,3
      DGPSS(0)=DGPSS(0)+DMC(IA)*DINT*2.D0*PI/PAR*
     &(0.D0,1.D0)*DGMY/4.D0/PI/SMT(ISORT)**2
      ENDDO
      DMS( 0)=0.5D0*(POTPS(IPLW,1,1)-POTPS(IPLW,NSPIN,1))
      DMS(-1)=POTPS(IPLW,1,NORBS)
      DMS(+1)=POTPS(IPLW,NSPIN,NORBS)
      DMC(0)=0.5D0*(POTPS(IPLW,1,1)+POTPS(IPLW,NSPIN,1))
	DMC(1)=(DMS(-1)-DMS(+1))/SQRT(2.D0)
	DMC(2)=(DMS(-1)+DMS(+1))/SQRT(2.D0)*(0.D0,-1.D0) ! since it is M^{+/-}
	DMC(3)= DMS(0)
      DO IA=0,3
      DGPVS(IA)=DGPVS(IA)+DMC(IA)*DINT*2.D0*PI/PAR*
     &(0.D0,1.D0)*DGMY/4.D0/PI/SMT(ISORT)**2
	ENDDO
	ENDDO
	ENDIF
C  EVALUATE AVERAGE GRADIENT OF THE POTENTIAL AND THE DENSITY AT SPHERE
      DO IA=0,3
	GRHOS(IA)=(0.D0,0.D0)
      GPOTS(IA)=(0.D0,0.D0)
      ENDDO
	IRAD=NRAD(ISORT)
	LM=3-MY
	ISYM=LMSYM(LM,IATOM)
	IF(IATOM.EQ.INUC.AND.SYM(LM,IATOM))THEN
      DMS( 0)=RHO(IRAD,ISYM,IATOM,1,1)-RHO(IRAD,ISYM,IATOM,NSPIN,1)
      DMS(-1)=RHO(IRAD,ISYM,IATOM,1,NORBS)
      DMS(+1)=RHO(IRAD,ISYM,IATOM,NSPIN,NORBS)
      DMC(0)=0.5D0*DBLE(NSPIN)*
     &       (RHO(IRAD,ISYM,IATOM,1,1)+RHO(IRAD,ISYM,IATOM,NSPIN,1))
	DMC(1)=(DMS(-1)-DMS(+1))/SQRT(2.D0)
	DMC(2)=(DMS(-1)+DMS(+1))/SQRT(2.D0)*(0.D0,-1.D0) ! since it is M^{+/-}
	DMC(3)= DMS(0)
      DO IA=0,3
      GRHOS(IA)=(0.D0,1.D0)*SQRT(4.D0*PI/3.D0)*
     &(-1)**MY*DMC(IA)/4.D0/PI
      ENDDO
      DMS( 0)=0.5D0*
     &       (POT(IRAD,ISYM,IATOM,1,1)-POT(IRAD,ISYM,IATOM,NSPIN,1))
      DMS(-1)=POT(IRAD,ISYM,IATOM,1,NORBS)
      DMS(+1)=POT(IRAD,ISYM,IATOM,NSPIN,NORBS)
      DMC(0)=0.5D0*
     &       (POT(IRAD,ISYM,IATOM,1,1)+POT(IRAD,ISYM,IATOM,NSPIN,1))
	DMC(1)=(DMS(-1)-DMS(+1))/SQRT(2.D0)
	DMC(2)=(DMS(-1)+DMS(+1))/SQRT(2.D0)*(0.D0,-1.D0) ! since it is M^{+/-}
	DMC(3)= DMS(0)
      DO IA=0,3
      GPOTS(IA)=(0.D0,1.D0)*SQRT(4.D0*PI/3.D0)*
     &(-1)**MY*DMC(IA)/4.D0/PI
      ENDDO
      ENDIF
C  PRINT POTENTIAL INFORMATION
      WRITE(IUN,1020)
 1020 FORMAT(1X,'Potential variations ---->')
	WRITE(IUN,1021)LIB_CNUM0P((DVMT(IATOM,MY,INUC,1)+
     &DVMT(IATOM,MY,INUC,NSPIN))*0.5D0,1.D-07),MY,INUC,IATOM
	WRITE(IUN,1022)LIB_CNUM0P(DVPSS(0)-DGPVS(0),1.D-07),MY,INUC,IATOM
	WRITE(IUN,1023)LIB_CNUM0P((DVMT(IATOM,MY,INUC,1)+
     &DVMT(IATOM,MY,INUC,NSPIN))*0.5D0+GPOTS(0),1.D-07),
     &MY,INUC,IATOM
	WRITE(IUN,1024)LIB_CNUM0P(DVPSS(0),1.D-07),MY,INUC,IATOM
	WRITE(IUN,1025)LIB_CNUM0P(DVPS0(0),1.D-07),MY,INUC,IATOM
 1021 FORMAT(1X,'Soft  change in  V(S)   = (',G14.7,',',G14.7,')',
     &   '|DsVs',I2,1X,I2,1X,I2)
 1022 FORMAT(1X,'Soft  change in  P(S)   = (',G14.7,',',G14.7,')',
     &   '|DsPs',I2,1X,I2,1X,I2)
 1023 FORMAT(1X,'Total change in  V(S)   = (',G14.7,',',G14.7,')',
     &   '|DtVs',I2,1X,I2,1X,I2)
 1024 FORMAT(1X,'Total change in  P(S)   = (',G14.7,',',G14.7,')',
     &   '|DtPs',I2,1X,I2,1X,I2)
 1025 FORMAT(1X,'Total change in  P(0)   = (',G14.7,',',G14.7,')',
     &   '|DtP0',I2,1X,I2,1X,I2)
      IF(NSPIN.EQ.2.AND.NORBS.EQ.1)THEN
	WRITE(IUN,1031)LIB_CNUM0P(DPOT(IRAD,1,IATOM,1,1)-
     &DPOT(IRAD,1,IATOM,NSPIN,1),1.D-07)/SQPI4,MY,INUC,IATOM
	WRITE(IUN,1032)LIB_CNUM0P(DVPSS(3)-DGPVS(3),1.D-07),MY,INUC,IATOM
	WRITE(IUN,1033)LIB_CNUM0P(DPOT(IRAD,1,IATOM,1,1)-
     &DPOT(IRAD,1,IATOM,NSPIN,1)+GPOTS(3),1.D-07)/SQPI4,MY,INUC,IATOM
	WRITE(IUN,1034)LIB_CNUM0P(DVPSS(3),1.D-07),MY,INUC,IATOM
	WRITE(IUN,1035)LIB_CNUM0P(DVPS0(3),1.D-07),MY,INUC,IATOM
 1031 FORMAT(1X,'Soft  change in  B(S)   = (',G14.7,',',G14.7,')',
     &   '|DsBS',I2,1X,I2,1X,I2)
 1032 FORMAT(1X,'Soft  change in PB(S)   = (',G14.7,',',G14.7,')',
     &   '|DsBS',I2,1X,I2,1X,I2)
 1033 FORMAT(1X,'Total change in  B(S)   = (',G14.7,',',G14.7,')',
     &   '|DsBS',I2,1X,I2,1X,I2)
 1034 FORMAT(1X,'Total change in PB(S)   = (',G14.7,',',G14.7,')',
     &   '|DsBS',I2,1X,I2,1X,I2)
 1035 FORMAT(1X,'Total change in PB(0)   = (',G14.7,',',G14.7,')',
     &   '|DsBS',I2,1X,I2,1X,I2)
      ELSEIF(NSPIN.EQ.2.AND.NORBS.EQ.2)THEN
      DMS( 0)=0.5D0*
     &        (DPOT(IRAD,1,IATOM,1    ,1)-
     &         DPOT(IRAD,1,IATOM,NSPIN,1))/SQPI4
      DMS(-1)= DPOT(IRAD,1,IATOM,    1,NORBS)/SQPI4
      DMS(+1)= DPOT(IRAD,1,IATOM,NSPIN,NORBS)/SQPI4
	DMC(1)=(DMS(-1)-DMS(+1))/SQRT(2.D0)
	DMC(2)=(DMS(-1)+DMS(+1))/SQRT(2.D0)*(0.D0,-1.D0) ! since it is M^{+/-}
	DMC(3)= DMS(0)
	WRITE(IUN,1041)LIB_CNUM0P(DMC(1),1.D-07),MY,INUC,IATOM
	WRITE(IUN,1042)LIB_CNUM0P(DMC(2),1.D-07),MY,INUC,IATOM
	WRITE(IUN,1043)LIB_CNUM0P(DMC(3),1.D-07),MY,INUC,IATOM
 1041 FORMAT(1X,'Soft  change in Bx(S)   = (',G14.7,',',G14.7,')',
     &   '|DsBx',I2,1X,I2,1X,I2)
 1042 FORMAT(1X,'Soft  change in By(S)   = (',G14.7,',',G14.7,')',
     &   '|DsBy',I2,1X,I2,1X,I2)
 1043 FORMAT(1X,'Soft  change in Bz(S)   = (',G14.7,',',G14.7,')',
     &   '|DsBz',I2,1X,I2,1X,I2)
	WRITE(IUN,1051)LIB_CNUM0P(DVPSS(1)-DGPVS(1),1.D-07),MY,INUC,IATOM
	WRITE(IUN,1052)LIB_CNUM0P(DVPSS(2)-DGPVS(2),1.D-07),MY,INUC,IATOM
	WRITE(IUN,1053)LIB_CNUM0P(DVPSS(3)-DGPVS(3),1.D-07),MY,INUC,IATOM
 1051 FORMAT(1X,'Soft  change in Px(S)   = (',G14.7,',',G14.7,')',
     &   '|DsBx',I2,1X,I2,1X,I2)
 1052 FORMAT(1X,'Soft  change in Py(S)   = (',G14.7,',',G14.7,')',
     &   '|DsBy',I2,1X,I2,1X,I2)
 1053 FORMAT(1X,'Soft  change in Pz(S)   = (',G14.7,',',G14.7,')',
     &   '|DsBz',I2,1X,I2,1X,I2)
	WRITE(IUN,1061)LIB_CNUM0P(DMC(1)+GPOTS(1),1.D-07),MY,INUC,IATOM
	WRITE(IUN,1062)LIB_CNUM0P(DMC(2)+GPOTS(2),1.D-07),MY,INUC,IATOM
	WRITE(IUN,1063)LIB_CNUM0P(DMC(3)+GPOTS(3),1.D-07),MY,INUC,IATOM
 1061 FORMAT(1X,'Total change in Bx(S)   = (',G14.7,',',G14.7,')',
     &   '|DsBx',I2,1X,I2,1X,I2)
 1062 FORMAT(1X,'Total change in By(S)   = (',G14.7,',',G14.7,')',
     &   '|DsBy',I2,1X,I2,1X,I2)
 1063 FORMAT(1X,'Total change in Bz(S)   = (',G14.7,',',G14.7,')',
     &   '|DsBz',I2,1X,I2,1X,I2)
	WRITE(IUN,1071)LIB_CNUM0P(DVPSS(1),1.D-07),MY,INUC,IATOM
	WRITE(IUN,1072)LIB_CNUM0P(DVPSS(2),1.D-07),MY,INUC,IATOM
	WRITE(IUN,1073)LIB_CNUM0P(DVPSS(3),1.D-07),MY,INUC,IATOM
 1071 FORMAT(1X,'Total change in Px(S)   = (',G14.7,',',G14.7,')',
     &   '|DsBx',I2,1X,I2,1X,I2)
 1072 FORMAT(1X,'Total change in Py(S)   = (',G14.7,',',G14.7,')',
     &   '|DsBy',I2,1X,I2,1X,I2)
 1073 FORMAT(1X,'Total change in Pz(S)   = (',G14.7,',',G14.7,')',
     &   '|DsBz',I2,1X,I2,1X,I2)
	WRITE(IUN,1081)LIB_CNUM0P(DVPS0(1),1.D-07),MY,INUC,IATOM
	WRITE(IUN,1082)LIB_CNUM0P(DVPS0(2),1.D-07),MY,INUC,IATOM
	WRITE(IUN,1083)LIB_CNUM0P(DVPS0(3),1.D-07),MY,INUC,IATOM
 1081 FORMAT(1X,'Total change in Px(0)   = (',G14.7,',',G14.7,')',
     &   '|DsBx',I2,1X,I2,1X,I2)
 1082 FORMAT(1X,'Total change in Py(0)   = (',G14.7,',',G14.7,')',
     &   '|DsBy',I2,1X,I2,1X,I2)
 1083 FORMAT(1X,'Total change in Pz(0)   = (',G14.7,',',G14.7,')',
     &   '|DsBz',I2,1X,I2,1X,I2)
      ENDIF
C  PRINT CHANGE IN CHARGE DENSITY INFORMATION
      WRITE(IUN,1090)
 1090 FORMAT(1X,'Densities variations ---->')
	WRITE(IUN,1091)LIB_CNUM0P(DRHO(IRAD,1,IATOM,1,1)+
     &DRHO(IRAD,1,IATOM,NSPIN,1),1.D-07)/SQPI4,MY,INUC,IATOM
	WRITE(IUN,1092)LIB_CNUM0P(DRHOS(0)-DGPSS(0),1.D-07),MY,INUC,IATOM
	WRITE(IUN,1093)LIB_CNUM0P((DRHO(IRAD,1,IATOM,1,1)+
     &DRHO(IRAD,1,IATOM,NSPIN,1))/SQPI4+GRHOS(0),1.D-07),MY,INUC,IATOM
	WRITE(IUN,1094)LIB_CNUM0P(DRHOS(0),1.D-07),MY,INUC,IATOM
	WRITE(IUN,1095)LIB_CNUM0P(DRHO0(0),1.D-07),MY,INUC,IATOM
 1091 FORMAT(1X,'Soft  change in RO(S)   = (',G14.7,',',G14.7,')',
     &   '|DsRs',I2,1X,I2,1X,I2)
 1092 FORMAT(1X,'Soft  change in PS(S)   = (',G14.7,',',G14.7,')',
     &   '|DsPs',I2,1X,I2,1X,I2)
 1093 FORMAT(1X,'Total change in RO(S)   = (',G14.7,',',G14.7,')',
     &   '|DtRs',I2,1X,I2,1X,I2)
 1094 FORMAT(1X,'Total change in PS(S)   = (',G14.7,',',G14.7,')',
     &   '|DtPs',I2,1X,I2,1X,I2)
 1095 FORMAT(1X,'Total change in PS(0)   = (',G14.7,',',G14.7,')',
     &   '|DtP0',I2,1X,I2,1X,I2)
      IF(NSPIN.EQ.2.AND.NORBS.EQ.1)THEN
	WRITE(IUN,1101)LIB_CNUM0P(DRHO(IRAD,1,IATOM,1,1)-
     &DRHO(IRAD,1,IATOM,NSPIN,1),1.D-07)/SQPI4,MY,INUC,IATOM
	WRITE(IUN,1102)LIB_CNUM0P(DRHOS(3)-DGPSS(3),1.D-07),MY,INUC,IATOM
	WRITE(IUN,1103)LIB_CNUM0P(DRHO(IRAD,1,IATOM,1,1)-
     &DRHO(IRAD,1,IATOM,NSPIN,1)+GRHOS(3),1.D-07)/SQPI4,MY,INUC,IATOM
	WRITE(IUN,1104)LIB_CNUM0P(DRHOS(3),1.D-07),MY,INUC,IATOM
	WRITE(IUN,1105)LIB_CNUM0P(DRHO0(3),1.D-07),MY,INUC,IATOM
 1101 FORMAT(1X,'Soft  change in DS(S)   = (',G14.7,',',G14.7,')',
     &   '|DsDS',I2,1X,I2,1X,I2)
 1102 FORMAT(1X,'Soft  change in DP(S)   = (',G14.7,',',G14.7,')',
     &   '|DsDS',I2,1X,I2,1X,I2)
 1103 FORMAT(1X,'Total change in DS(S)   = (',G14.7,',',G14.7,')',
     &   '|DsDS',I2,1X,I2,1X,I2)
 1104 FORMAT(1X,'Total change in DP(S)   = (',G14.7,',',G14.7,')',
     &   '|DsDS',I2,1X,I2,1X,I2)
 1105 FORMAT(1X,'Total change in DP(0)   = (',G14.7,',',G14.7,')',
     &   '|DsDS',I2,1X,I2,1X,I2)
      ELSEIF(NSPIN.EQ.2.AND.NORBS.EQ.2)THEN
      DMS( 0)=(DRHO(IRAD,1,IATOM,1    ,1)-
     &         DRHO(IRAD,1,IATOM,NSPIN,1))/SQPI4
      DMS(-1)= DRHO(IRAD,1,IATOM,    1,NORBS)/SQPI4
      DMS(+1)= DRHO(IRAD,1,IATOM,NSPIN,NORBS)/SQPI4
	DMC(1)=(DMS(-1)-DMS(+1))/SQRT(2.D0)
	DMC(2)=(DMS(-1)+DMS(+1))/SQRT(2.D0)*(0.D0,-1.D0) ! since it is M^{+/-}
	DMC(3)= DMS(0)
	WRITE(IUN,1111)LIB_CNUM0P(DMC(1),1.D-07),MY,INUC,IATOM
	WRITE(IUN,1112)LIB_CNUM0P(DMC(2),1.D-07),MY,INUC,IATOM
	WRITE(IUN,1113)LIB_CNUM0P(DMC(3),1.D-07),MY,INUC,IATOM
 1111 FORMAT(1X,'Soft  change in Dx(S)   = (',G14.7,',',G14.7,')',
     &   '|DsDx',I2,1X,I2,1X,I2)
 1112 FORMAT(1X,'Soft  change in Dy(S)   = (',G14.7,',',G14.7,')',
     &   '|DsDy',I2,1X,I2,1X,I2)
 1113 FORMAT(1X,'Soft  change in Dz(S)   = (',G14.7,',',G14.7,')',
     &   '|DsDz',I2,1X,I2,1X,I2)
	WRITE(IUN,1121)LIB_CNUM0P(DRHOS(1)-DGPSS(1),1.D-07),MY,INUC,IATOM
	WRITE(IUN,1122)LIB_CNUM0P(DRHOS(2)-DGPSS(2),1.D-07),MY,INUC,IATOM
	WRITE(IUN,1123)LIB_CNUM0P(DRHOS(3)-DGPSS(3),1.D-07),MY,INUC,IATOM
 1121 FORMAT(1X,'Soft  change in Px(S)   = (',G14.7,',',G14.7,')',
     &   '|DsDx',I2,1X,I2,1X,I2)
 1122 FORMAT(1X,'Soft  change in Py(S)   = (',G14.7,',',G14.7,')',
     &   '|DsDy',I2,1X,I2,1X,I2)
 1123 FORMAT(1X,'Soft  change in Pz(S)   = (',G14.7,',',G14.7,')',
     &   '|DsDz',I2,1X,I2,1X,I2)
	WRITE(IUN,1131)LIB_CNUM0P(DMC(1)+GRHOS(1),1.D-07),MY,INUC,IATOM
	WRITE(IUN,1132)LIB_CNUM0P(DMC(2)+GRHOS(2),1.D-07),MY,INUC,IATOM
	WRITE(IUN,1133)LIB_CNUM0P(DMC(3)+GRHOS(3),1.D-07),MY,INUC,IATOM
 1131 FORMAT(1X,'Total change in Dx(S)   = (',G14.7,',',G14.7,')',
     &   '|DsDx',I2,1X,I2,1X,I2)
 1132 FORMAT(1X,'Total change in Dy(S)   = (',G14.7,',',G14.7,')',
     &   '|DsDy',I2,1X,I2,1X,I2)
 1133 FORMAT(1X,'Total change in Dz(S)   = (',G14.7,',',G14.7,')',
     &   '|DsDz',I2,1X,I2,1X,I2)
	WRITE(IUN,1141)LIB_CNUM0P(DRHOS(1),1.D-07),MY,INUC,IATOM
	WRITE(IUN,1142)LIB_CNUM0P(DRHOS(2),1.D-07),MY,INUC,IATOM
	WRITE(IUN,1143)LIB_CNUM0P(DRHOS(3),1.D-07),MY,INUC,IATOM
 1141 FORMAT(1X,'Total change in Px(S)   = (',G14.7,',',G14.7,')',
     &   '|DsDx',I2,1X,I2,1X,I2)
 1142 FORMAT(1X,'Total change in Py(S)   = (',G14.7,',',G14.7,')',
     &   '|DsDy',I2,1X,I2,1X,I2)
 1143 FORMAT(1X,'Total change in Pz(S)   = (',G14.7,',',G14.7,')',
     &   '|DsDz',I2,1X,I2,1X,I2)
	WRITE(IUN,1151)LIB_CNUM0P(DRHO0(1),1.D-07),MY,INUC,IATOM
	WRITE(IUN,1152)LIB_CNUM0P(DRHO0(2),1.D-07),MY,INUC,IATOM
	WRITE(IUN,1153)LIB_CNUM0P(DRHO0(3),1.D-07),MY,INUC,IATOM
 1151 FORMAT(1X,'Total change in Px(0)   = (',G14.7,',',G14.7,')',
     &   '|DsDx',I2,1X,I2,1X,I2)
 1152 FORMAT(1X,'Total change in Py(0)   = (',G14.7,',',G14.7,')',
     &   '|DsDy',I2,1X,I2,1X,I2)
 1153 FORMAT(1X,'Total change in Pz(0)   = (',G14.7,',',G14.7,')',
     &   '|DsDz',I2,1X,I2,1X,I2)
      ENDIF
C  PRINT CHARGE & MAGNETIZATIONS
      WRITE(IUN,1160)
 1160 FORMAT(1X,'Variations in charges --->')
	WRITE(IUN,1161)LIB_CNUM0P(DELMRO(1,IATOM,1,1,MY,INUC)+
     &DELMRO(1,IATOM,NSPIN,1,MY,INUC),1.D-07),MY,INUC,IATOM
 1161 FORMAT(1X,'Soft  change in  Z(S)   = (',G14.7,',',G14.7,')',
     &   '|DsZp',I2,1X,I2,1X,I2)
      IF(NSPIN.EQ.2.AND.NORBS.EQ.1)THEN
	WRITE(IUN,1162)LIB_CNUM0P(DELMRO(1,IATOM,1,1,MY,INUC)-
     &DELMRO(1,IATOM,NSPIN,1,MY,INUC),1.D-07),MY,INUC,IATOM
 1162 FORMAT(1X,'Soft  change in  M(S)   = (',G14.7,',',G14.7,')',
     &   '|DsMp',I2,1X,I2,1X,I2)
      ELSEIF(NSPIN.EQ.2.AND.NORBS.EQ.2)THEN
      DMS(0 )=DELMRO(1,IATOM,1,1,MY,INUC)-
     &        DELMRO(1,IATOM,NSPIN,1,MY,INUC)
      DMS(-1)=DELMRO(1,IATOM,1,    NORBS,MY,INUC)
      DMS(+1)=DELMRO(1,IATOM,NSPIN,NORBS,MY,INUC)
	DMC(1)=(DMS(-1)-DMS(+1))/SQRT(2.D0)
	DMC(2)=(DMS(-1)+DMS(+1))/SQRT(2.D0)*(0.D0,-1.D0) ! since it is M^{+/-}
	DMC(3)= DMS(0)
	WRITE(IUN,1173)LIB_CNUM0P(DMC(1),1.D-07),MY,INUC,IATOM
	WRITE(IUN,1174)LIB_CNUM0P(DMC(2),1.D-07),MY,INUC,IATOM
	WRITE(IUN,1175)LIB_CNUM0P(DMC(3),1.D-07),MY,INUC,IATOM
 1173 FORMAT(1X,'Soft  change in Mx(S)   = (',G14.7,',',G14.7,')',
     &   '|DsMx',I2,1X,I2,1X,I2)
 1174 FORMAT(1X,'Soft  change in My(S)   = (',G14.7,',',G14.7,')',
     &   '|DsMy',I2,1X,I2,1X,I2)
 1175 FORMAT(1X,'Soft  change in Mz(S)   = (',G14.7,',',G14.7,')',
     &   '|DsMz',I2,1X,I2,1X,I2)
      ENDIF
 2000	CONTINUE                                       !!! over atoms
      WRITE(IUN,1200)
 1200 FORMAT(1X,'T o t a l variations  --->')
	WRITE(IUN,1210)LIB_CNUM0P(DIPOLE(-1),1.D-07),MY,INUC
	WRITE(IUN,1220)LIB_CNUM0P(DIPOLE(+0),1.D-07),MY,INUC
	WRITE(IUN,1230)LIB_CNUM0P(DIPOLE(+1),1.D-07),MY,INUC
	WRITE(IUN,1240)(0.D0,0.D0),MY,INUC
	WRITE(IUN,1250)LIB_CNUM0P(DZTOT,1.D-07),MY,INUC
	WRITE(IUN,1260)LIB_CNUM0P(DPTOT,1.D-07),MY,INUC
 1210 FORMAT(1X,'Induced M-dipole moment = (',G14.7,',',G14.7,')',
     &   '|MDip',I2,1X,I2)
 1220 FORMAT(1X,'Induced 0-dipole moment = (',G14.7,',',G14.7,')',
     &   '|0Dip',I2,1X,I2)
 1230 FORMAT(1X,'Induced P-dipole moment = (',G14.7,',',G14.7,')',
     &   '|PDip',I2,1X,I2)
 1240 FORMAT(1X,'Change in the MT-zero   = (',G14.7,',',G14.7,')',
     &   '|DVmtz',I2,1X,I2)
 1250 FORMAT(1X,'Change in the <Z-mts>   = (',G14.7,',',G14.7,')',
     &   '|DZmts',I2,1X,I2)
 1260 FORMAT(1X,'Change in the <P-mts>   = (',G14.7,',',G14.7,')',
     &   '|DPmts',I2,1X,I2)
      IF(NSPIN.EQ.2.AND.NORBS.EQ.1)THEN
	WRITE(IUN,1310)LIB_CNUM0P(DMDTOT(-1,0),1.D-07),MY,INUC
	WRITE(IUN,1320)LIB_CNUM0P(DMDTOT(+0,0),1.D-07),MY,INUC
	WRITE(IUN,1330)LIB_CNUM0P(DMDTOT(+1,0),1.D-07),MY,INUC
	WRITE(IUN,1340)LIB_CNUM0P(DMSTOT(0),1.D-07),MY,INUC
	WRITE(IUN,1350)LIB_CNUM0P(DMPTOT(0),1.D-07),MY,INUC
 1310 FORMAT(1X,'Induced M-magnet moment = (',G14.7,',',G14.7,')',
     &   '|MMag',I2,1X,I2)
 1320 FORMAT(1X,'Induced 0-magnet moment = (',G14.7,',',G14.7,')',
     &   '|0Mag',I2,1X,I2)
 1330 FORMAT(1X,'Induced P-magnet moment = (',G14.7,',',G14.7,')',
     &   '|PMag',I2,1X,I2)
 1340 FORMAT(1X,'Change in the <MSmts>   = (',G14.7,',',G14.7,')',
     &   '|MSmts',I2,1X,I2)
 1350 FORMAT(1X,'Change in the <MPmts>   = (',G14.7,',',G14.7,')',
     &   '|MPmts',I2,1X,I2)
      ELSEIF(NSPIN.EQ.2.AND.NORBS.EQ.2)THEN
      DMS(-1)=DMDTOT(-1,-1)
      DMS( 0)=DMDTOT(-1, 0)
      DMS(+1)=DMDTOT(-1,+1)
	DMC(1)=(DMS(-1)-DMS(+1))/SQRT(2.D0)
	DMC(2)=(DMS(-1)+DMS(+1))/SQRT(2.D0)*(0.D0,-1.D0) ! since it is M^{+/-}
	DMC(3)= DMS(0)
	WRITE(IUN,1410)LIB_CNUM0P(DMC(1),1.D-07),MY,INUC
	WRITE(IUN,1420)LIB_CNUM0P(DMC(2),1.D-07),MY,INUC
	WRITE(IUN,1430)LIB_CNUM0P(DMC(3),1.D-07),MY,INUC
 1410 FORMAT(1X,'Induced M-magnet momentX= (',G14.7,',',G14.7,')',
     &   '|MMaX',I2,1X,I2)
 1420 FORMAT(1X,'Induced M-magnet momentY= (',G14.7,',',G14.7,')',
     &   '|MMaY',I2,1X,I2)
 1430 FORMAT(1X,'Induced M-magnet momentZ= (',G14.7,',',G14.7,')',
     &   '|MMaZ',I2,1X,I2)
      DMS(-1)=DMDTOT( 0,-1)
      DMS( 0)=DMDTOT( 0, 0)
      DMS(+1)=DMDTOT( 0,+1)
	DMC(1)=(DMS(-1)-DMS(+1))/SQRT(2.D0)
	DMC(2)=(DMS(-1)+DMS(+1))/SQRT(2.D0)*(0.D0,-1.D0) ! since it is M^{+/-}
	DMC(3)= DMS(0)
	WRITE(IUN,1510)LIB_CNUM0P(DMC(1),1.D-07),MY,INUC
	WRITE(IUN,1520)LIB_CNUM0P(DMC(2),1.D-07),MY,INUC
	WRITE(IUN,1530)LIB_CNUM0P(DMC(3),1.D-07),MY,INUC
 1510 FORMAT(1X,'Induced 0-magnet momentX= (',G14.7,',',G14.7,')',
     &   '|MMaX',I2,1X,I2)
 1520 FORMAT(1X,'Induced 0-magnet momentY= (',G14.7,',',G14.7,')',
     &   '|MMaY',I2,1X,I2)
 1530 FORMAT(1X,'Induced 0-magnet momentZ= (',G14.7,',',G14.7,')',
     &   '|MMaZ',I2,1X,I2)
      DMS(-1)=DMDTOT(+1,-1)
      DMS( 0)=DMDTOT(+1, 0)
      DMS(+1)=DMDTOT(+1,+1)
	DMC(1)=(DMS(-1)-DMS(+1))/SQRT(2.D0)
	DMC(2)=(DMS(-1)+DMS(+1))/SQRT(2.D0)*(0.D0,-1.D0) ! since it is M^{+/-}
	DMC(3)= DMS(0)
	WRITE(IUN,1610)LIB_CNUM0P(DMC(1),1.D-07),MY,INUC
	WRITE(IUN,1620)LIB_CNUM0P(DMC(2),1.D-07),MY,INUC
	WRITE(IUN,1630)LIB_CNUM0P(DMC(3),1.D-07),MY,INUC
 1610 FORMAT(1X,'Induced P-magnet momentX= (',G14.7,',',G14.7,')',
     &   '|MMaX',I2,1X,I2)
 1620 FORMAT(1X,'Induced P-magnet momentY= (',G14.7,',',G14.7,')',
     &   '|MMaY',I2,1X,I2)
 1630 FORMAT(1X,'Induced P-magnet momentZ= (',G14.7,',',G14.7,')',
     &   '|MMaZ',I2,1X,I2)
      DMS(-1)=DMSTOT(-1)
      DMS( 0)=DMSTOT( 0)
      DMS(+1)=DMSTOT(+1)
	DMC(1)=(DMS(-1)-DMS(+1))/SQRT(2.D0)
	DMC(2)=(DMS(-1)+DMS(+1))/SQRT(2.D0)*(0.D0,-1.D0) ! since it is M^{+/-}
	DMC(3)= DMS(0)
	WRITE(IUN,1710)LIB_CNUM0P(DMC(1),1.D-07),MY,INUC
	WRITE(IUN,1720)LIB_CNUM0P(DMC(2),1.D-07),MY,INUC
	WRITE(IUN,1730)LIB_CNUM0P(DMC(3),1.D-07),MY,INUC
 1710 FORMAT(1X,'Change in the <MSmts> X = (',G14.7,',',G14.7,')',
     &   '|MSmtX',I2,1X,I2)
 1720 FORMAT(1X,'Change in the <MSmts> Y = (',G14.7,',',G14.7,')',
     &   '|MSmtY',I2,1X,I2)
 1730 FORMAT(1X,'Change in the <MSmts> Z = (',G14.7,',',G14.7,')',
     &   '|MSmtZ',I2,1X,I2)
      DMS(-1)=DMPTOT(-1)
      DMS( 0)=DMPTOT( 0)
      DMS(+1)=DMPTOT(+1)
	DMC(1)=(DMS(-1)-DMS(+1))/SQRT(2.D0)
	DMC(2)=(DMS(-1)+DMS(+1))/SQRT(2.D0)*(0.D0,-1.D0) ! since it is M^{+/-}
	DMC(3)= DMS(0)
	WRITE(IUN,1810)LIB_CNUM0P(DMC(1),1.D-07),MY,INUC
	WRITE(IUN,1820)LIB_CNUM0P(DMC(2),1.D-07),MY,INUC
	WRITE(IUN,1830)LIB_CNUM0P(DMC(3),1.D-07),MY,INUC
 1810 FORMAT(1X,'Change in the <MPmts> X = (',G14.7,',',G14.7,')',
     &   '|MPmtX',I2,1X,I2)
 1820 FORMAT(1X,'Change in the <MPmts> Y = (',G14.7,',',G14.7,')',
     &   '|MPmtY',I2,1X,I2)
 1830 FORMAT(1X,'Change in the <MPmts> Z = (',G14.7,',',G14.7,')',
     &   '|MPmtZ',I2,1X,I2)
      ENDIF
	END




      SUBROUTINE DPT_PRINT4(MY,INUC,IQPNT,KEY)
********************************************************
*  Print input/output induced-charge transfer.         *
********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_LATTICE, ONLY : TAU                                        !!! from readstr
      USE COM_PLZCOM,  ONLY : NPLZ,LPLZ,IPLZ,NPTB,QPTB,INDPTB            !!! from readlrt
	USE COM_LATPAR,  ONLY : PAR,ORTH,OMEGAC                            !!! from readini
	USE COM_RADMESH, ONLY : NRAD                                       !!! from makerad
	USE COM_PLWMESH, ONLY : NPLW,GPLW                                  !!! from makeplw
	USE COM_LABELS,  ONLY : TXTEL                                      !!! from readini
	USE COM_QMESH,   ONLY : NQPNT,QPNT                                 !!! from readpnt
	USE COM_SPHERE,  ONLY : SWZ,SMT                                    !!! from readini
      USE COM_PLZMOM,  ONLY : PSMAT,SCRMAT,DIEMAT,SCRINT                 !!! from screen
      USE COM_INPDCH,  ONLY : DCHINP,DPSINP,DCHOUT,DPSOUT                !!! from print3
      USE COM_DROMULT, ONLY : DELMRO,DPSMOM                              !!! from dmultrho
	USE COM_DELRHO,  ONLY : DRHOPS,DRHOPS1                             !!! from delrho
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
      IMPLICIT REAL*8 (A-C,E-H,O-Z)
      IMPLICIT COMPLEX*16 (D)
	COMPLEX*16, ALLOCATABLE :: DPSSCR(:,:,:,:)
      COMPLEX*16 LIB_CNUM0P
	COMPLEX*16 DIFF,DIPINP(-1:1),DIPOUT(-1:1),EXPQR
     &   ,TOTINP,TOTOUT,TOTSCR
      CHARACTER POL(-1:1)*1
	LOGICAL FIRST
      SAVE TOTINP,TOTOUT,TOTSCR,DIPINP,DIPOUT,DPSSCR
      DATA PI/3.141592653589793D0/,POL/'m','0','p'/,FIRST/.TRUE./
	IF(FIRST)
     &ALLOCATE(DPSSCR(NENVMEM,NSPINMEM,-1:1,NATOMMEM))
	FIRST=.FALSE.
      SQPI4=2.D0*SQRT(PI)
C  GET SCREENED CHARGE TRANSFER
      IF(KEY.EQ.1)THEN
	DO IPTB=1,NPTB
	DO ISPIN=1,NSPIN                             !!! over spins
	DPSSCR(IPTB,ISPIN,MY,INUC)=(0.D0,0.D0)
	DO JPTB=1,NPTB
	JPLW=INDPTB(JPTB)
	DPSSCR(IPTB,ISPIN,MY,INUC)=DPSSCR(IPTB,ISPIN,MY,INUC)+
     &  DIEMAT(IPTB,JPTB)*(DRHOPS(JPLW,ISPIN,1)+
     &  DRHOPS1(JPLW,ISPIN,1)+DRHOPS1(JPLW,ISPIN,2))
	ENDDO
      ENDDO                                        !!! over spins
	ENDDO
C  SET SCREENED LONG-RANGE INTERACTION
	DO IPTB=1,NPTB
	SCRINT(IPTB,MY,INUC)=(0.D0,0.D0)
	DO JPTB=1,NPTB
	JPLW=INDPTB(JPTB)
      SCRINT(IPTB,MY,INUC)=SCRINT(IPTB,MY,INUC)+
     &  SCRMAT(IPTB,JPTB)*(
     &  (DRHOPS (JPLW,1,1)+DRHOPS (JPLW,NSPIN,1))/2.D0*DBLE(NSPIN)+
     &  (DRHOPS1(JPLW,1,1)+DRHOPS1(JPLW,NSPIN,1))/2.D0*DBLE(NSPIN)+
     &  (DRHOPS1(JPLW,1,2)+DRHOPS1(JPLW,NSPIN,2))/2.D0*DBLE(NSPIN))
	ENDDO
	ENDDO
C  PRINT BLOCK
      ELSEIF(KEY.EQ.2)THEN
	WRITE(IUN,1001)INUC,POL(MY),TXTEL(IS(INUC))
      WRITE(IUN,1000)
      TOTINP=(0.D0,0.D0)
      TOTOUT=(0.D0,0.D0)
      DIPINP(-1)=(0.D0,0.D0)
      DIPINP( 0)=(0.D0,0.D0)
      DIPINP(+1)=(0.D0,0.D0)
      DIPOUT(-1)=(0.D0,0.D0)
      DIPOUT( 0)=(0.D0,0.D0)
      DIPOUT(+1)=(0.D0,0.D0)
	DO ISPIN=1,NSPIN                         !!! over spins
C  INPUT INDUCED PSEUDOCHARGE 
	DO IPTB=1,NPTB
	IPLW=INDPTB(IPTB)
	DPSOUT(IPTB,ISPIN,MY,INUC)=DRHOPS(IPLW,ISPIN,1)+
     &DRHOPS1(IPLW,ISPIN,1)+DRHOPS1(IPLW,ISPIN,2)
	ENDDO
      DO IATOM=1,NATOM                         !!! over atoms
      ISORT=IS(IATOM)
      WRITE(IUN,1010)TXTEL(ISORT)
C  SET OUTPUT INDUCED-CHARGE-TRANSFER
      DO L=0,ILSV(ISORT)
      DO M=-L,L
      LM=L*(L+1)+M+1
      DCHOUT(LM,IATOM,ISPIN,MY,INUC)=
     &DELMRO(LM,IATOM,ISPIN,1,MY,INUC)
	ENDDO
	ENDDO
C  PRINT INPUT/OUTPUT INDUCED-CHARGE TRANSFER
      WRITE(IUN,1020)LIB_CNUM0P(DCHINP(1,IATOM,ISPIN,MY,INUC),
     &  1.D-07),LIB_CNUM0P(DCHOUT(1,IATOM,ISPIN,MY,INUC),1.D-07)
      WRITE(IUN,1030)LIB_CNUM0P(DCHINP(2,IATOM,ISPIN,MY,INUC),
     &  1.D-07),LIB_CNUM0P(DCHOUT(2,IATOM,ISPIN,MY,INUC),1.D-07)
      WRITE(IUN,1040)LIB_CNUM0P(DCHINP(3,IATOM,ISPIN,MY,INUC),
     &  1.D-07),LIB_CNUM0P(DCHOUT(3,IATOM,ISPIN,MY,INUC),1.D-07)
      WRITE(IUN,1050)LIB_CNUM0P(DCHINP(4,IATOM,ISPIN,MY,INUC),
     &  1.D-07),LIB_CNUM0P(DCHOUT(4,IATOM,ISPIN,MY,INUC),1.D-07)
      SCP=QPNT(1,IQPNT)*TAU(1,IATOM)+
     &    QPNT(2,IQPNT)*TAU(2,IATOM)+
     &    QPNT(3,IQPNT)*TAU(3,IATOM)
      EXPQR=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
      TOTINP=TOTINP+DCHINP(1,IATOM,ISPIN,MY,INUC)*EXPQR
      TOTOUT=TOTOUT+DCHOUT(1,IATOM,ISPIN,MY,INUC)*EXPQR
      DIPINP(-1)=DIPINP(-1)+DCHINP(2,IATOM,ISPIN,MY,INUC)*EXPQR
      DIPOUT(-1)=DIPOUT(-1)+DCHOUT(2,IATOM,ISPIN,MY,INUC)*EXPQR
      DIPINP( 0)=DIPINP( 0)+DCHINP(3,IATOM,ISPIN,MY,INUC)*EXPQR
      DIPOUT( 0)=DIPOUT( 0)+DCHOUT(3,IATOM,ISPIN,MY,INUC)*EXPQR
      DIPINP(+1)=DIPINP(+1)+DCHINP(4,IATOM,ISPIN,MY,INUC)*EXPQR
      DIPOUT(+1)=DIPOUT(+1)+DCHOUT(4,IATOM,ISPIN,MY,INUC)*EXPQR
      ENDDO                                       !!! over atoms
      ENDDO                                       !!! over spins
      WRITE(IUN,1060)
      WRITE(IUN,1020)LIB_CNUM0P(TOTINP,1.D-07),
     &  LIB_CNUM0P(TOTOUT,1.D-07)
      WRITE(IUN,1030)LIB_CNUM0P(DIPINP(-1),1.D-07),
     &  LIB_CNUM0P(DIPOUT(-1),1.D-07)
      WRITE(IUN,1040)LIB_CNUM0P(DIPINP( 0),1.D-07),
     &  LIB_CNUM0P(DIPOUT( 0),1.D-07)
      WRITE(IUN,1050)LIB_CNUM0P(DIPINP(+1),1.D-07),
     &  LIB_CNUM0P(DIPOUT(+1),1.D-07)
      WRITE(IUN,1070)
	DO IPTB=1,NPTB
      WRITE(IUN,1080)IPTB,LIB_CNUM0P((DPSINP(IPTB,1,MY,INUC)+
     &  DPSINP(IPTB,NSPIN,MY,INUC))/2.D0*DBLE(NSPIN)*OMEGAC,1.D-07)
     &                     ,LIB_CNUM0P((DPSOUT(IPTB,1,MY,INUC)+
     &  DPSOUT(IPTB,NSPIN,MY,INUC))/2.D0*DBLE(NSPIN)*OMEGAC,1.D-07)
	ENDDO
C  CHECK SCREENED CHARGE TRANSFER
	IF(LPLZ.GT.0)THEN
	DO IPTB=1,NPTB
      IF(ABS(DPSSCR(IPTB,1,MY,INUC)+DPSSCR(IPTB,NSPIN,MY,INUC)-
     &         DPSOUT(IPTB,1,MY,INUC)-DPSOUT(IPTB,NSPIN,MY,INUC))
     &  .GT.1.D-06)WRITE(IUT,*)
     &  '<PRINT4>:: ERROR IN SCREENED CHARGE ::',
     &  (DPSOUT(IPTB,1,MY,INUC)+DPSOUT(IPTB,NSPIN,MY,INUC))/
     &  2.D0*DBLE(NSPIN)*OMEGAC,
     &  (DPSSCR(IPTB,1,MY,INUC)+DPSSCR(IPTB,NSPIN,MY,INUC))/
     &  2.D0*DBLE(NSPIN)*OMEGAC
	ENDDO
	ENDIF
      ENDIF
1000  FORMAT(1X,'Input/output induced charge transfer, dQ_iat-->')
1001  FORMAT(1X,'Atom ',I2,' Movement::  polarization  "',A1,'" ',A10)
1010  FORMAT(1X,23X,'dQ_iat[INP]',19X,'dQ_iat[OUT]',3X,A10)
1020  FORMAT(1X,'l=0,m= 0 :',2X,'(',G12.5,',',G12.5,')',2X,
     &                          '(',G12.5,',',G12.5,')')
1030  FORMAT(1X,'l=1,m=-1 :',2X,'(',G12.5,',',G12.5,')',2X,
     &                          '(',G12.5,',',G12.5,')')
1040  FORMAT(1X,'l=1,m= 0 :',2X,'(',G12.5,',',G12.5,')',2X,
     &                          '(',G12.5,',',G12.5,')')
1050  FORMAT(1X,'l=1,m=+1 :',2X,'(',G12.5,',',G12.5,')',2X,
     &                          '(',G12.5,',',G12.5,')')
1060  FORMAT(1X,23X,'dQ_tot[INP]',19X,'dQ_tot[OUT]',3X,'TOTAL')
1070  FORMAT(1X,23X,'dP_tot[INP]',19X,'dP_tot[OUT]',3X,'TOTAL')
1080  FORMAT(1X,'drho(G',I2,'):',2X,'(',G12.5,',',G12.5,')',2X,
     &                              '(',G12.5,',',G12.5,')')
      END

