	SUBROUTINE DPT_SSCRPOT(IQPNT,ITER)
************************************************************
*   The calculation of the screened long-range part of the *
*   potential and corresponding contribution to DRHO.      *
************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
      USE COM_PHNCOM,  ONLY : ITERMAX,NITER                              !!! from readini
	USE COM_QMESH,   ONLY : NQPNT,QPNT                                 !!! from readpnt
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_RADMESH, ONLY : NRAD,H,R                                   !!! from makerad
	USE COM_SPHERE,  ONLY : SWZ,SMT                                    !!! from readini
	USE COM_PLWMESH, ONLY : NPLW,GPLW                                  !!! from makeplw
      USE COM_PLZCOM,  ONLY : NPLZ,LPLZ,IPLZ,NPTB,QPTB,INDPTB            !!! from readlrt
      USE COM_PLZMOM,  ONLY : PSMAT,SCRMAT,DIEMAT,SCRINT                 !!! from screen
      USE COM_DELHUB,  ONLY : DELDHUB,DELVHUB,DELTHUB,DELGHUB            !!! from plzfiles
      USE COM_DELRHO,  ONLY : PRHO=>DRHO,DRHO=>TRHO
     &                       ,PRHOPS=>DRHOPS,DRHOPS=>TRHOPS              !!! from drofiles
	USE COM_LATTICE, ONLY : TAU                                        !!! from readstr
	USE COM_LATPAR,  ONLY : PAR,ORTH,OMEGAC                            !!! from readini
	USE COM_PHNCHN  ,ONLY : IUDRO,IUDPX,IUDRX,IUDPY,IUDRY,IUPLZ,IUPLS  !!! from channels
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	CHARACTER POL(-1:1)*3
      DATA PI/3.141592653589793D0/,POL/'"M"','"0"','"P"'/
	IF(MODE.NE.2)RETURN
C  DO GLOBALLY OVER DISPLACEMENTS AND POLARIZATIONS
	DO 2000 INUC=1,NATOM             !!! over displacements
	DO 1000 MY=-1,1                  !!! over polarizations
      IF(NITER(MY,INUC).EQ.0)GOTO1000
C  READ CHANGE IN CHARGE DENSITY DUE TO SHORT-RANGE PART OF THE POTENTIAL
	IF(NPLZ.EQ.1)CALL DRO_DROFILES(MY,INUC,IQPNT,IUDPX,'R','D',' ')
	IF(NPLZ.EQ.1)CALL DRO_DPSFILES(MY,INUC,IQPNT,IUDPY,'R','D',' ')
	IF(NPLZ.EQ.0)CALL DRO_DROFILES(MY,INUC,IQPNT,IUDRX,'R','D',' ')
	IF(NPLZ.EQ.0)CALL DRO_DPSFILES(MY,INUC,IQPNT,IUDRY,'R','D',' ')
      IF(LPLZ.EQ.0)GOTO100
C  CALCULATE SCREENED "SOFT" PART OF THE RESPONSE
   	CALL DPT_DMULTRHO(MY,INUC,IQPNT)     !!! change in pseudodensity moments
   	CALL DPT_DMULTFTR(MY,INUC,IQPNT,1)   !!! change in multipoles
      CALL DPT_PRINT4(MY,INUC,IQPNT,1)     !!! get screened charge transfer
C  READ CHANGE IN CHARGE DENSITY
	CALL DRO_DROFILES(MY,INUC,IQPNT,IUDPX,'R','D',' ')
      DO IATOM=1,NATOM
      ISORT=IS(IATOM)
      DO IORBS=1,NORBS
      DO IUPDN=1,NSPIN
      DO L=0,ILSV(ISORT)
      DO M=-L,L
      LM=L*(L+1)+M+1
      DO IRAD=0,NRAD(ISORT)
      DRHO(IRAD,LM,IATOM,IUPDN,IORBS)=PRHO(IRAD,LM,IATOM,IUPDN,IORBS)
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      ENDDO
C  *** NEW CHANGE IN CHARGE DENSITY AT THE ITERATION ***
      DO IPTB=1,NPTB                             !!! over {q+G}-vectors
	CALL PLZ_PLZFILES(IPTB,IQPNT,IUPLZ,'R',' ')
      DO IATOM=1,NATOM
      ISORT=IS(IATOM)
      DO IORBS=1,NORBS
      DO IUPDN=1,NSPIN
      DO L=0,ILSV(ISORT)
      DO M=-L,L
      LM=L*(L+1)+M+1
      DO IRAD=0,NRAD(ISORT)
      DRHO(IRAD,LM,IATOM,IUPDN,IORBS)=DRHO(IRAD,LM,IATOM,IUPDN,IORBS)+
     &PRHO(IRAD,LM,IATOM,IUPDN,IORBS)*SCRINT(IPTB,MY,INUC)
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      ENDDO
	DO IORBS=1,NORBS                           !!! over iorbs
	DO IUPDN=1,NSPIN                           !!! over spins
	DO IATOM=1,NATOM                           !!! over atoms
	ISORT=IS(IATOM) 
	DO L=0,ILSB(ISORT)                         !!! over l
      DO M1=-L,L                                 !!! over m1
      LM1=L*(L+1)+M1+1
      DO M=-L,L                                  !!! over m
      LM=L*(L+1)+M+1
      IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M1+1 ! ! (l,m'm)
      DELDHUB(IU,IATOM,IUPDN,IORBS)=DELDHUB(IU,IATOM,IUPDN,IORBS)+
     &DELGHUB(IU,IATOM,IUPDN,IORBS)*SCRINT(IPTB,MY,INUC)
	ENDDO                                      !!! over m1
      ENDDO                                      !!! over m
      ENDDO                                      !!! over l
      ENDDO                                      !!! over atoms
	ENDDO                                      !!! over spins
	ENDDO                                      !!! over iorbs
      ENDDO                                      !!! over {q+G}-vectors
C STORE CHANGE IN CHARGE DENSITY
      DO IATOM=1,NATOM
      ISORT=IS(IATOM)
      DO IORBS=1,NORBS
      DO IUPDN=1,NSPIN
      DO L=0,ILSV(ISORT)
      DO M=-L,L
      LM=L*(L+1)+M+1
      DO IRAD=0,NRAD(ISORT)
      PRHO(IRAD,LM,IATOM,IUPDN,IORBS)=DRHO(IRAD,LM,IATOM,IUPDN,IORBS)
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      ENDDO
	CALL DRO_DROFILES(MY,INUC,IQPNT,IUDPX,'W','D',' ')
C READ CHANGE IN PSEUDODENSITY
	CALL DRO_DPSFILES(MY,INUC,IQPNT,IUDPY,'R','D',' ')
	DO IORBS=1,NORBS
	DO IUPDN=1,NSPIN
	DO IPLW=0,NPLW
	DRHOPS(IPLW,IUPDN,IORBS)=PRHOPS(IPLW,IUPDN,IORBS)
	ENDDO
	ENDDO
	ENDDO
C  NEW CHANGE IN PSEUDODENSITY AT THE ITERATION
      DO IPTB=1,NPTB                             !!! over {q+G}-vectors
	CALL PLZ_PLSFILES(IPTB,IQPNT,IUPLS,'R',' ')
      DO IORBS=1,NORBS                           !!! over iorbs
      DO IUPDN=1,NSPIN                           !!! over spins
      DO IPLW=0,NPLW
      DRHOPS(IPLW,IUPDN,IORBS)=DRHOPS(IPLW,IUPDN,IORBS)+
     &PRHOPS(IPLW,IUPDN,IORBS)*SCRINT(IPTB,MY,INUC)
      ENDDO   
      ENDDO                                      !!! over spins
      ENDDO                                      !!! over iorbs
      ENDDO                                      !!! over {q+G}-vectors
C STORE CHANGE IN PSEUDODENSITY
	DO IORBS=1,NORBS
	DO IUPDN=1,NSPIN
	DO IPLW=0,NPLW
	PRHOPS(IPLW,IUPDN,IORBS)=DRHOPS(IPLW,IUPDN,IORBS)
	ENDDO
	ENDDO
	ENDDO
	CALL DRO_DPSFILES(MY,INUC,IQPNT,IUDPY,'W','D',' ')
C  PRINT INPUT/OUTPUT INDUCED CHARGE TRANSFER
 100	CALL DPT_DMULTRHO(MY,INUC,IQPNT)     !!! change in pseudodensity moments
   	CALL DPT_DMULTFTR(MY,INUC,IQPNT,0)   !!! change in multipoles
      CALL DPT_PRINT4(MY,INUC,IQPNT,2)     !!! printing routine
1000	CONTINUE                         !!! over polarizations
2000	CONTINUE                         !!! over displacements
	END
