	SUBROUTINE DRO_DROFILES(MY,INUC,IQPNT,ICHN,TOPER,TDRHO,AOPER)
************************************************************
*  Reads/writes/initializes induced charge density in      *
*  channels IUDRX/IUDPX                                    *
*  TOPER='R'ead, 'W'rite, 'I'nitialize,'D'elete            *
*  TDRHO='D'rho, 'T'rho , G'rho, 'A'll                     *
************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
      USE COM_PHNCOM,  ONLY : ITERMAX,NITER,EPS,DELZ,DELD,CONVDRO
     &                       ,CONVDMO                                    !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_LATTICE, ONLY : TAU                                        !!! from readstr
	USE COM_RADMESH, ONLY : NRAD,H,R                                   !!! from makerad
	USE COM_SPHERE,  ONLY : SWZ,SMT                                    !!! from readini
      USE COM_MIXDRHO, ONLY : ADMIX1,ADMIN,ADMAX,KEY,ADMOPT              !!! from readini
      USE COM_PLZCOM,  ONLY : NPLZ,LPLZ,IPLZ,NPTB                        !!! from readlrt
      USE COM_MAGDAT,  ONLY : AXMAG                                      !!! from readini
      USE COM_MIXDMAG, ONLY : ADMSPN,ASMIN,ASMAX,KSP,ADSPIN              !!! from readini
      USE COM_MIXDBRD, ONLY : LBROY,IBROY,ADMIXB,ADMIXH                  !!! from readini
	USE COM_MASHDEP, ONLY : NVAL                                       !!! from setup
      USE COM_DELRHO,  ONLY : DRHO,TRHO,GRHO                             !!! from delrho
      USE COM_DELHUB,  ONLY : DELDHUB,DELTHUB,DELGHUB                    !!! from plzfiles
	USE COM_QMESH,   ONLY : NQPNT,QPNT                                 !!! from readpnt
	USE COM_OLDMESH, ONLY : NRAD0,ROLD,AXMAG0                          !!! from drofiles
      USE COM_PLZMOM,  ONLY : PSMAT,SCRMAT,DIEMAT,SCRINT                 !!! from screen
	USE COM_PHNCHN  ,ONLY : IUDRX                                      !!! from channels
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	USE COM_LMTOUT
	USE COM_PHNOUT
	IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER, ALLOCATABLE :: ILSV0(:)
	CHARACTER TDRHO*1,TOPER*1,AOPER*1,STATUS*3,DFILE*130
	LOGICAL EXIST,LDRHO,LTRHO,LGRHO,NDRHO,NTRHO,NGRHO
	REAL*8 QPNT0(3)
	IF(TOPER.NE.' ')THEN
      IF(ICHN.NE.IUDRX)DFILE=SCNFILE(MY,INUC,ICHN)
      IF(ICHN.EQ.IUDRX)DFILE=DROFILE(MY,INUC)
      INQUIRE(FILE=DFILE,EXIST=EXIST)
	IF(.NOT.EXIST)STATUS='NEW'
	IF(     EXIST)STATUS='OLD'
	ENDIF
C Allocate data
	IF(AOPER.EQ.'A')THEN
	ALLOCATE(DRHO(0:NRADMEM,LIMVMEM,NATOMMEM,NSPINMEM,NORBSMEM))
	ALLOCATE(TRHO(0:NRADMEM,LIMVMEM,NATOMMEM,NSPINMEM,NORBSMEM))
	ALLOCATE(GRHO(0:NRADMEM,LIMVMEM,NATOMMEM,NSPINMEM,NORBSMEM))
	ALLOCATE(DELDHUB(LIMB2MEM,NATOMMEM,NSPINMEM,NORBSMEM))
	ALLOCATE(DELGHUB(LIMB2MEM,NATOMMEM,NSPINMEM,NORBSMEM))
	ALLOCATE(DELTHUB(LIMB2MEM,NATOMMEM,NSPINMEM,NORBSMEM))
	ALLOCATE(SCRINT(NENVMEM,-1:1,NATOMMEM))
	IF(.NOT.ALLOCATED(ROLD))ALLOCATE(ROLD(0:NRADMEM,NSORTMEM))
	IF(.NOT.ALLOCATED(NRAD0))ALLOCATE(NRAD0(NSORTMEM))
	IF(.NOT.ALLOCATED(AXMAG0))ALLOCATE(AXMAG0(3,NSORTMEM))
	ENDIF
C *** DELETE FILE
	IF(TOPER.EQ.'D')THEN
      OPEN(UNIT=ICHN,FILE=DFILE,STATUS=STATUS,
     &FORM='UNFORMATTED',ACCESS='SEQUENTIAL')
	CLOSE(UNIT=ICHN,STATUS='DELETE')
	RETURN
	ENDIF
	ALLOCATE(ILSV0(NSORTMEM))
C *** READ DATA FROM DROFILE OR SCNFILE
	IF(TOPER.NE.'I'.AND.TOPER.NE.' ')THEN
      IF(.NOT.EXIST)
     &CALL FULLSTOP('<DROFILES>: FILE MUST EXIST!')
      OPEN(UNIT=ICHN,FILE=DFILE,STATUS='OLD',
     &FORM='UNFORMATTED',ACCESS='SEQUENTIAL')
C Read control information:
      READ(ICHN)NATOM0,NSORT0,NSPIN0,NORBS0,
     &(NRAD0(ISORT),ISORT=1,NSORT0),
     &(ILSV0(ISORT),ISORT=1,NSORT0),(QPNT0(I),I=1,3),
     &((AXMAG0(I,ISORT),I=1,3),ISORT=1,NSORT0)
      READ(ICHN)((ROLD(IRAD,ISORT),IRAD=0,NRAD0(ISORT)),ISORT=1,NSORT) 
      IF(NATOM0.NE.NATOM)
     &CALL FULLSTOP('<DROFILES>: # OF ATOMS MISMATCH')
      IF(NSORT0.NE.NSORT)
     &CALL FULLSTOP('<DROFILES>: # OF SORTS MISMATCH')
      IF(NSPIN0.NE.NSPIN)
     &CALL FULLSTOP('<DROFILES>: # OF SPINS MISMATCH')
      IF(NORBS0.NE.NORBS)
     &CALL FULLSTOP('<DROFILES>: # OF NORBS MISMATCH')
	DO ISORT=1,NSORT
	IF(NRAD0(ISORT).GT.NRADMEM)
     &CALL FULLSTOP('<DROFILES>:: NRAD0>NRADMAX')
	IF(ILSV0(ISORT).GT.LMAXVMEM)
     &CALL FULLSTOP('<DROFILES>:: ILSV0>LMAXV  ')
	ENDDO
C Understand what to read:
	LDRHO=(TOPER.EQ.'R'.AND.(TDRHO.EQ.'D'.OR .TDRHO.EQ.'A'))
	LTRHO=(TOPER.EQ.'R'.AND.(TDRHO.EQ.'T'.OR .TDRHO.EQ.'A'))
	LGRHO=(TOPER.EQ.'R'.AND.(TDRHO.EQ.'G'.OR .TDRHO.EQ.'A'))
	LDRHO=(TOPER.EQ.'W'.AND.(TDRHO.NE.'D'.AND.TDRHO.NE.'A')).OR.
     &LDRHO
	LTRHO=(TOPER.EQ.'W'.AND.(TDRHO.NE.'T'.AND.TDRHO.NE.'A')).OR.
     &LTRHO
	LGRHO=(TOPER.EQ.'W'.AND.(TDRHO.NE.'G'.AND.TDRHO.NE.'A')).OR.
     &LGRHO
	LTRHO=LTRHO.AND.ICHN.EQ.IUDRX
	LGRHO=LGRHO.AND.ICHN.EQ.IUDRX
	NDRHO=.NOT.LDRHO
	NTRHO=.NOT.LTRHO.AND.ICHN.EQ.IUDRX
	NGRHO=.NOT.LGRHO.AND.ICHN.EQ.IUDRX
C Read change in charge density:
      DO IATOM=1,NATOM                           !!! over atoms
      ISORT=IS(IATOM)
	LGRHO=LGRHO.AND.IATOM.EQ.INUC
	NGRHO=NGRHO.AND.IATOM.EQ.INUC
      DO IORBS=1,NORBS                           !!! over iorbs
      DO IUPDN=1,NSPIN                           !!! over spins
      IF(LDRHO)READ(ICHN)((DRHO(IRAD,LM,IATOM,IUPDN,IORBS),
     &  IRAD=0,NRAD0(ISORT)),LM=1,(ILSV0(ISORT)+1)**2)
	IF(NDRHO)READ(ICHN)
      IF(LTRHO)READ(ICHN)((TRHO(IRAD,LM,IATOM,IUPDN,IORBS),
     &  IRAD=0,NRAD0(ISORT)),LM=1,(ILSV0(ISORT)+1)**2)
	IF(NTRHO)READ(ICHN)
      IF(LGRHO)READ(ICHN)((GRHO(IRAD,LM,IATOM,IUPDN,IORBS),
     &  IRAD=0,NRAD0(ISORT)),LM=1,(ILSV0(ISORT)+1)**2)
	IF(NGRHO)READ(ICHN)
      IF(LDRHO)READ(ICHN)(DELDHUB(IU,IATOM,IUPDN,IORBS),
     &  IU=1,(ILSB(ISORT)+1)*(2*ILSB(ISORT)+1)*(2*ILSB(ISORT)+3)/3)
	IF(NDRHO)READ(ICHN)
      IF(LTRHO)READ(ICHN)(DELTHUB(IU,IATOM,IUPDN,IORBS),
     &  IU=1,(ILSB(ISORT)+1)*(2*ILSB(ISORT)+1)*(2*ILSB(ISORT)+3)/3)
	IF(NTRHO)READ(ICHN)
      IF(LGRHO)READ(ICHN)(DELGHUB(IU,IATOM,IUPDN,IORBS),
     &  IU=1,(ILSB(ISORT)+1)*(2*ILSB(ISORT)+1)*(2*ILSB(ISORT)+3)/3)
	IF(NGRHO)READ(ICHN)
C Set zeroes for higher l's
	DO L=ILSV0(ISORT)+1,ILSV(ISORT)
	DO M=-L,L
	LM=L*(L+1)+M+1
	DO IRAD=0,NRAD0(ISORT)
	IF(LDRHO)DRHO(IRAD,LM,IATOM,IUPDN,IORBS)=(0.D0,0.D0)
	IF(LTRHO)TRHO(IRAD,LM,IATOM,IUPDN,IORBS)=(0.D0,0.D0)
	IF(LGRHO)GRHO(IRAD,LM,IATOM,IUPDN,IORBS)=(0.D0,0.D0)
	ENDDO
	ENDDO
	ENDDO
	ENDDO                                      !!! over spins
	ENDDO                                      !!! over iorbs
	ENDDO                                      !!! over atoms
C Read screened long-range interaction:
	IF(ICHN.EQ.IUDRX.AND.TOPER.EQ.'R'.AND.TDRHO.EQ.'A')
     &READ(ICHN)NPTB0,(SCRINT(IPTB,MY,INUC),IPTB=1,NPTB0)
	CLOSE(ICHN)
	ENDIF
C **** INITIALIZE CHANGE IN CHARGE DENSITY
	IF(TOPER.EQ.'I')THEN
	LDRHO=.TRUE.
	LTRHO=ICHN.EQ.IUDRX
	LGRHO=ICHN.EQ.IUDRX
	DO IATOM=1,NATOM                           !!! over atoms
	ISORT=IS(IATOM)
	LGRHO=LGRHO.AND.IATOM.EQ.INUC
	DO IORBS=1,NORBS                           !!! over iorbs
	DO IUPDN=1,NSPIN                           !!! over spins
	DO L=0,ILSV(ISORT)
	DO M=-L,L
	LM=L*(L+1)+M+1
	DO IRAD=0,NRAD(ISORT)
	IF(LDRHO)DRHO(IRAD,LM,IATOM,IUPDN,IORBS)=(0.D0,0.D0)
	IF(LTRHO)TRHO(IRAD,LM,IATOM,IUPDN,IORBS)=(0.D0,0.D0)
	IF(LGRHO)GRHO(IRAD,LM,IATOM,IUPDN,IORBS)=(0.D0,0.D0)
	ENDDO
	ENDDO
	ENDDO
	ENDDO                                      !!! over spins
	ENDDO                                      !!! over iorbs
	ENDDO                                      !!! over atoms
	DO IORBS=1,NORBS                           !!! over iorbs
	DO IUPDN=1,NSPIN                           !!! over spins
	DO IATOM=1,NATOM                           !!! over atoms
	ISORT=IS(IATOM) 
	DO L=0,ILSB(ISORT)                         !!! over l
      DO M1=-L,L                                 !!! over m1
      LM1=L*(L+1)+M1+1
      DO M=-L,L                                  !!! over m
      LM=L*(L+1)+M+1
      IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M1+1 ! ! (l,m'm)
      IF(LDRHO)DELDHUB(IU,IATOM,IUPDN,IORBS)=(0.D0,0.D0)
      IF(LTRHO)DELTHUB(IU,IATOM,IUPDN,IORBS)=(0.D0,0.D0)
      IF(LGRHO)DELGHUB(IU,IATOM,IUPDN,IORBS)=(0.D0,0.D0)
	ENDDO                                      !!! over m1
      ENDDO                                      !!! over m
      ENDDO                                      !!! over l
      ENDDO                                      !!! over atoms
	ENDDO                                      !!! over spins
	ENDDO                                      !!! over iorbs
C INITIALIZE CONVERGENCY CRITERIUM
      DO IA=0,3
	CONVDRO(IA,MY,INUC)=(1.D+05,1.D+05)
	ENDDO
C INITIALIZE SCREENED LONG RANGE INTERACTION
	DO IPTB=1,NPTB
	IF(ICHN.EQ.IUDRX)SCRINT(IPTB,MY,INUC)=(0.D0,0.D0)
	ENDDO
	ENDIF
C **** STORE DATA IN DROFILE OR SCNFILE
	IF(TOPER.NE.'R'.AND.TOPER.NE.' ')THEN
	OPEN(UNIT=ICHN,FILE=DFILE,STATUS=STATUS,
     &FORM='UNFORMATTED',ACCESS='SEQUENTIAL')
	CLOSE(UNIT=ICHN,STATUS='DELETE')
	OPEN(UNIT=ICHN,FILE=DFILE,STATUS='NEW',
     &FORM='UNFORMATTED',ACCESS='SEQUENTIAL')
C Store control information:
      WRITE(ICHN)NATOM,NSORT,NSPIN,NORBS,
     &(NRAD(ISORT),ISORT=1,NSORT),
     &(ILSV(ISORT),ISORT=1,NSORT),(QPNT(I,IQPNT),I=1,3),
     &((AXMAG(I,ISORT),I=1,3),ISORT=1,NSORT),
     &NITER (MY,INUC),EPS   (MY,INUC),KEY  (MY,INUC),
     &KSP   (MY,INUC),LBROY (MY,INUC),ADMIN(MY,INUC),
     &ADMAX (MY,INUC),ASMIN (MY,INUC),ASMAX(MY,INUC),
     &ADMIXB(MY,INUC),ADMIXH(MY,INUC),
     &(CONVDRO(IA,MY,INUC),IA=0,3)
      WRITE(ICHN)((R(IRAD,ISORT),IRAD=0,NRAD(ISORT)),ISORT=1,NSORT) 
C Store change in charge density:
	LDRHO=.TRUE.
	LTRHO=ICHN.EQ.IUDRX
	LGRHO=ICHN.EQ.IUDRX
      DO IATOM=1,NATOM                           !!! over atoms
      ISORT=IS(IATOM)
	LGRHO=LGRHO.AND.IATOM.EQ.INUC
      DO IORBS=1,NORBS                           !!! over iorbs
      DO IUPDN=1,NSPIN                           !!! over spins
      IF(LDRHO)WRITE(ICHN)((DRHO(IRAD,LM,IATOM,IUPDN,IORBS),
     &  IRAD=0,NRAD(ISORT)),LM=1,(ILSV(ISORT)+1)**2)
      IF(LTRHO)WRITE(ICHN)((TRHO(IRAD,LM,IATOM,IUPDN,IORBS),
     &  IRAD=0,NRAD(ISORT)),LM=1,(ILSV(ISORT)+1)**2)
      IF(LGRHO)WRITE(ICHN)((GRHO(IRAD,LM,IATOM,IUPDN,IORBS),
     &  IRAD=0,NRAD(ISORT)),LM=1,(ILSV(ISORT)+1)**2)
      IF(LDRHO)WRITE(ICHN)(DELDHUB(IU,IATOM,IUPDN,IORBS),
     &  IU=1,(ILSB(ISORT)+1)*(2*ILSB(ISORT)+1)*(2*ILSB(ISORT)+3)/3)
      IF(LTRHO)WRITE(ICHN)(DELTHUB(IU,IATOM,IUPDN,IORBS),
     &  IU=1,(ILSB(ISORT)+1)*(2*ILSB(ISORT)+1)*(2*ILSB(ISORT)+3)/3)
      IF(LGRHO)WRITE(ICHN)(DELGHUB(IU,IATOM,IUPDN,IORBS),
     &  IU=1,(ILSB(ISORT)+1)*(2*ILSB(ISORT)+1)*(2*ILSB(ISORT)+3)/3)
	ENDDO                                      !!! over spins
	ENDDO                                      !!! over iorbs
	ENDDO                                      !!! over atoms
C Store screened long-range interaction:
	IF(ICHN.EQ.IUDRX)
     &WRITE(ICHN)NPTB,(SCRINT(IPTB,MY,INUC),IPTB=1,NPTB)
	CLOSE(ICHN)
	ENDIF
C Deallocate data
	IF(AOPER.EQ.'D')THEN
	DEALLOCATE(DRHO,TRHO,GRHO,DELDHUB,DELTHUB,DELGHUB,SCRINT)
	IF(ALLOCATED(ROLD))DEALLOCATE(ROLD)
	IF(ALLOCATED(NRAD0))DEALLOCATE(NRAD0)
	IF(ALLOCATED(AXMAG0))DEALLOCATE(AXMAG0)
	ENDIF
	DEALLOCATE(ILSV0)
	END




	SUBROUTINE DRO_DPSFILES(MY,INUC,IQPNT,ICHN,TOPER,TDRHO,AOPER)
************************************************************
*  Reads/writes/initializes induced charge density in      *
*  channels IUDRY/IUDPY                                    *
*  TOPER='R'ead, 'W'rite, or 'I'nitialize                  *
*  TDRHO='D'rho, 'T'rho, 'G'rho 'A'll                      *
************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
      USE COM_PHNCOM,  ONLY : ITERMAX,NITER                              !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_LATTICE, ONLY : RBAS,GBAS                                  !!! from readstr
      USE COM_MAGDAT,  ONLY : AXMAG                                      !!! from readini
	USE COM_DELRHO,  ONLY : DRHOPS,TRHOPS,GRHOPS,DRHOPS1               !!! from delrho
	USE COM_QMESH,   ONLY : NQPNT,QPNT                                 !!! from readpnt
	USE COM_LATPAR,  ONLY : PAR,ORTH,OMEGAC                            !!! from readini
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	USE COM_PLWMESH, ONLY : NPLW,GPLW                                  !!! from makeplw
	USE COM_OLDMESH, ONLY : NPLW0,GPLW0,RBAS0,GBAS0,ORTH0              !!! from dpsfiles
	USE COM_PHNCHN  ,ONLY : IUDRY                                      !!! from channels
	USE COM_MASHDEP, ONLY : NVAL                                       !!! from setup
	USE COM_LMTOUT
	USE COM_PHNOUT
	IMPLICIT REAL*8 (A-H,O-Z)
	CHARACTER TDRHO*1,TOPER*1,AOPER*1,STATUS*3,DFILE*130
	LOGICAL EXIST,LDRHO,LTRHO,LGRHO,NDRHO,NTRHO,NGRHO
	DIMENSION QPNT0(3)
	IF(TOPER.NE.' ')THEN
      IF(ICHN.NE.IUDRY)DFILE=SCNFILE(MY,INUC,ICHN)
      IF(ICHN.EQ.IUDRY)DFILE=DPSFILE(MY,INUC)
      INQUIRE(FILE=DFILE,EXIST=EXIST)
	IF(.NOT.EXIST)STATUS='NEW'
	IF(     EXIST)STATUS='OLD'
	ENDIF
C Allocate data
	IF(AOPER.EQ.'A')THEN
	ALLOCATE(DRHOPS(0:NPLWMEM,NSPINMEM,NORBSMEM))
	ALLOCATE(TRHOPS(0:NPLWMEM,NSPINMEM,NORBSMEM))
	ALLOCATE(GRHOPS(0:NPLWMEM,NSPINMEM,NORBSMEM))
	ALLOCATE(DRHOPS1(0:NPLWMEM,NSPINMEM,2))
	IF(.NOT.ALLOCATED(GPLW0))ALLOCATE(GPLW0(3,0:NPLWMEM))
	ENDIF
C *** DELETE FILE
	IF(TOPER.EQ.'D')THEN
      OPEN(UNIT=ICHN,FILE=DFILE,STATUS='OLD',
     &FORM='UNFORMATTED',ACCESS='SEQUENTIAL')
	CLOSE(UNIT=ICHN,STATUS='DELETE')
	RETURN
	ENDIF
C *** READ DATA FROM DPSFILE OR SCNFILE
	IF(TOPER.NE.'I'.AND.TOPER.NE.' ')THEN
      IF(.NOT.EXIST)
     &CALL FULLSTOP('<DPSFILES>: FILE MUST EXIST!')
      OPEN(UNIT=ICHN,FILE=DFILE,STATUS='OLD',
     &  FORM='UNFORMATTED',ACCESS='SEQUENTIAL')
C Read control information:
	IF(ICHN.EQ.IUDRY)
     &  READ(ICHN)NPLW0,((GPLW0(I,IPLW),I=1,3),IPLW=0,NPLW0),
     &  ORTH0,GBAS0,RBAS0
	IF(ICHN.NE.IUDRY)NPLW0=NPLW
      IF(NPLW0.GT.NPLWMEM)
     &CALL FULLSTOP('<DPSFILES>: NPLW0>NPLWMEM')
C Understand what to read:
	LDRHO=(TOPER.EQ.'R'.AND.(TDRHO.EQ.'D'.OR .TDRHO.EQ.'A'))
	LTRHO=(TOPER.EQ.'R'.AND.(TDRHO.EQ.'T'.OR .TDRHO.EQ.'A'))
	LGRHO=(TOPER.EQ.'R'.AND.(TDRHO.EQ.'G'.OR .TDRHO.EQ.'A'))
	LDRHO=(TOPER.EQ.'W'.AND.(TDRHO.NE.'D'.AND.TDRHO.NE.'A')).OR.
     &  LDRHO
	LTRHO=(TOPER.EQ.'W'.AND.(TDRHO.NE.'T'.AND.TDRHO.NE.'A')).OR.
     &  LTRHO
	LGRHO=(TOPER.EQ.'W'.AND.(TDRHO.NE.'G'.AND.TDRHO.NE.'A')).OR.
     &  LGRHO
	LTRHO=LTRHO.AND.ICHN.EQ.IUDRY
	LGRHO=LGRHO.AND.ICHN.EQ.IUDRY
	NDRHO=.NOT.LDRHO
	NTRHO=.NOT.LTRHO.AND.ICHN.EQ.IUDRY
	NGRHO=.NOT.LGRHO.AND.ICHN.EQ.IUDRY
C Read change in pseudodensity:
	DO IORBS=1,NORBS
	DO IUPDN=1,NSPIN
      IF(LDRHO)READ(ICHN)(DRHOPS(IPLW,IUPDN,IORBS),IPLW=0,NPLW0)
	IF(NDRHO)READ(ICHN)
      IF(LTRHO)READ(ICHN)(TRHOPS(IPLW,IUPDN,IORBS),IPLW=0,NPLW0)
	IF(NTRHO)READ(ICHN)
      IF(LGRHO)READ(ICHN)(GRHOPS(IPLW,IUPDN,IORBS),IPLW=0,NPLW0)
	IF(NGRHO)READ(ICHN)
C Set zeroes for higher plw's
	DO IPLW=NPLW0+1,NPLW
	IF(LDRHO)DRHOPS(IPLW,IUPDN,IORBS)=(0.D0,0.D0)
	IF(LTRHO)TRHOPS(IPLW,IUPDN,IORBS)=(0.D0,0.D0)
	IF(LGRHO)GRHOPS(IPLW,IUPDN,IORBS)=(0.D0,0.D0)
	ENDDO
	ENDDO
	ENDDO                                      !!! over spins
	CLOSE(ICHN)
	ENDIF
C **** INITIALIZE CHANGE IN CHARGE DENSITY
	IF(TOPER.EQ.'I')THEN
	LDRHO=.TRUE.
	LTRHO=ICHN.EQ.IUDRY
	LGRHO=ICHN.EQ.IUDRY
	DO IORBS=1,NORBS                           !!! over iorbs
	DO IUPDN=1,NSPIN                           !!! over spins
	DO IPLW=0,NPLW
	IF(LDRHO)DRHOPS(IPLW,IUPDN,IORBS)=(0.D0,0.D0)
	IF(LTRHO)TRHOPS(IPLW,IUPDN,IORBS)=(0.D0,0.D0)
	IF(LGRHO)GRHOPS(IPLW,IUPDN,IORBS)=(0.D0,0.D0)
	ENDDO
	ENDDO
	ENDDO                                      !!! over spins
	ENDIF
C **** STORE DATA IN DROFILE OR SCNFILE
	IF(TOPER.NE.'R'.AND.TOPER.NE.' ')THEN
	OPEN(UNIT=ICHN,FILE=DFILE,STATUS=STATUS,
     &FORM='UNFORMATTED',ACCESS='SEQUENTIAL')
	CLOSE(UNIT=ICHN,STATUS='DELETE')
	OPEN(UNIT=ICHN,FILE=DFILE,STATUS='NEW',
     &FORM='UNFORMATTED',ACCESS='SEQUENTIAL')
C Store control information:
	IF(ICHN.EQ.IUDRY)
     &WRITE(ICHN)NPLW,((GPLW(I,IPLW),I=1,3),IPLW=0,NPLW),
     &ORTH,GBAS,RBAS
C Store change in charge density:
	LDRHO=.TRUE.
	LTRHO=ICHN.EQ.IUDRY
	LGRHO=ICHN.EQ.IUDRY
      DO IORBS=1,NORBS                           !!! over iorbs
      DO IUPDN=1,NSPIN                           !!! over spins
      IF(LDRHO)WRITE(ICHN)(DRHOPS(IPLW,IUPDN,IORBS),IPLW=0,NPLW)
      IF(LTRHO)WRITE(ICHN)(TRHOPS(IPLW,IUPDN,IORBS),IPLW=0,NPLW)
      IF(LGRHO)WRITE(ICHN)(GRHOPS(IPLW,IUPDN,IORBS),IPLW=0,NPLW)
	ENDDO                                      !!! over spins
	ENDDO                                      !!! over iorbs
	CLOSE(ICHN)
	ENDIF
C Deallocate data
	IF(AOPER.EQ.'D')THEN
	DEALLOCATE(DRHOPS,TRHOPS,GRHOPS,DRHOPS1)
	IF(ALLOCATED(GPLW0))DEALLOCATE(GPLW0)
	ENDIF
	END
