	SUBROUTINE DRO_GRADRHO(IQPNT)
**********************************************************
* Optional calculation of the charge density gradient.   *
**********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
      USE COM_PHNCOM,  ONLY : ITERMAX,NITER                              !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
     &                       ,LRTV
	USE COM_SYMMLM,  ONLY : SYM                                        !!! from makesym
	USE COM_RADMESH, ONLY : NRAD,H,R,DR,WEIGHT                         !!! from radmsh
	USE COM_PANPAR,  ONLY : LTPAN,LSPAN,IATS,ISTS                      !!! from readini
	USE COM_KAPPAR,  ONLY : NPAN,NKAP,EK,EKAP                          !!! from readini
	USE COM_SPHERE,  ONLY : SWZ,SMT                                    !!! from readini
	USE COM_HAMPAR  ,ONLY : ATOSHH=>HPARHH                              !!! from tospar
     &                       ,ATOSJH=>HPARJH
     &                       ,ATOSHJ=>HPARHJ
     &                       ,ATOSJJ=>HPARJJ 
      USE COM_INPPAR,  ONLY : TNY,ENY,DNY                                !!! from readini
	USE COM_LMTPAR,  ONLY : GAM,AAH,BBH,AAJ,BBJ                        !!! from potpar
	USE COM_POTDAT,  ONLY : POTRWF                                     !!! from fulpot
	USE COM_DELRHO,  ONLY : GRHO                                       !!! from gradrho
	USE COM_GAUNT,   ONLY : C                                          !!! from makegnt
	USE COM_MASHDEP, ONLY : NVAL                                       !!! from setup
	USE COM_CHANNELS,ONLY : IUTOS                                      !!! from channels
	USE COM_PHNCHN  ,ONLY : IUDRO,IUDPX,IUDRX,IUDPY,IUDRY              !!! from channels
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: FIH(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: FIHD(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: FIJ(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: FIJD(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: FIHDD(:,:)
	COMPLEX*16, ALLOCATABLE :: FIJDD(:,:)
	COMPLEX*16, ALLOCATABLE :: DRODR(:,:)
	COMPLEX*16, ALLOCATABLE :: ROR(:,:) 
	REAL*8, ALLOCATABLE :: AFI(:,:)
	REAL*8, ALLOCATABLE :: AFID(:,:)
	REAL*8, ALLOCATABLE :: AFIP(:,:)
	REAL*8, ALLOCATABLE :: AFIDP(:,:)
	REAL*8, ALLOCATABLE :: AFIDDS(:)
	REAL*8, ALLOCATABLE :: AFIDDPS(:)
	COMPLEX*16 CGNT,T(4)
	LOGICAL LOG1,LOG
	DATA PI/3.141592653589793D0/
C Memory allocations
	ALLOCATE(FIH(0:NRADMEM,0:LMAXTMEM,NKAPMEM,NSPINMEM))
	ALLOCATE(FIHD(0:NRADMEM,0:LMAXTMEM,NKAPMEM,NSPINMEM))
	ALLOCATE(FIJ(0:NRADMEM,0:LMAXTMEM,NKAPMEM,NSPINMEM))
	ALLOCATE(FIJD(0:NRADMEM,0:LMAXTMEM,NKAPMEM,NSPINMEM))
	ALLOCATE(FIHDD(0:LMAXTMEM,NKAPMEM))
	ALLOCATE(FIJDD(0:LMAXTMEM,NKAPMEM))
	ALLOCATE(DRODR(0:NRADMEM,LIMVMEM))
	ALLOCATE(ROR(0:NRADMEM,LIMVMEM))
	ALLOCATE(AFI(0:NRADMEM,0:LMAXTMEM))
	ALLOCATE(AFID(0:NRADMEM,0:LMAXTMEM))
	ALLOCATE(AFIP(0:NRADMEM,0:LMAXTMEM))
	ALLOCATE(AFIDP(0:NRADMEM,0:LMAXTMEM))
	ALLOCATE(AFIDDS(0:LMAXTMEM))
	ALLOCATE(AFIDDPS(0:LMAXTMEM))
	SQPI4=2.D0*SQRT(PI)
	SQPI43=SQRT(4.D0*PI/3.D0)
	IF(MODE.EQ.2.OR.MODE.EQ.4.OR.MODE.EQ.5)RETURN
C  *** DO GLOBALLY OVER DISPLACEMENTS AND POLARIZATIONS ***
	DO 4000 INUC=1,NATOM                        !!! over displacements
	DO 3000 MY=-1,1                             !!! over polarizations
	IF(NITER(MY,INUC).EQ.0)GOTO3000
	IATOM=INUC
	ISORT=IS(IATOM)
	DO 2000 IPAN=1,NPAN                         !!! over panels
C  Find FIny and FIny-dot radial functions as well as their variations
      DO ISPIN=1,NSPIN                            !!! over spins
      DO IKAP=1,NKAP(IPAN)                        !!! over energies
      CALL LIB_RADSCH_PHIS(ENY(0,ISORT,IKAP,IPAN,ISPIN),AFI,AFIP,
     &AFID,AFIDP,AFIDDS,AFIDDPS,SMT(ISORT),POTRWF(0,ISORT,ISPIN),
     &ILST(ISORT),NRAD(ISORT),H(ISORT),R(0,ISORT),DR(0,ISORT),
     &LRTV(ISORT))
C  Transfere to FIH,FIJ convinient functions:
      DO L=0,ILST(ISORT)
      DO IRAD=0,NRAD(ISORT)
      FIH (IRAD,L,IKAP,ISPIN)=AAH(L,ISORT,IKAP,IPAN,ISPIN)*AFI(IRAD,L)+
     &BBH(L,ISORT,IKAP,IPAN,ISPIN)*AFIP(IRAD,L)
      FIJ (IRAD,L,IKAP,ISPIN)=AAJ(L,ISORT,IKAP,IPAN,ISPIN)*AFI(IRAD,L)+
     &BBJ(L,ISORT,IKAP,IPAN,ISPIN)*AFIP(IRAD,L)
      FIHD(IRAD,L,IKAP,ISPIN)=AAH(L,ISORT,IKAP,IPAN,ISPIN)*AFID(IRAD,L)+
     &BBH(L,ISORT,IKAP,IPAN,ISPIN)*AFIDP(IRAD,L)
      FIJD(IRAD,L,IKAP,ISPIN)=AAJ(L,ISORT,IKAP,IPAN,ISPIN)*AFID(IRAD,L)+
     &BBJ(L,ISORT,IKAP,IPAN,ISPIN)*AFIDP(IRAD,L)
      ENDDO   
      ENDDO   
      ENDDO                                      !!! over energies
      ENDDO                                      !!! over spins
	DO 1200 IORBS=1,NORBS                      !!! over spins
	DO 1100 IUPDN=1,NSPIN                      !!! over spins
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
C  INITIALIZE CHARGE DENSITY GRADIENT
	DO L2=0,ILSV(ISORT)
	DO M2=-L2,L2        
	LM2=L2*(L2+1)+M2+1
	DO IRAD=0,NRAD(ISORT)
	IF(IPAN.EQ.1)GRHO(IRAD,LM2,IATOM,IUPDN,IORBS)=(0.D0,0.D0)
	DRODR(IRAD,LM2)=(0.D0,0.D0)
	ROR  (IRAD,LM2)=(0.D0,0.D0)
	ENDDO
	ENDDO
	ENDDO
	DO IKAP1=1,NKAP(IPAN)                      !!! over energies
	DO IKAP=1,NKAP(IPAN)                       !!! over energies
C  READ TOS-MATRIX FROM THE SCRATCH FILE
	NSHIFT=0
	DO JPAN=1,NPAN
	IF(JPAN.LT.IPAN)
     &NSHIFT=NSHIFT+NKAP(JPAN)**2*NATOM*NSPIN*NORBS
      ENDDO
	IREC=IKAP1+NKAP(IPAN)*(IKAP-1)+NKAP(IPAN)**2*(IATOM-1)+
     &NKAP(IPAN)**2*NATOM*(IUPDN-1)+NKAP(IPAN)**2*NATOM*NSPIN*(IORBS-1)+
     &NSHIFT
      READ(IUTOS,REC=IREC)((ATOSHH(L1M1,LM,IATOM),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((ATOSJH(L1M1,LM,IATOM),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((ATOSHJ(L1M1,LM,IATOM),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &((ATOSJJ(L1M1,LM,IATOM),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2)
C  CALCULATE CHARGE DENSITY RADIAL DERIVATIVE
	DO L1=0,ILST(ISORT)                     !!! over l1
	LOG1=.FALSE.
	IF(LTPAN(L1,IATOM,IKAP1,IPAN))LOG1=.TRUE.
	DO M1=-L1,L1                            !!! over m1
	LM1=L1*(L1+1)+M1+1
	DO L=0,ILST(ISORT)                      !!! over l
	LOG=.FALSE.
	IF(LTPAN(L,IATOM,IKAP,IPAN))LOG=.TRUE.
	DO M=-L,L                               !!! over m
	LM=L*(L+1)+M+1
 	DO L2=ABS(L1-L),L1+L,2                  !!! over l2 (expansion of dro)
 	M2=M-M1
	LM2=L2*(L2+1)+M2+1
	IF(ABS(M2).LE.L2.AND.L2.LE.ILSV(ISORT))THEN! over m2 (expansion of dro)
 	CGNT=(0.D0,1.D0)**(L-L1-L2)*C(L2/2,LM,LM1)
	DO IRAD=0,NRAD(ISORT)                   !!! over radial mesh
	IF(LOG1.AND.LOG)
     &DRODR(IRAD,LM2)=DRODR(IRAD,LM2)+
     &ATOSHH(LM1,LM,IATOM)*(
     &CONJG(FIHD(IRAD,L1,IKAP1,ISPIN1))*FIH (IRAD,L,IKAP,ISPIN)+
     &CONJG(FIH (IRAD,L1,IKAP1,ISPIN1))*FIHD(IRAD,L,IKAP,ISPIN))*CGNT
	IF(LOG1)
     &DRODR(IRAD,LM2)=DRODR(IRAD,LM2)-
     &ATOSHJ(LM1,LM,IATOM)*(
     &CONJG(FIHD(IRAD,L1,IKAP1,ISPIN1))*FIJ (IRAD,L,IKAP,ISPIN)+
     &CONJG(FIH (IRAD,L1,IKAP1,ISPIN1))*FIJD(IRAD,L,IKAP,ISPIN))*
     &GAM(L,ISORT)*CGNT
	IF(LOG)
     &DRODR(IRAD,LM2)=DRODR(IRAD,LM2)-
     &ATOSJH(LM1,LM,IATOM)*(
     &CONJG(FIJD(IRAD,L1,IKAP1,ISPIN1))*FIH (IRAD,L,IKAP,ISPIN)+
     &CONJG(FIJ (IRAD,L1,IKAP1,ISPIN1))*FIHD(IRAD,L,IKAP,ISPIN))*
     &GAM(L1,ISORT)*CGNT
	DRODR(IRAD,LM2)=DRODR(IRAD,LM2)+
     &ATOSJJ(LM1,LM,IATOM)*(
     &CONJG(FIJD(IRAD,L1,IKAP1,ISPIN1))*FIJ (IRAD,L,IKAP,ISPIN)+
     &CONJG(FIJ (IRAD,L1,IKAP1,ISPIN1))*FIJD(IRAD,L,IKAP,ISPIN))*
     &GAM(L1,ISORT)*GAM(L,ISORT)*CGNT
C  CALCULATE CHARGE DENSITY ITSELF
      IF(LOG1.AND.LOG)
     &ROR(IRAD,LM2)=ROR(IRAD,LM2)+
     &(ATOSHH(LM1,LM,IATOM)*
     &CONJG(FIH(IRAD,L1,IKAP1,ISPIN1))*FIH(IRAD,L,IKAP,ISPIN))*CGNT
      IF(LOG1)
     &ROR(IRAD,LM2)=ROR(IRAD,LM2)-
     &(ATOSHJ(LM1,LM,IATOM)*
     &CONJG(FIH(IRAD,L1,IKAP1,ISPIN1))*FIJ(IRAD,L,IKAP,ISPIN)*
     &GAM(L,ISORT))*CGNT
      IF(LOG)
     &ROR(IRAD,LM2)=ROR(IRAD,LM2)-
     &(ATOSJH(LM1,LM,IATOM)*
     &CONJG(FIJ(IRAD,L1,IKAP1,ISPIN1))*FIH(IRAD,L,IKAP,ISPIN)*
     &GAM(L1,ISORT))*CGNT
     	ROR(IRAD,LM2)=ROR(IRAD,LM2)+
     &(ATOSJJ(LM1,LM,IATOM)*
     &CONJG(FIJ(IRAD,L1,IKAP1,ISPIN1))*FIJ(IRAD,L,IKAP,ISPIN)*
     &GAM(L1,ISORT)*GAM(L,ISORT))*CGNT
      ENDDO                                   !!! over radial mesh
	ENDIF                                   !!! over m2 (expansion of dro)
      ENDDO                                   !!! over l2 (expansion of dro)
      ENDDO                                   !!! over m
      ENDDO                                   !!! over l
      ENDDO                                   !!! over m1
      ENDDO                                   !!! over l1
      ENDDO                                   !!! over energies
      ENDDO                                   !!! over energies
C  CALCULATE CHARGE DENSITY GRADIENT
	DO L2=0,ILSV(ISORT)                     !!! over l2
	DO M2=-L2,L2                            !!! over m2
	LM2=L2*(L2+1)+M2+1
	IF(L2.GT.0.AND.(L2-1).GE.ABS(M2-MY))THEN
	L2MY=L2*(L2-1)+M2-MY+1
	CGNT=C(0,LM2,L2MY)*SQPI43*(0.D0,-1.D0)
	DO IRAD=1,NRAD(ISORT)
	GRHO(IRAD,LM2,IATOM,IUPDN,IORBS)=GRHO(IRAD,LM2,IATOM,IUPDN,IORBS)+
     &CGNT*(DRODR(IRAD,L2MY)-DBLE(L2-1)/R(IRAD,ISORT)*ROR(IRAD,L2MY))
      ENDDO    
	ENDIF
	IF(L2.LT.ILSV(ISORT))THEN
	L2MY=(L2+1)*(L2+2)+M2-MY+1
	CGNT=C(0,LM2,L2MY)*SQPI43*(0.D0,1.D0)
	DO IRAD=1,NRAD(ISORT)
	GRHO(IRAD,LM2,IATOM,IUPDN,IORBS)=GRHO(IRAD,LM2,IATOM,IUPDN,IORBS)+
     &CGNT*(DRODR(IRAD,L2MY)+DBLE(L2+2)/R(IRAD,ISORT)*ROR(IRAD,L2MY))
      ENDDO    
	ENDIF
	GRHO(0,LM2,IATOM,IUPDN,IORBS)=GRHO(1,LM2,IATOM,IUPDN,IORBS)
      ENDDO                                   !!! over m2 
      ENDDO                                   !!! over l2
1100 	CONTINUE                                !!! over spins
1200 	CONTINUE                                !!! over iorbs
2000 	CONTINUE                                !!! over panels
C STORE CHARGE DENSITY GRADIENT
	CALL DRO_DROFILES(MY,INUC,IQPNT,IUDRX,'W','G',' ')
3000	CONTINUE                                !!! over polarizations
4000	CONTINUE                                !!! over displacements
C Memory deallocations
	DEALLOCATE(FIH,FIHD,FIJ,FIJD,FIHDD,FIJDD)
	DEALLOCATE(DRODR,ROR,AFI,AFID)
	DEALLOCATE(AFIP,AFIDP,AFIDDS,AFIDDPS)
      END
