	SUBROUTINE DRO_GRADRPS(IQPNT)
****************************************************************
* Computes gradient of the pseudodensity
****************************************************************
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
      USE COM_PHNCOM,  ONLY : ITERMAX,NITER                              !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_LATPAR,  ONLY : PAR,ORTH,OMEGAC                            !!! from readini
	USE COM_SPHERE,  ONLY : SWZ,SMT,ZNUC,ZCOR                          !!! from readini
	USE COM_PLWMESH, ONLY : NPLW,GPLW                                  !!! from makeplw
	USE COM_DENDAT,  ONLY : RHOPS                                      !!! from readscf
	USE COM_DELRHO,  ONLY : GRHOPS                                     !!! from delrho
	USE COM_PHNCHN  ,ONLY : IUDPX,IUDRX,IUDPY,IUDRY                    !!! from channels
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16 GMY
	DATA PI/3.141592653589793D0/
	SQPI4=2.D0*SQRT(PI)
C Set pseudocharge density gradient	
      DO INUC=1,NATOM	               !!! over displacements
	DO MY=-1,1                       !!! over polarizations
	IF(NITER(MY,INUC).EQ.0)CYCLE
      DO IORBS=1,NORBS                 !!! over iorbs
	DO IUPDN=1,NSPIN                 !!! over iupdn
	DO IPLW=0,NPLW                   !!! over plane waves
	GX=GPLW(1,IPLW)*2.D0*PI/PAR
	GY=GPLW(2,IPLW)*2.D0*PI/PAR
	GZ=GPLW(3,IPLW)*2.D0*PI/PAR
      IF(MY.EQ.-1)GMY=+1.D0/SQRT(2.D0)*(GX-(0.D0,1.D0)*GY)
      IF(MY.EQ.+1)GMY=-1.D0/SQRT(2.D0)*(GX+(0.D0,1.D0)*GY)
      IF(MY.EQ. 0)GMY=GZ
      GRHOPS(IPLW,IUPDN,IORBS)=RHOPS(IPLW,IUPDN,IORBS)*GMY*(0.D0,1.D0)
	ENDDO                            !!! over plane waves
	ENDDO                            !!! over iupdn
      ENDDO                            !!! over iorbs
	CALL DRO_DPSFILES(MY,INUC,IQPNT,IUDRY,'W','G',' ')
	ENDDO                            !!! over polarizations
      ENDDO          	               !!! over displacements
	END