	SUBROUTINE DRO_MAGDRHO(IQPNT)
*****************************************************************
*  Rotate old induced magnetization into new quantization axis  *
*****************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
      USE COM_PHNCOM,  ONLY : ITERMAX,NITER                              !!! from readini
	USE COM_RADMESH, ONLY : NRAD                                       !!! from radmsh
	USE COM_MAGDAT,  ONLY : AXMAG                                      !!! from radmsh
	USE COM_OLDMESH, ONLY : AXMAG0                                     !!! from radmsh
      USE COM_DELRHO,  ONLY : DRHO,TRHO,GRHO,DRHOPS,TRHOPS               !!! from delrho
      USE COM_DELHUB,  ONLY : DELDHUB,DELTHUB,DELGHUB                    !!! from plzfiles
	USE COM_PLWMESH, ONLY : NPLW                                       !!! from makeplw
	USE COM_QMESH,   ONLY : NQPNT,QPNT                                 !!! from readpnt
	USE COM_MASHDEP, ONLY : NVAL                                       !!! from setup
	USE COM_PHNCHN  ,ONLY : IUDRO,IUDPX,IUDRX,IUDPY,IUDRY              !!! from channels
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8 TR1(3),TR0(3),TRT(3)
	COMPLEX*16, ALLOCATABLE :: SRMAP(:,:,:,:,:)
      COMPLEX*16 TR(3,-1:1),TD(-1:1,3),GD(4,-1:2),GR(-1:2,4)
     &      ,TRN(3,3),TRO(3,3),TRC(3,3),TRM(-1:2,-1:2),TUD(4,4)
     &      ,RONEW(2,2,3)
      DATA PI/3.141592653589793D0/
	IF(NORBS.EQ.1)RETURN ! makes sense in relativistic case only
	IF(MODE.LE.1)RETURN ! no file exists
C Memory allocations
      ALLOCATE(SRMAP(NSPINMEM,NORBSMEM,NSPINMEM,NORBSMEM,0:NSORT))
C SET TRANSFORMATION MATRICES
C Transformation matrix my->xyz
	TD(-1,1)=(+1.D0,+0.D0)/SQRT(2.D0)
	TD(-1,2)=(+0.D0,+1.D0)/SQRT(2.D0)
	TD(-1,3)=(+0.D0,+0.D0)
	TD( 0,1)=(+0.D0,+0.D0)
	TD( 0,2)=(+0.D0,+0.D0)
	TD( 0,3)=(+1.D0,+0.D0)
	TD(+1,1)=(-1.D0,+0.D0)/SQRT(2.D0)
	TD(+1,2)=(+0.D0,+1.D0)/SQRT(2.D0)
	TD(+1,3)=(+0.D0,+0.D0)
C Reciprocal transformation matrix my->xyz
	TR(1,-1)=(+1.D0,+0.D0)/SQRT(2.D0)
	TR(1, 0)=(+0.D0,+0.D0)
	TR(1,+1)=(-1.D0,+0.D0)/SQRT(2.D0)
	TR(2,-1)=(+0.D0,-1.D0)/SQRT(2.D0)
	TR(2, 0)=(+0.D0,+0.D0)
	TR(2,+1)=(+0.D0,-1.D0)/SQRT(2.D0)
	TR(3,-1)=(+0.D0,+0.D0)
	TR(3, 0)=(+1.D0,+0.D0)
	TR(3,+1)=(+0.D0,+0.D0)
C UpDn to M transformation
	GD(1,-1)=(+0.0D0,0.D0)
	GD(1, 0)=(+0.5D0,0.D0)
	GD(1,+1)=(+0.0D0,0.D0)
	GD(1, 2)=(+0.5D0,0.D0)
	GD(2,-1)=(+0.0D0,0.D0)
	GD(2, 0)=(-0.5D0,0.D0)
	GD(2,+1)=(+0.0D0,0.D0)
	GD(2, 2)=(+0.5D0,0.D0)
	GD(3,-1)=(+1.0D0,0.D0)
	GD(3, 0)=(+0.0D0,0.D0)
	GD(3,+1)=(+0.0D0,0.D0)
	GD(3, 2)=(+0.0D0,0.D0)
	GD(4,-1)=(+0.0D0,0.D0)
	GD(4, 0)=(+0.0D0,0.D0)
	GD(4,+1)=(+1.0D0,0.D0)
	GD(4, 2)=(+0.0D0,0.D0)
C UpDn to M reciprocal transformation
	GR(-1,1)=(+0.0D0,0.D0)
	GR(-1,2)=(+0.0D0,0.D0)
	GR(-1,3)=(+1.0D0,0.D0)
	GR(-1,4)=(+0.0D0,0.D0)
	GR( 0,1)=(+1.0D0,0.D0)
	GR( 0,2)=(-1.0D0,0.D0)
	GR( 0,3)=(+0.0D0,0.D0)
	GR( 0,4)=(+0.0D0,0.D0)
	GR(+1,1)=(+0.0D0,0.D0)
	GR(+1,2)=(+0.0D0,0.D0)
	GR(+1,3)=(+0.0D0,0.D0)
	GR(+1,4)=(+1.0D0,0.D0)
	GR( 2,1)=(+1.0D0,0.D0)
	GR( 2,2)=(+1.0D0,0.D0)
	GR( 2,3)=(+0.0D0,0.D0)
	GR( 2,4)=(+0.0D0,0.D0)
C  *** DO GLOBALLY OVER POLARIZATIONS AND DISPLACEMENTS ***
	DO 2000 INUC=1,NATOM                      !!! over displacements
	DO 1000 IPOL=-1,1                         !!! over polarizations
	IF(NITER(IPOL,INUC).EQ.0)GOTO 1000
C  READ CHANGE IN CHARGE DENSITY
	CALL DRO_DROFILES(IPOL,INUC,IQPNT,IUDRX,'R','A',' ')
	CALL DRO_DPSFILES(IPOL,INUC,IQPNT,IUDRY,'R','A',' ')
	IMAG=0
	DO ISORT=1,NSORT
	IF(ABS(AXMAG(1,ISORT)-AXMAG0(1,ISORT)).GT.1.D-07.OR.
     &   ABS(AXMAG(2,ISORT)-AXMAG0(2,ISORT)).GT.1.D-07.OR.
     &   ABS(AXMAG(3,ISORT)-AXMAG0(3,ISORT)).GT.1.D-07)IMAG=1
      ENDDO
      IF(IMAG.EQ.0)GOTO 1000 ! skip displacements
C *************************************************************
	DO ISORT=1,NSORT                        !!! over sorts
	CALL LIB_ROTAXES(AXMAG(1,ISORT),TETA,PFI)
C New system transformation: M{xyz}=TRS*M{teta,fi,rho}
	TRN(1,1)=+DCMPLX(COS(PFI)*COS(TETA),0.D0)
	TRN(1,2)=-DCMPLX(SIN(PFI),0.D0)
	TRN(1,3)=+DCMPLX(SIN(TETA)*COS(PFI),0.D0)
	TRN(2,1)=+DCMPLX(SIN(PFI)*COS(TETA),0.D0)
	TRN(2,2)=+DCMPLX(COS(PFI),0.D0)
	TRN(2,3)=+DCMPLX(SIN(TETA)*SIN(PFI),0.D0)
	TRN(3,1)=-DCMPLX(SIN(TETA),0.D0)
	TRN(3,2)=+DCMPLX(0.D0,0.D0)
	TRN(3,3)=+DCMPLX(COS(TETA),0.D0)
      CALL LIB_ROTAXES(AXMAG0(1,ISORT),TETA,PFI)
C Old system transformation: M{xyz}=TRS*M{teta,fi,rho}
	TRO(1,1)=+DCMPLX(COS(PFI)*COS(TETA),0.D0)
	TRO(1,2)=-DCMPLX(SIN(PFI),0.D0)
	TRO(1,3)=+DCMPLX(SIN(TETA)*COS(PFI),0.D0)
	TRO(2,1)=+DCMPLX(SIN(PFI)*COS(TETA),0.D0)
	TRO(2,2)=+DCMPLX(COS(PFI),0.D0)
	TRO(2,3)=+DCMPLX(SIN(TETA)*SIN(PFI),0.D0)
	TRO(3,1)=-DCMPLX(SIN(TETA),0.D0)
	TRO(3,2)=+DCMPLX(0.D0,0.D0)
	TRO(3,3)=+DCMPLX(COS(TETA),0.D0)
C Transformation matrix is Tnew*Told^{+}
	DO I=1,3
	DO J=1,3
	TRC(I,J)=(0.D0,0.D0)
	DO K=1,3
	TRC(I,J)=TRC(I,J)+TRN(I,K)*DCONJG(TRO(J,K))
	ENDDO
	ENDDO
	ENDDO
C Transform to my-representation
	DO MY=-1,1
	DO NY=-1,1
	TRM(MY,NY)=(0.D0,0.D0)
	DO I=1,3
	DO J=1,3
	TRM(MY,NY)=TRM(MY,NY)+TD(MY,I)*TRC(I,J)*TR(J,NY)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C Add density element
	DO MY=-1,1
	TRM(MY,2)=(0.D0,0.D0)
	TRM(2,MY)=(0.D0,0.D0)
	ENDDO
	TRM(2,2)=(+1.D0,0.D0)
C Transformation between UpDn vectors
	DO I=1,4
	DO J=1,4
	TUD(I,J)=(0.D0,0.D0)
	DO MY=-1,2
	DO NY=-1,2
	TUD(I,J)=TUD(I,J)+GD(I,MY)*TRM(MY,NY)*GR(NY,J)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C TUD is what we really need:
	DO IORBS0=1,NORBS
	DO IUPDN0=1,NSPIN
	I0=IUPDN0+NSPIN*(IORBS0-1)
	DO IORBS =1,NORBS
	DO IUPDN =1,NSPIN
	I=IUPDN+NSPIN*(IORBS-1)
	SRMAP(IUPDN,IORBS,IUPDN0,IORBS0,ISORT)=TUD(I,I0)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
      ENDDO                                     !!! over sorts	
C *************************************************
C MAGNETIZATION MAPPING FOR THE INTERSTITIAL REGION
	DO IORBS=1,NORBS
	DO IUPDN=1,NSPIN
	DO IORBS0=1,NORBS
	DO IUPDN0=1,NSPIN
	SRMAP(IUPDN,IORBS,IUPDN0,IORBS0,0)=(0.D0,0.D0)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C Check for same quantization axis for all atoms in
C old and new structures 
	ANX=AXMAG(1,1)
	ANY=AXMAG(2,1)
	ANZ=AXMAG(3,1)
	LA=1
	DO ISORT=1,NSORT
	IF(ABS(ANX-AXMAG(1,ISORT)).GE.1.D-07.OR.
     &   ABS(ANY-AXMAG(2,ISORT)).GE.1.D-07.OR.
     &   ABS(ANZ-AXMAG(3,ISORT)).GE.1.D-07)LA=0
	ENDDO
	ANX0=AXMAG0(1,1)
	ANY0=AXMAG0(2,1)
	ANZ0=AXMAG0(3,1)
	DO ISORT=1,NSORT
	IF(ABS(ANX0-AXMAG0(1,ISORT)).GE.1.D-07.OR.
     &   ABS(ANY0-AXMAG0(2,ISORT)).GE.1.D-07.OR.
     &   ABS(ANZ0-AXMAG0(3,ISORT)).GE.1.D-07)LA=0
	ENDDO
C Check for same orientations
	LS=1
	DO ISORT=1,NSORT
	IF(ABS(AXMAG(1,ISORT)-AXMAG0(1,ISORT)).GE.1.D-07.OR.
     &   ABS(AXMAG(2,ISORT)-AXMAG0(2,ISORT)).GE.1.D-07.OR.
     &   ABS(AXMAG(3,ISORT)-AXMAG0(3,ISORT)).GE.1.D-07)LS=0
	ENDDO
C Unique axis for all atoms case
	IF(LA.EQ.1)THEN
	DO IORBS=1,NORBS
	DO IUPDN=1,NSPIN
	DO IORBS0=1,NORBS
	DO IUPDN0=1,NSPIN
	SRMAP(IUPDN,IORBS,IUPDN0,IORBS0,0)=
     &SRMAP(IUPDN,IORBS,IUPDN0,IORBS0,1)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDIF
C Orientations did not change case
	IF(LS.EQ.1)THEN
	DO IORBS=1,NORBS
	DO IUPDN=1,NSPIN
	DO IORBS0=1,NORBS
	DO IUPDN0=1,NSPIN
	IF(IORBS.EQ.IORBS0.AND.IUPDN.EQ.IUPDN0)
     &SRMAP(IUPDN,IORBS,IUPDN0,IORBS0,0)=(1.D0,0.D0)
	IF(IORBS.NE.IORBS0.OR.IUPDN.NE.IUPDN0)
     &SRMAP(IUPDN,IORBS,IUPDN0,IORBS0,0)=(0.D0,0.D0)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDIF
C If not two previous cases, leave only density
	IF(LA.EQ.0.AND.LS.EQ.0)THEN
	DO IUPDN=1,NSPIN
      SRMAP(IUPDN,    1,    1,NORBS,0)=(0.D0,0.D0)
      SRMAP(IUPDN,    1,NSPIN,NORBS,0)=(0.D0,0.D0)
      SRMAP(IUPDN,NORBS,    1,NORBS,0)=(0.D0,0.D0)
      SRMAP(IUPDN,NORBS,NSPIN,NORBS,0)=(0.D0,0.D0)
      SRMAP(IUPDN,NORBS,    1,    1,0)=(0.D0,0.D0)
      SRMAP(IUPDN,NORBS,NSPIN,    1,0)=(0.D0,0.D0)
      SRMAP(IUPDN,    1,    1,    1,0)=(0.5D0,0.D0)
      SRMAP(IUPDN,    1,NSPIN,    1,0)=(0.5D0,0.D0)
	ENDDO
	ENDIF
C  DO OVER ATOMS
	DO IATOM=1,NATOM                          !!! over atoms
	ISORT=IS(IATOM)
	DO L=0,ILSV(ISORT)                        !!! over l
	DO M=-L,L                                 !!! over m
	LM=L*(L+1)+M+1
	DO IRAD=0,NRAD(ISORT)                     !!! over irad
C Transform to new coordinates set by AXMAG:
	DO IORBS=1,NORBS
	DO IUPDN=1,NSPIN
	RONEW(IUPDN,IORBS,1)=(0.D0,0.D0)
	RONEW(IUPDN,IORBS,2)=(0.D0,0.D0)
	RONEW(IUPDN,IORBS,3)=(0.D0,0.D0)
	DO IORBS0=1,NORBS
	DO IUPDN0=1,NSPIN
	RONEW(IUPDN,IORBS,1)=RONEW(IUPDN,IORBS,1)+
     &SRMAP(IUPDN,IORBS,IUPDN0,IORBS0,ISORT)*
     &DRHO(IRAD,LM,IATOM,IUPDN0,IORBS0)
	RONEW(IUPDN,IORBS,2)=RONEW(IUPDN,IORBS,2)+
     &SRMAP(IUPDN,IORBS,IUPDN0,IORBS0,ISORT)*
     &TRHO(IRAD,LM,IATOM,IUPDN0,IORBS0)
	RONEW(IUPDN,IORBS,3)=RONEW(IUPDN,IORBS,3)+
     &SRMAP(IUPDN,IORBS,IUPDN0,IORBS0,ISORT)*
     &GRHO(IRAD,LM,IATOM,IUPDN0,IORBS0)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	DO IORBS=1,NORBS
	DO IUPDN=1,NSPIN
	DRHO(IRAD,LM,IATOM,IUPDN,IORBS)=RONEW(IUPDN,IORBS,1)
	TRHO(IRAD,LM,IATOM,IUPDN,IORBS)=RONEW(IUPDN,IORBS,2)
	GRHO(IRAD,LM,IATOM,IUPDN,IORBS)=RONEW(IUPDN,IORBS,3)
	ENDDO
	ENDDO
      ENDDO                                     !!! over irad
      ENDDO                                     !!! over m
      ENDDO                                     !!! over l
      ENDDO                                     !!! over iatom
C  DO OVER ATOMS
	DO IATOM=1,NATOM                          !!! over atoms
	ISORT=IS(IATOM)
	DO L=0,ILSB(ISORT)                         !!! over l
      DO M1=-L,L                                 !!! over m1
      LM1=L*(L+1)+M1+1
      DO M=-L,L                                  !!! over m
      LM=L*(L+1)+M+1
      IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M1+1 ! ! (l,m'm)
C Transform to new coordinates set by AXMAG:
	DO IORBS=1,NORBS
	DO IUPDN=1,NSPIN
	RONEW(IUPDN,IORBS,1)=(0.D0,0.D0)
	RONEW(IUPDN,IORBS,2)=(0.D0,0.D0)
	RONEW(IUPDN,IORBS,3)=(0.D0,0.D0)
	DO IORBS0=1,NORBS
	DO IUPDN0=1,NSPIN
	RONEW(IUPDN,IORBS,1)=RONEW(IUPDN,IORBS,1)+
     &SRMAP(IUPDN,IORBS,IUPDN0,IORBS0,ISORT)*
     &DELDHUB(IU,IATOM,IUPDN0,IORBS0)
	RONEW(IUPDN,IORBS,2)=RONEW(IUPDN,IORBS,2)+
     &SRMAP(IUPDN,IORBS,IUPDN0,IORBS0,ISORT)*
     &DELTHUB(IU,IATOM,IUPDN0,IORBS0)
	RONEW(IUPDN,IORBS,3)=RONEW(IUPDN,IORBS,3)+
     &SRMAP(IUPDN,IORBS,IUPDN0,IORBS0,ISORT)*
     &DELGHUB(IU,IATOM,IUPDN0,IORBS0)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	DO IORBS=1,NORBS
	DO IUPDN=1,NSPIN
	DELDHUB(IU,IATOM,IUPDN,IORBS)=RONEW(IUPDN,IORBS,1)
	DELTHUB(IU,IATOM,IUPDN,IORBS)=RONEW(IUPDN,IORBS,2)
	DELGHUB(IU,IATOM,IUPDN,IORBS)=RONEW(IUPDN,IORBS,3)
	ENDDO
	ENDDO
	ENDDO                                      !!! over m1
      ENDDO                                      !!! over m
      ENDDO                                      !!! over l
      ENDDO                                     !!! over iatom
C  DO OVER INTERSTITIALS
      DO IPLW=0,NPLW                            !!! over plane waves
	DO IORBS=1,NORBS
	DO IUPDN=1,NSPIN
	RONEW(IUPDN,IORBS,1)=(0.D0,0.D0)
	RONEW(IUPDN,IORBS,2)=(0.D0,0.D0)
	DO IORBS0=1,NORBS
	DO IUPDN0=1,NSPIN
	RONEW(IUPDN,IORBS,1)=RONEW(IUPDN,IORBS,1)+
     &SRMAP(IUPDN,IORBS,IUPDN0,IORBS0,0)*
     &DRHOPS(IPLW,IUPDN0,IORBS0)
	RONEW(IUPDN,IORBS,2)=RONEW(IUPDN,IORBS,2)+
     &SRMAP(IUPDN,IORBS,IUPDN0,IORBS0,0)*
     &TRHOPS(IPLW,IUPDN0,IORBS0)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	DO IORBS=1,NORBS
	DO IUPDN=1,NSPIN
	DRHOPS(IPLW,IUPDN,IORBS)=RONEW(IUPDN,IORBS,1)
	TRHOPS(IPLW,IUPDN,IORBS)=RONEW(IUPDN,IORBS,2)
	ENDDO
	ENDDO
      ENDDO 	                                !!! over plane waves
C  STORE NEW INDUCED CHARGE DENSITY
	CALL DRO_DROFILES(IPOL,INUC,IQPNT,IUDRX,'W','A',' ')
	CALL DRO_DPSFILES(IPOL,INUC,IQPNT,IUDRY,'W','A',' ')
1000	CONTINUE                                  !!! over polarizations
2000	CONTINUE                                  !!! over displacements
C Memory deallocations
	DEALLOCATE(SRMAP)
	END
