	SUBROUTINE DRO_MIXBRD(IQPNT,ITER,KEY)
**************************************************************
*  Mixes induced charge densities according to the Broyden   *
*  prescription.                                             *
**************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
      USE COM_PHNCOM,  ONLY : ITERMAX,NITER                              !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_QMESH,   ONLY : NQPNT,QPNT                                 !!! from readpnt
	USE COM_PLWMESH, ONLY : NPLW,GPLW                                  !!! from makeplw
      USE COM_MIXDBRD, ONLY : LBROY,IBROY,ADMIXB,ADMIXH,MTER,WTER,WMIX   !!! from readini
	USE COM_LATTICE, ONLY : TAU                                        !!! from readstr
	USE COM_RADMESH, ONLY : NRAD,H,R,DR,WEIGHT,RL                      !!! from radmsh
      USE COM_DELRHO,  ONLY : DRHO                                       !!! from delrho
	USE COM_SPHERE,  ONLY : SWZ,SMT,ZNUC,ZCOR                          !!! from readini
      USE COM_PLZCOM,  ONLY : NPLZ,LPLZ,IPLZ,NPTB,QPTB,INDPTB            !!! from readlrt
      USE COM_LABELS,  ONLY : TXTEL,TXTSP                                !!! from readini
	USE COM_LATPAR,  ONLY : PAR,ORTH,OMEGAC                            !!! from readini
	USE COM_DELRHO,  ONLY : DRHOPS,DRHOPS1                             !!! from delrho
      USE COM_DELHUB,  ONLY : DELDHUB                                    !!! from plzfiles
      USE COM_LMTOUT,  ONLY : SCNFILE                                    !!! from storage
      USE COM_CHANNELS,ONLY : IUBRO                                      !!! from channels
	USE COM_PHNCHN  ,ONLY : IUDPX,IUDPY                                !!! from channels
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
      IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER, ALLOCATABLE :: LBROY0(:,:)
	LOGICAL, ALLOCATABLE :: RESET(:,:)
	REAL*8, ALLOCATABLE :: WRAD(:)
	COMPLEX*16, ALLOCATABLE :: WRK1(:)
	COMPLEX*16, ALLOCATABLE :: WRK2(:)
	COMPLEX*16, ALLOCATABLE :: WINP(:,:,:)
	COMPLEX*16, ALLOCATABLE :: WORK1(:)
	COMPLEX*16, ALLOCATABLE :: WORK2(:)
	COMPLEX*16, ALLOCATABLE :: DQCH(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: XRHO(:)
	COMPLEX*16, ALLOCATABLE :: XNEW(:)
	COMPLEX*16, ALLOCATABLE :: DHUBOLD(:,:,:,:,:,:,:)
      COMPLEX*16 TOTNEW(0:3),DIPNEW(-1:1,0:3)
     &   ,EXPQR,LIB_CNUM0P,DMS(-1:1),DMC(0:3)
      CHARACTER LIB_TCPS*19,TCHAR(0:3)*19
      LOGICAL FIRST
	SAVE LBROY0,FIRST,RESET,DHUBOLD
      DATA PI/3.141592653589793D0/,FIRST/.TRUE./
C  DO GLOBALLY OVER POLARIZATIONS AND DISPLACEMENTS
	DO 2000 INUC=1,NATOM                !!! over displacements
	DO 1000 MY=-1,1                     !!! over polarizations
	IF(NITER(MY,INUC).EQ.0)GOTO 1000
C  SAVE SWITCHES
	IF(FIRST)THEN
	IF(.NOT.ALLOCATED(LBROY0))ALLOCATE(LBROY0(-1:1,NATOMMEM))
	IF(.NOT.ALLOCATED(DHUBOLD))ALLOCATE
     &(DHUBOLD(LIMB2MEM,NATOMMEM,NSPINMEM,NORBSMEM,
     &                     0:NTERMEM,-1:1,NATOMMEM))
	IF(.NOT.ALLOCATED(RESET))ALLOCATE(RESET(-1:1,NATOMMEM))
      LBROY0(MY,INUC)=LBROY(MY,INUC)
	MTER(MY,INUC)=0
	RESET(MY,INUC)=.TRUE.
	ENDIF
C  DO NOT START BROYDEN, WAIT
	IF(ITER.LE.IBROY(MY,INUC))THEN
	LBROY(MY,INUC)=-1
C  SWITCH ON NOW
	ELSEIF(ITER.GT.IBROY(MY,INUC))THEN
	LBROY(MY,INUC)=LBROY0(MY,INUC)
	ENDIF
	IF(LBROY(MY,INUC).LT.0)GOTO 1000
C  SET ITERATION NUMBER
	IF(MTER(MY,INUC).EQ.NTERMEM-1)RESET(MY,INUC)=.TRUE.
	IF(MTER(MY,INUC).EQ.NTERMEM-1)
     &WRITE(IUT,*)'<MIXROB>:: MTER>NTEREM, BROYDEN RESTARTED'
	IF(RESET(MY,INUC))MTER(MY,INUC)=0
	IF(KEY.EQ.1.AND.MTER(MY,INUC).NE.0)GOTO 1000
	IF(KEY.EQ.2)MTER(MY,INUC)=MTER(MY,INUC)+1
C  READ CHANGE IN CHARGE DENSITY
      CALL DRO_DROFILES(MY,INUC,IQPNT,IUDPX,'R','D',' ')
      CALL DRO_DPSFILES(MY,INUC,IQPNT,IUDPY,'R','D',' ')
C  *** SET MIXING ARRAY ***
C  Count lenght of the mixing array
	IDIM=0
	DO IATOM=1,NATOM                    !!! over atoms
	ISORT=IS(IATOM)
      DO L=0,ILSV(ISORT)                  !!! over l
      DO M=-L,L                           !!! over m
      LM=L*(L+1)+M+1
      IF(L.LE.LBROY(MY,INUC))THEN         !!! for l.le.lbroy
	DO IRAD=0,NRAD(ISORT)
	IDIM=IDIM+1
	ENDDO
	IF(NSPIN.EQ.2)THEN
	DO IRAD=0,NRAD(ISORT)
	IDIM=IDIM+1
	ENDDO
	ENDIF
	IF(NORBS.EQ.2)THEN
	DO IRAD=0,NRAD(ISORT)
	IDIM=IDIM+1
	ENDDO
	DO IRAD=0,NRAD(ISORT)
	IDIM=IDIM+1
	ENDDO
	ENDIF
	ENDIF                               !!! for l.le.lbroy
	ENDDO                               !!! over m
	ENDDO                               !!! over l
	ENDDO                               !!! over atoms
	DO IPLW=0,NPLW                      !!! over plane waves
	IDIM=IDIM+1
	ENDDO                               !!! over plane waves
	IF(NSPIN.EQ.2)THEN
	DO IPLW=0,NPLW                      !!! over plane waves
	IDIM=IDIM+1
	ENDDO                               !!! over plane waves
	ENDIF
	IF(NORBS.EQ.2)THEN
	DO IPLW=0,NPLW                      !!! over plane waves
	IDIM=IDIM+1
	ENDDO                               !!! over plane waves
	DO IPLW=0,NPLW                      !!! over plane waves
	IDIM=IDIM+1
	ENDDO                               !!! over plane waves
	ENDIF
	NLENMEM=IDIM
C Memory allocations
	ALLOCATE(WRAD(NLENMEM))
	ALLOCATE(WRK1(NLENMEM))
	ALLOCATE(WRK2(NLENMEM))
	ALLOCATE(WINP(NTERMEM,-1:1,NATOMMEM))
	ALLOCATE(WORK1(0:NRADMEM))
	ALLOCATE(WORK2(0:NRADMEM))
	ALLOCATE(DQCH(4,NATOMMEM,NSPINMEM,NORBSMEM))
	ALLOCATE(XRHO(NLENMEM))
	ALLOCATE(XNEW(NLENMEM))
C  MT-PART
	IDIM=0
	DO IATOM=1,NATOM                    !!! over atoms
	ISORT=IS(IATOM)
      DO L=0,ILSV(ISORT)                  !!! over l
      DO M=-L,L                           !!! over m
      LM=L*(L+1)+M+1
      SL=SMT(ISORT)**L
      IF(L.LE.LBROY(MY,INUC))THEN         !!! for l.le.lbroy
C  1) Pack Induced Density into Array
	DO IRAD=0,NRAD(ISORT)
	IDIM=IDIM+1
      XRHO(IDIM)=0.5D0*DBLE(NSPIN)*(
     &DRHO(IRAD,LM,IATOM,1,1)+DRHO(IRAD,LM,IATOM,NSPIN,1))
	WRAD(IDIM)=1.D0
	ENDDO
C  2) Pack Induced Magnetization into Array
	IF(NSPIN.EQ.2)THEN
	DO IRAD=0,NRAD(ISORT)
	IDIM=IDIM+1
      XRHO(IDIM)=DRHO(IRAD,LM,IATOM,1,1)-DRHO(IRAD,LM,IATOM,NSPIN,1)
	WRAD(IDIM)=1.D0
	ENDDO
	ENDIF
C 3) Pack Transverse Magnetization into Array
	IF(NORBS.EQ.2)THEN
	DO IRAD=0,NRAD(ISORT)
	IDIM=IDIM+1
      XRHO(IDIM)=DRHO(IRAD,LM,IATOM,1,NORBS)
	WRAD(IDIM)=1.D0
	ENDDO
	DO IRAD=0,NRAD(ISORT)
	IDIM=IDIM+1
      XRHO(IDIM)=DRHO(IRAD,LM,IATOM,NSPIN,NORBS)
	WRAD(IDIM)=1.D0
	ENDDO
	ENDIF
	ENDIF                               !!! for l.le.lbroy
	ENDDO                               !!! over m
	ENDDO                               !!! over l
	ENDDO                               !!! over atoms
C  *** SET MIXING ARRAY ***
C  PLW-PART
C  1) Pack Induced Density into Array
	DO IPLW=0,NPLW                      !!! over plane waves
	IDIM=IDIM+1
      XRHO(IDIM)=0.5D0*DBLE(NSPIN)*(
     &DRHOPS(IPLW,1,1)+DRHOPS(IPLW,NSPIN,1))
	WRAD(IDIM)=1.D0
	ENDDO                               !!! over plane waves
C  2) Pack Induced Magnetization into Array
	IF(NSPIN.EQ.2)THEN
	DO IPLW=0,NPLW                      !!! over plane waves
	IDIM=IDIM+1
      XRHO(IDIM)=DRHOPS(IPLW,1,1)-DRHOPS(IPLW,NSPIN,1)
	WRAD(IDIM)=1.D0
	ENDDO                               !!! over plane waves
	ENDIF
C 3) Pack Transverse Magnetisation into Array
	IF(NORBS.EQ.2)THEN
	DO IPLW=0,NPLW                      !!! over plane waves
	IDIM=IDIM+1
      XRHO(IDIM)=DRHOPS(IPLW,1,NORBS)
	WRAD(IDIM)=1.D0
	ENDDO                               !!! over plane waves
	DO IPLW=0,NPLW                      !!! over plane waves
	IDIM=IDIM+1
      XRHO(IDIM)=DRHOPS(IPLW,NSPIN,NORBS)
	WRAD(IDIM)=1.D0
	ENDDO                               !!! over plane waves
	ENDIF
	NDIM=IDIM
	IF(NDIM.GT.NLENMEM)CALL FULLSTOP('<MIXDBRD>:: NDIM.GT.NLENMEM')
C  INITIALIZE BROYDEN MIXING FOR OCCUPANCIES
      DO IORBS=1,NORBS                    !!! over iorbs
    	DO IUPDN=1,NSPIN                    !!! over spins
	DO IATOM=1,NATOM                    !!! over atoms
	ISORT=IS(IATOM)
	DO L=0,ILSB(ISORT)                  !!! over l
	DO M=-L,L                           !!! over m
	DO K=-L,L                           !!! over k
	LM=L*(L+1)+M+1
	LK=L*(L+1)+K+1
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+K)+L+M+1           !  (l,m k) packed
	IF(KEY.EQ.1.AND.MTER(MY,INUC).EQ.0)
     &DHUBOLD(IU,IATOM,IUPDN,IORBS,MTER(MY,INUC),MY,INUC)=
     &DELDHUB(IU,IATOM,IUPDN,IORBS)
	ENDDO                                !!! over k
	ENDDO                                !!! over m
	ENDDO                                !!! over l
	ENDDO                                !!! over atoms
	ENDDO                                !!! over spins
	ENDDO                                !!! over iorbs
C  SEND ARRAY TO BROYDEN
      CALL DRO_DBROY4N(XRHO,XNEW,WRAD,WRK1,WRK2,NDIM,MTER,
     &ADMIXB,WTER,WINP,WMIX,IUBRO,SCNFILE(-1,1,IUBRO),MY,INUC)
	IF(MTER(MY,INUC).EQ.0)RESET(MY,INUC)=.FALSE.
	IF(MTER(MY,INUC).EQ.0)GOTO 500
C  *** DEFINE NEW INDUCED DENSITY ***
C  MT-PART
	IDIM=0
	NEGD=0
	DO IATOM=1,NATOM                    !!! over atoms
	ISORT=IS(IATOM)
      DO L=0,ILSV(ISORT)                  !!! over l
      DO M=-L,L                           !!! over m
      LM=L*(L+1)+M+1
      SL=SMT(ISORT)**L
      IF(L.LE.LBROY(MY,INUC))THEN         !!! for l.le.lbroy
C  Repack Induced Spin Densities
	DO IRAD=0,NRAD(ISORT) 
	IDIM=IDIM+1
	DRHO(IRAD,LM,IATOM,1,1)=XNEW(IDIM)/DBLE(NSPIN)
	DRHO(IRAD,LM,IATOM,NSPIN,1)=XNEW(IDIM)/DBLE(NSPIN)
	ENDDO
	IF(NSPIN.EQ.2)THEN
	DO IRAD=0,NRAD(ISORT)
	IDIM=IDIM+1
	DRHO(IRAD,LM,IATOM,1,1)=DRHO(IRAD,LM,IATOM,1,1)+
     &XNEW(IDIM)/DBLE(NSPIN)
	DRHO(IRAD,LM,IATOM,NSPIN,1)=DRHO(IRAD,LM,IATOM,NSPIN,1)-
     &XNEW(IDIM)/DBLE(NSPIN)
	ENDDO
	ENDIF
C Repack transverse components
	IF(NORBS.EQ.2)THEN
	DO IRAD=0,NRAD(ISORT)
	IDIM=IDIM+1
	DRHO(IRAD,LM,IATOM,1,NORBS)=XNEW(IDIM)
	ENDDO
	DO IRAD=0,NRAD(ISORT)
	IDIM=IDIM+1
	DRHO(IRAD,LM,IATOM,NSPIN,NORBS)=XNEW(IDIM)
	ENDDO
	ENDIF
	ENDIF                               !!! for l.le.lbroy
	ENDDO                               !!! over m
	ENDDO                               !!! over l
	ENDDO                               !!! over atoms
C  *** DEFINE NEW INDUCED DENSITY ***
C  PLW-PART
	DO IPLW=0,NPLW                      !!! over plane waves
	IDIM=IDIM+1
	DRHOPS(IPLW,1,1)=XNEW(IDIM)/DBLE(NSPIN)
	DRHOPS(IPLW,NSPIN,1)=XNEW(IDIM)/DBLE(NSPIN)
	ENDDO                               !!! over plane waves
	IF(NSPIN.EQ.2)THEN
	DO IPLW=0,NPLW                      !!! over plane waves
	IDIM=IDIM+1
	DRHOPS(IPLW,1,1)=DRHOPS(IPLW,1,1)+XNEW(IDIM)/DBLE(NSPIN)
	DRHOPS(IPLW,NSPIN,1)=DRHOPS(IPLW,NSPIN,1)-XNEW(IDIM)/
     &DBLE(NSPIN)
	ENDDO                               !!! over plane waves
	ENDIF
	IF(NORBS.EQ.2)THEN
	DO IPLW=0,NPLW                      !!! over plane waves
	IDIM=IDIM+1
	DRHOPS(IPLW,1,NORBS)=XNEW(IDIM)
	ENDDO                               !!! over plane waves
	DO IPLW=0,NPLW                      !!! over plane waves
	IDIM=IDIM+1
	DRHOPS(IPLW,NSPIN,NORBS)=XNEW(IDIM)
	ENDDO                               !!! over plane waves
	ENDIF
C  SET NEW INDUCED CHARGES
      DO IORBS=1,NORBS                    !!! over iorbs
      DO IUPDN=1,NSPIN                    !!! over spins
      DO IATOM=1,NATOM                    !!! over atoms
      ISORT=IS(IATOM)
	DO L=0,1                            !!! over l=0,1
      SL=SMT(ISORT)**L
	DO M=-L,L                           !!! over m
	LM=L*(L+1)+M+1
      DO IRAD=0,NRAD(ISORT)
      WORK1(IRAD)=DRHO(IRAD,LM,IATOM,IUPDN,IORBS)*
     &RL(IRAD,L,ISORT)/SL*WEIGHT(IRAD,ISORT)/SQRT(4.D0*PI)
	ENDDO
      CALL LIB_CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
      DQCH(LM,IATOM,IUPDN,IORBS)=WORK2(NRAD(ISORT))
	ENDDO                               !!! over m
	ENDDO                               !!! over l
	ENDDO                               !!! over atoms
	ENDDO                               !!! over spins
	ENDDO                               !!! over iorbs
C  DO BROYDEN MIXING FOR OCCUPANCIES
      IF(LBROY(MY,INUC).GE.0)THEN         !!! for l.le.lbroy
      DO IORBS=1,NORBS                    !!! over iorbs
    	DO IUPDN=1,NSPIN                    !!! over spins
	DO IATOM=1,NATOM                    !!! over atoms
	ISORT=IS(IATOM)
	DO L=0,ILSB(ISORT)                  !!! over l
	DO M=-L,L                           !!! over m
	DO K=-L,L                           !!! over k
	LM=L*(L+1)+M+1
	LK=L*(L+1)+K+1
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+K)+L+M+1           !  (l,m k) packed
      DHUBOLD(IU,IATOM,IUPDN,IORBS,MTER(MY,INUC),MY,INUC)=
     &DELDHUB(IU,IATOM,IUPDN,IORBS)
	RONEW=WINP(MTER(MY,INUC),MY,INUC)*
     &DHUBOLD(IU,IATOM,IUPDN,IORBS,0,MY,INUC)
	DO LTER=1,MTER(MY,INUC)             !!! over iterations
	RONEW=RONEW+WMIX(MTER(MY,INUC),LTER,MY,INUC)*
     &DHUBOLD(IU,IATOM,IUPDN,IORBS,LTER,MY,INUC)
	ENDDO                               !!! over iterations
 	DELDHUB(IU,IATOM,IUPDN,IORBS)=RONEW
	ENDDO                                !!! over k
	ENDDO                                !!! over m
	ENDDO                                !!! over l
	ENDDO                                !!! over atoms
	ENDDO                                !!! over spins
	ENDDO                                !!! over iorbs
	ENDIF
C  Restart mixing (example)
C	IRES=0
C	IF(IRES.EQ.0)RESET(MY,INUC)=.FALSE.
C	IF(IRES.EQ.1)RESET(MY,INUC)=.TRUE.
C	IF(IRES.EQ.1)WRITE(IUT,*)'<MIXBRD>: BROYDEN  MIXING  RESTARTED' 
C  Switch off mixing ??? (example)
C	IF(IRES.EQ.1)LBROY (MY,INUC)=-1
C	IF(IRES.EQ.1)LBROY0(MY,INUC)=-1
C	IF(IRES.EQ.1)WRITE(IUT,*)'<MIXBRD>: BROYDEN  MIXING  IS OFF' 
C  PRINT BLOCK
	WRITE(IUN,1001)INUC,MY,TXTEL(IS(INUC))
	WRITE(IUN,1010)WTER(MTER(MY,INUC),MY,INUC)
	WRITE(IUN,1020)
 1001 FORMAT(1X,'Atom ',I2,' movement:: polarization "',I2,'" ',A10)
 1010 FORMAT(1X,'Broyden Mixing for dRHO(r), Iter-Weight=',G14.7)
 1020 FORMAT(1X,'Guessed after Broyden induced charge, dQ_iat-->')
	DO IA=0,3
      TOTNEW(IA)=(0.D0,0.D0)
      DIPNEW(-1,IA)=(0.D0,0.D0)
      DIPNEW( 0,IA)=(0.D0,0.D0)
      DIPNEW(+1,IA)=(0.D0,0.D0)
      ENDDO
      DO IATOM=1,NATOM                    !!! over atoms
      ISORT=IS(IATOM)
      SCP=QPNT(1,IQPNT)*TAU(1,IATOM)+
     &    QPNT(2,IQPNT)*TAU(2,IATOM)+
     &    QPNT(3,IQPNT)*TAU(3,IATOM)
      EXPQR=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	WRITE(IUN,1030)TXTEL(ISORT)
 1030 FORMAT(1X,23X,'dQ_iat[NEW]',19X,'dM_XYZ[NEW]',3X,A10)
      DMS( 0)=DQCH(1,IATOM,1,1)-DQCH(1,IATOM,NSPIN,1)
      DMS(-1)=DQCH(1,IATOM,1,NORBS)
      DMS(+1)=DQCH(1,IATOM,NSPIN,NORBS)
      DMC(0)=(DQCH(1,IATOM,1,1)+DQCH(1,IATOM,NSPIN,1))*
     &        0.5D0*DBLE(NSPIN)
	DMC(1)=(DMS(-1)-DMS(+1))/SQRT(2.D0)
	DMC(2)=(DMS(-1)+DMS(+1))/SQRT(2.D0)*(0.D0,-1.D0) ! since it is M^{+/-}
	DMC(3)= DMS(0)
	DO IA=0,3
	TOTNEW(IA)=TOTNEW(IA)+DMC(IA)*EXPQR
	TCHAR(IA)=LIB_TCPS(DMC(IA),1.D-07)
	ENDDO
	IF(NORBS.EQ.1)WRITE(IUN,1040) TCHAR(0),TCHAR(3)
	IF(NORBS.EQ.2)WRITE(IUN,1040)(TCHAR(IA),IA=0,3)
 1040 FORMAT(1X,'l=0,m= 0 :',1X,A19,1X,A19,1X,A19,1X,A19)
      DMS( 0)=DQCH(2,IATOM,1,1)-DQCH(2,IATOM,NSPIN,1)
      DMS(-1)=DQCH(2,IATOM,1,NORBS)
      DMS(+1)=DQCH(2,IATOM,NSPIN,NORBS)
      DMC(0)=(DQCH(2,IATOM,1,1)+DQCH(2,IATOM,NSPIN,1))*
     &        0.5D0*DBLE(NSPIN)
	DMC(1)=(DMS(-1)-DMS(+1))/SQRT(2.D0)
	DMC(2)=(DMS(-1)+DMS(+1))/SQRT(2.D0)*(0.D0,-1.D0) ! since it is M^{+/-}
	DMC(3)= DMS(0)
	DO IA=0,3
	DIPNEW(-1,IA)=DIPNEW(-1,IA)+DMC(IA)*EXPQR
	TCHAR(IA)=LIB_TCPS(DMC(IA),1.D-07)
	ENDDO
	IF(NORBS.EQ.1)WRITE(IUN,1050) TCHAR(0),TCHAR(3)
	IF(NORBS.EQ.2)WRITE(IUN,1050)(TCHAR(IA),IA=0,3)
 1050 FORMAT(1X,'l=1,m=-1 :',1X,A19,1X,A19,1X,A19,1X,A19)
      DMS( 0)=DQCH(3,IATOM,1,1)-DQCH(3,IATOM,NSPIN,1)
      DMS(-1)=DQCH(3,IATOM,1,NORBS)
      DMS(+1)=DQCH(3,IATOM,NSPIN,NORBS)
      DMC(0)=(DQCH(3,IATOM,1,1)+DQCH(3,IATOM,NSPIN,1))*
     &        0.5D0*DBLE(NSPIN)
	DMC(1)=(DMS(-1)-DMS(+1))/SQRT(2.D0)
	DMC(2)=(DMS(-1)+DMS(+1))/SQRT(2.D0)*(0.D0,-1.D0) ! since it is M^{+/-}
	DMC(3)= DMS(0)
	DO IA=0,3
	DIPNEW( 0,IA)=DIPNEW( 0,IA)+DMC(IA)*EXPQR
	TCHAR(IA)=LIB_TCPS(DMC(IA),1.D-07)
	ENDDO
	IF(NORBS.EQ.1)WRITE(IUN,1060) TCHAR(0),TCHAR(3)
	IF(NORBS.EQ.2)WRITE(IUN,1060)(TCHAR(IA),IA=0,3)
 1060 FORMAT(1X,'l=1,m= 0 :',1X,A19,1X,A19,1X,A19,1X,A19)
      DMS( 0)=DQCH(4,IATOM,1,1)-DQCH(4,IATOM,NSPIN,1)
      DMS(-1)=DQCH(4,IATOM,1,NORBS)
      DMS(+1)=DQCH(4,IATOM,NSPIN,NORBS)
      DMC(0)=(DQCH(4,IATOM,1,1)+DQCH(4,IATOM,NSPIN,1))*
     &        0.5D0*DBLE(NSPIN)
	DMC(1)=(DMS(-1)-DMS(+1))/SQRT(2.D0)
	DMC(2)=(DMS(-1)+DMS(+1))/SQRT(2.D0)*(0.D0,-1.D0) ! since it is M^{+/-}
	DMC(3)= DMS(0)
	DO IA=0,3
	DIPNEW(+1,IA)=DIPNEW(+1,IA)+DMC(IA)*EXPQR
	TCHAR(IA)=LIB_TCPS(DMC(IA),1.D-07)
	ENDDO
	IF(NORBS.EQ.1)WRITE(IUN,1070) TCHAR(0),TCHAR(3)
	IF(NORBS.EQ.2)WRITE(IUN,1070)(TCHAR(IA),IA=0,3)
 1070 FORMAT(1X,'l=1,m=+1 :',1X,A19,1X,A19,1X,A19,1X,A19)
	ENDDO                               !!! over atoms
C Print totals	
      WRITE(IUN,1080)
 1080 FORMAT(1X,23X,'dQ_tot[NEW]',19X,'dM_XYZ[NEW]',3X,'TOTAL')
	DO IA=0,3
	TCHAR(IA)=LIB_TCPS(TOTNEW(IA),1.D-07)
	ENDDO
	IF(NORBS.EQ.1)WRITE(IUN,1040) TCHAR(0),TCHAR(3)
	IF(NORBS.EQ.2)WRITE(IUN,1040)(TCHAR(IA),IA=0,3)
	DO IA=0,3
	TCHAR(IA)=LIB_TCPS(DIPNEW(-1,IA),1.D-07)
	ENDDO
	IF(NORBS.EQ.1)WRITE(IUN,1050) TCHAR(0),TCHAR(3)
	IF(NORBS.EQ.2)WRITE(IUN,1050)(TCHAR(IA),IA=0,3)
	DO IA=0,3
	TCHAR(IA)=LIB_TCPS(DIPNEW( 0,IA),1.D-07)
	ENDDO
	IF(NORBS.EQ.1)WRITE(IUN,1060) TCHAR(0),TCHAR(3)
	IF(NORBS.EQ.2)WRITE(IUN,1060)(TCHAR(IA),IA=0,3)
	DO IA=0,3
	TCHAR(IA)=LIB_TCPS(DIPNEW(+1,IA),1.D-07)
	ENDDO
	IF(NORBS.EQ.1)WRITE(IUN,1070) TCHAR(0),TCHAR(3)
	IF(NORBS.EQ.2)WRITE(IUN,1070)(TCHAR(IA),IA=0,3)
C Print pseudocharges     
      CALL DPT_DMULTRHO(MY,INUC,IQPNT)     !!! change in pseudodensity moments
      CALL DPT_DMULTFTR(MY,INUC,IQPNT,0)   !!! change in multipoles
      WRITE(IUN,1090)
 1090 FORMAT(1X,23X,'dP_tot[NEW]',19X,'dS_tot[NEW]',3X,'TOTAL')
	DO IPTB=1,NPTB
	IPLW=INDPTB(IPTB)
      DMS( 0)=OMEGAC*(DRHOPS (IPLW,1,1)-DRHOPS (IPLW,NSPIN,1))
     &       +OMEGAC*(DRHOPS1(IPLW,1,1)-DRHOPS1(IPLW,NSPIN,1))
     &       +OMEGAC*(DRHOPS1(IPLW,1,2)-DRHOPS1(IPLW,NSPIN,2))
      DMS(-1)=OMEGAC*DRHOPS(IPLW,1,NORBS)
      DMS(+1)=OMEGAC*DRHOPS(IPLW,NSPIN,NORBS)
	DMC(1)=(DMS(-1)-DMS(+1))/SQRT(2.D0)
	DMC(2)=(DMS(-1)+DMS(+1))/SQRT(2.D0)*(0.D0,-1.D0) ! since it is M^{+/-}
	DMC(3)= DMS(0)
      DMC(0)=OMEGAC*(DRHOPS (IPLW,1,1)+DRHOPS (IPLW,NSPIN,1))/
     &2.D0*DBLE(NSPIN) 
     &      +OMEGAC*(DRHOPS1(IPLW,1,1)+DRHOPS1(IPLW,NSPIN,1))/
     &2.D0*DBLE(NSPIN) 
     &      +OMEGAC*(DRHOPS1(IPLW,1,2)+DRHOPS1(IPLW,NSPIN,2))/
     &2.D0*DBLE(NSPIN) 
	DO IA=0,3
	TCHAR(IA)=LIB_TCPS(DMC(IA),1.D-07)
	ENDDO
	IF(NORBS.EQ.1)WRITE(IUN,1100)IPTB,TCHAR(0),TCHAR(3)
	IF(NORBS.EQ.2)WRITE(IUN,1100)IPTB,(TCHAR(IA),IA=0,3)
 1100 FORMAT(1X,'Drho(G',I2,'):',1X,A19,1X,A19,1X,A19,1X,A19)
	ENDDO
C  SAVE CHANGE IN CHARGE DENSITY
      CALL DRO_DROFILES(MY,INUC,IQPNT,IUDPX,'W','D',' ')
      CALL DRO_DPSFILES(MY,INUC,IQPNT,IUDPY,'W','D',' ')
C Memory deallocations
  500 DEALLOCATE(WRAD,WRK1,WRK2,WINP,WORK1,WORK2,DQCH,XRHO,XNEW)
 1000 CONTINUE                            !!! over polarizations
 2000 CONTINUE                            !!! over displacements
	FIRST=.FALSE.
	END
