	SUBROUTINE DRO_MIXDPS(IQPNT,ITER,EXIT)
******************************************************
*  Admixture of the induced charge density in the    *
*  self-consistent cycle (pseudopart)                *
******************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
      USE COM_PHNCOM,  ONLY : ITERMAX,NITER,EPS,DELZ,DELD,CONVDRO
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_LATPAR,  ONLY : PAR,ORTH,OMEGAC                            !!! from readini
      USE COM_MIXDRHO, ONLY : ADMIX1,ADMIN,ADMAX,KEY,ADMOPT              !!! from readini
      USE COM_MIXDMAG, ONLY : ADMSPN,ASMIN,ASMAX,KSP,ADSPIN              !!! from readini
      USE COM_MIXDBRD, ONLY : LBROY,IBROY,ADMIXB,ADMIXH                  !!! from readini
	USE COM_QMESH,   ONLY : NQPNT,QPNT                                 !!! from readpnt
	USE COM_PLWMESH, ONLY : NPLW,GPLW                                  !!! from makeplw
	USE COM_DELRHO,  ONLY : DRHOPS,TRHOPS                              !!! from delrho
      USE COM_SYMNUC,  ONLY : NUMQ,KEYQ,USUM                             !!! from symnuc
	USE COM_SPHERE,  ONLY : SWZ,SMT                                    !!! from readini
      USE COM_LABELS,  ONLY : TXTEL                                      !!! from readini
	USE COM_MASHDEP, ONLY : NVAL                                       !!! from setup
	USE COM_PHNCHN  ,ONLY : IUDRO,IUDPX,IUDRX,IUDPY,IUDRY              !!! from channels
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: CONVDPS(:,:,:)
	DIMENSION QPNT0(3)
      COMPLEX*16 DROOUT,DROINP,DMNEW,DRONEW,DMOUT,DMINP,DIFDRO
     &   ,LIB_CNUM0P,DMS(-1:1),DMC(3)
	CHARACTER POL(-1:1)*1
	LOGICAL EXIT
	DATA PI/3.141592653589793D0/,POL/'m','0','p'/
	IF((MODE.EQ.4.OR.MODE.EQ.5).AND.ITER.GE.1)RETURN
	ALLOCATE(CONVDPS(0:3,-1:1,NATOMMEM))
C *** DO GLOBALLY OEVR DISPLACEMENTS AND POLARIZATIONS
      DO 2000 INUC=1,NATOM                   !!! over displacements
      DO 1000 MY=-1,1                        !!! over polarizations
      IF(NITER(MY,INUC).EQ.0)GOTO1000
C ITER<1, NOTHING IS KNOWN AT THE MOMENT
      IF(ITER.LT.1.AND.MODE.EQ.1)THEN
      CALL DRO_DPSFILES(MY,INUC,IQPNT,IUDRY,'I',' ',' ')
      CALL DRO_DPSFILES(MY,INUC,IQPNT,IUDPY,'I',' ',' ')
C ITER<1, EVERYTHING IS KNOWN
      ELSEIF(ITER.LT.1.AND.(MODE.EQ.2.OR.MODE.EQ.4.
     &  OR.MODE.EQ.5))THEN
      CALL DRO_DPSFILES(MY,INUC,IQPNT,IUDPY,'I',' ',' ')
      CALL DRO_DPSFILES(MY,INUC,IQPNT,IUDRY,'R','D',' ')
      CALL DRO_DPSFILES(MY,INUC,IQPNT,IUDPY,'W','D',' ')
C ITER<1, SOMETHING IS KNOWN
      ELSEIF(ITER.LT.1.AND.MODE.EQ.3)THEN
      CALL DRO_DPSFILES(MY,INUC,IQPNT,IUDPY,'I',' ',' ')
C ITER=1, SOFT PART DUE TO RIGID CHANGE NOW IS KNOWN, REST IS ZERO
      ELSEIF(ITER.EQ.1.AND.MODE.EQ.1)THEN
      CALL DRO_DPSFILES(MY,INUC,IQPNT,IUDPY,'R','D',' ')
	DO IORBS=1,NORBS
	DO IUPDN=1,NSPIN
	DO IPLW=0,NPLW
	TRHOPS(IPLW,IUPDN,IORBS)=DRHOPS(IPLW,IUPDN,IORBS)
	DRHOPS(IPLW,IUPDN,IORBS)=(0.D0,0.D0)
	ENDDO
	ENDDO
	ENDDO
      CALL DRO_DPSFILES(MY,INUC,IQPNT,IUDRY,'W','A',' ')
C ITER=1, NEW TRHO IS CALCULATED
      ELSEIF(ITER.EQ.1.AND.MODE.EQ.3)THEN
      CALL DRO_DPSFILES(MY,INUC,IQPNT,IUDPY,'R','D',' ')
      CALL DRO_DPSFILES(MY,INUC,IQPNT,IUDRY,'R','T',' ')
	DO IORBS=1,NORBS
	DO IUPDN=1,NSPIN
	DO IPLW=0,NPLW
	TRHOPS(IPLW,IUPDN,IORBS)=DRHOPS(IPLW,IUPDN,IORBS)-
     &TRHOPS(IPLW,IUPDN,IORBS)
	ENDDO
	ENDDO
	ENDDO
      CALL DRO_DPSFILES(MY,INUC,IQPNT,IUDRY,'W','T',' ')
      CALL DRO_DPSFILES(MY,INUC,IQPNT,IUDRY,'R','D',' ')
      CALL DRO_DPSFILES(MY,INUC,IQPNT,IUDPY,'W','D',' ')
      ENDIF
      IF(ITER.LT.1)GOTO1000
C CALCULATE CHARGE DENSITY DIFFERENCE BETWEEN TWO ITERATIONS
      CALL DRO_DPSFILES(MY,INUC,IQPNT,IUDRY,'R','D',' ')
	DO IORBS=1,NORBS
	DO IUPDN=1,NSPIN
	DO IPLW=0,NPLW
	TRHOPS(IPLW,IUPDN,IORBS)=DRHOPS(IPLW,IUPDN,IORBS)
	ENDDO
	ENDDO
	ENDDO
C Convergencies
      CALL DRO_DPSFILES(MY,INUC,IQPNT,IUDPY,'R','D',' ')
      CONVDPS(0,MY,INUC)=(0.D0,0.D0)
      CONVDPS(1,MY,INUC)=(0.D0,0.D0)
      CONVDPS(2,MY,INUC)=(0.D0,0.D0)
      CONVDPS(3,MY,INUC)=(0.D0,0.D0)
	DO IPLW=0,NPLW                       !!! over plane waves
C DENSITY CONVERGENCY
      DROOUT=(DRHOPS(IPLW,1,1)+DRHOPS(IPLW,NSPIN,1))/
     &2.D0*DBLE(NSPIN)
      DROINP=(TRHOPS(IPLW,1,1)+TRHOPS(IPLW,NSPIN,1))/
     &2.D0*DBLE(NSPIN)
      CONVDPS(0,MY,INUC)=CONVDPS(0,MY,INUC)+
     &DCONJG(DROOUT-DROINP)*(DROOUT-DROINP)
C MAGNETIZATION CONVERGENCY
      DROOUT=DRHOPS(IPLW,1,1)-DRHOPS(IPLW,NSPIN,1)
      DROINP=TRHOPS(IPLW,1,1)-TRHOPS(IPLW,NSPIN,1)
      DMS( 0)=DROOUT-DROINP
      DROOUT=DRHOPS(IPLW,1,NORBS)
      DROINP=TRHOPS(IPLW,1,NORBS)
      DMS(-1)=DROOUT-DROINP
      DROOUT=DRHOPS(IPLW,NSPIN,NORBS)
      DROINP=TRHOPS(IPLW,NSPIN,NORBS)
      DMS(+1)=DROOUT-DROINP
	DMC(1)=(DMS(-1)-DMS(+1))/SQRT(2.D0)
	DMC(2)=(DMS(-1)+DMS(+1))/SQRT(2.D0)*(0.D0,-1.D0) ! since it is M^{+/-}
	DMC(3)= DMS(0)
      DO IA=1,3
      CONVDPS(IA,MY,INUC)=CONVDPS(IA,MY,INUC)+DCONJG(DMC(IA))*DMC(IA)
      ENDDO
      ENDDO                                !!! over plane waves
1000	CONTINUE
2000	CONTINUE
	IF(ITER.LT.1)GOTO 7000
C ADMIX NEW AND OLD INDUCED CHARGE DENSITIES : [drho/dt]{inp}(i+1)
      DO 4000 INUC=1,NATOM                 !!! over displacements
      DO 3000 MY=-1,1                      !!! over polarizations
      IF(NITER(MY,INUC).EQ.0)GOTO3000
      CALL DRO_DPSFILES(MY,INUC,IQPNT,IUDRY,'R','D',' ')
	DO IORBS=1,NORBS
	DO IUPDN=1,NSPIN
	DO IPLW=0,NPLW
	TRHOPS(IPLW,IUPDN,IORBS)=DRHOPS(IPLW,IUPDN,IORBS)
	ENDDO
	ENDDO
	ENDDO
      CALL DRO_DPSFILES(MY,INUC,IQPNT,IUDPY,'R','D',' ')
	IF(LBROY(MY,INUC).LT.0)THEN
	DO IPLW=0,NPLW
C TOTAL INDUCED DENSITY
      DROOUT=(DRHOPS(IPLW,1,1)+DRHOPS(IPLW,NSPIN,1))/2.D0*DBLE(NSPIN)
      DROINP=(TRHOPS(IPLW,1,1)+TRHOPS(IPLW,NSPIN,1))/2.D0*DBLE(NSPIN)
      DRONEW=ADMOPT(MY,INUC)*DROOUT+(1.D0-ADMOPT(MY,INUC))*DROINP
C INDUCED MAGNETIZATION
      DMOUT=DRHOPS(IPLW,1,1)-DRHOPS(IPLW,NSPIN,1)
      DMINP=TRHOPS(IPLW,1,1)-TRHOPS(IPLW,NSPIN,1)
      DMNEW=ADSPIN(MY,INUC)*DMOUT+(1.D0-ADSPIN(MY,INUC))*DMINP
      DRHOPS(IPLW,1    ,1)=(DRONEW+DMNEW)/DBLE(NSPIN)
      DRHOPS(IPLW,NSPIN,1)=(DRONEW-DMNEW)/DBLE(NSPIN)
	DO IORBS=2,NORBS
	DO IUPDN=1,NSPIN
	DROOUT=DRHOPS(IPLW,IUPDN,IORBS)
	DROINP=TRHOPS(IPLW,IUPDN,IORBS)
	DRONEW=ADSPIN(MY,INUC)*DROOUT+(1.D0-ADSPIN(MY,INUC))*DROINP
	DRHOPS(IPLW,IUPDN,IORBS)=DRONEW
	ENDDO
	ENDDO
	ENDDO
	ENDIF
      CALL DRO_DPSFILES(MY,INUC,IQPNT,IUDRY,'W','D',' ')
      CALL DRO_DPSFILES(MY,INUC,IQPNT,IUDPY,'W','D',' ')
 3000 CONTINUE                             !!! over my
 4000 CONTINUE                             !!! over displacements
	WRITE(IUN,1001)
 1001 FORMAT(1X,'**** Results from the linear-mixing subroutines  -->')
	DO 6000 INUC=1,NATOM
	DO 5000 MY=-1,1
	DO ITERM=1,2
	IF(ITERM.EQ.1)ICH=IUN
	IF(ITERM.EQ.2)ICH=IUT
	IF(IUN.EQ.IUT.AND.ITERM.EQ.2)CYCLE
C  PRINT INFORMATION 
	WRITE(ICH,1010)INUC,MY,TXTEL(IS(INUC))
	IF(NITER(MY,INUC).EQ.0)WRITE(ICH,1015)
      IF(NITER(MY,INUC).EQ.0)CYCLE
	IF(LBROY(MY,INUC).LT.0)
     &WRITE(ICH,1020)ADMOPT(MY,INUC),ADMIN(MY,INUC),ADMAX(MY,INUC),
     &ADSPIN(MY,INUC),MY,INUC
	IF(LBROY(MY,INUC).GE.0)
     &WRITE(ICH,1025)ADMIXB(MY,INUC),ADMOPT(MY,INUC),MY,INUC
 1010 FORMAT(1X,'Atom ',I2,' movement:: polarization "',I2,'" ',A10)
 1015 FORMAT(1X,'Self-Consistensy either done or not performed.')
 1020 FORMAT(1X,'Opt,min,max,spn mix =',4(G12.5,1X),'|MiX',I2,1X,I2)
 1025 FORMAT(1X,'Broyden is on! bmix =',2(G12.5,1X),6X,'|MiX',I2,1X,I2)
C Charge and moments
     	WRITE(ICH,1030)LIB_CNUM0P(DELZ(0,MY,INUC),1.D-10),MY,INUC
	IF(NSPIN.EQ.2.AND.NORBS.EQ.1)
     &WRITE(ICH,1031)LIB_CNUM0P(DELZ(3,MY,INUC),1.D-10),MY,INUC
	IF(NSPIN.EQ.2.AND.NORBS.EQ.2)
     &WRITE(ICH,1032)LIB_CNUM0P(DELZ(1,MY,INUC),1.D-10),MY,INUC
	IF(NSPIN.EQ.2.AND.NORBS.EQ.2)
     &WRITE(ICH,1033)LIB_CNUM0P(DELZ(2,MY,INUC),1.D-10),MY,INUC
	IF(NSPIN.EQ.2.AND.NORBS.EQ.2)
     &WRITE(ICH,1034)LIB_CNUM0P(DELZ(3,MY,INUC),1.D-10),MY,INUC
 1030 FORMAT(1X,'Charge  Convergence = (',G14.7,',',G14.7,')',
     &  '|ChC',I2,1X,I2) 
 1031 FORMAT(1X,'MagMom  Convergence = (',G14.7,',',G14.7,')',
     &  '|MmZ',I2,1X,I2) 
 1032 FORMAT(1X,'MagMomX Convergence = (',G14.7,',',G14.7,')',
     &  '|MmX',I2,1X,I2) 
 1033 FORMAT(1X,'MagMomY Convergence = (',G14.7,',',G14.7,')',
     &  '|MmY',I2,1X,I2) 
 1034 FORMAT(1X,'MagMomZ Convergence = (',G14.7,',',G14.7,')',
     &  '|MmZ',I2,1X,I2) 
C Electric and Magnetic Dipoles
	WRITE(ICH,1040)LIB_CNUM0P(DELD(0,MY,INUC),1.D-10),MY,INUC
	IF(NSPIN.EQ.2.AND.NORBS.EQ.1)
     &WRITE(ICH,1041)LIB_CNUM0P(DELD(3,MY,INUC),1.D-10),MY,INUC
	IF(NSPIN.EQ.2.AND.NORBS.EQ.2)
     &WRITE(ICH,1042)LIB_CNUM0P(DELD(1,MY,INUC),1.D-10),MY,INUC
	IF(NSPIN.EQ.2.AND.NORBS.EQ.2)
     &WRITE(ICH,1043)LIB_CNUM0P(DELD(2,MY,INUC),1.D-10),MY,INUC
	IF(NSPIN.EQ.2.AND.NORBS.EQ.2)
     &WRITE(ICH,1044)LIB_CNUM0P(DELD(3,MY,INUC),1.D-10),MY,INUC
 1040 FORMAT(1X,'Dipole  Convergence = (',G14.7,',',G14.7,')',
     &  '|DiC',I2,1X,I2) 
 1041 FORMAT(1X,'MagDip  Convergence = (',G14.7,',',G14.7,')',
     &  '|DmZ',I2,1X,I2) 
 1042 FORMAT(1X,'MagDipX Convergence = (',G14.7,',',G14.7,')',
     &  '|DmX',I2,1X,I2) 
 1043 FORMAT(1X,'MagDipY Convergence = (',G14.7,',',G14.7,')',
     &  '|DmY',I2,1X,I2) 
 1044 FORMAT(1X,'MagDipZ Convergence = (',G14.7,',',G14.7,')',
     &  '|DmZ',I2,1X,I2) 
C Density variations     
	WRITE(ICH,1050)LIB_CNUM0P(CONVDRO(0,MY,INUC),1.D-10),MY,INUC
	IF(NSPIN.EQ.2.AND.NORBS.EQ.1)
     &WRITE(ICH,1055)LIB_CNUM0P(CONVDRO(3,MY,INUC),1.D-10),MY,INUC
	IF(NSPIN.EQ.2.AND.NORBS.EQ.2)
     &WRITE(ICH,1056)LIB_CNUM0P(CONVDRO(1,MY,INUC),1.D-10),MY,INUC
	IF(NSPIN.EQ.2.AND.NORBS.EQ.2)
     &WRITE(ICH,1057)LIB_CNUM0P(CONVDRO(2,MY,INUC),1.D-10),MY,INUC
	IF(NSPIN.EQ.2.AND.NORBS.EQ.2)
     &WRITE(ICH,1058)LIB_CNUM0P(CONVDRO(3,MY,INUC),1.D-10),MY,INUC
 1050 FORMAT(1X,'Density Convergence = (',G14.7,',',G14.7,')',
     &  '|DeC',I2,1X,I2) 
 1055 FORMAT(1X,'Magnet  Convergence = (',G14.7,',',G14.7,')',
     &  '|DiM',I2,1X,I2) 
 1056 FORMAT(1X,'MagnetX Convergence = (',G14.7,',',G14.7,')',
     &  '|DiX',I2,1X,I2) 
 1057 FORMAT(1X,'MagnetY Convergence = (',G14.7,',',G14.7,')',
     &  '|DiY',I2,1X,I2) 
 1058 FORMAT(1X,'MagnetZ Convergence = (',G14.7,',',G14.7,')',
     &  '|DiZ',I2,1X,I2) 
C Pseudodensity variations
	WRITE(ICH,1060)LIB_CNUM0P(CONVDPS(0,MY,INUC),1.D-10),MY,INUC
	IF(NSPIN.EQ.2.AND.NORBS.EQ.1)
     &WRITE(ICH,1065)LIB_CNUM0P(CONVDPS(3,MY,INUC),1.D-10),MY,INUC
	IF(NSPIN.EQ.2.AND.NORBS.EQ.2)
     &WRITE(ICH,1066)LIB_CNUM0P(CONVDPS(1,MY,INUC),1.D-10),MY,INUC
	IF(NSPIN.EQ.2.AND.NORBS.EQ.2)
     &WRITE(ICH,1067)LIB_CNUM0P(CONVDPS(2,MY,INUC),1.D-10),MY,INUC
	IF(NSPIN.EQ.2.AND.NORBS.EQ.2)
     &WRITE(ICH,1068)LIB_CNUM0P(CONVDPS(3,MY,INUC),1.D-10),MY,INUC
 1060 FORMAT(1X,'PseudoD Convergence = (',G14.7,',',G14.7,')',
     &  '|DcC',I2,1X,I2) 
 1065 FORMAT(1X,'PseudoM Convergence = (',G14.7,',',G14.7,')',
     &  '|DcM',I2,1X,I2) 
 1066 FORMAT(1X,'PseudoMXConvergence = (',G14.7,',',G14.7,')',
     &  '|DcX',I2,1X,I2) 
 1067 FORMAT(1X,'PseudoMYConvergence = (',G14.7,',',G14.7,')',
     &  '|DcY',I2,1X,I2) 
 1068 FORMAT(1X,'PseudoMZConvergence = (',G14.7,',',G14.7,')',
     &  '|DcZ',I2,1X,I2) 
      ENDDO
5000	CONTINUE                             !!! over my
6000	CONTINUE                             !!! over displacements
C CHECK FOR CONVERGENCY
	DO INUC=1,NATOM
	DO MY=-1,1
	IF(NITER(MY,INUC).NE.0)THEN
      EXDRHO=SQRT(DREAL(CONVDRO(0,MY,INUC))**2+
     &DIMAG(CONVDRO(0,MY,INUC))**2)
      EXDMOM=0.D0
      IF(NSPIN.EQ.2.AND.NORBS.EQ.1)
     &EXDMOM=SQRT(DREAL(CONVDRO(3,MY,INUC))**2
     &           +DIMAG(CONVDRO(3,MY,INUC))**2)
      IF(NSPIN.EQ.2.AND.NORBS.EQ.2)
     &EXDMOM=SQRT(DREAL(CONVDRO(1,MY,INUC))**2
     &           +DREAL(CONVDRO(2,MY,INUC))**2
     &           +DREAL(CONVDRO(3,MY,INUC))**2
     &           +DIMAG(CONVDRO(1,MY,INUC))**2
     &           +DIMAG(CONVDRO(2,MY,INUC))**2
     &           +DIMAG(CONVDRO(3,MY,INUC))**2)
      IF(EXDRHO.LE.EPS(MY,INUC).AND.EXDMOM.LE.EPS(MY,INUC).
     &AND.MODE.NE.1.AND.MODE.NE.3)NITER(MY,INUC)=0
	ENDIF
	ENDDO
	ENDDO
C CHECK FOR EXITING
      NIT=0
      DO INUC=1,NATOM
      DO MY=-1,1
      IF(NITER(MY,INUC).NE.0)THEN
      DO INUC1=1,NATOM
      DO MY1=-1,1
      IF(USUM(MY,INUC,MY1,INUC1).GT.1.D-06)THEN
      IF(NITER(MY,INUC).NE.NITER(MY1,INUC1))THEN
      WRITE(IUN,*)'CONVERGENCY IS WRONG FOR MY1,INUC1,MY,INUC:',
     &MY1,INUC1,MY,INUC
      MAXITER=MAX(NITER(MY,INUC),NITER(MY1,INUC1))
      NITER(MY,INUC)=MAXITER
      NITER(MY1,INUC1)=MAXITER
      ENDIF
      ENDIF
      ENDDO
      ENDDO
      NIT=NIT+NITER(MY,INUC)
      ENDIF
      ENDDO
      ENDDO
C SET EXITING
      EXIT=.FALSE.
      IF(NIT.EQ.0)EXIT=.TRUE.
C SET MODE=2
      IF(ITER.EQ.1)MODE=2 
C MEMORY DEALLOCATIONS
 7000 DEALLOCATE(CONVDPS)
	END
