	SUBROUTINE DRO_SPLDPS(IQPNT)
**************************************************************
*  Set new induced density if # of plane waves is changed.   *
**************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
      USE COM_PHNCOM,  ONLY : ITERMAX,NITER                              !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_LATTICE, ONLY : RBAS,GBAS                                  !!! from readstr
	USE COM_PLWMESH, ONLY : NPLW,GPLW                                  !!! from makeplw
	USE COM_SPHERE,  ONLY : SWZ,SMT                                    !!! from readini
	USE COM_LATPAR,  ONLY : PAR,ORTH,OMEGAC                            !!! from readini
	USE COM_QMESH,   ONLY : NQPNT,QPNT                                 !!! from readpnt
	USE COM_DELRHO,  ONLY : DRHOPS,TRHOPS                              !!! from delrho
      USE COM_OLDMESH, ONLY : NPLW0,GPLW0,RBAS0,GBAS0,ORTH0              !!! from dpsfiles
	USE COM_MASHDEP, ONLY : NVAL                                       !!! from setup
	USE COM_PHNCHN  ,ONLY : IUDRO,IUDPX,IUDRX,IUDPY,IUDRY              !!! from channels
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
      IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: TOLDPS(:)
	COMPLEX*16, ALLOCATABLE :: DOLDPS(:)
      DATA PI/3.141592653589793D0/
	IF(MODE.NE.3)RETURN
	ALLOCATE(DOLDPS(0:NPLWMEM))
	ALLOCATE(TOLDPS(0:NPLWMEM))
C  *** DO GLOBALLY OVER POLARIZATIONS AND DISPLACEMENTS ***
      DO 2000 INUC=1,NATOM                       !!! over displacements
      DO 1000 MY=-1,1                            !!! over polarizations
	IF(NITER(MY,INUC).EQ.0)GOTO1000
C  READ CHANGE IN CHARGE DENSITY
	CALL DRO_DPSFILES(MY,INUC,IQPNT,IUDRY,'R','A',' ')
	DO IORBS=1,NORBS                           !!! over iorbs
	DO IUPDN=1,NSPIN                           !!! over spins
C  NEW CHANGE IN PSEUDOCHARGE DENSITY 
      DO IPLW=0,NPLW0
      DOLDPS(IPLW)=DRHOPS(IPLW,IUPDN,IORBS)
      TOLDPS(IPLW)=TRHOPS(IPLW,IUPDN,IORBS)
	ENDDO
      DO IPLW=0,NPLW
      DRHOPS(IPLW,IUPDN,IORBS)=(0.D0,0.D0)
      TRHOPS(IPLW,IUPDN,IORBS)=(0.D0,0.D0)
	ENDDO
      NPLWI=-1
      DO IPLW=0,NPLW
C  SET G IN UNITS OF GBAS
      X1=GPLW(1,IPLW)*RBAS(1,1)+GPLW(2,IPLW)*RBAS(2,1)+
     &  GPLW(3,IPLW)*RBAS(3,1)
      X2=GPLW(1,IPLW)*RBAS(1,2)+GPLW(2,IPLW)*RBAS(2,2)+
     &  GPLW(3,IPLW)*RBAS(3,2)
      X3=GPLW(1,IPLW)*RBAS(1,3)+GPLW(2,IPLW)*RBAS(2,3)+
     &  GPLW(3,IPLW)*RBAS(3,3)
      M1=ANINT(X1)
      M2=ANINT(X2)
      M3=ANINT(X3)
      IF(ABS(M1-X1).GE.1.D-05.OR.
     &  ABS(M2-X2).GE.1.D-05.OR.
     &  ABS(M3-X3).GE.1.D-05)CALL FULLSTOP('<SPLDPS>:
     &  NEW RECIPROCAL VECTOR COORDINATES ARE NOT INTEGER')
      DO JPLW=0,NPLW0
      X1OLD=GPLW0(1,JPLW)*RBAS0(1,1)+
     &      GPLW0(2,JPLW)*RBAS0(2,1)+
     &      GPLW0(3,JPLW)*RBAS0(3,1)
      X2OLD=GPLW0(1,JPLW)*RBAS0(1,2)+
     &      GPLW0(2,JPLW)*RBAS0(2,2)+
     &      GPLW0(3,JPLW)*RBAS0(3,2)
      X3OLD=GPLW0(1,JPLW)*RBAS0(1,3)+
     &      GPLW0(2,JPLW)*RBAS0(2,3)+
     &      GPLW0(3,JPLW)*RBAS0(3,3)
      M1OLD=ANINT(X1OLD)
      M2OLD=ANINT(X2OLD)
      M3OLD=ANINT(X3OLD)
      IF(M1.EQ.M1OLD.AND.M2.EQ.M2OLD.AND.M3.EQ.M3OLD)THEN
      DRHOPS(IPLW,IUPDN,IORBS)=DOLDPS(JPLW)
      TRHOPS(IPLW,IUPDN,IORBS)=TOLDPS(JPLW)
      NPLWI=NPLWI+1
      ENDIF
	ENDDO
	ENDDO
	ENDDO                                     !!! over spins
	ENDDO                                     !!! over iorbs
C  STORE NEW CHANGE IN PSEUDODENSITY
	CALL DRO_DPSFILES(MY,INUC,IQPNT,IUDRY,'W','A',' ')
1000	CONTINUE                                  !!! over polarizations
2000	CONTINUE                                  !!! over displacements
      WRITE(IUN,1010)NPLW0,NPLW,NPLWI
1010  FORMAT(1X,'Plane waves: old=',I7,'; new=',I7,'; coinsiding ',I7)
	DEALLOCATE(DOLDPS,TOLDPS)
	END
