	SUBROUTINE DRO_SPLDRO(IQPNT)
**************************************************************
*  Spline old induced density into new radial mesh.          *
**************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
      USE COM_PHNCOM,  ONLY : ITERMAX,NITER                              !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_RADMESH, ONLY : NRAD,H,R,DR,WEIGHT,RL                      !!! from radmsh
	USE COM_KAPPAR,  ONLY : NPAN,NKAP                                  !!! from readini
	USE COM_SPHERE,  ONLY : SWZ,SMT                                    !!! from readini
      USE COM_DELRHO,  ONLY : DRHO,TRHO,GRHO                             !!! from delrho
	USE COM_QMESH,   ONLY : NQPNT,QPNT                                 !!! from readpnt
	USE COM_MASHDEP, ONLY : NVAL                                       !!! from setup
      USE COM_OLDMESH, ONLY : NRAD0,ROLD                                 !!! from drofiles
	USE COM_PHNCHN  ,ONLY : IUDRO,IUDPX,IUDRX,IUDPY,IUDRY              !!! from channels
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8, ALLOCATABLE :: WORK1(:,:)
	REAL*8, ALLOCATABLE :: DEROUT(:,:)
	REAL*8, ALLOCATABLE :: DERIN(:,:)
	REAL*8, ALLOCATABLE :: ROTMPR(:)
	REAL*8, ALLOCATABLE :: ROTMPI(:)
	DIMENSION QPNT0(3)
      DATA PI/3.141592653589793D0/
      IF(MODE.NE.3)RETURN
C Memory allocations
	ALLOCATE(WORK1(0:NRADMEM,2))
	ALLOCATE(DEROUT(0:NRADMEM,2))
	ALLOCATE(DERIN(0:NRADMEM,2))
	ALLOCATE(ROTMPR(0:NRADMEM))
	ALLOCATE(ROTMPI(0:NRADMEM))
C  *** DO GLOBALLY OVER POLARIZATIONS AND DISPLACEMENTS ***
	DO 2000 INUC=1,NATOM                      !!! over displacements
	DO 1000 MY=-1,1                           !!! over polarizations
	IF(NITER(MY,INUC).EQ.0)GOTO1000
C  READ CHANGE IN CHARGE DENSITY
	CALL DRO_DROFILES(MY,INUC,IQPNT,IUDRX,'R','A',' ')
C  DO OVER ATOMS AND SPINS
      DO IORBS=1,NORBS                          !!! over iorbs
	DO IUPDN=1,NSPIN                          !!! over spins
	DO IATOM=1,NATOM                          !!! over atoms
	ISORT=IS(IATOM)
	DO IRAD=0,NRAD(ISORT)
	IF(R(IRAD,ISORT)-ROLD(NRAD0(ISORT),ISORT).GT.1.D-09)GOTO100
	ENDDO
	IRAD=NRAD(ISORT)+1
 100  NR=IRAD-1
      DO LM=1,(ILSV(ISORT)+1)**2                !!! over lm
C  SPLINE INTERPOLATION FOR THE <<DRHO>>
	DO IRAD=0,NRAD0(ISORT)
	ROTMPR(IRAD)=DREAL(DRHO(IRAD,LM,IATOM,IUPDN,IORBS))
	ROTMPI(IRAD)=DIMAG(DRHO(IRAD,LM,IATOM,IUPDN,IORBS))
	ENDDO
      CALL LIB_SPLIN3(ROLD(0,ISORT),ROTMPR,DERIN,NRAD0(ISORT)+1,
     &  NRADMEM+1,R(0,ISORT),WORK1(0,1),DEROUT,NR+1,NRADMEM+1,-1)
      CALL LIB_SPLIN3(ROLD(0,ISORT),ROTMPI,DERIN,NRAD0(ISORT)+1,
     &  NRADMEM+1,R(0,ISORT),WORK1(0,2),DEROUT,NR+1,NRADMEM+1,-1)
	DO IRAD=0,NR
	DRHO(IRAD,LM,IATOM,IUPDN,IORBS)=
     &DCMPLX(WORK1(IRAD,1),WORK1(IRAD,2))
	ENDDO
	DO IRAD=NR+1,NRAD(ISORT)
	DRHO(IRAD,LM,IATOM,IUPDN,IORBS)=
     &DRHO(NR,LM,IATOM,IUPDN,IORBS)
	ENDDO
C  SPLINE INTERPOLATION FOR THE <<TRHO>>
	DO IRAD=0,NRAD0(ISORT)
	ROTMPR(IRAD)=DREAL(TRHO(IRAD,LM,IATOM,IUPDN,IORBS))
	ROTMPI(IRAD)=DIMAG(TRHO(IRAD,LM,IATOM,IUPDN,IORBS))
	ENDDO
      CALL LIB_SPLIN3(ROLD(0,ISORT),ROTMPR,DERIN,NRAD0(ISORT)+1,
     &  NRADMEM+1,R(0,ISORT),WORK1(0,1),DEROUT,NR+1,NRADMEM+1,-1)
      CALL LIB_SPLIN3(ROLD(0,ISORT),ROTMPI,DERIN,NRAD0(ISORT)+1,
     &  NRADMEM+1,R(0,ISORT),WORK1(0,2),DEROUT,NR+1,NRADMEM+1,-1)
	DO IRAD=0,NR
	TRHO(IRAD,LM,IATOM,IUPDN,IORBS)=
     &DCMPLX(WORK1(IRAD,1),WORK1(IRAD,2))
	ENDDO
	DO IRAD=NR+1,NRAD(ISORT)
	TRHO(IRAD,LM,IATOM,IUPDN,IORBS)=
     &TRHO(NR,LM,IATOM,IUPDN,IORBS)
	ENDDO
C  SPLINE INTERPOLATION FOR THE <<GRHO>>
	IF(IATOM.EQ.INUC)THEN
	DO IRAD=0,NRAD0(ISORT)
	ROTMPR(IRAD)=DREAL(GRHO(IRAD,LM,IATOM,IUPDN,IORBS))
	ROTMPI(IRAD)=DIMAG(GRHO(IRAD,LM,IATOM,IUPDN,IORBS))
	ENDDO
      CALL LIB_SPLIN3(ROLD(0,ISORT),ROTMPR,DERIN,NRAD0(ISORT)+1,
     &  NRADMEM+1,R(0,ISORT),WORK1(0,1),DEROUT,NR+1,NRADMEM+1,-1)
      CALL LIB_SPLIN3(ROLD(0,ISORT),ROTMPI,DERIN,NRAD0(ISORT)+1,
     &  NRADMEM+1,R(0,ISORT),WORK1(0,2),DEROUT,NR+1,NRADMEM+1,-1)
	DO IRAD=0,NR
	GRHO(IRAD,LM,IATOM,IUPDN,IORBS)=
     &DCMPLX(WORK1(IRAD,1),WORK1(IRAD,2))
	ENDDO
	DO IRAD=NR+1,NRAD(ISORT)
	GRHO(IRAD,LM,IATOM,IUPDN,IORBS)=
     &GRHO(NR  ,LM,IATOM,IUPDN,IORBS)
	ENDDO
	ENDIF
      ENDDO                                     !!! over lm
      ENDDO                                     !!! over atoms
      ENDDO                                     !!! over spins
      ENDDO                                     !!! over iorbs
C  STORE SPLINE-INTERPOLATED INDUCED CHARGE DENSITY
	CALL DRO_DROFILES(MY,INUC,IQPNT,IUDRX,'W','A',' ')
1000	CONTINUE                                  !!! over polarizations
2000	CONTINUE                                  !!! over displacements
C Memory deallocations
	DEALLOCATE(WORK1,DEROUT,DERIN,ROTMPR,ROTMPI)
	END
