	SUBROUTINE FRC_ENERGY1
!       Routine written by KH	
**********************************************************
*  Calculate total energy of a solid according to the    *
*  density functional theory.                            *
**********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_UNIT    ,ONLY: IUN,IUT                  !!! from setup
      USE COM_SCFLOOP ,ONLY : NITER1
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER,PARAMETER :: fh_en=578 ! Added by KH 
      REAL*8 EXCHO
      CALL ABORTNOW()
      IF (NITER1.GT.1) RETURN
C POTENTIAL PART
	CALL POT_POTFILES(12,'R','!')!! read full potential
	CALL FRC_PTNLENER(EPTN)      !!! find potential energy
	CALL POT_POTFILES(12,'!','D')!! deallocate full potential
C COULOMB PART
	CALL POT_POTFILES(12,'!','A')!!! initialize Coulomb potential
	CALL FRC_COULENER(ECOU)      !!! find Coulomb energy
	CALL POT_POTFILES(12,'!','D')!!! deallocate Coulomb potential
C EXCHANGE-CORRELATION IN LDA/GGA
	CALL POT_POTFILES(12,'!','A')!!! initialize exch.corr. potential
	CALL FRC_EXCHENER(EXCH)      !!! find exchange-correlation energy
	CALL POT_POTFILES(12,'!','D')!!! deallocate exch.corr.potential
	EXCHO = EXCH
	CALL POT_POTFILES(12,'R','A')!! read full potential
C EXCHANGE-CORRELATIONS BEYOND LDA/GGA
        CALL FRC_HUBRENER(EHUB)      !!! find Hubbard correction
	CALL FRC_DMFTENER(EDMF,0)    !!! find DMFT correction
C PRINT ENERGIES
	WRITE(IUN,1000)
	WRITE(IUN,1030)EPTN
	WRITE(IUN,1050)ECOU
	WRITE(IUN,1060)EXCH
        WRITE(IUN,1070)EHUB
	IF(IUN.NE.IUT) WRITE(IUN,1030)EPTN
	IF(IUN.NE.IUT) WRITE(IUN,1050)ECOU
	IF(IUN.NE.IUT) WRITE(IUN,1060)EXCH
	WRITE(IUN,1000)
C-------- Start Energy Output by KH ----------------------------
      open(fh_en,file='iener.dat',form='formatted')
      write(fh_en,fmt='(A)') '# Input Energies: Pot, Coul, Exch'
      write(fh_en,*) EPTN, ECOU, EXCH
      close(fh_en)
C-------- End Energy Output by KH   ----------------------------
1000  FORMAT(1X,'***************************************************')
1010  FORMAT(1X,'*       BAND ENERGY     =',G20.14,'     *')
1020  FORMAT(1X,'*       CORE ENERGY     =',G20.14,'     *')
1030  FORMAT(1X,'*       POTENTIAL ENERGY=',G20.14,'     *')
1040  FORMAT(1X,'*       KINETIC ENERGY  =',G20.14,'     *')
1050  FORMAT(1X,'*       COULOMB ENERGY  =',G20.14,'     *')
1060  FORMAT(1X,'*       EXCH-CORR ENERGY=',G20.14,'     *')
1070  FORMAT(1X,'*       LDA+U CORRECTION=',G20.14,'     *')
1080  FORMAT(1X,'*       DMFT CORRECTION =',G20.14,'     *')
1090  FORMAT(1X,'*       TOTAL ENERGY    =',G20.14,'     *')
	END
