	SUBROUTINE FRC_INTVAR(IPNT,IPAN,IENW)
***********************************************************
*  Calculates pseudopotential contribution to the         *
*  Pulay force.                                           *
***********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM
      USE COM_CONTROL ,ONLY: LMTO,IASA,NPFR                   !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS          !!! from readini
     &                      ,IS,ILST,ILSB                     !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP                   !!! from readini
      USE COM_LATPAR  ,ONLY: PAR,OMEGAC                       !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN                      !!! from readini
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC          !!! from readini
      USE COM_LATTICE ,ONLY: TAU                              !!! from readini
      USE COM_POTDAT  ,ONLY: POTPS1                           !!! from rhofull
      USE COM_INDORB  ,ONLY: INDLMT                           !!! from lmtpar
      USE COM_RINPAR  ,ONLY: VINT0=>RINT0,XFUN=>RFUN          !!! from intvar
      USE COM_PLWMESH ,ONLY: NPLW,GPLW,INDG,KVEC,KGMIN,KGMAX  !!! from plwmesh
      USE COM_ETAPAR  ,ONLY: NBAS,LBAS                        !!! from setpar
      USE COM_TEILORG ,ONLY: MBAS,KEYT                        !!! from readini
      USE COM_KMESH   ,ONLY: NPNT,PNT,WGT                     !!! from tetra
      USE COM_INPTTR  ,ONLY: SH                               !!! from readini
	USE COM_PULAYF  ,ONLY: PILF                             !!! from forces
	USE COM_LMTVEC  ,ONLY: APHR,APSR,APJR                   !!! from lmtbnd
	USE COM_CHANNELS,ONLY: IUPSI,IUPIN,IUPUL                !!! from readini
      USE COM_MASHDEP ,ONLY: LENCMP                           !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER, INTRINSIC :: SIZE
      COMPLEX*16, ALLOCATABLE :: YLM(:,:)
      COMPLEX*16, ALLOCATABLE :: APH(:,:,:)
      COMPLEX*16, ALLOCATABLE :: CFTR(:,:,:,:)
      COMPLEX*16, ALLOCATABLE :: CONVT(:)
      COMPLEX*16, ALLOCATABLE :: DCONV(:)
      COMPLEX*16, ALLOCATABLE :: PSIK(:)
      COMPLEX*16, ALLOCATABLE :: PSIX(:)
      COMPLEX*16, ALLOCATABLE :: DPSI(:)
      COMPLEX*16, ALLOCATABLE :: EXPS(:)
      COMPLEX*16, ALLOCATABLE :: EXPK(:)
      COMPLEX*16, ALLOCATABLE :: PFI(:,:)
      COMPLEX*16, ALLOCATABLE :: PFM(:,:)
	DIMENSION PNTR(3),PNTK(3)
	DATA PI/3.141592653589793D0/
C RETURN KEYS
      CALL ABORTNOW()
	IF(NPFR.EQ.0)RETURN
	IF(IENW.EQ.1)RETURN
      IF(NPLWMEM.EQ.-1)RETURN
C MEMORY ALLOCATIONS
      ALLOCATE(YLM(LIMBMEM,0:NBASMEM))
      SIZE_YLM=DBLE(SIZE(YLM)*LENCMP)/1024.D0**2
      ALLOCATE(CFTR(0:LMAXBMEM,NSORTMEM,NKAPMEM,0:NBASMEM))
      SIZE_CFTR=DBLE(SIZE(CFTR)*LENCMP)/1024.D0**2
      ALLOCATE(APH(LIMBMEM,NATOMMEM,NKAPMEM))
      ALLOCATE(CONVT(0:NBASMEM))
      ALLOCATE(DCONV(0:NBASMEM))
      ALLOCATE(PSIK(0:NBASMEM))
      ALLOCATE(PSIX(0:NBASMEM))
      ALLOCATE(DPSI(0:NBASMEM))
      ALLOCATE(EXPS(0:NBASMEM))
      ALLOCATE(EXPK(0:NBASMEM))
      SIZE_PSIS=7.D0*DBLE(SIZE(PSIK)*LENCMP)/1024.D0**2
      ALLOCATE(PFI(3,NATOMMEM))
      ALLOCATE(PFM(-1:1,NATOMMEM))
      CURMEM=CURMEM+SIZE_YLM+SIZE_CFTR+SIZE_PSIS
      IF(TOTMEM.LT.CURMEM)TXTMEM='<INTMAT> Subroutine'
      IF(TOTMEM.LT.CURMEM)TOTMEM=CURMEM
C FIND K-POINT PNTK=K+G WHICH HAS A MINIMAL LENGTH
      XK=PNT(1,IPNT,IPAN)+SH(1,IPAN)
      YK=PNT(2,IPNT,IPAN)+SH(2,IPAN)
      ZK=PNT(3,IPNT,IPAN)+SH(3,IPAN)
      CALL REDUC2(XK,YK,ZK,NBAS,GPLW(1,0),PNTK(1),PNTK(2),PNTK(3),
     &GRX,GRY,GRZ)
C SET PSEUDOLMTOS FOR THE POINT IPNTK
      CALL BND_FTRMAT(PNTK,0,IPAN,PNTR,YLM,CFTR)
C DO GLOBALLY OVER BANDS, SPINS
      DO 3000 IORBS=1,NORBS                          !!! over spinor components
      DO 2000 IBNDS=1,NSPIN                          !!! over spin subbands
      IF(NORBS.EQ.1)ISPIN=IBNDS
      IF(NORBS.EQ.2)ISPIN=IORBS
C READ POTENTIAL PARAMETERS
      IREC=ISPIN
      IF(KEYT.GT.0)
     &READ(IUPIN,REC=ISPIN)((VINT0(IPAR1,IPAR),IPAR1=1,
     &NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((XFUN(IPAR1,IBAS),
     &IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
      DO 1000 IBNDT=1,NBNDF(IPAN)                    !!! over bands
      IBAND=IBNDS+NSPIN*(IBNDT-1)
C SET |PSI(k+G)> 
      DO IBAS=0,MIN(NBAS,MBAS)
      PSIK(IBAS)=(0.D0,0.D0)
      PSIX(IBAS)=(0.D0,0.D0)
	ENDDO
      DO IATOM=1,NATOM                               !!! over iatom
	ISORT=IS(IATOM)
C CALCULATE EXPONENTIAL FACTOR
      DO IBAS=0,MIN(NBAS,MBAS)
      SCP=(GPLW(1,IBAS)+PNTK(1))*TAU(1,IATOM)+
     &    (GPLW(2,IBAS)+PNTK(2))*TAU(2,IATOM)+
     &    (GPLW(3,IBAS)+PNTK(3))*TAU(3,IATOM)
      EXPK(IBAS)=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
      ENDDO      
C PSEUDOWAVEFUNCTION:
      DO IKAP=1,NKAP(IPAN)                           !!! over energies
      DO L=0,ILSB(ISORT)                             !!! over l
      IF(LTPAN(L,IATOM,IKAP,IPAN))THEN
      DO M=-L,L                                      !!! over m
      LM=L*(L+1)+M+1
	IPAR=INDLMT(LM,IATOM,IKAP,1,IPAN)
      MINB=MIN(LBAS(L,ISORT,IKAP,IPAN),MBAS)
      DO IBAS=0,MINB
      PSIK(IBAS)=PSIK(IBAS)+APHR(LM,IATOM,IKAP,ISPIN,IBAND)*
     &CFTR(L,ISORT,IKAP,IBAS)*EXPK(IBAS)*YLM(LM,IBAS)
      ENDDO      
	IF(KEYT.NE.0)THEN
      DO IBAS=0,MIN(NBAS,MBAS) 
      PSIX(IBAS)=PSIX(IBAS)+DCONJG(APHR(LM,IATOM,IKAP,ISPIN,IBAND)*
     &EXPK(0))*XFUN(IPAR,IBAS)
      ENDDO      
	ENDIF
      ENDDO                                          !!! over m
	ENDIF
      ENDDO                                          !!! over l
      ENDDO                                          !!! over ikap
      ENDDO                                          !!! over iatom
C SET CONVOLUTION OF THE PSEUDOORBITAL WITH THE PSEUDOPOTENTIAL
      M1D=KGMAX(1)-KGMIN(1)+1
      M2D=KGMAX(2)-KGMIN(2)+1
      M3D=KGMAX(3)-KGMIN(3)+1
      M12D=M1D*M2D
      M123D=M1D*M2D*M3D
	DO IBAS=0,MIN(NBAS,MBAS)
	CONVT(IBAS)=PSIX(IBAS)
      M1I=KVEC(1,IBAS)+KGMIN(1)
      M2I=KVEC(2,IBAS)+KGMIN(2)
      M3I=KVEC(3,IBAS)+KGMIN(3)
	DO JBAS=0,MIN(NBAS,MBAS)
      M1K=KVEC(1,JBAS)-M1I
      M2K=KVEC(2,JBAS)-M2I
      M3K=KVEC(3,JBAS)-M3I
      IFTR=1+M1K+M1D*M2K+M12D*M3K
      KPLW=-1
      IF(IFTR.GT.0.AND.IFTR.LE.M123D)KPLW=INDG(IFTR)
      IF(KPLW.GE.0)
     &CONVT(IBAS)=CONVT(IBAS)+DCONJG(PSIK(JBAS))*POTPS1(KPLW,ISPIN,1)
      ENDDO      
      ENDDO      
C *** DO GLOBALLY OVER DISPLACEMENTS AND POLARIZATIONS ***
	DO INUC=1,NATOM                                !!! over displacements
	DO IXYZ=1,3                                    !!! over polarizations
C SET Delta|PSI(k+G)>
      DO IBAS=0,MIN(NBAS,MBAS)
      DPSI(IBAS)=(0.D0,0.D0)
      ENDDO      
      DO IATOM=1,NATOM                               !!! over iatom
	ISORT=IS(IATOM)
	IF(IATOM.EQ.INUC)THEN
C CALCULATE EXPONENTIAL FACTOR
      DO IBAS=0,MIN(NBAS,MBAS)
      SCP=(GPLW(1,IBAS)+PNTK(1))*TAU(1,IATOM)+
     &    (GPLW(2,IBAS)+PNTK(2))*TAU(2,IATOM)+
     &    (GPLW(3,IBAS)+PNTK(3))*TAU(3,IATOM)
      EXPK(IBAS)=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
      ENDDO      
C PSEUDOWAVEFUNCTION CHANGE IN FIRST ORDER
      DO IKAP=1,NKAP(IPAN)                           !!! over energies
      DO L=0,ILSB(ISORT)                             !!! over l
      IF(LTPAN(L,IATOM,IKAP,IPAN))THEN
      DO M=-L,L                                      !!! over m
      LM=L*(L+1)+M+1
      MINB=MIN(LBAS(L,ISORT,IKAP,IPAN),MBAS)
      DO IBAS=0,MINB
      DPSI(IBAS)=DPSI(IBAS)+APHR(LM,IATOM,IKAP,ISPIN,IBAND)*
     &CFTR(L,ISORT,IKAP,IBAS)*EXPK(IBAS)*YLM(LM,IBAS)*
     &(0.D0,-1.D0)*(GPLW(IXYZ,IBAS)+PNTK(IXYZ))*2.D0*PI/PAR
      ENDDO      
      ENDDO                                          !!! over m
	ENDIF
      ENDDO                                          !!! over l
      ENDDO                                          !!! over ikap
	ENDIF
      ENDDO                                          !!! over iatom
C SET INTERSTITIAL CONTRIBUTION TO THE PULAY FORCE
	PFI(IXYZ,INUC)=(0.D0,0.D0)
	DO IBAS=0,MIN(NBAS,MBAS)
	PFI(IXYZ,INUC)=PFI(IXYZ,INUC)+CONVT(IBAS)*DPSI(IBAS)
      ENDDO      
	PFI(IXYZ,INUC)=PFI(IXYZ,INUC)+DCONJG(PFI(IXYZ,INUC))
      ENDDO                                          !!! over polarizations
      ENDDO                                          !!! over displacements
C TRANSFERE TO CYCLIC COORDINATE SYSTEM
	DO INUC=1,NATOM
	PFM(-1,INUC)=+1.D0/SQRT(2.D0)*
     &  (PFI(1,INUC)-(0.D0,1.D0)*PFI(2,INUC))
	PFM(+1,INUC)=-1.D0/SQRT(2.D0)*
     &  (PFI(1,INUC)+(0.D0,1.D0)*PFI(2,INUC))
	PFM(0,INUC)=PFI(3,INUC)
	DO MY=-1,1
	PILF(MY,INUC,IORBS,IBAND,2)=PFM(MY,INUC)
      ENDDO      
      ENDDO      
C STORE FOR BANDS CROSSING THE FERMI LEVEL
      IF(IBNDT.GE.NBNDE(IPAN))THEN !!! write for fermi states
      IF(IPAN.GT.1)
     &CALL FULLSTOP('<INTVAR> ERROR IN WRITE STATEMENT')
      IREC=IBNDT-NBNDE(1)+1+
     &(NBNDF(1)-NBNDE(1)+1)*(IBNDS-1)+
     &(NBNDF(1)-NBNDE(1)+1)*NSPIN*(IORBS-1)+
     &(NBNDF(1)-NBNDE(1)+1)*NSPIN*NORBS*(IPNT-1)
      WRITE(IUPUL,REC=IREC)(((PILF(MY,INUC,IORBS,IBAND,IMI),
     &MY=-1,1),INUC=1,NATOM),IMI=1,2)
      ENDIF
1000  CONTINUE                                !!! over bands
2000  CONTINUE                                !!! over spin subbands
3000  CONTINUE                                !!! over spinor components
C MEMORY DEALLOCATIONS
      DEALLOCATE(YLM,CFTR,CONVT,DCONV,PSIK,PSIX)
      DEALLOCATE(APH,DPSI,EXPS,EXPK,PFI,PFM)
      CURMEM=CURMEM-SIZE_YLM-SIZE_CFTR-SIZE_PSIS
	END
