	SUBROUTINE FRC_PULEND(IPAN)
***********************************************************
*  Makes final contribution to the Pulay force.           *
***********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                          !!! from setup
      USE COM_CONTROL ,ONLY: LMTO,IASA,NPFR                   !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS          !!! from readini
     &                      ,IS,ILST,ILSB                     !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP                   !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN                      !!! from readini
      USE COM_LATPAR  ,ONLY: PAR,OMEGAC                       !!! from readini
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC          !!! from readini
      USE COM_LATTICE ,ONLY: TAU                              !!! from readini
      USE COM_POTDAT  ,ONLY: POTPS1                           !!! from rhofull
      USE COM_INDORB  ,ONLY: INDLMT                           !!! from lmtpar
      USE COM_PLWMESH ,ONLY: NPLW,GPLW                        !!! from plwmesh
      USE COM_ETAPAR  ,ONLY: NBAS,LBAS                        !!! from setpar
      USE COM_TEILORG ,ONLY: MBAS,KEYT                        !!! from readini
      USE COM_RINPAR  ,ONLY: RINT0,RFUN                       !!! from tosint
	USE COM_PULAYF  ,ONLY: PFVAL,PILF                       !!! from forces
      USE COM_MASHDEP ,ONLY: LENCMP                           !!! from setup
	USE COM_CHANNELS,ONLY: IUPDS,IUPFC                      !!! from channels
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER, INTRINSIC :: SIZE
      COMPLEX*16, ALLOCATABLE :: YLM(:,:)
      COMPLEX*16, ALLOCATABLE :: CFTR(:,:,:,:)
      COMPLEX*16, ALLOCATABLE :: EXPS(:)
      COMPLEX*16, ALLOCATABLE :: CHIS(:)
      COMPLEX*16, ALLOCATABLE :: CONV(:)
      COMPLEX*16, ALLOCATABLE :: EXPK(:)
      COMPLEX*16, ALLOCATABLE :: CHIK(:)
      COMPLEX*16, ALLOCATABLE :: CONR(:)
      COMPLEX*16, ALLOCATABLE :: CONT1(:,:)
      COMPLEX*16, ALLOCATABLE :: PFI(:,:)
      COMPLEX*16, ALLOCATABLE :: PFM(:,:)
	DIMENSION PNTR(3),PNTK(3)
	DATA PI/3.141592653589793D0/
      CALL ABORTNOW()
C RETURN KEYS
      IF(NPLWMEM.EQ.-1)RETURN
      IF(KEYT.EQ.0)RETURN
      IF(NPFR.EQ.0)RETURN
C MEMORY ALLOCATIONS
      ALLOCATE(YLM(LIMBMEM,0:NBASMEM))
      ALLOCATE(CFTR(0:LMAXBMEM,NSORTMEM,NKAPMEM,0:NBASMEM))
      SIZE_YLM=DBLE(SIZE(YLM)*LENCMP)/1024.D0**2
      SIZE_CFTR=DBLE(SIZE(CFTR)*LENCMP)/1024.D0**2
      ALLOCATE(EXPS(0:NBASMEM))
      ALLOCATE(CHIS(0:NBASMEM))
      ALLOCATE(CONV(0:NBASMEM))
      ALLOCATE(EXPK(0:NBASMEM))
      ALLOCATE(CHIK(0:NBASMEM))
      ALLOCATE(CONR(0:NBASMEM))
      ALLOCATE(CONT1(0:NBASMEM,3))
      SIZE_PSIS=9.D0*DBLE(SIZE(EXPS)*LENCMP)/1024.D0**2
      CURMEM=CURMEM+SIZE_YLM+SIZE_CFTR+SIZE_PSIS
      IF(TOTMEM.LT.CURMEM)TXTMEM='<PULEND> Subroutine'
      IF(TOTMEM.LT.CURMEM)TOTMEM=CURMEM
      ALLOCATE(PFI(3,NATOMMEM))
      ALLOCATE(PFM(-1:1,NATOMMEM))
C START CODE:
      PNTK(1)=0.D0
      PNTK(2)=0.D0
      PNTK(3)=0.D0
C SET PSEUDOLMTOS FOR THE POINT IPNTK
      CALL BND_FTRMAT(PNTK,1,IPAN,PNTR,YLM,CFTR)
C DO OVER SPINS
	DO 1000 ISPIN=1,NSPIN                       !!! over spins
      IREC=ISPIN
      READ(IUPDS,REC=IREC)((RINT0(IPAR1,IPAR),IPAR1=1,
     &NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((RFUN(IPAR1,IBAS),
     &IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
C SET ZEROES
	DO INUC=1,NATOM	
	DO IXYZ=1,3
	PFI(IXYZ,INUC)=(0.D0,0.D0)
	ENDDO
	ENDDO
C DO OVER LEFT INDEX
      DO IATOM1=1,NATOM                           !!! over iatom1
      ISORT1=IS(IATOM1)
	INUC1=IATOM1                                !!! <--- displacing atom
C CALCULATE EXPONENTIAL FACTOR
      DO IBAS=0,NBAS
      SCP=(GPLW(1,IBAS)+PNTK(1))*TAU(1,IATOM1)+
     &    (GPLW(2,IBAS)+PNTK(2))*TAU(2,IATOM1)+
     &    (GPLW(3,IBAS)+PNTK(3))*TAU(3,IATOM1)
      EXPS(IBAS)=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	ENDDO
      DO IKAP1=1,NKAP(IPAN)                       !!! over energy
      DO L1=0,ILSB(ISORT1)                        !!! over l1
      DO M1=-L1,L1                                !!! over m1
      IF(.NOT.LTPAN(L1,IATOM1,IKAP1,IPAN))EXIT
      L1M1=L1*(L1+1)+M1+1
      IPAR1=INDLMT(L1M1,IATOM1,IKAP1,1,IPAN)
C FOURIER TRANSFORM OF THE PSEUDOORBITAL
      DO IBAS=MBAS+1,LBAS(L1,ISORT1,IKAP1,IPAN)   !!! NG_1{large}
      CHIS(IBAS)=DCONJG(CFTR(L1,ISORT1,IKAP1,IBAS)*
     &YLM(L1M1,IBAS)*EXPS(IBAS))
	ENDDO
	DO IBAS=0,MIN(NBAS,MBAS)
	CHIK(IBAS)=RFUN(IPAR1,IBAS)
	ENDDO
C CONVOLUTION OF THE PSEUDOORBITAL WITH THE PSEUDOPOTENTIAL
      CALL BND_CONVOL1(POTPS1(0,ISPIN,1),CHIS(0),CONV(0),'L',
     &             0,NBAS,MBAS+1,LBAS(L1,ISORT1,IKAP1,IPAN))
      CALL BND_CONVOL1(POTPS1(0,ISPIN,1),CHIK(0),CONR(0),'R',
     &             MBAS+1,NBAS,0,MIN(NBAS,MBAS))
C DO OVER POLARIZATIONS
	DO IXYZ=1,3                                 !!! over xyz
C  1) SMALL-SMALL G CONTRIBUTION : HAS BEEN DONE BEFORE
C  2) SMALL-LARGE G CONTRIBUTION
	DO IBAS=MBAS+1,LBAS(L1,ISORT1,IKAP1,IPAN)
   	PFI(IXYZ,INUC1)=PFI(IXYZ,INUC1)+(0.D0,1.D0)*
     &	CHIS(IBAS)*CONR(IBAS)*GPLW(IXYZ,IBAS)*2.D0*PI/PAR
	ENDDO
      ENDDO                                       !!! over xyz
C SET CONVOLUTION OF PSEUDOORBITAL WITH TOS-MATRIX
      DO INUC=1,NATOM                             !!! over iatom
	IATOM=INUC
      ISORT=IS(IATOM)
	DO IXYZ=1,3
	DO IBAS=0,NBAS
	CONT1(IBAS,IXYZ)=(0.D0,0.D0)
	ENDDO
	ENDDO
C CALCULATE EXPONENTIAL FACTOR
      DO IBAS=0,NBAS                              !!! NGMAX{large}
      SCP=(GPLW(1,IBAS)+PNTK(1))*TAU(1,IATOM)+
     &    (GPLW(2,IBAS)+PNTK(2))*TAU(2,IATOM)+
     &    (GPLW(3,IBAS)+PNTK(3))*TAU(3,IATOM)
      EXPK(IBAS)=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	ENDDO 
      DO IKAP=1,NKAP(IPAN)                        !!! over energy
      DO L=0,ILSB(ISORT)                          !!! over l
      DO M=-L,L                                   !!! over m
      IF(.NOT.LTPAN(L,IATOM,IKAP,IPAN))EXIT
      LM=L*(L+1)+M+1
      IPAR=INDLMT(LM,IATOM,IKAP,1,IPAN)
C SET LOWER PART OF THE MATRIX
      IF(IPAR1.LT.IPAR)
     &RINT0(IPAR1,IPAR)=DCONJG(RINT0(IPAR,IPAR1))
C FOURIER TRANSFORM OF THE PSEUDOORBITAL
      DO IBAS=MBAS+1,LBAS(L,ISORT,IKAP,IPAN)
      CHIK(IBAS)=CFTR(L,ISORT,IKAP,IBAS)*YLM(LM,IBAS)*EXPK(IBAS)
	ENDDO
C DO OVER POLARIZATIONS
	DO IXYZ=1,3                                 !!! over xyz
	DO IBAS=MBAS+1,LBAS(L,ISORT,IKAP,IPAN)
	CONT1(IBAS,IXYZ)=CONT1(IBAS,IXYZ)+RINT0(IPAR1,IPAR)*
     &CHIK(IBAS)*(0.D0,1.D0)*GPLW(IXYZ,IBAS)*2.D0*PI/PAR
      ENDDO    
      ENDDO                                       !!! over m
      ENDDO                                       !!! over l
      ENDDO                                       !!! over energy
      ENDDO                                       !!! over xyz
C  4) LARGE-LARGE G CONTRIBUTION
	DO IXYZ=1,3                                 !!! over xyz
	DO IBAS=MBAS+1,NBAS
	PFI(IXYZ,INUC)=PFI(IXYZ,INUC)-CONV(IBAS)*CONT1(IBAS,IXYZ)
      ENDDO
      ENDDO                                       !!! over xyz
      ENDDO                                       !!! over inuc
      ENDDO                                       !!! over m1
      ENDDO                                       !!! over l1
      ENDDO                                       !!! over energy
      ENDDO                                       !!! over iatom1
C TRANSFERE TO SPHERICAL COORDINATE SYSTEM
      DO INUC=1,NATOM
	DO IXYZ=1,3
      PFI(IXYZ,INUC)=PFI(IXYZ,INUC)+DCONJG(PFI(IXYZ,INUC))
	ENDDO
      PFM(-1,INUC)=+1.D0/SQRT(2.D0)*
     &      (PFI(1,INUC)-(0.D0,1.D0)*PFI(2,INUC))
      PFM(+1,INUC)=-1.D0/SQRT(2.D0)*
     &      (PFI(1,INUC)+(0.D0,1.D0)*PFI(2,INUC))
      PFM(0,INUC)=PFI(3,INUC)
	DO MY=-1,1
      PFVAL(MY,INUC,IPAN,ISPIN,2)=PFVAL(MY,INUC,IPAN,ISPIN,2)+
     &PFM(MY,INUC)
	ENDDO
	ENDDO
1000	CONTINUE                                    !!! over spins
C DO AGAIN OVER POLARIZATIONS AND SPINS 
	DO 3000 ISPIN=1,NSPIN                       !!! over spins
	DO 2000 IXYZ=1,3                            !!! over xyz
      IREC=ISPIN+NSPIN*(IXYZ-1)
      READ(IUPFC,REC=IREC)((RINT0(IPAR1,IPAR),IPAR1=1,
     &NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((RFUN(IPAR1,IBAS),
     &IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
C SET ZEROES
	DO INUC=1,NATOM	
	PFI(IXYZ,INUC)=(0.D0,0.D0)
	ENDDO
C DO OVER LEFT INDEX
      DO IATOM1=1,NATOM                           !!! over iatom1
      ISORT1=IS(IATOM1)
	INUC1=IATOM1                                !!! <--- displacing atom
C CALCULATE EXPONENTIAL FACTOR
      DO IBAS=0,NBAS
      SCP=(GPLW(1,IBAS)+PNTK(1))*TAU(1,IATOM1)+
     &    (GPLW(2,IBAS)+PNTK(2))*TAU(2,IATOM1)+
     &    (GPLW(3,IBAS)+PNTK(3))*TAU(3,IATOM1)
      EXPS(IBAS)=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	ENDDO
      DO IKAP1=1,NKAP(IPAN)                       !!! over energy
      DO L1=0,ILSB(ISORT1)                        !!! over l1
      DO M1=-L1,L1                                !!! over m1
      IF(.NOT.LTPAN(L1,IATOM1,IKAP1,IPAN))EXIT
      L1M1=L1*(L1+1)+M1+1
      IPAR1=INDLMT(L1M1,IATOM1,IKAP1,1,IPAN)
C FOURIER TRANSFORM OF THE PSEUDOORBITAL
      DO IBAS=MBAS+1,LBAS(L1,ISORT1,IKAP1,IPAN)   !!! NG_1{large}
      CHIS(IBAS)=DCONJG(CFTR(L1,ISORT1,IKAP1,IBAS)*
     &YLM(L1M1,IBAS)*EXPS(IBAS))
	ENDDO
C CONVOLUTION OF THE PSEUDOORBITAL WITH THE PSEUDOPOTENTIAL
      CALL BND_CONVOL1(POTPS1(0,ISPIN,1),CHIS(0),CONV(0),'L',
     &             0,NBAS,MBAS+1,LBAS(L1,ISORT1,IKAP1,IPAN))
C  1) SMALL-SMALL G CONTRIBUTION : HAS BEEN DONE BEFORE
C  2) LARGE-SMALL G CONTRIBUTION
	DO IBAS=0,MIN(NBAS,MBAS)
   	PFI(IXYZ,INUC1)=PFI(IXYZ,INUC1)+(0.D0,1.D0)*
     &CONV(IBAS)*RFUN(IPAR1,IBAS)
      ENDDO                                       !!! over ibas
C SET CONVOLUTION OF PSEUDOORBITAL WITH TOS-MATRIX
      DO INUC=1,NATOM                             !!! over iatom
	IATOM=INUC
      ISORT=IS(IATOM)
	DO IBAS=0,NBAS
	CONT1(IBAS,1)=(0.D0,0.D0)
	ENDDO
C CALCULATE EXPONENTIAL FACTOR
      DO IBAS=0,NBAS                              !!! NGMAX{large}
      SCP=(GPLW(1,IBAS)+PNTK(1))*TAU(1,IATOM)+
     &    (GPLW(2,IBAS)+PNTK(2))*TAU(2,IATOM)+
     &    (GPLW(3,IBAS)+PNTK(3))*TAU(3,IATOM)
      EXPK(IBAS)=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	ENDDO
      DO IKAP=1,NKAP(IPAN)                        !!! over energy
      DO L=0,ILSB(ISORT)                          !!! over l
      DO M=-L,L                                   !!! over m
      IF(.NOT.LTPAN(L,IATOM,IKAP,IPAN))EXIT
      LM=L*(L+1)+M+1
      IPAR=INDLMT(LM,IATOM,IKAP,1,IPAN)
C SET LOWER PART OF THE MATRIX
      IF(IPAR1.LT.IPAR)
     &RINT0(IPAR1,IPAR)=DCONJG(RINT0(IPAR,IPAR1))
C FOURIER TRANSFORM OF THE PSEUDOORBITAL
      DO IBAS=MBAS+1,LBAS(L,ISORT,IKAP,IPAN)
      CHIK(IBAS)=CFTR(L,ISORT,IKAP,IBAS)*YLM(LM,IBAS)*EXPK(IBAS)
	ENDDO
C CONVOLUTION
	DO IBAS=MBAS+1,LBAS(L,ISORT,IKAP,IPAN)
	CONT1(IBAS,1)=CONT1(IBAS,1)+RINT0(IPAR1,IPAR)*
     &CHIK(IBAS)*(0.D0,1.D0)
	ENDDO
      ENDDO                                      !!! over m
      ENDDO                                      !!! over l
      ENDDO                                      !!! over energy
C  4) LARGE-LARGE G CONTRIBUTION
	DO IBAS=MBAS+1,NBAS
	PFI(IXYZ,INUC)=PFI(IXYZ,INUC)-CONV(IBAS)*CONT1(IBAS,1)
      ENDDO                                      !!! over ibas
      ENDDO                                      !!! over inuc
      ENDDO                                      !!! over m1
      ENDDO                                      !!! over l1
      ENDDO                                      !!! over energy
      ENDDO                                      !!! over iatom1
2000	CONTINUE                                   !!! over polarizations
C TRANSFERE TO SPHERICAL COORDINATE SYSTEM
      DO INUC=1,NATOM
	DO IXYZ=1,3
      PFI(IXYZ,INUC)=PFI(IXYZ,INUC)+DCONJG(PFI(IXYZ,INUC))
	ENDDO
      PFM(-1,INUC)=+1.D0/SQRT(2.D0)*
     &    (PFI(1,INUC)-(0.D0,1.D0)*PFI(2,INUC))
      PFM(+1,INUC)=-1.D0/SQRT(2.D0)*
     &    (PFI(1,INUC)+(0.D0,1.D0)*PFI(2,INUC))
      PFM(0,INUC)=PFI(3,INUC)
	DO MY=-1,1
      PFVAL(MY,INUC,IPAN,ISPIN,2)=PFVAL(MY,INUC,IPAN,ISPIN,2)+
     &PFM(MY,INUC)
	ENDDO
	ENDDO
3000	CONTINUE                                   !!! over spins
C MEMORY DEALLOCATIONS
      DEALLOCATE(YLM,CFTR,EXPS,CHIS,CONV,EXPK)
      DEALLOCATE(CHIK,CONR,CONT1,PFI,PFM)
      CURMEM=CURMEM-SIZE_YLM-SIZE_CFTR-SIZE_PSIS
	END
