	SUBROUTINE FTB_ALLOCATE(AOPER)
*********************************************************
*  Subroutine prepares hamiltonian matrix and overlap   *
*  matrix from real-space form for given k-point.       *
*********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                          !!! from setup
      USE COM_LATTICE ,ONLY: RBAS,GBAS,TAU                    !!! from readstr
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS,ILSB  !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP                   !!! from readini
      USE COM_TBBPAR  ,ONLY: LTBAS,LSBAS,INBAS,NTBAS          !!! from readhop
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDC,NBNDT,NBNDH    !!! from readini
      USE COM_ENVSITE ,ONLY: NENV,TENV,ISENV                  !!! from envmesh
      USE COM_LMTMAT  ,ONLY: HMAT,OMAT                        !!! from lmtmat
      USE COM_HOPCOM  ,ONLY: TMAT,SMAT                        !!! from readhop
	USE COM_ENERGY  ,ONLY: EARR,EARW,ETRT,ETRW,WTOS,WDOS
     &                      ,WTRT,WDRT                        !!! from allocate
      USE COM_INPTTR  ,ONLY: NDIV,NDIC,SH                     !!! from readini
      USE COM_KMESH   ,ONLY: NPNT,PNT                         !!! from tetra
      USE COM_WMESH   ,ONLY: NPNW,PNW                         !!! from tetra
      USE COM_MASHDEP ,ONLY: LENCMP                           !!! from setup
      USE COM_UNIT    ,ONLY: IUN,IUT                          !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
	CHARACTER*1 AOPER
	DATA PI/3.141592653589793D0/
      CALL ABORTNOW()
	IF(.NOT.ALLOCATED(EARR))
     &ALLOCATE(EARR(NBNDT(1)*NSPINMEM,NPNTMEM,NPANMEM))
	IF(.NOT.ALLOCATED(EARW))
     &ALLOCATE(EARW(NBNDT(1)*NSPINMEM,NPNWMEM,NPANMEM))
	IF(.NOT.ALLOCATED(WTOS))
     &ALLOCATE(WTOS(NBNDT(1)*NSPINMEM,NPNTMEM))
	IF(.NOT.ALLOCATED(WDOS))
     &ALLOCATE(WDOS(NBNDT(1)*NSPINMEM,NPNTMEM))
	IF(.NOT.ALLOCATED(ETRT))
     &ALLOCATE(ETRT((NBNDT(1)+NBNDH(1))*NSPINMEM,NPNTMEM,NPANMEM))
	IF(.NOT.ALLOCATED(ETRW))
     &ALLOCATE(ETRW((NBNDT(1)+NBNDH(1))*NSPINMEM,NPNWMEM,NPANMEM))
	IF(.NOT.ALLOCATED(WTRT))
     &ALLOCATE(WTRT((NBNDT(1)+NBNDH(1))*NSPINMEM,NPNTMEM))
	IF(.NOT.ALLOCATED(WDRT))
     &ALLOCATE(WDRT((NBNDT(1)+NBNDH(1))*NSPINMEM,NPNTMEM))
C MEMORY ALLOCATIONS
	IF(AOPER.EQ.'A')THEN
      ALLOCATE(HMAT(NTBAS*NSPIN,NTBAS*NSPIN))
      ALLOCATE(OMAT(NTBAS*NSPIN,NTBAS*NSPIN))
C MEMORY DEALLOCATIONS
	ELSEIF(AOPER.EQ.'D')THEN
	DEALLOCATE(HMAT,OMAT)
	ENDIF
	END