	SUBROUTINE FTB_FTBBND(IPNT,IENW)
*********************************************************
*  Subroutine prepares hamiltonian matrix and overlap   *
*  matrix,calculates eigenvalies and eigenvectors and   *
*  prepares wave functions                              *
*********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                               !!! from setup
      USE COM_CONTROL ,ONLY: LIFT,LMTO,IASA,NPFR,IDMF              !!! from readini
      USE COM_LATTICE ,ONLY: RBAS,GBAS,TAU                         !!! from readstr
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS,ILSB       !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP                        !!! from readini
      USE COM_TBBPAR  ,ONLY: LTBAS,LSBAS,INBAS,NTBAS               !!! from readhop
      USE COM_ENVSITE ,ONLY: NENV,TENV,ISENV                       !!! from envmesh
      USE COM_LMTMAT  ,ONLY: HMAT,OMAT                             !!! from lmtmat
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC               !!! from readini
      USE COM_ENERGY  ,ONLY: EARR,EARW                             !!! from bands
      USE COM_HUBDAT  ,ONLY: MCRL,LCRL,NCLM                        !!! from readhub
      USE COM_INPTTR  ,ONLY: NDIV,NDIC,SH                          !!! from readini
      USE COM_KMESH   ,ONLY: NPNT,PNT                              !!! from tetra
      USE COM_WMESH   ,ONLY: NPNW,PNW                              !!! from tetra
      USE COM_MASHDEP ,ONLY: LENCMP                                !!! from setup
      USE COM_LMTOUT  ,ONLY: ICPSK,ICCHI,ICOPT                     !!! from readini
      USE COM_LMTOUT  ,ONLY: ICCON,ICOPT,ICCHI,ICODF,ICBND !!! from readini  (Gunnar)
      USE COM_PANPAR  ,ONLY: LTPAN                                 !!! from readini  (Gunnar)
      USE COM_INDORB  ,ONLY: INDLMT                                !!! from lmtpar   (Gunnar)
      USE COM_CHANNELS,ONLY: IUPSI,IUPSK,IUHAM,IUWFK               !!! from readini
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                       !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8, ALLOCATABLE :: E(:)
	COMPLEX*16, ALLOCATABLE :: CR(:,:,:)
      LOGICAL LOG


c---------- Start : Hamiltonian and overlap matrix output by Gunnar ----------

        integer :: fh_ham = 547
        integer :: fh_olp = 557
        integer, parameter  :: fh_idx = 7919 ! File handle added by Gunnar


c---------- Finish: Hamiltonian and overlap matrix output by Gunnar ----------

	
      DATA PI/3.141592653589793D0/
      CALL ABORTNOW()
C MEMORY ALLOCATIONS
      ALLOCATE(E(NBNDT(1)*NSPINMEM))
      ALLOCATE(CR(NCLM,NSPINMEM,NBNDT(1)*NSPINMEM))
C HERMITIANNESS OF THE MATRICES
	DO IDIM1=1,NTBAS*NSPIN
	DO IDIM=1,IDIM1
      TH=ABS(HMAT(IDIM1,IDIM)-CONJG(HMAT(IDIM,IDIM1)))
C     IF(TH.GE.1.D-05)WRITE(IUT,*)'HMAT-->',IDIM1,IDIM,TH
      TO=ABS(OMAT(IDIM1,IDIM)-CONJG(OMAT(IDIM,IDIM1)))
C     IF(TO.GE.1.D-05)WRITE(IUT,*)'OMAT-->',IDIM1,IDIM,TO
	ENDDO
	ENDDO

c---------- Start : Hamiltonian and overlap matrix output by Gunnar ----------
	   
c	if(ICBND.gt.0) then

	if(IPNT.eq.1) then
	open(fh_ham,file='ham.dat',form='formatted')
	open(fh_olp,file='olp.dat',form='formatted')
	write(fh_ham,*) NPNT(1),NBNDT(1)
	write(fh_olp,*) NPNT(1),NBNDT(1)
	else
c	open(fh_ham,file='ham.dat',access='append',form='formatted')
c	open(fh_olp,file='olp.dat',access='append',form='formatted')
	open(fh_ham,file='ham.dat',access='SEQUENTIAL',POSITION='APPEND')
	open(fh_olp,file='olp.dat',access='SEQUENTIAL',POSITION='APPEND')
	endif

	write(fh_ham,*) IPNT
	write(fh_olp,*) IPNT

	IF(IENW.EQ.1)NSHIFT=0
	IF(IENW.EQ.0.AND.NPNW(1).EQ.NPNT(1))NSHIFT=0
	IF(IENW.EQ.0.AND.NPNW(1).GT.NPNT(1))NSHIFT=NSPIN*NORBS*NPNW(1)
	DO IORBS=1,NORBS
	DO IUPDN=1,NSPIN
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF

	write(fh_ham,*) ((hmat(IDIM1+NBNDT(1)*(ISPIN1-1),
     &                         IDIM +NBNDT(1)*(ISPIN -1)),
     &                         IDIM1=1,NBNDT(1)),IDIM=1,NBNDT(1))
	
	write(fh_olp,*) ((omat(IDIM1+NBNDT(1)*(ISPIN1-1),
     &                         IDIM +NBNDT(1)*(ISPIN -1)),
     &                         IDIM1=1,NBNDT(1)),IDIM=1,NBNDT(1))
	
	enddo
	enddo

	close(fh_ham)
	close(fh_olp)

c	endif

c---------- Finish: Hamiltonian and overlap matrix output by Gunnar --------


	
C HAMILTONIAN STORAGE
	IF(IDMF.GT.2)THEN
	IF(IENW.EQ.1)NSHIFT=0
	IF(IENW.EQ.0.AND.NPNW(1).EQ.NPNT(1))NSHIFT=0
	IF(IENW.EQ.0.AND.NPNW(1).GT.NPNT(1))NSHIFT=NSPIN*NORBS*NPNW(1)
	DO IORBS=1,NORBS
	DO IUPDN=1,NSPIN
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
	IREC=IUPDN+NSPIN*(IORBS-1)+NSPIN*NORBS*(IPNT-1)+NSHIFT
      WRITE(IUHAM,REC=IREC)
     &((HMAT(IDIM1+NTBAS*(ISPIN1-1),IDIM+NTBAS*(ISPIN-1)),
     &IDIM1=1,NTBAS),IDIM=1,NTBAS),
     &((OMAT(IDIM1+NTBAS*(ISPIN1-1),IDIM+NTBAS*(ISPIN-1)),
     &IDIM1=1,NTBAS),IDIM=1,NTBAS)
	ENDDO
	ENDDO
	ENDIF
C GENERALIZED EIGENVALUE PROBLEM
      CALL LIB_EIGEN1C(NTBAS*NSPIN,HMAT,OMAT,E,NSPIN,NORBS,1,
     &     IERR,1,1.D-07)
C EIGENVALUES
      DO IBNDS=1,NSPIN
      DO IBNDT=1,NTBAS
      IBAND=IBNDS+NSPIN*(IBNDT-1)
      IF(IENW.EQ.0)EARR(IBAND,IPNT,1)=E(IBAND)
      IF(IENW.EQ.1)EARW(IBAND,IPNT,1)=E(IBAND)
      IF(NPNT(1).EQ.NPNW(1))
     &EARW(IBAND,IPNT,1)=EARR(IBAND,IPNT,1)
      ENDDO
      ENDDO
	IF(IENW.EQ.1)GOTO1000
C Coefficients for correlated states
      IF(IDMF.GT.2)THEN
	DO IORBS=1,NORBS            !!! over spinor components
	DO IBNDS=1,NSPIN            !!! over spin subbands
	IF(NORBS.EQ.1)ISPIN=IBNDS
	IF(NORBS.EQ.2)ISPIN=IORBS
	DO IBNDT=1,NBNDT(1)         !!! over bands
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	ICLM=0
	DO IATOM=1,NATOM            !!! over atoms
	ISORT=IS(IATOM)
	IF(MCRL(IATOM).EQ.0)CYCLE
	DO L=0,ILSB(ISORT)          !!! over l
	IF(.NOT.LTBAS(L,IATOM))CYCLE
	IF(LCRL(L,IATOM).EQ.0)CYCLE
	DO M=-L,L
	LM=L*(L+1)+M+1
      IDIM=INBAS(LM,IATOM)+NTBAS*(ISPIN-1)
	ICLM=ICLM+1
	CR(ICLM,ISPIN,IBAND)=OMAT(IDIM,IBAND)
      ENDDO                       !!! over m
      ENDDO                       !!! over l
      ENDDO                       !!! over iatom
      ENDDO                       !!! over bands
      ENDDO                       !!! over spin subbands
      ENDDO                       !!! over spinor components
      ENDIF
      IREC=IPNT
      IF(NORBS.EQ.1)
     &WRITE(IUPSI,REC=IREC)
     &(((OMAT(IDIM+NTBAS*(IBNDS-1),IBNDS+NSPIN*(IBNDT-1)),
     &IDIM=1,NTBAS),IBNDS=1,NSPIN),IBNDT=NBNDE(1),NBNDF(1))
      IF(NORBS.EQ.2)
     &WRITE(IUPSI,REC=IREC)
     &((((OMAT(IDIM+NTBAS*(IORBS-1),IBNDS+NSPIN*(IBNDT-1)),
     &IDIM=1,NTBAS),IORBS=1,NORBS),IBNDS=1,NSPIN),
     &IBNDT=NBNDE(1),NBNDF(1))
      IF(ICPSK.GT.0.OR.ICCHI.GT.0.OR.ICOPT.GT.0)THEN ! store all bands
      IREC=IPNT
      IF(NORBS.EQ.1)
     &WRITE(IUPSK,REC=IREC)
     &(((OMAT(IDIM+NTBAS*(IBNDS-1),IBNDS+NSPIN*(IBNDT-1)),
     &IDIM=1,NTBAS),IBNDS=1,NSPIN),IBNDT=1,NBNDT(1))
      IF(NORBS.EQ.2)
     &WRITE(IUPSK,REC=IREC)
     &((((OMAT(IDIM+NTBAS*(IORBS-1),IBNDS+NSPIN*(IBNDT-1)),
     &IDIM=1,NTBAS),IORBS=1,NORBS),IBNDS=1,NSPIN),
     &IBNDT=1,NBNDT(1))
      ENDIF     
	IF(IDMF.GT.2)THEN
	IREC=IPNT
	IF(NORBS.EQ.1)
     &WRITE(IUWFK,REC=IREC)
     &((( CR(ICLM,IBNDS,IBNDS+NSPIN*(IBNDT-1)),ICLM=1,NCLM),
     &    IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)),
     &((( CR(ICLM,IBNDS,IBNDS+NSPIN*(IBNDT-1)),ICLM=1,NCLM),
     &    IBNDS=1,NSPIN),IBNDT=1,NBNDT(1))
	IF(NORBS.EQ.2)
     &WRITE(IUWFK,REC=IREC)
     &((((CR(ICLM,IORBS,IBNDS+NSPIN*(IBNDT-1)),ICLM=1,NCLM),
     &    IORBS=1,NORBS),IBNDS=1,NSPIN),IBNDT=1,NBNDT(1)),
     &((((CR(ICLM,IORBS,IBNDS+NSPIN*(IBNDT-1)),ICLM=1,NCLM),
     &    IORBS=1,NORBS),IBNDS=1,NSPIN),IBNDT=1,NBNDT(1))
	ENDIF


c---------- Output statements added by Gunnar 6.23.2000  ----------

	open(fh_idx,file="idx.dat",status='unknown')
	
	write(fh_idx,'("##### Number of atoms and sorts #####")')
	write(fh_idx,'(2i3)') natom,nsort
	write(fh_idx,'("##### Atom to sort index and max L #####")')
	do iatom = 1,natom
	   isort = is(iatom)
	   write(fh_idx,'(3i3)') iatom,isort,ilsb(isort)
	enddo
	write(fh_idx,'("##### Orbital presence array #####")')
	write(fh_idx,'("##### Atom #, l and is there #####")')
	do iatom = 1,natom
	   isort = is(iatom)
	   do l = 0,ilsb(isort)
	      write(fh_idx,'(2i3,l2)') iatom,l,ltpan(l,iatom,1,1)
	   enddo
	enddo
	write(fh_idx,'("##### Hamiltonian index array #####")')
	write(fh_idx,'("##### Atom, l, m and index    #####")')
	do iatom = 1,natom
	   isort = is(iatom)
	   do l = 0,ilsb(isort)
	      do m = -l,l
		 lm = l*(l+1)+m+1
		 write(fh_idx,'(4i4)') iatom,l,m,indlmt(lm,iatom,1,1,1)
	      enddo
	   enddo
	enddo

	close(fh_idx)

c---------- End of output statements added by Gunnar ----------

	
C MEMORY DEALLOCATIONS
 1000 DEALLOCATE(E,CR)
	IF(IENW.EQ.1)THEN
	SIZE_MAT=2.D0*DBLE(SIZE(OMAT)*LENCMP)/1024.D0**2
	DEALLOCATE(HMAT,OMAT)
      CURMEM=CURMEM-SIZE_MAT
	ENDIF
	END
