	SUBROUTINE FTB_FTBMFT
****************************************************************
*   Control module for package of programs solved generalized  *
*   eigenvalue problem for tight-binding method.               *
****************************************************************
C SET EXTERNAL CONNECTIONS
      USE COM_CONTROL ,ONLY: LIFT,LMTO,IASA,IDMF,NPFR               !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN                      !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP                              !!! from readini
      USE COM_KMESH   ,ONLY: NPNT,PNT                               !!! from tetra
      USE COM_WMESH   ,ONLY: NPNW,PNW                               !!! from tetra
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC                !!! from readini
      USE COM_FERMI   ,ONLY: EF,ZFIL                                !!! from ttrints
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT                            !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	DIMENSION VEL(3),SPTOS(2),SPDOS(2),SPVEL(3,2)
     &    ,VELM(3,3),SPVELM(3,3,2)
	DATA PI/3.141592653589793D0/
C COMPUTE EIGENVALUES AND EIGENVECTORS
	CALL FTB_ALLOCATE('A')
	CALL FTB_NULDEN                          !!! set density matrix to zero
	CALL FTB_FTBPAR                          !!! open scratch files
	CALL PRINTHM(IUN)                        !!! print hopping matrix
C PREPARE BANDS FOR WEIGHTS
      IF(NPNW(1).GT.NPNT(1))THEN
      DO IPNW=1,NPNW(1)                        !!! over k-points
      CALL FTB_FTBSTR(IPNW,1)                  !!! prepare Hamiltonian
      CALL FTB_FTBHUB(IPNW,1)                  !!! add Hubbard potential
      CALL FTB_FTBBND(IPNW,1)                  !!! solve eigenvalue problem
      ENDDO                                    !!! over k-points
      ENDIF
C COMPUTE BANDS AND WAVE FUNCTIONS
	DO IPNT=1,NPNT(1)                        !!! DO over k-points
	CALL FTB_FTBSTR(IPNT,0)                  !!! prepare Hamiltonian
	CALL FTB_FTBHUB(IPNT,0)                  !!! add Hubbard potential
	CALL FTB_FTBBND(IPNT,0)                  !!! solve eigenvalue problem
 	CALL FTB_FTBFAT(IPNT,0)                  !!! prepare fat bands
	CALL FTB_DENMAT(IPNT,0)                  !!! built density matrix
      ENDDO                                    !!! ENDDO over k-points
	CALL FTB_ALLOCATE('D')
C Store Data
	IF(IDMF.GT.2)RETURN
	CALL BND_SETFAT                          !!! store fat bands
	CALL BND_SETDOS                          !!! store density of states
	CALL BND_SETFRS                          !!! store fermi surface
	IF(LIFT.LE.2)RETURN
C COMPUTE FERMI LEVEL
      CALL BND_INSUL(EF,ZFIL)                  !!! recognize insulating case
      CALL BND_FNDFRM(EF,ZFIL,EF,100,1.D-09,0.8D0)! search for Fermi energy
      CALL TTR_TTRVEL(EF,DOS,VEL,SPTOS,SPDOS,SPVEL,VELM,SPVELM,0)
	CALL BND_LRCHI(EF,MBNDF,MBNDE,MBNDC)
C INTEGRATE DENSITY MATRIX FOR THE FERMI SURFACE STATES
	CALL FTB_ALLOCATE('A')
	DO IPNT=1,NPNT(1)
	CALL FTB_DENMAT(IPNT,1)
	ENDDO
	CALL FTB_ALLOCATE('D')
C SYMMETRIZE DENSITY MATRIX
      CALL FTB_SYMDEN                              !!! symmetrize density matrix
	END
