	SUBROUTINE FTB_FTBPAR
*********************************************************
*  Prints potential parameters.                         *
*********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_CONTROL ,ONLY: LIFT,LMTO,IASA,NPFR,IDMF              !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS,ILST,ILSB
     &                      ,LRTV,NHSORT                           !!! from readini
      USE COM_LATPAR  ,ONLY: PAR,OMEGAC                            !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP,EK                     !!! from readini
      USE COM_TBBPAR  ,ONLY: LTBAS,LSBAS,INBAS,NTBAS               !!! from readhop
      USE COM_INPTTR  ,ONLY: NDIV,NDIC,NDIVDIR,NDIR,PNTNOT         !!! from readini
      USE COM_HUBDAT  ,ONLY: NHUB,MCRL,LCRL,NCLM                   !!! from readhub
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDC,NBNDT,NBNDH         !!! from readini
     &                      ,MBNDF,MBNDE,MBNDC                     !!! from bzint
      USE COM_KMESH   ,ONLY: NPNT,PNT                              !!! from makettr
      USE COM_FERMI   ,ONLY: EF                                    !!! from ttrints
      USE COM_LMTOUT  ,ONLY: ICPSI,PSIFILE,ICFAT,FATFILE           !!! from readini
     &                      ,ICDOS,DOSFILE,ICODF,ODFFILE
     &                      ,ICPSK,PSKFILE,ICCHI,ICOPT,SCRFILE
      USE COM_CHANNELS,ONLY: IUPSI,IUPSK,IUDOS,IUHAM,IUWFK         !!! from setup
      USE COM_LABELS  ,ONLY: TXTAT,TXTEL,TXTSP                     !!! from readini
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT                           !!! from setup
      USE COM_MASHDEP ,ONLY: NVAL                                  !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	LOGICAL LOG,FIRST,EXIST,OPEN
	SAVE FIRST
	DATA PI/3.141592653589793D0/,FIRST/.TRUE./
      CALL ABORTNOW()
C RETURN KEYS
C       none
C REDEFINE # OF BANDS 
	IF(MBNDF.NE.-1.AND.MBNDE.NE.-1.AND.MBNDC.NE.-1)THEN
	NBNDF(1)=MBNDF
	NBNDE(1)=MBNDE
	NBNDC(1)=MBNDC
	ENDIF
C **************************************************************
C OPEN FILE FOR WAVE COEFFICIENTS
	NRECLPSI=NVAL*NTBAS*(NBNDF(1)-NBNDE(1)+1)*NSPIN*NORBS
	IF(ICPSI.EQ.0)THEN ! storage is not necessary
	INQUIRE(FILE=SCRFILE(IUPSI),EXIST=EXIST,OPENED=OPEN)
	IF(.NOT.OPEN.AND.EXIST)
     &OPEN(UNIT=IUPSI,FILE=SCRFILE(IUPSI),STATUS='OLD',
     &ACCESS='DIRECT',FORM='UNFORMATTED',RECL=NRECLPSI)
	IF(EXIST)CLOSE(UNIT=IUPSI,STATUS='DELETE')
	OPEN(UNIT=IUPSI,FILE=SCRFILE(IUPSI),STATUS='NEW',
     &ACCESS='DIRECT',FORM='UNFORMATTED',RECL=NRECLPSI)
	ELSEIF(ICPSI.NE.0)THEN
	INQUIRE(FILE=SCRFILE(IUPSI),EXIST=EXIST,OPENED=OPEN)
	IF(.NOT.OPEN.AND.EXIST)
     &OPEN(UNIT=IUPSI,FILE=PSIFILE,STATUS='OLD',
     &ACCESS='DIRECT',FORM='UNFORMATTED',RECL=NRECLPSI)
	IF(EXIST)CLOSE(UNIT=IUPSI,STATUS='DELETE')
	OPEN(UNIT=IUPSI,FILE=PSIFILE,STATUS='NEW',
     &ACCESS='DIRECT',FORM='UNFORMATTED',RECL=NRECLPSI)
	ENDIF
C **************************************************************
C OPEN FILE FOR WAVE COEFFICIENTS
	NRECLPSK=NVAL*NTBAS*(NBNDT(1)+NBNDH(1))*NSPIN*NORBS
	IF((ICPSK.EQ.1.OR.ICCHI.EQ.1.OR.ICOPT.EQ.1))THEN
	INQUIRE(FILE=SCRFILE(IUPSK),EXIST=EXIST,OPENED=OPEN)
	IF(.NOT.OPEN.AND.EXIST)
     &OPEN(UNIT=IUPSK,FILE=SCRFILE(IUPSK),STATUS='OLD',ACCESS='DIRECT',
     &FORM='UNFORMATTED',RECL=NRECLPSK)
	IF(EXIST)CLOSE(UNIT=IUPSK,STATUS='DELETE')
	OPEN(UNIT=IUPSK,FILE=SCRFILE(IUPSK),STATUS='NEW',ACCESS='DIRECT',
     &FORM='UNFORMATTED',RECL=NRECLPSK)
	ELSEIF(ICPSK.EQ.2)THEN
	INQUIRE(FILE=PSKFILE,EXIST=EXIST,OPENED=OPEN)
	IF(.NOT.OPEN.AND.EXIST)
     &OPEN(UNIT=IUPSK,FILE=PSKFILE,STATUS='OLD',ACCESS='DIRECT',
     &FORM='UNFORMATTED',RECL=NRECLPSK)
	IF(EXIST)CLOSE(UNIT=IUPSK,STATUS='DELETE')
	OPEN(UNIT=IUPSK,FILE=PSKFILE,STATUS='NEW',ACCESS='DIRECT',
     &FORM='UNFORMATTED',RECL=NRECLPSK)
	ENDIF
C **************************************************************
C OPEN FILE FOR TLM-CHARACTERS
	IF(ICFAT.GT.0.OR.ICDOS.GT.0)THEN
	INQUIRE(FILE=SCRFILE(IUDOS),EXIST=EXIST,OPENED=OPEN)
	IF(.NOT.OPEN.AND.EXIST)
     &OPEN(UNIT=IUDOS,FILE=SCRFILE(IUDOS),STATUS='OLD',
     &ACCESS='SEQUENTIAL',FORM='UNFORMATTED')
	IF(EXIST)CLOSE(UNIT=IUDOS,STATUS='DELETE')
	OPEN(UNIT=IUDOS,FILE=SCRFILE(IUDOS),STATUS='NEW',
     &ACCESS='SEQUENTIAL',FORM='UNFORMATTED')
      ENDIF
C **************************************************************
C OPEN FILE FOR STORING HAMILTONIAN
	IF(IDMF.GT.2)THEN
	NRECL=NVAL*2*NTBAS*NTBAS
	INQUIRE(FILE=SCRFILE(IUHAM),EXIST=EXIST,OPENED=OPEN)
	IF(.NOT.OPEN.AND.EXIST)
     &OPEN(UNIT=IUHAM,FILE=SCRFILE(IUHAM),STATUS='OLD',ACCESS='DIRECT',
     &FORM='UNFORMATTED',RECL=NRECL)
	IF(EXIST)CLOSE(UNIT=IUHAM,STATUS='DELETE')
	OPEN(UNIT=IUHAM,FILE=SCRFILE(IUHAM),STATUS='NEW',ACCESS='DIRECT',
     &FORM='UNFORMATTED',RECL=NRECL)
      ENDIF
C **************************************************************
C OPEN FILE FOR STORING EIGENVECTORS FOR CORRELATED STATES
	IF(IDMF.GT.2)THEN
	IF(NCLM.EQ.0)
     &CALL FULLSTOP('<BND_BNDPAR> :: Correlated subset not defined')
	NRECLWFK=2*NVAL*NCLM*NORBS*NBNDT(1)*NSPIN
	INQUIRE(FILE=SCRFILE(IUWFK),EXIST=EXIST,OPENED=OPEN)
	IF(.NOT.OPEN.AND.EXIST)
     &OPEN(UNIT=IUWFK,FILE=SCRFILE(IUWFK),STATUS='OLD',ACCESS='DIRECT',
     &FORM='UNFORMATTED',RECL=NRECLWFK)
	IF(EXIST)CLOSE(UNIT=IUWFK,STATUS='DELETE')
	OPEN(UNIT=IUWFK,FILE=SCRFILE(IUWFK),STATUS='NEW',ACCESS='DIRECT',
     &FORM='UNFORMATTED',RECL=NRECLWFK)
      ENDIF
	FIRST=.FALSE.
	END
