	SUBROUTINE FTB_FTBSTR(IPNT,IENW)
*********************************************************
*  Subroutine prepares hamiltonian matrix and overlap   *
*  matrix from real-space form for given k-point.       *
*********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                          !!! from setup
      USE COM_LATTICE ,ONLY: RBAS,GBAS,TAU                    !!! from readstr
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS,ILSB  !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP                   !!! from readini
      USE COM_TBBPAR  ,ONLY: LTBAS,LSBAS,INBAS,NTBAS          !!! from readhop
      USE COM_ENVSITE ,ONLY: NENV,TENV,ISENV                  !!! from envmesh
      USE COM_LMTMAT  ,ONLY: HMAT,OMAT                        !!! from lmtmat
      USE COM_HOPCOM  ,ONLY: TMAT,SMAT                        !!! from readhop
      USE COM_INPTTR  ,ONLY: NDIV,NDIC,SH                     !!! from readini
      USE COM_KMESH   ,ONLY: NPNT,PNT                         !!! from tetra
      USE COM_WMESH   ,ONLY: NPNW,PNW                         !!! from tetra
      USE COM_MASHDEP ,ONLY: LENCMP                           !!! from setup
      USE COM_UNIT    ,ONLY: IUN,IUT                          !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16 EXPKR,HS,OS
	LOGICAL LOG
	DATA PI/3.141592653589793D0/
      CALL ABORTNOW()
C MEMORY ALLOCATIONS
C K-POINT
	IF(IENW.EQ.0)THEN
	XK=PNT(1,IPNT,1)+SH(1,1)
	YK=PNT(2,IPNT,1)+SH(2,1)
	ZK=PNT(3,IPNT,1)+SH(3,1)
	ELSE
	XK=PNW(1,IPNT,1)+SH(1,1)
	YK=PNW(2,IPNT,1)+SH(2,1)
	ZK=PNW(3,IPNT,1)+SH(3,1)
	ENDIF
C START CODE
	DO IDIM1=1,NTBAS*NSPIN
	DO IDIM=1,NTBAS*NSPIN
	HMAT(IDIM1,IDIM)=(0.D0,0.D0)
	OMAT(IDIM1,IDIM)=(0.D0,0.D0)
	ENDDO
	ENDDO
C CALCULATE HAMILTONIAN AND OVERLAP MATRICES IN K-SPACE
      DO 2000 IORBS=1,NORBS
      DO 1000 IUPDN=1,NSPIN
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
	DO IATOM1=1,NATOM                   !!! over iatom1
	ISORT1=IS(IATOM1)
	DO L1=0,ILSB(ISORT1)                !!! over l1
	DO M1=-L1,L1                        !!! over m1
	IF(.NOT.LTBAS(L1,IATOM1))EXIT
	L1M1=L1*(L1+1)+M1+1
	IDIM1=INBAS(L1M1,IATOM1)+NTBAS*(ISPIN1-1)
C  DO OVER CLUSTER SITES
	DO IENV=0,NENV(IATOM1)              !!! over ienv
	IATOM=ISENV(IENV,IATOM1) 
	ISORT=IS(IATOM)
	RX=TENV(1,IENV,IATOM1)+(TAU(1,IATOM1)-TAU(1,IATOM))
	RY=TENV(2,IENV,IATOM1)+(TAU(2,IATOM1)-TAU(2,IATOM))
	RZ=TENV(3,IENV,IATOM1)+(TAU(3,IATOM1)-TAU(3,IATOM))
	SCP=XK*RX+YK*RY+ZK*RZ
	EXPKR=EXP((0.D0,+1.D0)*SCP*2.D0*PI) 
	DO L=0,ILSB(ISORT)                  !!! over l
	DO M=-L,L                           !!! over m
	IF(.NOT.LTBAS(L,IATOM))EXIT
	LM=L*(L+1)+M+1
	IDIM=INBAS(LM,IATOM)+NTBAS*(ISPIN-1)
	HMAT(IDIM1,IDIM)=HMAT(IDIM1,IDIM)+
     &  TMAT(L1M1,LM,IATOM1,IENV,IUPDN,IORBS)*EXPKR
	OMAT(IDIM1,IDIM)=OMAT(IDIM1,IDIM)+
     &  SMAT(L1M1,LM,IATOM1,IENV,IUPDN,IORBS)*EXPKR
      ENDDO                               !!! over m
      ENDDO                               !!! over l
      ENDDO                               !!! over ienv
      ENDDO                               !!! over m1
      ENDDO                               !!! over l1
      ENDDO                               !!! over iatom1
1000	CONTINUE                            !!! over spins
2000	CONTINUE                            !!! over iorbs
	END
