	SUBROUTINE FINDIRR(ICUB,RAXIS,RANGL,RINVS,IPRINT,ITASK)
*******************************************************
*  Prepares hopping matrix from the knowledge of the  *
*  hopping integrals read from HOPFILE.               *
*  Also sets overlap matrix if required.              *
*  iTask = 1   builds HOPPING matrix                  *
*  iTask = 2   builds HINF array                      *
*******************************************************
C SET ARRAY-SIZE DATA
	USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
	USE COM_LMTMEM                                         !!! from setup
	USE COM_PARAM  ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS,ILSB  !!! from readini
	USE COM_LATPAR ,ONLY: PAR,ORTH,OMEGAC                  !!! from readini
	USE COM_PANPAR ,ONLY: LTPAN,LSPAN                      !!! from readini
	USE COM_LATTICE,ONLY: RBAS,GBAS,TAU                    !!! from readstr
	USE COM_INPPAR ,ONLY: ENY,DNY,NODES                    !!! from readini
	USE COM_ENVSITE,ONLY: NENV,TENV,ISENV,IPENV,IRENV      !!! from envmesh
	USE COM_HOPCOM ,ONLY: TMAT,SMAT                        !!! from readhop
	USE COM_HOPDAT ,ONLY: NINF,HINF,NHOP,HIND              !!! from readhop
	USE COM_TBBPAR ,ONLY: LTBAS,LSBAS,INBAS,NTBAS          !!! from readhop
	USE COM_GROUPS ,ONLY: NGROUP,U,IP,RDC,SHIFT,INV,IKOV   !!! from groups
	USE COM_LABELS ,ONLY: TXTEL,TXTSP,TXTAT                !!! from readini
	USE COM_UNIT   ,ONLY: IUN,IUR,IUT                      !!! from setup
	USE COM_MASHDEP,ONLY: LENCMP                           !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER, INTRINSIC :: SIZE
	INTEGER, ALLOCATABLE :: IRE(:,:,:,:)
	INTEGER, ALLOCATABLE :: IRH(:,:,:,:)
	INTEGER, ALLOCATABLE :: IHI(:,:)
	INTEGER, ALLOCATABLE :: IRI(:,:)
	COMPLEX*16, ALLOCATABLE :: THOP(:,:)
	COMPLEX*16, ALLOCATABLE :: SHOP(:,:)
	COMPLEX*16, ALLOCATABLE :: RMAT(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: AIRR(:,:)
	COMPLEX*16, ALLOCATABLE :: BIRR(:,:,:)
	COMPLEX*16, ALLOCATABLE :: CIRR(:)
	COMPLEX*16, ALLOCATABLE :: DIRR(:,:)
	COMPLEX*16, ALLOCATABLE :: BINV(:,:)
	COMPLEX*16, ALLOCATABLE :: WORK(:)
	COMPLEX*16, ALLOCATABLE :: UWIGL(:,:)
	COMPLEX*16, ALLOCATABLE :: UWIGR(:,:)
	COMPLEX*16, ALLOCATABLE :: UROTL(:,:)
	COMPLEX*16, ALLOCATABLE :: UROTR(:,:)
	COMPLEX*16, ALLOCATABLE :: ULOCL(:,:)
	COMPLEX*16, ALLOCATABLE :: ULOCR(:,:)
	DIMENSION RAXIS(3,0:LMAXBMEM,NATOMMEM)
     &    ,RANGL(0:LMAXBMEM,NATOMMEM),RINVS(0:LMAXBMEM,NATOMMEM)
	COMPLEX*16 TC(-3:3,7,0:3),TS(7,-3:3,0:3),SCP,SCA,SCL
	CHARACTER TCUBC(-3:3,0:3,2)*10
	DATA PI/3.141592653589793D0/
C MEMORY ALLOCATIONS
	ALLOCATE(IRE(0:LMAXBMEM,0:LMAXBMEM,NATOMMEM,0:NENVMEM))
	ALLOCATE(IRH(LIMBMEM,LIMBMEM,NATOMMEM,0:NENVMEM))
	ALLOCATE(IHI(-LMAXBMEM:LMAXBMEM,-LMAXBMEM:LMAXBMEM))
	ALLOCATE(IRI(-LMAXBMEM:LMAXBMEM,-LMAXBMEM:LMAXBMEM))
	ALLOCATE(THOP(-LMAXBMEM:LMAXBMEM,-LMAXBMEM:LMAXBMEM))
	ALLOCATE(SHOP(-LMAXBMEM:LMAXBMEM,-LMAXBMEM:LMAXBMEM))
	ALLOCATE(RMAT(-LMAXBMEM:LMAXBMEM,-LMAXBMEM:LMAXBMEM,
     &              -LMAXBMEM:LMAXBMEM,-LMAXBMEM:LMAXBMEM))
	ALLOCATE(AIRR(-LMAXBMEM:LMAXBMEM,-LMAXBMEM:LMAXBMEM))
	ALLOCATE(BIRR(-LMAXBMEM:LMAXBMEM,-LMAXBMEM:LMAXBMEM,
     &             (2*LMAXBMEM+1)**2))
	ALLOCATE(CIRR((2*LMAXBMEM+1)**2))
	ALLOCATE(DIRR((2*LMAXBMEM+1)**2,(2*LMAXBMEM+1)**2))
	ALLOCATE(BINV((2*LMAXBMEM+1)**2,(2*LMAXBMEM+1)**2))
	ALLOCATE(WORK((2*LMAXBMEM+1)**2))
	ALLOCATE(UWIGL(LIMB2MEM,NGROUP))
	ALLOCATE(UWIGR(LIMB2MEM,NGROUP))
	ALLOCATE(UROTL(LIMB2MEM,2))
	ALLOCATE(UROTR(LIMB2MEM,2))
	ALLOCATE(ULOCL(LIMB2MEM,2))
	ALLOCATE(ULOCR(LIMB2MEM,2))
C CUBIC HARMONICS
	CALL LIB_TRANSS(TS)   ! built transformation matrices
	CALL LIB_TRANSC(TC)   ! built transformation matrices
	CALL LIB_INTCUBC(TCUBC)
C ZEROISE POINTER ARRAY
	DO IATOM1=1,NATOM                   !!! over iatom1
	ISORT1=IS(IATOM1)
	DO IENV=0,NENV(IATOM1)              !!! over ienv
	IATOM=ISENV(IENV,IATOM1)
	ISORT=IS(IATOM)
 	DO L1=0,ILSB(ISORT1)                !!! over l1
	DO M1=-L1,L1                        !!! over m1
	L1M1=L1*(L1+1)+M1+1
	DO L=0,ILSB(ISORT)                  !!! over l
	DO M=-L,L                           !!! over m
	LM=L*(L+1)+M+1
	IRE(L1  ,L ,IATOM1,IENV)=-999
	IRH(L1M1,LM,IATOM1,IENV)=-999
	ENDDO                               !!! over m
	ENDDO                               !!! over l
	ENDDO                               !!! over m1
	ENDDO                               !!! over l1
	ENDDO                               !!! over ienv
	ENDDO                               !!! over iatom1
C *********************************************************
C DEFINE WHICH SUBBLOCKS ARE IN USE
C *********************************************************
	IF(ITASK.EQ.1)THEN
	IHOP=0
	DO IATOM1=1,NATOM                   !!! over iatom1
	ISORT1=IS(IATOM1)
	DO IENV=0,NENV(IATOM1)              !!! over ienv
	IATOM=ISENV(IENV,IATOM1)
	ISORT=IS(IATOM)
	DO L1=0,ILSB(ISORT1)                !!! over l1
	DO L=0,ILSB(ISORT)                  !!! over l
	IN=0
	DO INF=1,NINF
	READ(HINF(INF),*)IATOM1R,NM1R,L1R,M1R,IATOMR,NMR,
     &LR,MR,IENVR,IENV1R
	IF(IATOM1R.EQ.IATOM1.AND.IATOMR.EQ.IATOM.AND.
     &L1R.EQ.L1.AND.LR.EQ.L.AND.IENVR.EQ.IENV)IN=IN+1
	IF(IN.GT.0)EXIT
	ENDDO
	IF(IN.NE.0.AND..NOT.LTBAS(L1,IATOM1))
     &CALL FULLSTOP('<FindIRR> L does not belong to the basis.')
	IF(IN.NE.0.AND..NOT.LTBAS(L ,IATOM ))
     &CALL FULLSTOP('<FindIRR> L does not belong to the basis.')
	IF(IN.NE.0)IHOP=IHOP+1
	IF(IN.NE.0)WRITE(HIND(IHOP),1070)L1,L,IATOM1,IENV
	ENDDO                               !!! over l
	ENDDO                               !!! over l1
	ENDDO                               !!! over ienv
	ENDDO                               !!! over iatom1
	NHOP=IHOP
	ELSEIF(ITASK.EQ.2)THEN
	IHOP=0
	INF=0
	DO IATOM1=1,NATOM                   !!! over iatom1
	ISORT1=IS(IATOM1)
	DO IENV=0,NENV(IATOM1)              !!! over ienv
	IATOM=ISENV(IENV,IATOM1)
	ISORT=IS(IATOM)
	DO L1=0,ILSB(ISORT1)                !!! over l1
	IF(.NOT.LTBAS(L1,IATOM1))CYCLE
	DO L=0,ILSB(ISORT)                  !!! over l
	IF(.NOT.LTBAS(L ,IATOM ))CYCLE
	IF(IRENV(IENV,IATOM1).NE.1)CYCLE
	IF(IRE(L1,L,IATOM1,IENV).NE.-999)CYCLE
C Check pointers
	IRE(L1,L,IATOM1,IENV)=1
	DO IR=1,NGROUP                      !!! over group
	IG=IKOV(IR)
	IATOM1G=IP(IATOM1,IR)
	IENVG=IPENV(IENV,IATOM1,IR)
	IATOMG=ISENV(IENVG,IATOM1G)
C Set complex conjugate:
	DO IE=0,NENV(IATOMG)
	DIFF=(TENV(1,IENVG,IATOM1G)+TENV(1,IE,IATOMG))**2
     &    +(TENV(2,IENVG,IATOM1G)+TENV(2,IE,IATOMG))**2
     &    +(TENV(3,IENVG,IATOM1G)+TENV(3,IE,IATOMG))**2
	IF(DIFF.LE.1.D-10)EXIT
	ENDDO
	IF(IE.EQ.NENV(IATOMG)+1)
     &  CALL FULLSTOP('<FINDIRR> WRONG CONJUGATION')
	IENV1G=IE
	IRE(L1,L,IATOM1G,IENVG)=1  ! rotated
	IRE(L,L1,IATOMG,IENV1G)=1  ! conjugated
	ENDDO                               !!! over group
C Set orbitals:
	IHOP=IHOP+1
	WRITE(HIND(IHOP),1070)L1,L,IATOM1,IENV
	ENDDO                               !!! over l
	ENDDO                               !!! over l1
	ENDDO                               !!! over ienv
	ENDDO                               !!! over iatom1
	NHOP=IHOP
	NINF=0
	ENDIF
C *********************************************************
C DEFINE ELEMENTS WHICH ARE ZEROES
C *********************************************************
	DO 1000 IHOP=1,NHOP                 !!! over subblocks
	READ(HIND(IHOP),*)L1,L,IATOM1,IENV
	ISORT1=IS(IATOM1)
	IATOM=ISENV(IENV,IATOM1)
	ISORT=IS(IATOM)
C Get rotational matrices
	CALL LIB_TRANSU(L1,RAXIS(1,L1,IATOM1),RANGL(L1,IATOM1),
     &  RINVS(L1,IATOM1),UROTL(1,1),LIMB2MEM)
	CALL LIB_CONJGU(L1,UROTL(1,1),UROTL(1,2),LIMB2MEM)
	CALL LIB_TRANSU(L ,RAXIS(1,L ,IATOM ),RANGL(L ,IATOM ),
     &  RINVS(L ,IATOM ),UROTR(1,1),LIMB2MEM)
	CALL LIB_CONJGU(L ,UROTR(1,1),UROTR(1,2),LIMB2MEM)
	DO IR=1,NGROUP
	IG=IKOV(IR)
C Local coordinates
	IWIG1=L1*(2*L1-1)*(2*L1+1)/3+1
	CALL PRD(U(IWIG1,IG),UROTL(IWIG1,1),ULOCL(IWIG1,1),L1)
	CALL PRD(UROTL(IWIG1,2),ULOCL(IWIG1,1),ULOCL(IWIG1,2),L1)
	IWIG =L *(2*L -1)*(2*L +1)/3+1
	CALL PRD(U(IWIG ,IG),UROTR(IWIG ,1),ULOCR(IWIG ,1),L )
	CALL PRD(UROTR(IWIG ,2),ULOCR(IWIG ,1),ULOCR(IWIG ,2),L)
C Cubic Harmonics
	IF(ICUB.EQ.1)THEN
	CALL LIB_CUBWIG(ULOCL(1,2),UWIGL(1,IR),L1,TS)
	CALL LIB_CUBWIG(ULOCR(1,2),UWIGR(1,IR),L ,TS)
	ELSE
	DO M1=-L1,L1
	DO M=-L1,L1
	IWIG=L1*(2*L1-1)*(2*L1+1)/3+(2*L1+1)*(L1+M)+L1+M1+1 ! (l1 ,m1 m) packed
	UWIGL(IWIG,IR)=ULOCL(IWIG,2)
	ENDDO
	ENDDO
	DO M1=-L,L
	DO M=-L,L
	IWIG=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M1+1 ! (l1 ,m1 m) packed
	UWIGR(IWIG,IR)=ULOCR(IWIG,2)
	ENDDO
	ENDDO
	ENDIF
	ENDDO
C Start looping over subblock
	DO M1=-L1,L1                        !!! over m1
	L1M1=L1*(L1+1)+M1+1
	DO M=-L,L                           !!! over m
	LM=L*(L+1)+M+1
	IF(IRH(L1M1,LM,IATOM1,IENV).NE.-999)CYCLE
	DO M2=-L1,L1                        !!! over m2
	DO M3=-L,L                          !!! over m3
	THOP(M2,M3)=(0.D0,0.D0)
	ENDDO                               !!! over m2
	ENDDO                               !!! over m3
	DO IR=1,NGROUP                      !!! over point group
	IG=IKOV(IR)
	IATOM1G=IP(IATOM1,IR)
	IENVG=IPENV(IENV,IATOM1,IR)
	IATOMG=ISENV(IENVG,IATOM1G)
	IF(IATOM1G.NE.IATOM1)CYCLE
	IF(IENVG.NE.IENV)CYCLE
	DO M2=-L1,L1                        !!! over m2
	L1M2=L1*(L1+1)+M2+1
	IWIG21=L1*(2*L1-1)*(2*L1+1)/3+(2*L1+1)*(L1+M1)+L1+M2+1
	DO M3=-L,L                          !!! over m3
	LM3=L*(L+1)+M3+1
	IWIG30=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M3+1
	THOP(M2,M3)=THOP(M2,M3)+
     &CONJG(UWIGL(IWIG21,IR))*UWIGR(IWIG30,IR)
	ENDDO                               !!! over m2
	ENDDO                               !!! over m3
	ENDDO                               !!! over group
	S=0.D0
	DO M2=-L1,L1                        !!! over m2
	DO M3=-L,L                          !!! over m3
	S=S+ABS(THOP(M2,M3))
	ENDDO                               !!! over m2
	ENDDO                               !!! over m3
	IF(S.LE.1.D-05)THEN
	IRH(L1M1,LM,IATOM1,IENV)=0
	ENDIF
	ENDDO                               !!! over m
	ENDDO                               !!! over m1
1000	CONTINUE                            !!! over subblocks
C *********************************************************
C IRREDUCIBLE CONDITIONS
C *********************************************************
	DO 2000 IHOP=1,NHOP                 !!! over subblocks
	READ(HIND(IHOP),*)L1,L,IATOM1,IENV
	ISORT1=IS(IATOM1)
	IATOM=ISENV(IENV,IATOM1)
	ISORT=IS(IATOM)
C Get rotational matrices
	CALL LIB_TRANSU(L1,RAXIS(1,L1,IATOM1),RANGL(L1,IATOM1),
     &RINVS(L1,IATOM1),UROTL(1,1),LIMB2MEM)
	CALL LIB_CONJGU(L1,UROTL(1,1),UROTL(1,2),LIMB2MEM)
	CALL LIB_TRANSU(L ,RAXIS(1,L ,IATOM ),RANGL(L ,IATOM ),
     &RINVS(L ,IATOM ),UROTR(1,1),LIMB2MEM)
	CALL LIB_CONJGU(L ,UROTR(1,1),UROTR(1,2),LIMB2MEM)
	DO IR=1,NGROUP
	IG=IKOV(IR)
C Local coordinates
	IWIG1=L1*(2*L1-1)*(2*L1+1)/3+1
	CALL PRD(U(IWIG1,IG),UROTL(IWIG1,1),ULOCL(IWIG1,1),L1)
	CALL PRD(UROTL(IWIG1,2),ULOCL(IWIG1,1),ULOCL(IWIG1,2),L1)
	IWIG =L *(2*L -1)*(2*L +1)/3+1
	CALL PRD(U(IWIG ,IG),UROTR(IWIG ,1),ULOCR(IWIG ,1),L )
	CALL PRD(UROTR(IWIG ,2),ULOCR(IWIG ,1),ULOCR(IWIG ,2),L)
C Cubic Harmonics
	IF(ICUB.EQ.1)THEN
	CALL LIB_CUBWIG(ULOCL(1,2),UWIGL(1,IR),L1,TS)
	CALL LIB_CUBWIG(ULOCR(1,2),UWIGR(1,IR),L ,TS)
	ELSE
	DO M1=-L1,L1
	DO M=-L1,L1
	IWIG=L1*(2*L1-1)*(2*L1+1)/3+(2*L1+1)*(L1+M)+L1+M1+1 ! (l1 ,m1 m) packed
	UWIGL(IWIG,IR)=ULOCL(IWIG,2)
	ENDDO
	ENDDO
	DO M1=-L,L
	DO M=-L,L
	IWIG=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M1+1 ! (l1 ,m1 m) packed
	UWIGR(IWIG,IR)=ULOCR(IWIG,2)
	ENDDO
	ENDDO
	ENDIF
	ENDDO
C Start looping over subblock
	CALL FIND_LBLANK(TXTAT(ISORT1),10,NBL1)
	CALL FIND_LBLANK(TXTAT(ISORT),10,NBL)
	IF(IPRINT.EQ.1)
     &WRITE(IUN,1010)TXTAT(ISORT1)(1:NBL1)//'@',IATOM1
     &              ,TXTAT(ISORT)(1:NBL)//'@',IATOM
     &             ,(TENV(I,IENV,IATOM1),I=1,3)
	NRR=0
C Print 
	IF(IPRINT.EQ.1)WRITE(IUN,1020)L1,L
	IDIM=0
	DO M1=-L1,L1                        !!! over m1
	L1M1=L1*(L1+1)+M1+1
	DO M=-L,L                           !!! over m
	LM=L*(L+1)+M+1
	IF(IRH(L1M1,LM,IATOM1,IENV).EQ.0)CYCLE
	IDIM=IDIM+1
	IRH(L1M1,LM,IATOM1,IENV)=IDIM
	DO IR=1,NGROUP                      !!! over point group
	IG=IKOV(IR)
	IATOM1G=IP(IATOM1,IR)
	IENVG=IPENV(IENV,IATOM1,IR)
	IATOMG=ISENV(IENVG,IATOM1G)
	IF(IATOM1G.NE.IATOM1)CYCLE
	IF(IENVG.NE.IENV)CYCLE
	DO M2=-L1,L1                        !!! over m2
	L1M2=L1*(L1+1)+M2+1
	IWIG21=L1*(2*L1-1)*(2*L1+1)/3+(2*L1+1)*(L1+M1)+L1+M2+1
	DO M3=-L,L                          !!! over m3
	LM3=L*(L+1)+M3+1
	IWIG30=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M3+1
	AIRR(M2,M3)=CONJG(UWIGL(IWIG21,IR))*UWIGR(IWIG30,IR)
	IF(M1.EQ.M2.AND.M.EQ.M3)AIRR(M2,M3)=AIRR(M2,M3)-(1.D0,0.D0)
	IF(IRH(L1M2,LM3,IATOM1,IENV).EQ.0)AIRR(M2,M3)=(0.D0,0.D0)
	ENDDO                               !!! over m2
	ENDDO                               !!! over m3
	NZ=0
	SCL=(0.D0,0.D0)
	DO M2=-L1,L1                        !!! over m2
	DO M3=-L,L                          !!! over m3
	IF(ABS(AIRR(M2,M3)).GT.1.D-07)NZ=NZ+1
	SCL=SCL+AIRR(M2,M3)*AIRR(M2,M3)
	ENDDO                               !!! over m2
	ENDDO                               !!! over m3
	IF(NZ.LE.0)CYCLE
	IF(NRR.EQ.0)THEN ! First vector is coming
	NRR=NRR+1
	DO M2=-L1,L1                        !!! over m2
	DO M3=-L,L                          !!! over m3
	BIRR(M2,M3,NRR)=AIRR(M2,M3)/SQRT(SCL)
	ENDDO                               !!! over m2
	ENDDO                               !!! over m3
	CYCLE
	ENDIF
C New condition
	NRR=NRR+1
	DO M2=-L1,L1                        !!! over m2
	DO M3=-L,L                          !!! over m3
	BIRR(M2,M3,NRR)=AIRR(M2,M3)
	ENDDO                               !!! over m2
	ENDDO                               !!! over m3
C Orthogonalize to all previous
	DO IRR=1,NRR-1                      !!! over irr
	SCP=(0.D0,0.D0)
	SCA=(0.D0,0.D0)
	DO M2=-L1,L1                        !!! over m2
	DO M3=-L,L                          !!! over m3
	SCP=SCP+BIRR(M2,M3,IRR)*AIRR(M2,M3)
	SCA=SCA+BIRR(M2,M3,IRR)*BIRR(M2,M3,IRR)
	ENDDO                               !!! over m2
	ENDDO                               !!! over m3
	DO M2=-L1,L1                        !!! over m2
	DO M3=-L,L                          !!! over m3
	BIRR(M2,M3,NRR)=BIRR(M2,M3,NRR)-BIRR(M2,M3,IRR)*SCP/SCA
	ENDDO                               !!! over m2
	ENDDO                               !!! over m3
	ENDDO                               !!! over irr
C Check lenght
	SCL=(0.D0,0.D0)
	DO M2=-L1,L1                        !!! over m2
	DO M3=-L,L                          !!! over m3
	SCL=SCL+BIRR(M2,M3,NRR)*BIRR(M2,M3,NRR)
	ENDDO                               !!! over m2
	ENDDO                               !!! over m3
	IF(ABS(SCL).LT.1.D-10)NRR=NRR-1
	IF(ABS(SCL).LT.1.D-10)CYCLE
C Normalize
	DO M2=-L1,L1                        !!! over m2
	DO M3=-L,L                          !!! over m3
	BIRR(M2,M3,NRR)=BIRR(M2,M3,NRR)/SQRT(SCL)
	ENDDO                               !!! over m2
	ENDDO                               !!! over m3
C
	ENDDO                               !!! over group
	ENDDO                               !!! over m
	ENDDO                               !!! over m1
C All conditions found, its number is smaller then dimension
	NDIM=(2*L1+1)*(2*L+1)
	NZER=0
	DO M2=-L1,L1                        !!! over m2
	L1M2=L1*(L1+1)+M2+1
	DO M3=-L,L                          !!! over m3
	LM3=L*(L+1)+M3+1
	IF(IRH(L1M2,LM3,IATOM1,IENV).EQ.0)NZER=NZER+1
	ENDDO                               !!! over m2
	ENDDO                               !!! over m3
	NDIM=NDIM-NZER
	IF(NDIM.EQ.0)CYCLE ! all elements are equal zero
C Check orthogonality
	IF(NRR.GE.NDIM)THEN
	DO IRR=1,NRR                        !!!
	DO JRR=1,NRR
	SCP=(0.D0,0.D0)
      DO M2=-L1,L1                        !!! over m2
      L1M2=L1*(L1+1)+M2+1
      DO M3=-L,L                          !!! over m3
      LM3=L*(L+1)+M3+1
      IF(IRH(L1M2,LM3,IATOM1,IENV).EQ.0)CYCLE
	SCP=SCP+BIRR(M2,M3,IRR)*BIRR(M2,M3,JRR)
      ENDDO                               !!! over m2
      ENDDO                               !!! over m3
	WRITE(IUT,*)SCP,IRR,JRR
      ENDDO                               !!! over irr
      ENDDO                               !!! over jrr
	CALL FINDIRR_MESG01(2)
	ENDIF
C Print preliminary info
	IF(IPRINT.EQ.1)
     &WRITE(IUN,1030)(2*L1+1)*(2*L+1),NDIM,NRR,NDIM-NRR
C Fill up by vectors until dimension is reached
	DO JRR=NRR+1,NDIM                   !!! over jrr
	DO IRAND=1,10
C Set random vector
	DO M2=-L1,L1                        !!! over m2
	L1M2=L1*(L1+1)+M2+1
	DO M3=-L,L                          !!! over m3
	LM3=L*(L+1)+M3+1
	R=LOG(DBLE(ABS(25*M2+100+IRAND)))+COS(DBLE(M3+JRR))
	AIRR(M2,M3)=COS(R)+(0.D0,1.D0)*SIN(R*R)
	IF(IRH(L1M2,LM3,IATOM1,IENV).EQ.0)AIRR(M2,M3)=(0.D0,0.D0)
	ENDDO                               !!! over m2
	ENDDO                               !!! over m3
	DO M2=-L1,L1                        !!! over m2
	DO M3=-L,L                          !!! over m3
	BIRR(M2,M3,JRR)=AIRR(M2,M3)
	ENDDO                               !!! over m2
	ENDDO                               !!! over m3
C Orthogonalize to all previous
	DO IRR=1,JRR-1                      !!! over irr
	SCP=(0.D0,0.D0)
	SCA=(0.D0,0.D0)
	DO M2=-L1,L1                        !!! over m2
	DO M3=-L,L                          !!! over m3
	SCP=SCP+BIRR(M2,M3,IRR)*AIRR(M2,M3)
	SCA=SCA+BIRR(M2,M3,IRR)*BIRR(M2,M3,IRR)
	ENDDO                               !!! over m2
	ENDDO                               !!! over m3
	DO M2=-L1,L1                        !!! over m2
	DO M3=-L,L                          !!! over m3
	BIRR(M2,M3,JRR)=BIRR(M2,M3,JRR)-BIRR(M2,M3,IRR)*SCP/SCA
	ENDDO                               !!! over m2
	ENDDO                               !!! over m3
	ENDDO                               !!! over irr
C Check lenght
	SCL=(0.D0,0.D0)
	DO M2=-L1,L1                        !!! over m2
	DO M3=-L,L                          !!! over m3
	SCL=SCL+BIRR(M2,M3,JRR)*BIRR(M2,M3,JRR)
	ENDDO                               !!! over m2
	ENDDO                               !!! over m3
	IF(ABS(SCL).LT.1.D-10)CYCLE        !!! new random vector
C Normalize
	DO M2=-L1,L1                        !!! over m2
	DO M3=-L,L                          !!! over m3
	BIRR(M2,M3,JRR)=BIRR(M2,M3,JRR)/SQRT(SCL)
	ENDDO                               !!! over m2
	ENDDO                               !!! over m3
	EXIT
	ENDDO                               !!! over irandoms
	IF(IRAND.GT.1)THEN
	WRITE(IUN,*)'Warning from <FindIRR>::'
	WRITE(IUN,*)'Random vectors failure.'
	ENDIF
	IF(IRAND.EQ.101)CALL FINDIRR_MESG01(3)
	ENDDO                               !!! over jrr
C Now BIRR forms complete basis in M*M' space, invert it
	DO IRR=1,NDIM                       !!! over irr
	IDIM=0
	DO M2=-L1,L1                        !!! over m2
	L1M2=L1*(L1+1)+M2+1
	DO M3=-L,L                          !!! over m3
	LM3=L*(L+1)+M3+1
	IF(IRH(L1M2,LM3,IATOM1,IENV).EQ.0)CYCLE
	IDIM=IDIM+1
	BINV(IDIM,IRR)=BIRR(M2,M3,IRR)
	ENDDO                               !!! over m2
	ENDDO                               !!! over m3
	ENDDO                               !!! over irr
	CALL LIB_CINV(NDIM,BINV,(2*LMAXBMEM+1)**2,WORK,IFAIL)
	IF(IFAIL.NE.0)CALL FINDIRR_MESG01(4)
C It is a time to look at input information
	DO M1=-L1,L1
	DO M=-L,L
	IHI(M1,M)=0
	IRI(M1,M)=0
	ENDDO
	ENDDO
	DO INF=1,NINF
	READ(HINF(INF),1070)IATOM1R,NM1R,L1R,M1R,IATOMR,NMR,
     &LR,MR,IENVR,IENV1R,IUPDNR,IORBSR
	L1M1=L1R*(L1R+1)+M1R+1
	LM=LR*(LR+1)+MR+1
	IF(IATOM1R.EQ.IATOM1.AND.IATOMR.EQ.IATOM.AND.
     &L1R.EQ.L1.AND.LR.EQ.L.AND.IENVR.EQ.IENV.AND.
     &(ABS(TMAT(L1M1,LM,IATOM1,IENV,IUPDNR,IORBSR)).GT.1.D-10.OR.
     & ABS(SMAT(L1M1,LM,IATOM1,IENV,IUPDNR,IORBSR)).GT.1.D-10))
     &IHI(M1R,MR)=1
	EXIT
	ENDDO
C Check input information
	NR=0
	DO M1=-L1,L1                        !!! over m1
	L1M1=L1*(L1+1)+M1+1
	DO M=-L,L                           !!! over m
	LM=L*(L+1)+M+1
	IF(IRH(L1M1,LM,IATOM1,IENV).EQ.0.
     &AND.IHI(M1,M).NE.0)THEN
	IHI(M1,M)=0
	DO IORBS=1,NORBS
	DO IUPDN=1,NSPIN
	TMAT(L1M1,LM,IATOM1,IENV,IUPDN,IORBS)=(0.D0,0.D0)
	SMAT(L1M1,LM,IATOM1,IENV,IUPDN,IORBS)=(0.D0,0.D0)
	ENDDO
	ENDDO
	WRITE(IUT,*)'Warning from <FindIRR>::'
	WRITE(IUT,*)'Input hopping will be set to zero due to symmetry'
	WRITE(IUT,*)'iAtom,l1,l,m1,m ==',IATOM1,L1,L,M1,M
	ENDIF
	IF(IHI(M1,M).NE.0)NR=NR+1
	ENDDO
	ENDDO
	IF(NR.GT.NDIM-NRR)THEN
	WRITE(IUT,*)'Message from <FindIRR>::'
	WRITE(IUT,*)'Too many elements set in hoppings block:'
	WRITE(IUT,*)'iAtom,l1,l ==',IATOM1,L1,L,M1,M
	WRITE(IUT,*)'Some of them are linear dependent.'
	ENDIF
C Inverted matrix must tell us which elements will be irreducible
	IDIM=0
	NIRM=0
	DO M1=-L1,L1                        !!! over m1
	DO M=-L,L                           !!! over m
C Choose m2,m3
	DO K1=-L1,L1                        !!! over k1
	DO K=-L,L                           !!! over k
	IF(IHI(K1,K).NE.0)THEN ! first drop inputs
	M2=K1
	M3=K
	IHI(K1,K)=0
	IRI(K1,K)=1
	GOTO 100
	ENDIF
	ENDDO
	ENDDO
	DO K1=-L1,L1                        !!! over k1
	DO K=-L,L                           !!! over k
	IF(IRI(K1,K).EQ.0)THEN ! drop the rest
	M2=K1
	M3=K
	IRI(K1,K)=1
	GOTO 100
	ENDIF
	ENDDO
	ENDDO
 100	L1M2=L1*(L1+1)+M2+1
	LM3=L*(L+1)+M3+1
	IF(IRH(L1M2,LM3,IATOM1,IENV).EQ.0)CYCLE
	IDIM=IDIM+1
	DO IUP=1,NDIM-NRR
	CIRR(IUP)=BINV(IUP+NRR,IDIM)
	ENDDO
	NZ=0
	SCL=(0.D0,0.D0)
	DO IUP=1,NDIM-NRR
	IF(ABS(CIRR(IUP)).GT.1.D-07)NZ=NZ+1
	SCL=SCL+CIRR(IUP)*CIRR(IUP)
	ENDDO
	IF(NZ.LE.0)CALL FINDIRR_MESG01(5) 
	IF(NIRM.EQ.0)THEN
	NIRM=NIRM+1
	DO IUP=1,NDIM-NRR
	DIRR(IUP,NIRM)=CIRR(IUP)/SQRT(SCL)
	ENDDO
C Set pointer to irreducible element
	IRH(L1M2,LM3,IATOM1,IENV)=NIRM
	CYCLE
	ENDIF
C New elemet
	NIRM=NIRM+1
	DO IUP=1,NDIM-NRR
	DIRR(IUP,NIRM)=CIRR(IUP)
	ENDDO
C Orthogonalize to all previous
	DO IRM=1,NIRM-1
	SCP=(0.D0,0.D0)
	SCA=(0.D0,0.D0)
	DO IUP=1,NDIM-NRR
	SCP=SCP+DIRR(IUP,IRM)*CIRR(IUP)
	SCA=SCA+DIRR(IUP,IRM)*DIRR(IUP,IRM)
	ENDDO
	DO IUP=1,NDIM-NRR
	DIRR(IUP,NIRM)=DIRR(IUP,NIRM)-DIRR(IUP,IRM)*SCP/SCA
	ENDDO
	ENDDO
C Check lenght
	SCL=(0.D0,0.D0)
	DO IUP=1,NDIM-NRR
	SCL=SCL+DIRR(IUP,NIRM)*DIRR(IUP,NIRM)
	ENDDO
	IF(ABS(SCL).LT.1.D-10)IRH(L1M2,LM3,IATOM1,IENV)=-1
	IF(ABS(SCL).LT.1.D-10)NIRM=NIRM-1
	IF(ABS(SCL).LT.1.D-10)CYCLE
C Normalize
	DO IUP=1,NDIM-NRR
	DIRR(IUP,NIRM)=DIRR(IUP,NIRM)/SQRT(SCL)
	ENDDO 
C Set pointer to irreducible element
	IRH(L1M2,LM3,IATOM1,IENV)=+NIRM
	ENDDO                               !!! over m
	ENDDO                               !!! over m1
C Printing block
	IF(IPRINT.EQ.1)THEN
	WRITE(IUN,1040)(TCUBC(M3,L,ICUB),M3=-L,L)
	WRITE(IUN,1050)
	DO M2=-L1,L1                        !!! over m2
	L1M2=L1*(L1+1)+M2+1
      WRITE(IUN,1060)TCUBC(M2,L1,ICUB),
     &  (IRH(L1M2,L*(L+1)+M3+1,IATOM1,IENV),M3=-L,L)
	ENDDO
	ENDIF
	IF(NIRM+NRR.NE.NDIM)CALL FINDIRR_MESG01(7)
C Set matrix which generates all elements from irreducible elements
	IF(ITASK.EQ.1)THEN
	DO IRR=1,NRR                        !!! over irr
	JRR=0
	DO M2=-L1,L1                        !!! over m2
	L1M2=L1*(L1+1)+M2+1
	DO M3=-L,L                          !!! over m3
	LM3=L*(L+1)+M3+1
	IF(IRH(L1M2,LM3,IATOM1,IENV).EQ.0)CYCLE ! zero by symmetry
	IF(IRH(L1M2,LM3,IATOM1,IENV).GT.0)CYCLE ! irreducible
	JRR=JRR+1
	BINV(JRR,IRR)=BIRR(M2,M3,IRR)
	ENDDO                               !!! over m2
	ENDDO                               !!! over m3
	IF(JRR.NE.NRR)CALL FINDIRR_MESG01(8)
	ENDDO                               !!! over irr
	IF(NRR.GT.0)
     &  CALL LIB_CINV(NRR,BINV,(2*LMAXBMEM+1)**2,WORK,IFAIL)
	IF(IFAIL.NE.0.AND.NRR.GT.0)CALL FINDIRR_MESG01(9)
	JRR=0
	DO M1=-L1,L1                        !!! over m1
	L1M1=L1*(L1+1)+M1+1
	DO M=-L,L                           !!! over m
	LM=L*(L+1)+M+1
	IF(IRH(L1M1,LM,IATOM1,IENV).GE.0)THEN
	DO M2=-L1,L1                        !!! over m2
	L1M2=L1*(L1+1)+M2+1
	DO M3=-L,L                          !!! over m3
	LM3=L*(L+1)+M3+1
	RMAT(M2,M3,M1,M)=(0.D0,0.D0)
	ENDDO                               !!! over m2
	ENDDO                               !!! over m3
	CYCLE ! irreducibles or zeros
	ENDIF
	JRR=JRR+1
	DO M2=-L1,L1                        !!! over m2
	L1M2=L1*(L1+1)+M2+1
	DO M3=-L,L                          !!! over m3
	LM3=L*(L+1)+M3+1
	RMAT(M2,M3,M1,M)=(0.D0,0.D0)
	IF(IRH(L1M2,LM3,IATOM1,IENV).LE.0)CYCLE ! reducibles or zeros
C Reduce->Irreduce elements should be non-zeroes
	DO IRR=1,NRR                        !!! over irr
	RMAT(M2,M3,M1,M)=RMAT(M2,M3,M1,M)-
     &  BIRR(M2,M3,IRR)*BINV(IRR,JRR)
	ENDDO                               !!! over irr
	ENDDO                               !!! over m2
	ENDDO                               !!! over m3
	ENDDO                               !!! over m
	ENDDO                               !!! over m1
C Find all elements from the irreducible
	DO IORBS=1,NORBS                    !!! over iorbs
	DO IUPDN=1,NSPIN                    !!! over ispin
	DO M1=-L1,L1                        !!! over m1
	L1M1=L1*(L1+1)+M1+1
	DO M=-L,L                           !!! over m
	LM=L*(L+1)+M+1
	THOP(M1,M)=(0.D0,0.D0)
	SHOP(M1,M)=(0.D0,0.D0)
	IF(IRH(L1M1,LM,IATOM1,IENV).GT.0)
     &  THOP(M1,M)=TMAT(L1M1,LM,IATOM1,IENV,IUPDN,IORBS)
	IF(IRH(L1M1,LM,IATOM1,IENV).GT.0)
     &  SHOP(M1,M)=SMAT(L1M1,LM,IATOM1,IENV,IUPDN,IORBS)
	IF(IRH(L1M1,LM,IATOM1,IENV).GT.0)CYCLE
	DO M2=-L1,L1                        !!! over m2
	L1M2=L1*(L1+1)+M2+1
	DO M3=-L,L                          !!! over m3
	LM3=L*(L+1)+M3+1
	IF(IRH(L1M2,LM3,IATOM1,IENV).LE.0)CYCLE ! reducibles or zeroes
 	THOP(M1,M)=THOP(M1,M)+RMAT(M2,M3,M1,M)*
     &  TMAT(L1M2,LM3,IATOM1,IENV,IUPDN,IORBS)
 	SHOP(M1,M)=SHOP(M1,M)+RMAT(M2,M3,M1,M)*
     &  SMAT(L1M2,LM3,IATOM1,IENV,IUPDN,IORBS)
	ENDDO                               !!! over m2
	ENDDO                               !!! over m3
	TMAT(L1M1,LM,IATOM1,IENV,IUPDN,IORBS)=THOP(M1,M)
	SMAT(L1M1,LM,IATOM1,IENV,IUPDN,IORBS)=SHOP(M1,M)
	ENDDO                               !!! over m
	ENDDO                               !!! over m1
	ENDDO                               !!! over iupdn
	ENDDO                               !!! over iorbs
	ENDIF
C ******************************************************
2000	CONTINUE                            !!! over subblocks
C DEFINE NEW HINF ARRAY IF REQUIRED
	IF(ITASK.EQ.2)THEN
	INF=0
	DO IORBS=1,NORBS                    !!! over iorbs
	DO IUPDN=1,NSPIN                    !!! over spins
	IF(IUPDN.EQ.2.AND.IORBS.EQ.2)CYCLE
	DO IHOP=1,NHOP                      !!! over subblocks
	READ(HIND(IHOP),*)L1,L,IATOM1,IENV
	ISORT1=IS(IATOM1)
	IATOM=ISENV(IENV,IATOM1)
	ISORT=IS(IATOM)
C Set complex conjugate:
	DO IE=0,NENV(IATOM)
	DIFF=(TENV(1,IENV,IATOM1)+TENV(1,IE,IATOM))**2
     &    +(TENV(2,IENV,IATOM1)+TENV(2,IE,IATOM))**2
     &    +(TENV(3,IENV,IATOM1)+TENV(3,IE,IATOM))**2
	IF(DIFF.LE.1.D-10)EXIT
	ENDDO
	IF(IE.EQ.NENV(IATOM)+1)
     &CALL FULLSTOP('<FINDIRR> WRONG CONJUGATION')
	IENV1=IE
C Set orbitals:
	NM1=NODES(L1,ISORT1,1,1)+L1+1
	NM=NODES(L,ISORT,1,1)+L+1
	DO M1=-L1,L1                        !!! over m1
	L1M1=L1*(L1+1)+M1+1
	DO M=-L,L                           !!! over m
	LM=L*(L+1)+M+1
	IF(IRH(L1M1,LM,IATOM1,IENV).LE.0)CYCLE
	INF=INF+1
	WRITE(HINF(INF),1070)IATOM1,NM1,L1,M1,IATOM,NM,
     &  L,M,IENV,IENV1,IUPDN,IORBS
	ENDDO                               !!! over m
	ENDDO                               !!! over m1
	ENDDO                               !!! over subblocks
	ENDDO                               !!! over spins
	ENDDO                               !!! over iorbs
	NINF=INF
	ENDIF
C MEMORY DEALLOCATIONS
	DEALLOCATE(THOP,SHOP,RMAT,AIRR,BIRR,CIRR,DIRR)
	DEALLOCATE(IRE,IRH,IHI,IRI,BINV,WORK)
	DEALLOCATE(UWIGL,UROTL,ULOCL,UWIGR,UROTR,ULOCR)
C Formats
1010	FORMAT(1X,'Analysing hoppings:',A,I2,1X,A,I2,' via ',
     &  '(',G12.5,1X,',',G12.5,',',G12.5,')')
1020	FORMAT(1X,'Processing subblock l1=',I1,1X,',l=',I1)
1030	FORMAT(1X,'Total -> ',I2,', Actual -> ',I2,
     &  ',Conditions -> ',I2,',Irreducible -> ',I2)
1040	FORMAT(1X,'m1=',10X,' | ',7A10)
1050	FORMAT(1X,'---------------')
1060	FORMAT(1X,'m =',A10,' | ',7(4X,I2,4X))
1070	FORMAT(1X,12(I3,1X))
	CONTAINS
	SUBROUTINE FINDIRR_MESG01(IERR)
	WRITE(IUT,*)'Terminated in <FINDIRR>::'
	WRITE(IUT,*)'Internal error #',IERR,' detected.'
	WRITE(IUT,*)'Algorithm assuming searching irreducible'
	WRITE(IUT,*)'hopping matrix elements does not work.'
	CALL FULLSTOP('Terminated')
	END SUBROUTINE FINDIRR_MESG01
	END
