	SUBROUTINE HOP_GETHTB(IPNT,IPAN,IENW)
*********************************************************
* TB-hopping integrals are calculated                   *
* by integrating over Brillouin zone.                   *
*********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                          !!! from setup
      USE COM_CONTROL,ONLY: LIFT,LMTO,IASA,NPFR,NOVR          !!! from readini
      USE COM_PARAM  ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS        !!! from readini
     &                     ,ILSB,ILST,NHSORT
      USE COM_KAPPAR ,ONLY: NPAN,NKAP,EKAP                    !!! from readini
      USE COM_PANPAR ,ONLY: LTPAN,LSPAN                       !!! from readini
      USE COM_NBANDS ,ONLY: NBNDF,NBNDE,NBNDT                 !!! from readini
      USE COM_LATTICE,ONLY: TAU                               !!! from readstr
      USE COM_INDORB ,ONLY: INDLMT                            !!! from lmtpar
      USE COM_LMTMAT ,ONLY: HMAT,OMAT                         !!! from lmtmat
      USE COM_ENVSITE,ONLY: NENV,TENV,ISENV,IPENV,IRENV       !!! from envmesh
      USE COM_TBBPAR ,ONLY: LTBAS,LSBAS,INBAS,NTBAS           !!! from readhop
      USE COM_HOPCOM ,ONLY: TMAT,SMAT                         !!! from gethtb
      USE COM_INPTTR ,ONLY: SH                                !!! from readini
      USE COM_KMESH  ,ONLY: NPNT,PNT,WGT                      !!! from tetra
      USE COM_GROUPS ,ONLY: NGROUP,IKOV,IP,RDC,SHIFT,U        !!! from groups
	USE COM_LMTOUT ,ONLY: ICHPP                             !!! from readini
      USE COM_MASHDEP,ONLY: NVAL,LENCMP                       !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER, INTRINSIC :: SIZE
	REAL*8, ALLOCATABLE :: XVAL(:)
	REAL*8, ALLOCATABLE :: ROVR(:,:,:)
	COMPLEX*16, ALLOCATABLE :: THOP(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: SHOP(:,:,:,:)
	COMPLEX*16 PHSK
      DATA PI/3.141592653589793D0/,ICHECK/1/
      CALL ABORTNOW()
C RETURN KEYS
	IF(ICHPP.LE.0)RETURN
	IF(LMTO.EQ.1)RETURN
	IF(IPAN.GT.1)RETURN
C MEMORY ALLOCATIONS
	ALLOCATE(XVAL(NBNDT(1)*NSPINMEM))
	NDIM=NBNDT(IPAN)*NSPIN
c DO OVER SPINS IF THERE IS NO SPIN-ORBIT COUPLING
      DO 2000 IORBS=1,NORBS
      DO 1000 IUPDN=1,NSPIN
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
C *********************************************************
C SET UP REAL-SPACE HOPPING INTEGRALS
      DO IATOM1=1,NATOM                   !!! over iatom1
      ISORT1=IS(IATOM1)
      DO IENV=0,NENV(IATOM1)              !!! over ienv
      IATOM=ISENV(IENV,IATOM1)
      ISORT=IS(IATOM)
      RX=TENV(1,IENV,IATOM1)+(TAU(1,IATOM1)-TAU(1,IATOM))
      RY=TENV(2,IENV,IATOM1)+(TAU(2,IATOM1)-TAU(2,IATOM))
      RZ=TENV(3,IENV,IATOM1)+(TAU(3,IATOM1)-TAU(3,IATOM))
      XK=PNT(1,IPNT,IPAN)+SH(1,IPAN)
      YK=PNT(2,IPNT,IPAN)+SH(2,IPAN)
      ZK=PNT(3,IPNT,IPAN)+SH(3,IPAN)
      SCP=XK*RX+YK*RY+ZK*RZ
      PHSK=EXP((0.D0,-1.D0)*SCP*2.D0*PI)
      DO L1=0,ILSB(ISORT1)                !!! over l1
      DO M1=-L1,L1                        !!! over m1
      IF(.NOT.LTBAS(L1,IATOM1))EXIT
      IF(.NOT.LTPAN(L1,IATOM1,1,IPAN))EXIT
      L1M1=L1*(L1+1)+M1+1
	IDIM1=INDLMT(L1M1,IATOM1,1,ISPIN1,IPAN)
      DO L=0,ILSB(ISORT)                  !!! over l
      DO M=-L,L                           !!! over m
      IF(.NOT.LTBAS(L,IATOM))EXIT
      IF(.NOT.LTPAN(L,IATOM,1,IPAN))EXIT
      LM=L*(L+1)+M+1
	IDIM=INDLMT(LM,IATOM,1,ISPIN,IPAN)
C DO NOT RENORMALIZE! IT MIGHT LEAD TO LONGER RANGE 
C	ANORM=1.D0/SQRT(DREAL(OMAT(IDIM1,IDIM1)))
C    &          /SQRT(DREAL(OMAT(IDIM,IDIM)))
	ANORM=1.D0
	IF(IPNT.EQ.1)
     &TMAT(L1M1,LM,IATOM1,IENV,IUPDN,IORBS)=(0.D0,0.D0)
	IF(IPNT.EQ.1)
     &SMAT(L1M1,LM,IATOM1,IENV,IUPDN,IORBS)=(0.D0,0.D0)
      TMAT(L1M1,LM,IATOM1,IENV,IUPDN,IORBS)=
     &TMAT(L1M1,LM,IATOM1,IENV,IUPDN,IORBS)+WGT(IPNT,IPAN)/2.D0*
     &HMAT(IDIM1,IDIM)*PHSK*ANORM
      SMAT(L1M1,LM,IATOM1,IENV,IUPDN,IORBS)=
     &SMAT(L1M1,LM,IATOM1,IENV,IUPDN,IORBS)+WGT(IPNT,IPAN)/2.D0*
     &OMAT(IDIM1,IDIM)*PHSK*ANORM
      ENDDO                               !!! over m
      ENDDO                               !!! over l
      ENDDO                               !!! over m1
      ENDDO                               !!! over l1
      ENDDO                               !!! over ienv
      ENDDO                               !!! over iatom1
1000	CONTINUE                            !!! over spins
2000	CONTINUE                            !!! over iorbs
C MEMORY DEALLOCATIONS
	DEALLOCATE(XVAL)
      IF(IPNT.NE.NPNT(IPAN))RETURN
C *********************************************************
C MAKE SYMMETRIZATION
	ALLOCATE(ROVR(0:LMAXBMEM,NSORTMEM,NSPINMEM))
	ALLOCATE(THOP(LIMBMEM,LIMBMEM,NATOMMEM,0:NENVMEM))
	ALLOCATE(SHOP(LIMBMEM,LIMBMEM,NATOMMEM,0:NENVMEM))
      SIZE_THOP=DBLE(SIZE(THOP)*LENCMP)/1024.D0**2
      SIZE_SHOP=DBLE(SIZE(SHOP)*LENCMP)/1024.D0**2
      CURMEM=CURMEM+SIZE_THOP+SIZE_SHOP
      IF(TOTMEM.LT.CURMEM)TXTMEM='<GETHTB> Subroutine'
      IF(TOTMEM.LT.CURMEM)TOTMEM=CURMEM
      DO IORBS=1,NORBS                    !!! over iorbs
      DO IUPDN=1,NSPIN                    !!! over spins
      DO IATOM1=1,NATOM                   !!! over iatom1
      ISORT1=IS(IATOM1)
      DO IENV=0,NENV(IATOM1)              !!! over ienv
      IATOM=ISENV(IENV,IATOM1)
      ISORT=IS(IATOM)
      DO L1=0,ILSB(ISORT1)                !!! over l1
      IF(.NOT.LTBAS(L1,IATOM1))CYCLE
      DO L=0,ILSB(ISORT)                  !!! over l
      IF(.NOT.LTBAS(L,IATOM))CYCLE
      DO M1=-L1,L1
      L1M1=L1*(L1+1)+M1+1
      DO M=-L,L
      LM=L*(L+1)+M+1
      THOP(L1M1,LM,IATOM1,IENV)=(0.D0,0.D0)
      SHOP(L1M1,LM,IATOM1,IENV)=(0.D0,0.D0)
      ENDDO
      ENDDO
      DO IR=1,NGROUP                      !!! over point group
      IG=IKOV(IR)
      IATOM1G=IP(IATOM1,IR)
      IENVG=IPENV(IENV,IATOM1,IR)
      IATOMG=ISENV(IENVG,IATOM1G)
      DO M1=-L1,L1
      L1M1=L1*(L1+1)+M1+1
      DO M=-L,L
      LM=L*(L+1)+M+1
      DO M2=-L1,L1
      L1M2=L1*(L1+1)+M2+1
      IWIG12=L1*(2*L1-1)*(2*L1+1)/3+(2*L1+1)*(L1+M2)+L1+M1+1
      DO M3=-L,L
      LM3=L*(L+1)+M3+1
      IWIG03=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M3)+L+M+1
      THOP(L1M1,LM,IATOM1,IENV)=
     &THOP(L1M1,LM,IATOM1,IENV)+
     &TMAT(L1M2,LM3,IATOM1G,IENVG,IUPDN,IORBS)*
     &U(IWIG12,IG)*CONJG(U(IWIG03,IG))
      SHOP(L1M1,LM,IATOM1,IENV)=
     &SHOP(L1M1,LM,IATOM1,IENV)+
     &SMAT(L1M2,LM3,IATOM1G,IENVG,IUPDN,IORBS)*
     &U(IWIG12,IG)*CONJG(U(IWIG03,IG))
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      ENDDO                               !!! over point group
      ENDDO                               !!! over l
      ENDDO                               !!! over l1
      ENDDO                               !!! over ienv
      ENDDO                               !!! over iatom1
C ********************************************************
C SET UP ROTATED MATRIX
      DO IATOM1=1,NATOM                   !!! over iatom1
      ISORT1=IS(IATOM1)
      DO IENV=0,NENV(IATOM1)              !!! over ienv
      IATOM=ISENV(IENV,IATOM1)
      ISORT=IS(IATOM)
      DO L1=0,ILSB(ISORT1)                !!! over l1
      IF(.NOT.LTBAS(L1,IATOM1))CYCLE
      DO L=0,ILSB(ISORT)                  !!! over l
      IF(.NOT.LTBAS(L,IATOM))CYCLE
      DO M1=-L1,L1
      L1M1=L1*(L1+1)+M1+1
      DO M=-L,L
      LM=L*(L+1)+M+1
      TMAT(L1M1,LM,IATOM1,IENV,IUPDN,IORBS)=
     &THOP(L1M1,LM,IATOM1,IENV)/DBLE(NGROUP)
      SMAT(L1M1,LM,IATOM1,IENV,IUPDN,IORBS)=
     &SHOP(L1M1,LM,IATOM1,IENV)/DBLE(NGROUP)
      ENDDO
      ENDDO
      ENDDO                               !!! over l
      ENDDO                               !!! over l1
      ENDDO                               !!! over ienv
      ENDDO                               !!! over iatom1
      ENDDO                               !!! over spins
      ENDDO                               !!! over iorbs
C ***************************************************
C SET UP RENORMALIZATION FACTOR BY AVERAGING OVER ALL M
C AND OVER ALL ATOMS OF GIVEN SORT. THIS KEEPS SYMMETRY
	DO ISPIN=1,NSPIN
	DO ISORT=1,NSORT
	DO L=0,ILSB(ISORT)
	ROVR(L,ISORT,ISPIN)=0.D0
      DO IATOM=1,NATOM
	IF(IS(IATOM).NE.ISORT)CYCLE
      IF(.NOT.LTBAS(L,IATOM))CYCLE
      DO M=-L,L
      LM=L*(L+1)+M+1
	ROVR(L,ISORT,ISPIN)=ROVR(L,ISORT,ISPIN)+
     &1.D0/SQRT(SMAT(LM,LM,IATOM,0,ISPIN,1))/
     &DBLE(2*L+1)/DBLE(NHSORT(ISORT)) 
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C RENORMALIZE NOW, IT SHOULD NOT LEAD TO LONGER RANGE
	DO IORBS=1,NORBS                    !!! over iorbs
	DO ISPIN=1,NSPIN                    !!! over spins
      DO IATOM1=1,NATOM                   !!! over iatom1
      ISORT1=IS(IATOM1)
      DO IENV=0,NENV(IATOM1)              !!! over ienv
      IATOM=ISENV(IENV,IATOM1)
      ISORT=IS(IATOM)
      DO L1=0,ILSB(ISORT1)                !!! over l1
      IF(.NOT.LTBAS(L1,IATOM1))CYCLE
      DO L=0,ILSB(ISORT)                  !!! over l
      IF(.NOT.LTBAS(L,IATOM))CYCLE
      DO M1=-L1,L1
      L1M1=L1*(L1+1)+M1+1
      DO M=-L,L
      LM=L*(L+1)+M+1
	ANORM=ROVR(L1,ISORT1,ISPIN)*ROVR(L,ISORT,ISPIN)
      TMAT(L1M1,LM,IATOM1,IENV,ISPIN,IORBS)=
     &TMAT(L1M1,LM,IATOM1,IENV,ISPIN,IORBS)*ANORM
      SMAT(L1M1,LM,IATOM1,IENV,ISPIN,IORBS)=
     &SMAT(L1M1,LM,IATOM1,IENV,ISPIN,IORBS)*ANORM
      ENDDO
      ENDDO
      ENDDO                               !!! over l
      ENDDO                               !!! over l1
      ENDDO                               !!! over ienv
      ENDDO                               !!! over iatom1
      ENDDO                               !!! over spins
      ENDDO                               !!! over iorbs
C MEMORY DEALLOCATIONS
	DEALLOCATE(ROVR,THOP,SHOP)
      CURMEM=CURMEM-SIZE_THOP-SIZE_SHOP
C STORE HOPPING INTEGRALS
	CALL HOP_WRITEHOP(2)
	END
