	SUBROUTINE HOP_STRALP(IPNT,IPAN,IENW)
***********************************************************
*   The calculation of the screened structure constants.  * 
***********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                          !!! from setup
      USE COM_CONTROL ,ONLY: LMTO,IASA,NOVR,NPFR              !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,IS,ILST,ILSB   !!! from readini
      USE COM_LATPAR  ,ONLY: PAR,OMEGAC                       !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP,EK                !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN                      !!! from readini
      USE COM_SPHERE  ,ONLY: SMT,SWZ                          !!! from readini
      USE COM_SCRINP  ,ONLY: ALPHA,ALPDOT                     !!! from alpcon
      USE COM_STRCON  ,ONLY: SSCON,SDCON                      !!! from strgnt
	USE COM_UNIT    ,ONLY: IUN,IUR,IUT                      !!! from setup
      USE COM_MASHDEP ,ONLY: LENCMP                           !!! from readini
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER, INTRINSIC :: SIZE
	REAL*8,     ALLOCATABLE :: WRK(:)
	COMPLEX*16, ALLOCATABLE :: XM(:,:)
	COMPLEX*16, ALLOCATABLE :: WD(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: SW(:,:)
	DATA PI/3.141592653589793D0/
      CALL ABORTNOW()
C RETURN KEYS
	IF(LMTO.NE.2)RETURN
C MEMORY ALLOCATIONS
	ALLOCATE(WRK(LIMBMEM*NATOMMEM))
	ALLOCATE(XM(LIMBMEM*NATOMMEM,LIMBMEM*NATOMMEM))
	ALLOCATE(WD(LIMBMEM,NATOMMEM,LIMBMEM,NATOMMEM))
	ALLOCATE(SW(LIMT1MEM,NATOMMEM))
      SIZE_XM=DBLE(SIZE(XM)*LENCMP)/1024.D0**2
      SIZE_WD=DBLE(SIZE(WD)*LENCMP)/1024.D0**2
      CURMEM=CURMEM+SIZE_XM+SIZE_WD
      IF(TOTMEM.LT.CURMEM)TXTMEM='<STRALP> Subroutine'
      IF(TOTMEM.LT.CURMEM)TOTMEM=CURMEM
C START CODE
      DO 1000 IKAP=1,NKAP(IPAN)           !!! over ikap1
C CHECK SCREENING
	CHK=0.D0
	DO ISORT=1,NSORT
	DO L=0,ILSB(ISORT)
	CHK=CHK+ABS(ALPHA(L,ISORT,IKAP,IPAN)) 
	ENDDO
	ENDDO
	IF(ABS(CHK).LE.1.D-07)GOTO1000      !!! no screening
C SET RECIPROCAL TRANSFORMATION MATRIX
      IDIM1=0
      DO IATOM1=1,NATOM                   !!! over iatom1
      ISORT1=IS(IATOM1)
      DO L1=0,ILSB(ISORT1)                !!! over l1
      DO M1=-L1,L1                        !!! over m1
      L1M1=L1*(L1+1)+M1+1
      IDIM1=IDIM1+1
      IDIM=0
      DO IATOM=1,NATOM                    !!! over iatom
      ISORT=IS(IATOM)
      DO L=0,ILSB(ISORT)                  !!! over l
      DO M=-L,L                           !!! over m
      LM=L*(L+1)+M+1
      IDIM=IDIM+1
      XM(IDIM1,IDIM)=-ALPHA(L1,ISORT1,IKAP,IPAN)*
     &SSCON(L1M1,IATOM1,LM,IATOM,IKAP)*ALPHA(L,ISORT,IKAP,IPAN)
      ENDDO                               !!! over m
      ENDDO                               !!! over l
      ENDDO                               !!! over iatom
      XM(IDIM1,IDIM1)=XM(IDIM1,IDIM1)+ALPHA(L1,ISORT1,IKAP,IPAN)
      ENDDO                               !!! over m1
      ENDDO                               !!! over l1
      ENDDO                               !!! over iatom1
	MDIM=IDIM1
C INVERT MATRIX
      CALL LIB_CINV(MDIM,XM,LIMBMEM*NATOMMEM,WRK,IFAIL)
      IF(IFAIL.NE.0)
     &WRITE(IUT,*)'<STRALP>:: ERROR IN INVERSION PROGRAM'
C SCREENED STRUCTURE CONSTANTS
C Sa=[1-S0*A]^{-1}*S0=(A-A*S0*A)^{-1}-1/A
	IDIM1=0
      DO IATOM1=1,NATOM                   !!! over iatom1
      ISORT1=IS(IATOM1)
      DO L1=0,ILSB(ISORT1)                !!! over l1
      DO M1=-L1,L1                        !!! over m1
      L1M1=L1*(L1+1)+M1+1
	IDIM1=IDIM1+1
	IDIM=0
      DO IATOM=1,NATOM                    !!! over iatom
      ISORT=IS(IATOM)
      DO L=0,ILSB(ISORT)                  !!! over l
      DO M=-L,L                           !!! over m
      LM=L*(L+1)+M+1
      IDIM=IDIM+1
	SSCON(L1M1,IATOM1,LM,IATOM,IKAP)=XM(IDIM1,IDIM)
      ENDDO                               !!! over m
      ENDDO                               !!! over l
      ENDDO                               !!! over iatom
	SSCON(L1M1,IATOM1,L1M1,IATOM1,IKAP)=
     &SSCON(L1M1,IATOM1,L1M1,IATOM1,IKAP)-
     &1.D0/ALPHA(L1,ISORT1,IKAP,IPAN)
      ENDDO                               !!! over m1
      ENDDO                               !!! over l1
      ENDDO                               !!! over iatom1
C EXPAND SCREENED STRUCTURE CONSTANTS FOR HIGHER L'S
C S(a)=S(0)*(1+A*S(a))=[1-S(0)A]^{-1}*S(0)
	IDIM1=0
      DO IATOM1=1,NATOM                   !!! over ienv1
      ISORT1=IS(IATOM1)
      DO L1=ILSB(ISORT1)+1,ILST(ISORT1)   !!! over l1
      DO M1=-L1,L1                        !!! over m1
      L1M1=L1*(L1+1)+M1+1
	IDIM1=IDIM1+1
	IDIM=0
      DO IATOM=1,NATOM                    !!! over iatom
	ISORT=IS(IATOM)
      DO L=0,ILSB(ISORT)                  !!! over l
      DO M=-L,L                           !!! over m
      LM=L*(L+1)+M+1
	IDIM=IDIM+1
	SW(LM,IATOM)=SSCON(L1M1,IATOM1,LM,IATOM,IKAP)
      DO IATOM2=1,NATOM                   !!! over iatom2
      ISORT2=IS(IATOM2)
      DO L2=0,ILSB(ISORT2)                !!! over l2
      DO M2=-L2,L2                        !!! over m2
      L2M2=L2*(L2+1)+M2+1
	SW(LM,IATOM)=SW(LM,IATOM)+
     &SSCON(L1M1,IATOM1,L2M2,IATOM2,IKAP)*
     &ALPHA(L2,ISORT2,IKAP,IPAN)*
     &SSCON(L2M2,IATOM2,LM,IATOM,IKAP)
      ENDDO                               !!! over m2
      ENDDO                               !!! over l2
      ENDDO                               !!! over iatom2
      ENDDO                               !!! over m
      ENDDO                               !!! over l
      ENDDO                               !!! over iatom
      DO IATOM=1,NATOM                    !!! over iatom
	ISORT=IS(IATOM)
      DO L=0,ILSB(ISORT)                  !!! over l
      DO M=-L,L                           !!! over m
      LM=L*(L+1)+M+1
	SSCON(L1M1,IATOM1,LM,IATOM,IKAP)=SW(LM,IATOM)
      ENDDO                               !!! over m
      ENDDO                               !!! over l
      ENDDO                               !!! over iatom
      ENDDO                               !!! over m1
      ENDDO                               !!! over l1
      ENDDO                               !!! over iatom1
C GENERATE ENERGY DERIVATIVES OF THE SCREENED STR.CON.
      IDIM2=0
      DO IATOM2=1,NATOM                   !!! over iatom2
      ISORT2=IS(IATOM2)
      DO L2=0,ILSB(ISORT2)                !!! over l2
      DO M2=-L2,L2                        !!! over m2
      L2M2=L2*(L2+1)+M2+1
      IDIM2=IDIM2+1
	IDIM=0
	DO IATOM=1,NATOM                    !!! over iatom
	ISORT=IS(IATOM)          
      DO L=0,ILSB(ISORT)                  !!! over l
      DO M=-L,L                           !!! over m
      LM=L*(L+1)+M+1
	IDIM=IDIM+1
      WD(L2M2,IATOM2,LM,IATOM)=(0.D0,0.D0)
      IDIM3=0
      DO IATOM3=1,NATOM                   !!! over ienv3
      ISORT3=IS(IATOM3)
      DO L3=0,ILSB(ISORT3)                !!! over l3
      DO M3=-L3,L3                        !!! over m3
      L3M3=L3*(L3+1)+M3+1
      IDIM3=IDIM3+1
      WD(L2M2,IATOM2,LM,IATOM)=WD(L2M2,IATOM2,LM,IATOM)+
     &ALPHA(L2,ISORT2,IKAP,IPAN)*
     &SDCON(L2M2,IATOM2,L3M3,IATOM3,IKAP)*
     &ALPHA(L3,ISORT3,IKAP,IPAN)*XM(IDIM3,IDIM)
      ENDDO                               !!! over m3
      ENDDO                               !!! over l3
      ENDDO                               !!! over iatom3
      ENDDO                               !!! over m
      ENDDO                               !!! over l
      ENDDO                               !!! over iatom
      ENDDO                               !!! over m2
      ENDDO                               !!! over l2
      ENDDO                               !!! over iatom2
C
	IDIM=0
	DO IATOM=1,NATOM                    !!! over iatom
	ISORT=IS(IATOM)          
      DO L=0,ILSB(ISORT)                  !!! over l
      DO M=-L,L                           !!! over m
      LM=L*(L+1)+M+1
	IDIM=IDIM+1
      IDIM1=0
      DO IATOM1=1,NATOM                   !!! over iatom1
      ISORT1=IS(IATOM1)
      DO L1=0,ILSB(ISORT1)                !!! over l1
      DO M1=-L1,L1                        !!! over m1
      L1M1=L1*(L1+1)+M1+1
      SDCON(L1M1,IATOM1,LM,IATOM,IKAP)=(0.D0,0.D0)
      IDIM1=IDIM1+1
      IDIM2=0
      DO IATOM2=1,NATOM                   !!! over iatom2
      ISORT2=IS(IATOM2)
      DO L2=0,ILSB(ISORT2)                !!! over l2
      DO M2=-L2,L2                        !!! over m2
      L2M2=L2*(L2+1)+M2+1
      IDIM2=IDIM2+1
      SDCON(L1M1,IATOM1,LM,IATOM,IKAP)=
     &SDCON(L1M1,IATOM1,LM,IATOM,IKAP)+
     &XM(IDIM1,IDIM2)*WD(L2M2,IATOM2,LM,IATOM)
      SDCON(L1M1,IATOM1,LM,IATOM,IKAP)=
     &SDCON(L1M1,IATOM1,LM,IATOM,IKAP)+
     &XM(IDIM1,IDIM2)*ALPDOT(L2,ISORT2,IKAP,IPAN)*
     &SSCON(L2M2,IATOM2,LM,IATOM,IKAP)
      ENDDO                               !!! over m2
      ENDDO                               !!! over l2
      ENDDO                               !!! over iatom2
      SDCON(L1M1,IATOM1,LM,IATOM,IKAP)=
     &SDCON(L1M1,IATOM1,LM,IATOM,IKAP)-
     &1.D0/ALPHA(L1,ISORT1,IKAP,IPAN)*ALPDOT(L1,ISORT1,IKAP,IPAN)*
     &SSCON(L1M1,IATOM1,LM,IATOM,IKAP)
      ENDDO                               !!! over m1
      ENDDO                               !!! over l1
      ENDDO                               !!! over iatom1
      ENDDO                               !!! over m
      ENDDO                               !!! over l
      ENDDO                               !!! over iatom
1000	CONTINUE                            !!! over ikap
C MEMORY DEALLOCATIONS
	DEALLOCATE(WRK,XM,WD,SW)
      CURMEM=CURMEM-SIZE_XM-SIZE_WD
	END
