	SUBROUTINE HUB_HUBPAR(IPAN)
***************************************************************
*   Adds Hubbard correction to the potential parameters.      *
***************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
	USE COM_LMTMEM
      USE COM_CONTROL ,ONLY: LMTO,IASA,IDMF,NOVR,NPFR               !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS,ILST,ILSB,LRTV! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP,EK                      !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN,IATS,ISTS                  !!! from readini
      USE COM_SUMPAR  ,ONLY: PHH,PJH,PHJ,PJJ                        !!! from ovrpar
      USE COM_LMTPAR  ,ONLY: GAM,AAH,AAJ,BBH,BBJ                    !!! from potpar
      USE COM_HAMPAR  ,ONLY: HPARHH,HPARJH,HPARHJ,HPARJJ            !!! from potpar
      USE COM_RADMESH ,ONLY: NRAD,H,R,DR,WEIGHT,RL                  !!! from radmesh
      USE COM_MASHDEP ,ONLY: NVAL,LENREL,LENCMP                     !!! from setup
      USE COM_HUBCOM  ,ONLY: VHUB,VDBC,VCNS                         !!! from readhub
      USE COM_CHANNELS,ONLY: IUNMT                                  !!! from readini
	USE COM_LMTINP  ,ONLY: ICHUB                                  !!! from readini
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	LOGICAL LOG1,LOG
	DATA PI/3.141592653589793D0/
      CALL ABORTNOW()
C RETURN KEYS
	IF(IDMF.NE.1.AND.IDMF.NE.2)RETURN
	IF(IPAN.NE.1)RETURN
C MEMORY ALLOCATIONS FOR SCRATCH ARRAYS
C START CODE
	DO 5000 IATOM=1,NATOM          !!! over atoms
	ISORT=IS(IATOM)
	DO 4000 IORBS=1,NORBS          !!! over spins
	DO 3000 IUPDN=1,NSPIN          !!! over spins
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
      DO 2000 IKAP1=1,NKAP(IPAN)     !!! over energy
      DO 1000 IKAP =1,NKAP(IPAN)     !!! over energy
C READ POTENTIAL PARAMETERS
      IREC=IKAP1+NKAP(IPAN)*(IKAP-1)+NKAP(IPAN)**2*(IATOM-1)+
     &NKAP(IPAN)**2*NATOM*(IUPDN-1)+
     &NKAP(IPAN)**2*NATOM*NSPIN*(IORBS-1)
      READ(IUNMT,REC=IREC)((HPARHH(L1M1,LM,IATOM),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((HPARJH(L1M1,LM,IATOM),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((HPARHJ(L1M1,LM,IATOM),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &((HPARJJ(L1M1,LM,IATOM),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2)
C ADD HUBBARD POTENTIAL
	DO L=0,ILSB(ISORT)             !!! over l
	LOG1=.FALSE.
	LOG =.FALSE.
	IF(LTPAN(L,IATOM,IKAP1,IPAN))LOG1=.TRUE.
	IF(LTPAN(L,IATOM,IKAP ,IPAN))LOG =.TRUE.
C ********************
C Note that VHUB is ALREADY the matrix element <B^{+/-} * S_{+/-}>
C not just a field <B^{+/-}>!
	DO M1=-L,L                     !!! over m1
	LM1=L*(L+1)+M1+1
	DO M=-L,L                      !!! over m
	LM=L*(L+1)+M+1
      IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M1+1 !!! (l,m1 m)
C For off diagonal elements we need to <<divide>> by {+/-}sqrt(2) starting from LmtART 6.60
	IF(LOG1.AND.LOG)
     &HPARHH(LM1,LM,IATOM)=HPARHH(LM1,LM,IATOM)+
     &PHH(IKAP1,IKAP,L,ISORT,IPAN,IUPDN,IORBS)*
     &          (VHUB(IU,IATOM,IUPDN,IORBS)-
     &           VDBC(IU,IATOM,IUPDN,IORBS)+
     &           VCNS(IU,IATOM,IUPDN,IORBS))
 	IF(LOG)
     &HPARJH(LM1,LM,IATOM)=HPARJH(LM1,LM,IATOM)+
     &PJH(IKAP1,IKAP,L,ISORT,IPAN,IUPDN,IORBS)*
     &          (VHUB(IU,IATOM,IUPDN,IORBS)-
     &           VDBC(IU,IATOM,IUPDN,IORBS)+
     &           VCNS(IU,IATOM,IUPDN,IORBS))
 	IF(LOG1)
     &HPARHJ(LM1,LM,IATOM)=HPARHJ(LM1,LM,IATOM)+
     &PHJ(IKAP1,IKAP,L,ISORT,IPAN,IUPDN,IORBS)*
     &          (VHUB(IU,IATOM,IUPDN,IORBS)- 
     &           VDBC(IU,IATOM,IUPDN,IORBS)+
     &           VCNS(IU,IATOM,IUPDN,IORBS))
 	HPARJJ(LM1,LM,IATOM)=HPARJJ(LM1,LM,IATOM)+
     &PJJ(IKAP1,IKAP,L,ISORT,IPAN,IUPDN,IORBS)*
     &          (VHUB(IU,IATOM,IUPDN,IORBS)-
     &           VDBC(IU,IATOM,IUPDN,IORBS)+
     &           VCNS(IU,IATOM,IUPDN,IORBS))
      ENDDO                          !!! over m
      ENDDO                          !!! over m1
      ENDDO                          !!! over l
C STORE POTENTIAL PARAMETERS
	IREC=IKAP1+NKAP(IPAN)*(IKAP-1)+NKAP(IPAN)**2*(IATOM-1)+
     &NKAP(IPAN)**2*NATOM*(IUPDN-1)+
     &NKAP(IPAN)**2*NATOM*NSPIN*(IORBS-1)
	WRITE(IUNMT,REC=IREC)((HPARHH(L1M1,LM,IATOM),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((HPARJH(L1M1,LM,IATOM),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((HPARHJ(L1M1,LM,IATOM),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &((HPARJJ(L1M1,LM,IATOM),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2)
1000  CONTINUE                       !!! over ikap
2000  CONTINUE                       !!! over ikap1
3000  CONTINUE                       !!! over spins
4000  CONTINUE                       !!! over iorbs
5000  CONTINUE                       !!! over atoms
C MEMORY DEALLOCATIONS
	END
