	SUBROUTINE HUB_MSBMESH
*******************************************************
* Set Matsubara and real axis grids
*******************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
	USE COM_MSBMESH ,ONLY : TEMP,OBND,KGRD
     &                       ,NMSB,WMSB,DMSB,FMSB,SMSB
     &                       ,NMSL,WMSL,DMSL,FMSL,SMSL
     &                       ,NOMG,WOMG,DOMG,FOMG,WMIN,WMAX
     &                       ,NMSC,WMSC,DMSC,FMSC
      USE COM_UNIT    ,ONLY : IUN,IUR,IUT
      USE COM_MASHDEP ,ONLY : NVAL,LENCMP
C SET LOCAL VARIABLES 
      IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8, ALLOCATABLE :: WORK1(:),WORK2(:)
	COMPLEX*16, ALLOCATABLE :: YMSB(:),YMSL(:)
      DATA PI/3.141592653589793D0/
C CONSTRUCT LINEAR MATSUBARA GRID
      IF(ALLOCATED(WMSL))DEALLOCATE(WMSL)
      IF(ALLOCATED(DMSL))DEALLOCATE(DMSL)
      IF(ALLOCATED(FMSL))DEALLOCATE(FMSL)
	ALLOCATE(WMSL(0:NMSL))
	ALLOCATE(DMSL(0:NMSL))
	ALLOCATE(FMSL(0:NMSL))
	DO IMSL=0,NMSL
	WMSL(IMSL)=PI*TEMP*DBLE(2*IMSL+1)
	DMSL(IMSL)=0.D0
	FMSL(IMSL)=1.D0
	ENDDO
	SMSL=2.D0*PI*TEMP
C BUILD LOGARITHMIC MATSUBARA GRID
      IF(ALLOCATED(WMSB))DEALLOCATE(WMSB)
      IF(ALLOCATED(DMSB))DEALLOCATE(DMSB)
      IF(ALLOCATED(FMSB))DEALLOCATE(FMSB)
	ALLOCATE(WMSB(0:NMSB))
	ALLOCATE(DMSB(0:NMSB))
	ALLOCATE(FMSB(0:NMSB))
C LOGARITHMIC GRID
      IF(ABS(TEMP).GE.1.D-10)THEN
C Correlated band parameters
	OMAX=WMSL(NMSL)-WMSL(0)
	IF(ABS(OMAX).LE.1.D-10)OMAX=1.D-10
C Distribute N points within bandwidth
	NB=NMSB/2
	SMSB=LOG(OMAX/OBND)/DBLE(NMSB-NB)
	BETB=OMAX/(EXP(SMSB*DBLE(NMSB))-1.D0)
	DO IMSB=0,NMSB
	WMSB(IMSB)=BETB*(EXP(SMSB*DBLE(IMSB))-1.D0)+WMSL(0)
	DMSB(IMSB)=BETB*(EXP(SMSB*DBLE(IMSB)))
	ENDDO
	WMSB(0)=WMSL(0)
	WMSB(NMSB)=WMSL(NMSL)
C CONSTRUCT WEIGHT FUNCTION TO PERFORM MATSUBARA SUMS
	ALLOCATE(YMSB(0:NMSB))
	ALLOCATE(YMSL(0:NMSL))
	DO IMSB=0,NMSB
	DO JMSB=0,NMSB
	YMSB(JMSB)=(0.D0,0.D0)
	ENDDO
	YMSB(IMSB)=(1.D0,0.D0)
	DO IMSL=0,NMSL
	YMSL(IMSL)=(0.D0,0.D0)
	ENDDO
      CALL LIB_CSPLINES(NMSB+1,WMSB,YMSB,NMSL+1,WMSL,YMSL)
	FMSB(IMSB)=0.D0
	DO IMSL=0,NMSL
	FMSB(IMSB)=FMSB(IMSB)+DREAL(YMSL(IMSL))
	ENDDO
	ENDDO
	DEALLOCATE(YMSB,YMSL)
	ELSE
      WRITE(IUN,*)'<HUB_MSBMESH>: T=0, no Matsubara grid generated'
	DO IMSB=0,NMSB
	WMSB(IMSB)=0.D0
	DMSB(IMSB)=0.D0
	FMSB(IMSB)=0.D0
	ENDDO
	ENDIF
C SET REAL AXIS LOGARITHMIC GRID
      IF(ALLOCATED(WOMG))DEALLOCATE(WOMG)
      IF(ALLOCATED(DOMG))DEALLOCATE(DOMG)
      IF(ALLOCATED(FOMG))DEALLOCATE(FOMG)
	ALLOCATE(WOMG(0:NOMG))
	ALLOCATE(DOMG(0:NOMG))
	ALLOCATE(FOMG(0:NOMG))
C Correlated band parameters
	ORIT=ABS(WMAX)
	OLEF=ABS(WMIN)
	IF(ABS(ORIT).LE.1.D-10)ORIT=1.D-10
	IF(ABS(OLEF).LE.1.D-10)OLEF=1.D-10
	IF(MOD(NOMG,2).NE.0)
     &CALL FULLSTOP('<MSBMESH>:: NOMG MUST BE EVEN')
	NMID=NOMG/2
      ALLOCATE(WORK1(0:NMID))
      ALLOCATE(WORK2(0:NMID))
C Distribute 80% of N points within bandwidth
      IF(ORIT.LE.OBND)
     &CALL FULLSTOP('<HUB_MSBMESH>:: Grid failure: Wmax<Obnd')
      IF(OLEF.LE.OBND)
     &CALL FULLSTOP('<HUB_MSBMESH>:: Grid failure: Wmin<Obnd')
	NE=NMID*0.8
	SRIT=LOG(ORIT/OBND)/DBLE(NMID-NE)
	SLEF=LOG(OLEF/OBND)/DBLE(NMID-NE)
	BRIT=ORIT/(EXP(SRIT*DBLE(NMID))-1.D0)
	BLEF=OLEF/(EXP(SLEF*DBLE(NMID))-1.D0)
	SRIT=LOG(ORIT/BRIT+1.D0)/DBLE(NMID)
	SLEF=LOG(OLEF/BLEF+1.D0)/DBLE(NMID)
C Left interval	
	IOMG=NMID+1
	DO I=0,NMID
	IOMG=IOMG-1
	WOMG(IOMG)=-BLEF*(EXP(SLEF*DBLE(I))-1.D0)
	DOMG(IOMG)=+BLEF*(EXP(SLEF*DBLE(I)))
	FOMG(IOMG)=0.D0
	ENDDO
C Set weights for left interval
	IOMG=NMID+1
	DO I=0,NMID
	IOMG=IOMG-1
      DO J=0,NMID
      WORK1(J)=0.D0
      ENDDO	
      WORK1(I)=DOMG(IOMG)
      CALL LIB_QD(SLEF,WORK1,WORK2,NMID+1)
      FOMG(IOMG)=WORK2(NMID)
      ENDDO
	DLEF=DOMG(NMID)
	FLEF=FOMG(NMID)
C Check that sum to be half interval, i.e. WMIN
      SUML=0.D0
      DO IOMG=0,NMID
      SUML=SUML+FOMG(IOMG)
      ENDDO
C Right interval      
	IOMG=NMID-1
	DO I=0,NMID
	IOMG=IOMG+1
	WOMG(IOMG)=+BRIT*(EXP(SRIT*DBLE(I))-1.D0)
	DOMG(IOMG)=+BRIT*(EXP(SRIT*DBLE(I)))
	FOMG(IOMG)=0.D0
	ENDDO
C Set weights for right interval
	IOMG=NMID-1
	DO I=0,NMID
	IOMG=IOMG+1
      DO J=0,NMID
      WORK1(J)=0.D0
      ENDDO	
      WORK1(I)=DOMG(IOMG)
      CALL LIB_QD(SRIT,WORK1,WORK2,NMID+1)
      FOMG(IOMG)=WORK2(NMID)
      ENDDO
	DRIT=DOMG(NMID)
	FRIT=FOMG(NMID)
C Check that sum to be half interval, i.e. WMAX
      SUMR=0.D0
      DO IOMG=NMID,NOMG
      SUMR=SUMR+FOMG(IOMG)
      ENDDO
      SUMT=SUML+SUMR
	WOMG(0   )=WMIN
	WOMG(NOMG)=WMAX
	WOMG(NMID)=0.D0
	DOMG(NMID)=0.5D0*(DRIT+DLEF)
	FOMG(NMID)=0.5D0*(FRIT+FLEF)
C Linear Grid (obsolete)	
      IF(.FALSE.)THEN
	IF(NOMG.NE.0)ESTEP=(WMAX-WMIN)/DBLE(NOMG)
	IF(NOMG.EQ.0)ESTEP=0.D0
	DO IOMG=0,NOMG
	WOMG(IOMG)=WMIN+DBLE(IOMG)*ESTEP
	DOMG(IOMG)=0.D0
	FOMG(IOMG)=ESTEP*DBLE(NOMG)/DBLE(NOMG+1)
	ENDDO
	ENDIF
C Current frequency grid
      IF(KGRD.EQ.1)NMSC=NOMG
      IF(KGRD.EQ.2)NMSC=NMSB
      NMSCMEM=NMSC
	IF(ALLOCATED(WMSC))DEALLOCATE(WMSC)
	IF(ALLOCATED(FMSC))DEALLOCATE(FMSC)
	IF(ALLOCATED(DMSC))DEALLOCATE(DMSC)
      ALLOCATE(WMSC(0:NMSCMEM))
      ALLOCATE(FMSC(0:NMSCMEM))
      ALLOCATE(DMSC(0:NMSCMEM))
      IF(KGRD.EQ.1)THEN
      DO IOMG=0,NOMG
      WMSC(IOMG)=DCMPLX(WOMG(IOMG),0.D0)
      FMSC(IOMG)=FOMG(IOMG)
      DMSC(IOMG)=DOMG(IOMG)
      ENDDO
      ELSEIF(KGRD.EQ.2)THEN
      DO IMSB=0,NMSB
      WMSC(IMSB)=DCMPLX(0.D0,WMSB(IMSB))
      FMSC(IMSB)=FMSB(IMSB)
      DMSC(IMSB)=DMSB(IMSB)
      ENDDO
      ENDIF
      END
