      SUBROUTINE HUB_READREP(OCS,NWIG,NRSP,NROR,L,ICUBI,IRE,FILE,NREC)
************************************************************
*  Reads density matrices in a particular representation  *
************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
C Passed arrays
      COMPLEX*16 OCS(NWIG,2,2)
      CHARACTER FILE(NREC)*150
C Allocatable arrays
	REAL*8, ALLOCATABLE :: OCR(:)
	COMPLEX*16, ALLOCATABLE :: OCP(:,:,:),RMAT(:,:)
C Local arrays
      COMPLEX*16 TC(-3:3,7,0:3)
      CHARACTER TEXT*64
      LOGICAL FIRST
      SAVE TC
      DATA PI/3.141592653589793D0/,FIRST/.TRUE./
      IF(L.GT.3)
     &CALL FULLSTOP('<HUB_WRITEREP>: L > 3 not allowed!')
C Initialize arrays
      IF(FIRST)THEN 
      CALL LIB_TRANSC(TC)
      FIRST=.FALSE.
      ENDIF
C Memory allocations      
	ALLOCATE(OCP(NWIG,2,2))
	ALLOCATE(OCR(-L:L))
C READ MATRIX
      IREC=0
	DO IOR=1,NROR
	DO ISP=1,NRSP
	DO IRM=1,IRE
	IREC=IREC+1
	READ(FILE(IREC),FMT='(A)')TEXT
	DO M1=-L,L
	IREC=IREC+1
	READ(FILE(IREC),*)(OCR(M),M=-L,L)
	DO M=-L,L
      IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M1+1  !  (l,m' m) packed
	IF(IRM.EQ.1)OCP(IU,ISP,IOR)=DCMPLX(OCR(M),0.D0)
	IF(IRM.EQ.2)OCP(IU,ISP,IOR)=DCMPLX(DREAL(OCP(IU,ISP,IOR)),OCR(M))
	ENDDO                                  !!! over m
	ENDDO                                  !!! over m1
	ENDDO                                  !!! over i
	ENDDO
	ENDDO
C TRANSFER TO SPHERICAL HARMONICS IF NECESSARY
	IF(ICUBI.EQ.1)THEN
	DO IOR=1,NROR
	DO ISP=1,NRSP
	DO MY1=-L,L
	DO MY =-L,L
      IUY=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+MY)+L+MY1+1  !  (l,m' m) packed
	OCS(IUY,ISP,IOR)=(0.D0,0.D0)
	DO MX1=-L,L
	DO MX =-L,L
      IUX=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+MX)+L+MX1+1  !  (l,m' m) packed
      OCS(IUY,ISP,IOR)=OCS(IUY,ISP,IOR)+CONJG(TC(MY1,MX1+L+1,L))*
     &OCP(IUX,ISP,IOR)*TC(MY,MX+L+1,L)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO                                   !!! over isp
	ENDDO                                   !!! over ior
	ELSEIF(ICUBI.EQ.2)THEN
	DO IOR=1,NROR
	DO ISP=1,NRSP
	DO M1=-L,L
	DO M=-L,L
      IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M1+1     !  (l,m' m) packed
      OCS(IU,ISP,IOR)=OCP(IU,ISP,IOR)
	ENDDO
	ENDDO
	ENDDO                                   !!! over isp
	ENDDO                                   !!! over ior
C Relativistic transformations
	ELSEIF(ICUBI.EQ.3)THEN
	NDIM=2*(2*L+1)
      ALLOCATE(RMAT(NDIM,NDIM))
	DO IORBS=1,2
	DO IUPDN=1,2
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =3-IUPDN
	ENDIF
	IF(NROR.EQ.1.AND.IORBS.EQ.2)CYCLE
	IF(NRSP.EQ.1)IUPDN0=1
	IF(NRSP.EQ.2)IUPDN0=IUPDN
	DO K=-L,L
	IDIM1=K+L+1+(2*L+1)*(ISPIN1-1)
	DO M=-L,L
	IDIM=M+L+1+(2*L+1)*(ISPIN-1)
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+K+1 !!! (l,k m)
	RMAT(IDIM1,IDIM)=OCP(IU,IUPDN0,IORBS)
      ENDDO
      ENDDO
      ENDDO
      ENDDO
	CALL LIB_TRANSCUB(NDIM,-3,NDIM,-3,RMAT)
	DO IORBS=1,2
	DO IUPDN=1,2
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =3-IUPDN
	ENDIF
	IF(NROR.EQ.1.AND.IORBS.EQ.2)CYCLE
	IF(NRSP.EQ.1)IUPDN0=1
	IF(NRSP.EQ.2)IUPDN0=IUPDN
	DO K=-L,L
	IDIM1=K+L+1+(2*L+1)*(ISPIN1-1)
	DO M=-L,L
	IDIM=M+L+1+(2*L+1)*(ISPIN-1)
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+K+1 !!! (l,k m)
	OCS(IU,IUPDN0,IORBS)=RMAT(IDIM1,IDIM)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	DEALLOCATE(RMAT)
	ENDIF
C Memory deallocations
      DEALLOCATE(OCP,OCR)
      END



      SUBROUTINE HUB_WRITEREP(OCS,NWIG,NSPIN,NORBS,
     &           NWSP,NWOR,L,ICUBC,IRE,ICHAN)
************************************************************
*  Stores density matrices in a particular representation  *
************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
C Passed arrays
      COMPLEX*16 OCS(NWIG,2,2)
C Allocatable arrays
	COMPLEX*16, ALLOCATABLE :: OCP(:,:,:),RMAT(:,:)
C Local arrays
      COMPLEX*16 TS(7,-3:3,0:3)
      CHARACTER TRE(2)*4,TSP(2,2)*5,LIB_TDP*10
     &   ,TCUBC(-3:3,0:3,2)*10,TPR(-3:3,-3:3)*10
     &   ,TRELC(-3:3,2,0:3)*10
      LOGICAL FIRST
      SAVE TCUBC,TRELC,TS
      DATA PI/3.141592653589793D0/,FIRST/.TRUE./
     &   ,TRE/'REAL','IMAG'/,TSP/'Up-Up','Dn-Dn','Up-Dn','Dn-Up'/
      IF(L.GT.3)
     &CALL FULLSTOP('<HUB_WRITEREP>: L > 3 not allowed!')
C Initialize arrays
      IF(FIRST)THEN 
	CALL LIB_INTCUBC(TCUBC)
      CALL LIB_INTRELC(TRELC)
      CALL LIB_TRANSS(TS)
      FIRST=.FALSE.
      ENDIF
C Memory allocations      
	ALLOCATE(OCP(NWIG,2,2))
C  TRANSFORM TO CUBIC HARMONICS IF REQUIRED
	IF(ICUBC.EQ.1)THEN
	DO IORBS=1,NORBS
	DO IUPDN=1,NSPIN
	DO MX1=-L,L
	DO MX =-L,L
      IUX=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+MX)+L+MX1+1  !  (l,m' m) packed
	OCP(IUX,IUPDN,IORBS)=(0.D0,0.D0)
	DO MY1=-L,L
	DO MY =-L,L
      IUY=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+MY)+L+MY1+1  !  (l,m' m) packed
      OCP(IUX,IUPDN,IORBS)=OCP(IUX,IUPDN,IORBS)+
     &CONJG(TS(MX1+L+1,MY1,L))*OCS(IUY,IUPDN,IORBS)*TS(MX+L+1,MY,L)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ELSEIF(ICUBC.EQ.2)THEN
	DO IORBS=1,NORBS
	DO IUPDN=1,NSPIN
	DO M1=-L,L
	DO M=-L,L
      IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M1+1     !  (l,m' m) packed
	OCP(IU,IUPDN,IORBS)=OCS(IU,IUPDN,IORBS)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C Relativistic transformations
	ELSEIF(ICUBC.EQ.3)THEN
	NDIM=2*(2*L+1)
      ALLOCATE(RMAT(NDIM,NDIM))
	DO IORBS=1,2
	DO IUPDN=1,2
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =3-IUPDN
	ENDIF
	IF(NORBS.EQ.1.AND.IORBS.EQ.2)CYCLE
	IF(NSPIN.EQ.1)IUPDN0=1
	IF(NSPIN.EQ.2)IUPDN0=IUPDN
	DO K=-L,L
	IDIM1=K+L+1+(2*L+1)*(ISPIN1-1)
	DO M=-L,L
	IDIM=M+L+1+(2*L+1)*(ISPIN-1)
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+K+1 !!! (l,k m)
	RMAT(IDIM1,IDIM)=OCS(IU,IUPDN0,IORBS)
      ENDDO
      ENDDO
      ENDDO
      ENDDO
	CALL LIB_TRANSCUB(NDIM,+3,NDIM,+3,RMAT)
	DO IORBS=1,2
	DO IUPDN=1,2
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =3-IUPDN
	ENDIF
	IF(NORBS.EQ.1.AND.IORBS.EQ.2)CYCLE
	IF(NSPIN.EQ.1)IUPDN0=1
	IF(NSPIN.EQ.2)IUPDN0=IUPDN
	DO K=-L,L
	IDIM1=K+L+1+(2*L+1)*(ISPIN1-1)
	DO M=-L,L
	IDIM=M+L+1+(2*L+1)*(ISPIN-1)
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+K+1 !!! (l,k m)
	OCP(IU,IUPDN0,IORBS)=RMAT(IDIM1,IDIM)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	DEALLOCATE(RMAT)
	ENDIF
C  WRITE REAL/IMAG PARTS SEPARATELY
	DO IORBS=1,NWOR                       !!! over iorbs
	DO IUPDN=1,NWSP                       !!! over iupdn
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =3-IUPDN
	ENDIF
	DO I=1,IRE                             !!! over re/im
	IF(L.EQ.0.AND.(ICUBC.EQ.1.OR.ICUBC.EQ.2))
     &WRITE(ICHAN,10110)(TCUBC(M,L,ICUBC),M=-L,L),TRE(I),
     &TSP(IUPDN,IORBS)
	IF(L.EQ.1.AND.(ICUBC.EQ.1.OR.ICUBC.EQ.2))
     &WRITE(ICHAN,10120)(TCUBC(M,L,ICUBC),M=-L,L),TRE(I),
     &TSP(IUPDN,IORBS)
	IF(L.EQ.2.AND.(ICUBC.EQ.1.OR.ICUBC.EQ.2))
     &WRITE(ICHAN,10130)(TCUBC(M,L,ICUBC),M=-L,L),TRE(I),
     &TSP(IUPDN,IORBS)
	IF(L.EQ.3.AND.(ICUBC.EQ.1.OR.ICUBC.EQ.2))
     &WRITE(ICHAN,10140)(TCUBC(M,L,ICUBC),M=-L,L),TRE(I),
     &TSP(IUPDN,IORBS)
	IF(L.EQ.0.AND.ICUBC.EQ.3)
     &WRITE(ICHAN,10150)(TRELC(M,ISPIN,L),M=-L,L),TRE(I)
	IF(L.EQ.1.AND.ICUBC.EQ.3)
     &WRITE(ICHAN,10160)(TRELC(M,ISPIN,L),M=-L,L),TRE(I)
	IF(L.EQ.2.AND.ICUBC.EQ.3)
     &WRITE(ICHAN,10170)(TRELC(M,ISPIN,L),M=-L,L),TRE(I)
	IF(L.EQ.3.AND.ICUBC.EQ.3)
     &WRITE(ICHAN,10180)(TRELC(M,ISPIN,L),M=-L,L),TRE(I)
	DO M1=-L,L
	DO M=-L,L
      IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M1+1     !  (l,m' m) packed
      IF(I.EQ.1)TPAR=DREAL(OCP(IU,IUPDN,IORBS))
      IF(I.EQ.2)TPAR=DIMAG(OCP(IU,IUPDN,IORBS))
      IF(ABS(TPAR).GT.1.D-07)TPR(M1,M)=LIB_TDP(TPAR,1.D-07)
      IF(ABS(TPAR).LE.1.D-07)TPR(M1,M)=' 0.0000000'
	ENDDO
	ENDDO
	DO M1=-L,L
	IF(L.EQ.0.AND.(ICUBC.EQ.1.OR.ICUBC.EQ.2))
     &WRITE(ICHAN,10210)(TPR(M1,M),M=-L,L),TCUBC(M1,L,ICUBC)
	IF(L.EQ.1.AND.(ICUBC.EQ.1.OR.ICUBC.EQ.2))
     &WRITE(ICHAN,10220)(TPR(M1,M),M=-L,L),TCUBC(M1,L,ICUBC)
	IF(L.EQ.2.AND.(ICUBC.EQ.1.OR.ICUBC.EQ.2))
     &WRITE(ICHAN,10230)(TPR(M1,M),M=-L,L),TCUBC(M1,L,ICUBC)
	IF(L.EQ.3.AND.(ICUBC.EQ.1.OR.ICUBC.EQ.2))
     &WRITE(ICHAN,10240)(TPR(M1,M),M=-L,L),TCUBC(M1,L,ICUBC)
	IF(L.EQ.0.AND.ICUBC.EQ.3)
     &WRITE(ICHAN,10210)(TPR(M1,M),M=-L,L),TRELC(M1,ISPIN1,L)
	IF(L.EQ.1.AND.ICUBC.EQ.3)
     &WRITE(ICHAN,10220)(TPR(M1,M),M=-L,L),TRELC(M1,ISPIN1,L)
	IF(L.EQ.2.AND.ICUBC.EQ.3)
     &WRITE(ICHAN,10230)(TPR(M1,M),M=-L,L),TRELC(M1,ISPIN1,L)
	IF(L.EQ.3.AND.ICUBC.EQ.3)
     &WRITE(ICHAN,10240)(TPR(M1,M),M=-L,L),TRELC(M1,ISPIN1,L)
	ENDDO
	ENDDO                                  !!! over re/im
	ENDDO                                  !!! over iupdn
	ENDDO                                  !!! over iorbs
C Memory deallocations
      DEALLOCATE(OCP)
10110 FORMAT(1X,1(A10,2X),2X,A4,',',A5)
10120 FORMAT(1X,3(A10,2X),2X,A4,',',A5)
10130 FORMAT(1X,5(A10,2X),2X,A4,',',A5)
10140 FORMAT(1X,7(A10,2X),2X,A4,',',A5)
10150 FORMAT(1X,1(A10,2X),2X,A4)
10160 FORMAT(1X,3(A10,2X),2X,A4)
10170 FORMAT(1X,5(A10,2X),2X,A4)
10180 FORMAT(1X,7(A10,2X),2X,A4)
10210 FORMAT(1X,1(A10,2X),2X,A10)
10220 FORMAT(1X,3(A10,2X),2X,A10)
10230 FORMAT(1X,5(A10,2X),2X,A10)
10240 FORMAT(1X,7(A10,2X),2X,A10)
      END