      SUBROUTINE IMP_COMBREP(L,IATOM,IRUN,NDEG,MSPIN,NREP,LREP,KDREP)
**********************************************************
*  Prepares combinatorial arrays
**********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                    !!! from setup
      USE COM_CONTROL ,ONLY: LIFT,LMTO,IDMF                             !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS,ILSB            !!! from readini
	USE COM_IMPDAT  ,ONLY: NRUNIMP,KSTATES
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                            !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER LREP(2*(2*L+1)),KDREP(2*(2*L+1))
C Allocatable Arrays
	INTEGER, ALLOCATABLE :: MREP(:)
	INTEGER, ALLOCATABLE :: LCFG(:)
	INTEGER, ALLOCATABLE :: IPCF(:)
	INTEGER, ALLOCATABLE :: IPRF(:)
	INTEGER, ALLOCATABLE :: IPNF(:)
	INTEGER, ALLOCATABLE :: IPNF0(:)
	INTEGER, ALLOCATABLE :: IPNFP1(:)
	INTEGER, ALLOCATABLE :: LREP0(:)
	INTEGER, ALLOCATABLE :: LREP1(:)
	INTEGER, ALLOCATABLE :: LREP2(:)
	INTEGER, ALLOCATABLE :: KDR00(:)
	INTEGER, ALLOCATABLE :: KDR12(:)
	REAL*8, ALLOCATABLE :: COMB(:,:)
	REAL*8, ALLOCATABLE :: COMR(:)
      DATA PI/3.141592653589793D0/
      CALL ABORTNOW()
	ISORT=IS(IATOM)
	NDIM=2*(2*L+1)
	NDEG=0 ! this is total degeneracy
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).NE.0)NDEG=NDEG+1
	ENDDO
C COMBINATORICS
	ALLOCATE(COMB(0:NDEG,0:NDEG))
	CALL LIB_GETCOMB(COMB,NDEG)
C Count # of representations as non-equivalent elements of KSTATES pointer
	IREP0=0
	IREP1=0
	IREP2=0
	DO IPOS=1,NDIM
	ISUB0=0
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.IPOS)ISUB0=ISUB0+1
	ENDDO
	ISUB1=0
	DO IDIM=1,NDIM/2
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.IPOS)ISUB1=ISUB1+1
	ENDDO
	ISUB2=0
	DO IDIM=NDIM/2+1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.IPOS)ISUB2=ISUB2+1
	ENDDO
	IF(ISUB0.NE.0)IREP0=IREP0+1
	IF(ISUB1.NE.0)IREP1=IREP1+1
	IF(ISUB2.NE.0)IREP2=IREP2+1
	ENDDO
	NREP0=IREP0
	NREP1=IREP1
	NREP2=IREP2
	ALLOCATE(LREP0(NREP0))
	ALLOCATE(LREP1(NREP1))
	ALLOCATE(LREP2(NREP2))
	ALLOCATE(KDR00(NDIM))
	ALLOCATE(KDR12(NDIM))
	DO IDIM=1,NDIM
	KDR00(IDIM)=-1
	KDR12(IDIM)=-1
	ENDDO
C Find degeneracies of each sublevel
	IREP0=0
	IREP1=0
	IREP2=0
	DO IPOS=1,NDIM
	ISUB0=0
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.IPOS)ISUB0=ISUB0+1
	ENDDO
	IF(ISUB0.NE.0)THEN
	IREP0=IREP0+1
	LREP0(IREP0)=ISUB0
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.IPOS)KDR00(IDIM)=IREP0
	ENDDO
	ENDIF
	ISUB1=0
	DO IDIM=1,NDIM/2
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.IPOS)ISUB1=ISUB1+1
	ENDDO
	IF(ISUB1.NE.0)THEN
	IREP1=IREP1+1
	LREP1(IREP1)=ISUB1
	DO IDIM=1,NDIM/2
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.IPOS)KDR12(IDIM)=IREP1
	ENDDO
	ENDIF
	ISUB2=0
	DO IDIM=NDIM/2+1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.IPOS)ISUB2=ISUB2+1
	ENDDO
	IF(ISUB2.NE.0)THEN
	IREP2=IREP2+1
	LREP2(IREP2)=ISUB2
	DO IDIM=NDIM/2+1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.IPOS)KDR12(IDIM)=IREP2
	ENDDO
	ENDIF
	ENDDO
C Check full degeneracy
	IDEG=0
	DO IREP0=1,NREP0
	IDEG=IDEG+LREP0(IREP0)
	ENDDO
	IF(IDEG.NE.NDEG)
     &CALL FULLSTOP('Wrong KSTATES pointer for this solver')
	IDEG=0
	DO IREP1=1,NREP1
	IDEG=IDEG+LREP1(IREP1)
	ENDDO
	DO IREP2=1,NREP2
	IDEG=IDEG+LREP2(IREP2)
	ENDDO
	IF(IDEG.NE.NDEG)
     &CALL FULLSTOP('Wrong KSTATES pointer for this solver')
C Check if spin polarization is allowed
	IF(NREP1.EQ.NREP2)MSPIN=NSPIN
	IF(NREP1.NE.NREP2)MSPIN=1      ! switch off spin polarization
	IF(NREP1.EQ.NREP2)THEN         ! check again
	DO IREP=1,NREP1
	IF(LREP1(IREP).NE.LREP2(IREP))MSPIN=1
	ENDDO
	ENDIF
	IF(MSPIN.EQ.NSPIN)NREP=(NREP1+NREP2)/2
	IF(MSPIN.NE.NSPIN)NREP=NREP0
	DO IREP=1,NREP
	IF(MSPIN.EQ.NSPIN.AND.NREP1.EQ.NREP2)
     &LREP(IREP)=(LREP1(IREP)+LREP2(IREP))/MSPIN
	IF(MSPIN.NE.NSPIN.OR .NREP1.NE.NREP2)
     &LREP(IREP)=LREP0(IREP)
	ENDDO
	DO IDIM=1,NDIM
	IF(MSPIN.EQ.NSPIN)
     &KDREP(IDIM)=KDR12(IDIM)
	IF(MSPIN.NE.NSPIN)
     &KDREP(IDIM)=KDR00(IDIM)
	ENDDO
C CONFIGURATIONS PER SPIN, Minimum: NDEG/2+1, Maximum 2**(NDEG/2)
	DO ISPIN=1,MSPIN
	NCNF=1
	DO IREP=1,NREP
	NCNF=NCNF*(LREP(IREP)+1)
	ENDDO
	ENDDO
	IF(MSPIN.EQ.1)NCNF0=1
	IF(MSPIN.EQ.2)NCNF0=NCNF
C CONFIGURATIONS, Minimum: NDEG/2+1, Maximum 2**(NDEG/2)
	ALLOCATE(MREP(0:NREP))
	MREP(0)=1
	DO IREP=1,NREP
	MREP(IREP)=MREP(IREP-1)*(LREP(IREP)+1)
	ENDDO
C SORT BY NUMBERS OF ELECTRONS
	ALLOCATE(IPNF(NREP))
	ALLOCATE(IPNF0(NREP))
	ALLOCATE(IPNFP1(NREP))
	ALLOCATE(IPCF(NCNF))
	ALLOCATE(IPRF(NCNF))
	ALLOCATE(LCFG(0:NDEG/MSPIN))
C Looping over total allowed numbers of electrons in all sublevels
	ICFR=0
	DO IDEG=0,NDEG/MSPIN
	LCFG(IDEG)=0
C Configurations are numbered in one way from 1 to NCNF.
C Start looping over them
	DO ICNF=1,NCNF
C Find out numbers of electrons at each sublevel for given configuration ICNF
C Return array is IPNF(IREP) for spin channel
	CALL LIB_GETCONF(NREP,LREP,MREP,ICNF,NCNF,IPNF)
	NELC=0 ! count # of electrons for given configuration
	DO IREP=1,NREP
	NELC=NELC+IPNF(IREP)
	ENDDO
C if this configuration contains right number of electrons, count it
	IF(NELC.NE.IDEG)CYCLE 
	LCFG(IDEG)=LCFG(IDEG)+1
	ICFR=ICFR+1
C this pointer relates second-to-first numbering schemes for configurations
	IPCF(ICFR)=ICNF 
	ENDDO
	ENDDO
C CHECK ALGORITHM
	ICFR=0 ! second way of numbering configurations
C looping over allowed total numbers of electrons of the same spin
	DO IDEG=0,NDEG/MSPIN
C looping over configurations within given number of electrons of the same spin
	DO ICFG=1,LCFG(IDEG) 
	ICFR=ICFR+1
	ICNF=IPCF(ICFR) ! find out the configuration in first numbering scheme
C Find out array showing how many electrons are in each sublevel
	CALL LIB_GETCONF(NREP,LREP,MREP,ICNF,NCNF,IPNF) 
	NELC=0 ! count # of electrons
	DO IREP=1,NREP
	IF(IPNF(IREP).LT.0.OR.IPNF(IREP).GT.LREP(IREP))
     &CALL FULLSTOP('Wrong configuration')
	NELC=NELC+IPNF(IREP)
	ENDDO
	ENDDO
	IF(NELC.NE.IDEG)CALL FULLSTOP('# of electrons mismatch')
	ENDDO
C Set reciprocal pointer which related first-to-second numbering scheme for configirations
	DO ICNF=1,NCNF 
	IPRF(ICNF)=-1
	ENDDO
	DO ICFR=1,NCNF
	ICNF=IPCF(ICFR)
	IPRF(ICNF)=ICFR
	ENDDO
	DO ICNF=1,NCNF
	IF(IPRF(ICNF).EQ.-1)CALL FULLSTOP('Wrong reciprocal pointer')
	ENDDO
C Compute product of all combinatorics using second scheme of 
C numbering configurations
	ALLOCATE(COMR(NCNF))
	ICFR=0
	DO IDEG=0,NDEG/MSPIN
	DO ICFG=1,LCFG(IDEG)
	ICFR=ICFR+1
	ICNF=IPCF(ICFR)
	CALL LIB_GETCONF(NREP,LREP,MREP,ICNF,NCNF,IPNF)
	COMR(ICFR)=1.D0 
	DO IREP=1,NREP
	COMR(ICFR)=COMR(ICFR)*COMB(IPNF(IREP),LREP(IREP))
	ENDDO
	ENDDO
	ENDDO
C CHECK COMBINATORICS
	SUS=0.D0
	ICFR=0
	DO IDEG=0,NDEG/MSPIN
	SUM=0.D0
	DO ICFG=1,LCFG(IDEG)
	ICFR=ICFR+1
	SUM=SUM+COMR(ICFR)
	SUS=SUS+COMR(ICFR)
	ENDDO
	IF(ABS(SUM-COMB(IDEG,NDEG/MSPIN)).GT.1.D-07)
     &CALL FULLSTOP('Combinatorics mismatch')
	ENDDO
	IF(ABS(SUS-2.D0**(NDEG/MSPIN)).GT.1.D-07)
     &CALL FULLSTOP('Combinatorics mismatch')
C Memory Deallocations
	DEALLOCATE(LREP0,LREP1,LREP2,KDR00,KDR12,COMR,COMB)
	DEALLOCATE(MREP,IPNF,IPNF0,IPNFP1,IPCF,IPRF,LCFG)
      END