	SUBROUTINE IMP_CRFIRAT_COFS(NDEG,NREP,NSPIN,LREP,NCNF,NCNF0,
     &           ELOC,UPAR,GPAR,ZOCC,TPAR,SIGM0,SIGMI,ZMASS,PSIK,
     &           MRAT,WSIG,PSIG,KOCC,IERR)
***************************************************************
* Finds rational interpolation for self-energy, returns       *
* coefficients Wi and Pi which represents Sigma(w) as         *
* Sigma(w)=Sigma(oo)+Sum{i=1,M)Wi/(w-Pi)                      *
***************************************************************
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                       !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
C Passed arrays
	INTEGER LREP(NREP)
	REAL*8 ELOC(NREP,NSPIN),PSIK(NCNF,NCNF0),ZOCC(NSPIN)
     &      ,SIGM0(NREP,NSPIN),SIGMI(NREP,NSPIN),ZMASS(NREP,NSPIN)
      COMPLEX*16 WSIG(NDEG*NDEG,NREP,NSPIN),PSIG(NDEG*NDEG,NREP,NSPIN)
C Allocatable arrays
	INTEGER, ALLOCATABLE :: MREP(:)
	INTEGER, ALLOCATABLE :: MRATCRF(:,:)
	INTEGER, ALLOCATABLE :: LCFG(:)
	INTEGER, ALLOCATABLE :: IPCF(:)
	INTEGER, ALLOCATABLE :: IPRF(:)
	INTEGER, ALLOCATABLE :: IPNF(:)
	INTEGER, ALLOCATABLE :: IPNF0(:)
	INTEGER, ALLOCATABLE :: IPNFP1(:)
	REAL*8, ALLOCATABLE :: EATS(:,:)
	REAL*8, ALLOCATABLE :: ZTOT(:)
	REAL*8, ALLOCATABLE :: ZREP(:,:)
	REAL*8, ALLOCATABLE :: COMB(:,:)
	REAL*8, ALLOCATABLE :: COMR(:)
	REAL*8, ALLOCATABLE :: GMOM(:,:,:)
	REAL*8, ALLOCATABLE :: SMOM(:,:,:)
	REAL*8, ALLOCATABLE :: WGAT(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: OMGH(:)
	COMPLEX*16, ALLOCATABLE :: SIGH(:)
	COMPLEX*16, ALLOCATABLE :: OMGG(:)
	COMPLEX*16, ALLOCATABLE :: SIGG(:)
	COMPLEX*16, ALLOCATABLE :: ACOF(:)
	COMPLEX*16, ALLOCATABLE :: BCOF(:)
	COMPLEX*16, ALLOCATABLE :: APOL(:,:)
	COMPLEX*16, ALLOCATABLE :: CPOL(:)
	COMPLEX*16, ALLOCATABLE :: RPOL(:)
	COMPLEX*16, ALLOCATABLE :: BCOL(:)
	COMPLEX*16, ALLOCATABLE :: AMAT(:,:)
	COMPLEX*16, ALLOCATABLE :: BREN(:)
	COMPLEX*16, ALLOCATABLE :: WCOL(:)
	COMPLEX*16, ALLOCATABLE :: WMAT(:,:)
C Internal variables
	COMPLEX*16 DIM,CNUM,CDEN,CSIG,ZOMG,OMG0M,OMG0P,SIG0M,SIG0P
	DATA PI/3.141592653589793D0/,DIM/(0.D0,1.D0)/,EPSW/1.D-04/
     &    ,ACCU/1.D-06/,ISBMF/0/
C CONFIGURATIONS, Minimum: NDEG/2+1, Maximum 2**(NDEG/2)
	ALLOCATE(MREP(0:NREP))
	MREP(0)=1
	DO IREP=1,NREP
	MREP(IREP)=MREP(IREP-1)*(LREP(IREP)+1)
	ENDDO
C SORT BY NUMBERS OF ELECTRONS
	ALLOCATE(IPNF(NREP))
	ALLOCATE(IPNF0(NREP))
	ALLOCATE(IPCF(NCNF))
	ALLOCATE(IPRF(NCNF))
	ALLOCATE(LCFG(0:NDEG/NSPIN))
	ALLOCATE(IPNFP1(NREP))
C Looping over total allowed numbers of electrons in all sublevels
	ICFR=0
	DO IDEG=0,NDEG/NSPIN
	LCFG(IDEG)=0
C Configurations are numbered in one way from 1 to NCNF.
C Start looping over them
	DO ICNF=1,NCNF
C Find out numbers of electrons at each sublevel for given configuration ICNF
C Return array is IPNF(IREP) for spin channel
	CALL LIB_GETCONF(NREP,LREP,MREP,ICNF,NCNF,IPNF)
	NELC=0 ! count # of electrons for given configuration
	DO IREP=1,NREP
	NELC=NELC+IPNF(IREP)
	ENDDO
C if this configuration contains right number of electrons, count it
	IF(NELC.NE.IDEG)CYCLE 
	LCFG(IDEG)=LCFG(IDEG)+1
	ICFR=ICFR+1
C this pointer relates second-to-first numbering schemes for configurations
	IPCF(ICFR)=ICNF 
	ENDDO
	ENDDO
C CHECK ALGORITHM
	ICFR=0 ! second way of numbering configurations
C looping over allowed total numbers of electrons of the same spin
	DO IDEG=0,NDEG/NSPIN
C looping over configurations within given number of electrons of the same spin
	DO ICFG=1,LCFG(IDEG) 
	ICFR=ICFR+1
	ICNF=IPCF(ICFR) ! find out the configuration in first numbering scheme
C Find out array showing how many electrons are in each sublevel
	CALL LIB_GETCONF(NREP,LREP,MREP,ICNF,NCNF,IPNF) 
	NELC=0 ! count # of electrons
	DO IREP=1,NREP
	IF(IPNF(IREP).LT.0.OR.IPNF(IREP).GT.LREP(IREP))
     &CALL FULLSTOP('Wrong configuration')
	NELC=NELC+IPNF(IREP)
	ENDDO
	ENDDO
	IF(NELC.NE.IDEG)CALL FULLSTOP('# of electrons mismatch')
	ENDDO
C Set reciprocal pointer which related first-to-second numbering scheme for configirations
	DO ICNF=1,NCNF 
	IPRF(ICNF)=-1
	ENDDO
	DO ICFR=1,NCNF
	ICNF=IPCF(ICFR)
	IPRF(ICNF)=ICFR
	ENDDO
	DO ICNF=1,NCNF
	IF(IPRF(ICNF).EQ.-1)CALL FULLSTOP('Wrong reciprocal pointer')
	ENDDO
C *******************************************
C Compute product of all combinatorics using second scheme of 
C numbering configurations
	ALLOCATE(COMR(NCNF))
	ALLOCATE(COMB(0:NDEG,0:NDEG))
	CALL LIB_GETCOMB(COMB,NDEG)
	ICFR=0
	DO IDEG=0,NDEG/NSPIN
	DO ICFG=1,LCFG(IDEG)
	ICFR=ICFR+1
	ICNF=IPCF(ICFR)
	CALL LIB_GETCONF(NREP,LREP,MREP,ICNF,NCNF,IPNF)
	COMR(ICFR)=1.D0 
	DO IREP=1,NREP
	COMR(ICFR)=COMR(ICFR)*COMB(IPNF(IREP),LREP(IREP))
	ENDDO
	ENDDO
	ENDDO
C CHECK COMBINATORICS
	SUS=0.D0
	ICFR=0
	DO IDEG=0,NDEG/NSPIN
	SUM=0.D0
	DO ICFG=1,LCFG(IDEG)
	ICFR=ICFR+1
	SUM=SUM+COMR(ICFR)
	SUS=SUS+COMR(ICFR)
	ENDDO
	IF(ABS(SUM-COMB(IDEG,NDEG/NSPIN)).GT.1.D-07)
     &CALL FULLSTOP('Combinatorics mismatch')
	ENDDO
	IF(ABS(SUS-2.D0**(NDEG/NSPIN)).GT.1.D-07)
     &CALL FULLSTOP('Combinatorics mismatch')
C *************************************
C Many-body atomic levels EATS numbered using second scheme of numbering configurations
	IF(NSPIN.EQ.2.AND.NCNF.NE.NCNF0)CALL FULLSTOP('nCnf.ne.nCnf0')
	IF(NSPIN.EQ.1.AND.NCNF0.NE.1)CALL FULLSTOP('nCnf0 should be 1')
	ALLOCATE(EATS(NCNF,NCNF0))
	ICFR=0
	DO IDEG=0,NDEG/NSPIN
	DO ICFG=1,LCFG(IDEG)
	ICFR=ICFR+1
	ICNF=IPCF(ICFR)
	CALL LIB_GETCONF(NREP,LREP,MREP,ICNF,NCNF,IPNF)
	ICFR0=0
	DO IDEG0=0,NDEG/NSPIN
	DO ICFG0=1,LCFG(IDEG0)
	ICFR0=ICFR0+1
	IF(NSPIN.EQ.1.AND.ICFR0.GT.1)CYCLE
	ICNF0=IPCF(ICFR0)
	CALL LIB_GETCONF(NREP,LREP,MREP,ICNF0,NCNF,IPNF0)
	EATS(ICFR,ICFR0)=0.D0
	NELC =0
	NELC0=0
	DO IREP=1,NREP
	IF(NSPIN.EQ.1.AND.IPNF0(IREP).NE.0)CALL FULLSTOP('Ipnf0.ne.0')
	EATS(ICFR,ICFR0)=EATS(ICFR,ICFR0)+
     &ELOC(IREP,1)*DBLE(IPNF(IREP))+ELOC(IREP,NSPIN)*DBLE(IPNF0(IREP))
	NELC =NELC +IPNF(IREP)
	NELC0=NELC0+IPNF0(IREP)
	ENDDO
	IF(NELC .NE.IDEG )CALL FULLSTOP('# of electrons mismatch')
	IF(NELC0.NE.IDEG0)CALL FULLSTOP('# of electrons mismatch')
	ITOT=IDEG+IDEG0 ! total number of electrons
	IF(NSPIN.EQ.1)DIUP=DBLE(ITOT)/2.D0
	IF(NSPIN.EQ.1)DIDN=DBLE(ITOT)/2.D0
	IF(NSPIN.EQ.2)DIUP=DBLE(IDEG)
	IF(NSPIN.EQ.2)DIDN=DBLE(IDEG0)
	EATS(ICFR,ICFR0)=EATS(ICFR,ICFR0)+
     &UPAR*DBLE(ITOT*(ITOT-1))/2.D0-
     &GPAR*    (DIUP*(DIUP-1))/2.D0-
     &GPAR*    (DIDN*(DIDN-1))/2.D0
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C CURRENT DENSITY FROM PROBABILITIES
	ALLOCATE(ZTOT(NSPIN))
	ALLOCATE(ZREP(NREP,NSPIN))
	DO ISPIN=1,NSPIN
	ZTOT(ISPIN)=0.D0
	DO IREP=1,NREP
	ZREP(IREP,ISPIN)=0.D0
	ICFR=0
	DO IDEG=0,NDEG/NSPIN
	DO ICFG=1,LCFG(IDEG)
	ICFR=ICFR+1
	ICNF=IPCF(ICFR)
	CALL LIB_GETCONF(NREP,LREP,MREP,ICNF,NCNF,IPNF)
	ICFR0=0
	DO IDEG0=0,NDEG/NSPIN
	DO ICFG0=1,LCFG(IDEG0)
	ICFR0=ICFR0+1
	IF(NSPIN.EQ.1.AND.ICFR0.GT.1)CYCLE
	IF(ISPIN.EQ.1)
     &ZREP(IREP,ISPIN)=ZREP(IREP,ISPIN)+DBLE(IPNF(IREP))*
     &COMR(ICFR)*COMR(ICFR0)*PSIK(ICFR,ICFR0)**2
	IF(ISPIN.EQ.2)
     &ZREP(IREP,ISPIN)=ZREP(IREP,ISPIN)+DBLE(IPNF(IREP))*
     &COMR(ICFR0)*COMR(ICFR)*PSIK(ICFR0,ICFR)**2
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ZTOT(ISPIN)=ZTOT(ISPIN)+ZREP(IREP,ISPIN)
	ENDDO
	ENDDO
C MOMENTS OF THE ATOMIC GREEN FUNCTION WITH PSIK-PROBABILITIES
	ALLOCATE(GMOM(0:10,NREP,NSPIN))
	ALLOCATE(SMOM(0:10,NREP,NSPIN))
	DO ISPIN=1,NSPIN            ! looping over spins
	DO IREP=1,NREP              ! looping over sublevels
	GMOM(0,IREP,ISPIN)=0.D0
	DO IMOM=1,10                ! looping over moments
	GMOM(IMOM,IREP,ISPIN)=0.D0
	ICFR=0
	DO IDEG=0,NDEG/NSPIN        ! looping over all configurations
	DO ICFG=1,LCFG(IDEG)        ! using second numbering scheme
	ICFR=ICFR+1
	ICNF=IPCF(ICFR)
C Find real occupancies for each sublevel within given configuration
	CALL LIB_GETCONF(NREP,LREP,MREP,ICNF,NCNF,IPNF)
C Increase occupancy of sublevel IREP by 1
	DO IREP1=1,NREP
	IPNFP1(IREP1)=IPNF(IREP1)
	ENDDO
	IPNFP1(IREP)=IPNFP1(IREP)+1
C Find out corresponding configuration number in the first numbering scheme
	CALL LIB_SETCONF(NREP,LREP,MREP,ICNFP1,NCNF,IPNFP1)
	ICFRP1=0 ! try to understand that we did not exceed the total allowed 
	IF(IPNF(IREP).NE.LREP(IREP))ICFRP1=IPRF(ICNFP1) ! number of electrons
C Set contribution to atomic Green function from this excitation
C the prefactor (N-n)/N comes because combinatorics we are defined as C(n,N) while
C they should be C(n,N-1) for excitation at a given sublevel.
	IF(ICFRP1.NE.0)THEN
	ICFR0=0
	DO IDEG0=0,NDEG/NSPIN
	DO ICFG0=1,LCFG(IDEG0)
	ICFR0=ICFR0+1
	IF(NSPIN.EQ.1.AND.ICFR0.GT.1)CYCLE
	IF(ISPIN.EQ.1)
     &GMOM(IMOM,IREP,ISPIN)=GMOM(IMOM,IREP,ISPIN)+
     &DBLE(LREP(IREP)-IPNF(IREP))/
     &DBLE(LREP(IREP))*COMR(ICFR)*COMR(ICFR0)*
     &(PSIK(ICFR,ICFR0)**2+PSIK(ICFRP1,ICFR0)**2)*
     &(EATS(ICFRP1,ICFR0)-EATS(ICFR,ICFR0))**(IMOM-1)
	IF(ISPIN.EQ.2)
     &GMOM(IMOM,IREP,ISPIN)=GMOM(IMOM,IREP,ISPIN)+
     &DBLE(LREP(IREP)-IPNF(IREP))/
     &DBLE(LREP(IREP))*COMR(ICFR0)*COMR(ICFR)*
     &(PSIK(ICFR0,ICFR)**2+PSIK(ICFR0,ICFRP1)**2)*
     &(EATS(ICFR0,ICFRP1)-EATS(ICFR0,ICFR))**(IMOM-1)
	ENDDO
	ENDDO
	ENDIF
	ENDDO
	ENDDO
	ENDDO                  !!! over moments
	ENDDO                  !!! over sublevels
	ENDDO                  !!! over spins
C MOMENTS OF THE ATOMIC SELF-ENERGY
	DO ISPIN=1,NSPIN
	DO IREP=1,NREP
	SMOM(0,IREP,ISPIN)=-ELOC(IREP,ISPIN)+GMOM(2,IREP,ISPIN) ! This is Sigma(inf) with density from SBMF
	SMOM(1,IREP,ISPIN)=GMOM(3,IREP,ISPIN)-GMOM(2,IREP,ISPIN)**2
	SMOM(2,IREP,ISPIN)=(GMOM(4,IREP,ISPIN)-2.D0*GMOM(2,IREP,ISPIN)*
     &                    GMOM(3,IREP,ISPIN)+GMOM(2,IREP,ISPIN)**3)
	DO IMOM=3,10
	SMOM(IMOM,IREP,ISPIN)=0.D0
	ENDDO
	ENDDO
	ENDDO
C COUNT NON-ZERO CONTRIBUTIONS
	ALLOCATE(WGAT(0:NDEG,0:NDEG,NREP,NSPIN))
	DO ISPIN=1,NSPIN       !!! over spins
	DO IREP=1,NREP         !!! over representations
	DO IEUP=0,NDEG/NSPIN
	DO IEDN=0,NDEG/NSPIN
	WGAT(IEUP,IEDN,IREP,ISPIN)=0.D0
	ENDDO
	ENDDO
	ICFR=0
	DO IDEG=0,NDEG/NSPIN        ! looping over all configurations
	DO ICFG=1,LCFG(IDEG)        ! using second numbering scheme
	ICFR=ICFR+1
	ICNF=IPCF(ICFR)
C Find real occupancies for each sublevel within given configuration
	CALL LIB_GETCONF(NREP,LREP,MREP,ICNF,NCNF,IPNF)
C Increase occupancy of sublevel IREP by 1
	DO IREP1=1,NREP
	IPNFP1(IREP1)=IPNF(IREP1)
	ENDDO
	IPNFP1(IREP)=IPNFP1(IREP)+1
C Find out corresponding configuration number in the first numbering scheme
	CALL LIB_SETCONF(NREP,LREP,MREP,ICNFP1,NCNF,IPNFP1)
	ICFRP1=0 ! try to understand that we did not exceed the total allowed 
	IF(IPNF(IREP).NE.LREP(IREP))ICFRP1=IPRF(ICNFP1) ! number of electrons
C Set contribution to atomic Green function from this excitation
C the prefactor (N-n)/N comes because combinatorics we are defined as C(n,N) while
C they should be C(n,N-1) for excitation at a given sublevel.
	IF(ICFRP1.NE.0)THEN
	ICFR0=0
	DO IDEG0=0,NDEG/NSPIN
	DO ICFG0=1,LCFG(IDEG0)
	ICFR0=ICFR0+1
	IF(NSPIN.EQ.1.AND.ICFR0.GT.1)CYCLE
	IF(ISPIN.EQ.1)
     &WGAT(IDEG,IDEG0,IREP,ISPIN)=WGAT(IDEG,IDEG0,IREP,ISPIN)+
     &DBLE(LREP(IREP)-IPNF(IREP))/
     &DBLE(LREP(IREP))*COMR(ICFR)*COMR(ICFR0)*
     &(PSIK(ICFR,ICFR0)**2+PSIK(ICFRP1,ICFR0)**2)
	IF(ISPIN.EQ.2)
     &WGAT(IDEG,IDEG0,IREP,ISPIN)=WGAT(IDEG,IDEG0,IREP,ISPIN)+
     &DBLE(LREP(IREP)-IPNF(IREP))/
     &DBLE(LREP(IREP))*COMR(ICFR0)*COMR(ICFR)*
     &(PSIK(ICFR0,ICFR)**2+PSIK(ICFR0,ICFRP1)**2)
	ENDDO
	ENDDO
	ENDIF
	ENDDO
	ENDDO
	ENDDO                      !!! over representatons
	ENDDO                      !!! over spins
C START LOOPING OVER REPRESENTATONS
	ALLOCATE(MRATCRF(NREP,NSPIN))
	DO 2000 ISPIN=1,NSPIN      !!! over representatons
	DO 1000 IREP=1,NREP        !!! over spins
C Count Hubbard poles
	NHUB=0
	DO IEUP=0,NDEG/NSPIN
	DO IEDN=0,NDEG/NSPIN
	IF(NSPIN.EQ.1.AND.IEDN.GT.0)CYCLE
	IF(WGAT(IEUP,IEDN,IREP,ISPIN).GT.EPSW)NHUB=NHUB+1
	ENDDO
	ENDDO
	IF(NHUB.EQ.0)CALL FULLSTOP('Nhub=0, Check Psik')
	IF(NHUB.GT.NDEG)CALL FULLSTOP('Nhub>Ndeg')
C Account for filled or empty case
	IF(NHUB.EQ.1)MRAT=0
	IF(NHUB.EQ.1)MRATCRF(IREP,ISPIN)=0
	IF(NHUB.EQ.1)GOTO 1000
C Memory Allocations
	ALLOCATE(OMGH(NHUB))
	ALLOCATE(SIGH(NHUB))
C Poistions of Hubbard bands
	IHUB=0
	DO IEUP=0,NDEG/NSPIN
	DO IEDN=0,NDEG/NSPIN
	ITOT=IEUP+IEDN
	IF(ISPIN.EQ.1)IDEG=IEUP
	IF(ISPIN.EQ.2)IDEG=IEDN
	IF(NSPIN.EQ.1.AND.IEDN.GT.0)CYCLE
	IF(WGAT(IEUP,IEDN,IREP,ISPIN).LE.EPSW)CYCLE
	IHUB=IHUB+1
	OMGH(IHUB)=
     &DCMPLX(ELOC(IREP,ISPIN)+UPAR*DBLE(ITOT)-GPAR*DBLE(IDEG),-0.0D0)
	ENDDO
	ENDDO
C Self-energy at those positions
	DO IHUB=1,NHUB
	SIGH(IHUB)=OMGH(IHUB)-ELOC(IREP,ISPIN)
	ENDDO
C Select the pole which is closest to zero
	OMGH0=ABS(DREAL(OMGH(1)))
	DO IHUB=1,NHUB-1
	OMGH0=MIN(OMGH0,ABS(DREAL(OMGH(IHUB))))
	ENDDO
	IHUBH0=0
	DO IHUB=1,NHUB-1
	IF(ABS(OMGH0-ABS(DREAL(OMGH(IHUB)))).LE.1.D-10)IHUBH0=IHUB
	ENDDO
	IF(IHUBH0.EQ.0)CALL FULLSTOP('IHUBH0=0')
C ZEROES OF THE ATOMIC GREEN FUNCTION
	ALLOCATE(OMGG(NHUB-1))
	ALLOCATE(SIGG(NHUB-1))
	ALLOCATE(APOL(0:NHUB-1,NHUB))
	ALLOCATE(CPOL(0:NHUB-1))
	ALLOCATE(RPOL(NHUB-1))
C Singularities at Hubbard bands
	DO IHUB=1,NHUB
	IROT=0
	DO JHUB=1,NHUB
	IF(JHUB.EQ.IHUB)CYCLE
	IROT=IROT+1
	RPOL(IROT)=OMGH(JHUB)
	ENDDO
	MPOL=NHUB-1
C Coefficients
	CALL LIB_PCOEFS(MPOL,RPOL,APOL(0,IHUB))
	ENDDO
C Convolve with weights
	DO IPOL=0,NHUB-1
	CPOL(IPOL)=(0.D0,0.D0)
	IHUB=0
	DO IEUP=0,NDEG/NSPIN
	DO IEDN=0,NDEG/NSPIN
	IF(WGAT(IEUP,IEDN,IREP,ISPIN).LE.EPSW)CYCLE
	IHUB=IHUB+1
	CPOL(IPOL)=CPOL(IPOL)+WGAT(IEUP,IEDN,IREP,ISPIN)*APOL(IPOL,IHUB)
	ENDDO
	ENDDO
	ENDDO
C Find zeroes now
	CALL LIB_PZEROS(NHUB-1,CPOL,OMGG,1.D-14,IFAIL)
	IF(IFAIL.NE.0)WRITE(IUT,*)'Zeroes fail'
C Self-energy is infinite at those points, reverse is 0
	DO IHUB=1,NHUB-1
	SIGG(IHUB)=(0.D0,0.D0)
	ENDDO
C Check atomic Green function
	DO IHUB=1,NHUB-1
	GATM=0.D0
	DO IEUP=0,NDEG/NSPIN
	DO IEDN=0,NDEG/NSPIN
	ITOT=IEUP+IEDN
	IF(ISPIN.EQ.1)IDEG=IEUP
	IF(ISPIN.EQ.2)IDEG=IEDN
	IF(WGAT(IEUP,IEDN,IREP,ISPIN).LE.EPSW)CYCLE
	DENM=
     &OMGG(IHUB)-(ELOC(IREP,ISPIN)+UPAR*DBLE(ITOT)-GPAR*DBLE(IDEG))
	IF(ABS(DENM).LE.1.D-10)CYCLE
	GATM=GATM+WGAT(IEUP,IEDN,IREP,ISPIN)/DENM
	ENDDO
	ENDDO
	IF(ABS(GATM).GT.ACCU)WRITE(IUT,*)'Wrong zeroes',GATM,OMGG(IHUB)
	ENDDO
C Select the pole which is closest to zero
	OMGG0=ABS(DREAL(OMGG(1)))
	DO IHUB=1,NHUB-1
	OMGG0=MIN(OMGG0,ABS(DREAL(OMGG(IHUB))))
	ENDDO
	IHUBG0=0
	DO IHUB=1,NHUB-1
	IF(ABS(OMGG0-ABS(DREAL(OMGG(IHUB)))).LE.1.D-10)IHUBG0=IHUB
	ENDDO
	IF(IHUBG0.EQ.0)CALL FULLSTOP('IHUBG0=0')
C Check mass renormalization
	IF(ZMASS(IREP,ISPIN).GT.1.D-04)ZMAS1=1.D0/ZMASS(IREP,ISPIN)-1.D0
	IF(ZMASS(IREP,ISPIN).LE.1.D-04)ZMAS1=1.D+04-1.D0
C Set self energies at two points closest to zero
	OMG0M=-TPAR*ZMASS(IREP,ISPIN)
	OMG0P=+TPAR*ZMASS(IREP,ISPIN)
	IF(DREAL(OMGH(IHUBH0)).LT.0.D0)OMG0P=(0.D0,0.D0)
	IF(DREAL(OMGH(IHUBH0)).GE.0.D0)OMG0M=(0.D0,0.D0)
	SIG0M=-ZMAS1*OMG0M+SIGM0(IREP,ISPIN)
	SIG0P=-ZMAS1*OMG0P+SIGM0(IREP,ISPIN)
C Imaginary axis case
	OMG0M=(0.D0,0.D0)
	OMG0P=TPAR*DIM
	SIG0M=-ZMAS1*OMG0M+SIGM0(IREP,ISPIN)
	SIG0P=-ZMAS1*OMG0P+SIGM0(IREP,ISPIN)
C Do not decide which information to throw away
C	IF(OMGG0.LT.OMGH0)IHUBH0=0 ! Throw Green function zero
C	IF(OMGG0.GE.OMGH0)IHUBG0=0 ! Throw Atomic Pole
C Always throw away Green function pole
	IHUBH0=0
C Check Mott insulating regime
	IF(ZMASS(IREP,ISPIN).GT.1.D-04)IMOTT=0 ! Metalic regime
	IF(ZMASS(IREP,ISPIN).LE.1.D-04)IMOTT=1 ! Insulating regime
	IF(ZMASS(IREP,ISPIN).LE.1.D-04)IHUBH0=0 ! Account for all zeroes of Green function
	IF(ZMASS(IREP,ISPIN).LE.1.D-04)IHUBG0=0 ! Account for all Hubbard bands
	IF(IMOTT.EQ.0)MRAT=NHUB
	IF(IMOTT.EQ.1)MRAT=NHUB-1
	IF(IMOTT.EQ.0)NCON=2*NHUB+2
	IF(IMOTT.EQ.1)NCON=2*NHUB
C FIND INTERPOLATION COEFFICIENTS
	ALLOCATE(ACOF(0:MRAT))
	ALLOCATE(BCOF(0:MRAT))
	DO IRAT=0,MRAT
	ACOF(IRAT)=(0.D0,0.D0)
	BCOF(IRAT)=(0.D0,0.D0)
	ENDDO
	ALLOCATE(AMAT(NCON,2*MRAT+2))
	ALLOCATE(BCOL(NCON))
	DO ICON=1,NCON
	BCOL(ICON)=0.D0
	DO IRAT=1,2*MRAT+2
	AMAT(ICON,IRAT)=0.D0
	ENDDO
	ENDDO
C Count conditions
	ICON=0
C 1. Poles of atomic Green function except the one which is closest to w=0
	DO IHUB=1,NHUB
	IF(IHUB.EQ.IHUBH0)CYCLE
	ICON=ICON+1
	DO IRAT=0,MRAT
	AMAT(ICON,IRAT+1)=OMGH(IHUB)**IRAT
	ENDDO
	DO IRAT=0,MRAT
	AMAT(ICON,MRAT+1+IRAT+1)=-SIGH(IHUB)*OMGH(IHUB)**IRAT
	ENDDO
	BCOL(ICON)=(0.D0,0.D0)
	ENDDO
C 2. Zeroes of atomic Green functions except the one which is closest to w=0
	DO IHUB=1,NHUB-1
	IF(IHUB.EQ.IHUBG0)CYCLE
	ICON=ICON+1
	DO IRAT=0,MRAT
	AMAT(ICON,IRAT+1)=SIGG(IHUB)*OMGG(IHUB)**IRAT
	ENDDO
	DO IRAT=0,MRAT
	AMAT(ICON,MRAT+1+IRAT+1)=-OMGG(IHUB)**IRAT
	ENDDO
	BCOL(ICON)=(0.D0,0.D0)
	ENDDO
C 3. b0 is always 1
	ICON=ICON+1
	AMAT(ICON,MRAT+1+1)=(1.D0,0.D0)   ! b0=1
	BCOL(ICON)=(1.D0,0.D0)
C 4. Sigma(infinity) limit for metallic case only
	IF(IMOTT.EQ.0)THEN
	ICON=ICON+1
	AMAT(ICON,MRAT+1)=(1.D0,0.D0)
	AMAT(ICON,MRAT+1+MRAT+1)=-DCMPLX(SIGMI(IREP,ISPIN),0.D0)
	BCOL(ICON)=(0.D0,0.D0)
	ENDIF
C 5. SBMF for metallic case with Sigma(0) and Slope(0)
	IF(IMOTT.EQ.0.AND.ISBMF.EQ.0)THEN
	ICON=ICON+1
	AMAT(ICON,1)=(1.D0,0.D0)          ! a0=Sigma(0)
	BCOL(ICON)=DCMPLX(SIGM0(IREP,ISPIN),0.D0)
	ICON=ICON+1
	AMAT(ICON,2)=DCMPLX(1.D0,0.D0)
	AMAT(ICON,MRAT+1+2)=-DCMPLX(SIGM0(IREP,ISPIN),0.D0)
	BCOL(ICON)=DCMPLX(-ZMAS1,0.D0)
C 5. SBMF for metallic case with Sigma(+/-)
	ELSEIF(IMOTT.EQ.0.AND.ISBMF.EQ.1)THEN
	ICON=ICON+1
	DO IRAT=0,MRAT
	AMAT(ICON,IRAT+1)=OMG0M**IRAT
	ENDDO
	DO IRAT=0,MRAT
	AMAT(ICON,MRAT+1+IRAT+1)=-SIG0M*OMG0M**IRAT
	ENDDO
	BCOL(ICON)=(0.D0,0.D0)
	ICON=ICON+1
	DO IRAT=0,MRAT
	AMAT(ICON,IRAT+1)=OMG0P**IRAT
	ENDDO
	DO IRAT=0,MRAT
	AMAT(ICON,MRAT+1+IRAT+1)=-SIG0P*OMG0P**IRAT
	ENDDO
	BCOL(ICON)=(0.D0,0.D0)
	ENDIF
	IF(ICON.NE.NCON)CALL FULLSTOP('Wrong iCon')
C Solve for coefficients now
	CALL LIB_CSIMQ(AMAT,BCOL,NCON,2*MRAT+2,IFAIL)
	IF(IFAIL.GT.0)WRITE(IUT,*)'Simq fails:',IFAIL
	DO IRAT=0,MRAT
	ACOF(IRAT)=BCOL(IRAT+1)
	ENDDO
	DO IRAT=0,MRAT
	BCOF(IRAT)=BCOL(MRAT+1+IRAT+1)
	ENDDO
C FIND POLE REPRESENTATION
	ALLOCATE(BREN(0:MRAT))
	DO IRAT=0,MRAT
	BREN(IRAT)=BCOF(IRAT)/BCOF(MRAT)
	ENDDO
	CALL LIB_PZEROS(MRAT,BREN,PSIG(1,IREP,ISPIN),1.D-14,IFAIL)
	IF(IFAIL.NE.0)WRITE(IUT,*)'Zeroes fail'
C Coefficients
	DO IPOL=1,MRAT
	IROT=0
	DO JPOL=1,MRAT
	IF(JPOL.EQ.IPOL)CYCLE
	IROT=IROT+1
	RPOL(IROT)=PSIG(JPOL,IREP,ISPIN)
	ENDDO
	MPOL=MRAT-1
	IF(MPOL.EQ.0)APOL(0,1)=(1.D0,0.D0)
	IF(MPOL.GT.0)
     &CALL LIB_PCOEFS(MPOL,RPOL,APOL(0,IPOL))
	ENDDO
C Solve for weights now
	ALLOCATE(WMAT(0:MRAT-1,MRAT))
	ALLOCATE(WCOL(0:MRAT-1))
	DO IRAT=0,MRAT-1
	WCOL(IRAT)=(ACOF(IRAT)-BCOF(IRAT)*ACOF(MRAT)/BCOF(MRAT))
     &                                            /BCOF(MRAT)
	DO IPOL=1,MRAT
	WMAT(IRAT,IPOL)=APOL(IRAT,IPOL)
	ENDDO
	ENDDO
	CALL LIB_CSIMQ(WMAT,WCOL,MRAT,MRAT,IFAIL)
	IF(IFAIL.GT.0)WRITE(IUT,*)'Simq fails:',IFAIL
	IPOL=0
	DO IRAT=0,MRAT-1
	IPOL=IPOL+1
	WSIG(IPOL,IREP,ISPIN)=WCOL(IRAT)
	ENDDO
	IF(ISBMF.EQ.0)THEN
C Check Sigma(0) using rational approximation
	ZOMG=(0.D0,0.D0)
	CNUM=0.D0
	DO IRAT=0,MRAT
	CNUM=CNUM+ACOF(IRAT)*ZOMG**IRAT
	ENDDO
	CDEN=0.D0
	DO IRAT=0,MRAT
	CDEN=CDEN+BCOF(IRAT)*ZOMG**IRAT
	ENDDO
	CSIG=CNUM/CDEN
	IF(ABS(CSIG-SIGM0(IREP,ISPIN)).GT.ACCU.AND.IMOTT.EQ.0)
     &   WRITE(IUT,*)'Sigma(0) fails'
C Check Sigma(0) using pole representation
	CSIG=DCMPLX(SIGMI(IREP,ISPIN),0.D0)
	DO IPOL=1,MRAT
	IF(ABS(ZOMG-PSIG(IPOL,IREP,ISPIN)).LE.ACCU)CYCLE
	CSIG=CSIG+WSIG(IPOL,IREP,ISPIN)/(ZOMG-PSIG(IPOL,IREP,ISPIN))
	ENDDO
	IF(ABS(CSIG-SIGM0(IREP,ISPIN)).GT.ACCU.AND.IMOTT.EQ.0)
     &   WRITE(IUT,*)'Sigma(0) fails'
C Check slope at zero using pole representation
	CSIG=DCMPLX(0.D0,0.D0)
	DO IPOL=1,MRAT
	IF(ABS(PSIG(IPOL,IREP,ISPIN)).LE.ACCU)CYCLE
	CSIG=CSIG-WSIG(IPOL,IREP,ISPIN)/PSIG(IPOL,IREP,ISPIN)**2
	ENDDO
	IF(ABS(CSIG+ZMAS1).GT.ACCU.AND.IMOTT.EQ.0)
     &WRITE(IUT,*)'Slope(0) fails'
	ELSEIF(ISBMF.EQ.1)THEN
C Check Sigma(-) using rational approximation
	ZOMG=OMG0M
	CNUM=0.D0
	DO IRAT=0,MRAT
	CNUM=CNUM+ACOF(IRAT)*ZOMG**IRAT
	ENDDO
	CDEN=0.D0
	DO IRAT=0,MRAT
	CDEN=CDEN+BCOF(IRAT)*ZOMG**IRAT
	ENDDO
	CSIG=CNUM/CDEN
	IF(ABS(CSIG-SIG0M).GT.ACCU.AND.IMOTT.EQ.0)
     &WRITE(IUT,*)'Sigma(-) fails'
C Check Sigma(-) using pole representation
	CSIG=DCMPLX(SIGMI(IREP,ISPIN),0.D0)
	DO IPOL=1,MRAT
	IF(ABS(ZOMG-PSIG(IPOL,IREP,ISPIN)).LE.ACCU)CYCLE
	CSIG=CSIG+WSIG(IPOL,IREP,ISPIN)/(ZOMG-PSIG(IPOL,IREP,ISPIN))
	ENDDO
	IF(ABS(CSIG-SIG0M).GT.ACCU.AND.IMOTT.EQ.0)
     &WRITE(IUT,*)'Sigma(-) fails'
C Check Sigma(+) using rational approximation
	ZOMG=OMG0P
	CNUM=0.D0
	DO IRAT=0,MRAT
	CNUM=CNUM+ACOF(IRAT)*ZOMG**IRAT
	ENDDO
	CDEN=0.D0
	DO IRAT=0,MRAT
	CDEN=CDEN+BCOF(IRAT)*ZOMG**IRAT
	ENDDO
	CSIG=CNUM/CDEN
	IF(ABS(CSIG-SIG0P).GT.ACCU.AND.IMOTT.EQ.0)
     &WRITE(IUT,*)'Sigma(+) fails'
C Check Sigma(-) using pole representation
	CSIG=DCMPLX(SIGMI(IREP,ISPIN),0.D0)
	DO IPOL=1,MRAT
	IF(ABS(ZOMG-PSIG(IPOL,IREP,ISPIN)).LE.ACCU)CYCLE
	CSIG=CSIG+WSIG(IPOL,IREP,ISPIN)/(ZOMG-PSIG(IPOL,IREP,ISPIN))
	ENDDO
	IF(ABS(CSIG-SIG0P).GT.ACCU.AND.IMOTT.EQ.0)
     &WRITE(IUT,*)'Sigma(+) fails'
	ENDIF
C Check Sigma at Hubbard bands using rational approximation
	DO IHUB=1,NHUB
	IF(IHUB.EQ.IHUBH0)CYCLE
	ZOMG=OMGH(IHUB)
	CNUM=0.D0
	DO IRAT=0,MRAT
	CNUM=CNUM+ACOF(IRAT)*ZOMG**IRAT
	ENDDO
	CDEN=0.D0
	DO IRAT=0,MRAT
	CDEN=CDEN+BCOF(IRAT)*ZOMG**IRAT
	ENDDO
	CSIG=CNUM/CDEN
	IF(ABS(CSIG-SIGH(IHUB)).GT.ACCU)
     &WRITE(IUT,*)'Sigma(Whub) fails'
	ENDDO
C Check Sigma at Hubbard bands using pole representation
	DO IHUB=1,NHUB
	IF(IHUB.EQ.IHUBH0)CYCLE
	ZOMG=OMGH(IHUB)
	CSIG=ACOF(MRAT)/BCOF(MRAT) ! this sigma(oo) for metallic case
	DO IPOL=1,MRAT
	CSIG=CSIG+WSIG(IPOL,IREP,ISPIN)/(ZOMG-PSIG(IPOL,IREP,ISPIN))
	ENDDO
	IF(ABS(CSIG-SIGH(IHUB)).GT.ACCU)
     &WRITE(IUT,*)'Sigma(Whub) fails'
	ENDDO
C Check Sigma(oo). In insulating case, the input Sigma(oo) can be different.
	CSIG=ACOF(MRAT)/BCOF(MRAT)
	IF(ABS(CSIG-SIGMI(IREP,ISPIN)).GT.ACCU.AND.IMOTT.EQ.0)
     &WRITE(IUT,*)'Sigma(oo) fails'
C Check singularties
	DO IHUB=1,NHUB-1
	IF(IHUB.EQ.IHUBG0)CYCLE
	ZOMG=OMGG(IHUB)
	CNUM=0.D0
	DO IRAT=0,MRAT
	CNUM=CNUM+ACOF(IRAT)*ZOMG**IRAT
	ENDDO
	CDEN=0.D0
	DO IRAT=0,MRAT
	CDEN=CDEN+BCOF(IRAT)*ZOMG**IRAT
	ENDDO
	CSIG=CDEN/CNUM
	IF(ABS(CSIG-SIGG(IHUB)).GT.ACCU)WRITE(IUT,*)'Sigma(Wgrn) fails'
	ENDDO
C Shifts poles to account for a slight change in the Hartree shift
	IF(KOCC.EQ.1)THEN
	IF(ISPIN.EQ.1)ISPIN1=NSPIN
	IF(ISPIN.EQ.NSPIN)ISPIN1=1
	DO IPOL=1,MRAT
	PSIG(IPOL,IREP,ISPIN)=
     &PSIG(IPOL,IREP,ISPIN)+UPAR*(ZOCC(ISPIN1)-ZTOT(ISPIN1))+
     &(UPAR-GPAR)*(ZOCC(ISPIN)-ZTOT(ISPIN))
	ENDDO
	ENDIF
C Sort poles so that the closest to zero is the first pole
      DO IPOL=1,MRAT
      DO JPOL=IPOL+1,MRAT
	IF(ABS(DREAL(PSIG(IPOL,IREP,ISPIN))).GT.
     &   ABS(DREAL(PSIG(JPOL,IREP,ISPIN))))THEN
	CSIG=PSIG(IPOL,IREP,ISPIN)
	PSIG(IPOL,IREP,ISPIN)=PSIG(JPOL,IREP,ISPIN)
	PSIG(JPOL,IREP,ISPIN)=CSIG
	CSIG=WSIG(IPOL,IREP,ISPIN)
	WSIG(IPOL,IREP,ISPIN)=WSIG(JPOL,IREP,ISPIN)
	WSIG(JPOL,IREP,ISPIN)=CSIG
	ENDIF
	ENDDO
	ENDDO
	MRATCRF(IREP,ISPIN)=MRAT
	DEALLOCATE(APOL,CPOL,RPOL,AMAT,BCOL,WCOL,WMAT)
	DEALLOCATE(OMGH,SIGH,OMGG,SIGG,BREN,ACOF,BCOF)
 1000	CONTINUE
 2000	CONTINUE
	MRAT=0
	DO ISPIN=1,NSPIN
	DO IREP=1,NREP
	MRAT=MAX(MRAT,MRATCRF(IREP,ISPIN))
	ENDDO
	ENDDO
	DO ISPIN=1,NSPIN
	DO IREP=1,NREP
	DO IPOL=MRATCRF(IREP,ISPIN)+1,MRAT
	WSIG(IPOL,IREP,ISPIN)=(0.D0,0.D0)
	PSIG(IPOL,IREP,ISPIN)=(1.D0,0.D0)
	ENDDO
	ENDDO
	ENDDO
C Print poles and coefficients
	DO ISPIN=1,NSPIN
	DO IREP=1,NREP
	WRITE(IUN,10100)IREP,ISPIN
	WRITE(IUN,10110)
      DO IPOL=1,MRAT
	WRITE(IUN,10120)IPOL,PSIG(IPOL,IREP,ISPIN),WSIG(IPOL,IREP,ISPIN)
	IF(DREAL(WSIG(IPOL,IREP,ISPIN)).LT.0.D0)THEN
	WHATTODO=1.D0
	WSIG(IPOL,IREP,ISPIN)=(0.D0,0.D0)
	ENDIF
	ENDDO
	ENDDO
	ENDDO
10100 FORMAT(1X,'Self-Energy Pole Expansion for iRep, iSpin ', I2,2X,I2)
10110 FORMAT(1X,'Pole            Position                      Weight')
10120 FORMAT(1X,I3,3X,'(',G12.5,',',G12.5,')',
     &             2X,'(',G12.5,',',G12.5,')')
C Memory deallocations
	DEALLOCATE(GMOM,SMOM,COMR,COMB,EATS,ZREP,MRATCRF,ZTOT,WGAT)
	DEALLOCATE(MREP,IPNF,IPNF0,IPCF,IPRF,LCFG,IPNFP1)
	END
