      subroutine imp_crfqmcm(g0,g,dtau,u,if,if1,iscf,idum,acc,
     &           nrat,nsweep,correl,s,vn,Temp,L,Nd,Nf,Nlm,
     &           master,myid,numprocs)
c############################################################
      implicit real*8(a-h,o-z)
	real*8 g0(L,Nd),g(L,Nd),u(Nf),s(2*L,1,Nf),vn(L,Nf),correl(Nd,Nd)
	complex*16 ci
cMPI  include 'mpif.h'
	integer, allocatable :: ipoint(:,:)
	integer, allocatable :: ipvt(:)
	real*8, allocatable :: ga(:,:,:)
	real*8, allocatable :: v(:)
	real*8, allocatable :: del(:,:)
	real*8, allocatable :: gst(:,:,:)
	real*8, allocatable :: docc(:)
	real*8, allocatable :: xg(:)
	real*8, allocatable :: xgf(:)
	real*8, allocatable :: g00(:)
	real*8, allocatable :: gx(:,:,:)
	real*8, allocatable :: xs(:)
	real*8, allocatable :: xf(:,:)
	real*8, allocatable :: xlam(:)
	real*8, allocatable :: d(:,:)
	real*8, allocatable :: b(:,:)	
	real*8, allocatable :: binv(:,:)	
	real*8, allocatable :: ee(:)	
	real*8, allocatable :: ze(:)
      data ci/(0.d0,1.d0)/,pi/3.1415926535898d0/
     &     ,zero/0.d0/,one/1.d0/,two/2.d0/
c memory allocations
	allocate(ga(L,L,Nd))
	allocate(v(L))
	allocate(del(L,L))
	allocate(gst(L,L,Nd))
	allocate(docc(Nlm))
	allocate(xg(-L:L))
	allocate(xgf(-L:L))
	allocate(g00(-L:L))
	allocate(gx(L,L,Nd))
	allocate(xs(0:L))
	allocate(xlam(Nf))
	allocate(xf(Nd,Nf))
	allocate(d(L,L))
	allocate(b(L,L))
	allocate(binv(L,L))
	allocate(ee(L))
	allocate(ze(l))
	allocate(ipoint(Nf,2))
      allocate(ipvt(l))
c     print*,'myid,Idum',myid,Idum
	Beta=1.d0/Temp
      if(idum.eq.0)idum=123457
      polar=.5d0
c---------- devide sweeps to numprocs -----------
c     nsweep=5000/numprocs
c     nsweep=256000/numprocs
c***select here the number of sweeps for the last loop***
c	if(if.eq.0)nsweep=500000/numprocs
c	if(if.eq.0)nsweep=5000/numprocs
c********************************************************
      if(myid .eq. master) then  ! master
      print*,'HFQMC - nsweep*Numprocs=',nsweep,numprocs
      endif  ! master
      ndirty=100
      ncor=2
      if(iscf.eq.1) then
        nwarm=100
      else
        nwarm=30
      endif
      do in=1,Nlm
	docc(in)=0.d0
      enddo
      do j=1,L
         do  i=1,L
            del(i,j)=0.d0
            del(i,i)=1.d0
         enddo 
      enddo

      do kc=1,Nd
       do j=1,L
         do i=1,L
            gst(i,j,kc)=0.d0
         enddo 
        enddo
      enddo

	do kc=1,Nd
	do kc1=1,Nd
	correl(kc,kc1)=0.d0
	enddo
	enddo

c initialize xf
c xf contains in the sign of the interaction (ie. +=ferro
c and -=antiferro) given the channel (1-Nd) and the pseudo spin (1-Nf)
	do i=1,Nd
	 do j=1,Nf
	  xf(i,j)=0.d0
	 enddo
	enddo
c--------  Sigma(i,ij) ---------
c--------  =  1 if i<j
c--------  = -1 if i>j
c-------- Upper triangle:
        ij=0
        do i=1,Nd-1
         do j=i+1,Nd
          ij=ij+1
          xf(i,ij)=1.d0
          xf(j,ij)=-1.d0
         enddo 
        enddo 
c-----------------------------
c initialize ipoint
c first entry (1-Nf) is which speudo spin flips
c and the second entry (1-2) corresponds 
c 1 to ferro-coupling (+), and 2 to antiferro (-)
        ij=0
        do i=1,Nd-1
         do j=i+1,Nd
          ij=ij+1
          ipoint(ij,1)=i
          ipoint(ij,2)=j
         enddo 
        enddo 

c--------- Test print: ----------
c      if(myid .eq. master) then  ! master
c      print*,'Nf=',ij
c      print*,'xf(k,ij)='
c      do k=1,Nd
c       do ij=1,Nf
c        print*,k,ij,xf(k,ij)
c       enddo
c      enddo
c      print*,'ipoint(ij,1/2)='
c      do ij=1,Nf
c        print*,'Up',ij,ipoint(ij,1)
c        print*,'Dn',ij,ipoint(ij,2)
c      enddo
c      endif  ! master

	do i=1,Nf
      z=dtau*u(i)/2.d0
      z=exp(z)
      xlam(i)=dlog(z+dsqrt(z**2-1.d0))
	enddo
c initialize
      r=ranw(idum)
c-------- Minus - change for QMC G-notation
	do kc=1,Nd
         do i=0,L-1
          g00(i)=-g0(i+1,kc)
         enddo
         do i=1,L-1
          g00(-i)=-g00(L-i)
         enddo

c?      g00(-L)=-g00(0)

	 do  ir=1,L
	  do  is=1,L
           gx(is,ir,kc)=g00(is-ir)
	  enddo
	 enddo
	enddo

      if(iscf.eq.1) then
	do iv=1,Nf
	 xlam0=xlam(iv)
	 call imp_crfqmcm_init(xlam0,v,polar,idum,L)
	 do i=1,L
	  vn(i,iv)=v(i)
	 enddo
	enddo
      endif

c     if( myid.eq.master) then
c        print*,'Ising fields - start'
c       do iv=1,Nf
c        write(*,'(8f10.3)')(vn(i,iv),i=1,L)
c       enddo
c       do kc=1,Nd
c       print*,'G(i)=',kc
c       write(6,'(8f10.4)')((gx(i,j,kc),i=1,L),j=1,L)
c       enddo
c     endif  ! master

	do kc=1,Nd
      call imp_crfqmcm_gcln(ga,vn,gx,del,b,binv,ee,
     &     ipvt,ze,xf,kc,L,Nd,Nf)
	enddo

c********************************************
c does a total of nsweeps
c a clean update comes after
c ndirty dirty updates
c*********************
c kx= # of measurements
c irr= # of accepted flips (after the warm-up)
c nrat= # of negative det encountered
c********************************************


	kxmax=0
	kx=0

      	irr=0
      	nrat=0
      	do 2 k=1,nsweep
         kk=mod(k,ndirty)
         kcor=mod(k,ncor)
         do 5 j=1,L
	  do 55 iv=1,Nf
            dv=2.d0*vn(j,iv)

c****calculates the determinant ratio***********
	kup=ipoint(iv,1)
	kdw=ipoint(iv,2)
            ratup=1.d0+(1.d0-ga(j,j,kup))*(dexp(-dv)-1.d0)
            ratdw=1.d0+(1.d0-ga(j,j,kdw))*(dexp(dv)-1.d0)
            rat=ratup*ratdw

            if(rat.lt.0.)then
               nrat=nrat+1
            end if
            rat=rat/(1.d0+rat)
c for num rec
	r=ranw(idum)
            if(rat.gt.r)then
               if(k.gt.nwarm)then
                  irr=irr+1
               end if
               vn(j,iv)=-vn(j,iv)
               if(kk.eq.0)then
       call imp_crfqmcm_gcln(ga,vn,gx,del,b,binv,ee,ipvt,
     &                        ze,xf,kup,L,Nd,Nf)
       call imp_crfqmcm_gcln(ga,vn,gx,del,b,binv,ee,ipvt,
     &                        ze,xf,kdw,L,Nd,Nf)
                  goto 100
               endif
            call imp_crfqmcm_gnew(ga,vn,j,iv,del,d,1.d0,kup,L,Nd,Nf)
            call imp_crfqmcm_gnew(ga,vn,j,iv,del,d,-1.d0,kdw,L,Nd,Nf)
            endif
  100      continue
55	continue
5        continue


c*** store the measurements*****************

	if(kcor.eq.0.and.k.gt.nwarm)then

	kx=kx+1
	do kc=1,Nd
c******store the g's************************
	do jx=1,L
           do ix=1,L
              gst(ix,jx,kc)=gst(ix,jx,kc)+ga(ix,jx,kc)
	enddo
	enddo
	enddo

*******************************************************************
c     Calculate correlators used for moments (for Fourier transform):
c********************************************************************
       do kc=1,Nd
        do kc1=1,Nd
           if (kc1.ne.kc) then
              do ix=1,L
                 correl(kc,kc1)=correl(kc,kc1)
     &                 +(1.d0-ga(ix,ix,kc))*(1.d0-ga(ix,ix,kc1))
              enddo
c             write(68,*)kc,kc1,correl(kc,kc1)
           else
              do ix=1,L
                 correl(kc,kc1)=correl(kc,kc1)
     &                 +(1.d0-ga(ix,ix,kc))
              enddo
c!!! do not need this: diagonal correlators are just occupations
           endif
        enddo
        enddo
c*******************************************************************

c       if(if.eq.0)then
        do ix=1,L
         do ik=1,Nlm
       docc(ik)=docc(ik)+ga(ix,ix,ik)*ga(ix,ix,ik+Nlm)
         enddo
        enddo
c       endif


	if(if1.eq.1)goto 654
c******store the Ising spins****************
        do 557 iq=1,L
	do iv=1,Nf
        s(iq,kx,iv)=vn(iq,iv)/abs(vn(iq,iv))
        s(iq+L,kx,iv)=s(iq,kx,iv)
	enddo
557     continue
654	continue

 	endif
c******************************************************

 2    continue

c     if( myid.eq.master) then
c        print*,'Ising fields - end QMC'
c       do iv=1,Nf
c        write(*,'(16f5.0)')(vn(i,iv),i=1,L)
c       enddo
c     endif  ! master
c--------Acceptance rate :
      acc=dfloat(irr)/dfloat((nsweep-nwarm)*L*Nf)

c?	jrate=jrate+1
      if(myid .eq. master) then  ! master
c     write(2,*)'acc.rate:',(dfloat(irr)/dfloat((nsweep-nwarm)*L*Nf))
c     write(3,*)jrate,(dfloat(irr)/dfloat((nsweep-nwarm)*L*Nf))
c     write(2,*)'# of neg det:',nrat
      endif  ! master



c**** get g(-L:L) by averaging the matrices up & dw********
       kxmax=kx*numprocs
c	print*,irr,kxmax

c*** normalize the sum of the g's*********

	do kc=1,Nd
	 do kc1=1,Nd
	 correl(kc,kc1)=correl(kc,kc1)/dfloat(kxmax*L)
c	 write(62,*)kc,kc1,correl(kc,kc1)
	 enddo
	 do jx=1,L
        do ix=1,L
         gst(ix,jx,kc)=gst(ix,jx,kc)/dfloat(kxmax)
        enddo
	 enddo
	enddo

c***and the double occupation*****
c     if(myid .eq. master) then  ! master
c       print*,'i, u(i),double occ(i)='
c       if(if.eq.0)then
c       do k=1,Nlm
c       docc(k)=docc(k)/dfloat(kxmax*L)
c        write(*,*)k,u(k),docc(k)
c       enddo
c     endif  ! master
c       endif


c**** wrap-around***********

	do kc=1,Nd

c for negative times
        do 601 j=0,L-1
           xg(-j)=0.
           do 602 i=1,L-j
                 xg(-j)=xg(-j)+gst(i,i+j,kc)
 602       continue
c here enforces paramagnetic solution
c           xga(-j)=.5*(xgu(-j)+xgd(-j))
 601    continue

c for positive times
        do 604 j=1,L-1
           xg(j)=0.
           do 605 i=1,L-j
                 xg(j)=xg(j)+gst(i+j,i,kc)
 605       continue
c here enforces paramagnetic solution
c          xga(j)=.5*(xgu(j)+xgd(j))
 604    continue
c here enforces time "antiperiodicity"
        do 606 i=1,L-1
           xgf(i)=(xg(i)-xg(i-L))/dfloat(L)
           xgf(i-L)=-xgf(i)
 606    continue
        xgf(0)=xg(0)/dfloat(L)
        xgf(-L)=-xgf(0)

c***********************************************

c       do 556 i=-L,L
c          g(i,kc)=xgf(i)
c556    continue
c---------- Change Minus from QMC --------?????
        do  i=0,L-1
           g(i+1,kc)=-xgf(i)
	enddo

c****close the kc loop**************** 
	enddo


	if(if.eq.1)goto 777

         if(if1.eq.0)then
c***********get chis***************

c***first from the ising fields****


	do iv=1,Nf

c!!!!have to fix this!!!
c one has to have Nf different suceptibilities!!!!
        kxa=1
        xxx=1.d0
        xsa=0.d0
        xs2=0.d0
        do 587 ii=0,L
        xs(ii)=0.d0
587     continue
        do 558 iq=1,kxa
        do 559 itq=0,L-1
        do 560 il=1,L
        itk=il+itq
        xs(itq)=xs(itq)+s(itk,iq,iv)*s(il,iq,iv)
        xsa=xsa+s(il,iq,iv)
        xs2=xs2+s(il,iq,iv)**2
560     continue
559     continue
558     continue
        do 561 ii=1,L-1
        xs(ii)=xxx*xs(ii)/dfloat(kxa*L)
        write(43,*)dble(ii)/dtau/dble(L),xs(ii)
561     continue

	enddo

        endif


777	continue
c memory allocations
	deallocate(ga,v,del,gst,docc,xg,xgf,g00,gx,xs,
     &           xlam,xf,d,b,binv,ee,ipoint,ipvt,ze)
      return
      end
            


c##################################################
c***********dirty update of g**************

      subroutine imp_crfqmcm_gnew(g,vn,j,iv,del,d,xflag,kc,L,Nd,Nf)
      implicit real*8(a-h,o-z)
      real*8 g(L,L,Nd),vn(L,Nf),del(L,L),d(L,L)
        dv=xflag*2.d0*vn(j,iv)
        ee=exp(dv)-1.d0
        a=ee/(1.d0+(1.d0-g(j,j,kc))*ee)
        do 2 i2=1,L
           do 1 i1=1,L
           d(i1,i2)=g(i1,i2,kc)+(g(i1,j,kc)-del(i1,j))*(a*g(j,i2,kc))
 1         continue
 2      continue
        do 3 i2=1,L
        do 3 i1=1,L
        g(i1,i2,kc)=d(i1,i2)
3       continue
      return
      end




      subroutine imp_crfqmcm_gcln(g,vn,gx,del,b,binv,ee,ipvt,z,
     &                             xf,kc,L,Nd,Nf)
c******clean update of g************
      implicit real*8(a-h,o-z)
	integer ipvt(L)
      real*8 g(L,L,Nd),vn(L,Nf),gx(L,L,Nd),del(L,L),xf(Nd,Nf)
     &      ,b(L,L),binv(L,L),ee(L),z(L)
c start code
	do  i=1,L
	vv=0.d0
	 do iv=1,Nf
	  vv=vv+xf(kc,iv)*vn(i,iv)
	 enddo
 	ee(i)=dexp(vv)-1.d0
	enddo

      do j=1,L
         do  i=1,L
            b(i,j)=del(i,j)-ee(j)*(gx(i,j,kc)-del(i,j))
	 enddo
      enddo

	call lib_inverse(b,binv,ipvt,z,L)

      do i1=1,L
         do i2=1,L
            xdum=0.d0
            do i=1,L
               xdum=xdum+binv(i1,i)*gx(i,i2,kc)
	    enddo
           g(i1,i2,kc)=xdum
          enddo
       enddo
      return
      end


      subroutine imp_crfqmcm_init(xlam,v,polar,idum,L)
      implicit real*8(a-h,o-z)
      double precision v(L)
c initialize
      do 1 i=1,L
         s=1.d0
	  r=ranw(idum)
         if(r.gt.polar) s=-1.d0
         v(i)=xlam*s
 1    continue
      return
      end
