	SUBROUTINE IMP_CRFSBMF_MAIN(NDEG,NREP,NSPIN,LREP,NCNF,
     &  NCNF0,EATS,TPAR,UPAR,GPAR,ELOC,DEL,GFF,SIG,PSIK,
     &  IFIX,ZMAS,ZIMP,ZREP,KFIX,
     &  TEMP,NMSC,WMSC,FMSC,DAMP,IERR)
*****************************************************************
* Solves Anderson impurity model using Gutzwiller aproximation  *
* Version 2. Crystal field splittings                           *
*****************************************************************
      USE COM_LMTOUT  ,ONLY: SCRFILE                               !!! from readini
      USE COM_CHANNELS,ONLY: IUBIM                                 !!! from channels
      USE COM_MASHDEP ,ONLY: NVAL,LENCMP                           !!! from setup
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                       !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
C PASSED ARRAYS
	INTEGER LREP(NREP),IFIX(NCNF,NCNF0)
	DIMENSION ELOC(NREP,NSPIN),ZMAS(NREP,NSPIN)
     &    ,ZIMP(NREP,NSPIN),ZREP(NREP,NSPIN),PSIK(NCNF,NCNF0)
     &    ,FMSC(0:NMSC),EATS(NCNF,NCNF0)
	COMPLEX*16 DEL(0:NMSC+1,NREP,NSPIN),GFF(0:NMSC+1,NREP,NSPIN)
     &    ,SIG(0:NMSC+1,NREP,NSPIN),WMSC(0:NMSC)
C ALLOCATABLE ARRAYS
	INTEGER, ALLOCATABLE :: MREP(:)
	INTEGER, ALLOCATABLE :: IPNF(:)
	INTEGER, ALLOCATABLE :: LCFG(:)
	INTEGER, ALLOCATABLE :: IPCF(:)
	INTEGER, ALLOCATABLE :: IPRF(:)
	INTEGER, ALLOCATABLE :: IPNF0(:)
	INTEGER, ALLOCATABLE :: IPNFP1(:)
	REAL*8, ALLOCATABLE :: ZPSI(:)
	REAL*8, ALLOCATABLE :: ZSUM(:)
	REAL*8, ALLOCATABLE :: COMR(:)
	REAL*8, ALLOCATABLE :: DSUM(:,:)
	REAL*8, ALLOCATABLE :: ELAM(:,:)
	REAL*8, ALLOCATABLE :: COMB(:,:)
	COMPLEX*16 DIM
	CHARACTER HELP*40,TCTRL*10,TCTRM*10,LIB_TDP*10
	DATA PI/3.141592653589793D0/,DIM/(0.D0,1.D0)/
     &   ,NITER/50/,EPS/1.D-05/
C Partial Charges
	ALLOCATE(DSUM(NREP,NSPIN))
	ALLOCATE(ELAM(NREP,NSPIN))
C CONFIGURATIONS, Minimum: NDEG/2+1, Maximum 2**(NDEG/2)
	ALLOCATE(MREP(0:NREP))
	MREP(0)=1
	DO IREP=1,NREP
	MREP(IREP)=MREP(IREP-1)*(LREP(IREP)+1)
	ENDDO
C SORT BY NUMBERS OF ELECTRONS
	ALLOCATE(IPNF(NREP))
	ALLOCATE(IPNF0(NREP))
	ALLOCATE(IPNFP1(NREP))
	ALLOCATE(IPCF(NCNF))
	ALLOCATE(IPRF(NCNF))
	ALLOCATE(LCFG(0:NDEG/NSPIN))
C Looping over total allowed numbers of electrons in all sublevels
	ICFR=0
	DO IDEG=0,NDEG/NSPIN
	LCFG(IDEG)=0
C Configurations are numbered in one way from 1 to NCNF.
C Start looping over them
	DO ICNF=1,NCNF
C Find out numbers of electrons at each sublevel for given configuration ICNF
C Return array is IPNF(IREP) for spin channel
	CALL LIB_GETCONF(NREP,LREP,MREP,ICNF,NCNF,IPNF)
	NELC=0 ! count # of electrons for given configuration
	DO IREP=1,NREP
	NELC=NELC+IPNF(IREP)
	ENDDO
C if this configuration contains right number of electrons, count it
	IF(NELC.NE.IDEG)CYCLE 
	LCFG(IDEG)=LCFG(IDEG)+1
	ICFR=ICFR+1
C this pointer relates second-to-first numbering schemes for configurations
	IPCF(ICFR)=ICNF 
	ENDDO
	ENDDO
C CHECK ALGORITHM
	ICFR=0 ! second way of numbering configurations
C looping over allowed total numbers of electrons of the same spin
	DO IDEG=0,NDEG/NSPIN
C looping over configurations within given number of electrons of the same spin
	DO ICFG=1,LCFG(IDEG) 
	ICFR=ICFR+1
	ICNF=IPCF(ICFR) ! find out the configuration in first numbering scheme
C Find out array showing how many electrons are in each sublevel
	CALL LIB_GETCONF(NREP,LREP,MREP,ICNF,NCNF,IPNF) 
	NELC=0 ! count # of electrons
	DO IREP=1,NREP
	IF(IPNF(IREP).LT.0.OR.IPNF(IREP).GT.LREP(IREP))
     &CALL FULLSTOP('Wrong configuration')
	NELC=NELC+IPNF(IREP)
	ENDDO
	ENDDO
	IF(NELC.NE.IDEG)CALL FULLSTOP('# of electrons mismatch')
	ENDDO
C Set reciprocal pointer which related first-to-second numbering scheme for configirations
	DO ICNF=1,NCNF 
	IPRF(ICNF)=-1
	ENDDO
	DO ICFR=1,NCNF
	ICNF=IPCF(ICFR)
	IPRF(ICNF)=ICFR
	ENDDO
	DO ICNF=1,NCNF
	IF(IPRF(ICNF).EQ.-1)CALL FULLSTOP('Wrong reciprocal pointer')
	ENDDO
C PRINT BLOCK
	WRITE(IUN,10010)NDEG,NREP,NSPIN
	WRITE(IUN,10020)(LREP(IREP),IREP=1,NREP)
	MCNF=0
	WRITE(IUN,10030)
	DO IDEG=0,NDEG/NSPIN
	WRITE(IUN,10040)IDEG,LCFG(IDEG)
	MCNF=MCNF+LCFG(IDEG)
	ENDDO
	IF(MCNF.NE.NCNF)CALL FULLSTOP('Configurations mismatch')
	WRITE(IUN,10050)NCNF
10010	FORMAT(1X,'Total degeneracy, # of representations,spins = ',
     &I2,1X,I2,1X,I2)
10020	FORMAT(1X,'Subdegeneracies left => ',14(1X,I2))
10030	FORMAT(1X,' n     Cnf ')
10040	FORMAT(1X,I2,2X,I5)
10050	FORMAT(1X,'Total # of configurations = ',I5)
C *******************************************
C Compute product of all combinatorics using second scheme of 
C numbering configurations
	ALLOCATE(COMR(NCNF))
	ALLOCATE(COMB(0:NDEG,0:NDEG))
	CALL LIB_GETCOMB(COMB,NDEG)
	ICFR=0
	DO IDEG=0,NDEG/NSPIN
	DO ICFG=1,LCFG(IDEG)
	ICFR=ICFR+1
	ICNF=IPCF(ICFR)
	CALL LIB_GETCONF(NREP,LREP,MREP,ICNF,NCNF,IPNF)
	COMR(ICFR)=1.D0 
	DO IREP=1,NREP
	COMR(ICFR)=COMR(ICFR)*COMB(IPNF(IREP),LREP(IREP))
	ENDDO
	ENDDO
	ENDDO
C CHECK COMBINATORICS
	SUS=0.D0
	ICFR=0
	DO IDEG=0,NDEG/NSPIN
	SUM=0.D0
	DO ICFG=1,LCFG(IDEG)
	ICFR=ICFR+1
	SUM=SUM+COMR(ICFR)
	SUS=SUS+COMR(ICFR)
	ENDDO
	IF(ABS(SUM-COMB(IDEG,NDEG/NSPIN)).GT.1.D-07)
     &CALL FULLSTOP('Combinatorics mismatch')
	ENDDO
	IF(ABS(SUS-2.D0**(NDEG/NSPIN)).GT.1.D-07)
     &CALL FULLSTOP('Combinatorics mismatch')
C *************************************
C Many-body atomic levels EATS numbered using second scheme of numbering configurations
	IF(NSPIN.EQ.2.AND.NCNF.NE.NCNF0)CALL FULLSTOP('nCnf.ne.nCnf0')
	IF(NSPIN.EQ.1.AND.NCNF0.NE.1)CALL FULLSTOP('nCnf0 should be 1')
	ICFR=0
	DO IDEG=0,NDEG/NSPIN
	DO ICFG=1,LCFG(IDEG)
	ICFR=ICFR+1
	ICNF=IPCF(ICFR)
	CALL LIB_GETCONF(NREP,LREP,MREP,ICNF,NCNF,IPNF)
	ICFR0=0
	DO IDEG0=0,NDEG/NSPIN
	DO ICFG0=1,LCFG(IDEG0)
	ICFR0=ICFR0+1
	IF(NSPIN.EQ.1.AND.ICFR0.GT.1)CYCLE
	ICNF0=IPCF(ICFR0)
	CALL LIB_GETCONF(NREP,LREP,MREP,ICNF0,NCNF,IPNF0)
	EATS(ICFR,ICFR0)=0.D0
	NELC =0
	NELC0=0
	DO IREP=1,NREP
	IF(NSPIN.EQ.1.AND.IPNF0(IREP).NE.0)CALL FULLSTOP('Ipnf0.ne.0')
	EATS(ICFR,ICFR0)=EATS(ICFR,ICFR0)+
     &ELOC(IREP,1)*DBLE(IPNF(IREP))+ELOC(IREP,NSPIN)*DBLE(IPNF0(IREP))
	NELC =NELC +IPNF(IREP)
	NELC0=NELC0+IPNF0(IREP)
	ENDDO
	IF(NELC .NE.IDEG )CALL FULLSTOP('# of electrons mismatch')
	IF(NELC0.NE.IDEG0)CALL FULLSTOP('# of electrons mismatch')
	ITOT=IDEG+IDEG0 ! total number of electrons
	IF(NSPIN.EQ.1)DIUP=DBLE(ITOT)/2.D0
	IF(NSPIN.EQ.1)DIDN=DBLE(ITOT)/2.D0
	IF(NSPIN.EQ.2)DIUP=DBLE(IDEG)
	IF(NSPIN.EQ.2)DIDN=DBLE(IDEG0)
	EATS(ICFR,ICFR0)=EATS(ICFR,ICFR0)+
     &UPAR*DBLE(ITOT*(ITOT-1))/2.D0-
     &GPAR*    (DIUP*(DIUP-1))/2.D0-
     &GPAR*    (DIDN*(DIDN-1))/2.D0
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	WRITE(IUN,10110)
	WRITE(IUN,10120)TEMP
	WRITE(IUN,10130)UPAR
	WRITE(IUN,10135)GPAR
	WRITE(IUN,10140)NDEG
	WRITE(IUN,10150)NMSC
10110	FORMAT(1X,'Solving impurity model at low frequencies:')
10120	FORMAT(1X,'Temp = ',G12.5)
10130	FORMAT(1X,'Upar = ',G12.5)
10135	FORMAT(1X,'Jpar = ',G12.5)
10140	FORMAT(1X,'Ndeg = ',I5)
10150	FORMAT(1X,'Nmsc = ',I5)
C Solve Gutzwiller
	CALL IMP_CRFSBMF_PSIK(NDEG,NREP,NSPIN,LREP,MREP,NCNF,NCNF0,
     &     IPNF,LCFG,IPCF,IPRF,TPAR,EATS,ELOC,COMB,COMR,
     &     DEL,GFF,SIG,PSIK,IFIX,ZMAS,DSUM,ZIMP,ZREP,ELAM,
     &     KFIX,TEMP,NMSC,WMSC,FMSC,DAMP,IERR)
C Estimate charge
	ALLOCATE(ZPSI(NSPIN))
	DO ISPIN=1,NSPIN
	ZPSI(ISPIN)=0.D0
	DO IREP=1,NREP
	ZPSI(ISPIN)=ZPSI(ISPIN)+ZREP(IREP,ISPIN)
	ENDDO
	ENDDO
C Estimate charge from Green's function
	ALLOCATE(ZSUM(NSPIN))
	DO ISPIN=1,NSPIN
	ZSUM(ISPIN)=0.D0
	DO IREP=1,NREP
	ZSUM(ISPIN)=ZSUM(ISPIN)+ZIMP(IREP,ISPIN)
	ENDDO
	ZSUM(ISPIN)=ZSUM(ISPIN)/2.D0*DBLE(NSPIN)
	ENDDO
C Print
	IF(NSPIN.EQ.1)THEN
	ICFR=0
	WRITE(IUN,10210)
	DO IDEG=0,NDEG/NSPIN
	DO ICFG=1,LCFG(IDEG)
	ICFR=ICFR+1
	ICNF=IPCF(ICFR) ! find out the configuration in first numbering scheme
	CALL LIB_GETCONF(NREP,LREP,MREP,ICNF,NCNF,IPNF) 
	TCTRL=LIB_TDP(COMR(ICFR)*COMR(1)*PSIK(ICFR,1)**2,1.D-10)
	TCTRM=LIB_TDP(EATS(ICFR,1),1.D-10)
	WRITE(IUN,10220)IFIX(ICFR,1),TCTRL,
     &IDEG,ICFG,TCTRM,(IPNF(IREP),IREP=1,NREP)
	ENDDO
	ENDDO
10210	FORMAT(1X,'f',5X,'<X>',4X,'Nel',1X,'Conf',4X,'<E>')
10220	FORMAT(1X,I1,1X,A10,I3,1X,I3,2X,A10,14(1X,I3))
	ELSEIF(NSPIN.EQ.2)THEN
	ICFR=0
	WRITE(IUN,10230)
	DO IDEG=0,NDEG/NSPIN
	DO ICFG=1,LCFG(IDEG)
	ICFR=ICFR+1
	ICNF=IPCF(ICFR) ! find out the configuration in first numbering scheme
	CALL LIB_GETCONF(NREP,LREP,MREP,ICNF,NCNF,IPNF)
	ICFR1=0
	DO IDEG1=0,NDEG/NSPIN
	DO ICFG1=1,LCFG(IDEG1)
	ICFR1=ICFR1+1
	ICNF1=IPCF(ICFR1) ! find out the configuration in first numbering scheme
	CALL LIB_GETCONF(NREP,LREP,MREP,ICNF1,NCNF,IPNFP1)
	TCTRL=LIB_TDP(COMR(ICFR)*COMR(ICFR1)*PSIK(ICFR,ICFR1)**2,1.D-10)
	TCTRM=LIB_TDP(EATS(ICFR,ICFR1),1.D-10)
	WRITE(IUN,10240)IFIX(ICFR,ICFR1),TCTRL,
     &IDEG,IDEG1,ICFG,ICFG1,TCTRM,
     &(IPNF(IREP),IREP=1,NREP),(IPNFP1(IREP),IREP=1,NREP)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
10230	FORMAT(1X,I1,6X,'<X>',2X,'N_up N_dn C_up C_dn',5X,
     &       '<E>',4X,'Sublevels')
10240	FORMAT(1X,I1,1X,A10,I3,2X,I3,2X,I3,2X,I3,2X,A10,28(1X,I3))
	ENDIF
C Print
	DO ISPIN=1,NSPIN
	DO IREP=1,NREP
	WRITE(IUN,10250)IREP,ISPIN,ELOC(IREP,ISPIN)
	WRITE(IUN,10260)DREAL(SIG(0,IREP,ISPIN)),
     &ZMAS(IREP,ISPIN),ZREP(IREP,ISPIN),ZIMP(IREP,ISPIN)
	ENDDO
	ENDDO
10250 FORMAT(1X,'Results for Rep, Spin = ',I3,1X,I3,' Eloc = ',G12.5)
10260	FORMAT(1X,'Sig0= ',G12.5,' Zmas= ',G12.5,
     &         ' Zrep= ',G12.5,' Zimp= ',G12.5)
	DO ISPIN=1,NSPIN
	IF(NSPIN.EQ.2)
     &WRITE(IUN,10270)ISPIN
	IF(NSPIN.EQ.1)
     &WRITE(IUN,10275)
	WRITE(IUN,10280)ZPSI(ISPIN),ZSUM(ISPIN)*2.D0/DBLE(NSPIN)
	ENDDO
10270 FORMAT(1X,'Results for Charges, Spin = ',I3)
10275 FORMAT(1X,'Results for Charges')
10280 FORMAT(1X,'Zhub= ',G12.5,' Zsum= ',G12.5)
C MEMORY DEALLOCATIONS
	DEALLOCATE(DSUM,ELAM,COMB)
	DEALLOCATE(MREP,IPNF,LCFG,IPCF,IPRF,IPNF0,IPNFP1)
	DEALLOCATE(COMR,ZPSI,ZSUM)
	END













	SUBROUTINE IMP_CRFSBMF_PSIK(NDEG,NREP,NSPIN,LREP,MREP,NCNF,NCNF0,
     &      IPNF,LCFG,IPCF,IPRF,TPAR,EATS,ELOC,COMB,COMR,
     &      DEL,GFF,SIG,PSIK,IFIX,ZMAS,DSUM,ZIMP,ZREP,ELAM,
     &      KFIX,TEMP,NMSC,WMSC,FMSC,DAMP,IERR)
*****************************************************************
*  Solves Anderson impurity model by iterations                 *
*  Zero-configurational width approximation is used.            *
*  Essential input:                                             *
*    WMSC - logaritmic Matsubara grid                           *
*    FMSC - weight to compute Matsubara sum                     *
*    DEL - hybridization function                               *
*  Essential output                                             *
*    ZMAS - Mass renormalization                                *
*  Method: based on low frequency expansion                     *
*  which predicts correct effective mass renormalizaton.        *
*****************************************************************
      USE COM_LMTOUT  ,ONLY: SCRFILE                               !!! from readini
      USE COM_CHANNELS,ONLY: IUBIM                                 !!! from channels
      USE COM_MASHDEP ,ONLY: NVAL,LENCMP                           !!! from setup
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                       !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
C PASSED PARAMETERS
	INTEGER LREP(NREP),MREP(0:NREP),IPNF(NREP),LCFG(0:NDEG)
     &    ,IPCF(NCNF),IPRF(NCNF),IFIX(NCNF,NCNF0)
	DIMENSION ELOC(NREP,NSPIN),EATS(NCNF,NCNF0)
     &    ,ZMAS(NREP,NSPIN),ZIMP(NREP,NSPIN),ELAM(NREP,NSPIN)
     &    ,DSUM(NREP,NSPIN),ZREP(NREP,NSPIN),FMSC(0:NMSC)
     &    ,COMB(0:NDEG,0:NDEG),COMR(NCNF),PSIK(NCNF,NCNF0)
	COMPLEX*16 DEL(0:NMSC+1,NREP,NSPIN),GFF(0:NMSC+1,NREP,NSPIN)
     &    ,SIG(0:NMSC+1,NREP,NSPIN),WMSC(0:NMSC)
C Allocatable arrays
	INTEGER, ALLOCATABLE :: JPNF(:)
	INTEGER, ALLOCATABLE :: IPNFM1(:)
	INTEGER, ALLOCATABLE :: IPNFP1(:)
	REAL*8, ALLOCATABLE :: ETOT(:)
	REAL*8, ALLOCATABLE :: EKIN(:)
	REAL*8, ALLOCATABLE :: EPOT(:)
	REAL*8, ALLOCATABLE :: ELAG(:)
	REAL*8, ALLOCATABLE :: ZPSI(:)
	REAL*8, ALLOCATABLE :: ZTOT(:)
	REAL*8, ALLOCATABLE :: WTER(:)
	REAL*8, ALLOCATABLE :: FNOM(:)
	REAL*8, ALLOCATABLE :: WDIM(:)
	REAL*8, ALLOCATABLE :: PSIN(:,:)
	REAL*8, ALLOCATABLE :: XSTA(:,:)
	COMPLEX*16, ALLOCATABLE :: AMAS(:,:,:)
	COMPLEX*16, ALLOCATABLE :: DLEFT(:,:)
	COMPLEX*16, ALLOCATABLE :: DRITE(:,:)
	COMPLEX*16, ALLOCATABLE :: BMASS(:,:)
	COMPLEX*16, ALLOCATABLE :: XINP(:)
	COMPLEX*16, ALLOCATABLE :: XOUT(:)
	COMPLEX*16, ALLOCATABLE :: BETA(:,:)
	COMPLEX*16, ALLOCATABLE :: CMAT(:,:)
	COMPLEX*16, ALLOCATABLE :: GAMA(:,:)
	COMPLEX*16, ALLOCATABLE :: WBRO(:)
	COMPLEX*16, ALLOCATABLE :: WINP(:)
	COMPLEX*16, ALLOCATABLE :: WMIX(:,:)
	COMPLEX*16, ALLOCATABLE :: DELF(:)
	COMPLEX*16, ALLOCATABLE :: UVEC(:)
	COMPLEX*16, ALLOCATABLE :: ELAR(:)
	COMPLEX*16, ALLOCATABLE :: AMAT(:,:)
	COMPLEX*16, ALLOCATABLE :: OMAT(:,:)
	COMPLEX*16, ALLOCATABLE :: GFG(:,:,:)
C Local variables
	COMPLEX*16 DIM,PHS,PSI
	DATA PI/3.141592653589793D0/,DIM/(0.D0,1.D0)/
     &    ,EPS/1.D-04/,NITER/300/,NIBRD/15/,ADMIX/0.35D0/
C Memory Allocations
	ALLOCATE(JPNF(NREP))
	ALLOCATE(IPNFM1(NREP))
	ALLOCATE(IPNFP1(NREP))
	ALLOCATE(ETOT(NCNF*NCNF0))
	ALLOCATE(EKIN(NCNF*NCNF0))
	ALLOCATE(EPOT(NCNF*NCNF0))
	ALLOCATE(ELAG(NCNF*NCNF0))
	ALLOCATE(PSIN(NCNF,NCNF0))
	ALLOCATE(XSTA(NCNF,NCNF0))
	ALLOCATE(ELAR(NCNF*NCNF0))
	ALLOCATE(ZPSI(NSPIN))
	ALLOCATE(ZTOT(NSPIN))
	ALLOCATE(AMAS(NCNF*NCNF0,NREP,NSPIN))
	ALLOCATE(AMAT(NCNF*NCNF0,NCNF*NCNF0))
	ALLOCATE(OMAT(NCNF*NCNF0,NCNF*NCNF0))
	ALLOCATE(WTER(0:NIBRD))
	ALLOCATE(FNOM(NIBRD))
	ALLOCATE(BETA(NIBRD,NIBRD))
	ALLOCATE(CMAT(NIBRD,NIBRD))
	ALLOCATE(GAMA(NIBRD,NIBRD))
	ALLOCATE(WBRO(NIBRD))
	ALLOCATE(WINP(NIBRD))
	ALLOCATE(WMIX(NIBRD,NIBRD))
	ALLOCATE(WDIM(NCNF*NCNF0))
	ALLOCATE(XINP(NCNF*NCNF0))
	ALLOCATE(XOUT(NCNF*NCNF0))
	ALLOCATE(DELF(NCNF*NCNF0))
	ALLOCATE(UVEC(NCNF*NCNF0))
	ALLOCATE(GFG(0:NMSC,NREP,NSPIN))
	ALLOCATE(DLEFT(NREP,NSPIN))
	ALLOCATE(DRITE(NREP,NSPIN))
	ALLOCATE(BMASS(NREP,NSPIN))
C START CODE:
	IERR=0
C Start from non-interacting case
	CALL IMP_CRFSBMF_XNOT(NCNF,NCNF0,EATS,TEMP,COMR,XSTA)
	ICFR=0
	DO IDEG=0,NDEG/NSPIN
	DO ICFG=1,LCFG(IDEG)
	ICFR=ICFR+1
	ICFR0=0
	DO IDEG0=0,NDEG/NSPIN
	DO ICFG0=1,LCFG(IDEG0)
	ICFR0=ICFR0+1
	IF(NSPIN.EQ.1.AND.ICFR0.GT.1)CYCLE
	IF(KFIX.EQ.0.AND.IFIX(ICFR,ICFR0).EQ.0)
     &PSIK(ICFR,ICFR0)=SQRT(1.D0/2.D0**NDEG)        ! non-interacting case
C    &PSIK(ICFR,ICFR0)=SQRT(ABS(XSTA(ICFR,ICFR0)))  ! statistical weights case does not work well
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C NORMALIZE
	PSUM=0.D0
	ICFR=0
	DO IDEG=0,NDEG/NSPIN
	DO ICFG=1,LCFG(IDEG)
	ICFR=ICFR+1
	ICFR0=0
	DO IDEG0=0,NDEG/NSPIN
	DO ICFG0=1,LCFG(IDEG0)
	ICFR0=ICFR0+1
	IF(NSPIN.EQ.1.AND.ICFR0.GT.1)CYCLE
	PSUM=PSUM+COMR(ICFR)*COMR(ICFR0)*PSIK(ICFR,ICFR0)**2
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ICFR=0
	DO IDEG=0,NDEG/NSPIN
	DO ICFG=1,LCFG(IDEG)
	ICFR=ICFR+1
	ICFR0=0
	DO IDEG0=0,NDEG/NSPIN
	DO ICFG0=1,LCFG(IDEG0)
	ICFR0=ICFR0+1
	IF(NSPIN.EQ.1.AND.ICFR0.GT.1)CYCLE
	PSIK(ICFR,ICFR0)=PSIK(ICFR,ICFR0)/SQRT(PSUM)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C Initialize Broyden routine
	NDIM=NCNF*NCNF0
	IDIM=0
	ICFR=0
	DO IDEG=0,NDEG/NSPIN
	DO ICFG=1,LCFG(IDEG)
	ICFR=ICFR+1
	ICFR0=0
	DO IDEG0=0,NDEG/NSPIN
	DO ICFG0=1,LCFG(IDEG0)
	ICFR0=ICFR0+1
	IF(NSPIN.EQ.1.AND.ICFR0.GT.1)CYCLE
	IDIM=IDIM+1
	XINP(IDIM)=DCMPLX(PSIK(ICFR,ICFR0),0.D0)
	WDIM(IDIM)=1.D0
	ENDDO
	ENDDO
	ENDDO
	ENDDO
      CALL LIB_BROY6(XINP,XOUT,WDIM,DELF,UVEC,NDIM,0,ADMIX,WTER,
     &WBRO,WINP,WMIX,FNOM,BETA,CMAT,GAMA,NIBRD,NVAL,
     &IUBIM,SCRFILE(IUBIM),IERR)
C Start iterating:
	DLAR=0.D0
	MTER=0
	DO 1000 ITER=1,NITER
	MTER=MTER+1
C Compute charges
	DO ISPIN=1,NSPIN
	ZPSI(ISPIN)=0.D0
	DO IREP=1,NREP
	ZREP(IREP,ISPIN)=0.D0
	ICFR=0
	DO IDEG=0,NDEG/NSPIN
	DO ICFG=1,LCFG(IDEG)
	ICFR=ICFR+1
	ICNF=IPCF(ICFR)
	CALL LIB_GETCONF(NREP,LREP,MREP,ICNF,NCNF,IPNF)
	ICFR0=0
	DO IDEG0=0,NDEG/NSPIN
	DO ICFG0=1,LCFG(IDEG0)
	ICFR0=ICFR0+1
	IF(NSPIN.EQ.1.AND.ICFR0.GT.1)CYCLE
	IF(ISPIN.EQ.1)
     &ZREP(IREP,ISPIN)=ZREP(IREP,ISPIN)+DBLE(IPNF(IREP))*
     &COMR(ICFR)*COMR(ICFR0)*PSIK(ICFR,ICFR0)**2
	IF(ISPIN.EQ.2)
     &ZREP(IREP,ISPIN)=ZREP(IREP,ISPIN)+DBLE(IPNF(IREP))*
     &COMR(ICFR0)*COMR(ICFR)*PSIK(ICFR0,ICFR)**2
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ZPSI(ISPIN)=ZPSI(ISPIN)+ZREP(IREP,ISPIN)
	ENDDO
	ENDDO
C Compute Left,Right, Mass
	DO ISPIN=1,NSPIN            ! looping over spins
	DO IREP=1,NREP              ! looping over sublevels
	DLEFT(IREP,ISPIN)=(1.D0,0.D0)
	DRITE(IREP,ISPIN)=(1.D0,0.D0)
	BMASS(IREP,ISPIN)=(0.D0,0.D0)
	ICFR=0
	DO IDEG=0,NDEG/NSPIN        ! looping over all configurations
	DO ICFG=1,LCFG(IDEG)        ! using second numbering scheme
	ICFR=ICFR+1
	ICNF=IPCF(ICFR)
C Find real occupancies for each sublevel within given configuration
	CALL LIB_GETCONF(NREP,LREP,MREP,ICNF,NCNF,IPNF)
C In/Decrease occupancy of sublevel IREP by 1
	DO IREP1=1,NREP
	IPNFM1(IREP1)=IPNF(IREP1)
	IPNFP1(IREP1)=IPNF(IREP1)
	ENDDO
	IPNFM1(IREP)=IPNFM1(IREP)-1
	IPNFP1(IREP)=IPNFP1(IREP)+1
C Find out corresponding configuration number in the first numbering scheme
	CALL LIB_SETCONF(NREP,LREP,MREP,ICNFM1,NCNF,IPNFM1)
	CALL LIB_SETCONF(NREP,LREP,MREP,ICNFP1,NCNF,IPNFP1)
	ICFRM1=0
	ICFRP1=0 ! try to understand that we did not exceed the total allowed 
	IF(IPNF(IREP).NE.0)         ICFRM1=IPRF(ICNFM1) ! number of electrons
	IF(IPNF(IREP).NE.LREP(IREP))ICFRP1=IPRF(ICNFP1)
C Left
	IF(IPNF(IREP).NE.0)THEN
	DO JCFR=1,NCNF0
	IF(ISPIN.EQ.1)
     &DLEFT(IREP,ISPIN)=DLEFT(IREP,ISPIN)-
     &DBLE(IPNF(IREP))/DBLE(LREP(IREP))*
     &COMR(ICFR)*COMR(JCFR)*PSIK(ICFR,JCFR)**2
	IF(ISPIN.EQ.2)
     &DLEFT(IREP,ISPIN)=DLEFT(IREP,ISPIN)-
     &DBLE(IPNF(IREP))/DBLE(LREP(IREP))*
     &COMR(JCFR)*COMR(ICFR)*PSIK(JCFR,ICFR)**2
	ENDDO
	ENDIF
C Rite
	IF(IPNF(IREP).NE.LREP(IREP))THEN
	DO JCFR=1,NCNF0
	IF(ISPIN.EQ.1)
     &DRITE(IREP,ISPIN)=DRITE(IREP,ISPIN)-
     &(DBLE(LREP(IREP))-DBLE(IPNF(IREP)))/DBLE(LREP(IREP))*
     &COMR(ICFR)*COMR(JCFR)*PSIK(ICFR,JCFR)**2
	IF(ISPIN.EQ.2)
     &DRITE(IREP,ISPIN)=DRITE(IREP,ISPIN)-
     &(DBLE(LREP(IREP))-DBLE(IPNF(IREP)))/DBLE(LREP(IREP))*
     &COMR(JCFR)*COMR(ICFR)*PSIK(JCFR,ICFR)**2
	ENDDO
	ENDIF
C Mass
	IF(IPNF(IREP).NE.0)THEN
	DO JCFR=1,NCNF0
	IF(ISPIN.EQ.1)
     &BMASS(IREP,ISPIN)=BMASS(IREP,ISPIN)+
     &DBLE(IPNF(IREP))/DBLE(LREP(IREP))*
     &PSIK(ICFR,JCFR)*PSIK(ICFRM1,JCFR)*COMR(ICFR)*COMR(JCFR)
	IF(ISPIN.EQ.2)
     &BMASS(IREP,ISPIN)=BMASS(IREP,ISPIN)+
     &DBLE(IPNF(IREP))/DBLE(LREP(IREP))*
     &PSIK(JCFR,ICFR)*PSIK(JCFR,ICFRM1)*COMR(JCFR)*COMR(ICFR)
	ENDDO
	ENDIF
	ENDDO
	ENDDO
	IF(ABS(DLEFT(IREP,ISPIN)).NE.0.D0)
     &DLEFT(IREP,ISPIN)=(1.D0,0.D0)/SQRT(DLEFT(IREP,ISPIN))
	IF(ABS(DRITE(IREP,ISPIN)).NE.0.D0)
     &DRITE(IREP,ISPIN)=(1.D0,0.D0)/SQRT(DRITE(IREP,ISPIN))
	BMASS(IREP,ISPIN)=BMASS(IREP,ISPIN)*
     &DLEFT(IREP,ISPIN)*DRITE(IREP,ISPIN)
	ENDDO                  !!! over sublevels
	ENDDO                  !!! over spins
C Compute Lagrange multipliers
	DO 300 ISPIN=1,NSPIN
	DO 200 IREP=1,NREP
	JTER=0
	E1=-TPAR
	E2=+TPAR
	CALL LIB_FINDROOT(ELAM(IREP,ISPIN),ZDIF,E1,E2,JTER,IEXIT,
     &     IUN,1.D-05,50)
 100	JTER=JTER+1
C Find new Greens function
	DO IMSC=0,NMSC
	GFG(IMSC,IREP,ISPIN)=1.D0/(WMSC(IMSC)-ELAM(IREP,ISPIN)-
     &BMASS(IREP,ISPIN)**2*DEL(IMSC,IREP,ISPIN))
	ENDDO
C Find new charge
	ZIMP(IREP,ISPIN)=0.D0
	DO IMSC=0,NMSC
      ZIMP(IREP,ISPIN)=ZIMP(IREP,ISPIN)+2.D0*TEMP*
     &DREAL(GFG(IMSC,IREP,ISPIN)-
     &1.D0/(WMSC(IMSC)-ELAM(IREP,ISPIN)))*FMSC(IMSC)
	ENDDO
	ZIMP(IREP,ISPIN)=DBLE(LREP(IREP))*(ZIMP(IREP,ISPIN)+
     &FERMIFUN(ELAM(IREP,ISPIN),TEMP))
	ZDIF=ZREP(IREP,ISPIN)-ZIMP(IREP,ISPIN)
	CALL LIB_FINDROOT(ELAM(IREP,ISPIN),ZDIF,E1,E2,JTER,IEXIT,
     &     IUN,1.D-05,50)
	IF(IEXIT.EQ.1)GOTO 200
	GOTO 100
  200 CONTINUE		
  300	CONTINUE
C Find new Greens function
	DO ISPIN=1,NSPIN
	DO IREP=1,NREP
	DO IMSC=0,NMSC
	GFG(IMSC,IREP,ISPIN)=1.D0/(WMSC(IMSC)-ELAM(IREP,ISPIN)-
     &BMASS(IREP,ISPIN)**2*DEL(IMSC,IREP,ISPIN))
	ENDDO
	ENDDO
	ENDDO
C Find new charge and sum
	DO ISPIN=1,NSPIN
	DO IREP=1,NREP
	ZIMP(IREP,ISPIN)=0.D0
	DSUM(IREP,ISPIN)=0.D0
	DO IMSC=0,NMSC
      ZIMP(IREP,ISPIN)=ZIMP(IREP,ISPIN)+2.D0*TEMP*
     &DREAL(GFG(IMSC,IREP,ISPIN)-1.D0/(WMSC(IMSC)-
     &ELAM(IREP,ISPIN)))*FMSC(IMSC)
      DSUM(IREP,ISPIN)=DSUM(IREP,ISPIN)+2.D0*TEMP*
     &DREAL(GFG(IMSC,IREP,ISPIN)*
     &DEL(IMSC,IREP,ISPIN))*FMSC(IMSC)
	ENDDO
	ZIMP(IREP,ISPIN)=DBLE(LREP(IREP))*(ZIMP(IREP,ISPIN)+
     &FERMIFUN(ELAM(IREP,ISPIN),TEMP))
	ENDDO
	ENDDO
	IF(KFIX.EQ.1)GOTO 2000 ! do not loop, return now
C Set Matrix=0
	IDIM=0
	ICFR=0
	DO IDEG=0,NDEG/NSPIN
	DO ICFG=1,LCFG(IDEG)
	ICFR=ICFR+1
	ICFR0=0
	DO IDEG0=0,NDEG/NSPIN
	DO ICFG0=1,LCFG(IDEG0)
	ICFR0=ICFR0+1
	IF(NSPIN.EQ.1.AND.ICFR0.GT.1)CYCLE
	IDIM=IDIM+1
	JDIM=0
	JCFR=0
	DO JDEG=0,NDEG/NSPIN
	DO JCFG=1,LCFG(JDEG)
	JCFR=JCFR+1
	JCFR0=0
	DO JDEG0=0,NDEG/NSPIN
	DO JCFG0=1,LCFG(JDEG0)
	JCFR0=JCFR0+1
	IF(NSPIN.EQ.1.AND.JCFR0.GT.1)CYCLE
	JDIM=JDIM+1
	AMAT(IDIM,JDIM)=(0.D0,0.D0)
	OMAT(IDIM,JDIM)=(0.D0,0.D0)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	OMAT(IDIM,IDIM)=(1.D0,0.D0)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C Prepare Matrix
	ICFR=0
	DO IDEG=0,NDEG/NSPIN
	DO ICFG=1,LCFG(IDEG)
	ICFR=ICFR+1
	ICNF=IPCF(ICFR)
	CALL LIB_GETCONF(NREP,LREP,MREP,ICNF,NCNF,IPNF)
	ICFR0=0
	DO IDEG0=0,NDEG/NSPIN
	DO ICFG0=1,LCFG(IDEG0)
	ICFR0=ICFR0+1
	IF(NSPIN.EQ.1.AND.ICFR0.GT.1)CYCLE
	IDIM=ICFR0+(ICFR-1)*NCNF0
	AMAT(IDIM,IDIM)=AMAT(IDIM,IDIM)+EATS(ICFR,ICFR0)
	DO ISPIN=1,NSPIN
	DO IREP=1,NREP
	DO IREP1=1,NREP
	IPNFM1(IREP1)=IPNF(IREP1)
	IPNFP1(IREP1)=IPNF(IREP1)
	ENDDO
	IPNFM1(IREP)=IPNFM1(IREP)-1
	IPNFP1(IREP)=IPNFP1(IREP)+1
	CALL LIB_SETCONF(NREP,LREP,MREP,ICNFM1,NCNF,IPNFM1)
	CALL LIB_SETCONF(NREP,LREP,MREP,ICNFP1,NCNF,IPNFP1)
	ICFRM1=0
	ICFRP1=0
	IF(IPNF(IREP).NE.0)         ICFRM1=IPRF(ICNFM1)
	IF(IPNF(IREP).NE.LREP(IREP))ICFRP1=IPRF(ICNFP1)
	IF(ISPIN.EQ.1)THEN
	IDIM=ICFR0+(ICFR-1)*NCNF0
	IDIMM1=ICFR0+(ICFRM1-1)*NCNF0
	IDIMP1=ICFR0+(ICFRP1-1)*NCNF0
	ELSEIF(ISPIN.EQ.2)THEN
	IDIM=ICFR+(ICFR0-1)*NCNF0
	IDIMM1=ICFRM1+(ICFR0-1)*NCNF0
	IDIMP1=ICFRP1+(ICFR0-1)*NCNF0
	ENDIF
C
	AMAT(IDIM,IDIM)=AMAT(IDIM,IDIM)-DBLE(IPNF(IREP))*ELAM(IREP,ISPIN)
C
      AMAT(IDIM,IDIM)=AMAT(IDIM,IDIM)+DBLE(IPNF(IREP))*
     &DSUM(IREP,ISPIN)*BMASS(IREP,ISPIN)**2*
     &DLEFT(IREP,ISPIN)*DLEFT(IREP,ISPIN)
C
	IF(IPNF(IREP).NE.0)
     &AMAT(IDIM,IDIMM1)=AMAT(IDIM,IDIMM1)+DBLE(IPNF(IREP))*
     &DSUM(IREP,ISPIN)*BMASS(IREP,ISPIN)*
     &DLEFT(IREP,ISPIN)*DRITE(IREP,ISPIN)
C
      AMAT(IDIM,IDIM)=AMAT(IDIM,IDIM)+DBLE(LREP(IREP)-IPNF(IREP))*
     &DSUM(IREP,ISPIN)*BMASS(IREP,ISPIN)**2*
     &DRITE(IREP,ISPIN)*DRITE(IREP,ISPIN)
C
	IF(IPNF(IREP).NE.LREP(IREP))
     &AMAT(IDIM,IDIMP1)=AMAT(IDIM,IDIMP1)+DBLE(LREP(IREP)-IPNF(IREP))*
     &DSUM(IREP,ISPIN)*BMASS(IREP,ISPIN)*
     &DLEFT(IREP,ISPIN)*DRITE(IREP,ISPIN)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C Matrix is ready, diagonalize now:
	CALL LIB_CMPEIG1A(NCNF*NCNF0,AMAT,OMAT,ELAR,1,1,1,IFAIL,0,1.D-05)
	IF(IFAIL.NE.0)
     &CALL FULLSTOP('<IMP_CRFSBMF_PSIK> :: Error in diagonalization')
C Search for correct root:
	IROT=0
	NROT=0
	DO 400 IBND=1,NCNF*NCNF0
	PHS=(0.D0,0.D0)
	IDIM=0
	ICFR=0
	DO IDEG=0,NDEG/NSPIN
	DO ICFG=1,LCFG(IDEG)
	ICFR=ICFR+1
	ICFR0=0
	DO IDEG0=0,NDEG/NSPIN
	DO ICFG0=1,LCFG(IDEG0)
	ICFR0=ICFR0+1
	IF(NSPIN.EQ.1.AND.ICFR0.GT.1)CYCLE
	IDIM=IDIM+1
	IF(IDIM.NE.ICFR0+(ICFR-1)*NCNF0)CALL FULLSTOP('Wrong iDim')
	IF(ABS(OMAT(IDIM,IBND)).LE.1.D-08)CYCLE
	PHS=OMAT(IDIM,IBND)/ABS(OMAT(IDIM,IBND))
	IF(ABS(OMAT(IDIM,IBND)).GT.1.D-08)EXIT
	ENDDO
	IF(ABS(OMAT(IDIM,IBND)).GT.1.D-08)EXIT
	ENDDO
	IF(ABS(OMAT(IDIM,IBND)).GT.1.D-08)EXIT
	ENDDO
	IF(ABS(OMAT(IDIM,IBND)).GT.1.D-08)EXIT
	ENDDO
	IF(ABS(PHS).LE.1.D-10)
     &CALL FULLSTOP('IMP_CRFSBMF_PSIK>:: Wrong Phase')
	IDIM=0
	ICFR=0
	DO IDEG=0,NDEG/NSPIN
	DO ICFG=1,LCFG(IDEG)
	ICFR=ICFR+1
	ICFR0=0
	DO IDEG0=0,NDEG/NSPIN
	DO ICFG0=1,LCFG(IDEG0)
	ICFR0=ICFR0+1
	IF(NSPIN.EQ.1.AND.ICFR0.GT.1)CYCLE
	IDIM=IDIM+1
	OMAT(IDIM,IBND)=OMAT(IDIM,IBND)/PHS
	IF(DIMAG(OMAT(IDIM,IBND)).GT.1.D-05
     &.OR.DIMAG(ELAR(IBND)).GT.1.D-05)
     &WRITE(IUN,*)'Complex Solutions, imaginary parts =',
     &DIMAG(OMAT(IDIM,IBND)),DIMAG(ELAR(IBND))
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C Check norm
	PSUM=0.D0
	IDIM=0
	ICFR=0
	DO IDEG=0,NDEG/NSPIN
	DO ICFG=1,LCFG(IDEG)
	ICFR=ICFR+1
	ICFR0=0
	DO IDEG0=0,NDEG/NSPIN
	DO ICFG0=1,LCFG(IDEG0)
	ICFR0=ICFR0+1
	IF(NSPIN.EQ.1.AND.ICFR0.GT.1)CYCLE
	IDIM=IDIM+1
	PSUM=PSUM+COMR(ICFR)*COMR(ICFR0)*
     &     OMAT(IDIM,IBND)*DCONJG(OMAT(IDIM,IBND))
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	IDIM=0
	ICFR=0
	DO IDEG=0,NDEG/NSPIN
	DO ICFG=1,LCFG(IDEG)
	ICFR=ICFR+1
	ICFR0=0
	DO IDEG0=0,NDEG/NSPIN
	DO ICFG0=1,LCFG(IDEG0)
	ICFR0=ICFR0+1
	IF(NSPIN.EQ.1.AND.ICFR0.GT.1)CYCLE
	IDIM=IDIM+1
	OMAT(IDIM,IBND)=OMAT(IDIM,IBND)/SQRT(PSUM)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C Compute Left,Right, Mass
	DO ISPIN=1,NSPIN            ! looping over spins
	DO IREP=1,NREP              ! looping over sublevels
	DLEFT(IREP,ISPIN)=(1.D0,0.D0)
	DRITE(IREP,ISPIN)=(1.D0,0.D0)
	BMASS(IREP,ISPIN)=(0.D0,0.D0)
	ICFR=0
	DO IDEG=0,NDEG/NSPIN        ! looping over all configurations
	DO ICFG=1,LCFG(IDEG)        ! using second numbering scheme
	ICFR=ICFR+1
	ICNF=IPCF(ICFR)
C Find real occupancies for each sublevel within given configuration
	CALL LIB_GETCONF(NREP,LREP,MREP,ICNF,NCNF,IPNF)
C In/Decrease occupancy of sublevel IREP by 1
	DO IREP1=1,NREP
	IPNFM1(IREP1)=IPNF(IREP1)
	IPNFP1(IREP1)=IPNF(IREP1)
	ENDDO
	IPNFM1(IREP)=IPNFM1(IREP)-1
	IPNFP1(IREP)=IPNFP1(IREP)+1
C Find out corresponding configuration number in the first numbering scheme
	CALL LIB_SETCONF(NREP,LREP,MREP,ICNFM1,NCNF,IPNFM1)
	CALL LIB_SETCONF(NREP,LREP,MREP,ICNFP1,NCNF,IPNFP1)
	ICFRM1=0
	ICFRP1=0 ! try to understand that we did not exceed the total allowed 
	IF(IPNF(IREP).NE.0)         ICFRM1=IPRF(ICNFM1) ! number of electrons
	IF(IPNF(IREP).NE.LREP(IREP))ICFRP1=IPRF(ICNFP1)
C Left
	IF(IPNF(IREP).NE.0)THEN
	DO JCFR=1,NCNF0
	IF(ISPIN.EQ.1)
     &IDIM=JCFR+(ICFR-1)*NCNF0
	IF(ISPIN.EQ.2)
     &IDIM=ICFR+(JCFR-1)*NCNF0
      DLEFT(IREP,ISPIN)=DLEFT(IREP,ISPIN)-
     &DBLE(IPNF(IREP))/DBLE(LREP(IREP))*
     &COMR(ICFR)*COMR(JCFR)*OMAT(IDIM,IBND)*DCONJG(OMAT(IDIM,IBND))
	ENDDO
	ENDIF
C Rite
	IF(IPNF(IREP).NE.LREP(IREP))THEN
	DO JCFR=1,NCNF0
	IF(ISPIN.EQ.1)
     &IDIM=JCFR+(ICFR-1)*NCNF0
	IF(ISPIN.EQ.2)
     &IDIM=ICFR+(JCFR-1)*NCNF0
      DRITE(IREP,ISPIN)=DRITE(IREP,ISPIN)-
     &(DBLE(LREP(IREP))-DBLE(IPNF(IREP)))/DBLE(LREP(IREP))*
     &COMR(ICFR)*COMR(JCFR)*OMAT(IDIM,IBND)*DCONJG(OMAT(IDIM,IBND))
	ENDDO
	ENDIF
C Mass
	IF(IPNF(IREP).NE.0)THEN
	DO JCFR=1,NCNF0
	IDIM=JCFR+(ICFR-1)*NCNF0
	IDIMM1=JCFR+(ICFRM1-1)*NCNF0
	IF(ISPIN.EQ.1)
     &BMASS(IREP,ISPIN)=BMASS(IREP,ISPIN)+
     &DBLE(IPNF(IREP))/DBLE(LREP(IREP))*COMR(ICFR)*COMR(JCFR)*
     &OMAT(IDIM,IBND)*DCONJG(OMAT(IDIMM1,IBND))
	IDIM=ICFR+(JCFR-1)*NCNF0
	IDIMM1=ICFRM1+(JCFR-1)*NCNF0
	IF(ISPIN.EQ.2)
     &BMASS(IREP,ISPIN)=BMASS(IREP,ISPIN)+
     &DBLE(IPNF(IREP))/DBLE(LREP(IREP))*COMR(JCFR)*COMR(ICFR)*
     &OMAT(IDIM,IBND)*DCONJG(OMAT(IDIMM1,IBND))
	ENDDO
	ENDIF
	ENDDO
	ENDDO
	IF(ABS(DLEFT(IREP,ISPIN)).NE.0.D0)
     &DLEFT(IREP,ISPIN)=(1.D0,0.D0)/SQRT(DLEFT(IREP,ISPIN))
	IF(ABS(DRITE(IREP,ISPIN)).NE.0.D0)
     &DRITE(IREP,ISPIN)=(1.D0,0.D0)/SQRT(DRITE(IREP,ISPIN))
	AMAS(IBND,IREP,ISPIN)=BMASS(IREP,ISPIN)*
     &    DLEFT(IREP,ISPIN)*DRITE(IREP,ISPIN)
	ENDDO                                !!! over sublevels
	ENDDO                                !!! over spins
  400	CONTINUE
C TOTAL ENERGY
	DO IBND=1,NCNF*NCNF0                 !!! over bands
C Estimate kinetic energy
	EKIN(IBND)=0.D0
	DO ISPIN=1,NSPIN
	DO IREP=1,NREP
	DO IMSC=0,NMSC
	PHS=(WMSC(IMSC)-ELAM(IREP,ISPIN)-AMAS(IBND,IREP,ISPIN)**2*
     &DEL(IMSC,IREP,ISPIN))/(WMSC(IMSC)-ELAM(IREP,ISPIN))
      EKIN(IBND)=EKIN(IBND)-2.D0*TEMP*DBLE(LREP(IREP))*FMSC(IMSC)*
     &DREAL(LOG(PHS))
	ENDDO
	EKIN(IBND)=EKIN(IBND)-DBLE(LREP(IREP))*TEMP*
     &LOG(SAFEEXP(ELAM(IREP,ISPIN)/TEMP)+1.D0)
	ENDDO
	ENDDO
C Estimate potential energy
	EPOT(IBND)=0.D0
	IDIM=0
	ICFR=0
	DO IDEG=0,NDEG/NSPIN
	DO ICFG=1,LCFG(IDEG)
	ICFR=ICFR+1
	ICFR0=0
	DO IDEG0=0,NDEG/NSPIN
	DO ICFG0=1,LCFG(IDEG0)
	ICFR0=ICFR0+1
	IF(NSPIN.EQ.1.AND.ICFR0.GT.1)CYCLE
	IDIM=IDIM+1
	EPOT(IBND)=EPOT(IBND)+COMR(ICFR)*EATS(ICFR,ICFR0)*
     &DCONJG(OMAT(IDIM,IBND))*OMAT(IDIM,IBND)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C Estimate Lagrange multipliers part
	ELAG(IBND)=0.D0
	DO ISPIN=1,NSPIN
	DO IREP=1,NREP
	IDIM=0
	ICFR=0
	DO IDEG=0,NDEG/NSPIN
	DO ICFG=1,LCFG(IDEG)
	ICFR=ICFR+1
	ICNF=IPCF(ICFR)
	CALL LIB_GETCONF(NREP,LREP,MREP,ICNF,NCNF,IPNF)
	ICFR0=0
	DO IDEG0=0,NDEG/NSPIN
	DO ICFG0=1,LCFG(IDEG0)
	ICFR0=ICFR0+1
	IF(NSPIN.EQ.1.AND.ICFR0.GT.1)CYCLE
	IDIM=ICFR0+(ICFR-1)*NCNF0
	IF(ISPIN.EQ.1)
     &ELAG(IBND)=ELAG(IBND)-ELAM(IREP,ISPIN)*
     &COMR(ICFR)*COMR(ICFR0)*IPNF(IREP)*
     &DCONJG(OMAT(IDIM,IBND))*OMAT(IDIM,IBND)
	IDIM=ICFR+(ICFR0-1)*NCNF0
	IF(ISPIN.EQ.2)
     &ELAG(IBND)=ELAG(IBND)-ELAM(IREP,ISPIN)*
     &COMR(ICFR0)*COMR(ICFR)*IPNF(IREP)*
     &DCONJG(OMAT(IDIM,IBND))*OMAT(IDIM,IBND)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ETOT(IBND)=EKIN(IBND)+EPOT(IBND)+ELAG(IBND)
	ENDDO                      !!! over bands
C Usually correct root has the lowest eigenvalue (1st one)
	IROT=1
C Check root for the lowest energy
	EMIN=ETOT(1)
	DO IBND=1,NCNF*NCNF0
C	IF(ETOT(IBND).LT.EMIN)IROT=IBND
	IF(ETOT(IBND).LT.EMIN)EMIN=ETOT(IBND)
	ENDDO
C
	DLAR=DREAL(ELAR(IROT))
	DO ISPIN=1,NSPIN
	DO IREP=1,NREP
	IF(ABS(AMAS(IROT,IREP,ISPIN)).LE.1.D-12)THEN
C	WRITE(IUN,*)'Wrong mass renormalization!'
	AMAS(IROT,IREP,ISPIN)=ABS(AMAS(IROT,IREP,ISPIN))
	ENDIF
	BMASS(IREP,ISPIN)=AMAS(IROT,IREP,ISPIN)
	ENDDO
	ENDDO
C Set new Psik's
	IDIM=0
	ICFR=0
	DO IDEG=0,NDEG/NSPIN
	DO ICFG=1,LCFG(IDEG)
	ICFR=ICFR+1
	ICFR0=0
	DO IDEG0=0,NDEG/NSPIN
	DO ICFG0=1,LCFG(IDEG0)
	ICFR0=ICFR0+1
	IF(NSPIN.EQ.1.AND.ICFR0.GT.1)CYCLE
	IDIM=IDIM+1
	IF(IFIX(ICFR,ICFR0).EQ.0)
     &PSIN(ICFR,ICFR0)=ABS(DREAL(OMAT(IDIM,IROT)))
	IF(IFIX(ICFR,ICFR0).NE.0)
     &PSIN(ICFR,ICFR0)=PSIK(ICFR,ICFR0)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C Check norm
	PSUM=0.D0
	ICFR=0
	DO IDEG=0,NDEG/NSPIN
	DO ICFG=1,LCFG(IDEG)
	ICFR=ICFR+1
	ICFR0=0
	DO IDEG0=0,NDEG/NSPIN
	DO ICFG0=1,LCFG(IDEG0)
	ICFR0=ICFR0+1
	IF(NSPIN.EQ.1.AND.ICFR0.GT.1)CYCLE
	PSUM=PSUM+COMR(ICFR)*COMR(ICFR0)*PSIN(ICFR,ICFR0)**2
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ICFR=0
	DO IDEG=0,NDEG/NSPIN
	DO ICFG=1,LCFG(IDEG)
	ICFR=ICFR+1
	ICFR0=0
	DO IDEG0=0,NDEG/NSPIN
	DO ICFG0=1,LCFG(IDEG0)
	ICFR0=ICFR0+1
	IF(NSPIN.EQ.1.AND.ICFR0.GT.1)CYCLE
	PSIN(ICFR,ICFR0)=PSIN(ICFR,ICFR0)/SQRT(PSUM)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C Compare with the old results
	PDIF=0.D0
	ICFR=0
	DO IDEG=0,NDEG/NSPIN
	DO ICFG=1,LCFG(IDEG)
	ICFR=ICFR+1
	ICFR0=0
	DO IDEG0=0,NDEG/NSPIN
	DO ICFG0=1,LCFG(IDEG0)
	ICFR0=ICFR0+1
	IF(NSPIN.EQ.1.AND.ICFR0.GT.1)CYCLE
	PDIF=PDIF+COMR(ICFR)*COMR(ICFR0)*
     &ABS(PSIK(ICFR,ICFR0)**2-PSIN(ICFR,ICFR0)**2)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	IF(PDIF.LE.EPS.AND.ITER.GT.1) GOTO 2000
C Send result to Broyden
	IDIM=0
	ICFR=0
	DO IDEG=0,NDEG/NSPIN
	DO ICFG=1,LCFG(IDEG)
	ICFR=ICFR+1
	ICFR0=0
	DO IDEG0=0,NDEG/NSPIN
	DO ICFG0=1,LCFG(IDEG0)
	ICFR0=ICFR0+1
	IF(NSPIN.EQ.1.AND.ICFR0.GT.1)CYCLE
	IDIM=IDIM+1
	XINP(IDIM)=DCMPLX(PSIN(ICFR,ICFR0),0.D0)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
      CALL LIB_BROY6(XINP,XOUT,WDIM,DELF,UVEC,NDIM,MTER,ADMIX,WTER,
     &WBRO,WINP,WMIX,FNOM,BETA,CMAT,GAMA,NIBRD,NVAL,
     &IUBIM,SCRFILE(IUBIM),IERR)
C Set new coefficients predicted by Broyden
	IDIM=0
	ICFR=0
	DO IDEG=0,NDEG/NSPIN
	DO ICFG=1,LCFG(IDEG)
	ICFR=ICFR+1
	ICFR0=0
	DO IDEG0=0,NDEG/NSPIN
	DO ICFG0=1,LCFG(IDEG0)
	ICFR0=ICFR0+1
	IF(NSPIN.EQ.1.AND.ICFR0.GT.1)CYCLE
	IDIM=IDIM+1
	IF(IFIX(ICFR,ICFR0).EQ.0)
     &PSIK(ICFR,ICFR0)=ABS(DREAL(XOUT(IDIM)))
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	PSUM=0.D0
	ICFR=0
	DO IDEG=0,NDEG/NSPIN
	DO ICFG=1,LCFG(IDEG)
	ICFR=ICFR+1
	ICFR0=0
	DO IDEG0=0,NDEG/NSPIN
	DO ICFG0=1,LCFG(IDEG0)
	ICFR0=ICFR0+1
	IF(NSPIN.EQ.1.AND.ICFR0.GT.1)CYCLE
	PSUM=PSUM+COMR(ICFR)*COMR(ICFR0)*PSIK(ICFR,ICFR0)**2
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ICFR=0
	DO IDEG=0,NDEG/NSPIN
	DO ICFG=1,LCFG(IDEG)
	ICFR=ICFR+1
	ICFR0=0
	DO IDEG0=0,NDEG/NSPIN
	DO ICFG0=1,LCFG(IDEG0)
	ICFR0=ICFR0+1
	IF(NSPIN.EQ.1.AND.ICFR0.GT.1)CYCLE
	PSIK(ICFR,ICFR0)=PSIK(ICFR,ICFR0)/SQRT(PSUM)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C Restart Broyden
	IF(MTER.GE.NIBRD-1)THEN
	IDIM=0
	ICFR=0
	DO IDEG=0,NDEG/NSPIN
	DO ICFG=1,LCFG(IDEG)
	ICFR=ICFR+1
	ICFR0=0
	DO IDEG0=0,NDEG/NSPIN
	DO ICFG0=1,LCFG(IDEG0)
	ICFR0=ICFR0+1
	IF(NSPIN.EQ.1.AND.ICFR0.GT.1)CYCLE
	IDIM=IDIM+1
	XINP(IDIM)=DCMPLX(PSIK(ICFR,ICFR0),0.D0)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	MTER=0
      CALL LIB_BROY6(XINP,XOUT,WDIM,DELF,UVEC,NDIM,0,ADMIX,WTER,
     &WBRO,WINP,WMIX,FNOM,BETA,CMAT,GAMA,NIBRD,NVAL,
     &IUBIM,SCRFILE(IUBIM),IERR)
	ENDIF
 1000	CONTINUE
	WRITE(IUN,10100)ITER,PDIF
	IERR=1
C	BMASS=0.D0
 2000	CONTINUE
C Returned parameters
	DO ISPIN=1,NSPIN
	DO IREP=1,NREP
	ZMAS(IREP,ISPIN)=DREAL(BMASS(IREP,ISPIN))**2
	DO IMSC=0,NMSC
	GFF(IMSC,IREP,ISPIN)=BMASS(IREP,ISPIN)**2*GFG(IMSC,IREP,ISPIN)
	IF(ABS(BMASS(IREP,ISPIN)).GT.1.D-10)
     &SIG(IMSC,IREP,ISPIN)=WMSC(IMSC)-ELOC(IREP,ISPIN)-
     &DEL(IMSC,IREP,ISPIN)-1.D0/GFF(IMSC,IREP,ISPIN)
	IF(ABS(BMASS(IREP,ISPIN)).LE.1.D-10)
     &SIG(IMSC,IREP,ISPIN)=(0.D0,0.D0)
	ENDDO
	ENDDO
	ENDDO
C Memory Deallocations
	DEALLOCATE(JPNF,IPNFM1,IPNFP1)
	DEALLOCATE(PSIN,AMAT,OMAT,GFG,AMAS,DLEFT,DRITE,BMASS)
	DEALLOCATE(ETOT,EKIN,EPOT,ELAG,ELAR,ZPSI,ZTOT,XSTA)
	DEALLOCATE(XINP,XOUT,WTER,WDIM,WBRO,WINP,WMIX,DELF,UVEC)
	DEALLOCATE(FNOM,BETA,CMAT,GAMA)
10100	FORMAT(1X,'No convergency after ',I3,' iterations.',
     &1X,' Accuracy reached',G12.5)
	END



 





	SUBROUTINE IMP_CRFSBMF_XNOT(NCNF,NCNF0,EATS,TEMP,COMR,XHUB)
*******************************************************
*  Finds correlational functions for an atom          *
*******************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	DIMENSION EATS(NCNF,NCNF0),COMR(NCNF)
	INTEGER, ALLOCATABLE :: IATM(:)
	REAL*8, ALLOCATABLE :: EATM(:)
	REAL*8, ALLOCATABLE :: XATM(:)
	REAL*8 XHUB(NCNF,NCNF0)
	DATA EPS/1.D-05/
C Order atomic states in increasing order
	ALLOCATE(EATM(NCNF*NCNF0))
	ALLOCATE(XATM(NCNF*NCNF0))
	ALLOCATE(IATM(NCNF*NCNF0))
	DO ICNF=1,NCNF
	DO JCNF=1,NCNF0
	EATM(ICNF+NCNF*(JCNF-1))=EATS(ICNF,JCNF)
	IATM(ICNF+NCNF*(JCNF-1))=ICNF+NCNF*(JCNF-1)
	ENDDO
	ENDDO
      DO ISTR=1,NCNF*NCNF0
      DO JSTR=ISTR+1,NCNF*NCNF0
	IF(EATM(ISTR).GT.EATM(JSTR))THEN
	S=EATM(ISTR)
	EATM(ISTR)=EATM(JSTR)
	EATM(JSTR)=S
	I=IATM(ISTR)
	IATM(ISTR)=IATM(JSTR)
	IATM(JSTR)=I
	ENDIF
	ENDDO
	ENDDO
C In this ordering scheme we can loop forward only
	IF(TEMP.GT.0.D0)THEN
      XATM(1)=1.D0
      DO ISTR=1,NCNF*NCNF0-1
      E=EATM(ISTR+1)-EATM(ISTR)
      XATM(ISTR+1)=SAFEEXP(-E/TEMP)*XATM(ISTR)
      ENDDO
C If temperature is zero, only first states survive
	ELSEIF(TEMP.EQ.0.D0)THEN
      XATM(1)=1.D0
      DO ISTR=1,NCNF*NCNF0-1
      E=EATM(ISTR+1)-EATM(ISTR)
      IF(ABS(E).LE.EPS)XATM(ISTR+1)=XATM(ISTR)
	IF(ABS(E).GT.EPS)XATM(ISTR+1)=0.D0
      ENDDO
	ENDIF
C Reorder
	DO ISTR=1,NCNF*NCNF0
	JCNF=(IATM(ISTR)-1)/NCNF+1
	ICNF=IATM(ISTR)-NCNF*(JCNF-1)
	XHUB(ICNF,JCNF)=XATM(ISTR)
	ENDDO
C Renormalize 
      XSUM=0.D0
      DO ICNF=1,NCNF
      DO JCNF=1,NCNF0
      XSUM=XSUM+XHUB(ICNF,JCNF)*COMR(ICNF)*COMR(JCNF)
      ENDDO
	ENDDO
      DO ICNF=1,NCNF
      DO JCNF=1,NCNF0
      XHUB(ICNF,JCNF)=XHUB(ICNF,JCNF)/XSUM
      ENDDO
      ENDDO
C Check
	XSUM=0.D0
	DO ICNF=1,NCNF
	DO JCNF=1,NCNF0
	XSUM=XSUM+XHUB(ICNF,JCNF)*COMR(ICNF)*COMR(JCNF)
	ENDDO
	ENDDO
	IF(ABS(XSUM-1.D0).GT.1.D-10)
     &CALL FULLSTOP('<IMP_CRFHUB1_XNOT>:: Normalization error')
	DEALLOCATE(EATM,XATM,IATM)
	RETURN
	END






