      SUBROUTINE IMP_HYBFUN(L,IATOM,GLOCMAT,EIMPMAT,OIMPMAT,VDBCMAT,
     &     SIGWMAT,SIGIMAT,VRATMAT,WRATMAT,PRATMAT,ORATMAT,
     &     DELWMAT,DELIMAT,IERR)
*********************************************************************
*  Subroutine finds hybridization  function of the impurity problem *
*********************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                 !!! from setup
      USE COM_CONTROL ,ONLY: LIFT,LMTO,IDMF                          !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS,ILSB         !!! from readini
      USE COM_MSBMESH ,ONLY: TEMP,WMSC,NMSC,OBND,FMSC,DMSC,KGRD      !!! from readhub
	USE COM_IMPDAT  ,ONLY: NRUNIMP,KSTATES,KCRDSYS,NPOLIMP         !!! from readhub
      USE COM_HUBDAT  ,ONLY: MCRL,LCRL,KDELFUN,PDMP,KHRM             !!! from readhub
      USE COM_FERMI   ,ONLY: EF                                      !!! from ttrints
      USE COM_LMTOUT  ,ONLY: SCRFILE                                 !!! from readini
      USE COM_MASHDEP ,ONLY: NVAL,LENCMP                             !!! from setup
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                         !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: HG(:,:),HS(:,:),OG(:,:),OS(:,:)
	COMPLEX*16, ALLOCATABLE :: WA(:),EG(:),ES(:),GF(:,:),SE(:,:)
	COMPLEX*16, ALLOCATABLE :: GT(:,:),ST(:,:)
	COMPLEX*16, ALLOCATABLE :: GINVMAT(:,:),GSIGMAT(:,:)
	COMPLEX*16, ALLOCATABLE :: WPOLTTR(:,:,:,:),GWGTTTR(:,:,:)
	COMPLEX*16 GLOCMAT(0:NMSCMEM+1,2*(2*L+1),2*(2*L+1))
     &          ,SIGWMAT(0:NMSCMEM+1,2*(2*L+1),2*(2*L+1))
     &          ,DELWMAT(0:NMSCMEM+1,2*(2*L+1),2*(2*L+1))
     &          ,VDBCMAT(         2*(2*L+1),2*(2*L+1))
     &          ,EIMPMAT(         2*(2*L+1),2*(2*L+1))
     &          ,OIMPMAT(         2*(2*L+1),2*(2*L+1))
     &          ,SIGIMAT(         2*(2*L+1),2*(2*L+1))
     &          ,DELIMAT(         2*(2*L+1),2*(2*L+1))
     &          ,VRATMAT(         2*(2*L+1),2*(2*L+1),NPOLMEM)
     &          ,WRATMAT(         2*(2*L+1),2*(2*L+1),NPOLMEM)
     &          ,PRATMAT(         2*(2*L+1),2*(2*L+1),NPOLMEM)
     &          ,ORATMAT(         2*(2*L+1),2*(2*L+1),NPOLMEM)
	COMPLEX*16 DIM,ZMSC,WPOL
      DATA PI/3.141592653589793D0/,DIM/(0.D0,1.D0)/,EPSDEG/1.D-05/
      CALL ABORTNOW()
	IERR=0
	ISORT=IS(IATOM)
	NDIM=2*(2*L+1)
	NPOL=NPOLIMP(L,IATOM)
	EFRM=EF
C MEMORY ALLOCATIONS
      ALLOCATE(GSIGMAT(NDIM,NDIM))
      ALLOCATE(GINVMAT(NDIM,NDIM))
      ALLOCATE(WA(NDIM))
C DO OVER FREQUENCIES
	DO 1000 IMSC=0,NMSC                     !!! over frequencies
	ZMSC=WMSC(IMSC)
      DO IDIM1=1,NDIM                         !!! over idim1
      DO IDIM=1,NDIM                          !!! over idim
      GINVMAT(IDIM1,IDIM)=GLOCMAT(IMSC,IDIM1,IDIM)
      ENDDO                                   !!! over idim
      ENDDO                                   !!! over idim1
C INVERT GREEN FUNCTION
	CALL LIB_CINV(NDIM,GINVMAT,NDIM,WA,IFAIL)
	IF(IFAIL.NE.0)THEN
      WRITE(IUN,*)'<IMP_HYBFUN>:: Error in inversion program'
      DO IDIM1=1,NDIM
      DO IDIM =1,NDIM
      GINVMAT(IDIM1,IDIM)=(0.D0,0.D0)
      ENDDO
      ENDDO
      ENDIF
C **********************************************
C MATRIX CALCULATION WITHOUT ANY PRECONDITIONING
C Makes sense for real/imag axis DMFT, probalematic for rational forms.
      IF(KDELFUN(L,IATOM).EQ.1)THEN
      DO IDIM1=1,NDIM
      DO IDIM =1,NDIM
      GSIGMAT(IDIM1,IDIM)=GINVMAT(IDIM1,IDIM)+SIGWMAT(IMSC,IDIM1,IDIM)
	DELWMAT(IMSC,IDIM1,IDIM)=(ZMSC+EFRM)*OIMPMAT(IDIM1,IDIM)-
     &EIMPMAT(IDIM1,IDIM)+SIGIMAT(IDIM1,IDIM)-GSIGMAT(IDIM1,IDIM)
      ENDDO
      ENDDO
C **********************************************
C DIAGONAL APPROXIMATION VALID IN SOME CRYSTAL FIELD CASES
      ELSEIF(KDELFUN(L,IATOM).EQ.2)THEN
      DO IDIM1=1,NDIM
      DO IDIM =1,NDIM
      GSIGMAT(     IDIM1,IDIM)=(0.D0,0.D0)
      DELWMAT(IMSC,IDIM1,IDIM)=(0.D0,0.D0)
      ENDDO
      ENDDO
      DO IDIM=1,NDIM
      GSIGMAT(IDIM,IDIM)=GINVMAT(IDIM,IDIM)+SIGWMAT(IMSC,IDIM,IDIM)
	DELWMAT(IMSC,IDIM,IDIM)=(ZMSC+EFRM)*OIMPMAT(IDIM,IDIM)-
     &EIMPMAT(IDIM,IDIM)+SIGIMAT(IDIM,IDIM)-GSIGMAT(IDIM,IDIM)
      ENDDO
C **********************************************
C EIGENVALUE ANALYSIS      
      ELSEIF(KDELFUN(L,IATOM).EQ.3)THEN
      ALLOCATE(GF(NDIM,NDIM))
      ALLOCATE(SE(NDIM,NDIM))
      ALLOCATE(HG(NDIM,NDIM))
      ALLOCATE(HS(NDIM,NDIM))
      ALLOCATE(OG(NDIM,NDIM))
      ALLOCATE(OS(NDIM,NDIM))
      ALLOCATE(GT(NDIM,NDIM))
      ALLOCATE(ST(NDIM,NDIM))
      ALLOCATE(EG(NDIM))
      ALLOCATE(ES(NDIM))
C Find roots of Green function inverted and self-energy
      DO IDIM1=1,NDIM                         !!! over idim1
      DO IDIM=1,NDIM                          !!! over idim
      GF(IDIM1,IDIM)=GLOCMAT(IMSC,IDIM1,IDIM)
      SE(IDIM1,IDIM)=SIGWMAT(IMSC,IDIM1,IDIM)
      HS(IDIM1,IDIM)=SIGWMAT(IMSC,IDIM1,IDIM)
      HG(IDIM1,IDIM)=GINVMAT(IDIM1,IDIM)
      OS(IDIM1,IDIM)=(0.D0,0.D0)
      OG(IDIM1,IDIM)=(0.D0,0.D0)
      ENDDO                                   !!! over idim
      OS(IDIM1,IDIM1)=(1.D0,0.D0)
      OG(IDIM1,IDIM1)=(1.D0,0.D0)
      ENDDO                                   !!! over idim1
      CALL LIB_CMPEIG1A(NDIM,HS,OS,ES,1,1,1,IERR,0,1.D-05)
      CALL LIB_CMPEIG1A(NDIM,HG,OG,EG,1,1,1,IERR,0,1.D-05)
C TEST ARRAYS
      DO IDIM1=1,NDIM
      DO IDIM =1,NDIM
      GT(IDIM1,IDIM)=(0.D0,0.D0)
      ST(IDIM1,IDIM)=(0.D0,0.D0)
      DO IBND=1,NDIM
      GT(IDIM1,IDIM)=GT(IDIM1,IDIM)+
     &HG(IDIM1,IBND)/EG(IBND)*OG(IDIM,IBND)  ! Green function
      ST(IDIM1,IDIM)=ST(IDIM1,IDIM)+
     &OS(IDIM1,IBND)*ES(IBND)*HS(IDIM,IBND)  ! Self-energy
      ENDDO
      IF(ABS(GT(IDIM1,IDIM)-GF(IDIM1,IDIM)).GT.1.D-07)
     &WRITE(IUN,*)'<IMP_HYBFUN>: Diagonal. rep for G(w) fails:',
     &GT(IDIM1,IDIM),GF(IDIM1,IDIM)
      IF(ABS(ST(IDIM1,IDIM)-SE(IDIM1,IDIM)).GT.1.D-07)
     &WRITE(IUN,*)'<IMP_HYBFUN>: Diagonal. rep for S(w) fails:',
     &ST(IDIM1,IDIM),SE(IDIM1,IDIM)
      ENDDO
      ENDDO
C IF EIGENVALUES IN BOTH SELF-ENERGY AND INVERSE GREEN FUNCTION ARE LARGER
C THAN CUTOFF VALUE CANCEL THEM OUT
      NG=0
      NS=0
      IF(ABS(PDMP).GT.0.D0)PEXC=1.D0/PDMP
      IF(ABS(PDMP).EQ.0.D0)PEXC=1.D+10
      DO IBND=1,NDIM
      IF(ABS(DREAL(EG(IBND))).LE.PEXC)NG=IDIM
      IF(ABS(DREAL(ES(IBND))).LE.PEXC)NS=IDIM
      ENDDO
      NCUT=MAX(NG,NS)
C PREPARE A SUM OF GREEN FUNCTION^-1 +SELF-ENERGY
C WHERE ALL SIMILAR POLES ARE EXCLUDED
      DO IDIM1=1,NDIM
      DO IDIM =1,NDIM
      GSIGMAT(IDIM1,IDIM)=(0.D0,0.D0)
      DO IBND=1,NCUT
      GSIGMAT(IDIM1,IDIM)=GSIGMAT(IDIM1,IDIM)+
     &OG(IDIM1,IBND)*EG(IBND)*HG(IDIM,IBND)+       ! Green function inverted
     &OS(IDIM1,IBND)*ES(IBND)*HS(IDIM,IBND)        ! Self-energy
      ENDDO
	DELWMAT(IMSC,IDIM1,IDIM)=(ZMSC+EFRM)*OIMPMAT(IDIM1,IDIM)-
     &EIMPMAT(IDIM1,IDIM)+SIGIMAT(IDIM1,IDIM)-GSIGMAT(IDIM1,IDIM)
      ENDDO
      ENDDO
      DEALLOCATE(GF,SE,HG,HS,OG,OS,EG,ES,GT,ST)
      ENDIF

cccc  
      if(kgrd.eq.1)w=dreal(wmsc(imsc))
      if(kgrd.eq.2)w=dimag(wmsc(imsc))
      write(98,fmt='(7(1x,g12.5))')w,
     &dreal(glocmat(imsc,1,1)),dreal(sigwmat(imsc,1,1)),
     &dreal(delwmat(imsc,1,1)),
     &dimag(glocmat(imsc,1,1)),dimag(sigwmat(imsc,1,1)),
     &dimag(delwmat(imsc,1,1))


 1000 CONTINUE                                      !!! over frequencies	
C Limiting behavior
      DO IDIM1=1,NDIM                               !!! over idim1
      DO IDIM =1,NDIM                               !!! over idim
      IF(KGRD.EQ.1)DELIMAT(IDIM1,IDIM)=(0.D0,0.D0)
      IF(KGRD.EQ.2)DELIMAT(IDIM1,IDIM)=DELWMAT(NMSC,IDIM1,IDIM)
      ENDDO                                         !!! over idim
      ENDDO                                         !!! over idim1
C MEMORY DEALLOCATIONS
      DEALLOCATE(GINVMAT,GSIGMAT,WA)
	END SUBROUTINE IMP_HYBFUN
