      SUBROUTINE IMP_HYBINT(L,IATOM,DHUBMAT,VDBCMAT,EIMPMAT,
     &     ELOCMAT,OIMPMAT,DELWMAT,DELIMAT,VRHBMAT,WRHBMAT,
     &     PRHBMAT,ORHBMAT,IERR)
**************************************************************
*  Subroutine finds rational interpolation for hybridization * 
**************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                 !!! from setup
      USE COM_CONTROL ,ONLY: LIFT,LMTO,IDMF                          !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS,ILSB         !!! from readini
      USE COM_MSBMESH ,ONLY: TEMP,WMSC,NMSC,OBND,FMSC,DMSC,KGRD      !!! from readhub
	USE COM_IMPDAT  ,ONLY: NRUNIMP,KSTATES,KCRDSYS,NPLDIMP         !!! from readhub
      USE COM_HUBDAT  ,ONLY: MCRL,LCRL,PDMP,KSOLVER,KDBLCNT          !!! from readhub
     &                      ,CDBLCNT,KDELINT,KDELRAT
      USE COM_FERMI   ,ONLY: EF                                      !!! from ttrints
      USE COM_LMTOUT  ,ONLY: SCRFILE                                 !!! from readini
      USE COM_MASHDEP ,ONLY: NVAL,LENCMP                             !!! from setup
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                         !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 UIMP(2*(2*L+1),2*(2*L+1),2*(2*L+1),2*(2*L+1))
	COMPLEX*16 DELWMAT(0:NMSCMEM+1,2*(2*L+1),2*(2*L+1))
     &          ,DHUBMAT(         2*(2*L+1),2*(2*L+1))
     &          ,VDBCMAT(         2*(2*L+1),2*(2*L+1))
     &          ,EIMPMAT(         2*(2*L+1),2*(2*L+1))
     &          ,ELOCMAT(         2*(2*L+1),2*(2*L+1))
     &          ,OIMPMAT(         2*(2*L+1),2*(2*L+1))
     &          ,DELIMAT(         2*(2*L+1),2*(2*L+1))
     &          ,VRHBMAT(         2*(2*L+1),2*(2*L+1),NPLDMEM)
     &          ,WRHBMAT(         2*(2*L+1),2*(2*L+1),NPLDMEM)
     &          ,PRHBMAT(         2*(2*L+1),2*(2*L+1),NPLDMEM)
     &          ,ORHBMAT(         2*(2*L+1),2*(2*L+1),NPLDMEM)
	COMPLEX*16 DIM,ZMSC,CAVR
	CHARACTER HELP*40,TCTRL*10,TCTRM*10,LIB_TDP*10
	EXTERNAL IMP_HYBDIF
	REAL*8, ALLOCATABLE :: FTMP(:),DTMP(:),GTMP(:),HTMP(:),WTMP(:)
      REAL*8, ALLOCATABLE :: WINP(:),WOUT(:),XTMP(:),SINT(:),XVEC(:)
      REAL*8, ALLOCATABLE :: DOCC(:,:),DTOT(:,:),UOCC(:,:)
	COMPLEX*16, ALLOCATABLE :: EIMPDEG(:,:)
	COMPLEX*16, ALLOCATABLE :: ELOCDEG(:,:)
	COMPLEX*16, ALLOCATABLE :: OIMPDEG(:,:)
	COMPLEX*16, ALLOCATABLE :: DHUBDEG(:,:)
	COMPLEX*16, ALLOCATABLE :: VDBCDEG(:,:)
	COMPLEX*16, ALLOCATABLE :: DELIDEG(:,:)
	COMPLEX*16, ALLOCATABLE :: DELWDEG(:,:,:)
	COMPLEX*16, ALLOCATABLE :: VRHBDEG(:,:,:)
	COMPLEX*16, ALLOCATABLE :: WRHBDEG(:,:,:)
	COMPLEX*16, ALLOCATABLE :: PRHBDEG(:,:,:)
	COMPLEX*16, ALLOCATABLE :: ORHBDEG(:,:,:)
      COMPLEX*16, ALLOCATABLE :: VARR(:,:),WARR(:,:),PINV(:,:),WORK(:)
      COMPLEX*16, ALLOCATABLE :: HINP(:),HOUT(:),ZOUT(:),PCOF(:),WCOF(:)
      COMPLEX*16, ALLOCATABLE :: WORK1(:),WORK2(:)
      DATA PI/3.141592653589793D0/,DIM/(0.D0,1.D0)/,EPSDEG/1.D-05/
      CALL ABORTNOW()
C MEMORY ALLOCATIONS
	IERR=0
	ISORT=IS(IATOM)
	NDIM=2*(2*L+1)
	NPLD=NPLDIMP(L,IATOM)
	NMOM=MAX(NPLD,5)
	EFRM=EF
	IREC=0
	ILEN=0
C DO OVER SOLUTIONS OF IMPURITY MODEL
	DO 1000 IRUN=1,NRUNIMP(L,IATOM)
C Count states which participate in this run
	NDEG=0 ! this is degeneracy within this run
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).NE.0)NDEG=NDEG+1
	ENDDO
	IF(NDEG.EQ.0)GOTO 1000
C MEMORY ALLOCATIONS
C Impurity arrays
	ALLOCATE(EIMPDEG(NDEG,NDEG))
	ALLOCATE(ELOCDEG(NDEG,NDEG))
	ALLOCATE(OIMPDEG(NDEG,NDEG))
	ALLOCATE(DHUBDEG(NDEG,NDEG))
	ALLOCATE(VDBCDEG(NDEG,NDEG))
	ALLOCATE(DELIDEG(NDEG,NDEG))
	ALLOCATE(DELWDEG(0:NMSCMEM+1,NDEG,NDEG))
	ALLOCATE(VRHBDEG(NDEG,NDEG,NPLDMEM))
	ALLOCATE(WRHBDEG(NDEG,NDEG,NPLDMEM))
	ALLOCATE(PRHBDEG(NDEG,NDEG,NPLDMEM))
	ALLOCATE(ORHBDEG(NDEG,NDEG,NPLDMEM))
	ALLOCATE(PCOF(NPLDMEM))
	ALLOCATE(WCOF(NPLDMEM))
C ****************************************************
C REALLOCATE INPUT ARRAYS WITHIN CURRENT DEGENERACY
	IDEG1=0
	DO IDIM1=1,NDIM
	IF(KSTATES(IDIM1,IRUN,L,IATOM).EQ.0)CYCLE
	IDEG1=IDEG1+1
	IDEG=0
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.0)CYCLE
	IDEG=IDEG+1
C Impurity levels, self-energy limits
	EIMPDEG(IDEG1,IDEG)=EIMPMAT(IDIM1,IDIM)
	ELOCDEG(IDEG1,IDEG)=ELOCMAT(IDIM1,IDIM)
	OIMPDEG(IDEG1,IDEG)=OIMPMAT(IDIM1,IDIM)
	DHUBDEG(IDEG1,IDEG)=DHUBMAT(IDIM1,IDIM)
	VDBCDEG(IDEG1,IDEG)=VDBCMAT(IDIM1,IDIM)
	DELIDEG(IDEG1,IDEG)=DELIMAT(IDIM1,IDIM)
C Self-energy, bath and hybridization
	DO IMSC=0,NMSC
	DELWDEG(IMSC,IDEG1,IDEG)=DELWMAT(IMSC,IDIM1,IDIM)
	ENDDO
	DO IPOL=1,NPLD
	VRHBDEG(IDEG1,IDEG,IPOL)=VRHBMAT(IDIM1,IDIM,IPOL)
	WRHBDEG(IDEG1,IDEG,IPOL)=WRHBMAT(IDIM1,IDIM,IPOL)
	PRHBDEG(IDEG1,IDEG,IPOL)=PRHBMAT(IDIM1,IDIM,IPOL)
	ORHBDEG(IDEG1,IDEG,IPOL)=ORHBMAT(IDIM1,IDIM,IPOL)
	ENDDO
	ENDDO
	ENDDO
C Find moments of the Hybridization function
      ALLOCATE(DOCC(-NMOM:+NMOM,NDEG))
      ALLOCATE(UOCC(-NMOM:+NMOM,NDEG))
      ALLOCATE(DTOT(-NMOM:+NMOM,NDEG))
	IDEG=0
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.0)CYCLE
	IDEG=IDEG+1
	DO IMOM=-NMOM,+NMOM
	DOCC(IMOM,IDEG)=0.D0
	DTOT(IMOM,IDEG)=0.D0
	IF(KGRD.EQ.1)THEN
	DO IMSC=0,NMSC
	WOMG=DREAL(WMSC(IMSC))
	WMOM=0.D0
	IF(ABS(WOMG).GT.1.D-08)WMOM=WOMG**IMOM
	DOCC(IMOM,IDEG)=DOCC(IMOM,IDEG)+WMOM*FMSC(IMSC)*
     &DIMAG(DELWDEG(IMSC,IDEG,IDEG))*FERMIFUN(WOMG,TEMP)
	DTOT(IMOM,IDEG)=DTOT(IMOM,IDEG)+WMOM*FMSC(IMSC)*
     &DIMAG(DELWDEG(IMSC,IDEG,IDEG))
	ENDDO
	ENDIF
	UOCC(IMOM,IDEG)=DTOT(IMOM,IDEG)-DOCC(IMOM,IDEG)
	ENDDO
	ENDDO
C **********************************************
C Find rational representation for Delta(w) using 
C algorithm assuming moments: 2 poles
      IF(KDELINT(L,IATOM).EQ.1)THEN
      IF(KGRD.NE.1)
     &CALL FULLSTOP('<IMP_HYBINT>:: Grid should be REAL for MOM1 fit')
	IF(NPLD.NE.1)
     &CALL FULLSTOP('<IMP_HYBINT>:: Npld should be 1 for MOM1 fit')
      ALLOCATE(WTMP(NPLDMEM))
      ALLOCATE(HTMP(NPLDMEM))
	IDEG=0
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.0)CYCLE
	IDEG=IDEG+1
C States below 0
	CALL LIB_RATMOM2(DOCC(0,IDEG),DOCC(1,IDEG),
     &                 HTMP(1),WTMP(1),-1.D0)
	DO IPOL=1,NPLD
	VRHBDEG(IDEG,IDEG,IPOL)=SQRT(ABS(HTMP(IPOL)))
	WRHBDEG(IDEG,IDEG,IPOL)=SQRT(ABS(HTMP(IPOL)))
	PRHBDEG(IDEG,IDEG,IPOL)=WTMP(IPOL)
	ORHBDEG(IDEG,IDEG,IPOL)=1.D0
	ENDDO
	ENDDO
	DEALLOCATE(WTMP,HTMP)
C **********************************************
C Find rational representation for Delta(w) using 
C algorithm assuming moments: 2 poles
      ELSEIF(KDELINT(L,IATOM).EQ.2)THEN
      IF(KGRD.NE.1)
     &CALL FULLSTOP('<IMP_HYBINT>:: Grid should be REAL for MOM2 fit')
	IF(NPLD.NE.2)
     &CALL FULLSTOP('<IMP_HYBINT>:: Npld should be 2 for MOM2 fit')
      ALLOCATE(WTMP(NPLDMEM))
      ALLOCATE(HTMP(NPLDMEM))
	IDEG=0
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.0)CYCLE
	IDEG=IDEG+1
C States below 0
	CALL LIB_RATMOM2(DOCC(0,IDEG),DOCC(1,IDEG),
     &                 HTMP(1),WTMP(1),-1.D0)
C States above 0
	CALL LIB_RATMOM2(UOCC(0,IDEG),UOCC(1,IDEG),
     &                 HTMP(2),WTMP(2),+1.D0)
	DO IPOL=1,NPLD
	VRHBDEG(IDEG,IDEG,IPOL)=SQRT(ABS(HTMP(IPOL)))
	WRHBDEG(IDEG,IDEG,IPOL)=SQRT(ABS(HTMP(IPOL)))
	PRHBDEG(IDEG,IDEG,IPOL)=WTMP(IPOL)
	ORHBDEG(IDEG,IDEG,IPOL)=1.D0
	ENDDO
	ENDDO
	DEALLOCATE(WTMP,HTMP)
C **********************************************
C Find rational representation for Delta(w) using 
C algorithm assuming moments: 3 poles
	ELSEIF(KDELINT(L,IATOM).EQ.3)THEN
      IF(KGRD.NE.1)
     &CALL FULLSTOP('<IMP_HYBINT>:: Grid should be REAL for MOM3 fit')
	IF(NPLD.NE.3)
     &CALL FULLSTOP('<IMP_HYBINT>:: Npld should be 3 for MOM3 fit')
      ALLOCATE(WTMP(NPLDMEM))
      ALLOCATE(HTMP(NPLDMEM))
	IDEG=0
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.0)CYCLE
	IDEG=IDEG+1
C Occupied states
	CALL LIB_RATMOM4(DOCC( 0,IDEG),DOCC( 1,IDEG),
     &                 DOCC( 2,IDEG),DOCC(-1,IDEG),
     &                 HTMP( 1),HTMP( 2),
     &                 WTMP( 1),WTMP( 2),-1.D0)
C States above 0
	CALL LIB_RATMOM2(UOCC(0,IDEG),UOCC(1,IDEG),
     &                 HTMP(3),WTMP(3),+1.D0)
	DO IPOL=1,NPLD
	VRHBDEG(IDEG,IDEG,IPOL)=SQRT(ABS(HTMP(IPOL)))
	WRHBDEG(IDEG,IDEG,IPOL)=SQRT(ABS(HTMP(IPOL)))
	PRHBDEG(IDEG,IDEG,IPOL)=WTMP(IPOL)
	ORHBDEG(IDEG,IDEG,IPOL)=1.D0
	ENDDO
	ENDDO
	DEALLOCATE(WTMP,HTMP)
C **********************************************
C Find rational representation for Delta(w) using 
C algorithm assuming moments: 4 poles
	ELSEIF(KDELINT(L,IATOM).EQ.4)THEN
      IF(KGRD.NE.1)
     &CALL FULLSTOP('<IMP_HYBINT>:: Grid should be REAL for MOM4 fit')
	IF(NPLD.NE.4)
     &CALL FULLSTOP('<IMP_HYBINT>:: Npld should be 4 for MOM4 fit')
      ALLOCATE(WTMP(NPLDMEM))
      ALLOCATE(HTMP(NPLDMEM))
	IDEG=0
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.0)CYCLE
	IDEG=IDEG+1
C Occupied states
	CALL LIB_RATMOM4(DOCC( 0,IDEG),DOCC( 1,IDEG),
     &                 DOCC( 2,IDEG),DOCC(-1,IDEG),
     &                 HTMP( 1),HTMP( 2),
     &                 WTMP( 1),WTMP( 2),-1.D0)
C Unoccupied states
	CALL LIB_RATMOM4(UOCC( 0,IDEG),UOCC( 1,IDEG),
     &                 UOCC( 2,IDEG),UOCC(-1,IDEG),
     &                 HTMP( 3),HTMP( 4),
     &                 WTMP( 3),WTMP( 4),+1.D0)
	DO IPOL=1,NPLD
	VRHBDEG(IDEG,IDEG,IPOL)=SQRT(ABS(HTMP(IPOL)))
	WRHBDEG(IDEG,IDEG,IPOL)=SQRT(ABS(HTMP(IPOL)))
	PRHBDEG(IDEG,IDEG,IPOL)=WTMP(IPOL)
	ORHBDEG(IDEG,IDEG,IPOL)=1.D0
	ENDDO
	ENDDO
	DEALLOCATE(WTMP,HTMP)
C **********************************************
C Find rational representation for Delta(w) using 
C algorithm assuming moments: 6 poles
	ELSEIF(KDELINT(L,IATOM).EQ.5)THEN
      IF(KGRD.NE.1)
     &CALL FULLSTOP('<IMP_HYBINT>:: Grid should be REAL for MOM5 fit')
	IF(NPLD.NE.5)
     &CALL FULLSTOP('<IMP_HYBINT>:: Npld should be 5 for MOM5 fit')
      ALLOCATE(WTMP(NPLDMEM))
      ALLOCATE(HTMP(NPLDMEM))
	IDEG=0
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.0)CYCLE
	IDEG=IDEG+1
C Occupied states
	CALL LIB_RATMOM6(DOCC( 0,IDEG),DOCC( 1,IDEG),
     &                 DOCC( 2,IDEG),DOCC( 3,IDEG),
     &                 DOCC(-1,IDEG),DOCC(-2,IDEG),
     &   HTMP( 1),HTMP( 2),HTMP( 3),
     &   WTMP( 1),WTMP( 2),WTMP( 3),-1.D0)
C Unoccupied states
	CALL LIB_RATMOM4(UOCC( 0,IDEG),UOCC( 1,IDEG),
     &                 UOCC( 2,IDEG),UOCC(-1,IDEG),
     &                 HTMP( 4),HTMP( 5),
     &                 WTMP( 4),WTMP( 5),+1.D0)
	DO IPOL=1,NPLD
	VRHBDEG(IDEG,IDEG,IPOL)=SQRT(ABS(HTMP(IPOL)))
	WRHBDEG(IDEG,IDEG,IPOL)=SQRT(ABS(HTMP(IPOL)))
	PRHBDEG(IDEG,IDEG,IPOL)=WTMP(IPOL)
	ORHBDEG(IDEG,IDEG,IPOL)=1.D0
	ENDDO
	ENDDO
	DEALLOCATE(WTMP,HTMP)
C **********************************************
C Find rational representation for Delta(w) using 
C algorithm assuming moments: 6 poles
	ELSEIF(KDELINT(L,IATOM).EQ.6)THEN
      IF(KGRD.NE.1)
     &CALL FULLSTOP('<IMP_HYBINT>:: Grid should be REAL for MOM6 fit')
	IF(NPLD.NE.6)
     &CALL FULLSTOP('<IMP_HYBINT>:: Npld should be 6 for MOM6 fit')
      ALLOCATE(WTMP(NPLDMEM))
      ALLOCATE(HTMP(NPLDMEM))
	IDEG=0
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.0)CYCLE
	IDEG=IDEG+1
C Occupied states
	CALL LIB_RATMOM6(DOCC( 0,IDEG),DOCC( 1,IDEG),
     &                 DOCC( 2,IDEG),DOCC( 3,IDEG),
     &                 DOCC(-1,IDEG),DOCC(-2,IDEG),
     &   HTMP( 1),HTMP( 2),HTMP( 3),
     &   WTMP( 1),WTMP( 2),WTMP( 3),-1.D0)
C Unoccupied states
	CALL LIB_RATMOM6(UOCC( 0,IDEG),UOCC( 1,IDEG),
     &                 UOCC( 2,IDEG),UOCC( 3,IDEG),
     &                 UOCC(-1,IDEG),UOCC(-2,IDEG),
     &   HTMP( 4),HTMP( 5),HTMP( 6),
     &   WTMP( 4),WTMP( 5),WTMP( 6),+1.D0)
	DO IPOL=1,NPLD
	VRHBDEG(IDEG,IDEG,IPOL)=SQRT(ABS(HTMP(IPOL)))
	WRHBDEG(IDEG,IDEG,IPOL)=SQRT(ABS(HTMP(IPOL)))
	PRHBDEG(IDEG,IDEG,IPOL)=WTMP(IPOL)
	ORHBDEG(IDEG,IDEG,IPOL)=1.D0
	ENDDO
	ENDDO
	DEALLOCATE(WTMP,HTMP)
C **********************************************
C Find rational representation for Delta(w) using 
C algorithm assuming arbitrary # of moments
	ELSEIF(KDELINT(L,IATOM).EQ.7)THEN
      IF(KGRD.NE.1)
     &CALL FULLSTOP('<IMP_HYBINT>:: Grid should be REAL for MOMN fit')
	IF(MOD(NPLD,2).NE.0)
     &CALL FULLSTOP('<IMP_HYBINT>:: Npld should be Even for MOMN fit')
      ALLOCATE(WTMP(NPLDMEM))
      ALLOCATE(HTMP(NPLDMEM))
	IDEG=0
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.0)CYCLE
	IDEG=IDEG+1
C Occupied states
	CALL LIB_RAPX(DOCC(0,IDEG),NPLD-1,HTMP(1),
     &              WTMP(1),NPLD/2,IERR,-1.D0,0)
	IF(IERR.GT.0)CALL FULLSTOP('<IMP_HYBINT>:: ERROR IN LIB_RAPX')
C Unoccupied states
	CALL LIB_RAPX(UOCC(0,IDEG),NPLD-1,HTMP(NPLD/2+1),
     &WTMP(NPLD/2+1),NPLD/2,IERR,+1.D0,0)
	IF(IERR.GT.0)CALL FULLSTOP('<IMP_HYBINT>:: ERROR IN LIB_RAPX')
	DO IPOL=1,NPLD
	VRHBDEG(IDEG,IDEG,IPOL)=SQRT(ABS(HTMP(IPOL)))
	WRHBDEG(IDEG,IDEG,IPOL)=SQRT(ABS(HTMP(IPOL)))
	PRHBDEG(IDEG,IDEG,IPOL)=WTMP(IPOL)
	ORHBDEG(IDEG,IDEG,IPOL)=1.D0
	ENDDO
	ENDDO
	DEALLOCATE(WTMP,HTMP)
C ******************************************************
C Find rational representation for Delta(w) using 
C simple fit to the data on the real axis
C ******************************************************
      ELSEIF(KDELINT(L,IATOM).EQ.8)THEN
      IF(KGRD.NE.1)
     &CALL FULLSTOP('<IMP_HYBINT>:: Grid should be REAL for GRID fit')
      ALLOCATE(SINT(NPLDMEM))
	IDEG=0
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.0)CYCLE
	IDEG=IDEG+1
C Set grid if not known
      SUM=0.D0
	DO IPOL=1,NPLD-1
      SUM=SUM+ABS(PRHBDEG(IDEG,IDEG,IPOL+1)-PRHBDEG(IDEG,IDEG,IPOL))
      ENDDO
      IF(SUM.LE.1.D-08.AND.NPLD.GT.1)THEN
      WMIN=DREAL(WMSC(0))
      WMAX=DREAL(WMSC(NMSC))
      STEP=(WMAX-WMIN)/DBLE(NPLD-1)
      DO IPOL=1,NPLD
      PRHBDEG(IDEG,IDEG,IPOL)=WMIN+STEP*DBLE(IPOL-1)
      ENDDO
      PRHBDEG(IDEG,IDEG,NPLD)=WMAX
      ENDIF
C Set integration intervals
      DO IPOL=1,NPLD
      IF(IPOL.GT.1.AND.IPOL.LT.NPLD)THEN
      DL=PRHBDEG(IDEG,IDEG,IPOL)-PRHBDEG(IDEG,IDEG,IPOL-1)
      DR=PRHBDEG(IDEG,IDEG,IPOL+1)-PRHBDEG(IDEG,IDEG,IPOL)
      SINT(IPOL)=MIN(DL/2.D0,DR/2.D0)
      ELSEIF(IPOL.EQ.1.AND.NPLD.NE.1)THEN
      DR=PRHBDEG(IDEG,IDEG,IPOL+1)-PRHBDEG(IDEG,IDEG,IPOL)
      SINT(IPOL)=DR/2.D0
      ELSEIF(IPOL.EQ.NPLD.AND.NPLD.NE.1)THEN
      DL=PRHBDEG(IDEG,IDEG,IPOL)-PRHBDEG(IDEG,IDEG,IPOL-1)
      SINT(IPOL)=DL/2.D0
      ELSE
      CALL FULLSTOP('<IMP_HYBINT>: NPLD.EQ.1 is not assumed')
      ENDIF
      ENDDO
C Integrate ImDelta(w) over the intervals
      DO IPOL=1,NPLD
      WLEF=PRHBDEG(IDEG,IDEG,IPOL)-SINT(IPOL)
      WRIT=PRHBDEG(IDEG,IDEG,IPOL)+SINT(IPOL)
      VEFF=0.D0
      DO IMSC=0,NMSC
      IF(DREAL(WMSC(IMSC)).LT.WLEF.OR.DREAL(WMSC(IMSC)).GT.WRIT)CYCLE
      VEFF=VEFF+DIMAG(DELWDEG(IMSC,IDEG,IDEG))*FMSC(IMSC)
      ENDDO
C Store the result as an effective hopping
      VRHBDEG(IDEG,IDEG,IPOL)=SQRT(ABS(VEFF))
      WRHBDEG(IDEG,IDEG,IPOL)=SQRT(ABS(VEFF))
      ENDDO
      ENDDO      
      DEALLOCATE(SINT)
C ******************************************************
C Find rational representation for Delta(w) using 
C conjugate gradient search
C ******************************************************
      ELSEIF(KDELINT(L,IATOM).EQ.9)THEN
      NLEN=2*NPLD
      ALLOCATE(FTMP(0:NMSC))
      ALLOCATE(DTMP(0:NMSC))
      ALLOCATE(GTMP(NLEN))
      ALLOCATE(HTMP(NLEN*NLEN+4))
      ALLOCATE(WTMP(NLEN*NLEN+4))
      ALLOCATE(XTMP(NLEN))
      ALLOCATE(XVEC(NLEN))
C Remember content of the FMSC/DMSC arrays
      DO IMSC=0,NMSC
      FTMP(IMSC)=FMSC(IMSC)
      DTMP(IMSC)=DMSC(IMSC)
      ENDDO
	IDEG=0
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.0)CYCLE
	IDEG=IDEG+1
C Set hybridization
	DO IMSC=0,NMSC
	FMSC(IMSC)=DREAL(DELWDEG(IMSC,IDEG,IDEG))
	DMSC(IMSC)=DIMAG(DELWDEG(IMSC,IDEG,IDEG))
	ENDDO
C Set initial approximation to the parameters
      VPAR=0.D0
	DO IPOL=1,NPLD
	VPAR=VPAR+ABS(VRHBDEG(IDEG,IDEG,IPOL))+
     &          ABS(WRHBDEG(IDEG,IDEG,IPOL))
	ENDDO
C Use previous fit
	IF(VPAR.GE.1.D-10)THEN
      DO ILEN=1,NPLD
      XVEC(ILEN)=SQRT(ABS(DREAL(VRHBDEG(IDEG,IDEG,IPOL))*
     &                    DREAL(WRHBDEG(IDEG,IDEG,IPOL))))
      ENDDO
      DO ILEN=1,NPLD
      XVEC(ILEN+NPLD)=DREAL(PRHBDEG(IDEG,IDEG,IPOL))
      ENDDO
      ELSE
C Generate some approximation
      DO ILEN=1,NPLD
      XVEC(ILEN)=1.D0
      ENDDO
      IF(NPLD.GT.1)STEP=1.D0/DBLE(NPLD-1)
      IF(NPLD.LE.1)STEP=0.D0
      DO ILEN=1,NPLD
      XVEC(ILEN+NPLD)=OBND*(DBLE(ILEN-1)*STEP-0.5D0)
      ENDDO
      ENDIF
      DO ILEN=1,NLEN
      XTMP(ILEN)=ABS(XVEC(ILEN))+1.D-15
      ENDDO
C Call conjugate gradient search subroutine
      CALL LIB_CONJGRAD(IMP_HYBDIF,NLEN,XVEC,FMIN,GTMP,HTMP,WTMP,
     &                   -0.5D0,XTMP,1.D-05,1.D-05,1,5000,0,IEXIT)
C Rational interpolation coefficients are obtained
	DO IPOL=1,NPLD
	VRHBDEG(IDEG,IDEG,IPOL)=XVEC(IPOL)
	WRHBDEG(IDEG,IDEG,IPOL)=XVEC(IPOL)
	PRHBDEG(IDEG,IDEG,IPOL)=XVEC(IPOL+NPLD)
	ORHBDEG(IDEG,IDEG,IPOL)=1.D0
	ENDDO
      ENDDO
C Rewind arrays back
      DO IMSC=0,NMSC
      FMSC(IMSC)=FTMP(IMSC)
      DMSC(IMSC)=DTMP(IMSC)
      ENDDO
      DEALLOCATE(GTMP,HTMP,WTMP,XTMP,XVEC,FTMP,DTMP)
C ******************************************************
C Find rational representation for Delta(w) using 
C Pade approximation to the data on the imaginary axis
C ******************************************************
      ELSEIF(KDELINT(L,IATOM).EQ.10)THEN
      IF(KGRD.NE.2)
     &CALL FULLSTOP('<IMP_HYBINT>:: Grid should be IMAG for PADE fit')
      ALLOCATE(WINP(0:NMSC))
      ALLOCATE(HINP(0:NMSC))
      ALLOCATE(WOUT(2*NPLDMEM))
      ALLOCATE(ZOUT(2*NPLDMEM))
      ALLOCATE(HOUT(2*NPLDMEM))
	IDEG=0
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.0)CYCLE
	IDEG=IDEG+1
C Set unform imaginary axis grid
      DO IMSC=0,NMSC
      WINP(IMSC)=DIMAG(WMSC(IMSC))
      HINP(IMSC)=DELWDEG(IMSC,IDEG,IDEG)
      ENDDO
      WMIN=DIMAG(WMSC(0))
      WMAX=DIMAG(WMSC(NMSC))
      STEP=(WMAX-WMIN)/DBLE(2*NPLD-1)
      DO IPOL=1,2*NPLD
      WOUT(IPOL)=WMIN+STEP*DBLE(IPOL-1)
      ZOUT(IPOL)=DCMPLX(0.D0,WOUT(IPOL))
      ENDDO
      WOUT(1)=WMIN
      WOUT(2*NPLD)=WMAX
      ZOUT(1)=DCMPLX(0.D0,WMIN)
      ZOUT(2*NPLD)=DCMPLX(0.D0,WMAX)
      CALL LIB_CSPLINES(NMSC+1,WINP,HINP,2*NPLD,WOUT,HOUT)
C Make Pade fit
	CALL LIB_PADEPOLES(ZOUT,HOUT,PCOF,WCOF,NPLD)
      DO IPOL=1,NPLD
      PRHBDEG(IDEG,IDEG,IPOL)=DREAL(PCOF(IPOL))
      VRHBDEG(IDEG,IDEG,IPOL)=SQRT(ABS(DREAL(WCOF(IPOL))))
      WRHBDEG(IDEG,IDEG,IPOL)=SQRT(ABS(DREAL(WCOF(IPOL))))
      ENDDO
      ENDDO
      DEALLOCATE(WINP,HINP,WOUT,ZOUT,HOUT)
      ENDIF
C ******************************************************
C Force rational representation for Delta(w)
      IF(KDELRAT(L,IATOM).EQ.1)THEN
	ALLOCATE(PINV(NDEG,NDEG))
	ALLOCATE(VARR(NDEG,NDEG))
	ALLOCATE(WARR(NDEG,NDEG))
	ALLOCATE(WORK(NDEG))
C Do over frequencies
	DO IMSC=0,NMSC                          !!! over frequencies
	ZMSC=WMSC(IMSC)
C Set zero
	DO IDEG1=1,NDEG
	DO IDEG=1,NDEG
	DELWDEG(IMSC,IDEG1,IDEG)=(0.D0,0.D0)
	ENDDO
	ENDDO
C DO OVER HYBRIDIZATION POLES
	DO IPOL=1,NPLD                          !!! over poles
C Set up matrices
	DO IDEG1=1,NDEG
	DO IDEG=1,NDEG
	PINV(IDEG1,IDEG)=(0.D0,0.D0)
	VARR(IDEG1,IDEG)=(0.D0,0.D0)
	WARR(IDEG1,IDEG)=(0.D0,0.D0)
	ENDDO
	ENDDO
	DO IDEG1=1,NDEG
	DO IDEG=1,NDEG
	PINV(IDEG1,IDEG)=
C     (ZMSC+EFRM)*
     &(ZMSC+DCMPLX(0.D0,0.D0))*
     &ORHBDEG(IDEG1,IDEG,IPOL)-PRHBDEG(IDEG1,IDEG,IPOL)
	VARR(IDEG1,IDEG)=VRHBDEG(IDEG1,IDEG,IPOL)
	WARR(IDEG1,IDEG)=WRHBDEG(IDEG1,IDEG,IPOL)
	ENDDO
	ENDDO
C Invert matrix
	CALL LIB_CINV(NDIM,PINV,NDIM,WORK,IFAIL)
	IF(IFAIL.NE.0)THEN
      WRITE(IUN,*)'<IMP_HYBINT>:: Error in inversion program'
	DO IDEG1=1,NDEG
	DO IDEG=1,NDEG
	PINV(IDEG1,IDEG)=(0.D0,0.0D0)
	ENDDO
	ENDDO
      ENDIF
C Construct product
	DO IDEG1=1,NDEG
	DO IDEG=1,NDEG
	DO JDEG1=1,NDEG
	DO JDEG=1,NDEG
	DELWDEG(IMSC,IDEG1,IDEG)=DELWDEG(IMSC,IDEG1,IDEG)+
     &VARR(IDEG1,JDEG1)*PINV(JDEG1,JDEG)*WARR(JDEG,IDEG) ! swapped indexes in Warr !
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO                                   !!! over poles
	ENDDO                                   !!! over frequencies
	DEALLOCATE(PINV,VARR,WARR,WORK)
      ENDIF
C Print poles and coefficients
	WRITE(IUN,10100)
	WRITE(IUN,10110)
      DO IDEG=1,NDEG
      DO IPOL=1,NPLD
      WDEL=VRHBDEG(IDEG,IDEG,IPOL)*WRHBDEG(IDEG,IDEG,IPOL)
      PDEL=DREAL(PRHBDEG(IDEG,IDEG,IPOL))
	WRITE(IUN,10120)IDEG,IPOL,PDEL,WDEL
	ENDDO
	ENDDO
10100 FORMAT(1X,'Hybridization  Pole Expansion Results:')
10110 FORMAT(1X,'iDeg  Pole     Position        Weight')
10120 FORMAT(1X,I3,3X,I3,3X,G12.5,3X,G12.5)
C *****************************************************
C SET RETURNING ARRAYS
	IDEG1=0
	DO IDIM1=1,NDIM
	IF(KSTATES(IDIM1,IRUN,L,IATOM).EQ.0)CYCLE
	IDEG1=IDEG1+1
	IDEG=0
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.0)CYCLE
	IDEG=IDEG+1
C Set self-energy
	DO IMSC=0,NMSC
      DELWMAT(IMSC,IDIM1,IDIM)=DELWDEG(IMSC,IDEG1,IDEG)
	ENDDO
C Set self-energy at infinity
      DELIMAT(IDIM1,IDIM)=DELIDEG(IDEG1,IDEG)
C Set rational interpolation coefficients
	DO IPOL=1,NPLD
	VRHBMAT(IDIM1,IDIM,IPOL)=VRHBDEG(IDEG1,IDEG,IPOL)
	WRHBMAT(IDIM1,IDIM,IPOL)=WRHBDEG(IDEG1,IDEG,IPOL)
	PRHBMAT(IDIM1,IDIM,IPOL)=PRHBDEG(IDEG1,IDEG,IPOL)
	ORHBMAT(IDIM1,IDIM,IPOL)=ORHBDEG(IDEG1,IDEG,IPOL)
	ENDDO
	ENDDO
	ENDDO
	DEALLOCATE(EIMPDEG,ELOCDEG,OIMPDEG,DELWDEG,DHUBDEG,DELIDEG)
	DEALLOCATE(VRHBDEG,WRHBDEG,PRHBDEG,ORHBDEG,VDBCDEG)
      DEALLOCATE(DOCC,UOCC,DTOT,PCOF,WCOF)
 1000	CONTINUE
C MEMORY DEALLOCATIONS
	END SUBROUTINE IMP_HYBINT


      SUBROUTINE IMP_HYBDIF(NLEN,XVEC,FVAL)
**************************************************************
*  Subroutine returns value of the functional which performs *
*  a fit for hybridization function using conjugate gradient *
**************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                          !!! from setup
      USE COM_MSBMESH ,ONLY: TEMP,WMSC,NMSC,FMSC,DMSC         !!! from readhub
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8, ALLOCATABLE :: VHYB(:)
      REAL*8, ALLOCATABLE :: POLE(:)
      COMPLEX*16, ALLOCATABLE :: DELW(:)
      REAL*8 XVEC(NLEN)
      COMPLEX*16 DELF
      DATA PI/3.141592653589793D0/
C Memory allocations
      NPLD=NLEN/2
      ALLOCATE(VHYB(NPLD))
      ALLOCATE(POLE(NPLD))
      ALLOCATE(DELW(0:NMSC))
C Hybridization matrix elements and poles positions
      DO IPLD=1,NPLD
      VHYB(IPLD)=XVEC(IPLD)
      POLE(IPLD)=XVEC(IPLD+NPLD)
      ENDDO
C Hybridization function is passed thru two auxiliary arrays
      DO IMSC=0,NMSC
      DELW(IMSC)=DCMPLX(FMSC(IMSC),DMSC(IMSC))
      ENDDO
C Functional to minimize is the difference between Delta(w) and its rational fit
      DIFF=0.D0
      DO IMSC=0,NMSC
C Compute current fit to Delta(w)
      DELF=0.D0
      DO IPLD=1,NPLD
      DELF=DELF+VHYB(IPLD)**2/(WMSC(IMSC)-POLE(IPLD))
      ENDDO
C Compute difference
      DIFF=DIFF+ABS(DELF-DELW(IMSC))
      ENDDO
      FVAL=DIFF/DBLE(NMSC+1)
C Memory deallocations
      DEALLOCATE(VHYB,POLE,DELW)
      END