      SUBROUTINE IMP_HYBLEV(L,IATOM,NHYBMIN,ELEVMAT,EHYBMAT,
     &           VHYBMAT,THYB)
************************************************************
*  Finds hybridization levels
************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                 !!! from setup
      USE COM_CONTROL ,ONLY: LIFT,LMTO,IDMF                          !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS,ILSB         !!! from readini
 	USE COM_IMPDAT  ,ONLY: KCRDSYS
      USE COM_HUBDAT  ,ONLY: MCRL,LCRL,KSOLVER,KDBLCNT,CDBLCNT       !!! from readhub
      USE COM_HOPDAT  ,ONLY: ICUBC                                   !!! from readhop
      USE COM_ENVSITE ,ONLY: NENV,TENV,ISENV                         !!! from envmesh
      USE COM_TBBPAR  ,ONLY: LTBAS,LSBAS,INBAS,NTBAS                 !!! from readhop
      USE COM_TBBSYS  ,ONLY: RINPAXE,RINPANG,ROUTAXE,ROUTANG         !!! from readhop
     &                      ,RINPINV,ROUTINV
      USE COM_LABELS  ,ONLY: TXTAT,TXTSP,TXTEL                       !!! from readini
      USE COM_HOPCOM  ,ONLY: TMAT,SMAT                               !!! from readhop
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                         !!! from setup
      IMPLICIT REAL*8 (A-H,O-Z)
C PASSED ARRAYS
	COMPLEX*16 ELEVMAT(2*(2*L+1),2*(2*L+1))
     &   ,EHYBMAT(2*LIMBMEM*NENVMEM,2*LIMBMEM*NENVMEM)
     &   ,VHYBMAT(2*(2*L+1),2*LIMBMEM*NENVMEM)
      CHARACTER*10 THYB(2*LIMBMEM*NENVMEM)
C SET LOCAL VARIABLES
      INTEGER NHSP(2)
      COMPLEX*16 UJL(2,2),UJR(2,2),U1(2,2)
C Local allocatable arrays
      INTEGER, ALLOCATABLE :: LHYB(:)
      INTEGER, ALLOCATABLE :: LIND(:,:,:)
      INTEGER, ALLOCATABLE :: MIND(:,:,:)
      INTEGER, ALLOCATABLE :: NIND(:,:,:)
	COMPLEX*16, ALLOCATABLE :: EHYB(:,:,:)
	COMPLEX*16, ALLOCATABLE :: ELEV(:,:)
	COMPLEX*16, ALLOCATABLE :: VHYB(:,:)
	COMPLEX*16, ALLOCATABLE :: EMAT(:,:)
	COMPLEX*16, ALLOCATABLE :: GMAT(:,:)
	COMPLEX*16, ALLOCATABLE :: UL(:)
	COMPLEX*16, ALLOCATABLE :: UR(:)
      DATA PI/3.141592653589793D0/,EPSDEG/1.D-05/
      CALL ABORTNOW()
C MEMORY ALLOCATIONS
      NDIM=2*(2*L+1)
      KSYS=KCRDSYS(L,IATOM)
	ALLOCATE(EHYB(2*LIMBMEM,2*LIMBMEM,NENVMEM))
	ALLOCATE(VHYB(NDIM,2*LIMBMEM*NENVMEM))
	ALLOCATE(ELEV(NDIM,NDIM))
	ALLOCATE(UL(NWIGMEM))
	ALLOCATE(UR(NWIGMEM))
	ALLOCATE(LHYB(NENVMEM))
	ALLOCATE(LIND(LIMBMEM,2,NENVMEM))
	ALLOCATE(MIND(LIMBMEM,2,NENVMEM))
	ALLOCATE(NIND(LIMBMEM,2,NENVMEM))
	U1(1,1)=(1.D0,0.D0)
	U1(1,2)=(0.D0,0.D0)
	U1(2,1)=(0.D0,0.D0)
	U1(2,2)=(1.D0,0.D0)
C CALCULATE TOTAL SIZE OF CLUSTER HAMILTONIANS
C Zeroise hoppings
      IHYB=0
      DO ISPIN=1,2                        !!! over spins
	DO IENV=1,NENV(IATOM)               !!! over ienv
	IATOMH=ISENV(IENV,IATOM) 
	ISORTH=IS(IATOMH)
	DO LH=0,ILSB(ISORTH)                !!! over lh
	IF(.NOT.LTBAS(LH,IATOMH))CYCLE
	DO MH=-LH,LH
	LMH=LH*(LH+1)+MH+1
      IHYB=IHYB+1
      NIND(LMH,ISPIN,IENV)=IHYB
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      NHYB=IHYB
C INITIALIZE LOCAL IMPURITY LEVELS
C Zeroise local impurity levels
      IDIM1=0
	DO ISPIN1=1,2
      DO M1=-L,L
      IDIM1=IDIM1+1
      IDIM=0
	DO ISPIN=1,2
      DO M=-L,L
      IDIM=IDIM+1
      ELEV(IDIM1,IDIM)=(0.D0,0.D0)
      ENDDO
      ENDDO
      ENDDO
      ENDDO
C Copy Local Impurity levels from TMAT
	DO IORBS=1,NORBS
	DO IUPDN=1,NSPIN
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
      DO M1=-L,L
      LM1=L*(L+1)+M1+1
      IDIM1=L+M1+1+(2*L+1)*(ISPIN1-1)
      DO M=-L,L
      LM=L*(L+1)+M+1
      IDIM=L+M+1+(2*L+1)*(ISPIN-1)
      ELEV(IDIM1,IDIM)=TMAT(LM1,LM,IATOM,0,IUPDN,IORBS)
      ENDDO
      ENDDO
      ENDDO
      ENDDO
C Copy spin subblocs
      DO M1=-L,L
      DO M=-L,L
	IF(NSPIN.EQ.2)CYCLE
	ISPIN1=1
	ISPIN =2
      IDIM1UP=L+M1+1+(2*L+1)*(ISPIN1-1)
      IDIM UP=L+M +1+(2*L+1)*(ISPIN1-1)
      IDIM1DN=L+M1+1+(2*L+1)*(ISPIN -1)
      IDIM DN=L+M +1+(2*L+1)*(ISPIN -1)
      ELEV(IDIM1DN,IDIMDN)=ELEV(IDIM1UP,IDIMUP)
      ENDDO
      ENDDO
C INITIALIZE HYBRIDIZATION LEVELS
C Zeroise Hybridization levels
	DO IENV=1,NENV(IATOM)               !!! over ienv
	IATOMH=ISENV(IENV,IATOM) 
	ISORTH=IS(IATOMH)
	IDIM1=0
	DO ISPIN1=1,2
	DO L1H=0,ILSB(ISORTH)               !!! over l1
	IF(.NOT.LTBAS(L1H,IATOMH))CYCLE
      DO M1H=-L1H,L1H
      L1MH=L1H*(L1H+1)+M1H+1
	IDIM1=IDIM1+1
	LIND(L1MH,ISPIN1,IENV)=IDIM1
	IDIM=0
	DO ISPIN=1,2
	DO LH=0,ILSB(ISORTH)                !!! over l1
	IF(.NOT.LTBAS(LH,IATOMH))CYCLE
      DO MH=-LH,LH
      LMH=LH*(LH+1)+MH+1
	IDIM=IDIM+1
	LIND(LMH,ISPIN,IENV)=IDIM
      EHYB(IDIM1,IDIM,IENV)=(0.D0,0.D0)
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      LHYB(IENV)=IDIM1/2
      ENDDO
C Copy Hybridization levels
	DO IORBS=1,NORBS
	DO IUPDN=1,NSPIN
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
	DO IENV=1,NENV(IATOM)               !!! over ienv
	IATOMH=ISENV(IENV,IATOM) 
	ISORTH=IS(IATOMH)
	DO L1H=0,ILSB(ISORTH)               !!! over l1
	IF(.NOT.LTBAS(L1H,IATOMH))CYCLE
      DO M1H=-L1H,L1H
      L1MH=L1H*(L1H+1)+M1H+1
	IDIM1=LIND(L1MH,ISPIN1,IENV)
	DO LH=0,ILSB(ISORTH)                !!! over l1
	IF(.NOT.LTBAS(LH,IATOMH))CYCLE
      DO MH=-LH,LH
      LMH=LH*(LH+1)+MH+1
	IDIM=LIND(LMH,ISPIN,IENV)
      EHYB(IDIM1,IDIM,IENV)=TMAT(L1MH,LMH,IATOMH,0,IUPDN,IORBS)
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      ENDDO
C Copy spin subblocks
	DO IENV=1,NENV(IATOM)               !!! over ienv
	IATOMH=ISENV(IENV,IATOM) 
	ISORTH=IS(IATOMH)
	DO L1H=0,ILSB(ISORTH)               !!! over l1
	IF(.NOT.LTBAS(L1H,IATOMH))CYCLE
      DO M1H=-L1H,L1H
      L1MH=L1H*(L1H+1)+M1H+1
	DO LH=0,ILSB(ISORTH)                !!! over l1
	IF(.NOT.LTBAS(LH,IATOMH))CYCLE
      DO MH=-LH,LH
      LMH=LH*(LH+1)+MH+1
      IF(NSPIN.EQ.2)CYCLE
      ISPIN1=1
      ISPIN =2
	IDIM1UP=LIND(L1MH,ISPIN1,IENV)
	IDIM UP=LIND(L MH,ISPIN1,IENV)
	IDIM1DN=LIND(L1MH,ISPIN ,IENV)
	IDIM DN=LIND(LMH ,ISPIN ,IENV)
      EHYB(IDIM1DN,IDIMDN,IENV)=EHYB(IDIM1UP,IDIMUP,IENV)
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      ENDDO
C INITIALIZE HYBRIDIZATION MATRIX ELEMENTS
C Zeroise hoppings
      IHYB=0
      DO ISPIN=1,2                        !!! over spins
	DO IENV=1,NENV(IATOM)               !!! over ienv
	IATOMH=ISENV(IENV,IATOM) 
	ISORTH=IS(IATOMH)
	DO LH=0,ILSB(ISORTH)                !!! over lh
	IF(.NOT.LTBAS(LH,IATOMH))CYCLE
	DO MH=-LH,LH
      IHYB=IHYB+1
      DO IDIM=1,NDIM
      VHYB(IDIM,IHYB)=(0.D0,0.D0)
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      ENDDO
C Copy hoppings from TMAT
	DO IORBS=1,NORBS
	DO IUPDN=1,NSPIN
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
	IHYB0=0
	DO IENV=1,NENV(IATOM)               !!! over ienv
	IATOMH=ISENV(IENV,IATOM) 
	ISORTH=IS(IATOMH)
	DO LH=0,ILSB(ISORTH)                !!! over lh
	IF(.NOT.LTBAS(LH,IATOMH))CYCLE
	DO MH=-LH,LH
	LMH=LH*(LH+1)+MH+1
      IHYB0=IHYB0+1
      IHYB=IHYB0+NHYB/2*(ISPIN-1)
      DO M=-L,L
      LM=L*(L+1)+M+1
      IDIM=M+L+1+(2*L+1)*(ISPIN1-1)
      VHYB(IDIM,IHYB)=TMAT(LM,LMH,IATOM,IENV,IUPDN,IORBS)
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      ENDDO
C Copy spin subblocks
	IHYB0=0
	DO IENV=1,NENV(IATOM)               !!! over ienv
	IATOMH=ISENV(IENV,IATOM) 
	ISORTH=IS(IATOMH)
	DO LH=0,ILSB(ISORTH)                !!! over lh
	IF(.NOT.LTBAS(LH,IATOMH))CYCLE
	DO MH=-LH,LH
	LMH=LH*(LH+1)+MH+1
      IHYB0=IHYB0+1
      DO M=-L,L
      LM=L*(L+1)+M+1
      IF(NSPIN.EQ.2)CYCLE
      ISPIN1=1
      ISPIN =2
      IDIMUP=M+L+1+(2*L+1)*(ISPIN1-1)
      IDIMDN=M+L+1+(2*L+1)*(ISPIN -1)
      IHYBUP=IHYB0+NHYB/2*(ISPIN1-1)
      IHYBDN=IHYB0+NHYB/2*(ISPIN -1)
      VHYB(IDIMDN,IHYBDN)=VHYB(IDIMUP,IHYBUP)
      ENDDO
      ENDDO
      ENDDO
      ENDDO
C TRANSFORM LOCAL LEVELS TO CUBIC/SPINOR HARMONICS
      CALL LIB_TRANSU(L,ROUTAXE(1,L,IATOM),ROUTANG(L,IATOM),
     &ROUTINV(L,IATOM),UL,NWIGMEM)
      CALL LIB_TRANSUJ(ROUTAXE(1,L,IATOM),ROUTANG(L,IATOM),
     &ROUTINV(L,IATOM),UJL)
      CALL LIB_TRANSU(L,ROUTAXE(1,L,IATOM),ROUTANG(L,IATOM),
     &ROUTINV(L,IATOM),UR,NWIGMEM)
      CALL LIB_TRANSUJ(ROUTAXE(1,L,IATOM),ROUTANG(L,IATOM),
     &ROUTINV(L,IATOM),UJR)
      ALLOCATE(EMAT(NDIM,NDIM))
      ALLOCATE(GMAT(NDIM,NDIM))
	DO IDIM1=1,NDIM
	DO IDIM=1,NDIM
	EMAT(IDIM1,IDIM)=ELEV(IDIM1,IDIM)
      ENDDO
      ENDDO
	CALL LIB_LTURNUGEN(GMAT,EMAT,L,L,UL,UR,UJL,UJR,
     &     NWIGMEM,NWIGMEM,2,2)
      CALL LIB_TRANSCUB(2*(2*L+1),KSYS,2*(2*L+1),KSYS,GMAT)
	DO IDIM1=1,NDIM
	DO IDIM=1,NDIM
	ELEV(IDIM1,IDIM)=GMAT(IDIM1,IDIM)
      ENDDO
      ENDDO
      DEALLOCATE(EMAT,GMAT)
C TRANSFORM HYBRIDIZATION MATRIX ELEMENTS TO CUBIC/SPINOR HAMONICS
      CALL LIB_TRANSU(L,ROUTAXE(1,L,IATOM),ROUTANG(L,IATOM),
     &ROUTINV(L,IATOM),UL,NWIGMEM)
      CALL LIB_TRANSUJ(ROUTAXE(1,L,IATOM),ROUTANG(L,IATOM),
     &ROUTINV(L,IATOM),UJL)
      UR(1)=(1.D0,0.D0)
      IHYB0=0
	DO IENV=1,NENV(IATOM)               !!! over ienv
	IATOMH=ISENV(IENV,IATOM) 
	ISORTH=IS(IATOMH)
	DO LH=0,ILSB(ISORTH)                !!! over lh
	IF(.NOT.LTBAS(LH,IATOMH))CYCLE
	DO MH=-LH,LH
      IHYB0=IHYB0+1
      ALLOCATE(EMAT(NDIM,2))
      ALLOCATE(GMAT(NDIM,2))
      DO ISPIN=1,2                        !!! over spins
      DO IDIM=1,NDIM
      EMAT(IDIM,ISPIN)=VHYB(IDIM,IHYB0+NHYB/2*(ISPIN-1))
      ENDDO
      ENDDO
	CALL LIB_LTURNUGEN(GMAT,EMAT,L,0,UL,UR,UJL,U1,
     &     NWIGMEM,1,2,2)
      CALL LIB_TRANSCUB(2*(2*L+1),KSYS,2,0,GMAT)
      DO ISPIN=1,2                        !!! over spins
	DO IDIM=1,NDIM
	VHYB(IDIM,IHYB0+NHYB/2*(ISPIN-1))=GMAT(IDIM,ISPIN)
      ENDDO
      ENDDO
      DEALLOCATE(EMAT,GMAT)
      ENDDO
      ENDDO
      ENDDO
C TRANSFORM HYBRIDIZATION LEVELS TO CUBIC/SPINOR HARMONICS
	DO IENV=1,NENV(IATOM)               !!! over ienv
	IATOMH=ISENV(IENV,IATOM) 
	ISORTH=IS(IATOMH)
	DO L1H=0,ILSB(ISORTH)               !!! over l1
	IF(.NOT.LTBAS(L1H,IATOMH))CYCLE
      CALL LIB_TRANSU(L1H,ROUTAXE(1,L1H,IATOMH),ROUTANG(L1H,IATOMH),
     &ROUTINV(L1H,IATOMH),UL,NWIGMEM)
      CALL LIB_TRANSUJ(ROUTAXE(1,L1H,IATOMH),ROUTANG(L1H,IATOMH),
     &ROUTINV(L1H,IATOMH),UJL)
	DO LH=0,ILSB(ISORTH)                !!! over l1
	IF(.NOT.LTBAS(LH,IATOMH))CYCLE
      CALL LIB_TRANSU(LH,ROUTAXE(1,LH,IATOMH),ROUTANG(LH,IATOMH),
     &ROUTINV(LH,IATOMH),UR,NWIGMEM)
      CALL LIB_TRANSUJ(ROUTAXE(1,LH,IATOMH),ROUTANG(LH,IATOMH),
     &ROUTINV(LH,IATOMH),UJR)
	ALLOCATE(EMAT(2*(2*L1H+1),2*(2*LH+1)))
	ALLOCATE(GMAT(2*(2*L1H+1),2*(2*LH+1)))
	DO ISPIN1=1,2
      DO M1H=-L1H,L1H
      L1MH=L1H*(L1H+1)+M1H+1
	IDIM1=LIND(L1MH,ISPIN1,IENV)
	IMAT1=M1H+L1H+1+(2*L1H+1)*(ISPIN1-1)
	DO ISPIN=1,2
      DO MH=-LH,LH
      LMH=LH*(LH+1)+MH+1
	IDIM=LIND(LMH,ISPIN,IENV)
	IMAT=MH+LH+1+(2*LH+1)*(ISPIN-1)
      EMAT(IMAT1,IMAT)=EHYB(IDIM1,IDIM,IENV)
      ENDDO
      ENDDO
      ENDDO
      ENDDO
	CALL LIB_LTURNUGEN(GMAT,EMAT,L1H,LH,UL,UR,UJL,UJR,
     &     NWIGMEM,NWIGMEM,2,2)
      CALL LIB_TRANSCUB(2*(2*L1H+1),ICUBC,2*(2*LH+1),ICUBC,GMAT)
	DO ISPIN1=1,2
      DO M1H=-L1H,L1H
      L1MH=L1H*(L1H+1)+M1H+1
	IDIM1=LIND(L1MH,ISPIN1,IENV)
	IMAT1=M1H+L1H+1+(2*L1H+1)*(ISPIN1-1)
	DO ISPIN=1,2
      DO MH=-LH,LH
      LMH=LH*(LH+1)+MH+1
	IDIM=LIND(LMH,ISPIN,IENV)
	IMAT=MH+LH+1+(2*LH+1)*(ISPIN-1)
      EHYB(IDIM1,IDIM,IENV)=GMAT(IMAT1,IMAT)
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      DEALLOCATE(EMAT,GMAT)
      ENDDO
      ENDDO
      ENDDO
C TRANSFORM HYBRIDIZATION LEVELS TO CUBIC/SPINOR HARMONICS
	DO M=-L,L
      IHYB0=0
	DO IENV=1,NENV(IATOM)               !!! over ienv
	IATOMH=ISENV(IENV,IATOM) 
	ISORTH=IS(IATOMH)
	DO LH=0,ILSB(ISORTH)                !!! over l1
	IF(.NOT.LTBAS(LH,IATOMH))CYCLE
      CALL LIB_TRANSU(LH,ROUTAXE(1,LH,IATOMH),ROUTANG(LH,IATOMH),
     &ROUTINV(LH,IATOMH),UR,NWIGMEM)
      CALL LIB_TRANSUJ(ROUTAXE(1,LH,IATOMH),ROUTANG(LH,IATOMH),
     &ROUTINV(LH,IATOMH),UJR)
      UL(1)=(1.D0,0.D0)
	ALLOCATE(EMAT(2,2*(2*LH+1)))
	ALLOCATE(GMAT(2,2*(2*LH+1)))
	DO MH=-LH,LH
	IHYB0=IHYB0+1
	DO ISPIN1=1,2
	IHYB=IHYB0+NHYB/2*(ISPIN1-1)
	IMAT=LH+MH+1+(2*LH+1)*(ISPIN1-1)
	DO ISPIN=1,2
	IDIM=M+L+1+(2*L+1)*(ISPIN-1)
	EMAT(ISPIN,IMAT)=VHYB(IDIM,IHYB)
	ENDDO
	ENDDO
	ENDDO
	CALL LIB_LTURNUGEN(GMAT,EMAT,0,LH,UL,UR,U1,UJR,
     &     1,NWIGMEM,2,2)
      CALL LIB_TRANSCUB(2,0,2*(2*LH+1),ICUBC,GMAT)
      IHYB0=IHYB0-(2*LH+1)
	DO MH=-LH,LH
	IHYB0=IHYB0+1
	DO ISPIN1=1,2
	IHYB=IHYB0+NHYB/2*(ISPIN1-1)
	IMAT=LH+MH+1+(2*LH+1)*(ISPIN1-1)
	DO ISPIN=1,2
	IDIM=M+L+1+(2*L+1)*(ISPIN-1)
	VHYB(IDIM,IHYB)=GMAT(ISPIN,IMAT)
	ENDDO
	ENDDO
	ENDDO
	DEALLOCATE(EMAT,GMAT)
      ENDDO
	ENDDO
      ENDDO
C Define # of non-zero hybridizations
      DO ISPIN =1,2                       !!! over spins
      NHSP(ISPIN)=0
	DO IENV=1,NENV(IATOM)               !!! over ienv
	IATOMH=ISENV(IENV,IATOM) 
	ISORTH=IS(IATOMH)
	DO LH=0,ILSB(ISORTH)                !!! over l1
	IF(.NOT.LTBAS(LH,IATOMH))CYCLE
	DO MH=-LH,LH
	LMH=LH*(LH+1)+MH+1
      IHYB=NIND(LMH,ISPIN,IENV)
      SUM=0.D0
      DO IDIM=1,NDIM
      SUM=SUM+ABS(VHYB(IDIM,IHYB))
      ENDDO
      IF(SUM.GT.1.D-10)NHSP(ISPIN)=NHSP(ISPIN)+1
      ENDDO
	ENDDO
	ENDDO
	ENDDO
	IF(NHSP(1).NE.NHSP(2))
     &CALL FULLSTOP('<HYBLEV>: Nhyb_up.ne.Nhyb_dn')
	NHYBMIN=2*NHSP(1)
      MHYB=0
      DO ISPIN=1,2                        !!! over spins
	DO IENV=1,NENV(IATOM)               !!! over ienv
	IATOMH=ISENV(IENV,IATOM) 
	ISORTH=IS(IATOMH)
	DO LH=0,ILSB(ISORTH)                !!! over l1
	IF(.NOT.LTBAS(LH,IATOMH))CYCLE
	DO MH=-LH,LH
	LMH=LH*(LH+1)+MH+1
      IHYB=NIND(LMH,ISPIN,IENV)
      SUM=0.D0
      DO IDIM=1,NDIM
      SUM=SUM+ABS(VHYB(IDIM,IHYB))
      ENDDO
      IF(SUM.LE.1.D-10)CYCLE
      MHYB=MHYB+1
      MIND(LMH,ISPIN,IENV)=MHYB
      THYB(MHYB)=TXTAT(ISORTH)
      DO IDIM=1,NDIM
      VHYBMAT(IDIM,MHYB)=VHYB(IDIM,IHYB)
      ENDDO
      ENDDO
	ENDDO
	ENDDO
	ENDDO
	IF(MHYB.NE.NHYBMIN)
     &CALL FULLSTOP('<HYBLEB>:: Error in NHYBMIN')
C
      DO MHYB1=1,NHYBMIN
      DO MHYB2=1,NHYBMIN
      EHYBMAT(MHYB1,MHYB2)=(0.D0,0.D0)
      ENDDO
      ENDDO
	DO IENV=1,NENV(IATOM)               !!! over ienv
	IATOMH=ISENV(IENV,IATOM) 
	ISORTH=IS(IATOMH)
	DO LH=0,ILSB(ISORTH)                !!! over l1
	IF(.NOT.LTBAS(LH,IATOMH))CYCLE
      DO ISPIN1=1,2                       !!! over spins
	DO M1H=-LH,LH
      LM1H=LH*(LH+1)+M1H+1
	IHYB=NIND(LM1H,ISPIN1,IENV)
      SUM1=0.D0
      DO IDIM=1,NDIM
      SUM1=SUM1+ABS(VHYB(IDIM,IHYB))
      ENDDO
      IF(SUM1.LE.1.D-10)CYCLE
      MHYB1=MIND(LM1H,ISPIN1,IENV)
      DO ISPIN=1,2                       !!! over spins
	DO MH=-LH,LH
      LMH=LH*(LH+1)+MH+1
	JHYB=NIND(LMH,ISPIN,IENV)
      SUM2=0.D0
      DO IDIM=1,NDIM
      SUM2=SUM2+ABS(VHYB(IDIM,JHYB))
      ENDDO
      IF(SUM2.LE.1.D-10)CYCLE
	IDIM=LIND(LM1H,ISPIN1,IENV)
	JDIM=LIND(LMH,ISPIN,IENV)
      MHYB2=MIND(LMH,ISPIN,IENV)
      EHYBMAT(MHYB1,MHYB2)=EHYB(IDIM,JDIM,IENV)
      ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C  Matrix of impurity levels
      DO IDIM1=1,NDIM
      DO IDIM=1,NDIM
      ELEVMAT(IDIM1,IDIM)=ELEV(IDIM1,IDIM)
      ENDDO
      ENDDO
C MEOMORY DEALLOCATIONS
	DEALLOCATE(EHYB,ELEV,VHYB,LHYB,LIND,MIND,UL,UR)
	END
