      SUBROUTINE IMP_IMPFOCK(L,IATOM,DHUBMAT,VDBCMAT,
     &     EIMPMAT,ELOCMAT,OIMPMAT,SIGWMAT,SIGIMAT,
     &     SIG0MAT,VRATMAT,WRATMAT,PRATMAT,ORATMAT,
     &     EINTGAL,ESTAHFK,ESTADBC,EGALHFK,EGALDBC,
     &     UIMP,UPAR,GPAR,IERR)
************************************************************
*  Subroutine solves Anderson impurity model for given     *
*  hybridization function Delta(iWn)                       *
*  Hartree-Fock approximation is used                      *
*  Returns Sigma(w),Sigma(0),Sigma(inf) as well as         *
*  rational interpolation coefficients for the self-energy * 
************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                    !!! from setup
      USE COM_CONTROL ,ONLY: LIFT,LMTO,IDMF                             !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS,ILSB            !!! from readini
      USE COM_MSBMESH ,ONLY: TEMP,NMSC,WMSC,FMSC,OBND                   !!! from readhub
	USE COM_IMPDAT  ,ONLY: NRUNIMP,KSTATES,NPOLIMP                    !!! from readhub
      USE COM_HUBDAT  ,ONLY: MCRL,LCRL,KSOLVER,KSIGMOO,KIMPLEV,
     &                       KDBLCNT,CDBLCNT                            !!! from readhub
      USE COM_FERMI   ,ONLY: EF                                         !!! from ttrints
      USE COM_LMTOUT  ,ONLY: SCRFILE                                    !!! from readini
      USE COM_MASHDEP ,ONLY: NVAL,LENCMP                                !!! from setup
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                            !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 UIMP(2*(2*L+1),2*(2*L+1),2*(2*L+1),2*(2*L+1))
	COMPLEX*16 SIGWMAT(0:NMSCMEM+1,2*(2*L+1),2*(2*L+1))
     &          ,DHUBMAT(         2*(2*L+1),2*(2*L+1))
     &          ,VDBCMAT(         2*(2*L+1),2*(2*L+1))
     &          ,EIMPMAT(         2*(2*L+1),2*(2*L+1))
     &          ,ELOCMAT(         2*(2*L+1),2*(2*L+1))
     &          ,SIGIMAT(         2*(2*L+1),2*(2*L+1))
     &          ,SIG0MAT(         2*(2*L+1),2*(2*L+1))
     &          ,OIMPMAT(         2*(2*L+1),2*(2*L+1))
     &          ,VRATMAT(         2*(2*L+1),2*(2*L+1),NPOLMEM)
     &          ,WRATMAT(         2*(2*L+1),2*(2*L+1),NPOLMEM)
     &          ,PRATMAT(         2*(2*L+1),2*(2*L+1),NPOLMEM)
     &          ,ORATMAT(         2*(2*L+1),2*(2*L+1),NPOLMEM)
	COMPLEX*16 DIM,CAVR
	COMPLEX*16, ALLOCATABLE :: SIGIDEG(:,:)
	COMPLEX*16, ALLOCATABLE :: SIG0DEG(:,:)
	COMPLEX*16, ALLOCATABLE :: OIMPDEG(:,:)
	COMPLEX*16, ALLOCATABLE :: DHUBDEG(:,:)
	COMPLEX*16, ALLOCATABLE :: VDBCDEG(:,:)
	COMPLEX*16, ALLOCATABLE :: EIMPDEG(:,:)
	COMPLEX*16, ALLOCATABLE :: ELDADEG(:,:)
	COMPLEX*16, ALLOCATABLE :: ELOCDEG(:,:)
	COMPLEX*16, ALLOCATABLE :: SIGWDEG(:,:,:)
	COMPLEX*16, ALLOCATABLE :: VRATDEG(:,:,:)
	COMPLEX*16, ALLOCATABLE :: WRATDEG(:,:,:)
	COMPLEX*16, ALLOCATABLE :: PRATDEG(:,:,:)
	COMPLEX*16, ALLOCATABLE :: ORATDEG(:,:,:)
	COMPLEX*16, ALLOCATABLE :: SIGA(:,:,:)
	COMPLEX*16, ALLOCATABLE :: SIGI(:,:)
	REAL*8 ZAVRSCF(2),ZOCCSCF(2),ZAVRIMP(2),ZOCCIMP(2)
      DATA PI/3.141592653589793D0/,DIM/(0.D0,1.D0)/,EPSDEG/1.D-05/
      CALL ABORTNOW()
	IERR=0
	ISORT=IS(IATOM)
	NDIM=2*(2*L+1)
	MSPIN=NSPIN
	EFRM=EF
	CHEM=EF
C DO OVER SOLUTIONS OF IMPURITY MODEL
	DO 1000 IRUN=1,NRUNIMP(L,IATOM)
C Count states which participate in this run
	NDEG=0 ! this is degeneracy within this run
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).NE.0)NDEG=NDEG+1
	ENDDO
	IF(NDEG.EQ.0)GOTO 1000
C MEMORY ALLOCATIONS
	ALLOCATE(SIGIDEG(NDEG,NDEG))
	ALLOCATE(SIG0DEG(NDEG,NDEG))
	ALLOCATE(DHUBDEG(NDEG,NDEG))
	ALLOCATE(EIMPDEG(NDEG,NDEG))
	ALLOCATE(ELOCDEG(NDEG,NDEG))
	ALLOCATE(VDBCDEG(NDEG,NDEG))
	ALLOCATE(ELDADEG(NDEG,NDEG))
	ALLOCATE(OIMPDEG(NDEG,NDEG))
	ALLOCATE(SIGWDEG(0:NMSCMEM+1,NDEG,NDEG))
	ALLOCATE(VRATDEG(NDEG,NDEG,NPOLMEM))
	ALLOCATE(WRATDEG(NDEG,NDEG,NPOLMEM))
	ALLOCATE(PRATDEG(NDEG,NDEG,NPOLMEM))
	ALLOCATE(ORATDEG(NDEG,NDEG,NPOLMEM))
	ALLOCATE(SIGI(NDEG,NDEG))
C ****************************************************
C REALLOCATE INPUT ARRAYS WITHIN CURRENT DEGENERACY
	IDEG1=0
	DO IDIM1=1,NDIM
	IF(KSTATES(IDIM1,IRUN,L,IATOM).EQ.0)CYCLE
	IDEG1=IDEG1+1
	IDEG=0
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.0)CYCLE
	IDEG=IDEG+1
C Impurity levels, self-energy limits
	EIMPDEG(IDEG1,IDEG)=EIMPMAT(IDIM1,IDIM)
	ELOCDEG(IDEG1,IDEG)=ELOCMAT(IDIM1,IDIM)
	OIMPDEG(IDEG1,IDEG)=OIMPMAT(IDIM1,IDIM)
	DHUBDEG(IDEG1,IDEG)=DHUBMAT(IDIM1,IDIM)
	SIGIDEG(IDEG1,IDEG)=SIGIMAT(IDIM1,IDIM)
	VDBCDEG(IDEG1,IDEG)=VDBCMAT(IDIM1,IDIM)
	SIG0DEG(IDEG1,IDEG)=SIG0MAT(IDIM1,IDIM)
	ENDDO
	ENDDO
C Occupancies
	DO ISPIN=1,NSPIN
	ZOCCSCF(ISPIN)=0.D0
	ENDDO
	IDEG=0
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.0)CYCLE
	IDEG=IDEG+1
	ISPIN=(2*IDIM-1)/NDIM+1
	IF(NSPIN.EQ.1)ISPIN=1
	ZOCCSCF(ISPIN)=ZOCCSCF(ISPIN)+DHUBDEG(IDEG,IDEG)
	ENDDO
	DO ISPIN=1,NSPIN
	ZAVRSCF(ISPIN)=ZOCCSCF(ISPIN)
	ENDDO
C Average occupancies for spin restricted double countings
	ZOCCAVR=(ZAVRSCF(1)+ZAVRSCF(NSPIN))/2.D0
	ZAVRSCF(1)=ZOCCAVR
	ZAVRSCF(NSPIN)=ZOCCAVR
	DO ISPIN=1,NSPIN
	ZOCCIMP(ISPIN)=ZOCCSCF(ISPIN)
	ZAVRIMP(ISPIN)=ZAVRSCF(ISPIN)
	ENDDO
C Restore mean field (LDA) positions of impurity levels
	IDEG1=0
	DO IDIM1=1,NDIM
	IF(KSTATES(IDIM1,IRUN,L,IATOM).EQ.0)CYCLE
	IDEG1=IDEG1+1
	IDEG=0
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.0)CYCLE
	IDEG=IDEG+1
	ELDADEG(IDEG1,IDEG)=EIMPDEG(IDEG1,IDEG)+VDBCDEG(IDEG1,IDEG)-
     &SIGIDEG(IDEG1,IDEG)
	ENDDO
	ENDDO
C ****************************************************
C SELF-ENERGY AT INFINITY CAN BE SET ACCORDING TO THE CURRENT OCCUPANCIES
      ALLOCATE(SIGA(NDIM,NDIM,3))
	IDEG=0
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.0)CYCLE
	IDEG=IDEG+1
	ISPIN=(2*IDIM-1)/NDIM+1
	IF(NSPIN.EQ.1)ISPIN=1
	IF(ISPIN.EQ.1)ISPINM=NSPIN
	IF(ISPIN.EQ.NSPIN)ISPINM=1
	IDEG1=0
	DO IDIM1=1,NDIM
	IF(KSTATES(IDIM1,IRUN,L,IATOM).EQ.0)CYCLE
	IDEG1=IDEG1+1
	ISPIN1=(2*IDIM1-1)/NDIM+1
	IF(NSPIN.EQ.1 )ISPIN1=1
	IF(ISPIN1.EQ.1)ISPIN1M=NSPIN
	IF(ISPIN1.EQ.NSPIN)ISPIN1M=1
      SIGA(IDIM,IDIM1,1)=(0.D0,0.D0)
      SIGA(IDIM,IDIM1,2)=(0.D0,0.D0)
      SIGA(IDIM,IDIM1,3)=(0.D0,0.D0)
	IF(IDIM.EQ.IDIM1)ONE=1.D0
	IF(IDIM.NE.IDIM1)ONE=0.D0
	JDEG=0
	DO JDIM=1,NDIM
	IF(KSTATES(JDIM,IRUN,L,IATOM).EQ.0)CYCLE
	JDEG=JDEG+1
	JDEG1=0
	DO JDIM1=1,NDIM
	IF(KSTATES(JDIM1,IRUN,L,IATOM).EQ.0)CYCLE
	JDEG1=JDEG1+1
C Matrix Case: Uimp(ij,i'j')=<ij|1/r|i'j'>
      SIGA(IDIM,IDIM1,1)=SIGA(IDIM,IDIM1,1)+
     &(UIMP(IDIM,JDIM,IDIM1,JDIM1)-UIMP(IDIM,JDIM,JDIM1,IDIM1))*
     &DHUBDEG(JDEG,JDEG1)
	ENDDO
	ENDDO
C SU(N) Case
      SIGA(IDIM,IDIM1,2)=UPAR*ZOCCSCF(ISPINM)/2.D0*DBLE(MSPIN)*ONE+
     &(UPAR-GPAR)*(ZOCCSCF(ISPIN)/2.D0*DBLE(MSPIN)*ONE-
     & DHUBDEG(IDEG,IDEG1))*ONE
C Other cases
      SIGA(IDIM,IDIM1,3)=SIGIDEG(IDIM,IDIM1)
	ENDDO
	ENDDO
C RESET SELF-ENERGY AT INFINITY: 
C Note that it is probably better to use average occupancies and interactions
C than exact Coulomb and density matrices due to well known problem of Hartree
C term and full potential LDA taking care of those. 
	IDEG1=0
	DO IDIM1=1,NDIM
	IF(KSTATES(IDIM1,IRUN,L,IATOM).EQ.0)CYCLE
	IDEG1=IDEG1+1
	IDEG=0
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.0)CYCLE
	IDEG=IDEG+1
	IF(KSIGMOO(L,IATOM).EQ.11.OR.KSIGMOO(L,IATOM).EQ.12) ! matrix
     &SIGI(IDEG1,IDEG)=SIGA(IDIM1,IDIM,1)
	IF(KSIGMOO(L,IATOM).EQ.21.OR.KSIGMOO(L,IATOM).EQ.22) ! spherical
     &SIGI(IDEG1,IDEG)=SIGA(IDIM1,IDIM,2)
	IF(KSIGMOO(L,IATOM).EQ.31.OR.KSIGMOO(L,IATOM).EQ.32) ! external
     &SIGI(IDEG1,IDEG)=SIGA(IDIM1,IDIM,3)
	IF(KSIGMOO(L,IATOM).EQ.41.OR.KSIGMOO(L,IATOM).EQ.42) ! external
     &SIGI(IDEG1,IDEG)=SIGA(IDIM1,IDIM,3)
	ENDDO
	ENDDO
C ******************************************************
C SET OUTPUT ARRAYS
	IDEG1=0
	DO IDIM1=1,NDIM
	IF(KSTATES(IDIM1,IRUN,L,IATOM).EQ.0)CYCLE
	IDEG1=IDEG1+1
	ISPIN1=(2*IDIM1-1)/NDIM+1
	IF(NSPIN.EQ.1)ISPIN1=1
	IDEG=0
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.0)CYCLE
	IDEG=IDEG+1
	ISPIN=(2*IDIM-1)/NDIM+1
	IF(NSPIN.EQ.1)ISPIN=1
C Set self-energy
	DO IMSC=0,NMSC
      SIGWDEG(IMSC,IDEG1,IDEG)=SIGI(IDEG1,IDEG)
	ENDDO
C Set self-energy at infinity
      SIGIDEG(IDEG1,IDEG)=SIGI(IDEG1,IDEG)
C Set self-energy at zero
      SIG0DEG(IDEG1,IDEG)=SIGI(IDEG1,IDEG)
C Set double counting potential
	IF(ISPIN.EQ.1)ISPINM=NSPIN
	IF(ISPIN.EQ.NSPIN)ISPINM=1
C Set bare impurity levels
	IF(IDEG1.EQ.IDEG)
     &ELOCDEG(IDEG1,IDEG)=EIMPDEG(IDEG1,IDEG)-EFRM-SIGIDEG(IDEG1,IDEG)
	IF(IDEG1.NE.IDEG)
     &ELOCDEG(IDEG1,IDEG)=EIMPDEG(IDEG1,IDEG)-SIGIDEG(IDEG1,IDEG)
C Set rational interpolation coefficients
	DO IPOL=1,NPOLIMP(L,IATOM)
	VRATDEG(IDEG1,IDEG,IPOL)=(0.D0,0.D0)
	WRATDEG(IDEG1,IDEG,IPOL)=(0.D0,0.D0)
	PRATDEG(IDEG1,IDEG,IPOL)=(0.D0,0.D0)
	ORATDEG(IDEG1,IDEG,IPOL)=(0.D0,0.D0)
	IF(IDEG1.EQ.IDEG)
     &ORATDEG(IDEG1,IDEG,IPOL)=DCMPLX(1.D0,0.D0)
	ENDDO
C Set double counting potential
	IF(ISPIN.EQ.1)ISPINM=NSPIN
	IF(ISPIN.EQ.NSPIN)ISPINM=1
C 00  Keep this array untouched
	IF(KDBLCNT(L,IATOM).EQ.0)
     &VDBCDEG(IDEG1,IDEG)=VDBCDEG(IDEG1,IDEG)
C 11. Fully localized spin polarized limit with Nscf
	IF(KDBLCNT(L,IATOM).EQ.11.AND.IDEG1.EQ.IDEG)
     &VDBCDEG(IDEG1,IDEG)=UPAR*ZOCCSCF(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZOCCSCF(ISPIN)/2.D0*DBLE(MSPIN)-(UPAR-GPAR)*
     &CDBLCNT(L,IATOM)
	IF(KDBLCNT(L,IATOM).EQ.11.AND.IDEG1.NE.IDEG)
     &VDBCDEG(IDEG1,IDEG)=(0.D0,0.D0)
C 12. Fully localized spin restricted limit with Nscf
	IF(KDBLCNT(L,IATOM).EQ.12.AND.IDEG1.EQ.IDEG)
     &VDBCDEG(IDEG1,IDEG)=UPAR*ZAVRSCF(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZAVRSCF(ISPIN)/2.D0*DBLE(MSPIN)-(UPAR-GPAR)*
     &CDBLCNT(L,IATOM)
	IF(KDBLCNT(L,IATOM).EQ.12.AND.IDEG1.NE.IDEG)
     &VDBCDEG(IDEG1,IDEG)=(0.D0,0.D0)
C 13. Fully localized spin polarized limit with Nimp
	IF(KDBLCNT(L,IATOM).EQ.13.AND.IDEG1.EQ.IDEG)
     &VDBCDEG(IDEG1,IDEG)=UPAR*ZOCCIMP(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZOCCIMP(ISPIN)/2.D0*DBLE(MSPIN)-(UPAR-GPAR)*
     &CDBLCNT(L,IATOM)
	IF(KDBLCNT(L,IATOM).EQ.13.AND.IDEG1.NE.IDEG)
     &VDBCDEG(IDEG1,IDEG)=(0.D0,0.D0)
C 14. Fully localized spin restricted limit with Nimp
	IF(KDBLCNT(L,IATOM).EQ.14.AND.IDEG1.EQ.IDEG)
     &VDBCDEG(IDEG1,IDEG)=UPAR*ZAVRIMP(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZAVRIMP(ISPIN)/2.D0*DBLE(MSPIN)-(UPAR-GPAR)*
     &CDBLCNT(L,IATOM)
	IF(KDBLCNT(L,IATOM).EQ.14.AND.IDEG1.NE.IDEG)
     &VDBCDEG(IDEG1,IDEG)=(0.D0,0.D0)
C 21. Analitical spin polarized limit of Sigma(inf) with Nscf
	IF(KDBLCNT(L,IATOM).EQ.21.AND.IDEG1.EQ.IDEG)
     &VDBCDEG(IDEG,IDEG)=UPAR*ZOCCSCF(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZOCCSCF(ISPIN)/2.D0*DBLE(MSPIN)-(UPAR-GPAR)*
     &ZOCCSCF(ISPIN)/2.D0*DBLE(MSPIN)/(DBLE(NDEG)/2.D0)
	IF(KDBLCNT(L,IATOM).EQ.21.AND.IDEG1.NE.IDEG)
     &VDBCDEG(IDEG1,IDEG)=(0.D0,0.D0)
C 22. Analitical spin restricted limit of Sigma(inf) with Nscf
	IF(KDBLCNT(L,IATOM).EQ.22.AND.IDEG1.EQ.IDEG)
     &VDBCDEG(IDEG,IDEG)=UPAR*ZAVRSCF(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZAVRSCF(ISPIN)/2.D0*DBLE(MSPIN)-(UPAR-GPAR)*
     &ZAVRSCF(ISPIN)/2.D0*DBLE(MSPIN)/(DBLE(NDEG)/2.D0)
	IF(KDBLCNT(L,IATOM).EQ.22.AND.IDEG1.NE.IDEG)
     &VDBCDEG(IDEG1,IDEG)=(0.D0,0.D0)
C 23. Analitical spin polarized limit of Sigma(inf) with Nimp
	IF(KDBLCNT(L,IATOM).EQ.23.AND.IDEG1.EQ.IDEG)
     &VDBCDEG(IDEG,IDEG)=UPAR*ZOCCIMP(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZOCCIMP(ISPIN)/2.D0*DBLE(MSPIN)-(UPAR-GPAR)*
     &ZOCCIMP(ISPIN)/2.D0*DBLE(MSPIN)/(DBLE(NDEG)/2.D0)
	IF(KDBLCNT(L,IATOM).EQ.23.AND.IDEG1.NE.IDEG)
     &VDBCDEG(IDEG1,IDEG)=(0.D0,0.D0)
C 24. Analitical spin restricted limit of Sigma(inf) with Nimp
	IF(KDBLCNT(L,IATOM).EQ.24.AND.IDEG1.EQ.IDEG)
     &VDBCDEG(IDEG,IDEG)=UPAR*ZAVRIMP(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZAVRIMP(ISPIN)/2.D0*DBLE(MSPIN)-(UPAR-GPAR)*
     &ZAVRIMP(ISPIN)/2.D0*DBLE(MSPIN)/(DBLE(NDEG)/2.D0)
	IF(KDBLCNT(L,IATOM).EQ.24.AND.IDEG1.NE.IDEG)
     &VDBCDEG(IDEG1,IDEG)=(0.D0,0.D0)
C 30. Fixed double counting
	IF(KDBLCNT(L,IATOM).EQ.30)
     &VDBCDEG(IDEG1,IDEG)=VDBCDEG(IDEG1,IDEG)
C 40. Double counting according to Eloc
	IF(KDBLCNT(L,IATOM).EQ.40.AND.IDEG1.EQ.IDEG)
     &VDBCDEG(IDEG1,IDEG)=ELDADEG(IDEG1,IDEG)-CHEM-ELOCDEG(IDEG1,IDEG)
	IF(KDBLCNT(L,IATOM).EQ.40.AND.IDEG1.NE.IDEG)
     &VDBCDEG(IDEG1,IDEG)=(0.D0,0.D0)
C 50. Sigma(0)
	IF(KDBLCNT(L,IATOM).EQ.50)
     &VDBCDEG(IDEG1,IDEG)=SIG0DEG(IDEG1,IDEG)
C 60. Sigma(inf)
	IF(KDBLCNT(L,IATOM).EQ.60)
     &VDBCDEG(IDEG1,IDEG)=SIGIDEG(IDEG1,IDEG)
	ENDDO
	ENDDO
C *********************************************
C Set contribution to the total energy
C (note that density and local Green function have indexes swapped)
	IDEG1=0
	DO IDIM1=1,NDIM
	IF(KSTATES(IDIM1,IRUN,L,IATOM).EQ.0)CYCLE
	IDEG1=IDEG1+1
	ISPIN1=(2*IDIM1-1)/NDIM+1
	IF(NSPIN.EQ.1)ISPIN1=1
	IF(ISPIN1.EQ.1)ISPIN1M=NSPIN
	IF(ISPIN1.EQ.NSPIN)ISPIN1M=1
	IDEG=0
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.0)CYCLE
	IDEG=IDEG+1
	ISPIN=(2*IDIM-1)/NDIM+1
	IF(NSPIN.EQ.1)ISPIN=1
	IF(ISPIN.EQ.1)ISPINM=NSPIN
	IF(ISPIN.EQ.NSPIN)ISPINM=1
C *********************************************
C Galitsky-Migdal formulae for the interaction = 0
      EINTGAL=EINTGAL+0.D0
C *********************************************
C Matrix case of Hartree-Fock interaction
C should be the same as EGALHFK
	IF(KSIGMOO(L,IATOM).EQ.11.OR.KSIGMOO(L,IATOM).EQ.12)THEN
	JDEG=0
	DO JDIM=1,NDIM
	IF(KSTATES(JDIM,IRUN,L,IATOM).EQ.0)CYCLE
	JDEG=JDEG+1
	JDEG1=0
	DO JDIM1=1,NDIM
	IF(KSTATES(JDIM1,IRUN,L,IATOM).EQ.0)CYCLE
	JDEG1=JDEG1+1
      ESTAHFK=ESTAHFK+0.5D0*
     &(UIMP(IDIM,JDIM,IDIM1,JDIM1)-UIMP(IDIM,JDIM,JDIM1,IDIM1))*
     &DHUBDEG(IDEG,IDEG1)*DHUBDEG(JDEG,JDEG1)
      ENDDO
      ENDDO
C Spherical case of Hartree-Fock interaction
	ELSEIF(KSIGMOO(L,IATOM).EQ.21.OR.KSIGMOO(L,IATOM).EQ.22)THEN
	IF(IDIM1.EQ.IDIM)
     &ESTAHFK=ESTAHFK+0.5D0*DHUBDEG(IDEG,IDEG)*
     &(UPAR*ZOCCSCF(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*(ZOCCSCF(ISPIN)/2.D0*DBLE(MSPIN)-
     & DHUBDEG(IDEG,IDEG)))
C External
	ELSEIF(KSIGMOO(L,IATOM).EQ.31.OR.KSIGMOO(L,IATOM).EQ.32)THEN
      ESTAHFK=ESTAHFK+0.5D0*DHUBDEG(IDEG1,IDEG)*
     &SIGIDEG(IDEG1,IDEG)
C External
	ELSEIF(KSIGMOO(L,IATOM).EQ.41.OR.KSIGMOO(L,IATOM).EQ.42)THEN
      ESTAHFK=ESTAHFK+0.5D0*DHUBDEG(IDEG1,IDEG)*
     &SIGIDEG(IDEG1,IDEG)
      ENDIF	
C **********************      
C Double counting energy
C 00  External
	IF(KDBLCNT(L,IATOM).EQ.0)THEN
      ESTADBC=ESTADBC+0.5D0*DHUBDEG(IDEG1,IDEG)*
     &VDBCDEG(IDEG1,IDEG)
C 11. Fully localized spin polarized limit with Nscf
	ELSEIF(KDBLCNT(L,IATOM).EQ.11)THEN
	IF(IDIM1.EQ.IDIM)
     &ESTADBC=ESTADBC+0.5D0*DHUBDEG(IDEG,IDEG)*
     &(UPAR*ZOCCSCF(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZOCCSCF(ISPIN)/2.D0*DBLE(MSPIN)-
     &2.D0*(UPAR-GPAR)*CDBLCNT(L,IATOM))
C 12. Fully localized spin restricted limit with Nscf
	ELSEIF(KDBLCNT(L,IATOM).EQ.12)THEN
	IF(IDIM1.EQ.IDIM)
     &ESTADBC=ESTADBC+0.5D0*DHUBDEG(IDEG,IDEG)*
     &(UPAR*ZAVRSCF(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZAVRSCF(ISPIN)/2.D0*DBLE(MSPIN)-
     &2.D0*(UPAR-GPAR)*CDBLCNT(L,IATOM))
C 13. Fully localized spin polarized limit with Nimp
	ELSEIF(KDBLCNT(L,IATOM).EQ.13)THEN
	IF(IDIM1.EQ.IDIM)
     &ESTADBC=ESTADBC+0.5D0*DHUBDEG(IDEG,IDEG)*
     &(UPAR*ZOCCIMP(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZOCCIMP(ISPIN)/2.D0*DBLE(MSPIN)-
     &2.D0*(UPAR-GPAR)*CDBLCNT(L,IATOM))
C 14. Fully localized spin restricted limit with Nimp
	ELSEIF(KDBLCNT(L,IATOM).EQ.14)THEN
	IF(IDIM1.EQ.IDIM)
     &ESTADBC=ESTADBC+0.5D0*DHUBDEG(IDEG,IDEG)*
     &(UPAR*ZAVRIMP(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZAVRIMP(ISPIN)/2.D0*DBLE(MSPIN)-
     &2.D0*(UPAR-GPAR)*CDBLCNT(L,IATOM))
C 21. Analitical spin polarized limit of Sigma(inf) with Nscf
	ELSEIF(KDBLCNT(L,IATOM).EQ.21)THEN
	IF(IDIM1.EQ.IDIM)
     &ESTADBC=ESTADBC+0.5D0*DHUBDEG(IDEG,IDEG)*
     &(UPAR*ZOCCSCF(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZOCCSCF(ISPIN)/2.D0*DBLE(MSPIN)-(UPAR-GPAR)*
     &ZOCCSCF(ISPIN)/2.D0*DBLE(MSPIN)/(DBLE(NDEG)/2.D0))
C 22. Analitical spin restricted limit of Sigma(inf) with Nscf
	ELSEIF(KDBLCNT(L,IATOM).EQ.22)THEN
	IF(IDIM1.EQ.IDIM)
     &ESTADBC=ESTADBC+0.5D0*DHUBDEG(IDEG,IDEG)*
     &(UPAR*ZAVRSCF(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZAVRSCF(ISPIN)/2.D0*DBLE(MSPIN)-(UPAR-GPAR)*
     &ZAVRSCF(ISPIN)/2.D0*DBLE(MSPIN)/(DBLE(NDEG)/2.D0))
C 23. Analitical spin polarized limit of Sigma(inf) with Nimp
	ELSEIF(KDBLCNT(L,IATOM).EQ.23)THEN
	IF(IDIM1.EQ.IDIM)
     &ESTADBC=ESTADBC+0.5D0*DHUBDEG(IDEG,IDEG)*
     &(UPAR*ZOCCIMP(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZOCCIMP(ISPIN)/2.D0*DBLE(MSPIN)-(UPAR-GPAR)*
     &ZOCCIMP(ISPIN)/2.D0*DBLE(MSPIN)/(DBLE(NDEG)/2.D0))
C 24. Analitical spin restricted limit of Sigma(inf) with Nimp
	ELSEIF(KDBLCNT(L,IATOM).EQ.24)THEN
	IF(IDIM1.EQ.IDIM)
     &ESTADBC=ESTADBC+0.5D0*DHUBDEG(IDEG,IDEG)*
     &(UPAR*ZAVRIMP(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZAVRIMP(ISPIN)/2.D0*DBLE(MSPIN)-(UPAR-GPAR)*
     &ZAVRIMP(ISPIN)/2.D0*DBLE(MSPIN)/(DBLE(NDEG)/2.D0))
C 30. Fixed double counting
	ELSEIF(KDBLCNT(L,IATOM).EQ.30)THEN
      ESTADBC=ESTADBC+0.5D0*DHUBDEG(IDEG1,IDEG)*
     &VDBCDEG(IDEG1,IDEG)
C 40. Double counting according to Eloc
	ELSEIF(KDBLCNT(L,IATOM).EQ.40)THEN
      ESTADBC=ESTADBC+0.5D0*DHUBDEG(IDEG1,IDEG)*
     &VDBCDEG(IDEG1,IDEG)
C 50. Sigma(0)
	ELSEIF(KDBLCNT(L,IATOM).EQ.50)THEN
      ESTADBC=ESTADBC+0.5D0*DHUBDEG(IDEG1,IDEG)*
     &VDBCDEG(IDEG1,IDEG)
C 60. Sigma(inf)
	ELSEIF(KDBLCNT(L,IATOM).EQ.60)THEN
      ESTADBC=ESTADBC+0.5D0*DHUBDEG(IDEG1,IDEG)*
     &VDBCDEG(IDEG1,IDEG)
      ENDIF
C *********************************************
C Galitsky-Migdal formulae for the static parts
	EGALHFK=EGALHFK+0.5D0*DHUBDEG(IDEG1,IDEG)*
     &SIGIDEG(IDEG1,IDEG)
	EGALDBC=EGALDBC+0.5D0*DHUBDEG(IDEG1,IDEG)*
     &VDBCDEG(IDEG1,IDEG)
	ENDDO
	ENDDO
C *****************************************************
C SET RETURNING ARRAYS
	IDEG1=0
	DO IDIM1=1,NDIM
	IF(KSTATES(IDIM1,IRUN,L,IATOM).EQ.0)CYCLE
	IDEG1=IDEG1+1
	IDEG=0
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.0)CYCLE
	IDEG=IDEG+1
C Set self-energy
	DO IMSC=0,NMSC
      SIGWMAT(IMSC,IDIM1,IDIM)=SIGWDEG(IMSC,IDEG1,IDEG)
	ENDDO
C Set self-energy at infinity
      SIGIMAT(IDIM1,IDIM)=SIGIDEG(IDEG1,IDEG)
C Set self-energy at zero
      SIG0MAT(IDIM1,IDIM)=SIG0DEG(IDEG1,IDEG)
C Set double counting potential
	VDBCMAT(IDIM1,IDIM)=VDBCDEG(IDEG1,IDEG)
C Set bare impurity levels
	ELOCMAT(IDIM1,IDIM)=ELOCDEG(IDEG1,IDEG)
C Set rational interpolation coefficients
	DO IPOL=1,NPOLIMP(L,IATOM)
	VRATMAT(IDIM1,IDIM,IPOL)=VRATDEG(IDEG1,IDEG,IPOL)
	WRATMAT(IDIM1,IDIM,IPOL)=WRATDEG(IDEG1,IDEG,IPOL)
	PRATMAT(IDIM1,IDIM,IPOL)=PRATDEG(IDEG1,IDEG,IPOL)
	ORATMAT(IDIM1,IDIM,IPOL)=ORATDEG(IDEG1,IDEG,IPOL)
	ENDDO
	ENDDO
	ENDDO
C MEMORY DEALLOCATIONS
	DEALLOCATE(SIGWDEG,SIGIDEG,SIG0DEG,DHUBDEG)
	DEALLOCATE(EIMPDEG,ELOCDEG,OIMPDEG,ELDADEG)
	DEALLOCATE(VRATDEG,WRATDEG,PRATDEG,ORATDEG)
	DEALLOCATE(VDBCDEG,SIGI,SIGA)
 1000	CONTINUE
	END
