      SUBROUTINE IMP_IMPFSIG(L,IATOM,DHUBMAT,VDBCMAT,EIMPMAT,
     &     ELOCMAT,OIMPMAT,SIGWMAT,SIGIMAT,SIG0MAT,VRATMAT,
     &     WRATMAT,PRATMAT,ORATMAT,UIMP,UPAR,GPAR,IERR)
************************************************************
*  Subroutine solves Anderson impurity model for given     *
*  hybridization function Delta(iWn)                       *
*  Hartree-Fock approximation is used                      *
*  Returns Sigma(w),Sigma(0),Sigma(inf) as well as         *
*  rational interpolation coefficients for the self-energy * 
************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                    !!! from setup
      USE COM_CONTROL ,ONLY: LIFT,LMTO,IDMF                             !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS,ILSB            !!! from readini
      USE COM_MSBMESH ,ONLY: TEMP,NMSC,WMSC,FMSC                        !!! from readhub
	USE COM_IMPDAT  ,ONLY: NRUNIMP,KSTATES,NPOLIMP                    !!! from readhub
      USE COM_HUBDAT  ,ONLY: MCRL,LCRL,KSOLVER,KSIGMOO,KIMPLEV,
     &                       KDBLCNT,CDBLCNT                            !!! from readhub
      USE COM_FERMI   ,ONLY: EF                                         !!! from ttrints
      USE COM_LMTOUT  ,ONLY: SCRFILE                                    !!! from readini
      USE COM_MASHDEP ,ONLY: NVAL,LENCMP                                !!! from setup
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                            !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 UIMP(2*(2*L+1),2*(2*L+1),2*(2*L+1),2*(2*L+1))
	COMPLEX*16 SIGWMAT(0:NMSCMEM+1,2*(2*L+1),2*(2*L+1))
     &          ,DHUBMAT(         2*(2*L+1),2*(2*L+1))
     &          ,VDBCMAT(         2*(2*L+1),2*(2*L+1))
     &          ,EIMPMAT(         2*(2*L+1),2*(2*L+1))
     &          ,ELOCMAT(         2*(2*L+1),2*(2*L+1))
     &          ,SIGIMAT(         2*(2*L+1),2*(2*L+1))
     &          ,SIG0MAT(         2*(2*L+1),2*(2*L+1))
     &          ,OIMPMAT(         2*(2*L+1),2*(2*L+1))
     &          ,VRATMAT(         2*(2*L+1),2*(2*L+1),NPOLMEM)
     &          ,WRATMAT(         2*(2*L+1),2*(2*L+1),NPOLMEM)
     &          ,PRATMAT(         2*(2*L+1),2*(2*L+1),NPOLMEM)
     &          ,ORATMAT(         2*(2*L+1),2*(2*L+1),NPOLMEM)
C Local allocatable arrays
	COMPLEX*16 DIM,CAVR
	INTEGER, ALLOCATABLE :: MREP(:)
	INTEGER, ALLOCATABLE :: LCFG(:)
	INTEGER, ALLOCATABLE :: IPCF(:)
	INTEGER, ALLOCATABLE :: IPRF(:)
	INTEGER, ALLOCATABLE :: IPNF(:)
	INTEGER, ALLOCATABLE :: IPNF0(:)
	INTEGER, ALLOCATABLE :: IPNFP1(:)
	INTEGER, ALLOCATABLE :: LREP(:)
	INTEGER, ALLOCATABLE :: LREP0(:)
	INTEGER, ALLOCATABLE :: LREP1(:)
	INTEGER, ALLOCATABLE :: LREP2(:)
	INTEGER, ALLOCATABLE :: KDREP(:)
	INTEGER, ALLOCATABLE :: KDR00(:)
	INTEGER, ALLOCATABLE :: KDR12(:)
	REAL*8, ALLOCATABLE :: COMB(:,:)
	REAL*8, ALLOCATABLE :: COMR(:)
	COMPLEX*16, ALLOCATABLE :: SIGIDEG(:,:)
	COMPLEX*16, ALLOCATABLE :: SIG0DEG(:,:)
	COMPLEX*16, ALLOCATABLE :: OIMPDEG(:,:)
	COMPLEX*16, ALLOCATABLE :: DHUBDEG(:,:)
	COMPLEX*16, ALLOCATABLE :: VDBCDEG(:,:)
	COMPLEX*16, ALLOCATABLE :: EIMPDEG(:,:)
	COMPLEX*16, ALLOCATABLE :: ELOCDEG(:,:)
	COMPLEX*16, ALLOCATABLE :: SIGWDEG(:,:,:)
	COMPLEX*16, ALLOCATABLE :: VRATDEG(:,:,:)
	COMPLEX*16, ALLOCATABLE :: WRATDEG(:,:,:)
	COMPLEX*16, ALLOCATABLE :: PRATDEG(:,:,:)
	COMPLEX*16, ALLOCATABLE :: ORATDEG(:,:,:)
	COMPLEX*16, ALLOCATABLE :: SIGA(:,:,:)
	COMPLEX*16, ALLOCATABLE :: SIGI(:,:)
	COMPLEX*16, ALLOCATABLE :: GINV(:,:)
	COMPLEX*16, ALLOCATABLE :: ELDA(:,:)
	COMPLEX*16, ALLOCATABLE :: WORK(:)
	REAL*8 ZAVRSCF(2),ZOCCSCF(2),ZAVRIMP(2),ZOCCIMP(2)
      DATA PI/3.141592653589793D0/,DIM/(0.D0,1.D0)/,EPSDEG/1.D-05/
      CALL ABORTNOW()
	IERR=0
	ISORT=IS(IATOM)
	NDIM=2*(2*L+1)
	EFRM=EF
	CHEM=EF
C DO OVER SOLUTIONS OF IMPURITY MODEL
	DO 1000 IRUN=1,NRUNIMP(L,IATOM)
C Count states which participate in this run
	NDEG=0 ! this is degeneracy within this run
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).NE.0)NDEG=NDEG+1
	ENDDO
	IF(NDEG.EQ.0)GOTO 1000
C MEMORY ALLOCATIONS
	ALLOCATE(SIGIDEG(NDEG,NDEG))
	ALLOCATE(SIG0DEG(NDEG,NDEG))
	ALLOCATE(DHUBDEG(NDEG,NDEG))
	ALLOCATE(EIMPDEG(NDEG,NDEG))
	ALLOCATE(ELOCDEG(NDEG,NDEG))
	ALLOCATE(VDBCDEG(NDEG,NDEG))
	ALLOCATE(OIMPDEG(NDEG,NDEG))
	ALLOCATE(SIGWDEG(0:NMSCMEM+1,NDEG,NDEG))
	ALLOCATE(VRATDEG(NDEG,NDEG,NPOLMEM))
	ALLOCATE(WRATDEG(NDEG,NDEG,NPOLMEM))
	ALLOCATE(PRATDEG(NDEG,NDEG,NPOLMEM))
	ALLOCATE(ORATDEG(NDEG,NDEG,NPOLMEM))
	ALLOCATE(SIGI(NDEG,NDEG))
	ALLOCATE(COMB(0:NDEG,0:NDEG))
C COMBINATORICS
	CALL LIB_GETCOMB(COMB,NDEG)
C ****************************************************
C REALLOCATE INPUT ARRAYS WITHIN CURRENT DEGENERACY
	IDEG1=0
	DO IDIM1=1,NDIM
	IF(KSTATES(IDIM1,IRUN,L,IATOM).EQ.0)CYCLE
	IDEG1=IDEG1+1
	IDEG=0
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.0)CYCLE
	IDEG=IDEG+1
C Impurity levels, self-energy limits
	EIMPDEG(IDEG1,IDEG)=EIMPMAT(IDIM1,IDIM)
	ELOCDEG(IDEG1,IDEG)=ELOCMAT(IDIM1,IDIM)
	OIMPDEG(IDEG1,IDEG)=OIMPMAT(IDIM1,IDIM)
	DHUBDEG(IDEG1,IDEG)=DHUBMAT(IDIM1,IDIM)
	SIGIDEG(IDEG1,IDEG)=SIGIMAT(IDIM1,IDIM)
	VDBCDEG(IDEG1,IDEG)=VDBCMAT(IDIM1,IDIM)
	SIG0DEG(IDEG1,IDEG)=SIG0MAT(IDIM1,IDIM)
C Self-energy, bath and hybridization
	DO IMSC=0,NMSC
	SIGWDEG(IMSC,IDEG1,IDEG)=SIGWMAT(IMSC,IDIM1,IDIM)
	ENDDO
C Rational interpolation coefficients
	DO IPOL=1,NPOLIMP(L,IATOM)
	VRATDEG(IDEG1,IDEG,IPOL)=VRATMAT(IDIM1,IDIM,IPOL)
	WRATDEG(IDEG1,IDEG,IPOL)=WRATMAT(IDIM1,IDIM,IPOL)
	PRATDEG(IDEG1,IDEG,IPOL)=PRATMAT(IDIM1,IDIM,IPOL)
	ORATDEG(IDEG1,IDEG,IPOL)=ORATMAT(IDIM1,IDIM,IPOL)
	ENDDO
	ENDDO
	ENDDO
C *******************************************************	
C Check states which participate
	IF(NRUNIMP(L,IATOM).NE.1)
     &CALL FULLSTOP('This solver assumes NRUNIMP=1')
	NDEG=0 ! this is total degeneracy
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).NE.0)NDEG=NDEG+1
	ENDDO
	IF(NDEG.NE.NDIM)
     &CALL FULLSTOP('Wrong KSTATES array for this solver')
C Count # of representations as non-equivalent elements of KSTATES pointer
	IREP0=0
	IREP1=0
	IREP2=0
	DO IPOS=1,NDIM
	ISUB0=0
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.IPOS)ISUB0=ISUB0+1
	ENDDO
	ISUB1=0
	DO IDIM=1,NDIM/2
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.IPOS)ISUB1=ISUB1+1
	ENDDO
	ISUB2=0
	DO IDIM=NDIM/2+1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.IPOS)ISUB2=ISUB2+1
	ENDDO
	IF(ISUB0.NE.0)IREP0=IREP0+1
	IF(ISUB1.NE.0)IREP1=IREP1+1
	IF(ISUB2.NE.0)IREP2=IREP2+1
	ENDDO
	NREP0=IREP0
	NREP1=IREP1
	NREP2=IREP2
	ALLOCATE(LREP0(NREP0))
	ALLOCATE(LREP1(NREP1))
	ALLOCATE(LREP2(NREP2))
	ALLOCATE(KDREP(NDIM))
	ALLOCATE(KDR00(NDIM))
	ALLOCATE(KDR12(NDIM))
	DO IDIM=1,NDIM
	KDR00(IDIM)=-1
	KDR12(IDIM)=-1
	ENDDO
C Find degeneracies of each sublevel
	IREP0=0
	IREP1=0
	IREP2=0
	DO IPOS=1,NDIM
	ISUB0=0
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.IPOS)ISUB0=ISUB0+1
	ENDDO
	IF(ISUB0.NE.0)THEN
	IREP0=IREP0+1
	LREP0(IREP0)=ISUB0
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.IPOS)KDR00(IDIM)=IREP0
	ENDDO
	ENDIF
	ISUB1=0
	DO IDIM=1,NDIM/2
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.IPOS)ISUB1=ISUB1+1
	ENDDO
	IF(ISUB1.NE.0)THEN
	IREP1=IREP1+1
	LREP1(IREP1)=ISUB1
	DO IDIM=1,NDIM/2
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.IPOS)KDR12(IDIM)=IREP1
	ENDDO
	ENDIF
	ISUB2=0
	DO IDIM=NDIM/2+1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.IPOS)ISUB2=ISUB2+1
	ENDDO
	IF(ISUB2.NE.0)THEN
	IREP2=IREP2+1
	LREP2(IREP2)=ISUB2
	DO IDIM=NDIM/2+1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.IPOS)KDR12(IDIM)=IREP2
	ENDDO
	ENDIF
	ENDDO
C Check full degeneracy
	IDEG=0
	DO IREP0=1,NREP0
	IDEG=IDEG+LREP0(IREP0)
	ENDDO
	IF(IDEG.NE.NDEG)
     &CALL FULLSTOP('Wrong KSTATES pointer for this solver')
	IDEG=0
	DO IREP1=1,NREP1
	IDEG=IDEG+LREP1(IREP1)
	ENDDO
	DO IREP2=1,NREP2
	IDEG=IDEG+LREP2(IREP2)
	ENDDO
	IF(IDEG.NE.NDEG)
     &CALL FULLSTOP('Wrong KSTATES pointer for this solver')
C Check if spin polarization is allowed
	IF(NREP1.EQ.NREP2)MSPIN=NSPIN
	IF(NREP1.NE.NREP2)MSPIN=1      ! switch off spin polarization
	IF(NREP1.EQ.NREP2)THEN         ! check again
	DO IREP=1,NREP1
	IF(LREP1(IREP).NE.LREP2(IREP))MSPIN=1
	ENDDO
	ENDIF
	IF(MSPIN.EQ.NSPIN)NREP=(NREP1+NREP2)/2
	IF(MSPIN.NE.NSPIN)NREP=NREP0
	ALLOCATE(LREP(NREP))
	DO IREP=1,NREP
	IF(MSPIN.EQ.NSPIN.AND.NREP1.EQ.NREP2)
     &LREP(IREP)=(LREP1(IREP)+LREP2(IREP))/MSPIN
	IF(MSPIN.NE.NSPIN.OR .NREP1.NE.NREP2)
     &LREP(IREP)=LREP0(IREP)
	ENDDO
	DO IDIM=1,NDIM
	IF(MSPIN.EQ.NSPIN)
     &KDREP(IDIM)=KDR12(IDIM)
	IF(MSPIN.NE.NSPIN)
     &KDREP(IDIM)=KDR00(IDIM)
	ENDDO
C CONFIGURATIONS PER SPIN, Minimum: NDEG/2+1, Maximum 2**(NDEG/2)
	DO ISPIN=1,MSPIN
	NCNF=1
	DO IREP=1,NREP
	NCNF=NCNF*(LREP(IREP)+1)
	ENDDO
	ENDDO
	IF(MSPIN.EQ.1)NCNF0=1
	IF(MSPIN.EQ.2)NCNF0=NCNF
C CONFIGURATIONS, Minimum: NDEG/2+1, Maximum 2**(NDEG/2)
	ALLOCATE(MREP(0:NREP))
	MREP(0)=1
	DO IREP=1,NREP
	MREP(IREP)=MREP(IREP-1)*(LREP(IREP)+1)
	ENDDO
C SORT BY NUMBERS OF ELECTRONS
	ALLOCATE(IPNF(NREP))
	ALLOCATE(IPNF0(NREP))
	ALLOCATE(IPNFP1(NREP))
	ALLOCATE(IPCF(NCNF))
	ALLOCATE(IPRF(NCNF))
	ALLOCATE(LCFG(0:NDEG/MSPIN))
C Looping over total allowed numbers of electrons in all sublevels
	ICFR=0
	DO IDEG=0,NDEG/MSPIN
	LCFG(IDEG)=0
C Configurations are numbered in one way from 1 to NCNF.
C Start looping over them
	DO ICNF=1,NCNF
C Find out numbers of electrons at each sublevel for given configuration ICNF
C Return array is IPNF(IREP) for spin channel
	CALL LIB_GETCONF(NREP,LREP,MREP,ICNF,NCNF,IPNF)
	NELC=0 ! count # of electrons for given configuration
	DO IREP=1,NREP
	NELC=NELC+IPNF(IREP)
	ENDDO
C if this configuration contains right number of electrons, count it
	IF(NELC.NE.IDEG)CYCLE 
	LCFG(IDEG)=LCFG(IDEG)+1
	ICFR=ICFR+1
C this pointer relates second-to-first numbering schemes for configurations
	IPCF(ICFR)=ICNF 
	ENDDO
	ENDDO
C CHECK ALGORITHM
	ICFR=0 ! second way of numbering configurations
C looping over allowed total numbers of electrons of the same spin
	DO IDEG=0,NDEG/MSPIN
C looping over configurations within given number of electrons of the same spin
	DO ICFG=1,LCFG(IDEG) 
	ICFR=ICFR+1
	ICNF=IPCF(ICFR) ! find out the configuration in first numbering scheme
C Find out array showing how many electrons are in each sublevel
	CALL LIB_GETCONF(NREP,LREP,MREP,ICNF,NCNF,IPNF) 
	NELC=0 ! count # of electrons
	DO IREP=1,NREP
	IF(IPNF(IREP).LT.0.OR.IPNF(IREP).GT.LREP(IREP))
     &CALL FULLSTOP('Wrong configuration')
	NELC=NELC+IPNF(IREP)
	ENDDO
	ENDDO
	IF(NELC.NE.IDEG)CALL FULLSTOP('# of electrons mismatch')
	ENDDO
C Set reciprocal pointer which related first-to-second numbering scheme for configirations
	DO ICNF=1,NCNF 
	IPRF(ICNF)=-1
	ENDDO
	DO ICFR=1,NCNF
	ICNF=IPCF(ICFR)
	IPRF(ICNF)=ICFR
	ENDDO
	DO ICNF=1,NCNF
	IF(IPRF(ICNF).EQ.-1)CALL FULLSTOP('Wrong reciprocal pointer')
	ENDDO
C Compute product of all combinatorics using second scheme of 
C numbering configurations
	ALLOCATE(COMR(NCNF))
	ICFR=0
	DO IDEG=0,NDEG/MSPIN
	DO ICFG=1,LCFG(IDEG)
	ICFR=ICFR+1
	ICNF=IPCF(ICFR)
	CALL LIB_GETCONF(NREP,LREP,MREP,ICNF,NCNF,IPNF)
	COMR(ICFR)=1.D0 
	DO IREP=1,NREP
	COMR(ICFR)=COMR(ICFR)*COMB(IPNF(IREP),LREP(IREP))
	ENDDO
	ENDDO
	ENDDO
C CHECK COMBINATORICS
	SUS=0.D0
	ICFR=0
	DO IDEG=0,NDEG/MSPIN
	SUM=0.D0
	DO ICFG=1,LCFG(IDEG)
	ICFR=ICFR+1
	SUM=SUM+COMR(ICFR)
	SUS=SUS+COMR(ICFR)
	ENDDO
	IF(ABS(SUM-COMB(IDEG,NDEG/MSPIN)).GT.1.D-07)
     &CALL FULLSTOP('Combinatorics mismatch')
	ENDDO
	IF(ABS(SUS-2.D0**(NDEG/MSPIN)).GT.1.D-07)
     &CALL FULLSTOP('Combinatorics mismatch')
C *********************************************************
C Occupancies
	DO ISPIN=1,MSPIN
	ZOCCSCF(ISPIN)=0.D0
	ENDDO
	IDEG=0
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.0)CYCLE
	IDEG=IDEG+1
	ISPIN=(2*IDIM-1)/NDIM+1
	IF(MSPIN.EQ.1)ISPIN=1
	ZOCCSCF(ISPIN)=ZOCCSCF(ISPIN)+DHUBDEG(IDEG,IDEG)
	ENDDO
	DO ISPIN=1,MSPIN
	ZAVRSCF(ISPIN)=ZOCCSCF(ISPIN)
	ENDDO
C Average occupancies for spin restricted double countings
	ZOCCAVR=(ZAVRSCF(1)+ZAVRSCF(MSPIN))/2.D0
	ZAVRSCF(1)=ZOCCAVR
	ZAVRSCF(MSPIN)=ZOCCAVR
	DO ISPIN=1,MSPIN
	ZOCCIMP(ISPIN)=ZOCCSCF(ISPIN)
	ZAVRIMP(ISPIN)=ZAVRSCF(ISPIN)
	ENDDO
C ***********************************************
C Set Mean Field (LDA) position of impurity level
	ALLOCATE(ELDA(NREP,MSPIN))
	IDEG=0
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.0)CYCLE
	IDEG=IDEG+1
	IREP=KDREP(IDIM)
	ISPIN=(2*IDIM-1)/NDIM+1
	IF(MSPIN.EQ.1)ISPIN=1
	ELDA(IREP,ISPIN)=EIMPDEG(IDEG,IDEG)-
     &(SIGIDEG(IDEG,IDEG)-VDBCDEG(IDEG,IDEG))
	ENDDO
C Average LDA levels if paramagnetic double counting is working
	IF(MOD(KDBLCNT(L,IATOM),2).EQ.0)THEN
	DO IREP=1,NREP
	ELDAAVR=(ELDA(IREP,1)+ELDA(IREP,MSPIN))/2.D0
	ELDA(IREP,1)=ELDAAVR
	ELDA(IREP,MSPIN)=ELDAAVR
	ENDDO
	ENDIF
C ****************************************************
C SELF-ENERGY AT INFINITY CAN BE SET ACCORDING TO THE CURRENT OCCUPANCIES
C In general we have four ways of dealing with it, (1) by using 
C full density matrix coming from LDA or (2) exact diagonalization
C or using average occupancy matrices, cases (3) and (4)
      ALLOCATE(SIGA(NDIM,NDIM,4))
	IDEG=0
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.0)CYCLE
	IDEG=IDEG+1
	IREP=KDREP(IDIM)
	ISPIN=(2*IDIM-1)/NDIM+1
	IF(MSPIN.EQ.1)ISPIN=1
	IF(ISPIN.EQ.1)ISPINM=MSPIN
	IF(ISPIN.EQ.MSPIN)ISPINM=1
	IDEG1=0
	DO IDIM1=1,NDIM
	IF(KSTATES(IDIM1,IRUN,L,IATOM).EQ.0)CYCLE
	IDEG1=IDEG1+1
	IREP1=KDREP(IDIM1)
	ISPIN1=(2*IDIM1-1)/NDIM+1
	IF(MSPIN.EQ.1 )ISPIN1=1
	IF(ISPIN1.EQ.1)ISPIN1M=MSPIN
	IF(ISPIN1.EQ.MSPIN)ISPIN1M=1
      SIGA(IDIM,IDIM1,1)=(0.D0,0.D0)
      SIGA(IDIM,IDIM1,2)=(0.D0,0.D0)
      SIGA(IDIM,IDIM1,3)=(0.D0,0.D0)
      SIGA(IDIM,IDIM1,4)=(0.D0,0.D0)
	IF(IDIM.EQ.IDIM1)ONE=1.D0
	IF(IDIM.NE.IDIM1)ONE=0.D0
	JDEG=0
	DO JDIM=1,NDIM
	IF(KSTATES(JDIM,IRUN,L,IATOM).EQ.0)CYCLE
	JDEG=JDEG+1
	JDEG1=0
	DO JDIM1=1,NDIM
	IF(KSTATES(JDIM1,IRUN,L,IATOM).EQ.0)CYCLE
	JDEG1=JDEG1+1
C Matrix Case
      SIGA(IDIM,IDIM1,1)=SIGA(IDIM,IDIM1,1)+
     &(UIMP(IDIM,JDIM,IDIM1,JDIM1)-UIMP(IDIM,JDIM,JDIM1,IDIM1))*
     &DHUBDEG(JDEG,JDEG1)
	ENDDO
	ENDDO
C SU(N) Case
      SIGA(IDIM,IDIM1,2)=UPAR*ZOCCSCF(ISPINM)/2.D0*DBLE(MSPIN)*ONE+
     &(UPAR-GPAR)*(ZOCCSCF(ISPIN)/2.D0*DBLE(MSPIN)*ONE-
     & DHUBDEG(IDEG,IDEG1))
C Other cases
      SIGA(IDIM,IDIM1,3)=SIGWDEG(NMSC,IDIM,IDIM1)
      SIGA(IDIM,IDIM1,4)=SIGIDEG(IDIM,IDIM1)
	ENDDO
	ENDDO
C RESET SELF-ENERGY AT INFINITY: 
C Note that it is probably better to use average occupancies and interactions
C than exact Coulomb and density matrices due to well known problem of Hartree
C term and full potential LDA taking care of those. 
	IDEG1=0
	DO IDIM1=1,NDIM
	IF(KSTATES(IDIM1,IRUN,L,IATOM).EQ.0)CYCLE
	IDEG1=IDEG1+1
	IDEG=0
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.0)CYCLE
	IDEG=IDEG+1
	IF(KSIGMOO(L,IATOM).EQ.11.OR.KSIGMOO(L,IATOM).EQ.12) ! analitical matrix
     &SIGI(IDEG1,IDEG)=SIGA(IDIM1,IDIM,1)
	IF(KSIGMOO(L,IATOM).EQ.21.OR.KSIGMOO(L,IATOM).EQ.22) ! analitical spherical
     &SIGI(IDEG1,IDEG)=SIGA(IDIM1,IDIM,2)
	IF(KSIGMOO(L,IATOM).EQ.31) ! numerical
     &SIGI(IDEG1,IDEG)=SIGA(IDIM1,IDIM,3)
	IF(KSIGMOO(L,IATOM).EQ.41) ! given by input
     &SIGI(IDEG1,IDEG)=SIGA(IDIM1,IDIM,4)
	ENDDO
	ENDDO
C ******************************************************
C SET OUTPUT ARRAYS
	ALLOCATE(GINV(NDEG,NDEG))
	ALLOCATE(WORK(NDEG))
	DO IMSC=0,NMSC                  ! over frequencies
	ZMSC=WMSC(IMSC)
	IDEG1=0
	DO IDIM1=1,NDIM
	IF(KSTATES(IDIM1,IRUN,L,IATOM).EQ.0)CYCLE
	IDEG1=IDEG1+1
	IDEG=0
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.0)CYCLE
	IDEG=IDEG+1
	IF(IDMF.EQ.3)
     &SIGWDEG(IMSC,IDEG1,IDEG)=SIGWDEG(IMSC,IDEG1,IDEG)-
     &SIGWDEG(NMSC,IDEG1,IDEG)+SIGI(IDEG1,IDEG)
	IF(IDMF.EQ.4)
     &SIGWDEG(IMSC,IDEG1,IDEG)=SIGI(IDEG1,IDEG)
	IF(IDMF.EQ.5)
     &SIGWDEG(IMSC,IDEG1,IDEG)=SIGWDEG(IMSC,IDIM1,IDIM)
      ENDDO
      ENDDO
C Force self-energy form as follows from pole expansion
	IF(IDMF.EQ.4)THEN
	DO IPOL=1,NPOL         ! over poles
	DO IDEG1=1,NDEG
	DO IDEG =1,NDEG
	GINV(IDEG1,IDEG)=
     &ZMSC*ORATDEG(IDEG1,IDEG,IPOL)-PRATDEG(IDEG1,IDEG,IPOL)
	ENDDO
	ENDDO
C Invert matrix
	CALL LIB_CINV(NDIM,GINV,NDEG,WORK,IFAIL)
	IF(IFAIL.NE.0)THEN
      WRITE(IUN,*)'<IMP_IMPFSIG>:: Error in inversion program'
	DO IDEG1=1,NDEG
	DO IDEG =1,NDEG
	GINV(IDEG1,IDEG)=(0.D0,0.D0)
	ENDDO
	ENDDO
	ENDIF
C Construct product
	IDEG1=0
	DO IDIM1=1,NDIM
	IF(KSTATES(IDIM1,IRUN,L,IATOM).EQ.0)CYCLE
	IDEG1=IDEG1+1
	IDEG=0
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.0)CYCLE
	IDEG=IDEG+1
	DO JDEG1=1,NDEG
	DO JDEG =1,NDEG
      SIGWDEG(IMSC,IDEG1,IDEG)=SIGWDEG(IMSC,IDEG1,IDEG)+
     &VRATDEG(IDEG1,JDEG1,IPOL)*GINV(JDEG1,JDEG)*WRATDEG(JDEG,IDEG,IPOL) ! swapped indexes in Warr !
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO                           ! over poles
	ENDIF
	ENDDO                           ! over frequencies
C SET OUTPUT ARRAYS
	IDEG1=0
	DO IDIM1=1,NDIM
	IF(KSTATES(IDIM1,IRUN,L,IATOM).EQ.0)CYCLE
	IDEG1=IDEG1+1
	IREP1=KDREP(IDIM1)
	ISPIN1=(2*IDIM1-1)/NDIM+1
	IF(MSPIN.EQ.1)ISPIN1=1
	IDEG=0
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.0)CYCLE
	IDEG=IDEG+1
	IREP=KDREP(IDIM)
	ISPIN=(2*IDIM-1)/NDIM+1
	IF(MSPIN.EQ.1)ISPIN=1
	IF(IDIM1.EQ.IDIM)ONE=1.D0
	IF(IDIM1.NE.IDIM)ONE=0.D0
C Set self-energy at infinity
      SIGIDEG(IDEG1,IDEG)=SIGI(IDIM1,IDIM)
C Set self-energy at zero
      IF(IDMF.EQ.3)
     &SIG0DEG(IDEG1,IDEG)=SIGWDEG(0,IDEG1,IDEG)
      IF(IDMF.EQ.4)
     &SIG0DEG(IDEG1,IDEG)=SIGWDEG(0,IDEG1,IDEG)
      IF(IDMF.EQ.5)
     &SIG0DEG(IDEG1,IDEG)=SIG0DEG(IDEG1,IDEG)
C Reset self-energy
	DO IMSC=0,NMSC
	IF(IDMF.EQ.3)
     &SIGWDEG(IMSC,IDEG1,IDEG)=SIGWDEG(IMSC,IDEG1,IDEG)-
     &SIGWDEG(NMSC,IDEG1,IDEG)+SIGIDEG(IDEG1,IDEG)
	ENDDO
C Set rational interpolation coefficients
	DO IPOL=1,NPOLIMP(L,IATOM)
	VRATDEG(IDEG1,IDEG,IPOL)=VRATDEG(IDEG1,IDEG,IPOL)
	WRATDEG(IDEG1,IDEG,IPOL)=WRATDEG(IDEG1,IDEG,IPOL)
	PRATDEG(IDEG1,IDEG,IPOL)=PRATDEG(IDEG1,IDEG,IPOL)
	ORATDEG(IDEG1,IDEG,IPOL)=ORATDEG(IDEG1,IDEG,IPOL)
	ENDDO
C Set bare impurity levels unless they are fixed from input
	IF(IDEG1.EQ.IDEG.AND.KIMPLEV(L,IATOM)/10.NE.3)
     &ELOCDEG(IDEG1,IDEG)=EIMPDEG(IDEG1,IDEG)-EFRM-SIGIDEG(IDEG1,IDEG)
	IF(IDEG1.NE.IDEG.AND.KIMPLEV(L,IATOM)/10.NE.3)
     &ELOCDEG(IDEG1,IDEG)=EIMPDEG(IDEG1,IDEG)-SIGIDEG(IDEG1,IDEG)
C Set double counting potential
	IF(ISPIN.EQ.1)ISPINM=MSPIN
	IF(ISPIN.EQ.MSPIN)ISPINM=1
C 00  Keep this array untouched
	IF(KDBLCNT(L,IATOM).EQ.0)
     &VDBCDEG(IDEG1,IDEG)=VDBCDEG(IDEG1,IDEG)
C 11. Fully localized spin polarized limit with Nscf
	IF(KDBLCNT(L,IATOM).EQ.11.AND.IDEG1.EQ.IDEG)
     &VDBCDEG(IDEG1,IDEG)=UPAR*ZOCCSCF(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZOCCSCF(ISPIN)/2.D0*DBLE(MSPIN)-(UPAR-GPAR)*
     &CDBLCNT(L,IATOM)
	IF(KDBLCNT(L,IATOM).EQ.11.AND.IDEG1.NE.IDEG)
     &VDBCDEG(IDEG1,IDEG)=(0.D0,0.D0)
C 12. Fully localized spin restricted limit with Nscf
	IF(KDBLCNT(L,IATOM).EQ.12.AND.IDEG1.EQ.IDEG)
     &VDBCDEG(IDEG1,IDEG)=UPAR*ZAVRSCF(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZAVRSCF(ISPIN)/2.D0*DBLE(MSPIN)-(UPAR-GPAR)*
     &CDBLCNT(L,IATOM)
	IF(KDBLCNT(L,IATOM).EQ.12.AND.IDEG1.NE.IDEG)
     &VDBCDEG(IDEG1,IDEG)=(0.D0,0.D0)
C 13. Fully localized spin polarized limit with Nimp
	IF(KDBLCNT(L,IATOM).EQ.13.AND.IDEG1.EQ.IDEG)
     &VDBCDEG(IDEG1,IDEG)=UPAR*ZOCCIMP(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZOCCIMP(ISPIN)/2.D0*DBLE(MSPIN)-(UPAR-GPAR)*
     &CDBLCNT(L,IATOM)
	IF(KDBLCNT(L,IATOM).EQ.13.AND.IDEG1.NE.IDEG)
     &VDBCDEG(IDEG1,IDEG)=(0.D0,0.D0)
C 14. Fully localized spin restricted limit with Nimp
	IF(KDBLCNT(L,IATOM).EQ.14.AND.IDEG1.EQ.IDEG)
     &VDBCDEG(IDEG1,IDEG)=UPAR*ZAVRIMP(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZAVRIMP(ISPIN)/2.D0*DBLE(MSPIN)-(UPAR-GPAR)*
     &CDBLCNT(L,IATOM)
	IF(KDBLCNT(L,IATOM).EQ.14.AND.IDEG1.NE.IDEG)
     &VDBCDEG(IDEG1,IDEG)=(0.D0,0.D0)
C 21. Analitical spin polarized limit of Sigma(inf) with Nscf
	IF(KDBLCNT(L,IATOM).EQ.21.AND.IDEG1.EQ.IDEG)
     &VDBCDEG(IDEG,IDEG)=UPAR*ZOCCSCF(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZOCCSCF(ISPIN)/2.D0*DBLE(MSPIN)-(UPAR-GPAR)*
     &ZOCCSCF(ISPIN)/2.D0*DBLE(MSPIN)/(DBLE(NDEG)/2.D0)
	IF(KDBLCNT(L,IATOM).EQ.21.AND.IDEG1.NE.IDEG)
     &VDBCDEG(IDEG1,IDEG)=(0.D0,0.D0)
C 22. Analitical spin restricted limit of Sigma(inf) with Nscf
	IF(KDBLCNT(L,IATOM).EQ.22.AND.IDEG1.EQ.IDEG)
     &VDBCDEG(IDEG,IDEG)=UPAR*ZAVRSCF(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZAVRSCF(ISPIN)/2.D0*DBLE(MSPIN)-(UPAR-GPAR)*
     &ZAVRSCF(ISPIN)/2.D0*DBLE(MSPIN)/(DBLE(NDEG)/2.D0)
	IF(KDBLCNT(L,IATOM).EQ.22.AND.IDEG1.NE.IDEG)
     &VDBCDEG(IDEG1,IDEG)=(0.D0,0.D0)
C 23. Analitical spin polarized limit of Sigma(inf) with Nimp
	IF(KDBLCNT(L,IATOM).EQ.23.AND.IDEG1.EQ.IDEG)
     &VDBCDEG(IDEG,IDEG)=UPAR*ZOCCIMP(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZOCCIMP(ISPIN)/2.D0*DBLE(MSPIN)-(UPAR-GPAR)*
     &ZOCCIMP(ISPIN)/2.D0*DBLE(MSPIN)/(DBLE(NDEG)/2.D0)
	IF(KDBLCNT(L,IATOM).EQ.23.AND.IDEG1.NE.IDEG)
     &VDBCDEG(IDEG1,IDEG)=(0.D0,0.D0)
C 24. Analitical spin restricted limit of Sigma(inf) with Nimp
	IF(KDBLCNT(L,IATOM).EQ.24.AND.IDEG1.EQ.IDEG)
     &VDBCDEG(IDEG,IDEG)=UPAR*ZAVRIMP(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZAVRIMP(ISPIN)/2.D0*DBLE(MSPIN)-(UPAR-GPAR)*
     &ZAVRIMP(ISPIN)/2.D0*DBLE(MSPIN)/(DBLE(NDEG)/2.D0)
	IF(KDBLCNT(L,IATOM).EQ.24.AND.IDEG1.NE.IDEG)
     &VDBCDEG(IDEG1,IDEG)=(0.D0,0.D0)
C 30. Fixed double counting
	IF(KDBLCNT(L,IATOM).EQ.30)
     &VDBCDEG(IDEG1,IDEG)=VDBCDEG(IDEG1,IDEG)
C 40. Double counting according to Eloc
	IF(KDBLCNT(L,IATOM).EQ.40.AND.IDEG1.EQ.IDEG)
     &VDBCDEG(IDEG1,IDEG)=ELDA(IREP,ISPIN)-CHEM-ELOCDEG(IDEG1,IDEG)
	IF(KDBLCNT(L,IATOM).EQ.40.AND.IDEG1.NE.IDEG)
     &VDBCDEG(IDEG1,IDEG)=(0.D0,0.D0)
C 50. Sigma(0)
	IF(KDBLCNT(L,IATOM).EQ.50)
     &VDBCDEG(IDEG1,IDEG)=SIG0DEG(IDEG1,IDEG)
C 60. Sigma(inf)
	IF(KDBLCNT(L,IATOM).EQ.60)
     &VDBCDEG(IDEG1,IDEG)=SIGIDEG(IDEG1,IDEG)
	ENDDO
	ENDDO
C MEMORY DEALLOCATIONS
	DEALLOCATE(MREP,LCFG,IPCF,IPRF,IPNF,IPNF0,IPNFP1,LREP,LREP0)
	DEALLOCATE(LREP1,LREP2,KDREP,KDR00,KDR12,COMB,COMR)
C *****************************************************
C SET RETURNING ARRAYS
	IDEG1=0
	DO IDIM1=1,NDIM
	IF(KSTATES(IDIM1,IRUN,L,IATOM).EQ.0)CYCLE
	IDEG1=IDEG1+1
	IDEG=0
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.0)CYCLE
	IDEG=IDEG+1
C Set self-energy
	DO IMSC=0,NMSC
      SIGWMAT(IMSC,IDIM1,IDIM)=SIGWDEG(IMSC,IDEG1,IDEG)
	ENDDO
C Set self-energy at infinity
      SIGIMAT(IDIM1,IDIM)=SIGIDEG(IDEG1,IDEG)
C Set self-energy at zero
      SIG0MAT(IDIM1,IDIM)=SIG0DEG(IDEG1,IDEG)
C Set double counting potential
	VDBCMAT(IDIM1,IDIM)=VDBCDEG(IDEG1,IDEG)
C Set bare impurity levels
	ELOCMAT(IDIM1,IDIM)=ELOCDEG(IDEG1,IDEG)
C Set rational interpolation coefficients
	DO IPOL=1,NPOLIMP(L,IATOM)
	VRATMAT(IDIM1,IDIM,IPOL)=VRATDEG(IDEG1,IDEG,IPOL)
	WRATMAT(IDIM1,IDIM,IPOL)=WRATDEG(IDEG1,IDEG,IPOL)
	PRATMAT(IDIM1,IDIM,IPOL)=PRATDEG(IDEG1,IDEG,IPOL)
	ORATMAT(IDIM1,IDIM,IPOL)=ORATDEG(IDEG1,IDEG,IPOL)
	ENDDO
	ENDDO
	ENDDO
C MEMORY DEALLOCATIONS
	DEALLOCATE(SIGWDEG,SIGIDEG,SIG0DEG,DHUBDEG)
	DEALLOCATE(VRATDEG,WRATDEG,PRATDEG,ORATDEG)
	DEALLOCATE(EIMPDEG,ELOCDEG,OIMPDEG)
	DEALLOCATE(VDBCDEG,SIGI,SIGA,GINV,WORK,ELDA)
 1000	CONTINUE
	END
