      SUBROUTINE IMP_IMPIRAT(L,IATOM,DHUBMAT,VDBCMAT,BATHMAT,
     &           EIMPMAT,ELOCMAT,OIMPMAT,SIGWMAT,DELWMAT,SIGIMAT,
     &           SIG0MAT,DELIMAT,BMASMAT,VRATMAT,WRATMAT,PRATMAT,
     &           ORATMAT,UIMP,UPAR,GPAR,IERR)
************************************************************
*  Subroutine solves Anderson impurity model for given     *
*  hybridization function Delta(iWn)                       *
*  Returns Sigma(w),Sigma(0),Sigma(inf) as well as         *
*  rational interpolation coefficients for the self-energy * 
************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                    !!! from setup
      USE COM_CONTROL ,ONLY: LIFT,LMTO,IDMF                             !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS,ILSB            !!! from readini
      USE COM_MSBMESH ,ONLY: TEMP,OBND,NMSC,WMSC,FMSC,KGRD              !!! from readhub
	USE COM_IMPDAT  ,ONLY: NRUNIMP,KSTATES,NPOLIMP,IMPSECT,
     &                       IMPINFO,IMPDATA,IMPWORK                    !!! from readhub
      USE COM_HUBDAT  ,ONLY: MCRL,LCRL,KSOLVER,KSIGMOO,KIMPLEV,
     &                       KDBLCNT,CDBLCNT                            !!! from readhub
      USE COM_FERMI   ,ONLY: EF                                         !!! from ttrints
      USE COM_LMTOUT  ,ONLY: SCRFILE                                    !!! from readini
      USE COM_MASHDEP ,ONLY: NVAL,LENCMP                                !!! from setup
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                            !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 UIMP(2*(2*L+1),2*(2*L+1),2*(2*L+1),2*(2*L+1))
	COMPLEX*16 BATHMAT(0:NMSC+1,2*(2*L+1),2*(2*L+1))
     &          ,DELWMAT(0:NMSC+1,2*(2*L+1),2*(2*L+1))
     &          ,SIGWMAT(0:NMSC+1,2*(2*L+1),2*(2*L+1))
     &          ,DHUBMAT(         2*(2*L+1),2*(2*L+1))
     &          ,VDBCMAT(         2*(2*L+1),2*(2*L+1))
     &          ,SIGIMAT(         2*(2*L+1),2*(2*L+1))
     &          ,SIG0MAT(         2*(2*L+1),2*(2*L+1))
     &          ,DELIMAT(         2*(2*L+1),2*(2*L+1))
     &          ,BMASMAT(         2*(2*L+1),2*(2*L+1))
     &          ,EIMPMAT(         2*(2*L+1),2*(2*L+1))
     &          ,ELOCMAT(         2*(2*L+1),2*(2*L+1))
     &          ,OIMPMAT(         2*(2*L+1),2*(2*L+1))
     &          ,VRATMAT(         2*(2*L+1),2*(2*L+1),NPOLMEM)
     &          ,WRATMAT(         2*(2*L+1),2*(2*L+1),NPOLMEM)
     &          ,PRATMAT(         2*(2*L+1),2*(2*L+1),NPOLMEM)
     &          ,ORATMAT(         2*(2*L+1),2*(2*L+1),NPOLMEM)
	COMPLEX*16 DIM,ZMSC,GMSB,EAVR,OAVR,BAVR,SAVR,DAVR
     &         ,RAVR,VAVR,XAVR,CAVR
	CHARACTER HELP*40,TCTRL*10,TCTRM*10,TCTRR*10,TCTRS*10,LIB_TDP*10
	INTEGER, ALLOCATABLE :: MREP(:)
	INTEGER, ALLOCATABLE :: LCFG(:)
	INTEGER, ALLOCATABLE :: IPCF(:)
	INTEGER, ALLOCATABLE :: IPRF(:)
	INTEGER, ALLOCATABLE :: IPNF(:)
	INTEGER, ALLOCATABLE :: IPNF0(:)
	INTEGER, ALLOCATABLE :: IPNFP1(:)
	INTEGER, ALLOCATABLE :: LREP(:)
	INTEGER, ALLOCATABLE :: LREP0(:)
	INTEGER, ALLOCATABLE :: LREP1(:)
	INTEGER, ALLOCATABLE :: LREP2(:)
	INTEGER, ALLOCATABLE :: KDREP(:)
	INTEGER, ALLOCATABLE :: KDR00(:)
	INTEGER, ALLOCATABLE :: KDR12(:)
	INTEGER, ALLOCATABLE :: IFIXSUN(:)
	INTEGER, ALLOCATABLE :: IFIXCRF(:,:)
	REAL*8, ALLOCATABLE :: COMB(:,:)
	REAL*8, ALLOCATABLE :: COMR(:)
	REAL*8, ALLOCATABLE :: XHUBSUN(:)
	REAL*8, ALLOCATABLE :: YHUBSUN(:)
	REAL*8, ALLOCATABLE :: EATSSUN(:)
	REAL*8, ALLOCATABLE :: XHUBCRF(:,:)
	REAL*8, ALLOCATABLE :: YHUBCRF(:,:)
	REAL*8, ALLOCATABLE :: PSIKSUN(:)
	REAL*8, ALLOCATABLE :: PSIKCRF(:,:)
	REAL*8, ALLOCATABLE :: ELOCCRF(:,:)
	REAL*8, ALLOCATABLE :: ELDACRF(:,:)
	REAL*8, ALLOCATABLE :: EINPCRF(:,:)
	REAL*8, ALLOCATABLE :: DELVCRF(:,:)
	REAL*8, ALLOCATABLE :: DELBCRF(:,:)
	REAL*8, ALLOCATABLE :: EATSCRF(:,:)
	REAL*8, ALLOCATABLE :: SIGICRF(:,:)
	REAL*8, ALLOCATABLE :: SIG0CRF(:,:)
	REAL*8, ALLOCATABLE :: ZMASCRF(:,:)
	REAL*8, ALLOCATABLE :: RMASCRF(:,:)
	REAL*8, ALLOCATABLE :: ZRESCRF(:,:)
	REAL*8, ALLOCATABLE :: VRATCRF(:,:)
	REAL*8, ALLOCATABLE :: WRATCRF(:,:)
	REAL*8, ALLOCATABLE :: POLECRF(:,:)
	REAL*8, ALLOCATABLE :: OVRLCRF(:,:)
	REAL*8, ALLOCATABLE :: ZIMPCRF(:,:)
	REAL*8, ALLOCATABLE :: ZREPCRF(:,:)
	REAL*8, ALLOCATABLE :: ZATMCRF(:,:)
	COMPLEX*16, ALLOCATABLE :: EIMPDEG(:,:)
	COMPLEX*16, ALLOCATABLE :: ELOCDEG(:,:)
	COMPLEX*16, ALLOCATABLE :: OIMPDEG(:,:)
	COMPLEX*16, ALLOCATABLE :: DHUBDEG(:,:)
	COMPLEX*16, ALLOCATABLE :: VDBCDEG(:,:)
	COMPLEX*16, ALLOCATABLE :: VDBNDEG(:,:)
	COMPLEX*16, ALLOCATABLE :: SIGIDEG(:,:)
	COMPLEX*16, ALLOCATABLE :: SIG0DEG(:,:)
	COMPLEX*16, ALLOCATABLE :: BMASDEG(:,:)
	COMPLEX*16, ALLOCATABLE :: DELIDEG(:,:)
	COMPLEX*16, ALLOCATABLE :: BATHDEG(:,:,:)
	COMPLEX*16, ALLOCATABLE :: DELWDEG(:,:,:)
	COMPLEX*16, ALLOCATABLE :: SIGWDEG(:,:,:)
	COMPLEX*16, ALLOCATABLE :: VRATDEG(:,:,:)
	COMPLEX*16, ALLOCATABLE :: WRATDEG(:,:,:)
	COMPLEX*16, ALLOCATABLE :: PRATDEG(:,:,:)
	COMPLEX*16, ALLOCATABLE :: ORATDEG(:,:,:)
	COMPLEX*16, ALLOCATABLE :: SIGA(:,:,:)
	COMPLEX*16, ALLOCATABLE :: DELSUN(:)
	COMPLEX*16, ALLOCATABLE :: SIGSUN(:)
	COMPLEX*16, ALLOCATABLE :: GFFSUN(:)
	COMPLEX*16, ALLOCATABLE :: WSIGSUN(:)
	COMPLEX*16, ALLOCATABLE :: PSIGSUN(:)
	COMPLEX*16, ALLOCATABLE :: WSIGCRF(:,:,:)
	COMPLEX*16, ALLOCATABLE :: PSIGCRF(:,:,:)
	COMPLEX*16, ALLOCATABLE :: DELCRF(:,:,:)
	COMPLEX*16, ALLOCATABLE :: SIGCRF(:,:,:)
	COMPLEX*16, ALLOCATABLE :: GFFCRF(:,:,:)
	REAL*8 ZAVRSCF(2),ZOCCSCF(2),ZAVRIMP(2),ZOCCIMP(2)
      DATA PI/3.141592653589793D0/,DIM/(0.D0,1.D0)/,EPSDEG/1.D-05/
      CALL ABORTNOW()
C MEMORY ALLOCATIONS
	ALLOCATE(IMPWORK(1))
	IERR=0
	ISORT=IS(IATOM)
	NDIM=2*(2*L+1)
	EFRM=EF
	CHEM=EF
C DO OVER SOLUTIONS OF IMPURITY MODEL
	IREC=0
	ILEN=0
	DO 1000 IRUN=1,NRUNIMP(L,IATOM)
C Count states which participate in this run
	NDEG=0 ! this is degeneracy within this run
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).NE.0)NDEG=NDEG+1
	ENDDO
	IF(NDEG.EQ.0)GOTO 1000
C MEMORY ALLOCATIONS
C Impurity arrays
	ALLOCATE(EIMPDEG(NDEG,NDEG))
	ALLOCATE(ELOCDEG(NDEG,NDEG))
	ALLOCATE(OIMPDEG(NDEG,NDEG))
	ALLOCATE(DHUBDEG(NDEG,NDEG))
	ALLOCATE(VDBCDEG(NDEG,NDEG))
	ALLOCATE(VDBNDEG(NDEG,NDEG))
	ALLOCATE(SIGIDEG(NDEG,NDEG))
	ALLOCATE(SIG0DEG(NDEG,NDEG))
	ALLOCATE(DELIDEG(NDEG,NDEG))
	ALLOCATE(BMASDEG(NDEG,NDEG))
	ALLOCATE(SIGWDEG(0:NMSCMEM+1,NDEG,NDEG))
	ALLOCATE(DELWDEG(0:NMSCMEM+1,NDEG,NDEG))
	ALLOCATE(BATHDEG(0:NMSCMEM+1,NDEG,NDEG))
	ALLOCATE(VRATDEG(NDEG,NDEG,NPOLMEM))
	ALLOCATE(WRATDEG(NDEG,NDEG,NPOLMEM))
	ALLOCATE(PRATDEG(NDEG,NDEG,NPOLMEM))
	ALLOCATE(ORATDEG(NDEG,NDEG,NPOLMEM))
	ALLOCATE(COMB(0:NDEG,0:NDEG))
C COMBINATORICS
	CALL LIB_GETCOMB(COMB,NDEG)
C ****************************************************
C REALLOCATE INPUT ARRAYS WITHIN CURRENT DEGENERACY
	IDEG1=0
	DO IDIM1=1,NDIM
	IF(KSTATES(IDIM1,IRUN,L,IATOM).EQ.0)CYCLE
	IDEG1=IDEG1+1
	IDEG=0
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.0)CYCLE
	IDEG=IDEG+1
C Impurity levels, self-energy limits
	EIMPDEG(IDEG1,IDEG)=EIMPMAT(IDIM1,IDIM)
	ELOCDEG(IDEG1,IDEG)=ELOCMAT(IDIM1,IDIM)
	OIMPDEG(IDEG1,IDEG)=OIMPMAT(IDIM1,IDIM)
	DHUBDEG(IDEG1,IDEG)=DHUBMAT(IDIM1,IDIM)
	SIGIDEG(IDEG1,IDEG)=SIGIMAT(IDIM1,IDIM)
	VDBCDEG(IDEG1,IDEG)=VDBCMAT(IDIM1,IDIM)
	SIG0DEG(IDEG1,IDEG)=SIG0MAT(IDIM1,IDIM)
	DELIDEG(IDEG1,IDEG)=DELIMAT(IDIM1,IDIM)
	BMASDEG(IDEG1,IDEG)=BMASMAT(IDIM1,IDIM)
C Self-energy, bath and hybridization
	DO IMSC=0,NMSC
	SIGWDEG(IMSC,IDEG1,IDEG)=SIGWMAT(IMSC,IDIM1,IDIM)
	DELWDEG(IMSC,IDEG1,IDEG)=DELWMAT(IMSC,IDIM1,IDIM)
	BATHDEG(IMSC,IDEG1,IDEG)=BATHMAT(IMSC,IDIM1,IDIM)
	ENDDO
	ENDDO
	ENDDO
C QUARTER OF BANDWIDTH
	TPAR=OBND/4.D0
C *************************************************************
C SU(N) SOLUTION OF IMPURITY MODEL USING RATIONAL APPROXIMATION
C *************************************************************
	IF(MOD(KSOLVER(L,IATOM),10).EQ.1)THEN
C Allocate SU(N) arrays
	ALLOCATE(XHUBSUN(0:NDEG))
	ALLOCATE(YHUBSUN(0:NDEG))
	ALLOCATE(PSIKSUN(0:NDEG))
	ALLOCATE(IFIXSUN(0:NDEG))
	ALLOCATE(EATSSUN(0:NDEG))
	ALLOCATE(WSIGSUN(NDEG))
	ALLOCATE(PSIGSUN(NDEG))
	ALLOCATE(DELSUN(0:NMSCMEM+1))
	ALLOCATE(GFFSUN(0:NMSCMEM+1))
	ALLOCATE(SIGSUN(0:NMSCMEM+1))
C Additional control data
	KFIX=0 ! by default do not fix proabilities
	KRES=0 ! by default do not reset mass renormalizations
	MSPIN=1
	ELOCSUN=0.D0
	ZMASSUN=0.D0
	RMASSUN=1.D0
	DO IDEG=0,NDEG
	XHUBSUN(IDEG)=0.D0
	PSIKSUN(IDEG)=0.D0
	IFIXSUN(IDEG)=0
	ENDDO
	IF(IMPINFO(L,IATOM).EQ.0)GOTO 200
C Read controls
	IREC=IREC+1
	IF(IREC.GT.IMPINFO(L,IATOM))GOTO 100
	READ(IMPDATA(IREC,L,IATOM),*,END=100,ERR=100)
     &IRUNR,KFIX        ! run,probabilities
	IF(IRUNR.NE.IRUN)CALL FULLSTOP('Error reading imp.data: IRUN')
C Read set-up
	IREC=IREC+1
	IF(IREC.GT.IMPINFO(L,IATOM))GOTO 100
	READ(IMPDATA(IREC,L,IATOM),*,END=100,ERR=100)
     &NDEGR,NREPR,NCNFR,NCN0R       ! run,degeneracy, representations, configurations
	IF(NDEGR.NE.NDEG)CALL FULLSTOP('Error reading imp.data: NDEG')
	IF(NREPR.NE.1   )CALL FULLSTOP('Error reading imp.data: NREP')
	IF(NCNFR.NE.NDEG+1.AND.NCNFR.NE.0)
     &                 CALL FULLSTOP('Error reading imp.data: NCNF')
	IF(NCN0R.NE.1   )CALL FULLSTOP('Error reading imp.data:NCNF0')
C Read local impurity levels
	IREC=IREC+1
	IF(IREC.GT.IMPINFO(L,IATOM))GOTO 100
	READ(IMPDATA(IREC,L,IATOM),*,END=100,ERR=100)
     &LREPR,ISPINR,EINPSUN,ZMASSUN,RMASSUN,SIG0SUN  ! subdegeneracy, impurity level
	IF(LREPR.NE.NDEG)CALL FULLSTOP('Error reading imp.data:LREPR')
	IF(ISPINR.NE.1)CALL FULLSTOP('Error reading imp.data:ISPINR')
C Read Probabilities
	DO ICNF=1,NCNFR
	IF(ICNF.EQ.1)IREC=IREC+1      ! skip comment
	IREC=IREC+1
	IF(IREC.GT.IMPINFO(L,IATOM))GOTO 100
	READ(IMPDATA(IREC,L,IATOM),*,END=100,ERR=100)
     &IFIX,PHUB                     ! probability in SBMF within SU(N)
	IFIXSUN(ICNF-1)=IFIX
	XHUBSUN(ICNF-1)=PHUB/COMB(ICNF-1,NDEG)
	PSIKSUN(ICNF-1)=SQRT(ABS(XHUBSUN(ICNF-1)))
	ENDDO
	GOTO 200
  100	CONTINUE
	CALL FULLSTOP('Error reading imp.data: Not enough data.')
  200 CONTINUE
C Average hybridization
	DO IMSC=0,NMSC
	DELSUN(IMSC)=(0.D0,0.D0)
	DO IDEG=1,NDEG
	DELSUN(IMSC)=DELSUN(IMSC)+DELWDEG(IMSC,IDEG,IDEG)-
     &                          DELIDEG(     IDEG,IDEG)
	ENDDO
	DELSUN(IMSC)=DELSUN(IMSC)/DBLE(NDEG)
	ENDDO
C New average charge
	ZAVRSCF(1)=0.D0
	DO IDEG=1,NDEG
	ZAVRSCF(1)=ZAVRSCF(1)+DHUBDEG(IDEG,IDEG)
	ENDDO
	ZOCCSCF(1)=ZAVRSCF(1)
C New atomic charges
	ZATMSUN=ZAVRSCF(1)/DBLE(NDEG)
C Fixed mass renormalization
	KRESSUN=KRES
	ZRESSUN=ZMASSUN*RMASSUN
C Fixed probabilities
	KFIXSUN=KFIX
	IF(KFIXSUN.EQ.0)THEN
	DO IDEG=0,NDEG
	XHUBSUN(IDEG)=0.D0
	PSIKSUN(IDEG)=0.D0
	ENDDO
	ENDIF
C A new guess for the double counting which replaces the Hartree shift
	DO IDEG=1,NDEG
	ISPINM=1
	ISPIN =1
C New double counting is the old one
	VDBNDEG(IDEG,IDEG)=VDBCDEG(IDEG,IDEG)
C Unless it can be guessed immidiately in some cases
	IF(KDBLCNT(L,IATOM).EQ.11)
     &VDBNDEG(IDEG,IDEG)=UPAR*ZOCCSCF(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZOCCSCF(ISPIN)/2.D0*DBLE(MSPIN)-(UPAR-GPAR)*
     &CDBLCNT(L,IATOM)
	IF(KDBLCNT(L,IATOM).EQ.12)
     &VDBNDEG(IDEG,IDEG)=UPAR*ZAVRSCF(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZAVRSCF(ISPIN)/2.D0*DBLE(MSPIN)-(UPAR-GPAR)*
     &CDBLCNT(L,IATOM)
	IF(KDBLCNT(L,IATOM).EQ.21)
     &VDBNDEG(IDEG,IDEG)=UPAR*ZOCCSCF(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZOCCSCF(ISPIN)/2.D0*DBLE(MSPIN)-(UPAR-GPAR)*
     &ZOCCSCF(ISPIN)/2.D0*DBLE(MSPIN)/(DBLE(NDEG)/2.D0)
	IF(KDBLCNT(L,IATOM).EQ.22)
     &VDBNDEG(IDEG,IDEG)=UPAR*ZAVRSCF(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZAVRSCF(ISPIN)/2.D0*DBLE(MSPIN)-(UPAR-GPAR)*
     &ZAVRSCF(ISPIN)/2.D0*DBLE(MSPIN)/(DBLE(NDEG)/2.D0)
	ENDDO
C ***********************************************************************
C Set ELOCs
	IF(KIMPLEV(L,IATOM)/10.EQ.1.OR.KIMPLEV(L,IATOM)/10.EQ.2)THEN
	ELOCSUN=0.D0 ! Bare position
	DO IDEG=1,NDEG
C Eloc is Elda-Vdc but due to overlap, the expression is more complicated
C Notice that Eimp=o(Elda-Vdc+SigI)o
C Notice that we plug-in new double counting here
	IF(KIMPLEV(L,IATOM)/10.EQ.1)
     &ELOCSUN=ELOCSUN+EIMPDEG(IDEG,IDEG)-VDBNDEG(IDEG,IDEG)-EFRM-
     &(SIGIDEG(IDEG,IDEG)-VDBCDEG(IDEG,IDEG))
C Eloc can be just -U(n-1/2) if Elda=Ef or if valence needs to be fixed
      IF(KIMPLEV(L,IATOM)/10.EQ.2)
     &ELOCSUN=ELOCSUN-VDBNDEG(IDEG,IDEG)
	ENDDO
	ELOCSUN=ELOCSUN/DBLE(NDEG)
C Eloc is given by input
	ELSEIF(KIMPLEV(L,IATOM)/10.EQ.3)THEN
	IF(IMPINFO(L,IATOM).EQ.0)CALL FULLSTOP('Eloc not set')
	ELOCSUN=EINPSUN
	ENDIF
C ***********************************************
C Set Mean Field (LDA) poistion of impurity level
	ELDASUN=0.D0
	DO IDEG=1,NDEG
	ELDASUN=ELDASUN+EIMPDEG(IDEG,IDEG)-
     &(SIGIDEG(IDEG,IDEG)-VDBCDEG(IDEG,IDEG))
	ENDDO
	ELDASUN=ELDASUN/DBLE(NDEG)
C *********************************************************************
C SU(N) SOLUTION OF IMPURITY MODEL USING ATOMIC SELF-ENERGY (HUBBARD I)
      CALL IMP_SUNHUB1_STAT(NDEG,EATSSUN,TPAR,UPAR,ELOCSUN,DELSUN(0)
     &  ,GFFSUN(0),SIGSUN(0),XHUBSUN(0),YHUBSUN(0),IFIXSUN(0),SIGISUN
     &  ,VRATSUN,WRATSUN,POLESUN,OVRLSUN,ZSUMSUN,ZHUBSUN,KFIXSUN
     &  ,TEMP,NMSC,WMSC,FMSC,0.000D0,IERR)
      ZAVRIMP(1)=ZHUBSUN
      ZOCCIMP(1)=ZHUBSUN
C SELF-ENERGY AT INFINITY CAN BE SET ACCORDING TO THE CURRENT OCCUPANCIES
      SIGA1=UPAR*ZOCCSCF(1)-UPAR*ZOCCSCF(1)/DBLE(NDEG) ! lda occupations
      SIGA2=UPAR*ZOCCIMP(1)-UPAR*ZOCCIMP(1)/DBLE(NDEG)   ! atomic integer occupations
      SIGA3=DREAL(SIGSUN(NMSC))
      SIGA4=SIGISUN
C RESET SELF-ENERGY AT INFINITY: 
	DO IMSC=0,NMSC                  ! over frequencies
	IF(KSIGMOO(L,IATOM).EQ.11.OR.KSIGMOO(L,IATOM).EQ.21)
     &SIGSUN(IMSC)=SIGSUN(IMSC)-SIGISUN+SIGA1
	IF(KSIGMOO(L,IATOM).EQ.12.OR.KSIGMOO(L,IATOM).EQ.22)
     &SIGSUN(IMSC)=SIGSUN(IMSC)-SIGISUN+SIGA2
	IF(KSIGMOO(L,IATOM).EQ.31)
     &SIGSUN(IMSC)=SIGSUN(IMSC)-SIGISUN+SIGA3
	IF(KSIGMOO(L,IATOM).EQ.41)
     &SIGSUN(IMSC)=SIGSUN(IMSC)-SIGISUN+SIGA4
      ENDDO                           ! over frequencies
	IF(KSIGMOO(L,IATOM).EQ.11.OR.KSIGMOO(L,IATOM).EQ.21)SIGISUN=SIGA1
	IF(KSIGMOO(L,IATOM).EQ.12.OR.KSIGMOO(L,IATOM).EQ.22)SIGISUN=SIGA2
	IF(KSIGMOO(L,IATOM).EQ.31)SIGISUN=SIGA3
	IF(KSIGMOO(L,IATOM).EQ.41)SIGISUN=SIGA4
C *******************************************
C SU(N) SOLUTION OF IMPURITY MODEL USING SBMF
      IF(KGRD.EQ.2.AND.KRESSUN.EQ.0)THEN
	CALL IMP_SUNSBMF_HEAD(NDEG,EATSSUN,TPAR,UPAR
     &  ,ELOCSUN,DELSUN(0),GFFSUN(0),SIGSUN(0),PSIKSUN(0),IFIXSUN(0)
     &  ,ZMASSUN,ZSUMSUN,ZPSISUN,KFIXSUN 
     &  ,TEMP,NMSC,WMSC,FMSC,0.000D0,IERR)
C Set Sigma0
	SIG0SUN=DREAL(SIGSUN(0))
	ZRESSUN=ZMASSUN*RMASSUN ! renormalize mass if requested
C *******************************************
C FIND SIGMA(0) FROM FIXED MASS RENORMALIZATIONS
      ELSEIF(KGRD.EQ.2.AND.KRESSUN.EQ.1.AND.
     &        ABS(ZRESSUN).GT.1.D-10)THEN
	JTER=0
	E1=-TPAR
	E2=+TPAR
	CALL LIB_FINDROOT(ELAM,ZDIF,E1,E2,JTER,IEXIT,IUN,1.D-05,50)
      DO JTER=1,10**5
C Find new Greens function
	DO IMSC=0,NMSC
	ZMSC=WMSC(IMSC)
	GFFSUN(IMSC)=1.D0/(ZMSC-ELAM-ZRESSUN*DELSUN(IMSC))
	ENDDO
C Find new charge
	ZIMP=0.D0
	DO IMSC=0,NMSC
      ZIMP=ZIMP+2.D0*TEMP*
     &DREAL(GFFSUN(IMSC)-1.D0/(WMSC(IMSC)-ELAM))*FMSC(IMSC)
	ENDDO
	ZIMP=ZIMP+FERMIFUN(ELAM,TEMP)
	ZDIF=ZATMSUN-ZIMP
	CALL LIB_FINDROOT(ELAM,ZDIF,E1,E2,JTER,IEXIT,IUN,1.D-05,50)
	IF(IEXIT.EQ.1)EXIT
      ENDDO	
      SIG0SUN=ELAM/ZRESSUN-ELOCSUN
      ENDIF
C Find rational interpolation
	IF(ABS(ZRESSUN).LE.1.D-05.OR.KRESSUN.EQ.1)THEN
	DO IDEG=0,NDEG
	PSIKSUN(IDEG)=SQRT(ABS(XHUBSUN(IDEG)))
	ENDDO
	ENDIF
	CALL IMP_SUNIRAT_COFS(NDEG,ELOCSUN,UPAR,ZOCCSUN,TPAR,COMB,
     &     SIG0SUN,SIGISUN,ZRESSUN,PSIKSUN,MRATSUN,WSIGSUN,
     &     PSIGSUN,0,IERR)
C RATIONAL INTERPOLATION IN SUN CASE
	DO IMSC=0,NMSC
	ZMSC=WMSC(IMSC)
	SIGSUN(IMSC)=SIGISUN
	DO IRAT=1,MRATSUN
	SIGSUN(IMSC)=SIGSUN(IMSC)+WSIGSUN(IRAT)/(ZMSC-PSIGSUN(IRAT))
	ENDDO
	ENDDO
C Reconstruct Green function
	DO IMSC=0,NMSC
	ZMSC=WMSC(IMSC)
	GFFSUN(IMSC)=1.D0/(ZMSC-ELOCSUN-DELSUN(IMSC)-SIGSUN(IMSC))
	ENDDO
      ZAVRIMP(1)=ZHUBSUN
      ZOCCIMP(1)=ZHUBSUN
C SELF-ENERGY AT INFINITY CAN BE SET ACCORDING TO THE CURRENT OCCUPANCIES
      SIGA1=UPAR*ZOCCSCF(1)-UPAR*ZOCCSCF(1)/DBLE(NDEG)   ! lda occupations
      SIGA2=UPAR*ZOCCIMP(1)-UPAR*ZOCCIMP(1)/DBLE(NDEG)   ! atomic integer occupations
      SIGA3=DREAL(SIGSUN(NMSC))
      SIGA4=SIGISUN
C RESET SELF-ENERGY AT INFINITY: 
	DO IMSC=0,NMSC                  ! over frequencies
	IF(KSIGMOO(L,IATOM).EQ.11.OR.KSIGMOO(L,IATOM).EQ.21)
     &SIGSUN(IMSC)=SIGSUN(IMSC)-SIGISUN+SIGA1
	IF(KSIGMOO(L,IATOM).EQ.12.OR.KSIGMOO(L,IATOM).EQ.22)
     &SIGSUN(IMSC)=SIGSUN(IMSC)-SIGISUN+SIGA2
	IF(KSIGMOO(L,IATOM).EQ.31)
     &SIGSUN(IMSC)=SIGSUN(IMSC)-SIGISUN+SIGA3
	IF(KSIGMOO(L,IATOM).EQ.41)
     &SIGSUN(IMSC)=SIGSUN(IMSC)-SIGISUN+SIGA4
      ENDDO                           ! over frequencies
	IF(KSIGMOO(L,IATOM).EQ.11.OR.KSIGMOO(L,IATOM).EQ.21)SIGISUN=SIGA1
	IF(KSIGMOO(L,IATOM).EQ.12.OR.KSIGMOO(L,IATOM).EQ.22)SIGISUN=SIGA2
	IF(KSIGMOO(L,IATOM).EQ.31)SIGISUN=SIGA3
	IF(KSIGMOO(L,IATOM).EQ.41)SIGISUN=SIGA4
C SET OUTPUT ARRAYS
	IDEG1=0
	DO IDIM1=1,NDIM
	IF(KSTATES(IDIM1,IRUN,L,IATOM).EQ.0)CYCLE
	IDEG1=IDEG1+1
	IDEG=0
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.0)CYCLE
	IDEG=IDEG+1
C Set self-energy
	DO IMSC=0,NMSC
	ZMSC=WMSC(IMSC)
	IF(IDEG1.EQ.IDEG.AND.IDMF.EQ.3)
     &SIGWDEG(IMSC,IDEG1,IDEG)=SIGSUN(IMSC)
	IF(IDEG1.EQ.IDEG.AND.IDMF.EQ.4)THEN
	SIGWDEG(IMSC,IDEG1,IDEG)=SIGISUN
	DO IPOL=1,MIN(NPOLIMP(L,IATOM),MRATSUN)
      SIGWDEG(IMSC,IDEG1,IDEG)=SIGWDEG(IMSC,IDEG1,IDEG)+
     &WSIGSUN(IPOL)/(ZMSC*OVRLSUN-PSIGSUN(IPOL))
	ENDDO
	ENDIF
	IF(IDEG1.EQ.IDEG.AND.IDMF.EQ.5)
     &SIGWDEG(IMSC,IDEG1,IDEG)=SIGSUN(IMSC)
	IF(IDEG1.NE.IDEG)
     &SIGWDEG(IMSC,IDEG1,IDEG)=(0.D0,0.D0)
	ENDDO
C Set self-energy at infinity
	IF(IDEG1.EQ.IDEG)
     &SIGIDEG(IDEG1,IDEG)=DCMPLX(SIGISUN,0.D0)
	IF(IDEG1.NE.IDEG)
     &SIGIDEG(IDEG1,IDEG)=(0.D0,0.D0)
C Set self-energy at zero
	IF(IDEG1.EQ.IDEG.AND.IDMF.EQ.3)
     &SIG0DEG(IDEG1,IDEG)=DREAL(SIGSUN(0))
	IF(IDEG1.EQ.IDEG.AND.IDMF.EQ.4)
     &SIG0DEG(IDEG1,IDEG)=DREAL(SIGSUN(0))
	IF(IDEG1.EQ.IDEG.AND.IDMF.EQ.5)      !!! do not reset !!!
     &SIG0DEG(IDEG1,IDEG)=SIG0DEG(IDEG1,IDEG)
	IF(IDEG1.NE.IDEG)
     &SIG0DEG(IDEG1,IDEG)=(0.D0,0.D0)
C Set mass renormlization
	IF(IDEG1.EQ.IDEG)
     &BMASDEG(IDEG1,IDEG)=SQRT(ZMASSUN)
	IF(IDEG1.NE.IDEG)
     &BMASDEG(IDEG1,IDEG)=(0.D0,0.D0)
C Set bare impurity levels
	IF(IDEG1.EQ.IDEG)
     &ELOCDEG(IDEG1,IDEG)=ELOCSUN
	IF(IDEG1.NE.IDEG)
     &ELOCDEG(IDEG1,IDEG)=(0.D0,0.D0)
C Set rational interpolation coefficients
	DO IPOL=1,NPOLIMP(L,IATOM)
	VRATDEG(IDEG1,IDEG,IPOL)=(0.D0,0.D0)
	WRATDEG(IDEG1,IDEG,IPOL)=(0.D0,0.D0)
	PRATDEG(IDEG1,IDEG,IPOL)=(0.D0,0.D0)
	ORATDEG(IDEG1,IDEG,IPOL)=(0.D0,0.D0)
	IF(IDEG1.EQ.IDEG.AND.IPOL.LE.MRATSUN)THEN
	VRATDEG(IDEG1,IDEG,IPOL)=SQRT(WSIGSUN(IPOL))
	WRATDEG(IDEG1,IDEG,IPOL)=SQRT(WSIGSUN(IPOL))
	PRATDEG(IDEG1,IDEG,IPOL)=PSIGSUN(IPOL)
C    &                +EFRM*DCMPLX(OVRLSUN,0.D0)
	ORATDEG(IDEG1,IDEG,IPOL)=DCMPLX(OVRLSUN,0.D0)
	ENDIF
	IF(IDEG1.EQ.IDEG.AND.IPOL.GT.MRATSUN)THEN
	PRATDEG(IDEG1,IDEG,IPOL)=DCMPLX(+1.D0,0.D0)
	ORATDEG(IDEG1,IDEG,IPOL)=DCMPLX(+1.D0,0.D0)
	ENDIF
	ENDDO
C Set double counting potential
      ISPIN =1
      ISPINM=1
C 00  Keep this array untouched
	IF(KDBLCNT(L,IATOM).EQ.0)
     &VDBCDEG(IDEG1,IDEG)=VDBCDEG(IDEG1,IDEG)
C 11. Fully localized spin polarized limit with Nscf
	IF(KDBLCNT(L,IATOM).EQ.11.AND.IDEG1.EQ.IDEG)
     &VDBCDEG(IDEG1,IDEG)=UPAR*ZOCCSCF(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZOCCSCF(ISPIN)/2.D0*DBLE(MSPIN)-(UPAR-GPAR)*
     &CDBLCNT(L,IATOM)
	IF(KDBLCNT(L,IATOM).EQ.11.AND.IDEG1.NE.IDEG)
     &VDBCDEG(IDEG1,IDEG)=(0.D0,0.D0)
C 12. Fully localized spin restricted limit with Nscf
	IF(KDBLCNT(L,IATOM).EQ.12.AND.IDEG1.EQ.IDEG)
     &VDBCDEG(IDEG1,IDEG)=UPAR*ZAVRSCF(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZAVRSCF(ISPIN)/2.D0*DBLE(MSPIN)-(UPAR-GPAR)*
     &CDBLCNT(L,IATOM)
	IF(KDBLCNT(L,IATOM).EQ.12.AND.IDEG1.NE.IDEG)
     &VDBCDEG(IDEG1,IDEG)=(0.D0,0.D0)
C 13. Fully localized spin polarized limit with Nimp
	IF(KDBLCNT(L,IATOM).EQ.13.AND.IDEG1.EQ.IDEG)
     &VDBCDEG(IDEG1,IDEG)=UPAR*ZOCCIMP(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZOCCIMP(ISPIN)/2.D0*DBLE(MSPIN)-(UPAR-GPAR)*
     &CDBLCNT(L,IATOM)
	IF(KDBLCNT(L,IATOM).EQ.13.AND.IDEG1.NE.IDEG)
     &VDBCDEG(IDEG1,IDEG)=(0.D0,0.D0)
C 14. Fully localized spin restricted limit with Nimp
	IF(KDBLCNT(L,IATOM).EQ.14.AND.IDEG1.EQ.IDEG)
     &VDBCDEG(IDEG1,IDEG)=UPAR*ZAVRIMP(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZAVRIMP(ISPIN)/2.D0*DBLE(MSPIN)-(UPAR-GPAR)*
     &CDBLCNT(L,IATOM)
	IF(KDBLCNT(L,IATOM).EQ.14.AND.IDEG1.NE.IDEG)
     &VDBCDEG(IDEG1,IDEG)=(0.D0,0.D0)
C 21. Analitical spin polarized limit of Sigma(inf) with Nscf
	IF(KDBLCNT(L,IATOM).EQ.21.AND.IDEG1.EQ.IDEG)
     &VDBCDEG(IDEG,IDEG)=UPAR*ZOCCSCF(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZOCCSCF(ISPIN)/2.D0*DBLE(MSPIN)-(UPAR-GPAR)*
     &ZOCCSCF(ISPIN)/2.D0*DBLE(MSPIN)/(DBLE(NDEG)/2.D0)
	IF(KDBLCNT(L,IATOM).EQ.21.AND.IDEG1.NE.IDEG)
     &VDBCDEG(IDEG1,IDEG)=(0.D0,0.D0)
C 22. Analitical spin restricted limit of Sigma(inf) with Nscf
	IF(KDBLCNT(L,IATOM).EQ.22.AND.IDEG1.EQ.IDEG)
     &VDBCDEG(IDEG,IDEG)=UPAR*ZAVRSCF(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZAVRSCF(ISPIN)/2.D0*DBLE(MSPIN)-(UPAR-GPAR)*
     &ZAVRSCF(ISPIN)/2.D0*DBLE(MSPIN)/(DBLE(NDEG)/2.D0)
	IF(KDBLCNT(L,IATOM).EQ.22.AND.IDEG1.NE.IDEG)
     &VDBCDEG(IDEG1,IDEG)=(0.D0,0.D0)
C 23. Analitical spin polarized limit of Sigma(inf) with Nimp
	IF(KDBLCNT(L,IATOM).EQ.23.AND.IDEG1.EQ.IDEG)
     &VDBCDEG(IDEG,IDEG)=UPAR*ZOCCIMP(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZOCCIMP(ISPIN)/2.D0*DBLE(MSPIN)-(UPAR-GPAR)*
     &ZOCCIMP(ISPIN)/2.D0*DBLE(MSPIN)/(DBLE(NDEG)/2.D0)
	IF(KDBLCNT(L,IATOM).EQ.23.AND.IDEG1.NE.IDEG)
     &VDBCDEG(IDEG1,IDEG)=(0.D0,0.D0)
C 24. Analitical spin restricted limit of Sigma(inf) with Nimp
	IF(KDBLCNT(L,IATOM).EQ.24.AND.IDEG1.EQ.IDEG)
     &VDBCDEG(IDEG,IDEG)=UPAR*ZAVRIMP(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZAVRIMP(ISPIN)/2.D0*DBLE(MSPIN)-(UPAR-GPAR)*
     &ZAVRIMP(ISPIN)/2.D0*DBLE(MSPIN)/(DBLE(NDEG)/2.D0)
	IF(KDBLCNT(L,IATOM).EQ.24.AND.IDEG1.NE.IDEG)
     &VDBCDEG(IDEG1,IDEG)=(0.D0,0.D0)
C 30. Fixed double counting
	IF(KDBLCNT(L,IATOM).EQ.30)
     &VDBCDEG(IDEG1,IDEG)=VDBCDEG(IDEG1,IDEG)
C 40. Double counting according to Eloc
	IF(KDBLCNT(L,IATOM).EQ.40.AND.IDEG1.EQ.IDEG)
     &VDBCDEG(IDEG1,IDEG)=ELDASUN-EFRM-ELOCSUN
	IF(KDBLCNT(L,IATOM).EQ.40.AND.IDEG1.NE.IDEG)
     &VDBCDEG(IDEG1,IDEG)=(0.D0,0.D0)
C 50. Sigma(0)
	IF(KDBLCNT(L,IATOM).EQ.50)
     &VDBCDEG(IDEG1,IDEG)=SIG0DEG(IDEG1,IDEG)
C 60. Sigma(inf)
	IF(KDBLCNT(L,IATOM).EQ.60)
     &VDBCDEG(IDEG1,IDEG)=SIGIDEG(IDEG1,IDEG)
	ENDDO
	ENDDO
C UPGRADE IMPURITY INFORMATION IF REQUESTED
	IF(IMPSECT(L,IATOM).EQ.2)THEN
	LOLD=ILEN
	LNEW=LOLD+4+(1+NDEG)
	CALL IMP_IMPIRAT_REFILE(LOLD,LNEW)
	ILEN=ILEN+1
	WRITE(IMPWORK(ILEN),10100)IRUN,KFIX
	ILEN=ILEN+1
	WRITE(IMPWORK(ILEN),10110)NDEG,NREP,NCNF,NCNF0
	ILEN=ILEN+1
	TCTRL=LIB_TDP(ELOCSUN,1.D-10)
	TCTRM=LIB_TDP(ZMASSUN,1.D-10)
	TCTRR=LIB_TDP(RMASSUN,1.D-10)
	TCTRS=LIB_TDP(SIG0SUN,1.D-10)
	WRITE(IMPWORK(ILEN),10120)NDEG,1,TCTRL,TCTRM,TCTRR,TCTRS
C Store Probabilities
	ILEN=ILEN+1
	WRITE(IMPWORK(ILEN),10130)
	DO IDEG=0,NDEG
	IFIX=IFIXSUN(IDEG)
	TCTRL=LIB_TDP(PSIKSUN(IDEG)**2**COMB(IDEG,NDEG),1.D-10)
	TCTRM=LIB_TDP(EATSSUN(IDEG),1.D-10)
	ILEN=ILEN+1
	WRITE(IMPWORK(ILEN),10140)IFIX,TCTRL,IDEG,TCTRM
	ENDDO
10100	FORMAT(2(1X,I3),' ! iRun,kFix' )
10110	FORMAT(4(1X,I3),' ! nDeg,nRep,nCnf,nCnf0')
10120	FORMAT(1X,I3,1X,I3,1X,A10,1X,A10,1X,A10,1X,A10,
     &                ' ! lRep,iSpin,Eloc,Zmas,Rmas,Sig0')
10130	FORMAT(1X,'f   <Psik^2>   n     <En>')
10140	FORMAT(1X,I1,1X,A10,1X,I3,1X,A10)
	ENDIF
	DEALLOCATE(DELSUN,SIGSUN,GFFSUN,XHUBSUN,YHUBSUN,PSIKSUN)
	DEALLOCATE(WSIGSUN,PSIGSUN,EATSSUN,IFIXSUN)
C *******************************************************
C CRYSTAL FIELD SPIN POLARIZED SOLUTION OF IMPURITY MODEL
C *******************************************************
	ELSEIF(MOD(KSOLVER(L,IATOM),10).EQ.2)THEN
C Count # of representations as non-equivalent elements of KSTATES pointer
	IREP0=0
	IREP1=0
	IREP2=0
	DO IPOS=1,NDIM
	ISUB0=0
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.IPOS)ISUB0=ISUB0+1
	ENDDO
	ISUB1=0
	DO IDIM=1,NDIM/2
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.IPOS)ISUB1=ISUB1+1
	ENDDO
	ISUB2=0
	DO IDIM=NDIM/2+1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.IPOS)ISUB2=ISUB2+1
	ENDDO
	IF(ISUB0.NE.0)IREP0=IREP0+1
	IF(ISUB1.NE.0)IREP1=IREP1+1
	IF(ISUB2.NE.0)IREP2=IREP2+1
	ENDDO
	NREP0=IREP0
	NREP1=IREP1
	NREP2=IREP2
	ALLOCATE(LREP0(NREP0))
	ALLOCATE(LREP1(NREP1))
	ALLOCATE(LREP2(NREP2))
	ALLOCATE(KDREP(NDIM))
	ALLOCATE(KDR00(NDIM))
	ALLOCATE(KDR12(NDIM))
	DO IDIM=1,NDIM
	KDR00(IDIM)=-1
	KDR12(IDIM)=-1
	ENDDO
C Find degeneracies of each sublevel
	IREP0=0
	IREP1=0
	IREP2=0
	DO IPOS=1,NDIM
	ISUB0=0
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.IPOS)ISUB0=ISUB0+1
	ENDDO
	IF(ISUB0.NE.0)THEN
	IREP0=IREP0+1
	LREP0(IREP0)=ISUB0
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.IPOS)KDR00(IDIM)=IREP0
	ENDDO
	ENDIF
	ISUB1=0
	DO IDIM=1,NDIM/2
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.IPOS)ISUB1=ISUB1+1
	ENDDO
	IF(ISUB1.NE.0)THEN
	IREP1=IREP1+1
	LREP1(IREP1)=ISUB1
	DO IDIM=1,NDIM/2
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.IPOS)KDR12(IDIM)=IREP1
	ENDDO
	ENDIF
	ISUB2=0
	DO IDIM=NDIM/2+1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.IPOS)ISUB2=ISUB2+1
	ENDDO
	IF(ISUB2.NE.0)THEN
	IREP2=IREP2+1
	LREP2(IREP2)=ISUB2
	DO IDIM=NDIM/2+1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.IPOS)KDR12(IDIM)=IREP2
	ENDDO
	ENDIF
	ENDDO
C Check full degeneracy
	IDEG=0
	DO IREP0=1,NREP0
	IDEG=IDEG+LREP0(IREP0)
	ENDDO
	IF(IDEG.NE.NDEG)
     &CALL FULLSTOP('Wrong KSTATES pointer for this solver')
	IDEG=0
	DO IREP1=1,NREP1
	IDEG=IDEG+LREP1(IREP1)
	ENDDO
	DO IREP2=1,NREP2
	IDEG=IDEG+LREP2(IREP2)
	ENDDO
	IF(IDEG.NE.NDEG)
     &CALL FULLSTOP('Wrong KSTATES pointer for this solver')
C Check if spin polarization is allowed
	IF(NREP1.EQ.NREP2)MSPIN=NSPIN
	IF(NREP1.NE.NREP2)MSPIN=1      ! switch off spin polarization
	IF(MSPIN.EQ.NSPIN)NREP=(NREP1+NREP2)/2
	IF(MSPIN.NE.NSPIN)NREP=NREP0
	ALLOCATE(LREP(NREP))
	DO IREP=1,NREP
	IF(MSPIN.EQ.NSPIN)
     &LREP(IREP)=(LREP1(IREP)+LREP2(IREP))/MSPIN
	IF(MSPIN.NE.NSPIN)
     &LREP(IREP)=LREP0(IREP)
	ENDDO
	DO IDIM=1,NDIM
	IF(MSPIN.EQ.NSPIN)
     &KDREP(IDIM)=KDR12(IDIM)
	IF(MSPIN.NE.NSPIN)
     &KDREP(IDIM)=KDR00(IDIM)
	ENDDO
C CONFIGURATIONS PER SPIN, Minimum: NDEG/2+1, Maximum 2**(NDEG/2)
	DO ISPIN=1,MSPIN
	NCNF=1
	DO IREP=1,NREP
	NCNF=NCNF*(LREP(IREP)+1)
	ENDDO
	ENDDO
	IF(MSPIN.EQ.1)NCNF0=1
	IF(MSPIN.EQ.2)NCNF0=NCNF
C CONFIGURATIONS, Minimum: NDEG/2+1, Maximum 2**(NDEG/2)
	ALLOCATE(MREP(0:NREP))
	MREP(0)=1
	DO IREP=1,NREP
	MREP(IREP)=MREP(IREP-1)*(LREP(IREP)+1)
	ENDDO
C SORT BY NUMBERS OF ELECTRONS
	ALLOCATE(IPNF(NREP))
	ALLOCATE(IPNF0(NREP))
	ALLOCATE(IPNFP1(NREP))
	ALLOCATE(IPCF(NCNF))
	ALLOCATE(IPRF(NCNF))
	ALLOCATE(LCFG(0:NDEG/MSPIN))
C Looping over total allowed numbers of electrons in all sublevels
	ICFR=0
	DO IDEG=0,NDEG/MSPIN
	LCFG(IDEG)=0
C Configurations are numbered in one way from 1 to NCNF.
C Start looping over them
	DO ICNF=1,NCNF
C Find out numbers of electrons at each sublevel for given configuration ICNF
C Return array is IPNF(IREP) for spin channel
	CALL LIB_GETCONF(NREP,LREP,MREP,ICNF,NCNF,IPNF)
	NELC=0 ! count # of electrons for given configuration
	DO IREP=1,NREP
	NELC=NELC+IPNF(IREP)
	ENDDO
C if this configuration contains right number of electrons, count it
	IF(NELC.NE.IDEG)CYCLE 
	LCFG(IDEG)=LCFG(IDEG)+1
	ICFR=ICFR+1
C this pointer relates second-to-first numbering schemes for configurations
	IPCF(ICFR)=ICNF 
	ENDDO
	ENDDO
C CHECK ALGORITHM
	ICFR=0 ! second way of numbering configurations
C looping over allowed total numbers of electrons of the same spin
	DO IDEG=0,NDEG/MSPIN
C looping over configurations within given number of electrons of the same spin
	DO ICFG=1,LCFG(IDEG) 
	ICFR=ICFR+1
	ICNF=IPCF(ICFR) ! find out the configuration in first numbering scheme
C Find out array showing how many electrons are in each sublevel
	CALL LIB_GETCONF(NREP,LREP,MREP,ICNF,NCNF,IPNF) 
	NELC=0 ! count # of electrons
	DO IREP=1,NREP
	IF(IPNF(IREP).LT.0.OR.IPNF(IREP).GT.LREP(IREP))
     &CALL FULLSTOP('Wrong configuration')
	NELC=NELC+IPNF(IREP)
	ENDDO
	ENDDO
	IF(NELC.NE.IDEG)CALL FULLSTOP('# of electrons mismatch')
	ENDDO
C Set reciprocal pointer which related first-to-second numbering scheme for configirations
	DO ICNF=1,NCNF 
	IPRF(ICNF)=-1
	ENDDO
	DO ICFR=1,NCNF
	ICNF=IPCF(ICFR)
	IPRF(ICNF)=ICFR
	ENDDO
	DO ICNF=1,NCNF
	IF(IPRF(ICNF).EQ.-1)CALL FULLSTOP('Wrong reciprocal pointer')
	ENDDO
C Compute product of all combinatorics using second scheme of 
C numbering configurations
	ALLOCATE(COMR(NCNF))
	ICFR=0
	DO IDEG=0,NDEG/MSPIN
	DO ICFG=1,LCFG(IDEG)
	ICFR=ICFR+1
	ICNF=IPCF(ICFR)
	CALL LIB_GETCONF(NREP,LREP,MREP,ICNF,NCNF,IPNF)
	COMR(ICFR)=1.D0 
	DO IREP=1,NREP
	COMR(ICFR)=COMR(ICFR)*COMB(IPNF(IREP),LREP(IREP))
	ENDDO
	ENDDO
	ENDDO
C CHECK COMBINATORICS
	SUS=0.D0
	ICFR=0
	DO IDEG=0,NDEG/MSPIN
	SUM=0.D0
	DO ICFG=1,LCFG(IDEG)
	ICFR=ICFR+1
	SUM=SUM+COMR(ICFR)
	SUS=SUS+COMR(ICFR)
	ENDDO
	IF(ABS(SUM-COMB(IDEG,NDEG/MSPIN)).GT.1.D-07)
     &CALL FULLSTOP('Combinatorics mismatch')
	ENDDO
	IF(ABS(SUS-2.D0**(NDEG/MSPIN)).GT.1.D-07)
     &CALL FULLSTOP('Combinatorics mismatch')
C *******************************************
C Memory allocations for crystal field arrays
	ALLOCATE(IFIXCRF(NCNF,NCNF0))
	ALLOCATE(XHUBCRF(NCNF,NCNF0))
	ALLOCATE(YHUBCRF(NCNF,NCNF0))
	ALLOCATE(PSIKCRF(NCNF,NCNF0))
	ALLOCATE(EATSCRF(NCNF,NCNF0))
	ALLOCATE(WSIGCRF(NDEG*NDEG,NREP,MSPIN))
	ALLOCATE(PSIGCRF(NDEG*NDEG,NREP,MSPIN))
	ALLOCATE(ELOCCRF(NREP,MSPIN))
	ALLOCATE(ELDACRF(NREP,MSPIN))
	ALLOCATE(EINPCRF(NREP,MSPIN))
	ALLOCATE(DELVCRF(NREP,MSPIN))
	ALLOCATE(DELBCRF(NREP,MSPIN))
	ALLOCATE(SIGICRF(NREP,MSPIN))
	ALLOCATE(SIG0CRF(NREP,MSPIN))
	ALLOCATE(ZMASCRF(NREP,MSPIN))
	ALLOCATE(ZRESCRF(NREP,MSPIN))
	ALLOCATE(RMASCRF(NREP,MSPIN))
	ALLOCATE(VRATCRF(NREP,MSPIN))
	ALLOCATE(WRATCRF(NREP,MSPIN))
	ALLOCATE(POLECRF(NREP,MSPIN))
	ALLOCATE(OVRLCRF(NREP,MSPIN))
	ALLOCATE(ZIMPCRF(NREP,MSPIN))
	ALLOCATE(ZREPCRF(NREP,MSPIN))
	ALLOCATE(ZATMCRF(NREP,MSPIN))
	ALLOCATE(DELCRF(0:NMSCMEM+1,NREP,MSPIN))
	ALLOCATE(GFFCRF(0:NMSCMEM+1,NREP,MSPIN))
	ALLOCATE(SIGCRF(0:NMSCMEM+1,NREP,MSPIN))
C Additional control data
	KFIX=0 ! by default do not fix proabilities
	KRES=0 ! by default do not reset mass renormalizations
	DO ISPIN=1,MSPIN
	DO IREP=1,NREP
	ELOCCRF(IREP,ISPIN)=0.D0
	ZMASCRF(IREP,ISPIN)=0.D0
	RMASCRF(IREP,ISPIN)=1.D0
	ENDDO
	ENDDO
	DO ICNF=1,NCNF
	DO ICNF0=1,NCNF0
	PSIKCRF(ICNF,ICNF0)=0.D0
	XHUBCRF(ICNF,ICNF0)=0.D0
	IFIXCRF(ICNF,ICNF0)=0
	ENDDO
	ENDDO
	IF(IMPINFO(L,IATOM).EQ.0)GOTO 400
C Read controls
	IREC=IREC+1
	IF(IREC.GT.IMPINFO(L,IATOM))GOTO 300
	READ(IMPDATA(IREC,L,IATOM),*,END=300,ERR=300)
     &IRUNR,KFIX,KRES   ! run,probabilities
	IF(IRUNR.NE.IRUN)CALL FULLSTOP('Error reading imp.data: IRUN')
C Read set-up
	IREC=IREC+1
	IF(IREC.GT.IMPINFO(L,IATOM))GOTO 300
	READ(IMPDATA(IREC,L,IATOM),*,END=300,ERR=300)
     &NDEGR,NREPR,NCNFR,NCN0R       ! run,degeneracy, representations, configurations
	IF(NDEGR.NE.NDEG)CALL FULLSTOP('Error reading imp.data: NDEG')
	IF(NREPR.NE.NREP)CALL FULLSTOP('Error reading imp.data: NREP')
	IF(NCNFR.NE.NCNF.AND.NCNFR.NE.0)
     &                 CALL FULLSTOP('Error reading imp.data: NCNF')
	IF(NCN0R.NE.NCNF0.AND.NCN0R.NE.1)
     &                 CALL FULLSTOP('Error reading imp.data:NCNF0')
C Read local impurity levels
	DO ISPIN=1,MSPIN
	DO IREP=1,NREP
	IREC=IREC+1
	IF(IREC.GT.IMPINFO(L,IATOM))GOTO 300
	READ(IMPDATA(IREC,L,IATOM),*,END=300,ERR=300)LREPR,ISPINR,
     &EINPCRF(IREP,ISPINR),ZMASCRF(IREP,ISPINR),
     &RMASCRF(IREP,ISPINR),SIG0CRF(IREP,ISPINR)  ! subdegeneracy,spin,impurity level
	IF(LREPR.NE.LREP(IREP))
     &CALL FULLSTOP('Error reading imp.data:LREPR')
	ENDDO
	ENDDO
C Read Probabilities
	DO ICNF=1,NCNFR
	IF(ICNF.EQ.1)IREC=IREC+1      ! skip comment
	DO ICNF0=1,NCNF0
	IREC=IREC+1
	IF(IREC.GT.IMPINFO(L,IATOM))GOTO 300
	READ(IMPDATA(IREC,L,IATOM),*,END=300,ERR=300)
     &IFIX,PHUB                    ! probability in Hubbard 1 within CRF
	IFIXCRF(ICNF,ICNF0)=IFIX
	XHUBCRF(ICNF,ICNF0)=PHUB/(COMR(ICNF)*COMR(ICNF0))
	PSIKCRF(ICNF,ICNF0)=SQRT(ABS(XHUBCRF(ICNF,ICNF0)))
	ENDDO
	ENDDO
	GOTO 400
  300	CONTINUE
	CALL FULLSTOP('Error reading imp.data: Not enough data.')
  400 CONTINUE
C Prepare levels
	IDEG=0
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.0)CYCLE
	IDEG=IDEG+1
	IREP=KDREP(IDIM)
	ISPIN=(2*IDIM-1)/NDIM+1
	IF(MSPIN.EQ.1)ISPIN=1
C Hybridization
	DO IMSC=0,NMSC
	DELCRF(IMSC,IREP,ISPIN)=DELWDEG(IMSC,IDEG,IDEG)-
     &                        DELIDEG(     IDEG,IDEG)
	SIGCRF(IMSC,IREP,ISPIN)=SIGWDEG(IMSC,IDEG,IDEG)
	ENDDO
	ENDDO
C Occupancies
	DO ISPIN=1,MSPIN
	ZOCCSCF(ISPIN)=0.D0
	ENDDO
	IDEG=0
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.0)CYCLE
	IDEG=IDEG+1
	IREP=KDREP(IDIM)
	ISPIN=(2*IDIM-1)/NDIM+1
	IF(MSPIN.EQ.1)ISPIN=1
	ZOCCSCF(ISPIN)=ZOCCSCF(ISPIN)+DHUBDEG(IDEG,IDEG)
	ENDDO
	DO ISPIN=1,MSPIN
	ZAVRSCF(ISPIN)=ZOCCSCF(ISPIN)
	ENDDO
C Average occupancies in case of spin restricted double countings
	ZOCCAVR=(ZAVRSCF(1)+ZAVRSCF(MSPIN))/2.D0
	ZAVRSCF(1)=ZOCCAVR
	ZAVRSCF(MSPIN)=ZOCCAVR
C Determine atomic charges automatically
	IDEG=0
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.0)CYCLE
	IDEG=IDEG+1
	IREP=KDREP(IDIM)
	ISPIN=(2*IDIM-1)/NDIM+1
	IF(MSPIN.EQ.1)ISPIN=1
	ZATMCRF(IREP,ISPIN)=DHUBDEG(IDEG,IDEG)
	ENDDO
C Fixed mass renormalization
	KRESCRF=KRES
	DO ISPIN=1,MSPIN
	DO IREP=1,NREP
	ZRESCRF(IREP,ISPIN)=ZMASCRF(IREP,ISPIN)*RMASCRF(IREP,ISPIN)
	ENDDO
	ENDDO
C Fixed probabilities
	KFIXCRF=KFIX
	IF(KFIXCRF.EQ.0)THEN
	DO ICNF=1,NCNF
	DO ICNF0=1,NCNF0
	PSIKCRF(ICNF,ICNF0)=0.D0
	XHUBCRF(ICNF,ICNF0)=0.D0
	ENDDO
	ENDDO
	ENDIF
C A new guess for the double counting will replace the Hartree shift
	IDEG=0
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.0)CYCLE
	IDEG=IDEG+1
	IREP=KDREP(IDIM)
	ISPIN=(2*IDIM-1)/NDIM+1
	IF(MSPIN.EQ.1)ISPIN=1
	IF(ISPIN.EQ.1)ISPINM=MSPIN
	IF(ISPIN.EQ.MSPIN)ISPINM=1
C New double counting is the old one
	VDBNDEG(IDEG,IDEG)=VDBCDEG(IDEG,IDEG)
C Unless it can be guessed immidiately in some cases
	IF(KDBLCNT(L,IATOM).EQ.11)
     &VDBNDEG(IDEG,IDEG)=UPAR*ZOCCSCF(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZOCCSCF(ISPIN)/2.D0*DBLE(MSPIN)-(UPAR-GPAR)*
     &CDBLCNT(L,IATOM)
	IF(KDBLCNT(L,IATOM).EQ.12)
     &VDBNDEG(IDEG,IDEG)=UPAR*ZAVRSCF(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZAVRSCF(ISPIN)/2.D0*DBLE(MSPIN)-(UPAR-GPAR)*
     &CDBLCNT(L,IATOM)
	IF(KDBLCNT(L,IATOM).EQ.21)
     &VDBNDEG(IDEG,IDEG)=UPAR*ZOCCSCF(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZOCCSCF(ISPIN)/2.D0*DBLE(MSPIN)-(UPAR-GPAR)*
     &ZOCCSCF(ISPIN)/2.D0*DBLE(MSPIN)/(DBLE(NDEG)/2.D0)
	IF(KDBLCNT(L,IATOM).EQ.22)
     &VDBNDEG(IDEG,IDEG)=UPAR*ZAVRSCF(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZAVRSCF(ISPIN)/2.D0*DBLE(MSPIN)-(UPAR-GPAR)*
     &ZAVRSCF(ISPIN)/2.D0*DBLE(MSPIN)/(DBLE(NDEG)/2.D0)
	ENDDO
C ************************************************************
C SET ELOCs
	IF(KIMPLEV(L,IATOM)/10.EQ.1.OR.KIMPLEV(L,IATOM)/10.EQ.2)THEN
	IDEG=0
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.0)CYCLE
	IDEG=IDEG+1
	IREP=KDREP(IDIM)
	ISPIN=(2*IDIM-1)/NDIM+1
	IF(MSPIN.EQ.1)ISPIN=1
C Eloc is Elda-Vdc but due to overlap, the expression is more complicated
C Notice that Eimp=o(Elda-Vdc+SigI)o
C Notice that we plug in new double counting here
      IF(KIMPLEV(L,IATOM)/10.EQ.1)
     &ELOCCRF(IREP,ISPIN)=EIMPDEG(IDEG,IDEG)-VDBNDEG(IDEG,IDEG)-EFRM-
     &(SIGIDEG(IDEG,IDEG)-VDBCDEG(IDEG,IDEG))
C Eloc can be just -U(n-1/2) if Elda=Ef or if valence needs to be fixed
      IF(KIMPLEV(L,IATOM)/10.EQ.2)
     &ELOCCRF(IREP,ISPIN)=-VDBNDEG(IDEG,IDEG)
	ENDDO
C Average level position
      EINPAVR=0.D0
	ELOCAVR=0.D0
	DO IREP=1,NREP
	DO ISPIN=1,MSPIN
      EINPAVR=EINPAVR+EINPCRF(IREP,ISPIN)
	ELOCAVR=ELOCAVR+ELOCCRF(IREP,ISPIN)
	ENDDO
	ENDDO
	EINPAVR=EINPAVR/DBLE(NREP)/DBLE(MSPIN)
      ELOCAVR=ELOCAVR/DBLE(NREP)/DBLE(MSPIN)
C Freeze spin splittings
	DO IREP=1,NREP
      IF(MOD(KIMPLEV(L,IATOM),10).EQ.1)
     &BLOCAVR=(ELOCCRF(IREP,1)-ELOCCRF(IREP,MSPIN))/2.D0
      IF(MOD(KIMPLEV(L,IATOM),10).EQ.2)
     &BLOCAVR=(EINPCRF(IREP,1)-EINPCRF(IREP,MSPIN))/2.D0
      DELBCRF(IREP,1)    =+BLOCAVR
      DELBCRF(IREP,MSPIN)=-BLOCAVR
	ENDDO
C Freeze crf splittings
	DO ISPIN=1,MSPIN
	DO IREP=1,NREP
	IF(MOD(KIMPLEV(L,IATOM),10).EQ.1)DELVCRF(IREP,ISPIN)=
     &(ELOCCRF(IREP,1)+ELOCCRF(IREP,MSPIN))/2.D0-ELOCAVR
      IF(MOD(KIMPLEV(L,IATOM),10).EQ.2)DELVCRF(IREP,ISPIN)=
     &(EINPCRF(IREP,1)+EINPCRF(IREP,MSPIN))/2.D0-EINPAVR
	ENDDO
	ENDDO
C Set local levels
	DO ISPIN=1,MSPIN
	DO IREP=1,NREP
	ELOCCRF(IREP,ISPIN)=ELOCAVR+DELVCRF(IREP,ISPIN)+
     &                            DELBCRF(IREP,ISPIN)
	ENDDO
	ENDDO
C Eloc is given by input
	ELSEIF(KIMPLEV(L,IATOM)/10.EQ.3)THEN
	IF(IMPINFO(L,IATOM).EQ.0)CALL FULLSTOP('Eloc not set')
	DO IREP=1,NREP
	DO ISPIN=1,MSPIN
	ELOCCRF(IREP,ISPIN)=EINPCRF(IREP,ISPIN)
	ENDDO
	ENDDO
	ENDIF
C ***********************************************
C Set Mean Field (LDA) position of impurity level
	IDEG=0
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.0)CYCLE
	IDEG=IDEG+1
	IREP=KDREP(IDIM)
	ISPIN=(2*IDIM-1)/NDIM+1
	IF(MSPIN.EQ.1)ISPIN=1
	ELDACRF(IREP,ISPIN)=EIMPDEG(IDEG,IDEG)-
     &(SIGIDEG(IDEG,IDEG)-VDBCDEG(IDEG,IDEG))
	ENDDO
C Average LDA levels if paramagnetic double counting is working
	IF(MOD(KDBLCNT(L,IATOM),2).EQ.0)THEN
	DO IREP=1,NREP
	ELDAAVR=(ELDACRF(IREP,1)+ELDACRF(IREP,MSPIN))/2.D0
	ELDACRF(IREP,1)=ELDAAVR
	ELDACRF(IREP,MSPIN)=ELDAAVR
	ENDDO
	ENDIF
C ********************************************
C CRF SOLUTION OF IMPURITY MODEL USING ATOMIC SELF-ENERGY (HUBBARD I)
      CALL IMP_CRFHUB1_STAT(NDEG,NREP,MSPIN,LREP,NCNF,NCNF0,EATSCRF,
     &  TPAR,UPAR,GPAR,ELOCCRF,DELCRF,GFFCRF,SIGCRF,XHUBCRF,YHUBCRF,
     &  IFIXCRF,SIGICRF,VRATCRF,WRATCRF,POLECRF,OVRLCRF,ZIMPCRF,
     &  ZREPCRF,KFIXCRF,TEMP,NMSC,WMSC,FMSC,0.000D0,IERR)
C New impurity densities
	DO ISPIN=1,MSPIN
	ZOCCIMP(ISPIN)=0.D0
	DO IREP=1,NREP
	ZOCCIMP(ISPIN)=ZOCCIMP(ISPIN)+ZREPCRF(IREP,ISPIN)
	ENDDO
	ENDDO
C Average occupancies in case of spin restricted double countings
	DOCCAVR=(ZAVRIMP(1)+ZAVRIMP(MSPIN))/2.D0
	ZAVRIMP(1)=DOCCAVR
	ZAVRIMP(MSPIN)=DOCCAVR
C SELF-ENERGY AT INFINITY CAN BE SET ACCORDING TO THE CURRENT OCCUPANCIES
      ALLOCATE(SIGA(NREP,MSPIN,4))
	IDEG=0
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.0)CYCLE
	IDEG=IDEG+1
	IREP=KDREP(IDIM)
	ISPIN=(2*IDIM-1)/NDIM+1
	IF(MSPIN.EQ.1)ISPIN=1
	IF(ISPIN.EQ.1)ISPINM=MSPIN
	IF(ISPIN.EQ.MSPIN)ISPINM=1
C LDA Occupations
      SIGA(IREP,ISPIN,1)=UPAR*ZOCCSCF(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*(ZOCCSCF(ISPIN)/2.D0*DBLE(MSPIN)-
     &                   ZATMCRF(IREP,ISPIN)                 )
C Atomic Integer occupations
      SIGA(IREP,ISPIN,2)=UPAR*ZOCCIMP(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*(ZOCCIMP(ISPIN)/2.D0*DBLE(MSPIN)-
     &                   ZREPCRF(IREP,ISPIN)/DBLE(LREP(IREP)))
      SIGA(IREP,ISPIN,3)=DREAL(SIGCRF(NMSC,IREP,ISPIN))
      SIGA(IREP,ISPIN,4)=SIGICRF(IREP,ISPIN)
	ENDDO
C RESET SELF-ENERGY AT INFINITY: 
	DO IREP=1,NREP
	DO ISPIN=1,MSPIN
	DO IMSC=0,NMSC                  ! over frequencies
	IF(KSIGMOO(L,IATOM).EQ.11.OR.KSIGMOO(L,IATOM).EQ.21)
     &SIGCRF(IMSC,IREP,ISPIN)=SIGCRF(IMSC,IREP,ISPIN)-
     &SIGICRF(IREP,ISPIN)+SIGA(IREP,ISPIN,1)
	IF(KSIGMOO(L,IATOM).EQ.12.OR.KSIGMOO(L,IATOM).EQ.22)
     &SIGCRF(IMSC,IREP,ISPIN)=SIGCRF(IMSC,IREP,ISPIN)-
     &SIGICRF(IREP,ISPIN)+SIGA(IREP,ISPIN,2)
	IF(KSIGMOO(L,IATOM).EQ.31)
     &SIGCRF(IMSC,IREP,ISPIN)=SIGCRF(IMSC,IREP,ISPIN)-
     &SIGICRF(IREP,ISPIN)+SIGA(IREP,ISPIN,3)
	IF(KSIGMOO(L,IATOM).EQ.41)
     &SIGCRF(IMSC,IREP,ISPIN)=SIGCRF(IMSC,IREP,ISPIN)-
     &SIGICRF(IREP,ISPIN)+SIGA(IREP,ISPIN,4)
      ENDDO                           ! over frequencies
	IF(KSIGMOO(L,IATOM).EQ.11.OR.KSIGMOO(L,IATOM).EQ.21)
     &SIGICRF(IREP,ISPIN)=SIGA(IREP,ISPIN,1)
	IF(KSIGMOO(L,IATOM).EQ.12.OR.KSIGMOO(L,IATOM).EQ.22)
     &SIGICRF(IREP,ISPIN)=SIGA(IREP,ISPIN,2)
	IF(KSIGMOO(L,IATOM).EQ.31)
     &SIGICRF(IREP,ISPIN)=SIGA(IREP,ISPIN,3)
	IF(KSIGMOO(L,IATOM).EQ.41)
     &SIGICRF(IREP,ISPIN)=SIGA(IREP,ISPIN,4)
      ENDDO      
      ENDDO      
C *****************************************
C CRF SOLUTION OF IMPURITY MODEL USING SBMF
      IF(KGRD.EQ.2.AND.KRESCRF.EQ.0)THEN
	CALL IMP_CRFSBMF_MAIN(NDEG,NREP,MSPIN,LREP,NCNF,NCNF0,EATSCRF,
     &  TPAR,UPAR,GPAR,ELOCCRF,DELCRF,GFFCRF,
     &  SIGCRF,PSIKCRF,IFIXCRF,ZMASCRF,ZIMPCRF,ZREPCRF,
     &  KFIXCRF,TEMP,NMSC,WMSC,FMSC,0.000D0,IERR)
C Set Sigma0
	DO ISPIN=1,MSPIN
	DO IREP=1,NREP
	SIG0CRF(IREP,ISPIN)=DREAL(SIGCRF(0,IREP,ISPIN))
	ZRESCRF(IREP,ISPIN)=ZMASCRF(IREP,ISPIN)*RMASCRF(IREP,ISPIN)
	ENDDO
	ENDDO
C ********************************************
C DETERMINE SIGMA(0) FOR FIXED MASS RENORMALIZATIONS
	ELSEIF(KGRD.EQ.2.AND.KRESCRF.EQ.1)THEN
	DO ISPIN=1,MSPIN
	DO IREP=1,NREP
	IF(ABS(ZRESCRF(IREP,ISPIN)).LE.1.D-10)CYCLE
	JTER=0
	E1=-TPAR
	E2=+TPAR
	CALL LIB_FINDROOT(ELAM,ZDIF,E1,E2,JTER,IEXIT,IUN,1.D-05,50)
      DO JTER=1,10**5
C Find new Greens function
	DO IMSC=0,NMSC
	ZMSC=WMSC(IMSC)
	GFFCRF(IMSC,IREP,ISPIN)=1.D0/(ZMSC-ELAM-
     &ZRESCRF(IREP,ISPIN)*DELCRF(IMSC,IREP,ISPIN))
	ENDDO
C Find new charge
	ZIMP=0.D0
	DO IMSC=0,NMSC
      ZIMP=ZIMP+2.D0*TEMP*DREAL(GFFCRF(IMSC,IREP,ISPIN)-
     &1.D0/(WMSC(IMSC)-ELAM))*FMSC(IMSC)
	ENDDO
	ZIMP=ZIMP+FERMIFUN(ELAM,TEMP)
	ZDIF=ZATMCRF(IREP,ISPIN)-ZIMP
	CALL LIB_FINDROOT(ELAM,ZDIF,E1,E2,JTER,IEXIT,IUN,1.D-05,50)
	IF(IEXIT.EQ.1)EXIT
      ENDDO	
      SIG0CRF(IREP,ISPIN)=ELAM/ZRESCRF(IREP,ISPIN)-ELOCCRF(IREP,ISPIN)
      ENDDO
      ENDDO	
	ENDIF
C RATIONAL INTERPOLATION IN CRF CASE
	ZRES=0.D0
	DO ISPIN=1,MSPIN
	DO IREP=1,NREP
	ZRES=ZRES+ZRESCRF(IREP,ISPIN)
	ENDDO
	ENDDO
	IF(ABS(ZRES).LE.1.D-05.OR.KRESCRF.EQ.1)THEN
	DO ICNF=1,NCNF
	DO JCNF=1,NCNF0
	PSIKCRF(ICNF,JCNF)=SQRT(ABS(XHUBCRF(ICNF,JCNF)))
	ENDDO
	ENDDO
	ENDIF
	CALL IMP_CRFIRAT_COFS(NDEG,NREP,MSPIN,LREP,NCNF,NCNF0,
     &     ELOCCRF,UPAR,GPAR,ZTOT,TPAR,SIG0CRF,SIGICRF,ZRESCRF,
     &     PSIKCRF,MRATCRF,WSIGCRF,PSIGCRF,0,IERR)
C Reconstruct self-energy
	DO ISPIN=1,MSPIN
	DO IREP=1,NREP
	DO IMSC=0,NMSC
	ZMSC=WMSC(IMSC)
	SIGCRF(IMSC,IREP,ISPIN)=SIGICRF(IREP,ISPIN)
	DO IRAT=1,MRATCRF
	SIGCRF(IMSC,IREP,ISPIN)=SIGCRF(IMSC,IREP,ISPIN)+
     &WSIGCRF(IRAT,IREP,ISPIN)/(ZMSC-PSIGCRF(IRAT,IREP,ISPIN))
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C Reconstruct Green function
	DO ISPIN=1,MSPIN
	DO IREP=1,NREP
	DO IMSC=0,NMSC
	ZMSC=WMSC(IMSC)
	GFFCRF(IMSC,IREP,ISPIN)=1.D0/(ZMSC-ELOCCRF(IREP,ISPIN)-
     &DELCRF(IMSC,IREP,ISPIN)-SIGCRF(IMSC,IREP,ISPIN))
	ENDDO
	ENDDO
	ENDDO
C RESET SELF-ENERGY AT INFINITY: 
	DO IREP=1,NREP
	DO ISPIN=1,MSPIN
	DO IMSC=0,NMSC                  ! over frequencies
	IF(KSIGMOO(L,IATOM).EQ.11.OR.KSIGMOO(L,IATOM).EQ.21)
     &SIGCRF(IMSC,IREP,ISPIN)=SIGCRF(IMSC,IREP,ISPIN)-
     &SIGICRF(IREP,ISPIN)+SIGA(IREP,ISPIN,1)
	IF(KSIGMOO(L,IATOM).EQ.12.OR.KSIGMOO(L,IATOM).EQ.22)
     &SIGCRF(IMSC,IREP,ISPIN)=SIGCRF(IMSC,IREP,ISPIN)-
     &SIGICRF(IREP,ISPIN)+SIGA(IREP,ISPIN,2)
	IF(KSIGMOO(L,IATOM).EQ.31)
     &SIGCRF(IMSC,IREP,ISPIN)=SIGCRF(IMSC,IREP,ISPIN)-
     &SIGICRF(IREP,ISPIN)+SIGA(IREP,ISPIN,3)
	IF(KSIGMOO(L,IATOM).EQ.41)
     &SIGCRF(IMSC,IREP,ISPIN)=SIGCRF(IMSC,IREP,ISPIN)-
     &SIGICRF(IREP,ISPIN)+SIGA(IREP,ISPIN,4)
      ENDDO                           ! over frequencies
	IF(KSIGMOO(L,IATOM).EQ.11.OR.KSIGMOO(L,IATOM).EQ.21)
     &SIGICRF(IREP,ISPIN)=SIGA(IREP,ISPIN,1)
	IF(KSIGMOO(L,IATOM).EQ.12.OR.KSIGMOO(L,IATOM).EQ.22)
     &SIGICRF(IREP,ISPIN)=SIGA(IREP,ISPIN,2)
	IF(KSIGMOO(L,IATOM).EQ.31)
     &SIGICRF(IREP,ISPIN)=SIGA(IREP,ISPIN,3)
	IF(KSIGMOO(L,IATOM).EQ.41)
     &SIGICRF(IREP,ISPIN)=SIGA(IREP,ISPIN,4)
      ENDDO      
      ENDDO      
C SET OUTPUT ARRAYS
	IDEG1=0
	DO IDIM1=1,NDIM
	IF(KSTATES(IDIM1,IRUN,L,IATOM).EQ.0)CYCLE
	IDEG1=IDEG1+1
	IREP1=KDREP(IDIM1)
	ISPIN1=(2*IDIM1-1)/NDIM+1
	IF(MSPIN.EQ.1)ISPIN1=1
	IDEG=0
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.0)CYCLE
	IDEG=IDEG+1
	IREP=KDREP(IDIM)
	ISPIN=(2*IDIM-1)/NDIM+1
	IF(MSPIN.EQ.1)ISPIN=1
C Set self-energy
	DO IMSC=0,NMSC
	ZMSC=WMSC(IMSC)
	IF(IDEG1.EQ.IDEG.AND.IDMF.EQ.3)
     &SIGWDEG(IMSC,IDEG1,IDEG)=SIGCRF(IMSC,IREP,ISPIN)
	IF(IDEG1.EQ.IDEG.AND.IDMF.EQ.4)THEN
	SIGWDEG(IMSC,IDEG1,IDEG)=SIGICRF(IREP,ISPIN)
	DO IPOL=1,MIN(NPOLIMP(L,IATOM),MRATCRF)
      SIGWDEG(IMSC,IDEG1,IDEG)=SIGWDEG(IMSC,IDEG1,IDEG)+
     &WSIGCRF(IPOL,IREP,ISPIN)/(ZMSC*OVRLCRF(IREP,ISPIN)-
     &PSIGCRF(IPOL,IREP,ISPIN))
	IF(IDEG1.EQ.IDEG.AND.IDMF.EQ.5)
     &SIGWDEG(IMSC,IDEG1,IDEG)=SIGCRF(IMSC,IREP,ISPIN)
	ENDDO
	ENDIF
	IF(IDEG1.NE.IDEG)
     &SIGWDEG(IMSC,IDEG1,IDEG)=(0.D0,0.D0)
	ENDDO
C Set self-energy at infinity
	IF(IDEG1.EQ.IDEG)
     &SIGIDEG(IDEG1,IDEG)=DCMPLX(SIGICRF(IREP,ISPIN),0.D0)
	IF(IDEG1.NE.IDEG)
     &SIGIDEG(IDEG1,IDEG)=(0.D0,0.D0)
C Set self-energy at zero
	IF(IDEG1.EQ.IDEG.AND.IDMF.EQ.3)
     &SIG0DEG(IDEG1,IDEG)=DREAL(SIGCRF(0,IREP,ISPIN))
	IF(IDEG1.EQ.IDEG.AND.IDMF.EQ.4)
     &SIG0DEG(IDEG1,IDEG)=DREAL(SIGCRF(0,IREP,ISPIN))
	IF(IDEG1.EQ.IDEG.AND.IDMF.EQ.5)    !!! do not reset !!!
     &SIG0DEG(IDEG1,IDEG)=SIG0DEG(IDEG1,IDEG)
	IF(IDEG1.NE.IDEG)
     &SIG0DEG(IDEG1,IDEG)=(0.D0,0.D0)
C Set mass renormalization
	IF(IDEG1.EQ.IDEG)
     &BMASDEG(IDEG1,IDEG)=SQRT(ABS(ZMASCRF(IREP,ISPIN)))
	IF(IDEG1.NE.IDEG)
     &BMASDEG(IDEG1,IDEG)=(0.D0,0.D0)
C Set bare impurity levels
	IF(IDEG1.EQ.IDEG)
     &ELOCDEG(IDEG1,IDEG)=ELOCCRF(IREP,ISPIN)
	IF(IDEG1.NE.IDEG)
     &ELOCDEG(IDEG1,IDEG)=(0.D0,0.D0)
C Set rational interpolation coefficients
	DO IPOL=1,NPOLIMP(L,IATOM)
	VRATDEG(IDEG1,IDEG,IPOL)=(0.D0,0.D0)
	WRATDEG(IDEG1,IDEG,IPOL)=(0.D0,0.D0)
	PRATDEG(IDEG1,IDEG,IPOL)=(0.D0,0.D0)
	ORATDEG(IDEG1,IDEG,IPOL)=(0.D0,0.D0)
	IF(IDEG1.EQ.IDEG.AND.IPOL.LE.MRATCRF)THEN
	VRATDEG(IDEG1,IDEG,IPOL)=SQRT(WSIGCRF(IPOL,IREP,ISPIN))
	WRATDEG(IDEG1,IDEG,IPOL)=SQRT(WSIGCRF(IPOL,IREP,ISPIN))
	PRATDEG(IDEG1,IDEG,IPOL)=PSIGCRF(IPOL,IREP,ISPIN)
C    &                +EFRM*DCMPLX(OVRLCRF(IREP,ISPIN),0.D0)
	ORATDEG(IDEG1,IDEG,IPOL)=DCMPLX(OVRLCRF(IREP,ISPIN),0.D0)
	ENDIF
	IF(IDEG1.EQ.IDEG.AND.IPOL.GT.MRATCRF)THEN
	PRATDEG(IDEG1,IDEG,IPOL)=DCMPLX(1.D0,0.D0) ! for unhybridzied poles put them to 1.0 Ry above Ef
	ORATDEG(IDEG1,IDEG,IPOL)=DCMPLX(1.D0,0.D0)
	ENDIF
	ENDDO
C Set double counting potential
	IF(ISPIN.EQ.1)ISPINM=MSPIN
	IF(ISPIN.EQ.MSPIN)ISPINM=1
C 00  Keep this array untouched
	IF(KDBLCNT(L,IATOM).EQ.0)
     &VDBCDEG(IDEG1,IDEG)=VDBCDEG(IDEG1,IDEG)
C 11. Fully localized spin polarized limit with Nscf
	IF(KDBLCNT(L,IATOM).EQ.11.AND.IDEG1.EQ.IDEG)
     &VDBCDEG(IDEG1,IDEG)=UPAR*ZOCCSCF(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZOCCSCF(ISPIN)/2.D0*DBLE(MSPIN)-(UPAR-GPAR)*
     &CDBLCNT(L,IATOM)
	IF(KDBLCNT(L,IATOM).EQ.11.AND.IDEG1.NE.IDEG)
     &VDBCDEG(IDEG1,IDEG)=(0.D0,0.D0)
C 12. Fully localized spin restricted limit with Nscf
	IF(KDBLCNT(L,IATOM).EQ.12.AND.IDEG1.EQ.IDEG)
     &VDBCDEG(IDEG1,IDEG)=UPAR*ZAVRSCF(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZAVRSCF(ISPIN)/2.D0*DBLE(MSPIN)-(UPAR-GPAR)*
     &CDBLCNT(L,IATOM)
	IF(KDBLCNT(L,IATOM).EQ.12.AND.IDEG1.NE.IDEG)
     &VDBCDEG(IDEG1,IDEG)=(0.D0,0.D0)
C 13. Fully localized spin polarized limit with Nimp
	IF(KDBLCNT(L,IATOM).EQ.13.AND.IDEG1.EQ.IDEG)
     &VDBCDEG(IDEG1,IDEG)=UPAR*ZOCCIMP(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZOCCIMP(ISPIN)/2.D0*DBLE(MSPIN)-(UPAR-GPAR)*
     &CDBLCNT(L,IATOM)
	IF(KDBLCNT(L,IATOM).EQ.13.AND.IDEG1.NE.IDEG)
     &VDBCDEG(IDEG1,IDEG)=(0.D0,0.D0)
C 14. Fully localized spin restricted limit with Nimp
	IF(KDBLCNT(L,IATOM).EQ.14.AND.IDEG1.EQ.IDEG)
     &VDBCDEG(IDEG1,IDEG)=UPAR*ZAVRIMP(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZAVRIMP(ISPIN)/2.D0*DBLE(MSPIN)-(UPAR-GPAR)*
     &CDBLCNT(L,IATOM)
	IF(KDBLCNT(L,IATOM).EQ.14.AND.IDEG1.NE.IDEG)
     &VDBCDEG(IDEG1,IDEG)=(0.D0,0.D0)
C 21. Analitical spin polarized limit of Sigma(inf) with Nscf
	IF(KDBLCNT(L,IATOM).EQ.21.AND.IDEG1.EQ.IDEG)
     &VDBCDEG(IDEG,IDEG)=UPAR*ZOCCSCF(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZOCCSCF(ISPIN)/2.D0*DBLE(MSPIN)-(UPAR-GPAR)*
     &ZOCCSCF(ISPIN)/2.D0*DBLE(MSPIN)/(DBLE(NDEG)/2.D0)
	IF(KDBLCNT(L,IATOM).EQ.21.AND.IDEG1.NE.IDEG)
     &VDBCDEG(IDEG1,IDEG)=(0.D0,0.D0)
C 22. Analitical spin restricted limit of Sigma(inf) with Nscf
	IF(KDBLCNT(L,IATOM).EQ.22.AND.IDEG1.EQ.IDEG)
     &VDBCDEG(IDEG,IDEG)=UPAR*ZAVRSCF(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZAVRSCF(ISPIN)/2.D0*DBLE(MSPIN)-(UPAR-GPAR)*
     &ZAVRSCF(ISPIN)/2.D0*DBLE(MSPIN)/(DBLE(NDEG)/2.D0)
	IF(KDBLCNT(L,IATOM).EQ.22.AND.IDEG1.NE.IDEG)
     &VDBCDEG(IDEG1,IDEG)=(0.D0,0.D0)
C 23. Analitical spin polarized limit of Sigma(inf) with Nimp
	IF(KDBLCNT(L,IATOM).EQ.23.AND.IDEG1.EQ.IDEG)
     &VDBCDEG(IDEG,IDEG)=UPAR*ZOCCIMP(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZOCCIMP(ISPIN)/2.D0*DBLE(MSPIN)-(UPAR-GPAR)*
     &ZOCCIMP(ISPIN)/2.D0*DBLE(MSPIN)/(DBLE(NDEG)/2.D0)
	IF(KDBLCNT(L,IATOM).EQ.23.AND.IDEG1.NE.IDEG)
     &VDBCDEG(IDEG1,IDEG)=(0.D0,0.D0)
C 24. Analitical spin restricted limit of Sigma(inf) with Nimp
	IF(KDBLCNT(L,IATOM).EQ.24.AND.IDEG1.EQ.IDEG)
     &VDBCDEG(IDEG,IDEG)=UPAR*ZAVRIMP(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZAVRIMP(ISPIN)/2.D0*DBLE(MSPIN)-(UPAR-GPAR)*
     &ZAVRIMP(ISPIN)/2.D0*DBLE(MSPIN)/(DBLE(NDEG)/2.D0)
	IF(KDBLCNT(L,IATOM).EQ.24.AND.IDEG1.NE.IDEG)
     &VDBCDEG(IDEG1,IDEG)=(0.D0,0.D0)
C 30. Fixed double counting
	IF(KDBLCNT(L,IATOM).EQ.30)
     &VDBCDEG(IDEG1,IDEG)=VDBCDEG(IDEG1,IDEG)
C 40. Double counting according to Eloc
	IF(KDBLCNT(L,IATOM).EQ.40.AND.IDEG1.EQ.IDEG)
     &VDBCDEG(IDEG1,IDEG)=ELDACRF(IREP,ISPIN)-EFRM-ELOCCRF(IREP,ISPIN)
	IF(KDBLCNT(L,IATOM).EQ.40.AND.IDEG1.NE.IDEG)
     &VDBCDEG(IDEG1,IDEG)=(0.D0,0.D0)
C 50. Sigma(0)
	IF(KDBLCNT(L,IATOM).EQ.50)
     &VDBCDEG(IDEG1,IDEG)=SIG0DEG(IDEG1,IDEG)
C 60. Sigma(inf)
	IF(KDBLCNT(L,IATOM).EQ.60)
     &VDBCDEG(IDEG1,IDEG)=SIGIDEG(IDEG1,IDEG)
	ENDDO
	ENDDO
C UPGRADE IMPURITY INFORMATION IF REQUESTED
	IF(IMPSECT(L,IATOM).EQ.2)THEN
	LOLD=ILEN
	LNEW=LOLD+2+NREP*MSPIN+1+NCNF*NCNF0
	CALL IMP_IMPIRAT_REFILE(LOLD,LNEW)
	ILEN=ILEN+1
	WRITE(IMPWORK(ILEN),10200)IRUN,KFIX
	ILEN=ILEN+1
	WRITE(IMPWORK(ILEN),10210)NDEG,NREP,NCNF,NCNF0
C Store levels
	DO ISPIN=1,MSPIN
	DO IREP=1,NREP
	ILEN=ILEN+1
	TCTRL=LIB_TDP(ELOCCRF(IREP,ISPIN),1.D-10)
	TCTRM=LIB_TDP(ZMASCRF(IREP,ISPIN),1.D-10)
	TCTRR=LIB_TDP(RMASCRF(IREP,ISPIN),1.D-10)
	TCTRS=LIB_TDP(SIG0CRF(IREP,ISPIN),1.D-10)
	WRITE(IMPWORK(ILEN),10220)
     &LREP(IREP),ISPIN,TCTRL,TCTRM,TCTRR,TCTRS
	ENDDO
	ENDDO
C Store Probabilities
	IF(MSPIN.EQ.1)THEN
	ICFR=0
	ILEN=ILEN+1
	WRITE(IMPWORK(ILEN),10230)
	DO IDEG=0,NDEG
	DO ICFG=1,LCFG(IDEG)
	ICFR=ICFR+1
	ICNF=IPCF(ICFR) ! find out the configuration in first numbering scheme
	CALL LIB_GETCONF(NREP,LREP,MREP,ICNF,NCNF,IPNF) 
	IFIX=IFIXCRF(ICFR,1)
	TCTRL=LIB_TDP(COMR(ICFR)*COMR(1)*PSIKCRF(ICFR,1)**2,1.D-10)
	TCTRM=LIB_TDP(EATSCRF(ICFR,1),1.D-10)
	ILEN=ILEN+1
	WRITE(IMPWORK(ILEN),10240)IFIX,TCTRL,
     &IDEG,ICFG,TCTRM,(IPNF(IREP),IREP=1,NREP)
	ENDDO
	ENDDO
	ELSEIF(MSPIN.EQ.2)THEN
	ICFR=0
	ILEN=ILEN+1
	WRITE(IMPWORK(ILEN),10250)
	DO IDEG=0,NDEG/MSPIN
	DO ICFG=1,LCFG(IDEG)
	ICFR=ICFR+1
	ICNF=IPCF(ICFR) ! find out the configuration in first numbering scheme
	CALL LIB_GETCONF(NREP,LREP,MREP,ICNF,NCNF,IPNF)
	ICFR1=0
	DO IDEG1=0,NDEG/MSPIN
	DO ICFG1=1,LCFG(IDEG1)
	ICFR1=ICFR1+1
	ICNF1=IPCF(ICFR1) ! find out the configuration in first numbering scheme
	CALL LIB_GETCONF(NREP,LREP,MREP,ICNF1,NCNF,IPNFP1)
	IFIX=IFIXCRF(ICFR,ICFR1)
	TCTRL=LIB_TDP(COMR(ICFR)*COMR(ICFR1)*PSIKCRF(ICFR,ICFR1)**2,
     &1.D-10)
	TCTRM=LIB_TDP(EATSCRF(ICFR,ICFR1),1.D-10)
	ILEN=ILEN+1
	WRITE(IMPWORK(ILEN),10260)IFIX,
     &TCTRL,IDEG,IDEG1,ICFG,ICFG1,TCTRM,
     &(IPNF(IREP),IREP=1,NREP),(IPNFP1(IREP),IREP=1,NREP)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDIF
10200	FORMAT(2(1X,I3),' ! iRun,kFix' )
10210	FORMAT(4(1X,I3),' ! nDeg,nRep,nCnf,nCnf0')
10220	FORMAT(1X,I3,1X,I3,1X,A10,1X,A10,1X,A10,1X,A10,
     &                ' ! lRep,iSpin,Eloc,Zmas,Rmas,Sig0')
10230	FORMAT(1X,'f',5X,'<X>',4X,'Nel',1X,'Conf',4X,'<E>')
10240	FORMAT(1X,I1,1X,A10,I3,1X,I3,2X,A10,14(1X,I3))
10250	FORMAT(1X,'f',6X,'<X>',2X,'N_up N_dn C_up C_dn',5X,
     &       '<E>',4X,'Sublevels')
10260	FORMAT(1X,I1,1X,A10,I3,2X,I3,2X,I3,2X,I3,2X,A10,28(1X,I3))
	ENDIF
	DEALLOCATE(LREP,LREP0,LREP1,LREP2,KDREP,KDR00,KDR12)
	DEALLOCATE(ELOCCRF,EINPCRF,DELVCRF,DELBCRF,ELDACRF,EATSCRF)
	DEALLOCATE(VRATCRF,WRATCRF,POLECRF,OVRLCRF,SIGICRF)
	DEALLOCATE(PSIKCRF,XHUBCRF,YHUBCRF)
	DEALLOCATE(ZIMPCRF,ZREPCRF,ZATMCRF)
	DEALLOCATE(DELCRF,GFFCRF,SIGCRF,WSIGCRF,PSIGCRF)
	DEALLOCATE(SIG0CRF,ZMASCRF,ZRESCRF,RMASCRF,IFIXCRF)
	DEALLOCATE(MREP,IPNF,IPNF0,IPNFP1,IPCF,IPRF,LCFG,COMR)
	ENDIF
C *****************************************************
C SET RETURNING ARRAYS
	IDEG1=0
	DO IDIM1=1,NDIM
	IF(KSTATES(IDIM1,IRUN,L,IATOM).EQ.0)CYCLE
	IDEG1=IDEG1+1
	IDEG=0
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.0)CYCLE
	IDEG=IDEG+1
C Set self-energy
	DO IMSC=0,NMSC
      SIGWMAT(IMSC,IDIM1,IDIM)=SIGWDEG(IMSC,IDEG1,IDEG)
	ENDDO
C Set self-energy at infinity
      SIGIMAT(IDIM1,IDIM)=SIGIDEG(IDEG1,IDEG)
C Set self-energy at zero
      SIG0MAT(IDIM1,IDIM)=SIG0DEG(IDEG1,IDEG)
C Set mass renormalization array b=sqrt(z)
      BMASMAT(IDIM1,IDIM)=BMASDEG(IDEG1,IDEG)
C Set rational interpolation coefficients
	DO IPOL=1,NPOLIMP(L,IATOM)
	VRATMAT(IDIM1,IDIM,IPOL)=VRATDEG(IDEG1,IDEG,IPOL)
	WRATMAT(IDIM1,IDIM,IPOL)=WRATDEG(IDEG1,IDEG,IPOL)
	PRATMAT(IDIM1,IDIM,IPOL)=PRATDEG(IDEG1,IDEG,IPOL)
	ORATMAT(IDIM1,IDIM,IPOL)=ORATDEG(IDEG1,IDEG,IPOL)
	ENDDO
C Set double counting potential
	VDBCMAT(IDIM1,IDIM)=VDBCDEG(IDEG1,IDEG)
C Set bare impurity levels
	ELOCMAT(IDIM1,IDIM)=ELOCDEG(IDEG1,IDEG)
	ENDDO
	ENDDO
	DEALLOCATE(EIMPDEG,ELOCDEG,OIMPDEG,SIGWDEG,DELWDEG,DHUBDEG)
	DEALLOCATE(SIGIDEG,SIG0DEG,DELIDEG,BATHDEG,BMASDEG,SIGA,COMB)
	DEALLOCATE(VRATDEG,WRATDEG,PRATDEG,ORATDEG,VDBCDEG,VDBNDEG)
 1000	CONTINUE
C UPDATE IMPURITY INFORMATION
	IF(IMPSECT(L,IATOM).EQ.2)THEN
      CALL IMP_IMPIRAT_RECOPY(ILEN)
	IMPINFO(L,IATOM)=ILEN
	DO IREC=1,IMPINFO(L,IATOM)
	IMPDATA(IREC,L,IATOM)=IMPWORK(IREC)
	ENDDO
	ENDIF
C MEMORY DEALLOCATIONS
	DEALLOCATE(IMPWORK)

	CONTAINS

	SUBROUTINE IMP_IMPIRAT_REFILE(LO,LN)
      CHARACTER*150, ALLOCATABLE :: COPY(:)
C Copy the data into temporary array
	ALLOCATE(COPY(LO+1))
	DO IL=1,LO
	COPY(IL)=IMPWORK(IL)
	ENDDO
	DEALLOCATE(IMPWORK)
	ALLOCATE(IMPWORK(LN))
	DO IL=1,LO
	IMPWORK(IL)=COPY(IL)
	ENDDO
	DO IL=LO+1,LN
	DO I=1,150
	IMPWORK(IL)(I:I)=' '
	ENDDO
	ENDDO
	DEALLOCATE(COPY)
	END SUBROUTINE IMP_IMPIRAT_REFILE

	SUBROUTINE IMP_IMPIRAT_RECOPY(NI)
      CHARACTER*150, ALLOCATABLE :: DATA(:,:,:)
C Determine the size of current array
	IMAX=1
	DO KATOM=1,NATOM
	DO LK=0,LMAXBMEM
	IMAX=MAX(IMAX,IMPINFO(LK,KATOM))
	ENDDO
	ENDDO
	IF(IMAX.GE.NI)RETURN ! no reallocation needed
C Copy the data into temporary array
	ALLOCATE(DATA(IMAX,0:LMAXBMEM,NATOMMEM))
	DO KATOM=1,NATOM
	DO LK=0,LMAXBMEM
	DO IR=1,IMAX
	DATA(IR,LK,KATOM)=IMPDATA(IR,LK,KATOM)
	ENDDO
	ENDDO
	ENDDO
	DEALLOCATE(IMPDATA)
	ALLOCATE(IMPDATA(NI,0:LMAXBMEM,NATOMMEM))
	DO KATOM=1,NATOM
	DO LK=0,LMAXBMEM
	DO IR=1,IMAX
	IMPDATA(IR,LK,KATOM)=DATA(IR,LK,KATOM)
	ENDDO
	DO IR=IMAX+1,NI
	DO I=1,150
	IMPDATA(IR,LK,KATOM)(I:I)=' '
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	DEALLOCATE(DATA)
	END SUBROUTINE IMP_IMPIRAT_RECOPY

	END SUBROUTINE IMP_IMPIRAT
