      SUBROUTINE IMP_IMPQMCF(L,IATOM,DHUBMAT,VDBCMAT,BATHMAT,EIMPMAT,
     &     ELOCMAT,OIMPMAT,SIGWMAT,GLOCMAT,DELWMAT,SIGIMAT,SIG0MAT,
     &     DELIMAT,BMASMAT,VRATMAT,WRATMAT,PRATMAT,ORATMAT,
     &     VRHBMAT,WRHBMAT,PRHBMAT,ORHBMAT,ETRAMAT,OTRAMAT,
     &     EINTGAL,ESTAHFK,ESTADBC,EGALHFK,EGALDBC,
     &     UIMP,UPAR,GPAR,FSLT,IERR)
************************************************************
*  Subroutine solves Anderson impurity model for given     *
*  hybridization function Delta(iWn)                       *
*  Returns Sigma(w),Sigma(0),Sigma(inf) as well as         *
*  rational interpolation coefficients for the self-energy * 
************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                    !!! from setup
      USE COM_CONTROL ,ONLY: LIFT,LMTO,IDMF                             !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS,ILSB            !!! from readini
      USE COM_MSBMESH ,ONLY: TEMP,NMSB,NMSL,NOMG,WMIN,WMAX,
     &                       OBND,NMSC,WMSC,FMSC,KGRD                   !!! from readhub
	USE COM_IMPDAT  ,ONLY: NRUNIMP,KSTATES,KCRDSYS,NPOLIMP,NPLDIMP 
     &                      ,IMPSECT,IMPINFO,IMPDATA,IMPWORK            !!! from readhub
      USE COM_HUBDAT  ,ONLY: MCRL,LCRL,PDMP,KSOLVER,KSIGMOO,KIMPLEV,
     &                       KDBLCNT,CDBLCNT,KDELINT                    !!! from readhub
      USE COM_QMCPAR  ,ONLY: MODR                                       !!! from readqmc
      USE COM_LSHELL  ,ONLY: LORB,HMAG,HORB,ALSC,ELEV,FSLA,KSYS 
     &                      ,DAMP,NRUNSHL,KSTSHL
      USE COM_IMPGRF  ,ONLY: CHEM,FILL,KFRM,KVRB,GLOC,DELW,
     &                       NRAT,NPOL,NMOM,GMOM,DMAT,PMAT,BATH,
     &                       SIGI,SRAT,VRAT,WRAT,PRAT,ORAT,DTRM,RTRM,
     &                       SIGW,SIG0,BMAS,KRAT,KINT,NPLD,KDIN,KDRT
      USE COM_FERMI   ,ONLY: EF                                         !!! from ttrints
      USE COM_LMTOUT  ,ONLY: SCRFILE                                    !!! from readini
      USE COM_QMCOUT  ,ONLY: ICGRF,ICQMC,QMCFILE,ICQMS,QMSFILE          !!! from readqmc
      USE COM_QMCEXT  ,ONLY: EXTNQMC,EXTNQMS                            !!! from setup
      USE COM_MASHDEP ,ONLY: NVAL,LENCMP                                !!! from setup
      USE COM_CHANNELS,ONLY: IUINP                                      !!! from channels
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                            !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 UIMP(2*(2*L+1),2*(2*L+1),2*(2*L+1),2*(2*L+1))
	COMPLEX*16 BATHMAT(0:NMSCMEM+1,2*(2*L+1),2*(2*L+1))
     &          ,DELWMAT(0:NMSCMEM+1,2*(2*L+1),2*(2*L+1))
     &          ,SIGWMAT(0:NMSCMEM+1,2*(2*L+1),2*(2*L+1))
     &          ,GLOCMAT(0:NMSCMEM+1,2*(2*L+1),2*(2*L+1))
     &          ,DHUBMAT(         2*(2*L+1),2*(2*L+1))
     &          ,VDBCMAT(         2*(2*L+1),2*(2*L+1))
     &          ,SIGIMAT(         2*(2*L+1),2*(2*L+1))
     &          ,SIG0MAT(         2*(2*L+1),2*(2*L+1))
     &          ,DELIMAT(         2*(2*L+1),2*(2*L+1))
     &          ,BMASMAT(         2*(2*L+1),2*(2*L+1))
     &          ,EIMPMAT(         2*(2*L+1),2*(2*L+1))
     &          ,ELOCMAT(         2*(2*L+1),2*(2*L+1))
     &          ,OIMPMAT(         2*(2*L+1),2*(2*L+1))
     &          ,VRATMAT(         2*(2*L+1),2*(2*L+1),NPOLMEM)
     &          ,WRATMAT(         2*(2*L+1),2*(2*L+1),NPOLMEM)
     &          ,PRATMAT(         2*(2*L+1),2*(2*L+1),NPOLMEM)
     &          ,ORATMAT(         2*(2*L+1),2*(2*L+1),NPOLMEM)
     &          ,VRHBMAT(         2*(2*L+1),2*(2*L+1),NPLDMEM)
     &          ,WRHBMAT(         2*(2*L+1),2*(2*L+1),NPLDMEM)
     &          ,PRHBMAT(         2*(2*L+1),2*(2*L+1),NPLDMEM)
     &          ,ORHBMAT(         2*(2*L+1),2*(2*L+1),NPLDMEM)
     &          ,ETRAMAT(         2*(2*L+1),2*(2*L+1))
     &          ,OTRAMAT(         2*(2*L+1),2*(2*L+1))
C Local allocatable arrays
      INTEGER, ALLOCATABLE :: LREP(:),KDREP(:)
	REAL*8, ALLOCATABLE :: ELOC(:,:),EINP(:,:),ELDA(:,:)
	REAL*8, ALLOCATABLE :: DELV(:,:),DELB(:,:),EBATH(:,:),VBATH(:,:)
      COMPLEX*16, ALLOCATABLE :: VDBNMAT(:,:),GINV(:,:),SIGA(:,:,:)
      COMPLEX*16, ALLOCATABLE :: WORK(:)
	CHARACTER*150, ALLOCATABLE :: QMCDATA(:),QMCCOPY(:)
	REAL*8 ZAVRSCF(2),ZOCCSCF(2),ZAVRIMP(2),ZOCCIMP(2),ERAT(14)
     &      ,FSLT(0:3)
	COMPLEX*16 DIM,ZMSC,GMSB,CAVR
	CHARACTER HELP*40,TCTRL*10,LIB_TDP*10,FILE*130
	CHARACTER STRING*150,INF*130
	LOGICAL EXIST,MODIFIED,DEF,ASK,VAL,NTH
      DATA PI/3.141592653589793D0/,DIM/(0.D0,1.D0)/,EPSDEG/1.D-05/
      CALL ABORTNOW()
	IERR=0
	ISORT=IS(IATOM)
	NDIM=2*(2*L+1)
	EFRM=EF
	CHEM=EF
      LORB=L
C MEMORY ALLOCATIONS
      ALLOCATE(IMPWORK(1))
      ALLOCATE(LREP(NDIM))
      ALLOCATE(KDREP(NDIM))
      ALLOCATE(VDBNMAT(NDIM,NDIM))
C ********************************
C Get QMCFILE name
      HELP='! Path to QMCFile                       '
      LHLP=40
	IF(IMPINFO(L,IATOM).EQ.0)
     &CALL FULLSTOP('<IMP_IMPQMC>:: IMPINFO is empty')
      IMPWORK(1)=IMPDATA(1,L,IATOM)
	CALL READ_CHAR(IMPDATA(1,L,IATOM),IMPWORK(1),1,1,
     &'qmcfile',7,IN,1,0,RE,1,0,CM,1,0,FILE,130,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
      CALL LIB_CONVLOW(FILE,130)
      CALL LIB_RMBLANK(FILE,130)
      CALL FIND_LBLANK(FILE,130,NBP)
      CALL FIND_LBLANK(EXTNQMC,60,NBE)
	QMCFILE=FILE(:NBP)//'.'//EXTNQMC(:NBE)
	INQUIRE(FILE=QMCFILE,EXIST=EXIST)
	IF(.NOT.EXIST)CALL FULLSTOP('<QMCFILE> not found!')
C ********************************
C UNDERSTAND THE LENGHT OF QMCFILE
	CALL FILE_LENGHT(QMCFILE,NLEN,IUINP)
	ALLOCATE(QMCDATA(NLEN))
C ********************************
C READ INIFILE TO INTERNAL FILE
	OPEN(UNIT=IUINP,FILE=QMCFILE,STATUS='OLD',FORM='FORMATTED')
	DO ILEN=1,NLEN
	READ(IUINP,FMT='(A150)')QMCDATA(ILEN)
	ENDDO
	CLOSE(IUINP)
C ********************************
C UNDERSTAND INPUT: CLASSIC or MODERN
	STRING=QMCDATA(1)
	CALL LIB_CONVLOW(STRING,150)
	CALL LIB_RMBLANK(STRING,150)
	MODERN=0
	DO IPOS=1,80
	IF(STRING(IPOS:IPOS+11).EQ.'input=modern')MODERN=2
	IF(MODERN.NE.0)EXIT
	ENDDO
	IF(MODERN.EQ.2)MODIFIED=.TRUE. 
	IF(MODERN.NE.2)CALL FULLSTOP('<QMCFILE> format not recognized!')
C SAVE CONTROLS
      NMSB0=NMSB
      NOMG0=NOMG
      NMSC0=NMSC
      NMSL0=NMSL
      TEMP0=TEMP
      OBND0=OBND
      WMIN0=WMIN
      WMAX0=WMAX
      LORB0=LORB
      KGRD0=KGRD
C READ CONTROL DATA
	CALL QMC_READQMC_CTRL(QMCDATA,NLEN)
C READ DMFT SETTINGS
	CALL QMC_READQMC_DMFT(QMCDATA,NLEN)
C READ SHELL INFORMATION
	CALL QMC_READQMC_SHEL(QMCDATA,NLEN)
C READ QMC SETUP           
	CALL QMC_READQMC_SETS(QMCDATA,NLEN)
C CHECK CONTROLS
      IF(KSYS.NE.KCRDSYS(L,IATOM))
     &CALL FULLSTOP('<QMCFILE>:  Coordinate system mismatch')
      IF(LORB0.NE.LORB)
     &CALL FULLSTOP('<QMCFILE>: Lorb mismatch')
      DO L0=0,LORB
      IF(ABS(FSLT(L0)-FSLA(L0)).GT.1.D-10)
     &CALL FULLSTOP('<QMCFILE>: Slater integrals mismatch')
      ENDDO
      IF(NPOL.NE.NPOLIMP(L,IATOM))
     &CALL FULLSTOP('<QMCFILE>: nPol mismatch')
      IF(NRUNIMP(L,IATOM).NE.NRUNSHL)
     &CALL FULLSTOP('<QMCFILE>: NrunSHL mismatch')
      DO IRUN=1,NRUNIMP(L,IATOM)
      DO IDIM=1,NDIM
      IF(KSTATES(IDIM,IRUN,L,IATOM).NE.KSTSHL(IDIM,IRUN))
     &CALL FULLSTOP('<QMCFILE>: KstSHL(:) mismatch')
      ENDDO
      ENDDO
      NMSB=NMSB0
      NOMG=NOMG0
      NMSC=NMSC0
      NMSL=NMSL0
      TEMP=TEMP0
      OBND=OBND0
      WMIN=WMIN0
      WMAX=WMAX0
      KGRD=KGRD0
C *******************************************************
C Reset controls
      KFRM=1                   ! do NOT search chemical potential
      KVRB=0                   ! switch off various printouts
	EFRM=EF                  ! Fermi level
	CHEM=EF                  ! Fermi level
	DAMP=PDMP                ! damping in cluster Green function calculation
C Transform impurity levels to KSYS representation
      CALL LIB_TRANSMAT(NDIM,+KSYS,NDIM,+KSYS,ELEV(1,1),
     &     OTRAMAT,ETRAMAT)
C *******************************************
C ZEROISE NEW DOUBLE COUNTING
      DO IDIM1=1,NDIM
      DO IDIM =1,NDIM
      VDBNMAT(IDIM1,IDIM)=(0.D0,0.D0)
      ENDDO
      ENDDO
C  DO OVER SOLUTIONS OF IMPURITY PROBLEM
      DO 1000 IRUN=1,NRUNIMP(L,IATOM)
      CALL IMP_COMBREP(L,IATOM,IRUN,NDEG,MSPIN,NREP,LREP,KDREP)
	ALLOCATE(ELOC(NREP,MSPIN))
	ALLOCATE(EINP(NREP,MSPIN))
	ALLOCATE(DELV(NREP,MSPIN))
	ALLOCATE(DELB(NREP,MSPIN))
	ALLOCATE(ELDA(NREP,MSPIN))
C Set input impurity levels
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.0)CYCLE
	IREP=KDREP(IDIM)
	ISPIN=(2*IDIM-1)/NDIM+1
	IF(MSPIN.EQ.1)ISPIN=1
	EINP(IREP,ISPIN)=ELEV(IDIM,IDIM)
	ENDDO
C ********************************************
C Occupancies
	DO ISPIN=1,MSPIN
	ZOCCSCF(ISPIN)=0.D0
	ENDDO
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.0)CYCLE
	IREP=KDREP(IDIM)
	ISPIN=(2*IDIM-1)/NDIM+1
	IF(MSPIN.EQ.1)ISPIN=1
	ZOCCSCF(ISPIN)=ZOCCSCF(ISPIN)+DHUBMAT(IDIM,IDIM)
	ENDDO
	DO ISPIN=1,MSPIN
	ZAVRSCF(ISPIN)=ZOCCSCF(ISPIN)
	ENDDO
C Average occupancies for spin restricted double countings
	ZOCCAVR=(ZAVRSCF(1)+ZAVRSCF(MSPIN))/2.D0
	ZAVRSCF(1)=ZOCCAVR
	ZAVRSCF(MSPIN)=ZOCCAVR
C ******************************************************************
C A new guess for the double counting will replace the Hartree shift
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.0)CYCLE
	IREP=KDREP(IDIM)
	ISPIN=(2*IDIM-1)/NDIM+1
	IF(MSPIN.EQ.1)ISPIN=1
	IF(ISPIN.EQ.1)ISPINM=MSPIN
	IF(ISPIN.EQ.MSPIN)ISPINM=1
C New double counting is the old one
	VDBNMAT(IDIM,IDIM)=VDBCMAT(IDIM,IDIM)
C Unless it can be guessed immideately in some cases
	IF(KDBLCNT(L,IATOM).EQ.11)
     &VDBNMAT(IDIM,IDIM)=UPAR*ZOCCSCF(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZOCCSCF(ISPIN)/2.D0*DBLE(MSPIN)-(UPAR-GPAR)*
     &CDBLCNT(L,IATOM)
	IF(KDBLCNT(L,IATOM).EQ.12)
     &VDBNMAT(IDIM,IDIM)=UPAR*ZAVRSCF(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZAVRSCF(ISPIN)/2.D0*DBLE(MSPIN)-(UPAR-GPAR)*
     &CDBLCNT(L,IATOM)
	IF(KDBLCNT(L,IATOM).EQ.21)
     &VDBNMAT(IDIM,IDIM)=UPAR*ZOCCSCF(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZOCCSCF(ISPIN)/2.D0*DBLE(MSPIN)-(UPAR-GPAR)*
     &ZOCCSCF(ISPIN)/2.D0*DBLE(MSPIN)/(DBLE(NDEG)/2.D0)
	IF(KDBLCNT(L,IATOM).EQ.22)
     &VDBNMAT(IDIM,IDIM)=UPAR*ZAVRSCF(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZAVRSCF(ISPIN)/2.D0*DBLE(MSPIN)-(UPAR-GPAR)*
     &ZAVRSCF(ISPIN)/2.D0*DBLE(MSPIN)/(DBLE(NDEG)/2.D0)
	ENDDO
C ************************************************************
C SET ELOCs
	IF(KIMPLEV(L,IATOM)/10.EQ.1.OR.KIMPLEV(L,IATOM)/10.EQ.2)THEN
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.0)CYCLE
	IREP=KDREP(IDIM)
	ISPIN=(2*IDIM-1)/NDIM+1
	IF(MSPIN.EQ.1)ISPIN=1
C Eloc is Elda-Vdc but due to overlap, the expression is more complicated
C Notice that Eimp=o(Elda-Vdc+SigI)o
C Notice that we plug in new double counting here
      IF(KIMPLEV(L,IATOM)/10.EQ.1)
     &ELOC(IREP,ISPIN)=EIMPMAT(IDIM,IDIM)-VDBNMAT(IDIM,IDIM)-CHEM-
     &(SIGIMAT(IDIM,IDIM)-VDBCMAT(IDIM,IDIM))
C Eloc can be just -U(n-1/2) if Elda=Ef or if valence needs to be fixed
      IF(KIMPLEV(L,IATOM)/10.EQ.2)
     &ELOC(IREP,ISPIN)=-VDBNMAT(IDIM,IDIM)
	ENDDO
C Average level position
      EINPAVR=0.D0
	ELOCAVR=0.D0
	DO IREP=1,NREP
	DO ISPIN=1,MSPIN
      EINPAVR=EINPAVR+EINP(IREP,ISPIN)
	ELOCAVR=ELOCAVR+ELOC(IREP,ISPIN)
	ENDDO
	ENDDO
	EINPAVR=EINPAVR/DBLE(NREP)/DBLE(MSPIN)
      ELOCAVR=ELOCAVR/DBLE(NREP)/DBLE(MSPIN)
C Freeze spin splittings
	DO IREP=1,NREP
      IF(MOD(KIMPLEV(L,IATOM),10).EQ.1)
     &BLOCAVR=(ELOC(IREP,1)-ELOC(IREP,MSPIN))/2.D0
      IF(MOD(KIMPLEV(L,IATOM),10).EQ.2)
     &BLOCAVR=(EINP(IREP,1)-EINP(IREP,MSPIN))/2.D0
      DELB(IREP,1)    =+BLOCAVR
      DELB(IREP,MSPIN)=-BLOCAVR
	ENDDO
C Freeze crf splittings
	DO ISPIN=1,MSPIN
	DO IREP=1,NREP
	IF(MOD(KIMPLEV(L,IATOM),10).EQ.1)
     &DELV(IREP,ISPIN)=(ELOC(IREP,1)+ELOC(IREP,MSPIN))/2.D0-ELOCAVR
      IF(MOD(KIMPLEV(L,IATOM),10).EQ.2)
     &DELV(IREP,ISPIN)=(EINP(IREP,1)+EINP(IREP,MSPIN))/2.D0-EINPAVR
	ENDDO
	ENDDO
C Set local levels
	DO ISPIN=1,MSPIN
	DO IREP=1,NREP
	ELOC(IREP,ISPIN)=ELOCAVR+DELV(IREP,ISPIN)+
     &                         DELB(IREP,ISPIN)
	ENDDO
	ENDDO
C Eloc is given by input
	ELSEIF(KIMPLEV(L,IATOM)/10.EQ.3)THEN
	IF(IMPINFO(L,IATOM).EQ.0)CALL FULLSTOP('Eloc not set')
	DO IREP=1,NREP
	DO ISPIN=1,MSPIN
	ELOC(IREP,ISPIN)=EINP(IREP,ISPIN)
	ENDDO
	ENDDO
	ENDIF
C ***********************************************
C Set Mean Field (LDA) position of impurity level
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.0)CYCLE
	IREP=KDREP(IDIM)
	ISPIN=(2*IDIM-1)/NDIM+1
	IF(MSPIN.EQ.1)ISPIN=1
	ELDA(IREP,ISPIN)=EIMPMAT(IDIM,IDIM)-
     &(SIGIMAT(IDIM,IDIM)-VDBCMAT(IDIM,IDIM))
	ENDDO
C Average LDA levels if paramagnetic double counting is working
	IF(MOD(KDBLCNT(L,IATOM),2).EQ.0)THEN
	DO IREP=1,NREP
	ELDAAVR=(ELDA(IREP,1)+ELDA(IREP,MSPIN))/2.D0
	ELDA(IREP,1)=ELDAAVR
	ELDA(IREP,MSPIN)=ELDAAVR
	ENDDO
	ENDIF
C **********************************************************
C Double counting according to Eloc can be set now
	IF(KDBLCNT(L,IATOM).EQ.40)THEN
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.0)CYCLE
	IREP=KDREP(IDIM)
	ISPIN=(2*IDIM-1)/NDIM+1
	IF(MSPIN.EQ.1)ISPIN=1
      VDBNMAT(IDIM,IDIM)=ELDA(IREP,ISPIN)-CHEM-ELOC(IREP,ISPIN)
	ENDDO
      ENDIF
C *********************************************
C Reset Impurity levels
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.0)CYCLE
	IREP=KDREP(IDIM)
	ISPIN=(2*IDIM-1)/NDIM+1
	IF(MSPIN.EQ.1)ISPIN=1
	ELEV(IDIM,IDIM)=ELOC(IREP,ISPIN)      ! QMC solver assumes not shifted Eloc
	ENDDO
C Memory deallocations
	DEALLOCATE(ELOC,EINP,DELV,DELB,ELDA)
 1000 CONTINUE
C Shift all impurity levels by the chemical potential
	DO IDIM=1,NDIM
	ELEV(IDIM,IDIM)=ELEV(IDIM,IDIM)+CHEM  ! QMC solver assumes not shifted Eloc
	ENDDO
C *********************************************
C Memory allocations for QMC arrays
      CALL QMC_ALLOCATE('A')
C SET UP TRANSFORMATION MATRICES
      DO IDIM1=1,NDIM
      DO IDIM=1,NDIM
      DTRM(IDIM1,IDIM)=OTRAMAT(IDIM1,IDIM)
      RTRM(IDIM1,IDIM)=ETRAMAT(IDIM1,IDIM)
      ENDDO
      ENDDO
      DO IDIM1=1,NDIM
      DO IDIM =1,NDIM
      DO IMSC=0,NMSC
      BATH(IDIM1,IDIM,IMSC)=BATHMAT(IMSC,IDIM1,IDIM)
      DELW(IDIM1,IDIM,IMSC)=DELWMAT(IMSC,IDIM1,IDIM)
      SIGW(IDIM1,IDIM,IMSC)=(0.D0,0.D0)
      GLOC(IDIM1,IDIM,IMSC)=(0.D0,0.D0)
      ENDDO
      DO IPOL=1,NPOL
      VRAT(IDIM1,IDIM,IPOL)=(0.D0,0.D0)
      WRAT(IDIM1,IDIM,IPOL)=(0.D0,0.D0)
      PRAT(IDIM1,IDIM,IPOL)=(0.D0,0.D0)
      ORAT(IDIM1,IDIM,IPOL)=(0.D0,0.D0)
      ENDDO
      ENDDO
      ENDDO
C Transform matrices back to spherical harmonics
      CALL LIB_TRANSMAT(NDIM,-KSYS,NDIM,-KSYS,ELEV(1,1),
     &     OTRAMAT,ETRAMAT)
      DO IMSC=0,NMSC
      CALL LIB_TRANSMAT(NDIM,-KSYS,NDIM,-KSYS,DELW(1,1,IMSC),
     &     OTRAMAT,ETRAMAT)
      CALL LIB_TRANSMAT(NDIM,-KSYS,NDIM,-KSYS,BATH(1,1,IMSC),
     &     OTRAMAT,ETRAMAT)
      ENDDO
C *************************************
C IMPURITY QMC WITH YIFENG YANG PROGRAM
      IF(MODR/10.EQ.1)CALL QMC_QMCYIF
C *************************************
C COMPUTE RATIONAL FORM FOR SELF-ENERGY
	CALL IMP_SIGRAT
C Transform matrices to local representation
      CALL LIB_TRANSMAT(NDIM,+KSYS,NDIM,+KSYS,ELEV(1,1),
     &     OTRAMAT,ETRAMAT)
      CALL LIB_TRANSMAT(NDIM,+KSYS,NDIM,+KSYS,SIGI(1,1),
     &     OTRAMAT,ETRAMAT)
      CALL LIB_TRANSMAT(NDIM,+KSYS,NDIM,+KSYS,SRAT(1,1),
     &     OTRAMAT,ETRAMAT)
      CALL LIB_TRANSMAT(NDIM,+KSYS,NDIM,+KSYS,DMAT(1,1,0),
     &     OTRAMAT,ETRAMAT)
      DO IMSC=0,NMSC
      CALL LIB_TRANSMAT(NDIM,+KSYS,NDIM,+KSYS,DELW(1,1,IMSC),
     &     OTRAMAT,ETRAMAT)
      CALL LIB_TRANSMAT(NDIM,+KSYS,NDIM,+KSYS,BATH(1,1,IMSC),
     &     OTRAMAT,ETRAMAT)
      CALL LIB_TRANSMAT(NDIM,+KSYS,NDIM,+KSYS,GLOC(1,1,IMSC),
     &     OTRAMAT,ETRAMAT)
      CALL LIB_TRANSMAT(NDIM,+KSYS,NDIM,+KSYS,SIGW(1,1,IMSC),
     &     OTRAMAT,ETRAMAT)
      ENDDO
	DO IPOL=1,NPOL
      CALL LIB_TRANSMAT(NDIM,+KSYS,NDIM,+KSYS,VRAT(1,1,IPOL),
     &     OTRAMAT,ETRAMAT)
      CALL LIB_TRANSMAT(NDIM,+KSYS,NDIM,+KSYS,WRAT(1,1,IPOL),
     &     OTRAMAT,ETRAMAT)
      CALL LIB_TRANSMAT(NDIM,+KSYS,NDIM,+KSYS,PRAT(1,1,IPOL),
     &     OTRAMAT,ETRAMAT)
      CALL LIB_TRANSMAT(NDIM,+KSYS,NDIM,+KSYS,ORAT(1,1,IPOL),
     &     OTRAMAT,ETRAMAT)
      ENDDO
C *********************************************************************** 
C ZEROISE OUTPUT ARRAYS
      DO IDIM1=1,NDIM
      DO IDIM =1,NDIM
      SIGIMAT(IDIM1,IDIM)=(0.D0,0.D0)
      SIG0MAT(IDIM1,IDIM)=(0.D0,0.D0)
      BMASMAT(IDIM1,IDIM)=(0.D0,0.D0)
      ELOCMAT(IDIM1,IDIM)=(0.D0,0.D0)
C     VDBCMAT(IDIM1,IDIM)=(0.D0,0.D0)  ! do not zeroise double counting !
      DO IMSC=0,NMSC+1
      SIGWMAT(IMSC,IDIM1,IDIM)=(0.D0,0.D0)
      ENDDO
      ENDDO
      ENDDO
C  DO OVER SOLUTIONS OF IMPURITY PROBLEM
      DO 2000 IRUN=1,NRUNIMP(L,IATOM)
      CALL IMP_COMBREP(L,IATOM,IRUN,NDEG,MSPIN,NREP,LREP,KDREP)
C Occupancies from LDA+DMFT
	DO ISPIN=1,MSPIN
	ZOCCSCF(ISPIN)=0.D0
	ENDDO
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.0)CYCLE
	IREP=KDREP(IDIM)
	ISPIN=(2*IDIM-1)/NDIM+1
	IF(MSPIN.EQ.1)ISPIN=1
	ZOCCSCF(ISPIN)=ZOCCSCF(ISPIN)+DHUBMAT(IDIM,IDIM)
	ENDDO
	DO ISPIN=1,MSPIN
	ZAVRSCF(ISPIN)=ZOCCSCF(ISPIN)
	ENDDO
C Average occupancies for spin restricted double countings
	ZOCCAVR=(ZAVRSCF(1)+ZAVRSCF(MSPIN))/2.D0
	ZAVRSCF(1)=ZOCCAVR
	ZAVRSCF(MSPIN)=ZOCCAVR
C New Occupancies for the Impurity
	DO ISPIN=1,MSPIN
	ZOCCIMP(ISPIN)=0.D0
	ENDDO
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.0)CYCLE
	ISPIN=(2*IDIM-1)/NDIM+1
	IF(MSPIN.EQ.1)ISPIN=1
	ZOCCIMP(ISPIN)=ZOCCIMP(ISPIN)+DMAT(IDIM,IDIM,0)
	ENDDO
	DO ISPIN=1,MSPIN
	ZAVRIMP(ISPIN)=ZOCCIMP(ISPIN)
	ENDDO
C Average occupancies in case of spin restricted double countings
	ZOCCAVR=(ZAVRIMP(1)+ZAVRIMP(MSPIN))/2.D0
	ZAVRIMP(1)=ZOCCAVR
	ZAVRIMP(MSPIN)=ZOCCAVR
C ***********************************************************************
C SELF-ENERGY AT INFINITY CAN BE SET ACCORDING TO THE CURRENT OCCUPANCIES
C In general we have four ways of dealing with it, (1) by using 
C full density matrix coming from LDA or (2) exact diagonalization
C or using average occupancy matrices, cases (3) and (4)
      ALLOCATE(SIGA(NDIM,NDIM,6))
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.0)CYCLE
	ISPIN=(2*IDIM-1)/NDIM+1
	IF(MSPIN.EQ.1)ISPIN=1
	IF(ISPIN.EQ.1)ISPINM=MSPIN
	IF(ISPIN.EQ.MSPIN)ISPINM=1
	DO IDIM1=1,NDIM
	IF(KSTATES(IDIM1,IRUN,L,IATOM).EQ.0)CYCLE
	ISPIN1=(2*IDIM1-1)/NDIM+1
	IF(MSPIN.EQ.1 )ISPIN1=1
	IF(ISPIN1.EQ.1)ISPIN1M=MSPIN
	IF(ISPIN1.EQ.MSPIN)ISPIN1M=1
      SIGA(IDIM,IDIM1,1)=(0.D0,0.D0)
      SIGA(IDIM,IDIM1,2)=(0.D0,0.D0)
      SIGA(IDIM,IDIM1,3)=(0.D0,0.D0)
      SIGA(IDIM,IDIM1,4)=(0.D0,0.D0)
      SIGA(IDIM,IDIM1,5)=(0.D0,0.D0)
      SIGA(IDIM,IDIM1,6)=(0.D0,0.D0)
	IF(IDIM.EQ.IDIM1)ONE=1.D0
	IF(IDIM.NE.IDIM1)ONE=0.D0
	DO JDIM=1,NDIM
	IF(KSTATES(JDIM,IRUN,L,IATOM).EQ.0)CYCLE
	DO JDIM1=1,NDIM
	IF(KSTATES(JDIM1,IRUN,L,IATOM).EQ.0)CYCLE
C Matrix case
      SIGA(IDIM,IDIM1,1)=SIGA(IDIM,IDIM1,1)+
     &(UIMP(IDIM,JDIM,IDIM1,JDIM1)-UIMP(IDIM,JDIM,JDIM1,IDIM1))*
     &DHUBMAT(JDIM,JDIM1)
      SIGA(IDIM,IDIM1,2)=SIGA(IDIM,IDIM1,2)+
     &(UIMP(IDIM,JDIM,IDIM1,JDIM1)-UIMP(IDIM,JDIM,JDIM1,IDIM1))*
     &DMAT(JDIM,JDIM1,0)
	ENDDO
	ENDDO
C SU(N) case
      SIGA(IDIM,IDIM1,3)=UPAR*ZOCCSCF(ISPINM)/2.D0*DBLE(MSPIN)*ONE+
     &(UPAR-GPAR)*(ZOCCSCF(ISPIN)/2.D0*DBLE(MSPIN)*ONE-
     & DHUBMAT(IDIM,IDIM1))*ONE
      SIGA(IDIM,IDIM1,4)=UPAR*ZOCCIMP(ISPINM)/2.D0*DBLE(MSPIN)*ONE+
     &(UPAR-GPAR)*(ZOCCIMP(ISPIN)/2.D0*DBLE(MSPIN)*ONE-
     & DMAT(IDIM,IDIM1,0))*ONE
C Other cases
      SIGA(IDIM,IDIM1,5)=0.5D0*(SIGW(IDIM,IDIM1,NMSC)
     &                  +DCONJG(SIGW(IDIM1,IDIM,NMSC)))
      SIGA(IDIM,IDIM1,6)=SIGIMAT(IDIM,IDIM1)
	ENDDO
	ENDDO
C RESET SELF-ENERGY AT INFINITY: 
C Note that it is probably better to use average occupancies and interactions
C than exact Coulomb and density matrices due to well known problem of Hartree
C term and full potential LDA taking care of those. 
C Therefore only cases (3) and (4) apply below
	DO IDIM1=1,NDIM
	IF(KSTATES(IDIM1,IRUN,L,IATOM).EQ.0)CYCLE
	ISPIN1=(2*IDIM1-1)/NDIM+1
	IF(MSPIN.EQ.1 )ISPIN1=1
	IF(ISPIN1.EQ.1)ISPIN1M=MSPIN
	IF(ISPIN1.EQ.MSPIN)ISPIN1M=1
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.0)CYCLE
	ISPIN=(2*IDIM-1)/NDIM+1
	IF(MSPIN.EQ.1)ISPIN=1
	IF(ISPIN.EQ.1)ISPINM=MSPIN
	IF(ISPIN.EQ.MSPIN)ISPINM=1
	IF(IDIM1.EQ.IDIM)ONE=1.D0
	IF(IDIM1.NE.IDIM)ONE=0.D0
C Reset Sigma(w)
	DO IMSC=0,NMSC                  ! over frequencies
	IF(KSIGMOO(L,IATOM).EQ.11)
     &SIGW(IDIM1,IDIM,IMSC)=SIGW(IDIM1,IDIM,IMSC)-
     &SIGI(IDIM1,IDIM)+SIGA(IDIM1,IDIM,1)
	IF(KSIGMOO(L,IATOM).EQ.12)
     &SIGW(IDIM1,IDIM,IMSC)=SIGW(IDIM1,IDIM,IMSC)-
     &SIGI(IDIM1,IDIM)+SIGA(IDIM1,IDIM,2)
	IF(KSIGMOO(L,IATOM).EQ.21)
     &SIGW(IDIM1,IDIM,IMSC)=SIGW(IDIM1,IDIM,IMSC)-
     &SIGI(IDIM1,IDIM)+SIGA(IDIM1,IDIM,3)
	IF(KSIGMOO(L,IATOM).EQ.22)
     &SIGW(IDIM1,IDIM,IMSC)=SIGW(IDIM1,IDIM,IMSC)-
     &SIGI(IDIM1,IDIM)+SIGA(IDIM1,IDIM,4)
	IF(KSIGMOO(L,IATOM).EQ.31)
     &SIGW(IDIM1,IDIM,IMSC)=SIGW(IDIM1,IDIM,IMSC)-
     &SIGI(IDIM1,IDIM)+SIGA(IDIM1,IDIM,5)
	IF(KSIGMOO(L,IATOM).EQ.41)
     &SIGW(IDIM1,IDIM,IMSC)=SIGW(IDIM1,IDIM,IMSC)-
     &SIGI(IDIM1,IDIM)+SIGA(IDIM1,IDIM,6)
      ENDDO
C Reset Sigma(oo)
	IF(KSIGMOO(L,IATOM).EQ.11)SIGI(IDIM1,IDIM)=SIGA(IDIM1,IDIM,1)
	IF(KSIGMOO(L,IATOM).EQ.12)SIGI(IDIM1,IDIM)=SIGA(IDIM1,IDIM,2)
	IF(KSIGMOO(L,IATOM).EQ.21)SIGI(IDIM1,IDIM)=SIGA(IDIM1,IDIM,3)
	IF(KSIGMOO(L,IATOM).EQ.22)SIGI(IDIM1,IDIM)=SIGA(IDIM1,IDIM,4)
	IF(KSIGMOO(L,IATOM).EQ.31)SIGI(IDIM1,IDIM)=SIGA(IDIM1,IDIM,5)
	IF(KSIGMOO(L,IATOM).EQ.41)SIGI(IDIM1,IDIM)=SIGA(IDIM1,IDIM,6)
C Reset Sigma(oo), rational fit
	IF(KSIGMOO(L,IATOM).EQ.11)SRAT(IDIM1,IDIM)=SIGA(IDIM1,IDIM,1)
	IF(KSIGMOO(L,IATOM).EQ.12)SRAT(IDIM1,IDIM)=SIGA(IDIM1,IDIM,2)
	IF(KSIGMOO(L,IATOM).EQ.21)SRAT(IDIM1,IDIM)=SIGA(IDIM1,IDIM,3)
	IF(KSIGMOO(L,IATOM).EQ.22)SRAT(IDIM1,IDIM)=SIGA(IDIM1,IDIM,4)
	IF(KSIGMOO(L,IATOM).EQ.31)SRAT(IDIM1,IDIM)=SIGA(IDIM1,IDIM,5)
	IF(KSIGMOO(L,IATOM).EQ.41)SRAT(IDIM1,IDIM)=SIGA(IDIM1,IDIM,6)
      ENDDO      
      ENDDO      
C SET OUTPUT ARRAYS
	ALLOCATE(GINV(NDEG,NDEG))
	ALLOCATE(WORK(NDEG))
	DO IMSC=0,NMSC                  ! over frequencies
	ZMSC=WMSC(IMSC)
	DO IDIM1=1,NDIM
	IF(KSTATES(IDIM1,IRUN,L,IATOM).EQ.0)CYCLE
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.0)CYCLE
	IF(IDMF.EQ.3)
     &SIGWMAT(IMSC,IDIM1,IDIM)=SIGW(IDIM1,IDIM,IMSC)
	IF(IDMF.EQ.4)
     &SIGWMAT(IMSC,IDIM1,IDIM)=SRAT(IDIM1,IDIM)
	IF(IDMF.EQ.5)
     &SIGWMAT(IMSC,IDIM1,IDIM)=SIGW(IDIM1,IDIM,IMSC)
      ENDDO
      ENDDO
C Force self-energy form as follows from pole expansion
	IF(IDMF.EQ.4)THEN
	DO IPOL=1,NPOL         ! over poles
	IDEG1=0
	DO IDIM1=1,NDIM
	IF(KSTATES(IDIM1,IRUN,L,IATOM).EQ.0)CYCLE
	IDEG1=IDEG1+1
	DO IDEG=0
	DO IDIM =1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.0)CYCLE
	IDEG=IDEG+1
	GINV(IDEG1,IDEG)=
     &(ZMSC+DCMPLX(0.D0,0.D0))*
     &ORAT(IDIM1,IDIM,IPOL)-PRAT(IDIM1,IDIM,IPOL)
	ENDDO
	ENDDO
C Invert matrix
	CALL LIB_CINV(NDEG,GINV,NDEG,WORK,IFAIL)
	IF(IFAIL.NE.0)THEN
      WRITE(IUN,*)'<IMP_IMPRATF>:: Error in inversion program'
	DO IDEG1=1,NDEG
	DO IDEG =1,NDEG
	GINV(IDEG1,IDEG)=(0.D0,0.D0)
	ENDDO
	ENDDO
	ENDIF
C Construct product
	DO IDIM1=1,NDIM
	IF(KSTATES(IDIM1,IRUN,L,IATOM).EQ.0)CYCLE
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.0)CYCLE
	JDEG1=0
	DO JDIM1=1,NDIM
	IF(KSTATES(JDIM1,IRUN,L,IATOM).EQ.0)CYCLE
	JDEG1=JDEG1+1
	JDEG=0
	DO JDIM=1,NDIM
	IF(KSTATES(JDIM,IRUN,L,IATOM).EQ.0)CYCLE
	JDEG=JDEG+1
      SIGWMAT(IMSC,IDIM1,IDIM)=SIGWMAT(IMSC,IDIM1,IDIM)+
     &VRAT(IDIM1,JDIM1,IPOL)*GINV(JDEG1,JDEG)*WRAT(JDIM,IDIM,IPOL) ! swapped indexes in Warr !
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO                           ! over poles
	ENDIF
	ENDDO                           ! over frequencies
C
	DO IDIM1=1,NDIM
	IF(KSTATES(IDIM1,IRUN,L,IATOM).EQ.0)CYCLE
	IREP1=KDREP(IDIM1)
	ISPIN1=(2*IDIM1-1)/NDIM+1
	IF(MSPIN.EQ.1)ISPIN1=1
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.0)CYCLE
	IREP=KDREP(IDIM)
	ISPIN=(2*IDIM-1)/NDIM+1
	IF(MSPIN.EQ.1)ISPIN=1
	IF(IDIM1.EQ.IDIM)ONE=1.D0
	IF(IDIM1.NE.IDIM)ONE=0.D0
C Set self-energy at infinity
      IF(IDMF.EQ.3)
     &SIGIMAT(IDIM1,IDIM)=SIGI(IDIM1,IDIM)
      IF(IDMF.EQ.4)
     &SIGIMAT(IDIM1,IDIM)=SRAT(IDIM1,IDIM)
      IF(IDMF.EQ.5)
     &SIGIMAT(IDIM1,IDIM)=SIGI(IDIM1,IDIM)
C Set self-energy at zero
	IF(IDMF.EQ.3)
     &SIG0MAT(IDIM1,IDIM)=DREAL(SIGW(IDIM1,IDIM,0))
	IF(IDMF.EQ.4)
     &SIG0MAT(IDIM1,IDIM)=DREAL(SIGW(IDIM1,IDIM,0))
	IF(IDMF.EQ.5)  ! do not reset this value
     &SIG0MAT(IDIM1,IDIM)=SIG0MAT(IDIM1,IDIM)
C Set mass renormalization to zero
      BMASMAT(IDIM1,IDIM)=(0.D0,0.D0)
C Set bare impurity levels
      ELOCMAT(IDIM1,IDIM)=ELEV(IDIM1,IDIM)-CHEM*ONE
C Set rational interpolation coefficients
	DO IPOL=1,NPOL
	VRATMAT(IDIM1,IDIM,IPOL)=VRAT(IDIM1,IDIM,IPOL)
	WRATMAT(IDIM1,IDIM,IPOL)=WRAT(IDIM1,IDIM,IPOL)
	PRATMAT(IDIM1,IDIM,IPOL)=PRAT(IDIM1,IDIM,IPOL)
C    &                   +CHEM*ORAT(IDIM1,IDIM,IPOL)
	ORATMAT(IDIM1,IDIM,IPOL)=ORAT(IDIM1,IDIM,IPOL)
	ENDDO
	DO IPOL=NPOL+1,NPOLIMP(L,IATOM)
	VRATMAT(IDIM1,IDIM,IPOL)=(0.D0,0.D0)
	WRATMAT(IDIM1,IDIM,IPOL)=(0.D0,0.D0)
	PRATMAT(IDIM1,IDIM,IPOL)=DCMPLX(ONE,0.D0)
	ORATMAT(IDIM1,IDIM,IPOL)=DCMPLX(ONE,0.D0)
	ENDDO
C *****************************
C Set double counting potential
	IF(ISPIN.EQ.1)ISPINM=MSPIN
	IF(ISPIN.EQ.MSPIN)ISPINM=1
C 00  Keep this array untouched
	IF(KDBLCNT(L,IATOM).EQ.0)
     &VDBCMAT(IDIM1,IDIM)=VDBCMAT(IDIM1,IDIM)
C 11. Fully localized spin polarized limit with Nscf was set
	IF(KDBLCNT(L,IATOM).EQ.11.AND.IDIM1.EQ.IDIM)
     &VDBCMAT(IDIM1,IDIM)=UPAR*ZOCCSCF(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZOCCSCF(ISPIN)/2.D0*DBLE(MSPIN)-(UPAR-GPAR)*
     &CDBLCNT(L,IATOM)
C 12. Fully localized spin restricted limit with Nscf was set
	IF(KDBLCNT(L,IATOM).EQ.12.AND.IDIM1.EQ.IDIM)
     &VDBCMAT(IDIM1,IDIM)=UPAR*ZAVRSCF(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZAVRSCF(ISPIN)/2.D0*DBLE(MSPIN)-(UPAR-GPAR)*
     &CDBLCNT(L,IATOM)
C 13. Fully localized spin polarized limit with Nimp
	IF(KDBLCNT(L,IATOM).EQ.13.AND.IDIM1.EQ.IDIM)
     &VDBCMAT(IDIM1,IDIM)=UPAR*ZOCCIMP(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZOCCIMP(ISPIN)/2.D0*DBLE(MSPIN)-(UPAR-GPAR)*
     &CDBLCNT(L,IATOM)
C 14. Fully localized spin restricted limit with Nimp
	IF(KDBLCNT(L,IATOM).EQ.14.AND.IDIM1.EQ.IDIM)
     &VDBCMAT(IDIM1,IDIM)=UPAR*ZAVRIMP(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZAVRIMP(ISPIN)/2.D0*DBLE(MSPIN)-(UPAR-GPAR)*
     &CDBLCNT(L,IATOM)
C 21. Analitical spin polarized limit of Sigma(inf) with Nscf was set
	IF(KDBLCNT(L,IATOM).EQ.21.AND.IDIM1.EQ.IDIM)
     &VDBCMAT(IDIM1,IDIM)=UPAR*ZOCCSCF(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZOCCSCF(ISPIN)/2.D0*DBLE(MSPIN)-(UPAR-GPAR)*
     &ZOCCSCF(ISPIN)/2.D0*DBLE(MSPIN)/(DBLE(NDEG)/2.D0)
C 22. Analitical spin restricted limit of Sigma(inf) with Nscf was set
	IF(KDBLCNT(L,IATOM).EQ.22.AND.IDIM1.EQ.IDIM)
     &VDBCMAT(IDIM1,IDIM)=UPAR*ZAVRSCF(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZAVRSCF(ISPIN)/2.D0*DBLE(MSPIN)-(UPAR-GPAR)*
     &ZAVRSCF(ISPIN)/2.D0*DBLE(MSPIN)/(DBLE(NDEG)/2.D0)
C 23. Analitical spin polarized limit of Sigma(inf) with Nimp
	IF(KDBLCNT(L,IATOM).EQ.23.AND.IDIM1.EQ.IDIM)
     &VDBCMAT(IDIM1,IDIM)=UPAR*ZOCCIMP(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZOCCIMP(ISPIN)/2.D0*DBLE(MSPIN)-(UPAR-GPAR)*
     &ZOCCIMP(ISPIN)/2.D0*DBLE(MSPIN)/(DBLE(NDEG)/2.D0)
C 24. Analitical spin restricted limit of Sigma(inf) with Nimp
	IF(KDBLCNT(L,IATOM).EQ.24.AND.IDIM1.EQ.IDIM)
     &VDBCMAT(IDIM1,IDIM)=UPAR*ZAVRIMP(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZAVRIMP(ISPIN)/2.D0*DBLE(MSPIN)-(UPAR-GPAR)*
     &ZAVRIMP(ISPIN)/2.D0*DBLE(MSPIN)/(DBLE(NDEG)/2.D0)
C 30. Fixed double counting
	IF(KDBLCNT(L,IATOM).EQ.30)
     &VDBCMAT(IDIM1,IDIM)=VDBCMAT(IDIM1,IDIM)
C 40. Double counting according to Eloc
	IF(KDBLCNT(L,IATOM).EQ.40)
     &VDBCMAT(IDIM1,IDIM)=VDBNMAT(IDIM1,IDIM)
C 50. Sigma(0)
	IF(KDBLCNT(L,IATOM).EQ.50)
     &VDBCMAT(IDIM1,IDIM)=SIG0MAT(IDIM1,IDIM)
C 60. Sigma(inf)
	IF(KDBLCNT(L,IATOM).EQ.60)
     &VDBCMAT(IDIM1,IDIM)=SIGIMAT(IDIM1,IDIM)
	ENDDO
	ENDDO
C *********************************************
C Set contribution to the total energy
C (note that density and local Green function have indexes swapped)
	DO IDIM1=1,NDIM
	IF(KSTATES(IDIM1,IRUN,L,IATOM).EQ.0)CYCLE
	IREP1=KDREP(IDIM1)
	ISPIN1=(2*IDIM1-1)/NDIM+1
	IF(MSPIN.EQ.1)ISPIN1=1
	IF(ISPIN1.EQ.1)ISPIN1M=NSPIN
	IF(ISPIN1.EQ.NSPIN)ISPIN1M=1
	DO IDIM=1,NDIM
	IF(KSTATES(IDIM,IRUN,L,IATOM).EQ.0)CYCLE
	IREP=KDREP(IDIM)
	ISPIN=(2*IDIM-1)/NDIM+1
	IF(MSPIN.EQ.1)ISPIN=1
	IF(ISPIN.EQ.1)ISPINM=NSPIN
	IF(ISPIN.EQ.NSPIN)ISPINM=1
C *********************************************
C Galitsky-Migdal formulae for the interaction
	DO IMSC=0,NMSC                  ! over frequencies
	IF(IDMF.EQ.3)
     &EINTGAL=EINTGAL+0.5D0*2.D0*TEMP*FMSC(IMSC)*DREAL(
     &(SIGWMAT(IMSC,IDIM,IDIM1)-SIGIMAT(IDIM,IDIM1))*
     & GLOCMAT(IMSC,IDIM1,IDIM))
	IF(IDMF.EQ.5)
     &EINTGAL=EINTGAL+0.5D0*FMSC(IMSC)*DREAL(
     &(SIGWMAT(IMSC,IDIM,IDIM1)-SIGIMAT(IDIM,IDIM1))*
     & GLOCMAT(IMSC,IDIM1,IDIM))
      ENDDO                          !!! over IMSC
C *********************************************
C Matrix case of Hartree-Fock interaction with LDA occupancies
C (should be the same as EGALHFK)
	IF(KSIGMOO(L,IATOM).EQ.11)THEN
	JDEG=0
	DO JDIM=1,NDIM
	IF(KSTATES(JDIM,IRUN,L,IATOM).EQ.0)CYCLE
	JDEG=JDEG+1
	JDEG1=0
	DO JDIM1=1,NDIM
	IF(KSTATES(JDIM1,IRUN,L,IATOM).EQ.0)CYCLE
	JDEG1=JDEG1+1
      ESTAHFK=ESTAHFK+0.5D0*
     &(UIMP(IDIM,JDIM,IDIM1,JDIM1)-UIMP(IDIM,JDIM,JDIM1,IDIM1))*
     &DHUBMAT(IDIM,IDIM1)*DHUBMAT(JDIM,JDIM1)
      ENDDO
      ENDDO
C *********************************************
C Matrix case of Hartree-Fock interaction with IMP occupancies
C (should be the same as EGALHFK)
	ELSEIF(KSIGMOO(L,IATOM).EQ.12)THEN
	JDEG=0
	DO JDIM=1,NDIM
	IF(KSTATES(JDIM,IRUN,L,IATOM).EQ.0)CYCLE
	JDEG=JDEG+1
	JDEG1=0
	DO JDIM1=1,NDIM
	IF(KSTATES(JDIM1,IRUN,L,IATOM).EQ.0)CYCLE
	JDEG1=JDEG1+1
      ESTAHFK=ESTAHFK+0.5D0*
     &(UIMP(IDIM,JDIM,IDIM1,JDIM1)-UIMP(IDIM,JDIM,JDIM1,IDIM1))*
     &DMAT(IDIM,IDIM1,0)*DMAT(JDIM,JDIM1,0)
      ENDDO
      ENDDO
C Spherical case of Hartree-Fock interaction with LDA occupancies
	ELSEIF(KSIGMOO(L,IATOM).EQ.21)THEN
	IF(IDIM1.EQ.IDIM)
     &ESTAHFK=ESTAHFK+0.5D0*DHUBMAT(IDIM,IDIM)*
     &(UPAR*ZOCCSCF(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*(ZOCCSCF(ISPIN)/2.D0*DBLE(MSPIN)-
     & DHUBMAT(IDIM,IDIM)))
C Spherical case of Hartree-Fock interaction with IMP occupancies
	ELSEIF(KSIGMOO(L,IATOM).EQ.22)THEN
	IF(IDIM1.EQ.IDIM)
     &ESTAHFK=ESTAHFK+0.5D0*DMAT(IDIM,IDIM,0)*
     &(UPAR*ZOCCIMP(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*(ZOCCIMP(ISPIN)/2.D0*DBLE(MSPIN)-
     & DMAT(IDIM,IDIM,0)))
C External
	ELSEIF(KSIGMOO(L,IATOM).EQ.31)THEN
      ESTAHFK=ESTAHFK+0.5D0*DHUBMAT(IDIM1,IDIM)*
     &SIGIMAT(IDIM1,IDIM)
C External
	ELSEIF(KSIGMOO(L,IATOM).EQ.32)THEN
      ESTAHFK=ESTAHFK+0.5D0*DMAT(IDIM1,IDIM,0)*
     &SIGIMAT(IDIM1,IDIM)
C External
	ELSEIF(KSIGMOO(L,IATOM).EQ.41)THEN
      ESTAHFK=ESTAHFK+0.5D0*DHUBMAT(IDIM1,IDIM)*
     &SIGIMAT(IDIM1,IDIM)
C External
	ELSEIF(KSIGMOO(L,IATOM).EQ.42)THEN
      ESTAHFK=ESTAHFK+0.5D0*DMAT(IDIM1,IDIM,0)*
     &SIGIMAT(IDIM1,IDIM)
      ENDIF	
C **********************      
C Double counting energy
C 00  External
	IF(KDBLCNT(L,IATOM).EQ.0)THEN
      ESTADBC=ESTADBC+0.5D0*DHUBMAT(IDIM1,IDIM)*
     &VDBCMAT(IDIM1,IDIM)
C 11. Fully localized spin polarized limit with Nscf was set
	ELSEIF(KDBLCNT(L,IATOM).EQ.11)THEN
	IF(IDIM1.EQ.IDIM)
     &ESTADBC=ESTADBC+0.5D0*DHUBMAT(IDIM,IDIM)*
     &(UPAR*ZOCCSCF(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZOCCSCF(ISPIN)/2.D0*DBLE(MSPIN)-
     &2.D0*(UPAR-GPAR)*CDBLCNT(L,IATOM))
C 12. Fully localized spin restricted limit with Nscf was set
	ELSEIF(KDBLCNT(L,IATOM).EQ.12)THEN
	IF(IDIM1.EQ.IDIM)
     &ESTADBC=ESTADBC+0.5D0*DHUBMAT(IDIM,IDIM)*
     &(UPAR*ZAVRSCF(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZAVRSCF(ISPIN)/2.D0*DBLE(MSPIN)-
     &2.D0*(UPAR-GPAR)*CDBLCNT(L,IATOM))
C 13. Fully localized spin polarized limit with Nimp 
	ELSEIF(KDBLCNT(L,IATOM).EQ.13)THEN
	IF(IDIM1.EQ.IDIM)
     &ESTADBC=ESTADBC+0.5D0*DMAT(IDIM,IDIM,0)*
     &(UPAR*ZOCCIMP(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZOCCIMP(ISPIN)/2.D0*DBLE(MSPIN)-
     &2.D0*(UPAR-GPAR)*CDBLCNT(L,IATOM))
C 14. Fully localized spin restricted limit with Nimp
	ELSEIF(KDBLCNT(L,IATOM).EQ.14)THEN
	IF(IDIM1.EQ.IDIM)
     &ESTADBC=ESTADBC+0.5D0*DMAT(IDIM,IDIM,0)*
     &(UPAR*ZAVRIMP(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZAVRIMP(ISPIN)/2.D0*DBLE(MSPIN)-
     &2.D0*(UPAR-GPAR)*CDBLCNT(L,IATOM))
C 21. Analitical spin polarized limit of Sigma(inf) with Nscf was set
	ELSEIF(KDBLCNT(L,IATOM).EQ.21)THEN
	IF(IDIM1.EQ.IDIM)
     &ESTADBC=ESTADBC+0.5D0*DHUBMAT(IDIM,IDIM)*
     &(UPAR*ZOCCSCF(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZOCCSCF(ISPIN)/2.D0*DBLE(MSPIN)-(UPAR-GPAR)*
     &ZOCCSCF(ISPIN)/2.D0*DBLE(MSPIN)/(DBLE(NDEG)/2.D0))
C 22. Analitical spin restricted limit of Sigma(inf) with Nscf
	ELSEIF(KDBLCNT(L,IATOM).EQ.22)THEN
	IF(IDIM1.EQ.IDIM)
     &ESTADBC=ESTADBC+0.5D0*DHUBMAT(IDIM,IDIM)*
     &(UPAR*ZAVRSCF(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZAVRSCF(ISPIN)/2.D0*DBLE(MSPIN)-(UPAR-GPAR)*
     &ZAVRSCF(ISPIN)/2.D0*DBLE(MSPIN)/(DBLE(NDEG)/2.D0))
C 23. Analitical spin polarized limit of Sigma(inf) with Nimp
	ELSEIF(KDBLCNT(L,IATOM).EQ.23)THEN
	IF(IDIM1.EQ.IDIM)
     &ESTADBC=ESTADBC+0.5D0*DMAT(IDIM,IDIM,0)*
     &(UPAR*ZOCCIMP(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZOCCIMP(ISPIN)/2.D0*DBLE(MSPIN)-(UPAR-GPAR)*
     &ZOCCIMP(ISPIN)/2.D0*DBLE(MSPIN)/(DBLE(NDEG)/2.D0))
C 24. Analitical spin restricted limit of Sigma(inf) with Nimp
	ELSEIF(KDBLCNT(L,IATOM).EQ.24)THEN
	IF(IDIM1.EQ.IDIM)
     &ESTADBC=ESTADBC+0.5D0*DMAT(IDIM,IDIM,0)*
     &(UPAR*ZAVRIMP(ISPINM)/2.D0*DBLE(MSPIN)+
     &(UPAR-GPAR)*ZAVRIMP(ISPIN)/2.D0*DBLE(MSPIN)-(UPAR-GPAR)*
     &ZAVRIMP(ISPIN)/2.D0*DBLE(MSPIN)/(DBLE(NDEG)/2.D0))
C 30. Fixed double counting
	ELSEIF(KDBLCNT(L,IATOM).EQ.30)THEN
      ESTADBC=ESTADBC+0.5D0*DHUBMAT(IDIM1,IDIM)*
     &VDBCMAT(IDIM1,IDIM)
C 40. Double counting according to Eloc
	ELSEIF(KDBLCNT(L,IATOM).EQ.40)THEN
      ESTADBC=ESTADBC+0.5D0*DHUBMAT(IDIM1,IDIM)*
     &VDBCMAT(IDIM1,IDIM)
C 50. Sigma(0)
	ELSEIF(KDBLCNT(L,IATOM).EQ.50)THEN
      ESTADBC=ESTADBC+0.5D0*DHUBMAT(IDIM1,IDIM)*
     &VDBCMAT(IDIM1,IDIM)
C 60. Sigma(inf)
	ELSEIF(KDBLCNT(L,IATOM).EQ.60)THEN
      ESTADBC=ESTADBC+0.5D0*DHUBMAT(IDIM1,IDIM)*
     &VDBCMAT(IDIM1,IDIM)
      ENDIF
C *********************************************
C Galitsky-Migdal formulae for the static parts
	IF(KSIGMOO(L,IATOM).EQ.11)THEN
	EGALHFK=EGALHFK+0.5D0*DHUBMAT(IDIM1,IDIM)*
     &SIGIMAT(IDIM1,IDIM)
	ELSEIF(KSIGMOO(L,IATOM).EQ.12)THEN
	EGALHFK=EGALHFK+0.5D0*DMAT(IDIM1,IDIM,0)*
     &SIGIMAT(IDIM1,IDIM)
	ELSEIF(KSIGMOO(L,IATOM).EQ.21)THEN
	EGALHFK=EGALHFK+0.5D0*DHUBMAT(IDIM1,IDIM)*
     &SIGIMAT(IDIM1,IDIM)
	ELSEIF(KSIGMOO(L,IATOM).EQ.22)THEN
	EGALHFK=EGALHFK+0.5D0*DMAT(IDIM1,IDIM,0)*
     &SIGIMAT(IDIM1,IDIM)
	ELSEIF(KSIGMOO(L,IATOM).EQ.31)THEN
	EGALHFK=EGALHFK+0.5D0*DHUBMAT(IDIM1,IDIM)*
     &SIGIMAT(IDIM1,IDIM)
	ELSEIF(KSIGMOO(L,IATOM).EQ.32)THEN
	EGALHFK=EGALHFK+0.5D0*DMAT(IDIM1,IDIM,0)*
     &SIGIMAT(IDIM1,IDIM)
	ELSEIF(KSIGMOO(L,IATOM).EQ.41)THEN
	EGALHFK=EGALHFK+0.5D0*DHUBMAT(IDIM1,IDIM)*
     &SIGIMAT(IDIM1,IDIM)
	ELSEIF(KSIGMOO(L,IATOM).EQ.42)THEN
	EGALHFK=EGALHFK+0.5D0*DMAT(IDIM1,IDIM,0)*
     &SIGIMAT(IDIM1,IDIM)
      ENDIF     
	EGALDBC=EGALDBC+0.5D0*DHUBMAT(IDIM1,IDIM)*
     &VDBCMAT(IDIM1,IDIM)
	ENDDO
	ENDDO
	DEALLOCATE(SIGA,GINV,WORK)
 2000 CONTINUE
C UPGRADE QMCFILE INFORMATION IF REQUESTED
	IF(IMPSECT(L,IATOM).EQ.2)THEN
C Locate section=dmft
      CALL READ_SECT(QMCDATA(1),NLEN,ISEC,NSEC,MSEC,
     &'<section=dmft',13,'<section=',9,'ok',2)
	ALLOCATE(QMCCOPY(NSEC))
	DO ILIN=1,MSEC
	QMCCOPY(ILIN)=QMCDATA(ILIN+ISEC-1)
	ENDDO
C Upgrade Position of chemical potential (it is zero in this case)
	HELP='! Chemical Potential                    '
	LHLP=40
	CALL READ_CHAR(QMCDATA(ISEC),QMCCOPY(1),NSEC,MSEC,
     &  'chem',4,IN,1,0,0.D0,1,1,CM,1,0,' ',1,0,
     &  HELP,LHLP,DEF,ASK,VAL,NTH,.TRUE.,.TRUE.)
	DEALLOCATE(QMCCOPY)
C Locate section=shel
      CALL READ_SECT(QMCDATA(1),NLEN,ISEC,NSEC,MSEC,
     &'<section=shel',13,'<section=',9,'ok',2)
	ALLOCATE(QMCCOPY(NSEC))
	DO ILIN=1,MSEC
	QMCCOPY(ILIN)=QMCDATA(ILIN+ISEC-1)
	ENDDO
C Upgrade Positions of Impurity Levels
      DO IDIM=1,NDIM
      ERAT(IDIM)=DREAL(ELEV(IDIM,IDIM))-CHEM
      ENDDO
	IF(LORB.LE.1)HELP='! Local level energies                  '
	IF(LORB.GT.1)HELP='                                        '
	LHLP=40
	CALL READ_CHAR(QMCDATA(ISEC),QMCCOPY(1),NSEC,MSEC,
     &  'eloc(:)',7,IN,1,0,ERAT,2*(2*LORB+1),1,CM,1,0,' ',1,0,
     &  HELP,LHLP,DEF,ASK,VAL,NTH,.TRUE.,.TRUE.)
	DEALLOCATE(QMCCOPY)
C File upgrade done, store data	
      CALL FIND_LBLANK(FILE,130,NBP)
      CALL FIND_LBLANK(EXTNQMS,60,NBE)
	QMSFILE=FILE(:NBP)//'.'//EXTNQMS(:NBE)
      CALL READ_OVWR(QMSFILE,QMCDATA,NLEN)
      ENDIF
C MEMORY DEALLOCATIONS
      CALL QMC_ALLOCATE('D')
	DEALLOCATE(QMCDATA,IMPWORK,LREP,KDREP,VDBNMAT)
	END
