      SUBROUTINE IMP_SETDOS(L,IATOM,DAMP)
************************************************************
*  Finds non-nteracting density of states of the cluster   *
************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                 !!! from setup
      USE COM_CONTROL ,ONLY: LIFT,LMTO,IDMF,IASA                     !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS,ILSB         !!! from readini
      USE COM_HUBDAT  ,ONLY: NHUB,MCRL,LCRL                          !!! from readhub
      USE COM_ENVSITE ,ONLY: NENV,TENV,ISENV                         !!! from envmesh
      USE COM_INPPAR  ,ONLY: ENY,DNY,NODES                           !!! from readini
      USE COM_TBBPAR  ,ONLY: LTBAS,LSBAS,INBAS,NTBAS                 !!! from readhop
      USE COM_LABELS  ,ONLY: TXTAT,TXTSP,TXTEL                       !!! from readini
      USE COM_FERMI   ,ONLY: EF                                      !!! from ttrints
      USE COM_FREQU   ,ONLY: NENRDOS,ENRDOS                          !!! from readini
      USE COM_HOPCOM  ,ONLY: TMAT,SMAT                               !!! from readhop
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                         !!! from setup
      USE COM_CHANNELS,ONLY: IUDOS                                   !!! from channels
      USE COM_LMTOUT                                                 !!! from readini
      IMPLICIT REAL*8 (A-H,O-Z)
C Local allocatable arrays
      INTEGER, ALLOCATABLE :: NIND(:,:,:)
      INTEGER, ALLOCATABLE :: ILMTBAS(:,:)
      INTEGER, ALLOCATABLE :: INODBAS(:,:)
      INTEGER, ALLOCATABLE :: ISCLS(:)
      INTEGER, ALLOCATABLE :: ILSBCLS(:)
      INTEGER, ALLOCATABLE :: NHSTCLS(:)
      REAL*8, ALLOCATABLE :: ECLS(:)
	COMPLEX*16, ALLOCATABLE :: HCLS(:,:)
	COMPLEX*16, ALLOCATABLE :: OCLS(:,:)
      COMPLEX*16, ALLOCATABLE :: TLMS(:,:,:,:)
      COMPLEX*16, ALLOCATABLE :: GRNI(:,:,:)
      CHARACTER*10, ALLOCATABLE :: TATSCLS(:)
C SET LOCAL VARIABLES
	REAL*8 SPTOS(2),SPDOS(2)
	COMPLEX*16 DENOM,DIM
	CHARACTER HELP*40,DFILE*130,TSTATE*10
	LOGICAL EXIST,OPEN
      DATA PI/3.141592653589793D0/,DIM/(0.D0,1.D0)/
	IF(ICDOS.EQ.0)RETURN
	IF(IASA.NE.3)RETURN
C MEMORY ALLOCATIONS
	ALLOCATE(NIND(LIMBMEM,2,NENVMEM))
	CHEM=EF
	LORB=L
      NDIM=2*(2*LORB+1)
C CALCULATE TOTAL SIZE OF CLUSTER HAMILTONIANS
      IHYB=0
      DO ISPIN=1,2                        !!! over spins
	DO IENV=1,NENV(IATOM)               !!! over ienv
	IATOMH=ISENV(IENV,IATOM) 
	ISORTH=IS(IATOMH)
	DO LH=0,ILSB(ISORTH)                !!! over lh
	IF(.NOT.LTBAS(LH,IATOMH))CYCLE
	DO MH=-LH,LH
	LMH=LH*(LH+1)+MH+1
      IHYB=IHYB+1
      NIND(LMH,ISPIN,IENV)=IHYB
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      NHYB=IHYB
      NDIMCLS=(NHYB+NDIM)/2
C SET UP CLUSTER HAMILTONIAN
      ALLOCATE(HCLS(NDIMCLS*NSPIN,NDIMCLS*NSPIN))
      ALLOCATE(OCLS(NDIMCLS*NSPIN,NDIMCLS*NSPIN))
      DO ICLS1=1,NDIMCLS*NSPIN      
      DO ICLS =1,NDIMCLS*NSPIN      
      HCLS(ICLS1,ICLS)=(0.D0,0.D0)
      OCLS(ICLS1,ICLS)=(0.D0,0.D0)
      ENDDO
      ENDDO
C HYBRIDIZATION LEVELS
	DO IORBS=1,NORBS
	DO IUPDN=1,NSPIN
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
	DO IENV=1,NENV(IATOM)               !!! over ienv
	IATOMH=ISENV(IENV,IATOM) 
	ISORTH=IS(IATOMH)
	DO L1H=0,ILSB(ISORTH)               !!! over l1
	IF(.NOT.LTBAS(L1H,IATOMH))CYCLE
      DO M1H=-L1H,L1H
      L1MH=L1H*(L1H+1)+M1H+1
	ICLS1=NIND(L1MH,1,IENV)+NDIMCLS*(ISPIN1-1)
	DO LH=0,ILSB(ISORTH)                !!! over l1
	IF(.NOT.LTBAS(LH,IATOMH))CYCLE
      DO MH=-LH,LH
      LMH=LH*(LH+1)+MH+1
      ICLS=NIND(LMH,1,IENV)+NDIMCLS*(ISPIN-1)
      HCLS(ICLS1,ICLS)=TMAT(L1MH,LMH,IATOMH,0,IUPDN,IORBS)
      OCLS(ICLS1,ICLS)=SMAT(L1MH,LMH,IATOMH,0,IUPDN,IORBS)
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      ENDDO
C IMPURITY LEVELS
	DO IORBS=1,NORBS
	DO IUPDN=1,NSPIN
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
      DO M1=-L,L
      LM1=L*(L+1)+M1+1
      ICLS1=NHYB/2+M1+L+1+NDIMCLS*(ISPIN1-1)
      DO M=-L,L
      LM=L*(L+1)+M+1
      ICLS=NHYB/2+M+L+1+NDIMCLS*(ISPIN-1)
      HCLS(ICLS1,ICLS)=TMAT(LM1,LM,IATOM,0,IUPDN,IORBS)
      OCLS(ICLS1,ICLS)=SMAT(LM1,LM,IATOM,0,IUPDN,IORBS)
      ENDDO
      ENDDO
      ENDDO
      ENDDO
C HYBRIDIZATION MATRIX ELEMENTS
	DO IORBS=1,NORBS
	DO IUPDN=1,NSPIN
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
	DO IENV=1,NENV(IATOM)               !!! over ienv
	IATOMH=ISENV(IENV,IATOM) 
	ISORTH=IS(IATOMH)
	DO LH=0,ILSB(ISORTH)                !!! over lh
	IF(.NOT.LTBAS(LH,IATOMH))CYCLE
	DO MH=-LH,LH
	LMH=LH*(LH+1)+MH+1
      ICLS=NIND(LMH,1,IENV)+NDIMCLS*(ISPIN-1)
      DO M=-L,L
      LM=L*(L+1)+M+1
      ICLS1=NHYB/2+M+L+1+NDIMCLS*(ISPIN1-1)
      HCLS(ICLS1,ICLS)=TMAT(LM,LMH,IATOM,IENV,IUPDN,IORBS)
      HCLS(ICLS,ICLS1)=DCONJG(HCLS(ICLS1,ICLS))
      OCLS(ICLS1,ICLS)=SMAT(LM,LMH,IATOM,IENV,IUPDN,IORBS)
      OCLS(ICLS,ICLS1)=DCONJG(OCLS(ICLS1,ICLS))
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      ENDDO
C DIAGONALIZE CLUSTER
      ALLOCATE(ECLS(NDIMCLS*NSPIN))
      CALL LIB_EIGEN1C(NDIMCLS*NSPIN,HCLS,OCLS,ECLS,NSPIN,NORBS,
     &                 1,IERR,0,1.D-07)
C RANGE FOR THE DENSITY OF STATES
      EMIN=ECLS(NDIMCLS*NSPIN)
      EMAX=ECLS(1)
      DO IBND=1,NDIMCLS*NSPIN
      EMIN=MIN(EMIN,ECLS(IBND))
      EMAX=MAX(EMAX,ECLS(IBND))
      ENDDO
      IF(ABS(ENRDOS(NENRDOS)-ENRDOS(0)).LE.1.D-14)THEN
      EMIN=EMIN-0.1D0
      EMAX=EMAX+0.1D0
	IF(NENRDOS.NE.0)ESTEP=(EMAX-EMIN)/DBLE(NENRDOS)
	IF(NENRDOS.EQ.0)ESTEP=0.D0
	DO IENR=0,NENRDOS
	ENRDOS(IENR)=EMIN+DBLE(IENR)*ESTEP+CHEM
	ENDDO
      ENDIF
C Set filename
      IHUB=0
      ICRL=0
      DO IATOM0=1,NATOM
      IF(MCRL(IATOM0).EQ.0)CYCLE
      DO L0=0,ILSB(IS(IATOM0))
      IF(LCRL(L0,IATOM0).EQ.0)CYCLE
      IHUB=IHUB+1
      IF(IATOM0.EQ.IATOM.AND.L0.EQ.L)ICRL=IHUB
      ENDDO
      ENDDO
      CALL FIND_LBLANK(DOSFILE,130,NBP)
      TSTATE='          '
      IF(ICRL.GE. 1.AND.ICRL.LE. 9)WRITE(TSTATE(1:1),FMT='(I1)')ICRL
      IF(ICRL.GE.10.AND.ICRL.LE.99)WRITE(TSTATE(1:1),FMT='(I2)')ICRL
      IF(ICRL.GE.100)CALL FULLSTOP('<SETDOS> :: ICRL > 99 NOT READY')
      DFILE=DOSFILE
      IF(NHUB.GT.1)
     &DFILE=DOSFILE(:NBP)//TSTATE
	INQUIRE(FILE=DFILE,EXIST=EXIST)
	IF(EXIST)THEN
      OPEN(UNIT=IUDOS,FILE=DFILE,STATUS='OLD',FORM='FORMATTED')
	CLOSE(UNIT=IUDOS,STATUS='DELETE')
	ENDIF
	OPEN(IUDOS,FILE=DFILE,STATUS='NEW',FORM='FORMATTED')
C STORE HEADER INFO.
	WRITE(IUDOS,10010)
	WRITE(IUDOS,10020)
10010	FORMAT(1X,'<FILE=DOSFILE,INPUT=MODERN>')
10020 FORMAT('****************************************************')
	WRITE(IUDOS,10030)
10030 FORMAT(1X,'<SECTION=CTRL>              ! CONTROL PARAMETERS:')
      HELP='! Energy mesh for Dos(E)               '
	WRITE(IUDOS,10040)NENRDOS,HELP
10040 FORMAT(1X,'nEnrDOS=',I5,16X,A40)
      HELP='! Min.Energy (Ry) for Dos(E)           '
	WRITE(IUDOS,10050)ENRDOS(0),HELP
10050 FORMAT(1X,'EminDOS=',G14.7,7X,A40)
      HELP='! Max.Energy (Ry) for Dos(E)           '
	WRITE(IUDOS,10060)ENRDOS(NENRDOS),HELP
10060 FORMAT(1X,'EmaxDOS=',G14.7,7X,A40)
C STORE DOS DATA
	WRITE(IUDOS,10110)
10110 FORMAT(1X,'<SECTION=DATA>              ! DOS  DATA:')
C CLUSTER ARRAYS
      ALLOCATE(ISCLS(0:NENV(IATOM)))
      DO IENV=0,NENV(IATOM)
      ISCLS(IENV)=IENV+1
      ENDDO
      ALLOCATE(ILSBCLS(0:NENV(IATOM)))
      ALLOCATE(NHSTCLS(0:NENV(IATOM)))
      DO IENV=0,NENV(IATOM)
	IATOMH=ISENV(IENV,IATOM) 
	ISORTH=IS(IATOMH)
      ILSBCLS(IENV)=ILSB(ISORTH)
      NHSTCLS(IENV)=1
      ENDDO      
      WRITE(IUDOS,*)NENV(IATOM)+1,NENV(IATOM)+1,NSPIN,NORBS,
     &(ISCLS(IENV),IENV=0,NENV(IATOM)),
     &(ILSBCLS(IENV),IENV=0,NENV(IATOM)),
     &(NHSTCLS(IENV),IENV=0,NENV(IATOM)),
     &EF,ENRDOS(0),ENRDOS(NENRDOS),NENRDOS
      ALLOCATE(TATSCLS(0:NENV(IATOM)))
      DO IENV=0,NENV(IATOM)
	IATOMH=ISENV(IENV,IATOM) 
	ISORTH=IS(IATOMH)
      TATSCLS(IENV)=TXTAT(ISORTH)
      ENDDO
      WRITE(IUDOS,FMT='(5A10)')(TATSCLS(IENV),IENV=0,NENV(IATOM))
C Store basis set
      ALLOCATE(ILMTBAS(0:LMAXBMEM,0:NENV(IATOM)))
      ALLOCATE(INODBAS(0:LMAXBMEM,0:NENV(IATOM)))
      DO IENV=0,NENV(IATOM)
	IATOMH=ISENV(IENV,IATOM) 
	ISORTH=IS(IATOMH)
      DO LI=0,ILSB(ISORTH)
      ILMTBAS(LI,IENV)=0
      INODBAS(LI,IENV)=0
      IF(LTBAS(LI,IATOMH))ILMTBAS(LI,IENV)=1
      IF(LTBAS(LI,IATOMH))INODBAS(LI,IENV)=
     &NODES(LI,IS(IATOMH),1,1)+LI+1
      ENDDO
      ENDDO
      WRITE(IUDOS,*)((ILMTBAS(LI,IENV),LI=0,
     &ILSB(IS(ISENV(IENV,IATOM)))),IENV=0,NENV(IATOM))
      WRITE(IUDOS,*)((INODBAS(LI,IENV),LI=0,
     &ILSB(IS(ISENV(IENV,IATOM)))),IENV=0,NENV(IATOM))
C COMPUTE NON INTERACTNG GREEN FUNCTION OF THE CLUSTER AND STORE IT
      ALLOCATE(GRNI(LIMB2MEM,0:NENVMEM,NSPINMEM))
      ALLOCATE(TLMS(LIMB2MEM,0:NENVMEM,NSPINMEM,NDIMCLS*NSPIN))
      DO 1000 IENR=0,NENRDOS
C Set cluster matrix elements to zero
      DO IBND=1,NDIMCLS*NSPIN
      DO ISPIN=1,NSPIN
	DO IENV=0,NENV(IATOM)               !!! over ienv
	IATOMH=ISENV(IENV,IATOM) 
	ISORTH=IS(IATOMH)
	DO LH=0,ILSB(ISORTH)                !!! over l1
      DO M1=-LH,LH
      DO M=-LH,LH
	IU=LH*(2*LH-1)*(2*LH+1)/3+(2*LH+1)*(LH+M)+LH+M1+1 !!! (l,m1 m)
      TLMS(IU,IENV,ISPIN,IBND)=(0.D0,0.D0)
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      ENDDO
C Add contribution from the impurity level
      DO IBND=1,NDIMCLS*NSPIN
      DO ISPIN=1,NSPIN
      DO M1=-L,L
      LM1=L*(L+1)+M1+1
      ICLS1=NHYB/2+M1+L+1+NDIMCLS*(ISPIN-1)
      DO M=-L,L
      LM=L*(L+1)+M+1
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M1+1 !!! (l,m1 m)
      ICLS=NHYB/2+M+L+1+NDIMCLS*(ISPIN-1)
      TLMS(IU,0,ISPIN,IBND)=DCONJG(OCLS(ICLS1,IBND))*OCLS(ICLS,IBND)
      ENDDO
      ENDDO
      ENDDO
      ENDDO
C Add contribution from the hybridizations
      DO IBND=1,NDIMCLS*NSPIN
      DO ISPIN=1,NSPIN
	DO IENV=1,NENV(IATOM)               !!! over ienv
	IATOMH=ISENV(IENV,IATOM) 
	ISORTH=IS(IATOMH)
	DO LH=0,ILSB(ISORTH)                !!! over l1
	IF(.NOT.LTBAS(LH,IATOMH))CYCLE
      DO M1H=-LH,LH
      LM1H=LH*(LH+1)+M1H+1
	ICLS1=NIND(LM1H,1,IENV)+NDIMCLS*(ISPIN-1)
      DO MH=-LH,LH
      LMH=LH*(LH+1)+MH+1
      ICLS=NIND(LMH,1,IENV)+NDIMCLS*(ISPIN-1)
	IU=LH*(2*LH-1)*(2*LH+1)/3+(2*LH+1)*(LH+MH)+LH+M1H+1 !!! (lh,m1 m)
      TLMS(IU,IENV,ISPIN,IBND)=DCONJG(OCLS(ICLS1,IBND))*OCLS(ICLS,IBND)
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      ENDDO      
C Imaginary Green function
      DO ISPIN=1,NSPIN
	DO IENV=0,NENV(IATOM)               !!! over ienv
	IATOMH=ISENV(IENV,IATOM) 
	ISORTH=IS(IATOMH)
	DO LH=0,ILSB(ISORTH)                !!! over l1
	IF(.NOT.LTBAS(LH,IATOMH))CYCLE
      DO M1H=-LH,LH
      DO MH=-LH,LH
	IU=LH*(2*LH-1)*(2*LH+1)/3+(2*LH+1)*(LH+MH)+LH+M1H+1 !!! (lh,m1 m)
      GRNI(IU,IENV,ISPIN)=(0.D0,0.D0)
      DO IBND=1,NDIMCLS*NSPIN
      DENOM=ENRDOS(IENR)-CHEM-ECLS(IBND)+DIM*DAMP
      IF(ABS(DENOM).GT.1.D-14)
     &DOSWG=-DIMAG(1.D0/DENOM)/PI
      GRNI(IU,IENV,ISPIN)=GRNI(IU,IENV,ISPIN)+
     &TLMS(IU,IENV,ISPIN,IBND)*DOSWG
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      ENDDO
C Total DOS
      DO ISPIN=1,NSPIN
      SPTOS(ISPIN)=0.D0
      SPDOS(ISPIN)=0.D0
	DO IENV=0,NENV(IATOM)               !!! over ienv
	IATOMH=ISENV(IENV,IATOM) 
	ISORTH=IS(IATOMH)
	DO LH=0,ILSB(ISORTH)                !!! over l1
	IF(.NOT.LTBAS(LH,IATOMH))CYCLE
      DO M1H=-LH,LH
      DO MH=-LH,LH
	IU=LH*(2*LH-1)*(2*LH+1)/3+(2*LH+1)*(LH+MH)+LH+M1H+1 !!! (lh,m1 m)
      SPDOS(ISPIN)=SPDOS(ISPIN)+GRNI(IU,IENV,ISPIN)
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      ENDDO
C Total TOS
      DO IBNDS=1,NSPIN
      DO IBNDT=1,NDIMCLS
      SPTOS(IBNDS)=0.D0
      IBAND=IBNDS+NSPIN*(IBNDT-1)
      IF(ECLS(IBAND)+CHEM.LE.ENRDOS(IENR))SPTOS(IBNDS)=SPTOS(IBNDS)+1
      ENDDO
      ENDDO
      IF(NORBS.EQ.2)THEN
      TOTOS=SPTOS(1)+SPTOS(NSPIN)
      SPTOS(1)=TOTOS/2.D0
      SPTOS(NSPIN)=TOTOS/2.D0
      ENDIF
      WRITE(IUDOS,*)ENRDOS(IENR),(SPTOS(ISPIN),ISPIN=1,NSPIN),
     &                           (SPDOS(ISPIN),ISPIN=1,NSPIN)
C Record it
      DO ISPIN=1,NSPIN
	DO IENV=0,NENV(IATOM)               !!! over ienv
	IATOMH=ISENV(IENV,IATOM) 
	ISORTH=IS(IATOMH)
      DO LH=0,ILSB(ISORTH)
      LMS=LH*(2*LH-1)*(2*LH+1)/3+1
      LME=LMS+(2*LH+1)**2-1
	IF(.NOT.LTBAS(LH,IATOMH))CYCLE
      WRITE(IUDOS,*)(GRNI(LM1M,IENV,ISPIN),LM1M=LMS,LME)
      ENDDO
      ENDDO
      ENDDO
 1000 CONTINUE                           !!! over frequencies
      CLOSE(IUDOS)
      DEALLOCATE(ISCLS,ILSBCLS,NHSTCLS,TLMS,TATSCLS,ILMTBAS,INODBAS)
	DEALLOCATE(ECLS,HCLS,OCLS,GRNI,NIND)
	END
