	SUBROUTINE IMP_SIGRAT
***************************************************************
*  Finds rational form for the self-energy
***************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LSHELL  ,ONLY: LORB,ELEV,DAMP,KSYS                     !!! from shells
      USE COM_IMPGRF  ,ONLY: GLOC,NRAT,NPOL,KRAT,KINT,
     &                       NMOM,GMOM,DMAT,SIGW,SIG0,BMAS,
     &                       SIGI,SRAT,VRAT,WRAT,PRAT,ORAT,
     &                       DTRM,RTRM,CHEM,KVRB
	USE COM_MSBMESH ,ONLY: TEMP,KGRD,NMSC,WMSC,FMSC                !!! from readrat
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                         !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8, ALLOCATABLE :: TREL(:,:)
	REAL*8, ALLOCATABLE :: ELOC(:)
	REAL*8, ALLOCATABLE :: WGAT(:,:)
	REAL*8, ALLOCATABLE :: RLOC(:,:)
	REAL*8, ALLOCATABLE :: DLOC(:,:)
	REAL*8, ALLOCATABLE :: ULOC(:,:)
	REAL*8, ALLOCATABLE :: SIGZ(:)
	REAL*8, ALLOCATABLE :: ZMAS(:)
	REAL*8, ALLOCATABLE :: WPOL(:,:)
	REAL*8, ALLOCATABLE :: SIGT(:)
	REAL*8, ALLOCATABLE :: VLOC(:,:)
	REAL*8, ALLOCATABLE :: WLOC(:,:)
	REAL*8, ALLOCATABLE :: PLOC(:,:)
	REAL*8, ALLOCATABLE :: OLOC(:,:)
	COMPLEX*16, ALLOCATABLE :: DENM(:,:)
	COMPLEX*16, ALLOCATABLE :: GINV(:,:)
	COMPLEX*16, ALLOCATABLE :: GAGF(:,:)
	COMPLEX*16, ALLOCATABLE :: GSIG(:,:)
	COMPLEX*16, ALLOCATABLE :: GPOL(:,:)
	COMPLEX*16, ALLOCATABLE :: SIGP(:,:)
	COMPLEX*16, ALLOCATABLE :: WORK(:)
	COMPLEX*16, ALLOCATABLE :: WSIG(:,:)
	COMPLEX*16, ALLOCATABLE :: PSIG(:,:)
	COMPLEX*16 DIM,TS(7,-3:3,0:3),TC(-3:3,7,0:3)
     &    ,GTRA,GTRS,GTRP,STRA,STRP,ZMSC
	LOGICAL EXIST
      DATA PI/3.141592653589793D0/,DIM/(0.D0,1.D0)/
C ********************************************
	L=LORB
	NDEG=2*(2*LORB+1)
C CONSTRUCT POLE EXPANSION FOR ATOMIC SELF-ENERGY
C Cubic harmonics transformations
	CALL LIB_TRANSC(TC)
	CALL LIB_TRANSS(TS)
C Spinor transformations
	ALLOCATE(TREL(NDEG,NDEG))
	CALL LIB_TRANSREL_LINP(TREL,L)
C Transform to diagonal representation
	ALLOCATE(WORK(NDEG))
	ALLOCATE(GINV(NDEG,NDEG))
	ALLOCATE(ELOC(NDEG))
	ALLOCATE(SIGT(NDEG))
	ALLOCATE(SIGZ(NDEG))
	ALLOCATE(ZMAS(NDEG))
	ALLOCATE(WGAT(NRAT,NDEG))
	ALLOCATE(WPOL(NRAT,NDEG))
	ALLOCATE(RLOC(-NMOM:+NMOM,NDEG))
	ALLOCATE(DLOC(-NMOM:+NMOM,NDEG))
	ALLOCATE(ULOC(-NMOM:+NMOM,NDEG))
	IF(KSYS.EQ.1)THEN
	MS=0
	DO ISPIN=1,2
	DO M =-LORB,LORB
	MS=MS+1
	ELOC(MS)=0.D0
	SIGZ(MS)=0.D0
	ZMAS(MS)=0.D0
	SIGT(MS)=0.D0
	DO IRAT=1,NRAT
	WGAT(IRAT,MS)=0.D0
	ENDDO
	DO IMOM=-NMOM,+NMOM
	RLOC(IMOM,MS)=0.D0
	DLOC(IMOM,MS)=0.D0
	ENDDO
	K1S1=0
	DO JSPIN1=1,2
	DO K1=-LORB,LORB
	K1S1=K1S1+1
	IF(ISPIN.NE.JSPIN1)CYCLE
	KS=0
	DO JSPIN=1,2
	DO K =-LORB,LORB
	KS=KS+1
	IF(ISPIN.NE.JSPIN)CYCLE
      ELOC(MS)=ELOC(MS)+CONJG(TS(M+LORB+1,K1,LORB))*
     &ELEV(K1S1,KS)*TS(M+LORB+1,K,LORB)
      ZMAS(MS)=ZMAS(MS)+CONJG(TS(M+LORB+1,K1,LORB))*
     &BMAS(K1S1,KS)*TS(M+LORB+1,K,LORB)
      SIGZ(MS)=SIGZ(MS)+CONJG(TS(M+LORB+1,K1,LORB))*
     &SIG0(K1S1,KS)*TS(M+LORB+1,K,LORB)
      SIGT(MS)=SIGT(MS)+CONJG(TS(M+LORB+1,K1,LORB))*
     &SIGI(K1S1,KS)*TS(M+LORB+1,K,LORB)
	DO IMOM=-NMOM,+NMOM
      RLOC(IMOM,MS)=RLOC(IMOM,MS)+CONJG(TS(M+LORB+1,K1,LORB))*
     &GMOM(K1S1,KS,IMOM)*TS(M+LORB+1,K,LORB)
      DLOC(IMOM,MS)=DLOC(IMOM,MS)+CONJG(TS(M+LORB+1,K1,LORB))*
     &DMAT(K1S1,KS,IMOM)*TS(M+LORB+1,K,LORB)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ZMAS(MS)=ZMAS(MS)**2
	ENDDO
	ENDDO
	ELSEIF(KSYS.EQ.2)THEN
	MS=0
	DO ISPIN=1,2
	DO M =-LORB,LORB
	MS=MS+1
      ELOC(MS)=ELEV(MS,MS)
      SIGZ(MS)=SIG0(MS,MS)
      ZMAS(MS)=BMAS(MS,MS)**2
      SIGT(MS)=SIGI(MS,MS)
	DO IMOM=-NMOM,+NMOM
      RLOC(IMOM,MS)=GMOM(MS,MS,IMOM)
      DLOC(IMOM,MS)=DMAT(MS,MS,IMOM)
	ENDDO
	ENDDO
	ENDDO
	ELSEIF(KSYS.EQ.3)THEN
	DO IDEG =1,NDEG
	ELOC(IDEG)=0.D0
	SIGZ(IDEG)=0.D0
	ZMAS(IDEG)=0.D0
	SIGT(IDEG)=0.D0
	DO IRAT=1,NRAT
	WGAT(IRAT,IDEG)=0.D0
	ENDDO
	DO IMOM=-NMOM,+NMOM
	RLOC(IMOM,IDEG)=0.D0
	DLOC(IMOM,IDEG)=0.D0
	ENDDO
	DO JDEG1=1,NDEG   
	DO JDEG =1,NDEG
	ELOC(IDEG)=ELOC(IDEG)+
     &TREL(IDEG,JDEG1)*ELEV(JDEG1,JDEG)*TREL(IDEG,JDEG) ! indexation checked: first index - relativ., second - spherical
	SIGZ(IDEG)=SIGZ(IDEG)+
     &TREL(IDEG,JDEG1)*SIG0(JDEG1,JDEG)*TREL(IDEG,JDEG)
	ZMAS(IDEG)=ZMAS(IDEG)+
     &TREL(IDEG,JDEG1)*BMAS(JDEG1,JDEG)*TREL(IDEG,JDEG)
	SIGT(IDEG)=SIGT(IDEG)+
     &TREL(IDEG,JDEG1)*SIGI(JDEG1,JDEG)*TREL(IDEG,JDEG)
	DO IMOM=-NMOM,+NMOM
	RLOC(IMOM,IDEG)=RLOC(IMOM,IDEG)+
     &TREL(IDEG,JDEG1)*GMOM(JDEG1,JDEG,IMOM)*TREL(IDEG,JDEG)
	DLOC(IMOM,IDEG)=DLOC(IMOM,IDEG)+
     &TREL(IDEG,JDEG1)*DMAT(JDEG1,JDEG,IMOM)*TREL(IDEG,JDEG)
	ENDDO
	ENDDO
	ENDDO
	ZMAS(IDEG)=ZMAS(IDEG)**2
	ENDDO
C External Transformation
      ELSE
	DO IDEG =1,NDEG
	ELOC(IDEG)=0.D0
	SIGZ(IDEG)=0.D0
	ZMAS(IDEG)=0.D0
	SIGT(IDEG)=0.D0
	DO IRAT=1,NRAT
	WGAT(IRAT,IDEG)=0.D0
	ENDDO
	DO IMOM=-NMOM,+NMOM
	RLOC(IMOM,IDEG)=0.D0
	DLOC(IMOM,IDEG)=0.D0
	ENDDO
	DO JDEG1=1,NDEG   
	DO JDEG =1,NDEG
	ELOC(IDEG)=ELOC(IDEG)+
     &DTRM(IDEG,JDEG1)*ELEV(JDEG1,JDEG)*DTRM(IDEG,JDEG) ! indexation checked: first index - relativ., second - spherical
	SIGZ(IDEG)=SIGZ(IDEG)+
     &DTRM(IDEG,JDEG1)*SIG0(JDEG1,JDEG)*DTRM(IDEG,JDEG)
	ZMAS(IDEG)=ZMAS(IDEG)+
     &DTRM(IDEG,JDEG1)*BMAS(JDEG1,JDEG)*DTRM(IDEG,JDEG)
	SIGT(IDEG)=SIGT(IDEG)+
     &DTRM(IDEG,JDEG1)*SIGI(JDEG1,JDEG)*DTRM(IDEG,JDEG)
	DO IMOM=-NMOM,+NMOM
	RLOC(IMOM,IDEG)=RLOC(IMOM,IDEG)+
     &DTRM(IDEG,JDEG1)*GMOM(JDEG1,JDEG,IMOM)*DTRM(IDEG,JDEG)
	DLOC(IMOM,IDEG)=DLOC(IMOM,IDEG)+
     &DTRM(IDEG,JDEG1)*DMAT(JDEG1,JDEG,IMOM)*DTRM(IDEG,JDEG)
	ENDDO
	ENDDO
	ENDDO
	ZMAS(IDEG)=ZMAS(IDEG)**2
	ENDDO
	ENDIF
C Find pole expansion for the self-energy
	ALLOCATE(WSIG(NRAT,NDEG))
	ALLOCATE(PSIG(NRAT,NDEG))
	ALLOCATE(VLOC(NDEG,NRAT))
	ALLOCATE(WLOC(NDEG,NRAT))
	ALLOCATE(PLOC(NDEG,NRAT))
	ALLOCATE(OLOC(NDEG,NRAT))
C **********************************************
C Algorithm assuming density moments: 2 poles
	IF(KINT.EQ.1)THEN
	IF(NRAT.NE.2)CALL FULLSTOP('Nrat should be 2')
	DO IDEG=1,NDEG
C Occupied states
	CALL LIB_RATMOM2(             DLOC(0,IDEG),             
     &                              DLOC(1,IDEG),
     &                 WGAT(1,IDEG),WPOL(1,IDEG),-1.D0)
C Unoccupied states
	CALL LIB_RATMOM2(RLOC(0,IDEG)-DLOC(0,IDEG),
     &                 RLOC(1,IDEG)-DLOC(1,IDEG),
     &                 WGAT(2,IDEG),WPOL(2,IDEG),+1.D0)
	ENDDO
C **********************************************
C Algorithm assuming density moments: 4 poles
	ELSEIF(KINT.EQ.2)THEN
	IF(NRAT.NE.4)CALL FULLSTOP('Nrat should be 4')
	DO IDEG=1,NDEG
C Occupied states
	CALL LIB_RATMOM4(              DLOC( 0,IDEG),             
     &                               DLOC( 1,IDEG),
     &                               DLOC( 2,IDEG),
     &                               DLOC(-1,IDEG),
     &                 WGAT( 1,IDEG),WGAT( 2,IDEG),
     &                 WPOL( 1,IDEG),WPOL( 2,IDEG),-1.D0)
C Unoccupied states
	CALL LIB_RATMOM4(RLOC( 0,IDEG)-DLOC( 0,IDEG),
     &                 RLOC( 1,IDEG)-DLOC( 1,IDEG),
     &                 RLOC( 2,IDEG)-DLOC( 2,IDEG),
     &                 RLOC(-1,IDEG)-DLOC(-1,IDEG),
     &                 WGAT( 3,IDEG),WGAT( 4,IDEG),
     &                 WPOL( 3,IDEG),WPOL( 4,IDEG),+1.D0)
      ENDDO
C **********************************************
C Algorithm assuming density moments: 6 poles
	ELSEIF(KINT.EQ.3)THEN
	IF(NRAT.NE.6)CALL FULLSTOP('Nrat should be 6')
	DO IDEG=1,NDEG
C Occupied states
	CALL LIB_RATMOM6(              DLOC( 0,IDEG),
     &                               DLOC( 1,IDEG),
     &                               DLOC( 2,IDEG),
     &                               DLOC( 3,IDEG),
     &                               DLOC(-1,IDEG),
     &                               DLOC(-2,IDEG),
     &   WGAT( 1,IDEG),WGAT( 2,IDEG),WGAT( 3,IDEG),
     &   WPOL( 1,IDEG),WPOL( 2,IDEG),WPOL( 3,IDEG),-1.D0)
C Unoccupied states
	CALL LIB_RATMOM6(RLOC( 0,IDEG)-DLOC( 0,IDEG),
     &                 RLOC( 1,IDEG)-DLOC( 1,IDEG),
     &                 RLOC( 2,IDEG)-DLOC( 2,IDEG),
     &                 RLOC( 3,IDEG)-DLOC( 3,IDEG),
     &                 RLOC(-1,IDEG)-DLOC(-1,IDEG),
     &                 RLOC(-2,IDEG)-DLOC(-2,IDEG),
     &   WGAT( 4,IDEG),WGAT( 5,IDEG),WGAT( 6,IDEG),
     &   WPOL( 4,IDEG),WPOL( 5,IDEG),WPOL( 6,IDEG),+1.D0)
      ENDDO
C **********************************************
C Algorithm assuming arbitrary # of moments
	ELSEIF(KINT.EQ.4)THEN
	IF(MOD(NRAT,2).NE.0)CALL FULLSTOP('<SIGRAT>:: Nrat must be ODD!')
	DO IDEG=1,NDEG
C Occupied states
	CALL LIB_RAPX(DLOC(0,IDEG),NRAT-1,WGAT(1,IDEG),
     &              WPOL(1,IDEG),NRAT/2,IERR,-1.D0,0)
	IF(IERR.GT.0)CALL FULLSTOP('<SIGRAT>:: ERROR IN LIB_RAPX')
C Unoccupied states
	DO IMOM=-NMOM,+NMOM
	ULOC(IMOM,IDEG)=RLOC(IMOM,IDEG)-DLOC(IMOM,IDEG)
	ENDDO
	CALL LIB_RAPX(ULOC(0,IDEG),NRAT-1,WGAT(NRAT/2+1,IDEG),
     &              WPOL(NRAT/2+1,IDEG),NRAT/2,IERR,+1.D0,0)
	IF(IERR.GT.0)CALL FULLSTOP('<SIGRAT>:: ERROR IN LIB_RAPX')
	ENDDO
	ENDIF
C Print poles and coefficients
	WRITE(IUN,10100)
	WRITE(IUN,10110)
      DO IDEG=1,NDEG
      DO IRAT=1,NRAT
	WRITE(IUN,10120)IDEG,IRAT,WPOL(IRAT,IDEG),WGAT(IRAT,IDEG)
	IF(WGAT(IRAT,IDEG).LT.0.D0)THEN
	WHATTODO=1.D0
	WGAT(IRAT,IDEG)=0.D0
	ENDIF
	ENDDO
	ENDDO
10100 FORMAT(1X,'Green Function Pole Expansion Results:')
10110 FORMAT(1X,'iDeg  Pole     Position        Weight')
10120 FORMAT(1X,I3,3X,I3,3X,G12.5,3X,G12.5)
C **********************************************
	ALLOCATE(DENM(NDEG,NDEG))
	M1S1=0
	DO ISPIN1=1,2
	DO M1=-LORB,LORB
	M1S1=M1S1+1
	MS=0
	DO ISPIN=1,2
	DO M =-LORB,LORB
	MS=MS+1
	DENM(M1S1,MS)=(0.D0,0.D0)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C Find rational interpolation for self-energy
	MPOLMAX=0
	IF(NRAT.GT.0)THEN
	DO IDEG=1,NDEG
	CALL IMP_AGFIRAT_COFS(NRAT,WPOL(1,IDEG),WGAT(1,IDEG),ELOC(IDEG),
     & 0.D0,SIGZ(IDEG),SIGT(IDEG),ZMAS(IDEG),MPOL,WSIG(1,IDEG),
     & PSIG(1,IDEG),IERR)
	MPOLMAX=MAX(MPOLMAX,MPOL)
	DO IPOL=1,MPOL
	VLOC(IDEG,IPOL)=SQRT(ABS(WSIG(IPOL,IDEG)))
	WLOC(IDEG,IPOL)=SQRT(ABS(WSIG(IPOL,IDEG)))
	PLOC(IDEG,IPOL)=PSIG(IPOL,IDEG)
	OLOC(IDEG,IPOL)=1.D0
	ENDDO
	DO IPOL=MPOL+1,NRAT
	VLOC(IDEG,IPOL)=0.D0
	WLOC(IDEG,IPOL)=0.D0
	PLOC(IDEG,IPOL)=1.D0
	OLOC(IDEG,IPOL)=1.D0
	ENDDO
	ENDDO
	ENDIF
C Transform to matrix representation
	IF(KSYS.EQ.1)THEN
	M1S1=0
	DO ISPIN1=1,2
	DO M1=-LORB,LORB
	M1S1=M1S1+1
	MS=0
	DO ISPIN=1,2
	DO M =-LORB,LORB
	MS=MS+1
	SRAT(M1S1,MS)=(0.D0,0.D0)
	DENM(M1S1,MS)=(0.D0,0.D0)
	DO IPOL=1,NPOL
	VRAT(M1S1,MS,IPOL)=(0.D0,0.D0)
	WRAT(M1S1,MS,IPOL)=(0.D0,0.D0)
	PRAT(M1S1,MS,IPOL)=(0.D0,0.D0)
	ORAT(M1S1,MS,IPOL)=(0.D0,0.D0)
	ENDDO
	KS=0
	DO JSPIN=1,2
	DO K =-LORB,LORB
	KS=KS+1
	IF(ISPIN1.NE.JSPIN)CYCLE
	IF(ISPIN .NE.JSPIN)CYCLE
      SRAT(M1S1,MS)=SRAT(M1S1,MS)+
     &CONJG(TC(M1,K+LORB+1,LORB))*
     &SIGT(KS)*TC(M,K+LORB+1,LORB)
      DENM(M1S1,MS)=DENM(M1S1,MS)+
     &CONJG(TC(M1,K+LORB+1,LORB))*
     &DLOC(0,KS)*TC(M,K+LORB+1,LORB)
	DO IPOL=1,NPOL
	VRAT(M1S1,MS,IPOL)=VRAT(M1S1,MS,IPOL)+
     &CONJG(TC(M1,K+LORB+1,LORB))*
     &TC(M,K+LORB+1,LORB)*VLOC(KS,IPOL)
	WRAT(M1S1,MS,IPOL)=WRAT(M1S1,MS,IPOL)+
     &CONJG(TC(M1,K+LORB+1,LORB))*
     &TC(M,K+LORB+1,LORB)*WLOC(KS,IPOL)
	PRAT(M1S1,MS,IPOL)=PRAT(M1S1,MS,IPOL)+
     &CONJG(TC(M1,K+LORB+1,LORB))*
     &TC(M,K+LORB+1,LORB)*PLOC(KS,IPOL)
	ORAT(M1S1,MS,IPOL)=ORAT(M1S1,MS,IPOL)+
     &CONJG(TC(M1,K+LORB+1,LORB))*
     &TC(M,K+LORB+1,LORB)*OLOC(KS,IPOL)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ELSEIF(KSYS.EQ.2)THEN
	M1S1=0
	DO ISPIN1=1,2
	DO M1=-LORB,LORB
	M1S1=M1S1+1
	MS=0
	DO ISPIN=1,2
	DO M =-LORB,LORB
	MS=MS+1
      SRAT(M1S1,MS)=(0.D0,0.D0)
      DENM(M1S1,MS)=(0.D0,0.D0)
	IF(M1S1.EQ.MS)
     &SRAT(MS,MS)=SIGT(MS)
	IF(M1S1.EQ.MS)
     &DENM(MS,MS)=DLOC(0,MS)
	DO IPOL=1,NPOL
	VRAT(M1S1,MS,IPOL)=(0.D0,0.D0)
	WRAT(M1S1,MS,IPOL)=(0.D0,0.D0)
	PRAT(M1S1,MS,IPOL)=(0.D0,0.D0)
	ORAT(M1S1,MS,IPOL)=(0.D0,0.D0)
	IF(M1S1.EQ.MS)THEN
	VRAT(MS,MS,IPOL)=VLOC(MS,IPOL)
	WRAT(MS,MS,IPOL)=WLOC(MS,IPOL)
	PRAT(MS,MS,IPOL)=PLOC(MS,IPOL)
	ORAT(MS,MS,IPOL)=OLOC(MS,IPOL)
	ENDIF
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ELSEIF(KSYS.EQ.3)THEN
	DO IDEG1=1,NDEG
	DO IDEG =1,NDEG
	SRAT(IDEG1,IDEG)=(0.D0,0.D0)
	DENM(IDEG1,IDEG)=(0.D0,0.D0)
	DO IPOL=1,NPOL
	VRAT(IDEG1,IDEG,IPOL)=(0.D0,0.D0)
	WRAT(IDEG1,IDEG,IPOL)=(0.D0,0.D0)
	PRAT(IDEG1,IDEG,IPOL)=(0.D0,0.D0)
	ORAT(IDEG1,IDEG,IPOL)=(0.D0,0.D0)
	ENDDO
	DO JDEG =1,NDEG
	SRAT(IDEG1,IDEG)=SRAT(IDEG1,IDEG)+
     &TREL(JDEG,IDEG1)*SIGT(JDEG)*TREL(JDEG,IDEG) ! indexation checked: first index - relativ., second - spherical
	DENM(IDEG1,IDEG)=DENM(IDEG1,IDEG)+
     &TREL(JDEG,IDEG1)*DLOC(0,JDEG)*TREL(JDEG,IDEG) ! indexation checked: first index - relativ., second - spherical
	DO IPOL=1,NPOL
	VRAT(IDEG1,IDEG,IPOL)=VRAT(IDEG1,IDEG,IPOL)+
     &TREL(JDEG,IDEG1)*VLOC(JDEG,IPOL)*TREL(JDEG,IDEG)
	WRAT(IDEG1,IDEG,IPOL)=WRAT(IDEG1,IDEG,IPOL)+
     &TREL(JDEG,IDEG1)*WLOC(JDEG,IPOL)*TREL(JDEG,IDEG)
	PRAT(IDEG1,IDEG,IPOL)=PRAT(IDEG1,IDEG,IPOL)+
     &TREL(JDEG,IDEG1)*PLOC(JDEG,IPOL)*TREL(JDEG,IDEG)
	ORAT(IDEG1,IDEG,IPOL)=ORAT(IDEG1,IDEG,IPOL)+
     &TREL(JDEG,IDEG1)*OLOC(JDEG,IPOL)*TREL(JDEG,IDEG)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C External Transformation
	ELSE
	DO IDEG1=1,NDEG
	DO IDEG =1,NDEG
	SRAT(IDEG1,IDEG)=(0.D0,0.D0)
	DENM(IDEG1,IDEG)=(0.D0,0.D0)
	DO IPOL=1,NPOL
	VRAT(IDEG1,IDEG,IPOL)=(0.D0,0.D0)
	WRAT(IDEG1,IDEG,IPOL)=(0.D0,0.D0)
	PRAT(IDEG1,IDEG,IPOL)=(0.D0,0.D0)
	ORAT(IDEG1,IDEG,IPOL)=(0.D0,0.D0)
	ENDDO
	DO JDEG =1,NDEG
	SRAT(IDEG1,IDEG)=SRAT(IDEG1,IDEG)+
     &RTRM(JDEG,IDEG1)*SIGT(JDEG)*RTRM(JDEG,IDEG) ! indexation checked: first index - relativ., second - spherical
	DENM(IDEG1,IDEG)=DENM(IDEG1,IDEG)+
     &RTRM(JDEG,IDEG1)*DLOC(0,JDEG)*RTRM(JDEG,IDEG) ! indexation checked: first index - relativ., second - spherical
	DO IPOL=1,NPOL
	VRAT(IDEG1,IDEG,IPOL)=VRAT(IDEG1,IDEG,IPOL)+
     &RTRM(JDEG,IDEG1)*VLOC(JDEG,IPOL)*RTRM(JDEG,IDEG)
	WRAT(IDEG1,IDEG,IPOL)=WRAT(IDEG1,IDEG,IPOL)+
     &RTRM(JDEG,IDEG1)*WLOC(JDEG,IPOL)*RTRM(JDEG,IDEG)
	PRAT(IDEG1,IDEG,IPOL)=PRAT(IDEG1,IDEG,IPOL)+
     &RTRM(JDEG,IDEG1)*PLOC(JDEG,IPOL)*RTRM(JDEG,IDEG)
	ORAT(IDEG1,IDEG,IPOL)=ORAT(IDEG1,IDEG,IPOL)+
     &RTRM(JDEG,IDEG1)*OLOC(JDEG,IPOL)*RTRM(JDEG,IDEG)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDIF
C Print spin and orbital moments
      TOTDEN1=0.D0
      SPZMOM1=0.D0
      ORBMOM1=0.D0
      TOTDEN2=0.D0
      SPZMOM2=0.D0
      ORBMOM2=0.D0
      TOTDEN3=0.D0
      SPZMOM3=0.D0
      ORBMOM3=0.D0
	MS=0
	DO ISPIN=1,2
	DO M =-LORB,LORB
	MS=MS+1
      TOTDEN1=TOTDEN1+DMAT(MS,MS,0)
      SPZMOM1=SPZMOM1-DMAT(MS,MS,0)*(-1)**ISPIN
      ORBMOM1=ORBMOM1+DMAT(MS,MS,0)*DBLE(M)
      TOTDEN2=TOTDEN2+DENM(MS,MS)
      SPZMOM2=SPZMOM2-DENM(MS,MS)*(-1)**ISPIN
      ORBMOM2=ORBMOM2+DENM(MS,MS)*DBLE(M)
      DO IMSC=0,NMSC
      IF(KGRD.EQ.1)THEN
      TOTDEN3=TOTDEN3+(-DIMAG(GLOC(MS,MS,IMSC))/PI)*FMSC(IMSC)*
     &FERMIFUN(DREAL(WMSC(IMSC)),TEMP)
      SPZMOM3=SPZMOM3-(-DIMAG(GLOC(MS,MS,IMSC))/PI)*FMSC(IMSC)*
     &(-1)**ISPIN*FERMIFUN(DREAL(WMSC(IMSC)),TEMP)
      ORBMOM3=ORBMOM3+(-DIMAG(GLOC(MS,MS,IMSC))/PI)*FMSC(IMSC)*
     &DBLE(M)*FERMIFUN(DREAL(WMSC(IMSC)),TEMP)
      ELSEIF(KGRD.EQ.2.AND.ABS(WMSC(IMSC)).GE.1.D-10)THEN
      TOTDEN3=TOTDEN3+DREAL(GLOC(MS,MS,IMSC)-1.D0/WMSC(IMSC))*
     &FMSC(IMSC)*2.D0*TEMP
      SPZMOM3=SPZMOM3-DREAL(GLOC(MS,MS,IMSC)-1.D0/WMSC(IMSC))*
     &FMSC(IMSC)*2.D0*TEMP*(-1)**ISPIN
      ORBMOM3=ORBMOM3+DREAL(GLOC(MS,MS,IMSC)-1.D0/WMSC(IMSC))*
     &FMSC(IMSC)*2.D0*TEMP*DBLE(M)
      ENDIF
      ENDDO
      IF(KGRD.EQ.2)TOTDEN3=TOTDEN3+0.5D0
      ENDDO
      ENDDO
	WRITE(IUN,10150)
	WRITE(IUN,10160)TOTDEN1,SPZMOM1,ORBMOM1
	WRITE(IUN,10170)TOTDEN2,SPZMOM2,ORBMOM2
	WRITE(IUN,10180)TOTDEN3,SPZMOM3,ORBMOM3
10150 FORMAT(1X,'Atomic Density    Spin Moment   Orbital Moment')
10160 FORMAT(1X,G14.7,3X,G14.7,3X,G14.7,' ! Plane Atomic')
10170 FORMAT(1X,G14.7,3X,G14.7,3X,G14.7,' ! Rational Fit')
10180 FORMAT(1X,G14.7,3X,G14.7,3X,G14.7,' ! Num.Integral')
C Shift poles to complex plane
	DO IDEG=1,NDEG
	DO IPOL=1,NPOL
	PRAT(IDEG,IDEG,IPOL)=PRAT(IDEG,IDEG,IPOL)-DCMPLX(0.D0,DAMP)
      ENDDO
      ENDDO
C Print Green functions calculated by various schemes
	ALLOCATE(GAGF(NDEG,NDEG))
	ALLOCATE(GSIG(NDEG,NDEG))
	ALLOCATE(GPOL(NDEG,NDEG))
	ALLOCATE(SIGP(NDEG,NDEG))
	IF(KVRB.EQ.1)WRITE(IUN,10210)
	DO 2000 IMSC=0,NMSC          ! over imsc
      ZMSC=WMSC(IMSC)           
	M1S1=0
	DO ISPIN1=1,2                   ! over ispin1
	DO M1=-L,L                      ! over m1
	M1S1=M1S1+1
	MS=0
	DO ISPIN=1,2                    ! over ispin
	DO M=-L,L                       ! over m
	MS=MS+1
	GAGF(M1S1,MS)=GLOC(M1S1,MS,IMSC)
	GSIG(M1S1,MS)=(0.D0,0.D0)
	GPOL(M1S1,MS)=(0.D0,0.D0)
	SIGP(M1S1,MS)=SRAT(M1S1,MS)
	ENDDO                           ! over m
	ENDDO                           ! over ispin
	ENDDO                           ! over m1
	ENDDO                           ! over ispin1
C Green function from self-energy
	M1S1=0
	DO ISPIN1=1,2                   ! over ispin1
	DO M1=-L,L                      ! over m1
	M1S1=M1S1+1
	MS=0
	DO ISPIN=1,2                    ! over ispin
	DO M=-L,L                       ! over m
	MS=MS+1
	IF(M1S1.EQ.MS)DI=1.D0
	IF(M1S1.NE.MS)DI=0.D0
	GSIG(M1S1,MS)=(WMSC(IMSC)+CHEM)*DI-
     &          ELEV(M1S1,MS)-SIGW(M1S1,MS,IMSC)
	ENDDO                           ! over m
	ENDDO                           ! over ispin
	ENDDO                           ! over m1
	ENDDO                           ! over ispin1
	CALL LIB_CINV(NDEG,GSIG,NDEG,WORK,IFAIL)
	IF(IFAIL.NE.0)THEN
      WRITE(IUN,*)'<IMP_SIGRAT>:: Error in inversion program'
	DO IDEG1=1,NDEG
	DO IDEG =1,NDEG
	GINV(IDEG1,IDEG)=(0.D0,0.D0)
      ENDDO	
      ENDDO	
	ENDIF
C Green function from pole expansion
	DO IPOL=1,NPOL                  ! over poles
	DO IDEG1=1,NDEG
	DO IDEG =1,NDEG
	GINV(IDEG1,IDEG)=
     &(ZMSC+DCMPLX(0.D0,0.D0))*
     & ORAT(IDEG1,IDEG,IPOL)-PRAT(IDEG1,IDEG,IPOL)
	ENDDO
	ENDDO
C Invert matrix
	CALL LIB_CINV(NDEG,GINV,NDEG,WORK,IFAIL)
	IF(IFAIL.NE.0)THEN
      WRITE(IUN,*)'<IMP_SIGRAT>:: Error in inversion program'
	DO IDEG1=1,NDEG
	DO IDEG =1,NDEG
	GINV(IDEG1,IDEG)=(0.D0,0.D0)
	ENDDO
	ENDDO
	ENDIF
C Construct product
	DO IDEG1=1,NDEG
	DO IDEG=1,NDEG
	DO JDEG1=1,NDEG
	DO JDEG=1,NDEG
	SIGP(IDEG1,IDEG)=SIGP(IDEG1,IDEG)+
     &VRAT(IDEG1,JDEG1,IPOL)*GINV(JDEG1,JDEG)*
     &WRAT(JDEG,IDEG,IPOL) ! swapped indexes in Warr !
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO                           ! over poles
C Green function from pole expansion
	M1S1=0
	DO ISPIN1=1,2                   ! over ispin1
	DO M1=-L,L                      ! over m1
	M1S1=M1S1+1
	MS=0
	DO ISPIN=1,2                    ! over ispin
	DO M=-L,L                       ! over m
	MS=MS+1
	IF(M1S1.EQ.MS)DI=1.D0
	IF(M1S1.NE.MS)DI=0.D0
	GPOL(M1S1,MS)=(WMSC(IMSC)+CHEM)*DI-
     &          ELEV(M1S1,MS)-SIGP(M1S1,MS)
	ENDDO                           ! over m
	ENDDO                           ! over ispin
	ENDDO                           ! over m1
	ENDDO                           ! over ispin1
	CALL LIB_CINV(NDEG,GPOL,NDEG,WORK,IFAIL)
	IF(IFAIL.NE.0)THEN
      WRITE(IUN,*)'<IMP_SIGRAT>:: Error in inversion program'
      DO IDEG1=1,NDEG	
      DO IDEG =1,NDEG	
      GPOL(IDEG1,IDEG)=(0.D0,0.D0)
      ENDDO
      ENDDO
	ENDIF
C Print traces of Green functions
	GTRA=0.D0
	GTRS=0.D0
	GTRP=0.D0
	STRA=0.D0
	STRP=0.D0
	MS=0
	DO ISPIN=1,2                    ! over ispin
	DO M=-L,L                       ! over m
	MS=MS+1
	GTRA=GTRA+GAGF(MS,MS)
	GTRS=GTRS+GSIG(MS,MS)
	GTRP=GTRP+GPOL(MS,MS)
	STRA=STRA+SIGW(MS,MS,IMSC)
	STRP=STRP+SIGP(MS,MS)
	ENDDO                           ! over m
	ENDDO                           ! over ispin
	IF(KGRD.EQ.1)WOMG=DREAL(WMSC(IMSC))
	IF(KGRD.EQ.2)WOMG=DIMAG(WMSC(IMSC))
	IF(KVRB.EQ.1)
     &WRITE(IUN,10220)WOMG,
     &DREAL(GTRA),DREAL(GTRS),DREAL(GTRP),DREAL(STRA),DREAL(STRP),
     &DIMAG(GTRA),DIMAG(GTRS),DIMAG(GTRP),DIMAG(STRA),DIMAG(STRP)
C Force rational form for self-energy
      IF(KRAT.EQ.1)THEN
	DO IDEG1=1,NDEG
	DO IDEG=1,NDEG
	SIGW(IDEG1,IDEG,IMSC)=SIGP(IDEG1,IDEG)
	ENDDO
	ENDDO
      ENDIF
 2000 CONTINUE                        ! over frequencies
10210 FORMAT(5X,'Omega',8X,'Re(Gagf)',7X,'Re(Gsig)',7X,'Re(Gpol)',
     &       7X,'Re(SigW)',7X,'Re(SigP)',
     &                  6X,'Im(Gagf)',7X,'Im(Gsig)',7X,'Im(Gpol)',
     &       7X,'Im(SigW)',7X,'Im(SigP)')
10220 FORMAT(11(1X,G14.7))
C MEMORY DEALLOCATIONS
	DEALLOCATE(DENM,GINV,WORK)
	DEALLOCATE(TREL,ELOC,WGAT,WSIG,PSIG,RLOC,DLOC,ULOC,WPOL)
	DEALLOCATE(SIGT,SIGZ,ZMAS,VLOC,WLOC,PLOC,OLOC)
	DEALLOCATE(GAGF,GSIG,GPOL,SIGP)
	END
