	SUBROUTINE IMP_SUNSBMF_HEAD(NDEG,EATS,TPAR,UPAR,
     &  ELOC,DEL,GFF,SIG,PSIK,IFIX,ZMASS,ZSUM,ZPSI,KFIX,
     &  TEMP,NMSC,WMSC,FMSC,DAMP,IERR)
*******************************************************
* Computes effective mass renormalization             *
*******************************************************
      USE COM_LMTOUT  ,ONLY: SCRFILE                               !!! from readini
      USE COM_CHANNELS,ONLY: IUBIM                                 !!! from channels
      USE COM_MASHDEP ,ONLY: NVAL,LENCMP                           !!! from setup
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                       !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8, ALLOCATABLE :: COMB(:,:)
	REAL*8, ALLOCATABLE :: ELEV(:)
C Passed parameters
	INTEGER IFIX(0:NDEG)
	DIMENSION  PSIK(0:NDEG),EATS(0:NDEG),FMSC(0:NMSC)
	COMPLEX*16 DEL(0:NMSC+1),GFF(0:NMSC+1),SIG(0:NMSC+1),WMSC(0:NMSC)
	CHARACTER HELP*40,TCTRL*10,TCTRM*10,LIB_TDP*10
	DATA PI/3.141592653589793D0/
C MEMORY ALlOCATIONS:
	ALLOCATE(ELEV(0:NDEG))
	ALLOCATE(COMB(0:NDEG,0:NDEG))
C START CODE:
	CALL LIB_GETCOMB(COMB,NDEG)
C LEVELS WITHIN SU(N)
	EDOP=ELOC+DBLE(NDEG-1)/2.D0*UPAR
	DO IDEG=0,NDEG
	ELEV(IDEG)=(DBLE(IDEG)-DBLE(NDEG-1)/2.D0)*UPAR
	EATS(IDEG)=ELOC*DBLE(IDEG)+UPAR*DBLE(IDEG*(IDEG-1))/2.D0
	ENDDO
C PRINT
	WRITE(IUN,10010)
	WRITE(IUN,10020)TEMP
	WRITE(IUN,10030)UPAR
	WRITE(IUN,10040)EDOP
	WRITE(IUN,10050)ELOC
	WRITE(IUN,10060)NDEG
	WRITE(IUN,10070)NMSC
10010	FORMAT(1X,'Solving impurity model at low frequencies:')
10020	FORMAT(1X,'Temp = ',G12.5)
10030	FORMAT(1X,'Upar = ',G12.5)
10040	FORMAT(1X,'Edop = ',G12.5)
10050	FORMAT(1X,'Eloc = ',G12.5)
10060	FORMAT(1X,'Ndeg = ',I5)
10070	FORMAT(1X,'Nmsc = ',I5)
	CALL IMP_SUNSBMF_PSIK(NDEG,TPAR,UPAR,EATS,ELEV,EDOP,
     &    ELOC,COMB,DEL,GFF,SIG,PSIK,IFIX,ZMASS,DSUM,ZSUM,
     &    KFIX,TEMP,NMSC,WMSC,FMSC,DAMP,IERR)
C Estimate charge
	ZPSI=0.D0
	DO IDEG=1,NDEG
	ZPSI=ZPSI+DBLE(NDEG)*COMB(IDEG-1,NDEG-1)*PSIK(IDEG)**2
	ENDDO
	WRITE(IUN,10120)
	PSUM=0.D0
	ZPSI=0.D0
	DO IDEG=0,NDEG
	PSUM=PSUM+COMB(IDEG,NDEG)*PSIK(IDEG)**2
	IF(IDEG.GT.0)
     &ZPSI=ZPSI+DBLE(NDEG)*COMB(IDEG-1,NDEG-1)*PSIK(IDEG)**2
	TCTRL=LIB_TDP(COMB(IDEG,NDEG)*PSIK(IDEG)**2,1.D-10)
	TCTRM=LIB_TDP(EATS(IDEG),1.D-10)
	WRITE(IUN,10130)IFIX(IDEG),TCTRL,IDEG,TCTRM
	ENDDO
	WRITE(IUN,10140)PSUM,ZSUM,ZPSI
	WRITE(IUN,10150)DSUM,ZMASS,DREAL(SIG(0))
C MEMORY DEALLOCATIONS
	DEALLOCATE(COMB,ELEV)
10120	FORMAT(1X,'f     <Xn>     n     <En>')
10130	FORMAT(1X,I1,1X,A10,1X,I3,1X,A10)
10140	FORMAT(1X,'Norm = ',G12.5,1X,'; Zsum = ',G12.5,'; Zpsi = ',G12.5)
10150 FORMAT(1X,'D*Gg = ',G12.5,1X,'; Mass = ',G12.5,'; Sig(0)=',G12.5)
	END








	SUBROUTINE IMP_SUNSBMF_PSIK(NDEG,TPAR,UPAR,
     &           EATS,ELEV,EDOP,ELOC,COMB,DEL,GFF,SIG,PSIK,
     &           IFIX,ZMASS,DSUM,ZSUM,KFIX,
     &           TEMP,NMSC,WMSC,FMSC,DAMP,IERR)
*****************************************************************
*  Solves Anderson impurity model by iterations                 *
*  Zero-configurational width approximation is used.            *
*  Essential input:                                             *
*    WMSC - logaritmic Matsubara grid                           *
*    FMSC - weight to compute Matsubara sum                     *
*    DEL - hybridization function                               *
*  Essential output                                             *
*    ZMASS - Mass renormalization                               *
*  Method: based on low frequency expansion                     *
*  which predicts correct effective mass renormalizaton.        *
*****************************************************************
      USE COM_LMTOUT  ,ONLY: SCRFILE                               !!! from readini
      USE COM_CHANNELS,ONLY: IUBIM                                 !!! from channels
      USE COM_MASHDEP ,ONLY: NVAL,LENCMP                           !!! from setup
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                       !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
C Passed parameters
	INTEGER IFIX(0:NDEG)
	DIMENSION PSIK(0:NDEG),EATS(0:NDEG),ELEV(0:NDEG)
     &    ,COMB(0:NDEG,0:NDEG),FMSC(0:NMSC)
	COMPLEX*16 DEL(0:NMSC+1),GFF(0:NMSC+1),SIG(0:NMSC+1),WMSC(0:NMSC)
C Allocatable arrays
	REAL*8, ALLOCATABLE :: PSIN(:)
	REAL*8, ALLOCATABLE :: XSTA(:)
	REAL*8, ALLOCATABLE :: AMAS(:)
	REAL*8, ALLOCATABLE :: WTER(:)
	REAL*8, ALLOCATABLE :: FNOM(:)
	REAL*8, ALLOCATABLE :: WDIM(:)
	COMPLEX*16, ALLOCATABLE :: XINP(:)
	COMPLEX*16, ALLOCATABLE :: XOUT(:)
	COMPLEX*16, ALLOCATABLE :: BETA(:,:)
	COMPLEX*16, ALLOCATABLE :: CMAT(:,:)
	COMPLEX*16, ALLOCATABLE :: GAMA(:,:)
	COMPLEX*16, ALLOCATABLE :: WBRO(:)
	COMPLEX*16, ALLOCATABLE :: WINP(:)
	COMPLEX*16, ALLOCATABLE :: WMIX(:,:)
	COMPLEX*16, ALLOCATABLE :: DELF(:)
	COMPLEX*16, ALLOCATABLE :: UVEC(:)
	COMPLEX*16, ALLOCATABLE :: ELAR(:)
	COMPLEX*16, ALLOCATABLE :: AMAT(:,:)
	COMPLEX*16, ALLOCATABLE :: OMAT(:,:)
	COMPLEX*16, ALLOCATABLE :: GFG(:)
C Local variables
	COMPLEX*16 DIM,PHS,PSI
	DATA PI/3.141592653589793D0/,DIM/(0.D0,1.D0)/
     &    ,EPS/1.D-10/,NITER/300/,NIBRD/15/,ADMIX/0.35D0/
C Memory Allocations
	ALLOCATE(PSIN(0:NDEG))
	ALLOCATE(XSTA(0:NDEG))
	ALLOCATE(ELAR(0:NDEG))
	ALLOCATE(AMAS(0:NDEG))
	ALLOCATE(AMAT(0:NDEG,0:NDEG))
	ALLOCATE(OMAT(0:NDEG,0:NDEG))
	ALLOCATE(WTER(0:NIBRD))
	ALLOCATE(FNOM(NIBRD))
	ALLOCATE(BETA(NIBRD,NIBRD))
	ALLOCATE(CMAT(NIBRD,NIBRD))
	ALLOCATE(GAMA(NIBRD,NIBRD))
	ALLOCATE(WBRO(NIBRD))
	ALLOCATE(WINP(NIBRD))
	ALLOCATE(WMIX(NIBRD,NIBRD))
	ALLOCATE(WDIM(NDEG+1))
	ALLOCATE(XINP(NDEG+1))
	ALLOCATE(XOUT(NDEG+1))
	ALLOCATE(DELF(0:NDEG))
	ALLOCATE(UVEC(0:NDEG))
	ALLOCATE(GFG(0:NMSC))
C START CODE:
	IERR=0
C Start from non-interacting case
	CALL IMP_SUNSBMF_XNOT(NDEG,ELEV,EDOP,TEMP,COMB,XSTA)
	PSUM=0.D0
	DO IDEG=0,NDEG
	PSUM=PSUM+COMB(IDEG,NDEG)
	ENDDO
	DO IDEG=0,NDEG
	IF(KFIX.EQ.0.AND.IFIX(IDEG).EQ.0)
     &PSIK(IDEG)=1.D0/SQRT(PSUM)       ! non-interacting case
C    &PSIK(IDEG)=SQRT(ABS(XSTA(IDEG))) ! statistical weights case does not work well
	ENDDO
C NORMALIZE
	PSUM=0.D0
	DO IDEG=0,NDEG
	PSUM=PSUM+COMB(IDEG,NDEG)*PSIK(IDEG)**2
	ENDDO
	DO IDEG=0,NDEG
	PSIK(IDEG)=ABS(PSIK(IDEG))/SQRT(PSUM)
	ENDDO
C Initialize Broyden routine
	NDIM=NDEG+1
	IDIM=0
	DO IDEG=0,NDEG
	IDIM=IDIM+1
	XINP(IDIM)=DCMPLX(PSIK(IDEG),0.D0)
	WDIM(IDIM)=1.D0
	ENDDO
      CALL LIB_BROY6(XINP,XOUT,WDIM,DELF,UVEC,NDIM,0,ADMIX,WTER,
     &WBRO,WINP,WMIX,FNOM,BETA,CMAT,GAMA,NIBRD,NVAL,IUBIM,
     &SCRFILE(IUBIM),IERR)
C Start iterating:
	MTER=0
	DO 1000 ITER=1,NITER
	MTER=MTER+1
C Estimate charge
	ZPSI=0.D0
	DO IDEG=1,NDEG
	ZPSI=ZPSI+DBLE(NDEG)*COMB(IDEG-1,NDEG-1)*PSIK(IDEG)**2
	ENDDO
C Compute Left
	DLEFT=1.D0
	DO IDEG=1,NDEG
	DLEFT=DLEFT-COMB(IDEG-1,NDEG-1)*PSIK(IDEG)**2
	ENDDO
	IF(ABS(DLEFT).NE.0.D0)
     &DLEFT=1.D0/SQRT(ABS(DLEFT))
C Compute Right
	DRITE=1.D0
	DO IDEG=0,NDEG-1
	DRITE=DRITE-COMB(IDEG,NDEG-1)*PSIK(IDEG)**2	
	ENDDO
	IF(ABS(DRITE).NE.0.D0)
     &DRITE=1.D0/SQRT(ABS(DRITE))
C Compute Bmass
	BMASS=0.D0
	DO IDEG=1,NDEG
	BMASS=BMASS+PSIK(IDEG)*PSIK(IDEG-1)*COMB(IDEG-1,NDEG-1)*
     &DLEFT*DRITE
	ENDDO
C Compute Lagrange multiplier Dlam which makes Ztot=Zsum
	JTER=0
	E1=-TPAR
	E2=+TPAR
	CALL LIB_FINDROOT(DLAM,ZDIF,E1,E2,JTER,IEXIT,IUN,1.D-05,50)
 100	JTER=JTER+1
C Find new Greens function
	DO IMSC=0,NMSC
	GFG(IMSC)=1.D0/(WMSC(IMSC)-DLAM-BMASS**2*DEL(IMSC))
	ENDDO
C Find new sum
	ZSUM=0.D0
	DO IMSC=0,NMSC
	IF(ABS(WMSC(IMSC)).LE.1.D-14)CYCLE
      ZSUM=ZSUM+2.D0*TEMP*DREAL(GFG(IMSC)-1.D0/(WMSC(IMSC)))*
     &FMSC(IMSC)
	ENDDO
	ZSUM=DBLE(NDEG)*(ZSUM+0.5D0)
	ZDIF=ZSUM-ZPSI
	CALL LIB_FINDROOT(DLAM,ZDIF,E1,E2,JTER,IEXIT,IUN,1.D-05,50)
	IF(IEXIT.EQ.1)GOTO 200
	GOTO 100
  200 CONTINUE
C Find new Greens function
	DO IMSC=0,NMSC
	GFG(IMSC)=1.D0/(WMSC(IMSC)-DLAM-BMASS**2*DEL(IMSC))
	ENDDO
C Find new sum
	DSUM=0.D0
	ZSUM=0.D0
	DO IMSC=0,NMSC
	IF(ABS(WMSC(IMSC)).LE.1.D-14)CYCLE
      ZSUM=ZSUM+2.D0*TEMP*DREAL(GFG(IMSC)-1.D0/(WMSC(IMSC)))*
     &FMSC(IMSC)
      DSUM=DSUM+2.D0*TEMP*DREAL(GFG(IMSC)*DEL(IMSC))*FMSC(IMSC)
	ENDDO
	ZSUM=DBLE(NDEG)*(ZSUM+0.5D0)
	IF(KFIX.EQ.1)GOTO 2000
C Prepare Matrix
	DO IDEG=0,NDEG
	DO JDEG=0,NDEG
	AMAT(IDEG,JDEG)=(0.D0,0.D0)
	OMAT(IDEG,JDEG)=(0.D0,0.D0)
	IF(IDEG.EQ.JDEG+1)
     &AMAT(IDEG,JDEG)=AMAT(IDEG,JDEG)+DBLE(IDEG)*
     &DSUM*BMASS*DLEFT*DRITE
	IF(IDEG.EQ.JDEG-1)
     &AMAT(IDEG,JDEG)=AMAT(IDEG,JDEG)+DBLE(NDEG-IDEG)*
     &DSUM*BMASS*DLEFT*DRITE
	ENDDO
	OMAT(IDEG,IDEG)=(1.D0,0.D0)
	AMAT(IDEG,IDEG)=AMAT(IDEG,IDEG)+
     &EATS(IDEG)-DBLE(IDEG)*DLAM+
     &DBLE(     IDEG)*BMASS**2*DSUM*DLEFT**2+
     &DBLE(NDEG-IDEG)*BMASS**2*DSUM*DRITE**2
	ENDDO
	CALL LIB_CMPEIG1A(NDEG+1,AMAT,OMAT,ELAR,1,1,1,IFAIL,0,1.D-05)
	IF(IFAIL.NE.0)
     &CALL FULLSTOP('<IMP_SUNSBMF_PSIK> :: Error in diagonalization')
C Search for correct root:
	IROT=0
	NROT=0
	DO IBND=0,NDEG
	PHS=(0.D0,0.D0)
	AMAS(IBND)=0.D0
	DO IDEG=0,NDEG
	IF(ABS(OMAT(IDEG,IBND)).LE.1.D-08)CYCLE
	PHS=OMAT(IDEG,IBND)/ABS(OMAT(IDEG,IBND))
	IF(ABS(OMAT(IDEG,IBND)).GT.1.D-08)EXIT
	ENDDO
	IF(ABS(PHS).LE.1.D-10)
     &CALL FULLSTOP('IMP_SUNSBMF_PSIK>:: Wrong Phase')
	DO IDEG=0,NDEG
	OMAT(IDEG,IBND)=OMAT(IDEG,IBND)/PHS
	IF(DIMAG(OMAT(IDEG,IBND)).GT.1.D-05.OR.
     &   DIMAG(ELAR(IBND)).GT.1.D-05)
     &WRITE(IUN,*)'Complex Solutions, imaginary parts =',
     &DIMAG(OMAT(IDEG,IBND)),DIMAG(ELAR(IBND))
	ENDDO
C Check norm
	PSUM=0.D0
	DO IDEG=0,NDEG
	PSUM=PSUM+COMB(IDEG,NDEG)*
     &OMAT(IDEG,IBND)*DCONJG(OMAT(IDEG,IBND))
	ENDDO
	DO IDEG=0,NDEG
	OMAT(IDEG,IBND)=OMAT(IDEG,IBND)/SQRT(PSUM)
	ENDDO
C Set mass renormalization
	DLEFT=1.D0
	DRITE=1.D0
	DO IDEG=0,NDEG
	IF(IDEG.GT.0)
     &DLEFT=DLEFT-COMB(IDEG-1,NDEG-1)*
     &OMAT(IDEG,IBND)*DCONJG(OMAT(IDEG,IBND))
	IF(IDEG.LT.NDEG)
     &DRITE=DRITE-COMB(IDEG,NDEG-1)*
     &OMAT(IDEG,IBND)*DCONJG(OMAT(IDEG,IBND))
	IF(IDEG.GT.0)
     &AMAS(IBND)=AMAS(IBND)+COMB(IDEG-1,NDEG-1)*
     &DREAL(OMAT(IDEG,IBND))*DREAL(OMAT(IDEG-1,IBND))
	ENDDO
	IF(ABS(DLEFT).NE.0.D0)
     &DLEFT=1.D0/SQRT(ABS(DLEFT))
	IF(ABS(DRITE).NE.0.D0)
     &DRITE=1.D0/SQRT(ABS(DRITE))
	AMAS(IBND)=AMAS(IBND)*DLEFT*DRITE
	ENDDO
C Usually correct root has the lowest eigenvalue (1st one)
	IROT=0
	DLAR=DREAL(ELAR(IROT))
	IF(AMAS(IROT).LE.1.D-12)THEN
C	WRITE(IUN,*)'Wrong mass renormalization!'
	AMAS(IROT)=ABS(AMAS(IROT))
	ENDIF
C Set new Psik's
	DO IDEG=0,NDEG
	IF(IFIX(IDEG).EQ.0)
     &PSIN(IDEG)=ABS(DREAL(OMAT(IDEG,IROT)))
	IF(IFIX(IDEG).NE.0)
     &PSIN(IDEG)=PSIK(IDEG)
	ENDDO
C Check norm
	PSUM=0.D0
	DO IDEG=0,NDEG
	PSUM=PSUM+COMB(IDEG,NDEG)*PSIN(IDEG)**2
	ENDDO
	DO IDEG=0,NDEG
	PSIN(IDEG)=PSIN(IDEG)/SQRT(PSUM)
	ENDDO
C Compare with the old results
	PDIF=0.D0
	DO IDEG=0,NDEG
	PDIF=PDIF+(COMB(IDEG,NDEG)*(PSIK(IDEG)-PSIN(IDEG)))**2
	ENDDO
	IF(PDIF.LE.EPS.AND.ITER.GT.1) GOTO 2000
C Send result to Broyden
	IDIM=0
	DO IDEG=0,NDEG
	IDIM=IDIM+1
	XINP(IDIM)=DCMPLX(PSIN(IDEG),0.D0)
	ENDDO
      CALL LIB_BROY6(XINP,XOUT,WDIM,DELF,UVEC,NDIM,MTER,ADMIX,WTER,
     &WBRO,WINP,WMIX,FNOM,BETA,CMAT,GAMA,NIBRD,NVAL,IUBIM,
     &SCRFILE(IUBIM),IERR)
C Set new coefficients predicted by Broyden
	IDIM=0
	DO IDEG=0,NDEG
	IDIM=IDIM+1
	IF(IFIX(IDEG).EQ.0)
     &PSIK(IDEG)=DREAL(XOUT(IDIM))
	ENDDO
	PSUM=0.D0
	DO IDEG=0,NDEG
	PSUM=PSUM+COMB(IDEG,NDEG)*PSIK(IDEG)**2
	ENDDO
	DO IDEG=0,NDEG
	PSIK(IDEG)=ABS(PSIK(IDEG))/SQRT(PSUM)
	ENDDO
C Restart Broyden
	IF(MTER.GE.NIBRD-1)THEN
	IDIM=0
	DO IDEG=0,NDEG
	IDIM=IDIM+1
	XINP(IDIM)=DCMPLX(PSIK(IDEG),0.D0)
	ENDDO
	MTER=0
      CALL LIB_BROY6(XINP,XOUT,WDIM,DELF,UVEC,NDIM,0,ADMIX,WTER,
     &WBRO,WINP,WMIX,FNOM,BETA,CMAT,GAMA,NIBRD,NVAL,IUBIM,
     &SCRFILE(IUBIM),IERR)
	ENDIF
 1000	CONTINUE
	WRITE(IUN,10100)ITER,PDIF
	IERR=1
C	BMASS=0.D0
 2000	CONTINUE
C Returned parameters
	ZMASS=BMASS**2
	DO IMSC=0,NMSC
	GFF(IMSC)=BMASS**2*GFG(IMSC)
	IF(BMASS.GT.1.D-10)
     &SIG(IMSC)=WMSC(IMSC)-ELOC-DEL(IMSC)-1.D0/GFF(IMSC)
	IF(BMASS.LE.1.D-10)
     &SIG(IMSC)=(0.D0,0.D0)
	ENDDO
C Memory Deallocations
	DEALLOCATE(PSIN,XSTA,ELAR,AMAT,OMAT,GFG,AMAS)
	DEALLOCATE(XINP,XOUT,WTER,WDIM,WBRO,WINP,WMIX,DELF,UVEC)
	DEALLOCATE(FNOM,BETA,CMAT,GAMA)
10100	FORMAT(1X,'No convergency after ',I3,' iterations.',
     &1X,' Accuracy reached',G12.5)
	END








	SUBROUTINE IMP_SUNSBMF_XNOT(NDEG,ELEV,EDOP,TEMP,COMB,XHUB)
*******************************************************
*  Finds correlational functions for an atom          *
*  in zero configurational width approximation        *
*******************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	DIMENSION ELEV(0:NDEG),COMB(0:NDEG,0:NDEG)
     &   ,XHUB(0:NDEG)
      IDOP=0
      DO IDEG=0,NDEG
      IF(ELEV(IDEG)+EDOP.LE.0.D0)IDOP=IDEG
      IF(ELEV(IDEG)+EDOP.GT.0.D0)EXIT
      ENDDO
C Looping backwards
      XHUB(IDOP)=1.D0
      DO IDEG=IDOP,1,-1
      E=ELEV(IDEG-1)+EDOP
      XHUB(IDEG-1)=SAFEEXP(+E/TEMP)*XHUB(IDEG)
      ENDDO
C Looping forwards
      XHUB(IDOP)=1.D0
      DO IDEG=IDOP,NDEG-1
      E=ELEV(IDEG)+EDOP
      XHUB(IDEG+1)=SAFEEXP(-E/TEMP)*XHUB(IDEG)
      ENDDO
C  Renormalize continiously
      XSUM=0.D0
      DO JDEG=0,NDEG
      XSUM=XSUM+XHUB(JDEG)*COMB(JDEG,NDEG)
      ENDDO
      DO JDEG=0,NDEG
      XHUB(JDEG)=XHUB(JDEG)/XSUM
      ENDDO
C  Check Normalizaton
	XSUM=0.D0
	DO IDEG=0,NDEG
	XSUM=XSUM+XHUB(IDEG)*COMB(IDEG,NDEG)
	ENDDO
	IF(ABS(XSUM-1.D0).GT.1.D-10)STOP
	RETURN
	END



