	SUBROUTINE INI_GETDOS
******************************************************
*   Read Green function data                         *
******************************************************
C SET EXTERNAL CONNECTIONS
      USE COM_CONTROL   ,ONLY: MODE,LIFT,LMTO                !!! from readini
      USE COM_NBANDS    ,ONLY: NBNDF,NBNDE,NBNDC,NBNDT       !!! from readini
	USE COM_FREQU     ,ONLY: NENRDOS,ENRDOS                !!! from getdos
	USE COM_INPTTR    ,ONLY: NDIV,NDIC,NDIW                !!! from readini
      USE COM_UNIT      ,ONLY: IUT,IUR,IUN                   !!! from setup
	USE COM_CHANNELS  ,ONLY: IUINP                         !!! from setup
      USE COM_LMTOUT    ,ONLY: ICDOS,DOSFILE                 !!! from readini
C SET LOCAL VARIBLES
	IMPLICIT REAL*8 (A-H,O-Z)
	CHARACTER DATA(100)*150,COPY(100)*150, HELP*40
	COMPLEX*16 CM
      LOGICAL EXIST,DEF,ASK,VAL,NTH
	DATA PI/3.141592653589793D0/
	IF(ICDOS.EQ.0)RETURN
	INQUIRE(FILE=DOSFILE,EXIST=EXIST)
	IF(EXIST)
     &OPEN(UNIT=IUINP,FILE=DOSFILE,STATUS='OLD',FORM='FORMATTED')
C TRY READING FIRST 99 LINES
	ILEN=0
	DO I=1,100
	ILEN=ILEN+1
	IF(EXIST)READ(IUINP,FMT='(A)',ERR=100,END=100)DATA(ILEN)
	ENDDO
  100 NLEN=ILEN-1
      IF(NLEN.EQ.0)NLEN=1
	IF(EXIST)CLOSE(IUINP)
      CALL READ_SECT(DATA(1),NLEN,ISEC,NSEC,MSEC,
     &'<section=ctrl',13,'<section=',9,'ok',2)
C Allocate temporary file
      DO ILIN=1,MSEC
      COPY(ILIN)=DATA(ILIN+ISEC-1)
      ENDDO
C Process NENRDOS
      NENRDOS=100
      HELP='! Energy mesh for DOS                  '
      LHLP=40
      CALL READ_CHAR(DATA(ISEC),COPY(1),NSEC,MSEC,
     &'nenrdos',7,NENRDOS,1,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.FALSE.,.FALSE.)
C Process EDOSMIN
      EDOSMIN=0.D0
      HELP='! Min.Energy (Ry) for DOS              '
      LHLP=40
      CALL READ_CHAR(DATA(ISEC),COPY(1),NSEC,MSEC,
     &'emindos',7,IN,1,0,EDOSMIN,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.FALSE.,.FALSE.)
C Process EDOSMAX
      EDOSMAX=0.D0
      HELP='! Max.Energy (Ry) for DOS              '
      LHLP=40
      CALL READ_CHAR(DATA(ISEC),COPY(1),NSEC,MSEC,
     &'emaxdos',7,IN,1,0,EDOSMAX,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.FALSE.,.FALSE.)
C Overwrite NDIV if needed
	HELP='! Tetrahedron mesh                     '
	LHLP=40
	CALL READ_CHAR(DATA(ISEC),COPY(1),NSEC,MSEC,
     &  'ndiv(:)',7,NDIV,3,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.FALSE.,.FALSE.)
	IF(NDIC(1).EQ.0)THEN
	NDIC(1)=1
	NDIC(2)=1
	NDIC(3)=1
	ENDIF
C Overwrite NDIW if needed
C	HELP='! Tetrahedron mesh for weights         '
C	LHLP=40
C	CALL READ_CHAR(DATA(ISEC),COPY(1),NSEC,MSEC,
C    &  'ndiw(:)',7,NDIW,3,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
C    &  DEF,ASK,VAL,NTH,.FALSE.,.FALSE.)
	NDIW(1)=NDIV(1)
	NDIW(2)=NDIV(2)
	NDIW(3)=NDIV(3)
C SET FREQUENCIES
	ALLOCATE(ENRDOS(0:NENRDOS+1))
	IF(NENRDOS.NE.0)ESTEP=(EDOSMAX-EDOSMIN)/DBLE(NENRDOS)
	IF(NENRDOS.EQ.0)ESTEP=0.D0
	DO IENR=0,NENRDOS
	ENRDOS(IENR)=EDOSMIN+DBLE(IENR)*ESTEP
	ENDDO
	END
