	SUBROUTINE INI_GETFAT
******************************************************
*   Read Fat bands data                              *
******************************************************
C SET EXTERNAL CONNECTIONS
      USE COM_CONTROL   ,ONLY: MODE,LIFT,LMTO                !!! from readini
      USE COM_NBANDS    ,ONLY: NBNDF,NBNDE,NBNDC,NBNDT       !!! from readini
	USE COM_INPTTR    ,ONLY: NDIVDIR,NDIR,HSPNT,PNTNOT     !!! from readstr
      USE COM_LATPAR    ,ONLY: PAR,ORTH,OMEGAC,STRAIN          !!! from readini
      USE COM_UNIT      ,ONLY: IUT,IUR,IUN                   !!! from setup
	USE COM_CHANNELS  ,ONLY: IUINP                         !!! from setup
      USE COM_LMTOUT    ,ONLY: ICFAT,FATFILE                 !!! from readini
C SET LOCAL VARIBLES
	IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8, ALLOCATABLE :: HSPNTR(:,:,:)
	CHARACTER DATA(100)*150,COPY(100)*150, HELP*40,STRARR(80)*1
	COMPLEX*16 CM
      LOGICAL EXIST,DEF,ASK,VAL,NTH
	DATA PI/3.141592653589793D0/
	IF(ICFAT.EQ.0)RETURN
	INQUIRE(FILE=FATFILE,EXIST=EXIST)
	IF(EXIST)
     &OPEN(UNIT=IUINP,FILE=FATFILE,STATUS='OLD',FORM='FORMATTED')
C TRY READING FIRST 99 LINES
	ILEN=0
	DO I=1,100
	ILEN=ILEN+1
	IF(EXIST)READ(IUINP,FMT='(A)',ERR=100,END=100)DATA(ILEN)
	ENDDO
  100 NLEN=ILEN-1
      IF(NLEN.EQ.0)NLEN=1
	IF(EXIST)CLOSE(IUINP)
      CALL READ_SECT(DATA(1),NLEN,ISEC,NSEC,MSEC,
     &'<section=ctrl',13,'<section=',9,'ok',2)
C Allocate temporary file
      DO ILIN=1,MSEC
      COPY(ILIN)=DATA(ILIN+ISEC-1)
      ENDDO
C Overwrite NDIVDIR if needed
	NDIVDIR=10
	HELP='! # of divisions                       '
	LHLP=40
	CALL READ_CHAR(DATA(ISEC),COPY(1),NSEC,MSEC,
     &  'ndivdir',7,NDIVDIR,1,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.FALSE.,.FALSE.)
C MODERN INPUT IS USED, DEFAULTS ARE AVAIABLE
      CALL READ_SECT(DATA(1),NLEN,ISEC,NSEC,MSEC,
     &'<section=dirs',13,'<section=',9,'ok',2)
	IF(MSEC.GT.1)THEN
	IREC=ISEC+1
      READ(DATA(IREC),*)NDIR
	IF(ALLOCATED(HSPNT))DEALLOCATE(HSPNT)
	IF(ALLOCATED(PNTNOT))DEALLOCATE(PNTNOT)
	ALLOCATE(HSPNT(3,2,NDIR))
	ALLOCATE(HSPNTR(3,2,NDIR))
	ALLOCATE(PNTNOT(2,NDIR))
      DO IDIR=1,NDIR
	IREC=IREC+1
      READ(DATA(IREC),FMT='(2(1X,A1))')
     &(PNTNOT(IVEC,IDIR),IVEC=1,2)
	IREC=IREC+1
      READ(DATA(IREC),FMT='(80A1)')STRARR
      CALL LIB_COMPVEC(STRARR,HSPNTR(1,1,IDIR),6)
	ENDDO
C ACCOUNT FOR ORTHOROMBICITY PARAMETERS
      DO I=2,3
      DO IVEC=1,2
      DO IDIR=1,NDIR
      HSPNTR(I,IVEC,IDIR)=HSPNTR(I,IVEC,IDIR)/ORTH(I)
	ENDDO
	ENDDO
	ENDDO
C APPLY INVERSE STRAIN TO HIGH-SYMMETRY DIRECTIONS: K'=K*S^(-1)
      DO IDIR=1,NDIR
      DO IVEC=1,2
      DO I=1,3
      HSPNT(I,IVEC,IDIR)=0.D0
      DO J=1,3
      HSPNT(I,IVEC,IDIR)=HSPNT(I,IVEC,IDIR)+
     &HSPNTR(J,IVEC,IDIR)*STRAIN(J,I,2)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	DEALLOCATE(HSPNTR)
	ENDIF
	END
