	SUBROUTINE INI_GETFRS
******************************************************
*   Read Fermi Surface data                          *
******************************************************
C SET EXTERNAL CONNECTIONS
      USE COM_CONTROL   ,ONLY: MODE,LIFT,LMTO                    !!! from readini
      USE COM_NBANDS    ,ONLY: NBNDF,NBNDE,NBNDC,NBNDT           !!! from readini
      USE COM_LATPAR    ,ONLY: PAR,ORTH,OMEGAC,STRAIN            !!! from readini
      USE COM_LATTICE   ,ONLY: RBAS,GBAS,BBAS,TAU,ORIGIN,IBZCUBE !!! from readstr
	USE COM_INPTTR    ,ONLY: NDIV,NDIC,NDIW                    !!! from readini
      USE COM_UNIT      ,ONLY: IUT,IUR,IUN                       !!! from setup
	USE COM_CHANNELS  ,ONLY: IUINP                             !!! from setup
      USE COM_LMTOUT    ,ONLY: ICFRS,FRSFILE                     !!! from readini
C SET LOCAL VARIBLES
	IMPLICIT REAL*8 (A-H,O-Z)
	DIMENSION CUBR(3,3),ORGR(3)
	CHARACTER DATA(100)*150,COPY(100)*150, HELP*40,STRARR(80)*1
	COMPLEX*16 CM
      LOGICAL EXIST,DEF,ASK,VAL,NTH
	DATA PI/3.141592653589793D0/
	IF(ICFRS.EQ.0)RETURN
	INQUIRE(FILE=FRSFILE,EXIST=EXIST)
	IF(EXIST)
     &OPEN(UNIT=IUINP,FILE=FRSFILE,STATUS='OLD',FORM='FORMATTED')
C TRY READING FIRST 99 LINES
	ILEN=0
	DO I=1,100
	ILEN=ILEN+1
	IF(EXIST)READ(IUINP,FMT='(A)',ERR=100,END=100)DATA(ILEN)
	ENDDO
  100 NLEN=ILEN-1
      IF(NLEN.EQ.0)NLEN=1
	IF(EXIST)CLOSE(IUINP)
      CALL READ_SECT(DATA(1),NLEN,ISEC,NSEC,MSEC,
     &'<section=ctrl',13,'<section=',9,'ok',2)
C Allocate temporary file
      DO ILIN=1,MSEC
      COPY(ILIN)=DATA(ILIN+ISEC-1)
      ENDDO
C Overwrite NDIV if needed
	HELP='! Tetrahedron mesh                     '
	LHLP=40
	CALL READ_CHAR(DATA(ISEC),COPY(1),NSEC,MSEC,
     &  'ndiv(:)',7,NDIV,3,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.FALSE.,.FALSE.)
	IF(NDIC(1).EQ.0)THEN
	NDIC(1)=1
	NDIC(2)=1
	NDIC(3)=1
	ENDIF
C Overwrite NDIW if needed
C	HELP='! Tetrahedron mesh for weights         '
C	LHLP=40
C	CALL READ_CHAR(DATA(ISEC),COPY(1),NSEC,MSEC,
C    &  'ndiw(:)',7,NDIW,3,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
C    &  DEF,ASK,VAL,NTH,.FALSE.,.FALSE.)
C	IF(NDIW(1).EQ.0)THEN
	NDIW(1)=NDIV(1)
	NDIW(2)=NDIV(2)
	NDIW(3)=NDIV(3)
C	ENDIF
C READ CUBE
      CALL READ_SECT(DATA(1),NLEN,ISEC,NSEC,MSEC,
     &'<section=cube',13,'<section=',9,'ok',2)
C Process Cube
	IF(MSEC.NE.0)THEN
      DO IVEC=1,3
      READ(DATA(ISEC+IVEC),FMT='(80A1)')STRARR
      CALL LIB_COMPVEC(STRARR,CUBR(1,IVEC),3)
	ENDDO
      READ(DATA(ISEC+IVEC),FMT='(80A1)')STRARR
      CALL LIB_COMPVEC(STRARR,ORGR,3)
	ELSE
	CUBR(1,1)=1.D0
	CUBR(2,1)=0.D0
	CUBR(3,1)=0.D0
	CUBR(1,2)=0.D0
	CUBR(2,2)=1.D0
	CUBR(3,2)=0.D0
	CUBR(1,3)=0.D0
	CUBR(2,3)=0.D0
	CUBR(3,3)=1.D0
	ORGR(1)=0.5D0
	ORGR(2)=0.5D0
	ORGR(3)=0.5D0
	ENDIF
C ACCOUNT FOR ORTHOROMBICITY
      DO I=2,3
      DO IVEC=1,3
      CUBR(I,IVEC)=CUBR(I,IVEC)/ORTH(I)
	ENDDO
	ORGR(I)=ORGR(I)/ORTH(I)
	ENDDO
C APPLY INVERSE STRAIN AND OVERWRITE BBAS
	IBZCUBE=0
      DO IVEC=1,3
      DO I=1,3
      BBAS(I,IVEC)=0.D0
	ORIGIN(I)=0.D0
      DO J=1,3
      BBAS(I,IVEC)=BBAS(I,IVEC)+CUBR(J,IVEC)*STRAIN(J,I,2)
	ORIGIN(I)=ORIGIN(I)+ORGR(J)*STRAIN(J,I,2)
	ENDDO
	ENDDO
	ENDDO
	END
