	SUBROUTINE INI_INIT
*************************************************************
*    Control module <INIT> for reading all the input data   *
*************************************************************
C SET EXTERNAL CONNECTIONS
	USE COM_LMTMEM
      USE COM_LMTINP ,ONLY: TRACINP !!! from init
      USE COM_UNIT   ,ONLY: IUT,IUR,IUN,IUI                 !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER ST*8,FN*8,PROGN*8
      LOGICAL EXIST,EXIT,LIB_TRACER,TRAC
      DATA ST/'started'/,FN/'finished'/
C RECOGNIZE CONTROL INFORMATION
	CALL INI_CTRLINF
C READ CONTROL DATA
	CALL INI_READINI       !!! read INIFILE
	CALL INI_READSTR       !!! read STRFILE
	CALL INI_STORAGE       !!! file storage
C TEST DATA
	CALL INI_TESTINP       !!! test input data
	CALL INI_READINI_SHOW  !!! print INIFILE
	CALL INI_READSTR_SHOW  !!! print STRFILE
C MAKE ATOMS AND STRUCTURE
	progn='MakeATM '
	if(lib_tracer(progn,tracinp,iut,iur,iui))then
      call lib_timel(times)
      write(iun,1110)progn,st,times,curmem,totmem
	CALL INI_MAKEATM       !!! store atoms and structure
      call lib_timel(timef)
      write(iun,1120)progn,fn,timef,curmem,totmem
	endif
C MAKE POINT GROUP
	progn='MakeGRP '
	if(lib_tracer(progn,tracinp,iut,iur,iui))then
      call lib_timel(times)
      write(iun,1110)progn,st,times,curmem,totmem
	CALL INI_MAKEGRP       !!! find point group
	CALL INI_MAKEGNT       !!! find Gaunt coefficients
      call lib_timel(timef)
      write(iun,1120)progn,fn,timef,curmem,totmem
	endif
C FIND SYMMETRY OF CHARGE DENSITY
	progn='MakeSYM '
	if(lib_tracer(progn,tracinp,iut,iur,iui))then
      call lib_timel(times)
      write(iun,1110)progn,st,times,curmem,totmem
      CALL INI_MAKESYM       !!! find symmetry of RHO
      call lib_timel(timef)
      write(iun,1120)progn,fn,timef,curmem,totmem
	endif
C FIND MT-SPHERES
	progn='MakeSMT '
	if(lib_tracer(progn,tracinp,iut,iur,iui))then
      call lib_timel(times)
      write(iun,1110)progn,st,times,curmem,totmem
      CALL INI_MAKESMT       !!! find MT-spheres
	CALL INI_MAKERAD       !!! make radial mesh
      call lib_timel(timef)
      write(iun,1120)progn,fn,timef,curmem,totmem
	endif
C MAKE FAST FOURIER TRANSFORM
	progn='MakeFFT '
	if(lib_tracer(progn,tracinp,iut,iur,iui))then
      call lib_timel(times)
      write(iun,1110)progn,st,times,curmem,totmem
      CALL INI_MAKEFFT       !!! make FFTs
      call lib_timel(timef)
      write(iun,1120)progn,fn,timef,curmem,totmem
	endif
C MAKE PLANE WAVES
	progn='MakePLW '
	if(lib_tracer(progn,tracinp,iut,iur,iui))then
      call lib_timel(times)
      write(iun,1110)progn,st,times,curmem,totmem
      CALL INI_MAKEPLW       !!! make PLWs
      CALL INI_MAKEPLW_DPLW  !!! make PLWs
      call lib_timel(timef)
      write(iun,1120)progn,fn,timef,curmem,totmem
	endif
C MAKE SCF FILE
      progn='MakeSCF '
      if(lib_tracer(progn,tracinp,iut,iur,iui))then
      call lib_timel(times)
      write(iun,1110)progn,st,times,curmem,totmem
      CALL INI_MAKESCF       !!! make input density
      CALL INI_READSCF       !!! read scffile
      call lib_timel(timef)
      write(iun,1120)progn,fn,timef,curmem,totmem
      endif
C MAKE PSEUDOHANKELS
	progn='MakeHAN '
	if(lib_tracer(progn,tracinp,iut,iur,iui))then
      call lib_timel(times)
      write(iun,1110)progn,st,times,curmem,totmem
      CALL INI_MAKEHAN        !!! make pseudoHankels
      call lib_timel(timef)
      write(iun,1120)progn,fn,timef,curmem,totmem
	endif
C MAKE PSEUDOLMTOS
	progn='MakeTEI '
	if(lib_tracer(progn,tracinp,iut,iur,iui))then
      call lib_timel(times)
      write(iun,1110)progn,st,times,curmem,totmem
 	CALL INI_MAKETEI        !!! make pseudoLMTOs
      call lib_timel(timef)
      write(iun,1120)progn,fn,timef,curmem,totmem
	endif
C MAKE CLUSTER SITES
	progn='MakeENV '
	if(lib_tracer(progn,tracinp,iut,iur,iui))then
      call lib_timel(times)
      write(iun,1110)progn,st,times,curmem,totmem
      CALL INI_MAKEENV        !!! make enviroment vectors
      call lib_timel(timef)
      write(iun,1120)progn,fn,timef,curmem,totmem
	endif
C MAKE K-MESH
	progn='MakeTTR '
	if(lib_tracer(progn,tracinp,iut,iur,iui))then
      call lib_timel(times)
      write(iun,1110)progn,st,times,curmem,totmem
      CALL INI_MAKETTR       !!! make tetrahedron grid 
      call lib_timel(timef)
      write(iun,1120)progn,fn,timef,curmem,totmem
	endif
C READ HUBBARD INTERACTION MATRIX
	progn='ReadHUB '
	if(lib_tracer(progn,tracinp,iut,iur,iui))then
      call lib_timel(times)
      write(iun,1110)progn,st,times,curmem,totmem
      CALL HUB_READHUB        !!! read Hubbard interactions
	CALL HUB_READHUB_SHOW   !!! show header of Hubfile
      call lib_timel(timef)
      write(iun,1120)progn,fn,timef,curmem,totmem
	endif
C READ HOPPING INTEGRALS
	progn='ReadHOP '
	if(lib_tracer(progn,tracinp,iut,iur,iui))then
      call lib_timel(times)
      write(iun,1110)progn,st,times,curmem,totmem
      CALL HOP_READHOP        !!! read hoppings
      call lib_timel(timef)
      write(iun,1120)progn,fn,timef,curmem,totmem
	endif
C READ Q-POINTS
	progn='ReadPNT '
	if(lib_tracer(progn,tracinp,iut,iur,iui))then
      call lib_timel(times)
      write(iun,1110)progn,st,times,curmem,totmem
      CALL INI_READPNT           !!! read 
      call lib_timel(timef)
      write(iun,1120)progn,fn,timef,curmem,totmem
	endif
C INITIALIZATION COMPLETED. UPGRADE INPUT FILES
	progn='MakeUPG '
	if(lib_tracer(progn,tracinp,iut,iur,iui))then
      call lib_timel(times)
      write(iun,1110)progn,st,times,curmem,totmem
!      CALL INI_READINI_UPGR  !!! upgrade INIFILE KH CHANGED!!!
      call lib_timel(timef)
      write(iun,1120)progn,fn,timef,curmem,totmem
	endif
1110  FORMAT('***** ',A8,1X,A8,'; CPU : ',G12.5,
     &       '; CUR/MAX mem.(Mb): ',G10.3,'/',G10.3)
1120  FORMAT('***** ',A8,1X,A8,'; CPU : ',G12.5,
     &       '; CUR/MAX mem.(Mb): ',G10.3,'/',G10.3)
      END SUBROUTINE INI_INIT
