	SUBROUTINE INI_MAKEATM
************************************************************
*  Controls finding crystal group.                         *
************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
	USE COM_PARAM   ,ONLY : NATOM,NSORT,NSPIN,NORBS,IS   !!! from readini
     &                       ,ILST,ILSB,ILSV               !!! from readini
	USE COM_LATTICE ,ONLY : RBAS,GBAS,TAO,TAU            !!! from readstr
	USE COM_LATPAR  ,ONLY : PAR,PAR0,VV0,ORTH,STRAIN     !!! from readini
      USE COM_MAGDAT  ,ONLY : AXMAG                        !!! from ttrint1
      USE COM_KAPPAR  ,ONLY : NPAN,NKAP,EKAP               !!! from readini
      USE COM_PANPAR  ,ONLY : LTPAN,LSPAN,IATS,ISTS        !!! from readini
      USE COM_INPPAR  ,ONLY : ENY,DNY,TNY,NODES,MNY        !!! from readini
	USE COM_SPHERE  ,ONLY : ZNUC,SMT,SMTS                !!! from readini
	USE COM_LMTOUT  ,ONLY : ICATM,ATMFILE                !!! from readstr
	USE COM_LABELS  ,ONLY : TXTEL,TXTAT                  !!! from readini
	USE COM_UNIT    ,ONLY : IUN,IUR,IUT                  !!! from setup
	USE COM_CHANNELS,ONLY : IUAIN                            !!! from channels
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER, ALLOCATABLE :: ILMTBAS(:,:)
	INTEGER, ALLOCATABLE :: INODBAS(:,:)
      DATA PI/3.141592653589793D0/,EPS/1.D-05/
C ********************************
C STORE ATOMS FILE
      IF(ICATM.LE.0)RETURN
      OPEN(UNIT=IUAIN,FILE=ATMFILE,STATUS='NEW',FORM='FORMATTED')
	WRITE(IUAIN,1010)
	WRITE(IUAIN,*)NATOM,NSORT,NSPIN,NORBS
	WRITE(IUAIN,*)(IS(IATOM),IATOM=1,NATOM)
      WRITE(IUAIN,*)RBAS,GBAS,PAR,ORTH,STRAIN,
     &((TAO(I,IATOM),I=1,3),IATOM=1,NATOM),
     &((TAU(I,IATOM),I=1,3),IATOM=1,NATOM),
     &(ZNUC(ISORT),ISORT=1,NSORT),
     &(SMTS(ISORT),ISORT=1,NSORT),
     &((AXMAG(I,ISORT),I=1,3),ISORT=1,NSORT)
      WRITE(IUAIN,FMT='(5A10)')(TXTAT(ISORT),ISORT=1,NSORT)
      WRITE(IUAIN,*)(ILSB(ISORT),ISORT=1,NSORT)
C Store basis set
	ALLOCATE(ILMTBAS(0:LMAXBMEM,NATOMMEM))
	ALLOCATE(INODBAS(0:LMAXBMEM,NATOMMEM))
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	DO L=0,ILSB(IS(IATOM))
	ILMTBAS(L,IATOM)=0
	INODBAS(L,IATOM)=0
	DO IKAP=1,NKAP(1)
	IF(LTPAN(L,IATOM,IKAP,1))ILMTBAS(L,IATOM)=1
	IF(LTPAN(L,IATOM,IKAP,1))INODBAS(L,IATOM)=
     &NODES(L,ISORT,IKAP,1)+L+1
	ENDDO
	ENDDO
	ENDDO
	WRITE(IUAIN,*)((ILMTBAS(L,IATOM),L=0,ILSB(IS(IATOM))),
     &IATOM=1,NATOM)
	WRITE(IUAIN,*)((INODBAS(L,IATOM),L=0,ILSB(IS(IATOM))),
     &IATOM=1,NATOM)
      CLOSE(IUAIN)
1010	FORMAT('<FILE=ATMFILE,INPUT=MODERN>')
C MEMORY DEALLOCATIONS
	DEALLOCATE(ILMTBAS,INODBAS)
	END SUBROUTINE INI_MAKEATM
