	SUBROUTINE INI_MAKERAD
*************************************************************
*   Makes radial mesh in each  MT-sphere.                   *
*************************************************************
C SET ARRAY SIZE DATA
	USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
	USE COM_LMTMEM
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,IS,ILSV,LRTV  !!! from readini
      USE COM_LATPAR  ,ONLY: PAR,PAR0,VV0,ORTH,OMEGAC        !!! from readini
      USE COM_SPHERE  ,ONLY: ZNUC,SMT,SASA,SWZ               !!! from readini
      USE COM_RADMESH ,ONLY: NRAD,H,R,RL,DR,WEIGHT           !!! from makerad
      USE COM_POTDAT  ,ONLY: POTRWF                          !!! from makerad
      USE COM_LABELS  ,ONLY: TXTAT,TXTEL,TXTSP               !!! from setup
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT                     !!! from setup
      USE COM_MASHDEP ,ONLY: LENREL                          !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER ,INTRINSIC :: SIZE
	DATA PI/3.141592653589793D0/,DELTANR/0.03D0/,DELTAR/0.03D0/
C MEMORY ALLOCATIONS FOR MAIN CONTROL ARRAYS
	ALLOCATE(H(NSORTMEM))
	ALLOCATE(NRAD(NSORTMEM))
C FIRST ESTIMATE # OF POINTS
	NRADMEM=0
      DO ISORT=1,NSORT
      IF(LRTV(ISORT).EQ.0)H(ISORT)=DELTANR
      IF(LRTV(ISORT).EQ.1)H(ISORT)=DELTA R
      XMIN=-LOG(2.D0*ZNUC(ISORT)+1.D0)
      BETTA=EXP(XMIN)
      PAR0=PAR/VV0**0.333333333333333D0
      SMT0=SMT(ISORT)*PAR0/PAR
      NRAD(ISORT)=2*LOG(SMT0/BETTA+1.D0)/H(ISORT)
      NRAD(ISORT)=MAX(NRAD(ISORT),100)
      NRAD(ISORT)=MIN(NRAD(ISORT),1000)
      NRAD(ISORT)=((NRAD(ISORT)-1)/2)*2  !!! must be odd number
	NRADMEM=MAX(NRADMEM,NRAD(ISORT))
	ENDDO
C MEMORY ALLOCATIONS FOR MAIN CONTROL ARRAYS
	ALLOCATE(R(0:NRADMEM,NSORTMEM))
	ALLOCATE(RL(0:NRADMEM,0:LMAXVMEM,NSORTMEM))
	ALLOCATE(DR(0:NRADMEM,NSORTMEM))
	ALLOCATE(WEIGHT(0:NRADMEM,NSORTMEM))
	DO 100 ISORT=1,NSORT
	XMIN=-LOG(2.D0*ZNUC(ISORT)+1.D0)
	BETTA=EXP(XMIN)
	PAR0=PAR/VV0**0.333333333333333D0
   	SMT0=SMT(ISORT)*PAR0/PAR
C # OF RADIAL POINTS IS DEFINED, REDEFINE XMIN
C	BETTA=SMT(ISORT)/(EXP(H(ISORT)*NRAD(ISORT))-1.D0)
   	BETTA=SMT0      /(EXP(H(ISORT)*NRAD(ISORT))-1.D0)
	XMIN=LOG(BETTA)
C SCALE STEP AND XMAX ACCORDING TO V/V0
	H(ISORT)=LOG(SMT(ISORT)/BETTA+1.D0)/DBLE(NRAD(ISORT))
	XMAX=XMIN+H(ISORT)*DBLE(NRAD(ISORT))
C DEFINE RADIAL MESH ARRAYS
	DO IRAD=0,NRAD(ISORT)
	R(IRAD,ISORT)=BETTA*(EXP(H(ISORT)*IRAD)-1.D0)
	DR(IRAD,ISORT)=BETTA*EXP(H(ISORT)*IRAD)
	WEIGHT(IRAD,ISORT)=4.D0*PI*R(IRAD,ISORT)**2*DR(IRAD,ISORT)
	RL(IRAD,0,ISORT)=1.D0
	DO L=1,ILSV(ISORT)
	RL(IRAD,L,ISORT)=R(IRAD,ISORT)**L
	ENDDO
	ENDDO
	IF(ABS(R(NRAD(ISORT),ISORT)-SMT(ISORT)).GE.1.D-12)THEN
	WRITE(IUT,*)'Warning from <RADMESH>:'
	WRITE(IUT,*)'Lost of accuracy detected.'
	WRITE(IUT,*)'Radial mesh does not match MT-sphere radius.'
	WRITE(IUT,*)'R(Nrad,isort)=',R(NRAD(ISORT),ISORT)
	WRITE(IUT,*)'Smt(isort)   =',SMT(ISORT)
	ENDIF
 100	CONTINUE
C PRINT RADIAL POINTS
	DO ISORT=1,NSORT
	WRITE(IUN,1010)NRAD(ISORT),SMT(ISORT),SASA(ISORT),TXTEL(ISORT)
1010	FORMAT(1X,'Nrad =',I4,' ; Smt =',G14.7,' ; Sasa =',G14.7,1X,A10)
	ENDDO
C MEMORY ALLOCATIONS FOR FROZEN POTENTIAL
	ALLOCATE(POTRWF(0:NRADMEM,NSORTMEM,NSPINMEM))
	DO ISPIN=1,NSPIN
	DO ISORT=1,NSORT
	DO IRAD=0,NRAD(ISORT)
	POTRWF(IRAD,ISORT,ISPIN)=0.D0
	ENDDO 
	ENDDO
	ENDDO
	END



      SUBROUTINE INI_LIBMESH
************************************************************
* Builts Liberman mesh used in atomic calculations.        *
************************************************************
C SET ARRAY SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_PARAM   ,ONLY: NSORT                            !!! from readini
      USE COM_LIBMESH ,ONLY: NLIB,HLIB,RLIB,DRLIB             !!! from libmesh
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
      DATA PI/3.141592653589793D0/
	IF(ALLOCATED(HLIB))DEALLOCATE(HLIB,RLIB,DRLIB)
C MEMORY ALLOCATIONS
      NLIB=421
	NLIBMEM=NLIB
      ALLOCATE(HLIB(NSORTMEM))
      ALLOCATE(RLIB(0:NLIBMEM,NSORTMEM))
      ALLOCATE(DRLIB(0:NLIBMEM,NSORTMEM))
C BUILT MESH
      HH1=32.D0
      XMAX=LOG(60.D0)
      XMIN=XMAX-DBLE(NLIB-1)/HH1
      DO ISORT=1,NSORT
      HLIB(ISORT)=(XMAX-XMIN)/DBLE(NLIB-1)
      RLIB(0,ISORT)=0.D0
      DRLIB(0,ISORT)=0.D0
      DO IRAD=1,NLIB
      RLIB(IRAD,ISORT)=EXP(XMIN+HLIB(ISORT)*(IRAD-1))
      DRLIB(IRAD,ISORT)=EXP(XMIN+HLIB(ISORT)*(IRAD-1))
      ENDDO
      ENDDO
      END

