	SUBROUTINE INI_MAKESYM
****************************************************************
*  Define which coefficients in the expansion of the potential *
*  or charge density over spherical harmonics are not equal    *
*  to zero for a given crystalline group.                      *
****************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_PARAM,   ONLY : NATOM,NSORT,NSPIN,NORBS
     &                       ,IS,ILST,ILSB,ILSV               !!! from readini
	USE COM_LATTICE, ONLY : RBAS,GBAS,TAU                   !!! from readstr
      USE COM_SYMMLM,  ONLY : NSYM,LMSYM,SYM                  !!! from symlmm
      USE COM_GROUPS,  ONLY : NGROUP,IKOV,IP,U,SJ             !!! from groups
      USE COM_LABELS,  ONLY : TXTEL,TXTAT                     !!! from setup
      USE COM_UNIT,    ONLY : IUN,IUR,IUT                     !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER, ALLOCATABLE :: LPR(:)
	INTEGER, ALLOCATABLE :: MPR(:,:)
	INTEGER, ALLOCATABLE :: IARR(:)
	COMPLEX*16, ALLOCATABLE :: YLM(:)
	COMPLEX*16, ALLOCATABLE :: ZLM(:,:,:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: XL1(:,:,:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: XL2(:,:,:,:,:,:)
	COMPLEX*16 EXPGR
	CHARACTER BLANCK*40
	DATA PI/3.141592653589793D0/
C MEMORY ALLOCATIONS FOR MAIN CONTROL ARRAYS
	ALLOCATE(NSYM(NATOMMEM))
	ALLOCATE(LMSYM(LIMVMEM,NATOMMEM))
	ALLOCATE(SYM(LIMVMEM,NATOMMEM))
C MEMORY ALLOCATIONS FOR INTERNAL ARRAYS
	ALLOCATE(LPR(0:LMAXVMEM))
	ALLOCATE(MPR(0:LMAXVMEM,2*LMAXVMEM+1))
	ALLOCATE(IARR(LIMVMEM))
	ALLOCATE(YLM(LIMVMEM))
	ALLOCATE(ZLM(LIMVMEM,NATOMMEM,2,2,2,2))
	ALLOCATE(XL1(LIMVMEM,NATOMMEM,2,2,2,2))
	ALLOCATE(XL2(LIMVMEM,NATOMMEM,2,2,2,2))
      WRITE(IUN,1001)
1001  FORMAT(1X,'Start finding LM expansions for rho(r):       '/)
C DEFINE WHICH OF THE DENSITY OR POTENTIAL L-COMPONENTS WILL BE ZERO
      SYM(:,:) = .FALSE.
      LMSYM(:,:) = 0
      LMM=0
      DO IATOM=1,NATOM                !!! over iatom
      LMM=MAX(LMM,ILSV(IS(IATOM)))
      DO LM=1,(ILSV(IS(IATOM))+1)**2
      SYM(LM,IATOM)=.FALSE.
	DO IORBS=1,NORBS
	DO IUPDN=1,NSPIN
	DO JORBS=1,NORBS
	DO JUPDN=1,NSPIN
      ZLM(LM,IATOM,IUPDN,IORBS,JUPDN,JORBS)=(0.D0,0.D0)
      XL1(LM,IATOM,IUPDN,IORBS,JUPDN,JORBS)=(0.D0,0.D0)
      XL2(LM,IATOM,IUPDN,IORBS,JUPDN,JORBS)=(0.D0,0.D0)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO                           !!! over iatom
C SET ARBITRARY VECTOR
      AX=0.1D0
      AY=0.2D0
      AZ=0.3D0
      AA=SQRT(AX**2+AY**2+AZ**2)
C DO OVER ATOMS AND CRYSTALLINE GROUP
	DO IORBS=1,NORBS                !!! over iorbs
	DO IUPDN=1,NSPIN                !!! over iupdn
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
	DO JORBS=1,NORBS                !!! over iorbs
	DO JUPDN=1,NSPIN                !!! over iupdn
	IF(JORBS.EQ.1)THEN
	JSPIN1=JUPDN
	JSPIN =JUPDN
	ELSEIF(JORBS.EQ.2)THEN
	JSPIN1=JUPDN
	JSPIN =NSPIN+1-JUPDN
	ENDIF
	IF(NORBS.EQ.1.AND.IUPDN.NE.JUPDN)CYCLE
      DO IATOM=1,NATOM                !!! over iatom
      ISORT=IS(IATOM)
      DO IR=1,NGROUP                  !!! over ig
      IG=IKOV(IR)
      IATOMG=IP(IATOM,IR)
	IF(IATOMG.EQ.IATOM)THEN
C ROTATE VECTOR BY GROUP OPERATION
      CALL LIB_ROTATE(AX,AY,AZ,ARX,ARY,ARZ,U(2,IG),2)
      CALL LIB_SPHHARM(ARX/AA,ARY/AA,ARZ/AA,ILSV(ISORT),YLM)
      DO L=0,ILSV(ISORT)
      DO M=-L,L
      LM=L*(L+1)+M+1
      ZLM(LM,IATOM,IUPDN,IORBS,JUPDN,JORBS)=
     &ZLM(LM,IATOM,IUPDN,IORBS,JUPDN,JORBS)+YLM(LM)*
     &DCONJG(SJ(ISPIN1,JSPIN1,IR))*SJ(ISPIN,JSPIN,IR)
	DO M1=-L,L
	IWIG1=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M1+1
	IWIG2=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M1)+L+M+1
      XL1(LM,IATOM,IUPDN,IORBS,JUPDN,JORBS)=
     &XL1(LM,IATOM,IUPDN,IORBS,JUPDN,JORBS)+U(IWIG1,IG)*
     &DCONJG(SJ(ISPIN1,JSPIN1,IR))*SJ(ISPIN,JSPIN,IR)
      XL2(LM,IATOM,IUPDN,IORBS,JUPDN,JORBS)=
     &XL2(LM,IATOM,IUPDN,IORBS,JUPDN,JORBS)+U(IWIG2,IG)*
     &DCONJG(SJ(ISPIN1,JSPIN1,IR))*SJ(ISPIN,JSPIN,IR)
	ENDDO
	ENDDO
	ENDDO
	ENDIF
	ENDDO                           !!! over ig
	ENDDO                           !!! over iatom
	ENDDO                           !!! over jupdn
	ENDDO                           !!! over jorbs
	ENDDO                           !!! over iupdn
	ENDDO                           !!! over iorbs
C LOOK FOR ZEROES
	DO IORBS=1,NORBS
	DO IUPDN=1,NSPIN
	DO JORBS=1,NORBS
	DO JUPDN=1,NSPIN
	IF(NORBS.EQ.1.AND.IUPDN.NE.JUPDN)CYCLE
      DO IATOM=1,NATOM
      DO LM=1,(ILSV(IS(IATOM))+1)**2
      IF(ABS(ZLM(LM,IATOM,IUPDN,IORBS,JUPDN,JORBS)).GT.1.D-08)
     &SYM(LM,IATOM)=.TRUE.
      IF(ABS(XL1(LM,IATOM,IUPDN,IORBS,JUPDN,JORBS)).GT.1.D-08)
     &SYM(LM,IATOM)=.TRUE.
      IF(ABS(XL2(LM,IATOM,IUPDN,IORBS,JUPDN,JORBS)).GT.1.D-08)
     &SYM(LM,IATOM)=.TRUE.
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C PRINT ALLOWED LM-VALUES
	BLANCK='                                        '
	ISYMMEM=0
	DO IATOM=1,NATOM                        !!! over atoms
	ISORT=IS(IATOM)
	WRITE(IUN,1010)(TAU(I,IATOM),I=1,3),TXTEL(IS(IATOM))
	WRITE(IUN,1020)ILST(IS(IATOM))
	WRITE(IUN,1030)ILSV(IS(IATOM))
	WRITE(IUN,1040)
	NSYM(IATOM)=0
	LPRMAX=0
	DO L=0,ILSV(IS(IATOM))
	LPR(L)=0
	DO M=-L,L
	LM=L*(L+1)+M+1
	LMSYM(LM,IATOM)=0
	IF(SYM(LM,IATOM))THEN
	NSYM(IATOM)=NSYM(IATOM)+1
	LMSYM(LM,IATOM)=NSYM(IATOM)
	LPR(L)=LPR(L)+1
	MPR(L,LPR(L))=M
	ENDIF
	ENDDO
	IF(L.LE.8)LPRMAX=MAX(LPRMAX,LPR(L))
	ENDDO
C THE FOLLOWING CYCLE IS JUST FOR PRINTING, REMOVE IT IF DOES NOT WORK
	DO L=0,ILSV(IS(IATOM))
	NSHIFT=2*(LPRMAX-LPR(L))+1
	IF(NSHIFT.LE. 0)NSHIFT=1 
	IF(NSHIFT.GT.40)NSHIFT=40
	IF(LPR(L).NE.0.AND.L.LE.8)WRITE(IUN,1050)L,BLANCK(:NSHIFT),
     &(MPR(L,I),I=1,LPR(L))
	IF(LPR(L).NE.0.AND.L.GT.8)WRITE(IUN,1060)L,LPR(L)
	ENDDO
	WRITE(IUN,1070)NSYM(IATOM)
	ISYMMEM=MAX(ISYMMEM,NSYM(IATOM))
	ENDDO                                   !!! over atoms
1010  FORMAT(1X,'Position : (',G12.5,',',G12.5,',',G12.5,') ',A10)
1020  FORMAT(1X,'LMTO-basis set is expanded in spherical harmonics ',
     &'up to Lmax=',I2)
1030  FORMAT(1X,'Charge density is expanded in spherical harmonics ',
     &'up to Lmax=',I2)
1040  FORMAT(1X,'Non-zero elements allowed by symmetry are ',
     &          'the following:')
1050  FORMAT(1X,'l=',I2,' ; m=',A,17(1X,I3))
1060  FORMAT(1X,'l=',I2,' ; m= ',I2,' elements')
1070  FORMAT(1X,'Total # of non-zero components found ',I3/)
C SET MEMORY LIMITS DATA
	NSYMMEM=ISYMMEM
C MEMORY DEALLOCATIONS
	DEALLOCATE(LPR)
	DEALLOCATE(MPR)
	DEALLOCATE(IARR)
	DEALLOCATE(YLM)
	DEALLOCATE(ZLM)
	DEALLOCATE(XL1)
	DEALLOCATE(XL2)
	END
