        SUBROUTINE INI_MAKETEI
******************************************************************
* Selects maximal # of plane waves which can affect k-dependence *
* of the interstitial-potential matrix elements. The rest will be*
* taken into account by Teilor series with respect to k-vector.  *
******************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
	USE COM_CONTROL, ONLY : IASA                            !!! from readini
      USE COM_LATPAR,  ONLY : PAR,OMEGAC,STRAIN               !!! from readini
      USE COM_LATTICE, ONLY : GBAS,RBAS,ISTRAIN               !!! from readstr
      USE COM_PLWMESH, ONLY : NPLW,GPLW                       !!! from plwmesh
      USE COM_TEILORG, ONLY : KEYT,MBAS,BZM,GOPT              !!! from readini
      USE COM_UNIT,    ONLY : IUN,IUR,IUT                     !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION GEQU(3,3),PNTK(3),PNTR(3),GL(3) 
      DATA PI/3.141592653589793D0/
	IF(IASA.NE.2)RETURN
	WRITE(IUN,1001)
1001  FORMAT(1X,'Start preparing Fourier transform for pseudoLMTOs:'/)
C SET RECIPROCAL LATTICE FOR THE CELL IN THE EQUILLIBRIUM
      IF(ISTRAIN.EQ.1)THEN
      DO IVEC=1,3
      DO I=1,3
      GEQU(I,IVEC)=0.D0
      DO J=1,3
      GEQU(I,IVEC)=GEQU(I,IVEC)+GBAS(J,IVEC)*STRAIN(J,I,1)
	ENDDO
	ENDDO
	ENDDO
      ELSEIF(ISTRAIN.NE.1)THEN
      DO IVEC=1,3
      GEQU(1,IVEC)=GBAS(1,IVEC)
      GEQU(2,IVEC)=GBAS(2,IVEC)
      GEQU(3,IVEC)=GBAS(3,IVEC)
	ENDDO
      ENDIF
C FIND POSSIBLE K-VECTOR OF LARGEST LENGHT
	N3=2
	N2=2
	N1=2
	BZMAX=0.D0
	DO I3=0,N3
	DO I2=0,N2
	DO I1=0,N1
	PNTK(1)=GEQU(1,1)/DBLE(N1)*DBLE(I1)
     &	       +GEQU(1,2)/DBLE(N2)*DBLE(I2)
     &	       +GEQU(1,3)/DBLE(N3)*DBLE(I3)
	PNTK(2)=GEQU(2,1)/DBLE(N1)*DBLE(I1)
     &	       +GEQU(2,2)/DBLE(N2)*DBLE(I2)
     &	       +GEQU(2,3)/DBLE(N3)*DBLE(I3)
	PNTK(3)=GEQU(3,1)/DBLE(N1)*DBLE(I1)
     &	       +GEQU(3,2)/DBLE(N2)*DBLE(I2)
     &	       +GEQU(3,3)/DBLE(N3)*DBLE(I3)
	CALL STR_SITEGEN_REDC(GEQU(1,1),GEQU(1,2),GEQU(1,3),PNTK,PNTR,0)
	BZMAX=MAX(BZMAX,SQRT(PNTR(1)**2+PNTR(2)**2+PNTR(3)**2))
	ENDDO
	ENDDO
	ENDDO
	BZMAX=BZMAX+1.D-10
C TRY TO FIND OPTIMAL # OF VECTORS
	IF(ABS(BZM).LE.1.D-10)THEN
	NOPTIMAL=350 ! optimal # of reciprocal lattice vectors
	VOPTIMAL=DBLE(NOPTIMAL)/OMEGAC*PAR**3
	GOPTIMAL=(3.D0/4.D0/PI*VOPTIMAL)**(1.D0/3.D0)
      IF(ISTRAIN.EQ.1)THEN
      DO I=1,3
      GL(I)=0.D0
      DO J=1,3
      GL(I)=GL(I)+GPLW(J,NPLW)*STRAIN(J,I,1)
      ENDDO
      ENDDO
      ELSEIF(ISTRAIN.NE.1)THEN
      DO I=1,3
      GL(I)=GPLW(I,NPLW)
      ENDDO
      ENDIF
      GCUTMAX=SQRT(GL(1)**2+GL(2)**2+GL(3)**2)
	IF(GOPTIMAL.GT.GCUTMAX)GOPTIMAL=GCUTMAX
	BZM=GOPTIMAL/BZMAX
	IF(BZM.LT. 5.D0)BZM= 5.D0
	IF(BZM.GT.10.D0)BZM=10.D0
	BZM=5.D0 ! we will keep this value for a while.
	ENDIF
	GOPT=BZM*BZMAX
C FIND # OF VECTORS WITHIN A SPHERE "GSMAL"
	DO IPLW=0,NPLW
        IF(ISTRAIN.EQ.1)THEN
        DO I=1,3
        GL(I)=0.D0
        DO J=1,3
        GL(I)=GL(I)+GPLW(J,IPLW)*STRAIN(J,I,1)
        ENDDO
        ENDDO
        ELSEIF(ISTRAIN.NE.1)THEN
        DO I=1,3
        GL(I)=GPLW(I,IPLW)
        ENDDO
        ENDIF
	ABSI=SQRT(GL(1)**2+GL(2)**2+GL(3)**2)
	IF(ABSI.GT.GOPT)EXIT
	ENDDO 
C MEMORY LIMITS
        MBAS=IPLW-1
	IF(KEYT.EQ.0)MBAS=NPLW+1
        MBASMEM=MBAS
        WRITE(IUN,1010)MBAS
        WRITE(IUN,1020)BZMAX
        WRITE(IUN,1030)GOPT
        WRITE(IUN,1040)GOPT**2*(2.D0*PI/PAR)**2
1010    FORMAT(1X,'# of (k+G)-terms in Fourier sums ',I7)
1020    FORMAT(1X,'Brillouin zone radius calculated ',G14.7,' 2pi/a')
1030    FORMAT(1X,'Teilor"s sphere radius estimated ',G14.7,' 2pi/a')
1040    FORMAT(1X,'Teilor"s cutoff energy estimated ',G14.7,' Ry  '/)
C ERROR HANDLINGS
C       none
        END SUBROUTINE INI_MAKETEI
