	SUBROUTINE INI_MAKETTR
**************************************************************
* Controls computing the k-mesh.                             *
**************************************************************
C SET ARRAY SIZE DATA
	USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM
	USE COM_INPTTR,  ONLY : NDIV,NDIC,NDIW,NDIVDIR                   !!! from readini
      USE COM_LATTICE, ONLY : RBAS,GBAS,BBAS,AKBAS,RKBAS,ORIGIN,IBZCUBE ! from readstr
	USE COM_NBANDS  ,ONLY : NBNDF,NBNDE,NBNDT,NBNDC                  !!! from readini
      USE COM_TETRGEN ,ONLY : NPOINTS,POINTS,WEIGHS,IREFPQS
     &                       ,IREFGQS,IREFTQS,ITTRCUT                  !!! from makettr
      USE COM_KMESH,   ONLY : NPNT,PNT,WGT,IPQARR,IGQARR,KCUT,ITQARR   !!! from tetra
      USE COM_WMESH,   ONLY : NPNW,PNW,WGW,IPWARR,IGWARR,KCUW,ITWARR   !!! from tetra
	USE COM_KAPPAR,  ONLY : NPAN
	USE COM_UNIT,    ONLY : IUN,IUR,IUT
      USE COM_MASHDEP, ONLY : LENINT,LENREL                            !!! from setup
      USE COM_LATPAR,  ONLY : PAR                                      ! KH
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
 	INTEGER, INTRINSIC :: SIZE
	LOGICAL LOGBZA

c---------- Start : Brillouin zone data output added by Gunnar ----------
	
	INTEGER :: fh_bz = 7919 ! File handle for file bz.dat
	integer :: i,j          ! Loop indices
	integer :: iktmp        ! Temporary k-point index
	integer :: igtmp        ! Temporary group index
	integer :: nkp          ! Number of irreducible k-points
	integer :: nktot        ! Total number of k-points
	integer :: ntet         ! Number of irreducible tetrahedra
	integer :: j1,j2,j3     ! Loop indices
	integer :: tc(1:4)      ! Tetrahedron corner indices
	integer :: ikp          ! k-point counter
	integer :: itet         ! Tetrahedron counter
	integer :: nbr(1:3,1:4) ! Nearest neighbour array
	integer :: gro(1:3,1:4) ! Group operations for nearest neighbours
	real*8  :: latcon       ! Lattice constant (atomic units)
	real*8  :: kx,ky,kz
	
c---------- Finish: Brillouin zone data output added by Gunnar ----------       

	
C START CODE:
	WRITE(IUN,1001)
C SET DEFAULT BZ DIVISIONS IF REQUIRED
	IF(NDIV(1)+NDIV(2)+NDIV(3).EQ.0)THEN
	IF(NBNDC(1).EQ.0)NDIVOPT=4
	IF(NBNDC(1).NE.0)NDIVOPT=6
C Find largest vector
	BZL1=SQRT(BBAS(1,1)**2+BBAS(2,1)**2+BBAS(3,1)**2)
	BZL2=SQRT(BBAS(1,2)**2+BBAS(2,2)**2+BBAS(3,2)**2)
	BZL3=SQRT(BBAS(1,3)**2+BBAS(2,3)**2+BBAS(3,3)**2)
	BZN1=DBLE(NDIVOPT)*BZL1/MAX(BZL1,BZL2,BZL3)
	BZN2=DBLE(NDIVOPT)*BZL2/MAX(BZL1,BZL2,BZL3)
	BZN3=DBLE(NDIVOPT)*BZL3/MAX(BZL1,BZL2,BZL3)
C Set divisions for main panel
	NDIV(1)=NINT(BZN1)
	NDIV(2)=NINT(BZN2)
	NDIV(3)=NINT(BZN3)
	NDIVMIN=MIN(NDIV(1),NDIV(2),NDIV(3))
	IF(MOD(NDIVMIN,2).NE.0)THEN
	IF(MOD(NDIV(1),NDIVMIN).EQ.0)NDIV(1)=(NDIVMIN+1)*(NDIV(1)/NDIVMIN)
	IF(MOD(NDIV(2),NDIVMIN).EQ.0)NDIV(2)=(NDIVMIN+1)*(NDIV(2)/NDIVMIN)
	IF(MOD(NDIV(3),NDIVMIN).EQ.0)NDIV(3)=(NDIVMIN+1)*(NDIV(3)/NDIVMIN)
	ENDIF
	IF(MOD(NDIV(1),2).NE.0)NDIV(1)=NDIV(1)+1
	IF(MOD(NDIV(2),2).NE.0)NDIV(2)=NDIV(2)+1
	IF(MOD(NDIV(3),2).NE.0)NDIV(3)=NDIV(3)+1
	IF(NDIV(1).LE.0)NDIV(1)=1
	IF(NDIV(2).LE.0)NDIV(2)=1
	IF(NDIV(3).LE.0)NDIV(3)=1
	NDIW(1)=NDIV(1)
	NDIW(2)=NDIV(2)
	NDIW(3)=NDIV(3)
C Set divisons for semicore panels
	NDIC(1)=NDIV(1)
	NDIC(2)=NDIV(2)
	NDIC(3)=NDIV(3)
	ENDIF
C CHECK IF BZ IS RECIPROCAL LATTICE CELL
	LOGBZA=.TRUE.
	DO IVEC=1,3
	DO I=1,3
	IF(ABS(BBAS(I,IVEC)-GBAS(I,IVEC)).GT.1.D-06)LOGBZA=.FALSE.
	ENDDO
	ENDDO
	IF(IBZCUBE.EQ.0)LOGBZA=.FALSE.
C SET PRIMITIVE TRANSLATIONS FOR BZ AND PRIMITIVE CELL
      DO I=1,3
      AKBAS(I,1,1)=BBAS(I,1)/NDIV(1)
      AKBAS(I,2,1)=BBAS(I,2)/NDIV(2)
      AKBAS(I,3,1)=BBAS(I,3)/NDIV(3)
      AKBAS(I,1,2)=BBAS(I,1)/NDIC(1)
      AKBAS(I,2,2)=BBAS(I,2)/NDIC(2)
      AKBAS(I,3,2)=BBAS(I,3)/NDIC(3)
      AKBAS(I,1,3)=BBAS(I,1)/NDIW(1)
      AKBAS(I,2,3)=BBAS(I,2)/NDIW(2)
      AKBAS(I,3,3)=BBAS(I,3)/NDIW(3)
	ENDDO
C SET TRANSLATIONS WHICH ARE RECIPROCAL TO AKBAS AND AD
      DO IP=1,3
      CALL INI_READSTR_CROS(RKBAS(1,1,IP),AKBAS(1,2,IP),AKBAS(1,3,IP))
      CALL INI_READSTR_CROS(RKBAS(1,2,IP),AKBAS(1,3,IP),AKBAS(1,1,IP))
      CALL INI_READSTR_CROS(RKBAS(1,3,IP),AKBAS(1,1,IP),AKBAS(1,2,IP))
      WK=AKBAS(1,1,IP)*RKBAS(1,1,IP)+AKBAS(2,1,IP)*RKBAS(2,1,IP)+
     &AKBAS(3,1,IP)*RKBAS(3,1,IP)
      DO I=1,3
      RKBAS(I,1,IP)=RKBAS(I,1,IP)/WK
      RKBAS(I,2,IP)=RKBAS(I,2,IP)/WK
      RKBAS(I,3,IP)=RKBAS(I,3,IP)/WK
	ENDDO
	ENDDO
C ************************************************
C CONSTRUCT K-MESH IN THE ENTIRE BZ
      IF(NDIVDIR.EQ.0)THEN
C MEMORY ALLOCATIONS FOR MAIN CONTROL ARRAYS
      ALLOCATE(IPQARR(0:NDIV(1),0:NDIV(2),0:NDIV(3)))
      ALLOCATE(IGQARR(0:NDIV(1),0:NDIV(2),0:NDIV(3)))
      ALLOCATE(IPWARR(0:NDIW(1),0:NDIW(2),0:NDIW(3)))
      ALLOCATE(IGWARR(0:NDIW(1),0:NDIW(2),0:NDIW(3)))
      ALLOCATE(ITQARR(6,0:NDIV(1),0:NDIV(2),0:NDIV(3)))
      ALLOCATE(ITWARR(6,0:NDIW(1),0:NDIW(2),0:NDIW(3)))
      SIZE_IPQ=DBLE(SIZE(IPQARR)*LENINT)/1024.D0**2
      SIZE_IGQ=DBLE(SIZE(IGQARR)*LENINT)/1024.D0**2
      SIZE_ITQ=DBLE(SIZE(ITQARR)*LENINT)/1024.D0**2
      SIZE_IPW=DBLE(SIZE(IPWARR)*LENINT)/1024.D0**2
      SIZE_IGW=DBLE(SIZE(IGWARR)*LENINT)/1024.D0**2
      SIZE_ITW=DBLE(SIZE(ITWARR)*LENINT)/1024.D0**2
      CURMEM=CURMEM+SIZE_IGQ+SIZE_IPQ+SIZE_ITQ
     &             +SIZE_IGW+SIZE_IPW+SIZE_ITW
      ALLOCATE(NPNT(NPANMEM))
      ALLOCATE(NPNW(NPANMEM))
C Generate k-mesh for the valence panel
	IF(LOGBZA)
     &CALL INI_MAKETTR_TETR(NDIV,RBAS,GBAS,AKBAS(1,1,1),
     &RKBAS(1,1,1))
	IF(.NOT.LOGBZA)
     &CALL INI_MAKETTR_CUBE(NDIV,RBAS,GBAS,AKBAS(1,1,1),
     &RKBAS(1,1,1),ORIGIN)
      NPNT(1)=NPOINTS
      NPNTMEM=NPOINTS
      ALLOCATE(PNT(3,NPNTMEM,NPANMEM))
      ALLOCATE(WGT(  NPNTMEM,NPANMEM))
      SIZE_PNT=DBLE(SIZE(PNT)*LENREL)/1024.D0**2
      SIZE_WGT=DBLE(SIZE(WGT)*LENREL)/1024.D0**2
      CURMEM=CURMEM+SIZE_PNT+SIZE_WGT
C Set points/weights
	DO IPNT=1,NPNT(1)
	PNT(1,IPNT,1)=POINTS(1,IPNT)
	PNT(2,IPNT,1)=POINTS(2,IPNT)
	PNT(3,IPNT,1)=POINTS(3,IPNT)
	WGT(IPNT,1)=WEIGHS(IPNT)
	ENDDO
C Set pointers
	DO I1=0,NDIV(1)
	DO I2=0,NDIV(2)
	DO I3=0,NDIV(3)
	IPQARR(I1,I2,I3)=IREFPQS(I1,I2,I3)
	IGQARR(I1,I2,I3)=IREFGQS(I1,I2,I3)
	DO ITTR=1,6
	ITQARR(ITTR,I1,I2,I3)=IREFTQS(ITTR,I1,I2,I3)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C Set tetrahedra
	DO ITTR=1,6
      DO I=1,4
      KCUT(1,I,ITTR)=ITTRCUT(1,I,ITTR)
      KCUT(2,I,ITTR)=ITTRCUT(2,I,ITTR)
      KCUT(3,I,ITTR)=ITTRCUT(3,I,ITTR)
	ENDDO
	ENDDO

c---------- Start : Brillouin zone data output added by Gunnar ----------
	
	open(fh_bz,file='bz.dat',status='unknown')
	
c---------- Find number of irreducible k-points and tetrahedra ----------

	nkp = npnt(1)
	nktot = ndiv(1)*ndiv(2)*ndiv(3)
	
	itet = 0
	do i3 = 0,ndiv(3)-1
	   do i2 = 0,ndiv(2)-1
	      do i1 = 0,ndiv(1)-1
		 do ittr = 1,6
		    wtet = itqarr(ittr,i1,i2,i3)
		    if(wtet.gt.0) then
		       itet = itet+1
		    endif
		 enddo
	      enddo
	   enddo
	enddo

	ntet = itet

	latcon = PAR

	write(fh_bz,'("##### lattice constant, ")',advance='no')
	write(fh_bz,'("number of k-points and tetrahedra #####")')

	write(fh_bz,'(f18.10,6i8)') latcon,nkp,ntet,nktot,
     &                              ndiv(1),ndiv(2),ndiv(3)

        write(fh_bz,'("#####  k-point coordinates, ")',advance='no')
	write(fh_bz,'("multiplicity and weight #####")')

	DO IPNT=1,NPNT(1)
	   write(fh_bz,'(i5,4f18.10)') ipnt,pnt(1,ipnt,1),
     &           pnt(2,ipnt,1),pnt(3,ipnt,1),wgt(ipnt,1)
	ENDDO

	write(fh_bz,'("##### tetrahedron number, ")',advance='no')
	write(fh_bz,'("multiplicity, corner index and type #####")')

	itet = 0
	do i3 = 0,ndiv(3)-1
	   do i2 = 0,ndiv(2)-1
	      do i1 = 0,ndiv(1)-1
		 do ittr = 1,6
		    wtet = itqarr(ittr,i1,i2,i3)
		    if(wtet.gt.0) then
		       itet = itet+1
		       do i = 1,4
			  j1 = i1+kcut(1,i,ittr)
			  j2 = i2+kcut(2,i,ittr)
			  j3 = i3+kcut(3,i,ittr)
			  tc(i) = ipqarr(j1,j2,j3)
		       enddo
		       write(fh_bz,'(7i5)') itet,int(wtet),
     &                       tc(1),tc(2),tc(3),tc(4),ittr
		    endif
		 enddo
	      enddo
	   enddo
	enddo

	write(fh_bz,'("##### kcut matrices for each, ")',advance='no')
	write(fh_bz,'("tetrahedron type #####")')

	write(fh_bz,'(6(4i2,2x))') ((kcut(1,i,ittr),i=1,4),ittr=1,6)
	write(fh_bz,'(6(4i2,2x))') ((kcut(2,i,ittr),i=1,4),ittr=1,6)
	write(fh_bz,'(6(4i2,2x))') ((kcut(3,i,ittr),i=1,4),ittr=1,6)
	
	write(fh_bz,'("#####  nearest neighbor index #####")')

C Check for neighbours of every irreducible k-point

	do ikp = 1,nkp

C Find a representative for the irreducible k-point
	   
	   i3loop: do i3 = 0, ndiv(3)-1
	   do i2 = 0, ndiv(2)-1
	      do i1 = 0, ndiv(1)-1
		 iktmp = ipqarr(i1,i2,i3)
		 igtmp = igqarr(i1,i2,i3)
		 
		 
c---------- Check if the point corresponds to the irreducible ----------
c---------- point and make sure that it is the correct point. ----------
c---------- Group operation number one is always the identity ----------

		 if(iktmp.eq.ikp.and.igtmp.eq.1) then

C---------- Found the correct point ----------

				!---------- Direction 1 ----------
		    
		    i = mod(i1+1,ndiv(1))          ! x+dx
		    if (i.lt.0) i=i+ndiv(1)
		    nbr(1,1) = ipqarr(i,i2,i3)
		    gro(1,1) = igqarr(i,i2,i3)

		    i = mod(i1-1,ndiv(1))          ! x-dx
		    if (i.lt.0) i=i+ndiv(1)
		    nbr(1,2) = ipqarr(i,i2,i3)
		    gro(1,2) = igqarr(i,i2,i3)

		    i = mod(i1+2,ndiv(1))          ! x+2dx
		    if (i.lt.0) i=i+ndiv(1)
		    nbr(1,3) = ipqarr(i,i2,i3)
		    gro(1,3) = igqarr(i,i2,i3)

		    i = mod(i1-2,ndiv(1))          ! x-2dx
		    if (i.lt.0) i=i+ndiv(1)
		    nbr(1,4) = ipqarr(i,i2,i3)
		    gro(1,4) = igqarr(i,i2,i3)

		    
				!---------- Direction 2 ----------

		    i = mod(i2+1,ndiv(2))          ! y+dy
		    if (i.lt.0) i=i+ndiv(2)
		    nbr(2,1) = ipqarr(i1,i,i3)
		    gro(2,1) = igqarr(i1,i,i3)

		    i = mod(i2-1,ndiv(2))          ! y-dy
		    if (i.lt.0) i=i+ndiv(2)
		    nbr(2,2) = ipqarr(i1,i,i3)
		    gro(2,2) = igqarr(i1,i,i3)

		    i = mod(i2+2,ndiv(2))          ! y+2dy
		    if (i.lt.0) i=i+ndiv(2)
		    nbr(2,3) = ipqarr(i1,i,i3)
		    gro(2,3) = igqarr(i1,i,i3)

		    i = mod(i2-2,ndiv(2))          ! y-2dy
		    if (i.lt.0) i=i+ndiv(2)
		    nbr(2,4) = ipqarr(i1,i,i3)
		    gro(2,4) = igqarr(i1,i,i3)


				!---------- Direction 3 ----------

		    i = mod(i3+1,ndiv(3))          ! z+dz
		    if (i.lt.0) i=i+ndiv(3)
		    nbr(3,1) = ipqarr(i1,i2,i)
		    gro(3,1) = igqarr(i1,i2,i)

		    i = mod(i3-1,ndiv(3))          ! z-dz
		    if (i.lt.0) i=i+ndiv(3)
		    nbr(3,2) = ipqarr(i1,i2,i)
		    gro(3,2) = igqarr(i1,i2,i)

		    i = mod(i3+2,ndiv(3))          ! z+2dz
		    if (i.lt.0) i=i+ndiv(3)
		    nbr(3,3) = ipqarr(i1,i2,i)
		    gro(3,3) = igqarr(i1,i2,i)

		    i = mod(i3-2,ndiv(3))          ! z-2dz
		    if (i.lt.0) i=i+ndiv(3)
		    nbr(3,4) = ipqarr(i1,i2,i)
		    gro(3,4) = igqarr(i1,i2,i)

		    write(fh_bz,'(13i5)') ikp,((nbr(i,j),j=1,4),i=1,3)
		    write(fh_bz,'(13i5)') ikp,((gro(i,j),j=1,4),i=1,3)

		    
C Now go to the next irreducible k-point

		    exit i3loop
		    
		 endif
		 
	      enddo
	   enddo
	enddo i3loop
	enddo

	write(fh_bz,'("#####  real space A matrix #####")')

	write(fh_bz,'(3f18.10)') (RBAS(i,1)*ndiv(i),i=1,3)  ! x dir
	write(fh_bz,'(3f18.10)') (RBAS(i,2)*ndiv(i),i=1,3)  ! y dir 
	write(fh_bz,'(3f18.10)') (RBAS(i,3)*ndiv(i),i=1,3)  ! z dir

	write(fh_bz,'("#####  momentum space  matrix #####")')

	write(fh_bz,'(3f18.10)') (GBAS(i,1)/ndiv(i),i=1,3)  ! x dir
	write(fh_bz,'(3f18.10)') (GBAS(i,2)/ndiv(i),i=1,3)  ! y dir
	write(fh_bz,'(3f18.10)') (GBAS(i,3)/ndiv(i),i=1,3)  ! z dir

	write(fh_bz,'("##### All k-points and reference point #####")')

	do i3 = 0,ndiv(3)-1
	   do i2 = 0,ndiv(2)-1
	      do i1 = 0,ndiv(1)-1
		 kx = i1*AKBAS(1,1,1)+i2*AKBAS(2,1,1)+i3*AKBAS(3,1,1)
		 ky = i1*AKBAS(1,2,1)+i2*AKBAS(2,2,1)+i3*AKBAS(3,2,1)
		 kz = i1*AKBAS(1,3,1)+i2*AKBAS(2,3,1)+i3*AKBAS(3,3,1)
		 write(fh_bz,'(3i3,i5,i4)') i1,i2,i3,
     &                   ipqarr(i1,i2,i3),igqarr(i1,i2,i3)
	      enddo
	   enddo
	enddo
	
	close(fh_bz)

c---------- Finish: Brillouin zone data output added by Gunnar ----------

	
C MEMORY DEALLOCATIONS
	DEALLOCATE(POINTS,WEIGHS,IREFPQS,IREFGQS,IREFTQS)
C Generate k-mesh for semicore panels
	IF(LOGBZA)
     &CALL INI_MAKETTR_TETR(NDIC,RBAS,GBAS,AKBAS(1,1,2),
     &RKBAS(1,1,2))
	IF(.NOT.LOGBZA)
     &CALL INI_MAKETTR_CUBE(NDIC,RBAS,GBAS,AKBAS(1,1,2),
     &RKBAS(1,1,2),ORIGIN)
	IF(NPOINTS.GT.NPNT(1))CALL INI_MAKETTR_MESG01
C Set points/weights
	DO IPAN=2,NPAN
	NPNT(IPAN)=NPOINTS
      DO IPNT=1,NPNT(IPAN)
      PNT(1,IPNT,IPAN)=POINTS(1,IPNT)
      PNT(2,IPNT,IPAN)=POINTS(2,IPNT)
      PNT(3,IPNT,IPAN)=POINTS(3,IPNT)
	WGT(IPNT,IPAN)=WEIGHS(IPNT)
	ENDDO
	ENDDO
C MEMORY DEALLOCATIONS
	DEALLOCATE(POINTS,WEIGHS,IREFPQS,IREFGQS,IREFTQS)
C Generate k-mesh for weights
	IF(LOGBZA)
     &CALL INI_MAKETTR_TETR(NDIW,RBAS,GBAS,AKBAS(1,1,3),
     &RKBAS(1,1,3))
	IF(.NOT.LOGBZA)
     &CALL INI_MAKETTR_CUBE(NDIW,RBAS,GBAS,AKBAS(1,1,3),
     &RKBAS(1,1,3),ORIGIN)
	IF(NPOINTS.LT.NPNT(1))CALL INI_MAKETTR_MESG02
      NPNW(1)=NPOINTS
      NPNWMEM=NPOINTS
      ALLOCATE(PNW(3,NPNWMEM,NPANMEM))
      ALLOCATE(WGW(  NPNWMEM,NPANMEM))
      SIZE_PNW=DBLE(SIZE(PNW)*LENREL)/1024.D0**2
      SIZE_WGW=DBLE(SIZE(WGW)*LENREL)/1024.D0**2
      CURMEM=CURMEM+SIZE_PNW+SIZE_WGW
C Set points/weights
	DO IPNT=1,NPNW(1)
	PNW(1,IPNT,1)=POINTS(1,IPNT)
	PNW(2,IPNT,1)=POINTS(2,IPNT)
	PNW(3,IPNT,1)=POINTS(3,IPNT)
	WGW(IPNT,1)=WEIGHS(IPNT)
	ENDDO
C Set points/weights
      DO IPAN=2,NPAN
      NPNW(IPAN)=NPNT(IPAN)
      DO IPNT=1,NPNW(IPAN)
      PNW(1,IPNT,IPAN)=PNT(1,IPNT,IPAN)
      PNW(2,IPNT,IPAN)=PNT(2,IPNT,IPAN)
      PNW(3,IPNT,IPAN)=PNT(3,IPNT,IPAN)
      WGW(IPNT,IPAN)=WGT(IPNT,IPAN)
      ENDDO
      ENDDO
C Set pointers
	DO I1=0,NDIW(1)
	DO I2=0,NDIW(2)
	DO I3=0,NDIW(3)
	IPWARR(I1,I2,I3)=IREFPQS(I1,I2,I3)
	IGWARR(I1,I2,I3)=IREFGQS(I1,I2,I3)
	DO ITTR=1,6
	ITWARR(ITTR,I1,I2,I3)=IREFTQS(ITTR,I1,I2,I3)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C Set tetrahedra
	DO ITTR=1,6
      DO I=1,4
      KCUW(1,I,ITTR)=ITTRCUT(1,I,ITTR)
      KCUW(2,I,ITTR)=ITTRCUT(2,I,ITTR)
      KCUW(3,I,ITTR)=ITTRCUT(3,I,ITTR)
	ENDDO
	ENDDO
C LINK POINTS
      CALL INI_MAKETTR_LINKS
C MEMORY DEALLOCATIONS
	DEALLOCATE(POINTS,WEIGHS,IREFPQS,IREFGQS,IREFTQS)
C ******************************************************************
C CONSTRUCT K-MESH ALONG HIGH-SYMMETRY LINES
      ELSEIF(NDIVDIR.NE.0)THEN
	CALL INI_MAKETTR_DIRS
	ENDIF 
C Print points
      WRITE(IUN,1010)NPNT(1)
      IF(NPAN.GT.1)WRITE(IUN,1020)NPNT(NPAN)
      IF(NPNT(1).NE.NPNW(1))WRITE(IUN,1030)NPNW(1)
1001	FORMAT(1X,'Start preparing mesh of k-points:'/)
1010  FORMAT(1X,'K-points generated  for main valence panel:',I5)
1020  FORMAT(1X,'K-points generated  for semicore    panels:',I5/)
1030  FORMAT(1X,'K-points generated  for weights           :',I5/)
C ******************************************************************
C ERROR HANDLINGS
	CONTAINS
	SUBROUTINE INI_MAKETTR_MESG01
	WRITE(IUT,*)'Terminated in <MAKETTR>:'
	WRITE(IUT,*)'# of k-points for semicore panels'
	WRITE(IUT,*)'is found to be larger than # of k-points'
	WRITE(IUT,*)'generated for valence panel. This is not'
	WRITE(IUT,*)'assumed. Specify divsions NDIC.LE.NDIV in'
	WRITE(IUT,*)'INIFILE.'
	CALL FULLSTOP(' ')
	END SUBROUTINE INI_MAKETTR_MESG01
	SUBROUTINE INI_MAKETTR_MESG02
	WRITE(IUT,*)'Terminated in <MAKETTR>:'
	WRITE(IUT,*)'# of k-points for weights'
	WRITE(IUT,*)'is found to be smaller than # of k-points'
	WRITE(IUT,*)'generated for valence panel. This is not'
	WRITE(IUT,*)'assumed. Specify divsions NDIW.GE.NDIV in'
	WRITE(IUT,*)'INIFILE.'
	CALL FULLSTOP(' ')
	END SUBROUTINE INI_MAKETTR_MESG02
	END  



      SUBROUTINE INI_MAKETTR_TETR(NDIVS,RBAS,GBAS,AKBAS,RKBAS)
**************************************************************
*  Divides the reciprocal lattice into microcells            *
**************************************************************
C SET EXTERNAL CONNECTIONS
      USE COM_TETRGEN ,ONLY : NPOINTS,POINTS,WEIGHS,IREFPQS
     &                       ,IREFGQS,IREFTQS,ITTRCUT         !!! from makettr
      USE COM_GROUPS  ,ONLY : NGROUP,IKOV,U                   !!! from groups
	USE COM_SITEGEN ,ONLY : NSITES,SITES,IREFSITES          !!! from sitegen
	USE COM_UNIT,    ONLY : IUN,IUR,IUT
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER, ALLOCATABLE :: KVEC(:,:)
	INTEGER NDIVS(3),IBTR(3,3),IMC(0:1,0:1,0:1),KTT(4),KTK(4)
	DIMENSION V(3),V1(3),TU(3),QB1(3,3),RBAS(3,3),GBAS(3,3)
     &  ,AKBAS(3,3),RKBAS(3,3)
	DATA PI/3.141592653589793D0/,TU/0.D0,0.D0,0.D0/
C MEMORY ALLOCATIONS FOR MAIN CONTROL ARRAYS
	IF(ALLOCATED(IREFPQS))DEALLOCATE(IREFPQS)
	IF(ALLOCATED(IREFGQS))DEALLOCATE(IREFGQS)
	IF(ALLOCATED(IREFTQS))DEALLOCATE(IREFTQS)
	ALLOCATE(IREFPQS(0:NDIVS(1),0:NDIVS(2),0:NDIVS(3)))
	ALLOCATE(IREFGQS(0:NDIVS(1),0:NDIVS(2),0:NDIVS(3)))
	ALLOCATE(IREFTQS(6,0:NDIVS(1),0:NDIVS(2),0:NDIVS(3)))
C ************************************************************* 
C DO TWICE, FIRST: DEFINE # OF K-POINTS, SECOND ALLOCATE ARRAYS
	RM=1.5D0
	ILOOP=0
1000	ILOOP=ILOOP+1                            !!! make two loops
	IF(ILOOP.EQ.2)THEN
C MEMORY ALLOCATIONS
	IF(ALLOCATED(POINTS))DEALLOCATE(POINTS) 
	ALLOCATE(POINTS(3,NPOINTS))
	IF(ALLOCATED(WEIGHS))DEALLOCATE(WEIGHS) 
	ALLOCATE(WEIGHS(  NPOINTS))
	ENDIF
C ****************************************
C FIND SPHERE RADIUS CIRCUMSCRIBING BZ
	N1=NDIVS(1)
	N2=NDIVS(2)
	N3=NDIVS(3)	
	RMAX=0.D0
	DO IZ=-1,1
	DO JZ=-1,1
	DO KZ=-1,1
	RSUM=0.D0
	DO I=1,3
	RSUM=RSUM+(IZ*AKBAS(I,1)*N1+
     &           JZ*AKBAS(I,2)*N2+
     &           KZ*AKBAS(I,3)*N3)**2
	ENDDO
	RMAX=MAX(RMAX,RSUM)
	ENDDO
	ENDDO
	ENDDO
	RMAX=RM*SQRT(RMAX)+0.1D0
C GENERATE ALL RECIPROCAL LATTICE VECTORS INSIDE SPHERE "RMAX"
	CALL STR_SITEGEN(RMAX,GBAS,TU,1)
	NVEC=NSITES
C ALLOCATE KVEC ARRAY
	IF(ALLOCATED(KVEC))DEALLOCATE(KVEC)
	ALLOCATE(KVEC(3,0:NVEC))
	DO IVEC=0,NVEC
	X1=SITES(1,IVEC)*RKBAS(1,1)+
     &   SITES(2,IVEC)*RKBAS(2,1)+
     &   SITES(3,IVEC)*RKBAS(3,1)
	X2=SITES(1,IVEC)*RKBAS(1,2)+
     &   SITES(2,IVEC)*RKBAS(2,2)+
     &   SITES(3,IVEC)*RKBAS(3,2)
	X3=SITES(1,IVEC)*RKBAS(1,3)+
     &   SITES(2,IVEC)*RKBAS(2,3)+
     &   SITES(3,IVEC)*RKBAS(3,3)
	KVEC(1,IVEC)=ANINT(X1)
	KVEC(2,IVEC)=ANINT(X2)
	KVEC(3,IVEC)=ANINT(X3)
	IF(ABS(KVEC(1,IVEC)-X1).GE.1.D-05.OR.
     &   ABS(KVEC(2,IVEC)-X2).GE.1.D-05.OR.
     &   ABS(KVEC(3,IVEC)-X3).GE.1.D-05)CALL INI_MAKETTR_MESG01
	ENDDO
C Initialize indicators      
      DO I3=0,N3
      DO I2=0,N2
      DO I1=0,N1
      IREFGQS(I1,I2,I3)=0
      IREFPQS(I1,I2,I3)=0
	DO ITTR=1,6
      IREFTQS(ITTR,I1,I2,I3)=0
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C Find non-equivalent k-points
      NPOINTS=0
	NWGT=0
C Start looping over whole BZ
      DO 4000 I3=0,N3                       !!! over i3
      DO 3000 I2=0,N2                       !!! over i2
      DO 2000 I1=0,N1                       !!! over i1
      IF(IREFPQS(I1,I2,I3).EQ.0)THEN
      V(1)=I1*AKBAS(1,1)+
     &     I2*AKBAS(1,2)+
     &     I3*AKBAS(1,3)
      V(2)=I1*AKBAS(2,1)+
     &     I2*AKBAS(2,2)+
     &     I3*AKBAS(2,3)
      V(3)=I1*AKBAS(3,1)+
     &     I2*AKBAS(3,2)+
     &     I3*AKBAS(3,3)
      IWGT=0
C Rotate given point
      DO IR=1,NGROUP                   !!! over group
	IG=IKOV(IR)
      CALL LIB_ROTATE(V(1),V(2),V(3),V1(1),V1(2),V1(3),U(2,IG),2)
      X1=V1(1)*RKBAS(1,1)+
     &   V1(2)*RKBAS(2,1)+
     &   V1(3)*RKBAS(3,1)
      X2=V1(1)*RKBAS(1,2)+
     &   V1(2)*RKBAS(2,2)+
     &   V1(3)*RKBAS(3,2)
      X3=V1(1)*RKBAS(1,3)+
     &   V1(2)*RKBAS(2,3)+
     &   V1(3)*RKBAS(3,3)
      J1=ANINT(X1)
      J2=ANINT(X2)
      J3=ANINT(X3)
C Check whether the k-vector is on the grid
      IF(ABS(X1-J1).GE.1.D-03.OR.ABS(X2-J2).GE.1.D-03.OR.ABS(X3-J3).
     &GE.1.D-03)CALL INI_MAKETTR_MESG02
C Reduce the point to the BZ
	NRED=0
	DO IVEC=0,NVEC                    !!! over vectors
	K1=J1+KVEC(1,IVEC)
	K2=J2+KVEC(2,IVEC)
	K3=J3+KVEC(3,IVEC)
	IF(  (K1.GE.0.AND.K1.LE.N1)
     &.AND.(K2.GE.0.AND.K2.LE.N2)
     &.AND.(K3.GE.0.AND.K3.LE.N3))THEN
C The point is reduced to the BZ by vector IVEC             
	NRED=NRED+1
	IF(NRED.GT.8)CALL INI_MAKETTR_MESG03
	IF(IREFGQS(K1,K2,K3).EQ.0)IREFGQS(K1,K2,K3)=IR
	IF(IREFPQS(K1,K2,K3).EQ.0)IWGT=IWGT+1
         IREFPQS(K1,K2,K3)=NPOINTS+1
	ENDIF
	ENDDO                             !!! over vectors
   	IF(NRED.EQ.0)CALL INI_MAKETTR_MESG04
   	IF(NRED.EQ.0)GOTO1000
	ENDDO                             !!! over group
      NPOINTS=NPOINTS+1
C SET K-MESH 
	IF(ILOOP.EQ.2)THEN
      POINTS(1,NPOINTS)=V(1)
      POINTS(2,NPOINTS)=V(2)
      POINTS(3,NPOINTS)=V(3)
	WEIGHS(  NPOINTS)=0.D0
	ENDIF
	NWGT=NWGT+IWGT
      ENDIF
2000	CONTINUE                          !!! over i1
3000	CONTINUE                          !!! over i2
4000	CONTINUE                          !!! over i3
C DEALLOCATE KVEC ARRAY
	DEALLOCATE(KVEC)
	IF(NWGT.NE.(N1+1)*(N2+1)*(N3+1))CALL INI_MAKETTR_MESG05
C FIND NONEQUIVALENT TETRAHEDRA
	IF(ILOOP.EQ.2)THEN                !!! for second loop only
      CALL INI_MAKETTR_CCUTUP(AKBAS(1,1),QB1,IBTR,ITTRCUT)
      OT=1.D0/DBLE(N1*N2*N3)/6.D0       !!! volume of tetrahedron
      VOLIBZ=1.D0
      DO I3=0,N3-1
      DO I2=0,N2-1
      DO I1=0,N1-1
C Set up tetrahedron inside microcel
      DO ITTR=1,6
      DO I=1,4
C Coordinates of the tetrahedron are given by KTT
      J1=I1+ITTRCUT(1,I,ITTR)
      J2=I2+ITTRCUT(2,I,ITTR)
      J3=I3+ITTRCUT(3,I,ITTR)
      KTT(I)=IREFPQS(J1,J2,J3)
	ENDDO
      DO I=1,4
      WEIGHS(KTT(I))=WEIGHS(KTT(I))+OT/4.D0 ! geometrical weight f(kj)=1
	ENDDO
C Count how many times this tetrahedon present in the BZ
      IF(IREFTQS(ITTR,I1,I2,I3).EQ.0)THEN
	DO I=1,4
	DO J=I+1,4
	IF(KTT(I).GT.KTT(J))THEN
	K0=KTT(I)
	KTT(I)=KTT(J)
	KTT(J)=K0
	ENDIF
	ENDDO
	ENDDO
      DO K3=0,N3-1
      DO K2=0,N2-1
      DO K1=0,N1-1
C Set up tetrahedron inside microcel
      DO KTTR=1,6
      DO I=1,4
C Coordinates of the tetrahedron are given by KTT
      J1=K1+ITTRCUT(1,I,KTTR)
      J2=K2+ITTRCUT(2,I,KTTR)
      J3=K3+ITTRCUT(3,I,KTTR)
      KTK(I)=IREFPQS(J1,J2,J3)
	ENDDO
	DO I=1,4
	DO J=I+1,4
	IF(KTK(I).GT.KTK(J))THEN
	K0=KTK(I)
	KTK(I)=KTK(J)
	KTK(J)=K0
	ENDIF
	ENDDO
	ENDDO
	IF(KTT(1).EQ.KTK(1).AND.KTT(2).EQ.KTK(2).AND.
     &   KTT(3).EQ.KTK(3).AND.KTT(4).EQ.KTK(4))THEN
      IREFTQS(ITTR,I1,I2,I3)=IREFTQS(ITTR,I1,I2,I3)+1
	IF(IREFTQS(KTTR,K1,K2,K3).EQ.0)
     &IREFTQS(KTTR,K1,K2,K3)=-1
	ENDIF
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDIF
C
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C NORMALIZATION
      DO IPNT=1,NPOINTS
      WEIGHS(IPNT)=WEIGHS(IPNT)/VOLIBZ*2.D0
	ENDDO
	ENDIF                              !!! for second loop only
      IF(ILOOP.LT.2)GOTO1000             !!! over two loops
C CHECK TETRAHEDRA
	NTTR=0
      DO I3=0,N3-1
      DO I2=0,N2-1
      DO I1=0,N1-1
      DO ITTR=1,6
	IF(IREFTQS(ITTR,I1,I2,I3).LT.0)CYCLE
	NTTR=NTTR+IREFTQS(ITTR,I1,I2,I3)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	IF(NTTR.NE.6*N1*N2*N3)
     &CALL FULLSTOP('<INI_MAKETTR_TETR>: Wrong counting of tetrahedra!')
C MEMORY DEALLOCATIONS
	IF(ALLOCATED(SITES))DEALLOCATE(SITES)
	IF(ALLOCATED(IREFSITES))DEALLOCATE(IREFSITES)
	CONTAINS
C ERROR HANDLINGS
	SUBROUTINE INI_MAKETTR_MESG01
	WRITE(IUT,*)'Terminated in <MAKETTR>:'
	WRITE(IUT,*)'Internal error. Wrong generation of'
	WRITE(IUT,*)'reciprocal lattice vectors detected.'
	CALL FULLSTOP(' ')
	END SUBROUTINE INI_MAKETTR_MESG01
	SUBROUTINE INI_MAKETTR_MESG02
	WRITE(IUT,*)'Terminated in <MAKETTR>:'
	WRITE(IUT,*)'Wrong generation of the grid in k-space detected.'
	WRITE(IUT,*)'Check out grid divisions NDIV(:) in INIFILE'
	CALL FULLSTOP(' ')
	END SUBROUTINE INI_MAKETTR_MESG02
	SUBROUTINE INI_MAKETTR_MESG03
	WRITE(IUT,*)'Terminated in <MAKETTR>:'
	WRITE(IUT,*)'Internal error. NRED=0.'
	CALL FULLSTOP(' ')
	END SUBROUTINE INI_MAKETTR_MESG03
	SUBROUTINE INI_MAKETTR_MESG04
	WRITE(IUT,*)'Warning from <MAKETTR>:'
	WRITE(IUT,*)'Standard reduction algorithm does not work,'
	WRITE(IUT,*)'trying to increase RMAX.'
	RM=RM+0.5D0
	IF(RM.GT.5.D0)THEN
	WRITE(IUT,*)'Terminated in <MAKETTR>:'
      WRITE(IUT,*)'After applying symmetry operation the rotated'
      WRITE(IUT,*)'k point cannot be reduced to the first BZ.'
      WRITE(IUT,*)'even after increasing the Rmax to ',RM
      WRITE(IUT,*)'Check out grid divisions NDIV(:) in INIFILE.'
	WRITE(IUT,*)'It also might be an internal error in the'
	WRITE(IUT,*)'reduction algorithm.'
	CALL FULLSTOP(' ')
	ENDIF
	ILOOP=0
	END SUBROUTINE INI_MAKETTR_MESG04
	SUBROUTINE INI_MAKETTR_MESG05
	WRITE(IUT,*)'Terminated in <MAKETTR>:'
	WRITE(IUT,*)'Internal error: Sum rule for the geometrical'
	WRITE(IUT,*)'weights is violated.'        
	CALL FULLSTOP(' ')
	END SUBROUTINE INI_MAKETTR_MESG05
      END SUBROUTINE INI_MAKETTR_TETR




      SUBROUTINE INI_MAKETTR_CUBE(NDIVS,RBAS,GBAS,AKBAS,RKBAS,ORIGIN)
**************************************************************
*  Divides the reciprocal lattice into microcells            *
*  Generalized alghorithm is used by this routine            *
**************************************************************
C SET EXTERNAL CONNECTIONS
      USE COM_TETRGEN ,ONLY : NPOINTS,POINTS,WEIGHS,IREFPQS
     &                       ,IREFGQS,IREFTQS,ITTRCUT         !!! from makettr
      USE COM_GROUPS  ,ONLY : NGROUP,IKOV,U                   !!! from groups
	USE COM_SITEGEN ,ONLY : NSITES,SITES,IREFSITES          !!! from sitegen
	USE COM_UNIT,    ONLY : IUN,IUR,IUT
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER NDIVS(3),IBTR(3,3),IMC(0:1,0:1,0:1),KTT(4),KTK(4)
	DIMENSION V(3),V1(3),TU(3),QB1(3,3),RBAS(3,3),GBAS(3,3)
     &  ,AKBAS(3,3),RKBAS(3,3),ORIGIN(3)
	DATA PI/3.141592653589793D0/,TU/0.D0,0.D0,0.D0/
C MEMORY ALLOCATIONS FOR MAIN CONTROL ARRAYS
	IF(ALLOCATED(IREFPQS))DEALLOCATE(IREFPQS)
	IF(ALLOCATED(IREFGQS))DEALLOCATE(IREFGQS)
	IF(ALLOCATED(IREFTQS))DEALLOCATE(IREFTQS)
	ALLOCATE(IREFPQS(0:NDIVS(1),0:NDIVS(2),0:NDIVS(3)))
	ALLOCATE(IREFGQS(0:NDIVS(1),0:NDIVS(2),0:NDIVS(3)))
	ALLOCATE(IREFTQS(6,0:NDIVS(1),0:NDIVS(2),0:NDIVS(3)))
C ************************************************************* 
C DO TWICE, FIRST: DEFINE # OF K-POINTS, SECOND ALLOCATE ARRAYS
	RM=1.5D0
	ILOOP=0
1000	ILOOP=ILOOP+1                            !!! make two loops
	IF(ILOOP.EQ.2)THEN
C MEMORY ALLOCATIONS
	IF(ALLOCATED(POINTS))DEALLOCATE(POINTS) 
	ALLOCATE(POINTS(3,NPOINTS))
	IF(ALLOCATED(WEIGHS))DEALLOCATE(WEIGHS) 
	ALLOCATE(WEIGHS(  NPOINTS))
	ENDIF
C ****************************************
C FIND SPHERE RADIUS CIRCUMSCRIBING BZ
	N1=NDIVS(1)
	N2=NDIVS(2)
	N3=NDIVS(3)	
	RMAX=0.D0
	DO IZ=-1,1
	DO JZ=-1,1
	DO KZ=-1,1
	RSUM=0.D0
	DO I=1,3
	RSUM=RSUM+(IZ*AKBAS(I,1)*N1+JZ*AKBAS(I,2)*N2+KZ*AKBAS(I,3)*N3)**2
	ENDDO
	RMAX=MAX(RMAX,RSUM)
	ENDDO
	ENDDO
	ENDDO
	RMAX=RM*SQRT(RMAX)+0.1D0
C GENERATE ALL RECIPROCAL LATTICE VECTORS INSIDE SPHERE "RMAX"
	CALL STR_SITEGEN(RMAX,GBAS,TU,1)
	NVEC=NSITES
C Initialize indicators      
      DO I3=0,N3
      DO I2=0,N2
      DO I1=0,N1
      IREFGQS(I1,I2,I3)=0
      IREFPQS(I1,I2,I3)=0
	DO ITTR=1,6
      IREFTQS(ITTR,I1,I2,I3)=0
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C Find non-equivalent k-points
      NPOINTS=0
	NWGT=0
C Start looping over whole BZ
      DO 4000 I3=0,N3                       !!! over i3
      DO 3000 I2=0,N2                       !!! over i2
      DO 2000 I1=0,N1                       !!! over i1
      IF(IREFPQS(I1,I2,I3).EQ.0)THEN
      V(1)=I1*AKBAS(1,1)+I2*AKBAS(1,2)+I3*AKBAS(1,3)-ORIGIN(1)
      V(2)=I1*AKBAS(2,1)+I2*AKBAS(2,2)+I3*AKBAS(2,3)-ORIGIN(2)
      V(3)=I1*AKBAS(3,1)+I2*AKBAS(3,2)+I3*AKBAS(3,3)-ORIGIN(3)
      IWGT=0
C Rotate given point
      DO IR=1,NGROUP                   !!! over group
	IG=IKOV(IR)
      CALL LIB_ROTATE(V(1),V(2),V(3),V1(1),V1(2),V1(3),U(2,IG),2)
C Reduce the point to the BZ
	NRED=0
	DO IVEC=0,NVEC                    !!! over vectors
	X1=V1(1)+SITES(1,IVEC)+ORIGIN(1)
	X2=V1(2)+SITES(2,IVEC)+ORIGIN(2)
	X3=V1(3)+SITES(3,IVEC)+ORIGIN(3)
      Y1=X1*RKBAS(1,1)+X2*RKBAS(2,1)+X3*RKBAS(3,1)
      Y2=X1*RKBAS(1,2)+X2*RKBAS(2,2)+X3*RKBAS(3,2)
      Y3=X1*RKBAS(1,3)+X2*RKBAS(2,3)+X3*RKBAS(3,3)
      K1=ANINT(Y1)
      K2=ANINT(Y2)
      K3=ANINT(Y3)
C Check whether the k-vector is on the grid
      IF(ABS(Y1-K1).GE.1.D-03.OR.ABS(Y2-K2).GE.1.D-03.OR.ABS(Y3-K3).
     &GE.1.D-03)CYCLE
	IF(  (K1.GE.0.AND.K1.LE.N1)
     &.AND.(K2.GE.0.AND.K2.LE.N2)
     &.AND.(K3.GE.0.AND.K3.LE.N3))THEN
C The point is reduced to the BZ by vector IVEC             
	NRED=NRED+1
	IF(IREFGQS(K1,K2,K3).EQ.0)IREFGQS(K1,K2,K3)=IR
	IF(IREFPQS(K1,K2,K3).EQ.0)IWGT=IWGT+1
         IREFPQS(K1,K2,K3)=NPOINTS+1
	ENDIF
	ENDDO                             !!! over vectors
	ENDDO                             !!! over group
      NPOINTS=NPOINTS+1
C SET K-MESH 
	IF(ILOOP.EQ.2)THEN
      POINTS(1,NPOINTS)=V(1)
      POINTS(2,NPOINTS)=V(2)
      POINTS(3,NPOINTS)=V(3)
	WEIGHS(  NPOINTS)=0.D0
	ENDIF
	NWGT=NWGT+IWGT
      ENDIF
2000	CONTINUE                          !!! over i1
3000	CONTINUE                          !!! over i2
4000	CONTINUE                          !!! over i3
      IF(ILOOP.LT.2)GOTO1000             !!! over two loops
C MEMORY DEALLOCATIONS
	IF(ALLOCATED(SITES))DEALLOCATE(SITES)
	IF(ALLOCATED(IREFSITES))DEALLOCATE(IREFSITES)
	CONTAINS
C ERROR HANDLINGS
	SUBROUTINE INI_MAKETTR_MESG05
	WRITE(IUT,*)'Terminated in <MAKETTR>:'
	WRITE(IUT,*)'Internal error: Sum rule for the geometrical'
	WRITE(IUT,*)'weights is violated.'        
	CALL FULLSTOP(' ')
	END SUBROUTINE INI_MAKETTR_MESG05
      END SUBROUTINE INI_MAKETTR_CUBE





	SUBROUTINE INI_MAKETTR_DIRS
******************************************************
* Constructs k-mesh in high-symmetry directions.     *
******************************************************
C SET ARRAY-SIZE DATA
	USE DIM_LMTART, ONLY : NPNTMEM,NPNWMEM,NPANMEM
C SET EXTERNAL CONNECTIONS
	USE COM_LMTMEM
	USE COM_MASHDEP,ONLY : LENINT,LENREL                    !!! from setup
	USE COM_KAPPAR, ONLY : NPAN                             !!! from readini
	USE COM_INPTTR, ONLY : HSPNT,NDIVDIR,NDIR               !!! from readstr
	USE COM_KMESH,  ONLY : NPNT,PNT                         !!! from hsmsh
	USE COM_WMESH,  ONLY : NPNW,PNW                         !!! from hsmsh
	USE COM_UNIT,   ONLY : IUN,IUR,IUT
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
C MEMORY ALLOCATIONS
	NPNTMEM=(NDIVDIR+1)*NDIR !!! # of points
	NPNWMEM=(NDIVDIR+1)*NDIR !!! # of points
	ALLOCATE(NPNT(NPANMEM))
	ALLOCATE(NPNW(NPANMEM))
	ALLOCATE(PNT(3,NPNTMEM,NPANMEM))
	ALLOCATE(PNW(3,NPNWMEM,NPANMEM))
	SIZE_PNT=DBLE(SIZE(PNT)*LENREL)/1024.D0**2
	CURMEM=CURMEM+2*SIZE_PNT
C START CODE
	IPAN=1
	IPNT=0
	DO IDIR=1,NDIR
	DX=HSPNT(1,2,IDIR)-HSPNT(1,1,IDIR)
	DY=HSPNT(2,2,IDIR)-HSPNT(2,1,IDIR)
	DZ=HSPNT(3,2,IDIR)-HSPNT(3,1,IDIR)
	DO I=1,NDIVDIR+1
	IPNT=IPNT+1
	PNT(1,IPNT,1)=HSPNT(1,1,IDIR)+DX*DBLE(I-1)/DBLE(NDIVDIR)
	PNT(2,IPNT,1)=HSPNT(2,1,IDIR)+DY*DBLE(I-1)/DBLE(NDIVDIR)
	PNT(3,IPNT,1)=HSPNT(3,1,IDIR)+DZ*DBLE(I-1)/DBLE(NDIVDIR)
	PNW(1,IPNT,1)=HSPNT(1,1,IDIR)+DX*DBLE(I-1)/DBLE(NDIVDIR)
	PNW(2,IPNT,1)=HSPNT(2,1,IDIR)+DY*DBLE(I-1)/DBLE(NDIVDIR)
	PNW(3,IPNT,1)=HSPNT(3,1,IDIR)+DZ*DBLE(I-1)/DBLE(NDIVDIR)
	ENDDO
	ENDDO
	NPNT(1)=IPNT
	NPNW(1)=IPNT
	DO IPAN=2,NPAN
	NPNT(IPAN)=0
	NPNW(IPAN)=0
	ENDDO
	END






	SUBROUTINE REDFCEL(X,AD,RD,NDIV,NR)
*********************************************************
*  Finds coordinates of vector X in the first cell      *
*  defined by Ad*Ndiv. Rd - reciprocals to Ad.          *
*********************************************************
	USE COM_UNIT,    ONLY : IUN,IUR,IUT
	IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER NDIV(3),NR(3)
	DIMENSION X(3),AD(3,3),RD(3,3)
	X1=X(1)*RD(1,1)+X(2)*RD(2,1)+X(3)*RD(3,1)
	X2=X(1)*RD(1,2)+X(2)*RD(2,2)+X(3)*RD(3,2)
	X3=X(1)*RD(1,3)+X(2)*RD(2,3)+X(3)*RD(3,3)
	N1=ANINT(X1)
	N2=ANINT(X2)
	N3=ANINT(X3)
	IF(ABS(N1-X1).GE.1.D-05.OR.
     &   ABS(N2-X2).GE.1.D-05.OR.
     &   ABS(N3-X3).GE.1.D-05)THEN 
      WRITE(IUT,*)'<REDFCEL>:: WRONG POINT !'
      CALL FULLSTOP(' ')
      ENDIF
	NR(1)=MOD(N1,NDIV(1))
	NR(2)=MOD(N2,NDIV(2))
	NR(3)=MOD(N3,NDIV(3))
	IF(NR(1).LT.0)NR(1)=NR(1)+NDIV(1)
	IF(NR(2).LT.0)NR(2)=NR(2)+NDIV(2)
	IF(NR(3).LT.0)NR(3)=NR(3)+NDIV(3)
	END





      SUBROUTINE INI_MAKETTR_CCUTUP(B0,B,IBTR,KCUT)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION B(3,3),IBTR(3,3),B0(3,3),KCUT0(3,4,6),KCUT(3,4,6),
     &   SHIFT(3),P(3,4)
      DATA KCUT0/
     &  0,0,0, 0,1,0, 1,1,0, 1,1,1,  0,0,0, 1,0,0, 1,1,0, 1,1,1,
     &  0,0,0, 1,0,0, 1,0,1, 1,1,1,  0,0,0, 0,1,0, 0,1,1, 1,1,1,
     &  0,0,0, 0,0,1, 0,1,1, 1,1,1,  0,0,0, 0,0,1, 1,0,1, 1,1,1 /
      DATA SHIFT/0.D0,0.D0,0.D0/
      ANRM2(X,Y,Z)=X*X*1.00001D0+Y*Y*1.00002D0+Z*Z*1.00003D0
     .  -X*0.000004D0-Y*0.000003D0-Z*0.000002D0
C ------ CALL CSHEAR TO GET MOST COMPACT CELL (doesn't work) --------
      CALL INI_MAKETTR_CSHEAR(B0,B,IBTR)
C ----- CHOSE CUTUP WITH SHORTEST MAX EDGE ---------
      LZ=0
      LXX=0
      LYY=0
      EDGMAX=1.D20
      EDGMIN=0.D0
      DO 2000 LX=0,1
      DO 1000 LY=0,1
      DO ITET=1,6
      DO IC=1,4
      CALL INI_MAKETTR_MXMYMZ(KCUT0(1,IC,ITET),KCUT(1,IC,ITET),LX,LY,LZ)
      ENDDO
      ENDDO
      EDMIN=1.D+20
      EDMAX=0.D+00
      DO ITET=1,6
      DO IC=1,4
      CALL INI_MAKETTR_GTBVEC(KCUT(1,IC,ITET),B,SHIFT,P(1,IC))
      ENDDO
      DO I=1,3
      DO J=I+1,4
      XX=ANRM2(P(1,I)-P(1,J),P(2,I)-P(2,J),P(3,I)-P(3,J))
      EDMAX=DMAX1(EDMAX,XX)
      EDMIN=DMIN1(EDMIN,XX)
	ENDDO
	ENDDO
      ENDDO
      IF(EDMAX.LT.EDGMAX)THEN
      LXX=LX
      LYY=LY
      EDGMAX=EDMAX
      EDGMIN=EDMIN
      ENDIF
 1000 CONTINUE
 2000 CONTINUE
      DO ITET = 1, 6
      DO IC = 1, 4
      CALL INI_MAKETTR_MXMYMZ(KCUT0(1,IC,ITET),KCUT(1,IC,ITET),
     &LXX,LYY,LZ)
	ENDDO
	ENDDO
      END


      SUBROUTINE INI_MAKETTR_GTBVEC(K,B,SHIFT,V)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION K(3),V(3),B(3,3),SHIFT(3)
      V(1)=SHIFT(1)+K(1)*B(1,1)+K(2)*B(1,2)+K(3)*B(1,3)
      V(2)=SHIFT(2)+K(1)*B(2,1)+K(2)*B(2,2)+K(3)*B(2,3)
      V(3)=SHIFT(3)+K(1)*B(3,1)+K(2)*B(3,2)+K(3)*B(3,3)
      RETURN
      END


      SUBROUTINE INI_MAKETTR_MXMYMZ(KIN,K,LX,LY,LZ)
C- Do mirrors in x,y,z if lx,ly,lz=1, respectively
C ----------------------------------------------------------------
Ci Inputs
Ci
Co Outputs
Co
Cr Remarks
Cr
C ----------------------------------------------------------------
      DIMENSION KIN(3),K(3)
      K(1)=KIN(1)
      K(2)=KIN(2)
      K(3)=KIN(3)
      IF(LX.EQ.1)K(1)=1-K(1)
      IF(LY.EQ.1)K(2)=1-K(2)
      IF(LZ.EQ.1)K(3)=1-K(3)
      RETURN
      END

      SUBROUTINE INI_MAKETTR_CSHEAR(B0,B,IBTR)
C- Tries to make microcell more compart by shearing.
C ----------------------------------------------------------------
Ci Inputs
Ci
Co Outputs
Co
Cr Remarks
Cr   Ibtr gives the transformation from bo to b.
C ----------------------------------------------------------------
C      implicit none
C Passed parameters
C Local parameters
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION B(3,3),IBTR(3,3),B0(3,3)
      DO I = 1, 3
      DO J = 1, 3
      B(J,I) = B0(J,I)
      IBTR(J,I) = 0
      ENDDO
      IBTR(I,I) = 1
      ENDDO
      END


      SUBROUTINE INI_MAKETTR_LINKS
********************************************************************
* Establishes links betwee the k-points                            *
********************************************************************
C SET ARRAY SIZE DATA
	USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM
	USE COM_INPTTR,  ONLY : NDIV                                     !!! from readini
      USE COM_KMESH,   ONLY : NPNT,PNT,IPQARR,LINPNT,KCUT              !!! from tetra
	USE COM_KAPPAR,  ONLY : NPAN                                     !!! from readini
	USE COM_UNIT,    ONLY : IUN,IUR,IUT                              !!! from readini
      USE COM_MASHDEP, ONLY : LENINT,LENREL                            !!! from setup
      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER, ALLOCATABLE :: ICHILD(:)
      INTEGER KTT(4)
C  Memory allocations
      ALLOCATE(LINPNT(2,NPNT(1)-1))
      ALLOCATE(ICHILD(NPNT(1)))
      IERROR=0
C  Originally all points are parent
      DO IPNT=1,NPNT(1)
      ICHILD(IPNT)=0
      ENDDO
      ILIN=0
      DO I3=0,NDIV(3)-1               !!! over cells along G3
      DO I2=0,NDIV(2)-1               !!! over cells along G2
      DO I1=0,NDIV(1)-1               !!! over cells along G1
C  THE MICROCELL IS SET UP BY I1,I2,I3
C  SET UP TETRAHEDRON INSIDE MICROCELL
      DO ITTR=1,6                     !!! over tetrahedra
      DO I=1,4
C  COORDINATES OF THE TETRAHEDRON ARE GIVEN BY KTT
      J1=I1+KCUT(1,I,ITTR)
      J2=I2+KCUT(2,I,ITTR)
      J3=I3+KCUT(3,I,ITTR)
      KTT(I)=IPQARR(J1,J2,J3)
      ENDDO
C  FIND ORIGIN
      I0=1
      DO I=1,4
      KSUM=KCUT(1,I,ITTR)+KCUT(2,I,ITTR)+KCUT(3,I,ITTR)
      IF(KSUM.EQ.0)I0=I
      ENDDO      
C  SET UP POSSIBLE LINKS WITHIN THE TETRAHEDRON
      IPNT1=KTT(I0)
      IF(ICHILD(IPNT1).NE.1)ICHILD(IPNT1)=-1
      DO IL=1,4
      IF(IL.EQ.I0)CYCLE
      IPNTL=KTT(IL)
      IF(IPNT1.EQ.IPNTL)CYCLE ! skip same points
      IF(ABS(ICHILD(IPNT1)).EQ.1.AND.ABS(ICHILD(IPNTL)).EQ.1)CYCLE ! skip link
      ILIN=ILIN+1
      IF(ILIN.GT.NPNT(1)-1)IERROR=1
      IF(IERROR.GT.0)GOTO 1000
      ICHILD(IPNTL)=1
      LINPNT(1,ILIN)=IPNT1
      LINPNT(2,ILIN)=IPNTL
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      ENDDO
C Check that each child was born by one parent
      DO IPNT=1,NPNT(1)
      IF(ABS(ICHILD(IPNT)).NE.1)IERROR=2
      IF(IERROR.GT.0)GOTO 1000
      ISUM=0
      DO ILIN=1,NPNT(1)-1
      IF(LINPNT(2,ILIN).EQ.IPNT)ISUM=ISUM+1
      ENDDO
      IF(ISUM.EQ.0)THEN ! it must be original point
      IF(ICHILD(IPNT).NE.-1)IERROR=3 !  Error in parent point
      IF(IERROR.GT.0)GOTO 1000
      ELSEIF(ISUM.EQ.1)THEN ! this is correct!
      CONTINUE
      ELSE
      IF(ICHILD(IPNT).NE.-1)IERROR=4 !  Error in child point
      IF(IERROR.GT.0)GOTO 1000
      ENDIF
      ENDDO
 1000 DEALLOCATE(ICHILD)
      IF(IERROR.GT.0)
     &WRITE(IUN,*)'<INI_MAKETTR_LINKS>:: Error in Algorithm ',IERROR
      IF(IERROR.GT.0)
     &DEALLOCATE(LINPNT)
      END
