	SUBROUTINE INI_TESTINP
****************************************************
*  Test input data for correctness.                *
****************************************************
C SET EXTERNAL CONNECTIONS
	USE COM_CONTROL ,ONLY : LIFT,LMTO,IASA,NPFR,NOVR        !!! from readini
      USE COM_PARAM   ,ONLY : NSORT,NATOM,NHSORT,LRTV         !!! from readini
      USE COM_KAPPAR  ,ONLY : NPAN,NKAP                       !!! from readini
      USE COM_NBANDS  ,ONLY : NBNDF,NBNDE,NBNDT               !!! from readini
      USE COM_SPHERE  ,ONLY : ZNUC,ZCOR                       !!! from readini
      USE COM_LABELS  ,ONLY : TXTEL                           !!! from readini
      USE COM_UNIT    ,ONLY : IUN,IUT,IUR                     !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
C CHECK CONTROLS
	IF(NPFR.GT.0.AND.LMTO.GT.1)THEN
	WRITE(IUT,*)'Terminated in <TESTINP>:'
	WRITE(IUT,*)'Force calculations are not avaiable for'
	WRITE(IUT,*)'the screened LMTO representation (key LMTO>1)'
	CALL FULLSTOP(' ')
	ENDIF
	IF(NPFR.GT.0.AND.IASA.EQ.1)THEN
	WRITE(IUT,*)'Terminated in <TESTINP>:'
	WRITE(IUT,*)'Force calculations are not avaiable for'
	WRITE(IUT,*)'the ASA calculations (key IASA=1)'
	CALL FULLSTOP(' ')
	ENDIF
	IF(NOVR.NE.0.AND.NOVR.NE.1)THEN
	WRITE(IUT,*)'Terminated in <TESTINP>:'
	WRITE(IUT,*)'Overlap matrix control key NOVR should be 0 or 1'
	CALL FULLSTOP(' ')
	ENDIF
	IF(LIFT.LT.3.AND.NPFR.GT.0)THEN
	WRITE(IUT,*)'Terminated in <TESTINP>:'
	WRITE(IUT,*)'Force calculations cannot be performed in the'
	WRITE(IUT,*)'mode when self-consistency is turned off.'
	CALL FULLSTOP(' ')
	ENDIF
C CHECK RELATIVISTIC
	ZVALTOT=0.D0
	DO ISORT=1,NSORT
	IF(ZNUC(ISORT).GT.21.AND.LRTV(ISORT).EQ.0)THEN
	WRITE(IUT,*)'Warning from <TESTINP>:'
	WRITE(IUT,*)
     &  'No scalar relativism is switched on ',TXTEL(ISORT),
     &  '; Recommended when Z > 21' 
	ENDIF
	IF(ABS(ZNUC(ISORT)).LT.1.D-12)ZNUC(ISORT)=1.D-12
	IF(ABS(ZCOR(ISORT)).LT.1.D-12)ZCOR(ISORT)=1.D-12
	ZVALTOT=ZVALTOT+(ZNUC(ISORT)-ZCOR(ISORT))*NHSORT(ISORT)
	ENDDO
C CHECK BANDS
	DO IPAN=1,NPAN
	IF(NBNDF(IPAN).GT.NBNDT(IPAN))THEN
	WRITE(IUT,*)'Terminated in <TESTINP>:'
      WRITE(IUT,*)'Input # of filled bands is larger than'
	WRITE(IUT,*)'the total # of bands.'
	CALL FULLSTOP(' ')
	ENDIF 
	IF(IPAN.GT.1)ZVALTOT=ZVALTOT-2.D0*NBNDT(IPAN)
	ENDDO
	IF(2.D0*DBLE(NBNDF(1)).LT.ZVALTOT)THEN
      WRITE(IUT,*)'Warning from <TESTINP>:'
	WRITE(IUT,*)'Input # of filled bands is too small.'
	WRITE(IUT,*)'Standard correction will be made.'
	NBNDF(1)=ZVALTOT/2.D0+2
	ENDIF
	END
