	SUBROUTINE LIB_DERIV1(FUN,DFUNDR,NRAD,H,R,DR,S)
****************************************************************
*   Calculates radial derivative, Real*8 version.              *
****************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	DIMENSION DFUNDR(0:NRAD),R(0:NRAD),DR(0:NRAD)
     &    ,FUN(0:NRAD)
	DATA PI/3.141592653589793D0/
	IF(NRAD.LT.7)
     &  CALL FULLSTOP('<LIB_DERIV1> # of rad.points is too small')
C DEFINE MESH PARAMETERS
	BETTA=S/(EXP(H*DBLE(NRAD))-1.D0)
	STEPRAD=1.D0
C GET FIRST-ORDER DERIVATIVE
	DO IRAD=1,NRAD                       !!! over rad.points
	DIRADDR=1.D0/(H*(R(IRAD)+BETTA))
	IF(IRAD.EQ.1)THEN
	DFUNDR(IRAD)=((6.D0*FUN(IRAD+1)+
     &  20.D0/3.D0*FUN(IRAD+3)+1.2D0*FUN(IRAD+5))-
     &  (2.45D0*FUN(IRAD+0)+7.5D0*FUN(IRAD+2)+
     &  3.75D0*FUN(IRAD+4)+1.D0/6.D0*FUN(IRAD+6)))/
     &  STEPRAD*DIRADDR
	ELSEIF(IRAD.GT.1.AND.IRAD.LT.NRAD-1)THEN
	DFUNDR(IRAD)=(FUN(IRAD-2)-FUN(IRAD+2)+
     &  8.D0*FUN(IRAD+1)-8.D0*FUN(IRAD-1))/12.D0/
     &  STEPRAD*DIRADDR
	ELSEIF(IRAD.EQ.NRAD-1)THEN
	DFUNDR(IRAD)=(-1.D0/12.D0*FUN(IRAD-3)+
     &  0.5D0*FUN(IRAD-2)-1.5D0*FUN(IRAD-1)+
     &  5.D0/6.D0*FUN(IRAD)+0.25D0*FUN(IRAD+1))/
     &  STEPRAD*DIRADDR
	ELSEIF(IRAD.EQ.NRAD)THEN
	DFUNDR(IRAD)=(0.25D0*FUN(IRAD-4)-
     &  4.D0/3.D0*FUN(IRAD-3)+3.D0*FUN(IRAD-2)-
     &  4.D0*FUN(IRAD-1)+25.D0/12.D0*FUN(IRAD))/
     &  STEPRAD*DIRADDR
	ENDIF
	ENDDO                               !!! over rad.points
	DFUNDR(0)=DFUNDR(1)
	END


	SUBROUTINE LIB_CDERIV1(FUN,DFUNDR,NRAD,H,R,DR,S)
****************************************************************
*   Calculates radial derivative, Complex*16 version           *
****************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16 DFUNDR(0:NRAD),FUN(0:NRAD)
	DIMENSION R(0:NRAD),DR(0:NRAD)
	DATA PI/3.141592653589793D0/
	IF(NRAD.LT.7)
     &  CALL FULLSTOP('<LIB_CDERIV1> # of rad.points is too small')
C DEFINE MESH PARAMETERS
	BETTA=S/(EXP(H*DBLE(NRAD))-1.D0)
	STEPRAD=1.D0
C GET FIRST-ORDER DERIVATIVE
	DO IRAD=1,NRAD                       !!! over rad.points
	DIRADDR=1.D0/(H*(R(IRAD)+BETTA))
	IF(IRAD.EQ.1)THEN
	DFUNDR(IRAD)=((6.D0*FUN(IRAD+1)+
     &  20.D0/3.D0*FUN(IRAD+3)+1.2D0*FUN(IRAD+5))-
     &  (2.45D0*FUN(IRAD+0)+7.5D0*FUN(IRAD+2)+
     &  3.75D0*FUN(IRAD+4)+1.D0/6.D0*FUN(IRAD+6)))/
     &  STEPRAD*DIRADDR
	ELSEIF(IRAD.GT.1.AND.IRAD.LT.NRAD-1)THEN
	DFUNDR(IRAD)=(FUN(IRAD-2)-FUN(IRAD+2)+
     &  8.D0*FUN(IRAD+1)-8.D0*FUN(IRAD-1))/12.D0/
     &  STEPRAD*DIRADDR
	ELSEIF(IRAD.EQ.NRAD-1)THEN
	DFUNDR(IRAD)=(-1.D0/12.D0*FUN(IRAD-3)+
     &  0.5D0*FUN(IRAD-2)-1.5D0*FUN(IRAD-1)+
     &  5.D0/6.D0*FUN(IRAD)+0.25D0*FUN(IRAD+1))/
     &  STEPRAD*DIRADDR
	ELSEIF(IRAD.EQ.NRAD)THEN
	DFUNDR(IRAD)=(0.25D0*FUN(IRAD-4)-
     &  4.D0/3.D0*FUN(IRAD-3)+3.D0*FUN(IRAD-2)-
     &  4.D0*FUN(IRAD-1)+25.D0/12.D0*FUN(IRAD))/
     &  STEPRAD*DIRADDR
	ENDIF
	ENDDO                               !!! over rad.points
	DFUNDR(0)=DFUNDR(1)
	END
