	SUBROUTINE LIB_DRSUB(FUN,DFUNDR,NRAD,H,R,DR)
****************************************************************
*   Calculates radial derivative.                              *
****************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
	IMPLICIT REAL*8 (A-H,O-Z)
	DIMENSION R(0:NRAD),DR(0:NRAD)
	COMPLEX*16 FUN(0:NRAD),DFUNDR(0:NRAD)
	DATA PI/3.141592653589793D0/
C PARABOLIC INTERPOLATION FORMULA
	F3FUN(X,F1,F2,F3,X1,X2,X3)=
     &  (X-X2)*(X-X3)/(X1-X2)/(X1-X3)*F1+
     &  (X-X1)*(X-X3)/(X2-X1)/(X2-X3)*F2+
     &  (X-X1)*(X-X2)/(X3-X1)/(X3-X2)*F3
C CORRESPONDING FIRST-ORDER DERIVATIVE
	F3DER(X,F1,F2,F3,X1,X2,X3)=
     &  ((X-X2)+(X-X3))/(X1-X2)/(X1-X3)*F1+
     &  ((X-X1)+(X-X3))/(X2-X1)/(X2-X3)*F2+
     &  ((X-X1)+(X-X2))/(X3-X1)/(X3-X2)*F3
	IF(NRAD.LT.7)CALL FULLSTOP('<DRSUB> # of rad.points is too small')
C DEFINE MESH PARAMETERS
      BETTA=R(NRAD)/(EXP(H*DBLE(NRAD))-1.D0)
	STEPRAD=1.D0
C GET FIRST-ORDER DERIVATIVE
	DO IRAD=0,NRAD                       !!! over rad.points
	DIRADDR=1.D0/(H*(R(IRAD)+BETTA))
	IF(IRAD.EQ.0)THEN
	DFUNDR(IRAD)=((6.D0*FUN(IRAD+1)+
     &  20.D0/3.D0*FUN(IRAD+3)+
     &  1.2D0*FUN(IRAD+5))-
     &  (2.45D0*FUN(IRAD+0)+7.5D0*
     &  FUN(IRAD+2)+3.75D0*FUN(IRAD+4)+
     &  1.D0/6.D0*FUN(IRAD+6)))/STEPRAD*DIRADDR
	ELSEIF(IRAD.EQ.1)THEN
	DFUNDR(IRAD)=((6.D0*FUN(IRAD+1)+
     &  20.D0/3.D0*FUN(IRAD+3)+
     &  1.2D0*FUN(IRAD+5))-
     &  (2.45D0*FUN(IRAD+0)+7.5D0*
     &  FUN(IRAD+2)+3.75D0*FUN(IRAD+4)+
     &  1.D0/6.D0*FUN(IRAD+6)))/STEPRAD*DIRADDR
	ELSEIF(IRAD.GT.1.AND.IRAD.LT.NRAD-1)THEN
	DFUNDR(IRAD)=(FUN(IRAD-2)-
     &  FUN(IRAD+2)+8.D0*FUN(IRAD+1)-
     &  8.D0*FUN(IRAD-1))/12.D0/
     &  STEPRAD*DIRADDR
	ELSEIF(IRAD.EQ.NRAD-1)THEN
	DFUNDR(IRAD)=(-1.D0/12.D0*
     &  FUN(IRAD-3)+0.5D0*FUN(IRAD-2
     &  )-1.5D0*FUN(IRAD-1)+
     &  5.D0/6.D0*FUN(IRAD)+0.25D0*
     &  FUN(IRAD+1))/STEPRAD*DIRADDR
	ELSEIF(IRAD.EQ.NRAD)THEN
	DFUNDR(IRAD)=(0.25D0*
     &  FUN(IRAD-4)-4.D0/3.D0*FUN(IRAD-3
     &  )+3.D0*FUN(IRAD-2)-
     &  4.D0*FUN(IRAD-1)+25.D0/12.D0*
     &  FUN(IRAD))/STEPRAD*DIRADDR
	ENDIF
      ENDDO                                 !!! over rad.points
	END
