      SUBROUTINE LIB_FORCESYM(CMAT,IS,NDIM)
************************************************************
*  Forces symmetry of the diagonal elements of the matrix  *
*  according to the symmetry array                         *
************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 CMAT(NDIM,NDIM),CAVR
      INTEGER IS(NDIM)
	DO ICUR=1,NDIM
	NCUR=0
	CAVR=(0.D0,0.D0)
	DO IDIM=1,NDIM
	IF(IS(IDIM).NE.ICUR)CYCLE
	CAVR=CAVR+CMAT(IDIM,IDIM)
	NCUR=NCUR+1
	ENDDO
	DO IDIM=1,NDIM
	IF(IS(IDIM).NE.ICUR)CYCLE
	CMAT(IDIM,IDIM)=CAVR/DBLE(NCUR)
	ENDDO
	ENDDO
      END
      
      
      SUBROUTINE LIB_FORCESYM3L(CMAT,IS,NDIM,N1ST,NRUN)
************************************************************
*  Forces symmetry of the diagonal elements of the matrix  *
*  according to the symmetry array                         *
************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 CMAT(N1ST,NDIM,NDIM),CAVR
      INTEGER IS(NDIM,NRUN)
      DO IRUN=1,NRUN
      DO I1ST=1,N1ST
	DO ICUR=1,NDIM
	NCUR=0
	CAVR=(0.D0,0.D0)
	DO IDIM=1,NDIM
	IF(IS(IDIM,IRUN).NE.ICUR)CYCLE
	CAVR=CAVR+CMAT(I1ST,IDIM,IDIM)
	NCUR=NCUR+1
	ENDDO
	DO IDIM=1,NDIM
	IF(IS(IDIM,IRUN).NE.ICUR)CYCLE
	CMAT(I1ST,IDIM,IDIM)=CAVR/DBLE(NCUR)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
      END
      
      
      SUBROUTINE LIB_FORCESYM3R(CMAT,IS,NDIM,N3RD,NRUN)
************************************************************
*  Forces symmetry of the diagonal elements of the matrix  *
*  according to the symmetry array                         *
************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 CMAT(NDIM,NDIM,N3RD),CAVR
      INTEGER IS(NDIM,NRUN)
      DO IRUN=1,NRUN
      DO I3RD=1,N3RD
	DO ICUR=1,NDIM
	NCUR=0
	CAVR=(0.D0,0.D0)
	DO IDIM=1,NDIM
	IF(IS(IDIM,IRUN).NE.ICUR)CYCLE
	CAVR=CAVR+CMAT(IDIM,IDIM,I3RD)
	NCUR=NCUR+1
	ENDDO
	DO IDIM=1,NDIM
	IF(IS(IDIM,IRUN).NE.ICUR)CYCLE
	CMAT(IDIM,IDIM,I3RD)=CAVR/DBLE(NCUR)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
      END
      
      
      SUBROUTINE LIB_FORCESYMR1(CMAT,IS,NDIM)
************************************************************
*  Forces symmetry of the one dimensional real matrix  *
*  according to the symmetry array                         *
************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 CMAT(NDIM),CAVR
      INTEGER IS(NDIM)
	DO ICUR=1,NDIM
	NCUR=0
	CAVR=0.D0
	DO IDIM=1,NDIM
	IF(IS(IDIM).NE.ICUR)CYCLE
	CAVR=CAVR+CMAT(IDIM)
	NCUR=NCUR+1
	ENDDO
	DO IDIM=1,NDIM
	IF(IS(IDIM).NE.ICUR)CYCLE
	CMAT(IDIM)=CAVR/DBLE(NCUR)
	ENDDO
	ENDDO
      END
      
      
      SUBROUTINE LIB_FORCESYMR2(CMAT,IS,NDIM)
************************************************************
*  Forces symmetry of the whole real matrix  *
*  according to the symmetry array                         *
************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 CMAT(NDIM,NDIM),CAVR
      INTEGER IS(NDIM)
	DO ICUR=1,NDIM
	NCUR=0
	CAVR=0.D0
	NCUR2=0
	CAVR2=0.D0
	DO IDIM=1,NDIM
	IF(IS(IDIM).NE.ICUR)CYCLE
	DO IDIM2=1,NDIM
	IF(IS(IDIM2).NE.ICUR)CYCLE
	IF(IDIM.NE.IDIM2) THEN
	CAVR=CAVR+CMAT(IDIM,IDIM2)
	NCUR=NCUR+1
	ELSE
	CAVR2=CAVR2+CMAT(IDIM,IDIM2)
	NCUR2=NCUR2+1
	ENDIF
	ENDDO
	ENDDO
	DO IDIM=1,NDIM
	IF(IS(IDIM).NE.ICUR)CYCLE
	DO IDIM2=1,NDIM
	IF(IS(IDIM2).NE.ICUR)CYCLE
	IF(IDIM.NE.IDIM2) THEN
	CMAT(IDIM,IDIM2)=CAVR/DBLE(NCUR)
	ELSE
	CMAT(IDIM,IDIM2)=CAVR2/DBLE(NCUR2)
	ENDIF
	ENDDO
	ENDDO
	ENDDO
      END



      SUBROUTINE LIB_FORCEHERM(HMAT,NDIM)
************************************************************
*  Forces hermitianness 
************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 HMAT(NDIM,NDIM),HERM
	DO IDIM1=1,NDIM
	DO IDIM=1,IDIM1
	HERM=0.5D0*(HMAT(IDIM1,IDIM)+DCONJG(HMAT(IDIM,IDIM1)))
	HMAT(IDIM1,IDIM)=HERM
	HMAT(IDIM,IDIM1)=DCONJG(HERM)
	ENDDO
	ENDDO
      END
      