	SUBROUTINE LIB_PMATSUP(PMATS)
******************************************************
*  Returns Pauli matrices in spherical cooridnates   *
*  using the following indexation: <s'|Sigma^mu|s>   *
******************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16 PMATS(2,2,-1:1)
	PMATS(1,1,-1)=DCMPLX(0.D0,0.D0)
	PMATS(1,2,-1)=DCMPLX(+SQRT(2.D0),0.D0)
	PMATS(2,1,-1)=DCMPLX(0.D0,0.D0)
	PMATS(2,2,-1)=DCMPLX(0.D0,0.D0)
C	
	PMATS(1,1, 0)=DCMPLX(+1.D0,0.D0)
	PMATS(1,2, 0)=DCMPLX(0.D0,0.D0)
	PMATS(2,1, 0)=DCMPLX(0.D0,0.D0)
	PMATS(2,2, 0)=DCMPLX(-1.D0,0.D0)
C	
	PMATS(1,1,+1)=DCMPLX(0.D0,0.D0)
	PMATS(1,2,+1)=DCMPLX(0.D0,0.D0)
	PMATS(2,1,+1)=DCMPLX(-SQRT(2.D0),0.D0)
	PMATS(2,2,+1)=DCMPLX(0.D0,0.D0)
	END

	SUBROUTINE LIB_PMATSDN(PMATS)
******************************************************
*  Returns Pauli matrices in spherical cooridnates   *
*  using the following indexation: <s'|Sigma_mu|s>   *
******************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16 PMATS(2,2,-1:1)
	PMATS(1,1,-1)=DCMPLX(0.D0,0.D0)
	PMATS(1,2,-1)=DCMPLX(0.D0,0.D0)
	PMATS(2,1,-1)=DCMPLX(+SQRT(2.D0),0.D0)
	PMATS(2,2,-1)=DCMPLX(0.D0,0.D0)
C	
	PMATS(1,1, 0)=DCMPLX(+1.D0,0.D0)
	PMATS(1,2, 0)=DCMPLX(0.D0,0.D0)
	PMATS(2,1, 0)=DCMPLX(0.D0,0.D0)
	PMATS(2,2, 0)=DCMPLX(-1.D0,0.D0)
C	
	PMATS(1,1,+1)=DCMPLX(0.D0,0.D0)
	PMATS(1,2,+1)=DCMPLX(-SQRT(2.D0),0.D0)
	PMATS(2,1,+1)=DCMPLX(0.D0,0.D0)
	PMATS(2,2,+1)=DCMPLX(0.D0,0.D0)
	END



	SUBROUTINE LIB_SPHCROSSDNDNUP(SPHC)
**********************************************************************
*  Returns cross product of spherical orths in spherical coordinates *
*  using the following (upper/lower) indexation: [e_mu * e_nu]^a     *
**********************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16 SPHC(-1:1,-1:1,-1:1)
	SPHC(-1,-1,-1)=DCMPLX(0.D0,0.D0)
	SPHC(-1,-1, 0)=DCMPLX(0.D0,0.D0)
	SPHC(-1,-1,+1)=DCMPLX(0.D0,0.D0)
C
	SPHC(-1, 0,-1)=DCMPLX(0.D0,0.D0)
	SPHC(-1, 0, 0)=DCMPLX(0.D0,0.D0)
	SPHC(-1, 0,+1)=DCMPLX(0.D0,-1.D0)
C
	SPHC(-1,+1,-1)=DCMPLX(0.D0,0.D0)
	SPHC(-1,+1, 0)=DCMPLX(0.D0,+1.D0)
	SPHC(-1,+1,+1)=DCMPLX(0.D0,0.D0)
C
	SPHC( 0,-1,-1)=DCMPLX(0.D0,0.D0)
	SPHC( 0,-1, 0)=DCMPLX(0.D0,0.D0)
	SPHC( 0,-1,+1)=DCMPLX(0.D0,+1.D0)
C
	SPHC( 0, 0,-1)=DCMPLX(0.D0,0.D0)
	SPHC( 0, 0, 0)=DCMPLX(0.D0,0.D0)
	SPHC( 0, 0,+1)=DCMPLX(0.D0,0.D0)
C
	SPHC( 0,+1,-1)=DCMPLX(0.D0,-1.D0)
	SPHC( 0,+1, 0)=DCMPLX(0.D0,0.D0)
	SPHC( 0,+1,+1)=DCMPLX(0.D0,0.D0)
C
	SPHC(+1,-1,-1)=DCMPLX(0.D0,0.D0)
	SPHC(+1,-1, 0)=DCMPLX(0.D0,-1.D0)
	SPHC(+1,-1,+1)=DCMPLX(0.D0,0.D0)
C
	SPHC(+1, 0,-1)=DCMPLX(0.D0,+1.D0)
	SPHC(+1, 0, 0)=DCMPLX(0.D0,0.D0)
	SPHC(+1, 0,+1)=DCMPLX(0.D0,0.D0)
C
	SPHC(+1,+1,-1)=DCMPLX(0.D0,0.D0)
	SPHC(+1,+1, 0)=DCMPLX(0.D0,0.D0)
	SPHC(+1,+1,+1)=DCMPLX(0.D0,0.D0)
	END

	SUBROUTINE LIB_SPHCROSSDNDNDN(SPHC)
**********************************************************************
*  Returns cross product of spherical orths in spherical coordinates *
*  using the following (upper/lower) indexation: [e_mu * e_nu]_a     *
**********************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16 SPHC(-1:1,-1:1,-1:1)
	SPHC(-1,-1,-1)=DCMPLX(0.D0,0.D0)
	SPHC(-1,-1, 0)=DCMPLX(0.D0,0.D0)
	SPHC(-1,-1,+1)=DCMPLX(0.D0,0.D0)
C
	SPHC(-1, 0,-1)=DCMPLX(0.D0,+1.D0)
	SPHC(-1, 0, 0)=DCMPLX(0.D0,0.D0)
	SPHC(-1, 0,+1)=DCMPLX(0.D0,0.D0)
C
	SPHC(-1,+1,-1)=DCMPLX(0.D0,0.D0)
	SPHC(-1,+1, 0)=DCMPLX(0.D0,+1.D0)
	SPHC(-1,+1,+1)=DCMPLX(0.D0,0.D0)
C
	SPHC( 0,-1,-1)=DCMPLX(0.D0,-1.D0)
	SPHC( 0,-1, 0)=DCMPLX(0.D0,0.D0)
	SPHC( 0,-1,+1)=DCMPLX(0.D0,0.D0)
C
	SPHC( 0, 0,-1)=DCMPLX(0.D0,0.D0)
	SPHC( 0, 0, 0)=DCMPLX(0.D0,0.D0)
	SPHC( 0, 0,+1)=DCMPLX(0.D0,0.D0)
C
	SPHC( 0,+1,-1)=DCMPLX(0.D0,0.D0)
	SPHC( 0,+1, 0)=DCMPLX(0.D0,0.D0)
	SPHC( 0,+1,+1)=DCMPLX(0.D0,+1.D0)
C
	SPHC(+1,-1,-1)=DCMPLX(0.D0,0.D0)
	SPHC(+1,-1, 0)=DCMPLX(0.D0,-1.D0)
	SPHC(+1,-1,+1)=DCMPLX(0.D0,0.D0)
C
	SPHC(+1, 0,-1)=DCMPLX(0.D0,0.D0)
	SPHC(+1, 0, 0)=DCMPLX(0.D0,0.D0)
	SPHC(+1, 0,+1)=DCMPLX(0.D0,-1.D0)
C
	SPHC(+1,+1,-1)=DCMPLX(0.D0,0.D0)
	SPHC(+1,+1, 0)=DCMPLX(0.D0,0.D0)
	SPHC(+1,+1,+1)=DCMPLX(0.D0,0.D0)
	END


	SUBROUTINE LIB_SPHUP2CAR(TR)
***************************************************************
*  Transforms spherical coordinates to cartesian coordinates  *
*      R(a) = Sum_mu T(a,mu) * R^mu                           *
***************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16 TR(3,-1:1)
	TR(1,-1)=DCMPLX(+1.D0,+0.D0)/SQRT(2.D0)
	TR(1, 0)=DCMPLX(+0.D0,+0.D0)
	TR(1,+1)=DCMPLX(-1.D0,+0.D0)/SQRT(2.D0)
	TR(2,-1)=DCMPLX(+0.D0,-1.D0)/SQRT(2.D0)
	TR(2, 0)=DCMPLX(+0.D0,+0.D0)
	TR(2,+1)=DCMPLX(+0.D0,-1.D0)/SQRT(2.D0)
	TR(3,-1)=DCMPLX(+0.D0,+0.D0)
	TR(3, 0)=DCMPLX(+1.D0,+0.D0)
	TR(3,+1)=DCMPLX(+0.D0,+0.D0)
	END

	SUBROUTINE LIB_SPHDN2CAR(TR)
***************************************************************
*  Transforms spherical coordinates to cartesian coordinates  *
*      R(a) = Sum_mu T(mu,a) * R_mu                           *
***************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16 TR(3,-1:1)
	TR(1,-1)=DCMPLX(+1.D0,+0.D0)/SQRT(2.D0)
	TR(1, 0)=DCMPLX(+0.D0,+0.D0)
	TR(1,+1)=DCMPLX(-1.D0,+0.D0)/SQRT(2.D0)
	TR(2,-1)=DCMPLX(+0.D0,+1.D0)/SQRT(2.D0)
	TR(2, 0)=DCMPLX(+0.D0,+0.D0)
	TR(2,+1)=DCMPLX(+0.D0,+1.D0)/SQRT(2.D0)
	TR(3,-1)=DCMPLX(+0.D0,+0.D0)
	TR(3, 0)=DCMPLX(+1.D0,+0.D0)
	TR(3,+1)=DCMPLX(+0.D0,+0.D0)
	END

	SUBROUTINE LIB_CAR2SPHUP(TR)
***************************************************************
*  Transforms cartesian coordinates to spherical coordinates  *
*      R^mu = Sum_a T(mu,a) * R^a                             *
***************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16 TR(-1:1,3)
	TR(-1,1)=DCMPLX(+1.D0,+0.D0)/SQRT(2.D0)
	TR(-1,2)=DCMPLX(+0.D0,+1.D0)/SQRT(2.D0)
	TR(-1,3)=DCMPLX(+0.D0,+0.D0)
	TR( 0,1)=DCMPLX(+0.D0,+0.D0)
	TR( 0,2)=DCMPLX(+0.D0,+0.D0)
	TR( 0,3)=DCMPLX(+1.D0,+0.D0)
	TR(+1,1)=DCMPLX(-1.D0,+0.D0)/SQRT(2.D0)
	TR(+1,2)=DCMPLX(+0.D0,+1.D0)/SQRT(2.D0)
	TR(+1,3)=DCMPLX(+0.D0,+0.D0)
	END

	SUBROUTINE LIB_CAR2SPHDN(TR)
***************************************************************
*  Transforms cartesian coordinates to spherical coordinates  *
*      R_mu = Sum_a T(mu,a) * R^a                             *
***************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16 TR(-1:1,3)
	TR(-1,1)=DCMPLX(+1.D0,+0.D0)/SQRT(2.D0)
	TR(-1,2)=DCMPLX(+0.D0,-1.D0)/SQRT(2.D0)
	TR(-1,3)=DCMPLX(+0.D0,+0.D0)
	TR( 0,1)=DCMPLX(+0.D0,+0.D0)
	TR( 0,2)=DCMPLX(+0.D0,+0.D0)
	TR( 0,3)=DCMPLX(+1.D0,+0.D0)
	TR(+1,1)=DCMPLX(-1.D0,+0.D0)/SQRT(2.D0)
	TR(+1,2)=DCMPLX(+0.D0,-1.D0)/SQRT(2.D0)
	TR(+1,3)=DCMPLX(+0.D0,+0.D0)
	END