      SUBROUTINE LIB_PRATTPOLS(N,X,POLS)
C **************************************************
C Returns Pratt Polynomials
C **************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 POLS(-1:N+1,0:N)
C Zeroise
      DO IPOL=-1,N+1
      DO ITER=0,N
      POLS(IPOL,ITER)=0.D0
      ENDDO
      ENDDO
C Iteration 0
      POLS(-1,0)=1.D0
      POLS( 0,0)=1.D0      
      POLS(+1,0)=0.D0
C Iteration 1
      POLS(-1,1)=1.D0
      POLS( 0,1)=1.D0      
      POLS(+1,1)=X
      POLS(+2,1)=0.D0
C Iteration 2
      POLS(-1,2)=1.D0
      POLS( 0,2)=1.D0      
      POLS(+1,2)=2.D0*X-X*X
      POLS(+2,2)=X*X
      POLS(+3,2)=0.D0
C Boundaries
      DO ITER=0,N
      POLS(-1,ITER)=1.D0
      POLS( 0,ITER)=1.D0
      POLS(ITER+1,ITER)=0.D0
      ENDDO
C Iteration N
      DO ITER=3,N
      DO IPOL=0,ITER
      POLS(IPOL,ITER)=X*POLS(IPOL-1,ITER-1)+(1.D0-X)*POLS(IPOL,ITER-1)
      ENDDO
      ENDDO
      END


      SUBROUTINE LIB_PRATTPOLS_TEST
C     PROGRAM LIB_PRATTPOLS_TEST
C ***************************************************
C Tests above program
C ***************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8, ALLOCATABLE :: POLS(:,:)
C To work set some X<1
    1 READ(5,*)N,X,AMIX
      ALLOCATE(POLS(-1:N+1,0:N))
C Compute polynomials
      CALL LIB_PRATTPOLS(N,AMIX,POLS)
C Compute function directly (works for any x)
      FUNDIR=1.D0/(1.D0-X)
C Compute function by Teilor expansion (works for |x|<1)
      FUNTEI=0.D0 
      XI=1.D0
      DO I=0,N
      FUNTEI=FUNTEI+XI
      XI=XI*X
      ENDDO
C Compute function by mixing (works for any x<1 provided N is large and Amix is small)
      FINP=1.D0 
      FOUT=1.D0+X
      DO ITER=1,N
      FNEWINP=AMIX*FOUT+(1.D0-AMIX)*FINP
      FNEWOUT=1.D0+X*FNEWINP
      FOUT=FNEWOUT
      FINP=FNEWINP
      ENDDO
      FUNMIX=FINP
C Compute function by polynomials (by definition should give the same as FUNMIX)
      FUNPOL=0.D0 
      XI=1.D0
      DO I=0,N
      FUNPOL=FUNPOL+XI*POLS(I,N)
      XI=XI*X
      ENDDO
      PRINT*,FUNDIR,FUNTEI,FUNMIX,FUNPOL
      DEALLOCATE(POLS)
      GOTO 1
      END
