	SUBROUTINE LIB_RADSCH_PARS(ENY,AFIS,AFIPS,DNY,TNY,DNYP,
     &                       FPMN,S,Z,LM,NRAD,H,R,DR,LR)
************************************************************
*   The calculation of potential parameters for <<LMTO>>   *
************************************************************
C SET ARRAY-SIZE DATA
        USE DIM_LMTART
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8, ALLOCATABLE :: FI(:,:)
	REAL*8, ALLOCATABLE :: FID(:,:)
	COMPLEX*16, ALLOCATABLE :: DELFI(:,:)
	COMPLEX*16, ALLOCATABLE :: DELFID(:,:)
	COMPLEX*16, ALLOCATABLE :: DVL(:)
	DIMENSION Z(0:NRADMEM),R(0:NRADMEM),DR(0:NRADMEM)
     &    ,ENY(0:LM),DNY(0:LM),TNY(0:LM),DNYP(0:LM),FPMN(0:LM)
     &    ,AFIS(0:LM),AFIPS(0:LM)
	REAL*8 LIB_RADSCH_FSIM
	COMPLEX*16 DELNY
	DATA DEL/0.025D0/,PI/3.141592653589793D0/
C MEMORY ALLOCATIONS
	ALLOCATE(FI(0:NRADMEM,5))
	ALLOCATE(FID(0:NRADMEM,5))
	ALLOCATE(DELFI(0:NRADMEM,5))
	ALLOCATE(DELFID(0:NRADMEM,5))
	ALLOCATE(DVL(0:NRADMEM))
C START CODE
	DELNY=(0.D0,0.D0)
	SQPI4=SQRT(4.D0*PI)
	DO IRAD=0,NRAD
	DVL(IRAD)=DCMPLX(-SQPI4,0.D0)
	ENDDO
	DO L=0,LM
C SOLVE RADIAL SCHROEDINGER EQUATION
	CALL LIB_RADSCH(ENY(L),S,Z,L,-1,NODES,D,FI(0,3),FID(0,3),
     &  NRAD,H,R,DR,LR)
C SOLVE SCHROEDINGER EQUATION FOR ENERGY DERIVATIVE
	CALL LIB_RADSCH_DELV(ENY(L),DELNY,S,Z,L,-1,DVL,NOD,DELFI(0,3),
     &  DELFID(0,3),FI(0,3),FID(0,3),NRAD,H,R,DR,LR)
C SET POTENTIAL PARAMETERS AT THE SPHERE BOUNDARY
	AFIS(L)=FI(NRAD,3) 
	AFIDS=FID(NRAD,3)
	AFIPS(L)=DREAL(DELFI(NRAD,3))
C     AFIDPS=DREAL(DELFID(NRAD,3))
	DNY(L)=S*AFIDS/AFIS(L)
	TNY(L)=NODES+0.5D0-ATAN(DNY(L))/PI
C     DNYP(L)=S*AFIDPS/AFIPS(L)
	DNYP(L)=DNY(L)-1.D0/(S*AFIS(L)*AFIPS(L))
	DO IRAD=0,NRAD
	FI(IRAD,3)=DREAL(DELFI(IRAD,3))*R(IRAD)
	ENDDO
	FPMN(L)=LIB_RADSCH_FSIM(FI(0,3),FI(0,3),NRAD,H,DR)
	ENDDO
C MEMORY DEALLOCATIONS
	DEALLOCATE(FI)
	DEALLOCATE(FID)
	DEALLOCATE(DELFI)
	DEALLOCATE(DELFID)
	DEALLOCATE(DVL)
	END SUBROUTINE LIB_RADSCH_PARS



	SUBROUTINE LIB_RADSCH_TNYS(E,T,TE,L1,S,Z,NRAD,H,R,DR,LR)
*********************************************************
*   The calculation of T(D(E))-function for given L,E   *
*********************************************************
C SET ARRAY-SIZE DATA
        USE DIM_LMTART
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8, ALLOCATABLE :: FI(:)
	REAL*8, ALLOCATABLE :: FID(:)
	DIMENSION Z(0:NRADMEM),R(0:NRADMEM),DR(0:NRADMEM)
	DATA DEL/0.025D0/,PI/3.141592653589793D0/
C MEMORY ALLOCATIONS
	ALLOCATE(FI(0:NRADMEM))
	ALLOCATE(FID(0:NRADMEM))
C START CODE
	EN=E
	L=L1-1
	CALL LIB_RADSCH(EN,S,Z,L,-1,NODES,D,FI(0),FID(0),NRAD,H,R,DR,LR)
	T=NODES+0.5D0-ATAN(D)/PI
	DE=-1.D0/(S*FI(NRAD)*FI(NRAD))
	TE=-1.D0/(1+D*D)/PI*DE
C MEMORY DEALLOCATIONS
	DEALLOCATE(FI)
	DEALLOCATE(FID)
	END SUBROUTINE LIB_RADSCH_TNYS


	SUBROUTINE LIB_RADSCH_PHIS(ENY,AFI,AFIP,AFID,AFIDP,
     &             AFIDDS,AFIDDPS,S,Z,LM,NRAD,H,R,DR,LR)
*********************************************************
*   The calculation of the radial wave functions        *
*   and their energy derivatives up to first order.     *
*********************************************************
C SET ARRAY-SIZE DATA
        USE DIM_LMTART
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8, ALLOCATABLE :: FI(:,:)
	REAL*8, ALLOCATABLE :: FID(:,:)
	COMPLEX*16, ALLOCATABLE :: DELFI(:,:)
	COMPLEX*16, ALLOCATABLE :: DELFID(:,:)
	COMPLEX*16, ALLOCATABLE :: DVL(:)
	DIMENSION Z(0:NRADMEM),R(0:NRADMEM),DR(0:NRADMEM)
     &    ,AFI(0:NRADMEM,0:LMAXTMEM),AFIP(0:NRADMEM,0:LMAXTMEM)
     &    ,AFID(0:NRADMEM,0:LMAXTMEM),AFIDP(0:NRADMEM,0:LMAXTMEM)
     &    ,ENY(0:LM),AFIDDS(0:LM),AFIDDPS(0:LM)
	COMPLEX*16 DELNY
	DATA DEL/0.025D0/,PI/3.141592653589793D0/
C MEMORY ALLOCATIONS
	ALLOCATE(FI(0:NRADMEM,5))
	ALLOCATE(FID(0:NRADMEM,5))
	ALLOCATE(DELFI(0:NRADMEM,5))
	ALLOCATE(DELFID(0:NRADMEM,5))
	ALLOCATE(DVL(0:NRADMEM))
C START CODE
	DELNY=(0.D0,0.D0)
	SQPI4=SQRT(4.D0*PI)
	DO IRAD=0,NRAD
	DVL(IRAD)=DCMPLX(-SQPI4,0.D0)
	ENDDO
	DO L=0,LM
C  SOLVE RADIAL SCHROEDINGER EQUATION 
	CALL LIB_RADSCH(ENY(L),S,Z,L,-1,NODES,D,FI(0,3),FID(0,3),NRAD,
     &  H,R,DR,LR)
C  SOLVE SCHROEDINGER EQUATION FOR ENERGY DERIVATIVE
	CALL LIB_RADSCH_DELV(ENY(L),DELNY,S,Z,L,-1,DVL,NOD,DELFI(0,3),
     &  DELFID(0,3),FI(0,3),FID(0,3),NRAD,H,R,DR,LR)
	DO IRAD=0,NRAD
	AFI(IRAD,L)=FI(IRAD,3)
	AFID(IRAD,L)=FID(IRAD,3)
	AFIP(IRAD,L)=DREAL(DELFI(IRAD,3))
	AFIDP(IRAD,L)=DREAL(DELFID(IRAD,3))
	ENDDO
C  SECOND ORDER DERIVATIVES AT THE SPHERE BOUNDARY
	AFIDDS(L)=0.D0
	AFIDDPS(L)=0.D0
C       AFIDDS(L)=AFI(NRAD,L)*(L*(L+1)/S/S-Z(NRAD)/S-ENY(L))
C     &               -2.D0/S*AFID(NRAD,L)
C       AFIDDPS(L)=AFIP(NRAD,L)*(L*(L+1)/S/S-Z(NRAD)/S-ENY(L))
C     &               -2.D0/S*AFIDP(NRAD,L)-AFI(NRAD,L)
	ENDDO
C MEMORY DEALLOCATIONS
	DEALLOCATE(FI)
	DEALLOCATE(FID)
	DEALLOCATE(DELFI)
	DEALLOCATE(DELFID)
	DEALLOCATE(DVL)
	END SUBROUTINE LIB_RADSCH_PHIS


	SUBROUTINE LIB_RADSCH_PHIP(ENY,AFI,AFIP,AFID,AFIDP,
     &             AFIPP,AFIDPP,S,Z,LM,NRAD,H,R,DR,LR)
*********************************************************
*   The calculation of the radial wave functions        *
*   and their energy derivatives up to second order.    *
*********************************************************
C SET ARRAY-SIZE DATA
        USE DIM_LMTART
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8, ALLOCATABLE :: FI(:,:)
	REAL*8, ALLOCATABLE :: FID(:,:)
	COMPLEX*16, ALLOCATABLE :: DELFI(:,:)
	COMPLEX*16, ALLOCATABLE :: DELFID(:,:)
	COMPLEX*16, ALLOCATABLE :: DVL(:)
	DIMENSION Z(0:NRADMEM),R(0:NRADMEM),DR(0:NRADMEM)
     &    ,AFI(0:NRADMEM,0:LMAXTMEM),AFIP(0:NRADMEM,0:LMAXTMEM)
     &    ,AFID(0:NRADMEM,0:LMAXTMEM),AFIDP(0:NRADMEM,0:LMAXTMEM)
     &    ,AFIPP(0:NRADMEM,0:LMAXTMEM),AFIDPP(0:NRADMEM,0:LMAXTMEM)
     &    ,ENY(0:LM)
	COMPLEX*16 DELNY
	DATA DEL/0.025D0/,PI/3.141592653589793D0/
C MEMORY ALLOCATIONS
	ALLOCATE(FI(0:NRADMEM,5))
	ALLOCATE(FID(0:NRADMEM,5))
	ALLOCATE(DELFI(0:NRADMEM,5))
	ALLOCATE(DELFID(0:NRADMEM,5))
	ALLOCATE(DVL(0:NRADMEM))
C START CODE
	DELNY=(0.D0,0.D0)
	SQPI4=SQRT(4.D0*PI)
	DO IRAD=0,NRAD
	DVL(IRAD)=DCMPLX(-SQPI4,0.D0)
	ENDDO
	DO 100 L=0,LM
	DO N=1,5
	EN=ENY(L)+DEL*(N-3.D0)
C  SOLVE RADIAL SCHROEDINGER EQUATION 
	CALL LIB_RADSCH(EN,S,Z,L,-1,NODE,D,FI(0,N),FID(0,N),NRAD,
     &  H,R,DR,LR)
	IF(N.EQ.3)NODES=NODE
C  SOLVE SCHROEDINGER EQUATION FOR ENERGY DERIVATIVE
	CALL LIB_RADSCH_DELV(EN,DELNY,S,Z,L,-1,DVL,NOD,DELFI(0,N),
     &  DELFID(0,N),FI(0,N),FID(0,N),NRAD,H,R,DR,LR)
	ENDDO
	DO IRAD=0,NRAD
	AFI(IRAD,L)=FI(IRAD,3)
	AFID(IRAD,L)=FID(IRAD,3)
	AFIP(IRAD,L)=DREAL(DELFI(IRAD,3))
	AFIDP(IRAD,L)=DREAL(DELFID(IRAD,3))
	AFIPP(IRAD,L)=DREAL((DELFI(IRAD,1)-DELFI(IRAD,5)+8.D0*
     &  (DELFI(IRAD,4)-DELFI(IRAD,2))))/(12.D0*DEL)
	AFIDPP(IRAD,L)=DREAL((DELFID(IRAD,1)-DELFID(IRAD,5)+8.D0*
     &  (DELFID(IRAD,4)-DELFID(IRAD,2))))/(12.D0*DEL)
	ENDDO 
 100    CONTINUE
C MEMORY DEALLOCATIONS
	DEALLOCATE(FI)
	DEALLOCATE(FID)
	DEALLOCATE(DELFI)
	DEALLOCATE(DELFID)
	DEALLOCATE(DVL)
	END SUBROUTINE LIB_RADSCH_PHIP


	SUBROUTINE LIB_RADSCH(EN,S,Z,L,JT,NODES,D,FI,FID,NRAD,H,R,DR,LR)
***************************************************************
*  The solution of the radial Schroedinger equation           *
*                                                             *
*   / P'(r)=Q(r)+(l+1)*P(r)/r                                 *
*   \ Q'(r)=(V(r)-E)*P(r)-(l+1)*Q(r)/r                        *
*     FI(r)=P(r)/r and FID(r)=FI'(r)                          *
*                                                             *
*  or (scalar) relativistic Dirac equation                    *
*                                                             *
*   / P'(r)=A(r)*Q(r)+P(r)/r                                  *
*   \ Q'(r)=[V(r)-E+C(r)-V'(r)/r/A(r)^2*(k+1)/c^2]*P(r)-Q(r)/r*
*  where                                                      *
*     A(r)=1+(E-V(r))/c^2                                     *
*     C(r)=l*(l+1)/r^2/A(r)                                   *
*     g(r)=P(r)/r - large component and                       *
*     f(r)=(Q(r)+(k+1)/A(r)*P(r)/r)/(rc) - small component    *
*  and c is the light velocity.                               *
*  Scalar-relativistic equations are obtained by dropping     *
*  the spin-orbit term with k=-l-1 for j=l+1/2 and k=l for    *
*  j=l-1/2.                                                   *
***************************************************************
	IMPLICIT REAL*8 (A-H,K,M,O-Z)
	REAL*8, ALLOCATABLE :: P(:)
	REAL*8, ALLOCATABLE :: Q(:)
	REAL*8, ALLOCATABLE :: DZDR(:)
	REAL*8 L2,LIB_RADSCH_FSIM
	DIMENSION Z(0:NRAD),R(0:NRAD),FI(0:NRAD),FID(0:NRAD)
     &    ,DR(0:NRAD)
	DATA C2/0.000013312838D0/,EPSP/1.D-14/
C MEMORY ALLOCATIONS
	ALLOCATE(P(0:NRAD))
	ALLOCATE(Q(0:NRAD))
	ALLOCATE(DZDR(0:NRAD))
	L1=L+1
	NODES=0
	BETTA=S/(EXP(H*NRAD)-1.D0)
	IF(Z(0).GE.1.D-05)LCR=LR
	IF(Z(0).LE.1.D-05)LCR=0
C ****** NON-RELATIVISTIC VERSION (LOGARITHMIC SCALE) ******
	IF(LCR.EQ.0) THEN
C   ASSYMPTOTIC BEHAVIOR ::
	P(0)=0.D0
	Q(0)=0.D0
	I0=1
  10  P(I0)=R(I0)**L1*(1.D0-Z(0)/(2.D0*L1)*R(I0))
	IF(P(I0).LE.EPSP)THEN
	P(I0)=0.D0
	Q(I0)=0.D0
	I0=I0+1
	GOTO 10
	ENDIF
	Q(I0)=-Z(0)*R(I0)**L1/(L1*2.D0)
	IF(Z(0).LE.1.D-05)Q(I0)=-EN*R(I0)**(L1+1)/(2.D0*L1+1)
C   4-TH ORDER RUNGE-KUTTA LOOP ::
	R3=R(I0)
	A3=DR(I0)*H
	B3=A3/R3*L1
	V3=A3*EN+A3/R3*Z(I0)
	DO I=I0,NRAD-1
	R1=R3
	R2=BETTA*(EXP(H*(I+0.5D0))-1.D0) !!! R(I+1/2)
	R3=R(I+1)
	A1=A3
	A2=(R2+BETTA)*H
	A3=DR(I+1)*H
	B1=B3
	B2=A2/R2*L1
	B3=A3/R3*L1
	V1=V3
	IF(I.NE.NRAD-1)V2=A2*EN+A2/R2*(9.D0*(Z(I)+Z(I+1))-Z(I-1)-Z(I+2))
     &  *6.25D-2
	IF(I.EQ.NRAD-1)V2=A2*EN+A2/R2*(Z(I)+Z(I+1))*0.5D0
	V3=A3*EN+A3/R3*Z(I+1)
C   **************
	K1= A1*Q(I)+B1*P(I)
	M1=-V1*P(I)-B1*Q(I)
C   **************
	K2= A2*(Q(I)+M1*0.5D0)+B2*(P(I)+K1*0.5D0)
	M2=-V2*(P(I)+K1*0.5D0)-B2*(Q(I)+M1*0.5D0)
C   **************
	K3= A2*(Q(I)+M2*0.5D0)+B2*(P(I)+K2*0.5D0)
	M3=-V2*(P(I)+K2*0.5D0)-B2*(Q(I)+M2*0.5D0)
C   **************
	K4= A3*(Q(I)+M3)+B3*(P(I)+K3)
	M4=-V3*(P(I)+K3)-B3*(Q(I)+M3)
C   **************
	P(I+1)=P(I)+(K1+K4+2.D0*(K2+K3))/6.D0
	Q(I+1)=Q(I)+(M1+M4+2.D0*(M2+M3))/6.D0
	IF(P(I)*P(I+1).LT.0.D0)NODES=NODES+1
	ENDDO
	D=S*Q(NRAD)/P(NRAD)+L  !!! LOGARITHM.DERIVATIVE
C   NORMALIZATION ::
	ANORM=SQRT(LIB_RADSCH_FSIM(P(0),P(0),NRAD,H,DR(0)))
	DO I=1,NRAD
	FI(I)=P(I)/(ANORM*R(I))
	FID(I)=Q(I)/(ANORM*R(I))+L*P(I)/(ANORM*R(I)*R(I))
	ENDDO
	IF(L.EQ.0)THEN
	FI(0)=1.D0/ANORM
	FID(0)=-Z(0)/(2.D0*ANORM)
	ELSEIF(L.EQ.1)THEN
	FI(0)=0.0D0
	FID(0)=1.D0/ANORM
	ELSE
	FI(0)=0.D0
	FID(0)=0.D0
	ENDIF
C ****** SCALARRELATIVISTIC VERSION ******
	ELSEIF(LCR.EQ.1)THEN
	L2=L1*(L1-1)
C   ASSIMPTOTIC BEHAVIOR ::
	QL=SQRT(L2+1-Z(0)**2*C2)
	P(0)=0.D0
	Q(0)=0.D0
	I0=1
  20  P(I0)=R(I0)**QL
	IF(P(I0).LE.EPSP)THEN
	P(I0)=0.D0
	Q(I0)=0.D0
	I0=I0+1
	GOTO 20
	ENDIF
	Q(I0)=P(I0)*(QL-1)/(Z(0)*C2)
C   4-TH ORDER RUNGE-KUTTA LOOP ::
	R3=R(I0)
	B3=DR(I0)/R3*H
	EV3=EN+Z(I0)/R3
	A3=DR(I0)*(1.D0+EV3*C2)*H
	V3=DR(I0)*(EV3-L2/R3/R3/(1.D0+EV3*C2))*H
	DO I=I0,NRAD-1
	R1=R3
	R2=BETTA*(EXP(H*(I+0.5D0))-1.D0)   !!! R(I+1/2)
	R3=R(I+1)
	B1=B3
	B2=(R2+BETTA)/R2*H
	B3=DR(I+1)/R3*H
	EV1=EV3
	IF(I.NE.NRAD-1) EV2=EN+(9.D0*(Z(I)+Z(I+1))-Z(I-1)-Z(I+2))*
     &  6.25D-02/R2
	IF(I.EQ.NRAD-1) EV2=EN+(Z(I)+Z(I+1))*0.5D0/R2
	EV3=EN+Z(I+1)/R3
	A1=A3
	A2=(R2+BETTA)*(1.D0+EV2*C2)*H
	A3=DR(I+1)*(1.D0+EV3*C2)*H
	V1=V3
	V2=(R2+BETTA)*(EV2-L2/R2/R2/(1.D0+EV2*C2))*H
	V3=DR(I+1)*(EV3-L2/R3/R3/(1.D0+EV3*C2))*H
C   **************
	K1= A1*Q(I)+B1*P(I)
	M1=-V1*P(I)-B1*Q(I)
C   **************
	K2= A2*(Q(I)+M1*0.5D0)+B2*(P(I)+K1*0.5D0)
	M2=-V2*(P(I)+K1*0.5D0)-B2*(Q(I)+M1*0.5D0)
C   **************
	K3= A2*(Q(I)+M2*0.5D0)+B2*(P(I)+K2*0.5D0)
	M3=-V2*(P(I)+K2*0.5D0)-B2*(Q(I)+M2*0.5D0)
C   **************
	K4= A3*(Q(I)+M3)+B3*(P(I)+K3)
	M4=-V3*(P(I)+K3)-B3*(Q(I)+M3)
C   **************
	P(I+1)=P(I)+(K1+K4+2.D0*(K2+K3))/6.D0
	Q(I+1)=Q(I)+(M1+M4+2.D0*(M2+M3))/6.D0
	IF(P(I)*P(I+1).LT.0.D0)NODES=NODES+1
	ENDDO
	D=Q(NRAD)/P(NRAD)*(S+(EN*S+Z(NRAD))*C2)
C   NORMALISATION ::
	ANORM=SQRT(LIB_RADSCH_FSIM(P(0),P(0),NRAD,H,DR))
	DO I=1,NRAD
	FI (I)=P(I)/(ANORM*R(I))
	FID(I)=Q(I)/(ANORM*R(I))*(1.D0+C2*(EN+Z(I)/R(I)))
	ENDDO
	IF(L.EQ.0)THEN
	FI(0)=FI(1)-FID(1)*R(1)  !!! diverges
	FID(0)=FID(1)
	ELSEIF(L.EQ.1)THEN
	FI(0)=0.D0
	FID(0)=FID(1)            !!! diverges
	ELSE
	FI(0)=0.D0
	FID(0)=0.D0
	ENDIF
C ****** FULLY RELATIVISTIC VERSION (WITH PAULI RETURN) ******
	ELSEIF(LCR.EQ.2)THEN
	L2=DBLE(L1*(L1-1))
	RJ=DBLE(JT)/2.D0
	RL=DBLE(L)
	IF(ABS(RJ-(RL-0.5D0)).LE.1.D-10)RK=RL
	IF(ABS(RJ-(RL+0.5D0)).LE.1.D-10)RK=-RL-1.D0
C FIND DERIVATIVE OF THE POTENTIAL
	CALL LIB_DERIV1(Z,DZDR,NRAD,H,R,DR,S)
C ASSIMPTOTIC BEHAVIOR ::
	QL=SQRT(L2-(RK+1)+1.D0-Z(0)**2*C2)
	P(0)=0.D0
	Q(0)=0.D0
	I0=1
  30  P(I0)=R(I0)**QL
	IF(ABS(P(I0)).LE.EPSP)THEN
	P(I0)=0.D0
	Q(I0)=0.D0
	I0=I0+1
	GOTO 30
	ENDIF
	Q(I0)=P(I0)*(QL-1.D0)/(Z(0)*C2)
C   4-TH ORDER RUNGE-KUTTA LOOP ::
	R3=R(I0)
	B3=DR(I0)/R3*H
	EV3=EN+Z(I0)/R3
	DVDR3=(Z(I0)/R3-DZDR(I0))/R3
	SO3=DVDR3/R3*(RK+1.D0)*C2/(1.D0+EV3*C2)**2
	A3=DR(I0)*H*(1.D0+EV3*C2)
	V3=DR(I0)*H*EV3
     &  -DR(I0)*H*L2/R3/R3/(1.D0+EV3*C2)
     &  +DR(I0)*H*SO3
	DO I=I0,NRAD-1
	R1=R3
	R2=BETTA*(EXP(H*(DBLE(I)+0.5D0))-1.D0)   !!! R(I+1/2)
	R3=R(I+1)
	B1=B3
	B2=(R2+BETTA)/R2*H
	B3=DR(I+1)/R3*H
	EV1=EV3
	DVDR1=DVDR3
	SO1=SO3
	IF(I.NE.NRAD-1)THEN
	ZMR=(9.D0*(Z(I)+Z(I+1))-Z(I-1)-Z(I+2))*6.25D-02
	ZMD=(9.D0*(DZDR(I)+DZDR(I+1))-DZDR(I-1)-DZDR(I+2))*6.25D-02
	ELSEIF(I.EQ.NRAD-1)THEN
	ZMR=(Z(I)+Z(I+1))*0.5D0
	ZMD=(DZDR(I)+DZDR(I+1))*0.5D0
	ENDIF
	EV2=EN+ZMR/R2
	DVDR2=(ZMR/R2-ZMD)/R2
	SO2=DVDR2/R2*(RK+1.D0)*C2/(1.D0+EV2*C2)**2
	EV3=EN+Z(I+1)/R3
	DVDR3=(Z(I+1)/R3-DZDR(I+1))/R3
	SO3=DVDR3/R3*(RK+1.D0)*C2/(1.D0+EV3*C2)**2
	A1=A3
	A2=(R2+BETTA)*(1.D0+EV2*C2)*H
	A3=DR(I+1)*(1.D0+EV3*C2)*H
	V1=V3
	V2=(R2+BETTA)*H*EV2
     &  -(R2+BETTA)*H*L2/R2/R2/(1.D0+EV2*C2)
     &  +(R2+BETTA)*H*SO2
	V3=DR(I+1)*H*EV3
     &  -DR(I+1)*H*L2/R3/R3/(1.D0+EV3*C2)
     &  +DR(I+1)*H*SO3
C **************
	K1= A1*Q(I)+B1*P(I)
	M1=-V1*P(I)-B1*Q(I)
C **************
	K2= A2*(Q(I)+M1*0.5D0)+B2*(P(I)+K1*0.5D0)
	M2=-V2*(P(I)+K1*0.5D0)-B2*(Q(I)+M1*0.5D0)
C **************
	K3= A2*(Q(I)+M2*0.5D0)+B2*(P(I)+K2*0.5D0)
	M3=-V2*(P(I)+K2*0.5D0)-B2*(Q(I)+M2*0.5D0)
C **************
	K4= A3*(Q(I)+M3)+B3*(P(I)+K3)
	M4=-V3*(P(I)+K3)-B3*(Q(I)+M3)
C **************
	P(I+1)=P(I)+(K1+K4+2.D0*(K2+K3))/6.D0
	Q(I+1)=Q(I)+(M1+M4+2.D0*(M2+M3))/6.D0
	IF(P(I)*P(I+1).LT.0.D0)NODES=NODES+1
	ENDDO
	D=Q(NRAD)/P(NRAD)*(S+(EN*S+Z(NRAD))*C2)
C   NORMALISATION ::
	ANORM=SQRT(LIB_RADSCH_FSIM(P(0),P(0),NRAD,H,DR))
C DO NOT FORM RELATIVISTIC SMALL COMPONENT, 
C FORM DERIVATIVE OF LARGE COMPONENT INSTEAD
	DO I=1,NRAD
	FI (I)=P(I)/(ANORM*R(I))
	FID(I)=Q(I)/(ANORM*R(I))*(1.D0+C2*(EN+Z(I)/R(I)))
	ENDDO
	IF(L.EQ.0)THEN
	FI(0)=FI(1)-FID(1)*R(1)  !!! diverges
	FID(0)=FID(1)
	ELSEIF(L.EQ.1)THEN
	FI(0)=0.D0
	FID(0)=FID(1)            !!! diverges
	ELSE
	FI(0)=0.D0
	FID(0)=0.D0
	ENDIF
	ENDIF
C MEMORY DEALLOCATIONS
	DEALLOCATE(P,Q,DZDR)
	END




C********* INTEGRATION PROGRAM ***************
	FUNCTION LIB_RADSCH_FSIM(T1,T2,NRAD,H,DR)
	IMPLICIT REAL*8 (A-H,O-Z)
	DIMENSION T1(0:NRAD),T2(0:NRAD),DR(0:NRAD)
	REAL*8 LIB_RADSCH_FSIM
	S4=4.D0*DR(1)*T1(1)*T2(1)
	S2=DR(0)*T1(0)*T2(0)+DR(NRAD)*T1(NRAD)*T2(NRAD)
	DO J=2,NRAD-2,2
	S2=S2+2.D0*DR(J)*T1(J)*T2(J)
	S4=S4+4.D0*DR(J+1)*T1(J+1)*T2(J+1)
	ENDDO
	LIB_RADSCH_FSIM=H*0.333333333333333333D0*(S2+S4)
	END



	SUBROUTINE LIB_RADSCH_DELV(EN,DEN,S,Z,L,JT,DVL,NODES,DELFI,
     &           DELFID,FI,FID,NRAD,H,R,DR,LR)
***************************************************************
*  The solution of the linearized Schroedinger equation:      *
*   / dP'(r)=dQ(r)+(l+1)*dP(r)/r                              *
*   \ dQ'(r)=(V(r)-E)*dP(r)-(l+1)*dQ(r)/r+dV(r)*P(r)          *
*     dFI(r)=dP(r)/r and dFID(r)=dFI'(r)                      *
* or its relativistic analoges.                               *
***************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	IMPLICIT COMPLEX*16 (K,M)
	REAL*8, ALLOCATABLE :: P(:)
	REAL*8, ALLOCATABLE :: Q(:)
	REAL*8, ALLOCATABLE :: DZDR(:)
	COMPLEX*16, ALLOCATABLE :: DP(:)
	COMPLEX*16, ALLOCATABLE :: DQ(:)
	COMPLEX*16, ALLOCATABLE :: DV(:)
	REAL*8 L2,LIB_RADSCH_FSIM
	DIMENSION Z(0:NRAD),R(0:NRAD),DR(0:NRAD),FI(0:NRAD)
     &     ,FID(0:NRAD)
	COMPLEX*16 DVL(0:NRAD),DELFI(0:NRAD),DELFID(0:NRAD)
     &     ,AL,BL,DV0,DV1,DV2,DV3,DAN,DS1,DS2,DS3,DEN
     &     ,LIB_RADSCH_CSIM
	DATA C2/0.000013312838D0/,PI/3.141592657589793D0/,EPSP/1.D-14/
C MEMORY ALLOCATIONS
	ALLOCATE(P(0:NRAD))
	ALLOCATE(Q(0:NRAD))
	ALLOCATE(DP(0:NRAD))
	ALLOCATE(DQ(0:NRAD))
	ALLOCATE(DV(0:NRAD))
	ALLOCATE(DZDR(0:NRAD))
	SQPI4=SQRT(4.D0*PI)
C GET SPHERICAL PART OF THE INDUCED POTENTIAL
	DO IRAD=0,NRAD
	DV(IRAD)=DVL(IRAD)/SQPI4-DEN
	ENDDO
	L1=L+1
	NODES=0
	BETTA=S/(EXP(H*NRAD)-1.D0)
	IF(Z(0).GE.1.D-05)LCR=LR
	IF(Z(0).LE.1.D-05)LCR=0
C ****** NON-RELATIVISTIC VERSION (LOGARITHMIC SCALE) ******
	IF(LCR.EQ.0) THEN
C   ASSYMPTOTIC BEHAVIOR ::
	I0=0
  10  I0=I0+1
	IF(I0.GT.NRAD)CALL FULLSTOP('<DELRADSCH>:: I0.GT.NRAD')
	IF(FI(I0).EQ.0.D0)GOTO10
	AN=FI(I0)/R(I0)**L/(1.D0-Z(0)/2.D0/(L+1)*R(I0))
	R1R2=R(1)/R(2)
	R2R1=R(2)/R(1)
	DV0=DV(0)
	DV1=(DV(1)-DV(0))/R(1)/(1.D0-R1R2)+(DV(2)-DV(0))/
     &  R(2)/(1.D0-R2R1)
	AL=AN*DV0/((L+2)*(L+3)-L*(L+1))
	BL=(AN*DV1-Z(0)/2.D0/(L+1)*AN*DV0-Z(0)*AL)/((L+3)*(L+4)-L*(L+1))
	I0=1
	P(0)=R(0)*FI(0)
	DP(0)=(0.D0,0.D0)
	DQ(0)=(0.D0,0.D0)
  20  DP(I0)=AL*R(I0)**(L+3)+BL*R(I0)**(L+4)
	P(I0)=R(I0)*FI(I0)
	IF(ABS(DP(I0)).LE.EPSP)THEN
	DQ(I0)=0.D0
	I0=I0+1
	IF(I0.EQ.NRAD+1)GOTO 30
	GOTO20
	ENDIF
	DQ(I0)=2.D0*AL*R(I0)**(L+2)+3.D0*BL*R(I0)**(L+3)
C   4-TH ORDER RUNGE-KUTTA LOOP ::
	R3=R(I0)
	A3=DR(I0)*H
	B3=A3/R3*L1
	V3=A3*EN+A3/R3*Z(I0)
	P3=R3*FI(I0)
	DV3=A3*DV(I0)
	DO I=I0,NRAD-1
	R1=R3
	R2=BETTA*(EXP(H*(I+0.5D0))-1.D0) !!! R(I+1/2)
	R3=R(I+1)
	A1=A3
	A2=(R2+BETTA)*H
	A3=DR(I+1)*H
	B1=B3
	B2=A2/R2*L1
	B3=A3/R3*L1
	V1=V3
	IF(I.NE.NRAD-1)V2=A2*EN+A2/R2*(9.D0*(Z(I)+Z(I+1))-Z(I-1)-Z(I+2))
     &  *6.25D-02
	IF(I.EQ.NRAD-1)V2=A2*EN+A2/R2*(Z(I)+Z(I+1))*0.5D0
	V3=A3*EN+A3/R3*Z(I+1)
	P1=P3
	IF(I.NE.NRAD-1)P2=R2*(9.D0*(FI(I)+FI(I+1))-FI(I-1)-FI(I+2))*
     &  6.25D-02
	IF(I.EQ.NRAD-1)P2=R2*(FI(I)+FI(I+1))*0.5D0
	P3=R3*FI(I+1)
	DV1=DV3
	IF(I.NE.NRAD-1)DV2=A2*(9.D0*(DV(I)+DV(I+1))-DV(I-1)-DV(I+2))*
     &  6.25D-02
	IF(I.EQ.NRAD-1)DV2=A2*(DV(I)+DV(I+1))*0.5D0
	DV3=A3*DV(I+1)
	P(I+1)=P3
C   **************
	K1= A1*DQ(I)+B1*DP(I)
	M1=-V1*DP(I)-B1*DQ(I)+DV1*P1
C   **************
	K2= A2*(DQ(I)+M1*0.5D0)+B2*(DP(I)+K1*0.5D0)
	M2=-V2*(DP(I)+K1*0.5D0)-B2*(DQ(I)+M1*0.5D0)+DV2*P2
C   **************
	K3= A2*(DQ(I)+M2*0.5D0)+B2*(DP(I)+K2*0.5D0)
	M3=-V2*(DP(I)+K2*0.5D0)-B2*(DQ(I)+M2*0.5D0)+DV2*P2
C   **************
	K4= A3*(DQ(I)+M3)+B3*(DP(I)+K3)
	M4=-V3*(DP(I)+K3)-B3*(DQ(I)+M3)+DV3*P3
C   **************
	DP(I+1)=DP(I)+(K1+K4+2.D0*(K2+K3))/6.D0
	DQ(I+1)=DQ(I)+(M1+M4+2.D0*(M2+M3))/6.D0
	ENDDO
C   NORMALIZATION ::
  30  DAN=LIB_RADSCH_CSIM(P(0),DP(0),NRAD,H,DR(0))
	DELFI(0)=-DAN*FI(0)
	DELFID(0)=-DAN*FID(0)
	DO I=1,NRAD
	DELFI(I)=DP(I)/R(I)-DAN*FI(I)
	DELFID(I)=DQ(I)/R(I)+L*DP(I)/R(I)/R(I)-DAN*FID(I)
	ENDDO
C ****** SCALAR RELATIVISTIC VERSION ******
	ELSEIF(LCR.EQ.1)THEN
	L2=DBLE(L1*(L1-1))
	QL=SQRT(L2+1.D0-Z(0)**2*C2)
C   ASSYMPTOTIC BEHAVIOR ::
	I0=0
  40  I0=I0+1
	IF(I0.GT.NRAD)CALL FULLSTOP('<DELRADSCH>:: I0.GT.NRAD')
	IF(FI(I0).EQ.0.D0)GOTO 40
	AN=FI(I0)/R(I0)**(QL-1)
	DV0=DV(0)
	AL=-DV0*AN*(-2.D0*Z(0)*C2+(QL-1.D0)/Z(0))/(2.D0*QL+1.D0)
	I0=1
	P(0)=R(0)*FI(0)
	Q(0)=0.D0
	DP(0)=(0.D0,0.D0)
	DQ(0)=(0.D0,0.D0)
  50  DP(I0)=AL*R(I0)**(QL+1.D0)
	P(I0)=R(I0)*FI(I0)
	Q(I0)=R(I0)*FID(I0)/(1.D0+C2*(EN+Z(I0)/R(I0)))
	IF(ABS(DP(I0)).LE.EPSP)THEN
	DQ(I0)=0.D0
	I0=I0+1
	IF(I0.EQ.NRAD+1)GOTO 60
	GOTO50
	ENDIF
	DQ(I0)=R(I0)**(QL+1.D0)/(Z(0)*C2)*(AL*QL-DV0*AN*(QL-
     &  1.D0)/(Z(0)*C2))
C   4-TH ORDER RUNGE-KUTTA LOOP ::
	R3=R(I0)
	B3=DR(I0)/R3*H
	EV3=EN+Z(I0)/R3
	A3=DR(I0)*(1.D0+EV3*C2)*H
	V3=DR(I0)*(EV3-L2/R3/R3/(1.D0+EV3*C2))*H
	DV3=DR(I0)*DV(I0)*H
	DS3=DV3*(1.D0+L2/R3/R3*C2/(1.D0+EV3*C2)**2)
	P3=P(I0)
	Q3=Q(I0)
	DO I=I0,NRAD-1
	R1=R3
	R2=BETTA*(EXP(H*(I+0.5D0))-1.D0)   !!! R(I+1/2)
	R3=R(I+1)
	B1=B3
	B2=(R2+BETTA)/R2*H
	B3=DR(I+1)/R3*H
	EV1=EV3
	IF(I.NE.NRAD-1)EV2=EN+(9.D0*(Z(I)+Z(I+1))-Z(I-1)-Z(I+2))*
     &  6.25D-02/R2
	IF(I.EQ.NRAD-1)EV2=EN+(Z(I)+Z(I+1))*0.5D0/R2
	EV3=EN+Z(I+1)/R3
	A1=A3
	A2=(R2+BETTA)*(1.D0+EV2*C2)*H
	A3=DR(I+1)*(1.D0+EV3*C2)*H
	V1=V3
	V2=(R2+BETTA)*(EV2-L2/R2/R2/(1.D0+EV2*C2))*H
	V3=DR(I+1)*(EV3-L2/R3/R3/(1.D0+EV3*C2))*H
	DV1=DV3
	IF(I.NE.NRAD-1)DV2=(R2+BETTA)*(9.D0*(DV(I)+DV(I+1))-
     &  DV(I-1)-DV(I+2))*6.25D-2*H
	IF(I.EQ.NRAD-1)DV2=(R2+BETTA)*(DV(I)+DV(I+1))*0.5D0*H
	DV3=DR(I+1)*DV(I+1)*H
	DS1=DS3
	DS2=DV2*(1.D0+L2/R2/R2*C2/(1.D0+EV2*C2)**2)
	DS3=DV3*(1.D0+L2/R3/R3*C2/(1.D0+EV3*C2)**2)
	P1=P3
	IF(I.NE.NRAD-1)P2=R2*(9.D0*(FI(I)+FI(I+1))-FI(I-1)-FI(I+2))*
     &  6.25D-02
	IF(I.EQ.NRAD-1)P2=R2*(FI(I)+FI(I+1))*0.5D0
	P3=R3*FI(I+1)
	Q1=Q3
	IF(I.NE.NRAD-1)Q2=R2*(9.D0*(FID(I)+FID(I+1))-FID(I-1)-FID(I+2))*
     &  6.25D-02/(1.D0+C2*EV2)
	IF(I.EQ.NRAD-1)Q2=R2*(FID(I)+FID(I+1))*0.5D0/(1.D0+C2*EV2)
	Q3=R3*FID(I+1)/(1.D0+C2*EV3)
	P(I+1)=P3
	Q(I+1)=Q3
C   **************
	K1=+A1*DQ(I)+B1*DP(I)-DV1*C2*Q1
	M1=-V1*DP(I)-B1*DQ(I)+DS1*P1
C   **************
	K2= A2*(DQ(I)+M1*0.5D0)+B2*(DP(I)+K1*0.5D0)-DV2*C2*Q2
	M2=-V2*(DP(I)+K1*0.5D0)-B2*(DQ(I)+M1*0.5D0)+DS2*P2
C   **************
	K3= A2*(DQ(I)+M2*0.5D0)+B2*(DP(I)+K2*0.5D0)-DV2*C2*Q2
	M3=-V2*(DP(I)+K2*0.5D0)-B2*(DQ(I)+M2*0.5D0)+DS2*P2
C   **************
	K4= A3*(DQ(I)+M3)+B3*(DP(I)+K3)-DV3*C2*Q3
	M4=-V3*(DP(I)+K3)-B3*(DQ(I)+M3)+DS3*P3
C   **************
	DP(I+1)=DP(I)+(K1+K4+2.D0*(K2+K3))/6.D0
	DQ(I+1)=DQ(I)+(M1+M4+2.D0*(M2+M3))/6.D0
	ENDDO
C   NORMALIZATION ::
  60  DAN=LIB_RADSCH_CSIM(P(0),DP(0),NRAD,H,DR(0))
	DELFI(0)=-DAN*FI(0)
	DELFID(0)=-DAN*FID(0)
	DO I=1,NRAD
	DELFI(I)=DP(I)/R(I)-DAN*FI(I)
	DELFID(I)=(DQ(I)*(1.D0+C2*(EN+Z(I)/R(I)))-Q(I)*C2*DV(I))/R(I)-
     &  DAN*FID(I)
	ENDDO
C ****** FULL RELATIVISTIC VERSION (NOT CHECKED!) ******
	ELSEIF(LCR.EQ.2)THEN
	L2=DBLE(L1*(L1-1))
	RJ=DBLE(JT)/2.D0
	RL=DBLE(L)
	IF(ABS(RJ-(RL-0.5D0)).LE.1.D-10)RK=RL
	IF(ABS(RJ-(RL+0.5D0)).LE.1.D-10)RK=-RL-1.D0
C FIND DERIVATIVE OF THE POTENTIAL
	CALL LIB_DERIV1(Z,DZDR,NRAD,H,R,DR,S)
	QL=SQRT(L2+1.D0-Z(0)**2*C2)
C   ASSYMPTOTIC BEHAVIOR ::
	I0=0
  70  I0=I0+1
	IF(I0.GT.NRAD)CALL FULLSTOP('<DELRADSCH>:: I0.GT.NRAD')
	IF(FI(I0).EQ.0.D0)GOTO 70
	AN=FI(I0)/R(I0)**(QL-1)
	DV0=DV(0)
	AL=-DV0*AN*(-2.D0*Z(0)*C2+(QL-1.D0)/Z(0))/(2.D0*QL+1.D0)
	I0=1
	P(0)=R(0)*FI(0)
	Q(0)=0.D0
	DP(0)=(0.D0,0.D0)
	DQ(0)=(0.D0,0.D0)
  80  DP(I0)=AL*R(I0)**(QL+1.D0)
	P(I0)=R(I0)*FI(I0)
	Q(I0)=R(I0)*FID(I0)/(1.D0+C2*(EN+Z(I0)/R(I0)))
	IF(ABS(DP(I0)).LE.EPSP)THEN
	DQ(I0)=0.D0
	I0=I0+1
	IF(I0.EQ.NRAD+1)GOTO 90
	GOTO80
	ENDIF
	DQ(I0)=R(I0)**(QL+1.D0)/(Z(0)*C2)*(AL*QL-DV0*AN*(QL-
     &  1.D0)/(Z(0)*C2))
C   4-TH ORDER RUNGE-KUTTA LOOP ::
	R3=R(I0)
	B3=DR(I0)/R3*H
	EV3=EN+Z(I0)/R3
	DVDR3=(Z(I0)/R3-DZDR(I0))/R3
	SO3=DVDR3/R3*(RK+1.D0)*C2/(1.D0+EV3*C2)**2
	A3=DR(I0)*H*(1.D0+EV3*C2)
	V3=DR(I0)*H*EV3
     &  -DR(I0)*H*L2/R3/R3/(1.D0+EV3*C2)
     &  +DR(I0)*H*SO3
	DV3=DR(I0)*DV(I0)*H
	DS3=DV3*(1.D0+L2/R3/R3*C2/(1.D0+EV3*C2)**2-
     &    2.D0*DVDR3/R3*(RK+1.D0)*C2*C2/(1.D0+EV3*C2)**3)
	P3=P(I0)
	Q3=Q(I0)
	DO I=I0,NRAD-1
	R1=R3
	R2=BETTA*(EXP(H*(DBLE(I)+0.5D0))-1.D0)   !!! R(I+1/2)
	R3=R(I+1)
	B1=B3
	B2=(R2+BETTA)/R2*H
	B3=DR(I+1)/R3*H
	EV1=EV3
	DVDR1=DVDR3
	SO1=SO3
	IF(I.NE.NRAD-1)THEN
	ZMR=(9.D0*(Z(I)+Z(I+1))-Z(I-1)-Z(I+2))*6.25D-02
	ZMD=(9.D0*(DZDR(I)+DZDR(I+1))-DZDR(I-1)-DZDR(I+2))*6.25D-02
	ELSEIF(I.EQ.NRAD-1)THEN
	ZMR=(Z(I)+Z(I+1))*0.5D0
	ZMD=(DZDR(I)+DZDR(I+1))*0.5D0
	ENDIF
	EV2=EN+ZMR/R2
	DVDR2=(ZMR/R2-ZMD)/R2
	SO2=DVDR2/R2*(RK+1.D0)*C2/(1.D0+EV2*C2)**2
	EV3=EN+Z(I+1)/R3
	DVDR3=(Z(I+1)/R3-DZDR(I+1))/R3
	SO3=DVDR3/R3*(RK+1.D0)*C2/(1.D0+EV3*C2)**2
	A1=A3
	A2=(R2+BETTA)*(1.D0+EV2*C2)*H
	A3=DR(I+1)*(1.D0+EV3*C2)*H
	V1=V3
	V2=(R2+BETTA)*H*EV2
     &  -(R2+BETTA)*H*L2/R2/R2/(1.D0+EV2*C2)
     &  +(R2+BETTA)*H*SO2
	V3=DR(I+1)*H*EV3
     &  -DR(I+1)*H*L2/R3/R3/(1.D0+EV3*C2)
     &  +DR(I+1)*H*SO3
	DV1=DV3
	IF(I.NE.NRAD-1)DV2=(R2+BETTA)*(9.D0*(DV(I)+DV(I+1))-
     &  DV(I-1)-DV(I+2))*6.25D-2*H
	IF(I.EQ.NRAD-1)DV2=(R2+BETTA)*(DV(I)+DV(I+1))*0.5D0*H
	DV3=DR(I+1)*DV(I+1)*H
	DS1=DS3
	DS2=DV2*(1.D0+L2/R2/R2*C2/(1.D0+EV2*C2)**2-
     &    2.D0*DVDR2/R2*(RK+1.D0)*C2*C2/(1.D0+EV2*C2)**3)
	DS3=DV3*(1.D0+L2/R3/R3*C2/(1.D0+EV3*C2)**2-
     &    2.D0*DVDR3/R3*(RK+1.D0)*C2*C2/(1.D0+EV3*C2)**3)
	P1=P3
	IF(I.NE.NRAD-1)P2=R2*(9.D0*(FI(I)+FI(I+1))-FI(I-1)-FI(I+2))*
     &  6.25D-02
	IF(I.EQ.NRAD-1)P2=R2*(FI(I)+FI(I+1))*0.5D0
	P3=R3*FI(I+1)
	Q1=Q3
	IF(I.NE.NRAD-1)Q2=R2*(9.D0*(FID(I)+FID(I+1))-FID(I-1)-FID(I+2))*
     &  6.25D-02/(1.D0+C2*EV2)
	IF(I.EQ.NRAD-1)Q2=R2*(FID(I)+FID(I+1))*0.5D0/(1.D0+C2*EV2)
	Q3=R3*FID(I+1)/(1.D0+C2*EV3)
	P(I+1)=P3
	Q(I+1)=Q3
C   **************
	K1=+A1*DQ(I)+B1*DP(I)-DV1*C2*Q1
	M1=-V1*DP(I)-B1*DQ(I)+DS1*P1
C   **************
	K2= A2*(DQ(I)+M1*0.5D0)+B2*(DP(I)+K1*0.5D0)-DV2*C2*Q2
	M2=-V2*(DP(I)+K1*0.5D0)-B2*(DQ(I)+M1*0.5D0)+DS2*P2
C   **************
	K3= A2*(DQ(I)+M2*0.5D0)+B2*(DP(I)+K2*0.5D0)-DV2*C2*Q2
	M3=-V2*(DP(I)+K2*0.5D0)-B2*(DQ(I)+M2*0.5D0)+DS2*P2
C   **************
	K4= A3*(DQ(I)+M3)+B3*(DP(I)+K3)-DV3*C2*Q3
	M4=-V3*(DP(I)+K3)-B3*(DQ(I)+M3)+DS3*P3
C   **************
	DP(I+1)=DP(I)+(K1+K4+2.D0*(K2+K3))/6.D0
	DQ(I+1)=DQ(I)+(M1+M4+2.D0*(M2+M3))/6.D0
	ENDDO
C   NORMALIZATION ::
  90  DAN=LIB_RADSCH_CSIM(P(0),DP(0),NRAD,H,DR(0))
	DELFI(0)=-DAN*FI(0)
	DELFID(0)=-DAN*FID(0)
	DO I=1,NRAD
	DELFI(I)=DP(I)/R(I)-DAN*FI(I)
	DELFID(I)=(DQ(I)*(1.D0+C2*(EN+Z(I)/R(I)))-Q(I)*C2*DV(I))/R(I)-
     &  DAN*FID(I)
	ENDDO
	ENDIF
C MEMORY DEALLOCATIONS
	DEALLOCATE(P,Q,DP,DQ,DV,DZDR)
	END



C********* INTEGRATION PROGRAM ***************
	FUNCTION LIB_RADSCH_CSIM(T1,T2,NRAD,H,DR)
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16 LIB_RADSCH_CSIM,T2,S2,S4
	DIMENSION T1(0:NRAD),T2(0:NRAD),DR(0:NRAD)
	S4=4.D0*DR(1)*T1(1)*T2(1)
	S2=DR(0)*T1(0)*T2(0)+DR(NRAD)*T1(NRAD)*T2(NRAD)
	DO J=2,NRAD-2,2
	S2=S2+2.D0*DR(J)*T1(J)*T2(J)
	S4=S4+4.D0*DR(J+1)*T1(J+1)*T2(J+1)
	ENDDO
	LIB_RADSCH_CSIM=H*0.333333333333333D0*(S2+S4)
	END FUNCTION LIB_RADSCH_CSIM


