	SUBROUTINE LIB_TRANSREL_LMAX(TREL,LMAX)
***********************************************************
*  Builds transformation matrix which transforms          *
*  spinors of spherical harmonics to relativistic spinors *
***********************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 TREL(2*(LMAX+1)**2,2*(LMAX+1)**2)
	LJM=0
	DO L=0,LMAX
	DO J=2*L-1,2*L+1,2
	DJ=DBLE(J)/2.D0
	IF(J.LT.0)CYCLE
	DO MJ=-J,J,2 ! Mj-1/2
	DMJ=DBLE(MJ)/2.D0
	LJM=LJM+1
	DO ISPIN=1,2
	DO M=-L,L
	LMS=L*(L+1)+M+1+(LMAX+1)**2*(ISPIN-1)
	TREL(LJM,LMS)=(0.D0,0.D0)
	ENDDO
	ENDDO
	IF(J.EQ.2*L-1)THEN
	M=NINT(DMJ-0.5D0)
	LMS=L*(L+1)+M+1
	IF(M.GE.-L)TREL(LJM,LMS)=-SQRT((DJ-DMJ+1.D0)/(2.D0*DJ+2.D0))
	M=NINT(DMJ+0.5D0)
	LMS=L*(L+1)+M+1+(LMAX+1)**2
	IF(M.LE.+L)TREL(LJM,LMS)=+SQRT((DJ+DMJ+1.D0)/(2.D0*DJ+2.D0))
	ELSEIF(J.EQ.2*L+1)THEN
	M=NINT(DMJ-0.5D0)
	LMS=L*(L+1)+M+1
	IF(M.GE.-L)TREL(LJM,LMS)=+SQRT((DJ+DMJ)/(2.D0*DJ))
	M=NINT(DMJ+0.5D0)
	LMS=L*(L+1)+M+1+(LMAX+1)**2
	IF(M.LE.+L)TREL(LJM,LMS)=+SQRT((DJ-DMJ)/(2.D0*DJ))
	ENDIF
	ENDDO
	ENDDO
	ENDDO
	END



	SUBROUTINE LIB_TRANSREL_LINP(TREL,L)
***********************************************************
*  Builds transformation matrix which transforms          *
*  spinors of spherical harmonics to relativistic spinors *
***********************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 TREL(2*(2*L+1),2*(2*L+1))
	LJM=0
	DO J=2*L-1,2*L+1,2
	DJ=DBLE(J)/2.D0
	IF(J.LT.0)CYCLE
	DO MJ=-J,J,2 ! Mj-1/2
	DMJ=DBLE(MJ)/2.D0
	LJM=LJM+1
	DO ISPIN=1,2
	DO M=-L,L
	LMS=L+M+1+(2*L+1)*(ISPIN-1)
	TREL(LJM,LMS)=(0.D0,0.D0)
	ENDDO
	ENDDO
	IF(J.EQ.2*L-1)THEN
	M=NINT(DMJ-0.5D0)
	LMS=L+M+1
	IF(M.GE.-L)TREL(LJM,LMS)=-SQRT((DJ-DMJ+1.D0)/(2.D0*DJ+2.D0))
	M=NINT(DMJ+0.5D0)
	LMS=L+M+1+(2*L+1)
	IF(M.LE.+L)TREL(LJM,LMS)=+SQRT((DJ+DMJ+1.D0)/(2.D0*DJ+2.D0))
	ELSEIF(J.EQ.2*L+1)THEN
	M=NINT(DMJ-0.5D0)
	LMS=L+M+1
	IF(M.GE.-L)TREL(LJM,LMS)=+SQRT((DJ+DMJ)/(2.D0*DJ))
	M=NINT(DMJ+0.5D0)
	LMS=L+M+1+(2*L+1)
	IF(M.LE.+L)TREL(LJM,LMS)=+SQRT((DJ-DMJ)/(2.D0*DJ))
	ENDIF
	ENDDO
	ENDDO
	END





	SUBROUTINE LIB_TRANSREL_TBAK(TBAK,L)
***********************************************************
*  Builds transformation matrix which transforms          *
*  spinors of spherical harmonics to relativistic spinors *
***********************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 TBAK(2*(2*L+1),2*(2*L+1))
	REAL*8, ALLOCATABLE :: TREL(:,:)
	ALLOCATE(TREL(2*(2*L+1),2*(2*L+1)))
	CALL LIB_TRANSREL_LINP(TREL,L)
C Unitary matrix: reciprocal is equal to transposed.
	DO I=1,2*(2*L+1)
	DO J=1,2*(2*L+1)
	TBAK(I,J)=TREL(J,I)
	ENDDO
	ENDDO
	DEALLOCATE(TREL)
	END





	SUBROUTINE LIB_TRANSREL_LSCO(L)
***********************************************************
*  Check spin orbit coupling hamiltonian
*  spinors of spherical harmonics to relativistic spinors *
***********************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8, ALLOCATABLE :: TREL(:,:)
	REAL*8, ALLOCATABLE :: SLM(:,:,:)
	COMPLEX*16, ALLOCATABLE :: HMAT(:,:)
	COMPLEX*16, ALLOCATABLE :: EMAT(:,:)
C MEMORY ALLOCATIONS
	ALLOCATE(SLM(2*L+1,2,2))
	ALLOCATE(TREL(2*(2*L+1),2*(2*L+1)))
	ALLOCATE(HMAT(2*(2*L+1),2*(2*L+1)))
	ALLOCATE(EMAT(2*(2*L+1),2*(2*L+1)))
	CALL LIB_TRANSREL_LINP(TREL,L)
C SET <Ylm|s*l|Ylm>/2 MATRIX ELEMENT
	DO M=-L,L
	LM=L+M+1
	SLM(LM,1,1)=0.5D0*DBLE(+M)
	SLM(LM,1,2)=0.5D0*SQRT(DBLE((L+M)*(L-M+1)))
	SLM(LM,2,1)=0.5D0*SQRT(DBLE((L-M)*(L+M+1)))
	SLM(LM,2,2)=0.5D0*DBLE(-M)
	ENDDO
C Built spin orbit coupled hamiltonian
	DO M1=-L,L                                    !!! over m1
	LM1=L+M1+1
	DO M=-L,L                                     !!! over m
	LM=L+M+1
	DO IUPDN1=1,2                                 !!! over iupdn1
	LMS1=LM1+(2*L+1)*(IUPDN1-1)
	DO IUPDN =1,2                                 !!! over iupdn
	LMS =LM +(2*L+1)*(IUPDN -1)
	ISIGN=IUPDN1-IUPDN
	HMAT(LMS1,LMS)=0.D0
	IF(M1.EQ.M+ISIGN)
     &HMAT(LMS1,LMS)=HMAT(LMS1,LMS)+SLM(LM,IUPDN1,IUPDN)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C Check that Trel diagonalizes Hmat
C Emat should be diagonal with j=l+-1/2 sublevels
	DO I1=1,2*(2*L+1)
	DO I=1,2*(2*L+1)
	EMAT(I1,I)=0.D0
	DO LMS1=1,2*(2*L+1)
	DO LMS=1,2*(2*L+1)
	EMAT(I1,I)=EMAT(I1,I)+
     &TREL(I1,LMS1)*HMAT(LMS1,LMS)*TREL(I,LMS)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	DEALLOCATE(TREL,HMAT,EMAT)
	END






	SUBROUTINE LIB_TLEVCHAR(TLEV,THED)
**********************************************************
*  Sets level notations.                                 *
**********************************************************
	CHARACTER*19 TLEV(8,0:4,8),THED
	THED       ='Orbital   n  l  j  '
C N=1
	TLEV(1,0,1)=' 1s1/2    1  0  1/2'
C N=2
	TLEV(2,0,1)=' 2s1/2    2  0  1/2'
	TLEV(2,1,1)=' 2p1/2    2  1  1/2'
	TLEV(2,1,3)=' 2p3/2    2  1  3/2'
C N=3
	TLEV(3,0,1)=' 3s1/2    3  0  1/2' 
	TLEV(3,1,1)=' 3p1/2    3  1  1/2'
	TLEV(3,1,3)=' 3p3/2    3  1  3/2'
	TLEV(3,2,3)=' 3d3/2    3  2  3/2'
	TLEV(3,2,5)=' 3d5/2    3  2  5/2'
C N=4
	TLEV(4,0,1)=' 4s1/2    4  0  1/2'
	TLEV(4,1,1)=' 4p1/2    4  1  1/2'
	TLEV(4,1,3)=' 4p3/2    4  1  3/2'
	TLEV(4,2,3)=' 4d3/2    4  2  3/2'
	TLEV(4,2,5)=' 4d5/2    4  2  5/2'
	TLEV(4,3,5)=' 4f5/2    4  3  5/2'
	TLEV(4,3,7)=' 4f7/2    4  3  7/2'
C N=5
	TLEV(5,0,1)=' 5s1/2    5  0  1/2'
	TLEV(5,1,1)=' 5p1/2    5  1  1/2'
	TLEV(5,1,3)=' 5p3/2    5  1  3/2'
	TLEV(5,2,3)=' 5d3/2    5  2  3/2'
	TLEV(5,2,5)=' 5d5/2    5  2  5/2'
	TLEV(5,3,5)=' 5f5/2    5  3  5/2'
	TLEV(5,3,7)=' 5f7/2    5  3  7/2'
C N=6
	TLEV(6,0,1)=' 6s1/2    6  0  1/2'
	TLEV(6,1,1)=' 6p1/2    6  1  1/2'
	TLEV(6,1,3)=' 6p3/2    6  1  3/2'
	TLEV(6,2,3)=' 6d3/2    6  2  3/2'
	TLEV(6,2,5)=' 6d5/2    6  2  5/2'
	TLEV(6,3,5)=' 6f5/2    6  3  5/2'
	TLEV(6,3,7)=' 6f7/2    6  3  7/2'
C N=7
	TLEV(7,0,1)=' 7s1/2    7  0  1/2'
	TLEV(7,1,1)=' 7p1/2    7  1  1/2'
	TLEV(7,1,3)=' 7p3/2    7  1  3/2'
	TLEV(7,2,3)=' 7d3/2    7  2  3/2'
	TLEV(7,2,5)=' 7d5/2    7  2  5/2'
	TLEV(7,3,5)=' 7f5/2    7  3  5/2'
	TLEV(7,3,7)=' 7f7/2    7  3  7/2'
	END



	SUBROUTINE LIB_INTRELC(TRELC)
**************************************************************
*   Initializes character string.                            *
**************************************************************
	CHARACTER TRELC(-3:3,2,0:3)*10
	DO L=0,3
	DO I=1,2
	DO M=-3,3
	TRELC(M,I,L)='  error!  '
	ENDDO
	ENDDO
	ENDDO
C S-wave
      L=0
C     J=1/2
	TRELC( 0,1,L)=' -1/2(1/2)'
	TRELC( 0,2,L)=' +1/2(1/2)'
C P-wave
      L=1
C     J=1/2
	TRELC(-1,1,L)=' -1/2(1/2)'
	TRELC( 0,1,L)=' +1/2(1/2)'
C     J=3/2
	TRELC(+1,1,L)=' -3/2(3/2)'
	TRELC(-1,2,L)=' -1/2(3/2)'
	TRELC( 0,2,L)=' +1/2(3/2)'
	TRELC(+1,2,L)=' +3/2(3/2)'
C D-wave
      L=2
C     J=3/2
	TRELC(-2,1,L)=' -3/2(3/2)'
	TRELC(-1,1,L)=' -1/2(3/2)'
	TRELC( 0,1,L)=' +1/2(3/2)'
	TRELC(+1,1,L)=' +3/2(3/2)'
C     J=5/2
	TRELC(+2,1,L)=' -5/2(5/2)'
	TRELC(-2,2,L)=' -3/2(5/2)'
	TRELC(-1,2,L)=' -1/2(5/2)'
	TRELC( 0,2,L)=' +1/2(5/2)'
	TRELC(+1,2,L)=' +3/2(5/2)'
	TRELC(+2,2,L)=' +5/2(5/2)'
C F-wave
      L=3
C     J=5/2
	TRELC(-3,1,L)=' -5/2(5/2)'
	TRELC(-2,1,L)=' -3/2(5/2)'
	TRELC(-1,1,L)=' -1/2(5/2)'
	TRELC( 0,1,L)=' +1/2(5/2)'
	TRELC(+1,1,L)=' +3/2(5/2)'
	TRELC(+2,1,L)=' +5/2(5/2)'
C     J=7/2
	TRELC(+3,1,L)=' -7/2(7/2)'
	TRELC(-3,2,L)=' -5/2(7/2)'
	TRELC(-2,2,L)=' -3/2(7/2)'
	TRELC(-1,2,L)=' -1/2(7/2)'
	TRELC( 0,2,L)=' +1/2(7/2)'
	TRELC(+1,2,L)=' +3/2(7/2)'
	TRELC(+2,2,L)=' +5/2(7/2)'
	TRELC(+3,2,L)=' +7/2(7/2)'
	END
