      SUBROUTINE LIB_TRANSCUB(NDEGL,KSYSL,NDEGR,KSYSR,HMAT)
******************************************************************
*  Transforms matrix to cubic or spinor harmonics or vice versa  *      
******************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 HMAT(NDEGL,NDEGR)
      REAL*8, ALLOCATABLE :: TREL(:,:)
      REAL*8, ALLOCATABLE :: TRER(:,:)
      COMPLEX*16, ALLOCATABLE :: TMAT(:,:)
	COMPLEX*16 TC(-3:3,7,0:3),TS(7,-3:3,0:3)
      DATA PI/3.141592653589793D0/
C Cubic harmonics transformations
      IF(NDEGL.EQ.0.OR.NDEGR.EQ.0)RETURN
	CALL LIB_TRANSC(TC)
	CALL LIB_TRANSS(TS)
	LL=(NDEGL/2-1)/2
	LR=(NDEGR/2-1)/2
	IF(2*(2*LL+1).NE.NDEGL.AND.KSYSL.NE.0)
     &CALL FULLSTOP('<LIB_TRANSCUB>::2*(2*LL+1).NE.NDEGL')
	IF(2*(2*LR+1).NE.NDEGR.AND.KSYSR.NE.0)
     &CALL FULLSTOP('<LIB_TRANSCUB>::2*(2*LR+1).NE.NDEGR')
C Spinor transformations
	ALLOCATE(TREL(NDEGL,NDEGL))
	CALL LIB_TRANSREL_LINP(TREL,LL)
C Spinor transformations
	ALLOCATE(TRER(NDEGR,NDEGR))
	CALL LIB_TRANSREL_LINP(TRER,LR)
	ALLOCATE(TMAT(NDEGL,NDEGR))
C Left index - cubic to spherical harmonics
	IF(KSYSL.EQ.-1)THEN
	DO IDEGL=1,NDEGL
	DO IDEGR=1,NDEGR
	TMAT(IDEGL,IDEGR)=HMAT(IDEGL,IDEGR)
	ENDDO
	ENDDO
	M1S1=0
	DO ISPIN1=1,2
	DO M1=-LL,LL
	M1S1=M1S1+1
	DO IDEGR=1,NDEGR
	HMAT(M1S1,IDEGR)=(0.D0,0.D0)
	K1S1=0
	DO JSPIN1=1,2
	DO K1=-LL,LL
	K1S1=K1S1+1
	IF(ISPIN1.NE.JSPIN1)CYCLE
      HMAT(M1S1,IDEGR)=HMAT(M1S1,IDEGR)+
     &CONJG(TC(M1,K1+LL+1,LL))*TMAT(K1S1,IDEGR)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
      ENDIF
C Right index - cubic to spherical harmonics
	IF(KSYSR.EQ.-1)THEN
	DO IDEGL=1,NDEGL
	DO IDEGR=1,NDEGR
	TMAT(IDEGL,IDEGR)=HMAT(IDEGL,IDEGR)
	ENDDO
	ENDDO
	DO IDEGL=1,NDEGL
	MS=0
	DO ISPIN=1,2
	DO M =-LR,LR
	MS=MS+1
	HMAT(IDEGL,MS)=(0.D0,0.D0)
	KS=0
	DO JSPIN=1,2
	DO K =-LR,LR
	KS=KS+1
	IF(ISPIN.NE.JSPIN)CYCLE
      HMAT(IDEGL,MS)=HMAT(IDEGL,MS)+
     &TMAT(IDEGL,KS)*TC(M,K+LR+1,LR)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
      ENDIF
C Left index - spherical to cubic harmonics
	IF(KSYSL.EQ.+1)THEN
	DO IDEGL=1,NDEGL
	DO IDEGR=1,NDEGR
	TMAT(IDEGL,IDEGR)=HMAT(IDEGL,IDEGR)
	ENDDO
	ENDDO
	M1S1=0
	DO ISPIN1=1,2
	DO M1=-LL,LL
	M1S1=M1S1+1
	DO IDEGR=1,NDEGR
	HMAT(M1S1,IDEGR)=(0.D0,0.D0)
	K1S1=0
	DO JSPIN1=1,2
	DO K1=-LL,LL
	K1S1=K1S1+1
	IF(ISPIN1.NE.JSPIN1)CYCLE
      HMAT(M1S1,IDEGR)=HMAT(M1S1,IDEGR)+
     &CONJG(TS(M1+LL+1,K1,LL))*TMAT(K1S1,IDEGR)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
      ENDIF
C Right index - spherical to cubic harmonics
	IF(KSYSR.EQ.+1)THEN
	DO IDEGL=1,NDEGL
	DO IDEGR=1,NDEGR
	TMAT(IDEGL,IDEGR)=HMAT(IDEGL,IDEGR)
	ENDDO
	ENDDO
	DO IDEGL=1,NDEGL
	MS=0
	DO ISPIN=1,2
	DO M =-LR,LR
	MS=MS+1
	HMAT(IDEGL,MS)=(0.D0,0.D0)
	KS=0
	DO JSPIN=1,2
	DO K =-LR,LR
	KS=KS+1
	IF(ISPIN.NE.JSPIN)CYCLE
      HMAT(IDEGL,MS)=HMAT(IDEGL,MS)+
     &TMAT(IDEGL,KS)*TS(M+LR+1,K,LR)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
      ENDIF
C Left index - spherical to spherical harmonics
	IF(ABS(KSYSL).EQ.2)THEN
	DO IDEGL=1,NDEGL
	DO IDEGR=1,NDEGR
	HMAT(IDEGL,IDEGR)=HMAT(IDEGL,IDEGR)
	ENDDO
	ENDDO
      ENDIF
C Right index - spherical to spherical harmonics
	IF(ABS(KSYSR).EQ.2)THEN
	DO IDEGL=1,NDEGL
	DO IDEGR=1,NDEGR
	HMAT(IDEGL,IDEGR)=HMAT(IDEGL,IDEGR)
	ENDDO
	ENDDO
      ENDIF
C Left index - spinor to spherical harmonics
	IF(KSYSL.EQ.-3)THEN
	DO IDEGL=1,NDEGL
	DO IDEGR=1,NDEGR
	TMAT(IDEGL,IDEGR)=HMAT(IDEGL,IDEGR)
	ENDDO
	ENDDO
	DO IDEG1=1,NDEGL
	DO IDEG =1,NDEGR
	HMAT(IDEG1,IDEG)=(0.D0,0.D0)
	DO JDEG1=1,NDEGL  
	HMAT(IDEG1,IDEG)=HMAT(IDEG1,IDEG)+
     &TREL(JDEG1,IDEG1)*TMAT(JDEG1,IDEG)
	ENDDO
	ENDDO
	ENDDO
	ENDIF
C Right index - spinor to spherical harmonics
	IF(KSYSR.EQ.-3)THEN
	DO IDEGL=1,NDEGL
	DO IDEGR=1,NDEGR
	TMAT(IDEGL,IDEGR)=HMAT(IDEGL,IDEGR)
	ENDDO
	ENDDO
	DO IDEG1=1,NDEGL
	DO IDEG =1,NDEGR
	HMAT(IDEG1,IDEG)=0.D0
	DO JDEG =1,NDEGR
	HMAT(IDEG1,IDEG)=HMAT(IDEG1,IDEG)+
     &TMAT(IDEG1,JDEG)*TRER(JDEG,IDEG)
	ENDDO
	ENDDO
	ENDDO
	ENDIF
C Left index - spherical to spinor harmonics
	IF(KSYSL.EQ.+3)THEN
	DO IDEGL=1,NDEGL
	DO IDEGR=1,NDEGR
	TMAT(IDEGL,IDEGR)=HMAT(IDEGL,IDEGR)
	ENDDO
	ENDDO
	DO IDEG1=1,NDEGL
	DO IDEG =1,NDEGR
	HMAT(IDEG1,IDEG)=(0.D0,0.D0)
	DO JDEG1=1,NDEGL  
	HMAT(IDEG1,IDEG)=HMAT(IDEG1,IDEG)+
     &TREL(IDEG1,JDEG1)*TMAT(JDEG1,IDEG)
	ENDDO
	ENDDO
	ENDDO
	ENDIF
C Right index - spherical to spinor harmonics
	IF(KSYSR.EQ.+3)THEN
	DO IDEGL=1,NDEGL
	DO IDEGR=1,NDEGR
	TMAT(IDEGL,IDEGR)=HMAT(IDEGL,IDEGR)
	ENDDO
	ENDDO
	DO IDEG1=1,NDEGL
	DO IDEG =1,NDEGR
	HMAT(IDEG1,IDEG)=0.D0
	DO JDEG =1,NDEGR
	HMAT(IDEG1,IDEG)=HMAT(IDEG1,IDEG)+
     &TMAT(IDEG1,JDEG)*TRER(IDEG,JDEG)
	ENDDO
	ENDDO
	ENDDO
	ENDIF
	IF(ABS(KSYSL).GT.3.OR.KSYSR.GT.3)
     &CALL FULLSTOP('<LIB_TRANSCUB>:: Transformation not ready')
	DEALLOCATE(TMAT,TREL,TRER)
      END
      
      
      
      SUBROUTINE LIB_TRANSMAT(NDEGL,KSYSL,NDEGR,KSYSR,HMAT,OMAT,EMAT)
******************************************************************
*  Transforms matrix to cubic or spinor harmonics or vice versa  *      
******************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 HMAT(NDEGL,NDEGR),OMAT(NDEGL,NDEGR),EMAT(NDEGL,NDEGR)
      COMPLEX*16, ALLOCATABLE :: TMAT(:,:)
C Standard transformation
      IF(ABS(KSYSL).LE.3.AND.ABS(KSYSR).LE.3)THEN
      CALL LIB_TRANSCUB(NDEGL,KSYSL,NDEGR,KSYSR,HMAT)
      ELSEIF(ABS(KSYSL).GT.3.AND.ABS(KSYSR).GT.3)THEN
C Custom transformation
	ALLOCATE(TMAT(NDEGL,NDEGR))
C Left index - custom to spherical
	IF(KSYSL.LT.0)THEN
	DO IDEGL=1,NDEGL
	DO IDEGR=1,NDEGR
	TMAT(IDEGL,IDEGR)=HMAT(IDEGL,IDEGR)
	ENDDO
	ENDDO
	DO IDEG1=1,NDEGL
	DO IDEG =1,NDEGR
	HMAT(IDEG1,IDEG)=(0.D0,0.D0)
	DO JDEG1=1,NDEGL  
	HMAT(IDEG1,IDEG)=HMAT(IDEG1,IDEG)+
     &DCONJG(EMAT(IDEG1,JDEG1))*TMAT(JDEG1,IDEG)
	ENDDO
	ENDDO
	ENDDO
	ENDIF
C Right index - custom to spherical harmonics
	IF(KSYSR.LT.0)THEN
	DO IDEGL=1,NDEGL
	DO IDEGR=1,NDEGR
	TMAT(IDEGL,IDEGR)=HMAT(IDEGL,IDEGR)
	ENDDO
	ENDDO
	DO IDEG1=1,NDEGL
	DO IDEG =1,NDEGR
	HMAT(IDEG1,IDEG)=0.D0
	DO JDEG =1,NDEGR
	HMAT(IDEG1,IDEG)=HMAT(IDEG1,IDEG)+
     &TMAT(IDEG1,JDEG)*EMAT(IDEG,JDEG)
	ENDDO
	ENDDO
	ENDDO
	ENDIF
C Left index - spherical to custom
	IF(KSYSL.GT.0)THEN
	DO IDEGL=1,NDEGL
	DO IDEGR=1,NDEGR
	TMAT(IDEGL,IDEGR)=HMAT(IDEGL,IDEGR)
	ENDDO
	ENDDO
	DO IDEG1=1,NDEGL
	DO IDEG =1,NDEGR
	HMAT(IDEG1,IDEG)=(0.D0,0.D0)
	DO JDEG1=1,NDEGL  
	HMAT(IDEG1,IDEG)=HMAT(IDEG1,IDEG)+
     &DCONJG(OMAT(JDEG1,IDEG1))*TMAT(JDEG1,IDEG)
	ENDDO
	ENDDO
	ENDDO
	ENDIF
C Right index - spherical to custom
	IF(KSYSR.GT.0)THEN
	DO IDEGL=1,NDEGL
	DO IDEGR=1,NDEGR
	TMAT(IDEGL,IDEGR)=HMAT(IDEGL,IDEGR)
	ENDDO
	ENDDO
	DO IDEG1=1,NDEGL
	DO IDEG =1,NDEGR
	HMAT(IDEG1,IDEG)=0.D0
	DO JDEG =1,NDEGR
	HMAT(IDEG1,IDEG)=HMAT(IDEG1,IDEG)+
     &TMAT(IDEG1,JDEG)*OMAT(JDEG,IDEG)
	ENDDO
	ENDDO
	ENDDO
	ENDIF
      DEALLOCATE(TMAT)
      ELSE
      CALL FULLSTOP('<LIB_TRANSMAT>:: Wrong Transformation')
      ENDIF
      END
      
      
      SUBROUTINE LIB_TRANSMAT3L(NDEGL,KSYSL,NDEGR,KSYSR,HMAT,
     &                          OMAT,EMAT,NL)
******************************************************************
*  Transforms matrix to cubic or spinor harmonics or vice versa  *      
******************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 HMAT(NL,NDEGL,NDEGR),OMAT(NDEGL,NDEGR),
     &           EMAT(NDEGL,NDEGR)
      COMPLEX*16, ALLOCATABLE :: TMAT(:,:)
      ALLOCATE(TMAT(NDEGL,NDEGR))
      DO IL=1,NL
	DO IDEG1=1,NDEGL
	DO IDEG =1,NDEGR
	TMAT(IDEG1,IDEG)=HMAT(IL,IDEG1,IDEG)
      ENDDO
      ENDDO
      CALL LIB_TRANSMAT(NDEGL,KSYSL,NDEGR,KSYSR,TMAT,OMAT,EMAT)
	DO IDEG1=1,NDEGL
	DO IDEG =1,NDEGR
	HMAT(IL,IDEG1,IDEG)=TMAT(IDEG1,IDEG)
      ENDDO
      ENDDO
      ENDDO
      DEALLOCATE(TMAT)
      END
      
      
      SUBROUTINE LIB_TRANSMAT3R(NDEGL,KSYSL,NDEGR,KSYSR,HMAT,
     &                          OMAT,EMAT,NR)
******************************************************************
*  Transforms matrix to cubic or spinor harmonics or vice versa  *      
******************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 HMAT(NDEGL,NDEGR,NR),OMAT(NDEGL,NDEGR),
     &           EMAT(NDEGL,NDEGR)
      COMPLEX*16, ALLOCATABLE :: TMAT(:,:)
      ALLOCATE(TMAT(NDEGL,NDEGR))
      DO IR=1,NR
	DO IDEG1=1,NDEGL
	DO IDEG =1,NDEGR
	TMAT(IDEG1,IDEG)=HMAT(IDEG1,IDEG,IR)
      ENDDO
      ENDDO
      CALL LIB_TRANSMAT(NDEGL,KSYSL,NDEGR,KSYSR,TMAT,OMAT,EMAT)
	DO IDEG1=1,NDEGL
	DO IDEG =1,NDEGR
	HMAT(IDEG1,IDEG,IR)=TMAT(IDEG1,IDEG)
      ENDDO
      ENDDO
      ENDDO
      DEALLOCATE(TMAT)
      END



      SUBROUTINE LIB_TRANSCUB3L(NDEGL,KSYSL,NDEGR,KSYSR,HMAT,NL)
******************************************************************
*  Transforms matrix to cubic or spinor harmonics or vice versa  *      
******************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 HMAT(NL,NDEGL,NDEGR)
      COMPLEX*16, ALLOCATABLE :: TMAT(:,:)
      ALLOCATE(TMAT(NDEGL,NDEGR))
      DO IL=1,NL
	DO IDEG1=1,NDEGL
	DO IDEG =1,NDEGR
	TMAT(IDEG1,IDEG)=HMAT(IL,IDEG1,IDEG)
      ENDDO
      ENDDO
      CALL LIB_TRANSCUB(NDEGL,KSYSL,NDEGR,KSYSR,TMAT)
	DO IDEG1=1,NDEGL
	DO IDEG =1,NDEGR
	HMAT(IL,IDEG1,IDEG)=TMAT(IDEG1,IDEG)
      ENDDO
      ENDDO
      ENDDO
      DEALLOCATE(TMAT)
      END


      
      SUBROUTINE LIB_TRANSCUB3R(NDEGL,KSYSL,NDEGR,KSYSR,HMAT,NR)
******************************************************************
*  Transforms matrix to cubic or spinor harmonics or vice versa  *      
******************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 HMAT(NDEGL,NDEGR,NR)
      COMPLEX*16, ALLOCATABLE :: TMAT(:,:)
      ALLOCATE(TMAT(NDEGL,NDEGR))
      DO IR=1,NR
	DO IDEG1=1,NDEGL
	DO IDEG =1,NDEGR
	TMAT(IDEG1,IDEG)=HMAT(IDEG1,IDEG,IR)
      ENDDO
      ENDDO
      CALL LIB_TRANSCUB(NDEGL,KSYSL,NDEGR,KSYSR,TMAT)
	DO IDEG1=1,NDEGL
	DO IDEG =1,NDEGR
	HMAT(IDEG1,IDEG,IR)=TMAT(IDEG1,IDEG)
      ENDDO
      ENDDO
      ENDDO
      DEALLOCATE(TMAT)
      END




      SUBROUTINE LIB_TRANSMAT6L(NDEGL,NDIML,KSYSL,NDEGR,NDIMR,KSYSR,
     &                          HMAT,OMAT,EMAT,NL)
******************************************************************
*  Transforms matrix to cubic or spinor harmonics or vice versa  *      
******************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 HMAT(NL,NDIML,NDIMR),OMAT(NDEGL,NDEGR),
     &           EMAT(NDEGL,NDEGR)
      COMPLEX*16, ALLOCATABLE :: TMAT(:,:)
      ALLOCATE(TMAT(NDEGL,NDEGR))
      DO IL=1,NL
	DO IDEG1=1,NDEGL
	DO IDEG =1,NDEGR
	TMAT(IDEG1,IDEG)=HMAT(IL,IDEG1,IDEG)
      ENDDO
      ENDDO
      CALL LIB_TRANSMAT(NDEGL,KSYSL,NDEGR,KSYSR,TMAT,OMAT,EMAT)
	DO IDEG1=1,NDEGL
	DO IDEG =1,NDEGR
	HMAT(IL,IDEG1,IDEG)=TMAT(IDEG1,IDEG)
      ENDDO
      ENDDO
      ENDDO
      DEALLOCATE(TMAT)
      END
      
      
      SUBROUTINE LIB_TRANSMAT6R(NDEGL,NDIML,KSYSL,NDEGR,NDIMR,KSYSR,
     &                          HMAT,OMAT,EMAT,NR)
******************************************************************
*  Transforms matrix to cubic or spinor harmonics or vice versa  *      
******************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 HMAT(NDIML,NDIMR,NR),OMAT(NDEGL,NDEGR),
     &           EMAT(NDEGL,NDEGR)
      COMPLEX*16, ALLOCATABLE :: TMAT(:,:)
      ALLOCATE(TMAT(NDEGL,NDEGR))
      DO IR=1,NR
	DO IDEG1=1,NDEGL
	DO IDEG =1,NDEGR
	TMAT(IDEG1,IDEG)=HMAT(IDEG1,IDEG,IR)
      ENDDO
      ENDDO
      CALL LIB_TRANSMAT(NDEGL,KSYSL,NDEGR,KSYSR,TMAT,OMAT,EMAT)
	DO IDEG1=1,NDEGL
	DO IDEG =1,NDEGR
	HMAT(IDEG1,IDEG,IR)=TMAT(IDEG1,IDEG)
      ENDDO
      ENDDO
      ENDDO
      DEALLOCATE(TMAT)
      END



      SUBROUTINE LIB_TRANSCUB6L(NDEGL,NDIML,KSYSL,NDEGR,NDIMR,KSYSR,
     &           HMAT,NL)
******************************************************************
*  Transforms matrix to cubic or spinor harmonics or vice versa  *      
******************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 HMAT(NL,NDIML,NDIMR)
      COMPLEX*16, ALLOCATABLE :: TMAT(:,:)
      ALLOCATE(TMAT(NDEGL,NDEGR))
      DO IL=1,NL
	DO IDEG1=1,NDEGL
	DO IDEG =1,NDEGR
	TMAT(IDEG1,IDEG)=HMAT(IL,IDEG1,IDEG)
      ENDDO
      ENDDO
      CALL LIB_TRANSCUB(NDEGL,KSYSL,NDEGR,KSYSR,TMAT)
	DO IDEG1=1,NDEGL
	DO IDEG =1,NDEGR
	HMAT(IL,IDEG1,IDEG)=TMAT(IDEG1,IDEG)
      ENDDO
      ENDDO
      ENDDO
      DEALLOCATE(TMAT)
      END


      
      SUBROUTINE LIB_TRANSCUB6R(NDEGL,NDIML,KSYSL,NDEGR,NDIMR,KSYSR,
     &           HMAT,NR)
******************************************************************
*  Transforms matrix to cubic or spinor harmonics or vice versa  *      
******************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 HMAT(NDIML,NDIMR,NR)
      COMPLEX*16, ALLOCATABLE :: TMAT(:,:)
      ALLOCATE(TMAT(NDEGL,NDEGR))
      DO IR=1,NR
	DO IDEG1=1,NDEGL
	DO IDEG =1,NDEGR
	TMAT(IDEG1,IDEG)=HMAT(IDEG1,IDEG,IR)
      ENDDO
      ENDDO
      CALL LIB_TRANSCUB(NDEGL,KSYSL,NDEGR,KSYSR,TMAT)
	DO IDEG1=1,NDEGL
	DO IDEG =1,NDEGR
	HMAT(IDEG1,IDEG,IR)=TMAT(IDEG1,IDEG)
      ENDDO
      ENDDO
      ENDDO
      DEALLOCATE(TMAT)
      END
