 	SUBROUTINE MAN_ATOMS
************************************************************
*  THE MAIN MODULE CONTROLLING ATOMIC SPECTRA CALCULATIONS *
************************************************************
      USE COM_RATPAR, ONLY: MODR
      USE COM_RATOUT, ONLY: ICGRF
C READ ALL INPUT FILES
 	CALL RAT_INIT
C Memory Allocations
      CALL RAT_ALLOCATE('A')
C **********************************************************
C SELF-CONSISTENT CHARGE DENSITY FOR ATOMIC PROBLEM
      IF(MODR/10.EQ.1)CALL RAT_RATSCF
C **********************************************************
C MANY BODY CALCULATIONS OF ATOMIC SPECTRA
      IF(MODR/10.EQ.2)CALL RAT_SHELLS
C **********************************************************
C EXACT DIAGONALIZATION FOR CLUSTERS BY BLOCKS
      IF(MODR/10.EQ.3)CALL RAT_CLSSAV
C **********************************************************
C EXACT DIAGONALIZATION FOR CLUSTERS (Yin Quan version)
      IF(MODR/10.EQ.4)CALL RAT_CLSYIN
C **********************************************************
C EXACT DIAGONALIZATION FOR CLUSTERS (Alexei Gordienko version)
      IF(MODR/10.EQ.5)CALL RAT_CLSGOR
C **********************************************************
C Rational Interpolation for self energy
	IF(ICGRF.GT.0  )CALL IMP_SIGRAT
C **********************************************************
C Stores Cluster Green function and Self-energy
	IF(ICGRF.GT.0  )CALL RAT_SETGRF
C **********************************************************
C Memory deallocations
      CALL RAT_ALLOCATE('D')
      CALL MAN_ARTOUT('<Atoms> stopped')
 	END
