	SUBROUTINE MAN_LMTSETUP
*************************************************************
*  Sets up default control parameters, variables, etc.      *
*************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
C Memory controls
      USE COM_LMTMEM  ,ONLY:  CURMEM,TOTMEM                    !!! from setup
C All files
      USE COM_LMTINP
	USE COM_EXTENS 
	USE COM_LMTOUT
C Outputs
      USE COM_MASHDEP ,ONLY:  EPSMAS,NVAL,LENREL,LENINT,LENCMP !!! from setup
      USE COM_LABELS  ,ONLY:  TXTSP,PATHSCRT,NAMESTRC,ELEMENT  !!! from setup
     &                       ,NAMEDENS,NAMEATOM,NAMELMTO 
      USE COM_UNIT    ,ONLY:  IUN,IUT,IUR,IUI                  !!! from setup
C SET LOCAL VARIBLES
	IMPLICIT REAL*8 (A-H,O-Z)
	CHARACTER*2 ELEM(0:104)
C SET PERIODIC TABLE DATA
      DATA ELEM/'e '
     &          ,'h ','he','li','be','b ','c ','n ','o ','f ','ne'
     &          ,'na','mg','al','si','p ','s ','cl','ar','k ','ca'
     &          ,'sc','ti','v ','cr','mn','fe','co','ni','cu','zn'
     &          ,'ga','ge','as','se','br','kr','rb','sr','y ','zr'
     &          ,'nb','mo','tc','ru','rh','pd','ag','cd','in','sn'
     &          ,'sb','te','i ','xe','cs','ba','la','ce','pr','nd'
     &          ,'pm','sm','eu','gd','tb','dy','ho','er','tm','yb'
     &          ,'lu','hf','ta','w ','re','os','ir','pt','au','hg'
     &          ,'tl','pb','bi','po','at','rn','fr','ra','ac','th'
     &          ,'pa','u ','np','pu','am','cm','bk','cf','es','fm'
     &          ,'md','no','lw','??'/
C DIFFERENT INITIALIZATIONS FOR PROGRAM:
      TXTSP(1)='up'   ! UP spin label
      TXTSP(2)='dn'   ! DOWN spin label
	DO IEL=0,104    ! Load elements names
	ELEMENT(IEL)=ELEM(IEL)
	ENDDO
C INITIALIZE MAIN PARAMETERS OF THE ARRAYS
	NATOMMEM=0   !!! current # of atoms
	NSORTMEM=0   !!! current # of sorts
	NSPINMEM=0   !!! current # of spins
	NORBSMEM=0   !!! current # of LS's
	LMAXVMEM=0   !!! current # of IlsV
	LMAXBMEM=0   !!! current # of Ilsb
	LMAXTMEM=0   !!! current # of IlsT 
	LMAXCMEM=0   !!! current # of max(ilsB,ilsT,ilsV)
	LIMDTMEM=0   !!! current # of connections t'-t
	NKAPMEM=0    !!! current # of kappas
	NPANMEM=0    !!! current # of panels
	NDIMMEM=0    !!! current dimension
	NGGAMEM=0    !!! current GGA or LDA
C  PLANE WAVE DATA PARAMETERS 
	NPLWMEM=0    !!! current # of plane waves
	NFFTMEM=0    !!! current # of FFT points
	NBASMEM=0    !!! current # of plane waves
	MBASMEM=0    !!! current # of plane waves
C  OTHER PARAMETERS
	NPNTMEM=0    !!! current # of k-points
	NRADMEM=0    !!! current # of radial points
	NRATMEM=0    !!! current # of radial points for atoms
	NLIBMEM=0    !!! current # of Liberman points
	NSYMMEM=0    !!! current # of sph-harmonics
	NOPRMEM=0    !!! current # of group operations
	NENVMEM=0    !!! current # of nearest neighbors
	NSHLMEM=0    !!! current # of n.n shells
	NLENMEM=0    !!! current size of Broyden array
	NTERMEM=0    !!! current # of Broyden iterations
	NPNWMEM=0    !!! current # of k-points for weights
	NOMGMEM=0    !!! current # of frequencies
	NCHIMEM=0    !!! TB-susceptibility dimension
	NMSCMEM=0    !!! # of Matsubara frequencies, log grid
	NCNFMEM=0    !!! # of configurations in Impurity site
	NPOLMEM=0    !!! # of poles in rational interpolation
C  LM-COMBINATIONS
	LIMVMEM=(LMAXVMEM+1)**2
	LIMBMEM=(LMAXBMEM+1)**2
	LIMTMEM=(LMAXTMEM+1)**2
	LIMCMEM=(LMAXCMEM+1)**2
	LIMV1MEM=(LMAXVMEM+2)**2
	LIMB1MEM=(LMAXBMEM+2)**2
	LIMT1MEM=(LMAXTMEM+2)**2
	LIMC1MEM=(LMAXCMEM+2)**2
	LIMV2MEM=(LMAXVMEM+1)*(2*LMAXVMEM+1)*(2*LMAXVMEM+3)/3
	LIMB2MEM=(LMAXBMEM+1)*(2*LMAXBMEM+1)*(2*LMAXBMEM+3)/3
	LIMT2MEM=(LMAXTMEM+1)*(2*LMAXTMEM+1)*(2*LMAXTMEM+3)/3
	LIMC2MEM=(LMAXCMEM+1)*(2*LMAXCMEM+1)*(2*LMAXCMEM+3)/3
	NWIGMEM=(LMAXTMEM+1)*(2*LMAXTMEM+1)*(2*LMAXTMEM+3)/3
C DATA DEPENDING ON THE COMPUTER:
C 1) Record lenght value for unformatted output
	NVAL=16         ! IBM RISC value
*     NVAL=4          ! DEC VAX  value 
*     NVAL=16         ! CRAY value 
*     NVAL=16         ! MS-DOS FTN77/486 value
C 2) Mashine accuracy
      DO I=-25,1
      SMALL=10.D0**I
      IF(1.D0+SMALL.NE.1.D0)EXIT
      ENDDO
      EPSMAS=SMALL
C 3) Lenghts of integers/reals/complexs
	LENREL=8        ! real double precision
	LENINT=4        ! integer single precision
	LENCMP=16       ! complex double precision
C DEFAULT OUTPUT CHANNELS
	IUT=6           ! default printing-to-terminal channel
      IUR=5           ! default reading-from-terminal channel
      IUI=5           ! standard channel for terminal reading
	IUN=6           ! standard channel for terminal printing
C PATHES
	PATHSCRT='./'                  ! scratch files
C	PATHSCRT='/user/savrasov/scratch/'! scratch files
C FILE NAMES
	CTRFILE='terminal'                     ! terminal input
	LOGFILE='terminal'                     ! terminal errors
	ABRFILE='abortnow'                     ! aborting flag
        NAMEDENS='/home/haule/realMaterial/data/atomdat/den.' ! atomic density data
        NAMEATOM='/home/haule/realMaterial/data/atomdat/rat.' ! input atomic files
        NAMESTRC='/home/haule/realMaterial/data/atomdat/str.' ! structure files
        NAMELMTO='/home/haule/realMaterial/data/atomdat/lmt.' ! LMTO atom files
C	NAMEDENS='D:\MStudio MindLab\Atomdat\den.' ! atomic density data
C	NAMEATOM='D:\MStudio MindLab\Atomdat\rat.' ! input atomic files
C	NAMESTRC='D:\MStudio MindLab\Atomdat\str.' ! structure files
C	NAMELMTO='D:\MStudio MindLab\Atomdat\lmt.' ! LMTO atom files
C	NAMEDENS='/user/savrasov/atomdat/den.' ! atomic density data
C	NAMEATOM='/user/savrasov/atomdat/rat.' ! input atomic files
C	NAMESTRC='/user/savrasov/atomdat/str.' ! structure files
C	NAMELMTO='/user/savrasov/atomdat/lmt.' ! LMTO atom files
C DEFAULT EXTENSIONS
	LENEXTN=3       ! # of characters
C Controls
	EXTNCTR='ctr'   ! CtrFile: Controls input
	EXTNLOG='log'   ! LogFile: Controls output
	EXTNABR='abr'   ! AbrFile: Controls termination
	EXTNINF='inf'   ! InfFile: Information
C Inputs
	EXTNINI='ini'   ! IniFile: Input control and atomic data
	EXTNSCS='scs'   ! ScsFile: Input charge density
	EXTNSTR='str'   ! StrFile: Input structure data
	EXTNHOP='hop'   ! HopFile: Input hopiings
	EXTNHUB='hub'   ! HubFile: Input Hubbard parameters
	EXTNPNT='pnt'   ! PntFile: Input list of q-points
	EXTNKOV='kov'   ! KovFile: Group symmetry
	EXTNENR='enr'   ! EnrFile: Input energies
C Outputs
	EXTNCON='con'   ! ConFile: Bare Structure constants
	EXTNFTR='ftr'   ! FtrFile: Screened structure constants
	EXTNATM='atm'   ! AtmFile: Atoms & Structure
	EXTNGRP='grp'   ! GrpFile: Crystal group elements
	EXTNPSI='psi'   ! PsiFile: Wave functions
	EXTNPSK='psk'   ! PskFile: Wave functions
	EXTNTMP='tmp'   ! TmpFile: Temporary storage
	EXTNBND='bnd'   ! BndFile: Energy bands
	EXTNFRS='frs'   ! FrsFile: Fermi Surface
	EXTNPOT='pot'   ! PotFile: Full potential
	EXTNFAT='fat'   ! FatFile: Fat bands
	EXTNDOS='dos'   ! DosFile: Density of states
	EXTNGRF='grf'   ! GrfFile: Greens function in DMFT
	EXTNHYB='hyb'   ! HybFile: Hybridization function in DMFT
	EXTNSCF='scf'   ! ScfFile: Output charge density
	EXTNHBR='hbr'   ! HbrFile: Output Hubbard parameters
	EXTNHPP='hpp'   ! HppFile: Output Hoppings
	EXTNOUT='out'   ! OutFile: Current output
	EXTNOPT='opt'   ! OptFile: Optical properties
	EXTNODF='odf'   ! OdfFile: Optical properties using input Sigma(w)
	EXTNCHI='chi'   ! ChiFile: susceptibility
	EXTNSCR='scr'   ! ScrFile: Scratch storage
	EXTNSCN='scn'   ! ScnFile: Scratch storage
	EXTNSCP='scp'   ! ScpFile: Scratch storage
C NULLIFY MEMORY
	CURMEM=0.D0     ! current memory used
	TOTMEM=0.D0     ! total memory used 
	END
