	SUBROUTINE MAN_PHONONS
************************************************************
*   The calculation of the phonon spectrum.                * 
*   Written by S.Yu.Savrasov                               *
************************************************************
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,IDMF,MODE                        !!! from readini
      USE COM_PHNCOM,  ONLY : ITERMAX,NITER                              !!! from readini
      USE COM_LRTCOM,  ONLY : QVECTOR                                    !!! from readini
	USE COM_QMESH,   ONLY : NQPNT,QPNT                                 !!! from readpnt
      USE COM_MSBMESH ,ONLY : TEMP,NMSC                                  !!! from readhub
      USE COM_NBANDS  ,ONLY : NBNDF,NBNDE,NBNDT,NBNDC                    !!! from readini
      USE COM_FERMI   ,ONLY : EF,ZDFT,ZBND,KFRM                          !!! from ttrints
	USE COM_CHANNELS,ONLY : IUSCF,IUPOT                                !!! from channels
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	CHARACTER ST*8,FN*8,PROGN*8,POL(-1:1)*3
	LOGICAL EXIT
	DATA ST/'started'/,FN/'finished'/,POL/'"M"','"0"','"P"'/
C  REAL ALL INPUT DATA
	CALL PHN_INIT
C CALCULATE STRUCTURE CONSTANTS
	progn='StrMsh  '
	call lib_timel(times)
	write(iun,1110)progn,st,times,curmem,totmem
	CALL STR_VECGEN     !!! generate structure vectors
	CALL STR_STRSNG     !!! check for singularities
	CALL STR_STRMSH     !!! calculate structure constants
	call lib_timel(timef)
	write(iun,1120)progn,fn,timef,curmem,totmem
C CALCULATE SCREENED STRUCTURE CONSTANTS
	progn='ScrCon  '
      call lib_timel(times)
      write(iun,1110)progn,st,times,curmem,totmem
      CALL HOP_ALPCON     !!! get screening parameters "alpha"
      call lib_timel(timef)
      write(iun,1120)progn,fn,timef,curmem,totmem
C  SELECT Q-VECTOR
	READ(QVECTOR,*)IQPNT
C  PREPARE DATA WHICH DEPEND ON THE CRYSTALLINE STRUCTURE
	progn='DelStr  '
	call lib_timel(times)
	write(iun,1110)progn,st,times,curmem,totmem
	CALL CHI_DELMSH(IQPNT)         !!! analisys of coarse k-mesh in IBZ
      CALL CHI_DELMSW(IQPNT)         !!! analisys of dense  k-mesh in IBZ
	CALL PHN_SYMNUC(IQPNT)         !!! symmetry of the phonon modes
	CALL PHN_QTASKS(IQPNT)         !!! phonon modes tasks
	call lib_timel(timef)
	write(iun,1120)progn,fn,timef,curmem,totmem
	IF(LIFT.LE.1)CALL MAN_ARTOUT('No band structure calculation')
	CALL RHO_RHOFILES(IUSCF,'R','A')! read charge density
C  CALCULATE MULTIPOLE FIELD
	CALL POT_MULTRHO    !!! calculate moments of (pseudo)density
	CALL POT_MULTFTR    !!! multipoles as lattice sums
	CALL POT_MULTASA    !!! multipoles as lattice sums
	CALL POT_PRINTC(1)  !!! save input charge for printing
C  CALCULATE FULL POTENTIAL
	progn='FulPot  '
	CALL POT_POTFILES(IUPOT,'!','A')! initialize full potential
	call lib_timel(times)
	write(iun,1110)progn,st,times,curmem,totmem
	CALL POT_VCOUL      !!! calculate Coulomb potential within MT-spheres
	CALL POT_VEXCH(1)   !!! calculate ex.-cor.potential within MT-spheres
	CALL POT_VCFTR      !!! calculate Coulomb potential in the int.region
	CALL POT_VXFTR(1)   !!! calculate ex.-cor.potential in the int.region
	CALL POT_ZEROV      !!! set up energy zero
	CALL POT_VPINT      !!! calculate convolutions of pseudopotential
	CALL POT_PRINT2     !!! print necessary information
      CALL HUB_HUBPOT     !!! adds Hubbard correction to the potential
      CALL HUB_WRITEHUB_DATA(IUN,2)  !!! print Hubbard correction
      CALL HUB_WRITEHUB_DATA(IUN,3)  !!! print Double Counting correction
      CALL HUB_WRITEHUB_DATA(IUN,4)  !!! print Constrained potential
	call lib_timel(timef)
	write(iun,1120)progn,fn,timef,curmem,totmem
	CALL RHO_RHOFILES(IUSCF,'!','D')! deallocate charge density
C  CALCULATE BAND STRUCTURE
	progn='Bands   '
	call lib_timel(times)
	write(iun,1110)progn,st,times,curmem,totmem
	CALL BND_LMTDFT         !!! find band energies and eigenvectors
	call lib_timel(timef)
	write(iun,1120)progn,fn,timef,curmem,totmem
C CALCULATE GREEN FUNCTION WITH DMFT
      progn='DMFT    '
      call lib_timel(times)
      write(iun,1110)progn,st,times,curmem,totmem
      CALL DMF_LMTRAT         !!! find Sigma using rational interpolation
      call lib_timel(timef)
      write(iun,1120)progn,fn,timef,curmem,totmem
	IF(LIFT.LE.2)CALL MAN_ARTOUT('No Phonon Spectrum Calculation')
C CALCULATE FULL VALENCE PLUS SEMICORE DENSITY IN UNIT-CELL
	progn='FullRHO '
	call lib_timel(times)
	write(iun,1110)progn,st,times,curmem,totmem
	CALL RHO_RHOFUL     !!! find new valence charge density within MTS
	CALL RHO_RENROV     !!! renormalize valence density
	call lib_timel(timef)
	write(iun,1120)progn,fn,timef,curmem,totmem
C CALCULATE DEEP CORE
	progn='RenCOR  '
	call lib_timel(times)
	write(iun,1110)progn,st,times,curmem,totmem
	CALL RHO_RENCOR     !!! find core charge density destribution in cell
	call lib_timel(timef)
	write(iun,1120)progn,fn,timef,curmem,totmem
C  DO NOT RELOAD DENSITY, IT NEEDS TO BE CONSISTENT WITH CURRENT EIGENVECTORS
C     CALL RHO_RHOFILES(IUSCF,'!','D')! deallocate charge density
C	CALL INI_READSCF                ! 
C	CALL RHO_RHOFILES(IUSCF,'R','A')! read charge density
C  FIND FERMI LEVEL
	IF(IDMF.EQ.0.OR.IDMF.EQ.1.OR.IDMF.EQ.2)
     &CALL BND_FNDFRM(EF,ZDFT,EF,100,1.D-09,0.8D0)! search for Fermi energy
	IF(IDMF.EQ.3.AND.KFRM.EQ.0)
     &CALL DMF_FRMFND(EF,ZDFT,EF,0,100,1.D-05,0.8D0)
	IF(IDMF.EQ.4.AND.KFRM.EQ.0)
     &CALL DMF_FNDFRM(EF,ZDFT,EF,NMSC+1,100,1.D-05,0.8D0)
	IF(IDMF.EQ.4.AND.KFRM.EQ.1)
     &CALL DMF_FNDFRM(EF,ZBND,EF,NMSC+1,100,1.D-05,0.8D0)
	IF(IDMF.EQ.5.AND.KFRM.EQ.0)
     &CALL DMF_FRMFND(EF,ZDFT,EF,0,100,1.D-05,0.8D0)
C REDEFINE BANDS CROSSING EF
      IF(MODE.NE.5)THEN
      CALL CHI_LRCHI(EF,MBNDF,MBNDE,MBNDC)      !!! bands crossing Ef +/- window
      NF=NBNDF(1)
      NE=NBNDE(1)
      NC=NBNDC(1)
	NBNDF(1)=MBNDF
	NBNDE(1)=MBNDE
	NBNDC(1)=MBNDC
	ENDIF
C  PREPARE TETRAHEDRON WEIGHTS
	progn='ChiTet  '
	call lib_timel(times)
	write(iun,1110)progn,st,times,curmem,totmem
	CALL PHN_DELTET(IQPNT)         !!! k-point tetrahedron weights 
	CALL PHN_EPITET(IQPNT)         !!! + weights for el.ph.int.
	call lib_timel(timef)
	write(iun,1120)progn,fn,timef,curmem,totmem
	IF(LIFT.LE.3)CALL MAN_ARTOUT('No SCF-loop')
C  CALCULATE POLARIZABILITY FUNCTION
	progn='PolarZ  '
	call lib_timel(times)
	write(iun,1110)progn,st,times,curmem,totmem
	CALL PLZ_PLZFILES(0,0,0,' ','A')!! allocate polarizability in MTS
	CALL PLZ_PLSFILES(0,0,0,' ','A')!! allocate pseudopolarizability
	CALL PLZ_PLWCRD(IQPNT)         !!! set G-vectors for pi(r,q+G)
      CALL PLZ_POLARZ(IQPNT)         !!! polarizability pi(r,q+G) [G input]
      CALL PLZ_PLZMAT(IQPNT)         !!! matrix in plane-wave representation
      CALL PLZ_SCREEN(IQPNT)         !!! inverse dielectric matrix
	CALL PLZ_PLZFILES(0,0,0,' ','D')!! deallocate polarizability in MTS
	CALL PLZ_PLSFILES(0,0,0,' ','D')!! deallocate pseudopolarizability
	call lib_timel(timef)
	write(iun,1120)progn,fn,timef,curmem,totmem
C  Memory allocations for density and potential
	CALL DRO_DROFILES(0,0,0,0,' ',' ','A')
	CALL DRO_DPSFILES(0,0,0,0,' ',' ','A')
	CALL DPT_DSVFILES(0,0,0,0,' ',' ','A')
	CALL DPT_DPVFILES(0,0,0,0,' ',' ','A')
C  SET CHANGE IN CHARGE DENSITY AT THE BEGINING
      CALL DRO_SPLDRO(IQPNT)         !!! spline induced density to a new mesh
      CALL DRO_SPLDPS(IQPNT)         !!! new pseudodensity if Nplw is changed
C  NEW MAGNETIZATION AXIS
      CALL DRO_MAGDRHO(IQPNT)        !!! rotate magnetization axis
C  INITIALIZE MIXING ROUTINES
      CALL DRO_MIXDRO(IQPNT,0,EXIT)  !!! initialize induced density in MTS
      CALL DRO_MIXDPS(IQPNT,0,EXIT)  !!! initialize induced density in INT
C  DENSITY & FULL POTENTIAL GRADIENT
      CALL DRO_GRADRHO(IQPNT)        !!! calculate gradient of the density
      CALL DRO_GRADRPS(IQPNT)        !!! calculate gradient of the pseudodensity
      CALL DPT_GRADPOT(IQPNT)        !!! calculate gradient of the potential
C
C ******* THE LOOP OF SELF-CONSISTENCY FOR GIVEN Q-VECTOR ******
C
	DO 100 ITER=1,ITERMAX
	WRITE(IUN,1020)ITER,(QPNT(I,IQPNT),I=1,3)
      CALL DRO_MIXBRD(IQPNT,ITER,1)  !!! initialize Broyden mixing
C  CALCULATE MULTIPOLE FIELD
	CALL POT_MULTRHO    !!! calculate moments of (pseudo)density
	CALL POT_MULTFTR    !!! multipoles as lattice sums
	CALL POT_MULTASA    !!! multipoles as lattice sums
C  CALCULATE FULL POTENTIAL
	CALL POT_POTFILES(IUPOT,'!','A')! initialize full potential
	CALL POT_VCOUL      !!! calculate Coulomb potential within MT-spheres
	CALL POT_VEXCH(1)   !!! calculate ex.-cor.potential within MT-spheres
	CALL POT_VCFTR      !!! calculate Coulomb potential in the int.region
	CALL POT_VXFTR(1)   !!! calculate ex.-cor.potential in the int.region
	CALL POT_ZEROV      !!! set up energy zero
	CALL POT_VPINT      !!! calculate convolutions of pseudopotential
	CALL POT_PRINT2     !!! print necessary information
      CALL HUB_HUBPOT     !!! adds Hubbard correction to the potential
C  CALCULATE FULL POTENTIAL VARIATION (WITHOUT ITS GRADIENT)
	progn='DelPot  '
	call lib_timel(times)
	write(iun,1110)progn,st,times,curmem,totmem
 	CALL DPT_SDELPOT(IQPNT,ITER)   !!! set change in the potential
	call lib_timel(timef)
	write(iun,1120)progn,fn,timef,curmem,totmem
C  CALCULATE POTENTIAL PARAMETERS VARIATION, 
C  FIND INDUCED CHARGE DENSITY
	progn='DelBnd  '
	call lib_timel(times)
	write(iun,1110)progn,st,times,curmem,totmem
 	CALL DEL_DELBND(IQPNT)         !!! Change in pot.par and TOS
	call lib_timel(timef)
	write(iun,1120)progn,fn,timef,curmem,totmem
C  ADD PART CONNECTED WITH THE LONG-RANGE POTENTIAL
	progn='ScrPot  '
	call lib_timel(times)
	write(iun,1110)progn,st,times,curmem,totmem
      CALL DPT_SSCRPOT(IQPNT,ITER)   !!! compute long-range contribution
	call lib_timel(timef)
	write(iun,1120)progn,fn,timef,curmem,totmem
C CALCULATE DYNAMICAL MATRIX AND PHONON SPECTRUM
	progn='DynMat  '
	call lib_timel(times)
	write(iun,1110)progn,st,times,curmem,totmem
      CALL PHN_SDYNMAT(IQPNT)        !!! Dynamical matrix !!!
      CALL PHN_SPECTRA(IQPNT)        !!! Phonon spectra   !!!
	call lib_timel(timef)
	write(iun,1120)progn,fn,timef,curmem,totmem
C STORE DATA
      CALL PHN_SETPHN(IQPNT)        !!! Dynamical Matrix !!!
      CALL PHN_SETEPI(IQPNT)        !!! El-Ph.Interaction !!!
C MIX DENSITIES
	CALL DRO_MIXBRD(IQPNT,ITER,2)  !!! mix densities according to Broyden
      CALL DRO_MIXDRO(IQPNT,ITER,EXIT)!! mix densities with linear mixing
	CALL DRO_MIXDPS(IQPNT,ITER,EXIT)!! mix densities with linear mixing
	IF(EXIT)CALL MAN_ARTOUT('Density convergence reached')
	write(iun,1130)TOTMEM
	write(iun,1140)TXTMEM
 100  CONTINUE
	CALL MAN_ARTOUT('Number of iterations exceeded')
1010  FORMAT(/1X,A64/)
1020  FORMAT(/63('=')/
     &1X,'ITERATION ',I3,'  FOR Q-VECTOR (',G11.4,',',G11.4,',',
     &  G11.4,')'/63('=')/)
1110  FORMAT('***** ',A8,1X,A8,'; CPU : ',G12.5,
     &       '; CUR/MAX mem.(Mb): ',G10.3,'/',G10.3)
1120  FORMAT('***** ',A8,1X,A8,'; CPU : ',G12.5,
     &       '; CUR/MAX mem.(Mb): ',G10.3,'/',G10.3)
1130  FORMAT(/' Maximum memory allocated (Mbyte) ==',G14.7)
1140  FORMAT( ' Peak memory reached in ',A)
	END
