	SUBROUTINE MAN_SUPRA
************************************************************
*   The calculation of superconductivity parameters
************************************************************
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT                                       !!! from readini
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	CHARACTER ST*8,FN*8,PROGN*8
	LOGICAL EXIT
	DATA ST/'started'/,FN/'finished'/
C  REAL ALL INPUT DATA
	CALL SUP_INIT
C  CALCULATING PHONON SPECTRUM
	progn='OmegaQ  '
	call lib_timel(times)
	write(iun,1110)progn,st,times,curmem,totmem
	CALL SUP_OMEGAQ             !!! frequencies 
	call lib_timel(timef)
	write(iun,1120)progn,fn,timef,curmem,totmem
C  CALCUALTING DENSITY OF STATES
	progn='PhnDos  '
	call lib_timel(times)
	write(iun,1110)progn,st,times,curmem,totmem
	CALL SUP_PHNDOS             !!! phonon density of states
	call lib_timel(timef)
	write(iun,1120)progn,fn,timef,curmem,totmem
C  CALCULATING LINEWIDTHS
	progn='PhnLwd  '
	call lib_timel(times)
	write(iun,1110)progn,st,times,curmem,totmem
	CALL SUP_PHNLWD             !!! linewidths
	call lib_timel(timef)
	write(iun,1120)progn,fn,timef,curmem,totmem
C  CALCULATING ALF^2(OM)*F(OM)
	progn='EliFun  '
	call lib_timel(times)
	write(iun,1110)progn,st,times,curmem,totmem
	CALL SUP_ELIFUN              !!! Eliashberg function
	call lib_timel(timef)
	write(iun,1120)progn,fn,timef,curmem,totmem
C  CALCULATING TRANSPORT WIDTHS
	progn='TraLwd  '
	call lib_timel(times)
	write(iun,1110)progn,st,times,curmem,totmem
	CALL SUP_TRALWD             !!! transport linewidths
	call lib_timel(timef)
	write(iun,1120)progn,fn,timef,curmem,totmem
C  CALCULATING TRANSPORT SPECTRUM
	progn='SpeFun  '
	call lib_timel(times)
	write(iun,1110)progn,st,times,curmem,totmem
	CALL SUP_SPEFUN             !!! transport spectral function
	call lib_timel(timef)
	write(iun,1120)progn,fn,timef,curmem,totmem
C  CALCULATING ElECTR.RESISTIVITY
	progn='ElrRes  '
	call lib_timel(times)
	write(iun,1110)progn,st,times,curmem,totmem
	CALL SUP_ELRESI              !!! Electrical resistivity
	call lib_timel(timef)
	write(iun,1120)progn,fn,timef,curmem,totmem
C  CALCULATING PHONON FREE ENERGY
	progn='FreEnr  '
	call lib_timel(times)
	write(iun,1110)progn,st,times,curmem,totmem
	CALL SUP_FREENR                !!! Phonon Free Energy
	call lib_timel(timef)
	write(iun,1120)progn,fn,timef,curmem,totmem
C  MEMORY USED
	write(iun,1130)TOTMEM
	write(iun,1140)TXTMEM
C  STOP LMTART
	CALL MAN_ARTOUT('Finished')
1110  FORMAT('***** ',A8,1X,A8,'; CPU : ',G12.5,
     &       '; CUR/MAX mem.(Mb): ',G10.3,'/',G10.3)
1120  FORMAT('***** ',A8,1X,A8,'; CPU : ',G12.5,
     &       '; CUR/MAX mem.(Mb): ',G10.3,'/',G10.3)
1130  FORMAT(/' Maximum memory allocated (Mbyte) ==',G14.7)
1140  FORMAT( ' Peak memory reached in ',A)
	END
