	SUBROUTINE MDL_MIXDMF(KMSB,ITER,IEXIT,KEY)
**************************************************************
* Mixes self-energy function in the DMFT loop according to   *
* Broyden prescription.                                      *
**************************************************************
C SET EXTERNAL CONNECTIONS
      USE COM_MSBMESH ,ONLY: NMSC,TEMP
      USE COM_MDLMIX  ,ONLY: EPSDMF,MIXBRD,ADMIXL,MIXFUN,NBROY
      USE COM_LSHELL  ,ONLY: LORB
      USE COM_IMPGRF  ,ONLY: GLOC,SIGW,BATH,DELW
      USE COM_LMTOUT  ,ONLY: SCRFILE
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT
      USE COM_CHANNELS,ONLY: IUSGM,IUBSG
	USE COM_MASHDEP ,ONLY: NVAL,LENCMP
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8, ALLOCATABLE :: WRAD(:)
	REAL*8, ALLOCATABLE :: WTER(:)
	REAL*8, ALLOCATABLE :: FNOM(:)
	COMPLEX*16, ALLOCATABLE :: BETA(:,:)
	COMPLEX*16, ALLOCATABLE :: CMAT(:,:)
	COMPLEX*16, ALLOCATABLE :: GAMA(:,:)
	COMPLEX*16, ALLOCATABLE :: WBRO(:)
	COMPLEX*16, ALLOCATABLE :: WINP(:)
	COMPLEX*16, ALLOCATABLE :: WMIX(:,:)
      COMPLEX*16, ALLOCATABLE :: WRK1(:)
      COMPLEX*16, ALLOCATABLE :: WRK2(:)
      COMPLEX*16, ALLOCATABLE :: XINP(:)
      COMPLEX*16, ALLOCATABLE :: XOUT(:)
      LOGICAL FIRST,RESET
      CHARACTER TCPS*19,TC*19,TM*19
	SAVE FIRST,RESET,WTER,WMIX,WBRO,WINP,MTER,FNOM,BETA,CMAT,GAMA
      DATA PI/3.141592653589793D0/,FIRST/.TRUE./
      CALL ABORTNOW()
	IF(KEY.NE.0.AND.KEY.NE.MIXFUN)RETURN
	IEXIT=0
C SAVE SWITCHES
      IF(FIRST)THEN
      ALLOCATE(WTER(0:NBROY))
	ALLOCATE(FNOM(NBROY))
	ALLOCATE(BETA(NBROY,NBROY))
	ALLOCATE(CMAT(NBROY,NBROY))
	ALLOCATE(GAMA(NBROY,NBROY))
      ALLOCATE(WBRO(NBROY))
      ALLOCATE(WINP(NBROY))
      ALLOCATE(WMIX(NBROY,NBROY))
      RESET=.TRUE.
	MTER=0
      ENDIF
	IF(ITER.EQ.1.AND.KEY.EQ.0)MTER=0
      FIRST=.FALSE.
C SET ITERATION NUMBER
	IF(MTER.EQ.NBROY-1)RESET=.TRUE.
	IF(MTER.EQ.NBROY-1)
     &WRITE(IUT,*)'<MIXDMF>:: Mter>Ntermem, Broyden restarted'
	IF(RESET)MTER=0
	IF(KEY.EQ.0.AND.MTER.NE.0)RETURN
	IF(KEY.NE.0)MTER=MTER+1
	IF(.NOT.MIXBRD.AND.MTER.NE.0)MTER=1 ! use linear mixing
C DEFINE MAXIMUM SIZE OF THE BROYDEN ARRAY
      NDIM=2*(2*LORB+1)
	NLEN=(NMSC+1)*NDIM**2
      NLENMEM=NLEN
C  MEMORY ALLOCATIONS
      ALLOCATE(WRAD(NLENMEM))
      ALLOCATE(WRK1(NLENMEM))
      ALLOCATE(WRK2(NLENMEM))
      ALLOCATE(XINP(NLENMEM))
      ALLOCATE(XOUT(NLENMEM))
C  *** SET MIXING ARRAY ***
      ILEN=0
      DO IDIM1=1,NDIM
      DO IDIM =1,NDIM
	DO IMSC=0,NMSC
	ILEN=ILEN+1
	IF(MIXFUN.EQ.1)XINP(ILEN)=DELW(IDIM1,IDIM,IMSC)
	IF(MIXFUN.EQ.2)XINP(ILEN)=SIGW(IDIM1,IDIM,IMSC)
	WRAD(ILEN)=1.D0
	ENDDO
	ENDDO
	ENDDO
C  SEND ARRAY TO BROYDEN
      CALL LIB_BROY6(XINP,XOUT,WRAD,WRK1,WRK2,NLEN,MTER,ADMIXL,WTER,
     &WBRO,WINP,WMIX,FNOM,BETA,CMAT,GAMA,NBROY,NVAL,
     &IUBSG,SCRFILE(IUBSG),IERR)      
	IF(MTER.EQ.0)RESET=.FALSE.
	IF(MTER.EQ.0)GOTO 1000
C Compare with the old results
	DDIF=0.D0
	DVAL=0.D0
	DO ILEN=1,NLEN
	DDIF=DDIF+(XOUT(ILEN)-XINP(ILEN))*
     &DCONJG(XOUT(ILEN)-XINP(ILEN))
	DVAL=DVAL+(XOUT(ILEN)+XINP(ILEN))*
     &DCONJG(XOUT(ILEN)+XINP(ILEN))
	ENDDO
	DDIF=SQRT(DDIF)/DBLE(NMSC+1)
	DVAL=SQRT(DVAL)/DBLE(NMSC+1)
	IF(DVAL.GT.1.D-10)DDIF=DDIF/DVAL
C DIVERGENCY OCCURS
C	IF(DVAL.GT.1.D+04)THEN
C	DO ILEN=1,NLEN
C	XOUT(ILEN)=(0.D0,0.D0)
C	ENDDO
C	RESET=.TRUE.
C	GOTO 1000
C	ENDIF
	IF(DDIF.LE.EPSDMF)IEXIT=1
	IF(ADMIXL.EQ.1.D0.AND.MTER.EQ.1)IEXIT=0
C *** DEFINE NEW HYBRIDIZATION ***
      ILEN=0
      DO IDIM1=1,NDIM
      DO IDIM =1,NDIM
	DO IMSC=0,NMSC
	ILEN=ILEN+1
	IF(DIMAG(XOUT(ILEN)).GT.-1.D-14)
     &XOUT(ILEN)=DCMPLX(DREAL(XOUT(ILEN)),-1.D-14)
	IF(MIXFUN.EQ.1)
     &DELW(IDIM1,IDIM,IMSC)=XOUT(ILEN)
	IF(MIXFUN.EQ.2)
     &SIGW(IDIM1,IDIM,IMSC)=XOUT(ILEN)
	ENDDO
	ENDDO
	ENDDO
C  PRINT BLOCK
	WRITE(IUN,1010)WTER(MTER),DDIF
C MEMORY DEALLOCATONS
1000	DEALLOCATE(WRAD,WRK1,WRK2,XINP,XOUT) 
1010	FORMAT(1X,'Mixing, Iter-Weight=',G14.7, ' Accuracy=',G14.7)
	END
