	SUBROUTINE MDL_MODELHUB_SCFD(TPAR,GFF,DEL)
*********************************************************************
*  Self-consistency for Hubbard Model                               *
*********************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16 DIM,DEL,GFF
	DATA PI/3.141592653589793D0/,DIM/(0.D0,1.D0)/
	DEL=TPAR**2*GFF
	END



	SUBROUTINE MDL_MODELHUB_SCFG(WOMG,TPAR,ELOC,SIG,GFF)
*********************************************************************
*  Self-consistency for Hubbard Model                               *
*********************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16 DIM,SIG,WOMG,SAVR,DAVR,GFF
	DATA PI/3.141592653589793D0/,DIM/(0.D0,1.D0)/
C Impurity Green function self-consisntent with resepct to DMFT
	DAVR=(WOMG-ELOC-SIG)/2.D0/TPAR**2
	SAVR=DAVR*DAVR-1.D0/TPAR**2
	IF(DIMAG(SAVR).GE.0.D0)GFF=DAVR-SQRT(SAVR)
	IF(DIMAG(SAVR).LT.0.D0)GFF=DAVR+SQRT(SAVR)
	END







	SUBROUTINE MDL_MODELPAM_SCFD(WOMG,ECON,VPAR,TPAR,ELOC,SIG,DEL,GCC)
*********************************************************************
*  Self-consistency for Periodic Anderson Model                     *
*********************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16 DIM,DEL,GCC,SIG,WOMG,ZMSB,SAVR,GRFN
	DATA PI/3.141592653589793D0/,DIM/(0.D0,1.D0)/
	ZMSB=WOMG-ECON-VPAR**2/(WOMG-ELOC-SIG)
	CALL MDL_MODELHYB(TPAR,ZMSB,SAVR)
	GCC=SAVR/TPAR**2
	GRFN=1.D0/(WOMG-ELOC-SIG)+VPAR**2/(WOMG-ELOC-SIG)**2*GCC
	DEL=WOMG-ELOC-1.D0/GRFN-SIG
	END






	SUBROUTINE MDL_MODELPAM_SCFG(WOMG,TPAR,ELOC,SIG,GFF)
*********************************************************************
*  Self-consistency for Hubbard Model                               *
*********************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16 DIM,SIG,WOMG,SAVR,DAVR,GFF
	DATA PI/3.141592653589793D0/,DIM/(0.D0,1.D0)/
C Impurity Green function self-consisntent with resepct to DMFT
	DAVR=(WOMG-ELOC-SIG)/2.D0/TPAR**2
	SAVR=DAVR*DAVR-1.D0/TPAR**2
	IF(DIMAG(SAVR).GE.0.D0)GFF=DAVR-SQRT(SAVR)
	IF(DIMAG(SAVR).LT.0.D0)GFF=DAVR+SQRT(SAVR)
	END



	SUBROUTINE MDL_MODELHYB(T,Z,DEL)
***********************************************************
*  Model Hybridization, semicircular case.                *
***********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16 DEL,Z,DIM,A
	DATA PI/3.141592653589793D0/,DIM/(0.D0,1.D0)/
	D=2.D0*T
	DEL=(0.D0,0.D0)
	CALL LIB_SQUAREROOT(Z**2-DCMPLX(4.D0*T**2,0.D0),A)
C Semicircle DOS
	IF(DIMAG(Z).GE.0.D0)DEL=1.D0/2.D0*(Z-A)
 	IF(DIMAG(Z).LT.0.D0)DEL=1.D0/2.D0*(Z+A)
	END

