	SUBROUTINE MDL_READMDL
************************************************************
*  <READMDL> controls reading the data from MDLFILE.       *
************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTINP  ,ONLY: PROJECT,INPINFO                 !!! from artinp
	USE COM_EXTENS  ,ONLY: LENEXTN                         !!! from setup
	USE COM_MDLEXT  ,ONLY: EXTNMDL                         !!! from setup
	USE COM_MDLOUT  ,ONLY: MDLFILE                         !!! from setup
      USE COM_MDLPAR  ,ONLY: IMOD,IMPS                       !!! from readmdl
      USE COM_CHANNELS,ONLY: IUINP                           !!! from channels
	USE COM_UNIT    ,ONLY: IUN,IUT,IUR                     !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	CHARACTER STRING*150,INF*130
	CHARACTER*150, ALLOCATABLE :: MDLDATA(:)
	LOGICAL EXIST,MODIFIED,PRESENT
	DATA PI/3.141592653589793D0/
C CHECK INPINFO
	INF=INPINFO
	CALL SUBSTR_IN_STR(PRESENT,INF,130,EXTNMDL,LENEXTN)
	IF(.NOT.PRESENT)CALL FULLSTOP('<MDLFILE> identifier not found!')
C SET FILE NAME
      CALL FIND_LBLANK(PROJECT,130,NBP)
      CALL FIND_LBLANK(EXTNMDL,60,NBE)
	MDLFILE=PROJECT(:NBP)//'.'//EXTNMDL(:NBE)
	INQUIRE(FILE=MDLFILE,EXIST=EXIST)
	IF(.NOT.EXIST)CALL FULLSTOP('<MDLFILE> not found!')
C ********************************
C UNDERSTAND THE LENGHT OF INIFILE
	CALL FILE_LENGHT(MDLFILE,NLEN,IUINP)
	ALLOCATE(MDLDATA(NLEN))
C ********************************
C READ INIFILE TO INTERNAL FILE
	OPEN(UNIT=IUINP,FILE=MDLFILE,STATUS='OLD',FORM='FORMATTED')
	DO ILEN=1,NLEN
	READ(IUINP,FMT='(A150)')MDLDATA(ILEN)
	ENDDO
	CLOSE(IUINP)
C ********************************
C UNDERSTAND INPUT: CLASSIC or MODERN
	STRING=MDLDATA(1)
	CALL LIB_CONVLOW(STRING,150)
	CALL LIB_RMBLANK(STRING,150)
	MODERN=0
	DO IPOS=1,80
	IF(STRING(IPOS:IPOS+11).EQ.'input=modern')MODERN=2
	IF(MODERN.NE.0)EXIT
	ENDDO
	IF(MODERN.EQ.2)MODIFIED=.TRUE. 
	IF(MODERN.NE.2)CALL FULLSTOP('<MDLFILE> format not recognized!')
C READ CONTROL DATA
	CALL MDL_READMDL_CTRL(MDLDATA,NLEN)
C READ DMFT SETTINGS
	CALL MDL_READMDL_DMFT(MDLDATA,NLEN)
C READ ITER SETTINGS
	CALL MDL_READMDL_ITER(MDLDATA,NLEN)
C READ SHELL INFORMATION
	CALL MDL_READMDL_SHEL(MDLDATA,NLEN)
C READ IMPURITY SOLVER SETTINGS
C	IF(IMPS.EQ.1)
C    &CALL MDL_READMDL_FOCK(MDLDATA,NLEN)
	IF(IMPS.EQ.2)
     &CALL MDL_READMDL_HUB1(MDLDATA,NLEN)
	IF(IMPS.EQ.3)
     &CALL MDL_READMDL_SBMF(MDLDATA,NLEN)
	IF(IMPS.EQ.4)
     &CALL MDL_READMDL_IRAT(MDLDATA,NLEN)
	IF(IMPS.EQ.5)
     &CALL MDL_READMDL_QMCF(MDLDATA,NLEN)
	IF(IMPS.EQ.6)
     &CALL MDL_READMDL_RATF(MDLDATA,NLEN)
C READ CORRELATED LEVELS DATA
	CALL MDL_READMDL_BAND(MDLDATA,NLEN)
C ********************************
C MDLFILE HAS BEEN READ, OVERWRITE IT
	IF(MODIFIED)CALL READ_OVWR(MDLFILE,MDLDATA,NLEN)
C Compute Matsubara grid
      CALL HUB_MSBMESH
C Compute Gaunt coefficients
	LMAXBMEM=LORB
	LMAXCMEM=3
	LIMCMEM=(LMAXCMEM+1)**2
	CALL INI_MAKEGNT
C MEMORY DEALLOCATIONS
	DEALLOCATE(MDLDATA)
C ERROR HANDLINGS
C	none
C *****************************************************************
	END SUBROUTINE MDL_READMDL




	SUBROUTINE MDL_READMDL_CTRL(MDLDATA,NLEN)
*******************************************************
* Reads control                                       *
*******************************************************
C SET EXTERNAL CONNECTIONS
      USE COM_MDLPAR  ,ONLY : IMOD,IMPS,ISHP
      USE COM_IMPGRF  ,ONLY : KVRB
      USE COM_UNIT    ,ONLY : IUN,IUR,IUT
C SET LOCAL VARIABLES 
      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER, INTRINSIC :: SIZE
      REAL*8, ALLOCATABLE :: UMAT(:,:,:,:)
      CHARACTER*150, ALLOCATABLE :: MDLCOPY(:)
      CHARACTER*150, MDLDATA(NLEN)
      CHARACTER TEXT*64,TCTRL*10,STRING*150,HELP*40,SNOT*20
      LOGICAL DEF,ASK,VAL,NTH,MDF
      DATA PI/3.141592653589793D0/
C **************************************
C READING CONTROLS
      CALL READ_SECT(MDLDATA(1),NLEN,ISEC,NSEC,MSEC,
     &'<section=ctrl',13,'<section=',9,'ok',2)
C Set section title
      DO IPOS=1,150
      IF(MDLDATA(ISEC)(IPOS:IPOS).EQ.'>')EXIT
      ENDDO
      DO JPOS=IPOS+1,150
      IF(MSEC.NE.0)MDLDATA(ISEC)(JPOS:JPOS)=' '
      ENDDO
      IF(IPOS.LE.50)THEN
      HELP='! CONTROL PARAMETERS:                   '
      IF(MSEC.NE.0)MDLDATA(ISEC)(IPOS+1:IPOS+40)=HELP
      ENDIF
C Allocate temporary file
      ALLOCATE(MDLCOPY(NSEC))
      DO ILIN=1,MSEC
      MDLCOPY(ILIN)=MDLDATA(ILIN+ISEC-1)
      ENDDO
C **************************************
C READING THE DATA: SELECT MODEL
C  SCHM='HUB       ' - Hubbard model
C  SCHM='PAM       ' - Periodic Anderson Impurity Model
C Process SCHM
      TCTRL='HUB'
      HELP='! HUB/PAM                               '
      LHLP=40
      CALL READ_CHAR(MDLDATA(ISEC),MDLCOPY(1),NSEC,MSEC,
     &'model',5,IN,1,0,RE,1,0,CM,1,0,TCTRL,10,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Transform to integer keys
	CALL LIB_CONVLOW(TCTRL,10)
	CALL LIB_RMBLANK(TCTRL,10)
	NB=INDEX(TCTRL,' ')
	IMOD=0
	IF(TCTRL(:NB-1).EQ.'hub')IMOD=1
	IF(TCTRL(:NB-1).EQ.'pam')IMOD=2
	IF(IMOD.EQ.0)
     &CALL FULLSTOP('Wrong <<scheme>> keyword in MDLFILE')
C **************************************
C Process impurity solver choice
      TCTRL='none      '
      HELP='! impurity solver choice                '
      LHLP=40
      CALL READ_CHAR(MDLDATA(ISEC),MDLCOPY(1),NSEC,MSEC,
     &'method',6,IN,1,0,RE,1,0,CM,1,0,TCTRL,10,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
      CALL LIB_CONVLOW(TCTRL,10)
      CALL LIB_RMBLANK(TCTRL,10)
	NB=INDEX(TCTRL,' ')
	IMPS=-1
	IF(TCTRL(:NB-1).EQ.'none')IMPS=0
C Hartree Fock Solvers
	IF(TCTRL(:NB-1).EQ.'fock')IMPS=1
C Atomic (Hubbard1) Solver
	IF(TCTRL(:NB-1).EQ.'hub1')IMPS=2
C SBMF Solver
	IF(TCTRL(:NB-1).EQ.'sbmf')IMPS=3
C Interpolative (SBMF+Atomic) Solver
	IF(TCTRL(:NB-1).EQ.'irat')IMPS=4
C QMC Solvers
	IF(TCTRL(:NB-1).EQ.'qmcf')IMPS=5
C Flex Solver
 	IF(TCTRL(:NB-1).EQ.'ratf')IMPS=6
C **************************************
C Process DOS
      TCTRL='semi      '
      HELP='! shape of density of states            '
      LHLP=40
      CALL READ_CHAR(MDLDATA(ISEC),MDLCOPY(1),NSEC,MSEC,
     &'shape',5,IN,1,0,RE,1,0,CM,1,0,TCTRL,10,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
      CALL LIB_CONVLOW(TCTRL,10)
      CALL LIB_RMBLANK(TCTRL,10)
	NB=INDEX(TCTRL,' ')
	ISHP=-1
	IF(TCTRL(:NB-1).EQ.'semi')ISHP=1
C ******************************************
C READING THE DATA: SELECT VERBOCITY SWITCH
	TCTRL='Full      '
	HELP='! set: Full/None                       '
	LHLP=40
	CALL READ_CHAR(MDLDATA(ISEC),MDLCOPY(1),NSEC,MSEC,
     &  'verboc',6,IN,1,0,RE,1,0,CM,1,0,TCTRL,10,1,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
      CALL LIB_CONVLOW(TCTRL,10)
      CALL LIB_RMBLANK(TCTRL,10)
	KVRB=-1
      IF(TCTRL(1:6).EQ.'none  ')KVRB=0
      IF(TCTRL(1:6).EQ.'full  ')KVRB=1
      IF(TCTRL(1:6).EQ.'auto  ')KVRB=1
	IF(KVRB.EQ.-1)THEN
	WRITE(IUT,*)'Terminated in <READRAT>:'
	WRITE(IUT,*)'Syntax error in control line VERBOC'
	CALL FULLSTOP(' ')
	ENDIF
C **************************************
      CALL READ_ERRR(MDLDATA(ISEC),MDLCOPY(1),NSEC,MSEC,'CTRL')
      DEALLOCATE(MDLCOPY)
	END SUBROUTINE MDL_READMDL_CTRL





	SUBROUTINE MDL_READMDL_DMFT(MDLDATA,NLEN)
*******************************************************
* Reads DMFT settings                                 *
*******************************************************
C SET EXTERNAL CONNECTIONS
	USE COM_MSBMESH ,ONLY : TEMP,OBND,KGRD,NMSB,NMSL,WMSB
     &                       ,WMSL,DMSB,DMSL,SMSB,SMSL
     &                       ,FMSB,NOMG,WOMG,WMIN,WMAX
      USE COM_IMPGRF  ,ONLY : CHEM,FILL,KFRM
	USE COM_FERMI   ,ONLY : EF
      USE COM_UNIT    ,ONLY : IUN,IUR,IUT
      USE COM_MASHDEP ,ONLY : NVAL,LENCMP
C SET LOCAL VARIABLES 
      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER, INTRINSIC :: SIZE
      CHARACTER*150, ALLOCATABLE :: MDLCOPY(:)
      LOGICAL DEF,ASK,VAL,NTH,MDF
      CHARACTER*150, MDLDATA(NLEN)
      CHARACTER TEXT*64,TCTRL*10,STRING*150,HELP*40,SNOT*20
      DATA PI/3.141592653589793D0/
C **************************************
C READING THE DATA: SELECT DMFT SETTINGS
C NMSB - # of Matsubara energies
C TEMP - # Temperature in K
      CALL READ_SECT(MDLDATA(1),NLEN,ISEC,NSEC,MSEC,
     &'<section=dmft',13,'<section=',9,'ok',2)
C Set section title
      DO IPOS=1,150
      IF(MDLDATA(ISEC)(IPOS:IPOS).EQ.'>')EXIT
      ENDDO
      DO JPOS=IPOS+1,150
      IF(MSEC.NE.0)MDLDATA(ISEC)(JPOS:JPOS)=' '
      ENDDO
      IF(IPOS.LE.50)THEN
      HELP='! DMFT SETTINGS                         '
      IF(MSEC.NE.0)MDLDATA(ISEC)(IPOS+1:IPOS+40)=HELP
      ENDIF
C Allocate temporary file
      ALLOCATE(MDLCOPY(NSEC))
      DO ILIN=1,MSEC
      MDLCOPY(ILIN)=MDLDATA(ILIN+ISEC-1)
      ENDDO
C Process NMSB
      NMSB=2
      HELP='! # of Matsubara frequencies            '
      LHLP=40
      CALL READ_CHAR(MDLDATA(ISEC),MDLCOPY(1),NSEC,MSEC,
     &'nmsb',4,NMSB,1,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
	NMSBMEM=NMSB
	NMSCMEM=NMSB
C Process OBND
      OBND=1.D0
      HELP='! Effective bandwidth for the grid      '
      LHLP=40
      CALL READ_CHAR(MDLDATA(ISEC),MDLCOPY(1),NSEC,MSEC,
     &'obnd',4,IN,1,0,OBND,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Process NMSL
      NMSL=1024
      HELP='! # of linear Matsubara frequencies     '
      LHLP=40
      CALL READ_CHAR(MDLDATA(ISEC),MDLCOPY(1),NSEC,MSEC,
     &'nmsl',4,NMSL,1,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
      NMSLMEM=NMSL
C Process NOMG
      NOMG=100
      HELP='! # of frequencies at real axis         '
      LHLP=40
      CALL READ_CHAR(MDLDATA(ISEC),MDLCOPY(1),NSEC,MSEC,
     &'nomg',4,NOMG,1,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
      NOMGMEM=NOMG
C Process WMIN
      WMIN=-10.D0
      HELP='! Minimal frequency for the real axis   '
      LHLP=40
      CALL READ_CHAR(MDLDATA(ISEC),MDLCOPY(1),NSEC,MSEC,
     &'wmin',4,IN,1,0,WMIN,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Process WMAX
      WMAX=+10.D0
      HELP='! Maximal frequency for the real axis   '
      LHLP=40
      CALL READ_CHAR(MDLDATA(ISEC),MDLCOPY(1),NSEC,MSEC,
     &'wmax',4,IN,1,0,WMAX,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Process KGRD
      KGRD=2 ! default is imaginary axis
      HELP='! set current grid to real/imag         '
      LHLP=40
      CALL READ_CHAR(MDLDATA(ISEC),MDLCOPY(1),NSEC,MSEC,
     &'grid',4,IN,1,0,RE,1,0,CM,1,0,TCTRL,10,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
      CALL LIB_CONVLOW(TCTRL,10)
      CALL LIB_RMBLANK(TCTRL,10)
	IF(TCTRL(1:4).EQ.'real')KGRD=1
	IF(TCTRL(1:4).EQ.'imag')KGRD=2
C Process Fill
      FILL=0.D0
      HELP='! Mean Filling                          '
      LHLP=40
      CALL READ_CHAR(MDLDATA(ISEC),MDLCOPY(1),NSEC,MSEC,
     &'fill',4,IN,1,0,FILL,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Process Chem
      CHEM=0.D0
      HELP='! Chemical potential                    '
      LHLP=40
      CALL READ_CHAR(MDLDATA(ISEC),MDLCOPY(1),NSEC,MSEC,
     &'chem',4,IN,1,0,CHEM,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
      EF=CHEM
C Process Fermi Search options
      TCTRL='auto      '
      HELP='! Fermi search options                  '
      LHLP=40
      CALL READ_CHAR(MDLDATA(ISEC),MDLCOPY(1),NSEC,MSEC,
     &'kfrm',4,IN,1,0,RE,1,0,CM,1,0,TCTRL,10,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
      CALL LIB_CONVLOW(TCTRL,10)
      CALL LIB_RMBLANK(TCTRL,10)
	KFRM=-1
	IF(TCTRL(1:4).EQ.'auto')KFRM=0
	IF(TCTRL(1:4).EQ.'fill')KFRM=0
	IF(TCTRL(1:4).EQ.'find')KFRM=0
	IF(TCTRL(1:4).EQ.'keep')KFRM=1
	IF(KFRM.EQ.-1)
     &CALL FULLSTOP('Keyword KFRM not recognized in MDLFILE')
C Process temperature
      TEMP=0.01D0
      HELP='! Temperature of the calculation        '
      LHLP=40
      CALL READ_CHAR(MDLDATA(ISEC),MDLCOPY(1),NSEC,MSEC,
     &'temp',4,IN,1,0,TEMP,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C **************************************
      CALL READ_ERRR(MDLDATA(ISEC),MDLCOPY(1),NSEC,MSEC,'DMFT')
      DEALLOCATE(MDLCOPY)
	END SUBROUTINE MDL_READMDL_DMFT




	SUBROUTINE MDL_READMDL_ITER(MDLDATA,NLEN)
*******************************************************
* Reads DMFT settings                                 *
*******************************************************
C SET EXTERNAL CONNECTIONS
	USE COM_MDLMIX  ,ONLY : NDIT,EPSDMF,MIXBRD,ADMIXL,
     &                        MIXFUN,NBROY
	USE COM_FERMI   ,ONLY : EF
      USE COM_UNIT    ,ONLY : IUN,IUR,IUT
      USE COM_MASHDEP ,ONLY : NVAL,LENCMP
C SET LOCAL VARIABLES 
      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER, INTRINSIC :: SIZE
      CHARACTER*150, ALLOCATABLE :: MDLCOPY(:)
      LOGICAL DEF,ASK,VAL,NTH,MDF
      CHARACTER*150, MDLDATA(NLEN)
      CHARACTER TEXT*64,TCTRL*10,STRING*150,HELP*40,SNOT*20
      DATA PI/3.141592653589793D0/
C **************************************
C READING THE DATA: SELECT DMFT SETTINGS
C NDIT - # of DMFT iterations
      CALL READ_SECT(MDLDATA(1),NLEN,ISEC,NSEC,MSEC,
     &'<section=iter',13,'<section=',9,'ok',2)
C Set section title
      DO IPOS=1,150
      IF(MDLDATA(ISEC)(IPOS:IPOS).EQ.'>')EXIT
      ENDDO
      DO JPOS=IPOS+1,150
      IF(MSEC.NE.0)MDLDATA(ISEC)(JPOS:JPOS)=' '
      ENDDO
      IF(IPOS.LE.50)THEN
      HELP='! DMFT SETTINGS                         '
      IF(MSEC.NE.0)MDLDATA(ISEC)(IPOS+1:IPOS+40)=HELP
      ENDIF
C Allocate temporary file
      ALLOCATE(MDLCOPY(NSEC))
      DO ILIN=1,MSEC
      MDLCOPY(ILIN)=MDLDATA(ILIN+ISEC-1)
      ENDDO
C Process NDIT
      NDIT=20
      HELP='! # of DMFT iterations                  '
      LHLP=40
      CALL READ_CHAR(MDLDATA(ISEC),MDLCOPY(1),NSEC,MSEC,
     &'ndit',4,NDIT,1,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Use Broyden
      TCTRL='yes       '
      HELP='! Use Broyden mixing for DMFT loop      '
      LHLP=40
      CALL READ_CHAR(MDLDATA(ISEC),MDLCOPY(1),NSEC,MSEC,
     &'broy',4,IN,1,0,RE,1,0,CM,1,0,TCTRL,10,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
      CALL LIB_CONVLOW(TCTRL,10)
      CALL LIB_RMBLANK(TCTRL,10)
	MIXBRD=.TRUE.
	IF(TCTRL(1:3).EQ.'yes')MIXBRD=.TRUE.
	IF(TCTRL(1:2).EQ.'no' )MIXBRD=.FALSE.
C Process NBROY
      NBROY=15
      HELP='! Reset Broyden mixing after NBROY '
      LHLP=40
      CALL READ_CHAR(MDLDATA(ISEC),MDLCOPY(1),NSEC,MSEC,
     &'nbroy',5,NBROY,1,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Mix Delta(w)/Sigma(w)
      TCTRL='Delta     '
      HELP='! Mix Delta(w)/Sigma(w) in DMFT loop    '
      LHLP=40
      CALL READ_CHAR(MDLDATA(ISEC),MDLCOPY(1),NSEC,MSEC,
     &'mixfun',6,IN,1,0,RE,1,0,CM,1,0,TCTRL,10,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
      CALL LIB_CONVLOW(TCTRL,10)
      CALL LIB_RMBLANK(TCTRL,10)
	MIXFUN=0
	IF(TCTRL(1:5).EQ.'delta')MIXFUN=1
	IF(TCTRL(1:5).EQ.'sigma')MIXFUN=2
	IF(MIXFUN.EQ.0)
     &CALL FULLSTOP('Mixing function not recognized in MDLFILE')
C Process AdmixL
      ADMIXL=0.35D0
      HELP='! Mixing parameter                      '
      LHLP=40
      CALL READ_CHAR(MDLDATA(ISEC),MDLCOPY(1),NSEC,MSEC,
     &'mixing',6,IN,1,0,ADMIXL,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Process Accuracy
      EPSDMF=1.D-05
      HELP='! Accuracy                              '
      LHLP=40
      CALL READ_CHAR(MDLDATA(ISEC),MDLCOPY(1),NSEC,MSEC,
     &'epsdmf',6,IN,1,0,EPSDMF,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C **************************************
      CALL READ_ERRR(MDLDATA(ISEC),MDLCOPY(1),NSEC,MSEC,'ITER')
      DEALLOCATE(MDLCOPY)
	END SUBROUTINE MDL_READMDL_ITER




	SUBROUTINE MDL_READMDL_HUB1(MDLDATA,NLEN)
*******************************************************
* Reads settings for Hubbard 1 solver
*******************************************************
C SET EXTERNAL CONNECTIONS
      USE COM_MDLPAR  ,ONLY : IMOD,IMPS,ISYM,ISPN
      USE COM_UNIT    ,ONLY : IUN,IUR,IUT
C SET LOCAL VARIABLES 
      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER, INTRINSIC :: SIZE
      CHARACTER*150, ALLOCATABLE :: MDLCOPY(:)
      CHARACTER*150, MDLDATA(NLEN)
      CHARACTER TEXT*64,TCTRL*10,STRING*150,HELP*40,SNOT*20
      LOGICAL DEF,ASK,VAL,NTH,MDF
      DATA PI/3.141592653589793D0/
C **************************************
C READING CONTROLS
      CALL READ_SECT(MDLDATA(1),NLEN,ISEC,NSEC,MSEC,
     &'<section=hub1',13,'<section=',9,'ok',2)
C Set section title
      DO IPOS=1,150
      IF(MDLDATA(ISEC)(IPOS:IPOS).EQ.'>')EXIT
      ENDDO
      DO JPOS=IPOS+1,150
      IF(MSEC.NE.0)MDLDATA(ISEC)(JPOS:JPOS)=' '
      ENDDO
      IF(IPOS.LE.50)THEN
      HELP='! CONTROL PARAMETERS:                   '
      IF(MSEC.NE.0)MDLDATA(ISEC)(IPOS+1:IPOS+40)=HELP
      ENDIF
C Allocate temporary file
      ALLOCATE(MDLCOPY(NSEC))
      DO ILIN=1,MSEC
      MDLCOPY(ILIN)=MDLDATA(ILIN+ISEC-1)
      ENDDO
C **************************************
C READING THE DATA: SELECT SYMMETRY
C Process SCHM
      TCTRL='CRF'
      HELP='! SUN/CRF/MAT                           '
      LHLP=40
      CALL READ_CHAR(MDLDATA(ISEC),MDLCOPY(1),NSEC,MSEC,
     &'symmet',6,IN,1,0,RE,1,0,CM,1,0,TCTRL,10,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Transform to integer keys
	CALL LIB_CONVLOW(TCTRL,10)
	CALL LIB_RMBLANK(TCTRL,10)
	NB=INDEX(TCTRL,' ')
	ISYM=0
	IF(TCTRL(:NB-1).EQ.'sun')ISYM=1
	IF(TCTRL(:NB-1).EQ.'crf')ISYM=2
	IF(TCTRL(:NB-1).EQ.'mat')ISYM=3
	IF(ISYM.EQ.0)
     &CALL FULLSTOP('Wrong <<symmet>> keyword in MDLFILE')
C **************************************
C READING THE DATA: SELECT SPINS
C Process SPINS
      TCTRL='auto'
      HELP='! # of spins: auto/one/both             '
      LHLP=40
      CALL READ_CHAR(MDLDATA(ISEC),MDLCOPY(1),NSEC,MSEC,
     &'nspins',6,IN,1,0,RE,1,0,CM,1,0,TCTRL,10,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Transform to integer keys
	CALL LIB_CONVLOW(TCTRL,10)
	CALL LIB_RMBLANK(TCTRL,10)
	NB=INDEX(TCTRL,' ')
	ISYM=0
	IF(TCTRL(:NB-1).EQ.'auto'.AND.ISYM.EQ.1)ISPN=1
	IF(TCTRL(:NB-1).EQ.'auto'.AND.ISYM.EQ.2)ISPN=2
	IF(TCTRL(:NB-1).EQ.'one' )ISPN=1
	IF(TCTRL(:NB-1).EQ.'both')ISYM=2
	IF(ISYM.EQ.0)
     &CALL FULLSTOP('Wrong <<nspins>> keyword in MDLFILE')
C **************************************
      CALL READ_ERRR(MDLDATA(ISEC),MDLCOPY(1),NSEC,MSEC,'CTRL')
      DEALLOCATE(MDLCOPY)
	END SUBROUTINE MDL_READMDL_HUB1


	SUBROUTINE MDL_READMDL_SBMF(MDLDATA,NLEN)
*******************************************************
* Reads settings for slave boson mean field solver
*******************************************************
C SET EXTERNAL CONNECTIONS
      USE COM_MDLPAR  ,ONLY : IMOD,IMPS,ISYM,ISPN
      USE COM_UNIT    ,ONLY : IUN,IUR,IUT
C SET LOCAL VARIABLES 
      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER, INTRINSIC :: SIZE
      CHARACTER*150, ALLOCATABLE :: MDLCOPY(:)
      CHARACTER*150, MDLDATA(NLEN)
      CHARACTER TEXT*64,TCTRL*10,STRING*150,HELP*40,SNOT*20
      LOGICAL DEF,ASK,VAL,NTH,MDF
      DATA PI/3.141592653589793D0/
C **************************************
C READING CONTROLS
      CALL READ_SECT(MDLDATA(1),NLEN,ISEC,NSEC,MSEC,
     &'<section=sbmf',13,'<section=',9,'ok',2)
C Set section title
      DO IPOS=1,150
      IF(MDLDATA(ISEC)(IPOS:IPOS).EQ.'>')EXIT
      ENDDO
      DO JPOS=IPOS+1,150
      IF(MSEC.NE.0)MDLDATA(ISEC)(JPOS:JPOS)=' '
      ENDDO
      IF(IPOS.LE.50)THEN
      HELP='! CONTROL PARAMETERS:                   '
      IF(MSEC.NE.0)MDLDATA(ISEC)(IPOS+1:IPOS+40)=HELP
      ENDIF
C Allocate temporary file
      ALLOCATE(MDLCOPY(NSEC))
      DO ILIN=1,MSEC
      MDLCOPY(ILIN)=MDLDATA(ILIN+ISEC-1)
      ENDDO
C **************************************
C READING THE DATA: SELECT SYMMETRY
C Process SCHM
      TCTRL='CRF'
      HELP='! SUN/CRF/MAT                           '
      LHLP=40
      CALL READ_CHAR(MDLDATA(ISEC),MDLCOPY(1),NSEC,MSEC,
     &'symmet',6,IN,1,0,RE,1,0,CM,1,0,TCTRL,10,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Transform to integer keys
	CALL LIB_CONVLOW(TCTRL,10)
	CALL LIB_RMBLANK(TCTRL,10)
	NB=INDEX(TCTRL,' ')
	ISYM=0
	IF(TCTRL(:NB-1).EQ.'sun')ISYM=1
	IF(TCTRL(:NB-1).EQ.'crf')ISYM=2
	IF(TCTRL(:NB-1).EQ.'mat')ISYM=3
	IF(ISYM.EQ.0)
     &CALL FULLSTOP('Wrong <<symmet>> keyword in MDLFILE')
C **************************************
C READING THE DATA: SELECT SPINS
C Process SPINS
      TCTRL='auto'
      HELP='! # of spins: auto/one/both             '
      LHLP=40
      CALL READ_CHAR(MDLDATA(ISEC),MDLCOPY(1),NSEC,MSEC,
     &'nspins',6,IN,1,0,RE,1,0,CM,1,0,TCTRL,10,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Transform to integer keys
	CALL LIB_CONVLOW(TCTRL,10)
	CALL LIB_RMBLANK(TCTRL,10)
	NB=INDEX(TCTRL,' ')
	ISYM=0
	IF(TCTRL(:NB-1).EQ.'auto'.AND.ISYM.EQ.1)ISPN=1
	IF(TCTRL(:NB-1).EQ.'auto'.AND.ISYM.EQ.2)ISPN=2
	IF(TCTRL(:NB-1).EQ.'one' )ISPN=1
	IF(TCTRL(:NB-1).EQ.'both')ISYM=2
	IF(ISYM.EQ.0)
     &CALL FULLSTOP('Wrong <<nspins>> keyword in MDLFILE')
C **************************************
      CALL READ_ERRR(MDLDATA(ISEC),MDLCOPY(1),NSEC,MSEC,'CTRL')
      DEALLOCATE(MDLCOPY)
	END SUBROUTINE MDL_READMDL_SBMF


	SUBROUTINE MDL_READMDL_IRAT(MDLDATA,NLEN)
*******************************************************
* Reads settings for slave boson mean field solver
*******************************************************
C SET EXTERNAL CONNECTIONS
      USE COM_MDLPAR  ,ONLY : IMOD,IMPS,ISYM,ISPN
      USE COM_UNIT    ,ONLY : IUN,IUR,IUT
C SET LOCAL VARIABLES 
      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER, INTRINSIC :: SIZE
      CHARACTER*150, ALLOCATABLE :: MDLCOPY(:)
      CHARACTER*150, MDLDATA(NLEN)
      CHARACTER TEXT*64,TCTRL*10,STRING*150,HELP*40,SNOT*20
      LOGICAL DEF,ASK,VAL,NTH,MDF
      DATA PI/3.141592653589793D0/
C **************************************
C READING CONTROLS
      CALL READ_SECT(MDLDATA(1),NLEN,ISEC,NSEC,MSEC,
     &'<section=irat',13,'<section=',9,'ok',2)
C Set section title
      DO IPOS=1,150
      IF(MDLDATA(ISEC)(IPOS:IPOS).EQ.'>')EXIT
      ENDDO
      DO JPOS=IPOS+1,150
      IF(MSEC.NE.0)MDLDATA(ISEC)(JPOS:JPOS)=' '
      ENDDO
      IF(IPOS.LE.50)THEN
      HELP='! CONTROL PARAMETERS:                   '
      IF(MSEC.NE.0)MDLDATA(ISEC)(IPOS+1:IPOS+40)=HELP
      ENDIF
C Allocate temporary file
      ALLOCATE(MDLCOPY(NSEC))
      DO ILIN=1,MSEC
      MDLCOPY(ILIN)=MDLDATA(ILIN+ISEC-1)
      ENDDO
C **************************************
C READING THE DATA: SELECT SYMMETRY
C Process SCHM
      TCTRL='CRF'
      HELP='! SUN/CRF/MAT                           '
      LHLP=40
      CALL READ_CHAR(MDLDATA(ISEC),MDLCOPY(1),NSEC,MSEC,
     &'symmet',6,IN,1,0,RE,1,0,CM,1,0,TCTRL,10,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Transform to integer keys
	CALL LIB_CONVLOW(TCTRL,10)
	CALL LIB_RMBLANK(TCTRL,10)
	NB=INDEX(TCTRL,' ')
	ISYM=0
	IF(TCTRL(:NB-1).EQ.'sun')ISYM=1
	IF(TCTRL(:NB-1).EQ.'crf')ISYM=2
	IF(TCTRL(:NB-1).EQ.'mat')ISYM=3
	IF(ISYM.EQ.0)
     &CALL FULLSTOP('Wrong <<symmet>> keyword in MDLFILE')
C **************************************
C READING THE DATA: SELECT SPINS
C Process SPINS
      TCTRL='auto'
      HELP='! # of spins: auto/one/both             '
      LHLP=40
      CALL READ_CHAR(MDLDATA(ISEC),MDLCOPY(1),NSEC,MSEC,
     &'nspins',6,IN,1,0,RE,1,0,CM,1,0,TCTRL,10,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Transform to integer keys
	CALL LIB_CONVLOW(TCTRL,10)
	CALL LIB_RMBLANK(TCTRL,10)
	NB=INDEX(TCTRL,' ')
	ISYM=0
	IF(TCTRL(:NB-1).EQ.'auto'.AND.ISYM.EQ.1)ISPN=1
	IF(TCTRL(:NB-1).EQ.'auto'.AND.ISYM.EQ.2)ISPN=2
	IF(TCTRL(:NB-1).EQ.'one' )ISPN=1
	IF(TCTRL(:NB-1).EQ.'both')ISYM=2
	IF(ISYM.EQ.0)
     &CALL FULLSTOP('Wrong <<nspins>> keyword in MDLFILE')
C **************************************
      CALL READ_ERRR(MDLDATA(ISEC),MDLCOPY(1),NSEC,MSEC,'CTRL')
      DEALLOCATE(MDLCOPY)
	END SUBROUTINE MDL_READMDL_IRAT



	SUBROUTINE MDL_READMDL_QMCF(MDLDATA,NLEN)
*******************************************************
* Reads settings for QMC Method
*******************************************************
C SET EXTERNAL CONNECTIONS
      USE COM_MDLPAR  ,ONLY : IMOD,IMPS,ISYM
	USE COM_QMCOUT  ,ONLY : ICQMC,QMCFILE,ICQMS,QMSFILE
	USE COM_QMCEXT  ,ONLY : EXTNQMC,EXTNQMS
	USE COM_CHANNELS,ONLY : IUINP
      USE COM_UNIT    ,ONLY : IUN,IUR,IUT
C SET LOCAL VARIABLES 
      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER, INTRINSIC :: SIZE
      CHARACTER*150, ALLOCATABLE :: MDLCOPY(:)
      CHARACTER*150, MDLDATA(NLEN)
      CHARACTER TEXT*64,TCTRL*10,STRING*150,FILE*130,HELP*40,SNOT*20
      LOGICAL DEF,ASK,VAL,NTH,MDF,EXIST
      DATA PI/3.141592653589793D0/
C **************************************
C READING CONTROLS
      CALL READ_SECT(MDLDATA(1),NLEN,ISEC,NSEC,MSEC,
     &'<section=qmcf',13,'<section=',9,'ok',2)
C Set section title
      DO IPOS=1,150
      IF(MDLDATA(ISEC)(IPOS:IPOS).EQ.'>')EXIT
      ENDDO
      DO JPOS=IPOS+1,150
      IF(MSEC.NE.0)MDLDATA(ISEC)(JPOS:JPOS)=' '
      ENDDO
      IF(IPOS.LE.50)THEN
      HELP='! CONTROL PARAMETERS:                   '
      IF(MSEC.NE.0)MDLDATA(ISEC)(IPOS+1:IPOS+40)=HELP
      ENDIF
C Allocate temporary file
      ALLOCATE(MDLCOPY(NSEC))
      DO ILIN=1,MSEC
      MDLCOPY(ILIN)=MDLDATA(ILIN+ISEC-1)
      ENDDO
C **************************************
C READING THE DATA: SELECT SYMMETRY
C Process SCHM
      TCTRL='CRF'
      HELP='! SUN/CRF/MAT                           '
      LHLP=40
      CALL READ_CHAR(MDLDATA(ISEC),MDLCOPY(1),NSEC,MSEC,
     &'symmet',6,IN,1,0,RE,1,0,CM,1,0,TCTRL,10,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Transform to integer keys
	CALL LIB_CONVLOW(TCTRL,10)
	CALL LIB_RMBLANK(TCTRL,10)
	NB=INDEX(TCTRL,' ')
	ISYM=0
	IF(TCTRL(:NB-1).EQ.'sun')ISYM=1
	IF(TCTRL(:NB-1).EQ.'crf')ISYM=2
	IF(TCTRL(:NB-1).EQ.'mat')ISYM=3
	IF(ISYM.EQ.0)
     &CALL FULLSTOP('Wrong <<symmet>> keyword in MDLFILE')
C *************************************
C Get QMCFILE name
      HELP='! Path to QMCFile                       '
      DO I=1,130
      FILE(I:I)=' '
      ENDDO
      LHLP=40
      CALL READ_CHAR(MDLDATA(ISEC),MDLCOPY(1),NSEC,MSEC,
     &'qmcfile',7,IN,1,0,RE,1,0,CM,1,0,FILE,130,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
      CALL LIB_CONVLOW(FILE,130)
      CALL LIB_RMBLANK(FILE,130)
      CALL FIND_LBLANK(FILE,130,NBP)
      CALL FIND_LBLANK(EXTNQMC,60,NBE)
	QMCFILE=FILE(:NBP)//'.'//EXTNQMC(:NBE)
	INQUIRE(FILE=QMCFILE,EXIST=EXIST)
	IF(.NOT.EXIST)CALL FULLSTOP('<QMCFILE> not found!')
C *************************************
C Get QMSFILE name
      HELP='! Path to QmsFile                       '
      DO I=1,130
      FILE(I:I)=' '
      ENDDO
      ICQMS=0
      LHLP=40
      CALL READ_CHAR(MDLDATA(ISEC),MDLCOPY(1),NSEC,MSEC,
     &'qmsfile',7,IN,1,0,RE,1,0,CM,1,0,FILE,130,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
      CALL LIB_CONVLOW(FILE,130)
      CALL LIB_RMBLANK(FILE,130)
      CALL FIND_LBLANK(FILE,130,NBP)
      IF(NBP.GT.0)THEN
      ICQMS=1
      CALL FIND_LBLANK(EXTNQMS,60,NBE)
	QMSFILE=FILE(:NBP)//'.'//EXTNQMS(:NBE)
	INQUIRE(FILE=QMSFILE,EXIST=EXIST)
	IF(EXIST)THEN
	OPEN(UNIT=IUINP,FILE=QMSFILE,FORM='FORMATTED',STATUS='OLD')
	CALL FIND_LBLANK(QMSFILE,130,NA)
	WRITE(IUT,*)QMSFILE(:NA),' DELETED !'
	CLOSE(UNIT=IUINP,STATUS='DELETE')
	ENDIF
	ENDIF
C **************************************
      CALL READ_ERRR(MDLDATA(ISEC),MDLCOPY(1),NSEC,MSEC,'QMCF')
      DEALLOCATE(MDLCOPY)
	END SUBROUTINE MDL_READMDL_QMCF



	SUBROUTINE MDL_READMDL_RATF(MDLDATA,NLEN)
*******************************************************
* Reads settings for QMC Method
*******************************************************
C SET EXTERNAL CONNECTIONS
      USE COM_MDLPAR  ,ONLY : IMOD,IMPS,ISYM
	USE COM_RATOUT  ,ONLY : ICRAT,RATFILE,ICRSC,RSCFILE
	USE COM_RATEXT  ,ONLY : EXTNRAT,EXTNRSC
	USE COM_CHANNELS,ONLY : IUINP
      USE COM_UNIT    ,ONLY : IUN,IUR,IUT
C SET LOCAL VARIABLES 
      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER, INTRINSIC :: SIZE
      CHARACTER*150, ALLOCATABLE :: MDLCOPY(:)
      CHARACTER*150, MDLDATA(NLEN)
      CHARACTER TEXT*64,TCTRL*10,STRING*150,FILE*130,HELP*40,SNOT*20
      LOGICAL DEF,ASK,VAL,NTH,MDF,EXIST
      DATA PI/3.141592653589793D0/
C **************************************
C READING CONTROLS
      CALL READ_SECT(MDLDATA(1),NLEN,ISEC,NSEC,MSEC,
     &'<section=ratf',13,'<section=',9,'ok',2)
C Set section title
      DO IPOS=1,150
      IF(MDLDATA(ISEC)(IPOS:IPOS).EQ.'>')EXIT
      ENDDO
      DO JPOS=IPOS+1,150
      IF(MSEC.NE.0)MDLDATA(ISEC)(JPOS:JPOS)=' '
      ENDDO
      IF(IPOS.LE.50)THEN
      HELP='! CONTROL PARAMETERS:                   '
      IF(MSEC.NE.0)MDLDATA(ISEC)(IPOS+1:IPOS+40)=HELP
      ENDIF
C Allocate temporary file
      ALLOCATE(MDLCOPY(NSEC))
      DO ILIN=1,MSEC
      MDLCOPY(ILIN)=MDLDATA(ILIN+ISEC-1)
      ENDDO
C **************************************
C READING THE DATA: SELECT SYMMETRY
C Process SCHM
      TCTRL='CRF'
      HELP='! SUN/CRF/MAT                           '
      LHLP=40
      CALL READ_CHAR(MDLDATA(ISEC),MDLCOPY(1),NSEC,MSEC,
     &'symmet',6,IN,1,0,RE,1,0,CM,1,0,TCTRL,10,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Transform to integer keys
	CALL LIB_CONVLOW(TCTRL,10)
	CALL LIB_RMBLANK(TCTRL,10)
	NB=INDEX(TCTRL,' ')
	ISYM=0
	IF(TCTRL(:NB-1).EQ.'sun')ISYM=1
	IF(TCTRL(:NB-1).EQ.'crf')ISYM=2
	IF(TCTRL(:NB-1).EQ.'mat')ISYM=3
	IF(ISYM.EQ.0)
     &CALL FULLSTOP('Wrong <<symmet>> keyword in MDLFILE')
C *************************************
C Get RATFILE name
      HELP='! Path to RatFile                       '
      DO I=1,130
      FILE(I:I)=' '
      ENDDO
      LHLP=40
      CALL READ_CHAR(MDLDATA(ISEC),MDLCOPY(1),NSEC,MSEC,
     &'ratfile',7,IN,1,0,RE,1,0,CM,1,0,FILE,130,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
      CALL LIB_CONVLOW(FILE,130)
      CALL LIB_RMBLANK(FILE,130)
      CALL FIND_LBLANK(FILE,130,NBP)
      CALL FIND_LBLANK(EXTNRAT,60,NBE)
	RATFILE=FILE(:NBP)//'.'//EXTNRAT(:NBE)
	INQUIRE(FILE=RATFILE,EXIST=EXIST)
	IF(.NOT.EXIST)CALL FULLSTOP('<RATFILE> not found!')
C *************************************
C Get RSCFILE name
      HELP='! Path to RscFile                       '
      DO I=1,130
      FILE(I:I)=' '
      ENDDO
      ICRSC=0
      LHLP=40
      CALL READ_CHAR(MDLDATA(ISEC),MDLCOPY(1),NSEC,MSEC,
     &'rscfile',7,IN,1,0,RE,1,0,CM,1,0,FILE,130,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
      CALL LIB_CONVLOW(FILE,130)
      CALL LIB_RMBLANK(FILE,130)
      CALL FIND_LBLANK(FILE,130,NBP)
      IF(NBP.GT.0)THEN
      ICRSC=1
      CALL FIND_LBLANK(EXTNRSC,60,NBE)
	RSCFILE=FILE(:NBP)//'.'//EXTNRSC(:NBE)
	INQUIRE(FILE=RSCFILE,EXIST=EXIST)
	IF(EXIST)THEN
	OPEN(UNIT=IUINP,FILE=RSCFILE,FORM='FORMATTED',STATUS='OLD')
	CALL FIND_LBLANK(RSCFILE,130,NA)
	WRITE(IUT,*)RSCFILE(:NA),' DELETED !'
	CLOSE(UNIT=IUINP,STATUS='DELETE')
	ENDIF
	ENDIF
C **************************************
      CALL READ_ERRR(MDLDATA(ISEC),MDLCOPY(1),NSEC,MSEC,'RATF')
      DEALLOCATE(MDLCOPY)
	END SUBROUTINE MDL_READMDL_RATF



	SUBROUTINE MDL_READMDL_SHEL(MDLDATA,NLEN)
*******************************************************
* Reads control                                       *
*******************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LSHELL  ,ONLY : NORB,LORB,LOCCIMP,HMAG,KSYS,CSTA,
     &                        HORB,ALSC,ELEV,FSLA,NFILSHL,NFLUSHL,    !!! from readmdl
     &                        DAMP,NRUNSHL,KSTSHL 
      USE COM_IMPGRF  ,ONLY : CHEM,FILL,KINT,KRAT,NMOM,NPOL,NRAT      !!! from readmdl
     &                       ,NPLD,KDIN,KDRT
      USE COM_UNIT    ,ONLY : IUN,IUR,IUT                             !!! from readmdl
C SET LOCAL VARIABLES 
      IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER*150, ALLOCATABLE :: MDLCOPY(:)
      INTEGER KST(14)
	REAL*8 ELOC(14)
      CHARACTER*150, MDLDATA(NLEN)
      CHARACTER TEXT*64,TCTRL*10,STRING*150,HELP*40,SNOT*20
     &   ,CTHUB*2,CLHUB*1,TORB*2
      LOGICAL DEF,ASK,VAL,NTH,MDF
      DATA PI/3.141592653589793D0/
C MEMORY ALLOCATIONS FOR MAIN ARRAYS
C None
	DO L=0,3
	FSLA(L)=0.D0
	ENDDO
	DO IDEG=1,14
	ELOC(IDEG)=0.D0
	ENDDO
C **************************************
C READING CONTROLS
      CALL READ_SECT(MDLDATA(1),NLEN,ISEC,NSEC,MSEC,
     &'<section=shel',13,'<section=',9,'ok',2)
C Set section title
      DO IPOS=1,150
      IF(MDLDATA(ISEC)(IPOS:IPOS).EQ.'>')EXIT
      ENDDO
      DO JPOS=IPOS+1,150
      IF(MSEC.NE.0)MDLDATA(ISEC)(JPOS:JPOS)=' '
      ENDDO
      IF(IPOS.LE.50)THEN
      HELP='! SHELL DATA                            '
      IF(MSEC.NE.0)MDLDATA(ISEC)(IPOS+1:IPOS+40)=HELP
      ENDIF
C Allocate temporary file
      ALLOCATE(MDLCOPY(NSEC))
      DO ILIN=1,MSEC
      MDLCOPY(ILIN)=MDLDATA(ILIN+ISEC-1)
      ENDDO
C Process cState (cannot be blank)
      TCTRL='El@0::1s  '
      HELP='! Correlated State pointer              '
      LHLP=40
      CALL READ_CHAR(MDLDATA(ISEC),MDLCOPY(1),NSEC,MSEC,
     &'cstate',6,IN,1,0,RE,1,0,CM,1,0,TCTRL,10,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
	CSTA=TCTRL
	CALL GET_STATE(TCTRL,10,IAORB,ISORB,MQ,LORB,M,1)
	IF(LORB.LT.0.OR.LORB.GT.3)
     &CALL FULLSTOP('Wrong correlated state pointer') 
	NORB=MQ
C Process Fill
      NFILSHL=0
      HELP='! Shell Mean Filling                    '
      LHLP=40
      CALL READ_CHAR(MDLDATA(ISEC),MDLCOPY(1),NSEC,MSEC,
     &'nfill',5,NFILSHL,1,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Process Fluc
      NFLUSHL=0
      HELP='! Fluctuations around mean filling      '
      LHLP=40
      CALL READ_CHAR(MDLDATA(ISEC),MDLCOPY(1),NSEC,MSEC,
     &'nfluc',5,NFLUSHL,1,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Process Hmag
      HMAG=0.D0
      HELP='! External magnetic spin field          '
      LHLP=40
      CALL READ_CHAR(MDLDATA(ISEC),MDLCOPY(1),NSEC,MSEC,
     &'hmag',4,IN,1,0,HMAG,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Process Horb
      HORB=0.D0
      HELP='! External magnetic orbtial field       '
      LHLP=40
      CALL READ_CHAR(MDLDATA(ISEC),MDLCOPY(1),NSEC,MSEC,
     &'horb',4,IN,1,0,HORB,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Process Alsc
      ALSC=0.D0
      HELP='! Spin orbit coupling strength          '
      LHLP=40
      CALL READ_CHAR(MDLDATA(ISEC),MDLCOPY(1),NSEC,MSEC,
     &'alsc',4,IN,1,0,ALSC,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Process Damp
      DAMP=0.D0
      HELP='! Damping parameter                     '
      LHLP=40
      CALL READ_CHAR(MDLDATA(ISEC),MDLCOPY(1),NSEC,MSEC,
     &'damp',4,IN,1,0,DAMP,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Process coordinate system for local levels
      TCTRL='spherical '
      HELP='! system: cubic/spherical/spinor        '
      LHLP=40
      CALL READ_CHAR(MDLDATA(ISEC),MDLCOPY(1),NSEC,MSEC,
     &'crdsys',6,IN,1,0,RE,1,0,CM,1,0,TCTRL,10,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
      CALL LIB_CONVLOW(TCTRL,10)
      CALL LIB_RMBLANK(TCTRL,10)
	NB=INDEX(TCTRL,' ')
	KSYS=-1
	IF(TCTRL(:NB-1).EQ.'cubic'    )KSYS=1
	IF(TCTRL(:NB-1).EQ.'spherical')KSYS=2
	IF(TCTRL(:NB-1).EQ.'spinor'   )KSYS=3
C	IF(TCTRL(:NB-1).EQ.'diagonal' )KSYS=4
C	IF(TCTRL(:NB-1).EQ.'custom'   )KSYS=5
	IF(KSYS.EQ.-1)
     &CALL FULLSTOP('Coordinate system not recognized')
C Process Eloc
	IF(LORB.LE.1)HELP='! Local level energies                  '
	IF(LORB.GT.1)HELP='                                        '
      LHLP=40
      DO I=1,14
      ELOC(I)=0.D0
      ENDDO
      CALL READ_CHAR(MDLDATA(ISEC),MDLCOPY(1),NSEC,MSEC,
     &'eloc(:)',7,IN,1,0,ELOC,2*(2*LORB+1),1,CM,1,0,' ',1,0,
     &HELP,LHLP,DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C **************************************
C Process # of runs for impurity solver
	NRUN=1
      HELP='! # of runs for impurity solver         '
      LHLP=40
      CALL READ_CHAR(MDLDATA(ISEC),MDLCOPY(1),NSEC,MSEC,
     &'imprun',6,NRUN,1,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
	NRUNSHL=NRUN
C **************************************
C For each run process states which participate
	NDIM=2*(2*LORB+1)
	DO IRUN=1,NRUNSHL          !!! ovr runs
	DO IDIM=1,NDIM
	KST(IDIM)=IDIM
	ENDDO
      HELP='! states pointer in each run            '
	CALL READ_CHAR(MDLDATA(ISEC),MDLCOPY(1),NSEC,MSEC,
     &'kstates(:)',10,KST,NDIM,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.FALSE.,.FALSE.)
	DO IDIM=1,NDIM
	KSTSHL(IDIM,IRUN)=KST(IDIM)
	ENDDO
C Count degeneracies
	NDEG=0
	DO IDIM=1,NDIM
	IF(KSTSHL(IDIM,IRUN).NE.0)NDEG=NDEG+1
	ENDDO
	IF(MOD(NDEG,2).NE.0)
     &CALL FULLSTOP('Wrong kstates(:) pointer')
	ENDDO                          !!! over runs
C Process Rational Interpolation Method
      TCTRL='mom4      '
      HELP='! Rational interpolation method         '
      LHLP=40
      CALL READ_CHAR(MDLDATA(ISEC),MDLCOPY(1),NSEC,MSEC,
     &'sigint',6,IN,1,0,RE,1,0,CM,1,0,TCTRL,10,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
	CALL LIB_CONVLOW(TCTRL,10)
	CALL LIB_RMBLANK(TCTRL,10)
	NB=INDEX(TCTRL,' ')
	KINT=-1
	IF(TCTRL(:NB-1).EQ.'none')KINT=0
	IF(TCTRL(:NB-1).EQ.'mom2')KINT=1
	IF(TCTRL(:NB-1).EQ.'mom4')KINT=2
	IF(TCTRL(:NB-1).EQ.'mom6')KINT=3
	IF(TCTRL(:NB-1).EQ.'momn')KINT=4
C Process NPOL for impurity self-energy
      IF(KINT.EQ.0)NPOL=0
      IF(KINT.EQ.1)NPOL=1
      IF(KINT.EQ.2)NPOL=3
      IF(KINT.EQ.3)NPOL=5
      IF(KINT.EQ.4)NPOL=5
      HELP='! # of poles in Sigma(w) fit           '
      LHLP=40
      CALL READ_CHAR(MDLDATA(ISEC),MDLCOPY(1),NSEC,MSEC,
     &'npol',4,NPOL,1,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.FALSE.,.FALSE.)
	IF(MOD(NPOL+1,2).NE.0.AND.NPOL.GT.0)
     &CALL FULLSTOP('<GETGRF>:: Npol must be Even')
      IF(KINT.EQ.0)NRAT=0
      IF(KINT.EQ.1)NRAT=2
      IF(KINT.EQ.2)NRAT=4
      IF(KINT.EQ.3)NRAT=6
      IF(KINT.EQ.4)NRAT=NPOL+1
      IF(NRAT.NE.NPOL+1.AND.NPOL.GT.0)
     &CALL FULLSTOP('<MDL_READMDL>::NRAT.NE.NPOL+1')
	IF(MOD(NRAT,2).NE.0)
     &CALL FULLSTOP('<MDL_READMDL>:: Nrat must be ODD')
	NMOM=MAX(NRAT,5)
C Force rational interpolation for Self-Energy
      TCTRL='sigmaw    '
      HELP='! Force rational interpolation for Sigma'
      LHLP=40
      CALL READ_CHAR(MDLDATA(ISEC),MDLCOPY(1),NSEC,MSEC,
     &'sigrat',6,IN,1,0,RE,1,0,CM,1,0,TCTRL,10,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
	CALL LIB_CONVLOW(TCTRL,10)
	CALL LIB_RMBLANK(TCTRL,10)
	NB=INDEX(TCTRL,' ')
	KRAT=-1
	IF(TCTRL(:NB-1).EQ.'sigmaw')KRAT=0
	IF(TCTRL(:NB-1).EQ.'ratint')KRAT=1
	IF(KRAT.EQ.-1)
     &CALL FULLSTOP('<MDL_READMDL>:Wrong <<krat>> keyword in MDLFILE')
C **************************************
C Process Delta Interpolation method
      TCTRL='none      '
      HELP='! Delta Interpolation Method            '
      LHLP=40
      CALL READ_CHAR(MDLDATA(ISEC),MDLCOPY(1),NSEC,MSEC,
     &'delint',6,IN,1,0,RE,1,0,CM,1,0,TCTRL,10,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
      CALL LIB_CONVLOW(TCTRL,10)
      CALL LIB_RMBLANK(TCTRL,10)
	NB=INDEX(TCTRL,' ')
	KDIN=-1
	IF(TCTRL(:NB-1).EQ.'none')KDIN=0
	IF(TCTRL(:NB-1).EQ.'mom2')KDIN=1
	IF(TCTRL(:NB-1).EQ.'mom4')KDIN=2
	IF(TCTRL(:NB-1).EQ.'mom6')KDIN=3
	IF(TCTRL(:NB-1).EQ.'momn')KDIN=4
	IF(TCTRL(:NB-1).EQ.'grid')KDIN=5
	IF(TCTRL(:NB-1).EQ.'conj')KDIN=6
	IF(TCTRL(:NB-1).EQ.'pade')KDIN=7
	IF(KDIN.EQ.-1)
     &CALL FULLSTOP('<HUB_READHUB>::Wrong <<delint>> keyword')
	IF(KDIN.EQ.1.OR.KDIN.EQ.2.OR.KDIN.EQ.3)WRITE(IUT,*)
     &'<RAT_READRAT>:: Reverse moments for metallic Delta(w) diverge!'
C **************************************
C Process Delta Representation
      TCTRL='deltaw    '
      HELP='! Delta Represenation: DeltaW/RatInt    '
      LHLP=40
      CALL READ_CHAR(MDLDATA(ISEC),MDLCOPY(1),NSEC,MSEC,
     &'delrat',6,IN,1,0,RE,1,0,CM,1,0,TCTRL,10,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
      CALL LIB_CONVLOW(TCTRL,10)
      CALL LIB_RMBLANK(TCTRL,10)
	NB=INDEX(TCTRL,' ')
	KDRT=-1
	IF(TCTRL(:NB-1).EQ.'deltaw')KDRT=0
	IF(TCTRL(:NB-1).EQ.'ratint')KDRT=1
C Process NPLD
      NPLD=0
      IF(KDIN.EQ.1)NPLD=2
      IF(KDIN.EQ.2)NPLD=4
      IF(KDIN.EQ.3)NPLD=6
      HELP='! # of poles for hybridization          '
      LHLP=40
      CALL READ_CHAR(MDLDATA(ISEC),MDLCOPY(1),NSEC,MSEC,
     &'npld',4,NPLD,1,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C **************************************
C Process Slater Integrals, F(0,ll),F(2,ll),F(4,ll), etc.
	DO L=0,LORB
	FSLT=0.D0
      HELP='! Slater integrals                      '
      LHLP=40
	WRITE(CLHUB,FMT='(I1)')2*L
	CTHUB='f'//CLHUB
      CALL READ_CHAR(MDLDATA(ISEC),MDLCOPY(1),NSEC,MSEC,
     &CTHUB,2,IN,1,0,FSLT,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
	FSLA(L)=FSLT
	ENDDO
C **************************************
      CALL READ_ERRR(MDLDATA(ISEC),MDLCOPY(1),NSEC,MSEC,'SHEL')
      DEALLOCATE(MDLCOPY)
	L=LORB
C Set up occupancies to be calculated
      NDIM=2*(2*LORB+1)
      IF(.NOT.ALLOCATED(LOCCIMP))
     &ALLOCATE(LOCCIMP(0:NDIM))
      DO IOCC=0,NDIM
      LOCCIMP(IOCC)=0
      ENDDO
      DO IOCC=0,NDIM
      IF(IOCC.GE.NFILSHL-NFLUSHL.AND.IOCC.LE.NFILSHL+NFLUSHL)
     &LOCCIMP(IOCC)=1
      ENDDO
C Matrix of local levels
	IF(.NOT.ALLOCATED(ELEV))
     &ALLOCATE(ELEV(NDIM,NDIM))
	DO IDEG1=1,NDIM
	DO IDEG=1,NDIM
	ELEV(IDEG1,IDEG)=(0.D0,0.D0)
	ENDDO
	ELEV(IDEG1,IDEG1)=DCMPLX(ELOC(IDEG1),0.D0)
	ENDDO
C Do not transform it to spherical harmonics	
      CALL LIB_TRANSCUB(NDIM,-KSYS,NDIM,-KSYS,ELEV)
C Memory deallocations
C none
	END SUBROUTINE MDL_READMDL_SHEL



	SUBROUTINE MDL_READMDL_BAND(MDLDATA,NLEN)
*******************************************************
* Reads band data
*******************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LSHELL  ,ONLY: NORB,LORB,KSYS
      USE COM_MDLPAR  ,ONLY: IMOD,IMPS,ISYM
      USE COM_IMPGRF  ,ONLY: CHEM,FILL,KINT                          !!! from readmdl
      USE COM_MDLBND  ,ONLY: TPAR,VPAR,ECON
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT
C SET LOCAL VARIABLES 
      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER, INTRINSIC :: SIZE
      CHARACTER*150, ALLOCATABLE :: MDLCOPY(:)
      CHARACTER*150, MDLDATA(NLEN)
      REAL*8 TBND(14),VBND(14),EBND(14)
      CHARACTER TEXT*64,TCTRL*10,STRING*150,FILE*130,HELP*40,SNOT*20
      LOGICAL DEF,ASK,VAL,NTH,MDF,EXIST
      DATA PI/3.141592653589793D0/
C MEMORY ALLOCATIONS
      NDIM=2*(2*LORB+1)      
C **************************************
C READING CONTROLS
      CALL READ_SECT(MDLDATA(1),NLEN,ISEC,NSEC,MSEC,
     &'<section=band',13,'<section=',9,'ok',2)
C Set section title
      DO IPOS=1,150
      IF(MDLDATA(ISEC)(IPOS:IPOS).EQ.'>')EXIT
      ENDDO
      DO JPOS=IPOS+1,150
      IF(MSEC.NE.0)MDLDATA(ISEC)(JPOS:JPOS)=' '
      ENDDO
      IF(IPOS.LE.50)THEN
      HELP='! CONTROL PARAMETERS:                   '
      IF(MSEC.NE.0)MDLDATA(ISEC)(IPOS+1:IPOS+40)=HELP
      ENDIF
C Allocate temporary file
      ALLOCATE(MDLCOPY(NSEC))
      DO ILIN=1,MSEC
      MDLCOPY(ILIN)=MDLDATA(ILIN+ISEC-1)
      ENDDO
C **************************************
C READING THE DATA: SELECT BAND DATA
C Process Tpar
	IF(LORB.LE.1)HELP='! Effective bandwidth/4                 '
	IF(LORB.GT.1)HELP='                                        '
      LHLP=40
      DO I=1,14
      TBND(I)=0.D0
      ENDDO
      CALL READ_CHAR(MDLDATA(ISEC),MDLCOPY(1),NSEC,MSEC,
     &'tpar(:)',7,IN,1,0,TBND,2*(2*LORB+1),1,CM,1,0,' ',1,0,
     &HELP,LHLP,DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Process Vpar
	IF(LORB.LE.1)HELP='! Effective hopppings                   '
	IF(LORB.GT.1)HELP='                                        '
      LHLP=40
      DO I=1,14
      VBND(I)=0.D0
      ENDDO
      CALL READ_CHAR(MDLDATA(ISEC),MDLCOPY(1),NSEC,MSEC,
     &'vpar(:)',7,IN,1,0,VBND,2*(2*LORB+1),1,CM,1,0,' ',1,0,
     &HELP,LHLP,DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Process Econ
	IF(LORB.LE.1)HELP='! Non-interacting band positions        '
	IF(LORB.GT.1)HELP='                                        '
      LHLP=40
      DO I=1,14
      EBND(I)=0.D0
      ENDDO
      CALL READ_CHAR(MDLDATA(ISEC),MDLCOPY(1),NSEC,MSEC,
     &'econ(:)',7,IN,1,0,EBND,2*(2*LORB+1),1,CM,1,0,' ',1,0,
     &HELP,LHLP,DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C **************************************
      CALL READ_ERRR(MDLDATA(ISEC),MDLCOPY(1),NSEC,MSEC,'CTRL')
      DEALLOCATE(MDLCOPY)
C Band matrices in KSYS representation
      ALLOCATE(TPAR(NDIM,NDIM))
      ALLOCATE(VPAR(NDIM,NDIM))
      ALLOCATE(ECON(NDIM,NDIM))
      DO IDIM1=1,NDIM
      DO IDIM =1,NDIM
      TPAR(IDIM1,IDIM)=(0.D0,0.D0)
      VPAR(IDIM1,IDIM)=(0.D0,0.D0)
      ECON(IDIM1,IDIM)=(0.D0,0.D0)
      ENDDO
      ENDDO
      DO IDIM=1,NDIM
      TPAR(IDIM,IDIM)=DCMPLX(TBND(IDIM),0.D0)
      VPAR(IDIM,IDIM)=DCMPLX(VBND(IDIM),0.D0)
      ECON(IDIM,IDIM)=DCMPLX(EBND(IDIM),0.D0)
      ENDDO
C Do not transform matrices      
      CALL LIB_TRANSCUB(NDIM,-KSYS,NDIM,-KSYS,TPAR)
      CALL LIB_TRANSCUB(NDIM,-KSYS,NDIM,-KSYS,VPAR)
      CALL LIB_TRANSCUB(NDIM,-KSYS,NDIM,-KSYS,ECON)
	END SUBROUTINE MDL_READMDL_BAND


	