	SUBROUTINE MDL_SCFIRAT
**************************************************************
* Computes Impurity Green function with DMFT using           *
* rational interpolation method.                             *
**************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                       !!! from setup
	USE COM_MDLPAR  ,ONLY: IMPS,IMOD,ISYM,ISPN
	USE COM_MDLMIX  ,ONLY: NDIT
      USE COM_MDLBND  ,ONLY: TPAR,VPAR,ECON
      USE COM_LSHELL  ,ONLY: NORB,LORB,LOCCIMP,HMAG,KSYS,CSTA,
     &                       HORB,ALSC,ELEV,FSLA,NFILSHL,NFLUSHL,
     &                       NRUNSHL,KSTSHL 
      USE COM_IMPGRF  ,ONLY: CHEM,ICUB,SIGW,GMOM,DMAT,
     &                       GLOC,SIGI,NPOL,DELW,NMOM,
     &                       SRAT,VRAT,WRAT,PRAT,ORAT
      USE COM_MSBMESH ,ONLY: TEMP,NMSB,WMSB,NOMG,WOMG,FMSB,KGRD
     &                      ,NMSC,WMSC 
      USE COM_MASHDEP ,ONLY: NVAL,LENCMP
      USE COM_MDLOUT  ,ONLY: ICGRF
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
C Allocatable arrays
	INTEGER, SAVE, ALLOCATABLE :: LREP(:)
	REAL*8, SAVE, ALLOCATABLE :: COMB(:,:)
	REAL*8, ALLOCATABLE :: UMAT(:,:,:,:)
C
	INTEGER, ALLOCATABLE :: KATS(:)
	INTEGER, ALLOCATABLE :: MREP(:)
	INTEGER, ALLOCATABLE :: LCFG(:)
	INTEGER, ALLOCATABLE :: IPCF(:)
	INTEGER, ALLOCATABLE :: IPRF(:)
	INTEGER, ALLOCATABLE :: IPNF(:)
	INTEGER, ALLOCATABLE :: IPNF0(:)
	INTEGER, ALLOCATABLE :: IPNFP1(:)
	INTEGER, ALLOCATABLE :: LRPH(:)
	INTEGER, ALLOCATABLE :: LREP0(:)
	INTEGER, ALLOCATABLE :: LREP1(:)
	INTEGER, ALLOCATABLE :: LREP2(:)
	INTEGER, ALLOCATABLE :: KDREP(:)
	INTEGER, ALLOCATABLE :: KDR00(:)
	INTEGER, ALLOCATABLE :: KDR12(:)
	REAL*8, ALLOCATABLE :: COMR(:)
C
	REAL*8, SAVE, ALLOCATABLE :: TBND(:,:)
	REAL*8, SAVE, ALLOCATABLE :: VBND(:,:)
	REAL*8, SAVE, ALLOCATABLE :: EBND(:,:)
	REAL*8, SAVE, ALLOCATABLE :: ELOC(:,:)
	REAL*8, SAVE, ALLOCATABLE :: EDOP(:,:)
C
	COMPLEX*16, SAVE, ALLOCATABLE :: GTMP(:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: DTMP(:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: STMP(:,:)
C
      COMPLEX*16, SAVE, ALLOCATABLE :: GFF(:,:,:)
      COMPLEX*16, SAVE, ALLOCATABLE :: GCC(:,:,:)
      COMPLEX*16, SAVE, ALLOCATABLE :: SIG(:,:,:)
      COMPLEX*16, SAVE, ALLOCATABLE :: DEL(:,:,:)
      COMPLEX*16, SAVE, ALLOCATABLE :: GFR(:,:,:)
      COMPLEX*16, SAVE, ALLOCATABLE :: GCR(:,:,:)
      COMPLEX*16, SAVE, ALLOCATABLE :: SIR(:,:,:)
      COMPLEX*16, SAVE, ALLOCATABLE :: DLR(:,:,:)
C
	REAL*8, ALLOCATABLE :: SINF(:,:)
	REAL*8, ALLOCATABLE :: VCOF(:,:)
	REAL*8, ALLOCATABLE :: WCOF(:,:)
	REAL*8, ALLOCATABLE :: POLE(:,:)
	REAL*8, ALLOCATABLE :: OVRL(:,:)
	COMPLEX*16, ALLOCATABLE :: WSIG(:,:,:)
	COMPLEX*16, ALLOCATABLE :: PSIG(:,:,:)
C
	REAL*8, ALLOCATABLE :: ZIMP(:,:)
	REAL*8, ALLOCATABLE :: ZREP(:,:)
	REAL*8, ALLOCATABLE :: ZCON(:,:)
	REAL*8, ALLOCATABLE :: DIMP(:,:)
	REAL*8, ALLOCATABLE :: DREP(:,:)
C
	INTEGER, ALLOCATABLE :: IFIX(:,:)
	REAL*8, ALLOCATABLE :: ZTOT(:)
	REAL*8, ALLOCATABLE :: ZSUM(:)
	REAL*8, ALLOCATABLE :: ZPSI(:)
	REAL*8, ALLOCATABLE :: ZMAS(:,:)
	REAL*8, ALLOCATABLE :: PSIK(:,:)
	REAL*8, ALLOCATABLE :: EATS(:,:)
	REAL*8, ALLOCATABLE :: XHUB(:,:)
	REAL*8, ALLOCATABLE :: YHUB(:,:)
	REAL*8, ALLOCATABLE :: SIGM0(:,:)
	REAL*8, ALLOCATABLE :: SIGMI(:,:)
	COMPLEX*16, ALLOCATABLE :: OMSB(:)
	COMPLEX*16, ALLOCATABLE :: DLRT(:,:)
	COMPLEX*16, ALLOCATABLE :: GFRT(:,:)
	COMPLEX*16, ALLOCATABLE :: SIRT(:,:)
C Local variables
	COMPLEX*16 DIM,ZMSB,ZOMG
	CHARACTER*60 TEXT
	DATA PI/3.141592653589793D0/,DIM/(0.D0,1.D0)/
C START CODE
	IF(NRUNSHL.NE.1)
     &CALL FULLSTOP('<MDL_SCFHUB1>:: NRUNSHL>1 DOES NOT WORK!')
      IRUN=1
      IF(ISPN.EQ.1)NSPIN=1
      IF(ISPN.GT.1)NSPIN=2
C	
      NDIM=2*(2*LORB+1)
	NDEG=0 ! this is total degeneracy
	DO IDIM=1,NDIM
	IF(KSTSHL(IDIM,IRUN).NE.0)NDEG=NDEG+1
	ENDDO
	IF(NDEG.NE.NDIM)
     &CALL FULLSTOP('Wrong KSTATES array for atomic solver')
C COMBINATORICS
	ALLOCATE(COMB(0:NDEG,0:NDEG))
	CALL LIB_GETCOMB(COMB,NDEG)
C COULOMB INTERACTION	
      ALLOCATE(UMAT(-LORB:LORB,-LORB:LORB,-LORB:LORB,-LORB:LORB))
	CALL LIB_HUBMAT_L4(LORB,FSLA,UMAT,UPAR,GPAR)
C Count # of representations as non-equivalent elements of KSTATES pointer
	IREP0=0
	IREP1=0
	IREP2=0
	DO IPOS=1,NDIM
	ISUB0=0
	DO IDIM=1,NDIM
	IF(KSTSHL(IDIM,IRUN).EQ.IPOS)ISUB0=ISUB0+1
	ENDDO
	ISUB1=0
	DO IDIM=1,NDIM/2
	IF(KSTSHL(IDIM,IRUN).EQ.IPOS)ISUB1=ISUB1+1
	ENDDO
	ISUB2=0
	DO IDIM=NDIM/2+1,NDIM
	IF(KSTSHL(IDIM,IRUN).EQ.IPOS)ISUB2=ISUB2+1
	ENDDO
	IF(ISUB0.NE.0)IREP0=IREP0+1
	IF(ISUB1.NE.0)IREP1=IREP1+1
	IF(ISUB2.NE.0)IREP2=IREP2+1
	ENDDO
	NREP0=IREP0
	NREP1=IREP1
	NREP2=IREP2
	ALLOCATE(LREP0(NREP0))
	ALLOCATE(LREP1(NREP1))
	ALLOCATE(LREP2(NREP2))
	ALLOCATE(KDREP(NDIM))
	ALLOCATE(KDR00(NDIM))
	ALLOCATE(KDR12(NDIM))
	DO IDIM=1,NDIM
	KDR00(IDIM)=-1
	KDR12(IDIM)=-1
	ENDDO
C Find degeneracies of each sublevel
	IREP0=0
	IREP1=0
	IREP2=0
	DO IPOS=1,NDIM
	ISUB0=0
	DO IDIM=1,NDIM
	IF(KSTSHL(IDIM,IRUN).EQ.IPOS)ISUB0=ISUB0+1
	ENDDO
	IF(ISUB0.NE.0)THEN
	IREP0=IREP0+1
	LREP0(IREP0)=ISUB0
	DO IDIM=1,NDIM
	IF(KSTSHL(IDIM,IRUN).EQ.IPOS)KDR00(IDIM)=IREP0
	ENDDO
	ENDIF
	ISUB1=0
	DO IDIM=1,NDIM/2
	IF(KSTSHL(IDIM,IRUN).EQ.IPOS)ISUB1=ISUB1+1
	ENDDO
	IF(ISUB1.NE.0)THEN
	IREP1=IREP1+1
	LREP1(IREP1)=ISUB1
	DO IDIM=1,NDIM/2
	IF(KSTSHL(IDIM,IRUN).EQ.IPOS)KDR12(IDIM)=IREP1
	ENDDO
	ENDIF
	ISUB2=0
	DO IDIM=NDIM/2+1,NDIM
	IF(KSTSHL(IDIM,IRUN).EQ.IPOS)ISUB2=ISUB2+1
	ENDDO
	IF(ISUB2.NE.0)THEN
	IREP2=IREP2+1
	LREP2(IREP2)=ISUB2
	DO IDIM=NDIM/2+1,NDIM
	IF(KSTSHL(IDIM,IRUN).EQ.IPOS)KDR12(IDIM)=IREP2
	ENDDO
	ENDIF
	ENDDO
C Check full degeneracy
	IDEG=0
	DO IREP0=1,NREP0
	IDEG=IDEG+LREP0(IREP0)
	ENDDO
	IF(IDEG.NE.NDEG)
     &CALL FULLSTOP('Wrong KSTATES pointer for this solver')
	IDEG=0
	DO IREP1=1,NREP1
	IDEG=IDEG+LREP1(IREP1)
	ENDDO
	DO IREP2=1,NREP2
	IDEG=IDEG+LREP2(IREP2)
	ENDDO
	IF(IDEG.NE.NDEG)
     &CALL FULLSTOP('Wrong KSTATES pointer for this solver')
C Check if spin polarization is allowed
	IF(NREP1.EQ.NREP2)MSPIN=NSPIN
	IF(NREP1.NE.NREP2)MSPIN=1      ! switch off spin polarization
	IF(NREP1.EQ.NREP2)THEN         ! check again
	DO IREP=1,NREP1
	IF(LREP1(IREP).NE.LREP2(IREP))MSPIN=1
	ENDDO
	ENDIF
	IF(MSPIN.EQ.NSPIN)NREP=(NREP1+NREP2)/2
	IF(MSPIN.NE.NSPIN)NREP=NREP0
	ALLOCATE(LREP(NREP))
	DO IREP=1,NREP
	IF(MSPIN.EQ.NSPIN.AND.NREP1.EQ.NREP2)
     &LREP(IREP)=(LREP1(IREP)+LREP2(IREP))/MSPIN
	IF(MSPIN.NE.NSPIN.OR .NREP1.NE.NREP2)
     &LREP(IREP)=LREP0(IREP)
	ENDDO
	DO IDIM=1,NDIM
	IF(MSPIN.EQ.NSPIN)
     &KDREP(IDIM)=KDR12(IDIM)
	IF(MSPIN.NE.NSPIN)
     &KDREP(IDIM)=KDR00(IDIM)
	ENDDO
C CONFIGURATIONS PER SPIN, Minimum: NDEG/2+1, Maximum 2**(NDEG/2)
	DO ISPIN=1,MSPIN
	NCNF=1
	DO IREP=1,NREP
	NCNF=NCNF*(LREP(IREP)+1)
	ENDDO
	ENDDO
	IF(MSPIN.EQ.1)NCNF0=1
	IF(MSPIN.EQ.2)NCNF0=NCNF
C CONFIGURATIONS, Minimum: NDEG/2+1, Maximum 2**(NDEG/2)
	ALLOCATE(MREP(0:NREP))
	MREP(0)=1
	DO IREP=1,NREP
	MREP(IREP)=MREP(IREP-1)*(LREP(IREP)+1)
	ENDDO
C SORT BY NUMBERS OF ELECTRONS
	ALLOCATE(IPNF(NREP))
	ALLOCATE(IPNF0(NREP))
	ALLOCATE(IPNFP1(NREP))
	ALLOCATE(IPCF(NCNF))
	ALLOCATE(IPRF(NCNF))
	ALLOCATE(LCFG(0:NDEG/MSPIN))
C Looping over total allowed numbers of electrons in all sublevels
	ICFR=0
	DO IDEG=0,NDEG/MSPIN
	LCFG(IDEG)=0
C Configurations are numbered in one way from 1 to NCNF.
C Start looping over them
	DO ICNF=1,NCNF
C Find out numbers of electrons at each sublevel for given configuration ICNF
C Return array is IPNF(IREP) for spin channel
	CALL LIB_GETCONF(NREP,LREP,MREP,ICNF,NCNF,IPNF)
	NELC=0 ! count # of electrons for given configuration
	DO IREP=1,NREP
	NELC=NELC+IPNF(IREP)
	ENDDO
C if this configuration contains right number of electrons, count it
	IF(NELC.NE.IDEG)CYCLE 
	LCFG(IDEG)=LCFG(IDEG)+1
	ICFR=ICFR+1
C this pointer relates second-to-first numbering schemes for configurations
	IPCF(ICFR)=ICNF 
	ENDDO
	ENDDO
C CHECK ALGORITHM
	ICFR=0 ! second way of numbering configurations
C looping over allowed total numbers of electrons of the same spin
	DO IDEG=0,NDEG/MSPIN
C looping over configurations within given number of electrons of the same spin
	DO ICFG=1,LCFG(IDEG) 
	ICFR=ICFR+1
	ICNF=IPCF(ICFR) ! find out the configuration in first numbering scheme
C Find out array showing how many electrons are in each sublevel
	CALL LIB_GETCONF(NREP,LREP,MREP,ICNF,NCNF,IPNF) 
	NELC=0 ! count # of electrons
	DO IREP=1,NREP
	IF(IPNF(IREP).LT.0.OR.IPNF(IREP).GT.LREP(IREP))
     &CALL FULLSTOP('Wrong configuration')
	NELC=NELC+IPNF(IREP)
	ENDDO
	ENDDO
	IF(NELC.NE.IDEG)CALL FULLSTOP('# of electrons mismatch')
	ENDDO
C Set reciprocal pointer which related first-to-second numbering scheme for configirations
	DO ICNF=1,NCNF 
	IPRF(ICNF)=-1
	ENDDO
	DO ICFR=1,NCNF
	ICNF=IPCF(ICFR)
	IPRF(ICNF)=ICFR
	ENDDO
	DO ICNF=1,NCNF
	IF(IPRF(ICNF).EQ.-1)CALL FULLSTOP('Wrong reciprocal pointer')
	ENDDO
C Compute product of all combinatorics using second scheme of 
C numbering configurations
	ALLOCATE(COMR(NCNF))
	ICFR=0
	DO IDEG=0,NDEG/MSPIN
	DO ICFG=1,LCFG(IDEG)
	ICFR=ICFR+1
	ICNF=IPCF(ICFR)
	CALL LIB_GETCONF(NREP,LREP,MREP,ICNF,NCNF,IPNF)
	COMR(ICFR)=1.D0 
	DO IREP=1,NREP
	COMR(ICFR)=COMR(ICFR)*COMB(IPNF(IREP),LREP(IREP))
	ENDDO
	ENDDO
	ENDDO
C CHECK COMBINATORICS
	SUS=0.D0
	ICFR=0
	DO IDEG=0,NDEG/MSPIN
	SUM=0.D0
	DO ICFG=1,LCFG(IDEG)
	ICFR=ICFR+1
	SUM=SUM+COMR(ICFR)
	SUS=SUS+COMR(ICFR)
	ENDDO
	IF(ABS(SUM-COMB(IDEG,NDEG/MSPIN)).GT.1.D-07)
     &CALL FULLSTOP('Combinatorics mismatch')
	ENDDO
	IF(ABS(SUS-2.D0**(NDEG/MSPIN)).GT.1.D-07)
     &CALL FULLSTOP('Combinatorics mismatch')
C MEMORY ALLOCATIONS
	ALLOCATE(ELOC(NREP,NSPIN))
	ALLOCATE(EDOP(NREP,NSPIN))
	ALLOCATE(EBND(NREP,NSPIN))
	ALLOCATE(TBND(NREP,NSPIN))
	ALLOCATE(VBND(NREP,NSPIN))
	ALLOCATE(ZIMP(NREP,NSPIN))
	ALLOCATE(ZREP(NREP,NSPIN))
	ALLOCATE(ZCON(NREP,NSPIN))
	ALLOCATE(DIMP(NREP,NSPIN))
	ALLOCATE(DREP(NREP,NSPIN))
	ALLOCATE(SINF(NREP,NSPIN))
	ALLOCATE(VCOF(NREP,NSPIN))
	ALLOCATE(WCOF(NREP,NSPIN))
	ALLOCATE(POLE(NREP,NSPIN))
	ALLOCATE(OVRL(NREP,NSPIN))
	ALLOCATE(DEL(0:NMSB+1,NREP,NSPIN))
	ALLOCATE(GFF(0:NMSB+1,NREP,NSPIN))
	ALLOCATE(GCC(0:NMSB+1,NREP,NSPIN))
	ALLOCATE(SIG(0:NMSB+1,NREP,NSPIN))
	ALLOCATE(DLR(0:NOMG+1,NREP,NSPIN))
	ALLOCATE(GFR(0:NOMG+1,NREP,NSPIN))
	ALLOCATE(GCR(0:NOMG+1,NREP,NSPIN))
	ALLOCATE(SIR(0:NOMG+1,NREP,NSPIN))
	ALLOCATE(WSIG(NDEG*NDEG,NREP,NSPIN))
	ALLOCATE(PSIG(NDEG*NDEG,NREP,NSPIN))
	DO ISPIN=1,NSPIN
	DO IREP=1,NREP
	ELOC(IREP,ISPIN)=0.D0
	EDOP(IREP,ISPIN)=0.D0
	TBND(IREP,ISPIN)=0.D0
	VBND(IREP,ISPIN)=0.D0
	ZIMP(IREP,ISPIN)=0.D0
	ZREP(IREP,ISPIN)=0.D0
	ZCON(IREP,ISPIN)=0.D0
	DIMP(IREP,ISPIN)=0.D0
	DREP(IREP,ISPIN)=0.D0
	SINF(IREP,ISPIN)=0.D0
	VCOF(IREP,ISPIN)=0.D0
	WCOF(IREP,ISPIN)=0.D0
	POLE(IREP,ISPIN)=0.D0
	OVRL(IREP,ISPIN)=0.D0
	DO IMSB=0,NMSB+1
	DEL(IMSB,IREP,ISPIN)=(0.D0,0.D0)
	GFF(IMSB,IREP,ISPIN)=(0.D0,0.D0)
	GCC(IMSB,IREP,ISPIN)=(0.D0,0.D0)
	SIG(IMSB,IREP,ISPIN)=(0.D0,0.D0)
	ENDDO
	DO IOMG=0,NOMG+1
	DLR(IOMG,IREP,ISPIN)=(0.D0,0.D0)
	GFR(IOMG,IREP,ISPIN)=(0.D0,0.D0)
	GCR(IOMG,IREP,ISPIN)=(0.D0,0.D0)
	SIR(IOMG,IREP,ISPIN)=(0.D0,0.D0)
	ENDDO
	DO IRAT=1,NDEG*NDEG
	WSIG(IRAT,IREP,ISPIN)=(0.D0,0.D0)
	PSIG(IRAT,IREP,ISPIN)=(0.D0,0.D0)
	ENDDO
	ENDDO
	ENDDO
C Transform matrices to local representation
      CALL LIB_TRANSCUB(NDIM,+KSYS,NDIM,+KSYS,ELEV(1,1))
      CALL LIB_TRANSCUB(NDIM,+KSYS,NDIM,+KSYS,TPAR(1,1))
      CALL LIB_TRANSCUB(NDIM,+KSYS,NDIM,+KSYS,VPAR(1,1))
      CALL LIB_TRANSCUB(NDIM,+KSYS,NDIM,+KSYS,ECON(1,1))
C SET BAND PARAMETERS
	IDEG=0
	DO IDIM=1,NDIM
	IF(KSTSHL(IDIM,IRUN).EQ.0)CYCLE
	IDEG=IDEG+1
	IREP=KDREP(IDIM)
	ISPIN=(2*IDIM-1)/NDIM+1
	IF(MSPIN.EQ.1)ISPIN=1
	ELOC(IREP,ISPIN)=DREAL(ELEV(IDIM,IDIM))-CHEM
	EDOP(IREP,ISPIN)=DREAL(ELEV(IDIM,IDIM))-CHEM+
     &                 DBLE(NDEG-1)/2.D0*UPAR
	TBND(IREP,ISPIN)=DREAL(TPAR(IDIM,IDIM))
	VBND(IREP,ISPIN)=DREAL(VPAR(IDIM,IDIM))
	EBND(IREP,ISPIN)=DREAL(ECON(IDIM,IDIM))-CHEM
      ENDDO
C MEMORY ALLOCATIONS
	ALLOCATE(ZTOT(NSPIN))
	ALLOCATE(ZMAS(NREP,NSPIN))
	ALLOCATE(IFIX(NCNF,NCNF0))
	ALLOCATE(PSIK(NCNF,NCNF0))
	ALLOCATE(EATS(NCNF,NCNF0))
	ALLOCATE(XHUB(NCNF,NCNF0))
	ALLOCATE(YHUB(NCNF,NCNF0))
	ALLOCATE(DLRT(NREP,NSPIN))
	ALLOCATE(GFRT(NREP,NSPIN))
	ALLOCATE(SIRT(NREP,NSPIN))
	ALLOCATE(SIGM0(NREP,NSPIN))
	ALLOCATE(SIGMI(NREP,NSPIN))
      ALLOCATE(OMSB(0:NMSB))
      DO IMSB=0,NMSB
      OMSB(IMSB)=(0.D0,1.D0)*WMSB(IMSB)
      ENDDO
C Set zeroes
	DO ICNF=1,NCNF
	DO JCNF=1,NCNF0
	EATS(ICNF,JCNF)=0.D0
	PSIK(ICNF,JCNF)=0.D0
	XHUB(ICNF,JCNF)=0.D0
	YHUB(ICNF,JCNF)=0.D0
	IFIX(ICNF,JCNF)=0
	ENDDO
	ENDDO
C Green function and self-energy
	DO IDIM1=1,NDIM
	DO IDIM =1,NDIM
	DO IMSB=0,NMSB
	SIGW(IDIM1,IDIM,IMSB)=(0.D0,0.D0)
	DELW(IDIM1,IDIM,IMSB)=(0.D0,0.D0)
	GLOC(IDIM1,IDIM,IMSB)=(0.D0,0.D0)
	ENDDO
	SIGI(IDIM1,IDIM)=(0.D0,0.D0)
	DO IMOM=-NMOM,+NMOM
	GMOM(IDIM1,IDIM,IMOM)=(0.D0,0.D0)
	DMAT(IDIM1,IDIM,IMOM)=(0.D0,0.D0)
	ENDDO
	DO IPOL=1,NPOL
	VRAT(IDIM1,IDIM,IPOL)=(0.D0,0.D0)
	WRAT(IDIM1,IDIM,IPOL)=(0.D0,0.D0)
	PRAT(IDIM1,IDIM,IPOL)=(0.D0,0.D0)
	ORAT(IDIM1,IDIM,IPOL)=(0.D0,0.D0)
	ENDDO
	ENDDO
	ENDDO
C PREPARE HYBRIDIZATION
	DO ISPIN=1,NSPIN
	DO IREP=1,NREP
	DO IMSB=0,NMSB
	CALL MDL_MODELHYB(TBND(IREP,ISPIN),OMSB(IMSB),
     &     DEL(IMSB,IREP,ISPIN))
	ENDDO
	ENDDO
	ENDDO
C PREPARE SELF-ENERGY
	DO ISPIN=1,NSPIN
	DO IREP=1,NREP
	DO IMSB=0,NMSB
	SIG(IMSB,IREP,ISPIN)=(0.D0,0.D0)
	ENDDO
	ENDDO
	ENDDO
C Green function and self-energy
	IDEG=0
	DO IDIM=1,NDIM
	IF(KSTSHL(IDIM,IRUN).EQ.0)CYCLE
	IDEG=IDEG+1
	IREP=KDREP(IDIM)
	ISPIN=(2*IDIM-1)/NDIM+1
	IF(MSPIN.EQ.1)ISPIN=1
	DO IMSB=0,NMSB
	SIGW(IDIM,IDIM,IMSB)=SIG(IMSB,IREP,ISPIN)
	DELW(IDIM,IDIM,IMSB)=DEL(IMSB,IREP,ISPIN)
	ENDDO
	ENDDO
C **********************************************
C IMAGINARY AXIS DMFT LOOP
	TEXT='Imaginary axis DMFT loop converged.'
	DO 1000 ITER=1,NDIT
C Green function and self-energy
	IDEG=0
	DO IDIM=1,NDIM
	IF(KSTSHL(IDIM,IRUN).EQ.0)CYCLE
	IDEG=IDEG+1
	IREP=KDREP(IDIM)
	ISPIN=(2*IDIM-1)/NDIM+1
	IF(MSPIN.EQ.1)ISPIN=1
	DO IMSB=0,NMSB
	SIGW(IDIM,IDIM,IMSB)=SIG(IMSB,IREP,ISPIN)
	DELW(IDIM,IDIM,IMSB)=DEL(IMSB,IREP,ISPIN)
	ENDDO
	ENDDO
      CALL MDL_MIXDMF(0,ITER,IEXIT,0)!! initialize Broyden
C Find self-energy and impurity Green function within SBMF
C SU(N) case
	IF(ISYM.EQ.1)
     &CALL IMP_SUNSBMF_HEAD(NDEG,EATS,TBND,UPAR,ELOC,
     &  DEL,GFF,SIG,PSIK,IFIX,ZMAS,ZIMP,ZREP,0,
     &  TEMP,NMSB,OMSB,FMSB,0.0D0,IERR)
C Crystal field case
	IF(ISYM.EQ.2)
     &CALL IMP_CRFSBMF_MAIN(NDEG,NREP,NSPIN,LREP,NCNF,
     &  NCNF0,EATS,TBND,UPAR,GPAR,ELOC,DEL,GFF,SIG,
     &  PSIK,IFIX,ZMAS,ZIMP,ZREP,0,
     &  TEMP,NMSB,OMSB,FMSB,0.0D0,IERR)
C Green function and self-energy
	IDEG=0
	DO IDIM=1,NDIM
	IF(KSTSHL(IDIM,IRUN).EQ.0)CYCLE
	IDEG=IDEG+1
	IREP=KDREP(IDIM)
	ISPIN=(2*IDIM-1)/NDIM+1
	IF(MSPIN.EQ.1)ISPIN=1
	DO IMSB=0,NMSB
	SIGW(IDIM,IDIM,IMSB)=SIG(IMSB,IREP,ISPIN)
	DELW(IDIM,IDIM,IMSB)=DEL(IMSB,IREP,ISPIN)
	ENDDO
	ENDDO
C Mix self energies
	IF(NDIT.NE.1)
     &CALL MDL_MIXDMF(0,ITER,IEXIT,2)   !!! mix self-energies
C Compute the Green function
	DO ISPIN=1,NSPIN
	DO IREP=1,NREP
	DO IMSB=0,NMSB
	GFF(IMSB,IREP,ISPIN)=1.D0/(OMSB(IMSB)-ELOC(IREP,ISPIN)-
     &SIG(IMSB,IREP,ISPIN)-DEL(IMSB,IREP,ISPIN))
	ENDDO
	ENDDO
	ENDDO
C Total charge
	DO ISPIN=1,NSPIN
	ZTOT(ISPIN)=0.D0
	DO IREP=1,NREP
	ZTOT(ISPIN)=ZTOT(ISPIN)+ZREP(IREP,ISPIN)
	ENDDO
	ZTOT(ISPIN)=ZTOT(ISPIN)/2.D0*DBLE(NSPIN)
	ENDDO
C Limits
	DO ISPIN=1,NSPIN
	IF(ISPIN.EQ.1)ISPIN1=NSPIN
	IF(ISPIN.EQ.NSPIN)ISPIN1=1
	DO IREP=1,NREP
	SIGM0(IREP,ISPIN)=DREAL(SIG(0,IREP,ISPIN))
	SIGMI(IREP,ISPIN)=UPAR*ZTOT(ISPIN1)+
     &(UPAR-GPAR)*(ZTOT(ISPIN)-ZREP(IREP,ISPIN)/DBLE(LREP(IREP)))
C	SIGMI(IREP,ISPIN)=DREAL(SIG(NMSB,IREP,ISPIN))
	ENDDO
	ENDDO
C Hybridization for semicircle DOS according to DMFT
	IF(IMOD.EQ.1)THEN
	DO ISPIN=1,NSPIN
	DO IREP=1,NREP
	DO IMSB=0,NMSB
	CALL MDL_MODELHUB_SCFD(TBND(IREP,ISPIN),GFF(IMSB,IREP,ISPIN),
     &DEL(IMSB,IREP,ISPIN))
	GCC(IMSB,IREP,ISPIN)=GFF(IMSB,IREP,ISPIN)
	ENDDO
	ENDDO
	ENDDO
	ELSEIF(IMOD.EQ.2)THEN
	DO ISPIN=1,NSPIN
	DO IREP=1,NREP
	DO IMSB=0,NMSB
	CALL MDL_MODELPAM_SCFD(OMSB(IMSB),EBND(IREP,ISPIN),
     &VBND(IREP,ISPIN),TBND(IREP,ISPIN),ELOC(IREP,ISPIN),
     &SIG(IMSB,IREP,ISPIN),DEL(IMSB,IREP,ISPIN),GCC(IMSB,IREP,ISPIN))
	ENDDO
	ENDDO
	ENDDO
	ENDIF
C Green function and self-energy
	IDEG=0
	DO IDIM=1,NDIM
	IF(KSTSHL(IDIM,IRUN).EQ.0)CYCLE
	IDEG=IDEG+1
	IREP=KDREP(IDIM)
	ISPIN=(2*IDIM-1)/NDIM+1
	IF(MSPIN.EQ.1)ISPIN=1
	DO IMSB=0,NMSB
	SIGW(IDIM,IDIM,IMSB)=SIG(IMSB,IREP,ISPIN)
	DELW(IDIM,IDIM,IMSB)=DEL(IMSB,IREP,ISPIN)
	ENDDO
	ENDDO
C Mix hybridizations
	IF(NDIT.NE.1)
     &CALL MDL_MIXDMF(0,ITER,IEXIT,1)   !!! mix hybridizations
C Green function and self-energy
	IDEG=0
	DO IDIM=1,NDIM
	IF(KSTSHL(IDIM,IRUN).EQ.0)CYCLE
	IDEG=IDEG+1
	IREP=KDREP(IDIM)
	ISPIN=(2*IDIM-1)/NDIM+1
	IF(MSPIN.EQ.1)ISPIN=1
	DO IMSB=0,NMSB
	SIG(IMSB,IREP,ISPIN)=SIGW(IDIM,IDIM,IMSB)
	DEL(IMSB,IREP,ISPIN)=DELW(IDIM,IDIM,IMSB)
	ENDDO
	ENDDO
	IF(IEXIT.EQ.1.OR.NDIT.EQ.1)GOTO 1100
 1000	CONTINUE
      TEXT='Imaginary axis DMFT loop did not converge.'
 1100	CONTINUE
C FIND RATIONAL INTERPOLATION
	ZMAST=0.D0
	DO ISPIN=1,NSPIN
	DO IREP=1,NREP
	ZMAST=ZMAST+ZMAS(IREP,ISPIN)
	ENDDO
	ENDDO
	IF(ZMAST.LE.1.D-05)THEN
C Solve Hubbard I equations
C SU(N) case
	IF(ISYM.EQ.1)
     &CALL IMP_SUNHUB1_STAT(NDEG,EATS,TBND,UPAR,ELOC,DEL,GFF,
     &  SIG,XHUB,YHUB,IFIX,SINF,VCOF,WCOF,POLE,OVRL,
     &  ZIMP,ZREP,0,TEMP,NMSB,OMSB,FMSB,0.0D0,IERR)
C Crystal field case
	IF(ISYM.EQ.2)
     &CALL IMP_CRFHUB1_STAT(NDEG,NREP,NSPIN,LREP,NCNF,NCNF0,
     &  EATS,TBND,UPAR,GPAR,ELOC,DEL,GFF,SIG,XHUB,YHUB,
     &  IFIX,SINF,VCOF,WCOF,POLE,OVRL,
     &  ZIMP,ZREP,0,TEMP,NMSB,OMSB,FMSB,0.0D0,IERR)
	DO ICNF=1,NCNF
	DO ICNF0=1,NCNF0
	PSIK(ICNF,ICNF0)=SQRT(ABS(XHUB(ICNF,ICNF0)))
	ENDDO
	ENDDO
	ENDIF
C Find rational interpolation
	IF(ISYM.EQ.1)
     &CALL IMP_SUNIRAT_COFS(NDEG,ELOC,UPAR,ZOCC,TBND,COMB,
     &     SIGM0,SIGMI,ZMAS,PSIK,MRAT,WSIG,PSIG,0,IERR)
	IF(ISYM.EQ.2)
     &CALL IMP_CRFIRAT_COFS(NDEG,NREP,NSPIN,LREP,NCNF,NCNF0,
     &     ELOC,UPAR,GPAR,ZOCC,TBND,SIGM0,SIGMI,ZMAS,PSIK,
     &     MRAT,WSIG,PSIG,0,IERR)
C Reconstruct self-energy
	DO ISPIN=1,NSPIN
	DO IREP=1,NREP
	DO IMSB=0,NMSB
	ZOMG=OMSB(IMSB)
	SIG(IMSB,IREP,ISPIN)=SIGMI(IREP,ISPIN)
	DO IRAT=1,MRAT
	SIG(IMSB,IREP,ISPIN)=SIG(IMSB,IREP,ISPIN)+
     &WSIG(IRAT,IREP,ISPIN)/(ZOMG-PSIG(IRAT,IREP,ISPIN))
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C Reconstruct Green function
	DO ISPIN=1,NSPIN
	DO IREP=1,NREP
	DO IMSB=0,NMSB
      CALL MDL_MODELHUB_SCFG(OMSB(IMSB),TBND(IREP,ISPIN),
     &ELOC(IREP,ISPIN),SIG(IMSB,IREP,ISPIN),GFF(IMSB,IREP,ISPIN))
	ENDDO
	ENDDO
	ENDDO
C Reconstruct new Delta(iW)
	IF(IMOD.EQ.1)THEN
	DO ISPIN=1,NSPIN
	DO IREP=1,NREP
	DO IMSB=0,NMSB
	CALL MDL_MODELHUB_SCFD(TBND(IREP,ISPIN),GFF(IMSB,IREP,ISPIN),
     &DEL(IMSB,IREP,ISPIN))
	GCC(IMSB,IREP,ISPIN)=GFF(IMSB,IREP,ISPIN)
	ENDDO
	ENDDO
	ENDDO
	ELSEIF(IMOD.EQ.2)THEN
	DO ISPIN=1,NSPIN
	DO IREP=1,NREP
	DO IMSB=0,NMSB
	CALL MDL_MODELPAM_SCFD(OMSB(IMSB),EBND(IREP,ISPIN),
     &VBND(IREP,ISPIN),TBND(IREP,ISPIN),ELOC(IREP,ISPIN),
     &SIG(IMSB,IREP,ISPIN),DEL(IMSB,IREP,ISPIN),GCC(IMSB,IREP,ISPIN))
	ENDDO
	ENDDO
	ENDDO
	ENDIF
C Charge from Green function
	DO ISPIN=1,NSPIN
	DO IREP=1,NREP
	ZIMP(IREP,ISPIN)=0.D0
	DO IMSB=0,NMSB
      ZIMP(IREP,ISPIN)=ZIMP(IREP,ISPIN)+
     &2.D0*TEMP*DREAL(GFF(IMSB,IREP,ISPIN)-
     &1.D0/(OMSB(IMSB)))*FMSB(IMSB)
	ENDDO
	ZIMP(IREP,ISPIN)=ZIMP(IREP,ISPIN)+0.5D0
	ZIMP(IREP,ISPIN)=ZIMP(IREP,ISPIN)*DBLE(LREP(IREP))
	ENDDO
	ENDDO
C Conduction band charge
	DO ISPIN=1,NSPIN
	DO IREP=1,NREP
	ZCON(IREP,ISPIN)=0.D0
	DO IMSB=0,NMSB
      ZCON(IREP,ISPIN)=ZCON(IREP,ISPIN)+2.D0*TEMP*
     &DREAL(GCC(IMSB,IREP,ISPIN)-1.D0/(OMSB(IMSB)))*FMSB(IMSB)
	ENDDO
	ZCON(IREP,ISPIN)=ZCON(IREP,ISPIN)+0.5D0
	ZCON(IREP,ISPIN)=ZCON(IREP,ISPIN)*DBLE(2) ! Conduction band capacity is assumed to be 2 (s band)
	ENDDO
	ENDDO
C Estimate charge
	ALLOCATE(ZPSI(NSPIN))
	DO ISPIN=1,NSPIN
	ZPSI(ISPIN)=0.D0
	DO IREP=1,NREP
	ZPSI(ISPIN)=ZPSI(ISPIN)+ZREP(IREP,ISPIN)
	ENDDO
	ENDDO
C Estimate charge from Green's function
	ALLOCATE(ZSUM(NSPIN))
	DO ISPIN=1,NSPIN
	ZSUM(ISPIN)=0.D0
	DO IREP=1,NREP
	ZSUM(ISPIN)=ZSUM(ISPIN)+ZIMP(IREP,ISPIN)
	ENDDO
	ZSUM(ISPIN)=ZSUM(ISPIN)/2.D0*DBLE(NSPIN)
	ENDDO
C Print
	DO ISPIN=1,NSPIN
	IF(NSPIN.EQ.2)
     &WRITE(IUN,10110)ISPIN
	IF(NSPIN.EQ.1)
     &WRITE(IUN,10120)
	WRITE(IUN,10130)ZPSI(ISPIN),ZSUM(ISPIN)*2.D0/DBLE(NSPIN)
	ENDDO
10110 FORMAT(1X,'Results for Charges, Spin = ',I3)
10120 FORMAT(1X,'Results for Charges')
10130 FORMAT(1X,'Zpsi= ',G12.5,' Zsum= ',G12.5)
C **************************************
	DO ISPIN=1,NSPIN
	DO IREP=1,NREP
	ZOMG=DCMPLX(WOMG(0),0.001D0)
	CALL MDL_MODELHYB(TBND(IREP,ISPIN),ZOMG,DLR(0,IREP,ISPIN))
	SIR(0,IREP,ISPIN)=DCMPLX(DREAL(SIG(NMSB,IREP,ISPIN)),-1.D-03)
	ENDDO
	ENDDO
C REAL AXIS DMFT LOOP
	DO 2000 IOMG=0,NOMG
	ZOMG=DCMPLX(WOMG(IOMG),0.001D0)
	DO ISPIN=1,NSPIN
	DO IREP=1,NREP
	IF(IOMG.NE.0)DLR(IOMG,IREP,ISPIN)=DLR(IOMG-1,IREP,ISPIN)
	IF(IOMG.NE.0)SIR(IOMG,IREP,ISPIN)=SIR(IOMG-1,IREP,ISPIN)
	DLR(IOMG,IREP,ISPIN)=DLR(IOMG,IREP,ISPIN)+(0.D0,-1.D-03)
	SIR(IOMG,IREP,ISPIN)=SIR(IOMG,IREP,ISPIN)+(0.D0,-1.D-03)
	ENDDO
	ENDDO
C Initialize Broyden routine
	DO ISPIN=1,NSPIN
	DO IREP=1,NREP
	DLRT(IREP,ISPIN)=DLR(IOMG,IREP,ISPIN)
	ENDDO
	ENDDO
C Set Self-energy at this frequency
	DO ISPIN=1,NSPIN
	DO IREP=1,NREP
	SIRT(IREP,ISPIN)=SIGMI(IREP,ISPIN)
	DO IRAT=1,MRAT
	SIRT(IREP,ISPIN)=SIRT(IREP,ISPIN)+
     &WSIG(IRAT,IREP,ISPIN)/(ZOMG-PSIG(IRAT,IREP,ISPIN))
	ENDDO
	ENDDO
	ENDDO
C
	DO ISPIN=1,NSPIN
	DO IREP=1,NREP
	SIR(IOMG,IREP,ISPIN)=SIRT(IREP,ISPIN)
	ENDDO
	ENDDO
C Impurity Green function
	DO ISPIN=1,NSPIN
	DO IREP=1,NREP
	GFR(IOMG,IREP,ISPIN)=1.D0/(ZOMG-ELOC(IREP,ISPIN)-
     &SIR(IOMG,IREP,ISPIN)-DLR(IOMG,IREP,ISPIN))
	ENDDO
	ENDDO
C Hybridization for semicircle DOS according to DMFT
	IF(IMOD.EQ.1)THEN
	DO ISPIN=1,NSPIN
	DO IREP=1,NREP
      CALL MDL_MODELHUB_SCFG(ZOMG,TBND(IREP,ISPIN),
     &ELOC(IREP,ISPIN),SIR(IOMG,IREP,ISPIN),GFR(IOMG,IREP,ISPIN))
	IF(DIMAG(GFR(IOMG,IREP,ISPIN)).GT.0.D0)
     &GFR(IOMG,IREP,ISPIN)=DCMPLX(DREAL(GFR(IOMG,IREP,ISPIN)),-1.D-05)
	CALL MDL_MODELHUB_SCFD(TBND(IREP,ISPIN),GFR(IOMG,IREP,ISPIN),
     &DLR(IOMG,IREP,ISPIN))
	GCR(IOMG,IREP,ISPIN)=GFR(IOMG,IREP,ISPIN)
	ENDDO
	ENDDO
	ELSEIF(IMOD.EQ.2)THEN
	DO ISPIN=1,NSPIN
	DO IREP=1,NREP
      CALL MDL_MODELPAM_SCFG(ZOMG,TBND(IREP,ISPIN),
     &ELOC(IREP,ISPIN),SIR(IOMG,IREP,ISPIN),GFR(IOMG,IREP,ISPIN))
	CALL MDL_MODELPAM_SCFD(ZOMG,EBND(IREP,ISPIN),
     &VBND(IREP,ISPIN),TBND(IREP,ISPIN),ELOC(IREP,ISPIN),
     &SIR(IOMG,IREP,ISPIN),DLR(IOMG,IREP,ISPIN),GCR(IOMG,IREP,ISPIN))
	ENDDO
	ENDDO
	ENDIF
 2000 CONTINUE                          !!! over frequencies
C SET RETURNING PARAMETERS
      DO IDIM1=1,NDIM
      DO IDIM =1,NDIM
      DO IMSC=0,NMSC
      GLOC(IDIM1,IDIM,IMSC)=(0.D0,0.D0)
      SIGW(IDIM1,IDIM,IMSC)=(0.D0,0.D0)
      DELW(IDIM1,IDIM,IMSC)=(0.D0,0.D0)
      ENDDO
      SIGI(IDIM1,IDIM)=(0.D0,0.D0)
      DO IPOL=1,NPOL
      VRAT(IDIM1,IDIM,IPOL)=(0.D0,0.D0)
      WRAT(IDIM1,IDIM,IPOL)=(0.D0,0.D0)
      PRAT(IDIM1,IDIM,IPOL)=(0.D0,0.D0)
      ORAT(IDIM1,IDIM,IPOL)=(0.D0,0.D0)
      ENDDO
      ENDDO
      ENDDO
	IDEG=0
	DO IDIM=1,NDIM
	IF(KSTSHL(IDIM,IRUN).EQ.0)CYCLE
	IDEG=IDEG+1
	IREP=KDREP(IDIM)
	ISPIN=(2*IDIM-1)/NDIM+1
	IF(MSPIN.EQ.1)ISPIN=1
C Green function and self-energy
	DO IMSC=0,NMSC
	IF(KGRD.EQ.1)THEN
	GLOC(IDIM,IDIM,IMSC)=GFR(IMSC,IREP,ISPIN)
	SIGW(IDIM,IDIM,IMSC)=SIR(IMSC,IREP,ISPIN)
	DELW(IDIM,IDIM,IMSC)=DLR(IMSC,IREP,ISPIN)
	ELSEIF(KGRD.EQ.2)THEN
	GLOC(IDIM,IDIM,IMSC)=GFF(IMSC,IREP,ISPIN)
	SIGW(IDIM,IDIM,IMSC)=SIG(IMSC,IREP,ISPIN)
	DELW(IDIM,IDIM,IMSC)=DEL(IMSC,IREP,ISPIN)
	ENDIF
	ENDDO
C Rational interpolation coefficients
      SIGI(IDIM,IDIM)=SINF(IREP,ISPIN)
      DO IPOL=1,1
      VRAT(IDIM,IDIM,IPOL)=VCOF(IREP,ISPIN)
      WRAT(IDIM,IDIM,IPOL)=WCOF(IREP,ISPIN)
      PRAT(IDIM,IDIM,IPOL)=POLE(IREP,ISPIN)
      ORAT(IDIM,IDIM,IPOL)=OVRL(IREP,ISPIN)
      ENDDO
	ENDDO
C Transform matrices to spherical harmonics
      CALL LIB_TRANSCUB(NDIM,-KSYS,NDIM,-KSYS,ELEV(1,1))
      CALL LIB_TRANSCUB(NDIM,-KSYS,NDIM,-KSYS,TPAR(1,1))
      CALL LIB_TRANSCUB(NDIM,-KSYS,NDIM,-KSYS,VPAR(1,1))
      CALL LIB_TRANSCUB(NDIM,-KSYS,NDIM,-KSYS,ECON(1,1))
C Turn spectral functions spherical harmonics
      ALLOCATE(GTMP(NDIM,NDIM))
      ALLOCATE(STMP(NDIM,NDIM))
      ALLOCATE(DTMP(NDIM,NDIM))
      DO IMSC=0,NMSC
      DO IDIM1=1,NDIM
      DO IDIM=1,NDIM
      GTMP(IDIM1,IDIM)=GLOC(IDIM1,IDIM,IMSC)
      STMP(IDIM1,IDIM)=SIGW(IDIM1,IDIM,IMSC)
      DTMP(IDIM1,IDIM)=DELW(IDIM1,IDIM,IMSC)
      ENDDO
      ENDDO
      CALL LIB_TRANSCUB(NDIM,-KSYS,NDIM,-KSYS,GTMP)
      CALL LIB_TRANSCUB(NDIM,-KSYS,NDIM,-KSYS,STMP)
      CALL LIB_TRANSCUB(NDIM,-KSYS,NDIM,-KSYS,DTMP)
      DO IDIM1=1,NDIM
      DO IDIM=1,NDIM
      GLOC(IDIM1,IDIM,IMSC)=GTMP(IDIM1,IDIM)
      SIGW(IDIM1,IDIM,IMSC)=STMP(IDIM1,IDIM)
      DELW(IDIM1,IDIM,IMSC)=DTMP(IDIM1,IDIM)
      ENDDO
      ENDDO
      ENDDO
      DEALLOCATE(GTMP,STMP,DTMP)
C Rational interpolations      
      CALL LIB_TRANSCUB(NDIM,-KSYS,NDIM,-KSYS,SIGI(1,1))
      DO IPOL=1,NPOL
      CALL LIB_TRANSCUB(NDIM,-KSYS,NDIM,-KSYS,VRAT(1,1,IPOL))
      CALL LIB_TRANSCUB(NDIM,-KSYS,NDIM,-KSYS,WRAT(1,1,IPOL))
      CALL LIB_TRANSCUB(NDIM,-KSYS,NDIM,-KSYS,PRAT(1,1,IPOL))
      CALL LIB_TRANSCUB(NDIM,-KSYS,NDIM,-KSYS,ORAT(1,1,IPOL))
      ENDDO
	IF(ICGRF.EQ.2)CALL MDL_SETGRF     !!! store real axis data
C MEMORY DEALLOCATIONS
      DEALLOCATE(EATS,XHUB,YHUB,IFIX,OMSB)
	DEALLOCATE(GFRT,SIRT,DLRT)
	DEALLOCATE(LREP0,LREP1,LREP2,KDREP,KDR00,KDR12)
	DEALLOCATE(IPNF,IPNF0,IPNFP1,IPCF,IPRF,LCFG)
      DEALLOCATE(COMB,COMR,LREP,MREP,UMAT)
	DEALLOCATE(ELOC,EDOP,EBND,TBND,VBND,ZIMP,ZREP,ZCON)
	DEALLOCATE(DIMP,DREP,SINF,VCOF,WCOF,POLE,OVRL)
	DEALLOCATE(DEL,GFF,GCC,SIG,DLR,GFR,GCR,SIR,WSIG,PSIG)
	END