	SUBROUTINE MDL_SCFQMCF
**************************************************************
* Computes Impurity Green function with DMFT using QMC       *
**************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                       !!! from setup
	USE COM_MDLPAR  ,ONLY: IMPS,IMOD,ISYM,ISPN
	USE COM_MDLMIX  ,ONLY: NDIT
      USE COM_MSBMESH ,ONLY: TEMP,NOMG,WOMG,FOMG,WMIN,WMAX,
     &                       NMSB,WMSB,FMSB,NMSL,WMSL,FMSL,
     &                       OBND,NMSC,WMSC,FMSC,KGRD
      USE COM_LSHELL  ,ONLY: LORB,HMAG,HORB,ALSC,ELEV,FSLA,KSYS 
     &                      ,DAMP,NRUNSHL,KSTSHL
      USE COM_IMPGRF  ,ONLY: CHEM,FILL,KFRM,KVRB,NPLD,
     &                       GLOC,SIGW,BATH,DELW,KDRT,
     &                       KDIN,KINT,KRAT,NMOM,NPOL,NRAT
      USE COM_QMCPAR  ,ONLY: MODR
      USE COM_QMCOUT  ,ONLY: ICGRF,GRFFILE,ICQMC,QMCFILE,ICQMS,QMSFILE
      USE COM_QMCEXT  ,ONLY: EXTNQMC,EXTNQMS
      USE COM_MDLBND  ,ONLY: TPAR,VPAR,ECON
      USE COM_MDLOUT  ,ONLY: ICGRFMDL=>ICGRF,GRFMDLFILE=>GRFFILE
      USE COM_CHANNELS,ONLY: IUINP
      USE COM_MASHDEP ,ONLY: NVAL,LENCMP
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
C Allocatable arrays
      INTEGER, ALLOCATABLE :: KST(:,:)
	COMPLEX*16, ALLOCATABLE :: G0M1(:,:),GCON(:,:,:),ZCON(:,:)
	COMPLEX*16, ALLOCATABLE :: WORK(:),ELEV0(:,:)
	CHARACTER*150, ALLOCATABLE :: QMCDATA(:)
C Local variables
      INTEGER KSTSHL0(14,14)
      REAL*8 FSLA0(0:3)
	COMPLEX*16 DIM,ZMSB,ZOMG,GFUN
	CHARACTER TEXT*60,STRING*150,INF*130,ST*8,FN*8,PROGN*8
	CHARACTER HELP*40,TCTRL*10,LIB_TDP*10,FILE*130
	LOGICAL EXIST
	DATA PI/3.141592653589793D0/,DIM/(0.D0,1.D0)/
     &     ST/'started'/,FN/'finished'/
C Memory Allocations
      NDIM=2*(2*LORB+1)
      ALLOCATE(GCON(NDIM,NDIM,0:NMSC))
      ALLOCATE(ZCON(NDIM,NDIM))
      ALLOCATE(G0M1(NDIM,NDIM))
      ALLOCATE(WORK(NDIM))
      ALLOCATE(ELEV0(NDIM,NDIM))
      ALLOCATE(KST(NDIM,NRUNSHL))
      ICGRF=ICGRFMDL
      GRFFILE=GRFMDLFILE
C *************************************
C Get QMCFILE name
	INQUIRE(FILE=QMCFILE,EXIST=EXIST)
	IF(.NOT.EXIST)CALL FULLSTOP('<QMCFILE> not found!')
C ********************************
C UNDERSTAND THE LENGHT OF INIFILE
	CALL FILE_LENGHT(QMCFILE,NLEN,IUINP)
	ALLOCATE(QMCDATA(NLEN))
C ********************************
C READ INIFILE TO INTERNAL FILE
	OPEN(UNIT=IUINP,FILE=QMCFILE,STATUS='OLD',FORM='FORMATTED')
	DO ILEN=1,NLEN
	READ(IUINP,FMT='(A150)')QMCDATA(ILEN)
	ENDDO
	CLOSE(IUINP)
C ********************************
C UNDERSTAND INPUT: CLASSIC or MODERN
	STRING=QMCDATA(1)
	CALL LIB_CONVLOW(STRING,150)
	CALL LIB_RMBLANK(STRING,150)
	MODERN=0
	DO IPOS=1,80
	IF(STRING(IPOS:IPOS+11).EQ.'input=modern')MODERN=2
	IF(MODERN.NE.0)EXIT
	ENDDO
	IF(MODERN.EQ.2)MODIFIED=.TRUE. 
	IF(MODERN.NE.2)CALL FULLSTOP('<QMCFILE> format not recognized!')
C SAVE CONTROLS
      NMSB0=NMSB
      NOMG0=NOMG
      NMSC0=NMSC
      NMSL0=NMSL
      TEMP0=TEMP
      OBND0=OBND
      WMIN0=WMIN
      WMAX0=WMAX
      LORB0=LORB
      KGRD0=KGRD
      CHEM0=CHEM
      FILL0=FILL
      DAMP0=DAMP
      KDIN0=KDIN
      KDRT0=KDRT
      NPLD0=NPLD
      KINT0=KINT
      KRAT0=KRAT
      NMOM0=NMOM
      NPOL0=NPOL
      NRAT0=NRAT
      DO L0=0,3
      FSLA0(L0)=FSLA(L0)
      ENDDO
      DO IDIM1=1,NDIM
      DO IDIM=1,NDIM
      ELEV0(IDIM1,IDIM)=ELEV(IDIM1,IDIM)
      ENDDO
      ENDDO
      NRUNSHL0=NRUNSHL
      DO IRUN=1,NRUNSHL
      DO IDIM=1,NDIM
      KSTSHL0(IDIM,IRUN)=KSTSHL(IDIM,IRUN)
      ENDDO
      ENDDO
C READ CONTROL DATA
	CALL QMC_READQMC_CTRL(QMCDATA,NLEN)
C READ DMFT SETTINGS
	CALL QMC_READQMC_DMFT(QMCDATA,NLEN)
C READ SHELL INFORMATION
	CALL QMC_READQMC_SHEL(QMCDATA,NLEN)
C READ SHELL INFORMATION
	CALL QMC_READQMC_SETS(QMCDATA,NLEN)
C CHECK CONTROLS
      IF(LORB0.NE.LORB)
     &CALL FULLSTOP('<MDL_SCFQMCF> :: LORB MISMATCH')
      NMSB=NMSB0
      NOMG=NOMG0
      NMSC=NMSC0
      NMSL=NMSL0
      TEMP=TEMP0
      OBND=OBND0
      WMIN=WMIN0
      WMAX=WMAX0
      KGRD=KGRD0
      CHEM=CHEM0
      FILL=FILL0
      DAMP=DAMP0
      KDIN=KDIN0
      KDRT=KDRT0
      NPLD=NPLD0
      KINT=KINT0
      KRAT=KRAT0
      NMOM=NMOM0
      NPOL=NPOL0
      NRAT=NRAT0
      DO L0=0,3
      FSLA(L0)=FSLA(L)
      ENDDO
      DO IDIM1=1,NDIM
      DO IDIM=1,NDIM
      ELEV(IDIM1,IDIM)=ELEV0(IDIM1,IDIM)
      ENDDO
      ENDDO
      NRUNSHL=NRUNSHL0
      DO IRUN=1,NRUNSHL
      DO IDIM=1,NDIM
      KSTSHL(IDIM,IRUN)=KSTSHL0(IDIM,IRUN)
      ENDDO
      ENDDO
C *******************************************************
C Reset controls
      KFRM=1                   ! do NOT search chemical potential
      KVRB=0                   ! switch off various printouts
C *******************************************
C ALLOCATE MEMORY
      CALL QMC_ALLOCATE('A')
      NDIM=2*(2*LORB+1)
      DO IDIM1=1,NDIM
      DO IDIM =1,NDIM
      DO IMSB=0,NMSB
      BATH(IDIM1,IDIM,IMSB)=(0.D0,0.D0)
      DELW(IDIM1,IDIM,IMSB)=(0.D0,0.D0)
      SIGW(IDIM1,IDIM,IMSB)=(0.D0,0.D0)
      GLOC(IDIM1,IDIM,IMSB)=(0.D0,0.D0)
      ENDDO
      ENDDO
      ENDDO
C Transform matrices to local representation
      CALL LIB_TRANSCUB(NDIM,+KSYS,NDIM,+KSYS,ELEV(1,1))
      CALL LIB_TRANSCUB(NDIM,+KSYS,NDIM,+KSYS,TPAR(1,1))
      CALL LIB_TRANSCUB(NDIM,+KSYS,NDIM,+KSYS,VPAR(1,1))
      CALL LIB_TRANSCUB(NDIM,+KSYS,NDIM,+KSYS,ECON(1,1))
C PREPARE HYBRIDIZATION
      DO IDIM1=1,NDIM
      DO IDIM=1,NDIM
      DO IMSB=0,NMSB
      DELW(IDIM1,IDIM,IMSB)=(0.D0,0.D0)
      ENDDO
      ENDDO
      ENDDO
      DO IDIM=1,NDIM
	DO IMSB=0,NMSB
	ZMSB=DCMPLX(0.D0,WMSB(IMSB))
	TBND=DREAL(TPAR(IDIM,IDIM))
	CALL MDL_MODELHYB(TBND,ZMSB,DELW(IDIM,IDIM,IMSB))
	ENDDO
	ENDDO
C Prepare averaging pointer
      DO IRUN=1,NRUNSHL
      DO IDIM=1,NDIM
      KST(IDIM,IRUN)=KSTSHL(IDIM,IRUN)
      ENDDO
      ENDDO
C **********************************************
C IMAGINARY AXIS DMFT LOOP DONE IN LOCAL REPRESENTATION
	TEXT='Imaginary axis DMFT loop converged.'
	DO 1000 ITER=1,NDIT
C Initialize Broyden
      CALL MDL_MIXDMF(0,ITER,IEXIT,0)!! initialize Broyden
C SET UP REVERSE BATH GREEN FUNCTION G0^-1
      DO IMSB=0,NMSB
	DO IDIM1=1,NDIM
	DO IDIM=1,NDIM
	IF(IDIM1.EQ.IDIM)ONE=1.D0
	IF(IDIM1.NE.IDIM)ONE=0.D0
	ZMSB=DCMPLX(0.D0,WMSB(IMSB))
	G0M1(IDIM1,IDIM)=(ZMSB+CHEM)*ONE-
     &ELEV(IDIM1,IDIM)-DELW(IDIM1,IDIM,IMSB)
	ENDDO
	ENDDO
C INVERT BATH GREEN FUNCTION
	CALL LIB_CINV(NDIM,G0M1,NDIM,WORK,IFAIL)
	IF(IFAIL.NE.0)THEN
      WRITE(IUN,*)'<MDL_SCFQMCF>:: Error in inversion program'
	DO IDIM1=1,NDIM
	DO IDIM=1,NDIM
	G0M1(IDIM1,IDIM)=(0.D0,0.D0)
	ENDDO
	ENDDO
      ENDIF
C SAVE BATH GREEN FUNCTION G0
	DO IDIM1=1,NDIM
	DO IDIM=1,NDIM
	BATH(IDIM1,IDIM,IMSB)=G0M1(IDIM1,IDIM)
	ENDDO
	ENDDO
	ENDDO                             !!! over frequencies
C Average diagonal elements according to KST pointer
      CALL LIB_FORCESYM3L(ELEV,KST,NDIM,     1,NRUNSHL)
      CALL LIB_FORCESYM3L(DELW,KST,NDIM,NMSC+1,NRUNSHL)
      CALL LIB_FORCESYM3L(BATH,KST,NDIM,NMSC+1,NRUNSHL)
C Transform matrices back to spherical harmonics
      CALL LIB_TRANSCUB(NDIM,-KSYS,NDIM,-KSYS,ELEV(1,1))
      DO IMSB=0,NMSB
      CALL LIB_TRANSCUB(NDIM,-KSYS,NDIM,-KSYS,DELW(1,1,IMSB))
      CALL LIB_TRANSCUB(NDIM,-KSYS,NDIM,-KSYS,BATH(1,1,IMSB))
	DO IDIM1=1,NDIM
	DO IDIM=1,NDIM
	SIGW(IDIM1,IDIM,IMSB)=(0.D0,0.D0)
	GLOC(IDIM1,IDIM,IMSB)=(0.D0,0.D0)
	ENDDO
	ENDDO
      ENDDO
C Impurity QMC with Yifeng Yang program
	progn='QmcYif'
	call lib_timel(times)
	write(iun,10100)progn,st,times,curmem,totmem
      IF(MODR/10.EQ.1)CALL QMC_QMCYIF
      call lib_timel(timef)
	write(iun,10100)progn,fn,timef,curmem,totmem
C COMPUTE RATIONAL FORM FOR SELF-ENERGY
	progn='SigRat'
	call lib_timel(times)
	write(iun,10100)progn,st,times,curmem,totmem
	IF(ICGRF.GT.0)CALL IMP_SIGRAT
      call lib_timel(timef)
	write(iun,10100)progn,fn,timef,curmem,totmem
C Transform matrices to local representation
      CALL LIB_TRANSCUB(NDIM,+KSYS,NDIM,+KSYS,ELEV(1,1))
      DO IMSB=0,NMSB
      CALL LIB_TRANSCUB(NDIM,+KSYS,NDIM,+KSYS,DELW(1,1,IMSB))
      CALL LIB_TRANSCUB(NDIM,+KSYS,NDIM,+KSYS,BATH(1,1,IMSB))
      CALL LIB_TRANSCUB(NDIM,+KSYS,NDIM,+KSYS,GLOC(1,1,IMSB))
      CALL LIB_TRANSCUB(NDIM,+KSYS,NDIM,+KSYS,SIGW(1,1,IMSB))
      ENDDO
C Average diagonal elements according to KST pointer
      CALL LIB_FORCESYM3L(ELEV,KST,NDIM,     1,NRUNSHL)
      CALL LIB_FORCESYM3L(DELW,KST,NDIM,NMSC+1,NRUNSHL)
      CALL LIB_FORCESYM3L(BATH,KST,NDIM,NMSC+1,NRUNSHL)
      CALL LIB_FORCESYM3L(GLOC,KST,NDIM,NMSC+1,NRUNSHL)
      CALL LIB_FORCESYM3L(SIGW,KST,NDIM,NMSC+1,NRUNSHL)
C Hybridization for semicircle DOS according to DMFT
	IF(IMOD.EQ.1)THEN
	DO IDIM=1,NDIM
	DO IMSB=0,NMSB
	ZMSB=DCMPLX(0.D0,WMSB(IMSB))
	GFUN=GLOC(IDIM,IDIM,IMSB)
	TBND=DREAL(TPAR(IDIM,IDIM))
	CALL MDL_MODELHUB_SCFD(TBND,GFUN,DELW(IDIM,IDIM,IMSB))
	ENDDO
	ENDDO
	ELSEIF(IMOD.EQ.2)THEN
	DO IDIM=1,NDIM
	DO IMSB=0,NMSB
	ZMSB=DCMPLX(0.D0,WMSB(IMSB))
	TBND=DREAL(TPAR(IDIM,IDIM))
	EBND=DREAL(ECON(IDIM,IDIM))-CHEM
	VBND=DREAL(VPAR(IDIM,IDIM))
	ELOC=DREAL(ELEV(IDIM,IDIM))-CHEM
	CALL MDL_MODELPAM_SCFD(ZMSB,EBND,VBND,TBND,ELOC,
     &SIGW(IMSB,IDIM,IDIM),DELW(IMSB,IDIM,IDIM),GCON(IMSB,IDIM,IDIM))
	ENDDO
	ENDDO
	ENDIF
C Mix 
	IF(NDIT.NE.1)
     &CALL MDL_MIXDMF(0,ITER,IEXIT,1)   !!! mix hybridizations
	IF(IEXIT.EQ.1.OR.NDIT.EQ.1)GOTO 1100
 1000	CONTINUE
      TEXT='Imaginary axis DMFT loop did not converge.'
 1100	CONTINUE
C Conduction band charge
	DO IDIM1=1,NDIM
	DO IDIM=1,NDIM
	IF(IDIM1.EQ.IDIM)ONE=1.D0
	IF(IDIM1.NE.IDIM)ONE=0.D0
	ZCON(IDIM1,IDIM)=0.D0
	DO IMSB=0,NMSB
      ZCON(IDIM1,IDIM)=ZCON(IDIM1,IDIM)+2.D0*TEMP*
     &DREAL(GCON(IDIM1,IDIM,IMSB)-ONE/(DIM*WMSB(IMSB)))*FMSB(IMSB)
	ENDDO
	ZCON(IDIM1,IDIM)=ZCON(IDIM1,IDIM)+0.5D0*ONE
	ZCON(IDIM1,IDIM)=ZCON(IDIM1,IDIM)*DBLE(2) ! Conduction band capacity is assumed to be 2 (s band)
	ENDDO
	ENDDO
C UPGRADE RATFILE IF REQUESTED
      IF(ICQMS.GT.0)THEN
      CALL READ_OVWR(QMSFILE,QMCDATA,NLEN)
      ENDIF
C **************************************
C Transform matrices to spherical harmonics
      CALL LIB_TRANSCUB(NDIM,-KSYS,NDIM,-KSYS,TPAR(1,1))
      CALL LIB_TRANSCUB(NDIM,-KSYS,NDIM,-KSYS,VPAR(1,1))
      CALL LIB_TRANSCUB(NDIM,-KSYS,NDIM,-KSYS,ECON(1,1))
      CALL LIB_TRANSCUB(NDIM,-KSYS,NDIM,-KSYS,ELEV(1,1))
      DO IMSB=0,NMSB
      CALL LIB_TRANSCUB(NDIM,-KSYS,NDIM,-KSYS,DELW(1,1,IMSB))
      CALL LIB_TRANSCUB(NDIM,-KSYS,NDIM,-KSYS,BATH(1,1,IMSB))
      CALL LIB_TRANSCUB(NDIM,-KSYS,NDIM,-KSYS,GLOC(1,1,IMSB))
      CALL LIB_TRANSCUB(NDIM,-KSYS,NDIM,-KSYS,SIGW(1,1,IMSB))
      ENDDO
C Store Green function
	IF(ICGRF.EQ.2)CALL QMC_SETGRF     !!! store Green function data
C MEMORY DEALLOCATIONS
      DEALLOCATE(GCON,G0M1,ZCON,ELEV0,WORK,KST)
      DEALLOCATE(QMCDATA)
10100 FORMAT('***** ',A8,1X,A8,'; CPU : ',G12.5,
     &       '; CUR/MAX mem.(Mb): ',G10.3,'/',G10.3)
	END