	SUBROUTINE MDL_SCFRATF
***************************************************************
* Computes Impurity Green function with DMFT using Exact Diag *
***************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM
	USE COM_MDLPAR  ,ONLY: IMPS,IMOD,ISYM,ISPN
	USE COM_MDLMIX  ,ONLY: NDIT
      USE COM_MSBMESH ,ONLY: TEMP,NOMG,WOMG,FOMG,WMIN,WMAX,
     &                       NMSB,WMSB,FMSB,NMSL,WMSL,FMSL,
     &                       OBND,NMSC,WMSC,FMSC,KGRD
      USE COM_LSHELL  ,ONLY: LORB,HMAG,HORB,ALSC,ELEV,FSLA,KSYS 
     &                      ,DAMP,NRUNSHL,KSTSHL
      USE COM_IMPGRF  ,ONLY: CHEM,FILL,KFRM,KVRB,NPLD,
     &                       GLOC,SIGW,BATH,DELW,KDRT,
     &                       VRHB,WRHB,PRHB,ORHB,KDIN,
     &                       KINT,KRAT,NMOM,NPOL,NRAT
      USE COM_RATPAR  ,ONLY: MODR
      USE COM_RATOUT  ,ONLY: ICGRF,GRFFILE,ICRAT,RATFILE,ICRSC,RSCFILE
      USE COM_RATCLS  ,ONLY: KHYBLEV
      USE COM_RATHYB  ,ONLY: NHYB,EHYB,VHYB,NBST,NDST
      USE COM_RATEXT  ,ONLY: EXTNRAT,EXTNRSC
      USE COM_MDLBND  ,ONLY: TPAR,VPAR,ECON
      USE COM_MDLOUT  ,ONLY: ICGRFMDL=>ICGRF,GRFMDLFILE=>GRFFILE
      USE COM_CHANNELS,ONLY: IUINP
      USE COM_MASHDEP ,ONLY: NVAL,LENCMP
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
C Allocatable arrays
      INTEGER, ALLOCATABLE :: KST(:,:)
	COMPLEX*16, ALLOCATABLE :: G0M1(:,:),GCON(:,:,:),ZCON(:,:)
	COMPLEX*16, ALLOCATABLE :: WORK(:),ELEV0(:,:),GTRA(:,:,:)
      REAL*8, ALLOCATABLE :: EBATH(:,:),VBATH(:,:)
	CHARACTER*150, ALLOCATABLE :: RATDATA(:),RATCOPY(:)
C Local variables
      INTEGER KSTSHL0(14,14)
      REAL*8 FSLA0(0:3),ERAT(14)
	COMPLEX*16 DIM,ZOMG,ZMSB,GFUN
	CHARACTER TEXT*60,STRING*150,INF*130,ST*8,FN*8,PROGN*8
	CHARACTER HELP*40,TCTRL*10,LIB_TDP*10,FILE*130
	LOGICAL EXIST
	DATA PI/3.141592653589793D0/,DIM/(0.D0,1.D0)/
     &     ST/'started'/,FN/'finished'/
C Memory Allocations
      NDIM=2*(2*LORB+1)
      ALLOCATE(GCON(NDIM,NDIM,0:NMSC))
      ALLOCATE(ZCON(NDIM,NDIM))
      ALLOCATE(G0M1(NDIM,NDIM))
      ALLOCATE(GTRA(NDIM,NDIM,5))
      ALLOCATE(WORK(NDIM))
      ALLOCATE(ELEV0(NDIM,NDIM))
      ALLOCATE(KST(NDIM,NRUNSHL))
      ICGRF=ICGRFMDL
      GRFFILE=GRFMDLFILE
C *************************************
C Get RATFILE name
	INQUIRE(FILE=RATFILE,EXIST=EXIST)
	IF(.NOT.EXIST)CALL FULLSTOP('<RATFILE> not found!')
C ********************************
C UNDERSTAND THE LENGHT OF INIFILE
	CALL FILE_LENGHT(RATFILE,NLEN,IUINP)
	ALLOCATE(RATDATA(NLEN))
C ********************************
C READ INIFILE TO INTERNAL FILE
	OPEN(UNIT=IUINP,FILE=RATFILE,STATUS='OLD',FORM='FORMATTED')
	DO ILEN=1,NLEN
	READ(IUINP,FMT='(A150)')RATDATA(ILEN)
	ENDDO
	CLOSE(IUINP)
C ********************************
C UNDERSTAND INPUT: CLASSIC or MODERN
	STRING=RATDATA(1)
	CALL LIB_CONVLOW(STRING,150)
	CALL LIB_RMBLANK(STRING,150)
	MODERN=0
	DO IPOS=1,80
	IF(STRING(IPOS:IPOS+11).EQ.'input=modern')MODERN=2
	IF(MODERN.NE.0)EXIT
	ENDDO
	IF(MODERN.EQ.2)MODIFIED=.TRUE. 
	IF(MODERN.NE.2)CALL FULLSTOP('<RATFILE> format not recognized!')
C SAVE CONTROLS
      NMSB0=NMSB
      NOMG0=NOMG
      NMSC0=NMSC
      NMSL0=NMSL
      TEMP0=TEMP
      OBND0=OBND
      WMIN0=WMIN
      WMAX0=WMAX
      LORB0=LORB
      KGRD0=KGRD
      CHEM0=CHEM
      FILL0=FILL
      DAMP0=DAMP
      KDIN0=KDIN
      KDRT0=KDRT
      NPLD0=NPLD
      KINT0=KINT
      KRAT0=KRAT
      NMOM0=NMOM
      NPOL0=NPOL
      NRAT0=NRAT
      DO L0=0,3
      FSLA0(L0)=FSLA(L0)
      ENDDO
      DO IDIM1=1,NDIM
      DO IDIM=1,NDIM
      ELEV0(IDIM1,IDIM)=ELEV(IDIM1,IDIM)
      ENDDO
      ENDDO
      NRUNSHL0=NRUNSHL
      DO IRUN=1,NRUNSHL
      DO IDIM=1,NDIM
      KSTSHL0(IDIM,IRUN)=KSTSHL(IDIM,IRUN)
      ENDDO
      ENDDO
C READ CONTROL DATA
	CALL RAT_READRAT_CTRL(RATDATA,NLEN)
C READ DMFT SETTINGS
	CALL RAT_READRAT_DMFT(RATDATA,NLEN)
C READ SHELL INFORMATION
	CALL RAT_READRAT_SHEL(RATDATA,NLEN)
C READ CLUSTER INFORMATION
	CALL RAT_READRAT_CLUS(RATDATA,NLEN)
C READ LEVELS INFORMATION
	CALL RAT_READRAT_BLEV(RATDATA,NLEN)
C CHECK CONTROLS
      IF(LORB0.NE.LORB)
     &CALL FULLSTOP('<MDL_SCFRATF> :: LORB MISMATCH')
      NMSB=NMSB0
      NOMG=NOMG0
      NMSC=NMSC0
      NMSL=NMSL0
      TEMP=TEMP0
      OBND=OBND0
      WMIN=WMIN0
      WMAX=WMAX0
      KGRD=KGRD0
      CHEM=CHEM0
      FILL=FILL0
      DAMP=DAMP0
      KDIN=KDIN0
      KDRT=KDRT0
      NPLD=NPLD0
      KINT=KINT0
      KRAT=KRAT0
      NMOM=NMOM0
      NPOL=NPOL0
      NRAT=NRAT0
      DO L0=0,3
      FSLA(L0)=FSLA(L)
      ENDDO
      DO IDIM1=1,NDIM
      DO IDIM=1,NDIM
      ELEV(IDIM1,IDIM)=ELEV0(IDIM1,IDIM)
      ENDDO
      ENDDO
      NRUNSHL=NRUNSHL0
      DO IRUN=1,NRUNSHL
      DO IDIM=1,NDIM
      KSTSHL(IDIM,IRUN)=KSTSHL0(IDIM,IRUN)
      ENDDO
      ENDDO
C *******************************************************
C Reset controls
      KFRM=1                   ! do NOT search chemical potential
      KVRB=0                   ! switch off various printouts
C *******************************************
C ALLOCATE MEMORY
      CALL MDL_ALLOCATE('D')
      CALL RAT_ALLOCATE('A')
      NDIM=2*(2*LORB+1)
      DO IDIM1=1,NDIM
      DO IDIM =1,NDIM
      DO IOMG=0,NOMG
      BATH(IDIM1,IDIM,IOMG)=(0.D0,0.D0)
      DELW(IDIM1,IDIM,IOMG)=(0.D0,0.D0)
      SIGW(IDIM1,IDIM,IOMG)=(0.D0,0.D0)
      GLOC(IDIM1,IDIM,IOMG)=(0.D0,0.D0)
      ENDDO
      ENDDO
      ENDDO
C Transform matrices to local representation
      CALL LIB_TRANSCUB(NDIM,+KSYS,NDIM,+KSYS,ELEV(1,1))
      CALL LIB_TRANSCUB(NDIM,+KSYS,NDIM,+KSYS,TPAR(1,1))
      CALL LIB_TRANSCUB(NDIM,+KSYS,NDIM,+KSYS,VPAR(1,1))
      CALL LIB_TRANSCUB(NDIM,+KSYS,NDIM,+KSYS,ECON(1,1))
C PREPARE HYBRIDIZATION
      DO IDIM1=1,NDIM
      DO IDIM=1,NDIM
      DO IOMG=0,NOMG
      DELW(IDIM1,IDIM,IMSB)=(0.D0,0.D0)
      ENDDO
      ENDDO
      ENDDO
      DO IDIM=1,NDIM
	DO IOMG=0,NOMG
	ZOMG=DCMPLX(WOMG(IOMG),0.D0)
	TBND=DREAL(TPAR(IDIM,IDIM))
	CALL MDL_MODELHYB(TBND,ZOMG,DELW(IDIM,IDIM,IOMG))
	ENDDO
	ENDDO
C Prepare averaging pointer
      DO IRUN=1,NRUNSHL
      DO IDIM=1,NDIM
      KST(IDIM,IRUN)=KSTSHL(IDIM,IRUN)
      ENDDO
      ENDDO
C **********************************************
C REAL AXIS DMFT LOOP IN LOCAL REPRESENTATION
	TEXT='Real axis DMFT loop converged.'
	DO 1000 ITER=1,NDIT
      CALL MDL_MIXDMF(0,ITER,IEXIT,0)!! initialize Broyden
C SET UP REVERSE BATH GREEN FUNCTION G0^-1
      DO IOMG=0,NOMG
	DO IDIM1=1,NDIM
	DO IDIM=1,NDIM
	IF(IDIM1.EQ.IDIM)ONE=1.D0
	IF(IDIM1.NE.IDIM)ONE=0.D0
	ZOMG=DCMPLX(WOMG(IOMG),0.D0)
	G0M1(IDIM1,IDIM)=(ZOMG+CHEM)*ONE-
     &ELEV(IDIM1,IDIM)-DELW(IDIM1,IDIM,IOMG)
	ENDDO
	ENDDO
C INVERT BATH GREEN FUNCTION
	CALL LIB_CINV(NDIM,G0M1,NDIM,WORK,IFAIL)
	IF(IFAIL.NE.0)THEN
      WRITE(IUN,*)'<MDL_SCFRATF>:: Error in inversion program'
	DO IDIM1=1,NDIM
	DO IDIM=1,NDIM
	G0M1(IDIM1,IDIM)=(0.D0,0.D0)
	ENDDO
	ENDDO
      ENDIF
C SAVE BATH GREEN FUNCTION G0
	DO IDIM1=1,NDIM
	DO IDIM=1,NDIM
	BATH(IDIM1,IDIM,IOMG)=G0M1(IDIM1,IDIM)
	ENDDO
	ENDDO
	ENDDO                             !!! over frequencies
C DISRETIZE HYBRIDIZATION
C *****************************************************
C We can just use hybridization levels after ratfile
      IF(KHYBLEV.EQ.1.AND.MODR/10.NE.2)THEN
C Hybridzation levels
      DO IHYB=1,NHYB
      EHYB(IHYB)=EHYB(IHYB)
      ENDDO
C Hybridization matrix elements
      DO IHYB=1,NHYB
      DO IDIM=1,NDIM
      VHYB(IDIM,IHYB)=VHYB(IDIM,IHYB)
      ENDDO
      ENDDO
C *****************************************************
C We cannot reset impurity cluster using HOPFILE here
      ELSEIF(KHYBLEV.EQ.2.AND.MODR/10.NE.2)THEN
      CALL FULLSTOP('<SCFRATF>: HOPFILE cannot be given as input')
C *****************************************************
C We can do self-consistent bath via its rational form
      ELSEIF(KHYBLEV.EQ.3.AND.MODR/10.NE.2)THEN
C The # of levels should be Npld*Ndim
      IF(NHYB.NE.NPLD*NDIM)
     &CALL FULLSTOP('<SCFRATF>: Nhyb should be Npld*Ndim')
C Initial hybridzation levels are whatever is read from RatFile
      DO IPOL=1,NPLD
      DO IDIM1=1,NDIM
      DO IDIM=1,NDIM
      VRHB(IDIM1,IDIM,IPOL)=(0.D0,0.D0)
      WRHB(IDIM1,IDIM,IPOL)=(0.D0,0.D0)
      PRHB(IDIM1,IDIM,IPOL)=(0.D0,0.D0)
      ORHB(IDIM1,IDIM,IPOL)=(0.D0,0.D0)
      ENDDO
      ENDDO
      ENDDO
      IHYB=0
      DO IPOL=1,NPLD
	DO IDIM=1,NDIM
      IHYB=IHYB+1
      PRHB(IDIM,IDIM,IPOL)=EHYB(IHYB)
      ENDDO
      ENDDO
      CALL MDL_SCFRATF_HYBR
C Hybridzation levels
      IHYB=0
      DO IPOL=1,NPLD
	DO IDIM=1,NDIM
      IHYB=IHYB+1
      EHYB(IHYB)=DCMPLX(DREAL(PRHB(IDIM,IDIM,IPOL)),0.D0)
      ENDDO
      ENDDO
C Hybridization matrix elements
      DO IHYB=1,NHYB
      DO IDIM=1,NDIM
      VHYB(IDIM,IHYB)=(0.D0,0.D0)
      ENDDO
      ENDDO
      IHYB=0
      DO IPOL=1,NPLD
	DO IDIM=1,NDIM
      IHYB=IHYB+1
      VHYB(IDIM,IHYB)=DCMPLX(DREAL(VRHB(IDIM,IDIM,IPOL)),0.D0)
      ENDDO
      ENDDO
      ENDIF
C Average diagonal elements according to KST pointer
      CALL LIB_FORCESYM3L(ELEV,KST,NDIM,1,NRUNSHL)
      DO IOMG=0,NOMG
      DO IDIM1=1,NDIM
      DO IDIM=1,NDIM
      GTRA(IDIM1,IDIM,1)=DELW(IDIM1,IDIM,IOMG)
      GTRA(IDIM1,IDIM,2)=BATH(IDIM1,IDIM,IOMG)
      ENDDO
      ENDDO
      CALL LIB_FORCESYM3L(GTRA(1,1,1),KST,NDIM,1,NRUNSHL)
      CALL LIB_FORCESYM3L(GTRA(1,1,2),KST,NDIM,1,NRUNSHL)
      DO IDIM1=1,NDIM
      DO IDIM=1,NDIM
      DELW(IDIM1,IDIM,IOMG)=GTRA(IDIM1,IDIM,1)
      BATH(IDIM1,IDIM,IOMG)=GTRA(IDIM1,IDIM,2)
      ENDDO
      ENDDO
      ENDDO
C Transform matrices back to spherical harmonics
      CALL LIB_TRANSCUB(NDIM,-KSYS,NDIM,-KSYS,ELEV(1,1))
      DO IOMG=0,NOMG
      DO IDIM1=1,NDIM
      DO IDIM=1,NDIM
      GTRA(IDIM1,IDIM,1)=DELW(IDIM1,IDIM,IOMG)
      GTRA(IDIM1,IDIM,2)=BATH(IDIM1,IDIM,IOMG)
      ENDDO
      ENDDO
      CALL LIB_TRANSCUB(NDIM,-KSYS,NDIM,-KSYS,GTRA(1,1,1))
      CALL LIB_TRANSCUB(NDIM,-KSYS,NDIM,-KSYS,GTRA(1,1,2))
      DO IDIM1=1,NDIM
      DO IDIM=1,NDIM
      DELW(IDIM1,IDIM,IOMG)=GTRA(IDIM1,IDIM,1)
      BATH(IDIM1,IDIM,IOMG)=GTRA(IDIM1,IDIM,2)
      ENDDO
      ENDDO
      ENDDO
      CALL LIB_TRANSCUB(NDIM,-KSYS,NHYB,0,VHYB(1,1))
C START EXACT DIAGONALIZATION METHOD
	progn='ExDiag'
	call lib_timel(times)
	write(iun,10100)progn,st,times,curmem,totmem
C **********************************************************
C MANY BODY CALCULATIONS OF ATOMIC SPECTRA
      IF(MODR/10.EQ.2)CALL RAT_SHELLS
C **********************************************************
C EXACT DIAGONALIZATION FOR CLUSTERS BY BLOCKS
      IF(MODR/10.EQ.3)CALL RAT_CLSSAV
C **********************************************************
C EXACT DIAGONALIZATION FOR CLUSTERS (Yin Quan version)
      IF(MODR/10.EQ.4)CALL RAT_CLSYIN
C **********************************************************
C EXACT DIAGONALIZATION FOR CLUSTERS (Alexei Gordienko version)
      IF(MODR/10.EQ.5)CALL RAT_CLSGOR
      call lib_timel(timef)
	write(iun,10100)progn,fn,timef,curmem,totmem
C COMPUTE RATIONAL FORM FOR SELF-ENERGY
	progn='SigRat'
	call lib_timel(times)
	write(iun,10100)progn,st,times,curmem,totmem
	IF(ICGRF.GT.0)CALL IMP_SIGRAT
      call lib_timel(timef)
	write(iun,10100)progn,fn,timef,curmem,totmem
C Transform matrices to local representation
      CALL LIB_TRANSCUB(NDIM,+KSYS,NDIM,+KSYS,ELEV(1,1))
      DO IOMG=0,NOMG
      DO IDIM1=1,NDIM
      DO IDIM=1,NDIM
      GTRA(IDIM1,IDIM,1)=DELW(IDIM1,IDIM,IOMG)
      GTRA(IDIM1,IDIM,2)=BATH(IDIM1,IDIM,IOMG)
      GTRA(IDIM1,IDIM,3)=GLOC(IDIM1,IDIM,IOMG)
      GTRA(IDIM1,IDIM,5)=SIGW(IDIM1,IDIM,IOMG)
      ENDDO
      ENDDO
      CALL LIB_TRANSCUB(NDIM,+KSYS,NDIM,+KSYS,GTRA(1,1,1))
      CALL LIB_TRANSCUB(NDIM,+KSYS,NDIM,+KSYS,GTRA(1,1,2))
      CALL LIB_TRANSCUB(NDIM,+KSYS,NDIM,+KSYS,GTRA(1,1,3))
      CALL LIB_TRANSCUB(NDIM,+KSYS,NDIM,+KSYS,GTRA(1,1,4))
      CALL LIB_TRANSCUB(NDIM,+KSYS,NDIM,+KSYS,GTRA(1,1,5))
      DO IDIM1=1,NDIM
      DO IDIM=1,NDIM
      DELW(IDIM1,IDIM,IOMG)=GTRA(IDIM1,IDIM,1)
      BATH(IDIM1,IDIM,IOMG)=GTRA(IDIM1,IDIM,2)
      GLOC(IDIM1,IDIM,IOMG)=GTRA(IDIM1,IDIM,3)
      SIGW(IDIM1,IDIM,IOMG)=GTRA(IDIM1,IDIM,5)
      ENDDO
      ENDDO
      ENDDO
      CALL LIB_TRANSCUB(NDIM,+KSYS,NHYB,0,VHYB(1,1))
C Average diagonal elements according to KST poiner
      CALL LIB_FORCESYM3L(ELEV,KST,NDIM,1,NRUNSHL)
      DO IOMG=0,NOMG
      DO IDIM1=1,NDIM
      DO IDIM=1,NDIM
      GTRA(IDIM1,IDIM,1)=DELW(IDIM1,IDIM,IOMG)
      GTRA(IDIM1,IDIM,2)=BATH(IDIM1,IDIM,IOMG)
      GTRA(IDIM1,IDIM,3)=GLOC(IDIM1,IDIM,IOMG)
      GTRA(IDIM1,IDIM,5)=SIGW(IDIM1,IDIM,IOMG)
      ENDDO
      ENDDO
      CALL LIB_FORCESYM3L(GTRA(1,1,1),KST,NDIM,1,NRUNSHL)
      CALL LIB_FORCESYM3L(GTRA(1,1,2),KST,NDIM,1,NRUNSHL)
      CALL LIB_FORCESYM3L(GTRA(1,1,3),KST,NDIM,1,NRUNSHL)
      CALL LIB_FORCESYM3L(GTRA(1,1,5),KST,NDIM,1,NRUNSHL)
      DO IDIM1=1,NDIM
      DO IDIM=1,NDIM
      DELW(IDIM1,IDIM,IOMG)=GTRA(IDIM1,IDIM,1)
      BATH(IDIM1,IDIM,IOMG)=GTRA(IDIM1,IDIM,2)
      GLOC(IDIM1,IDIM,IOMG)=GTRA(IDIM1,IDIM,3)
      SIGW(IDIM1,IDIM,IOMG)=GTRA(IDIM1,IDIM,5)
      ENDDO
      ENDDO
      ENDDO
C Hybridization for semicircle DOS according to DMFT
	IF(IMOD.EQ.1)THEN
	DO IDIM=1,NDIM
	DO IOMG=0,NOMG
	ZOMG=DCMPLX(WOMG(IOMG),0.D0)
	GFUN=GLOC(IDIM,IDIM,IOMG)
	TBND=DREAL(TPAR(IDIM,IDIM))
	CALL MDL_MODELHUB_SCFD(TBND,GFUN,DELW(IDIM,IDIM,IOMG))
	ENDDO
	ENDDO
	ELSEIF(IMOD.EQ.2)THEN
	DO IDIM=1,NDIM
	DO IOMG=0,NOMG
	ZOMG=DCMPLX(WOMG(IOMG),0.D0)
	TBND=DREAL(TPAR(IDIM,IDIM))
	EBND=DREAL(ECON(IDIM,IDIM))-CHEM
	VBND=DREAL(VPAR(IDIM,IDIM))
	ELOC=DREAL(ELEV(IDIM,IDIM))-CHEM
	CALL MDL_MODELPAM_SCFD(ZOMG,EBND,VBND,TBND,ELOC,
     &SIGW(IOMG,IDIM,IDIM),DELW(IOMG,IDIM,IDIM),GCON(IOMG,IDIM,IDIM))
	ENDDO
	ENDDO
	ENDIF
C Mix 
	IF(NDIT.NE.1)
     &CALL MDL_MIXDMF(0,ITER,IEXIT,1)   !!! mix hybridizations
	IF(IEXIT.EQ.1.OR.NDIT.EQ.1)GOTO 1100
 1000	CONTINUE
      TEXT='Real axis DMFT loop did not converge.'
 1100	CONTINUE
C Conduction band charge
	DO IDIM1=1,NDIM
	DO IDIM=1,NDIM
	IF(IDIM1.EQ.IDIM)ONE=1.D0
	IF(IDIM1.NE.IDIM)ONE=0.D0
	ZCON(IDIM1,IDIM)=0.D0
	DO IOMG=0,NOMG
      ZCON(IDIM1,IDIM)=ZCON(IDIM1,IDIM)-
     &DIMAG(GCON(IDIM1,IDIM,IOMG))/PI*FOMG(IOMG)
	ENDDO
	ZCON(IDIM1,IDIM)=ZCON(IDIM1,IDIM)*DBLE(2) ! Conduction band capacity is assumed to be 2 (s band)
	ENDDO
	ENDDO
C UPGRADE RATFILE IF REQUESTED
      IF(ICRSC.GT.0)THEN
C Locate section=dmft
      CALL READ_SECT(RATDATA(1),NLEN,ISEC,NSEC,MSEC,
     &'<section=dmft',13,'<section=',9,'ok',2)
	ALLOCATE(RATCOPY(NSEC))
	DO ILIN=1,MSEC
	RATCOPY(ILIN)=RATDATA(ILIN+ISEC-1)
	ENDDO
C Upgrade Positions of Chemical Potential
	HELP='! Chemical Potential                    '
	LHLP=40
	CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &  'chem',4,IN,1,0,CHEM,1,1,CM,1,0,' ',1,0,
     &  HELP,LHLP,DEF,ASK,VAL,NTH,.TRUE.,.TRUE.)
	DEALLOCATE(RATCOPY)
C Locate section=shel
      CALL READ_SECT(RATDATA(1),NLEN,ISEC,NSEC,MSEC,
     &'<section=shel',13,'<section=',9,'ok',2)
	ALLOCATE(RATCOPY(NSEC))
	DO ILIN=1,MSEC
	RATCOPY(ILIN)=RATDATA(ILIN+ISEC-1)
	ENDDO
C Upgrade Positions of Impurity Levels
      DO IDIM=1,NDIM
      ERAT(IDIM)=DREAL(ELEV(IDIM,IDIM))
      ENDDO
	IF(LORB.LE.1)HELP='! Local level energies                  '
	IF(LORB.GT.1)HELP='                                        '
	LHLP=40
	CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &  'eloc(:)',7,IN,1,0,ERAT,2*(2*LORB+1),1,CM,1,0,' ',1,0,
     &  HELP,LHLP,DEF,ASK,VAL,NTH,.TRUE.,.TRUE.)
	DEALLOCATE(RATCOPY)
C Update bath levels and hybridizations
      ALLOCATE(EBATH(14*NDIM,NBST))
      ALLOCATE(VBATH(14*NDIM,NBST))
	ILOC=1
	IHYB=0
	DO IBST=1,NBST                      !!! over bath states
      CALL READ_SECT(RATDATA(ILOC),NLEN-ILOC+1,KSEC,NSEC,MSEC,
     &'<section=blev',13,'<section=',9,'ok',2)
	ISEC=KSEC+ILOC-1
	ILOC=ISEC+1
C Allocate temporary file
      ALLOCATE(RATCOPY(NSEC))
      DO ILIN=1,MSEC
      RATCOPY(ILIN)=RATDATA(ILIN+ISEC-1)
      ENDDO
      IBAT=0
      DO IDST=1,NDST(IBST)
      IHYB=IHYB+1
      EBATH(IDST,IBST)=DREAL(EHYB(IHYB))
      DO IDIM=1,NDIM
      IBAT=IBAT+1
      VBATH(IBAT,IBST)=VHYB(IDIM,IHYB)
      ENDDO
      ENDDO
	IF(NDST(IBST).LE.6)HELP='! Bath  level energies                  '
	IF(NDST(IBST).GT.6)HELP='                                        '
	LHLP=40
	CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &  'ebat(:)',7,IN,1,0,EBATH(1,IBST),NDST(IBST),1,CM,1,0,' ',1,0,
     &  HELP,LHLP,DEF,ASK,VAL,NTH,.TRUE.,.TRUE.)
	HELP='                                        '
	LHLP=40
	CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &  'vhyb(:)',7,IN,1,0,VBATH(1,IBST),NDST(IBST)*NDIM,1,CM,
     &  1,0,' ',1,0,HELP,LHLP,DEF,ASK,VAL,NTH,.TRUE.,.TRUE.)
	DEALLOCATE(RATCOPY)
	ENDDO                                  !!! over bath levels
      DEALLOCATE(EBATH,VBATH)
      CALL READ_OVWR(RSCFILE,RATDATA,NLEN)
      ENDIF
C **************************************
C Transform matrices to spherical harmonics
      CALL LIB_TRANSCUB(NDIM,-KSYS,NDIM,-KSYS,TPAR(1,1))
      CALL LIB_TRANSCUB(NDIM,-KSYS,NDIM,-KSYS,VPAR(1,1))
      CALL LIB_TRANSCUB(NDIM,-KSYS,NDIM,-KSYS,ECON(1,1))
      CALL LIB_TRANSCUB(NDIM,-KSYS,NDIM,-KSYS,ELEV(1,1))
      DO IOMG=0,NOMG
      DO IDIM1=1,NDIM
      DO IDIM=1,NDIM
      GTRA(IDIM1,IDIM,1)=DELW(IDIM1,IDIM,IOMG)
      GTRA(IDIM1,IDIM,2)=BATH(IDIM1,IDIM,IOMG)
      GTRA(IDIM1,IDIM,3)=GLOC(IDIM1,IDIM,IOMG)
      GTRA(IDIM1,IDIM,5)=SIGW(IDIM1,IDIM,IOMG)
      ENDDO
      ENDDO
      CALL LIB_TRANSCUB(NDIM,-KSYS,NDIM,-KSYS,GTRA(1,1,1))
      CALL LIB_TRANSCUB(NDIM,-KSYS,NDIM,-KSYS,GTRA(1,1,2))
      CALL LIB_TRANSCUB(NDIM,-KSYS,NDIM,-KSYS,GTRA(1,1,3))
      CALL LIB_TRANSCUB(NDIM,-KSYS,NDIM,-KSYS,GTRA(1,1,5))
      DO IDIM1=1,NDIM
      DO IDIM=1,NDIM
      DELW(IDIM1,IDIM,IOMG)=GTRA(IDIM1,IDIM,1)
      BATH(IDIM1,IDIM,IOMG)=GTRA(IDIM1,IDIM,2)
      GLOC(IDIM1,IDIM,IOMG)=GTRA(IDIM1,IDIM,3)
      SIGW(IDIM1,IDIM,IOMG)=GTRA(IDIM1,IDIM,5)
      ENDDO
      ENDDO
      ENDDO
C Store Green function data
	IF(ICGRF.EQ.2)CALL RAT_SETGRF     !!! store Green function data
C MEMORY DEALLOCATIONS
      DEALLOCATE(GCON,G0M1,GTRA,ZCON,ELEV0,WORK,KST)
      DEALLOCATE(RATDATA)
      CALL RAT_ALLOCATE('D')
10100 FORMAT('***** ',A8,1X,A8,'; CPU : ',G12.5,
     &       '; CUR/MAX mem.(Mb): ',G10.3,'/',G10.3)
	END
	
	
	
	
	
	SUBROUTINE MDL_SCFRATF_HYBR
***************************************************************
* Disrectize hybridization function
***************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                       !!! from setup
	USE COM_MDLPAR  ,ONLY: IMPS,IMOD,ISYM,ISPN
	USE COM_MDLMIX  ,ONLY: NDIT
      USE COM_MSBMESH ,ONLY: TEMP,NMSC,WMSC,FMSC,DMSC,KGRD
      USE COM_LSHELL  ,ONLY: LORB,KSYS,DAMP,KSTSHL,NRUNSHL
      USE COM_IMPGRF  ,ONLY: CHEM,KVRB,DELW,BATH,NMOM,
     &                       VRHB,WRHB,PRHB,ORHB,NPLD,KDIN,KDRT
      USE COM_RATCLS  ,ONLY: KHYBLEV
      USE COM_RATHYB  ,ONLY: NHYB,EHYB,VHYB
      USE COM_CHANNELS,ONLY: IUINP
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
C Allocatable arrays
	REAL*8, ALLOCATABLE :: FTMP(:),DTMP(:),GTMP(:),HTMP(:),WTMP(:)
      REAL*8, ALLOCATABLE :: WINP(:),WOUT(:),XTMP(:),SINT(:),XVEC(:)
      REAL*8, ALLOCATABLE :: DOCC(:,:),DTOT(:,:),UOCC(:,:)
	COMPLEX*16, ALLOCATABLE :: DOMG(:),VCOF(:),WCOF(:),PCOF(:),OCOF(:)
      COMPLEX*16, ALLOCATABLE :: VARR(:,:),WARR(:,:),PINV(:,:),WORK(:)
      COMPLEX*16, ALLOCATABLE :: HINP(:),HOUT(:),ZOUT(:)
      COMPLEX*16, ALLOCATABLE :: WORK1(:),WORK2(:)
C Local variables
	COMPLEX*16 DIM,ZMSC,GMSB
	EXTERNAL MDL_SCFRATF_HYBD
	DATA PI/3.141592653589793D0/,DIM/(0.D0,1.D0)/
C Memory Allocations
C Averagings
	ALLOCATE(DOMG(0:NMSCMEM))
	ALLOCATE(VCOF(NPLD))
	ALLOCATE(WCOF(NPLD))
	ALLOCATE(PCOF(NPLD))
	ALLOCATE(OCOF(NPLD))
      NDIM=2*(2*LORB+1)
C Find moments of the Hybridization function
      ALLOCATE(DOCC(-NMOM:+NMOM,NDIM))
      ALLOCATE(UOCC(-NMOM:+NMOM,NDIM))
      ALLOCATE(DTOT(-NMOM:+NMOM,NDIM))
	DO IDIM=1,NDIM
	DO IMOM=-NMOM,+NMOM
	DOCC(IMOM,IDIM)=0.D0
	DTOT(IMOM,IDIM)=0.D0
	IF(KGRD.EQ.1)THEN
	DO IMSC=0,NMSC
	WOMG=DREAL(WMSC(IMSC))
	WMOM=0.D0
	IF(ABS(WOMG).GT.1.D-08)WMOM=WOMG**IMOM
	DOCC(IMOM,IDIM)=DOCC(IMOM,IDIM)+WMOM*FMSC(IMSC)*
     &DIMAG(DELW(IDIM,IDIM,IMSC))*FERMIFUN(WOMG,TEMP)
	DTOT(IMOM,IDIM)=DTOT(IMOM,IDIM)+WMOM*FMSC(IMSC)*
     &DIMAG(DELW(IDIM,IDIM,IMSC))
	ENDDO
	ENDIF
	UOCC(IMOM,IDIM)=DTOT(IMOM,IDIM)-DOCC(IMOM,IDIM)
	ENDDO
	ENDDO
C **********************************************
C Find rational representation for Delta(w) using 
C algorithm assuming moments: 2 poles
      IF(KDIN.EQ.1)THEN
      IF(KGRD.NE.1)CALL FULLSTOP
     &('<MDL_SCFRATF_HYBR>:: Grid should be REAL for MOM2 fit')
	IF(NPLD.NE.2)CALL FULLSTOP
     &('<MDL_SCFRATF_HYBR>:: Npld should be 2 for MOM2 fit')
      DO IPOL=1,NPLD
      DO IDIM1=1,NDIM
      DO IDIM=1,NDIM
      VRHB(IDIM1,IDIM,IPOL)=(0.D0,0.D0)
      WRHB(IDIM1,IDIM,IPOL)=(0.D0,0.D0)
      PRHB(IDIM1,IDIM,IPOL)=(0.D0,0.D0)
      ORHB(IDIM1,IDIM,IPOL)=(0.D0,0.D0)
      ENDDO
      ENDDO
      ENDDO
      ALLOCATE(WTMP(NPLD))
      ALLOCATE(HTMP(NPLD))
	DO IDIM=1,NDIM
C States below 0
	CALL LIB_RATMOM2(DOCC(0,IDIM),DOCC(1,IDIM),
     &                 HTMP(1),WTMP(1),-1.D0)
C States above 0
	CALL LIB_RATMOM2(UOCC(0,IDIM),UOCC(1,IDIM),
     &                 HTMP(2),WTMP(2),+1.D0)
	DO IPOL=1,NPLD
	VRHB(IDIM,IDIM,IPOL)=SQRT(ABS(HTMP(IPOL)))
	WRHB(IDIM,IDIM,IPOL)=SQRT(ABS(HTMP(IPOL)))
	PRHB(IDIM,IDIM,IPOL)=WTMP(IPOL)
	ORHB(IDIM,IDIM,IPOL)=1.D0
	ENDDO
	ENDDO
	DEALLOCATE(WTMP,HTMP)
C **********************************************
C Find rational representation for Delta(w) using 
C algorithm assuming moments: 4 poles
	ELSEIF(KDIN.EQ.2)THEN
      IF(KGRD.NE.1)CALL FULLSTOP
     &('<MDL_SCFRATF_HYBR>:: Grid should be REAL for MOM4 fit')
	IF(NPLD.NE.4)CALL FULLSTOP
     &('<MDL_SCFRATF_HYBR>:: Npld should be 4 for MOM4 fit')
      DO IPOL=1,NPLD
      DO IDIM1=1,NDIM
      DO IDIM=1,NDIM
      VRHB(IDIM1,IDIM,IPOL)=(0.D0,0.D0)
      WRHB(IDIM1,IDIM,IPOL)=(0.D0,0.D0)
      PRHB(IDIM1,IDIM,IPOL)=(0.D0,0.D0)
      ORHB(IDIM1,IDIM,IPOL)=(0.D0,0.D0)
      ENDDO
      ENDDO
      ENDDO
      ALLOCATE(WTMP(NPLD))
      ALLOCATE(HTMP(NPLD))
	DO IDIM=1,NDIM
C Occupied states
	CALL LIB_RATMOM4(DOCC( 0,IDIM),DOCC( 1,IDIM),
     &                 DOCC( 2,IDIM),DOCC(-1,IDIM),
     &                 HTMP( 1),HTMP( 2),
     &                 WTMP( 1),WTMP( 2),-1.D0)
C Unoccupied states
	CALL LIB_RATMOM4(UOCC( 0,IDIM),UOCC( 1,IDIM),
     &                 UOCC( 2,IDIM),UOCC(-1,IDIM),
     &                 HTMP( 3),HTMP( 4),
     &                 WTMP( 3),WTMP( 4),+1.D0)
	DO IPOL=1,NPLD
	VRHB(IDIM,IDIM,IPOL)=SQRT(ABS(HTMP(IPOL)))
	WRHB(IDIM,IDIM,IPOL)=SQRT(ABS(HTMP(IPOL)))
	PRHB(IDIM,IDIM,IPOL)=WTMP(IPOL)
	ORHB(IDIM,IDIM,IPOL)=1.D0
	ENDDO
	ENDDO
	DEALLOCATE(WTMP,HTMP)
C **********************************************
C Find rational representation for Delta(w) using 
C algorithm assuming moments: 6 poles
	ELSEIF(KDIN.EQ.3)THEN
      IF(KGRD.NE.1)CALL FULLSTOP
     &('<MDL_SCFRATF_HYBR>:: Grid should be REAL for MOM6 fit')
	IF(NPLD.NE.6)CALL FULLSTOP
     &('<MDL_SCFRATF_HYBR>:: Npld should be 6 for MOM6 fit')
      DO IPOL=1,NPLD
      DO IDIM1=1,NDIM
      DO IDIM=1,NDIM
      VRHB(IDIM1,IDIM,IPOL)=(0.D0,0.D0)
      WRHB(IDIM1,IDIM,IPOL)=(0.D0,0.D0)
      PRHB(IDIM1,IDIM,IPOL)=(0.D0,0.D0)
      ORHB(IDIM1,IDIM,IPOL)=(0.D0,0.D0)
      ENDDO
      ENDDO
      ENDDO
      ALLOCATE(WTMP(NPLD))
      ALLOCATE(HTMP(NPLD))
	DO IDIM=1,NDIM
C Occupied states
	CALL LIB_RATMOM6(DOCC( 0,IDIM),DOCC( 1,IDIM),
     &                 DOCC( 2,IDIM),DOCC( 3,IDIM),
     &                 DOCC(-1,IDIM),DOCC(-2,IDIM),
     &   HTMP( 1),HTMP( 2),HTMP( 3),
     &   WTMP( 1),WTMP( 2),WTMP( 3),-1.D0)
C Unoccupied states
	CALL LIB_RATMOM6(UOCC( 0,IDIM),UOCC( 1,IDIM),
     &                 UOCC( 2,IDIM),UOCC( 3,IDIM),
     &                 UOCC(-1,IDIM),UOCC(-2,IDIM),
     &   HTMP( 4),HTMP( 5),HTMP( 6),
     &   WTMP( 4),WTMP( 5),WTMP( 6),+1.D0)
	DO IPOL=1,NPLD
	VRHB(IDIM,IDIM,IPOL)=SQRT(ABS(HTMP(IPOL)))
	WRHB(IDIM,IDIM,IPOL)=SQRT(ABS(HTMP(IPOL)))
	PRHB(IDIM,IDIM,IPOL)=WTMP(IPOL)
	ORHB(IDIM,IDIM,IPOL)=1.D0
	ENDDO
	ENDDO
	DEALLOCATE(WTMP,HTMP)
C **********************************************
C Find rational representation for Delta(w) using 
C algorithm assuming arbitrary # of moments
	ELSEIF(KDIN.EQ.4)THEN
      IF(KGRD.NE.1)CALL FULLSTOP
     &('<MDL_SCFRATF_HYBR>:: Grid should be REAL for MOMN fit')
	IF(MOD(NPLD,2).NE.0)CALL FULLSTOP
     &('<MDL_SCFRATF_HYBR>:: Npld should be Even for MOMN fit')
      DO IPOL=1,NPLD
      DO IDIM1=1,NDIM
      DO IDIM=1,NDIM
      VRHB(IDIM1,IDIM,IPOL)=(0.D0,0.D0)
      WRHB(IDIM1,IDIM,IPOL)=(0.D0,0.D0)
      PRHB(IDIM1,IDIM,IPOL)=(0.D0,0.D0)
      ORHB(IDIM1,IDIM,IPOL)=(0.D0,0.D0)
      ENDDO
      ENDDO
      ENDDO
      ALLOCATE(WTMP(NPLD))
      ALLOCATE(HTMP(NPLD))
	DO IDIM=1,NDIM
C Occupied states
	CALL LIB_RAPX(DOCC(0,IDIM),NPLD-1,HTMP(1),
     &              WTMP(1),NPLD/2,IERR,-1.D0,0)
	IF(IERR.GT.0)
     &CALL FULLSTOP('<MDL_SCFRATF_HYBR>:: ERROR IN LIB_RAPX')
C Unoccupied states
	CALL LIB_RAPX(UOCC(0,IDIM),NPLD-1,HTMP(NPLD/2+1),
     &WTMP(NPLD/2+1),NPLD/2,IERR,+1.D0,0)
	IF(IERR.GT.0)
     &CALL FULLSTOP('<MDL_SCFRATF_HYBR>:: ERROR IN LIB_RAPX')
	DO IPOL=1,NPLD
	VRHB(IDIM,IDIM,IPOL)=SQRT(ABS(HTMP(IPOL)))
	WRHB(IDIM,IDIM,IPOL)=SQRT(ABS(HTMP(IPOL)))
	PRHB(IDIM,IDIM,IPOL)=WTMP(IPOL)
	ORHB(IDIM,IDIM,IPOL)=(1.D0,0.D0)
	ENDDO
	ENDDO
	DEALLOCATE(WTMP,HTMP)
C ******************************************************
C Find rational representation for Delta(w) using 
C simple fit to the data on the real axis
C ******************************************************
      ELSEIF(KDIN.EQ.5)THEN
      IF(KGRD.NE.1)CALL FULLSTOP
     &('<MDL_SCFRATF_HYBR>:: Grid should be REAL for GRID fit')
      ALLOCATE(SINT(NPLD))
      DO IPOL=1,NPLD
      DO IDIM1=1,NDIM
      DO IDIM=1,NDIM
      VRHB(IDIM1,IDIM,IPOL)=(0.D0,0.D0)
      WRHB(IDIM1,IDIM,IPOL)=(0.D0,0.D0)
      ORHB(IDIM1,IDIM,IPOL)=(0.D0,0.D0)
      ENDDO
      ENDDO
      ENDDO
	DO IDIM=1,NDIM
C Set grid if not known
      SUM=0.D0
	DO IPOL=1,NPLD-1
      SUM=SUM+ABS(PRHB(IDIM,IDIM,IPOL+1)-PRHB(IDIM,IDIM,IPOL))
      ENDDO
      IF(SUM.LE.1.D-08.AND.NPLD.GT.1)THEN
      WMIN=DREAL(WMSC(0))
      WMAX=DREAL(WMSC(NMSC))
      STEP=(WMAX-WMIN)/DBLE(NPLD-1)
      DO IPOL=1,NPLD
      PRHB(IDIM,IDIM,IPOL)=WMIN+STEP*DBLE(IPOL-1)
      ENDDO
      PRHB(IDIM,IDIM,NPLD)=WMAX
      ENDIF
C Set integration intervals
      DO IPOL=1,NPLD
      IF(IPOL.GT.1.AND.IPOL.LT.NPLD)THEN
      DL=PRHB(IDIM,IDIM,IPOL)-PRHB(IDIM,IDIM,IPOL-1)
      DR=PRHB(IDIM,IDIM,IPOL+1)-PRHB(IDIM,IDIM,IPOL)
      SINT(IPOL)=MIN(DL/2.D0,DR/2.D0)
      ELSEIF(IPOL.EQ.1.AND.NPLD.NE.1)THEN
      DR=PRHB(IDIM,IDIM,IPOL+1)-PRHB(IDIM,IDIM,IPOL)
      SINT(IPOL)=DR/2.D0
      ELSEIF(IPOL.EQ.NPLD.AND.NPLD.NE.1)THEN
      DL=PRHB(IDIM,IDIM,IPOL)-PRHB(IDIM,IDIM,IPOL-1)
      SINT(IPOL)=DL/2.D0
      ELSE
      CALL FULLSTOP('<MDL_SCFRATF_HYBR>: NPLD.EQ.1 is not assumed')
      ENDIF
      ENDDO
C Integrate ImDelta(w) over the intervals
      DO IPOL=1,NPLD
      WLEF=PRHB(IDIM,IDIM,IPOL)-SINT(IPOL)
      WRIT=PRHB(IDIM,IDIM,IPOL)+SINT(IPOL)
      VEFF=0.D0
      DO IMSC=0,NMSC
      IF(DREAL(WMSC(IMSC)).LT.WLEF.OR.DREAL(WMSC(IMSC)).GT.WRIT)CYCLE
      VEFF=VEFF+DIMAG(DELW(IDIM,IDIM,IMSC))*FMSC(IMSC)
      ENDDO
C Store the result as an effective hopping
      VRHB(IDIM,IDIM,IPOL)=SQRT(ABS(VEFF))
      WRHB(IDIM,IDIM,IPOL)=SQRT(ABS(VEFF))
      ORHB(IDIM,IDIM,IPOL)=(1.D0,0.D0)
      ENDDO
      ENDDO      
      DEALLOCATE(SINT)
C ******************************************************
C Find rational representation for Delta(w) using 
C conjugate gradient search
C ******************************************************
      ELSEIF(KDIN.EQ.6)THEN
      NLEN=2*NPLD
      DO IPOL=1,NPLD
      DO IDIM1=1,NDIM
      DO IDIM=1,NDIM
      VRHB(IDIM1,IDIM,IPOL)=(0.D0,0.D0)
      WRHB(IDIM1,IDIM,IPOL)=(0.D0,0.D0)
      PRHB(IDIM1,IDIM,IPOL)=(0.D0,0.D0)
      ORHB(IDIM1,IDIM,IPOL)=(0.D0,0.D0)
      ENDDO
      ENDDO
      ENDDO
      ALLOCATE(FTMP(0:NMSC))
      ALLOCATE(DTMP(0:NMSC))
      ALLOCATE(GTMP(NLEN))
      ALLOCATE(HTMP(NLEN*NLEN+4))
      ALLOCATE(WTMP(NLEN*NLEN+4))
      ALLOCATE(XTMP(NLEN))
      ALLOCATE(XVEC(NLEN))
C Remember content of the FMSC/DMSC arrays
      DO IMSC=0,NMSC
      FTMP(IMSC)=FMSC(IMSC)
      DTMP(IMSC)=DMSC(IMSC)
      ENDDO
	DO IDIM=1,NDIM
C Set hybridization
	DO IMSC=0,NMSC
	FMSC(IMSC)=DREAL(DELW(IDIM,IDIM,IMSC))
	DMSC(IMSC)=DIMAG(DELW(IDIM,IDIM,IMSC))
	ENDDO
C Set initial approximation to the parameters
      VPAR=0.D0
	DO IPOL=1,NPLD
	VPAR=VPAR+ABS(VRHB(IDIM,IDIM,IPOL))+
     &          ABS(WRHB(IDIM,IDIM,IPOL))
	ENDDO
C Use previous fit
	IF(VPAR.GE.1.D-10)THEN
      DO ILEN=1,NPLD
      XVEC(ILEN)=SQRT(ABS(DREAL(VRHB(IDIM,IDIM,IPOL))*
     &                    DREAL(WRHB(IDIM,IDIM,IPOL))))
      ENDDO
      DO ILEN=1,NPLD
      XVEC(ILEN+NPLD)=DREAL(PRHB(IDIM,IDIM,IPOL))
      ENDDO
      ELSE
C Generate some approximation
      DO ILEN=1,NPLD
      XVEC(ILEN)=1.D0
      ENDDO
      IF(NPLD.GT.1)STEP=1.D0/DBLE(NPLD-1)
      IF(NPLD.LE.1)STEP=0.D0
      DO ILEN=1,NPLD
      XVEC(ILEN+NPLD)=OBND*(DBLE(ILEN-1)*STEP-0.5D0)
      ENDDO
      ENDIF
      DO ILEN=1,NLEN
      XTMP(ILEN)=ABS(XVEC(ILEN))+1.D-15
      ENDDO
C Call conjugate gradient search subroutine
      CALL LIB_CONJGRAD(MDL_SCFRATF_HYBD,NLEN,XVEC,FMIN,GTMP,HTMP,WTMP,
     &                   -0.5D0,XTMP,1.D-05,1.D-05,1,5000,0,IEXIT)
C Rational interpolation coefficients are obtained
	DO IPOL=1,NPLD
	VRHB(IDIM,IDIM,IPOL)=XVEC(IPOL)
	WRHB(IDIM,IDIM,IPOL)=XVEC(IPOL)
	PRHB(IDIM,IDIM,IPOL)=XVEC(IPOL+NPLD)
	ORHB(IDIM,IDIM,IPOL)=(1.D0,0.D0)
	ENDDO
      ENDDO
C Rewind arrays back
      DO IMSC=0,NMSC
      FMSC(IMSC)=FTMP(IMSC)
      DMSC(IMSC)=DTMP(IMSC)
      ENDDO
      DEALLOCATE(GTMP,HTMP,WTMP,XTMP,XVEC,FTMP,DTMP)
C ******************************************************
C Find rational representation for Delta(w) using 
C Pade approximation to the data on the imaginary axis
C ******************************************************
      ELSEIF(KDIN.EQ.7)THEN
      IF(KGRD.NE.2)CALL FULLSTOP
     &('<MDL_SCFRATF_HYBR>:: Grid should be IMAG for PADE fit')
      DO IPOL=1,NPLD
      DO IDIM1=1,NDIM
      DO IDIM=1,NDIM
      VRHB(IDIM1,IDIM,IPOL)=(0.D0,0.D0)
      WRHB(IDIM1,IDIM,IPOL)=(0.D0,0.D0)
      PRHB(IDIM1,IDIM,IPOL)=(0.D0,0.D0)
      ORHB(IDIM1,IDIM,IPOL)=(0.D0,0.D0)
      ENDDO
      ENDDO
      ENDDO
      ALLOCATE(WINP(0:NMSC))
      ALLOCATE(HINP(0:NMSC))
      ALLOCATE(WOUT(2*NPLD))
      ALLOCATE(ZOUT(2*NPLD))
      ALLOCATE(HOUT(2*NPLD))
	DO IDIM=1,NDIM
C Set unform imaginary axis grid
      DO IMSC=0,NMSC
      WINP(IMSC)=DIMAG(WMSC(IMSC))
      HINP(IMSC)=DELW(IDIM,IDIM,IMSC)
      ENDDO
      WMIN=DIMAG(WMSC(0))
      WMAX=DIMAG(WMSC(NMSC))
      STEP=(WMAX-WMIN)/DBLE(2*NPLD-1)
      DO IPOL=1,2*NPLD
      WOUT(IPOL)=WMIN+STEP*DBLE(IPOL-1)
      ZOUT(IPOL)=DCMPLX(0.D0,WOUT(IPOL))
      ENDDO
      WOUT(1)=WMIN
      WOUT(2*NPLD)=WMAX
      ZOUT(1)=DCMPLX(0.D0,WMIN)
      ZOUT(2*NPLD)=DCMPLX(0.D0,WMAX)
      CALL LIB_CSPLINES(NMSC+1,WINP,HINP,2*NPLD,WOUT,HOUT)
C Make Pade fit
	CALL LIB_PADEPOLES(ZOUT,HOUT,PCOF,WCOF,NPLD)
      DO IPOL=1,NPLD
      PRHB(IDIM,IDIM,IPOL)=DREAL(PCOF(IPOL))
      VRHB(IDIM,IDIM,IPOL)=SQRT(ABS(DREAL(WCOF(IPOL))))
      WRHB(IDIM,IDIM,IPOL)=SQRT(ABS(DREAL(WCOF(IPOL))))
      ORHB(IDIM,IDIM,IPOL)=(1.D0,0.D0)
      ENDDO
      ENDDO
      DEALLOCATE(WINP,HINP,WOUT,ZOUT,HOUT)
      ENDIF
C ******************************************************
C Force rational representation for Delta(w)
      IF(KDRT.EQ.1)THEN
	ALLOCATE(PINV(NDIM,NDIM))
	ALLOCATE(VARR(NDIM,NDIM))
	ALLOCATE(WARR(NDIM,NDIM))
	ALLOCATE(WORK(NDIM))
C Do over frequencies
	DO IMSC=0,NMSC                          !!! over frequencies
	ZMSC=WMSC(IMSC)
C Set zero
	DO IDIM1=1,NDIM
	DO IDIM=1,NDIM
	DELW(IDIM1,IDIM,IMSC)=(0.D0,0.D0)
	ENDDO
	ENDDO
C DO OVER HYBRIDIZATION POLES
	DO IPOL=1,NPLD                          !!! over poles
C Set up matrices
	DO IDIM1=1,NDIM
	DO IDIM=1,NDIM
	PINV(IDIM1,IDIM)=(0.D0,0.D0)
	VARR(IDIM1,IDIM)=(0.D0,0.D0)
	WARR(IDIM1,IDIM)=(0.D0,0.D0)
	ENDDO
	ENDDO
	DO IDIM1=1,NDIM
	DO IDIM=1,NDIM
	PINV(IDIM1,IDIM)=
C     (ZMSC+EFRM)*
     &(ZMSC+DCMPLX(0.D0,0.D0))*
     &ORHB(IDIM1,IDIM,IPOL)-PRHB(IDIM1,IDIM,IPOL)
	VARR(IDIM1,IDIM)=VRHB(IDIM1,IDIM,IPOL)
	WARR(IDIM1,IDIM)=WRHB(IDIM1,IDIM,IPOL)
	ENDDO
	ENDDO
C Invert matrix
	CALL LIB_CINV(NDIM,PINV,NDIM,WORK,IFAIL)
	IF(IFAIL.NE.0)THEN
      WRITE(IUN,*)'<MDL_SCFRATF_HYBR>:: Error in inversion program'
	DO IDIM1=1,NDIM
	DO IDIM=1,NDIM
	PINV(IDIM1,IDIM)=(0.D0,0.0D0)
	ENDDO
	ENDDO
      ENDIF
C Construct product
	DO IDIM1=1,NDIM
	DO IDIM=1,NDIM
	DO JDEG1=1,NDIM
	DO JDEG=1,NDIM
	DELW(IDIM1,IDIM,IMSC)=DELW(IDIM1,IDIM,IMSC)+
     &VARR(IDIM1,JDEG1)*PINV(JDEG1,JDEG)*WARR(JDEG,IDIM) ! swapped indexes in Warr !
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO                                   !!! over poles
	ENDDO                                   !!! over frequencies
	DEALLOCATE(PINV,VARR,WARR,WORK)
      ENDIF
C Print poles and coefficients
	WRITE(IUN,10100)
	WRITE(IUN,10110)
      DO IDIM=1,NDIM
      DO IPOL=1,NPLD
      WDEL=VRHB(IDIM,IDIM,IPOL)*WRHB(IDIM,IDIM,IPOL)
      PDEL=DREAL(PRHB(IDIM,IDIM,IPOL))
	WRITE(IUN,10120)IDIM,IPOL,PDEL,WDEL
	ENDDO
	ENDDO
10100 FORMAT(1X,'Hybridization  Pole Expansion Results:')
10110 FORMAT(1X,'iDim  Pole     Position        Weight')
10120 FORMAT(1X,I3,3X,I3,3X,G12.5,3X,G12.5)
C MEMORY DEALLOCATIONS
	DEALLOCATE(DOMG,VCOF,WCOF,PCOF,OCOF)
      DEALLOCATE(DOCC,UOCC,DTOT)
      END
      
      
      
      SUBROUTINE MDL_SCFRATF_HYBD(NLEN,XVEC,FVAL)
**************************************************************
*  Subroutine returns value of the functional which performs *
*  a fit for hybridization function using conjugate gradient *
**************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                          !!! from setup
      USE COM_MSBMESH ,ONLY: TEMP,WMSC,NMSC,FMSC,DMSC         !!! from readhub
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8, ALLOCATABLE :: VHYB(:)
      REAL*8, ALLOCATABLE :: POLE(:)
      COMPLEX*16, ALLOCATABLE :: DELW(:)
      REAL*8 XVEC(NLEN)
      COMPLEX*16 DELF
      DATA PI/3.141592653589793D0/
C Memory allocations
      NPLD=NLEN/2
      ALLOCATE(VHYB(NPLD))
      ALLOCATE(POLE(NPLD))
      ALLOCATE(DELW(0:NMSC))
C Hybridization matrix elements and poles positions
      DO IPLD=1,NPLD
      VHYB(IPLD)=XVEC(IPLD)
      POLE(IPLD)=XVEC(IPLD+NPLD)
      ENDDO
C Hybridization function is passed thru two auxiliary arrays
      DO IMSC=0,NMSC
      DELW(IMSC)=DCMPLX(FMSC(IMSC),DMSC(IMSC))
      ENDDO
C Functional to minimize is the difference between Delta(w) and its rational fit
      DIFF=0.D0
      DO IMSC=0,NMSC
C Compute current fit to Delta(w)
      DELF=0.D0
      DO IPLD=1,NPLD
      DELF=DELF+VHYB(IPLD)**2/(WMSC(IMSC)-POLE(IPLD))
      ENDDO
C Compute difference
      DIFF=DIFF+ABS(DELF-DELW(IMSC))
      ENDDO
      FVAL=DIFF/DBLE(NMSC+1)
C Memory deallocations
      DEALLOCATE(VHYB,POLE,DELW)
      END