	SUBROUTINE MDL_SETGRF
***************************************************************
*  Stores Green function
***************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LSHELL  ,ONLY: NORB,LORB,ELEV,CSTA                     !!! from shells
      USE COM_IMPGRF  ,ONLY: CHEM,ICUB,NWOR,NWSP,IMRE,SIGW,KINT,
     &                       GLOC,SIGI,NPOL,NRAT,KRAT,
     &                       SRAT,VRAT,WRAT,PRAT,ORAT,GMOM,DMAT
	USE COM_MSBMESH ,ONLY: TEMP,KGRD,NMSC,WMSC                     !!! from readrat
	USE COM_FREQU   ,ONLY: NOMGGRF                                 !!! from getgrf
      USE COM_FERMI   ,ONLY: EF                                      !!! from readrat
	USE COM_CHANNELS,ONLY: IUAIN                                   !!! from channels
      USE COM_MDLOUT  ,ONLY: ICGRF,GRFFILE                           !!! from storage
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                         !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER, ALLOCATABLE :: ILMTBAS(:,:)
	INTEGER, ALLOCATABLE :: INODBAS(:,:)
      INTEGER, ALLOCATABLE :: IS(:)
      INTEGER, ALLOCATABLE :: ILSB(:)
      INTEGER, ALLOCATABLE :: NHST(:)
	REAL*8, ALLOCATABLE :: GDOS(:,:,:)
	REAL*8, ALLOCATABLE :: EIGV(:)
	COMPLEX*16, ALLOCATABLE :: OCP(:,:,:)
	COMPLEX*16, ALLOCATABLE :: OCS(:,:,:)
	COMPLEX*16, ALLOCATABLE :: HMAT(:,:)
	COMPLEX*16, ALLOCATABLE :: OMAT(:,:)
      CHARACTER*10, ALLOCATABLE :: TATS(:)
	COMPLEX*16 DIM,CMAT
	REAL*8 SPTOS(2),SPDOS(2)
	LOGICAL EXIST
	CHARACTER TEXT*64,CTHUB*2,CNHUB*1,CLHUB*1,TCTRL*10
     &   ,TL(0:3)*1,LIB_TDP*10,STRING*150,FILE*130,HELP*40
      DATA PI/3.141592653589793D0/,DIM/(0.D0,1.D0)/,TL/'s','p','d','f'/
	IF(ICGRF.EQ.0)RETURN
C ********************************************
	L=LORB
	NDEG=2*(2*LORB+1)
C STORE HEADER
	INQUIRE(FILE=GRFFILE,EXIST=EXIST)
	IF(EXIST)THEN
      OPEN(UNIT=IUAIN,FILE=GRFFILE,STATUS='OLD',FORM='FORMATTED')
	CLOSE(UNIT=IUAIN,STATUS='DELETE')
	ENDIF
	OPEN(UNIT=IUAIN,FILE=GRFFILE,STATUS='NEW',FORM='FORMATTED')
	WRITE(IUAIN,10010)
	WRITE(IUAIN,10020)
10010	FORMAT(1X,'<FILE=GRFFILE,INPUT=MODERN>')
10020 FORMAT('****************************************************')
	WRITE(IUAIN,10030)
10030 FORMAT(1X,'<SECTION=CTRL>               ! CONTROL PARAMETERS:')
      IF(NOMGGRF.GT.0)THEN
      HELP='! Frequency Grid                       '
      IF(KGRD.EQ.1)
     &WRITE(IUAIN,10040)NMSC,HELP
10040 FORMAT(1X,'nOmgGrf=',I5,16X,A40)
      HELP='! Min.Frequency (Ry)                   '
      IF(KGRD.EQ.1)
     &WRITE(IUAIN,10050)DREAL(WMSC(0)),HELP
      IF(KGRD.EQ.2)
     &WRITE(IUAIN,10050)DIMAG(WMSC(0)),HELP
10050 FORMAT(1X,'WminGrf=',G14.7,7X,A40)
      HELP='! Max.Frequency (Ry)                   '
      IF(KGRD.EQ.1)
     &WRITE(IUAIN,10060)DREAL(WMSC(NMSC)+EF),HELP
      IF(KGRD.EQ.2)
     &WRITE(IUAIN,10060)DIMAG(WMSC(NMSC)),HELP
10060 FORMAT(1X,'WmaxGrf=',G14.7,7X,A40)
      ENDIF
C Process CUBC
      HELP='! Cubic/Spherical harmonics (output)    '
	IF(ICUB.EQ.1)TCTRL='cubic    '
	IF(ICUB.EQ.2)TCTRL='spherical'
	IF(ICUB.EQ.3)TCTRL='spinor'
	WRITE(IUAIN,10061)TCTRL,HELP
10061 FORMAT(1X,'Yharm = ',A10,11X,A40)
C Process NWOR
      IF(NWOR.EQ.1)TCTRL='One     '
      IF(NWOR.EQ.2)TCTRL='Both    '
      HELP='! One/Both orbits to store              '
	WRITE(IUAIN,10063)TCTRL,HELP
10063 FORMAT(1X,'Worbs = ',A10,11X,A40)
C Process NWSP
      IF(NWSP.EQ.1)TCTRL='One     '
      IF(NWSP.EQ.2)TCTRL='Both    '
      HELP='! One/Both spins  to store              '
	WRITE(IUAIN,10064)TCTRL,HELP
10064 FORMAT(1X,'Wspin = ',A10,11X,A40)
C Process REIM
      HELP='! Real/Complex output                   '
	IF(IMRE.EQ.1)TCTRL='real      '
	IF(IMRE.EQ.2)TCTRL='complex   '
	WRITE(IUAIN,10065)TCTRL,HELP
10065 FORMAT(1X,'Format= ',A10,11X,A40)
C STORE DOS DATA
	WRITE(IUAIN,10070)
10070 FORMAT(1X,'<SECTION=DATA>               ! DOS DATA:')
C Set atoms
      NATOM=1
      NSORT=1
      NSPIN=NWSP
      NORBS=NWOR
      ALLOCATE(IS(NATOM))
      DO I=1,NATOM
      IS(I)=I
      ENDDO
      ALLOCATE(ILSB(NSORT))
      ALLOCATE(NHST(NSORT))
      ILSB(1)=L
      NHST(1)=1
      IF(KGRD.EQ.1)
     &WRITE(IUAIN,*)NATOM,NSORT,NSPIN,NORBS,
     &(IS(I),I=1,NATOM),(ILSB(I),I=1,NSORT),
     &(NHST(I),I=1,NSORT),0.D0,
     &DREAL(WMSC(0)),DREAL(WMSC(NMSC)),NMSC
      IF(KGRD.EQ.2)
     &WRITE(IUAIN,*)NATOM,NSORT,NSPIN,NORBS,
     &(IS(I),I=1,NATOM),(ILSB(I),I=1,NSORT),
     &(NHST(I),I=1,NSORT),0.D0,
     &DIMAG(WMSC(0)),DIMAG(WMSC(NMSC)),NMSC
      ALLOCATE(TATS(NATOM))
      TATS(1)='El'
      WRITE(IUAIN,FMT='(5A10)')(TATS(I),I=1,NSORT)
C Store basis set
      ALLOCATE(ILMTBAS(0:L,NATOM))
      ALLOCATE(INODBAS(0:L,NATOM))
      LA=0
      DO I=1,NATOM
      LH=ILSB(I)
      LA=MAX(LA,LH)
      DO LI=0,LH
      ILMTBAS(LI,I)=0
      INODBAS(LI,I)=0
      IF(LI.EQ.L .AND.I.EQ.1)ILMTBAS(LI,I)=1
      IF(LI.EQ.LH.AND.I.NE.1)ILMTBAS(LI,I)=1
      IF(LI.EQ.L .AND.I.EQ.1)INODBAS(LI,I)=NORB
      IF(LI.EQ.LH.AND.I.NE.1)INODBAS(LI,I)=1
      ENDDO
      ENDDO
      WRITE(IUAIN,*)((ILMTBAS(LI,I),LI=0,ILSB(I)),
     &I=1,NATOM)
      WRITE(IUAIN,*)((INODBAS(LI,I),LI=0,ILSB(I)),
     &I=1,NATOM)
C Store imaginary part of the Green function into the GrfFile
      NWIG=(LA+1)*(2*LA+1)*(2*LA+3)/3
	ALLOCATE(GDOS(NWIG,2,NATOM))
	DO 1000 IMSC=0,NMSC             ! over imsc
C Impurity
	M1S1=0
	DO ISPIN1=1,2                   ! over ispin1
	DO M1=-L,L                      ! over m1
	M1S1=M1S1+1
	MS=0
	DO ISPIN=1,2                    ! over ispin
	DO M=-L,L                       ! over m
	MS=MS+1
	IF(ISPIN1.NE.ISPIN)CYCLE
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M1+1
	GDOS(IU,ISPIN,1)=-DIMAG(GLOC(M1S1,MS,IMSC))/PI
	ENDDO                           ! over m
	ENDDO                           ! over ispin
	ENDDO                           ! over m1
	ENDDO                           ! over ispin1
C Averages
	DO ISPIN=1,2
	SPDOS(ISPIN)=0.D0
	SPTOS(ISPIN)=0.D0
	DO I=1,NATOM
	LH=ILSB(I)
	DO M=-LH,LH
	IU=LH*(2*LH-1)*(2*LH+1)/3+(2*LH+1)*(LH+M)+LH+M+1
	SPDOS(ISPIN)=SPDOS(ISPIN)+GDOS(IU,ISPIN,I)
	ENDDO
	ENDDO
	ENDDO
C Average over spins, if necessary
	IF(NWSP.EQ.1.AND.NWOR.EQ.1)THEN
	SPTOS(1)=SPTOS(1)+SPTOS(2)
	SPDOS(1)=SPDOS(1)+SPDOS(2)
	DO I=1,NATOM
	LH=ILSB(I)
	DO M1=-LH,LH
	DO M=-LH,LH
	IU=LH*(2*LH-1)*(2*LH+1)/3+(2*LH+1)*(LH+M)+LH+M1+1
	GDOS(IU,1,I)=GDOS(IU,1,I)+GDOS(IU,2,I)
	ENDDO
	ENDDO
	ENDDO
	ELSEIF(NWSP.EQ.2.AND.NWOR.EQ.1)THEN
C Do nothing
	ELSEIF(NWSP.EQ.1.AND.NWOR.EQ.2)THEN
C Error
	CALL FULLSTOP('nSpin = 2, nOrbs = 2 cannot be set')
	ELSEIF(NWSP.EQ.2.AND.NWOR.EQ.2)THEN
	TOSAV=(SPTOS(1)+SPTOS(2))/2.D0
	DOSAV=(SPDOS(1)+SPDOS(2))/2.D0
	DO ISPIN=1,2
	SPTOS(ISPIN)=TOSAV
	SPDOS(ISPIN)=DOSAV
	ENDDO
	DO I=1,NATOM
	LH=ILSB(I)
	DO M1=-LH,LH
	DO M=-LH,LH
      IU=LH*(2*LH-1)*(2*LH+1)/3+(2*LH+1)*(LH+M)+L+M1+1
	DOSAV=(GDOS(IU,1,I)+GDOS(IU,2,I))/2.D0
	DO ISPIN=1,2
	GDOS(IU,ISPIN,I)=DOSAV
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDIF
	IF(KGRD.EQ.1)WOMG=DREAL(WMSC(IMSC))
	IF(KGRD.EQ.2)WOMG=DIMAG(WMSC(IMSC))
      WRITE(IUAIN,*)WOMG,(SPTOS(ISPIN),ISPIN=1,NWSP),
     &                   (SPDOS(ISPIN),ISPIN=1,NWSP)
      DO ISPIN=1,NWSP
      DO I=1,NATOM
      LH=ILSB(I)
      LMS=LH*(2*LH-1)*(2*LH+1)/3+1
      LME=LMS+(2*LH+1)**2-1
      WRITE(IUAIN,*)(GDOS(IU,ISPIN,I),IU=LMS,LME)
      ENDDO
      ENDDO
 1000 CONTINUE                        ! over imsc
      DEALLOCATE(IS,ILSB,NHST)
	DEALLOCATE(ILMTBAS,INODBAS)
	DEALLOCATE(GDOS)
C CONSTRUCT SELF-ENERGY MATRIX
	IF(KGRD.EQ.1)
     &WRITE(IUAIN,10081)
10081 FORMAT(1X,'<SECTION=SIGR>',14X,'! SELF-ENERGY AT REAL AXIS:')
	IF(KGRD.EQ.2)
     &WRITE(IUAIN,10082)
10082 FORMAT(1X,'<SECTION=SIGW>',14X,'! SELF-ENERGY AT IMAG AXIS:')
	IREC=0
C Process NMSC
      HELP='! # of frequencies                      '
      WRITE(IUAIN,10091)NMSC,HELP
10091 FORMAT(1X,'nMsi  =',I10,11X,A40)
	ALLOCATE(OCP((L+1)*(2*L+1)*(2*L+3)/3,2,2))
	ALLOCATE(OCS((L+1)*(2*L+1)*(2*L+3)/3,2,2))
	DO 2000 IMSC=0,NMSC          ! over imsc
C Self-energy in packed form
	DO IORBS=1,2
	DO IUPDN=1,2
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =3-IUPDN
	ENDIF
	DO K=-L,L
	IDIM1=K+L+1+(2*L+1)*(ISPIN1-1)
	DO M=-L,L
	IDIM=M+L+1+(2*L+1)*(ISPIN-1)
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+K+1 !!! (l,k m)
	IW=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+K)+L+M+1 !!! (l,m k)
	OCS(IU,IUPDN,IORBS)=SIGW(IDIM1,IDIM,IMSC)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	IF(KGRD.EQ.1)
     &WRITE(IUAIN,10101)CSTA,IMSC,DREAL(WMSC(IMSC))
	IF(KGRD.EQ.2)
     &WRITE(IUAIN,10102)CSTA,IMSC,DIMAG(WMSC(IMSC))
C  STORE MATRIX IN A GIVEN REPRESENTATION     
      CALL HUB_WRITEREP(OCS,(L+1)*(2*L+1)*(2*L+3)/3,2,2,
     &                  NWSP,NWOR,L,ICUB,IMRE,IUAIN)
 2000	CONTINUE                               !!! over imsc
C FORMATS
10101 FORMAT(1X,'cState=',A10,' ; iOmg = ',I7,' ; wOmg = ',G14.7)
10102 FORMAT(1X,'cState=',A10,' ; iMsb = ',I7,' ; wMsb = ',G14.7)
C SAVE POLE EXPANSION FOR ATOMIC SELF-ENERGY
C Store pole coefficients
	WRITE(IUAIN,10210)
10210 FORMAT(1X,'<SECTION=SRAT>',14X,'! RATIONAL INTERPOLATION:')
C Process NRAT
	WRITE(IUAIN,10300)CSTA,NPOL
	WRITE(IUAIN,10250)
	WRITE(IUAIN,10301)CSTA
C STORE ARRAYS
	DO IORBS=1,2
	DO IUPDN=1,2
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =3-IUPDN
	ENDIF
	DO K=-L,L
	IDIM1=K+L+1+(2*L+1)*(ISPIN1-1)
	DO M=-L,L
	IDIM=M+L+1+(2*L+1)*(ISPIN-1)
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+K+1 !!! (l,k m)
	IW=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+K)+L+M+1 !!! (l,m k)
      OCS(IU,IUPDN,IORBS)=SRAT(IDIM1,IDIM)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C  STORE MATRIX IN A GIVEN REPRESENTATION     
      CALL HUB_WRITEREP(OCS,(L+1)*(2*L+1)*(2*L+3)/3,2,2,
     &                  NWSP,NWOR,L,ICUB,IMRE,IUAIN)
C STORE RATIONAL INTERPOLATION COEFFICIENTS
	DO IPOL=1,NPOL
	DO IARR=1,4                            !!! over arrays
	IF(IARR.EQ.1)WRITE(IUAIN,10260)
	IF(IARR.EQ.2)WRITE(IUAIN,10270)
	IF(IARR.EQ.3)WRITE(IUAIN,10280)
	IF(IARR.EQ.4)WRITE(IUAIN,10290)
	WRITE(IUAIN,10305)CSTA,IPOL
C STORE ARRAYS
	DO IORBS=1,2
	DO IUPDN=1,2
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =3-IUPDN
	ENDIF
	DO K=-L,L
	IDIM1=K+L+1+(2*L+1)*(ISPIN1-1)
	DO M=-L,L
	IDIM=M+L+1+(2*L+1)*(ISPIN-1)
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+K+1 !!! (l,k m)
	IW=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+K)+L+M+1 !!! (l,m k)
      IF(IARR.EQ.1)
     &OCS(IU,IUPDN,IORBS)=VRAT(IDIM1,IDIM,IPOL)
      IF(IARR.EQ.2)
     &OCS(IU,IUPDN,IORBS)=WRAT(IDIM1,IDIM,IPOL)
      IF(IARR.EQ.3)
     &OCS(IU,IUPDN,IORBS)=PRAT(IDIM1,IDIM,IPOL)
      IF(IARR.EQ.4)
     &OCS(IU,IUPDN,IORBS)=ORAT(IDIM1,IDIM,IPOL)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C  STORE MATRIX IN A GIVEN REPRESENTATION     
      CALL HUB_WRITEREP(OCS,(L+1)*(2*L+1)*(2*L+3)/3,2,2,
     &                  NWSP,NWOR,L,ICUB,IMRE,IUAIN)
	ENDDO                                  !!! over arrays
	ENDDO                                  !!! over poles
10250 FORMAT('!!! Sigma(oo)')
10260 FORMAT('!!! V coefficients')
10270 FORMAT('!!! W coefficients')
10280 FORMAT('!!! P poles positions')
10290 FORMAT('!!! O overlap matrix')
10300 FORMAT(1X,'cState=',A10,' ; nPoles = ',I3)
10301 FORMAT(1X,'cState=',A10)
10305 FORMAT(1X,'cState=',A10,' ; iPol = ',I3)
C SAVE DENSITY MATRIX
C Store pole coefficients
	WRITE(IUAIN,10400)
10400 FORMAT(1X,'<SECTION=DHUB>',14X,'! DENSITY MATRIX:')
	WRITE(IUAIN,10405)CSTA
C STORE ARRAYS
	DO IORBS=1,2
	DO IUPDN=1,2
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =3-IUPDN
	ENDIF
	DO K=-L,L
	IDIM1=K+L+1+(2*L+1)*(ISPIN1-1)
	DO M=-L,L
	IDIM=M+L+1+(2*L+1)*(ISPIN-1)
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+K+1 !!! (l,k m)
	IW=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+K)+L+M+1 !!! (l,m k)
      OCS(IU,IUPDN,IORBS)=DMAT(IDIM1,IDIM,0)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C  STORE MATRIX IN A GIVEN REPRESENTATION     
      CALL HUB_WRITEREP(OCS,(L+1)*(2*L+1)*(2*L+3)/3,2,2,
     &                  NWSP,NWOR,L,ICUB,IMRE,IUAIN)
10405 FORMAT(1X,'cState=',A10)
C DIAGONALIZE DENSITY MATRIX
	NDIM=(2*L+1)*2
	ALLOCATE(HMAT(NDIM,NDIM))
	ALLOCATE(OMAT(NDIM,NDIM))
	ALLOCATE(EIGV(NDIM))
	DO ISPIN1=1,2
	DO K=-L,L
	IDIM1=K+L+1+(2*L+1)*(ISPIN1-1)
	DO ISPIN=1,2
	DO M=-L,L
	IDIM=M+L+1+(2*L+1)*(ISPIN-1)
	HMAT(IDIM1,IDIM)=DMAT(IDIM1,IDIM,0)
	IF(IDIM1.EQ.IDIM)
     &OMAT(IDIM1,IDIM)=(1.D0,0.D0)
	IF(IDIM1.NE.IDIM)
     &OMAT(IDIM1,IDIM)=(0.D0,0.D0)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C ENFORCE HEMITIANNESS
	DO IDIM1=1,NDIM
	DO IDIM =1,IDIM1
	CMAT=0.5D0*(HMAT(IDIM1,IDIM)+DCONJG(HMAT(IDIM,IDIM1)))
	HMAT(IDIM1,IDIM)=CMAT
	HMAT(IDIM,IDIM1)=DCONJG(CMAT)
	CMAT=0.5D0*(OMAT(IDIM1,IDIM)+DCONJG(OMAT(IDIM,IDIM1)))
	OMAT(IDIM1,IDIM)=CMAT
	OMAT(IDIM,IDIM1)=DCONJG(CMAT)
	ENDDO
	ENDDO
      CALL LIB_EIGEN1C(NDIM,HMAT,OMAT,EIGV,2,2,1,IERR,1,1.D-07)
	IF(IERR.EQ.1)
     &CALL FULLSTOP('<RAT_SETGRF> Error in diagonalization')
C SAVE MATRIX WHICH DIAGONALIZES DENSITY MATRIX
	WRITE(IUAIN,10500)
10500 FORMAT(1X,'<SECTION=CSYS>',14X,'! TRANSFORMATION MATRIX:')
	WRITE(IUAIN,10505)CSTA
C STORE ARRAYS
	DO IORBS=1,2
	DO IUPDN=1,2
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =3-IUPDN
	ENDIF
	DO K=-L,L
	IDIM1=K+L+1+(2*L+1)*(ISPIN1-1)
	DO M=-L,L
	IDIM=M+L+1+(2*L+1)*(ISPIN-1)
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+K+1 !!! (l,k m)
	IW=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+K)+L+M+1 !!! (l,m k)
      OCS(IU,IUPDN,IORBS)=OMAT(IDIM1,IDIM)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C  STORE MATRIX IN A GIVEN REPRESENTATION     
      CALL HUB_WRITEREP(OCS,(L+1)*(2*L+1)*(2*L+3)/3,2,2,
     &                  NWSP,NWOR,L,ICUB,IMRE,IUAIN)
      DEALLOCATE(HMAT,OMAT,EIGV)
10505 FORMAT(1X,'cState=',A10)
C SAVE LOCAL IMPURITY LEVELS
	WRITE(IUAIN,10600)
10600 FORMAT(1X,'<SECTION=ELOC>',14X,'! LOCAL IMPURITY LEVELS:')
	WRITE(IUAIN,10605)CSTA
C STORE ARRAYS
	DO IORBS=1,2
	DO IUPDN=1,2
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =3-IUPDN
	ENDIF
	DO K=-L,L
	IDIM1=K+L+1+(2*L+1)*(ISPIN1-1)
	DO M=-L,L
	IDIM=M+L+1+(2*L+1)*(ISPIN-1)
	IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+K+1 !!! (l,k m)
	IW=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+K)+L+M+1 !!! (l,m k)
      OCS(IU,IUPDN,IORBS)=ELEV(IDIM1,IDIM)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C  STORE MATRIX IN A GIVEN REPRESENTATION     
      CALL HUB_WRITEREP(OCS,(L+1)*(2*L+1)*(2*L+3)/3,2,2,
     &                  NWSP,NWOR,L,ICUB,IMRE,IUAIN)
10605 FORMAT(1X,'cState=',A10)
C ********************
	CLOSE(IUAIN)
C MEMORY DEALLOCATIONS
	DEALLOCATE(OCP,OCS)
	END
