      MODULE COM_RATOUT
*************************************************************
* Containes pointers to output information.                 *
*************************************************************
      INTEGER, SAVE :: ICRAT
      INTEGER, SAVE :: ICRSC
      INTEGER, SAVE :: ICADS
      INTEGER, SAVE :: ICSHL
      INTEGER, SAVE :: ICCLS
      INTEGER, SAVE :: ICGRF
      CHARACTER*130, SAVE :: RATFILE
      CHARACTER*130, SAVE :: RSCFILE
      CHARACTER*130, SAVE :: GRFFILE
      CHARACTER*130, SAVE :: ADSFILE
      CHARACTER*130, SAVE :: SHLFILE
      CHARACTER*130, SAVE :: CLSFILE
      END MODULE COM_RATOUT



	MODULE COM_RATEXT
*************************************************************
* Contains default extensions
*************************************************************
	CHARACTER*60, SAVE :: EXTNRAT
	CHARACTER*60, SAVE :: EXTNRSC
	CHARACTER*60, SAVE :: EXTNGRF
	CHARACTER*60, SAVE :: EXTNADS
	CHARACTER*60, SAVE :: EXTNSHL
	CHARACTER*60, SAVE :: EXTNCLS
	END MODULE COM_RATEXT


	MODULE COM_RATCHN
*************************************************************
* Contains channels
*************************************************************
C ATOMIC SHELLS
	INTEGER, SAVE :: IUSHC  !   Atomic shell data                  Temporary
	INTEGER, SAVE :: IUSHL  !   Atomic shell data                  Temporary
	INTEGER, SAVE :: IUAGF  !   Atomic matrix elements             Temporary
C CLUSTERS
	INTEGER, SAVE :: IUCL1  !   Cluster data                       Temporary
	INTEGER, SAVE :: IUCL2  !   Cluster data                       Temporary
	INTEGER, SAVE :: IUCL3  !   Cluster data                       Temporary
	INTEGER, SAVE :: IUCL4  !   Cluster data                       Temporary
	INTEGER, SAVE :: IUCL5  !   Cluster data                       Temporary
	END MODULE COM_RATCHN



      MODULE COM_RATPAR
***************************************************************
*  General control keys for the program.                      *
***************************************************************
      INTEGER, SAVE :: MODR       ! running mode
      INTEGER, SAVE :: LCRT       ! controls relativism
      INTEGER, SAVE :: KORB       ! Orbital Moments key
      REAL*8, SAVE :: EPSDEG      ! degeneracy threshold
      REAL*8, SAVE :: EPSHUB      ! statistical weights threshold
      REAL*8, SAVE :: EPSMAT      ! matrix elements threshold
      REAL*8, SAVE :: EPSZIP      ! storage threshold
      END MODULE COM_RATPAR


      MODULE COM_RATCLS
***************************************************************
*  Cluster settings                                           *
***************************************************************
      INTEGER, SAVE :: NFOCTOT    ! Total Hilbert space explored
      INTEGER, SAVE :: NEXTTOT    ! Extended Hilbert space explored
      INTEGER, SAVE :: NMOMHAM    ! # of moments for Hamiltonian
      INTEGER, SAVE :: NLANCOS    ! # of exact eigenstates to reslove with Lancos
      INTEGER, SAVE :: NEXCPAR    ! # particles to excite in the bath
      INTEGER, SAVE :: KHYBLEV    ! Read Hybridization Levels from rat/hop files
	REAL*8, SAVE :: WCUTBAS     ! Cutoff frequency for the Hilbert space
	REAL*8, SAVE :: WEXTBAS     ! Max.   frequency for the Hilbert space
	REAL*8, SAVE :: EXCTEMP     ! Fictitious temperatue for the bath states
      INTEGER, SAVE, ALLOCATABLE :: LOCCCLS(:)  ! cluster occupancies
      INTEGER, SAVE, ALLOCATABLE :: LOCCBAT(:)  ! bath occupancies
      INTEGER, SAVE, ALLOCATABLE :: NFOCCLS(:)  ! Hilbert space for each filling
      INTEGER, SAVE, ALLOCATABLE :: NEXTCLS(:)  ! Extended Hilbert space for each filling
      INTEGER, SAVE, ALLOCATABLE :: NBLKCLS(:)  ! # of subblocks in each filling
      INTEGER, SAVE, ALLOCATABLE :: NFOCBLK(:,:)! Dimension of each block        
      INTEGER, SAVE, ALLOCATABLE :: NFOCIMP(:)  ! Total Dimension of Hilbert Space
      INTEGER, SAVE, ALLOCATABLE :: NCUTIMP(:)  ! Cutoff Dimension of Hilbert Space
      INTEGER, SAVE, ALLOCATABLE :: NFOCBAT(:)  ! Total Dimension of Hilbert Space
      INTEGER, SAVE, ALLOCATABLE :: NCUTBAT(:)  ! Cutoff Dimension of Hilbert Space
      REAL*8, SAVE, ALLOCATABLE :: SPECCLS(:)   ! Cluster spectrum
      REAL*8, SAVE, ALLOCATABLE :: XHUBCLS(:)   ! Cluster probailities
      REAL*8, SAVE, ALLOCATABLE :: SEXTCLS(:)   ! Extended Cluster spectrum
      REAL*8, SAVE, ALLOCATABLE :: XEXTCLS(:)   ! Extended Cluster probailities
      END MODULE COM_RATCLS


      MODULE COM_RATHYB
***************************************************************
*  Cluster settings                                           *
***************************************************************
      INTEGER, SAVE :: NBST       ! # of hybridization states
      INTEGER, SAVE :: NHYB       ! # of hybridization levels
      INTEGER, SAVE, ALLOCATABLE :: NDST(:) ! degeneracy for each state
	REAL*8, SAVE :: BMAG        ! Magnetic field for bath electrons
      COMPLEX*16, SAVE, ALLOCATABLE :: EHYB(:)   ! levels
      COMPLEX*16, SAVE, ALLOCATABLE :: VHYB(:,:) ! hybridizations with impurity
      CHARACTER*10, SAVE, ALLOCATABLE :: TBST(:) ! levels notations
      END MODULE COM_RATHYB



      MODULE COM_LSHELL
***************************************************************
*  Shell settings                                             *
***************************************************************
      INTEGER, SAVE :: NORB                ! main quantum number
      INTEGER, SAVE :: LORB                ! orbital quantum number
      INTEGER, SAVE :: KSYS                ! coordinate system key
      INTEGER, SAVE :: NFILSHL             ! Mean Fillings                
      INTEGER, SAVE :: NFLUSHL             ! Fluctuations around mean filling
      INTEGER, SAVE :: NRUNSHL             ! # of runs for impurity 
      INTEGER, SAVE :: KSTSHL(14,14)       ! particpating states pointer
	CHARACTER*10 CSTA                    ! correlated state pointer
      REAL*8, SAVE :: HMAG                 ! magnetic spin field
      REAL*8, SAVE :: HORB                 ! magnetic orbital field
      REAL*8, SAVE :: ALSC                 ! spin orbit coupling
	REAL*8, SAVE :: DAMP                 ! damping for Green function
      REAL*8, SAVE :: FSLA(0:3)            ! Slater integrals
      INTEGER, SAVE, ALLOCATABLE :: LOCCIMP(:)        ! occupancy fluctuations
      INTEGER, SAVE, ALLOCATABLE :: ISTATE(:,:)       ! Fock Space
      REAL*8, SAVE, ALLOCATABLE :: SPECIMP(:)         ! Atomic spectrum
      REAL*8, SAVE, ALLOCATABLE :: XHUBIMP(:)         ! Atomic probailities
      COMPLEX*16, SAVE, ALLOCATABLE :: ELEV(:,:)      ! Matrix of local levels
      CHARACTER*5, SAVE, ALLOCATABLE :: TLSJIMP(:,:)  ! LSJ for each level
      END MODULE COM_LSHELL



      MODULE COM_IMPGRF
***************************************************************
*  Shell settings                                             *
***************************************************************
	INTEGER, SAVE :: NWSP       ! # of Spins to store
	INTEGER, SAVE :: NWOR       ! # of Orbits to store
	INTEGER, SAVE :: IMRE       ! Real/Complex output
	INTEGER, SAVE :: ICUB       ! Spherical/Cubic harmonics storage
	INTEGER, SAVE :: NRAT       ! # of poles for atomic Green function
	INTEGER, SAVE :: NPOL       ! # of poles for self-energy
	INTEGER, SAVE :: NPLD       ! # of poles for hybridization
	INTEGER, SAVE :: NMOM       ! # of moments for atomic Green Function
	INTEGER, SAVE :: KRAT       ! force rational representation for Sigma(w) 
	INTEGER, SAVE :: KINT       ! Green function interpolation method
	INTEGER, SAVE :: KDRT       ! force rational representation for Delta(w) 
	INTEGER, SAVE :: KDIN       ! Hybridization interpolation method
      INTEGER, SAVE :: KFRM       ! Chemical potential search key
      INTEGER, SAVE :: KVRB       ! Verbocity key
	REAL*8, SAVE :: CHEM        ! Chemical potential
	REAL*8, SAVE :: FILL        ! Mean filling
	COMPLEX*16, SAVE, ALLOCATABLE :: GMOM(:,:,:) ! Green function momenta
	COMPLEX*16, SAVE, ALLOCATABLE :: PMAT(:,:,:) ! Pole matrix elements
	COMPLEX*16, SAVE, ALLOCATABLE :: GLOC(:,:,:) ! Green function, Re 
	COMPLEX*16, SAVE, ALLOCATABLE :: SIGW(:,:,:) ! Self-energy
	COMPLEX*16, SAVE, ALLOCATABLE :: BATH(:,:,:) ! Bath Green function
	COMPLEX*16, SAVE, ALLOCATABLE :: DELW(:,:,:) ! Hybridization
	COMPLEX*16, SAVE, ALLOCATABLE :: VRHB(:,:,:) ! V hybridization
	COMPLEX*16, SAVE, ALLOCATABLE :: WRHB(:,:,:) ! W hybridization
	COMPLEX*16, SAVE, ALLOCATABLE :: PRHB(:,:,:) ! Poles hybridization
	COMPLEX*16, SAVE, ALLOCATABLE :: ORHB(:,:,:) ! Overlaps hybridizaton
	COMPLEX*16, SAVE, ALLOCATABLE :: VRAT(:,:,:) ! V
	COMPLEX*16, SAVE, ALLOCATABLE :: WRAT(:,:,:) ! W
	COMPLEX*16, SAVE, ALLOCATABLE :: PRAT(:,:,:) ! Poles
	COMPLEX*16, SAVE, ALLOCATABLE :: ORAT(:,:,:) ! Overlaps
	COMPLEX*16, SAVE, ALLOCATABLE :: SRAT(:,:)   ! Sigma(oo) (rational fit)
	COMPLEX*16, SAVE, ALLOCATABLE :: SIGI(:,:)   ! Sigma(oo) (true value)
	COMPLEX*16, SAVE, ALLOCATABLE :: SIG0(:,:)   ! Sigma(0)
	COMPLEX*16, SAVE, ALLOCATABLE :: BMAS(:,:)   ! Bmas
	COMPLEX*16, SAVE, ALLOCATABLE :: DMAT(:,:,:) ! Density matrix
	COMPLEX*16, SAVE, ALLOCATABLE :: DTRM(:,:)   ! Direct Transformation matrix
	COMPLEX*16, SAVE, ALLOCATABLE :: RTRM(:,:)   ! Reverse Transformation matrix
      END MODULE COM_IMPGRF


	MODULE COM_RATSCF
***************************************************************
*  Self-consisntency settings
***************************************************************
      INTEGER, SAVE :: NITER
      LOGICAL, SAVE :: MIXBRD
      REAL*8, SAVE :: EPSEN
      REAL*8, SAVE :: EPSRAT
      REAL*8, SAVE :: ADMIXL
      REAL*8, SAVE :: ADMIX1
      REAL*8, SAVE :: ZRAT
      REAL*8, SAVE :: ERAT
      REAL*8, SAVE :: SRAT
      REAL*8, SAVE :: GRAT
      REAL*8, SAVE, ALLOCATABLE :: RATRHO(:)
      REAL*8, SAVE, ALLOCATABLE :: RATPOT(:)
	CHARACTER*10, SAVE :: TRAT
      END MODULE COM_RATSCF



	MODULE COM_RATMESH
***************************************************************
*  Radial aotmic grid                                         *
***************************************************************
      INTEGER, SAVE :: NRAT
      INTEGER, SAVE :: NLIB
      REAL*8, SAVE :: HRAT
      REAL*8, SAVE :: HLIB
      REAL*8, SAVE, ALLOCATABLE :: RRAT(:)
      REAL*8, SAVE, ALLOCATABLE :: DRAT(:)
      REAL*8, SAVE, ALLOCATABLE :: WRAT(:)
      REAL*8, SAVE, ALLOCATABLE :: PRAT(:,:)
      REAL*8, SAVE, ALLOCATABLE :: RLIB(:)
      REAL*8, SAVE, ALLOCATABLE :: DLIB(:)
      END MODULE COM_RATMESH



      MODULE COM_RATLEV
*************************************************************
* Containes core electrons data.                            *
*************************************************************
      INTEGER, SAVE :: NLEVT   ! total # of levels
      INTEGER, SAVE, ALLOCATABLE :: LNUM(:)  ! packed n,l,j
      INTEGER, SAVE, ALLOCATABLE :: LEVC(:)  ! shows core/valence level
      INTEGER, SAVE, ALLOCATABLE :: LEVN(:)  ! main quantum number 
      INTEGER, SAVE, ALLOCATABLE :: LEVL(:)  ! orbital quantum number
      INTEGER, SAVE, ALLOCATABLE :: LEVJ(:)  ! total moment (times 2)
      REAL*8,  SAVE, ALLOCATABLE :: ELEV(:)  ! level energies (Ry)
      REAL*8,  SAVE, ALLOCATABLE :: ZLEV(:)  ! level occupancies
      REAL*8,  SAVE, ALLOCATABLE :: GLEV(:)  ! Exchange parameters
      REAL*8,  SAVE, ALLOCATABLE :: SLEV(:,:)! Slater integrals
      END MODULE COM_RATLEV
