        MODULE DIM_LMTART
*************************************************************
*  Dynamical memory allocation data for the LMTART code.    *
*************************************************************
C  MAIN PARAMETERS OF THE ARRAYS
	INTEGER, SAVE :: NATOMMEM   !!! current # of atoms
	INTEGER, SAVE :: NSORTMEM   !!! current # of sorts
	INTEGER, SAVE :: NSPINMEM   !!! current # of spins
	INTEGER, SAVE :: NORBSMEM   !!! current # of LS's
	INTEGER, SAVE :: LMAXVMEM   !!! current # of IlsV
	INTEGER, SAVE :: LMAXBMEM   !!! current # of Ilsb
	INTEGER, SAVE :: LMAXTMEM   !!! current # of IlsT 
	INTEGER, SAVE :: LMAXCMEM   !!! current # of max(ilsB,ilsT,ilsV)
	INTEGER, SAVE :: LIMDTMEM   !!! current # of connections t'-t
	INTEGER, SAVE :: NKAPMEM    !!! current # of kappas
	INTEGER, SAVE :: NPANMEM    !!! current # of panels
	INTEGER, SAVE :: NDIMMEM    !!! current dimension
	INTEGER, SAVE :: NGGAMEM    !!! current GGA or LDA
C  PLANE WAVE DATA PARAMETERS 
	INTEGER, SAVE :: NPLWMEM    !!! current # of plane waves
	INTEGER, SAVE :: NFFTMEM    !!! current # of FFT points
	INTEGER, SAVE :: NBASMEM    !!! current # of plane waves
	INTEGER, SAVE :: MBASMEM    !!! current # of plane waves
C  OTHER PARAMETERS
	INTEGER, SAVE :: NPNTMEM    !!! current # of k-points
	INTEGER, SAVE :: NRADMEM    !!! current # of radial points
	INTEGER, SAVE :: NRATMEM    !!! current # of radial points for atoms
	INTEGER, SAVE :: NLIBMEM    !!! current # of Liberman points
	INTEGER, SAVE :: NSYMMEM    !!! current # of sph-harmonics
	INTEGER, SAVE :: NOPRMEM    !!! current # of group operations
	INTEGER, SAVE :: NENVMEM    !!! current # of nearest neighbors
	INTEGER, SAVE :: NSHLMEM    !!! current # of n.n shells
	INTEGER, SAVE :: NLENMEM    !!! current size of Broyden array
	INTEGER, SAVE :: NTERMEM    !!! current # of Broyden iterations
	INTEGER, SAVE :: NPNWMEM    !!! current # of k-points for weights
	INTEGER, SAVE :: NOMGMEM    !!! current # of frequencies
	INTEGER, SAVE :: NCHIMEM    !!! TB-susceptibility dimension
	INTEGER, SAVE :: NMSCMEM    !!! # of Matsubara frequencies, log grid
	INTEGER, SAVE :: NCNFMEM    !!! # of configurations in Impurity site
	INTEGER, SAVE :: NPOLMEM    !!! # of poles in rational interpolation for self-energy
	INTEGER, SAVE :: NPLDMEM    !!! # of poles in rational interpolation for hybridization
C  LM-COMBINATIONS
	INTEGER, SAVE :: LIMVMEM    !!! (LmaxV+1)^2
	INTEGER, SAVE :: LIMBMEM    !!! (LmaxB+1)^2
	INTEGER, SAVE :: LIMTMEM    !!! (LmaxT+1)^2
	INTEGER, SAVE :: LIMCMEM    !!! (LmaxC+1)^2
	INTEGER, SAVE :: LIMV1MEM   !!! (LmaxV+2)^2
	INTEGER, SAVE :: LIMB1MEM   !!! (LmaxB+2)^2
	INTEGER, SAVE :: LIMT1MEM   !!! (LmaxT+2)^2
	INTEGER, SAVE :: LIMC1MEM   !!! (LmaxC+2)^2
	INTEGER, SAVE :: LIMV2MEM   !!! (LmaxV+1)*(2*LmaxV+1)*(2*LmaxV+3)/3)
	INTEGER, SAVE :: LIMB2MEM   !!! (LmaxB+1)*(2*LmaxB+1)*(2*LmaxB+3)/3)
	INTEGER, SAVE :: LIMT2MEM   !!! (LmaxT+1)*(2*LmaxT+1)*(2*LmaxT+3)/3)
	INTEGER, SAVE :: LIMC2MEM   !!! (LmaxC+1)*(2*LmaxC+1)*(2*LmaxC+3)/3)
	INTEGER, SAVE :: NWIGMEM    !!! (LmaxT+1)*(2*LmaxT+1)*(2*LmaxT+3)/3)
	END MODULE DIM_LMTART
