      MODULE COM_PHNOUT
*************************************************************
* Containes pointers to output information.                 *
*************************************************************
      INTEGER, SAVE :: ICLRT
      INTEGER, SAVE :: ICPHN
      INTEGER, SAVE :: ICEPI
      INTEGER, SAVE :: ICDPV
      INTEGER, SAVE :: ICDSV
      INTEGER, SAVE :: ICPLZ
      INTEGER, SAVE :: ICPLS
      INTEGER, SAVE :: ICWGT
C Phonon files
      CHARACTER*130, SAVE :: LRTFILE
      CHARACTER*130, SAVE :: PHNFILE
      CHARACTER*130, SAVE :: EPIFILE
      CHARACTER*130, SAVE :: WGTFILE(10)
      CHARACTER*130, SAVE, ALLOCATABLE :: DROFILE(:,:)
      CHARACTER*130, SAVE, ALLOCATABLE :: DPSFILE(:,:)
      CHARACTER*130, SAVE, ALLOCATABLE :: DPVFILE(:,:)
      CHARACTER*130, SAVE, ALLOCATABLE :: DSVFILE(:,:)
      CHARACTER*130, SAVE, ALLOCATABLE :: PLZFILE(:)
      CHARACTER*130, SAVE, ALLOCATABLE :: PLSFILE(:)
      END MODULE COM_PHNOUT


	MODULE COM_PHNEXT
*************************************************************
* Contains default extensions
*************************************************************
	CHARACTER*60, SAVE :: EXTNLRT
      CHARACTER*60, SAVE :: EXTNPHN
      CHARACTER*60, SAVE :: EXTNEPI
      CHARACTER*60, SAVE :: EXTNWGT
      CHARACTER*60, SAVE :: EXTNDRO
      CHARACTER*60, SAVE :: EXTNDPS
      CHARACTER*60, SAVE :: EXTNDPV
      CHARACTER*60, SAVE :: EXTNDSV
      CHARACTER*60, SAVE :: EXTNPLZ
      CHARACTER*60, SAVE :: EXTNPLS
	END MODULE COM_PHNEXT


	MODULE COM_PHNCHN
*************************************************************
* Contains channels
*************************************************************
      INTEGER, SAVE :: IUPLZ  !   Polarizability PLZFILE             Permanent          
      INTEGER, SAVE :: IUPLS  !   Pseudopolarizability PLSFILE       Permanent          
      INTEGER, SAVE :: IUPLY  !   Polarizabilty                      Temporary          
      INTEGER, SAVE :: IUPSY  !   Pseudopolarizability               Temporary          
      INTEGER, SAVE :: IUSTN  !   Stoner matrix (not ready)          Permanent          
      INTEGER, SAVE :: IUDRO  !   Induced charge density             Temporary          
      INTEGER, SAVE :: IUDPS  !   Induced pseudodensity              Temporary          
      INTEGER, SAVE :: IUDRX  !   Induced charge density DROFILE     Permanent          
      INTEGER, SAVE :: IUDPX  !   Induced charge density             Temporary          
      INTEGER, SAVE :: IUDRY  !   Induced pseudodensity  DPSFILE     Permanent          
      INTEGER, SAVE :: IUDPY  !   Induced pseudodensity              Temporary          
      INTEGER, SAVE :: IUDSV  !   Induced potential DSVFILE      Permanent/Temporary    
      INTEGER, SAVE :: IUDPV  !   Induced pseudopot.DPVFILE      Permanent/Temporary    
      INTEGER, SAVE :: IUTTR  !   Tetrahedron weights                Temporary          
      INTEGER, SAVE :: IUTTW  !   Tetrahedron weights WGTFILE        Permanent          
      INTEGER, SAVE :: IUDMT  !   Change in NMT parameters           Temporary          
      INTEGER, SAVE :: IUDTS  !   Change in TOS matrix               Temporary          
      INTEGER, SAVE :: IUBMT  !   Change in BMT parameters           Temporary          
      INTEGER, SAVE :: IUBOS  !   Change in BOS matrix               Temporary          
      INTEGER, SAVE :: IUDYN  !   Dynamical matrix data              Temporary          
      INTEGER, SAVE :: IUDIN  !   Induced INT parameters             Temporary          
      INTEGER, SAVE :: IUPDD  !   Induced pseudodensity data         Temporary          
      INTEGER, SAVE :: IUDMD  !   Dynamical matrix data              Temporary 
	END MODULE COM_PHNCHN





      MODULE COM_PHNCOM
***************************************************************
*  General control keys for the program.                      *
***************************************************************
      INTEGER, SAVE :: IRMT                             !!! rmta key
      INTEGER, SAVE :: ITERMAX                          !!! max.# iterations
	CHARACTER*10, SAVE :: MOVTASK                     !!! polarizations
      INTEGER, SAVE, ALLOCATABLE :: NITER(:,:)          !!! iterations for each mode
	REAL*8, SAVE, ALLOCATABLE :: EPS(:,:)             !!! accuracy
	COMPLEX*16, SAVE, ALLOCATABLE :: CONVDRO(:,:,:)   !!! convergency
	COMPLEX*16, SAVE, ALLOCATABLE :: CONVDMO(:,:,:)   !!! convergency
	COMPLEX*16, SAVE, ALLOCATABLE :: DELZ(:,:,:)      !!! convergency
	COMPLEX*16, SAVE, ALLOCATABLE :: DELD(:,:,:)      !!! convergency
      END MODULE COM_PHNCOM



      MODULE COM_MIXDRHO
***************************************************************
*  Mixings
***************************************************************
      INTEGER, SAVE, ALLOCATABLE :: KEY(:,:)
	REAL*8, SAVE, ALLOCATABLE :: ADMIX1(:,:)
	REAL*8, SAVE, ALLOCATABLE :: ADMOPT(:,:)
	REAL*8, SAVE, ALLOCATABLE :: ADMIN(:,:)
	REAL*8, SAVE, ALLOCATABLE :: ADMAX(:,:)
      END MODULE COM_MIXDRHO

      MODULE COM_MIXDMAG
***************************************************************
*  Mixings
***************************************************************
      INTEGER, SAVE, ALLOCATABLE :: KSP(:,:)
	REAL*8, SAVE, ALLOCATABLE :: ADMSPN(:,:)
	REAL*8, SAVE, ALLOCATABLE :: ADSPIN(:,:)
	REAL*8, SAVE, ALLOCATABLE :: ASMIN(:,:)
	REAL*8, SAVE, ALLOCATABLE :: ASMAX(:,:)
      END MODULE COM_MIXDMAG

      MODULE COM_MIXDBRD
***************************************************************
*  Mixings
***************************************************************
      INTEGER, SAVE, ALLOCATABLE :: LBROY(:,:)
      INTEGER, SAVE, ALLOCATABLE :: IBROY(:,:)
      INTEGER, SAVE, ALLOCATABLE :: MTER(:,:)
	REAL*8, SAVE, ALLOCATABLE :: ADMIXB(:,:)
	REAL*8, SAVE, ALLOCATABLE :: ADMIXH(:,:)
	REAL*8, SAVE, ALLOCATABLE :: WTER(:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: WMIX(:,:,:,:)
      END MODULE COM_MIXDBRD

      MODULE COM_SYMNUC
***************************************************************
*  Change in potential
***************************************************************
      INTEGER, SAVE :: NUMQ
      INTEGER, SAVE :: KEYQ
	REAL*8, SAVE, ALLOCATABLE :: USUM(:,:,:,:)
      END MODULE COM_SYMNUC


      MODULE COM_OLDMESH
***************************************************************
***************************************************************
      INTEGER, SAVE :: NPLW0
	REAL*8, SAVE :: ORTH0(2:3)
	REAL*8, SAVE :: RBAS0(3,3)
	REAL*8, SAVE :: GBAS0(3,3)
      INTEGER, SAVE, ALLOCATABLE :: NRAD0(:)
	REAL*8, SAVE, ALLOCATABLE :: GPLW0(:,:)
	REAL*8, SAVE, ALLOCATABLE :: ROLD(:,:)
	REAL*8, SAVE, ALLOCATABLE :: AXMAG0(:,:)
      END MODULE COM_OLDMESH



      MODULE COM_DELPOT
***************************************************************
*  Change in potential
***************************************************************
	COMPLEX*16, SAVE, ALLOCATABLE :: DPOT(:,:,:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: GPOT(:,:,:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: DPOTRWF(:,:,:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: DPOTPS(:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: DPOTPS1(:,:,:)
      END MODULE COM_DELPOT

      MODULE COM_DELRHO
***************************************************************
*  Change in density
***************************************************************
	COMPLEX*16, SAVE, ALLOCATABLE :: DRHO(:,:,:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: TRHO(:,:,:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: GRHO(:,:,:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: DRHOPS(:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: TRHOPS(:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: GRHOPS(:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: DRHOPS1(:,:,:)
      END MODULE COM_DELRHO


      MODULE COM_PLZCOM
***************************************************************
*   Polarizbility
***************************************************************
      INTEGER, SAVE :: NPLZ
      INTEGER, SAVE :: LPLZ
      INTEGER, SAVE :: IPLZ
      INTEGER, SAVE :: NPTB
      INTEGER, SAVE, ALLOCATABLE :: INDPTB(:)
      INTEGER, SAVE, ALLOCATABLE :: INPTBR(:,:)
	REAL*8, SAVE, ALLOCATABLE :: QPTB(:,:)
      END MODULE COM_PLZCOM


      MODULE COM_PLZMOM
***************************************************************
*   Polarizbility
***************************************************************
	COMPLEX*16, SAVE, ALLOCATABLE :: PSMAT(:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: SCRMAT(:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: DIEMAT(:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: SCRINT(:,:,:)
      END MODULE COM_PLZMOM


      MODULE COM_EPIMAT
***************************************************************
*   El.ph.interaction
***************************************************************
	COMPLEX*16, SAVE, ALLOCATABLE :: EPIMAT(:,:,:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: VELMAT(:,:,:,:,:)
      END MODULE COM_EPIMAT


      MODULE COM_DYNMAT
***************************************************************
*   Dyn.matrix
***************************************************************
	REAL*8, SAVE, ALLOCATABLE :: OM(:)
	COMPLEX*16, SAVE, ALLOCATABLE :: DYNMAT(:,:,:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: BNDMAT(:,:,:,:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: DPOL(:,:,:)
      END MODULE COM_DYNMAT



      MODULE COM_DINPPAR
***************************************************************
*   Change in inppar
***************************************************************
	COMPLEX*16, SAVE, ALLOCATABLE :: DELENY(:,:,:,:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: DELDNY(:,:,:,:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: DELTNY(:,:,:,:,:,:)
      END MODULE COM_DINPPAR


      MODULE COM_DLMTPAR
***************************************************************
*   Change in inppar
***************************************************************
	COMPLEX*16, SAVE, ALLOCATABLE :: DELAAH(:,:,:,:,:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: DELBBH(:,:,:,:,:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: DELAAJ(:,:,:,:,:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: DELBBJ(:,:,:,:,:,:,:)
      END MODULE COM_DLMTPAR

      MODULE COM_DMTSPAR
***************************************************************
*   Change in inppar
***************************************************************
	COMPLEX*16, SAVE, ALLOCATABLE :: DHMTHH(:,:,:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: DHMTHJ(:,:,:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: DHMTJH(:,:,:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: DHMTJJ(:,:,:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: DOMTHH(:,:,:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: DOMTHJ(:,:,:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: DOMTJH(:,:,:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: DOMTJJ(:,:,:,:,:)
      END MODULE COM_DMTSPAR


      MODULE COM_DPOTPAR
***************************************************************
*   Change in inppar
***************************************************************
	COMPLEX*16, SAVE, ALLOCATABLE :: DELFF(:,:,:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: DELFFP(:,:,:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: DELFPF(:,:,:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: DELFPFP(:,:,:,:,:)
      END MODULE COM_DPOTPAR



      MODULE COM_DOVRPAR
***************************************************************
*   Change in inppar
***************************************************************
	COMPLEX*16, SAVE, ALLOCATABLE :: DELOHH(:,:,:,:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: DELOHJ(:,:,:,:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: DELOJH(:,:,:,:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: DELOJJ(:,:,:,:,:,:)
      END MODULE COM_DOVRPAR




	MODULE COM_DROMULT
**************************************************************
**************************************************************
	COMPLEX*16, SAVE, ALLOCATABLE :: DPSMOM1(:,:,:,:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: DELMAD(:,:,:,:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: DPSMOM(:,:,:,:,:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: DELMRO(:,:,:,:,:,:)
      END MODULE COM_DROMULT


	MODULE COM_ZERODV
**************************************************************
**************************************************************
	COMPLEX*16, SAVE, ALLOCATABLE :: DVMT(:,:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: DVMT0(:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: DVAV(:,:)
      END MODULE COM_ZERODV


	MODULE COM_DELHUB
**************************************************************
**************************************************************
	COMPLEX*16, SAVE, ALLOCATABLE :: DELDHUB(:,:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: DELTHUB(:,:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: DELGHUB(:,:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: DELVHUB(:,:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: DELVRAT(:,:,:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: DELWRAT(:,:,:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: DELPRAT(:,:,:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: DELORAT(:,:,:,:,:)
	END MODULE COM_DELHUB



	MODULE COM_PSIVEC
**************************************************************
**************************************************************
	COMPLEX*16, SAVE, ALLOCATABLE :: APHK(:,:,:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: APJK(:,:,:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: AEHK(:,:,:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: APHQ(:,:,:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: APJQ(:,:,:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: AEHQ(:,:,:,:,:)
	END MODULE COM_PSIVEC


	MODULE COM_DPSIVEC
**************************************************************
**************************************************************
	REAL*8, SAVE :: PNTK(3)
	REAL*8, SAVE :: PNTQ(3)
	COMPLEX*16, SAVE, ALLOCATABLE :: PSIK(:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: PSIQ(:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: PSIK2(:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: PSIQ2(:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: DPSK(:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: DPSQ(:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: SPSK(:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: DPSK2(:,:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: DPSQ2(:,:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: SPSK2(:,:,:,:)
	END MODULE COM_DPSIVEC

	MODULE COM_DELHAM
**************************************************************
**************************************************************
	COMPLEX*16, SAVE, ALLOCATABLE :: DHMAT(:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: DOMAT(:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: DHMATT(:,:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: DOMATT(:,:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: DVINTR(:,:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: DHMATR(:,:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: DOMATR(:,:,:,:)
	END MODULE COM_DELHAM


	MODULE COM_D2HAML
**************************************************************
**************************************************************
	COMPLEX*16, SAVE, ALLOCATABLE :: D2HMATK(:,:,:,:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: D2OMATK(:,:,:,:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: D2HMATQ(:,:,:,:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: D2OMATQ(:,:,:,:,:,:)
	END MODULE COM_D2HAML

	MODULE COM_DSTRCON
**************************************************************
**************************************************************
	COMPLEX*16, SAVE, ALLOCATABLE :: STRK(:,:,:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: STDK(:,:,:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: STRQ(:,:,:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: STDQ(:,:,:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: DSKL(:,:,:,:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: DSQL(:,:,:,:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: DDKL(:,:,:,:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: DDQL(:,:,:,:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: DSKL2(:,:,:,:,:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: DSQL2(:,:,:,:,:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: DDKL2(:,:,:,:,:,:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: DDQL2(:,:,:,:,:,:,:)
	END MODULE COM_DSTRCON


	MODULE COM_INPDCH
**************************************************************
**************************************************************
      COMPLEX*16, SAVE, ALLOCATABLE :: DCHINP(:,:,:,:,:)
      COMPLEX*16, SAVE, ALLOCATABLE :: DCHOUT(:,:,:,:,:)
      COMPLEX*16, SAVE, ALLOCATABLE :: DPSINP(:,:,:,:)
      COMPLEX*16, SAVE, ALLOCATABLE :: DPSOUT(:,:,:,:)
	END MODULE COM_INPDCH
