	SUBROUTINE ODF_LMTODF
************************************************************
*   The calculation of Optics within DMFT                  *
************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                        !!! from setup
      USE COM_CONTROL ,ONLY: LIFT,LMTO,IDMF                 !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS     !!! from readini
      USE COM_SPHERE  ,ONLY: ZNUC,ZCOR,ZSEM,ZVAL            !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP                      !!! from readini
      USE COM_KMESH   ,ONLY: NPNT,PNT                       !!! from tetra
      USE COM_WMESH   ,ONLY: NPNW,PNW                       !!! from tetra
	USE COM_FREQU   ,ONLY: NOMGOPT,OMGOPT,NENROPT         !!! from getopt
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC        !!! from readini
	USE COM_FERMI   ,ONLY: EF                             !!! from ttrints
	USE COM_LMTOUT  ,ONLY: ICCON,ICODF                    !!! from readini
      USE COM_CHANNELS,ONLY: IUCON,IUHAM,IUOPT,IUNMT        !!! from channels
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT,IUI                !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16 ZOMG,ZENR,ZENP,ZENM
      DATA PI/3.141592653589793D0/
	IF(ICODF.EQ.0)RETURN
	IF(IDMF.NE.5)RETURN
C Compute radial matrix elements
	CALL BND_POTPAR(1)            !!! different potential partameters
	CALL BND_LMTPAR(1)            !!! some combinations of parameters
	CALL BND_OVRPAR(1)            !!! potential parameters for overlapping
	CALL OPT_OPTPAR(1)            !!! optical matrix elements
	CALL ODF_ODFPAR(1)            !!! optical conductivity
C Memory allocations
	CALL ODF_ALLOCATE('A')
C LOOPING OVER OPTICAL FREQUENCIES
	DO 2000 IOMG=0,NOMGOPT        !!! over optical frequencies
	ZOMG=DCMPLX(OMGOPT(IOMG)+1.D-09,0.D0)
	HOMG=(OMGOPT(NOMGOPT)-OMGOPT(0))/DBLE(NOMGOPT)
	HENR=HOMG/DBLE(NENROPT)
	NENROMG=NINT(OMGOPT(IOMG)/HENR)
	IF(NENROMG.LE.0)NENROMG=1
	HENR=OMGOPT(IOMG)/DBLE(NENROMG)
C	HENR=OMGOPT(IOMG)
C	NENROMG=1
	DO 1000 IENR=0,NENROMG-1      !!! over internal energy intervals
	ZENR=DCMPLX(HENR*DBLE(IENR)-OMGOPT(IOMG)/2.D0,0.D0)
	ZENM=DCMPLX(HENR*(DBLE(IENR)+0.5D0)-OMGOPT(IOMG)/2.D0,0.D0)
     &    -ZOMG/2.D0
	CALL DMF_SGMDAT(ZENM)         !!! Set self-energy
	CALL DMF_SGMPAR(1)
C COMPUTE POLES OF THE GREENS FUNCTION ON COARSE MESH
	DO IPNT=1,NPNT(1)             !!! over k-points
      CALL BND_STRSUM(IPNT,1,0)     !!! calculate lattice sums
      CALL BND_STRGNT(IPNT,1,0,1)   !!! restore bare structure matrices
      CALL HOP_STRALP(IPNT,1,0)     !!! screen structure constants
      CALL HOP_SCRSTR(IPNT,1,0)     !!! restore screened structure constants
	CALL DMF_LMTMAT(IPNT,0,0)     !!! Build H+Self-energy
	CALL ODF_ODFBND(IPNT,ZENM,0,1)!!! solve eigenvalue problem
      ENDDO                         !!! over k-points
	CLOSE(UNIT=IUNMT,STATUS='DELETE')
	IF(ICCON.EQ.0)CLOSE(UNIT=IUCON,STATUS='DELETE')
	IF(ICCON.NE.0)CLOSE(UNIT=IUCON,STATUS='KEEP')
	ZENP=DCMPLX(HENR*(DBLE(IENR)+0.5D0)-OMGOPT(IOMG)/2.D0,0.D0)
     &    +ZOMG/2.D0
	CALL DMF_SGMDAT(ZENP)         !!! Set self-energy
	CALL DMF_SGMPAR(1)
C COMPUTE POLES OF THE GREENS FUNCTION ON COARSE MESH
	DO IPNT=1,NPNT(1)             !!! over k-points
      CALL BND_STRSUM(IPNT,1,0)     !!! calculate lattice sums
      CALL BND_STRGNT(IPNT,1,0,1)   !!! restore bare structure matrices
      CALL HOP_STRALP(IPNT,1,0)     !!! screen structure constants
      CALL HOP_SCRSTR(IPNT,1,0)     !!! restore screened structure constants
	CALL DMF_LMTMAT(IPNT,0,0)     !!! Build H+Self-energy
	CALL ODF_ODFBND(IPNT,ZENP,0,2)!!! solve eigenvalue problem
      ENDDO                         !!! over k-points
	CLOSE(UNIT=IUNMT,STATUS='DELETE')
	IF(ICCON.EQ.0)CLOSE(UNIT=IUCON,STATUS='DELETE')
	IF(ICCON.NE.0)CLOSE(UNIT=IUCON,STATUS='KEEP')
C COMPUTE SIGMA
	DO IPNT=1,NPNT(1)             !!! over k-points
C Structure constants
      CALL BND_STRSUM(IPNT,1,0)     !!! calculate lattice sums
      CALL BND_STRGNT(IPNT,1,0,1)   !!! restore bare structure matrices
      CALL HOP_STRALP(IPNT,1,0)     !!! screen structure constants
      CALL HOP_SCRSTR(IPNT,1,0)     !!! restore screened structure constants
C Optical matrix elements
	CALL OPT_OPTMAT(IPNT)         !!! compute current matrix element
	CALL OPT_OPTHAN(IPNT)         !!! add interstitial region
	CALL ODF_ODFPSI(IPNT)         !!! goto band representation
C Add contribution to optical conductivity
	CALL ODF_ODFTTR(IPNT,ZOMG)    !!! compute weight
	CALL ODF_ODFINT(IPNT,IOMG,ZOMG,ZENR,HENR)
      ENDDO                         !!! over k-points
	IF(ICCON.EQ.0)CLOSE(UNIT=IUCON,STATUS='DELETE')
	IF(ICCON.NE.0)CLOSE(UNIT=IUCON,STATUS='KEEP')
 1000 CONTINUE                      !!! over internal energy intervals
	CALL ODF_SYMODF(IOMG)         !!! symmetrize optical conductivity
 2000 CONTINUE                      !!! over optical frequencies
	CALL ODF_SETODF               !!! save optical conductivity
	CLOSE(UNIT=IUOPT,STATUS='DELETE')
	CLOSE(UNIT=IUHAM,STATUS='DELETE')
C Memory deallocations
	CALL ODF_ALLOCATE('D')
	END
