	SUBROUTINE ODF_ODFBND(IPNT,ZOMG,IENW,IMP)
*********************************************************
*  Subroutine prepares hamiltonian matrix plus          *
*  self-energy matrix, computes complex eigenvalues and *
*  eigenvectors and stores them.                        *
*********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                               !!! from setup
      USE COM_CONTROL ,ONLY: LIFT,LMTO,IDMF                        !!! from readini
      USE COM_LATTICE ,ONLY: RBAS,GBAS,TAU                         !!! from readstr
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS,ILSB       !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP                        !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN                           !!! from readini
      USE COM_ENVSITE ,ONLY: NENV,TENV,ISENV                       !!! from envmesh
      USE COM_LMTMAT  ,ONLY: HMAT,OMAT                             !!! from lmtmat
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC               !!! from readini
	USE COM_LMTVEC  ,ONLY: APHR,APSR,APHL,APSL                   !!! from odfbnd
      USE COM_HUBDAT  ,ONLY: MCRL,LCRL,NCLM                        !!! from readhub
      USE COM_GRFDAT  ,ONLY: EPOL,EPOW                             !!! from grfbnd
      USE COM_INPTTR  ,ONLY: NDIV,NDIC,SH                          !!! from readini
	USE COM_INDORB  ,ONLY: INDDMF                                !!! from lmtpar
      USE COM_KMESH   ,ONLY: NPNT,PNT                              !!! from tetra
      USE COM_WMESH   ,ONLY: NPNW,PNW                              !!! from tetra
	USE COM_LMTOUT  ,ONLY: ICODF                                 !!! from readini
      USE COM_CHANNELS,ONLY: IUCEW                                 !!! from channels
      USE COM_MASHDEP ,ONLY: LENCMP                                !!! from setup
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                       !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16, ALLOCATABLE :: CE(:)
	COMPLEX*16 ZOMG
      LOGICAL LOG
      DATA PI/3.141592653589793D0/
      CALL ABORTNOW()
C MEMORY ALLOCATIONS
      ALLOCATE(CE(NBNDT(1)*NSPINMEM))
C GENERALIZED EIGENVALUE PROBLEM
	IF(IENW.EQ.1)IVEC=0 !!! eigenvectors not needed
	IF(IENW.EQ.0)IVEC=1 !!! eigenvectors required
      CALL LIB_CMPEIG1A(NBNDT(1)*NSPIN,HMAT,OMAT,CE,NSPIN,
     &                  NORBS,IVEC,IERR,0,1.D-05)
C Eigenvalues for H+Sigma(iWn)-Sigma0
      DO IBNDS=1,NSPIN
      DO IBNDT=1,NBNDT(1)
      IBAND=IBNDS+NSPIN*(IBNDT-1)
      IF(IENW.EQ.0)EPOL(IBAND,IPNT,IMP)=CE(IBAND)
      IF(IENW.EQ.1)EPOW(IBAND,IPNT,IMP)=CE(IBAND)
      IF(NPNT(1).EQ.NPNW(1))
     &EPOW(IBAND,IPNT,IMP)=EPOL(IBAND,IPNT,IMP)
      ENDDO
      ENDDO
C WAVE FUNCTIONS EXPANSION COEFFICIENTS APH AND APJ 
	DO 400 IORBS=1,NORBS        !!! over spinor components
	DO 300 IBNDS=1,NSPIN        !!! over spin subbands
	IF(NORBS.EQ.1)ISPIN=IBNDS
	IF(NORBS.EQ.2)ISPIN=IORBS
	DO 200 IBNDT=1,NBNDT(1)     !!! over all bands
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	DO 100 IKAP=1,NKAP(1)       !!! over energies
C SET APH
	DO IATOM=1,NATOM            !!! over iatom
	ISORT=IS(IATOM)
      DO L=0,ILSB(ISORT)          !!! over l
      DO M=-L,L                   !!! over m
      LM=L*(L+1)+M+1
	IDIM=INDDMF(LM,IATOM,IKAP,ISPIN)
	IF(IMP.EQ.1)THEN
	APHR(LM,IATOM,IKAP,ISPIN,IBAND)=(0.D0,0.D0)
	APHL(LM,IATOM,IKAP,ISPIN,IBAND)=(0.D0,0.D0)
      IF(.NOT.LTPAN(L,IATOM,IKAP,1))CYCLE
	APHR(LM,IATOM,IKAP,ISPIN,IBAND)=OMAT(IDIM,IBAND)
	APHL(LM,IATOM,IKAP,ISPIN,IBAND)=HMAT(IDIM,IBAND)
	ELSEIF(IMP.EQ.2)THEN
	APSR(LM,IATOM,IKAP,ISPIN,IBAND)=(0.D0,0.D0)
	APSL(LM,IATOM,IKAP,ISPIN,IBAND)=(0.D0,0.D0)
      IF(.NOT.LTPAN(L,IATOM,IKAP,1))CYCLE
	APSR(LM,IATOM,IKAP,ISPIN,IBAND)=OMAT(IDIM,IBAND)
	APSL(LM,IATOM,IKAP,ISPIN,IBAND)=HMAT(IDIM,IBAND)
	ENDIF
      ENDDO                       !!! over m
      ENDDO                       !!! over l
      ENDDO                       !!! over iatom
  100 CONTINUE                    !!! over energies
  200 CONTINUE                    !!! over bands
  300 CONTINUE                    !!! over spin subbands
  400 CONTINUE                 
C MEMORY DEALLOCATIONS
      DEALLOCATE(CE)
	END
