	SUBROUTINE ODF_ODFINT(IPNT,IOMG,ZOMG,ZENR,HENR)
************************************************************
*   The calculation of optical properties                  *
************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
	USE COM_LMTMEM                                        !!! from setup
	USE COM_CONTROL ,ONLY: LIFT,LMTO                      !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,NHSORT !!! from readini
     &                      ,IS,ILST,ILSB
	USE COM_KAPPAR  ,ONLY: NPAN,NKAP                      !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN                    !!! from readini
	USE COM_KMESH   ,ONLY: NPNT,PNT                       !!! from tetra
      USE COM_FREQU   ,ONLY: NOMGOPT,OMGOPT                 !!! from readini
      USE COM_GRFDAT  ,ONLY: EPOL,EPOW                      !!! from odfbnd
	USE COM_FERMI   ,ONLY: EF                             !!! from ttrints
	USE COM_ODFMAT  ,ONLY: SIGMAW,WGTODF,OPLL,OPRL,OPLR,OPRR! from odfpsi
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC        !!! from readini
	USE COM_CHANNELS,ONLY: IUPSI                          !!! from readini
	USE COM_UNIT    ,ONLY: IUN,IUR,IUT,IUI                !!! from setup
	USE COM_LMTOUT  ,ONLY: ICODF                          !!! from readini
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16 DIM,ZOMG,ZENR,WGTLOG(2,2),ALP(2),ALQ(2)
	DATA PI/3.141592653589793D0/,DIM/(0.D0,1.D0)/
C MEMORY ALLOCATIONS
C none
C COMPUTE CONTRIBUTION TO OPTICAL MATRIX (-i*Nabla = momentum operator)
	DO MU=-1,1                                    !!! over polarizations
	DO NU=-1,1                                    !!! over polarizations
	DO IBNDS=1,NSPIN                              !!! over spin subbands
      DO IBNDT=1,NBNDT(1)                           !!! over bands
      IBAND=IBNDS+NSPIN*(IBNDT-1)
	ALP(1)=LOG((ZENR+HENR-ZOMG/2.D0+EF-DCONJG(EPOL(IBAND,IPNT,1)))
     &          /(ZENR     -ZOMG/2.D0+EF-DCONJG(EPOL(IBAND,IPNT,1))))
	ALP(2)=LOG((ZENR+HENR-ZOMG/2.D0+EF-EPOL(IBAND,IPNT,1))
     &          /(ZENR     -ZOMG/2.D0+EF-EPOL(IBAND,IPNT,1)))
      DO IBNDS1=1,NSPIN                             !!! over spin subbands
      DO IBNDT1=1,NBNDT(1)                          !!! over bands
      IBAND1=IBNDS1+NSPIN*(IBNDT1-1)
	ALQ(1)=LOG((ZENR+HENR+ZOMG/2.D0+EF-DCONJG(EPOL(IBAND1,IPNT,2)))
     &          /(ZENR     +ZOMG/2.D0+EF-DCONJG(EPOL(IBAND1,IPNT,2))))
	ALQ(2)=LOG((ZENR+HENR+ZOMG/2.D0+EF-EPOL(IBAND1,IPNT,2))
     &          /(ZENR     +ZOMG/2.D0+EF-EPOL(IBAND1,IPNT,2)))
	WGTLOG(1,1)=ALP(1)-ALQ(1)
	WGTLOG(1,2)=ALP(1)-ALQ(2)
	WGTLOG(2,1)=ALP(2)-ALQ(1)
	WGTLOG(2,2)=ALP(2)-ALQ(2)
C  --
	SIGMAW(IOMG,MU,NU)=SIGMAW(IOMG,MU,NU)+
     &(-1)*(-1)*WGTODF(IBAND,IBAND1,1,1)*WGTLOG(1,1)*
     &(-DIM)*OPRL(IBAND,IBAND1,MU,1)*(-DIM)*OPRL(IBAND1,IBAND,NU,2)
C  ++
	SIGMAW(IOMG,MU,NU)=SIGMAW(IOMG,MU,NU)+
     &(+1)*(+1)*WGTODF(IBAND,IBAND1,2,2)*WGTLOG(2,2)*
     &(-DIM)*OPLR(IBAND,IBAND1,MU,1)*(-DIM)*OPLR(IBAND1,IBAND,NU,2)
C  -+
	SIGMAW(IOMG,MU,NU)=SIGMAW(IOMG,MU,NU)+
     &(-1)*(+1)*WGTODF(IBAND,IBAND1,1,2)*WGTLOG(1,2)*
     &(-DIM)*OPLL(IBAND,IBAND1,MU,1)*(-DIM)*OPRR(IBAND1,IBAND,NU,2)
C  +-
	SIGMAW(IOMG,MU,NU)=SIGMAW(IOMG,MU,NU)+
     &(+1)*(-1)*WGTODF(IBAND,IBAND1,2,1)*WGTLOG(2,1)*
     &(-DIM)*OPRR(IBAND,IBAND1,MU,1)*(-DIM)*OPLL(IBAND1,IBAND,NU,2)
	ENDDO                                         !!! over bands
	ENDDO                                         !!! over spin subbands
	ENDDO                                         !!! over bands
	ENDDO                                         !!! over spin subbands
	ENDDO                                         !!! over polarizations
	ENDDO                                         !!! over polarizations
C MEMORY DEALLOCATIONS
C none
	END
