	SUBROUTINE ODF_ODFPAR(IPAN)
************************************************************
*   The calculation of Optical Conductivity                *
************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                        !!! from setup
      USE COM_CONTROL ,ONLY: LIFT,LMTO,IASA,IDMF            !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS
     &                      ,IS,ILSB,ILST                   !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP                      !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN                    !!! from readini
      USE COM_KMESH   ,ONLY: NPNT,PNT                       !!! from tetra
      USE COM_HUBDAT  ,ONLY: MCRL,LCRL,NCLM                 !!! from readhub
	USE COM_FREQU   ,ONLY: NOMGOPT,OMGOPT                 !!! from getopt
      USE COM_GRFDAT  ,ONLY: EPOL,EPOW                      !!! from grfbnd
      USE COM_DMFDAT  ,ONLY: SIGW                           !!! from grfmat
	USE COM_OPTMAT  ,ONLY: OPTN                           !!! from optmat
      USE COM_INDORB  ,ONLY: INDDMF                         !!! from odfpar
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC,NBNDH  !!! from readini
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT,IUI                !!! from setup
	USE COM_ODFMAT  ,ONLY: SIGMAW,WGTODF,OPLL,OPLR,OPRL,OPRR! from odfpar
      USE COM_LMTOUT  ,ONLY: ICODF,ODFFILE,SCRFILE          !!! from readini
      USE COM_CHANNELS,ONLY: IUCEW                          !!! from channels
      USE COM_MASHDEP ,ONLY: NVAL,LENCMP                    !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	LOGICAL FIRST,EXIST,OPEN
	DATA FIRST/.TRUE./
C MEMORY ALLOCATIONS
	ALLOCATE(INDDMF(LIMBMEM,NATOMMEM,NKAPMEM,NSPINMEM))
	ALLOCATE(EPOL(NBNDT(1)*NSPINMEM,NPNTMEM,2))
	ALLOCATE(EPOW(NBNDT(1)*NSPINMEM,NPNWMEM,2))
	ALLOCATE(SIGMAW(0:NOMGOPT,-1:1,-1:1))
	ALLOCATE(WGTODF(NBNDT(1)*NSPINMEM,NBNDT(1)*NSPINMEM,2,2))
	ALLOCATE(OPTN(NBNDT(1)*NSPINMEM,NBNDT(1)*NSPINMEM,-1:1))
	ALLOCATE(OPLL(NBNDT(1)*NSPINMEM,NBNDT(1)*NSPINMEM,-1:1,2))
	ALLOCATE(OPRL(NBNDT(1)*NSPINMEM,NBNDT(1)*NSPINMEM,-1:1,2))
	ALLOCATE(OPLR(NBNDT(1)*NSPINMEM,NBNDT(1)*NSPINMEM,-1:1,2))
	ALLOCATE(OPRR(NBNDT(1)*NSPINMEM,NBNDT(1)*NSPINMEM,-1:1,2))
      SIZE_EPOL=DBLE(SIZE(EPOL)*LENCMP)/1024.D0**2
      SIZE_EPOW=DBLE(SIZE(EPOW)*LENCMP)/1024.D0**2
      CURMEM=CURMEM+SIZE_EPOL+SIZE_EPOW
C Set complex index
	DO ISPIN=1,NSPIN
	IDIM=(ISPIN-1)*(NBNDT(1)+NBNDH(1))
	DO IKAP=1,NKAP(1)
	DO IATOM=1,NATOM
	DO L=0,ILSB(IS(IATOM))
	IF(.NOT.LTPAN(L,IATOM,IKAP,1))CYCLE
	DO M=-L,L
	LM=L*(L+1)+M+1
	IDIM=IDIM+1
	INDDMF(LM,IATOM,IKAP,ISPIN)=IDIM
	ENDDO 
	ENDDO 
	ENDDO 
	ENDDO 
	ENDDO 
C ZEROISE OPTICAL CONDUCTIVITY
	DO IMU=-1,1
	DO INU=-1,1
	DO IOMG=0,NOMGOPT
	SIGMAW(IOMG,IMU,INU)=(0.D0,0.D0)
	ENDDO
	ENDDO
	ENDDO
	END