	SUBROUTINE ODF_ODFPSI(IPNT)
************************************************************
*   The calculation of optical properties                  *
************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
	USE COM_LMTMEM                                        !!! from setup
	USE COM_CONTROL ,ONLY: LIFT,LMTO                      !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,NHSORT !!! from readini
     &                      ,IS,ILST,ILSB
	USE COM_KAPPAR  ,ONLY: NPAN,NKAP                      !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN                    !!! from readini
	USE COM_KMESH   ,ONLY: NPNT,PNT                       !!! from tetra
      USE COM_FREQU   ,ONLY: NOMGOPT,OMGOPT                 !!! from readini
	USE COM_OPTMAT  ,ONLY: OPTN                           !!! from optmat
	USE COM_ODFMAT  ,ONLY: OPLL,OPLR,OPRL,OPRR            !!! from optmat
	USE COM_LMTVEC  ,ONLY: APHR,APSR,APHL,APSL            !!! from odfbnd
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC        !!! from readini
      USE COM_INDORB  ,ONLY: INDDMF                         !!! from lmtpar
	USE COM_UNIT    ,ONLY: IUN,IUR,IUT,IUI                !!! from setup
	USE COM_LMTOUT  ,ONLY: ICODF                          !!! from readini
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: ALML(:,:,:)
	COMPLEX*16, ALLOCATABLE :: ALMR(:,:,:)
	COMPLEX*16, ALLOCATABLE :: OTLL(:,:,:)
	COMPLEX*16, ALLOCATABLE :: OTLR(:,:,:)
	COMPLEX*16, ALLOCATABLE :: OTRL(:,:,:)
	COMPLEX*16, ALLOCATABLE :: OTRR(:,:,:)
	COMPLEX*16 OINT
	DATA PI/3.141592653589793D0/
      CALL ABORTNOW()
C MEMORY ALLOCATIONS
	ALLOCATE(OTLL(NBNDT(1)*NSPINMEM,NBNDT(1)*NSPINMEM,2))
	ALLOCATE(OTLR(NBNDT(1)*NSPINMEM,NBNDT(1)*NSPINMEM,2))
	ALLOCATE(OTRL(NBNDT(1)*NSPINMEM,NBNDT(1)*NSPINMEM,2))
	ALLOCATE(OTRR(NBNDT(1)*NSPINMEM,NBNDT(1)*NSPINMEM,2))
	ALLOCATE(ALML(NBNDT(1)*NSPINMEM,NBNDT(1)*NSPINMEM,2))
	ALLOCATE(ALMR(NBNDT(1)*NSPINMEM,NBNDT(1)*NSPINMEM,2))
C READ EIGENVECTORS
	DO 500 IBNDS=1,NSPIN        !!! over spin subbands
	DO 400 IBNDT=1,NBNDT(1)     !!! over all bands
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	DO IDIM=1,NBNDT(1)*NSPIN
	ALML(IDIM,IBAND,1)=(0.D0,0.D0)
	ALMR(IDIM,IBAND,1)=(0.D0,0.D0)
	ALML(IDIM,IBAND,2)=(0.D0,0.D0)
	ALMR(IDIM,IBAND,2)=(0.D0,0.D0)
	ENDDO
	DO 300 IORBS=1,NORBS        !!! over spinor components
	IF(NORBS.EQ.1)ISPIN=IBNDS
	IF(NORBS.EQ.2)ISPIN=IORBS
	DO 200 IMP=1,2              !!! over -/+
	DO 100 IKAP=1,NKAP(1)       !!! over energies
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	DO L=0,ILSB(ISORT)
	IF(.NOT.LTPAN(L,IATOM,IKAP,1))CYCLE
	DO M=-L,L
	LM=L*(L+1)+M+1
	IDIM=INDDMF(LM,IATOM,IKAP,ISPIN)
	IF(IMP.EQ.1)THEN
	ALML(IDIM,IBAND,IMP)=APHL(LM,IATOM,IKAP,ISPIN,IBAND)
	ALMR(IDIM,IBAND,IMP)=APHR(LM,IATOM,IKAP,ISPIN,IBAND)
	ELSEIF(IMP.EQ.1)THEN
	ALML(IDIM,IBAND,IMP)=APSL(LM,IATOM,IKAP,ISPIN,IBAND)
	ALMR(IDIM,IBAND,IMP)=APSR(LM,IATOM,IKAP,ISPIN,IBAND)
	ENDIF
	ENDDO
	ENDDO
	ENDDO
  100 CONTINUE                    !!! over energies
  200 CONTINUE                    !!! over -/+
  300 CONTINUE                    !!! over spinor components
  400 CONTINUE                    !!! over bands
  500 CONTINUE                    !!! over spin subbands
C COMPUTE CONTRIBUTION TO OPTICAL MATRIX
	DO 1000 MU=-1,1                               !!! over polarizations
	DO IBNDS=1,NSPIN                              !!! over spin subbands
      DO IBNDT=1,NBNDT(1)                           !!! over bands
      IBAND=IBNDS+NSPIN*(IBNDT-1)
	DO IDIM1=1,NBNDT(1)*NSPIN
	OTLL(IDIM1,IBAND,1)=(0.D0,0.D0)
	OTLL(IDIM1,IBAND,2)=(0.D0,0.D0)
	OTLR(IDIM1,IBAND,1)=(0.D0,0.D0)
	OTLR(IDIM1,IBAND,2)=(0.D0,0.D0)
	OTRL(IDIM1,IBAND,1)=(0.D0,0.D0)
	OTRL(IDIM1,IBAND,2)=(0.D0,0.D0)
	OTRR(IDIM1,IBAND,1)=(0.D0,0.D0)
	OTRR(IDIM1,IBAND,2)=(0.D0,0.D0)
	DO IDIM=1,NBNDT(1)*NSPIN
	OTLL(IDIM1,IBAND,1)=OTLL(IDIM1,IBAND,1)+
     &OPTN(IDIM1,IDIM,MU)*DCONJG(ALML(IDIM,IBAND,2))
	OTLL(IDIM1,IBAND,2)=OTLL(IDIM1,IBAND,2)+
     &OPTN(IDIM1,IDIM,MU)*DCONJG(ALML(IDIM,IBAND,1))
	OTLR(IDIM1,IBAND,1)=OTLR(IDIM1,IBAND,1)+
     &OPTN(IDIM1,IDIM,MU)*ALMR(IDIM,IBAND,2)
	OTLR(IDIM1,IBAND,2)=OTLR(IDIM1,IBAND,2)+
     &OPTN(IDIM1,IDIM,MU)*ALMR(IDIM,IBAND,1)
	OTRL(IDIM1,IBAND,1)=OTRL(IDIM1,IBAND,1)+
     &OPTN(IDIM1,IDIM,MU)*DCONJG(ALML(IDIM,IBAND,2))
	OTRL(IDIM1,IBAND,2)=OTRL(IDIM1,IBAND,2)+
     &OPTN(IDIM1,IDIM,MU)*DCONJG(ALML(IDIM,IBAND,1))
	OTRR(IDIM1,IBAND,1)=OTRR(IDIM1,IBAND,1)+
     &OPTN(IDIM1,IDIM,MU)*ALMR(IDIM,IBAND,2)
	OTRR(IDIM1,IBAND,2)=OTRR(IDIM1,IBAND,2)+
     &OPTN(IDIM1,IDIM,MU)*ALMR(IDIM,IBAND,1)
      ENDDO                                         !!! over idim
      ENDDO                                         !!! over idim1
	ENDDO                                         !!! over bands
	ENDDO                                         !!! over spin subbands
	DO IBNDS1=1,NSPIN                             !!! over spin subbands
      DO IBNDT1=1,NBNDT(1)                          !!! over bands
      IBAND1=IBNDS1+NSPIN*(IBNDT1-1)
	DO IBNDS=1,NSPIN                              !!! over spin subbands
      DO IBNDT=1,NBNDT(1)                           !!! over bands
      IBAND=IBNDS+NSPIN*(IBNDT-1)
	OPLL(IBAND1,IBAND,MU,1)=(0.D0,0.D0)
	OPLL(IBAND1,IBAND,MU,2)=(0.D0,0.D0)
	OPLR(IBAND1,IBAND,MU,1)=(0.D0,0.D0)
	OPLR(IBAND1,IBAND,MU,2)=(0.D0,0.D0)
	OPRL(IBAND1,IBAND,MU,1)=(0.D0,0.D0)
	OPRL(IBAND1,IBAND,MU,2)=(0.D0,0.D0)
	OPRR(IBAND1,IBAND,MU,1)=(0.D0,0.D0)
	OPRR(IBAND1,IBAND,MU,2)=(0.D0,0.D0)
	DO IDIM1=1,NBNDT(1)*NSPIN                     !!! over idim1
	OPLL(IBAND1,IBAND,MU,1)=OPLL(IBAND1,IBAND,MU,1)+
     &ALML(IDIM1,IBAND1,1)*OTLL(IDIM1,IBAND,1)
	OPLL(IBAND1,IBAND,MU,2)=OPLL(IBAND1,IBAND,MU,2)+
     &ALML(IDIM1,IBAND1,2)*OTLL(IDIM1,IBAND,2)
	OPLR(IBAND1,IBAND,MU,1)=OPLR(IBAND1,IBAND,MU,1)+
     &ALML(IDIM1,IBAND1,1)*OTLR(IDIM1,IBAND,1)
	OPLR(IBAND1,IBAND,MU,2)=OPLR(IBAND1,IBAND,MU,2)+
     &ALML(IDIM1,IBAND1,2)*OTLR(IDIM1,IBAND,2)
	OPRL(IBAND1,IBAND,MU,1)=OPRL(IBAND1,IBAND,MU,1)+
     &DCONJG(ALMR(IDIM1,IBAND1,1))*OTRL(IDIM1,IBAND,1)
	OPRL(IBAND1,IBAND,MU,2)=OPRL(IBAND1,IBAND,MU,2)+
     &DCONJG(ALMR(IDIM1,IBAND1,2))*OTRL(IDIM1,IBAND,2)
	OPRR(IBAND1,IBAND,MU,1)=OPRR(IBAND1,IBAND,MU,1)+
     &DCONJG(ALMR(IDIM1,IBAND1,1))*OTRR(IDIM1,IBAND,1)
	OPRR(IBAND1,IBAND,MU,2)=OPRR(IBAND1,IBAND,MU,2)+
     &DCONJG(ALMR(IDIM1,IBAND1,2))*OTRR(IDIM1,IBAND,2)
      ENDDO                                         !!! over idim1
	ENDDO                                         !!! over bands
	ENDDO                                         !!! over spin subbands
	ENDDO                                         !!! over bands
	ENDDO                                         !!! over spin subbands
 1000	CONTINUE                                      !!! over polarizations
C CHECK HERMITIANNES 
	GOTO 2000
C NOTE THAT MATRIX ELEMENT IS TAKEN WITH NABLA ONLY! NO (0.0,1.0) IS ADDED!
	DIF=0.D0
	ID1=0
	ID2=0
	MU0=0
	DO MU=-1,1
	DO IDIM1=1,NBNDT(1)*NSPIN
	DO IDIM =1,NBNDT(1)*NSPIN
C 	DEL=ABS(OPLL(IDIM1,IDIM,MU)+(-1)**MU*DCONJG(OPLL(IDIM,IDIM1,-MU)))
C	IF(DIF.LE.DEL)THEN
C	DIF=DEL
C	ID1=IDIM1
C	ID2=IDIM
C	MU0=MU
C	ENDIF
	ENDDO
	ENDDO
	ENDDO
C PRINT MAXIMUM ERROR FOR DEBUGGING PURPOSES
C	PRINT*,'In band representation',ID1,ID2,MU0
C	PRINT*,OPTN(ID1,ID2,MU0)
C	PRINT*,-(-1)**MU0*DCONJG(OPTN(ID2,ID1,-MU0))
C ENFORCE HERMITIANNESS
	DO MU=-1,1
	DO IDIM1=1,NBNDT(1)*NSPIN
	DO IDIM =1,NBNDT(1)*NSPIN
C	OINT=0.5D0*(OPLL(IDIM1,IDIM,+MU)-(-1)**MU*
C    &     DCONJG(OPLL(IDIM,IDIM1,-MU)))
C	OPLL(IDIM1,IDIM,+MU)=OINT
C	OPLL(IDIM,IDIM1,-MU)=-(-1)**MU*DCONJG(OINT)
	ENDDO
	ENDDO
	ENDDO
C MEMORY DEALLOCATIONS
 2000	DEALLOCATE(ALML,ALMR,OTLL,OTLR,OTRL,OTRR)
	END



