	SUBROUTINE ODF_ODFTTR(IPNT,ZOMG)
***********************************************************
*  The calculation of weights for Greens function integ-  *
*  rations over IBZ by means of tetrahedron method.       *
***********************************************************
C  SET ARRAY-SIZE DATA
      USE DIM_LMTART
C  SET EXTERNAL CONNECTIONS
      USE COM_PARAM  ,ONLY: NATOM,NSORT,NSPIN,NORBS           !!! from readini
      USE COM_KAPPAR ,ONLY: NPAN,NKAP                         !!! from readini
      USE COM_LATPAR ,ONLY: PAR,ORTH,OMEGAC                   !!! from readini
      USE COM_LATTICE,ONLY: RBAS,GBAS,AKBAS,RKBAS             !!! from readstr
      USE COM_NBANDS ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC           !!! from readini
	USE COM_FREQU  ,ONLY: NOMGOPT,OMGOPT                    !!! from getopt
	USE COM_ODFMAT ,ONLY: WGTODF                            !!! from odfpsi
      USE COM_GRFDAT ,ONLY: EPOL,EPOW                         !!! from odfbnd
	USE COM_FERMI  ,ONLY: EF                                !!! from ttrints
	USE COM_HUBDAT ,ONLY: PDMP                              !!! from readhub
      USE COM_INPTTR ,ONLY: NDIV,NDIC,NDIW,SH,KEYTTR
     &                     ,TFERMI,GBROAD                     !!! from readini
      USE COM_KMESH  ,ONLY: NPNT,PNT,WGT,IPQARR,ITQARR,KCUT   !!! from makettr
      USE COM_WMESH  ,ONLY: NPNW,PNW,WGW,IPWARR,ITWARR,KCUW   !!! from tetra
      USE COM_UNIT   ,ONLY: IUN,IUR,IUT                       !!! from setup
C  SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER KTT(4),KTW(4)
      DIMENSION E(4),AT(4),AD(4),FAT(4),FAD(4),FL(0:4,4)
     &   ,PKT(3,4),PKW(3,4),CRW(3,4),REC(3,3)
	COMPLEX*16 ZE(4,2,2),AG(4),DG(4),A0(4),CINT(4),DINT(4)
     &   ,ZOMG,GH,GD,ZI,ZJ
      DATA PI/3.141592653589793D0/,EPS/1.D-10/
C  MEMORY ALLOCATIONS
C  *********** INITIALIZATION **************
      VOLIBZ=1.D0
      OT=1.D0/NDIV(1)/NDIV(2)/NDIV(3)/6.D0
      OW=1.D0/NDIW(1)/NDIW(2)/NDIW(3)/6.D0
C  *********** TETRAHEDRON METHOD **********
C  WEIGHTS FOR SIGMA
	DO IBNDS=1,NSPIN
	DO IBNDT=1,NBNDT(1)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	DO IBNDS1=1,NSPIN
	DO IBNDT1=1,NBNDT(1)
	IBAND1=IBNDS1+NSPIN*(IBNDT1-1)
	WGTODF(IBAND,IBAND1,1,1)=0.D0
	WGTODF(IBAND,IBAND1,2,1)=0.D0
	WGTODF(IBAND,IBAND1,1,2)=0.D0
	WGTODF(IBAND,IBAND1,2,2)=0.D0
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C  DO OVER MICROCELLS
      DO 5200 I3=0,NDIV(3)-1               !!! over cells along G3
      DO 5200 I2=0,NDIV(2)-1               !!! over cells along G2
      DO 5200 I1=0,NDIV(1)-1               !!! over cells along G1
C  THE MICROCELL IS SET UP BY I1,I2,I3
C  SET UP TETRAHEDRON INSIDE MICROCELL
      DO 5100 ITTR=1,6                     !!! over tetrahedra
	IF(ITQARR(ITTR,I1,I2,I3).LT.0)GOTO 5100
	WTTR=DBLE(ITQARR(ITTR,I1,I2,I3))
      DO I=1,4
C  COORDINATES OF THE TETRAHEDRON AGE GIVEN BY KTT
      J1=I1+KCUT(1,I,ITTR)
      J2=I2+KCUT(2,I,ITTR)
      J3=I3+KCUT(3,I,ITTR)
      KTT(I)=IPQARR(J1,J2,J3)
      ENDDO
C  CHECK IF THE POINT "IPNT" IS WITHIN THE TETRAHEDRON
	IHERE=0
	DO I=1,4
	IF(KTT(I).EQ.IPNT)IHERE=1
	ENDDO
	IF(IHERE.EQ.0)GOTO 5100
C  SET UP POINTS "K" DESCRIBING TETRAHEDRON IN THE SPACE
      DO I=1,4
      J1=I1+KCUT(1,I,ITTR)
      J2=I2+KCUT(2,I,ITTR)
      J3=I3+KCUT(3,I,ITTR)
      PKT(1,I)=(J1*AKBAS(1,1,1)+
     &          J2*AKBAS(1,2,1)+
     &          J3*AKBAS(1,3,1))*2.D0*PI/PAR
      PKT(2,I)=(J1*AKBAS(2,1,1)+
     &          J2*AKBAS(2,2,1)+
     &          J3*AKBAS(2,3,1))*2.D0*PI/PAR
      PKT(3,I)=(J1*AKBAS(3,1,1)+
     &          J2*AKBAS(3,2,1)+
     &          J3*AKBAS(3,3,1))*2.D0*PI/PAR
      ENDDO
C  SHIFT COORDINATE SYSTEM TO THE FIRST POINT
      DO I=2,4
      PKT(1,I)=PKT(1,I)-PKT(1,1)
      PKT(2,I)=PKT(2,I)-PKT(2,1)
      PKT(3,I)=PKT(3,I)-PKT(3,1)
      ENDDO
C  SET RECIPROCALS "REC" TO "PKT"
      CALL CROSS(REC(1,1),PKT(1,3),PKT(1,4))
      CALL CROSS(REC(1,2),PKT(1,4),PKT(1,2))
      CALL CROSS(REC(1,3),PKT(1,2),PKT(1,3))
      W=REC(1,1)*PKT(1,2)+REC(2,1)*PKT(2,2)+REC(3,1)*PKT(3,2)
      IF(ABS(W).LE.1.D-10)
     &CALL FULLSTOP('<TTRGRF>:: INTERNAL ERROR: W=0')
      DO I=1,3
      REC(I,1)=REC(I,1)/W
      REC(I,2)=REC(I,2)/W
      REC(I,3)=REC(I,3)/W
      ENDDO
C  DO OVER DIVISIONS OF THE MICROCELL
      DO 4200 ID3=0,NDIW(3)/NDIV(3)-1
      DO 4200 ID2=0,NDIW(2)/NDIV(2)-1
      DO 4200 ID1=0,NDIW(1)/NDIV(1)-1
C  THE SMALL MICROCELL IS SET UP BY IW1,IW2,IW3
      IW1=I1*NDIW(1)/NDIV(1)+ID1
      IW2=I2*NDIW(2)/NDIV(2)+ID2
      IW3=I3*NDIW(3)/NDIV(3)+ID3
C  SET UP SMALL TETRAHEDRON INSIDE SMALL MICROCELL
      DO 4100 ITTRD=1,6
      DO I=1,4
      JW1=IW1+KCUT(1,I,ITTRD)
      JW2=IW2+KCUT(2,I,ITTRD)
      JW3=IW3+KCUT(3,I,ITTRD)
      KTW(I)=IPWARR(JW1,JW2,JW3)
      ENDDO
C  SET UP POINTS K DESCRIBING SMALL TETRAHEDRON IN THE SPACE
      DO I=1,4
      JW1=IW1+KCUT(1,I,ITTRD)
      JW2=IW2+KCUT(2,I,ITTRD)
      JW3=IW3+KCUT(3,I,ITTRD)
      PKW(1,I)=(JW1*AKBAS(1,1,3)+
     &          JW2*AKBAS(1,2,3)+
     &          JW3*AKBAS(1,3,3))*2.D0*PI/PAR
      PKW(2,I)=(JW1*AKBAS(2,1,3)+
     &          JW2*AKBAS(2,2,3)+
     &          JW3*AKBAS(2,3,3))*2.D0*PI/PAR
      PKW(3,I)=(JW1*AKBAS(3,1,3)+
     &          JW2*AKBAS(3,2,3)+
     &          JW3*AKBAS(3,3,3))*2.D0*PI/PAR
      ENDDO
C  SHIFT COORDINATE SYSTEM TO THE FIRST POINT
      DO I=1,4
      PKW(1,I)=PKW(1,I)-PKT(1,1)
      PKW(2,I)=PKW(2,I)-PKT(2,1)
      PKW(3,I)=PKW(3,I)-PKT(3,1)
      ENDDO
C  CHECK WHETHER A SMALL TETRAHEDRON "PKW" IS INSIDE  TETRAHEDRON "PKT"
      DO I=1,4
      X1=PKW(1,I)*REC(1,1)+PKW(2,I)*REC(2,1)+PKW(3,I)*REC(3,1)
      X2=PKW(1,I)*REC(1,2)+PKW(2,I)*REC(2,2)+PKW(3,I)*REC(3,2)
      X3=PKW(1,I)*REC(1,3)+PKW(2,I)*REC(2,3)+PKW(3,I)*REC(3,3)
      IF(.NOT.((X1.GE.-EPS.AND.X1.LE.1.D0+EPS).AND.
     &         (X2.GE.-EPS.AND.X2.LE.1.D0+EPS).AND.
     &         (X3.GE.-EPS.AND.X3.LE.1.D0+EPS).AND.
     &         (X1+X2+X3.LE.1.D0+EPS)))GOTO 4100
      CRW(1,I)=X1
      CRW(2,I)=X2
      CRW(3,I)=X3
      ENDDO
C  CALCULATE CONTRIBUTION TO THE POINTS GIVEN BY "KTT=PKT"
      DO 2200 IBNDS1=1,NSPIN                    !!! over spin subbands
      DO 2100 IBNDT1=1,NBNDT(1)                 !!! over valence bands
      IBAND1=IBNDS1+NSPIN*(IBNDT1-1)
      DO 1200 IBNDS=1,NSPIN                     !!! over spin subbands
      DO 1100 IBNDT=1,NBNDT(1)                  !!! over valence bands
      IBAND=IBNDS+NSPIN*(IBNDT-1)
C  TAKE INTEGRAL FOR FREQUENCY DEPENDENT BANDS
      DO I=1,4
	ZE(I,1,1)=DCONJG(EPOW(IBAND1,KTW(I),2)-EPOW(IBAND,KTW(I),1))
	ZE(I,1,2)=EPOW(IBAND1,KTW(I),2)-DCONJG(EPOW(IBAND,KTW(I),1))
	ZE(I,2,1)=DCONJG(EPOW(IBAND1,KTW(I),2))-EPOW(IBAND,KTW(I),1)
	ZE(I,2,2)=EPOW(IBAND1,KTW(I),2)-EPOW(IBAND,KTW(I),1)
C  ADD ARTIFICIAL BROADENING
	ZE(I,1,1)=ZE(I,1,1)+DCMPLX(0.D0,-PDMP)
	ZE(I,2,2)=ZE(I,2,2)+DCMPLX(0.D0,+PDMP)
      ENDDO
	DO IMP1=1,2
	DO IMP =1,2
      CALL TTR_MCTTRINT5(ZE(1,IMP1,IMP),OW,ZOMG,CINT,DINT,1)
	AG(1)=CINT(1)-CINT(2)-CINT(3)-CINT(4)
	AG(2)=CINT(2)
	AG(3)=CINT(3)
	AG(4)=CINT(4)
	DG(1)=DINT(1)-DINT(2)-DINT(3)-DINT(4)
	DG(2)=DINT(2)
	DG(3)=DINT(3)
	DG(4)=DINT(4)
      DO IT=1,4
	IF(IPNT.NE.KTT(IT))CYCLE
      DO I=1,4
      IF(IT.EQ.1)WF=1.D0-CRW(1,I)-CRW(2,I)-CRW(3,I)
      IF(IT.NE.1)WF=CRW(IT-1,I)
      WGTODF(IBAND,IBAND1,IMP1,IMP)=WGTODF(IBAND,IBAND1,IMP1,IMP)+
     &AG(I)*WF*WTTR
      ENDDO
      ENDDO
	ENDDO
	ENDDO
 1100 CONTINUE                                  !!! over valence bands
 1200 CONTINUE                                  !!! over spin subbands
 2100 CONTINUE                                  !!! over valence bands
 2200 CONTINUE                                  !!! over spin subbands
 4100 CONTINUE                                  !!! over small tetrahedra
 4200 CONTINUE                                  !!! over small microcells
 5100 CONTINUE                                  !!! over tetrahedra
 5200 CONTINUE                                  !!! over microcells
C Normalization. Note that the imaginary part is PI times
C larger than the density of states since ImG(E)=pi*N(E) and 
C if G(w)=1/(w-E(k)-id), ImG(w)=pi*d(w-E(k))
      DO IBNDS=1,NSPIN
      DO IBNDT=1,NBNDT(1)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
      DO IBNDS1=1,NSPIN
      DO IBNDT1=1,NBNDT(1)
	IBAND1=IBNDS1+NSPIN*(IBNDT1-1)
      WGTODF(IBAND,IBAND1,1,1)=WGTODF(IBAND,IBAND1,1,1)/
     &VOLIBZ*2.D0/DBLE(NSPIN)
      WGTODF(IBAND,IBAND1,1,2)=WGTODF(IBAND,IBAND1,1,2)/
     &VOLIBZ*2.D0/DBLE(NSPIN)
      WGTODF(IBAND,IBAND1,2,1)=WGTODF(IBAND,IBAND1,2,1)/
     &VOLIBZ*2.D0/DBLE(NSPIN)
      WGTODF(IBAND,IBAND1,2,2)=WGTODF(IBAND,IBAND1,2,2)/
     &VOLIBZ*2.D0/DBLE(NSPIN)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	RETURN
	END
