	SUBROUTINE ODF_SETODF
************************************************************
*   Saves optical matrix                                   *
************************************************************
C SET EXTERNAL CONNECTIONS
	USE COM_LMTMEM                                        !!! from setup
	USE COM_CONTROL ,ONLY: LIFT,LMTO                      !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,NHSORT !!! from readini
     &                      ,IS,ILST,ILSB
      USE COM_LATPAR  ,ONLY: PAR,OMEGAC                     !!! from readini
	USE COM_KAPPAR  ,ONLY: NPAN,NKAP                      !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN                    !!! from readini
	USE COM_INPTTR  ,ONLY: NDIV,NDIC,NDIW                 !!! from readini
	USE COM_KMESH   ,ONLY: NPNT,PNT                       !!! from tetra
      USE COM_FREQU   ,ONLY: NOMGOPT,OMGOPT,NENROPT         !!! from readini
      USE COM_FERMI   ,ONLY: EF                             !!! from ttrints
	USE COM_ODFMAT  ,ONLY: SIGMAW                         !!! from optmat
	USE COM_UNIT    ,ONLY: IUN,IUR,IUT,IUI                !!! from setup
      USE COM_CHANNELS,ONLY: IUAIN                          !!! from channels
	USE COM_LMTOUT  ,ONLY: ICODF,ODFFILE                  !!! from readini
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	DIMENSION VEL(3),SPTOS(2),SPDOS(2),SPVEL(3,2)
     &   ,VELM(3,3),SPVELM(3,3,2)
      COMPLEX*16 TRS(7,-3:3,0:3),S(3,3)
	CHARACTER HELP*40 
	LOGICAL EXIST
	DATA PI/3.141592653589793D0/
	IF(ICODF.EQ.0)RETURN
C Build transformation matrices
	CALL LIB_TRANSC(TRC)
	CALL LIB_TRANSS(TRS)
	INQUIRE(FILE=ODFFILE,EXIST=EXIST)
	IF(EXIST)THEN
      OPEN(UNIT=IUAIN,FILE=ODFFILE,STATUS='OLD',FORM='FORMATTED')
	CLOSE(UNIT=IUAIN,STATUS='DELETE')
	ENDIF
	OPEN(IUAIN,FILE=ODFFILE,STATUS='NEW',FORM='FORMATTED')
C STORE HEADER INFO.
	WRITE(IUAIN,10010)
	WRITE(IUAIN,10020)
10010	FORMAT(1X,'<FILE=ODFFILE,INPUT=MODERN>')
10020 FORMAT('****************************************************')
	WRITE(IUAIN,10030)
10030 FORMAT(1X,'<SECTION=CTRL>               ! CONTROL PARAMETERS:')
      HELP='! Frequency mesh for optics          '
	WRITE(IUAIN,10040)NOMGOPT,HELP
10040 FORMAT(1X,'nOmgOPT=',I5,16X,A40)
      HELP='! Min.Frequency (Ry)  for optics     '
	WRITE(IUAIN,10050)OMGOPT(0),HELP
10050 FORMAT(1X,'WminOPT=',G14.7,7X,A40)
      HELP='! Max.Frequency (Ry)  for optics     '
	WRITE(IUAIN,10060)OMGOPT(NOMGOPT),HELP
10060 FORMAT(1X,'WmaxOPT=',G14.7,7X,A40)
      HELP='! Internal energy mesh for optics    '
	WRITE(IUAIN,10065)NENROPT,HELP
10065 FORMAT(1X,'NenrOPT=',I5,16X,A40)
	HELP='! Tetrahedron mesh                     '
	WRITE(IUAIN,10070)NDIV,HELP
10070 FORMAT(1X,'nDiv(:)=',I2,1X,I2,1X,I2,1X,12X,A40)
	HELP='! Tetrahedron mesh for weights         '
	WRITE(IUAIN,10080)NDIW,HELP
10080 FORMAT(1X,'nDiw(:)=',I2,1X,I2,1X,I2,1X,12X,A40)
C STORE OPTICAL DATA
	WRITE(IUAIN,10110)
10110 FORMAT(1X,'<SECTION=DATA>               ! OPTICAL DATA:')
	WRITE(IUAIN,10200)NOMGOPT,OMGOPT(0),OMGOPT(NOMGOPT),PAR,OMEGAC
	DO IOMG=0,NOMGOPT
C TRANSFORM TO CARTESIAN COORDINATES
	DO IA=1,3
	DO IB=1,3
	S(IA,IB)=(0.D0,0.D0)
	DO MU=-1,1
	DO NU=-1,1
	S(IA,IB)=S(IA,IB)+
     &TRS(IA,MU,1)*SIGMAW(IOMG,MU,NU)*TRS(IB,NU,1)
	ENDDO
	ENDDO
C OUTPUT E2 INSTEAD OF SIGMA
	OMG=OMGOPT(IOMG)
	IF(OMGOPT(IOMG).LE.1.D-10)OMG=1.D-10
	S(IA,IB)=4.D0*PI/OMG*S(IA,IB)
	IF(ABS(S(IA,IB)).LE.1.D-07)S(IA,IB)=(0.D0,0.D0)
	ENDDO
	ENDDO
	WRITE(IUAIN,10220)OMGOPT(IOMG),((DREAL(S(I,J)),I=1,3),J=1,3)
	ENDDO
	CLOSE(IUAIN)
	RETURN
10200 FORMAT(1X,I5,1X,G14.7,1X,G14.7,1X,G14.7,1X,G14.7)
10210 FORMAT(1X,13X,9(G12.5,1X))
10220 FORMAT(1X,10(G12.5,1X))
	END SUBROUTINE ODF_SETODF

