	SUBROUTINE ODF_SYMODF(IOMG)
************************************************************
*   Symmetrize optical matrix                              *
************************************************************
C SET EXTERNAL CONNECTIONS
	USE COM_LMTMEM                                        !!! from setup
	USE COM_CONTROL ,ONLY: LIFT,LMTO                      !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,NHSORT !!! from readini
     &                      ,IS,ILST,ILSB
      USE COM_LATPAR  ,ONLY: PAR,OMEGAC                     !!! from readini
	USE COM_KAPPAR  ,ONLY: NPAN,NKAP                      !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN                    !!! from readini
	USE COM_KMESH   ,ONLY: NPNT,PNT                       !!! from tetra
      USE COM_FREQU   ,ONLY: NOMGOPT,OMGOPT                 !!! from readini
	USE COM_GROUPS  ,ONLY: NGROUP,U,IP,RDC,SHIFT,INV,IKOV !!! from groups
      USE COM_GRFDAT  ,ONLY: EPOL,EPOW                      !!! from odfbnd
	USE COM_ODFMAT  ,ONLY: SIGMAW                         !!! from optmat
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC        !!! from readini
	USE COM_UNIT    ,ONLY: IUN,IUR,IUT,IUI                !!! from setup
	USE COM_LMTOUT  ,ONLY: ICODF                          !!! from readini
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: ST(:,:)
	DATA PI/3.141592653589793D0/
C MEMORY ALLOCATIONS
	ALLOCATE(ST(-1:1,-1:1))
C SYMMETRIZE IMAGINARY DIELECTRIC FUNCTION
	DO MU=-1,1
	DO NU=-1,1
	ST(MU,NU)=(0.D0,0.D0)
	ENDDO
	ENDDO
C ROTATIONS OF E2_MU_NU (LOW INDEXES HERE!)
	DO IR=1,NGROUP
	IG=IKOV(IR)
	DO MU=-1,1
	DO NU=-1,1
      DO MU1=-1,1
      DO NU1=-1,1
      MUMU1=3+3*(1+MU1)+MU
      NUNU1=3+3*(1+NU1)+NU
      ST(MU,NU)=ST(MU,NU)+
     &CONJG(U(MUMU1,IG))*SIGMAW(IOMG,MU1,NU1)*CONJG(U(NUNU1,IG))
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C PROPERLY NORMALIZED OPTICAL CONDUCTIVITY (BOTH INTER AND INTRABAND)
	DO MU=-1,1
	DO NU=-1,1
	SIGMAW(IOMG,MU,NU)=(0.D0,0.D0)
	IF(ABS(OMGOPT(IOMG)).GT.1.D-10)
     &SIGMAW(IOMG,MU,NU)=-ST(MU,NU)/DBLE(NGROUP)*
     &2.D0/OMGOPT(IOMG)/4.D0/PI/OMEGAC/0.5D0/0.5D0  !!! -e2/w/4pi/Vcell/m2
     	ENDDO
	ENDDO
C MEMORY DEALLOCATIONS
	DEALLOCATE(ST)
	END
