	SUBROUTINE OPT_FTBOPT
************************************************************
*   The calculation of optical properties                  *
************************************************************
C SET EXTERNAL CONNECTIONS
	USE COM_LMTMEM                                        !!! from setup
	USE COM_CONTROL ,ONLY: LIFT,LMTO                      !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,NHSORT !!! from readini
	USE COM_KAPPAR  ,ONLY: NPAN,NKAP                      !!! from readini
	USE COM_KMESH   ,ONLY: NPNT,PNT                       !!! from tetra
	USE COM_FREQU   ,ONLY: NOMGOPT                        !!! from tetra
      USE COM_FERMI   ,ONLY: EF,ZFIL                        !!! from ttrints
	USE COM_UNIT    ,ONLY: IUN,IUR,IUT,IUI                !!! from setup
	USE COM_LMTOUT  ,ONLY: ICCON,ICOPT                    !!! from readini
	USE COM_CHANNELS,ONLY: IUCON,IUOPT                    !!! from channels
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	DATA PI/3.141592653589793D0/
	IF(ICOPT.EQ.0)RETURN
C FIND FERMI LEVEL
      CALL BND_INSUL(EF,ZFIL)         !!! recognize insulating case
      CALL BND_FNDFRM(EF,ZFIL,EF,100,1.D-09,0.8D0)! search for Fermi energy
C Compute radial matrix elements
	CALL OPT_NULOPT(1)                !!! set eps(w)=0
C INTEGRATE OVER BRILLOUIN ZONE
	DO IPNT=1,NPNT(1)                 !!! over k-points
C Optical matrix elements
	CALL OPT_OPTDHK(IPNT)             !!! compute current matrix element
	CALL OPT_OPTPTB(IPNT)             !!! goto band representation
C COMPUTE E2 FOR ALL FREQUENCIES
	DO IOMG=0,NOMGOPT                 !!! over frequencies
	CALL OPT_OPTTET(IPNT,IOMG)        !!! k-point tetrahedron weights
	CALL OPT_OPTINT(IPNT,IOMG)        !!! integrate dielectric function 
      ENDDO                             !!! over frequencies
 	ENDDO                             !!! over k-points
	CLOSE(UNIT=IUOPT,STATUS='DELETE')
	IF(ICCON.EQ.0)CLOSE(UNIT=IUCON,STATUS='DELETE')
	IF(ICCON.NE.0)CLOSE(UNIT=IUCON,STATUS='KEEP')
	CALL OPT_SYMOPT                   !!! symmetrize optical integrals
	CALL OPT_SETOPT                   !!! save optical properties
	END
