	SUBROUTINE OPT_LMTOPT
************************************************************
*   The calculation of optical properties                  *
************************************************************
C SET EXTERNAL CONNECTIONS
	USE COM_LMTMEM                                        !!! from setup
	USE COM_CONTROL ,ONLY: LIFT,LMTO                      !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,NHSORT !!! from readini
	USE COM_KAPPAR  ,ONLY: NPAN,NKAP                      !!! from readini
	USE COM_KMESH   ,ONLY: NPNT,PNT                       !!! from tetra
	USE COM_FREQU   ,ONLY: NOMGOPT                        !!! from tetra
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC        !!! from readini
      USE COM_FERMI   ,ONLY: EF,ZDFT                        !!! from ttrints
	USE COM_UNIT    ,ONLY: IUN,IUR,IUT,IUI                !!! from setup
	USE COM_LMTOUT  ,ONLY: ICCON,ICOPT                    !!! from readini
	USE COM_CHANNELS,ONLY: IUCON,IUOPT                    !!! from channels
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	DATA PI/3.141592653589793D0/
	IF(ICOPT.EQ.0)RETURN
	CALL OPT_ALLOCATE('A')
C FIND FERMI LEVEL
      CALL BND_INSUL(EF,ZDFT)       !!! recognize insulating case
      CALL BND_FNDFRM(EF,ZDFT,EF,100,1.D-09,0.8D0)! search for Fermi energy
C Compute radial matrix elements
	CALL BND_POTPAR(1)                       !!! different potential partameters
	CALL BND_LMTPAR(1)                       !!! some combinations of parameters
	CALL BND_OVRPAR(1)                       !!! potential parameters for overlapping
	CALL OPT_OPTPAR(1)                       !!! optical matrix elements
	CALL OPT_NULOPT(1)                       !!! set eps(w)=0
C INTEGRATE OVER BRILLOUIN ZONE
	DO IPNT=1,NPNT(1)                        !!! over k-points
C Structure constants
      CALL BND_STRSUM(IPNT,1,0)                !!! calculate lattice sums
      CALL BND_STRGNT(IPNT,1,0,1)              !!! restore bare structure matrices
      CALL HOP_STRALP(IPNT,1,0)                !!! screen structure constants
      CALL HOP_SCRSTR(IPNT,1,0)                !!! restore screened structure constants
C Optical matrix elements
	CALL OPT_OPTMAT(IPNT)                    !!! compute current matrix element
	CALL OPT_OPTHAN(IPNT)                    !!! add interstitial region
	CALL OPT_OPTPSI(IPNT)                    !!! goto band representation
C COMPUTE E2 FOR ALL FREQUENCIES
	DO IOMG=0,NOMGOPT                        !!! over frequencies
	CALL OPT_OPTTET(IPNT,IOMG)               !!! k-point tetrahedron weights
	CALL OPT_OPTINT(IPNT,IOMG)               !!! integrate dielectric function 
      ENDDO                                    !!! over frequencies
 	ENDDO                                    !!! over k-points
	CLOSE(UNIT=IUOPT,STATUS='DELETE')
	IF(ICCON.EQ.0)CLOSE(UNIT=IUCON,STATUS='DELETE')
	IF(ICCON.NE.0)CLOSE(UNIT=IUCON,STATUS='KEEP')
	CALL OPT_SYMOPT                          !!! symmetrize optical integrals
	CALL OPT_SETOPT                          !!! save optical properties
	CALL OPT_ALLOCATE('D')
	END
