	SUBROUTINE OPT_OPTHAN(IPNT)
************************************************************
*   The calculation of optical matrix elements             *
************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                          !!! from setup
      USE COM_CONTROL ,ONLY: LMTO,IASA,NPFR,NOVR              !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS
     &                      ,IS,ILSB,ILST                     !!! from readini
      USE COM_LATPAR  ,ONLY: PAR,OMEGAC                       !!! from readini
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP                   !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN                      !!! from readini
      USE COM_SPHERE  ,ONLY: SMT,SWZ                          !!! from readini
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT                !!! from readini
      USE COM_LMTPAR  ,ONLY: GAM                              !!! from potpar
      USE COM_INTPAR  ,ONLY: WHH,WJH,WHJ,WJJ                  !!! from ovrpar
      USE COM_GAUNT   ,ONLY: C                                !!! from gdata
      USE COM_INDORB  ,ONLY: INDLMT                           !!! from lmtpar
	USE COM_OPTMAT  ,ONLY: OPTN                             !!! from optmat
      USE COM_CHANNELS,ONLY: IUOPT                            !!! from lmtmat
      USE COM_STRCON  ,ONLY: SSCON,SDCON                      !!! from strgnt
      USE COM_MASHDEP ,ONLY: LENCMP                           !!! from readini
	USE COM_LMTOUT  ,ONLY: ICOPT                            !!! from readini
	USE COM_KMESH   ,ONLY: NPNT,PNT                        ! KH
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER, ALLOCATABLE :: INDOPT(:,:,:)
	COMPLEX*16, ALLOCATABLE :: OMAT(:,:)
      COMPLEX*16  OINT
	COMPLEX*16  :: CI=(0., 1.D0)
	COMPLEX*16 VXTMP, VYTMP, VZTMP
	integer :: fh_vel = 559
	integer :: ADDINTST = 0   ! KH VERY IMPOTRANT! THIS DOES NOT ADD INTERSTITIALS AND AVOID FACTOR OF 2 IN OPTICS
	DATA PI/3.141592653589793D0/
	SQPI43=SQRT(4.D0*PI/3.D0)
	CALL  ABORTNOW()
C MEMORY ALLOCATIONS
	ALLOCATE(INDOPT(LIMB1MEM,NATOMMEM,NKAPMEM))
	JDIM=0
	DO IKAP=1,NKAP(1)
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	DO L=0,ILSB(ISORT)+1
	DO M=-L,L
	LM=L*(L+1)+M+1
	JDIM=JDIM+1
	INDOPT(LM,IATOM,IKAP)=JDIM
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	NDIM=JDIM
	ALLOCATE(OMAT(NDIM,NDIM))
C SET ZEROES
	DO JDIM1=1,NDIM
	DO JDIM =1,NDIM
	OMAT(JDIM1,JDIM)=(0.D0,0.D0)
	ENDDO
	ENDDO
C *********************************************
C SET OVERLAP MATRIX IN THE INTERSTITIAL REGION
	DO IKAP1=1,NKAP(1)                !!! over energy
	DO IATOM1=1,NATOM                 !!! over iatom1
	ISORT1=IS(IATOM1)
	DO L1=0,ILSB(ISORT1)              !!! over l1 ! do not loop over lmax+1 here
	DO M1=-L1,L1                      !!! over m1
	L1M1=L1*(L1+1)+M1+1
	JDIM1=INDOPT(L1M1,IATOM1,IKAP1)
	DO IKAP =1,NKAP(1)                !!! over energy
	DO IATOM=1,NATOM                  !!! over iatom
	ISORT=IS(IATOM)
	DO L=0,ILSB(ISORT)   !+1  KH            !!! over l
	DO M=-L,L                         !!! over m
	LM=L*(L+1)+M+1
	JDIM=INDOPT(LM,IATOM,IKAP)
	OINT=(0.D0,0.D0)
C ONE-CENTER TERM :
	IF(IATOM1.EQ.IATOM.AND.L1M1.EQ.LM)
     &OINT=OINT+WHH(IKAP1,IKAP,L,ISORT)
C TWO-CENTER TERM :
	OINT=OINT-WJH(IKAP1,IKAP,L,ISORT)*GAM(L,ISORT)*
     &DCONJG(SSCON(LM,IATOM,L1M1,IATOM1,IKAP1))
	OINT=OINT-WHJ(IKAP1,IKAP,L1,ISORT1)*GAM(L1,ISORT1)*
     &SSCON(L1M1,IATOM1,LM,IATOM,IKAP)
C ADD SDCON MATRIX IN CASE EQUAL ENERGIES
	IF(ABS(EKAP(IKAP,1)-DCONJG(EKAP(IKAP1,1))).
     &   LE.1.D-10.AND.NOVR.EQ.0)
     &OINT=OINT-SDCON(L1M1,IATOM1,LM,IATOM,IKAP)*PAR**3
C THREE-CENTER TERM :
	DO KATOM=1,NATOM                  !!! over katom
	KSORT=IS(KATOM)
	DO L2=0,ILST(KSORT)               !!! over l2
	DO M2=-L2,L2                      !!! over m2
	L2M2=L2*(L2+1)+M2+1
	OINT=OINT+CONJG(SSCON(L2M2,KATOM,L1M1,IATOM1,IKAP1))*
     &WJJ(IKAP1,IKAP,L2,KSORT)*GAM(L2,KSORT)*GAM(L2,KSORT)*
     &SSCON(L2M2,KATOM,LM,IATOM,IKAP)
      ENDDO                             !!! over m2
      ENDDO                             !!! over l2
      ENDDO                             !!! over katom
C SET OPTICAL MATRIX ELEMENT AND OVERLAP MATRICES
      OMAT(JDIM1,JDIM)=OINT
      ENDDO                             !!! over m
      ENDDO                             !!! over l
      ENDDO                             !!! over iatom
      ENDDO                             !!! over energy
      ENDDO                             !!! over m1
      ENDDO                             !!! over l1
      ENDDO                             !!! over iatom1
      ENDDO                             !!! over energy
C ******************************************
C SET CONTRIBUTION TO OPTICAL MATRIX ELEMENT
	DO 3000 MU=-1,1                   !!! over polarizations
	DO 2000 IORBS=1,NORBS             !!! over iorbs
	DO 1000 IUPDN=1,NSPIN             !!! over spins
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
C Skip off-diagonal-over-spins elements
	IF(ISPIN1.NE.ISPIN)CYCLE
	DO IKAP1=1,NKAP(1)                !!! over energy
	DO IATOM1=1,NATOM                 !!! over iatom1
	ISORT1=IS(IATOM1) 
	DO L1=0,ILSB(ISORT1)              !!! over l1
	IF(.NOT.LTPAN(L1,IATOM1,IKAP1,1))CYCLE
	DO M1=-L1,L1                      !!! over m1
	L1M1=L1*(L1+1)+M1+1
	IDIM1=INDLMT(L1M1,IATOM1,IKAP1,ISPIN1,1)
	JDIM1=INDOPT(L1M1,IATOM1,IKAP1)
	DO IKAP =1,NKAP(1)                !!! over energy
	DO IATOM=1,NATOM                  !!! over iatom
	ISORT=IS(IATOM)
	DO L=0,ILSB(ISORT)                !!! over l
	IF(.NOT.LTPAN(L,IATOM,IKAP,1))CYCLE
	DO M=-L,L                         !!! over m
	LM=L*(L+1)+M+1
	IDIM=INDLMT(LM,IATOM,IKAP,ISPIN,1)
	OINT=(0.D0,0.D0)
	IF(.TRUE.)THEN
	LMU=(L+1)*(L+2)+M+MU+1
	JDIMU=INDOPT(LMU,IATOM,IKAP)
	OINT=OINT+(0.D0,1.D0)*SQPI43*C(0,LMU,LM)*
     &DBLE(2*L+1)/SMT(ISORT)*OMAT(JDIM1,JDIMU)
	ENDIF
	IF(ABS(M+MU).LE.L-1.AND.L.GT.0)THEN
	LMU=(L-1)*(L+0)+M+MU+1
	JDIMU=INDOPT(LMU,IATOM,IKAP)
	OINT=OINT+(0.D0,1.D0)*SQPI43*C(0,LMU,LM)*
     &SMT(ISORT)*EKAP(IKAP,1)/DBLE(2*L-1)*OMAT(JDIM1,JDIMU)
	ENDIF
C SET OPTICAL MATRIX ELEMENT
      IF (ADDINTST) OPTN(IDIM1,IDIM,MU)=OPTN(IDIM1,IDIM,MU)+OINT
      ENDDO                             !!! over m
      ENDDO                             !!! over l
      ENDDO                             !!! over iatom
      ENDDO                             !!! over m1
      ENDDO                             !!! over l1
      ENDDO                             !!! over iatom1
      ENDDO                             !!! over energy
      ENDDO                             !!! over energy
 1000 CONTINUE                          !!! over spins
 2000 CONTINUE                          !!! over iorbs
 3000	CONTINUE                          !!! over polarizations
C CHECK HERMITIANNES NOW
C NOTE THAT MATRIX ELEMENT IS TAKEN WITH NABLA ONLY! NO (0.0,1.0) IS ADDED!
	DIF=0.D0
	ID1=0
	ID2=0
	MU0=0
	DO MU=-1,1
	DO IDIM1=1,NBNDT(1)*NSPIN
	DO IDIM =1,NBNDT(1)*NSPIN
	DEL=ABS(OPTN(IDIM1,IDIM,MU)+(-1)**MU*DCONJG(OPTN(IDIM,IDIM1,-MU)))
	IF(DIF.LE.DEL)THEN
	DIF=DEL
	ID1=IDIM1
	ID2=IDIM
	MU0=MU
	ENDIF
	ENDDO
	ENDDO
	ENDDO
C PRINT MAXIMUM ERROR FOR DEBUGGING PURPOSES
C	PRINT*,'Maximum error for',ID1,ID2,MU0
C	PRINT*,OPTN(ID1,ID2,MU0)
C	PRINT*,-(-1)**MU0*DCONJG(OPTN(ID2,ID1,-MU0))
C ENFORCE HERMITIANNESS
	DO MU=-1,1
	DO IDIM1=1,NBNDT(1)*NSPIN
	DO IDIM =1,NBNDT(1)*NSPIN
	OINT=0.5D0*(OPTN(IDIM1,IDIM,+MU)-(-1)**MU*
     &     DCONJG(OPTN(IDIM,IDIM1,-MU)))
	OPTN(IDIM1,IDIM,+MU)=OINT
	OPTN(IDIM,IDIM1,-MU)=-(-1)**MU*DCONJG(OINT)
	ENDDO
	ENDDO
	ENDDO

c---------- Start : Velocity matrix output by Gunnar ----------
	IF(IPNT.eq.1) then
	open(fh_vel,file='vel.dat',form='formatted')
	write(fh_vel,*) NPNT(1),NBNDT(1)
	ELSE
	open(fh_vel,file='vel.dat',access='SEQUENTIAL',position='APPEND')
	ENDIF
	write(fh_vel,*) IPNT
!	Transformation from \mu representation to x,y,z
	DO IDIM1=1,NBNDT(1)*NSPIN
	DO IDIM =1,NBNDT(1)*NSPIN
	VXTMP=    ( OPTN(IDIM1,IDIM,-1) - OPTN(IDIM1,IDIM,+1) )/SQRT(2.)
	VYTMP=+CI*( OPTN(IDIM1,IDIM,-1) + OPTN(IDIM1,IDIM,+1) )/SQRT(2.)
	VZTMP=      OPTN(IDIM1,IDIM, 0)
	OPTN(IDIM1,IDIM,-1)=VXTMP
	OPTN(IDIM1,IDIM, 0)=VYTMP
	OPTN(IDIM1,IDIM,+1)=VZTMP
	ENDDO
	ENDDO
	write(fh_vel,*) (((OPTN(IDIM1,IDIM,MU), MU=-1,1),
     &IDIM1=1,NBNDT(1)*NSPIN),IDIM=1,NBNDT(1)*NSPIN)
	close(fh_vel)
c---------- Finish: Velocity matrix output by Gunnar ----------


	
C MEMORY DEALLOCATIONS
	DEALLOCATE(INDOPT,OMAT)
	END
