	SUBROUTINE OPT_OPTTET(IPNT,IOMG)
*****************************************************************
*  Calculate weight function for the integration over BZ        *
*                                                               *
*  Imaginary part:                                              *
*                                                               *
*  ___    /  3                                                  *
*  >      \ d k  [f(Ef-E(kj))-f(Ef-E(k+qj')]*R(k,k+q,jj')*      *
*  ---    /          d(E(kj)-E(k+qj')-W)                        *
*  jj'     BZ                                                   *
*                                                               *
*  where f(x) are occupation numbers and R are some matrix      *
*  elements. Tetrahedron method is used.                        *
*****************************************************************
C  SET ARRAY-SIZE DATA
      USE DIM_LMTART
C  SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                           !!! from setup
      USE COM_CONTROL ,ONLY: LIFT,LMTO,IASA,NPFR,NOVR          !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS           !!! from readini
      USE COM_LATTICE ,ONLY: RBAS,GBAS,AKBAS,RKBAS             !!! from readstr
      USE COM_LATPAR  ,ONLY: PAR,ORTH,OMEGAC                   !!! from readini
      USE COM_NBANDS  ,ONLY: NBNDF,NBNDE,NBNDT,NBNDC,POLUS     !!! from readini
      USE COM_KMESH   ,ONLY: NPNT,PNT,IPQARR,KCUT,WGT          !!! from tetra
      USE COM_WMESH   ,ONLY: NPNW,PNW,IPWARR,KCUW              !!! from tetra
      USE COM_INPTTR  ,ONLY: NDIV,NDIC,NDIW                    !!! from readini
      USE COM_FREQU   ,ONLY: OMGOPT                            !!! from readini
	USE COM_OPTMAT  ,ONLY: WGTOPT                            !!! from opttet
	USE COM_FERMI   ,ONLY: EF                                !!! from bzint
	USE COM_ENERGY  ,ONLY: EARR,EARW,WTOS,WDOS               !!! from bands
      USE COM_MASHDEP ,ONLY: LENCMP,NVAL                       !!! from readini
      USE COM_LMTOUT  ,ONLY: SCRFILE                           !!! from readini
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT                       !!! from setup
C  SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER KTQ(4),KT(4),KTT(4),KGG(4),KTW(4)
      DIMENSION REC(3,3),PKT(3,4),PKW(3,4),CRW(3,4),QWGT(4,3)
     &   ,E(4),H(4),WGTQ(4),AT(4),AD(4),ADS(4,2),ATS(4,2)
     &   ,PQT(3,4),VK(3),VQ(3)
	LOGICAL EXIST,LNEG,LPOS
	DATA PI/3.141592653589793D0/,NODEBUG/0/,EPS/1.D-10/
C  MEMORY ALLOCATIONS
C  none
	DO IBNDS=1,NSPIN
	DO IBNDT=1,NBNDT(1)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	DO IBNDS1=1,NSPIN
	DO IBNDT1=1,NBNDT(1)
	IBAND1=IBNDS1+NSPIN*(IBNDT1-1)
C  WEIGHTS FOR THE IMAGINARY PART
	WGTOPT(IBAND,IBAND1)=0.D0
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C------------------------------------------------------------
C  DO OVER WHOLE BRILLOUIN ZONE REPRESENTED BY MICROCELLS AND 
C  INTEGRATE OVER THE TETRAHEDRA
C------------------------------------------------------------
	VOLIBZ=1.D0
      OT=1.D0/DBLE(NDIV(1)*NDIV(2)*NDIV(3))/6.D0
      OW=1.D0/DBLE(NDIW(1)*NDIW(2)*NDIW(3))/6.D0
	DO 4200 I3=0,NDIV(3)-1               !!! over cells along G3
	DO 4200 I2=0,NDIV(2)-1               !!! over cells along G2
	DO 4200 I1=0,NDIV(1)-1               !!! over cells along G1
C  THE MICROCELL IS SET UP BY I1,I2,I3
C  SET UP TETRAHEDRA INSIDE MICROCELL
	DO 4100 ITTR=1,6                    !!! over tetrahedra
	DO I=1,4
C  COORDINATES OF THE TETRAHEDRON AGE GIVEN BY KTT, SHIFTED - BY KTT1
	J1=I1+KCUT(1,I,ITTR)
	J2=I2+KCUT(2,I,ITTR)
	J3=I3+KCUT(3,I,ITTR)
	KTT(I)=IPQARR(J1,J2,J3)
	KGG(I)=1
	ENDDO
C  TWO TETRAHEDRA FOUND, DEFINE CASE
	DO I=1,4
	KT(I)=0
	ENDDO
	DO I=1,4
	IF(KT(I).EQ.0)THEN
	KT(I)=I
	DO J=I+1,4
      IF(KTT(I).EQ.KTT(J).AND.KGG(I).EQ.KGG(J).AND.KT(J).EQ.0)KT(J)=I  
	ENDDO
	ENDIF
	ENDDO
C  CHECK IF THE POINT "IPNT" IS WITHIN THE TETRAHEDRON
	IHERE=0
	DO I=1,4
	IF(KTT(I).EQ.IPNT)IHERE=1
	ENDDO
	IF(IHERE.EQ.0)GOTO 4100
C  SET UP POINTS "K" DESCRIBING TETRAHEDRON IN THE SPACE
      DO I=1,4
      J1=I1+KCUT(1,I,ITTR)
      J2=I2+KCUT(2,I,ITTR)
      J3=I3+KCUT(3,I,ITTR)
      PKT(1,I)=(J1*AKBAS(1,1,1)+
     &          J2*AKBAS(1,2,1)+
     &          J3*AKBAS(1,3,1))*2.D0*PI/PAR
      PKT(2,I)=(J1*AKBAS(2,1,1)+
     &          J2*AKBAS(2,2,1)+
     &          J3*AKBAS(2,3,1))*2.D0*PI/PAR
      PKT(3,I)=(J1*AKBAS(3,1,1)+
     &          J2*AKBAS(3,2,1)+
     &          J3*AKBAS(3,3,1))*2.D0*PI/PAR
	ENDDO
C  SHIFT COORDINATE SYSTEM TO THE FIRST POINT
      DO I=2,4
      PKT(1,I)=PKT(1,I)-PKT(1,1)
      PKT(2,I)=PKT(2,I)-PKT(2,1)
      PKT(3,I)=PKT(3,I)-PKT(3,1)
	ENDDO
C  SET RECIPROCALS "REC" TO "PKT"
      CALL CROSS(REC(1,1),PKT(1,3),PKT(1,4))
      CALL CROSS(REC(1,2),PKT(1,4),PKT(1,2))
      CALL CROSS(REC(1,3),PKT(1,2),PKT(1,3))
      W=REC(1,1)*PKT(1,2)+REC(2,1)*PKT(2,2)+REC(3,1)*PKT(3,2)
      IF(ABS(W).LE.1.D-10)
     &CALL FULLSTOP('<OPTTET>:: INTERNAL ERROR: W=0')
      DO I=1,3
      REC(I,1)=REC(I,1)/W
      REC(I,2)=REC(I,2)/W
      REC(I,3)=REC(I,3)/W
	ENDDO
C--------------------------------------------
C  DO OVER DIVISIONS OF THE MICROCELL
C--------------------------------------------
      DO 3200 ID3=0,NDIW(3)/NDIV(3)-1
      DO 3200 ID2=0,NDIW(2)/NDIV(2)-1
      DO 3200 ID1=0,NDIW(1)/NDIV(1)-1
C  THE SMALL MICROCELL IS SET UP BY IW1,IW2,IW3
      IW1=I1*NDIW(1)/NDIV(1)+ID1
      IW2=I2*NDIW(2)/NDIV(2)+ID2
      IW3=I3*NDIW(3)/NDIV(3)+ID3
C  SET UP SMALL TETRAHEDRON INSIDE SMALL MICROCELL
      DO 3100 ITTRD=1,6
      DO I=1,4
      JW1=IW1+KCUT(1,I,ITTRD)
      JW2=IW2+KCUT(2,I,ITTRD)
      JW3=IW3+KCUT(3,I,ITTRD)
      KTW(I)=IPWARR(JW1,JW2,JW3)
	KTQ(I)=IPWARR(JW1,JW2,JW3)
	ENDDO
C  SET UP POINTS K DESCRIBING SMALL TETRAHEDRON IN THE SPACE
      DO I=1,4
      JW1=IW1+KCUT(1,I,ITTRD)
      JW2=IW2+KCUT(2,I,ITTRD)
      JW3=IW3+KCUT(3,I,ITTRD)
      PKW(1,I)=(JW1*AKBAS(1,1,3)+
     &          JW2*AKBAS(1,2,3)+
     &          JW3*AKBAS(1,3,3))*2.D0*PI/PAR
      PKW(2,I)=(JW1*AKBAS(2,1,3)+
     &          JW2*AKBAS(2,2,3)+
     &          JW3*AKBAS(2,3,3))*2.D0*PI/PAR
      PKW(3,I)=(JW1*AKBAS(3,1,3)+
     &          JW2*AKBAS(3,2,3)+
     &          JW3*AKBAS(3,3,3))*2.D0*PI/PAR
	ENDDO
C  SHIFT COORDINATE SYSTEM TO THE FIRST POINT
      DO I=1,4
      PKW(1,I)=PKW(1,I)-PKT(1,1)
      PKW(2,I)=PKW(2,I)-PKT(2,1)
      PKW(3,I)=PKW(3,I)-PKT(3,1)
      PQT(1,I)=PKW(1,I)
      PQT(2,I)=PKW(2,I)
      PQT(3,I)=PKW(3,I)
	ENDDO
C  CHECK WHETHER A SMALL TETRAHEDRON "PKW" IS INSIDE  TETRAHEDRON "PKT"
      DO I=1,4
      X1=PKW(1,I)*REC(1,1)+PKW(2,I)*REC(2,1)+PKW(3,I)*REC(3,1)
      X2=PKW(1,I)*REC(1,2)+PKW(2,I)*REC(2,2)+PKW(3,I)*REC(3,2)
      X3=PKW(1,I)*REC(1,3)+PKW(2,I)*REC(2,3)+PKW(3,I)*REC(3,3)
      IF(.NOT.((X1.GE.-EPS.AND.X1.LE.1.D0+EPS).AND.
     &         (X2.GE.-EPS.AND.X2.LE.1.D0+EPS).AND.
     &         (X3.GE.-EPS.AND.X3.LE.1.D0+EPS).AND.
     &         (X1+X2+X3.LE.1.D0+EPS)))GOTO3100
      CRW(1,I)=X1
      CRW(2,I)=X2
      CRW(3,I)=X3
	ENDDO
C---------------------------------------------
C  CALCULATE CONTRIBUTIONS FOR THESE POINTS
C---------------------------------------------
	IPAN=1
C  START LOOPING OVER BANDS
	DO 2200 IBNDS=1,NSPIN                 !!! over spin subbands
	DO 2100 IBNDT=1,NBNDF(1)              !!! over all bands
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	DO I=1,4
	E(I)=EARW(IBAND,KTW(I),1)             !!! E(k,js)
	ENDDO
	DO 1200 IBNDS1=1,NSPIN                !!! over spin subbands
	DO 1100 IBNDT1=NBNDE(1),NBNDT(1)      !!! over bands
	IBAND1=IBNDS1+NSPIN*(IBNDT1-1)
	IF(NORBS.EQ.1.AND.IBNDS1.NE.IBNDS)GOTO 1100 ! skip spin-flip transitions
	DIF=0.D0
	DO I=1,4
	H(I)=EARW(IBAND1,KTQ(I),1)            !!! E(k,j's')
	DIF=DIF+ABS(E(I)-H(I)+OMGOPT(IOMG))
	ENDDO
C  CHECK WHETHER THE ENERGIES AT THE CORNERS COINCIDE
      DIF=0.D0
      DO I=1,4
      DIF=DIF+ABS(E(I)-H(I)+OMGOPT(IOMG))
      ENDDO
C  CHECK WHETHER TRANSITION IS ALLOWED
      LNEG=.FALSE.
      LPOS=.FALSE.
      DO I=1,4
      IF(E(I)-H(I)+OMGOPT(IOMG).LE.0.D0)LNEG=.TRUE.
      IF(E(I)-H(I)+OMGOPT(IOMG).GE.0.D0)LPOS=.TRUE.
      ENDDO
      IF(ABS(DIF).GT.1.D-05.AND.LNEG.AND.LPOS.AND.
     &ABS(OMGOPT(IOMG)).GE.1.D-10)THEN
C  ENERGIES ARE DIFFERENT, SET UP WEIGHTS
      CALL MOHEAD(E,H,EF,OMGOPT(IOMG),OW,QWGT)
      DO IT=1,4
	IF(IPNT.NE.KTT(IT))CYCLE
      DO I=1,4
      IF(IT.EQ.1)WF=1.D0-CRW(1,I)-CRW(2,I)-CRW(3,I)
      IF(IT.NE.1)WF=CRW(IT-1,I)
      WGTOPT(IBAND,IBAND1)=WGTOPT(IBAND,IBAND1)+
     &QWGT(I,1)*WF                          !!! f(kj)*[1-f(kj')]
      ENDDO
      ENDDO
      ENDIF
1100  CONTINUE                                  !!! over bands
1200  CONTINUE                                  !!! over spin subbands
2100  CONTINUE                                  !!! over bands
2200  CONTINUE                                  !!! over spin subbands
3100  CONTINUE                                  !!! over small tetrahedra
3200  CONTINUE                                  !!! over small microcells
4100  CONTINUE                                  !!! over tetrahedra
4200  CONTINUE                                  !!! over microcells
C  NORMALIZATION
	DO IBNDS=1,NSPIN
	DO IBNDT=1,NBNDT(1)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	DO IBNDS1=1,NSPIN
	DO IBNDT1=1,NBNDT(1)
	IBAND1=IBNDS1+NSPIN*(IBNDT1-1)
	WGTOPT(IBAND,IBAND1)=WGTOPT(IBAND,IBAND1)/
     &VOLIBZ*2.D0/DBLE(NSPIN)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	RETURN
	END
