	SUBROUTINE PHN_CTRLINF
************************************************************
*  <CTRLINF> checks control strings                        *
************************************************************
C SET EXTERNAL CONNECTIONS
	USE COM_CONTROL   ,ONLY : MODE                          !!! from ctrlinf
      USE COM_LMTINP    ,ONLY : INPINFO,RUNMODE               !!! from artinp
	USE COM_LRTCOM    ,ONLY : QVECTOR,RUNTASK,IRMT          !!! from ctrlinf
	USE COM_UNIT      ,ONLY : IUT                           !!! from setup
	USE COM_EXTENS                                          !!! from setup
	USE COM_PHNEXT                                          !!! from setup
C SET LOCAL VARIBLES
	IMPLICIT REAL*8 (A-H,O-Z)
	CHARACTER UN(100)*2,INF*130,INM*130
      LOGICAL PRESENT
C RECOGNIZE INPINFO
      CALL LIB_CONVLOW(INPINFO,130)
      CALL LIB_RMBLANK(INPINFO,130)
	DO IPOS=1,130
	INF(IPOS:IPOS)=' '
	INM(IPOS:IPOS)=' '
	ENDDO
      IF(INF(1:1).EQ.' ')INF=INPINFO
      IF(INF(1:1).EQ.' ')INF='Error: Blank INPINFO String!'
	INM=INF !!! Save translated string
C CHECK REGISTRED DATA TYPES
	CALL SUBSTR_IN_STR(PRESENT,INF,130,EXTNINI,LENEXTN)
	CALL SUBSTR_IN_STR(PRESENT,INF,130,EXTNSTR,LENEXTN)
	CALL SUBSTR_IN_STR(PRESENT,INF,130,EXTNSCS,LENEXTN)
	CALL SUBSTR_IN_STR(PRESENT,INF,130,EXTNHUB,LENEXTN)
	CALL SUBSTR_IN_STR(PRESENT,INF,130,EXTNLRT,LENEXTN)
	CALL SUBSTR_IN_STR(PRESENT,INF,130,EXTNPNT,LENEXTN)
C CHECK ERRORS
	IERR=0
	DO IPOS=1,130
	IF(INF(IPOS:IPOS).NE.'+'.AND.INF(IPOS:IPOS).NE.' ')IERR=1
	ENDDO
	IF(IERR.EQ.1)THEN
	WRITE(IUT,*)'Terminated in <CTRLINF>:'
	WRITE(IUT,*)'INPINFO string contains errors.'
	WRITE(IUT,*)'INPINFO string read      :',INPINFO
	WRITE(IUT,*)'INPINFO string translated:',INF
	CALL FULLSTOP(' ')
	ENDIF
C RESET INPINFO STRING NOW
	INPINFO=INM
C ***************************************************************
C RECOGNIZE RUNNING MODE
C       =0 - preparational, 1 - full start, 2 - restart, 3 - update restart
C       =4 - dynamical matrix, =5 - electron-phonon interaction
C       =51- rigid muffin-tin part of the electron-phonon interaction
      CALL LIB_RMBLANK(RUNMODE,130)
      CALL LIB_CONVLOW(RUNMODE,130)
	MODE=-1
	IRMT=0
	IF(RUNMODE(1:6).EQ.'prelim')MODE=0
      IF(RUNMODE(1:6).EQ.'fstart')MODE=1
      IF(RUNMODE(1:6).EQ.'rstart')MODE=2
      IF(RUNMODE(1:6).EQ.'update')MODE=3
      IF(RUNMODE(1:6).EQ.'dynmat')MODE=4
      IF(RUNMODE(1:6).EQ.'epimat')MODE=5
      IF(RUNMODE(1:6).EQ.'rmtmat')MODE=5
      IF(RUNMODE(1:6).EQ.'rmtmat')IRMT=1
	IF(MODE.EQ.-1)CALL FULLSTOP('RUNMODE string not recognized!')
C RECOGNIZE Q-VECTOR AND RUNTASK
	DO IPOS=1,10
	QVECTOR(IPOS:IPOS)=' '
	ENDDO
	DO IPOS=1,60
	RUNTASK(IPOS:IPOS)=' '
	ENDDO
	DO IPOS1=1,130
	IF(RUNMODE(IPOS1:IPOS1).EQ.'+')EXIT
	ENDDO
	DO IPOS2=IPOS1+1,130
	IF(RUNMODE(IPOS2:IPOS2).EQ.'+')EXIT
	ENDDO
	IVEC=0
	DO IPOS=IPOS1+1,IPOS2-1
	IVEC=IVEC+1
	IF(IVEC.GT.10)CALL FULLSTOP('Too large string Qvector!')
	QVECTOR(IVEC:IVEC)=RUNMODE(IPOS:IPOS)
	ENDDO
	IF(IVEC.EQ.0)CALL FULLSTOP('String Qvector not found!')
	ITSK=0
	DO IPOS=IPOS2+1,130
	ITSK=ITSK+1
	IF(RUNMODE(IPOS:IPOS).EQ.' ')EXIT
	IF(ITSK.GT.60)CALL FULLSTOP('Too large string RunTask!')
	RUNTASK(ITSK:ITSK)=RUNMODE(IPOS:IPOS)
	ENDDO
	IF(ITSK.EQ.0)CALL FULLSTOP('String RunTask not found!')
	END SUBROUTINE PHN_CTRLINF
