	SUBROUTINE PHN_DELTET(IQPNT)
*****************************************************************
*  Calculate weight function for the integration over BZ        *
*  the following susceptibility like expressions:               *
*                                                               *
*  ___    /  3    f(Ef-E(kj))*(1-f(Ef-E(k+qj'))                 *
*  >      \ d k   -----------------------------  R(k,k+q,jj')   *
*  ---    /             E(kj)-E(k+qj")            LL't          *
*  jj'     BZ                                                   *
*                                                               *
*  ___    /  3                                                  *
*  >      \ d k   f(Ef-E(kj))*f(Ef-E(k+qj') R(k,k+q,jj')        *
*  ---    /                                  LL't               *
*  jj'     BZ                                                   *
*                                                               *
*  where f(x) are occupation numbers and R are some matrix      *
*  elements. Tetrahedron method is used.                        *
*****************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                 !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                    !!! from readini
	USE COM_PARAM,   ONLY : NSPIN,NORBS                            !!! from readini
	USE COM_LATTICE, ONLY : RBAS,GBAS,AKBAS                        !!! from init
	USE COM_LATPAR,  ONLY : PAR,ORTH,OMEGAC                        !!! from readini
	USE COM_KAPPAR,  ONLY : NPAN                                   !!! from readini
	USE COM_NBANDS,  ONLY : NBNDF,NBNDE,NBNDT,NBNDC,NBNDH,POLUS    !!! from readini
	USE COM_INPTTR,  ONLY : NDIV,NDIW                              !!! from readini
	USE COM_KMESH,   ONLY : NPNT,PNT,WGT,KCUT,IPQARR               !!! from makettr
	USE COM_ENERGY,  ONLY : ETRT,ETRW,WTRT,WDRT                    !!! from lmtbnd
	USE COM_LRTCOM,  ONLY : LWHI                                   !!! from readlrt
	USE COM_SYMMESW, ONLY : IG0IGW=>IG0IG1,IK0IKW=>IK0IK1          !!! from delmesw
	USE COM_SYMMESH, ONLY : IG0IG1,IK0IK1                          !!! from delmesh
      USE COM_WMESH,   ONLY : NPNW,PNW,KCUW,IPWARR,IGWARR            !!! from makettr
	USE COM_QMESH,   ONLY : NQPNT,QPNT                             !!! from readpnt
	USE COM_SUBGROUP,ONLY : NSGQ,NGEQ,ISG,KSYMPN,MSYMPN,IGS        !!! from delmesh
	USE COM_FERMI,   ONLY : EF                                     !!! from ttrint1
	USE COM_GROUPS,  ONLY : NGROUP,INV,IKOV                        !!! from makegrp
	USE COM_MASHDEP, ONLY : NVAL                                   !!! from setup
	USE COM_PHNCHN  ,ONLY : IUTTR,IUTTW                            !!! from channels
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                        !!! from setup
	USE COM_LMTOUT
	USE COM_PHNOUT
	IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER KTQ(4),KT(4),KTT(4),KGG(4),KTW(4)
	CHARACTER*130 FILE
	LOGICAL EXIST
	REAL*8, ALLOCATABLE :: WEIGQ(:,:,:,:)
	REAL*8, ALLOCATABLE :: WEIGK(:,:,:)
	REAL*8, ALLOCATABLE :: WTST(:,:)
	REAL*8, ALLOCATABLE :: CHIQ(:,:,:)
	DIMENSION AT(4),AD(4),REC(3,3)
     &   ,ADS(4,2),ATS(4,2),E(4),H(4),WGTQ(4)
     &   ,QWGT(4,3),PKT(3,4),PKW(3,4),CRW(3,4)
	DATA PI/3.141592653589793D0/,NODEBUG/0/,EPS/1.D-10/
	IF(LWHI.NE.1)RETURN
C Memory allocations
	ALLOCATE(WEIGQ(NBNDC(1)*NSPINMEM,NBNDC(1)*NSPINMEM,6,4))
	ALLOCATE(WEIGK(NBNDC(1)*NSPINMEM,4,4))
	ALLOCATE(WTST(6,NBNDC(1)*NSPINMEM+1))
	ALLOCATE(CHIQ(NBNDC(1)*NSPINMEM,NBNDC(1)*NSPINMEM,8))
C  GET INFORMATION ABOUT THE FILE
	IF(ICWGT.NE.0)FILE=WGTFILE(LWHI)
	IF(ICWGT.EQ.0)FILE=SCRFILE(IUTTW)
	IF(ICWGT.EQ.2)GOTO 5000
      NRECL=NVAL/2+NVAL/2*NBNDC(1)**2*6
	NRECL=NVAL/2*NBNDC(1)*4+NRECL
	NRECL=MAX(NRECL,NVAL/2*12)
      OPEN(UNIT=IUTTW,FILE=FILE,STATUS='NEW',
     &  FORM='UNFORMATTED',ACCESS='DIRECT',RECL=NRECL)
	WRITE(IUTTW,REC=1)NRECL,NDIV(1),NDIV(2),NDIV(3),NPNT(1),
     &NBNDF(1),NBNDE(1),NBNDT(1),NBNDH(1),NSPIN,NORBS,LWHI,POLUS
C  OPEN SCRATCH FILE FOR FAST ACCESS
      OPEN(UNIT=IUTTR,FILE=SCRFILE(IUTTR),STATUS='NEW',
     &  FORM='UNFORMATTED',ACCESS='DIRECT',RECL=NRECL)
	WRITE(IUTTR,REC=1)NRECL,NDIV(1),NDIV(2),NDIV(3),NPNT(1),
     &NBNDF(1),NBNDE(1),NBNDT(1),NBNDH(1),NSPIN,NORBS,LWHI,POLUS
C  INITIALLY SET WEIGHTS FOR ALL POINTS TO ZERO
	DO ISGQ=1,NSGQ
	DO IPNT=1,NPNT(1)
	WGTQ(1)=0.D0
	DO IBNDS1=1,NSPIN
	DO IBNDC1=1,NBNDC(1)
	IBANC1=IBNDS1+NSPIN*(IBNDC1-1)
	DO IC=1,4
	WEIGK(IBANC1,IC,1)=0.D0
	ENDDO
	DO IBNDS=1,NSPIN
	DO IBNDC=1,NBNDC(1)
	IBANC=IBNDS+NSPIN*(IBNDC-1)
	DO IC=1,6
	WEIGQ(IBANC,IBANC1,IC,1)=0.D0
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	IREC=1+IPNT+NPNT(1)*(ISGQ-1)
	WRITE(IUTTR,REC=IREC)WGTQ(1),
     &(((WEIGQ(IBANC,IBANC1,IC,1),IBANC=1,NBNDC(1)*NSPIN),
     &IBANC1=1,NBNDC(1)*NSPIN),IC=1,6),
     &((WEIGK(IBANC,IC,1),IBANC=1,NBNDC(1)*NSPIN),IC=1,4)
	ENDDO
	ENDDO
C  DO OVER WHOLE BRILLOUIN ZONE REPRESENTED BY MICROCELLS AND 
C  INTEGRATE OVER THE TETRAHEDRA
	VOLIBZ=1.D0
      OT=1.D0/DBLE(NDIV(1)*NDIV(2)*NDIV(3))/6.D0
      OW=1.D0/DBLE(NDIW(1)*NDIW(2)*NDIW(3))/6.D0
	DO 4200 I3=0,NDIV(3)-1               !!! over cells along G3
	DO 4200 I2=0,NDIV(2)-1               !!! over cells along G2
	DO 4200 I1=0,NDIV(1)-1               !!! over cells along G1
C  THE MICROCELL IS SET UP BY I1,I2,I3
C  SET UP TETRAHEDRA INSIDE MICROCELL
	DO 4100 ITTR=1,6                    !!! over tetrahedra
	DO I=1,4
C  COORDINATES OF THE TETRAHEDRON AGE GIVEN BY KTT, SHIFTED - BY KTT1
	J1=I1+KCUT(1,I,ITTR)
	J2=I2+KCUT(2,I,ITTR)
	J3=I3+KCUT(3,I,ITTR)
	KTT(I)=IPQARR(J1,J2,J3)
	KGG(I)=IGS(J1,J2,J3)
	ENDDO
C  TWO TETRAHEDRA FOUND, DEFINE CASE
	DO I=1,4
	KT(I)=0
	ENDDO
	DO I=1,4
	IF(KT(I).EQ.0)THEN
	KT(I)=I
	DO J=I+1,4
      IF(KTT(I).EQ.KTT(J).AND.KGG(I).EQ.KGG(J).AND.KT(J).EQ.0)KT(J)=I  
	ENDDO
	ENDIF
	ENDDO
C  READ WEIGHTS FOR THE POINTS
	DO I=4,1,-1 !!! looping backwards to avoid a bug in shit IBM compiler
	IPNT=KTT(I)
	ISGQ=KGG(I)
	IREC=1+IPNT+NPNT(1)*(ISGQ-1)
	READ(IUTTR,REC=IREC)WGTQ(KT(I)),
     &(((WEIGQ(IBANC,IBANC1,IC,KT(I)),IBANC=1,NBNDC(1)*NSPIN),
     &IBANC1=1,NBNDC(1)*NSPIN),IC=1,6),
     &((WEIGK(IBANC,IC,KT(I)),IBANC=1,NBNDC(1)*NSPIN),IC=1,4)
	ENDDO
C  SET GEOMETRICAL WEIGHT
	DO I=1,4
	WGTQ(KT(I))=WGTQ(KT(I))+OT/4.D0       !!! geometrical weight f(kj)=1
	ENDDO
C  SET UP POINTS "K" DESCRIBING TETRAHEDRON IN THE SPACE
      DO I=1,4
      J1=I1+KCUT(1,I,ITTR)
      J2=I2+KCUT(2,I,ITTR)
      J3=I3+KCUT(3,I,ITTR)
      PKT(1,I)=(J1*AKBAS(1,1,1)+
     &          J2*AKBAS(1,2,1)+
     &          J3*AKBAS(1,3,1))*2.D0*PI/PAR
      PKT(2,I)=(J1*AKBAS(2,1,1)+
     &          J2*AKBAS(2,2,1)+
     &          J3*AKBAS(2,3,1))*2.D0*PI/PAR
      PKT(3,I)=(J1*AKBAS(3,1,1)+
     &          J2*AKBAS(3,2,1)+
     &          J3*AKBAS(3,3,1))*2.D0*PI/PAR
	ENDDO
C  SHIFT COORDINATE SYSTEM TO THE FIRST POINT
      DO I=2,4
      PKT(1,I)=PKT(1,I)-PKT(1,1)
      PKT(2,I)=PKT(2,I)-PKT(2,1)
      PKT(3,I)=PKT(3,I)-PKT(3,1)
	ENDDO
C  SET RECIPROCALS "REC" TO "PKT"
      CALL CROSS(REC(1,1),PKT(1,3),PKT(1,4))
      CALL CROSS(REC(1,2),PKT(1,4),PKT(1,2))
      CALL CROSS(REC(1,3),PKT(1,2),PKT(1,3))
      W=REC(1,1)*PKT(1,2)+REC(2,1)*PKT(2,2)+REC(3,1)*PKT(3,2)
      IF(ABS(W).LE.1.D-10)
     &CALL FULLSTOP('<DELTET>:: INTERNAL ERROR: W=0')
      DO I=1,3
      REC(I,1)=REC(I,1)/W
      REC(I,2)=REC(I,2)/W
      REC(I,3)=REC(I,3)/W
	ENDDO
C  DO OVER DIVISIONS OF THE MICROCELL
      DO 3200 ID3=0,NDIW(3)/NDIV(3)-1
      DO 3200 ID2=0,NDIW(2)/NDIV(2)-1
      DO 3200 ID1=0,NDIW(1)/NDIV(1)-1
C  THE SMALL MICROCELL IS SET UP BY IW1,IW2,IW3
      IW1=I1*NDIW(1)/NDIV(1)+ID1
      IW2=I2*NDIW(2)/NDIV(2)+ID2
      IW3=I3*NDIW(3)/NDIV(3)+ID3
C  SET UP SMALL TETRAHEDRON INSIDE SMALL MICROCELL
      DO 3100 ITTRD=1,6
      DO I=1,4
      JW1=IW1+KCUT(1,I,ITTRD)
      JW2=IW2+KCUT(2,I,ITTRD)
      JW3=IW3+KCUT(3,I,ITTRD)
      KTW(I)=IPWARR(JW1,JW2,JW3)
	KTQ(I)=IK0IKW(KTW(I),IGWARR(JW1,JW2,JW3))
	ENDDO
C  SET UP POINTS K DESCRIBING SMALL TETRAHEDRON IN THE SPACE
      DO I=1,4
      JW1=IW1+KCUT(1,I,ITTRD)
      JW2=IW2+KCUT(2,I,ITTRD)
      JW3=IW3+KCUT(3,I,ITTRD)
C     PKW(1,I)=(JW1*QW(1,1)+JW2*QW(1,2)+JW3*QW(1,3))*2.D0*PI/PAR
C     PKW(2,I)=(JW1*QW(2,1)+JW2*QW(2,2)+JW3*QW(2,3))*2.D0*PI/PAR
C     PKW(3,I)=(JW1*QW(3,1)+JW2*QW(3,2)+JW3*QW(3,3))*2.D0*PI/PAR
      PKW(1,I)=(JW1*AKBAS(1,1,3)+
     &          JW2*AKBAS(1,2,3)+
     &          JW3*AKBAS(1,3,3))*2.D0*PI/PAR
      PKW(2,I)=(JW1*AKBAS(2,1,3)+
     &          JW2*AKBAS(2,2,3)+
     &          JW3*AKBAS(2,3,3))*2.D0*PI/PAR
      PKW(3,I)=(JW1*AKBAS(3,1,3)+
     &          JW2*AKBAS(3,2,3)+
     &          JW3*AKBAS(3,3,3))*2.D0*PI/PAR
	ENDDO
C  SHIFT COORDINATE SYSTEM TO THE FIRST POINT
      DO I=1,4
      PKW(1,I)=PKW(1,I)-PKT(1,1)
      PKW(2,I)=PKW(2,I)-PKT(2,1)
      PKW(3,I)=PKW(3,I)-PKT(3,1)
	ENDDO
C  CHECK WHETHER A SMALL TETRAHEDRON "PKW" IS INSIDE  TETRAHEDRON "PKT"
      DO I=1,4
      X1=PKW(1,I)*REC(1,1)+PKW(2,I)*REC(2,1)+PKW(3,I)*REC(3,1)
      X2=PKW(1,I)*REC(1,2)+PKW(2,I)*REC(2,2)+PKW(3,I)*REC(3,2)
      X3=PKW(1,I)*REC(1,3)+PKW(2,I)*REC(2,3)+PKW(3,I)*REC(3,3)
      IF(.NOT.((X1.GE.-EPS.AND.X1.LE.1.D0+EPS).AND.
     &         (X2.GE.-EPS.AND.X2.LE.1.D0+EPS).AND.
     &         (X3.GE.-EPS.AND.X3.LE.1.D0+EPS).AND.
     &         (X1+X2+X3.LE.1.D0+EPS)))GOTO3100
      CRW(1,I)=X1
      CRW(2,I)=X2
      CRW(3,I)=X3
	ENDDO
C  CALCULATE CONTRIBUTIONS FOR THESE POINTS
	DO 2200 IBNDS=1,NSPIN                  !!! over spin subbands
	IBNDC=0
	DO 2100 IBNDT=NBNDE(1),NBNDF(1)        !!! over bands at EF
	IBNDC=IBNDC+1
	IBANC=IBNDS+NSPIN*(IBNDC-1)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	DO I=1,4
	E(I)=ETRW(IBAND,KTW(I),1)             !!! E(k,j)
	H(I)=ETRW(IBAND,KTQ(I),1)             !!! E(g*k+q,j)
	ENDDO
      CALL TTR_MCTTRINT0(E,EF,OW,AT,AD,TS,DS,'B','W')
      DO IT=1,4
      DO I=1,4
      IF(IT.EQ.1)WF=1.D0-CRW(1,I)-CRW(2,I)-CRW(3,I)
      IF(IT.NE.1)WF=CRW(IT-1,I)
      WEIGK(IBANC,1,KT(IT))=WEIGK(IBANC,1,KT(IT))+AT(I)*WF !!! weight f(kj)
      WEIGK(IBANC,3,KT(IT))=WEIGK(IBANC,3,KT(IT))+AD(I)*WF !!! weight d(kj)
	ENDDO
	ENDDO
      CALL TTR_MCTTRINT0(H,EF,OW,AT,AD,TS,DS,'B','W')
      DO IT=1,4
      DO I=1,4
      IF(IT.EQ.1)WF=1.D0-CRW(1,I)-CRW(2,I)-CRW(3,I)
      IF(IT.NE.1)WF=CRW(IT-1,I)
      WEIGK(IBANC,2,KT(IT))=WEIGK(IBANC,2,KT(IT))+AT(I)*WF !!! weight f(k+qj')
      WEIGK(IBANC,4,KT(IT))=WEIGK(IBANC,4,KT(IT))+AD(I)*WF !!! weight d(k+qj')
	ENDDO
	ENDDO
	DO 1200 IBNDS1=1,NSPIN                 !!! over spin subbands
	IBNDC1=0
	DO 1100 IBNDT1=NBNDE(1),NBNDF(1)       !!! over bands at EF
	IBNDC1=IBNDC1+1
	IBANC1=IBNDS1+NSPIN*(IBNDC1-1)
	IBAND1=IBNDS1+NSPIN*(IBNDT1-1)
	DIF=0.D0
	DO I=1,4
	H(I)=ETRW(IBAND1,KTQ(I),1)            !!! E(g*k+q,j')
	DIF=DIF+ABS(H(I)-E(I))
	ENDDO
C  CHECK WHETHER THE ENERGIES AT THE CORNERS COINSIDE
	IF(ABS(DIF).GT.1.D-05)THEN
C  ENERGIES ARE DIFFERENT, SET UP WEIGHTS FOR 1/[E(k,j)-E(g*k+q,j')]
	CALL CHI_MCHEAD(E,H,EF,0.D0,OW,QWGT)
      DO IT=1,4
      DO I=1,4
	WE=(E(I)-H(I))**2/((E(I)-H(I))**2+POLUS**2)
      IF(IT.EQ.1)WF=1.D0-CRW(1,I)-CRW(2,I)-CRW(3,I)
      IF(IT.NE.1)WF=CRW(IT-1,I)
	WEIGQ(IBANC,IBANC1,1,KT(IT))=WEIGQ(IBANC,IBANC1,1,KT(IT))+
     &  QWGT(I,1)*WF                          !!! f(kj)*[1-f(k+qj')]
	WEIGQ(IBANC,IBANC1,2,KT(IT))=WEIGQ(IBANC,IBANC1,2,KT(IT))+
     &  QWGT(I,2)*WF                          !!! [1-f(kj)]*f(k+qj')
	WEIGQ(IBANC,IBANC1,5,KT(IT))=WEIGQ(IBANC,IBANC1,5,KT(IT))+
     &  QWGT(I,1)*WF*WE                       !!! f(kj)*[1-f(k+qj')]
	WEIGQ(IBANC,IBANC1,6,KT(IT))=WEIGQ(IBANC,IBANC1,6,KT(IT))+
     &  QWGT(I,2)*WF*WE                       !!! [1-f(kj)]*f(k+qj')
	ENDDO
	ENDDO
	ELSE
C  ENERGIES ARE THE SAME, WEIGHTS ARE JUST DENSITY OF STATES
      CALL TTR_MCTTRINT0(E,EF,OW,ATS(1,1),ADS(1,1),TS,DS,'B','W')
      CALL TTR_MCTTRINT0(H,EF,OW,ATS(1,2),ADS(1,2),TS,DS,'B','W')
      DO IT=1,4
      DO I=1,4
      IF(IT.EQ.1)WF=1.D0-CRW(1,I)-CRW(2,I)-CRW(3,I)
      IF(IT.NE.1)WF=CRW(IT-1,I)
	WEIGQ(IBANC,IBANC1,3,KT(IT))=WEIGQ(IBANC,IBANC1,3,KT(IT))-
     &  0.5D0*(ADS(I,1)+ADS(I,2))/2.D0*WF    !!! f(kj)*[1-f(k+qj')]=>-N(Ef)/2
	WEIGQ(IBANC,IBANC1,4,KT(IT))=WEIGQ(IBANC,IBANC1,4,KT(IT))+
     &  0.5D0*(ADS(I,1)+ADS(I,2))/2.D0*WF    !!! [1-f(kj)]*f(k+qj')=>+N(Ef)/2
	ENDDO
	ENDDO
	ENDIF
 1100 CONTINUE                             !!! over bands
 1200 CONTINUE                             !!! over bands
 2100 CONTINUE                             !!! over bands
 2200 CONTINUE                             !!! over bands
C  WRITE CONTRIBUTIONS BACK TO THE FILE
	DO I=1,4
	IPNT=KTT(I)
	ISGQ=KGG(I)
	IREC=1+IPNT+NPNT(1)*(ISGQ-1)
	WRITE(IUTTR,REC=IREC)WGTQ(KT(I)),
     &(((WEIGQ(IBANC,IBANC1,IC,KT(I)),IBANC=1,NBNDC(1)*NSPIN),
     &IBANC1=1,NBNDC(1)*NSPIN),IC=1,6),
     &((WEIGK(IBANC,IC,KT(I)),IBANC=1,NBNDC(1)*NSPIN),IC=1,4)
	ENDDO
 3100 CONTINUE                                  !!! over small tetrahedra
 3200 CONTINUE                                  !!! over small microcells
 4100 CONTINUE                                  !!! over tetrahedra
 4200 CONTINUE                                  !!! over microcells
C  NORMALIZATION
      TWGT=0.D0
	DO ISGQ=1,NSGQ                            !!! over star of the q-vector
	DO IPNT=1,NPNT(1)                         !!! over irreducible points
	IREC=1+IPNT+NPNT(1)*(ISGQ-1)
	READ(IUTTR,REC=IREC)WGTQ(1),
     &(((WEIGQ(IBANC,IBANC1,IC,1),IBANC=1,NBNDC(1)*NSPIN),
     &IBANC1=1,NBNDC(1)*NSPIN),IC=1,6),
     &((WEIGK(IBANC,IC,1),IBANC=1,NBNDC(1)*NSPIN),IC=1,4)
	WGTQ(1)=WGTQ(1)/VOLIBZ*2.D0/DBLE(NSPIN)
	TWGT=TWGT+WGTQ(1)
	DO IBNDS1=1,NSPIN
	DO IBNDC1=1,NBNDC(1)
	IBANC1=IBNDS1+NSPIN*(IBNDC1-1)
	DO IC=1,4
	WEIGK(IBANC1,IC,1)=WEIGK(IBANC1,IC,1)/VOLIBZ*2.D0/
     &DBLE(NSPIN)
	ENDDO
	DO IBNDS=1,NSPIN
	DO IBNDC=1,NBNDC(1)
	IBANC=IBNDS+NSPIN*(IBNDC-1)
	DO IC=1,6
	WEIGQ(IBANC,IBANC1,IC,1)=WEIGQ(IBANC,IBANC1,IC,1)/
     &VOLIBZ*2.D0/DBLE(NSPIN)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	IREC=1+IPNT+NPNT(1)*(ISGQ-1)
	WRITE(IUTTW,REC=IREC)WGTQ(1),
     &(((WEIGQ(IBANC,IBANC1,IC,1),IBANC=1,NBNDC(1)*NSPIN),
     &IBANC1=1,NBNDC(1)*NSPIN),IC=1,6),
     &((WEIGK(IBANC,IC,1),IBANC=1,NBNDC(1)*NSPIN),IC=1,4)
      ENDDO                                     !!! over irreducible points
      ENDDO                                     !!! over star of the q-vector
	CLOSE(IUTTR,STATUS='DELETE')
	CLOSE(IUTTW,STATUS='KEEP')
C  WEIGHT-FILE HAS BEEN CALCULATED, CHECK IT
 5000 INQUIRE(FILE=FILE,RECL=NRECL)
CWRONG  IF(WRONG)THEN                !!! wrong compiler option
      NRECL=NVAL
      OPEN(UNIT=IUTTW,FILE=FILE,STATUS='OLD',FORM='UNFORMATTED',
     &  ACCESS='DIRECT',RECL=NRECL)
      READ(IUTTW,REC=1)NRECL
      CLOSE(IUTTW)
CWRONG  ENDIF
	OPEN(UNIT=IUTTW,FILE=FILE,STATUS='OLD',
     &FORM='UNFORMATTED',ACCESS='DIRECT',RECL=NRECL)
	READ(IUTTW,REC=1)NRECL,N1,N2,N3,NPNT0,
     &	NBNDF0,NBNDE0,NBNDT0,NBNDH0,NSPIN0,NORBS0,LWHI0,POLUS0
	IF(N1.NE.NDIV(1).OR.N2.NE.NDIV(2).OR.N3.NE.NDIV(3))
     &CALL FULLSTOP('<DELTET> # of divisions mismatches in WGTFILE')
	IF(NPNT0.NE.NPNT(1))
     &CALL FULLSTOP('<DELTET> # of points mismatches in WGTFILE')
	IF(NBNDF0.NE.NBNDF(1))
     &CALL FULLSTOP('<DELTET> # of filled bands mismatches in WGTFILE')
	IF(NBNDE0.NE.NBNDE(1))
     &CALL FULLSTOP('<DELTET> # of empty bands mismatches in WGTFILE')
	IF(NBNDT0.NE.NBNDT(1))
     &CALL FULLSTOP('<DELTET> # of total bands mismatches in WGTFILE')
	IF(NBNDH0.NE.NBNDH(1))
     &CALL FULLSTOP('<DELTET> # of H bands mismatches in WGTFILE')
	IF(NSPIN0.NE.NSPIN)
     &CALL FULLSTOP('<DELTET> # of spins mismatches in WGTFILE')
	IF(NORBS0.NE.NORBS)
     &CALL FULLSTOP('<DELTET> SO-coupling mismatches in WGTFILE')
	IF(LWHI0.NE.1)
     &CALL FULLSTOP('<DELTET> Not Re(chi) stored in WGTFILE')
	IF(ABS(POLUS-POLUS0).GE.1.D-10)
     &CALL FULLSTOP('<DELTET>:: Poles mismatch in WGTFILE')
C  TEST WEIGHTS
	ERR1=0.D0
	ERR2=0.D0
	ERR3=0.D0
	ERR4=0.D0
	ERR5=0.D0
	ERR6=0.D0
	DO IPNT=1,NPNT(1)                         !!! over k-points
	DO IBNDS=1,NSPIN
	DO IBNDC=1,NBNDC(1)
	IBANC=IBNDS+NSPIN*(IBNDC-1)
	DO IC=1,6
	WTST(IC,IBANC)=0.D0
	ENDDO
	ENDDO
	ENDDO
	WTST(1,1)=0.D0
	WTST(2,1)=0.D0
	DO ISGQ=1,NSGQ                            !!! over q-star
	IREC=1+IPNT+NPNT(1)*(ISGQ-1)
	READ(IUTTW,REC=IREC)WGTQ(1),
     &(((WEIGQ(IBANC,IBANC1,IC,1),IBANC=1,NBNDC(1)*NSPIN),
     &IBANC1=1,NBNDC(1)*NSPIN),IC=1,6),
     &((WEIGK(IBANC,IC,1),IBANC=1,NBNDC(1)*NSPIN),IC=1,4)
	WTST(1,1)=WTST(1,1)+WGTQ(1)
	IF(KSYMPN(ISGQ,IPNT).LT.0)WTST(2,1)=WTST(2,1)+WGTQ(1)
	DO IBNDS=1,NSPIN
	DO IBNDC=1,NBNDC(1)
	IBANC=IBNDS+NSPIN*(IBNDC-1)
	WTST(3,IBANC)=WTST(3,IBANC)+WEIGK(IBANC,1,1)
	IF(KSYMPN(ISGQ,IPNT).LT.0)
     &WTST(4,IBANC)=WTST(4,IBANC)+WEIGK(IBANC,1,1)
	WTST(5,IBANC)=WTST(5,IBANC)+WEIGK(IBANC,3,1)
	IF(KSYMPN(ISGQ,IPNT).LT.0)
     &WTST(6,IBANC)=WTST(6,IBANC)+WEIGK(IBANC,3,1)
	ENDDO                                     !!! over bands
	ENDDO                                     !!! over bands
	ENDDO                                     !!! over q-star
	ERR1=MAX(ERR1,ABS(WTST(1,1)-WGT(IPNT,1)))
	ERR2=MAX(ERR2,ABS(WTST(2,1)))
	DO IBNDS=1,NSPIN
	DO IBNDC=1,NBNDC(1)
	IBANC=IBNDS+NSPIN*(IBNDC-1)
	IBNDT=IBNDC+NBNDE(1)-1
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	ERR3=MAX(ERR3,ABS(WTST(3,IBANC)-WTRT(IBAND,IPNT)))
	ERR4=MAX(ERR4,ABS(WTST(4,IBANC)))
	ERR5=MAX(ERR5,ABS(WTST(5,IBANC)-WDRT(IBAND,IPNT)))
	ERR6=MAX(ERR6,ABS(WTST(6,IBANC)))
	ENDDO                                     !!! over bands
	ENDDO                                     !!! over bands
	ENDDO                                     !!! over k-points
	IF(ERR1.GT.1.D-07)WRITE(IUT,*)'<DELTET>: ERR1=',ERR1
	IF(ERR2.GT.1.D-07)WRITE(IUT,*)'<DELTET>: ERR2=',ERR2
	IF(ERR3.GT.1.D-07)WRITE(IUT,*)'<DELTET>: ERR3=',ERR3
	IF(ERR4.GT.1.D-07)WRITE(IUT,*)'<DELTET>: ERR4=',ERR4
	IF(ERR5.GT.1.D-07)WRITE(IUT,*)'<DELTET>: ERR5=',ERR5
	IF(ERR6.GT.1.D-07)WRITE(IUT,*)'<DELTET>: ERR6=',ERR6
C  TEST CHIQ
	TOSK=0.D0
	DOSK=0.D0
	TOSQ=0.D0
	DOSQ=0.D0
	TWGT=0.D0
	DO IBNDS=1,NSPIN
	DO IBNDC=1,NBNDC(1)
	IBANC=IBNDS+NSPIN*(IBNDC-1)
	DO IBNDS1=1,NSPIN
	DO IBNDC1=1,NBNDC(1)
	IBANC1=IBNDS1+NSPIN*(IBNDC1-1)
	DO IC=1,8
	CHIQ(IBANC,IBANC1,IC)=(0.D0,0.D0)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	DO ISGQ=1,NSGQ                              !!! over q-star
	DO IPNT=1,NPNT(1)                           !!! over k-points
      IF(KSYMPN(ISGQ,IPNT).GE.0)THEN
C  SET POINT-GROUP INFORMATION
      IRK=ISG(1,ISGQ)
      IGK=IKOV(IRK)
      IPNTK=IPNT
      IRQ=IG0IG1(IPNT,IRK)
      IPNTQ=IK0IK1(IPNT,IRK)
C  READ TETRAHEDRON WEIGHTS FOR BRILLOUIN ZONE INTEGRATION
	IREC=1+IPNT+NPNT(1)*(ISGQ-1)
	READ(IUTTW,REC=IREC)WGTQ(1),
     &(((WEIGQ(IBANC,IBANC1,IC,1),IBANC=1,NBNDC(1)*NSPIN),
     &IBANC1=1,NBNDC(1)*NSPIN),IC=1,6),
     &((WEIGK(IBANC,IC,1),IBANC=1,NBNDC(1)*NSPIN),IC=1,4)
	TWGT=TWGT+WGTQ(1)
C  INTEGRATE OVER BZ
	DO IBNDS=1,NSPIN
	DO IBNDC=1,NBNDC(1)
	IBANC=IBNDS+NSPIN*(IBNDC-1)
	IBNDT=IBNDC+NBNDE(1)-1
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	TOSK=TOSK+WEIGK(IBANC,1,1)
	TOSQ=TOSQ+WEIGK(IBANC,2,1)
	DOSK=DOSK+WEIGK(IBANC,3,1)
	DOSQ=DOSQ+WEIGK(IBANC,4,1)
	DO IBNDS1=1,NSPIN
	DO IBNDC1=1,NBNDC(1)
	IBANC1=IBNDS1+NSPIN*(IBNDC1-1)
	IBNDT1=IBNDC1+NBNDE(1)-1
	IBAND1=IBNDS1+NSPIN*(IBNDT1-1)
	DO IC=1,6
	CHIQ(IBANC,IBANC1,IC)=CHIQ(IBANC,IBANC1,IC)+
     &WEIGQ(IBANC,IBANC1,IC,1)
	ENDDO
      DEK=ETRT(IBAND,IPNTK,1)-ETRT(IBAND1,IPNTQ,1)
	CHIQ(IBANC,IBANC1,7)=CHIQ(IBANC,IBANC1,7)+
     &WEIGK(IBANC,1,1)*DEK/(DEK**2+POLUS**2)
	CHIQ(IBANC,IBANC1,8)=CHIQ(IBANC,IBANC1,8)+
     &WEIGK(IBANC1,2,1)*DEK/(DEK**2+POLUS**2)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDIF
      ENDDO                               !!! over irreducible points
      ENDDO                               !!! over star of the q-vector
C  PRINT TEST DATA
	WRITE(IUN,1010)
	WRITE(IUN,1015)
	CHIT=0.D0
	CHID=0.D0
	CHIF=0.D0
	CHIW=0.D0
	DO IBNDS=1,NSPIN
	DO IBNDS1=1,NSPIN
	IF(NORBS.EQ.1.AND.IBNDS.NE.IBNDS1)CYCLE
	DO IBNDC=1,NBNDC(1)
	DO IBNDC1=1,NBNDC(1)
	IBANC=IBNDS+NSPIN*(IBNDC-1)
	IBNDT=IBNDC+NBNDE(1)-1
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	IBANC1=IBNDS1+NSPIN*(IBNDC1-1)
	IBNDT1=IBNDC1+NBNDE(1)-1
	IBAND1=IBNDS1+NSPIN*(IBNDT1-1)
	CHIT=CHIT+CHIQ(IBANC,IBANC1,1)-CHIQ(IBANC,IBANC1,2)
	CHID=CHID+CHIQ(IBANC,IBANC1,3)-CHIQ(IBANC,IBANC1,4)
	CHIF=CHIF+CHIQ(IBANC,IBANC1,5)-CHIQ(IBANC,IBANC1,6)
	CHIW=CHIW+CHIQ(IBANC,IBANC1,7)-CHIQ(IBANC,IBANC1,8)
	WRITE(IUN,1020)IBANC,IBANC1,
     &CHIQ(IBANC,IBANC1,1)-CHIQ(IBANC,IBANC1,2),
     &CHIQ(IBANC,IBANC1,3)-CHIQ(IBANC,IBANC1,4),
     &CHIQ(IBANC,IBANC1,5)-CHIQ(IBANC,IBANC1,6),
     &CHIQ(IBANC,IBANC1,7)-CHIQ(IBANC,IBANC1,8)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	WRITE(IUN,1030)
	WRITE(IUN,1040)CHIT,CHID,CHIT+CHID
	WRITE(IUN,1050)TWGT,TOSK,DOSK
	WRITE(IUN,1060)TWGT,TOSQ,DOSQ
	WRITE(IUN,1070)CHIF,CHIW,CHIF-CHIW
1010	FORMAT(1X,'Test print from the Integration Routine ::')
1015	FORMAT(1X,'ibnd  ibnd1',4X,'chi(V)',9X,'chi(F)',
     &  9X,'chi1(d)',8X,'chi2(d)')
1020	FORMAT(1X,1X,I2,4X,I2,4(1X,G14.7))
1030	FORMAT(1X,'Sum over band index and TOS,DOS numbers ::')
1040	FORMAT(1X,'CHIT,CHID,CHIS==',3(1X,G14.7))
1050	FORMAT(1X,'TEST,TOSK,DOSK==',3(1X,G14.7))
1060	FORMAT(1X,'TEST,TOSQ,DOSQ==',3(1X,G14.7))
1070	FORMAT(1X,'CHIF,CHIW,DIFF==',3(1X,G14.7))
C Memory deallocations
	DEALLOCATE(WEIGQ,WEIGK,WTST,CHIQ)
	END
