	SUBROUTINE PHN_SDYNMAT(IQPNT)
************************************************************
*   Calculates derivative of the total energy over nuclear *
*   displacements. The Pulay terms are assumed to be       *
*   taken in "rigid" approximation.                        *
*   Last edited 04.05.95.                                  *
************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_LATTICE, ONLY : TAU                                        !!! from readstr
	USE COM_DYNMAT,  ONLY : DYNMAT,BNDMAT                              !!! from dynmat
	USE COM_KAPPAR,  ONLY : NPAN                                       !!! from readini
      USE COM_LABELS,  ONLY : TXTEL                                      !!! from readini
	USE COM_QMESH,   ONLY : NQPNT,QPNT                                 !!! from readpnt
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16, ALLOCATABLE :: DBND(:,:,:,:,:)
      COMPLEX*16, ALLOCATABLE :: DPTN(:,:,:,:,:)
      COMPLEX*16, ALLOCATABLE :: DCOU(:,:,:,:,:)
      COMPLEX*16, ALLOCATABLE :: DEXC(:,:,:,:,:)
      COMPLEX*16, ALLOCATABLE :: DMLT(:,:,:,:,:)
      COMPLEX*16, ALLOCATABLE :: DMT0(:,:,:,:,:)
      COMPLEX*16, ALLOCATABLE :: DHLF(:,:,:,:,:)
      COMPLEX*16, ALLOCATABLE :: PBND(:,:,:,:  )
	DATA IPRINT/1/              !!! full output
	IF(MODE.EQ.5)RETURN
      ALLOCATE(DBND(3,NATOMMEM,3,NATOMMEM,8))  !!! Band Contribution
      ALLOCATE(DPTN(3,NATOMMEM,3,NATOMMEM,4))  !!! Potential Energy Contribution
      ALLOCATE(DCOU(3,NATOMMEM,3,NATOMMEM,4))  !!! Coulomb Energy Contribution
      ALLOCATE(DEXC(3,NATOMMEM,3,NATOMMEM,4))  !!! Exchange-Correlation Energy 
      ALLOCATE(DMLT(3,NATOMMEM,3,NATOMMEM,4))  !!! Multipole Contribution
      ALLOCATE(DMT0(3,NATOMMEM,3,NATOMMEM,4))  !!! Mt-zero Contribution
      ALLOCATE(DHLF(3,NATOMMEM,3,NATOMMEM,4))  !!! Hellman-Feynmann Theorem
      ALLOCATE(PBND(3,NATOMMEM,3,NATOMMEM  ))  !!! MT-part, INT-part of the Band Term
C   CALCULATE DIFFERENT CONTRIBUTIONS TO THE DYNAMICAL MATRIX
   	CALL PHN_SBNDMAT(DBND,IQPNT)          !!! band contribution 
   	CALL PHN_SHLFMAT(DHLF,IQPNT)          !!! Hellman-Feynman contribution 
   	CALL PHN_SMT0MAT(DMT0,IQPNT)          !!! mt-zero contribution
   	CALL PHN_SPTNMAT(DPTN,IQPNT)          !!! potential contribution 
   	CALL PHN_SCOUMAT(DCOU,IQPNT)          !!! coulomb contribution 
   	CALL PHN_SMLTMAT(DMLT,IQPNT)          !!! multipole contribution 
   	CALL PHN_SEXCMAT(DEXC,IQPNT)          !!! exchange-correlation contribution 
C *** SET DIFFERENT FORMULAS FOR DYNAMICAL MATRIX ***
	DO 20 INUC1=1,NATOM
	DO 20 INUC=1,NATOM
	DO 10 IXYZ1=1,3
	DO 10 IXYZ=1,3
C   THE FIRST FORMULA FOR THE FORCE THEOREM
	DYNMAT(IXYZ1,INUC1,IXYZ,INUC,1)=
     &  DBND(IXYZ1,INUC1,IXYZ,INUC,1)+
     &  DBND(IXYZ1,INUC1,IXYZ,INUC,2)-
     &  DCOU(IXYZ1,INUC1,IXYZ,INUC,1)*0.5D0-
     &  DCOU(IXYZ1,INUC1,IXYZ,INUC,2)*0.5D0+
     &  DMLT(IXYZ1,INUC1,IXYZ,INUC,1)-
     &  DEXC(IXYZ1,INUC1,IXYZ,INUC,1)-
     &  DEXC(IXYZ1,INUC1,IXYZ,INUC,2)+
     &  DMT0(IXYZ1,INUC1,IXYZ,INUC,1)
C   THE SECOND FORMULA FOR THE FORCE THEOREM
	DYNMAT(IXYZ1,INUC1,IXYZ,INUC,2)=
     &  DBND(IXYZ1,INUC1,IXYZ,INUC,1)+
     &  DBND(IXYZ1,INUC1,IXYZ,INUC,2)-
     &  DCOU(IXYZ1,INUC1,IXYZ,INUC,1)-
     &  DEXC(IXYZ1,INUC1,IXYZ,INUC,1)-
     &  DEXC(IXYZ1,INUC1,IXYZ,INUC,2)+
     &  DMT0(IXYZ1,INUC1,IXYZ,INUC,1)
C   THE THIRD FORMULA FOR THE FORCE THEOREM
	DYNMAT(IXYZ1,INUC1,IXYZ,INUC,3)=
     &  DBND(IXYZ1,INUC1,IXYZ,INUC,1)+
     &  DBND(IXYZ1,INUC1,IXYZ,INUC,2)-
     &  DPTN(IXYZ1,INUC1,IXYZ,INUC,1)-
     &  DCOU(IXYZ1,INUC1,IXYZ,INUC,3)
C   THE HELLMANN-FEYNMAN + PULAY FORCE FORMULA
	IF(NPFR.EQ.1)
     &	DYNMAT(IXYZ1,INUC1,IXYZ,INUC,4)=
     &  DBND(IXYZ1,INUC1,IXYZ,INUC,1)+
     &  DBND(IXYZ1,INUC1,IXYZ,INUC,2)-
     &  DPTN(IXYZ1,INUC1,IXYZ,INUC,4)+
     &  DHLF(IXYZ1,INUC1,IXYZ,INUC,2)+
     &  DHLF(IXYZ1,INUC1,IXYZ,INUC,1)
C   THE HELLMANN-FEYNMAN + CORE CORRECTION (NO PULAY IS AVAIABLE)
	IF(NPFR.EQ.0.OR.NPFR.EQ.2)
     &  DYNMAT(IXYZ1,INUC1,IXYZ,INUC,4)=-
     &  DPTN(IXYZ1,INUC1,IXYZ,INUC,3)+
     &  DHLF(IXYZ1,INUC1,IXYZ,INUC,3)+
     &  DHLF(IXYZ1,INUC1,IXYZ,INUC,1)
C   SET ZEROES
	DO 10 IC=1,4
	IF(ABS(DBND(IXYZ1,INUC1,IXYZ,INUC,IC)).LE.1.D-10)
     &  DBND(IXYZ1,INUC1,IXYZ,INUC,IC)=(0.D0,0.D0)
	IF(ABS(DMLT(IXYZ1,INUC1,IXYZ,INUC,IC)).LE.1.D-10)
     &  DMLT(IXYZ1,INUC1,IXYZ,INUC,IC)=(0.D0,0.D0)
	IF(ABS(DMT0(IXYZ1,INUC1,IXYZ,INUC,IC)).LE.1.D-10)
     &  DMT0(IXYZ1,INUC1,IXYZ,INUC,IC)=(0.D0,0.D0)
	IF(ABS(DPTN(IXYZ1,INUC1,IXYZ,INUC,IC)).LE.1.D-10)
     &  DPTN(IXYZ1,INUC1,IXYZ,INUC,IC)=(0.D0,0.D0)
	IF(ABS(DCOU(IXYZ1,INUC1,IXYZ,INUC,IC)).LE.1.D-10)
     &  DCOU(IXYZ1,INUC1,IXYZ,INUC,IC)=(0.D0,0.D0)
	IF(ABS(DEXC(IXYZ1,INUC1,IXYZ,INUC,IC)).LE.1.D-10)
     &  DEXC(IXYZ1,INUC1,IXYZ,INUC,IC)=(0.D0,0.D0)
	IF(ABS(DHLF(IXYZ1,INUC1,IXYZ,INUC,IC)).LE.1.D-10)
     &  DHLF(IXYZ1,INUC1,IXYZ,INUC,IC)=(0.D0,0.D0)
	IF(ABS(DYNMAT(IXYZ1,INUC1,IXYZ,INUC,IC)).LE.1.D-10)
     &  DYNMAT(IXYZ1,INUC1,IXYZ,INUC,IC)=(0.D0,0.D0)
  10    CONTINUE
  20	CONTINUE
C *** PRINT BLOCK ***
	WRITE(IUN,1010)
      WRITE(IUN,1011)(QPNT(I,IQPNT),I=1,3)
      DO 2000 INUC1=1,NATOM              !!! over nuclear shifts
      DO 2000 INUC=1,NATOM               !!! over nuclear shifts
      WRITE(IUN,1012)INUC1,TXTEL(IS(INUC1)),INUC,TXTEL(IS(INUC))
1010  FORMAT(1X,'**** D Y N A M I C A L   M A T R I X (Ry/a.u**2) ****')
1011  FORMAT(1X,'Q-vector: (',G11.4,',',G11.4,',',G11.4,')')
1012  FORMAT(1X,'Elements: atom #',I2,1X,A10,' and #',I2,1X,A10)
C  First Formula
	IF(NPFR.EQ.1.OR.NPFR.EQ.2)THEN
        WRITE(IUN,1110)
        DO 110 IXYZ1=1,3                   !!! over x,y,z
        WRITE(IUN,1100)(DYNMAT(IXYZ1,INUC1,IXYZ,INUC,1),IXYZ=1,3)
 110    CONTINUE                           !!! over x,y,z
	ENDIF
C  Second Formula
	IF(NPFR.EQ.1)THEN
        WRITE(IUN,1120)
        DO 120 IXYZ1=1,3                   !!! over x,y,z
        WRITE(IUN,1100)(DYNMAT(IXYZ1,INUC1,IXYZ,INUC,2),IXYZ=1,3)
 120    CONTINUE                           !!! over x,y,z
	ENDIF
C  Third Formula
	IF(NPFR.EQ.1)THEN
        WRITE(IUN,1130)
        DO 130 IXYZ1=1,3                   !!! over x,y,z
        WRITE(IUN,1100)(DYNMAT(IXYZ1,INUC1,IXYZ,INUC,3),IXYZ=1,3)
 130    CONTINUE                           !!! over x,y,z
	ENDIF
C  Hellman-Feynman plus Pulay Formula
	IF(NPFR.EQ.1)THEN
        WRITE(IUN,1140)
        DO 140 IXYZ1=1,3                   !!! over x,y,z
        WRITE(IUN,1100)(DYNMAT(IXYZ1,INUC1,IXYZ,INUC,4),IXYZ=1,3)
 140    CONTINUE                           !!! over x,y,z
	ENDIF
C  Hellman-Feynman plus Core Correction
	IF(NPFR.EQ.0.OR.NPFR.EQ.2)THEN
        WRITE(IUN,1150)
        DO 150 IXYZ1=1,3                   !!! over x,y,z
        WRITE(IUN,1100)(DHLF(IXYZ1,INUC1,IXYZ,INUC,1),IXYZ=1,3)
 150    CONTINUE                           !!! over x,y,z
        WRITE(IUN,1160)
        DO 160 IXYZ1=1,3                   !!! over x,y,z
        WRITE(IUN,1100)(DHLF(IXYZ1,INUC1,IXYZ,INUC,3)-          
     &                  DPTN(IXYZ1,INUC1,IXYZ,INUC,3),IXYZ=1,3)
 160    CONTINUE                           !!! over x,y,z
        WRITE(IUN,1170)
        DO 170 IXYZ1=1,3                   !!! over x,y,z
        WRITE(IUN,1100)(DYNMAT(IXYZ1,INUC1,IXYZ,INUC,4),IXYZ=1,3)
 170    CONTINUE                           !!! over x,y,z
	ENDIF
1100  FORMAT(1X,2G11.4,'|',2G11.4,'|',2G11.4)
1110  FORMAT(1X,'First  Formula for Dynamical Matrix -------->')
1120  FORMAT(1X,'Second Formula for Dynamical Matrix -------->')
1130  FORMAT(1X,'Third  Formula for Dynamical Matrix -------->')
1140  FORMAT(1X,'HF+PL  Formula for Dynamical Matrix -------->')
1150  FORMAT(1X,'HF     Formula for Dynamical Matrix -------->')
1160  FORMAT(1X,'CR     Formula for Dynamical Matrix -------->')
1170  FORMAT(1X,'HF+CR  Formula for Dynamical Matrix -------->')
2000	CONTINUE
	WRITE(IUN,1200)
1200  FORMAT(1X,'*****************************************************')
C  PRINT DIFFERENT CONTRIBUTIONS IF NECESSARY
	IF(NPFR.EQ.0)GOTO 5000
	IF(IPRINT.NE.1)GOTO 5000
	WRITE(IUN,1301)
      WRITE(IUN,1302)(QPNT(I,IQPNT),I=1,3)
      DO 4000 INUC1=1,NATOM              !!! over nuclear shifts
      DO 4000 INUC=1,NATOM               !!! over nuclear shifts
      WRITE(IUN,1303)INUC1,TXTEL(IS(INUC1)),INUC,TXTEL(IS(INUC))
1301  FORMAT(1X,'DIFFERENT CONTRIBUTIONS TO THE DYNAMICAL MATRIX ')
1302  FORMAT(1X,'Q-vector: (',G11.4,',',G11.4,',',G11.4,')')
1303  FORMAT(1X,'Elements: atom #',I2,1X,A10,' and #',I2,1X,A10)
C  CONTRIBUTIONS IN THE FIRST FORMULA
	IF(NPFR.EQ.1.OR.NPFR.EQ.2)THEN
        WRITE(IUN,1310)
        WRITE(IUN,1311)
        DO 311 IXYZ1=1,3                   !!! over x,y,z
        WRITE(IUN,1100)(DBND(IXYZ1,INUC1,IXYZ,INUC,1)+         
     &                  DBND(IXYZ1,INUC1,IXYZ,INUC,2),IXYZ=1,3)
 311    CONTINUE                           !!! over x,y,z
        WRITE(IUN,1312)
        DO 312 IXYZ1=1,3                   !!! over x,y,z
        WRITE(IUN,1100)(DMLT(IXYZ1,INUC1,IXYZ,INUC,1),IXYZ=1,3)
 312    CONTINUE                           !!! over x,y,z
        WRITE(IUN,1313)
        DO 313 IXYZ1=1,3                   !!! over x,y,z
        WRITE(IUN,1100)(DCOU(IXYZ1,INUC1,IXYZ,INUC,1)*(-0.5D0)+
     &                  DCOU(IXYZ1,INUC1,IXYZ,INUC,2)*(-0.5D0)+      
     &                  DMLT(IXYZ1,INUC1,IXYZ,INUC,1),IXYZ=1,3)
 313    CONTINUE                           !!! over x,y,z
        WRITE(IUN,1314)
        DO 314 IXYZ1=1,3                   !!! over x,y,z
        WRITE(IUN,1100)(DEXC(IXYZ1,INUC1,IXYZ,INUC,1)*(-1.D0)+  
     &          (-1.D0)*DEXC(IXYZ1,INUC1,IXYZ,INUC,2),IXYZ=1,3)
 314    CONTINUE                           !!! over x,y,z
        WRITE(IUN,1315)
        DO 315 IXYZ1=1,3                   !!! over x,y,z
        WRITE(IUN,1100)(DMT0(IXYZ1,INUC1,IXYZ,INUC,1),IXYZ=1,3)
 315    CONTINUE                           !!! over x,y,z
        WRITE(IUN,1316)
        DO 316 IXYZ1=1,3                   !!! over x,y,z
        WRITE(IUN,1100)(DYNMAT(IXYZ1,INUC1,IXYZ,INUC,1),IXYZ=1,3)
 316    CONTINUE                           !!! over x,y,z
	ENDIF
1310   FORMAT(1X,'Contributions in the FIRST FORMULA are  ------>')
1311   FORMAT(1X,'Band Contribution                  :           ')
1312   FORMAT(1X,'Multipole Contribution             :           ')
1313   FORMAT(1X,'Coulomb1 Contribution              :           ')
1314   FORMAT(1X,'Exchange-Correlation Contribution  :           ')
1315   FORMAT(1X,'MT-zero Contribution               :           ')
1316   FORMAT(1X,'Total MATRIX 1                     :           ')
C  CONTRIBUTIONS IN THE SECOND FORMULA
	IF(NPFR.EQ.1)THEN
        WRITE(IUN,1320)
        WRITE(IUN,1321)
        DO 321 IXYZ1=1,3                   !!! over x,y,z
        WRITE(IUN,1100)(DBND(IXYZ1,INUC1,IXYZ,INUC,1)+         
     &                  DBND(IXYZ1,INUC1,IXYZ,INUC,2),IXYZ=1,3)
 321    CONTINUE                           !!! over x,y,z
        WRITE(IUN,1323)
        DO 323 IXYZ1=1,3                   !!! over x,y,z
        WRITE(IUN,1100)(DCOU(IXYZ1,INUC1,IXYZ,INUC,1)*(-1.D0)
     &                                               ,IXYZ=1,3)
 323    CONTINUE                           !!! over x,y,z
        WRITE(IUN,1324)
        DO 324 IXYZ1=1,3                   !!! over x,y,z
        WRITE(IUN,1100)(DEXC(IXYZ1,INUC1,IXYZ,INUC,1)*(-1.D0)+  
     &          (-1.D0)*DEXC(IXYZ1,INUC1,IXYZ,INUC,2),IXYZ=1,3)
 324    CONTINUE                           !!! over x,y,z
        WRITE(IUN,1325)
        DO 325 IXYZ1=1,3                   !!! over x,y,z
        WRITE(IUN,1100)(DMT0(IXYZ1,INUC1,IXYZ,INUC,1),IXYZ=1,3)
 325    CONTINUE                           !!! over x,y,z
        WRITE(IUN,1326)
        DO 326 IXYZ1=1,3                   !!! over x,y,z
        WRITE(IUN,1100)(DYNMAT(IXYZ1,INUC1,IXYZ,INUC,2),IXYZ=1,3)
 326    CONTINUE                           !!! over x,y,z
	ENDIF
1320   FORMAT(1X,'Contributions in the SECOND FORMULA are ------>')
1321   FORMAT(1X,'Band Contribution                  :           ')
1323   FORMAT(1X,'Coulomb2 Contribution              :           ')
1324   FORMAT(1X,'Exchange-Correlation Contribution  :           ')
1325   FORMAT(1X,'MT-zero Contribution               :           ')
1326   FORMAT(1X,'Total MATRIX 2                     :           ')
C  CONTRIBUTIONS IN THE THIRD FORMULA
	IF(NPFR.EQ.1)THEN
        WRITE(IUN,1330)
        WRITE(IUN,1331)
        DO 331 IXYZ1=1,3                   !!! over x,y,z
        WRITE(IUN,1100)(DBND(IXYZ1,INUC1,IXYZ,INUC,1)+         
     &                  DBND(IXYZ1,INUC1,IXYZ,INUC,2),IXYZ=1,3)
 331    CONTINUE                           !!! over x,y,z
        WRITE(IUN,1332)
        DO 332 IXYZ1=1,3                   !!! over x,y,z
        WRITE(IUN,1100)(DPTN(IXYZ1,INUC1,IXYZ,INUC,1)*(-1.D0)
     &                                               ,IXYZ=1,3)
 332    CONTINUE                           !!! over x,y,z
        WRITE(IUN,1333)
        DO 333 IXYZ1=1,3                   !!! over x,y,z
        WRITE(IUN,1100)(DCOU(IXYZ1,INUC1,IXYZ,INUC,3)*(-1.D0)
     &                                               ,IXYZ=1,3)
 333    CONTINUE                           !!! over x,y,z
        WRITE(IUN,1334)
        DO 334 IXYZ1=1,3                   !!! over x,y,z
        WRITE(IUN,1100)(DYNMAT(IXYZ1,INUC1,IXYZ,INUC,3),IXYZ=1,3)
 334    CONTINUE                           !!! over x,y,z
	ENDIF
1330   FORMAT(1X,'Contributions in the THIRD FORMULA are  ------>')
1331   FORMAT(1X,'Band Contribution                  :           ')
1332   FORMAT(1X,'Potential Contribution             :           ')
1333   FORMAT(1X,'Coulomb3 Contribution              :           ')
1334   FORMAT(1X,'Total MATRIX 3                     :           ')
C  CONTRIBUTIONS IN THE HELLMANN-FEYNMAN PLUS PULAY FORMULA
	IF(NPFR.EQ.1)THEN
        WRITE(IUN,1340)
        WRITE(IUN,1341)
        DO 341 IXYZ1=1,3                   !!! over x,y,z
        WRITE(IUN,1100)(DBND(IXYZ1,INUC1,IXYZ,INUC,1)+         
     &                  DBND(IXYZ1,INUC1,IXYZ,INUC,2)-
     &                  DPTN(IXYZ1,INUC1,IXYZ,INUC,4)+
     &                  DPTN(IXYZ1,INUC1,IXYZ,INUC,3)+
     &                  DHLF(IXYZ1,INUC1,IXYZ,INUC,2)-
     &                  DHLF(IXYZ1,INUC1,IXYZ,INUC,3)
     &                                               ,IXYZ=1,3)
 341    CONTINUE                           !!! over x,y,z
        WRITE(IUN,1342)
        DO 342 IXYZ1=1,3                   !!! over x,y,z
        WRITE(IUN,1100)(DHLF(IXYZ1,INUC1,IXYZ,INUC,3)-       
     &                  DPTN(IXYZ1,INUC1,IXYZ,INUC,3) 
     &                                               ,IXYZ=1,3)
 342    CONTINUE                           !!! over x,y,z
        WRITE(IUN,1343)
        DO 343 IXYZ1=1,3                   !!! over x,y,z
        WRITE(IUN,1100)(DHLF(IXYZ1,INUC1,IXYZ,INUC,1)
     &                                               ,IXYZ=1,3)
 343    CONTINUE                           !!! over x,y,z
        WRITE(IUN,1344)
        DO 344 IXYZ1=1,3                   !!! over x,y,z
        WRITE(IUN,1100)(DPTN(IXYZ1,INUC1,IXYZ,INUC,4)-
     &                  DHLF(IXYZ1,INUC1,IXYZ,INUC,2)-
     &                  DPTN(IXYZ1,INUC1,IXYZ,INUC,1)-
     &                  DCOU(IXYZ1,INUC1,IXYZ,INUC,3)
     &                                               ,IXYZ=1,3)
 344    CONTINUE                           !!! over x,y,z
        WRITE(IUN,1345)
        DO 345 IXYZ1=1,3                   !!! over x,y,z
        WRITE(IUN,1100)(DYNMAT(IXYZ1,INUC1,IXYZ,INUC,4),IXYZ=1,3)
 345    CONTINUE                           !!! over x,y,z
	ENDIF
1340   FORMAT(1X,'Contributions in the HF+PL FORMULA are  ------>')
1341   FORMAT(1X,'Pulay Contribution                 :           ')
1342   FORMAT(1X,'Core Correction                    :           ')
1343   FORMAT(1X,'Hellman-Feynman Theorem            :           ')
1344   FORMAT(1X,'Hellman-Feynman"Theorem            :           ')
1345   FORMAT(1X,'Total MATRIX 4                     :           ')
C CHECK OUT SURFACE INTERGALS
	IF(NPFR.EQ.1.OR.NPFR.EQ.2)THEN
        WRITE(IUN,1400)
        WRITE(IUN,1411)
        DO 411 IXYZ1=1,3                   !!! over x,y,z
        WRITE(IUN,1100)(DMT0(IXYZ1,INUC1,IXYZ,INUC,1),IXYZ=1,3)
 411    CONTINUE                           !!! over x,y,z
        WRITE(IUN,1412)
        DO 412 IXYZ1=1,3                   !!! over x,y,z
        WRITE(IUN,1100)(DMT0(IXYZ1,INUC1,IXYZ,INUC,4),IXYZ=1,3)
 412    CONTINUE                           !!! over x,y,z
        WRITE(IUN,1413)
        DO 413 IXYZ1=1,3                   !!! over x,y,z
        WRITE(IUN,1100)(DPTN(IXYZ1,INUC1,IXYZ,INUC,1)+
     &                  DPTN(IXYZ1,INUC1,IXYZ,INUC,2),IXYZ=1,3)
 413    CONTINUE                           !!! over x,y,z
        WRITE(IUN,1414)
        DO 414 IXYZ1=1,3                   !!! over x,y,z
        WRITE(IUN,1100)(DPTN(IXYZ1,INUC1,IXYZ,INUC,4),IXYZ=1,3)
 414    CONTINUE                           !!! over x,y,z
        WRITE(IUN,1415)
        DO 415 IXYZ1=1,3                   !!! over x,y,z
        WRITE(IUN,1100)(DCOU(IXYZ1,INUC1,IXYZ,INUC,1)+
     &                  DCOU(IXYZ1,INUC1,IXYZ,INUC,2),IXYZ=1,3)
 415    CONTINUE                           !!! over x,y,z
        WRITE(IUN,1416)
        DO 416 IXYZ1=1,3                   !!! over x,y,z
        WRITE(IUN,1100)(DCOU(IXYZ1,INUC1,IXYZ,INUC,4),IXYZ=1,3)
 416    CONTINUE                           !!! over x,y,z
        WRITE(IUN,1417)
        DO 417 IXYZ1=1,3                   !!! over x,y,z
        WRITE(IUN,1100)(DEXC(IXYZ1,INUC1,IXYZ,INUC,1)+
     &                  DEXC(IXYZ1,INUC1,IXYZ,INUC,2),IXYZ=1,3)
 417    CONTINUE                           !!! over x,y,z
        WRITE(IUN,1418)
        DO 418 IXYZ1=1,3                   !!! over x,y,z
        WRITE(IUN,1100)(DEXC(IXYZ1,INUC1,IXYZ,INUC,4),IXYZ=1,3)
 418    CONTINUE                           !!! over x,y,z
	ENDIF
1400   FORMAT(1X,'Comparison between SURFACE INTEGRALS      ------>')
1411   FORMAT(1X,'MTZ"P integral                     :             ')
1412   FORMAT(1X,'MTZ"S integral                     :             ')
1413   FORMAT(1X,'PTN"P integral                     :             ')
1414   FORMAT(1X,'PTN"S integral                     :             ')
1415   FORMAT(1X,'COU"P integral                     :             ')
1416   FORMAT(1X,'COU"S integral                     :             ')
1417   FORMAT(1X,'EXC"P integral                     :             ')
1418   FORMAT(1X,'EXC"S integral                     :             ')
	IF(NPFR.EQ.1.OR.NPFR.EQ.2)THEN
	WRITE(IUN,1500)
        WRITE(IUN,1501)
        DO 501 IXYZ1=1,3                   !!! over x,y,z
        WRITE(IUN,1100)(DBND(IXYZ1,INUC1,IXYZ,INUC,1),IXYZ=1,3)
 501    CONTINUE                           !!! over x,y,z
        WRITE(IUN,1502)
        DO 502 IXYZ1=1,3                   !!! over x,y,z
        WRITE(IUN,1100)(DBND(IXYZ1,INUC1,IXYZ,INUC,2),IXYZ=1,3)
 502    CONTINUE                           !!! over x,y,z
        WRITE(IUN,1503)
        DO 503 IXYZ1=1,3                   !!! over x,y,z
        WRITE(IUN,1100)(DBND(IXYZ1,INUC1,IXYZ,INUC,3),IXYZ=1,3)
 503    CONTINUE                           !!! over x,y,z
        WRITE(IUN,1504)
        DO 504 IXYZ1=1,3                   !!! over x,y,z
        WRITE(IUN,1100)(DBND(IXYZ1,INUC1,IXYZ,INUC,4),IXYZ=1,3)
 504    CONTINUE                           !!! over x,y,z
        WRITE(IUN,1505)
        DO 505 IXYZ1=1,3                   !!! over x,y,z
        WRITE(IUN,1100)(DBND(IXYZ1,INUC1,IXYZ,INUC,5),IXYZ=1,3)
 505    CONTINUE                           !!! over x,y,z
	WRITE(IUN,1508)
	DO 570 IPAN=1,NPAN
	WRITE(IUN,1509)IPAN
      WRITE(IUN,1510)
	CALL PHN_TRANSMAT(BNDMAT(-1,1,-1,1,1,IPAN),PBND,NATOM)
      DO 510 IXYZ1=1,3                   !!! over x,y,z
      WRITE(IUN,1100)(PBND(IXYZ1,INUC1,IXYZ,INUC),IXYZ=1,3)
 510  CONTINUE                           !!! over x,y,z
      WRITE(IUN,1520)
	CALL PHN_TRANSMAT(BNDMAT(-1,1,-1,1,2,IPAN),PBND,NATOM)
      DO 520 IXYZ1=1,3                   !!! over x,y,z
      WRITE(IUN,1100)(PBND(IXYZ1,INUC1,IXYZ,INUC),IXYZ=1,3)
 520  CONTINUE                           !!! over x,y,z
      WRITE(IUN,1530)
	CALL PHN_TRANSMAT(BNDMAT(-1,1,-1,1,3,IPAN),PBND,NATOM)
      DO 530 IXYZ1=1,3                   !!! over x,y,z
      WRITE(IUN,1100)(PBND(IXYZ1,INUC1,IXYZ,INUC),IXYZ=1,3)
 530  CONTINUE                           !!! over x,y,z
      WRITE(IUN,1540)
	CALL PHN_TRANSMAT(BNDMAT(-1,1,-1,1,4,IPAN),PBND,NATOM)
      DO 540 IXYZ1=1,3                   !!! over x,y,z
      WRITE(IUN,1100)(PBND(IXYZ1,INUC1,IXYZ,INUC),IXYZ=1,3)
 540  CONTINUE                           !!! over x,y,z
      WRITE(IUN,1550)
	CALL PHN_TRANSMAT(BNDMAT(-1,1,-1,1,5,IPAN),PBND,NATOM)
      DO 550 IXYZ1=1,3                   !!! over x,y,z
      WRITE(IUN,1100)(PBND(IXYZ1,INUC1,IXYZ,INUC),IXYZ=1,3)
 550  CONTINUE                           !!! over x,y,z
      WRITE(IUN,1560)
	CALL PHN_TRANSMAT(BNDMAT(-1,1,-1,1,6,IPAN),PBND,NATOM)
      DO 560 IXYZ1=1,3                   !!! over x,y,z
      WRITE(IUN,1100)(PBND(IXYZ1,INUC1,IXYZ,INUC),IXYZ=1,3)
 560  CONTINUE                           !!! over x,y,z
 570	CONTINUE
 580	CONTINUE
	ENDIF
1500  FORMAT(1X,'K-point Convergency Check in BZ-INTEGRALS ------>')
1501  FORMAT(1X,'Usual Weight  Contribution [1-5]   :             ')
1502  FORMAT(1X,'Fermi Weight  Contribution [6]     :             ')
1503  FORMAT(1X,'Fermi States  Contribution [5+6]   :             ')
1504  FORMAT(1X,'Fermi States  Contribution [7=5+6] :             ')
1505  FORMAT(1X,'Fermi Surface Contribution [8]     :             ')
1508  FORMAT(1X,'Contributions from different PANELS       ------>')
1509  FORMAT(1X,'Panel # ',I2,' : MT-parts,INT-parts:             ')
1510  FORMAT(1X,'d2[r]Hmt  Contribution     [1]     :             ')
1520  FORMAT(1X,'d2[s]Hmt  Contribution     [2]     :             ')
1530  FORMAT(1X,'d2[r]Vint Contribution     [3]     :             ')
1540  FORMAT(1X,'d1[t]Htot Contribution     [4]     :             ')
1550  FORMAT(1X,'d1[t]Htot Contribution     [5]     :             ')
1560  FORMAT(1X,'d1[t]Htot Contribution     [6]     :             ')
C
4000  CONTINUE                                !!! OVER DISPLACEMENTS
	WRITE(IUN,4001)
4001  FORMAT(1X,'***************************************************')
C MEMORY DEALLOCATIONS
5000  DEALLOCATE(DBND,DPTN,DCOU,DEXC,DMLT,DMT0,DHLF,PBND)
	END




	SUBROUTINE PHN_SBNDMAT(DBND,IQPNT)
**************************************************************
*   Calculates band contribution to the Dynamical Matrix.    *
**************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
	USE COM_PHNCOM,  ONLY : NITER                                      !!! from readini
	USE COM_PARAM,   ONLY : NSPIN,NSORT,IS,ILST,ILSB,ILSV,NATOM        !!! from readini
	USE COM_LATTICE, ONLY : TAU                                        !!! from readstr
	USE COM_DYNMAT,  ONLY : BNDMAT                                     !!! from d2dynend
	USE COM_KAPPAR,  ONLY : NPAN                                       !!! from readini
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: TMPMAT(:,:,:,:,:)
	COMPLEX*16 DBND(3,NATOMMEM,3,NATOMMEM,8)
	DATA PI/3.141592653589793D0/
	DO 10 INUC1=1,NATOM
	DO 10 INUC =1,NATOM
	DO 10 IXYZ1=1,3
	DO 10 IXYZ =1,3
	DO 10 IC=1,4
	DBND(IXYZ1,INUC1,IXYZ,INUC,IC)=(0.D0,0.D0)
  10	CONTINUE
	IF(MODE.NE.4)RETURN
C  MEMORY ALLOCATIONS
	ALLOCATE(TMPMAT(-1:1,NATOMMEM,-1:1,NATOMMEM,8))
C  TRANSFERE TO CARTESIAN SYSTEM
	DO 130 INUC1=1,NATOM
	DO 130 INUC =1,NATOM
	DO 130 MY1=-1,1
	DO 130 MY=-1,1
	DO 100 II=1,8
	TMPMAT(MY1,INUC1,MY,INUC,II)=(0.D0,0.D0)
 100	CONTINUE
	IF(NITER(MY1,INUC1).EQ.0)GOTO 130
	IF(NITER(MY ,INUC ).EQ.0)GOTO 130
	DO 110 IPAN=1,NPAN
C  USUAL-TETRAHEDRON-WEIGHTS CONTRIBUTION
	TMPMAT(MY1,INUC1,MY,INUC,1)=TMPMAT(MY1,INUC1,MY,INUC,1)+
     &BNDMAT(MY1,INUC1,MY,INUC,1,IPAN)+
     &BNDMAT(MY1,INUC1,MY,INUC,2,IPAN)+
     &BNDMAT(MY1,INUC1,MY,INUC,3,IPAN)+
     &BNDMAT(MY1,INUC1,MY,INUC,4,IPAN)+
     &BNDMAT(MY1,INUC1,MY,INUC,5,IPAN)
C  FERMI-STATES TETRAHEDRON-WEIGHTS CONTRIBUTION
	TMPMAT(MY1,INUC1,MY,INUC,2)=TMPMAT(MY1,INUC1,MY,INUC,2)+
     &BNDMAT(MY1,INUC1,MY,INUC,6,IPAN)
C  FERMI-STATES CONTRIBUTION 1
	TMPMAT(MY1,INUC1,MY,INUC,3)=TMPMAT(MY1,INUC1,MY,INUC,3)+
     &BNDMAT(MY1,INUC1,MY,INUC,5,IPAN)+
     &BNDMAT(MY1,INUC1,MY,INUC,6,IPAN)
C  FERMI-STATES CONTRIBUTION 2
	TMPMAT(MY1,INUC1,MY,INUC,4)=TMPMAT(MY1,INUC1,MY,INUC,4)+
     &BNDMAT(MY1,INUC1,MY,INUC,7,IPAN)
C  FERMI-SURFACE CONTRIBUTION
	TMPMAT(MY1,INUC1,MY,INUC,5)=TMPMAT(MY1,INUC1,MY,INUC,5)+
     &BNDMAT(MY1,INUC1,MY,INUC,8,IPAN)
C  TOTAL CONTRIBUTION
	TMPMAT(MY1,INUC1,MY,INUC,6)=TMPMAT(MY1,INUC1,MY,INUC,6)+
     &BNDMAT(MY1,INUC1,MY,INUC,10,IPAN)
 110	CONTINUE
 120	CONTINUE
	DIFF=ABS(TMPMAT(MY1,INUC1,MY,INUC,1)
     &        +TMPMAT(MY1,INUC1,MY,INUC,2)
     &        -TMPMAT(MY1,INUC1,MY,INUC,6))
	IF(DIFF.GE.1.D-05)WRITE(IUT,*)'<BNDMAT>:: LOST OF ACCURACY',
     &  DIFF,MY,MY1,INUC,INUC1,TMPMAT(MY1,INUC1,MY,INUC,6)
 130	CONTINUE
	DO 140 II=1,8
	CALL PHN_TRANSMAT(TMPMAT(-1,1,-1,1,II),DBND(1,1,1,1,II),NATOM)
 140	CONTINUE
	DEALLOCATE(TMPMAT)
	END


	SUBROUTINE PHN_SHLFMAT(DHLF,IQPNT)
*****************************************************************
*  Calculates Hellmann-Feynman + Core Correction Contributions  *
*  to the Dynamical Matrix.                                     *
*****************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
      USE COM_PHNCOM,  ONLY : ITERMAX,NITER                              !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
     &                       ,NHSORT
	USE COM_RADMESH, ONLY : NRAD,H,R,DR,WEIGHT,RL                      !!! from radmsh
	USE COM_SPHERE,  ONLY : SWZ,SMT,ZNUC,ZCOR                          !!! from readini
	USE COM_POTDAT,  ONLY : POT,POTSPH                                 !!! from fulpot
	USE COM_DELPOT,  ONLY : DPOT                                       !!! from delpot
      USE COM_DELRHO,  ONLY : DRHO                                       !!! from delrho
	USE COM_DENDAT,  ONLY : RHO,RHOCOR                                 !!! from readscf
	USE COM_SYMMLM,  ONLY : SYM,LMSYM                                  !!! from makesym
	USE COM_MULTRO,  ONLY : AMTOT,PSMOM,PSMOM1,QMAD                    !!! from multrho
	USE COM_POTMTS,  ONLY : VMT0,VMT,VSF0,VSF                          !!! from vzero
	USE COM_LATPAR,  ONLY : PAR,ORTH,OMEGAC                            !!! from readini
      USE COM_DROMULT, ONLY : DELMRO,DELMAD                              !!! from dmultrho
	USE COM_GAUNT,   ONLY : C                                          !!! from makegnt
	USE COM_PHNCHN  ,ONLY : IUDPX,IUDPY,IUDSV,IUDPV                    !!! from channels
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: WORK1(:)
	COMPLEX*16, ALLOCATABLE :: WORK2(:)
	COMPLEX*16, ALLOCATABLE :: DVDR(:,:)
	COMPLEX*16, ALLOCATABLE :: DVLMDR(:)
	COMPLEX*16, ALLOCATABLE :: VR2(:,:)
	COMPLEX*16, ALLOCATABLE :: DPSM(:,:,:,:,:)
      COMPLEX*16 DINT,DSRF(-1:1),DXYZ(3),CGNT,DCOR(-1:1)
     &  ,DHLF(3,NATOM,3,NATOM,4)
	DATA PI/3.141592653589793D0/
C Memory allocations
	ALLOCATE(WORK1(0:NRADMEM))
	ALLOCATE(WORK2(0:NRADMEM))
	ALLOCATE(DVDR(0:NRADMEM,LIMVMEM))
	ALLOCATE(DVLMDR(0:NRADMEM))
	ALLOCATE(VR2(0:NRADMEM,LIMVMEM))
	ALLOCATE(DPSM(-1:1,NATOMMEM,3,NATOMMEM,4))
	SQPI4=2.D0*SQRT(PI)
	DO 1 INUC1=1,NATOM
	DO 1 INUC =1,NATOM
	DO 1 IXYZ1=1,3
	DO 1 IXYZ =1,3
	DO 1 MY1=-1,1
	DO 1 IC=1,4
	DHLF(IXYZ1,INUC1,IXYZ,INUC,IC)=(0.D0,0.D0)
	DPSM(MY1  ,INUC1,IXYZ,INUC,IC)=(0.D0,0.D0)
   1	CONTINUE
	DO 2000 INUC1=1,NATOM                      !!! over displacements
	DO 1000 MY1=-1,1                           !!! over polarizations
	IF(NITER(MY1,INUC1).EQ.0)GOTO1000
      CALL DRO_DROFILES(MY1,INUC1,IQPNT,IUDPX,'R','D',' ')  !!! read change in density
      CALL DPT_DSVFILES(MY1,INUC1,IQPNT,IUDSV,'R','D',' ')  !!! read change in potential
	DO 40 INUC=1,NATOM                         !!! over displacements
	ISORT=IS(INUC)
	DO 30 MY=-1,1                              !!! over polarizations
	DSRF(MY)=(0.D0,0.D0)
	LM=3-MY
	CGNT=(0.D0,1.D0)/SQRT(3.D0)*(-1)**MY/SQRT(4.D0*PI)
	DO 20 IUPDN=1,NSPIN                        !!! over spins
	DO 10 IRAD=0,NRAD(ISORT)                   !!! over radial mesh
	WORK1(IRAD)=DRHO(IRAD,LM,INUC,IUPDN,1)*DR(IRAD,ISORT)
  10	CONTINUE                                   !!! over radial mesh
	CALL LIB_CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	DSRF(MY)=DSRF(MY)-ZNUC(ISORT)*CGNT*(4.D0*PI*2.D0*
     &  WORK2(NRAD(ISORT))+3.D0*2.D0/SMT(ISORT)*(
     &  DELMAD(1,LM,INUC,IUPDN,MY1,INUC1)+
     &  DELMAD(2,LM,INUC,IUPDN,MY1,INUC1)+
     &  DELMAD(3,LM,INUC,IUPDN,MY1,INUC1)+
     &  DELMAD(4,LM,INUC,IUPDN,MY1,INUC1)+
     &  DELMAD(5,LM,INUC,IUPDN,MY1,INUC1)))
  20	CONTINUE                                   !!! over spins
  30	CONTINUE                                   !!! over polarizations
	CALL PHN_TRANSFER(DSRF(-1),DXYZ(1))
	DPSM(MY1,INUC1,1,INUC,1)=DXYZ(1)
	DPSM(MY1,INUC1,2,INUC,1)=DXYZ(2)
	DPSM(MY1,INUC1,3,INUC,1)=DXYZ(3)
  40	CONTINUE                                   !!! over displacements
C  CALCULATE CORE CORRECTION AND Int(rho*grad(Delta_Veff)
	DO 500 INUC=1,NATOM                        !!! over displacements
	ISORT=IS(INUC)
	DO 240 MY=-1,1                             !!! over polarizations
	DSRF(MY)=(0.D0,0.D0)
	DCOR(MY)=(0.D0,0.D0)
	DO 232 IORBS=1,NORBS                       !!! over spins
	DO 230 IUPDN=1,NSPIN                       !!! over spins
	DO 120 L=0,ILSV(ISORT)                     !!! over l
	DO 110 M=-L,L                              !!! over m
	LM=L*(L+1)+M+1
	DO 50 IRAD=0,NRAD(ISORT)
	WORK1(IRAD)=DPOT(IRAD,LM,INUC,IUPDN,IORBS)
  50	CONTINUE
     	CALL LIB_DRSUB(WORK1,WORK2,NRAD(ISORT),H(ISORT),
     &  R(0,ISORT),DR(0,ISORT))
	DO 60 IRAD=0,NRAD(ISORT)
	DVDR(IRAD,LM)=WORK2(IRAD)*R(IRAD,ISORT)**2
	VR2(IRAD,LM)=DPOT(IRAD,LM,INUC,IUPDN,IORBS)*R(IRAD,ISORT)
  60	CONTINUE
 110	CONTINUE                                   !!! over m
 120	CONTINUE                                   !!! over l
	DO 220 L=0,ILSV(ISORT)                     !!! over l
	DO 210 M=-L,L                              !!! over m
	LM=L*(L+1)+M+1
	LMMY=(L-1)*L+M-MY+1
	LMPY=(L+1)*(L+2)+M-MY+1
	DO 130 IRAD=0,NRAD(ISORT)                  !!! over radial mesh
	DVLMDR(IRAD)=(0.D0,0.D0)
	IF(L.GT.0.AND.ABS(M-MY).LE.L-1)THEN
	CGNT=(0.D0,-1.D0)*SQRT(4.D0*PI/3.D0)*C(0,LM,LMMY)
	DVLMDR(IRAD)=DVLMDR(IRAD)+CGNT*(DVDR(IRAD,LMMY)-
     &  DBLE(L-1)*VR2(IRAD,LMMY))
	ENDIF
	IF(L.LT.ILSV(ISORT))THEN
	CGNT=(0.D0,+1.D0)*SQRT(4.D0*PI/3.D0)*C(0,LM,LMPY)
	DVLMDR(IRAD)=DVLMDR(IRAD)+CGNT*(DVDR(IRAD,LMPY)+
     &  DBLE(L+2)*VR2(IRAD,LMPY))
	ENDIF
 130	CONTINUE                                   !!! over radial mesh
	ISYM=LMSYM(LM,INUC)
	IF(SYM(LM,INUC))THEN
	DO 140 IRAD=0,NRAD(ISORT)                  !!! over radial mesh
	WORK1(IRAD)=DCONJG(RHO(IRAD,ISYM,INUC,IUPDN,IORBS))*DVLMDR(IRAD)*
     &  DR(IRAD,ISORT)
 140 	CONTINUE                                   !!! over radial mesh
	CALL LIB_CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	DSRF(MY)=DSRF(MY)+WORK2(NRAD(ISORT))
	ENDIF
	IF(L.EQ.0.AND.IORBS.EQ.1)THEN
	DO 150 IRAD=0,NRAD(ISORT)                  !!! over radial mesh
	WORK1(IRAD)=RHOCOR(IRAD,ISORT,IUPDN)*DVLMDR(IRAD)*
     &  DR(IRAD,ISORT)
 150	CONTINUE                                   !!! over radial mesh
	CALL LIB_CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	DCOR(MY)=DCOR(MY)+WORK2(NRAD(ISORT))
	ENDIF
 210  CONTINUE                                   !!! over m
 220  CONTINUE                                   !!! over l
 230  CONTINUE                                   !!! over spins
 232  CONTINUE                                   !!! over spins
 240  CONTINUE                                   !!! over polarizations
C  CALCULATE Int(Delta_rho*grad(Veff)
	DO 440 MY=-1,1                             !!! over polarizations
	DO 432 IORBS=1,NORBS                       !!! over spins
	DO 430 IUPDN=1,NSPIN                       !!! over spins
	DO 320 L=0,ILSV(ISORT)                     !!! over l
	DO 310 M=-L,L                              !!! over m
	LM=L*(L+1)+M+1
	DO 245 IRAD=0,NRAD(ISORT)
	DVDR(IRAD,LM)=(0.D0,0.D0)
	VR2(IRAD,LM)=(0.D0,0.D0)
 245	CONTINUE
      IF(.NOT.SYM(LM,INUC))GOTO310
      ISYM=LMSYM(LM,INUC)
      IF(ISYM.NE.1)THEN
	DO 250 IRAD=0,NRAD(ISORT)
	WORK1(IRAD)=POT(IRAD,ISYM,INUC,IUPDN,IORBS)
 250	CONTINUE
     	CALL LIB_DRSUB(WORK1,WORK2,NRAD(ISORT),H(ISORT),
     &  R(0,ISORT),DR(0,ISORT))
	DO 260 IRAD=0,NRAD(ISORT)
	DVDR(IRAD,LM)=WORK2(IRAD)*R(IRAD,ISORT)**2
	VR2(IRAD,LM)=POT(IRAD,ISYM,INUC,IUPDN,IORBS)*R(IRAD,ISORT)
 260	CONTINUE
      ELSEIF(ISYM.EQ.1)THEN
      WORK1(0)=2.D0*ZNUC(ISORT)
      DO 270 IRAD=1,NRAD(ISORT)
      WORK1(IRAD)=-R(IRAD,ISORT)*POT(IRAD,1,INUC,IUPDN,IORBS)/
     &SQRT(4.D0*PI)
 270  CONTINUE
      CALL LIB_DRSUB(WORK1,WORK2,NRAD(ISORT),H(ISORT),
     &R(0,ISORT),DR(0,ISORT))
      DVDR(0,ISYM)=2.D0*ZNUC(ISORT)*SQPI4
      VR2(0,ISYM)=-2.D0*ZNUC(ISORT)*SQPI4
      DO 280 IRAD=1,NRAD(ISORT)
      DVDR(IRAD,ISYM)=-R(IRAD,ISORT)*POT(IRAD,1,INUC,IUPDN,IORBS)-
     &WORK2(IRAD)*R(IRAD,ISORT)*SQPI4
      VR2(IRAD,ISYM)=R(IRAD,ISORT)*POT(IRAD,1,INUC,IUPDN,IORBS)
 280  CONTINUE
      ENDIF
 310	CONTINUE                                   !!! over m
 320	CONTINUE                                   !!! over l
	DO 420 L=0,ILSV(ISORT)                     !!! over l
	DO 410 M=-L,L                              !!! over m
	LM=L*(L+1)+M+1
	LMMY=(L-1)*L+M-MY+1
	LMPY=(L+1)*(L+2)+M-MY+1
	DO 330 IRAD=0,NRAD(ISORT)                  !!! over radial mesh
	DVLMDR(IRAD)=(0.D0,0.D0)
	IF(L.GT.0.AND.ABS(M-MY).LE.L-1)THEN
	CGNT=(0.D0,-1.D0)*SQRT(4.D0*PI/3.D0)*C(0,LM,LMMY)
	DVLMDR(IRAD)=DVLMDR(IRAD)+CGNT*(DVDR(IRAD,LMMY)-
     &  DBLE(L-1)*VR2(IRAD,LMMY))
	ENDIF
	IF(L.LT.ILSV(ISORT))THEN
	CGNT=(0.D0,+1.D0)*SQRT(4.D0*PI/3.D0)*C(0,LM,LMPY)
	DVLMDR(IRAD)=DVLMDR(IRAD)+CGNT*(DVDR(IRAD,LMPY)+
     &  DBLE(L+2)*VR2(IRAD,LMPY))
	ENDIF
 330	CONTINUE                                   !!! over radial mesh
	LMM=L*(L+1)-M+1
	DO 340 IRAD=0,NRAD(ISORT)                  !!! over radial mesh
	WORK1(IRAD)=DRHO(IRAD,LMM,INUC,IUPDN,IORBS)*
     &  DVLMDR(IRAD)*DR(IRAD,ISORT)*(-1)**(L+M)
 340 	CONTINUE                                   !!! over radial mesh
	CALL LIB_CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	DSRF(MY)=DSRF(MY)+WORK2(NRAD(ISORT))
 410  CONTINUE                                   !!! over m
 420  CONTINUE                                   !!! over l
 430  CONTINUE                                   !!! over spins
 432  CONTINUE                                   !!! over spins
 440  CONTINUE                                   !!! over polarizations
	CALL PHN_TRANSFER(DSRF(-1),DXYZ(1))
	DPSM(MY1,INUC1,1,INUC,2)=DXYZ(1)
	DPSM(MY1,INUC1,2,INUC,2)=DXYZ(2)
	DPSM(MY1,INUC1,3,INUC,2)=DXYZ(3)
	CALL PHN_TRANSFER(DCOR(-1),DXYZ(1))
	DPSM(MY1,INUC1,1,INUC,3)=DXYZ(1)
	DPSM(MY1,INUC1,2,INUC,3)=DXYZ(2)
	DPSM(MY1,INUC1,3,INUC,3)=DXYZ(3)
 500  CONTINUE                                   !!! over displacements
1000 	CONTINUE                                   !!! over polarizations
2000	CONTINUE                                   !!! over displacements
C  TRANFERE TO CARTESIAN COORDINATES
	DO 640 INUC1=1,NATOM
	DO 630 INUC=1,NATOM
	DO 620 IXYZ=1,3
	DO 610 IC=1,4
	CALL PHN_TRANSFER(DPSM(-1,INUC1,IXYZ,INUC,IC),
     &              DHLF( 1,INUC1,IXYZ,INUC,IC))
 610	CONTINUE
 620	CONTINUE
 630	CONTINUE
 640	CONTINUE
C Memory deallocations
	DEALLOCATE(WORK1,WORK2,DVDR,DVLMDR,VR2,DPSM)
	END




	SUBROUTINE PHN_SMT0MAT(DMT0,IQPNT)
*****************************************************************
*  Calculates MT-zero contribution to the Dynamical Matrix.     *
*****************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
      USE COM_PHNCOM,  ONLY : ITERMAX,NITER                              !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
     &                       ,NHSORT
	USE COM_RADMESH, ONLY : NRAD,H,R,DR,WEIGHT,RL                      !!! from radmsh
	USE COM_LATPAR,  ONLY : PAR,ORTH,OMEGAC                            !!! from readini
	USE COM_QMESH,   ONLY : NQPNT,QPNT                                 !!! from readpnt
	USE COM_SPHERE,  ONLY : SWZ,SMT                                    !!! from readini
	USE COM_DENDAT,  ONLY : RHO,RHOCOR,RHOPS                           !!! from readscf
	USE COM_DELPOT,  ONLY : DPOT,DPOTPS,DPOTPS1                        !!! from delpot
      USE COM_DELRHO,  ONLY : DRHO,DRHOPS,DRHOPS1                        !!! from delrho
	USE COM_PLWMESH, ONLY : NPLW,GPLW                                  !!! from makeplw
	USE COM_POTDAT,  ONLY : POT,POTSPH,POTPS,POTPS1                    !!! from fulpot
	USE COM_SYMMLM,  ONLY : SYM,LMSYM                                  !!! from makesym
      USE COM_PLW2MSH, ONLY : N2PLW,G2PLW	                               !!! from makeplw
	USE COM_GAUNT,   ONLY : C                                          !!! from makegnt
	USE COM_POTMTS,  ONLY : VMT0,VMT,VSF0,VSF                          !!! from vzero
      USE COM_DROMULT, ONLY : DELMRO,DELMAD                              !!! from dmultrho
	USE COM_ZERODV,  ONLY : DVAV,DVMT,DVMT0                            !!! from dvzero
	USE COM_PHNCHN,  ONLY : IUDRO,IUDPX,IUDRX,IUDPY,IUDRY,IUDSV,IUDPV  !!! from channels
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8, ALLOCATABLE :: WORK3(:)
	REAL*8, ALLOCATABLE :: WORK4(:)
	COMPLEX*16, ALLOCATABLE :: WORK1(:)
	COMPLEX*16, ALLOCATABLE :: WORK2(:)
	COMPLEX*16, ALLOCATABLE :: TMPARR(:)
	COMPLEX*16, ALLOCATABLE :: DPSM(:,:,:,:,:)
	REAL*8  TR1,TR2
      COMPLEX*16 CGNT,DCOR(-1:1),DXYZ(3),GMY1,DINT,DSRF(-1:1)
     &    ,DMT0(3,NATOMMEM,3,NATOMMEM,4)
	DATA PI/3.141592653589793D0/
	SQPI4=2.D0*SQRT(PI)
	DO 10 INUC1=1,NATOM
	DO 10 INUC =1,NATOM
	DO 10 IXYZ1=1,3
	DO 10 IXYZ =1,3
	DO 10 MY1=-1,1
	DO 10 IC=1,4
	DMT0(IXYZ1,INUC1,IXYZ,INUC,IC)=(0.D0,0.D0)
  10	CONTINUE
	IF(NPFR.EQ.0)RETURN
C Memory allocations
	ALLOCATE(WORK1(0:NRADMEM))
	ALLOCATE(WORK2(0:NRADMEM))
	ALLOCATE(WORK3(0:NRADMEM))
	ALLOCATE(WORK4(0:NRADMEM))
	ALLOCATE(TMPARR(0:NPLWMEM))
	ALLOCATE(DPSM(-1:1,NATOMMEM,3,NATOMMEM,4))
	DO 20 INUC1=1,NATOM
	DO 20 INUC =1,NATOM
	DO 20 IXYZ1=1,3
	DO 20 IXYZ =1,3
	DO 20 MY1=-1,1
	DO 20 IC=1,4
	DPSM(MY1,INUC1,IXYZ,INUC,IC)=(0.D0,0.D0)
  20	CONTINUE
C  SET MT-ZERO CONTRIBUTION TO DYNAMICAL MATRIX
	DO 2000 INUC1=1,NATOM                      !!! over displacements
	DO 1000 MY1=-1,1                           !!! over polarizations
	IF(NITER(MY1,INUC1).EQ.0)GOTO1000
      CALL DRO_DROFILES(MY1,INUC1,IQPNT,IUDPX,'R','D',' ')  !!! read change in density
      CALL DPT_DSVFILES(MY1,INUC1,IQPNT,IUDSV,'R','D',' ')  !!! read change in potential
      CALL DRO_DPSFILES(MY1,INUC1,IQPNT,IUDPY,'R','D',' ')  !!! read change in density
      CALL DPT_DPVFILES(MY1,INUC1,IQPNT,IUDPV,'R','D',' ')  !!! read change in potential
	IF(NPFR.NE.0)THEN !!! slow/fast calculation
C  CALCULATE DMT01=d(+)/d(t1,i1)*Int[grad_i(rho)*Vmt0]
C  1) Dmt01_1=Int[grad_i[d(+)rho/d(t1,i1)]*Vmt0]
	DO 120 IXYZ =1,3                           !!! over polarizations
	DO 118 IUPDN=1,NSPIN                       !!! over spins
	DO 116 INUC=1,NATOM                        !!! over displacements
	DO 114 I2PLW=0,NPLW                        !!! over plane waves
	CALL INI_MAKEPLW_DINT(G2PLW(1,I2PLW)+QPNT(1,IQPNT),
     &                      G2PLW(2,I2PLW)+QPNT(2,IQPNT),
     &                      G2PLW(3,I2PLW)+QPNT(3,IQPNT),DINT,INUC)
	TMPARR(I2PLW)=DRHOPS(I2PLW,IUPDN,1)*2.D0*PI/PAR*
     &  (QPNT(IXYZ,IQPNT)+GPLW(IXYZ,I2PLW))*(0.D0,1.D0)
	DPSM(MY1,INUC1,IXYZ,INUC,1)=
     &DPSM(MY1,INUC1,IXYZ,INUC,1)+TMPARR(I2PLW)*DINT*VMT0
 114	CONTINUE                                   !!! over palne waves 
 116	CONTINUE                                   !!! over displacements
 118	CONTINUE                                   !!! over spins
 120	CONTINUE                                   !!! over polarizations
C  2) Dmt01_2=Int[grad_i(rho)*d(+)Vmt0/d(t1,i1)]
	DO 130 IXYZ =1,3                           !!! over polarizations
	DO 128 IUPDN=1,NSPIN                       !!! over spins
	DO 126 INUC=1,NATOM                        !!! over displacements
	DO 124 I2PLW=0,NPLW                        !!! over plane waves
	CALL INI_MAKEPLW_DINT(G2PLW(1,I2PLW)+QPNT(1,IQPNT),
     &                      G2PLW(2,I2PLW)+QPNT(2,IQPNT),
     &                      G2PLW(3,I2PLW)+QPNT(3,IQPNT),DINT,INUC)
	TMPARR(I2PLW)=RHOPS(I2PLW,IUPDN,1)*2.D0*PI/PAR*
     &  GPLW(IXYZ,I2PLW)*(0.D0,1.D0)
	DPSM(MY1,INUC1,IXYZ,INUC,1)=
     &DPSM(MY1,INUC1,IXYZ,INUC,1)+TMPARR(I2PLW)*DINT*DVMT0(MY1,INUC1)
 124	CONTINUE                                   !!! over palne waves 
 126	CONTINUE                                   !!! over displacements
 128	CONTINUE                                   !!! over spins
 130	CONTINUE                                   !!! over polarizations
C  3) Dmt01_3=d(+)Int/d(t1,i1)[grad_i(rho)*Vmt0]
	DO 140 IXYZ =1,3                           !!! over polarizations
	DO 138 IUPDN=1,NSPIN                       !!! over spins
	DO 136 INUC=1,NATOM                        !!! over displacements
	IF(INUC1.EQ.INUC)THEN
	DO 134 I2PLW=0,NPLW                        !!! over plane waves
        IF(MY1.EQ.-1)GMY1=+1.D0/SQRT(2.D0)*
     &  (G2PLW(1,I2PLW)-(0.D0,1.D0)*G2PLW(2,I2PLW))
        IF(MY1.EQ.+1)GMY1=-1.D0/SQRT(2.D0)*
     &  (G2PLW(1,I2PLW)+(0.D0,1.D0)*G2PLW(2,I2PLW))
        IF(MY1.EQ. 0)GMY1=G2PLW(3,I2PLW)
	CALL INI_MAKEPLW_DINT(G2PLW(1,I2PLW),
     &                      G2PLW(2,I2PLW),
     &                      G2PLW(3,I2PLW),DINT,INUC)
	DINT=DINT*2.D0*PI/PAR*(0.D0,1.D0)*GMY1
	TMPARR(I2PLW)=RHOPS(I2PLW,IUPDN,1)*2.D0*PI/PAR*
     &  G2PLW(IXYZ,I2PLW)*(0.D0,1.D0)
	DPSM(MY1,INUC1,IXYZ,INUC,1)=
     &DPSM(MY1,INUC1,IXYZ,INUC,1)+TMPARR(I2PLW)*DINT*VMT0
 134	CONTINUE                                   !!! over palne waves 
	ENDIF
 136	CONTINUE                                   !!! over displacements
 138	CONTINUE                                   !!! over spins
 140	CONTINUE                                   !!! over polarizations
	ENDIF   !!! slow/fast calculations
C  ESTIMATE SURFACE INTEGRALS FROM CHARGE DENSITY AND POTENTIAL
	DO 580 INUC=1,NATOM                        !!! over inuc
	ISORT=IS(INUC)
	DO 570 MY=-1,1                             !!! over my
	DSRF(MY)=(0.D0,0.D0)
	DO 510 IUPDN=1,NSPIN                       !!! over spins
	LM=3-MY
	ISYM=LMSYM(LM,INUC)
	IF(SYM(LM,INUC))
     &  DSRF(MY)=DSRF(MY)+(0.D0,1.D0)*SQRT(4.D0*PI/3.D0)*
     &  (-1)**MY*SMT(ISORT)**2*
     &  RHO(NRAD(ISORT),ISYM,INUC,IUPDN,1)*
     &  DVMT0(MY1,INUC1)
	DSRF(MY)=DSRF(MY)+(0.D0,1.D0)*SQRT(4.D0*PI/3.D0)*
     &  (-1)**MY*SMT(ISORT)**2*VMT0*
     &  DRHO(NRAD(ISORT),LM,INUC,IUPDN,1)
 510 	CONTINUE                                   !!! over spins
 570	CONTINUE                                   !!! over my
	CALL PHN_TRANSFER(DSRF(-1),DXYZ(1))
	DPSM(MY1,INUC1,1,INUC,4)=DXYZ(1)
	DPSM(MY1,INUC1,2,INUC,4)=DXYZ(2)
	DPSM(MY1,INUC1,3,INUC,4)=DXYZ(3)
 580	CONTINUE                                   !!! over inuc
1000 	CONTINUE                                   !!! over polarizations
2000	CONTINUE                                   !!! over displacements
C  TRANFERE TO CARTESIAN COORDINATES
	DO 640 INUC1=1,NATOM
	DO 630 INUC=1,NATOM
	DO 620 IXYZ=1,3
	DO 610 IC=1,4
	CALL PHN_TRANSFER(DPSM(-1,INUC1,IXYZ,INUC,IC),
     &              DMT0( 1,INUC1,IXYZ,INUC,IC))
 610	CONTINUE
 620	CONTINUE
 630	CONTINUE
 640	CONTINUE
C Memory deallocations
	DEALLOCATE(WORK1,WORK2,WORK3,WORK4,TMPARR,DPSM)
	END



	SUBROUTINE PHN_SPTNMAT(DPTN,IQPNT)
*****************************************************************
*  Calculates potential contribution to the Dynamical Matrix.   *
*****************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
      USE COM_PHNCOM,  ONLY : ITERMAX,NITER                              !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
     &                       ,NHSORT
	USE COM_RADMESH, ONLY : NRAD,H,R,DR,WEIGHT,RL                      !!! from radmsh
	USE COM_LATPAR,  ONLY : PAR,ORTH,OMEGAC                            !!! from readini
	USE COM_SPHERE,  ONLY : SWZ,SMT                                    !!! from readini
	USE COM_QMESH,   ONLY : NQPNT,QPNT                                 !!! from readpnt
	USE COM_SYMMLM,  ONLY : SYM,LMSYM                                  !!! from makesym
	USE COM_POTDAT,  ONLY : POT,POTSPH,POTPS,POTPS1                    !!! from fulpot
	USE COM_DELPOT,  ONLY : DPOT,DPOTPS,DPOTPS1                        !!! from delpot
      USE COM_DELRHO,  ONLY : DRHO,DRHOPS,DRHOPS1                        !!! from delrho
      USE COM_PLW2MSH, ONLY : N2PLW,G2PLW	                               !!! from makeplw
	USE COM_PLWMESH, ONLY : NPLW,GPLW                                  !!! from makeplw
	USE COM_POTMTS,  ONLY : VMT0,VMT,VSF0,VSF                          !!! from vzero
	USE COM_DENDAT,  ONLY : RHO,RHOCOR,RHOPS,RHOPS1                    !!! from readscf
      USE COM_DROMULT, ONLY : DELMRO,DELMAD                              !!! from dmultrho
	USE COM_GAUNT,   ONLY : C                                          !!! from makegnt
	USE COM_PHNCHN  ,ONLY : IUDRO,IUDPX,IUDRX,IUDPY,IUDRY,IUDSV,IUDPV  !!! from channels
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8, ALLOCATABLE :: WORK3(:)
	REAL*8, ALLOCATABLE :: WORK4(:)
	COMPLEX*16, ALLOCATABLE :: WORK1(:)
	COMPLEX*16, ALLOCATABLE :: WORK2(:)
	COMPLEX*16, ALLOCATABLE :: PROD(:)
	COMPLEX*16, ALLOCATABLE :: TMPARR(:)
	COMPLEX*16, ALLOCATABLE :: DPSM(:,:,:,:,:)
	REAL*8 TR1,TR2
	COMPLEX*16 DCOR(-1:1),GMY1,DXYZ(3),DINT,DSRF(-1:1),CGNT
     &   ,DPTN(3,NATOMMEM,3,NATOMMEM,4)
	DATA PI/3.141592653589793D0/
	DO 1 INUC1=1,NATOM
	DO 1 INUC =1,NATOM
	DO 1 IXYZ1=1,3
	DO 1 IXYZ =1,3
	DO 1 MY1=-1,1
	DO 1 IC=1,4
	DPTN(IXYZ1,INUC1,IXYZ,INUC,IC)=(0.D0,0.D0)
   1  CONTINUE
      IF(NPFR.EQ.0)RETURN
C Memory allocations
	ALLOCATE(WORK1(0:NRADMEM))
	ALLOCATE(WORK2(0:NRADMEM))
	ALLOCATE(WORK3(0:NRADMEM))
	ALLOCATE(WORK4(0:NRADMEM))
	ALLOCATE(PROD(0:9*NPLWMEM))
	ALLOCATE(TMPARR(0:NPLWMEM))
	ALLOCATE(DPSM(-1:1,NATOMMEM,3,NATOMMEM,4))
	SQPI4=2.D0*SQRT(PI)
	DO 10 INUC1=1,NATOM
	DO 10 INUC =1,NATOM
	DO 10 IXYZ1=1,3
	DO 10 IXYZ =1,3
	DO 10 MY1=-1,1
	DO 10 IC=1,4
	DPSM(  MY1,INUC1,IXYZ,INUC,IC)=(0.D0,0.D0)
  10	CONTINUE
C  SET POTENTIAL CONTRIBUTION TO DYNAMICAL MATRIX
	DO 2000 INUC1=1,NATOM                      !!! over displacements
	DO 1000 MY1=-1,1                           !!! over polarizations
	IF(NITER(MY1,INUC1).EQ.0)GOTO1000
      CALL DRO_DROFILES(MY1,INUC1,IQPNT,IUDPX,'R','D',' ')  !!! read change in density
      CALL DPT_DSVFILES(MY1,INUC1,IQPNT,IUDSV,'R','D',' ')  !!! read change in potential
      CALL DRO_DPSFILES(MY1,INUC1,IQPNT,IUDPY,'R','D',' ')  !!! read change in density
      CALL DPT_DPVFILES(MY1,INUC1,IQPNT,IUDPV,'R','D',' ')  !!! read change in potential
	IF(NPFR.EQ.1)THEN !!! slow calculation
C  CALCULATE DPTN1=d(+)/d(t1,i1)*Int[grad_i(rho)*Veff]
C  1) Dptn1_1=Int[grad_i[d(+)rho/d(t1,i1)]*Veff]
	DO 120 IXYZ =1,3                           !!! over polarizations
	DO 119 IORBS=1,NORBS                       !!! over iorbs
	DO 118 IUPDN=1,NSPIN                       !!! over iupdn
	DO 112 IPLW=0,NPLW                         !!! over plane waves
	TMPARR(IPLW)=DRHOPS(IPLW,IUPDN,IORBS)*2.D0*PI/PAR*
     &  (QPNT(IXYZ,IQPNT)+GPLW(IXYZ,IPLW))*(0.D0,1.D0)
 112	CONTINUE                                   !!! over plane waves
	CALL PHN_RHOVSUB(POTPS(0,IUPDN,IORBS),TMPARR,PROD)
	DO 116 INUC=1,NATOM                        !!! over displacements
	DO 114 I2PLW=0,N2PLW                       !!! over plane waves
	CALL INI_MAKEPLW_DINT(G2PLW(1,I2PLW)+QPNT(1,IQPNT),
     &                      G2PLW(2,I2PLW)+QPNT(2,IQPNT),
     &                      G2PLW(3,I2PLW)+QPNT(3,IQPNT),DINT,INUC)
	DPSM(MY1,INUC1,IXYZ,INUC,1)=
     &DPSM(MY1,INUC1,IXYZ,INUC,1)+PROD(I2PLW)*DINT
 114	CONTINUE                                   !!! over palne waves 
 116	CONTINUE                                   !!! over displacements
 118	CONTINUE                                   !!! over iupdn
 119	CONTINUE                                   !!! over iorbs
 120	CONTINUE                                   !!! over polarizations
C  2) Dptn1_2=Int[grad_i(rho)*d(+)Veff/d(t1,i1)]
	DO 130 IXYZ =1,3                           !!! over polarizations
	DO 129 IORBS=1,NORBS                       !!! over iorbs
	DO 128 IUPDN=1,NSPIN                       !!! over iupdn
	DO 122 IPLW=0,NPLW                         !!! over plane waves
	TMPARR(IPLW)=RHOPS(IPLW,IUPDN,IORBS)*2.D0*PI/PAR*
     &  GPLW(IXYZ,IPLW)*(0.D0,1.D0)
 122	CONTINUE                                   !!! over plane waves
	CALL PHN_RHOVSUB(TMPARR,DPOTPS(0,IUPDN,IORBS),PROD)
	DO 126 INUC=1,NATOM                        !!! over displacements
	DO 124 I2PLW=0,N2PLW                       !!! over plane waves
	CALL INI_MAKEPLW_DINT(G2PLW(1,I2PLW)+QPNT(1,IQPNT),
     &                      G2PLW(2,I2PLW)+QPNT(2,IQPNT),
     &                      G2PLW(3,I2PLW)+QPNT(3,IQPNT),DINT,INUC)
	DPSM(MY1,INUC1,IXYZ,INUC,1)=
     &DPSM(MY1,INUC1,IXYZ,INUC,1)+PROD(I2PLW)*DINT
 124	CONTINUE                                   !!! over palne waves 
 126	CONTINUE                                   !!! over displacements
 128	CONTINUE                                   !!! over iupdn
 129	CONTINUE                                   !!! over iorbs
 130	CONTINUE                                   !!! over polarizations
C  3) Dptn1_3=d(+)Int/d(t1,i1)[grad_i(rho)*Vexc]
	DO 140 IXYZ =1,3                           !!! over polarizations
	DO 139 IORBS=1,NORBS                       !!! over iorbs
	DO 138 IUPDN=1,NSPIN                       !!! over spins
	DO 132 IPLW=0,NPLW                         !!! over plane waves
	TMPARR(IPLW)=RHOPS(IPLW,IUPDN,IORBS)*2.D0*PI/PAR*
     &  GPLW(IXYZ,IPLW)*(0.D0,1.D0)
 132	CONTINUE                                   !!! over plane waves
	CALL PHN_RHOVSUB(TMPARR,POTPS(0,IUPDN,IORBS),PROD)
	DO 136 INUC=1,NATOM                        !!! over displacements
	IF(INUC1.EQ.INUC)THEN
	DO 134 I2PLW=0,N2PLW                       !!! over plane waves
      IF(MY1.EQ.-1)GMY1=+1.D0/SQRT(2.D0)*
     &  (G2PLW(1,I2PLW)-(0.D0,1.D0)*G2PLW(2,I2PLW))
      IF(MY1.EQ.+1)GMY1=-1.D0/SQRT(2.D0)*
     &  (G2PLW(1,I2PLW)+(0.D0,1.D0)*G2PLW(2,I2PLW))
      IF(MY1.EQ. 0)GMY1=G2PLW(3,I2PLW)
	CALL INI_MAKEPLW_DINT(G2PLW(1,I2PLW),
     &                      G2PLW(2,I2PLW),
     &                       G2PLW(3,I2PLW),DINT,INUC)
	DINT=DINT*2.D0*PI/PAR*(0.D0,1.D0)*GMY1
	DPSM(MY1,INUC1,IXYZ,INUC,1)=
     &DPSM(MY1,INUC1,IXYZ,INUC,1)+PROD(I2PLW)*DINT
 134	CONTINUE                                   !!! over palne waves 
	ENDIF
 136	CONTINUE                                   !!! over displacements
 138	CONTINUE                                   !!! over iupdn
 139	CONTINUE                                   !!! over iorbs
 140	CONTINUE                                   !!! over polarizations
C  CALCULATE DPTN2=d(+)/d(t1,i1)*Int[rho*grad_i(Veff)]
C  1) Dptn2_1=Int[d(+)rho/d(t1,i1)*grad_i(Veff)]
	DO 150 IXYZ =1,3                           !!! over polarizations
	DO 149 IORBS=1,NORBS                       !!! over spins
	DO 148 IUPDN=1,NSPIN                       !!! over spins
	DO 142 IPLW=0,NPLW                         !!! over plane waves
	TMPARR(IPLW)=POTPS(IPLW,IUPDN,IORBS)*2.D0*PI/PAR*
     &  GPLW(IXYZ,IPLW)*(0.D0,1.D0)
 142	CONTINUE                                   !!! over plane waves
	CALL PHN_RHOVSUB(TMPARR,DRHOPS(0,IUPDN,IORBS),PROD)
	DO 146 INUC=1,NATOM                        !!! over displacements
	DO 144 I2PLW=0,N2PLW                       !!! over plane waves
	CALL INI_MAKEPLW_DINT(G2PLW(1,I2PLW)+QPNT(1,IQPNT),
     &                      G2PLW(2,I2PLW)+QPNT(2,IQPNT),
     &                      G2PLW(3,I2PLW)+QPNT(3,IQPNT),DINT,INUC)
	DPSM(MY1,INUC1,IXYZ,INUC,2)=
     &DPSM(MY1,INUC1,IXYZ,INUC,2)+PROD(I2PLW)*DINT
 144	CONTINUE                                   !!! over palne waves 
 146	CONTINUE                                   !!! over displacements
 148	CONTINUE                                   !!! over spins
 149	CONTINUE                                   !!! over spins
 150	CONTINUE                                   !!! over polarizations
C  2) Dptn2_2=Int[rho*grad_i[d(+)Veff/d(t1,i1)]]
	DO 160 IXYZ =1,3                           !!! over polarizations
	DO 159 IORBS=1,NORBS                       !!! over spins
	DO 158 IUPDN=1,NSPIN                       !!! over spins
	DO 152 IPLW=0,NPLW                         !!! over plane waves
	TMPARR(IPLW)=DPOTPS(IPLW,IUPDN,IORBS)*2.D0*PI/PAR*
     &  (QPNT(IXYZ,IQPNT)+GPLW(IXYZ,IPLW))*(0.D0,1.D0)
 152	CONTINUE                                   !!! over plane waves
	CALL PHN_RHOVSUB(RHOPS(0,IUPDN,IORBS),TMPARR,PROD)
	DO 156 INUC=1,NATOM                        !!! over displacements
	DO 154 I2PLW=0,N2PLW                       !!! over plane waves
	CALL INI_MAKEPLW_DINT(G2PLW(1,I2PLW)+QPNT(1,IQPNT),
     &                      G2PLW(2,I2PLW)+QPNT(2,IQPNT),
     &                      G2PLW(3,I2PLW)+QPNT(3,IQPNT),DINT,INUC)
	DPSM(MY1,INUC1,IXYZ,INUC,2)=
     &  DPSM(MY1,INUC1,IXYZ,INUC,2)+PROD(I2PLW)*DINT
 154	CONTINUE                                   !!! over palne waves 
 156	CONTINUE                                   !!! over displacements
 158	CONTINUE                                   !!! over spins
 159	CONTINUE                                   !!! over spins
 160	CONTINUE                                   !!! over polarizations
C  3) Dptn2_3=d(+)Int/d(t1,i1)[rho*grad_i(Veff)]
	DO 170 IXYZ =1,3                           !!! over polarizations
	DO 169 IORBS=1,NORBS                       !!! over spins
	DO 168 IUPDN=1,NSPIN                       !!! over spins
	DO 162 IPLW=0,NPLW                         !!! over plane waves
	TMPARR(IPLW)=POTPS(IPLW,IUPDN,IORBS)*2.D0*PI/PAR*
     &  GPLW(IXYZ,IPLW)*(0.D0,1.D0)
 162	CONTINUE                                   !!! over plane waves
	CALL PHN_RHOVSUB(RHOPS(0,IUPDN,IORBS),TMPARR,PROD)
	DO 166 INUC=1,NATOM                        !!! over displacements
	IF(INUC1.EQ.INUC)THEN
	DO 164 I2PLW=0,N2PLW                       !!! over plane waves
      IF(MY1.EQ.-1)GMY1=+1.D0/SQRT(2.D0)*
     &  (G2PLW(1,I2PLW)-(0.D0,1.D0)*G2PLW(2,I2PLW))
      IF(MY1.EQ.+1)GMY1=-1.D0/SQRT(2.D0)*
     &  (G2PLW(1,I2PLW)+(0.D0,1.D0)*G2PLW(2,I2PLW))
      IF(MY1.EQ. 0)GMY1=G2PLW(3,I2PLW)
	CALL INI_MAKEPLW_DINT(G2PLW(1,I2PLW),
     &                      G2PLW(2,I2PLW),
     &                      G2PLW(3,I2PLW),DINT,INUC)
	DINT=DINT*2.D0*PI/PAR*(0.D0,1.D0)*GMY1
	DPSM(MY1,INUC1,IXYZ,INUC,2)=
     &DPSM(MY1,INUC1,IXYZ,INUC,2)+PROD(I2PLW)*DINT
 164	CONTINUE                                   !!! over palne waves 
	ENDIF
 166	CONTINUE                                   !!! over displacements
 168	CONTINUE                                   !!! over spins
 169	CONTINUE                                   !!! over spins
 170	CONTINUE                                   !!! over polarizations
	ELSEIF(NPFR.EQ.2)THEN !!! fast calculation
C  CALCULATE DPTN1=d(+)/d(t1,i1)*Int[grad_i(rho*Veff)]
C  1) Dptn1_1=Int[grad_i[d(+)rho/d(t1,i1)*Veff]]
	DO 319 IORBS=1,NORBS                       !!! over spins
	DO 318 IUPDN=1,NSPIN                       !!! over spins
	DO 312 IPLW=0,NPLW                         !!! over plane waves
	TMPARR(IPLW)=DRHOPS(IPLW,IUPDN,IORBS)
 312	CONTINUE                                   !!! over plane waves
	CALL PHN_RHOVSUB(POTPS(0,IUPDN,IORBS),TMPARR,PROD)
	DO 316 INUC=1,NATOM                        !!! over displacements
	DO 314 I2PLW=0,N2PLW                       !!! over plane waves
	CALL INI_MAKEPLW_DINT(G2PLW(1,I2PLW)+QPNT(1,IQPNT),
     &                      G2PLW(2,I2PLW)+QPNT(2,IQPNT),
     &                      G2PLW(3,I2PLW)+QPNT(3,IQPNT),DINT,INUC)
	DINT=DINT*PROD(I2PLW)*(0.D0,1.D0)*2.D0*PI/PAR
	DPSM(MY1,INUC1,1,INUC,1)=
     &DPSM(MY1,INUC1,1,INUC,1)+DINT*(G2PLW(1,I2PLW)+QPNT(1,IQPNT))
	DPSM(MY1,INUC1,2,INUC,1)=
     &DPSM(MY1,INUC1,2,INUC,1)+DINT*(G2PLW(2,I2PLW)+QPNT(2,IQPNT))
	DPSM(MY1,INUC1,3,INUC,1)=
     &DPSM(MY1,INUC1,3,INUC,1)+DINT*(G2PLW(3,I2PLW)+QPNT(3,IQPNT))
 314	CONTINUE                                   !!! over palne waves 
 316	CONTINUE                                   !!! over displacements
 318	CONTINUE                                   !!! over spins
 319	CONTINUE                                   !!! over spins
C  2) Dptn1_2=Int[grad_i[rho*(d(+)Veff/d(t1,i1))]
	DO 329 IORBS=1,NORBS                       !!! over spins
	DO 328 IUPDN=1,NSPIN                       !!! over spins
	DO 322 IPLW=0,NPLW                         !!! over plane waves
	TMPARR(IPLW)=DPOTPS(IPLW,IUPDN,IORBS)
 322	CONTINUE                                   !!! over plane waves
	CALL PHN_RHOVSUB(RHOPS(0,IUPDN,IORBS),TMPARR,PROD)
	DO 326 INUC=1,NATOM                        !!! over displacements
	DO 324 I2PLW=0,N2PLW                       !!! over plane waves
	CALL INI_MAKEPLW_DINT(G2PLW(1,I2PLW)+QPNT(1,IQPNT),
     &                      G2PLW(2,I2PLW)+QPNT(2,IQPNT),
     &                      G2PLW(3,I2PLW)+QPNT(3,IQPNT),DINT,INUC)
	DINT=DINT*PROD(I2PLW)*(0.D0,1.D0)*2.D0*PI/PAR
	DPSM(MY1,INUC1,1,INUC,1)=
     &DPSM(MY1,INUC1,1,INUC,1)+DINT*(G2PLW(1,I2PLW)+QPNT(1,IQPNT))
	DPSM(MY1,INUC1,2,INUC,1)=
     &DPSM(MY1,INUC1,2,INUC,1)+DINT*(G2PLW(2,I2PLW)+QPNT(2,IQPNT))
	DPSM(MY1,INUC1,3,INUC,1)=
     &DPSM(MY1,INUC1,3,INUC,1)+DINT*(G2PLW(3,I2PLW)+QPNT(3,IQPNT))
 324	CONTINUE                                   !!! over palne waves 
 326	CONTINUE                                   !!! over displacements
 328	CONTINUE                                   !!! over spins
 329	CONTINUE                                   !!! over spins
C  3) Dptn1_3=d(+)Int/d(t1,i1)[grad_i[rho*Veff]]
	DO 339 IORBS=1,NORBS                       !!! over spins
	DO 338 IUPDN=1,NSPIN                       !!! over spins
	DO 332 IPLW=0,NPLW                         !!! over plane waves
	TMPARR(IPLW)=POTPS(IPLW,IUPDN,IORBS)
 332	CONTINUE                                   !!! over plane waves
	CALL PHN_RHOVSUB(RHOPS(0,IUPDN,IORBS),TMPARR,PROD)
	DO 336 INUC=1,NATOM                        !!! over displacements
	IF(INUC1.EQ.INUC)THEN
	DO 334 I2PLW=0,N2PLW                       !!! over plane waves
      IF(MY1.EQ.-1)GMY1=+1.D0/SQRT(2.D0)*
     &  (G2PLW(1,I2PLW)-(0.D0,1.D0)*G2PLW(2,I2PLW))
      IF(MY1.EQ.+1)GMY1=-1.D0/SQRT(2.D0)*
     &  (G2PLW(1,I2PLW)+(0.D0,1.D0)*G2PLW(2,I2PLW))
      IF(MY1.EQ. 0)GMY1=G2PLW(3,I2PLW)
	CALL INI_MAKEPLW_DINT(G2PLW(1,I2PLW),
     &                      G2PLW(2,I2PLW),
     &                      G2PLW(3,I2PLW),DINT,INUC)
	DINT=DINT*PROD(I2PLW)*(0.D0,1.D0)*2.D0*PI/PAR*
     *  (0.D0,1.D0)*2.D0*PI/PAR*GMY1
	DPSM(MY1,INUC1,1,INUC,1)=
     &  DPSM(MY1,INUC1,1,INUC,1)+DINT*G2PLW(1,I2PLW)
	DPSM(MY1,INUC1,2,INUC,1)=
     &  DPSM(MY1,INUC1,2,INUC,1)+DINT*G2PLW(2,I2PLW)
	DPSM(MY1,INUC1,3,INUC,1)=
     &  DPSM(MY1,INUC1,3,INUC,1)+DINT*G2PLW(3,I2PLW)
 334	CONTINUE                                   !!! over palne waves 
	ENDIF
 336	CONTINUE                                   !!! over displacements
 338	CONTINUE                                   !!! over spins
 339	CONTINUE                                   !!! over spins
	ENDIF   !!! slow/fast calculations
C  ESTIMATE SURFACE INTEGRALS FROM CHARGE DENSITY AND POTENTIAL
	DO 580 INUC=1,NATOM                        !!! over inuc
	ISORT=IS(INUC)
	DO 570 MY=-1,1                             !!! over my
	DSRF(MY)=(0.D0,0.D0)
	DCOR(MY)=(0.D0,0.D0)
	DO 560 L1=0,ILSV(ISORT)                    !!! over l1
	DO 550 M1=-L1,L1                           !!! over m1
	L1M1=L1*(L1+1)+M1+1
	IF(.NOT.SYM(L1M1,INUC))GOTO550
	ISYM1=LMSYM(L1M1,INUC)
	DO 540 L=0,ILSV(ISORT)                     !!! over l
	DO 530 M=-L,L                              !!! over m
	LM=L*(L+1)+M+1
      DO 520 L2=ABS(L1-L),L1+L,2                 !!! over l2
      M2=M-M1
      IF(L2.EQ.1.AND.M2.EQ.-MY)THEN
	CGNT=(0.D0,1.D0)**(L-L1-L2)*C(L2/2,LM,L1M1)
	DO 512 IORBS=1,NORBS                       !!! over spins
	DO 510 IUPDN=1,NSPIN                       !!! over spins
	DSRF(MY)=DSRF(MY)+(0.D0,1.D0)*SQRT(4.D0*PI/3.D0)*
     &  (-1)**MY*SMT(ISORT)**2*CGNT*(
     &  DCONJG(RHO(NRAD(ISORT),ISYM1,INUC,IUPDN,IORBS))*
     &  DPOT(NRAD(ISORT),LM,INUC,IUPDN,IORBS)+
     &  DCONJG(POT(NRAD(ISORT),ISYM1,INUC,IUPDN,IORBS))*
     &  DRHO(NRAD(ISORT),LM,INUC,IUPDN,IORBS))
	IF(L1.EQ.0.AND.IORBS.EQ.1)
     &  DCOR(MY)=DCOR(MY)+(0.D0,1.D0)*SQRT(4.D0*PI/3.D0)*
     &  (-1)**MY*SMT(ISORT)**2*CGNT*
     &  RHOCOR(NRAD(ISORT),ISORT,IUPDN)*
     &  DPOT(NRAD(ISORT),LM,INUC,IUPDN,1)
 510 	CONTINUE                                   !!! over spins
 512 	CONTINUE                                   !!! over spins
	ENDIF
 520  CONTINUE                                   !!! over l2
 530 	CONTINUE                                   !!! over m
 540 	CONTINUE                                   !!! over l
 550	CONTINUE                                   !!! over m1
 560	CONTINUE                                   !!! over l1
 570	CONTINUE                                   !!! over my
	CALL PHN_TRANSFER(DCOR(-1),DXYZ(1))
	DPSM(MY1,INUC1,1,INUC,3)=DXYZ(1)
	DPSM(MY1,INUC1,2,INUC,3)=DXYZ(2)
	DPSM(MY1,INUC1,3,INUC,3)=DXYZ(3)
	CALL PHN_TRANSFER(DSRF(-1),DXYZ(1))
	DPSM(MY1,INUC1,1,INUC,4)=DXYZ(1)
	DPSM(MY1,INUC1,2,INUC,4)=DXYZ(2)
	DPSM(MY1,INUC1,3,INUC,4)=DXYZ(3)
 580	CONTINUE                                   !!! over inuc
1000 	CONTINUE                                   !!! over polarizations
2000	CONTINUE                                   !!! over displacements
C  TRANFERE TO CARTESIAN COORDINATES
	DO 640 INUC1=1,NATOM
	DO 630 INUC=1,NATOM
	DO 620 IXYZ=1,3
	DO 610 IC=1,4
	CALL PHN_TRANSFER(DPSM(-1,INUC1,IXYZ,INUC,IC),
     &              DPTN( 1,INUC1,IXYZ,INUC,IC))
 610	CONTINUE
 620	CONTINUE
 630	CONTINUE
 640	CONTINUE
C Memory deallocations
	DEALLOCATE(WORK1,WORK2,WORK3,WORK4,PROD,TMPARR,DPSM)
	END




	SUBROUTINE PHN_SCOUMAT(DCOU,IQPNT)
*******************************************************************
*  Calculates electrostatic contribution to the Dynamical Matrix. *
*******************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
      USE COM_PHNCOM,  ONLY : ITERMAX,NITER                              !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
     &                       ,NHSORT
	USE COM_RADMESH, ONLY : NRAD,H,R,DR,WEIGHT,RL                      !!! from radmsh
	USE COM_LATPAR,  ONLY : PAR,ORTH,OMEGAC                            !!! from readini
	USE COM_QMESH,   ONLY : NQPNT,QPNT                                 !!! from readpnt
	USE COM_PLWMESH, ONLY : NPLW,GPLW                                  !!! from makeplw
	USE COM_SPHERE,  ONLY : SWZ,SMT,ZNUC,ZCOR                          !!! from readini
	USE COM_DELPOT,  ONLY : DPOT,DPOTPS,DPOTPS1                        !!! from delpot
      USE COM_DELRHO,  ONLY : DRHO,DRHOPS,DRHOPS1                        !!! from delrho
	USE COM_SYMMLM,  ONLY : SYM,LMSYM                                  !!! from makesym
	USE COM_POTDAT,  ONLY : POT,POTSPH,POTPS,POTPS1                    !!! from fulpot
      USE COM_PLW2MSH, ONLY : N2PLW,G2PLW	                               !!! from makeplw
	USE COM_DENDAT,  ONLY : RHO,RHOCOR,RHOPS,RHOPS1                    !!! from readscf
      USE COM_DROMULT, ONLY : DELMRO,DELMAD                              !!! from dmultrho
	USE COM_GAUNT,   ONLY : C                                          !!! from makegnt
	USE COM_PHNCHN  ,ONLY : IUDPX,IUDPY                                !!! from channels
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8, ALLOCATABLE :: WORK3(:)
	REAL*8, ALLOCATABLE :: WORK4(:)
	COMPLEX*16, ALLOCATABLE :: WORK1(:)
	COMPLEX*16, ALLOCATABLE :: WORK2(:)
	COMPLEX*16, ALLOCATABLE :: PROD(:)
	COMPLEX*16, ALLOCATABLE :: TMPARR(:)
	COMPLEX*16, ALLOCATABLE :: RHOTMP(:)
	COMPLEX*16, ALLOCATABLE :: DPSM(:,:,:,:,:)
	REAL*8 TR1,TR2
      COMPLEX*16 GMY1,DXYZ(3),DINT,CGNT,DSRF(-1:1)
     &  ,DCOU(3,NATOMMEM,3,NATOMMEM,4)
	DATA PI/3.141592653589793D0/
	SQPI4=2.D0*SQRT(PI)
	DO 10 INUC1=1,NATOM
	DO 10 INUC =1,NATOM
	DO 10 IXYZ1=1,3
	DO 10 MY1=-1,1
	DO 10 IXYZ =1,3
	DO 10 IC=1,4
	DCOU(IXYZ1,INUC1,IXYZ,INUC,IC)=(0.D0,0.D0)
  10	CONTINUE
	IF(NPFR.EQ.0)RETURN
C Memory allocations
	ALLOCATE(WORK1(0:NRADMEM))
	ALLOCATE(WORK2(0:NRADMEM))
	ALLOCATE(WORK3(0:NRADMEM))
	ALLOCATE(WORK4(0:NRADMEM))
	ALLOCATE(PROD(0:9*NPLWMEM))
	ALLOCATE(TMPARR(0:NPLWMEM))
	ALLOCATE(RHOTMP(0:NPLWMEM))
	ALLOCATE(DPSM(-1:1,NATOMMEM,3,NATOMMEM,4))
	SQPI4=2.D0*SQRT(PI)
	DO 15 INUC1=1,NATOM
	DO 15 INUC =1,NATOM
	DO 15 IXYZ1=1,3
	DO 15 MY1=-1,1
	DO 15 IXYZ =1,3
	DO 15 IC=1,4
	DPSM(MY1,INUC1,IXYZ,INUC,IC)=(0.D0,0.D0)
  15	CONTINUE
C  THE COULOMB POTENTIALS FOR SPIN UP AND DOWN ELECTRONS ARE THE SAME
C  ALL FORMULAE BELOW ARE OK!
      DO 30 IATOM=1,NATOM                        !!! over atoms
      ISORT=IS(IATOM)
      DO 30 IORBS=1,NORBS                        !!! over spins
      DO 30 IUPDN=1,NSPIN                        !!! over spins
      DO 30 L=0,ILSV(ISORT)                      !!! over l
      DO 30 M=-L,L                               !!! over m
      LM=L*(L+1)+M+1
      IF(SYM(LM,IATOM))THEN                      !!! for non-zero components
      ISYM=LMSYM(LM,IATOM)
      DO 20 IRAD=0,NRAD(ISORT)                   !!! over rad.points
      POT(IRAD,ISYM,IATOM,IUPDN,IORBS)=(0.D0,0.D0)
  20  CONTINUE                                   !!! over rad.points
      ENDIF                                      !!! for non-zero components
  30  CONTINUE                                   !!! 
      DO 40 IORBS=1,NORBS
      DO 40 IUPDN=1,NSPIN
      DO 40 IPLW=0,NPLW
      POTPS(IPLW,IUPDN,IORBS)=(0.D0,0.D0)
  40  CONTINUE
      CALL POT_VCOUL                             !!! Coulomb potential within MTs
      CALL POT_VCFTR                             !!! Coulomb potential in the int.reg.
C  *** SET COULOMB CONTRIBUTION TO DYNAMICAL MATRIX ***
	DO 2000 INUC1=1,NATOM                      !!! over displacements
	DO 1000 MY1=-1,1                           !!! over polarizations
	IF(NITER(MY1,INUC1).EQ.0)GOTO1000
      CALL DRO_DROFILES(MY1,INUC1,IQPNT,IUDPX,'R','D',' ')  !!! read change in density
      CALL DRO_DPSFILES(MY1,INUC1,IQPNT,IUDPY,'R','D',' ')  !!! read change in density
C  CALCULATE CHANGE IN THE COULOMB POTENTIAL
	DO 50 IORBS=1,NORBS                        !!! over spins
	DO 50 IUPDN=1,NSPIN                        !!! over spins
      DO 50 IATOM=1,NATOM                        !!! over all atoms in cell
      ISORT=IS(IATOM)
      DO 50 L=0,ILSV(ISORT)                      !!! over l
      DO 50 M=-L,L                               !!! over m
      LM=L*(L+1)+M+1
      DO 50 IRAD=0,NRAD(ISORT)                   !!! over radial mesh
      DPOT(IRAD,LM,IATOM,IUPDN,IORBS)=(0.D0,0.D0)
  50  CONTINUE                                   !!! 
	DO 60 IORBS=1,NORBS                        !!! over spins
	DO 60 IUPDN=1,NSPIN                        !!! over spins
      DO 60 IPLW=0,NPLW                          !!! over plane waves
      DPOTPS(IPLW,IUPDN,IORBS)=(0.D0,0.D0) 
  60  CONTINUE                                   !!! 
      CALL DPT_DMULTRHO(MY1,INUC1,IQPNT)             !!! change in pseudodensity moments
      CALL DPT_DMULTFTR(MY1,INUC1,IQPNT,0)           !!! change in multipoles
      CALL DPT_DELVCOUL(MY1,INUC1,IQPNT)             !!! change in Coulomb potential in MTS
      CALL DPT_DELVCFTR(MY1,INUC1,IQPNT,0)           !!! change in Coulomb potential in INT
	IF(NPFR.EQ.1)THEN !!! slow calculation
C  CALCULATE DCOU1=d(+)/d(t1,i1)*Int[grad_i(rho)*Vcou]
C  1) Dcou1_1=Int[grad_i[d(+)rho/d(t1,i1)]*Vcou]
	DO 120 IXYZ =1,3                           !!! over polarizations
	DO 118 IUPDN=1,NSPIN                       !!! over spins
	DO 112 IPLW=0,NPLW                         !!! over plane waves
	RHOTMP(IPLW)=DRHOPS(IPLW,IUPDN,1)+DRHOPS1(IPLW,IUPDN,1)+
     &  DRHOPS1(IPLW,IUPDN,2) 
	TMPARR(IPLW)=RHOTMP(IPLW)*2.D0*PI/PAR*
     &  (QPNT(IXYZ,IQPNT)+GPLW(IXYZ,IPLW))*(0.D0,1.D0)
 112	CONTINUE                                   !!! over plane waves
	CALL PHN_RHOVSUB(POTPS(0,IUPDN,1),TMPARR,PROD)
	DO 116 INUC=1,NATOM                        !!! over displacements
	DO 114 I2PLW=0,N2PLW                       !!! over plane waves
	CALL INI_MAKEPLW_DINT(G2PLW(1,I2PLW)+QPNT(1,IQPNT),
     &                      G2PLW(2,I2PLW)+QPNT(2,IQPNT),
     &                      G2PLW(3,I2PLW)+QPNT(3,IQPNT),DINT,INUC)
	DPSM(MY1,INUC1,IXYZ,INUC,1)=
     &DPSM(MY1,INUC1,IXYZ,INUC,1)+PROD(I2PLW)*DINT
 114	CONTINUE                                   !!! over palne waves 
 116	CONTINUE                                   !!! over displacements
 118	CONTINUE                                   !!! over spins
 120	CONTINUE                                   !!! over polarizations
C  2) Dcou1_2=Int[grad_i(rho)*d(+)Vcou/d(t1,i1)]
	DO 130 IXYZ =1,3                           !!! over polarizations
	DO 128 IUPDN=1,NSPIN                       !!! over spins
	DO 122 IPLW=0,NPLW                         !!! over plane waves
	RHOTMP(IPLW)=RHOPS(IPLW,IUPDN,1)+RHOPS1(IPLW,IUPDN,1)
	TMPARR(IPLW)=RHOTMP(IPLW)*2.D0*PI/PAR*
     &  GPLW(IXYZ,IPLW)*(0.D0,1.D0)
 122	CONTINUE                                   !!! over plane waves
	CALL PHN_RHOVSUB(TMPARR,DPOTPS(0,IUPDN,1),PROD)
	DO 126 INUC=1,NATOM                        !!! over displacements
	DO 124 I2PLW=0,N2PLW                       !!! over plane waves
	CALL INI_MAKEPLW_DINT(G2PLW(1,I2PLW)+QPNT(1,IQPNT),
     &                      G2PLW(2,I2PLW)+QPNT(2,IQPNT),
     &                      G2PLW(3,I2PLW)+QPNT(3,IQPNT),DINT,INUC)
	DPSM(MY1,INUC1,IXYZ,INUC,1)=
     &DPSM(MY1,INUC1,IXYZ,INUC,1)+PROD(I2PLW)*DINT
 124	CONTINUE                                   !!! over palne waves 
 126	CONTINUE                                   !!! over displacements
 128	CONTINUE                                   !!! over spins
 130	CONTINUE                                   !!! over polarizations
C  3) Dcou1_3=d(+)Int/d(t1,i1)[grad_i(rho)*Vexc]
	DO 140 IXYZ =1,3                           !!! over polarizations
	DO 138 IUPDN=1,NSPIN                       !!! over spins
	DO 132 IPLW=0,NPLW                         !!! over plane waves
	RHOTMP(IPLW)=RHOPS(IPLW,IUPDN,1)+RHOPS1(IPLW,IUPDN,1)
	TMPARR(IPLW)=RHOTMP(IPLW)*2.D0*PI/PAR*
     &GPLW(IXYZ,IPLW)*(0.D0,1.D0)
 132	CONTINUE                                   !!! over plane waves
	CALL PHN_RHOVSUB(TMPARR,POTPS(0,IUPDN,1),PROD)
	DO 136 INUC=1,NATOM                        !!! over displacements
	IF(INUC1.EQ.INUC)THEN
	DO 134 I2PLW=0,N2PLW                       !!! over plane waves
      IF(MY1.EQ.-1)GMY1=+1.D0/SQRT(2.D0)*
     &(G2PLW(1,I2PLW)-(0.D0,1.D0)*G2PLW(2,I2PLW))
      IF(MY1.EQ.+1)GMY1=-1.D0/SQRT(2.D0)*
     &(G2PLW(1,I2PLW)+(0.D0,1.D0)*G2PLW(2,I2PLW))
      IF(MY1.EQ. 0)GMY1=G2PLW(3,I2PLW)
	CALL INI_MAKEPLW_DINT(G2PLW(1,I2PLW),
     &                      G2PLW(2,I2PLW),
     &                      G2PLW(3,I2PLW),DINT,INUC)
	DINT=DINT*2.D0*PI/PAR*(0.D0,1.D0)*GMY1
	DPSM(MY1,INUC1,IXYZ,INUC,1)=
     &DPSM(MY1,INUC1,IXYZ,INUC,1)+PROD(I2PLW)*DINT
 134	CONTINUE                                   !!! over palne waves 
	ENDIF
 136	CONTINUE                                   !!! over displacements
 138	CONTINUE                                   !!! over spins
 140	CONTINUE                                   !!! over polarizations
C  CALCULATE DCOU2=d(+)/d(t1,i1)*Int[rho*grad_i(Vcou)]
C  1) Dcou2_1=Int[d(+)rho/d(t1,i1)*grad_i(Vcou)]
	DO 150 IXYZ =1,3                           !!! over polarizations
	DO 148 IUPDN=1,NSPIN                       !!! over spins
	DO 142 IPLW=0,NPLW                         !!! over plane waves
	RHOTMP(IPLW)=DRHOPS(IPLW,IUPDN,1)+DRHOPS1(IPLW,IUPDN,1)+
     &DRHOPS1(IPLW,IUPDN,2) 
	TMPARR(IPLW)=POTPS(IPLW,IUPDN,1)*2.D0*PI/PAR*
     &GPLW(IXYZ,IPLW)*(0.D0,1.D0)
 142	CONTINUE                                   !!! over plane waves
	CALL PHN_RHOVSUB(TMPARR,RHOTMP,PROD)
	DO 146 INUC=1,NATOM                        !!! over displacements
	DO 144 I2PLW=0,N2PLW                       !!! over plane waves
	CALL INI_MAKEPLW_DINT(G2PLW(1,I2PLW)+QPNT(1,IQPNT),
     &                      G2PLW(2,I2PLW)+QPNT(2,IQPNT),
     &                      G2PLW(3,I2PLW)+QPNT(3,IQPNT),DINT,INUC)
	DPSM(MY1,INUC1,IXYZ,INUC,2)=
     &DPSM(MY1,INUC1,IXYZ,INUC,2)+PROD(I2PLW)*DINT
 144	CONTINUE                                   !!! over palne waves 
 146	CONTINUE                                   !!! over displacements
 148	CONTINUE                                   !!! over spins
 150	CONTINUE                                   !!! over polarizations
C  2) Dcou2_2=Int[rho*grad_i[d(+)Vcou/d(t1,i1)]]
	DO 160 IXYZ =1,3                           !!! over polarizations
	DO 158 IUPDN=1,NSPIN                       !!! over spins
	DO 152 IPLW=0,NPLW                         !!! over plane waves
	RHOTMP(IPLW)=RHOPS(IPLW,IUPDN,1)+RHOPS1(IPLW,IUPDN,1)
	TMPARR(IPLW)=DPOTPS(IPLW,IUPDN,1)*2.D0*PI/PAR*
     &  (QPNT(IXYZ,IQPNT)+GPLW(IXYZ,IPLW))*(0.D0,1.D0)
 152	CONTINUE                                   !!! over plane waves
	CALL PHN_RHOVSUB(RHOTMP,TMPARR,PROD)
	DO 156 INUC=1,NATOM                        !!! over displacements
	DO 154 I2PLW=0,N2PLW                       !!! over plane waves
	CALL INI_MAKEPLW_DINT(G2PLW(1,I2PLW)+QPNT(1,IQPNT),
     &                      G2PLW(2,I2PLW)+QPNT(2,IQPNT),
     &                      G2PLW(3,I2PLW)+QPNT(3,IQPNT),DINT,INUC)
	DPSM(MY1,INUC1,IXYZ,INUC,2)=
     &DPSM(MY1,INUC1,IXYZ,INUC,2)+PROD(I2PLW)*DINT
 154	CONTINUE                                   !!! over palne waves 
 156	CONTINUE                                   !!! over displacements
 158	CONTINUE                                   !!! over spins
 160	CONTINUE                                   !!! over polarizations
C  3) Dcou2_3=d(+)Int/d(t1,i1)[rho*grad_i(Vcou)]
	DO 170 IXYZ =1,3                           !!! over polarizations
	DO 168 IUPDN=1,NSPIN                       !!! over spins
	DO 162 IPLW=0,NPLW                         !!! over plane waves
	RHOTMP(IPLW)=RHOPS(IPLW,IUPDN,1)+RHOPS1(IPLW,IUPDN,1)
	TMPARR(IPLW)=POTPS(IPLW,IUPDN,1)*2.D0*PI/PAR*
     &  GPLW(IXYZ,IPLW)*(0.D0,1.D0)
 162	CONTINUE                                   !!! over plane waves
	CALL PHN_RHOVSUB(RHOTMP,TMPARR,PROD)
	DO 166 INUC=1,NATOM                        !!! over displacements
	IF(INUC1.EQ.INUC)THEN
	DO 164 I2PLW=0,N2PLW                       !!! over plane waves
      IF(MY1.EQ.-1)GMY1=+1.D0/SQRT(2.D0)*
     &  (G2PLW(1,I2PLW)-(0.D0,1.D0)*G2PLW(2,I2PLW))
      IF(MY1.EQ.+1)GMY1=-1.D0/SQRT(2.D0)*
     &  (G2PLW(1,I2PLW)+(0.D0,1.D0)*G2PLW(2,I2PLW))
      IF(MY1.EQ. 0)GMY1=G2PLW(3,I2PLW)
	CALL INI_MAKEPLW_DINT(G2PLW(1,I2PLW),
     &                      G2PLW(2,I2PLW),
     &                      G2PLW(3,I2PLW),DINT,INUC)
	DINT=DINT*2.D0*PI/PAR*(0.D0,1.D0)*GMY1
	DPSM(MY1,INUC1,IXYZ,INUC,2)=
     &DPSM(MY1,INUC1,IXYZ,INUC,2)+PROD(I2PLW)*DINT
 164	CONTINUE                                   !!! over palne waves 
	ENDIF
 166	CONTINUE                                   !!! over displacements
 168	CONTINUE                                   !!! over spins
 170	CONTINUE                                   !!! over polarizations
C  CALCULATE DCOU3=d(+)/d(t1,i1)*Int[grad_i(rho1)*Vcou]
C  1) Dcou3_1=Int[grad_i[d(+)rho1/d(t1,i1)]*Vcou]
	DO 190 IXYZ =1,3                           !!! over polarizations
	DO 188 IUPDN=1,NSPIN                       !!! over spins
	DO 182 IPLW=0,NPLW                         !!! over plane waves
	RHOTMP(IPLW)=DRHOPS1(IPLW,IUPDN,1)+DRHOPS1(IPLW,IUPDN,2) 
	TMPARR(IPLW)=RHOTMP(IPLW)*2.D0*PI/PAR*
     &  (QPNT(IXYZ,IQPNT)+GPLW(IXYZ,IPLW))*(0.D0,1.D0)
 182	CONTINUE                                   !!! over plane waves
	CALL PHN_RHOVSUB(POTPS(0,IUPDN,1),TMPARR,PROD)
	DO 186 INUC=1,NATOM                        !!! over displacements
	DO 184 I2PLW=0,N2PLW                       !!! over plane waves
	CALL INI_MAKEPLW_DINT(G2PLW(1,I2PLW)+QPNT(1,IQPNT),
     &                      G2PLW(2,I2PLW)+QPNT(2,IQPNT),
     &                      G2PLW(3,I2PLW)+QPNT(3,IQPNT),DINT,INUC)
	DPSM(MY1,INUC1,IXYZ,INUC,3)=
     &DPSM(MY1,INUC1,IXYZ,INUC,3)+PROD(I2PLW)*DINT
 184	CONTINUE                                   !!! over palne waves 
 186	CONTINUE                                   !!! over displacements
 188	CONTINUE                                   !!! over spins
 190	CONTINUE                                   !!! over polarizations
C  2) Dcou3_2=Int[grad_i(rho1)*d(+)Vcou/d(t1,i1)]
	DO 200 IXYZ =1,3                           !!! over polarizations
	DO 198 IUPDN=1,NSPIN                       !!! over spins
	DO 192 IPLW=0,NPLW                         !!! over plane waves
	RHOTMP(IPLW)=RHOPS1(IPLW,IUPDN,1)
	TMPARR(IPLW)=RHOTMP(IPLW)*2.D0*PI/PAR*
     &  GPLW(IXYZ,IPLW)*(0.D0,1.D0)
 192	CONTINUE                                   !!! over plane waves
	CALL PHN_RHOVSUB(TMPARR,DPOTPS(0,IUPDN,1),PROD)
	DO 196 INUC=1,NATOM                        !!! over displacements
	DO 194 I2PLW=0,N2PLW                       !!! over plane waves
	CALL INI_MAKEPLW_DINT(G2PLW(1,I2PLW)+QPNT(1,IQPNT),
     &                      G2PLW(2,I2PLW)+QPNT(2,IQPNT),
     &                      G2PLW(3,I2PLW)+QPNT(3,IQPNT),DINT,INUC)
	DPSM(MY1,INUC1,IXYZ,INUC,3)=
     &DPSM(MY1,INUC1,IXYZ,INUC,3)+PROD(I2PLW)*DINT
 194	CONTINUE                                   !!! over palne waves 
 196	CONTINUE                                   !!! over displacements
 198	CONTINUE                                   !!! over spins
 200	CONTINUE                                   !!! over polarizations
C  3) Dcou3_3=d(+)Int/d(t1,i1)[grad_i(rho1)*Vexc]
	DO 220 IXYZ =1,3                           !!! over polarizations
	DO 218 IUPDN=1,NSPIN                       !!! over spins
	DO 212 IPLW=0,NPLW                         !!! over plane waves
	RHOTMP(IPLW)=RHOPS1(IPLW,IUPDN,1)
	TMPARR(IPLW)=RHOTMP(IPLW)*2.D0*PI/PAR*
     &  GPLW(IXYZ,IPLW)*(0.D0,1.D0)
 212	CONTINUE                                   !!! over plane waves
	CALL PHN_RHOVSUB(TMPARR,POTPS(0,IUPDN,1),PROD)
	DO 216 INUC=1,NATOM                        !!! over displacements
	IF(INUC1.EQ.INUC)THEN
	DO 214 I2PLW=0,N2PLW                       !!! over plane waves
      IF(MY1.EQ.-1)GMY1=+1.D0/SQRT(2.D0)*
     &  (G2PLW(1,I2PLW)-(0.D0,1.D0)*G2PLW(2,I2PLW))
      IF(MY1.EQ.+1)GMY1=-1.D0/SQRT(2.D0)*
     &  (G2PLW(1,I2PLW)+(0.D0,1.D0)*G2PLW(2,I2PLW))
      IF(MY1.EQ. 0)GMY1=G2PLW(3,I2PLW)
	CALL INI_MAKEPLW_DINT(G2PLW(1,I2PLW),
     &                      G2PLW(2,I2PLW),
     &                      G2PLW(3,I2PLW),DINT,INUC)
	DINT=DINT*2.D0*PI/PAR*(0.D0,1.D0)*GMY1
	DPSM(MY1,INUC1,IXYZ,INUC,3)=
     &DPSM(MY1,INUC1,IXYZ,INUC,3)+PROD(I2PLW)*DINT
 214	CONTINUE                                   !!! over palne waves 
	ENDIF
 216	CONTINUE                                   !!! over displacements
 218	CONTINUE                                   !!! over spins
 220	CONTINUE                                   !!! over polarizations
	ELSEIF(NPFR.EQ.2)THEN !!! fast calculation
C  CALCULATE DCOU1=d(+)/d(t1,i1)*Int[grad_i(rho*Vcou)]
C  1) Dcou1_1=Int[grad_i[d(+)rho/d(t1,i1)*Vcou]]
	DO 318 IUPDN=1,NSPIN                       !!! over spins
	DO 312 IPLW=0,NPLW                         !!! over plane waves
	RHOTMP(IPLW)=DRHOPS(IPLW,IUPDN,1)+DRHOPS1(IPLW,IUPDN,1)+
     &  DRHOPS1(IPLW,IUPDN,2) 
 312	CONTINUE                                   !!! over plane waves
	CALL PHN_RHOVSUB(POTPS(0,IUPDN,1),RHOTMP,PROD)
	DO 316 INUC=1,NATOM                        !!! over displacements
	DO 314 I2PLW=0,N2PLW                       !!! over plane waves
	CALL INI_MAKEPLW_DINT(G2PLW(1,I2PLW)+QPNT(1,IQPNT),
     &                      G2PLW(2,I2PLW)+QPNT(2,IQPNT),
     &                      G2PLW(3,I2PLW)+QPNT(3,IQPNT),DINT,INUC)
	DINT=DINT*PROD(I2PLW)*(0.D0,1.D0)*2.D0*PI/PAR
	DPSM(MY1,INUC1,1,INUC,1)=
     &DPSM(MY1,INUC1,1,INUC,1)+DINT*(G2PLW(1,I2PLW)+QPNT(1,IQPNT))
	DPSM(MY1,INUC1,2,INUC,1)=
     &DPSM(MY1,INUC1,2,INUC,1)+DINT*(G2PLW(2,I2PLW)+QPNT(2,IQPNT))
	DPSM(MY1,INUC1,3,INUC,1)=
     &DPSM(MY1,INUC1,3,INUC,1)+DINT*(G2PLW(3,I2PLW)+QPNT(3,IQPNT))
 314	CONTINUE                                   !!! over palne waves 
 316	CONTINUE                                   !!! over displacements
 318	CONTINUE                                   !!! over spins
C  2) Dcou1_2=Int[grad_i[rho*(d(+)Vcou/d(t1,i1))]
	DO 328 IUPDN=1,NSPIN                       !!! over spins
	DO 322 IPLW=0,NPLW                         !!! over plane waves
	RHOTMP(IPLW)=RHOPS(IPLW,IUPDN,1)+RHOPS1(IPLW,IUPDN,1)
	TMPARR(IPLW)=DPOTPS(IPLW,IUPDN,1)
 322	CONTINUE                                   !!! over plane waves
	CALL PHN_RHOVSUB(RHOTMP,TMPARR,PROD)
	DO 326 INUC=1,NATOM                        !!! over displacements
	DO 324 I2PLW=0,N2PLW                       !!! over plane waves
	CALL INI_MAKEPLW_DINT(G2PLW(1,I2PLW)+QPNT(1,IQPNT),
     &                      G2PLW(2,I2PLW)+QPNT(2,IQPNT),
     &                      G2PLW(3,I2PLW)+QPNT(3,IQPNT),DINT,INUC)
	DINT=DINT*PROD(I2PLW)*(0.D0,1.D0)*2.D0*PI/PAR
	DPSM(MY1,INUC1,1,INUC,1)=
     &DPSM(MY1,INUC1,1,INUC,1)+DINT*(G2PLW(1,I2PLW)+QPNT(1,IQPNT))
	DPSM(MY1,INUC1,2,INUC,1)=
     &DPSM(MY1,INUC1,2,INUC,1)+DINT*(G2PLW(2,I2PLW)+QPNT(2,IQPNT))
	DPSM(MY1,INUC1,3,INUC,1)=
     &DPSM(MY1,INUC1,3,INUC,1)+DINT*(G2PLW(3,I2PLW)+QPNT(3,IQPNT))
 324	CONTINUE                                   !!! over palne waves 
 326	CONTINUE                                   !!! over displacements
 328	CONTINUE                                   !!! over spins
C  3) Dcou1_3=d(+)Int/d(t1,i1)[grad_i[rho*Vcou]]
	DO 338 IUPDN=1,NSPIN                       !!! over spins
	DO 332 IPLW=0,NPLW                         !!! over plane waves
	RHOTMP(IPLW)=RHOPS(IPLW,IUPDN,1)+RHOPS1(IPLW,IUPDN,1)
	TMPARR(IPLW)=POTPS(IPLW,IUPDN,1)
 332	CONTINUE                                   !!! over plane waves
	CALL PHN_RHOVSUB(RHOTMP,TMPARR,PROD)
	DO 336 INUC=1,NATOM                        !!! over displacements
	IF(INUC1.EQ.INUC)THEN
	DO 334 I2PLW=0,N2PLW                       !!! over plane waves
      IF(MY1.EQ.-1)GMY1=+1.D0/SQRT(2.D0)*
     &(G2PLW(1,I2PLW)-(0.D0,1.D0)*G2PLW(2,I2PLW))
      IF(MY1.EQ.+1)GMY1=-1.D0/SQRT(2.D0)*
     &(G2PLW(1,I2PLW)+(0.D0,1.D0)*G2PLW(2,I2PLW))
      IF(MY1.EQ. 0)GMY1=G2PLW(3,I2PLW)
	CALL INI_MAKEPLW_DINT(G2PLW(1,I2PLW),
     &                      G2PLW(2,I2PLW),
     &                      G2PLW(3,I2PLW),DINT,INUC)
	DINT=DINT*PROD(I2PLW)*(0.D0,1.D0)*2.D0*PI/PAR*
     *  (0.D0,1.D0)*2.D0*PI/PAR*GMY1
	DPSM(MY1,INUC1,1,INUC,1)=
     &DPSM(MY1,INUC1,1,INUC,1)+DINT*G2PLW(1,I2PLW)
	DPSM(MY1,INUC1,2,INUC,1)=
     &DPSM(MY1,INUC1,2,INUC,1)+DINT*G2PLW(2,I2PLW)
	DPSM(MY1,INUC1,3,INUC,1)=
     &DPSM(MY1,INUC1,3,INUC,1)+DINT*G2PLW(3,I2PLW)
 334	CONTINUE                                   !!! over palne waves 
	ENDIF
 336	CONTINUE                                   !!! over displacements
 338	CONTINUE                                   !!! over spins
	ENDIF   !!! slow/fast calculations
C  ESTIMATE SURFACE INTEGRALS FROM CHARGE DENSITY AND POTENTIAL
	DO 580 INUC=1,NATOM                        !!! over inuc
	ISORT=IS(INUC)
	DO 570 MY=-1,1                             !!! over my
	DSRF(MY)=(0.D0,0.D0)
	DO 560 L1=0,ILSV(ISORT)                    !!! over l1
	DO 550 M1=-L1,L1                           !!! over m1
	L1M1=L1*(L1+1)+M1+1
	IF(.NOT.SYM(L1M1,INUC))GOTO550
	ISYM1=LMSYM(L1M1,INUC)
	DO 540 L=0,ILSV(ISORT)                     !!! over l
	DO 530 M=-L,L                              !!! over m
	LM=L*(L+1)+M+1
      DO 520 L2=ABS(L1-L),L1+L,2                 !!! over l2
      M2=M-M1
      IF(L2.EQ.1.AND.M2.EQ.-MY)THEN
	CGNT=(0.D0,1.D0)**(L-L1-L2)*C(L2/2,LM,L1M1)
	DSRF(MY)=DSRF(MY)+(0.D0,1.D0)*SQRT(4.D0*PI/3.D0)*
     &  (-1)**MY*SMT(ISORT)**2*CGNT*(
     &  DCONJG(RHO(NRAD(ISORT),ISYM1,INUC,1,1)+
     &  RHO(NRAD(ISORT),ISYM1,INUC,NSPIN,1))/2.D0*DBLE(NSPIN)*
     &  (DPOT(NRAD(ISORT),LM,INUC,1,1)+
     &   DPOT(NRAD(ISORT),LM,INUC,NSPIN,1))/2.D0+
     &  DCONJG(POT(NRAD(ISORT),ISYM1,INUC,1,1)+
     &  POT(NRAD(ISORT),ISYM1,INUC,NSPIN,1))/2.D0*
     &  (DRHO(NRAD(ISORT),LM,INUC,1,1)+
     &   DRHO(NRAD(ISORT),LM,INUC,NSPIN,1))/2.D0*DBLE(NSPIN))
	IF(L1.EQ.0)DSRF(MY)=DSRF(MY)+(0.D0,1.D0)*SQRT(4.D0*PI/3.D0)*
     &  (-1)**MY*SMT(ISORT)**2*CGNT*
     &  (-2.D0*ZNUC(ISORT))/SMT(ISORT)*SQRT(4.D0*PI)*
     &  (DRHO(NRAD(ISORT),LM,INUC,1,1)+
     &   DRHO(NRAD(ISORT),LM,INUC,NSPIN,1))/2.D0*DBLE(NSPIN)
	ENDIF
 520  CONTINUE                                   !!! over l2
 530 	CONTINUE                                   !!! over m
 540 	CONTINUE                                   !!! over l
 550	CONTINUE                                   !!! over m1
 560	CONTINUE                                   !!! over l1
 570	CONTINUE                                   !!! over my
	CALL PHN_TRANSFER(DSRF(-1),DXYZ(1))
	DPSM(MY1,INUC1,1,INUC,4)=DXYZ(1)
	DPSM(MY1,INUC1,2,INUC,4)=DXYZ(2)
	DPSM(MY1,INUC1,3,INUC,4)=DXYZ(3)
 580	CONTINUE                                   !!! over inuc
1000 	CONTINUE                                   !!! over polarizations
2000	CONTINUE                                   !!! over displacements
C  TRANFERE TO CARTESIAN COORDINATES
	DO 640 INUC1=1,NATOM
	DO 630 INUC=1,NATOM
	DO 620 IXYZ=1,3
	DO 610 IC=1,4
	CALL PHN_TRANSFER(DPSM(-1,INUC1,IXYZ,INUC,IC),
     &              DCOU( 1,INUC1,IXYZ,INUC,IC))
 610	CONTINUE
 620	CONTINUE
 630	CONTINUE
 640	CONTINUE
C Memory deallocations
	DEALLOCATE(WORK1,WORK2,WORK3,WORK4,PROD,TMPARR,RHOTMP,DPSM)
	END



	SUBROUTINE PHN_SMLTMAT(DMLT,IQPNT)
************************************************************
*   Calculates multipole contribution to the Dynamical     *
*   Matrix.                                                *
************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
      USE COM_PHNCOM,  ONLY : ITERMAX,NITER                              !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_LATTICE, ONLY : TAU                                        !!! from readstr
	USE COM_LATPAR,  ONLY : PAR,ORTH,OMEGAC                            !!! from readini
	USE COM_SYMMLM,  ONLY : SYM,LMSYM                                  !!! from makesym
	USE COM_PLWMESH, ONLY : NPLW,GPLW                                  !!! from makeplw
	USE COM_QMESH,   ONLY : NQPNT,QPNT                                 !!! from readpnt
	USE COM_SPHERE,  ONLY : SWZ,SMT,ZNUC,ZCOR                          !!! from readini
	USE COM_MULTRO,  ONLY : AMTOT,PSMOM,PSMOM1,QMAD                    !!! from multrho
	USE COM_POTDAT,  ONLY : POTPS,POTPS1                               !!! from readscf
	USE COM_DENDAT,  ONLY : RHOPS,RHOPS1                               !!! from readscf
	USE COM_DELRHO,  ONLY : DRHOPS,DRHOPS1                             !!! from delrho
      USE COM_DROMULT, ONLY : DELMRO,DELMAD                              !!! from dmultrho
	USE COM_ACCURG,  ONLY : BET                                        !!! from multrho
	USE COM_MASHDEP, ONLY : NVAL                                       !!! from setup
	USE COM_PHNCHN  ,ONLY : IUDPX,IUDPY                                !!! from channels
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8, ALLOCATABLE :: BES(:)
	REAL*8, ALLOCATABLE :: BESD(:)
	COMPLEX*16, ALLOCATABLE ::YLM(:)
	COMPLEX*16, ALLOCATABLE ::D2MAD(:,:,:,:)
	COMPLEX*16, ALLOCATABLE ::DRMOM(:,:,:,:)
	COMPLEX*16, ALLOCATABLE ::DRMAD(:,:,:,:)
	COMPLEX*16, ALLOCATABLE ::D2MOM(:,:,:,:)
	COMPLEX*16, ALLOCATABLE ::DPSM(:,:,:,:,:)
	COMPLEX*16 EXPT,DMLT(3,NATOMMEM,3,NATOMMEM,4),DTMP(-1:1),GMY1
	DATA PI/3.141592653589793D0/
	SQPI4=SQRT(4.D0*PI)
	DO 10 INUC1=1,NATOM
	DO 10 INUC =1,NATOM
	DO 10 IXYZ1=1,3
	DO 10 IXYZ =1,3
	DO 10 MY1=-1,1
	DO 10 IC=1,4
	DMLT(IXYZ1,INUC1,IXYZ,INUC,IC)=(0.D0,0.D0)
  10	CONTINUE
	IF(NPFR.EQ.0)RETURN
C Memory allocations
	ALLOCATE(YLM(LIMVMEM))
	ALLOCATE(D2MAD(LIMVMEM,NATOMMEM,NSPINMEM,3))
	ALLOCATE(DRMOM(LIMVMEM,NATOMMEM,NSPINMEM,3))
	ALLOCATE(DRMAD(LIMVMEM,NATOMMEM,NSPINMEM,3))
	ALLOCATE(D2MOM(LIMVMEM,NATOMMEM,NSPINMEM,3))
	ALLOCATE(DPSM(-1:1,NATOMMEM,3,NATOMMEM,4))
	ALLOCATE(BES(-1:LMAXVMEM+1))
	ALLOCATE(BESD(0:LMAXVMEM+1))
	SQPI4=SQRT(4.D0*PI)
	DO 15 INUC1=1,NATOM
	DO 15 INUC =1,NATOM
	DO 15 IXYZ1=1,3
	DO 15 IXYZ =1,3
	DO 15 MY1=-1,1
	DO 15 IC=1,4
	DPSM(MY1,INUC1,IXYZ,INUC,IC)=(0.D0,0.D0)
  15	CONTINUE
	DO 2000 INUC1=1,NATOM                      !!! over displacements
	DO 1000 MY1=-1,1                           !!! over polarizations
	IF(NITER(MY1,INUC1).EQ.0)GOTO1000
      CALL DRO_DROFILES(MY1,INUC1,IQPNT,IUDPX,'R','D',' ')  !!! read change in density
      CALL DRO_DPSFILES(MY1,INUC1,IQPNT,IUDPY,'R','D',' ')  !!! read change in density
      CALL DPT_DMULTRHO(MY1,INUC1,IQPNT)             !!! change in moments
      CALL DPT_DMULTFTR(MY1,INUC1,IQPNT,0)           !!! change in multipoles
C  CALCULATE CHANGES IN MULTIPOLE CHARGE DUE TO ATOMIC MOVEMENTS
	LMM=0
	ZPSD=0.D0
	DO 50 IUPDN=1,NSPIN
	ZPSD=ZPSD+OMEGAC*RHOPS(0,IUPDN,1)
	DO 40 IATOM=1,NATOM
	ISORT=IS(IATOM)
	LMM=MAX(LMM,ILSV(ISORT))
	DO 30 L=0,ILSV(ISORT)
	DO 20 M=-L,L
	LM=L*(L+1)+M+1
	DO 20 IXYZ=1,3
	DRMOM(LM,IATOM,IUPDN,IXYZ)=(0.D0,0.D0)
	DRMAD(LM,IATOM,IUPDN,IXYZ)=(0.D0,0.D0)
	D2MAD(LM,IATOM,IUPDN,IXYZ)=(0.D0,0.D0)
	D2MOM(LM,IATOM,IUPDN,IXYZ)=(0.D0,0.D0)
  20  CONTINUE
  30  CONTINUE
  40  CONTINUE
  50  CONTINUE
	DO 140 IPLW=0,NPLW                   !!! over plane waves
	GX=GPLW(1,IPLW)*2.D0*PI/PAR
	GY=GPLW(2,IPLW)*2.D0*PI/PAR
	GZ=GPLW(3,IPLW)*2.D0*PI/PAR
	AG=SQRT(GX**2+GY**2+GZ**2)
	AG2=AG*AG
      IF(MY1.EQ.-1)GMY1=+1.D0/SQRT(2.D0)*(GX-(0.D0,1.D0)*GY)
      IF(MY1.EQ.+1)GMY1=-1.D0/SQRT(2.D0)*(GX+(0.D0,1.D0)*GY)
      IF(MY1.EQ. 0)GMY1=GZ
C  SET SPHERICAL HARMONICS
	IF(AG.GE.1.D-10)THEN
	CALL LIB_SPHHARM(GX/AG,GY/AG,GZ/AG,LMM,YLM)
	ELSE
	YLM(1)=1.D0/SQRT(4.D0*PI)
	DO 60 LM=2,(LMM+1)**2
	YLM(LM)=(0.D0,0.D0)
  60  CONTINUE
	ENDIF
C  SET CHANGE IN MULTIPOLE CHARGES
	IF(AG.GE.1.D-10)THEN                 !!! not for G=0 !
	DO 130 IATOM=1,NATOM                 !!! over atoms
	ISORT=IS(IATOM)
	CALL LIB_BESSR(AG*SMT(ISORT),BES(0),BESD(0),ILSV(ISORT)+1)
	BES(-1)=COS(AG*SMT(ISORT))/(AG*SMT(ISORT))
	SCP=GPLW(1,IPLW)*TAU(1,IATOM)+
     &    GPLW(2,IPLW)*TAU(2,IATOM)+
     &    GPLW(3,IPLW)*TAU(3,IATOM)
	EXPT=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	DO 120 IUPDN=1,NSPIN                 !!! over spins
	DO 110 L=0,ILSV(ISORT)
	DO 100 M=-L,L
	LM=L*(L+1)+M+1
C  d[r]Qlm/d[t,i]
	DRMAD(LM,IATOM,IUPDN,1)=DRMAD(LM,IATOM,IUPDN,1)+
     &  4.D0*PI*SMT(ISORT)/DBLE(2*L+1)*(RHOPS(IPLW,IUPDN,1)+
     &  RHOPS1(IPLW,IUPDN,1))*4.D0*PI*DCONJG(EXPT*YLM(LM))/AG*
     &  BES(L-1)*(0.D0,1.D0)*GX
	DRMAD(LM,IATOM,IUPDN,2)=DRMAD(LM,IATOM,IUPDN,2)+
     &  4.D0*PI*SMT(ISORT)/DBLE(2*L+1)*(RHOPS(IPLW,IUPDN,1)+
     &  RHOPS1(IPLW,IUPDN,1))*4.D0*PI*DCONJG(EXPT*YLM(LM))/AG*
     &  BES(L-1)*(0.D0,1.D0)*GY
	DRMAD(LM,IATOM,IUPDN,3)=DRMAD(LM,IATOM,IUPDN,3)+
     &  4.D0*PI*SMT(ISORT)/DBLE(2*L+1)*(RHOPS(IPLW,IUPDN,1)+
     &  RHOPS1(IPLW,IUPDN,1))*4.D0*PI*DCONJG(EXPT*YLM(LM))/AG*
     &  BES(L-1)*(0.D0,1.D0)*GZ
C  d[2]Qlm/d[t,i]
	IF(INUC1.EQ.IATOM)THEN
	D2MAD(LM,IATOM,IUPDN,1)=D2MAD(LM,IATOM,IUPDN,1)+
     &  4.D0*PI*SMT(ISORT)/DBLE(2*L+1)*(RHOPS(IPLW,IUPDN,1)+
     &  RHOPS1(IPLW,IUPDN,1))*4.D0*PI*DCONJG(EXPT*YLM(LM))/AG*
     &  BES(L-1)*(0.D0,1.D0)*GMY1*(0.D0,1.D0)*GX
	D2MAD(LM,IATOM,IUPDN,2)=D2MAD(LM,IATOM,IUPDN,2)+
     &  4.D0*PI*SMT(ISORT)/DBLE(2*L+1)*(RHOPS(IPLW,IUPDN,1)+
     &  RHOPS1(IPLW,IUPDN,1))*4.D0*PI*DCONJG(EXPT*YLM(LM))/AG*
     &  BES(L-1)*(0.D0,1.D0)*GMY1*(0.D0,1.D0)*GY
	D2MAD(LM,IATOM,IUPDN,3)=D2MAD(LM,IATOM,IUPDN,3)+
     &  4.D0*PI*SMT(ISORT)/DBLE(2*L+1)*(RHOPS(IPLW,IUPDN,1)+
     &  RHOPS1(IPLW,IUPDN,1))*4.D0*PI*DCONJG(EXPT*YLM(LM))/AG*
     &  BES(L-1)*(0.D0,1.D0)*GMY1*(0.D0,1.D0)*GZ
	ENDIF
C  d[r]Mlm/d[t,i]
      DRMOM(LM,IATOM,IUPDN,1)=DRMOM(LM,IATOM,IUPDN,1)+
     &  SQPI4*4.D0*PI*SMT(ISORT)**2*(RHOPS(IPLW,IUPDN,1)+
     &  RHOPS1(IPLW,IUPDN,1))*DCONJG(EXPT*YLM(LM))/AG*
     &  BES(L+1)*(0.D0,1.D0)*GX
      DRMOM(LM,IATOM,IUPDN,2)=DRMOM(LM,IATOM,IUPDN,2)+
     &  SQPI4*4.D0*PI*SMT(ISORT)**2*(RHOPS(IPLW,IUPDN,1)+
     &  RHOPS1(IPLW,IUPDN,1))*DCONJG(EXPT*YLM(LM))/AG*
     &  BES(L+1)*(0.D0,1.D0)*GY
      DRMOM(LM,IATOM,IUPDN,3)=DRMOM(LM,IATOM,IUPDN,3)+
     &  SQPI4*4.D0*PI*SMT(ISORT)**2*(RHOPS(IPLW,IUPDN,1)+
     &  RHOPS1(IPLW,IUPDN,1))*DCONJG(EXPT*YLM(LM))/AG*
     &  BES(L+1)*(0.D0,1.D0)*GZ
C  d[2]Mlm/d[t,i]
	IF(INUC1.EQ.IATOM)THEN
      D2MOM(LM,IATOM,IUPDN,1)=D2MOM(LM,IATOM,IUPDN,1)+
     &  SQPI4*4.D0*PI*SMT(ISORT)**2*(RHOPS(IPLW,IUPDN,1)+
     &  RHOPS1(IPLW,IUPDN,1))*DCONJG(EXPT*YLM(LM))/AG*
     &  BES(L+1)*(0.D0,1.D0)*GMY1*(0.D0,1.D0)*GX
      D2MOM(LM,IATOM,IUPDN,2)=D2MOM(LM,IATOM,IUPDN,2)+
     &  SQPI4*4.D0*PI*SMT(ISORT)**2*(RHOPS(IPLW,IUPDN,1)+
     &  RHOPS1(IPLW,IUPDN,1))*DCONJG(EXPT*YLM(LM))/AG*
     &  BES(L+1)*(0.D0,1.D0)*GMY1*(0.D0,1.D0)*GY
      D2MOM(LM,IATOM,IUPDN,3)=D2MOM(LM,IATOM,IUPDN,3)+
     &  SQPI4*4.D0*PI*SMT(ISORT)**2*(RHOPS(IPLW,IUPDN,1)+
     &  RHOPS1(IPLW,IUPDN,1))*DCONJG(EXPT*YLM(LM))/AG*
     &  BES(L+1)*(0.D0,1.D0)*GMY1*(0.D0,1.D0)*GZ
	ENDIF
 100  CONTINUE
 110  CONTINUE
 120  CONTINUE                             !!! over spins
 130  CONTINUE                             !!! over atoms
	ENDIF
 140  CONTINUE                             !!! over plane waves
	DO 240 IPLW=0,NPLW                   !!! over plane waves
	GX=(QPNT(1,IQPNT)+GPLW(1,IPLW))*2.D0*PI/PAR
	GY=(QPNT(2,IQPNT)+GPLW(2,IPLW))*2.D0*PI/PAR
	GZ=(QPNT(3,IQPNT)+GPLW(3,IPLW))*2.D0*PI/PAR
	AG=SQRT(GX**2+GY**2+GZ**2)
	AG2=AG*AG
      IF(MY1.EQ.-1)GMY1=+1.D0/SQRT(2.D0)*(GX-(0.D0,1.D0)*GY)
      IF(MY1.EQ.+1)GMY1=-1.D0/SQRT(2.D0)*(GX+(0.D0,1.D0)*GY)
      IF(MY1.EQ. 0)GMY1=GZ
C  SET SPHERICAL HARMONICS
	IF(AG.GE.1.D-10)THEN
	CALL LIB_SPHHARM(GX/AG,GY/AG,GZ/AG,LMM,YLM)
	ELSE
	YLM(1)=1.D0/SQRT(4.D0*PI)
	DO 160 LM=2,(LMM+1)**2
	YLM(LM)=(0.D0,0.D0)
 160  CONTINUE
	ENDIF
C  SET CHANGE IN MULTIPOLE CHARGES
	IF(AG.GE.1.D-10)THEN                 !!! not for G=0 !
	DO 230 IATOM=1,NATOM                 !!! over atoms
	ISORT=IS(IATOM)
	CALL LIB_BESSR(AG*SMT(ISORT),BES(0),BESD(0),ILSV(ISORT)+1)
	BES(-1)=COS(AG*SMT(ISORT))/(AG*SMT(ISORT))
	SCP=(QPNT(1,IQPNT)+GPLW(1,IPLW))*TAU(1,IATOM)+
     &    (QPNT(2,IQPNT)+GPLW(2,IPLW))*TAU(2,IATOM)+
     &    (QPNT(3,IQPNT)+GPLW(3,IPLW))*TAU(3,IATOM)
	EXPT=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	DO 220 IUPDN=1,NSPIN                 !!! over spins
	DO 210 L=0,ILSV(ISORT)
	DO 200 M=-L,L
	LM=L*(L+1)+M+1
C  d[2]Qlm/d[t,i]
	D2MAD(LM,IATOM,IUPDN,1)=D2MAD(LM,IATOM,IUPDN,1)+
     &  4.D0*PI*SMT(ISORT)/DBLE(2*L+1)*(DRHOPS(IPLW,IUPDN,1)+
     &  DRHOPS1(IPLW,IUPDN,1)+DRHOPS1(IPLW,IUPDN,2))*4.D0*PI*
     &  DCONJG(EXPT*YLM(LM))/AG*BES(L-1)*(0.D0,1.D0)*GX
	D2MAD(LM,IATOM,IUPDN,2)=D2MAD(LM,IATOM,IUPDN,2)+
     &  4.D0*PI*SMT(ISORT)/DBLE(2*L+1)*(DRHOPS(IPLW,IUPDN,1)+
     &  DRHOPS1(IPLW,IUPDN,1)+DRHOPS1(IPLW,IUPDN,2))*4.D0*PI*
     &  DCONJG(EXPT*YLM(LM))/AG*BES(L-1)*(0.D0,1.D0)*GY
	D2MAD(LM,IATOM,IUPDN,3)=D2MAD(LM,IATOM,IUPDN,3)+
     &  4.D0*PI*SMT(ISORT)/DBLE(2*L+1)*(DRHOPS(IPLW,IUPDN,1)+
     &  DRHOPS1(IPLW,IUPDN,1)+DRHOPS1(IPLW,IUPDN,2))*4.D0*PI*
     &  DCONJG(EXPT*YLM(LM))/AG*BES(L-1)*(0.D0,1.D0)*GZ
C  d[2]Mlm/d[t,i]
      D2MOM(LM,IATOM,IUPDN,1)=D2MOM(LM,IATOM,IUPDN,1)+
     &  SQPI4*4.D0*PI*SMT(ISORT)**2*(DRHOPS(IPLW,IUPDN,1)+
     &  DRHOPS1(IPLW,IUPDN,1)+DRHOPS1(IPLW,IUPDN,2))*
     &  DCONJG(EXPT*YLM(LM))/AG*BES(L+1)*(0.D0,1.D0)*GX
      D2MOM(LM,IATOM,IUPDN,2)=D2MOM(LM,IATOM,IUPDN,2)+
     &  SQPI4*4.D0*PI*SMT(ISORT)**2*(DRHOPS(IPLW,IUPDN,1)+
     &  DRHOPS1(IPLW,IUPDN,1)+DRHOPS1(IPLW,IUPDN,2))*
     &  DCONJG(EXPT*YLM(LM))/AG*BES(L+1)*(0.D0,1.D0)*GY
      D2MOM(LM,IATOM,IUPDN,3)=D2MOM(LM,IATOM,IUPDN,3)+
     &  SQPI4*4.D0*PI*SMT(ISORT)**2*(DRHOPS(IPLW,IUPDN,1)+
     &  DRHOPS1(IPLW,IUPDN,1)+DRHOPS1(IPLW,IUPDN,2))*
     &  DCONJG(EXPT*YLM(LM))/AG*BES(L+1)*(0.D0,1.D0)*GZ
 200  CONTINUE
 210  CONTINUE
 220  CONTINUE                             !!! over spins
 230  CONTINUE                             !!! over atoms
	ENDIF
 240  CONTINUE                             !!! over plane waves
C  SET MULTIPOLE CONTRIBUTION TO THE DYNAMICAL MATRIX
	DO 350 INUC=1,NATOM                  !!! over movements
	DO 340 IXYZ=1,3                      !!! over x,y,z
	IATOM=INUC                           !!! 
	ISORT=IS(IATOM)
	DO 320 L=0,ILSV(ISORT)               !!! over l
	DO 310 M=-L,L                        !!! over m
	LM=L*(L+1)+M+1
	LMM=L*(L+1)-M+1
 	DPSM(MY1,INUC1,IXYZ,INUC,1)=DPSM(MY1,INUC1,IXYZ,INUC,1)+
     &  1.D0/SQPI4*(-1)**(L+M)*(DELMRO(LMM,INUC,1,1,MY1,INUC1)+
     &  DELMRO(LMM,INUC,NSPIN,1,MY1,INUC1))/2.D0*DBLE(NSPIN)*
     &  (DRMAD(LM,INUC,1,IXYZ)+DRMAD(LM,INUC,NSPIN,IXYZ))/2.D0*
     &  DBLE(NSPIN)
	IF(SYM(LMM,IATOM))THEN
	ISYM=LMSYM(LMM,IATOM)
	DPSM(MY1,INUC1,IXYZ,INUC,2)=DPSM(MY1,INUC1,IXYZ,INUC,2)+
     &  1.D0/SQPI4*(-1)**(L+M)*(AMTOT(ISYM,INUC,1,1)+
     &  AMTOT(ISYM,INUC,NSPIN,1))/2.D0*DBLE(NSPIN)*
     &  (D2MAD(LM,INUC,1,IXYZ)+D2MAD(LM,INUC,NSPIN,IXYZ))/
     &  2.D0*DBLE(NSPIN)
	ENDIF
	IF(SYM(LM,IATOM))THEN
	ISYM=LMSYM(LM,IATOM)
	DPSM(MY1,INUC1,IXYZ,INUC,3)=DPSM(MY1,INUC1,IXYZ,INUC,3)-
     &  1.D0/SQPI4*(-1)**(L+M)*(D2MOM(LMM,INUC,1,IXYZ)+
     &  D2MOM(LMM,INUC,NSPIN,IXYZ))/2.D0*DBLE(NSPIN)*
     &  (QMAD(1,ISYM,INUC,1)+QMAD(2,ISYM,INUC,1)+
     &  QMAD(1,ISYM,INUC,NSPIN)+QMAD(2,ISYM,INUC,NSPIN))/
     &  2.D0*DBLE(NSPIN)
	ENDIF
 	DPSM(MY1,INUC1,IXYZ,INUC,4)=DPSM(MY1,INUC1,IXYZ,INUC,4)-
     &  1.D0/SQPI4*(-1)**(L+M)*(DRMOM(LMM,INUC,1,IXYZ)+
     &  DRMOM(LMM,INUC,NSPIN,IXYZ))/2.D0*DBLE(NSPIN)*(
     &  DELMAD(1,LM,INUC,1,MY1,INUC1)+DELMAD(1,LM,INUC,NSPIN,MY1,INUC1)+
     &  DELMAD(2,LM,INUC,1,MY1,INUC1)+DELMAD(2,LM,INUC,NSPIN,MY1,INUC1)+
     &  DELMAD(3,LM,INUC,1,MY1,INUC1)+DELMAD(3,LM,INUC,NSPIN,MY1,INUC1)+
     &  DELMAD(4,LM,INUC,1,MY1,INUC1)+DELMAD(4,LM,INUC,NSPIN,MY1,INUC1)+
     &  DELMAD(5,LM,INUC,1,MY1,INUC1)+DELMAD(5,LM,INUC,NSPIN,MY1,INUC1))
     &  /2.D0*DBLE(NSPIN)
 310	CONTINUE                             !!! over m
 320	CONTINUE                             !!! over l
 340	CONTINUE                             !!! over x,y,z
 350	CONTINUE                             !!! over movements
1000	CONTINUE                             !!! over polarizations
2000	CONTINUE                             !!! over displacements
C  TRANFERE TO CARTESIAN COORDINATES
	DO 640 INUC1=1,NATOM
	DO 630 INUC=1,NATOM
	DO 620 IXYZ=1,3
	DO 610 MY1=-1,1
	DTMP(MY1)=DPSM(MY1,INUC1,IXYZ,INUC,1)+
     &          DPSM(MY1,INUC1,IXYZ,INUC,2)+
     &          DPSM(MY1,INUC1,IXYZ,INUC,3)+
     &          DPSM(MY1,INUC1,IXYZ,INUC,4)
 610	CONTINUE
	CALL PHN_TRANSFER(DTMP(-1),DMLT(1,INUC1,IXYZ,INUC,1))
 620	CONTINUE
 630	CONTINUE
 640	CONTINUE
C Memory deallocations
	DEALLOCATE(YLM,D2MAD,DRMOM,DRMAD,D2MOM,DPSM,BES,BESD)
	END




	SUBROUTINE PHN_SEXCMAT(DEXC,IQPNT)
*********************************************************
*  Calculates exchange-correlation contribution to the  *
*  Dynamical Matrix.                                    *
*********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE,ILDA,IGGA              !!! from readini
	USE COM_PHNCOM,  ONLY : NITER                                      !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
     &                       ,NHSORT
	USE COM_RADMESH, ONLY : NRAD,H,R,DR,WEIGHT,RL                      !!! from radmsh
	USE COM_LATPAR,  ONLY : PAR,ORTH,OMEGAC                            !!! from readini
	USE COM_QMESH,   ONLY : NQPNT,QPNT                                 !!! from readpnt
      USE COM_PLW2MSH, ONLY : N2PLW,G2PLW	                               !!! from makeplw
	USE COM_SYMMLM,  ONLY : SYM,LMSYM                                  !!! from makesym
	USE COM_PLWMESH, ONLY : NPLW,GPLW                                  !!! from makeplw
	USE COM_SPHERE,  ONLY : SWZ,SMT                                    !!! from readini
	USE COM_POTDAT,  ONLY : POT,POTSPH,POTPS,POTPS1                    !!! from fulpot
	USE COM_DENDAT,  ONLY : RHO,RHOCOR,RHOPS,RHOPS1                    !!! from readscf
	USE COM_DELPOT,  ONLY : DPOT,DPOTPS,DPOTPS1                        !!! from delpot
      USE COM_DELRHO,  ONLY : DRHO,DRHOPS,DRHOPS1                        !!! from delrho
	USE COM_GAUNT,   ONLY : C                                          !!! from makegnt
	USE COM_PHNCHN  ,ONLY : IUDPX,IUDPY                                !!! from channels
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8, ALLOCATABLE :: WORK3(:)
	REAL*8, ALLOCATABLE :: WORK4(:)
	COMPLEX*16, ALLOCATABLE :: WORK1(:)
	COMPLEX*16, ALLOCATABLE :: WORK2(:)
	COMPLEX*16, ALLOCATABLE :: PROD(:)
	COMPLEX*16, ALLOCATABLE :: TMPARR(:)
	COMPLEX*16, ALLOCATABLE :: DPSM(:,:,:,:,:)
	REAL*8 TR1,TR2
      COMPLEX*16 DXYZ(3),GMY1,DINT,DSRF(-1:1),CGNT
     &   ,DEXC(3,NATOMMEM,3,NATOMMEM,4)
	DATA PI/3.141592653589793D0/
	DO 1 INUC1=1,NATOM
	DO 1 INUC =1,NATOM
	DO 1 IXYZ1=1,3
	DO 1 IXYZ =1,3
	DO 1 MY1=-1,1
	DO 1 IC=1,4
	DEXC(IXYZ1,INUC1,IXYZ,INUC,IC)=(0.D0,0.D0)
   1  CONTINUE
      IF(NPFR.EQ.0)RETURN
C Memory allocations
	ALLOCATE(WORK1(0:NRADMEM))
	ALLOCATE(WORK2(0:NRADMEM))
	ALLOCATE(WORK3(0:NRADMEM))
	ALLOCATE(WORK4(0:NRADMEM))
	ALLOCATE(PROD(0:9*NPLWMEM))
	ALLOCATE(TMPARR(0:NPLWMEM))
	ALLOCATE(DPSM(-1:1,NATOMMEM,3,NATOMMEM,4))
	SQPI4=2.D0*SQRT(PI)
	DO 10 INUC1=1,NATOM
	DO 10 INUC =1,NATOM
	DO 10 IXYZ1=1,3
	DO 10 IXYZ =1,3
	DO 10 MY1=-1,1
	DO 10 IC=1,4
	DPSM(  MY1,INUC1,IXYZ,INUC,IC)=(0.D0,0.D0)
  10	CONTINUE
C  SET EXCHANGE-CORRELATION ENERGY
      DO 30 IATOM=1,NATOM                        !!! over atoms
      ISORT=IS(IATOM)
      DO 30 IORBS=1,NORBS                        !!! over spins
      DO 30 IUPDN=1,NSPIN                        !!! over spins
      DO 30 L=0,ILSV(ISORT)                      !!! over l
      DO 30 M=-L,L                               !!! over m
      LM=L*(L+1)+M+1
      IF(SYM(LM,IATOM))THEN                      !!! for non-zero components
      ISYM=LMSYM(LM,IATOM)
      DO 20 IRAD=0,NRAD(ISORT)                   !!! over rad.points
      POT(IRAD,ISYM,IATOM,IUPDN,IORBS)=(0.D0,0.D0)
  20  CONTINUE                                   !!! over rad.points
      ENDIF                                      !!! for non-zero components
  30  CONTINUE                                   !!! 
      DO 40 IORBS=1,NORBS
      DO 40 IUPDN=1,NSPIN
      DO 40 IPLW=0,NPLW
      POTPS(IPLW,IUPDN,IORBS)=(0.D0,0.D0)
  40  CONTINUE
      CALL POT_VEXCH(2)                          !!! exchange-correlation within MTs
      CALL POT_VXFTR(2)                          !!! pseudopart by Fourier transform
C  *** SET EXCHANGE-CORRELATION CONTRIBUTION TO DYNAMICAL MATRIX ***
	DO 2000 INUC1=1,NATOM                      !!! over displacements
	DO 1000 MY1=-1,1                           !!! over polarizations
	IF(NITER(MY1,INUC1).EQ.0)GOTO1000
      CALL DRO_DROFILES(MY1,INUC1,IQPNT,IUDPX,'R','D',' ')  !!! read change in density
      CALL DRO_DPSFILES(MY1,INUC1,IQPNT,IUDPY,'R','D',' ')  !!! read change in density
C  CALCULATE CHANGE IN EXCHANGE-CORRELATION ENERGY
	DO 50 IORBS=1,NORBS                        !!! over spins
	DO 50 IUPDN=1,NSPIN                        !!! over spins
      DO 50 IATOM=1,NATOM                        !!! over all atoms in cell
      ISORT=IS(IATOM)
      DO 50 L=0,ILSV(ISORT)                      !!! over l
      DO 50 M=-L,L                               !!! over m
      LM=L*(L+1)+M+1
      DO 50 IRAD=0,NRAD(ISORT)                   !!! over radial mesh
      DPOT(IRAD,LM,IATOM,IUPDN,IORBS)=(0.D0,0.D0)
  50  CONTINUE                                   !!! 
	DO 60 IORBS=1,NORBS                        !!! over spins
	DO 60 IUPDN=1,NSPIN                        !!! over spins
      DO 60 IPLW=0,NPLW                          !!! over plane waves
      DPOTPS(IPLW,IUPDN,IORBS)=(0.D0,0.D0) 
  60  CONTINUE                                   !!! 
      CALL DPT_DELVEXCH(MY1,INUC1,IQPNT,2)           !!! change in XC-energy in MTS
      CALL DPT_DELVXFTR(MY1,INUC1,IQPNT,2)           !!! change in XC-energy in INT
	IF(NPFR.EQ.1)THEN !!! slow calculation
C  CALCULATE DEXC1=d(+)/d(t1,i1)*Int[grad_i(rho)*Vexc]
C  1) Dexc1_1=Int[grad_i[d(+)rho/d(t1,i1)]*Vexc]
	DO 120 IXYZ =1,3                           !!! over polarizations
	DO 119 IORBS=1,NORBS                       !!! over spins
	DO 118 IUPDN=1,NSPIN                       !!! over spins
	DO 112 IPLW=0,NPLW                         !!! over plane waves
	TMPARR(IPLW)=DRHOPS(IPLW,IUPDN,IORBS)*2.D0*PI/PAR*
     &  (QPNT(IXYZ,IQPNT)+GPLW(IXYZ,IPLW))*(0.D0,1.D0)
 112	CONTINUE                                   !!! over plane waves
	CALL PHN_RHOVSUB(POTPS(0,IUPDN,IORBS),TMPARR,PROD)
	DO 116 INUC=1,NATOM                        !!! over displacements
	DO 114 I2PLW=0,N2PLW                       !!! over plane waves
	CALL INI_MAKEPLW_DINT(G2PLW(1,I2PLW)+QPNT(1,IQPNT),
     &                      G2PLW(2,I2PLW)+QPNT(2,IQPNT),
     &                      G2PLW(3,I2PLW)+QPNT(3,IQPNT),DINT,INUC)
	DPSM(MY1,INUC1,IXYZ,INUC,1)=
     &DPSM(MY1,INUC1,IXYZ,INUC,1)+PROD(I2PLW)*DINT
 114	CONTINUE                                   !!! over palne waves 
 116	CONTINUE                                   !!! over displacements
 118	CONTINUE                                   !!! over spins
 119	CONTINUE                                   !!! over spins
 120	CONTINUE                                   !!! over polarizations
C  2) Dexc1_2=Int[grad_i(rho)*d(+)Vexc/d(t1,i1)]
	DO 130 IXYZ =1,3                           !!! over polarizations
	DO 129 IORBS=1,NORBS                       !!! over spins
	DO 128 IUPDN=1,NSPIN                       !!! over spins
	DO 122 IPLW=0,NPLW                         !!! over plane waves
	TMPARR(IPLW)=RHOPS(IPLW,IUPDN,IORBS)*2.D0*PI/PAR*
     &  GPLW(IXYZ,IPLW)*(0.D0,1.D0)
 122	CONTINUE                                   !!! over plane waves
	CALL PHN_RHOVSUB(TMPARR,DPOTPS(0,IUPDN,IORBS),PROD)
	DO 126 INUC=1,NATOM                        !!! over displacements
	DO 124 I2PLW=0,N2PLW                       !!! over plane waves
	CALL INI_MAKEPLW_DINT(G2PLW(1,I2PLW)+QPNT(1,IQPNT),
     &                      G2PLW(2,I2PLW)+QPNT(2,IQPNT),
     &                      G2PLW(3,I2PLW)+QPNT(3,IQPNT),DINT,INUC)
	DPSM(MY1,INUC1,IXYZ,INUC,1)=
     &DPSM(MY1,INUC1,IXYZ,INUC,1)+PROD(I2PLW)*DINT
 124	CONTINUE                                   !!! over palne waves 
 126	CONTINUE                                   !!! over displacements
 128	CONTINUE                                   !!! over spins
 129	CONTINUE                                   !!! over spins
 130	CONTINUE                                   !!! over polarizations
C  3) Dexc1_3=d(+)Int/d(t1,i1)[grad_i(rho)*Vexc]
	DO 140 IXYZ =1,3                           !!! over polarizations
	DO 139 IORBS=1,NORBS                       !!! over spins
	DO 138 IUPDN=1,NSPIN                       !!! over spins
	DO 132 IPLW=0,NPLW                         !!! over plane waves
	TMPARR(IPLW)=RHOPS(IPLW,IUPDN,IORBS)*2.D0*PI/PAR*
     &  GPLW(IXYZ,IPLW)*(0.D0,1.D0)
 132	CONTINUE                                   !!! over plane waves
	CALL PHN_RHOVSUB(TMPARR,POTPS(0,IUPDN,IORBS),PROD)
	DO 136 INUC=1,NATOM                        !!! over displacements
	IF(INUC1.EQ.INUC)THEN
	DO 134 I2PLW=0,N2PLW                       !!! over plane waves
      IF(MY1.EQ.-1)GMY1=+1.D0/SQRT(2.D0)*
     &  (G2PLW(1,I2PLW)-(0.D0,1.D0)*G2PLW(2,I2PLW))
      IF(MY1.EQ.+1)GMY1=-1.D0/SQRT(2.D0)*
     &  (G2PLW(1,I2PLW)+(0.D0,1.D0)*G2PLW(2,I2PLW))
      IF(MY1.EQ. 0)GMY1=G2PLW(3,I2PLW)
	CALL INI_MAKEPLW_DINT(G2PLW(1,I2PLW),
     &                      G2PLW(2,I2PLW),
     &                      G2PLW(3,I2PLW),DINT,INUC)
	DINT=DINT*2.D0*PI/PAR*(0.D0,1.D0)*GMY1
	DPSM(MY1,INUC1,IXYZ,INUC,1)=
     &DPSM(MY1,INUC1,IXYZ,INUC,1)+PROD(I2PLW)*DINT
 134	CONTINUE                                   !!! over palne waves 
	ENDIF
 136	CONTINUE                                   !!! over displacements
 138	CONTINUE                                   !!! over spins
 139	CONTINUE                                   !!! over spins
 140	CONTINUE                                   !!! over polarizations
C  CALCULATE DEXC2=d(+)/d(t1,i1)*Int[rho*grad_i(Vexc)]
C  1) Dexc2_1=Int[d(+)rho/d(t1,i1)*grad_i(Vexc)]
	DO 150 IXYZ =1,3                           !!! over polarizations
	DO 149 IORBS=1,NORBS                       !!! over spins
	DO 148 IUPDN=1,NSPIN                       !!! over spins
	DO 142 IPLW=0,NPLW                         !!! over plane waves
	TMPARR(IPLW)=POTPS(IPLW,IUPDN,IORBS)*2.D0*PI/PAR*
     &  GPLW(IXYZ,IPLW)*(0.D0,1.D0)
 142	CONTINUE                                   !!! over plane waves
	CALL PHN_RHOVSUB(TMPARR,DRHOPS(0,IUPDN,IORBS),PROD)
	DO 146 INUC=1,NATOM                        !!! over displacements
	DO 144 I2PLW=0,N2PLW                       !!! over plane waves
	CALL INI_MAKEPLW_DINT(G2PLW(1,I2PLW)+QPNT(1,IQPNT),
     &                      G2PLW(2,I2PLW)+QPNT(2,IQPNT),
     &                      G2PLW(3,I2PLW)+QPNT(3,IQPNT),DINT,INUC)
	DPSM(MY1,INUC1,IXYZ,INUC,2)=
     &DPSM(MY1,INUC1,IXYZ,INUC,2)+PROD(I2PLW)*DINT
 144	CONTINUE                                   !!! over palne waves 
 146	CONTINUE                                   !!! over displacements
 148	CONTINUE                                   !!! over spins
 149	CONTINUE                                   !!! over spins
 150	CONTINUE                                   !!! over polarizations
C  2) Dexc2_2=Int[rho*grad_i[d(+)Vexc/d(t1,i1)]]
	DO 160 IXYZ =1,3                           !!! over polarizations
	DO 159 IORBS=1,NORBS                       !!! over spins
	DO 158 IUPDN=1,NSPIN                       !!! over spins
	DO 152 IPLW=0,NPLW                         !!! over plane waves
	TMPARR(IPLW)=DPOTPS(IPLW,IUPDN,IORBS)*2.D0*PI/PAR*
     &  (QPNT(IXYZ,IQPNT)+GPLW(IXYZ,IPLW))*(0.D0,1.D0)
 152	CONTINUE                                   !!! over plane waves
	CALL PHN_RHOVSUB(RHOPS(0,IUPDN,IORBS),TMPARR,PROD)
	DO 156 INUC=1,NATOM                        !!! over displacements
	DO 154 I2PLW=0,N2PLW                       !!! over plane waves
	CALL INI_MAKEPLW_DINT(G2PLW(1,I2PLW)+QPNT(1,IQPNT),
     &                      G2PLW(2,I2PLW)+QPNT(2,IQPNT),
     &                      G2PLW(3,I2PLW)+QPNT(3,IQPNT),DINT,INUC)
	DPSM(MY1,INUC1,IXYZ,INUC,2)=
     &  DPSM(MY1,INUC1,IXYZ,INUC,2)+PROD(I2PLW)*DINT
 154	CONTINUE                                   !!! over palne waves 
 156	CONTINUE                                   !!! over displacements
 158	CONTINUE                                   !!! over spins
 159	CONTINUE                                   !!! over spins
 160	CONTINUE                                   !!! over polarizations
C  3) Dexc2_3=d(+)Int/d(t1,i1)[rho*grad_i(Vexc)]
	DO 170 IXYZ =1,3                           !!! over polarizations
	DO 169 IORBS=1,NORBS                       !!! over spins
	DO 168 IUPDN=1,NSPIN                       !!! over spins
	DO 162 IPLW=0,NPLW                         !!! over plane waves
	TMPARR(IPLW)=POTPS(IPLW,IUPDN,IORBS)*2.D0*PI/PAR*
     &GPLW(IXYZ,IPLW)*(0.D0,1.D0)
 162	CONTINUE                                   !!! over plane waves
	CALL PHN_RHOVSUB(RHOPS(0,IUPDN,IORBS),TMPARR,PROD)
	DO 166 INUC=1,NATOM                        !!! over displacements
	IF(INUC1.EQ.INUC)THEN
	DO 164 I2PLW=0,N2PLW                       !!! over plane waves
      IF(MY1.EQ.-1)GMY1=+1.D0/SQRT(2.D0)*
     &  (G2PLW(1,I2PLW)-(0.D0,1.D0)*G2PLW(2,I2PLW))
      IF(MY1.EQ.+1)GMY1=-1.D0/SQRT(2.D0)*
     &  (G2PLW(1,I2PLW)+(0.D0,1.D0)*G2PLW(2,I2PLW))
      IF(MY1.EQ. 0)GMY1=G2PLW(3,I2PLW)
	CALL INI_MAKEPLW_DINT(G2PLW(1,I2PLW),
     &                      G2PLW(2,I2PLW),
     &                      G2PLW(3,I2PLW),DINT,INUC)
	DINT=DINT*2.D0*PI/PAR*(0.D0,1.D0)*GMY1
	DPSM(MY1,INUC1,IXYZ,INUC,2)=
     &DPSM(MY1,INUC1,IXYZ,INUC,2)+PROD(I2PLW)*DINT
 164	CONTINUE                                   !!! over palne waves 
	ENDIF
 166	CONTINUE                                   !!! over displacements
 168	CONTINUE                                   !!! over spins
 169	CONTINUE                                   !!! over spins
 170	CONTINUE                                   !!! over polarizations
	ELSEIF(NPFR.EQ.2)THEN !!! fast calculation
C  CALCULATE DEXC1=d(+)/d(t1,i1)*Int[grad_i(rho*Vexc)]
C  1) Dexc1_1=Int[grad_i[d(+)rho/d(t1,i1)*Vexc]]
	DO 319 IORBS=1,NORBS                       !!! over spins
	DO 318 IUPDN=1,NSPIN                       !!! over spins
	DO 312 IPLW=0,NPLW                         !!! over plane waves
	TMPARR(IPLW)=DRHOPS(IPLW,IUPDN,IORBS)
 312	CONTINUE                                   !!! over plane waves
	CALL PHN_RHOVSUB(POTPS(0,IUPDN,IORBS),TMPARR,PROD)
	DO 316 INUC=1,NATOM                        !!! over displacements
	DO 314 I2PLW=0,N2PLW                       !!! over plane waves
	CALL INI_MAKEPLW_DINT(G2PLW(1,I2PLW)+QPNT(1,IQPNT),
     &                      G2PLW(2,I2PLW)+QPNT(2,IQPNT),
     &                      G2PLW(3,I2PLW)+QPNT(3,IQPNT),DINT,INUC)
	DINT=DINT*PROD(I2PLW)*(0.D0,1.D0)*2.D0*PI/PAR
	DPSM(MY1,INUC1,1,INUC,1)=
     &DPSM(MY1,INUC1,1,INUC,1)+DINT*(G2PLW(1,I2PLW)+QPNT(1,IQPNT))
	DPSM(MY1,INUC1,2,INUC,1)=
     &DPSM(MY1,INUC1,2,INUC,1)+DINT*(G2PLW(2,I2PLW)+QPNT(2,IQPNT))
	DPSM(MY1,INUC1,3,INUC,1)=
     &DPSM(MY1,INUC1,3,INUC,1)+DINT*(G2PLW(3,I2PLW)+QPNT(3,IQPNT))
 314	CONTINUE                                   !!! over palne waves 
 316	CONTINUE                                   !!! over displacements
 318	CONTINUE                                   !!! over spins
 319	CONTINUE                                   !!! over spins
C  2) Dexc1_2=Int[grad_i[rho*(d(+)Vexc/d(t1,i1))]
	DO 329 IORBS=1,NORBS                       !!! over spins
	DO 328 IUPDN=1,NSPIN                       !!! over spins
	DO 322 IPLW=0,NPLW                         !!! over plane waves
	TMPARR(IPLW)=DPOTPS(IPLW,IUPDN,IORBS)
 322	CONTINUE                                   !!! over plane waves
	CALL PHN_RHOVSUB(RHOPS(0,IUPDN,IORBS),TMPARR,PROD)
	DO 326 INUC=1,NATOM                        !!! over displacements
	DO 324 I2PLW=0,N2PLW                       !!! over plane waves
	CALL INI_MAKEPLW_DINT(G2PLW(1,I2PLW)+QPNT(1,IQPNT),
     &                      G2PLW(2,I2PLW)+QPNT(2,IQPNT),
     &                      G2PLW(3,I2PLW)+QPNT(3,IQPNT),DINT,INUC)
	DINT=DINT*PROD(I2PLW)*(0.D0,1.D0)*2.D0*PI/PAR
	DPSM(MY1,INUC1,1,INUC,1)=
     &DPSM(MY1,INUC1,1,INUC,1)+DINT*(G2PLW(1,I2PLW)+QPNT(1,IQPNT))
	DPSM(MY1,INUC1,2,INUC,1)=
     &DPSM(MY1,INUC1,2,INUC,1)+DINT*(G2PLW(2,I2PLW)+QPNT(2,IQPNT))
	DPSM(MY1,INUC1,3,INUC,1)=
     &DPSM(MY1,INUC1,3,INUC,1)+DINT*(G2PLW(3,I2PLW)+QPNT(3,IQPNT))
 324	CONTINUE                                   !!! over palne waves 
 326	CONTINUE                                   !!! over displacements
 328	CONTINUE                                   !!! over spins
 329	CONTINUE                                   !!! over spins
C  3) Dexc1_3=d(+)Int/d(t1,i1)[grad_i[rho*Vexc]]
	DO 339 IORBS=1,NORBS                       !!! over spins
	DO 338 IUPDN=1,NSPIN                       !!! over spins
	DO 332 IPLW=0,NPLW                         !!! over plane waves
	TMPARR(IPLW)=POTPS(IPLW,IUPDN,IORBS)
 332	CONTINUE                                   !!! over plane waves
	CALL PHN_RHOVSUB(RHOPS(0,IUPDN,IORBS),TMPARR,PROD)
	DO 336 INUC=1,NATOM                        !!! over displacements
	IF(INUC1.EQ.INUC)THEN
	DO 334 I2PLW=0,N2PLW                       !!! over plane waves
      IF(MY1.EQ.-1)GMY1=+1.D0/SQRT(2.D0)*
     &  (G2PLW(1,I2PLW)-(0.D0,1.D0)*G2PLW(2,I2PLW))
      IF(MY1.EQ.+1)GMY1=-1.D0/SQRT(2.D0)*
     &  (G2PLW(1,I2PLW)+(0.D0,1.D0)*G2PLW(2,I2PLW))
      IF(MY1.EQ. 0)GMY1=G2PLW(3,I2PLW)
	CALL INI_MAKEPLW_DINT(G2PLW(1,I2PLW),
     &                      G2PLW(2,I2PLW),
     &                      G2PLW(3,I2PLW),DINT,INUC)
	DINT=DINT*PROD(I2PLW)*(0.D0,1.D0)*2.D0*PI/PAR*
     *  (0.D0,1.D0)*2.D0*PI/PAR*GMY1
	DPSM(MY1,INUC1,1,INUC,1)=
     &DPSM(MY1,INUC1,1,INUC,1)+DINT*G2PLW(1,I2PLW)
	DPSM(MY1,INUC1,2,INUC,1)=
     &DPSM(MY1,INUC1,2,INUC,1)+DINT*G2PLW(2,I2PLW)
	DPSM(MY1,INUC1,3,INUC,1)=
     &DPSM(MY1,INUC1,3,INUC,1)+DINT*G2PLW(3,I2PLW)
 334	CONTINUE                                   !!! over palne waves 
	ENDIF
 336	CONTINUE                                   !!! over displacements
 338	CONTINUE                                   !!! over spins
 339	CONTINUE                                   !!! over spins
	ENDIF   !!! slow/fast calculations
C  ESTIMATE SURFACE INTEGRALS FROM CHARGE DENSITY AND POTENTIAL
	DO 580 INUC=1,NATOM                        !!! over inuc
	ISORT=IS(INUC)
	DO 570 MY=-1,1                             !!! over my
	DSRF(MY)=(0.D0,0.D0)
	DO 560 L1=0,ILSV(ISORT)                    !!! over l1
	DO 550 M1=-L1,L1                           !!! over m1
	L1M1=L1*(L1+1)+M1+1
	IF(.NOT.SYM(L1M1,INUC))GOTO550
	ISYM1=LMSYM(L1M1,INUC)
	DO 540 L=0,ILSV(ISORT)                     !!! over l
	DO 530 M=-L,L                              !!! over m
	LM=L*(L+1)+M+1
      DO 520 L2=ABS(L1-L),L1+L,2                 !!! over l2
      M2=M-M1
      IF(L2.EQ.1.AND.M2.EQ.-MY)THEN
	CGNT=(0.D0,1.D0)**(L-L1-L2)*C(L2/2,LM,L1M1)
	DO 512 IORBS=1,NORBS                       !!! over spins
	DO 510 IUPDN=1,NSPIN                       !!! over spins
	DSRF(MY)=DSRF(MY)+(0.D0,1.D0)*SQRT(4.D0*PI/3.D0)*
     &  (-1)**MY*SMT(ISORT)**2*CGNT*(
     &  DCONJG(RHO(NRAD(ISORT),ISYM1,INUC,IUPDN,IORBS))*
     &  DPOT(NRAD(ISORT),LM,INUC,IUPDN,IORBS)+
     &  DCONJG(POT(NRAD(ISORT),ISYM1,INUC,IUPDN,IORBS))*
     &  DRHO(NRAD(ISORT),LM,INUC,IUPDN,IORBS))
 510 	CONTINUE                                   !!! over spins
 512 	CONTINUE                                   !!! over spins
	ENDIF
 520  CONTINUE                                   !!! over l2
 530 	CONTINUE                                   !!! over m
 540 	CONTINUE                                   !!! over l
 550	CONTINUE                                   !!! over m1
 560	CONTINUE                                   !!! over l1
 570	CONTINUE                                   !!! over my
	CALL PHN_TRANSFER(DSRF(-1),DXYZ(1))
	DPSM(MY1,INUC1,1,INUC,4)=DXYZ(1)
	DPSM(MY1,INUC1,2,INUC,4)=DXYZ(2)
	DPSM(MY1,INUC1,3,INUC,4)=DXYZ(3)
 580	CONTINUE                                   !!! over inuc
1000 	CONTINUE                                   !!! over polarizations
2000	CONTINUE                                   !!! over displacements
C  TRANFERE TO CARTESIAN COORDINATES
	DO 640 INUC1=1,NATOM
	DO 630 INUC=1,NATOM
	DO 620 IXYZ=1,3
	DO 610 IC=1,4
	CALL PHN_TRANSFER(DPSM(-1,INUC1,IXYZ,INUC,IC),
     &              DEXC( 1,INUC1,IXYZ,INUC,IC))
 610	CONTINUE
 620	CONTINUE
 630	CONTINUE
 640	CONTINUE
C Memory deallocations
	DEALLOCATE(WORK1,WORK2,WORK3,WORK4,PROD,TMPARR,DPSM)
	END






	SUBROUTINE PHN_TRANSFER(A,B)
************************************************************
*  Transfere from cyclic to cartesian system.              *
************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16 TR(-1:1,3),A(-1:1),B(3)
      DATA TR/(+0.70710678118655D0, 0.00000000000000D0)
     &         ,( 0.00000000000000D0, 0.00000000000000D0)
     &         ,(-0.70710678118655D0, 0.00000000000000D0)
     &         ,( 0.00000000000000D0,+0.70710678118655D0)
     &         ,( 0.00000000000000D0, 0.00000000000000D0)
     &         ,( 0.00000000000000D0,+0.70710678118655D0)
     &         ,( 0.00000000000000D0, 0.00000000000000D0)
     &         ,( 1.00000000000000D0, 0.00000000000000D0)
     &         ,( 0.00000000000000D0, 0.00000000000000D0)/
	DO 20 I=1,3
	B(I)=(0.D0,0.D0)
	DO 10 MY=-1,1
	B(I)=B(I)+A(MY)*TR(MY,I)
  10  CONTINUE
  20  CONTINUE        
	END


	SUBROUTINE PHN_TRANSMAT(A,B,NATOM)
************************************************************
*  Transfere from cyclic to cartesian system.              *
************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16 TR(-1:1,3),A(-1:1,NATOM,-1:1,NATOM)
     &    ,B(3,NATOM,3,NATOM)
      DATA TR/(+0.70710678118655D0, 0.00000000000000D0)
     &       ,( 0.00000000000000D0, 0.00000000000000D0)
     &       ,(-0.70710678118655D0, 0.00000000000000D0)
     &       ,( 0.00000000000000D0,+0.70710678118655D0)
     &       ,( 0.00000000000000D0, 0.00000000000000D0)
     &       ,( 0.00000000000000D0,+0.70710678118655D0)
     &       ,( 0.00000000000000D0, 0.00000000000000D0)
     &       ,( 1.00000000000000D0, 0.00000000000000D0)
     &       ,( 0.00000000000000D0, 0.00000000000000D0)/
	DO 60 INUC1=1,NATOM
	DO 50 INUC =1,NATOM
	DO 40 I=1,3
	DO 30 J=1,3
      B(I,INUC1,J,INUC)=(0.D0,0.D0)
      DO 20 MY1=-1,1                          !!! over -1,0,1
      DO 10 MY=-1,1                           !!! over -1,0,1
      B(I,INUC1,J,INUC)=B(I,INUC1,J,INUC)+
     &A(MY1,INUC1,MY,INUC)*TR(MY1,I)*TR(MY,J)
  10  CONTINUE                                 !!! over -1,0,1
  20  CONTINUE                                 !!! over -1,0,1
  30  CONTINUE                                 !!! over x,y,z
  40  CONTINUE                                 !!! over x,y,z
  50  CONTINUE                                 !!! over displacements
  60  CONTINUE                                 !!! over displacements
	END



      SUBROUTINE PHN_RHOVSUB(RHOPS,POTPS,PROD)
*****************************************************************
*  Calculates product of rho(G') and v(G) as an expansion       *
*  in plane waves.                                              *
*****************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_PLWMESH, ONLY : NPLW,GPLW,KVEC,KGMIN,KGMAX,INDG            !!! from makeplw
      USE COM_PLW2MSH, ONLY : N2PLW,G2PLW,INDG2     	                   !!! from makeplw
	USE COM_LATPAR,  ONLY : PAR,ORTH,OMEGAC                            !!! from readini
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 RHOPS(0:NPLW),POTPS(0:NPLW),PROD(0:9*NPLW)
      DATA PI/3.141592653589793D0/
C  SET ZERO IN PROD-ARRAY
	DO 10 I2PLW=0,N2PLW
	PROD(I2PLW)=(0.D0,0.D0)
  10	CONTINUE
C  DO OVER PLANE WAVES
      M1D=2*KGMAX(1)-2*KGMIN(1)+1
      M2D=2*KGMAX(2)-2*KGMIN(2)+1
      M3D=2*KGMAX(3)-2*KGMIN(3)+1
      M12D=M1D*M2D
      M123D=M1D*M2D*M3D
      DO 30 IPLW=0,NPLW
      M1I=KVEC(1,IPLW)+2*KGMIN(1)
      M2I=KVEC(2,IPLW)+2*KGMIN(2)
      M3I=KVEC(3,IPLW)+2*KGMIN(3)
      DO 20 JPLW=0,NPLW
      M1=KVEC(1,JPLW)-M1I
      M2=KVEC(2,JPLW)-M2I
      M3=KVEC(3,JPLW)-M3I
      IDIM=1+M1+M1D*M2+M12D*M3
      I2PLW=INDG2(IDIM)
	PROD(I2PLW)=PROD(I2PLW)+DCONJG(RHOPS(IPLW))*POTPS(JPLW)
  20	CONTINUE
  30	CONTINUE
	END
