	SUBROUTINE PHN_EPITET(IQPNT)
*****************************************************************
*  Calculate weight function for the integration over BZ        *
*  of the imaginary part of susceptibility:                     *
*                                                               *
*  ___    /  3                                                  *
*  >      \ d k   d(Ef-E(kj))*d(Ef-E(k+qj')*R(k,k+q,jj')        *
*  ---    /                                                     *
*  jj'     BZ                                                   *
*                                                               *
*  ___    /  3                                                  *
*  >      \ d k d(Ef-E(kj))*d(Ef-E(k+qj')*R(k,k+q,jj')          *
*  ---    /                                 *(v(kj)-v(k+qj')^2  * 
*  jj'     BZ                                                   *
*                                                               *
*  where d(x) are the delta-functions and R are the matrix      *
*  elements. Tetrahedron method is used.                        *
*****************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_LATTICE, ONLY : RBAS,GBAS,AKBAS                            !!! from readstr
	USE COM_LATPAR,  ONLY : PAR,ORTH,OMEGAC                            !!! from readini
	USE COM_KMESH,   ONLY : NPNT,PNT,KCUT,IPQARR                       !!! from makettr
 	USE COM_WMESH,   ONLY : NPNW,PNW,KCUW,IPWARR,IGWARR                !!! from makettr
	USE COM_SYMMESW, ONLY : IG0IGW=>IG0IG1,IK0IKW=>IK0IK1              !!! from delmesw
	USE COM_LRTCOM,  ONLY : LWHI                                       !!! from readlrt
	USE COM_ENERGY,  ONLY : ETRT,ETRW                                  !!! from lmtbnd
 	USE COM_KAPPAR,  ONLY : NPAN                                       !!! from readini
	USE COM_NBANDS,  ONLY : NBNDF,NBNDE,NBNDT,NBNDC,NBNDH              !!! from readini
	USE COM_INPTTR,  ONLY : NDIV,NDIW                                  !!! from readini
	USE COM_GROUPS,  ONLY : NGROUP,INV,IKOV                            !!! from makegrp
	USE COM_SUBGROUP,ONLY : NSGQ,NGEQ,ISG,KSYMPN,MSYMPN,IGS            !!! from delmesh
	USE COM_QMESH,   ONLY : NQPNT,QPNT                                 !!! from readpnt
	USE COM_FERMI,   ONLY : EF                                         !!! from ttrint
	USE COM_MASHDEP, ONLY : NVAL                                       !!! from setup
	USE COM_PHNCHN  ,ONLY : IUTTR,IUTTW                                !!! from channels
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	USE COM_LMTOUT
	USE COM_PHNOUT
	IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8, ALLOCATABLE :: WVEL(:,:,:,:)
	REAL*8, ALLOCATABLE :: WEPI(:,:,:)
	COMPLEX*16, ALLOCATABLE :: DELH(:,:,:,:)
	INTEGER KTQ(4),KT(4),KTT(4),KGG(4),KTW(4)
	LOGICAL EXIST
	DIMENSION REC(3,3),QWGT(4),AT(4),AD(4)
     &   ,PKT(3,4),PQT(3,4),VK(3),VQ(3)
     &   ,E(4),H(4),ATB(4),ADB(4),VEL(3)
     &   ,PKW(3,4),CRW(3,4),CHIM(4)
	CHARACTER*130 FILE
	DATA PI/3.141592653589793D0/,EPS/1.D-10/
	IF(LWHI.NE.2)RETURN
C Memory allocations
	ALLOCATE(WVEL(NBNDC(1)*NSPINMEM,NBNDC(1)*NSPINMEM,3,4))
	ALLOCATE(WEPI(NBNDC(1)*NSPINMEM,NBNDC(1)*NSPINMEM,4))
	ALLOCATE(DELH(NBNDC(1)*NSPINMEM,NBNDC(1)*NSPINMEM,-1:1,NATOMMEM))
	IF(ICWGT.NE.0)FILE=WGTFILE(LWHI)
	IF(ICWGT.EQ.0)FILE=SCRFILE(IUTTR)
	IF(ICWGT.EQ.2)GOTO 5000
C  OPEN FILE FOR STORING WEIGHTS
      NRECL=NVAL/2*NBNDC(1)**2*4+NVAL*NBNDC(1)**2*3*NATOM
	NRECL=MAX(NRECL,NVAL/2*12)
      OPEN(UNIT=IUTTR,FILE=FILE,STATUS='NEW',
     &FORM='UNFORMATTED',ACCESS='DIRECT',RECL=NRECL)
	WRITE(IUTTR,REC=1)NRECL,NDIV(1),NDIV(2),NDIV(3),NPNT(1),
     &NBNDF(1),NBNDE(1),NBNDT(1),NBNDH(1),NSPIN,NORBS,LWHI
C  OPEN SCRATCH FILE FOR FAST ACCESS
      OPEN(UNIT=IUTTW,FILE=SCRFILE(IUTTW),STATUS='NEW',
     &FORM='UNFORMATTED',ACCESS='DIRECT',RECL=NRECL)
	WRITE(IUTTW,REC=1)NRECL,NDIV(1),NDIV(2),NDIV(3),NPNT(1),
     &  NBNDF(1),NBNDE(1),NBNDT(1),NBNDH(1),NSPIN,NORBS,LWHI
C  INITIALLY SET WEIGHTS FOR GIVEN POINT TO ZERO
	DOS=0.D0
	VEL(1)=0.D0
	VEL(2)=0.D0
	VEL(3)=0.D0
	DO ISGQ=1,NSGQ
	DO IPNT=1,NPNT(1)
	DO IBNDS=1,NSPIN
	DO IBNDC=1,NBNDC(1)
	IBANC=IBNDS+NSPIN*(IBNDC-1)
	DO IBNDS1=1,NSPIN
	DO IBNDC1=1,NBNDC(1)
	IBANC1=IBNDS1+NSPIN*(IBNDC1-1)
	WEPI(IBANC,IBANC1,1)=0.D0
	WVEL(IBANC,IBANC1,1,1)=0.D0
	WVEL(IBANC,IBANC1,2,1)=0.D0
	WVEL(IBANC,IBANC1,3,1)=0.D0
	ENDDO
	ENDDO
	ENDDO
	ENDDO
      IREC=1+IPNT+NPNT(1)*(ISGQ-1)
      WRITE(IUTTW,REC=IREC)
     &((WEPI(IBANC,IBANC1  ,1),IBANC =1,NBNDC(1)*NSPIN),
     &                         IBANC1=1,NBNDC(1)*NSPIN),
     &((WVEL(IBANC,IBANC1,1,1),IBANC =1,NBNDC(1)*NSPIN),
     &                         IBANC1=1,NBNDC(1)*NSPIN),
     &((WVEL(IBANC,IBANC1,2,1),IBANC =1,NBNDC(1)*NSPIN),
     &                         IBANC1=1,NBNDC(1)*NSPIN),
     &((WVEL(IBANC,IBANC1,3,1),IBANC =1,NBNDC(1)*NSPIN),
     &                         IBANC1=1,NBNDC(1)*NSPIN)
	ENDDO
	ENDDO
C  SET DIVISIONS ALONG X,Y,Z
	N1=NDIV(1)
	N2=NDIV(2)
	N3=NDIV(3)
C  DO OVER WHOLE BRILLOUIN ZONE REPRESENTED BY MICROCELLS AND 
C  INTEGRATE OVER THE TETRAHEDRA
      OT=1.D0/DBLE(NDIV(1)*NDIV(2)*NDIV(3))/6.D0
      OW=1.D0/DBLE(NDIW(1)*NDIW(2)*NDIW(3))/6.D0
	VOLIBZ=1.D0
      DO 4200 I3=0,NDIV(3)-1              !!! over cells along G3
      DO 4200 I2=0,NDIV(2)-1              !!! over cells along G2
      DO 4200 I1=0,NDIV(1)-1              !!! over cells along G1
C  THE MICROCELL IS SET UP BY I1,I2,I3
C  SET UP TETRAHEDRA INSIDE MICROCELL
      DO 4100 ITTR=1,6                    !!! over tetrahedra
      DO I=1,4
C  COORDINATES OF THE TETRAHEDRON AGE GIVEN BY KTT, SHIFTED - BY KTT1
      J1=I1+KCUT(1,I,ITTR)
      J2=I2+KCUT(2,I,ITTR)
      J3=I3+KCUT(3,I,ITTR)
      KTT(I)=IPQARR(J1,J2,J3)
      KGG(I)=IGS(J1,J2,J3)
      ENDDO
C  TWO TETRAHEDRA FOUND, DEFINE CASE
      DO I=1,4
      KT(I)=0
      ENDDO
      DO I=1,4
      IF(KT(I).EQ.0)THEN
      KT(I)=I
      DO J=I+1,4
      IF(KTT(I).EQ.KTT(J).AND.KGG(I).EQ.KGG(J).AND.KT(J).EQ.0)KT(J)=I
      ENDDO
      ENDIF
      ENDDO
C  READ WEIGHTS FOR THE POINTS
	DO I=4,1,-1 !!! looping backwards to avoid a bug in shit IBM compiler
      IPNT=KTT(I)
      ISGQ=KGG(I)
      IREC=1+IPNT+NPNT(1)*(ISGQ-1)
      READ(IUTTW,REC=IREC)
     &((WEPI(IBANC,IBANC1  ,KT(I)),IBANC =1,NBNDC(1)*NSPIN),
     &                             IBANC1=1,NBNDC(1)*NSPIN),
     &((WVEL(IBANC,IBANC1,1,KT(I)),IBANC =1,NBNDC(1)*NSPIN),
     &                             IBANC1=1,NBNDC(1)*NSPIN),
     &((WVEL(IBANC,IBANC1,2,KT(I)),IBANC =1,NBNDC(1)*NSPIN),
     &                             IBANC1=1,NBNDC(1)*NSPIN),
     &((WVEL(IBANC,IBANC1,3,KT(I)),IBANC =1,NBNDC(1)*NSPIN),
     &                             IBANC1=1,NBNDC(1)*NSPIN)
	ENDDO
C  SET UP POINTS "K" DESCRIBING TETRAHEDRON IN THE SPACE
      DO I=1,4
      J1=I1+KCUT(1,I,ITTR)
      J2=I2+KCUT(2,I,ITTR)
      J3=I3+KCUT(3,I,ITTR)
      PKT(1,I)=(J1*AKBAS(1,1,1)+
     &          J2*AKBAS(1,2,1)+
     &          J3*AKBAS(1,3,1))*2.D0*PI/PAR
      PKT(2,I)=(J1*AKBAS(2,1,1)+
     &          J2*AKBAS(2,2,1)+
     &          J3*AKBAS(2,3,1))*2.D0*PI/PAR
      PKT(3,I)=(J1*AKBAS(3,1,1)+
     &          J2*AKBAS(3,2,1)+
     &          J3*AKBAS(3,3,1))*2.D0*PI/PAR
      ENDDO
C  SHIFT COORDINATE SYSTEM TO THE FIRST POINT
      DO I=2,4
      PKT(1,I)=PKT(1,I)-PKT(1,1)
      PKT(2,I)=PKT(2,I)-PKT(2,1)
      PKT(3,I)=PKT(3,I)-PKT(3,1)
      ENDDO
C  SET RECIPROCALS "REC" TO "PKT"
      CALL CROSS(REC(1,1),PKT(1,3),PKT(1,4))
      CALL CROSS(REC(1,2),PKT(1,4),PKT(1,2))
      CALL CROSS(REC(1,3),PKT(1,2),PKT(1,3))
      W=REC(1,1)*PKT(1,2)+REC(2,1)*PKT(2,2)+REC(3,1)*PKT(3,2)
      IF(ABS(W).LE.1.D-10)
     &CALL FULLSTOP('<DELTET>:: INTERNAL ERROR: W=0')
      DO I=1,3
      REC(I,1)=REC(I,1)/W
      REC(I,2)=REC(I,2)/W
      REC(I,3)=REC(I,3)/W
      ENDDO
C  DO OVER DIVISIONS OF THE MICROCELL
      DO 3200 ID3=0,NDIW(3)/NDIV(3)-1
      DO 3200 ID2=0,NDIW(2)/NDIV(2)-1
      DO 3200 ID1=0,NDIW(1)/NDIV(1)-1
C  THE SMALL MICROCELL IS SET UP BY IW1,IW2,IW3
      IW1=I1*NDIW(1)/NDIV(1)+ID1
      IW2=I2*NDIW(2)/NDIV(2)+ID2
      IW3=I3*NDIW(3)/NDIV(3)+ID3
C  SET UP SMALL TETRAHEDRON INSIDE SMALL MICROCELL
      DO 3100 ITTRD=1,6
      DO I=1,4
      JW1=IW1+KCUT(1,I,ITTRD)
      JW2=IW2+KCUT(2,I,ITTRD)
      JW3=IW3+KCUT(3,I,ITTRD)
      KTW(I)=IPWARR(JW1,JW2,JW3)
      KTQ(I)=IK0IKW(KTW(I),IGWARR(JW1,JW2,JW3))
      ENDDO
C  SET UP POINTS K DESCRIBING SMALL TETRAHEDRON IN THE SPACE
      DO I=1,4
      JW1=IW1+KCUT(1,I,ITTRD)
      JW2=IW2+KCUT(2,I,ITTRD)
      JW3=IW3+KCUT(3,I,ITTRD)
C     PKW(1,I)=(JW1*QW(1,1)+JW2*QW(1,2)+JW3*QW(1,3))*2.D0*PI/PAR
C     PKW(2,I)=(JW1*QW(2,1)+JW2*QW(2,2)+JW3*QW(2,3))*2.D0*PI/PAR
C     PKW(3,I)=(JW1*QW(3,1)+JW2*QW(3,2)+JW3*QW(3,3))*2.D0*PI/PAR
      PKW(1,I)=(JW1*AKBAS(1,1,3)+
     &          JW2*AKBAS(1,2,3)+
     &          JW3*AKBAS(1,3,3))*2.D0*PI/PAR
      PKW(2,I)=(JW1*AKBAS(2,1,3)+
     &          JW2*AKBAS(2,2,3)+
     &          JW3*AKBAS(2,3,3))*2.D0*PI/PAR
      PKW(3,I)=(JW1*AKBAS(3,1,3)+
     &          JW2*AKBAS(3,2,3)+
     &          JW3*AKBAS(3,3,3))*2.D0*PI/PAR
      ENDDO
C  SHIFT COORDINATE SYSTEM TO THE FIRST POINT
      DO I=1,4
      PKW(1,I)=PKW(1,I)-PKT(1,1)
      PKW(2,I)=PKW(2,I)-PKT(2,1)
      PKW(3,I)=PKW(3,I)-PKT(3,1)
      PQT(1,I)=PKW(1,I)+QPNT(1,IQPNT)*2.D0*PI/PAR
      PQT(2,I)=PKW(2,I)+QPNT(2,IQPNT)*2.D0*PI/PAR
      PQT(3,I)=PKW(3,I)+QPNT(3,IQPNT)*2.D0*PI/PAR
      ENDDO
C  CHECK WHETHER A SMALL TETRAHEDRON "PKW" IS INSIDE  TETRAHEDRON "PKT"
      DO I=1,4
      X1=PKW(1,I)*REC(1,1)+PKW(2,I)*REC(2,1)+PKW(3,I)*REC(3,1)
      X2=PKW(1,I)*REC(1,2)+PKW(2,I)*REC(2,2)+PKW(3,I)*REC(3,2)
      X3=PKW(1,I)*REC(1,3)+PKW(2,I)*REC(2,3)+PKW(3,I)*REC(3,3)
      IF(.NOT.((X1.GE.-EPS.AND.X1.LE.1.D0+EPS).AND.
     &         (X2.GE.-EPS.AND.X2.LE.1.D0+EPS).AND.
     &         (X3.GE.-EPS.AND.X3.LE.1.D0+EPS).AND.
     &         (X1+X2+X3.LE.1.D0+EPS)))GOTO 3100
      CRW(1,I)=X1
      CRW(2,I)=X2
      CRW(3,I)=X3
      ENDDO
C  CALCULATE CONTRIBUTIONS FOR THESE POINTS
	DO 2200 IBNDS=1,NSPIN                  !!! over spin subbands
	IBNDC=0
	DO 2100 IBNDT=NBNDE(1),NBNDF(1)        !!! over bands at EF
	IBNDC=IBNDC+1
	IBANC=IBNDS+NSPIN*(IBNDC-1)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	DO I=1,4
	E(I)=ETRW(IBAND,KTW(I),1)              !!! E(k,j)
	ENDDO
	CALL TTR_GETVEL(E,PKW,VK)                  !!! dE(kj)/dk
	CALL TTR_MCTTRINT0(E,EF,OW,AT,AD,TS,DS,'B','W')! d.o.s.
	DOS=DOS+DS
	DO IVEL=1,3                        
	VEL(IVEL)=VEL(IVEL)+DS*VK(IVEL)**2     !!! velocities
	ENDDO
	DO 1200 IBNDS1=1,NSPIN                 !!! over spin subbands
	IBNDC1=0
	DO 1100 IBNDT1=NBNDE(1),NBNDF(1)       !!! over bands at EF
	IBNDC1=IBNDC1+1
	IBANC1=IBNDS1+NSPIN*(IBNDC1-1)
	IBAND1=IBNDS1+NSPIN*(IBNDT1-1)
	DO I=1,4
	H(I)=ETRW(IBAND1,KTQ(I),1)             !!! E(g*k+q,j')
	ENDDO
	CALL TTR_GETVEL(H,PQT,VQ)                  !!! dE(gk+qj')/dk
C  GET WEIGHTS
	CALL CHI_MDHEAD(E,H,EF,OW,QWGT)
	
	if(abs(qwgt(1))+abs(qwgt(2))+abs(qwgt(3))+abs(qwgt(4)).gt.1.d0)then
	write(99,*)i1,i2,i3,ittr,ibanc,ibanc1
	write(99,*)qwgt
	write(99,*)'******************'
	CALL CHI_MDHEAD(E,H,EF,OW,QWGT)
	endif
	
      DO IT=1,4
      DO I=1,4
      IF(IT.EQ.1)WF=1.D0-CRW(1,I)-CRW(2,I)-CRW(3,I)
      IF(IT.NE.1)WF=CRW(IT-1,I)
	WEPI(IBANC,IBANC1,KT(IT))=WEPI(IBANC,IBANC1,KT(IT))+
     &  QWGT(I)*WF
	WVEL(IBANC,IBANC1,1,KT(IT))=WVEL(IBANC,IBANC1,1,KT(IT))+
     &  QWGT(I)*WF*(VK(1)**2+VK(2)**2+VK(3)**2)
	WVEL(IBANC,IBANC1,2,KT(IT))=WVEL(IBANC,IBANC1,2,KT(IT))+
     &  QWGT(I)*WF*(VQ(1)**2+VQ(2)**2+VQ(3)**2)
	WVEL(IBANC,IBANC1,3,KT(IT))=WVEL(IBANC,IBANC1,3,KT(IT))+
     &  QWGT(I)*WF*(VK(1)*VQ(1)+VK(2)*VQ(2)+VK(3)*VQ(3))
	ENDDO
	ENDDO
 1100 CONTINUE                             !!! over bands
 1200 CONTINUE                             !!! over spin subbands
 2100 CONTINUE                             !!! over bands
 2200 CONTINUE                             !!! over spin subbands
C WRITE WEIGHTS BACK TO THE FILE
      DO I=1,4
      IPNT=KTT(I)
      ISGQ=KGG(I)
      IREC=1+IPNT+NPNT(1)*(ISGQ-1)
      WRITE(IUTTW,REC=IREC)
     &((WEPI(IBANC,IBANC1  ,KT(I)),IBANC =1,NBNDC(1)*NSPIN),
     &                             IBANC1=1,NBNDC(1)*NSPIN),
     &((WVEL(IBANC,IBANC1,1,KT(I)),IBANC =1,NBNDC(1)*NSPIN),
     &                             IBANC1=1,NBNDC(1)*NSPIN),
     &((WVEL(IBANC,IBANC1,2,KT(I)),IBANC =1,NBNDC(1)*NSPIN),
     &                             IBANC1=1,NBNDC(1)*NSPIN),
     &((WVEL(IBANC,IBANC1,3,KT(I)),IBANC =1,NBNDC(1)*NSPIN),
     &                             IBANC1=1,NBNDC(1)*NSPIN)
	ENDDO
3100  CONTINUE                             !!! over small tetrahedra
3200  CONTINUE                             !!! over small microcells
4100  CONTINUE                             !!! over tetrahedra
4200  CONTINUE                             !!! over microcells
C  NORMALIZATION
	DO ISGQ=1,NSGQ                         !!! over star of the q-vector
	DO IPNT=1,NPNT(1)                      !!! over irreducible points
	WTOT=0.D0
      IREC=1+IPNT+NPNT(1)*(ISGQ-1)
      READ(IUTTW,REC=IREC)
     &((WEPI(IBANC,IBANC1  ,1),IBANC =1,NBNDC(1)*NSPIN),
     &                         IBANC1=1,NBNDC(1)*NSPIN),
     &((WVEL(IBANC,IBANC1,1,1),IBANC =1,NBNDC(1)*NSPIN),
     &                         IBANC1=1,NBNDC(1)*NSPIN),
     &((WVEL(IBANC,IBANC1,2,1),IBANC =1,NBNDC(1)*NSPIN),
     &                         IBANC1=1,NBNDC(1)*NSPIN),
     &((WVEL(IBANC,IBANC1,3,1),IBANC =1,NBNDC(1)*NSPIN),
     &                         IBANC1=1,NBNDC(1)*NSPIN)
	DO IBNDS=1,NSPIN
	DO IBNDC=1,NBNDC(1)
	IBANC=IBNDS+NSPIN*(IBNDC-1)
	DO IBNDS1=1,NSPIN
	DO IBNDC1=1,NBNDC(1)
	IBANC1=IBNDS1+NSPIN*(IBNDC1-1)
	WEPI(IBANC,IBANC1,1)=WEPI(IBANC,IBANC1,1)/
     &VOLIBZ*2.D0/DBLE(NSPIN)
	WVEL(IBANC,IBANC1,1,1)=WVEL(IBANC,IBANC1,1,1)/
     &  VOLIBZ*2.D0/DBLE(NSPIN)
	WVEL(IBANC,IBANC1,2,1)=WVEL(IBANC,IBANC1,2,1)/
     &  VOLIBZ*2.D0/DBLE(NSPIN)
	WVEL(IBANC,IBANC1,3,1)=WVEL(IBANC,IBANC1,3,1)/
     &  VOLIBZ*2.D0/DBLE(NSPIN)
	WTOT=WTOT+WEPI(IBANC,IBANC1,1)
      DO INUC=1,NATOM
      DO MY=-1,1
      DELH(IBANC,IBANC1,MY,INUC)=(0.D0,0.D0)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
      IREC=1+IPNT+NPNT(1)*(ISGQ-1)
      WRITE(IUTTR,REC=IREC)
     &((WEPI(IBANC,IBANC1  ,1),IBANC =1,NBNDC(1)*NSPIN),
     &                         IBANC1=1,NBNDC(1)*NSPIN),
     &((WVEL(IBANC,IBANC1,1,1),IBANC =1,NBNDC(1)*NSPIN),
     &                         IBANC1=1,NBNDC(1)*NSPIN),
     &((WVEL(IBANC,IBANC1,2,1),IBANC =1,NBNDC(1)*NSPIN),
     &                         IBANC1=1,NBNDC(1)*NSPIN),
     &((WVEL(IBANC,IBANC1,3,1),IBANC =1,NBNDC(1)*NSPIN),
     &                         IBANC1=1,NBNDC(1)*NSPIN),
     &((((DELH(IBANC,IBANC1,MY,INUC),IBANC=1,NBNDC(1)*NSPIN),
     &IBANC1=1,NBNDC(1)*NSPIN),MY=-1,1),INUC=1,NATOM)
      ENDDO                               !!! over irreducible points
      ENDDO                               !!! over star of the q-vector
	CLOSE(IUTTR,STATUS='KEEP')
	CLOSE(IUTTW,STATUS='DELETE')
	DOS=DOS/VOLIBZ*2.D0/DBLE(NSPIN)     !!! total dos
	VEL(1)=VEL(1)/VOLIBZ*2.D0/DBLE(NSPIN)!! velocities
	VEL(2)=VEL(2)/VOLIBZ*2.D0/DBLE(NSPIN)!! velocities
	VEL(3)=VEL(3)/VOLIBZ*2.D0/DBLE(NSPIN)!! velocities
	WRITE(IUN,1010)
	WRITE(IUN,1020)(VEL(I),I=1,3)
	WRITE(IUN,1030)
	WRITE(IUN,1040)(13.6058D0*SQRT(8.D0*PI*VEL(I)/OMEGAC),I=1,3)
 1010	FORMAT(1X,'Calculated average square of electron velocities:')
 1020	FORMAT(1X,'<Vx^2>=',G14.7,' ; <Vy^2>=',G14.7,' ; <Vz^2>=',G14.7)
 1030	FORMAT(1X,'Calculated bare plasma frequencies (in units eV):')
 1040	FORMAT(1X,'om_p^x=',G14.7,' ; om_p^y=',G14.7,' ; om_p^z=',G14.7)
 5000 INQUIRE(FILE=FILE,RECL=NRECL)
CWRONG  IF(WRONG)THEN                !!! wrong compiler option
      NRECL=NVAL
      OPEN(UNIT=IUTTR,FILE=FILE,STATUS='OLD',FORM='UNFORMATTED',
     &  ACCESS='DIRECT',RECL=NRECL)
      READ(IUTTR,REC=1)NRECL
      CLOSE(IUTTR)
CWRONG  ENDIF
	OPEN(UNIT=IUTTR,FILE=FILE,STATUS='OLD',
     &  FORM='UNFORMATTED',ACCESS='DIRECT',RECL=NRECL)
	READ(IUTTR,REC=1)NRECL,N1,N2,N3,NPNT0,
     &	NBNDF0,NBNDE0,NBNDT0,NBNDH0,NSPIN0,NORBS0,LWHI0
	IF(N1.NE.NDIV(1).OR.N2.NE.NDIV(2).OR.N3.NE.NDIV(3))
     &CALL FULLSTOP('<EPITET> # of divisions mismatches in WGTFILE')
	IF(NPNT0.NE.NPNT(1))
     &CALL FULLSTOP('<EPITET> # of points mismatches in WGTFILE')
	IF(NBNDF0.NE.NBNDF(1))
     &CALL FULLSTOP('<EPITET> # of filled bands mismatches in WGTFILE')
	IF(NBNDE0.NE.NBNDE(1))
     &CALL FULLSTOP('<EPITET> # of empty bands mismatches in WGTFILE')
	IF(NBNDT0.NE.NBNDT(1))
     &CALL FULLSTOP('<EPITET> # of total bands mismatches in WGTFILE')
	IF(NBNDH0.NE.NBNDH(1))
     &CALL FULLSTOP('<EPITET> # of H bands mismatches in WGTFILE')
	IF(NSPIN0.NE.NSPIN)
     &CALL FULLSTOP('<EPITET> # of spins mismatches in WGTFILE')
	IF(NORBS0.NE.NORBS)
     &CALL FULLSTOP('<EPITET> SO-coupling mismatches in WGTFILE')
	IF(LWHI0.NE.2)
     &CALL FULLSTOP('<EPITET> Not Im(chi) stored in WGTFILE')
C PRINT SUSCEPTIBILITY SUMMED OVER BANDS
      DO IV=1,4
      CHIM(IV)=0.d0
      ENDDO
      DO ISGQ=1,NSGQ                            !!! over star of the q-vector
      DO IPNT=1,NPNT(1)                         !!! over irreducible points
      IREC=1+IPNT+NPNT(1)*(ISGQ-1)
      READ(IUTTR,REC=IREC)
     &((WEPI(IBANC,IBANC1  ,1),IBANC =1,NBNDC(1)*NSPIN),
     &                         IBANC1=1,NBNDC(1)*NSPIN),
     &((WVEL(IBANC,IBANC1,1,1),IBANC =1,NBNDC(1)*NSPIN),
     &                         IBANC1=1,NBNDC(1)*NSPIN),
     &((WVEL(IBANC,IBANC1,2,1),IBANC =1,NBNDC(1)*NSPIN),
     &                         IBANC1=1,NBNDC(1)*NSPIN),
     &((WVEL(IBANC,IBANC1,3,1),IBANC =1,NBNDC(1)*NSPIN),
     &                         IBANC1=1,NBNDC(1)*NSPIN)
	DO IBNDS=1,NSPIN
	DO IBNDC=1,NBNDC(1)
	IBANC=IBNDS+NSPIN*(IBNDC-1)
	DO IBNDS1=1,NSPIN
	DO IBNDC1=1,NBNDC(1)
	IBANC1=IBNDS1+NSPIN*(IBNDC1-1)
      CHIM(1)=CHIM(1)+WEPI(IBANC,IBANC1,1)
      CHIM(2)=CHIM(2)+WVEL(IBANC,IBANC1,1,1)
      CHIM(3)=CHIM(3)+WVEL(IBANC,IBANC1,2,1)
      CHIM(4)=CHIM(4)+WVEL(IBANC,IBANC1,3,1)
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      ENDDO                                     !!! over irreducible points
      ENDDO                                     !!! over star of the q-vector
      WRITE(IUN,1110)
      WRITE(IUN,1120)CHIM(1)
      WRITE(IUN,1130)CHIM(2)
      WRITE(IUN,1140)CHIM(3)
      WRITE(IUN,1150)CHIM(4)
1110  FORMAT(1X,'Imaginary susceptibility Im[chi(q)] --->')
1120  FORMAT(1X,'Im[chi(q,omega)]/omega=',G14.7)
1130  FORMAT(1X,'Im[vel(x,omega)]/omega=',G14.7)
1140  FORMAT(1X,'Im[vel(y,omega)]/omega=',G14.7)
1150  FORMAT(1X,'Im[vel(z,omega)]/omega=',G14.7)
C Memory deallocations
	DEALLOCATE(WVEL,WEPI,DELH)
      END
