	SUBROUTINE PHN_READLRT
**************************************************************
*  Reads LRTFILE which controls linear response calculation. *
**************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                           !!! from setup
      USE COM_CONTROL, ONLY : LIFT,NPFR,LRWF,MODE              !!! from readini
      USE COM_PARAM,   ONLY : NATOM,NSORT,NSPIN,NORBS,IS,ILSB  !!! from readini
      USE COM_PHNCOM,  ONLY : ITERMAX,NITER,EPS,DELZ,DELD
     &                       ,CONVDRO,CONVDMO                  !!! from readlrt
      USE COM_LRTCOM,  ONLY : LDLF,LWHI,LWAV                   !!! from readlrt
      USE COM_PANPAR,  ONLY : LTPAN,LSPAN                      !!! from readini
      USE COM_KAPPAR,  ONLY : NPAN,NKAP,EK,EKAP                !!! from readini
      USE COM_SCFLOOP, ONLY : NITER1,EPSTOT,EPSRHO,EPSMAG      !!! from readini
	USE COM_QMESH,   ONLY : NQPNT,QPNT                       !!! from readpnt
      USE COM_PLZCOM,  ONLY : NPLZ,LPLZ,IPLZ                   !!! from readlrt
	USE COM_MIXRHO1 ,ONLY : KEY0=>KEY,KSP0=>KSP
     &               ,ADMIX10=>ADMIX1,ADMIN0=>ADMIN,ADMAX0=>ADMAX
     &               ,ADMSPN0=>ADMSPN,ASMIN0=>ASMIN,ASMAX0=>ASMAX
	USE COM_MIXBROY ,ONLY : LBROY0=>LBROY,IBROY0=>IBROY
     &               ,ADMIXB0=>ADMIXB,ADMIXH0=>ADMIXH
      USE COM_MIXDRHO, ONLY : ADMIX1,ADMIN,ADMAX,ADMOPT,KEY    !!! from readlrt
      USE COM_MIXDMAG, ONLY : ADMSPN,ASMIN,ASMAX,ADSPIN,KSP    !!! from readlrt
      USE COM_MIXDBRD, ONLY : LBROY,IBROY,ADMIXB,ADMIXH
     &                       ,MTER,WTER,WMIX                   !!! from readlrt
      USE COM_LABELS,  ONLY : TXTEL,TXTAT                      !!! from readini
	USE COM_MASHDEP, ONLY : NVAL                             !!! from setup
      USE COM_EPIMAT,  ONLY : EPIMAT,VELMAT                    !!! from readlrt
	USE COM_DYNMAT,  ONLY : OM,DYNMAT,BNDMAT,DPOL            !!! from readlrt
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                  !!! from setup
	USE COM_CHANNELS,ONLY : IUINP                            !!! from channels
	USE COM_EXTENS  ,ONLY : LENEXTN                          !!! from setup
	USE COM_PHNEXT  ,ONLY : EXTNLRT                          !!! from setup
	USE COM_LMTINP
	USE COM_LMTOUT
	USE COM_PHNOUT
      IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER STRARR(80)*1,STRING*150,HELP*40
     &  ,SCHM*10,TPLZ*10,TSTN*10,TDLF*10,TDYN*10
     &  ,TWAV*10,INF*130,CHAR*1
	COMPLEX*16 CM
      CHARACTER*150, ALLOCATABLE :: LRTDATA(:)
      CHARACTER*150, ALLOCATABLE :: LRTCOPY(:)
      LOGICAL EXIST,MODIFIED,PRESENT,DEF,ASK,VAL,NTH,MDF
      DATA PI/3.141592653589793D0/
C CHECK INPINFO
      INF=INPINFO
      CALL SUBSTR_IN_STR(PRESENT,INF,130,EXTNLRT,LENEXTN)
      IF(.NOT.PRESENT)CALL FULLSTOP('<READLRT> :: Wrong INPINFO.')
C SET FILE NAME
      CALL FIND_LBLANK(PROJECT,130,NBP)
      CALL FIND_LBLANK(EXTNLRT,60,NBE)
      LRTFILE=PROJECT(:NBP)//'.'//EXTNLRT(:NBE)
      INQUIRE(FILE=LRTFILE,EXIST=EXIST)
      IF(.NOT.EXIST)CALL FULLSTOP('LrtFile does not exist!')
C ********************************
C UNDERSTAND THE LENGHT OF STRFILE
      CALL FILE_LENGHT(LRTFILE,NLEN,IUINP)
      ALLOCATE(LRTDATA(NLEN))
C ********************************
C READ STRFILE TO INTERNAL FILE
      OPEN(UNIT=IUINP,FILE=LRTFILE,STATUS='OLD',FORM='FORMATTED')
      DO ILEN=1,NLEN
      READ(IUINP,FMT='(A150)')LRTDATA(ILEN)
      ENDDO
      CLOSE(IUINP)
C ********************************
C UNDERSTAND INPUT: CLASSIC or MODERN
      STRING=LRTDATA(1)
      CALL LIB_CONVLOW(STRING,150)
      MODERN=0
      DO IPOS=1,80
      IF(STRING(IPOS:IPOS+11).EQ.'input=modern')MODERN=2
      IF(MODERN.NE.0)EXIT
      ENDDO
	IF(MODERN.NE.2)CALL FULLSTOP('LrtFile not recognozed!')
      IF(MODERN.EQ.2)MODIFIED=.TRUE.
C **************************************
C READING THE DATA: SELECT CONTROLS
C **************************************
C MODERN INPUT IS USED, DEFAULTS ARE AVAIABLE
      CALL READ_SECT(LRTDATA(1),NLEN,ISEC,NSEC,MSEC,
     &  '<section=ctrl',13,'<section=',9,'ok',2)
C Set section title
      DO IPOS=1,150
      IF(LRTDATA(ISEC)(IPOS:IPOS).EQ.'>')EXIT
      ENDDO
      DO JPOS=IPOS+1,150
      IF(MSEC.NE.0)LRTDATA(ISEC)(JPOS:JPOS)=' '
      ENDDO
      IF(IPOS.LE.50)THEN
      HELP='! CONTROL PARAMETERS:                  '
      IF(MSEC.NE.0)LRTDATA(ISEC)(IPOS+1:IPOS+40)=HELP
      ENDIF
C Allocate temporary file
      ALLOCATE(LRTCOPY(NSEC))
      DO ILIN=1,MSEC
      LRTCOPY(ILIN)=LRTDATA(ILIN+ISEC-1)
      ENDDO
C  Switch for scheme:
	SCHM='phonons'
      HELP='! Scheme phonons/magnons               '
      LHLP=40
      CALL READ_CHAR(LRTDATA(ISEC),LRTCOPY(1),NSEC,MSEC,
     &'scheme',6,IN,1,0,RE,1,0,CM,1,0,SCHM,10,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
      CALL LIB_CONVLOW(SCHM,10)
      CALL LIB_RMBLANK(SCHM,10)
	LRTM=0
      IF(SCHM(1:7).EQ.'phonons')LRTM=1
      IF(SCHM(1:7).EQ.'magnons')LRTM=2
	IF(LRTM.EQ.0)
     &CALL FULLSTOP('<READLRT>: Scheme keyword not recognized!')
C  Switch for polarizability:
	LPLZ=1
      HELP='! Polarizability switch (0,1,...)      '
      LHLP=40
      CALL READ_CHAR(LRTDATA(ISEC),LRTCOPY(1),NSEC,MSEC,
     &'plzmax',6,LPLZ,1,1,RE,1,0,CM,1,0,CHAR,1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C  Max # of vectors
	NENV=30
      HELP='! max.# of reciprocal lattice vectors  '
      LHLP=40
      CALL READ_CHAR(LRTDATA(ISEC),LRTCOPY(1),NSEC,MSEC,
     &'vecmax',6,NENV,1,1,RE,1,0,CM,1,0,CHAR,1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
	NENVMEM=NENV
C  Switch for Stoner matrix:
	TSTN='on'
      HELP='! Stoner matrix  on/off                '
      LHLP=40
      CALL READ_CHAR(LRTDATA(ISEC),LRTCOPY(1),NSEC,MSEC,
     &'stoner',6,IN,1,0,RE,1,0,CM,1,0,TSTN,10,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
      CALL LIB_CONVLOW(TSTN,10)
      CALL LIB_RMBLANK(TSTN,10)
	LSTN=-1
	IF(TSTN(1:3).EQ.'off' )LSTN=0
	IF(TSTN(1:2).EQ.'on'  )LSTN=1
	IF(TSTN(1:4).EQ.'auto')LSTN=0
	IF(LSTN.EQ.-1)
     &CALL FULLSTOP('<READLRT>: Stoner keyword not recognized!')
C  Switch for including changes in radial functions:
	TDLF='on'
      HELP='! Change in radial functions on/off    '
      LHLP=40
      CALL READ_CHAR(LRTDATA(ISEC),LRTCOPY(1),NSEC,MSEC,
     &'delrad',6,IN,1,0,RE,1,0,CM,1,0,TDLF,10,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
      CALL LIB_CONVLOW(TDLF,10)
      CALL LIB_RMBLANK(TDLF,10)
	LDLF=-1
	IF(TDLF(1:3).EQ.'off' )LDLF=1
	IF(TDLF(1:2).EQ.'on'  )LDLF=2
	IF(TDLF(1:4).EQ.'auto')LDLF=2
	IF(LDLF.EQ.-1)
     &CALL FULLSTOP('<READLRT>: DelRad keyword not recognized!')
C  Switch for dynamical matrix formulae:
	TDYN='auto'
      HELP='! Dyn.Matrix auto/none/hf/oka*/oka1    '
      LHLP=40
      CALL READ_CHAR(LRTDATA(ISEC),LRTCOPY(1),NSEC,MSEC,
     &'dynmat',6,IN,1,0,RE,1,0,CM,1,0,TDYN,10,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
      CALL LIB_CONVLOW(TDYN,10)
      CALL LIB_RMBLANK(TDYN,10)
	NPFR=-1
	IF(TDYN(1:4).EQ.'auto')NPFR=0
	IF(TDYN(1:4).EQ.'none')NPFR=0
	IF(TDYN(1:2).EQ.'hf'  )NPFR=0
	IF(TDYN(1:4).EQ.'oka*')NPFR=1
	IF(TDYN(1:4).EQ.'oka1')NPFR=2
	IF(NPFR.EQ.-1)
     &CALL FULLSTOP('<READLRT>: DynMat keyword not recognized!')
C  Switch for spd-wave symmetry of epi lambda
	TWAV='auto'
      HELP='! spd-wave symmetry key                '
      LHLP=40
      CALL READ_CHAR(LRTDATA(ISEC),LRTCOPY(1),NSEC,MSEC,
     &'l-wave',6,IN,1,0,RE,1,0,CM,1,0,TWAV,10,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
      CALL LIB_CONVLOW(TWAV,10)
      CALL LIB_RMBLANK(TWAV,10)
	LWAV=-1
	IF(TWAV(1:4).EQ.'auto')    LWAV=1
	IF(TWAV(1:4).EQ.'none')    LWAV=1
	IF(TWAV(1:4).EQ.'s{e}')    LWAV=0
	IF(TWAV(1:4).EQ.'s{0}')    LWAV=1
	IF(TWAV(1:4).EQ.'p{x}')    LWAV=2
	IF(TWAV(1:4).EQ.'p{y}')    LWAV=3
	IF(TWAV(1:4).EQ.'p{z}')    LWAV=4
	IF(TWAV(1:5).EQ.'d{yz}')   LWAV=5
	IF(TWAV(1:5).EQ.'d{zx}')   LWAV=6
	IF(TWAV(1:5).EQ.'d{xy}')   LWAV=7
	IF(TWAV(1:8).EQ.'d{x2-y2}')LWAV=8
	IF(TWAV(1:8).EQ.'d{3z2-1}')LWAV=9
	IF(LWAV.EQ.-1)
     &CALL FULLSTOP('<READLRT>: L-Wave keyword not recognized!')
C **************************************
      CALL READ_ERRR(LRTDATA(ISEC),LRTCOPY(1),NSEC,MSEC,'CTRL')
      DEALLOCATE(LRTCOPY)
C **************************************
C READING THE DATA: SELECT FILES
C **************************************
C MODERN INPUT IS USED, DEFAULTS ARE AVAIABLE
      CALL READ_SECT(LRTDATA(1),NLEN,ISEC,NSEC,MSEC,
     &  '<section=file',13,'<section=',9,'ok',2)
C Set section title
      DO IPOS=1,150
      IF(LRTDATA(ISEC)(IPOS:IPOS).EQ.'>')EXIT
      ENDDO
      DO JPOS=IPOS+1,150
      IF(MSEC.NE.0)LRTDATA(ISEC)(JPOS:JPOS)=' '
      ENDDO
      IF(IPOS.LE.50)THEN
      HELP='! FILE STORAGE:                        '
      IF(MSEC.NE.0)LRTDATA(ISEC)(IPOS+1:IPOS+40)=HELP
      ENDIF
C Allocate temporary file
      ALLOCATE(LRTCOPY(NSEC))
      DO ILIN=1,MSEC
      LRTCOPY(ILIN)=LRTDATA(ILIN+ISEC-1)
      ENDDO
C Output
	OUTFILE='out'
      HELP='! Output file (set STDOUT for terminal)'
      LHLP=40
      CALL READ_CHAR(LRTDATA(ISEC),LRTCOPY(1),NSEC,MSEC,
     &'outfile',7,IN,1,0,RE,1,0,CM,1,0,OUTFILE,130,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Phonon spectrum
	PHNFILE='phn'
      HELP='! Phonon spectrum                      '
      LHLP=40
      CALL READ_CHAR(LRTDATA(ISEC),LRTCOPY(1),NSEC,MSEC,
     &'phnfile',7,IN,1,0,RE,1,0,CM,1,0,PHNFILE,130,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Electron-Phonon interaction Matrix
	EPIFILE='epi'
      HELP='! Electron-Phnon Interaction Matrix    '
      LHLP=40
      CALL READ_CHAR(LRTDATA(ISEC),LRTCOPY(1),NSEC,MSEC,
     &'epifile',7,IN,1,0,RE,1,0,CM,1,0,EPIFILE,130,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Intergration weights
	WGTFILE(1)='wgt'
      HELP='! Integration weights                  '
      LHLP=40
      CALL READ_CHAR(LRTDATA(ISEC),LRTCOPY(1),NSEC,MSEC,
     &'wgtfile',7,IN,1,0,RE,1,0,CM,1,0,WGTFILE(1),130,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Polarizability within MTS
	ALLOCATE(PLZFILE(NENVMEM))
	PLZFILE(1)='plz'
      HELP='! Polarizability within MTS            '
      LHLP=40
      CALL READ_CHAR(LRTDATA(ISEC),LRTCOPY(1),NSEC,MSEC,
     &'plzfile',7,IN,1,0,RE,1,0,CM,1,0,PLZFILE(1),130,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Polarizability within INT
	ALLOCATE(PLSFILE(NENVMEM))
	PLSFILE(1)='pls'
      HELP='! Polarizability within INT          '
      LHLP=40
      CALL READ_CHAR(LRTDATA(ISEC),LRTCOPY(1),NSEC,MSEC,
     &'plsfile',7,IN,1,0,RE,1,0,CM,1,0,PLSFILE(1),130,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Induced potential within MTS
	ALLOCATE(DSVFILE(-1:1,NATOMMEM))
	DSVFILE(-1,1)='dsv'
      HELP='! Induced potential within MTS       '
      LHLP=40
      CALL READ_CHAR(LRTDATA(ISEC),LRTCOPY(1),NSEC,MSEC,
     &'dsvfile',7,IN,1,0,RE,1,0,CM,1,0,DSVFILE(-1,1),130,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Induced potential within INT
	ALLOCATE(DPVFILE(-1:1,NATOMMEM))
	DPVFILE(-1,1)='dpv'
      HELP='! Induced potential within INT       '
      LHLP=40
      CALL READ_CHAR(LRTDATA(ISEC),LRTCOPY(1),NSEC,MSEC,
     &'dpvfile',7,IN,1,0,RE,1,0,CM,1,0,DPVFILE(-1,1),130,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Induced desity within MTS
	ALLOCATE(DROFILE(-1:1,NATOMMEM))
	DROFILE(-1,1)='dro'
      HELP='! Induced density   within MTS       '
      LHLP=40
      CALL READ_CHAR(LRTDATA(ISEC),LRTCOPY(1),NSEC,MSEC,
     &'drofile',7,IN,1,0,RE,1,0,CM,1,0,DROFILE(-1,1),130,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Induced desity within INT
	ALLOCATE(DPSFILE(-1:1,NATOMMEM))
	DPSFILE(-1,1)='dps'
      HELP='! Induced density   within INT       '
      LHLP=40
      CALL READ_CHAR(LRTDATA(ISEC),LRTCOPY(1),NSEC,MSEC,
     &'dpsfile',7,IN,1,0,RE,1,0,CM,1,0,DPSFILE(-1,1),130,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C **************************************
      CALL READ_ERRR(LRTDATA(ISEC),LRTCOPY(1),NSEC,MSEC,'CTRL')
      DEALLOCATE(LRTCOPY)
C **************************************
C ALL DATA READ NOW, UPDATE LRTFILE
	IF(MODIFIED) 
     &CALL READ_OVWR(LRTFILE,LRTDATA,NLEN)
C   SET MODE FOR THE DYNAMICAL MATRIX
      IF(MODE.NE.4)NPFR=0
	IF(MODE.EQ.4.AND.NPFR.EQ.0.AND.TDYN(1:4).NE.'auto')
     &WRITE(IUT,*)'<READLRT>:: FOR MODE=4, DYN.MAT IS SET TO OKA*' 
	IF(MODE.EQ.4.AND.NPFR.EQ.0)NPFR=2
C   SWITCH OFF POLARIZABILITY IF DYNAMICAL MATRIX IS REQUIRED
      IF(MODE.EQ.4)LPLZ=0
      IF(MODE.EQ.5)LPLZ=0
C   SET LIFT TO "BANDS" IF MODE IS "PREPARATIONAL"
      IF(MODE.EQ.0)LIFT=2
C   SET RMTA-CASE FOR EPI-CALCULATION
      IF(MODE.NE.51)IRMTA=0
      IF(MODE.EQ.51)IRMTA=1
      IF(MODE.EQ.51)MODE=5
C   NEW SELF-CONSISTENCY SCHEME IS ALWAYS ON!
      NPLZ=1
C   SET LIFT TO "PHONONS" IF SCF IS ON
	IF(MODE.NE.0)LIFT=4
C   CHECK RADIAL WAVE FUCNTIONS
      IF(LRWF.EQ.0)
     &CALL FULLSTOP('<LRTFILE> LRWF KEY CANNOT BE ZERO!')
C   SET SWITCH FOR TETRAHEDRON WEIGHTS
      IF(MODE.LE.4)LWHI=1
      IF(MODE.EQ.5)LWHI=2
C   CHECK LMAXB
      DO IATOM=1,NATOM
      ISORT=IS(IATOM)
      DO IKAP=1,NKAP(1)
      MAXLB=-1
      DO L=0,ILSB(ISORT)
      IF(LTPAN(L,IATOM,IKAP,1))MAXLB=MAX(MAXLB,L)
      ENDDO
      IF(MAXLB.GT.ILSB(ISORT)-1)THEN
      IF(DREAL(EKAP(IKAP,1)).LE.0.D0)
     &CALL FULLSTOP('<READLRT>:: SET ILSB TO ILSB+1 IN <INIFILE>')
      ENDIF
      ENDDO
      ENDDO
C  SET MIXING ARRAYS
	IF(MODE.NE.0)ITERMAX=NITER1
      IF(MODE.EQ.0)ITERMAX=0
      IF(MODE.EQ.4)ITERMAX=1
      IF(MODE.EQ.5)ITERMAX=1
	ALLOCATE(NITER(-1:1,NATOMMEM))
	ALLOCATE(EPS(-1:1,NATOMMEM))
	ALLOCATE(KEY(-1:1,NATOMMEM))
	ALLOCATE(KSP(-1:1,NATOMMEM))
	ALLOCATE(DELZ(0:3,-1:1,NATOMMEM))
	ALLOCATE(DELD(0:3,-1:1,NATOMMEM))
	ALLOCATE(CONVDRO(0:3,-1:1,NATOMMEM))
	ALLOCATE(LBROY (-1:1,NATOMMEM))
	ALLOCATE(IBROY (-1:1,NATOMMEM))
	ALLOCATE(ADMIX1(-1:1,NATOMMEM))
	ALLOCATE(ADMOPT(-1:1,NATOMMEM))
	ALLOCATE(ADMIN (-1:1,NATOMMEM))
	ALLOCATE(ADMAX (-1:1,NATOMMEM))
	ALLOCATE(ADMSPN(-1:1,NATOMMEM))
	ALLOCATE(ADSPIN(-1:1,NATOMMEM))
	ALLOCATE(ASMIN (-1:1,NATOMMEM))
	ALLOCATE(ASMAX (-1:1,NATOMMEM))
	ALLOCATE(ADMIXB(-1:1,NATOMMEM))
	ALLOCATE(ADMIXH(-1:1,NATOMMEM))
	ALLOCATE(MTER(-1:1,NATOMMEM))
	ALLOCATE(WTER(0:NTERMEM,-1:1,NATOMMEM))
	ALLOCATE(WMIX(NTERMEM,NTERMEM,-1:1,NATOMMEM))
	DO INUC=1,NATOM
      DO MY=-1,1
      NITER(MY,INUC)=ITERMAX
      EPS  (MY,INUC)=EPSRHO
      KEY  (MY,INUC)=KEY0
      KSP  (MY,INUC)=KSP0
      LBROY(MY,INUC)=LBROY0
      IBROY(MY,INUC)=IBROY0
      ADMIX1(MY,INUC)=ADMIX10
      ADMOPT(MY,INUC)=ADMIX10
      ADMIN (MY,INUC)=ADMIX10
      ADMAX (MY,INUC)=ADMIX10
      ADMSPN(MY,INUC)=ADMSPN0
      ADSPIN(MY,INUC)=ADMSPN0
      ASMIN (MY,INUC)=ADMSPN0
      ASMAX (MY,INUC)=ADMSPN0
      ADMIXB(MY,INUC)=ADMIXB0
      ADMIXH(MY,INUC)=ADMIXH0
      ENDDO
      ENDDO
C Allocate dynamical matrix and electron-phonon interaction arrays
	ALLOCATE(OM(3*NATOMMEM))
	ALLOCATE(DPOL(3,NATOMMEM,3*NATOMMEM))
	ALLOCATE(DYNMAT(3,NATOMMEM,3,NATOMMEM,4))
	ALLOCATE(EPIMAT(-1:1,NATOMMEM,-1:1,NATOMMEM,4))
	ALLOCATE(VELMAT(-1:1,NATOMMEM,-1:1,NATOMMEM,4))
	ALLOCATE(BNDMAT(-1:1,NATOMMEM,-1:1,NATOMMEM,10,NPANMEM))
	END
