	SUBROUTINE PHN_RUNTASK
************************************************************
*  Selects displacements and polarizations to run.         *
************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                       !!! from setup
	USE COM_PARAM,   ONLY : NATOM                        !!! from readini
	USE COM_PHNCOM,  ONLY : NITER                        !!! from ctrlinf
	USE COM_LRTCOM,  ONLY : RUNTASK,MOVTASK              !!! from ctrlinf
	IMPLICIT REAL*8 (A-H,O-Z)
	LOGICAL, ALLOCATABLE :: LNUC(:,:)
C Memory allocations
	ALLOCATE(LNUC(-1:1,NATOMMEM))
C CONVERT TO LOW-CASE LETTERS
	CALL LIB_CONVLOW(RUNTASK,60)
	MOVTASK='          '
C SEARCH FOR CONTROL SYMBOLS <>
	IF(RUNTASK(1:1).EQ.'<')THEN          !!! if '<'
	RUNTASK(1:1)=' '
	ITSK=0
	DO IL=2,60                           !!! over il
	IF(RUNTASK(IL:IL).EQ.'>')THEN
	RUNTASK(IL:IL)=' '
	EXIT
	ENDIF
	ITSK=ITSK+1
	IF(ITSK.GT.10)
     &CALL FULLSTOP('<RunTask>:: too many characters!')
	MOVTASK(ITSK:ITSK)=RUNTASK(IL:IL)
	RUNTASK(IL:IL)=' '
	ENDDO                                !!! over il
	ELSEIF(RUNTASK(1:3).EQ.'all')THEN    !!! if 'all'
	RUNTASK(1:3)='   '
	ENDIF                                !!! endif
C COMPUTE HOW MANY ATOMIC DISPLACEMENTS TO RUN
	NDSP=0
	NMZP=0
	DO IL=1,60
	IF(RUNTASK(IL:IL).EQ.'a')NDSP=NDSP+1
	IF(RUNTASK(IL:IL).EQ.'m'.OR.
     &   RUNTASK(IL:IL).EQ.'p'.OR.
     &   RUNTASK(IL:IL).EQ.'z')NMZP=NMZP+1
	ENDDO
	IF(NMZP.NE.NDSP)
     &CALL FULLSTOP('<RunTask>:: wrong control string!')
C SET LOGICAL ARRAY
	DO INUC=1,NATOM
	DO MY=-1,1
	IF(NDSP.EQ.0)LNUC(MY,INUC)=.TRUE.
	IF(NDSP.NE.0)LNUC(MY,INUC)=.FALSE.
	ENDDO
	ENDDO
C SPECIFY TASK-CHARACTER IF EMPTY
	IF(MOVTASK(1:1).EQ.' ')THEN             !!! if ' '
	IF(NDSP.GT.1)
     &CALL FULLSTOP('<RunTask>:: task not specified!')
	DO IL1=1,60                          !!! over il1
	IF(RUNTASK(IL1:IL1).EQ.'a')THEN         
	ITSK=0
	DO IL=IL1+1,60                       !!! over il
	IF(RUNTASK(IL:IL).EQ.'m'.OR.
     &   RUNTASK(IL:IL).EQ.'p'.OR.
     &   RUNTASK(IL:IL).EQ.'z')THEN
	DO IT=IL1,IL
	MOVTASK(IT-IL1+1:IT-IL1+1)=RUNTASK(IT:IT)
	ENDDO
	EXIT
	ENDIF
	ENDDO                                !!! over il
	EXIT
	ENDIF
	ENDDO                                !!! over il1
	ENDIF                                !!! endif ' '
C SELECT DISPLACEMENTS AND POLARIZATIONS TO RUN
	DO IL1=1,60
	IF(RUNTASK(IL1:IL1).EQ.'a')THEN
	RUNTASK(IL1:IL1)=' '
	DO IL=IL1+1,60
	IF(RUNTASK(IL:IL).EQ.'m'.OR.
     &   RUNTASK(IL:IL).EQ.'p'.OR.
     &   RUNTASK(IL:IL).EQ.'z')THEN
	IF(RUNTASK(IL:IL).EQ.'m')MY=-1
	IF(RUNTASK(IL:IL).EQ.'p')MY=+1
	IF(RUNTASK(IL:IL).EQ.'z')MY= 0
	RUNTASK(IL:IL)=' '
	READ(RUNTASK(IL1+1:IL-1),*)INUC
	IF(INUC.LT.1.OR.INUC.GT.NATOM)
     &CALL FULLSTOP('<RunTask>:: wrong control string!')
	LNUC(MY,INUC)=.TRUE.
	DO IT=IL1+1,IL-1
	RUNTASK(IT:IT)=' '
	ENDDO
	EXIT
	ENDIF
	ENDDO
	ENDIF
	ENDDO
C SET NUMBER OF ITERATIONS TO ZERO 
	DO INUC=1,NATOM
	DO MY=-1,1
	IF(.NOT.LNUC(MY,INUC))NITER(MY,INUC)=0
	ENDDO
	ENDDO
	DEALLOCATE(LNUC)
      END
