	SUBROUTINE PHN_SETEPI(IQPNT)
**********************************************************
*  Stores electron--phonon matrix to the EPIFILE.        *
**********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_NBANDS,  ONLY : NBNDF,NBNDE,NBNDT                          !!! from readini
	USE COM_KMESH,   ONLY : NPNT                                       !!! from makettr
      USE COM_LABELS,  ONLY : TXTEL,TXTAT                                !!! from readini
	USE COM_ENERGY,  ONLY : EARR,WTOS,WDOS                             !!! from lmtbnd
	USE COM_FERMI,   ONLY : EF                                         !!! from ttrint
	USE COM_SPHERE,  ONLY : AMAS                                       !!! from readini
      USE COM_EPIMAT,  ONLY : EPIMAT,VELMAT                              !!! from nultos
	USE COM_QMESH,   ONLY : NQPNT,QPNT                                 !!! from readpnt
	USE COM_PHNOUT  ,ONLY : ICEPI,EPIFILE                              !!! from readini
      USE COM_CHANNELS,ONLY : IUAIN                                      !!! from channels
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: EPMAT(:,:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: TRMAT(:,:,:,:,:)
	COMPLEX*16 TR(-1:1,3)
	CHARACTER LIB_TCP*23,TCHAR(3)*23
	DIMENSION VEL(3),SPVEL(3,2),SPDOS(2),SPTOS(2),AVL(2),VELM(3,3)
     &   ,SPVELM(3,3,2)
      LOGICAL OPEN,EXIST
	DATA TR/  (+0.70710678118655D0, 0.00000000000000D0)
     &         ,( 0.00000000000000D0, 0.00000000000000D0)
     &         ,(-0.70710678118655D0, 0.00000000000000D0)
     &         ,( 0.00000000000000D0,+0.70710678118655D0)
     &         ,( 0.00000000000000D0, 0.00000000000000D0)
     &         ,( 0.00000000000000D0,+0.70710678118655D0)
     &         ,( 0.00000000000000D0, 0.00000000000000D0)
     &         ,( 1.00000000000000D0, 0.00000000000000D0)
     &         ,( 0.00000000000000D0, 0.00000000000000D0)/
	IF(MODE.NE.5)RETURN
	IF(ICEPI.EQ.0)RETURN
C STORE HEADER INFO.
	INQUIRE(FILE=EPIFILE,EXIST=EXIST)
	IF(EXIST)THEN
      OPEN(UNIT=IUAIN,FILE=EPIFILE,STATUS='OLD',FORM='FORMATTED')
	CLOSE(UNIT=IUAIN,STATUS='DELETE')
	ENDIF
	OPEN(IUAIN,FILE=EPIFILE,STATUS='NEW',FORM='FORMATTED')
	WRITE(IUAIN,10010)
	WRITE(IUAIN,10020)
10010	FORMAT(1X,'<FILE=EPIFILE,INPUT=MODERN>')
10020 FORMAT('****************************************************')
	WRITE(IUAIN,10030)
10030 FORMAT(1X,'<SECTION=QPNT>',30X,'! Q-POINT:')
      WRITE(IUAIN,10040)(QPNT(I,IQPNT),I=1,3)
10040 FORMAT(1X,G14.7,' , ',G14.7,' , ',G14.7)
	ALLOCATE(EPMAT(3,NATOMMEM,3,NATOMMEM,4))
	ALLOCATE(TRMAT(3,NATOMMEM,3,NATOMMEM,4))
C  FIND DENSITY OF STATES AT THE FERMI LEVEL
      CALL TTR_TTRVEL(EF,DOS,VEL,SPTOS,SPDOS,SPVEL,VELM,SPVELM,1)
	DO IBNDS=1,NSPIN
	DOT=0.D0
	DO IBNDT=1,NBNDT(1)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	DO IPNT=1,NPNT(1)
	DOT=DOT+WDOS(IBAND,IPNT)
	ENDDO
	ENDDO
	IF(ABS(SPDOS(IBNDS)-DOT).GE.1.D-08)
     &WRITE(IUT,*)'ERROR IN <EPIMAT> :',SPDOS(IBNDS),DOT 
	IF(SPDOS(IBNDS).LE.1.D-07)SPDOS(IBNDS)=1.D0
	ENDDO
C  SET VELOCITIES
      AVT=0.D0
	DO IBNDS=1,NSPIN
	AVL(IBNDS)=SPVEL(1,IBNDS)+SPVEL(2,IBNDS)+SPVEL(3,IBNDS)
	IF(AVL(IBNDS).LE.1.D-07)
     &WRITE(IUT,*)'ERROR IN <EPIMAT> : AVL(IBNDS).EQ.0'
	IF(AVL(IBNDS).LE.1.D-07)AVL(IBNDS)=1.D0
	AVT=AVT+AVL(IBNDS)
	ENDDO
C  MAKE TOTAL HOPFIELD MATRIX IN CARTESIAN SYSTEM
	WRITE(IUAIN,10110)
10110 FORMAT(1X,'<SECTION=EPIM>',30X,'! EPI.MATRIX (Ry/a.u^2):')
	DO 2000 INUC1=1,NATOM               !!! over nuclear shifts
	DO 1000 INUC=1,NATOM                !!! over nuclear shifts
      WRITE(IUAIN,10120)INUC1,TXTAT(IS(INUC1)),INUC,TXTAT(IS(INUC))
	DO I=1,3                           !!! over x,y,z
	DO J=1,3                           !!! over x,y,z
	EPMAT(I,INUC1,J,INUC,1)=(0.0,0.0)
	EPMAT(I,INUC1,J,INUC,2)=(0.0,0.0)
	EPMAT(I,INUC1,J,INUC,3)=(0.0,0.0)
	EPMAT(I,INUC1,J,INUC,4)=(0.0,0.0)
	TRMAT(I,INUC1,J,INUC,1)=(0.0,0.0)
	TRMAT(I,INUC1,J,INUC,2)=(0.0,0.0)
	TRMAT(I,INUC1,J,INUC,3)=(0.0,0.0)
	TRMAT(I,INUC1,J,INUC,4)=(0.0,0.0)
	DO MY1=-1,1                        !!! over -1,0,1
	DO MY=-1,1                         !!! over -1,0,1
	EPMAT(I,INUC1,J,INUC,1)=EPMAT(I,INUC1,J,INUC,1)+
     &EPIMAT(MY1,INUC1,MY,INUC,1)*
     &  TR(MY1,I)*TR(MY,J)/DOS
	EPMAT(I,INUC1,J,INUC,2)=EPMAT(I,INUC1,J,INUC,2)+
     &EPIMAT(MY1,INUC1,MY,INUC,2)*
     &  TR(MY1,I)*TR(MY,J)/DOS
	EPMAT(I,INUC1,J,INUC,3)=EPMAT(I,INUC1,J,INUC,3)+
     &EPIMAT(MY1,INUC1,MY,INUC,3)*
     &  TR(MY1,I)*TR(MY,J)/DOS
	EPMAT(I,INUC1,J,INUC,4)=EPMAT(I,INUC1,J,INUC,4)+
     &EPIMAT(MY1,INUC1,MY,INUC,4)*
     &  TR(MY1,I)*TR(MY,J)/DOS
	TRMAT(I,INUC1,J,INUC,1)=TRMAT(I,INUC1,J,INUC,1)+
     &VELMAT(MY1,INUC1,MY,INUC,1)*
     &  TR(MY1,I)*TR(MY,J)/AVT/2.D0
	TRMAT(I,INUC1,J,INUC,2)=TRMAT(I,INUC1,J,INUC,2)+
     &VELMAT(MY1,INUC1,MY,INUC,2)*
     &  TR(MY1,I)*TR(MY,J)/AVT/2.D0
	TRMAT(I,INUC1,J,INUC,3)=TRMAT(I,INUC1,J,INUC,3)+
     &VELMAT(MY1,INUC1,MY,INUC,3)*
     &  TR(MY1,I)*TR(MY,J)/AVT/2.D0
	TRMAT(I,INUC1,J,INUC,4)=TRMAT(I,INUC1,J,INUC,4)+
     &VELMAT(MY1,INUC1,MY,INUC,4)*
     &  TR(MY1,I)*TR(MY,J)/AVT/2.D0
      ENDDO                              !!! over -1,0,1
      ENDDO                              !!! over -1,0,1
	TRMAT(I,INUC1,J,INUC,4)=TRMAT(I,INUC1,J,INUC,1)+
     &TRMAT(I,INUC1,J,INUC,2)-TRMAT(I,INUC1,J,INUC,3)*2.D0
      ENDDO                              !!! over x,y,z
      ENDDO                              !!! over x,y,z
	WRITE(IUAIN,10140)
 	DO I=1,3
	DO J=1,3
	TCHAR(J)=LIB_TCP(EPMAT(I,INUC1,J,INUC,1),1.D-07)
	ENDDO
	WRITE(IUAIN,10130)(TCHAR(J),J=1,3)
	ENDDO
	WRITE(IUAIN,10150)
 	DO I=1,3
	DO J=1,3
	TCHAR(J)=LIB_TCP(EPMAT(I,INUC1,J,INUC,2),1.D-07)
	ENDDO
	WRITE(IUAIN,10130)(TCHAR(J),J=1,3)
	ENDDO
	WRITE(IUAIN,10160)
 	DO I=1,3
	DO J=1,3
	TCHAR(J)=LIB_TCP(EPMAT(I,INUC1,J,INUC,3),1.D-07)
	ENDDO
	WRITE(IUAIN,10130)(TCHAR(J),J=1,3)
	ENDDO
	WRITE(IUAIN,10170)
 	DO I=1,3
	DO J=1,3
	TCHAR(J)=LIB_TCP(EPMAT(I,INUC1,J,INUC,4),1.D-07)
	ENDDO
	WRITE(IUAIN,10130)(TCHAR(J),J=1,3)
	ENDDO
	WRITE(IUAIN,10180)
 	DO I=1,3
	DO J=1,3
	TCHAR(J)=LIB_TCP(TRMAT(I,INUC1,J,INUC,1),1.D-07)
	ENDDO
	WRITE(IUAIN,10130)(TCHAR(J),J=1,3)
	ENDDO
	WRITE(IUAIN,10190)
 	DO I=1,3
	DO J=1,3
	TCHAR(J)=LIB_TCP(TRMAT(I,INUC1,J,INUC,2),1.D-07)
	ENDDO
	WRITE(IUAIN,10130)(TCHAR(J),J=1,3)
	ENDDO
	WRITE(IUAIN,10200)
 	DO I=1,3
	DO J=1,3
	TCHAR(J)=LIB_TCP(TRMAT(I,INUC1,J,INUC,3),1.D-07)
	ENDDO
	WRITE(IUAIN,10130)(TCHAR(J),J=1,3)
	ENDDO
	WRITE(IUAIN,10210)
 	DO I=1,3
	DO J=1,3
	TCHAR(J)=LIB_TCP(TRMAT(I,INUC1,J,INUC,4),1.D-07)
	ENDDO
	WRITE(IUAIN,10130)(TCHAR(J),J=1,3)
	ENDDO
 1000 CONTINUE                           !!! over nuclear shifts
 2000 CONTINUE                           !!! over nuclear shifts
      CLOSE(IUAIN)
10120 FORMAT('! Elements: atom #',I2,1X,A10,' and #',I2,1X,A10)
10130 FORMAT(1X,A23,',',A23,',',A23)
10140 FORMAT('! Hopfield matrix (rigid part) is given by ---->')
10150 FORMAT('! the same, for k-point-convergency check  ---->')
10160 FORMAT('! Hopfield matrix (total part) is given by ---->')
10170 FORMAT('! the same, for k-point-convergency check  ---->')
10180 FORMAT('! Transport <v(k  j )*v(k  j )> is given by ---->')
10190 FORMAT('! Transport <v(k+qj")*v(k+qj")> is given by ---->')
10200 FORMAT('! Transport <v(k  j )*v(k+qj")> is given by ---->')
10210 FORMAT('! Transport (v(kj)-v(k+qj"))^2  is given by ---->')
	DEALLOCATE(EPMAT,TRMAT)
	END
