	SUBROUTINE PHN_SETPHN(IQPNT)
******************************************************
*   Stores phonon spectrum into PHNFILE              *
******************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_CONTROL, ONLY: LIFT,LMTO,NPFR,MODE                         !!! from readini
	USE COM_PARAM,   ONLY: NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN   !!! from readini
	USE COM_SPHERE,  ONLY: AMAS                                        !!! from init
	USE COM_QMESH,   ONLY: NQPNT,QPNT                                  !!! from readpnt
      USE COM_LABELS  ,ONLY: TXTAT,TXTEL,TXTSP                           !!! from readini
	USE COM_PHNOUT  ,ONLY: ICPHN,PHNFILE                               !!! from readini
      USE COM_DYNMAT,  ONLY: DYNMAT,OM,DPOL                              !!! from dynmat
      USE COM_UNIT,    ONLY: IUN,IUR,IUT,IUI                             !!! from setup
      USE COM_CHANNELS,ONLY: IUAIN                                       !!! from channels
C SET LOCAL VARIBLES
	IMPLICIT REAL*8 (A-H,O-Z)
	CHARACTER LIB_TCP*23,TCHAR(3)*23
	LOGICAL EXIST,OPEN
	IF(MODE.NE.4)RETURN
	IF(ICPHN.EQ.0)RETURN
	IFT=1 ! First formula for Dyn.Matrix is used
C STORE HEADER INFO.
	INQUIRE(FILE=PHNFILE,EXIST=EXIST)
	IF(EXIST)THEN
      OPEN(UNIT=IUAIN,FILE=PHNFILE,STATUS='OLD',FORM='FORMATTED')
	CLOSE(UNIT=IUAIN,STATUS='DELETE')
	ENDIF
	OPEN(IUAIN,FILE=PHNFILE,STATUS='NEW',FORM='FORMATTED')
	WRITE(IUAIN,10010)
	WRITE(IUAIN,10020)
10010	FORMAT(1X,'<FILE=PHNFILE,INPUT=MODERN>')
10020 FORMAT('****************************************************')
	WRITE(IUAIN,10030)
10030 FORMAT(1X,'<SECTION=QPNT>',30X,'! Q-POINT:')
      WRITE(IUAIN,10040)(QPNT(I,IQPNT),I=1,3)
10040 FORMAT(1X,G14.7,' , ',G14.7,' , ',G14.7)
	WRITE(IUAIN,10110)
10110 FORMAT(1X,'<SECTION=DMAT>',30X,'! DYN.MATRIX (Ry/a.u^2):')
C PRINT DYNAMICAL MATRIX
      DO INUC=1,NATOM             !!! over displacements
      DO JNUC=1,NATOM             !!! over displacements
      WRITE(IUAIN,10120)INUC,TXTAT(IS(INUC)),JNUC,TXTAT(IS(JNUC))
10120 FORMAT('! Elements: atom #',I2,1X,A10,' and #',I2,1X,A10)
	DO I=1,3
	DO J=1,3
	TCHAR(J)=LIB_TCP(DYNMAT(I,INUC,J,JNUC,IFT),1.D-07)
	ENDDO
	WRITE(IUAIN,10130)(TCHAR(J),J=1,3)
	ENDDO
10130 FORMAT(1X,A23,',',A23,',',A23)
      ENDDO                       !!! over displacements
      ENDDO                       !!! over displacements
C PRINT PHONON SPECTRUM
	WRITE(IUAIN,10210)
10210 FORMAT(1X,'<SECTION=PHNS>',30X,'! PHONON SPECTRUM:')
	WRITE(IUAIN,10220)
	WRITE(IUAIN,10260)(OM(IOMG),IOMG=1,3*NATOM)
	WRITE(IUAIN,10230)
	WRITE(IUAIN,10260)(OM(IOMG)*11605.0,IOMG=1,3*NATOM)  !!! Degrees K
	WRITE(IUAIN,10240)
	WRITE(IUAIN,10260)(OM(IOMG)*8065.80,IOMG=1,3*NATOM)  !!! sm**(-1)
	WRITE(IUAIN,10250)
	WRITE(IUAIN,10260)(OM(IOMG)*241.807,IOMG=1,3*NATOM)  !!! THz
10220 FORMAT('!',4X,'P H O N O N     S P E C T R U M (eV)')
10230 FORMAT('!',4X,'P H O N O N     S P E C T R U M (K)')
10240 FORMAT('!',4X,'P H O N O N     S P E C T R U M (sm**(-1))')
10250 FORMAT('!',4X,'P H O N O N     S P E C T R U M (THz)')
10260 FORMAT(1X, G12.5,' , ',G12.5,' , ',G12.5)
C PRINT POLARIZATIONS
	WRITE(IUAIN,10310)
10310 FORMAT(1X,'<SECTION=DPOL>',30X,'! POLARIZATIONS:')
	DO IOMG=1,3*NATOM              !!! over phonon branches
	WRITE(IUAIN,10320)OM(IOMG)*8065.80  !!! sm**(-1)
	DO IATOM=1,NATOM               !!! over atoms
	DO I=1,3
	TCHAR(I)=LIB_TCP(DPOL(I,IATOM,IOMG),1.D-07)
	ENDDO
	WRITE(IUAIN,10330)(TCHAR(I),I=1,3)
      ENDDO                          !!! over atoms
      ENDDO                          !!! over phonon branches
	CLOSE(IUAIN)
10320 FORMAT('! Omega(qj) = ',G12.5,' sm**(-1)')
10330 FORMAT(1X,A23,',',A23,',',A23)
	END
