	SUBROUTINE PHN_STORAGE
************************************************************
*  Sets phonon files storage
************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                   !!! from setup
      USE COM_CONTROL, ONLY : LIFT,NPFR,LRWF,MODE                      !!! from readini
      USE COM_PARAM,   ONLY : NATOM,NSORT,NSPIN,NORBS                  !!! from readini
      USE COM_PHNCOM,  ONLY : ITERMAX,NITER,EPS,CONVDRO                 !!! from readlrt
      USE COM_LRTCOM,  ONLY : LWHI,QVECTOR,MOVTASK                     !!! from readlrt
      USE COM_PANPAR,  ONLY : LTPAN,LSPAN                              !!! from readini
      USE COM_KAPPAR,  ONLY : NPAN,NKAP,EK,EKAP                        !!! from readini
      USE COM_SCFLOOP, ONLY : NITER1,EPSTOT,EPSRHO,EPSMAG              !!! from readini
      USE COM_NBANDS,  ONLY : NBNDF,NBNDE,NBNDC,NBNDT                  !!! from readini
	USE COM_QMESH,   ONLY : NQPNT,NQDIV,QPNT                         !!! from readpnt
	USE COM_MAGDAT  ,ONLY : AXMAG                                    !!! from readini
      USE COM_PLZCOM,  ONLY : NPLZ,LPLZ,IPLZ                           !!! from readlrt
	USE COM_INPTTR,  ONLY : NDIV,NDIC,NDIW                           !!! from readini
      USE COM_MIXDRHO, ONLY : ADMIX1,ADMIN,ADMAX,KEY                   !!! from readlrt
      USE COM_MIXDMAG, ONLY : ADMSPN,ASMIN,ASMAX,KSP                   !!! from readlrt
      USE COM_MIXDBRD, ONLY : LBROY,IBROY,ADMIXB,ADMIXH                !!! from readlrt
      USE COM_LABELS,  ONLY : TXTEL,PATHSCRT                           !!! from readini
	USE COM_MASHDEP, ONLY : NVAL                                     !!! from setup
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                          !!! from setup
	USE COM_CHANNELS,ONLY : IUINP,IUOUT                              !!! from channels
	USE COM_PHNCHN  ,ONLY : IUDRX                                    !!! from channels
	USE COM_LMTINP                                                   !!! from readini
	USE COM_LMTOUT                                                   !!! from readini
	USE COM_EXTENS                                                   !!! from setup
	USE COM_PHNOUT                                                   !!! from readini
	USE COM_PHNEXT                                                   !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER, ALLOCATABLE :: NRAD0(:)
	INTEGER, ALLOCATABLE :: ILSV0(:)
	REAL*8, ALLOCATABLE :: AXMAG0(:,:)
	LOGICAL, ALLOCATABLE :: LNUC(:,:)
	CHARACTER*10, ALLOCATABLE :: TPTB(:)
	CHARACTER*10, ALLOCATABLE :: TNUC(:,:)
	LOGICAL EXIST,PRESENT,COMPUTE
      CHARACTER DFILE*130,INF*130,UN(99)*2,TW*3,RS*10
	DIMENSION QPNT0(3)
	DATA PI/3.141592653589793D0/
C Memory allocations
	ALLOCATE(NRAD0(NSORTMEM))
	ALLOCATE(ILSV0(NSORTMEM))
	ALLOCATE(AXMAG0(3,NSORTMEM))
	ALLOCATE(TNUC(-1:1,NATOMMEM))
	ALLOCATE(TPTB(NENVMEM))
	ALLOCATE(LNUC(-1:1,NATOMMEM))
C Read q-point
	READ(QVECTOR,*)IQPNT
C CHANNEL ABBREVIATIONS
	DO ICHN=1,99
      IF(ICHN.LE.9)WRITE(RS,FMT='(I1)')ICHN
      IF(ICHN.GT.9)WRITE(RS,FMT='(I2)')ICHN
      IF(ICHN.GT.99)
     &CALL FULLSTOP('<STORAGE>:: ICHN>99 NOT ASSUMED')
      NRS=INDEX(RS,' ')
      IF(ICHN.LE.9)RS='0'//RS(:NRS-1)
      IF(ICHN.GT.9)RS=RS(:NRS-1)
      NRS=INDEX(RS,' ')
	UN(ICHN)=RS(:NRS-1)
	ENDDO
C MOVEMENTS ABBREVIATIONS
      DO INUC=1,NATOM
      IF(INUC.LE.9)WRITE(RS,FMT='(I1)')INUC
      IF(INUC.GT.9)WRITE(RS,FMT='(I2)')INUC
      IF(INUC.GT.99)
     &CALL FULLSTOP('<STORAGE>:: INUC>99 NOT ASSUMED')
      NRS=INDEX(RS,' ')
      IF(INUC.LE.9)RS='0'//RS(:NRS-1)
      IF(INUC.GT.9)RS=RS(:NRS-1)
      NRS=INDEX(RS,' ')
      DO MY=-1,1
      IF(MY.EQ.-1)TNUC(MY,INUC)='m'//RS(:NRS-1)
      IF(MY.EQ. 0)TNUC(MY,INUC)='z'//RS(:NRS-1)
      IF(MY.EQ.+1)TNUC(MY,INUC)='p'//RS(:NRS-1)
	ENDDO
	ENDDO
C RECIPROCAL VECTORS FOR POLARIZABILITY
	DO IPTB=1,MIN(NENVMEM,999)
      IF(IPTB.LE.9)                 WRITE(RS,FMT='(I1)')IPTB
      IF(IPTB.GT.9 .AND.IPTB.LE.99) WRITE(RS,FMT='(I2)')IPTB
      IF(IPTB.GT.99.AND.IPTB.LE.999)WRITE(RS,FMT='(I3)')IPTB
      IF(IPTB.GT.999)
     &CALL FULLSTOP('<STORAGE>:: NPTB>999 NOT ASSUMED')
      NRS=INDEX(RS,' ')
	TPTB(IPTB)=RS(:NRS-1)
	ENDDO
	ND=INDEX(MOVTASK,' ')
	IF(ND.LE.1)ND=2
C Q-POINT ABBREVIATIONS
      NQ=INDEX(QVECTOR,' ')
      IF(NQ.LE.1)NQ=2
C Initialize LMTART switches
	ICCHI=0  ! no susceptibility calculation
	ICOPT=0  ! no optical properties
	ICSCF=0  ! scratch storage of the potential
	ICPOT=0  ! scratch storage of the density
	ICPSI=0  ! conduction bands wave functions
	ICFAT=0  ! fat bands
	ICDOS=0  ! densities of states
	IF(MODE.NE.5)
     &ICPSK=1  ! all bands wave functions
	IF(MODE.EQ.5)
     &ICPSK=0  ! all bands wave functions
      IF(MODE.NE.5)THEN
C Set # of empty bands to the total # of bands for band structure run
	NBNDF(1)=NBNDT(1)
	NBNDE(1)=1
	NBNDC(1)=NBNDT(1)
	ENDIF
C Reset k-point grids
      IF(MODE.EQ.0)THEN
      NDIV(1)=NDIW(1)    
      NDIV(2)=NDIW(2)
      NDIV(3)=NDIW(3)
      NDIC(1)=NDIW(1)    
      NDIC(2)=NDIW(2)
      NDIC(3)=NDIW(3)
      ELSE
      NDIC(1)=NDIV(1)
      NDIC(2)=NDIV(2)
      NDIC(3)=NDIV(3)
      ENDIF
C Check grids for consistency
      IF(ABS(MOD(DBLE(NDIW(1)),DBLE(NDIV(1)))).GT.1.D-10.OR.
     &   ABS(MOD(DBLE(NDIW(2)),DBLE(NDIV(2)))).GT.1.D-10.OR.
     &   ABS(MOD(DBLE(NDIW(3)),DBLE(NDIV(3)))).GT.1.D-10)
     &CALL FULLSTOP(' Incommensurate k-point grids')
C Check grids for consistency
      IF(ABS(MOD(DBLE(NDIV(1)),DBLE(NQDIV(1)))).GT.1.D-10.OR.
     &   ABS(MOD(DBLE(NDIV(2)),DBLE(NQDIV(2)))).GT.1.D-10.OR.
     &   ABS(MOD(DBLE(NDIV(3)),DBLE(NQDIV(3)))).GT.1.D-10)
     &WRITE(IUT,*)'k-point and q-point grids incommensurate'
C *******************************************************
C Set files which depend on the electronic structure
C *******************************************************
C HUBBARD CORRECTIONS
	INF=INPINFO
      CALL FIND_LBLANK(PROJECT,130,NBP)
      CALL FIND_LBLANK(EXTNHUB,60,NBE)
      HUBFILE=PROJECT(:NBP)//'.'//EXTNHUB(:NBE)
	CALL LIB_RMBLANK(HUBFILE,130)
      CALL SUBSTR_IN_STR(PRESENT,INF,130,EXTNHUB,LENEXTN)
      IF(.NOT.PRESENT)ICHUB=0       !!! do not use hubfile
      IF(     PRESENT)ICHUB=2       !!! use hubfile
	INQUIRE(FILE=HUBFILE,EXIST=EXIST)
      IF(.NOT.EXIST.AND.ICHUB.EQ.2)THEN
      WRITE(IUT,*)'Terminated in <STORAGE>::'
      WRITE(IUT,*)'Hubbard corrections HUBFILE ',HUBFILE
      WRITE(IUT,*)'should exist for this mode.'
	CALL FULLSTOP(' ')
	ENDIF
C ENERGY BANDS AT DENSE GRID
      CALL FIND_LBLANK(PROJECT,130,NBP)
      CALL FIND_LBLANK(EXTNENR,60,NBE)
      ENRFILE=PROJECT(:NBP)//'.'//EXTNENR(:NBE)
	CALL LIB_RMBLANK(ENRFILE,130)
      INQUIRE(FILE=ENRFILE,EXIST=EXIST)
      IF(MODE.EQ.0.AND.EXIST)
     &CALL FULLSTOP('<STORAGE>:: ENRFILE SHOULD NOT EXIST IF MODE=0')
      IF(MODE.EQ.0.AND.(.NOT.EXIST))
     &WRITE(IUT,*)'<STORAGE>:: ENRFILE DOES NOT EXIST, WILL BE MADE'
      IF(MODE.NE.0.AND.(.NOT.EXIST).AND.NDIV(1).NE.NDIW(1))
     &WRITE(IUT,*)'<STORAGE>:: ENRFILE DOES NOT EXIST, SLOW MODE!!!'
      IF(MODE.EQ.0.AND.(.NOT.EXIST))ICENR=1
      IF(MODE.NE.0.AND.      EXIST )ICENR=2
      IF(MODE.NE.0.AND.(.NOT.EXIST))ICENR=0
C STRUCTURE CONSTANTS
      CALL FIND_LBLANK(PROJECT,130,NBP)
      CALL FIND_LBLANK(EXTNCON,60,NBE)
      CONFILE=PROJECT(:NBP)//'.'//EXTNCON(:NBE)
	CALL LIB_RMBLANK(CONFILE,130)
      INQUIRE(FILE=CONFILE,EXIST=EXIST)
      IF(MODE.EQ.0.AND.EXIST)
     &WRITE(IUT,*)'<STORAGE>:: CONFILE EXIST, WILL BE CHECKED'
      IF(MODE.NE.0.AND.(.NOT.EXIST))
     &WRITE(IUT,*)'<STORAGE>:: CONFILE DOES NOT EXIST, WILL BE MADE'
      IF(MODE.EQ.0.AND.      EXIST )ICCON=2
      IF(MODE.EQ.0.AND.(.NOT.EXIST))ICCON=0
      IF(MODE.NE.0.AND.      EXIST )ICCON=2
      IF(MODE.NE.0.AND.(.NOT.EXIST))ICCON=1
C *******************************************************
C Set files which depend on the perturbation wave vector
C *******************************************************
C TETRAHEDRON WEIGHTS
      DFILE=WGTFILE(1)
      NA=INDEX(DFILE,' ')
      IF(LWHI.EQ.1)TW='re0' ! real part and omega=0
      IF(LWHI.EQ.2)TW='im0' ! imaginary part and omega=0
      IF(LWHI.EQ.3)TW='reW' ! frequency dependent real part
      IF(LWHI.EQ.4)TW='imW' ! frequency dependent imaginary part
      WGTFILE(LWHI)=DFILE(:NA-1)//QVECTOR(:NQ-1)//TW
      INQUIRE(FILE=WGTFILE(LWHI),EXIST=EXIST)
	IF(.NOT.EXIST)ICWGT=1
	IF(     EXIST)ICWGT=2
      IF(EXIST)
     &WRITE(IUT,*)'<STORAGE>:: WGTFILE EXIST, WILL BE CHECKED'
      IF(.NOT.EXIST)
     &WRITE(IUT,*)'<STORAGE>:: WGTFILE DOES NOT EXIST, WILL BE MADE'
C PHONON SPECTRUM
      IF(MODE.EQ.4)ICPHN=1
      IF(MODE.NE.4)ICPHN=0
      NA=INDEX(PHNFILE,' ')
      PHNFILE=PHNFILE(:NA-1)//QVECTOR(:NQ-1)
      INQUIRE(FILE=PHNFILE,EXIST=EXIST)
      IF(EXIST.AND.ICPHN.EQ.1)
     &CALL FULLSTOP('<STORAGE>:: PHNFILE EXIST, DELETE IT !')
C ELECTRON-PHONON INTERACTION MATRIX
      IF(MODE.EQ.5)ICEPI=1
      IF(MODE.NE.5)ICEPI=0
      NA=INDEX(EPIFILE,' ')
      EPIFILE=EPIFILE(:NA-1)//QVECTOR(:NQ-1)
      INQUIRE(FILE=EPIFILE,EXIST=EXIST)
      IF(EXIST.AND.ICEPI.EQ.1)
     &CALL FULLSTOP('<STORAGE>:: EPIFILE EXIST, DELETE IT !')
C POLARIZABILITY FUNCTION
      QPNT2=QPNT(1,IQPNT)**2+QPNT(2,IQPNT)**2+QPNT(3,IQPNT)**2
      IF(QPNT2.LE.1.D-10.AND.LPLZ.EQ.1)WRITE(IUT,*)
     & '<STORAGE>:: Q-vector iz ZERO [G-point]! LPLZ=0 MODE IS USED!'
      IF(QPNT2.LE.1.D-10.AND.LPLZ.EQ.1)LPLZ=0
	IF(LPLZ.NE.0)THEN
	DFILE=PLZFILE(1)
      NA=INDEX(DFILE,' ')
	DO IPTB=1,NENVMEM
      NRS=INDEX(TPTB(IPTB),' ')
      PLZFILE(IPTB)=DFILE(:NA-1)//QVECTOR(:NQ-1)
     &//'g'//TPTB(IPTB)(:NRS-1)
      INQUIRE(FILE=PLZFILE(IPTB),EXIST=EXIST)
	IF(.NOT.EXIST.AND.IPTB.EQ.1)ICPLZ=1
	IF(     EXIST.AND.IPTB.EQ.1)ICPLZ=2
      IF(.NOT.EXIST.AND.IPTB.EQ.1)
     &WRITE(IUT,*)'<STORAGE>:: PLZFILE DOES NOT EXIST, WILL BE MADE'
      IF(     EXIST.AND.IPTB.EQ.1)
     &WRITE(IUT,*)'<STORAGE>:: PLZFILE  EXIST, WILL BE CHECKED'
	ENDDO
	DFILE=PLSFILE(1)
      NA=INDEX(DFILE,' ')
	DO IPTB=1,NENVMEM
      NRS=INDEX(TPTB(IPTB),' ')
      PLSFILE(IPTB)=DFILE(:NA-1)//QVECTOR(:NQ-1)
     &//'g'//TPTB(IPTB)(:NRS-1)
      INQUIRE(FILE=PLSFILE(IPTB),EXIST=EXIST)
      IF(.NOT.EXIST.AND.IPTB.EQ.1)
     &WRITE(IUT,*)'<STORAGE>:: PLSFILE DOES NOT EXIST, WILL BE MADE'
      IF(     EXIST.AND.IPTB.EQ.1)
     &WRITE(IUT,*)'<STORAGE>:: PLSFILE  EXIST, WILL BE CHECKED'
	ENDDO
	ELSEIF(LPLZ.EQ.0)THEN
	ICPLZ=0
	ENDIF
      IF(LPLZ.NE.0.AND.(MODE.EQ.4.OR.MODE.EQ.5).AND.ICPLZ.NE.2)
     &CALL FULLSTOP('PLZFILE MUST EXIST IF MODE=5 AND LPLZ>0')
C CHANGE IN THE FULL POTENTIAL AND PSEUDOPOTENTIAL
	DFILE=DSVFILE(-1,1)
      NA=INDEX(DFILE,' ')
	DO INUC=1,NATOM
	DO MY=-1,1
	IF(NITER(MY,INUC).NE.0)THEN
      NT=INDEX(TNUC(MY,INUC),' ')
      DSVFILE(MY,INUC)=DFILE(:NA-1)//QVECTOR(:NQ-1)
     &                             //TNUC(MY,INUC)(:NT-1)
      INQUIRE(FILE=DSVFILE(MY,INUC),EXIST=EXIST)
	IF(.NOT.EXIST)ICDSV=0
	IF(     EXIST)ICDSV=0
	ENDIF 
	ENDDO
	ENDDO
	DFILE=DPVFILE(-1,1)
      NA=INDEX(DFILE,' ')
	DO INUC=1,NATOM
	DO MY=-1,1
	IF(NITER(MY,INUC).NE.0)THEN
      NT=INDEX(TNUC(MY,INUC),' ')
      DPVFILE(MY,INUC)=DFILE(:NA-1)//QVECTOR(:NQ-1)
     &                             //TNUC(MY,INUC)(:NT-1)
      INQUIRE(FILE=DPVFILE(MY,INUC),EXIST=EXIST)
	IF(.NOT.EXIST)ICDPV=0
	IF(     EXIST)ICDPV=0
	ENDIF
	ENDDO
	ENDDO
C CHANGE IN CHARGE DENSITY
	DFILE=DROFILE(-1,1)
      NA=INDEX(DFILE,' ')
	DO INUC=1,NATOM
	DO MY=-1,1
	IF(NITER(MY,INUC).NE.0)THEN
      NT=INDEX(TNUC(MY,INUC),' ')
      DROFILE(MY,INUC)=DFILE(:NA-1)//QVECTOR(:NQ-1)
     &                             //TNUC(MY,INUC)(:NT-1)
      INQUIRE(FILE=DROFILE(MY,INUC),EXIST=EXIST)
	IF(.NOT.EXIST)ICDRO=1
	IF(     EXIST)ICDRO=2
      IF(     EXIST.AND.MODE.EQ.1)
     &CALL FULLSTOP('<STORAGE>:: DROFILE EXIST, DELETE IT !')
      IF(.NOT.EXIST.AND.MODE.EQ.2.AND.ICDRO.NE.0)
     &WRITE(IUT,*)'<STORAGE>:: DROFILE DOES NOT EXIST, ',
     &'MODE IS SET TO ONE'
      IF(.NOT.EXIST.AND.MODE.EQ.2.AND.ICDRO.NE.0)MODE=1
	ENDIF
	ENDDO
	ENDDO
	DFILE=DPSFILE(-1,1)
      NA=INDEX(DFILE,' ')
	DO INUC=1,NATOM
	DO MY=-1,1
	IF(NITER(MY,INUC).NE.0)THEN
      NT=INDEX(TNUC(MY,INUC),' ')
      DPSFILE(MY,INUC)=DFILE(:NA-1)//QVECTOR(:NQ-1)
     &                             //TNUC(MY,INUC)(:NT-1)
      INQUIRE(FILE=DPSFILE(MY,INUC),EXIST=EXIST)
	IF(.NOT.EXIST)ICDPS=1
	IF(     EXIST)ICDPS=2
      IF(    EXIST.AND.MODE.EQ.1)
     &CALL FULLSTOP('<STORAGE>:: DPSFILE EXIST, DELETE IT !')
      IF(.NOT.EXIST.AND.MODE.EQ.2.AND.ICDPS.NE.0)
     &WRITE(IUT,*)'<STORAGE>:: DPSFILE DOES NOT EXIST, ',
     &  'MODE IS SET TO ONE'
      IF(.NOT.EXIST.AND.MODE.EQ.2.AND.ICDRO.NE.0)MODE=1
      ENDIF
	ENDDO
	ENDDO
C OUTPUT FILE
      CALL LIB_RMBLANK(OUTFILE,130)
      DFILE=OUTFILE
      CALL LIB_CONVLOW(DFILE,130)
      NA=INDEX(DFILE,' ')
      IF(DFILE(1:NA).EQ.'stdout')ICOUT=0
      IF(DFILE(1:NA).NE.'stdout')ICOUT=2
      IF(ICOUT.GT.0)THEN
      OUTFILE=OUTFILE(:NA-1)//QVECTOR(:NQ-1)//MOVTASK(:ND-1)
      INQUIRE(FILE=OUTFILE,EXIST=EXIST)
      IF(EXIST.AND.ICOUT.EQ.1)THEN
      CALL FULLSTOP('<STORAGE>:: OUTFILE EXIST, DELETE IT !')
      ELSEIF(EXIST.AND.ICOUT.EQ.2)THEN
      OPEN(UNIT=IUINP,FILE=OUTFILE,FORM='FORMATTED',STATUS='OLD')
      NA=INDEX(OUTFILE,' ')
      WRITE(IUT,*)OUTFILE(:NA-1)//' DELETED !'
      CLOSE(UNIT=IUINP,STATUS='DELETE')
      ENDIF
      ENDIF
      IF(ICOUT.NE.0)THEN
      IUN=IUOUT
      OPEN(UNIT=IUOUT,FILE=OUTFILE,STATUS='NEW')
      ELSE
      IUN=IUT
      ENDIF
C SET SCRATCH FILES
	ISCR1MIN=1
	ISCR1MAX=99
	ALLOCATE(SCRFILE(1:99))
      CALL FIND_LBLANK(PROJECT,130,NBP)
      CALL FIND_LBLANK(EXTNSCR,60,NBE)
	SCRFILE(1)=PROJECT(:NBP)//'.'//EXTNSCR(:NBE)
	CALL LIB_RMBLANK(SCRFILE(1),130)
	NS=INDEX(PATHSCRT,' ')
	IF(NS.EQ.0)NS=1
	NA=INDEX(SCRFILE(1),' ')
	DFILE=PATHSCRT(:NS-1)//SCRFILE(1)(:NA-1)
      NA=INDEX(DFILE,' ')
      DO ICHN=ISCR1MIN,ISCR1MAX
      SCRFILE(ICHN)=DFILE(:NA-1)//UN(ICHN)
     &  //'q'//QVECTOR(:NQ-1)//MOVTASK(:ND-1)
	ENDDO
      DO ICHN=ISCR1MIN,ISCR1MAX
      INQUIRE(FILE=SCRFILE(ICHN),EXIST=EXIST)
      IF(EXIST)THEN
      OPEN(UNIT=IUINP,FILE=SCRFILE(ICHN),FORM='UNFORMATTED',
     &STATUS='OLD')
      NA=INDEX(SCRFILE(ICHN),' ')
      WRITE(IUT,*)SCRFILE(ICHN)(:NA-1)//' DELETED !'
      CLOSE(UNIT=IUINP,STATUS='DELETE')
	ENDIF
	ENDDO
C SCRATCH FILES FOR POLARIZABILITY
	ISCP1MIN=1
	ISCP1MAX=99
	ISCP2MIN=1
	ISCP2MAX=NENVMEM
	ALLOCATE(SCPFILE(NENVMEM,100))
	DO ICHN=1,99
      NS=INDEX(SCRFILE(ICHN),' ')
	DO IPTB=1,NENVMEM
      NRS=INDEX(TPTB(IPTB),' ')
      SCPFILE(IPTB,ICHN)=SCRFILE(ICHN)(:NS-1)
     &  //'g'//TPTB(IPTB)(:NRS-1)
      INQUIRE(FILE=SCPFILE(IPTB,ICHN),EXIST=EXIST)
      IF(EXIST)THEN
      OPEN(UNIT=IUINP,FILE=SCPFILE(IPTB,ICHN),FORM='UNFORMATTED',
     &STATUS='OLD')
      NA=INDEX(SCPFILE(IPTB,ICHN),' ')
      WRITE(IUT,*)SCPFILE(IPTB,ICHN)(:NA-1)//' DELETED !'
      CLOSE(UNIT=IUINP,STATUS='DELETE')
      ENDIF
	ENDDO
	ENDDO
C SET SCRATCH FILES NAMED FOR EVERY DISPLACEMENT
	ISCN1MIN=1
	ISCN1MAX=99
	ISCN2MIN=1
	ISCN2MAX=NATOMMEM
	ISCN3MIN=-1
	ISCN3MAX=+1
	ALLOCATE(SCNFILE(-1:1,NATOMMEM,99))
      DO ICHN=1,99
      NS=INDEX(SCRFILE(ICHN),' ')
      DO INUC=1,NATOM
      DO MY=-1,1
      NT=INDEX(TNUC(MY,INUC),' ')
      SCNFILE(MY,INUC,ICHN)=SCRFILE(ICHN)(:NS-1)
     &  //TNUC(MY,INUC)(:NT-1)
      INQUIRE(FILE=SCNFILE(MY,INUC,ICHN),EXIST=EXIST)
      IF(EXIST)THEN
      OPEN(UNIT=IUINP,FILE=SCNFILE(MY,INUC,ICHN),FORM='UNFORMATTED',
     &STATUS='OLD')
      NA=INDEX(SCNFILE(MY,INUC,ICHN),' ')
      WRITE(IUT,*)SCNFILE(MY,INUC,ICHN)(:NA-1)//' DELETED !'
      CLOSE(UNIT=IUINP,STATUS='DELETE')
      ENDIF
	ENDDO
	ENDDO
	ENDDO
C--------------------------------------------
C *** SET MIXING PARAMETERS *****************
C--------------------------------------------
	DO INUC=1,NATOM
	DO MY=-1,1
      ADMIN(MY,INUC)=MAX(0.D0,ADMIX1(MY,INUC)/2.D0)
      ADMAX(MY,INUC)=MIN(1.D0,ADMIX1(MY,INUC)*2.D0)
	ASMIN(MY,INUC)=ADMSPN(MY,INUC) 
	ASMAX(MY,INUC)=ADMSPN(MY,INUC) 
	ENDDO
	ENDDO
C CHECK FOR START BROYDEN MODE
	DO INUC=1,NATOM
	DO MY=-1,1
	IF(MODE.NE.2.AND.IBROY(MY,INUC).EQ.0)IBROY(MY,INUC)=1
	ENDDO
	ENDDO
C RESET MIXING ACCORDING TO WHAT IS STORED IN DROFILES
	IF(MODE.NE.1)THEN
	DO INUC=1,NATOM
	DO MY=-1,1
	IF(NITER(MY,INUC).NE.0)THEN
      INQUIRE(FILE=DROFILE(MY,INUC),EXIST=EXIST)
	IF(.NOT.EXIST)
     &CALL FULLSTOP('<STORAGE>:: DROFILE MUST EXIST!')
	OPEN(UNIT=IUDRX,FILE=DROFILE(MY,INUC),STATUS='OLD',
     &FORM='UNFORMATTED',ACCESS='SEQUENTIAL')
      READ(IUDRX)NATOM0,NSORT0,NSPIN0,NORBS0,
     &(NRAD0(ISORT),ISORT=1,NSORT0),
     &(ILSV0(ISORT),ISORT=1,NSORT0),(QPNT0(I),I=1,3),
     &((AXMAG0(I,ISORT),I=1,3),ISORT=1,NSORT0),
     &NITER0,EPS0,KEY0,KSP0,LBROY0,ADMIN0,ADMAX0,ASMIN0,ASMAX0,
     &ADMIXB0,ADMIXH0,(CONVDRO(IA,MY,INUC),IA=0,3)
	CLOSE(IUDRX)
	IF(NATOM0.NE.NATOM)
     &CALL FULLSTOP(' # OF ATOMS MISMATCH IN <DROFILE>')
      IF(NSORT0.NE.NSORT)
     &CALL FULLSTOP(' # OF SORTS MISMATCH IN <DROFILE>')
      IF(NSPIN0.NE.NSPIN)
     &CALL FULLSTOP(' # OF SPINS MISMATCH IN <DROFILE>')
      IF(NORBS0.NE.NORBS)
     &CALL FULLSTOP(' # OF NORBS MISMATCH IN <DROFILE>')
      NA=INDEX(DROFILE(MY,INUC),' ')
C  SWITCH OFF SOME MODES IF SELF-CONSISTENT
      IF(NORBS0.EQ.1)
     &ACCUR=MAX(SQRT(DREAL(CONVDRO(0,MY,INUC))**2
     &              +DIMAG(CONVDRO(0,MY,INUC))**2),
     &          SQRT(DREAL(CONVDRO(3,MY,INUC))**2
     &              +DIMAG(CONVDRO(3,MY,INUC))**2))
      IF(NORBS0.EQ.2)
     &ACCUR=MAX(SQRT(DREAL(CONVDRO(0,MY,INUC))**2
     &              +DIMAG(CONVDRO(0,MY,INUC))**2),
     &          SQRT(DREAL(CONVDRO(1,MY,INUC))**2
     &              +DIMAG(CONVDRO(1,MY,INUC))**2
     &              +DREAL(CONVDRO(2,MY,INUC))**2
     &              +DIMAG(CONVDRO(2,MY,INUC))**2
     &              +DREAL(CONVDRO(3,MY,INUC))**2
     &              +DIMAG(CONVDRO(3,MY,INUC))**2))
      IF(MODE.EQ.2.AND.EPS(MY,INUC).GE.ACCUR)NITER(MY,INUC)=0
      WRITE(IUN,1010)ACCUR,EPS(MY,INUC),NITER(MY,INUC),
     &DROFILE(MY,INUC)(:NA-1)
1010	FORMAT(1X,'Accuracy reached=',G9.2,'; required=',G9.2,
     &  '; Niter set to ',I3,' for ',A)
C  SET MIXING
      IF((MODE.EQ.2.OR.MODE.EQ.3).AND.KEY(MY,INUC).EQ.0)THEN
      ADMIN (MY,INUC)=ADMIN0
      ADMAX (MY,INUC)=ADMAX0
      ASMIN (MY,INUC)=ASMIN0
      ASMAX (MY,INUC)=ASMAX0
      ADMIX1(MY,INUC)=(ADMIN(MY,INUC)+ADMAX(MY,INUC))/2.D0
      ADMSPN(MY,INUC)=(ASMIN(MY,INUC)+ASMAX(MY,INUC))/2.D0
      ENDIF
	ENDIF
	ENDDO
	ENDDO
	ENDIF
C Memory deallocations
	DEALLOCATE(NRAD0,ILSV0,TNUC,TPTB,LNUC,AXMAG0)
	END
