	SUBROUTINE PHN_SYMNUC(IQPNT)
********************************************************
*  Symmetry of the phonon modes.                       *
********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
      USE COM_PHNCOM,  ONLY : ITERMAX,NITER                              !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
      USE COM_LABELS,  ONLY : TXTEL                                      !!! from readini
	USE COM_QMESH,   ONLY : NQPNT,QPNT                                 !!! from readpnt
	USE COM_GROUPS,  ONLY : NGROUP,U,IP,RDC,INV,IKOV                   !!! from makegrp
      USE COM_SYMNUC,  ONLY : NUMQ,KEYQ,USUM                             !!! from symnuc
	USE COM_SUBGROUP,ONLY : NSGQ,NGEQ,ISG                              !!! from delmesh
	USE COM_MASHDEP, ONLY : NVAL                                       !!! from setup
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: SUM(:)
	CHARACTER*1, ALLOCATABLE :: TSUM(:,:,:,:)
      DATA PI/3.141592653589793D0/
C Memory allocations for main control arrays
	ALLOCATE(USUM(-1:1,NATOMMEM,-1:1,NATOMMEM))
C Memory allocations
	ALLOCATE(SUM(NWIGMEM))
	ALLOCATE(TSUM(-1:1,NATOMMEM,-1:1,NATOMMEM))
C  SET SUM TO ZERO
      DO INUC1=1,NATOM
      DO INUC=1,NATOM
      DO MY1=-1,1
      DO MY=-1,1
      USUM(MY1,INUC1,MY,INUC)=0.D0
      ENDDO
      ENDDO
      ENDDO
      ENDDO
C CALCULATE USUM
      DO 5000 INUC=1,NATOM
      DO 4000 MY=-1,1
      DO 3000 INUC1=1,NATOM
      DO 2000 MY1=-1,1
      DO 1000 IGEQ=1,NGEQ
      IR=ISG(IGEQ,1)
      IG=IKOV(IR)
      INUCG=IP(INUC,IR)
      IF(INUCG.NE.INUC1)GOTO1000
      IWIGMY=3+3*(1+MY1)+MY
      IF(ABS(U(IWIGMY,IG)).LE.1.D-10)GOTO1000
      USUM(MY,INUC,MY1,INUC1)=1.D0
1000  CONTINUE
2000  CONTINUE
3000  CONTINUE
4000  CONTINUE
5000  CONTINUE
C  SET UP COUPLING 
	DO INUC1=1,NATOM
	DO INUC=1,NATOM
	DO MY1=-1,1
	DO MY=-1,1
	IF(ABS(USUM(MY1,INUC1,MY,INUC)).LE.1.D-06)
     &  TSUM(MY1,INUC1,MY,INUC)='N'
	IF(ABS(USUM(MY1,INUC1,MY,INUC)).GT.1.D-06)
     &  TSUM(MY1,INUC1,MY,INUC)='Y'
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C  PRINT BLOCK
	WRITE(IUN,1010)
	DO INUC1=1,NATOM
	DO INUC=1,NATOM
	WRITE(IUN,1020)INUC1,TXTEL(IS(INUC1)),INUC,TXTEL(IS(INUC))
	WRITE(IUN,1030)
	DO MY1=-1,1
	WRITE(IUN,1040)MY1,(TSUM(MY1,INUC1,MY,INUC),MY=-1,1)
	ENDDO
	ENDDO
	ENDDO
	IERROR=0
	DO INUC1=1,NATOM
	DO INUC=1,NATOM
	DO MY1=-1,1
	DO MY=-1,1
	IF(ABS(USUM(MY1,INUC1,MY,INUC)).GT.1.D-06.AND.
     &  NITER(MY1,INUC1).NE.NITER(MY,INUC))THEN
	IERROR=1
	WRITE(IUT,*)'Atoms:',inuc1,inuc,' and polarzations:',my1,my,
     &  ' are coupled by symmetry, specify another RUNTASK mode'
	ENDIF
      IF(USUM(MY,INUC,MY1,INUC1).NE.USUM(MY1,INUC1,MY,INUC))THEN
      WRITE(IUT,*)'Error in hermitianness, element ',MY,INUC,MY1,INUC1
	IERROR=1
	ENDIF
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	IF(IERROR.EQ.1)CALL FULLSTOP('stop in SYMNUC')
1010	FORMAT(1X,'*** Displacements coupled by symmetry ----->>')
1020  FORMAT(1X,'Elements: atom #',I2,1X,A10,' and #',I2,1X,A10)
1030	FORMAT(1X,'mu1/mu      -1         0         1')
1040  FORMAT(3X,I2,4X,'|',4X,A1,4X,'|',4X,A1,4X,'|',4X,A1,4X,'|')
	DEALLOCATE(SUM,TSUM)
	END



	SUBROUTINE PHN_QTASKS(IQPNT)
********************************************************
*  Prints tasks
********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
      USE COM_PHNCOM,  ONLY : ITERMAX,NITER                              !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
      USE COM_LABELS,  ONLY : TXTEL                                      !!! from readini
	USE COM_QMESH,   ONLY : NQPNT,QPNT                                 !!! from readpnt
	USE COM_GROUPS,  ONLY : NGROUP,U,IP,RDC,INV,IKOV                   !!! from makegrp
      USE COM_SYMNUC,  ONLY : NUMQ,KEYQ,USUM                             !!! from symnuc
	USE COM_SUBGROUP,ONLY : NSGQ,NGEQ,ISG                              !!! from delmesh
	USE COM_MASHDEP, ONLY : NVAL                                       !!! from setup
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER, ALLOCATABLE :: LTSK(:,:)
      LOGICAL, ALLOCATABLE :: LNUC(:,:)
      CHARACTER*5, ALLOCATABLE :: TNUC(:,:)
      CHARACTER*5, ALLOCATABLE :: TDSP(:)
	CHARACTER RS*10,TASK*10
      DATA PI/3.141592653589793D0/
C MEMORY ALLOCATIONS
      ALLOCATE(LTSK(-1:1,NATOMMEM))
      ALLOCATE(LNUC(-1:1,NATOMMEM))
      ALLOCATE(TNUC(-1:1,NATOMMEM))
      ALLOCATE(TDSP(3*NATOMMEM))
C SET INDICATOR TO ZERO
	DO INUC=1,NATOM
      IF(INUC.LE.9)WRITE(RS,FMT='(I1)')INUC
      IF(INUC.GT.9)WRITE(RS,FMT='(I2)')INUC
      IF(INUC.GT.99)STOP'<QVECTOR>:: INUC>99 NOT ASSUMED'
      NRS=INDEX(RS,' ')
	DO MY=-1,1
	LTSK(MY,INUC)=0
      IF(MY.EQ.-1)TNUC(MY,INUC)='a'//RS(:NRS-1)//'m'
      IF(MY.EQ. 0)TNUC(MY,INUC)='a'//RS(:NRS-1)//'z'
      IF(MY.EQ.+1)TNUC(MY,INUC)='a'//RS(:NRS-1)//'p'
	ENDDO
	ENDDO
C SEARCH FOR EQUIVALENT TASKS
	ITSK=0
	DO INUC=1,NATOM
	DO MY=-1,1
	IF(LTSK(MY,INUC).EQ.0)THEN
	ITSK=ITSK+1
	DO INUC1=1,NATOM
	DO MY1=-1,1
	IF(ABS(USUM(MY,INUC,MY1,INUC1)).GT.1.D-06.AND.
     &LTSK(MY1,INUC1).EQ.0)THEN
	LTSK(MY,INUC)=ITSK
	LTSK(MY1,INUC1)=ITSK
	ENDIF
	ENDDO
	ENDDO
	ENDIF
	ENDDO
	ENDDO
	NTSK=ITSK
C PRINT TASKS
	WRITE(IUN,1010)NTSK
	DO ITSK=1,NTSK
	NDSP=0
      IF(ITSK.LE.9)WRITE(RS,FMT='(I1)')ITSK
      IF(ITSK.GT.9)WRITE(RS,FMT='(I2)')ITSK
      IF(ITSK.GT.99)STOP'<QVECTOR>:: ITSK>99 NOT ASSUMED'
      NRS=INDEX(RS,' ')
	TASK='<tsk'//RS(:NRS-1)//'>'
	DO INUC=1,NATOM
	DO MY=-1,1
	IF(LTSK(MY,INUC).EQ.ITSK)THEN
	NDSP=NDSP+1
	TDSP(NDSP)=TNUC(MY,INUC)
	ENDIF
	ENDDO
	ENDDO
      NT=INDEX(TASK,' ')
	WRITE(IUN,1020)TASK(:NT-1),(TDSP(IDSP),IDSP=1,NDSP)
	ENDDO
1010	FORMAT(1X,'Sorting displacements over tasks, TOTAL # =',I3)
1020	FORMAT(1X,A,4X,10(1X,A5))
C MEMORY DEALLOCATIONS
      DEALLOCATE(LTSK,LNUC,TNUC,TDSP)
	END
