	SUBROUTINE PLZ_SPLIPAR(IPTB,IPAN,IQPNT)
***********************************************************
*  Calculates contribution to the change in the           *
*  interstitial potential matrix elements from k=0        *
*  and large vectors G.                                   *
***********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_LATTICE, ONLY : TAU                                        !!! from readstr
	USE COM_LATPAR,  ONLY : PAR,ORTH,OMEGAC                            !!! from readini
	USE COM_PANPAR,  ONLY : LTPAN,LSPAN,IATS,ISTS                      !!! from readini
	USE COM_PLWMESH, ONLY : NPLW,GPLW                                  !!! from makeplw
	USE COM_KAPPAR,  ONLY : NPAN,NKAP,EK,EKAP                          !!! from readini
	USE COM_INDORB,  ONLY : INDLMT                                     !!! from readini
	USE COM_SPHERE,  ONLY : SWZ,SMT                                    !!! from readini
	USE COM_NBANDS,  ONLY : NBNDF,NBNDE,NBNDT,NBNDH                    !!! from readini
	USE COM_KMESH,   ONLY : NPNT,PNT                                   !!! from makettr
	USE COM_ETAPAR,  ONLY : ETA,CUT,LBAS,NBAS                          !!! from makeplw
	USE COM_TEILORG, ONLY : KEYT,BZM,GOPT,MBAS                         !!! from makeplw
	USE COM_INPTTR,  ONLY : NDIV,NDIW                                  !!! from readini
	USE COM_QMESH,   ONLY : NQPNT,QPNT                                 !!! from readpnt
	USE COM_DELPOT,  ONLY : DPOTPS,DPOTPS1                             !!! from delpot
	USE COM_MASHDEP, ONLY : NVAL                                       !!! from setup
	USE COM_PHNCHN  ,ONLY : IUDIN
	USE COM_LMTOUT,  ONLY : SCRFILE                                    !!! from setup
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: DXFUN0(:,:)
	COMPLEX*16, ALLOCATABLE :: DXFUNQ(:,:)
	COMPLEX*16, ALLOCATABLE :: DVINT0(:,:)
	COMPLEX*16, ALLOCATABLE :: DVINTQ(:,:)
	COMPLEX*16, ALLOCATABLE :: YLM0(:,:)
	COMPLEX*16, ALLOCATABLE :: CFTR0(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: YLMQ(:,:)
	COMPLEX*16, ALLOCATABLE :: CFTRQ(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: CHI0(:)
	COMPLEX*16, ALLOCATABLE :: CON0(:)
	COMPLEX*16, ALLOCATABLE :: EXP0(:)
	COMPLEX*16, ALLOCATABLE :: EXPQ(:)
	COMPLEX*16, ALLOCATABLE :: CHIQ(:)
	COMPLEX*16, ALLOCATABLE :: CONQ(:)
	COMPLEX*16, ALLOCATABLE :: EXS0(:)
	COMPLEX*16, ALLOCATABLE :: EXSQ(:)
	COMPLEX*16 DHH0,DHHQ,GMY
	DIMENSION PNTR(3),PNTK(3)
	LOGICAL EXIST
	CHARACTER STATUS*3
	DATA PI/3.141592653589793D0/
C  OPEN SCRATCH FILE FOR STORING POTENTIAL PARAMETERS
	NRECL=NVAL*(NBNDT(IPAN)*(MIN(NBAS,MBAS)+1)+
     &  NBNDT(IPAN)**2)
	INQUIRE(FILE=SCRFILE(IUDIN),EXIST=EXIST)
	IF(.NOT.EXIST)STATUS='NEW'
	IF(     EXIST)STATUS='OLD'
	OPEN(UNIT=IUDIN,FILE=SCRFILE(IUDIN),STATUS=STATUS,
     &  ACCESS='DIRECT',FORM='UNFORMATTED',RECL=NRECL)
	IF(KEYT.EQ.0)RETURN
C Memory allocations
	ALLOCATE(DXFUN0(NBNDT(IPAN),0:MBASMEM))
	ALLOCATE(DVINT0(NBNDT(IPAN),NBNDT(IPAN)))
	ALLOCATE(DXFUNQ(NBNDT(IPAN),0:MBASMEM))
	ALLOCATE(DVINTQ(NBNDT(IPAN),NBNDT(IPAN)))
	ALLOCATE(YLM0(LIMBMEM,0:NBASMEM))
	ALLOCATE(CFTR0(0:LMAXBMEM,NSORTMEM,NKAPMEM,0:NBASMEM))
	ALLOCATE(YLMQ(LIMBMEM,0:NBASMEM))
	ALLOCATE(CFTRQ(0:LMAXBMEM,NSORTMEM,NKAPMEM,0:NBASMEM))
	ALLOCATE(CHI0(0:NBASMEM))
	ALLOCATE(CON0(0:NBASMEM))
	ALLOCATE(EXP0(0:NBASMEM))
	ALLOCATE(CHIQ(0:NBASMEM))
	ALLOCATE(CONQ(0:NBASMEM))
	ALLOCATE(EXS0(0:NBASMEM))
	ALLOCATE(EXPQ(0:NBASMEM))
	ALLOCATE(EXSQ(0:NBASMEM))
	LMB=0
	DO ISORT=1,NSORT
	DO IKAP=1,NKAP(IPAN)
	DO L=0,ILSB(ISORT)
	IF(LSPAN(L,ISORT,IKAP,IPAN))LMB=MAX(L,LMB)
	ENDDO
	ENDDO
	ENDDO
C  SET PSEUDOLMTOS FOR THE POINT IPNTK
	PNTK(1)=QPNT(1,IQPNT)
	PNTK(2)=QPNT(2,IQPNT)
	PNTK(3)=QPNT(3,IQPNT)
	CALL BND_FTRMAT(PNTK,1,IPAN,PNTR,YLM0,CFTR0)
	DO IBAS=0,NBAS
	DO L=0,LMB
	DO M=-L,L
	LM=L*(L+1)+M+1
	YLMQ(LM,IBAS)=YLM0(LM,IBAS)
	ENDDO
	ENDDO
	ENDDO
	DO ISORT=1,NSORT                  !!! over isort
	DO IKAP=1,NKAP(IPAN)              !!! over ikap
	DO L=0,ILSB(ISORT)                !!! over l
	DO IBAS=0,LBAS(L,ISORT,IKAP,IPAN) !!! over ibas
	CFTRQ(L,ISORT,IKAP,IBAS)=CFTR0(L,ISORT,IKAP,IBAS)
	ENDDO                             !!! over ibas
	ENDDO                             !!! over l
	ENDDO                             !!! over ikap
	ENDDO                             !!! over isort
C  SET PSEUDOLMTOS FOR THE POINT IPNTK
	PNTK(1)=0.D0
	PNTK(2)=0.D0
	PNTK(3)=0.D0
	CALL BND_FTRMAT(PNTK,1,IPAN,PNTR,YLM0,CFTR0)
C  DO OVER SPINS
      DO 2000 IORBS=1,NORBS             !!! over iorbs
      DO 1000 IUPDN=1,NSPIN             !!! over ispin
	IF(IORBS.EQ.1)THEN
	IUPDN1=IUPDN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	SIGNF=1.D0
	ELSEIF(IORBS.EQ.2)THEN
	IUPDN1=NSPIN+1-IUPDN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	IF(ISPIN1.EQ.1.AND.ISPIN.EQ.2)SIGNF=-SQRT(2.D0) ! B^{+} * <S_{+}>
	IF(ISPIN1.EQ.2.AND.ISPIN.EQ.1)SIGNF=+SQRT(2.D0) ! B^{-} * <S_{-}>
	ENDIF
C  ####################################################
C  ORIGINAL CONVOLUTIONS OF PSEUDOORBITALS
C  ####################################################
	DO IATOM1=1,NATOM                 !!! over iatom1
	ISORT1=IS(IATOM1)
C  CALCULATE EXPONENTIAL FACTOR
	DO IBAS=0,NBAS
	SCP=(GPLW(1,IBAS)+PNTK(1))*TAU(1,IATOM1)+
     &    (GPLW(2,IBAS)+PNTK(2))*TAU(2,IATOM1)+
     &    (GPLW(3,IBAS)+PNTK(3))*TAU(3,IATOM1)
	EXP0(IBAS)=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	SCP=(GPLW(1,IBAS)+QPNT(1,IQPNT))*TAU(1,IATOM1)+
     &    (GPLW(2,IBAS)+QPNT(2,IQPNT))*TAU(2,IATOM1)+
     &    (GPLW(3,IBAS)+QPNT(3,IQPNT))*TAU(3,IATOM1)
	EXPQ(IBAS)=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	ENDDO
	DO IKAP1=1,NKAP(IPAN)             !!! over energy
	DO L1=0,ILSB(ISORT1)              !!! over l1
	DO M1=-L1,L1                      !!! over m1
	IF(.NOT.LTPAN(L1,IATOM1,IKAP1,IPAN))EXIT
	L1M1=L1*(L1+1)+M1+1
	IPAR1=INDLMT(L1M1,IATOM1,IKAP1,1,IPAN)
	DO IBAS=0,LBAS(L1,ISORT1,IKAP1,IPAN)! NG_1
C  FOURIER TRANSFORM OF THE PSEUDOORBITAL
	CHI0(IBAS)=CFTR0(L1,ISORT1,IKAP1,IBAS)*
     &  YLM0(L1M1,IBAS)*EXP0(IBAS)
	CHIQ(IBAS)=DCONJG(CFTRQ(L1,ISORT1,IKAP1,IBAS)*
     &  YLMQ(L1M1,IBAS)*EXPQ(IBAS))
	ENDDO
C  CONVOLUTION OF THE PSEUDOORBITAL WITH THE PSEUDOPOTENTIAL
      CALL BND_CONVOL1(DPOTPS1(0,IUPDN1,IORBS),CHI0(0),CON0(0),'R',
     &               0,NBAS,MBAS+1,LBAS(L1,ISORT1,IKAP1,IPAN))
      CALL BND_CONVOL1(DPOTPS1(0,IUPDN1,IORBS),CHIQ(0),CONQ(0),'L',
     &               0,NBAS,MBAS+1,LBAS(L1,ISORT1,IKAP1,IPAN))
	DO IBAS=0,MIN(NBAS,MBAS)          !!! NGMAX{small}
	DXFUN0(IPAR1,IBAS)=CON0(IBAS)*SIGNF     !!! dX0/d{t1m1}
	DXFUNQ(IPAR1,IBAS)=CONQ(IBAS)*SIGNF     !!! dYq/d{t1m1}
	ENDDO
C  DO OVER RIGHT INDEX
	DO IATOM=1,NATOM                  !!! over iatom
	ISORT=IS(IATOM)
C  CALCULATE EXPONENTIAL FACTOR
	DO IBAS=0,NBAS                    !!! NGMAX{large}
	SCP=(GPLW(1,IBAS)+PNTK(1))*TAU(1,IATOM)+
     &    (GPLW(2,IBAS)+PNTK(2))*TAU(2,IATOM)+
     &    (GPLW(3,IBAS)+PNTK(3))*TAU(3,IATOM)
	EXS0(IBAS)=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	ENDDO
	DO IKAP=1,NKAP(IPAN)              !!! over energy
	DO L=0,ILSB(ISORT)                !!! over l
	DO M=-L,L                         !!! over m
	IF(.NOT.LTPAN(L,IATOM,IKAP,IPAN))EXIT
	LM=L*(L+1)+M+1
	IPAR=INDLMT(LM,IATOM,IKAP,1,IPAN)
C  FOURIER TRANSFORM OF THE PSEUDOORBITAL
	DO IBAS=MBAS+1,LBAS(L,ISORT,IKAP,IPAN)  !!! NG_0{large}
	CHI0(IBAS)=CFTR0(L,ISORT,IKAP,IBAS)*YLM0(LM,IBAS)*EXS0(IBAS)
	ENDDO
C  ******** PSEUDOPOTENTIAL MATRIX ************
C     CONTRIBUTION FROM LARGE G, K-DEPENDENCE BY TEILOR WILL BE USED
	DHH0=(0.D0,0.D0)
	DO IBAS=MBAS+1,LBAS(L,ISORT,IKAP,IPAN)  !!! NG_0{large}
	DHH0=DHH0+CONQ(IBAS)*CHI0(IBAS)         !!! dV/d{t1m1}
	ENDDO
	DVINT0(IPAR1,IPAR)=DHH0*SIGNF     !!! the hamiltonian
	ENDDO                             !!! over m
	ENDDO                             !!! over l
	ENDDO                             !!! over energy
	ENDDO                             !!! over iatom
	ENDDO                             !!! over m1
	ENDDO                             !!! over l1
	ENDDO                             !!! over energy
	ENDDO                             !!! over iatom1
C  STORE DATA
	IREC=1+2*(IUPDN-1)+2*NSPIN*(IORBS-1)
	WRITE(IUDIN,REC=IREC)((DVINT0(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DXFUN0(IPAR1,
     &  IBAS),IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
	IREC=2+2*(IUPDN-1)+2*NSPIN*(IORBS-1)
	WRITE(IUDIN,REC=IREC)((DVINT0(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DXFUNQ(IPAR1,
     &  IBAS),IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
 1000 CONTINUE                          !!! over ispin
 2000 CONTINUE                          !!! over iorbs
C Memory allocations
	DEALLOCATE(DXFUN0,DXFUNQ,DVINT0,DVINTQ,CFTR0,YLM0,CFTRQ,YLMQ)
	DEALLOCATE(CHI0,CON0,EXP0,CHIQ,CONQ,EXS0,EXPQ,EXSQ)
	END
