	SUBROUTINE PLZ_SPLSSYM(IQPNT)
********************************************************
*  Symmetrizes change in pseudocharge density.         *
********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
      USE COM_PHNCOM,  ONLY : ITERMAX,NITER                              !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
      USE COM_PLWMESH, ONLY : NPLW,GPLW,KVEC,KGMIN,KGMAX,INDG            !!! from makeplw
	USE COM_LATTICE, ONLY : RBAS,GBAS,TAU                              !!! from readstr
	USE COM_SPHERE,  ONLY : SWZ,SMT                                    !!! from readini
	USE COM_DELRHO,  ONLY : DRHOPS                                     !!! from delrho
	USE COM_GROUPS,  ONLY : NGROUP,U,SJ,IP,RDC,SHIFT,INV,IKOV          !!! from makegrp
	USE COM_SUBGROUP,ONLY : NSGQ,NGEQ,ISG                              !!! from delmesh
      USE COM_PLZCOM,  ONLY : NPLZ,LPLZ,IPLZ,NPTB,QPTB,INDPTB,INPTBR     !!! from readlrt
	USE COM_QMESH,   ONLY : NQPNT,QPNT                                 !!! from readpnt
	USE COM_MASHDEP, ONLY : NVAL                                       !!! from setup
	USE COM_PHNCHN  ,ONLY : IUPLS,IUPSY                                !!! from channels
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: SRHOPS(:,:,:)
	COMPLEX*16 PHSQ,EXPGR,EXPQR
	DIMENSION QPNT0(3)
      DATA PI/3.141592653589793D0/
C Memory allocations
      ALLOCATE(SRHOPS(0:NPLWMEM,NSPINMEM,NORBSMEM))
C *** DO GLOBALLY OVER PERTURBATION VECTORS ***
      DO 2000 IPTB=1,NPTB                  !!! over {q+G}-vectors
      CALL PLZ_PLSFILES(IPTB,IQPNT,IUPLS,'I',' ') !!! initialize file
	DO IORBS=1,NORBS
	DO IUPDN=1,NSPIN
	DO IPLW=0,NPLW
	SRHOPS(IPLW,IUPDN,IORBS)=(0.D0,0.D0)
	ENDDO
	ENDDO
	ENDDO
	GPTBX=QPTB(1,IPTB)-QPNT(1,IQPNT)
	GPTBY=QPTB(2,IPTB)-QPNT(2,IQPNT)
	GPTBZ=QPTB(3,IPTB)-QPNT(3,IQPNT)
C  DO OVER GROUP OF THE WAVEVECTOR Q
      DO 1000 IGEQ=1,NGEQ                  !!! over group of q-vector
      IR=ISG(IGEQ,1)                       !!! element "g" in the main G-list
      IG=IKOV(IR)                          !!! element "g" after Kovalev
      IPTBR=INPTBR(IGEQ,IPTB)              !!! q+Gr=q+gamma^{-1}G
      CALL PLZ_PLSFILES(IPTBR,IQPNT,IUPSY,'R',' ') !!! read unsymmetrized pi(r){q+Gr}
C  *** SYMMETRIZE INDUCED PSEUDODENSITY ***
	DO IORBS=1,NORBS                     !!! over spins
	DO IUPDN=1,NSPIN                     !!! over spins
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	SIGNI=1.D0
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	IF(ISPIN1.EQ.1.AND.ISPIN.EQ.2)SIGNI=+SQRT(2.D0) ! M^{-}=<S^{-}>=-<S_{+}>
	IF(ISPIN1.EQ.2.AND.ISPIN.EQ.1)SIGNI=-SQRT(2.D0) ! M^{+}=<S^{+}>=-<S_{-}>
	ENDIF
	DO JORBS=1,NORBS
	DO JUPDN=1,NSPIN
	IF(NORBS.EQ.1.AND.IUPDN.NE.JUPDN)CYCLE
	IF(JORBS.EQ.1)THEN
	JSPIN1=JUPDN
	JSPIN =JUPDN
	SIGNJ=1.D0
	ELSEIF(JORBS.EQ.2)THEN
	JSPIN1=JUPDN
	JSPIN =NSPIN+1-JUPDN
	IF(JSPIN1.EQ.1.AND.JSPIN.EQ.2)SIGNJ=+SQRT(2.D0) ! M^{-}=<S^{-}>=-<S_{+}>
	IF(JSPIN1.EQ.2.AND.JSPIN.EQ.1)SIGNJ=-SQRT(2.D0) ! M^{+}=<S^{+}>=-<S_{-}>
	ENDIF
      DO IPLW=0,NPLW                       !!! over iplw
C  RECIPROCAL LATTICE VECTOR IS GIVEN BY
      GX=GPLW(1,IPLW)
      GY=GPLW(2,IPLW)
      GZ=GPLW(3,IPLW)
C  APPLY SYMMETRY OPERATION
      CALL LIB_ROTATE(GX,GY,GZ,GRX,GRY,GRZ,U(2,IG),1)
C  GET COORDINATES IN G1,G2,G3
      X1R=GRX*RBAS(1,1)+GRY*RBAS(2,1)+GRZ*RBAS(3,1)
      X2R=GRX*RBAS(1,2)+GRY*RBAS(2,2)+GRZ*RBAS(3,2)
      X3R=GRX*RBAS(1,3)+GRY*RBAS(2,3)+GRZ*RBAS(3,3)
      M1R=ANINT(X1R)
      M2R=ANINT(X2R)
      M3R=ANINT(X3R)
      IF(ABS(DBLE(M1R)-X1R).GE.1.D-10.OR.
     &   ABS(DBLE(M2R)-X2R).GE.1.D-10.OR.
     &   ABS(DBLE(M3R)-X3R).GE.1.D-10)
     &CALL FULLSTOP('<PLSSYM>: WRONG VECTOR')
      IDIM=1+M1R-KGMIN(1)+(KGMAX(1)-KGMIN(1)+1)*(M2R-KGMIN(2))+
     &  (KGMAX(1)-KGMIN(1)+1)*(KGMAX(2)-KGMIN(2)+1)*(M3R-KGMIN(3))
        IPLWR=INDG(IDIM)
      IF(IPLWR.EQ.-1)CALL FULLSTOP('<PLSSYM>:: ERROR IN IPLWR')
      SCP=(GX-GPTBX)*SHIFT(1,IR)+
     &    (GY-GPTBY)*SHIFT(2,IR)+
     &    (GZ-GPTBZ)*SHIFT(3,IR)
      EXPGR=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
C  SYMMETRIZE CHARGE DENSITY
      SRHOPS(IPLW,IUPDN,IORBS)=SRHOPS(IPLW,IUPDN,IORBS)+
     &DRHOPS(IPLWR,JUPDN,JORBS)*EXPGR*SIGNI/SIGNJ*
     &DCONJG(SJ(ISPIN1,JSPIN1,IR))*SJ(ISPIN,JSPIN,IR)
      ENDDO                                !!! over plane waves
	ENDDO                                !!! over jupdn
	ENDDO                                !!! over jorbs
	ENDDO                                !!! over iupdn
	ENDDO                                !!! over iorbs
1000  CONTINUE                             !!! over group of vector q
C  NORMALIZATION
	DO IORBS=1,NORBS
	DO IUPDN=1,NSPIN
	DO IPLW=0,NPLW
	DRHOPS(IPLW,IUPDN,IORBS)=SRHOPS(IPLW,IUPDN,IORBS)/DBLE(NGEQ)
	ENDDO
	ENDDO
	ENDDO
C  SYMMETRIZATION IS DONE, WRITE PLSFILE
      CALL PLZ_PLSFILES(IPTB,IQPNT,IUPLS,'W',' ')
2000  CONTINUE                             !!! over {q+G}-vectors
C  DELETE SCRATCH FILES
      DO IPTB=1,NPTB
      CALL PLZ_PLSFILES(IPTB,IQPNT,IUPSY,'D',' ')
      ENDDO
	DEALLOCATE(SRHOPS)
	END
