        SUBROUTINE PLZ_PLWCRD(IQPNT)
***********************************************************
*  Generates coordination spheres in reciprocal space     *
*  for using in polarizability calculation.               *
*  Last revison 21.10.96.                                 *
***********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT                                       !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_LATPAR,  ONLY : PAR,ORTH,OMEGAC                            !!! from readini
      USE COM_PLWMESH, ONLY : NPLW,GPLW,KVEC,KGMIN,KGMAX,INDG            !!! from makeplw
      USE COM_ACCURG,  ONLY : EPSR,EPSG,ECUTG                            !!! from readini
	USE COM_LATTICE, ONLY : RBAS,GBAS,TAU                              !!! from readstr
	USE COM_SPHERE,  ONLY : SWZ,SMT                                    !!! from readini
      USE COM_FFTMESH, ONLY : NFFTG                                      !!! from readini
	USE COM_GROUPS,  ONLY : NGROUP,U,IP,RDC,SHIFT,INV,IKOV             !!! from makegrp
      USE COM_PLZCOM,  ONLY : NPLZ,LPLZ,IPLZ,NPTB,QPTB,INDPTB,INPTBR     !!! from readlrt
	USE COM_QMESH,   ONLY : NQPNT,QPNT                                 !!! from readpnt
	USE COM_SUBGROUP,ONLY : NSGQ,NGEQ,ISG                              !!! from delmesh
	USE COM_MASHDEP, ONLY : NVAL                                       !!! from setup
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
      IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER, ALLOCATABLE :: INDRSH(:)
      DIMENSION GL(3)
	LOGICAL EXIST
      DATA PI/3.141592653589793D0/
C Memory allocations for main control arrays
	ALLOCATE(QPTB(3,NENVMEM))
	ALLOCATE(INDPTB(NENVMEM))
	ALLOCATE(INPTBR(NOPRMEM,NENVMEM))
C  SET INDICATOR ARRAY TO ZERO
	ALLOCATE(INDRSH(0:NPLWMEM))
      DO 10 IPLW=0,NPLW
      INDRSH(IPLW)=0
  10  CONTINUE
	NRSH=LPLZ-1
	GPLZ=SQRT(QPNT(1,IQPNT)**2+QPNT(2,IQPNT)**2+QPNT(3,IQPNT)**2)
      IRSH=0
C  DO OVER PLANE WAVES
      DO 30 IPLW=1,NPLW                           !!! over iplw
      IF(INDRSH(IPLW).NE.0)GOTO30
      IRSH=IRSH+1
C  RECIPROCAL LATTICE VECTOR IS GIVEN BY
      GX=GPLW(1,IPLW)
      GY=GPLW(2,IPLW)
      GZ=GPLW(3,IPLW)
      GRSH=SQRT(GPLW(1,IPLW)**2+GPLW(2,IPLW)**2+GPLW(3,IPLW)**2)
      IF(IRSH.EQ.NRSH)GPLZ=GRSH
      DO 20 IR=1,NGROUP                           !!! over point group
C  APPLY SYMMETRY OPERATION
      IG=IKOV(IR)
      CALL LIB_ROTATE(GX,GY,GZ,GRX,GRY,GRZ,U(2,IG),2)
C  GET COORDINATES IN G1,G2,G3
      X1R=GRX*RBAS(1,1)+GRY*RBAS(2,1)+GRZ*RBAS(3,1)
      X2R=GRX*RBAS(1,2)+GRY*RBAS(2,2)+GRZ*RBAS(3,2)
      X3R=GRX*RBAS(1,3)+GRY*RBAS(2,3)+GRZ*RBAS(3,3)
      M1R=ANINT(X1R)
      M2R=ANINT(X2R)
      M3R=ANINT(X3R)
      IF(ABS(DBLE(M1R)-X1R).GE.1.D-10.OR.
     &   ABS(DBLE(M2R)-X2R).GE.1.D-10.OR.
     &   ABS(DBLE(M3R)-X3R).GE.1.D-10)
     &CALL FULLSTOP('<PLWCRD>: WRONG VECTOR')
      IDIM=1+M1R-KGMIN(1)+(KGMAX(1)-KGMIN(1)+1)*(M2R-KGMIN(2))+
     &  (KGMAX(1)-KGMIN(1)+1)*(KGMAX(2)-KGMIN(2)+1)*(M3R-KGMIN(3))
      IPLWR=INDG(IDIM)
      IF(IPLWR.EQ.-1)
     &CALL FULLSTOP('<PLWCRD>:: ERROR IN IPLWR')
      INDRSH(IPLWR)=IRSH
  20  CONTINUE                                     !!! over group
  30  CONTINUE                                     !!! over iplw
	GPLZ=GPLZ+1.D-10
      NRSHTOT=IRSH                                 !!! total # of shells
C  SET PERTURBATION VECTORS
	IPTB=0
	DO 40 IPLW=0,NPLW                            !!! over iplw
	PTBX=QPNT(1,IQPNT)+GPLW(1,IPLW)
	PTBY=QPNT(2,IQPNT)+GPLW(2,IPLW)
	PTBZ=QPNT(3,IQPNT)+GPLW(3,IPLW)
	GPTB=SQRT(PTBX**2+PTBY**2+PTBZ**2)
	IF(GPTB.GT.GPLZ)GOTO40
	IPTB=IPTB+1
	IF(IPTB.GT.NENVMEM)
     &CALL FULLSTOP('<PLWCRD>: IPTB.GT.NENVMEM')
	QPTB(1,IPTB)=PTBX
	QPTB(2,IPTB)=PTBY
	QPTB(3,IPTB)=PTBZ
	INDPTB(IPTB)=IPLW
  40	CONTINUE                                     !!! over iplw
	NPTB=IPTB
C  SORT VECTORS ACCORDING THE GROUP OF VECTOR Q
	DO 70 IPTB=1,NPTB                            !!! over g-vectors
	GX=QPTB(1,IPTB)-QPNT(1,IQPNT)
	GY=QPTB(2,IPTB)-QPNT(2,IQPNT)
	GZ=QPTB(3,IPTB)-QPNT(3,IQPNT)
      DO 60 IGEQ=1,NGEQ                            !!! over group of q
C  APPLY INVERSIONAL SYMMETRY OPERATION
      IR=ISG(IGEQ,1)                       !!! element "g" in the main G-list
      IG=IKOV(IR)                          !!! element "g" after Kovalev
      CALL LIB_ROTATE(GX,GY,GZ,GRX,GRY,GRZ,U(2,IG),1)
C  GET COORDINATES IN G1,G2,G3
      X1R=GRX*RBAS(1,1)+GRY*RBAS(2,1)+GRZ*RBAS(3,1)
      X2R=GRX*RBAS(1,2)+GRY*RBAS(2,2)+GRZ*RBAS(3,2)
      X3R=GRX*RBAS(1,3)+GRY*RBAS(2,3)+GRZ*RBAS(3,3)
      M1R=ANINT(X1R)
      M2R=ANINT(X2R)
      M3R=ANINT(X3R)
      IF(ABS(DBLE(M1R)-X1R).GE.1.D-10.OR.
     &   ABS(DBLE(M2R)-X2R).GE.1.D-10.OR.
     &   ABS(DBLE(M3R)-X3R).GE.1.D-10)
     &CALL FULLSTOP('<PLWCRD>: WRONG VECTOR')
      IDIM=1+M1R-KGMIN(1)+(KGMAX(1)-KGMIN(1)+1)*(M2R-KGMIN(2))+
     &  (KGMAX(1)-KGMIN(1)+1)*(KGMAX(2)-KGMIN(2)+1)*(M3R-KGMIN(3))
      IPLWR=INDG(IDIM)
      IF(IPLWR.EQ.-1)
     &CALL FULLSTOP('<PLWCRD>:: ERROR IN IPLWR')
	IPTBR=0
	DO 50 JPTB=1,NPTB
	IF(INDPTB(JPTB).EQ.IPLWR)IPTBR=JPTB
  50	CONTINUE
	IF(IPTBR.EQ.0)
     &CALL FULLSTOP('<PLWCRD>:: ERROR IN ROTATING G-VECTORS')
	INPTBR(IGEQ,IPTB)=IPTBR                     !!! gamma^{-1}G=GR
  60	CONTINUE                                    !!! over group of q
  70	CONTINUE                                    !!! over g-vectors
C  PRINT OUT PERTURBATION VECTORS
	WRITE(IUN,1010)NPTB
      WRITE(IUN,1020)
      DO 100 IPTB=1,NPTB
	PTBX=QPTB(1,IPTB)
	PTBY=QPTB(2,IPTB)
	PTBZ=QPTB(3,IPTB)
	GPTB=SQRT(PTBX**2+PTBY**2+PTBZ**2)
	NCT=0
	DO 90 JPTB=1,NPTB
	NT=0
	DO 80 IGEQ=1,NGEQ
	IF(INPTBR(IGEQ,IPTB).EQ.JPTB)NT=NT+1
  80	CONTINUE
	IF(NT.GT.0)NT=1
	NCT=NCT+NT
  90	CONTINUE
      WRITE(IUN,1030)QPTB(1,IPTB),QPTB(2,IPTB),QPTB(3,IPTB),GPTB,NCT
 100  CONTINUE
C  PRINT COORDINATION SPHERES IN RECIPROCAL SPACE
	WRITE(IUN,1040)
	DO 120 IRSH=1,MIN(LPLZ+4,NRSHTOT)
	IPWS=0
	DO 110 IPLW=1,NPLW
	IF(INDRSH(IPLW).EQ.IRSH)THEN
	PX=GPLW(1,IPLW)
	PY=GPLW(2,IPLW)
	PZ=GPLW(3,IPLW)
	GP=SQRT(PX**2+PY**2+PZ**2)
	IPWS=IPWS+1
	ENDIF
 110	CONTINUE
	WRITE(IUN,1050)IRSH,GP,IPWS
 120	CONTINUE
1010	FORMAT(1X,'Calculation of polarizability, # of vectors:',I3)
1020  FORMAT(1X,'    {q+G}x       {q+G}y       {q+G}z         |q+G|',
     &  8X,'DeG')
1030  FORMAT(1X,'(',G12.5,',',G12.5,',',G12.5,')',2X,G12.5,2X,I4)
1040	FORMAT(1X,'Calculation of shells in reciprocal lattice:')
1050	FORMAT(1X,I2,'th: |G| = ',G14.7,' ; # of vectors = ',I3)
      DEALLOCATE(INDRSH)
      END
