	SUBROUTINE PLZ_SPLZEND(IPTB,IPAN,IQPNT)
***********************************************************
*  Makes final pseudodensity by adding LS,SL and LL terms.*
***********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
	USE COM_PLWMESH, ONLY : NPLW,GPLW                                  !!! from makeplw
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_LATTICE, ONLY : TAU                                        !!! from readstr
	USE COM_LATPAR,  ONLY : PAR,ORTH,OMEGAC                            !!! from readini
	USE COM_KAPPAR,  ONLY : NPAN,NKAP,EK,EKAP                          !!! from readini
	USE COM_PANPAR,  ONLY : LTPAN,LSPAN,IATS,ISTS                      !!! from readini
	USE COM_NBANDS,  ONLY : NBNDF,NBNDE,NBNDT,NBNDC,NBNDH              !!! from readini
	USE COM_ETAPAR,  ONLY : ETA,CUT,LBAS,NBAS                          !!! from makeplw
	USE COM_KMESH,   ONLY : NPNT,PNT                                   !!! from makettr
	USE COM_INDORB,  ONLY : INDLMT                                     !!! from readini
	USE COM_INPTTR,  ONLY : NDIV,NDIW                                  !!! from readini
	USE COM_QMESH,   ONLY : NQPNT,QPNT                                 !!! from readpnt
	USE COM_SPHERE,  ONLY : SWZ,SMT                                    !!! from readini
	USE COM_MASHDEP, ONLY : NVAL                                       !!! from setup
	USE COM_DELRHO,  ONLY : DRHOPS                                     !!! from delrho
	USE COM_TEILORG, ONLY : KEYT,BZM,GOPT,MBAS                         !!! from makeplw
	USE COM_PHNCHN  ,ONLY : IUPSY,IUPDD                                !!! from channels
	USE COM_LMTOUT,  ONLY : SCRFILE                                    !!! from setup
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: DRFUN0(:,:)
	COMPLEX*16, ALLOCATABLE :: DRFUNQ(:,:)
	COMPLEX*16, ALLOCATABLE :: DRINT0Q(:,:)
	COMPLEX*16, ALLOCATABLE :: YLM0(:,:)
	COMPLEX*16, ALLOCATABLE :: CFTR0(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: YLMQ(:,:)
	COMPLEX*16, ALLOCATABLE :: CFTRQ(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: EXP0(:)
	COMPLEX*16, ALLOCATABLE :: CHI0(:)
	COMPLEX*16, ALLOCATABLE :: EXS0(:)
	COMPLEX*16, ALLOCATABLE :: EXPQ(:)
	COMPLEX*16, ALLOCATABLE :: CHIQ(:)
	COMPLEX*16, ALLOCATABLE :: EXSQ(:)
	COMPLEX*16, ALLOCATABLE :: DCON(:)
	COMPLEX*16, ALLOCATABLE :: CHIS(:)
	DIMENSION PNTR(3),PNTK(3)
	DATA PI/3.141592653589793D0/
	IF(KEYT.EQ.0)RETURN
	IF(MODE.EQ.5)RETURN
C Memory allocations
	ALLOCATE(DRFUN0(NBNDT(IPAN),0:MBASMEM))
	ALLOCATE(DRINT0Q(NBNDT(IPAN),NBNDT(IPAN)))
	ALLOCATE(DRFUNQ(NBNDT(IPAN),0:MBASMEM))
	ALLOCATE(YLM0(LIMBMEM,0:NBASMEM))
	ALLOCATE(CFTR0(0:LMAXBMEM,NSORTMEM,NKAPMEM,0:NBASMEM))
	ALLOCATE(YLMQ(LIMBMEM,0:NBASMEM))
	ALLOCATE(CFTRQ(0:LMAXBMEM,NSORTMEM,NKAPMEM,0:NBASMEM))
	ALLOCATE(EXP0(0:NBASMEM))
	ALLOCATE(CHI0(0:NBASMEM))
	ALLOCATE(EXS0(0:NBASMEM))
	ALLOCATE(EXPQ(0:NBASMEM))
	ALLOCATE(CHIQ(0:NBASMEM))
	ALLOCATE(EXSQ(0:NBASMEM))
	ALLOCATE(DCON(0:NBASMEM))
	ALLOCATE(CHIS(0:NBASMEM))
	LMB=0
	DO ISORT=1,NSORT
	DO IKAP=1,NKAP(IPAN)
	DO L=0,ILSB(ISORT)
	IF(LSPAN(L,ISORT,IKAP,IPAN))LMB=MAX(L,LMB)
	ENDDO
	ENDDO
	ENDDO
C  SET PSEUDOLMTOS FOR THE POINT IPNTK
	PNTK(1)=QPNT(1,IQPNT)
	PNTK(2)=QPNT(2,IQPNT)
	PNTK(3)=QPNT(3,IQPNT)
	CALL BND_FTRMAT(PNTK,1,IPAN,PNTR,YLM0,CFTR0)
	DO IBAS=0,NBAS
	DO L=0,LMB
	DO M=-L,L
	LM=L*(L+1)+M+1
	YLMQ(LM,IBAS)=YLM0(LM,IBAS)
	ENDDO
	ENDDO
	ENDDO
	DO ISORT=1,NSORT                  !!! over isort
	DO IKAP=1,NKAP(IPAN)              !!! over ikap
	DO L=0,ILSB(ISORT)                !!! over l
	DO IBAS=0,LBAS(L,ISORT,IKAP,IPAN) !!! over ibas
	CFTRQ(L,ISORT,IKAP,IBAS)=CFTR0(L,ISORT,IKAP,IBAS)
	ENDDO                             !!! over ibas
	ENDDO                             !!! over l
	ENDDO                             !!! over ikap
	ENDDO                             !!! over isort
C  SET PSEUDOLMTOS FOR THE POINT IPNTK
	PNTK(1)=0.D0
	PNTK(2)=0.D0
	PNTK(3)=0.D0
	CALL BND_FTRMAT(PNTK,1,IPAN,PNTR,YLM0,CFTR0)
C  READ DENSITY
      CALL PLZ_PLSFILES(IPTB,IQPNT,IUPSY,'R',' ') !!! read pseudo-pi_q(r)
C  DO OVER SPINS
	DO 6000 IORBS=1,NORBS                                     !!! over iorbs
	DO 5000 IUPDN=1,NSPIN                                     !!! over iupdn
 	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
C  READ DENSITY PARAMETERS
	IREC=IUPDN+NSPIN*(IORBS-1)
	READ(IUPDD,REC=IREC)((DRINT0Q(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((DRFUN0(IPAR1,
     &  IBAS),IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS)),
     &  ((DRFUNQ(IPAR1,IBAS),IPAR1=1,NBNDT(IPAN)),IBAS=0,
     &  MIN(NBAS,MBAS))
C  DO OVER LEFT INDEX
	DO 4000 IATOM1=1,NATOM                      !!! over iatom1
	ISORT1=IS(IATOM1)
C  CALCULATE EXPONENTIAL FACTOR
	DO IBAS=0,NBAS
	SCP=(GPLW(1,IBAS)+PNTK(1))*TAU(1,IATOM1)+
     &    (GPLW(2,IBAS)+PNTK(2))*TAU(2,IATOM1)+
     &    (GPLW(3,IBAS)+PNTK(3))*TAU(3,IATOM1)
	EXP0(IBAS)=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	SCP=(GPLW(1,IBAS)+QPNT(1,IQPNT))*TAU(1,IATOM1)+
     &    (GPLW(2,IBAS)+QPNT(2,IQPNT))*TAU(2,IATOM1)+
     &    (GPLW(3,IBAS)+QPNT(3,IQPNT))*TAU(3,IATOM1)
	EXPQ(IBAS)=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	ENDDO
	DO 3000 IKAP1=1,NKAP(IPAN)                  !!! over energy
	DO 2000 L1=0,ILSB(ISORT1)                   !!! over l1
	DO 1000 M1=-L1,L1                           !!! over m1
	IF(.NOT.LTPAN(L1,IATOM1,IKAP1,IPAN))EXIT
	L1M1=L1*(L1+1)+M1+1
	IPAR1=INDLMT(L1M1,IATOM1,IKAP1,1,IPAN)
C  FOURIER TRANSFORM OF THE PSEUDOORBITAL
	DO IBAS=MBAS+1,LBAS(L1,ISORT1,IKAP1,IPAN)   !!! NG_1{large}
	CHI0(IBAS)=DCONJG(CFTR0(L1,ISORT1,IKAP1,IBAS)*
     &  YLM0(L1M1,IBAS)*EXP0(IBAS))
	CHIQ(IBAS)=CFTRQ(L1,ISORT1,IKAP1,IBAS)*
     &  YLMQ(L1M1,IBAS)*EXPQ(IBAS)
	ENDDO
C  FOURIER TRANSFORM OF THE PSEUDOCHARGE DENSITY
C  LS CONTRIBUTION
      DO JBAS=0,MIN(NBAS,MBAS)
      CHIS(JBAS)=DRFUN0(IPAR1,JBAS)
      ENDDO
      CALL BND_CONVOL2(DRHOPS(0,IUPDN,IORBS),CHIS(0),CHIQ(0),'P',
     &  0,MIN(NBAS,MBAS),MBAS+1,LBAS(L1,ISORT1,IKAP1,IPAN))
C  SL CONTRIBUTION
      DO IBAS=0,MIN(NBAS,MBAS)
      CHIS(IBAS)=DRFUNQ(IPAR1,IBAS)
      ENDDO
      CALL BND_CONVOL2(DRHOPS(0,IUPDN,IORBS),CHI0(0),CHIS(0),'P',
     &  MBAS+1,LBAS(L1,ISORT1,IKAP1,IPAN),0,MIN(NBAS,MBAS))
C  SET CONVOLUTION OF PSEUDOORBITAL WITH TOS-MATRIX
	DO IBAS=0,NBAS
	DCON(IBAS)=(0.D0,0.D0)
	ENDDO
	DO IATOM=1,NATOM                           !!! over iatom
	ISORT=IS(IATOM)
C  CALCULATE EXPONENTIAL FACTOR
	DO IBAS=0,NBAS                             !!! NGMAX{large}
	SCP=(GPLW(1,IBAS)+QPNT(1,IQPNT))*TAU(1,IATOM)+
     &    (GPLW(2,IBAS)+QPNT(2,IQPNT))*TAU(2,IATOM)+
     &    (GPLW(3,IBAS)+QPNT(3,IQPNT))*TAU(3,IATOM)
	EXSQ(IBAS)=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	ENDDO
	DO IKAP=1,NKAP(IPAN)                       !!! over energy
	DO L=0,ILSB(ISORT)                         !!! over l
	DO M=-L,L                                  !!! over m
	IF(.NOT.LTPAN(L,IATOM,IKAP,IPAN))EXIT
	LM=L*(L+1)+M+1
	IPAR=INDLMT(LM,IATOM,IKAP,1,IPAN)
C  FOURIER TRANSFORM OF THE PSEUDOORBITAL
	DO IBAS=MBAS+1,LBAS(L,ISORT,IKAP,IPAN)     !!! NG{large}
	CHIQ(IBAS)=CFTRQ(L,ISORT,IKAP,IBAS)*
     &  YLMQ(LM,IBAS)*EXSQ(IBAS)
	ENDDO
C  CONVOLUTION
	DO IBAS=MBAS+1,LBAS(L,ISORT,IKAP,IPAN)
	DCON(IBAS)=DCON(IBAS)+DRINT0Q(IPAR1,IPAR)*CHIQ(IBAS)
	ENDDO
	ENDDO                                      !!! over m
	ENDDO                                      !!! over l
	ENDDO                                      !!! over energy
	ENDDO                                      !!! over iatom
C  4) LARGE-LARGE G CONTRIBUTION
      CALL BND_CONVOL2(DRHOPS(0,IUPDN,IORBS), CHI0(0),DCON(0),'P',
     &  MBAS+1,LBAS(L1,ISORT1,IKAP1,IPAN),MBAS+1,NBAS)
 1000 CONTINUE                                   !!! over m1
 2000 CONTINUE                                   !!! over l1
 3000 CONTINUE                                   !!! over energy
 4000 CONTINUE                                   !!! over iatom1
 5000 CONTINUE                                   !!! over iupdn
 6000 CONTINUE                                   !!! over iorbs
C  STORE POLARIZABILITY
      CALL PLZ_PLSFILES(IPTB,IQPNT,IUPSY,'W',' ')!!! read pseudo-pi_q(r)
C Memory deallocations
	DEALLOCATE(DRFUN0,DRINT0Q,DRFUNQ,EXP0,CHI0,EXS0,EXPQ)
	DEALLOCATE(CHIQ,EXSQ,DCON,CHIS)
	DEALLOCATE(CFTR0,YLM0,CFTRQ,YLMQ)
	END
