	SUBROUTINE PLZ_PLZFILES(IPTB,IQPNT,ICHN,FOPER,AOPER)
********************************************************
* Reads/Writes/Initializes polarizability function     *
* within MT-spheres according to FOPER='R','W','I','D' *
********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_RADMESH, ONLY : NRAD,H,R                                   !!! from makerad
	USE COM_QMESH,   ONLY : NQPNT,QPNT                                 !!! from readpnt
      USE COM_PLZCOM,  ONLY : NPLZ,LPLZ,IPLZ,NPTB,QPTB,INDPTB            !!! from readlrt
      USE COM_DELRHO,  ONLY : DRHO                                       !!! from delrho
	USE COM_SPHERE,  ONLY : SWZ,SMT                                    !!! from readini
      USE COM_DELHUB,  ONLY : DELGHUB                                    !!! from plzfiles
	USE COM_MASHDEP, ONLY : NVAL                                       !!! from setup
      USE COM_OLDMESH, ONLY : NRAD0,ROLD                                 !!! from drofiles
	USE COM_PHNCHN  ,ONLY : IUPLZ                                      !!! from channels
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	USE COM_LMTOUT
	USE COM_PHNOUT
	IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER, ALLOCATABLE :: ILSV0(:)
	LOGICAL EXIST,LDRHO,NDRHO
	CHARACTER TDRHO*1,FOPER*1,AOPER*1,STATUS*3,DFILE*130
	DIMENSION QPTB0(3)
	IF(FOPER.NE.' ')THEN
      IF(ICHN.NE.IUPLZ)DFILE=SCPFILE(IPTB,ICHN)
      IF(ICHN.EQ.IUPLZ)DFILE=PLZFILE(IPTB)
      INQUIRE(FILE=DFILE,EXIST=EXIST)
      IF(.NOT.EXIST)STATUS='NEW'
      IF(     EXIST)STATUS='OLD'
	ENDIF
C Allocate data
	IF(AOPER.EQ.'A')THEN
	ALLOCATE(DRHO(0:NRADMEM,LIMVMEM,NATOMMEM,NSPINMEM,NORBSMEM))
	ALLOCATE(DELGHUB(LIMB2MEM,NATOMMEM,NSPINMEM,NORBSMEM))
	IF(.NOT.ALLOCATED(ROLD))ALLOCATE(ROLD(0:NRADMEM,NSORTMEM))
	IF(.NOT.ALLOCATED(NRAD0))ALLOCATE(NRAD0(NSORTMEM))
	ENDIF
C *** DELETE FILE
      IF(FOPER.EQ.'D')THEN
      OPEN(UNIT=ICHN,FILE=DFILE,STATUS=STATUS,
     &FORM='UNFORMATTED',ACCESS='SEQUENTIAL')
      CLOSE(UNIT=ICHN,STATUS='DELETE')
      RETURN
      ENDIF
	ALLOCATE(ILSV0(NSORTMEM))
C *** READ DATA FROM PLZFILE OR SCPFILE
      IF(FOPER.EQ.'R')THEN
      IF(.NOT.EXIST)
     &CALL FULLSTOP('<PLZFILES>: FILE MUST EXIST!')
      OPEN(UNIT=ICHN,FILE=DFILE,STATUS='OLD',
     &  FORM='UNFORMATTED',ACCESS='SEQUENTIAL')
C Read control information:
	READ(ICHN)NATOM0,NSORT0,NSPIN0,NORBS0,
     &(NRAD0(ISORT),ISORT=1,NSORT0),
     &(ILSV0(ISORT),ISORT=1,NSORT0),(QPTB0(I),I=1,3)
      READ(ICHN)((ROLD(IRAD,ISORT),IRAD=0,NRAD0(ISORT)),ISORT=1,NSORT)
      IF(NATOM0.NE.NATOM)
     &CALL FULLSTOP('<PLZFILES>: # OF ATOMS MISMATCH')
      IF(NSORT0.NE.NSORT)
     &CALL FULLSTOP('<PLZFILES>: # OF SORTS MISMATCH')
      IF(NSPIN0.NE.NSPIN)
     &CALL FULLSTOP('<PLZFILES>: # OF SPINS MISMATCH')
      IF(NORBS0.NE.NORBS)
     &CALL FULLSTOP('<PLZFILES>: # OF NORBS MISMATCH')
      DO ISORT=1,NSORT
      IF(NRAD0(ISORT).GT.NRADMEM)
     &CALL FULLSTOP('<PLZFILES>:: NRAD0>NRADMAX')
      IF(ILSV0(ISORT).GT.LMAXVMEM)
     &CALL FULLSTOP('<PLZFILES>:: ILSV0>LMAXV  ')
      ENDDO
	IF(ABS(QPTB0(1)-QPTB(1,IPTB)).GT.1.D-10.OR.
     &   ABS(QPTB0(2)-QPTB(2,IPTB)).GT.1.D-10.OR.
     &   ABS(QPTB0(3)-QPTB(3,IPTB)).GT.1.D-10)
     &CALL FULLSTOP('<PLZFILES>: PERTURBATION VECTOR MISMATCHES')
C Read polarizability:
	LDRHO=.TRUE.	
	NDRHO=.NOT.LDRHO
      DO IATOM=1,NATOM                           !!! over atoms
      ISORT=IS(IATOM)
      DO IORBS=1,NORBS                           !!! over iorbs
      DO ISPIN=1,NSPIN                           !!! over spins
      IF(LDRHO)READ(ICHN)((DRHO(IRAD,LM,IATOM,ISPIN,IORBS),
     &IRAD=0,NRAD0(ISORT)),LM=1,(ILSV0(ISORT)+1)**2)
      IF(NDRHO)READ(ICHN)
      IF(LDRHO)READ(ICHN)(DELGHUB(IU,IATOM,ISPIN,IORBS),
     &  IU=1,(ILSB(ISORT)+1)*(2*ILSB(ISORT)+1)*(2*ILSB(ISORT)+3)/3)
	IF(NDRHO)READ(ICHN)
C Set zeroes for higher l's
      DO L=ILSV0(ISORT)+1,ILSV(ISORT)
      DO M=-L,L
      LM=L*(L+1)+M+1
      DO IRAD=0,NRAD0(ISORT)
      IF(LDRHO)DRHO(IRAD,LM,IATOM,ISPIN,IORBS)=(0.D0,0.D0)
      ENDDO
      ENDDO
      ENDDO
      ENDDO                                      !!! over spins
      ENDDO                                      !!! over iorbs
      ENDDO                                      !!! over atoms
      CLOSE(ICHN)
      ENDIF
C **** INITIALIZE POLARIZABILITY
      IF(FOPER.EQ.'I')THEN
      LDRHO=.TRUE.
      DO IATOM=1,NATOM                           !!! over atoms
      ISORT=IS(IATOM)
      DO IORBS=1,NORBS                           !!! over iorbs
      DO ISPIN=1,NSPIN                           !!! over spins
      DO L=0,ILSV(ISORT)
      DO M=-L,L
      LM=L*(L+1)+M+1
      DO IRAD=0,NRAD(ISORT)
      IF(LDRHO)DRHO(IRAD,LM,IATOM,ISPIN,IORBS)=(0.D0,0.D0)
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      ENDDO                                      !!! over spins
      ENDDO                                      !!! over atoms
	DO IORBS=1,NORBS                           !!! over iorbs
	DO ISPIN=1,NSPIN                           !!! over spins
	DO IATOM=1,NATOM                           !!! over atoms
	ISORT=IS(IATOM) 
	DO L=0,ILSB(ISORT)                         !!! over l
      DO M1=-L,L                                 !!! over m1
      LM1=L*(L+1)+M1+1
      DO M=-L,L                                  !!! over m
      LM=L*(L+1)+M+1
      IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M1+1 ! ! (l,m'm)
      IF(LDRHO)DELGHUB(IU,IATOM,ISPIN,IORBS)=(0.D0,0.D0)
	ENDDO                                      !!! over m1
      ENDDO                                      !!! over m
      ENDDO                                      !!! over l
      ENDDO                                      !!! over atoms
	ENDDO                                      !!! over spins
	ENDDO                                      !!! over iorbs
      ENDIF
C **** STORE DATA IN PLZFILE OR SCPFILE
      IF(FOPER.NE.'R'.AND.FOPER.NE.' ')THEN
      OPEN(UNIT=ICHN,FILE=DFILE,STATUS=STATUS,
     &  FORM='UNFORMATTED',ACCESS='SEQUENTIAL')
      CLOSE(UNIT=ICHN,STATUS='DELETE')
      OPEN(UNIT=ICHN,FILE=DFILE,STATUS='NEW',
     &  FORM='UNFORMATTED',ACCESS='SEQUENTIAL')
C Store control information:
      WRITE(ICHN)NATOM,NSORT,NSPIN,NORBS,
     &(NRAD(ISORT),ISORT=1,NSORT),
     &(ILSV(ISORT),ISORT=1,NSORT),(QPTB(I,IPTB),I=1,3)
      WRITE(ICHN)((R(IRAD,ISORT),IRAD=0,NRAD(ISORT)),ISORT=1,NSORT)
C Store polarizability:
      LDRHO=.TRUE.
      DO IATOM=1,NATOM                           !!! over atoms
      ISORT=IS(IATOM)
      DO IORBS=1,NORBS                           !!! over iorbs
      DO ISPIN=1,NSPIN                           !!! over spins
      IF(LDRHO)WRITE(ICHN)((DRHO(IRAD,LM,IATOM,ISPIN,IORBS),
     &IRAD=0,NRAD(ISORT)),LM=1,(ILSV(ISORT)+1)**2)
      IF(LDRHO)WRITE(ICHN)(DELGHUB(IU,IATOM,ISPIN,IORBS),
     &  IU=1,(ILSB(ISORT)+1)*(2*ILSB(ISORT)+1)*(2*ILSB(ISORT)+3)/3)
      ENDDO                                      !!! over spins
      ENDDO                                      !!! over iorbs
      ENDDO                                      !!! over atoms
      CLOSE(ICHN)
      ENDIF
C Deallocate data
	IF(AOPER.EQ.'D')THEN
	DEALLOCATE(DRHO,DELGHUB)
	IF(ALLOCATED(ROLD))DEALLOCATE(ROLD)
	IF(ALLOCATED(NRAD0))DEALLOCATE(NRAD0)
	ENDIF
	DEALLOCATE(ILSV0)
      END




	SUBROUTINE PLZ_PLSFILES(IPTB,IQPNT,ICHN,FOPER,AOPER)
********************************************************
* Reads/Writes/Initializes polarizability function     *
* int the int.region according to FOPER='R','W','I','D'*
********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_LATPAR,  ONLY : PAR,ORTH,OMEGAC                            !!! from readini
	USE COM_QMESH,   ONLY : NQPNT,QPNT                                 !!! from readpnt
	USE COM_SPHERE,  ONLY : SWZ,SMT                                    !!! from readini
      USE COM_PLZCOM,  ONLY : NPLZ,LPLZ,IPLZ,NPTB,QPTB,INDPTB            !!! from readlrt
	USE COM_DELRHO,  ONLY : DRHOPS                                     !!! from delrho
	USE COM_LATTICE, ONLY : GBAS,RBAS                                  !!! from readstr
	USE COM_PLWMESH, ONLY : NPLW,GPLW                                  !!! from makeplw
	USE COM_MASHDEP, ONLY : NVAL                                       !!! from setup
      USE COM_OLDMESH, ONLY : NPLW0,GPLW0,RBAS0,GBAS0,ORTH0              !!! from dpsfiles
	USE COM_PHNCHN  ,ONLY : IUPLS                                      !!! from channels
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	USE COM_LMTOUT
	USE COM_PHNOUT
	IMPLICIT REAL*8 (A-H,O-Z)
	LOGICAL EXIST,LDRHO,NDRHO
	CHARACTER TDRHO*1,FOPER*1,AOPER*1,STATUS*3,DFILE*130
	DIMENSION QPTB0(3)
	IF(FOPER.NE.' ')THEN
      IF(ICHN.NE.IUPLS)DFILE=SCPFILE(IPTB,ICHN)
      IF(ICHN.EQ.IUPLS)DFILE=PLSFILE(IPTB)
      INQUIRE(FILE=DFILE,EXIST=EXIST)
      IF(.NOT.EXIST)STATUS='NEW'
      IF(     EXIST)STATUS='OLD'
	ENDIF
C Allocate data
	IF(AOPER.EQ.'A')THEN
	ALLOCATE(DRHOPS(0:NPLWMEM,NSPINMEM,NORBSMEM))
	IF(.NOT.ALLOCATED(GPLW0))ALLOCATE(GPLW0(3,0:NPLWMEM))
	ENDIF
C *** DELETE FILE
      IF(FOPER.EQ.'D')THEN
      OPEN(UNIT=ICHN,FILE=DFILE,STATUS='OLD',
     &FORM='UNFORMATTED',ACCESS='SEQUENTIAL')
      CLOSE(UNIT=ICHN,STATUS='DELETE')
      RETURN
      ENDIF
C *** READ DATA FROM PLSFILE OR SCPFILE
      IF(FOPER.EQ.'R')THEN
      IF(.NOT.EXIST)
     &CALL FULLSTOP('<PLSFILES>: FILE MUST EXIST!')
      OPEN(UNIT=ICHN,FILE=DFILE,STATUS='OLD',
     &FORM='UNFORMATTED',ACCESS='SEQUENTIAL')
C Read control information:
	IF(ICHN.EQ.IUPLS)
     &READ(ICHN)NPLW0,((GPLW0(I,IPLW),I=1,3),IPLW=0,NPLW0),
     &ORTH0,GBAS0,RBAS0
      IF(ICHN.NE.IUPLS)NPLW0=NPLW
      IF(NPLW0.GT.NPLWMEM)
     &CALL FULLSTOP('<PLSFILES>: NPLW0>NPLWMEM')
C Read polarizability
	LDRHO=.TRUE.
	NDRHO=.NOT.LDRHO
      DO IORBS=1,NORBS
      DO ISPIN=1,NSPIN
      IF(LDRHO)READ(ICHN)(DRHOPS(IPLW,ISPIN,IORBS),IPLW=0,NPLW0)
      IF(NDRHO)READ(ICHN)
C Set zeroes for higher plw's
      DO IPLW=NPLW0+1,NPLW
      IF(LDRHO)DRHOPS(IPLW,ISPIN,IORBS)=(0.D0,0.D0)
      ENDDO
      ENDDO                                      !!! over spins
      ENDDO                                      !!! over iorbs
      CLOSE(ICHN)
      ENDIF
C **** INITIALIZE POLARIZABILITY
      IF(FOPER.EQ.'I')THEN
      LDRHO=.TRUE.
      DO IORBS=1,NORBS                           !!! over iorbs
      DO ISPIN=1,NSPIN                           !!! over spins
      DO IPLW=0,NPLW
      IF(LDRHO)DRHOPS(IPLW,ISPIN,IORBS)=(0.D0,0.D0)
      ENDDO
      ENDDO
      ENDDO                                      !!! over spins
      ENDIF
C **** STORE DATA IN PLSFILE OR SCPFILE
      IF(FOPER.NE.'R'.AND.FOPER.NE.' ')THEN
      OPEN(UNIT=ICHN,FILE=DFILE,STATUS=STATUS,
     &FORM='UNFORMATTED',ACCESS='SEQUENTIAL')
      CLOSE(UNIT=ICHN,STATUS='DELETE')
      OPEN(UNIT=ICHN,FILE=DFILE,STATUS='NEW',
     &FORM='UNFORMATTED',ACCESS='SEQUENTIAL')
C Store control information:
      IF(ICHN.EQ.IUPLS)
     &WRITE(ICHN)NPLW,((GPLW(I,IPLW),I=1,3),IPLW=0,NPLW),
     &ORTH,GBAS,RBAS
C Store change in charge density:
      LDRHO=.TRUE.
      DO IORBS=1,NORBS                           !!! over iorbs
      DO ISPIN=1,NSPIN                           !!! over spins
      IF(LDRHO)WRITE(ICHN)(DRHOPS(IPLW,ISPIN,IORBS),IPLW=0,NPLW)
      ENDDO                                      !!! over spins
      ENDDO                                      !!! over iorbs
      CLOSE(ICHN)
      ENDIF
C Deallocate data
	IF(AOPER.EQ.'D')THEN
	DEALLOCATE(DRHOPS)
	IF(ALLOCATED(GPLW0))DEALLOCATE(GPLW0)
	ENDIF
      END
