	SUBROUTINE PLZ_SPLZINL(IPNT,ISGQ,IPTB,IPAN,IQPNT)
***********************************************************
*  Calculates pseudopotential contribution to the         *
*  change in the hamiltonian and overlap matrix using     *
*  fourier transform.                                     * 
***********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_KAPPAR,  ONLY : NPAN,NKAP,EK,EKAP                          !!! from readini
	USE COM_LATPAR,  ONLY : PAR,ORTH,OMEGAC                            !!! from readini
	USE COM_NBANDS,  ONLY : NBNDF,NBNDE,NBNDT,NBNDH                    !!! from readini
	USE COM_PLWMESH, ONLY : NPLW,GPLW                                  !!! from makeplw
	USE COM_PANPAR,  ONLY : LTPAN,LSPAN,IATS,ISTS                      !!! from readini
	USE COM_TEILORG, ONLY : KEYT,BZM,GOPT,MBAS                         !!! from makeplw
	USE COM_DPSIVEC, ONLY : PSIK,PSIQ,DPSK,DPSQ,PNTK,PNTQ              !!! from d2psivec
	USE COM_ETAPAR,  ONLY : ETA,CUT,LBAS,NBAS                          !!! from makeplw
	USE COM_DELHAM,  ONLY : DHMAT                                      !!! from delmat
	USE COM_PHNCHN  ,ONLY : IUDIN
	USE COM_MASHDEP, ONLY : NVAL                                       !!! from setup
	USE COM_LMTOUT,  ONLY : SCRFILE                                    !!! from setup
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: XFUN0(:,:,:)
	COMPLEX*16, ALLOCATABLE :: XFUNQ(:,:,:)
	COMPLEX*16, ALLOCATABLE :: VINT0Q(:,:)
	COMPLEX*16 DELVT
	DATA PI/3.141592653589793D0/
	IF(KEYT.EQ.0)RETURN
C Memory allocations
	ALLOCATE(XFUN0((NBNDT(IPAN)+NBNDH(IPAN))*NSPINMEM,
     &                                0:MBASMEM,NSPINMEM))
	ALLOCATE(XFUNQ((NBNDT(IPAN)+NBNDH(IPAN))*NSPINMEM,
     &                                0:MBASMEM,NSPINMEM))
	ALLOCATE(VINT0Q((NBNDT(IPAN)+NBNDH(IPAN))*NSPINMEM,
     &                (NBNDT(IPAN)+NBNDH(IPAN))*NSPINMEM))
	XK=PNTK(1)
	YK=PNTK(2)
	ZK=PNTK(3)
      IF(MODE.NE.5)IBNDMIN=1
      IF(MODE.NE.5)IBNDMAX=NBNDT(IPAN)+NBNDH(IPAN)
      IF(MODE.EQ.5)IBNDMIN=NBNDE(IPAN)
      IF(MODE.EQ.5)IBNDMAX=NBNDF(IPAN)
C  READ POTENTIAL PARAMETERS
      DO IORBS=1,NORBS                  !!! over iorbs
      DO IUPDN=1,NSPIN                  !!! over ispin
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
	IREC=1+2*(IUPDN-1)+2*NSPIN*(IORBS-1)
	READ(IUDIN,REC=IREC)
     &((VINT0Q(IPAR1+NBNDT(IPAN)*(ISPIN1-1),
     &IPAR+NBNDT(IPAN)*(ISPIN-1)),IPAR1=1,
     &NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),
     &((XFUN0(IPAR1+NBNDT(IPAN)*(ISPIN1-1),IBAS,ISPIN),
     &IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
	IREC=2+2*(IUPDN-1)+2*NSPIN*(IORBS-1)
	READ(IUDIN,REC=IREC)
     &((VINT0Q(IPAR1+NBNDT(IPAN)*(ISPIN1-1),
     &IPAR+NBNDT(IPAN)*(ISPIN-1)),IPAR1=1,
     &NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),
     &((XFUNQ(IPAR1+NBNDT(IPAN)*(ISPIN1-1),IBAS,ISPIN),
     &IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
      ENDDO
	ENDDO
C  TRASFERE TO BAND REPRESENTATION
	CALL DEL_TRVINT(PNTK,      0,0,0,0,IPAN,VINT0Q)
	CALL DEL_TRXFUN(PNTK,'0N*0N',0,0,0,IPAN,XFUN0,XFUNQ)
	CALL DEL_TRXFUN(PNTK,'QN*QC',0,0,0,IPAN,XFUN0,XFUNQ) 
C  COMPUTE CONTRIBUTION
      DO IBNDS1=1,NSPIN                    !!! over spin subbands
	DO IBNDT1=IBNDMIN,IBNDMAX            !!! over all bands
	IBAND1=IBNDS1+NSPIN*(IBNDT1-1)
      DO IBNDS=1,NSPIN                     !!! over spin subbands
	IF(NORBS.EQ.1.AND.IBNDS1.NE.IBNDS)CYCLE
	DO IBNDT=IBNDMIN,IBNDMAX             !!! over all bands
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	DELVT=VINT0Q(IBAND1,IBAND)
	DO JSPIN=1,NSPIN
	IF(NORBS.EQ.1.AND.IBNDS1.NE.JSPIN)CYCLE
	IF(NORBS.EQ.1.AND.IBNDS .NE.JSPIN)CYCLE
	DO IBAS=0,MIN(NBAS,MBAS)
	DELVT=DELVT+DCONJG(PSIQ(IBAS,JSPIN,IBAND1))*XFUN0(IBAND,IBAS,JSPIN)+
     &XFUNQ(IBAND1,IBAS,JSPIN)*PSIK(IBAS,JSPIN,IBAND)
	ENDDO
	ENDDO
	DHMAT(IBAND1,IBAND)=DHMAT(IBAND1,IBAND)+DELVT
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C Memory deallocations
	DEALLOCATE(XFUN0,XFUNQ,VINT0Q)
	END
