	SUBROUTINE PLZ_SPLZINT(IPNT,ISGQ,IPTB,IPAN,IQPNT)
***********************************************************
*  Calculates pseudopotential contribution to the         *
*  change in the hamiltonian and overlap matrix using     *
*  fourier transform.                                     * 
***********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_LATPAR,  ONLY : PAR,ORTH,OMEGAC                            !!! from readini
	USE COM_KAPPAR,  ONLY : NPAN,NKAP,EK,EKAP                          !!! from readini
	USE COM_PANPAR,  ONLY : LTPAN,LSPAN,IATS,ISTS                      !!! from readini
	USE COM_NBANDS,  ONLY : NBNDF,NBNDE,NBNDT,NBNDC,NBNDH              !!! from readini
	USE COM_ETAPAR,  ONLY : ETA,CUT,LBAS,NBAS                          !!! from makeplw
	USE COM_POTDAT,  ONLY : POTPS,POTPS1                               !!! from readscf
	USE COM_DELPOT,  ONLY : DPOTPS,DPOTPS1                             !!! from delpot
	USE COM_DPSIVEC, ONLY : PSIK,PSIQ,DPSK,DPSQ,PNTK,PNTQ              !!! from d2psivec
	USE COM_TEILORG, ONLY : KEYT,BZM,GOPT,MBAS                         !!! from makeplw
	USE COM_PLWMESH, ONLY : NPLW,GPLW                                  !!! from makeplw
	USE COM_DELHAM,  ONLY : DHMAT                                      !!! from delmat
	USE COM_MASHDEP, ONLY : NVAL                                       !!! from setup
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: CHIS(:)
	COMPLEX*16, ALLOCATABLE :: CONV(:)
	COMPLEX*16 GMY,DELVR,DELVT
	DATA PI/3.141592653589793D0/
C Memory allocations
      ALLOCATE(CONV(0:NBASMEM))
	ALLOCATE(CHIS(0:NBASMEM))
      IF(MODE.NE.5)IBNDMIN=1
      IF(MODE.NE.5)IBNDMAX=NBNDT(IPAN)+NBNDH(IPAN)
      IF(MODE.EQ.5)IBNDMIN=NBNDE(IPAN)
      IF(MODE.EQ.5)IBNDMAX=NBNDF(IPAN)
      DO 6000 IORBS=1,NORBS          !!! over iorbs
      DO 5000 IUPDN=1,NSPIN          !!! over ispin
	IF(IORBS.EQ.1)THEN
	IUPDN1=IUPDN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	SIGNF=1.D0
	ELSEIF(IORBS.EQ.2)THEN
	IUPDN1=NSPIN+1-IUPDN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	IF(ISPIN1.EQ.1.AND.ISPIN.EQ.2)SIGNF=-SQRT(2.D0) ! B^{+}*S_{+}
	IF(ISPIN1.EQ.2.AND.ISPIN.EQ.1)SIGNF=+SQRT(2.D0) ! B^{-}*S_{-}
	ENDIF
C *** DO GLOBALLY OVER BANDS IBND ***
      DO 4000 IBNDS1=1,NSPIN                    !!! over spin subbands
	IF(NORBS.EQ.1.AND.IBNDS1.NE.ISPIN1)GOTO 4000
	DO 3000 IBNDT1=IBNDMIN,IBNDMAX            !!! over all bands
	IBAND1=IBNDS1+NSPIN*(IBNDT1-1)
C  CONVOLUTION OF THE PSEUDOORBITAL WITH THE PSEUDOPOTENTIAL
      DO IBAS=0,NBAS
      CHIS(IBAS)=DCONJG(PSIQ(IBAS,ISPIN1,IBAND1))
      ENDDO
      CALL BND_CONVOL1(DPOTPS1(0,IUPDN1,IORBS),CHIS(0),CONV(0),'L',
     &               0,MIN(NBAS,MBAS),0,MIN(NBAS,MBAS))
C *** DO GLOBALLY OVER BANDS ***
      DO 2000 IBNDS=1,NSPIN                     !!! over spin subbands
	IF(NORBS.EQ.1.AND.IBNDS.NE.ISPIN)GOTO 2000
	DO 1000 IBNDT=IBNDMIN,IBNDMAX             !!! over all bands
	IBAND=IBNDS+NSPIN*(IBNDT-1)
      IF((IPAN.EQ.1.AND.((IBNDT.LE.NBNDF(IPAN).AND.IBNDT1.GE.NBNDE(
     &  IPAN)).OR.(IBNDT.GE.NBNDE(IPAN).AND.IBNDT1.LE.NBNDF(IPAN))))
     &  .OR.(MODE.EQ.4.OR.MODE.EQ.5))THEN                         
C  CHANGE IN PSEUDPOTENTIAL MATRIX ELEMENTS
	DELVT=(0.D0,0.D0)
	DO IBAS=0,MIN(NBAS,MBAS)                   !!! over plane waves
	DELVT=DELVT+CONV(IBAS)*PSIK(IBAS,ISPIN,IBAND)
      ENDDO                                      !!! over plane waves
      DELVT=DELVT*SIGNF
	DHMAT(IBAND1,IBAND)=DHMAT(IBAND1,IBAND)+DELVT
	ENDIF
 1000 CONTINUE                                   !!! over all bands
 2000 CONTINUE                                   !!! over spin subbands
 3000 CONTINUE                                   !!! over all bands
 4000 CONTINUE                                   !!! over spin subbands
 5000 CONTINUE                                   !!! over iupdn
 6000 CONTINUE                                   !!! over iorbs
C Memory allocations
      DEALLOCATE(CONV,CHIS)
	END
