	SUBROUTINE PLZ_PLZMAT(IQPNT)
*******************************************************************
*  Computes polarizability matrix pi(q+G,q+G")                    *
*******************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_RADMESH, ONLY : NRAD,H,R,DR,WEIGHT,RL                      !!! from radmsh
	USE COM_LATPAR,  ONLY : PAR,ORTH,OMEGAC                            !!! from readini
	USE COM_LATTICE, ONLY : TAU                                        !!! from readstr
	USE COM_PLWMESH, ONLY : NPLW,GPLW                                  !!! from makeplw
	USE COM_SPHERE,  ONLY : SWZ,SMT                                    !!! from readini
	USE COM_QMESH,   ONLY : NQPNT,QPNT                                 !!! from readpnt
	USE COM_MASHDEP, ONLY : NVAL                                       !!! from setup
      USE COM_PLZCOM,  ONLY : NPLZ,LPLZ,IPLZ,NPTB,QPTB,INDPTB            !!! from readlrt
      USE COM_PLZMOM,  ONLY : PSMAT                                      !!! from screen
	USE COM_ACCURG,  ONLY : BET                                        !!! from multrho
      USE COM_DELRHO,  ONLY : DRHO,DRHOPS                                !!! from plzmts
	USE COM_PHNCHN  ,ONLY : IUPLZ,IUPLS                                !!! from channels
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
      IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: PLSM1(:,:,:)
	COMPLEX*16, ALLOCATABLE :: PLSM(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: PLZM(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: RHAN(:)
	COMPLEX*16, ALLOCATABLE :: WORK1(:)
	COMPLEX*16, ALLOCATABLE :: WORK2(:)
	COMPLEX*16, ALLOCATABLE :: YLM(:)
	COMPLEX*16, ALLOCATABLE :: GAUS(:,:)
	COMPLEX*16, ALLOCATABLE :: PIMAT(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: DRHOPS1(:,:)
	REAL*8, ALLOCATABLE :: BES(:)
	REAL*8, ALLOCATABLE :: BESD(:)
	REAL*8, ALLOCATABLE :: BT(:)
	REAL*8, ALLOCATABLE :: COFL(:,:)
      COMPLEX*16 EXPQR,GINT,LIB_CNUM0P,EXPT
      DATA PI/3.141592653589793D0/
      SQPI4=2.D0*SQRT(PI)
	IF(LPLZ.EQ.0)RETURN
C Memory allocations for main arrays
	ALLOCATE(PSMAT(NENVMEM,NENVMEM,NSPINMEM))
C Memory allocations
	ALLOCATE(PLSM1(LIMVMEM,NATOMMEM,NSPINMEM))
	ALLOCATE(PLSM(LIMVMEM,NATOMMEM,NSPINMEM,NORBSMEM))
	ALLOCATE(PLZM(LIMVMEM,NATOMMEM,NSPINMEM,NORBSMEM))
	ALLOCATE(RHAN(0:LMAXVMEM+1))
	ALLOCATE(WORK1(0:NRADMEM))
	ALLOCATE(WORK2(0:NRADMEM))
	ALLOCATE(YLM(LIMVMEM))
	ALLOCATE(GAUS(0:LIMVMEM,NATOMMEM))
	ALLOCATE(PIMAT(NENVMEM,NENVMEM,NSPINMEM,NORBSMEM))
	ALLOCATE(BES(-1:LMAXVMEM+1))
	ALLOCATE(BESD(0:LMAXVMEM+1))
	ALLOCATE(BT(0:LMAXVMEM+1))
	ALLOCATE(COFL(0:LMAXVMEM,NSORTMEM))
	ALLOCATE(DRHOPS1(0:NPLWMEM,NSPINMEM))
C  DO OVER PERTURBATION VECTORS
	DO 1000 IPTB=1,NPTB                     !!! over {q+G}-vectors
C  SET ZEROES
	DO IORBS=1,NORBS                        !!! over spins
	DO IUPDN=1,NSPIN                        !!! over spins
	DO JPTB=1,NPTB                          !!! over jptb
	PIMAT(JPTB,IPTB,IUPDN,IORBS)=(0.D0,0.D0)
      ENDDO                                   !!! over jptb
      ENDDO                                   !!! over spins
      ENDDO                                   !!! over spins
C  READ POLARIZABILITY DATA
	CALL PLZ_PLZFILES(IPTB,IQPNT,IUPLZ,'R',' ')!!! read pi_q(r)
	CALL PLZ_PLSFILES(IPTB,IQPNT,IUPLS,'R',' ')!!! read pi_q(G)
C  CALCULATE MOMENTS OF THE POLARIZABILITY WITHIN SPHERES
	DO IORBS=1,NORBS                        !!! over spins
	DO IUPDN=1,NSPIN                        !!! over spins
      DO IATOM=1,NATOM                        !!! over atoms
      ISORT=IS(IATOM)
      DO L=0,ILSV(ISORT)                      !!! over l
      DO M=-L,L                               !!! over m
      LM=L*(L+1)+M+1
      SL=SMT(ISORT)**L
      DO IRAD=0,NRAD(ISORT)                   !!! over irad
      WORK1(IRAD)=DRHO(IRAD,LM,IATOM,IUPDN,IORBS)*
     &RL(IRAD,L,ISORT)/SL*WEIGHT(IRAD,ISORT)/SQRT(4.D0*PI)
      ENDDO                                   !!! over irad
      CALL LIB_CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
      PLZM(LM,IATOM,IUPDN,IORBS)=WORK2(NRAD(ISORT))
      ENDDO                                   !!! over m
      ENDDO                                   !!! over l
      ENDDO                                   !!! over atoms
      ENDDO                                   !!! over spins
      ENDDO                                   !!! over spins
C  CONTRIBUTION FROM MT-SPHERES TO PI(Q+G",Q+G)
	DO IORBS=1,NORBS                        !!! over spins
	DO IUPDN=1,NSPIN                        !!! over spins
	DO JPTB=1,NPTB                          !!! over q+G"
	DO IATOM=1,NATOM                        !!! over atoms
      ISORT=IS(IATOM)
      QX=QPTB(1,JPTB)*2.D0*PI/PAR
      QY=QPTB(2,JPTB)*2.D0*PI/PAR
      QZ=QPTB(3,JPTB)*2.D0*PI/PAR
      AQ=SQRT(QX**2+QY**2+QZ**2)
      IF(AQ.GE.1.D-10)THEN
      CALL LIB_SPHHARM(QX/AQ,QY/AQ,QZ/AQ,ILSV(ISORT),YLM)
      ELSE
      YLM(1)=1.D0/SQRT(4.D0*PI)
      DO LM=2,(ILSV(ISORT)+1)**2
      YLM(LM)=(0.D0,0.D0)
	ENDDO
      ENDIF
      CALL LIB_BESSR(AQ*SMT(ISORT),BES(0),BESD(0),ILSV(ISORT))
      DO L=0,ILSV(ISORT)
      BES(L)=BES(L)*AQ*SMT(ISORT)
	ENDDO
      BES(-1)=COS(AQ*SMT(ISORT))
      SCP=QPTB(1,JPTB)*TAU(1,IATOM)+
     &    QPTB(2,JPTB)*TAU(2,IATOM)+
     &    QPTB(3,JPTB)*TAU(3,IATOM)
      EXPQR=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
      DO L=0,ILSV(ISORT)                      !!! over l
      DO M=-L,L                               !!! over m
      LM=L*(L+1)+M+1
   	PIMAT(JPTB,IPTB,IUPDN,IORBS)=PIMAT(JPTB,IPTB,IUPDN,IORBS)+
     &PLZM(LM,IATOM,IUPDN,IORBS)/SQRT(4.D0*PI)*EXPQR*YLM(LM)*
     &4.D0*PI*BES(L-1)/DBLE(2*L+1)
      ENDDO                                   !!! over m
      ENDDO                                   !!! over l
      ENDDO                                   !!! over atoms
      ENDDO                                   !!! over q+G"
      ENDDO                                   !!! over spins
      ENDDO                                   !!! over spins
C  CONTRIBUTION FROM INTERSTITIALS TO PI(Q+G",Q+G)
	DO JPTB=1,NPTB                          !!! over q+G"
      DO IPLW=0,NPLW                          !!! over plane waves
	GX=GPLW(1,IPLW)-(QPTB(1,JPTB)-QPNT(1,IQPNT))
	GY=GPLW(2,IPLW)-(QPTB(2,JPTB)-QPNT(2,IQPNT))
	GZ=GPLW(3,IPLW)-(QPTB(3,JPTB)-QPNT(3,IQPNT))
	CALL MAKEPLW_SINT(GX,GY,GZ,GINT)
	DO IORBS=1,NORBS                        !!! over spins
	DO IUPDN=1,NSPIN                        !!! over spins
   	PIMAT(JPTB,IPTB,IUPDN,IORBS)=PIMAT(JPTB,IPTB,IUPDN,IORBS)+
     &DRHOPS(IPLW,IUPDN,IORBS)*GINT
      ENDDO                                   !!! over spins
      ENDDO                                   !!! over spins
      ENDDO                                   !!! over plane waves 
      ENDDO                                   !!! over q+G"
1000	CONTINUE                                !!! over {q+G}-vectors
C  CHECK THE HERMITIANNESS AND PRINT OUT POLARIZABILITY
	DO IPTB=1,NPTB                          !!! over q+G
	DO JPTB=1,NPTB                          !!! over q+G"
	IF(ABS(DCONJG(PIMAT(IPTB,JPTB,1,1)+PIMAT(IPTB,JPTB,NSPIN,1)  )-
     &(PIMAT(JPTB,IPTB,1,1)+PIMAT(JPTB,IPTB,NSPIN,1))).GE.1.D-05)THEN
      WRITE(IUN,*)'ERROR: NON-HERMITIAN COMPONENTS:',JPTB,IPTB
 	WRITE(IUN,1020)JPTB,IPTB,
     &LIB_CNUM0P(PIMAT(JPTB,IPTB,1,1)+PIMAT(JPTB,IPTB,NSPIN,1),1.D-07)
	ENDIF
      ENDDO                                   !!! over q+G"
      ENDDO                                   !!! over q+G
C  PIMAT IS NOT WHAT IS ACTUALLY NEEDED, PSMAT IS REQUIRED!
C  *** COMPUTE LONG-RANGE PART OF THE POLARIZABILITY MATRIX *** 
 	WRITE(IUN,1010)
C  DO OVER PERTURBATION VECTORS
	DO 2000 IPTB=1,NPTB                     !!! over {q+G}-vectors
C  SET ZEROES
	DO IUPDN=1,NSPIN                        !!! over spins
	DO JPTB=1,NPTB                          !!! over jptb
	PSMAT(JPTB,IPTB,IUPDN)=(0.D0,0.D0)
      ENDDO                                   !!! over jptb
      ENDDO                                   !!! over spins
C  READ POLARIZABILITY DATA
	CALL PLZ_PLZFILES(IPTB,IQPNT,IUPLZ,'R',' ')!!! read pi_q(r)
	CALL PLZ_PLSFILES(IPTB,IQPNT,IUPLS,'R',' ')!!! read pi_q(G)
C  CALCULATE MOMENTS OF THE POLARIZABILITY WITHIN SPHERES
	DO IORBS=1,NORBS                        !!! over spins
	DO IUPDN=1,NSPIN                        !!! over spins
      DO IATOM=1,NATOM                        !!! over atoms
      ISORT=IS(IATOM)
      DO L=0,ILSV(ISORT)                      !!! over l
      DO M=-L,L                               !!! over m
      LM=L*(L+1)+M+1
      SL=SMT(ISORT)**L
      DO IRAD=0,NRAD(ISORT)                   !!! over irad
      WORK1(IRAD)=DRHO(IRAD,LM,IATOM,IUPDN,IORBS)*
     &RL(IRAD,L,ISORT)/SL*WEIGHT(IRAD,ISORT)/SQRT(4.D0*PI)
      ENDDO                                   !!! over irad
      CALL LIB_CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
      PLZM(LM,IATOM,IUPDN,IORBS)=WORK2(NRAD(ISORT))
      ENDDO                                   !!! over m
      ENDDO                                   !!! over l
      ENDDO                                   !!! over atoms
      ENDDO                                   !!! over spins
      ENDDO                                   !!! over spins
C  CALCULATE MOMENTS OF THE PSEUDOPOLARIZABILITY WITHIN SPHERES
      LMM=0
      DO IORBS=1,NORBS
      DO IUPDN=1,NSPIN
      DO IATOM=1,NATOM
      ISORT=IS(IATOM)
      LMM=MAX(LMM,ILSV(ISORT))
      DO L=0,ILSV(ISORT)
      DO M=-L,L
      LM=L*(L+1)+M+1
      PLSM(LM,IATOM,IUPDN,IORBS)=(0.D0,0.D0)
      ENDDO   
      ENDDO   
      ENDDO   
      ENDDO   
      ENDDO   
      DO IPLW=0,NPLW                       !!! over plane waves
      GX=(GPLW(1,IPLW)+QPNT(1,IQPNT))*2.D0*PI/PAR
      GY=(GPLW(2,IPLW)+QPNT(2,IQPNT))*2.D0*PI/PAR
      GZ=(GPLW(3,IPLW)+QPNT(3,IQPNT))*2.D0*PI/PAR
      AG=SQRT(GX**2+GY**2+GZ**2)
      AG2=AG*AG
C  SET SPHERICAL HARMONICS
      IF(AG.GE.1.D-10)THEN
      CALL LIB_SPHHARM(GX/AG,GY/AG,GZ/AG,LMM,YLM)
      ELSE
      YLM(1)=1.D0/SQRT(4.D0*PI)
      DO LM=2,(LMM+1)**2
      YLM(LM)=(0.D0,0.D0)
      ENDDO   
      ENDIF
      DO IATOM=1,NATOM                     !!! over atoms
      ISORT=IS(IATOM)
      CALL LIB_BESSR(AG*SMT(ISORT),BES(0),BESD(0),ILSV(ISORT)+1)
      SCP=(QPNT(1,IQPNT)+GPLW(1,IPLW))*TAU(1,IATOM)+
     &    (QPNT(2,IQPNT)+GPLW(2,IPLW))*TAU(2,IATOM)+
     &    (QPNT(3,IQPNT)+GPLW(3,IPLW))*TAU(3,IATOM)
      EXPT=EXP((0.D0,1.D0)*2.D0*PI*SCP)
      DO IORBS=1,NORBS                     !!! over spins
      DO IUPDN=1,NSPIN                     !!! over spins
      DO L=0,ILSV(ISORT)
      DO M=-L,L
      LM=L*(L+1)+M+1
      IF(AG.GT.1.D-10)THEN
      PLSM(LM,IATOM,IUPDN,IORBS)=PLSM(LM,IATOM,IUPDN,IORBS)+
     &4.D0*PI*SMT(ISORT)**2*DRHOPS(IPLW,IUPDN,IORBS)*BES(L+1)*
     &EXPT*DCONJG(YLM(LM))/AG*SQPI4
      ELSE
      PLSM(LM,IATOM,IUPDN,IORBS)=PLSM(LM,IATOM,IUPDN,IORBS)+
     &4.D0*PI/3.D0*SMT(ISORT)**3*DRHOPS(IPLW,IUPDN,IORBS)*
     &EXPT*DCONJG(YLM(LM))*SQPI4
      ENDIF
      ENDDO   
      ENDDO   
      ENDDO                                !!! over spins
      ENDDO                                !!! over spins
      ENDDO                                !!! over atoms
      ENDDO                                !!! over plane waves
C  CALCULATE AUXILARY PSEUDOCHARGE DENSITY
C  WHICH HAS THE SAME MULTIPOLES AS A TRUE DENSITY MINUS PSEUDODENSITY
      DO IUPDN=1,NSPIN
      DO IATOM=1,NATOM
      ISORT=IS(IATOM)
      BT(0)=BET(0,ISORT)
      DO L=1,ILSV(ISORT)+1
      BT(L)=BET(L-1,ISORT)
      ENDDO   
      CALL LIB_REGHAN(SMT(ISORT),(0.D0,0.D0),SMT(ISORT),BT(0),
     &RHAN(0),ILSV(ISORT)+1)
      DO L=0,ILSV(ISORT)
      COFL(L,ISORT)=4.D0*PI/OMEGAC*SMT(ISORT)**(L+1)/FAC2(2*L-1)
      DO M=-L,L
      LM=L*(L+1)+M+1
C  GAUSSIAN MULTIPOLE MOMENT WITHIN SPHERE
      GSMOM=SQPI4*SMT(ISORT)*DBLE(2*L+1)*RHAN(L+1)
C  GAUSSIAN MULTIPOLE MOMENT IN WHOLE SPACE
C     GSMOM=SQPI4*SMT(ISORT)*DBLE(2*L+1)
      PLSM1(LM,IATOM,IUPDN)=
     &(PLZM(LM,IATOM,IUPDN,1)-PLSM(LM,IATOM,IUPDN,1))/GSMOM
      ENDDO   
      ENDDO   
      ENDDO   
      ENDDO   
      DO IPLW=0,NPLW                        !!! over plane waves
      GX=(QPNT(1,IQPNT)+GPLW(1,IPLW))*2.D0*PI/PAR
      GY=(QPNT(2,IQPNT)+GPLW(2,IPLW))*2.D0*PI/PAR
      GZ=(QPNT(3,IQPNT)+GPLW(3,IPLW))*2.D0*PI/PAR
      AG=SQRT(GX**2+GY**2+GZ**2)
      AG2=AG*AG
C  SET SPHERICAL HARMONICS
      IF(AG.GE.1.D-10)THEN
      CALL LIB_SPHHARM(GX/AG,GY/AG,GZ/AG,LMM,YLM)
      ELSE
      YLM(1)=1.D0/SQRT(4.D0*PI)
      DO LM=2,(LMM+1)**2
      YLM(LM)=(0.D0,0.D0)
      ENDDO   
      ENDIF
C  SET AUXILARY PSEUDODENSITY DRHOPS1
      DO IUPDN=1,NSPIN                      !!! over spins
      DRHOPS1(IPLW,IUPDN)=(0.D0,0.D0)
      DO IATOM=1,NATOM                      !!! over atoms
      ISORT=IS(IATOM)
C  CALCULATE EXPONENTIAL FACTOR
      SCP=(QPNT(1,IQPNT)+GPLW(1,IPLW))*TAU(1,IATOM)+
     &    (QPNT(2,IQPNT)+GPLW(2,IPLW))*TAU(2,IATOM)+
     &    (QPNT(3,IQPNT)+GPLW(3,IPLW))*TAU(3,IATOM)
      EXPT=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
      DO L=0,ILSV(ISORT)
      IF(L.EQ.0)AGL=1.D0
      IF(L.NE.0)AGL=AG**L
      EXPG=EXP(-0.25D0*AG**2/BET(L,ISORT)**2)
      GAUS(L,IATOM)=COFL(L,ISORT)*EXPT*AGL*EXPG
      DO M=-L,L
      LM=L*(L+1)+M+1
      DRHOPS1(IPLW,IUPDN)=DRHOPS1(IPLW,IUPDN)+
     &GAUS(L,IATOM)*YLM(LM)*PLSM1(LM,IATOM,IUPDN)
      ENDDO   
      ENDDO   
      ENDDO                                !!! over atoms
      ENDDO                                !!! over spins
      ENDDO                                !!! over plane waves
C  COMPUTE POLARIZABILITY MATRIX
	DO JPTB=1,NPTB
	JPLW=INDPTB(JPTB)
	DO IUPDN=1,NSPIN
	PSMAT(JPTB,IPTB,IUPDN)=
     &DRHOPS(JPLW,IUPDN,1)+DRHOPS1(JPLW,IUPDN)
      ENDDO   
 	IF(NSPIN.EQ.1)WRITE(IUN,1020)JPTB,IPTB,
     &	(LIB_CNUM0P(PSMAT(JPTB,IPTB,IUPDN),1.D-07),IUPDN=1,NSPIN)
 	IF(NSPIN.EQ.2)WRITE(IUN,1030)JPTB,IPTB,
     &	(LIB_CNUM0P(PSMAT(JPTB,IPTB,IUPDN),1.D-07),IUPDN=1,NSPIN)
      ENDDO   
2000	CONTINUE                             !!! over {q+G}-vectors
C  SCREENING DEBYE RADIUS
	SCRD2=-8.D0*PI*DREAL(PSMAT(1,1,1)+PSMAT(1,1,NSPIN))/
     &  2.D0*DBLE(NSPIN)
      IF(SCRD2.LT.0.D0.AND.LPLZ.EQ.1.AND.NPTB.EQ.1)THEN
      WRITE(IUN,1060)
      PRINT1060
      LPLZ=0
      ENDIF
      QPNT2=QPNT(1,IQPNT)**2+QPNT(2,IQPNT)**2+QPNT(3,IQPNT)**2
      IF(QPNT2.LE.1.D-10.AND.LPLZ.EQ.1)WRITE(IUN,1070)
      IF(QPNT2.LE.1.D-10.AND.LPLZ.EQ.1)LPLZ=0
1010	FORMAT(1X,'Elements of PI(q+G",q+G) matrix computed --->')
1020	FORMAT(1X,'(',I2,',',I2,') = ','(',G12.5,',',G12.5,')')
1030	FORMAT(1X,'(',I2,',',I2,') = ','(',G12.5,',',G12.5,')',2X,
     &                                 '(',G12.5,',',G12.5,')')
1060  FORMAT(1X,'KDebye^2(q) IS NEGATIVE! LPLZ=0 MODE IS USED!')
1070  FORMAT(1X,'Q-vector iz ZERO [G-point]! LPLZ=0 MODE IS USED!')
	DEALLOCATE(PLSM,PLSM1,RHAN,WORK1,WORK2,YLM,GAUS,PIMAT)
	DEALLOCATE(BES,BESD,BT,COFL,DRHOPS1)
	END
