	SUBROUTINE PLZ_SPLZMTO(IPNT,ISGQ,IPAN,IQPNT)
**************************************************************
*  Calculate change in the Hamiltonian and Overlap matrices  *
*  due to change in the potential parameters                 *
**************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_PANPAR,  ONLY : LTPAN,LSPAN,IATS,ISTS                      !!! from readini
	USE COM_NBANDS,  ONLY : NBNDF,NBNDE,NBNDT,NBNDH                    !!! from readini
	USE COM_DHAMPAR, ONLY : DELHHH,DELHJH,DELHHJ,DELHJJ                !!! from intpar
	USE COM_KAPPAR,  ONLY : NPAN,NKAP,EK,EKAP                          !!! from readini
	USE COM_DELHAM,  ONLY : DHMAT                                      !!! from delmat
	USE COM_PSIVEC,  ONLY : APHK,APJK,APHQ,APJQ                        !!! from lmtvec
	USE COM_PHNCHN  ,ONLY : IUDMT                                      !!! from channels
	USE COM_MASHDEP, ONLY : NVAL                                       !!! from setup
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: DHHA(:)
	COMPLEX*16, ALLOCATABLE :: DJHA(:)
	COMPLEX*16, ALLOCATABLE :: DHJS(:)
	COMPLEX*16, ALLOCATABLE :: DJJS(:)
	COMPLEX*16, ALLOCATABLE :: DHA(:,:,:)
	COMPLEX*16, ALLOCATABLE :: DHS(:,:,:)
	DATA PI/3.141592653589793D0/
C Memory allocations
	ALLOCATE(DHHA(LIMTMEM))
	ALLOCATE(DJHA(LIMTMEM))
	ALLOCATE(DHJS(LIMTMEM))
	ALLOCATE(DJJS(LIMTMEM))
	ALLOCATE(DHA(LIMTMEM,NATOMMEM,NKAPMEM))
	ALLOCATE(DHS(LIMTMEM,NATOMMEM,NKAPMEM))
      IF(MODE.NE.5)IBNDMIN=1
      IF(MODE.NE.5)IBNDMAX=NBNDT(IPAN)+NBNDH(IPAN)
      IF(MODE.EQ.5)IBNDMIN=NBNDE(IPAN)
      IF(MODE.EQ.5)IBNDMAX=NBNDF(IPAN)
C  SET INITIAL VALUES
      DO IBNDS1=1,NSPIN
	DO IBNDT1=1,NBNDT(IPAN)+NBNDH(IPAN)
	IBAND1=IBNDS1+NSPIN*(IBNDT1-1)
      DO IBNDS=1,NSPIN
	DO IBNDT =1,NBNDT(IPAN)+NBNDH(IPAN)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	DHMAT(IBAND1,IBAND)=(0.D0,0.D0)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
      DO 6000 IORBS=1,NORBS          !!! over iorbs
      DO 5000 IUPDN=1,NSPIN          !!! over ispin
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
C  READ CHANGE IN POTENTIAL PARAMETERS
	DO IATOM=1,NATOM
      ISORT=IS(IATOM)
      DO IKAP1=1,NKAP(IPAN)
      DO IKAP=1,NKAP(IPAN)
      IREC=IKAP1+NKAP(IPAN)*(IKAP-1)+NKAP(IPAN)**2*(IATOM-1)+
     &NKAP(IPAN)**2*NATOM*(IUPDN-1)+
     &NKAP(IPAN)**2*NATOM*NSPIN*(IORBS-1)
      READ(IUDMT,REC=IREC)((DELHHH(L1M1,LM,IATOM,IKAP1,IKAP),
     &  L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &  ((DELHJH(L1M1,LM,IATOM,IKAP1,IKAP),
     &  L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &  ((DELHHJ(L1M1,LM,IATOM,IKAP1,IKAP),
     &  L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &  ((DELHJJ(L1M1,LM,IATOM,IKAP1,IKAP),
     &  L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2)
      ENDDO
      ENDDO
      ENDDO
C  **** CALCULATE SOFT CHANGE IN THE HAMILTONIAN AND OVERLAP MATRIX ****
      DO 4000 IBNDS=1,NSPIN                     !!! over spin subbands
	IF(NORBS.EQ.1.AND.IBNDS.NE.ISPIN)GOTO 4000
	DO 3000 IBNDT=IBNDMIN,IBNDMAX             !!! over all bands
	IBAND=IBNDS+NSPIN*(IBNDT-1)
C  FIND CONVOLUTIONS WITH THE CHANGE IN H-PAR AND O-PAR
	DO IKAP1=1,NKAP(IPAN)                  !!! over energies
	DO IATOM=1,NATOM                       !!! over atoms
	ISORT=IS(IATOM)
	DO L1=0,ILST(ISORT)                    !!! over l1
	DO M1=-L1,L1                           !!! over m1
	L1M1=L1*(L1+1)+M1+1
	DHHA(L1M1)=(0.D0,0.D0)
	DJHA(L1M1)=(0.D0,0.D0)
	DHJS(L1M1)=(0.D0,0.D0)
	DJJS(L1M1)=(0.D0,0.D0)
	DO IKAP=1,NKAP(IPAN)                   !!! over energies
	IF(IPAN.EQ.1.OR.(MODE.EQ.4.OR.MODE.EQ.5))THEN! only for valence panel
	DO L=0,ILST(ISORT)
	DO M=-L,L                              !!! over l
	LM=L*(L+1)+M+1                            !!! over m
	IF(LTPAN(L1,IATOM,IKAP1,IPAN).AND.LTPAN(L,IATOM,IKAP,IPAN))
     &DHHA(L1M1)=DHHA(L1M1)+
     &DELHHH(L1M1,LM,IATOM,IKAP1,IKAP)*
     &APHK(LM,IATOM,IKAP,ISPIN,IBAND)
	IF(LTPAN(L,IATOM,IKAP,IPAN))
     &DJHA(L1M1)=DJHA(L1M1)+
     &DELHJH(L1M1,LM,IATOM,IKAP1,IKAP)*
     &APHK(LM,IATOM,IKAP,ISPIN,IBAND)
	IF(LTPAN(L1,IATOM,IKAP1,IPAN))
     &DHJS(L1M1)=DHJS(L1M1)+
     &DELHHJ(L1M1,LM,IATOM,IKAP1,IKAP)*
     &APJK(LM,IATOM,IKAP,ISPIN,IBAND)
	DJJS(L1M1)=DJJS(L1M1)+
     &DELHJJ(L1M1,LM,IATOM,IKAP1,IKAP)*
     &APJK(LM,IATOM,IKAP,ISPIN,IBAND)
      ENDDO                                     !!! over m
      ENDDO                                     !!! over l
	ENDIF
      ENDDO                                     !!! over energies
	DHA(L1M1,IATOM,IKAP1)=+DHHA(L1M1)-DHJS(L1M1)
	DHS(L1M1,IATOM,IKAP1)=-DJHA(L1M1)+DJJS(L1M1)
      ENDDO                                     !!! over m1
      ENDDO                                     !!! over l1
      ENDDO                                     !!! over atoms
      ENDDO                                     !!! over energies
C ***** DO GLOBALLY OVER BANDS IBND1 ******
      DO 2000 IBNDS1=1,NSPIN                    !!! over spin subbands
	IF(NORBS.EQ.1.AND.IBNDS1.NE.ISPIN1)GOTO 2000
	DO 1000 IBNDT1=IBNDMIN,IBNDMAX            !!! over all bands
	IBAND1=IBNDS1+NSPIN*(IBNDT1-1)
	DO IKAP=1,NKAP(IPAN)                      !!! over energies
	DO IATOM=1,NATOM                          !!! over atoms
	ISORT=IS(IATOM)
	DO L=0,ILST(ISORT)                        !!! over l
	DO M=-L,L                                 !!! over m
	LM=L*(L+1)+M+1
C  ONE-, TWO- AND THREE-CENTER CONTRIBUTIONS TO THE CHANGE IN H-MATRIX
	IF((IPAN.EQ.1.AND.((IBNDT.LE.NBNDF(IPAN).AND.IBNDT1.GE.NBNDE(
     &  IPAN)).OR.(IBNDT.GE.NBNDE(IPAN).AND.IBNDT1.LE.NBNDF(IPAN))))
     &  .OR.(MODE.EQ.4.OR.MODE.EQ.5))THEN 
	IF(LTPAN(L,IATOM,IKAP,IPAN))
     &DHMAT(IBAND1,IBAND)=DHMAT(IBAND1,IBAND)+
     &CONJG(APHQ(LM,IATOM,IKAP,ISPIN1,IBAND1))*DHA(LM,IATOM,IKAP)
	DHMAT(IBAND1,IBAND)=DHMAT(IBAND1,IBAND)+
     &CONJG(APJQ(LM,IATOM,IKAP,ISPIN1,IBAND1))*DHS(LM,IATOM,IKAP)
	ENDIF
      ENDDO                                     !!! over m
      ENDDO                                     !!! over l
      ENDDO                                     !!! over atoms
      ENDDO                                     !!! over energies
 1000 CONTINUE                                 !!! over all bands
 2000 CONTINUE                                 !!! over spin subbands
 3000 CONTINUE                                 !!! over all bands
 4000 CONTINUE                                 !!! over spin subbands
 5000 CONTINUE                                 !!! over spins
 6000 CONTINUE                                 !!! over spins
C Memory deallocations
	DEALLOCATE(DHHA,DJHA,DHJS,DJJS,DHA,DHS)
	END
