	SUBROUTINE PLZ_SPLZMTS(IPTB,IPAN,IQPNT)
**********************************************************
* The calculation of the polarizability within MTS.      *
**********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
     &                       ,LRTV
	USE COM_RADMESH, ONLY : NRAD,H,R,DR,WEIGHT                         !!! from radmsh
	USE COM_PANPAR,  ONLY : LTPAN,LSPAN,IATS,ISTS                      !!! from readini
	USE COM_KAPPAR,  ONLY : NPAN,NKAP,EK,EKAP                          !!! from readini
	USE COM_SPHERE,  ONLY : SWZ,SMT                                    !!! from readini
	USE COM_GAUNT,   ONLY : C                                          !!! from makegnt
	USE COM_SYMMLM,  ONLY : SYM                                        !!! from makesym
      USE COM_SUMPAR,  ONLY : PHH,PJH,PHJ,PJJ                            !!! from ovrpar
	USE COM_DHAMPAR, ONLY : DTOSHH=>DELHHH                             !!! from tospar
     &                       ,DTOSJH=>DELHJH
     &                       ,DTOSHJ=>DELHHJ
     &                       ,DTOSJJ=>DELHJJ 
	USE COM_POTDAT,  ONLY : POTRWF                                     !!! from fulpot
      USE COM_INPPAR,  ONLY : TNY,ENY,DNY                                !!! from readini
	USE COM_LMTPAR,  ONLY : GAM,AAH,BBH,AAJ,BBJ                        !!! from potpar
      USE COM_DELRHO,  ONLY : DRHO                                       !!! from plzmts
      USE COM_DELHUB,  ONLY : DELGHUB                                    !!! from plzfiles
	USE COM_PHNCHN  ,ONLY : IUPLY,IUDTS                                !!! from channels
	USE COM_MASHDEP, ONLY : NVAL                                       !!! from setup
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: FIH(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: FIHD(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: FIJ(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: FIJD(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: FIHDD(:,:)
	COMPLEX*16, ALLOCATABLE :: FIJDD(:,:)
	REAL*8, ALLOCATABLE :: AFI(:,:)
	REAL*8, ALLOCATABLE :: AFID(:,:)
	REAL*8, ALLOCATABLE :: AFIP(:,:)
	REAL*8, ALLOCATABLE :: AFIDP(:,:)
	REAL*8, ALLOCATABLE :: AFIDDS(:)
	REAL*8, ALLOCATABLE :: AFIDDPS(:)
	COMPLEX*16 CGNT,T(4),SUM
	LOGICAL LOG1,LOG
	DATA PI/3.141592653589793D0/
	IF(MODE.EQ.5)RETURN
C Memory allocations
	ALLOCATE(FIH(0:NRADMEM,0:LMAXTMEM,NKAPMEM,NSPINMEM))
	ALLOCATE(FIHD(0:NRADMEM,0:LMAXTMEM,NKAPMEM,NSPINMEM))
	ALLOCATE(FIJ(0:NRADMEM,0:LMAXTMEM,NKAPMEM,NSPINMEM))
	ALLOCATE(FIJD(0:NRADMEM,0:LMAXTMEM,NKAPMEM,NSPINMEM))
	ALLOCATE(FIHDD(0:LMAXTMEM,NKAPMEM))
	ALLOCATE(FIJDD(0:LMAXTMEM,NKAPMEM))
	ALLOCATE(AFI(0:NRADMEM,0:LMAXTMEM))
	ALLOCATE(AFID(0:NRADMEM,0:LMAXTMEM))
	ALLOCATE(AFIP(0:NRADMEM,0:LMAXTMEM))
	ALLOCATE(AFIDP(0:NRADMEM,0:LMAXTMEM))
	ALLOCATE(AFIDDS(0:LMAXTMEM))
	ALLOCATE(AFIDDPS(0:LMAXTMEM))
	SQPI4=2.D0*SQRT(PI)
      CALL PLZ_PLZFILES(IPTB,IQPNT,IUPLY,'R',' ')!!! read polarizability
	DO 1000 IATOM=1,NATOM                      !!! over atoms in cell
	ISORT=IS(IATOM)
C  Find FIny and FIny-dot radial functions as well as their variations
      DO ISPIN=1,NSPIN                           !!! over spins
	DO IKAP=1,NKAP(IPAN)                       !!! over energies
	CALL LIB_RADSCH_PHIS(ENY(0,ISORT,IKAP,IPAN,ISPIN),
     &AFI,AFIP,AFID,AFIDP,AFIDDS,AFIDDPS,SMT(ISORT),
     &POTRWF(0,ISORT,ISPIN),ILST(ISORT),NRAD(ISORT),
     &H(ISORT),R(0,ISORT),DR(0,ISORT),LRTV(ISORT))
C  Transfere to FIH,FIJ,DELFIH,DELFIJ convinient functions:
	DO L=0,ILST(ISORT)
	DO IRAD=0,NRAD(ISORT)
	FIH(IRAD,L,IKAP,ISPIN)=
     &AAH(L,ISORT,IKAP,IPAN,ISPIN)*AFI (IRAD,L)+
     &BBH(L,ISORT,IKAP,IPAN,ISPIN)*AFIP(IRAD,L)
	FIJ(IRAD,L,IKAP,ISPIN)=
     &AAJ(L,ISORT,IKAP,IPAN,ISPIN)*AFI (IRAD,L)+
     &BBJ(L,ISORT,IKAP,IPAN,ISPIN)*AFIP(IRAD,L)
      ENDDO   
      ENDDO   
      ENDDO                                      !!! over energies
      ENDDO                                      !!! over spins
      DO IORBS=1,NORBS                           !!! over iorbs
      DO IUPDN=1,NSPIN                           !!! over iupdn
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
	DO IKAP1=1,NKAP(IPAN)                      !!! over energies
	DO IKAP=1,NKAP(IPAN)                       !!! over energies
C READ CHANGE IN THE TOS-MATRIX
      IREC=IKAP1+NKAP(IPAN)*(IKAP-1)+
     &NKAP(IPAN)**2*(IATOM-1)+
     &NKAP(IPAN)**2*NATOM*(IUPDN-1)+
     &NKAP(IPAN)**2*NATOM*NSPIN*(IORBS-1)
      READ(IUDTS,REC=IREC)
     &((DTOSHH(L1M1,LM,IATOM,IKAP1,IKAP),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((DTOSJH(L1M1,LM,IATOM,IKAP1,IKAP),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((DTOSHJ(L1M1,LM,IATOM,IKAP1,IKAP),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &((DTOSJJ(L1M1,LM,IATOM,IKAP1,IKAP),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2)
C  CALCULATE CONTRIBUTION GOING FROM THE CHANGE IN THE TOS-MATRIX
	DO L1=0,ILST(ISORT)                        !!! over l1
	LOG1=.FALSE.
	IF(LTPAN(L1,IATOM,IKAP1,IPAN))LOG1=.TRUE.
	DO M1=-L1,L1                               !!! over m1
	LM1=L1*(L1+1)+M1+1
	DO L=0,ILST(ISORT)                         !!! over l
	LOG=.FALSE.
	IF(LTPAN(L,IATOM,IKAP,IPAN))LOG=.TRUE.
	DO M=-L,L                                  !!! over m
	LM=L*(L+1)+M+1
	DO L2=ABS(L1-L),L1+L,2                     !!! over l2 (expansion of dro)
	M2=M-M1
	LM2=L2*(L2+1)+M2+1
	IF(ABS(M2).LE.L2.AND.L2.LE.ILSV(ISORT))THEN!!! over m2 (expansion of dro)
	CGNT=(0.D0,1.D0)**(L-L1-L2)*C(L2/2,LM,LM1)
	DO IRAD=0,NRAD(ISORT)                      !!! over radial mesh
	IF(LOG1.AND.LOG)
     &DRHO(IRAD,LM2,IATOM,IUPDN,IORBS)=
     &DRHO(IRAD,LM2,IATOM,IUPDN,IORBS)+
     &DTOSHH(LM1,LM,IATOM,IKAP1,IKAP)*
     &CONJG(FIH(IRAD,L1,IKAP1,ISPIN1))*FIH(IRAD,L,IKAP,ISPIN)*CGNT
	IF(LOG1)
     &DRHO(IRAD,LM2,IATOM,IUPDN,IORBS)=
     &DRHO(IRAD,LM2,IATOM,IUPDN,IORBS)-
     &DTOSHJ(LM1,LM,IATOM,IKAP1,IKAP)*
     &CONJG(FIH(IRAD,L1,IKAP1,ISPIN1))*FIJ(IRAD,L,IKAP,ISPIN)*
     &GAM(L,ISORT)*CGNT
	IF(LOG)
     &DRHO(IRAD,LM2,IATOM,IUPDN,IORBS)=
     &DRHO(IRAD,LM2,IATOM,IUPDN,IORBS)-
     &DTOSJH(LM1,LM,IATOM,IKAP1,IKAP)*
     &CONJG(FIJ(IRAD,L1,IKAP1,ISPIN1))*FIH(IRAD,L,IKAP,ISPIN)*
     &GAM(L1,ISORT)*CGNT
	DRHO(IRAD,LM2,IATOM,IUPDN,IORBS)=
     &DRHO(IRAD,LM2,IATOM,IUPDN,IORBS)+
     &DTOSJJ(LM1,LM,IATOM,IKAP1,IKAP)*
     &CONJG(FIJ(IRAD,L1,IKAP1,ISPIN1))*
     &FIJ(IRAD,L,IKAP,ISPIN)*GAM(L1,ISORT)*GAM(L,ISORT)*CGNT
      ENDDO                                      !!! over radial mesh
	ENDIF                                      !!! over m2 (expansion of dro)
      ENDDO                                      !!! over l2 (expansion of dro)
      ENDDO                                      !!! over m
      ENDDO                                      !!! over l
      ENDDO                                      !!! over m1
      ENDDO                                      !!! over l1
C  COMPUTE OCCUPATION NUMBERS
	DO L=0,ILSB(ISORT)                         !!! over l
      DO M1=-L,L                                 !!! over m1
      LM1=L*(L+1)+M1+1
      DO M=-L,L                                  !!! over m
      LM=L*(L+1)+M+1
      IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M1+1 ! ! (l,m'm)
	SUM=(0.D0,0.D0)
      IF(LSPAN(L,ISORT,IKAP1,IPAN).AND.LSPAN(L,ISORT,IKAP,IPAN))THEN
      SUM=SUM+DTOSHH(LM1,LM,IATOM,IKAP1,IKAP)*
     &        PHH(IKAP1,IKAP,L,ISORT,IPAN,IUPDN,IORBS)
      SUM=SUM-DTOSHJ(LM1,LM,IATOM,IKAP1,IKAP)*
     &        PHJ(IKAP1,IKAP,L,ISORT,IPAN,IUPDN,IORBS)
      SUM=SUM-DTOSJH(LM1,LM,IATOM,IKAP1,IKAP)*
     &        PJH(IKAP1,IKAP,L,ISORT,IPAN,IUPDN,IORBS)
      ENDIF
      SUM=SUM+DTOSJJ(LM1,LM,IATOM,IKAP1,IKAP)*
     &        PJJ(IKAP1,IKAP,L,ISORT,IPAN,IUPDN,IORBS)
	DELGHUB(IU,IATOM,IUPDN,IORBS)=
     &DELGHUB(IU,IATOM,IUPDN,IORBS)+SUM
	ENDDO                                      !!! over m1
      ENDDO                                      !!! over m
      ENDDO                                      !!! over l
      ENDDO                                      !!! over energies
      ENDDO                                      !!! over energies
      ENDDO                                      !!! over iupdn
      ENDDO                                      !!! over iorbs
1000  CONTINUE                                   !!! over all atoms in cell
      CALL PLZ_PLZFILES(IPTB,IQPNT,IUPLY,'W',' ')!!! store polarizability
C Memory deallocations
	DEALLOCATE(FIH,FIHD,FIJ,FIJD,FIHDD,FIJDD)
	DEALLOCATE(AFI,AFID,AFIP,AFIDP,AFIDDS,AFIDDPS)
	END
