	SUBROUTINE PLZ_SPLZPAR(IPTB,IPAN,IQPNT)
***************************************************************
*   Calculate radial matrix elements for a perturbation       *
*   given by the long-range part of the potential within      *
*   MT-spheres.                                               *
***************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
     &                       ,LRTV
	USE COM_RADMESH, ONLY : NRAD,H,R,DR,WEIGHT,RL                      !!! from radmsh
	USE COM_LATPAR,  ONLY : PAR,ORTH,OMEGAC                            !!! from readini
	USE COM_KAPPAR,  ONLY : NPAN,NKAP,EK,EKAP                          !!! from readini
	USE COM_PANPAR,  ONLY : LTPAN,LSPAN,IATS,ISTS                      !!! from readini
	USE COM_QMESH,   ONLY : NQPNT,QPNT                                 !!! from readpnt
	USE COM_SPHERE,  ONLY : SWZ,SMT                                    !!! from readini
	USE COM_LMTPAR,  ONLY : GAM,AAH,BBH,AAJ,BBJ                        !!! from potpar
      USE COM_PLZCOM,  ONLY : NPLZ,LPLZ,IPLZ,NPTB,QPTB,INDPTB            !!! from readlrt
      USE COM_INPPAR,  ONLY : TNY,ENY,DNY                                !!! from readini
	USE COM_DHAMPAR, ONLY : DELHHH,DELHJH,DELHHJ,DELHJJ                !!! from intpar
	USE COM_POTDAT,  ONLY : POT,POTRWF                                 !!! from fulpot
	USE COM_GAUNT,   ONLY : C                                          !!! from makegnt
	USE COM_LATTICE, ONLY : TAU                                        !!! from readstr
	USE COM_DELPOT,  ONLY : DPOT                                       !!! from potfiles
	USE COM_SYMMLM,  ONLY : SYM,LMSYM                                  !!! from makesym
	USE COM_MASHDEP, ONLY : NVAL                                       !!! from setup
	USE COM_LMTOUT,  ONLY : SCRFILE                                    !!! from setup
	USE COM_PHNCHN  ,ONLY : IUDMT                                      !!! from channels
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: RADMAT(:,:,:,:)
      COMPLEX*16, ALLOCATABLE :: WORK1(:)
      COMPLEX*16, ALLOCATABLE :: WORK2(:)
	COMPLEX*16, ALLOCATABLE :: FIH(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: FIJ(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: YLM(:)
	COMPLEX*16, ALLOCATABLE :: DPT(:,:)
	REAL*8, ALLOCATABLE :: AFI(:,:)
	REAL*8, ALLOCATABLE :: AFID(:,:)
	REAL*8, ALLOCATABLE :: AFIP(:,:)
	REAL*8, ALLOCATABLE :: AFIDP(:,:)
	REAL*8, ALLOCATABLE :: AFIDDS(:)
	REAL*8, ALLOCATABLE :: AFIDDPS(:)
	REAL*8, ALLOCATABLE :: BES(:)
	REAL*8, ALLOCATABLE :: BESD(:)
	COMPLEX*16 EXPQR
	LOGICAL LOG1,LOG,EXIST
	DATA PI/3.141592653589793D0/
C Memory allocations
	ALLOCATE(RADMAT(4,0:LMAXTMEM,0:LMAXTMEM,LIMVMEM))
      ALLOCATE(WORK1(0:NRADMEM))
      ALLOCATE(WORK2(0:NRADMEM))
	ALLOCATE(FIH(0:NRADMEM,0:LMAXTMEM,NKAPMEM,NSPINMEM))
	ALLOCATE(FIJ(0:NRADMEM,0:LMAXTMEM,NKAPMEM,NSPINMEM))
	ALLOCATE(AFI(0:NRADMEM,0:LMAXTMEM))
	ALLOCATE(AFID(0:NRADMEM,0:LMAXTMEM))
	ALLOCATE(AFIP(0:NRADMEM,0:LMAXTMEM))
	ALLOCATE(AFIDP(0:NRADMEM,0:LMAXTMEM))
	ALLOCATE(AFIDDS(0:LMAXTMEM))
	ALLOCATE(AFIDDPS(0:LMAXTMEM))
	ALLOCATE(YLM(LIMVMEM))
	ALLOCATE(BES(-1:LMAXVMEM))
	ALLOCATE(BESD(0:LMAXVMEM))
C SCRATCH FILE FOR STORING CHANGE IN POTENTIAL PARAMETERS
      NRECL=0
      DO IATOM=1,NATOM
      ISORT=IS(IATOM)
      LMAXH=((ILSB(ISORT)+1)**2+(ILST(ISORT)+1)**2)**2
      NRECL=MAX(NRECL,NVAL*LMAXH)
      ENDDO
      OPEN(UNIT=IUDMT,FILE=SCRFILE(IUDMT),STATUS='NEW',
     &  FORM='UNFORMATTED',ACCESS='DIRECT',RECL=NRECL)
C  *** DO GLOBALLY OVER ATOMS IN CELL ***
      DO IORBS=1,NORBS          !!! over iorbs
      DO IUPDN=1,NSPIN          !!! over ispin
	DO IATOM=1,NATOM          !!! over atoms
	ISORT=IS(IATOM)
C  SET PERTURBATIVE POTENTIAL
      QX=QPTB(1,IPTB)*2.D0*PI/PAR
      QY=QPTB(2,IPTB)*2.D0*PI/PAR
      QZ=QPTB(3,IPTB)*2.D0*PI/PAR
      AQ=SQRT(QX**2+QY**2+QZ**2)
      IF(AQ.GE.1.D-10)THEN
      CALL LIB_SPHHARM(QX/AQ,QY/AQ,QZ/AQ,ILSV(ISORT),YLM)
      ELSE
      YLM(1)=1.D0/SQRT(4.D0*PI)
      DO LM=2,(ILSV(ISORT)+1)**2
      YLM(LM)=(0.D0,0.D0)
	ENDDO
      ENDIF
      CALL LIB_BESSR(AQ*SMT(ISORT),BES(0),BESD(0),ILSV(ISORT))
	DO L=0,ILSV(ISORT)
	BES(L)=BES(L)*AQ*SMT(ISORT)
	ENDDO
      BES(-1)=COS(AQ*SMT(ISORT))
      SCP=QPTB(1,IPTB)*TAU(1,IATOM)+
     &    QPTB(2,IPTB)*TAU(2,IATOM)+
     &    QPTB(3,IPTB)*TAU(3,IATOM)
      EXPQR=EXP((0.D0,1.D0)*2.D0*PI*SCP)
      DO L=0,ILSV(ISORT)             !!! over l
      DO M=-L,L                      !!! over m
      LM=L*(L+1)+M+1
      IF(IORBS.EQ.1)THEN
      DO IRAD=0,NRAD(ISORT)          !!! over radial mesh
      DPOT(IRAD,LM,IATOM,IUPDN,IORBS)=RL(IRAD,L,ISORT)/
     &SMT(ISORT)**L/DBLE(2*L+1)*EXPQR*DCONJG(YLM(LM))*
     &4.D0*PI*BES(L-1)
      ENDDO                          !!! over radial mesh
      ELSEIF(IORBS.EQ.2)THEN
      DO IRAD=0,NRAD(ISORT)          !!! over radial mesh
      DPOT(IRAD,LM,IATOM,IUPDN,IORBS)=(0.D0,0.D0)
      ENDDO                          !!! over radial mesh
      ENDIF
      ENDDO                          !!! over m
      ENDDO                          !!! over l
      ENDDO                          !!! over atoms
      ENDDO                          !!! over spins
      ENDDO                          !!! over iorbs
C  COMPUTE MATRIX ELEMENTS
      DO 5000 IORBS=1,NORBS          !!! over iorbs
      DO 4000 IUPDN=1,NSPIN          !!! over ispin
	DO 3000 IATOM=1,NATOM          !!! over atoms
	ISORT=IS(IATOM)
C  Find FIny and FIny-dot radial functions as well as their variations
      DO ISPIN=1,NSPIN               !!! over spins
	DO IKAP=1,NKAP(IPAN)           !!! over energies
	CALL LIB_RADSCH_PHIS(ENY(0,ISORT,IKAP,IPAN,ISPIN),AFI,AFIP,
     &AFID,AFIDP,AFIDDS,AFIDDPS,SMT(ISORT),POTRWF(0,ISORT,ISPIN),
     &ILST(ISORT),NRAD(ISORT),H(ISORT),R(0,ISORT),DR(0,ISORT),
     &LRTV(ISORT))
C  Transfere to FIH,FIJ convinient functions:
	DO L=0,ILST(ISORT)
	DO IRAD=0,NRAD(ISORT)
	FIH(IRAD,L,IKAP,ISPIN)=
     &AAH(L,ISORT,IKAP,IPAN,ISPIN)*AFI (IRAD,L)+
     &BBH(L,ISORT,IKAP,IPAN,ISPIN)*AFIP(IRAD,L)
	FIJ(IRAD,L,IKAP,ISPIN)=
     &AAJ(L,ISORT,IKAP,IPAN,ISPIN)*AFI (IRAD,L)+
     &BBJ(L,ISORT,IKAP,IPAN,ISPIN)*AFIP(IRAD,L)
      ENDDO    
      ENDDO   
      ENDDO                          !!! over energies
      ENDDO                          !!! over spins
	IF(IORBS.EQ.1)THEN
	IUPDN1=IUPDN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	SIGNF=1.D0
	ELSEIF(IORBS.EQ.2)THEN
	IUPDN1=NSPIN+1-IUPDN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	IF(ISPIN1.EQ.1.AND.ISPIN.EQ.2)SIGNF=-SQRT(2.D0) ! B^{+} * <S_{+}>
	IF(ISPIN1.EQ.2.AND.ISPIN.EQ.1)SIGNF=+SQRT(2.D0) ! B^{-} * <S_{-}>
	ENDIF
C  *** DO GLOBALLY OVER ENERGIES ***
	DO 2000 IKAP1=1,NKAP(IPAN)     !!! over ikap1
	DO 1000 IKAP=1,NKAP(IPAN)      !!! over ikap
C  CALCULATE DIFFERENT RADIAL MATRIX ELEMENTS
	DO L1=0,ILST(ISORT)            !!! over l1
	LOG1=.FALSE.
	IF(LTPAN(L1,IATOM,IKAP1,IPAN))LOG1=.TRUE.
	DO L=0,ILST(ISORT)             !!! over l
	LOG=.FALSE.
	IF(LTPAN(L,IATOM,IKAP,IPAN))LOG=.TRUE.
	DO L2=ABS(L1-L),L1+L,2         !!! over l2
	IF(L2.LE.ILSV(ISORT))THEN
	DO M2=-L2,L2                   !!! over m2
	L2M2=L2*(L2+1)+M2+1
	RADMAT(1,L1,L,L2M2)=(0.D0,0.D0)
	RADMAT(2,L1,L,L2M2)=(0.D0,0.D0)
	RADMAT(3,L1,L,L2M2)=(0.D0,0.D0)
	RADMAT(4,L1,L,L2M2)=(0.D0,0.D0)
	IF(LOG1.AND.LOG)THEN
	DO IRAD=0,NRAD(ISORT)          !!! over radial mesh
	WORK1(IRAD)=CONJG(FIH(IRAD,L1,IKAP1,ISPIN1))*
     &FIH(IRAD,L,IKAP,ISPIN)*DPOT(IRAD,L2M2,IATOM,IUPDN1,IORBS)*
     &R(IRAD,ISORT)**2*DR(IRAD,ISORT)
      ENDDO                          !!! over radial mesh
	CALL LIB_CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	RADMAT(1,L1,L,L2M2)=RADMAT(1,L1,L,L2M2)+
     &WORK2(NRAD(ISORT))*SIGNF
	ENDIF
	IF(LOG)THEN
	DO IRAD=0,NRAD(ISORT)          !!! over radial mesh
	WORK1(IRAD)=CONJG(FIJ(IRAD,L1,IKAP1,ISPIN1))*
     &FIH(IRAD,L,IKAP,ISPIN)*DPOT(IRAD,L2M2,IATOM,IUPDN1,IORBS)*
     &R(IRAD,ISORT)**2*DR(IRAD,ISORT)
      ENDDO                          !!! over radial mesh
	CALL LIB_CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	RADMAT(2,L1,L,L2M2)=RADMAT(2,L1,L,L2M2)+
     &WORK2(NRAD(ISORT))*SIGNF
	ENDIF
	IF(LOG1)THEN
	DO IRAD=0,NRAD(ISORT)          !!! over radial mesh
	WORK1(IRAD)=CONJG(FIH(IRAD,L1,IKAP1,ISPIN1))*
     &FIJ(IRAD,L,IKAP,ISPIN)*DPOT(IRAD,L2M2,IATOM,IUPDN1,IORBS)*
     &R(IRAD,ISORT)**2*DR(IRAD,ISORT)
      ENDDO                          !!! over radial mesh
	CALL LIB_CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	RADMAT(3,L1,L,L2M2)=RADMAT(3,L1,L,L2M2)+
     &WORK2(NRAD(ISORT))*SIGNF
	ENDIF
	DO IRAD=0,NRAD(ISORT)          !!! over radial mesh
	WORK1(IRAD)=CONJG(FIJ(IRAD,L1,IKAP1,ISPIN1))*
     &FIJ(IRAD,L,IKAP,ISPIN)*DPOT(IRAD,L2M2,IATOM,IUPDN1,IORBS)*
     &R(IRAD,ISORT)**2*DR(IRAD,ISORT)
      ENDDO                          !!! over radial mesh
	CALL LIB_CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	RADMAT(4,L1,L,L2M2)=RADMAT(4,L1,L,L2M2)+
     &WORK2(NRAD(ISORT))*SIGNF
      ENDDO                          !!! over m2
	ENDIF
      ENDDO                          !!! over l2
      ENDDO                          !!! over l
      ENDDO                          !!! over l1
C  CALCULATE POTENTIAL PARAMETERS VARIATIONS
	DO L1=0,ILST(ISORT)            !!! over l1
	LOG1=.FALSE.
	IF(LTPAN(L1,IATOM,IKAP1,IPAN))LOG1=.TRUE.
	DO M1=-L1,L1                   !!! over m1
	L1M1=L1*(L1+1)+M1+1
	DO L=0,ILST(ISORT)             !!! over l
	LOG=.FALSE.
	IF(LTPAN(L,IATOM,IKAP,IPAN))LOG=.TRUE.
	DO M=-L,L                      !!! over m
	LM=L*(L+1)+M+1
	IF(LOG1.AND.LOG)
     &DELHHH(L1M1,LM,IATOM,IKAP1,IKAP)=(0.D0,0.D0)
	IF(LOG )DELHJH(L1M1,LM,IATOM,IKAP1,IKAP)=(0.D0,0.D0)
	IF(LOG1)DELHHJ(L1M1,LM,IATOM,IKAP1,IKAP)=(0.D0,0.D0)
	DELHJJ(L1M1,LM,IATOM,IKAP1,IKAP)=(0.D0,0.D0)
	DO L2=ABS(L1-L),L1+L,2         !!! over l2
	LL2=L2/2
	M2=M1-M
	L2M2=L2*(L2+1)+M2+1
	IF(ABS(M2).LE.L2.AND.L2.LE.ILSV(ISORT))THEN
	IF(LOG1.AND.LOG)
     &DELHHH(L1M1,LM,IATOM,IKAP1,IKAP)=
     &DELHHH(L1M1,LM,IATOM,IKAP1,IKAP)+
     &(0.D0,1.D0)**(L2+L-L1)*C(LL2,L1M1,LM)*
     &RADMAT(1,L1,L,L2M2)
	IF(LOG)
     &DELHJH(L1M1,LM,IATOM,IKAP1,IKAP)=
     &DELHJH(L1M1,LM,IATOM,IKAP1,IKAP)+
     &(0.D0,1.D0)**(L2+L-L1)*C(LL2,L1M1,LM)*
     &RADMAT(2,L1,L,L2M2)*GAM(L1,ISORT)
	IF(LOG1)
     &DELHHJ(L1M1,LM,IATOM,IKAP1,IKAP)=
     &DELHHJ(L1M1,LM,IATOM,IKAP1,IKAP)+
     &(0.D0,1.D0)**(L2+L-L1)*C(LL2,L1M1,LM)*
     &RADMAT(3,L1,L,L2M2)*GAM(L,ISORT)
	DELHJJ(L1M1,LM,IATOM,IKAP1,IKAP)=
     &DELHJJ(L1M1,LM,IATOM,IKAP1,IKAP)+
     &(0.D0,1.D0)**(L2+L-L1)*C(LL2,L1M1,LM)*
     &RADMAT(4,L1,L,L2M2)*GAM(L1,ISORT)*GAM(L,ISORT)
	ENDIF                          !!! over m2
      ENDDO                          !!! over l2
      ENDDO                          !!! over m
      ENDDO                          !!! over l
      ENDDO                          !!! over m1
      ENDDO                          !!! over l1
C  STORE CHANGE IN POTENTIAL PARAMETERS
      IREC=IKAP1+NKAP(IPAN)*(IKAP-1)+NKAP(IPAN)**2*(IATOM-1)+
     &NKAP(IPAN)**2*NATOM*(IUPDN-1)+
     &NKAP(IPAN)**2*NATOM*NSPIN*(IORBS-1)
      WRITE(IUDMT,REC=IREC)((DELHHH(L1M1,LM,IATOM,IKAP1,IKAP),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((DELHJH(L1M1,LM,IATOM,IKAP1,IKAP),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((DELHHJ(L1M1,LM,IATOM,IKAP1,IKAP),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &((DELHJJ(L1M1,LM,IATOM,IKAP1,IKAP),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2)
 1000  CONTINUE                       !!! over ikap
 2000  CONTINUE                       !!! over ikap1
 3000  CONTINUE                       !!! over atoms
 4000  CONTINUE                       !!! over spins
 5000  CONTINUE                       !!! over spins
C Memory deallocations
	DEALLOCATE(RADMAT,WORK1,WORK2)
	DEALLOCATE(FIH,FIJ,AFI,AFID,AFIP,AFIDP,AFIDDS,AFIDDPS)
	DEALLOCATE(YLM,BES,BESD)
	END
