	SUBROUTINE PLZ_SPLZPIN(IPTB,IPAN,IQPNT)
*********************************************************
* Calculates convolution of pseudopotential with inter- *
* stitial plane-wave integral.                          *
*********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
      USE COM_PLZCOM,  ONLY : NPLZ,LPLZ,IPLZ,NPTB,QPTB,INDPTB            !!! from readlrt
      USE COM_PLWMESH, ONLY : NPLW,GPLW,KVEC,KGMIN,KGMAX,INDG            !!! from makeplw
	USE COM_LATPAR,  ONLY : PAR,ORTH,OMEGAC                            !!! from readini
	USE COM_DELPOT,  ONLY : DPOTPS,DPOTPS1                             !!! from delpot
	USE COM_SPHERE,  ONLY : SWZ,SMT                                    !!! from readini
      USE COM_PLW2MSH, ONLY : N2PLW,G2PLW,INDG2   	                   !!! from makeplw
	USE COM_QMESH,   ONLY : NQPNT,QPNT                                 !!! from readpnt
	USE COM_MASHDEP, ONLY : NVAL                                       !!! from setup
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16 GVAL
	COMPLEX*16, ALLOCATABLE :: GINT(:)
	DATA PI/3.141592653589793D0/
	ALLOCATE(GINT(0:9*NPLWMEM))
	M1D=2*KGMAX(1)-2*KGMIN(1)+1
	M2D=2*KGMAX(2)-2*KGMIN(2)+1
	M3D=2*KGMAX(3)-2*KGMIN(3)+1
	M12D=M1D*M2D
	M123D=M1D*M2D*M3D
      DO 2000 IORBS=1,NORBS                !!! over iorbs
      DO 1000 IUPDN=1,NSPIN                !!! over ispin
C  SET PERTURBATIVE PSEUDOPOTENTIAL TO EXP(iqr)
	DO IPLW=0,NPLW                       !!! over plane waves
	DPOTPS(IPLW,IUPDN,IORBS)=(0.D0,0.D0)
	IF(IPLW.EQ.INDPTB(IPTB).AND.IORBS.EQ.1)
     &DPOTPS(IPLW,IUPDN,IORBS)=(1.D0,0.D0)
      ENDDO                                !!! over plane waves
C  SET CONVOLUTION FOR THE CHANGE IN THE PSEUDOPOTENTIAL
	CALL MAKEPLW_WINT(GINT)              !!! take the integral for PWs
	DO IPLW=0,NPLW                       !!! over plane waves
	DPOTPS1(IPLW,IUPDN,IORBS)=(0.D0,0.D0)
	M1I=KVEC(1,IPLW)+2*KGMIN(1)
	M2I=KVEC(2,IPLW)+2*KGMIN(2)
	M3I=KVEC(3,IPLW)+2*KGMIN(3)
	DO JPLW=0,NPLW                       !!! over plane waves
      M1=KVEC(1,JPLW)-M1I
      M2=KVEC(2,JPLW)-M2I
      M3=KVEC(3,JPLW)-M3I
      IDIM=1+M1+M1D*M2+M12D*M3
	I2PLW=INDG2(IDIM)
	DPOTPS1(IPLW,IUPDN,IORBS)=DPOTPS1(IPLW,IUPDN,IORBS)+
     &DPOTPS(JPLW,IUPDN,IORBS)*GINT(I2PLW)
      ENDDO                                !!! over plane waves
      ENDDO                                !!! over plane waves
 1000 CONTINUE
 2000 CONTINUE
	DEALLOCATE(GINT)
	END
