	SUBROUTINE PLZ_SPLZSYM(IQPNT)
********************************************************
*  Symmetrizes polarizability over group of q-vector.  *
********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
      USE COM_PHNCOM,  ONLY : ITERMAX,NITER                              !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_RADMESH, ONLY : NRAD,H,R                                   !!! from makerad
	USE COM_QMESH,   ONLY : NQPNT,QPNT                                 !!! from readpnt
      USE COM_PLZCOM,  ONLY : NPLZ,LPLZ,IPLZ,NPTB,QPTB,INDPTB,INPTBR     !!! from readlrt
      USE COM_GROUPS,  ONLY : NGROUP,U,SJ,IP,RDC,SHIFT,INV,IKOV          !!! from makegrp
	USE COM_SUBGROUP,ONLY : NSGQ,NGEQ,ISG                              !!! from delmesh
	USE COM_SPHERE,  ONLY : SWZ,SMT                                    !!! from readini
      USE COM_DELRHO,  ONLY : DRHO                                       !!! from plzmts
      USE COM_DELHUB,  ONLY : DELDHUB,DELVHUB,DELTHUB,DELGHUB            !!! from plzfiles
	USE COM_PHNCHN  ,ONLY : IUPLZ,IUPLY                                !!! from channels
	USE COM_MASHDEP, ONLY : NVAL                                       !!! from setup
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: SRHO(:,:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: DELSHUB(:,:,:,:)
	COMPLEX*16 PHSQ
	DIMENSION QPNT0(3)
      DATA PI/3.141592653589793D0/
C Memory allocations
	ALLOCATE(SRHO(0:NRADMEM,LIMVMEM,NATOMMEM,NSPINMEM,NORBSMEM))
	ALLOCATE(DELSHUB(LIMB2MEM,NATOMMEM,NSPINMEM,NORBSMEM))
C *** DO GLOBALLY OVER PERTURBATION VECTORS ***
      DO 2000 IPTB=1,NPTB                  !!! over {q+G}-vectors
	CALL PLZ_PLZFILES(IPTB,IQPNT,IUPLZ,'I',' ') !!! initialize file
      DO IATOM=1,NATOM
      ISORT=IS(IATOM)
      DO IORBS=1,NORBS
      DO IUPDN=1,NSPIN
      DO L=0,ILSV(ISORT)
      DO M=-L,L
      LM=L*(L+1)+M+1
      DO IRAD=0,NRAD(ISORT)
      SRHO(IRAD,LM,IATOM,IUPDN,IORBS)=(0.D0,0.D0)
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      ENDDO
	DO IORBS=1,NORBS                           !!! over iorbs
	DO IUPDN=1,NSPIN                           !!! over spins
	DO IATOM=1,NATOM                           !!! over atoms
	ISORT=IS(IATOM) 
	DO L=0,ILSB(ISORT)                         !!! over l
      DO M1=-L,L                                 !!! over m1
      LM1=L*(L+1)+M1+1
      DO M=-L,L                                  !!! over m
      LM=L*(L+1)+M+1
      IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M1+1 ! ! (l,m'm)
      DELSHUB(IU,IATOM,IUPDN,IORBS)=(0.D0,0.D0)
	ENDDO                                      !!! over m1
      ENDDO                                      !!! over m
      ENDDO                                      !!! over l
      ENDDO                                      !!! over atoms
	ENDDO                                      !!! over spins
	ENDDO                                      !!! over iorbs
C  DO OVER GROUP OF THE WAVEVECTOR Q
	DO 1000 IGEQ=1,NGEQ                  !!! over group of q-vector
      IR=ISG(IGEQ,1)                       !!! element "g" in the main G-list
      IG=IKOV(IR)                          !!! element "g" after Kovalev
	IPTBR=INPTBR(IGEQ,IPTB)              !!! q+Gr=q+gamma^{-1}G
	CALL PLZ_PLZFILES(IPTBR,IQPNT,IUPLY,'R',' ')  !!! read unsymmetrized pi(r){q+Gr}
C  DO THE SAME OPERATIONS FOR EVERY KIND OF ATOM, MT-SPHERE PART
	DO IORBS=1,NORBS                     !!! over iorbs
	DO IUPDN=1,NSPIN                     !!! over spins 
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	SIGNI=1.D0
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	IF(ISPIN1.EQ.1.AND.ISPIN.EQ.2)SIGNI=+SQRT(2.D0) ! M^{-}=<S^{-}>=-<S_{+}>
	IF(ISPIN1.EQ.2.AND.ISPIN.EQ.1)SIGNI=-SQRT(2.D0) ! M^{+}=<S^{+}>=-<S_{-}>
	ENDIF
	DO IATOM=1,NATOM                     !!! over atoms
	ISORT=IS(IATOM)
      IATOMG=IP(IATOM,IR)
	IF(IS(IATOMG).NE.ISORT)
     &CALL FULLSTOP('<PLZSYM>:: ERROR IN IP-ARRAY')
      SQ=QPTB(1,IPTB)*(RDC(1,IATOM,IR)+SHIFT(1,IR))+
     &   QPTB(2,IPTB)*(RDC(2,IATOM,IR)+SHIFT(2,IR))+
     &   QPTB(3,IPTB)*(RDC(3,IATOM,IR)+SHIFT(3,IR))
      PHSQ=EXP(2.D0*PI*SQ*(0.D0,1.D0))
C  SYMMETRIZE INDUCED DENSITY BY WIGNER MATRICES
	DO JORBS=1,NORBS
	DO JUPDN=1,NSPIN    
	IF(JORBS.EQ.1)THEN
	JSPIN1=JUPDN
	JSPIN =JUPDN
	SIGNJ=1.D0
	ELSEIF(JORBS.EQ.2)THEN
	JSPIN1=JUPDN
	JSPIN =NSPIN+1-JUPDN
	IF(JSPIN1.EQ.1.AND.JSPIN.EQ.2)SIGNJ=+SQRT(2.D0) ! M^{-}=<S^{-}>=-<S_{+}>
	IF(JSPIN1.EQ.2.AND.JSPIN.EQ.1)SIGNJ=-SQRT(2.D0) ! M^{+}=<S^{+}>=-<S_{-}>
	ENDIF
	IF(NORBS.EQ.1.AND.JUPDN.NE.IUPDN)CYCLE
	DO L=0,ILSV(ISORT)                   !!! over l
	LL=L*(2*L-1)*(2*L+1)/3
	DO M=-L,L                            !!! over m
	LM=L*(L+1)+M+1
	DO M1=-L,L                           !!! over m1
	LM1=L*(L+1)+M1+1
	IWIG01=LL+(2*L+1)*(L+M1)+L+M+1       !!! U(l,m,m1)
	DO IRAD=0,NRAD(ISORT)
	SRHO(IRAD,LM,IATOM,IUPDN,IORBS)=SRHO(IRAD,LM,IATOM,IUPDN,IORBS)+
     &U(IWIG01,IG)*DRHO(IRAD,LM1,IATOMG,JUPDN,JORBS)*PHSQ*SIGNI/SIGNJ*
     &DCONJG(SJ(ISPIN1,JSPIN1,IR))*SJ(ISPIN,JSPIN,IR)
	ENDDO
      ENDDO                                !!! over m1
      ENDDO                                !!! over m
      ENDDO                                !!! over l
C  SYMMETRIZE DENSITY MATRIX BY WIGNER MATRICES
	DO L=0,ILSB(ISORT)                   !!! over l
      LL=L*(2*L-1)*(2*L+1)/3
      DO M1=-L,L                           !!! over m1
      LM1=L*(L+1)+M1+1
      DO M=-L,L                            !!! over m
      LM=L*(L+1)+M+1
      IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M1+1 ! ! (l,m'm)
      DO K1=-L,L                           !!! over m1
      LK1=L*(L+1)+K1+1
      DO K=-L,L                            !!! over m
      LK=L*(L+1)+K+1
      IW=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+K)+L+K1+1   ! ! (l,k'k)
	M1K1=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+K1)+L+M1+1  ! U(l,m1,k1)
	MK=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+K)+L+M+1    !!! U(l,m,k)
      DELSHUB(IU,IATOM,IUPDN,IORBS)=DELSHUB(IU,IATOM,IUPDN,IORBS)+
     &CONJG(U(M1K1,IG))*DELGHUB(IW,IATOMG,JUPDN,JORBS)*U(MK,IG)*PHSQ*
     &SIGNI/SIGNJ*DCONJG(SJ(ISPIN1,JSPIN1,IR))*SJ(ISPIN,JSPIN,IR)
	ENDDO                                !!! over k1
      ENDDO                                !!! over k
	ENDDO                                !!! over m1
      ENDDO                                !!! over m
      ENDDO                                !!! over l
      ENDDO                                !!! over jupdn
      ENDDO                                !!! over jorbs
      ENDDO                                !!! over atoms
      ENDDO                                !!! over spins
      ENDDO                                !!! over iorbs
 1000 CONTINUE                             !!! over group of vector q
C  NORMALIZATION
      DO IATOM=1,NATOM                     !!! over atoms
      ISORT=IS(IATOM)
      DO IORBS=1,NORBS                     !!! over iorbs
      DO IUPDN=1,NSPIN                     !!! over spins
      DO L=0,ILSV(ISORT)
      DO M=-L,L
      LM=L*(L+1)+M+1
      DO IRAD=0,NRAD(ISORT)
      DRHO(IRAD,LM,IATOM,IUPDN,IORBS)=
     &SRHO(IRAD,LM,IATOM,IUPDN,IORBS)/DBLE(NGEQ)
      ENDDO
      ENDDO
      ENDDO
	DO L=0,ILSB(ISORT)                   !!! over l
      DO M1=-L,L                           !!! over m1
      LM1=L*(L+1)+M1+1
      DO M=-L,L                            !!! over m
      LM=L*(L+1)+M+1
      IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M1+1 ! ! (l,m'm)
      DELGHUB(IU,IATOM,IUPDN,IORBS)=
     &DELSHUB(IU,IATOM,IUPDN,IORBS)/DBLE(NGEQ)
	ENDDO                                !!! over m1
      ENDDO                                !!! over m
      ENDDO                                !!! over l
      ENDDO                                !!! over spins
      ENDDO                                !!! over spins
      ENDDO                                !!! over atoms
C  SYMMETRIZATION IS DONE, WRITE PLZFILE
	CALL PLZ_PLZFILES(IPTB,IQPNT,IUPLZ,'W',' ')
2000	CONTINUE                             !!! over {q+G}-vectors
C  DELETE SCRATCH FILES
	DO IPTB=1,NPTB
	CALL PLZ_PLZFILES(IPTB,IQPNT,IUPLY,'D',' ')
	ENDDO
	DEALLOCATE(DELSHUB,SRHO)
	END
