	SUBROUTINE PLZ_SCREEN(IQPNT)
**********************************************************************
*  Screens bare long-range Coulomb field by the dielectric function. *
**********************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                     !!! from setup
      USE COM_CONTROL, ONLY : LIFT,LMTO,NPFR,MODE                        !!! from readini
	USE COM_PARAM,   ONLY : NSORT,IS,ILST,ILSB,ILSV,NATOM,NORBS,NSPIN  !!! from readini
	USE COM_LATTICE, ONLY : TAU                                        !!! from readstr
	USE COM_LATPAR,  ONLY : PAR,ORTH,OMEGAC                            !!! from readini
      USE COM_PLZCOM,  ONLY : NPLZ,LPLZ,IPLZ,NPTB,QPTB,INDPTB            !!! from readlrt
	USE COM_RADMESH, ONLY : NRAD                                       !!! from makerad
      USE COM_PLZMOM,  ONLY : PSMAT,SCRMAT,DIEMAT                        !!! from screen
	USE COM_QMESH,   ONLY : NQPNT,QPNT                                 !!! from readpnt
	USE COM_SPHERE,  ONLY : SWZ,SMT                                    !!! from readini
	USE COM_MASHDEP, ONLY : NVAL                                       !!! from setup
      USE COM_UNIT,    ONLY : IUN,IUR,IUT,IUI                            !!! from setup
      IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: WORK(:)
      COMPLEX*16 EPSCON,SCRDEB
      DATA PI/3.141592653589793D0/
	IF(LPLZ.EQ.0)RETURN
C  Memory allocations for main control arrays
	ALLOCATE(SCRMAT(NENVMEM,NENVMEM))
	ALLOCATE(DIEMAT(NENVMEM,NENVMEM))
C  Memory allocations
	ALLOCATE(WORK(NENVMEM))
C  COMPUTE INVERSE DIELECTRIC MATRIX
	DO IPTB=1,NPTB
	AQ=SQRT(QPTB(1,IPTB)**2+QPTB(2,IPTB)**2+QPTB(3,IPTB)**2)
	AQ=AQ*2.D0*PI/PAR
	IF(AQ.LE.1.D-10)VCL=0.D0
	IF(AQ.GT.1.D-10)VCL=8.D0*PI/AQ/AQ
	DO JPTB=1,NPTB
	DIEMAT(JPTB,IPTB)=-VCL*0.5D0*DBLE(NSPIN)*(
     &PSMAT(JPTB,IPTB,1)+PSMAT(JPTB,IPTB,NSPIN))
	ENDDO
	IF(AQ.LE.1.D-10)DIEMAT(1,IPTB)=(0.D0,0.D0)
	DIEMAT(IPTB,IPTB)=DIEMAT(IPTB,IPTB)+(1.D0,0.D0)
	ENDDO
      CALL LIB_CINV(NPTB,DIEMAT,NENVMEM,WORK,IFAIL)
      IF(IFAIL.NE.0)
     &CALL FULLSTOP('<SCREEN>:: ERROR IN INVERSION')
C  SET INVERSE DIELECTRIC CONSTANT TO ZERO IF Q=0
	DO IPTB=1,NPTB
	AQ=SQRT(QPTB(1,IPTB)**2+QPTB(2,IPTB)**2+QPTB(3,IPTB)**2)
	AQ=AQ*2.D0*PI/PAR
	IF(AQ.LE.1.D-10)DIEMAT(IPTB,IPTB)=(1.D-14,0.D0)
	ENDDO
C  COMPUTE SCREENED COULOMB INTERACTION
	DO IPTB=1,NPTB
	AQ=SQRT(QPTB(1,IPTB)**2+QPTB(2,IPTB)**2+QPTB(3,IPTB)**2)
	AQ=AQ*2.D0*PI/PAR
	IF(AQ.LE.1.D-10)VCL=0.D0
	IF(AQ.GT.1.D-10)VCL=8.D0*PI/AQ/AQ
	DO JPTB=1,NPTB
	SCRMAT(IPTB,JPTB)=VCL*DIEMAT(IPTB,JPTB)
	ENDDO
	ENDDO
C  RESET SCREENED INTERACTION TO BARE ONE IF TEST IS REQUIRED
	IF(NPLZ.EQ.0)THEN
	DO IPTB=1,NPTB
	DO JPTB=1,NPTB
	SCRMAT(IPTB,JPTB)=(0.D0,0.D0)
	ENDDO
	AQ=SQRT(QPTB(1,IPTB)**2+QPTB(2,IPTB)**2+QPTB(3,IPTB)**2)
	AQ=AQ*2.D0*PI/PAR
	IF(AQ.LE.1.D-10)VCL=0.D0
	IF(AQ.GT.1.D-10)VCL=8.D0*PI/AQ/AQ
	SCRMAT(IPTB,IPTB)=VCL
	ENDDO
	ENDIF
C  PRINT RESPONSE CONSTANTS
	DO IPTB=1,NPTB
	WRITE(IUN,1010)IPTB,IPTB
	EPSCON=DIEMAT(IPTB,IPTB)   ! eps^{-1}
	AQ2=QPTB(1,IPTB)**2+QPTB(2,IPTB)**2+QPTB(3,IPTB)**2
	SCRDEB=AQ2*(1.D0/EPSCON-1.D0)
      WRITE(IUN,1020)SQRT(AQ2),0.D0
      WRITE(IUN,1030)SQRT(SCRDEB)
      WRITE(IUN,1040)SQRT(AQ2+SCRDEB)
      WRITE(IUN,1050)1.D0/EPSCON
	ENDDO
1010	FORMAT(1X,'From Pi(',I2,',',I2,') found  response constants --->')
1020  FORMAT(1X,'Q=|q+G|  length (2pi/a) = (',G14.7,',',G14.7,')')
1030	FORMAT(1X,'Screened radius (2pi/a) = (',G14.7,',',G14.7,')')
1040	FORMAT(1X,'Sqrt(Q^2+Ksc^2) (2pi/a) = (',G14.7,',',G14.7,')')
1050	FORMAT(1X,'Dielectric Constant     = (',G14.7,',',G14.7,')')
	DEALLOCATE(WORK)
      END
