	SUBROUTINE POT_MULTRHO
**************************************************************
*  Calculates multipoles from the mt-spheres.                *
**************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                          !!! from setup
      USE COM_CONTROL ,ONLY: LMTO,IASA                        !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS,ILSV  !!! from readini
      USE COM_LATPAR  ,ONLY: PAR,OMEGAC                       !!! from readini
      USE COM_SPHERE  ,ONLY: ZNUC,ZCOR,SMT                    !!! from readini
      USE COM_LATTICE ,ONLY: TAU                              !!! from readstr
      USE COM_SYMMLM  ,ONLY: SYM,LMSYM                        !!! from symlmm
      USE COM_DENDAT  ,ONLY: RHO,RHOCOR,RHOPS                 !!! from rhofull
      USE COM_MULTRO  ,ONLY: AMTOT,PSMOM,PSMOM1,QMAD          !!! from multrho
      USE COM_PLWMESH ,ONLY: NPLW,GPLW                        !!! from plwmesh
      USE COM_ACCURG  ,ONLY: BET                              !!! from plwmesh
      USE COM_RADMESH ,ONLY: NRAD,H,R,DR,WEIGHT,RL            !!! from radmesh
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT                      !!! from setup
      USE COM_MASHDEP ,ONLY: LENCMP                           !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER, INTRINSIC :: SIZE
	REAL*8, ALLOCATABLE :: BES(:)
	REAL*8, ALLOCATABLE :: BESD(:)
	REAL*8, ALLOCATABLE :: BT(:)
	COMPLEX*16, ALLOCATABLE :: WORK1(:)
	COMPLEX*16, ALLOCATABLE :: WORK2(:)
	COMPLEX*16, ALLOCATABLE :: RHAN(:)
	COMPLEX*16, ALLOCATABLE :: YLM(:)
	COMPLEX*16 EXPT
	LOGICAL FIRST
	DATA PI/3.141592653589793D0/,FIRST/.TRUE./
	SQPI4=2.D0*SQRT(PI)
      CALL ABORTNOW()
C MEMORY ALLOCATIONS FOR MAIN CONTROL ARRAYS
	IF(FIRST)THEN
	FIRST=.FALSE.
      ALLOCATE(AMTOT(NSYMMEM,NATOMMEM,NSPINMEM,NORBSMEM))
      ALLOCATE(PSMOM(NSYMMEM,NATOMMEM,NSPINMEM,NORBSMEM))
      ALLOCATE(PSMOM1(NSYMMEM,NATOMMEM,NSPINMEM))
      ALLOCATE(QMAD(2,NSYMMEM,NATOMMEM,NSPINMEM))
	ENDIF
C MEMORY ALLOCATIONS FOR SCRATCH ARRAYS
	ALLOCATE(BES(0:LMAXVMEM+1))
	ALLOCATE(BESD(0:LMAXVMEM+1))
	ALLOCATE(BT(0:LMAXVMEM+1))
	ALLOCATE(WORK1(0:NRADMEM))
	ALLOCATE(WORK2(0:NRADMEM))
	ALLOCATE(RHAN(0:LMAXVMEM+1))
	ALLOCATE(YLM(LIMVMEM))
C CALCULATE MOMENTS OF THE FULL DENSITY AND PSEUDODENSITY WITHIN SPHERE
	DO IORBS=1,NORBS
	DO IUPDN=1,NSPIN
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	DO L=0,ILSV(ISORT)
	DO M=-L,L
	LM=L*(L+1)+M+1
	IF(.NOT.SYM(LM,IATOM))CYCLE
	ISYM=LMSYM(LM,IATOM)
	SL=SMT(ISORT)**L
	DO IRAD=0,NRAD(ISORT)
	WORK1(IRAD)=RHO(IRAD,ISYM,IATOM,IUPDN,IORBS)*
     &RL(IRAD,L,ISORT)/SL*WEIGHT(IRAD,ISORT)/SQRT(4.D0*PI)
      ENDDO   
	CALL LIB_CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	AMTOT(ISYM,IATOM,IUPDN,IORBS)=WORK2(NRAD(ISORT))
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ZINT=0.D0
	DO ISPIN=1,NSPIN
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	AMTOT(1,IATOM,ISPIN,1)=AMTOT(1,IATOM,ISPIN,1)-
     &ZNUC(ISORT)/DBLE(NSPIN)
	ZINT=ZINT-AMTOT(1,IATOM,ISPIN,1)
	ENDDO
	ENDDO
C CALCULATE MOMENTS OF THE PSEUDOCHARGE DENSITY
	LMM=0
	ZPSD=0.D0
	DO ISPIN=1,NSPIN
	IF(NPLW.NE.-1)
     &ZPSD=ZPSD+OMEGAC*RHOPS(0,ISPIN,1)
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	LMM=MAX(LMM,ILSV(ISORT))
	DO L=0,ILSV(ISORT)
	DO M=-L,L
	LM=L*(L+1)+M+1
	IF(.NOT.SYM(LM,IATOM))CYCLE
	ISYM=LMSYM(LM,IATOM)
	PSMOM (ISYM,IATOM,ISPIN,1)=(0.D0,0.D0)
	PSMOM (ISYM,IATOM,ISPIN,NORBS)=(0.D0,0.D0)
	PSMOM1(ISYM,IATOM,ISPIN)=(0.D0,0.D0)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	DO IPLW=0,NPLW                       !!! over plane waves
	GX=GPLW(1,IPLW)*2.D0*PI/PAR
	GY=GPLW(2,IPLW)*2.D0*PI/PAR
	GZ=GPLW(3,IPLW)*2.D0*PI/PAR
	AG=SQRT(GX**2+GY**2+GZ**2)
	AG2=AG*AG
C SET SPHERICAL HARMONICS
	IF(AG.GE.1.D-10)THEN
	CALL LIB_SPHHARM(GX/AG,GY/AG,GZ/AG,LMM,YLM)
	ELSE
	YLM(1)=1.D0/SQRT(4.D0*PI)
	DO LM=2,(LMM+1)**2
	YLM(LM)=(0.D0,0.D0)
	ENDDO
	ENDIF
C SET MULTIPOLE MOMENTS
	DO IATOM=1,NATOM                     !!! over atoms
	ISORT=IS(IATOM)
	CALL LIB_BESSR(AG*SMT(ISORT),BES,BESD,ILSV(ISORT)+1)
	SCP=GPLW(1,IPLW)*TAU(1,IATOM)+
     &    GPLW(2,IPLW)*TAU(2,IATOM)+
     &    GPLW(3,IPLW)*TAU(3,IATOM)
	EXPT=EXP((0.D0,1.D0)*2.D0*PI*SCP)
	DO IORBS=1,NORBS                     !!! over iorbs
	DO IUPDN=1,NSPIN                     !!! over spins
	DO L=0,ILSV(ISORT)
	DO M=-L,L
	LM=L*(L+1)+M+1
	IF(.NOT.SYM(LM,IATOM))CYCLE
	ISYM=LMSYM(LM,IATOM)
	IF(AG.GT.1.D-10)THEN
	PSMOM(ISYM,IATOM,IUPDN,IORBS)=PSMOM(ISYM,IATOM,IUPDN,IORBS)+
     &4.D0*PI*SMT(ISORT)**2*RHOPS(IPLW,IUPDN,IORBS)*BES(L+1)*
     &EXPT*DCONJG(YLM(LM))/AG*SQPI4
	ELSE
	PSMOM(ISYM,IATOM,IUPDN,IORBS)=PSMOM(ISYM,IATOM,IUPDN,IORBS)+
     &4.D0*PI/3.D0*SMT(ISORT)**3*RHOPS(IPLW,IUPDN,IORBS)*
     &EXPT*DCONJG(YLM(LM))*SQPI4
	ENDIF
	ENDDO  
      ENDDO   
      ENDDO                                !!! over spins
      ENDDO                                !!! over iorbs
      ENDDO                                !!! over atoms
      ENDDO                                !!! over plane waves
C CALCULATE AUXILARY PSEUDOCHARGE DENSITY (ITS COEFFICIENTS)
C WHICH HAS THE SAME MULTIPOLES AS A TRUE DENSITY MINUS PSEUDODENSITY
	IF(NPLW.NE.-1)THEN
	DO ISPIN=1,NSPIN
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	BT(0)=BET(0,ISORT)
	DO L=1,ILSV(ISORT)+1
	BT(L)=BET(L-1,ISORT)
	ENDDO
	CALL LIB_REGHAN(SMT(ISORT),(0.D0,0.D0),SMT(ISORT),BT(0),
     &  RHAN(0),ILSV(ISORT)+1)
	DO L=0,ILSV(ISORT)
	DO M=-L,L
	LM=L*(L+1)+M+1
	IF(SYM(LM,IATOM))THEN       !!! only for non-zero components
	ISYM=LMSYM(LM,IATOM)
C GAUSSIAN MULTIPOLE MOMENT WITHIN SPHERE
	GSMOM=SQPI4*SMT(ISORT)*DBLE(2*L+1)*RHAN(L+1)
C GAUSSIAN MULTIPOLE MOMENT IN WHOLE SPACE
C     GSMOM=SQPI4*SMT(ISORT)*DBLE(2*L+1)
	PSMOM1(ISYM,IATOM,ISPIN)=(AMTOT(ISYM,IATOM,ISPIN,1)-
     &PSMOM(ISYM,IATOM,ISPIN,1))/GSMOM
	ENDIF
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDIF
C MEMORY DEALLOCATIONS
	DEALLOCATE(BES,BESD,BT,WORK1,WORK2,RHAN,YLM)
	END
