	SUBROUTINE POT_PRINT2
***********************************************
*  Print data on the potential and density    *
***********************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS,ILSV,NHSORT !!! from readini
      USE COM_LATPAR  ,ONLY: PAR,OMEGAC                             !!! from readini
      USE COM_SPHERE  ,ONLY: ZNUC,ZCOR,SWZ,SMT,SASA                 !!! from readini
      USE COM_LATTICE ,ONLY: TAU                                    !!! from readstr
      USE COM_POTDAT  ,ONLY: POT,POTPS                              !!! from potfull
      USE COM_DENDAT  ,ONLY: RHO,RHOPS                              !!! from rhofull
      USE COM_MULTRO  ,ONLY: AMTOT,PSMOM,PSMOM1                     !!! from multrho
      USE COM_POTMTS  ,ONLY: VMT0,VMT,VSF0,VSF,VAV0                 !!! from potzero
      USE COM_PLWMESH ,ONLY: NPLW,GPLW                              !!! from plwmesh
	USE COM_MAGDAT  ,ONLY: ISPL,BSPL                              !!! from readini
      USE COM_RADMESH ,ONLY: NRAD                                   !!! from radmesh
      USE COM_LABELS  ,ONLY: TXTAT,TXTEL,TXTSP                      !!! from readini
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT                            !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16 EXPGR,AMTS(-1:1),AMTC(3),PMTS(-1:1),PMTC(3)
     &   ,BXCS(-1:1),BXCC(3)
	DATA PI/3.141592653589793D0/
	SQPI4=2.D0*SQRT(PI)
C PRINT POTENTIAL AND DENSITY DATA
	SINT=0.D0
	ZPSD=0.D0
	IF(NPLW.NE.-1)
     &ZPSD=OMEGAC*(RHOPS(0,1,1)+RHOPS(0,NSPIN,1))/2.D0*DBLE(NSPIN)
	ZINT=0.D0
	IF(NPLW.NE.-1)ZINT=ZPSD
	ZAUX=0.D0
	AMAG=0.D0
	AINT=0.D0
	IF(NPLW.NE.-1)
     &AINT=OMEGAC*(RHOPS(0,1,1)-RHOPS(0,NSPIN,1))
	DO 2000 IATOM=1,NATOM
	ISORT=IS(IATOM)
	WRITE(IUN,1001)TXTEL(ISORT),IATOM
 1001 FORMAT(1X,'Input data ',A10,' in the position ',I3,' ------->')
C POTENTIAL AND DENSITY AT THE SPHERE
	POTS=DREAL(POT(NRAD(ISORT),1,IATOM,1,1)+
     &POT(NRAD(ISORT),1,IATOM,NSPIN,1))/2.D0/SQPI4+VMT0
	BXCS(0)=(POT(NRAD(ISORT),1,IATOM,1,1)-
     &POT(NRAD(ISORT),1,IATOM,NSPIN,1))/2.D0/SQPI4
	BXCS(-1)=(0.D0,0.D0)
	BXCS(+1)=(0.D0,0.D0)
	RHOS=DREAL(RHO(NRAD(ISORT),1,IATOM,1,1)+
     &RHO(NRAD(ISORT),1,IATOM,NSPIN,1))/2.D0/SQPI4*DBLE(NSPIN)
	AMTS(0)=(RHO(NRAD(ISORT),1,IATOM,1,1)-
     &RHO(NRAD(ISORT),1,IATOM,NSPIN,1))/SQPI4
	AMTS(-1)=(0.D0,0.D0)
	AMTS(+1)=(0.D0,0.D0)
	IF(NORBS.EQ.2)THEN
	BXCS(-1)=POT(NRAD(ISORT),1,IATOM,    1,NORBS)/SQPI4
	BXCS(+1)=POT(NRAD(ISORT),1,IATOM,NSPIN,NORBS)/SQPI4
	AMTS(-1)=RHO(NRAD(ISORT),1,IATOM,    1,NORBS)/SQPI4
	AMTS(+1)=RHO(NRAD(ISORT),1,IATOM,NSPIN,NORBS)/SQPI4
	ENDIF
	BXCC(1)=(BXCS(-1)-BXCS(+1))/SQRT(2.D0)
	BXCC(2)=(BXCS(-1)+BXCS(+1))/SQRT(2.D0)*(0.D0,-1.D0) ! since it is M^{+/-}
	BXCC(3)=BXCS(0)
	AMTC(1)=(AMTS(-1)-AMTS(+1))/SQRT(2.D0)
	AMTC(2)=(AMTS(-1)+AMTS(+1))/SQRT(2.D0)*(0.D0,-1.D0) ! since it is M^{+/-}
	AMTC(3)=AMTS(0)
      WRITE(IUN,1010)POTS,RHOS
 1010 FORMAT(1X,'   V(S)=',G14.7,'  |     RO(S)=',G14.7)
	IF(NSPIN.EQ.2.AND.NORBS.EQ.1)THEN
	WRITE(IUN,1020)DREAL(BXCS(0)),DREAL(AMTS(0))
 1020 FORMAT(1X,' Bxc(S)=',G14.7,'  |     AM(S)=',G14.7)
	ELSEIF(NSPIN.EQ.2.AND.NORBS.EQ.2)THEN
	WRITE(IUN,1030)DREAL(BXCC(1)),DREAL(AMTC(1))
	WRITE(IUN,1040)DREAL(BXCC(2)),DREAL(AMTC(2))
	WRITE(IUN,1050)DREAL(BXCC(3)),DREAL(AMTC(3))
 1030 FORMAT(1X,'  Bx(S)=',G14.7,'  |    AMx(S)=',G14.7)
 1040 FORMAT(1X,'  By(S)=',G14.7,'  |    AMy(S)=',G14.7)
 1050 FORMAT(1X,'  Bz(S)=',G14.7,'  |    AMz(S)=',G14.7)
	ENDIF
C PSEUDOPOTENTIAL AND DENSITY AT THE SPHERE
	POTS=0.D0
	RHOS=0.D0
	BXCS( 0)=(0.D0,0.D0)
	BXCS(-1)=(0.D0,0.D0)
	BXCS(+1)=(0.D0,0.D0)
	AMTS( 0)=(0.D0,0.D0)
	AMTS(-1)=(0.D0,0.D0)
	AMTS(+1)=(0.D0,0.D0)
	DO IPLW=0,NPLW
	SCP=GPLW(1,IPLW)*TAU(1,IATOM)+
     &    GPLW(2,IPLW)*TAU(2,IATOM)+
     &    GPLW(3,IPLW)*TAU(3,IATOM)
	GS=SQRT(GPLW(1,IPLW)**2+GPLW(2,IPLW)**2+GPLW(3,IPLW)**2)*
     &  2.D0*PI/PAR*SMT(ISORT)
	EXPGR=EXP((0.D0,1.D0)*2.D0*PI*SCP)
	IF(GS.GE.1.D-10)SG=SIN(GS)/GS
	IF(GS.LT.1.D-10)SG=1.D0
	POTS=POTS+
     &(POTPS(IPLW,1,1)+POTPS(IPLW,NSPIN,1))/2.D0*EXPGR*SG
	RHOS=RHOS+
     &(RHOPS(IPLW,1,1)+RHOPS(IPLW,NSPIN,1))/2.D0*DBLE(NSPIN)*EXPGR*SG
	BXCS(0)=BXCS(0)+
     &(POTPS(IPLW,1,1)-POTPS(IPLW,NSPIN,1))/2.D0*EXPGR*SG
	AMTS(0)=AMTS(0)+
     &(RHOPS(IPLW,1,1)-RHOPS(IPLW,NSPIN,1))*EXPGR*SG
	IF(NORBS.EQ.2)THEN
	BXCS(-1)=BXCS(-1)+POTPS(IPLW,1,NORBS)*EXPGR*SG
	BXCS(+1)=BXCS(+1)+POTPS(IPLW,NSPIN,NORBS)*EXPGR*SG
	AMTS(-1)=AMTS(-1)+RHOPS(IPLW,1,NORBS)*EXPGR*SG
	AMTS(+1)=AMTS(+1)+RHOPS(IPLW,NSPIN,NORBS)*EXPGR*SG
	ENDIF
	ENDDO
	BXCC(1)=(BXCS(-1)-BXCS(+1))/SQRT(2.D0)
	BXCC(2)=(BXCS(-1)+BXCS(+1))/SQRT(2.D0)*(0.D0,-1.D0) ! since it is M^{+/-}
	BXCC(3)=BXCS(0)
	AMTC(1)=(AMTS(-1)-AMTS(+1))/SQRT(2.D0)
	AMTC(2)=(AMTS(-1)+AMTS(+1))/SQRT(2.D0)*(0.D0,-1.D0) ! since it is M^{+/-}
	AMTC(3)=AMTS(0)
      WRITE(IUN,1110)POTS+VMT0,RHOS
 1110 FORMAT(1X,'   P(S)=',G14.7,'  |     PD(S)=',G14.7)
	IF(NSPIN.EQ.2.AND.NORBS.EQ.1)THEN
	WRITE(IUN,1120)DREAL(BXCS(0)),DREAL(AMTS(0))
 1120 FORMAT(1X,' Pxc(S)=',G14.7,'  |     PM(S)=',G14.7)
	ELSEIF(NSPIN.EQ.2.AND.NORBS.EQ.2)THEN
	WRITE(IUN,1130)DREAL(BXCC(1)),DREAL(AMTC(1))
	WRITE(IUN,1140)DREAL(BXCC(2)),DREAL(AMTC(2))
	WRITE(IUN,1150)DREAL(BXCC(3)),DREAL(AMTC(3))
 1130 FORMAT(1X,'  Px(S)=',G14.7,'  |    PMx(S)=',G14.7)
 1140 FORMAT(1X,'  Py(S)=',G14.7,'  |    PMy(S)=',G14.7)
 1150 FORMAT(1X,'  Pz(S)=',G14.7,'  |    PMz(S)=',G14.7)
	ENDIF
C POTENTIAL AND DENSITY AT THE CENTER OF ATOM
	POTS=0.D0
	RHOS=0.D0
	BXCS( 0)=(0.D0,0.D0)
	BXCS(-1)=(0.D0,0.D0)
	BXCS(+1)=(0.D0,0.D0)
	AMTS( 0)=(0.D0,0.D0)
	AMTS(-1)=(0.D0,0.D0)
	AMTS(+1)=(0.D0,0.D0)
	DO IPLW=0,NPLW
	SCP=GPLW(1,IPLW)*TAU(1,IATOM)+
     &    GPLW(2,IPLW)*TAU(2,IATOM)+
     &    GPLW(3,IPLW)*TAU(3,IATOM)
	GS=SQRT(GPLW(1,IPLW)**2+GPLW(2,IPLW)**2+GPLW(3,IPLW)**2)*
     &  2.D0*PI/PAR*SMT(ISORT)
	EXPGR=EXP((0.D0,1.D0)*2.D0*PI*SCP)
	POTS=POTS+
     &(POTPS(IPLW,1,1)+POTPS(IPLW,NSPIN,1))/2.D0*EXPGR
	RHOS=RHOS+
     &(RHOPS(IPLW,1,1)+RHOPS(IPLW,NSPIN,1))/2.D0*DBLE(NSPIN)*EXPGR
	BXCS(0)=BXCS(0)+
     &(POTPS(IPLW,1,1)-POTPS(IPLW,NSPIN,1))/2.D0*EXPGR
	AMTS(0)=AMTS(0)+
     &(RHOPS(IPLW,1,1)-RHOPS(IPLW,NSPIN,1))*EXPGR
	IF(NORBS.EQ.2)THEN
	BXCS(-1)=BXCS(-1)+POTPS(IPLW,1,NORBS)*EXPGR
	BXCS(+1)=BXCS(+1)+POTPS(IPLW,NSPIN,NORBS)*EXPGR
	AMTS(-1)=AMTS(-1)+RHOPS(IPLW,1,NORBS)*EXPGR
	AMTS(+1)=AMTS(+1)+RHOPS(IPLW,NSPIN,NORBS)*EXPGR
	ENDIF
	ENDDO
	BXCC(1)=(BXCS(-1)-BXCS(+1))/SQRT(2.D0)
	BXCC(2)=(BXCS(-1)+BXCS(+1))/SQRT(2.D0)*(0.D0,-1.D0) ! since it is M^{+/-}
	BXCC(3)=BXCS(0)
	AMTC(1)=(AMTS(-1)-AMTS(+1))/SQRT(2.D0)
	AMTC(2)=(AMTS(-1)+AMTS(+1))/SQRT(2.D0)*(0.D0,-1.D0) ! since it is M^{+/-}
	AMTC(3)=AMTS(0)
      WRITE(IUN,1210)POTS,RHOS
 1210 FORMAT(1X,'   P(0)=',G14.7,'  |     PD(0)=',G14.7)
	IF(NSPIN.EQ.2.AND.NORBS.EQ.1)THEN
	WRITE(IUN,1220)DREAL(BXCS(0)),DREAL(AMTS(0))
 1220 FORMAT(1X,' Pxc(0)=',G14.7,'  |     PM(0)=',G14.7)
	ELSEIF(NSPIN.EQ.2.AND.NORBS.EQ.2)THEN
	WRITE(IUN,1230)DREAL(BXCC(1)),DREAL(AMTC(1))
	WRITE(IUN,1240)DREAL(BXCC(2)),DREAL(AMTC(2))
	WRITE(IUN,1250)DREAL(BXCC(3)),DREAL(AMTC(3))
 1230 FORMAT(1X,'  Px(0)=',G14.7,'  |    PMx(0)=',G14.7)
 1240 FORMAT(1X,'  Py(0)=',G14.7,'  |    PMy(0)=',G14.7)
 1250 FORMAT(1X,'  Pz(0)=',G14.7,'  |    PMz(0)=',G14.7)
	ENDIF
C CHARGE AMD MAGNETIZATION
	AMTS(0)=AMTOT(1,IATOM,1,1)-AMTOT(1,IATOM,NSPIN,1)
	AMTS(-1)=(0.D0,0.D0)
	AMTS(+1)=(0.D0,0.D0)
	PMTS(0)=PSMOM(1,IATOM,1,1)-PSMOM(1,IATOM,NSPIN,1)
	PMTS(-1)=(0.D0,0.D0)
	PMTS(+1)=(0.D0,0.D0)
	IF(NORBS.EQ.2)THEN
	AMTS(-1)=AMTOT(1,IATOM,1,NORBS)
	AMTS(+1)=AMTOT(1,IATOM,2,NORBS)
	PMTS(-1)=PSMOM(1,IATOM,1,NORBS)
	PMTS(+1)=PSMOM(1,IATOM,2,NORBS)
	ENDIF
	AMTC(1)=(AMTS(-1)-AMTS(+1))/SQRT(2.D0)
	AMTC(2)=(AMTS(-1)+AMTS(+1))/SQRT(2.D0)*(0.D0,-1.D0) ! since it is M^{+/-}
	AMTC(3)=AMTS(0)
	PMTC(1)=(PMTS(-1)-PMTS(+1))/SQRT(2.D0)
	PMTC(2)=(PMTS(-1)+PMTS(+1))/SQRT(2.D0)*(0.D0,-1.D0) ! since it is M^{+/-}
	PMTC(3)=PMTS(0)
	AMAG=AMAG+DREAL(AMTS(0))
	AINT=AINT-DREAL(PMTS(0))
	IF(NSPIN.EQ.2.AND.NORBS.EQ.1)THEN
	WRITE(IUN,1260)DREAL(AMTC(3)),DREAL(PMTC(3))
1260  FORMAT(1X,'   M(S)=',G14.7,'  |     PM(S)=',G14.7)
	ELSEIF(NSPIN.EQ.2.AND.NORBS.EQ.2)THEN
	WRITE(IUN,1270)DREAL(AMTC(1)),DREAL(PMTC(1))
	WRITE(IUN,1280)DREAL(AMTC(2)),DREAL(PMTC(2))
	WRITE(IUN,1290)DREAL(AMTC(3)),DREAL(PMTC(3))
1270  FORMAT(1X,'  Mx(S)=',G14.7,'  |     Px(S)=',G14.7)
1280  FORMAT(1X,'  My(S)=',G14.7,'  |     Py(S)=',G14.7)
1290  FORMAT(1X,'  Mz(S)=',G14.7,'  |     Pz(S)=',G14.7)
	ENDIF
C INTERSTITIAL CHARGE AND MAGNETIZATION
	ZAUX=ZAUX-(PSMOM1(1,IATOM,1)+PSMOM1(1,IATOM,NSPIN))/
     &2.D0*DBLE(NSPIN)*SQPI4*SMT(ISORT)
	SINT=SINT-DREAL(AMTOT(1,IATOM,1,1)+AMTOT(1,IATOM,NSPIN,1))/
     &2.D0*DBLE(NSPIN)
	IF(NPLW.NE.-1)
     &ZINT=ZINT-(PSMOM(1,IATOM,1,1)+PSMOM(1,IATOM,NSPIN,1))/
     &2.D0*DBLE(NSPIN)
      IF(NPLW.EQ.-1)
     &ZINT=ZINT+(RHO(NRAD(ISORT),1,IATOM,1,1)+
     &RHO(NRAD(ISORT),1,IATOM,NSPIN,1))/2.D0*DBLE(NSPIN)/SQPI4*
     &4.D0*PI/3.D0*(SASA(ISORT)**3-SMT(ISORT)**3)
 2000 CONTINUE
	WRITE(IUN,1310)VMT0
	WRITE(IUN,1320)VAV0
 1310 FORMAT(' Average potential over the sphere boundaries is ',G14.7)
 1320 FORMAT(' Average potential in the interstitial region is ',G14.7)
	IF(NPLW.NE.-1)WRITE(IUN,1330)SINT
	IF(NPLW.NE.-1)WRITE(IUN,1340)ZINT
	IF(NPLW.NE.-1)WRITE(IUN,1350)ZPSD/ZAUX
	IF(NPLW.EQ.-1)WRITE(IUN,1360)0.D0
	IF(NPLW.EQ.-1)WRITE(IUN,1370)ZINT-SINT
	IF(NSPIN.EQ.2.AND.NORBS.EQ.1)WRITE(IUN,1380)AINT
	IF(NSPIN.EQ.2.AND.NORBS.EQ.1)WRITE(IUN,1390)AMAG+AINT
 1330 FORMAT(' Total charge in the interstitial region must be ',G14.7)
 1340 FORMAT(' Total charge found  via  fourier  transform  is ',G14.7)
 1350 FORMAT(' Auxilary density renormalization coefficient is ',G14.7)
 1360 FORMAT(' Total charge in the interstitial region must be ',G14.7)
 1370 FORMAT(' Total charge  found  in  the elementary cell is ',G14.7)
 1380 FORMAT(' Magnetization  in  the  interstitial region  is ',G14.7)
 1390 FORMAT(' Total magnetization found in elementary cell is ',G14.7)
	RETURN
	END



	SUBROUTINE POT_PRINTC(KEY)
*******************************************************
*  Prints input-output charge.                        *
*******************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_PARAM  ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS,ILSV,NHSORT  !!! from readini
      USE COM_LATPAR ,ONLY: PAR,OMEGAC                              !!! from readini
      USE COM_SPHERE ,ONLY: ZNUC,ZCOR,SMT,SWZ,SASA                  !!! from readini
      USE COM_DENDAT ,ONLY: RHO,RHOPS,RHOPS1                        !!! from rhofull
      USE COM_MULTRO ,ONLY: AMTOT,PSMOM                             !!! from multrho
      USE COM_RADMESH,ONLY: NRAD                                    !!! from radmesh
      USE COM_PLWMESH,ONLY: NPLW                                    !!! from plwmesh
      USE COM_LABELS ,ONLY: TXTAT,TXTEL,TXTSP                       !!! from readini
      USE COM_UNIT   ,ONLY: IUN,IUR,IUT                             !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, SAVE, ALLOCATABLE :: SMTINP(:)
	COMPLEX*16, SAVE, ALLOCATABLE :: SMTOUT(:)
	COMPLEX*16, SAVE, ALLOCATABLE :: AMTINP(:,:)
	COMPLEX*16, SAVE, ALLOCATABLE :: AMTOUT(:,:)
	COMPLEX*16 AINP(3),AOUT(3)
	SAVE SININP,ZININP
	DATA PI/3.141592653589793D0/
      SQPI4=2.D0*SQRT(PI)
C MEMORY ALLOCATIONS
	IF(.NOT.ALLOCATED(SMTINP))ALLOCATE(SMTINP(NATOMMEM))
	IF(.NOT.ALLOCATED(SMTOUT))ALLOCATE(SMTOUT(NATOMMEM))
	IF(.NOT.ALLOCATED(AMTINP))ALLOCATE(AMTINP(NATOMMEM,-1:1))
	IF(.NOT.ALLOCATED(AMTOUT))ALLOCATE(AMTOUT(NATOMMEM,-1:1))
C SAVE INPUT CHARGE TRANSFER
	IF(KEY.EQ.1)THEN
	SININP=0.D0
	ZININP=0.D0
	IF(NPLW.NE.-1)
     &ZININP=OMEGAC*(RHOPS(0,1,1)+RHOPS(0,NSPIN,1))/2.D0*DBLE(NSPIN)
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	SMTINP(IATOM)=(AMTOT(1,IATOM,1,1)+AMTOT(1,IATOM,NSPIN,1))/
     &2.D0*DBLE(NSPIN)
      AMTINP(IATOM,0)=AMTOT(1,IATOM,1,1)-AMTOT(1,IATOM,NSPIN,1)
	AMTINP(IATOM,-1)=(0.D0,0.D0)
	AMTINP(IATOM,+1)=(0.D0,0.D0)
	IF(NORBS.EQ.2)THEN
	AMTINP(IATOM,-1)=AMTOT(1,IATOM,1,NORBS)
	AMTINP(IATOM,+1)=AMTOT(1,IATOM,2,NORBS)
	ENDIF
	SININP=SININP-SMTINP(IATOM)
	IF(NPLW.NE.-1)
     &ZININP=ZININP-(PSMOM(1,IATOM,1,1)+PSMOM(1,IATOM,NSPIN,1))/
     &2.D0*DBLE(NSPIN)
	IF(NPLW.EQ.-1)
     &ZININP=ZININP+(RHO(NRAD(ISORT),1,IATOM,1,1)+
     &RHO(NRAD(ISORT),1,IATOM,NSPIN,1))/2.D0*DBLE(NSPIN)/SQPI4*
     &4.D0*PI/3.D0*(SASA(ISORT)**3-SMT(ISORT)**3)
	ENDDO
	ELSEIF(KEY.EQ.2)THEN
	SINOUT=0.D0
	ZINOUT=0.D0
	IF(NPLW.NE.-1)
     &ZINOUT=OMEGAC*(RHOPS(0,1,1)+RHOPS(0,NSPIN,1))/2.D0*DBLE(NSPIN)
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	SMTOUT(IATOM)=(AMTOT(1,IATOM,1,1)+AMTOT(1,IATOM,NSPIN,1))/
     &2.D0*DBLE(NSPIN)
      AMTOUT(IATOM,0)=AMTOT(1,IATOM,1,1)-AMTOT(1,IATOM,NSPIN,1)
	AMTOUT(IATOM,-1)=(0.D0,0.D0)
	AMTOUT(IATOM,+1)=(0.D0,0.D0)
	IF(NORBS.EQ.2)THEN
	AMTOUT(IATOM,-1)=AMTOT(1,IATOM,1,NORBS)
	AMTOUT(IATOM,+1)=AMTOT(1,IATOM,2,NORBS)
	ENDIF
	SINOUT=SINOUT-SMTOUT(IATOM)
	IF(NPLW.NE.-1)
     &ZINOUT=ZINOUT-(PSMOM(1,IATOM,1,1)+PSMOM(1,IATOM,NSPIN,1))/
     &2.D0*DBLE(NSPIN)
	IF(NPLW.EQ.-1)
     &ZINOUT=ZINOUT+(RHO(NRAD(ISORT),1,IATOM,1,1)+
     &RHO(NRAD(ISORT),1,IATOM,NSPIN,1))/2.D0*DBLE(NSPIN)/SQPI4*
     &4.D0*PI/3.D0*(SASA(ISORT)**3-SMT(ISORT)**3)
	ENDDO 
C  PRINT CELL CHARGES
	WRITE(IUN,1010)
	WRITE(IUN,1020)
	DO IATOM=1,NATOM
	WRITE(IUN,1030)DREAL(SMTINP(IATOM)),DREAL(SMTOUT(IATOM)),
     &TXTEL(IS(IATOM))
	ENDDO
      IF(NSPIN.EQ.2.AND.NORBS.EQ.1)THEN
      WRITE(IUN,1040)
      WRITE(IUN,1050)
      DO IATOM=1,NATOM
      WRITE(IUN,1030)DREAL(AMTINP(IATOM,0)),DREAL(AMTOUT(IATOM,0)),
     &TXTEL(IS(IATOM))
	ENDDO
      ELSEIF(NSPIN.EQ.2.AND.NORBS.EQ.2)THEN
      WRITE(IUN,1040)
      WRITE(IUN,1050)
      DO IATOM=1,NATOM
	AINP(1)=(AMTINP(IATOM,-1)-AMTINP(IATOM,+1))/SQRT(2.D0)
	AINP(2)=(AMTINP(IATOM,-1)+AMTINP(IATOM,+1))/SQRT(2.D0)*
     &(0.D0,-1.D0) ! since it is M^{+/-}, not M_{+/-}
	AINP(3)= AMTINP(IATOM,0)
	AOUT(1)=(AMTOUT(IATOM,-1)-AMTOUT(IATOM,+1))/SQRT(2.D0)
	AOUT(2)=(AMTOUT(IATOM,-1)+AMTOUT(IATOM,+1))/SQRT(2.D0)*
     &(0.D0,-1.D0) ! since it is M^{+/-}, not M_{+/-}
	AOUT(3)= AMTOUT(IATOM,0)
      WRITE(IUN,1035)DREAL(AINP(1)),DREAL(AOUT(1)),TXTEL(IS(IATOM)),'X'
      WRITE(IUN,1035)DREAL(AINP(2)),DREAL(AOUT(2)),TXTEL(IS(IATOM)),'Y'
      WRITE(IUN,1035)DREAL(AINP(3)),DREAL(AOUT(3)),TXTEL(IS(IATOM)),'Z'
	ENDDO
      ENDIF
	WRITE(IUN,1060)
	WRITE(IUN,1030)SININP,SINOUT
	WRITE(IUN,1030)ZININP,ZINOUT
	WRITE(IUN,1070)
	ENDIF
1010  FORMAT(1X,'Input/output charge transfer at the iteration  --->')
1020  FORMAT(1X,'    S(inp)              S(out)')
1030  FORMAT(1X,G14.7,6X,G14.7,2X,A)
1035  FORMAT(1X,G14.7,6X,G14.7,2X,A10,1X,A1)
1040  FORMAT(1X,'Input/output magnetic moment at the iteration  --->')
1050  FORMAT(1X,'    M(inp)              M(out)')
1060  FORMAT(1X,'    I(inp)              I(out)')
1070  FORMAT(63('*'))
	END
