	SUBROUTINE POT_VXFTR(KEY)
***********************************************************
* Calculates exchange-correlation part of pseudopotential *
* Generalized gradient corrections after Perdew added.    *
***********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM
      USE COM_CONTROL ,ONLY: ILDA,IGGA,ILSD                   !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS       !!! from readini
      USE COM_LATPAR  ,ONLY: PAR,OMEGAC                       !!! from readini
      USE COM_LATTICE ,ONLY: RBAS,GBAS,TAU                    !!! from readstr
      USE COM_POTDAT  ,ONLY: POTPS                            !!! from potfull
      USE COM_DENDAT  ,ONLY: RHOPS                            !!! from rhofull
      USE COM_PLWMESH ,ONLY: NPLW,GPLW,KVEC,KGMIN,KGMAX,INDG  !!! from plwmesh
      USE COM_FFTMESH ,ONLY: NFFTG,AD,RD                      !!! from fftmesh
      USE COM_MASHDEP ,ONLY: LENINT,LENREL,LENCMP             !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER MF(3)
	INTEGER, INTRINSIC :: SIZE
	COMPLEX*16, ALLOCATABLE :: RHORS(:,:,:)
	COMPLEX*16, ALLOCATABLE :: G1RHO(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: G2RHO(:,:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: VXCRS(:,:,:)
	COMPLEX*16, ALLOCATABLE :: TMPARR(:)
	COMPLEX*16 EXPGR,GR1UP(3),GR1DN(3),GR2UP(3,3),GR2DN(3,3)
     &   ,D0M(-1:1),GR1RHO(3),GR1MAG(3,-1:1),GR2RHO(3,3)
     &   ,GR2MAG(3,3,-1:1),GR1MOD(3),GR2MOD(3,3)
	DIMENSION GL(3),QGAM(3),XC(2)
	DATA PI/3.141592653589793D0/,QGAM/0.D0,0.D0,0.D0/
      CALL ABORTNOW()
	IF(NPLW.EQ.-1)RETURN
C MEMORY ALLOCATAIONS FOR SCRATCH ARRAYS
	ALLOCATE(RHORS(NFFTMEM,NSPINMEM,NORBSMEM))
      SIZE_RHORS=DBLE(SIZE(RHORS)*LENCMP)/1024.D0**2
	ALLOCATE(G1RHO(NFFTMEM,NSPINMEM,NORBSMEM,NGGAMEM))
      SIZE_G1RHO=DBLE(SIZE(G1RHO)*LENCMP)/1024.D0**2
	ALLOCATE(G2RHO(NFFTMEM,NSPINMEM,NORBSMEM,NGGAMEM,NGGAMEM))
      SIZE_G2RHO=DBLE(SIZE(G2RHO)*LENCMP)/1024.D0**2
	ALLOCATE(VXCRS(NFFTMEM,NSPINMEM,NORBSMEM))
      SIZE_VXCRS=DBLE(SIZE(VXCRS)*LENCMP)/1024.D0**2
	ALLOCATE(TMPARR(NFFTMEM))
      SIZE_TMPARR=DBLE(SIZE(TMPARR)*LENCMP)/1024.D0**2
      CURMEM=CURMEM+SIZE_RHORS+SIZE_G1RHO+SIZE_G2RHO+
     &SIZE_VXCRS+SIZE_TMPARR
      IF(TOTMEM.LT.CURMEM)TXTMEM='<MULTFTR> Subroutine'
      IF(TOTMEM.LT.CURMEM)TOTMEM=CURMEM
C START CODE
      SFACT=0.5D0*DBLE(NSPIN)
	DO IORBS=1,NORBS
	DO IUPDN=1,NSPIN
C SET CHARGE DENSITY AT THE REAL SPACE MESH
	CALL POT_FTRANSD(RHOPS(0,IUPDN,IORBS),RHORS(1,IUPDN,IORBS),
     &TMPARR,0,0,QGAM)
	IF(IGGA.NE.0)THEN
C SET DENSITY GRADIENTS
	DO IA=1,3
	CALL POT_FTRANSD(RHOPS(0,IUPDN,IORBS),
     &G1RHO(1,IUPDN,IORBS,IA),TMPARR,IA,0,QGAM)
	DO IB=1,3
	CALL POT_FTRANSD(RHOPS(0,IUPDN,IORBS),
     &G2RHO(1,IUPDN,IORBS,IA,IB),TMPARR,IA,IB,QGAM)
	ENDDO
	ENDDO
	ENDIF
	ENDDO
	ENDDO
C Set gradients to zero
      DO IA=1,3 
      GR1UP(IA)=(0.D0,0.D0)
      GR1DN(IA)=(0.D0,0.D0)
      DO IB=1,3
      GR2UP(IA,IB)=(0.D0,0.D0)
      GR2DN(IA,IB)=(0.D0,0.D0)
      ENDDO
      ENDDO
      ALRUP=0.D0
      ALRDN=0.D0
C *** GET EXCHANGE-CORRELATION PSEUDOPOTENTIAL AT THE REAL SPACE MESH ***
	DO 3000 MFFT3=0,NFFTG(3)-1           !!! over mfft3
	DO 2000 MFFT2=0,NFFTG(2)-1           !!! over mfft2
	DO 1000 MFFT1=0,NFFTG(1)-1           !!! over mfft1
	IFFT=1+MFFT1+MFFT2*NFFTG(1)+MFFT3*NFFTG(1)*NFFTG(2)
	ARHO=DREAL(RHORS(IFFT,1,1)+RHORS(IFFT,NSPIN,1))*SFACT
	ZMAG=DREAL(RHORS(IFFT,1,1)-RHORS(IFFT,NSPIN,1))
	AMAG=SQRT(ZMAG*ZMAG)
	D0M( 0)=RHORS(IFFT,1,1)-RHORS(IFFT,NSPIN,1)
	D0M(-1)=(0.D0,0.D0)
	D0M(+1)=(0.D0,0.D0)
	IF(NORBS.EQ.2)THEN
	D0M( 0)=RHORS(IFFT,1,1)-RHORS(IFFT,NSPIN,1)
	D0M(-1)=RHORS(IFFT,1,NORBS)
	D0M(+1)=RHORS(IFFT,2,NORBS)
	AMAG=SQRT(DCONJG(D0M( 0))*D0M( 0)+
     &          DCONJG(D0M(-1))*D0M(-1)+
     &          DCONJG(D0M(+1))*D0M(+1))
	ENDIF
C Spin densities
	IF(ILSD.EQ.1)THEN
	ROUP=0.5D0*(ARHO+AMAG)
	RODN=0.5D0*(ARHO-AMAG)
	ELSEIF(ILSD.EQ.0)THEN
	ROUP=0.5D0*ARHO
	RODN=0.5D0*ARHO
	ENDIF
C Spin gradients
      IF(IGGA.NE.0)THEN
	DO IA=1,3
	GR1RHO(IA)=(G1RHO(IFFT,1,1,IA)+G1RHO(IFFT,NSPIN,1,IA))*SFACT
	GR1MAG(IA,0)=(G1RHO(IFFT,1,1,IA)-G1RHO(IFFT,NSPIN,1,IA))
	GR1MAG(IA,-1)=(0.D0,0.D0)
	GR1MAG(IA,+1)=(0.D0,0.D0)
	IF(NORBS.EQ.2)THEN
	GR1MAG(IA,-1)=G1RHO(IFFT,1,NORBS,IA)
	GR1MAG(IA,+1)=G1RHO(IFFT,2,NORBS,IA)
	ENDIF
	ENDDO
	DO IA=1,3
	DO IB=1,3
	GR2RHO(IA,IB)=(G2RHO(IFFT,1,1,IA,IB)+G2RHO(IFFT,NSPIN,1,IA,IB))*
     &SFACT
	GR2MAG(IA,IB,0 )=G2RHO(IFFT,1,1,IA,IB)-G2RHO(IFFT,NSPIN,1,IA,IB)
	GR2MAG(IA,IB,-1)=(0.D0,0.D0)
	GR2MAG(IA,IB,+1)=(0.D0,0.D0)
	IF(NORBS.EQ.2)THEN
	GR2MAG(IA,IB,-1)=G2RHO(IFFT,1,NORBS,IA,IB)
	GR2MAG(IA,IB,+1)=G2RHO(IFFT,2,NORBS,IA,IB)
	ENDIF
	ENDDO
	ENDDO
C
	IF(ABS(AMAG).GT.1.D-14)RMAG=1.D0/AMAG
	IF(ABS(AMAG).LE.1.D-14)RMAG=0.D0
	DO IA=1,3
	GR1MOD(IA)=(0.D0,0.D0)
	DO MY=-1,1
	GR1MOD(IA)=GR1MOD(IA)+0.5D0*(DCONJG(D0M(MY))*GR1MAG(IA,MY)+
     &D0M(MY)*DCONJG(GR1MAG(IA,MY)))*RMAG
	ENDDO
	ENDDO
	DO IA=1,3
	DO IB=1,3
	GR2MOD(IA,IB)=-GR1MOD(IA)*GR1MOD(IB)*RMAG
	DO MY=-1,1
	GR2MOD(IA,IB)=GR2MOD(IA,IB)+0.5D0*RMAG*(
     &DCONJG(GR1MAG(IB,MY))*GR1MAG(IA,MY)+
     &DCONJG(GR1MAG(IA,MY))*GR1MAG(IB,MY)+
     &DCONJG(D0M(MY))*GR2MAG(IA,IB,MY)+
     &D0M(MY)*DCONJG(GR2MAG(IA,IB,MY)))
	ENDDO
	ENDDO
	ENDDO
C
	ALRUP=0.D0
	ALRDN=0.D0
	DO IA=1,3
	IF(ILSD.EQ.1)THEN
	GR1UP(IA)=0.5D0*(GR1RHO(IA)+GR1MOD(IA))
	GR1DN(IA)=0.5D0*(GR1RHO(IA)-GR1MOD(IA))
	ELSEIF(ILSD.EQ.0)THEN
	GR1UP(IA)=0.5D0*GR1RHO(IA)
	GR1DN(IA)=0.5D0*GR1RHO(IA)
	ENDIF
	DO IB=1,3
	IF(ILSD.EQ.1)THEN
	GR2UP(IA,IB)=0.5D0*(GR2RHO(IA,IB)+GR2MOD(IA,IB))
	GR2DN(IA,IB)=0.5D0*(GR2RHO(IA,IB)-GR2MOD(IA,IB))
	ELSEIF(ILSD.EQ.0)THEN
	GR2UP(IA,IB)=0.5D0*GR2RHO(IA,IB)
	GR2DN(IA,IB)=0.5D0*GR2RHO(IA,IB)
	ENDIF
	ENDDO
	ALRUP=ALRUP+GR2UP(IA,IA)
	ALRDN=ALRDN+GR2DN(IA,IA)
	ENDDO
      ENDIF
C SET EXCHANGE-CORRELATION
      CALL POT_EXCVXC(ROUP,RODN,GR1UP,GR1DN,GR2UP,GR2DN,ALRUP,ALRDN,
     &            ILDA,IGGA,KEY,NSPIN,EXCUP,EXCDN,VXCUP,VXCDN)
	    IF(KEY.EQ.1.AND.ILSD.EQ.1)THEN
	XC(1)=VXCUP
	XC(2)=VXCDN
	ELSEIF(KEY.EQ.1.AND.ILSD.EQ.0)THEN
	XC(1)=0.5D0*(VXCUP+VXCDN)
	XC(2)=0.5D0*(VXCUP+VXCDN)
	ELSEIF(KEY.EQ.2.AND.ILSD.EQ.1)THEN
	XC(1)=EXCUP
	XC(2)=EXCDN
	ELSEIF(KEY.EQ.2.AND.ILSD.EQ.0)THEN
	XC(1)=0.5D0*(EXCUP+EXCDN)
	XC(2)=0.5D0*(EXCUP+EXCDN)
	ENDIF
      DO IUPDN=1,NSPIN
	VXCRS(IFFT,IUPDN,1)=0.5D0*(XC(1)+XC(NSPIN))
	IF(ABS(AMAG).GT.1.D-14)
     &VXCRS(IFFT,IUPDN,1)=VXCRS(IFFT,IUPDN,1)+(-1)**(IUPDN+1)*
     &0.5D0*(XC(1)-XC(NSPIN))*ZMAG/AMAG
	IF(NORBS.EQ.2)
     &VXCRS(IFFT,IUPDN,NORBS)=(0.D0,0.D0)
	IF(NORBS.EQ.2.AND.ABS(AMAG).GT.1.D-14)
     &VXCRS(IFFT,IUPDN,NORBS)=
     &0.5D0*(XC(1)-XC(NSPIN))*RHORS(IFFT,IUPDN,NORBS)/AMAG
      ENDDO
1000  CONTINUE                            !!! over mfft1
2000  CONTINUE                            !!! over mfft2
3000  CONTINUE                            !!! over mfft3
C GET EXCHANGE-CORRELATION POTENTIAL BY RECIPROCAL FOURIER TRANSFORM
	DO IORBS=1,NORBS
	DO IUPDN=1,NSPIN
	CALL POT_FTRANSR(POTPS(0,IUPDN,IORBS),
     &VXCRS(1,IUPDN,IORBS),TMPARR,QGAM)
	ENDDO
	ENDDO
C MEMORY DEALLOCATAIONS FOR SCRATCH ARRAYS
	DEALLOCATE(RHORS)
	DEALLOCATE(G1RHO)
	DEALLOCATE(G2RHO)
	DEALLOCATE(VXCRS)
	DEALLOCATE(TMPARR)
      CURMEM=CURMEM-SIZE_RHORS-SIZE_G1RHO-SIZE_G2RHO-
     &SIZE_VXCRS-SIZE_TMPARR
	END




	SUBROUTINE POT_FTRANSD(RHOPS,RHORS,RHOTM,IA,IB,QPNT)
********************************************************************
* Makes direct Fourier transform for the density and its gradients *
********************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LATPAR  ,ONLY: PAR,ORTH,OMEGAC                  !!! from readini
      USE COM_LATTICE ,ONLY: RBAS,GBAS                        !!! from readstr
      USE COM_PLWMESH ,ONLY: NPLW,GPLW,KVEC,KGMIN,KGMAX,INDG  !!! from plwmesh
      USE COM_FFTMESH ,ONLY: NFFTG,AD,RD                      !!! from fftmesh
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER MF(3)
	COMPLEX*16 RHOPS(0:NPLWMEM),RHORS(NFFTMEM)
     &  ,RHOTM(NFFTMEM),EXPQR,EXPGR
	DIMENSION QPNT(3),GL(3)
	DATA PI/3.141592653589793D0/
C **** SET CHARGE DENSITY AT THE RECIPROCAL MESH ***
	DO M3=KGMIN(3),KGMAX(3)
	DO M2=KGMIN(2),KGMAX(2)
	DO M1=KGMIN(1),KGMAX(1)
	IDIM=1+M1-KGMIN(1)+(KGMAX(1)-KGMIN(1)+1)*(M2-KGMIN(2))+
     &(KGMAX(1)-KGMIN(1)+1)*(KGMAX(2)-KGMIN(2)+1)*(M3-KGMIN(3))
	IPLW=INDG(IDIM)
	GL(1)=M1*GBAS(1,1)+M2*GBAS(1,2)+M3*GBAS(1,3)
	GL(2)=M1*GBAS(2,1)+M2*GBAS(2,2)+M3*GBAS(2,3)
	GL(3)=M1*GBAS(3,1)+M2*GBAS(3,2)+M3*GBAS(3,3)
C REDUCE TO FIRST CELL GIVEN BY RD(I,1..3)
	CALL REDFCEL(GL,GBAS,RBAS,NFFTG,MF)
	IFTR=1+MF(1)+MF(2)*NFFTG(1)+MF(3)*NFFTG(1)*NFFTG(2)
	IF(IA.EQ.0.AND.IB.EQ.0)THEN
C Density:
	IF(IPLW.EQ.-1)RHOTM(IFTR)=(0.D0,0.D0)
	IF(IPLW.NE.-1)RHOTM(IFTR)=RHOPS(IPLW)
	ELSEIF(IA.NE.0.AND.IB.EQ.0)THEN
C Density gradients:
	IF(IPLW.EQ.-1)RHOTM(IFTR)=(0.D0,0.D0)
	IF(IPLW.NE.-1)RHOTM(IFTR)=(0.D0,1.D0)*
     &RHOPS(IPLW)*(QPNT(IA)+GPLW(IA,IPLW))*
     &2.D0*PI/PAR
	ELSEIF(IA.EQ.0.AND.IB.NE.0)THEN
C Density gradients:
	IF(IPLW.EQ.-1)RHOTM(IFTR)=(0.D0,0.D0)
	IF(IPLW.NE.-1)RHOTM(IFTR)=(0.D0,1.D0)*
     &RHOPS(IPLW)*(QPNT(IB)+GPLW(IB,IPLW))*
     &2.D0*PI/PAR
	ELSEIF(IA.NE.0.AND.IB.NE.0)THEN
C Second gradients:
	IF(IPLW.EQ.-1)RHOTM(IFTR)=(0.D0,0.D0)
	IF(IPLW.NE.-1)RHOTM(IFTR)=-(2.D0*PI/PAR)**2*
     &(QPNT(IA)+GPLW(IA,IPLW))*(QPNT(IB)+GPLW(IB,IPLW))*
     &RHOPS(IPLW)
	ENDIF
	ENDDO
	ENDDO
	ENDDO
C **** SET CHARGE DENSITY AT THE REAL SPACE MESH ***
C DO OVER "G2","G3" AND "R1", *** GET RHO{R1,G2,G3} ***
	DO MFTR3=0,NFFTG(3)-1
	DO MFTR2=0,NFFTG(2)-1
	DO MFFT1=0,NFFTG(1)-1
	IFFT=1+MFFT1+MFTR2*NFFTG(1)+MFTR3*NFFTG(1)*NFFTG(2)
	RSX=MFFT1*AD(1,1)
	RSY=MFFT1*AD(2,1)
	RSZ=MFFT1*AD(3,1)
	RHORS(IFFT)=(0.D0,0.D0)
C SUM OVER "G1"
	DO MFTR1=0,NFFTG(1)-1
	IFTR=1+MFTR1+MFTR2*NFFTG(1)+MFTR3*NFFTG(1)*NFFTG(2)
	SCP=RSX*MFTR1*GBAS(1,1)+RSY*MFTR1*GBAS(2,1)+RSZ*MFTR1*GBAS(3,1)
	EXPGR=EXP((0.D0,1.D0)*2.D0*PI*SCP)
	RHORS(IFFT)=RHORS(IFFT)+EXPGR*RHOTM(IFTR)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C DO OVER "G3","R1" AND "R2", *** GET RHO{R1,R2,G3} ***
	DO MFTR3=0,NFFTG(3)-1
	DO MFFT1=0,NFFTG(1)-1
	DO MFFT2=0,NFFTG(2)-1
	IFFT=1+MFFT1+MFFT2*NFFTG(1)+MFTR3*NFFTG(1)*NFFTG(2)
	RSX=MFFT2*AD(1,2)
	RSY=MFFT2*AD(2,2)
	RSZ=MFFT2*AD(3,2)
	RHOTM(IFFT)=(0.D0,0.D0)
C SUM OVER "G2"
	DO MFTR2=0,NFFTG(2)-1
	IFTR=1+MFFT1+MFTR2*NFFTG(1)+MFTR3*NFFTG(1)*NFFTG(2)
	SCP=RSX*MFTR2*GBAS(1,2)+RSY*MFTR2*GBAS(2,2)+RSZ*MFTR2*GBAS(3,2)
	EXPGR=EXP((0.D0,1.D0)*2.D0*PI*SCP)
	RHOTM(IFFT)=RHOTM(IFFT)+EXPGR*RHORS(IFTR)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C DO OVER "R1","R2" AND "R3", *** GET RHO{R1,R2,R3} ***
	DO MFFT1=0,NFFTG(1)-1
	DO MFFT2=0,NFFTG(2)-1
	DO MFFT3=0,NFFTG(3)-1
	IFFT=1+MFFT1+MFFT2*NFFTG(1)+MFFT3*NFFTG(1)*NFFTG(2)
	RSX=MFFT3*AD(1,3)
	RSY=MFFT3*AD(2,3)
	RSZ=MFFT3*AD(3,3)
	RHORS(IFFT)=(0.D0,0.D0)
C SUM OVER "G3"
	DO MFTR3=0,NFFTG(3)-1
	IFTR=1+MFFT1+MFFT2*NFFTG(1)+MFTR3*NFFTG(1)*NFFTG(2)
	SCP=RSX*MFTR3*GBAS(1,3)+RSY*MFTR3*GBAS(2,3)+RSZ*MFTR3*GBAS(3,3)
	EXPGR=EXP((0.D0,1.D0)*2.D0*PI*SCP)
	RHORS(IFFT)=RHORS(IFFT)+EXPGR*RHOTM(IFTR)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C GET RHO{R1,R2,R3} IF IT IS A BLOCH WAVE OF WAVEVECTOR "Q"
      DO MFFT1=0,NFFTG(1)-1
      DO MFFT2=0,NFFTG(2)-1
      DO MFFT3=0,NFFTG(3)-1
      IFFT=1+MFFT1+MFFT2*NFFTG(1)+MFFT3*NFFTG(1)*NFFTG(2)
      RSX=MFFT1*AD(1,1)+MFFT2*AD(1,2)+MFFT3*AD(1,3)
      RSY=MFFT1*AD(2,1)+MFFT2*AD(2,2)+MFFT3*AD(2,3)
      RSZ=MFFT1*AD(3,1)+MFFT2*AD(3,2)+MFFT3*AD(3,3)
      SCP=RSX*QPNT(1)+RSY*QPNT(2)+RSZ*QPNT(3)
      EXPQR=EXP((0.D0,1.D0)*2.D0*PI*SCP)
      RHORS(IFFT)=RHORS(IFFT)*EXPQR
      ENDDO
      ENDDO
      ENDDO
	END



	SUBROUTINE POT_FTRANSR(POTPS,VXCRS,VXCTM,QPNT)
********************************************************************
* Makes reciprocal Fourier transform for the potential             *
********************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LATPAR  ,ONLY : PAR,ORTH,OMEGAC                 !!! from readini
      USE COM_LATTICE ,ONLY : RBAS,GBAS                       !!! from readstr
      USE COM_PLWMESH ,ONLY : NPLW,GPLW,KVEC,KGMIN,KGMAX,INDG !!! from plwmesh
      USE COM_FFTMESH ,ONLY : NFFTG,AD,RD                     !!! from fftmesh
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER MF(3)
	COMPLEX*16 POTPS(0:NPLWMEM),VXCRS(NFFTMEM)
     &  ,VXCTM(NFFTMEM),EXPGR,EXPQR
	DIMENSION QPNT(3),GL(3)
	DATA PI/3.141592653589793D0/
C GET EXCHANGE-CORRELATION PSEUDOPOTENTIAL BY FAST FOURIER TRANSFORM
C GET VXC{R1,R2,R3} MULTIPLIED BY EXP(-IQR) IF IT IS A BLOCH WAVE
      DO MFFT1=0,NFFTG(1)-1
      DO MFFT2=0,NFFTG(2)-1
      DO MFFT3=0,NFFTG(3)-1
      IFFT=1+MFFT1+MFFT2*NFFTG(1)+MFFT3*NFFTG(1)*NFFTG(2)
      RSX=MFFT1*AD(1,1)+MFFT2*AD(1,2)+MFFT3*AD(1,3)
      RSY=MFFT1*AD(2,1)+MFFT2*AD(2,2)+MFFT3*AD(2,3)
      RSZ=MFFT1*AD(3,1)+MFFT2*AD(3,2)+MFFT3*AD(3,3)
      SCP=RSX*QPNT(1)+RSY*QPNT(2)+RSZ*QPNT(3)
      EXPQR=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
      VXCRS(IFFT)=VXCRS(IFFT)*EXPQR
      ENDDO
      ENDDO
      ENDDO
C DO OVER "R2","R3" AND "G1", *** GET VXC{G1,R2,R3} ***
	DO MFFT3=0,NFFTG(3)-1
	DO MFFT2=0,NFFTG(2)-1
	DO MFTR1=0,NFFTG(1)-1
	IFTR=1+MFTR1+MFFT2*NFFTG(1)+MFFT3*NFFTG(1)*NFFTG(2)
	GX=MFTR1*GBAS(1,1)
	GY=MFTR1*GBAS(2,1)
	GZ=MFTR1*GBAS(3,1)
	VXCTM(IFTR)=(0.D0,0.D0)
C SUM OVER "R1"
	DO MFFT1=0,NFFTG(1)-1
	IFFT=1+MFFT1+MFFT2*NFFTG(1)+MFFT3*NFFTG(1)*NFFTG(2)
	SCP=GX*MFFT1*AD(1,1)+GY*MFFT1*AD(2,1)+GZ*MFFT1*AD(3,1)
	EXPGR=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	VXCTM(IFTR)=VXCTM(IFTR)+EXPGR*VXCRS(IFFT)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C DO OVER "R3","G1" AND "G2", *** GET VXC{G1,G2,R3} ***
	DO MFFT3=0,NFFTG(3)-1
	DO MFTR1=0,NFFTG(1)-1
	DO MFTR2=0,NFFTG(2)-1
	IFTR=1+MFTR1+MFTR2*NFFTG(1)+MFFT3*NFFTG(1)*NFFTG(2)
	GX=MFTR2*GBAS(1,2)
	GY=MFTR2*GBAS(2,2)
	GZ=MFTR2*GBAS(3,2)
	VXCRS(IFTR)=(0.D0,0.D0)
C SUM OVER "R2"
	DO MFFT2=0,NFFTG(2)-1
	IFFT=1+MFTR1+MFFT2*NFFTG(1)+MFFT3*NFFTG(1)*NFFTG(2)
	SCP=GX*MFFT2*AD(1,2)+GY*MFFT2*AD(2,2)+GZ*MFFT2*AD(3,2)
	EXPGR=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	VXCRS(IFTR)=VXCRS(IFTR)+EXPGR*VXCTM(IFFT)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C DO OVER "G1","G2" AND "G3", *** GET VXC{G1,G2,G3} ***
	DO MFTR1=0,NFFTG(1)-1
	DO MFTR2=0,NFFTG(2)-1
	DO MFTR3=0,NFFTG(3)-1
	IFTR=1+MFTR1+MFTR2*NFFTG(1)+MFTR3*NFFTG(1)*NFFTG(2)
	GX=MFTR3*GBAS(1,3)
	GY=MFTR3*GBAS(2,3)
	GZ=MFTR3*GBAS(3,3)
	VXCTM(IFTR)=(0.D0,0.D0)
C SUM OVER "R3"
	DO MFFT3=0,NFFTG(3)-1
	IFFT=1+MFTR1+MFTR2*NFFTG(1)+MFFT3*NFFTG(1)*NFFTG(2)
	SCP=GX*MFFT3*AD(1,3)+GY*MFFT3*AD(2,3)+GZ*MFFT3*AD(3,3)
	EXPGR=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	VXCTM(IFTR)=VXCTM(IFTR)+EXPGR*VXCRS(IFFT)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C **** SET EXCHANGE-CORRELATION PSEUDOPOTENTIAL WITHIN SPHERE GMAX ***
      ANORM=1.D0/DBLE(NFFTG(1)*NFFTG(2)*NFFTG(3))
      DO M3=KGMIN(3),KGMAX(3)
      DO M2=KGMIN(2),KGMAX(2)
      DO M1=KGMIN(1),KGMAX(1)
      IDIM=1+M1-KGMIN(1)+(KGMAX(1)-KGMIN(1)+1)*(M2-KGMIN(2))+
     &(KGMAX(1)-KGMIN(1)+1)*(KGMAX(2)-KGMIN(2)+1)*(M3-KGMIN(3))
      IPLW=INDG(IDIM)
      IF(IPLW.NE.-1)THEN
      GL(1)=M1*GBAS(1,1)+M2*GBAS(1,2)+M3*GBAS(1,3)
      GL(2)=M1*GBAS(2,1)+M2*GBAS(2,2)+M3*GBAS(2,3)
      GL(3)=M1*GBAS(3,1)+M2*GBAS(3,2)+M3*GBAS(3,3)
C REDUCE TO FIRST CELL GIVEN BY RD(I,1..3)
      CALL REDFCEL(GL,GBAS,RBAS,NFFTG,MF)
      IFTR=1+MF(1)+MF(2)*NFFTG(1)+MF(3)*NFFTG(1)*NFFTG(2)
      POTPS(IPLW)=POTPS(IPLW)+ANORM*VXCTM(IFTR) ! add to Vc
      ENDIF
      ENDDO
      ENDDO
      ENDDO
	END
