	SUBROUTINE POT_ZEROV
***********************************************
*   Set up muffin-tin zero for the potential  *
***********************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_CONTROL ,ONLY: LRWF                             !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS
     &                      ,IS,ILSV,NHSORT                   !!! from readini
      USE COM_LATPAR  ,ONLY: PAR,OMEGAC                       !!! from readini
      USE COM_SPHERE  ,ONLY: ZNUC,ZCOR,SMT,SWZ                !!! from readini
      USE COM_SYMMLM  ,ONLY: SYM,LMSYM                        !!! from symlmm
      USE COM_POTDAT  ,ONLY: POT,POTSPH,POTPS,POTRWF          !!! from potfull
      USE COM_DENDAT  ,ONLY:                  POTFRZ          !!! from potfull
      USE COM_POTMTS  ,ONLY: VMT0,VMT,VSF0,VSF,VAV0           !!! from potzero
      USE COM_PLWMESH ,ONLY: NPLW,GPLW                        !!! from plwmesh
      USE COM_RADMESH ,ONLY: NRAD,H,R,DR,WEIGHT,RL            !!! from radmesh
      USE COM_MAGDAT  ,ONLY: AXMAG,AXEXT,BEXT,ISPL,BSPL       !!! from readini
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16 GINT,AMAG(-1:1),AEXT(-1:1)
	DATA PI/3.141592653589793D0/
	SQPI4=2.D0*SQRT(PI)
      CALL ABORTNOW()
C MEMORY ALLOCATIONS FOR MAIN CONTROL ARRAYS
	IF(.NOT.ALLOCATED(VMT))
     &ALLOCATE(VMT(NSORTMEM,NSPINMEM))
	IF(.NOT.ALLOCATED(VSF))
     &ALLOCATE(VSF(NSORTMEM,NSPINMEM))
C ADD NUCLEAR POTENTIAL
      DO ISPIN=1,NSPIN                    !!! over spins
      DO IATOM=1,NATOM                    !!! over atoms
      ISORT=IS(IATOM)
      DO IRAD=1,NRAD(ISORT)               !!! over radial mesh
      POT(IRAD,1,IATOM,ISPIN,1)=POT(IRAD,1,IATOM,ISPIN,1)-
     &2.D0*ZNUC(ISORT)/R(IRAD,ISORT)*SQPI4
      ENDDO                               !!! over radial mesh
      POT(0,1,IATOM,ISPIN,1)=POT(1,1,IATOM,ISPIN,1)
	ENDDO
	ENDDO
C APPLY EXTERNAL MAGNETIC FIELD ALONG LOCAL AXIS
C THIS WILL JUST SPLIT SPIN-UP AND SPIN-DN POTENTIAL 
C FOR AXIS ALONG (0,0,1)
      DO IATOM=1,NATOM                    !!! over atoms
      ISORT=IS(IATOM)
	AMAG(+0)=  AXMAG(3,ISORT)
	AMAG(-1)=+(AXMAG(1,ISORT)+(0.D0,1.D0)*AXMAG(2,ISORT))/SQRT(2.D0)    !!! B^{-}
	AMAG(+1)=-(AXMAG(1,ISORT)-(0.D0,1.D0)*AXMAG(2,ISORT))/SQRT(2.D0)    !!! B^{+}
	AMAG(+0)=AMAG(+0)*BSPL(ISORT)
	AMAG(-1)=AMAG(-1)*BSPL(ISORT)
	AMAG(+1)=AMAG(+1)*BSPL(ISORT)
	AEXT(+0)=  AXEXT(3,ISORT)
	AEXT(-1)=+(AXEXT(1,ISORT)+(0.D0,1.D0)*AXEXT(2,ISORT))/SQRT(2.D0)
	AEXT(+1)=-(AXEXT(1,ISORT)-(0.D0,1.D0)*AXEXT(2,ISORT))/SQRT(2.D0)
	AEXT(+0)=AEXT(+0)*BEXT(ISORT)
	AEXT(-1)=AEXT(-1)*BEXT(ISORT)
	AEXT(+1)=AEXT(+1)*BEXT(ISORT)
C Positive Bspl, Bext would mean that induced moment is along - (minus) magnetization axis
      DO IRAD=0,NRAD(ISORT)
      POT(IRAD,1,IATOM,1,1)=POT(IRAD,1,IATOM,1,1)+
     &(AMAG(+0)+AEXT(+0))*SQPI4
      POT(IRAD,1,IATOM,NSPIN,1)=POT(IRAD,1,IATOM,NSPIN,1)-
     &(AMAG(+0)+AEXT(+0))*SQPI4
	IF(NORBS.EQ.2)THEN
      POT(IRAD,1,IATOM,1,NORBS)=POT(IRAD,1,IATOM,1,NORBS)+
     &(AMAG(-1)+AEXT(-1))*SQPI4
      POT(IRAD,1,IATOM,NSPIN,NORBS)=POT(IRAD,1,IATOM,NSPIN,NORBS)+
     &(AMAG(+1)+AEXT(+1))*SQPI4
	ENDIF
      ENDDO
      ENDDO                               !!! over atoms
C  Switch on in the interstitials?
	ANX=AXMAG(1,1)
	ANY=AXMAG(2,1)
	ANZ=AXMAG(3,1)
	AEX=AXEXT(1,1)
	AEY=AXEXT(2,1)
	AEZ=AXEXT(3,1)
	SPL=0.D0
	BXT=0.D0
	LM=1
	LB=1
	DO ISORT=1,NSORT
	IF(ABS(ANX-AXMAG(1,ISORT)).GE.1.D-07.OR.
     &   ABS(ANY-AXMAG(2,ISORT)).GE.1.D-07.OR.
     &   ABS(ANZ-AXMAG(3,ISORT)).GE.1.D-07)LM=0
	IF(ABS(AEX-AXEXT(1,ISORT)).GE.1.D-07.OR.
     &   ABS(AEY-AXEXT(2,ISORT)).GE.1.D-07.OR.
     &   ABS(AEZ-AXEXT(3,ISORT)).GE.1.D-07)LB=0
	SPL=SPL+BSPL(ISORT)*DBLE(NHSORT(ISORT))/DBLE(NATOM)
	BXT=BXT+BEXT(ISORT)*DBLE(NHSORT(ISORT))/DBLE(NATOM)
	ENDDO
C	IF(NATOM.EQ.1)LM=1
C	IF(NATOM.NE.1)LM=0
C	IF(NATOM.EQ.1)LB=1
C	IF(NATOM.NE.1)LB=0
	AMAG(+0)=  ANZ
	AMAG(-1)=+(ANX+(0.D0,1.D0)*ANY)/SQRT(2.D0)
	AMAG(+1)=-(ANX-(0.D0,1.D0)*ANY)/SQRT(2.D0)
	AMAG(+0)=AMAG(+0)*SPL*LM
	AMAG(-1)=AMAG(-1)*SPL*LM
	AMAG(+1)=AMAG(+1)*SPL*LM
	AEXT(+0)=  AEZ
	AEXT(-1)=+(AEX+(0.D0,1.D0)*AEY)/SQRT(2.D0)
	AEXT(+1)=-(AEX-(0.D0,1.D0)*AEY)/SQRT(2.D0)
	AEXT(+0)=AEXT(+0)*BXT*LB
	AEXT(-1)=AEXT(-1)*BXT*LB
	AEXT(+1)=AEXT(+1)*BXT*LB
      IF(NPLW.NE.-1)
     &POTPS(0,1,1)=POTPS(0,1,1)+AMAG(+0)+AEXT(+0)
      IF(NPLW.NE.-1)
     &POTPS(0,NSPIN,1)=POTPS(0,NSPIN,1)-AMAG(+0)-AEXT(+0)
	IF(NORBS.EQ.2)THEN
      IF(NPLW.NE.-1)
     &POTPS(0,1,NORBS)=POTPS(0,1,NORBS)+AMAG(-1)+AEXT(-1)
      IF(NPLW.NE.-1)
     &POTPS(0,NSPIN,NORBS)=POTPS(0,NSPIN,NORBS)+AMAG(+1)+AEXT(+1)
	ENDIF
C
      PSVINT=0.D0
      DO IPLW=0,NPLW
      CALL MAKEPLW_SINT(GPLW(1,IPLW),GPLW(2,IPLW),GPLW(3,IPLW),GINT)
      PSVINT=PSVINT+(POTPS(IPLW,1,1)+POTPS(IPLW,NSPIN,1))/2.D0*GINT
      ENDDO
C SET UP SPLITTING TO ZERO
      DO ISORT=1,NSORT
      IF(ISPL(ISORT).NE.1)BSPL(ISORT)=0.D0
      ENDDO
C DEFINE MT-ZERO AND SURFACE ZERO
      VMT0=0.D0
      VSF0=0.D0
      SURFACE=0.D0
      OMEGAM=0.D0
      DO ISPIN=1,NSPIN
      DO ISORT=1,NSORT
      VMT(ISORT,ISPIN)=0.D0
      VSF(ISORT,ISPIN)=0.D0
      DO IATOM=1,NATOM
      IF(IS(IATOM).EQ.ISORT)THEN
      VMT(ISORT,ISPIN)=VMT(ISORT,ISPIN)+
     &POT(NRAD(ISORT),1,IATOM,ISPIN,1)/SQRT(4.D0*PI)/
     &DBLE(NHSORT(ISORT))
      ENDIF
      ENDDO
      VSF(ISORT,ISPIN)=VMT(ISORT,ISPIN)
      OMEGAM=OMEGAM+4.D0/3.D0*PI*NHSORT(ISORT)*SMT(ISORT)**3/
     &DBLE(NSPIN)
      SURFACE=SURFACE+4.D0*PI*NHSORT(ISORT)*SMT(ISORT)**2/DBLE(NSPIN)
      VSF0=VSF0+4.D0*PI*VMT(ISORT,ISPIN)*NHSORT(ISORT)*
     &SMT(ISORT)**2
      VMT0=VMT0+VMT(ISORT,ISPIN)*NHSORT(ISORT)
      ENDDO
      ENDDO
      VMT0=VMT0/DBLE(NATOM*NSPIN)
      VSF0=VSF0/SURFACE-VMT0
	IF(ABS(OMEGAC-OMEGAM).LE.1.D-10)
     &VAV0=0.D0
      IF(ABS(OMEGAC-OMEGAM).GT.1.D-10)
     &VAV0=PSVINT/(OMEGAC-OMEGAM)
C SHIFT POTENTIAL ACOORDING TO NEW ZERO
      DO ISPIN=1,NSPIN
      DO IATOM=1,NATOM
      DO IRAD=0,NRAD(IS(IATOM))
      POT(IRAD,1,IATOM,ISPIN,1)=POT(IRAD,1,IATOM,ISPIN,1)-VMT0*SQPI4
      ENDDO
      ENDDO
      IF(NPLW.NE.-1)POTPS(0,ISPIN,1)=POTPS(0,ISPIN,1)-VMT0
      ENDDO
C SET SPHERICAL PART OF THE POTENTIAL
      DO ISORT=1,NSORT
      DO ISPIN=1,NSPIN
      DO IRAD=0,NRAD(ISORT)
      POTSPH(IRAD,ISORT,ISPIN)=0.D0
      ENDDO
      DO IATOM=1,NATOM
      IF(IS(IATOM).EQ.ISORT)THEN
      DO IRAD=0,NRAD(ISORT)
      POTSPH(IRAD,ISORT,ISPIN)=POTSPH(IRAD,ISORT,ISPIN)-
     &R(IRAD,ISORT)*POT(IRAD,1,IATOM,ISPIN,1)/SQPI4/
     &DBLE(NHSORT(ISORT))
      ENDDO
      ENDIF
      ENDDO
      POTSPH(0,ISORT,ISPIN)=2.D0*ZNUC(ISORT)
      ENDDO
      ENDDO
C ********************************************************
C SET SPHERICAL POTENTIAL FOR CALCULATING RADIAL FUNCTIONS
	IF(LRWF.EQ.0)THEN
	DO ISORT=1,NSORT
	DO ISPIN=1,NSPIN
C READ from SCSFILE:
	DO IRAD=0,NRAD(ISORT)
      POTRWF(IRAD,ISORT,ISPIN)=POTFRZ(IRAD,ISORT,ISPIN)
	ENDDO
	ENDDO
	ENDDO
	RETURN 
	ENDIF
C CALCULATE
      DO ISORT=1,NSORT                                     !!! over sorts
      DO ISPIN=1,NSPIN                                     !!! over spins
      DO IRAD=0,NRAD(ISORT)
      POTRWF(IRAD,ISORT,ISPIN)=0.D0
      ENDDO
      DO IATOM=1,NATOM
      IF(IS(IATOM).EQ.ISORT)THEN
C Spin-averaged:
      IF(LRWF.EQ.1)THEN
      DO IRAD=0,NRAD(ISORT)
      POTRWF(IRAD,ISORT,ISPIN)=POTRWF(IRAD,ISORT,ISPIN)-
     &0.5D0*R(IRAD,ISORT)*POT(IRAD,1,IATOM,1    ,1)/SQPI4/
     &DBLE(NHSORT(ISORT))-
     &0.5D0*R(IRAD,ISORT)*POT(IRAD,1,IATOM,NSPIN,1)/SQPI4/
     &DBLE(NHSORT(ISORT))
      ENDDO
C Spin-dependent:
      ELSEIF(LRWF.EQ.2)THEN
      DO IRAD=0,NRAD(ISORT)
      POTRWF(IRAD,ISORT,ISPIN)=POTRWF(IRAD,ISORT,ISPIN)-
     &R(IRAD,ISORT)*POT(IRAD,1,IATOM,ISPIN,1)/SQPI4/
     &DBLE(NHSORT(ISORT))
      ENDDO
      ENDIF
      ENDIF
      ENDDO
      POTRWF(0,ISORT,ISPIN)=2.D0*ZNUC(ISORT)
C POTFRZ equivalent to POTRWF everywhere for LRWF>0
	DO IRAD=0,NRAD(ISORT)
      POTFRZ(IRAD,ISORT,ISPIN)=POTRWF(IRAD,ISORT,ISPIN)
	ENDDO
      ENDDO                                                !!! over spins
      ENDDO                                                !!! over sorts
      END
