      SUBROUTINE QMC_ALLOCATE(TOPER)
************************************************************
*  Allocates/deallocates data for RAT routines             *
************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                    !!! from setup
      USE COM_QMCPAR  ,ONLY: MODR                                       !!! from readrat
	USE COM_MSBMESH ,ONLY: TEMP,NMSC,WMSC,FMSC                        !!! from readrat
      USE COM_LSHELL  ,ONLY: LORB,LOCCIMP,ELEV
      USE COM_IMPGRF  ,ONLY: GLOC,NRAT,NPOL,KRAT,KINT,BATH,DELW,
     &                       NMOM,GMOM,DMAT,NPOL,SIGW,SIG0,BMAS,SIGI,
     &                       SRAT,VRAT,WRAT,PRAT,ORAT,DTRM,RTRM,
     &                       VRHB,WRHB,PRHB,ORHB,NPLD
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER*1 TOPER
      DATA PI/3.141592653589793D0/
C QMC interface
      IF(TOPER.EQ.'A')THEN
C Memory Allocations for Green function arrays
	NDEG=2*(2*LORB+1)
	IF(.NOT.ALLOCATED(GMOM))ALLOCATE(GMOM(NDEG,NDEG,-NMOM:+NMOM))
	IF(.NOT.ALLOCATED(DMAT))ALLOCATE(DMAT(NDEG,NDEG,-NMOM:+NMOM))
	IF(.NOT.ALLOCATED(GLOC))ALLOCATE(GLOC(NDEG,NDEG,0:NMSC))
	IF(.NOT.ALLOCATED(SIGW))ALLOCATE(SIGW(NDEG,NDEG,0:NMSC))
      IF(.NOT.ALLOCATED(BATH))ALLOCATE(BATH(NDEG,NDEG,0:NMSC))
      IF(.NOT.ALLOCATED(DELW))ALLOCATE(DELW(NDEG,NDEG,0:NMSC))
	IF(.NOT.ALLOCATED(BMAS))ALLOCATE(BMAS(NDEG,NDEG))
	IF(.NOT.ALLOCATED(DTRM))ALLOCATE(DTRM(NDEG,NDEG))
	IF(.NOT.ALLOCATED(RTRM))ALLOCATE(RTRM(NDEG,NDEG))
	IF(.NOT.ALLOCATED(SIG0))ALLOCATE(SIG0(NDEG,NDEG))
	IF(.NOT.ALLOCATED(SIGI))ALLOCATE(SIGI(NDEG,NDEG))
	IF(.NOT.ALLOCATED(SRAT))ALLOCATE(SRAT(NDEG,NDEG))
	IF(.NOT.ALLOCATED(VRAT))ALLOCATE(VRAT(NDEG,NDEG,NRAT))
	IF(.NOT.ALLOCATED(WRAT))ALLOCATE(WRAT(NDEG,NDEG,NRAT))
	IF(.NOT.ALLOCATED(PRAT))ALLOCATE(PRAT(NDEG,NDEG,NRAT))
	IF(.NOT.ALLOCATED(ORAT))ALLOCATE(ORAT(NDEG,NDEG,NRAT))
	IF(.NOT.ALLOCATED(VRHB))ALLOCATE(VRHB(NDEG,NDEG,NPLD))
	IF(.NOT.ALLOCATED(WRHB))ALLOCATE(WRHB(NDEG,NDEG,NPLD))
	IF(.NOT.ALLOCATED(PRHB))ALLOCATE(PRHB(NDEG,NDEG,NPLD))
	IF(.NOT.ALLOCATED(ORHB))ALLOCATE(ORHB(NDEG,NDEG,NPLD))
      ELSEIF(TOPER.EQ.'D')THEN
C Memory Deallocations for Green function arrays
      IF(ALLOCATED(GMOM))DEALLOCATE(GMOM)
      IF(ALLOCATED(DMAT))DEALLOCATE(DMAT)
      IF(ALLOCATED(GLOC))DEALLOCATE(GLOC)
      IF(ALLOCATED(SIGW))DEALLOCATE(SIGW)
      IF(ALLOCATED(BATH))DEALLOCATE(BATH)
      IF(ALLOCATED(DELW))DEALLOCATE(DELW)
      IF(ALLOCATED(BMAS))DEALLOCATE(BMAS)
      IF(ALLOCATED(DTRM))DEALLOCATE(DTRM)
      IF(ALLOCATED(RTRM))DEALLOCATE(RTRM)
      IF(ALLOCATED(SIG0))DEALLOCATE(SIG0)
      IF(ALLOCATED(SIGI))DEALLOCATE(SIGI)
      IF(ALLOCATED(SRAT))DEALLOCATE(SRAT)
      IF(ALLOCATED(VRAT))DEALLOCATE(VRAT)
      IF(ALLOCATED(WRAT))DEALLOCATE(WRAT)
      IF(ALLOCATED(PRAT))DEALLOCATE(PRAT)
      IF(ALLOCATED(ORAT))DEALLOCATE(ORAT)
      IF(ALLOCATED(PRAT))DEALLOCATE(BATH)
      IF(ALLOCATED(ORAT))DEALLOCATE(DELW)
	IF(ALLOCATED(VRHB))DEALLOCATE(VRHB)
	IF(ALLOCATED(WRHB))DEALLOCATE(WRHB)
	IF(ALLOCATED(PRHB))DEALLOCATE(PRHB)
	IF(ALLOCATED(ORHB))DEALLOCATE(ORHB)
	ENDIF
      END