	SUBROUTINE QMC_GETGRF
******************************************************
*   Read Green function data                         *
******************************************************
C SET EXTERNAL CONNECTIONS
      USE COM_UNIT      ,ONLY: IUT,IUR,IUN                          !!! from setup
      USE COM_IMPGRF    ,ONLY: ICUB,NWOR,NWSP,IMRE                  !!! from getgrf
	USE COM_MSBMESH   ,ONLY: TEMP,KGRD,NMSC,WMSC,FMSC,DMSC        !!! from readrat
	USE COM_FREQU     ,ONLY: NOMGGRF                              !!! from getgrf
	USE COM_CHANNELS  ,ONLY: IUINP                                !!! from setup
      USE COM_QMCOUT    ,ONLY: ICGRF,GRFFILE                        !!! from readini
C SET LOCAL VARIBLES
	IMPLICIT REAL*8 (A-H,O-Z)
	CHARACTER DATA(100)*150,COPY(100)*150, HELP*40,TCTRL*10
	COMPLEX*16 CM
      LOGICAL EXIST,DEF,ASK,VAL,NTH
	DATA PI/3.141592653589793D0/
	IF(ICGRF.EQ.0)RETURN
	INQUIRE(FILE=GRFFILE,EXIST=EXIST)
	IF(EXIST)
     &OPEN(UNIT=IUINP,FILE=GRFFILE,STATUS='OLD',FORM='FORMATTED')
C TRY READING FIRST 99 LINES
	ILEN=0
	DO I=1,100
	ILEN=ILEN+1
	IF(EXIST)READ(IUINP,FMT='(A)',ERR=100,END=100)DATA(ILEN)
	ENDDO
  100 NLEN=ILEN-1
      IF(NLEN.EQ.0)NLEN=1
	IF(EXIST)CLOSE(IUINP)
      CALL READ_SECT(DATA(1),NLEN,ISEC,NSEC,MSEC,
     &'<section=ctrl',13,'<section=',9,'ok',2)
C Allocate temporary file
      DO ILIN=1,MSEC
      COPY(ILIN)=DATA(ILIN+ISEC-1)
      ENDDO
C Process NOMGGRF
      NOMGGRF=0
      HELP='! Real axis grid                       '
      LHLP=40
      CALL READ_CHAR(DATA(ISEC),COPY(1),NSEC,MSEC,
     &'nomggrf',7,NOMGGRF,1,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.FALSE.,.FALSE.)
C Process WMIN
	WMINGRF=-1.0D0
      HELP='! Min.Frequency                        '
      LHLP=40
      CALL READ_CHAR(DATA(ISEC),COPY(1),NSEC,MSEC,
     &'wmingrf',7,IN,1,0,WMINGRF,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.FALSE.,.FALSE.)
C Process WMAX
	WMAXGRF=+1.0D0
      HELP='! Max.Frequency                        '
      LHLP=40
      CALL READ_CHAR(DATA(ISEC),COPY(1),NSEC,MSEC,
     &'wmaxgrf',7,IN,1,0,WMAXGRF,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.FALSE.,.FALSE.)
C Process CUBC
      TCTRL='Cubic     '
      HELP='! Cubic/Spherical harmonics (output)    '
      LHLP=40
      CALL READ_CHAR(DATA(ISEC),COPY(1),NSEC,MSEC,
     &'yharm',5,IN,1,0,RE,1,0,CM,1,0,TCTRL,10,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
	CALL LIB_CONVLOW(TCTRL,10)
	CALL LIB_RMBLANK(TCTRL,10)
	NB=INDEX(TCTRL,' ')
	ICUB=0
	IF(TCTRL(:NB-1).EQ.'cubic')ICUB=1
	IF(TCTRL(:NB-1).EQ.'spherical')ICUB=2
	IF(TCTRL(:NB-1).EQ.'spinor')ICUB=3
	IF(ICUB.EQ.0)
     &CALL FULLSTOP('Wrong <<Yharm>> keyword in GRFFILE')
C Process NWOR
      TCTRL='One       '
      HELP='! One/Both orbits to store              '
      LHLP=40
      CALL READ_CHAR(DATA(ISEC),COPY(1),NSEC,MSEC,
     &'worbs',5,IN,1,0,RE,1,0,CM,1,0,TCTRL,10,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
	CALL LIB_CONVLOW(TCTRL,10)
	CALL LIB_RMBLANK(TCTRL,10)
	NB=INDEX(TCTRL,' ')
	NWOR=0
	IF(TCTRL(:NB-1).EQ.'one' )NWOR=1
	IF(TCTRL(:NB-1).EQ.'both')NWOR=2
	IF(NWOR.EQ.0)
     &CALL FULLSTOP('Wrong <<Worbs>> keyword in GRFFILE')
C Process NWSP
      TCTRL='One       '
      HELP='! One/Both spins  to store              '
      LHLP=40
      CALL READ_CHAR(DATA(ISEC),COPY(1),NSEC,MSEC,
     &'wspin',5,IN,1,0,RE,1,0,CM,1,0,TCTRL,10,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
	CALL LIB_CONVLOW(TCTRL,10)
	CALL LIB_RMBLANK(TCTRL,10)
	NB=INDEX(TCTRL,' ')
	NWSP=0
	IF(TCTRL(:NB-1).EQ.'one' )NWSP=1
	IF(TCTRL(:NB-1).EQ.'both')NWSP=2
	IF(NWSP.EQ.0)
     &CALL FULLSTOP('Wrong <<Wspin>> keyword in GRFFILE')
C Process REIM
      TCTRL='Complex   '
      HELP='! Real/Complex output                   '
      LHLP=40
      CALL READ_CHAR(DATA(ISEC),COPY(1),NSEC,MSEC,
     &'format',6,IN,1,0,RE,1,0,CM,1,0,TCTRL,10,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
	CALL LIB_CONVLOW(TCTRL,10)
	CALL LIB_RMBLANK(TCTRL,10)
	NB=INDEX(TCTRL,' ')
	IMRE=0
	IF(TCTRL(:NB-1).EQ.'real')   IMRE=1
	IF(TCTRL(:NB-1).EQ.'complex')IMRE=2
	IF(IMRE.EQ.0)
     &CALL FULLSTOP('Wrong <<format>> keyword in GRFFILE')
C RESET ENERGY GRID
      IF(KGRD.EQ.1.AND.NOMGGRF.GT.0)THEN
	NMSC=NOMGGRF
	IF(ALLOCATED(WMSC))DEALLOCATE(WMSC)
	IF(ALLOCATED(FMSC))DEALLOCATE(FMSC)
	IF(ALLOCATED(DMSC))DEALLOCATE(DMSC)
	ALLOCATE(WMSC(0:NMSC))
	ALLOCATE(FMSC(0:NMSC))
	ALLOCATE(DMSC(0:NMSC))
	IF(NMSC.NE.0)WSTEP=(WMAXGRF-WMINGRF)/DBLE(NMSC)
	IF(NMSC.EQ.0)WSTEP=0.D0
	DO IMSC=0,NMSC
	WMSC(IMSC)=DCMPLX(WMINGRF+DBLE(IMSC)*WSTEP,0.D0)
	FMSC(IMSC)=WSTEP*DBLE(NMSC)/DBLE(NMSC+1)
	DMSC(IMSC)=0.D0
	ENDDO
	ENDIF
	END
