	SUBROUTINE QMC_QMCYIF
****************************************************************
*  Quantum Monte Carlo (Yifeng Yang version interface)         *
****************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                    !!! from setup
      USE COM_STREAM  ,ONLY: ISTREAM                                    !!! from setup
      USE COM_QMCPAR  ,ONLY: MODR,NSWP,NTAU,NWUP,NSMP,BETA,MOMT,OMGT    !!! from readqmc
      USE COM_MSBMESH ,ONLY: TEMP,NMSC,WMSC,NMSL,WMSL,NMSB,WMSB         !!! from readqmc
      USE COM_LSHELL  ,ONLY: LORB,HMAG,HORB,ALSC,ELEV,FSLA,KSYS 
     &                      ,NRUNSHL,KSTSHL                             !!! from readrat
      USE COM_IMPGRF  ,ONLY: CHEM,FILL,KFRM,GLOC,NMOM,GMOM,
     &                       DMAT,SIGW,SIG0,BMAS,SIGI,BATH,DELW
      USE COM_QMCOUT  ,ONLY: ICQMC,ICGRF                                !!! from readqmc
      USE COM_LMTOUT  ,ONLY: SCRFILE,OUTFILE                            !!! from storage
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                            !!! from setup
      USE COM_MASHDEP ,ONLY: NVAL                                       !!! from setup
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8, ALLOCATABLE :: UMAT(:,:,:,:),UIMP(:,:,:,:),DENSQMC(:,:)
      REAL*8, ALLOCATABLE :: UDEG(:,:),UCOU(:,:,:,:),WMSX(:),WMSY(:)
      REAL*8, ALLOCATABLE :: USUM(:),SMOM(:),SIGIQMC(:),SIG1QMC(:)
      COMPLEX*16, ALLOCATABLE :: RMAT(:,:),TMAT(:,:),G0M1(:,:),WORK(:)
	COMPLEX*16, ALLOCATABLE :: YMSX(:),YMSY(:)
	COMPLEX*16, ALLOCATABLE :: DENM(:),GRNM(:)
	COMPLEX*16, ALLOCATABLE :: BATHQMC(:,:,:)
	COMPLEX*16, ALLOCATABLE :: DELWQMC(:,:,:)
	COMPLEX*16, ALLOCATABLE :: SIGWQMC(:,:,:)
	COMPLEX*16, ALLOCATABLE :: GLOCQMC(:,:,:)
      COMPLEX*16 ZMSB,ZMSY,DIM
      LOGICAL LDIAG
      DATA DIM/(0.D0,1.D0)/
      L=LORB
      NDIM=2*(2*L+1)
C MEMORY ALLOCATIONS
      ALLOCATE(UIMP(2*(2*L+1),2*(2*L+1),2*(2*L+1),2*(2*L+1)))
      ALLOCATE(UMAT(-L:L,-L:L,-L:L,-L:L))
      ALLOCATE(UCOU(-L:L,-L:L,-L:L,-L:L))
	DO IDIM1=1,NDIM
	DO IDIM=1,NDIM
      DO IMOM=-NMOM,+NMOM
      DMAT(IDIM1,IDIM,IMOM)=(0.D0,0.D0)
      GMOM(IDIM1,IDIM,IMOM)=(0.D0,0.D0)
      ENDDO
      SIGI(IDIM1,IDIM)=(0.D0,0.D0)
      SIG0(IDIM1,IDIM)=(0.D0,0.D0)
      BMAS(IDIM1,IDIM)=(0.D0,0.D0)
      DO IMSB=0,NMSB
      SIGW(IDIM1,IDIM,IMSB)=(0.D0,0.D0)
      GLOC(IDIM1,IDIM,IMSB)=(0.D0,0.D0)
      ENDDO      
      ENDDO
      ENDDO
C SET UP INTERACTION MATRIX IN THIS REPRESENTATION      
	CALL LIB_HUBMAT_L4(L,FSLA,UMAT,UPAR,GPAR)
	DO M1=-L,L
	DO M =-L,L
	DO K1=-L,L
	DO K=-L,L
C Ucou(mm',kk')=<mm'|1/r|kk'> corresponds to Umat(mk m'k')
	UCOU(M,M1,K,K1)=UMAT(M,K,M1,K1)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C Get desired representation: Uimp(abgd)=<ab|1/r|gd>
	CALL LIB_HUBMAT_K4(L,UCOU,UIMP,KSYS)
C Transform all arrays to local representation
      CALL LIB_TRANSCUB(NDIM,+KSYS,NDIM,+KSYS,ELEV(1,1))
      DO IMSB=0,NMSB
      CALL LIB_TRANSCUB(NDIM,+KSYS,NDIM,+KSYS,BATH(1,1,IMSB))
      CALL LIB_TRANSCUB(NDIM,+KSYS,NDIM,+KSYS,DELW(1,1,IMSB))
      ENDDO
C IF NO INPUT HYBRIDIZATION, SET UP SEMICIRCLE
      IF(ISTREAM.EQ.6)THEN
      DO IDIM1=1,NDIM
      DO IDIM=1,NDIM
	DO IMSB=0,NMSB
      BATH(IDIM1,IDIM,IMSB)=(0.D0,0.D0)
      DELW(IDIM1,IDIM,IMSB)=(0.D0,0.D0)
      ENDDO
      ENDDO
      ENDDO
      DO IDIM=1,NDIM
	DO IMSB=0,NMSB
	ZMSB=DCMPLX(0.D0,WMSB(IMSB))
	TBND=0.5D0
	CALL MDL_MODELHYB(TBND,ZMSB,DELW(IDIM,IDIM,IMSB))
	BATH(IDIM,IDIM,IMSB)=1.D0/(ZMSB+CHEM-ELEV(IDIM,IDIM)-
     &                           DELW(IDIM,IDIM,IMSB))
	ENDDO
	ENDDO
      ENDIF
C DO OVER SOLUTIONS OF IMPURITY MODEL
	DO 1000 IRUN=1,NRUNSHL
C Count states which participate in this run
	NDEG=0 ! this is degeneracy within this run
	DO IDIM=1,NDIM                      !!! over solutions
	IF(KSTSHL(IDIM,IRUN).NE.0)NDEG=NDEG+1
	ENDDO
	IF(NDEG.EQ.0)GOTO 1000
C Memory allocations
	ALLOCATE(DENM(-NMOM:+NMOM))
	ALLOCATE(GRNM(-NMOM:+NMOM))
	ALLOCATE(UDEG(NDEG,NDEG))
C Set up Coulomb interaction matrix
	IDEG1=0
	DO IDIM1=1,NDIM
	IF(KSTSHL(IDIM1,IRUN).EQ.0)CYCLE
	IDEG1=IDEG1+1
	IDEG=0
	DO IDIM=1,NDIM
	IF(KSTSHL(IDIM,IRUN).EQ.0)CYCLE
	IDEG=IDEG+1
C Get diagonals: Udeg(ab)=Ucou(abab)=<ab|1/r|ab>
      UDEG(IDEG1,IDEG)=UIMP(IDIM1,IDIM,IDIM1,IDIM)-
     &                 UIMP(IDIM1,IDIM,IDIM,IDIM1)
      ENDDO
      ENDDO
C My linear grid: iWn=pT(2n+1),   n=0...N
C Yifeng's  grid: iWm=pT(2m-1-M), m=1...M
      NMSY=2*NMSL+2 ! # of points in Yifeng's grid
      ALLOCATE(WMSY(NMSY))
      ALLOCATE(YMSY(NMSY))
      DO IMSY=NMSY/2+1,NMSY
      WMSY(IMSY)=+WMSL(IMSY-NMSY/2-1)
      ENDDO
      DO IMSY=NMSY/2,1,-1
      WMSY(IMSY)=-WMSL(NMSY/2-IMSY)
      ENDDO
      ALLOCATE(WMSX(0:NMSB))
      ALLOCATE(YMSX(0:NMSB))
	ALLOCATE(USUM(NDEG))
      DO IDEG=1,NDEG
	USUM(IDEG)=0.D0
	DO IDEG1=1,NDEG
	USUM(IDEG)=USUM(IDEG)+UDEG(IDEG,IDEG1)
	ENDDO
	ENDDO
C Spline hybridization function to linear Matsubara grid
C Do not use (!) bath Green function directly (!);
C Spline routine fails for its inverse minus iWn !
	ALLOCATE(DELWQMC(NMSY,NDEG,NDEG))
	ALLOCATE(BATHQMC(NMSY,NDEG,NDEG))
	ALLOCATE(SIGWQMC(NMSY,NDEG,NDEG))
	ALLOCATE(GLOCQMC(NMSY,NDEG,NDEG))
	ALLOCATE(DENSQMC(NDEG,NDEG))
	ALLOCATE(SIGIQMC(NDEG))
	ALLOCATE(SIG1QMC(NDEG))
	IDEG1=0
	DO IDIM1=1,NDIM
	IF(KSTSHL(IDIM1,IRUN).EQ.0)CYCLE
	IDEG1=IDEG1+1
	IDEG=0
	DO IDIM=1,NDIM
	IF(KSTSHL(IDIM,IRUN).EQ.0)CYCLE
	IDEG=IDEG+1
      DO IMSB=0,NMSB
      WMSX(IMSB)=WMSB(IMSB)
      YMSX(IMSB)=DELW(IDIM1,IDIM,IMSB)
      ENDDO
	CALL LIB_CSPLINES(NMSB+1,WMSX,YMSX,NMSY/2,WMSY(NMSY/2+1),
     &                                          YMSY(NMSY/2+1))
	DO IMSY=NMSY/2+1,NMSY
	DELWQMC(IMSY,IDEG1,IDEG)=YMSY(IMSY)
	ENDDO
	DO IMSY=NMSY/2,1,-1
	DELWQMC(IMSY,IDEG,IDEG1)=DCONJG(YMSY(NMSY-IMSY+1))
	ENDDO
	ENDDO
	ENDDO
C Make Bath Green function and shift to particle hole symmetry point
	ALLOCATE(G0M1(NDEG,NDEG))
	ALLOCATE(WORK(NDEG))
C *************
C Diagonal case
      IF(MOD(MODR,10).EQ.1)THEN
      LDIAG=.TRUE.
	DO IMSY=1,NMSY
	ZMSY=DCMPLX(0.D0,WMSY(IMSY))
      DO IDEG1=1,NDEG
      DO IDEG=1,NDEG
	BATHQMC(IMSY,IDEG1,IDEG)=(0.D0,0.D0)
      ENDDO
      ENDDO
	IDEG=0
	DO IDIM=1,NDIM
	IF(KSTSHL(IDIM,IRUN).EQ.0)CYCLE
	IDEG=IDEG+1
	G0M1(IDEG,IDEG)=(ZMSY+CHEM-USUM(IDEG)/2.D0)-
     &ELEV(IDIM,IDIM)-DELWQMC(IMSY,IDEG,IDEG)
      ENDDO
      DO IDEG=1,NDEG
	BATHQMC(IMSY,IDEG,IDEG)=(1.D0,0.D0)/G0M1(IDEG,IDEG)
      ENDDO
      ENDDO
C *************
C Matrix case
      ELSEIF(MOD(MODR,10).EQ.2)THEN
      LDIAG=.FALSE.
	DO IMSY=1,NMSY
	ZMSY=DCMPLX(0.D0,WMSY(IMSY))
	IDEG1=0
	DO IDIM1=1,NDIM
	IF(KSTSHL(IDIM1,IRUN).EQ.0)CYCLE
	IDEG1=IDEG1+1
	IDEG=0
	DO IDIM=1,NDIM
	IF(KSTSHL(IDIM,IRUN).EQ.0)CYCLE
	IDEG=IDEG+1
	IF(IDEG1.EQ.IDEG)ONE=1.D0
	IF(IDEG1.NE.IDEG)ONE=0.D0
	G0M1(IDEG1,IDEG)=(ZMSY+CHEM-USUM(IDEG)/2.D0)*ONE-
     &ELEV(IDIM1,IDIM)-DELWQMC(IMSY,IDEG1,IDEG)
      ENDDO
      ENDDO
	CALL LIB_CINV(NDEG,G0M1,NDEG,WORK,IFAIL)
	IF(IFAIL.NE.0)THEN
      WRITE(IUN,*)'<QMC_QMCYIF>:: Error in inversion program'
      DO IDEG1=1,NDEG
      DO IDEG=1,NDEG
	G0M1(IDEG1,IDEG)=(0.D0,0.D0)
      ENDDO
      ENDDO
      ENDIF
      DO IDEG1=1,NDEG
      DO IDEG=1,NDEG
	BATHQMC(IMSY,IDEG1,IDEG)=G0M1(IDEG1,IDEG)
      ENDDO
      ENDDO
      ENDDO
      ENDIF
C CALL QUANTUM MONTE CARLO SUBROUTINE
      CALL QMC_RUN(NTAU,NDEG,NMSY,NWUP,NSWP,NSMP,KSTSHL(1,IRUN),UDEG,
     &     BETA,BATHQMC,SIGWQMC,GLOCQMC,DENSQMC,SIGIQMC,SIG1QMC,LDIAG)
C Spline back to the logarithmic Matsubara grid
	IDEG1=0
	DO IDIM1=1,NDIM
	IF(KSTSHL(IDIM1,IRUN).EQ.0)CYCLE
	IDEG1=IDEG1+1
	IDEG=0
	DO IDIM=1,NDIM
	IF(KSTSHL(IDIM,IRUN).EQ.0)CYCLE
	IDEG=IDEG+1
C Self energy
      DO IMSY=NMSY/2+1,NMSY
      YMSY(IMSY)=SIGWQMC(IMSY,IDEG1,IDEG)
      ENDDO
C Fit self-energy with moments form      
      IF(MOMT.GE.0.AND.IDEG1.EQ.IDEG)THEN
      IF(MOD(MOMT,2).NE.1)
     &CALL FULLSTOP('<QMC_QMCYIF>:: MomT must be ODD')
      ALLOCATE(SMOM(0:MOMT))
C Cutoff frequencies from where tail starts
      DO IMSY=1,NMSY
      IF(WMSY(IMSY).GT.OMGT)EXIT
      ENDDO
      KMSY=IMSY
      IF(KMSY.GT.NMSY)KMSY=NMSY
      SMOM(0)=+SIGIQMC(IDEG)
      SMOM(1)=-SIG1QMC(IDEG)
      IF(MOMT.GT.1)
     &CALL LIB_LSQMOM_FIXF(NMSY-KMSY+1,WMSY(KMSY),YMSY(KMSY),
     &                MOMT,SMOM,IFIT)
C Replace self-energy by its fit if no error
      IF(IFIT.EQ.0)THEN
      DO IMSY=KMSY,NMSY
      YMRE=0.D0
      DO IMOM=0,MOMT,2
      YMRE=YMRE+SMOM(IMOM)/WMSY(IMSY)**IMOM
      ENDDO
      YMIM=0.D0
      DO IMOM=1,MOMT,2
      YMIM=YMIM+SMOM(IMOM)/WMSY(IMSY)**IMOM
      ENDDO
      YMSY(IMSY)=DCMPLX(YMRE,YMIM)
      ENDDO
      ENDIF
      DEALLOCATE(SMOM)
      ENDIF
C Spline onto logarithmic grid      
	CALL LIB_CSPLINES(NMSY/2,WMSY(NMSY/2+1),YMSY(NMSY/2+1),
     &                  NMSB+1,WMSX,YMSX)
	DO IMSB=0,NMSB
	SIGW(IDIM1,IDIM,IMSB)=YMSX(IMSB)
	IF(IDIM1.EQ.IDIM)
     &SIGW(IDIM1,IDIM,IMSB)=
     &SIGW(IDIM1,IDIM,IMSB)+USUM(IDEG)/2.D0
	ENDDO
C Local Green function
      DO IMSY=NMSY/2+1,NMSY
      YMSY(IMSY)=GLOCQMC(IMSY,IDEG1,IDEG)
      ENDDO
	CALL LIB_CSPLINES(NMSY/2,WMSY(NMSY/2+1),YMSY(NMSY/2+1),
     &                  NMSB+1,WMSX,YMSX)
	DO IMSB=0,NMSB
	GLOC(IDIM1,IDIM,IMSB)=YMSX(IMSB)
	ENDDO
C Self-energy limits
      SIGI(IDIM1,IDIM)=SIGW(IDIM1,IDIM,NMSB)
      SIGI(IDIM1,IDIM)=0.5D0*(SIGW(IDIM1,IDIM,NMSB)
     &                +DCONJG(SIGW(IDIM,IDIM1,NMSB)))
      SIG0(IDIM1,IDIM)=SIGW(IDIM1,IDIM,0)
      BMAS(IDIM1,IDIM)=(0.D0,0.D0)
C Density matrix
      DO IMOM=-NMOM,NMOM
      DMAT(IDIM1,IDIM,IMOM)=(0.D0,0.D0)
      GMOM(IDIM1,IDIM,IMOM)=(0.D0,0.D0)
      ENDDO
      DMAT(IDIM1,IDIM,0)=DENSQMC(IDEG1,IDEG)
	ENDDO
	ENDDO
	DEALLOCATE(DENM,GRNM,YMSX,WMSX,YMSY,WMSY,SIGIQMC,SIG1QMC)
	DEALLOCATE(DELWQMC,BATHQMC,SIGWQMC,GLOCQMC,DENSQMC,USUM)
 1000 CONTINUE                            !!! over solutions
C *************
C Zeroise off diagonal elements for diagonal case
      IF(MOD(MODR,10).EQ.1)THEN
      DO IDIM1=1,NDIM
      DO IDIM =1,NDIM
      IF(IDIM1.EQ.IDIM)CYCLE
      SIGI(IDIM1,IDIM)=(0.D0,0.D0)
      SIG0(IDIM1,IDIM)=(0.D0,0.D0)
      BMAS(IDIM1,IDIM)=(0.D0,0.D0)
	DO IMSB=0,NMSB
	SIGW(IDIM1,IDIM,IMSB)=(0.D0,0.D0)
	GLOC(IDIM1,IDIM,IMSB)=(0.D0,0.D0)
      ENDDO
      DO IMOM=-NMOM,NMOM
      DMAT(IDIM1,IDIM,IMOM)=(0.D0,0.D0)
      GMOM(IDIM1,IDIM,IMOM)=(0.D0,0.D0)
      ENDDO
      ENDDO
      ENDDO      
      ENDIF
C Transform arrays back to spherical harmonics
      CALL LIB_TRANSCUB(NDIM,-KSYS,NDIM,-KSYS,ELEV(1,1))
      CALL LIB_TRANSCUB(NDIM,-KSYS,NDIM,-KSYS,SIGI(1,1))
      CALL LIB_TRANSCUB(NDIM,-KSYS,NDIM,-KSYS,SIG0(1,1))
      CALL LIB_TRANSCUB(NDIM,-KSYS,NDIM,-KSYS,BMAS(1,1))
      DO IMSB=0,NMSB
      CALL LIB_TRANSCUB(NDIM,-KSYS,NDIM,-KSYS,BATH(1,1,IMSB))
      CALL LIB_TRANSCUB(NDIM,-KSYS,NDIM,-KSYS,DELW(1,1,IMSB))
      CALL LIB_TRANSCUB(NDIM,-KSYS,NDIM,-KSYS,GLOC(1,1,IMSB))
      CALL LIB_TRANSCUB(NDIM,-KSYS,NDIM,-KSYS,SIGW(1,1,IMSB))
      ENDDO
      DO IMOM=-NMOM,+NMOM
      CALL LIB_TRANSCUB(NDIM,-KSYS,NDIM,-KSYS,DMAT(1,1,IMOM))
      CALL LIB_TRANSCUB(NDIM,-KSYS,NDIM,-KSYS,GMOM(1,1,IMOM))
      ENDDO
C MEMORY DEALLOCATIONS
      DEALLOCATE(UMAT,UIMP,UCOU)
      END