	SUBROUTINE RAT_AGFMAT
***************************************************************
*  Finds atomic Green function (disc storage is used)         *
***************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_RATPAR  ,ONLY: EPSDEG                                     !!! from readrat
      USE COM_LSHELL  ,ONLY: NORB,LORB,LOCCIMP,FSLA,ELEV,SPECIMP,
     &                       DAMP,XHUBIMP,ISTATE                        !!! from shells
      USE COM_IMPGRF  ,ONLY: CHEM,KVRB,GLOC,NRAT,
     &                       NMOM,GMOM,DMAT                             !!! from getagf
	USE COM_MSBMESH ,ONLY: TEMP,KGRD,NMSC,WMSC                        !!! from readrat
	USE COM_RATCHN  ,ONLY: IUAGF,IUSHL                                !!! from channels
      USE COM_RATOUT  ,ONLY: ICGRF,ICSHL,SHLFILE                        !!! from storage
      USE COM_LMTOUT  ,ONLY: SCRFILE                                    !!! from storage
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                            !!! from setup
      USE COM_MASHDEP ,ONLY: NVAL                                       !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER, ALLOCATABLE :: KREPN(:)
	INTEGER, ALLOCATABLE :: KREPM(:)
	INTEGER, ALLOCATABLE :: IMATP(:,:)
	REAL*8, ALLOCATABLE :: GTOT(:)
	REAL*8, ALLOCATABLE :: GMAX(:)
	REAL*8, ALLOCATABLE :: COMB(:,:)
	REAL*8, ALLOCATABLE :: EATSN(:)
	REAL*8, ALLOCATABLE :: EATSM(:)
	COMPLEX*16, ALLOCATABLE :: FMATD(:,:)
	COMPLEX*16, ALLOCATABLE :: WORKS(:,:)
	COMPLEX*16, ALLOCATABLE :: FMATP(:)
	CHARACTER*20, ALLOCATABLE :: TRAN(:)
	COMPLEX*16 DIM,DENOM,GFACT,XFACT
	CHARACTER HELP*40,TMS*10,TM1S1*10,TNC*10,SFILE*130
	LOGICAL EXIST,OPEN
	DATA PI/3.141592653589793D0/,DIM/(0.D0,1.D0)/
C ********************************************
      IF(ICGRF.EQ.0)RETURN
	L=LORB
	NDEG=2*(2*LORB+1)
C Zeroise atomic Green function and its pole expansion
	M1S1=0
	DO ISPIN1=1,2                   ! over ispin1
	DO M1=-L,L                      ! over m1
	M1S1=M1S1+1
	MS=0
	DO ISPIN=1,2                    ! over ispin
	DO M=-L,L                       ! over m
	MS=MS+1
C Density matrix and Total Momenta
	DO IMOM=-NMOM,+NMOM
	DMAT(M1S1,MS,IMOM)=(0.D0,0.D0)
	GMOM(M1S1,MS,IMOM)=(0.D0,0.D0)
	ENDDO
C Green function
	DO IMSC=0,NMSC               ! over imsc
	GLOC(M1S1,MS,IMSC)=(0.D0,0.D0)
	ENDDO                           ! over imsc
	ENDDO
	ENDDO                           ! over ispin
	ENDDO                           ! over m1
	ENDDO                           ! over ispin1
C Get combnatorics
	ALLOCATE(COMB(0:NDEG,0:NDEG))
	CALL LIB_GETCOMB(COMB,NDEG)
C PRINT DENSITY OF STATES WITHOUT MATRIX ELEMENTS
	ALLOCATE(GTOT(0:NMSC))
	ALLOCATE(GMAX(0:NMSC))
	ALLOCATE(TRAN(0:NMSC))
	DO IMSC=0,NMSC                  ! over imsc
	GTOT(IMSC)=0.D0
	GMAX(IMSC)=0.D0
	TRAN(IMSC)='                    '
	ENDDO                           ! over imsc
	DO 100 IOCC=0,NDEG              !!! over occupancies
	NOCCN=IOCC
	NOCCM=NOCCN-1
	IF(IOCC.EQ.0)GOTO 100
	IF(LOCCIMP(NOCCN).EQ.0)GOTO 100
	NFOCN=NINT(COMB(NOCCN,NDEG))    ! current dimension of Fock space
	IF(LOCCIMP(NOCCM).EQ.0)GOTO 100
	NFOCM=NINT(COMB(NOCCM,NDEG))    ! current dimension of Fock space
C Set shifts
	MDIMN=0
	DO JOCC=0,NOCCN
	IF(LOCCIMP(JOCC).EQ.0)CYCLE
	MDIMN=MDIMN+NINT(COMB(JOCC,NDEG))
	ENDDO
	MDIMM=0
	DO JOCC=0,NOCCM
	IF(LOCCIMP(JOCC).EQ.0)CYCLE
	MDIMM=MDIMM+NINT(COMB(JOCC,NDEG))
	ENDDO
C Set Xsum
	XSUM=0.D0
	DO IBNDN=1,NFOCN                ! over states
	XSUM=XSUM+XHUBIMP(IBNDN+MDIMN-NFOCN)
	ENDDO
	DO IBNDM=1,NFOCM                ! over states
	XSUM=XSUM+XHUBIMP(IBNDM+MDIMM-NFOCM)
	ENDDO
	IF(ABS(XSUM).LE.1.D-14)GOTO 100
C Find degeneracy of levels with occupancy N
	NREPN=1
	DO IBNDN=2,NFOCN
	IF(ABS(SPECIMP(IBNDN+MDIMN-NFOCN-1)-
     &       SPECIMP(IBNDN+MDIMN-NFOCN)).LE.EPSDEG)CYCLE
	NREPN=NREPN+1
	ENDDO
	ALLOCATE(KREPN(NREPN))
	IREP=1
	KREPN(1)=1
	DO IBNDN=2,NFOCN
	IF(ABS(SPECIMP(IBNDN+MDIMN-NFOCN-1)-
     &       SPECIMP(IBNDN+MDIMN-NFOCN)).LE.EPSDEG)
     &       KREPN(IREP)=KREPN(IREP)+1
	IF(ABS(SPECIMP(IBNDN+MDIMN-NFOCN-1)-
     &       SPECIMP(IBNDN+MDIMN-NFOCN)).LE.EPSDEG)CYCLE
	IREP=IREP+1
	KREPN(IREP)=1
	ENDDO
	ISUM=0
	DO IREP=1,NREPN
	ISUM=ISUM+KREPN(IREP)
	ENDDO
	IF(ISUM.NE.NFOCN)CALL FULLSTOP('ISUM.NE.NFOC')
C Find degeneracy of levels with occupancy N-1
	NREPM=1
	DO IBNDM=2,NFOCM
	IF(ABS(SPECIMP(IBNDM+MDIMM-NFOCM-1)-
     &       SPECIMP(IBNDM+MDIMM-NFOCM)).LE.EPSDEG)CYCLE
	NREPM=NREPM+1
	ENDDO
	ALLOCATE(KREPM(NREPM))
	IREP=1
	KREPM(1)=1
	DO IBNDM=2,NFOCM
	IF(ABS(SPECIMP(IBNDM+MDIMM-NFOCM-1)-
     &       SPECIMP(IBNDM+MDIMM-NFOCM)).LE.EPSDEG)
     &       KREPM(IREP)=KREPM(IREP)+1
	IF(ABS(SPECIMP(IBNDM+MDIMM-NFOCM-1)-
     &       SPECIMP(IBNDM+MDIMM-NFOCM)).LE.EPSDEG)CYCLE
	IREP=IREP+1
	KREPM(IREP)=1
	ENDDO
	ISUM=0
	DO IREP=1,NREPM
	ISUM=ISUM+KREPM(IREP)
	ENDDO
	IF(ISUM.NE.NFOCM)CALL FULLSTOP('ISUM.NE.NFOC')
C Add contribution to Dos
	IBNDN=0
	DO IREPN=1,NREPN
	IBNDN=IBNDN+KREPN(IREPN)
	XHUBN=XHUBIMP(IBNDN+MDIMN-NFOCN)
	IBNDM=0
	DO IREPM=1,NREPM
	IBNDM=IBNDM+KREPM(IREPM)
	XHUBM=XHUBIMP(IBNDM+MDIMM-NFOCM)
	DO IMSC=0,NMSC               ! over imsc
	DENOM=WMSC(IMSC)+CHEM+DIM*DAMP-
     &  (SPECIMP(IBNDN+MDIMN-NFOCN)-SPECIMP(IBNDM+MDIMM-NFOCM))
	DFACT=-DIMAG(1.D0/DENOM)/PI
	CONTR=(XHUBM+XHUBN)*DFACT*DBLE(KREPN(IREPN)*KREPM(IREPM))
	IF(CONTR.GT.GMAX(IMSC))THEN
	GMAX(IMSC)=CONTR
	IF(KVRB.EQ.1)
     &WRITE(TRAN(IMSC),FMT='(I2,1X,I5,4X,I2,1X,I5)')
     &                      NOCCN,IREPN,NOCCM,IREPM
	ENDIF
	GTOT(IMSC)=GTOT(IMSC)+CONTR
	ENDDO                           ! over imsc
	ENDDO                           ! over states
	ENDDO                           ! over states
	DEALLOCATE(KREPN,KREPM)
 100	CONTINUE                        !!! over occupancies
      IF(KVRB.EQ.1)THEN
	WRITE(IUN,10210)
	DO IMSC=0,NMSC
	IF(KGRD.EQ.1)WOMG=DREAL(WMSC(IMSC))
	IF(KGRD.EQ.2)WOMG=DIMAG(WMSC(IMSC))
      WRITE(IUN,10220)WOMG,GTOT(IMSC),GMAX(IMSC),TRAN(IMSC)
	ENDDO
	ENDIF
10210 FORMAT('!    Omega               TOT              MAX    ',
     &       '    N     i    N-1    j')
10220 FORMAT(1X,G14.7,3X,G14.7,3X,G14.7,3X,A20)
C FIND DENSITY OF STATES WITH MATRIX ELEMENTS
	DO IMSC=0,NMSC                  ! over imsc
	GTOT(IMSC)=0.D0
	GMAX(IMSC)=0.D0
	TRAN(IMSC)='                    '
	ENDDO                           ! over imsc
	CALL FIND_LBLANK(SCRFILE(IUAGF),130,NA)
	DO 3000 IOCC=0,NDEG             !!! over occupancies
	NOCCN=IOCC
	NOCCM=NOCCN-1
	IF(IOCC.EQ.0)GOTO 3000
	IF(LOCCIMP(NOCCN).EQ.0)GOTO 3000
	NFOCN=NINT(COMB(NOCCN,NDEG))    ! current dimension of Fock space
	IF(LOCCIMP(NOCCM).EQ.0)GOTO 3000
	NFOCM=NINT(COMB(NOCCM,NDEG))    ! current dimension of Fock space
C Set shifts
	MDIMN=0
	DO JOCC=0,NOCCN
	IF(LOCCIMP(JOCC).EQ.0)CYCLE
	MDIMN=MDIMN+NINT(COMB(JOCC,NDEG))
	ENDDO
	MDIMM=0
	DO JOCC=0,NOCCM
	IF(LOCCIMP(JOCC).EQ.0)CYCLE
	MDIMM=MDIMM+NINT(COMB(JOCC,NDEG))
	ENDDO
C Set Xsum
	XSUM=0.D0
	DO IBNDN=1,NFOCN                ! over states
	XSUM=XSUM+XHUBIMP(IBNDN+MDIMN-NFOCN)
	ENDDO
	DO IBNDM=1,NFOCM                ! over states
	XSUM=XSUM+XHUBIMP(IBNDM+MDIMM-NFOCM)
	ENDDO
	IF(ABS(XSUM).LE.1.D-14)GOTO 3000
	WRITE(IUN,10310)NOCCN,NOCCM
10310	FORMAT(1X,' Current transition  ',I5,'-->',I5)
C CALCULATE MATRIX ELEMENTS
      CALL RAT_SHLMAT(NOCCN,MATMAX,'D')
C RETRIVE SPECTRUM
	ALLOCATE(EATSN(NFOCN))
	ALLOCATE(EATSM(NFOCM))
	DO IBNDN=1,NFOCN
	EATSN(IBNDN)=SPECIMP(IBNDN+MDIMN-NFOCN)
	ENDDO
	DO IBNDM=1,NFOCM
	EATSM(IBNDM)=SPECIMP(IBNDM+MDIMM-NFOCM)
	ENDDO
C ******************************************
C COMPUTE CONTRIBUTION TO THE GREEN FUNCTION
	ALLOCATE(FMATD(NFOCM,NFOCN))
	ALLOCATE(WORKS(NFOCM,NFOCN))
	CALL FIND_LBLANK(SCRFILE(IUAGF),130,NA)
	M1S1=0
	DO ISPIN1=1,2                   ! over ispin1
	DO M1=-L,L                      ! over m1
	M1S1=M1S1+1
      CALL LIB_TINT(TNC,10,NOCCN,NC)
      CALL LIB_TINT(TM1S1,10,M1S1,NB)
      OPEN(UNIT=IUAGF,FILE=SCRFILE(IUAGF)(:NA)//'_'//TM1S1(:NB)//'_'//
     &TNC(:NC),STATUS='OLD',ACCESS='SEQUENTIAL',FORM='UNFORMATTED')
      READ(IUAGF)NMATP
      ALLOCATE(FMATP(NMATP))
      ALLOCATE(IMATP(2,NMATP))
	READ(IUAGF)(FMATP(IMAT),IMAT=1,NMATP),
     & ((IMATP(I,IMAT),I=1,2),IMAT=1,NMATP)
C Unpack
	DO IBNDM=1,NFOCM
	DO IBNDN=1,NFOCN
	WORKS(IBNDM,IBNDN)=(0.D0,0.D0)
	ENDDO
	ENDDO
	DO IMAT=1,NMATP
      IBNDM=IMATP(1,IMAT)
      IBNDN=IMATP(2,IMAT)
      WORKS(IBNDM,IBNDN)=FMATP(IMAT)
      ENDDO
	CLOSE(UNIT=IUAGF,STATUS='KEEP')
	DEALLOCATE(FMATP,IMATP)
	MS=0
	DO ISPIN=1,2                    ! over ispin
	DO M=-L,L                       ! over m
	MS=MS+1
      CALL LIB_TINT(TNC,10,NOCCN,NC)
      CALL LIB_TINT(TMS,10,MS,NB)
      OPEN(UNIT=IUAGF,FILE=SCRFILE(IUAGF)(:NA)//'_'//TMS(:NB)//'_'//
     &TNC(:NC),STATUS='OLD',ACCESS='SEQUENTIAL',FORM='UNFORMATTED')
      READ(IUAGF)NMATP
      ALLOCATE(FMATP(NMATP))
      ALLOCATE(IMATP(2,NMATP))
	READ(IUAGF)(FMATP(IMAT),IMAT=1,NMATP),
     & ((IMATP(I,IMAT),I=1,2),IMAT=1,NMATP)
C Unpack
	DO IBNDM=1,NFOCM
	DO IBNDN=1,NFOCN
	FMATD(IBNDM,IBNDN)=(0.D0,0.D0)
	ENDDO
	ENDDO
	DO IMAT=1,NMATP
      IBNDM=IMATP(1,IMAT)
      IBNDN=IMATP(2,IMAT)
      FMATD(IBNDM,IBNDN)=FMATP(IMAT)
      ENDDO
	CLOSE(UNIT=IUAGF,STATUS='KEEP')
	DEALLOCATE(FMATP,IMATP)
	DO IBNDN=1,NFOCN                ! over states
	XHUBN=XHUBIMP(IBNDN+MDIMN-NFOCN)
	DO IBNDM=1,NFOCM                ! over states
	XHUBM=XHUBIMP(IBNDM+MDIMM-NFOCM)
	GFACT=DCONJG(WORKS(IBNDM,IBNDN))*FMATD(IBNDM,IBNDN)*
     &     (XHUBM+XHUBN)
      XFACT=DCONJG(WORKS(IBNDM,IBNDN))*FMATD(IBNDM,IBNDN)*
     &     (XHUBN)
	IF(ABS(GFACT).LE.1.D-14)CYCLE
C Frequency loop
	DO IMSC=0,NMSC               ! over imsc
	DENOM=WMSC(IMSC)+CHEM+DIM*DAMP-
     &     (EATSN(IBNDN)-EATSM(IBNDM))
	RFACT=DREAL(1.D0/DENOM)
	DFACT=DIMAG(1.D0/DENOM)
	GLOC(M1S1,MS,IMSC)=GLOC(M1S1,MS,IMSC)+
     &                   DCMPLX(RFACT,DFACT)*GFACT
	ENDDO                           ! over imsc
C Pole loop
	DO IRAT=1,NRAT                  ! over IRAT
C	DENOM=WPOL(IRAT)+CHEM-(EATSN(IBNDN)-EATSM(IBNDM))
C	IF(ABS(DENOM).LE.SPOL(IRAT))RFACT=1.D0
C	IF(ABS(DENOM).GT.SPOL(IRAT))RFACT=0.D0
	ENDDO                           ! over IRAT
C Green function momenta
	EDIF=EATSN(IBNDN)-EATSM(IBNDM)-CHEM
	DO IMOM=-NMOM,+NMOM
	IF(ABS(EDIF).GT.1.D-14)EDIFM=EDIF**IMOM
	IF(ABS(EDIF).LE.1.D-14.AND.IMOM.NE.0)EDIFM=0.D0
	IF(                        IMOM.EQ.0)EDIFM=1.D0
	GMOM(M1S1,MS,IMOM)=GMOM(M1S1,MS,IMOM)+GFACT*EDIFM
      DMAT(M1S1,MS,IMOM)=DMAT(M1S1,MS,IMOM)+XFACT*EDIFM
      ENDDO
	ENDDO                           ! over states
	ENDDO                           ! over states
	ENDDO                           ! over m
	ENDDO                           ! over ispin
	ENDDO                           ! over m1
	ENDDO                           ! over ispin1
C Compute matrix element
	DO IBNDN=1,NFOCN                ! over states
	DO IBNDM=1,NFOCM                ! over states
	WORKS(IBNDM,IBNDN)=(0.D0,0.D0)
	ENDDO
	ENDDO
	CALL FIND_LBLANK(SCRFILE(IUAGF),130,NA)
	MS=0
	DO ISPIN=1,2                    ! over ispin
	DO M=-L,L                       ! over m
	MS=MS+1
      CALL LIB_TINT(TNC,10,NOCCN,NC)
      CALL LIB_TINT(TMS,10,MS,NB)
      OPEN(UNIT=IUAGF,FILE=SCRFILE(IUAGF)(:NA)//'_'//TMS(:NB)//'_'//
     &TNC(:NC),STATUS='OLD',ACCESS='SEQUENTIAL',FORM='UNFORMATTED')
      READ(IUAGF)NMATP
      ALLOCATE(FMATP(NMATP))
      ALLOCATE(IMATP(2,NMATP))
	READ(IUAGF)(FMATP(IMAT),IMAT=1,NMATP),
     & ((IMATP(I,IMAT),I=1,2),IMAT=1,NMATP)
C Unpack
	DO IBNDM=1,NFOCM
	DO IBNDN=1,NFOCN
	FMATD(IBNDM,IBNDN)=(0.D0,0.D0)
	ENDDO
	ENDDO
	DO IMAT=1,NMATP
      IBNDM=IMATP(1,IMAT)
      IBNDN=IMATP(2,IMAT)
      FMATD(IBNDM,IBNDN)=FMATP(IMAT)
      ENDDO
	CLOSE(UNIT=IUAGF,STATUS='KEEP')
	DEALLOCATE(FMATP,IMATP)
	DO IBNDN=1,NFOCN                ! over states
	DO IBNDM=1,NFOCM                ! over states
	WORKS(IBNDM,IBNDN)=WORKS(IBNDM,IBNDN)+
     &DCONJG(FMATD(IBNDM,IBNDN))*FMATD(IBNDM,IBNDN)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C Compute total density of states
	DO IBNDN=1,NFOCN                ! over states
	XHUBN=XHUBIMP(IBNDN+MDIMN-NFOCN)
	DO IBNDM=1,NFOCM                ! over states
	XHUBM=XHUBIMP(IBNDM+MDIMM-NFOCM)
	GFACT=WORKS(IBNDM,IBNDN)*(XHUBM+XHUBN)
	IF(ABS(GFACT).LE.1.D-14)CYCLE
	DO IMSC=0,NMSC               ! over imsc
	DENOM=WMSC(IMSC)+CHEM+DIM*DAMP-
     &     (EATSN(IBNDN)-EATSM(IBNDM))
	DFACT=-DIMAG(1.D0/DENOM)/PI
	CONTR=GFACT*DFACT
	IF(CONTR.GT.GMAX(IMSC))THEN
	GMAX(IMSC)=CONTR
	IF(KVRB.EQ.1)
     &WRITE(TRAN(IMSC),FMT='(I2,1X,I5,4X,I2,1X,I5)')
     &                      NOCCN,IBNDN,NOCCM,IBNDM
	ENDIF
	GTOT(IMSC)=GTOT(IMSC)+CONTR
	ENDDO                           ! over imsc
	ENDDO                           ! over states
	ENDDO                           ! over states
C Erase files
	CALL FIND_LBLANK(SCRFILE(IUAGF),130,NA)
	MS=0
	DO ISPIN=1,2                    ! over ispin
	DO M=-L,L                       ! over m
	MS=MS+1
      CALL LIB_TINT(TNC,10,NOCCN,NC)
      CALL LIB_TINT(TMS,10,MS,NB)
      OPEN(UNIT=IUAGF,FILE=SCRFILE(IUAGF)(:NA)//'_'//TMS(:NB)//'_'//
     &TNC(:NC),STATUS='OLD',ACCESS='SEQUENTIAL',FORM='UNFORMATTED')
	CLOSE(UNIT=IUAGF,STATUS='DELETE')
	ENDDO
	ENDDO
C Memory deallocations
	DEALLOCATE(EATSN,EATSM,FMATD,WORKS)
 3000	CONTINUE                         !!! over occupancies
      IF(KVRB.EQ.1)THEN
	WRITE(IUN,10410)
	DO IMSC=0,NMSC               ! over imsc
	IF(KGRD.EQ.1)WOMG=DREAL(WMSC(IMSC))
	IF(KGRD.EQ.2)WOMG=DIMAG(WMSC(IMSC))
      WRITE(IUN,10420)WOMG,GTOT(IMSC),
     &                GTOT(IMSC),GMAX(IMSC),TRAN(IMSC)
      ENDDO
      ENDIF
10410 FORMAT('!',4X,'Omega',9X,'DOS',10X,'TOT',10X,'MAX',
     &     5X,' N     i    N-1    j')
10420 FORMAT(1X,G12.5,1X,G12.5,1X,G12.5,1X,G12.5,1X,A20)
C Delete files
	DO IOCC=0,NDEG                 !!! over cluster occupancies
	IF(LOCCIMP(IOCC).EQ.0)CYCLE
      CALL LIB_TINT(TNC,10,IOCC,NC)
      IF(ICSHL.EQ.0)SFILE=SCRFILE(IUSHL)
      IF(ICSHL.GT.0)SFILE=SHLFILE
      CALL FIND_LBLANK(SFILE,130,NA)
      OPEN(UNIT=IUSHL,FILE=SFILE(:NA)//'_'//TNC(:NC),
     &STATUS='OLD',ACCESS='SEQUENTIAL',FORM='UNFORMATTED')
      IF(ICSHL.EQ.0)CLOSE(IUSHL,STATUS='DELETE')
      IF(ICSHL.GT.0)CLOSE(IUSHL,STATUS='KEEP')
      ENDDO
	DEALLOCATE(COMB,GTOT,GMAX,TRAN)
	END


