      SUBROUTINE RAT_ALLOCATE(TOPER)
************************************************************
*  Allocates/deallocates data for RAT routines             *
************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                    !!! from setup
      USE COM_RATPAR  ,ONLY: MODR,KORB                                  !!! from readrat
	USE COM_MSBMESH ,ONLY: TEMP,NMSC,WMSC,FMSC                        !!! from readrat
      USE COM_LSHELL  ,ONLY: LORB,LOCCIMP,ELEV,SPECIMP,XHUBIMP
     &                      ,TLSJIMP,ISTATE
      USE COM_RATCLS  ,ONLY: LOCCCLS,LOCCBAT                            !!! from readrat
     &                      ,NFOCTOT,NFOCCLS,NFOCBLK,NBLKCLS            !!! from readrat
     &                      ,NFOCIMP,NCUTIMP,NFOCBAT,NCUTBAT
     &                      ,NEXTCLS,SPECCLS,XHUBCLS,SEXTCLS,XEXTCLS
      USE COM_IMPGRF  ,ONLY: CHEM,FILL,KFRM,KVRB,
     &                       GLOC,NRAT,NPOL,KRAT,KINT,NMOM,
     &                       GMOM,DMAT,NPOL,SIGW,SIG0,BMAS,SIGI,
     &                       SRAT,VRAT,WRAT,PRAT,ORAT,DTRM,RTRM,
     &                       VRHB,WRHB,PRHB,ORHB,NPLD,DELW,BATH
      USE COM_RATHYB  ,ONLY: NHYB,EHYB,VHYB,NDST,TBST                   !!! from readrat
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER*1 TOPER
      DATA PI/3.141592653589793D0/
C RAT interface
      IF(TOPER.EQ.'A')THEN
C Memory Allocations for Green function arrays
	NDIM=2*(2*LORB+1)
	NSPC=2**NDIM
	IF(.NOT.ALLOCATED(SPECIMP))
     &ALLOCATE(SPECIMP(NSPC))
	IF(.NOT.ALLOCATED(XHUBIMP))
     &ALLOCATE(XHUBIMP(NSPC))
	IF(.NOT.ALLOCATED(TLSJIMP))
     &ALLOCATE(TLSJIMP(6,NSPC))
	IF(.NOT.ALLOCATED(ISTATE))
     &ALLOCATE(ISTATE(NDIM,0:NSPC-1))
	IF(MODR.GE.20)THEN
	IF(.NOT.ALLOCATED(GMOM))
     &ALLOCATE(GMOM(NDIM+NHYB,NDIM+NHYB,-NMOM:+NMOM))
	IF(.NOT.ALLOCATED(DMAT))
     &ALLOCATE(DMAT(NDIM+NHYB,NDIM+NHYB,-NMOM:+NMOM))
	IF(.NOT.ALLOCATED(GLOC))
     &ALLOCATE(GLOC(NDIM+NHYB,NDIM+NHYB,0:NMSC))
	IF(.NOT.ALLOCATED(SIGW))
     &ALLOCATE(SIGW(NDIM+NHYB,NDIM+NHYB,0:NMSC))
	IF(.NOT.ALLOCATED(DELW))
     &ALLOCATE(DELW(NDIM+NHYB,NDIM+NHYB,0:NMSC))
	IF(.NOT.ALLOCATED(BATH))
     &ALLOCATE(BATH(NDIM+NHYB,NDIM+NHYB,0:NMSC))
	IF(.NOT.ALLOCATED(BMAS))
     &ALLOCATE(BMAS(NDIM+NHYB,NDIM+NHYB))
	IF(.NOT.ALLOCATED(DTRM))
     &ALLOCATE(DTRM(NDIM,NDIM))
	IF(.NOT.ALLOCATED(RTRM))
     &ALLOCATE(RTRM(NDIM,NDIM))
	IF(.NOT.ALLOCATED(SIG0))
     &ALLOCATE(SIG0(NDIM+NHYB,NDIM+NHYB))
	IF(.NOT.ALLOCATED(SIGI))
     &ALLOCATE(SIGI(NDIM+NHYB,NDIM+NHYB))
	IF(.NOT.ALLOCATED(SRAT))
     &ALLOCATE(SRAT(NDIM,NDIM))
	IF(.NOT.ALLOCATED(VRAT))
     &ALLOCATE(VRAT(NDIM,NDIM,NRAT))
	IF(.NOT.ALLOCATED(WRAT))
     &ALLOCATE(WRAT(NDIM,NDIM,NRAT))
	IF(.NOT.ALLOCATED(PRAT))
     &ALLOCATE(PRAT(NDIM,NDIM,NRAT))
	IF(.NOT.ALLOCATED(ORAT))
     &ALLOCATE(ORAT(NDIM,NDIM,NRAT))
	IF(.NOT.ALLOCATED(VRHB))
     &ALLOCATE(VRHB(NDIM,NDIM,NPLD))
	IF(.NOT.ALLOCATED(WRHB))
     &ALLOCATE(WRHB(NDIM,NDIM,NPLD))
	IF(.NOT.ALLOCATED(PRHB))
     &ALLOCATE(PRHB(NDIM,NDIM,NPLD))
	IF(.NOT.ALLOCATED(ORHB))
     &ALLOCATE(ORHB(NDIM,NDIM,NPLD))
	IF(.NOT.ALLOCATED(NFOCCLS))
     &ALLOCATE(NFOCCLS(0:NDIM+NHYB))
	IF(.NOT.ALLOCATED(NEXTCLS))
     &ALLOCATE(NEXTCLS(0:NDIM+NHYB))
	IF(.NOT.ALLOCATED(NBLKCLS))
     &ALLOCATE(NBLKCLS(0:NDIM+NHYB))
	IF(.NOT.ALLOCATED(NFOCIMP))
     &ALLOCATE(NFOCIMP(-NDIM-NHYB-1:NDIM+NHYB+1))
	IF(.NOT.ALLOCATED(NCUTIMP))
     &ALLOCATE(NCUTIMP(-NDIM-NHYB-1:NDIM+NHYB+1))
	IF(.NOT.ALLOCATED(NFOCBAT))
     &ALLOCATE(NFOCBAT(-NDIM-NHYB-1:NDIM+NHYB+1))
	IF(.NOT.ALLOCATED(NCUTBAT))
     &ALLOCATE(NCUTBAT(-NDIM-NHYB-1:NDIM+NHYB+1))
	ENDIF
      ELSEIF(TOPER.EQ.'D')THEN
C Memory Deallocations for Green function arrays
      IF(ALLOCATED(GMOM))DEALLOCATE(GMOM)
      IF(ALLOCATED(DMAT))DEALLOCATE(DMAT)
      IF(ALLOCATED(GLOC))DEALLOCATE(GLOC)
      IF(ALLOCATED(SIGW))DEALLOCATE(SIGW)
      IF(ALLOCATED(DELW))DEALLOCATE(DELW)
      IF(ALLOCATED(BATH))DEALLOCATE(BATH)
      IF(ALLOCATED(BMAS))DEALLOCATE(BMAS)
      IF(ALLOCATED(DTRM))DEALLOCATE(DTRM)
      IF(ALLOCATED(RTRM))DEALLOCATE(RTRM)
      IF(ALLOCATED(SIG0))DEALLOCATE(SIG0)
      IF(ALLOCATED(SIGI))DEALLOCATE(SIGI)
      IF(ALLOCATED(SRAT))DEALLOCATE(SRAT)
      IF(ALLOCATED(VRAT))DEALLOCATE(VRAT)
      IF(ALLOCATED(WRAT))DEALLOCATE(WRAT)
      IF(ALLOCATED(PRAT))DEALLOCATE(PRAT)
      IF(ALLOCATED(ORAT))DEALLOCATE(ORAT)
C Memory deallocations for shell arrays
      IF(ALLOCATED(LOCCIMP))DEALLOCATE(LOCCIMP)
      IF(ALLOCATED(ELEV))DEALLOCATE(ELEV)
      IF(ALLOCATED(SPECIMP))DEALLOCATE(SPECIMP)
      IF(ALLOCATED(XHUBIMP))DEALLOCATE(XHUBIMP)
      IF(ALLOCATED(TLSJIMP))DEALLOCATE(TLSJIMP)
      IF(ALLOCATED(ISTATE))DEALLOCATE(ISTATE)
C Memory deallocations for cluster arrays
      IF(ALLOCATED(LOCCCLS))DEALLOCATE(LOCCCLS)
      IF(ALLOCATED(LOCCBAT))DEALLOCATE(LOCCBAT)
      IF(ALLOCATED(EHYB))DEALLOCATE(EHYB)
      IF(ALLOCATED(VHYB))DEALLOCATE(VHYB)
      IF(ALLOCATED(NDST))DEALLOCATE(NDST)
      IF(ALLOCATED(TBST))DEALLOCATE(TBST)
      IF(ALLOCATED(NFOCCLS))DEALLOCATE(NFOCCLS)
      IF(ALLOCATED(NEXTCLS))DEALLOCATE(NEXTCLS)
      IF(ALLOCATED(NBLKCLS))DEALLOCATE(NBLKCLS)
      IF(ALLOCATED(NFOCBLK))DEALLOCATE(NFOCBLK)
      IF(ALLOCATED(NFOCIMP))DEALLOCATE(NFOCIMP)
      IF(ALLOCATED(NCUTIMP))DEALLOCATE(NCUTIMP)
      IF(ALLOCATED(NFOCBAT))DEALLOCATE(NFOCBAT)
      IF(ALLOCATED(NCUTBAT))DEALLOCATE(NCUTBAT)
      IF(ALLOCATED(SPECCLS))DEALLOCATE(SPECCLS)
      IF(ALLOCATED(XHUBCLS))DEALLOCATE(XHUBCLS)
      IF(ALLOCATED(SEXTCLS))DEALLOCATE(SEXTCLS)
      IF(ALLOCATED(XEXTCLS))DEALLOCATE(XEXTCLS)
	IF(ALLOCATED(VRHB))DEALLOCATE(VRHB)
	IF(ALLOCATED(WRHB))DEALLOCATE(WRHB)
	IF(ALLOCATED(PRHB))DEALLOCATE(PRHB)
	IF(ALLOCATED(ORHB))DEALLOCATE(ORHB)
	ENDIF
      END