	SUBROUTINE RAT_CGFMAT
***************************************************************
*  Finds cluster Green function (disc storage is used)        *
***************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                    !!! from setup
      USE COM_RATPAR  ,ONLY: EPSHUB                                     !!! from readrat
      USE COM_RATCLS  ,ONLY: LOCCCLS,WCUTBAS,WEXTBAS,NEXTTOT,NEXTCLS    !!! from readrat
     &                      ,NFOCBLK,NFOCTOT,NFOCCLS,NBLKCLS            !!! from readrat
     &                      ,SPECCLS,XHUBCLS,SEXTCLS,XEXTCLS
      USE COM_LSHELL  ,ONLY: NORB,LORB,DAMP,LOCCIMP,ELEV
     &                      ,SPECIMP,XHUBIMP                            !!! from shells
      USE COM_RATHYB  ,ONLY: NHYB,EHYB,VHYB                             !!! from readrat
      USE COM_IMPGRF  ,ONLY: CHEM,KVRB,GLOC,
     &                       NRAT,NMOM,GMOM,DMAT                        !!! from getagf
	USE COM_MSBMESH ,ONLY: TEMP,KGRD,NMSC,WMSC                        !!! from readrat
      USE COM_RATCHN  ,ONLY: IUSHL,IUCL1,IUCL2,IUCL3,IUCL4,IUCL5        !!! from setup
      USE COM_LMTOUT  ,ONLY: SCRFILE                                    !!! from storage
      USE COM_RATOUT  ,ONLY: ICGRF,ICCLS,ICSHL,CLSFILE,SHLFILE          !!! from storage
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                            !!! from setup
      USE COM_MASHDEP ,ONLY: NVAL,LENCMP,LENREL,LENINT                  !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8, ALLOCATABLE :: GTOT(:)
	REAL*8, ALLOCATABLE :: GMAX(:)
      REAL*8, ALLOCATABLE :: ECLSN(:)
      REAL*8, ALLOCATABLE :: ECLSM(:)
      REAL*8, ALLOCATABLE :: EEXTN(:)
      REAL*8, ALLOCATABLE :: EEXTM(:)
      REAL*8, ALLOCATABLE :: XHUBN(:)
      REAL*8, ALLOCATABLE :: XHUBM(:)
      REAL*8, ALLOCATABLE :: XEXTN(:)
      REAL*8, ALLOCATABLE :: XEXTM(:)
	COMPLEX*16, ALLOCATABLE :: WORKS(:,:)
	COMPLEX*16, ALLOCATABLE :: WORKE(:,:)
	COMPLEX*16, ALLOCATABLE :: XMATS(:,:,:)
	COMPLEX*16, ALLOCATABLE :: XMATE(:,:,:)
	CHARACTER*20, ALLOCATABLE :: TRAN(:)
	COMPLEX*16 DIM,DENOM,GFACT,XFACT
	CHARACTER HELP*40,TNC*10,TNB*10,ST*8,FN*8,PROGN*8
     &   ,CFILE*130,SFILE*130
	LOGICAL EXIST,OPEN
	DATA ST/'started'/,FN/'finished'/
	DATA PI/3.141592653589793D0/,DIM/(0.D0,1.D0)/
C ********************************************
      IF(ICGRF.EQ.0)RETURN
	L=LORB
	NDEG=2*(2*LORB+1)
	ALLOCATE(GTOT(0:NMSC))
	ALLOCATE(GMAX(0:NMSC))
	ALLOCATE(TRAN(0:NMSC))
	DO IMSC=0,NMSC
	GTOT(IMSC)=0.D0
	GMAX(IMSC)=0.D0
	TRAN(IMSC)='                    '
	ENDDO
C Zeroise cluster Green function and its pole expansion
      DO M1S1=1,NDEG+NHYB
      DO MS  =1,NDEG+NHYB
C Density matrix and Total Momenta
	DO IMOM=-NMOM,+NMOM
	DMAT(M1S1,MS,IMOM)=(0.D0,0.D0)
	GMOM(M1S1,MS,IMOM)=(0.D0,0.D0)
	ENDDO
C Green function
	DO IMSC=0,NMSC                  ! over imsc
	GLOC(M1S1,MS,IMSC)=(0.D0,0.D0)
	ENDDO                           ! over imsc
	ENDDO                           ! over ms
	ENDDO                           ! over m1s1
C Start looping over electronic occupancies	
	DO 2200 ISIG=+1,-1,-2                    !!! over electron removal/addition
	DO 2100 IOCC=0,NDEG+NHYB                 !!! over cluster occupancies
	NOCCN=IOCC
	IF(LOCCCLS(NOCCN).EQ.0)GOTO 2100
	NFOCN=NFOCCLS(NOCCN)
	NEXTN=NEXTCLS(NOCCN)
      NBLKN=NBLKCLS(NOCCN)
	NOCCM=NOCCN-ISIG
      IF(NOCCM.LT.0.OR.NOCCM.GT.NDEG+NHYB)GOTO 2100
	IF(LOCCCLS(NOCCM).EQ.0)GOTO 2100
	NFOCM=NFOCCLS(NOCCM)
	NEXTM=NEXTCLS(NOCCM)
      NBLKM=NBLKCLS(NOCCM)
C Count shifts      
      NDIMN=0
      DO JOCC=0,NOCCN
      NDIMN=NDIMN+NFOCCLS(JOCC)
      ENDDO
	NDIMM=0
      DO JOCC=0,NOCCM
      NDIMM=NDIMM+NFOCCLS(JOCC)
      ENDDO
      NDEXN=0
      DO JOCC=0,NOCCN
      NDEXN=NDEXN+NEXTCLS(JOCC)
      ENDDO
	NDEXM=0
      DO JOCC=0,NOCCM
      NDEXM=NDEXM+NEXTCLS(JOCC)
      ENDDO
C ********************************************      
C Count non-zero probabilities for N electrons
      IENRXN=0
      IBNDTN=0
	DO IBLKN=0,NBLKCLS(NOCCN)         !!! over blocks
	DO IBNDN=1,NFOCBLK(IBLKN,NOCCN)
	IBNDTN=IBNDTN+1
	IF(ABS(XHUBCLS(IBNDTN+NDIMN-NFOCN)).GT.EPSHUB)IENRXN=IENRXN+1
	ENDDO
	ENDDO                             !!! over blocks
	NENRXN=IENRXN
C Count non-zero probabilities for N electrons in extened space
      IENREN=0
      IBNDTN=0
	DO IBNDN=1,NEXTCLS(NOCCN)
	IBNDTN=IBNDTN+1
	IF(ABS(XEXTCLS(IBNDTN+NDEXN-NEXTN)).GT.EPSHUB)IENREN=IENREN+1
	ENDDO
	NENREN=IENREN
C Energies and probabilities for N electrons
      IF(NENRXN.EQ.0)GOTO 1000
      IF(NENREN.GT.0)
     &WRITE(IUN,*)'WARNING: NON ZERO PROBABILITIES IN EXTENDED SPACE'
      ALLOCATE(XHUBN(NENRXN))
      ALLOCATE(ECLSN(NENRXN))
      IENRXN=0
      IBNDTN=0
	DO IBLKN=0,NBLKCLS(NOCCN)         !!! over blocks
	DO IBNDN=1,NFOCBLK(IBLKN,NOCCN)
	IBNDTN=IBNDTN+1
	IF(ABS(XHUBCLS(IBNDTN+NDIMN-NFOCN)).GT.EPSHUB)THEN
	IENRXN=IENRXN+1
	XHUBN(IENRXN)=XHUBCLS(IBNDTN+NDIMN-NFOCN)
	ECLSN(IENRXN)=SPECCLS(IBNDTN+NDIMN-NFOCN)
	ENDIF
	ENDDO
	ENDDO                             !!! over blocks
C Energies and probabilities for N electrons in extended space
      ALLOCATE(XEXTN(NENREN))
      ALLOCATE(EEXTN(NENREN))
      IENREN=0
      IBNDTN=0
	DO IBNDN=1,NEXTCLS(NOCCN)
	IBNDTN=IBNDTN+1
	IF(ABS(XEXTCLS(IBNDTN+NDEXN-NEXTN)).GT.EPSHUB)THEN
	IENREN=IENREN+1
	XEXTN(IENREN)=XEXTCLS(IBNDTN+NDEXN-NEXTN)
	EEXTN(IENREN)=SEXTCLS(IBNDTN+NDEXN-NEXTN)
	ENDIF
	ENDDO
C **********************************************************
C Energies and probabilities for N-I electrons
      ALLOCATE(XHUBM(NFOCM))
      ALLOCATE(ECLSM(NFOCM))
      IBNDTM=0
	DO IBLKM=0,NBLKCLS(NOCCM)         !!! over blocks
	DO IBNDM=1,NFOCBLK(IBLKM,NOCCM)
	IBNDTM=IBNDTM+1
	XHUBM(IBNDTM)=XHUBCLS(IBNDTM+NDIMM-NFOCM)
	ECLSM(IBNDTM)=SPECCLS(IBNDTM+NDIMM-NFOCM)
	ENDDO
	ENDDO                             !!! over blocks
C Energies and probabilities for N-I electrons in extended space
      ALLOCATE(XEXTM(NEXTM))
      ALLOCATE(EEXTM(NEXTM))
      IBNDTM=0
	DO IBNDM=1,NEXTCLS(NOCCM)
	IBNDTM=IBNDTM+1
	XEXTM(IBNDTM)=XEXTCLS(IBNDTM+NDEXM-NEXTM)
	EEXTM(IBNDTM)=SEXTCLS(IBNDTM+NDEXM-NEXTM)
	ENDDO
	IF(ISIG.EQ.+1)WRITE(IUN,10010)NOCCN,NOCCM
10010 FORMAT(/'GREEN FUN : ELECTRON REMOVAL   Ncls -> Ncls-1      =',
     &         I5,1X,I5/)
	IF(ISIG.EQ.-1)WRITE(IUN,10020)NOCCN,NOCCM
10020 FORMAT(/'GREEN FUN : ELECTRON ADDITION  Ncls -> Ncls+1      =',
     &         I5,1X,I5/)
	progn='ClsMat'
	call lib_timel(times)
	write(iun,10100)progn,st,times,curmem,totmem
10100 FORMAT('***** ',A8,1X,A8,'; CPU : ',G12.5,
     &       '; CUR/MAX mem.(Mb): ',G10.3,'/',G10.3)
C Compute matrix elements of heavy/light electron operators
      ALLOCATE(XMATS(NFOCM,NENRXN,2*(2*LORB+1)+NHYB))
      ALLOCATE(XMATE(NEXTM,NENRXN,2*(2*LORB+1)+NHYB))
      SIZE_XMAT=DBLE(SIZE(XMATS)*LENCMP)/1024.D0**2
     &         +DBLE(SIZE(XMATE)*LENCMP)/1024.D0**2
	WRITE(IUN,10030)SIZE_XMAT
10030 FORMAT(1X,'<Ncls-1|Cms|Ncls> memory allocated (Mb)=',G14.7)
      CALL RAT_CLSMAT(NOCCN,NOCCM,NFOCN,NFOCM,NEXTN,NEXTM,
     &     NBLKN,NBLKM,NDIMN,NDIMM,NDEXN,NDEXM,NENRXN,NENRXM,
     &     NENREN,NENREM,XMATS,XMATE,ISIG)
	progn='ClsMat'
	call lib_timel(timef)
	write(iun,10100)progn,fn,timef,curmem,totmem
C *****************************************************************************
C Calculate contribution to the Green function from the truncated Hilbert space
	DO M1S1=1,NDEG+NHYB             ! over m1s1
	DO MS  =1,NDEG+NHYB             ! over ms
	DO IENRXN=1,NENRXN              ! over states
	DO IBNDTM=1,NFOCM               ! over states
	IF(ISIG.EQ.+1)GFACT=XHUBN(IENRXN)*
     &DCONJG(XMATS(IBNDTM,IENRXN,M1S1))*XMATS(IBNDTM,IENRXN,MS)
	IF(ISIG.EQ.-1)GFACT=XHUBN(IENRXN)*
     &XMATS(IBNDTM,IENRXN,M1S1)*DCONJG(XMATS(IBNDTM,IENRXN,MS))
	IF(ISIG.EQ.+1)XFACT=GFACT
	IF(ISIG.EQ.-1)XFACT=(0.D0,0.D0)
	IF(ABS(GFACT).LE.1.D-14)CYCLE
C Frequency loop
	DO IMSC=0,NMSC               ! over imsc
	DENOM=WMSC(IMSC)+CHEM+DIM*DAMP-DBLE(ISIG)*
     &(ECLSN(IENRXN)-ECLSM(IBNDTM))
	RFACT=DREAL(1.D0/DENOM)
	DFACT=DIMAG(1.D0/DENOM)
	GLOC(M1S1,MS,IMSC)=GLOC(M1S1,MS,IMSC)+
     &                   DCMPLX(RFACT,DFACT)*GFACT
	ENDDO                           ! over imsc
C Green function momenta
	EDIF=DBLE(ISIG)*(ECLSN(IENRXN)-ECLSM(IBNDTM))-CHEM
	DO IMOM=-NMOM,+NMOM
	IF(ABS(EDIF).GT.1.D-14)EDIFM=EDIF**IMOM
	IF(ABS(EDIF).LE.1.D-14.AND.IMOM.NE.0)EDIFM=0.D0
	IF(                        IMOM.EQ.0)EDIFM=1.D0
	GMOM(M1S1,MS,IMOM)=GMOM(M1S1,MS,IMOM)+GFACT*EDIFM
      DMAT(M1S1,MS,IMOM)=DMAT(M1S1,MS,IMOM)+XFACT*EDIFM
      ENDDO
	ENDDO                           ! over states
	ENDDO                           ! over states
	ENDDO                           ! over ms
	ENDDO                           ! over m1s1
C *****************************************************************************
C Calculate contribution to the Green function from the extended Hilbert space
	DO M1S1=1,NDEG+NHYB             ! over m1s1
	DO MS  =1,NDEG+NHYB             ! over ms
	DO IENRXN=1,NENRXN              ! over states
	DO IBNDTM=1,NEXTM               ! over states
	IF(ISIG.EQ.+1)GFACT=XHUBN(IENRXN)*
     &DCONJG(XMATE(IBNDTM,IENRXN,M1S1))*XMATE(IBNDTM,IENRXN,MS)
	IF(ISIG.EQ.-1)GFACT=XHUBN(IENRXN)*
     &XMATE(IBNDTM,IENRXN,M1S1)*DCONJG(XMATE(IBNDTM,IENRXN,MS))
	IF(ISIG.EQ.+1)XFACT=GFACT
	IF(ISIG.EQ.-1)XFACT=(0.D0,0.D0)
	IF(ABS(GFACT).LE.1.D-14)CYCLE
C Frequency loop
	DO IMSC=0,NMSC               ! over imsc
	DENOM=WMSC(IMSC)+CHEM+DIM*DAMP-DBLE(ISIG)*
     &(ECLSN(IENRXN)-EEXTM(IBNDTM))
	RFACT=DREAL(1.D0/DENOM)
	DFACT=DIMAG(1.D0/DENOM)
	GLOC(M1S1,MS,IMSC)=GLOC(M1S1,MS,IMSC)+
     &                   DCMPLX(RFACT,DFACT)*GFACT
	ENDDO                           ! over imsc
C Green function momenta
	EDIF=DBLE(ISIG)*(ECLSN(IENRXN)-EEXTM(IBNDTM))-CHEM
	DO IMOM=-NMOM,+NMOM
	IF(ABS(EDIF).GT.1.D-14)EDIFM=EDIF**IMOM
	IF(ABS(EDIF).LE.1.D-14.AND.IMOM.NE.0)EDIFM=0.D0
	IF(                        IMOM.EQ.0)EDIFM=1.D0
	GMOM(M1S1,MS,IMOM)=GMOM(M1S1,MS,IMOM)+GFACT*EDIFM
      DMAT(M1S1,MS,IMOM)=DMAT(M1S1,MS,IMOM)+XFACT*EDIFM
      ENDDO
	ENDDO                           ! over states
	ENDDO                           ! over states
	ENDDO                           ! over ms
	ENDDO                           ! over m1s1
C ************************************************************
C Compute total density of states from truncated Hilbert space
	ALLOCATE(WORKS(NFOCM,NENRXN))
	DO IENRXN=1,NENRXN
	DO IBNDTM=1,NFOCM
	WORKS(IBNDTM,IENRXN)=(0.D0,0.D0)
	DO MS=1,NDEG+NHYB
	WORKS(IBNDTM,IENRXN)=WORKS(IBNDTM,IENRXN)+
     &DCONJG(XMATS(IBNDTM,IENRXN,MS))*XMATS(IBNDTM,IENRXN,MS)
	ENDDO
	ENDDO
	ENDDO
      IENRXN=0
      IBNDTN=0
	DO IBLKN=0,NBLKCLS(NOCCN)         !!! over blocks
	DO IBNDN=1,NFOCBLK(IBLKN,NOCCN)   !!! over states within a block
	IBNDTN=IBNDTN+1
	IF(ABS(XHUBCLS(IBNDTN+NDIMN-NFOCN)).LE.EPSHUB)CYCLE
	IENRXN=IENRXN+1
	DO IBNDTM=1,NFOCM                 !!! over states
	GFACT=WORKS(IBNDTM,IENRXN)*XHUBN(IENRXN)
	IF(ABS(GFACT).LE.1.D-14)CYCLE
	DO IMSC=0,NMSC                   ! over imsc
	DENOM=WMSC(IMSC)+CHEM+DIM*DAMP-DBLE(ISIG)*
     &     (ECLSN(IENRXN)-ECLSM(IBNDTM))
	DFACT=-DIMAG(1.D0/DENOM)/PI
	CONTR=GFACT*DFACT
	IF(CONTR.GT.GMAX(IMSC))THEN
	GMAX(IMSC)=CONTR
	IF(KVRB.EQ.1)
     &WRITE(TRAN(IMSC),FMT='(I2,1X,I5,4X,I2,1X,I5)')
     &                      NOCCN,IBNDTN,NOCCM,IBNDTM
	ENDIF
	GTOT(IMSC)=GTOT(IMSC)+CONTR
	ENDDO                           !!! over imsc
	ENDDO                           !!! over states
	ENDDO                           !!! over blocks
	ENDDO                           !!! over all states
C ************************************************************
C Compute total density of states from extended Hilbert space
	ALLOCATE(WORKE(NEXTM,NENRXN))
	DO IENRXN=1,NENRXN
	DO IBNDTM=1,NEXTM
	WORKE(IBNDTM,IENRXN)=(0.D0,0.D0)
	DO MS=1,NDEG+NHYB
	WORKE(IBNDTM,IENRXN)=WORKE(IBNDTM,IENRXN)+
     &DCONJG(XMATE(IBNDTM,IENRXN,MS))*XMATE(IBNDTM,IENRXN,MS)
	ENDDO
	ENDDO
	ENDDO
      IENRXN=0
      IBNDTN=0
	DO IBLKN=0,NBLKCLS(NOCCN)         !!! over blocks
	DO IBNDN=1,NFOCBLK(IBLKN,NOCCN)   !!! over states within a block
	IBNDTN=IBNDTN+1
	IF(ABS(XHUBCLS(IBNDTN+NDIMN-NFOCN)).LE.EPSHUB)CYCLE
	IENRXN=IENRXN+1
	DO IBNDTM=1,NEXTM                 !!! over states
	GFACT=WORKE(IBNDTM,IENRXN)*XHUBN(IENRXN)
	IF(ABS(GFACT).LE.1.D-14)CYCLE
	DO IMSC=0,NMSC                   ! over imsc
	DENOM=WMSC(IMSC)+CHEM+DIM*DAMP-DBLE(ISIG)*
     &     (ECLSN(IENRXN)-EEXTM(IBNDTM))
	DFACT=-DIMAG(1.D0/DENOM)/PI
	CONTR=GFACT*DFACT
	IF(CONTR.GT.GMAX(IMSC))THEN
	GMAX(IMSC)=CONTR
	IF(KVRB.EQ.1)
     &WRITE(TRAN(IMSC),FMT='(I2,1X,I5,4X,I2,1X,I5)')
     &                      NOCCN,IBNDTN,NOCCM,-1
	ENDIF
	GTOT(IMSC)=GTOT(IMSC)+CONTR
	ENDDO                           !!! over imsc
	ENDDO                           !!! over states
	ENDDO                           !!! over blocks
	ENDDO                           !!! over all states
C Memory deallocations
	DEALLOCATE(ECLSN,ECLSM,XHUBN,XHUBM,XMATS,WORKS)
	DEALLOCATE(EEXTN,EEXTM,XEXTN,XEXTM,XMATE,WORKE)
 1000 CONTINUE
 2100 CONTINUE                                 !!! over electron removal/addition
 2200 CONTINUE                                 !!! over cluster occupancies
      IF(KVRB.EQ.1)THEN
	WRITE(IUN,10410)
	DO IMSC=0,NMSC               ! over imsc
	IF(KGRD.EQ.1)WOMG=DREAL(WMSC(IMSC))
	IF(KGRD.EQ.2)WOMG=DIMAG(WMSC(IMSC))
      WRITE(IUN,10420)WOMG,GTOT(IMSC),
     &                GTOT(IMSC),GMAX(IMSC),TRAN(IMSC)
      ENDDO
      ENDIF
10410 FORMAT('!',4X,'Omega',9X,'DOS',10X,'TOT',10X,'MAX',
     &     5X,' N     i    N-1    j')
10420 FORMAT(1X,G12.5,1X,G12.5,1X,G12.5,1X,G12.5,1X,A20)
C Delete files
	DO IOCC=0,NDEG+NHYB                 !!! over cluster occupancies
	IF(LOCCCLS(IOCC).EQ.0)CYCLE
	DO IBLK=0,NBLKCLS(IOCC)
      CALL LIB_TINT(TNC,10,IOCC,NC)
      CALL LIB_TINT(TNB,10,IBLK,NB)
      IF(ICCLS.EQ.0)CFILE=SCRFILE(IUCL2)
      IF(ICCLS.GT.0)CFILE=CLSFILE
      CALL FIND_LBLANK(CFILE,130,NA)
      OPEN(UNIT=IUCL2,FILE=CFILE(:NA)//'_'//TNC(:NC)//'_'//
     &TNB(:NB),STATUS='OLD',ACCESS='SEQUENTIAL',FORM='UNFORMATTED')
      IF(ICCLS.EQ.0)CLOSE(IUCL2,STATUS='DELETE')
      IF(ICCLS.GT.0)CLOSE(IUCL2,STATUS='KEEP')
      ENDDO
      ENDDO
C Delete files
	DO IOCC=0,NDEG                 !!! over impurity occupancies
	IF(LOCCIMP(IOCC).EQ.0)CYCLE
      CALL LIB_TINT(TNC,10,IOCC,NC)
      IF(ICSHL.EQ.0)SFILE=SCRFILE(IUSHL)
      IF(ICSHL.GT.0)SFILE=SHLFILE
      CALL FIND_LBLANK(SFILE,130,NA)
      OPEN(UNIT=IUSHL,FILE=SFILE(:NA)//'_'//TNC(:NC),
     &STATUS='OLD',ACCESS='SEQUENTIAL',FORM='UNFORMATTED')
      IF(ICSHL.EQ.0)CLOSE(IUSHL,STATUS='DELETE')
      IF(ICSHL.GT.0)CLOSE(IUSHL,STATUS='KEEP')
      ENDDO
C Memory deallocations
      DEALLOCATE(GTOT,GMAX,TRAN)
	END
