	SUBROUTINE RAT_CLSGOR
**************************************************************
*  Cluster exact diagonalization (Aleksei Gordienko version)
**************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                    !!! from setup
      USE COM_RATPAR  ,ONLY: MODR,KORB                                  !!! from readrat
      USE COM_RATCLS  ,ONLY: LOCCCLS,WCUTBAS,WEXTBAS,NMOMHAM,NLANCOS
      USE COM_LSHELL  ,ONLY: NORB,LORB,LOCCIMP,ELEV,FSLA,DAMP
     &                      ,NFILSHL,NFLUSHL,HMAG,HORB,ALSC             !!! from shells
      USE COM_RATHYB  ,ONLY: NHYB,EHYB,VHYB,BMAG                        !!! from readrat
      USE COM_IMPGRF  ,ONLY: CHEM,FILL,KFRM,
     &                       GLOC,NRAT,NPOL,KRAT,KINT,
     &                       NMOM,GMOM,DMAT,NPOL,PMAT,SIGW,SIG0,BMAS,
     &                       SIGI,SRAT,VRAT,WRAT,PRAT,ORAT,DTRM,RTRM
	USE COM_MSBMESH ,ONLY: TEMP,KGRD,NMSC,WMSC                        !!! from readrat
      USE COM_RATCHN  ,ONLY: IUCL1,IUCL2,IUCL3,IUCL4,IUCL5              !!! from setup
      USE COM_RATOUT  ,ONLY: ICSHL,ICCLS,ICGRF
      USE COM_LMTOUT  ,ONLY: SCRFILE,OUTFILE                            !!! from storage
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                            !!! from setup
      USE COM_MASHDEP ,ONLY: NVAL                                       !!! from setup
      USE MOD_CLS_L   ,ONLY: CLS_L_MAIN  
      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER ICLSFILE(5)
C Cluster allocatable arrays
      REAL*8, ALLOCATABLE :: GDOS(:)
      REAL*8, ALLOCATABLE :: UMAT(:,:,:,:)
      COMPLEX*16, ALLOCATABLE :: WMSD(:)
      COMPLEX*16, ALLOCATABLE :: HLEV(:,:)
      COMPLEX*16, ALLOCATABLE :: GRFRCLS(:,:,:)
      COMPLEX*16, ALLOCATABLE :: GRFICLS(:,:,:)
      COMPLEX*16, ALLOCATABLE :: SIGWCLS(:,:,:)
      COMPLEX*16, ALLOCATABLE :: SIGICLS(:,:)
      COMPLEX*16, ALLOCATABLE :: GMOMCLS(:,:,:)
      COMPLEX*16, ALLOCATABLE :: DMATCLS(:,:,:)
	CHARACTER FCLSFILE(5)*130,ST*8,FN*8,PROGN*8
      DATA ST/'started'/,FN/'finished'/
C *****************************************
	L=LORB
	NDEG=2*(2*LORB+1)
      ICLSFILE(1)=IUCL1
      ICLSFILE(2)=IUCL2
      ICLSFILE(3)=IUCL3
      ICLSFILE(4)=IUCL4
      ICLSFILE(5)=IUN
      FCLSFILE(1)=SCRFILE(IUCL1)
      FCLSFILE(2)=SCRFILE(IUCL2)
      FCLSFILE(3)=SCRFILE(IUCL3)
      FCLSFILE(4)=SCRFILE(IUCL4)
      FCLSFILE(5)=OUTFILE
      ALLOCATE(GDOS(0:NMSC))
C Set mode for Quan's program
      IVER=MOD(MODR,10)
! First digit controls:
! 1 -- Only calculates Eigenvalues & Eigenvectors.
! 2 -- Returns the above quantities plus angular moments.
! 3 -- Returns Eigenvalues, Green's function, self-energy, density matrix, DOS.
! 4 -- Returns Eigenvalues, Green's function, self-energy, density matrix, DOS, plus angular moments.
! Second digit controls:
! 1 -- Fix mean filling, search for chemical potential.
! 2 -- Fix chemical potential, search for mean filling.
      MODECLS=-1
      IF(KFRM.EQ.0.AND.ICGRF.EQ.0.AND.KORB.EQ.0)MODECLS=11
      IF(KFRM.EQ.1.AND.ICGRF.EQ.0.AND.KORB.EQ.0)MODECLS=12
      IF(KFRM.EQ.0.AND.ICGRF.GT.0.AND.KORB.EQ.0)MODECLS=31
      IF(KFRM.EQ.1.AND.ICGRF.GT.0.AND.KORB.EQ.0)MODECLS=32
C
      IF(KFRM.EQ.0.AND.ICGRF.EQ.0.AND.KORB.EQ.1)MODECLS=21
      IF(KFRM.EQ.1.AND.ICGRF.EQ.0.AND.KORB.EQ.1)MODECLS=22
      IF(KFRM.EQ.0.AND.ICGRF.GT.0.AND.KORB.EQ.1)MODECLS=41
      IF(KFRM.EQ.1.AND.ICGRF.GT.0.AND.KORB.EQ.1)MODECLS=42
      IF(MODECLS.EQ.-1)
     &CALL FULLSTOP('RAT_CLSGOR>:: MODE NOT RECOGNIZED')
C Generate Interaction Matrix
      ALLOCATE(UMAT(-LORB:LORB,-LORB:LORB,-LORB:LORB,-LORB:LORB))
      CALL LIB_HUBMAT_L4(LORB,FSLA,UMAT,UAVR,GAVR)
C Set hybridzation levels
      ALLOCATE(HLEV(NHYB,NHYB))
      DO IHYB=1,NHYB
      DO JHYB=1,NHYB
      IF(IHYB.EQ.JHYB)ONE=1.D0
      IF(IHYB.NE.JHYB)ONE=0.D0
      HLEV(IHYB,JHYB)=EHYB(IHYB)*ONE
      ENDDO
      ENDDO
C Set complex grid
      ALLOCATE(WMSD(0:NMSC))
	DO IMSC=0,NMSC
	IF(KGRD.EQ.1)WMSD(IMSC)=WMSC(IMSC)+DCMPLX(0.D0,DAMP)
	IF(KGRD.EQ.2)WMSD(IMSC)=WMSC(IMSC)
	ENDDO
C Allocate spectral functions
	ALLOCATE(GRFRCLS(NHYB+NDEG,NHYB+NDEG,0:NMSC))
	ALLOCATE(GRFICLS(NHYB+NDEG,NHYB+NDEG,0:NMSC))
	ALLOCATE(SIGWCLS(NHYB+NDEG,NHYB+NDEG,0:NMSC))
	ALLOCATE(SIGICLS(NHYB+NDEG,NHYB+NDEG))
      ALLOCATE(GMOMCLS(NHYB+NDEG,NHYB+NDEG,-NMOM:+NMOM))
      ALLOCATE(DMATCLS(NHYB+NDEG,NHYB+NDEG,-NMOM:+NMOM))
C Call Cluster impurity solver
	progn='ClsMain'
	call lib_timel(times)
	write(iun,10100)progn,st,times,curmem,totmem
	CHEM1=-1.d0
	CHEM2=+1.d0
      CALL CLS_L_MAIN(NDEG,NHYB,NMOMHAM,NLANCOS,ELEV,HLEV,UMAT,VHYB,
     &  HMAG,HORB,BMAG,ALSC,NMSC+1,WMSD,MODECLS,FILL,NFILSHL,NFLUSHL,
     &  CHEM,CHEM1,CHEM2,TEMP,LOCCCLS,ICLSFILE,FCLSFILE,
     &  GRFRCLS,GRFICLS,SIGWCLS,SIGICLS,NMOM,GMOMCLS,DMATCLS,GDOS)
      call lib_timel(timef)
	write(iun,10100)progn,fn,timef,curmem,totmem
	IF(ICGRF.GT.0)THEN
C Reset spectral functions for impurity
	DO IDEG1=1,NDEG+NHYB
	IF(IDEG1.LE.NDEG)NSH1=+NHYB
	IF(IDEG1.GT.NDEG)NSH1=-NDEG
	DO IDEG =1,NDEG+NHYB
	IF(IDEG.LE.NDEG)NSH=+NHYB
	IF(IDEG.GT.NDEG)NSH=-NDEG
	DO IMSC=0,NMSC
	GLOC(IDEG1,IDEG,IMSC)=GRFRCLS(NSH1+IDEG1,NSH+IDEG,IMSC)
     &         +(0.D0,1.D0)*GRFICLS(NSH1+IDEG1,NSH+IDEG,IMSC)
	SIGW(IDEG1,IDEG,IMSC)=SIGWCLS(NSH1+IDEG1,NSH+IDEG,IMSC)
      ENDDO
	SIGI(IDEG1,IDEG)=SIGICLS(NSH1+IDEG1,NSH+IDEG)
	SIG0(IDEG1,IDEG)=(0.D0,0.D0)
	BMAS(IDEG1,IDEG)=(0.D0,0.D0)
      DO IMOM=-NMOM,+NMOM
      GMOM(IDEG1,IDEG,IMOM)=GMOMCLS(NSH1+IDEG1,NSH+IDEG,IMOM)
      DMAT(IDEG1,IDEG,IMOM)=DMATCLS(NSH1+IDEG1,NSH+IDEG,IMOM)
      ENDDO      	
      ENDDO      	
      ENDDO
      ENDIF
C MEMORY DEALLOCATIONS
	DEALLOCATE(GRFRCLS,GRFICLS,SIGWCLS,SIGICLS,GMOMCLS,DMATCLS)
      DEALLOCATE(GDOS,UMAT,HLEV,WMSD)
10100 FORMAT('***** ',A8,1X,A8,'; CPU : ',G12.5,
     &       '; CUR/MAX mem.(Mb): ',G10.3,'/',G10.3)
      END