	SUBROUTINE RAT_CLSMAT(NOCCCLSN,NOCCCLSM,NFOCCLSN,NFOCCLSM,
     &    NEXTCLSN,NEXTCLSM,NBLKCLSN,NBLKCLSM,NDIMCLSN,NDIMCLSM,
     &    NDEXCLSN,NDEXCLSM,NENRXN,NENRXM,NENREN,NENREM,
     &    XMATS,XMATE,ISIG)
***************************************************************
*  Finds matrix element for the cluster Green function        *
***************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                    !!! from setup
      USE COM_RATPAR  ,ONLY: EPSHUB,EPSMAT                              !!! from readrat
      USE COM_RATCLS  ,ONLY: LOCCCLS,LOCCBAT,WCUTBAS,WEXTBAS,SPECCLS
     &                      ,NFOCBLK,NFOCTOT,NFOCCLS,NBLKCLS,XHUBCLS    !!! from readrat
     &                      ,NFOCIMP,NCUTIMP,NFOCBAT,NCUTBAT
      USE COM_LSHELL  ,ONLY: NORB,LORB,LOCCIMP,ELEV,SPECIMP,XHUBIMP     !!! from shells
      USE COM_IMPGRF  ,ONLY: CHEM,KVRB                                  !!! from readrat
      USE COM_RATHYB  ,ONLY: NHYB,EHYB,VHYB                             !!! from readrat
	USE COM_MSBMESH ,ONLY: TEMP,NMSC,WMSC                             !!! from readrat
      USE COM_RATCHN  ,ONLY: IUAGF,IUCL1,IUCL2,IUCL3,IUCL4,IUCL5        !!! from setup
      USE COM_LMTOUT  ,ONLY: SCRFILE                                    !!! from storage
      USE COM_RATOUT  ,ONLY: ICCLS,CLSFILE                              !!! from storage
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                            !!! from setup
      USE COM_MASHDEP ,ONLY: NVAL,LENCMP,LENREL,LENINT                  !!! from setup
      IMPLICIT REAL*8 (A-H,O-Z)
C SET PASSED VARIABLES
	COMPLEX*16 XMATS(NFOCCLSM,NENRXN,2*(2*LORB+1)+NHYB)
     &          ,XMATE(NEXTCLSM,NENRXN,2*(2*LORB+1)+NHYB)
C SET LOCAL VARIABLES
      INTEGER, ALLOCATABLE :: IVECBN(:,:)
      INTEGER, ALLOCATABLE :: IPNTBN(:,:)
      INTEGER, ALLOCATABLE :: IVECBM(:,:)
      INTEGER, ALLOCATABLE :: IPNTBM(:,:)
      INTEGER, ALLOCATABLE :: IBLOCKN(:)
      INTEGER, ALLOCATABLE :: IBLOCKM(:)
      INTEGER, ALLOCATABLE :: IPOINTN(:,:)
      INTEGER, ALLOCATABLE :: IPOINTM(:,:)
      INTEGER, ALLOCATABLE :: IPTEXTN(:,:)
      INTEGER, ALLOCATABLE :: IPTEXTM(:,:)
      INTEGER, ALLOCATABLE :: IDIMBN(:)
      INTEGER, ALLOCATABLE :: IDIMBM(:)
      INTEGER, ALLOCATABLE :: NFOCDN(:)
      INTEGER, ALLOCATABLE :: NFOCDM(:)
      INTEGER, ALLOCATABLE :: NEXTDN(:)
      INTEGER, ALLOCATABLE :: NEXTDM(:)
      INTEGER, ALLOCATABLE :: IFBATN(:,:)
      INTEGER, ALLOCATABLE :: IFBATM(:,:)
      INTEGER, ALLOCATABLE :: ISBATN(:,:)
      INTEGER, ALLOCATABLE :: NMATIMPP(:,:)
	INTEGER, ALLOCATABLE :: IMATIMPP(:,:)
	INTEGER, ALLOCATABLE :: IMATIMPL(:,:)
	INTEGER, ALLOCATABLE :: IMATBATH(:,:)
      REAL*8, ALLOCATABLE :: COMB(:,:)
      REAL*8, ALLOCATABLE :: EVALBN(:)
      REAL*8, ALLOCATABLE :: EVALBM(:)
	REAL*8, ALLOCATABLE :: SPECIMPN(:)
	REAL*8, ALLOCATABLE :: SPECIMPM(:)
	REAL*8, ALLOCATABLE :: SPECBATN(:)
	REAL*8, ALLOCATABLE :: SPECBATM(:)
      COMPLEX*16, ALLOCATABLE :: AVECBN(:)
      COMPLEX*16, ALLOCATABLE :: AVECBM(:)
      COMPLEX*16, ALLOCATABLE :: VMATBN(:,:)
      COMPLEX*16, ALLOCATABLE :: VMATBM(:,:)
      COMPLEX*16, ALLOCATABLE :: VECXN(:)
      COMPLEX*16, ALLOCATABLE :: VCLSN(:)
	COMPLEX*16, ALLOCATABLE :: FMATD(:,:)
	COMPLEX*16, ALLOCATABLE :: FMATIMPP(:)
	COMPLEX*16, ALLOCATABLE :: FMATIMPL(:)
	COMPLEX*16 DIM
	CHARACTER HELP*40,TMS*10,TNC*10,TNB*10,CFILE*130
	LOGICAL EXIST,OPEN,RAT_CLSMAT_CIMP,RAT_CLSMAT_CBAT
	DATA PI/3.141592653589793D0/,DIM/(0.D0,1.D0)/
C ********************************************
	L=LORB
	NDEG=2*(2*LORB+1)
C Get combinatorics
	ALLOCATE(COMB(0:NDEG+NHYB,0:NDEG+NHYB))
	CALL LIB_GETCOMB(COMB,NDEG+NHYB)
C **************************************************************
C EXTRACT EIGENVECTORS FOR N ELECTRONS      
C Count non-zero probabilities for N electrons
      IVECXN=0
      IENRXN=0
      IBNDTN=0
	DO IBLKN=0,NBLKCLS(NOCCCLSN)          !!! over blocks
	IBNDXN=0
	DO IBNDN=1,NFOCBLK(IBLKN,NOCCCLSN)
	IBNDTN=IBNDTN+1
	IF(ABS(XHUBCLS(IBNDTN+NDIMCLSN-NFOCCLSN)).GT.EPSHUB)
     &IBNDXN=IBNDXN+1
	ENDDO
	IVECXN=IVECXN+IBNDXN*NFOCBLK(IBLKN,NOCCCLSN)
	IENRXN=IENRXN+IBNDXN
	ENDDO                             !!! over blocks
	NVECXN=IVECXN
	NENRXN=IENRXN
	ALLOCATE(VECXN(NVECXN))
C Read vectors for N electrons
      IVECXN=0
      IENRXN=0
      IBNDTN=0
	DO IBLKN=0,NBLKCLS(NOCCCLSN)          !!! over blocks for N electrons
	IBNDXN=0
	DO IBNDN=1,NFOCBLK(IBLKN,NOCCCLSN)
	IBNDTN=IBNDTN+1
	IF(ABS(XHUBCLS(IBNDTN+NDIMCLSN-NFOCCLSN)).GT.EPSHUB)
     &IBNDXN=IBNDXN+1
	ENDDO
      IF(IBNDXN.EQ.0)CYCLE
	IENRXN=IENRXN+IBNDXN
C Read Eigenvectors
      CALL LIB_TINT(TNC,10,NOCCCLSN,NC)
      CALL LIB_TINT(TNB,10,IBLKN,NB)
      IF(ICCLS.EQ.0)CFILE=SCRFILE(IUCL2)
      IF(ICCLS.GT.0)CFILE=CLSFILE
      CALL FIND_LBLANK(CFILE,130,NA)
      OPEN(UNIT=IUCL2,FILE=CFILE(:NA)//'_'//TNC(:NC)//'_'//
     &TNB(:NB),STATUS='OLD',ACCESS='SEQUENTIAL',FORM='UNFORMATTED')
      READ(IUCL2)NFOCBN,NVECBN
      ALLOCATE(EVALBN(NFOCBN))
      ALLOCATE(IPNTBN(2,NFOCBN))
      ALLOCATE(IVECBN(2,NVECBN))
      ALLOCATE(AVECBN(NVECBN))
      READ(IUCL2)(EVALBN(IDIMN),IDIMN=1,NFOCBN),
     &((IPNTBN(I,IDIMN),I=1,2),IDIMN=1,NFOCBN),
     &((IVECBN(I,IVECN),I=1,2),IVECN=1,NVECBN),
     &          (AVECBN(IVECN),IVECN=1,NVECBN)
      CLOSE(IUCL2,STATUS='KEEP')
C Unpack Eigenvectors
      IF(IBLKN.NE.0)THEN
      ALLOCATE(VMATBN(NFOCBN,NFOCBN))
      DO IBNDN=1,NFOCBN
      DO IFOCN=1,NFOCBN
      VMATBN(IFOCN,IBNDN)=(0.D0,0.D0)
      ENDDO
      ENDDO
      DO IVECN=1,NVECBN
      IFOCN=IVECBN(1,IVECN)
      IBNDN=IVECBN(2,IVECN)
      VMATBN(IFOCN,IBNDN)=AVECBN(IVECN)
      ENDDO
C Pack vectors that we need
      IBNDTN=IBNDTN-NFOCBLK(IBLKN,NOCCCLSN)
	DO IBNDN=1,NFOCBLK(IBLKN,NOCCCLSN)
	IBNDTN=IBNDTN+1
	IF(ABS(XHUBCLS(IBNDTN+NDIMCLSN-NFOCCLSN)).LE.EPSHUB)CYCLE
      DO IFOCN=1,NFOCBLK(IBLKN,NOCCCLSN)
      IVECXN=IVECXN+1
      VECXN(IVECXN)=VMATBN(IFOCN,IBNDN)
      ENDDO
	ENDDO
	ELSEIF(IBLKN.EQ.0)THEN
      IBNDTN=IBNDTN-NFOCBLK(IBLKN,NOCCCLSN)
	DO IBNDN=1,NFOCBLK(IBLKN,NOCCCLSN)
	IBNDTN=IBNDTN+1
	IF(ABS(XHUBCLS(IBNDTN+NDIMCLSN-NFOCCLSN)).LE.EPSHUB)CYCLE
      DO IFOCN=1,NFOCBLK(IBLKN,NOCCCLSN)
      IVECXN=IVECXN+1
      IF(IBNDN.EQ.IFOCN)VECXN(IVECXN)=(1.D0,0.D0)
      IF(IBNDN.NE.IFOCN)VECXN(IVECXN)=(0.D0,0.D0)
      ENDDO
	ENDDO
	ENDIF
      DEALLOCATE(EVALBN,IVECBN,IPNTBN,AVECBN)
      IF(IBLKN.NE.0)DEALLOCATE(VMATBN)
      ENDDO	                                   !!! over blocks for N electrons
C Read Block Array for N electrons
      ALLOCATE(IBLOCKN(NFOCCLSN))
      ALLOCATE(IPOINTN(2,NFOCCLSN))
      ALLOCATE(IPTEXTN(2,NEXTCLSN))
      ALLOCATE(NFOCDN(0:NDEG))
      ALLOCATE(NEXTDN(0:NDEG))
      CALL LIB_TINT(TNC,10,NOCCCLSN,NC)
      CALL LIB_TINT(TNB,10,0,NB)
      IF(ICCLS.EQ.0)CFILE=SCRFILE(IUCL2)
      IF(ICCLS.GT.0)CFILE=CLSFILE
      CALL FIND_LBLANK(CFILE,130,NA)
      OPEN(UNIT=IUCL2,FILE=CFILE(:NA)//'_'//TNC(:NC)//'_'//
     &TNB(:NB),STATUS='OLD',ACCESS='SEQUENTIAL',FORM='UNFORMATTED')
      READ(IUCL2)NFOCB,NVECB,(IBLOCKN(IFOCT),IFOCT=1,NFOCCLSN),
     &((IPOINTN(I,IFOCT),I=1,2),IFOCT=1,NFOCCLSN),
     &(NFOCDN(IOCC),IOCC=0,NDEG)
      READ(IUCL2)
      READ(IUCL2)NEXTCLST,((IPTEXTN(I,IFOCT),I=1,2),IFOCT=1,NEXTCLSN),
     &(NEXTDN(IOCC),IOCC=0,NDEG)
      IF(NEXTCLST.NE.NEXTCLSN)
     &CALL FULLSTOP('<RAT_CLSMAT>::NEXTCLST.NE.NEXTCLSN')
      CLOSE(IUCL2,STATUS='KEEP')
C Read Block Array for N-I electrons
      ALLOCATE(IBLOCKM(NFOCCLSM))
      ALLOCATE(IPOINTM(2,NFOCCLSM))
      ALLOCATE(IPTEXTM(2,NEXTCLSM))
      ALLOCATE(NFOCDM(0:NDEG))
      ALLOCATE(NEXTDM(0:NDEG))
      CALL LIB_TINT(TNC,10,NOCCCLSM,NC)
      CALL LIB_TINT(TNB,10,0,NB)
      IF(ICCLS.EQ.0)CFILE=SCRFILE(IUCL2)
      IF(ICCLS.GT.0)CFILE=CLSFILE
      CALL FIND_LBLANK(CFILE,130,NA)
      OPEN(UNIT=IUCL2,FILE=CFILE(:NA)//'_'//TNC(:NC)//'_'//
     &TNB(:NB),STATUS='OLD',ACCESS='SEQUENTIAL',FORM='UNFORMATTED')
      READ(IUCL2)NFOCB,NVECB,(IBLOCKM(IFOCT),IFOCT=1,NFOCCLSM),
     &((IPOINTM(I,IFOCT),I=1,2),IFOCT=1,NFOCCLSM),
     &(NFOCDM(IOCC),IOCC=0,NDEG)
      READ(IUCL2)
      READ(IUCL2)NEXTCLST,((IPTEXTM(I,IFOCT),I=1,2),IFOCT=1,NEXTCLSM),
     &(NEXTDM(IOCC),IOCC=0,NDEG)
      IF(NEXTCLST.NE.NEXTCLSM)
     &CALL FULLSTOP('<RAT_CLSMAT>::NEXTCLST.NE.NEXTCLSM')
      CLOSE(IUCL2,STATUS='KEEP')
C ************************************************************
C PREPARE MATRIX ELEMENTS BETWEEN HEAVY/LIGHT ELECTRON OPERATORS
C Zeroise
      DO IDEG=1,NDEG+NHYB
	DO IENRXN=1,NENRXN
	DO IBNDTM=1,NFOCCLSM
	XMATS(IBNDTM,IENRXN,IDEG)=(0.D0,0.D0)
	ENDDO
	ENDDO
	DO IENRXN=1,NENRXN
	DO IBNDTM=1,NEXTCLSM
	XMATE(IBNDTM,IENRXN,IDEG)=(0.D0,0.D0)
	ENDDO
	ENDDO
	ENDDO
C Compute matrix elements for the impurity
      NMATIMP=0
      WRITE(IUN,10010)
10010 FORMAT(1X,'Computing matrix elements for impurity -->')
	DO IOCCIMP=0,NDEG             !!! over impurity occupancies
	NOCCIMPN=IOCCIMP
	NOCCIMPM=NOCCIMPN-ISIG
	IF(RAT_CLSMAT_CIMP(NOCCCLSN,NOCCCLSM,IOCCIMP,ISIG))CYCLE
	WRITE(IUN,10020)NOCCIMPN,NOCCIMPM
10020	FORMAT(1X,'Imp. occ N -> N-I = ',I5,1X,I5)
C Matrix Elements for the impurity
      IF(ISIG.EQ.+1)
     &CALL RAT_SHLMAT(IOCCIMP,NMATC,'D')
      IF(ISIG.EQ.-1)
     &CALL RAT_SHLMAT(IOCCIMP,NMATC,'C')
	NMATIMP=NMATIMP+NMATC
      ENDDO                                 !!! over impurity occupancies
C Evaluate size for matrix elements for the bath
      NMATBAT=0
	DO IOCCIMP=0,NDEG                     !!! over impurity occupancies
	NOCCBATN=NOCCCLSN-IOCCIMP
	NOCCBATM=NOCCCLSM-IOCCIMP
	IF(RAT_CLSMAT_CBAT(NOCCCLSN,NOCCCLSM,IOCCIMP,ISIG))CYCLE
C     NMATBAT=NMATBAT+NCUTBAT(NOCCBATN)
      NMATBAT=NMATBAT+NFOCBAT(NOCCBATN)
      ENDDO
C Prepare matrix elements for the impurity
	ALLOCATE(NMATIMPP(0:NDEG,NDEG))
	ALLOCATE(FMATIMPL(NMATIMP))
	ALLOCATE(IMATIMPL(2,NMATIMP))
	SIZE_FMAT=DBLE(SIZE(FMATIMPL)*LENCMP)/1024.D0**2
     &         +DBLE(SIZE(IMATIMPL)*LENINT)/1024.D0**2
      WRITE(IUN,10030)SIZE_FMAT
10030 FORMAT(1X,'<Nimp-I|Fms|Nimp> memory allocated (Mb)=',G14.7)
	NMATC=0
	DO 1200 IOCCIMP=0,NDEG             !!! over impurity occupancies
	NOCCIMPN=IOCCIMP
	NOCCIMPM=NOCCIMPN-ISIG
	IF(RAT_CLSMAT_CIMP(NOCCCLSN,NOCCCLSM,IOCCIMP,ISIG))CYCLE
C Read and store impurity matrix elements
	DO 1100 IDEG=1,NDEG                               !!! over impurity states
      NMATIMPP(IOCCIMP,IDEG)=0
	CALL FIND_LBLANK(SCRFILE(IUAGF),130,NA)
      CALL LIB_TINT(TNC,10,IOCCIMP,NC)
      CALL LIB_TINT(TMS,10,IDEG,NB)
      OPEN(UNIT=IUAGF,FILE=SCRFILE(IUAGF)(:NA)//'_'//TMS(:NB)//'_'//
     &TNC(:NC),STATUS='OLD',ACCESS='SEQUENTIAL',FORM='UNFORMATTED')
      READ(IUAGF)NMATIMPP(IOCCIMP,IDEG)
      ALLOCATE(FMATIMPP(NMATIMPP(IOCCIMP,IDEG)))
      ALLOCATE(IMATIMPP(2,NMATIMPP(IOCCIMP,IDEG)))
	READ(IUAGF)(FMATIMPP(IMAT),IMAT=1,NMATIMPP(IOCCIMP,IDEG)),
     & ((IMATIMPP(I,IMAT),I=1,2),IMAT=1,NMATIMPP(IOCCIMP,IDEG))
	CLOSE(UNIT=IUAGF,STATUS='DELETE')
C Pack matrix elements into long array
	DO IMAT=1,NMATIMPP(IOCCIMP,IDEG)
	FMATIMPL(IMAT+NMATC)=FMATIMPP(IMAT)
	IMATIMPL(1,IMAT+NMATC)=IMATIMPP(1,IMAT)
	IMATIMPL(2,IMAT+NMATC)=IMATIMPP(2,IMAT)
	ENDDO
	NMATC=NMATC+NMATIMPP(IOCCIMP,IDEG)
	DEALLOCATE(FMATIMPP,IMATIMPP)
 1100 CONTINUE 	                                !!! over impurity states
 1200 CONTINUE 	                                !!! over impurity occupancies
	ALLOCATE(IMATBATH(NHYB,NMATBAT))
	SIZE_BMAT=DBLE(SIZE(IMATBATH)*LENINT)/1024.D0**2
      WRITE(IUN,10040)SIZE_BMAT
10040 FORMAT(1X,'<Nbat-I|Cms|Nbat> memory allocated (Mb)=',G14.7)
C Prepare matrix elements for the bath
      NMATB=0
	DO 1300 IOCCIMP=0,NDEG                     !!! over impurity occupancies
	NOCCBATN=NOCCCLSN-IOCCIMP
	NOCCBATM=NOCCCLSM-IOCCIMP
      NFOCBATN=NFOCBAT(NOCCBATN) ! total dimension of "Nf"   impurity space
      NFOCBATM=NFOCBAT(NOCCBATM) ! total dimension of "Nf"   impurity space
      NCUTBATN=NCUTBAT(NOCCBATN)
      NCUTBATM=NCUTBAT(NOCCBATM)
	IF(RAT_CLSMAT_CBAT(NOCCCLSN,NOCCCLSM,IOCCIMP,ISIG))CYCLE
	ALLOCATE(SPECBATN(NFOCBATN))
	ALLOCATE(SPECBATM(NFOCBATM))
	ALLOCATE(IFBATN(0:NHYB,NFOCBATN))
	ALLOCATE(IFBATM(0:NHYB,NFOCBATM))
	SIZE_MEM=SIZE_MEM+DBLE(SIZE(IFBATN)*LENINT)/1024.D0**2
     &                 +DBLE(SIZE(IFBATM)*LENINT)/1024.D0**2
	CALL RAT_CLSDIAG_BATH(SPECBATN,IFBATN,NOCCBATN,NFOCBATN,NFOCBATN)
	CALL RAT_CLSDIAG_BATH(SPECBATM,IFBATM,NOCCBATM,NFOCBATM,NFOCBATM)
C Apply destruction operator to the bath state with N electrons
C     ALLOCATE(ISBATN(NHYB,NCUTBATN))
      ALLOCATE(ISBATN(NHYB,NFOCBATN))
	SIZE_MEM=SIZE_MEM+DBLE(SIZE(ISBATN)*LENINT)/1024.D0**2
	IF(ISIG.EQ.+1)
     &CALL RAT_CLSDIAG_BMAT(IFBATN,IFBATM,ISBATN,NHYB,
     &     NFOCBATN,NFOCBATM,NFOCBATN,NFOCBATM,'D')
	IF(ISIG.EQ.-1)
     &CALL RAT_CLSDIAG_BMAT(IFBATN,IFBATM,ISBATN,NHYB,
     &     NFOCBATN,NFOCBATM,NFOCBATN,NFOCBATM,'C')
C Store Bath Matrix Elements into long array
      DO IHYB=1,NHYB     
      DO IFOCBN=1,NFOCBATN
      IMATBATH(IHYB,IFOCBN+NMATB)=ISBATN(IHYB,IFOCBN)
      ENDDO
      ENDDO
C     NMATB=NMATB+NCUTBATN
      NMATB=NMATB+NFOCBATN
      DEALLOCATE(SPECBATN,SPECBATM,IFBATN,IFBATM,ISBATN)
 1300 CONTINUE
C **************************************************************
C EVALUATE MATRIX ELEMENTS <bN-I|c^i|aN> ELECTRONS FOR ALL CONTRIBUTING |aN>
C --- Do over blocks for N-1 electrons
      NBNDTM=0
	DO 4000 IBLKM=0,NBLKCLS(NOCCCLSM)          !!! over blocks for N-1 electrons
C Read Eigenvectors for N-I electrons and given block IBLKM
      CALL LIB_TINT(TNC,10,NOCCCLSM,NC)
      CALL LIB_TINT(TNB,10,IBLKM,NB)
      IF(ICCLS.EQ.0)CFILE=SCRFILE(IUCL2)
      IF(ICCLS.GT.0)CFILE=CLSFILE
      CALL FIND_LBLANK(CFILE,130,NA)
      OPEN(UNIT=IUCL2,FILE=CFILE(:NA)//'_'//TNC(:NC)//'_'//
     &TNB(:NB),STATUS='OLD',ACCESS='SEQUENTIAL',FORM='UNFORMATTED')
      READ(IUCL2)NFOCBM,NVECBM
      ALLOCATE(EVALBM(NFOCBM))
      ALLOCATE(IPNTBM(2,NFOCBM))
      ALLOCATE(IVECBM(2,NVECBM))
      ALLOCATE(AVECBM(NVECBM))
      READ(IUCL2)(EVALBM(IDIMM),IDIMM=1,NFOCBM),
     &((IPNTBM(I,IDIMM),I=1,2),IDIMM=1,NFOCBM),
     &((IVECBM(I,IVECM),I=1,2),IVECM=1,NVECBM),
     &          (AVECBM(IVECM),IVECM=1,NVECBM)
      CLOSE(IUCL2,STATUS='KEEP')
      NBNDTM=NBNDTM+NFOCBM
C Unpack Eigenvectors to VMATBM matrix for all non diagonal blocks
      IF(IBLKM.NE.0)THEN
      ALLOCATE(VMATBM(NFOCBM,NFOCBM))
      DO IBNDM=1,NFOCBM
      DO IFOCM=1,NFOCBM
      VMATBM(IFOCM,IBNDM)=(0.D0,0.D0)
      ENDDO
      ENDDO
      DO IVECM=1,NVECBM
      IFOCM=IVECBM(1,IVECM)
      IBNDM=IVECBM(2,IVECM)
      VMATBM(IFOCM,IBNDM)=AVECBM(IVECM)
      ENDDO
      ENDIF
      DEALLOCATE(EVALBM,IPNTBM,IVECBM,AVECBM)
C---- Do over blocks for N electrons
      IVECXN=0
      IBNDTN=0
      LENRXN=0
	DO 3000 IBLKN=0,NBLKCLS(NOCCCLSN)          !!! over blocks for N electrons
	NFOCBN=NFOCBLK(IBLKN,NOCCCLSN)
C Check if this block has contribution
	IBNDXN=0
	DO IBNDN=1,NFOCBLK(IBLKN,NOCCCLSN)
	IBNDTN=IBNDTN+1
	IF(ABS(XHUBCLS(IBNDTN+NDIMCLSN-NFOCCLSN)).GT.EPSHUB)
     &IBNDXN=IBNDXN+1
	ENDDO
      IF(IBNDXN.EQ.0)GOTO 3000 ! skip block
      NBNDXN=IBNDXN
      LENRXN=LENRXN+NBNDXN
C Unpack only those vectors that we need into VMATBN matrix
	ALLOCATE(VMATBN(NFOCBN,NBNDXN))
      DO IBNDXN=1,NBNDXN
      DO IFOCN=1,NFOCBN
      IVECXN=IVECXN+1
      VMATBN(IFOCN,IBNDXN)=VECXN(IVECXN)
      ENDDO
	ENDDO
C Set pointer arrays
      ALLOCATE(IDIMBM(NFOCCLSM))
      ALLOCATE(IDIMBN(NFOCCLSN))
      IDIM=0
      DO IFOCT=1,NFOCCLSM
      IDIMBM(IFOCT)=0
      IF(IBLOCKM(IFOCT).NE.IBLKM)CYCLE
      IDIM=IDIM+1
      IDIMBM(IFOCT)=IDIM
      ENDDO
      IDIM=0
      DO IFOCT=1,NFOCCLSN
      IDIMBN(IFOCT)=0
      IF(IBLOCKN(IFOCT).NE.IBLKN)CYCLE
      IDIM=IDIM+1
      IDIMBN(IFOCT)=IDIM
      ENDDO
C **************************************************
C COMPUTE MATRIX ELEMENTS FOR IMPURITY
C **************************************************
C Loop over impurity occupancies
	NMATC=0
	DO 2200 IOCCIMP=0,NDEG                 !!! over impurity occupancies
	NOCCIMPN=IOCCIMP
	NFOCIMPN=NFOCIMP(NOCCIMPN)
	NOCCIMPM=NOCCIMPN-ISIG
	NFOCIMPM=NFOCIMP(NOCCIMPM)
	IF(RAT_CLSMAT_CIMP(NOCCCLSN,NOCCCLSM,IOCCIMP,ISIG))GOTO 2200
	DO 2100 IDEG=1,NDEG                    !!! over impurity states
	ALLOCATE(FMATD(NFOCIMPM,NFOCIMPN))
C Unpack impurity matrix element
	DO IFOCM=1,NFOCIMPM
	DO IFOCN=1,NFOCIMPN
	FMATD(IFOCM,IFOCN)=(0.D0,0.D0)
	ENDDO
	ENDDO
	DO IMAT=1,NMATIMPP(IOCCIMP,IDEG)
	IFOCM=IMATIMPL(1,IMAT+NMATC)
	IFOCN=IMATIMPL(2,IMAT+NMATC)
	FMATD(IFOCM,IFOCN)=FMATIMPL(IMAT+NMATC)
	ENDDO
	NMATC=NMATC+NMATIMPP(IOCCIMP,IDEG)
C COMPUTE MATRIX ELEMENTS FOR TRUNCATED HILBERT SPACE
C Set pointer shifts
      NDIMTN=0
      DO JOCC=0,NOCCIMPN-1
      NDIMTN=NDIMTN+NFOCDN(JOCC)
      ENDDO
      NDIMTM=0
      DO JOCC=0,NOCCIMPM-1
      NDIMTM=NDIMTM+NFOCDM(JOCC)
      ENDDO
C Loop over the basis functions for given subblocks
      DO IFOCIM=1,NFOCDM(NOCCIMPM)
      IFOCT=IFOCIM+NDIMTM
      IF(IBLOCKM(IFOCT).NE.IBLKM)CYCLE
      IFOCSM=IPOINTM(1,IFOCT)
      IFOCBM=IPOINTM(2,IFOCT)
      IFOCM=IDIMBM(IFOCT)
      DO IFOCIN=1,NFOCDN(NOCCIMPN)
      IFOCT=IFOCIN+NDIMTN
      IF(IBLOCKN(IFOCT).NE.IBLKN)CYCLE
      IFOCSN=IPOINTN(1,IFOCT)
      IFOCBN=IPOINTN(2,IFOCT)
      IFOCN=IDIMBN(IFOCT)
      IF(IFOCBM.NE.IFOCBN)CYCLE
      IF(ABS(FMATD(IFOCSM,IFOCSN)).LE.EPSMAT)CYCLE
C Compute matrix element between given blocks
	DO IBNDXN=1,NBNDXN
	IENRXN=LENRXN+IBNDXN-NBNDXN
      IF(IBLKM.NE.0)THEN
      DO IBNDM=1,NFOCBM
      IBNDTM=NBNDTM+IBNDM-NFOCBM
      XMATS(IBNDTM,IENRXN,IDEG)=XMATS(IBNDTM,IENRXN,IDEG)+
     &DCONJG(VMATBM(IFOCM,IBNDM))*FMATD(IFOCSM,IFOCSN)*
     &       VMATBN(IFOCN,IBNDXN)
      ENDDO
      ELSEIF(IBLKM.EQ.0)THEN
      IBNDM=IFOCM
      IBNDTM=NBNDTM+IBNDM-NFOCBM
      XMATS(IBNDTM,IENRXN,IDEG)=XMATS(IBNDTM,IENRXN,IDEG)+
     &       FMATD(IFOCSM,IFOCSN)*VMATBN(IFOCN,IBNDXN)
      ENDIF
      ENDDO
C ....
      ENDDO
      ENDDO
C COMPUTE MATRIX ELEMENTS FOR EXTENDED HILBERT SPACE
C Set pointer shifts
      NDIMTN=0
      DO JOCC=0,NOCCIMPN-1
      NDIMTN=NDIMTN+NFOCDN(JOCC)
      ENDDO
      NDEXTM=0
      DO JOCC=0,NOCCIMPM-1
      NDEXTM=NDEXTM+NEXTDM(JOCC)
      ENDDO
C Loop over the basis functions for given subblocks
      DO IFOCIM=1,NEXTDM(NOCCIMPM)
      IFOCT=IFOCIM+NDEXTM
C     IF(IBLOCKM(IFOCT).NE.IBLKM)CYCLE
      IFOCSM=IPTEXTM(1,IFOCT)
      IFOCBM=IPTEXTM(2,IFOCT)
      IFOCM=IFOCT ! IDIMBM(IFOCT)
      DO IFOCIN=1,NFOCDN(NOCCIMPN)
      IFOCT=IFOCIN+NDIMTN
      IF(IBLOCKN(IFOCT).NE.IBLKN)CYCLE
      IFOCSN=IPOINTN(1,IFOCT)
      IFOCBN=IPOINTN(2,IFOCT)
      IFOCN=IDIMBN(IFOCT)
      IF(IFOCBM.NE.IFOCBN)CYCLE
      IF(ABS(FMATD(IFOCSM,IFOCSN)).LE.EPSMAT)CYCLE
C Compute matrix element between given blocks
	DO IBNDXN=1,NBNDXN
	IENRXN=LENRXN+IBNDXN-NBNDXN
      IF(IBLKM.EQ.0)THEN
      IBNDM=IFOCM
      IBNDTM=IBNDM
      XMATE(IBNDTM,IENRXN,IDEG)=XMATE(IBNDTM,IENRXN,IDEG)+
     &       FMATD(IFOCSM,IFOCSN)*VMATBN(IFOCN,IBNDXN)
      ENDIF
      ENDDO
C ....
      ENDDO
      ENDDO
      DEALLOCATE(FMATD)
 2100 CONTINUE 	                                !!! over impurity states
 2200 CONTINUE 	                                !!! over impurity occupancies
C **************************************************
C COMPUTE MATRIX ELEMENTS FOR THE BATH
C **************************************************
C Loop over bath occupancies
      NMATB=0
	DO 2400 IOCCIMP=0,NDEG                     !!! over impurity occupancies
	NOCCBATN=NOCCCLSN-IOCCIMP
	NOCCBATM=NOCCCLSM-IOCCIMP
      NFOCBATN=NFOCBAT(NOCCBATN) ! total dimension of "Nf"   impurity space
      NFOCBATM=NFOCBAT(NOCCBATM) ! total dimension of "Nf"   impurity space
      NCUTBATN=NCUTBAT(NOCCBATN)
      NCUTBATM=NCUTBAT(NOCCBATM)
	IF(RAT_CLSMAT_CBAT(NOCCCLSN,NOCCCLSM,IOCCIMP,ISIG))GOTO 2400
C Unpack matrix elements over bath states
      ALLOCATE(ISBATN(NHYB,NFOCBATN))
      DO 2300 IHYB=1,NHYB       ! 
      DO IFOCBN=1,NFOCBATN
      ISBATN(IHYB,IFOCBN)=IMATBATH(IHYB,IFOCBN+NMATB)
      ENDDO
C COMPUTE MATRIX ELEMENTS FOR TRUNCATED HILBERT SPACE
C Set pointer shifts
      NDIMTN=0
      NDIMTM=0
      DO JOCC=0,IOCCIMP-1
      NDIMTN=NDIMTN+NFOCDN(JOCC)
      NDIMTM=NDIMTM+NFOCDM(JOCC)
      ENDDO
C Loop over the basis functions for given subblocks
      DO IFOCIM=1,NFOCDM(IOCCIMP)
      IFOCT=IFOCIM+NDIMTM
      IF(IBLOCKM(IFOCT).NE.IBLKM)CYCLE
      IFOCSM=IPOINTM(1,IFOCT)
      IFOCBM=IPOINTM(2,IFOCT)
      IFOCM=IDIMBM(IFOCT)
      DO IFOCIN=1,NFOCDN(IOCCIMP)
      IFOCT=IFOCIN+NDIMTN
      IF(IBLOCKN(IFOCT).NE.IBLKN)CYCLE
      IFOCSN=IPOINTN(1,IFOCT)
      IFOCBN=IPOINTN(2,IFOCT)
      IFOCN=IDIMBN(IFOCT)
      IF(IFOCSM.NE.IFOCSN)CYCLE
      IF(ABS(ISBATN(IHYB,IFOCBN)).NE.IFOCBM)CYCLE
C     IF(ISBATN(IHYB,IFOCBN).EQ.0)CYCLE
C Compute matrix element between given blocks
	ISIGN=ISBATN(IHYB,IFOCBN)/IFOCBM*(-1)**IOCCIMP
	DO IBNDXN=1,NBNDXN
	IENRXN=LENRXN+IBNDXN-NBNDXN
	IF(IBLKM.NE.0)THEN
      DO IBNDM=1,NFOCBM
      IBNDTM=NBNDTM+IBNDM-NFOCBM
      XMATS(IBNDTM,IENRXN,NDEG+IHYB)=XMATS(IBNDTM,IENRXN,NDEG+IHYB)+
     &DCONJG(VMATBM(IFOCM,IBNDM))*ISIGN*
     &       VMATBN(IFOCN,IBNDXN)
      ENDDO
      ELSEIF(IBLKM.EQ.0)THEN
      IBNDM=IFOCM
      IBNDTM=NBNDTM+IBNDM-NFOCBM
      XMATS(IBNDTM,IENRXN,NDEG+IHYB)=XMATS(IBNDTM,IENRXN,NDEG+IHYB)+
     &ISIGN*VMATBN(IFOCN,IBNDXN)
      ENDIF
      ENDDO
C ....
      ENDDO
      ENDDO
C COMPUTE MATRIX ELEMENTS FOR EXTENDED HILBERT SPACE
C Set pointer shifts
      NDIMTN=0
      NDEXTM=0
      DO JOCC=0,IOCCIMP-1
      NDEXTN=NDEXTN+NEXTDN(JOCC)
      NDEXTM=NDEXTM+NEXTDM(JOCC)
      ENDDO
C Loop over the basis functions for given subblocks
      DO IFOCIM=1,NEXTDM(IOCCIMP)
      IFOCT=IFOCIM+NDEXTM
C     IF(IBLOCKM(IFOCT).NE.IBLKM)CYCLE
      IFOCSM=IPTEXTM(1,IFOCT)
      IFOCBM=IPTEXTM(2,IFOCT)
      IFOCM=IFOCT ! IDIMBM(IFOCT)
      DO IFOCIN=1,NFOCDN(IOCCIMP)
      IFOCT=IFOCIN+NDIMTN
      IF(IBLOCKN(IFOCT).NE.IBLKN)CYCLE
      IFOCSN=IPOINTN(1,IFOCT)
      IFOCBN=IPOINTN(2,IFOCT)
      IFOCN=IDIMBN(IFOCT)
      IF(IFOCSM.NE.IFOCSN)CYCLE
      IF(ABS(ISBATN(IHYB,IFOCBN)).NE.IFOCBM)CYCLE
C     IF(ISBATN(IHYB,IFOCBN).EQ.0)CYCLE
C Compute matrix element between given blocks
	ISIGN=ISBATN(IHYB,IFOCBN)/IFOCBM*(-1)**IOCCIMP
	DO IBNDXN=1,NBNDXN
	IENRXN=LENRXN+IBNDXN-NBNDXN
      IF(IBLKM.EQ.0)THEN
      IBNDM=IFOCM
      IBNDTM=IBNDM
      XMATE(IBNDTM,IENRXN,NDEG+IHYB)=XMATE(IBNDTM,IENRXN,NDEG+IHYB)+
     &ISIGN*VMATBN(IFOCN,IBNDXN)
      ENDIF
      ENDDO
C ....
      ENDDO
      ENDDO
 2300 CONTINUE                                 !!! over bath states
C     NMATB=NMATB+NCUTBATN
      NMATB=NMATB+NFOCBATN
      DEALLOCATE(ISBATN)
 2400 CONTINUE                                 !!! over impurity occupancies
      DEALLOCATE(IDIMBM,IDIMBN)
      DEALLOCATE(VMATBN)
 3000 CONTINUE                                 !!! over blocks for N electrons
      IF(IBLKM.NE.0)DEALLOCATE(VMATBM)
 4000 CONTINUE                                 !!! over blocks for N-1 electrons
	DEALLOCATE(NMATIMPP,FMATIMPL,IMATIMPL)
	DEALLOCATE(VECXN)
      DEALLOCATE(IBLOCKN,IPOINTN,NFOCDN,IBLOCKM,IPOINTM,NFOCDM)
      DEALLOCATE(IPTEXTN,NEXTDN,IPTEXTM,NEXTDM)
	DEALLOCATE(COMB)
	END




      LOGICAL FUNCTION RAT_CLSMAT_CIMP(NOCCCLSN,NOCCCLSM,IOCCIMP,ISIG)
*******************************************************************
*  Determines if given <Nf-I,Ns> - <Nf,Ns> transition to be skipped
*******************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_RATCLS  ,ONLY: NFOCIMP,NCUTIMP,NFOCBAT,NCUTBAT         !!! from readrat
      USE COM_LSHELL  ,ONLY: LORB,LOCCIMP,SPECIMP
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                         !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
      LOGICAL SKIP,FBLOCK,GBLOCK
	DATA PI/3.141592653589793D0/
	SKIP=.TRUE.
C Select Fock spaces for "Nf,Ns", "Nf-I,Ns+I" "Nf+I,Ns-I" blocks
	NOCCIMPN=IOCCIMP           ! impuirty occupancy "Nf
	NOCCIMPM=NOCCIMPN-ISIG     ! impuirty occupancy "Nf-I
      NFOCIMPN=NFOCIMP(NOCCIMPN) ! total dimension of "Nf"   impurity space
      NFOCIMPM=NFOCIMP(NOCCIMPM) ! total dimension of "Nf-I" impurity space
	NOCCBATN=NOCCCLSN-NOCCIMPN ! bath occupancy Ns for Nf and Nf-I electrons
	NOCCBATN=NOCCCLSM-NOCCIMPM ! bath occupancy Ns for Nf and Nf-I electrons
      NFOCBATN=NFOCBAT(NOCCBATN) ! total dimension of "Ns"   bath space
C Select cutoff states
      NCUTIMPN=NCUTIMP(NOCCIMPN)
      NCUTIMPM=NCUTIMP(NOCCIMPM)
      NCUTBATN=NCUTBAT(NOCCBATN)
C Look at "Nf-I,Ns=F" , "Nf,Ns=G" blocks
      FBLOCK=.FALSE.
      IF(NCUTIMPM.GT.0.AND.NCUTBATN.GT.0)FBLOCK=.TRUE.
      GBLOCK=.FALSE.
      IF(NCUTIMPN.GT.0.AND.NCUTBATN.GT.0)GBLOCK=.TRUE.
C If both "Nf,Ns=G" and Nf-I,Ns=F blocks have non-zero dimensions Skipping is FALSE
      SKIP=.TRUE.
      IF(GBLOCK.AND.FBLOCK)SKIP=.FALSE.
      RAT_CLSMAT_CIMP=SKIP
      RETURN
      END
      
      

      LOGICAL FUNCTION RAT_CLSMAT_CBAT(NOCCCLSN,NOCCCLSM,IOCCIMP,ISIG)
*******************************************************************
*  Determines if given <Nf,Ns-I> - <Nf,Ns> transition to be skipped
*******************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_RATCLS  ,ONLY: NFOCIMP,NCUTIMP,NFOCBAT,NCUTBAT         !!! from readrat
      USE COM_LSHELL  ,ONLY: LORB,LOCCIMP,SPECIMP
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                         !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
      LOGICAL SKIP,FBLOCK,GBLOCK
	DATA PI/3.141592653589793D0/
	SKIP=.TRUE.
C Select Fock spaces for "Nf,Ns", "Nf-1,Ns+1" "Nf+1,Ns-1" blocks
	NOCCIMPN=IOCCIMP           ! impuirty occupancy "Nf
      NFOCIMPN=NFOCIMP(NOCCIMPN) ! total dimension of "Nf"   impurity space
	NOCCBATN=NOCCCLSN-NOCCIMPN ! bath occupancy Ns for Nf electrons
	NOCCBATM=NOCCCLSM-NOCCIMPN ! bath occupancy Ns-I for Nf electrons
      NFOCBATN=NFOCBAT(NOCCBATN) ! total dimension of "Ns" bath space
      NFOCBATM=NFOCBAT(NOCCBATM) ! total dimension of "Ns-I" bath space
C Select cutoff states
      NCUTIMPN=NCUTIMP(NOCCIMPN)
      NCUTBATN=NCUTBAT(NOCCBATN)
      NCUTBATM=NCUTBAT(NOCCBATM)
C Look at "Nf,Ns-I=F" , "Nf,Ns=G" blocks
      FBLOCK=.FALSE.
      IF(NCUTIMPN.GT.0.AND.NCUTBATM.GT.0)FBLOCK=.TRUE.
      GBLOCK=.FALSE.
      IF(NCUTIMPN.GT.0.AND.NCUTBATN.GT.0)GBLOCK=.TRUE.
C If both "Nf,Ns=G" and Nf,Ns-1=F blocks have non-zero dimensions Skipping is FALSE
      SKIP=.TRUE.
      IF(GBLOCK.AND.FBLOCK)SKIP=.FALSE.
      RAT_CLSMAT_CBAT=SKIP
      RETURN
      END