	SUBROUTINE RAT_CLSSAV
***************************************************************
* Exact diagonalization for clusters by blocks
***************************************************************
      USE COM_LMTMEM                                                    !!! from setup
      USE COM_RATOUT  ,ONLY: ICCLS,ICGRF
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER ST*8,FN*8,PROGN*8
      DATA ST/'started'/,FN/'finished'/
C Exact diagonalization for atomic shell
	progn='ShlDiag'
	call lib_timel(times)
	write(iun,10100)progn,st,times,curmem,totmem
      CALL RAT_SHLDIAG
      call lib_timel(timef)
	write(iun,10100)progn,fn,timef,curmem,totmem
C Block diagonalization for clusters	
	progn='ClsDiag'
	call lib_timel(times)
	write(iun,10100)progn,st,times,curmem,totmem
      CALL RAT_CLSDIAG
      call lib_timel(timef)
	write(iun,10100)progn,fn,timef,curmem,totmem
C Find chemical potential
      progn='ClsChem'
	call lib_timel(times)
	write(iun,10100)progn,st,times,curmem,totmem
      CALL RAT_CLSCHEM
      call lib_timel(timef)
	write(iun,10100)progn,fn,timef,curmem,totmem
C Compute Cluster Green function
	progn='CgfMat'
	call lib_timel(times)
	write(iun,10100)progn,st,times,curmem,totmem
	CALL RAT_CGFMAT
      call lib_timel(timef)
	write(iun,10100)progn,fn,timef,curmem,totmem
C Compute Cluster Self-energy
	progn='SigGrf'
	call lib_timel(times)
	write(iun,10100)progn,st,times,curmem,totmem
	CALL RAT_SIGGRF
      call lib_timel(timef)
	write(iun,10100)progn,fn,timef,curmem,totmem
10100 FORMAT('***** ',A8,1X,A8,'; CPU : ',G12.5,
     &       '; CUR/MAX mem.(Mb): ',G10.3,'/',G10.3)
      END



	SUBROUTINE RAT_CLSDIAG
***************************************************************
*  Diagonalize Cluster by blocks
***************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                    !!! from setup
      USE COM_IMPGRF  ,ONLY: CHEM,FILL,KFRM                             !!! from readrat
      USE COM_RATCLS  ,ONLY: LOCCCLS,LOCCBAT,WCUTBAS,WEXTBAS            !!! from readrat
     &                      ,NFOCTOT,NEXTTOT,NFOCCLS,NFOCBLK,NBLKCLS    !!! from readrat
     &                      ,NEXTCLS,NFOCIMP,NCUTIMP,NFOCBAT,NCUTBAT
     &                      ,SPECCLS,XHUBCLS,SEXTCLS,XEXTCLS,NEXCPAR
      USE COM_LSHELL  ,ONLY: LORB,LOCCIMP,SPECIMP              
	USE COM_MSBMESH ,ONLY: TEMP                                       !!! from readrat
      USE COM_RATHYB  ,ONLY: NHYB                                       !!! from readrat
      USE COM_RATCHN  ,ONLY: IUCL1,IUCL2,IUCL3,IUCL4,IUCL5              !!! from setup
      USE COM_LMTOUT  ,ONLY: SCRFILE                                    !!! from storage
      USE COM_RATOUT  ,ONLY: ICCLS,CLSFILE                              !!! from storage
      USE COM_MASHDEP ,ONLY: NVAL                                       !!! from setup
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                            !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER, ALLOCATABLE :: IBLOCK(:)
      INTEGER, ALLOCATABLE :: IPOINT(:,:)
      INTEGER, ALLOCATABLE :: IFBATH(:,:)
      REAL*8, ALLOCATABLE :: COMB(:,:)
      REAL*8, ALLOCATABLE :: EVAL(:)
	REAL*8, ALLOCATABLE :: SPECSHL(:)
	REAL*8, ALLOCATABLE :: SPECBAT(:)
	LOGICAL EXIST,OPEN
	CHARACTER TNC*10,TNB*10,ST*8,FN*8,PROGN*8,CFILE*130
	LOGICAL EXIT,LIB_TRACER
	DATA ST/'started'/,FN/'finished'/
	DATA PI/3.141592653589793D0/
C MEMORY ALLOCATIONS
	NDEG=2*(2*LORB+1)
      ALLOCATE(COMB(0:NDEG+NHYB,0:NDEG+NHYB))
	CALL LIB_GETCOMB(COMB,NDEG+NHYB)
C Zeroise Hilbert space dimensions
      DO IOCC=0,NDEG+NHYB
      NFOCCLS(IOCC)=0
      NEXTCLS(IOCC)=0
      NBLKCLS(IOCC)=0
      ENDDO
      DO IOCC=-NDEG-NHYB-1,NDEG+NHYB+1
      NFOCIMP(IOCC)=0
      NCUTIMP(IOCC)=0
      ENDDO
      DO IOCC=-NDEG-NHYB-1,NDEG+NHYB+1
      NFOCBAT(IOCC)=0
      NCUTBAT(IOCC)=0
      ENDDO
C *****************************************
C Set impurity Hilbert space
	MDIMIMP=0
      DO IOCCIMP=0,NDEG                   !!! over impurity occupancies
	IF(LOCCIMP(IOCCIMP).EQ.0)CYCLE
      NFOCIMP(IOCCIMP)=NINT(COMB(IOCCIMP,NDEG))
 	MDIMIMP=MDIMIMP+NFOCIMP(IOCCIMP)
C Get spectra of impurity shell for given subblocks
	ALLOCATE(SPECSHL(NFOCIMP(IOCCIMP)))
	DO IFOC=1,NINT(COMB(IOCCIMP,NDEG))
	SPECSHL(IFOC)=SPECIMP(IFOC+MDIMIMP-NFOCIMP(IOCCIMP))
	ENDDO
C Select cutoff states for impurity shell
      DO IFOC=1,NFOCIMP(IOCCIMP)
      IF(SPECSHL(IFOC).GT.SPECSHL(1)+WCUTBAS)EXIT
      ENDDO
      NCUTIMP(IOCCIMP)=IFOC-1
      DEALLOCATE(SPECSHL)
      ENDDO                                    !!! over impurity occupancies
C *****************************************
C Set bath Hilbert space
	DO IOCCBAT=0,NHYB                        !!! over bath occupancies
	IF(LOCCBAT(IOCCBAT).EQ.0)CYCLE
C Get dimensions of the Hilbert space
      NFOCMAX=0
	ALLOCATE(SPECBAT(NFOCMAX))
	ALLOCATE(IFBATH(0:NHYB,NFOCMAX))
	CALL RAT_CLSDIAG_BATH(SPECBAT,IFBATH,IOCCBAT,0,
     &                      NFOCBAT(IOCCBAT))
      DEALLOCATE(SPECBAT,IFBATH)
C Get spectra of the bath for given subblocks
      NFOCMAX=NFOCBAT(IOCCBAT)
	ALLOCATE(SPECBAT(NFOCMAX))
	ALLOCATE(IFBATH(0:NHYB,NFOCMAX))
	CALL RAT_CLSDIAG_BATH(SPECBAT,IFBATH,IOCCBAT,NFOCMAX,
     &                      NFOCBAT(IOCCBAT))
C Select cutoff states for the bath
      DO IFOC=1,NFOCBAT(IOCCBAT)
      IF(SPECBAT(IFOC).GT.SPECBAT(1)+WCUTBAS)EXIT
      ENDDO
      NCUTBAT(IOCCBAT)=IFOC-1
      DEALLOCATE(SPECBAT,IFBATH)
	ENDDO                                    !!! over bath occupancies
C *********************************************************************      
C Start looping over electronic occupancies	
      NFOCTOT=0
      NEXTTOT=0
	DO 1000 IOCC=0,NDEG+NHYB                 !!! over cluster occupancies
	IF(LOCCCLS(IOCC).EQ.0)CYCLE
	WRITE(IUN,10010)IOCC,NDEG+NHYB
10010	FORMAT(/'EXACT DIAG: CLUSTER ELECTRONS # ',I5, ' OUT OF ',I5/)
C Prepare hamiltonian
      progn='H matrix'
	call lib_timel(times)
	write(iun,1110)progn,st,times,curmem,totmem
      CALL RAT_CLSDIAG_HMAT(IOCC,NFOC,NEXT)
	call lib_timel(timef)
	write(iun,1110)progn,fn,timef,curmem,totmem
      NFOCCLS(IOCC)=NFOC
      NEXTCLS(IOCC)=NEXT
C Subdiagonalize hamiltonian
      ALLOCATE(IBLOCK(NFOC))
      ALLOCATE(IPOINT(2,NFOC))
      progn='H blocks'
	call lib_timel(times)
	write(iun,1110)progn,st,times,curmem,totmem
	CALL RAT_CLSDIAG_HSUB(IOCC,NFOC,NBLK,IBLOCK)
	call lib_timel(timef)
	write(iun,1110)progn,fn,timef,curmem,totmem
      NBLKCLS(IOCC)=NBLK
C Diagonalize hamiltonian by subblocks
      progn='Ex. Diag'
	call lib_timel(times)
	write(iun,1110)progn,st,times,curmem,totmem
      CALL RAT_CLSDIAG_DIAG(IOCC,NFOC,NEXT,NBLK,IBLOCK,IPOINT)
	call lib_timel(timef)
	write(iun,1110)progn,fn,timef,curmem,totmem
C Print eigenvalues and orbital quantum numbers
      progn='Orb.Moms'
	call lib_timel(times)
	write(iun,1110)progn,st,times,curmem,totmem
      CALL RAT_CLSDIAG_ORBM(IOCC,NFOC,NBLK,IBLOCK,IPOINT)
	call lib_timel(timef)
	write(iun,1110)progn,fn,timef,curmem,totmem
      DEALLOCATE(IBLOCK,IPOINT)
      NFOCTOT=NFOCTOT+NFOC
      NEXTTOT=NEXTTOT+NEXT
 1000 CONTINUE                                 !!! over cluster occupancies
C Read eigenvalues obtained
      NBLKMAX=0
      DO IOCC=0,NDEG+NHYB
      IF(LOCCCLS(IOCC).EQ.0)CYCLE
      NBLKMAX=MAX(NBLKMAX,NBLKCLS(IOCC))
      ENDDO
      IF(.NOT.ALLOCATED(NFOCBLK))
     &ALLOCATE(NFOCBLK(0:NBLKMAX,0:NDEG+NHYB))
      IF(.NOT.ALLOCATED(SPECCLS))
     &ALLOCATE(SPECCLS(NFOCTOT))
      IF(.NOT.ALLOCATED(XHUBCLS))
     &ALLOCATE(XHUBCLS(NFOCTOT))
      IF(.NOT.ALLOCATED(SEXTCLS))
     &ALLOCATE(SEXTCLS(NEXTTOT))
      IF(.NOT.ALLOCATED(XEXTCLS))
     &ALLOCATE(XEXTCLS(NEXTTOT))
      DO IOCC=0,NDEG+NHYB
	DO IBLK=0,NBLKMAX
      NFOCBLK(IBLK,IOCC)=0
      ENDDO
      ENDDO
      NFOCT=0
      NEXTT=0
	DO IOCC=0,NDEG+NHYB                     !!! over cluster occupancies
	IF(LOCCCLS(IOCC).EQ.0)CYCLE
	DO IBLK=0,NBLKCLS(IOCC)                 !!! over blocks
      CALL LIB_TINT(TNC,10,IOCC,NC)
      CALL LIB_TINT(TNB,10,IBLK,NB)
      IF(ICCLS.EQ.0)CFILE=SCRFILE(IUCL2)
      IF(ICCLS.GT.0)CFILE=CLSFILE
      CALL FIND_LBLANK(CFILE,130,NA)
      OPEN(UNIT=IUCL2,FILE=CFILE(:NA)//'_'//TNC(:NC)//'_'//
     &TNB(:NB),STATUS='OLD',ACCESS='SEQUENTIAL',FORM='UNFORMATTED')
      READ(IUCL2)NFOCB,NVECB
      ALLOCATE(EVAL(NFOCB))
      READ(IUCL2)(EVAL(IDIM),IDIM=1,NFOCB)
      DO IFOCB=1,NFOCB
      IFOCT=IFOCB+NFOCT
      SPECCLS(IFOCT)=EVAL(IFOCB)
      ENDDO
      NFOCBLK(IBLK,IOCC)=NFOCB
      NFOCT=NFOCT+NFOCB
      DEALLOCATE(EVAL)
      IF(IBLK.EQ.0)THEN
      READ(IUCL2)NEXTB
      ALLOCATE(EVAL(NEXTB))
      READ(IUCL2)(EVAL(IDIM),IDIM=1,NEXTB)
      DO IFOCB=1,NEXTB
      IFOCT=IFOCB+NEXTT
      SEXTCLS(IFOCT)=EVAL(IFOCB)
      ENDDO
      NEXTT=NEXTT+NEXTB
      DEALLOCATE(EVAL)
      ENDIF
      CLOSE(IUCL2,STATUS='KEEP')
      ENDDO                                   !!! over cluster occupancies
      ENDDO
      IF(NFOCT.NE.NFOCTOT)
     &CALL FULLSTOP('<RAT_CLSDIAG>:: ERROR IN NFOCT.NE.NFOCTOT')
      IF(NEXTT.NE.NEXTTOT)
     &CALL FULLSTOP('<RAT_CLSDIAG>:: ERROR IN NEXTT.NE.NEXTTOT')
C MEMORY DEALLOCATIONS     
      DEALLOCATE(COMB)
1110  FORMAT('***** ',A8,1X,A8,'; CPU : ',G12.5,
     &       '; CUR/MAX mem.(Mb): ',G10.3,'/',G10.3)
      END






	SUBROUTINE RAT_CLSCHEM
***************************************************************
*  Find chemical potential
***************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_IMPGRF  ,ONLY: CHEM,FILL,KFRM                          !!! from readrat
      USE COM_RATCLS  ,ONLY: LOCCCLS,NFOCTOT,NEXTTOT,NFOCCLS,NBLKCLS !!! from readrat
     &                      ,SPECCLS,XHUBCLS,SEXTCLS,XEXTCLS,NEXTCLS !!! from readrat
      USE COM_LSHELL  ,ONLY: LORB              
	USE COM_MSBMESH ,ONLY: TEMP                                    !!! from readrat
      USE COM_RATHYB  ,ONLY: NHYB                                    !!! from readrat
      USE COM_MASHDEP ,ONLY: NVAL                                    !!! from setup
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                         !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
	DATA PI/3.141592653589793D0/
C MEMORY ALLOCATIONS
	NDEG=2*(2*LORB+1)
C Compute chemical potential corresponding to mean filling
	WRITE(IUN,10110)
10110 FORMAT(1X,'Start search the chemical potential -->')
	WRITE(IUN,10120)
10120 FORMAT(1X,'   Energy     # of Electrons')
	EFRM=CHEM
C First try this Fermi level
	CALL RAT_CLSDIAG_XNOT(NDEG+NHYB,NFOCTOT,NEXTTOT,NFOCCLS,NEXTCLS,
     &     LOCCCLS,SPECCLS,SEXTCLS,EFRM,TEMP,XHUBCLS,XEXTCLS)
	STAT=0.D0
	ZSUM=0.D0
	NDIMT=0
	NEXTT=0
	DO IOCC=0,NDEG+NHYB
	IF(LOCCCLS(IOCC).EQ.0)CYCLE
	SUM=0.D0
	DO IFOC=1,NFOCCLS(IOCC)
	SUM=SUM+XHUBCLS(IFOC+NDIMT)
	ENDDO
	DO IFOC=1,NEXTCLS(IOCC)
	SUM=SUM+XEXTCLS(IFOC+NEXTT)
	ENDDO
	STAT=STAT+SUM
	ZSUM=ZSUM+SUM*DBLE(IOCC)
	NDIMT=NDIMT+NFOCCLS(IOCC)
	NEXTT=NEXTT+NEXTCLS(IOCC)
	ENDDO
	IF(ABS(STAT-1.D0).GT.1.D-07)
     &CALL FULLSTOP('Wrong renormalization')
	ZSUM=ZSUM/STAT
	WRITE(IUN,10130)EFRM,ZSUM
	ZDIF=FILL-ZSUM
      IF(ABS(ZDIF).LE.1.D-05.OR.KFRM.GT.0)GOTO 200
C If KFRM search is needed
	ZDIF=0.D0
	JTER=0
	EMIN=+1.D+10
	EMAX=-1.D+10
	DO IBND=1,NFOCTOT
	EMIN=MIN(EMIN,SPECCLS(IBND))
	EMAX=MAX(EMAX,SPECCLS(IBND))
	ENDDO
	DO IBND=1,NEXTTOT
	EMIN=MIN(EMIN,SEXTCLS(IBND))
	EMAX=MAX(EMAX,SEXTCLS(IBND))
	ENDDO
	E1=-0.5D0*(EMAX-EMIN)
	E2=+0.5D0*(EMAX-EMIN)
	IF(KFRM.EQ.0)
     &CALL LIB_FINDROOT(EFRM,ZDIF,E1,E2,JTER,IEXIT,IUN,1.D-05,50)
 100	JTER=JTER+1
C Find new charge
	CALL RAT_CLSDIAG_XNOT(NDEG+NHYB,NFOCTOT,NEXTTOT,NFOCCLS,NEXTCLS,
     &     LOCCCLS,SPECCLS,SEXTCLS,EFRM,TEMP,XHUBCLS,XEXTCLS)
	STAT=0.D0
	ZSUM=0.D0
	NDIMT=0
	NEXTT=0
	DO IOCC=0,NDEG+NHYB
	IF(LOCCCLS(IOCC).EQ.0)CYCLE
	SUM=0.D0
	DO IFOC=1,NFOCCLS(IOCC)
	SUM=SUM+XHUBCLS(IFOC+NDIMT)
	ENDDO
	DO IFOC=1,NEXTCLS(IOCC)
	SUM=SUM+XEXTCLS(IFOC+NEXTT)
	ENDDO
	STAT=STAT+SUM
	ZSUM=ZSUM+SUM*DBLE(IOCC)
	NDIMT=NDIMT+NFOCCLS(IOCC)
	NEXTT=NEXTT+NEXTCLS(IOCC)
	ENDDO
	IF(ABS(STAT-1.D0).GT.1.D-07)
     &CALL FULLSTOP('Wrong renormalization')
	ZSUM=ZSUM/STAT
C Difference
	ZDIF=FILL-ZSUM
	WRITE(IUN,10130)EFRM,ZSUM
10130 FORMAT(1X,G14.7,1X,G14.7)
	IF(KFRM.NE.0)GOTO 200
	CALL LIB_FINDROOT(EFRM,ZDIF,E1,E2,JTER,IEXIT,IUN,1.D-05,50)
	IF(IEXIT.EQ.1)GOTO 200
	GOTO 100
  200 CONTINUE
	CHEM=EFRM
C Compute probabilities
	CALL RAT_CLSDIAG_XNOT(NDEG+NHYB,NFOCTOT,NEXTTOT,NFOCCLS,NEXTCLS,
     &     LOCCCLS,SPECCLS,SEXTCLS,EFRM,TEMP,XHUBCLS,XEXTCLS)
	STAT=0.D0
	ZSUM=0.D0
	NDIMT=0
	NEXTT=0
	DO IOCC=0,NDEG+NHYB
	IF(LOCCCLS(IOCC).EQ.0)CYCLE
	SUM=0.D0
	DO IFOC=1,NFOCCLS(IOCC)
	SUM=SUM+XHUBCLS(IFOC+NDIMT)
	ENDDO
	DO IFOC=1,NEXTCLS(IOCC)
	SUM=SUM+XEXTCLS(IFOC+NEXTT)
	ENDDO
	STAT=STAT+SUM
	ZSUM=ZSUM+SUM*DBLE(IOCC)
	NDIMT=NDIMT+NFOCCLS(IOCC)
	NEXTT=NEXTT+NEXTCLS(IOCC)
	ENDDO
	IF(ABS(STAT-1.D0).GT.1.D-07)
     &CALL FULLSTOP('<RAT_CLSDIAG>:: Wrong renormalization')
	ZSUM=ZSUM/STAT
	FILL=ZSUM
      END



	SUBROUTINE RAT_CLSDIAG_HMAT(NOCCCLS,NFOCCLST,NEXTCLST)
***************************************************************
*  Prepare Hamiltonian for given number of cluster electrons
***************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_RATPAR  ,ONLY: EPSMAT                                  !!! from readrat
      USE COM_IMPGRF  ,ONLY: CHEM,FILL,KFRM                          !!! from readrat
      USE COM_RATCLS  ,ONLY: LOCCCLS,WCUTBAS,WEXTBAS                 !!! from readrat
     &                      ,NFOCIMP,NCUTIMP,NFOCBAT,NCUTBAT
      USE COM_LSHELL  ,ONLY: LORB,LOCCIMP,SPECIMP
      USE COM_RATHYB  ,ONLY: NHYB,EHYB,VHYB                          !!! from readrat
      USE COM_RATCHN  ,ONLY: IUAGF,IUCL1,IUCL2,IUCL3,IUCL4,IUCL5     !!! from setup
      USE COM_LMTOUT  ,ONLY: SCRFILE                                 !!! from storage
      USE COM_MASHDEP ,ONLY: NVAL,LENCMP,LENREL,LENINT               !!! from setup
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                         !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER, ALLOCATABLE :: IPBLKG(:)
	INTEGER, ALLOCATABLE :: IPBLKF(:)
      INTEGER, ALLOCATABLE :: IPBLKT(:,:)
      INTEGER, ALLOCATABLE :: IFBATN(:,:)
      INTEGER, ALLOCATABLE :: IFBATP(:,:)
      INTEGER, ALLOCATABLE :: ICBATN(:,:)
      INTEGER, ALLOCATABLE :: IFCLSG(:,:)
      INTEGER, ALLOCATABLE :: IFCLSF(:,:)
      INTEGER, ALLOCATABLE :: IPCLSG(:,:)
      INTEGER, ALLOCATABLE :: IPCLSF(:,:)
      INTEGER, ALLOCATABLE :: IECLSG(:,:)
      INTEGER, ALLOCATABLE :: IECLSF(:,:)
      INTEGER, ALLOCATABLE :: IHYBMATP(:,:)
	INTEGER, ALLOCATABLE :: NMATIMPP(:)
	INTEGER, ALLOCATABLE :: IMATIMPP(:,:)
	INTEGER, ALLOCATABLE :: IMATIMPL(:,:)
	REAL*8, ALLOCATABLE :: COMB(:,:)
	REAL*8, ALLOCATABLE :: SPECIMPN(:)
	REAL*8, ALLOCATABLE :: SPECIMPM(:)
	REAL*8, ALLOCATABLE :: SPECBATN(:)
	REAL*8, ALLOCATABLE :: SPECBATP(:)
	REAL*8, ALLOCATABLE :: SPECCLSG(:)
	REAL*8, ALLOCATABLE :: SPECCLSF(:)
	REAL*8, ALLOCATABLE :: SPECCLST(:)
	REAL*8, ALLOCATABLE :: SEXTCLSG(:)
	REAL*8, ALLOCATABLE :: SEXTCLSF(:)
	COMPLEX*16, ALLOCATABLE :: FMATIMPP(:)
	COMPLEX*16, ALLOCATABLE :: FMATIMPL(:)
	COMPLEX*16, ALLOCATABLE :: FMATIMPD(:,:)
	COMPLEX*16, ALLOCATABLE :: VHYBMATP(:)
	CHARACTER*1, ALLOCATABLE:: THYBMAT0(:,:)
	COMPLEX*16 DIM
	CHARACTER TMS*10,TCH*10,TNC*10
	LOGICAL EXIST,OPEN,RAT_CLSDIAG_SKIP
	DATA PI/3.141592653589793D0/,DIM/(0.D0,1.D0)/
C *************************************
C MEMORY ALLOCATIONS
      NDEG=2*(2*LORB+1)
      ALLOCATE(COMB(0:NDEG+NHYB,0:NDEG+NHYB))
	CALL LIB_GETCOMB(COMB,NDEG+NHYB)
C ********************************************
C Start looping over impurity occupancies
	MDIMIMPN=0
	MDIMIMPM=0
	NFOCCLST=0
	NEXTCLST=0
      DO 1000 IOCCIMP=0,NDEG                    !!! over impurity occupancies
	NOCCIMPN=IOCCIMP
      NFOCIMPN=NFOCIMP(NOCCIMPN) ! total dimension of "Nf"   impurity space
	MDIMIMPN=MDIMIMPN+NFOCIMPN
	NOCCIMPM=NOCCIMPN-1
      NFOCIMPM=NFOCIMP(NOCCIMPM) ! total dimension of "Nf-1" impurity space
      MDIMIMPM=MDIMIMPM+NFOCIMPM
	NOCCBATN=NOCCCLS-NOCCIMPN ! bath occupancy for Nimp electrons
	NOCCBATP=NOCCCLS-NOCCIMPM ! bath occupancy for Nimp-1 electrons
      NFOCBATN=NFOCBAT(NOCCBATN) ! total dimension of "Ns"   bath space
      NFOCBATP=NFOCBAT(NOCCBATP) ! total dimension of "Ns+1" bath space
      IF(RAT_CLSDIAG_SKIP(NOCCCLS,IOCCIMP))GOTO 1000
C Select cutoff states
      NCUTIMPN=NCUTIMP(NOCCIMPN)
      NCUTIMPM=NCUTIMP(NOCCIMPM)
      NCUTBATN=NCUTBAT(NOCCBATN)
      NCUTBATP=NCUTBAT(NOCCBATP)
	WRITE(IUN,10010)
10010	FORMAT(1X,' Blocks   <F>    <G>')
	WRITE(IUN,10020)NOCCIMPM,NOCCIMPN
10020	FORMAT(1X,' Imp. occ Nf-1 -> Nf = ',I5,1X,I5)
	WRITE(IUN,10030)NOCCBATP,NOCCBATN
10030	FORMAT(1X,' Bath occ Ns+1 -> Ns = ',I5,1X,I5)
C Get spectra of impurity shell for given subblocks
	SIZE_MEM=0.D0
	ALLOCATE(SPECIMPN(NFOCIMPN))
	ALLOCATE(SPECIMPM(NFOCIMPM))
	DO IFOCN=1,NFOCIMPN
	SPECIMPN(IFOCN)=SPECIMP(IFOCN+MDIMIMPN-NFOCIMPN)
	ENDDO
	DO IFOCM=1,NFOCIMPM
	SPECIMPM(IFOCM)=SPECIMP(IFOCM+MDIMIMPM-NFOCIMPM)
	ENDDO
C Get matrix elements for impurity shell
      NMATMAX=0
      IF(NCUTIMPN.GT.0.AND.NCUTIMPM.GT.0)
     &CALL RAT_SHLMAT(NOCCIMPN,NMATMAX,'D')
C Get spectra of the bath for given subblocks
	ALLOCATE(SPECBATN(NFOCBATN))
	ALLOCATE(SPECBATP(NFOCBATP))
	ALLOCATE(IFBATN(0:NHYB,NFOCBATN))
	ALLOCATE(IFBATP(0:NHYB,NFOCBATP))
      ALLOCATE(ICBATN(NHYB,NCUTBATN))
	SIZE_MEM=SIZE_MEM+DBLE(SIZE(IFBATN)*LENINT)/1024.D0**2
     &                 +DBLE(SIZE(IFBATP)*LENINT)/1024.D0**2
     &                 +DBLE(SIZE(ICBATN)*LENINT)/1024.D0**2
      IF(NFOCBATN.GT.0)
     &CALL RAT_CLSDIAG_BATH(SPECBATN,IFBATN,NOCCBATN,NFOCBATN,NFOCBATN)
      IF(NFOCBATP.GT.0)
     &CALL RAT_CLSDIAG_BATH(SPECBATP,IFBATP,NOCCBATP,NFOCBATP,NFOCBATP)
C Get matrix elements between the bath states
C by apply creation operator to the bath state with N electrons
      IF(NCUTBATN.GT.0.AND.NCUTBATP.GT.0)
     &CALL RAT_CLSDIAG_BMAT(IFBATN,IFBATP,ICBATN,NHYB,
     &     NFOCBATN,NFOCBATP,NCUTBATN,NCUTBATP,'C')
C Estimate the Hilbert space for "Nf,Ns" block
      EZERONN=0.D0
      IF(NCUTIMPN.GT.0.AND.NCUTBATN.GT.0)
     &EZERONN=SPECIMPN(1)+SPECBATN(1)
      IFOC=0
	DO IFOCS=1,NCUTIMPN
	DO IFOCB=1,NCUTBATN
	ECLUS=SPECIMPN(IFOCS)+SPECBATN(IFOCB)
	IF(ECLUS.LE.EZERONN+WCUTBAS)IFOC=IFOC+1
	ENDDO
	ENDDO
	NFOCCLSG=IFOC
	ALLOCATE(SPECCLSG(NFOCCLSG))
	ALLOCATE(IFCLSG(2,NFOCCLSG))
	ALLOCATE(IPCLSG(NCUTIMPN,NCUTBATN))
	SIZE_MEM=SIZE_MEM+DBLE(SIZE(IPCLSG)*LENINT)/1024.D0**2
      IFOC=0
	DO IFOCS=1,NCUTIMPN
	DO IFOCB=1,NCUTBATN
	IPCLSG(IFOCS,IFOCB)=0
	ECLUS=SPECIMPN(IFOCS)+SPECBATN(IFOCB)
	IF(ECLUS.LE.EZERONN+WCUTBAS)THEN
	IFOC=IFOC+1
	SPECCLSG(IFOC)=ECLUS
	IFCLSG(1,IFOC)=IFOCS
	IFCLSG(2,IFOC)=IFOCB
	IPCLSG(IFOCS,IFOCB)=IFOC
	ENDIF
	ENDDO
	ENDDO
C Estimate extended Hilbert space for "Nf,Ns" block
      EZERONN=0.D0
      IF(NCUTIMPN.GT.0.AND.NCUTBATN.GT.0)
     &EZERONN=SPECIMPN(1)+SPECBATN(1)
      IFOC=0
	DO IFOCS=1,NFOCIMPN
	DO IFOCB=1,NFOCBATN
	ECLUS=SPECIMPN(IFOCS)+SPECBATN(IFOCB)
	IF(ECLUS.GT.EZERONN+WCUTBAS.AND.
     &   ECLUS.LE.EZERONN+WEXTBAS)IFOC=IFOC+1
	ENDDO
	ENDDO
	NEXTCLSG=IFOC
	ALLOCATE(SEXTCLSG(NEXTCLSG))
	ALLOCATE(IECLSG(2,NEXTCLSG))
      IFOC=0
	DO IFOCS=1,NFOCIMPN
	DO IFOCB=1,NFOCBATN
	ECLUS=SPECIMPN(IFOCS)+SPECBATN(IFOCB)
	IF(ECLUS.GT.EZERONN+WCUTBAS.AND.
     &   ECLUS.LE.EZERONN+WEXTBAS)THEN
	IFOC=IFOC+1
	SEXTCLSG(IFOC)=ECLUS
	IECLSG(1,IFOC)=IFOCS
	IECLSG(2,IFOC)=IFOCB
	ENDIF
	ENDDO
	ENDDO
C Estimate the Hilbert space for "Nf-1,Ns+1" block
      EZEROMP=0.D0
      IF(NCUTIMPM.GT.0.AND.NCUTBATP.GT.0)
     &EZEROMP=SPECIMPM(1)+SPECBATP(1)
      IFOC=0
	DO IFOCS=1,NCUTIMPM
	DO IFOCB=1,NCUTBATP
	ECLUS=SPECIMPM(IFOCS)+SPECBATP(IFOCB)
	IF(ECLUS.LE.EZEROMP+WCUTBAS)IFOC=IFOC+1
	ENDDO
	ENDDO
	NFOCCLSF=IFOC
	ALLOCATE(SPECCLSF(NFOCCLSF))
	ALLOCATE(IFCLSF(2,NFOCCLSF))
	ALLOCATE(IPCLSF(NCUTIMPM,NCUTBATP))
	SIZE_MEM=SIZE_MEM+DBLE(SIZE(IPCLSF)*LENINT)/1024.D0**2
      IFOC=0
	DO IFOCS=1,NCUTIMPM
	DO IFOCB=1,NCUTBATP
	IPCLSF(IFOCS,IFOCB)=0
	ECLUS=SPECIMPM(IFOCS)+SPECBATP(IFOCB)
	IF(ECLUS.LE.EZEROMP+WCUTBAS)THEN
	IFOC=IFOC+1
	SPECCLSF(IFOC)=ECLUS
	IFCLSF(1,IFOC)=IFOCS
	IFCLSF(2,IFOC)=IFOCB
	IPCLSF(IFOCS,IFOCB)=IFOC
      ENDIF	
	ENDDO
	ENDDO
C Estimate extended Hilbert space for "Nf-1,Ns+1" block
      EZEROMP=0.D0
      IF(NCUTIMPM.GT.0.AND.NCUTBATP.GT.0)
     &EZEROMP=SPECIMPM(1)+SPECBATP(1)
      IFOC=0
	DO IFOCS=1,NFOCIMPM
	DO IFOCB=1,NFOCBATP
	ECLUS=SPECIMPM(IFOCS)+SPECBATP(IFOCB)
	IF(ECLUS.GT.EZEROMP+WCUTBAS.AND.
     &   ECLUS.LE.EZEROMP+WEXTBAS)IFOC=IFOC+1
	ENDDO
	ENDDO
	NEXTCLSF=IFOC
	ALLOCATE(SEXTCLSF(NEXTCLSF))
	ALLOCATE(IECLSF(2,NEXTCLSF))
      IFOC=0
	DO IFOCS=1,NFOCIMPM
	DO IFOCB=1,NFOCBATP
	ECLUS=SPECIMPM(IFOCS)+SPECBATP(IFOCB)
	IF(ECLUS.GT.EZEROMP+WCUTBAS.AND.
     &   ECLUS.LE.EZEROMP+WEXTBAS)THEN
	IFOC=IFOC+1
	SEXTCLSF(IFOC)=ECLUS
	IECLSF(1,IFOC)=IFOCS
	IECLSF(2,IFOC)=IFOCB
      ENDIF	
	ENDDO
	ENDDO
	WRITE(IUN,10040)
10040	FORMAT(1X,'Fock Spaces obtained --->')
	WRITE(IUN,10050)NFOCIMPN,NFOCBATN
10050	FORMAT(1X,'N_FocImp(N)      =',I7,'; N_FocBath(N)   =',I7)
	WRITE(IUN,10060)NCUTIMPN,NCUTBATN
10060	FORMAT(1X,'N_CutImp(N)      =',I7,'; N_CutBath(N)   =',I7)
	WRITE(IUN,10070)NFOCIMPM,NFOCBATP
10070	FORMAT(1X,'N_FocImp(N-1)    =',I7,'; NFocBath(N+1)  =',I7)
	WRITE(IUN,10080)NCUTIMPM,NCUTBATP
10080	FORMAT(1X,'N_CutImp(N-1)    =',I7,'; NCutBath(N+1)  =',I7)
	WRITE(IUN,10090)
10090	FORMAT(1X,'Cluster Hilbert space -->')
	WRITE(IUN,10100)NFOCCLSF,NFOCCLSG
10100	FORMAT(1X,'N_Cls(N-1*N+1)   =',I7,'; N_Cls(N * N)   =',I7)
	WRITE(IUN,10110)NEXTCLSF,NEXTCLSG
10110	FORMAT(1X,'N_Ext(N-1*N+1)   =',I7,'; N_Ext(N * N)   =',I7)
      IF(NFOCCLST.EQ.0)
     &NFOCCLST=NFOCCLSF
      NFOCCLST=NFOCCLST+NFOCCLSG
      IF(NEXTCLST.EQ.0)
     &NEXTCLST=NEXTCLSF
      NEXTCLST=NEXTCLST+NEXTCLSG
C Read matrix elements of the impurity
	CALL FIND_LBLANK(SCRFILE(IUAGF),130,NA)
	ALLOCATE(NMATIMPP(NDEG))
	ALLOCATE(FMATIMPL(NMATMAX))
	ALLOCATE(IMATIMPL(2,NMATMAX))
	SIZE_MEM=SIZE_MEM+DBLE(SIZE(FMATIMPL)*LENCMP)/1024.D0**2
     &                 +DBLE(SIZE(IMATIMPL)*LENINT)/1024.D0**2
	NMATC=0
	DO IDEG=1,NDEG
	NMATIMPP(IDEG)=0
	ENDDO
	IF(NCUTIMPN.GT.0.AND.NCUTIMPM.GT.0)THEN
	DO IDEG=1,NDEG                              !!! over impurity states
      CALL LIB_TINT(TNC,10,IOCCIMP,NC)
      CALL LIB_TINT(TMS,10,IDEG,NB)
      OPEN(UNIT=IUAGF,FILE=SCRFILE(IUAGF)(:NA)//'_'//TMS(:NB)//'_'//
     &TNC(:NC),STATUS='OLD',ACCESS='SEQUENTIAL',FORM='UNFORMATTED')
      READ(IUAGF)NMATIMPP(IDEG)
      ALLOCATE(FMATIMPP(NMATIMPP(IDEG)))
      ALLOCATE(IMATIMPP(2,NMATIMPP(IDEG)))
	READ(IUAGF)(FMATIMPP(IMAT),IMAT=1,NMATIMPP(IDEG)),
     & ((IMATIMPP(I,IMAT),I=1,2),IMAT=1,NMATIMPP(IDEG))
	CLOSE(UNIT=IUAGF,STATUS='DELETE')
C Pack matrix elements into long array
	DO IMAT=1,NMATIMPP(IDEG)
	FMATIMPL(IMAT+NMATC)=FMATIMPP(IMAT)
	IMATIMPL(1,IMAT+NMATC)=IMATIMPP(1,IMAT)
	IMATIMPL(2,IMAT+NMATC)=IMATIMPP(2,IMAT)
	ENDDO
	NMATC=NMATC+NMATIMPP(IDEG)
	DEALLOCATE(FMATIMPP,IMATIMPP)
	ENDDO                                        !!! over impurity states
	ENDIF
C BUILD HYBRIDIZATION MATRIX ELEMENTS
	ALLOCATE(FMATIMPD(NFOCIMPM,NFOCIMPN))
      ALLOCATE(THYBMAT0(NFOCCLSF,NFOCCLSG))
	SIZE_MEM=SIZE_MEM+DBLE(SIZE(THYBMAT0))/1024.D0**2
	SIZE_MEM=SIZE_MEM+DBLE(SIZE(FMATIMPD)*LENCMP)/1024.D0**2
C Set pointer array to zero
      DO IFOCF=1,NFOCCLSF
      DO IFOCG=1,NFOCCLSG
      THYBMAT0(IFOCF,IFOCG)='0'
      ENDDO
      ENDDO
C Do over bath states twice, first counts non-zeros, second fills arrays
      DO ITWO=1,2                                 !!! over itwo
      IF(ITWO.EQ.2)THEN
      ALLOCATE(IHYBMATP(2,NPACKHYB))
      ALLOCATE(VHYBMATP(NPACKHYB))
	SIZE_MEM=SIZE_MEM+DBLE(SIZE(VHYBMATP)*LENCMP)/1024.D0**2
     &                 +DBLE(SIZE(IHYBMATP)*LENINT)/1024.D0**2
      ENDIF
      IPACK=0
      DO IHYB=1,NHYB                              !!! over hyb states
	DO IFOCSN=1,NCUTIMPN
	DO IFOCSM=1,NCUTIMPM
      FMATIMPD(IFOCSM,IFOCSN)=(0.D0,0.D0)
      ENDDO
	ENDDO
	NMATC=0
	DO IDEG=1,NDEG                              !!! over imp states
	DO IMAT=1,NMATIMPP(IDEG)
	IFOCSM=IMATIMPL(1,IMAT+NMATC)
	IFOCSN=IMATIMPL(2,IMAT+NMATC)
	IF(IFOCSM.GT.NCUTIMPM)CYCLE
	IF(IFOCSN.GT.NCUTIMPN)CYCLE
	FMATIMPD(IFOCSM,IFOCSN)=FMATIMPD(IFOCSM,IFOCSN)+
     &FMATIMPL(IMAT+NMATC)*VHYB(IDEG,IHYB)
	ENDDO
	NMATC=NMATC+NMATIMPP(IDEG)
	ENDDO                                       !!! over imp states
	DO IFOCSN=1,NCUTIMPN
	DO IFOCSM=1,NCUTIMPM
	IF(ABS(FMATIMPD(IFOCSM,IFOCSN)).LE.EPSMAT)CYCLE
C Looping over bath states	
	DO IFOCBN=1,NCUTBATN
	IF(IPCLSG(IFOCSN,IFOCBN).EQ.0)CYCLE
	IFOCBP=ABS(ICBATN(IHYB,IFOCBN))
      IF(IFOCBP.EQ.0.OR.IFOCBP.GT.NCUTBATP)CYCLE
	IF(IPCLSF(IFOCSM,IFOCBP).EQ.0)CYCLE
	ISIGN=ICBATN(IHYB,IFOCBN)/IFOCBP*(-1)**NOCCIMPM
	IFOCG=IPCLSG(IFOCSN,IFOCBN)
	IFOCF=IPCLSF(IFOCSM,IFOCBP)
C	VMAT(IFOCG,IFOCF)=FMATIMPD(IFOCSM,IFOCSN)*ISIGN
      IPACK=IPACK+1
      IF(THYBMAT0(IFOCF,IFOCG).EQ.'1'.AND.ITWO.EQ.1)
     &CALL FULLSTOP('<RAT_CLSDIAG_HMAT>:: ERROR IN THYBMAT0')
      THYBMAT0(IFOCF,IFOCG)='1'
      IF(ITWO.EQ.2)THEN
      IHYBMATP(1,IPACK)=IFOCF
      IHYBMATP(2,IPACK)=IFOCG
      VHYBMATP(IPACK)=FMATIMPD(IFOCSM,IFOCSN)*ISIGN
      ENDIF
	ENDDO
	ENDDO
	ENDDO
	ENDDO                                       !!! over ihyb states
      NPACKHYB=IPACK
      ENDDO                                       !!! over itwo
	DEALLOCATE(NMATIMPP,FMATIMPL,IMATIMPL)
C Compute pointer arrays subdiagonalizing giving hamiltonian	
      ALLOCATE(IPBLKG(NFOCCLSG))
      ALLOCATE(IPBLKF(NFOCCLSF))
      DO IFOCG=1,NFOCCLSG
      IPBLKG(IFOCG)=0
      ENDDO
      DO IFOCF=1,NFOCCLSF
      IPBLKF(IFOCF)=0
      ENDDO
      IERR=0
C Looping over subblocks
      NBLK=0
  10  NBLK=NBLK+1    
      NELM=1
      DO IFOCG=1,NFOCCLSG
      IF(IPBLKG(IFOCG).LT.0)CYCLE
      IF(IPBLKG(IFOCG).EQ.0)IPBLKG(IFOCG)=NELM
      IF(IPBLKG(IFOCG).EQ.NELM)EXIT
      ENDDO
C Looping over elements of the subblock
 100  IFLG=0
      DO IFOCG=1,NFOCCLSG
      IF(IPBLKG(IFOCG).LT.0)CYCLE    !!! skip previous blocks
      IF(IPBLKG(IFOCG).NE.NELM)CYCLE !!! select given element
C Find all new elements created by given element
      DO IFOCF=1,NFOCCLSF
      IF(THYBMAT0(IFOCF,IFOCG).EQ.'0')CYCLE
      IFLG=1
      IPBLKF(IFOCF)=NELM+IFLG
      DO JFOCG=1,NFOCCLSG
      IF(THYBMAT0(IFOCF,JFOCG).EQ.'1'.AND.IPBLKG(JFOCG).EQ.0)THEN
      IFLG=1
      IPBLKG(JFOCG)=NELM+IFLG        !!! new elements created by current element
      ELSEIF(THYBMAT0(IFOCF,JFOCG).EQ.'1'.AND.
     &      (IPBLKG(JFOCG).LT.0.OR.IPBLKF(IFOCF).LT.0))THEN
      IERR=1
      ENDIF
      ENDDO
      ENDDO
      ENDDO
      IF(IFLG.EQ.0)GOTO 200
      NELM=NELM+IFLG
      GOTO 100
 200  CONTINUE
      IEXITF=0
      DO IFOCF=1,NFOCCLSF
      IF(IPBLKF(IFOCF).GT.0)IPBLKF(IFOCF)=-NBLK
      IF(IPBLKF(IFOCF).NE.0)IEXITF=IEXITF+1
      ENDDO
      IEXITG=0
      DO IFOCG=1,NFOCCLSG
      IF(IPBLKG(IFOCG).GT.0)IPBLKG(IFOCG)=-NBLK
      IF(IPBLKG(IFOCG).NE.0)IEXITG=IEXITG+1
      ENDDO
      IF(IEXITG.EQ.NFOCCLSG)GOTO 300
      GOTO 10
 300  CONTINUE
      IF(IERR.EQ.1)
     &CALL FULLSTOP('<RAT_MATCLS>:: Error in subblocks')
      DO IFOCG=1,NFOCCLSG
      IPBLKG(IFOCG)=-IPBLKG(IFOCG)
      ENDDO
      DO IFOCF=1,NFOCCLSF
      IPBLKF(IFOCF)=-IPBLKF(IFOCF)
      ENDDO
C Elements which do not hybridize in F block
      NDIAGF=0
      DO IFOCF=1,NFOCCLSF
      IF(IPBLKF(IFOCF).EQ.0)NDIAGF=NDIAGF+1
      ENDDO
C Elements which do not hybridize in G block
      NDIAGG=0
      DO IFOCG=1,NFOCCLSG
      IFLG=0
      IF(IPBLKG(IFOCG).EQ.0)
     &CALL FULLSTOP('<RAT_CLSDIAG> :: ERROR IN IPBLKG')
      DO IFOCF=1,NFOCCLSF
      IF(IPBLKG(IFOCG).EQ.IPBLKF(IFOCF))IFLG=1
      ENDDO
      IF(IFLG.EQ.0)THEN
      IBLK=IPBLKG(IFOCG)
      IPBLKG(IFOCG)=0
      NBLK=NBLK-1
      NDIAGG=NDIAGG+1
      DO JFOCF=1,NFOCCLSF
      IF(IPBLKF(JFOCF).GT.IBLK)IPBLKF(JFOCF)=IPBLKF(JFOCF)-1
      ENDDO
      DO JFOCG=1,NFOCCLSG
      IF(IPBLKG(JFOCG).GT.IBLK)IPBLKG(JFOCG)=IPBLKG(JFOCG)-1
      ENDDO
      ENDIF
      ENDDO
	WRITE(IUN,10210)NFOCCLSG+NFOCCLSF,NBLK
10210	FORMAT(1X,'Matrix dimension =',I7,'; # of subblocks =',I7)
	WRITE(IUN,10220)NDIAGF,NDIAGG
10220	FORMAT(1X,'# of diags(F)    =',I7,'; # of diags(G)  =',I7)
C Store information
      WRITE(IUN,10310)
      WRITE(IUN,10320)DBLE(NFOCCLSF*NFOCCLSG*LENCMP)/1024.D0**2
      WRITE(IUN,10330)DBLE(NPACKHYB*LENCMP)/1024.D0**2+
     &                DBLE(NPACKHYB*LENREL)/1024.D0**2
      WRITE(IUN,10340)SIZE_MEM
10310 FORMAT(1X,'Hybridizaton matrix elements storage:')
10320 FORMAT(1X,'Disk space need (Mb) =',G14.7)
10330 FORMAT(1X,'Disk space used (Mb) =',G14.7)
10340 FORMAT(1X,'Memory allocated(Mb) =',G14.7)
	CALL FIND_LBLANK(SCRFILE(IUCL1),130,NA)
      CALL LIB_TINT(TCH,10,IOCCIMP,ND)
	INQUIRE(FILE=SCRFILE(IUCL1)(:NA)//TCH(:ND),
     &EXIST=EXIST,OPENED=OPEN)
	IF(.NOT.OPEN.AND.EXIST)
     &OPEN(UNIT=IUCL1,FILE=SCRFILE(IUCL1)(:NA)//TCH(:ND),
     &STATUS='OLD',ACCESS='SEQUENTIAL',FORM='UNFORMATTED')
	IF(EXIST)CLOSE(UNIT=IUCL1,STATUS='DELETE')
      OPEN(UNIT=IUCL1,FILE=SCRFILE(IUCL1)(:NA)//TCH(:ND),
     &STATUS='NEW',ACCESS='SEQUENTIAL',FORM='UNFORMATTED')
      WRITE(IUCL1)NFOCCLSF,NFOCCLSG,NPACKHYB,NEXTCLSF,NEXTCLSG
      WRITE(IUCL1)(IPBLKF(IFOCF),IFOCF=1,NFOCCLSF),
     &            (IPBLKG(IFOCG),IFOCG=1,NFOCCLSG),
     &  ((IFCLSF(I,IFOCF),I=1,2),IFOCF=1,NFOCCLSF),
     &  ((IFCLSG(I,IFOCG),I=1,2),IFOCG=1,NFOCCLSG),
     &  ((IECLSF(I,IFOCF),I=1,2),IFOCF=1,NEXTCLSF),
     &  ((IECLSG(I,IFOCG),I=1,2),IFOCG=1,NEXTCLSG)
      WRITE(IUCL1)(SPECCLSF(IFOCF),IFOCF=1,NFOCCLSF),
     &            (SPECCLSG(IFOCG),IFOCG=1,NFOCCLSG),
     &            (SEXTCLSF(IFOCF),IFOCF=1,NEXTCLSF),
     &            (SEXTCLSG(IFOCG),IFOCG=1,NEXTCLSG)
      WRITE(IUCL1)(VHYBMATP(IPACK),IPACK=1,NPACKHYB),
     &  ((IHYBMATP(I,IPACK),I=1,2),IPACK=1,NPACKHYB)
      CLOSE(UNIT=IUCL1,STATUS='KEEP')
	DEALLOCATE(IFBATN,IFBATP,IFCLSG,IFCLSF,IECLSG,IECLSF)
	DEALLOCATE(SPECIMPN,SPECIMPM,SPECBATN,SPECBATP)
	DEALLOCATE(FMATIMPD,SPECCLSG,SPECCLSF,SEXTCLSG,SEXTCLSF)
	DEALLOCATE(THYBMAT0,IHYBMATP,VHYBMATP)
	DEALLOCATE(IPBLKG,IPBLKF,IPCLSG,IPCLSF,ICBATN)
 1000 CONTINUE                                 !!! over impurity occupancies
C Check counters
      MDIMN=0
      MDIMM=0
      DO IOCC=0,NDEG
      MDIMN=MDIMN+NFOCIMP(IOCC)
      MDIMM=MDIMM+NFOCIMP(IOCC-1)
      ENDDO
	IF(MDIMN.NE.MDIMIMPN)
     &CALL FULLSTOP('<RAT_CLSDIAG_HMAT>:: MDIMN.NE.MDIMIMPN')
	IF(MDIMM.NE.MDIMIMPM)
     &CALL FULLSTOP('<RAT_CLSDIAG_HMAT>:: MDIMM.NE.MDIMIMPM')
C MEMORY DEALLOCATIONS
      DEALLOCATE(COMB)
      END






	SUBROUTINE RAT_CLSDIAG_HSUB(NOCCCLS,NFOCCLST,NBLK,IBLOCK)
***************************************************************
*  Subdiagonalize Hamiltonian
***************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_RATPAR  ,ONLY: MODR                                    !!! from readrat
      USE COM_IMPGRF  ,ONLY: CHEM,FILL,KFRM                          !!! from readrat
      USE COM_RATCLS  ,ONLY: LOCCCLS,WCUTBAS,WEXTBAS                 !!! from readrat
     &                      ,NFOCIMP,NCUTIMP,NFOCBAT,NCUTBAT
      USE COM_LSHELL  ,ONLY: LORB,LOCCIMP,SPECIMP
      USE COM_RATHYB  ,ONLY: NHYB,EHYB,VHYB                          !!! from readrat
      USE COM_RATCHN  ,ONLY: IUCL1,IUCL2,IUCL3,IUCL4,IUCL5           !!! from setup
      USE COM_LMTOUT  ,ONLY: SCRFILE                                 !!! from storage
      USE COM_MASHDEP ,ONLY: NVAL                                    !!! from setup
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                         !!! from setup
      IMPLICIT REAL*8 (A-H,O-Z)
C PASSED ARRAYS
      INTEGER IBLOCK(NFOCCLST)
C SET LOCAL VARIABLES
	INTEGER, ALLOCATABLE :: IPBLKG(:)
	INTEGER, ALLOCATABLE :: IPBLKF(:)
      INTEGER, ALLOCATABLE :: IPBLKT(:,:)
      INTEGER, ALLOCATABLE :: IRBLKT(:,:)
      INTEGER, ALLOCATABLE :: NDCLST(:,:)
	COMPLEX*16 DIM
	CHARACTER TMS*2,TCH*10
	LOGICAL EXIST,OPEN,RAT_CLSDIAG_SKIP
	DATA PI/3.141592653589793D0/,DIM/(0.D0,1.D0)/
C *************************************
C Check for returns
      IF(MOD(MODR,10).EQ.2)THEN ! no block diagonalization necessary
      DO IFOCT=1,NFOCCLST
      IBLOCK(IFOCT)=1
      ENDDO
      NBLK=1
	WRITE(IUN,10110)NFOCCLST,NBLK
	RETURN
      ENDIF
C MEMORY ALLOCATIONS
      NDEG=2*(2*LORB+1)
      ALLOCATE(NDCLST(2,0:NDEG))
C Compute pointer array subdiagonalizing the Hamiltonian
      ALLOCATE(IPBLKT(2,NFOCCLST))
      DO IFOCT=1,NFOCCLST
      IPBLKT(1,IFOCT)=0
      IPBLKT(2,IFOCT)=0
      ENDDO
	DO IOCC=0,NDEG
	NDCLST(1,IOCC)=0
	NDCLST(2,IOCC)=0
	ENDDO
      NDIMT=0
      DO IOCC=0,NDEG                      !!! over impurity occupancies
	NOCCIMPN=IOCC
	NOCCIMPM=NOCCIMPN-1
	NOCCBATN=NOCCCLS-NOCCIMPN
	NOCCBATP=NOCCCLS-NOCCIMPM
      IF(RAT_CLSDIAG_SKIP(NOCCCLS,IOCC))CYCLE
	CALL FIND_LBLANK(SCRFILE(IUCL1),130,NA)
	CALL LIB_TINT(TCH,10,IOCC,ND)
      OPEN(UNIT=IUCL1,FILE=SCRFILE(IUCL1)(:NA)//TCH(:ND),STATUS='OLD',
     &ACCESS='SEQUENTIAL',FORM='UNFORMATTED')
      READ(IUCL1)NFOCCLSF,NFOCCLSG
      ALLOCATE(IPBLKF(NFOCCLSF))
      ALLOCATE(IPBLKG(NFOCCLSG))
      READ(IUCL1)(IPBLKF(IFOCF),IFOCF=1,NFOCCLSF),
     &           (IPBLKG(IFOCG),IFOCG=1,NFOCCLSG)
      READ(IUCL1)
      READ(IUCL1)
      CLOSE(UNIT=IUCL1,STATUS='KEEP')
      NDCLST(1,IOCC)=NFOCCLSF
      NDCLST(2,IOCC)=NFOCCLSG
      IF(NDIMT.EQ.0)NDIMT=NFOCCLSF
      DO IFOCF=1,NFOCCLSF
      IFOCT=IFOCF+NDIMT-NFOCCLSF
      IPBLKT(2,IFOCT)=IPBLKF(IFOCF)
      IF(NDIMT.EQ.NFOCCLSF)
     &IPBLKT(1,IFOCT)=IPBLKF(IFOCF) ! copy first F block
      ENDDO
      DO IFOCG=1,NFOCCLSG
      IFOCT=IFOCG+NDIMT
      IPBLKT(1,IFOCT)=IPBLKG(IFOCG)
      IF(NDIMT.EQ.NFOCCLST-NFOCCLSG)
     &IPBLKT(2,IFOCT)=IPBLKG(IFOCG) ! copy last G block
      ENDDO
      NDIMT=NDIMT+NFOCCLSG
      DEALLOCATE(IPBLKF,IPBLKG)
      ENDDO                                    !!! over impurity occupancies
	IF(NDIMT.NE.NFOCCLST)
     &CALL FULLSTOP('<RAT_CLSDIAG_HSUB>:: NDIMT.NE.NFOCCLST')
C Recognize subblocks
      ALLOCATE(IRBLKT(2,NFOCCLST))
      DO IFOCT=1,NFOCCLST
      IBLOCK(IFOCT)=0
      IRBLKT(1,IFOCT)=IPBLKT(1,IFOCT)
      IRBLKT(2,IFOCT)=IPBLKT(2,IFOCT)
      ENDDO
      IERR=0
      NBLK=0
   10 NBLK=NBLK+1
      IF(NBLK.GT.NFOCCLST+1)
     &CALL FULLSTOP('<RAT_CLSDIAG_HSUB>:: Error in NBLK')
C Find Parent Element in row 1 which was not considered before 
      NDIMT=0
      IEXIT=0
      DO IOCC=0,NDEG         !!! over impurity occupancies
      NFOCCLSF=NDCLST(1,IOCC)
      NFOCCLSG=NDCLST(2,IOCC)
      IF(NFOCCLSF.EQ.0)CYCLE
      IF(NDIMT.EQ.0)NDIMT=NFOCCLSF
      DO IFOCF=1,NFOCCLSF
      IFOCT=IFOCF+NDIMT-NFOCCLSF
C Case when F in row 1 is non-zero
      IF(IRBLKT(1,IFOCT).GT.0)IEXIT=1
      IF(IRBLKT(1,IFOCT).GT.0)
     &IRBLKT(1,IFOCT)=-IRBLKT(1,IFOCT)
C Case when F in row 1 is zero but F in row 2 is non zero
      IF(IRBLKT(1,IFOCT).EQ.0.AND.IRBLKT(2,IFOCT).GT.0)IEXIT=1
      IF(IRBLKT(1,IFOCT).EQ.0.AND.IRBLKT(2,IFOCT).GT.0)
     &IRBLKT(1,IFOCT)=-NFOCCLST ! -IRBLKT(2,IFOCT)
C
      IF(IEXIT.EQ.1)EXIT
      ENDDO
      IF(IEXIT.EQ.1)EXIT
      NDIMT=NDIMT+NFOCCLSG
      ENDDO                  !!! over impurity occupancies
      IF(IEXIT.EQ.0)NBLK=NBLK-1
      IF(IEXIT.EQ.0)GOTO 100 !!! exit the cycle
C Loop over "F" and "G" Elements
      NDIMT=0
      DO IOCC=0,NDEG            !!! over impurity occupancies
      NFOCCLSF=NDCLST(1,IOCC)
      NFOCCLSG=NDCLST(2,IOCC)
      IF(NFOCCLSF.EQ.0)CYCLE
      IF(NDIMT.EQ.0)NDIMT=NFOCCLSF
C Find all childs in row 2 of F column made by parent in row 1 of F column
      DO IFOCF=1,NFOCCLSF
      IFOCT=IFOCF+NDIMT-NFOCCLSF
      IF(IRBLKT(1,IFOCT).GE.0)CYCLE ! select either parent in 1F or a child made below in 1F
      IF(IRBLKT(2,IFOCT).NE.0)     ! if child is non zero
     &IRBLKT(2,IFOCT)=-ABS(IRBLKT(2,IFOCT))
      IF(IRBLKT(2,IFOCT).EQ.0)     ! if child is zero
     &IRBLKT(2,IFOCT)=-NFOCCLST
C Now child is found, copy this child to all elements in F1,F2 column
      DO JFOCF=1,NFOCCLSF
      JFOCT=JFOCF+NDIMT-NFOCCLSF
      IF(ABS(IRBLKT(2,JFOCT)).NE.ABS(IRBLKT(2,IFOCT)))CYCLE
C Made a new child in F2
      IRBLKT(2,JFOCT)=-ABS(IRBLKT(2,JFOCT))
C Check F1 too and made child if necessary
      IF(IRBLKT(1,JFOCT).GT.0.AND.JFOCT.LT.IFOCT)
     &IERR=1
      IF(IRBLKT(1,JFOCT).NE.0)
     &IRBLKT(1,JFOCT)=-ABS(IRBLKT(1,JFOCT))
      IF(IRBLKT(1,JFOCT).EQ.0)
     &IRBLKT(1,JFOCT)=-NFOCCLST
      ENDDO
      ENDDO
C Associate each negative element in column F of row 2 with column G of row 1
      DO IFOCG=1,NFOCCLSG
      IFOCT=IFOCG+NDIMT
      DO JFOCF=1,NFOCCLSF
      JFOCT=JFOCF+NDIMT-NFOCCLSF
      IF(IRBLKT(2,JFOCT).GT.0)CYCLE
      IF(ABS(IRBLKT(1,IFOCT)).EQ.ABS(IRBLKT(2,JFOCT)))
     &IRBLKT(1,IFOCT)=-ABS(IRBLKT(1,IFOCT))
      ENDDO
      ENDDO
      NDIMT=NDIMT+NFOCCLSG
      ENDDO                                    !!! over impurity occupancies
	IF(NDIMT.NE.NFOCCLST)
     &CALL FULLSTOP('<RAT_CLSDIAG_HSUB>:: NDIMT.NE.NFOCCLST')
C Copy information
      DO IFOCT=1,NFOCCLST
      IF(IRBLKT(1,IFOCT).LT.0)THEN
      IBLOCK(IFOCT)=NBLK
      IRBLKT(1,IFOCT)=0
      IRBLKT(2,IFOCT)=0
      ENDIF
      ENDDO
      GOTO 10
  100 CONTINUE
C Check for errors in the algorithm
      IF(IERR.EQ.1)
     &WRITE(IUT,*)'Error 1 in Subdiagonalization algorithm'
C Check for errors: if the block has dimension 1, it is diagonal
      MBLK=NBLK
      DO IBLK=1,NBLK
      NDIM=0
      DO IFOCT=1,NFOCCLST
      IF(IBLOCK(IFOCT).EQ.IBLK)NDIM=NDIM+1
      ENDDO
      IF(NDIM.NE.1)CYCLE
      MBLK=MBLK-1
      IERR=2
      DO IFOCT=1,NFOCCLST
      IF(IBLOCK(IFOCT).EQ.IBLK)IBLOCK(IFOCT)=0
      ENDDO
      ENDDO
      IF(IERR.EQ.2)
     &WRITE(IUT,*)'Error 2 in Subdiagonalization algorithm'
C Renumerate blocks
      KBLK=0
      DO IBLK=1,NBLK
      NDIM=0
      DO IFOCT=1,NFOCCLST
      IF(IBLOCK(IFOCT).EQ.IBLK)NDIM=NDIM+1
      ENDDO
      IF(NDIM.EQ.0)CYCLE
      IF(NDIM.EQ.1)
     &CALL FULLSTOP('<RAT_CLSDIAG_HSUB>:: ERROR NDIM.EQ.1')
      KBLK=KBLK+1
      DO IFOCT=1,NFOCCLST
      IF(IBLOCK(IFOCT).EQ.IBLK)IBLOCK(IFOCT)=KBLK
      ENDDO
      ENDDO
      IF(KBLK.NE.MBLK)
     &CALL FULLSTOP('<RAT_CLSDIAG_HSUB>:: KBLK.NE.MBLK')
      NBLK=KBLK
C Print # of blocks
      MAXD=0
      DO IBLK=1,NBLK
      NDIM=0
      DO IFOCT=1,NFOCCLST
      IF(IBLOCK(IFOCT).EQ.IBLK)NDIM=NDIM+1
      ENDDO
      MAXD=MAX(NDIM,MAXD)
      ENDDO
      NDIG=0
      DO IFOCT=1,NFOCCLST
      IF(IBLOCK(IFOCT).EQ.0)NDIG=NDIG+1
      ENDDO
	WRITE(IUN,10110)NFOCCLST,NBLK
10110	FORMAT(1X,'Total  dimension =',I7,'; # of subblocks =',I7)
	WRITE(IUN,10120)MAXD,NDIG
10120	FORMAT(1X,'Max.subblock dim =',I7,'; # of diagonals =',I7)
C MEMORY DEALLOCATIONS
      DEALLOCATE(IPBLKT,IRBLKT,NDCLST)
      END








	SUBROUTINE RAT_CLSDIAG_DIAG(NOCCCLS,NFOCCLST,NEXTCLST,
     &           NBLK,IBLOCK,IPNTCLST)
***************************************************************
*  Subdiagonalize the Hamiltonian
***************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_RATPAR  ,ONLY: EPSZIP                                  !!! from readrat
      USE COM_IMPGRF  ,ONLY: CHEM,FILL,KFRM                          !!! from readrat
      USE COM_RATCLS  ,ONLY: LOCCCLS,WCUTBAS,WEXTBAS                 !!! from readrat
     &                      ,NFOCIMP,NCUTIMP,NFOCBAT,NCUTBAT
      USE COM_LSHELL  ,ONLY: LORB,LOCCIMP,SPECIMP
      USE COM_RATHYB  ,ONLY: NHYB,EHYB,VHYB                          !!! from readrat
      USE COM_RATCHN  ,ONLY: IUCL1,IUCL2,IUCL3,IUCL4,IUCL5           !!! from setup
      USE COM_LMTOUT  ,ONLY: SCRFILE                                 !!! from storage
      USE COM_RATOUT  ,ONLY: ICCLS,CLSFILE                           !!! from storage
      USE COM_MASHDEP ,ONLY: NVAL,LENCMP,LENREL,LENINT               !!! from setup
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                         !!! from setup
      IMPLICIT REAL*8 (A-H,O-Z)
C PASSED ARRAYS
      INTEGER IBLOCK(NFOCCLST),IPNTCLST(2,NFOCCLST)
C SET LOCAL VARIABLES
	INTEGER, ALLOCATABLE :: IPBLKG(:)
	INTEGER, ALLOCATABLE :: IPBLKF(:)
	INTEGER, ALLOCATABLE :: IFCLSG(:,:)
	INTEGER, ALLOCATABLE :: IFCLSF(:,:)
	INTEGER, ALLOCATABLE :: IECLSG(:,:)
	INTEGER, ALLOCATABLE :: IECLSF(:,:)
	INTEGER, ALLOCATABLE :: IECLST(:,:)
	INTEGER, ALLOCATABLE :: IDIMF(:)
	INTEGER, ALLOCATABLE :: IDIMG(:)
	INTEGER, ALLOCATABLE :: IHYBMATP(:,:)
	INTEGER, ALLOCATABLE :: IVECCLSB(:,:)
      INTEGER, ALLOCATABLE :: IPNTCLSB(:,:)
      INTEGER, ALLOCATABLE :: NFOCCLSD(:)
      INTEGER, ALLOCATABLE :: NEXTCLSD(:)
      REAL*8, ALLOCATABLE :: SPECCLSB(:)
      REAL*8, ALLOCATABLE :: SPECDIAG(:)
      REAL*8, ALLOCATABLE :: SPECCLSF(:)
      REAL*8, ALLOCATABLE :: SPECCLSG(:)
      REAL*8, ALLOCATABLE :: SEXTCLSF(:)
      REAL*8, ALLOCATABLE :: SEXTCLSG(:)
      REAL*8, ALLOCATABLE :: SEXTCLST(:)
      COMPLEX*16, ALLOCATABLE :: HMATCLSB(:,:)
      COMPLEX*16, ALLOCATABLE :: OMATCLSB(:,:)
      COMPLEX*16, ALLOCATABLE :: VHYBMATP(:)
      COMPLEX*16, ALLOCATABLE :: AVECCLSB(:)
	COMPLEX*16 DIM
	CHARACTER TMS*2,TNC*10,TNB*10,CFILE*130
	LOGICAL EXIST,OPEN,RAT_CLSDIAG_SKIP
	DATA PI/3.141592653589793D0/,DIM/(0.D0,1.D0)/
C *************************************
C MEMORY ALLOCATIONS
      NDEG=2*(2*LORB+1)
      ALLOCATE(NFOCCLSD(0:NDEG))
      ALLOCATE(NEXTCLSD(0:NDEG))
      ALLOCATE(SEXTCLST(NEXTCLST))
      ALLOCATE(IECLST(2,NEXTCLST))
      DO IFOC=1,NEXTCLST
      IECLST(1,IFOC)=-1
      IECLST(2,IFOC)=-1
      SEXTCLST(IFOC)=0.D0
      ENDDO
      DO IOCC=0,NDEG
      NFOCCLSD(IOCC)=0
      NEXTCLSD(IOCC)=0
      ENDDO
      DO IFOCT=1,NFOCCLST
      IPNTCLST(1,IFOCT)=-1
      IPNTCLST(2,IFOCT)=-1
      ENDDO      
C DIAGONALIZE FOR GIVEN BLOCK
      SIZE_HMAT=0.D0
      DO 2000 IBLK=1,NBLK          !!! over iblk
      NFOCCLSB=0
      DO IFOCT=1,NFOCCLST
      IF(IBLOCK(IFOCT).EQ.IBLK)NFOCCLSB=NFOCCLSB+1
      ENDDO
      WRITE(IUN,10010)IBLK,NFOCCLSB
10010 FORMAT(1X,'Exact.Diag: block, dimension =',I7,1X,I7)
      ALLOCATE(SPECCLSB(NFOCCLSB))
      ALLOCATE(HMATCLSB(NFOCCLSB,NFOCCLSB))
      ALLOCATE(OMATCLSB(NFOCCLSB,NFOCCLSB))
      ALLOCATE(IPNTCLSB(2,NFOCCLSB))
      DO IDIM=1,NFOCCLSB
      SPECCLSB(IDIM)=0.D0
      IPNTCLSB(1,IDIM)=0
      IPNTCLSB(2,IDIM)=0
      DO JDIM=1,NFOCCLSB
      HMATCLSB(IDIM,JDIM)=(0.D0,0.D0)  
      OMATCLSB(IDIM,JDIM)=(0.D0,0.D0)  
      ENDDO
      OMATCLSB(IDIM,IDIM)=(1.D0,0.D0)  
      ENDDO
C Compute contribution to the hamiltonian from each occupancy
      NDIMT=0
      DO 1000 IOCC=0,NDEG                   !!! over impurity occupancies
	NOCCIMPN=IOCC
	NOCCIMPM=NOCCIMPN-1
	NOCCBATN=NOCCCLS-NOCCIMPN
	NOCCBATP=NOCCCLS-NOCCIMPM
      IF(RAT_CLSDIAG_SKIP(NOCCCLS,IOCC))GOTO 1000
	CALL FIND_LBLANK(SCRFILE(IUCL1),130,NA)
      CALL LIB_TINT(TNC,10,IOCC,NC)
      OPEN(UNIT=IUCL1,FILE=SCRFILE(IUCL1)(:NA)//TNC(:NC),
     &STATUS='OLD',ACCESS='SEQUENTIAL',FORM='UNFORMATTED')
      READ(IUCL1)NFOCCLSF,NFOCCLSG,NPACKHYB
      ALLOCATE(IPBLKF(NFOCCLSF))
      ALLOCATE(IPBLKG(NFOCCLSG))
      ALLOCATE(IFCLSF(2,NFOCCLSF))
      ALLOCATE(IFCLSG(2,NFOCCLSG))
      ALLOCATE(SPECCLSF(NFOCCLSF))
      ALLOCATE(SPECCLSG(NFOCCLSG))
      ALLOCATE(IHYBMATP(2,NPACKHYB))
      ALLOCATE(VHYBMATP(NPACKHYB))
      READ(IUCL1)(IPBLKF(IFOCF),IFOCF=1,NFOCCLSF),
     &           (IPBLKG(IFOCG),IFOCG=1,NFOCCLSG),
     & ((IFCLSF(I,IFOCF),I=1,2),IFOCF=1,NFOCCLSF),
     & ((IFCLSG(I,IFOCG),I=1,2),IFOCG=1,NFOCCLSG)
      READ(IUCL1)(SPECCLSF(IFOCF),IFOCF=1,NFOCCLSF),
     &           (SPECCLSG(IFOCG),IFOCG=1,NFOCCLSG)
      READ(IUCL1)(VHYBMATP(IPACK),IPACK=1,NPACKHYB),
     &((IHYBMATP(I,IPACK),I=1,2),IPACK=1,NPACKHYB)
      CLOSE(UNIT=IUCL1,STATUS='KEEP')
C Calculate dimensional arrays
      IF(NDIMT.EQ.0)NDIMT=NFOCCLSF
      LDIM=0
      DO IFOCT=1,NDIMT-NFOCCLSF
      IF(IBLOCK(IFOCT).NE.IBLK)CYCLE
      LDIM=LDIM+1
      ENDDO
      ALLOCATE(IDIMF(NFOCCLSF))
      IDIM=0
      DO IFOCF=1,NFOCCLSF
      IFOCT=IFOCF+NDIMT-NFOCCLSF
      IDIMF(IFOCF)=0
      IF(IBLOCK(IFOCT).NE.IBLK)CYCLE
      IDIM=IDIM+1
      IDIMF(IFOCF)=IDIM
      ENDDO
      NDIMF=IDIM
      ALLOCATE(IDIMG(NFOCCLSG))
      IDIM=0
      DO IFOCG=1,NFOCCLSG
      IFOCT=IFOCG+NDIMT
      IDIMG(IFOCG)=0
      IF(IBLOCK(IFOCT).NE.IBLK)CYCLE
      IDIM=IDIM+1
      IDIMG(IFOCG)=IDIM
      ENDDO
      NDIMG=IDIM 
C Compute diagonal elements of the hamiltonian
      DO IFOCF=1,NFOCCLSF
      IFOCT=IFOCF+NDIMT-NFOCCLSF
      IF(IBLOCK(IFOCT).NE.IBLK)CYCLE
      IDIM=IDIMF(IFOCF)+LDIM
      HMATCLSB(IDIM,IDIM)=SPECCLSF(IFOCF)
      IPNTCLSB(1,IDIM)=IFCLSF(1,IFOCF)
      IPNTCLSB(2,IDIM)=IFCLSF(2,IFOCF)
      IPNTCLST(1,IFOCT)=IFCLSF(1,IFOCF)
      IPNTCLST(2,IFOCT)=IFCLSF(2,IFOCF)
      ENDDO
      DO IFOCG=1,NFOCCLSG
      IFOCT=IFOCG+NDIMT
      IF(IBLOCK(IFOCT).NE.IBLK)CYCLE
      IDIM=IDIMG(IFOCG)+LDIM+NDIMF
      HMATCLSB(IDIM,IDIM)=SPECCLSG(IFOCG)
      IPNTCLSB(1,IDIM)=IFCLSG(1,IFOCG)
      IPNTCLSB(2,IDIM)=IFCLSG(2,IFOCG)
      IPNTCLST(1,IFOCT)=IFCLSG(1,IFOCG)
      IPNTCLST(2,IFOCT)=IFCLSG(2,IFOCG)
      ENDDO
C Compute hybridization matrix elements
      DO IPACK=1,NPACKHYB
      IFOCF=IHYBMATP(1,IPACK)
      IFOCT=IFOCF+NDIMT-NFOCCLSF      
      IF(IBLOCK(IFOCT).NE.IBLK)CYCLE
      IDIM=IDIMF(IFOCF)+LDIM
      JFOCG=IHYBMATP(2,IPACK)
      JFOCT=JFOCG+NDIMT
      IF(IBLOCK(JFOCT).NE.IBLK)CYCLE
      JDIM=IDIMG(JFOCG)+LDIM+NDIMF
      HMATCLSB(IDIM,JDIM)=VHYBMATP(IPACK)
      HMATCLSB(JDIM,IDIM)=DCONJG(VHYBMATP(IPACK))
      ENDDO
      NDIMT=NDIMT+NFOCCLSG
      NFOCCLSD(NOCCIMPN)=NFOCCLSG  ! record dimensions of G and F arrays
      NFOCCLSD(NOCCIMPM)=NFOCCLSF
      DEALLOCATE(IPBLKF,IPBLKG,IHYBMATP,VHYBMATP)
      DEALLOCATE(SPECCLSF,SPECCLSG)
      DEALLOCATE(IDIMG,IDIMF,IFCLSF,IFCLSG)
 1000 CONTINUE              !!! over impurity occupancies
	IF(NDIMT.NE.NFOCCLST)
     &CALL FULLSTOP('<RAT_CLSDIAG_DIAG>:: NDIMT.NE.NFOCCLST')
C Diagonalize given block
      CALL LIB_EIGEN1C(NFOCCLSB,HMATCLSB,OMATCLSB,SPECCLSB,
     &                 1,1,1,IERR,0,1.D-07)
      IF(IERR.NE.0)
     &CALL FULLSTOP('<RAT_CLSDIAG_DIAG>:: Eigen failed')
C Pack Eigenvectors
      IVEC=0
      DO IBND=1,NFOCCLSB
      DO IFOC=1,NFOCCLSB
      IF(ABS(OMATCLSB(IFOC,IBND)).LE.EPSZIP)CYCLE
      IVEC=IVEC+1
      ENDDO
      ENDDO
      NVECCLSB=IVEC
      ALLOCATE(AVECCLSB(NVECCLSB))
      ALLOCATE(IVECCLSB(2,NVECCLSB))
      IVEC=0
      DO IBND=1,NFOCCLSB
      DO IFOC=1,NFOCCLSB
      IF(ABS(OMATCLSB(IFOC,IBND)).LE.EPSZIP)CYCLE
      IVEC=IVEC+1
      IVECCLSB(1,IVEC)=IFOC
      IVECCLSB(2,IVEC)=IBND
      AVECCLSB(IVEC)=OMATCLSB(IFOC,IBND)
      ENDDO
      ENDDO
C Store eigenstates
      CALL LIB_TINT(TNC,10,NOCCCLS,NC)
      CALL LIB_TINT(TNB,10,IBLK,NB)
      IF(ICCLS.EQ.0)CFILE=SCRFILE(IUCL2)
      IF(ICCLS.GT.0)CFILE=CLSFILE
      CALL FIND_LBLANK(CFILE,130,NA)
	INQUIRE(FILE=CFILE(:NA)//'_'//TNC(:NC)//'_'//
     &TNB(:NB),EXIST=EXIST,OPENED=OPEN)
	IF(.NOT.OPEN.AND.EXIST)
     &OPEN(UNIT=IUCL2,FILE=CFILE(:NA)//'_'//TNC(:NC)//'_'//
     &TNB(:NB),STATUS='OLD',ACCESS='SEQUENTIAL',FORM='UNFORMATTED')
	IF(EXIST)CLOSE(UNIT=IUCL2,STATUS='DELETE')
      OPEN(UNIT=IUCL2,FILE=CFILE(:NA)//'_'//TNC(:NC)//'_'//
     &TNB(:NB),STATUS='NEW',ACCESS='SEQUENTIAL',FORM='UNFORMATTED')
      WRITE(IUCL2)NFOCCLSB,NVECCLSB
      WRITE(IUCL2)(SPECCLSB(IDIM),IDIM=1,NFOCCLSB),
     &((IPNTCLSB(I,IDIM),I=1,2),IDIM=1,NFOCCLSB),
     &((IVECCLSB(I,IVEC),I=1,2),IVEC=1,NVECCLSB),
     &          (AVECCLSB(IVEC),IVEC=1,NVECCLSB)
      SIZE_HMAT=SIZE_HMAT+DBLE(NVECCLSB*(LENCMP+2*LENINT))/1024.D0**2
      CLOSE(UNIT=IUCL2,STATUS='KEEP')
      DEALLOCATE(SPECCLSB,HMATCLSB,OMATCLSB,AVECCLSB,IVECCLSB,IPNTCLSB)
 2000 CONTINUE                     !!! over iblk
C All blocks done, save diagonals
      NDIAG=0
      DO IFOCT=1,NFOCCLST
      IF(IBLOCK(IFOCT).EQ.0)NDIAG=NDIAG+1
      ENDDO
      ALLOCATE(SPECDIAG(NDIAG))
      ALLOCATE(IPNTCLSB(2,NDIAG))
      ALLOCATE(IVECCLSB(2,NDIAG))
      ALLOCATE(AVECCLSB(NDIAG))
      DO IDIAG=1,NDIAG
      IVECCLSB(1,IDIAG)=IDIAG
      IVECCLSB(2,IDIAG)=IDIAG
      AVECCLSB(IDIAG)=(1.D0,0.D0)
      ENDDO
      IBLK=0
      NDIMT=0
      NEXTT=0
      DO 3000 IOCC=0,NDEG                   !!! over impurity occupancies
	NOCCIMPN=IOCC
	NOCCIMPM=NOCCIMPN-1
	NOCCBATN=NOCCCLS-NOCCIMPN
	NOCCBATP=NOCCCLS-NOCCIMPM
      IF(RAT_CLSDIAG_SKIP(NOCCCLS,IOCC))GOTO 3000
	CALL FIND_LBLANK(SCRFILE(IUCL1),130,NA)
      CALL LIB_TINT(TNC,10,IOCC,NC)
      OPEN(UNIT=IUCL1,FILE=SCRFILE(IUCL1)(:NA)//TNC(:NC),
     &STATUS='OLD',ACCESS='SEQUENTIAL',FORM='UNFORMATTED')
      READ(IUCL1)NFOCCLSF,NFOCCLSG,NPACKHYB,NEXTCLSF,NEXTCLSG
      ALLOCATE(IPBLKF(NFOCCLSF))
      ALLOCATE(IPBLKG(NFOCCLSG))
      ALLOCATE(IFCLSF(2,NFOCCLSF))
      ALLOCATE(IFCLSG(2,NFOCCLSG))
      ALLOCATE(IECLSF(2,NEXTCLSF))
      ALLOCATE(IECLSG(2,NEXTCLSG))
      ALLOCATE(SPECCLSF(NFOCCLSF))
      ALLOCATE(SPECCLSG(NFOCCLSG))
      ALLOCATE(SEXTCLSF(NEXTCLSF))
      ALLOCATE(SEXTCLSG(NEXTCLSG))
      READ(IUCL1)(IPBLKF(IFOCF),IFOCF=1,NFOCCLSF),
     &           (IPBLKG(IFOCG),IFOCG=1,NFOCCLSG),
     & ((IFCLSF(I,IFOCF),I=1,2),IFOCF=1,NFOCCLSF),
     & ((IFCLSG(I,IFOCG),I=1,2),IFOCG=1,NFOCCLSG),
     & ((IECLSF(I,IFOCF),I=1,2),IFOCF=1,NEXTCLSF),
     & ((IECLSG(I,IFOCG),I=1,2),IFOCG=1,NEXTCLSG)
      READ(IUCL1)(SPECCLSF(IFOCF),IFOCF=1,NFOCCLSF),
     &           (SPECCLSG(IFOCG),IFOCG=1,NFOCCLSG),
     &           (SEXTCLSF(IFOCF),IFOCF=1,NEXTCLSF),
     &           (SEXTCLSG(IFOCG),IFOCG=1,NEXTCLSG)
      CLOSE(UNIT=IUCL1,STATUS='KEEP')
C Calculate dimensional arrays
      IF(NDIMT.EQ.0)NDIMT=NFOCCLSF
      IF(NEXTT.EQ.0)NEXTT=NEXTCLSF
      LDIM=0
      DO IFOCT=1,NDIMT-NFOCCLSF
      IF(IBLOCK(IFOCT).NE.IBLK)CYCLE
      LDIM=LDIM+1
      ENDDO
      ALLOCATE(IDIMF(NFOCCLSF))
      IDIM=0
      DO IFOCF=1,NFOCCLSF
      IFOCT=IFOCF+NDIMT-NFOCCLSF
      IDIMF(IFOCF)=0
      IF(IBLOCK(IFOCT).NE.IBLK)CYCLE
      IDIM=IDIM+1
      IDIMF(IFOCF)=IDIM
      ENDDO
      NDIMF=IDIM
      ALLOCATE(IDIMG(NFOCCLSG))
      IDIM=0
      DO IFOCG=1,NFOCCLSG
      IFOCT=IFOCG+NDIMT
      IDIMG(IFOCG)=0
      IF(IBLOCK(IFOCT).NE.IBLK)CYCLE
      IDIM=IDIM+1
      IDIMG(IFOCG)=IDIM
      ENDDO
      NDIMG=IDIM 
C Compute diagonal elements of the hamiltonian
      DO IFOCF=1,NFOCCLSF
      IFOCT=IFOCF+NDIMT-NFOCCLSF
      IF(IBLOCK(IFOCT).NE.IBLK)CYCLE
      IDIM=IDIMF(IFOCF)+LDIM
      SPECDIAG(IDIM)=SPECCLSF(IFOCF)
      IPNTCLSB(1,IDIM)=IFCLSF(1,IFOCF)
      IPNTCLSB(2,IDIM)=IFCLSF(2,IFOCF)
      IPNTCLST(1,IFOCT)=IFCLSF(1,IFOCF)
      IPNTCLST(2,IFOCT)=IFCLSF(2,IFOCF)
      ENDDO
      DO IFOCG=1,NFOCCLSG
      IFOCT=IFOCG+NDIMT
      IF(IBLOCK(IFOCT).NE.IBLK)CYCLE
      IDIM=IDIMG(IFOCG)+LDIM+NDIMF
      SPECDIAG(IDIM)=SPECCLSG(IFOCG)
      IPNTCLSB(1,IDIM)=IFCLSG(1,IFOCG)
      IPNTCLSB(2,IDIM)=IFCLSG(2,IFOCG)
      IPNTCLST(1,IFOCT)=IFCLSG(1,IFOCG)
      IPNTCLST(2,IFOCT)=IFCLSG(2,IFOCG)
      ENDDO
C Compute eigenvalues for extended Fock space
      DO IFOCE=1,NEXTCLSF
      IFOCT=IFOCE+NEXTT-NEXTCLSF
      SEXTCLST(IFOCT)=SEXTCLSF(IFOCE)
      IECLST(1,IFOCT)=IECLSF(1,IFOCE)
      IECLST(2,IFOCT)=IECLSF(2,IFOCE)
      ENDDO
      DO IFOCE=1,NEXTCLSG
      IFOCT=IFOCE+NEXTT
      SEXTCLST(IFOCT)=SEXTCLSG(IFOCE)
      IECLST(1,IFOCT)=IECLSG(1,IFOCE)
      IECLST(2,IFOCT)=IECLSG(2,IFOCE)
      ENDDO
      NDIMT=NDIMT+NFOCCLSG
      NFOCCLSD(NOCCIMPN)=NFOCCLSG  ! record dimensions of G and F arrays
      NFOCCLSD(NOCCIMPM)=NFOCCLSF
      NEXTT=NEXTT+NEXTCLSG
      NEXTCLSD(NOCCIMPN)=NEXTCLSG  ! record dimensions of G and F arrays
      NEXTCLSD(NOCCIMPM)=NEXTCLSF
      DEALLOCATE(IPBLKF,IPBLKG,IFCLSF,IFCLSG,SPECCLSF,SPECCLSG)
      DEALLOCATE(IDIMG,IDIMF,SEXTCLSF,SEXTCLSG,IECLSF,IECLSG)
 3000 CONTINUE              !!! over impurity occupancies
C Check errors
	IF(NDIMT.NE.NFOCCLST)
     &CALL FULLSTOP('<RAT_CLSDIAG_DIAG>:: NDIMT.NE.NFOCCLST')
	IF(NEXTT.NE.NEXTCLST)
     &CALL FULLSTOP('<RAT_CLSDIAG_DIAG>:: NEXTT.NE.NEXTCLST')
      DO IFOCT=1,NFOCCLST
      IF(IPNTCLST(1,IFOCT).EQ.-1.OR.IPNTCLST(2,IFOCT).EQ.-1)
     &CALL FULLSTOP('<RAT_CLSDIAG_DIAG>:: Error in IPNTCLST')
      ENDDO
      DO IFOCT=1,NEXTCLST
      IF(IECLST(1,IFOCT).EQ.-1.OR.IECLST(2,IFOCT).EQ.-1)
     &CALL FULLSTOP('<RAT_CLSDIAG_DIAG>:: Error in IECLST')
      ENDDO
      NFOCT=0
      DO IOCC=0,NDEG
      NFOCT=NFOCT+NFOCCLSD(IOCC)
      ENDDO
      IF(NFOCT.NE.NFOCCLST)
     &CALL FULLSTOP('<RAT_CLSDIAG_DIAG>:: Error in NFOCCLSD')
      NFOCT=0
      DO IOCC=0,NDEG
      NFOCT=NFOCT+NEXTCLSD(IOCC)
      ENDDO
      IF(NFOCT.NE.NEXTCLST)
     &CALL FULLSTOP('<RAT_CLSDIAG_DIAG>:: Error in NEXTCLSD')
C Store eigenvalues
      CALL LIB_TINT(TNC,10,NOCCCLS,NC)
      CALL LIB_TINT(TNB,10,0,NB)
      IF(ICCLS.EQ.0)CFILE=SCRFILE(IUCL2)
      IF(ICCLS.GT.0)CFILE=CLSFILE
      CALL FIND_LBLANK(CFILE,130,NA)
	INQUIRE(FILE=CFILE(:NA)//'_'//TNC(:NC)//'_'//
     &TNB(:NB),EXIST=EXIST,OPENED=OPEN)
	IF(.NOT.OPEN.AND.EXIST)
     &OPEN(UNIT=IUCL2,FILE=CFILE(:NA)//'_'//TNC(:NC)//'_'//
     &TNB(:NB),STATUS='OLD',ACCESS='SEQUENTIAL',FORM='UNFORMATTED')
	IF(EXIST)CLOSE(UNIT=IUCL2,STATUS='DELETE')
      OPEN(UNIT=IUCL2,FILE=CFILE(:NA)//'_'//TNC(:NC)//'_'//
     &TNB(:NB),STATUS='NEW',ACCESS='SEQUENTIAL',FORM='UNFORMATTED')
      WRITE(IUCL2)NDIAG,NDIAG,(IBLOCK(IFOCT),IFOCT=1,NFOCCLST),
     &((IPNTCLST(I,IFOCT),I=1,2),IFOCT=1,NFOCCLST),
     &(NFOCCLSD(IOCC),IOCC=0,NDEG)
      WRITE(IUCL2)(SPECDIAG(IDIM),IDIM=1,NDIAG),
     &((IPNTCLSB(I,IDIM),I=1,2),IDIM=1,NDIAG),
     &((IVECCLSB(I,IVEC),I=1,2),IVEC=1,NDIAG),
     &          (AVECCLSB(IVEC),IVEC=1,NDIAG)
      WRITE(IUCL2)NEXTCLST,((IECLST(I,IFOCT),I=1,2),IFOCT=1,NEXTCLST),
     &(NEXTCLSD(IOCC),IOCC=0,NDEG)
      WRITE(IUCL2)(SEXTCLST(IFOCT),IFOCT=1,NEXTCLST)
      CLOSE(UNIT=IUCL2,STATUS='KEEP')
      DEALLOCATE(SPECDIAG,IPNTCLSB,IVECCLSB,AVECCLSB)
C Print storage information
      WRITE(IUN,10110)
      WRITE(IUN,10120)SIZE_HMAT
10110 FORMAT(1X,'Eigenvectors storage:')
10120 FORMAT(1X,'Disk space used (Mb) =',G14.7)
C Erase hamiltonian matrix
      DO IOCC=0,NDEG                   !!! over impurity occupancies
	NOCCIMPN=IOCC
	NOCCIMPM=NOCCIMPN-1
	NOCCBATN=NOCCCLS-NOCCIMPN
	NOCCBATP=NOCCCLS-NOCCIMPM
      IF(RAT_CLSDIAG_SKIP(NOCCCLS,IOCC))CYCLE
	CALL FIND_LBLANK(SCRFILE(IUCL1),130,NA)
      CALL LIB_TINT(TNC,10,IOCC,NC)
      OPEN(UNIT=IUCL1,FILE=SCRFILE(IUCL1)(:NA)//TNC(:NC),
     &STATUS='OLD',ACCESS='SEQUENTIAL',FORM='UNFORMATTED')
      CLOSE(UNIT=IUCL1,STATUS='DELETE')
      ENDDO
C MEMORY DEALLOCATIONS
      DEALLOCATE(SEXTCLST,IECLST,NFOCCLSD,NEXTCLSD)
      END




	SUBROUTINE RAT_CLSDIAG_ORBM(NOCCCLS,NFOCCLST,NBLK,IBLOCK,IPOINT)
***************************************************************
*  Print eigenvalues and quantum numbers
***************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_RATPAR  ,ONLY: KORB,EPSDEG,EPSMAT                      !!! from readrat
      USE COM_IMPGRF  ,ONLY: CHEM,FILL,KFRM                          !!! from readrat
      USE COM_RATCLS  ,ONLY: LOCCCLS,WCUTBAS,WEXTBAS                 !!! from readrat
     &                      ,NFOCIMP,NCUTIMP,NFOCBAT,NCUTBAT
      USE COM_LSHELL  ,ONLY: LORB,LOCCIMP         
      USE COM_RATHYB  ,ONLY: NHYB,EHYB,VHYB,NBST,NDST,TBST           !!! from readrat
      USE COM_RATCHN  ,ONLY: IUAGF,IUCL1,IUCL2,IUCL3,IUCL4,IUCL5     !!! from setup
      USE COM_LMTOUT  ,ONLY: SCRFILE                                 !!! from storage
      USE COM_RATOUT  ,ONLY: ICCLS,CLSFILE                           !!! from storage
      USE COM_MASHDEP ,ONLY: NVAL,LENCMP,LENREL,LENINT               !!! from setup
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                         !!! from setup
      IMPLICIT REAL*8 (A-H,O-Z)
C PASSED ARRAYS
      INTEGER IBLOCK(NFOCCLST),IPOINT(2,NFOCCLST)
C LOCAL ARRAYS
      INTEGER, ALLOCATABLE :: IREF(:)
      INTEGER, ALLOCATABLE :: KREP(:)
      INTEGER, ALLOCATABLE :: IDIMB(:)
      INTEGER, ALLOCATABLE :: IVECB(:,:)
      INTEGER, ALLOCATABLE :: IPNTB(:,:)
      INTEGER, ALLOCATABLE :: NFOCD(:)
	INTEGER, ALLOCATABLE :: NMATPOC(:,:)
	INTEGER, ALLOCATABLE :: NMATPMS(:)
	INTEGER, ALLOCATABLE :: NMATPML(:)
	INTEGER, ALLOCATABLE :: NMATPMJ(:)
	INTEGER, ALLOCATABLE :: NMATPSS(:)
	INTEGER, ALLOCATABLE :: NMATPLL(:)
	INTEGER, ALLOCATABLE :: NMATPJJ(:)
	INTEGER, ALLOCATABLE :: IMATIMP(:,:)
	INTEGER, ALLOCATABLE :: IMATPOC(:,:)
	INTEGER, ALLOCATABLE :: IMATPMS(:,:)
	INTEGER, ALLOCATABLE :: IMATPML(:,:)
	INTEGER, ALLOCATABLE :: IMATPMJ(:,:)
	INTEGER, ALLOCATABLE :: IMATPSS(:,:)
	INTEGER, ALLOCATABLE :: IMATPLL(:,:)
	INTEGER, ALLOCATABLE :: IMATPJJ(:,:)
	INTEGER, ALLOCATABLE :: IMATBATH(:,:)
      INTEGER, ALLOCATABLE :: IFBATH(:,:)
      REAL*8, ALLOCATABLE :: EVAL(:)
      REAL*8, ALLOCATABLE :: ECLS(:)
      REAL*8, ALLOCATABLE :: EORD(:)
      REAL*8, ALLOCATABLE :: OCCIMP(:,:)
      REAL*8, ALLOCATABLE :: DMSIMP(:)
      REAL*8, ALLOCATABLE :: DMLIMP(:)
      REAL*8, ALLOCATABLE :: DMJIMP(:)
      REAL*8, ALLOCATABLE :: DSSIMP(:)
      REAL*8, ALLOCATABLE :: DLLIMP(:)
      REAL*8, ALLOCATABLE :: DJJIMP(:)
      REAL*8, ALLOCATABLE :: OCCBAT(:,:)
      REAL*8, ALLOCATABLE :: DMSBAT(:)
      REAL*8, ALLOCATABLE :: SPECBATH(:)
	COMPLEX*16, ALLOCATABLE :: FMAT(:,:)
	COMPLEX*16, ALLOCATABLE :: FMATIMP(:)
	COMPLEX*16, ALLOCATABLE :: FMATPOC(:)
	COMPLEX*16, ALLOCATABLE :: FMATPMS(:)
	COMPLEX*16, ALLOCATABLE :: FMATPML(:)
	COMPLEX*16, ALLOCATABLE :: FMATPMJ(:)
	COMPLEX*16, ALLOCATABLE :: FMATPSS(:)
	COMPLEX*16, ALLOCATABLE :: FMATPLL(:)
	COMPLEX*16, ALLOCATABLE :: FMATPJJ(:)
      COMPLEX*16, ALLOCATABLE :: AVECB(:)
      COMPLEX*16, ALLOCATABLE :: VMATB(:,:)
	CHARACTER*5, ALLOCATABLE :: TCLS(:,:)
	CHARACTER*5, ALLOCATABLE :: TIMP(:)
	CHARACTER*5, ALLOCATABLE :: TBAT(:)
	COMPLEX*16 DIM
	CHARACTER TNC*10,TNB*10,CFILE*130
	CHARACTER*5 TML,TMS,TMJ,TL,TS,TJ,BMS,TOCT,BOCT
	LOGICAL EXIST,OPEN,RAT_CLSDIAG_SKIP
	DATA PI/3.141592653589793D0/,DIM/(0.D0,1.D0)/
C *************************************
      IF(KORB.EQ.0)RETURN      
      NDEG=2*(2*LORB+1)
      ALLOCATE(NFOCD(0:NDEG))
      ALLOCATE(ECLS(NFOCCLST))
      ALLOCATE(DMSIMP(NFOCCLST))
      ALLOCATE(DMLIMP(NFOCCLST))
      ALLOCATE(DMJIMP(NFOCCLST))
      ALLOCATE(DSSIMP(NFOCCLST))
      ALLOCATE(DLLIMP(NFOCCLST))
      ALLOCATE(DJJIMP(NFOCCLST))
      ALLOCATE(OCCIMP(NFOCCLST,NDEG))
      ALLOCATE(DMSBAT(NFOCCLST))
      ALLOCATE(OCCBAT(NFOCCLST,NHYB))
      DO IFOC=1,NFOCCLST
      ECLS(IFOC)=0.D0
      DMSIMP(IFOC)=0.D0
      DMLIMP(IFOC)=0.D0
      DMJIMP(IFOC)=0.D0
      DSSIMP(IFOC)=0.D0
      DLLIMP(IFOC)=0.D0
      DJJIMP(IFOC)=0.D0
      DMSBAT(IFOC)=0.D0
      DO IDEG=1,NDEG
      OCCIMP(IFOC,IDEG)=0.D0
      ENDDO
      DO IHYB=1,NHYB
      OCCBAT(IFOC,IHYB)=0.D0
      ENDDO
      ENDDO
C Compute matrix elements for the impurity
      NPOCMAX=0
      NPMSMAX=0
      NPMLMAX=0
      NPMJMAX=0
      NPSSMAX=0
      NPLLMAX=0
      NPJJMAX=0
	DO IOCCIMP=0,NDEG             !!! over impurity occupancies
	IF(LOCCIMP(IOCCIMP).EQ.0)CYCLE
      CALL RAT_ORBMAT(IOCCIMP,NPOC,NPMS,NPML,NPMJ,NPSS,NPLL,NPJJ)
      NPOCMAX=NPOCMAX+NPOC
      NPMSMAX=NPMSMAX+NPMS
      NPMLMAX=NPMLMAX+NPML
      NPMJMAX=NPMJMAX+NPMJ
      NPSSMAX=NPSSMAX+NPSS
      NPLLMAX=NPLLMAX+NPLL
      NPJJMAX=NPJJMAX+NPJJ
      ENDDO                          !!! over impurity occupancies
C Prepare matrix elements for the impurity
	ALLOCATE(NMATPOC(0:NDEG,NDEG))
	ALLOCATE(NMATPMS(0:NDEG))
	ALLOCATE(NMATPML(0:NDEG))
	ALLOCATE(NMATPMJ(0:NDEG))
	ALLOCATE(NMATPSS(0:NDEG))
	ALLOCATE(NMATPLL(0:NDEG))
	ALLOCATE(NMATPJJ(0:NDEG))
	ALLOCATE(FMATPOC(NPOCMAX))
	ALLOCATE(FMATPMS(NPMSMAX))
	ALLOCATE(FMATPML(NPMLMAX))
	ALLOCATE(FMATPMJ(NPMJMAX))
	ALLOCATE(FMATPSS(NPSSMAX))
	ALLOCATE(FMATPLL(NPLLMAX))
	ALLOCATE(FMATPJJ(NPJJMAX))
	ALLOCATE(IMATPOC(2,NPOCMAX))
	ALLOCATE(IMATPMS(2,NPMSMAX))
	ALLOCATE(IMATPML(2,NPMLMAX))
	ALLOCATE(IMATPMJ(2,NPMJMAX))
	ALLOCATE(IMATPSS(2,NPSSMAX))
	ALLOCATE(IMATPLL(2,NPLLMAX))
	ALLOCATE(IMATPJJ(2,NPJJMAX))
	SIZE_MEM= DBLE(SIZE(FMATPOC)*LENCMP)/1024.D0**2
     &         +DBLE(SIZE(FMATPMS)*LENCMP)/1024.D0**2
     &         +DBLE(SIZE(FMATPML)*LENCMP)/1024.D0**2
     &         +DBLE(SIZE(FMATPMJ)*LENCMP)/1024.D0**2
     &         +DBLE(SIZE(FMATPSS)*LENCMP)/1024.D0**2
     &         +DBLE(SIZE(FMATPLL)*LENCMP)/1024.D0**2
     &         +DBLE(SIZE(FMATPJJ)*LENCMP)/1024.D0**2
     &         +DBLE(SIZE(IMATPOC)*LENINT)/1024.D0**2
     &         +DBLE(SIZE(IMATPMS)*LENINT)/1024.D0**2
     &         +DBLE(SIZE(IMATPML)*LENINT)/1024.D0**2
     &         +DBLE(SIZE(IMATPMJ)*LENINT)/1024.D0**2
     &         +DBLE(SIZE(IMATPSS)*LENINT)/1024.D0**2
     &         +DBLE(SIZE(IMATPLL)*LENINT)/1024.D0**2
     &         +DBLE(SIZE(IMATPJJ)*LENINT)/1024.D0**2
	NPOC=0
	NPMS=0
	NPML=0
	NPMJ=0
	NPSS=0
	NPLL=0
	NPJJ=0
	DO 1000 IOCCIMP=0,NDEG                       !!! over impurity occupancies
	IF(LOCCIMP(IOCCIMP).EQ.0)GOTO 1000
	CALL FIND_LBLANK(SCRFILE(IUAGF),130,NA)
      CALL LIB_TINT(TNC,10,IOCCIMP,NC)
      OPEN(UNIT=IUAGF,FILE=SCRFILE(IUAGF)(:NA)//'_'//TNC(:NC),
     &STATUS='OLD',ACCESS='SEQUENTIAL',FORM='UNFORMATTED')
C Read and store occupancies
	DO IDEG=1,NDEG                               !!! over impurity states
      NMATPOC(IOCCIMP,IDEG)=0
      READ(IUAGF)NMATPOC(IOCCIMP,IDEG)
      ALLOCATE(FMATIMP(NMATPOC(IOCCIMP,IDEG)))
      ALLOCATE(IMATIMP(2,NMATPOC(IOCCIMP,IDEG)))
	READ(IUAGF)(FMATIMP(IMAT),IMAT=1,NMATPOC(IOCCIMP,IDEG)),
     & ((IMATIMP(I,IMAT),I=1,2),IMAT=1,NMATPOC(IOCCIMP,IDEG))
C Pack matrix elements into long array
	DO IMAT=1,NMATPOC(IOCCIMP,IDEG)
	FMATPOC(IMAT+NPOC)=FMATIMP(IMAT)
	IMATPOC(1,IMAT+NPOC)=IMATIMP(1,IMAT)
	IMATPOC(2,IMAT+NPOC)=IMATIMP(2,IMAT)
	ENDDO
	NPOC=NPOC+NMATPOC(IOCCIMP,IDEG)
	DEALLOCATE(FMATIMP,IMATIMP)
      ENDDO 	                                !!! over impurity states
C Read and store MS
      NMATPMS(IOCCIMP)=0
      READ(IUAGF)NMATPMS(IOCCIMP)
      ALLOCATE(FMATIMP(NMATPMS(IOCCIMP)))
      ALLOCATE(IMATIMP(2,NMATPMS(IOCCIMP)))
	READ(IUAGF)(FMATIMP(IMAT),IMAT=1,NMATPMS(IOCCIMP)),
     & ((IMATIMP(I,IMAT),I=1,2),IMAT=1,NMATPMS(IOCCIMP))
C Pack matrix elements into long array
	DO IMAT=1,NMATPMS(IOCCIMP)
	FMATPMS(IMAT+NPMS)=FMATIMP(IMAT)
	IMATPMS(1,IMAT+NPMS)=IMATIMP(1,IMAT)
	IMATPMS(2,IMAT+NPMS)=IMATIMP(2,IMAT)
	ENDDO
	NPMS=NPMS+NMATPMS(IOCCIMP)
	DEALLOCATE(FMATIMP,IMATIMP)
C Read and store ML
      NMATPML(IOCCIMP)=0
      READ(IUAGF)NMATPML(IOCCIMP)
      ALLOCATE(FMATIMP(NMATPML(IOCCIMP)))
      ALLOCATE(IMATIMP(2,NMATPML(IOCCIMP)))
	READ(IUAGF)(FMATIMP(IMAT),IMAT=1,NMATPML(IOCCIMP)),
     & ((IMATIMP(I,IMAT),I=1,2),IMAT=1,NMATPML(IOCCIMP))
C Pack matrix elements into long array
	DO IMAT=1,NMATPML(IOCCIMP)
	FMATPML(IMAT+NPML)=FMATIMP(IMAT)
	IMATPML(1,IMAT+NPML)=IMATIMP(1,IMAT)
	IMATPML(2,IMAT+NPML)=IMATIMP(2,IMAT)
	ENDDO
	NPML=NPML+NMATPML(IOCCIMP)
	DEALLOCATE(FMATIMP,IMATIMP)
C Read and store MJ
      NMATPMJ(IOCCIMP)=0
      READ(IUAGF)NMATPMJ(IOCCIMP)
      ALLOCATE(FMATIMP(NMATPMJ(IOCCIMP)))
      ALLOCATE(IMATIMP(2,NMATPMJ(IOCCIMP)))
	READ(IUAGF)(FMATIMP(IMAT),IMAT=1,NMATPMJ(IOCCIMP)),
     & ((IMATIMP(I,IMAT),I=1,2),IMAT=1,NMATPMJ(IOCCIMP))
C Pack matrix elements into long array
	DO IMAT=1,NMATPMJ(IOCCIMP)
	FMATPMJ(IMAT+NPMJ)=FMATIMP(IMAT)
	IMATPMJ(1,IMAT+NPMJ)=IMATIMP(1,IMAT)
	IMATPMJ(2,IMAT+NPMJ)=IMATIMP(2,IMAT)
	ENDDO
	NPMJ=NPMJ+NMATPMJ(IOCCIMP)
	DEALLOCATE(FMATIMP,IMATIMP)
C Read and store SS
      NMATPSS(IOCCIMP)=0
      READ(IUAGF)NMATPSS(IOCCIMP)
      ALLOCATE(FMATIMP(NMATPSS(IOCCIMP)))
      ALLOCATE(IMATIMP(2,NMATPSS(IOCCIMP)))
	READ(IUAGF)(FMATIMP(IMAT),IMAT=1,NMATPSS(IOCCIMP)),
     & ((IMATIMP(I,IMAT),I=1,2),IMAT=1,NMATPSS(IOCCIMP))
C Pack matrix elements into long array
	DO IMAT=1,NMATPSS(IOCCIMP)
	FMATPSS(IMAT+NPSS)=FMATIMP(IMAT)
	IMATPSS(1,IMAT+NPSS)=IMATIMP(1,IMAT)
	IMATPSS(2,IMAT+NPSS)=IMATIMP(2,IMAT)
	ENDDO
	NPSS=NPSS+NMATPSS(IOCCIMP)
	DEALLOCATE(FMATIMP,IMATIMP)
C Read and store LL
      NMATPLL(IOCCIMP)=0
      READ(IUAGF)NMATPLL(IOCCIMP)
      ALLOCATE(FMATIMP(NMATPLL(IOCCIMP)))
      ALLOCATE(IMATIMP(2,NMATPLL(IOCCIMP)))
	READ(IUAGF)(FMATIMP(IMAT),IMAT=1,NMATPLL(IOCCIMP)),
     & ((IMATIMP(I,IMAT),I=1,2),IMAT=1,NMATPLL(IOCCIMP))
C Pack matrix elements into long array
	DO IMAT=1,NMATPLL(IOCCIMP)
	FMATPLL(IMAT+NPLL)=FMATIMP(IMAT)
	IMATPLL(1,IMAT+NPLL)=IMATIMP(1,IMAT)
	IMATPLL(2,IMAT+NPLL)=IMATIMP(2,IMAT)
	ENDDO
	NPLL=NPLL+NMATPLL(IOCCIMP)
	DEALLOCATE(FMATIMP,IMATIMP)
C Read and store JJ
      NMATPJJ(IOCCIMP)=0
      READ(IUAGF)NMATPJJ(IOCCIMP)
      ALLOCATE(FMATIMP(NMATPJJ(IOCCIMP)))
      ALLOCATE(IMATIMP(2,NMATPJJ(IOCCIMP)))
	READ(IUAGF)(FMATIMP(IMAT),IMAT=1,NMATPJJ(IOCCIMP)),
     & ((IMATIMP(I,IMAT),I=1,2),IMAT=1,NMATPJJ(IOCCIMP))
C Pack matrix elements into long array
	DO IMAT=1,NMATPJJ(IOCCIMP)
	FMATPJJ(IMAT+NPJJ)=FMATIMP(IMAT)
	IMATPJJ(1,IMAT+NPJJ)=IMATIMP(1,IMAT)
	IMATPJJ(2,IMAT+NPJJ)=IMATIMP(2,IMAT)
	ENDDO
	NPJJ=NPJJ+NMATPJJ(IOCCIMP)
	DEALLOCATE(FMATIMP,IMATIMP)
	CLOSE(UNIT=IUAGF,STATUS='DELETE')
 1000 CONTINUE 	                               !!! over impurity occupancies
C Prepare matrix elements for the bath
      NMATBOC=0
	DO IOCCIMP=0,NDEG
	NOCCBATH=NOCCCLS-IOCCIMP
      NFOCBATH=NFOCBAT(NOCCBATH)               !!! total dimension of "Nf"   impurity space
      NCUTBATH=NCUTBAT(NOCCBATH)
      IF(NFOCBATH.EQ.0.OR.LOCCIMP(IOCCIMP).EQ.0)CYCLE
      NMATBOC=NMATBOC+NCUTBATH
      ENDDO
      ALLOCATE(IMATBATH(NHYB,NMATBOC))
      SIZE_MEM=SIZE_MEM+DBLE(IMATBOC*LENINT)/1024.D0**2      
      NBOC=0
	DO IOCCIMP=0,NDEG                         !!! over impurity occupancies
	NOCCBATH=NOCCCLS-IOCCIMP
      NFOCBATH=NFOCBAT(NOCCBATH)                !!! total dimension of "Nf"   impurity space
      NCUTBATH=NCUTBAT(NOCCBATH)
      IF(NFOCBATH.EQ.0.OR.LOCCIMP(IOCCIMP).EQ.0)CYCLE
	ALLOCATE(SPECBATH(NFOCBATH))
	ALLOCATE(IFBATH(0:NHYB,NFOCBATH))
	CALL RAT_CLSDIAG_BATH(SPECBATH,IFBATH,NOCCBATH,NFOCBATH,NFOCBATH)
C Store Bath Matrix Elements into long array
      DO IHYB=1,NHYB     
      DO IFOC=1,NCUTBATH
      IMATBATH(IHYB,IFOC+NBOC)=IFBATH(IHYB,IFOC)
      ENDDO
      ENDDO
      NBOC=NBOC+NCUTBATH
      DEALLOCATE(SPECBATH,IFBATH)
      ENDDO
      WRITE(IUN,10030)SIZE_MEM
10030 FORMAT(1X,'<N|LSJ|N> memory allocated (Mb)=',G14.7)
C **************************************************
C DO OVER BLOCKS
      NFOCT=0
	DO 3000 IBLK=0,NBLK                      !!! over blocks
      CALL LIB_TINT(TNC,10,NOCCCLS,NC)
      CALL LIB_TINT(TNB,10,IBLK,NB)
      IF(ICCLS.EQ.0)CFILE=SCRFILE(IUCL2)
      IF(ICCLS.GT.0)CFILE=CLSFILE
      CALL FIND_LBLANK(CFILE,130,NA)
      OPEN(UNIT=IUCL2,FILE=CFILE(:NA)//'_'//TNC(:NC)//'_'//
     &TNB(:NB),STATUS='OLD',ACCESS='SEQUENTIAL',FORM='UNFORMATTED')
      IF(IBLK.NE.0)
     &READ(IUCL2)NFOCB,NVECB
      IF(IBLK.EQ.0)
     &READ(IUCL2)NFOCB,NVECB,(IBLOCK(IFOCT),IFOCT=1,NFOCCLST),
     &((IPOINT(I,IFOCT),I=1,2),IFOCT=1,NFOCCLST),
     &(NFOCD(IOCC),IOCC=0,NDEG)
      ALLOCATE(EVAL(NFOCB))
      ALLOCATE(IPNTB(2,NFOCB))
      ALLOCATE(IVECB(2,NVECB))
      ALLOCATE(AVECB(NVECB))
      READ(IUCL2)(EVAL(IDIM),IDIM=1,NFOCB),
     &((IPNTB(I,IDIM),I=1,2),IDIM=1,NFOCB),
     &((IVECB(I,IVEC),I=1,2),IVEC=1,NVECB),
     &          (AVECB(IVEC),IVEC=1,NVECB)
      CLOSE(IUCL2,STATUS='KEEP')
C Unpack Eigenvectors
      ALLOCATE(VMATB(NFOCB,NFOCB))
      DO IBND=1,NFOCB
      DO IFOC=1,NFOCB
      VMATB(IFOC,IBND)=(0.D0,0.D0)
      ENDDO
      ENDDO
      DO IVEC=1,NVECB
      IFOC=IVECB(1,IVEC)
      IBND=IVECB(2,IVEC)
      VMATB(IFOC,IBND)=AVECB(IVEC)
      ENDDO
      DO IFOCB=1,NFOCB
      IFOCT=IFOCB+NFOCT
      ECLS(IFOCT)=EVAL(IFOCB)
      ENDDO
      DEALLOCATE(EVAL,IPNTB,IVECB,AVECB)
C Set pointer arrays
      ALLOCATE(IDIMB(NFOCCLST))
      IDIM=0
      DO IFOCT=1,NFOCCLST
      IDIMB(IFOCT)=0
      IF(IBLOCK(IFOCT).NE.IBLK)CYCLE
      IDIM=IDIM+1
      IDIMB(IFOCT)=IDIM
      ENDDO
C ******************************
C Loop over impurity occupancies
	NPOC=0
	NPMS=0
	NPML=0
	NPMJ=0
	NPSS=0
	NPLL=0
	NPJJ=0
	DO 2200 IOCCIMP=0,NDEG                 !!! over impurity occupancies
	IF(LOCCIMP(IOCCIMP).EQ.0)GOTO 2200
	NFOCIMPN=NFOCIMP(IOCCIMP)
	ALLOCATE(FMAT(NFOCIMPN,NFOCIMPN))
C Set pointer shifts
      NDIMT=0
      DO JOCC=0,IOCCIMP-1
      NDIMT=NDIMT+NFOCD(JOCC)
      ENDDO
C AVERAGE IMPURITY OCCUPANCIES
	DO 2100 IDEG=1,NDEG                    !!! over impurity states
C Unpack impurity matrix element
	DO IFOC=1,NFOCIMPN
	DO JFOC=1,NFOCIMPN
	FMAT(IFOC,JFOC)=(0.D0,0.D0)
	ENDDO
	ENDDO
	DO IMAT=1,NMATPOC(IOCCIMP,IDEG)
	IFOC=IMATPOC(1,IMAT+NPOC)
	JFOC=IMATPOC(2,IMAT+NPOC)
	FMAT(IFOC,JFOC)=FMATPOC(IMAT+NPOC)
	ENDDO
	NPOC=NPOC+NMATPOC(IOCCIMP,IDEG)
C Loop over the basis functions for given subblocks
      DO IFOCI1=1,NFOCD(IOCCIMP)
      IFOCT=IFOCI1+NDIMT
      IF(IBLOCK(IFOCT).NE.IBLK)CYCLE
      IFOCS1=IPOINT(1,IFOCT)
      IFOCB1=IPOINT(2,IFOCT)
      IFOC1=IDIMB(IFOCT)
      DO IFOCI=1,NFOCD(IOCCIMP)
      IFOCT=IFOCI+NDIMT
      IF(IBLOCK(IFOCT).NE.IBLK)CYCLE
      IFOCS=IPOINT(1,IFOCT)
      IFOCB=IPOINT(2,IFOCT)
      IFOC=IDIMB(IFOCT)
      IF(IFOCB1.NE.IFOCB)CYCLE
      IF(ABS(FMAT(IFOCS1,IFOCS)).LE.EPSMAT)CYCLE
C Compute matrix element between given blocks
      DO IBNDB=1,NFOCB
      IBNDT=IBNDB+NFOCT
      OCCIMP(IBNDT,IDEG)=OCCIMP(IBNDT,IDEG)+
     &DCONJG(VMATB(IFOC1,IBNDB))*FMAT(IFOCS1,IFOCS)*
     &       VMATB(IFOC,IBNDB)
      ENDDO
C ....
      ENDDO
      ENDDO
 2100 CONTINUE 	                                !!! over impurity states
C AVERAGE MS
C Unpack impurity matrix element
	DO IFOC=1,NFOCIMPN
	DO JFOC=1,NFOCIMPN
	FMAT(IFOC,JFOC)=(0.D0,0.D0)
	ENDDO
	ENDDO
	DO IMAT=1,NMATPMS(IOCCIMP)
	IFOC=IMATPMS(1,IMAT+NPMS)
	JFOC=IMATPMS(2,IMAT+NPMS)
	FMAT(IFOC,JFOC)=FMATPMS(IMAT+NPMS)
	ENDDO
	NPMS=NPMS+NMATPMS(IOCCIMP)
C Loop over the basis functions for given subblocks
      DO IFOCI1=1,NFOCD(IOCCIMP)
      IFOCT=IFOCI1+NDIMT
      IF(IBLOCK(IFOCT).NE.IBLK)CYCLE
      IFOCS1=IPOINT(1,IFOCT)
      IFOCB1=IPOINT(2,IFOCT)
      IFOC1=IDIMB(IFOCT)
      DO IFOCI=1,NFOCD(IOCCIMP)
      IFOCT=IFOCI+NDIMT
      IF(IBLOCK(IFOCT).NE.IBLK)CYCLE
      IFOCS=IPOINT(1,IFOCT)
      IFOCB=IPOINT(2,IFOCT)
      IFOC=IDIMB(IFOCT)
      IF(IFOCB1.NE.IFOCB)CYCLE
      IF(ABS(FMAT(IFOCS1,IFOCS)).LE.EPSMAT)CYCLE
C Compute matrix element between given blocks
      DO IBNDB=1,NFOCB
      IBNDT=IBNDB+NFOCT
      DMSIMP(IBNDT)=DMSIMP(IBNDT)+
     &DCONJG(VMATB(IFOC1,IBNDB))*FMAT(IFOCS1,IFOCS)*
     &       VMATB(IFOC,IBNDB)
      ENDDO
C ....
      ENDDO
      ENDDO
C AVERAGE ML
C Unpack impurity matrix element
	DO IFOC=1,NFOCIMPN
	DO JFOC=1,NFOCIMPN
	FMAT(IFOC,JFOC)=(0.D0,0.D0)
	ENDDO
	ENDDO
	DO IMAT=1,NMATPML(IOCCIMP)
	IFOC=IMATPML(1,IMAT+NPML)
	JFOC=IMATPML(2,IMAT+NPML)
	FMAT(IFOC,JFOC)=FMATPML(IMAT+NPML)
	ENDDO
	NPML=NPML+NMATPML(IOCCIMP)
C Loop over the basis functions for given subblocks
      DO IFOCI1=1,NFOCD(IOCCIMP)
      IFOCT=IFOCI1+NDIMT
      IF(IBLOCK(IFOCT).NE.IBLK)CYCLE
      IFOCS1=IPOINT(1,IFOCT)
      IFOCB1=IPOINT(2,IFOCT)
      IFOC1=IDIMB(IFOCT)
      DO IFOCI=1,NFOCD(IOCCIMP)
      IFOCT=IFOCI+NDIMT
      IF(IBLOCK(IFOCT).NE.IBLK)CYCLE
      IFOCS=IPOINT(1,IFOCT)
      IFOCB=IPOINT(2,IFOCT)
      IFOC=IDIMB(IFOCT)
      IF(IFOCB1.NE.IFOCB)CYCLE
      IF(ABS(FMAT(IFOCS1,IFOCS)).LE.EPSMAT)CYCLE
C Compute matrix element between given blocks
      DO IBNDB=1,NFOCB
      IBNDT=IBNDB+NFOCT
      DMLIMP(IBNDT)=DMLIMP(IBNDT)+
     &DCONJG(VMATB(IFOC1,IBNDB))*FMAT(IFOCS1,IFOCS)*
     &       VMATB(IFOC,IBNDB)
      ENDDO
C ....
      ENDDO
      ENDDO
C AVERAGE MJ
C Unpack impurity matrix element
	DO IFOC=1,NFOCIMPN
	DO JFOC=1,NFOCIMPN
	FMAT(IFOC,JFOC)=(0.D0,0.D0)
	ENDDO
	ENDDO
	DO IMAT=1,NMATPMJ(IOCCIMP)
	IFOC=IMATPMJ(1,IMAT+NPMJ)
	JFOC=IMATPMJ(2,IMAT+NPMJ)
	FMAT(IFOC,JFOC)=FMATPMJ(IMAT+NPMJ)
	ENDDO
	NPMJ=NPMJ+NMATPMJ(IOCCIMP)
C Loop over the basis functions for given subblocks
      DO IFOCI1=1,NFOCD(IOCCIMP)
      IFOCT=IFOCI1+NDIMT
      IF(IBLOCK(IFOCT).NE.IBLK)CYCLE
      IFOCS1=IPOINT(1,IFOCT)
      IFOCB1=IPOINT(2,IFOCT)
      IFOC1=IDIMB(IFOCT)
      DO IFOCI=1,NFOCD(IOCCIMP)
      IFOCT=IFOCI+NDIMT
      IF(IBLOCK(IFOCT).NE.IBLK)CYCLE
      IFOCS=IPOINT(1,IFOCT)
      IFOCB=IPOINT(2,IFOCT)
      IFOC=IDIMB(IFOCT)
      IF(IFOCB1.NE.IFOCB)CYCLE
      IF(ABS(FMAT(IFOCS1,IFOCS)).LE.EPSMAT)CYCLE
C Compute matrix element between given blocks
      DO IBNDB=1,NFOCB
      IBNDT=IBNDB+NFOCT
      DMJIMP(IBNDT)=DMJIMP(IBNDT)+
     &DCONJG(VMATB(IFOC1,IBNDB))*FMAT(IFOCS1,IFOCS)*
     &       VMATB(IFOC,IBNDB)
      ENDDO
C ....
      ENDDO
      ENDDO
C AVERAGE SS
C Unpack impurity matrix element
	DO IFOC=1,NFOCIMPN
	DO JFOC=1,NFOCIMPN
	FMAT(IFOC,JFOC)=(0.D0,0.D0)
	ENDDO
	ENDDO
	DO IMAT=1,NMATPSS(IOCCIMP)
	IFOC=IMATPSS(1,IMAT+NPSS)
	JFOC=IMATPSS(2,IMAT+NPSS)
	FMAT(IFOC,JFOC)=FMATPSS(IMAT+NPSS)
	ENDDO
	NPSS=NPSS+NMATPSS(IOCCIMP)
C Loop over the basis functions for given subblocks
      DO IFOCI1=1,NFOCD(IOCCIMP)
      IFOCT=IFOCI1+NDIMT
      IF(IBLOCK(IFOCT).NE.IBLK)CYCLE
      IFOCS1=IPOINT(1,IFOCT)
      IFOCB1=IPOINT(2,IFOCT)
      IFOC1=IDIMB(IFOCT)
      DO IFOCI=1,NFOCD(IOCCIMP)
      IFOCT=IFOCI+NDIMT
      IF(IBLOCK(IFOCT).NE.IBLK)CYCLE
      IFOCS=IPOINT(1,IFOCT)
      IFOCB=IPOINT(2,IFOCT)
      IFOC=IDIMB(IFOCT)
      IF(IFOCB1.NE.IFOCB)CYCLE
      IF(ABS(FMAT(IFOCS1,IFOCS)).LE.EPSMAT)CYCLE
C Compute matrix element between given blocks
      DO IBNDB=1,NFOCB
      IBNDT=IBNDB+NFOCT
      DSSIMP(IBNDT)=DSSIMP(IBNDT)+
     &DCONJG(VMATB(IFOC1,IBNDB))*FMAT(IFOCS1,IFOCS)*
     &       VMATB(IFOC,IBNDB)
      ENDDO
C ....
      ENDDO
      ENDDO
C AVERAGE LL
C Unpack impurity matrix element
	DO IFOC=1,NFOCIMPN
	DO JFOC=1,NFOCIMPN
	FMAT(IFOC,JFOC)=(0.D0,0.D0)
	ENDDO
	ENDDO
	DO IMAT=1,NMATPLL(IOCCIMP)
	IFOC=IMATPLL(1,IMAT+NPLL)
	JFOC=IMATPLL(2,IMAT+NPLL)
	FMAT(IFOC,JFOC)=FMATPLL(IMAT+NPLL)
	ENDDO
	NPLL=NPLL+NMATPLL(IOCCIMP)
C Loop over the basis functions for given subblocks
      DO IFOCI1=1,NFOCD(IOCCIMP)
      IFOCT=IFOCI1+NDIMT
      IF(IBLOCK(IFOCT).NE.IBLK)CYCLE
      IFOCS1=IPOINT(1,IFOCT)
      IFOCB1=IPOINT(2,IFOCT)
      IFOC1=IDIMB(IFOCT)
      DO IFOCI=1,NFOCD(IOCCIMP)
      IFOCT=IFOCI+NDIMT
      IF(IBLOCK(IFOCT).NE.IBLK)CYCLE
      IFOCS=IPOINT(1,IFOCT)
      IFOCB=IPOINT(2,IFOCT)
      IFOC=IDIMB(IFOCT)
      IF(IFOCB1.NE.IFOCB)CYCLE
      IF(ABS(FMAT(IFOCS1,IFOCS)).LE.EPSMAT)CYCLE
C Compute matrix element between given blocks
      DO IBNDB=1,NFOCB
      IBNDT=IBNDB+NFOCT
      DLLIMP(IBNDT)=DLLIMP(IBNDT)+
     &DCONJG(VMATB(IFOC1,IBNDB))*FMAT(IFOCS1,IFOCS)*
     &       VMATB(IFOC,IBNDB)
      ENDDO
C ....
      ENDDO
      ENDDO
C AVERAGE JJ
C Unpack impurity matrix element
	DO IFOC=1,NFOCIMPN
	DO JFOC=1,NFOCIMPN
	FMAT(IFOC,JFOC)=(0.D0,0.D0)
	ENDDO
	ENDDO
	DO IMAT=1,NMATPJJ(IOCCIMP)
	IFOC=IMATPJJ(1,IMAT+NPJJ)
	JFOC=IMATPJJ(2,IMAT+NPJJ)
	FMAT(IFOC,JFOC)=FMATPJJ(IMAT+NPJJ)
	ENDDO
	NPJJ=NPJJ+NMATPJJ(IOCCIMP)
C Loop over the basis functions for given subblocks
      DO IFOCI1=1,NFOCD(IOCCIMP)
      IFOCT=IFOCI1+NDIMT
      IF(IBLOCK(IFOCT).NE.IBLK)CYCLE
      IFOCS1=IPOINT(1,IFOCT)
      IFOCB1=IPOINT(2,IFOCT)
      IFOC1=IDIMB(IFOCT)
      DO IFOCI=1,NFOCD(IOCCIMP)
      IFOCT=IFOCI+NDIMT
      IF(IBLOCK(IFOCT).NE.IBLK)CYCLE
      IFOCS=IPOINT(1,IFOCT)
      IFOCB=IPOINT(2,IFOCT)
      IFOC=IDIMB(IFOCT)
      IF(IFOCB1.NE.IFOCB)CYCLE
      IF(ABS(FMAT(IFOCS1,IFOCS)).LE.EPSMAT)CYCLE
C Compute matrix element between given blocks
      DO IBNDB=1,NFOCB
      IBNDT=IBNDB+NFOCT
      DJJIMP(IBNDT)=DJJIMP(IBNDT)+
     &DCONJG(VMATB(IFOC1,IBNDB))*FMAT(IFOCS1,IFOCS)*
     &       VMATB(IFOC,IBNDB)
      ENDDO
C ....
      ENDDO
      ENDDO
      DEALLOCATE(FMAT)
 2200 CONTINUE 	                                !!! over impurity occupancies
C CALCULATE BATH OCCUPANCIES
      NBOC=0
	DO 2400 IOCCIMP=0,NDEG                    !!! over impurity occupancies
	NOCCBATH=NOCCCLS-IOCCIMP
      NFOCBATH=NFOCBAT(NOCCBATH)                !!! total dimension of "Nf"   impurity space
      NCUTBATH=NCUTBAT(NOCCBATH)
      IF(NFOCBATH.EQ.0.OR.LOCCIMP(IOCCIMP).EQ.0)GOTO 2400
C Set pointer shifts
      NDIMT=0
      DO JOCC=0,IOCCIMP-1
      NDIMT=NDIMT+NFOCD(JOCC)
      ENDDO
C Restore Bath Matrix Elements
	ALLOCATE(IFBATH(NHYB,NFOCBATH))
      IHYB=0
      DO 2330 IBST=1,NBST
      DO 2320 IUPDN=+1,-1,-2
      DO 2310 IDST=1,NDST(IBST)/2
      IHYB=IHYB+1
      DO IFOC=1,NCUTBATH
      IFBATH(IHYB,IFOC)=IMATBATH(IHYB,IFOC+NBOC)
      ENDDO
      DO IFOCI1=1,NFOCD(IOCCIMP)
      IFOCT=IFOCI1+NDIMT
      IF(IBLOCK(IFOCT).NE.IBLK)CYCLE
      IFOCS1=IPOINT(1,IFOCT)
      IFOCB1=IPOINT(2,IFOCT)
      IFOC1=IDIMB(IFOCT)
      DO IFOCI=1,NFOCD(IOCCIMP)
      IFOCT=IFOCI+NDIMT
      IF(IBLOCK(IFOCT).NE.IBLK)CYCLE
      IFOCS=IPOINT(1,IFOCT)
      IFOCB=IPOINT(2,IFOCT)
      IFOC=IDIMB(IFOCT)
      IF(IFOCS1.NE.IFOCS)CYCLE
      IF(IFOCB1.NE.IFOCB)CYCLE
      IF(IFBATH(IHYB,IFOCB).EQ.0)CYCLE
C Compute matrix element between given blocks
      DO IBNDB=1,NFOCB
      IBNDT=IBNDB+NFOCT
      OCCBAT(IBNDT,IHYB)=OCCBAT(IBNDT,IHYB)+
     &DCONJG(VMATB(IFOC1,IBNDB))*IFBATH(IHYB,IFOCB)*
     &       VMATB(IFOC,IBNDB)
      DMSBAT(IBNDT)=DMSBAT(IBNDT)+
     &DCONJG(VMATB(IFOC1,IBNDB))*IFBATH(IHYB,IFOCB)*
     &       VMATB(IFOC,IBNDB)*DBLE(IUPDN)*0.5D0
      ENDDO
C ....
      ENDDO
      ENDDO
 2310 CONTINUE      
 2320 CONTINUE      
 2330 CONTINUE      
      NBOC=NBOC+NCUTBATH
      DEALLOCATE(IFBATH) 
 2400 CONTINUE                                   !!! over impurity occupancies
      NFOCT=NFOCT+NFOCB
      DEALLOCATE(VMATB,IDIMB)
 3000 CONTINUE                                   !!! over blocks
      IF(NFOCT.NE.NFOCCLST)
     &CALL FULLSTOP('<RAT_CLSDIAG_ORBM>::NFOCT.NE.NFOCCLST')
C Sort energies in increasing order
      ALLOCATE(EORD(NFOCCLST))
      ALLOCATE(IREF(NFOCCLST))
      DO IFOC=1,NFOCCLST
      EORD(IFOC)=ECLS(IFOC)
      IREF(IFOC)=IFOC
      ENDDO
      DO ILEV=1,NFOCCLST
      DO JLEV=ILEV+1,NFOCCLST
	IF(EORD(ILEV).GT.EORD(JLEV))THEN
	S=EORD(ILEV)
	EORD(ILEV)=EORD(JLEV)
	EORD(JLEV)=S
	I=IREF(ILEV)
	IREF(ILEV)=IREF(JLEV)
	IREF(JLEV)=I
	ENDIF
	ENDDO
	ENDDO
C Find degeneracy
	NREP=1
	DO ILEV=2,NFOCCLST
	IF(ABS(EORD(ILEV-1)-EORD(ILEV)).LE.EPSDEG)CYCLE
	NREP=NREP+1
	ENDDO
	ALLOCATE(KREP(NREP))
	IREP=1
	KREP(1)=1
	DO ILEV=2,NFOCCLST
	IF(ABS(EORD(ILEV-1)-EORD(ILEV)).LE.EPSDEG)KREP(IREP)=KREP(IREP)+1
	IF(ABS(EORD(ILEV-1)-EORD(ILEV)).LE.EPSDEG)CYCLE
	IREP=IREP+1
	KREP(IREP)=1
	ENDDO
	ISUM=0
	DO IREP=1,NREP
	ISUM=ISUM+KREP(IREP)
	ENDDO
	IF(ISUM.NE.NFOCCLST)
     &CALL FULLSTOP('<RAT_CLSDIAG_ORBM>::ISUM.NE.NFOCCLST')
C Find absolute values of momenta
	DO IFOC=1,NFOCCLST
	DLLIMP(IFOC)=-0.5D0+0.5D0*SQRT(ABS(1.D0+4.D0*DLLIMP(IFOC)))
	DSSIMP(IFOC)=-0.5D0+0.5D0*SQRT(ABS(1.D0+4.D0*DSSIMP(IFOC)))
	DJJIMP(IFOC)=-0.5D0+0.5D0*SQRT(ABS(1.D0+4.D0*DJJIMP(IFOC)))
	ENDDO
C PRINT RESULT TO THE OUTPUT FILE
	ALLOCATE(TCLS(6,NFOCCLST))
	ALLOCATE(TIMP(NDEG))
	ALLOCATE(TBAT(NHYB))
	WRITE(IUN,10100)NFOCCLST
	IFOC=0
	DO IREP=1,NREP
	DO ISUB=1,KREP(IREP)
	IFOC=IFOC+1
      ILEV=IREF(IFOC)	
	IF(ISUB.EQ.1)THEN
      WRITE(IUN,10110)ECLS(ILEV),KREP(IREP),IREP
	IF(LORB.EQ.0)WRITE(IUN,10130)
	IF(LORB.EQ.1)WRITE(IUN,10131)
	IF(LORB.EQ.2)WRITE(IUN,10132)
	IF(LORB.EQ.3)WRITE(IUN,10133)
	ENDIF
	DO MS=1,NDEG
	IF(OCCIMP(ILEV,MS).LT.1.D-03)THEN
	TIMP(MS)=' 0.00'
	ELSE
	WRITE(TIMP(MS),FMT='(F5.2)')OCCIMP(ILEV,MS)
	ENDIF
	ENDDO
	IF(ABS(DLLIMP(ILEV)).LT.1.D-03)THEN
	TL=' 0.00'
	ELSE
	WRITE(TL,FMT='(F5.2)')DLLIMP(ILEV)
	ENDIF
	IF(ABS(DSSIMP(ILEV)).LT.1.D-03)THEN
	TS=' 0.00'
	ELSE
	WRITE(TS,FMT='(F5.2)')DSSIMP(ILEV)
	ENDIF
	IF(ABS(DJJIMP(ILEV)).LT.1.D-03)THEN
	TJ=' 0.00'
	ELSE
	WRITE(TJ,FMT='(F5.2)')DJJIMP(ILEV)
	ENDIF
	IF(ABS(DMLIMP(ILEV)).LT.1.D-03)THEN
	TML=' 0.00'
	ELSE
	WRITE(TML,FMT='(F5.2)')DMLIMP(ILEV)
	ENDIF
	IF(ABS(DMSIMP(ILEV)).LT.1.D-03)THEN
	TMS=' 0.00'
	ELSE
	WRITE(TMS,FMT='(F5.2)')DMSIMP(ILEV)
	ENDIF
	IF(ABS(DMJIMP(ILEV)).LT.1.D-03)THEN
	TMJ=' 0.00'
	ELSE
	WRITE(TMJ,FMT='(F5.2)')DMJIMP(ILEV)
	ENDIF
	IF(ABS(DMSBAT(ILEV)).LT.1.D-03)THEN
	BMS=' 0.00'
	ELSE
	WRITE(BMS,FMT='(F5.2)')DMSBAT(ILEV)
	ENDIF
	DO IHYB=1,NHYB
	IF(OCCBAT(ILEV,IHYB).LT.1.D-03)THEN
	TBAT(IHYB)=' 0.00'
	ELSE
	WRITE(TBAT(IHYB),FMT='(F5.2)')OCCBAT(ILEV,IHYB)
	ENDIF
	ENDDO
	OCCIMPT=0.D0
	DO IDEG=1,NDEG
	OCCIMPT=OCCIMPT+OCCIMP(ILEV,IDEG)
	ENDDO
	IF(ABS(OCCIMPT).LT.1.D-03)THEN
	TOCT=' 0.00'
	ELSE
	WRITE(TOCT,FMT='(F5.2)')OCCIMPT
	ENDIF
	OCCBATT=0.D0
	DO IHYB=1,NHYB
	OCCBATT=OCCBATT+OCCBAT(ILEV,IHYB)
	ENDDO
	IF(ABS(OCCBATT).LT.1.D-03)THEN
	BOCT=' 0.00'
	ELSE
	WRITE(BOCT,FMT='(F5.2)')OCCBATT
	ENDIF
	TCLS(1,ILEV)=TML
	TCLS(2,ILEV)=TMS
	TCLS(3,ILEV)=TMJ
	TCLS(4,ILEV)=TL
	TCLS(5,ILEV)=TS
	TCLS(6,ILEV)=TJ
	IF(LORB.EQ.0)WRITE(IUN,10140)ILEV,TML,TMS,TMJ,TL,TS,TJ,BMS,
     &(TIMP(MS),MS=1,NDEG),TOCT,(TBAT(IHYB),IHYB=1,NHYB),BOCT
	IF(LORB.EQ.1)WRITE(IUN,10141)ILEV,TML,TMS,TMJ,TL,TS,TJ,BMS,
     &(TIMP(MS),MS=1,NDEG),TOCT,(TBAT(IHYB),IHYB=1,NHYB),BOCT
	IF(LORB.EQ.2)WRITE(IUN,10142)ILEV,TML,TMS,TMJ,TL,TS,TJ,BMS,
     &(TIMP(MS),MS=1,NDEG),TOCT,(TBAT(IHYB),IHYB=1,NHYB),BOCT
	IF(LORB.EQ.3)WRITE(IUN,10143)ILEV,TML,TMS,TMJ,TL,TS,TJ,BMS,
     &(TIMP(MS),MS=1,NDEG),TOCT,(TBAT(IHYB),IHYB=1,NHYB),BOCT
	ENDDO
	ENDDO
C MEMORY DEALLOCATIONS
10100 FORMAT(1X,'Result of diagonalization, # of levels = ',I6)
10110 FORMAT(1X,'Energy = ',G12.5,' ; Deg = ',I3,' ; Lev = ',I3)
10130 FORMAT(1X,8X,'MLimp MSimp MJimp  Limp  Simp  Jimp MSbath',
     &1X,'Imp.Occs:   tot',5X, 'Bath Occupancies: tot')
10131 FORMAT(1X,8X,'MLimp MSimp MJimp  Limp  Simp  Jimp MSbath',
     &1X,'Imp.Occs:   tot',25X,'Bath Occupancies: tot')
10132 FORMAT(1X,8X,'MLimp MSimp MJimp  Limp  Simp  Jimp MSbath',
     &1X,'Imp.Occs:   tot',45X,'Bath Occupancies: tot')
10133 FORMAT(1X,8X,'MLimp MSimp MJimp  Limp  Simp  Jimp MSbath',
     &1X,'Imp.Occs:   tot',65X,'Bath Occupancies: tot')
10140 FORMAT(1X,I7,7(1X,A5),'|',3(A5) ,5X,65(A5))
10141 FORMAT(1X,I7,7(1X,A5),'|',7(A5) ,5X,65(A5))
10142 FORMAT(1X,I7,7(1X,A5),'|',11(A5),5X,65(A5))
10143 FORMAT(1X,I7,7(1X,A5),'|',15(A5),5X,65(A5))
      DEALLOCATE(EORD,IREF,KREP,ECLS)
      DEALLOCATE(DMSIMP,DMLIMP,DMJIMP,DSSIMP,DLLIMP)
      DEALLOCATE(DJJIMP,OCCIMP,TIMP,TCLS,TBAT)
	DEALLOCATE(NMATPOC,NMATPMS,NMATPML,NMATPMJ,NMATPSS)
	DEALLOCATE(NMATPLL,NMATPJJ,FMATPOC,FMATPMS,FMATPML)
	DEALLOCATE(FMATPMJ,FMATPSS,FMATPLL,FMATPJJ,IMATPOC)
	DEALLOCATE(IMATPMS,IMATPML,IMATPMJ,IMATPSS,IMATPLL)
	DEALLOCATE(IMATPJJ,NFOCD,IMATBATH,OCCBAT,DMSBAT)
      END





      
      
	SUBROUTINE RAT_CLSDIAG_BATH_OLD(SPECBATH,IFBATH,NBATH,NFOCBATH)
***************************************************************
*  Prepare bath states
***************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_RATHYB  ,ONLY: NHYB,EHYB                               !!! from readrat
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                         !!! from setup
      IMPLICIT REAL*8 (A-H,O-Z)
C PASSED VARIABLES
      INTEGER IFBATH(0:NHYB,NFOCBATH)
      REAL*8 SPECBATH(NFOCBATH)
C SET LOCAL VARIABLES
      INTEGER, ALLOCATABLE ::  IFVECT(:)
      INTEGER, ALLOCATABLE ::  IEXCIT(:)
      INTEGER, ALLOCATABLE ::  IREF(:)
      INTEGER, ALLOCATABLE ::  ITMP(:)
	REAL*8, ALLOCATABLE :: COMB(:,:)
	COMPLEX*16 DIM
	DATA PI/3.141592653589793D0/,DIM/(0.D0,1.D0)/
	IF(NBATH.GT.NHYB.OR.NBATH.LT.0)RETURN ! No bath states
C Get combinatorics
	ALLOCATE(COMB(0:NHYB,0:NHYB))
	CALL LIB_GETCOMB(COMB,NHYB)
	IF(NFOCBATH.NE.NINT(COMB(NBATH,NHYB)))
     &CALL FULLSTOP('<SPECBATH>:: NFOCBATH MISMATCH')
C CREATE FOCK SPACE FOR GIVEN OCCUPANCY
	ALLOCATE(IFVECT(0:NHYB))
C Represent each Fock vector using binary system
      NDIM=2**NHYB
      IFOC=0
	DO IVEC=1,NDIM-1
	ITWO=1
	IMAX=0
	DO WHILE(IVEC.GE.ITWO)
	ITWO=ITWO*2
	IMAX=IMAX+1
	ENDDO
	IFVECT(IMAX)=1
      IBATH=1
	DO IS=IMAX+1,NHYB
	IFVECT(IS)=0
	ENDDO
	INUM=IVEC
	DO I=IMAX-1,1,-1
	ITWO=ITWO/2
	INUM=INUM-ITWO*IFVECT(I+1)
	IFVECT(I)=INUM/(ITWO/2)
	IBATH=IBATH+IFVECT(I)
	ENDDO
C Check number of electrons
      IF(IBATH.NE.NBATH)CYCLE
      IFOC=IFOC+1
      DO IS=1,NHYB
      IFBATH(IS,IFOC)=IFVECT(IS)  ! record electrons slot occupancies
      ENDDO	
      IFBATH(0 ,IFOC)=IVEC       ! record binary number itself
	ENDDO
	IF(NBATH.EQ.0)THEN
	IFOC=1
	DO IS=1,NHYB
	IFBATH(IS,IFOC)=0
	ENDDO
	IFBATH(0,IFOC)=0
	ENDIF
	IF(IFOC.NE.NFOCBATH)
     &CALL FULLSTOP('<SPECBATH>::IFOC.NE.NFOCBATH')
C Calculate many body levels of the bath
	DO IFOC=1,NFOCBATH
      EBATH=0.D0	
      DO IS=1,NHYB
	EBATH=EBATH+DREAL(EHYB(IS))*IFBATH(IS,IFOC)
	ENDDO
	SPECBATH(IFOC)=EBATH
	ENDDO
C Order spectrum in increasing order
      ALLOCATE(IREF(NFOCBATH))
      DO IFOC=1,NFOCBATH
      IREF(IFOC)=IFOC
      ENDDO
      DO IFOC=1,NFOCBATH
      DO JFOC=IFOC+1,NFOCBATH
      IF(SPECBATH(IFOC).GT.SPECBATH(JFOC))THEN
      EBATHJ=SPECBATH(JFOC)
      SPECBATH(JFOC)=SPECBATH(IFOC)
      SPECBATH(IFOC)=EBATHJ
	I=IREF(IFOC)
	IREF(IFOC)=IREF(JFOC)
	IREF(JFOC)=I
      ENDIF
      ENDDO
      ENDDO
C Ordering done, swap Fock vectors as well
      ALLOCATE(ITMP(NFOCBATH))
      DO IS=0,NHYB
      DO IFOC=1,NFOCBATH
      ITMP(IFOC)=IFBATH(IS,IREF(IFOC))
      ENDDO
      DO IFOC=1,NFOCBATH
      IFBATH(IS,IFOC)=ITMP(IFOC)
      ENDDO
      ENDDO
C Find the ground state, if more than 1 then it's degenerate.
      DO IFOC=2,NFOCBATH
      IF(SPECBATH(IFOC).GT.SPECBATH(1))EXIT
      ENDDO
      NGRO=IFOC-1  ! 
C Evaluate how many electrons are excited with respect to the ground state
      ALLOCATE(IEXCIT(NFOCBATH))
      DO IFOC=1,NGRO
      IEXCIT(IFOC)=0
      ENDDO
      DO IFOC=NGRO+1,NFOCBATH
      NEXC=NHYB
      DO IGRO=1,NGRO
      IEXC=0
      DO IS=1,NHYB
      IEXC=IEXC+ABS(IFBATH(IS,IFOC)-IFBATH(IS,IGRO))
      ENDDO
      IF(MOD(IEXC,2).NE.0)
     &CALL FULLSTOP('<RAT_CLSDIAG_BATH>:: Error in IEXC')
      IEXC=IEXC/2
      NEXC=MIN(IEXC,NEXC)
      ENDDO
      IEXCIT(IFOC)=NEXC
      ENDDO
	DEALLOCATE(COMB,IFVECT,IREF,ITMP,IEXCIT)
	END



	SUBROUTINE RAT_CLSDIAG_BATH(SPECBATH,IFBATH,NBATH,
     &                            NFOCBMAX,NFOCBATH)
***************************************************************
*  Prepare bath states
***************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_RATHYB  ,ONLY: NHYB,EHYB                               !!! from readrat
      USE COM_RATCLS  ,ONLY: NEXCPAR,EXCTEMP                         !!! from readrat
      USE COM_RATPAR  ,ONLY: EPSHUB,EPSDEG                           !!! from readrat
	USE COM_MSBMESH ,ONLY: TEMP                                    !!! from readrat
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                         !!! from setup
      IMPLICIT REAL*8 (A-H,O-Z)
C PASSED VARIABLES
      INTEGER IFBATH(0:NHYB,NFOCBMAX)
      REAL*8 SPECBATH(NFOCBMAX)
C SET LOCAL VARIABLES
      INTEGER, ALLOCATABLE :: IFGRO(:,:)
      INTEGER, ALLOCATABLE :: IFEXC(:,:)
      INTEGER, ALLOCATABLE :: IFMEM(:,:)
      INTEGER, ALLOCATABLE :: IFBAT(:,:)
      INTEGER, ALLOCATABLE :: IPREV(:,:)
      INTEGER, ALLOCATABLE :: INEXT(:,:)
      INTEGER, ALLOCATABLE :: IFVEC(:)
      INTEGER, ALLOCATABLE :: IORD(:)
      INTEGER, ALLOCATABLE :: IREF(:)
      INTEGER, ALLOCATABLE :: ITMP(:)
      INTEGER, ALLOCATABLE :: KREP(:)
	REAL*8, ALLOCATABLE :: ELEV(:)
	REAL*8, ALLOCATABLE :: EREP(:)
	REAL*8, ALLOCATABLE :: COMB(:,:)
	REAL*8, ALLOCATABLE :: SPEC(:)
	REAL*8, ALLOCATABLE :: XHUB(:)
	DATA PI/3.141592653589793D0/
	IF(NBATH.GT.NHYB.OR.NBATH.LT.0)RETURN ! No bath states
C Get combinatorics
	ALLOCATE(COMB(0:NHYB,0:NHYB))
	CALL LIB_GETCOMB(COMB,NHYB)
C *******************************************
C Build full Hilbert space for the bath	
      IF(NEXCPAR.EQ.-1)THEN	               !!! <- Full Hilbert space
C If only dimension is required return now      
      IF(NFOCBMAX.EQ.0)THEN
      NFOCBATH=NINT(COMB(NBATH,NHYB))
      DEALLOCATE(COMB)
      RETURN
      ENDIF
C Start building Hylbert space
      NFOCBATH=NFOCBMAX
	IF(NFOCBMAX.NE.NINT(COMB(NBATH,NHYB)))
     &CALL FULLSTOP('<SPECBATH>:: NFOCBMAX MISMATCH')
C CREATE FOCK SPACE FOR GIVEN OCCUPANCY
	ALLOCATE(IFVEC(0:NHYB))
C Represent each Fock vector using binary system
      NDIM=2**NHYB
      IFOC=0
	DO IVEC=1,NDIM-1
	ITWO=1
	IMAX=0
	DO WHILE(IVEC.GE.ITWO)
	ITWO=ITWO*2
	IMAX=IMAX+1
	ENDDO
	IFVEC(IMAX)=1
      IBATH=1
	DO IS=IMAX+1,NHYB
	IFVEC(IS)=0
	ENDDO
	INUM=IVEC
	DO I=IMAX-1,1,-1
	ITWO=ITWO/2
	INUM=INUM-ITWO*IFVEC(I+1)
	IFVEC(I)=INUM/(ITWO/2)
	IBATH=IBATH+IFVEC(I)
	ENDDO
C Check number of electrons
      IF(IBATH.NE.NBATH)CYCLE
      IFOC=IFOC+1
      DO IS=1,NHYB
      IFBATH(IS,IFOC)=IFVEC(IS)  ! record electrons slot occupancies
      ENDDO	
      IFBATH(0 ,IFOC)=IVEC       ! record binary number itself
	ENDDO
	IF(NBATH.EQ.0)THEN
	IFOC=1
	DO IS=1,NHYB
	IFBATH(IS,IFOC)=0
	ENDDO
	IFBATH(0,IFOC)=0
	ENDIF
	IF(IFOC.NE.NFOCBATH)
     &CALL FULLSTOP('<SPECBATH>::IFOC.NE.NFOCBATH')
      DEALLOCATE(IFVEC)
C *******************************************
C Build restricted Hilbert space for the bath	
      ELSEIF(NEXCPAR.GE.0)THEN	               !!! <- Restricted Hilbert space
C Sort bath levels in increasing order
      ALLOCATE(IORD(NHYB))
      ALLOCATE(ELEV(NHYB))
      DO IHYB=1,NHYB
      ELEV(IHYB)=DREAL(EHYB(IHYB))
      IORD(IHYB)=IHYB
      ENDDO
      DO IHYB=1,NHYB
      DO JHYB=IHYB+1,NHYB
      IF(ELEV(IHYB).GT.ELEV(JHYB))THEN
      ELEVJ=ELEV(JHYB)
      ELEV(JHYB)=ELEV(IHYB)
      ELEV(IHYB)=ELEVJ
	I=IORD(IHYB)
	IORD(IHYB)=IORD(JHYB)
	IORD(JHYB)=I
      ENDIF
      ENDDO
      ENDDO
C Check it      
      DO IHYB=1,NHYB 
      IF(ABS(DREAL(EHYB(IORD(IHYB)))-ELEV(IHYB)).GT.1.D-08)
     &CALL FULLSTOP('<RAT_CLSDIAG_BATH>:: Wrong ordering!')
	ENDDO
C Count level degeneracies
	NREP=1
	DO IHYB=2,NHYB
	IF(ABS(ELEV(IHYB-1)-ELEV(IHYB)).LE.EPSDEG)CYCLE
	NREP=NREP+1
	ENDDO
	ALLOCATE(KREP(NREP))
	IREP=1
	KREP(1)=1
	DO IHYB=2,NHYB
	IF(ABS(ELEV(IHYB-1)-ELEV(IHYB)).LE.EPSDEG)KREP(IREP)=KREP(IREP)+1
	IF(ABS(ELEV(IHYB-1)-ELEV(IHYB)).LE.EPSDEG)CYCLE
	IREP=IREP+1
	KREP(IREP)=1
	ENDDO
	IDEG=0
	DO IREP=1,NREP
	IDEG=IDEG+KREP(IREP)
	ENDDO
	IF(IDEG.NE.NHYB)
     &CALL FULLSTOP('<RAT_CLSDIAG_BATH>: Wrong degeneracy')
C Degenerate Levels
	ALLOCATE(EREP(NREP))
	IHYB=0
	DO IREP=1,NREP
	EREP(IREP)=0.D0
	DO IALP=1,KREP(IREP)
	IHYB=IHYB+1
	EREP(IREP)=EREP(IREP)+ELEV(IHYB)
	ENDDO
	EREP(IREP)=EREP(IREP)/DBLE(KREP(IREP))
	ENDDO
C T=0 case **********************************
C Distribute Nbath electrons over Erep states
      IF(ABS(EXCTEMP).LE.1.D-10)THEN
      NELEC=0
      DO IREP=1,NREP
      NELEC=NELEC+KREP(IREP)
      IF(NELEC.GT.NBATH)EXIT
      ENDDO
      IREPF=IREP-1  !!! Filled bath levels are up to IREPF
      IREPL=IREP    !!! The last one is partially filled or empty
      IF(NELEC.NE.NBATH)
     &NDEGL=KREP(IREPL)
      IF(NELEC.EQ.NBATH)
     &NDEGL=0
      NELEC=NELEC-NDEGL
      NLAST=NBATH-NELEC
      IF(NLAST.GT.NDEGL)
     &CALL FULLSTOP('<RAT_CLSDIAG_BATH>: Wrong Filling')
      NGRO=COMB(NLAST,NDEGL) !!! Degeneracy of the ground state
C Set Fock vectors for the ground State(s)
      ALLOCATE(IFGRO(NHYB,NGRO))
      DO IGRO=1,NGRO
      DO IHYB=1,NHYB
      IFGRO(IHYB,IGRO)=0
      ENDDO
      ENDDO
C Set slots to 1 for all fully filled states       
      DO IGRO=1,NGRO
	IHYB=0
	DO IREP=1,IREPF
	DO IALP=1,KREP(IREP)
	IHYB=IHYB+1
      IFGRO(IHYB,IGRO)=1
	ENDDO
	ENDDO
	ENDDO
C Distribute Nlast electrons over NDEGL slots
      ALLOCATE(IFVEC(NDEGL))
      NDIM=2**NDEGL
      IGRO=0
	DO IVEC=1,NDIM-1
	ITWO=1
	IMAX=0
	DO WHILE(IVEC.GE.ITWO)
	ITWO=ITWO*2
	IMAX=IMAX+1
	ENDDO
	IFVEC(IMAX)=1
      IELEC=1
	DO IS=IMAX+1,NDEGL
	IFVEC(IS)=0
	ENDDO
	INUM=IVEC
	DO I=IMAX-1,1,-1
	ITWO=ITWO/2
	INUM=INUM-ITWO*IFVEC(I+1)
	IFVEC(I)=INUM/(ITWO/2)
	IELEC=IELEC+IFVEC(I)
	ENDDO
C Check number of electrons
      IF(IELEC.NE.NLAST)CYCLE
      IGRO=IGRO+1
	IHYB=0
	DO IREP=1,IREPF
	DO IALP=1,KREP(IREP)
	IHYB=IHYB+1
      ENDDO
      ENDDO      
      DO IS=1,NDEGL
      IFGRO(IHYB+IS,IGRO)=IFVEC(IS)  ! record electrons slot occupancies
      ENDDO	
	ENDDO
	IF(NLAST.EQ.0)THEN
	IGRO=1
	IHYB=0
	DO IREP=1,IREPF
	DO IALP=1,KREP(IREP)
	IHYB=IHYB+1
      ENDDO
      ENDDO      
	DO IS=1,NDEGL
	IFGRO(IHYB+IS,IGRO)=0
	ENDDO
	ENDIF
	IF(IGRO.NE.NGRO)
     &CALL FULLSTOP('<RAT_CLSDIAG_BATH>::IGRO.NE.NGRO')
	IHYBF0=0
	DO IREP=1,IREPF
	DO IALP=1,KREP(IREP)
	IHYBF0=IHYBF0+1
      ENDDO
      ENDDO
      IHYBL0=IHYBF0
      IF(NLAST.GT.0)IHYBL0=IHYBL0+NDEGL
C T.ne.0 case *******************************
      ELSEIF(ABS(EXCTEMP).GT.1.D-10)THEN
C Find chemical potential
	ZDIF=0.D0
	JTER=0
	EMIN=ELEV(1)
	EMAX=ELEV(NHYB)
	WDTH=ABS(EMAX-EMIN)
	IF(WDTH.LE.1.D-10)WDTH=1.D0
	E1=EMIN-5.D0*WDTH
	E2=EMAX+5.D0*WDTH
	EFRM=(EMAX+EMIN)/2.D0
      CALL LIB_FINDROOT(EFRM,ZDIF,E1,E2,JTER,IEXIT,IUN,1.D-05,50)
  100 JTER=JTER+1
C Find new charge
	ZSUM=0.D0
	DO IHYB=1,NHYB
	ZSUM=ZSUM+1.D0/(SAFEEXP((ELEV(IHYB)-EFRM)/EXCTEMP)+1.D0)
	ENDDO
C Difference
	ZDIF=DBLE(NBATH)-ZSUM
	CALL LIB_FINDROOT(EFRM,ZDIF,E1,E2,JTER,IEXIT,IUN,1.D-05,50)
	IF(IEXIT.EQ.1)GOTO 200
	GOTO 100
  200 CONTINUE
	CHEM=EFRM
C Find occupancies for each level and
C select maximum level for which occupancy is still not equal zero
	ZSUM=0.D0
	DO IHYB=1,NHYB
	ZSUM=ZSUM+1.D0/(SAFEEXP((ELEV(IHYB)-EFRM)/EXCTEMP)+1.D0)
	IF(ABS(ZSUM-DBLE(NBATH)).LE.ZDIF)EXIT
	ENDDO
      IF(IHYB.GT.NHYB)IHYB=NHYB
      IHYBFRM=IHYB
C Distribute bath electrons over the levels, build possible equilibrium states
      ALLOCATE(IFVEC(IHYBFRM))
      NDIM=2**IHYBFRM
      NFOC=0
      DO ITWICE=1,2            !!! do twice, first counts dimension, second fills arrays
      IF(ITWICE.EQ.2)ALLOCATE(IFBAT(0:NHYB,NFOC))
      IFOC=0
	DO IVEC=1,NDIM-1         ! do over all possible Fock states
	ITWO=1
	IMAX=0
	DO WHILE(IVEC.GE.ITWO)
	ITWO=ITWO*2
	IMAX=IMAX+1
	ENDDO
	IFVEC(IMAX)=1
      IBATH=1
	DO IS=IMAX+1,IHYBFRM
	IFVEC(IS)=0
	ENDDO
	INUM=IVEC
	DO I=IMAX-1,1,-1
	ITWO=ITWO/2
	INUM=INUM-ITWO*IFVEC(I+1)
	IFVEC(I)=INUM/(ITWO/2)
	IBATH=IBATH+IFVEC(I)
	ENDDO
C Check number of electrons
      IF(IBATH.NE.NBATH)CYCLE
      IFOC=IFOC+1
C Set Fock vectors on second run      
      IF(ITWICE.EQ.2)THEN
      DO IS=1,IHYBFRM
      IFBAT(IS,IFOC)=IFVEC(IS)  ! record electrons slot occupancies
      ENDDO	
      DO IS=IHYBFRM+1,NHYB
      IFBAT(IS,IFOC)=0
      ENDDO	
      ENDIF
	ENDDO                  !!! over all possible Fock states
C Set Fock vectors on second run      
	IF(NBATH.EQ.0)THEN
	IFOC=1
	IF(ITWICE.EQ.2)THEN
	DO IS=1,NHYB
	IFBAT(IS,IFOC)=0
	ENDDO
	ENDIF
	ENDIF
      NFOC=IFOC
	ENDDO                  !!! over iTwice
      DEALLOCATE(IFVEC)
C Calculate many body levels of the bath
      ALLOCATE(SPEC(NFOC))
	DO IFOC=1,NFOC
      EBATH=0.D0	
      DO IS=1,NHYB
	EBATH=EBATH+ELEV(IS)*IFBAT(IS,IFOC)
	ENDDO
	SPEC(IFOC)=EBATH
	ENDDO
C Order spectrum in increasing order
      ALLOCATE(IREF(NFOC))
      DO IFOC=1,NFOC
      IREF(IFOC)=IFOC
      ENDDO
      DO IFOC=1,NFOC
      DO JFOC=IFOC+1,NFOC
      IF(SPEC(IFOC).GT.SPEC(JFOC))THEN
      EBATHJ=SPEC(JFOC)
      SPEC(JFOC)=SPEC(IFOC)
      SPEC(IFOC)=EBATHJ
	I=IREF(IFOC)
	IREF(IFOC)=IREF(JFOC)
	IREF(JFOC)=I
      ENDIF
      ENDDO
      ENDDO
C Ordering done, swap Fock vectors as well
      ALLOCATE(ITMP(NFOC))
      DO IS=0,NHYB
      DO IFOC=1,NFOC
      ITMP(IFOC)=IFBAT(IS,IREF(IFOC))
      ENDDO
      DO IFOC=1,NFOC
      IFBAT(IS,IFOC)=ITMP(IFOC)
      ENDDO
      ENDDO
      DEALLOCATE(IREF,ITMP)
C Find probabilities 
      ALLOCATE(XHUB(NFOC))
      DO IFOC=1,NFOC 
      XHUB(IFOC)=1.D0
	EXIT
	ENDDO
      DO IFOC=1,NFOC-1
      E=SPEC(IFOC+1)-SPEC(IFOC)
      XHUB(IFOC+1)=SAFEEXP(-E/EXCTEMP)*XHUB(IFOC)
      ENDDO
C Renormalize 
      XSUM=0.D0
      DO IFOC=1,NFOC
      XSUM=XSUM+XHUB(IFOC)
      ENDDO
      DO IFOC=1,NFOC
      XHUB(IFOC)=XHUB(IFOC)/XSUM
      ENDDO
C Check renormalizaton
	XSUM=0.D0
      DO IFOC=1,NFOC
      XSUM=XSUM+XHUB(IFOC)
      ENDDO
	IF(ABS(XSUM-1.D0).GT.1.D-10)
     &CALL FULLSTOP('<RAT_CLSDIAG_BATH>:: Normalization error')
C Select equilibrium states from non-zero probabilities      
      IGRO=0
      DO IFOC=1,NFOC
      IF(XHUB(IFOC).GT.EPSHUB)IGRO=IGRO+1
      ENDDO
      NGRO=IGRO
      ALLOCATE(IFGRO(NHYB,NGRO))
      IGRO=0
      DO IFOC=1,NFOC
      IF(XHUB(IFOC).GT.EPSHUB)THEN
      IGRO=IGRO+1
      DO IHYB=1,NHYB
      IFGRO(IHYB,IGRO)=IFBAT(IHYB,IFOC)
      ENDDO
      ENDIF
      ENDDO
      DEALLOCATE(XHUB,SPEC,IFBAT)
      ENDIF
C **************************************
C Check limits
      IHYBF=0
      DO IHYB=1,NHYB
      ISUM=0
      DO IGRO=1,NGRO
      IF(IFGRO(IHYB,IGRO).EQ.1)ISUM=ISUM+1
      ENDDO
      IF(ISUM.EQ.NGRO)IHYBF=IHYB
      IF(ISUM.NE.NGRO)EXIT
      ENDDO
      IHYBL=NHYB
      DO IHYB=NHYB,1,-1
      ISUM=0
      DO IGRO=1,NGRO
      IF(IFGRO(IHYB,IGRO).EQ.0)ISUM=ISUM+1
      ENDDO
      IF(ISUM.NE.NGRO)IHYBL=IHYB
      IF(ISUM.NE.NGRO)EXIT
      ENDDO
C Find Fock vectors for excitations involving up to N particles
      ALLOCATE(IPREV(NHYB,NGRO))
      ALLOCATE(IFEXC(NHYB,NGRO))
      DO IGRO=1,NGRO
      DO IHYB=1,NHYB
      IPREV(IHYB,IGRO)=IFGRO(IHYB,IGRO)
      IFEXC(IHYB,IGRO)=IFGRO(IHYB,IGRO)
      ENDDO
      ENDDO
      NPRE=NGRO
      NFOC=NGRO
C Do over excitations      
      DO IPAR=1,NEXCPAR
C Record current Fock array
      ALLOCATE(IFMEM(NHYB,NFOC))
      DO IFOC=1,NFOC
      DO IHYB=1,NHYB
      IFMEM(IHYB,IFOC)=IFEXC(IHYB,IFOC)
      ENDDO
      ENDDO
      DEALLOCATE(IFEXC)
C Find one-particle excitations relative to a given set of states      
      NEXTMAX=NPRE*NBATH*(NHYB-NBATH)
      ALLOCATE(INEXT(NHYB,NEXTMAX))
      CALL RAT_CLSDIAG_IEXC(IPREV,NPRE,INEXT,NEXTMAX,NEXT,
     &                      IFMEM,NFOC,NHYB,IHYBL,IHYBF)
      ALLOCATE(IFEXC(NHYB,NFOC+NEXT))
      DO IFOC=1,NFOC
      DO IHYB=1,NHYB
      IFEXC(IHYB,IFOC)=IFMEM(IHYB,IFOC)
      ENDDO
      ENDDO
      DEALLOCATE(IFMEM)
      DO IFOC=1,NEXT
      DO IHYB=1,NHYB
      IFEXC(IHYB,NFOC+IFOC)=INEXT(IHYB,IFOC)
      ENDDO
      ENDDO
      NFOC=NFOC+NEXT
      NPRE=NEXT
      DEALLOCATE(IPREV)
      ALLOCATE(IPREV(NHYB,NEXT))
      DO IFOC=1,NEXT
      DO IHYB=1,NHYB
      IPREV(IHYB,IFOC)=INEXT(IHYB,IFOC)
      ENDDO
      ENDDO
      DEALLOCATE(INEXT)
      ENDDO
      DEALLOCATE(ELEV,EREP,KREP,IFGRO,IPREV)
C If only dimension was required return now
      IF(NFOCBMAX.EQ.0)THEN
      NFOCBATH=NFOC
      DEALLOCATE(COMB,IORD,IFEXC)
      RETURN
      ENDIF
C Hilbert space is made, return to original numeration of levels      
      DO IFOC=1,NFOC
      DO IHYB=1,NHYB 
      IFBATH(IORD(IHYB),IFOC)=IFEXC(IHYB,IFOC)
	ENDDO
      ENDDO
      DEALLOCATE(IFEXC,IORD)
C Encode using binary numbers
      DO IFOC=1,NFOC
	IVECPM=0
	ITWO=1
      DO IHYB=1,NHYB 
	IVECPM=IVECPM+IFBATH(IHYB,IFOC)*ITWO
	ITWO=ITWO*2
	ENDDO
      IFBATH(0,IFOC)=IVECPM
      ENDDO
      NFOCBATH=NFOC
      ENDIF                          !!! <- for full/restricted Hilbert spaces
C **************************************
C Calculate many body levels of the bath
	DO IFOC=1,NFOCBATH
      EBATH=0.D0	
      DO IS=1,NHYB
	EBATH=EBATH+DREAL(EHYB(IS))*IFBATH(IS,IFOC)
	ENDDO
	SPECBATH(IFOC)=EBATH
	ENDDO
C Order spectrum in increasing order
      ALLOCATE(IREF(NFOCBATH))
      DO IFOC=1,NFOCBATH
      IREF(IFOC)=IFOC
      ENDDO
      DO IFOC=1,NFOCBATH
      DO JFOC=IFOC+1,NFOCBATH
      IF(SPECBATH(IFOC).GT.SPECBATH(JFOC))THEN
      EBATHJ=SPECBATH(JFOC)
      SPECBATH(JFOC)=SPECBATH(IFOC)
      SPECBATH(IFOC)=EBATHJ
	I=IREF(IFOC)
	IREF(IFOC)=IREF(JFOC)
	IREF(JFOC)=I
      ENDIF
      ENDDO
      ENDDO
C Ordering done, swap Fock vectors as well
      ALLOCATE(ITMP(NFOCBATH))
      DO IS=0,NHYB
      DO IFOC=1,NFOCBATH
      ITMP(IFOC)=IFBATH(IS,IREF(IFOC))
      ENDDO
      DO IFOC=1,NFOCBATH
      IFBATH(IS,IFOC)=ITMP(IFOC)
      ENDDO
      ENDDO
C Memory deallocations      
      DEALLOCATE(COMB,IREF,ITMP)
      END




	SUBROUTINE RAT_CLSDIAG_IEXC(IFGRO,NGRO,IFEXC,NEXCMAX,NEXC,
     &                            IFMEM,NFOC,NHYB,IHYBL,IHYBF)
***************************************************************
*  Prepare bath states
***************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                         !!! from setup
      IMPLICIT REAL*8 (A-H,O-Z)
C Passed variables      
      INTEGER IFGRO(NHYB,NGRO),IFEXC(NHYB,NEXCMAX),IFMEM(NHYB,NFOC)
C Allocatable arrays
      INTEGER, ALLOCATABLE :: IFVEC(:)
	DATA PI/3.141592653589793D0/
C Memory allocations
	ALLOCATE(IFVEC(NHYB))
C Set one-particle excitations out of the ground state(s)
      IEXC=0
      DO IGRO=1,NGRO
C Copy vector
      NFILL=0
      DO IS=1,NHYB
	IFVEC(IS)=IFGRO(IS,IGRO)
	NFILL=NFILL+IFVEC(IS)
	ENDDO
C Do over states
	DO IHYB=1,IHYBL
C Destroy particle in IS slot
	IF(IFGRO(IHYB,IGRO).NE.1)CYCLE    !!! operator C+(is) creates the particle
	IFVEC(IHYB)=0
	DO IHYB1=IHYBF+1,NHYB
	IF(IHYB.EQ.IHYB1)CYCLE
C Create particle in IS1 slot
	IF(IFGRO(IHYB1,IGRO).NE.0)CYCLE   !!! operator C(is) destroys the particle
	IFVEC(IHYB1)=1
C Check if this state didnt appear before
      IFLAG=0
      DO IFOC=1,IEXC
      ISUM=0
      DO IS=1,NHYB
      IF(IFVEC(IS).EQ.IFEXC(IS,IFOC))ISUM=ISUM+1
      ENDDO
      IF(ISUM.EQ.NHYB)IFLAG=1
      IF(IFLAG.EQ.1)EXIT
      ENDDO
      DO IFOC=1,NFOC
      ISUM=0
      DO IS=1,NHYB
      IF(IFVEC(IS).EQ.IFMEM(IS,IFOC))ISUM=ISUM+1
      ENDDO
      IF(ISUM.EQ.NHYB)IFLAG=1
      IF(IFLAG.EQ.1)EXIT
      ENDDO
C Record this excited state      
      IF(IFLAG.EQ.0)THEN
      IEXC=IEXC+1
      NFVEC=0
      DO IS=1,NHYB
      IFEXC(IS,IEXC)=IFVEC(IS)
      NFVEC=NFVEC+IFVEC(IS)
      ENDDO
      IF(NFVEC.NE.NFILL)
     &CALL FULLSTOP('<RAT_CLSDIAG_BMAT>:: NFVEC.NE.NFILL')
      ENDIF
      IFVEC(IHYB1)=0
      ENDDO                           !!! over states
      IFVEC(IHYB)=1
      ENDDO                           !!! over states
      ENDDO                           !!! over ground states
      NEXC=IEXC
C Memory deallocations
	DEALLOCATE(IFVEC)
      END


	SUBROUTINE RAT_CLSDIAG_BMAT(IFBATN,IFBATPM,ICDBATN,NHYB,
     &           NFOCN,NFOCPM,NCUTN,NCUTPM,TOPER)
***************************************************************
*  Prepare bath states
***************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                         !!! from setup
      IMPLICIT REAL*8 (A-H,O-Z)
C PASSED VARIABLES
      INTEGER IFBATN(0:NHYB,NFOCN),IFBATPM(0:NHYB,NFOCPM)
     &       ,ICDBATN(NHYB,NCUTN)
      CHARACTER TOPER*1
C SET LOCAL VARIABLES
      INTEGER, ALLOCATABLE ::  IFVECT(:)
	DATA PI/3.141592653589793D0/
	IF(TOPER.NE.'C'.AND.TOPER.NE.'D')
     &CALL FULLSTOP('<RAT_CLSDIAG_BMAT>: TOPER IS WRONG')
	ALLOCATE(IFVECT(NHYB))
      DO IFOC=1,NCUTN
      DO IS=1,NHYB
      ICDBATN(IS,IFOC)=0
	ENDDO
	ENDDO
C Do over Fock space for N=NBATH electrons
      DO 2000 IFOC=1,NCUTN                 !!! over Fock space
C Copy vector
      DO IS=1,NHYB
	IFVECT(IS)=IFBATN(IS,IFOC)
	ENDDO
C Do over states
      DO 1000 IS=1,NHYB                    !!! over states
C Create particle in IS slot
      IF(TOPER.EQ.'C')THEN
	IF(IFBATN(IS,IFOC).NE.0)GOTO 1000    !!! operator C+(is) creates the particle
	IFVECT(IS)=1
	ISUMS=0
	DO I=1,IS-1
	ISUMS=ISUMS+IFVECT(I)
	ENDDO
	ISIGN=(-1)**ISUMS
C Destroy particle in IS slot
	ELSEIF(TOPER.EQ.'D')THEN
	IF(IFBATN(IS,IFOC).NE.1)GOTO 1000    !!! operator C(is) destroys the particle
	IFVECT(IS)=0
	ISUMS=0
	DO I=1,IS-1
	ISUMS=ISUMS+IFVECT(I)
	ENDDO
	ISIGN=(-1)**ISUMS
	ENDIF
C We got state iFvect, find out this state number
	IVECPM=0
	ITWO=1
	DO I=1,NHYB
	IVECPM=IVECPM+IFVECT(I)*ITWO
	ITWO=ITWO*2
	ENDDO
      DO IFOCPM=1,NCUTPM
      IF(IFBATPM(0,IFOCPM).EQ.IVECPM)EXIT
      ENDDO
      IF(IFOCPM.EQ.NCUTPM+1)IFOCPM=0
      ICDBATN(IS,IFOC)=IFOCPM*ISIGN
C Rewind the state back
	IF(TOPER.EQ.'D')IFVECT(IS)=1
	IF(TOPER.EQ.'C')IFVECT(IS)=0
 1000 CONTINUE                           !!! over states
 2000 CONTINUE                           !!! over Fock vectors
      DEALLOCATE(IFVECT)
      END



	SUBROUTINE RAT_CLSDIAG_XNOT(NDEG,NDIM,NDEX,NFOC,NEXT,LCLS,
     &           SPEC,SEXT,CHEM,TEMP,XHUB,XEXT)
*******************************************************
*  Finds correlational functions for a cluster        *
*******************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER, ALLOCATABLE :: IREF(:)
	REAL*8, ALLOCATABLE :: ECLS(:)
	REAL*8, ALLOCATABLE :: XCLS(:)
	INTEGER LCLS(0:NDEG),NFOC(0:NDEG),NEXT(0:NDEG)
	REAL*8 XHUB(NDIM),SPEC(NDIM),XEXT(NDEX),SEXT(NDEX)
	DATA EPS/1.D-05/
	ALLOCATE(ECLS(NDIM+NDEX))
	ALLOCATE(XCLS(NDIM+NDEX))
	ALLOCATE(IREF(NDIM+NDEX))
C Order atomic states in increasing order
	DO IDIM=1,NDIM
	ECLS(IDIM)=0.D0
	XCLS(IDIM)=0.D0
	XHUB(IDIM)=0.D0
	IREF(IDIM)=0
	ENDDO
	MDIM=0
	DO IOCC=0,NDEG
	IF(LCLS(IOCC).EQ.0)CYCLE
	MDIM=MDIM+NFOC(IOCC)
	DO IFOC=1,NFOC(IOCC)
	IDIM=IFOC+MDIM-NFOC(IOCC)
	ECLS(IDIM)=SPEC(IDIM)-CHEM*DBLE(IOCC)
	IREF(IDIM)=IDIM
	ENDDO
	ENDDO
	MEXT=0
	DO IOCC=0,NDEG
	IF(LCLS(IOCC).EQ.0)CYCLE
	MDIM=MDIM+NEXT(IOCC)
	MEXT=MEXT+NEXT(IOCC)
	DO IFOC=1,NEXT(IOCC)
	IDIM=IFOC+MDIM-NEXT(IOCC)
	IEXT=IFOC+MEXT-NEXT(IOCC)
	ECLS(IDIM)=SEXT(IEXT)-CHEM*DBLE(IOCC)
	IREF(IDIM)=-IEXT
	ENDDO
	ENDDO
C Sort energies in increasing order
      DO ISTR=1,NDIM+NDEX
	IF(IREF(ISTR).EQ.0)CYCLE
      DO JSTR=ISTR+1,NDIM+NDEX
	IF(IREF(JSTR).EQ.0)CYCLE
	IF(ECLS(ISTR).GT.ECLS(JSTR))THEN
	S=ECLS(ISTR)
	ECLS(ISTR)=ECLS(JSTR)
	ECLS(JSTR)=S
	I=IREF(ISTR)
	IREF(ISTR)=IREF(JSTR)
	IREF(JSTR)=I
	ENDIF
	ENDDO
	ENDDO
C In this ordering scheme we can loop forward only
	IF(TEMP.GT.0.D0)THEN
      DO ISTR=1,NDIM+NDEX-1
	IF(IREF(ISTR).EQ.0)CYCLE
      XCLS(ISTR)=1.D0
	EXIT
	ENDDO
      DO ISTR=1,NDIM+NDEX-1
	IF(IREF(ISTR+1).EQ.0.OR.IREF(ISTR).EQ.0)CYCLE
      E=ECLS(ISTR+1)-ECLS(ISTR)
      XCLS(ISTR+1)=SAFEEXP(-E/TEMP)*XCLS(ISTR)
      ENDDO
C If temperature is zero, only first states survive
	ELSEIF(TEMP.EQ.0.D0)THEN
      DO ISTR=1,NDIM+NDEX-1
	IF(IREF(ISTR).EQ.0)CYCLE
      XCLS(ISTR)=1.D0
	EXIT
	ENDDO
      DO ISTR=1,NDIM+NDEX-1
	IF(IREF(ISTR+1).EQ.0.OR.IREF(ISTR).EQ.0)CYCLE
      E=ECLS(ISTR+1)-ECLS(ISTR)
      IF(ABS(E).LE.EPS)XCLS(ISTR+1)=XCLS(ISTR)
	IF(ABS(E).GT.EPS)XCLS(ISTR+1)=0.D0
      ENDDO
	ENDIF
C Reorder
	DO ISTR=1,NDIM+NDEX
C	IF(IREF(ISTR).EQ.0)CYCLE
C	JDIM=(IREF(ISTR)-1)/NDIM+1
	IDIM=IREF(ISTR)
	IF(IDIM.GT.0)XHUB(+IDIM)=XCLS(ISTR)
	IF(IDIM.LT.0)XEXT(-IDIM)=XCLS(ISTR)
	ENDDO
C Renormalize 
      XSUM=0.D0
      DO IDIM=1,NDIM
      XSUM=XSUM+XHUB(IDIM)
      ENDDO
      DO IDIM=1,NDEX
      XSUM=XSUM+XEXT(IDIM)
      ENDDO
      DO IDIM=1,NDIM
      XHUB(IDIM)=XHUB(IDIM)/XSUM
      ENDDO
      DO IDIM=1,NDEX
      XEXT(IDIM)=XEXT(IDIM)/XSUM
      ENDDO
C Check
	XSUM=0.D0
	DO IDIM=1,NDIM
	XSUM=XSUM+XHUB(IDIM)
	ENDDO
	DO IDIM=1,NDEX
	XSUM=XSUM+XEXT(IDIM)
	ENDDO
	IF(ABS(XSUM-1.D0).GT.1.D-10)
     &CALL FULLSTOP('<RAT_CLSDIAG_XNOT>:: Normalization error')
	DEALLOCATE(ECLS,XCLS,IREF)
	RETURN
	END



      LOGICAL FUNCTION RAT_CLSDIAG_SKIP(NOCCCLS,IOCCIMP)
****************************************************************
*  Determines if given <Nf,Ns> block needs to be skipped       *
****************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_RATCLS  ,ONLY: NFOCIMP,NCUTIMP,NFOCBAT,NCUTBAT         !!! from readrat
      USE COM_LSHELL  ,ONLY: LORB,LOCCIMP,SPECIMP
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                         !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
      LOGICAL SKIP,FBLOCK,GBLOCK,LBLOCK
	DATA PI/3.141592653589793D0/
	SKIP=.TRUE.
C Select Fock spaces for "Nf,Ns", "Nf-1,Ns+1" "Nf+1,Ns-1" blocks
	NOCCIMPN=IOCCIMP           ! impuirty occupancy "Nf
	NOCCIMPM=NOCCIMPN-1        ! impuirty occupancy "Nf-1
	NOCCIMPP=NOCCIMPN+1        ! impuirty occupancy "Nf+1
      NFOCIMPM=NFOCIMP(NOCCIMPM) ! total dimension of "Nf-1" impurity space
      NFOCIMPN=NFOCIMP(NOCCIMPN) ! total dimension of "Nf"   impurity space
      NFOCIMPP=NFOCIMP(NOCCIMPP) ! total dimension of "Nf+1" impurity space
	NOCCBATN=NOCCCLS-NOCCIMPN  ! bath occupancy Ns for Nf electrons
	NOCCBATP=NOCCCLS-NOCCIMPM  ! bath occupancy Ns+1 for Nf-1 electrons
	NOCCBATM=NOCCCLS-NOCCIMPP  ! bath occupancy Ns-1 for Nf+1 electrons
      NFOCBATN=NFOCBAT(NOCCBATN) ! total dimension of "Ns"   bath space
      NFOCBATP=NFOCBAT(NOCCBATP) ! total dimension of "Ns+1" bath space
      NFOCBATM=NFOCBAT(NOCCBATM) ! total dimension of "Ns+1" bath space
C Select cutoff states
      NCUTIMPN=NCUTIMP(NOCCIMPN)
      NCUTIMPM=NCUTIMP(NOCCIMPM)
      NCUTIMPP=NCUTIMP(NOCCIMPP)
      NCUTBATN=NCUTBAT(NOCCBATN)
      NCUTBATP=NCUTBAT(NOCCBATP)
      NCUTBATM=NCUTBAT(NOCCBATM)
C Look at "Nf,Ns=G" , "Nf-1,Ns+1=F" "Nf+1,Ns-1=L" blocks
      GBLOCK=.FALSE.
      IF(NCUTIMPN.GT.0.AND.NCUTBATN.GT.0)GBLOCK=.TRUE.
      FBLOCK=.FALSE.
      IF(NCUTIMPM.GT.0.AND.NCUTBATP.GT.0)FBLOCK=.TRUE.
      LBLOCK=.FALSE.
      IF(NCUTIMPP.GT.0.AND.NCUTBATM.GT.0)LBLOCK=.TRUE.
C If both "Nf,Ns=G" and Nf-1,Ns+1=F blocks have non-zero dimensions Skipping is FALSE
      IF(GBLOCK.AND.FBLOCK)THEN
      SKIP=.FALSE.
      ELSEIF(GBLOCK.AND.(.NOT.FBLOCK))THEN
      IF(LBLOCK)SKIP=.TRUE.
      IF(.NOT.LBLOCK)SKIP=.FALSE.
      ELSEIF((.NOT.GBLOCK).AND.FBLOCK)THEN
      SKIP=.TRUE.
      ELSEIF((.NOT.GBLOCK).AND.(.NOT.FBLOCK))THEN
      SKIP=.TRUE.
      ENDIF
      RAT_CLSDIAG_SKIP=SKIP
      RETURN
      END