	SUBROUTINE RAT_GETADS
******************************************************
*   Read Green function data                         *
******************************************************
C SET EXTERNAL CONNECTIONS
	USE COM_FREQU     ,ONLY: NENRADS,ENRADS                !!! from getds
      USE COM_UNIT      ,ONLY: IUT,IUR,IUN                   !!! from setup
	USE COM_CHANNELS  ,ONLY: IUINP                         !!! from setup
      USE COM_RATOUT    ,ONLY: ICADS,ADSFILE                 !!! from readini
C SET LOCAL VARIBLES
	IMPLICIT REAL*8 (A-H,O-Z)
	CHARACTER DATA(100)*150,COPY(100)*150, HELP*40
	COMPLEX*16 CM
      LOGICAL EXIST,DEF,ASK,VAL,NTH
	DATA PI/3.141592653589793D0/
	IF(ICADS.EQ.0)RETURN
	INQUIRE(FILE=ADSFILE,EXIST=EXIST)
	IF(EXIST)
     &OPEN(UNIT=IUINP,FILE=ADSFILE,STATUS='OLD',FORM='FORMATTED')
C TRY READING FIRST 99 LINES
	ILEN=0
	DO I=1,100
	ILEN=ILEN+1
	IF(EXIST)READ(IUINP,FMT='(A)',ERR=100,END=100)DATA(ILEN)
	ENDDO
  100 NLEN=ILEN-1
      IF(NLEN.EQ.0)NLEN=1
	IF(EXIST)CLOSE(IUINP)
      CALL READ_SECT(DATA(1),NLEN,ISEC,NSEC,MSEC,
     &'<section=ctrl',13,'<section=',9,'ok',2)
C Allocate temporary file
      DO ILIN=1,MSEC
      COPY(ILIN)=DATA(ILIN+ISEC-1)
      ENDDO
C Process NENRADS
      NENRADS=100
      HELP='! Real axis grid                       '
      LHLP=40
      CALL READ_CHAR(DATA(ISEC),COPY(1),NSEC,MSEC,
     &'nenrads',7,NENRADS,1,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.FALSE.,.FALSE.)
C Process WMIN
      EMINADS=0.D0
      HELP='! Min.Energy                           '
      LHLP=40
      CALL READ_CHAR(DATA(ISEC),COPY(1),NSEC,MSEC,
     &'eminads',7,IN,1,0,EMINADS,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.FALSE.,.FALSE.)
C Process WMAX
      EMAXADS=0.D0
      HELP='! Max.Energy                           '
      LHLP=40
      CALL READ_CHAR(DATA(ISEC),COPY(1),NSEC,MSEC,
     &'emaxads',7,IN,1,0,EMAXADS,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.FALSE.,.FALSE.)
C SET ENERGIES
	IF(ALLOCATED(ENRADS))DEALLOCATE(ENRADS)
	ALLOCATE(ENRADS(0:NENRADS))
	IF(NENRADS.NE.0)ESTEP=(EMAXADS-EMINADS)/DBLE(NENRADS)
	IF(NENRADS.EQ.0)ESTEP=0.D0
	DO IENR=0,NENRADS
	ENRADS(IENR)=EMINADS+DBLE(IENR)*ESTEP
	ENDDO
	END
