	SUBROUTINE RAT_MATATM_HEAD(L,NDEG,NFOC,NOCC,ISTATE,FSLT,ELEV,
     &           HMAG,HORB,ALSC,EATS,AVEC,TATS,EPSD,IMOD,KORB)
********************************************************************
*  Diagonalizes atomic hamiltonian for given degeneracy,           *
*  returns array of eigenvalues                                    *
*  Regimes:                                                        *
*   iMod=0 - calculate                                            *
*   iMod=1 - calculate and store data                             *
*   iMod=2 - use previously calculated data                       *
********************************************************************
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                       !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
C Passed arrays
      INTEGER ISTATE(NDEG,0:2**NDEG-1)
	REAL*8 FSLT(0:L),EATS(NFOC)
	COMPLEX*16 ELEV(NDEG,NDEG),AVEC(NFOC,NFOC)
	CHARACTER TATS(6,NFOC)*5
C Allocatable arrays
	INTEGER, ALLOCATABLE :: ISUBSP(:)
	INTEGER, ALLOCATABLE :: ISPSUB(:)
	INTEGER, ALLOCATABLE :: IOPER(:)
	INTEGER, ALLOCATABLE :: KREP(:)
	REAL*8, ALLOCATABLE :: COMB(:,:)
	REAL*8, ALLOCATABLE :: OCCN(:,:)
	REAL*8, ALLOCATABLE :: DML(:)
	REAL*8, ALLOCATABLE :: DMS(:)
	REAL*8, ALLOCATABLE :: DMJ(:)
	REAL*8, ALLOCATABLE :: DLL(:)
	REAL*8, ALLOCATABLE :: DSS(:)
	REAL*8, ALLOCATABLE :: DLS(:)
	REAL*8, ALLOCATABLE :: DJJ(:)
	REAL*8, ALLOCATABLE :: DL(:)
	REAL*8, ALLOCATABLE :: DS(:)
	REAL*8, ALLOCATABLE :: DJ(:)
	REAL*8, ALLOCATABLE :: UMAT(:,:,:,:)
	REAL*8, ALLOCATABLE :: TMAT(:,:,:,:)
	REAL*8, ALLOCATABLE :: SLM(:,:,:)
	COMPLEX*16, ALLOCATABLE :: EKIN(:,:)
	COMPLEX*16, ALLOCATABLE :: EMAG(:,:)
	COMPLEX*16, ALLOCATABLE :: EORB(:,:)
	COMPLEX*16, ALLOCATABLE :: ECOU(:,:)
	COMPLEX*16, ALLOCATABLE :: HMAT(:,:)
	CHARACTER*5, ALLOCATABLE :: TOCC(:)
	COMPLEX*16 DIM
	CHARACTER*5 TML,TMS,TMJ,TL,TS,TJ
	DATA PI/3.141592653589793D0/,DIM/(0.D0,1.D0)/,EPS/1.D-04/
C *************************************
C Get combinatorics
	ALLOCATE(COMB(0:NDEG,0:NDEG))
	CALL LIB_GETCOMB(COMB,NDEG)
C Get interaction matrix
	ALLOCATE(UMAT(-L:L,-L:L,-L:L,-L:L))
	CALL LIB_HUBMAT_L4(L,FSLT,UMAT,UBAR,GBAR)
C Get Fock space
	NDIM=2**NDEG
	ALLOCATE(ISPSUB(0:NDIM-1))
	NFOC=NINT(COMB(NOCC,NDEG))
	ALLOCATE(ISUBSP(NFOC))
	IFOC=0
	DO IVEC=0,NDIM-1
	ISPSUB(IVEC)=-1
	IOCC=0
	DO MS=1,NDEG
	IOCC=IOCC+ISTATE(MS,IVEC)
	ENDDO
	IF(IOCC.EQ.NOCC)THEN
	IFOC=IFOC+1
	ISUBSP(IFOC)=IVEC
	ISPSUB(IVEC)=IFOC
	ENDIF
	ENDDO
	IF(IFOC.NE.NFOC)CALL FULLSTOP('IFOC.NE.NFOC')
C SET <Ylm|s*l|Ylm>/2 MATRIX ELEMENT
	ALLOCATE(SLM(-L:L,2,2))
	DO M=-L,L
	SLM(M,1,1)=0.5D0*DBLE(+M)
	SLM(M,1,2)=0.5D0*SQRT(DBLE((L+M)*(L-M+1)))
	SLM(M,2,1)=0.5D0*SQRT(DBLE((L-M)*(L+M+1)))
	SLM(M,2,2)=0.5D0*DBLE(-M)
	ENDDO
C Zeroise kinetic energy matrix
	ALLOCATE(EKIN(NFOC,NFOC))
	DO IFOC1=1,NFOC
	DO IFOC =1,NFOC
	EKIN(IFOC1,IFOC)=(0.D0,0.D0)
	ENDDO
	ENDDO
C SET KINETIC ENERGY MATRIX
	ALLOCATE(IOPER(NDEG))
	DO IFOC=1,NFOC                  !!! over all Fock states
	IVEC=ISUBSP(IFOC)
C Copy iFock vector
	MS=0
	DO ISPIN=1,2
	DO M=-L,L
	MS=MS+1
	IOPER(MS)=ISTATE(MS,IVEC)
	ENDDO
	ENDDO
C Destroy particle
	M1S1=0
	DO ISPIN1=1,2
	DO M1=-L,L
	M1S1=M1S1+1
	IF(ISTATE(M1S1,IVEC).NE.1)CYCLE ! operator C(ms) destroys the particle
	IOPER(M1S1)=0
	ISUMS=0
	DO I=1,M1S1-1
	ISUMS=ISUMS+IOPER(I)
	ENDDO
	ISIGN1=(-1)**ISUMS
C Create particle
	MS=0
	DO ISPIN=1,2
	DO M=-L,L
	MS=MS+1
	IF(IOPER(MS).NE.0)CYCLE  ! operator C+(ms) creates the particle
	IOPER(MS)=1
	ISUMS=0
	DO I=1,MS-1
	ISUMS=ISUMS+IOPER(I)
	ENDDO
	ISIGN=(-1)**ISUMS
C We got state iOper which is the same as iState but iOper(m1s1,iFoc)=0,iOper(ms,iFoc)=1
C Find out this state number
	IVEC1=0
	ITWO=1
	DO I=1,NDEG
	IVEC1=IVEC1+IOPER(I)*ITWO
	ITWO=ITWO*2
	ENDDO
	IFOC1=ISPSUB(IVEC1)
	IF(IFOC1.EQ.-1)CALL FULLSTOP('IFOC1.EQ.-1')
	EKIN(IFOC1,IFOC)=EKIN(IFOC1,IFOC)+ELEV(M1S1,MS)*ISIGN1*ISIGN
C Add spin orbit coupling correction
	IDIFF=ISPIN1-ISPIN
	IF(M1.EQ.M+IDIFF)
     &EKIN(IFOC1,IFOC)=EKIN(IFOC1,IFOC)+
     &                 ALSC*SLM(M,ISPIN1,ISPIN)*ISIGN1*ISIGN
C Rewind the state back
	IOPER(MS)=0
	ENDDO
	ENDDO
C Rewind the state back
	IOPER(M1S1)=1
	ENDDO
	ENDDO
	ENDDO                           !!! over all Fock states
C Zeroise magnetic and orbtial field contributions
	ALLOCATE(EMAG(NFOC,NFOC))
	ALLOCATE(EORB(NFOC,NFOC))
	DO IFOC1=1,NFOC
	DO IFOC =1,NFOC
	EMAG(IFOC1,IFOC)=(0.D0,0.D0)
	EORB(IFOC1,IFOC)=(0.D0,0.D0)
	ENDDO
	ENDDO
C SET MAGNETIC AND ORBITAL FIELD CONTRIBUTION
C Note that HMAG,HORB assume Bohr Magneton units since the precise
C operator is mu_B*(L+2S)*H
	DO IFOC=1,NFOC                  !!! over all Fock states
	IVEC=ISUBSP(IFOC)
	MS=0
	DO IUPDN=+1,-1,-2                 !!! spin magnetic moment is +/-1, i.e. up, dn
	DO M=-L,L
	MS=MS+1
	EMAG(IFOC,IFOC)=EMAG(IFOC,IFOC)+
     &HMAG*ISTATE(MS,IVEC)*DBLE(IUPDN)
	EORB(IFOC,IFOC)=EORB(IFOC,IFOC)+
     &HORB*ISTATE(MS,IVEC)*DBLE(M)
	ENDDO
	ENDDO
	ENDDO                           !!! over all Fock states
C Zeroise Coulomb interaction matrix
	ALLOCATE(ECOU(NFOC,NFOC))
	DO IFOC1=1,NFOC
	DO IFOC =1,NFOC
	ECOU(IFOC1,IFOC)=(0.D0,0.D0)
	ENDDO
	ENDDO
C SET COULOMB INTERATION MATRIX
	DO IFOC=1,NFOC                  !!! over all Fock states
	IVEC=ISUBSP(IFOC)
C Copy Fock vector
	DO MS=1,NDEG
	IOPER(MS)=ISTATE(MS,IVEC)
	ENDDO
C Destroy particle
	KS=0
	DO ISPIN=1,2
	DO K=-L,L
	KS=KS+1
	IF(ISTATE(KS,IVEC).NE.1)CYCLE ! operator C(ks) destroys the particle
	IOPER(KS)=0
	ISUMS=0
	DO I=1,KS-1
	ISUMS=ISUMS+IOPER(I)
	ENDDO
	IKS=(-1)**ISUMS
C Destroy particle
	K1S1=0
	DO ISPIN1=1,2
	DO K1=-L,L
	K1S1=K1S1+1
	IF(IOPER(K1S1).NE.1)CYCLE ! operator C(k1s1) destroys the particle
	IOPER(K1S1)=0
	ISUMS=0
	DO I=1,K1S1-1
	ISUMS=ISUMS+IOPER(I)
	ENDDO
	IK1S1=(-1)**ISUMS
C Create particle
	M1S1=0
	DO JSPIN1=1,2
	DO M1=-L,L
	M1S1=M1S1+1
	IF(IOPER(M1S1).NE.0)CYCLE ! operator C+(m1s1) creates the particle
	IOPER(M1S1)=1
	ISUMS=0
	DO I=1,M1S1-1
	ISUMS=ISUMS+IOPER(I)
	ENDDO
	IM1S1=(-1)**ISUMS
C Create particle
	MS=0
	DO JSPIN=1,2
	DO M=-L,L
	MS=MS+1
	IF(ISPIN1.NE.JSPIN1)CYCLE
	IF(ISPIN .NE.JSPIN )CYCLE
	IF(IOPER(MS).NE.0)CYCLE ! operator C+(ms) creates the particle
	IOPER(MS)=1
	ISUMS=0
	DO I=1,MS-1
	ISUMS=ISUMS+IOPER(I)
	ENDDO
	IMS=(-1)**ISUMS
C We got state iOper which is the same as iFock but with possibly 4 modified slots
C Find out this state number
	IVEC1=0
	ITWO=1
	DO I=1,NDEG
	IVEC1=IVEC1+IOPER(I)*ITWO
	ITWO=ITWO*2
	ENDDO
	IFOC1=ISPSUB(IVEC1)
	IF(IFOC1.EQ.-1)CALL FULLSTOP('IFOC1.EQ.-1')                     !  U(mk,m'k')  d_m+ d_m'+ d_k' d_k
	ISIGN=IMS*IKS*IM1S1*IK1S1
	ECOU(IFOC1,IFOC)=ECOU(IFOC1,IFOC)+UMAT(M,K,M1,K1)*ISIGN         ! <mm'|1/r|kk'>d_m+ d_m'+ d_k' d_k
C Rewind the state back                                               
	IOPER(MS)=0
	ENDDO
	ENDDO
C Rewind the state back
	IOPER(M1S1)=0
	ENDDO
	ENDDO
C Rewind the state back
	IOPER(K1S1)=1
	ENDDO
	ENDDO
C Rewind the state back
	IOPER(KS)=1
	ENDDO
	ENDDO
	ENDDO                           !!! over all Fock states
C Here comes fully interacting atomic problem
	ALLOCATE(HMAT(NFOC,NFOC))
	DO IFOC1=1,NFOC
	DO IFOC =1,NFOC
	HMAT(IFOC1,IFOC)=EKIN(IFOC1,IFOC)+0.5D0*ECOU(IFOC1,IFOC)+
     &                 EMAG(IFOC1,IFOC)+EORB(IFOC1,IFOC)
	ENDDO
	ENDDO
	IF(KORB.EQ.1)WRITE(IUN,10030)
10030	FORMAT(1X,' Exact diagonalization routines start:')
C DIAGONALIZE ATOMIC PROBLEM
	IF(IMOD.EQ.0.OR.IMOD.EQ.1)THEN
	DO IFOC1=1,NFOC
	DO IFOC =1,NFOC
	AVEC(IFOC1,IFOC)=(0.D0,0.D0)
	IF(IFOC1.EQ.IFOC)
     &AVEC(IFOC1,IFOC)=(1.D0,0.D0)
	ENDDO
	ENDDO
      CALL LIB_EIGEN1C(NFOC,HMAT,AVEC,EATS,1,1,1,IERR,0,1.D-07)
	ENDIF
C FIND EIGENVALUES
	IF(IMOD.EQ.2)
     &CALL RAT_MATATM_DIAG(NFOC,HMAT,AVEC,EATS,IERR)
	IF(KORB.EQ.1)WRITE(IUN,10040)
10040	FORMAT(1X,' Exact diagonalization routines finish.')
      IF(KORB.NE.1)GOTO 1000
C Find degeneracy
	NREP=1
	DO ILEV=2,NFOC
	IF(ABS(EATS(ILEV-1)-EATS(ILEV)).LE.EPSD)CYCLE
	NREP=NREP+1
	ENDDO
	ALLOCATE(KREP(NREP))
	IREP=1
	KREP(1)=1
	DO ILEV=2,NFOC
	IF(ABS(EATS(ILEV-1)-EATS(ILEV)).LE.EPSD)KREP(IREP)=KREP(IREP)+1
	IF(ABS(EATS(ILEV-1)-EATS(ILEV)).LE.EPSD)CYCLE
	IREP=IREP+1
	KREP(IREP)=1
	ENDDO
	ISUM=0
	DO IREP=1,NREP
	ISUM=ISUM+KREP(IREP)
	ENDDO
	IF(ISUM.NE.NFOC)CALL FULLSTOP('ISUM.NE.NFOC')
	ALLOCATE(OCCN(NDEG,NFOC))
	ALLOCATE(DML(NFOC))
	ALLOCATE(DMS(NFOC))
	ALLOCATE(DMJ(NFOC))
	ILEV=0
	DO IREP=1,NREP
	DO ISUB=1,KREP(IREP)
	ILEV=ILEV+1
C Find occupation numbers for interacting state
	DO MS=1,NDEG
	OCCN(MS,ILEV)=0.D0
	DO IFOC=1,NFOC
	IVEC=ISUBSP(IFOC)
	OCCN(MS,ILEV)=OCCN(MS,ILEV)+
     &DCONJG(AVEC(IFOC,ILEV))*AVEC(IFOC,ILEV)*ISTATE(MS,IVEC)
	ENDDO
	ENDDO
	SUM=0.D0
	DO MS=1,NDEG
	SUM=SUM+OCCN(MS,ILEV)
	ENDDO
C Find average projection of spin momentum onto z axis
	DMS(ILEV)=0
	MS=0
	DO IUPDN=+1,-1,-2                 !!! spin magnetic moment is +/-1, i.e. up, dn
	DO M=-L,L
	MS=MS+1
	DMS(ILEV)=DMS(ILEV)+0.5D0*OCCN(MS,ILEV)*DBLE(IUPDN)
	ENDDO
	ENDDO
C Find average projection of orbital momentum onto z axis
	DML(ILEV)=0
	MS=0
	DO ISPIN=1,2
	DO M=-L,L
	MS=MS+1
	DML(ILEV)=DML(ILEV)+OCCN(MS,ILEV)*DBLE(M)
	ENDDO
	ENDDO
C Find average projection of total momentum onto z axis
	DMJ(ILEV)=0
	MS=0
	DO IUPDN=+1,-1,-2                 !!! spin magnetic moment is +/-1, i.e. up, dn
	DO M=-L,L
	MS=MS+1
	DMJ(ILEV)=DMJ(ILEV)+OCCN(MS,ILEV)*(DBLE(M)+0.5D0*DBLE(IUPDN))
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C Calculate average operators squared
	ALLOCATE(TMAT(NDEG,NDEG,NDEG,NDEG))
	ALLOCATE(DLL(NFOC))
	ALLOCATE(DSS(NFOC))
	ALLOCATE(DLS(NFOC))
	ALLOCATE(DJJ(NFOC))
C Find average orbital operator squared
	CALL RAT_MATATM_OMAT(L,NDEG,TMAT)
      CALL RAT_MATATM_CONV(L,NDEG,NFOC,NDIM,ISTATE,ISUBSP,ISPSUB,
     &     HMAT,TMAT)
      CALL RAT_MATATM_DIAG(NFOC,HMAT,AVEC,DLL,IERR)
C Find average spin operator squared
	CALL RAT_MATATM_SMAT(L,NDEG,TMAT)
      CALL RAT_MATATM_CONV(L,NDEG,NFOC,NDIM,ISTATE,ISUBSP,ISPSUB,
     &     HMAT,TMAT)
      CALL RAT_MATATM_DIAG(NFOC,HMAT,AVEC,DSS,IERR)
C Find average spin orbital operator
	CALL RAT_MATATM_RMAT(L,NDEG,TMAT)
      CALL RAT_MATATM_CONV(L,NDEG,NFOC,NDIM,ISTATE,ISUBSP,ISPSUB,
     &     HMAT,TMAT)
      CALL RAT_MATATM_DIAG(NFOC,HMAT,AVEC,DLS,IERR)
C Find average total momentum operator squared
	DO ILEV=1,NFOC
	DJJ(ILEV)=DLL(ILEV)+DSS(ILEV)+DLS(ILEV)
	ENDDO
C Find absolute values of momenta
	ALLOCATE(DL(NFOC))
	ALLOCATE(DS(NFOC))
	ALLOCATE(DJ(NFOC))
	DO ILEV=1,NFOC
	DL(ILEV)=-0.5D0+0.5D0*SQRT(ABS(1.D0+4.D0*DLL(ILEV)))
	DS(ILEV)=-0.5D0+0.5D0*SQRT(ABS(1.D0+4.D0*DSS(ILEV)))
	DJ(ILEV)=-0.5D0+0.5D0*SQRT(ABS(1.D0+4.D0*DJJ(ILEV)))
	ENDDO
C PRINT RESULT TO THE TERMINAL
	ALLOCATE(TOCC(NDEG))
	WRITE(IUN,10100)NFOC
	ILEV=0
	DO IREP=1,NREP
	DO ISUB=1,KREP(IREP)
	ILEV=ILEV+1
	IF(ISUB.EQ.1)THEN
      WRITE(IUN,10110)EATS(ILEV),KREP(IREP),IREP
	WRITE(IUN,10130)
	ENDIF
	DO MS=1,NDEG
	IF(OCCN(MS,ILEV).LT.1.D-03)THEN
	TOCC(MS)=' 0.00'
	ELSE
	WRITE(TOCC(MS),FMT='(F5.2)')OCCN(MS,ILEV)
	ENDIF
	ENDDO
	IF(ABS(DL(ILEV)).LT.1.D-03)THEN
	TL=' 0.00'
	ELSE
	WRITE(TL,FMT='(F5.2)')DL(ILEV)
	ENDIF
	IF(ABS(DS(ILEV)).LT.1.D-03)THEN
	TS=' 0.00'
	ELSE
	WRITE(TS,FMT='(F5.2)')DS(ILEV)
	ENDIF
	IF(ABS(DJ(ILEV)).LT.1.D-03)THEN
	TJ=' 0.00'
	ELSE
	WRITE(TJ,FMT='(F5.2)')DJ(ILEV)
	ENDIF
	IF(ABS(DML(ILEV)).LT.1.D-03)THEN
	TML=' 0.00'
	ELSE
	WRITE(TML,FMT='(F5.2)')DML(ILEV)
	ENDIF
	IF(ABS(DMS(ILEV)).LT.1.D-03)THEN
	TMS=' 0.00'
	ELSE
	WRITE(TMS,FMT='(F5.2)')DMS(ILEV)
	ENDIF
	IF(ABS(DMJ(ILEV)).LT.1.D-03)THEN
	TMJ=' 0.00'
	ELSE
	WRITE(TMJ,FMT='(F5.2)')DMJ(ILEV)
	ENDIF
	TATS(1,ILEV)=TML
	TATS(2,ILEV)=TMS
	TATS(3,ILEV)=TMJ
	TATS(4,ILEV)=TL
	TATS(5,ILEV)=TS
	TATS(6,ILEV)=TJ
	WRITE(IUN,10140)ILEV,TML,TMS,TMJ,TL,TS,TJ,(TOCC(MS),MS=1,NDEG)
	ENDDO
	ENDDO
	WRITE(IUN,10150)
	WRITE(IUN,10160)
C MEMORY DEALLOCATIONS
	DEALLOCATE(KREP,TMAT,OCCN,TOCC)
	DEALLOCATE(DML,DMS,DMJ,DLL,DLS,DSS,DJJ,DL,DS,DJ)
10100 FORMAT(1X,'Result of diagonalization, # of levels = ',I6)
10110 FORMAT(1X,'Energy = ',G12.5,' ; Deg = ',I3,' ; Lev = ',I3)
10130 FORMAT(1X,6X,'  ML    MS    MJ     L     S     J   Occupancies')
10140 FORMAT(1X,I5,1X,A5,1X,A5,1X,A5,1X,A5,1X,A5,1X,A5,1X,14(A5))
10150 FORMAT(1X,'Note that quantization axis is picked arbitrary')
10160 FORMAT(1X,'unless external fields are switched on!')
C MEMORY DEALLOCATIONS
 1000 DEALLOCATE(HMAT,ISUBSP,ISPSUB,SLM)
	DEALLOCATE(IOPER,UMAT,EKIN,ECOU,EMAG,EORB,COMB)
	END







      SUBROUTINE RAT_MATATM_DIAG(NFOC,HMAT,AVEC,EATS,IERR)
*************************************************************************
* Evaluates average of the hamiltonian                                  *
*************************************************************************
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                       !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16 HMAT(NFOC,NFOC),AVEC(NFOC,NFOC)
	REAL*8 EATS(NFOC)
	COMPLEX*16, ALLOCATABLE :: PROD(:)
	DATA PI/3.141592653589793D0/
C Memory allocations
	ALLOCATE(PROD(NFOC))
C Evaluate average values for the hamiltonian
	DO IBND=1,NFOC
	EATS(IBND)=0.D0
	DO IFOC1=1,NFOC
	PROD(IFOC1)=(0.D0,0.D0)
	DO IFOC =1,NFOC
	PROD(IFOC1)=PROD(IFOC1)+HMAT(IFOC1,IFOC)*AVEC(IFOC,IBND)
	ENDDO
	ENDDO
	DO IFOC1=1,NFOC
	EATS(IBND)=EATS(IBND)+DCONJG(AVEC(IFOC1,IBND))*PROD(IFOC1)
	ENDDO
	ENDDO
C Memory deallocations
	DEALLOCATE(PROD)
	END



      SUBROUTINE RAT_MATATM_MATR(NFOC,HMAT,AVEC,EMAT,IERR)
*************************************************************************
* Evaluates average of the hamiltonian                                  *
*************************************************************************
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                       !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16 HMAT(NFOC,NFOC),AVEC(NFOC,NFOC),EMAT(NFOC,NFOC)
	COMPLEX*16, ALLOCATABLE :: PROD(:)
	DATA PI/3.141592653589793D0/
C Memory allocations
	ALLOCATE(PROD(NFOC))
C Evaluate average values for the hamiltonian
	DO IBND =1,NFOC
	DO IFOC1=1,NFOC
	PROD(IFOC1)=(0.D0,0.D0)
	DO IFOC =1,NFOC
	PROD(IFOC1)=PROD(IFOC1)+HMAT(IFOC1,IFOC)*AVEC(IFOC,IBND)
	ENDDO
	ENDDO
	DO IBND1=1,NFOC
	EMAT(IBND1,IBND)=(0.D0,0.D0)
	DO IFOC1=1,NFOC
	EMAT(IBND1,IBND)=EMAT(IBND1,IBND)+
     &DCONJG(AVEC(IFOC1,IBND1))*PROD(IFOC1)
	ENDDO
	ENDDO
	ENDDO
C Memory deallocations
	DEALLOCATE(PROD)
	END





      SUBROUTINE RAT_MATATM_CONV(L,NDEG,NFOC,NDIM,ISTATE,ISUBSP,ISPSUB,
     &                           HMAT,TMAT)
*************************************************************************
* Evaluates matrix elements of d+d d+d                                  *
*************************************************************************
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                       !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER ISUBSP(NFOC),ISTATE(NDEG,0:NDIM-1),ISPSUB(0:NDIM-1)
	REAL*8 TMAT(NDEG,NDEG,NDEG,NDEG)
	COMPLEX*16 HMAT(NFOC,NFOC)
	INTEGER, ALLOCATABLE :: IOPER(:)
	DATA PI/3.141592653589793D0/
C Memory Allocations
	ALLOCATE(IOPER(NDEG))
	DO IFOC1=1,NFOC
	DO IFOC=1,NFOC
	HMAT(IFOC1,IFOC)=(0.D0,0.D0)
	ENDDO
	ENDDO
C SET MATRIX ELEMENTS
	DO IFOC=1,NFOC                  !!! over all Fock states
	IVEC=ISUBSP(IFOC)
C Copy Fock vector
	DO MS=1,NDEG
	IOPER(MS)=ISTATE(MS,IVEC)
	ENDDO
C Create particle
	M1S1=0
	DO JSPIN1=1,2
	DO M1=-L,L
	M1S1=M1S1+1
	IF(ISTATE(M1S1,IVEC).NE.0)CYCLE ! operator C+(m1s1) creates the particle
	IOPER(M1S1)=1
	ISUMS=0
	DO I=1,M1S1-1
	ISUMS=ISUMS+IOPER(I)
	ENDDO
	IM1S1=(-1)**ISUMS
C Destroy particle
	K1S1=0
	DO ISPIN1=1,2
	DO K1=-L,L
	K1S1=K1S1+1
	IF(IOPER(K1S1).NE.1)CYCLE ! operator C(k1s1) destroys the particle
	IOPER(K1S1)=0
	ISUMS=0
	DO I=1,K1S1-1
	ISUMS=ISUMS+IOPER(I)
	ENDDO
	IK1S1=(-1)**ISUMS
C Create particle
	MS=0
	DO JSPIN=1,2
	DO M=-L,L
	MS=MS+1
	IF(IOPER(MS).NE.0)CYCLE ! operator C+(ms) creates the particle
	IOPER(MS)=1
	ISUMS=0
	DO I=1,MS-1
	ISUMS=ISUMS+IOPER(I)
	ENDDO
	IMS=(-1)**ISUMS
C Destroy particle
	KS=0
	DO ISPIN=1,2
	DO K=-L,L
	KS=KS+1
	IF(IOPER(KS).NE.1)CYCLE ! operator C(ks) destroys the particle
	IOPER(KS)=0
	ISUMS=0
	DO I=1,KS-1
	ISUMS=ISUMS+IOPER(I)
	ENDDO
	IKS=(-1)**ISUMS
C We got state iOper which is the same as iFock but with possibly 4 modified slots
C Find out this state number
	IVEC1=0
	ITWO=1
	DO I=1,NDEG
	IVEC1=IVEC1+IOPER(I)*ITWO
	ITWO=ITWO*2
	ENDDO
	IFOC1=ISPSUB(IVEC1)
	IF(IFOC1.EQ.-1)CALL FULLSTOP('IFOC1.EQ.-1')                     !  d_m+ d_m'+ d_k' d_k
	ISIGN=IMS*IKS*IM1S1*IK1S1
	HMAT(IFOC1,IFOC)=HMAT(IFOC1,IFOC)+TMAT(M1S1,K1S1,MS,KS)*ISIGN   ! d_m'+ d_k' d_m+ d_k
C Rewind the state back                                               
	IOPER(KS)=1
	ENDDO
	ENDDO
C Rewind the state back
	IOPER(MS)=0
	ENDDO
	ENDDO
C Rewind the state back
	IOPER(K1S1)=1
	ENDDO
	ENDDO
C Rewind the state back
 	IOPER(M1S1)=0
	ENDDO
	ENDDO
	ENDDO                           !!! over all Fock states
C Memory deallocations
	DEALLOCATE(IOPER)
	END


      SUBROUTINE RAT_MATATM_SMAT(L,NDEG,SMAT)
*************************************************************************
* Prepares spin square operator SS                                      *
*************************************************************************
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                       !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8 SMAT(NDEG,NDEG,NDEG,NDEG)
	REAL*8, ALLOCATABLE :: S(:,:,:)
	DATA PI/3.141592653589793D0/
	ALLOCATE(S(2,2,-1:1))
C Set matrix elements of spin operator S_mu (lower subscript)
	S(1,1,-1)=0.D0
	S(1,2,-1)=0.D0
	S(2,1,-1)=+1.D0/SQRT(2.D0)
	S(2,2,-1)=0.D0
	S(1,1,+1)=0.D0
	S(1,2,+1)=-1.D0/SQRT(2.D0)
	S(2,1,+1)=0.D0
	S(2,2,+1)=0.D0
	S(1,1, 0)=+0.5D0
	S(1,2, 0)=0.D0
	S(2,1, 0)=0.D0
	S(2,2, 0)=-0.5D0
C Zeroise matrix
	DO IDEG1=1,NDEG
	DO JDEG1=1,NDEG
	DO IDEG2=1,NDEG
	DO JDEG2=1,NDEG
	SMAT(IDEG1,JDEG1,IDEG2,JDEG2)=0.D0
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C Set matrix
	M1S1=0
	DO ISPIN1=1,2
	DO M1=-L,L
	M1S1=M1S1+1
	K1S1=0
	DO JSPIN1=1,2
	DO K1=-L,L
	K1S1=K1S1+1
	IF(M1.NE.K1)CYCLE
	MS=0
	DO ISPIN=1,2
	DO M=-L,L
	MS=MS+1
	KS=0
	DO JSPIN=1,2
	DO K=-L,L
	KS=KS+1
	IF(M.NE.K)CYCLE
	SMAT(M1S1,K1S1,MS,KS)=
     &S(ISPIN1,JSPIN1, 0)*S(ISPIN,JSPIN, 0)-
     &S(ISPIN1,JSPIN1,+1)*S(ISPIN,JSPIN,-1)-
     &S(ISPIN1,JSPIN1,-1)*S(ISPIN,JSPIN,+1)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	DEALLOCATE(S)
	END




      SUBROUTINE RAT_MATATM_OMAT(L,NDEG,OMAT)
*************************************************************************
* Prepares orbital operator squared LL                                  *
*************************************************************************
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                       !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8 OMAT(NDEG,NDEG,NDEG,NDEG)
	REAL*8, ALLOCATABLE :: O(:,:,:)
	DATA PI/3.141592653589793D0/
C Set matrix elements of orbital operator L_mu (lower subscript)
	ALLOCATE(O(-L:L,-L:L,-1:1))
	DO M1=-L,L
	DO M=-L,L
	O(M1,M, 0)=0.D0
	O(M1,M,-1)=0.D0
	O(M1,M,+1)=0.D0
	IF(M1.EQ.M)
     &O(M1,M,0)=DBLE(M)
	IF(M1.EQ.M-1)
     &O(M1,M,-1)=+SQRT(DBLE((L+M)*(L-M+1)))/SQRT(2.D0)
	IF(M1.EQ.M+1)
     &O(M1,M,+1)=-SQRT(DBLE((L-M)*(L+M+1)))/SQRT(2.D0)
	ENDDO
	ENDDO
C Zeroise matrix
	DO IDEG1=1,NDEG
	DO JDEG1=1,NDEG
	DO IDEG2=1,NDEG
	DO JDEG2=1,NDEG
	OMAT(IDEG1,JDEG1,IDEG2,JDEG2)=0.D0
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C Set matrix
	M1S1=0
	DO ISPIN1=1,2
	DO M1=-L,L
	M1S1=M1S1+1
	K1S1=0
	DO JSPIN1=1,2
	DO K1=-L,L
	K1S1=K1S1+1
	IF(ISPIN1.NE.JSPIN1)CYCLE
	MS=0
	DO ISPIN=1,2
	DO M=-L,L
	MS=MS+1
	KS=0
	DO JSPIN=1,2
	DO K=-L,L
	KS=KS+1
	IF(ISPIN.NE.JSPIN)CYCLE
	OMAT(M1S1,K1S1,MS,KS)=
     &O(M1,K1, 0)*O(M,K, 0)-
     &O(M1,K1,+1)*O(M,K,-1)-
     &O(M1,K1,-1)*O(M,K,+1)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	DEALLOCATE(O)
	END


      SUBROUTINE RAT_MATATM_RMAT(L,NDEG,RMAT)
*************************************************************************
* Prepares spin orbital operator LS                                     *
*************************************************************************
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                       !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8 RMAT(NDEG,NDEG,NDEG,NDEG)
	REAL*8, ALLOCATABLE :: O(:,:,:)
	REAL*8, ALLOCATABLE :: S(:,:,:)
	DATA PI/3.141592653589793D0/
C Set matrix elements of orbital operator L_mu (lower subscript)
	ALLOCATE(O(-L:L,-L:L,-1:1))
	ALLOCATE(S(2,2,-1:1))
	DO M1=-L,L
	DO M=-L,L
	O(M1,M, 0)=0.D0
	O(M1,M,-1)=0.D0
	O(M1,M,+1)=0.D0
	IF(M1.EQ.M)
     &O(M1,M,0)=DBLE(M)
	IF(M1.EQ.M-1)
     &O(M1,M,-1)=+SQRT(DBLE((L+M)*(L-M+1)))/SQRT(2.D0)
	IF(M1.EQ.M+1)
     &O(M1,M,+1)=-SQRT(DBLE((L-M)*(L+M+1)))/SQRT(2.D0)
	ENDDO
	ENDDO
C Set matrix elements of spin operator S_mu (lower subscript)
	S(1,1,-1)=0.D0
	S(1,2,-1)=0.D0
	S(2,1,-1)=+1.D0/SQRT(2.D0)
	S(2,2,-1)=0.D0
	S(1,1,+1)=0.D0
	S(1,2,+1)=-1.D0/SQRT(2.D0)
	S(2,1,+1)=0.D0
	S(2,2,+1)=0.D0
	S(1,1, 0)=+0.5D0
	S(1,2, 0)=0.D0
	S(2,1, 0)=0.D0
	S(2,2, 0)=-0.5D0
C Zeroise matrix
	DO IDEG1=1,NDEG
	DO JDEG1=1,NDEG
	DO IDEG2=1,NDEG
	DO JDEG2=1,NDEG
	RMAT(IDEG1,JDEG1,IDEG2,JDEG2)=0.D0
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C Set matrix
	M1S1=0
	DO ISPIN1=1,2
	DO M1=-L,L
	M1S1=M1S1+1
	K1S1=0
	DO JSPIN1=1,2
	DO K1=-L,L
	K1S1=K1S1+1
	IF(ISPIN1.NE.JSPIN1)CYCLE
	MS=0
	DO ISPIN=1,2
	DO M=-L,L
	MS=MS+1
	KS=0
	DO JSPIN=1,2
	DO K=-L,L
	KS=KS+1
	IF(M.NE.K)CYCLE
	RMAT(M1S1,K1S1,MS,KS)=
     &O(M1,K1, 0)*S(ISPIN,JSPIN, 0)-
     &O(M1,K1,+1)*S(ISPIN,JSPIN,-1)-
     &O(M1,K1,-1)*S(ISPIN,JSPIN,+1)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C Set matrix
	M1S1=0
	DO ISPIN1=1,2
	DO M1=-L,L
	M1S1=M1S1+1
	K1S1=0
	DO JSPIN1=1,2
	DO K1=-L,L
	K1S1=K1S1+1
	IF(M1.NE.K1)CYCLE
	MS=0
	DO ISPIN=1,2
	DO M=-L,L
	MS=MS+1
	KS=0
	DO JSPIN=1,2
	DO K=-L,L
	KS=KS+1
	IF(ISPIN.NE.JSPIN)CYCLE
	RMAT(M1S1,K1S1,MS,KS)=RMAT(M1S1,K1S1,MS,KS)+
     &S(ISPIN1,JSPIN1, 0)*O(M,K, 0)-
     &S(ISPIN1,JSPIN1,-1)*O(M,K,+1)-
     &S(ISPIN1,JSPIN1,+1)*O(M,K,-1)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	DEALLOCATE(O,S)
	END

