	SUBROUTINE RAT_MIXRAT(ITER,IEXIT,KEY)
**************************************************************
* Mixes density after Broyden prescription.                  *
**************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM
      USE COM_RATSCF  ,ONLY: EPSRAT,ADMIXL,ADMIX1,MIXBRD,RATRHO !!! from readrat
      USE COM_RATMESH ,ONLY: NRAT,HRAT,RRAT,DRAT,WRAT         !!! from radmesh
      USE COM_LMTOUT  ,ONLY: SCRFILE                            !!! from readini
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT                        !!! from setup
      USE COM_CHANNELS,ONLY: IUBSG                              !!! from channels
	USE COM_MASHDEP ,ONLY: NVAL,LENCMP                        !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8, ALLOCATABLE :: WRAD(:)
	REAL*8, ALLOCATABLE :: WTER(:)
	REAL*8, ALLOCATABLE :: FNOM(:)
	REAL*8, ALLOCATABLE :: WORK1(:)
	REAL*8, ALLOCATABLE :: WORK2(:)
	COMPLEX*16, ALLOCATABLE :: BETA(:,:)
	COMPLEX*16, ALLOCATABLE :: CMAT(:,:)
	COMPLEX*16, ALLOCATABLE :: GAMA(:,:)
	COMPLEX*16, ALLOCATABLE :: WBRO(:)
	COMPLEX*16, ALLOCATABLE :: WINP(:)
	COMPLEX*16, ALLOCATABLE :: WMIX(:,:)
      COMPLEX*16, ALLOCATABLE :: WRK1(:)
      COMPLEX*16, ALLOCATABLE :: WRK2(:)
      COMPLEX*16, ALLOCATABLE :: XINP(:)
      COMPLEX*16, ALLOCATABLE :: XOUT(:)
      LOGICAL FIRST,RESET
      CHARACTER TCPS*19,TC*19,TM*19
	SAVE FIRST,RESET,WTER,WMIX,WBRO,WINP
     &    ,MTER,FNOM,BETA,CMAT,GAMA,ADMIXB
      DATA PI/3.141592653589793D0/,FIRST/.TRUE./,ADMIXB/0.D0/
      CALL ABORTNOW()
	IEXIT=0
C ALLOCATE DATA
      IF(FIRST)THEN
      ALLOCATE(WTER(0:NTERMEM))
	ALLOCATE(FNOM(NTERMEM))
	ALLOCATE(BETA(NTERMEM,NTERMEM))
	ALLOCATE(CMAT(NTERMEM,NTERMEM))
	ALLOCATE(GAMA(NTERMEM,NTERMEM))
      ALLOCATE(WBRO(NTERMEM))
      ALLOCATE(WINP(NTERMEM))
      ALLOCATE(WMIX(NTERMEM,NTERMEM))
      RESET=.TRUE.
	MTER=0
      ENDIF
	IF(ITER.EQ.1)MTER=0
      FIRST=.FALSE.
C SET ITERATION NUMBER
	IF(MTER.EQ.NTERMEM-1)RESET=.TRUE.
	IF(MTER.EQ.NTERMEM-1)
     &WRITE(IUT,*)'<MIXDMF>:: Mter>Ntermem, Broyden restarted'
	IF(RESET)MTER=0
	IF(KEY.EQ.1.AND.MTER.NE.0)RETURN
	IF(KEY.EQ.2)MTER=MTER+1
	IF(.NOT.MIXBRD.AND.MTER.NE.0)MTER=1 ! use linear mixing
C CHOOSE PROPER MIXING
	IF(.NOT.MIXBRD)ADMIXB=ADMIXL
	IF(     MIXBRD)ADMIXB=ADMIX1
C DEFINE MAXIMUM SIZE OF THE BROYDEN ARRAY
      NLEN=NRAT+1
      NLENMEM=NLEN
C MEMORY ALLOCATIONS
      ALLOCATE(WRAD(NLENMEM))
      ALLOCATE(WRK1(NLENMEM))
      ALLOCATE(WRK2(NLENMEM))
      ALLOCATE(XINP(NLENMEM))
      ALLOCATE(XOUT(NLENMEM))
      ALLOCATE(WORK1(0:NRAT))
      ALLOCATE(WORK2(0:NRAT))
C *** SET MIXING ARRAY ***
	ILEN=0
	DO IRAT=0,NRAT             !!! over Matsubara frequencies
	ILEN=ILEN+1
	XINP(ILEN)=RATRHO(IRAT)
	WRAD(ILEN)=1.D0
	ENDDO
C  SEND ARRAY TO BROYDEN
      CALL LIB_BROY6(XINP,XOUT,WRAD,WRK1,WRK2,NLEN,MTER,ADMIXB,WTER,
     &WBRO,WINP,WMIX,FNOM,BETA,CMAT,GAMA,NTERMEM,NVAL,
     &IUBSG,SCRFILE(IUBSG),IERR)      
	IF(MTER.EQ.0)RESET=.FALSE.
	IF(MTER.EQ.0)GOTO 1000
C CHECK EXIT
	ILEN=0
	DO IRAT=0,NRAT
	ILEN=ILEN+1
	WORK1(IRAT)=(XOUT(ILEN)-XINP(ILEN))**2*WRAT(IRAT)
	ENDDO
	CALL LIB_QD(HRAT,WORK1,WORK2,NRAT+1)
	DDIF=SQRT(ABS(WORK2(NRAT)))
	IF(DDIF.LE.EPSRAT)IEXIT=1
	IF(ADMIXB.EQ.1.D0.AND.MTER.EQ.1)IEXIT=0
C *** DEFINE NEW DENSITY ***
      ILEN=0
	DO IRAT=0,NRAT
	ILEN=ILEN+1
	RATRHO(IRAT)=XOUT(ILEN)
	ENDDO
C  PRINT BLOCK
	WRITE(IUN,1010)WTER(MTER),DDIF
C MEMORY DEALLOCATONS
1000	DEALLOCATE(WRAD,WRK1,WRK2,XINP,XOUT,WORK1,WORK2) 
1010	FORMAT(1X,'Mixing, Iter-Weight=',G14.7, ' Accuracy=',G14.7)
	END
