	SUBROUTINE RAT_RATDEN
************************************************************
*   New density                                            *
************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
	USE COM_CONTROL ,ONLY: ISIC
      USE COM_RATPAR  ,ONLY: LCRT                                !!! from readrat
      USE COM_RATSCF  ,ONLY: SRAT,ZRAT,ERAT,TRAT,RATPOT,RATRHO   !!! from readrat
      USE COM_RATLEV  ,ONLY: NLEVT,LEVN,LEVL,LEVJ,ELEV,ZLEV
      USE COM_RATMESH ,ONLY: NRAT,HRAT,RRAT,DRAT,WRAT,PRAT       !!! from radmesh
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT                         !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8, ALLOCATABLE :: VBAR(:)
	REAL*8, ALLOCATABLE :: VSIC(:)
	REAL*8, ALLOCATABLE :: RHOR(:)
	REAL*8, ALLOCATABLE :: APHI(:)
	REAL*8, ALLOCATABLE :: APHID(:)
	REAL*8, ALLOCATABLE :: WORK1(:)
	REAL*8, ALLOCATABLE :: WORK2(:)
	CHARACTER TLEV(8,0:4,8)*19,THED*19
	LOGICAL EXIT
	DATA PI/3.141592653589793D0/
      CALL ABORTNOW()
	LCR=LCRT ! relativistic control
C MEMORY ALLOCATIONS
      ALLOCATE(WORK1(0:NRATMEM))
      ALLOCATE(WORK2(0:NRATMEM))
	ALLOCATE(VBAR(0:NRATMEM))
	ALLOCATE(VSIC(0:NRATMEM))
	ALLOCATE(RHOR(0:NRATMEM))
	ALLOCATE(APHI(0:NRATMEM))
	ALLOCATE(APHID(0:NRATMEM))
C START CODE
	DO IRAT=0,NRAT
	RHOR(IRAT)=0.D0
	ENDDO
C  SET THE POTENTIAL
      VBAR(0)=2.D0*ZRAT
	DO IRAT=1,NRAT
      VBAR(IRAT)=-RRAT(IRAT)*RATPOT(IRAT)
	ENDDO
      VBAR(0)=2.D0*ZRAT
C  RECALCULATE CORE LEVELS 
	DO 1000 ILEV=1,NLEVT                   !!! over core levels
	NQ=LEVN(ILEV)
	LQ=LEVL(ILEV)
	JQ=LEVJ(ILEV)
	QJ=DBLE(JQ)/2.D0
	NODE=NQ-LQ-1
	ROOT=ELEV(ILEV)
C  SOLVE DIRAC EQUATION WITH GROUND STATE POTENTIAL
	CALL LIB_CORSCH_ENYS(ROOT,NODE,LQ,JQ,DLOG,SRAT,
     &VBAR(0),APHI(0),APHID(0),NRAT,HRAT,RRAT(0),DRAT(0),LCR)
C Self-interaction corrections
	IF(ISIC.EQ.1)THEN
	IF(LCR.EQ.0.OR.LCR.EQ.1)THEN
	DO IRAT=0,NRAT
	RATRHO(IRAT)=APHI(IRAT)**2/(4.D0*PI)
	ENDDO
	ELSEIF(LCR.EQ.2)THEN
	DO IRAT=0,NRAT
	RATRHO(IRAT)=1.D0/(4.D0*PI)*(APHI(IRAT)**2+APHID(IRAT)**2)
	ENDDO
	ENDIF
	CALL RAT_VCOUL(1)
	CALL RAT_VEXCH(1)
      VSIC(0)=2.D0*ZRAT
	DO IRAT=1,NRAT
	VSIC(IRAT)=VBAR(IRAT)+RRAT(IRAT)*RATPOT(IRAT)+2.D0*ZRAT
	ENDDO
	ROOT=ELEV(ILEV)
C  Solve Diraq equation with self-interaction corrected potential
	CALL LIB_CORSCH_ENYS(ROOT,NODE,LQ,JQ,DLOG,SRAT,
     &VSIC(0),APHI(0),APHID(0),NRAT,HRAT,RRAT(0),DRAT(0),LCR)
	ENDIF
	ELEV(ILEV)=ROOT
C  SET NEW DENSITY FOR NON- OR SCALAR-RELATIVISTIC CASE
	IF(LCR.EQ.0.OR.LCR.EQ.1)THEN
	DO IRAT=0,NRAT
	RHOR(IRAT)=RHOR(IRAT)+ZLEV(ILEV)/(4.D0*PI)*APHI(IRAT)**2
	ENDDO
C  SET NEW DENSITY IN THE FULLY RELATIVISTIC CASE
C  APHI and APHID are the LARGE and SMALL components
	ELSEIF(LCR.EQ.2)THEN
	DO IRAT=0,NRAT
	RHOR(IRAT)=RHOR(IRAT)+
     &ZLEV(ILEV)/(4.D0*PI)*(APHI(IRAT)**2+APHID(IRAT)**2)
	ENDDO
	ENDIF
 1000 CONTINUE                            !!! over levels
C SET NEW DENSITY AND RESET OLD POTENTIAL
	DO IRAT=0,NRAT
	RATRHO(IRAT)=RHOR(IRAT)
	ENDDO
	DO IRAT=1,NRAT
	RATPOT(IRAT)=-VBAR(IRAT)/RRAT(IRAT)
	ENDDO
	RATPOT(0)=RATPOT(1)
C RENORMALIZE CHARGE IN UNIT-CELL
	DO IRAT=0,NRAT
	WORK1(IRAT)=RATRHO(IRAT)*WRAT(IRAT)
	ENDDO
	CALL LIB_QD(HRAT,WORK1,WORK2,NRAT+1)
	ENEW=WORK2(NRAT)
C RENORMALIZE DENSITY
	ANORM=1.D0
	IF(ENEW.GT.1.D-03)
     &ANORM=ERAT/ENEW
	DO IRAT=0,NRAT
	RATRHO(IRAT)=RATRHO(IRAT)*ANORM
	ENDDO
C PRINT LEVELS
	CALL LIB_TLEVCHAR(TLEV,THED) 
	WRITE(IUN,10010)THED,TRAT,ZRAT
	IF(ABS(ANORM-1.D0).GT.1.D-01)WRITE(IUT,*)
     &'<RATRHO>:: UNUSUALLY LARGE RENORMALIZATION OF ZRAT'
	DO ILEV=1,NLEVT
	NQ=LEVN(ILEV)
	LQ=LEVL(ILEV)
	JQ=LEVJ(ILEV)
      WRITE(IUN,10020)TLEV(NQ,LQ,JQ),INT(ZLEV(ILEV)),
     &ELEV(ILEV)
	ENDDO
C MEMORY DEALLOCATIONS
	DEALLOCATE(VBAR,VSIC,RHOR,APHI,APHID,WORK1,WORK2)
10010 FORMAT(1X,A19,'  # el.  Levels(Ry) ',A10,'; Zrat=',G12.5)
10020 FORMAT(1X,A19,3X,I2,3X,G14.7)
	END


