	SUBROUTINE RAT_MAKERAT
*************************************************************
*   Makes radial mesh                                       *
*************************************************************
C SET ARRAY SIZE DATA
	USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_RATPAR  ,ONLY: LCRT                            !!! from readrat
      USE COM_RATSCF  ,ONLY: ZRAT,SRAT,TRAT                  !!! from readrat
      USE COM_RATMESH ,ONLY: NRAT,HRAT,RRAT,DRAT,WRAT,PRAT   !!! from makerat
     &                      ,NLIB,HLIB,RLIB,DLIB
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT                     !!! from setup
      USE COM_MASHDEP ,ONLY: LENREL                          !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER ,INTRINSIC :: SIZE
	DATA PI/3.141592653589793D0/,DELTANR/0.03D0/,DELTAR/0.03D0/
C FIRST ESTIMATE # OF POINTS
      IF(LCRT.EQ.0)HRAT=DELTANR
      IF(LCRT.EQ.1)HRAT=DELTA R
      IF(LCRT.EQ.2)HRAT=DELTA R
      XMIN=-LOG(2.D0*ZRAT+1.D0)
      BETTA=EXP(XMIN)
      NRAT=2*LOG(SRAT/BETTA+1.D0)/HRAT
      NRAT=MAX(NRAT,100)
      NRAT=MIN(NRAT,1000)
      NRAT=((NRAT-1)/2)*2  !!! must be odd number
	NRATMEM=NRAT
C MEMORY ALLOCATIONS FOR MAIN CONTROL ARRAYS
	ALLOCATE(RRAT(0:NRATMEM))
	ALLOCATE(DRAT(0:NRATMEM))
	ALLOCATE(WRAT(0:NRATMEM))
	ALLOCATE(PRAT(0:NRATMEM,0:6))
	XMIN=-LOG(2.D0*ZRAT+1.D0)
	BETTA=EXP(XMIN)
C # OF RADIAL POINTS IS DEFINED, REDEFINE XMIN
   	BETTA=SRAT/(EXP(HRAT*NRAT)-1.D0)
	XMIN=LOG(BETTA)
C SCALE STEP AND XMAX ACCORDING TO V/V0
	HRAT=LOG(SRAT/BETTA+1.D0)/DBLE(NRAT)
	XMAX=XMIN+HRAT*DBLE(NRAT)
C DEFINE RADIAL MESH ARRAYS
	DO IRAT=0,NRAT
	RRAT(IRAT)=BETTA*(EXP(HRAT*IRAT)-1.D0)
	DRAT(IRAT)=BETTA*EXP(HRAT*IRAT)
	WRAT(IRAT)=4.D0*PI*RRAT(IRAT)**2*DRAT(IRAT)
	PRAT(IRAT,0)=1.D0
	DO L=1,6
	PRAT(IRAT,L)=RRAT(IRAT)**L
	ENDDO
	ENDDO
	IF(ABS(RRAT(NRAT)-SRAT).GE.1.D-12)THEN
	WRITE(IUT,*)'Warning from <RATMESH>:'
	WRITE(IUT,*)'Lost of accuracy detected.'
	WRITE(IUT,*)'Radial mesh does not match sphere radius.'
	WRITE(IUT,*)'R(nRaT)=',RRAT(NRAT)
	WRITE(IUT,*)'Srat   =',SRAT
	ENDIF
C PRINT RADIAL POINTS
	WRITE(IUN,1010)NRAT,SRAT,TRAT
1010	FORMAT(1X,'nRat =',I4,' ; sRat =',G14.7,1X,A10)
C MEMORY ALLOCATIONS
      NLIB=421
	NLIBMEM=NLIB
      ALLOCATE(RLIB(0:NLIBMEM))
      ALLOCATE(DLIB(0:NLIBMEM))
C BUILT LIBERMAN MESH
      HH1=32.D0
      XMAX=LOG(60.D0)
      XMIN=XMAX-DBLE(NLIB-1)/HH1
      HLIB=(XMAX-XMIN)/DBLE(NLIB-1)
      RLIB(0)=0.D0
      DLIB(0)=0.D0
      DO IRAD=1,NLIB
      RLIB(IRAD)=EXP(XMIN+HLIB*(IRAD-1))
      DLIB(IRAD)=EXP(XMIN+HLIB*(IRAD-1))
      ENDDO
      END
