	SUBROUTINE RAT_RATSCF
************************************************************
*   The calculation of the atomic density                  *
************************************************************
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                         !!! from setup
      USE COM_RATSCF, ONLY : NITER                           !!! from readrat
	USE COM_RATOUT ,ONLY : ICRSC                           !!! from readrat
      USE COM_UNIT,   ONLY : IUN,IUR,IUT,IUI                 !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	CHARACTER ST*8,FN*8,PROGN*8
	DATA ST/'started'/,FN/'finished'/
	IF(ICRSC.EQ.0)RETURN
      CALL RAT_MIXRAT(0,IEXIT,1)   !!! initialize Broyden
C  *****  THE LOOP OF SELF-CONSISTENCY *****
	DO 100 ITER=1,NITER
	write(iun,1100)iter
C CALCULATE FULL POTENTIAL
	progn='Pot     '
	call lib_timel(times)
	write(iun,1110)progn,st,times,curmem,totmem
	CALL RAT_VCOUL(1)   !!! calculate Coulomb potential
	CALL RAT_VEXCH(1)   !!! calculate ex.-cor.potential
	call lib_timel(timef)
	write(iun,1120)progn,fn,timef,curmem,totmem
C CALCULATE NEW DENSITY
	progn='Density '
	call lib_timel(times)
	write(iun,1110)progn,st,times,curmem,totmem
	CALL RAT_RATDEN         !!! find new density
	call lib_timel(timef)
	write(iun,1120)progn,fn,timef,curmem,totmem
	progn='Slaters '
	call lib_timel(times)
	write(iun,1110)progn,st,times,curmem,totmem
	CALL RAT_SLATER         !!! find Slater integrals
	call lib_timel(timef)
	write(iun,1120)progn,fn,timef,curmem,totmem
	progn='Energy  '
	call lib_timel(times)
	write(iun,1110)progn,st,times,curmem,totmem
	CALL RAT_ENERGY(IEXIT)  !!! calculate Total energy
	call lib_timel(timef)
	write(iun,1120)progn,fn,timef,curmem,totmem
C ADMIX DENSITY FOR THE NEXT ITERATION
      CALL RAT_MIXRAT(ITER,IEXIT,2)
	CALL RAT_WRITERAT(2)    !!! store atomic data
	IF(IEXIT.EQ.1)
     &CALL MAN_ARTOUT('Charge density convergence reached')
	write(iun,1130)TOTMEM
	write(iun,1140)TXTMEM
 100  CONTINUE
	CALL MAN_ARTOUT('Number of iterations exceeded in the SCF loop')
1100	FORMAT(/'                ITERATION ',I3/)
1110  FORMAT('***** ',A8,1X,A8,'; CPU : ',G12.5,
     &       '; CUR/MAX mem.(Mb): ',G10.3,'/',G10.3)
1120  FORMAT('***** ',A8,1X,A8,'; CPU : ',G12.5,
     &       '; CUR/MAX mem.(Mb): ',G10.3,'/',G10.3)
1130  FORMAT(/' Maximum memory allocated (Mbyte) ==',G14.7)
1140  FORMAT( ' Peak memory reached in ',A)
	END
