	SUBROUTINE RAT_READRAT
************************************************************
*  <READRAT> controls reading the data from RATFILE.       *
************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LSHELL  ,ONLY: NORB,LORB                       !!! from readrat
      USE COM_LMTINP  ,ONLY: PROJECT,INPINFO                 !!! from artinp
      USE COM_RATOUT  ,ONLY: ICRAT,RATFILE                   !!! from artinp
	USE COM_EXTENS  ,ONLY: LENEXTN                         !!! from setup
	USE COM_RATEXT  ,ONLY: EXTNRAT                         !!! from setup
      USE COM_CHANNELS,ONLY: IUINP                           !!! from channels
	USE COM_UNIT    ,ONLY: IUN,IUT,IUR                     !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	CHARACTER STRING*150,INF*130
	CHARACTER*150, ALLOCATABLE :: RATDATA(:)
	LOGICAL EXIST,MODIFIED,PRESENT
	DATA PI/3.141592653589793D0/
	IF(ICRAT.LE.0)RETURN
C CHECK INPINFO
	INF=INPINFO
	CALL SUBSTR_IN_STR(PRESENT,INF,130,EXTNRAT,LENEXTN)
	IF(.NOT.PRESENT)CALL FULLSTOP('<RATFILE> identifier not found!')
C SET FILE NAME
      CALL FIND_LBLANK(PROJECT,130,NBP)
      CALL FIND_LBLANK(EXTNRAT,60,NBE)
	RATFILE=PROJECT(:NBP)//'.'//EXTNRAT(:NBE)
	INQUIRE(FILE=RATFILE,EXIST=EXIST)
	IF(.NOT.EXIST)CALL FULLSTOP('<RATFILE> not found!')
C ********************************
C UNDERSTAND THE LENGHT OF INIFILE
	CALL FILE_LENGHT(RATFILE,NLEN,IUINP)
	ALLOCATE(RATDATA(NLEN))
C ********************************
C READ RATFILE TO INTERNAL FILE
	OPEN(UNIT=IUINP,FILE=RATFILE,STATUS='OLD',FORM='FORMATTED')
	DO ILEN=1,NLEN
	READ(IUINP,FMT='(A150)')RATDATA(ILEN)
	ENDDO
	CLOSE(IUINP)
C ********************************
C UNDERSTAND INPUT: CLASSIC or MODERN
	STRING=RATDATA(1)
	CALL LIB_CONVLOW(STRING,150)
	CALL LIB_RMBLANK(STRING,150)
	MODERN=0
	DO IPOS=1,80
	IF(STRING(IPOS:IPOS+11).EQ.'input=modern')MODERN=2
	IF(MODERN.NE.0)EXIT
	ENDDO
	IF(MODERN.EQ.2)MODIFIED=.TRUE. 
	IF(MODERN.NE.2)CALL FULLSTOP('<RATFILE> format not recognized!')
C READ CONTROL DATA
	CALL RAT_READRAT_CTRL(RATDATA,NLEN)
C READ RSCF SETTINGS
	CALL RAT_READRAT_RSCF(RATDATA,NLEN)
C READ CONF SETTINGS
	CALL RAT_READRAT_CONF(RATDATA,NLEN)
C READ SLATER INTEGRALS
	CALL RAT_READRAT_SLAT(RATDATA,NLEN)
C READ DMFT SETTINGS
	CALL RAT_READRAT_DMFT(RATDATA,NLEN)
C READ SHELL INFORMATION
	CALL RAT_READRAT_SHEL(RATDATA,NLEN)
C READ CLUSTER INFORMATION
	CALL RAT_READRAT_CLUS(RATDATA,NLEN)
C READ LEVELS INFORMATION
	CALL RAT_READRAT_BLEV(RATDATA,NLEN)
C READ DENSITY SETTINGS
	CALL RAT_READRAT_RDEN(RATDATA,NLEN)
C ********************************
C RATFILE HAS BEEN READ, OVERWRITE IT
	IF(MODIFIED)CALL READ_OVWR(RATFILE,RATDATA,NLEN)
C MEMORY DEALLOCATIONS
	DEALLOCATE(RATDATA)
C Compute Matsubara grid
      CALL HUB_MSBMESH
C Compute Gaunt coefficients
	LMAXBMEM=LORB
	LMAXCMEM=3
	LIMCMEM=(LMAXCMEM+1)**2
	CALL INI_MAKEGNT
C ERROR HANDLINGS
C	none
C *****************************************************************
	END SUBROUTINE RAT_READRAT




	SUBROUTINE RAT_READRAT_CTRL(RATDATA,NLEN)
*******************************************************
* Reads control                                       *
*******************************************************
C SET EXTERNAL CONNECTIONS
	USE COM_CONTROL, ONLY : ILDA,IGGA,ILSD,ISIC         !!! from readrat
      USE COM_RATPAR  ,ONLY : MODR,LCRT,KORB              !!! from readrat
      USE COM_IMPGRF  ,ONLY : KVRB                        !!! from readrat
      USE COM_RATSCF  ,ONLY : ZRAT,TRAT,SRAT              !!! from readrat
      USE COM_LABELS  ,ONLY:  ELEMENT                     !!! from setup
      USE COM_UNIT    ,ONLY : IUN,IUR,IUT
C SET LOCAL VARIABLES 
      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER, INTRINSIC :: SIZE
      CHARACTER*150, ALLOCATABLE :: RATCOPY(:)
      CHARACTER*150, RATDATA(NLEN)
      CHARACTER TEXT*64,TCTRL*10,STRING*150,HELP*40,SNOT*20
      LOGICAL DEF,ASK,VAL,NTH,MDF
      DATA PI/3.141592653589793D0/
C **************************************
C READING CONTROLS
      CALL READ_SECT(RATDATA(1),NLEN,ISEC,NSEC,MSEC,
     &'<section=ctrl',13,'<section=',9,'ok',2)
C Set section title
      DO IPOS=1,150
      IF(RATDATA(ISEC)(IPOS:IPOS).EQ.'>')EXIT
      ENDDO
      DO JPOS=IPOS+1,150
      IF(MSEC.NE.0)RATDATA(ISEC)(JPOS:JPOS)=' '
      ENDDO
      IF(IPOS.LE.50)THEN
      HELP='! CONTROL PARAMETERS:                   '
      IF(MSEC.NE.0)RATDATA(ISEC)(IPOS+1:IPOS+40)=HELP
      ENDIF
C Allocate temporary file
      ALLOCATE(RATCOPY(NSEC))
      DO ILIN=1,MSEC
      RATCOPY(ILIN)=RATDATA(ILIN+ISEC-1)
      ENDDO
C **************************************
C READING THE DATA: SELECT CONTROLS
	TCTRL='          '
	HELP='! set: RatSCF/Shells/ClsSS#/ClsQY#     '
	LHLP=40
	CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &  'method',6,IN,1,0,RE,1,0,CM,1,0,TCTRL,10,1,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
      CALL LIB_CONVLOW(TCTRL,10)
      CALL LIB_RMBLANK(TCTRL,10)
	MODR=-1
      IF(TCTRL(1:6).EQ.'ratscf')MODR=10
      IF(TCTRL(1:6).EQ.'shells')MODR=20
      IF(TCTRL(1:6).EQ.'clsss1')MODR=31
      IF(TCTRL(1:6).EQ.'clsss2')MODR=32
      IF(TCTRL(1:6).EQ.'clsqy1')MODR=41
      IF(TCTRL(1:6).EQ.'clsqy2')MODR=42
      IF(TCTRL(1:6).EQ.'clsag1')MODR=51
      IF(TCTRL(1:6).EQ.'clsag2')MODR=52
	IF(MODR.EQ.-1)THEN
	WRITE(IUT,*)'Terminated in <READRAT>:'
	WRITE(IUT,*)'Syntax error in control line METHOD'
	CALL FULLSTOP(' ')
	ENDIF
C **************************************
C READING THE DATA: SELECT ORBITAL MOMENTA SWITCH
	TCTRL='Find      '
	HELP='! set: Find/None                       '
	LHLP=40
	CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &  'orbmom',6,IN,1,0,RE,1,0,CM,1,0,TCTRL,10,1,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
      CALL LIB_CONVLOW(TCTRL,10)
      CALL LIB_RMBLANK(TCTRL,10)
	KORB=-1
      IF(TCTRL(1:6).EQ.'none  ')KORB=0
      IF(TCTRL(1:6).EQ.'find  ')KORB=1
      IF(TCTRL(1:6).EQ.'auto  ')KORB=1
	IF(KORB.EQ.-1)THEN
	WRITE(IUT,*)'Terminated in <READRAT>:'
	WRITE(IUT,*)'Syntax error in control line ORBMOM'
	CALL FULLSTOP(' ')
	ENDIF
C ******************************************
C READING THE DATA: SELECT VERBOCITY SWITCH
	TCTRL='Full      '
	HELP='! set: Full/None                       '
	LHLP=40
	CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &  'verboc',6,IN,1,0,RE,1,0,CM,1,0,TCTRL,10,1,HELP,LHLP,
     &  DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
      CALL LIB_CONVLOW(TCTRL,10)
      CALL LIB_RMBLANK(TCTRL,10)
	KVRB=-1
      IF(TCTRL(1:6).EQ.'none  ')KVRB=0
      IF(TCTRL(1:6).EQ.'full  ')KVRB=1
      IF(TCTRL(1:6).EQ.'auto  ')KVRB=1
	IF(KVRB.EQ.-1)THEN
	WRITE(IUT,*)'Terminated in <READRAT>:'
	WRITE(IUT,*)'Syntax error in control line VERBOC'
	CALL FULLSTOP(' ')
	ENDIF
C Process Zrat
      ZRAT=0.0D0
      HELP='! Atomic charge                         '
      LHLP=40
      CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &'charge',6,IN,1,0,ZRAT,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Process TRAT
	IRAT=NINT(ZRAT)
	TCTRL=ELEMENT(IRAT)
	HELP='! Atom label                            '
	LHLP=40
	CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &'rtitle',6,IN,1,0,RE,1,0,CM,1,0,TRAT,10,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Process Srat
      SRAT=60.0D0
      HELP='! Max.radius                            '
      LHLP=40
      CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &'sphere',6,IN,1,0,SRAT,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Process ILDA
	TCTRL='Vosko     '
	HELP='! set: none/Barth/Gunn/etc.            '
	LHLP=40
	CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &'ldafun',6,IN,1,0,RE,1,0,CM,1,0,TCTRL,10,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
      CALL LIB_CONVLOW(TCTRL,10)
      CALL LIB_RMBLANK(TCTRL,10)
	ILDA=-1
      IF(TCTRL(1:4).EQ.'none'   )ILDA=0
      IF(TCTRL(1:5).EQ.'barth'  )ILDA=1
      IF(TCTRL(1:4).EQ.'gunn'   )ILDA=2
      IF(TCTRL(1:7).EQ.'moruzzi')ILDA=3
      IF(TCTRL(1:5).EQ.'vosko'  )ILDA=4
      IF(TCTRL(1:6).EQ.'perdew' )ILDA=5
      IF(TCTRL(1:6).EQ.'gaspar' )ILDA=6
      IF(DEF.OR.NTH.OR.ASK      )ILDA=4
	IF(ILDA.EQ.-1)THEN
	WRITE(IUT,*)'Terminated in <READRAT>:'
	WRITE(IUT,*)'Syntax error in control line LDA'
	CALL FULLSTOP(' ')
	ENDIF
C Process IGGA
	TCTRL='none      '
	HELP='! set: none/91/96                      '
	LHLP=40
	CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &'ggafun',6,IN,1,0,RE,1,0,CM,1,0,TCTRL,10,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
      CALL LIB_CONVLOW(TCTRL,10)
      CALL LIB_RMBLANK(TCTRL,10)
	IGGA=-1
      IF(TCTRL(1:4).EQ.'none')IGGA=0
      IF(TCTRL(1:2).EQ.'91'  )IGGA=1
      IF(TCTRL(1:2).EQ.'96'  )IGGA=2
      IF(DEF.OR.NTH.OR.ASK   )IGGA=0
	IF(IGGA.EQ.-1)THEN
	WRITE(IUT,*)'Terminated in <READRAT>:'
	WRITE(IUT,*)'Syntax error in control line GGAFUN'
	CALL FULLSTOP(' ')
	ENDIF
C Process ILSD
      ILSD=0
C Process ISIC
	TCTRL='none      '
	HELP='! set: none/SIC                        '
	LHLP=40
	CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &'sicfun',6,IN,1,0,RE,1,0,CM,1,0,TCTRL,10,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
      CALL LIB_CONVLOW(TCTRL,10)
      CALL LIB_RMBLANK(TCTRL,10)
	ISIC=-1
      IF(TCTRL(1:4).EQ.'none')ISIC=0
      IF(TCTRL(1:3).EQ.'sic' )ISIC=1
      IF(DEF.OR.NTH.OR.ASK   )ISIC=0
	IF(ISIC.EQ.-1)THEN
	WRITE(IUT,*)'Terminated in <READRAT>:'
	WRITE(IUT,*)'Syntax error in control line SICFUN'
	CALL FULLSTOP(' ')
	ENDIF
C Process RELATIVISM
      TCTRL='Diraq'
      HELP='! None/Scalar/Diraq                     '
      LHLP=40
      CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &'relkey',6,IN,1,0,RE,1,0,CM,1,0,TCTRL,10,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Transform to integer keys
	CALL LIB_CONVLOW(TCTRL,10)
	CALL LIB_RMBLANK(TCTRL,10)
	NB=INDEX(TCTRL,' ')
	LCRT=-1
	IF(TCTRL(:NB-1).EQ.'none'  )LCRT=0
	IF(TCTRL(:NB-1).EQ.'scalar')LCRT=1
	IF(TCTRL(:NB-1).EQ.'diraq' )LCRT=2
	IF(LCRT.EQ.-1)
     &CALL FULLSTOP('Wrong <<relkey>> keyword in RATFILE')
C **************************************
      CALL READ_ERRR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,'CTRL')
      DEALLOCATE(RATCOPY)
C Memory deallocations
C     none
	END SUBROUTINE RAT_READRAT_CTRL



	SUBROUTINE RAT_READRAT_RSCF(RATDATA,NLEN)
*******************************************************
* Reads control                                       *
*******************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_RATSCF  ,ONLY : ZRAT,TRAT,SRAT,NITER,EPSEN,EPSRAT
     &                       ,ADMIXL,ADMIX1,MIXBRD
      USE COM_UNIT    ,ONLY : IUN,IUR,IUT
C SET LOCAL VARIABLES 
      IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER*150, ALLOCATABLE :: RATCOPY(:)
      CHARACTER*150, RATDATA(NLEN)
      CHARACTER TEXT*64,TCTRL*10,STRING*150,HELP*40,SNOT*20
      LOGICAL DEF,ASK,VAL,NTH,MDF
      DATA PI/3.141592653589793D0/
C **************************************
C READING CONTROLS
      CALL READ_SECT(RATDATA(1),NLEN,ISEC,NSEC,MSEC,
     &'<section=rscf',13,'<section=',9,'ok',2)
C Set section title
      DO IPOS=1,150
      IF(RATDATA(ISEC)(IPOS:IPOS).EQ.'>')EXIT
      ENDDO
      DO JPOS=IPOS+1,150
      IF(MSEC.NE.0)RATDATA(ISEC)(JPOS:JPOS)=' '
      ENDDO
      IF(IPOS.LE.50)THEN
      HELP='! SELF-CONSISTENCY                      '
      IF(MSEC.NE.0)RATDATA(ISEC)(IPOS+1:IPOS+40)=HELP
      ENDIF
C Allocate temporary file
      ALLOCATE(RATCOPY(NSEC))
      DO ILIN=1,MSEC
      RATCOPY(ILIN)=RATDATA(ILIN+ISEC-1)
      ENDDO
C **************************************
C READING THE DATA: SELECT SCF SETTINGS
C Process EpsEn
      EPSEN=1.D-14
      HELP='! Energy convergence                    '
      LHLP=40
      CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &'epstot',6,IN,1,0,EPSEN,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Process EpsRat
      EPSRAT=1.D-05
      HELP='! Density convergence                   '
      LHLP=40
      CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &'epsrat',6,IN,1,0,EPSRAT,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Process Niter
      NITER=50
      HELP='! # of iterations                       '
      LHLP=40
      CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &'niter1',6,NITER,1,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Process Admix1
      ADMIX1=0.3D0
      HELP='! Broyden Mixing                        '
      LHLP=40
      CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &'mixing',6,IN,1,0,ADMIX1,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Process AdmixL
      ADMIXL=0.1D0
      HELP='! Linear Mixing                         '
      LHLP=40
      CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &'admixl',6,IN,1,0,ADMIXL,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Process Broyden
      TCTRL='On'
      HELP='! On/Off                                '
      LHLP=40
      CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &'broyden',7,IN,1,0,RE,1,0,CM,1,0,TCTRL,10,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Set memory control parameter
	NTERMEM=15
C Transform to integer keys
	CALL LIB_CONVLOW(TCTRL,10)
	CALL LIB_RMBLANK(TCTRL,10)
	NB=INDEX(TCTRL,' ')
	MIXBRD=.TRUE.
	IF(TCTRL(:NB-1).EQ.'on' )MIXBRD=.TRUE.
	IF(TCTRL(:NB-1).EQ.'off')MIXBRD=.FALSE.
C **************************************
      CALL READ_ERRR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,'RSCF')
      DEALLOCATE(RATCOPY)
	END SUBROUTINE RAT_READRAT_RSCF




	SUBROUTINE RAT_READRAT_DMFT(RATDATA,NLEN)
*******************************************************
* Reads DMFT settings                                 *
*******************************************************
C SET EXTERNAL CONNECTIONS
      USE COM_IMPGRF  ,ONLY : CHEM,FILL,KFRM
	USE COM_MSBMESH ,ONLY : TEMP,OBND,NMSB,NMSL,WMSB,KGRD
     &                       ,WMSL,DMSB,DMSL,SMSB,SMSL
     &                       ,FMSB,NOMG,WOMG,WMIN,WMAX
      USE COM_UNIT    ,ONLY : IUN,IUR,IUT
      USE COM_MASHDEP ,ONLY : NVAL,LENCMP
C SET LOCAL VARIABLES 
      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER, INTRINSIC :: SIZE
      CHARACTER*150, ALLOCATABLE :: RATCOPY(:)
      LOGICAL DEF,ASK,VAL,NTH,MDF
      CHARACTER*150, RATDATA(NLEN)
      CHARACTER TEXT*64,TCTRL*10,STRING*150,HELP*40,SNOT*20
      DATA PI/3.141592653589793D0/
C **************************************
C READING THE DATA: SELECT DMFT SETTINGS
C NMSB - # of Matsubara energies
C TEMP - # Temperature in K
C NDIT - # of DMFT iterations
      CALL READ_SECT(RATDATA(1),NLEN,ISEC,NSEC,MSEC,
     &'<section=dmft',13,'<section=',9,'ok',2)
C Set section title
      DO IPOS=1,150
      IF(RATDATA(ISEC)(IPOS:IPOS).EQ.'>')EXIT
      ENDDO
      DO JPOS=IPOS+1,150
      IF(MSEC.NE.0)RATDATA(ISEC)(JPOS:JPOS)=' '
      ENDDO
      IF(IPOS.LE.50)THEN
      HELP='! DMFT SETTINGS                         '
      IF(MSEC.NE.0)RATDATA(ISEC)(IPOS+1:IPOS+40)=HELP
      ENDIF
C Allocate temporary file
      ALLOCATE(RATCOPY(NSEC))
      DO ILIN=1,MSEC
      RATCOPY(ILIN)=RATDATA(ILIN+ISEC-1)
      ENDDO
C Process NMSB
      NMSB=50
      HELP='! # of Matsubara frequencies            '
      LHLP=40
      CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &'nmsb',4,NMSB,1,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
	NMSBMEM=NMSB
	NMSCMEM=NMSB
C Process OBND
      OBND=1.D0
      HELP='! Effective bandwidth for the grid      '
      LHLP=40
      CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &'obnd',4,IN,1,0,OBND,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Process NMSL
      NMSL=1024
      HELP='! # of linear Matsubara frequencies     '
      LHLP=40
      CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &'nmsl',4,NMSL,1,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
      NMSLMEM=NMSL
C Process NOMG
      NOMG=100
      HELP='! # of frequencies at real axis         '
      LHLP=40
      CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &'nomg',4,NOMG,1,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
      NOMGMEM=NOMG
C Process WMIN
      WMIN=-10.D0
      HELP='! Minimal frequency for the real axis   '
      LHLP=40
      CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &'wmin',4,IN,1,0,WMIN,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Process WMAX
      WMAX=+10.D0
      HELP='! Maximal frequency for the real axis   '
      LHLP=40
      CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &'wmax',4,IN,1,0,WMAX,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Process KGRD
      KGRD=2 ! default is imaginary axis
      HELP='! set current grid to real/imag         '
      LHLP=40
      CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &'grid',4,IN,1,0,RE,1,0,CM,1,0,TCTRL,10,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
      CALL LIB_CONVLOW(TCTRL,10)
      CALL LIB_RMBLANK(TCTRL,10)
	IF(TCTRL(1:4).EQ.'real')KGRD=1
	IF(TCTRL(1:4).EQ.'imag')KGRD=2
C Process Fill
      FILL=0.D0
      HELP='! Mean Filling                          '
      LHLP=40
      CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &'fill',4,IN,1,0,FILL,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Process Chem
      CHEM=0.D0
      HELP='! Chemical potential                    '
      LHLP=40
      CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &'chem',4,IN,1,0,CHEM,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Process Fermi Search options
      TCTRL='auto      '
      HELP='! Fermi search options                  '
      LHLP=40
      CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &'kfrm',4,IN,1,0,RE,1,0,CM,1,0,TCTRL,10,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
      CALL LIB_CONVLOW(TCTRL,10)
      CALL LIB_RMBLANK(TCTRL,10)
	KFRM=-1
	IF(TCTRL(1:4).EQ.'auto')KFRM=0
	IF(TCTRL(1:4).EQ.'fill')KFRM=0
	IF(TCTRL(1:4).EQ.'find')KFRM=0
	IF(TCTRL(1:4).EQ.'keep')KFRM=1
	IF(KFRM.EQ.-1)
     &CALL FULLSTOP('Keyword KFRM not recognized in RATFILE')
C Process temperature
      TEMP=0.001D0
      HELP='! Temperature of the calculation        '
      LHLP=40
      CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &'temp',4,IN,1,0,TEMP,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
	IF(ABS(TEMP).LE.1.D-10.AND.KGRD.EQ.2)
     &CALL FULLSTOP('T should not be 0 if grid=IMAG')
C **************************************
      CALL READ_ERRR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,'DMFT')
      DEALLOCATE(RATCOPY)
	END SUBROUTINE RAT_READRAT_DMFT





	SUBROUTINE RAT_READRAT_SHEL(RATDATA,NLEN)
*******************************************************
* Reads control                                       *
*******************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_RATPAR  ,ONLY : MODR                                    !!! from readrat
      USE COM_LSHELL  ,ONLY : NORB,LORB,LOCCIMP,HMAG,KSYS,CSTA,
     &                        HORB,ALSC,ELEV,FSLA,NFILSHL,NFLUSHL,    !!! from readrat
     &                        DAMP,NRUNSHL,KSTSHL 
      USE COM_IMPGRF  ,ONLY : KINT,KRAT,NMOM,NPOL,NRAT,NPLD,KDIN,KDRT !!! from readrat
      USE COM_RATSCF  ,ONLY : ZRAT,TRAT,SRAT                          !!! from readrat
      USE COM_UNIT    ,ONLY : IUN,IUR,IUT                             !!! from readrat
C SET LOCAL VARIABLES 
      IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER*150, ALLOCATABLE :: RATCOPY(:)
      INTEGER KST(14)
	REAL*8 ELOC(14)
      CHARACTER*150, RATDATA(NLEN)
      CHARACTER TEXT*64,TCTRL*10,STRING*150,HELP*40,SNOT*20
     &   ,CTHUB*2,CLHUB*1,TORB*2
      LOGICAL DEF,ASK,VAL,NTH,MDF
      DATA PI/3.141592653589793D0/
C MEMORY ALLOCATIONS FOR MAIN ARRAYS
C None
	DO L=0,3
	FSLA(L)=0.D0
	ENDDO
	DO IDIM=1,14
	ELOC(IDIM)=0.D0
	ENDDO
C **************************************
C READING CONTROLS
      CALL READ_SECT(RATDATA(1),NLEN,ISEC,NSEC,MSEC,
     &'<section=shel',13,'<section=',9,'ok',2)
C Set section title
      DO IPOS=1,150
      IF(RATDATA(ISEC)(IPOS:IPOS).EQ.'>')EXIT
      ENDDO
      DO JPOS=IPOS+1,150
      IF(MSEC.NE.0)RATDATA(ISEC)(JPOS:JPOS)=' '
      ENDDO
      IF(IPOS.LE.50)THEN
      HELP='! SHELL DATA                            '
      IF(MSEC.NE.0)RATDATA(ISEC)(IPOS+1:IPOS+40)=HELP
      ENDIF
C Allocate temporary file
      ALLOCATE(RATCOPY(NSEC))
      DO ILIN=1,MSEC
      RATCOPY(ILIN)=RATDATA(ILIN+ISEC-1)
      ENDDO
C Process cState (cannot be blank)
      TCTRL='El@0::1s  '
      HELP='! Correlated State pointer              '
      LHLP=40
      CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &'cstate',6,IN,1,0,RE,1,0,CM,1,0,TCTRL,10,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
	CSTA=TCTRL
	CALL GET_STATE(TCTRL,10,IAORB,ISORB,MQ,LORB,M,1)
	IF(LORB.LT.0.OR.LORB.GT.3)
     &CALL FULLSTOP('Wrong correlated state pointer') 
	NORB=MQ
C Process Fill
      NFILSHL=0
      HELP='! Shell Mean Filling                    '
      LHLP=40
      CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &'nfill',5,NFILSHL,1,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Process Fluc
      NFLUSHL=0
      HELP='! Fluctuations around mean filling      '
      LHLP=40
      CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &'nfluc',5,NFLUSHL,1,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Process Hmag
      HMAG=0.D0
      HELP='! External magnetic spin field          '
      LHLP=40
      CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &'hmag',4,IN,1,0,HMAG,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Process Horb
      HORB=0.D0
      HELP='! External magnetic orbtial field       '
      LHLP=40
      CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &'horb',4,IN,1,0,HORB,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Process Alsc
      ALSC=0.D0
      HELP='! Spin orbit coupling strength          '
      LHLP=40
      CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &'alsc',4,IN,1,0,ALSC,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Process Damp
      DAMP=0.D0
      HELP='! Damping parameter                     '
      LHLP=40
      CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &'damp',4,IN,1,0,DAMP,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Process coordinate system for local levels
      TCTRL='spherical '
      HELP='! system: cubic/spherical/spinor        '
      LHLP=40
      CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &'crdsys',6,IN,1,0,RE,1,0,CM,1,0,TCTRL,10,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
      CALL LIB_CONVLOW(TCTRL,10)
      CALL LIB_RMBLANK(TCTRL,10)
	NB=INDEX(TCTRL,' ')
	KSYS=-1
	IF(TCTRL(:NB-1).EQ.'cubic'    )KSYS=1
	IF(TCTRL(:NB-1).EQ.'spherical')KSYS=2
	IF(TCTRL(:NB-1).EQ.'spinor'   )KSYS=3
C	IF(TCTRL(:NB-1).EQ.'diagonal' )KSYS=4
C	IF(TCTRL(:NB-1).EQ.'custom'   )KSYS=5
	IF(KSYS.EQ.-1)
     &CALL FULLSTOP('Coordinate system not recognized')
C Process Eloc
	IF(LORB.LE.1)HELP='! Local level energies                  '
	IF(LORB.GT.1)HELP='                                        '
      LHLP=40
      DO I=1,14
      ELOC(I)=0.D0
      ENDDO
      CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &'eloc(:)',7,IN,1,0,ELOC,2*(2*LORB+1),1,CM,1,0,' ',1,0,
     &HELP,LHLP,DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C **************************************
C Process # of runs for impurity solver
	NRUN=1
      HELP='! # of runs for impurity solver         '
      LHLP=40
      CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &'imprun',6,NRUN,1,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
	NRUNSHL=NRUN
C **************************************
C For each run process states which participate
	NDIM=2*(2*LORB+1)
	DO IRUN=1,NRUNSHL          !!! ovr runs
	DO IDIM=1,NDIM
	KST(IDIM)=IDIM
	ENDDO
      HELP='! states pointer in each run            '
	CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &'kstates(:)',10,KST,NDIM,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.FALSE.,.FALSE.)
	DO IDIM=1,NDIM
	KSTSHL(IDIM,IRUN)=KST(IDIM)
	ENDDO
C Count degeneracies
	NDEG=0
	DO IDIM=1,NDIM
	IF(KSTSHL(IDIM,IRUN).NE.0)NDEG=NDEG+1
	ENDDO
	IF(MOD(NDEG,2).NE.0)
     &CALL FULLSTOP('Wrong kstates(:) pointer')
	ENDDO                          !!! over runs
C Process Rational Interpolation Method
      TCTRL='mom4      '
      HELP='! Rational interpolation method         '
      LHLP=40
      CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &'sigint',6,IN,1,0,RE,1,0,CM,1,0,TCTRL,10,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
	CALL LIB_CONVLOW(TCTRL,10)
	CALL LIB_RMBLANK(TCTRL,10)
	NB=INDEX(TCTRL,' ')
	KINT=-1
	IF(TCTRL(:NB-1).EQ.'none')KINT=0
	IF(TCTRL(:NB-1).EQ.'mom2')KINT=1
	IF(TCTRL(:NB-1).EQ.'mom4')KINT=2
	IF(TCTRL(:NB-1).EQ.'mom6')KINT=3
	IF(TCTRL(:NB-1).EQ.'momn')KINT=4
	IF(KINT.EQ.-1)
     &CALL FULLSTOP('<RAT_READRAT>Wrong <<kint>> keyword')
      IF(MODR/10.EQ.5.AND.KINT.NE.4)
     &CALL FULLSTOP('<RAT_READRAT>Set kint=MomN for KPM solvers')
C Process NPOL for impurity self-energy
      IF(KINT.EQ.0)NPOL=0
      IF(KINT.EQ.1)NPOL=1
      IF(KINT.EQ.2)NPOL=3
      IF(KINT.EQ.3)NPOL=5
      IF(KINT.EQ.4)NPOL=5
      HELP='! # of poles in Sigma(w) fit           '
      LHLP=40
      CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &'npol',4,NPOL,1,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.FALSE.,.FALSE.)
	IF(MOD(NPOL+1,2).NE.0.AND.NPOL.GT.0)
     &CALL FULLSTOP('<GETGRF>:: Npol must be Even')
      IF(KINT.EQ.0)NRAT=0
      IF(KINT.EQ.1)NRAT=2
      IF(KINT.EQ.2)NRAT=4
      IF(KINT.EQ.3)NRAT=6
      IF(KINT.EQ.4)NRAT=NPOL+1
      IF(NRAT.NE.NPOL+1.AND.NPOL.GT.0)
     &CALL FULLSTOP('<RAT_READRAT>::NRAT.NE.NPOL+1')
	IF(MOD(NRAT,2).NE.0)
     &CALL FULLSTOP('<RAT_READRAT>:: Nrat must be ODD')
	NMOM=MAX(NRAT,5)
C Force rational interpolation for Self-Energy
      TCTRL='sigmaw    '
      HELP='! Force rational interpolation for Sigma'
      LHLP=40
      CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &'sigrat',6,IN,1,0,RE,1,0,CM,1,0,TCTRL,10,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
	CALL LIB_CONVLOW(TCTRL,10)
	CALL LIB_RMBLANK(TCTRL,10)
	NB=INDEX(TCTRL,' ')
	KRAT=-1
	IF(TCTRL(:NB-1).EQ.'sigmaw')KRAT=0
	IF(TCTRL(:NB-1).EQ.'ratint')KRAT=1
	IF(KRAT.EQ.-1)
     &CALL FULLSTOP('<RAT_READRAT>:Wrong <<krat>> keyword in RATFILE')
C **************************************
C Process Delta Interpolation method
      TCTRL='none      '
      HELP='! Delta Interpolation Method            '
      LHLP=40
      CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &'delint',6,IN,1,0,RE,1,0,CM,1,0,TCTRL,10,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
      CALL LIB_CONVLOW(TCTRL,10)
      CALL LIB_RMBLANK(TCTRL,10)
	NB=INDEX(TCTRL,' ')
	KDIN=-1
	IF(TCTRL(:NB-1).EQ.'none')KDIN=0
	IF(TCTRL(:NB-1).EQ.'mom2')KDIN=1
	IF(TCTRL(:NB-1).EQ.'mom4')KDIN=2
	IF(TCTRL(:NB-1).EQ.'mom6')KDIN=3
	IF(TCTRL(:NB-1).EQ.'momn')KDIN=4
	IF(TCTRL(:NB-1).EQ.'grid')KDIN=5
	IF(TCTRL(:NB-1).EQ.'conj')KDIN=6
	IF(TCTRL(:NB-1).EQ.'pade')KDIN=7
	IF(KDIN.EQ.-1)
     &CALL FULLSTOP('<HUB_READHUB>::Wrong <<delint>> keyword')
	IF(KDIN.EQ.1.OR.KDIN.EQ.2.OR.KDIN.EQ.3)WRITE(IUT,*)
     &'<RAT_READRAT>:: Reverse moments for metallic Delta(w) diverge!'
C **************************************
C Process Delta Representation
      TCTRL='deltaw    '
      HELP='! Delta Represenation: DeltaW/RatInt    '
      LHLP=40
      CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &'delrat',6,IN,1,0,RE,1,0,CM,1,0,TCTRL,10,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
      CALL LIB_CONVLOW(TCTRL,10)
      CALL LIB_RMBLANK(TCTRL,10)
	NB=INDEX(TCTRL,' ')
	KDRT=-1
	IF(TCTRL(:NB-1).EQ.'deltaw')KDRT=0
	IF(TCTRL(:NB-1).EQ.'ratint')KDRT=1
C Process NPLD
      NPLD=0
      IF(KDIN.EQ.1)NPLD=2
      IF(KDIN.EQ.2)NPLD=4
      IF(KDIN.EQ.3)NPLD=6
      HELP='! # of poles for hybridization          '
      LHLP=40
      CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &'npld',4,NPLD,1,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C **************************************
C Process Slater Integrals, F(0,ll),F(2,ll),F(4,ll), etc.
	DO L=0,LORB
	FSLT=0.D0
      HELP='! Slater integrals                      '
      LHLP=40
	WRITE(CLHUB,FMT='(I1)')2*L
	CTHUB='f'//CLHUB
      CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &CTHUB,2,IN,1,0,FSLT,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
	FSLA(L)=FSLT
	ENDDO
C **************************************
      CALL READ_ERRR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,'SHEL')
      DEALLOCATE(RATCOPY)
	L=LORB
C Set up occupancies to be calculated
      NDIM=2*(2*LORB+1)
      IF(.NOT.ALLOCATED(LOCCIMP))
     &ALLOCATE(LOCCIMP(0:NDIM))
      DO IOCC=0,NDIM
      LOCCIMP(IOCC)=0
      ENDDO
      DO IOCC=0,NDIM
      IF(IOCC.GE.NFILSHL-NFLUSHL.AND.IOCC.LE.NFILSHL+NFLUSHL)
     &LOCCIMP(IOCC)=1
      ENDDO
C Transform matrix of local levels to spherical harmonics
	IF(.NOT.ALLOCATED(ELEV))
     &ALLOCATE(ELEV(NDIM,NDIM))
	DO IDIM1=1,NDIM
	DO IDIM=1,NDIM
	ELEV(IDIM1,IDIM)=(0.D0,0.D0)
	ENDDO
	ELEV(IDIM1,IDIM1)=ELOC(IDIM1)
	ENDDO
      CALL LIB_TRANSCUB(NDIM,-KSYS,NDIM,-KSYS,ELEV)
C Memory deallocations
C none
	END SUBROUTINE RAT_READRAT_SHEL





	SUBROUTINE RAT_READRAT_CLUS(RATDATA,NLEN)
*******************************************************
* Reads control                                       *
*******************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_RATPAR  ,ONLY : EPSHUB,EPSMAT,EPSZIP,EPSDEG
      USE COM_RATCLS  ,ONLY : WCUTBAS,WEXTBAS,NEXCPAR,EXCTEMP
     &                       ,NMOMHAM,NLANCOS,KHYBLEV                 !!! from readrat
	USE COM_MSBMESH ,ONLY : TEMP                                    !!! from readrat
      USE COM_RATHYB  ,ONLY : BMAG,NBST                               !!! from readrat
      USE COM_UNIT    ,ONLY : IUN,IUR,IUT                             !!! from readrat
C SET LOCAL VARIABLES 
      IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER*150, ALLOCATABLE :: RATCOPY(:)
      CHARACTER*150, RATDATA(NLEN)
      CHARACTER TEXT*64,TCTRL*10,STRING*150,HELP*40,SNOT*20
     &   ,CTHUB*2,CLHUB*1,TORB*2
      LOGICAL DEF,ASK,VAL,NTH,MDF
      DATA PI/3.141592653589793D0/
C MEMORY ALLOCATIONS FOR MAIN ARRAYS
C **************************************
C READING CONTROLS
      CALL READ_SECT(RATDATA(1),NLEN,ISEC,NSEC,MSEC,
     &'<section=clus',13,'<section=',9,'ok',2)
C Set section title
      DO IPOS=1,150
      IF(RATDATA(ISEC)(IPOS:IPOS).EQ.'>')EXIT
      ENDDO
      DO JPOS=IPOS+1,150
      IF(MSEC.NE.0)RATDATA(ISEC)(JPOS:JPOS)=' '
      ENDDO
      IF(IPOS.LE.50)THEN
      HELP='! CLUSTER DATA                          '
      IF(MSEC.NE.0)RATDATA(ISEC)(IPOS+1:IPOS+40)=HELP
      ENDIF
C Allocate temporary file
      ALLOCATE(RATCOPY(NSEC))
      DO ILIN=1,MSEC
      RATCOPY(ILIN)=RATDATA(ILIN+ISEC-1)
      ENDDO
C Process BMAG
      BMAG=0.D0
      HELP='! Magnetic Field for the bath electrons '
      LHLP=40
      CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &'bmag',4,IN,1,0,BMAG,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Process nBst
      NBST=0
      HELP='! # of bath levels                      '
      LHLP=40
      CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &'nbat',4,NBST,1,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Process WCUTBAS
      WCUTBAS=1.D+10
      HELP='! Cutoff Frequency for the basis set    '
      LHLP=40
      CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &'wcutbas',7,IN,1,0,WCUTBAS,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Process WEXTBAS
      WEXTBAS=WCUTBAS
      HELP='! Max.   Frequency for the basis set    '
      LHLP=40
      CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &'wextbas',7,IN,1,0,WEXTBAS,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Process NEXCPAR
      NEXCPAR=-1
      HELP='! # of particles to excite in the bath  '
      LHLP=40
      CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &'nexcpar',7,NEXCPAR,1,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Process EXCTEMP
      EXCTEMP=0.D0
      HELP='! Fictitious temperature for the bath   '
      LHLP=40
      CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &'exctemp',7,IN,1,0,EXCTEMP,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Process NMOMHAM
      NMOMHAM=500
      HELP='! # of moments for hamiltonian          '
      LHLP=40
      CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &'nmomham',7,NMOMHAM,1,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Process NLANCOS
      NLANCOS=10
      HELP='! # of exact states to find with Lancosz'
      LHLP=40
      CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &'nlancos',7,NLANCOS,1,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Process KHYBLEV
      TCTRL='fixrat'
      HELP='! bath levels: fixrat/fixhop/scfhyb    '
      LHLP=40
      CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &'bathlev',7,IN,1,0,RE,1,0,CM,1,0,TCTRL,10,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
	CALL LIB_CONVLOW(TCTRL,10)
	CALL LIB_RMBLANK(TCTRL,10)
	NB=INDEX(TCTRL,' ')
	KHYBLEV=-1
	IF(TCTRL(:NB-1).EQ.'fixrat')KHYBLEV=1
	IF(TCTRL(:NB-1).EQ.'fixhop')KHYBLEV=2
	IF(TCTRL(:NB-1).EQ.'scfhyb')KHYBLEV=3
	IF(KHYBLEV.EQ.-1)CALL FULLSTOP(
     &'<RAT_READRAT>:Wrong <<BathLev>> keyword in RATFILE')
C Process Degeneracy Threshold
      EPSDEG=1.D-06
      HELP='! Degeneracy threshold                  '
      LHLP=40
      CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &'epsdeg',6,IN,1,0,EPSDEG,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Process Statistical Weights Threshold
      EPSHUB=1.D-12
      HELP='! Statistical Weights Threshold         '
      LHLP=40
      CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &'epshub',6,IN,1,0,EPSHUB,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Process Hybridization Matrix Elements Threshold
      EPSMAT=1.D-06
      HELP='! Matrix Elements Threshold             '
      LHLP=40
      CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &'epsmat',6,IN,1,0,EPSMAT,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Process Storage Threshold
      EPSZIP=1.D-06
      HELP='! Storage Threshold                     '
      LHLP=40
      CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &'epszip',6,IN,1,0,EPSZIP,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C **************************************
      CALL READ_ERRR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,'SHEL')
      DEALLOCATE(RATCOPY)
	END SUBROUTINE RAT_READRAT_CLUS






	SUBROUTINE RAT_READRAT_BLEV(RATDATA,NLEN)
*******************************************************
* Reads control                                       *
*******************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_IMPGRF  ,ONLY : FILL                                    !!! from readrat
      USE COM_RATCLS  ,ONLY : LOCCCLS,LOCCBAT                         !!! from readrat
      USE COM_LSHELL  ,ONLY : LORB,LOCCIMP,KSYS,NFILSHL,NFLUSHL       !!! from readrat
      USE COM_RATHYB  ,ONLY : NBST,NHYB,NDST,EHYB,VHYB,TBST           !!! from readrat
      USE COM_UNIT    ,ONLY : IUN,IUR,IUT                             !!! from readrat
C SET LOCAL VARIABLES 
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8, ALLOCATABLE :: EBATH(:,:)
      REAL*8, ALLOCATABLE :: VBATH(:,:)
      CHARACTER*150, ALLOCATABLE :: RATCOPY(:)
      CHARACTER*150, RATDATA(NLEN)
      CHARACTER TEXT*64,TCTRL*10,STRING*150,HELP*40,SNOT*20
     &   ,CTHUB*2,CLHUB*1,TORB*2
      LOGICAL DEF,ASK,VAL,NTH,MDF
      DATA PI/3.141592653589793D0/
C MEMORY ALLOCATIONS
      NDIM=2*(2*LORB+1)
      ALLOCATE(NDST(NBST))
      ALLOCATE(TBST(NBST))
      ALLOCATE(EBATH(14*NDIM,NBST))
      ALLOCATE(VBATH(14*NDIM,NBST))
C *********************************************
C READING THE DATA: SELECT BATH LEVELS
	ILOC=1
	DO 1000 IBST=1,NBST                    !!! over bath states
      CALL READ_SECT(RATDATA(ILOC),NLEN-ILOC+1,KSEC,NSEC,MSEC,
     &'<section=blev',13,'<section=',9,'ok',2)
	ISEC=KSEC+ILOC-1
	ILOC=ISEC+1
C Set section title
      DO IPOS=1,150
      IF(RATDATA(ISEC)(IPOS:IPOS).EQ.'>')EXIT
      ENDDO
      DO JPOS=IPOS+1,150
      IF(MSEC.NE.0)RATDATA(ISEC)(JPOS:JPOS)=' '
      ENDDO
      IF(IPOS.LE.50)THEN
      HELP='! BATH STATES                           '
      IF(MSEC.NE.0)RATDATA(ISEC)(IPOS+1:IPOS+40)=HELP
      ENDIF
C Allocate temporary file
      ALLOCATE(RATCOPY(NSEC))
      DO ILIN=1,MSEC
      RATCOPY(ILIN)=RATDATA(ILIN+ISEC-1)
      ENDDO
C Process Level notation
      SNOT='          '
      HELP='! Correlated state pointer              '
      LHLP=40
      CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &'bstate',6,IN,1,0,RE,1,0,CM,1,0,SNOT,20,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
      TBST(IBST)=SNOT
C Process Degeneracy
      NDST(IBST)=0
      HELP='! Degeneracy                            '
      LHLP=40
      CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &'ndeg',4,NDST(IBST),1,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
      IF(NDST(IBST).GT.14)
     &CALL FULLSTOP('<READRAT>:: Ndeg > 14 not assumed')
C Process Ebat
	HELP='! Bath levels                           '
	DO I=1,NDST(IBST)
	EBATH(I,IBST)=0.D0
	ENDDO
      LHLP=40
      CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &'ebat(:)',7,IN,1,0,EBATH(1,IBST),NDST(IBST),1,CM,1,0,' ',1,0,
     &HELP,LHLP,DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Process Vscl
      VSCL=1.D0
	HELP='! Scale hybridizations                  '
      LHLP=40
      CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &'vscl',4,IN,1,0,VSCL,1,1,CM,1,0,' ',1,0,
     &HELP,LHLP,DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Process Vhyb
      NBAT=NDIM*NDST(IBST)
	DO I=1,NBAT
	VBATH(I,IBST)=0.D0
	ENDDO
	HELP='                                        '
      LHLP=40
      CALL READ_CHAR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,
     &'vhyb(:)',7,IN,1,0,VBATH(1,IBST),NBAT,1,CM,1,0,' ',1,0,
     &HELP,LHLP,DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
      DO IBAT=1,NBAT
      VBATH(IBAT,IBST)=VBATH(IBAT,IBST)*VSCL
      ENDDO
C **************************************
      CALL READ_ERRR(RATDATA(ISEC),RATCOPY(1),NSEC,MSEC,'BLEV')
      DEALLOCATE(RATCOPY)
 1000 CONTINUE                                  !!! over bath states
C Count total number of bath levels
      NHYB=0
      DO IBST=1,NBST
      NHYB=NHYB+NDST(IBST)
      ENDDO
C Set up cluster occupancies to be calculated
      ALLOCATE(LOCCCLS(0:NDIM+NHYB))
      NFILCLS=NINT(FILL)
      DO IOCC=0,NDIM+NHYB
      LOCCCLS(IOCC)=0
      ENDDO
      DO IOCC=0,NDIM+NHYB
      IF(IOCC.GE.NFILCLS-NFLUSHL.AND.IOCC.LE.NFILCLS+NFLUSHL)
     &LOCCCLS(IOCC)=1
      ENDDO
C Set up possible bath occupancies
      ALLOCATE(LOCCBAT(0:NHYB))
      DO IOCC=0,NHYB
      LOCCBAT(IOCC)=0
      ENDDO
      DO IOCCCLS=0,NDIM+NHYB
      IF(LOCCCLS(IOCCCLS).EQ.0)CYCLE
      DO IOCCIMP=0,NDIM
      IF(LOCCIMP(IOCCIMP).EQ.0)CYCLE
      IOCCBAT=IOCCCLS-IOCCIMP
      IF(IOCCBAT.LT.0.OR.IOCCBAT.GT.NHYB)CYCLE
      LOCCBAT(IOCCBAT)=1
      ENDDO
      ENDDO
C Set up bath levels and hybridization matrix elements  
      ALLOCATE(EHYB(NHYB))
      ALLOCATE(VHYB(NDIM,NHYB))
      IHYB=0
      DO IBST=1,NBST
      IBAT=0
      DO IDST=1,NDST(IBST)
      IHYB=IHYB+1
      EHYB(IHYB)=DCMPLX(EBATH(IDST,IBST),0.D0)
      DO IDIM=1,NDIM
      IBAT=IBAT+1
      VHYB(IDIM,IHYB)=DCMPLX(VBATH(IBAT,IBST),0.D0)
      ENDDO
      ENDDO
      ENDDO
      CALL LIB_TRANSCUB(NDIM,-KSYS,NHYB,0,VHYB)
C MEMORY DEALLOCATIONS
      DEALLOCATE(EBATH,VBATH)
      END





	SUBROUTINE RAT_READRAT_CONF(RATDATA,NLEN)
*******************************************************************
* Reads atomic configuration from atomic data files.              *
*******************************************************************
C SET ARRAY SIZE DATA
	USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_RATSCF  ,ONLY : ZRAT,ERAT
	USE COM_RATLEV  ,ONLY : NLEVT,LNUM,ELEV,ZLEV
     &                       ,LEVN,LEVL,LEVJ,LEVC
	USE COM_UNIT    ,ONLY: IUN,IUT,IUR                     !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER*150, ALLOCATABLE :: RATCOPY(:)
      CHARACTER*150, RATDATA(NLEN)
      CHARACTER TEXT*64,TCTRL*10,STRING*150,HELP*40,SNOT*20
      LOGICAL DEF,ASK,VAL,NTH,MDF,CASE,EXIST
      DATA PI/3.141592653589793D0/
C ******************************************
C MEMORY ALLOCATIONS FOR MAIN CONTROL ARRAYS
	NLEVT=0
	ALLOCATE(LNUM(36))
	ALLOCATE(ELEV(36))
	ALLOCATE(ZLEV(36))
	ALLOCATE(LEVC(36))
	ALLOCATE(LEVN(36))
	ALLOCATE(LEVL(36))
	ALLOCATE(LEVJ(36))
	DO ILEV=1,36
	LNUM(ILEV)=0
	LEVC(ILEV)=0
	LEVN(ILEV)=0
	LEVL(ILEV)=0
	LEVJ(ILEV)=0
	ELEV(ILEV)=0.D0
	ZLEV(ILEV)=0.D0
	ENDDO
C **************************************
C READING CONTROLS
      CALL READ_SECT(RATDATA(1),NLEN,ISEC,NSEC,MSEC,
     &'<section=conf',13,'<section=',9,'ok',2)
C Set section title
      DO IPOS=1,150
      IF(RATDATA(ISEC)(IPOS:IPOS).EQ.'>')EXIT
      ENDDO
      DO JPOS=IPOS+1,150
      IF(MSEC.NE.0)RATDATA(ISEC)(JPOS:JPOS)=' '
      ENDDO
      IF(IPOS.LE.50)THEN
      HELP='! CONFIGURATION                        '
      IF(MSEC.NE.0)RATDATA(ISEC)(IPOS+1:IPOS+40)=HELP
      ENDIF
C Allocate temporary file
      ALLOCATE(RATCOPY(NSEC))
      DO ILIN=1,MSEC
      RATCOPY(ILIN)=RATDATA(ILIN+ISEC-1)
      ENDDO
C **************************************
C READING THE DATA: SELECT CONF SETTINGS
C Read level information
	ILEV=0
	DO ILIN=3,MSEC
	DO IPOS=1,9
	RATCOPY(ILIN)(IPOS:IPOS)=' '
	ENDDO
	DO IPOS=1,150
	IF(RATCOPY(ILIN)(IPOS:IPOS).EQ.'/')
     &   RATCOPY(ILIN)(IPOS:IPOS)=' '
      ENDDO
	READ(RATCOPY(ILIN),*,ERR=10,END=10)
     &  NQ,LQ,J1Q,J2Q,NE,ENER
	ILEV=ILEV+1
	LNUM(ILEV)=100*NQ+10*LQ+J1Q
	ZLEV(ILEV)=DBLE(NE)  ! # of electrons
	ELEV(ILEV)=ENER      ! energies
	LEVC(ILEV)=1         ! initialize core levels
	LEVN(ILEV)=NQ        ! main quantum number
	LEVL(ILEV)=LQ        ! orbital quantum number
	LEVJ(ILEV)=J1Q       ! total moment
	ENDDO
  10	NLEVT=ILEV
C END PROCESSING CONFIGURATION DATA
C **************************************
      DEALLOCATE(RATCOPY)
C Evaluate electronic charge
	ERAT=0.D0
	DO ILEV=1,NLEVT
	ERAT=ERAT+ZLEV(ILEV)
	ENDDO
	END SUBROUTINE RAT_READRAT_CONF


	SUBROUTINE RAT_READRAT_SLAT(RATDATA,NLEN)
*******************************************************************
* Reads atomic configuration from atomic data files.              *
*******************************************************************
C SET ARRAY SIZE DATA
	USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
	USE COM_RATLEV  ,ONLY : NLEVT,LEVL,SLEV,GLEV
	USE COM_UNIT    ,ONLY : IUN,IUT,IUR                    !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER*150, ALLOCATABLE :: RATCOPY(:)
      CHARACTER*150, RATDATA(NLEN)
      CHARACTER TEXT*64,TCTRL*10,STRING*150,HELP*40,SNOT*20
      LOGICAL DEF,ASK,VAL,NTH,MDF,CASE,EXIST
      DATA PI/3.141592653589793D0/
C ******************************************
C MEMORY ALLOCATIONS FOR MAIN CONTROL ARRAYS
	ALLOCATE(GLEV(36))
	ALLOCATE(SLEV(0:3,36))
	DO ILEV=1,36
	GLEV(ILEV)=0.D0
	DO L=0,3
	SLEV(L,ILEV)=0.D0
	ENDDO
	ENDDO
C **************************************
C READING CONTROLS
      CALL READ_SECT(RATDATA(1),NLEN,ISEC,NSEC,MSEC,
     &'<section=slat',13,'<section=',9,'ok',2)
C Set section title
      DO IPOS=1,150
      IF(RATDATA(ISEC)(IPOS:IPOS).EQ.'>')EXIT
      ENDDO
      DO JPOS=IPOS+1,150
      IF(MSEC.NE.0)RATDATA(ISEC)(JPOS:JPOS)=' '
      ENDDO
      IF(IPOS.LE.50)THEN
      HELP='! SLATER INTEGRALS                     '
      IF(MSEC.NE.0)RATDATA(ISEC)(IPOS+1:IPOS+40)=HELP
      ENDIF
C Allocate temporary file
      ALLOCATE(RATCOPY(NSEC))
      DO ILIN=1,MSEC
      RATCOPY(ILIN)=RATDATA(ILIN+ISEC-1)
      ENDDO
C **************************************
C READING THE DATA: SELECT CONF SETTINGS
C Read level information
	ILEV=0
	DO ILIN=3,MSEC
	DO IPOS=1,9
	RATCOPY(ILIN)(IPOS:IPOS)=' '
	ENDDO
	DO IPOS=1,150
	IF(RATCOPY(ILIN)(IPOS:IPOS).EQ.'/')
     &   RATCOPY(ILIN)(IPOS:IPOS)=' '
      ENDDO
	ILEV=ILEV+1
	LQ=LEVL(ILEV)
	READ(RATCOPY(ILIN),*,ERR=10,END=10)
     &  (SLEV(L2/2,ILEV),L2=0,2*LQ,2)
	ENDDO
  10	CONTINUE
C END PROCESSING CONFIGURATION DATA
C **************************************
      DEALLOCATE(RATCOPY)
	END SUBROUTINE RAT_READRAT_SLAT



	SUBROUTINE RAT_READRAT_RDEN(RATDATA,NLEN)
*******************************************************************
* Reads atomic configuration from atomic data files.              *
*******************************************************************
C SET ARRAY SIZE DATA
	USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_RATSCF  ,ONLY : ZRAT,TRAT,ERAT,RATRHO,RATPOT
      USE COM_RATMESH ,ONLY : NRAT,HRAT,RRAT,DRAT,WRAT        !!! from makerat
     &                       ,NLIB,HLIB,RLIB,DLIB            !!! from libmesh
	USE COM_LABELS  ,ONLY : ELEMENT,NAMEDENS                !!! from setup
	USE COM_CHANNELS,ONLY : IUINP                           !!! from setup
	USE COM_UNIT    ,ONLY : IUN,IUT,IUR                     !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8, ALLOCATABLE :: RAT0(:)
	REAL*8, ALLOCATABLE :: DEN0(:)
	REAL*8, ALLOCATABLE :: WORK1(:)
	REAL*8, ALLOCATABLE :: WORK2(:)
	REAL*8, ALLOCATABLE :: DENLIB(:)
	REAL*8, ALLOCATABLE :: DERINP(:,:)
	REAL*8, ALLOCATABLE :: DEROUT(:,:)
      CHARACTER*150, ALLOCATABLE :: RATCOPY(:)
      CHARACTER*150, RATDATA(NLEN)
      CHARACTER TEXT*64,TCTRL*10,STRING*150,HELP*40,SNOT*20,FILE*130
      LOGICAL DEF,ASK,VAL,NTH,MDF,CASE,EXIST
      DATA PI/3.141592653589793D0/
C ******************************************
C Calculate radial grid
	CALL RAT_MAKERAT
C MEMORY ALLOCATIONS FOR MAIN CONTROL ARRAYS
	ALLOCATE(RATRHO(0:NRAT))
	ALLOCATE(RATPOT(0:NRAT))
	DO IRAT=0,NRAT
	RATPOT(IRAT)=0.D0
	RATRHO(IRAT)=0.D0
	ENDDO
C READING CONTROLS
      CALL READ_SECT(RATDATA(1),NLEN,ISEC,NSEC,MSEC,
     &'<section=rden',13,'<section=',9,'ok',2)
C Set section title
      DO IPOS=1,150
      IF(RATDATA(ISEC)(IPOS:IPOS).EQ.'>')EXIT
      ENDDO
      DO JPOS=IPOS+1,150
      IF(MSEC.NE.0)RATDATA(ISEC)(JPOS:JPOS)=' '
      ENDDO
      IF(IPOS.LE.50)THEN
      HELP='! DENSITY                              '
      IF(MSEC.NE.0)RATDATA(ISEC)(IPOS+1:IPOS+40)=HELP
      ENDIF
C Allocate temporary file
      ALLOCATE(RATCOPY(NSEC))
      DO ILIN=1,MSEC
      RATCOPY(ILIN)=RATDATA(ILIN+ISEC-1)
      ENDDO
C **************************************
C READING THE DATA: SELECT DENSITY
	IF(MSEC.GT.0)THEN
	READ(RATCOPY(2),*)NRAT0
	ALLOCATE(RAT0(0:NRAT0))
	ALLOCATE(DEN0(0:NRAT0))
	ALLOCATE(DERINP(0:NRAT0,2))
	ALLOCATE(DEROUT(0:NRAT,2))
	ILIN=2
	DO IRAT0=0,NRAT0
	ILIN=ILIN+1
	READ(RATCOPY(ILIN),*)RAT0(IRAT0),DEN0(IRAT0)
	ENDDO
C SPLINE IT TO THE NEW GRID
      DO IRAT=0,NRAT
      IF(RRAT(IRAT)-RAT0(NRAT0).GT.1.D-09)EXIT
	ENDDO
      NR=IRAT-1
      CALL LIB_SPLIN3(RAT0(0),DEN0,DERINP,NRAT0+1,
     &NRAT0+1,RRAT(0),RATRHO,DEROUT,NR+1,NRAT+1,-1)
      DO IRAT=0,NR
      RATRHO(IRAT)=RATRHO(IRAT)
	ENDDO
      DO IRAT=NR+1,NRAT
      RATRHO(IRAT)=RATRHO(NR)
	ENDDO
      DEALLOCATE(RAT0,DEN0,DERINP,DEROUT)
C READ DENSITY FROM THE DATABASE
	ELSE
	ALLOCATE(WORK1(0:NLIB))
	ALLOCATE(WORK2(0:NLIB))
	ALLOCATE(DENLIB(0:NLIB))
	ALLOCATE(DERINP(0:NLIB,2))
	ALLOCATE(DEROUT(0:NRAT,2))
      NUCZ=NINT(ZRAT)
      CALL FIND_LBLANK(NAMEDENS,130,NBL)
      FILE=NAMEDENS(1:NBL)//ELEMENT(NUCZ)
      INQUIRE(FILE=FILE,EXIST=EXIST)
      IF(.NOT.EXIST)CALL FULLSTOP('Density database not found')
      OPEN(UNIT=IUINP,FILE=FILE,STATUS='OLD',FORM='FORMATTED')
      READ(IUINP,*)
      READ(IUINP,*)JC,JM,NLIBC
      IF(NLIBC.NE.NLIB)CALL FULLSTOP('Nlibc.ne.Nlib')
      READ(IUINP,*)(DENLIB(IRAD),IRAD=1,NLIB)
      CLOSE(IUINP)
C INTERPOLATE TO THE NUCLEUS
      DENLIB(0)=DENLIB(1)
C CHECK CHARGE
      DO IRAD=0,NLIB
      WORK1(IRAD)=DENLIB(IRAD)*4.D0*PI*RLIB(IRAD)**2*
     &DLIB(IRAD)
      ENDDO
      CALL LIB_QD(HLIB,WORK1,WORK2,NLIB)
      CHARGE=WORK2(NLIB-1)
C PRINT CHARGE
      CALL FIND_LBLANK(FILE,130,NBL)
      WRITE(IUN,10100)ZRAT,CHARGE,TRAT,FILE(1:NBL)
10100  FORMAT(1X,'Charge checking: ',G12.5,1X,G12.5,1X,A10,';',A)
C SPLINE IT TO THE NEW GRID
      DO IRAT=0,NRAT
      IF(RRAT(IRAT)-RLIB(NLIB).GT.1.D-09)EXIT
	ENDDO
      NR=IRAT-1
      CALL LIB_SPLIN3(RLIB(0),DENLIB,DERINP,NLIB+1,
     &NLIB+1,RRAT(0),RATRHO,DEROUT,NR+1,NRAT+1,-1)
      DO IRAT=0,NR
      RATRHO(IRAT)=RATRHO(IRAT)
	ENDDO
      DO IRAT=NR+1,NRAT
      RATRHO(IRAT)=RATRHO(NR)
	ENDDO
      DEALLOCATE(DENLIB,DERINP,DEROUT,WORK1,WORK2)
	ENDIF
C END PROCESSING DENSITY DATA
C **************************************
      DEALLOCATE(RATCOPY)
	END SUBROUTINE RAT_READRAT_RDEN



	SUBROUTINE RAT_WRITERAT(KW)
*******************************************************
*  Updates RATFILE.                                   * 
*******************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_RATPAR  ,ONLY : LCRT
      USE COM_RATSCF  ,ONLY : ZRAT,TRAT,RATRHO,RATPOT
      USE COM_RATMESH ,ONLY : NRAT,RRAT                       !!! from makerat
      USE COM_RATHYB  ,ONLY : NBST                            !!! from readrat
	USE COM_RATLEV  ,ONLY : NLEVT,LNUM,ELEV,ZLEV
     &                       ,LEVN,LEVL,LEVJ,LEVC,SLEV
      USE COM_RATOUT  ,ONLY : ICRAT,RATFILE,ICRSC,RSCFILE     !!! from readrat
      USE COM_CHANNELS,ONLY : IUINP                           !!! from setup
      USE COM_UNIT    ,ONLY : IUN,IUR,IUT                     !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER*150, ALLOCATABLE :: RATDATA(:)
      CHARACTER*150, ALLOCATABLE :: RATCOPY(:)
      LOGICAL EXIST,DEF,ASK,VAL,NTH,MDF
      CHARACTER STRING*150,FILE*130,HELP*40,TCTRL*10
     &   ,TLEV(8,0:4,8)*19,THED*19
      DATA PI/3.141592653589793D0/
C RETURN KEYS
	IF(ICRAT.EQ.0.AND.KW.EQ.1)RETURN
	IF(ICRSC.EQ.0.AND.KW.EQ.2)RETURN
C ********************************
C UNDERSTAND THE LENGHT OF HUBFILE
      CALL FILE_LENGHT(RATFILE,NLEN,IUINP)
      ALLOCATE(RATDATA(NLEN))
C ********************************
C READ RATFILE TO INTERNAL FILE
      OPEN(UNIT=IUINP,FILE=RATFILE,STATUS='OLD',FORM='FORMATTED')
      DO ILEN=1,NLEN
      READ(IUINP,FMT='(A150)')RATDATA(ILEN)
      ENDDO
      CLOSE(IUINP)
C OPEN BLANK FILE
	IF(KW.EQ.1)FILE=RATFILE
	IF(KW.EQ.2)FILE=RSCFILE
      INQUIRE(FILE=FILE,EXIST=EXIST)
      IF(EXIST)THEN
      OPEN(UNIT=IUINP,FILE=FILE,STATUS='OLD',FORM='FORMATTED')
	CLOSE(UNIT=IUINP,STATUS='DELETE')
	ENDIF
      OPEN(UNIT=IUINP,FILE=FILE,STATUS='NEW',FORM='FORMATTED')
C START STORAGE
	WRITE(IUINP,10100)
	WRITE(IUINP,10110)
10100	FORMAT(1X,'<FILE=RATFILE,INPUT=MODERN,TRACE=TRUE>')
10110 FORMAT('****************************************************')
10120	FORMAT(150(A1))
C PRINT CONTROL PARAMETERS
      CALL READ_SECT(RATDATA(1),NLEN,ISEC,NSEC,MSEC,
     &'<section=ctrl',13,'<section=',9,'ok',2)
	ALLOCATE(RATCOPY(NSEC))
	DO ILIN=1,MSEC
	RATCOPY(ILIN)=RATDATA(ILIN+ISEC-1)
	ENDDO
      DO ILIN=1,MSEC
	STRING=RATDATA(ILIN+ISEC-1)
	CALL FIND_LBLANK(STRING,150,NBL)
      WRITE(IUINP,10120)(STRING(I:I),I=1,NBL)
      ENDDO
	DEALLOCATE(RATCOPY)
C PRINT DMFT DATA
      CALL READ_SECT(RATDATA(1),NLEN,ISEC,NSEC,MSEC,
     &'<section=dmft',13,'<section=',9,'ok',2)
	ALLOCATE(RATCOPY(NSEC))
	DO ILIN=1,MSEC
	RATCOPY(ILIN)=RATDATA(ILIN+ISEC-1)
	ENDDO
      DO ILIN=1,MSEC
	STRING=RATDATA(ILIN+ISEC-1)
	CALL FIND_LBLANK(STRING,150,NBL)
      WRITE(IUINP,10120)(STRING(I:I),I=1,NBL)
      ENDDO
	DEALLOCATE(RATCOPY)
C PRINT RSCF DATA
      CALL READ_SECT(RATDATA(1),NLEN,ISEC,NSEC,MSEC,
     &'<section=rscf',13,'<section=',9,'ok',2)
	ALLOCATE(RATCOPY(NSEC))
	DO ILIN=1,MSEC
	RATCOPY(ILIN)=RATDATA(ILIN+ISEC-1)
	ENDDO
      DO ILIN=1,MSEC
	STRING=RATDATA(ILIN+ISEC-1)
	CALL FIND_LBLANK(STRING,150,NBL)
      WRITE(IUINP,10120)(STRING(I:I),I=1,NBL)
      ENDDO
	DEALLOCATE(RATCOPY)
C PRINT SHEL DATA
      CALL READ_SECT(RATDATA(1),NLEN,ISEC,NSEC,MSEC,
     &'<section=shel',13,'<section=',9,'ok',2)
	ALLOCATE(RATCOPY(NSEC))
	DO ILIN=1,MSEC
	RATCOPY(ILIN)=RATDATA(ILIN+ISEC-1)
	ENDDO
      DO ILIN=1,MSEC
	STRING=RATDATA(ILIN+ISEC-1)
	CALL FIND_LBLANK(STRING,150,NBL)
      WRITE(IUINP,10120)(STRING(I:I),I=1,NBL)
      ENDDO
	DEALLOCATE(RATCOPY)
C PRINT CLUSTER DATA
      CALL READ_SECT(RATDATA(1),NLEN,ISEC,NSEC,MSEC,
     &'<section=clus',13,'<section=',9,'ok',2)
	ALLOCATE(RATCOPY(NSEC))
	DO ILIN=1,MSEC
	RATCOPY(ILIN)=RATDATA(ILIN+ISEC-1)
	ENDDO
      DO ILIN=1,MSEC
	STRING=RATDATA(ILIN+ISEC-1)
	CALL FIND_LBLANK(STRING,150,NBL)
      WRITE(IUINP,10120)(STRING(I:I),I=1,NBL)
      ENDDO
	DEALLOCATE(RATCOPY)
C PRINT BATH LEVELS
	ILOC=1
	DO IBST=1,NBST
      CALL READ_SECT(RATDATA(ILOC),NLEN-ILOC+1,KSEC,NSEC,MSEC,
     &'<section=blev',13,'<section=',9,'ok',2)
	ISEC=KSEC+ILOC-1
	ILOC=ISEC+1
C Allocate temporary file
      ALLOCATE(RATCOPY(NSEC))
      DO ILIN=1,MSEC
      RATCOPY(ILIN)=RATDATA(ILIN+ISEC-1)
      ENDDO
	DEALLOCATE(RATCOPY)
	ENDDO                                  !!! over bath states
C PRINT CONF DATA
	CALL LIB_TLEVCHAR(TLEV,THED) 
	WRITE(IUINP,10200)
10200 FORMAT(1X,'<Section=CONF>',14X,'! CONFIGURATION:')
	WRITE(IUINP,10210)THED,TRAT
	DO ILEV=1,NLEVT
	NQ=LEVN(ILEV)
	LQ=LEVL(ILEV)
	JQ=LEVJ(ILEV)
      WRITE(IUINP,10220)TLEV(NQ,LQ,JQ),INT(ZLEV(ILEV)),
     &ELEV(ILEV)
	ENDDO
10210 FORMAT('!',A19,'  # el.  Levels(Ry) ',A10)
10220 FORMAT(1X,A19,3X,I2,3X,G14.7)
C PRINT SLAT DATA
	WRITE(IUINP,10300)
10300 FORMAT(1X,'<Section=SLAT>',14X,'! SLATER INTEGRALS:')
	WRITE(IUINP,10310)THED
	DO ILEV=1,NLEVT
	NQ=LEVN(ILEV)
	LQ=LEVL(ILEV)
	JQ=LEVJ(ILEV)
      WRITE(IUINP,10320)TLEV(NQ,LQ,JQ),
     &(SLEV(L2/2,ILEV),L2=0,2*LQ,2)
	ENDDO
10310 FORMAT('!',A19,3X,
     & '  F0(Ry)       F2(Ry)       F4(Ry)       F6(Ry)')
10320 FORMAT(1X,A19,3X,G12.5,1X,G12.5,1X,G12.5,1X,G12.5)
C PRINT RDEN DATA
	WRITE(IUINP,10400)
10400 FORMAT(1X,'<Section=RDEN>',14X,'! DENSITY:')
	WRITE(IUINP,10410)NRAT
	DO IRAT=0,NRAT
      WRITE(IUINP,10420)RRAT(IRAT),RATRHO(IRAT)
	ENDDO
10410 FORMAT(1X,I5,1X,'! # of grid points')
10420 FORMAT(1X,G14.7,1X,G14.7)
C Done
	CLOSE(IUINP)
C REFORMAT FILE
	DEALLOCATE(RATDATA)
      CALL FILE_LENGHT(FILE,NLEN,IUINP)
      ALLOCATE(RATDATA(NLEN))
      OPEN(UNIT=IUINP,FILE=FILE,STATUS='OLD',FORM='FORMATTED')
      DO ILEN=1,NLEN
      READ(IUINP,FMT='(A150)')RATDATA(ILEN)
      ENDDO
      CLOSE(IUINP)
      CALL READ_OVWR(FILE,RATDATA,NLEN)
C MEMORY DEALLOCATIONS
	DEALLOCATE(RATDATA)
	END
