	SUBROUTINE RAT_SETADS
***************************************************************
*  Finds atomic density of many body states                   *
***************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_RATSCF  ,ONLY: TRAT,SRAT                               !!! from readrat
      USE COM_IMPGRF  ,ONLY: CHEM                                    !!! from shells
      USE COM_LSHELL  ,ONLY: NORB,LORB,DAMP,LOCCIMP,SPECIMP,XHUBIMP  !!! from shells
	USE COM_MSBMESH ,ONLY: TEMP                                    !!! from readrat
	USE COM_FREQU   ,ONLY: NENRADS,ENRADS                          !!! from getagf
      USE COM_FERMI   ,ONLY: EF                                      !!! from readrat
	USE COM_CHANNELS,ONLY: IUAIN                                   !!! from channels
      USE COM_RATOUT  ,ONLY: ICADS,ADSFILE                           !!! from storage
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                         !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8, ALLOCATABLE :: COMB(:,:)
	COMPLEX*16 DIM,DENOM
	CHARACTER HELP*40
	LOGICAL EXIST
	DATA PI/3.141592653589793D0/,DIM/(0.D0,1.D0)/
C STORE HEADER INFO
	IF(ICADS.EQ.0)RETURN
C Get combnatorics
	NDEG=2*(2*LORB+1)
	NDIM=2**NDEG
	ALLOCATE(COMB(0:NDEG,0:NDEG))
	CALL LIB_GETCOMB(COMB,NDEG)
C Compute minimum/maximum eigenvalues
	MDIM=0
	DO IOCC=0,NDEG
	IF(LOCCIMP(IOCC).EQ.0)CYCLE
	NFOC=NINT(COMB(IOCC,NDEG))
	MDIM=MDIM+NFOC
	EMIN=SPECIMP(1+MDIM-NFOC)-CHEM*DBLE(IOCC)
	EMAX=SPECIMP(1+MDIM-NFOC)-CHEM*DBLE(IOCC)
	EXIT
	ENDDO
	MDIM=0
	DO IOCC=0,NDEG
	IF(LOCCIMP(IOCC).EQ.0)CYCLE
	NFOC=NINT(COMB(IOCC,NDEG))
	MDIM=MDIM+NFOC
	DO IFOC=1,NFOC
	DE=SPECIMP(IFOC+MDIM-NFOC)-CHEM*DBLE(IOCC)
	EMIN=MIN(EMIN,DE)
	EMAX=MAX(EMAX,DE)
	ENDDO
	ENDDO
	EMIN=EMIN-(EMAX-EMIN)/20.D0
	EMAX=EMAX+(EMAX-EMIN)/20.D0
C RESET ENERGIES
	IF(ABS(ENRADS(NENRADS)-ENRADS(0)).LE.1.D-10)THEN
	IF(ALLOCATED(ENRADS))DEALLOCATE(ENRADS)
	ALLOCATE(ENRADS(0:NENRADS))
	ESTEP=(EMAX-EMIN)/DBLE(NENRADS)
	DO IENR=0,NENRADS
	ENRADS(IENR)=EMIN+DBLE(IENR)*ESTEP
	ENDDO
	ENDIF
C GET FILE DATA
	INQUIRE(FILE=ADSFILE,EXIST=EXIST)
	IF(EXIST)THEN
      OPEN(UNIT=IUAIN,FILE=ADSFILE,STATUS='OLD',FORM='FORMATTED')
	CLOSE(UNIT=IUAIN,STATUS='DELETE')
	ENDIF
	OPEN(UNIT=IUAIN,FILE=ADSFILE,STATUS='NEW',FORM='FORMATTED')
	WRITE(IUAIN,10010)
	WRITE(IUAIN,10020)
10010	FORMAT(1X,'<FILE=ADSFILE,INPUT=MODERN>')
10020 FORMAT('****************************************************')
	WRITE(IUAIN,10030)
10030 FORMAT(1X,'<SECTION=CTRL>               ! CONTROL PARAMETERS:')
      HELP='! Energy grid                          '
	WRITE(IUAIN,10040)NENRADS,HELP
10040 FORMAT(1X,'nEnrADS=',I5,16X,A40)
      HELP='! Min.Energy (Ry)                      '
	WRITE(IUAIN,10050)ENRADS(0),HELP
10050 FORMAT(1X,'EminADS=',G14.7,7X,A40)
      HELP='! Max.Energy (Ry)                      '
	WRITE(IUAIN,10060)ENRADS(NENRADS),HELP
10060 FORMAT(1X,'EmaxADS=',G14.7,7X,A40)
C STORE DOS DATA
	WRITE(IUAIN,10110)
10110 FORMAT(1X,'<SECTION=DATA>               ! DOS DATA:')
	WRITE(IUAIN,10220)
10220 FORMAT('!    Nel            Omega               DOS')
C Compute density of many-body states
	MDIM=0
	DO IOCC=0,NDEG
	IF(LOCCIMP(IOCC).EQ.0)CYCLE
	NFOC=NINT(COMB(IOCC,NDEG))
	MDIM=MDIM+NFOC
	WRITE(IUAIN,10230)DBLE(IOCC),ENRADS(0),0.D0
	DO IOMG=0,NENRADS
	DOS=0.D0
	DO IFOC=1,NFOC
	DENRE=ENRADS(IOMG)-(SPECIMP(IFOC+MDIM-NFOC)-CHEM*DBLE(IOCC))
	DENOM=DCMPLX(DENRE,DAMP)
	DOS=DOS-DIMAG(1.D0/DENOM)/PI
	ENDDO
	WRITE(IUAIN,10230)DBLE(IOCC),ENRADS(IOMG),DOS
10230 FORMAT(1X,G14.7,1X,G14.7,3X,G14.7)
	ENDDO
	WRITE(IUAIN,10230)DBLE(IOCC),ENRADS(NENRADS),0.D0
	WRITE(IUAIN,10230)DBLE(IOCC),ENRADS(0),0.D0
	ENDDO
C Memory deallocations
	DEALLOCATE(COMB)
	END