	SUBROUTINE RAT_SHELLS
************************************************************
*  THE MAIN MODULE CONTROLLING ATOMIC SPECTRA CALCULATIONS *
************************************************************
      USE COM_LMTMEM                                                    !!! from setup
      USE COM_RATOUT  ,ONLY: ICSHL,ICGRF,ICADS
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                            !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER ST*8,FN*8,PROGN*8
      DATA ST/'started'/,FN/'finished'/
C MANY BODY CALCULATIONS OF ATOMIC SPECTRA
	progn='ShlDiag'
	call lib_timel(times)
	write(iun,10100)progn,st,times,curmem,totmem
      CALL RAT_SHLDIAG
      call lib_timel(timef)
	write(iun,10100)progn,fn,timef,curmem,totmem
	progn='ShlChem'
	call lib_timel(times)
	write(iun,10100)progn,st,times,curmem,totmem
      CALL RAT_SHLCHEM
      call lib_timel(timef)
	write(iun,10100)progn,fn,timef,curmem,totmem
C Compute atomic Green function
	progn='AgfMat'
	call lib_timel(times)
	write(iun,10100)progn,st,times,curmem,totmem
	CALL RAT_AGFMAT
      call lib_timel(timef)
	write(iun,10100)progn,fn,timef,curmem,totmem
C Compute Atomic self-energy
	progn='SigGrf'
	call lib_timel(times)
	write(iun,10100)progn,st,times,curmem,totmem
	CALL RAT_SIGGRF
      call lib_timel(timef)
	write(iun,10100)progn,fn,timef,curmem,totmem
C Compute Total Energy
	progn='ShlEtot'
	call lib_timel(times)
	write(iun,10100)progn,st,times,curmem,totmem
      CALL RAT_SHLETOT
      call lib_timel(timef)
	write(iun,10100)progn,fn,timef,curmem,totmem
C Compute Many body density of states
	progn='SetAds'
	call lib_timel(times)
	write(iun,10100)progn,st,times,curmem,totmem
	CALL RAT_SETADS
      call lib_timel(timef)
	write(iun,10100)progn,fn,timef,curmem,totmem
10100 FORMAT('***** ',A8,1X,A8,'; CPU : ',G12.5,
     &       '; CUR/MAX mem.(Mb): ',G10.3,'/',G10.3)
      END








	SUBROUTINE RAT_SHLDIAG
***************************************************************
*  Diagonalize atom
***************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
 	USE COM_RATOUT  ,ONLY: ICSHL                                   !!! from readrat
	USE COM_MSBMESH ,ONLY: TEMP,NMSC,WMSC                          !!! from readrat
      USE COM_RATPAR  ,ONLY: EPSDEG,KORB                             !!! from readrat
      USE COM_IMPGRF  ,ONLY: CHEM,FILL,KFRM                          !!! from readrat
      USE COM_LSHELL  ,ONLY: LORB,LOCCIMP,HMAG,HORB,ALSC,ISTATE, 
     &                       ELEV,FSLA,XHUBIMP,SPECIMP,TLSJIMP       !!! from readrat
      USE COM_RATOUT  ,ONLY: SHLFILE                                 !!! from channels
      USE COM_LMTOUT  ,ONLY: SCRFILE                                 !!! from setup
      USE COM_RATCHN  ,ONLY: IUSHL                                   !!! from channels
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                         !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8, ALLOCATABLE :: COMB(:,:)
	REAL*8, ALLOCATABLE :: EATS(:)
	REAL*8, ALLOCATABLE :: FSLT(:)
	COMPLEX*16, ALLOCATABLE :: AVEC(:,:)
	CHARACTER*5, ALLOCATABLE :: TATS(:,:)
	COMPLEX*16 DIM,DENOM
	REAL*8 LIB_ROUNDVAL
	DATA PI/3.141592653589793D0/,DIM/(0.D0,1.D0)/
C *************************************
C Set mode
	IMOD=ICSHL
	NDEG=2*(2*LORB+1)
	NDIM=2**NDEG
C Get combnatorics
	ALLOCATE(COMB(0:NDEG,0:NDEG))
	CALL LIB_GETCOMB(COMB,NDEG)
C CREATE FULL FOCK SPACE OF DIMENSION 2**nDeg
	DO MS=1,NDEG
	ISTATE(MS,0)=0
	ENDDO
C Represent IVEC using binary system
	DO IVEC=1,NDIM-1
	ITWO=1
	IMAX=0
	DO WHILE(IVEC.GE.ITWO)
	ITWO=ITWO*2
	IMAX=IMAX+1
	ENDDO
	ISTATE(IMAX,IVEC)=1
	DO MS=IMAX+1,NDEG
	ISTATE(MS,IVEC)=0
	ENDDO
	INUM=IVEC
	DO I=IMAX-1,1,-1
	ITWO=ITWO/2
	INUM=INUM-ITWO*ISTATE(I+1,IVEC)
	ISTATE(I,IVEC)=INUM/(ITWO/2)
	ENDDO
	ENDDO
C Check algorithm
	DO IFIL=0,NDEG
	ICHK=NINT(COMB(IFIL,NDEG))
	IFOC=0
	DO IVEC=0,NDIM-1
	IOCC=0
	DO MS=1,NDEG
	IOCC=IOCC+ISTATE(MS,IVEC)
	ENDDO
	IF(IOCC.EQ.IFIL)IFOC=IFOC+1
	ENDDO
	IF(IFOC.NE.ICHK)CALL FULLSTOP('iFoc.ne.iChk')
	ENDDO
C SLATER INTEGRALS
	ALLOCATE(FSLT(0:3))
	FSLT(0)=0.D0
	FSLT(1)=0.D0
	FSLT(2)=0.D0
	FSLT(3)=0.D0
	IF(LORB.EQ.0)THEN
	FSLT(0)=FSLA(0) ! U
	ELSEIF(LORB.EQ.1)THEN
	FSLT(0)=FSLA(0) ! U
	FSLT(1)=FSLA(1) ! 5J
	ELSEIF(LORB.EQ.2)THEN
	FSLT(0)=FSLA(0) ! U
	FSLT(1)=FSLA(1) ! 8.615*J
	FSLT(2)=FSLA(2) ! 5.385*J
	ELSEIF(LORB.EQ.3)THEN
	FSLT(0)=FSLA(0) ! U
	FSLT(1)=FSLA(1) ! 5.385*J
	FSLT(2)=FSLA(2) ! 8.615*J
	FSLT(3)=FSLA(3) ! 3.385*J
	ENDIF
C Solve atomic problem for given degeneracy
	DO IDIM=1,NDIM
	SPECIMP(IDIM)=0.D0
	DO I=1,6
	TLSJIMP(I,IDIM)='     '
	ENDDO
	ENDDO
	MDIM=0
	DO IOCC=0,NDEG
	IF(LOCCIMP(IOCC).EQ.0)CYCLE
	NFOC=NINT(COMB(IOCC,NDEG))
	MDIM=MDIM+NFOC
	WRITE(IUN,10010)IOCC
10010	FORMAT(1X,' Current # of electrons  = ',I5)
	WRITE(IUN,10020)NFOC
10020	FORMAT(1X,' Dimension of Fock space = ',I5)
	ALLOCATE(EATS(NFOC))
	ALLOCATE(TATS(6,NFOC))
	ALLOCATE(AVEC(NFOC,NFOC))
C Read data
	IF(IMOD.EQ.2)
     &CALL RAT_SHLFILES_READ(LORB,NDEG,IOCC,NFOC,EATS,AVEC)
C DIAGONALIZE ATOMIC PROBLEM 
	IF(IMOD.EQ.0.OR.IMOD.EQ.1)
     &CALL RAT_MATATM_HEAD(LORB,NDEG,NFOC,IOCC,ISTATE,FSLT,ELEV,
     &                HMAG,HORB,ALSC,EATS,AVEC,TATS,EPSDEG,IMOD,KORB)
C Store file
      CALL RAT_SHLFILES_KEEP(LORB,NDEG,IOCC,NFOC,EATS,AVEC)
C Save Eigenvalues
	DO IFOC=1,NFOC
	SPECIMP(IFOC+MDIM-NFOC)=EATS(IFOC)
	DO I=1,6
	TLSJIMP(I,IFOC+MDIM-NFOC)=TATS(I,IFOC)
	ENDDO
	ENDDO
C MEMORY DEALLOCATIONS
	DEALLOCATE(EATS,AVEC,TATS)
	ENDDO
C Atomic diagonalization is done
C MEMORY DEALLOCATIONS
	DEALLOCATE(COMB,FSLT)
	END



	SUBROUTINE RAT_SHLCHEM
***********************************************************
*  Compute chemical potential for atomic shell
***********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_IMPGRF  ,ONLY: CHEM,FILL,KFRM                          !!! from readrat
 	USE COM_RATOUT  ,ONLY: ICSHL                                   !!! from readrat
	USE COM_MSBMESH ,ONLY: TEMP,NMSC,WMSC                          !!! from readrat
      USE COM_LSHELL  ,ONLY: LORB,LOCCIMP,XHUBIMP,SPECIMP            !!! from readrat
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                         !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8, ALLOCATABLE :: COMB(:,:)
	COMPLEX*16 DIM
	REAL*8 LIB_ROUNDVAL
	DATA PI/3.141592653589793D0/,DIM/(0.D0,1.D0)/
	NDEG=2*(2*LORB+1)
	NDIM=2**NDEG
C Get combnatorics
	ALLOCATE(COMB(0:NDEG,0:NDEG))
	CALL LIB_GETCOMB(COMB,NDEG)
C Compute chemical potential corresponding to mean filling
	WRITE(IUN,10110)
10110 FORMAT(1X,'Start search the chemical potential -->')
	WRITE(IUN,10120)
10120 FORMAT(1X,'   Energy     # of Electrons')
	EFRM=CHEM
C First try this Fermi level
	CALL RAT_SHELLS_XNOT(NDEG,NDIM,COMB,LOCCIMP,SPECIMP,EFRM,
     &     TEMP,XHUBIMP)
	STAT=0.D0
	ZSUM=0.D0
	MDIM=0
	DO IOCC=0,NDEG
	IF(LOCCIMP(IOCC).EQ.0)CYCLE
	NFOC=NINT(COMB(IOCC,NDEG))
	MDIM=MDIM+NFOC
	SUM=0.D0
	DO IFOC=1,NFOC
	SUM=SUM+XHUBIMP(IFOC+MDIM-NFOC)
	ENDDO
	STAT=STAT+SUM
	ZSUM=ZSUM+SUM*DBLE(IOCC)
	ENDDO
	IF(ABS(STAT-1.D0).GT.1.D-07)
     &CALL FULLSTOP('Wrong renormalization')
	ZSUM=ZSUM/STAT
	WRITE(IUN,10130)EFRM,ZSUM
	ZDIF=FILL-ZSUM
      IF(ABS(ZDIF).LE.1.D-05.OR.KFRM.GT.0)GOTO 200
C If KFRM search is needed
	ZDIF=0.D0
	JTER=0
	EMIN=+1.D+10
	EMAX=-1.D+10
	MDIM=0
	DO IOCC=0,NDEG
	IF(LOCCIMP(IOCC).EQ.0)CYCLE
	NFOC=NINT(COMB(IOCC,NDEG))
	MDIM=MDIM+NFOC
	DO IFOC=1,NFOC
	EMIN=MIN(EMIN,SPECIMP(IFOC+MDIM-NFOC))
	EMAX=MAX(EMAX,SPECIMP(IFOC+MDIM-NFOC))
	ENDDO
	ENDDO
	E1=-0.5D0*(EMAX-EMIN)
	E2=+0.5D0*(EMAX-EMIN)
	IF(KFRM.EQ.0)
     &CALL LIB_FINDROOT(EFRM,ZDIF,E1,E2,JTER,IEXIT,IUN,1.D-05,50)
 100	JTER=JTER+1
C Find new charge
	CALL RAT_SHELLS_XNOT(NDEG,NDIM,COMB,LOCCIMP,SPECIMP,EFRM,
     &     TEMP,XHUBIMP)
	STAT=0.D0
	ZSUM=0.D0
	MDIM=0
	DO IOCC=0,NDEG
	IF(LOCCIMP(IOCC).EQ.0)CYCLE
	NFOC=NINT(COMB(IOCC,NDEG))
	MDIM=MDIM+NFOC
	SUM=0.D0
	DO IFOC=1,NFOC
	SUM=SUM+XHUBIMP(IFOC+MDIM-NFOC)
	ENDDO
	STAT=STAT+SUM
	ZSUM=ZSUM+SUM*DBLE(IOCC)
	ENDDO
	IF(ABS(STAT-1.D0).GT.1.D-07)
     &CALL FULLSTOP('Wrong renormalization')
	ZSUM=ZSUM/STAT
C Difference
	ZDIF=FILL-ZSUM
	WRITE(IUN,10130)EFRM,ZSUM
10130 FORMAT(1X,G14.7,1X,G14.7)
	IF(KFRM.NE.0)GOTO 200
	CALL LIB_FINDROOT(EFRM,ZDIF,E1,E2,JTER,IEXIT,IUN,1.D-05,50)
	IF(IEXIT.EQ.1)GOTO 200
	GOTO 100
  200 CONTINUE
	CHEM=EFRM
C Compute probabilities
	CALL RAT_SHELLS_XNOT(NDEG,NDIM,COMB,LOCCIMP,SPECIMP,
     &     CHEM,TEMP,XHUBIMP)
	STAT=0.D0
	ZSUM=0.D0
	MDIM=0
	DO IOCC=0,NDEG
	IF(LOCCIMP(IOCC).EQ.0)CYCLE
	NFOC=NINT(COMB(IOCC,NDEG))
	MDIM=MDIM+NFOC
	SUM=0.D0
	DO IFOC=1,NFOC
	SUM=SUM+XHUBIMP(IFOC+MDIM-NFOC)
	ENDDO
	STAT=STAT+SUM
	ZSUM=ZSUM+SUM*DBLE(IOCC)
	ENDDO
	IF(ABS(STAT-1.D0).GT.1.D-07)
     &CALL FULLSTOP('Wrong renormalization')
	ZSUM=ZSUM/STAT
	FILL=ZSUM
	DEALLOCATE(COMB)
      END



	SUBROUTINE RAT_SHELLS_XNOT(NDEG,NDIM,COMB,LIMP,
     &           SPEC,CHEM,TEMP,XHUB)
*******************************************************
*  Finds correlational functions for an atom          *
*******************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER, ALLOCATABLE :: IATM(:)
	REAL*8, ALLOCATABLE :: EATM(:)
	REAL*8, ALLOCATABLE :: XATM(:)
	INTEGER LIMP(0:NDEG)
	REAL*8 XHUB(NDIM),SPEC(NDIM),COMB(0:NDEG,0:NDEG)
	DATA EPS/1.D-05/
	ALLOCATE(EATM(NDIM))
	ALLOCATE(XATM(NDIM))
	ALLOCATE(IATM(NDIM))
C Order atomic states in increasing order
	DO IDIM=1,NDIM
	EATM(IDIM)=0.D0
	XATM(IDIM)=0.D0
	XHUB(IDIM)=0.D0
	IATM(IDIM)=0
	ENDDO
	MDIM=0
	DO IOCC=0,NDEG
	IF(LIMP(IOCC).EQ.0)CYCLE
	NFOC=NINT(COMB(IOCC,NDEG))
	MDIM=MDIM+NFOC
	DO IFOC=1,NFOC
	IDIM=IFOC+MDIM-NFOC
	EATM(IDIM)=SPEC(IDIM)-CHEM*DBLE(IOCC)
	IATM(IDIM)=IDIM
	ENDDO
	ENDDO
C Sort atomic energies in increasing order
      DO ISTR=1,NDIM
	IF(IATM(ISTR).EQ.0)CYCLE
      DO JSTR=ISTR+1,NDIM
	IF(IATM(JSTR).EQ.0)CYCLE
	IF(EATM(ISTR).GT.EATM(JSTR))THEN
	S=EATM(ISTR)
	EATM(ISTR)=EATM(JSTR)
	EATM(JSTR)=S
	I=IATM(ISTR)
	IATM(ISTR)=IATM(JSTR)
	IATM(JSTR)=I
	ENDIF
	ENDDO
	ENDDO
C In this ordering scheme we can loop forward only
	IF(TEMP.GT.0.D0)THEN
      DO ISTR=1,NDIM-1
	IF(IATM(ISTR).EQ.0)CYCLE
      XATM(ISTR)=1.D0
	EXIT
	ENDDO
      DO ISTR=1,NDIM-1
	IF(IATM(ISTR+1).EQ.0.OR.IATM(ISTR).EQ.0)CYCLE
      E=EATM(ISTR+1)-EATM(ISTR)
      XATM(ISTR+1)=SAFEEXP(-E/TEMP)*XATM(ISTR)
      ENDDO
C If temperature is zero, only first states survive
	ELSEIF(TEMP.EQ.0.D0)THEN
      DO ISTR=1,NDIM-1
	IF(IATM(ISTR).EQ.0)CYCLE
      XATM(ISTR)=1.D0
	EXIT
	ENDDO
      DO ISTR=1,NDIM-1
	IF(IATM(ISTR+1).EQ.0.OR.IATM(ISTR).EQ.0)CYCLE
      E=EATM(ISTR+1)-EATM(ISTR)
      IF(ABS(E).LE.EPS)XATM(ISTR+1)=XATM(ISTR)
	IF(ABS(E).GT.EPS)XATM(ISTR+1)=0.D0
      ENDDO
	ENDIF
C Reorder
	DO ISTR=1,NDIM
	IF(IATM(ISTR).EQ.0)CYCLE
	JDIM=(IATM(ISTR)-1)/NDIM+1
	IDIM=IATM(ISTR)
	XHUB(IDIM)=XATM(ISTR)
	ENDDO
C Renormalize 
      XSUM=0.D0
      DO IDIM=1,NDIM
      XSUM=XSUM+XHUB(IDIM)
      ENDDO
      DO IDIM=1,NDIM
      XHUB(IDIM)=XHUB(IDIM)/XSUM
      ENDDO
C Check
	XSUM=0.D0
	DO IDIM=1,NDIM
	XSUM=XSUM+XHUB(IDIM)
	ENDDO
	IF(ABS(XSUM-1.D0).GT.1.D-10)
     &CALL FULLSTOP('<RAT_SHELLS_XNOT>:: Normalization error')
	DEALLOCATE(EATM,XATM,IATM)
	RETURN
	END
