	SUBROUTINE RAT_SHLETOT
***************************************************************
*  Computes total energy of the atom
***************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
 	USE COM_RATOUT  ,ONLY: ICSHL                                   !!! from readrat
	USE COM_MSBMESH ,ONLY: TEMP,NMSC,WMSC                          !!! from readrat
      USE COM_IMPGRF  ,ONLY: CHEM,FILL,KFRM                          !!! from readrat
      USE COM_LSHELL  ,ONLY: LORB,LOCCIMP,HMAG,HORB,ALSC,
     &                       ELEV,FSLA,XHUBIMP,SPECIMP               !!! from readrat
      USE COM_RATOUT  ,ONLY: ICGRF                                   !!! from storage
      USE COM_IMPGRF  ,ONLY: GMOM,DMAT                               !!! from getagf
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                         !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8, ALLOCATABLE :: COMB(:,:)
	REAL*8, ALLOCATABLE :: SLM(:,:,:)
	REAL*8, ALLOCATABLE :: UMAT(:,:,:,:)
	COMPLEX*16 DIM,DENOM
	DATA PI/3.141592653589793D0/,DIM/(0.D0,1.D0)/
      IF(ICGRF.EQ.0)RETURN
C *************************************
C Set mode
	L=LORB
	NDEG=2*(2*LORB+1)
C Get combinatorics
	ALLOCATE(COMB(0:NDEG,0:NDEG))
	CALL LIB_GETCOMB(COMB,NDEG)
C SET <Ylm|s*l|Ylm>/2 MATRIX ELEMENT
	ALLOCATE(SLM(-L:L,2,2))
	DO M=-L,L
	SLM(M,1,1)=0.5D0*DBLE(+M)
	SLM(M,1,2)=0.5D0*SQRT(DBLE((L+M)*(L-M+1)))
	SLM(M,2,1)=0.5D0*SQRT(DBLE((L-M)*(L+M+1)))
	SLM(M,2,2)=0.5D0*DBLE(-M)
	ENDDO
C Get interaction matrix
	ALLOCATE(UMAT(-L:L,-L:L,-L:L,-L:L))
	CALL LIB_HUBMAT_L4(L,FSLA,UMAT,UBAR,GBAR)
C GET ENERGIES
	ETOTN=0.D0
	ETOTM=0.D0
	ETOTP=0.D0
	DO IOCC=0,NDEG
	IF(LOCCIMP(IOCC).EQ.0)CYCLE
	IF(IOCC.NE.NINT(FILL))CYCLE
C N ELECTRONS	
	NOCCN=IOCC
	NFOCN=NINT(COMB(NOCCN,NDEG))    ! current dimension of Fock space
C Set shift
	MDIMN=0
	DO JOCC=0,NOCCN
	IF(LOCCIMP(JOCC).EQ.0)CYCLE
	MDIMN=MDIMN+NINT(COMB(JOCC,NDEG))
	ENDDO
C Set total energy for N electrons
      ETOTN=SPECIMP(1+MDIMN-NFOCN)-CHEM*DBLE(NOCCN)
C N-1 ELECTRONS
	NOCCM=NOCCN-1
	IF(IOCC.NE.0)THEN
	IF(LOCCIMP(NOCCM).NE.0)THEN
	NFOCM=NINT(COMB(NOCCM,NDEG))    ! current dimension of Fock space
C Set shift
	MDIMM=0
	DO JOCC=0,NOCCM
	IF(LOCCIMP(JOCC).EQ.0)CYCLE
	MDIMM=MDIMM+NINT(COMB(JOCC,NDEG))
	ENDDO
C Set total energy for N-1 electrons
      ETOTM=SPECIMP(1+MDIMM-NFOCM)-CHEM*DBLE(NOCCM)
      ENDIF
      ENDIF
C N+1 ELECTRONS
	NOCCP=NOCCN+1
	IF(IOCC.NE.NDEG)THEN
	IF(LOCCIMP(NOCCP).NE.0)THEN
	NFOCP=NINT(COMB(NOCCP,NDEG))    ! current dimension of Fock space
C Set shift
	MDIMP=0
	DO JOCC=0,NOCCP
	IF(LOCCIMP(JOCC).EQ.0)CYCLE
	MDIMP=MDIMP+NINT(COMB(JOCC,NDEG))
	ENDDO
C Set total energy for N+1 electrons
      ETOTP=SPECIMP(1+MDIMP-NFOCP)-CHEM*DBLE(NOCCP)
      ENDIF
      ENDIF
	ENDDO
C Set kinetic energy
      ELEVN=0.D0
      ELSCN=0.D0
      EMAGN=0.D0
      EORBN=0.D0
	M1S1=0
	DO ISPIN1=1,2
	DO M1=-L,L
	M1S1=M1S1+1
	MS=0
	DO ISPIN=1,2
	DO M=-L,L
	MS=MS+1
	IF(M1S1.EQ.MS)ONE=1.D0
	IF(M1S1.NE.MS)ONE=0.D0
C Levels
      ELEVN=ELEVN+(ELEV(M1S1,MS)-CHEM*ONE)*DMAT(M1S1,MS,0)
C Spin orbit
      ELSCN=ELSCN+ALSC*SLM(M,ISPIN1,ISPIN)*DMAT(M1S1,MS,0)
C Spin field
      IF(ISPIN1.EQ.ISPIN)THEN
      IF(ISPIN.EQ.1)IUPDN=+1
      IF(ISPIN.EQ.2)IUPDN=-1
      EMAGN=EMAGN+HMAG*DBLE(IUPDN)*DMAT(M1S1,MS,0)
      ENDIF
C Orbital field
      IF(M1.EQ.M)THEN
	EORBN=EORBN+HORB*DBLE(M)*DMAT(M1S1,MS,0)
      ENDIF
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      EKINN=ELEVN+ELSCN+EMAGN+EORBN
C Compute Kohn Sham potential
      DETOT=0.5D0*(ETOTP-ETOTN)-0.5D0*(ETOTM-ETOTN)
      AELEV=0.D0
      ADMAT=0.D0
	MS=0
	DO ISPIN=1,2
	DO M=-L,L
	MS=MS+1
	AELEV=AELEV+ELEV(MS,MS)
	ADMAT=ADMAT+DMAT(MS,MS,0)
	ENDDO
	ENDDO
	AELEV=AELEV/DBLE(NDEG)-CHEM
	DCPOT=DETOT-AELEV
	DCSUN=UBAR*ADMAT/2.D0+(UBAR-GBAR)*ADMAT/2.D0-(UBAR-GBAR)*0.5D0
C Print total energies
      WRITE(IUN,10110)EKINN
      WRITE(IUN,10120)ETOTN-EKINN
      WRITE(IUN,10130)ETOTN
10110 FORMAT(1X,'Kinetic   Energy =',G14.7)
10120 FORMAT(1X,'Potential Energy =',G14.7)
10130 FORMAT(1X,'Total     Energy =',G14.7)
C Print Kohn-Sham potential
      WRITE(IUN,10210)DETOT
      WRITE(IUN,10220)AELEV+DCSUN
      WRITE(IUN,10230)DCPOT
      WRITE(IUN,10240)DCSUN
10210 FORMAT(1X,'dEtot/dn         =',G14.7)
10220 FORMAT(1X,'dEtot/dn SU(N)   =',G14.7)
10230 FORMAT(1X,'DC Potential     =',G14.7)
10240 FORMAT(1X,'DC Pot   SU(N)   =',G14.7)
C MEMORY DEALLOCATIONS
	DEALLOCATE(COMB,SLM,UMAT)
	END
