      SUBROUTINE RAT_SHLFILES_KEEP(L,NDEG,NOCC,NFOC,EATS,AVEC)
*************************************************************************
* Stores eigenvectors into the file                                     *
*************************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                               !!! from setup
	USE COM_RATPAR  ,ONLY: EPSZIP                                !!! from readrat
	USE COM_LMTOUT  ,ONLY: SCRFILE                               !!! from storage
	USE COM_RATOUT  ,ONLY: ICSHL,SHLFILE                         !!! from storage
	USE COM_RATCHN  ,ONLY: IUSHL                                 !!! from setup
      USE COM_MASHDEP ,ONLY: NVAL,LENCMP                           !!! from setup
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                       !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
C Passed arrays
	REAL*8 EATS(NFOC)
	COMPLEX*16 AVEC(NFOC,NFOC)
C Allocatable arrays
	INTEGER, ALLOCATABLE :: IPACK(:,:)
	COMPLEX*16, ALLOCATABLE :: APAC(:)
	LOGICAL EXIST,OPEN
      CHARACTER SFILE*130,TNC*10
	DATA PI/3.141592653589793D0/
      CALL LIB_TINT(TNC,10,NOCC,NC)
	IF(ICSHL.EQ.0)SFILE=SCRFILE(IUSHL)
	IF(ICSHL.GT.0)SFILE=SHLFILE
      CALL FIND_LBLANK(SFILE,130,NA)
C Open the file
	INQUIRE(FILE=SFILE(:NA)//'_'//TNC(:NC),EXIST=EXIST)
	IF(EXIST)THEN
      OPEN(UNIT=IUSHL,FILE=SFILE(:NA)//'_'//TNC(:NC),STATUS='OLD',
     &     FORM='UNFORMATTED',ACCESS='SEQUENTIAL')
      CLOSE(UNIT=IUSHL,STATUS='DELETE')
      ENDIF
      OPEN(UNIT=IUSHL,FILE=SFILE(:NA)//'_'//TNC(:NC),STATUS='NEW',
     &     FORM='UNFORMATTED',ACCESS='SEQUENTIAL')
C Store Eigenvectors in the packed form
      IPAC=0
      DO IBND=1,NFOC
      DO IFOC=1,NFOC
      IF(ABS(AVEC(IFOC,IBND)).LE.EPSZIP)CYCLE
      IPAC=IPAC+1
      ENDDO
      ENDDO
      NPAC=IPAC
      ALLOCATE(APAC(NPAC))
      ALLOCATE(IPACK(2,NPAC))
      IPAC=0
      DO IBND=1,NFOC
      DO IFOC=1,NFOC
      IF(ABS(AVEC(IFOC,IBND)).LE.EPSZIP)CYCLE
      IPAC=IPAC+1
      IPACK(1,IPAC)=IFOC
      IPACK(2,IPAC)=IBND
      APAC(IPAC)=AVEC(IFOC,IBND)
      ENDDO
      ENDDO
      WRITE(IUSHL)NOCC,NFOC,NPAC
      WRITE(IUSHL)(EATS(IFOC),IFOC=1,NFOC),
     &((IPACK(I,IPAC),I=1,2),IPAC=1,NPAC),
     &(APAC(IPAC),IPAC=1,NPAC)
      CLOSE(UNIT=IUSHL,STATUS='KEEP')
      DEALLOCATE(APAC,IPACK)
	END



      SUBROUTINE RAT_SHLFILES_READ(L,NDEG,NOCC,NFOC,EATS,AVEC)
*************************************************************************
* Reads eigenvectors from the file                                      
*************************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                               !!! from setup
	USE COM_LMTOUT  ,ONLY: SCRFILE                               !!! from storage
	USE COM_RATOUT  ,ONLY: ICSHL,SHLFILE                         !!! from storage
	USE COM_RATCHN  ,ONLY: IUSHL                                 !!! from setup
      USE COM_MASHDEP ,ONLY: NVAL,LENCMP                           !!! from setup
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                       !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
C Passed arrays
	REAL*8 EATS(NFOC)
	COMPLEX*16 AVEC(NFOC,NFOC)
C Allocatable arrays
	INTEGER, ALLOCATABLE :: IPACK(:,:)
	COMPLEX*16, ALLOCATABLE :: APAC(:)
	LOGICAL EXIST,OPEN
      CHARACTER SFILE*130,TNC*10
	DATA PI/3.141592653589793D0/
      CALL LIB_TINT(TNC,10,NOCC,NC)
	IF(ICSHL.EQ.0)SFILE=SCRFILE(IUSHL)
	IF(ICSHL.GT.0)SFILE=SHLFILE
      CALL FIND_LBLANK(SFILE,130,NA)
C Open the file
	INQUIRE(FILE=SFILE(:NA)//'_'//TNC(:NC),EXIST=EXIST)
	IF(.NOT.EXIST)
     &CALL FULLSTOP('<RAT_SHLFILES_READ>:: SHLFILE NOT FOUND')
      OPEN(UNIT=IUSHL,FILE=SFILE(:NA)//'_'//TNC(:NC),STATUS='OLD',
     &     FORM='UNFORMATTED',ACCESS='SEQUENTIAL')
      READ(IUSHL)NOCC0,NFOC0,NPAC
      IF(NOCC0.NE.NOCC)
     &CALL FULLSTOP('<RAT_SHLFILES_READ>:: NOCC0.NE.NOCC')
      IF(NFOC0.NE.NFOC)
     &CALL FULLSTOP('<RAT_SHLFILES_READ>:: NFOC0.NE.NFOC')
      ALLOCATE(APAC(NPAC))
      ALLOCATE(IPACK(2,NPAC))
      READ(IUSHL)(EATS(IFOC),IFOC=1,NFOC),
     &((IPACK(I,IPAC),I=1,2),IPAC=1,NPAC),
     &(APAC(IPAC),IPAC=1,NPAC)
C Unpack Eigenvectors
      DO IBND=1,NFOC
      DO IFOC=1,NFOC
      AVEC(IFOC,IBND)=(0.D0,0.D0)
      ENDDO
      ENDDO
      DO IPAC=1,NPAC
      IFOC=IPACK(1,IPAC)
      IBND=IPACK(2,IPAC)
      AVEC(IFOC,IBND)=APAC(IPAC)
      ENDDO
      CLOSE(UNIT=IUSHL,STATUS='KEEP')
      DEALLOCATE(APAC,IPACK)
	END
