	SUBROUTINE RAT_SHLMAT(IOCC,NMATMAX,TOPER)
***************************************************************
*  Finds matrix elements for atomic Green function            *
***************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_RATPAR  ,ONLY: EPSZIP                                     !!! from readrat
      USE COM_IMPGRF  ,ONLY: KVRB                                       !!! from readrat
      USE COM_LSHELL  ,ONLY: NORB,LORB,LOCCIMP,FSLA,ELEV,SPECIMP,ISTATE !!! from shells
	USE COM_RATCHN  ,ONLY: IUAGF,IUSHL                                !!! from channels
      USE COM_LMTOUT  ,ONLY: SCRFILE                                    !!! from storage
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                            !!! from setup
      USE COM_MASHDEP ,ONLY: NVAL,LENCMP,LENREL,LENINT                  !!! from setup
      IMPLICIT REAL*8 (A-H,O-Z)
C SET LOCAL VARIABLES
	INTEGER, ALLOCATABLE :: ISPSUBN(:)
	INTEGER, ALLOCATABLE :: ISPSUBM(:)
	INTEGER, ALLOCATABLE :: ISUBSPN(:)
	INTEGER, ALLOCATABLE :: ISUBSPM(:)
	INTEGER, ALLOCATABLE :: IMATS(:,:)
	INTEGER, ALLOCATABLE :: IMATP(:,:)
	INTEGER, ALLOCATABLE :: IOPER(:)
	REAL*8, ALLOCATABLE :: COMB(:,:)
	REAL*8, ALLOCATABLE :: EATSN(:)
	REAL*8, ALLOCATABLE :: EATSM(:)
      COMPLEX*16, ALLOCATABLE :: FMATS(:,:)
      COMPLEX*16, ALLOCATABLE :: WORKS(:,:)
	COMPLEX*16, ALLOCATABLE :: AVECN(:,:)
	COMPLEX*16, ALLOCATABLE :: AVECM(:,:)
	COMPLEX*16, ALLOCATABLE :: FMATP(:)
	COMPLEX*16 DIM,DENOM,GFACT,XFACT
	CHARACTER HELP*40,TMS*10,TNC*10,SFILE*130,TOPER*1
	LOGICAL EXIST,OPEN
	DATA PI/3.141592653589793D0/,DIM/(0.D0,1.D0)/
C ********************************************
	L=LORB
	NDEG=2*(2*LORB+1)
      NDIM=2**NDEG
      ISIG=0
      IF(TOPER.EQ.'D')ISIG=+1
      IF(TOPER.EQ.'C')ISIG=-1
      NOCCN=IOCC
      NOCCM=IOCC-ISIG
      IF(ISIG.EQ.0)
     &CALL FULLSTOP('<RAT_SHLMAT>:: ISIG.EQ.0')
      NMATMAX=0
      IF(NOCCN.LT.0.OR.NOCCN.GT.NDEG)RETURN
      IF(NOCCM.LT.0.OR.NOCCM.GT.NDEG)RETURN
      IF(LOCCIMP(NOCCN).EQ.0.OR.LOCCIMP(NOCCM).EQ.0)RETURN
C Get combnatorics
	ALLOCATE(COMB(0:NDEG,0:NDEG))
	CALL LIB_GETCOMB(COMB,NDEG)
      NFOCN=NINT(COMB(NOCCN,NDEG)) ! total dimension of "Nf"   impurity space
      NFOCM=NINT(COMB(NOCCM,NDEG)) ! total dimension of "Nf-1" impurity space
	ALLOCATE(IOPER(NDEG))
	ALLOCATE(FMATS(NFOCM,NFOCN))
	ALLOCATE(WORKS(NFOCM,NFOCN))
C Transition selected, calculate matrix element
	ALLOCATE(ISUBSPN(NFOCN))
	ALLOCATE(ISPSUBN(0:NDIM-1))
	IFOCN=0
	DO IVECN=0,NDIM-1
	ISPSUBN(IVECN)=-1
	IOCCN=0
	DO MS=1,NDEG
	IOCCN=IOCCN+ISTATE(MS,IVECN)
	ENDDO
	IF(IOCCN.EQ.NOCCN)THEN
	IFOCN=IFOCN+1
	ISUBSPN(IFOCN)=IVECN
	ISPSUBN(IVECN)=IFOCN
	ENDIF
	ENDDO
	IF(IFOCN.NE.NFOCN)CALL FULLSTOP('IFOC.NE.NFOC')
C Reduce/Add electron by one and find similar quantities
	ALLOCATE(ISUBSPM(NFOCM))
	ALLOCATE(ISPSUBM(0:NDIM-1))
	IFOCM=0
	DO IVECM=0,NDIM-1
	ISPSUBM(IVECM)=-1
	IOCCM=0
	DO MS=1,NDEG
	IOCCM=IOCCM+ISTATE(MS,IVECM)
	ENDDO
	IF(IOCCM.EQ.NOCCM)THEN
	IFOCM=IFOCM+1
	ISUBSPM(IFOCM)=IVECM
	ISPSUBM(IVECM)=IFOCM
	ENDIF
	ENDDO
	IF(IFOCM.NE.NFOCM)CALL FULLSTOP('IFOC.NE.NFOC')
C Read many body atomic states
	ALLOCATE(EATSN(NFOCN))
	ALLOCATE(AVECN(NFOCN,NFOCN))
	CALL RAT_SHLFILES_READ(L,NDEG,NOCCN,NFOCN,EATSN,AVECN)
	ALLOCATE(EATSM(NFOCM))
	ALLOCATE(AVECM(NFOCM,NFOCM))
	CALL RAT_SHLFILES_READ(L,NDEG,NOCCM,NFOCM,EATSM,AVECM)
C CHECK SCRATCH FILES
	CALL FIND_LBLANK(SCRFILE(IUAGF),130,NA)
	MS=0
	DO ISPIN=1,2
	DO M=-L,L
	MS=MS+1
      CALL LIB_TINT(TNC,10,IOCC,NC)
      CALL LIB_TINT(TMS,10,MS,NB)
	INQUIRE(FILE=SCRFILE(IUAGF)(:NA)//'_'//TMS(:NB)//'_'//TNC(:NC),
     &EXIST=EXIST,OPENED=OPEN)
	IF(.NOT.OPEN.AND.EXIST)
     &OPEN(UNIT=IUAGF,FILE=SCRFILE(IUAGF)(:NA)//'_'//TMS(:NB)//'_'//
     &TNC(:NC),STATUS='OLD',ACCESS='SEQUENTIAL',FORM='UNFORMATTED')
	IF(EXIST)CLOSE(UNIT=IUAGF,STATUS='DELETE')
	ENDDO
	ENDDO
C *********************************************
C SET MATIRX ELEMENTS WITH DESTRUCTION/CREATION OPERATOR
	ALLOCATE(IMATS(NFOCM,NFOCN))
	MS=0
	SIZE_FMATS=0.D0
	SIZE_FMATP=0.D0
	NMATMAX=0
	DO 2000 ISPIN=1,2                   !!! over ispin
	DO 1000 M=-L,L                      !!! over m
	MS=MS+1
	DO IFOCM=1,NFOCM
	DO IFOCN=1,NFOCN
	IMATS(IFOCM,IFOCN)=0
	ENDDO
	ENDDO
	DO IFOCN=1,NFOCN                    !!! over all Fock states
	IVECN=ISUBSPN(IFOCN)
C Copy iFock vector
	M1S1=0
	DO ISPIN1=1,2
	DO M1=-L,L
	M1S1=M1S1+1
	IOPER(M1S1)=ISTATE(M1S1,IVECN)
	ENDDO
	ENDDO
C Destroy particle
      IF(TOPER.EQ.'D')THEN
	IF(ISTATE(MS,IVECN).NE.1)CYCLE ! operator C^-(ms) destroys the particle
	IOPER(MS)=0
	ISUMS=0
	DO I=1,MS-1
	ISUMS=ISUMS+IOPER(I)
	ENDDO
	ISIGN=(-1)**ISUMS
	ELSEIF(TOPER.EQ.'C')THEN
	IF(ISTATE(MS,IVECN).NE.0)CYCLE ! operator C^+(ms) creates the particle
	IOPER(MS)=1
	ISUMS=0
	DO I=1,MS-1
	ISUMS=ISUMS+IOPER(I)
	ENDDO
	ISIGN=(-1)**ISUMS
      ENDIF
C Find out this state number
	ITWO=1
	IVECM=0
	DO I=1,NDEG
	IVECM=IVECM+IOPER(I)*ITWO
	ITWO=ITWO*2
	ENDDO
	IFOCM=ISPSUBM(IVECM)
	IF(IFOCM.EQ.-1)CALL FULLSTOP('IFOCM.EQ.-1')
	IMATS(IFOCM,IFOCN)=ISIGN
C Rewind the state back
	IF(TOPER.EQ.'D')IOPER(MS)=1
	IF(TOPER.EQ.'C')IOPER(MS)=0
	ENDDO                          ! over all Fock states
C Transfer matrix elements with Slater integrals to the matrix elements
C with real many body states
	DO IBNDN=1,NFOCN
	DO IBNDM=1,NFOCM
	FMATS(IBNDM,IBNDN)=(0.D0,0.D0)
	ENDDO
	ENDDO
	DO IBNDN=1,NFOCN
	DO IFOCM=1,NFOCM
	WORKS(IFOCM,IBNDN)=(0.D0,0.D0)
	ENDDO
	ENDDO
	DO IFOCN=1,NFOCN
	DO IFOCM=1,NFOCM
	IF(IMATS(IFOCM,IFOCN).NE.0)THEN
	DO IBNDN=1,NFOCN
	WORKS(IFOCM,IBNDN)=WORKS(IFOCM,IBNDN)+
     &IMATS(IFOCM,IFOCN)*AVECN(IFOCN,IBNDN)
	ENDDO
	ENDIF
	ENDDO
	ENDDO
	DO IBNDM=1,NFOCM
	DO IBNDN=1,NFOCN
	DO IFOCM=1,NFOCM
	FMATS(IBNDM,IBNDN)=FMATS(IBNDM,IBNDN)+
     &DCONJG(AVECM(IFOCM,IBNDM))*WORKS(IFOCM,IBNDN)
	ENDDO
	ENDDO
	ENDDO
C Pack and store matrix elements
      IMAT=0
	DO IBNDM=1,NFOCM
	DO IBNDN=1,NFOCN
      IF(ABS(FMATS(IBNDM,IBNDN)).LE.EPSZIP)CYCLE
      IMAT=IMAT+1
      ENDDO
      ENDDO
      NMATP=IMAT
      NMATMAX=NMATMAX+NMATP
      ALLOCATE(FMATP(NMATP))
      ALLOCATE(IMATP(2,NMATP))
      IMAT=0
	DO IBNDM=1,NFOCM
	DO IBNDN=1,NFOCN
      IF(ABS(FMATS(IBNDM,IBNDN)).LE.EPSZIP)CYCLE
      IMAT=IMAT+1
      FMATP(IMAT)=FMATS(IBNDM,IBNDN)
      IMATP(1,IMAT)=IBNDM
      IMATP(2,IMAT)=IBNDN
      ENDDO
      ENDDO
      SIZE_FMATS=SIZE_FMATS+DBLE(NFOCM*NFOCN*LENCMP)/1024.D0**2
      SIZE_FMATP=SIZE_FMATP+1.5D0*DBLE(NMATP*LENCMP)/1024.D0**2
C Store
	CALL FIND_LBLANK(SCRFILE(IUAGF),130,NA)
      CALL LIB_TINT(TNC,10,IOCC,NC)
      CALL LIB_TINT(TMS,10,MS,NB)
      OPEN(UNIT=IUAGF,FILE=SCRFILE(IUAGF)(:NA)//'_'//TMS(:NB)//'_'//
     &TNC(:NC),STATUS='NEW',ACCESS='SEQUENTIAL',FORM='UNFORMATTED')
      WRITE(IUAGF)NMATP
	WRITE(IUAGF)(FMATP(IMAT),IMAT=1,NMATP),
     &  ((IMATP(I,IMAT),I=1,2),IMAT=1,NMATP)
	CLOSE(UNIT=IUAGF,STATUS='KEEP')
	WRITE(IUN,10320)MS
	DEALLOCATE(FMATP,IMATP)
 1000	CONTINUE                           !!! over m
 2000	CONTINUE                           !!! over ispin
	WRITE(IUN,10330)SIZE_FMATS,SIZE_FMATP
10320 FORMAT(1X,'Matrix element for Fms =',I2,' stored')
10330 FORMAT(1X,'Total size, storage (Mbyte)=',G14.7,1X,G14.7)
C Memory deallocations
      DEALLOCATE(COMB,FMATS,WORKS)
	DEALLOCATE(EATSN,AVECN,EATSM,AVECM,IMATS)
	DEALLOCATE(ISPSUBN,ISPSUBM,ISUBSPN,ISUBSPM,IOPER)
      END




	SUBROUTINE RAT_ORBMAT(IOCC,NPOC,NPMS,NPML,NPMJ,NPSS,NPLL,NPJJ)
***************************************************************
*  Finds matrix elements of angular momenta
***************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_RATPAR  ,ONLY: EPSZIP                                     !!! from readrat
      USE COM_IMPGRF  ,ONLY: KVRB                                       !!! from readrat
      USE COM_LSHELL  ,ONLY: NORB,LORB,LOCCIMP,FSLA,ELEV,SPECIMP,ISTATE !!! from shells
	USE COM_RATCHN  ,ONLY: IUAGF,IUSHL                                !!! from channels
      USE COM_LMTOUT  ,ONLY: SCRFILE                                    !!! from storage
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                            !!! from setup
      USE COM_MASHDEP ,ONLY: NVAL,LENCMP,LENREL,LENINT                  !!! from setup
      IMPLICIT REAL*8 (A-H,O-Z)
C SET LOCAL VARIABLES
	INTEGER, ALLOCATABLE :: IOPER(:)
	INTEGER, ALLOCATABLE :: ISPSUB(:)
	INTEGER, ALLOCATABLE :: ISUBSP(:)
	INTEGER, ALLOCATABLE :: IMATP(:,:)
	REAL*8, ALLOCATABLE :: COMB(:,:)
	REAL*8, ALLOCATABLE :: EATS(:)
	REAL*8, ALLOCATABLE :: TMAT(:,:,:,:)
	REAL*8, ALLOCATABLE :: OCN(:)
	COMPLEX*16, ALLOCATABLE :: OCC(:,:)
	COMPLEX*16, ALLOCATABLE :: DML(:,:)
	COMPLEX*16, ALLOCATABLE :: DMS(:,:)
	COMPLEX*16, ALLOCATABLE :: DMJ(:,:)
	COMPLEX*16, ALLOCATABLE :: DLL(:,:)
	COMPLEX*16, ALLOCATABLE :: DSS(:,:)
	COMPLEX*16, ALLOCATABLE :: DLS(:,:)
	COMPLEX*16, ALLOCATABLE :: DJJ(:,:)
      COMPLEX*16, ALLOCATABLE :: FMATP(:)
      COMPLEX*16, ALLOCATABLE :: HMAT(:,:)
	COMPLEX*16, ALLOCATABLE :: AVEC(:,:)
	COMPLEX*16 DIM
	CHARACTER HELP*40,TMS*10,TNC*10,SFILE*130
	LOGICAL EXIST,OPEN
	DATA PI/3.141592653589793D0/,DIM/(0.D0,1.D0)/
C ********************************************
	L=LORB
	NDEG=2*(2*LORB+1)
      NDIM=2**NDEG
      IF(IOCC.LT.0.OR.IOCC.GT.NDEG)RETURN
      IF(LOCCIMP(IOCC).EQ.0)RETURN
C Get combnatorics
	ALLOCATE(COMB(0:NDEG,0:NDEG))
	CALL LIB_GETCOMB(COMB,NDEG)
      NFOC=NINT(COMB(IOCC,NDEG)) ! total dimension of "Nf"   impurity space
	ALLOCATE(IOPER(NDEG))
C Transition selected, calculate matrix element
	ALLOCATE(ISUBSP(NFOC))
	ALLOCATE(ISPSUB(0:NDIM-1))
	IFOC=0
	DO IVEC=0,NDIM-1
	ISPSUB(IVEC)=-1
	IOCC0=0
	DO MS=1,NDEG
	IOCC0=IOCC0+ISTATE(MS,IVEC)
	ENDDO
	IF(IOCC0.EQ.IOCC)THEN
	IFOC=IFOC+1
	ISUBSP(IFOC)=IVEC
	ISPSUB(IVEC)=IFOC
	ENDIF
	ENDDO
	IF(IFOC.NE.NFOC)CALL FULLSTOP('IFOC.NE.NFOC')
C Read many body atomic states
	ALLOCATE(EATS(NFOC))
	ALLOCATE(AVEC(NFOC,NFOC))
	CALL RAT_SHLFILES_READ(L,NDEG,IOCC,NFOC,EATS,AVEC)
C CHECK SCRATCH FILES
	CALL FIND_LBLANK(SCRFILE(IUAGF),130,NA)
      CALL LIB_TINT(TNC,10,IOCC,NC)
	INQUIRE(FILE=SCRFILE(IUAGF)(:NA)//'_'//TNC(:NC),
     &EXIST=EXIST,OPENED=OPEN)
	IF(.NOT.OPEN.AND.EXIST)
     &OPEN(UNIT=IUAGF,FILE=SCRFILE(IUAGF)(:NA)//'_'//TNC(:NC),
     &STATUS='OLD',ACCESS='SEQUENTIAL',FORM='UNFORMATTED')
	IF(EXIST)CLOSE(UNIT=IUAGF,STATUS='DELETE')
      OPEN(UNIT=IUAGF,FILE=SCRFILE(IUAGF)(:NA)//'_'//TNC(:NC),
     &STATUS='NEW',ACCESS='SEQUENTIAL',FORM='UNFORMATTED')
	SIZE_FMATS=0.D0
	SIZE_FMATP=0.D0
C AVERAGE OCCUPANCIES
	ALLOCATE(OCC(NFOC,NFOC))
	NPOC=0
	DO 100 MS=1,NDEG                  !!! over impurity states
	DO ILEV=1,NFOC
	DO JLEV=1,NFOC
	OCC(ILEV,JLEV)=0.D0
	DO IFOC=1,NFOC
	IVEC=ISUBSP(IFOC)
	OCC(ILEV,JLEV)=OCC(ILEV,JLEV)+
     &DCONJG(AVEC(IFOC,ILEV))*AVEC(IFOC,JLEV)*ISTATE(MS,IVEC)
	ENDDO
	ENDDO
	ENDDO
C Pack and store average values of operators squared
      IMAT=0
	DO ILEV=1,NFOC
	DO JLEV=1,NFOC
      IF(ABS(OCC(ILEV,JLEV)).LE.EPSZIP)CYCLE
      IMAT=IMAT+1
      ENDDO
      ENDDO
      NMATP=IMAT
      ALLOCATE(FMATP(NMATP))
      ALLOCATE(IMATP(2,NMATP))
      IMAT=0
	DO ILEV=1,NFOC
	DO JLEV=1,NFOC
      IF(ABS(OCC(ILEV,JLEV)).LE.EPSZIP)CYCLE
      IMAT=IMAT+1
      FMATP(IMAT)=OCC(ILEV,JLEV)
      IMATP(1,IMAT)=ILEV
      IMATP(2,IMAT)=JLEV
      ENDDO
      ENDDO
      SIZE_FMATS=SIZE_FMATS+DBLE(NFOC*NFOC*LENCMP)/1024.D0**2
      SIZE_FMATP=SIZE_FMATP+1.5D0*DBLE(NMATP*LENCMP)/1024.D0**2
C Store
      WRITE(IUAGF)NMATP
	WRITE(IUAGF)(FMATP(IMAT),IMAT=1,NMATP),
     &  ((IMATP(I,IMAT),I=1,2),IMAT=1,NMATP)
	DEALLOCATE(FMATP,IMATP)
	NPOC=NPOC+NMATP
 100  CONTINUE                          !!! over impurity states
      DEALLOCATE(OCC)
C AVERAGE MS,ML,MJ
	ALLOCATE(DMS(NFOC,NFOC))
	ALLOCATE(DML(NFOC,NFOC))
	ALLOCATE(DMJ(NFOC,NFOC))
	ALLOCATE(OCN(NDEG))
      DO 2000 ILEV=1,NFOC	                       !!! over iLev
      DO 1000 JLEV=1,NFOC	                       !!! over jLev
C Find occupation numbers for interacting state
	DO MS=1,NDEG
	OCN(MS)=0.D0
	DO IFOC=1,NFOC
	IVEC=ISUBSP(IFOC)
	OCN(MS)=OCN(MS)+
     &DCONJG(AVEC(IFOC,ILEV))*AVEC(IFOC,JLEV)*ISTATE(MS,IVEC)
	ENDDO
	ENDDO
C Find average projection of spin momentum onto z axis
	DMS(ILEV,JLEV)=0
	MS=0
	DO IUPDN=+1,-1,-2                 !!! spin magnetic moment is +/-1, i.e. up, dn
	DO M=-L,L
	MS=MS+1
	DMS(ILEV,JLEV)=DMS(ILEV,JLEV)+0.5D0*OCN(MS)*DBLE(IUPDN)
	ENDDO
	ENDDO
C Find average projection of orbital momentum onto z axis
	DML(ILEV,JLEV)=0
	MS=0
	DO ISPIN=1,2
	DO M=-L,L
	MS=MS+1
	DML(ILEV,JLEV)=DML(ILEV,JLEV)+OCN(MS)*DBLE(M)
	ENDDO
	ENDDO
C Find average projection of total momentum onto z axis
	DMJ(ILEV,JLEV)=0
	MS=0
	DO IUPDN=+1,-1,-2                 !!! spin magnetic moment is +/-1, i.e. up, dn
	DO M=-L,L
	MS=MS+1
	DMJ(ILEV,JLEV)=DMJ(ILEV,JLEV)+OCN(MS)*
     &               (DBLE(M)+0.5D0*DBLE(IUPDN))
	ENDDO
	ENDDO
 1000 CONTINUE                                  !!! over jLev
 2000 CONTINUE                                  !!! iver iLev
C **************************************************
C Pack and store average values of operators squared
	NPMS=0
	NPML=0
	NPMJ=0
      DO 3000 IC=1,3                     !!! over SS,LL,JJ
      IMAT=0
	DO ILEV=1,NFOC
	DO JLEV=1,NFOC
	IF(IC.EQ.1)THEN
      IF(ABS(DMS(ILEV,JLEV)).LE.EPSZIP)CYCLE
	ELSEIF(IC.EQ.2)THEN
      IF(ABS(DML(ILEV,JLEV)).LE.EPSZIP)CYCLE
	ELSEIF(IC.EQ.3)THEN
      IF(ABS(DMJ(ILEV,JLEV)).LE.EPSZIP)CYCLE
      ENDIF
      IMAT=IMAT+1
      ENDDO
      ENDDO
      NMATP=IMAT
      ALLOCATE(FMATP(NMATP))
      ALLOCATE(IMATP(2,NMATP))
      IMAT=0
	DO ILEV=1,NFOC
	DO JLEV=1,NFOC
	IF(IC.EQ.1)THEN
      IF(ABS(DMS(ILEV,JLEV)).LE.EPSZIP)CYCLE
	ELSEIF(IC.EQ.2)THEN
      IF(ABS(DML(ILEV,JLEV)).LE.EPSZIP)CYCLE
	ELSEIF(IC.EQ.3)THEN
      IF(ABS(DMJ(ILEV,JLEV)).LE.EPSZIP)CYCLE
      ENDIF
      IMAT=IMAT+1
      IF(IC.EQ.1)FMATP(IMAT)=DMS(ILEV,JLEV)
      IF(IC.EQ.2)FMATP(IMAT)=DML(ILEV,JLEV)
      IF(IC.EQ.3)FMATP(IMAT)=DMJ(ILEV,JLEV)
      IMATP(1,IMAT)=ILEV
      IMATP(2,IMAT)=JLEV
      ENDDO
      ENDDO
      SIZE_FMATS=SIZE_FMATS+DBLE(NFOC*NFOC*LENCMP)/1024.D0**2
      SIZE_FMATP=SIZE_FMATP+1.5D0*DBLE(NMATP*LENCMP)/1024.D0**2
C Store
      WRITE(IUAGF)NMATP
	WRITE(IUAGF)(FMATP(IMAT),IMAT=1,NMATP),
     &  ((IMATP(I,IMAT),I=1,2),IMAT=1,NMATP)
	DEALLOCATE(FMATP,IMATP)
	IF(IC.EQ.1)NPMS=NPMS+NMATP
	IF(IC.EQ.2)NPML=NPML+NMATP
	IF(IC.EQ.3)NPMJ=NPMJ+NMATP
 3000 CONTINUE                          !!! over MS,ML,MJ
      DEALLOCATE(DMS,DML,DMJ,OCN)
C **************************************************
C AVERAGE SS,LL,JJ
	ALLOCATE(HMAT(NFOC,NFOC))
	ALLOCATE(TMAT(NDEG,NDEG,NDEG,NDEG))
	ALLOCATE(DLL(NFOC,NFOC))
	ALLOCATE(DSS(NFOC,NFOC))
	ALLOCATE(DLS(NFOC,NFOC))
	ALLOCATE(DJJ(NFOC,NFOC))
C Find average orbital operator squared
	CALL RAT_MATATM_OMAT(L,NDEG,TMAT)
      CALL RAT_MATATM_CONV(L,NDEG,NFOC,NDIM,ISTATE,ISUBSP,ISPSUB,
     &     HMAT,TMAT)
      CALL RAT_MATATM_MATR(NFOC,HMAT,AVEC,DLL,IERR)
C Find average spin operator squared
	CALL RAT_MATATM_SMAT(L,NDEG,TMAT)
      CALL RAT_MATATM_CONV(L,NDEG,NFOC,NDIM,ISTATE,ISUBSP,ISPSUB,
     &     HMAT,TMAT)
      CALL RAT_MATATM_MATR(NFOC,HMAT,AVEC,DSS,IERR)
C Find average spin orbital operator
	CALL RAT_MATATM_RMAT(L,NDEG,TMAT)
      CALL RAT_MATATM_CONV(L,NDEG,NFOC,NDIM,ISTATE,ISUBSP,ISPSUB,
     &     HMAT,TMAT)
      CALL RAT_MATATM_MATR(NFOC,HMAT,AVEC,DLS,IERR)
C Find average total momentum operator squared
	DO ILEV=1,NFOC
	DO JLEV=1,NFOC
	DJJ(ILEV,JLEV)=DLL(ILEV,JLEV)+DSS(ILEV,JLEV)+DLS(ILEV,JLEV)
	ENDDO
	ENDDO
C **************************************************
C Pack and store average values of operators squared
	NPSS=0
	NPLL=0
	NPJJ=0
      DO 4000 IC=1,3                     !!! over SS,LL,JJ
      IMAT=0
	DO ILEV=1,NFOC
	DO JLEV=1,NFOC
	IF(IC.EQ.1)THEN
      IF(ABS(DSS(ILEV,JLEV)).LE.EPSZIP)CYCLE
	ELSEIF(IC.EQ.2)THEN
      IF(ABS(DLL(ILEV,JLEV)).LE.EPSZIP)CYCLE
	ELSEIF(IC.EQ.3)THEN
      IF(ABS(DJJ(ILEV,JLEV)).LE.EPSZIP)CYCLE
      ENDIF
      IMAT=IMAT+1
      ENDDO
      ENDDO
      NMATP=IMAT
      ALLOCATE(FMATP(NMATP))
      ALLOCATE(IMATP(2,NMATP))
      IMAT=0
	DO ILEV=1,NFOC
	DO JLEV=1,NFOC
	IF(IC.EQ.1)THEN
      IF(ABS(DSS(ILEV,JLEV)).LE.EPSZIP)CYCLE
	ELSEIF(IC.EQ.2)THEN
      IF(ABS(DLL(ILEV,JLEV)).LE.EPSZIP)CYCLE
	ELSEIF(IC.EQ.3)THEN
      IF(ABS(DJJ(ILEV,JLEV)).LE.EPSZIP)CYCLE
      ENDIF
      IMAT=IMAT+1
      IF(IC.EQ.1)FMATP(IMAT)=DSS(ILEV,JLEV)
      IF(IC.EQ.2)FMATP(IMAT)=DLL(ILEV,JLEV)
      IF(IC.EQ.3)FMATP(IMAT)=DJJ(ILEV,JLEV)
      IMATP(1,IMAT)=ILEV
      IMATP(2,IMAT)=JLEV
      ENDDO
      ENDDO
      SIZE_FMATS=SIZE_FMATS+DBLE(NFOC*NFOC*LENCMP)/1024.D0**2
      SIZE_FMATP=SIZE_FMATP+1.5D0*DBLE(NMATP*LENCMP)/1024.D0**2
C Store
      WRITE(IUAGF)NMATP
	WRITE(IUAGF)(FMATP(IMAT),IMAT=1,NMATP),
     &  ((IMATP(I,IMAT),I=1,2),IMAT=1,NMATP)
	DEALLOCATE(FMATP,IMATP)
	IF(IC.EQ.1)NPSS=NPSS+NMATP
	IF(IC.EQ.2)NPLL=NPLL+NMATP
	IF(IC.EQ.3)NPJJ=NPJJ+NMATP
 4000 CONTINUE                          !!! over SS,LL,JJ
	CLOSE(UNIT=IUAGF,STATUS='KEEP')
C Memory deallocations
      DEALLOCATE(COMB,DJJ,DLL,DSS,DLS)
	DEALLOCATE(EATS,HMAT,AVEC,IOPER,TMAT,ISUBSP,ISPSUB)
      END
