	SUBROUTINE RAT_SIGGRF
***************************************************************
*  Computes atomic self-energy
***************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LSHELL  ,ONLY: NORB,LORB,ELEV                          !!! from shells
      USE COM_RATHYB  ,ONLY: NHYB,EHYB,VHYB                          !!! from readrat
      USE COM_IMPGRF  ,ONLY: GLOC,NMOM,GMOM,DMAT,SIGW,SIGI
     &                      ,SIG0,BMAS,CHEM,KVRB
      USE COM_RATOUT  ,ONLY: ICGRF                                   !!! from storage
	USE COM_MSBMESH ,ONLY: TEMP,NMSC,WMSC                          !!! from readrat
      USE COM_UNIT    ,ONLY: IUN,IUT,IUR,IUI                         !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: GINV(:,:)
	COMPLEX*16, ALLOCATABLE :: WORK(:)
	COMPLEX*16 DIM,EMAT
	LOGICAL EXIST
      DATA PI/3.141592653589793D0/,DIM/(0.D0,1.D0)/
C ********************************************
      IF(ICGRF.EQ.0)RETURN
	L=LORB
	NDEG=2*(2*LORB+1)
C Construct self-energy matrix
	ALLOCATE(WORK(NDEG+NHYB))
	ALLOCATE(GINV(NDEG+NHYB,NDEG+NHYB))
	DO 1000 IMSC=0,NMSC          ! over imsc
	DO M1S1=1,NDEG+NHYB          ! over m1s1
	DO MS  =1,NDEG+NHYB          ! over ms
	GINV(M1S1,MS)=GLOC(M1S1,MS,IMSC)
	ENDDO                        ! over ms
	ENDDO                        ! over m1s1
C Invert matrix
	CALL LIB_CINV(NDEG+NHYB,GINV,NDEG+NHYB,WORK,IFAIL)
	IF(IFAIL.NE.0)THEN
      WRITE(IUN,*)'<RAT_SIGGRF>: Error in Inversion'
	DO M1S1=1,NDEG+NHYB          ! over m1s1
	DO MS  =1,NDEG+NHYB          ! over ms
	GINV(M1S1,MS)=(0.D0,0.D0)
	ENDDO                        ! over ms
	ENDDO                        ! over m1s1
      ENDIF
C Construct self-energy
	DO M1S1=1,NDEG+NHYB          ! over m1s1
	DO MS  =1,NDEG+NHYB          ! over ms
	IF(M1S1.EQ.MS)DI=1.D0
	IF(M1S1.NE.MS)DI=0.D0
	IF(M1S1.LE.NDEG.AND.MS.LE.NDEG)EMAT=ELEV(M1S1,MS)
	IF(M1S1.GT.NDEG.AND.MS.GT.NDEG)EMAT=EHYB(MS-NDEG)*DI
	IF(M1S1.LE.NDEG.AND.MS.GT.NDEG)EMAT=VHYB(M1S1,MS-NDEG)
	IF(M1S1.GT.NDEG.AND.MS.LE.NDEG)EMAT=DCONJG(VHYB(MS,M1S1-NDEG))
	SIGW(M1S1,MS,IMSC)=(WMSC(IMSC)+CHEM)*DI-
     &EMAT-GINV(M1S1,MS)
	ENDDO                        ! over ms
	ENDDO                        ! over m1s1
 1000 CONTINUE                     ! over imsc
C Hartree Fock value
	DO M1S1=1,NDEG+NHYB          ! over m1s1
	DO MS  =1,NDEG+NHYB          ! over ms
	IF(M1S1.EQ.MS)DI=1.D0
	IF(M1S1.NE.MS)DI=0.D0
	IF(M1S1.LE.NDEG.AND.MS.LE.NDEG)EMAT=ELEV(M1S1,MS)
	IF(M1S1.GT.NDEG.AND.MS.GT.NDEG)EMAT=EHYB(MS-NDEG)*DI
	IF(M1S1.LE.NDEG.AND.MS.GT.NDEG)EMAT=VHYB(M1S1,MS-NDEG)
	IF(M1S1.GT.NDEG.AND.MS.LE.NDEG)EMAT=DCONJG(VHYB(MS,M1S1-NDEG))
	SIGI(M1S1,MS)=CHEM*DI-EMAT+GMOM(M1S1,MS,1)
	ENDDO                        ! over ms
	ENDDO                        ! over m1s1
C Zero frequency value and slope are underdermined
	DO M1S1=1,NDEG+NHYB          ! over m1s1
	DO MS  =1,NDEG+NHYB          ! over ms
	SIG0(M1S1,MS)=(0.D0,0.D0)
	BMAS(M1S1,MS)=(0.D0,0.D0)
	ENDDO                        ! over ms
	ENDDO                        ! over m1s1
C MEMORY DEALLOCATIONS
	DEALLOCATE(GINV,WORK)
	END
