	SUBROUTINE RAT_SLATER
************************************************************
*   Slater integrals                                       *
************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_RATPAR  ,ONLY: LCRT                                !!! from readrat
      USE COM_RATSCF  ,ONLY: SRAT,ZRAT,ERAT,TRAT,RATPOT          !!! from readrat
      USE COM_RATLEV  ,ONLY: NLEVT,LEVN,LEVL,LEVJ,ELEV,ZLEV,SLEV,GLEV
      USE COM_RATMESH ,ONLY: NRAT,HRAT,RRAT,DRAT,WRAT,PRAT       !!! from radmesh
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT                         !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8, ALLOCATABLE :: VBAR(:)
	REAL*8, ALLOCATABLE :: PHI1(:)
	REAL*8, ALLOCATABLE :: PHI2(:)
	REAL*8, ALLOCATABLE :: APHI(:)
	REAL*8, ALLOCATABLE :: APHID(:)
	REAL*8, ALLOCATABLE :: APHIL(:,:)
	REAL*8, ALLOCATABLE :: WORK1(:)
	REAL*8, ALLOCATABLE :: WORK2(:)
	REAL*8, ALLOCATABLE :: SLATU(:,:,:)
	REAL*8, ALLOCATABLE :: SLATG(:,:,:)
	CHARACTER TLEV(8,0:4,8)*19,THED*19
	LOGICAL EXIT
	DATA PI/3.141592653589793D0/
      CALL ABORTNOW()
	LCR=LCRT ! relativistic control
C MEMORY ALLOCATIONS
      ALLOCATE(WORK1(0:NRATMEM))
      ALLOCATE(WORK2(0:NRATMEM))
	ALLOCATE(VBAR(0:NRATMEM))
	ALLOCATE(PHI1(0:NRATMEM))
	ALLOCATE(PHI2(0:NRATMEM))
	ALLOCATE(APHI(0:NRATMEM))
	ALLOCATE(APHID(0:NRATMEM))
	ALLOCATE(APHIL(0:NRATMEM,36))
	ALLOCATE(SLATU(0:3,36,36))
	ALLOCATE(SLATG(0:3,36,36))
C SET THE POTENTIAL
      VBAR(0)=2.D0*ZRAT
	DO IRAT=1,NRAT
      VBAR(IRAT)=-RRAT(IRAT)*RATPOT(IRAT)
	ENDDO
C RECALCULATE LEVELS 
	DO 1000 ILEV=1,NLEVT                   !!! over core levels
	NQ=LEVN(ILEV)
	LQ=LEVL(ILEV)
	JQ=LEVJ(ILEV)
	QJ=DBLE(JQ)/2.D0
	NODE=NQ-LQ-1
	ROOT=ELEV(ILEV)
C  SOLVE DIRAC EQUATION 
	CALL LIB_CORSCH_ENYS(ROOT,NODE,LQ,JQ,DLOG,SRAT,
     &VBAR(0),APHI(0),APHID(0),NRAT,HRAT,RRAT(0),DRAT(0),LCR)
	DO IRAT=0,NRAT
	APHIL(IRAT,ILEV)=APHI(IRAT)
	ENDDO
C  EVALUATE SLATER INTERGALS
	DO L2=0,2*LQ,2                          !!! over l2
	DO IRAT=0,NRAT
	WORK1(IRAT)=APHI(IRAT)**2*RRAT(IRAT)**2*DRAT(IRAT)*PRAT(IRAT,L2)
	ENDDO 
	CALL LIB_QD(HRAT,WORK1,WORK2,NRAT+1)
	PHI1(0)=0.0
	DO IRAT=1,NRAT
	PHI1(IRAT)=WORK2(IRAT)
	DO L1=1,L2+1
	PHI1(IRAT)=PHI1(IRAT)/RRAT(IRAT)
      ENDDO   
      ENDDO   
	WORK1(0)=0.0
	DO IRAT=1,NRAT
	WORK1(IRAT)=APHI(IRAT)**2*RRAT(IRAT)**2*DRAT(IRAT)
	DO L1=1,L2+1
	WORK1(IRAT)=WORK1(IRAT)/RRAT(IRAT)
      ENDDO   
      ENDDO   
	IF(L2.LE.1)THEN
	CALL LIB_QD(HRAT,WORK1,WORK2,NRAT+1)
	ELSE
	CALL LIB_QD(HRAT,WORK1(2),WORK2(2),NRAT-1)
	WORK2(1)=-(WORK1(1)+WORK1(2))*0.5D0*HRAT
	ENDIF
	PHI2(0)=0.0
	DO IRAT=1,NRAT
	PHI2(IRAT)=(WORK2(NRAT)-WORK2(IRAT))*PRAT(IRAT,L2)
      ENDDO   
	IF(L2.EQ.0)PHI2(0)=WORK2(NRAT)
	DO IRAT=0,NRAT                      !!! over radial mesh
	WORK1(IRAT)=(PHI1(IRAT)+PHI2(IRAT))*APHI(IRAT)**2*
     &RRAT(IRAT)**2*DRAT(IRAT)
      ENDDO                               !!! over radial mesh
	CALL LIB_QD(HRAT,WORK1(0),WORK2(0),NRAT+1)
	SLEV(L2/2,ILEV)=2.D0*WORK2(NRAT)
	ENDDO                               !!! over l2
	IF(LQ.EQ.0)GLEV(ILEV)=0.D0
	IF(LQ.EQ.1)GLEV(ILEV)=SLEV(1,ILEV)/5.D0
	IF(LQ.EQ.2)GLEV(ILEV)=(SLEV(1,ILEV)+SLEV(2,ILEV))/14.D0
	IF(LQ.EQ.3)GLEV(ILEV)=(286.D0*SLEV(1,ILEV)+195.D0*SLEV(2,ILEV)+
     &                       250.D0*SLEV(3,ILEV))/6435.D0
 1000 CONTINUE                            !!! over levels
	CALL LIB_TLEVCHAR(TLEV,THED) 
C  PRINT SLATER INTEGRALS
	WRITE(IUN,10030)THED
	DO ILEV=1,NLEVT
	NQ=LEVN(ILEV)
	LQ=LEVL(ILEV)
	JQ=LEVJ(ILEV)
	WRITE(IUN,10040)TLEV(NQ,LQ,JQ),(SLEV(L2/2,ILEV),L2=0,2*LQ,2)
	ENDDO
C  PRINT SLATER INTEGRALS
	WRITE(IUN,10050)THED
	DO ILEV=1,NLEVT
	NQ=LEVN(ILEV)
	LQ=LEVL(ILEV)
	JQ=LEVJ(ILEV)
	WRITE(IUN,10060)TLEV(NQ,LQ,JQ),SLEV(0,ILEV),GLEV(ILEV)
     &               ,SLEV(0,ILEV)*13.6D0,GLEV(ILEV)*13.6D0
	ENDDO
10010 FORMAT(1X,A19,'  # el.  Levels(Ry) ',A10,'; Zrat=',G12.5)
10020 FORMAT(1X,A19,3X,I2,3X,G14.7)
10030 FORMAT(1X,A19,3X,
     & '  F0(Ry)       F2(Ry)       F4(Ry)       F6(Ry)')
10040 FORMAT(1X,A19,3X,G12.5,1X,G12.5,1X,G12.5,1X,G12.5)
10050 FORMAT(1X,A19,3X,
     &'  U (Ry)       J (Ry)      U (eV)       J (eV)')
10060 FORMAT(1X,A19,3X,G12.5,1X,G12.5,G12.5,1X,G12.5)
C CALCULATE OFF DIAGINAL MATRIX OF SLATER INTEGRALS
	DO 3000 ILEV=1,NLEVT
	NQI=LEVN(ILEV)
	LQI=LEVL(ILEV)
	JQI=LEVJ(ILEV)
	DO 2000 JLEV=1,NLEVT
	NQJ=LEVN(JLEV)
	LQJ=LEVL(JLEV)
	JQJ=LEVJ(JLEV)
	DO L2=0,6,2
	SLATU(L2/2,JLEV,ILEV)=0.D0
	SLATG(L2/2,JLEV,ILEV)=0.D0
	ENDDO
C BARE SLATER INTEGRALS
	DO L2=ABS(LQI-LQJ),LQI+LQJ,2                !!! over l2
	DO IRAT=0,NRAT
	WORK1(IRAT)=APHIL(IRAT,JLEV)**2*RRAT(IRAT)**2
     &                               *DRAT(IRAT)*PRAT(IRAT,L2)
	ENDDO 
	CALL LIB_QD(HRAT,WORK1,WORK2,NRAT+1)
	PHI1(0)=0.0
	DO IRAT=1,NRAT
	PHI1(IRAT)=WORK2(IRAT)
	DO L1=1,L2+1
	PHI1(IRAT)=PHI1(IRAT)/RRAT(IRAT)
      ENDDO   
      ENDDO   
	WORK1(0)=0.0
	DO IRAT=1,NRAT
	WORK1(IRAT)=APHIL(IRAT,JLEV)**2*RRAT(IRAT)**2*DRAT(IRAT)
	DO L1=1,L2+1
	WORK1(IRAT)=WORK1(IRAT)/RRAT(IRAT)
      ENDDO   
      ENDDO   
	IF(L2.LE.1)THEN
	CALL LIB_QD(HRAT,WORK1,WORK2,NRAT+1)
	ELSE
	CALL LIB_QD(HRAT,WORK1(2),WORK2(2),NRAT-1)
	WORK2(1)=-(WORK1(1)+WORK1(2))*0.5D0*HRAT
	ENDIF
	PHI2(0)=0.0
	DO IRAT=1,NRAT
	PHI2(IRAT)=(WORK2(NRAT)-WORK2(IRAT))*PRAT(IRAT,L2)
      ENDDO   
	IF(L2.EQ.0)PHI2(0)=WORK2(NRAT)
	DO IRAT=0,NRAT                      !!! over radial mesh
	WORK1(IRAT)=(PHI1(IRAT)+PHI2(IRAT))*APHIL(IRAT,ILEV)**2*
     &RRAT(IRAT)**2*DRAT(IRAT)
      ENDDO                               !!! over radial mesh
	CALL LIB_QD(HRAT,WORK1(0),WORK2(0),NRAT+1)
	SLATU(L2/2,JLEV,ILEV)=2.D0*WORK2(NRAT)
	ENDDO                               !!! over l2
C EXCHANGE SLATER INTEGRALS
	DO L2=ABS(LQI-LQJ),LQI+LQJ,2                !!! over l2
	DO IRAT=0,NRAT
	WORK1(IRAT)=APHIL(IRAT,JLEV)*APHIL(IRAT,ILEV)*
     &            RRAT(IRAT)**2*DRAT(IRAT)*PRAT(IRAT,L2)
	ENDDO 
	CALL LIB_QD(HRAT,WORK1,WORK2,NRAT+1)
	PHI1(0)=0.0
	DO IRAT=1,NRAT
	PHI1(IRAT)=WORK2(IRAT)
	DO L1=1,L2+1
	PHI1(IRAT)=PHI1(IRAT)/RRAT(IRAT)
      ENDDO   
      ENDDO   
	WORK1(0)=0.0
	DO IRAT=1,NRAT
	WORK1(IRAT)=APHIL(IRAT,JLEV)*APHIL(IRAT,ILEV)*
     &            RRAT(IRAT)**2*DRAT(IRAT)
	DO L1=1,L2+1
	WORK1(IRAT)=WORK1(IRAT)/RRAT(IRAT)
      ENDDO   
      ENDDO   
	IF(L2.LE.1)THEN
	CALL LIB_QD(HRAT,WORK1,WORK2,NRAT+1)
	ELSE
	CALL LIB_QD(HRAT,WORK1(2),WORK2(2),NRAT-1)
	WORK2(1)=-(WORK1(1)+WORK1(2))*0.5D0*HRAT
	ENDIF
	PHI2(0)=0.0
	DO IRAT=1,NRAT
	PHI2(IRAT)=(WORK2(NRAT)-WORK2(IRAT))*PRAT(IRAT,L2)
      ENDDO   
	IF(L2.EQ.0)PHI2(0)=WORK2(NRAT)
	DO IRAT=0,NRAT                      !!! over radial mesh
	WORK1(IRAT)=(PHI1(IRAT)+PHI2(IRAT))*APHIL(IRAT,JLEV)*
     &APHIL(IRAT,ILEV)*RRAT(IRAT)**2*DRAT(IRAT)
      ENDDO                               !!! over radial mesh
	CALL LIB_QD(HRAT,WORK1(0),WORK2(0),NRAT+1)
	SLATG(L2/2,JLEV,ILEV)=2.D0*WORK2(NRAT)
	ENDDO                               !!! over l2
 2000	CONTINUE                            !!! over levels
 3000	CONTINUE                            !!! over levels
C PRINT OFF DIAGONAL INTEGRALS MATRIX
	DO ILEV=1,NLEVT
	NQI=LEVN(ILEV)
	LQI=LEVL(ILEV)
	JQI=LEVJ(ILEV)
	IF(ELEV(ILEV).LT.-3.D0)CYCLE
	DO JLEV=1,NLEVT
	NQJ=LEVN(JLEV)
	LQJ=LEVL(JLEV)
	JQJ=LEVJ(JLEV)
	IF(ELEV(JLEV).LT.-3.D0)CYCLE
	WRITE(IUN,10110)TLEV(NQI,LQI,JQI),TLEV(NQJ,LQJ,JQJ)
	WRITE(IUN,10120)(SLATU(L2/2,JLEV,ILEV),L2=0,6,2)
	WRITE(IUN,10130)(SLATG(L2/2,JLEV,ILEV),L2=0,6,2)
	ENDDO
	ENDDO
10110	FORMAT(1X,'Slater integrals between ',A19,' and ',A19)
10120	FORMAT(1X,'Fu(Ry)==',G12.5,1X,G12.5,1X,G12.5,1X,G12.5)
10130	FORMAT(1X,'Fj(Ry)==',G12.5,1X,G12.5,1X,G12.5,1X,G12.5)
C MEMORY DEALLOCATIONS
	DEALLOCATE(VBAR,APHI,APHIL,APHID,WORK1,WORK2)
	DEALLOCATE(PHI1,PHI2,SLATU,SLATG)
	END


