	SUBROUTINE RAT_STORAGE         
************************************************************
*  <STORAGE> checks file storage.                          *
************************************************************
C SET EXTERNAL CONNECTIONS
	USE COM_LABELS    ,ONLY: PATHSCRT                                 !!! from setup
      USE COM_UNIT      ,ONLY: IUT,IUR,IUN                              !!! from setup
	USE COM_CHANNELS  ,ONLY: IUINP,IUOUT                              !!! from setup
C FILE NAMES
      USE COM_LMTINP    ,ONLY: PROJECT,INPINFO,RUNMODE                  !!! from init
      USE COM_LMTOUT    ,ONLY: OUTFILE,SCRFILE,ISCR1MIN,ISCR1MAX,ICOUT  !!! from storage
	USE COM_EXTENS    ,ONLY: EXTNOUT,EXTNSCR,LENEXTN                  !!! from setup
      USE COM_RATOUT
	USE COM_RATEXT
C SET LOCAL VARIBLES
	IMPLICIT REAL*8 (A-H,O-Z)
	CHARACTER UN(100)*2,INF*130,RUN*130,RS*10
      LOGICAL EXIST,COMPUTE,PRESENT,USE
	DATA PI/3.141592653589793D0/                             
C CHANNEL ABBREVIATIONS
	DO ICHN=1,99
      IF(ICHN.LE.9)WRITE(RS,FMT='(I1)')ICHN
      IF(ICHN.GT.9)WRITE(RS,FMT='(I2)')ICHN
      IF(ICHN.GT.99)
     &CALL FULLSTOP('<STORAGE>:: ICHN>99 NOT ASSUMED')
      NRS=INDEX(RS,' ')
      IF(ICHN.LE.9)RS='0'//RS(:NRS-1)
      IF(ICHN.GT.9)RS=RS(:NRS-1)
      NRS=INDEX(RS,' ')
	UN(ICHN)=RS(:NRS-1)
	ENDDO
C INPUT/OUTPUT
	INF=INPINFO
	RUN=RUNMODE
C ***************************************************************
C SELF-CONSISTENT DENSITY
      CALL FIND_LBLANK(PROJECT,130,NBP)
      CALL FIND_LBLANK(EXTNRSC,60,NBE)
	RSCFILE=PROJECT(:NBP)//'.'//EXTNRSC(:NBE)
	CALL LIB_RMBLANK(RSCFILE,130)
      CALL SUBSTR_IN_STR(PRESENT,RUN,130,EXTNRSC,LENEXTN)
      COMPUTE=PRESENT
	IF(     COMPUTE)ICRSC=2 !!! store 
	IF(.NOT.COMPUTE)ICRSC=0 !!! do not store
	INQUIRE(FILE=RSCFILE,EXIST=EXIST)
	IF(EXIST.AND.ICRSC.EQ.2)THEN
	OPEN(UNIT=IUINP,FILE=RSCFILE,FORM='FORMATTED',STATUS='OLD')
	CALL FIND_LBLANK(RSCFILE,130,NA)
	WRITE(IUT,*)RSCFILE(:NA),' DELETED !'
	CLOSE(UNIT=IUINP,STATUS='DELETE')
	ENDIF
C ***************************************************************
C MANY BODY STATES FOR ATOMIC SHELL
      CALL FIND_LBLANK(PROJECT,130,NBP)
      CALL FIND_LBLANK(EXTNSHL,60,NBE)
	SHLFILE=PROJECT(:NBP)//'.'//EXTNSHL(:NBE)
	CALL LIB_RMBLANK(SHLFILE,130)
      CALL SUBSTR_IN_STR(PRESENT,RUN,130,EXTNSHL,LENEXTN)
      COMPUTE=PRESENT
      CALL SUBSTR_IN_STR(PRESENT,INF,130,EXTNSHL,LENEXTN)
	USE=PRESENT
	IF((.NOT.COMPUTE).AND.(.NOT.USE))ICSHL=0 !!! do not store
	IF((     COMPUTE).AND.(.NOT.USE))ICSHL=1 !!! store 
	IF((.NOT.COMPUTE).AND.(     USE))ICSHL=2 !!! use mode
	IF(COMPUTE.AND.USE)CALL FULLSTOP('Wrong mode for ShlFile')
	INQUIRE(FILE=SHLFILE,EXIST=EXIST)
	IF(.NOT.EXIST.AND.USE)CALL FULLSTOP('ShlFile not found!')
	IF(EXIST.AND.COMPUTE)THEN
	OPEN(UNIT=IUINP,FILE=SHLFILE,FORM='FORMATTED',STATUS='OLD')
	CALL FIND_LBLANK(SHLFILE,130,NA)
	WRITE(IUT,*)SHLFILE(:NA),' DELETED !'
	CLOSE(UNIT=IUINP,STATUS='DELETE')
	ENDIF
C ***************************************************************
C ATOMIC DENSITY OF MANY BODY STATES
      CALL FIND_LBLANK(PROJECT,130,NBP)
      CALL FIND_LBLANK(EXTNADS,60,NBE)
	ADSFILE=PROJECT(:NBP)//'.'//EXTNADS(:NBE)
	CALL LIB_RMBLANK(ADSFILE,130)
      CALL SUBSTR_IN_STR(PRESENT,RUN,130,EXTNADS,LENEXTN)
      COMPUTE=PRESENT
	IF(     COMPUTE)ICADS=2 !!! store 
	IF(.NOT.COMPUTE)ICADS=0 !!! do not store
	INQUIRE(FILE=ADSFILE,EXIST=EXIST)
	IF(ICADS.GT.0)CALL RAT_GETADS ! read parameters
C ***************************************************************
C MANY BODY STATES FOR CLUSTER
      CALL FIND_LBLANK(PROJECT,130,NBP)
      CALL FIND_LBLANK(EXTNCLS,60,NBE)
	CLSFILE=PROJECT(:NBP)//'.'//EXTNCLS(:NBE)
	CALL LIB_RMBLANK(CLSFILE,130)
      CALL SUBSTR_IN_STR(PRESENT,RUN,130,EXTNCLS,LENEXTN)
      COMPUTE=PRESENT
      CALL SUBSTR_IN_STR(PRESENT,INF,130,EXTNCLS,LENEXTN)
	USE=PRESENT
	IF((.NOT.COMPUTE).AND.(.NOT.USE))ICCLS=0 !!! do not store
	IF((     COMPUTE).AND.(.NOT.USE))ICCLS=1 !!! store 
	IF((.NOT.COMPUTE).AND.(     USE))ICCLS=2 !!! use mode
	IF(COMPUTE.AND.USE)CALL FULLSTOP('Wrong mode for ClsFile')
	INQUIRE(FILE=CLSFILE,EXIST=EXIST)
	IF(.NOT.EXIST.AND.USE)CALL FULLSTOP('ClsFile not found!')
	IF(EXIST.AND.COMPUTE)THEN
	OPEN(UNIT=IUINP,FILE=CLSFILE,FORM='FORMATTED',STATUS='OLD')
	CALL FIND_LBLANK(CLSFILE,130,NA)
	WRITE(IUT,*)CLSFILE(:NA),' DELETED !'
	CLOSE(UNIT=IUINP,STATUS='DELETE')
	ENDIF
C ***************************************************************
C GREEN FUNCTION
      CALL FIND_LBLANK(PROJECT,130,NBP)
      CALL FIND_LBLANK(EXTNGRF,60,NBE)
	GRFFILE=PROJECT(:NBP)//'.'//EXTNGRF(:NBE)
	CALL LIB_RMBLANK(GRFFILE,130)
      CALL SUBSTR_IN_STR(PRESENT,RUN,130,EXTNGRF,LENEXTN)
      COMPUTE=PRESENT
	IF(     COMPUTE)ICGRF=2 !!! store 
	IF(.NOT.COMPUTE)ICGRF=0 !!! do not store
	INQUIRE(FILE=GRFFILE,EXIST=EXIST)
	IF(ICGRF.GT.0)CALL RAT_GETGRF ! read parameters
C ***************************************************************
C OUTPUT FILE
      CALL FIND_LBLANK(PROJECT,130,NBP)
      CALL FIND_LBLANK(EXTNOUT,60,NBE)
	OUTFILE=PROJECT(:NBP)//'.'//EXTNOUT(:NBE)
	CALL LIB_RMBLANK(OUTFILE,130)
      CALL SUBSTR_IN_STR(PRESENT,RUN,130,EXTNOUT,LENEXTN)
      COMPUTE=PRESENT
      IF(     COMPUTE)ICOUT=2 !!! store output inforamtion
      IF(.NOT.COMPUTE)ICOUT=0 !!! print output information
      INQUIRE(FILE=OUTFILE,EXIST=EXIST)
      IF(EXIST.AND.ICOUT.EQ.1)THEN
	WRITE(IUT,*)'Terminated in <STORAGE>::' 
	WRITE(IUT,*)'Output OUTFILE ',OUTFILE
	WRITE(IUT,*)'should not exist for this mode.'
      ELSEIF(EXIST.AND.ICOUT.EQ.2)THEN
C delete it
      OPEN(UNIT=IUINP,FILE=OUTFILE,FORM='UNFORMATTED',
     &STATUS='OLD')
	CALL FIND_LBLANK(OUTFILE,130,NA)
      WRITE(IUT,*)OUTFILE(:NA),' DELETED !'
      CLOSE(UNIT=IUINP,STATUS='DELETE')
      ENDIF
      IF(ICOUT.NE.0)THEN
      IUN=IUOUT
      OPEN(UNIT=IUOUT,FILE=OUTFILE,STATUS='NEW')
      ELSE
      IUN=IUT
      ENDIF
C ***************************************************************
C SET SCRATCH STORAGE FILENAMES
      CALL FIND_LBLANK(PROJECT,130,NBP)
      CALL FIND_LBLANK(EXTNSCR,60,NBE)
	ISCR1MIN=1
	ISCR1MAX=99
	ALLOCATE(SCRFILE(1:99))
	SCRFILE(1)=PROJECT(:NBP)//'.'//EXTNSCR(:NBE)
	CALL LIB_RMBLANK(SCRFILE(1),130)
	CALL FIND_LBLANK(SCRFILE(1),130,NA)
	CALL FIND_LBLANK(PATHSCRT,130,NS)
      DO I=2,99
      SCRFILE(I)=PATHSCRT(:NS)//SCRFILE(1)(:NA)//UN(I)
      ENDDO
      SCRFILE(1)=PATHSCRT(:NS)//SCRFILE(1)(:NA)//UN(1)
      DO I=1,99
      INQUIRE(FILE=SCRFILE(I),EXIST=EXIST)
      IF(EXIST)THEN
      OPEN(UNIT=IUINP,FILE=SCRFILE(I),FORM='UNFORMATTED',STATUS='OLD')
	CALL FIND_LBLANK(SCRFILE(I),130,NA)
      WRITE(IUT,*)SCRFILE(I)(:NA)//' DELETED !'
      CLOSE(UNIT=IUINP,STATUS='DELETE')
      ENDIF
      ENDDO
	END SUBROUTINE RAT_STORAGE
