	SUBROUTINE RAT_VCOUL(INUC)
************************************************************
*  The calculation of the Coulomb potential                *
************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_RATSCF ,ONLY: ZRAT,RATPOT,RATRHO               !!! from potfull
      USE COM_RATMESH,ONLY: NRAT,HRAT,RRAT,DRAT,WRAT         !!! from radmesh
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8, ALLOCATABLE :: VC1(:)
	REAL*8, ALLOCATABLE :: VC2(:)
	REAL*8, ALLOCATABLE :: WORK1(:)
	REAL*8, ALLOCATABLE :: WORK2(:)
	DATA PI/3.141592653589793D0/
      CALL ABORTNOW()
	SQPI4=2.D0*SQRT(PI)
C MEMORY ALLOCATIONS FOR SCRATCH ARRAYS
	ALLOCATE(VC1(0:NRATMEM))
	ALLOCATE(VC2(0:NRATMEM))
	ALLOCATE(WORK1(0:NRATMEM))
	ALLOCATE(WORK2(0:NRATMEM))
C COULOMB CONTRIBUTION 
	DO IRAT=0,NRAT                      !!! over radial mesh
	RATPOT(IRAT)=0.D0
      ENDDO                               !!! over radial mesh
C SOLUTION OF THE POISSON EQUATION
	DO IRAT=0,NRAT
	WORK1(IRAT)=RATRHO(IRAT)*WRAT(IRAT)
	ENDDO 
	CALL LIB_QD(HRAT,WORK1,WORK2,NRAT+1)
	VC1(0)=0.0
	DO IRAT=1,NRAT
	VC1(IRAT)=WORK2(IRAT)/RRAT(IRAT)
      ENDDO   
	WORK1(0)=0.0
	DO IRAT=1,NRAT
	WORK1(IRAT)=RATRHO(IRAT)*WRAT(IRAT)/RRAT(IRAT)
      ENDDO   
	CALL LIB_QD(HRAT,WORK1(0),WORK2(0),NRAT+1)
	VC2(0)=0.0
	DO IRAT=1,NRAT
	VC2(IRAT)=(WORK2(NRAT)-WORK2(IRAT))
      ENDDO   
	VC2(0)=WORK2(NRAT)
C COULOMB POTENTIAL READY 
	E2=2.D0
	DO IRAT=0,NRAT                      !!! over radial mesh
	RATPOT(IRAT)=RATPOT(IRAT)+E2*(VC1(IRAT)+VC2(IRAT))
      ENDDO                               !!! over radial mesh
C ADD NUCLEAR POTENTIAL
	IF(INUC.EQ.1)THEN
      DO IRAT=1,NRAT                      !!! over radial mesh
      RATPOT(IRAT)=RATPOT(IRAT)-2.D0*ZRAT/RRAT(IRAT)
      ENDDO                               !!! over radial mesh
      RATPOT(0)=RATPOT(1)
	ENDIF
C MEMORY DEALLOCATIONS FOR SCRATCH ARRAYS
	DEALLOCATE(VC1)
	DEALLOCATE(VC2)
	DEALLOCATE(WORK1)
	DEALLOCATE(WORK2)
	END
