	SUBROUTINE RAT_VEXCH(KEY)
************************************************************
*  The calculation of the exchange-correlation potential   *
*  Generalized gradient corrections after Perdew  added.   *
*  Key=1 - potential, =2 - energy density                  *
************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                          !!! from setup
      USE COM_CONTROL ,ONLY: ILDA,IGGA,ILSD                   !!! from readini
      USE COM_RATSCF  ,ONLY: ZRAT,SRAT,RATPOT,RATRHO          !!! from readini
      USE COM_RATMESH ,ONLY: NRAT,HRAT,RRAT,DRAT,WRAT         !!! from radmesh
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8, ALLOCATABLE :: DRODR(:,:)
	COMPLEX*16 GR1UP(-1:1),GR2UP(-1:1,-1:1),D0M(-1:1)
     &    ,GR1DN(-1:1),GR2DN(-1:1,-1:1),XC(2),DXC(2)
     &    ,GR1RHO(-1:1),GR1MAG(-1:1,-1:1),GR2RHO(-1:1,-1:1)
     &    ,GR2MAG(-1:1,-1:1,-1:1),GR1MOD(-1:1),GR2MOD(-1:1,-1:1)
	DATA PI/3.141592653589793D0/
      CALL ABORTNOW()
	SQPI4=2.D0*SQRT(PI)
C MEMORY ALLOCATIONS FOR SCRATCH ARRAYS
	ALLOCATE(DRODR(0:NRATMEM,2))
C Set gradients to zero
	DO NY=-1,1
	GR1UP(NY)=(0.D0,0.D0)
	GR1DN(NY)=(0.D0,0.D0)
	DO NY1=-1,1
	GR2UP(NY,NY1)=(0.D0,0.D0)
	GR2DN(NY,NY1)=(0.D0,0.D0)
	ENDDO
	ENDDO
	ALRUP=0.D0
	ALRDN=0.D0
C ***** COMPUTE DENSITY GRADIENTS FOR GGA ****
C Compute spherical density gradients
      CALL LIB_DERIV1(RATRHO(0),DRODR(0,1),NRAT,HRAT,RRAT,DRAT,SRAT)
      CALL LIB_DERIV1(DRODR(0,1),DRODR(0,2),NRAT,HRAT,RRAT,DRAT,SRAT)
      DO 100 IRAT=0,NRAT           !!! over irat
	ARHO=RATRHO(IRAT)
	ZMAG=0.D0
	AMAG=SQRT(ZMAG*ZMAG)
	D0M( 0)=(0.D0,0.D0)
	D0M(-1)=(0.D0,0.D0)
	D0M(+1)=(0.D0,0.D0)
C Account for spin densities
	IF(ILSD.EQ.1)THEN
	ROUP=0.5D0*(ARHO+AMAG)
	RODN=0.5D0*(ARHO-AMAG)
C Abandon spin polarization if desired
	ELSEIF(ILSD.EQ.0)THEN
	ROUP=0.5D0*ARHO
	RODN=0.5D0*ARHO
	ENDIF
C Gradients from spherical densities, let x=y=z=r/sqrt(3)
	IF(IGGA.NE.0)THEN
	DO IA=-1,1
	GR1RHO(IA)=DRODR(IRAT,1)/SQRT(3.D0)
	GR1MAG(IA, 0)=(0.D0,0.D0)
	GR1MAG(IA,-1)=(0.D0,0.D0)
	GR1MAG(IA,+1)=(0.D0,0.D0)
	ENDDO
	DO IA=-1,1
	DO IB=-1,1
	IF(IA.EQ.IB)SD=+2.D0
	IF(IA.NE.IB)SD=-1.D0
	IF(IRAT.EQ.0)RR=RRAT(1)
	IF(IRAT.NE.0)RR=RRAT(IRAT)
	GR2RHO(IA,IB)=(DRODR(IRAT,1)/RR*SD+
     &               DRODR(IRAT,2))/3.D0
	GR2MAG(IA,IB, 0)=(0.D0,0.D0)
	GR2MAG(IA,IB,-1)=(0.D0,0.D0)
	GR2MAG(IA,IB,+1)=(0.D0,0.D0)
	ENDDO
	ENDDO
C
	IF(ABS(AMAG).GT.1.D-14)RMAG=1.D0/AMAG
	IF(ABS(AMAG).LE.1.D-14)RMAG=0.D0
	DO IA=-1,1
	GR1MOD(IA)=(0.D0,0.D0)
	ENDDO
	DO IA=-1,1
	DO IB=-1,1
	GR2MOD(IA,IB)=(0.D0,0.D0)
	ENDDO
	ENDDO
C
	ALRUP=0.D0
	ALRDN=0.D0
	DO IA=-1,1
	IF(ILSD.EQ.1)THEN
	GR1UP(IA)=0.5D0*(GR1RHO(IA)+GR1MOD(IA))
	GR1DN(IA)=0.5D0*(GR1RHO(IA)-GR1MOD(IA))
	ELSEIF(ILSD.EQ.0)THEN
	GR1UP(IA)=0.5D0*GR1RHO(IA)
	GR1DN(IA)=0.5D0*GR1RHO(IA)
	ENDIF
	DO IB=-1,1
	IF(ILSD.EQ.1)THEN
	GR2UP(IA,IB)=0.5D0*(GR2RHO(IA,IB)+GR2MOD(IA,IB))
	GR2DN(IA,IB)=0.5D0*(GR2RHO(IA,IB)-GR2MOD(IA,IB))
	ELSEIF(ILSD.EQ.0)THEN
	GR2UP(IA,IB)=0.5D0*GR2RHO(IA,IB)
	GR2DN(IA,IB)=0.5D0*GR2RHO(IA,IB)
	ENDIF
	ENDDO
	ALRUP=ALRUP+GR2UP(IA,IA)
	ALRDN=ALRDN+GR2DN(IA,IA)
	ENDDO
	ENDIF
C SET EXCHANGE-CORRELATION
	CALL POT_EXCVXC(ROUP,RODN,GR1UP,GR1DN,GR2UP,GR2DN,ALRUP,ALRDN,
     &     ILDA,IGGA,KEY,1,EXCUP,EXCDN,VXCUP,VXCDN)
	    IF(KEY.EQ.1.AND.ILSD.EQ.1)THEN
	XC(1)=VXCUP
	XC(2)=VXCDN
	ELSEIF(KEY.EQ.1.AND.ILSD.EQ.0)THEN
	XC(1)=0.5D0*(VXCUP+VXCDN)
	XC(2)=0.5D0*(VXCUP+VXCDN)
	ELSEIF(KEY.EQ.2.AND.ILSD.EQ.1)THEN
	XC(1)=EXCUP
	XC(2)=EXCDN
	ELSEIF(KEY.EQ.2.AND.ILSD.EQ.0)THEN
	XC(1)=0.5D0*(EXCUP+EXCDN)
	XC(2)=0.5D0*(EXCUP+EXCDN)
	ENDIF
	RATPOT(IRAT)=RATPOT(IRAT)+XC(1)
 100  CONTINUE                            !!! over radial mesh
C MEMORY DEALLOCATIONS
	DEALLOCATE(DRODR)
	END
