	SUBROUTINE RHO_EMADER
**********************************************************
*  Finds derivative of energy of magnetic anisotropy     *
**********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                          !!! from setup
      USE COM_CONTROL ,ONLY: LMTO,IASA,NPFR                   !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS          !!! from readini
     &                      ,IS,ILST,ILSB,ILSV,LRTV
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP,EK                !!! from readini
      USE COM_LATPAR  ,ONLY: PAR,OMEGAC                       !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN,IATS,ISTS            !!! from readini
      USE COM_SPHERE  ,ONLY: ZNUC,SMT                         !!! from readini
      USE COM_SYMMLM  ,ONLY: SYM,LMSYM                        !!! from symlmm
      USE COM_POTDAT  ,ONLY: POT,POTSPH,POTRWF                !!! from potfull
      USE COM_ORBPAR  ,ONLY: SPARHH,SPARJH,SPARHJ,SPARJJ      !!! from orbpar
      USE COM_INPPAR  ,ONLY: ENY,DNY                          !!! from readini
      USE COM_LMTPAR  ,ONLY: GAM,AAH,BBH,AAJ,BBJ              !!! from potpar
      USE COM_HAMPAR  ,ONLY: ATOSHH=>HPARHH                   !!! from tospar
     &                      ,ATOSJH=>HPARJH
     &                      ,ATOSHJ=>HPARHJ
     &                      ,ATOSJJ=>HPARJJ
      USE COM_RADMESH ,ONLY: NRAD,H,R,DR,WEIGHT,RL            !!! from radmesh
      USE COM_GAUNT   ,ONLY: C                                !!! from gdata
      USE COM_LABELS  ,ONLY: TXTAT,TXTEL,TXTSP                !!! from readini
	USE COM_LMTOUT  ,ONLY: SCRFILE                          !!! from readini
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT                      !!! from setup
      USE COM_CHANNELS,ONLY: IUTOS                            !!! from readini
      USE COM_MASHDEP ,ONLY: NVAL,LENREL,LENCMP               !!! from readini
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER, INTRINSIC :: SIZE
	REAL*8, ALLOCATABLE :: SLM(:,:,:)
	COMPLEX*16, ALLOCATABLE :: WORK1(:)
	COMPLEX*16, ALLOCATABLE :: WORK2(:)
	COMPLEX*16 CGNT,EMA(2,2,2,2),ESO
	LOGICAL LOG1,LOG
	DATA PI/3.141592653589793D0/
      CALL ABORTNOW()
	IF(NORBS.NE.2)RETURN
C MEMORY ALLOCATIONS
	ALLOCATE(WORK1(0:NRADMEM))
	ALLOCATE(WORK2(0:NRADMEM))
	ALLOCATE(SLM(LIMTMEM,2,2))
C SET <Ylm|s*l|Ylm>/2 MATRIX ELEMENT
	DO L=0,LMAXTMEM
	DO M=-L,L
	LM=L*(L+1)+M+1
	SLM(LM,1,1)=0.5D0*DBLE(+M)
	SLM(LM,1,2)=0.5D0*SQRT(DBLE((L+M)*(L-M+1)))
	SLM(LM,2,1)=0.5D0*SQRT(DBLE((L-M)*(L+M+1)))
	SLM(LM,2,2)=0.5D0*DBLE(-M)
	ENDDO
	ENDDO
C START CODE
	SQPI4=2.D0*SQRT(PI)
	DO ISPIN1=1,NSPIN
	DO JSPIN1=1,NSPIN
	DO JSPIN =1,NSPIN
	DO ISPIN =1,NSPIN
	EMA(ISPIN1,JSPIN1,JSPIN,ISPIN)=(0.D0,0.D0)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C DO GLOBALLY OVER ATOMS AND PANELS
	DO 4000 IPAN=1,NPAN                    !!! over panels
	NSHIFT=0
	DO JPAN=1,NPAN
	IF(JPAN.LT.IPAN)
     &NSHIFT=NSHIFT+NKAP(JPAN)**2*NATOM*NSPIN*NORBS
      ENDDO
	DO 3000 IATOM=1,NATOM                  !!! over atoms
	ISORT=IS(IATOM)
	DO 2000 IORBS=1,NORBS                  !!! over spins
	DO 1000 IUPDN=1,NSPIN                  !!! over spins
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
	DO IKAP1=1,NKAP(IPAN)                  !!! over energies
	DO IKAP=1,NKAP(IPAN)                   !!! over energies
	IREC=IKAP1+NKAP(IPAN)*(IKAP-1)+NKAP(IPAN)**2*(IATOM-1)+
     &NKAP(IPAN)**2*NATOM*(IUPDN-1)+NKAP(IPAN)**2*NATOM*NSPIN*(IORBS-1)+
     &NSHIFT
	READ(IUTOS,REC=IREC)
     &((ATOSHH(L1M1,LM,IATOM),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((ATOSJH(L1M1,LM,IATOM),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((ATOSHJ(L1M1,LM,IATOM),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &((ATOSJJ(L1M1,LM,IATOM),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2)
	DO L=0,ILST(ISORT)                     !!! over l
	LOG1=.FALSE.
	IF(LTPAN(L,IATOM,IKAP1,IPAN))LOG1=.TRUE.
	LOG=.FALSE.
	IF(LTPAN(L,IATOM,IKAP ,IPAN))LOG =.TRUE.
	DO JORBS=1,NORBS                       !!! over jorbs
	DO JUPDN=1,NSPIN                       !!! over jupdn
	IF(JORBS.EQ.1)THEN
	JSPIN1=JUPDN
	JSPIN =JUPDN
	ELSEIF(JORBS.EQ.2)THEN
	JSPIN1=JUPDN
	JSPIN =NSPIN+1-JUPDN
	ENDIF
	ISIGN=JSPIN1-JSPIN
	DO M1=-L,L                             !!! over m1
	LM1=L*(L+1)+M1+1
	DO M=-L,L                              !!! over m
	LM=L*(L+1)+M+1
	IF(M1.NE.M+ISIGN)CYCLE
	DO IRAD=0,NRAD(ISORT)                  !!! over radial mesh
	IF(LOG1.AND.LOG)
     &EMA(ISPIN1,JSPIN1,JSPIN,ISPIN)=
     &EMA(ISPIN1,JSPIN1,JSPIN,ISPIN)+
     &SPARHH(IKAP1,IKAP,L,ISORT,JSPIN1,JSPIN,IPAN)*
     &ATOSHH(LM1,LM,IATOM)*SLM(LM,JSPIN1,JSPIN)
	IF(LOG1)
     &EMA(ISPIN1,JSPIN1,JSPIN,ISPIN)=
     &EMA(ISPIN1,JSPIN1,JSPIN,ISPIN)-
     &SPARHJ(IKAP1,IKAP,L,ISORT,JSPIN1,JSPIN,IPAN)*
     &ATOSHJ(LM1,LM,IATOM)*SLM(LM,JSPIN1,JSPIN)
	IF(LOG)
     &EMA(ISPIN1,JSPIN1,JSPIN,ISPIN)=
     &EMA(ISPIN1,JSPIN1,JSPIN,ISPIN)-
     &SPARJH(IKAP1,IKAP,L,ISORT,JSPIN1,JSPIN,IPAN)*
     &ATOSJH(LM1,LM,IATOM)*SLM(LM,JSPIN1,JSPIN)
      EMA(ISPIN1,JSPIN1,JSPIN,ISPIN)=
     &EMA(ISPIN1,JSPIN1,JSPIN,ISPIN)+
     &SPARJJ(IKAP1,IKAP,L,ISORT,JSPIN1,JSPIN,IPAN)*
     &ATOSJJ(LM1,LM,IATOM)*SLM(LM,JSPIN1,JSPIN)
      ENDDO                                  !!! over radial mesh
      ENDDO                                  !!! over m
      ENDDO                                  !!! over m1
      ENDDO                                  !!! over jupdn
      ENDDO                                  !!! over jorbs
      ENDDO                                  !!! over l
      ENDDO                                  !!! over energies
      ENDDO                                  !!! over energies
1000	CONTINUE                               !!! over iupdn
2000	CONTINUE                               !!! over iorbs
3000	CONTINUE                               !!! over atoms
4000	CONTINUE                               !!! over panes
C Transform EMA
	ESO=(0.D0,0.D0)
	DO ISPIN1=1,NSPIN
	DO ISPIN =1,NSPIN
	ESO=ESO+EMA(ISPIN1,ISPIN1,ISPIN,ISPIN)
	ENDDO
	ENDDO
C Print
	WRITE(IUN,10010)ESO
	WRITE(IUN,10030)EMA(1,1,1,1)
	WRITE(IUN,10040)EMA(2,2,2,2)
	WRITE(IUN,10050)EMA(1,1,2,2)
	WRITE(IUN,10060)EMA(2,2,1,1)
10010	FORMAT(1X,'SO-energy = (',G14.7,',',G14.7,')')
10030	FORMAT(1X,'up-up     = (',G14.7,',',G14.7,')')
10040	FORMAT(1X,'dn-dn     = (',G14.7,',',G14.7,')')
10050	FORMAT(1X,'up-dn     = (',G14.7,',',G14.7,')')
10060	FORMAT(1X,'dn-up     = (',G14.7,',',G14.7,')')
C MEMORY DEALLOCATIONS
      DEALLOCATE(WORK1,WORK2,SLM)
	END
