	SUBROUTINE RHO_MIXROB(ITER,KEY)
**************************************************************
*  Mixes charge densities according to the Broyden           *
*  prescription.                                             *
*  Last modified 01.11.96.                                   *
**************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
	USE COM_LMTMEM  
      USE COM_CONTROL ,ONLY: LMTO,IASA                        !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS,IS,ILSV  !!! from readini
	USE COM_SPHERE  ,ONLY: ZNUC,ZCOR,SMT,SWZ                !!! from readini
      USE COM_SYMMLM  ,ONLY: SYM,LMSYM                        !!! from symlmm
      USE COM_DENDAT  ,ONLY: RHO,RHOCOR,RHOPS                 !!! from rhofull
      USE COM_PLWMESH ,ONLY: NPLW,GPLW                        !!! from plwmesh
      USE COM_RADMESH ,ONLY: NRAD,H,R,DR,WEIGHT,RL            !!! from radmesh
	USE COM_MIXBROY ,ONLY: NBROY,LBROY,IBROY,MTER           !!! from mixrob
     &                      ,ADMIXB,ADMIXH,WMIX,WINP
      USE COM_LMTOUT  ,ONLY: SCRFILE                          !!! from readini
      USE COM_LABELS  ,ONLY: TXTAT,TXTEL,TXTSP                !!! from readini
	USE COM_CHANNELS,ONLY: IUBRO                            !!! from channels
      USE COM_MASHDEP ,ONLY: NVAL,LENCMP                      !!! from setup
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT                      !!! from setup
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER, INTRINSIC :: SIZE
	REAL*8, ALLOCATABLE :: WTER(:)
	REAL*8, ALLOCATABLE :: WRAD(:)
	REAL*8, ALLOCATABLE :: FNOM(:)
	COMPLEX*16, ALLOCATABLE :: QCH(:,:,:)
	COMPLEX*16, ALLOCATABLE :: BETA(:,:)
	COMPLEX*16, ALLOCATABLE :: CMAT(:,:)
	COMPLEX*16, ALLOCATABLE :: GAMA(:,:)
	COMPLEX*16, ALLOCATABLE :: WBRO(:)
	COMPLEX*16, ALLOCATABLE :: WRK1(:)
	COMPLEX*16, ALLOCATABLE :: WRK2(:)
	COMPLEX*16, ALLOCATABLE :: WORK1(:)
	COMPLEX*16, ALLOCATABLE :: WORK2(:)
	COMPLEX*16, ALLOCATABLE :: XRHO(:)
	COMPLEX*16, ALLOCATABLE :: XNEW(:)
	COMPLEX*16 AMTS(-1:1),AMTC(3)
      LOGICAL FIRST,RESET
	SAVE LBROY0,FIRST,RESET,WTER,WBRO,FNOM,BETA,CMAT,GAMA
      DATA PI/3.141592653589793D0/,FIRST/.TRUE./
      CALL ABORTNOW()
C SAVE SWITCH
      IF(FIRST)THEN
	ALLOCATE(WTER(0:NTERMEM))
	ALLOCATE(FNOM(NTERMEM))
	ALLOCATE(BETA(NTERMEM,NTERMEM))
	ALLOCATE(CMAT(NTERMEM,NTERMEM))
	ALLOCATE(GAMA(NTERMEM,NTERMEM))
	ALLOCATE(WMIX(NTERMEM,NTERMEM))
	ALLOCATE(WBRO(NTERMEM))
	ALLOCATE(WINP(NTERMEM))
      LBROY0=LBROY
      MTER=0
      RESET=.TRUE.
      ENDIF
      FIRST=.FALSE.
C DO NOT START BROYDEN, WAIT
	IF(ITER.LE.IBROY)THEN
	LBROY=-1
C SWITCH ON NOW
	ELSEIF(ITER.GT.IBROY)THEN
	LBROY=LBROY0
	ENDIF
	IF(LBROY.LT.0)RETURN
C SET ITERATION NUMBER
	IF(MTER.EQ.NBROY-1)RESET=.TRUE.
	IF(MTER.EQ.NBROY-1)
     &WRITE(IUT,*)'<MIXROB>:: MTER>NBROY, BROYDEN RESTARTED'
	IF(RESET)MTER=0
	IF(KEY.EQ.1.AND.MTER.NE.0)RETURN
	IF(KEY.EQ.2)MTER=MTER+1
C DEFINE MAXIMUM SIZE OF THE BROYDEN ARRAY
	ILEN=0
      DO IATOM=1,NATOM
      ISORT=IS(IATOM)
      DO L=0,ILSV(ISORT)
      DO M=-L,L
      LM=L*(L+1)+M+1
      IF(SYM(LM,IATOM).AND.L.LE.LBROY)
     &ILEN=ILEN+NSPIN*NORBS*(NRAD(ISORT)+1)
	ENDDO
	ENDDO
	ENDDO
	ILEN=ILEN+NSPIN*NORBS*(NPLW+1)
	NLEN=ILEN
	NLENMEM=NLEN
C MEMORY ALLOCATIONS
	ALLOCATE(QCH(NATOMMEM,NSPINMEM,NORBSMEM))
	ALLOCATE(WRAD(NLENMEM))
	ALLOCATE(WRK1(NLENMEM))
	ALLOCATE(WRK2(NLENMEM))
	ALLOCATE(WORK1(0:NRADMEM))
	ALLOCATE(WORK2(0:NRADMEM))
	ALLOCATE(XRHO(NLENMEM))
	ALLOCATE(XNEW(NLENMEM))
      SIZE_HERE=5.D0*DBLE(SIZE(WRAD)*LENCMP)/1024.D0**2
	CURMEM=CURMEM+SIZE_HERE
      IF(TOTMEM.LT.CURMEM)TXTMEM='<MIXROB> Subroutine'
      IF(TOTMEM.LT.CURMEM)TOTMEM=CURMEM
C *** SET MIXING ARRAY ***
C MT-PART
	ILEN=0
	DO IATOM=1,NATOM                    !!! over atoms
	ISORT=IS(IATOM)
      DO L=0,ILSV(ISORT)                  !!! over l
      DO M=-L,L                           !!! over m
      LM=L*(L+1)+M+1
      ISYM=LMSYM(LM,IATOM)
      SL=SMT(ISORT)**L
      IF(SYM(LM,IATOM).AND.L.LE.LBROY)THEN!!! for only non-zero components
C 1) Pack Charge Density into Array
	DO IRAD=0,NRAD(ISORT)
	ILEN=ILEN+1
	IF(ISYM.EQ.1)
     &XRHO(ILEN)=0.5D0*DBLE(NSPIN)*DCMPLX(DREAL(
     &RHO(IRAD,ISYM,IATOM,1,1)+RHO(IRAD,ISYM,IATOM,NSPIN,1)),0.D0)
	IF(ISYM.GT.1)
     &XRHO(ILEN)=0.5D0*DBLE(NSPIN)*(
     &RHO(IRAD,ISYM,IATOM,1,1)+RHO(IRAD,ISYM,IATOM,NSPIN,1))
	WRAD(ILEN)=1.D0
	ENDDO
C 2) Pack Magnetization into Array
	IF(NSPIN.EQ.2)THEN
	DO IRAD=0,NRAD(ISORT)
	ILEN=ILEN+1
	IF(ISYM.EQ.1)
     &XRHO(ILEN)=CMPLX(DREAL(RHO(IRAD,ISYM,IATOM,1,1)-
     &RHO(IRAD,ISYM,IATOM,NSPIN,1)),0.D0)
	IF(ISYM.GT.1)
     &XRHO(ILEN)=RHO(IRAD,ISYM,IATOM,1,1)-RHO(IRAD,ISYM,IATOM,NSPIN,1)
	WRAD(ILEN)=1.D0
	ENDDO
	ENDIF
C 3) Pack Transverse Magnetization into Array
	IF(NORBS.EQ.2)THEN
	DO IRAD=0,NRAD(ISORT)
	ILEN=ILEN+1
      XRHO(ILEN)=RHO(IRAD,ISYM,IATOM,1,NORBS)
	WRAD(ILEN)=1.D0
	ENDDO
	DO IRAD=0,NRAD(ISORT)
	ILEN=ILEN+1
      XRHO(ILEN)=RHO(IRAD,ISYM,IATOM,NSPIN,NORBS)
	WRAD(ILEN)=1.D0
	ENDDO
	ENDIF
	ENDIF                               !!! for only non-zero components
	ENDDO                               !!! over m
	ENDDO                               !!! over l
	ENDDO                               !!! over atoms
C *** SET MIXING ARRAY ***
C PLW-PART
C 1) Pack Density into Array
	DO IPLW=0,NPLW                      !!! over plane waves
	ILEN=ILEN+1
      XRHO(ILEN)=0.5D0*DBLE(NSPIN)*(
     &RHOPS(IPLW,1,1)+RHOPS(IPLW,NSPIN,1))
	WRAD(ILEN)=1.D0
	ENDDO                               !!! over plane waves
C 2) Pack Magnetization into Array
	IF(NSPIN.EQ.2)THEN
	DO IPLW=0,NPLW                      !!! over plane waves
	ILEN=ILEN+1
      XRHO(ILEN)=RHOPS(IPLW,1,1)-RHOPS(IPLW,NSPIN,1)
	WRAD(ILEN)=1.D0
	ENDDO                               !!! over plane waves
	ENDIF
C 3) Pack Transverse Magnetisation into Array
	IF(NORBS.EQ.2)THEN
	DO IPLW=0,NPLW                      !!! over plane waves
	ILEN=ILEN+1
      XRHO(ILEN)=RHOPS(IPLW,1,NORBS)
	WRAD(ILEN)=1.D0
	ENDDO                               !!! over plane waves
	DO IPLW=0,NPLW                      !!! over plane waves
	ILEN=ILEN+1
      XRHO(ILEN)=RHOPS(IPLW,NSPIN,NORBS)
	WRAD(ILEN)=1.D0
	ENDDO                               !!! over plane waves
	ENDIF
C SEND ARRAY TO BROYDEN
      CALL LIB_BROY6(XRHO,XNEW,WRAD,WRK1,WRK2,NLEN,MTER,ADMIXB,
     &WTER,WBRO,WINP,WMIX,FNOM,BETA,CMAT,GAMA,NTERMEM,NVAL,
     &IUBRO,SCRFILE(IUBRO),IERR)      
	IF(MTER.EQ.0)RESET=.FALSE.
	IF(MTER.EQ.0)GOTO1000
C CHECK IF CHARGE DENSITY OBTAINED IS OK
	ILEN=0
	NEGD=0
	DO IATOM=1,NATOM                    !!! over atoms
	ISORT=IS(IATOM)
      DO L=0,ILSV(ISORT)                  !!! over l
      DO M=-L,L                           !!! over m
      LM=L*(L+1)+M+1
      ISYM=LMSYM(LM,IATOM)
      SL=SMT(ISORT)**L
      IF(SYM(LM,IATOM).AND.L.LE.LBROY)THEN!!! for only non-zero components
	DO IRAD=0,NRAD(ISORT) 
	ILEN=ILEN+1
	IF(ISYM.EQ.1)THEN
	IF(DREAL(XNEW(ILEN)).LT.0.D0)NEGD=1
	ENDIF
	ENDDO
	IF(NSPIN.EQ.2)ILEN=ILEN+NRAD(ISORT)+1
	IF(NORBS.EQ.2)ILEN=ILEN+(NRAD(ISORT)+1)*2
	ENDIF                               !!! for only non-zero components
	ENDDO                               !!! over m
	ENDDO                               !!! over l
	ENDDO                               !!! over atoms
C Switch off mixing
	IF(NEGD.EQ.1)
     &WRITE(IUN,*)'<MIXROB>::CHARGE DENSITY IS NOT POSITIVE'
C	IF(NEGD.EQ.1)LBROY =-1
C	IF(NEGD.EQ.1)LBROY0=-1
C	IF(NEGD.EQ.1)WRITE(IUT,*)'<MIXROB>: BROYDEN  MIXING IS OFF' 
C	IF(NEGD.EQ.1)GOTO 100
C *** DEFINE NEW CHARGE DENSITY ***
C MT-PART
	ILEN=0
	DO IATOM=1,NATOM                    !!! over atoms
	ISORT=IS(IATOM)
      DO L=0,ILSV(ISORT)                  !!! over l
      DO M=-L,L                           !!! over m
      LM=L*(L+1)+M+1
      ISYM=LMSYM(LM,IATOM)
      SL=SMT(ISORT)**L
      IF(SYM(LM,IATOM).AND.L.LE.LBROY)THEN!!! for only non-zero components
C Repack Spin Densities
	DO IRAD=0,NRAD(ISORT) 
	ILEN=ILEN+1
	IF(ISYM.EQ.1)THEN
	RHO(IRAD,ISYM,IATOM,1,1)=
     &CMPLX(DREAL(XNEW(ILEN)/DBLE(NSPIN)),0.D0)
	RHO(IRAD,ISYM,IATOM,NSPIN,1)=
     &CMPLX(DREAL(XNEW(ILEN)/DBLE(NSPIN)),0.D0)
	ELSE
	RHO(IRAD,ISYM,IATOM,1,1)=XNEW(ILEN)/DBLE(NSPIN)
	RHO(IRAD,ISYM,IATOM,NSPIN,1)=XNEW(ILEN)/DBLE(NSPIN)
	ENDIF
	ENDDO
	IF(NSPIN.EQ.2)THEN
	DO IRAD=0,NRAD(ISORT)
	ILEN=ILEN+1
	IF(ISYM.EQ.1)THEN
	RHO(IRAD,ISYM,IATOM,1,1)=RHO(IRAD,ISYM,IATOM,1,1)+
     &CMPLX(DREAL(XNEW(ILEN)/DBLE(NSPIN)),0.D0)
	RHO(IRAD,ISYM,IATOM,NSPIN,1)=RHO(IRAD,ISYM,IATOM,NSPIN,1)-
     &CMPLX(DREAL(XNEW(ILEN)/DBLE(NSPIN)),0.D0)
	ELSE
	RHO(IRAD,ISYM,IATOM,1,1)=RHO(IRAD,ISYM,IATOM,1,1)+
     &XNEW(ILEN)/DBLE(NSPIN)
	RHO(IRAD,ISYM,IATOM,NSPIN,1)=RHO(IRAD,ISYM,IATOM,NSPIN,1)-
     &XNEW(ILEN)/DBLE(NSPIN)
	ENDIF
	ENDDO
	ENDIF
C Repack transverse components
	IF(NORBS.EQ.2)THEN
	DO IRAD=0,NRAD(ISORT)
	ILEN=ILEN+1
	RHO(IRAD,ISYM,IATOM,1,NORBS)=XNEW(ILEN)
	ENDDO
	DO IRAD=0,NRAD(ISORT)
	ILEN=ILEN+1
	RHO(IRAD,ISYM,IATOM,NSPIN,NORBS)=XNEW(ILEN)
	ENDDO
	ENDIF
	ENDIF                               !!! for only non-zero components
	ENDDO                               !!! over m
	ENDDO                               !!! over l
	ENDDO                               !!! over atoms
C *** DEFINE NEW CHARGE DENSITY ***
C PLW-PART
	DO IPLW=0,NPLW                      !!! over plane waves
	ILEN=ILEN+1
	RHOPS(IPLW,1,1)=XNEW(ILEN)/DBLE(NSPIN)
	RHOPS(IPLW,NSPIN,1)=XNEW(ILEN)/DBLE(NSPIN)
	ENDDO                               !!! over plane waves
	IF(NSPIN.EQ.2)THEN
	DO IPLW=0,NPLW                      !!! over plane waves
	ILEN=ILEN+1
	RHOPS(IPLW,1,1)=RHOPS(IPLW,1,1)+XNEW(ILEN)/DBLE(NSPIN)
	RHOPS(IPLW,NSPIN,1)=RHOPS(IPLW,NSPIN,1)-XNEW(ILEN)/
     &DBLE(NSPIN)
	ENDDO                               !!! over plane waves
	ENDIF
	IF(NORBS.EQ.2)THEN
	DO IPLW=0,NPLW                      !!! over plane waves
	ILEN=ILEN+1
	RHOPS(IPLW,1,NORBS)=XNEW(ILEN)
	ENDDO                               !!! over plane waves
	DO IPLW=0,NPLW                      !!! over plane waves
	ILEN=ILEN+1
	RHOPS(IPLW,NSPIN,NORBS)=XNEW(ILEN)
	ENDDO                               !!! over plane waves
	ENDIF
C CHECK OUT ELECTRONEUTRALITY
 100	IRES=0
      DO IATOM=1,NATOM                    !!! over atoms
      ISORT=IS(IATOM)
	DO IORBS=1,NORBS
      DO IUPDN=1,NSPIN                    !!! over spins
      DO IRAD=0,NRAD(ISORT)
      WORK1(IRAD)=RHO(IRAD,1,IATOM,IUPDN,IORBS)*
     &WEIGHT(IRAD,ISORT)/SQRT(4.D0*PI)
	ENDDO
      CALL LIB_CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
      QCH(IATOM,IUPDN,IORBS)=WORK2(NRAD(ISORT))
	QIM=DIMAG(WORK2(NRAD(ISORT)))
      IF(ABS(QIM).GE.1.D-10.AND.IORBS.EQ.1)THEN
	IRES=1
	WRITE(IUT,*)'<MIXBRO>: IMAGINARY PART IS NOT ZERO',QIM
      ENDIF
	ENDDO                               !!! over spins
	ENDDO                               !!! over iorbs
	ENDDO                               !!! over atoms
C
      ZTOT=0.D0
	TOTM=0.D0
      DO IATOM=1,NATOM                    !!! over atoms
      ISORT=IS(IATOM)
      DO ISPIN=1,NSPIN                    !!! over spins
      QCH(IATOM,ISPIN,1)=QCH(IATOM,ISPIN,1)-
     &DCMPLX(ZNUC(ISORT)/DBLE(NSPIN),0.D0)
	ZTOT=ZTOT+DREAL(QCH(IATOM,ISPIN,1))
	TOTM=TOTM-DREAL(QCH(IATOM,ISPIN,1))*(-1)**ISPIN
	ENDDO                               !!! over spins
	ENDDO                               !!! over atoms
C Restart mixing
	IF(IRES.EQ.0)RESET=.FALSE.
 	IF(IRES.EQ.1)RESET=.TRUE.
	IF(IRES.EQ.1)WRITE(IUT,*)'<MIXBRO>: BROYDEN  MIXING  RESTARTED' 
C Switch off mixing ???
C	IF(IRES.EQ.1)LBROY =-1
C	IF(IRES.EQ.1)LBROY0=-1
C	IF(IRES.EQ.1)WRITE(IUT,*)'<MIXBRO>: BROYDEN  MIXING  IS OFF' 
C PRINT BLOCK
	WRITE(IUN,1010)WTER(MTER)
	IF(NSPIN.EQ.1)WRITE(IUN,1020)
	IF(NSPIN.EQ.2.AND.NORBS.EQ.1)WRITE(IUN,1030)
	IF(NSPIN.EQ.2.AND.NORBS.EQ.2)WRITE(IUN,1035)
      DO IATOM=1,NATOM                    !!! over atoms
      ISORT=IS(IATOM)
	CTOT=0.5D0*DBLE(NSPIN)*DREAL(QCH(IATOM,1,1)+QCH(IATOM,NSPIN,1))
	AMTS(0)=QCH(IATOM,1,1)-QCH(IATOM,NSPIN,1)
	AMTS(-1)=(0.D0,0.D0)
	AMTS(+1)=(0.D0,0.D0)
	IF(NORBS.EQ.2)THEN
	AMTS(-1)=QCH(IATOM,1,NORBS)
	AMTS(+1)=QCH(IATOM,NSPIN,NORBS)
	ENDIF
	AMTC(1)=(AMTS(-1)-AMTS(+1))/SQRT(2.D0)
	AMTC(2)=(AMTS(-1)+AMTS(+1))/SQRT(2.D0)*(0.D0,-1.D0) ! since it is M^{+/-}
	AMTC(3)=AMTS(0)
	IF(NSPIN.EQ.1)THEN
      WRITE(IUN,1040)CTOT,TXTEL(ISORT)
	ELSEIF(NSPIN.EQ.2.AND.NORBS.EQ.1)THEN
      WRITE(IUN,1050)CTOT,DREAL(AMTS(0)),TXTEL(ISORT)
	ELSEIF(NSPIN.EQ.2.AND.NORBS.EQ.2)THEN
      WRITE(IUN,1060)CTOT,DREAL(AMTC(1)),DREAL(AMTC(2))
     &                   ,DREAL(AMTC(3)),TXTEL(ISORT)
	ENDIF
	ENDDO                               !!! over atoms
	WRITE(IUN,1070)ZTOT
	IF(NSPIN.EQ.2.AND.NORBS.EQ.1)WRITE(IUN,1080)TOTM
	WRITE(IUN,1090)
C MEMORY DEALLOCATIONS
 1000 DEALLOCATE(QCH,WRAD,WRK1,WRK2,WORK1,WORK2,XRHO,XNEW)
	CURMEM=CURMEM-SIZE_HERE
1010	FORMAT(1X,'Broyden Mixing for Rho(r), Iter-Weight=',G14.7)
1020	FORMAT(4X,'Charge:')
1030	FORMAT(4X,'Charge:',8X,'Magnetization:')           
1035	FORMAT(4X,'Charge:',10X,'Mx',13X,'My',13X,'Mz:')           
1040	FORMAT(1X,G14.7,2X,A10)
1050	FORMAT(1X,G14.7,5X,G14.7,2X,A10)
1060	FORMAT(1X,G14.7,1X,G14.7,1X,G14.7,1X,G14.7,2X,A10)
1070  FORMAT(1X,'Interst. Charge after Broyden  =',G14.7)
1080  FORMAT(1X,'Magnetization over MT-spheres  =',G14.7)
1090  FORMAT(1X,'----------------------------------------------')
	END
