	SUBROUTINE RHO_ORBMAG
**********************************************************
*  Finds orbital contribution to magnetization,          *
**********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                          !!! from setup
      USE COM_CONTROL ,ONLY: LMTO,IASA,NPFR                   !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS          !!! from readini
     &                      ,IS,ILST,ILSB,ILSV,LRTV
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP,EK                !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN,IATS,ISTS            !!! from readini
      USE COM_LATPAR  ,ONLY: PAR,OMEGAC                       !!! from readini
      USE COM_MAGDAT  ,ONLY: AXMAG                            !!! from readini
      USE COM_SPHERE  ,ONLY: ZNUC,SMT                         !!! from readini
      USE COM_SYMMLM  ,ONLY: SYM,LMSYM                        !!! from symlmm
      USE COM_POTDAT  ,ONLY: POT,POTRWF,POTPS,POTPS1          !!! from potfull
      USE COM_DENDAT  ,ONLY: RHO,RHOPS                        !!! from rhofull
      USE COM_PLWMESH ,ONLY: NPLW,GPLW                        !!! from plwmesh
      USE COM_INPPAR  ,ONLY: ENY,DNY                          !!! from readini
      USE COM_LMTPAR  ,ONLY: GAM,AAH,BBH,AAJ,BBJ              !!! from potpar
      USE COM_HAMPAR  ,ONLY: ATOSHH=>HPARHH                   !!! from tospar
     &                      ,ATOSJH=>HPARJH
     &                      ,ATOSHJ=>HPARHJ
     &                      ,ATOSJJ=>HPARJJ
      USE COM_RADMESH ,ONLY: NRAD,H,R,DR,WEIGHT,RL            !!! from radmesh
      USE COM_GAUNT   ,ONLY: C                                !!! from gdata
      USE COM_LABELS  ,ONLY: TXTAT,TXTEL,TXTSP                !!! from readini
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT                      !!! from setup
      USE COM_CHANNELS,ONLY: IUTOS                            !!! from readini
      USE COM_MASHDEP ,ONLY: LENREL,LENCMP                    !!! from readini
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER, INTRINSIC :: SIZE
	REAL*8, ALLOCATABLE :: FI(:,:)
	REAL*8, ALLOCATABLE :: FID(:,:)
	REAL*8, ALLOCATABLE :: FIP(:,:)
	REAL*8, ALLOCATABLE :: FIDP(:,:)
	REAL*8, ALLOCATABLE :: FIDDS(:)
	REAL*8, ALLOCATABLE :: FIDDPS(:)
	COMPLEX*16, ALLOCATABLE :: FIH(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: FIJ(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: WORK1(:)
	COMPLEX*16, ALLOCATABLE :: WORK2(:)
	COMPLEX*16, ALLOCATABLE :: WORK3(:)
	COMPLEX*16, ALLOCATABLE :: ORBMZ(:,:,:)
	COMPLEX*16, ALLOCATABLE :: TRM(:,:,:)
	COMPLEX*16, ALLOCATABLE :: TRS(:,:,:)
	COMPLEX*16, ALLOCATABLE :: TRC(:,:,:)
	COMPLEX*16 CGNT,GINT,PAU(2,2,3),PAL(2,2,3),PAX(2,2,3)
     &    ,ORMS(-1:1),ORMI(-1:1),ORMC(3),ORML(3),TD(-1:1,3)
     &    ,TRMS(-1:1),TRMI(-1:1),TRML(3),TRMC(3),TR(3,-1:1)
     &    ,TORS(3),TORI(3),TORL(3),TORC(3),BXM(-1:1),BXC(3)
     &    ,BXR(3),ROM(-1:1),ROC(3),ROR(3)
	LOGICAL LOG1,LOG
	DATA PI/3.141592653589793D0/
      CALL ABORTNOW()
	IF(NORBS.NE.2)RETURN
C MEMORY ALLOCATIONS
	ALLOCATE(FI(0:NRADMEM,0:LMAXTMEM))
	ALLOCATE(FID(0:NRADMEM,0:LMAXTMEM))
	ALLOCATE(FIP(0:NRADMEM,0:LMAXTMEM))
	ALLOCATE(FIDP(0:NRADMEM,0:LMAXTMEM))
	ALLOCATE(FIDDS(0:LMAXTMEM))
	ALLOCATE(FIDDPS(0:LMAXTMEM))
	ALLOCATE(FIH(0:NRADMEM,0:LMAXTMEM,NKAPMEM,NSPINMEM))
	ALLOCATE(FIJ(0:NRADMEM,0:LMAXTMEM,NKAPMEM,NSPINMEM))
	SIZE_FIS=4.D0*DBLE(SIZE(FI)*LENREL)/1024.D0**2
	SIZE_FIH=2.D0*DBLE(SIZE(FIH)*LENCMP)/1024.D0**2
	CURMEM=CURMEM+SIZE_FIS+SIZE_FIH
      IF(TOTMEM.LT.CURMEM)TXTMEM='<ORBMAG> Subroutine'
      IF(TOTMEM.LT.CURMEM)TOTMEM=CURMEM
	ALLOCATE(WORK1(0:NRADMEM))
	ALLOCATE(WORK2(0:NRADMEM))
	ALLOCATE(WORK3(0:NRADMEM))
	ALLOCATE(ORBMZ(0:NRADMEM,-1:1,NATOMMEM))
	ALLOCATE(TRM(-1:2,-1:2,NSORTMEM))
	ALLOCATE(TRS(2,2,NSORTMEM))
	ALLOCATE(TRC(3,3,NSORTMEM))
C START CODE
	SQPI4=2.D0*SQRT(PI)
C DO GLOBALLY OVER ATOMS AND PANELS
	DO 4000 IATOM=1,NATOM                  !!! over atoms
	ISORT=IS(IATOM)
	DO IRAD=0,NRAD(ISORT)
	ORBMZ(IRAD,-1,IATOM)=(0.D0,0.D0)
	ORBMZ(IRAD, 0,IATOM)=(0.D0,0.D0)
	ORBMZ(IRAD,+1,IATOM)=(0.D0,0.D0)
	ENDDO
	DO 3000 IPAN=1,NPAN                    !!! over panels
	NSHIFT=0
	DO JPAN=1,NPAN
	IF(JPAN.LT.IPAN)
     &NSHIFT=NSHIFT+NKAP(JPAN)**2*NATOM*NSPIN*NORBS
      ENDDO
	DO ISPIN=1,NSPIN
	DO IKAP=1,NKAP(IPAN)                   !!! over energies
      CALL LIB_RADSCH_PHIS(ENY(0,ISORT,IKAP,IPAN,ISPIN),FI,FIP,FID,
     &  FIDP,FIDDS,FIDDPS,SMT(ISORT),POTRWF(0,ISORT,ISPIN),
     &  ILST(ISORT),NRAD(ISORT),H(ISORT),R(0,ISORT),DR(0,ISORT),
     &  LRTV(ISORT))
	DO L=0,ILST(ISORT)
	DO IRAD=0,NRAD(ISORT)
	FIH(IRAD,L,IKAP,ISPIN)=AAH(L,ISORT,IKAP,IPAN,ISPIN)*FI(IRAD,L)+
     &BBH(L,ISORT,IKAP,IPAN,ISPIN)*FIP(IRAD,L)
	FIJ(IRAD,L,IKAP,ISPIN)=AAJ(L,ISORT,IKAP,IPAN,ISPIN)*FI(IRAD,L)+
     &BBJ(L,ISORT,IKAP,IPAN,ISPIN)*FIP(IRAD,L)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	DO 2000 IORBS=1,1  ! there is only up-up and dn-dn matrix elements here
	DO 1000 IUPDN=1,NSPIN                  !!! over spins
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
	DO IKAP1=1,NKAP(IPAN)                  !!! over energies
	DO IKAP=1,NKAP(IPAN)                   !!! over energies
	IREC=IKAP1+NKAP(IPAN)*(IKAP-1)+NKAP(IPAN)**2*(IATOM-1)+
     &NKAP(IPAN)**2*NATOM*(IUPDN-1)+NKAP(IPAN)**2*NATOM*NSPIN*(IORBS-1)+
     &NSHIFT
	READ(IUTOS,REC=IREC)
     &((ATOSHH(L1M1,LM,IATOM),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((ATOSJH(L1M1,LM,IATOM),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((ATOSHJ(L1M1,LM,IATOM),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &((ATOSJJ(L1M1,LM,IATOM),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2)
	DO L=0,ILST(ISORT)                     !!! over l
	LOG1=.FALSE.
	IF(LTPAN(L,IATOM,IKAP1,IPAN))LOG1=.TRUE.
	LOG=.FALSE.
	IF(LTPAN(L,IATOM,IKAP ,IPAN))LOG =.TRUE.
	DO MY=-1,1                             !!! over my
	DO M1=-L,L                             !!! over m1
	LM1=L*(L+1)+M1+1
	DO M=-L,L                              !!! over m
	LM=L*(L+1)+M+1
	IF(MY.EQ. 0.AND.M1.NE.M  )CYCLE
	IF(MY.EQ.-1.AND.M1.NE.M-1)CYCLE
	IF(MY.EQ.+1.AND.M1.NE.M+1)CYCLE
	IF(MY.EQ.0 )FACT=DBLE(M)/SQPI4
	IF(MY.EQ.-1)FACT=+SQRT(DBLE((L+M)*(L-M+1)))/SQRT(2.D0)/SQPI4
	IF(MY.EQ.+1)FACT=-SQRT(DBLE((L-M)*(L+M+1)))/SQRT(2.D0)/SQPI4
	DO IRAD=0,NRAD(ISORT)                  !!! over radial mesh
	IF(LOG1.AND.LOG)
     &ORBMZ(IRAD,MY,IATOM)=ORBMZ(IRAD,MY,IATOM)+ATOSHH(LM1,LM,IATOM)*
     &CONJG(FIH(IRAD,L,IKAP1,ISPIN1))*FIH(IRAD,L,IKAP,ISPIN)*FACT
	IF(LOG1)
     &ORBMZ(IRAD,MY,IATOM)=ORBMZ(IRAD,MY,IATOM)-ATOSHJ(LM1,LM,IATOM)*
     &CONJG(FIH(IRAD,L,IKAP1,ISPIN1))*FIJ(IRAD,L,IKAP,ISPIN)*FACT*
     &GAM(L,ISORT)
	IF(LOG)
     &ORBMZ(IRAD,MY,IATOM)=ORBMZ(IRAD,MY,IATOM)-ATOSJH(LM1,LM,IATOM)*
     &CONJG(FIJ(IRAD,L,IKAP1,ISPIN1))*FIH(IRAD,L,IKAP,ISPIN)*FACT*
     &GAM(L,ISORT)
	ORBMZ(IRAD,MY,IATOM)=ORBMZ(IRAD,MY,IATOM)+ATOSJJ(LM1,LM,IATOM)*
     &CONJG(FIJ(IRAD,L,IKAP1,ISPIN1))*FIJ(IRAD,L,IKAP,ISPIN)*FACT*
     &GAM(L,ISORT)*GAM(L,ISORT)
      ENDDO                                  !!! over radial mesh
      ENDDO                                  !!! over m
      ENDDO                                  !!! over m1
      ENDDO                                  !!! over my
      ENDDO                                  !!! over l
      ENDDO                                  !!! over energies
      ENDDO                                  !!! over energies
1000	CONTINUE                               !!! over spins
2000	CONTINUE                               !!! over spins
3000  CONTINUE                               !!! over panels
4000  CONTINUE                               !!! over all atoms in cell
C SET TRANSFORMATION MATRICES
C Transformation matrix my->xyz
	TD(-1,1)=(+1.D0,+0.D0)/SQRT(2.D0)
	TD(-1,2)=(+0.D0,+1.D0)/SQRT(2.D0)
	TD(-1,3)=(+0.D0,+0.D0)
	TD( 0,1)=(+0.D0,+0.D0)
	TD( 0,2)=(+0.D0,+0.D0)
	TD( 0,3)=(+1.D0,+0.D0)
	TD(+1,1)=(-1.D0,+0.D0)/SQRT(2.D0)
	TD(+1,2)=(+0.D0,+1.D0)/SQRT(2.D0)
	TD(+1,3)=(+0.D0,+0.D0)
C Reciprocal transformation matrix my->xyz
	TR(1,-1)=(+1.D0,+0.D0)/SQRT(2.D0)
	TR(1, 0)=(+0.D0,+0.D0)
	TR(1,+1)=(-1.D0,+0.D0)/SQRT(2.D0)
	TR(2,-1)=(+0.D0,-1.D0)/SQRT(2.D0)
	TR(2, 0)=(+0.D0,+0.D0)
	TR(2,+1)=(+0.D0,-1.D0)/SQRT(2.D0)
	TR(3,-1)=(+0.D0,+0.D0)
	TR(3, 0)=(+1.D0,+0.D0)
	TR(3,+1)=(+0.D0,+0.D0)
	DO IATOM=1,NATOM                       !!! over atoms
	ISORT=IS(IATOM)
	CALL LIB_ROTAXES(AXMAG(1,ISORT),TETA,PFI)
C  Spinor transformation
	TRS(1,1,ISORT)=+DCMPLX(COS(0.5D0*TETA),0.D0)
	TRS(1,2,ISORT)=-SIN(0.5D0*TETA)*EXP((0.D0,-1.D0)*PFI)
	TRS(2,1,ISORT)=+SIN(0.5D0*TETA)*EXP((0.D0,+1.D0)*PFI)
	TRS(2,2,ISORT)=+DCMPLX(COS(0.5D0*TETA),0.D0)
C  System transformation: M{xyz}=TRC*M{teta,fi,rho}
	TRC(1,1,ISORT)=+DCMPLX(COS(PFI)*COS(TETA),0.D0)
	TRC(1,2,ISORT)=-DCMPLX(SIN(PFI),0.D0)
	TRC(1,3,ISORT)=+DCMPLX(SIN(TETA)*COS(PFI),0.D0)
	TRC(2,1,ISORT)=+DCMPLX(SIN(PFI)*COS(TETA),0.D0)
	TRC(2,2,ISORT)=+DCMPLX(COS(PFI),0.D0)
	TRC(2,3,ISORT)=+DCMPLX(SIN(TETA)*SIN(PFI),0.D0)
	TRC(3,1,ISORT)=-DCMPLX(SIN(TETA),0.D0)
	TRC(3,2,ISORT)=+DCMPLX(0.D0,0.D0)
	TRC(3,3,ISORT)=+DCMPLX(COS(TETA),0.D0)
C Transform to my-representation
	DO MY=-1,1
	DO NY=-1,1
	TRM(MY,NY,ISORT)=(0.D0,0.D0)
	DO I=1,3
	DO J=1,3
	TRM(MY,NY,ISORT)=TRM(MY,NY,ISORT)+TD(MY,I)*TRC(I,J,ISORT)*TR(J,NY)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C Add density element
	DO MY=-1,1
	TRM(MY,2,ISORT)=(0.D0,0.D0)
	TRM(2,MY,ISORT)=(0.D0,0.D0)
	ENDDO
	TRM(2,2,ISORT)=(+1.D0,0.D0)
C  Pauli matrices
	PAU(1,1,1)=(+0.D0,+0.D0)
	PAU(1,2,1)=(+1.D0,+0.D0)
	PAU(2,1,1)=(+1.D0,+0.D0)
	PAU(2,2,1)=(+0.D0,+0.D0)
	PAU(1,1,2)=(+0.D0,+0.D0)
	PAU(1,2,2)=(+0.D0,-1.D0)
	PAU(2,1,2)=(+0.D0,+1.D0)
	PAU(2,2,2)=(+0.D0,+0.D0)
	PAU(1,1,3)=(+1.D0,+0.D0)
	PAU(1,2,3)=(+0.D0,+0.D0)
	PAU(2,1,3)=(+0.D0,+0.D0)
	PAU(2,2,3)=(-1.D0,+0.D0)
C  Transform Pauli matrices
	DO IA=1,3
	DO I=1,2
	DO J=1,2
	PAL(I,J,IA)=(0.D0,0.D0)
	DO IB=1,3
	PAL(I,J,IA)=PAL(I,J,IA)+PAU(I,J,IB)*TRC(IB,IA,ISORT)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C  Return back, PAX is not necessarily Pauli, but:
	DO IA=1,3
	DO I=1,2
	DO J=1,2
	PAX(I,J,IA)=(0.D0,0.D0)
	DO M1=1,2
	DO M2=1,2
	PAX(I,J,IA)=PAX(I,J,IA)+
     &DCONJG(TRS(M1,I,ISORT))*PAL(M1,M2,IA)*TRS(M2,J,ISORT)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C  PAX should be this:
	PAU(1,1,1)=(+0.D0,+0.D0)
	PAU(1,2,1)=(+1.D0,+0.D0)*EXP((0.D0,-1.D0)*PFI)
	PAU(2,1,1)=(+1.D0,+0.D0)*EXP((0.D0,+1.D0)*PFI)
	PAU(2,2,1)=(+0.D0,+0.D0)
	PAU(1,1,2)=(+0.D0,+0.D0)
	PAU(1,2,2)=(+0.D0,-1.D0)*EXP((0.D0,-1.D0)*PFI)
	PAU(2,1,2)=(+0.D0,+1.D0)*EXP((0.D0,+1.D0)*PFI)
	PAU(2,2,2)=(+0.D0,+0.D0)
	PAU(1,1,3)=(+1.D0,+0.D0)
	PAU(1,2,3)=(+0.D0,+0.D0)
	PAU(2,1,3)=(+0.D0,+0.D0)
	PAU(2,2,3)=(-1.D0,+0.D0)
C  Check it
	DO IA=1,3
	DO I=1,2
	DO J=1,2
	IF(ABS(PAU(I,J,IA)-PAX(I,J,IA)).GT.1.D-08)
     &CALL FULLSTOP('<ORBMAG>: Wrong phase')
	ENDDO
	ENDDO
	ENDDO
	ENDDO                                 !!! over atoms
C ********************************************************
C FIND ORBITAL MOMENT 
	WRITE(IUN,1010)
1010	FORMAT(1X,'   Orbital magnetization:    ')
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	CALL LIB_ROTAXES(AXMAG(1,ISORT),TETA,PFI)
	DO MY=-1,1
	DO IRAD=0,NRAD(ISORT)
	WORK1(IRAD)=ORBMZ(IRAD,MY,IATOM)*SQPI4*R(IRAD,ISORT)**2*
     &DR(IRAD,ISORT)
	ENDDO
      CALL LIB_CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	ORMS(MY)=WORK2(NRAD(ISORT))
	ENDDO
C Transform to x,y,z from +/-/0
	ORMC(1)=(ORMS(-1)-ORMS(+1))/SQRT(2.D0)
	ORMC(2)=(ORMS(-1)+ORMS(+1))/SQRT(2.D0)*(0.D0,1.D0)
	ORMC(3)=ORMS(0)
	WRITE(IUN,1020)ORMC(1),TXTEL(ISORT)
	WRITE(IUN,1030)ORMC(2),TXTEL(ISORT)
	WRITE(IUN,1040)ORMC(3),TXTEL(ISORT)
1020	FORMAT(1X,'O_x   = (',G14.7,',',G14.7,') ',A10)
1030	FORMAT(1X,'O_y   = (',G14.7,',',G14.7,') ',A10)
1040	FORMAT(1X,'O_z   = (',G14.7,',',G14.7,') ',A10)
C Transform to the system related to local axis: M{teta,fi,rho}=TRC^{+}*M{xyz}
	DO IA=1,3
	ORML(IA)=(0.D0,0.D0)
	DO IB=1,3
	ORML(IA)=ORML(IA)+DCONJG(TRC(IB,IA,ISORT))*ORMC(IB)
	ENDDO
	ENDDO
	WRITE(IUN,1050)ORML(1),TXTEL(ISORT)
	WRITE(IUN,1060)ORML(2),TXTEL(ISORT)
	WRITE(IUN,1070)ORML(3),TXTEL(ISORT)
1050	FORMAT(1X,'O_tet = (',G14.7,',',G14.7,') ',A10)
1060	FORMAT(1X,'O_phi = (',G14.7,',',G14.7,') ',A10)
1070	FORMAT(1X,'O_rho = (',G14.7,',',G14.7,') ',A10)
	ENDDO
C ************************************************************
C FIND SPIN MOMENT
	WRITE(IUN,1100)
1100	FORMAT(1X,'   Transverse magnetization:    ')
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	CALL LIB_ROTAXES(AXMAG(1,ISORT),TETA,PFI)
C Z-Moment
	DO IRAD=0,NRAD(ISORT)
	WORK1(IRAD)=(RHO(IRAD,1,IATOM,1,1)-RHO(IRAD,1,IATOM,NSPIN,1))*
     &SQPI4*R(IRAD,ISORT)**2*DR(IRAD,ISORT)
	ENDDO
      CALL LIB_CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	TRMS(0)=WORK2(NRAD(ISORT))
C M-Moment M^{-}
	DO IRAD=0,NRAD(ISORT)
	WORK1(IRAD)=RHO(IRAD,1,IATOM,1,NORBS)*SQPI4*R(IRAD,ISORT)**2*
     &DR(IRAD,ISORT)
	ENDDO
      CALL LIB_CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	TRMS(-1)=WORK2(NRAD(ISORT))
C P-Moment M^{+}
	DO IRAD=0,NRAD(ISORT)
	WORK1(IRAD)=RHO(IRAD,1,IATOM,2,NORBS)*SQPI4*R(IRAD,ISORT)**2*
     &DR(IRAD,ISORT)
	ENDDO
      CALL LIB_CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	TRMS(+1)=WORK2(NRAD(ISORT))
C Transform to x,y,z from +/-/0
	TRMC(1)=(TRMS(-1)-TRMS(+1))/SQRT(2.D0)
	TRMC(2)=(TRMS(-1)+TRMS(+1))/SQRT(2.D0)*(0.D0,-1.D0) ! since it is T^{+/-}
	TRMC(3)= TRMS(0)
	WRITE(IUN,1110)TRMC(1),TXTEL(ISORT)
	WRITE(IUN,1120)TRMC(2),TXTEL(ISORT)
	WRITE(IUN,1130)TRMC(3),TXTEL(ISORT)
1110	FORMAT(1X,'M_x   = (',G14.7,',',G14.7,') ',A10)
1120	FORMAT(1X,'M_y   = (',G14.7,',',G14.7,') ',A10)
1130	FORMAT(1X,'M_z   = (',G14.7,',',G14.7,') ',A10)
C Transform to local coordinates
	DO IA=1,3
	TRML(IA)=(0.D0,0.D0)
	DO IB=1,3
	TRML(IA)=TRML(IA)+DCONJG(TRC(IB,IA,ISORT))*TRMC(IB)
	ENDDO
	ENDDO
	WRITE(IUN,1140)TRML(1),TXTEL(ISORT)
	WRITE(IUN,1150)TRML(2),TXTEL(ISORT)
	WRITE(IUN,1160)TRML(3),TXTEL(ISORT)
1140	FORMAT(1X,'M_tet = (',G14.7,',',G14.7,') ',A10)
1150	FORMAT(1X,'M_phi = (',G14.7,',',G14.7,') ',A10)
1160	FORMAT(1X,'M_rho = (',G14.7,',',G14.7,') ',A10)
	ENDDO
C INTERSTITIAL MOMENT
C Z-Moment
	TRMI(0)=(0.D0,0.D0)
	DO IPLW=0,NPLW
	CALL MAKEPLW_SINT(GPLW(1,IPLW),GPLW(2,IPLW),GPLW(3,IPLW),GINT)
	TRMI(0)=TRMI(0)+(RHOPS(IPLW,1,1)-RHOPS(IPLW,NSPIN,1))*GINT
	ENDDO
C M-Moment, M^{-}
	TRMI(-1)=(0.D0,0.D0)
	DO IPLW=0,NPLW
	CALL MAKEPLW_SINT(GPLW(1,IPLW),GPLW(2,IPLW),GPLW(3,IPLW),GINT)
	TRMI(-1)=TRMI(-1)+RHOPS(IPLW,1,NORBS)*GINT
	ENDDO
C P-Moment, M^{+}
	TRMI(+1)=(0.D0,0.D0)
	DO IPLW=0,NPLW
	CALL MAKEPLW_SINT(GPLW(1,IPLW),GPLW(2,IPLW),GPLW(3,IPLW),GINT)
	TRMI(+1)=TRMI(+1)+RHOPS(IPLW,2,NORBS)*GINT
	ENDDO
C Transform to x,y,z from +/-/0
	TRMC(1)=(TRMI(-1)-TRMI(+1))/SQRT(2.D0)
	TRMC(2)=(TRMI(-1)+TRMI(+1))/SQRT(2.D0)*(0.D0,-1.D0) ! since it is T^{+/-}
	TRMC(3)= TRMI(0)
	WRITE(IUN,1170)TRMC(1)
	WRITE(IUN,1180)TRMC(2)
	WRITE(IUN,1190)TRMC(3)
1170	FORMAT(1X,'M_x   = (',G14.7,',',G14.7,') ','int.region')
1180	FORMAT(1X,'M_y   = (',G14.7,',',G14.7,') ','int.region')
1190	FORMAT(1X,'M_z   = (',G14.7,',',G14.7,') ','int.region')
C ************************************************************
C COMPUTE TORQUE
	WRITE(IUN,1200)
1200	FORMAT(1X,'   Torque:')
	DO IATOM=1,NATOM                                    !!! over atoms
	ISORT=IS(IATOM)
	CALL LIB_ROTAXES(AXMAG(1,ISORT),TETA,PFI)
	TORL(1)=(0.D0,0.D0)
	TORL(2)=(0.D0,0.D0)
	DO L=0,ILSV(ISORT)                                  !!! over l
	DO M=-L,L                                           !!! over m
	LM=L*(L+1)+M+1
	IF(.NOT.SYM(LM,IATOM))CYCLE
	ISYM=LMSYM(LM,IATOM)
	DO IRAD=0,NRAD(ISORT)                               !!! over irad
C Set exchange-correlation field
	BXM(0) =0.5D0*
     &       (POT(IRAD,ISYM,IATOM,1,1)-POT(IRAD,ISYM,IATOM,NSPIN,1))
	BXM(-1)=POT(IRAD,ISYM,IATOM,1,NORBS)
	BXM(+1)=POT(IRAD,ISYM,IATOM,NSPIN,NORBS)
C Transform to xyz
	DO IA=1,3
	BXC(IA)=(0.D0,0.D0)
	DO MY=-1,1
	BXC(IA)=BXC(IA)+TR(IA,MY)*BXM(MY)
	ENDDO
	ENDDO
C Transform to teta,phi,rho
	DO IA=1,3
	BXR(IA)=(0.D0,0.D0)
	DO IB=1,3
	BXR(IA)=BXR(IA)+DCONJG(TRC(IB,IA,ISORT))*BXC(IB)
	ENDDO
	ENDDO
C Now density
	ROM(0)= RHO(IRAD,ISYM,IATOM,1,1)-RHO(IRAD,ISYM,IATOM,NSPIN,1)
	ROM(-1)=RHO(IRAD,ISYM,IATOM,1,NORBS)
	ROM(+1)=RHO(IRAD,ISYM,IATOM,NSPIN,NORBS)
C Transform to xyz
	DO IA=1,3
	ROC(IA)=(0.D0,0.D0)
	DO MY=-1,1
	ROC(IA)=ROC(IA)+TR(IA,MY)*ROM(MY)
	ENDDO
	ENDDO
C Transform to teta,phi,rho
	DO IA=1,3
	ROR(IA)=(0.D0,0.D0)
	DO IB=1,3
	ROR(IA)=ROR(IA)+DCONJG(TRC(IB,IA,ISORT))*ROC(IB)
	ENDDO
	ENDDO
C Integrate now
	WORK1(IRAD)=ROR(1)*DCONJG(BXR(3))*
     &DR(IRAD,ISORT)*R(IRAD,ISORT)**2
	WORK2(IRAD)=ROR(2)*DCONJG(BXR(3))*
     &DR(IRAD,ISORT)*R(IRAD,ISORT)**2
      ENDDO                                               !!! over irad
	CALL LIB_CQD(H(ISORT),WORK1,WORK3,NRAD(ISORT)+1)
	TORL(1)=TORL(1)+WORK3(NRAD(ISORT))
	CALL LIB_CQD(H(ISORT),WORK2,WORK3,NRAD(ISORT)+1)
	TORL(2)=TORL(2)+WORK3(NRAD(ISORT))
      ENDDO                                               !!! over m
      ENDDO                                               !!! over l
	TORL(3)=(0.D0,0.D0)
	WRITE(IUN,1210)TORL(1),TXTEL(ISORT)
	WRITE(IUN,1220)TORL(2),TXTEL(ISORT)
1210	FORMAT(1X,'T_tet = (',G14.7,',',G14.7,') ',A10)
1220	FORMAT(1X,'T_phi = (',G14.7,',',G14.7,') ',A10)
      ENDDO                                               !!! over iatom
C INTERSTITIAL REGION
	TORI(1)=(0.D0,0.D0)	
	TORI(2)=(0.D0,0.D0)	
	DO IPLW=0,NPLW                                      !!! over plane waves
C Set exchange-correlation field
	BXM(0) =0.5D0*(POTPS1(IPLW,1,1)-POTPS1(IPLW,NSPIN,1))
	BXM(-1)=POTPS1(IPLW,1,NORBS)
	BXM(+1)=POTPS1(IPLW,NSPIN,NORBS)
C Transform to xyz
	DO IA=1,3
	BXC(IA)=(0.D0,0.D0)
	DO MY=-1,1
	BXC(IA)=BXC(IA)+TR(IA,MY)*BXM(MY)
	ENDDO
	ENDDO
C Transform to teta,phi,rho
	DO IA=1,3
	BXR(IA)=(0.D0,0.D0)
	DO IB=1,3
	BXR(IA)=BXR(IA)+DCONJG(TRC(IB,IA,ISORT))*BXC(IB)
	ENDDO
	ENDDO
C Now density
	ROM(0)= RHOPS(IPLW,1,1)-RHOPS(IPLW,NSPIN,1)
	ROM(-1)=RHOPS(IPLW,1,NORBS)
	ROM(+1)=RHOPS(IPLW,NSPIN,NORBS)
C Transform to xyz
	DO IA=1,3
	ROC(IA)=(0.D0,0.D0)
	DO MY=-1,1
	ROC(IA)=ROC(IA)+TR(IA,MY)*ROM(MY)
	ENDDO
	ENDDO
C Transform to teta,phi,rho
	DO IA=1,3
	ROR(IA)=(0.D0,0.D0)
	DO IB=1,3
	ROR(IA)=ROR(IA)+DCONJG(TRC(IB,IA,ISORT))*ROC(IB)
	ENDDO
	ENDDO
C Integrate now
	TORI(1)=TORI(1)+ROR(1)*DCONJG(BXR(3))
	TORI(2)=TORI(2)+ROR(2)*DCONJG(BXR(3))
      ENDDO                                               !!! over plane waves
	TORI(3)=(0.D0,0.D0)
	WRITE(IUN,1230)TORI(1)
	WRITE(IUN,1240)TORI(2)
1230	FORMAT(1X,'T_tet = (',G14.7,',',G14.7,') ','int.region')
1240	FORMAT(1X,'T_phi = (',G14.7,',',G14.7,') ','int.region')
C MEMORY DEALLOCATIONS
      DEALLOCATE(FI,FID,FIP,FIDP,FIDDS,FIDDPS,FIH,FIJ)
	CURMEM=CURMEM-SIZE_FIS-SIZE_FIH
      DEALLOCATE(WORK1,WORK2,WORK3,ORBMZ,TRS,TRC)
	END
