	SUBROUTINE RHO_RENCOR
************************************************************
*   Renormalization of the core density                    *
************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_CONTROL ,ONLY: LMTO,IASA,NOVR,NPFR              !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS          !!! from readini
     &                      ,IS,ILSV,NHSORT                   !!! from readini
      USE COM_SPHERE  ,ONLY: SMT,SASA,ZNUC,ZCOR               !!! from readini
      USE COM_SYMMLM  ,ONLY: SYM,LMSYM,NSYM                   !!! from symlmm
      USE COM_POTDAT  ,ONLY: POT                              !!! from potfull
      USE COM_DENDAT  ,ONLY: RHO,RHOCOR,CORFRZ                !!! from rhofull
      USE COM_POTMTS  ,ONLY: VMT0,VMT                         !!! from potzero
      USE COM_CORELEC ,ONLY: NLEVT,LEVN,LEVL,LEVJ,LEVC
     &                      ,ELEV,ZLEV,ICOR                   !!! from rencor
      USE COM_RADMESH ,ONLY: NRAD,H,R,DR,WEIGHT,RL            !!! from radmesh
      USE COM_LABELS  ,ONLY: TXTAT,TXTEL,TXTSP                !!! from readini
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT                      !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8, ALLOCATABLE :: WORK1(:)
	REAL*8, ALLOCATABLE :: ZCMT(:)
	REAL*8, ALLOCATABLE :: ANORM(:)
	REAL*8, ALLOCATABLE :: VBAR(:)
	REAL*8, ALLOCATABLE :: APHI(:)
	REAL*8, ALLOCATABLE :: APHID(:)
	CHARACTER TLEV(8,0:4,8)*19,THED*19,PRMT(3)*8
	LOGICAL EXIT
	DATA PI/3.141592653589793D0/
     &    ,PRMT/'deepcore','semicore','valence '/
	INTEGER, PARAMETER  :: fh_func = 598 ! File handle added by KH
      CALL ABORTNOW()
	LCR=0  ! non-relativistic solution
	LCR=1  ! scalar relativistic solution
	LCR=2  ! fully relativistic solution
C MEMORY ALLOCATIONS
	ALLOCATE(WORK1(0:NRADMEM))
	ALLOCATE(ZCMT(NSORTMEM))
	ALLOCATE(ANORM(NSORTMEM))
	ALLOCATE(VBAR(0:NRADMEM))
	ALLOCATE(APHI(0:NRADMEM))
	ALLOCATE(APHID(0:NRADMEM))
C START CODE
	DO 1000 ISORT=1,NSORT                       !!! over sorts
C Set to old core if icor=0 and skip renormalization
	IF(ICOR(ISORT).EQ.0)THEN
	DO IRAD=0,NRAD(ISORT)
	RHOCOR(IRAD,ISORT,1)=CORFRZ(IRAD,ISORT,1)
	RHOCOR(IRAD,ISORT,NSPIN)=CORFRZ(IRAD,ISORT,NSPIN)
	ENDDO
	GOTO 1000
	ENDIF
	IF(ZNUC(ISORT).LE.1.D-5)GOTO 1000
	DO IRAD=0,NRAD(ISORT)
	RHOCOR(IRAD,ISORT,1)=0.D0
	RHOCOR(IRAD,ISORT,NSPIN)=0.D0
	ENDDO
C  SET THE POTENTIAL AVERAGED OVER SPINS!
	DO IRAD=0,NRAD(ISORT)
	VBAR(IRAD)=0.D0
	ENDDO
	DO KATOM=1,NATOM
	IF(IS(KATOM).EQ.ISORT)THEN
	DO IRAD=1,NRAD(ISORT)
      VBAR(IRAD)=VBAR(IRAD)-R(IRAD,ISORT)/SQRT(4.D0*PI)*
     &(POT(IRAD,1,KATOM,1,1)+POT(IRAD,1,KATOM,NSPIN,1))/2.D0/
     &DBLE(NHSORT(ISORT))
	ENDDO
	ENDIF
	ENDDO
      VBAR(0)=2.D0*ZNUC(ISORT)
C  RECALCULATE CORE LEVELS 
	DO ILEV=1,NLEVT(ISORT)                 !!! over core levels
	IF(LEVC(ILEV,ISORT).EQ.1)THEN          !!! for core levels
	NQ=LEVN(ILEV,ISORT)
	LQ=LEVL(ILEV,ISORT)
	JQ=LEVJ(ILEV,ISORT)
	QJ=DBLE(JQ)/2.D0
	NODE=NQ-LQ-1
	ROOT=ELEV(ILEV,ISORT)
C  SOLVE DIRAC EQUATION 
	CALL LIB_CORSCH_ENYS(ROOT,NODE,LQ,JQ,DLOG,SMT(ISORT),
     &VBAR(0),APHI(0),APHID(0),NRAD(ISORT),H(ISORT),
     &R(0,ISORT),DR(0,ISORT),LCR)
	ELEV(ILEV,ISORT)=ROOT
	DO ISPIN=1,NSPIN
C  SET NEW CORE DENSITY FOR NON- OR SCALAR-RELATIVISTIC CASE
	IF(LCR.EQ.0.OR.LCR.EQ.1)THEN
	DO IRAD=0,NRAD(ISORT)
	RHOCOR(IRAD,ISORT,ISPIN)=RHOCOR(IRAD,ISORT,ISPIN)+
     &ZLEV(ILEV,ISORT)/DBLE(NSPIN)/SQRT(4.D0*PI)*
     &APHI(IRAD)**2
	ENDDO
C  SET CORE DENSITY IN THE FULLY RELATIVISTIC CASE
C  APHI and APHID are the LARGE and SMALL components
	ELSEIF(LCR.EQ.2)THEN
	DO IRAD=0,NRAD(ISORT)
	RHOCOR(IRAD,ISORT,ISPIN)=RHOCOR(IRAD,ISORT,ISPIN)+
     &ZLEV(ILEV,ISORT)/DBLE(NSPIN)/SQRT(4.D0*PI)*
     &(APHI(IRAD)**2+APHID(IRAD)**2)
	ENDDO
	ENDIF
	ENDDO
	ENDIF                                  !!! for core levels
	ENDDO                                  !!! over core levels
 1000 CONTINUE                               !!! over sorts
C  SET NEW CHARGE DENSITY
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	DO ISPIN=1,NSPIN
	DO IRAD=0,NRAD(ISORT)
	RHO(IRAD,1,IATOM,ISPIN,1)=RHO(IRAD,1,IATOM,ISPIN,1)+
     &RHOCOR(IRAD,ISORT,ISPIN)
	ENDDO
	ENDDO
	ENDDO
C  FIND CORE CHARGE IN UNIT-CELL
	CALL RHO_RENCOR_ZCOR(ZCMT,ZCTOT,ANORM)
C*****  Start Output added by KH
       OPEN(fh_func,file='func.dat',access='SEQUENTIAL',
     &	    POSITION='APPEND')
       WRITE(fh_func,*) '************ CORE DENSITY *********'
       WRITE(fh_func,*) (((RHOCOR(IRAD,ISORT,ISPIN),IRAD=0,NRAD(ISORT)),
     &                            ISORT=1,NSORT),ISPIN=1,NSPIN)
       CLOSE(fh_func)
C*****  Stop Output added by KH
C  PRINT CORE LEVELS
	CALL LIB_TLEVCHAR(TLEV,THED) 
	DO ISORT=1,NSORT
	IF(ICOR(ISORT).NE.0)THEN
	WRITE(IUN,10010)THED,TXTEL(ISORT),ZCOR(ISORT)
	IF(ABS(ANORM(ISORT)-1.D0).GT.1.D-01)WRITE(IUT,*)
     &'<RENCOR>:: UNUSUALLY LARGE RENORMALIZATION OF ZCOR'
	DO ILEV=1,NLEVT(ISORT)
	NQ=LEVN(ILEV,ISORT)
	LQ=LEVL(ILEV,ISORT)
	JQ=LEVJ(ILEV,ISORT)
	IF(LEVC(ILEV,ISORT).EQ.1)
     &WRITE(IUN,10020)TLEV(NQ,LQ,JQ),INT(ZLEV(ILEV,ISORT)),
     &ELEV(ILEV,ISORT),PRMT(LEVC(ILEV,ISORT))
	IF(LEVC(ILEV,ISORT).NE.1)
     &WRITE(IUN,10030)TLEV(NQ,LQ,JQ),INT(ZLEV(ILEV,ISORT)),
     &               PRMT(LEVC(ILEV,ISORT))
	ENDDO
	ENDIF
	ENDDO
C MEMORY DEALLOCATIONS
	DEALLOCATE(WORK1)
	DEALLOCATE(ZCMT)
	DEALLOCATE(ANORM)
	DEALLOCATE(VBAR)
	DEALLOCATE(APHI)
	DEALLOCATE(APHID)
10010 FORMAT(1X,A19,'  # el.  Levels(Ry) ',A10,'; Zcor=',G12.5)
10020 FORMAT(1X,A19,3X,I2,3X,G14.7,'; ',A8)
10030 FORMAT(1X,A19,3X,I2,3X,14X  ,'; ',A8)
	END





	SUBROUTINE RHO_RENCOR_ZCOR(ZCMT,ZCTOT,ANORM)
**************************************************************
*  Find core charge in the elementary cell                   *
**************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_CONTROL ,ONLY: LMTO,IASA,NOVR,NPFR              !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS          !!! from readini
     &                      ,IS,ILSV,NHSORT                   !!! from readini
      USE COM_SPHERE  ,ONLY: SMT,SASA,ZNUC,ZCOR               !!! from readini
      USE COM_DENDAT  ,ONLY: RHO,RHOCOR                       !!! from rhofull
      USE COM_RADMESH ,ONLY: NRAD,H,R,DR,WEIGHT,RL            !!! from radmesh
      USE COM_LABELS  ,ONLY: TXTAT,TXTEL,TXTSP                !!! from readini
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT                      !!! from setup
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8, ALLOCATABLE :: WORK1(:)
	REAL*8, ALLOCATABLE :: WORK2(:)
	DIMENSION ZCMT(NSORTMEM),ANORM(NSORTMEM)
	COMPLEX*16 ROVAL,DIM
	DATA PI/3.141592653589793D0/,DIM/(0.D0,1.D0)/
	SQPI4=2.D0*SQRT(PI)
C MEMORY ALLOCATIONS
      ALLOCATE(WORK1(0:NRADMEM))
      ALLOCATE(WORK2(0:NRADMEM))
C START CODE
	ZCTOT=0.D0
	ZCORT=0.D0
	DO ISORT=1,NSORT                  !!! over sorts
	ZCMT(ISORT)=0.D0
	DO ISPIN=1,NSPIN                  !!! over spins
C  FIND CHARGES
	DO IRAD=0,NRAD(ISORT)
	WORK1(IRAD)=RHOCOR(IRAD,ISORT,ISPIN)*
     &WEIGHT(IRAD,ISORT)/SQRT(4.D0*PI)
	ENDDO
	CALL LIB_QD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	ZCMT(ISORT)=ZCMT(ISORT)+WORK2(NRAD(ISORT))
      ENDDO                             !!! over spins
	ZCTOT=ZCTOT+ZCMT(ISORT)*NHSORT(ISORT)
	ZCORT=ZCORT+ZCOR(ISORT)*NHSORT(ISORT)
      ENDDO                             !!! over atoms
C  RENORMALIZE CORE DENSITY
	DO ISPIN=1,NSPIN
	DO ISORT=1,NSORT
	ANORM(ISORT)=1.D0
	IF(ZCOR(ISORT).GT.1.D-03)
     &ANORM(ISORT)=ZCOR(ISORT)/ZCMT(ISORT)
	DO IRAD=0,NRAD(ISORT)
	DO IATOM=1,NATOM
	IF(IS(IATOM).NE.ISORT)CYCLE
	ROC=RHOCOR(IRAD,ISORT,ISPIN)
	ROVAL=RHO(IRAD,1,IATOM,ISPIN,1)-ROC
	ROC=ROC*ANORM(ISORT)
	RHO(IRAD,1,IATOM,ISPIN,1)=ROVAL+ROC
	ENDDO
	RHOCOR(IRAD,ISORT,ISPIN)=RHOCOR(IRAD,ISORT,ISPIN)*ANORM(ISORT)
	ENDDO
	ENDDO
	ENDDO
C MEMORY DEALLOCATIONS
      DEALLOCATE(WORK1)
      DEALLOCATE(WORK2)
	END




