	SUBROUTINE RHO_RHOFILES(ICHN,FOPER,AOPER)
************************************************************
*  Operates with charge density files.                     *
************************************************************
C SET ARRAY SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                              !!! from setup
      USE COM_CONTROL, ONLY : LMTO,IASA,LRWF                      !!! from readini
      USE COM_PARAM,   ONLY : NATOM,NSORT,NSPIN,NORBS
     &                       ,IS,ILST,ILSB,ILSV                   !!! from readini
      USE COM_KAPPAR,  ONLY : NPAN,NKAP,EKAP                      !!! from readini
      USE COM_SPHERE,  ONLY : ZNUC,ZCOR,SMT                       !!! from readini
      USE COM_LATPAR,  ONLY : PAR,ORTH,OMEGAC,STRAIN              !!! from readini
      USE COM_LATTICE, ONLY : RBAS,GBAS,TAU,TAO                   !!! from readstr
      USE COM_DENDAT,  ONLY : RHO,RHOCOR,RHOPS,RHOPS1,POTFRZ      !!! from readscf
      USE COM_POTDAT,  ONLY :                         POTRWF      !!! from readscf
      USE COM_INPPAR,  ONLY : ENY,DNY,TNY,NODES,MNY               !!! from readini
      USE COM_RADMESH, ONLY : NRAD,R                              !!! from makerad
      USE COM_FFTMESH, ONLY : NFFTG                               !!! from makefft
      USE COM_PLWMESH, ONLY : NPLW,GPLW                           !!! from makeplw
      USE COM_SYMMLM,  ONLY : NSYM,LMSYM,SYM                      !!! from symmlm
      USE COM_FERMI,   ONLY : EF                                  !!! from ttrint1
      USE COM_MAGDAT,  ONLY : AXMAG                               !!! from ttrint1
	USE COM_LMTINP,  ONLY : SCSFILE,SCSMADE,SCFMADE             !!! from init
	USE COM_LMTOUT,  ONLY : ICSCF,SCFFILE,SCRFILE               !!! from init
      USE COM_UNIT,    ONLY : IUN,IUR,IUT                         !!! from setup
      USE COM_MASHDEP, ONLY : LENCMP,LENREL,LENINT                !!! from readini
C SET LOCAL VARIABLES
      IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER, INTRINSIC :: SIZE
	CHARACTER STATUS*3,FOPER*1,AOPER*1,FILE*130,TEXT*64
      LOGICAL EXIST
      DATA PI/3.141592653589793D0/
      IF(ICSCF.GT.0)FILE=SCFFILE
      IF(ICSCF.EQ.0)FILE=SCRFILE(ICHN)
C CHECK FILE
      INQUIRE(FILE=FILE,EXIST=EXIST)
      IF(.NOT.EXIST)STATUS='NEW'
      IF(     EXIST)STATUS='OLD'
C FILE REMOVAL
	IF(FOPER.EQ.'D')THEN
      OPEN(UNIT=ICHN,FILE=FILE,STATUS=STATUS,FORM='FORMATTED')
      CLOSE(UNIT=ICHN,STATUS='DELETE')
	ENDIF
C ARRAY ALLOCATION
	IF(AOPER.EQ.'A')THEN
C Memory allocations for the charge density
      IF(.NOT.ALLOCATED(RHO))
     &ALLOCATE(RHO(0:NRADMEM,NSYMMEM,NATOMMEM,NSPINMEM,NORBSMEM))
      SIZE_RHO=DBLE(SIZE(RHO)*LENCMP)/1024.D0**2
      IF(.NOT.ALLOCATED(RHOCOR))
     &ALLOCATE(RHOCOR(0:NRADMEM,NSORTMEM,NSPINMEM))
      SIZE_RHOCOR=DBLE(SIZE(RHOCOR)*LENREL)/1024.D0**2
      IF(.NOT.ALLOCATED(POTFRZ))
     &ALLOCATE(POTFRZ(0:NRADMEM,NSORTMEM,NSPINMEM))
      SIZE_POTFRZ=DBLE(SIZE(POTFRZ)*LENREL)/1024.D0**2
      CURMEM=CURMEM+SIZE_RHO+SIZE_RHOCOR+SIZE_POTFRZ
C Initialize
      DO IORBS=1,NORBS
      DO ISPIN=1,NSPIN
      DO IATOM=1,NATOM
      ISORT=IS(IATOM)
      DO IRAD=0,NRAD(ISORT)
      DO ISYM=1,NSYM(IATOM)
      RHO(IRAD,ISYM,IATOM,ISPIN,IORBS)=(0.D0,0.D0)
      ENDDO
      RHOCOR(IRAD,ISORT,ISPIN)=(0.D0,0.D0)
      POTFRZ(IRAD,ISORT,ISPIN)=POTRWF(IRAD,ISORT,ISPIN)
      ENDDO
      ENDDO
      ENDDO
      ENDDO
C Memory allocations for pseudodensity
      IF(NPLWMEM.NE.-1)THEN
      IF(.NOT.ALLOCATED(RHOPS))
     &ALLOCATE(RHOPS(0:NPLWMEM,NSPINMEM,NORBSMEM))
      SIZE_RHOPS=DBLE(SIZE(RHOPS)*LENCMP)/1024.D0**2
      IF(.NOT.ALLOCATED(RHOPS1))
     &ALLOCATE(RHOPS1(0:NPLWMEM,NSPINMEM,NORBSMEM))
      SIZE_RHOPS1=DBLE(SIZE(RHOPS1)*LENCMP)/1024.D0**2
      CURMEM=CURMEM+SIZE_RHOPS+SIZE_RHOPS1
      DO IORBS=1,NORBS
      DO ISPIN=1,NSPIN
      DO IPLW=0,NPLW
      RHOPS (IPLW,ISPIN,IORBS)=(0.D0,0.D0)
      RHOPS1(IPLW,ISPIN,IORBS)=(0.D0,0.D0)
      ENDDO
      ENDDO
      ENDDO
      ENDIF
      IF(TOTMEM.LT.CURMEM)TXTMEM='<RHOFILES> Subroutine'
      IF(TOTMEM.LT.CURMEM)TOTMEM=CURMEM
	ENDIF
C ******************************************************
C READ DATA FROM THE FILE
      IF(FOPER.EQ.'R')THEN
      IF(.NOT.EXIST)CALL RHOFILES_MESG01
      OPEN(UNIT=ICHN,FILE=FILE,STATUS='OLD',FORM='FORMATTED')
	READ(ICHN,FMT='(A)')TEXT
C Read control information:
      READ(ICHN,*)NATOM,NSORT,NSPIN,NORBS
	READ(ICHN,*)(IS(IATOM),IATOM=1,NATOM)
	READ(ICHN,*)RBAS,GBAS,PAR,ORTH,STRAIN,
     &((TAO(I,IATOM),I=1,3),IATOM=1,NATOM),
     &((TAU(I,IATOM),I=1,3),IATOM=1,NATOM),
     &(ZNUC(ISORT),ISORT=1,NSORT),
     &(SMT (ISORT),ISORT=1,NSORT),
     &((AXMAG(I,ISORT),I=1,3),ISORT=1,NSORT)
      READ(ICHN,*)
     &(NRAD(ISORT),ISORT=1,NSORT),
     &(NSYM(IATOM),IATOM=1,NATOM),
     &(ILSV(ISORT),ISORT=1,NSORT)
C READ: radial mesh
      READ(ICHN,*)((R(IRAD,ISORT),IRAD=0,NRAD(ISORT)),
     &ISORT=1,NSORT)
C READ: Charge density
      DO IATOM=1,NATOM
      ISORT=IS(IATOM)
      DO IORBS=1,NORBS
      DO ISPIN=1,NSPIN
      DO L=0,ILSV(ISORT)
	DO M=-L,L
	LM=L*(L+1)+M+1
	IF(SYM(LM,IATOM))THEN
	ISYM=LMSYM(LM,IATOM)
      READ(ICHN,*)LM0
      READ(ICHN,*)(RHO(IRAD,ISYM,IATOM,ISPIN,IORBS),IRAD=0,NRAD(ISORT))
	ENDIF
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C READ: core density, spherical potential.
      DO ISORT=1,NSORT
      DO ISPIN=1,NSPIN
      READ(ICHN,*)(RHOCOR(IRAD,ISORT,ISPIN),IRAD=0,NRAD(ISORT))
      READ(ICHN,*)(POTFRZ(IRAD,ISORT,ISPIN),IRAD=0,NRAD(ISORT))
	ENDDO
	ENDDO
C READ: pseudodensity
      READ(ICHN,*)RBAS,GBAS,ORTH,PAR,STRAIN,NPLW,NFFTG,
     &((TAO(I,IATOM),I=1,3),IATOM=1,NATOM),
     &((TAU(I,IATOM),I=1,3),IATOM=1,NATOM)
      IF(NPLW.NE.-1)THEN
	READ(ICHN,*)((GPLW(I,IPLW),I=1,3),IPLW=0,NPLW)
	DO IORBS=1,NORBS
	DO ISPIN=1,NSPIN
	READ(ICHN,*)(RHOPS (IPLW,ISPIN,IORBS),IPLW=0,NPLW)
	READ(ICHN,*)(RHOPS1(IPLW,ISPIN,IORBS),IPLW=0,NPLW)
	ENDDO
	ENDDO
	ELSEIF(NPLW.EQ.-1)THEN
	READ(ICHN,*)
	DO IORBS=1,NORBS
	DO ISPIN=1,NSPIN
	READ(ICHN,*)
	READ(ICHN,*)
	ENDDO
	ENDDO
	ENDIF
C READ: restart information
      READ(ICHN,*)NKAP(1),(ILST(ISORT),ISORT=1,NSORT),
     &(ILSB(ISORT),ISORT=1,NSORT)
      READ(ICHN,*)
     &((((ENY(L,ISORT,IKAP,1,ISPIN),L=0,ILST(ISORT)),
     &ISORT=1,NSORT),IKAP=1,NKAP(1)),ISPIN=1,NSPIN),
     &((((DNY(L,ISORT,IKAP,1,ISPIN),L=0,ILST(ISORT)),
     &ISORT=1,NSORT),IKAP=1,NKAP(1)),ISPIN=1,NSPIN),
     &(((MNY(L,ISORT,IKAP,1),L=0,ILST(ISORT)),
     &ISORT=1,NSORT),IKAP=1,NKAP(1)),
     &(((NODES(L,ISORT,IKAP,1),L=0,ILST(ISORT)),
     &ISORT=1,NSORT),IKAP=1,NKAP(1))
C READ: EFermi,SCFkey but do not modfy existing Ef information now
	READ(ICHN,*)EFRM,SCFMADE
	CLOSE(ICHN)
	ENDIF
C ******************************************************
C STORE DATA TO THE FILE
	IF(FOPER.EQ.'W')THEN
      OPEN(UNIT=ICHN,FILE=FILE,STATUS=STATUS,FORM='FORMATTED')
      CLOSE(UNIT=ICHN,STATUS='DELETE')
      OPEN(UNIT=ICHN,FILE=FILE,STATUS='NEW',FORM='FORMATTED')
	WRITE(ICHN,10100)
10100	FORMAT(1X,'<FILE=SCFFILE,INPUT=MODERN>')
C STORE: control information:
      WRITE(ICHN,*)NATOM,NSORT,NSPIN,NORBS
	WRITE(ICHN,*)(IS(IATOM),IATOM=1,NATOM)
      WRITE(ICHN,*)RBAS,GBAS,PAR,ORTH,STRAIN,
     &((TAO(I,IATOM),I=1,3),IATOM=1,NATOM),
     &((TAU(I,IATOM),I=1,3),IATOM=1,NATOM),
     &(ZNUC(ISORT),ISORT=1,NSORT),
     &(SMT (ISORT),ISORT=1,NSORT),
     &((AXMAG(I,ISORT),I=1,3),ISORT=1,NSORT)
      WRITE(ICHN,*)
     &(NRAD(ISORT),ISORT=1,NSORT),
     &(NSYM(IATOM),IATOM=1,NATOM),
     &(ILSV(ISORT),ISORT=1,NSORT)
C STORE: Radial mesh
      WRITE(ICHN,*)((R(IRAD,ISORT),IRAD=0,NRAD(ISORT)),
     &ISORT=1,NSORT)
C STORE: Charge density
      DO IATOM=1,NATOM
      ISORT=IS(IATOM)
      DO IORBS=1,NORBS
      DO ISPIN=1,NSPIN
      DO L=0,ILSV(ISORT)
	DO M=-L,L
	LM=L*(L+1)+M+1
	IF(SYM(LM,IATOM))THEN
	ISYM=LMSYM(LM,IATOM)
      WRITE(ICHN,*)LM
      WRITE(ICHN,*)(RHO(IRAD,ISYM,IATOM,ISPIN,IORBS),IRAD=0,NRAD(ISORT))
	ENDIF
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      ENDDO
C STORE: core density, spherical potential.
      DO ISORT=1,NSORT
      DO ISPIN=1,NSPIN
      WRITE(ICHN,*)(RHOCOR(IRAD,ISORT,ISPIN),IRAD=0,NRAD(ISORT))
      WRITE(ICHN,*)(POTFRZ(IRAD,ISORT,ISPIN),IRAD=0,NRAD(ISORT))
      ENDDO
      ENDDO
C STORE: pseudodensity
      WRITE(ICHN,*)RBAS,GBAS,ORTH,PAR,STRAIN,NPLW,NFFTG,
     &((TAO(I,IATOM),I=1,3),IATOM=1,NATOM),
     &((TAU(I,IATOM),I=1,3),IATOM=1,NATOM)
      IF(NPLW.NE.-1)THEN
      WRITE(ICHN,*)((GPLW(I,IPLW),I=1,3),IPLW=0,NPLW)
      DO IORBS=1,NORBS
      DO ISPIN=1,NSPIN
      WRITE(ICHN,*)(RHOPS (IPLW,ISPIN,IORBS),IPLW=0,NPLW)
      WRITE(ICHN,*)(RHOPS1(IPLW,ISPIN,IORBS),IPLW=0,NPLW)
      ENDDO
      ENDDO
      ELSEIF(NPLW.EQ.-1)THEN
      WRITE(ICHN,*)
      DO IORBS=1,NORBS
      DO ISPIN=1,NSPIN
      WRITE(ICHN,*)
      WRITE(ICHN,*)
      ENDDO
      ENDDO
      ENDIF
C STORE: restart information
      WRITE(ICHN,*)NKAP(1),(ILST(ISORT),ISORT=1,NSORT),
     &(ILSB(ISORT),ISORT=1,NSORT)
      WRITE(ICHN,*)
     &((((ENY(L,ISORT,IKAP,1,ISPIN),L=0,ILST(ISORT)),
     &ISORT=1,NSORT),IKAP=1,NKAP(1)),ISPIN=1,NSPIN),
     &((((DNY(L,ISORT,IKAP,1,ISPIN),L=0,ILST(ISORT)),
     &ISORT=1,NSORT),IKAP=1,NKAP(1)),ISPIN=1,NSPIN),
     &(((MNY(L,ISORT,IKAP,1),L=0,ILST(ISORT)),
     &ISORT=1,NSORT),IKAP=1,NKAP(1)),
     &(((NODES(L,ISORT,IKAP,1),L=0,ILST(ISORT)),
     &ISORT=1,NSORT),IKAP=1,NKAP(1))
C STORE: EFermi,SCFkey
      WRITE(ICHN,*)EF,SCFMADE
	CLOSE(ICHN)
	ENDIF ! of store selection
C DEALLOCATE DENSITY
      IF(AOPER.EQ.'D')THEN
      SIZE_RHO=DBLE(SIZE(RHO)*LENCMP)/1024.D0**2
	DEALLOCATE(RHO)
      SIZE_RHOCOR=DBLE(SIZE(RHOCOR)*LENREL)/1024.D0**2
	DEALLOCATE(RHOCOR)
      SIZE_POTFRZ=DBLE(SIZE(POTFRZ)*LENREL)/1024.D0**2
	DEALLOCATE(POTFRZ)
      CURMEM=CURMEM-SIZE_RHO-SIZE_RHOCOR-SIZE_POTFRZ
	IF(NPLWMEM.NE.-1)THEN
      SIZE_RHOPS=DBLE(SIZE(RHOPS)*LENCMP)/1024.D0**2
	DEALLOCATE(RHOPS)
      SIZE_RHOPS1=DBLE(SIZE(RHOPS1)*LENCMP)/1024.D0**2
	DEALLOCATE(RHOPS1)
      CURMEM=CURMEM-SIZE_RHOPS-SIZE_RHOPS1
	ENDIF
      ENDIF
	CONTAINS
C ERROR HANDLINGS
      SUBROUTINE RHOFILES_MESG01
      WRITE(IUT,*)'Terminated in <RHOFILES>:'
      WRITE(IUT,*)'Input data file ',FILE
      WRITE(IUT,*)'cannot be found. Check for its existence'
      WRITE(IUT,*)'and/or correct path.'
      CALL FULLSTOP(' ')
      END SUBROUTINE RHOFILES_MESG01
      SUBROUTINE RHOFILES_MESG02(CHARV,LSIZE)
      CHARACTER CHARV*(*)
      WRITE(IUT,*)'Terminated in <RHOFILES>:'
      WRITE(IUT,*)'Memory allocation problem detected from'
      WRITE(IUT,*)'the system. Complex array '//CHARV//' of the size:'
      WRITE(IUT,*) DBLE(LSIZE*LENCMP)/1024.D0**2,' Mbyte'
      WRITE(IUT,*)'cannot be allocated.'
      CALL FULLSTOP(' ')
      END SUBROUTINE RHOFILES_MESG02
      END SUBROUTINE RHO_RHOFILES
