	SUBROUTINE RHO_RHOFUL
**********************************************************
* The calculation of the  full valence density           *
* whithin MT-spheres by one-center expansions.           *
**********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                          !!! from setup
      USE COM_CONTROL ,ONLY: LMTO,IASA                        !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS          !!! from readini
     &                      ,IS,ILST,ILSB,ILSV,LRTV
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP,EK                !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN,IATS,ISTS            !!! from readini
      USE COM_SPHERE  ,ONLY: ZNUC,SMT, ZCOR,SASA              !!! from readini KH
      USE COM_SYMMLM  ,ONLY: SYM,LMSYM                        !!! from symlmm
      USE COM_POTDAT  ,ONLY: POTRWF                           !!! from potfull
      USE COM_DENDAT  ,ONLY: RHO                              !!! from rhofull
      USE COM_INPPAR  ,ONLY: ENY,DNY                          !!! from readini
      USE COM_LMTPAR  ,ONLY: GAM,AAH,BBH,AAJ,BBJ              !!! from potpar
      USE COM_HAMPAR  ,ONLY: ATOSHH=>HPARHH                   !!! from tospar
     &                      ,ATOSJH=>HPARJH
     &                      ,ATOSHJ=>HPARHJ
     &                      ,ATOSJJ=>HPARJJ
      USE COM_RADMESH ,ONLY: NRAD,H,R,DR,WEIGHT,RL            !!! from radmesh
      USE COM_GAUNT   ,ONLY: C                                !!! from gdata
      USE COM_LABELS  ,ONLY: TXTAT,TXTEL,TXTSP                !!! from readini
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT                      !!! from setup
      USE COM_CHANNELS,ONLY: IUTOS                            !!! from readini
      USE COM_MASHDEP ,ONLY: LENREL,LENCMP                    !!! from readini
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER, INTRINSIC :: SIZE
	REAL*8, ALLOCATABLE :: FI(:,:)
	REAL*8, ALLOCATABLE :: FID(:,:)
	REAL*8, ALLOCATABLE :: FIP(:,:)
	REAL*8, ALLOCATABLE :: FIDP(:,:)
	REAL*8, ALLOCATABLE :: FIDDS(:)
	REAL*8, ALLOCATABLE :: FIDDPS(:)
	COMPLEX*16, ALLOCATABLE :: FIH(:,:,:,:)
	COMPLEX*16, ALLOCATABLE :: FIJ(:,:,:,:)
	COMPLEX*16 CGNT,T(4)
	LOGICAL LOG1,LOG
C*****  Start Output added by KH
	COMPLEX*16, ALLOCATABLE :: RHOSEMCR(:,:,:,:,:) !KH
	COMPLEX*16          :: t_rho                        !KH
	INTEGER, PARAMETER  :: fh_func = 598 ! File handle added by KH
	REAL*8              :: ZVALT
C       Stop Output added by KH
	DATA PI/3.141592653589793D0/
      CALL ABORTNOW()
C MEMORY ALLOCATIONS
	ALLOCATE(FI(0:NRADMEM,0:LMAXTMEM))
	ALLOCATE(FID(0:NRADMEM,0:LMAXTMEM))
	ALLOCATE(FIP(0:NRADMEM,0:LMAXTMEM))
	ALLOCATE(FIDP(0:NRADMEM,0:LMAXTMEM))
	ALLOCATE(FIDDS(0:LMAXTMEM))
	ALLOCATE(FIDDPS(0:LMAXTMEM))
	ALLOCATE(FIH(0:NRADMEM,0:LMAXTMEM,NKAPMEM,NSPINMEM))
	ALLOCATE(FIJ(0:NRADMEM,0:LMAXTMEM,NKAPMEM,NSPINMEM))

C*****  Start Output added by KH
      ALLOCATE(RHOSEMCR(0:NRADMEM,NSYMMEM,NATOMMEM,NSPINMEM,NORBSMEM)) !KH
      OPEN(fh_func,file='func.dat',form='formatted',status='unknown')
      DO ISORT=1,NSORT
      WRITE(fh_func,*) NRAD(ISORT), ILST(ISORT), NSPIN
      ENDDO
      WRITE(fh_func,*) '*** SYM DATA ****'
      WRITE(fh_func,*) LIMVMEM, NATOMMEM
      WRITE(fh_func,*) ((SYM(LM,IATOM),LM=1,LIMVMEM),IATOM=1,NATOMMEM)
      WRITE(fh_func,*) ((LMSYM(LM,IATOM),LM=1,LIMVMEM),IATOM=1,NATOMMEM)
      WRITE(fh_func,*) '*** Radial mesh *****'
      WRITE(fh_func,*)((R(IRAD,ISORT),IRAD=0,NRAD(ISORT)),ISORT=1,NSORT)! Radial mesh
      WRITE(fh_func,*) '*** Gaunt coefficients ****'
      WRITE(fh_func,*) LMAXCMEM+1, LIMCMEM
      WRITE(fh_func,*) (((C(L,L1,L2),L=0,LMAXCMEM),L1=1,LIMCMEM),
     &                        L2=1,LIMCMEM)
C*****  Stop Output added by KH

	
      SIZE_FIS=4.D0*DBLE(SIZE(FI)*LENREL)/1024.D0**2
      SIZE_FIH=2.D0*DBLE(SIZE(FIH)*LENCMP)/1024.D0**2
      CURMEM=CURMEM+SIZE_FIS+SIZE_FIH
      IF(TOTMEM.LT.CURMEM)TXTMEM='<RHOFULL> Subroutine'
      IF(TOTMEM.LT.CURMEM)TOTMEM=CURMEM
C START CODE
	SQPI4=2.D0*SQRT(PI)
	DO 6000 IPAN=1,NPAN                    !!! over panels
	NSHIFT=0
	DO JPAN=1,NPAN
	IF(JPAN.LT.IPAN)
     &NSHIFT=NSHIFT+NKAP(JPAN)**2*NATOM*NSPIN*NORBS
      ENDDO
	DO 5000 IATOM=1,NATOM                  !!! over atoms in cell
	ISORT=IS(IATOM)
	DO JSPIN=1,NSPIN
	DO IKAP=1,NKAP(IPAN)                  !!! over energies
      CALL LIB_RADSCH_PHIS(ENY(0,ISORT,IKAP,IPAN,JSPIN),FI,FIP,FID,
     &FIDP,FIDDS,FIDDPS,SMT(ISORT),POTRWF(0,ISORT,JSPIN),
     &ILST(ISORT),NRAD(ISORT),H(ISORT),R(0,ISORT),DR(0,ISORT),
     &LRTV(ISORT))
	DO L=0,ILST(ISORT)
	DO IRAD=0,NRAD(ISORT)
	FIH(IRAD,L,IKAP,JSPIN)=AAH(L,ISORT,IKAP,IPAN,JSPIN)*
     &FI(IRAD,L)+BBH(L,ISORT,IKAP,IPAN,JSPIN)*FIP(IRAD,L)
	FIJ(IRAD,L,IKAP,JSPIN)=AAJ(L,ISORT,IKAP,IPAN,JSPIN)*
     &FI(IRAD,L)+BBJ(L,ISORT,IKAP,IPAN,JSPIN)*FIP(IRAD,L)
	ENDDO 
	ENDDO 
      ENDDO                                  !!! over energies
	ENDDO                                  !!! over spins
	DO 4000 IORBS=1,NORBS                  !!! over spins
	DO 3000 IUPDN=1,NSPIN                  !!! over spins
	IF(IORBS.EQ.1)THEN
	ISPIN1=IUPDN
	ISPIN =IUPDN
	ELSEIF(IORBS.EQ.2)THEN
	ISPIN1=IUPDN
	ISPIN =NSPIN+1-IUPDN
	ENDIF
	DO L2=0,ILSV(ISORT)                    !!! over l2
	DO M2=-L2,L2                           !!! over m2
	LM2=L2*(L2+1)+M2+1
	IF(SYM(LM2,IATOM))THEN
	ISYM=LMSYM(LM2,IATOM)
	DO IRAD=0,NRAD(ISORT)                  !!! over radial mesh
	IF(IPAN.EQ.1)RHO(IRAD,ISYM,IATOM,IUPDN,IORBS)=(0.D0,0.D0)
	IF(IPAN.EQ.2.OR.NPAN.EQ.1)
     &RHOSEMCR(IRAD,ISYM,IATOM,IUPDN,IORBS)=(0.D0,0.D0)
      ENDDO                                  !!! over radial mesh
	ENDIF
      ENDDO                                  !!! over m2
      ENDDO                                  !!! over l2
	DO 2000 IKAP1=1,NKAP(IPAN)             !!! over energies
	DO 1000 IKAP=1,NKAP(IPAN)              !!! over energies
	IREC=IKAP1+NKAP(IPAN)*(IKAP-1)+NKAP(IPAN)**2*(IATOM-1)+
     &NKAP(IPAN)**2*NATOM*(IUPDN-1)+NKAP(IPAN)**2*NATOM*NSPIN*(IORBS-1)+
     &NSHIFT
	READ(IUTOS,REC=IREC)
     &((ATOSHH(L1M1,LM,IATOM),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((ATOSJH(L1M1,LM,IATOM),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((ATOSHJ(L1M1,LM,IATOM),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &((ATOSJJ(L1M1,LM,IATOM),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2)
	DO L1=0,ILST(ISORT)                    !!! over l1
	LOG1=.FALSE.
	IF(LTPAN(L1,IATOM,IKAP1,IPAN))LOG1=.TRUE.
	DO M1=-L1,L1                           !!! over m1
	LM1=L1*(L1+1)+M1+1
	DO L=0,ILST(ISORT)                     !!! over l
	LOG=.FALSE.
	IF(LTPAN(L,IATOM,IKAP,IPAN))LOG=.TRUE.
	DO M=-L,L                              !!! over m
	LM=L*(L+1)+M+1
	DO L2=ABS(L1-L),L1+L,2                 !!! over l2 (expansion of ro)
	IF(L2.LE.ILSV(ISORT))THEN
	M2=M-M1
	LM2=L2*(L2+1)+M2+1
	IF(ABS(M2).LE.L2)THEN                  !!! over m2 (expansion of ro)
	IF(SYM(LM2,IATOM))THEN
	ISYM=LMSYM(LM2,IATOM)
	CGNT=(0.D0,1.D0)**(L-L1-L2)*C(L2/2,LM,LM1)
	DO IRAD=0,NRAD(ISORT)                  !!! over radial mesh
	t_rho=0
	IF(LOG1.AND.LOG) t_rho=
     &(ATOSHH(LM1,LM,IATOM)*
     &CONJG(FIH(IRAD,L1,IKAP1,ISPIN1))*
     &FIH(IRAD,L,IKAP,ISPIN))*CGNT
	IF(LOG1) t_rho = t_rho -
     &(ATOSHJ(LM1,LM,IATOM)*
     &CONJG(FIH(IRAD,L1,IKAP1,ISPIN1))*
     &FIJ(IRAD,L,IKAP,ISPIN)*GAM(L,ISORT))*CGNT
	IF(LOG) t_rho = t_rho - 
     &(ATOSJH(LM1,LM,IATOM)*
     &CONJG(FIJ(IRAD,L1,IKAP1,ISPIN1))*
     &FIH(IRAD,L,IKAP,ISPIN)*GAM(L1,ISORT))*CGNT
	t_rho = t_rho + 
     &(ATOSJJ(LM1,LM,IATOM)*
     &CONJG(FIJ(IRAD,L1,IKAP1,ISPIN1))*
     &FIJ(IRAD,L,IKAP,ISPIN)*GAM(L1,ISORT)*
     &GAM(L,ISORT))*CGNT
	
      RHO(IRAD,ISYM,IATOM,IUPDN,IORBS)=
     &RHO(IRAD,ISYM,IATOM,IUPDN,IORBS) + t_rho
      IF (IPAN.NE.1) RHOSEMCR(IRAD,ISYM,IATOM,IUPDN,IORBS)=
     &RHOSEMCR(IRAD,ISYM,IATOM,IUPDN,IORBS)+t_rho
      ENDDO                                  !!! over radial mesh
      ENDIF
      ENDIF                                  !!! over m2
      ENDIF                                  !!!      l2
      ENDDO                                  !!! over l2 
      ENDDO                                  !!! over m
      ENDDO                                  !!! over l
      ENDDO                                  !!! over m1
      ENDDO                                  !!! over l1
1000  CONTINUE                               !!! over energies
2000  CONTINUE                               !!! over energies
3000  CONTINUE                               !!! over spins
4000  CONTINUE                               !!! over iorbs

C*****  Start Output added by KH
      IF (IPAN.EQ.1) THEN
      WRITE(fh_func,*) '*** RADIAL FUNCTIONS ****'
      WRITE(fh_func,*) (((FIH(IRAD,L,1,JSPIN),IRAD=0,NRAD(ISORT)),
     &                               L=0,ILST(ISORT)),JSPIN=1,NSPIN)
      WRITE(fh_func,*) (((FIJ(IRAD,L,1,JSPIN),IRAD=0,NRAD(ISORT)),
     &                               L=0,ILST(ISORT)),JSPIN=1,NSPIN)
      WRITE(fh_func,*) '*** GAM data ****'
      WRITE(fh_func,*) (GAM(L,isort),L=0,ILST(ISORT)+1)
      ENDIF
C*****  Stop Output added by KH
	
5000  CONTINUE                               !!! over all atoms in cell
6000  CONTINUE                               !!! over panels
	
C*****  Start Output added by KH
      WRITE(fh_func,*) '************ SEMICORE DENSITY *********'
      DO IATOM=1,NATOM
      ISORT=IS(IATOM)
      DO IORBS=1,NORBS
      DO ISPIN=1,NSPIN
      DO L=0,ILSV(ISORT)
      DO M=-L,L
      LM=L*(L+1)+M+1
      IF(SYM(LM,IATOM))THEN
      ISYM=LMSYM(LM,IATOM)
      WRITE(fh_func,*)LM
      WRITE(fh_func,*)
     &(RHOSEMCR(IRAD,ISYM,IATOM,ISPIN,IORBS),IRAD=0,NRAD(ISORT))
      ENDIF
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      WRITE(fh_func,*) '********* RADIAL MESH DETAILS ***********'
      WRITE(fh_func,*) 'H(isort)'
      WRITE(fh_func,*) (H(isort),isort=1,nsort)
      WRITE(fh_func,*) 'weight(r,isort)'
      WRITE(fh_func,*)
     &((weight(irad,isort),irad=0,nrad(isort)),isort=1,nsort)
C     Finds valence charge to print it to func.dat
      ZVALT=0
      DO ISPIN=1,NSPIN	!!! over spins
      DO IATOM=1,NATOM	!!! over atoms
      ISORT=IS(IATOM)
      ZVALT=ZVALT+(ZNUC(ISORT)-ZCOR(ISORT))/DBLE(NSPIN)
      ENDDO		!!! over atoms
      ENDDO		!!! over spins
      WRITE(fh_func,*) '************ VALENCE CHARGE ***********'
      WRITE(fh_func,*) ZVALT  ! Valence charge
      WRITE(fh_func,*) '*********** atomic sphere radius ******'
      WRITE(fh_func,*) (SASA(isort),isort=1,nsort)
      WRITE(fh_func,*) '********** MT-sphere radius ***********'
      WRITE(fh_func,*) (SMT(isort),isort=1,nsort)
      CLOSE(fh_func)
C*****  Stop Output added by KH

C       MEMORY DEALLOCATIONS
      DEALLOCATE(FI,FID,FIP,FIDP,FIDDS,FIDDPS,FIH,FIJ)
      DEALLOCATE(RHOSEMCR) !KH
      CURMEM=CURMEM-SIZE_FIS-SIZE_FIH
	END


	SUBROUTINE RHO_SRODOT
**********************************************************
* The calculation of the change in charge density due to *
* shift in Eny. Only for evaluating linear response      *
* corrections to atomic forces is necessary.             *
**********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                          !!! from setup
      USE COM_CONTROL ,ONLY: LMTO,IASA,NPFR                   !!! from readini
      USE COM_PARAM   ,ONLY: NATOM,NSORT,NSPIN,NORBS          !!! from readini
     &                      ,IS,ILST,ILSB,ILSV,LRTV
      USE COM_KAPPAR  ,ONLY: NPAN,NKAP,EKAP,EK                !!! from readini
      USE COM_PANPAR  ,ONLY: LTPAN,LSPAN,IATS,ISTS            !!! from readini
      USE COM_SPHERE  ,ONLY: ZNUC,SMT                         !!! from readini
      USE COM_SYMMLM  ,ONLY: SYM,LMSYM                        !!! from symlmm
      USE COM_POTDAT  ,ONLY: POT,POTRWF                       !!! from potfull
      USE COM_INPPAR  ,ONLY: ENY,DNY                          !!! from readini
      USE COM_LMTPAR  ,ONLY: GAM,AAH,BBH,AAJ,BBJ              !!! from potpar
      USE COM_ASAPAR  ,ONLY: HS,BS,DH,DJ                      !!! from potpar
	USE COM_PULAYF  ,ONLY: RESRHO                           !!! from rhodot
      USE COM_HAMPAR  ,ONLY: ATOSHH=>HPARHH                   !!! from tospar
     &                      ,ATOSJH=>HPARJH
     &                      ,ATOSHJ=>HPARHJ
     &                      ,ATOSJJ=>HPARJJ
      USE COM_RADMESH ,ONLY: NRAD,H,R,DR,WEIGHT,RL            !!! from radmesh
      USE COM_GAUNT   ,ONLY: C                                !!! from gdata
      USE COM_LABELS  ,ONLY: TXTAT,TXTEL,TXTSP                !!! from readini
      USE COM_UNIT    ,ONLY: IUN,IUR,IUT                      !!! from setup
      USE COM_CHANNELS,ONLY: IUTOS                            !!! from readini
      USE COM_MASHDEP ,ONLY: LENREL,LENCMP                    !!! from readini
C SET LOCAL VARIABLES
	IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER, INTRINSIC :: SIZE
      REAL*8, ALLOCATABLE :: FI(:,:)
      REAL*8, ALLOCATABLE :: FID(:,:)
      REAL*8, ALLOCATABLE :: FIP(:,:)
      REAL*8, ALLOCATABLE :: FIDP(:,:)
      REAL*8, ALLOCATABLE :: FIPP(:,:)
      REAL*8, ALLOCATABLE :: FIDPP(:,:)
      REAL*8, ALLOCATABLE :: RHODOT(:,:,:)
      COMPLEX*16, ALLOCATABLE :: FIH(:,:,:)
      COMPLEX*16, ALLOCATABLE :: FIJ(:,:,:)
      COMPLEX*16, ALLOCATABLE :: FIHP(:,:,:)
      COMPLEX*16, ALLOCATABLE :: FIJP(:,:,:)
      COMPLEX*16, ALLOCATABLE :: WORK1(:)
      COMPLEX*16, ALLOCATABLE :: WORK2(:)
      COMPLEX*16, ALLOCATABLE :: RODOT(:,:)
	COMPLEX*16 CGNT,T(4),AAHP,AAJP,BBHP,BBJP
	LOGICAL LOG1,LOG
	DATA PI/3.141592653589793D0/
	IF(NPFR.EQ.0)RETURN
C MEMORY ALLOCATIONS
	ALLOCATE(RESRHO(NATOMMEM,NPANMEM,NSPINMEM))
      ALLOCATE(FI(0:NRADMEM,0:LMAXTMEM))
      ALLOCATE(FID(0:NRADMEM,0:LMAXTMEM))
      ALLOCATE(FIP(0:NRADMEM,0:LMAXTMEM))
      ALLOCATE(FIDP(0:NRADMEM,0:LMAXTMEM))
      ALLOCATE(FIPP(0:NRADMEM,0:LMAXTMEM))
      ALLOCATE(FIDPP(0:NRADMEM,0:LMAXTMEM))
      ALLOCATE(FIH(0:NRADMEM,0:LMAXTMEM,NKAPMEM))
      ALLOCATE(FIJ(0:NRADMEM,0:LMAXTMEM,NKAPMEM))
      ALLOCATE(FIHP(0:NRADMEM,0:LMAXTMEM,NKAPMEM))
      ALLOCATE(FIJP(0:NRADMEM,0:LMAXTMEM,NKAPMEM))
      ALLOCATE(RODOT(0:NRADMEM,NSYMMEM))
      ALLOCATE(RHODOT(0:NRADMEM,NSORTMEM,NSPINMEM))
      SIZE_FIS=6.D0*DBLE(SIZE(FI)*LENREL)/1024.D0**2
      SIZE_FIH=4.D0*DBLE(SIZE(FIH)*LENCMP)/1024.D0**2
      SIZE_RODOT=DBLE(SIZE(RODOT)*LENCMP)/1024.D0**2
      SIZE_RHODOT=DBLE(SIZE(RHODOT)*LENREL)/1024.D0**2
      CURMEM=CURMEM+SIZE_FIS+SIZE_FIH+SIZE_RODOT+SIZE_RHODOT
      IF(TOTMEM.LT.CURMEM)TXTMEM='<RHODOT> Subroutine'
      IF(TOTMEM.LT.CURMEM)TOTMEM=CURMEM
      ALLOCATE(WORK1(0:NRADMEM))
      ALLOCATE(WORK2(0:NRADMEM))
C START CODE
	SQPI4=2.D0*SQRT(PI)
	DO 3000 ISPIN=1,NSPIN                  !!! over spins
	DO 2000 IPAN=1,NPAN                    !!! over panels
	NSHIFT=0
	DO JPAN=1,NPAN
	IF(JPAN.LT.IPAN)
     &NSHIFT=NSHIFT+NKAP(JPAN)**2*NATOM*NSPIN*NORBS
      ENDDO
	DO 1000 IATOM=1,NATOM                  !!! over atoms in cell
	DO IKAP=1,NKAP(IPAN)                   !!! over energies
	ISORT=IS(IATOM)
      CALL LIB_RADSCH_PHIP(ENY(0,ISORT,IKAP,IPAN,ISPIN),FI,FIP,FID,
     &FIDP,FIPP,FIDPP,SMT(ISORT),POTRWF(0,ISORT,ISPIN),ILST(ISORT),
     &NRAD(ISORT),H(ISORT),R(0,ISORT),DR(0,ISORT),LRTV(ISORT))
	DO L=0,ILST(ISORT)
C     DNYPP=SMT(ISORT)*FIDPP(NRAD(ISORT),L)/FIPP(NRAD(ISORT),L)
	DNYPP=DNY(L,ISORT,IKAP,IPAN,ISPIN)     !!! <--- property !!!
	AAHP=SMT(ISORT)*FIPP(NRAD(ISORT),L)*
     &HS(L,ISORT,IKAP,IPAN,ISPIN)*
     &(DH(L,ISORT,IKAP,IPAN,ISPIN)-DNYPP)
	AAJP=SMT(ISORT)*FIPP(NRAD(ISORT),L)*
     &BS(L,ISORT,IKAP,IPAN,ISPIN)* 
     &(DJ(L,ISORT,IKAP,IPAN,ISPIN)-DNYPP)
	BBHP=-AAH(L,ISORT,IKAP,IPAN,ISPIN) 
	BBJP=-AAJ(L,ISORT,IKAP,IPAN,ISPIN) 
	DO IRAD=0,NRAD(ISORT)
	FIH(IRAD,L,IKAP)=AAH(L,ISORT,IKAP,IPAN,ISPIN)*FI(IRAD,L)+
     &BBH(L,ISORT,IKAP,IPAN,ISPIN)*FIP(IRAD,L)
	FIJ(IRAD,L,IKAP)=AAJ(L,ISORT,IKAP,IPAN,ISPIN)*FI(IRAD,L)+
     &BBJ(L,ISORT,IKAP,IPAN,ISPIN)*FIP(IRAD,L)
	FIHP(IRAD,L,IKAP)=AAH(L,ISORT,IKAP,IPAN,ISPIN)*FIP(IRAD,L)+
     &BBH(L,ISORT,IKAP,IPAN,ISPIN)*FIPP(IRAD,L)+AAHP*FI(IRAD,L)+
     &BBHP*FIP(IRAD,L)
	FIJP(IRAD,L,IKAP)=AAJ(L,ISORT,IKAP,IPAN,ISPIN)*FIP(IRAD,L)+
     &BBJ(L,ISORT,IKAP,IPAN,ISPIN)*FIPP(IRAD,L)+AAJP*FI(IRAD,L)+
     &BBJP*FIP(IRAD,L)
	ENDDO
	ENDDO
      ENDDO                                  !!! over energies
C  SET CONTRIBUTION FOR GIVEN SPIN,L PANEL TO ZERO
	DO L2=0,ILSV(ISORT)                    !!! over l2
	DO M2=-L2,L2                           !!! over m2
	LM2=L2*(L2+1)+M2+1
	IF(SYM(LM2,IATOM))THEN
	ISYM=LMSYM(LM2,IATOM)
	DO IRAD=0,NRAD(ISORT)                  !!! over radial mesh
	RODOT(IRAD,ISYM)=(0.D0,0.D0)
      ENDDO                                  !!! over radial mesh
	ENDIF
      ENDDO                                  !!! over m2
      ENDDO                                  !!! over l2
	IF(IPAN.EQ.1)THEN
	DO IRAD=0,NRAD(ISORT)
	RHODOT(IRAD,ISORT,ISPIN)=0.D0
	ENDDO 
	ENDIF
	DO IKAP1=1,NKAP(IPAN)                  !!! over energies
	DO IKAP=1,NKAP(IPAN)                   !!! over energies
	IREC=IKAP1+NKAP(IPAN)*(IKAP-1)+NKAP(IPAN)**2*(IATOM-1)+
     &NKAP(IPAN)**2*NATOM*(ISPIN-1)+NSHIFT
	READ(IUTOS,REC=IREC)
     &((ATOSHH(L1M1,LM,IATOM),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((ATOSJH(L1M1,LM,IATOM),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &((ATOSHJ(L1M1,LM,IATOM),
     &L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &((ATOSJJ(L1M1,LM,IATOM),
     &L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2)
	DO L1=0,ILST(ISORT)                    !!! over l1
	LOG1=.FALSE.
	IF(LTPAN(L1,IATOM,IKAP1,IPAN))LOG1=.TRUE.
	DO M1=-L1,L1                           !!! over m1
	LM1=L1*(L1+1)+M1+1
	DO L=0,ILST(ISORT)                     !!! over l
	LOG=.FALSE.
	IF(LTPAN(L,IATOM,IKAP,IPAN))LOG=.TRUE.
	DO M=-L,L                              !!! over m
	LM=L*(L+1)+M+1
	DO L2=ABS(L1-L),L1+L,2                 !!! over l2 (expansion of ro)
	M2=M-M1
	LM2=L2*(L2+1)+M2+1
	IF(ABS(M2).LE.L2.AND.L2.LE.ILSV(ISORT))THEN
	IF(SYM(LM2,IATOM))THEN
	ISYM=LMSYM(LM2,IATOM)
	CGNT=(0.D0,1.D0)**(L-L1-L2)*C(L2/2,LM,LM1)
	DO IRAD=0,NRAD(ISORT)                  !!! over radial mesh
	IF(LOG1.AND.LOG)
     &RODOT(IRAD,ISYM)=RODOT(IRAD,ISYM)+
     &ATOSHH(LM1,LM,IATOM)*
     &(CONJG(FIH(IRAD,L1,IKAP1))*FIHP(IRAD,L,IKAP)+
     &CONJG(FIHP(IRAD,L1,IKAP1))*FIH(IRAD,L,IKAP))*CGNT
	IF(LOG1)
     &RODOT(IRAD,ISYM)=RODOT(IRAD,ISYM)-
     &ATOSHJ(LM1,LM,IATOM)*
     &(CONJG(FIH(IRAD,L1,IKAP1))*FIJP(IRAD,L,IKAP)+
     &CONJG(FIHP(IRAD,L1,IKAP1))*FIJ(IRAD,L,IKAP))*
     &GAM(L,ISORT)*CGNT
	IF(LOG)
     &RODOT(IRAD,ISYM)=RODOT(IRAD,ISYM)-
     &ATOSJH(LM1,LM,IATOM)*
     &(CONJG(FIJ(IRAD,L1,IKAP1))*FIHP(IRAD,L,IKAP)+
     &CONJG(FIJP(IRAD,L1,IKAP1))*FIH(IRAD,L,IKAP))*
     &GAM(L1,ISORT)*CGNT
	RODOT(IRAD,ISYM)=RODOT(IRAD,ISYM)+
     &ATOSJJ(LM1,LM,IATOM)*
     &(CONJG(FIJ(IRAD,L1,IKAP1))*FIJP(IRAD,L,IKAP)+
     &CONJG(FIJP(IRAD,L1,IKAP1))*FIJ(IRAD,L,IKAP))*
     &GAM(L1,ISORT)*GAM(L,ISORT)*CGNT
      ENDDO                                  !!! over radial mesh
	ENDIF
	ENDIF                                  !!! over m2 (expansion of ro)
      ENDDO                                  !!! over l2 (expansion of ro)
      ENDDO                                  !!! over m
      ENDDO                                  !!! over l
      ENDDO                                  !!! over m1
      ENDDO                                  !!! over l1
      ENDDO                                  !!! over energies
      ENDDO                                  !!! over energies
C  SAVE SPHERICAL CONTRIBUTION TO THE RESPONSE
	DO IRAD=0,NRAD(ISORT)
	RHODOT(IRAD,ISORT,ISPIN)=RHODOT(IRAD,ISORT,ISPIN)+
     &RODOT(IRAD,1)
	ENDDO
	IF(ABS(RODOT(NRAD(ISORT),1)).GE.1.D-06)WRITE(IUT,*)
     &'<SRODOT>: NO ACCURACY IN RHODOT ','1',RODOT(NRAD(ISORT),1)
C  CALCULATE INTEGRAL OF RODOT WITH THE NMT-PART OF THE POTENTIAL
	RESRHO(IATOM,IPAN,ISPIN)=(0.D0,0.D0)
	DO L=1,ILSV(ISORT)
	DO M=-L,L
	LM=L*(L+1)+M+1
	IF(SYM(LM,IATOM))THEN
	ISYM=LMSYM(LM,IATOM)
	DO IRAD=0,NRAD(ISORT)
	WORK1(IRAD)=CONJG(RODOT(IRAD,ISYM))*POT(IRAD,ISYM,IATOM,ISPIN,1)*
     &R(IRAD,ISORT)**2*DR(IRAD,ISORT)
	ENDDO
	CALL LIB_CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	RESRHO(IATOM,IPAN,ISPIN)=RESRHO(IATOM,IPAN,ISPIN)+
     &WORK2(NRAD(ISORT))
	IF(ABS(RODOT(NRAD(ISORT),ISYM)).GE.1.D-06)WRITE(IUT,*)
     &'<SRODOT>: NO ACCURACY IN RHODOT',LM,RODOT(NRAD(ISORT),ISYM)
	ENDIF
	ENDDO 
	ENDDO 
1000  CONTINUE                               !!! over all atoms in cell
2000  CONTINUE                               !!! over panels
3000  CONTINUE                               !!! over spins
C MEMORY DEALLOCATIONS 
      DEALLOCATE(FI,FID,FIP,FIDP,FIPP,FIDPP)
      DEALLOCATE(FIH,FIJ,FIHP,FIJP)
	DEALLOCATE(RODOT,RHODOT,WORK1,WORK2)
      CURMEM=CURMEM-SIZE_FIS-SIZE_FIH-SIZE_RODOT-SIZE_RHODOT
	END
