	SUBROUTINE SUP_ELIFUN
******************************************************
*  Calculates Eliashberg's function: alfa2(om)*F(om) *
******************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                  !!! from setup
      USE COM_PARAM,   ONLY: NATOM,NSORT,NSPIN,NORBS,IS               !!! from readini
	USE COM_SPHERE,  ONLY: AMAS                                     !!! from init
	USE COM_KMESH,   ONLY: NPNT,PNT,WGT                             !!! from readpnt
	USE COM_SUPDAT,  ONLY: UNITS,TXTUN,VEL,DOS,STARMU,TCEXP         !!! from readsup
	USE COM_SUPMAT,  ONLY: EPIMAT,DPOL,OM,WPTS,WPDS,GAMEPI          !!! from omegaq
      USE COM_UNIT,    ONLY: IUN,IUR,IUT,IUI                          !!! from setup
      USE COM_SUPOUT,  ONLY: ICELI,ELIFILE                            !!! from init
      USE COM_CHANNELS,ONLY: IUAIN                                    !!! from channels
	IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8, ALLOCATABLE :: ENRELI(:)
      COMPLEX*16, ALLOCATABLE :: PARDS(:)
      COMPLEX*16, ALLOCATABLE :: PELI(:,:)
	CHARACTER*150, ALLOCATABLE :: ELIDATA(:)
      CHARACTER*150, ALLOCATABLE :: ELICOPY(:)
      CHARACTER TCTRL*10,HELP*40,TUN*3
      COMPLEX*16 CM
	LOGICAL EXIST,DEF,ASK,VAL,NTH
	DATA PI/3.141592653589793D0/,KU/4/
	IF(ICELI.EQ.0)RETURN
	EMINELI=OM(3*NATOM,1)
	EMAXELI=OM(1,1)
	DO IPNT=1,NPNT(1)
      DO IBAND=1,3*NATOM
	EMINELI=MIN(OM(IBAND,IPNT),EMINELI)
	EMAXELI=MAX(OM(IBAND,IPNT),EMAXELI)
	ENDDO
	ENDDO
	NENRELI=100
C STORE HEADER INFO.
	INQUIRE(FILE=ELIFILE,EXIST=EXIST)
	IF(EXIST)THEN
C ********************************
C UNDERSTAND THE LENGHT OF INIFILE
	CALL FILE_LENGHT(ELIFILE,NLEN,IUAIN)
	NLEN=MIN(NLEN,100)
	ALLOCATE(ELIDATA(NLEN))
C ********************************
C READ INIFILE TO INTERNAL FILE
      OPEN(UNIT=IUAIN,FILE=ELIFILE,STATUS='OLD',FORM='FORMATTED')
	DO ILEN=1,NLEN
	READ(IUAIN,FMT='(A150)')ELIDATA(ILEN)
	ENDDO
C **************************************
C READING CONTROLS
      CALL READ_SECT(ELIDATA(1),NLEN,ISEC,NSEC,MSEC,
     &'<section=ctrl',13,'<section=',9,'ok',2)
C Set section title
      DO IPOS=1,150
      IF(ELIDATA(ISEC)(IPOS:IPOS).EQ.'>')EXIT
      ENDDO
      DO JPOS=IPOS+1,150
      IF(MSEC.NE.0)ELIDATA(ISEC)(JPOS:JPOS)=' '
      ENDDO
      IF(IPOS.LE.50)THEN
      HELP='! CONTROL PARAMETERS:                   '
      IF(MSEC.NE.0)ELIDATA(ISEC)(IPOS+1:IPOS+40)=HELP
      ENDIF
C Allocate temporary file
      ALLOCATE(ELICOPY(NSEC))
      DO ILIN=1,MSEC
      ELICOPY(ILIN)=ELIDATA(ILIN+ISEC-1)
      ENDDO
C **************************************
C Process Units
      TCTRL=TXTUN(KU)
      HELP='! Output Units: eV,K,rsm,THz            '
      LHLP=40
      CALL READ_CHAR(ELIDATA(ISEC),ELICOPY(1),NSEC,MSEC,
     &'units',5,IN,1,0,RE,1,0,CM,1,0,TCTRL,10,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
      KU=-1
      CALL LIB_CONVLOW(TCTRL,10)
      CALL LIB_RMBLANK(TCTRL,10)
	NB=INDEX(TCTRL,' ')
	DO IU=1,4
	TUN=TXTUN(IU)
	CALL LIB_CONVLOW(TUN,3)
	IF(TCTRL(:NB-1).EQ.TUN)KU=IU
	ENDDO
      IF(KU.EQ.-1)CALL FULLSTOP('<ELIFILE> Units not recognized')
C Process NENRELI
      HELP='! Energy mesh for Eliashberg function  '
      LHLP=40
      CALL READ_CHAR(ELIDATA(ISEC),ELICOPY(1),NSEC,MSEC,
     &'nenreli',7,NENRELI,1,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.FALSE.,.FALSE.)
C Process EMINELI
      HELP='! Min.Energy for Eliashberg function   '
      LHLP=40
      CALL READ_CHAR(ELIDATA(ISEC),ELICOPY(1),NSEC,MSEC,
     &'emineli',7,IN,1,0,EMIN,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.FALSE.,.FALSE.)
      IF(VAL)EMINELI=EMIN/UNITS(KU)
C Process EMAXELI
      HELP='! Max.Energy for Eliashberg function   '
      LHLP=40
      CALL READ_CHAR(ELIDATA(ISEC),ELICOPY(1),NSEC,MSEC,
     &'emaxeli',7,IN,1,0,EMAX,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.FALSE.,.FALSE.)
      IF(VAL)EMAXELI=EMAX/UNITS(KU)
      CALL READ_ERRR(ELIDATA(ISEC),ELICOPY(1),NSEC,MSEC,'CTRL')
      DEALLOCATE(ELICOPY,ELIDATA)
	CLOSE(UNIT=IUAIN,STATUS='DELETE')
	ENDIF
C FIND LIMITS
      ALLOCATE(ENRELI(0:NENRELI))
	IF(NENRELI.NE.0)ESTEP=(EMAXELI-EMINELI)/DBLE(NENRELI)
	IF(NENRELI.EQ.0)ESTEP=0.D0
	DO IENR=0,NENRELI
	ENRELI(IENR)=EMINELI+DBLE(IENR)*ESTEP
	ENDDO
C MEMORY ALLOCATIONS
	ALLOCATE(PARDS(NSORTMEM))
	ALLOCATE(PELI(3,NATOMMEM))
C STORE ELIASHBERG SPECTRAL FUNCTION
	INQUIRE(FILE=ELIFILE,EXIST=EXIST)
	IF(EXIST)THEN
      OPEN(UNIT=IUAIN,FILE=ELIFILE,STATUS='OLD',FORM='FORMATTED')
	CLOSE(UNIT=IUAIN,STATUS='DELETE')
	ENDIF
	OPEN(UNIT=IUAIN,FILE=ELIFILE,STATUS='NEW',FORM='FORMATTED')
	WRITE(IUAIN,10010)
	WRITE(IUAIN,10020)
10010	 FORMAT(1X,'<FILE=ELIFILE,INPUT=MODERN>')
10020 FORMAT('****************************************************')
	WRITE(IUAIN,10030)
10030 FORMAT(1X,'<SECTION=CTRL>               ! CONTROL PARAMETERS:')
      HELP='! Output Units: eV,K,rsm,THz            '
      WRITE(IUAIN,10035)TXTUN(KU),HELP
10035 FORMAT(1X,'Units  =',A3,18X,A40)
      HELP='! Energy mesh for Eliashberg Function  '
	WRITE(IUAIN,10040)NENRELI,HELP
10040 FORMAT(1X,'nEnrELI=',I5,16X,A40)
      HELP='! Min.Energy for ELI                   '
	WRITE(IUAIN,10050)ENRELI(0)*UNITS(KU),HELP
10050 FORMAT(1X,'EminELI=',G14.7,7X,A40)
      HELP='! Max.Energy for ELI                   '
	WRITE(IUAIN,10060)ENRELI(NENRELI)*UNITS(KU),HELP
10060 FORMAT(1X,'EmaxELI=',G14.7,7X,A40)
	WRITE(IUAIN,10070)
10070 FORMAT(1X,'<SECTION=DATA>               ! ELIASHBERG FUNCTION:')
C  **** DO GLOBALLY OVER OMEGA-INTERVAL ****
	DO 100 IOMG=0,NENRELI
	OMG=ENRELI(IOMG)
C  GET WEIGHTS
	CALL SUP_TTRINT(OMG,PTS,PDS,1)
C  CALCULATE ELIASHBERG FUNCTION (GAM AND OM IS IN EV-UNITS)
C  PARTIAL CONTRIBUTIOS MUST BE SYMMETRIZED! THE TOTAL EPI IS OK!
	EPI=0.D0
	DO 40 INUC=1,NATOM
	DO 30 IA=1,3
	PELI(IA,INUC)=0.D0
	DO 20 IBND=1,3*NATOM
	DO 10 IPNT=1,NPNT(1)
	IF(ABS(OM(IBND,IPNT)).LE.1.D-10)DOM1=0.D0
	IF(ABS(OM(IBND,IPNT)).GT.1.D-10)DOM1=1.D0/OM(IBND,IPNT)
	PELI(IA,INUC)=PELI(IA,INUC)+DCONJG(DPOL(IA,INUC,IBND,IPNT))*
     &DPOL(IA,INUC,IBND,IPNT)*WPDS(IBND,IPNT)*
     &DREAL(GAMEPI(IBND,IPNT))*DOM1/(DOS/13.6058)/PI ! Total dos in eV here
  10	CONTINUE
  20	CONTINUE
	EPI=EPI+PELI(IA,INUC)
  30	CONTINUE
  40	CONTINUE
	IF(ABS(PDS).LE.1.D-05)ALF2=0.D0
	IF(ABS(PDS).GT.1.D-05)ALF2=EPI/PDS
	WRITE(IUAIN,10120)OMG*UNITS(KU),ALF2*UNITS(KU),EPI,
     &  ' ! OMG[',TXTUN(KU),'],ALF2[',TXTUN(KU),'],EPI'
	DO 50 INUC=1,NATOM
CNOW  WRITE(IUAIN,10130)INUC,(PELI(IA,INUC),IA=1,3)
  50	CONTINUE
C  COMPUTE PARTIAL DOS
      CHK=0.D0
      DO 80 ISORT=1,NSORT
      PARDS(ISORT)=0.D0
      DO 70 INUC=1,NATOM
      IF(ISORT.NE.IS(INUC))GOTO70
      DO 60 IA=1,3
      PARDS(ISORT)=PARDS(ISORT)+PELI(IA,INUC)
  60  CONTINUE
  70  CONTINUE
      CHK=CHK+PARDS(ISORT)
  80  CONTINUE
C	IF(ABS(EPI-CHK).GE.1.D-10)PRINT*,'ERROR IN EPI-CHK',EPI-CHK
C     WRITE(52,1040)OMG*UNITS(2),EPI,(PARDS(ISORT),ISORT=1,NSORT)
 100	CONTINUE
	CLOSE(IUAIN)
10110 FORMAT(4X,I3,1X,I3)
10120 FORMAT(4X,3(1X,G12.5),5X,A7,A3,A7,A3,A5)
10130 FORMAT(1X,I3,3(1X,G12.5))
10140 FORMAT(1X,6(G12.5,1X))
C MEMORY DEALLOCATIONS
      DEALLOCATE(PARDS,PELI,ENRELI)
	END


	SUBROUTINE SUP_SPEFUN
***********************************************************
*  Calculates transport sectral function: alfa2(om)*F(om) *
*  Calculates also "out" and "in" spectral functions.     *
***********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                  !!! from setup
      USE COM_PARAM,   ONLY: NATOM,NSORT,NSPIN,NORBS,IS               !!! from readini
	USE COM_SPHERE,  ONLY: AMAS                                     !!! from init
	USE COM_KMESH,   ONLY: NPNT,PNT,WGT                             !!! from readpnt
	USE COM_SUPDAT,  ONLY: UNITS,TXTUN,VEL,DOS,STARMU,TCEXP         !!! from readsup
	USE COM_SUPMAT,  ONLY: EPIMAT,DPOL,OM,WPTS,WPDS,GAMTRA          !!! from omegaq
      USE COM_UNIT,    ONLY: IUN,IUR,IUT,IUI                          !!! from setup
      USE COM_SUPOUT,  ONLY: ICSPE,SPEFILE                            !!! from init
      USE COM_CHANNELS,ONLY: IUAIN                                    !!! from channels
	IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8, ALLOCATABLE :: ENRSPE(:)
      COMPLEX*16, ALLOCATABLE :: PELI(:,:,:)
	CHARACTER*150, ALLOCATABLE :: SPEDATA(:)
      CHARACTER*150, ALLOCATABLE :: SPECOPY(:)
      CHARACTER TCTRL*10,HELP*40,TUN*3
      COMPLEX*16 CM
	LOGICAL EXIST,DEF,ASK,VAL,NTH
	DATA PI/3.141592653589793D0/,KU/4/
	IF(ICSPE.EQ.0)RETURN
	EMINSPE=OM(3*NATOM,1)
	EMAXSPE=OM(1,1)
	DO IPNT=1,NPNT(1)
      DO IBAND=1,3*NATOM
	EMINSPE=MIN(OM(IBAND,IPNT),EMINSPE)
	EMAXSPE=MAX(OM(IBAND,IPNT),EMAXSPE)
	ENDDO
	ENDDO
	NENRSPE=100
C STORE HEADER INFO.
	INQUIRE(FILE=SPEFILE,EXIST=EXIST)
	IF(EXIST)THEN
C ********************************
C UNDERSTAND THE LENGHT OF INIFILE
	CALL FILE_LENGHT(SPEFILE,NLEN,IUAIN)
	NLEN=MIN(NLEN,100)
	ALLOCATE(SPEDATA(NLEN))
C ********************************
C READ INIFILE TO INTERNAL FILE
      OPEN(UNIT=IUAIN,FILE=SPEFILE,STATUS='OLD',FORM='FORMATTED')
	DO ILEN=1,NLEN
	READ(IUAIN,FMT='(A150)')SPEDATA(ILEN)
	ENDDO
C **************************************
C READING CONTROLS
      CALL READ_SECT(SPEDATA(1),NLEN,ISEC,NSEC,MSEC,
     &'<section=ctrl',13,'<section=',9,'ok',2)
C Set section title
      DO IPOS=1,150
      IF(SPEDATA(ISEC)(IPOS:IPOS).EQ.'>')EXIT
      ENDDO
      DO JPOS=IPOS+1,150
      IF(MSEC.NE.0)SPEDATA(ISEC)(JPOS:JPOS)=' '
      ENDDO
      IF(IPOS.LE.50)THEN
      HELP='! CONTROL PARAMETERS:                   '
      IF(MSEC.NE.0)SPEDATA(ISEC)(IPOS+1:IPOS+40)=HELP
      ENDIF
C Allocate temporary file
      ALLOCATE(SPECOPY(NSEC))
      DO ILIN=1,MSEC
      SPECOPY(ILIN)=SPEDATA(ILIN+ISEC-1)
      ENDDO
C **************************************
C Process Units
      TCTRL=TXTUN(KU)
      HELP='! Output Units: eV,K,rsm,THz            '
      LHLP=40
      CALL READ_CHAR(SPEDATA(ISEC),SPECOPY(1),NSEC,MSEC,
     &'units',5,IN,1,0,RE,1,0,CM,1,0,TCTRL,10,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
      KU=-1
      CALL LIB_CONVLOW(TCTRL,10)
      CALL LIB_RMBLANK(TCTRL,10)
	NB=INDEX(TCTRL,' ')
	DO IU=1,4
	TUN=TXTUN(IU)
	CALL LIB_CONVLOW(TUN,3)
	IF(TCTRL(:NB-1).EQ.TUN)KU=IU
	ENDDO
      IF(KU.EQ.-1)CALL FULLSTOP('<SPEFILE> Units not recognized')
C Process NENRSPE
      HELP='! Energy mesh for SPE                  '
      LHLP=40
      CALL READ_CHAR(SPEDATA(ISEC),SPECOPY(1),NSEC,MSEC,
     &'nenrspe',7,NENRSPE,1,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.FALSE.,.FALSE.)
C Process EMINSPE
      HELP='! Min.Energy for SPE                   '
      LHLP=40
      CALL READ_CHAR(SPEDATA(ISEC),SPECOPY(1),NSEC,MSEC,
     &'eminspe',7,IN,1,0,EMIN,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.FALSE.,.FALSE.)
      IF(VAL)EMINSPE=EMIN/UNITS(KU)
C Process EMAXSPE
      HELP='! Max.Energy for SPE                   '
      LHLP=40
      CALL READ_CHAR(SPEDATA(ISEC),SPECOPY(1),NSEC,MSEC,
     &'emaxspe',7,IN,1,0,EMAX,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.FALSE.,.FALSE.)
      IF(VAL)EMAXSPE=EMAX/UNITS(KU)
      CALL READ_ERRR(SPEDATA(ISEC),SPECOPY(1),NSEC,MSEC,'CTRL')
      DEALLOCATE(SPECOPY,SPEDATA)
	CLOSE(UNIT=IUAIN,STATUS='DELETE')
	ENDIF
C FIND LIMITS
      ALLOCATE(ENRSPE(0:NENRSPE))
	IF(NENRSPE.NE.0)ESTEP=(EMAXSPE-EMINSPE)/DBLE(NENRSPE)
	IF(NENRSPE.EQ.0)ESTEP=0.D0
	DO IENR=0,NENRSPE
	ENRSPE(IENR)=EMINSPE+DBLE(IENR)*ESTEP
	ENDDO
C MEMORY ALLOCATIONS
	ALLOCATE(PELI(4,3,NATOMMEM))
C STORE ELIASHBERG SPECTRAL FUNCTION
	INQUIRE(FILE=SPEFILE,EXIST=EXIST)
	IF(EXIST)THEN
      OPEN(UNIT=IUAIN,FILE=SPEFILE,STATUS='OLD',FORM='FORMATTED')
	CLOSE(UNIT=IUAIN,STATUS='DELETE')
	ENDIF
	OPEN(UNIT=IUAIN,FILE=SPEFILE,STATUS='NEW',FORM='FORMATTED')
	WRITE(IUAIN,10010)
	WRITE(IUAIN,10020)
10010	 FORMAT(1X,'<FILE=SPEFILE,INPUT=MODERN>')
10020 FORMAT('****************************************************')
	WRITE(IUAIN,10030)
10030 FORMAT(1X,'<SECTION=CTRL>               ! CONTROL PARAMETERS:')
      HELP='! Output Units: eV,K,rsm,THz           '
      WRITE(IUAIN,10035)TXTUN(KU),HELP
10035 FORMAT(1X,'Units  =',A3,18X,A40)
      HELP='! Energy mesh for Transport Function   '
	WRITE(IUAIN,10040)NENRSPE,HELP
10040 FORMAT(1X,'nEnrSPE=',I5,16X,A40)
      HELP='! Min.Energy for Transport function    '
	WRITE(IUAIN,10050)ENRSPE(0)*UNITS(KU),HELP
10050 FORMAT(1X,'EminSPE=',G14.7,7X,A40)
      HELP='! Max.Energy for Transport function    '
	WRITE(IUAIN,10060)ENRSPE(NENRSPE)*UNITS(KU),HELP
10060 FORMAT(1X,'EmaxSPE=',G14.7,7X,A40)
	WRITE(IUAIN,10070)
10070 FORMAT(1X,'<SECTION=DATA>               ! TRANSPORT FUNCTION:')
C  CALCULATE TRANSPORT SPECTRAL FUNCTION
	VTOT=VEL(1)+VEL(2)+VEL(3)
C  **** DO GLOBALLY OVER OMEGA-INTERVAL ****
	DO 50 IOMG=0,NENRSPE
	OMG=ENRSPE(IOMG)
C  GET WEIGHTS
	CALL SUP_TTRINT(OMG,PTS,PDS,1)
C  CALCULATE SPECTRAL FUNCTIONS (GAM AND OM IS IN EV-UNITS)
C  PARTIAL CONTRIBUTIOS MUST BE SYMMETRIZED! THE TOTAL EPI IS OK!
	EOUT1=0.D0
	EOUT2=0.D0
	EIN=0.D0
	ETR=0.D0
	DO 40 INUC=1,NATOM
	DO 30 IA=1,3
	PELI(1,IA,INUC)=0.D0
	PELI(2,IA,INUC)=0.D0
	PELI(3,IA,INUC)=0.D0
	PELI(4,IA,INUC)=0.D0
	DO 20 IBND=1,3*NATOM
	DO 10 IPNT=1,NPNT(1)
	IF(ABS(OM(IBND,IPNT)).LE.1.D-10)DOM1=0.D0
	IF(ABS(OM(IBND,IPNT)).GT.1.D-10)DOM1=1.D0/OM(IBND,IPNT)
C SPECTRAL FUNCTION "OUT" 
	PELI(1,IA,INUC)=PELI(1,IA,INUC)+DCONJG(
     &DPOL(IA,INUC,IBND,IPNT))*
     &DPOL(IA,INUC,IBND,IPNT)*WPDS(IBND,IPNT)*
     &DREAL(GAMTRA(1,IBND,IPNT))*DOM1/(VTOT/13.6058D0)/PI
C SPECTRAL FUNCTION "OUT" FOR TEST
	PELI(2,IA,INUC)=PELI(2,IA,INUC)+DCONJG(
     &DPOL(IA,INUC,IBND,IPNT))*
     &DPOL(IA,INUC,IBND,IPNT)*WPDS(IBND,IPNT)*
     &DREAL(GAMTRA(2,IBND,IPNT))*DOM1/(VTOT/13.6058D0)/PI
C SPECTRAL FUNCTION "IN"
	PELI(3,IA,INUC)=PELI(3,IA,INUC)+DCONJG(
     &DPOL(IA,INUC,IBND,IPNT))*
     &DPOL(IA,INUC,IBND,IPNT)*WPDS(IBND,IPNT)*
     &DREAL(GAMTRA(3,IBND,IPNT))*DOM1/(VTOT/13.6058D0)/PI
C TRANSPORT SPECTRAL FUNCTION
	PELI(4,IA,INUC)=PELI(4,IA,INUC)+DCONJG(
     &DPOL(IA,INUC,IBND,IPNT))*
     &DPOL(IA,INUC,IBND,IPNT)*WPDS(IBND,IPNT)*
     &DREAL(GAMTRA(4,IBND,IPNT))*DOM1/(VTOT/13.6058D0)/PI
  10	CONTINUE
  20	CONTINUE
	EOUT1=EOUT1+PELI(1,IA,INUC)
	EOUT2=EOUT2+PELI(2,IA,INUC)
	EIN=EIN+2.0*PELI(3,IA,INUC)
	ETR=ETR+    PELI(4,IA,INUC)     !!! alpha(+)^2*F(om)
  30	CONTINUE
  40	CONTINUE
	EOUT=EOUT1+EOUT2                
	EMN=EOUT+EIN                    !!! alpha(-)^2*F(om)
	IF(ABS(ETR-(EOUT-EIN)).GE.1.D-04)PRINT*,
     &  'ERROR IN SPECTRAL FUNCTIONS:',ABS(ETR-(EOUT-EIN))
	IF(ABS(PDS).LE.1.D-05)ATR2=0.D0
	IF(ABS(PDS).GT.1.D-05)ATR2=ETR/PDS
	IF(ABS(PDS).LE.1.D-05)AMN2=0.D0
	IF(ABS(PDS).GT.1.D-05)AMN2=EMN/PDS
	WRITE(IUAIN,10120)OMG*UNITS(KU),ATR2*UNITS(KU),ETR,
     &  AMN2*UNITS(KU),EMN,'! om|a2p*F|a2m*F'
  50	CONTINUE
	CLOSE(IUAIN)
10110 FORMAT(4X,I3,1X,I3)
10120 FORMAT(1X,5(G11.4,1X),1X,A16)
C MEMORY DEALLOCATIONS
      DEALLOCATE(PELI,ENRSPE)
	END
