	SUBROUTINE SUP_OMEGAQ
**********************************************************
*  Calculates phonon frequencies and polarizations.      *
**********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                          !!! from setup
      USE COM_PARAM,   ONLY: NATOM,NSORT,NSPIN,NORBS,IS       !!! from readini
	USE COM_SPHERE,  ONLY: AMAS                             !!! from init
	USE COM_KMESH,   ONLY: NPNT,PNT                         !!! from readpnt
	USE COM_SUPDAT,  ONLY: UNITS,TXTUN                      !!! from readsup
	USE COM_SUPMAT,  ONLY: DYNMAT,DPOL,OM                   !!! from omegaq
      USE COM_UNIT,    ONLY: IUN,IUR,IUT,IUI                  !!! from setup
      USE COM_SUPOUT,  ONLY: ICOMG,OMGFILE                    !!! from init
      USE COM_CHANNELS,ONLY: IUAIN                            !!! from channels
	IMPLICIT REAL*8 (A-H,O-Z)
	REAL*8, ALLOCATABLE :: AMASS(:)
	CHARACTER*150, ALLOCATABLE :: OMGDATA(:)
      CHARACTER*150, ALLOCATABLE :: OMGCOPY(:)
      CHARACTER TCTRL*10,HELP*40,TUN*3
	LOGICAL EXIST,DEF,ASK,VAL,NTH
	DATA PI/3.141592653589793D0/,KU/4/
	ALLOCATE(AMASS(NATOMMEM))
	DO IATOM=1,NATOM
	AMASS(IATOM)=AMAS(IS(IATOM))
	ENDDO
C  CALCULATE PHONON SPECTRUM AND POLARIZATIONS
	OMMIN=OM(3*NATOM,1)
	OMMAX=OM(1,1)
	DO IPNT=1,NPNT(1)
	CALL SUP_SPECTRUM(NATOM,DYNMAT(1,1,1,1,IPNT),AMASS,
     &                  OM(1,IPNT),DPOL(1,1,1,IPNT))
C  OM(Q) - FREQUENCIES IN EV, DPOL - RESPECTIVE POLARIZATIONS.
	DO IBND=1,3*NATOM
	OMMIN=MIN(OMMIN,OM(IBND,IPNT))
	OMMAX=MAX(OMMAX,OM(IBND,IPNT))
      ENDDO
      ENDDO
C STORAGE
	IF(ICOMG.GT.0)THEN
	INQUIRE(FILE=OMGFILE,EXIST=EXIST)
	IF(EXIST)THEN
C ********************************
C UNDERSTAND THE LENGHT OF INIFILE
	CALL FILE_LENGHT(OMGFILE,NLEN,IUAIN)
	NLEN=MIN(NLEN,100)
	ALLOCATE(OMGDATA(NLEN))
C ********************************
C READ INIFILE TO INTERNAL FILE
      OPEN(UNIT=IUAIN,FILE=OMGFILE,STATUS='OLD',FORM='FORMATTED')
	DO ILEN=1,NLEN
	READ(IUAIN,FMT='(A150)')OMGDATA(ILEN)
	ENDDO
C **************************************
C READING CONTROLS
      CALL READ_SECT(OMGDATA(1),NLEN,ISEC,NSEC,MSEC,
     &'<section=ctrl',13,'<section=',9,'ok',2)
C Set section title
      DO IPOS=1,150
      IF(OMGDATA(ISEC)(IPOS:IPOS).EQ.'>')EXIT
      ENDDO
      DO JPOS=IPOS+1,150
      IF(MSEC.NE.0)OMGDATA(ISEC)(JPOS:JPOS)=' '
      ENDDO
      IF(IPOS.LE.50)THEN
      HELP='! CONTROL PARAMETERS:                   '
      IF(MSEC.NE.0)OMGDATA(ISEC)(IPOS+1:IPOS+40)=HELP
      ENDIF
C Allocate temporary file
      ALLOCATE(OMGCOPY(NSEC))
      DO ILIN=1,MSEC
      OMGCOPY(ILIN)=OMGDATA(ILIN+ISEC-1)
      ENDDO
C **************************************
C Process Units
      TCTRL=TXTUN(KU)
      HELP='! Output Units: eV,K,rsm,THz            '
      LHLP=40
      CALL READ_CHAR(OMGDATA(ISEC),OMGCOPY(1),NSEC,MSEC,
     &'units',5,IN,1,0,RE,1,0,CM,1,0,TCTRL,10,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
      KU=-1
      CALL LIB_CONVLOW(TCTRL,10)
      CALL LIB_RMBLANK(TCTRL,10)
	NB=INDEX(TCTRL,' ')
	DO IU=1,4
	TUN=TXTUN(IU)
	CALL LIB_CONVLOW(TUN,3)
	IF(TCTRL(:NB-1).EQ.TUN)KU=IU
	ENDDO
      IF(KU.EQ.-1)CALL FULLSTOP('<OMGFILE> Units not recognized')
      CALL READ_ERRR(OMGDATA(ISEC),OMGCOPY(1),NSEC,MSEC,'CTRL')
      DEALLOCATE(OMGCOPY,OMGDATA)
	CLOSE(UNIT=IUAIN,STATUS='DELETE')
	ENDIF
	OPEN(IUAIN,FILE=OMGFILE,STATUS='NEW',FORM='FORMATTED')
	WRITE(IUAIN,10010)
	WRITE(IUAIN,10020)
10010	FORMAT(1X,'<FILE=OMGFILE,INPUT=MODERN>')
10020 FORMAT('****************************************************')
	WRITE(IUAIN,10030)
10030 FORMAT(1X,'<SECTION=CTRL>               ! Controls:')
      HELP='! Output Units: eV,K,rsm,THz            '
      WRITE(IUAIN,10040)TXTUN(KU),HELP
10040 FORMAT(1X,'Units  =',A3,18X,A40)
	WRITE(IUAIN,10080)
10080 FORMAT(1X,'<SECTION=DATA>               ! Phonon Spectrum:')
	DO IPNT=1,NPNT(1)
      WRITE(IUAIN,10090)(PNT(I,IPNT,1),I=1,3)
10090 FORMAT(1X,G14.7,' , ',G14.7,' , ',G14.7)
	WRITE(IUAIN,10100)(OM(I,IPNT)*UNITS(KU),I=1,3*NATOM)
10100	FORMAT(1X,3(G12.5,1X))
      ENDDO
	CLOSE(IUAIN)
	ENDIF
	WRITE(IUN,10110)OMMIN*UNITS(KU),TXTUN(KU) 
	WRITE(IUN,10120)OMMAX*UNITS(KU),TXTUN(KU) 
10110	FORMAT(1X,'Minimal frequency = ',G14.7,1X,A3)
10120	FORMAT(1X,'Maximal frequency = ',G14.7,1X,A3)
C MEMORY DEALLOCATIONS
      DEALLOCATE(AMASS)
	END




	SUBROUTINE SUP_SPECTRUM(NATOM,DYNMAT,AMASS,OM,DPOL)
************************************************************
*  Diagonalization of the dynamical matrix and calculation *
*  of the phonon frequences, polarizations.                *
************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16 DYNMAT(3,NATOM,3,NATOM),DPOL(3,NATOM,3*NATOM)
	REAL*8  AMASS(NATOM),OM(3*NATOM)
	COMPLEX*16, ALLOCATABLE :: HMAT(:,:)
	COMPLEX*16, ALLOCATABLE :: OMAT(:,:)
	ALLOCATE(HMAT(3*NATOM,3*NATOM))
	ALLOCATE(OMAT(3*NATOM,3*NATOM))
C  MAKE MATRIX FOR DIAGONALIZATION
	IDIM1=0
	DO 40 INUC1=1,NATOM                      !!! over nuclear shifts
	DO 30 I=1,3                              !!! over x,y,z
	IDIM1=IDIM1+1
	IDIM=0
	DO 20 INUC=1,NATOM                       !!! over nuclear shifts
	DO 10 J=1,3                              !!! over x,y,z
	IDIM=IDIM+1
	AMS=1.D0/SQRT(AMASS(INUC1)*AMASS(INUC))
	AMS=AMS*109.752D0                        !!! since Me=5.4876D-04 m.a.u.
	DMRE=DREAL(DYNMAT(I,INUC1,J,INUC))       !!! set up zeroes where necess.
	DMIM=DIMAG(DYNMAT(I,INUC1,J,INUC))
	IF(ABS(DMRE).LE.1.D-05)DMRE=0.D0
	IF(ABS(DMIM).LE.1.D-05)DMIM=0.D0
	HMAT(IDIM1,IDIM)=DCMPLX(DMRE,DMIM)*AMS
	OMAT(IDIM1,IDIM)=(0.D0,0.D0)
	IF(IDIM1.EQ.IDIM)OMAT(IDIM1,IDIM)=(1.D0,0.D0)
  10  CONTINUE                                 !!! over x,y,z
  20  CONTINUE                                 !!! over nuclear shifts
  30  CONTINUE                                 !!! over x,y,z
  40  CONTINUE                                 !!! over nuclear shifts
      DO 60 IDIM1=1,3*NATOM
      DO 50 IDIM=1,IDIM1
      DMRE10=+DREAL(HMAT(IDIM1,IDIM))
      DMRE01=+DREAL(HMAT(IDIM,IDIM1))
      DMRE=0.5D0*(DMRE10+DMRE01)
      DMIM10=+DIMAG(HMAT(IDIM1,IDIM))
      DMIM01=-DIMAG(HMAT(IDIM,IDIM1))
      DMIM=0.5D0*(DMIM10+DMIM01)
      HMAT(IDIM1,IDIM)=DCMPLX(DMRE,+DMIM)
      HMAT(IDIM,IDIM1)=DCMPLX(DMRE,-DMIM)
  50  CONTINUE
  60  CONTINUE
C  EIGENVALUE PROBLEM
      CALL LIB_EIGEN1C(3*NATOM,HMAT,OMAT,OM,1,1,1,IERR,1,1.D-07)
C  FREQUENCES AND POLARIZATIONS
	DO 90 IBND=1,3*NATOM                     !!! over phonon branches
	IF(OM(IBND).GE.0.D0)
     &	 OM(IBND)=+SQRT(+OM(IBND))*13.6058D0*0.3162278D-02  !  units are eV
	IF(OM(IBND).LT.0.D0)
     &	 OM(IBND)=-SQRT(-OM(IBND))*13.6058D0*0.3162278D-02  !  units are eV
	IDIM=0
	DO 80 INUC=1,NATOM                       !!! over nuclear shifts
	DO 70 I=1,3                              !!! over x,y,z
	IDIM=IDIM+1
	DPOL(I,INUC,IBND)=OMAT(IDIM,IBND)
  70  CONTINUE                                 !!! over x,y,z
  80  CONTINUE                                 !!! over nuclear shifts
  90  CONTINUE                                 !!! over phonon branches
	DEALLOCATE(HMAT,OMAT)
	END
