	SUBROUTINE SUP_PHNDOS
*************************************************************************
*  Calculates phonon density of states by means of tetrahedron method.  *
*************************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                          !!! from setup
      USE COM_PARAM,   ONLY: NATOM,NSORT,NHSORT,IS            !!! from readini
	USE COM_SPHERE,  ONLY: AMAS                             !!! from init
	USE COM_KMESH,   ONLY: NPNT,PNT                         !!! from readpnt
	USE COM_SUPDAT,  ONLY: UNITS,TXTUN                      !!! from readsup
	USE COM_SUPMAT,  ONLY: DYNMAT,DPOL,OM,WPTS,WPDS         !!! from omegaq
      USE COM_GROUPS  ,ONLY: NGROUP,INV,KELTAB,IKOV,IP        !!! from groups
     &                      ,RDC,SHIFT,SOPHS,U,UJ
      USE COM_UNIT,    ONLY: IUN,IUR,IUT,IUI                  !!! from setup
      USE COM_SUPOUT,  ONLY: ICPDS,PDSFILE                    !!! from init
      USE COM_LABELS  ,ONLY: TXTAT,TXTEL,TXTSP                !!! from readini
      USE COM_CHANNELS,ONLY: IUAIN                            !!! from channels
	IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER, ALLOCATABLE :: ILS(:)
	INTEGER, ALLOCATABLE :: ILMTBAS(:,:)
	INTEGER, ALLOCATABLE :: INODBAS(:,:)
	REAL*8, ALLOCATABLE :: ENRPDS(:)
      COMPLEX*16, ALLOCATABLE :: TLMM(:,:,:)
      COMPLEX*16, ALLOCATABLE :: TLMS(:,:)
      COMPLEX*16, ALLOCATABLE :: TLMT(:,:)
      COMPLEX*16 DPOLS(-1:1)
	CHARACTER*150, ALLOCATABLE :: PDSDATA(:)
      CHARACTER*150, ALLOCATABLE :: PDSCOPY(:)
      CHARACTER TCTRL*10,HELP*40,TUN*3
	LOGICAL EXIST,DEF,ASK,VAL,NTH
	DATA PI/3.141592653589793D0/,KU/4/
	IF(ICPDS.EQ.0)RETURN
	EMINPDS=OM(3*NATOM,1)
	EMAXPDS=OM(1,1)
	DO IPNT=1,NPNT(1)
      DO IBAND=1,3*NATOM
	EMINPDS=MIN(OM(IBAND,IPNT),EMINPDS)
	EMAXPDS=MAX(OM(IBAND,IPNT),EMAXPDS)
	ENDDO
	ENDDO
	NENRPDS=100
C STORE HEADER INFO.
	INQUIRE(FILE=PDSFILE,EXIST=EXIST)
	IF(EXIST)THEN
C ********************************
C UNDERSTAND THE LENGHT OF INIFILE
	CALL FILE_LENGHT(PDSFILE,NLEN,IUAIN)
	NLEN=MIN(NLEN,100)
	ALLOCATE(PDSDATA(NLEN))
C ********************************
C READ INIFILE TO INTERNAL FILE
      OPEN(UNIT=IUAIN,FILE=PDSFILE,STATUS='OLD',FORM='FORMATTED')
	DO ILEN=1,NLEN
	READ(IUAIN,FMT='(A150)')PDSDATA(ILEN)
	ENDDO
C **************************************
C READING CONTROLS
      CALL READ_SECT(PDSDATA(1),NLEN,ISEC,NSEC,MSEC,
     &'<section=ctrl',13,'<section=',9,'ok',2)
C Set section title
      DO IPOS=1,150
      IF(PDSDATA(ISEC)(IPOS:IPOS).EQ.'>')EXIT
      ENDDO
      DO JPOS=IPOS+1,150
      IF(MSEC.NE.0)PDSDATA(ISEC)(JPOS:JPOS)=' '
      ENDDO
      IF(IPOS.LE.50)THEN
      HELP='! CONTROL PARAMETERS:                   '
      IF(MSEC.NE.0)PDSDATA(ISEC)(IPOS+1:IPOS+40)=HELP
      ENDIF
C Allocate temporary file
      ALLOCATE(PDSCOPY(NSEC))
      DO ILIN=1,MSEC
      PDSCOPY(ILIN)=PDSDATA(ILIN+ISEC-1)
      ENDDO
C **************************************
C Process Units
      TCTRL=TXTUN(KU)
      HELP='! Output Units: eV,K,rsm,THz            '
      LHLP=40
      CALL READ_CHAR(PDSDATA(ISEC),PDSCOPY(1),NSEC,MSEC,
     &'units',5,IN,1,0,RE,1,0,CM,1,0,TCTRL,10,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
      KU=-1
      CALL LIB_CONVLOW(TCTRL,10)
      CALL LIB_RMBLANK(TCTRL,10)
	NB=INDEX(TCTRL,' ')
	DO IU=1,4
	TUN=TXTUN(IU)
	CALL LIB_CONVLOW(TUN,3)
	IF(TCTRL(:NB-1).EQ.TUN)KU=IU
	ENDDO
      IF(KU.EQ.-1)CALL FULLSTOP('<PDSFILE> Units not recognized')
C Process NENRPDS
      HELP='! Energy mesh for Phonon DOS           '
      LHLP=40
      CALL READ_CHAR(PDSDATA(ISEC),PDSCOPY(1),NSEC,MSEC,
     &'nenrpds',7,NENRPDS,1,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.FALSE.,.FALSE.)
C Process EPDSMIN
      HELP='! Min.Energy for Phonon DOS            '
      LHLP=40
      CALL READ_CHAR(PDSDATA(ISEC),PDSCOPY(1),NSEC,MSEC,
     &'eminpds',7,IN,1,0,EMIN,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.FALSE.,.FALSE.)
      IF(VAL)EMINPDS=EMIN/UNITS(KU)
C Process EPDSMAX
      HELP='! Max.Energy for Phonon DOS            '
      LHLP=40
      CALL READ_CHAR(PDSDATA(ISEC),PDSCOPY(1),NSEC,MSEC,
     &'emaxpds',7,IN,1,0,EMAX,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.FALSE.,.FALSE.)
      IF(VAL)EMAXPDS=EMAX/UNITS(KU)
      CALL READ_ERRR(PDSDATA(ISEC),PDSCOPY(1),NSEC,MSEC,'CTRL')
      DEALLOCATE(PDSCOPY,PDSDATA)
	CLOSE(UNIT=IUAIN,STATUS='DELETE')
	ENDIF
C FIND LIMITS
      ALLOCATE(ENRPDS(0:NENRPDS))
	IF(NENRPDS.NE.0)ESTEP=(EMAXPDS-EMINPDS)/DBLE(NENRPDS)
	IF(NENRPDS.EQ.0)ESTEP=0.D0
	DO IENR=0,NENRPDS
	ENRPDS(IENR)=EMINPDS+DBLE(IENR)*ESTEP
	ENDDO
	OPEN(UNIT=IUAIN,FILE=PDSFILE,STATUS='NEW',FORM='FORMATTED')
	WRITE(IUAIN,10010)
	WRITE(IUAIN,10020)
10010	FORMAT(1X,'<FILE=PDSFILE,INPUT=MODERN>')
10020 FORMAT('****************************************************')
	WRITE(IUAIN,10030)
10030 FORMAT(1X,'<SECTION=CTRL>               ! CONTROL PARAMETERS:')
      HELP='! Output Units: eV,K,rsm,THz            '
      WRITE(IUAIN,10035)TXTUN(KU),HELP
10035 FORMAT(1X,'Units  =',A3,18X,A40)
      HELP='! Energy mesh for Phonon DOS           '
	WRITE(IUAIN,10040)NENRPDS,HELP
10040 FORMAT(1X,'nEnrPDS=',I5,16X,A40)
      HELP='! Min.Energy for PDS                   '
	WRITE(IUAIN,10050)ENRPDS(0)*UNITS(KU),HELP
10050 FORMAT(1X,'EminPDS=',G14.7,7X,A40)
      HELP='! Max.Energy for PDS                   '
	WRITE(IUAIN,10060)ENRPDS(NENRPDS)*UNITS(KU),HELP
10060 FORMAT(1X,'EmaxPDS=',G14.7,7X,A40)
C STORE DOS DATA
	WRITE(IUAIN,10110)
10110 FORMAT(1X,'<SECTION=DATA>               ! DOS DATA:')
      ALLOCATE(ILS(0:NSORTMEM))
      DO ISORT=1,NSORT
      ILS(ISORT)=1
      ENDDO
      WRITE(IUAIN,*)NATOM,NSORT,1,1,(IS(IATOM),IATOM=1,NATOM),
     &(ILS(ISORT),ISORT=1,NSORT),(NHSORT(ISORT),ISORT=1,NSORT),
     &0.D0,ENRPDS(0)*UNITS(KU),ENRPDS(NENRPDS)*UNITS(KU),NENRPDS
      WRITE(IUAIN,FMT='(5A10)')(TXTAT(ISORT),ISORT=1,NSORT)
C Store basis set
      ALLOCATE(ILMTBAS(0:1,NATOMMEM))
      ALLOCATE(INODBAS(0:1,NATOMMEM))
      DO IATOM=1,NATOM
      ISORT=IS(IATOM)
      DO L=0,ILS(ISORT)
      ILMTBAS(L,IATOM)=0
      INODBAS(L,IATOM)=0
      IF(L.EQ.1)ILMTBAS(L,IATOM)=1
      IF(L.EQ.1)INODBAS(L,IATOM)=1
      ENDDO
      ENDDO
      WRITE(IUAIN,*)((ILMTBAS(L,IATOM),L=0,ILS(IS(IATOM))),
     &IATOM=1,NATOM)
      WRITE(IUAIN,*)((INODBAS(L,IATOM),L=0,ILS(IS(IATOM))),
     &IATOM=1,NATOM)
C Compute and store
	DELTAE=(EMAX-EMIN)/NENRPDS
	ALLOCATE(TLMM(10,NATOMMEM,3*NATOMMEM))
      ALLOCATE(TLMS(10,NATOMMEM))
      ALLOCATE(TLMT(10,NATOMMEM))
	DO 1000 IPNTDOS=0,NENRPDS                    !!! over energies
	E0=ENRPDS(IPNTDOS)
	CALL SUP_TTRINT(E0,TOS,DOS,1)
	WRITE(IUAIN,*)E0*UNITS(KU),TOS,DOS/UNITS(KU)
C INTEGRATE PARTIAL NUMBERS OF STATES
      DO IATOM=1,NATOM
      ISORT=IS(IATOM)
      L=ILS(ISORT)
      DO M1=-L,L
      LM1=L*(L+1)+M1+1
      DO M=-L,L
      LM=L*(L+1)+M+1
      LM1M=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M1+1           !  (l,m1 m) packed
      TLMS(LM1M,IATOM)=(0.D0,0.D0)
      ENDDO
      ENDDO
      ENDDO
C Sum over BZ
	DO IPNT=1,NPNT(1)           !!! over k-points
      DO IBAND=1,3*NATOM
      DO IATOM=1,NATOM
      ISORT=IS(IATOM)
      L=ILS(ISORT)
      DPOLS(-1)=+(DPOL(1,IATOM,IBAND,IPNT)-
     &(0.D0,1.D0)*DPOL(2,IATOM,IBAND,IPNT))/SQRT(2.D0)
      DPOLS(+1)=-(DPOL(1,IATOM,IBAND,IPNT)+
     &(0.D0,1.D0)*DPOL(2,IATOM,IBAND,IPNT))/SQRT(2.D0)
      DPOLS( 0)=  DPOL(3,IATOM,IBAND,IPNT)
      DO M1=-L,L
      DO M=-L,L
      LM1M=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M1+1           !  (l,m1 m) packed
      TLMM(LM1M,IATOM,IBAND)=DCONJG(DPOLS(M1))*DPOLS(M)
      ENDDO
      ENDDO
      ENDDO
      ENDDO
      DO IBAND=1,3*NATOM
	IF(ABS(WPDS(IBAND,IPNT)).LE.1.D-12)CYCLE
      DO IATOM=1,NATOM
      ISORT=IS(IATOM)
      L=1
      DO M1=-L,L
      DO M=-L,L
      LM1M=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M1+1           !  (l,m1 m) packed
      TLMS(LM1M,IATOM)=TLMS(LM1M,IATOM)+
     &TLMM(LM1M,IATOM,IBAND)*WPDS(IBAND,IPNT)
      ENDDO
      ENDDO
      ENDDO
      ENDDO
	ENDDO                       !!! over k-points
C Symmetrize
      DO IATOM=1,NATOM
      ISORT=IS(IATOM)
      L=ILS(ISORT)
      DO M1=-L,L
      LM1=L*(L+1)+M1+1
      DO M=-L,L
      LM=L*(L+1)+M+1
      LM1M=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M1+1           !  (l,m1 m) packed
      TLMT(LM1M,IATOM)=(0.D0,0.D0)
      ENDDO
      ENDDO
      ENDDO
      DO IR=1,NGROUP                         !!! over point group
      IG=IKOV(IR)
      DO IATOM=1,NATOM
      ISORT=IS(IATOM)
      L=ILS(ISORT)
      DO M1=-L,L
      DO M=-L,L
      LM1M=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M1+1           !  (l,m1 m) packed
	DO M2=-L,L
      LM1M2=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M2)+L+M1+1         !  (l,m1 m2) packed
	DO M3=-L,L
      LMM3=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M3)+L+M+1           !  (l,m m3) packed
      LM2M3=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M3)+L+M2+1         !  (l,m2 m3) packed
	TLMT(LM1M,IATOM)=TLMT(LM1M,IATOM)+
     &CONJG(U(LM1M2,IG))*TLMS(LM2M3,IP(IATOM,IR))*
     &U(LMM3,IG)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO                                  !!! over group
C Normalize
      DO IATOM=1,NATOM
      ISORT=IS(IATOM)
      L=ILS(ISORT)
      DO M1=-L,L
      LM1=L*(L+1)+M1+1
      DO M=-L,L
      LM=L*(L+1)+M+1
      LM1M=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M1+1           !  (l,m1 m) packed
      TLMS(LM1M,IATOM)=TLMT(LM1M,IATOM)/DBLE(NGROUP)
      ENDDO
      ENDDO
      ENDDO
C Store now
      DO IATOM=1,NATOM
      ISORT=IS(IATOM)
      L=ILS(ISORT)
      LMS=L*(2*L-1)*(2*L+1)/3+1
      LME=LMS+(2*L+1)**2-1
      WRITE(IUAIN,*)(TLMS(LM1M,IATOM)/UNITS(KU),LM1M=LMS,LME)
      ENDDO
 1000 CONTINUE                      !!! over energies
	CLOSE(IUAIN)
      DEALLOCATE(ILS,ILMTBAS,INODBAS)
	DEALLOCATE(TLMM,TLMS,TLMT,ENRPDS)
	END
