	SUBROUTINE SUP_READEPI
************************************************************
*  <READDYN> reads dynamical matrix                        *
************************************************************
C SET ARRAY SIZE DATA
	USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_PARAM,   ONLY: NATOM,NSORT,NSPIN,NORBS,IS      !!! from readini
	USE COM_SUPMAT,  ONLY: EPIMAT,TRAMAT,GAMTRA,ALMTRA     !!! from readepi
	USE COM_KMESH,   ONLY: NPNT,PNT                        !!! from readpnt
	USE COM_PHNOUT  ,ONLY: EPIFILE                         !!! from setup
      USE COM_CHANNELS,ONLY: IUINP                           !!! from channels
	USE COM_UNIT    ,ONLY: IUN,IUT,IUR                     !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	CHARACTER STRING*150,FILE*130,TQ1*1,TQ2*2,TQ3*3,TQ4*3,QVEC(4)*4
	CHARACTER*150, ALLOCATABLE :: EPIDATA(:)
	CHARACTER*150, ALLOCATABLE :: EPICOPY(:)
	LOGICAL EXIST,MODIFIED,PRESENT
	DATA PI/3.141592653589793D0/
C MEMORY ALLOCATIONS
      ALLOCATE(EPIMAT(3,NATOMMEM,3,NATOMMEM,NPNT(1)))
      ALLOCATE(TRAMAT(3,NATOMMEM,3,NATOMMEM,4,NPNT(1)))
      ALLOCATE(GAMTRA(4,3*NATOMMEM,NPNT(1)))
      ALLOCATE(ALMTRA(4,3*NATOMMEM,NPNT(1)))
C DO OVER POINTS
	DO 1000 IPNT=1,NPNT(1)
C Set zeroes
      DO INUC=1,NATOM             !!! over displacements
      DO JNUC=1,NATOM             !!! over displacements
	DO I=1,3
      DO J=1,3
	EPIMAT(I,INUC,J,JNUC,IPNT)=(0.D0,0.D0)
	DO IC=1,4
	TRAMAT(I,INUC,J,JNUC,IC,IPNT)=(0.D0,0.D0)
	ENDDO
	ENDDO
	ENDDO
      ENDDO                       !!! over displacements
      ENDDO                       !!! over displacements
C SET QVECTOR
      IF(IPNT.LE.9)THEN
      WRITE(TQ1,FMT='(I1)')IPNT
      QVEC(1)='000'//TQ1
      QVEC(2)='00'//TQ1//' '
      QVEC(3)='0'//TQ1//'  '
      QVEC(4)=    TQ1//'   '
      ELSEIF(IPNT.GE.10.AND.IPNT.LE.99)THEN
      WRITE(TQ2,FMT='(I2)')IPNT
      QVEC(1)='    '
      QVEC(2)='00'//TQ2
      QVEC(3)='0'//TQ2//' '
      QVEC(4)=    TQ2//'  '
      ELSEIF(IPNT.GE.100.AND.IPNT.LE.999)THEN
      WRITE(TQ3,FMT='(I3)')IPNT
      QVEC(1)='    '
      QVEC(2)='    '
      QVEC(3)='0'//TQ3
      QVEC(4)=TQ3//' '
      ELSEIF(IPNT.GE.1000.AND.IPNT.LE.9999)THEN
      WRITE(TQ4,FMT='(I4)')IPNT
      QVEC(1)='    '
      QVEC(2)='    '
      QVEC(3)='    '
      QVEC(4)=TQ4
      ELSE
      CALL FULLSTOP('<READEPI> :: IPNT>9999 NOT ASSUMED!')
      ENDIF
C SET FILE NAME
      EXIST=.FALSE.
      DO I=1,4
      IF(QVEC(I).EQ.'    ')CYCLE
      CALL FIND_LBLANK(EPIFILE,130,NA)
      FILE=EPIFILE(:NA)//QVEC(I)
	INQUIRE(FILE=FILE,EXIST=EXIST)
	IF(EXIST)EXIT
	ENDDO
C IF NOT EXIST, CYCLE
	IF(.NOT.EXIST)WRITE(IUT,10010)IPNT
10010 FORMAT(1X,'File not found for qpoint ',I4)
	IF(.NOT.EXIST)GOTO 1000
	CALL FIND_LBLANK(FILE,130,NA)
      WRITE(IUT,*)'Reading ',FILE(:NA)
C ********************************
C UNDERSTAND THE LENGHT OF THE FILE
	CALL FILE_LENGHT(FILE,NLEN,IUINP)
	ALLOCATE(EPIDATA(NLEN))
C ********************************
C READ EPIFILE TO INTERNAL FILE
	OPEN(UNIT=IUINP,FILE=FILE,STATUS='OLD',FORM='FORMATTED')
	DO ILEN=1,NLEN
	READ(IUINP,FMT='(A150)')EPIDATA(ILEN)
	ENDDO
	CLOSE(IUINP)
C ********************************
C UNDERSTAND INPUT: CLASSIC or MODERN
	STRING=EPIDATA(1)
	CALL LIB_CONVLOW(STRING,150)
	CALL LIB_RMBLANK(STRING,150)
	MODERN=0
	DO IPOS=1,80
	IF(STRING(IPOS:IPOS+11).EQ.'input=modern')MODERN=2
	IF(MODERN.NE.0)EXIT
	ENDDO
	IF(MODERN.EQ.2)MODIFIED=.TRUE. 
	IF(MODERN.NE.2)CALL FULLSTOP('<EPIFILE> format not recognized!')
C ********************************
C  READING QPOINT
      CALL SUP_READEPI_QPNT(EPIDATA,NLEN,IPNT)
C  READING ELECTRON PHONON INTERACTION
      CALL SUP_READEPI_EPIM(EPIDATA,NLEN,IPNT)
C MEMORY DEALLOCATIONS
	DEALLOCATE(EPIDATA)
 1000 CONTINUE
C ERROR HANDLINGS
C	none
C *****************************************************************
	END SUBROUTINE SUP_READEPI


	SUBROUTINE SUP_READEPI_QPNT(EPIDATA,NLEN,IPNT)
************************************************************
*  <READDYN> reads dynamical matrix                        *
************************************************************
C SET ARRAY SIZE DATA
	USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_PARAM,   ONLY: NATOM,NSORT,NSPIN,NORBS,IS      !!! from readini
	USE COM_SUPMAT,  ONLY: EPIMAT                          !!! from readepi
	USE COM_KMESH,   ONLY: NPNT,PNT                        !!! from readpnt
      USE COM_CHANNELS,ONLY: IUINP                           !!! from channels
	USE COM_UNIT    ,ONLY: IUN,IUT,IUR                     !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	CHARACTER*150, ALLOCATABLE :: EPICOPY(:)
	CHARACTER STRING*150,EPIDATA(NLEN)*150
	REAL*8 QPNT(3)
	DATA PI/3.141592653589793D0/
C **************************************
C READING CONTROLS
      CALL READ_SECT(EPIDATA(1),NLEN,ISEC,NSEC,MSEC,
     &'<section=qpnt',13,'<section=',9,'ok',2)
C Set section title
      DO IPOS=1,150
      IF(EPIDATA(ISEC)(IPOS:IPOS).EQ.'>')EXIT
      ENDDO
      DO JPOS=IPOS+1,150
      IF(MSEC.NE.0)EPIDATA(ISEC)(JPOS:JPOS)=' '
      ENDDO
C Allocate temporary file
      ALLOCATE(EPICOPY(NSEC))
      DO ILIN=1,MSEC
      EPICOPY(ILIN)=EPIDATA(ILIN+ISEC-1)
      ENDDO
C **************************************
      IREC=2
	READ(EPICOPY(IREC),*)QPNT(1),QPNT(2),QPNT(3)
	IF(ABS(QPNT(1)-PNT(1,IPNT,1)).GT.1.D-05.OR.
     &   ABS(QPNT(2)-PNT(2,IPNT,1)).GT.1.D-05.OR.
     &   ABS(QPNT(3)-PNT(3,IPNT,1)).GT.1.D-05)THEN
      WRITE(IUT,*)'Q-POINTS MISMATCH'
      WRITE(IUT,10010)(QPNT(I),I=1,3)
      WRITE(IUT,10020)(PNT(I,IPNT,1),I=1,3)
10010 FORMAT(1X,'Point read: ',G14.7,1X,G14.7,1X,G14.7)
10020 FORMAT(1X,'Generated : ',G14.7,1X,G14.7,1X,G14.7)
      ENDIF
C MEMORY DEALLOCATIONS
	DEALLOCATE(EPICOPY)
      END




	SUBROUTINE SUP_READEPI_EPIM(EPIDATA,NLEN,IPNT)
************************************************************
*  <READDYN> reads dynamical matrix                        *
************************************************************
C SET ARRAY SIZE DATA
	USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_PARAM,   ONLY: NATOM,NSORT,NSPIN,NORBS,IS      !!! from readini
	USE COM_SUPMAT,  ONLY: EPIMAT,TRAMAT                   !!! from readepi
	USE COM_KMESH,   ONLY: NPNT,PNT                        !!! from readpnt
      USE COM_CHANNELS,ONLY: IUINP                           !!! from channels
	USE COM_UNIT    ,ONLY: IUN,IUT,IUR                     !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	CHARACTER*150, ALLOCATABLE :: EPICOPY(:)
	CHARACTER STRING*150,EPIDATA(NLEN)*150
	DATA PI/3.141592653589793D0/
C **************************************
C READING CONTROLS
      CALL READ_SECT(EPIDATA(1),NLEN,ISEC,NSEC,MSEC,
     &'<section=epim',13,'<section=',9,'ok',2)
C Set section title
      DO IPOS=1,150
      IF(EPIDATA(ISEC)(IPOS:IPOS).EQ.'>')EXIT
      ENDDO
      DO JPOS=IPOS+1,150
      IF(MSEC.NE.0)EPIDATA(ISEC)(JPOS:JPOS)=' '
      ENDDO
C Allocate temporary file
      ALLOCATE(EPICOPY(NSEC))
      DO ILIN=1,MSEC
      EPICOPY(ILIN)=EPIDATA(ILIN+ISEC-1)
      ENDDO
C **************************************
      IREC=1
      DO INUC=1,NATOM             !!! over displacements
      DO JNUC=1,NATOM             !!! over displacements
      IREC=IREC+1
C Read EPI rigid
      IREC=IREC+1
	DO I=1,3
	IREC=IREC+1
	READ(EPICOPY(IREC),*)(EPIMAT(I,INUC,J,JNUC,IPNT),J=1,3)
	ENDDO
C Skip EPI rigid (k-point convergency)
      IREC=IREC+4
C Read EPI total
      IREC=IREC+1
	DO I=1,3
	IREC=IREC+1
	READ(EPICOPY(IREC),*)(EPIMAT(I,INUC,J,JNUC,IPNT),J=1,3)
	ENDDO
C Skip EPI total (k-point convergency)
      IREC=IREC+4
C Read TRA 1
      IREC=IREC+1
	DO I=1,3
	IREC=IREC+1
	READ(EPICOPY(IREC),*)(TRAMAT(I,INUC,J,JNUC,1,IPNT),J=1,3)
	ENDDO
C Read TRA 2
      IREC=IREC+1
	DO I=1,3
	IREC=IREC+1
	READ(EPICOPY(IREC),*)(TRAMAT(I,INUC,J,JNUC,2,IPNT),J=1,3)
	ENDDO
C Read TRA 3
      IREC=IREC+1
	DO I=1,3
	IREC=IREC+1
	READ(EPICOPY(IREC),*)(TRAMAT(I,INUC,J,JNUC,3,IPNT),J=1,3)
	ENDDO
C Read TRA 4
      IREC=IREC+1
	DO I=1,3
	IREC=IREC+1
	READ(EPICOPY(IREC),*)(TRAMAT(I,INUC,J,JNUC,4,IPNT),J=1,3)
	ENDDO
      ENDDO                       !!! over displacements
      ENDDO                       !!! over displacements
C MEMORY DEALLOCATIONS
	DEALLOCATE(EPICOPY)
      END