	SUBROUTINE SUP_READSUP
************************************************************
*  <READSUP> controls reading the data from SUPFILE.       *
************************************************************
      USE COM_LMTINP  ,ONLY: PROJECT,INPINFO                 !!! from artinp
	USE COM_EXTENS  ,ONLY: LENEXTN                         !!! from setup
	USE COM_SUPEXT  ,ONLY: EXTNSUP                         !!! from setup
	USE COM_SUPOUT  ,ONLY: SUPFILE                         !!! from setup
      USE COM_CHANNELS,ONLY: IUINP                           !!! from channels
	USE COM_UNIT    ,ONLY: IUN,IUT,IUR                     !!! from setup
	IMPLICIT REAL*8 (A-H,O-Z)
	CHARACTER STRING*150,INF*130
	CHARACTER*150, ALLOCATABLE :: SUPDATA(:)
	LOGICAL EXIST,MODIFIED,PRESENT
	DATA PI/3.141592653589793D0/
C CHECK INPINFO
	INF=INPINFO
	CALL SUBSTR_IN_STR(PRESENT,INF,130,EXTNSUP,LENEXTN)
	IF(.NOT.PRESENT)CALL FULLSTOP('<SUPFILE> identifier not found!')
C SET FILE NAME
      CALL FIND_LBLANK(PROJECT,130,NBP)
      CALL FIND_LBLANK(EXTNSUP,60,NBE)
	SUPFILE=PROJECT(:NBP)//'.'//EXTNSUP(:NBE)
	INQUIRE(FILE=SUPFILE,EXIST=EXIST)
	IF(.NOT.EXIST)CALL FULLSTOP('<SUPFILE> not found!')
C ********************************
C UNDERSTAND THE LENGHT OF INIFILE
	CALL FILE_LENGHT(SUPFILE,NLEN,IUINP)
	ALLOCATE(SUPDATA(NLEN))
C ********************************
C READ INIFILE TO INTERNAL FILE
	OPEN(UNIT=IUINP,FILE=SUPFILE,STATUS='OLD',FORM='FORMATTED')
	DO ILEN=1,NLEN
	READ(IUINP,FMT='(A150)')SUPDATA(ILEN)
	ENDDO
	CLOSE(IUINP)
C ********************************
C UNDERSTAND INPUT: CLASSIC or MODERN
	STRING=SUPDATA(1)
	CALL LIB_CONVLOW(STRING,150)
	CALL LIB_RMBLANK(STRING,150)
	MODERN=0
	DO IPOS=1,80
	IF(STRING(IPOS:IPOS+11).EQ.'input=modern')MODERN=2
	IF(MODERN.NE.0)EXIT
	ENDDO
	IF(MODERN.EQ.2)MODIFIED=.TRUE. 
	IF(MODERN.NE.2)CALL FULLSTOP('<SUPFILE> format not recognized!')
C READ CONTROL DATA
	CALL SUP_READSUP_CTRL(SUPDATA,NLEN)
C ********************************
C SUPFILE HAS BEEN READ, OVERWRITE IT
	IF(MODIFIED)CALL READ_OVWR(SUPFILE,SUPDATA,NLEN)
C MEMORY DEALLOCATIONS
	DEALLOCATE(SUPDATA)
C ERROR HANDLINGS
C	none
C *****************************************************************
	END SUBROUTINE SUP_READSUP




	SUBROUTINE SUP_READSUP_CTRL(SUPDATA,NLEN)
*******************************************************
* Reads control                                       *
*******************************************************
C SET EXTERNAL CONNECTIONS
      USE COM_INPTTR  ,ONLY : NDIV,NDIC,NDIW
      USE COM_QMESH   ,ONLY : NQDIV
      USE COM_SUPDAT  ,ONLY : DOS,VEL,STARMU,TCEXP
      USE COM_UNIT    ,ONLY : IUN,IUR,IUT
C SET LOCAL VARIABLES 
      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER, INTRINSIC :: SIZE
      CHARACTER*150, ALLOCATABLE :: SUPCOPY(:)
      CHARACTER*150, SUPDATA(NLEN)
      CHARACTER TEXT*64,TCTRL*10,STRING*150,HELP*40,SNOT*20
      LOGICAL DEF,ASK,VAL,NTH,MDF
      DATA PI/3.141592653589793D0/
C **************************************
C READING CONTROLS
      CALL READ_SECT(SUPDATA(1),NLEN,ISEC,NSEC,MSEC,
     &'<section=ctrl',13,'<section=',9,'ok',2)
C Set section title
      DO IPOS=1,150
      IF(SUPDATA(ISEC)(IPOS:IPOS).EQ.'>')EXIT
      ENDDO
      DO JPOS=IPOS+1,150
      IF(MSEC.NE.0)SUPDATA(ISEC)(JPOS:JPOS)=' '
      ENDDO
      IF(IPOS.LE.50)THEN
      HELP='! CONTROL PARAMETERS:                   '
      IF(MSEC.NE.0)SUPDATA(ISEC)(IPOS+1:IPOS+40)=HELP
      ENDIF
C Allocate temporary file
      ALLOCATE(SUPCOPY(NSEC))
      DO ILIN=1,MSEC
      SUPCOPY(ILIN)=SUPDATA(ILIN+ISEC-1)
      ENDDO
C **************************************
C Process DOS
      DOS=1.0D0
      HELP='! Density of States at Ef               '
      LHLP=40
      CALL READ_CHAR(SUPDATA(ISEC),SUPCOPY(1),NSEC,MSEC,
     &'dos',3,IN,1,0,DOS,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Process VEL
      VEL(1)=1.0D0
      VEL(2)=1.0D0
      VEL(3)=1.0D0
      HELP='! Fermi Velocities                      '
      LHLP=40
      CALL READ_CHAR(SUPDATA(ISEC),SUPCOPY(1),NSEC,MSEC,
     &'vel(:)',6,IN,1,0,VEL,3,1,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Process Mu*
      STARMU=0.15D0
      HELP='! Coulomb pseudopotential (mu*)         '
      LHLP=40
      CALL READ_CHAR(SUPDATA(ISEC),SUPCOPY(1),NSEC,MSEC,
     &'mustar',6,IN,1,0,STARMU,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C Process Tc_exp
      TCEXP=10.D0
      HELP='! Experimental Tc (K)                   '
      LHLP=40
      CALL READ_CHAR(SUPDATA(ISEC),SUPCOPY(1),NSEC,MSEC,
     &'tcexp',5,IN,1,0,TCEXP,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
C **************************************
      CALL READ_ERRR(SUPDATA(ISEC),SUPCOPY(1),NSEC,MSEC,'CTRL')
      DEALLOCATE(SUPCOPY)
C  RESET K-POINT GRIDS TO Q-POINT GRID
      DO I=1,3
      NDIV(I)=NQDIV(I)
      NDIC(I)=NQDIV(I)
      NDIW(I)=NQDIV(I)
      ENDDO
	END SUBROUTINE SUP_READSUP_CTRL