	SUBROUTINE SUP_STORAGE
************************************************************
*  <STORAGE> checks file storage.                          *
************************************************************
C SET EXTERNAL CONNECTIONS
	USE COM_LABELS    ,ONLY: PATHSCRT                      !!! from setup
      USE COM_UNIT      ,ONLY: IUT,IUR,IUN                   !!! from setup
	USE COM_CHANNELS  ,ONLY: IUINP,IUOUT                   !!! from setup
      USE COM_LMTINP
	USE COM_LMTOUT
	USE COM_EXTENS
	USE COM_PHNOUT
	USE COM_PHNEXT
	USE COM_SUPOUT
	USE COM_SUPEXT
C FILE NAMES
      USE COM_SUPOUT
	USE COM_SUPEXT
C SET LOCAL VARIBLES
	IMPLICIT REAL*8 (A-H,O-Z)
	CHARACTER UN(100)*2,INF*130,RUN*130,RS*10
      LOGICAL EXIST,COMPUTE,PRESENT
	DATA PI/3.141592653589793D0/                             
C CHANNEL ABBREVIATIONS
	DO ICHN=1,99
      IF(ICHN.LE.9)WRITE(RS,FMT='(I1)')ICHN
      IF(ICHN.GT.9)WRITE(RS,FMT='(I2)')ICHN
      IF(ICHN.GT.99)
     &CALL FULLSTOP('<STORAGE>:: ICHN>99 NOT ASSUMED')
      NRS=INDEX(RS,' ')
      IF(ICHN.LE.9)RS='0'//RS(:NRS-1)
      IF(ICHN.GT.9)RS=RS(:NRS-1)
      NRS=INDEX(RS,' ')
	UN(ICHN)=RS(:NRS-1)
	ENDDO
C INPUT/OUTPUT
	INF=INPINFO
	RUN=RUNMODE
C ***************************************************************
C PHONON SPECTRUM
      CALL FIND_LBLANK(PROJECT,130,NBP)
      CALL FIND_LBLANK(EXTNOMG,60,NBE)
	OMGFILE=PROJECT(:NBP)//'.'//EXTNOMG(:NBE)
	CALL LIB_RMBLANK(OMGFILE,130)
      CALL SUBSTR_IN_STR(PRESENT,RUN,130,EXTNOMG,LENEXTN)
      COMPUTE=PRESENT
	IF(     COMPUTE)ICOMG=2 !!! store 
	IF(.NOT.COMPUTE)ICOMG=0 !!! do not store
C ***************************************************************
C PHONON DENSITY OF STATES
      CALL FIND_LBLANK(PROJECT,130,NBP)
      CALL FIND_LBLANK(EXTNPDS,60,NBE)
	PDSFILE=PROJECT(:NBP)//'.'//EXTNPDS(:NBE)
	CALL LIB_RMBLANK(PDSFILE,130)
      CALL SUBSTR_IN_STR(PRESENT,RUN,130,EXTNPDS,LENEXTN)
      COMPUTE=PRESENT
	IF(     COMPUTE)ICPDS=2 !!! store 
	IF(.NOT.COMPUTE)ICPDS=0 !!! do not store
C ***************************************************************
C PHONON LINEWIDTHS
      CALL FIND_LBLANK(PROJECT,130,NBP)
      CALL FIND_LBLANK(EXTNLWD,60,NBE)
	LWDFILE=PROJECT(:NBP)//'.'//EXTNLWD(:NBE)
	CALL LIB_RMBLANK(LWDFILE,130)
      CALL SUBSTR_IN_STR(PRESENT,RUN,130,EXTNLWD,LENEXTN)
      COMPUTE=PRESENT
	IF(     COMPUTE)ICLWD=2 !!! store 
	IF(.NOT.COMPUTE)ICLWD=0 !!! do not store
C ***************************************************************
C ELIASHBERG FUNCTION
      CALL FIND_LBLANK(PROJECT,130,NBP)
      CALL FIND_LBLANK(EXTNELI,60,NBE)
	ELIFILE=PROJECT(:NBP)//'.'//EXTNELI(:NBE)
	CALL LIB_RMBLANK(ELIFILE,130)
      CALL SUBSTR_IN_STR(PRESENT,RUN,130,EXTNELI,LENEXTN)
      COMPUTE=PRESENT
	IF(     COMPUTE)ICELI=2 !!! store 
	IF(.NOT.COMPUTE)ICELI=0 !!! do not store
C ***************************************************************
C TRANSPORT LINEWIDTHS
      CALL FIND_LBLANK(PROJECT,130,NBP)
      CALL FIND_LBLANK(EXTNTRA,60,NBE)
	TRAFILE=PROJECT(:NBP)//'.'//EXTNTRA(:NBE)
	CALL LIB_RMBLANK(TRAFILE,130)
      CALL SUBSTR_IN_STR(PRESENT,RUN,130,EXTNTRA,LENEXTN)
      COMPUTE=PRESENT
	IF(     COMPUTE)ICTRA=2 !!! store 
	IF(.NOT.COMPUTE)ICTRA=0 !!! do not store
C ***************************************************************
C TRANSPORT SPECTRAL FUNCTION
      CALL FIND_LBLANK(PROJECT,130,NBP)
      CALL FIND_LBLANK(EXTNSPE,60,NBE)
	SPEFILE=PROJECT(:NBP)//'.'//EXTNSPE(:NBE)
	CALL LIB_RMBLANK(SPEFILE,130)
      CALL SUBSTR_IN_STR(PRESENT,RUN,130,EXTNSPE,LENEXTN)
      COMPUTE=PRESENT
	IF(     COMPUTE)ICSPE=2 !!! store 
	IF(.NOT.COMPUTE)ICSPE=0 !!! do not store
C ***************************************************************
C ELECTRICAL RESISTIVITY
      CALL FIND_LBLANK(PROJECT,130,NBP)
      CALL FIND_LBLANK(EXTNRES,60,NBE)
	RESFILE=PROJECT(:NBP)//'.'//EXTNRES(:NBE)
	CALL LIB_RMBLANK(RESFILE,130)
      CALL SUBSTR_IN_STR(PRESENT,RUN,130,EXTNRES,LENEXTN)
      COMPUTE=PRESENT
	IF(     COMPUTE)ICRES=2 !!! store 
	IF(.NOT.COMPUTE)ICRES=0 !!! do not store
C ***************************************************************
C PHONON FREE ENERGY
      CALL FIND_LBLANK(PROJECT,130,NBP)
      CALL FIND_LBLANK(EXTNFRE,60,NBE)
	FREFILE=PROJECT(:NBP)//'.'//EXTNFRE(:NBE)
	CALL LIB_RMBLANK(FREFILE,130)
      CALL SUBSTR_IN_STR(PRESENT,RUN,130,EXTNFRE,LENEXTN)
      COMPUTE=PRESENT
	IF(     COMPUTE)ICFRE=2 !!! store 
	IF(.NOT.COMPUTE)ICFRE=0 !!! do not store
C ***************************************************************
C OUTPUT FILE
      CALL FIND_LBLANK(PROJECT,130,NBP)
      CALL FIND_LBLANK(EXTNOUT,60,NBE)
	OUTFILE=PROJECT(:NBP)//'.'//EXTNOUT(:NBE)
	CALL LIB_RMBLANK(OUTFILE,130)
      CALL SUBSTR_IN_STR(PRESENT,RUN,130,EXTNOUT,LENEXTN)
      COMPUTE=PRESENT
      IF(     COMPUTE)ICOUT=2 !!! store output inforamtion
      IF(.NOT.COMPUTE)ICOUT=0 !!! print output information
      INQUIRE(FILE=OUTFILE,EXIST=EXIST)
      IF(EXIST.AND.ICOUT.EQ.1)THEN
	WRITE(IUT,*)'Terminated in <STORAGE>::' 
	WRITE(IUT,*)'Output OUTFILE ',OUTFILE
	WRITE(IUT,*)'should not exist for this mode.'
      ELSEIF(EXIST.AND.ICOUT.EQ.2)THEN
C delete it
      OPEN(UNIT=IUINP,FILE=OUTFILE,FORM='FORMATTED',STATUS='OLD')
	CALL FIND_LBLANK(OUTFILE,130,NA)
      WRITE(IUT,*)OUTFILE(:NA),' DELETED !'
      CLOSE(UNIT=IUINP,STATUS='DELETE')
      ENDIF
      IF(ICOUT.NE.0)THEN
      IUN=IUOUT
      OPEN(UNIT=IUOUT,FILE=OUTFILE,STATUS='NEW')
      ELSE
      IUN=IUT
      ENDIF
C ***************************************************************
C SET SCRATCH STORAGE FILENAMES
      CALL FIND_LBLANK(PROJECT,130,NBP)
      CALL FIND_LBLANK(EXTNSCR,60,NBE)
	ISCR1MIN=1
	ISCR1MAX=99
	ALLOCATE(SCRFILE(1:99))
	SCRFILE(1)=PROJECT(:NBP)//'.'//EXTNSCR(:NBE)
	CALL LIB_RMBLANK(SCRFILE(1),130)
	CALL FIND_LBLANK(SCRFILE(1),130,NA)
	CALL FIND_LBLANK(PATHSCRT,130,NS)
      DO I=2,99
      SCRFILE(I)=PATHSCRT(:NS)//SCRFILE(1)(:NA)//UN(I)
      ENDDO
      SCRFILE(1)=PATHSCRT(:NS)//SCRFILE(1)(:NA)//UN(1)
      DO I=1,99
      INQUIRE(FILE=SCRFILE(I),EXIST=EXIST)
      IF(EXIST)THEN
      OPEN(UNIT=IUINP,FILE=SCRFILE(I),FORM='UNFORMATTED',STATUS='OLD')
	CALL FIND_LBLANK(SCRFILE(I),130,NA)
      WRITE(IUT,*)SCRFILE(I)(:NA)//' DELETED !'
      CLOSE(UNIT=IUINP,STATUS='DELETE')
      ENDIF
      ENDDO
	END SUBROUTINE SUP_STORAGE
