	SUBROUTINE SUP_PHNLWD
**********************************************************
*  Calculates phonon linewidths.                         *
**********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                  !!! from setup
      USE COM_PARAM,   ONLY: NATOM,NSORT,NSPIN,NORBS,IS               !!! from readini
	USE COM_SPHERE,  ONLY: AMAS                                     !!! from init
	USE COM_KMESH,   ONLY: NPNT,PNT,WGT                             !!! from readpnt
	USE COM_SUPDAT,  ONLY: UNITS,TXTUN,VEL,DOS,STARMU,TCEXP         !!! from readsup
	USE COM_SUPMAT,  ONLY: EPIMAT,DPOL,OM,GAMEPI,ALMEPI             !!! from omegaq
      USE COM_UNIT,    ONLY: IUN,IUR,IUT,IUI                          !!! from setup
      USE COM_SUPOUT,  ONLY: ICLWD,LWDFILE                            !!! from init
      USE COM_LABELS  ,ONLY: TXTAT,TXTEL,TXTSP                        !!! from readini
      USE COM_CHANNELS,ONLY: IUAIN                                    !!! from channels
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: ALMTOT(:)
	COMPLEX*16, ALLOCATABLE :: PARLAM(:)
	COMPLEX*16 ALAMTOT,HOPFTOT
	CHARACTER*150, ALLOCATABLE :: LWDDATA(:)
      CHARACTER*150, ALLOCATABLE :: LWDCOPY(:)
      CHARACTER TCTRL*10,HELP*40,TUN*3
	LOGICAL EXIST,DEF,ASK,VAL,NTH
	DATA PI/3.141592653589793D0/,KU/4/
	ALLOCATE(ALMTOT(NPNT(1)))
	ALLOCATE(PARLAM(NSORTMEM))
C  CALCULATE PHONON LINEWIDTHS AND ELECTRON-PHONON COUPLING CONSTANT
	ALMIN=10.D+10
	ALMAX=0.D0
	DO ISORT=1,NSORT
	PARLAM(ISORT)=0.D0
	ENDDO
	DO 60 IPNT=1,NPNT(1)
	ALMTOT(IPNT)=0.D0
	DO 50 IBND=1,3*NATOM
	GAMEPI(IBND,IPNT)=(0.D0,0.D0)
	DO 40 IATOM=1,NATOM
	DO 30 JATOM=1,NATOM
C  RYDBERGS UNITS:
	AMS=1.D0/SQRT(AMAS(IS(IATOM))*AMAS(IS(JATOM)))
	AMS=AMS*109.752*(0.003162278D0)**2      !!! since Me=5.4876D-04 m.a.
	DO 20 IA=1,3
	DO 10 IB=1,3
	GAMEPI(IBND,IPNT)=GAMEPI(IBND,IPNT)+
     &DCONJG(DPOL(IA,IATOM,IBND,IPNT))*
     &EPIMAT(IA,IATOM,IB,JATOM,IPNT)*
     &DPOL(IB,JATOM,IBND,IPNT)*AMS
  10  CONTINUE
  20  CONTINUE
  30  CONTINUE
  40  CONTINUE
	IF(ABS(OM(IBND,IPNT)).LE.1.D-10)DOM1=0.D0
	IF(ABS(OM(IBND,IPNT)).GT.1.D-10)DOM1=1.D0/(OM(IBND,IPNT)/
     &  13.6058D0) ! Ry
	IF(OM(IBND,IPNT).GT.0.D0)FAC=1.D0
	IF(OM(IBND,IPNT).LT.0.D0)FAC=0.D0
	ALMEPI(IBND,IPNT)=GAMEPI(IBND,IPNT)*FAC*DOM1*DOM1   !!! Ry/Ry units
	GAMEPI(IBND,IPNT)=GAMEPI(IBND,IPNT)*PI*DOS/2.D0*13.6058D0 !!! eV units again
	ALMIN=MIN(ALMIN,DREAL(ALMEPI(IBND,IPNT)))
	ALMAX=MAX(ALMAX,DREAL(ALMEPI(IBND,IPNT)))
	ALMTOT(IPNT)=ALMTOT(IPNT)+ALMEPI(IBND,IPNT)
  50  CONTINUE
C  SET PARTIAL LAMBDA'S
	DO ISORT=1,NSORT
	DO IATOM=1,NATOM
	IF(ISORT.EQ.IS(IATOM))THEN
	AMS=1.D0/SQRT(AMAS(IS(IATOM))*AMAS(IS(IATOM)))
	AMS=AMS*109.752*(0.003162278D0)**2      !!! since Me=5.4876D-04 m.a.
	DO IBND=1,3*NATOM
	PARBND=0.D0
	DO IA=1,3
	DO IB=1,3
	PARBND=PARBND+DCONJG(DPOL(IA,IATOM,IBND,IPNT))*
     &EPIMAT(IA,IATOM,IB,IATOM,IPNT)*DPOL(IB,IATOM,IBND,IPNT)*AMS
	ENDDO
	ENDDO
	IF(ABS(OM(IBND,IPNT)).LE.1.D-10)DOM1=0.D0
	IF(ABS(OM(IBND,IPNT)).GT.1.D-10)DOM1=1.D0/(OM(IBND,IPNT)/
     &  13.6058D0) ! Ry
	PARLAM(ISORT)=PARLAM(ISORT)+PARBND*DOM1*DOM1*WGT(IPNT,1)/2.D0 
	ENDDO
	ENDIF
	ENDDO
	ENDDO
  60  CONTINUE
C  EVALUATE TOTAL LAMBDA
	ALAMTOT=(0.D0,0.D0)
	HOPFTOT=(0.D0,0.D0)
	OMEGAAV=0.D0 ! will be in eV
	OMEGASQ=0.D0 ! will be in eV
	OMEGALG=0.D0 ! will be in K
	DO 100 IPNT=1,NPNT(1)
	DO 70 IBND=1,3*NATOM
	ALAMTOT=ALAMTOT+ALMEPI(IBND,IPNT)*WGT(IPNT,1)/2.D0 ! 2 because of spin-factor
	OMEGAAV=OMEGAAV+DREAL(ALMEPI(IBND,IPNT))*OM(IBND,IPNT)*
     &WGT(IPNT,1)/2.D0
	OMEGASQ=OMEGASQ+DREAL(ALMEPI(IBND,IPNT))*OM(IBND,IPNT)**2*
     &WGT(IPNT,1)/2.D0
	IF(ABS(OM(IBND,IPNT)).GE.1.D-10)
     &OMEGALG=OMEGALG+DREAL(ALMEPI(IBND,IPNT))*WGT(IPNT,1)/2.D0*
     &LOG(ABS(OM(IBND,IPNT))*UNITS(2))
  70  CONTINUE
	DO 90 IATOM=1,NATOM
	DO 80 IA=1,3
	HOPFTOT=HOPFTOT+EPIMAT(IA,IATOM,IA,IATOM,IPNT)*WGT(IPNT,1)/2.D0
  80  CONTINUE
  90  CONTINUE
 100  CONTINUE
	OMEGASQ=OMEGASQ/DREAL(ALAMTOT)
	OMEGAAV=OMEGAAV/DREAL(ALAMTOT)
	OMEGALG=EXP(OMEGALG/DREAL(ALAMTOT))
	OMG2=SQRT(OMEGASQ)*UNITS(2)
	ALAM1=2.46D0*(1.D0+3.8D0*STARMU)
	ALAM2=1.82D0*(1.D0+6.3D0*STARMU)*(OMG2/OMEGALG)
	F1=(1.D0+(DREAL(ALAMTOT)/ALAM1)**1.5D0)**0.3333333333333D0
	F2=1.D0+(OMG2/OMEGALG-1.D0)*DREAL(ALAMTOT)**2/
     &  (DREAL(ALAMTOT)**2+ALAM2**2)
	HIGHTC=OMEGALG/1.2D0*EXP(-1.04D0*(1.D0+DREAL(ALAMTOT))
     &  /(DREAL(ALAMTOT)-STARMU-0.62D0*DREAL(ALAMTOT)*STARMU))
	THRMUS=1.D0/(1.D0+0.62D0*DREAL(ALAMTOT))*(
     &  DREAL(ALAMTOT)+1.04D0*(1.D0+DREAL(ALAMTOT))/
     &  LOG(1.2D0*TCEXP/OMEGALG)) !!! Tc-exp was in K from read.
	WRITE(IUN,10000)DREAL(ALAMTOT)
	WRITE(IUN,10001)DREAL(HOPFTOT)
	WRITE(IUN,10002)OMEGAAV*UNITS(KU),TXTUN(KU)
	WRITE(IUN,10003)OMEGALG,TXTUN( 2)
	WRITE(IUN,10013)OMG2,TXTUN( 2)
	WRITE(IUN,10004)HIGHTC,TXTUN( 2),TCEXP
	WRITE(IUN,10005)THRMUS,STARMU
	WRITE(IUN,10006)F1,F2
10000 FORMAT(1X,'TOTAL LAMBDA - COUPLING CONSTANT  = ',G14.7)
10001 FORMAT(1X,'TOTAL ETA    - HOPFIELD PARAMETER = ',G14.7,
     &  ' Ry/a^2')
10002 FORMAT(1X,'Estimated <omega>        = ',G14.7,1X,A3)
10003 FORMAT(1X,'Estimated exp<ln(omega)> = ',G14.7,1X,A3)
10013 FORMAT(1X,'Estimated <omega^2>^1/2  = ',G14.7,1X,A3)
10004 FORMAT(1X,'Estimated Tc             = ',G14.7,1X,A3,
     &  ', Tc-exp=',G10.3)
10005 FORMAT(1X,'Estimated mu from Tc-exp = ',G14.7,4X,
     &  ', Mu-inp=',G10.3)
10006 FORMAT(1X,'Prefactors f1, f2  found = ',G14.7,2X,G14.7)
C  STORE LINEWIDTHS
	IF(ICLWD.NE.0)THEN
	INQUIRE(FILE=LWDFILE,EXIST=EXIST)
	IF(EXIST)THEN
      OPEN(UNIT=IUAIN,FILE=LWDFILE,STATUS='OLD',FORM='FORMATTED')
C ********************************
C UNDERSTAND THE LENGHT OF INIFILE
	CALL FILE_LENGHT(LWDFILE,NLEN,IUAIN)
	NLEN=MIN(NLEN,100)
	ALLOCATE(LWDDATA(NLEN))
C ********************************
C READ INIFILE TO INTERNAL FILE
      OPEN(UNIT=IUAIN,FILE=LWDFILE,STATUS='OLD',FORM='FORMATTED')
	DO ILEN=1,NLEN
	READ(IUAIN,FMT='(A150)')LWDDATA(ILEN)
	ENDDO
C **************************************
C READING CONTROLS
      CALL READ_SECT(LWDDATA(1),NLEN,ISEC,NSEC,MSEC,
     &'<section=ctrl',13,'<section=',9,'ok',2)
C Set section title
      DO IPOS=1,150
      IF(LWDDATA(ISEC)(IPOS:IPOS).EQ.'>')EXIT
      ENDDO
      DO JPOS=IPOS+1,150
      IF(MSEC.NE.0)LWDDATA(ISEC)(JPOS:JPOS)=' '
      ENDDO
      IF(IPOS.LE.50)THEN
      HELP='! CONTROL PARAMETERS:                   '
      IF(MSEC.NE.0)LWDDATA(ISEC)(IPOS+1:IPOS+40)=HELP
      ENDIF
C Allocate temporary file
      ALLOCATE(LWDCOPY(NSEC))
      DO ILIN=1,MSEC
      LWDCOPY(ILIN)=LWDDATA(ILIN+ISEC-1)
      ENDDO
C **************************************
C Process Units
      TCTRL=TXTUN(KU)
      HELP='! Output Units: eV,K,rsm,THz            '
      LHLP=40
      CALL READ_CHAR(LWDDATA(ISEC),LWDCOPY(1),NSEC,MSEC,
     &'units',5,IN,1,0,RE,1,0,CM,1,0,TCTRL,10,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
      KU=-1
      CALL LIB_CONVLOW(TCTRL,10)
      CALL LIB_RMBLANK(TCTRL,10)
	NB=INDEX(TCTRL,' ')
	DO IU=1,4
	TUN=TXTUN(IU)
	CALL LIB_CONVLOW(TUN,3)
	IF(TCTRL(:NB-1).EQ.TUN)KU=IU
	ENDDO
      IF(KU.EQ.-1)CALL FULLSTOP('<LWDFILE> Units not recognized')
      CALL READ_ERRR(LWDDATA(ISEC),LWDCOPY(1),NSEC,MSEC,'CTRL')
      DEALLOCATE(LWDCOPY,LWDDATA)
	CLOSE(UNIT=IUAIN,STATUS='DELETE')
	ENDIF
	OPEN(UNIT=IUAIN,FILE=LWDFILE,STATUS='NEW',FORM='FORMATTED')
	WRITE(IUAIN,10010)
	WRITE(IUAIN,10020)
10010	FORMAT(1X,'<FILE=LWDFILE,INPUT=MODERN>')
10020 FORMAT('****************************************************')
	WRITE(IUAIN,10030)
10030 FORMAT(1X,'<SECTION=CTRL>               ! Controls:')
      HELP='! Output Units: eV,K,rsm,THz            '
      WRITE(IUAIN,10040)TXTUN(KU),HELP
10040 FORMAT(1X,'Units  =',A3,18X,A40)
	WRITE(IUAIN,10050)
10050 FORMAT(1X,'<SECTION=DATA>               ! Linewidths:')
	DO IPNT=1,NPNT(1)
	WRITE(IUAIN,10120)(PNT(I,IPNT,1),I=1,3)
C  WRITE DOUBLE WIDTHS (FULL WIDTHS AT HALF MAXIMUM)
	WRITE(IUAIN,10130)
     &(2.D0*DREAL(GAMEPI(I,IPNT))*UNITS(KU),I=1,3*NATOM)
	WRITE(IUAIN,10130)(DREAL(ALMEPI(I,IPNT)),I=1,3*NATOM),
     &DREAL(ALMTOT(IPNT))
      ENDDO
	CLOSE(IUAIN)
	ENDIF
	WRITE(IUN,10140)ALMIN
	WRITE(IUN,10150)ALMAX
	DO ISORT=1,NSORT
	WRITE(IUN,10160)PARLAM(ISORT),TXTEL(ISORT)
	ENDDO
10110 FORMAT(1X,I3,2X,I3)
10120 FORMAT(1X,G14.7,1X,G14.7,1X,G14.7)
10130 FORMAT(1X,4(G12.5,1X))
10140 FORMAT(1X,'Minimal lambda(qj) found = ',G14.7)
10150 FORMAT(1X,'Maximal lambda(qj) found = ',G14.7)
10160 FORMAT(1X,'Partial lambda_tot found = ',G14.7,1X, A10)
C MEMORY DEALLOCATIONS
      DEALLOCATE(ALMTOT,PARLAM)
	END


	SUBROUTINE SUP_TRALWD
**********************************************************
*  Calculates transport linewidths.                      *
**********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                  !!! from setup
      USE COM_PARAM,   ONLY: NATOM,NSORT,NSPIN,NORBS,IS               !!! from readini
	USE COM_SPHERE,  ONLY: AMAS                                     !!! from init
	USE COM_KMESH,   ONLY: NPNT,PNT,WGT                             !!! from readpnt
	USE COM_SUPDAT,  ONLY: UNITS,TXTUN,VEL,DOS,STARMU,TCEXP         !!! from readsup
	USE COM_SUPMAT,  ONLY: TRAMAT,DPOL,OM,GAMTRA,ALMTRA             !!! from omegaq
      USE COM_UNIT,    ONLY: IUN,IUR,IUT,IUI                          !!! from setup
      USE COM_SUPOUT,  ONLY: ICTRA,TRAFILE                            !!! from init
      USE COM_CHANNELS,ONLY: IUAIN                                    !!! from channels
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16, ALLOCATABLE :: ALMTOT(:,:)
	COMPLEX*16 ALAMOUT,ALAMOUT1,ALAMOUT2,ALAMIN,ALAMTR
     &   ,HOPFOUT,HOPFOUT1,HOPFOUT2,HOPFIN,HOPFTR
	CHARACTER*150, ALLOCATABLE :: TRADATA(:)
      CHARACTER*150, ALLOCATABLE :: TRACOPY(:)
      CHARACTER TCTRL*10,HELP*40,TUN*3
	LOGICAL EXIST,DEF,ASK,VAL,NTH
	DATA PI/3.141592653589793D0/,KU/4/
      ALLOCATE(ALMTOT(4,NPNT(1)))
	VTOT=(VEL(1)+VEL(2)+VEL(3))
C  CALCULATE TRANSPORT LINEWIDTHS AND TRANSPORT CONSTANT
	DO 60 IPNT=1,NPNT(1)
	DO 55 IC=1,4
	ALMTOT(IC,IPNT)=0.D0
	DO 50 IBND=1,3*NATOM
	GAMTRA(IC,IBND,IPNT)=(0.D0,0.D0)
	DO 40 IATOM=1,NATOM
	DO 30 JATOM=1,NATOM
C  RYDBERGS UNITS:
	AMS=1.D0/SQRT(AMAS(IS(IATOM))*AMAS(IS(JATOM)))
	AMS=AMS*109.752*(0.003162278D0)**2      !!! since Me=5.4876D-04 m.a.
	DO 20 IA=1,3
	DO 10 IB=1,3
	GAMTRA(IC,IBND,IPNT)=GAMTRA(IC,IBND,IPNT)+
     &DCONJG(DPOL(IA,IATOM,IBND,IPNT))*
     &TRAMAT(IA,IATOM,IB,JATOM,IC,IPNT)*
     &DPOL(IB,JATOM,IBND,IPNT)*AMS
  10  CONTINUE
  20  CONTINUE
  30  CONTINUE
  40  CONTINUE
	IF(ABS(OM(IBND,IPNT)).LE.1.D-10)DOM1=0.D0
	IF(ABS(OM(IBND,IPNT)).GT.1.D-10)DOM1=1.D0/(OM(IBND,IPNT)/
     &  13.6058D0) ! Ry
	IF(OM(IBND,IPNT).GT.0.D0)FAC=1.D0
	IF(OM(IBND,IPNT).LT.0.D0)FAC=0.D0
	ALMTRA(IC,IBND,IPNT)=GAMTRA(IC,IBND,IPNT)*FAC*DOM1*DOM1   !!! Ry/Ry units
	GAMTRA(IC,IBND,IPNT)=GAMTRA(IC,IBND,IPNT)*PI*VTOT/2.D0*13.6058D0 !!!eV units
	ALMTOT(IC,IPNT)=ALMTOT(IC,IPNT)+ALMTRA(IC,IBND,IPNT)
  50  CONTINUE
  55  CONTINUE
  60  CONTINUE
C  EVALUATE TOTAL TRANSPORT LAMBDA
	ALAMOUT1=(0.D0,0.D0)
	ALAMOUT2=(0.D0,0.D0)
	ALAMIN=(0.D0,0.D0)
	ALAMTR=(0.D0,0.D0)
	HOPFOUT1=(0.D0,0.D0)
	HOPFOUT2=(0.D0,0.D0)
	HOPFIN=(0.D0,0.D0)
	HOPFTR=(0.D0,0.D0)
	OMEGAAV=0.D0 ! will be in eV
	OMEGASQ=0.D0 ! will be in eV
	OMEGALG=0.D0 ! will be in K
	DO 100 IPNT=1,NPNT(1)
	DO 70 IBND=1,3*NATOM
	ALAMOUT1=ALAMOUT1+ALMTRA(1,IBND,IPNT)*WGT(IPNT,1)/2.D0 ! 2 spin-factor
	ALAMOUT2=ALAMOUT2+ALMTRA(2,IBND,IPNT)*WGT(IPNT,1)/2.D0 ! 2 spin-factor
	ALAMIN=ALAMIN+2.D0*ALMTRA(3,IBND,IPNT)*WGT(IPNT,1)/2.D0 ! 2 spin-factor
	ALAMTR=ALAMTR+ALMTRA(4,IBND,IPNT)*WGT(IPNT,1)/2.D0 ! 2 spin-factor
	OMEGAAV=OMEGAAV+DREAL(ALMTRA(4,IBND,IPNT))*OM(IBND,IPNT)*
     &WGT(IPNT,1)/2.D0
	OMEGASQ=OMEGASQ+DREAL(ALMTRA(4,IBND,IPNT))*OM(IBND,IPNT)**2*
     &WGT(IPNT,1)/2.D0
	IF(ABS(OM(IBND,IPNT)).GE.1.D-10)
     &OMEGALG=OMEGALG+DREAL(ALMTRA(4,IBND,IPNT))*WGT(IPNT,1)/2.D0*
     &LOG(ABS(OM(IBND,IPNT))*UNITS(2))
  70  CONTINUE
	DO 90 IATOM=1,NATOM
	DO 80 IA=1,3
	HOPFOUT1=HOPFOUT1+TRAMAT(IA,IATOM,IA,IATOM,1,IPNT)*
     &WGT(IPNT,1)/2.D0
	HOPFOUT2=HOPFOUT2+TRAMAT(IA,IATOM,IA,IATOM,2,IPNT)*
     &WGT(IPNT,1)/2.D0
	HOPFIN=HOPFIN+2.D0*TRAMAT(IA,IATOM,IA,IATOM,3,IPNT)*
     &WGT(IPNT,1)/2.D0
	HOPFTR=HOPFTR+TRAMAT(IA,IATOM,IA,IATOM,4,IPNT)*
     &WGT(IPNT,1)/2.D0
  80  CONTINUE
  90  CONTINUE
 100  CONTINUE
	ALAMOUT=ALAMOUT1+ALAMOUT2
	HOPFOUT=HOPFOUT1+HOPFOUT2
	OMEGASQ=OMEGASQ/DREAL(ALAMTR)
	OMEGAAV=OMEGAAV/DREAL(ALAMTR)
	OMEGALG=EXP(OMEGALG/DREAL(ALAMTR))
	OMG2=SQRT(OMEGASQ)*UNITS(2)
	IF(ABS(ALAMTR-(ALAMOUT-ALAMIN)).GE.1.D-04)PRINT*,
     &  'ERROR IN LAMBDA(TR):',ABS(ALAMTR-(ALAMOUT-ALAMIN))
	WRITE(IUN,10001)DREAL(ALAMOUT),DREAL(ALAMOUT1),DREAL(ALAMOUT2) 
	WRITE(IUN,10002)DREAL(ALAMIN)
	WRITE(IUN,10003)DREAL(ALAMTR)
	WRITE(IUN,10004)DREAL(ALAMOUT-ALAMIN)
	WRITE(IUN,10005)DREAL(HOPFOUT),DREAL(HOPFOUT1),DREAL(HOPFOUT2) 
	WRITE(IUN,10006)DREAL(HOPFIN)
	WRITE(IUN,10007)DREAL(HOPFTR)
	WRITE(IUN,10008)DREAL(HOPFOUT-HOPFIN)
	WRITE(IUN,10009)OMEGAAV*UNITS(KU),TXTUN(KU)
	WRITE(IUN,10011)OMEGALG,TXTUN(2)
	WRITE(IUN,10012)OMG2,TXTUN(2)                  
10001 FORMAT(1X,'Total lambda(out)= ',G14.7,'; out1=',G12.5,
     &'; out2=',G12.5)
10002 FORMAT(1X,'Total lambda(in) = ',G14.7)
10003 FORMAT(1X,'Total lambda(tr) = ',G14.7)
10004 FORMAT(1X,'lambda(out-in)   = ',G14.7)
10005 FORMAT(1X,'Total eta(out)   = ',G14.7,'; out1=',G12.5,
     &'; out2=',G12.5,' Ry/a^2')
10006 FORMAT(1X,'Total eta(in)    = ',G14.7,' Ry/a^2')
10007 FORMAT(1X,'Total eta(tr)    = ',G14.7,' Ry/a^2')
10008 FORMAT(1X,'eta(out)-eta(in) = ',G14.7,' Ry/a^2')
10009 FORMAT(1X,'Estimated <omega>_tr     = ',G14.7,1X,A3)
10011 FORMAT(1X,'Estimated exp<ln(omega)> = ',G14.7,1X,A3)
10012 FORMAT(1X,'Estimated <omega^2>^1/2  = ',G14.7,1X,A3)
C  STORE TRANSPORT LINEWIDTHS
	IF(ICTRA.NE.0)THEN
	INQUIRE(FILE=TRAFILE,EXIST=EXIST)
	IF(EXIST)THEN
      OPEN(UNIT=IUAIN,FILE=TRAFILE,STATUS='OLD',FORM='FORMATTED')
C ********************************
C UNDERSTAND THE LENGHT OF INIFILE
	CALL FILE_LENGHT(TRAFILE,NLEN,IUAIN)
	NLEN=MIN(NLEN,100)
	ALLOCATE(TRADATA(NLEN))
C ********************************
C READ INIFILE TO INTERNAL FILE
      OPEN(UNIT=IUAIN,FILE=TRAFILE,STATUS='OLD',FORM='FORMATTED')
	DO ILEN=1,NLEN
	READ(IUAIN,FMT='(A150)')TRADATA(ILEN)
	ENDDO
C **************************************
C READING CONTROLS
      CALL READ_SECT(TRADATA(1),NLEN,ISEC,NSEC,MSEC,
     &'<section=ctrl',13,'<section=',9,'ok',2)
C Set section title
      DO IPOS=1,150
      IF(TRADATA(ISEC)(IPOS:IPOS).EQ.'>')EXIT
      ENDDO
      DO JPOS=IPOS+1,150
      IF(MSEC.NE.0)TRADATA(ISEC)(JPOS:JPOS)=' '
      ENDDO
      IF(IPOS.LE.50)THEN
      HELP='! CONTROL PARAMETERS:                   '
      IF(MSEC.NE.0)TRADATA(ISEC)(IPOS+1:IPOS+40)=HELP
      ENDIF
C Allocate temporary file
      ALLOCATE(TRACOPY(NSEC))
      DO ILIN=1,MSEC
      TRACOPY(ILIN)=TRADATA(ILIN+ISEC-1)
      ENDDO
C **************************************
C Process Units
      TCTRL=TXTUN(KU)
      HELP='! Output Units: eV,K,rsm,THz            '
      LHLP=40
      CALL READ_CHAR(TRADATA(ISEC),TRACOPY(1),NSEC,MSEC,
     &'units',5,IN,1,0,RE,1,0,CM,1,0,TCTRL,10,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
      KU=-1
      CALL LIB_CONVLOW(TCTRL,10)
      CALL LIB_RMBLANK(TCTRL,10)
	NB=INDEX(TCTRL,' ')
	DO IU=1,4
	TUN=TXTUN(IU)
	CALL LIB_CONVLOW(TUN,3)
	IF(TCTRL(:NB-1).EQ.TUN)KU=IU
	ENDDO
      IF(KU.EQ.-1)CALL FULLSTOP('<TRAFILE> Units not recognized')
      CALL READ_ERRR(TRADATA(ISEC),TRACOPY(1),NSEC,MSEC,'CTRL')
      DEALLOCATE(TRACOPY,TRADATA)
	CLOSE(UNIT=IUAIN,STATUS='DELETE')
	ENDIF
	OPEN(UNIT=IUAIN,FILE=TRAFILE,STATUS='NEW',FORM='FORMATTED')
	WRITE(IUAIN,10010)
	WRITE(IUAIN,10020)
10010	FORMAT(1X,'<FILE=TRAFILE,INPUT=MODERN>')
10020 FORMAT('****************************************************')
	WRITE(IUAIN,10030)
10030 FORMAT(1X,'<SECTION=CTRL>               ! Controls:')
      HELP='! Output Units: eV,K,rsm,THz            '
      WRITE(IUAIN,10040)TXTUN(KU),HELP
10040 FORMAT(1X,'Units  =',A3,18X,A40)
	WRITE(IUAIN,10050)
10050 FORMAT(1X,'<SECTION=DATA>               ! Linewidths:')
	DO IPNT=1,NPNT(1)
	WRITE(IUAIN,10120)(PNT(I,IPNT,1),I=1,3)
C  WRITE DOUBLE WIDTHS (FULL WIDTHS AT HALF MAXIMUM)
	WRITE(IUAIN,10130)
     &(2.D0*DREAL(GAMTRA(1,I,IPNT))*UNITS(KU),I=1,3*NATOM)
	WRITE(IUAIN,10130)
     &(2.D0*DREAL(GAMTRA(2,I,IPNT))*UNITS(KU),I=1,3*NATOM)
	WRITE(IUAIN,10130)
     &(2.D0*DREAL(GAMTRA(3,I,IPNT))*UNITS(KU),I=1,3*NATOM)
	WRITE(IUAIN,10130)
     &(2.D0*DREAL(GAMTRA(4,I,IPNT))*UNITS(KU),I=1,3*NATOM)
	WRITE(IUAIN,10130)
     &(DREAL(ALMTRA(1,I,IPNT)),I=1,3*NATOM),
     & DREAL(ALMTOT(1,IPNT))
	WRITE(IUAIN,10130)(DREAL(ALMTRA(2,I,IPNT)),I=1,3*NATOM),
     &  DREAL(ALMTOT(2,IPNT))
	WRITE(IUAIN,10130)(DREAL(ALMTRA(3,I,IPNT)),I=1,3*NATOM),
     &  DREAL(ALMTOT(3,IPNT))
	WRITE(IUAIN,10130)(DREAL(ALMTRA(4,I,IPNT)),I=1,3*NATOM),
     &  DREAL(ALMTOT(4,IPNT))
      ENDDO
	CLOSE(IUAIN)
	ENDIF
10120 FORMAT(1X,G14.7,1X,G14.7,1X,G14.7)
10130 FORMAT(1X,4(G12.5,1X))
C MEMORY DEALLOCATIONS
      DEALLOCATE(ALMTOT)
	END




	SUBROUTINE SUP_ELRESI
*******************************************************************
*  Calculates phonon-limited electrical and thermal resistivity.  *
*******************************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                  !!! from setup
      USE COM_PARAM,   ONLY: NATOM,NSORT,NSPIN,NORBS,IS               !!! from readini
	USE COM_SPHERE,  ONLY: AMAS                                     !!! from init
	USE COM_KMESH,   ONLY: NPNT,PNT,WGT                             !!! from readpnt
	USE COM_LATPAR,  ONLY: PAR,ORTH,OMEGAC                          !!! from readstr
	USE COM_SUPDAT,  ONLY: UNITS,TXTUN,VEL,DOS,STARMU,TCEXP         !!! from readsup
	USE COM_SUPMAT,  ONLY: TRAMAT,DPOL,OM,GAMTRA,ALMTRA             !!! from omegaq
      USE COM_UNIT,    ONLY: IUN,IUR,IUT,IUI                          !!! from setup
      USE COM_SUPOUT,  ONLY: ICRES,RESFILE                            !!! from init
      USE COM_CHANNELS,ONLY: IUAIN                                    !!! from channels
	IMPLICIT REAL*8 (A-H,O-Z)
	CHARACTER*150, ALLOCATABLE :: RESDATA(:)
      CHARACTER*150, ALLOCATABLE :: RESCOPY(:)
      CHARACTER TCTRL*10,HELP*40,TUN*3
	LOGICAL EXIST,DEF,ASK,VAL,NTH
	DATA PI/3.141592653589793D0/,KU/2/
	VTOT=VEL(1)+VEL(2)+VEL(3)
	BOLCON=1.D0/13.6058D0/UNITS(2) ! Boltzman constant in atomic(Ry)units
	COEFR=0.02302D0    ! from atomic units (Ry) to mOm*cm
	COEFW=85.15146D+05 ! from atomic units (Ry) to cm*K/W
C  EVALUATE ELECTRICAL AND THERMAL RESISTIVITY AT ZERO TEMPERATURE, 273.15 K.
	RINT=0.D0
	WINT=0.D0
	TEMP=273.15D0/UNITS(2) ! eV
	TMINRES=0.D0
	TMAXRES=1000.D0/UNITS(2) ! eV
	NTMPRES=100
	DO 20 IPNT=1,NPNT(1)
	DO 10 IBND=1,3*NATOM
	IF(ABS(OM(IBND,IPNT)).LE.1.D-05)GOTO10
	IF(OM(IBND,IPNT).LT.0.D0)GOTO 10
	XPAR=OM(IBND,IPNT)/2.D0/TEMP
	ARGM=XPAR**2/SINH(XPAR)**2
	RINT=RINT+0.5D0*ARGM*ALMTRA(4,IBND,IPNT)*WGT(IPNT,1)/2.D0 ! 2 because of spin
	WINT=WINT+0.5D0*ARGM*(ALMTRA(4,IBND,IPNT)+4.D0*XPAR**2/PI**2*
     &  (ALMTRA(1,IBND,IPNT)+ALMTRA(2,IBND,IPNT))+2.D0*XPAR**2/PI**2*
     &  2.D0*ALMTRA(3,IBND,IPNT))*WGT(IPNT,1)/2.D0 ! 2 because of spin
  10  CONTINUE
  20  CONTINUE
	ERES=RINT*(12.D0*PI*OMEGAC*(TEMP/13.6058D0)/2.D0/VTOT)! atomic (Ry) units
	WRES=WINT*(36.D0/PI*OMEGAC/BOLCON/VTOT)               ! atomic (Ry) units
	WRITE(IUN,10001)ERES/COEFR ! in mOm*sm
	WRITE(IUN,10002)WRES/COEFW ! in cm*K/W
	WRITE(IUN,10003)COEFW/WRES ! in W/cm/K
10001 FORMAT(1X,'ELECTRICAL RESISTIVITY AT 273K = ',G14.7,' [mOm*cm]') 
10002 FORMAT(1X,'THERMAL    RESISTIVITY AT 273K = ',G14.7,' [cm*K/W]')
10003 FORMAT(1X,'THERMAL   CONDUCTIVITY AT 273K = ',G14.7,' [W/cm/K]')
C  STORE RESISTIVITY DATA
	IF(ICRES.NE.0)THEN
	INQUIRE(FILE=RESFILE,EXIST=EXIST)
	IF(EXIST)THEN
      OPEN(UNIT=IUAIN,FILE=RESFILE,STATUS='OLD',FORM='FORMATTED')
C ********************************
C UNDERSTAND THE LENGHT OF INIFILE
	CALL FILE_LENGHT(RESFILE,NLEN,IUAIN)
	NLEN=MIN(NLEN,100)
	ALLOCATE(RESDATA(NLEN))
C ********************************
C READ INIFILE TO INTERNAL FILE
      OPEN(UNIT=IUAIN,FILE=RESFILE,STATUS='OLD',FORM='FORMATTED')
	DO ILEN=1,NLEN
	READ(IUAIN,FMT='(A150)')RESDATA(ILEN)
	ENDDO
C **************************************
C READING CONTROLS
      CALL READ_SECT(RESDATA(1),NLEN,ISEC,NSEC,MSEC,
     &'<section=ctrl',13,'<section=',9,'ok',2)
C Set section title
      DO IPOS=1,150
      IF(RESDATA(ISEC)(IPOS:IPOS).EQ.'>')EXIT
      ENDDO
      DO JPOS=IPOS+1,150
      IF(MSEC.NE.0)RESDATA(ISEC)(JPOS:JPOS)=' '
      ENDDO
      IF(IPOS.LE.50)THEN
      HELP='! CONTROL PARAMETERS:                   '
      IF(MSEC.NE.0)RESDATA(ISEC)(IPOS+1:IPOS+40)=HELP
      ENDIF
C Allocate temporary file
      ALLOCATE(RESCOPY(NSEC))
      DO ILIN=1,MSEC
      RESCOPY(ILIN)=RESDATA(ILIN+ISEC-1)
      ENDDO
C **************************************
C Process Units
      TCTRL=TXTUN(KU)
      HELP='! Output Units: eV,K,rsm,THz            '
      LHLP=40
      CALL READ_CHAR(RESDATA(ISEC),RESCOPY(1),NSEC,MSEC,
     &'units',5,IN,1,0,RE,1,0,CM,1,0,TCTRL,10,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
      KU=-1
      CALL LIB_CONVLOW(TCTRL,10)
      CALL LIB_RMBLANK(TCTRL,10)
	NB=INDEX(TCTRL,' ')
	DO IU=1,4
	TUN=TXTUN(IU)
	CALL LIB_CONVLOW(TUN,3)
	IF(TCTRL(:NB-1).EQ.TUN)KU=IU
	ENDDO
      IF(KU.EQ.-1)CALL FULLSTOP('<RESFILE> Units not recognized')
C Process NTMPRES
      HELP='! Temperature mesh for Resistivity     '
      LHLP=40
      CALL READ_CHAR(RESDATA(ISEC),RESCOPY(1),NSEC,MSEC,
     &'ntmpres',7,NTMPRES,1,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.FALSE.,.FALSE.)
C Process TMINRES
      HELP='! Min.temperature for resisitivity     '
      LHLP=40
      CALL READ_CHAR(RESDATA(ISEC),RESCOPY(1),NSEC,MSEC,
     &'tminres',7,IN,1,0,TMIN,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.FALSE.,.FALSE.)
      IF(VAL)TMINRES=TMIN/UNITS(KU)
C Process TMAXRES
      HELP='! Max.Temperature for resisitivity     '
      LHLP=40
      CALL READ_CHAR(RESDATA(ISEC),RESCOPY(1),NSEC,MSEC,
     &'tmaxres',7,IN,1,0,TMAX,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.FALSE.,.FALSE.)
      IF(VAL)TMAXRES=TMAX/UNITS(KU)
      CALL READ_ERRR(RESDATA(ISEC),RESCOPY(1),NSEC,MSEC,'CTRL')
      DEALLOCATE(RESCOPY,RESDATA)
	CLOSE(UNIT=IUAIN,STATUS='DELETE')
	ENDIF
	OPEN(UNIT=IUAIN,FILE=RESFILE,STATUS='NEW',FORM='FORMATTED')
	WRITE(IUAIN,10010)
	WRITE(IUAIN,10020)
10010	FORMAT(1X,'<FILE=RESFILE,INPUT=MODERN>')
10020 FORMAT('****************************************************')
	WRITE(IUAIN,10030)
10030 FORMAT(1X,'<SECTION=CTRL>               ! Controls:')
      HELP='! Output Units: eV,K,rsm,THz            '
      WRITE(IUAIN,10040)TXTUN(KU),HELP
10040 FORMAT(1X,'Units  =',A3,18X,A40)
      HELP='! Temeprature grid for Resistivity     '
	WRITE(IUAIN,10050)NTMPRES,HELP
10050 FORMAT(1X,'nTmpRES=',I5,16X,A40)
      HELP='! Min.Temperature for Resistivity      '
	WRITE(IUAIN,10060)TMINRES*UNITS(KU),HELP
10060 FORMAT(1X,'TminRES=',G14.7,7X,A40)
      HELP='! Max.Temperature for Resistivity      '
	WRITE(IUAIN,10070)TMAXRES*UNITS(KU),HELP
10070 FORMAT(1X,'TmaxRES=',G14.7,7X,A40)
	WRITE(IUAIN,10080)
10080 FORMAT(1X,'<SECTION=DATA>               ! Resistivity:')
	DO 50 ITEMP=0,NTMPRES
	TEMP=TMINRES+(TMAXRES-TMINRES)/DBLE(NTMPRES)*ITEMP
	IF(ABS(TEMP).LE.1.D-08)TEMP=0.001D0
	RINT=0.D0
	WINT=0.D0
	DO 40 IPNT=1,NPNT(1)
	DO 30 IBND=1,3*NATOM
	IF(ABS(OM(IBND,IPNT)).LE.1.D-05)GOTO 30
	IF(OM(IBND,IPNT).LT.0.D0)GOTO 30
	XPAR=OM(IBND,IPNT)/2.D0/TEMP
	ARGM=XPAR**2/SINH(XPAR)**2
	RINT=RINT+0.5D0*ARGM*ALMTRA(4,IBND,IPNT)*WGT(IPNT,1)/2.D0 ! 2 because of spin
	WINT=WINT+0.5D0*ARGM*(ALMTRA(4,IBND,IPNT)+4.D0*XPAR**2/PI**2*
     &(ALMTRA(1,IBND,IPNT)+ALMTRA(2,IBND,IPNT))+2.D0*XPAR**2/PI**2*
     &2.D0*ALMTRA(3,IBND,IPNT))*WGT(IPNT,1)/2.D0 ! 2 because of spin
  30  CONTINUE
  40  CONTINUE
	ERES=RINT*(12.D0*PI*OMEGAC*(TEMP/13.6058D0)/2.D0/VTOT)! atomic (Ry) units
	WRES=WINT*(36.D0/PI*OMEGAC/BOLCON/VTOT)               ! atomic (Ry) units
      WRITE(IUAIN,10110)TEMP*UNITS(KU),ERES/COEFR,WRES/COEFW,COEFW/WRES
  50  CONTINUE
	CLOSE(IUAIN)
	ENDIF
10110 FORMAT(1X,G12.5,2X,G12.5,2X,G12.5,2X,G12.5,2X,
     &  ' ! T,Rho[mOm*sm],W[cm*K/W]')
	END



	SUBROUTINE SUP_FREENR
**********************************************************
*  Calculates phonon free energy, specific heat
**********************************************************
C SET ARRAY-SIZE DATA
      USE DIM_LMTART
C SET EXTERNAL CONNECTIONS
      USE COM_LMTMEM                                                  !!! from setup
      USE COM_PARAM,   ONLY: NATOM,NSORT,NSPIN,NORBS,IS               !!! from readini
	USE COM_SPHERE,  ONLY: AMAS                                     !!! from init
	USE COM_KMESH,   ONLY: NPNT,PNT,WGT                             !!! from readpnt
	USE COM_SUPDAT,  ONLY: UNITS,TXTUN,VEL,DOS,STARMU,TCEXP         !!! from readsup
	USE COM_SUPMAT,  ONLY: TRAMAT,DPOL,OM                           !!! from omegaq
      USE COM_UNIT,    ONLY: IUN,IUR,IUT,IUI                          !!! from setup
      USE COM_SUPOUT,  ONLY: ICFRE,FREFILE                            !!! from init
      USE COM_CHANNELS,ONLY: IUAIN                                    !!! from channels
	IMPLICIT REAL*8 (A-H,O-Z)
	CHARACTER*150, ALLOCATABLE :: FREDATA(:)
      CHARACTER*150, ALLOCATABLE :: FRECOPY(:)
      CHARACTER TCTRL*10,HELP*40,TUN*3
	LOGICAL EXIST,DEF,ASK,VAL,NTH
	DATA PI/3.141592653589793D0/,KU/2/
	TMINFRE=0.D0
	TMAXFRE=1000.D0/UNITS(2) ! eV
	NTMPFRE=100
C AVERAGE FREQUENCY SUMMED OVER ALL BRANCHES
	OMEGAAV=0.D0 ! will be in eV
	DO IPNT=1,NPNT(1)
	DO IBND=1,3*NATOM
	OMEGAAV=OMEGAAV+OM(IBND,IPNT)*WGT(IPNT,1)/2.D0
	ENDDO
	ENDDO
C FREE ENERGY AT ZERO C
	FREEENR=0.D0 ! will be eV
	SPEHEAT=0.D0 
	TEMP=273.15D0/UNITS(2) ! eV
	DO IPNT=1,NPNT(1)
	DO IBND=1,3*NATOM
	IF(OM(IBND,IPNT).LT.0.D0)CYCLE
	DL=ABS(1.D0-EXP(-OM(IBND,IPNT)/TEMP))
	IF(DL.LE.1.D-10)CYCLE
	FREEENR=FREEENR-TEMP*LOG(DL)*WGT(IPNT,1)/2.D0
	DL=EXP(OM(IBND,IPNT)/TEMP)-1.D0
	IF(DL.LE.1.D-10)CYCLE
	SPEHEAT=SPEHEAT+OM(IBND,IPNT)**2/TEMP**2*
     &EXP(OM(IBND,IPNT)/TEMP)/DL**2*WGT(IPNT,1)/2.D0
	ENDDO
	ENDDO
C PRINT RESULTS
	WRITE(IUN,10000)
	WRITE(IUN,10001)OMEGAAV/DBLE(3*NATOM)*UNITS(2) ! K
	WRITE(IUN,10002)FREEENR*UNITS(2) ! K
	WRITE(IUN,10003)(FREEENR+OMEGAAV/2.D0)*UNITS(2) ! K
	WRITE(IUN,10004)OMEGAAV/DBLE(3*NATOM)*UNITS(1) ! eV
	WRITE(IUN,10005)FREEENR*UNITS(1) ! eV
	WRITE(IUN,10006)(FREEENR+OMEGAAV/2.D0)*UNITS(1) ! eV
	WRITE(IUN,10007)SPEHEAT*8.314
10000 FORMAT(1X,'ESTIMATES FOR FREE ENERGY AT T=273.15 K  ')
10001 FORMAT(1X,'Estimated <omega>        = ',G14.7,1X,' K')
10002 FORMAT(1X,'Estimated ln(1-e(-w/T))  = ',G14.7,1X,' K')
10003 FORMAT(1X,'Estimated Free Energy    = ',G14.7,1X,' K')
10004 FORMAT(1X,'Estimated <omega>        = ',G14.7,1X,' eV')
10005 FORMAT(1X,'Estimated ln(1-e(-w/T))  = ',G14.7,1X,' eV')
10006 FORMAT(1X,'Estimated Free Energy    = ',G14.7,1X,' eV')
10007 FORMAT(1X,'Estimated Specific Heat  = ',G14.7,1X,' J/[mol*K]')
C STORE FREE ENERGY
	IF(ICFRE.NE.0)THEN
	INQUIRE(FILE=FREFILE,EXIST=EXIST)
	IF(EXIST)THEN
      OPEN(UNIT=IUAIN,FILE=FREFILE,STATUS='OLD',FORM='FORMATTED')
C ********************************
C UNDERSTAND THE LENGHT OF INIFILE
	CALL FILE_LENGHT(FREFILE,NLEN,IUAIN)
	NLEN=MIN(NLEN,100)
	ALLOCATE(FREDATA(NLEN))
C ********************************
C READ INIFILE TO INTERNAL FILE
      OPEN(UNIT=IUAIN,FILE=FREFILE,STATUS='OLD',FORM='FORMATTED')
	DO ILEN=1,NLEN
	READ(IUAIN,FMT='(A150)')FREDATA(ILEN)
	ENDDO
C **************************************
C READING CONTROLS
      CALL READ_SECT(FREDATA(1),NLEN,ISEC,NSEC,MSEC,
     &'<section=ctrl',13,'<section=',9,'ok',2)
C Set section title
      DO IPOS=1,150
      IF(FREDATA(ISEC)(IPOS:IPOS).EQ.'>')EXIT
      ENDDO
      DO JPOS=IPOS+1,150
      IF(MSEC.NE.0)FREDATA(ISEC)(JPOS:JPOS)=' '
      ENDDO
      IF(IPOS.LE.50)THEN
      HELP='! CONTROL PARAMETERS:                   '
      IF(MSEC.NE.0)FREDATA(ISEC)(IPOS+1:IPOS+40)=HELP
      ENDIF
C Allocate temporary file
      ALLOCATE(FRECOPY(NSEC))
      DO ILIN=1,MSEC
      FRECOPY(ILIN)=FREDATA(ILIN+ISEC-1)
      ENDDO
C **************************************
C Process Units
      TCTRL=TXTUN(KU)
      HELP='! Output Units: eV,K,rsm,THz            '
      LHLP=40
      CALL READ_CHAR(FREDATA(ISEC),FRECOPY(1),NSEC,MSEC,
     &'units',5,IN,1,0,RE,1,0,CM,1,0,TCTRL,10,1,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.TRUE.,.FALSE.)
      KU=-1
      CALL LIB_CONVLOW(TCTRL,10)
      CALL LIB_RMBLANK(TCTRL,10)
	NB=INDEX(TCTRL,' ')
	DO IU=1,4
	TUN=TXTUN(IU)
	CALL LIB_CONVLOW(TUN,3)
	IF(TCTRL(:NB-1).EQ.TUN)KU=IU
	ENDDO
      IF(KU.EQ.-1)CALL FULLSTOP('<FREFILE> Units not recognized')
C Process NTMPFE
      HELP='! Temperature mesh for Free Energy     '
      LHLP=40
      CALL READ_CHAR(FREDATA(ISEC),FRECOPY(1),NSEC,MSEC,
     &'ntmpfre',7,NTMPFRE,1,1,RE,1,0,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.FALSE.,.FALSE.)
C Process TMINFRE
      HELP='! Min.Temperature for Free Energy      '
      LHLP=40
      CALL READ_CHAR(FREDATA(ISEC),FRECOPY(1),NSEC,MSEC,
     &'tminfre',7,IN,1,0,TMIN,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.FALSE.,.FALSE.)
      IF(VAL)TMINFRE=TMIN/UNITS(KU)
C Process TMAX
      HELP='! Max.Temperature  for Free Energy     '
      LHLP=40
      CALL READ_CHAR(FREDATA(ISEC),FRECOPY(1),NSEC,MSEC,
     &'tmaxfre',7,IN,1,0,TMAX,1,1,CM,1,0,' ',1,0,HELP,LHLP,
     &DEF,ASK,VAL,NTH,.FALSE.,.FALSE.)
      IF(VAL)TMAXFRE=TMAX/UNITS(KU)
      CALL READ_ERRR(FREDATA(ISEC),FRECOPY(1),NSEC,MSEC,'CTRL')
      DEALLOCATE(FRECOPY,FREDATA)
	CLOSE(UNIT=IUAIN,STATUS='DELETE')
	ENDIF
	OPEN(UNIT=IUAIN,FILE=FREFILE,STATUS='NEW',FORM='FORMATTED')
	WRITE(IUAIN,10010)
	WRITE(IUAIN,10020)
10010	FORMAT(1X,'<FILE=FREFILE,INPUT=MODERN>')
10020 FORMAT('****************************************************')
	WRITE(IUAIN,10030)
10030 FORMAT(1X,'<SECTION=CTRL>               ! Controls:')
      HELP='! Output Units: eV,K,rsm,THz            '
      WRITE(IUAIN,10040)TXTUN(KU),HELP
10040 FORMAT(1X,'Units  =',A3,18X,A40)
      HELP='! Temeprature grid for free energy     '
	WRITE(IUAIN,10050)NTMPFRE,HELP
10050 FORMAT(1X,'nTmpFRE=',I5,16X,A40)
      HELP='! Min.Temperature for Free energy      '
	WRITE(IUAIN,10060)TMINFRE*UNITS(KU),HELP
10060 FORMAT(1X,'TminFRE=',G14.7,7X,A40)
      HELP='! Max.Temperature for free energy      '
	WRITE(IUAIN,10070)TMAXFRE*UNITS(KU),HELP
10070 FORMAT(1X,'TmaxFRE=',G14.7,7X,A40)
	WRITE(IUAIN,10080)
10080 FORMAT(1X,'<SECTION=DATA>               ! FREE ENERGY:')
	DO ITEMP=0,NTMPFRE
	TEMP=TMINFRE+(TMAXFRE-TMINFRE)/DBLE(NTMPFRE)*ITEMP
	IF(ABS(TEMP).LE.1.D-08)TEMP=0.0001D0
	FREE=0.D0
	HEAT=0.D0
	DO IPNT=1,NPNT(1)
	DO IBND=1,3*NATOM
	DL=ABS(1.D0-EXP(-OM(IBND,IPNT)/TEMP))
	IF(DL.LE.1.D-10)CYCLE
	FREE=FREE-TEMP*LOG(DL)*WGT(IPNT,1)/2.D0
	DE=OM(IBND,IPNT)/TEMP
	IF(DE.GE.20.D0)CYCLE
	DL=EXP(OM(IBND,IPNT)/TEMP)-1.D0
	IF(DL.LE.1.D-10)CYCLE
	HEAT=HEAT+OM(IBND,IPNT)**2/TEMP**2*
     &EXP(OM(IBND,IPNT)/TEMP)/DL**2*WGT(IPNT,1)/2.D0
	ENDDO
	ENDDO
	HEAT=HEAT*8.314 !!! Specific heat is now in J/[mol*K]
C EINSTEIN MODEL
	OMEGA=OMEGAAV/DBLE(3*NATOM)
	DL=ABS(1.D0-EXP(-OMEGA/TEMP))
	IF(DL.LE.1.D-10)FEIN=0.D0
	IF(DL.GT.1.D-10)FEIN=-TEMP*LOG(DL)*DBLE(3*NATOM)
	WRITE(IUAIN,10110)TEMP*UNITS(KU),(FREE+OMEGAAV/2.D0)*UNITS(KU),
     &(FEIN+OMEGAAV/2.D0)*UNITS(KU),HEAT
	ENDDO
10110	FORMAT(1X,G14.7,1X,G14.7,1X,G14.7,1X,G14.7)
	CLOSE(IUAIN)
	ENDIF
	END
